'use strict';

var tsParser = require('@typescript-eslint/parser');
var types = require('@typescript-eslint/types');
var utils = require('@typescript-eslint/utils');
var scopeManager = require('@typescript-eslint/scope-manager');
var typeUtils = require('@typescript-eslint/type-utils');
var ts25 = require('typescript');

function _interopDefault (e) { return e && e.__esModule ? e : { default: e }; }

var tsParser__default = /*#__PURE__*/_interopDefault(tsParser);
var ts25__default = /*#__PURE__*/_interopDefault(ts25);

var __defProp = Object.defineProperty;
var __export = (target, all16) => {
  for (var name6 in all16)
    __defProp(target, name6, { get: all16[name6], enumerable: true });
};

// ../../tools/dist/index.mjs
var fromEntries = (entries2) => {
  return Object.fromEntries(entries2);
};
var entries = (value) => {
  return Object.entries(value);
};

// ../eslint-plugin-react-core/dist/index.mjs
var dist_exports = {};
__export(dist_exports, {
  meta: () => meta,
  rules: () => rules
});

// ../../../node_modules/.pnpm/string-ts@2.1.1/node_modules/string-ts/dist/index.mjs
function charAt(str, index) {
  return str.charAt(index);
}
function join(tuple13, delimiter2 = "") {
  return tuple13.join(delimiter2);
}
function replace(sentence, lookup, replacement = "") {
  return sentence.replace(lookup, replacement);
}
function replaceAll(sentence, lookup, replacement = "") {
  if (typeof sentence.replaceAll === "function") {
    return sentence.replaceAll(lookup, replacement);
  }
  const regex = new RegExp(lookup, "g");
  return sentence.replace(regex, replacement);
}
function slice(str, start = 0, end = void 0) {
  return str.slice(start, end);
}
function toLowerCase(str) {
  return str.toLowerCase();
}
function toUpperCase(str) {
  return str.toUpperCase();
}
var UNESCAPED_SEPARATORS = [
  "[",
  "]",
  "{",
  "}",
  "(",
  ")",
  "|",
  "/",
  "-",
  "\\"
];
var SEPARATORS = [...UNESCAPED_SEPARATORS, " ", "_", "."];
function escapeChar(char) {
  return UNESCAPED_SEPARATORS.includes(char) ? `\\${char}` : char;
}
var SEPARATOR_REGEX = new RegExp(
  `[${SEPARATORS.map(escapeChar).join("")}]`,
  "g"
);
function words(sentence) {
  return sentence.replace(SEPARATOR_REGEX, " ").replace(/([a-zA-Z])([0-9])/g, "$1 $2").replace(/([0-9])([a-zA-Z])/g, "$1 $2").replace(/([a-zA-Z0-9_\-./])([^a-zA-Z0-9_\-./'])/g, "$1 $2").replace(/([^a-zA-Z0-9_\-./'])([a-zA-Z0-9_\-./])/g, "$1 $2").replace(/([a-z])([A-Z])/g, "$1 $2").replace(/([A-Z])([A-Z][a-z])/g, "$1 $2").trim().split(/\s+/g);
}
function capitalize(str) {
  return join([
    toUpperCase(charAt(str, 0) ?? ""),
    slice(str, 1)
  ]);
}
function pascalCaseAll(words2) {
  return words2.map((v8) => capitalize(toLowerCase(v8)));
}
function removeApostrophe(str) {
  return replaceAll(str, "'", "");
}
function pascalCase(str) {
  return join(pascalCaseAll(words(removeApostrophe(str))));
}
function uncapitalize(str) {
  return join([
    toLowerCase(charAt(str, 0) ?? ""),
    slice(str, 1)
  ]);
}
function camelCase(str) {
  return uncapitalize(pascalCase(removeApostrophe(str)));
}
function delimiterCase(str, delimiter2) {
  return join(words(removeApostrophe(str)), delimiter2);
}
function kebabCase(str) {
  return toLowerCase(delimiterCase(removeApostrophe(str), "-"));
}
function snakeCase(str) {
  return toLowerCase(delimiterCase(removeApostrophe(str), "_"));
}

// ../../../node_modules/.pnpm/valibot@0.31.0-rc.10/node_modules/valibot/dist/index.js
var store;
function getGlobalConfig(config2) {
  return {
    lang: config2?.lang ?? store?.lang,
    message: config2?.message,
    abortEarly: config2?.abortEarly ?? store?.abortEarly,
    abortPipeEarly: config2?.abortPipeEarly ?? store?.abortPipeEarly,
    skipPipe: config2?.skipPipe
  };
}
var ValiError = class extends Error {
  /**
   * The error issues.
   */
  issues;
  /**
   * Creates a Valibot error with useful information.
   *
   * @param issues The error issues.
   */
  constructor(issues) {
    super(issues[0].message);
    this.name = "ValiError";
    this.issues = issues;
  }
};
function parse(schema4, input, config2) {
  const dataset = schema4._run(
    { typed: false, value: input },
    getGlobalConfig(config2)
  );
  if (dataset.issues) {
    throw new ValiError(dataset.issues);
  }
  return dataset.value;
}
function isFlagSet(allFlags, flag) {
  return (allFlags & flag) !== 0;
}
function isFlagSetOnObject(obj, flag) {
  return isFlagSet(obj.flags, flag);
}
var isTypeFlagSet = isFlagSetOnObject;
ts25__default.default.versionMajorMinor.split(".").map((raw) => Number.parseInt(raw, 10));
ts25__default.default.TypeFlags.Intrinsic ?? ts25__default.default.TypeFlags.Any | ts25__default.default.TypeFlags.Unknown | ts25__default.default.TypeFlags.String | ts25__default.default.TypeFlags.Number | ts25__default.default.TypeFlags.BigInt | ts25__default.default.TypeFlags.Boolean | ts25__default.default.TypeFlags.BooleanLiteral | ts25__default.default.TypeFlags.ESSymbol | ts25__default.default.TypeFlags.Void | ts25__default.default.TypeFlags.Undefined | ts25__default.default.TypeFlags.Null | ts25__default.default.TypeFlags.Never | ts25__default.default.TypeFlags.NonPrimitive;
function isUnionType(type) {
  return isTypeFlagSet(type, ts25__default.default.TypeFlags.Union);
}
function isBooleanLiteralType(type) {
  return isTypeFlagSet(type, ts25__default.default.TypeFlags.BooleanLiteral);
}
function isFalseLiteralType(type) {
  return isBooleanLiteralType(type) && type.intrinsicName === "false";
}
function isTrueLiteralType(type) {
  return isBooleanLiteralType(type) && type.intrinsicName === "true";
}
function unionTypeParts(type) {
  return isUnionType(type) ? type.types : [type];
}
var __create = Object.create;
var __defProp2 = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __commonJS = (cb, mod) => function __require() {
  return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
};
var __export2 = (target, all123) => {
  for (var name22 in all123)
    __defProp2(target, name22, { get: all123[name22], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp2(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  __defProp2(target, "default", { value: mod, enumerable: true }),
  mod
));
var require_short_unique_id = __commonJS({
  "../../../node_modules/.pnpm/short-unique-id@5.2.0/node_modules/short-unique-id/dist/short-unique-id.js"(exports, module) {
    var ShortUniqueId2 = (() => {
      var __defProp72 = Object.defineProperty;
      var __getOwnPropDesc22 = Object.getOwnPropertyDescriptor;
      var __getOwnPropNames22 = Object.getOwnPropertyNames;
      var __getOwnPropSymbols = Object.getOwnPropertySymbols;
      var __hasOwnProp22 = Object.prototype.hasOwnProperty;
      var __propIsEnum = Object.prototype.propertyIsEnumerable;
      var __defNormalProp = (obj, key, value) => key in obj ? __defProp72(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
      var __spreadValues = (a52, b52) => {
        for (var prop in b52 || (b52 = {}))
          if (__hasOwnProp22.call(b52, prop))
            __defNormalProp(a52, prop, b52[prop]);
        if (__getOwnPropSymbols)
          for (var prop of __getOwnPropSymbols(b52)) {
            if (__propIsEnum.call(b52, prop))
              __defNormalProp(a52, prop, b52[prop]);
          }
        return a52;
      };
      var __export72 = (target, all123) => {
        for (var name22 in all123)
          __defProp72(target, name22, { get: all123[name22], enumerable: true });
      };
      var __copyProps22 = (to, from, except, desc) => {
        if (from && typeof from === "object" || typeof from === "function") {
          for (let key of __getOwnPropNames22(from))
            if (!__hasOwnProp22.call(to, key) && key !== except)
              __defProp72(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc22(from, key)) || desc.enumerable });
        }
        return to;
      };
      var __toCommonJS = (mod) => __copyProps22(__defProp72({}, "__esModule", { value: true }), mod);
      var __publicField = (obj, key, value) => {
        __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
        return value;
      };
      var src_exports = {};
      __export72(src_exports, {
        DEFAULT_OPTIONS: () => DEFAULT_OPTIONS,
        DEFAULT_UUID_LENGTH: () => DEFAULT_UUID_LENGTH,
        default: () => ShortUniqueId3
      });
      var version22 = "5.2.0";
      var DEFAULT_UUID_LENGTH = 6;
      var DEFAULT_OPTIONS = {
        dictionary: "alphanum",
        shuffle: true,
        debug: false,
        length: DEFAULT_UUID_LENGTH,
        counter: 0
      };
      var _ShortUniqueId = class _ShortUniqueId {
        constructor(argOptions = {}) {
          __publicField(this, "counter");
          __publicField(this, "debug");
          __publicField(this, "dict");
          __publicField(this, "version");
          __publicField(this, "dictIndex", 0);
          __publicField(this, "dictRange", []);
          __publicField(this, "lowerBound", 0);
          __publicField(this, "upperBound", 0);
          __publicField(this, "dictLength", 0);
          __publicField(this, "uuidLength");
          __publicField(this, "_digit_first_ascii", 48);
          __publicField(this, "_digit_last_ascii", 58);
          __publicField(this, "_alpha_lower_first_ascii", 97);
          __publicField(this, "_alpha_lower_last_ascii", 123);
          __publicField(this, "_hex_last_ascii", 103);
          __publicField(this, "_alpha_upper_first_ascii", 65);
          __publicField(this, "_alpha_upper_last_ascii", 91);
          __publicField(this, "_number_dict_ranges", {
            digits: [this._digit_first_ascii, this._digit_last_ascii]
          });
          __publicField(this, "_alpha_dict_ranges", {
            lowerCase: [this._alpha_lower_first_ascii, this._alpha_lower_last_ascii],
            upperCase: [this._alpha_upper_first_ascii, this._alpha_upper_last_ascii]
          });
          __publicField(this, "_alpha_lower_dict_ranges", {
            lowerCase: [this._alpha_lower_first_ascii, this._alpha_lower_last_ascii]
          });
          __publicField(this, "_alpha_upper_dict_ranges", {
            upperCase: [this._alpha_upper_first_ascii, this._alpha_upper_last_ascii]
          });
          __publicField(this, "_alphanum_dict_ranges", {
            digits: [this._digit_first_ascii, this._digit_last_ascii],
            lowerCase: [this._alpha_lower_first_ascii, this._alpha_lower_last_ascii],
            upperCase: [this._alpha_upper_first_ascii, this._alpha_upper_last_ascii]
          });
          __publicField(this, "_alphanum_lower_dict_ranges", {
            digits: [this._digit_first_ascii, this._digit_last_ascii],
            lowerCase: [this._alpha_lower_first_ascii, this._alpha_lower_last_ascii]
          });
          __publicField(this, "_alphanum_upper_dict_ranges", {
            digits: [this._digit_first_ascii, this._digit_last_ascii],
            upperCase: [this._alpha_upper_first_ascii, this._alpha_upper_last_ascii]
          });
          __publicField(this, "_hex_dict_ranges", {
            decDigits: [this._digit_first_ascii, this._digit_last_ascii],
            alphaDigits: [this._alpha_lower_first_ascii, this._hex_last_ascii]
          });
          __publicField(this, "_dict_ranges", {
            _number_dict_ranges: this._number_dict_ranges,
            _alpha_dict_ranges: this._alpha_dict_ranges,
            _alpha_lower_dict_ranges: this._alpha_lower_dict_ranges,
            _alpha_upper_dict_ranges: this._alpha_upper_dict_ranges,
            _alphanum_dict_ranges: this._alphanum_dict_ranges,
            _alphanum_lower_dict_ranges: this._alphanum_lower_dict_ranges,
            _alphanum_upper_dict_ranges: this._alphanum_upper_dict_ranges,
            _hex_dict_ranges: this._hex_dict_ranges
          });
          __publicField(this, "log", (...args) => {
            const finalArgs = [...args];
            finalArgs[0] = `[short-unique-id] ${args[0]}`;
            if (this.debug === true) {
              if (typeof console !== "undefined" && console !== null) {
                return console.log(...finalArgs);
              }
            }
          });
          __publicField(this, "_normalizeDictionary", (dictionary2, shuffle2) => {
            let finalDict;
            if (dictionary2 && Array.isArray(dictionary2) && dictionary2.length > 1) {
              finalDict = dictionary2;
            } else {
              finalDict = [];
              let i52;
              this.dictIndex = i52 = 0;
              const rangesName = `_${dictionary2}_dict_ranges`;
              const ranges = this._dict_ranges[rangesName];
              Object.keys(ranges).forEach((rangeType) => {
                const rangeTypeKey = rangeType;
                this.dictRange = ranges[rangeTypeKey];
                this.lowerBound = this.dictRange[0];
                this.upperBound = this.dictRange[1];
                for (this.dictIndex = i52 = this.lowerBound; this.lowerBound <= this.upperBound ? i52 < this.upperBound : i52 > this.upperBound; this.dictIndex = this.lowerBound <= this.upperBound ? i52 += 1 : i52 -= 1) {
                  finalDict.push(String.fromCharCode(this.dictIndex));
                }
              });
            }
            if (shuffle2) {
              const PROBABILITY = 0.5;
              finalDict = finalDict.sort(() => Math.random() - PROBABILITY);
            }
            return finalDict;
          });
          __publicField(this, "setDictionary", (dictionary2, shuffle2) => {
            this.dict = this._normalizeDictionary(dictionary2, shuffle2);
            this.dictLength = this.dict.length;
            this.setCounter(0);
          });
          __publicField(this, "seq", () => {
            return this.sequentialUUID();
          });
          __publicField(this, "sequentialUUID", () => {
            let counterDiv;
            let counterRem;
            let id = "";
            counterDiv = this.counter;
            do {
              counterRem = counterDiv % this.dictLength;
              counterDiv = Math.trunc(counterDiv / this.dictLength);
              id += this.dict[counterRem];
            } while (counterDiv !== 0);
            this.counter += 1;
            return id;
          });
          __publicField(this, "rnd", (uuidLength = this.uuidLength || DEFAULT_UUID_LENGTH) => {
            return this.randomUUID(uuidLength);
          });
          __publicField(this, "randomUUID", (uuidLength = this.uuidLength || DEFAULT_UUID_LENGTH) => {
            let id;
            let randomPartIdx;
            let j52;
            if (uuidLength === null || typeof uuidLength === "undefined" || uuidLength < 1) {
              throw new Error("Invalid UUID Length Provided");
            }
            id = "";
            for (j52 = 0; j52 < uuidLength; j52 += 1) {
              randomPartIdx = parseInt(
                (Math.random() * this.dictLength).toFixed(0),
                10
              ) % this.dictLength;
              id += this.dict[randomPartIdx];
            }
            return id;
          });
          __publicField(this, "fmt", (format85, date) => {
            return this.formattedUUID(format85, date);
          });
          __publicField(this, "formattedUUID", (format85, date) => {
            const fnMap = {
              "$r": this.randomUUID,
              "$s": this.sequentialUUID,
              "$t": this.stamp
            };
            const result = format85.replace(
              /\$[rs]\d{0,}|\$t0|\$t[1-9]\d{1,}/g,
              (m52) => {
                const fn = m52.slice(0, 2);
                const len = parseInt(m52.slice(2), 10);
                if (fn === "$s") {
                  return fnMap[fn]().padStart(len, "0");
                }
                if (fn === "$t" && date) {
                  return fnMap[fn](len, date);
                }
                return fnMap[fn](len);
              }
            );
            return result;
          });
          __publicField(this, "availableUUIDs", (uuidLength = this.uuidLength) => {
            return parseFloat(
              Math.pow([...new Set(this.dict)].length, uuidLength).toFixed(0)
            );
          });
          __publicField(this, "approxMaxBeforeCollision", (rounds = this.availableUUIDs(this.uuidLength)) => {
            return parseFloat(
              Math.sqrt(Math.PI / 2 * rounds).toFixed(20)
            );
          });
          __publicField(this, "collisionProbability", (rounds = this.availableUUIDs(this.uuidLength), uuidLength = this.uuidLength) => {
            return parseFloat(
              (this.approxMaxBeforeCollision(rounds) / this.availableUUIDs(uuidLength)).toFixed(20)
            );
          });
          __publicField(this, "uniqueness", (rounds = this.availableUUIDs(this.uuidLength)) => {
            const score = parseFloat(
              (1 - this.approxMaxBeforeCollision(rounds) / rounds).toFixed(20)
            );
            return score > 1 ? 1 : score < 0 ? 0 : score;
          });
          __publicField(this, "getVersion", () => {
            return this.version;
          });
          __publicField(this, "stamp", (finalLength, date) => {
            const hexStamp = Math.floor(+(date || /* @__PURE__ */ new Date()) / 1e3).toString(16);
            if (typeof finalLength === "number" && finalLength === 0) {
              return hexStamp;
            }
            if (typeof finalLength !== "number" || finalLength < 10) {
              throw new Error(
                [
                  "Param finalLength must be a number greater than or equal to 10,",
                  "or 0 if you want the raw hexadecimal timestamp"
                ].join("\n")
              );
            }
            const idLength = finalLength - 9;
            const rndIdx = Math.round(Math.random() * (idLength > 15 ? 15 : idLength));
            const id = this.randomUUID(idLength);
            return `${id.substring(0, rndIdx)}${hexStamp}${id.substring(rndIdx)}${rndIdx.toString(16)}`;
          });
          __publicField(this, "parseStamp", (suid, format85) => {
            if (format85 && !/t0|t[1-9]\d{1,}/.test(format85)) {
              throw new Error("Cannot extract date from a formated UUID with no timestamp in the format");
            }
            const stamp = format85 ? format85.replace(
              /\$[rs]\d{0,}|\$t0|\$t[1-9]\d{1,}/g,
              (m52) => {
                const fnMap = {
                  "$r": (len2) => [...Array(len2)].map(() => "r").join(""),
                  "$s": (len2) => [...Array(len2)].map(() => "s").join(""),
                  "$t": (len2) => [...Array(len2)].map(() => "t").join("")
                };
                const fn = m52.slice(0, 2);
                const len = parseInt(m52.slice(2), 10);
                return fnMap[fn](len);
              }
            ).replace(
              /^(.*?)(t{8,})(.*)$/g,
              (_m, p1, p232) => {
                return suid.substring(p1.length, p1.length + p232.length);
              }
            ) : suid;
            if (stamp.length === 8) {
              return new Date(parseInt(stamp, 16) * 1e3);
            }
            if (stamp.length < 10) {
              throw new Error("Stamp length invalid");
            }
            const rndIdx = parseInt(stamp.substring(stamp.length - 1), 16);
            return new Date(parseInt(stamp.substring(rndIdx, rndIdx + 8), 16) * 1e3);
          });
          __publicField(this, "setCounter", (counter2) => {
            this.counter = counter2;
          });
          __publicField(this, "validate", (uid4, dictionary2) => {
            const finalDictionary = dictionary2 ? this._normalizeDictionary(dictionary2) : this.dict;
            return uid4.split("").every((c52) => finalDictionary.includes(c52));
          });
          const options = __spreadValues(__spreadValues({}, DEFAULT_OPTIONS), argOptions);
          this.counter = 0;
          this.debug = false;
          this.dict = [];
          this.version = version22;
          const {
            dictionary,
            shuffle,
            length: length42,
            counter
          } = options;
          this.uuidLength = length42;
          this.setDictionary(dictionary, shuffle);
          this.setCounter(counter);
          this.debug = options.debug;
          this.log(this.dict);
          this.log(
            `Generator instantiated with Dictionary Size ${this.dictLength} and counter set to ${this.counter}`
          );
          this.log = this.log.bind(this);
          this.setDictionary = this.setDictionary.bind(this);
          this.setCounter = this.setCounter.bind(this);
          this.seq = this.seq.bind(this);
          this.sequentialUUID = this.sequentialUUID.bind(this);
          this.rnd = this.rnd.bind(this);
          this.randomUUID = this.randomUUID.bind(this);
          this.fmt = this.fmt.bind(this);
          this.formattedUUID = this.formattedUUID.bind(this);
          this.availableUUIDs = this.availableUUIDs.bind(this);
          this.approxMaxBeforeCollision = this.approxMaxBeforeCollision.bind(this);
          this.collisionProbability = this.collisionProbability.bind(this);
          this.uniqueness = this.uniqueness.bind(this);
          this.getVersion = this.getVersion.bind(this);
          this.stamp = this.stamp.bind(this);
          this.parseStamp = this.parseStamp.bind(this);
          return this;
        }
      };
      __publicField(_ShortUniqueId, "default", _ShortUniqueId);
      var ShortUniqueId3 = _ShortUniqueId;
      return __toCommonJS(src_exports);
    })();
    "undefined" != typeof module && (module.exports = ShortUniqueId2.default), "undefined" != typeof window && (ShortUniqueId2 = ShortUniqueId2.default);
  }
});
var name = "@neetly-eslint-react/eslint-plugin-react-core";
var version = "0.0.0-dev.0";
var t = Symbol.for("@ts-pattern/matcher");
var e = Symbol.for("@ts-pattern/isVariadic");
var n = "@ts-pattern/anonymous-select-key";
var r = (t52) => Boolean(t52 && "object" == typeof t52);
var i = (e52) => e52 && !!e52[t];
var o = (n52, s52, c52) => {
  if (i(n52)) {
    const e52 = n52[t](), { matched: r52, selections: i52 } = e52.match(s52);
    return r52 && i52 && Object.keys(i52).forEach((t52) => c52(t52, i52[t52])), r52;
  }
  if (r(n52)) {
    if (!r(s52)) return false;
    if (Array.isArray(n52)) {
      if (!Array.isArray(s52)) return false;
      let t52 = [], r52 = [], a52 = [];
      for (const o52 of n52.keys()) {
        const s62 = n52[o52];
        i(s62) && s62[e] ? a52.push(s62) : a52.length ? r52.push(s62) : t52.push(s62);
      }
      if (a52.length) {
        if (a52.length > 1) throw new Error("Pattern error: Using `...P.array(...)` several times in a single pattern is not allowed.");
        if (s52.length < t52.length + r52.length) return false;
        const e52 = s52.slice(0, t52.length), n62 = 0 === r52.length ? [] : s52.slice(-r52.length), i52 = s52.slice(t52.length, 0 === r52.length ? Infinity : -r52.length);
        return t52.every((t62, n72) => o(t62, e52[n72], c52)) && r52.every((t62, e62) => o(t62, n62[e62], c52)) && (0 === a52.length || o(a52[0], i52, c52));
      }
      return n52.length === s52.length && n52.every((t62, e52) => o(t62, s52[e52], c52));
    }
    return Object.keys(n52).every((e52) => {
      const r52 = n52[e52];
      return (e52 in s52 || i(a52 = r52) && "optional" === a52[t]().matcherType) && o(r52, s52[e52], c52);
      var a52;
    });
  }
  return Object.is(s52, n52);
};
var s = (e52) => {
  var n52, o52, a52;
  return r(e52) ? i(e52) ? null != (n52 = null == (o52 = (a52 = e52[t]()).getSelectionKeys) ? void 0 : o52.call(a52)) ? n52 : [] : Array.isArray(e52) ? c(e52, s) : c(Object.values(e52), s) : [];
};
var c = (t52, e52) => t52.reduce((t62, n52) => t62.concat(e52(n52)), []);
function a(...t52) {
  if (1 === t52.length) {
    const [e52] = t52;
    return (t62) => o(e52, t62, () => {
    });
  }
  if (2 === t52.length) {
    const [e52, n52] = t52;
    return o(e52, n52, () => {
    });
  }
  throw new Error(`isMatching wasn't given the right number of arguments: expected 1 or 2, received ${t52.length}.`);
}
function u(t52) {
  return Object.assign(t52, { optional: () => l(t52), and: (e52) => m(t52, e52), or: (e52) => d(t52, e52), select: (e52) => void 0 === e52 ? p(t52) : p(e52, t52) });
}
function h(t52) {
  return Object.assign(((t62) => Object.assign(t62, { [Symbol.iterator]() {
    let n52 = 0;
    const r52 = [{ value: Object.assign(t62, { [e]: true }), done: false }, { done: true, value: void 0 }];
    return { next: () => {
      var t72;
      return null != (t72 = r52[n52++]) ? t72 : r52.at(-1);
    } };
  } }))(t52), { optional: () => h(l(t52)), select: (e52) => h(void 0 === e52 ? p(t52) : p(e52, t52)) });
}
function l(e52) {
  return u({ [t]: () => ({ match: (t52) => {
    let n52 = {};
    const r52 = (t62, e62) => {
      n52[t62] = e62;
    };
    return void 0 === t52 ? (s(e52).forEach((t62) => r52(t62, void 0)), { matched: true, selections: n52 }) : { matched: o(e52, t52, r52), selections: n52 };
  }, getSelectionKeys: () => s(e52), matcherType: "optional" }) });
}
var f = (t52, e52) => {
  for (const n52 of t52) if (!e52(n52)) return false;
  return true;
};
var g = (t52, e52) => {
  for (const [n52, r52] of t52.entries()) if (!e52(r52, n52)) return false;
  return true;
};
function m(...e52) {
  return u({ [t]: () => ({ match: (t52) => {
    let n52 = {};
    const r52 = (t62, e62) => {
      n52[t62] = e62;
    };
    return { matched: e52.every((e62) => o(e62, t52, r52)), selections: n52 };
  }, getSelectionKeys: () => c(e52, s), matcherType: "and" }) });
}
function d(...e52) {
  return u({ [t]: () => ({ match: (t52) => {
    let n52 = {};
    const r52 = (t62, e62) => {
      n52[t62] = e62;
    };
    return c(e52, s).forEach((t62) => r52(t62, void 0)), { matched: e52.some((e62) => o(e62, t52, r52)), selections: n52 };
  }, getSelectionKeys: () => c(e52, s), matcherType: "or" }) });
}
function y(e52) {
  return { [t]: () => ({ match: (t52) => ({ matched: Boolean(e52(t52)) }) }) };
}
function p(...e52) {
  const r52 = "string" == typeof e52[0] ? e52[0] : void 0, i52 = 2 === e52.length ? e52[1] : "string" == typeof e52[0] ? void 0 : e52[0];
  return u({ [t]: () => ({ match: (t52) => {
    let e62 = { [null != r52 ? r52 : n]: t52 };
    return { matched: void 0 === i52 || o(i52, t52, (t62, n52) => {
      e62[t62] = n52;
    }), selections: e62 };
  }, getSelectionKeys: () => [null != r52 ? r52 : n].concat(void 0 === i52 ? [] : s(i52)) }) });
}
function v(t52) {
  return "number" == typeof t52;
}
function b(t52) {
  return "string" == typeof t52;
}
function w(t52) {
  return "bigint" == typeof t52;
}
var S = u(y(function(t52) {
  return true;
}));
var O = S;
var j = (t52) => Object.assign(u(t52), { startsWith: (e52) => {
  return j(m(t52, (n52 = e52, y((t62) => b(t62) && t62.startsWith(n52)))));
  var n52;
}, endsWith: (e52) => {
  return j(m(t52, (n52 = e52, y((t62) => b(t62) && t62.endsWith(n52)))));
  var n52;
}, minLength: (e52) => j(m(t52, ((t62) => y((e62) => b(e62) && e62.length >= t62))(e52))), maxLength: (e52) => j(m(t52, ((t62) => y((e62) => b(e62) && e62.length <= t62))(e52))), includes: (e52) => {
  return j(m(t52, (n52 = e52, y((t62) => b(t62) && t62.includes(n52)))));
  var n52;
}, regex: (e52) => {
  return j(m(t52, (n52 = e52, y((t62) => b(t62) && Boolean(t62.match(n52))))));
  var n52;
} });
var E = j(y(b));
var K = (t52) => Object.assign(u(t52), { between: (e52, n52) => K(m(t52, ((t62, e62) => y((n62) => v(n62) && t62 <= n62 && e62 >= n62))(e52, n52))), lt: (e52) => K(m(t52, ((t62) => y((e62) => v(e62) && e62 < t62))(e52))), gt: (e52) => K(m(t52, ((t62) => y((e62) => v(e62) && e62 > t62))(e52))), lte: (e52) => K(m(t52, ((t62) => y((e62) => v(e62) && e62 <= t62))(e52))), gte: (e52) => K(m(t52, ((t62) => y((e62) => v(e62) && e62 >= t62))(e52))), int: () => K(m(t52, y((t62) => v(t62) && Number.isInteger(t62)))), finite: () => K(m(t52, y((t62) => v(t62) && Number.isFinite(t62)))), positive: () => K(m(t52, y((t62) => v(t62) && t62 > 0))), negative: () => K(m(t52, y((t62) => v(t62) && t62 < 0))) });
var x = K(y(v));
var A = (t52) => Object.assign(u(t52), { between: (e52, n52) => A(m(t52, ((t62, e62) => y((n62) => w(n62) && t62 <= n62 && e62 >= n62))(e52, n52))), lt: (e52) => A(m(t52, ((t62) => y((e62) => w(e62) && e62 < t62))(e52))), gt: (e52) => A(m(t52, ((t62) => y((e62) => w(e62) && e62 > t62))(e52))), lte: (e52) => A(m(t52, ((t62) => y((e62) => w(e62) && e62 <= t62))(e52))), gte: (e52) => A(m(t52, ((t62) => y((e62) => w(e62) && e62 >= t62))(e52))), positive: () => A(m(t52, y((t62) => w(t62) && t62 > 0))), negative: () => A(m(t52, y((t62) => w(t62) && t62 < 0))) });
var P = A(y(w));
var T = u(y(function(t52) {
  return "boolean" == typeof t52;
}));
var k = u(y(function(t52) {
  return "symbol" == typeof t52;
}));
var B = u(y(function(t52) {
  return null == t52;
}));
var _ = u(y(function(t52) {
  return null != t52;
}));
var N = { __proto__: null, matcher: t, optional: l, array: function(...e52) {
  return h({ [t]: () => ({ match: (t52) => {
    if (!Array.isArray(t52)) return { matched: false };
    if (0 === e52.length) return { matched: true };
    const n52 = e52[0];
    let r52 = {};
    if (0 === t52.length) return s(n52).forEach((t62) => {
      r52[t62] = [];
    }), { matched: true, selections: r52 };
    const i52 = (t62, e62) => {
      r52[t62] = (r52[t62] || []).concat([e62]);
    };
    return { matched: t52.every((t62) => o(n52, t62, i52)), selections: r52 };
  }, getSelectionKeys: () => 0 === e52.length ? [] : s(e52[0]) }) });
}, set: function(...e52) {
  return u({ [t]: () => ({ match: (t52) => {
    if (!(t52 instanceof Set)) return { matched: false };
    let n52 = {};
    if (0 === t52.size) return { matched: true, selections: n52 };
    if (0 === e52.length) return { matched: true };
    const r52 = (t62, e62) => {
      n52[t62] = (n52[t62] || []).concat([e62]);
    }, i52 = e52[0];
    return { matched: f(t52, (t62) => o(i52, t62, r52)), selections: n52 };
  }, getSelectionKeys: () => 0 === e52.length ? [] : s(e52[0]) }) });
}, map: function(...e52) {
  return u({ [t]: () => ({ match: (t52) => {
    if (!(t52 instanceof Map)) return { matched: false };
    let n52 = {};
    if (0 === t52.size) return { matched: true, selections: n52 };
    const r52 = (t62, e62) => {
      n52[t62] = (n52[t62] || []).concat([e62]);
    };
    if (0 === e52.length) return { matched: true };
    var i52;
    if (1 === e52.length) throw new Error(`\`P.map\` wasn't given enough arguments. Expected (key, value), received ${null == (i52 = e52[0]) ? void 0 : i52.toString()}`);
    const [s52, c52] = e52;
    return { matched: g(t52, (t62, e62) => {
      const n62 = o(s52, e62, r52), i62 = o(c52, t62, r52);
      return n62 && i62;
    }), selections: n52 };
  }, getSelectionKeys: () => 0 === e52.length ? [] : [...s(e52[0]), ...s(e52[1])] }) });
}, intersection: m, union: d, not: function(e52) {
  return u({ [t]: () => ({ match: (t52) => ({ matched: !o(e52, t52, () => {
  }) }), getSelectionKeys: () => [], matcherType: "not" }) });
}, when: y, select: p, any: S, _: O, string: E, number: x, bigint: P, boolean: T, symbol: k, nullish: B, nonNullable: _, instanceOf: function(t52) {
  return u(y(/* @__PURE__ */ function(t62) {
    return (e52) => e52 instanceof t62;
  }(t52)));
}, shape: function(t52) {
  return u(y(a(t52)));
} };
var W = { matched: false, value: void 0 };
function $(t52) {
  return new z(t52, W);
}
var z = class _z {
  constructor(t52, e52) {
    this.input = void 0, this.state = void 0, this.input = t52, this.state = e52;
  }
  with(...t52) {
    if (this.state.matched) return this;
    const e52 = t52[t52.length - 1], r52 = [t52[0]];
    let i52;
    3 === t52.length && "function" == typeof t52[1] ? i52 = t52[1] : t52.length > 2 && r52.push(...t52.slice(1, t52.length - 1));
    let s52 = false, c52 = {};
    const a52 = (t62, e62) => {
      s52 = true, c52[t62] = e62;
    }, u52 = !r52.some((t62) => o(t62, this.input, a52)) || i52 && !Boolean(i52(this.input)) ? W : { matched: true, value: e52(s52 ? n in c52 ? c52[n] : c52 : this.input, this.input) };
    return new _z(this.input, u52);
  }
  when(t52, e52) {
    if (this.state.matched) return this;
    const n52 = Boolean(t52(this.input));
    return new _z(this.input, n52 ? { matched: true, value: e52(this.input, this.input) } : W);
  }
  otherwise(t52) {
    return this.state.matched ? this.state.value : t52(this.input);
  }
  exhaustive() {
    if (this.state.matched) return this.state.value;
    let t52;
    try {
      t52 = JSON.stringify(this.input);
    } catch (e52) {
      t52 = this.input;
    }
    throw new Error(`Pattern matching error: no pattern matches value ${t52}`);
  }
  run() {
    return this.exhaustive();
  }
  returnType() {
    return this;
  }
};
var __defProp22 = Object.defineProperty;
var __export22 = (target, all632) => {
  for (var name22 in all632)
    __defProp22(target, name22, { get: all632[name22], enumerable: true });
};
var KEYS = {
  ArrayExpression: [
    "elements"
  ],
  ArrayPattern: [
    "elements"
  ],
  ArrowFunctionExpression: [
    "params",
    "body"
  ],
  AssignmentExpression: [
    "left",
    "right"
  ],
  AssignmentPattern: [
    "left",
    "right"
  ],
  AwaitExpression: [
    "argument"
  ],
  BinaryExpression: [
    "left",
    "right"
  ],
  BlockStatement: [
    "body"
  ],
  BreakStatement: [
    "label"
  ],
  CallExpression: [
    "callee",
    "arguments"
  ],
  CatchClause: [
    "param",
    "body"
  ],
  ChainExpression: [
    "expression"
  ],
  ClassBody: [
    "body"
  ],
  ClassDeclaration: [
    "id",
    "superClass",
    "body"
  ],
  ClassExpression: [
    "id",
    "superClass",
    "body"
  ],
  ConditionalExpression: [
    "test",
    "consequent",
    "alternate"
  ],
  ContinueStatement: [
    "label"
  ],
  DebuggerStatement: [],
  DoWhileStatement: [
    "body",
    "test"
  ],
  EmptyStatement: [],
  ExperimentalRestProperty: [
    "argument"
  ],
  ExperimentalSpreadProperty: [
    "argument"
  ],
  ExportAllDeclaration: [
    "exported",
    "source"
  ],
  ExportDefaultDeclaration: [
    "declaration"
  ],
  ExportNamedDeclaration: [
    "declaration",
    "specifiers",
    "source"
  ],
  ExportSpecifier: [
    "exported",
    "local"
  ],
  ExpressionStatement: [
    "expression"
  ],
  ForInStatement: [
    "left",
    "right",
    "body"
  ],
  ForOfStatement: [
    "left",
    "right",
    "body"
  ],
  ForStatement: [
    "init",
    "test",
    "update",
    "body"
  ],
  FunctionDeclaration: [
    "id",
    "params",
    "body"
  ],
  FunctionExpression: [
    "id",
    "params",
    "body"
  ],
  Identifier: [],
  IfStatement: [
    "test",
    "consequent",
    "alternate"
  ],
  ImportDeclaration: [
    "specifiers",
    "source"
  ],
  ImportDefaultSpecifier: [
    "local"
  ],
  ImportExpression: [
    "source"
  ],
  ImportNamespaceSpecifier: [
    "local"
  ],
  ImportSpecifier: [
    "imported",
    "local"
  ],
  JSXAttribute: [
    "name",
    "value"
  ],
  JSXClosingElement: [
    "name"
  ],
  JSXClosingFragment: [],
  JSXElement: [
    "openingElement",
    "children",
    "closingElement"
  ],
  JSXEmptyExpression: [],
  JSXExpressionContainer: [
    "expression"
  ],
  JSXFragment: [
    "openingFragment",
    "children",
    "closingFragment"
  ],
  JSXIdentifier: [],
  JSXMemberExpression: [
    "object",
    "property"
  ],
  JSXNamespacedName: [
    "namespace",
    "name"
  ],
  JSXOpeningElement: [
    "name",
    "attributes"
  ],
  JSXOpeningFragment: [],
  JSXSpreadAttribute: [
    "argument"
  ],
  JSXSpreadChild: [
    "expression"
  ],
  JSXText: [],
  LabeledStatement: [
    "label",
    "body"
  ],
  Literal: [],
  LogicalExpression: [
    "left",
    "right"
  ],
  MemberExpression: [
    "object",
    "property"
  ],
  MetaProperty: [
    "meta",
    "property"
  ],
  MethodDefinition: [
    "key",
    "value"
  ],
  NewExpression: [
    "callee",
    "arguments"
  ],
  ObjectExpression: [
    "properties"
  ],
  ObjectPattern: [
    "properties"
  ],
  PrivateIdentifier: [],
  Program: [
    "body"
  ],
  Property: [
    "key",
    "value"
  ],
  PropertyDefinition: [
    "key",
    "value"
  ],
  RestElement: [
    "argument"
  ],
  ReturnStatement: [
    "argument"
  ],
  SequenceExpression: [
    "expressions"
  ],
  SpreadElement: [
    "argument"
  ],
  StaticBlock: [
    "body"
  ],
  Super: [],
  SwitchCase: [
    "test",
    "consequent"
  ],
  SwitchStatement: [
    "discriminant",
    "cases"
  ],
  TaggedTemplateExpression: [
    "tag",
    "quasi"
  ],
  TemplateElement: [],
  TemplateLiteral: [
    "quasis",
    "expressions"
  ],
  ThisExpression: [],
  ThrowStatement: [
    "argument"
  ],
  TryStatement: [
    "block",
    "handler",
    "finalizer"
  ],
  UnaryExpression: [
    "argument"
  ],
  UpdateExpression: [
    "argument"
  ],
  VariableDeclaration: [
    "declarations"
  ],
  VariableDeclarator: [
    "id",
    "init"
  ],
  WhileStatement: [
    "test",
    "body"
  ],
  WithStatement: [
    "object",
    "body"
  ],
  YieldExpression: [
    "argument"
  ]
};
var NODE_TYPES = Object.keys(KEYS);
for (const type of NODE_TYPES) {
  Object.freeze(KEYS[type]);
}
Object.freeze(KEYS);
var visitor_keys_default = KEYS;
var KEY_BLACKLIST = /* @__PURE__ */ new Set([
  "parent",
  "leadingComments",
  "trailingComments"
]);
function filterKey(key) {
  return !KEY_BLACKLIST.has(key) && key[0] !== "_";
}
function getKeys(node) {
  return Object.keys(node).filter(filterKey);
}
function getInnermostScope(initialScope, node) {
  const location = node.range[0];
  let scope = initialScope;
  let found = false;
  do {
    found = false;
    for (const childScope of scope.childScopes) {
      const range222 = childScope.block.range;
      if (range222[0] <= location && location < range222[1]) {
        scope = childScope;
        found = true;
        break;
      }
    }
  } while (found);
  return scope;
}
function findVariable(initialScope, nameOrNode) {
  let name22 = "";
  let scope = initialScope;
  if (typeof nameOrNode === "string") {
    name22 = nameOrNode;
  } else {
    name22 = nameOrNode.name;
    scope = getInnermostScope(scope, nameOrNode);
  }
  while (scope != null) {
    const variable = scope.set.get(name22);
    if (variable != null) {
      return variable;
    }
    scope = scope.upper;
  }
  return null;
}
function negate0(token) {
  return !this(token);
}
function negate(f232) {
  return negate0.bind(f232);
}
function isPunctuatorTokenWithValue(token, value) {
  return token.type === "Punctuator" && token.value === value;
}
function isArrowToken(token) {
  return isPunctuatorTokenWithValue(token, "=>");
}
function isCommaToken(token) {
  return isPunctuatorTokenWithValue(token, ",");
}
function isSemicolonToken(token) {
  return isPunctuatorTokenWithValue(token, ";");
}
function isColonToken(token) {
  return isPunctuatorTokenWithValue(token, ":");
}
function isOpeningParenToken(token) {
  return isPunctuatorTokenWithValue(token, "(");
}
function isClosingParenToken(token) {
  return isPunctuatorTokenWithValue(token, ")");
}
function isOpeningBracketToken(token) {
  return isPunctuatorTokenWithValue(token, "[");
}
function isClosingBracketToken(token) {
  return isPunctuatorTokenWithValue(token, "]");
}
function isOpeningBraceToken(token) {
  return isPunctuatorTokenWithValue(token, "{");
}
function isClosingBraceToken(token) {
  return isPunctuatorTokenWithValue(token, "}");
}
function isCommentToken(token) {
  return ["Block", "Line", "Shebang"].includes(token.type);
}
negate(isArrowToken);
negate(isCommaToken);
negate(isSemicolonToken);
negate(isColonToken);
negate(isOpeningParenToken);
negate(isClosingParenToken);
negate(isOpeningBracketToken);
negate(isClosingBracketToken);
negate(isOpeningBraceToken);
negate(isClosingBraceToken);
negate(isCommentToken);
function getOpeningParenOfParams(node, sourceCode) {
  return node.id ? sourceCode.getTokenAfter(node.id, isOpeningParenToken) : sourceCode.getFirstToken(node, isOpeningParenToken);
}
function getFunctionHeadLocation(node, sourceCode) {
  const parent = node.parent;
  let start = null;
  let end = null;
  if (node.type === "ArrowFunctionExpression") {
    const arrowToken = sourceCode.getTokenBefore(node.body, isArrowToken);
    start = arrowToken.loc.start;
    end = arrowToken.loc.end;
  } else if (parent.type === "Property" || parent.type === "MethodDefinition" || parent.type === "PropertyDefinition") {
    start = parent.loc.start;
    end = getOpeningParenOfParams(node, sourceCode).loc.start;
  } else {
    start = node.loc.start;
    end = getOpeningParenOfParams(node, sourceCode).loc.start;
  }
  return {
    start: { ...start },
    end: { ...end }
  };
}
var globalObject = typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {};
var builtinNames = Object.freeze(
  /* @__PURE__ */ new Set([
    "Array",
    "ArrayBuffer",
    "BigInt",
    "BigInt64Array",
    "BigUint64Array",
    "Boolean",
    "DataView",
    "Date",
    "decodeURI",
    "decodeURIComponent",
    "encodeURI",
    "encodeURIComponent",
    "escape",
    "Float32Array",
    "Float64Array",
    "Function",
    "Infinity",
    "Int16Array",
    "Int32Array",
    "Int8Array",
    "isFinite",
    "isNaN",
    "isPrototypeOf",
    "JSON",
    "Map",
    "Math",
    "NaN",
    "Number",
    "Object",
    "parseFloat",
    "parseInt",
    "Promise",
    "Proxy",
    "Reflect",
    "RegExp",
    "Set",
    "String",
    "Symbol",
    "Uint16Array",
    "Uint32Array",
    "Uint8Array",
    "Uint8ClampedArray",
    "undefined",
    "unescape",
    "WeakMap",
    "WeakSet"
  ])
);
var callAllowed = new Set(
  [
    Array.isArray,
    Array.of,
    Array.prototype.at,
    Array.prototype.concat,
    Array.prototype.entries,
    Array.prototype.every,
    Array.prototype.filter,
    Array.prototype.find,
    Array.prototype.findIndex,
    Array.prototype.flat,
    Array.prototype.includes,
    Array.prototype.indexOf,
    Array.prototype.join,
    Array.prototype.keys,
    Array.prototype.lastIndexOf,
    Array.prototype.slice,
    Array.prototype.some,
    Array.prototype.toString,
    Array.prototype.values,
    typeof BigInt === "function" ? BigInt : void 0,
    Boolean,
    Date,
    Date.parse,
    decodeURI,
    decodeURIComponent,
    encodeURI,
    encodeURIComponent,
    escape,
    isFinite,
    isNaN,
    isPrototypeOf,
    Map,
    Map.prototype.entries,
    Map.prototype.get,
    Map.prototype.has,
    Map.prototype.keys,
    Map.prototype.values,
    ...Object.getOwnPropertyNames(Math).filter((k232) => k232 !== "random").map((k232) => Math[k232]).filter((f232) => typeof f232 === "function"),
    Number,
    Number.isFinite,
    Number.isNaN,
    Number.parseFloat,
    Number.parseInt,
    Number.prototype.toExponential,
    Number.prototype.toFixed,
    Number.prototype.toPrecision,
    Number.prototype.toString,
    Object,
    Object.entries,
    Object.is,
    Object.isExtensible,
    Object.isFrozen,
    Object.isSealed,
    Object.keys,
    Object.values,
    parseFloat,
    parseInt,
    RegExp,
    Set,
    Set.prototype.entries,
    Set.prototype.has,
    Set.prototype.keys,
    Set.prototype.values,
    String,
    String.fromCharCode,
    String.fromCodePoint,
    String.raw,
    String.prototype.at,
    String.prototype.charAt,
    String.prototype.charCodeAt,
    String.prototype.codePointAt,
    String.prototype.concat,
    String.prototype.endsWith,
    String.prototype.includes,
    String.prototype.indexOf,
    String.prototype.lastIndexOf,
    String.prototype.normalize,
    String.prototype.padEnd,
    String.prototype.padStart,
    String.prototype.slice,
    String.prototype.startsWith,
    String.prototype.substr,
    String.prototype.substring,
    String.prototype.toLowerCase,
    String.prototype.toString,
    String.prototype.toUpperCase,
    String.prototype.trim,
    String.prototype.trimEnd,
    String.prototype.trimLeft,
    String.prototype.trimRight,
    String.prototype.trimStart,
    Symbol.for,
    Symbol.keyFor,
    unescape
  ].filter((f232) => typeof f232 === "function")
);
var callPassThrough = /* @__PURE__ */ new Set([
  Object.freeze,
  Object.preventExtensions,
  Object.seal
]);
var getterAllowed = [
  [Map, /* @__PURE__ */ new Set(["size"])],
  [
    RegExp,
    /* @__PURE__ */ new Set([
      "dotAll",
      "flags",
      "global",
      "hasIndices",
      "ignoreCase",
      "multiline",
      "source",
      "sticky",
      "unicode"
    ])
  ],
  [Set, /* @__PURE__ */ new Set(["size"])]
];
function getPropertyDescriptor(object32, name22) {
  let x232 = object32;
  while ((typeof x232 === "object" || typeof x232 === "function") && x232 !== null) {
    const d232 = Object.getOwnPropertyDescriptor(x232, name22);
    if (d232) {
      return d232;
    }
    x232 = Object.getPrototypeOf(x232);
  }
  return null;
}
function isGetter(object32, name22) {
  const d232 = getPropertyDescriptor(object32, name22);
  return d232 != null && d232.get != null;
}
function getElementValues(nodeList, initialScope) {
  const valueList = [];
  for (let i232 = 0; i232 < nodeList.length; ++i232) {
    const elementNode = nodeList[i232];
    if (elementNode == null) {
      valueList.length = i232 + 1;
    } else if (elementNode.type === "SpreadElement") {
      const argument = getStaticValueR(elementNode.argument, initialScope);
      if (argument == null) {
        return null;
      }
      valueList.push(...argument.value);
    } else {
      const element = getStaticValueR(elementNode, initialScope);
      if (element == null) {
        return null;
      }
      valueList.push(element.value);
    }
  }
  return valueList;
}
function isEffectivelyConst(variable) {
  const refs = variable.references;
  const inits = refs.filter((r232) => r232.init).length;
  const reads = refs.filter((r232) => r232.isReadOnly()).length;
  if (inits === 1 && reads + inits === refs.length) {
    return true;
  }
  return false;
}
var operations = Object.freeze({
  ArrayExpression(node, initialScope) {
    const elements = getElementValues(node.elements, initialScope);
    return elements != null ? { value: elements } : null;
  },
  AssignmentExpression(node, initialScope) {
    if (node.operator === "=") {
      return getStaticValueR(node.right, initialScope);
    }
    return null;
  },
  //eslint-disable-next-line complexity
  BinaryExpression(node, initialScope) {
    if (node.operator === "in" || node.operator === "instanceof") {
      return null;
    }
    const left532 = getStaticValueR(node.left, initialScope);
    const right532 = getStaticValueR(node.right, initialScope);
    if (left532 != null && right532 != null) {
      switch (node.operator) {
        case "==":
          return { value: left532.value == right532.value };
        case "!=":
          return { value: left532.value != right532.value };
        case "===":
          return { value: left532.value === right532.value };
        case "!==":
          return { value: left532.value !== right532.value };
        case "<":
          return { value: left532.value < right532.value };
        case "<=":
          return { value: left532.value <= right532.value };
        case ">":
          return { value: left532.value > right532.value };
        case ">=":
          return { value: left532.value >= right532.value };
        case "<<":
          return { value: left532.value << right532.value };
        case ">>":
          return { value: left532.value >> right532.value };
        case ">>>":
          return { value: left532.value >>> right532.value };
        case "+":
          return { value: left532.value + right532.value };
        case "-":
          return { value: left532.value - right532.value };
        case "*":
          return { value: left532.value * right532.value };
        case "/":
          return { value: left532.value / right532.value };
        case "%":
          return { value: left532.value % right532.value };
        case "**":
          return { value: left532.value ** right532.value };
        case "|":
          return { value: left532.value | right532.value };
        case "^":
          return { value: left532.value ^ right532.value };
        case "&":
          return { value: left532.value & right532.value };
      }
    }
    return null;
  },
  CallExpression(node, initialScope) {
    const calleeNode = node.callee;
    const args = getElementValues(node.arguments, initialScope);
    if (args != null) {
      if (calleeNode.type === "MemberExpression") {
        if (calleeNode.property.type === "PrivateIdentifier") {
          return null;
        }
        const object32 = getStaticValueR(calleeNode.object, initialScope);
        if (object32 != null) {
          if (object32.value == null && (object32.optional || node.optional)) {
            return { value: void 0, optional: true };
          }
          const property = getStaticPropertyNameValue(
            calleeNode,
            initialScope
          );
          if (property != null) {
            const receiver = object32.value;
            const methodName = property.value;
            if (callAllowed.has(receiver[methodName])) {
              return { value: receiver[methodName](...args) };
            }
            if (callPassThrough.has(receiver[methodName])) {
              return { value: args[0] };
            }
          }
        }
      } else {
        const callee = getStaticValueR(calleeNode, initialScope);
        if (callee != null) {
          if (callee.value == null && node.optional) {
            return { value: void 0, optional: true };
          }
          const func = callee.value;
          if (callAllowed.has(func)) {
            return { value: func(...args) };
          }
          if (callPassThrough.has(func)) {
            return { value: args[0] };
          }
        }
      }
    }
    return null;
  },
  ConditionalExpression(node, initialScope) {
    const test = getStaticValueR(node.test, initialScope);
    if (test != null) {
      return test.value ? getStaticValueR(node.consequent, initialScope) : getStaticValueR(node.alternate, initialScope);
    }
    return null;
  },
  ExpressionStatement(node, initialScope) {
    return getStaticValueR(node.expression, initialScope);
  },
  Identifier(node, initialScope) {
    if (initialScope != null) {
      const variable = findVariable(initialScope, node);
      if (variable != null && variable.defs.length === 0 && builtinNames.has(variable.name) && variable.name in globalObject) {
        return { value: globalObject[variable.name] };
      }
      if (variable != null && variable.defs.length === 1) {
        const def = variable.defs[0];
        if (def.parent && def.type === "Variable" && (def.parent.kind === "const" || isEffectivelyConst(variable)) && // TODO(mysticatea): don't support destructuring here.
        def.node.id.type === "Identifier") {
          return getStaticValueR(def.node.init, initialScope);
        }
      }
    }
    return null;
  },
  Literal(node) {
    if ((node.regex != null || node.bigint != null) && node.value == null) {
      return null;
    }
    return { value: node.value };
  },
  LogicalExpression(node, initialScope) {
    const left532 = getStaticValueR(node.left, initialScope);
    if (left532 != null) {
      if (node.operator === "||" && Boolean(left532.value) === true || node.operator === "&&" && Boolean(left532.value) === false || node.operator === "??" && left532.value != null) {
        return left532;
      }
      const right532 = getStaticValueR(node.right, initialScope);
      if (right532 != null) {
        return right532;
      }
    }
    return null;
  },
  MemberExpression(node, initialScope) {
    if (node.property.type === "PrivateIdentifier") {
      return null;
    }
    const object32 = getStaticValueR(node.object, initialScope);
    if (object32 != null) {
      if (object32.value == null && (object32.optional || node.optional)) {
        return { value: void 0, optional: true };
      }
      const property = getStaticPropertyNameValue(node, initialScope);
      if (property != null) {
        if (!isGetter(object32.value, property.value)) {
          return { value: object32.value[property.value] };
        }
        for (const [classFn, allowed] of getterAllowed) {
          if (object32.value instanceof classFn && allowed.has(property.value)) {
            return { value: object32.value[property.value] };
          }
        }
      }
    }
    return null;
  },
  ChainExpression(node, initialScope) {
    const expression = getStaticValueR(node.expression, initialScope);
    if (expression != null) {
      return { value: expression.value };
    }
    return null;
  },
  NewExpression(node, initialScope) {
    const callee = getStaticValueR(node.callee, initialScope);
    const args = getElementValues(node.arguments, initialScope);
    if (callee != null && args != null) {
      const Func = callee.value;
      if (callAllowed.has(Func)) {
        return { value: new Func(...args) };
      }
    }
    return null;
  },
  ObjectExpression(node, initialScope) {
    const object32 = {};
    for (const propertyNode of node.properties) {
      if (propertyNode.type === "Property") {
        if (propertyNode.kind !== "init") {
          return null;
        }
        const key = getStaticPropertyNameValue(
          propertyNode,
          initialScope
        );
        const value = getStaticValueR(propertyNode.value, initialScope);
        if (key == null || value == null) {
          return null;
        }
        object32[key.value] = value.value;
      } else if (propertyNode.type === "SpreadElement" || propertyNode.type === "ExperimentalSpreadProperty") {
        const argument = getStaticValueR(
          propertyNode.argument,
          initialScope
        );
        if (argument == null) {
          return null;
        }
        Object.assign(object32, argument.value);
      } else {
        return null;
      }
    }
    return { value: object32 };
  },
  SequenceExpression(node, initialScope) {
    const last222 = node.expressions[node.expressions.length - 1];
    return getStaticValueR(last222, initialScope);
  },
  TaggedTemplateExpression(node, initialScope) {
    const tag = getStaticValueR(node.tag, initialScope);
    const expressions = getElementValues(
      node.quasi.expressions,
      initialScope
    );
    if (tag != null && expressions != null) {
      const func = tag.value;
      const strings = node.quasi.quasis.map((q) => q.value.cooked);
      strings.raw = node.quasi.quasis.map((q) => q.value.raw);
      if (func === String.raw) {
        return { value: func(strings, ...expressions) };
      }
    }
    return null;
  },
  TemplateLiteral(node, initialScope) {
    const expressions = getElementValues(node.expressions, initialScope);
    if (expressions != null) {
      let value = node.quasis[0].value.cooked;
      for (let i232 = 0; i232 < expressions.length; ++i232) {
        value += expressions[i232];
        value += node.quasis[i232 + 1].value.cooked;
      }
      return { value };
    }
    return null;
  },
  UnaryExpression(node, initialScope) {
    if (node.operator === "delete") {
      return null;
    }
    if (node.operator === "void") {
      return { value: void 0 };
    }
    const arg = getStaticValueR(node.argument, initialScope);
    if (arg != null) {
      switch (node.operator) {
        case "-":
          return { value: -arg.value };
        case "+":
          return { value: +arg.value };
        case "!":
          return { value: !arg.value };
        case "~":
          return { value: ~arg.value };
        case "typeof":
          return { value: typeof arg.value };
      }
    }
    return null;
  }
});
function getStaticValueR(node, initialScope) {
  if (node != null && Object.hasOwnProperty.call(operations, node.type)) {
    return operations[node.type](node, initialScope);
  }
  return null;
}
function getStaticPropertyNameValue(node, initialScope) {
  const nameNode = node.type === "Property" ? node.key : node.property;
  if (node.computed) {
    return getStaticValueR(nameNode, initialScope);
  }
  if (nameNode.type === "Identifier") {
    return { value: nameNode.name };
  }
  if (nameNode.type === "Literal") {
    if (nameNode.bigint) {
      return { value: nameNode.bigint };
    }
    return { value: String(nameNode.value) };
  }
  return null;
}
function getStaticValue(node, initialScope = null) {
  try {
    return getStaticValueR(node, initialScope);
  } catch (_error) {
    return null;
  }
}
function getStringIfConstant(node, initialScope = null) {
  if (node && node.type === "Literal" && node.value === null) {
    if (node.regex) {
      return `/${node.regex.pattern}/${node.regex.flags}`;
    }
    if (node.bigint) {
      return node.bigint;
    }
  }
  const evaluated = getStaticValue(node, initialScope);
  return evaluated && String(evaluated.value);
}
function getPropertyName(node, initialScope) {
  switch (node.type) {
    case "MemberExpression":
      if (node.computed) {
        return getStringIfConstant(node.property, initialScope);
      }
      if (node.property.type === "PrivateIdentifier") {
        return null;
      }
      return node.property.name;
    case "Property":
    case "MethodDefinition":
    case "PropertyDefinition":
      if (node.computed) {
        return getStringIfConstant(node.key, initialScope);
      }
      if (node.key.type === "Literal") {
        return String(node.key.value);
      }
      if (node.key.type === "PrivateIdentifier") {
        return null;
      }
      return node.key.name;
  }
  return null;
}
function getFunctionNameWithKind(node, sourceCode) {
  const parent = node.parent;
  const tokens = [];
  const isObjectMethod = parent.type === "Property" && parent.value === node;
  const isClassMethod = parent.type === "MethodDefinition" && parent.value === node;
  const isClassFieldMethod = parent.type === "PropertyDefinition" && parent.value === node;
  if (isClassMethod || isClassFieldMethod) {
    if (parent.static) {
      tokens.push("static");
    }
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push("private");
    }
  }
  if (node.async) {
    tokens.push("async");
  }
  if (node.generator) {
    tokens.push("generator");
  }
  if (isObjectMethod || isClassMethod) {
    if (parent.kind === "constructor") {
      return "constructor";
    }
    if (parent.kind === "get") {
      tokens.push("getter");
    } else if (parent.kind === "set") {
      tokens.push("setter");
    } else {
      tokens.push("method");
    }
  } else if (isClassFieldMethod) {
    tokens.push("method");
  } else {
    if (node.type === "ArrowFunctionExpression") {
      tokens.push("arrow");
    }
    tokens.push("function");
  }
  if (isObjectMethod || isClassMethod || isClassFieldMethod) {
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push(`#${parent.key.name}`);
    } else {
      const name22 = getPropertyName(parent);
      if (name22) {
        tokens.push(`'${name22}'`);
      } else if (sourceCode) {
        const keyText = sourceCode.getText(parent.key);
        if (!keyText.includes("\n")) {
          tokens.push(`[${keyText}]`);
        }
      }
    }
  } else if (node.id) {
    tokens.push(`'${node.id.name}'`);
  } else if (parent.type === "VariableDeclarator" && parent.id && parent.id.type === "Identifier") {
    tokens.push(`'${parent.id.name}'`);
  } else if ((parent.type === "AssignmentExpression" || parent.type === "AssignmentPattern") && parent.left && parent.left.type === "Identifier") {
    tokens.push(`'${parent.left.name}'`);
  } else if (parent.type === "ExportDefaultDeclaration" && parent.declaration === node) {
    tokens.push("'default'");
  }
  return tokens.join(" ");
}
var typeConversionBinaryOps = Object.freeze(
  /* @__PURE__ */ new Set([
    "==",
    "!=",
    "<",
    "<=",
    ">",
    ">=",
    "<<",
    ">>",
    ">>>",
    "+",
    "-",
    "*",
    "/",
    "%",
    "|",
    "^",
    "&",
    "in"
  ])
);
var typeConversionUnaryOps = Object.freeze(/* @__PURE__ */ new Set(["-", "+", "!", "~"]));
function isNode(x232) {
  return x232 !== null && typeof x232 === "object" && typeof x232.type === "string";
}
var visitor = Object.freeze(
  Object.assign(/* @__PURE__ */ Object.create(null), {
    $visit(node, options, visitorKeys) {
      const { type } = node;
      if (typeof this[type] === "function") {
        return this[type](node, options, visitorKeys);
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    $visitChildren(node, options, visitorKeys) {
      const { type } = node;
      for (const key of visitorKeys[type] || getKeys(node)) {
        const value = node[key];
        if (Array.isArray(value)) {
          for (const element of value) {
            if (isNode(element) && this.$visit(element, options, visitorKeys)) {
              return true;
            }
          }
        } else if (isNode(value) && this.$visit(value, options, visitorKeys)) {
          return true;
        }
      }
      return false;
    },
    ArrowFunctionExpression() {
      return false;
    },
    AssignmentExpression() {
      return true;
    },
    AwaitExpression() {
      return true;
    },
    BinaryExpression(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && typeConversionBinaryOps.has(node.operator) && (node.left.type !== "Literal" || node.right.type !== "Literal")) {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    CallExpression() {
      return true;
    },
    FunctionExpression() {
      return false;
    },
    ImportExpression() {
      return true;
    },
    MemberExpression(node, options, visitorKeys) {
      if (options.considerGetters) {
        return true;
      }
      if (options.considerImplicitTypeConversion && node.computed && node.property.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    MethodDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    NewExpression() {
      return true;
    },
    Property(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    PropertyDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UnaryExpression(node, options, visitorKeys) {
      if (node.operator === "delete") {
        return true;
      }
      if (options.considerImplicitTypeConversion && typeConversionUnaryOps.has(node.operator) && node.argument.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UpdateExpression() {
      return true;
    },
    YieldExpression() {
      return true;
    }
  })
);
function hasSideEffect(node, sourceCode, { considerGetters = false, considerImplicitTypeConversion = false } = {}) {
  return visitor.$visit(
    node,
    { considerGetters, considerImplicitTypeConversion },
    sourceCode.visitorKeys || visitor_keys_default
  );
}
function getParentSyntaxParen(node, sourceCode) {
  const parent = node.parent;
  switch (parent.type) {
    case "CallExpression":
    case "NewExpression":
      if (parent.arguments.length === 1 && parent.arguments[0] === node) {
        return sourceCode.getTokenAfter(
          parent.callee,
          isOpeningParenToken
        );
      }
      return null;
    case "DoWhileStatement":
      if (parent.test === node) {
        return sourceCode.getTokenAfter(
          parent.body,
          isOpeningParenToken
        );
      }
      return null;
    case "IfStatement":
    case "WhileStatement":
      if (parent.test === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "ImportExpression":
      if (parent.source === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "SwitchStatement":
      if (parent.discriminant === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "WithStatement":
      if (parent.object === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    default:
      return null;
  }
}
function isParenthesized(timesOrNode, nodeOrSourceCode, optionalSourceCode) {
  let times, node, sourceCode, maybeLeftParen, maybeRightParen;
  if (typeof timesOrNode === "number") {
    times = timesOrNode | 0;
    node = nodeOrSourceCode;
    sourceCode = optionalSourceCode;
    if (!(times >= 1)) {
      throw new TypeError("'times' should be a positive integer.");
    }
  } else {
    times = 1;
    node = timesOrNode;
    sourceCode = nodeOrSourceCode;
  }
  if (node == null || // `Program` can't be parenthesized
  node.parent == null || // `CatchClause.param` can't be parenthesized, example `try {} catch (error) {}`
  node.parent.type === "CatchClause" && node.parent.param === node) {
    return false;
  }
  maybeLeftParen = maybeRightParen = node;
  do {
    maybeLeftParen = sourceCode.getTokenBefore(maybeLeftParen);
    maybeRightParen = sourceCode.getTokenAfter(maybeRightParen);
  } while (maybeLeftParen != null && maybeRightParen != null && isOpeningParenToken(maybeLeftParen) && isClosingParenToken(maybeRightParen) && // Avoid false positive such as `if (a) {}`
  maybeLeftParen !== getParentSyntaxParen(node, sourceCode) && --times > 0);
  return times === 0;
}
Function.call.bind(Object.hasOwnProperty);
var __defProp222 = Object.defineProperty;
var __export222 = (target, all3232) => {
  for (var name22 in all3232)
    __defProp222(target, name22, { get: all3232[name22], enumerable: true });
};
var NodeType = types.AST_NODE_TYPES;
var is = utils.ASTUtils.isNodeOfType;
var isOneOf = utils.ASTUtils.isNodeOfTypes;
isOneOf([
  NodeType.ArrowFunctionExpression,
  NodeType.FunctionDeclaration,
  NodeType.FunctionExpression
]);
isOneOf([
  NodeType.ArrowFunctionExpression,
  NodeType.FunctionDeclaration,
  NodeType.FunctionExpression,
  NodeType.TSCallSignatureDeclaration,
  NodeType.TSConstructSignatureDeclaration,
  NodeType.TSDeclareFunction,
  NodeType.TSEmptyBodyFunctionExpression,
  NodeType.TSFunctionType,
  NodeType.TSMethodSignature
]);
isOneOf([NodeType.ClassDeclaration, NodeType.ClassExpression]);
isOneOf([
  NodeType.DoWhileStatement,
  NodeType.ForInStatement,
  NodeType.ForOfStatement,
  NodeType.ForStatement,
  NodeType.WhileStatement
]);
isOneOf([NodeType.TSArrayType, NodeType.TSTupleType]);
isOneOf([
  NodeType.PropertyDefinition,
  NodeType.TSIndexSignature,
  NodeType.TSParameterProperty,
  NodeType.TSPropertySignature
]);
is(NodeType.JSXElement);
is(NodeType.JSXFragment);
isOneOf([
  NodeType.JSXAttribute,
  NodeType.JSXSpreadChild,
  NodeType.JSXClosingElement,
  NodeType.JSXClosingFragment,
  NodeType.JSXElement,
  NodeType.JSXEmptyExpression,
  NodeType.JSXExpressionContainer,
  NodeType.JSXFragment,
  NodeType.JSXIdentifier,
  NodeType.JSXMemberExpression,
  NodeType.JSXNamespacedName,
  NodeType.JSXOpeningElement,
  NodeType.JSXOpeningFragment,
  NodeType.JSXSpreadAttribute,
  NodeType.JSXSpreadChild,
  NodeType.JSXText
]);
isOneOf([
  NodeType.JSXIdentifier,
  NodeType.JSXMemberExpression,
  NodeType.JSXNamespacedName
]);
isOneOf([
  NodeType.ArrayPattern,
  NodeType.AssignmentPattern,
  NodeType.ObjectPattern,
  NodeType.RestElement
]);
isOneOf([
  NodeType.TSInterfaceDeclaration,
  NodeType.TSTypeAliasDeclaration
]);
isOneOf([
  NodeType.ArrayExpression,
  NodeType.ArrayPattern,
  NodeType.ArrowFunctionExpression,
  NodeType.CallExpression,
  NodeType.ClassExpression,
  NodeType.FunctionExpression,
  NodeType.Identifier,
  NodeType.JSXElement,
  NodeType.JSXFragment,
  NodeType.Literal,
  NodeType.TemplateLiteral,
  NodeType.MemberExpression,
  NodeType.MetaProperty,
  NodeType.ObjectExpression,
  NodeType.ObjectPattern,
  NodeType.SequenceExpression,
  NodeType.Super,
  NodeType.TaggedTemplateExpression,
  NodeType.ThisExpression
]);
isOneOf([
  NodeType.ArrayExpression,
  NodeType.ArrayPattern,
  NodeType.ArrowFunctionExpression,
  NodeType.CallExpression,
  NodeType.ClassExpression,
  NodeType.FunctionExpression,
  NodeType.Identifier,
  NodeType.JSXElement,
  NodeType.JSXFragment,
  NodeType.Literal,
  NodeType.TemplateLiteral,
  NodeType.MemberExpression,
  NodeType.MetaProperty,
  NodeType.ObjectExpression,
  NodeType.ObjectPattern,
  NodeType.SequenceExpression,
  NodeType.Super,
  NodeType.TaggedTemplateExpression,
  NodeType.ThisExpression,
  NodeType.TSAsExpression,
  NodeType.TSNonNullExpression,
  NodeType.TSTypeAssertion
]);
var Function_exports = {};
__export222(Function_exports, {
  SK: () => SK,
  absurd: () => absurd,
  apply: () => apply,
  compose: () => compose,
  constFalse: () => constFalse,
  constNull: () => constNull,
  constTrue: () => constTrue,
  constUndefined: () => constUndefined,
  constVoid: () => constVoid,
  constant: () => constant,
  dual: () => dual,
  flip: () => flip,
  flow: () => flow,
  hole: () => hole,
  identity: () => identity,
  isFunction: () => isFunction2,
  pipe: () => pipe,
  satisfies: () => satisfies,
  tupled: () => tupled,
  unsafeCoerce: () => unsafeCoerce,
  untupled: () => untupled
});
var isFunction2 = (input) => typeof input === "function";
var dual = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a232, b232) {
        if (arguments.length >= 2) {
          return body(a232, b232);
        }
        return function(self2) {
          return body(self2, a232);
        };
      };
    case 3:
      return function(a232, b232, c232) {
        if (arguments.length >= 3) {
          return body(a232, b232, c232);
        }
        return function(self2) {
          return body(self2, a232, b232);
        };
      };
    case 4:
      return function(a232, b232, c232, d232) {
        if (arguments.length >= 4) {
          return body(a232, b232, c232, d232);
        }
        return function(self2) {
          return body(self2, a232, b232, c232);
        };
      };
    case 5:
      return function(a232, b232, c232, d232, e232) {
        if (arguments.length >= 5) {
          return body(a232, b232, c232, d232, e232);
        }
        return function(self2) {
          return body(self2, a232, b232, c232, d232);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply = (a232) => (self2) => self2(a232);
var identity = (a232) => a232;
var satisfies = () => (b232) => b232;
var unsafeCoerce = identity;
var constant = (value) => () => value;
var constTrue = /* @__PURE__ */ constant(true);
var constFalse = /* @__PURE__ */ constant(false);
var constNull = /* @__PURE__ */ constant(null);
var constUndefined = /* @__PURE__ */ constant(void 0);
var constVoid = constUndefined;
var flip = (f232) => (...b232) => (...a232) => f232(...a232)(...b232);
var compose = /* @__PURE__ */ dual(2, (ab, bc) => (a232) => bc(ab(a232)));
var absurd = (_232) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled = (f232) => (a232) => f232(...a232);
var untupled = (f232) => (...a232) => f232(a232);
function pipe(a232, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a232;
    case 2:
      return ab(a232);
    case 3:
      return bc(ab(a232));
    case 4:
      return cd(bc(ab(a232)));
    case 5:
      return de(cd(bc(ab(a232))));
    case 6:
      return ef(de(cd(bc(ab(a232)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a232))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a232)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a232))))))));
    default: {
      let ret = arguments[0];
      for (let i232 = 1; i232 < arguments.length; i232++) {
        ret = arguments[i232](ret);
      }
      return ret;
    }
  }
}
function flow(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole = /* @__PURE__ */ unsafeCoerce(absurd);
var SK = (_232, b232) => b232;
var make = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_ = (map632) => dual(3, (self2, name22, f232) => map632(self2, (a232) => Object.assign({}, a232, {
  [name22]: f232(a232)
})));
var bindTo = (map632) => dual(2, (self2, name22) => map632(self2, (a232) => ({
  [name22]: a232
})));
var bind = (map632, flatMap4222) => dual(3, (self2, name22, f232) => flatMap4222(self2, (a232) => map632(f232(a232), (b232) => Object.assign({}, a232, {
  [name22]: b232
}))));
var moduleVersion = "3.2.8";
var getCurrentVersion = () => moduleVersion;
var globalStoreId = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion()}`);
if (!(globalStoreId in globalThis)) {
  globalThis[globalStoreId] = /* @__PURE__ */ new Map();
}
var globalStore = globalThis[globalStoreId];
var globalValue = (id, compute) => {
  if (!globalStore.has(id)) {
    globalStore.set(id, compute());
  }
  return globalStore.get(id);
};
var Predicate_exports = {};
__export222(Predicate_exports, {
  all: () => all,
  and: () => and,
  compose: () => compose2,
  eqv: () => eqv,
  every: () => every,
  hasProperty: () => hasProperty,
  implies: () => implies,
  isBigInt: () => isBigInt,
  isBoolean: () => isBoolean,
  isDate: () => isDate,
  isError: () => isError,
  isFunction: () => isFunction3,
  isIterable: () => isIterable,
  isMap: () => isMap,
  isNever: () => isNever,
  isNotNull: () => isNotNull,
  isNotNullable: () => isNotNullable,
  isNotUndefined: () => isNotUndefined,
  isNull: () => isNull,
  isNullable: () => isNullable,
  isNumber: () => isNumber,
  isObject: () => isObject,
  isPromise: () => isPromise,
  isPromiseLike: () => isPromiseLike,
  isReadonlyRecord: () => isReadonlyRecord,
  isRecord: () => isRecord,
  isSet: () => isSet,
  isString: () => isString,
  isSymbol: () => isSymbol,
  isTagged: () => isTagged,
  isTruthy: () => isTruthy,
  isUint8Array: () => isUint8Array,
  isUndefined: () => isUndefined,
  isUnknown: () => isUnknown,
  mapInput: () => mapInput,
  nand: () => nand,
  nor: () => nor,
  not: () => not,
  or: () => or,
  product: () => product,
  productMany: () => productMany,
  some: () => some,
  struct: () => struct,
  tuple: () => tuple,
  xor: () => xor
});
var mapInput = /* @__PURE__ */ dual(2, (self2, f232) => (b232) => self2(f232(b232)));
var isTruthy = (input) => !!input;
var isSet = (input) => input instanceof Set;
var isMap = (input) => input instanceof Map;
var isString = (input) => typeof input === "string";
var isNumber = (input) => typeof input === "number";
var isBoolean = (input) => typeof input === "boolean";
var isBigInt = (input) => typeof input === "bigint";
var isSymbol = (input) => typeof input === "symbol";
var isFunction3 = isFunction2;
var isUndefined = (input) => input === void 0;
var isNotUndefined = (input) => input !== void 0;
var isNull = (input) => input === null;
var isNotNull = (input) => input !== null;
var isNever = (_232) => false;
var isUnknown = (_232) => true;
var isRecordOrArray = (input) => typeof input === "object" && input !== null;
var isObject = (input) => isRecordOrArray(input) || isFunction3(input);
var hasProperty = /* @__PURE__ */ dual(2, (self2, property) => isObject(self2) && property in self2);
var isTagged = /* @__PURE__ */ dual(2, (self2, tag) => hasProperty(self2, "_tag") && self2["_tag"] === tag);
var isNullable = (input) => input === null || input === void 0;
var isNotNullable = (input) => input !== null && input !== void 0;
var isError = (input) => input instanceof Error;
var isUint8Array = (input) => input instanceof Uint8Array;
var isDate = (input) => input instanceof Date;
var isIterable = (input) => hasProperty(input, Symbol.iterator);
var isRecord = (input) => isRecordOrArray(input) && !Array.isArray(input);
var isReadonlyRecord = isRecord;
var isPromise = (input) => hasProperty(input, "then") && "catch" in input && isFunction3(input.then) && isFunction3(input.catch);
var isPromiseLike = (input) => hasProperty(input, "then") && isFunction3(input.then);
var compose2 = /* @__PURE__ */ dual(2, (ab, bc) => (a232) => ab(a232) && bc(a232));
var product = (self2, that) => ([a232, b232]) => self2(a232) && that(b232);
var all = (collection) => {
  return (as2332) => {
    let collectionIndex = 0;
    for (const p232 of collection) {
      if (collectionIndex >= as2332.length) {
        break;
      }
      if (p232(as2332[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany = (self2, collection) => {
  const rest = all(collection);
  return ([head232, ...tail232]) => self2(head232) === false ? false : rest(tail232);
};
var tuple = (...elements) => all(elements);
var struct = (fields) => {
  const keys2232 = Object.keys(fields);
  return (a232) => {
    for (const key of keys2232) {
      if (!fields[key](a232[key])) {
        return false;
      }
    }
    return true;
  };
};
var not = (self2) => (a232) => !self2(a232);
var or = /* @__PURE__ */ dual(2, (self2, that) => (a232) => self2(a232) || that(a232));
var and = /* @__PURE__ */ dual(2, (self2, that) => (a232) => self2(a232) && that(a232));
var xor = /* @__PURE__ */ dual(2, (self2, that) => (a232) => self2(a232) !== that(a232));
var eqv = /* @__PURE__ */ dual(2, (self2, that) => (a232) => self2(a232) === that(a232));
var implies = /* @__PURE__ */ dual(2, (self2, that) => (a232) => self2(a232) ? that(a232) : true);
var nor = /* @__PURE__ */ dual(2, (self2, that) => (a232) => !(self2(a232) || that(a232)));
var nand = /* @__PURE__ */ dual(2, (self2, that) => (a232) => !(self2(a232) && that(a232)));
var every = (collection) => (a232) => {
  for (const p232 of collection) {
    if (!p232(a232)) {
      return false;
    }
  }
  return true;
};
var some = (collection) => (a232) => {
  for (const p232 of collection) {
    if (p232(a232)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind = (u232) => isObject(u232) && GenKindTypeId in u232;
var GenKindImpl = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId] = GenKindTypeId;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen(this);
  }
};
var SingleShotGen = class _SingleShotGen {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a232) {
    return this.called ? {
      value: a232,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a232) {
    return {
      value: a232,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e232) {
    throw e232;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen(this.self);
  }
};
var adapter = () => function() {
  let x232 = arguments[0];
  for (let i232 = 1; i232 < arguments.length; i232++) {
    x232 = arguments[i232](x232);
  }
  return new GenKindImpl(x232);
};
var defaultIncHi = 335903614;
var defaultIncLo = 4150755663;
var MUL_HI = 1481765933 >>> 0;
var MUL_LO = 1284865837 >>> 0;
var BIT_53 = 9007199254740992;
var BIT_27 = 134217728;
var PCGRandom = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable(seedLo) && isNullable(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable(incLo) && isNullable(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo;
      incHi = this._state ? this._state[2] : defaultIncHi;
    } else if (isNullable(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add64(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max322) {
    if (!max322) {
      return this._next();
    }
    max322 = max322 >>> 0;
    if ((max322 & max322 - 1) === 0) {
      return this._next() & max322 - 1;
    }
    let num = 0;
    const skew = (-max322 >>> 0) % max322 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max322;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_27 + lo) / BIT_53;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul64(this._state, oldHi, oldLo, MUL_HI, MUL_LO);
    add64(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul64(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add64(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId]() {
    return this.#value;
  }
};
function yieldWrapGet(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId in self2) {
    return self2[YieldWrapTypeId]();
  }
  throw new Error(getBugErrorMessage("yieldWrapGet"));
}
var structuralRegionState = /* @__PURE__ */ globalValue("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache = /* @__PURE__ */ globalValue(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr = /* @__PURE__ */ globalValue(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom());
var symbol = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash = (self2) => {
  if (structuralRegionState.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number(self2);
    case "bigint":
      return string(self2.toString(10));
    case "boolean":
      return string(String(self2));
    case "symbol":
      return string(String(self2));
    case "string":
      return string(self2);
    case "undefined":
      return string("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string("null");
      } else if (self2 instanceof Date) {
        return hash(self2.toISOString());
      } else if (isHash(self2)) {
        return self2[symbol]();
      } else {
        return random(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random = (self2) => {
  if (!randomHashCache.has(self2)) {
    randomHashCache.set(self2, number(pcgr.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache.get(self2);
};
var combine = (b232) => (self2) => self2 * 53 ^ b232;
var optimize = (n232) => n232 & 3221225471 | n232 >>> 1 & 1073741824;
var isHash = (u232) => hasProperty(u232, symbol);
var number = (n232) => {
  if (n232 !== n232 || n232 === Infinity) {
    return 0;
  }
  let h232 = n232 | 0;
  if (h232 !== n232) {
    h232 ^= n232 * 4294967295;
  }
  while (n232 > 4294967295) {
    h232 ^= n232 /= 4294967295;
  }
  return optimize(n232);
};
var string = (str) => {
  let h232 = 5381, i232 = str.length;
  while (i232) {
    h232 = h232 * 33 ^ str.charCodeAt(--i232);
  }
  return optimize(h232);
};
var structureKeys = (o232, keys2232) => {
  let h232 = 12289;
  for (let i232 = 0; i232 < keys2232.length; i232++) {
    h232 ^= pipe(string(keys2232[i232]), combine(hash(o232[keys2232[i232]])));
  }
  return optimize(h232);
};
var structure = (o232) => structureKeys(o232, Object.keys(o232));
var array = (arr) => {
  let h232 = 6151;
  for (let i232 = 0; i232 < arr.length; i232++) {
    h232 = pipe(h232, combine(hash(arr[i232])));
  }
  return optimize(h232);
};
var cached = function() {
  if (arguments.length === 1) {
    const self22 = arguments[0];
    return function(hash3222) {
      Object.defineProperty(self22, symbol, {
        value() {
          return hash3222;
        },
        enumerable: false
      });
      return hash3222;
    };
  }
  const self2 = arguments[0];
  const hash2332 = arguments[1];
  Object.defineProperty(self2, symbol, {
    value() {
      return hash2332;
    },
    enumerable: false
  });
  return hash2332;
};
var symbol2 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals() {
  if (arguments.length === 1) {
    return (self2) => compareBoth(self2, arguments[0]);
  }
  return compareBoth(arguments[0], arguments[1]);
}
function compareBoth(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual(self2) && isEqual(that)) {
        if (hash(self2) === hash(that) && self2[symbol2](that)) {
          return true;
        } else {
          return structuralRegionState.enabled && structuralRegionState.tester ? structuralRegionState.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v232, i232) => compareBoth(v232, that[i232]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth(self2[key], that[key]))) {
              return structuralRegionState.tester ? structuralRegionState.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState.tester ? structuralRegionState.tester(self2, that) : false;
    }
  }
  return structuralRegionState.enabled && structuralRegionState.tester ? structuralRegionState.tester(self2, that) : false;
}
var isEqual = (u232) => hasProperty(u232, symbol2);
var equivalence = () => equals;
var NodeInspectSymbol = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON = (x232) => {
  if (hasProperty(x232, "toJSON") && isFunction3(x232["toJSON"]) && x232["toJSON"].length === 0) {
    return x232.toJSON();
  } else if (Array.isArray(x232)) {
    return x232.map(toJSON);
  }
  return x232;
};
var format = (x232) => JSON.stringify(x232, null, 2);
var pipeArguments = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i232 = 0, len = args.length; i232 < len; i232++) {
        ret = args[i232](ret);
      }
      return ret;
    }
  }
};
var OP_COMMIT = "Commit";
var OP_FAILURE = "Failure";
var OP_WITH_RUNTIME = "WithRuntime";
var EffectTypeId = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance = {
  /* c8 ignore next */
  _R: (_232) => _232,
  /* c8 ignore next */
  _E: (_232) => _232,
  /* c8 ignore next */
  _A: (_232) => _232,
  _V: /* @__PURE__ */ getCurrentVersion()
};
var sinkVariance = {
  /* c8 ignore next */
  _A: (_232) => _232,
  /* c8 ignore next */
  _In: (_232) => _232,
  /* c8 ignore next */
  _L: (_232) => _232,
  /* c8 ignore next */
  _E: (_232) => _232,
  /* c8 ignore next */
  _R: (_232) => _232
};
var channelVariance = {
  /* c8 ignore next */
  _Env: (_232) => _232,
  /* c8 ignore next */
  _InErr: (_232) => _232,
  /* c8 ignore next */
  _InElem: (_232) => _232,
  /* c8 ignore next */
  _InDone: (_232) => _232,
  /* c8 ignore next */
  _OutErr: (_232) => _232,
  /* c8 ignore next */
  _OutElem: (_232) => _232,
  /* c8 ignore next */
  _OutDone: (_232) => _232
};
var EffectPrototype = {
  [EffectTypeId]: effectVariance,
  [StreamTypeId]: effectVariance,
  [SinkTypeId]: sinkVariance,
  [ChannelTypeId]: channelVariance,
  [symbol2](that) {
    return this === that;
  },
  [symbol]() {
    return cached(this, random(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen(new YieldWrap(this));
  },
  pipe() {
    return pipeArguments(this, arguments);
  }
};
var StructuralPrototype = {
  [symbol]() {
    return cached(this, structure(this));
  },
  [symbol2](that) {
    const selfKeys = Object.keys(this);
    const thatKeys = Object.keys(that);
    if (selfKeys.length !== thatKeys.length) {
      return false;
    }
    for (const key of selfKeys) {
      if (!(key in that && equals(this[key], that[key]))) {
        return false;
      }
    }
    return true;
  }
};
var CommitPrototype = {
  ...EffectPrototype,
  _op: OP_COMMIT
};
var StructuralCommitPrototype = {
  ...CommitPrototype,
  ...StructuralPrototype
};
var TypeId = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto = {
  ...EffectPrototype,
  [TypeId]: {
    _A: (_232) => _232
  },
  [NodeInspectSymbol]() {
    return this.toJSON();
  },
  toString() {
    return format(this.toJSON());
  }
};
var SomeProto = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto), {
  _tag: "Some",
  _op: "Some",
  [symbol2](that) {
    return isOption(that) && isSome(that) && equals(this.value, that.value);
  },
  [symbol]() {
    return cached(this, combine(hash(this._tag))(hash(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON(this.value)
    };
  }
});
var NoneHash = /* @__PURE__ */ hash("None");
var NoneProto = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto), {
  _tag: "None",
  _op: "None",
  [symbol2](that) {
    return isOption(that) && isNone(that);
  },
  [symbol]() {
    return NoneHash;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption = (input) => hasProperty(input, TypeId);
var isNone = (fa) => fa._tag === "None";
var isSome = (fa) => fa._tag === "Some";
var none = /* @__PURE__ */ Object.create(NoneProto);
var some2 = (value) => {
  const a232 = Object.create(SomeProto);
  a232.value = value;
  return a232;
};
var TypeId2 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto2 = {
  ...EffectPrototype,
  [TypeId2]: {
    _R: (_232) => _232
  },
  [NodeInspectSymbol]() {
    return this.toJSON();
  },
  toString() {
    return format(this.toJSON());
  }
};
var RightProto = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto2), {
  _tag: "Right",
  _op: "Right",
  [symbol2](that) {
    return isEither(that) && isRight(that) && equals(this.right, that.right);
  },
  [symbol]() {
    return combine(hash(this._tag))(hash(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON(this.right)
    };
  }
});
var LeftProto = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto2), {
  _tag: "Left",
  _op: "Left",
  [symbol2](that) {
    return isEither(that) && isLeft(that) && equals(this.left, that.left);
  },
  [symbol]() {
    return combine(hash(this._tag))(hash(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON(this.left)
    };
  }
});
var isEither = (input) => hasProperty(input, TypeId2);
var isLeft = (ma) => ma._tag === "Left";
var isRight = (ma) => ma._tag === "Right";
var left = (left3232) => {
  const a232 = Object.create(LeftProto);
  a232.left = left3232;
  return a232;
};
var right = (right3232) => {
  const a232 = Object.create(RightProto);
  a232.right = right3232;
  return a232;
};
var getLeft = (self2) => isRight(self2) ? none : some2(self2.left);
var getRight = (self2) => isLeft(self2) ? none : some2(self2.right);
var right2 = right;
var left2 = left;
var Option_exports = {};
__export222(Option_exports, {
  Do: () => Do,
  TypeId: () => TypeId3,
  all: () => all2,
  andThen: () => andThen,
  ap: () => ap,
  as: () => as,
  asVoid: () => asVoid,
  bind: () => bind2,
  bindTo: () => bindTo2,
  composeK: () => composeK,
  contains: () => contains,
  containsWith: () => containsWith,
  exists: () => exists,
  filter: () => filter,
  filterMap: () => filterMap,
  firstSomeOf: () => firstSomeOf,
  flatMap: () => flatMap,
  flatMapNullable: () => flatMapNullable,
  flatten: () => flatten,
  fromIterable: () => fromIterable,
  fromNullable: () => fromNullable,
  gen: () => gen,
  getEquivalence: () => getEquivalence,
  getLeft: () => getLeft2,
  getOrElse: () => getOrElse,
  getOrNull: () => getOrNull,
  getOrThrow: () => getOrThrow,
  getOrThrowWith: () => getOrThrowWith,
  getOrUndefined: () => getOrUndefined,
  getOrder: () => getOrder,
  getRight: () => getRight2,
  isNone: () => isNone2,
  isOption: () => isOption2,
  isSome: () => isSome2,
  let: () => let_2,
  lift2: () => lift2,
  liftNullable: () => liftNullable,
  liftPredicate: () => liftPredicate,
  liftThrowable: () => liftThrowable,
  map: () => map,
  match: () => match2,
  none: () => none2,
  orElse: () => orElse,
  orElseEither: () => orElseEither,
  orElseSome: () => orElseSome,
  partitionMap: () => partitionMap,
  product: () => product2,
  productMany: () => productMany2,
  reduceCompact: () => reduceCompact,
  some: () => some3,
  tap: () => tap,
  toArray: () => toArray,
  toRefinement: () => toRefinement,
  void: () => void_,
  zipLeft: () => zipLeft,
  zipRight: () => zipRight,
  zipWith: () => zipWith
});
var make2 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId3 = /* @__PURE__ */ Symbol.for("effect/Option");
var none2 = () => none;
var some3 = some2;
var isOption2 = isOption;
var isNone2 = isNone;
var isSome2 = isSome;
var match2 = /* @__PURE__ */ dual(2, (self2, {
  onNone,
  onSome
}) => isNone2(self2) ? onNone() : onSome(self2.value));
var toRefinement = (f232) => (a232) => isSome2(f232(a232));
var fromIterable = (collection) => {
  for (const a232 of collection) {
    return some3(a232);
  }
  return none2();
};
var getRight2 = getRight;
var getLeft2 = getLeft;
var getOrElse = /* @__PURE__ */ dual(2, (self2, onNone) => isNone2(self2) ? onNone() : self2.value);
var orElse = /* @__PURE__ */ dual(2, (self2, that) => isNone2(self2) ? that() : self2);
var orElseSome = /* @__PURE__ */ dual(2, (self2, onNone) => isNone2(self2) ? some3(onNone()) : self2);
var orElseEither = /* @__PURE__ */ dual(2, (self2, that) => isNone2(self2) ? map(that(), right) : map(self2, left));
var firstSomeOf = (collection) => {
  let out = none2();
  for (out of collection) {
    if (isSome2(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable = (nullableValue) => nullableValue == null ? none2() : some3(nullableValue);
var liftNullable = (f232) => (...a232) => fromNullable(f232(...a232));
var getOrNull = /* @__PURE__ */ getOrElse(constNull);
var getOrUndefined = /* @__PURE__ */ getOrElse(constUndefined);
var liftThrowable = (f232) => (...a232) => {
  try {
    return some3(f232(...a232));
  } catch (e232) {
    return none2();
  }
};
var getOrThrowWith = /* @__PURE__ */ dual(2, (self2, onNone) => {
  if (isSome2(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow = /* @__PURE__ */ getOrThrowWith(() => new Error("getOrThrow called on a None"));
var map = /* @__PURE__ */ dual(2, (self2, f232) => isNone2(self2) ? none2() : some3(f232(self2.value)));
var as = /* @__PURE__ */ dual(2, (self2, b232) => map(self2, () => b232));
var asVoid = /* @__PURE__ */ as(void 0);
var void_ = /* @__PURE__ */ some3(void 0);
var flatMap = /* @__PURE__ */ dual(2, (self2, f232) => isNone2(self2) ? none2() : f232(self2.value));
var andThen = /* @__PURE__ */ dual(2, (self2, f232) => flatMap(self2, (a232) => {
  const b232 = isFunction2(f232) ? f232(a232) : f232;
  return isOption2(b232) ? b232 : some3(b232);
}));
var flatMapNullable = /* @__PURE__ */ dual(2, (self2, f232) => isNone2(self2) ? none2() : fromNullable(f232(self2.value)));
var flatten = /* @__PURE__ */ flatMap(identity);
var zipRight = /* @__PURE__ */ dual(2, (self2, that) => flatMap(self2, () => that));
var composeK = /* @__PURE__ */ dual(2, (afb, bfc) => (a232) => flatMap(afb(a232), bfc));
var zipLeft = /* @__PURE__ */ dual(2, (self2, that) => tap(self2, () => that));
var tap = /* @__PURE__ */ dual(2, (self2, f232) => flatMap(self2, (a232) => map(f232(a232), () => a232)));
var product2 = (self2, that) => isSome2(self2) && isSome2(that) ? some3([self2.value, that.value]) : none2();
var productMany2 = (self2, collection) => {
  if (isNone2(self2)) {
    return none2();
  }
  const out = [self2.value];
  for (const o232 of collection) {
    if (isNone2(o232)) {
      return none2();
    }
    out.push(o232.value);
  }
  return some3(out);
};
var all2 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o232 of input) {
      if (isNone2(o232)) {
        return none2();
      }
      out2.push(o232.value);
    }
    return some3(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o232 = input[key];
    if (isNone2(o232)) {
      return none2();
    }
    out[key] = o232.value;
  }
  return some3(out);
};
var zipWith = /* @__PURE__ */ dual(3, (self2, that, f232) => map(product2(self2, that), ([a232, b232]) => f232(a232, b232)));
var ap = /* @__PURE__ */ dual(2, (self2, that) => zipWith(self2, that, (f232, a232) => f232(a232)));
var reduceCompact = /* @__PURE__ */ dual(3, (self2, b232, f232) => {
  let out = b232;
  for (const oa of self2) {
    if (isSome2(oa)) {
      out = f232(out, oa.value);
    }
  }
  return out;
});
var toArray = (self2) => isNone2(self2) ? [] : [self2.value];
var partitionMap = /* @__PURE__ */ dual(2, (self2, f232) => {
  if (isNone2(self2)) {
    return [none2(), none2()];
  }
  const e232 = f232(self2.value);
  return isLeft(e232) ? [some3(e232.left), none2()] : [none2(), some3(e232.right)];
});
var filterMap = /* @__PURE__ */ dual(2, (self2, f232) => isNone2(self2) ? none2() : f232(self2.value));
var filter = /* @__PURE__ */ dual(2, (self2, predicate) => filterMap(self2, (b232) => predicate(b232) ? some2(b232) : none));
var getEquivalence = (isEquivalent) => make((x232, y232) => x232 === y232 || (isNone2(x232) ? isNone2(y232) : isNone2(y232) ? false : isEquivalent(x232.value, y232.value)));
var getOrder = (O232) => make2((self2, that) => isSome2(self2) ? isSome2(that) ? O232(self2.value, that.value) : 1 : -1);
var lift2 = (f232) => dual(2, (self2, that) => zipWith(self2, that, f232));
var liftPredicate = (predicate) => (b232) => predicate(b232) ? some3(b232) : none2();
var containsWith = (isEquivalent) => dual(2, (self2, a232) => isNone2(self2) ? false : isEquivalent(self2.value, a232));
var _equivalence = /* @__PURE__ */ equivalence();
var contains = /* @__PURE__ */ containsWith(_equivalence);
var exists = /* @__PURE__ */ dual(2, (self2, refinement) => isNone2(self2) ? false : refinement(self2.value));
var bindTo2 = /* @__PURE__ */ bindTo(map);
var let_2 = /* @__PURE__ */ let_(map);
var bind2 = /* @__PURE__ */ bind(map, flatMap);
var Do = /* @__PURE__ */ some3({});
var adapter2 = /* @__PURE__ */ adapter();
var gen = (f232) => {
  const iterator = f232(adapter2);
  let state = iterator.next();
  if (state.done) {
    return some3(state.value);
  } else {
    let current = state.value;
    if (isGenKind(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet(current);
    }
    if (isNone2(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet(current);
        }
        if (isNone2(current)) {
          return current;
        }
      }
    }
    return some3(state.value);
  }
};
var fromIterable2 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var reverse = (self2) => Array.from(self2).reverse();
var reduce = /* @__PURE__ */ dual(3, (self2, b232, f232) => fromIterable2(self2).reduce((b2222, a232, i232) => f232(b2222, a232, i232), b232));
var TagTypeId = /* @__PURE__ */ Symbol.for("effect/Context/Tag");
var STMSymbolKey = "effect/STM";
var STMTypeId = /* @__PURE__ */ Symbol.for(STMSymbolKey);
var TagProto = {
  ...EffectPrototype,
  _tag: "Tag",
  _op: "Tag",
  [STMTypeId]: effectVariance,
  [TagTypeId]: {
    _Service: (_232) => _232,
    _Identifier: (_232) => _232
  },
  toString() {
    return format(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Tag",
      key: this.key,
      stack: this.stack
    };
  },
  [NodeInspectSymbol]() {
    return this.toJSON();
  },
  of(self2) {
    return self2;
  },
  context(self2) {
    return make3(this, self2);
  }
};
var makeGenericTag = (key) => {
  const limit = Error.stackTraceLimit;
  Error.stackTraceLimit = 2;
  const creationError = new Error();
  Error.stackTraceLimit = limit;
  const tag = Object.create(TagProto);
  Object.defineProperty(tag, "stack", {
    get() {
      return creationError.stack;
    }
  });
  tag.key = key;
  return tag;
};
var TypeId4 = /* @__PURE__ */ Symbol.for("effect/Context");
var ContextProto = {
  [TypeId4]: {
    _Services: (_232) => _232
  },
  [symbol2](that) {
    if (isContext(that)) {
      if (this.unsafeMap.size === that.unsafeMap.size) {
        for (const k232 of this.unsafeMap.keys()) {
          if (!that.unsafeMap.has(k232) || !equals(this.unsafeMap.get(k232), that.unsafeMap.get(k232))) {
            return false;
          }
        }
        return true;
      }
    }
    return false;
  },
  [symbol]() {
    return cached(this, number(this.unsafeMap.size));
  },
  pipe() {
    return pipeArguments(this, arguments);
  },
  toString() {
    return format(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Context",
      services: Array.from(this.unsafeMap).map(toJSON)
    };
  },
  [NodeInspectSymbol]() {
    return this.toJSON();
  }
};
var makeContext = (unsafeMap) => {
  const context = Object.create(ContextProto);
  context.unsafeMap = unsafeMap;
  return context;
};
var isContext = (u232) => hasProperty(u232, TypeId4);
var _empty = /* @__PURE__ */ makeContext(/* @__PURE__ */ new Map());
var empty = () => _empty;
var make3 = (tag, service) => makeContext(/* @__PURE__ */ new Map([[tag.key, service]]));
var GenericTag = makeGenericTag;
var empty2 = empty;
var TypeId5 = /* @__PURE__ */ Symbol.for("effect/Chunk");
function copy(src, srcPos, dest, destPos, len) {
  for (let i232 = srcPos; i232 < Math.min(src.length, srcPos + len); i232++) {
    dest[destPos + i232 - srcPos] = src[i232];
  }
  return dest;
}
var emptyArray = [];
var getEquivalence2 = (isEquivalent) => make((self2, that) => self2.length === that.length && toReadonlyArray(self2).every((value, i232) => isEquivalent(value, unsafeGet2(that, i232))));
var _equivalence2 = /* @__PURE__ */ getEquivalence2(equals);
var ChunkProto = {
  [TypeId5]: {
    _A: (_232) => _232
  },
  toString() {
    return format(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Chunk",
      values: toReadonlyArray(this).map(toJSON)
    };
  },
  [NodeInspectSymbol]() {
    return this.toJSON();
  },
  [symbol2](that) {
    return isChunk(that) && _equivalence2(this, that);
  },
  [symbol]() {
    return cached(this, array(toReadonlyArray(this)));
  },
  [Symbol.iterator]() {
    switch (this.backing._tag) {
      case "IArray": {
        return this.backing.array[Symbol.iterator]();
      }
      case "IEmpty": {
        return emptyArray[Symbol.iterator]();
      }
      default: {
        return toReadonlyArray(this)[Symbol.iterator]();
      }
    }
  },
  pipe() {
    return pipeArguments(this, arguments);
  }
};
var makeChunk = (backing) => {
  const chunk = Object.create(ChunkProto);
  chunk.backing = backing;
  switch (backing._tag) {
    case "IEmpty": {
      chunk.length = 0;
      chunk.depth = 0;
      chunk.left = chunk;
      chunk.right = chunk;
      break;
    }
    case "IConcat": {
      chunk.length = backing.left.length + backing.right.length;
      chunk.depth = 1 + Math.max(backing.left.depth, backing.right.depth);
      chunk.left = backing.left;
      chunk.right = backing.right;
      break;
    }
    case "IArray": {
      chunk.length = backing.array.length;
      chunk.depth = 0;
      chunk.left = _empty2;
      chunk.right = _empty2;
      break;
    }
    case "ISingleton": {
      chunk.length = 1;
      chunk.depth = 0;
      chunk.left = _empty2;
      chunk.right = _empty2;
      break;
    }
    case "ISlice": {
      chunk.length = backing.length;
      chunk.depth = backing.chunk.depth + 1;
      chunk.left = _empty2;
      chunk.right = _empty2;
      break;
    }
  }
  return chunk;
};
var isChunk = (u232) => hasProperty(u232, TypeId5);
var _empty2 = /* @__PURE__ */ makeChunk({
  _tag: "IEmpty"
});
var empty3 = () => _empty2;
var make4 = (...as2332) => as2332.length === 1 ? of(as2332[0]) : unsafeFromNonEmptyArray(as2332);
var of = (a232) => makeChunk({
  _tag: "ISingleton",
  a: a232
});
var copyToArray = (self2, array3232, initial) => {
  switch (self2.backing._tag) {
    case "IArray": {
      copy(self2.backing.array, 0, array3232, initial, self2.length);
      break;
    }
    case "IConcat": {
      copyToArray(self2.left, array3232, initial);
      copyToArray(self2.right, array3232, initial + self2.left.length);
      break;
    }
    case "ISingleton": {
      array3232[initial] = self2.backing.a;
      break;
    }
    case "ISlice": {
      let i232 = 0;
      let j232 = initial;
      while (i232 < self2.length) {
        array3232[j232] = unsafeGet2(self2, i232);
        i232 += 1;
        j232 += 1;
      }
      break;
    }
  }
};
var toReadonlyArray = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      return emptyArray;
    }
    case "IArray": {
      return self2.backing.array;
    }
    default: {
      const arr = new Array(self2.length);
      copyToArray(self2, arr, 0);
      self2.backing = {
        _tag: "IArray",
        array: arr
      };
      self2.left = _empty2;
      self2.right = _empty2;
      self2.depth = 0;
      return arr;
    }
  }
};
var reverse2 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty":
    case "ISingleton":
      return self2;
    case "IArray": {
      return makeChunk({
        _tag: "IArray",
        array: reverse(self2.backing.array)
      });
    }
    case "IConcat": {
      return makeChunk({
        _tag: "IConcat",
        left: reverse2(self2.backing.right),
        right: reverse2(self2.backing.left)
      });
    }
    case "ISlice":
      return unsafeFromArray(reverse(toReadonlyArray(self2)));
  }
};
var unsafeFromArray = (self2) => makeChunk({
  _tag: "IArray",
  array: self2
});
var unsafeFromNonEmptyArray = (self2) => unsafeFromArray(self2);
var unsafeGet2 = /* @__PURE__ */ dual(2, (self2, index) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      throw new Error(`Index out of bounds`);
    }
    case "ISingleton": {
      if (index !== 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.a;
    }
    case "IArray": {
      if (index >= self2.length || index < 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.array[index];
    }
    case "IConcat": {
      return index < self2.left.length ? unsafeGet2(self2.left, index) : unsafeGet2(self2.right, index - self2.left.length);
    }
    case "ISlice": {
      return unsafeGet2(self2.backing.chunk, index + self2.backing.offset);
    }
  }
});
var prepend = /* @__PURE__ */ dual(2, (self2, elem) => appendAll(of(elem), self2));
var drop = /* @__PURE__ */ dual(2, (self2, n232) => {
  if (n232 <= 0) {
    return self2;
  } else if (n232 >= self2.length) {
    return _empty2;
  } else {
    switch (self2.backing._tag) {
      case "ISlice": {
        return makeChunk({
          _tag: "ISlice",
          chunk: self2.backing.chunk,
          offset: self2.backing.offset + n232,
          length: self2.backing.length - n232
        });
      }
      case "IConcat": {
        if (n232 > self2.left.length) {
          return drop(self2.right, n232 - self2.left.length);
        }
        return makeChunk({
          _tag: "IConcat",
          left: drop(self2.left, n232),
          right: self2.right
        });
      }
      default: {
        return makeChunk({
          _tag: "ISlice",
          chunk: self2,
          offset: n232,
          length: self2.length - n232
        });
      }
    }
  }
});
var appendAll = /* @__PURE__ */ dual(2, (self2, that) => {
  if (self2.backing._tag === "IEmpty") {
    return that;
  }
  if (that.backing._tag === "IEmpty") {
    return self2;
  }
  const diff2232 = that.depth - self2.depth;
  if (Math.abs(diff2232) <= 1) {
    return makeChunk({
      _tag: "IConcat",
      left: self2,
      right: that
    });
  } else if (diff2232 < -1) {
    if (self2.left.depth >= self2.right.depth) {
      const nr = appendAll(self2.right, that);
      return makeChunk({
        _tag: "IConcat",
        left: self2.left,
        right: nr
      });
    } else {
      const nrr = appendAll(self2.right.right, that);
      if (nrr.depth === self2.depth - 3) {
        const nr = makeChunk({
          _tag: "IConcat",
          left: self2.right.left,
          right: nrr
        });
        return makeChunk({
          _tag: "IConcat",
          left: self2.left,
          right: nr
        });
      } else {
        const nl = makeChunk({
          _tag: "IConcat",
          left: self2.left,
          right: self2.right.left
        });
        return makeChunk({
          _tag: "IConcat",
          left: nl,
          right: nrr
        });
      }
    }
  } else {
    if (that.right.depth >= that.left.depth) {
      const nl = appendAll(self2, that.left);
      return makeChunk({
        _tag: "IConcat",
        left: nl,
        right: that.right
      });
    } else {
      const nll = appendAll(self2, that.left.left);
      if (nll.depth === that.depth - 3) {
        const nl = makeChunk({
          _tag: "IConcat",
          left: nll,
          right: that.left.right
        });
        return makeChunk({
          _tag: "IConcat",
          left: nl,
          right: that.right
        });
      } else {
        const nr = makeChunk({
          _tag: "IConcat",
          left: that.left.right,
          right: that.right
        });
        return makeChunk({
          _tag: "IConcat",
          left: nll,
          right: nr
        });
      }
    }
  }
});
var isEmpty = (self2) => self2.length === 0;
var isNonEmpty = (self2) => self2.length > 0;
var unsafeHead = (self2) => unsafeGet2(self2, 0);
var headNonEmpty = unsafeHead;
var tailNonEmpty = (self2) => drop(self2, 1);
var SIZE = 5;
var BUCKET_SIZE = /* @__PURE__ */ Math.pow(2, SIZE);
var MASK = BUCKET_SIZE - 1;
var MAX_INDEX_NODE = BUCKET_SIZE / 2;
var MIN_ARRAY_NODE = BUCKET_SIZE / 4;
function popcount(x232) {
  x232 -= x232 >> 1 & 1431655765;
  x232 = (x232 & 858993459) + (x232 >> 2 & 858993459);
  x232 = x232 + (x232 >> 4) & 252645135;
  x232 += x232 >> 8;
  x232 += x232 >> 16;
  return x232 & 127;
}
function hashFragment(shift32, h232) {
  return h232 >>> shift32 & MASK;
}
function toBitmap(x232) {
  return 1 << x232;
}
function fromBitmap(bitmap, bit) {
  return popcount(bitmap & bit - 1);
}
var make5 = (value, previous) => ({
  value,
  previous
});
function arrayUpdate(mutate2232, at, v232, arr) {
  let out = arr;
  if (!mutate2232) {
    const len = arr.length;
    out = new Array(len);
    for (let i232 = 0; i232 < len; ++i232) out[i232] = arr[i232];
  }
  out[at] = v232;
  return out;
}
function arraySpliceOut(mutate2232, at, arr) {
  const newLen = arr.length - 1;
  let i232 = 0;
  let g232 = 0;
  let out = arr;
  if (mutate2232) {
    i232 = g232 = at;
  } else {
    out = new Array(newLen);
    while (i232 < at) out[g232++] = arr[i232++];
  }
  ++i232;
  while (i232 <= newLen) out[g232++] = arr[i232++];
  if (mutate2232) {
    out.length = newLen;
  }
  return out;
}
function arraySpliceIn(mutate2232, at, v232, arr) {
  const len = arr.length;
  if (mutate2232) {
    let i2222 = len;
    while (i2222 >= at) arr[i2222--] = arr[i2222];
    arr[at] = v232;
    return arr;
  }
  let i232 = 0, g232 = 0;
  const out = new Array(len + 1);
  while (i232 < at) out[g232++] = arr[i232++];
  out[at] = v232;
  while (i232 < len) out[++g232] = arr[i232++];
  return out;
}
var EmptyNode = class _EmptyNode {
  _tag = "EmptyNode";
  modify(edit, _shift, f232, hash2332, key, size4232) {
    const v232 = f232(none2());
    if (isNone2(v232)) return new _EmptyNode();
    ++size4232.value;
    return new LeafNode(edit, hash2332, key, v232);
  }
};
function isEmptyNode(a232) {
  return isTagged(a232, "EmptyNode");
}
function isLeafNode(node) {
  return isEmptyNode(node) || node._tag === "LeafNode" || node._tag === "CollisionNode";
}
function canEditNode(node, edit) {
  return isEmptyNode(node) ? false : edit === node.edit;
}
var LeafNode = class _LeafNode {
  edit;
  hash;
  key;
  value;
  _tag = "LeafNode";
  constructor(edit, hash2332, key, value) {
    this.edit = edit;
    this.hash = hash2332;
    this.key = key;
    this.value = value;
  }
  modify(edit, shift32, f232, hash2332, key, size4232) {
    if (equals(key, this.key)) {
      const v2222 = f232(this.value);
      if (v2222 === this.value) return this;
      else if (isNone2(v2222)) {
        --size4232.value;
        return new EmptyNode();
      }
      if (canEditNode(this, edit)) {
        this.value = v2222;
        return this;
      }
      return new _LeafNode(edit, hash2332, key, v2222);
    }
    const v232 = f232(none2());
    if (isNone2(v232)) return this;
    ++size4232.value;
    return mergeLeaves(edit, shift32, this.hash, this, hash2332, new _LeafNode(edit, hash2332, key, v232));
  }
};
var CollisionNode = class _CollisionNode {
  edit;
  hash;
  children;
  _tag = "CollisionNode";
  constructor(edit, hash2332, children) {
    this.edit = edit;
    this.hash = hash2332;
    this.children = children;
  }
  modify(edit, shift32, f232, hash2332, key, size4232) {
    if (hash2332 === this.hash) {
      const canEdit = canEditNode(this, edit);
      const list = this.updateCollisionList(canEdit, edit, this.hash, this.children, f232, key, size4232);
      if (list === this.children) return this;
      return list.length > 1 ? new _CollisionNode(edit, this.hash, list) : list[0];
    }
    const v232 = f232(none2());
    if (isNone2(v232)) return this;
    ++size4232.value;
    return mergeLeaves(edit, shift32, this.hash, this, hash2332, new LeafNode(edit, hash2332, key, v232));
  }
  updateCollisionList(mutate2232, edit, hash2332, list, f232, key, size4232) {
    const len = list.length;
    for (let i232 = 0; i232 < len; ++i232) {
      const child = list[i232];
      if ("key" in child && equals(key, child.key)) {
        const value = child.value;
        const newValue2 = f232(value);
        if (newValue2 === value) return list;
        if (isNone2(newValue2)) {
          --size4232.value;
          return arraySpliceOut(mutate2232, i232, list);
        }
        return arrayUpdate(mutate2232, i232, new LeafNode(edit, hash2332, key, newValue2), list);
      }
    }
    const newValue = f232(none2());
    if (isNone2(newValue)) return list;
    ++size4232.value;
    return arrayUpdate(mutate2232, len, new LeafNode(edit, hash2332, key, newValue), list);
  }
};
var IndexedNode = class _IndexedNode {
  edit;
  mask;
  children;
  _tag = "IndexedNode";
  constructor(edit, mask, children) {
    this.edit = edit;
    this.mask = mask;
    this.children = children;
  }
  modify(edit, shift32, f232, hash2332, key, size4232) {
    const mask = this.mask;
    const children = this.children;
    const frag = hashFragment(shift32, hash2332);
    const bit = toBitmap(frag);
    const indx = fromBitmap(mask, bit);
    const exists2332 = mask & bit;
    const canEdit = canEditNode(this, edit);
    if (!exists2332) {
      const _newChild = new EmptyNode().modify(edit, shift32 + SIZE, f232, hash2332, key, size4232);
      if (!_newChild) return this;
      return children.length >= MAX_INDEX_NODE ? expand(edit, frag, _newChild, mask, children) : new _IndexedNode(edit, mask | bit, arraySpliceIn(canEdit, indx, _newChild, children));
    }
    const current = children[indx];
    const child = current.modify(edit, shift32 + SIZE, f232, hash2332, key, size4232);
    if (current === child) return this;
    let bitmap = mask;
    let newChildren;
    if (isEmptyNode(child)) {
      bitmap &= ~bit;
      if (!bitmap) return new EmptyNode();
      if (children.length <= 2 && isLeafNode(children[indx ^ 1])) {
        return children[indx ^ 1];
      }
      newChildren = arraySpliceOut(canEdit, indx, children);
    } else {
      newChildren = arrayUpdate(canEdit, indx, child, children);
    }
    if (canEdit) {
      this.mask = bitmap;
      this.children = newChildren;
      return this;
    }
    return new _IndexedNode(edit, bitmap, newChildren);
  }
};
var ArrayNode = class _ArrayNode {
  edit;
  size;
  children;
  _tag = "ArrayNode";
  constructor(edit, size4232, children) {
    this.edit = edit;
    this.size = size4232;
    this.children = children;
  }
  modify(edit, shift32, f232, hash2332, key, size4232) {
    let count = this.size;
    const children = this.children;
    const frag = hashFragment(shift32, hash2332);
    const child = children[frag];
    const newChild = (child || new EmptyNode()).modify(edit, shift32 + SIZE, f232, hash2332, key, size4232);
    if (child === newChild) return this;
    const canEdit = canEditNode(this, edit);
    let newChildren;
    if (isEmptyNode(child) && !isEmptyNode(newChild)) {
      ++count;
      newChildren = arrayUpdate(canEdit, frag, newChild, children);
    } else if (!isEmptyNode(child) && isEmptyNode(newChild)) {
      --count;
      if (count <= MIN_ARRAY_NODE) {
        return pack(edit, count, frag, children);
      }
      newChildren = arrayUpdate(canEdit, frag, new EmptyNode(), children);
    } else {
      newChildren = arrayUpdate(canEdit, frag, newChild, children);
    }
    if (canEdit) {
      this.size = count;
      this.children = newChildren;
      return this;
    }
    return new _ArrayNode(edit, count, newChildren);
  }
};
function pack(edit, count, removed, elements) {
  const children = new Array(count - 1);
  let g232 = 0;
  let bitmap = 0;
  for (let i232 = 0, len = elements.length; i232 < len; ++i232) {
    if (i232 !== removed) {
      const elem = elements[i232];
      if (elem && !isEmptyNode(elem)) {
        children[g232++] = elem;
        bitmap |= 1 << i232;
      }
    }
  }
  return new IndexedNode(edit, bitmap, children);
}
function expand(edit, frag, child, bitmap, subNodes) {
  const arr = [];
  let bit = bitmap;
  let count = 0;
  for (let i232 = 0; bit; ++i232) {
    if (bit & 1) arr[i232] = subNodes[count++];
    bit >>>= 1;
  }
  arr[frag] = child;
  return new ArrayNode(edit, count + 1, arr);
}
function mergeLeavesInner(edit, shift32, h1, n1, h232, n232) {
  if (h1 === h232) return new CollisionNode(edit, h1, [n232, n1]);
  const subH1 = hashFragment(shift32, h1);
  const subH2 = hashFragment(shift32, h232);
  if (subH1 === subH2) {
    return (child) => new IndexedNode(edit, toBitmap(subH1) | toBitmap(subH2), [child]);
  } else {
    const children = subH1 < subH2 ? [n1, n232] : [n232, n1];
    return new IndexedNode(edit, toBitmap(subH1) | toBitmap(subH2), children);
  }
}
function mergeLeaves(edit, shift32, h1, n1, h232, n232) {
  let stack = void 0;
  let currentShift = shift32;
  while (true) {
    const res = mergeLeavesInner(edit, currentShift, h1, n1, h232, n232);
    if (typeof res === "function") {
      stack = make5(res, stack);
      currentShift = currentShift + SIZE;
    } else {
      let final = res;
      while (stack != null) {
        final = stack.value(final);
        stack = stack.previous;
      }
      return final;
    }
  }
}
var HashMapSymbolKey = "effect/HashMap";
var HashMapTypeId = /* @__PURE__ */ Symbol.for(HashMapSymbolKey);
var HashMapProto = {
  [HashMapTypeId]: HashMapTypeId,
  [Symbol.iterator]() {
    return new HashMapIterator(this, (k232, v232) => [k232, v232]);
  },
  [symbol]() {
    let hash2332 = hash(HashMapSymbolKey);
    for (const item of this) {
      hash2332 ^= pipe(hash(item[0]), combine(hash(item[1])));
    }
    return cached(this, hash2332);
  },
  [symbol2](that) {
    if (isHashMap(that)) {
      if (that._size !== this._size) {
        return false;
      }
      for (const item of this) {
        const elem = pipe(that, getHash(item[0], hash(item[0])));
        if (isNone2(elem)) {
          return false;
        } else {
          if (!equals(item[1], elem.value)) {
            return false;
          }
        }
      }
      return true;
    }
    return false;
  },
  toString() {
    return format(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashMap",
      values: Array.from(this).map(toJSON)
    };
  },
  [NodeInspectSymbol]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments(this, arguments);
  }
};
var makeImpl = (editable, edit, root, size4232) => {
  const map632 = Object.create(HashMapProto);
  map632._editable = editable;
  map632._edit = edit;
  map632._root = root;
  map632._size = size4232;
  return map632;
};
var HashMapIterator = class _HashMapIterator {
  map;
  f;
  v;
  constructor(map632, f232) {
    this.map = map632;
    this.f = f232;
    this.v = visitLazy(this.map._root, this.f, void 0);
  }
  next() {
    if (isNone2(this.v)) {
      return {
        done: true,
        value: void 0
      };
    }
    const v0 = this.v.value;
    this.v = applyCont(v0.cont);
    return {
      done: false,
      value: v0.value
    };
  }
  [Symbol.iterator]() {
    return new _HashMapIterator(this.map, this.f);
  }
};
var applyCont = (cont) => cont ? visitLazyChildren(cont[0], cont[1], cont[2], cont[3], cont[4]) : none2();
var visitLazy = (node, f232, cont = void 0) => {
  switch (node._tag) {
    case "LeafNode": {
      if (isSome2(node.value)) {
        return some3({
          value: f232(node.key, node.value.value),
          cont
        });
      }
      return applyCont(cont);
    }
    case "CollisionNode":
    case "ArrayNode":
    case "IndexedNode": {
      const children = node.children;
      return visitLazyChildren(children.length, children, 0, f232, cont);
    }
    default: {
      return applyCont(cont);
    }
  }
};
var visitLazyChildren = (len, children, i232, f232, cont) => {
  while (i232 < len) {
    const child = children[i232++];
    if (child && !isEmptyNode(child)) {
      return visitLazy(child, f232, [len, children, i232, f232, cont]);
    }
  }
  return applyCont(cont);
};
var _empty3 = /* @__PURE__ */ makeImpl(false, 0, /* @__PURE__ */ new EmptyNode(), 0);
var empty4 = () => _empty3;
var isHashMap = (u232) => hasProperty(u232, HashMapTypeId);
var getHash = /* @__PURE__ */ dual(3, (self2, key, hash2332) => {
  let node = self2._root;
  let shift32 = 0;
  while (true) {
    switch (node._tag) {
      case "LeafNode": {
        return equals(key, node.key) ? node.value : none2();
      }
      case "CollisionNode": {
        if (hash2332 === node.hash) {
          const children = node.children;
          for (let i232 = 0, len = children.length; i232 < len; ++i232) {
            const child = children[i232];
            if ("key" in child && equals(key, child.key)) {
              return child.value;
            }
          }
        }
        return none2();
      }
      case "IndexedNode": {
        const frag = hashFragment(shift32, hash2332);
        const bit = toBitmap(frag);
        if (node.mask & bit) {
          node = node.children[fromBitmap(node.mask, bit)];
          shift32 += SIZE;
          break;
        }
        return none2();
      }
      case "ArrayNode": {
        node = node.children[hashFragment(shift32, hash2332)];
        if (node) {
          shift32 += SIZE;
          break;
        }
        return none2();
      }
      default:
        return none2();
    }
  }
});
var set = /* @__PURE__ */ dual(3, (self2, key, value) => modifyAt(self2, key, () => some3(value)));
var setTree = /* @__PURE__ */ dual(3, (self2, newRoot, newSize) => {
  if (self2._editable) {
    self2._root = newRoot;
    self2._size = newSize;
    return self2;
  }
  return newRoot === self2._root ? self2 : makeImpl(self2._editable, self2._edit, newRoot, newSize);
});
var keys = (self2) => new HashMapIterator(self2, (key) => key);
var size = (self2) => self2._size;
var beginMutation = (self2) => makeImpl(true, self2._edit + 1, self2._root, self2._size);
var modifyAt = /* @__PURE__ */ dual(3, (self2, key, f232) => modifyHash(self2, key, hash(key), f232));
var modifyHash = /* @__PURE__ */ dual(4, (self2, key, hash2332, f232) => {
  const size4232 = {
    value: self2._size
  };
  const newRoot = self2._root.modify(self2._editable ? self2._edit : NaN, 0, f232, hash2332, key, size4232);
  return pipe(self2, setTree(newRoot, size4232.value));
});
var forEach = /* @__PURE__ */ dual(2, (self2, f232) => reduce2(self2, void 0, (_232, value, key) => f232(value, key)));
var reduce2 = /* @__PURE__ */ dual(3, (self2, zero, f232) => {
  const root = self2._root;
  if (root._tag === "LeafNode") {
    return isSome2(root.value) ? f232(zero, root.value.value, root.key) : zero;
  }
  if (root._tag === "EmptyNode") {
    return zero;
  }
  const toVisit = [root.children];
  let children;
  while (children = toVisit.pop()) {
    for (let i232 = 0, len = children.length; i232 < len; ) {
      const child = children[i232++];
      if (child && !isEmptyNode(child)) {
        if (child._tag === "LeafNode") {
          if (isSome2(child.value)) {
            zero = f232(zero, child.value.value, child.key);
          }
        } else {
          toVisit.push(child.children);
        }
      }
    }
  }
  return zero;
});
var HashSetSymbolKey = "effect/HashSet";
var HashSetTypeId = /* @__PURE__ */ Symbol.for(HashSetSymbolKey);
var HashSetProto = {
  [HashSetTypeId]: HashSetTypeId,
  [Symbol.iterator]() {
    return keys(this._keyMap);
  },
  [symbol]() {
    return cached(this, combine(hash(this._keyMap))(hash(HashSetSymbolKey)));
  },
  [symbol2](that) {
    if (isHashSet(that)) {
      return size(this._keyMap) === size(that._keyMap) && equals(this._keyMap, that._keyMap);
    }
    return false;
  },
  toString() {
    return format(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashSet",
      values: Array.from(this).map(toJSON)
    };
  },
  [NodeInspectSymbol]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments(this, arguments);
  }
};
var makeImpl2 = (keyMap) => {
  const set2332 = Object.create(HashSetProto);
  set2332._keyMap = keyMap;
  return set2332;
};
var isHashSet = (u232) => hasProperty(u232, HashSetTypeId);
var _empty4 = /* @__PURE__ */ makeImpl2(/* @__PURE__ */ empty4());
var empty5 = () => _empty4;
var size2 = (self2) => size(self2._keyMap);
var beginMutation2 = (self2) => makeImpl2(beginMutation(self2._keyMap));
var endMutation = (self2) => {
  self2._keyMap._editable = false;
  return self2;
};
var mutate = /* @__PURE__ */ dual(2, (self2, f232) => {
  const transient = beginMutation2(self2);
  f232(transient);
  return endMutation(transient);
});
var add2 = /* @__PURE__ */ dual(2, (self2, value) => self2._keyMap._editable ? (set(value, true)(self2._keyMap), self2) : makeImpl2(set(value, true)(self2._keyMap)));
var union2 = /* @__PURE__ */ dual(2, (self2, that) => mutate(empty5(), (set2332) => {
  forEach2(self2, (value) => add2(set2332, value));
  for (const value of that) {
    add2(set2332, value);
  }
}));
var forEach2 = /* @__PURE__ */ dual(2, (self2, f232) => forEach(self2._keyMap, (_232, k232) => f232(k232)));
var empty6 = empty5;
var size3 = size2;
var add3 = add2;
var union3 = union2;
var ArrayProto = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(Array.prototype), {
  [symbol]() {
    return cached(this, array(this));
  },
  [symbol2](that) {
    if (Array.isArray(that) && this.length === that.length) {
      return this.every((v232, i232) => equals(v232, that[i232]));
    } else {
      return false;
    }
  }
});
var Structural = /* @__PURE__ */ function() {
  function Structural3232(args) {
    if (args) {
      Object.assign(this, args);
    }
  }
  Structural3232.prototype = StructuralPrototype;
  return Structural3232;
}();
var struct2 = (as2332) => Object.assign(Object.create(StructuralPrototype), as2332);
var ContextPatchTypeId = /* @__PURE__ */ Symbol.for("effect/DifferContextPatch");
function variance(a232) {
  return a232;
}
var PatchProto = {
  ...Structural.prototype,
  [ContextPatchTypeId]: {
    _Value: variance,
    _Patch: variance
  }
};
var EmptyProto = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto), {
  _tag: "Empty"
});
var _empty5 = /* @__PURE__ */ Object.create(EmptyProto);
var empty7 = () => _empty5;
var AndThenProto = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto), {
  _tag: "AndThen"
});
var makeAndThen = (first, second) => {
  const o232 = Object.create(AndThenProto);
  o232.first = first;
  o232.second = second;
  return o232;
};
var AddServiceProto = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto), {
  _tag: "AddService"
});
var makeAddService = (key, service) => {
  const o232 = Object.create(AddServiceProto);
  o232.key = key;
  o232.service = service;
  return o232;
};
var RemoveServiceProto = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto), {
  _tag: "RemoveService"
});
var makeRemoveService = (key) => {
  const o232 = Object.create(RemoveServiceProto);
  o232.key = key;
  return o232;
};
var UpdateServiceProto = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto), {
  _tag: "UpdateService"
});
var makeUpdateService = (key, update232) => {
  const o232 = Object.create(UpdateServiceProto);
  o232.key = key;
  o232.update = update232;
  return o232;
};
var diff = (oldValue, newValue) => {
  const missingServices = new Map(oldValue.unsafeMap);
  let patch2232 = empty7();
  for (const [tag, newService] of newValue.unsafeMap.entries()) {
    if (missingServices.has(tag)) {
      const old = missingServices.get(tag);
      missingServices.delete(tag);
      if (!equals(old, newService)) {
        patch2232 = combine2(makeUpdateService(tag, () => newService))(patch2232);
      }
    } else {
      missingServices.delete(tag);
      patch2232 = combine2(makeAddService(tag, newService))(patch2232);
    }
  }
  for (const [tag] of missingServices.entries()) {
    patch2232 = combine2(makeRemoveService(tag))(patch2232);
  }
  return patch2232;
};
var combine2 = /* @__PURE__ */ dual(2, (self2, that) => makeAndThen(self2, that));
var patch = /* @__PURE__ */ dual(2, (self2, context) => {
  if (self2._tag === "Empty") {
    return context;
  }
  let wasServiceUpdated = false;
  let patches = of(self2);
  const updatedContext = new Map(context.unsafeMap);
  while (isNonEmpty(patches)) {
    const head232 = headNonEmpty(patches);
    const tail232 = tailNonEmpty(patches);
    switch (head232._tag) {
      case "Empty": {
        patches = tail232;
        break;
      }
      case "AddService": {
        updatedContext.set(head232.key, head232.service);
        patches = tail232;
        break;
      }
      case "AndThen": {
        patches = prepend(prepend(tail232, head232.second), head232.first);
        break;
      }
      case "RemoveService": {
        updatedContext.delete(head232.key);
        patches = tail232;
        break;
      }
      case "UpdateService": {
        updatedContext.set(head232.key, head232.update(updatedContext.get(head232.key)));
        wasServiceUpdated = true;
        patches = tail232;
        break;
      }
    }
  }
  if (!wasServiceUpdated) {
    return makeContext(updatedContext);
  }
  const map632 = /* @__PURE__ */ new Map();
  for (const [tag] of context.unsafeMap) {
    if (updatedContext.has(tag)) {
      map632.set(tag, updatedContext.get(tag));
      updatedContext.delete(tag);
    }
  }
  for (const [tag, s232] of updatedContext) {
    map632.set(tag, s232);
  }
  return makeContext(map632);
});
var DifferTypeId = /* @__PURE__ */ Symbol.for("effect/Differ");
var DifferProto = {
  [DifferTypeId]: {
    _P: identity,
    _V: identity
  }
};
var make7 = (params) => {
  const differ = Object.create(DifferProto);
  differ.empty = params.empty;
  differ.diff = params.diff;
  differ.combine = params.combine;
  differ.patch = params.patch;
  return differ;
};
var environment = () => make7({
  empty: empty7(),
  combine: (first, second) => combine2(second)(first),
  diff: (oldValue, newValue) => diff(oldValue, newValue),
  patch: (patch2232, oldValue) => patch(oldValue)(patch2232)
});
var OP_DIE = "Die";
var OP_EMPTY = "Empty";
var OP_FAIL = "Fail";
var OP_INTERRUPT = "Interrupt";
var OP_PARALLEL = "Parallel";
var OP_SEQUENTIAL = "Sequential";
var CauseSymbolKey = "effect/Cause";
var CauseTypeId = /* @__PURE__ */ Symbol.for(CauseSymbolKey);
var variance2 = {
  /* c8 ignore next */
  _E: (_232) => _232
};
var proto = {
  [CauseTypeId]: variance2,
  [symbol]() {
    return pipe(hash(CauseSymbolKey), combine(hash(flattenCause(this))), cached(this));
  },
  [symbol2](that) {
    return isCause(that) && causeEquals(this, that);
  },
  pipe() {
    return pipeArguments(this, arguments);
  },
  toJSON() {
    switch (this._tag) {
      case "Empty":
        return {
          _id: "Cause",
          _tag: this._tag
        };
      case "Die":
        return {
          _id: "Cause",
          _tag: this._tag,
          defect: toJSON(this.defect)
        };
      case "Interrupt":
        return {
          _id: "Cause",
          _tag: this._tag,
          fiberId: this.fiberId.toJSON()
        };
      case "Fail":
        return {
          _id: "Cause",
          _tag: this._tag,
          failure: toJSON(this.error)
        };
      case "Sequential":
      case "Parallel":
        return {
          _id: "Cause",
          _tag: this._tag,
          left: toJSON(this.left),
          right: toJSON(this.right)
        };
    }
  },
  toString() {
    return pretty(this);
  },
  [NodeInspectSymbol]() {
    return this.toJSON();
  }
};
var fail = (error) => {
  const o232 = Object.create(proto);
  o232._tag = OP_FAIL;
  o232.error = error;
  return o232;
};
var parallel = (left3232, right3232) => {
  const o232 = Object.create(proto);
  o232._tag = OP_PARALLEL;
  o232.left = left3232;
  o232.right = right3232;
  return o232;
};
var sequential = (left3232, right3232) => {
  const o232 = Object.create(proto);
  o232._tag = OP_SEQUENTIAL;
  o232.left = left3232;
  o232.right = right3232;
  return o232;
};
var isCause = (u232) => hasProperty(u232, CauseTypeId);
var isInterruptedOnly = (self2) => reduceWithContext(void 0, IsInterruptedOnlyCauseReducer)(self2);
var causeEquals = (left3232, right3232) => {
  let leftStack = of(left3232);
  let rightStack = of(right3232);
  while (isNonEmpty(leftStack) && isNonEmpty(rightStack)) {
    const [leftParallel, leftSequential] = pipe(headNonEmpty(leftStack), reduce4([empty6(), empty3()], ([parallel2232, sequential2232], cause) => {
      const [par, seq] = evaluateCause(cause);
      return some3([pipe(parallel2232, union3(par)), pipe(sequential2232, appendAll(seq))]);
    }));
    const [rightParallel, rightSequential] = pipe(headNonEmpty(rightStack), reduce4([empty6(), empty3()], ([parallel2232, sequential2232], cause) => {
      const [par, seq] = evaluateCause(cause);
      return some3([pipe(parallel2232, union3(par)), pipe(sequential2232, appendAll(seq))]);
    }));
    if (!equals(leftParallel, rightParallel)) {
      return false;
    }
    leftStack = leftSequential;
    rightStack = rightSequential;
  }
  return true;
};
var flattenCause = (cause) => {
  return flattenCauseLoop(of(cause), empty3());
};
var flattenCauseLoop = (causes, flattened) => {
  while (1) {
    const [parallel2232, sequential2232] = pipe(causes, reduce([empty6(), empty3()], ([parallel332, sequential332], cause) => {
      const [par, seq] = evaluateCause(cause);
      return [pipe(parallel332, union3(par)), pipe(sequential332, appendAll(seq))];
    }));
    const updated = size3(parallel2232) > 0 ? pipe(flattened, prepend(parallel2232)) : flattened;
    if (isEmpty(sequential2232)) {
      return reverse2(updated);
    }
    causes = sequential2232;
    flattened = updated;
  }
  throw new Error(getBugErrorMessage("Cause.flattenCauseLoop"));
};
var evaluateCause = (self2) => {
  let cause = self2;
  const stack = [];
  let _parallel = empty6();
  let _sequential = empty3();
  while (cause !== void 0) {
    switch (cause._tag) {
      case OP_EMPTY: {
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_FAIL: {
        _parallel = add3(_parallel, make4(cause._tag, cause.error));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_DIE: {
        _parallel = add3(_parallel, make4(cause._tag, cause.defect));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_INTERRUPT: {
        _parallel = add3(_parallel, make4(cause._tag, cause.fiberId));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_SEQUENTIAL: {
        switch (cause.left._tag) {
          case OP_EMPTY: {
            cause = cause.right;
            break;
          }
          case OP_SEQUENTIAL: {
            cause = sequential(cause.left.left, sequential(cause.left.right, cause.right));
            break;
          }
          case OP_PARALLEL: {
            cause = parallel(sequential(cause.left.left, cause.right), sequential(cause.left.right, cause.right));
            break;
          }
          default: {
            _sequential = prepend(_sequential, cause.right);
            cause = cause.left;
            break;
          }
        }
        break;
      }
      case OP_PARALLEL: {
        stack.push(cause.right);
        cause = cause.left;
        break;
      }
    }
  }
  throw new Error(getBugErrorMessage("Cause.evaluateCauseLoop"));
};
var IsInterruptedOnlyCauseReducer = {
  emptyCase: constTrue,
  failCase: constFalse,
  dieCase: constFalse,
  interruptCase: constTrue,
  sequentialCase: (_232, left3232, right3232) => left3232 && right3232,
  parallelCase: (_232, left3232, right3232) => left3232 && right3232
};
var OP_SEQUENTIAL_CASE = "SequentialCase";
var OP_PARALLEL_CASE = "ParallelCase";
var reduce4 = /* @__PURE__ */ dual(3, (self2, zero, pf) => {
  let accumulator = zero;
  let cause = self2;
  const causes = [];
  while (cause !== void 0) {
    const option = pf(accumulator, cause);
    accumulator = isSome2(option) ? option.value : accumulator;
    switch (cause._tag) {
      case OP_SEQUENTIAL: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      case OP_PARALLEL: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      default: {
        cause = void 0;
        break;
      }
    }
    if (cause === void 0 && causes.length > 0) {
      cause = causes.pop();
    }
  }
  return accumulator;
});
var reduceWithContext = /* @__PURE__ */ dual(3, (self2, context, reducer) => {
  const input = [self2];
  const output = [];
  while (input.length > 0) {
    const cause = input.pop();
    switch (cause._tag) {
      case OP_EMPTY: {
        output.push(right2(reducer.emptyCase(context)));
        break;
      }
      case OP_FAIL: {
        output.push(right2(reducer.failCase(context, cause.error)));
        break;
      }
      case OP_DIE: {
        output.push(right2(reducer.dieCase(context, cause.defect)));
        break;
      }
      case OP_INTERRUPT: {
        output.push(right2(reducer.interruptCase(context, cause.fiberId)));
        break;
      }
      case OP_SEQUENTIAL: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left2({
          _tag: OP_SEQUENTIAL_CASE
        }));
        break;
      }
      case OP_PARALLEL: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left2({
          _tag: OP_PARALLEL_CASE
        }));
        break;
      }
    }
  }
  const accumulator = [];
  while (output.length > 0) {
    const either = output.pop();
    switch (either._tag) {
      case "Left": {
        switch (either.left._tag) {
          case OP_SEQUENTIAL_CASE: {
            const left3232 = accumulator.pop();
            const right3232 = accumulator.pop();
            const value = reducer.sequentialCase(context, left3232, right3232);
            accumulator.push(value);
            break;
          }
          case OP_PARALLEL_CASE: {
            const left3232 = accumulator.pop();
            const right3232 = accumulator.pop();
            const value = reducer.parallelCase(context, left3232, right3232);
            accumulator.push(value);
            break;
          }
        }
        break;
      }
      case "Right": {
        accumulator.push(either.right);
        break;
      }
    }
  }
  if (accumulator.length === 0) {
    throw new Error("BUG: Cause.reduceWithContext - please report an issue at https://github.com/Effect-TS/effect/issues");
  }
  return accumulator.pop();
});
var pretty = (cause) => {
  if (isInterruptedOnly(cause)) {
    return "All fibers interrupted without errors.";
  }
  return prettyErrors(cause).map((e232) => e232.stack).join("\n");
};
var PrettyError = class extends globalThis.Error {
  span = void 0;
  constructor(originalError) {
    const prevLimit = Error.stackTraceLimit;
    Error.stackTraceLimit = 0;
    super(prettyErrorMessage(originalError));
    Error.stackTraceLimit = prevLimit;
    this.name = originalError instanceof Error ? originalError.name : "Error";
    if (typeof originalError === "object" && originalError !== null) {
      if (spanSymbol in originalError) {
        this.span = originalError[spanSymbol];
      }
      Object.keys(originalError).forEach((key) => {
        if (!(key in this)) {
          this[key] = originalError[key];
        }
      });
    }
    this.stack = prettyErrorStack(this.message, originalError instanceof Error && originalError.stack ? originalError.stack : "", this.span);
  }
  toJSON() {
    const out = {
      message: this.message,
      stack: this.stack
    };
    if (this.span) {
      out.span = this.span;
    }
    return out;
  }
};
var prettyErrorMessage = (u232) => {
  if (typeof u232 === "string") {
    return `Error: ${u232}`;
  }
  try {
    if (hasProperty(u232, "toString") && isFunction3(u232["toString"]) && u232["toString"] !== Object.prototype.toString && u232["toString"] !== globalThis.Array.prototype.toString) {
      return u232["toString"]();
    }
  } catch {
  }
  return `Error: ${JSON.stringify(u232)}`;
};
var locationRegex = /\((.*)\)/;
var spanToTrace = /* @__PURE__ */ globalValue("effect/Tracer/spanToTrace", () => /* @__PURE__ */ new WeakMap());
var prettyErrorStack = (message, stack, span222) => {
  const out = [message];
  const lines = stack.split("\n");
  for (let i232 = 1; i232 < lines.length; i232++) {
    if (lines[i232].includes("Generator.next")) {
      break;
    }
    if (lines[i232].includes("effect_internal_function")) {
      out.pop();
      break;
    }
    out.push(lines[i232].replace(/at .*effect_instruction_i.*\((.*)\)/, "at $1").replace(/EffectPrimitive\.\w+/, "<anonymous>"));
  }
  if (span222) {
    let current = span222;
    let i232 = 0;
    while (current && current._tag === "Span" && i232 < 10) {
      const stackFn = spanToTrace.get(current);
      if (typeof stackFn === "function") {
        const stack2 = stackFn();
        const locationMatch = stack2.match(locationRegex);
        const location = locationMatch ? locationMatch[1] : stack2.replace(/^at /, "");
        out.push(`    at ${current.name} (${location})`);
      } else {
        out.push(`    at ${current.name}`);
      }
      current = getOrUndefined(current.parent);
      i232++;
    }
  }
  return out.join("\n");
};
var spanSymbol = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var prettyErrors = (cause) => reduceWithContext(cause, void 0, {
  emptyCase: () => [],
  dieCase: (_232, unknownError) => {
    return [new PrettyError(unknownError)];
  },
  failCase: (_232, error) => {
    return [new PrettyError(error)];
  },
  interruptCase: () => [],
  parallelCase: (_232, l232, r232) => [...l232, ...r232],
  sequentialCase: (_232, l232, r232) => [...l232, ...r232]
});
var SingleShotGen2 = class _SingleShotGen2 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  next(a232) {
    return this.called ? {
      value: a232,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  return(a232) {
    return {
      value: a232,
      done: true
    };
  }
  throw(e232) {
    throw e232;
  }
  [Symbol.iterator]() {
    return new _SingleShotGen2(this.self);
  }
};
var spanTag = /* @__PURE__ */ GenericTag("effect/ParentSpan");
var EffectTypeId2 = /* @__PURE__ */ Symbol.for("effect/Effect");
var EffectPrimitive = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId2] = effectVariance;
  constructor(_op) {
    this._op = _op;
  }
  [symbol2](that) {
    return this === that;
  }
  [symbol]() {
    return cached(this, random(this));
  }
  pipe() {
    return pipeArguments(this, arguments);
  }
  toJSON() {
    return {
      _id: "Effect",
      _op: this._op,
      effect_instruction_i0: toJSON(this.effect_instruction_i0),
      effect_instruction_i1: toJSON(this.effect_instruction_i1),
      effect_instruction_i2: toJSON(this.effect_instruction_i2)
    };
  }
  toString() {
    return format(this.toJSON());
  }
  [NodeInspectSymbol]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen2(new YieldWrap(this));
  }
};
var EffectPrimitiveFailure = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId2] = effectVariance;
  constructor(_op) {
    this._op = _op;
    this._tag = _op;
  }
  [symbol2](that) {
    return exitIsExit(that) && that._op === "Failure" && // @ts-expect-error
    equals(this.effect_instruction_i0, that.effect_instruction_i0);
  }
  [symbol]() {
    return pipe(
      // @ts-expect-error
      string(this._tag),
      // @ts-expect-error
      combine(hash(this.effect_instruction_i0)),
      cached(this)
    );
  }
  get cause() {
    return this.effect_instruction_i0;
  }
  pipe() {
    return pipeArguments(this, arguments);
  }
  toJSON() {
    return {
      _id: "Exit",
      _tag: this._op,
      cause: this.cause.toJSON()
    };
  }
  toString() {
    return format(this.toJSON());
  }
  [NodeInspectSymbol]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen2(new YieldWrap(this));
  }
};
var isEffect = (u232) => hasProperty(u232, EffectTypeId2);
var withFiberRuntime = (withRuntime) => {
  const effect = new EffectPrimitive(OP_WITH_RUNTIME);
  effect.effect_instruction_i0 = withRuntime;
  return effect;
};
var spanSymbol2 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var originalSymbol = /* @__PURE__ */ Symbol.for("effect/OriginalAnnotation");
var capture = (obj, span222) => {
  if (isSome2(span222)) {
    return new Proxy(obj, {
      has(target, p232) {
        return p232 === spanSymbol2 || p232 === originalSymbol || p232 in target;
      },
      get(target, p232) {
        if (p232 === spanSymbol2) {
          return span222.value;
        }
        if (p232 === originalSymbol) {
          return obj;
        }
        return target[p232];
      }
    });
  }
  return obj;
};
var fail2 = (error) => isObject(error) && !(spanSymbol2 in error) ? withFiberRuntime((fiber) => failCause(fail(capture(error, currentSpanFromFiber(fiber))))) : failCause(fail(error));
var failCause = (cause) => {
  const effect = new EffectPrimitiveFailure(OP_FAILURE);
  effect.effect_instruction_i0 = cause;
  return effect;
};
var FiberRefSymbolKey = "effect/FiberRef";
var FiberRefTypeId = /* @__PURE__ */ Symbol.for(FiberRefSymbolKey);
var fiberRefVariance = {
  /* c8 ignore next */
  _A: (_232) => _232
};
var fiberRefUnsafeMakeContext = (initial) => {
  const differ = environment();
  return fiberRefUnsafeMakePatch(initial, {
    differ,
    fork: differ.empty
  });
};
var fiberRefUnsafeMakePatch = (initial, options) => ({
  [FiberRefTypeId]: fiberRefVariance,
  initial,
  diff: (oldValue, newValue) => options.differ.diff(oldValue, newValue),
  combine: (first, second) => options.differ.combine(first, second),
  patch: (patch2232) => (oldValue) => options.differ.patch(patch2232, oldValue),
  fork: options.fork,
  join: options.join ?? ((_232, n232) => n232),
  pipe() {
    return pipeArguments(this, arguments);
  }
});
var currentContext = /* @__PURE__ */ globalValue(/* @__PURE__ */ Symbol.for("effect/FiberRef/currentContext"), () => fiberRefUnsafeMakeContext(empty2()));
var YieldableError = /* @__PURE__ */ function() {
  class YieldableError2232 extends globalThis.Error {
    commit() {
      return fail2(this);
    }
    toString() {
      return this.message ? `${this.name}: ${this.message}` : this.name;
    }
    toJSON() {
      return {
        ...this
      };
    }
    [NodeInspectSymbol]() {
      const stack = this.stack;
      if (stack) {
        return `${this.toString()}
${stack.split("\n").slice(1).join("\n")}`;
      }
      return this.toString();
    }
  }
  Object.assign(YieldableError2232.prototype, StructuralCommitPrototype);
  return YieldableError2232;
}();
var exitIsExit = (u232) => isEffect(u232) && "_tag" in u232 && (u232._tag === "Success" || u232._tag === "Failure");
var currentSpanFromFiber = (fiber) => {
  const span222 = fiber.getFiberRef(currentContext).unsafeMap.get(spanTag.key);
  return span222 !== void 0 && span222._tag === "Span" ? some3(span222) : none2();
};
var Data_exports = {};
__export222(Data_exports, {
  Class: () => Class2,
  Error: () => Error2,
  Structural: () => Structural2,
  TaggedClass: () => TaggedClass,
  TaggedError: () => TaggedError,
  array: () => array2,
  case: () => _case,
  struct: () => struct3,
  tagged: () => tagged,
  taggedEnum: () => taggedEnum,
  tuple: () => tuple2,
  unsafeArray: () => unsafeArray,
  unsafeStruct: () => unsafeStruct
});
var struct3 = struct2;
var unsafeStruct = (as2332) => Object.setPrototypeOf(as2332, StructuralPrototype);
var tuple2 = (...as2332) => unsafeArray(as2332);
var array2 = (as2332) => unsafeArray(as2332.slice(0));
var unsafeArray = (as2332) => Object.setPrototypeOf(as2332, ArrayProto);
var _case = () => (args) => args === void 0 ? Object.create(StructuralPrototype) : struct3(args);
var tagged = (tag) => (args) => {
  const value = args === void 0 ? Object.create(StructuralPrototype) : struct3(args);
  value._tag = tag;
  return value;
};
var Class2 = Structural;
var TaggedClass = (tag) => {
  class Base extends Class2 {
    _tag = tag;
  }
  return Base;
};
var Structural2 = Structural;
var taggedEnum = () => new Proxy({}, {
  get(_target, tag, _receiver) {
    if (tag === "$is") {
      return isTagged;
    } else if (tag === "$match") {
      return taggedMatch;
    }
    return tagged(tag);
  }
});
function taggedMatch() {
  if (arguments.length === 1) {
    const cases2 = arguments[0];
    return function(value2) {
      return cases2[value2._tag](value2);
    };
  }
  const value = arguments[0];
  const cases = arguments[1];
  return cases[value._tag](value);
}
var Error2 = /* @__PURE__ */ function() {
  return class Base extends YieldableError {
    constructor(args) {
      super();
      if (args) {
        Object.assign(this, args);
      }
    }
  };
}();
var TaggedError = (tag) => {
  class Base extends Error2 {
    _tag = tag;
  }
  Base.prototype.name = tag;
  return Base;
};
var traverseUp = Function_exports.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType.Program) return Option_exports.none();
  return predicate(parent) ? Option_exports.some(parent) : traverseUp(parent, predicate);
});
var traverseUpGuard = Function_exports.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType.Program) return Option_exports.none();
  return predicate(parent) ? Option_exports.some(parent) : traverseUpGuard(parent, predicate);
});
var ESLintCommunityESLintUtils;
((ESLintCommunityESLintUtils2232) => {
  ESLintCommunityESLintUtils2232.getFunctionHeadLocation = getFunctionHeadLocation;
  ESLintCommunityESLintUtils2232.getFunctionNameWithKind = getFunctionNameWithKind;
  ESLintCommunityESLintUtils2232.getPropertyName = getPropertyName;
  ESLintCommunityESLintUtils2232.getStaticValue = getStaticValue;
  ESLintCommunityESLintUtils2232.getStringIfConstant = getStringIfConstant;
  ESLintCommunityESLintUtils2232.hasSideEffect = hasSideEffect;
  ESLintCommunityESLintUtils2232.isParenthesized = isParenthesized;
})(ESLintCommunityESLintUtils || (ESLintCommunityESLintUtils = {}));
var Construction = Data_exports.taggedEnum();
Construction.None();
a({
  type: N.union([NodeType.FunctionExpression, NodeType.ArrowFunctionExpression]),
  parent: {
    type: NodeType.Property,
    parent: {
      type: NodeType.ObjectExpression
    }
  }
});
a({
  type: N.union([NodeType.FunctionExpression, NodeType.ArrowFunctionExpression]),
  parent: {
    type: NodeType.MethodDefinition,
    parent: {
      type: NodeType.ClassBody
    }
  }
});
a({
  type: N.union([NodeType.FunctionExpression, NodeType.ArrowFunctionExpression]),
  parent: {
    type: NodeType.Property,
    parent: {
      type: NodeType.ClassBody
    }
  }
});
function isStringLiteral(node) {
  return node.type === NodeType.Literal && Predicate_exports.isString(node.value);
}
function isJSXElementOfBuiltinComponent(node) {
  return node.openingElement.name.type === NodeType.JSXIdentifier && node.openingElement.name.name.toLowerCase() === node.openingElement.name.name && /^[a-z]/u.test(node.openingElement.name.name);
}
var Function_exports2 = {};
__export22(Function_exports2, {
  SK: () => SK2,
  absurd: () => absurd2,
  apply: () => apply2,
  compose: () => compose3,
  constFalse: () => constFalse2,
  constNull: () => constNull2,
  constTrue: () => constTrue2,
  constUndefined: () => constUndefined2,
  constVoid: () => constVoid2,
  constant: () => constant2,
  dual: () => dual2,
  flip: () => flip2,
  flow: () => flow2,
  hole: () => hole2,
  identity: () => identity2,
  isFunction: () => isFunction4,
  pipe: () => pipe2,
  satisfies: () => satisfies2,
  tupled: () => tupled2,
  unsafeCoerce: () => unsafeCoerce2,
  untupled: () => untupled2
});
var isFunction4 = (input) => typeof input === "function";
var dual2 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a232, b232) {
        if (arguments.length >= 2) {
          return body(a232, b232);
        }
        return function(self2) {
          return body(self2, a232);
        };
      };
    case 3:
      return function(a232, b232, c232) {
        if (arguments.length >= 3) {
          return body(a232, b232, c232);
        }
        return function(self2) {
          return body(self2, a232, b232);
        };
      };
    case 4:
      return function(a232, b232, c232, d232) {
        if (arguments.length >= 4) {
          return body(a232, b232, c232, d232);
        }
        return function(self2) {
          return body(self2, a232, b232, c232);
        };
      };
    case 5:
      return function(a232, b232, c232, d232, e232) {
        if (arguments.length >= 5) {
          return body(a232, b232, c232, d232, e232);
        }
        return function(self2) {
          return body(self2, a232, b232, c232, d232);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply2 = (a232) => (self2) => self2(a232);
var identity2 = (a232) => a232;
var satisfies2 = () => (b232) => b232;
var unsafeCoerce2 = identity2;
var constant2 = (value) => () => value;
var constTrue2 = /* @__PURE__ */ constant2(true);
var constFalse2 = /* @__PURE__ */ constant2(false);
var constNull2 = /* @__PURE__ */ constant2(null);
var constUndefined2 = /* @__PURE__ */ constant2(void 0);
var constVoid2 = constUndefined2;
var flip2 = (f232) => (...b232) => (...a232) => f232(...a232)(...b232);
var compose3 = /* @__PURE__ */ dual2(2, (ab, bc) => (a232) => bc(ab(a232)));
var absurd2 = (_232) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled2 = (f232) => (a232) => f232(...a232);
var untupled2 = (f232) => (...a232) => f232(a232);
function pipe2(a232, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a232;
    case 2:
      return ab(a232);
    case 3:
      return bc(ab(a232));
    case 4:
      return cd(bc(ab(a232)));
    case 5:
      return de(cd(bc(ab(a232))));
    case 6:
      return ef(de(cd(bc(ab(a232)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a232))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a232)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a232))))))));
    default: {
      let ret = arguments[0];
      for (let i232 = 1; i232 < arguments.length; i232++) {
        ret = arguments[i232](ret);
      }
      return ret;
    }
  }
}
function flow2(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole2 = /* @__PURE__ */ unsafeCoerce2(absurd2);
var SK2 = (_232, b232) => b232;
var Array_exports = {};
__export22(Array_exports, {
  Do: () => Do3,
  allocate: () => allocate,
  append: () => append,
  appendAll: () => appendAll2,
  bind: () => bind5,
  bindTo: () => bindTo5,
  cartesian: () => cartesian,
  cartesianWith: () => cartesianWith,
  chop: () => chop,
  chunksOf: () => chunksOf,
  contains: () => contains3,
  containsWith: () => containsWith3,
  copy: () => copy2,
  dedupe: () => dedupe,
  dedupeAdjacent: () => dedupeAdjacent,
  dedupeAdjacentWith: () => dedupeAdjacentWith,
  dedupeWith: () => dedupeWith,
  difference: () => difference,
  differenceWith: () => differenceWith,
  drop: () => drop2,
  dropRight: () => dropRight,
  dropWhile: () => dropWhile,
  empty: () => empty9,
  every: () => every3,
  extend: () => extend,
  filter: () => filter3,
  filterMap: () => filterMap3,
  filterMapWhile: () => filterMapWhile,
  findFirst: () => findFirst2,
  findFirstIndex: () => findFirstIndex,
  findLast: () => findLast,
  findLastIndex: () => findLastIndex,
  flatMap: () => flatMap3,
  flatMapNullable: () => flatMapNullable3,
  flatten: () => flatten3,
  forEach: () => forEach3,
  fromIterable: () => fromIterable4,
  fromNullable: () => fromNullable3,
  fromOption: () => fromOption2,
  fromRecord: () => fromRecord,
  get: () => get,
  getEquivalence: () => getEquivalence4,
  getLefts: () => getLefts,
  getOrder: () => getOrder3,
  getRights: () => getRights,
  getSomes: () => getSomes,
  group: () => group,
  groupBy: () => groupBy,
  groupWith: () => groupWith,
  head: () => head,
  headNonEmpty: () => headNonEmpty2,
  init: () => init,
  initNonEmpty: () => initNonEmpty,
  insertAt: () => insertAt,
  intersection: () => intersection,
  intersectionWith: () => intersectionWith,
  intersperse: () => intersperse,
  isArray: () => isArray,
  isEmptyArray: () => isEmptyArray,
  isEmptyReadonlyArray: () => isEmptyReadonlyArray,
  isNonEmptyArray: () => isNonEmptyArray2,
  isNonEmptyReadonlyArray: () => isNonEmptyReadonlyArray,
  join: () => join2,
  last: () => last,
  lastNonEmpty: () => lastNonEmpty,
  length: () => length,
  let: () => let_5,
  liftEither: () => liftEither,
  liftNullable: () => liftNullable3,
  liftOption: () => liftOption,
  liftPredicate: () => liftPredicate3,
  make: () => make10,
  makeBy: () => makeBy,
  map: () => map3,
  mapAccum: () => mapAccum,
  match: () => match4,
  matchLeft: () => matchLeft,
  matchRight: () => matchRight,
  max: () => max2,
  min: () => min2,
  modify: () => modify,
  modifyNonEmptyHead: () => modifyNonEmptyHead,
  modifyNonEmptyLast: () => modifyNonEmptyLast,
  modifyOption: () => modifyOption,
  of: () => of2,
  partition: () => partition,
  partitionMap: () => partitionMap3,
  prepend: () => prepend2,
  prependAll: () => prependAll,
  range: () => range,
  reduce: () => reduce3,
  reduceRight: () => reduceRight,
  remove: () => remove,
  replace: () => replace2,
  replaceOption: () => replaceOption,
  replicate: () => replicate,
  reverse: () => reverse3,
  rotate: () => rotate,
  scan: () => scan,
  scanRight: () => scanRight,
  separate: () => separate,
  setNonEmptyHead: () => setNonEmptyHead,
  setNonEmptyLast: () => setNonEmptyLast,
  some: () => some7,
  sort: () => sort,
  sortBy: () => sortBy,
  sortWith: () => sortWith,
  span: () => span,
  split: () => split,
  splitAt: () => splitAt,
  splitNonEmptyAt: () => splitNonEmptyAt,
  splitWhere: () => splitWhere,
  tail: () => tail,
  tailNonEmpty: () => tailNonEmpty2,
  take: () => take,
  takeRight: () => takeRight,
  takeWhile: () => takeWhile,
  unappend: () => unappend,
  unfold: () => unfold,
  union: () => union,
  unionWith: () => unionWith,
  unprepend: () => unprepend,
  unsafeGet: () => unsafeGet,
  unzip: () => unzip,
  zip: () => zip,
  zipWith: () => zipWith3
});
var make6 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var array3 = (item) => make6((self2, that) => {
  if (self2.length !== that.length) {
    return false;
  }
  for (let i232 = 0; i232 < self2.length; i232++) {
    const isEq = item(self2[i232], that[i232]);
    if (!isEq) {
      return false;
    }
  }
  return true;
});
var let_3 = (map532) => dual2(3, (self2, name22, f232) => map532(self2, (a232) => Object.assign({}, a232, {
  [name22]: f232(a232)
})));
var bindTo3 = (map532) => dual2(2, (self2, name22) => map532(self2, (a232) => ({
  [name22]: a232
})));
var bind3 = (map532, flatMap532) => dual2(3, (self2, name22, f232) => flatMap532(self2, (a232) => map532(f232(a232), (b232) => Object.assign({}, a232, {
  [name22]: b232
}))));
var moduleVersion2 = "3.2.8";
var getCurrentVersion2 = () => moduleVersion2;
var globalStoreId2 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion2()}`);
if (!(globalStoreId2 in globalThis)) {
  globalThis[globalStoreId2] = /* @__PURE__ */ new Map();
}
var globalStore2 = globalThis[globalStoreId2];
var globalValue2 = (id, compute) => {
  if (!globalStore2.has(id)) {
    globalStore2.set(id, compute());
  }
  return globalStore2.get(id);
};
var Predicate_exports2 = {};
__export22(Predicate_exports2, {
  all: () => all3,
  and: () => and2,
  compose: () => compose4,
  eqv: () => eqv2,
  every: () => every2,
  hasProperty: () => hasProperty2,
  implies: () => implies2,
  isBigInt: () => isBigInt2,
  isBoolean: () => isBoolean2,
  isDate: () => isDate2,
  isError: () => isError2,
  isFunction: () => isFunction5,
  isIterable: () => isIterable2,
  isMap: () => isMap2,
  isNever: () => isNever2,
  isNotNull: () => isNotNull2,
  isNotNullable: () => isNotNullable2,
  isNotUndefined: () => isNotUndefined2,
  isNull: () => isNull2,
  isNullable: () => isNullable2,
  isNumber: () => isNumber2,
  isObject: () => isObject2,
  isPromise: () => isPromise2,
  isPromiseLike: () => isPromiseLike2,
  isReadonlyRecord: () => isReadonlyRecord2,
  isRecord: () => isRecord2,
  isSet: () => isSet2,
  isString: () => isString2,
  isSymbol: () => isSymbol2,
  isTagged: () => isTagged2,
  isTruthy: () => isTruthy2,
  isUint8Array: () => isUint8Array2,
  isUndefined: () => isUndefined2,
  isUnknown: () => isUnknown2,
  mapInput: () => mapInput2,
  nand: () => nand2,
  nor: () => nor2,
  not: () => not2,
  or: () => or2,
  product: () => product3,
  productMany: () => productMany3,
  some: () => some4,
  struct: () => struct4,
  tuple: () => tuple3,
  xor: () => xor2
});
var mapInput2 = /* @__PURE__ */ dual2(2, (self2, f232) => (b232) => self2(f232(b232)));
var isTruthy2 = (input) => !!input;
var isSet2 = (input) => input instanceof Set;
var isMap2 = (input) => input instanceof Map;
var isString2 = (input) => typeof input === "string";
var isNumber2 = (input) => typeof input === "number";
var isBoolean2 = (input) => typeof input === "boolean";
var isBigInt2 = (input) => typeof input === "bigint";
var isSymbol2 = (input) => typeof input === "symbol";
var isFunction5 = isFunction4;
var isUndefined2 = (input) => input === void 0;
var isNotUndefined2 = (input) => input !== void 0;
var isNull2 = (input) => input === null;
var isNotNull2 = (input) => input !== null;
var isNever2 = (_232) => false;
var isUnknown2 = (_232) => true;
var isRecordOrArray2 = (input) => typeof input === "object" && input !== null;
var isObject2 = (input) => isRecordOrArray2(input) || isFunction5(input);
var hasProperty2 = /* @__PURE__ */ dual2(2, (self2, property) => isObject2(self2) && property in self2);
var isTagged2 = /* @__PURE__ */ dual2(2, (self2, tag) => hasProperty2(self2, "_tag") && self2["_tag"] === tag);
var isNullable2 = (input) => input === null || input === void 0;
var isNotNullable2 = (input) => input !== null && input !== void 0;
var isError2 = (input) => input instanceof Error;
var isUint8Array2 = (input) => input instanceof Uint8Array;
var isDate2 = (input) => input instanceof Date;
var isIterable2 = (input) => hasProperty2(input, Symbol.iterator);
var isRecord2 = (input) => isRecordOrArray2(input) && !Array.isArray(input);
var isReadonlyRecord2 = isRecord2;
var isPromise2 = (input) => hasProperty2(input, "then") && "catch" in input && isFunction5(input.then) && isFunction5(input.catch);
var isPromiseLike2 = (input) => hasProperty2(input, "then") && isFunction5(input.then);
var compose4 = /* @__PURE__ */ dual2(2, (ab, bc) => (a232) => ab(a232) && bc(a232));
var product3 = (self2, that) => ([a232, b232]) => self2(a232) && that(b232);
var all3 = (collection) => {
  return (as432) => {
    let collectionIndex = 0;
    for (const p232 of collection) {
      if (collectionIndex >= as432.length) {
        break;
      }
      if (p232(as432[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany3 = (self2, collection) => {
  const rest = all3(collection);
  return ([head232, ...tail232]) => self2(head232) === false ? false : rest(tail232);
};
var tuple3 = (...elements) => all3(elements);
var struct4 = (fields) => {
  const keys432 = Object.keys(fields);
  return (a232) => {
    for (const key of keys432) {
      if (!fields[key](a232[key])) {
        return false;
      }
    }
    return true;
  };
};
var not2 = (self2) => (a232) => !self2(a232);
var or2 = /* @__PURE__ */ dual2(2, (self2, that) => (a232) => self2(a232) || that(a232));
var and2 = /* @__PURE__ */ dual2(2, (self2, that) => (a232) => self2(a232) && that(a232));
var xor2 = /* @__PURE__ */ dual2(2, (self2, that) => (a232) => self2(a232) !== that(a232));
var eqv2 = /* @__PURE__ */ dual2(2, (self2, that) => (a232) => self2(a232) === that(a232));
var implies2 = /* @__PURE__ */ dual2(2, (self2, that) => (a232) => self2(a232) ? that(a232) : true);
var nor2 = /* @__PURE__ */ dual2(2, (self2, that) => (a232) => !(self2(a232) || that(a232)));
var nand2 = /* @__PURE__ */ dual2(2, (self2, that) => (a232) => !(self2(a232) && that(a232)));
var every2 = (collection) => (a232) => {
  for (const p232 of collection) {
    if (!p232(a232)) {
      return false;
    }
  }
  return true;
};
var some4 = (collection) => (a232) => {
  for (const p232 of collection) {
    if (p232(a232)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage2 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId2 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind2 = (u232) => isObject2(u232) && GenKindTypeId2 in u232;
var GenKindImpl2 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity2;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId2] = GenKindTypeId2;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen3(this);
  }
};
var SingleShotGen3 = class _SingleShotGen5 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a232) {
    return this.called ? {
      value: a232,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a232) {
    return {
      value: a232,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e232) {
    throw e232;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen5(this.self);
  }
};
var adapter3 = () => function() {
  let x232 = arguments[0];
  for (let i232 = 1; i232 < arguments.length; i232++) {
    x232 = arguments[i232](x232);
  }
  return new GenKindImpl2(x232);
};
var defaultIncHi2 = 335903614;
var defaultIncLo2 = 4150755663;
var MUL_HI2 = 1481765933 >>> 0;
var MUL_LO2 = 1284865837 >>> 0;
var BIT_532 = 9007199254740992;
var BIT_272 = 134217728;
var PCGRandom2 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable2(seedLo) && isNullable2(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable2(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable2(incLo) && isNullable2(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo2;
      incHi = this._state ? this._state[2] : defaultIncHi2;
    } else if (isNullable2(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add642(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max322) {
    if (!max322) {
      return this._next();
    }
    max322 = max322 >>> 0;
    if ((max322 & max322 - 1) === 0) {
      return this._next() & max322 - 1;
    }
    let num = 0;
    const skew = (-max322 >>> 0) % max322 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max322;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_272 + lo) / BIT_532;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul642(this._state, oldHi, oldLo, MUL_HI2, MUL_LO2);
    add642(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul642(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add642(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId2 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap2 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId2]() {
    return this.#value;
  }
};
function yieldWrapGet2(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId2 in self2) {
    return self2[YieldWrapTypeId2]();
  }
  throw new Error(getBugErrorMessage2("yieldWrapGet"));
}
var structuralRegionState2 = /* @__PURE__ */ globalValue2("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache2 = /* @__PURE__ */ globalValue2(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr2 = /* @__PURE__ */ globalValue2(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom2());
var symbol3 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash2 = (self2) => {
  if (structuralRegionState2.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number2(self2);
    case "bigint":
      return string2(self2.toString(10));
    case "boolean":
      return string2(String(self2));
    case "symbol":
      return string2(String(self2));
    case "string":
      return string2(self2);
    case "undefined":
      return string2("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string2("null");
      } else if (self2 instanceof Date) {
        return hash2(self2.toISOString());
      } else if (isHash2(self2)) {
        return self2[symbol3]();
      } else {
        return random2(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random2 = (self2) => {
  if (!randomHashCache2.has(self2)) {
    randomHashCache2.set(self2, number2(pcgr2.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache2.get(self2);
};
var combine3 = (b232) => (self2) => self2 * 53 ^ b232;
var optimize2 = (n232) => n232 & 3221225471 | n232 >>> 1 & 1073741824;
var isHash2 = (u232) => hasProperty2(u232, symbol3);
var number2 = (n232) => {
  if (n232 !== n232 || n232 === Infinity) {
    return 0;
  }
  let h232 = n232 | 0;
  if (h232 !== n232) {
    h232 ^= n232 * 4294967295;
  }
  while (n232 > 4294967295) {
    h232 ^= n232 /= 4294967295;
  }
  return optimize2(n232);
};
var string2 = (str) => {
  let h232 = 5381, i232 = str.length;
  while (i232) {
    h232 = h232 * 33 ^ str.charCodeAt(--i232);
  }
  return optimize2(h232);
};
var cached2 = function() {
  if (arguments.length === 1) {
    const self3 = arguments[0];
    return function(hash532) {
      Object.defineProperty(self3, symbol3, {
        value() {
          return hash532;
        },
        enumerable: false
      });
      return hash532;
    };
  }
  const self2 = arguments[0];
  const hash432 = arguments[1];
  Object.defineProperty(self2, symbol3, {
    value() {
      return hash432;
    },
    enumerable: false
  });
  return hash432;
};
var symbol4 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals2() {
  if (arguments.length === 1) {
    return (self2) => compareBoth2(self2, arguments[0]);
  }
  return compareBoth2(arguments[0], arguments[1]);
}
function compareBoth2(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual2(self2) && isEqual2(that)) {
        if (hash2(self2) === hash2(that) && self2[symbol4](that)) {
          return true;
        } else {
          return structuralRegionState2.enabled && structuralRegionState2.tester ? structuralRegionState2.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState2.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v232, i232) => compareBoth2(v232, that[i232]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth2(self2[key], that[key]))) {
              return structuralRegionState2.tester ? structuralRegionState2.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState2.tester ? structuralRegionState2.tester(self2, that) : false;
    }
  }
  return structuralRegionState2.enabled && structuralRegionState2.tester ? structuralRegionState2.tester(self2, that) : false;
}
var isEqual2 = (u232) => hasProperty2(u232, symbol4);
var equivalence2 = () => equals2;
var NodeInspectSymbol2 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON2 = (x232) => {
  if (hasProperty2(x232, "toJSON") && isFunction5(x232["toJSON"]) && x232["toJSON"].length === 0) {
    return x232.toJSON();
  } else if (Array.isArray(x232)) {
    return x232.map(toJSON2);
  }
  return x232;
};
var format2 = (x232) => JSON.stringify(x232, null, 2);
var pipeArguments2 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i232 = 0, len = args.length; i232 < len; i232++) {
        ret = args[i232](ret);
      }
      return ret;
    }
  }
};
var EffectTypeId3 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId2 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId2 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId2 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance2 = {
  /* c8 ignore next */
  _R: (_232) => _232,
  /* c8 ignore next */
  _E: (_232) => _232,
  /* c8 ignore next */
  _A: (_232) => _232,
  _V: /* @__PURE__ */ getCurrentVersion2()
};
var sinkVariance2 = {
  /* c8 ignore next */
  _A: (_232) => _232,
  /* c8 ignore next */
  _In: (_232) => _232,
  /* c8 ignore next */
  _L: (_232) => _232,
  /* c8 ignore next */
  _E: (_232) => _232,
  /* c8 ignore next */
  _R: (_232) => _232
};
var channelVariance2 = {
  /* c8 ignore next */
  _Env: (_232) => _232,
  /* c8 ignore next */
  _InErr: (_232) => _232,
  /* c8 ignore next */
  _InElem: (_232) => _232,
  /* c8 ignore next */
  _InDone: (_232) => _232,
  /* c8 ignore next */
  _OutErr: (_232) => _232,
  /* c8 ignore next */
  _OutElem: (_232) => _232,
  /* c8 ignore next */
  _OutDone: (_232) => _232
};
var EffectPrototype2 = {
  [EffectTypeId3]: effectVariance2,
  [StreamTypeId2]: effectVariance2,
  [SinkTypeId2]: sinkVariance2,
  [ChannelTypeId2]: channelVariance2,
  [symbol4](that) {
    return this === that;
  },
  [symbol3]() {
    return cached2(this, random2(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen3(new YieldWrap2(this));
  },
  pipe() {
    return pipeArguments2(this, arguments);
  }
};
var TypeId6 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto3 = {
  ...EffectPrototype2,
  [TypeId6]: {
    _A: (_232) => _232
  },
  [NodeInspectSymbol2]() {
    return this.toJSON();
  },
  toString() {
    return format2(this.toJSON());
  }
};
var SomeProto2 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto3), {
  _tag: "Some",
  _op: "Some",
  [symbol4](that) {
    return isOption3(that) && isSome3(that) && equals2(this.value, that.value);
  },
  [symbol3]() {
    return cached2(this, combine3(hash2(this._tag))(hash2(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON2(this.value)
    };
  }
});
var NoneHash2 = /* @__PURE__ */ hash2("None");
var NoneProto2 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto3), {
  _tag: "None",
  _op: "None",
  [symbol4](that) {
    return isOption3(that) && isNone3(that);
  },
  [symbol3]() {
    return NoneHash2;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption3 = (input) => hasProperty2(input, TypeId6);
var isNone3 = (fa) => fa._tag === "None";
var isSome3 = (fa) => fa._tag === "Some";
var none3 = /* @__PURE__ */ Object.create(NoneProto2);
var some5 = (value) => {
  const a232 = Object.create(SomeProto2);
  a232.value = value;
  return a232;
};
var TypeId7 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto4 = {
  ...EffectPrototype2,
  [TypeId7]: {
    _R: (_232) => _232
  },
  [NodeInspectSymbol2]() {
    return this.toJSON();
  },
  toString() {
    return format2(this.toJSON());
  }
};
var RightProto2 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto4), {
  _tag: "Right",
  _op: "Right",
  [symbol4](that) {
    return isEither2(that) && isRight2(that) && equals2(this.right, that.right);
  },
  [symbol3]() {
    return combine3(hash2(this._tag))(hash2(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON2(this.right)
    };
  }
});
var LeftProto2 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto4), {
  _tag: "Left",
  _op: "Left",
  [symbol4](that) {
    return isEither2(that) && isLeft2(that) && equals2(this.left, that.left);
  },
  [symbol3]() {
    return combine3(hash2(this._tag))(hash2(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON2(this.left)
    };
  }
});
var isEither2 = (input) => hasProperty2(input, TypeId7);
var isLeft2 = (ma) => ma._tag === "Left";
var isRight2 = (ma) => ma._tag === "Right";
var left3 = (left532) => {
  const a232 = Object.create(LeftProto2);
  a232.left = left532;
  return a232;
};
var right3 = (right532) => {
  const a232 = Object.create(RightProto2);
  a232.right = right532;
  return a232;
};
var getLeft3 = (self2) => isRight2(self2) ? none3 : some5(self2.left);
var getRight3 = (self2) => isLeft2(self2) ? none3 : some5(self2.right);
var isLeft3 = isLeft2;
var isRight3 = isRight2;
var isNonEmptyArray = (self2) => self2.length > 0;
var Option_exports2 = {};
__export22(Option_exports2, {
  Do: () => Do2,
  TypeId: () => TypeId8,
  all: () => all4,
  andThen: () => andThen2,
  ap: () => ap2,
  as: () => as2,
  asVoid: () => asVoid2,
  bind: () => bind4,
  bindTo: () => bindTo4,
  composeK: () => composeK2,
  contains: () => contains2,
  containsWith: () => containsWith2,
  exists: () => exists2,
  filter: () => filter2,
  filterMap: () => filterMap2,
  firstSomeOf: () => firstSomeOf2,
  flatMap: () => flatMap2,
  flatMapNullable: () => flatMapNullable2,
  flatten: () => flatten2,
  fromIterable: () => fromIterable3,
  fromNullable: () => fromNullable2,
  gen: () => gen2,
  getEquivalence: () => getEquivalence3,
  getLeft: () => getLeft4,
  getOrElse: () => getOrElse2,
  getOrNull: () => getOrNull2,
  getOrThrow: () => getOrThrow2,
  getOrThrowWith: () => getOrThrowWith2,
  getOrUndefined: () => getOrUndefined2,
  getOrder: () => getOrder2,
  getRight: () => getRight4,
  isNone: () => isNone4,
  isOption: () => isOption4,
  isSome: () => isSome4,
  let: () => let_4,
  lift2: () => lift22,
  liftNullable: () => liftNullable2,
  liftPredicate: () => liftPredicate2,
  liftThrowable: () => liftThrowable2,
  map: () => map2,
  match: () => match3,
  none: () => none4,
  orElse: () => orElse2,
  orElseEither: () => orElseEither2,
  orElseSome: () => orElseSome2,
  partitionMap: () => partitionMap2,
  product: () => product4,
  productMany: () => productMany4,
  reduceCompact: () => reduceCompact2,
  some: () => some6,
  tap: () => tap2,
  toArray: () => toArray2,
  toRefinement: () => toRefinement2,
  void: () => void_2,
  zipLeft: () => zipLeft2,
  zipRight: () => zipRight2,
  zipWith: () => zipWith2
});
var make8 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var number3 = /* @__PURE__ */ make8((self2, that) => self2 < that ? -1 : 1);
var combineMany = /* @__PURE__ */ dual2(2, (self2, collection) => make8((a1, a232) => {
  let out = self2(a1, a232);
  if (out !== 0) {
    return out;
  }
  for (const O232 of collection) {
    out = O232(a1, a232);
    if (out !== 0) {
      return out;
    }
  }
  return out;
}));
var empty8 = () => make8(() => 0);
var combineAll = (collection) => combineMany(empty8(), collection);
var mapInput3 = /* @__PURE__ */ dual2(2, (self2, f232) => make8((b1, b232) => self2(f232(b1), f232(b232))));
var array4 = (O232) => make8((self2, that) => {
  const aLen = self2.length;
  const bLen = that.length;
  const len = Math.min(aLen, bLen);
  for (let i232 = 0; i232 < len; i232++) {
    const o232 = O232(self2[i232], that[i232]);
    if (o232 !== 0) {
      return o232;
    }
  }
  return number3(aLen, bLen);
});
var min = (O232) => dual2(2, (self2, that) => self2 === that || O232(self2, that) < 1 ? self2 : that);
var max = (O232) => dual2(2, (self2, that) => self2 === that || O232(self2, that) > -1 ? self2 : that);
var TypeId8 = /* @__PURE__ */ Symbol.for("effect/Option");
var none4 = () => none3;
var some6 = some5;
var isOption4 = isOption3;
var isNone4 = isNone3;
var isSome4 = isSome3;
var match3 = /* @__PURE__ */ dual2(2, (self2, {
  onNone,
  onSome
}) => isNone4(self2) ? onNone() : onSome(self2.value));
var toRefinement2 = (f232) => (a232) => isSome4(f232(a232));
var fromIterable3 = (collection) => {
  for (const a232 of collection) {
    return some6(a232);
  }
  return none4();
};
var getRight4 = getRight3;
var getLeft4 = getLeft3;
var getOrElse2 = /* @__PURE__ */ dual2(2, (self2, onNone) => isNone4(self2) ? onNone() : self2.value);
var orElse2 = /* @__PURE__ */ dual2(2, (self2, that) => isNone4(self2) ? that() : self2);
var orElseSome2 = /* @__PURE__ */ dual2(2, (self2, onNone) => isNone4(self2) ? some6(onNone()) : self2);
var orElseEither2 = /* @__PURE__ */ dual2(2, (self2, that) => isNone4(self2) ? map2(that(), right3) : map2(self2, left3));
var firstSomeOf2 = (collection) => {
  let out = none4();
  for (out of collection) {
    if (isSome4(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable2 = (nullableValue) => nullableValue == null ? none4() : some6(nullableValue);
var liftNullable2 = (f232) => (...a232) => fromNullable2(f232(...a232));
var getOrNull2 = /* @__PURE__ */ getOrElse2(constNull2);
var getOrUndefined2 = /* @__PURE__ */ getOrElse2(constUndefined2);
var liftThrowable2 = (f232) => (...a232) => {
  try {
    return some6(f232(...a232));
  } catch (e232) {
    return none4();
  }
};
var getOrThrowWith2 = /* @__PURE__ */ dual2(2, (self2, onNone) => {
  if (isSome4(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow2 = /* @__PURE__ */ getOrThrowWith2(() => new Error("getOrThrow called on a None"));
var map2 = /* @__PURE__ */ dual2(2, (self2, f232) => isNone4(self2) ? none4() : some6(f232(self2.value)));
var as2 = /* @__PURE__ */ dual2(2, (self2, b232) => map2(self2, () => b232));
var asVoid2 = /* @__PURE__ */ as2(void 0);
var void_2 = /* @__PURE__ */ some6(void 0);
var flatMap2 = /* @__PURE__ */ dual2(2, (self2, f232) => isNone4(self2) ? none4() : f232(self2.value));
var andThen2 = /* @__PURE__ */ dual2(2, (self2, f232) => flatMap2(self2, (a232) => {
  const b232 = isFunction4(f232) ? f232(a232) : f232;
  return isOption4(b232) ? b232 : some6(b232);
}));
var flatMapNullable2 = /* @__PURE__ */ dual2(2, (self2, f232) => isNone4(self2) ? none4() : fromNullable2(f232(self2.value)));
var flatten2 = /* @__PURE__ */ flatMap2(identity2);
var zipRight2 = /* @__PURE__ */ dual2(2, (self2, that) => flatMap2(self2, () => that));
var composeK2 = /* @__PURE__ */ dual2(2, (afb, bfc) => (a232) => flatMap2(afb(a232), bfc));
var zipLeft2 = /* @__PURE__ */ dual2(2, (self2, that) => tap2(self2, () => that));
var tap2 = /* @__PURE__ */ dual2(2, (self2, f232) => flatMap2(self2, (a232) => map2(f232(a232), () => a232)));
var product4 = (self2, that) => isSome4(self2) && isSome4(that) ? some6([self2.value, that.value]) : none4();
var productMany4 = (self2, collection) => {
  if (isNone4(self2)) {
    return none4();
  }
  const out = [self2.value];
  for (const o232 of collection) {
    if (isNone4(o232)) {
      return none4();
    }
    out.push(o232.value);
  }
  return some6(out);
};
var all4 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o232 of input) {
      if (isNone4(o232)) {
        return none4();
      }
      out2.push(o232.value);
    }
    return some6(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o232 = input[key];
    if (isNone4(o232)) {
      return none4();
    }
    out[key] = o232.value;
  }
  return some6(out);
};
var zipWith2 = /* @__PURE__ */ dual2(3, (self2, that, f232) => map2(product4(self2, that), ([a232, b232]) => f232(a232, b232)));
var ap2 = /* @__PURE__ */ dual2(2, (self2, that) => zipWith2(self2, that, (f232, a232) => f232(a232)));
var reduceCompact2 = /* @__PURE__ */ dual2(3, (self2, b232, f232) => {
  let out = b232;
  for (const oa of self2) {
    if (isSome4(oa)) {
      out = f232(out, oa.value);
    }
  }
  return out;
});
var toArray2 = (self2) => isNone4(self2) ? [] : [self2.value];
var partitionMap2 = /* @__PURE__ */ dual2(2, (self2, f232) => {
  if (isNone4(self2)) {
    return [none4(), none4()];
  }
  const e232 = f232(self2.value);
  return isLeft2(e232) ? [some6(e232.left), none4()] : [none4(), some6(e232.right)];
});
var filterMap2 = /* @__PURE__ */ dual2(2, (self2, f232) => isNone4(self2) ? none4() : f232(self2.value));
var filter2 = /* @__PURE__ */ dual2(2, (self2, predicate) => filterMap2(self2, (b232) => predicate(b232) ? some5(b232) : none3));
var getEquivalence3 = (isEquivalent) => make6((x232, y232) => x232 === y232 || (isNone4(x232) ? isNone4(y232) : isNone4(y232) ? false : isEquivalent(x232.value, y232.value)));
var getOrder2 = (O232) => make8((self2, that) => isSome4(self2) ? isSome4(that) ? O232(self2.value, that.value) : 1 : -1);
var lift22 = (f232) => dual2(2, (self2, that) => zipWith2(self2, that, f232));
var liftPredicate2 = (predicate) => (b232) => predicate(b232) ? some6(b232) : none4();
var containsWith2 = (isEquivalent) => dual2(2, (self2, a232) => isNone4(self2) ? false : isEquivalent(self2.value, a232));
var _equivalence3 = /* @__PURE__ */ equivalence2();
var contains2 = /* @__PURE__ */ containsWith2(_equivalence3);
var exists2 = /* @__PURE__ */ dual2(2, (self2, refinement) => isNone4(self2) ? false : refinement(self2.value));
var bindTo4 = /* @__PURE__ */ bindTo3(map2);
var let_4 = /* @__PURE__ */ let_3(map2);
var bind4 = /* @__PURE__ */ bind3(map2, flatMap2);
var Do2 = /* @__PURE__ */ some6({});
var adapter4 = /* @__PURE__ */ adapter3();
var gen2 = (f232) => {
  const iterator = f232(adapter4);
  let state = iterator.next();
  if (state.done) {
    return some6(state.value);
  } else {
    let current = state.value;
    if (isGenKind2(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet2(current);
    }
    if (isNone4(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind2(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet2(current);
        }
        if (isNone4(current)) {
          return current;
        }
      }
    }
    return some6(state.value);
  }
};
var make9 = (...elements) => elements;
var findFirst = /* @__PURE__ */ dual2(2, (self2, f232) => {
  let i232 = 0;
  for (const a232 of self2) {
    const o232 = f232(a232, i232);
    if (isBoolean2(o232)) {
      if (o232) {
        return some6(a232);
      }
    } else {
      if (isSome4(o232)) {
        return o232;
      }
    }
    i232++;
  }
  return none4();
});
var collect = /* @__PURE__ */ dual2(2, (self2, f232) => {
  const out = [];
  for (const key of keys2(self2)) {
    out.push(f232(key, self2[key]));
  }
  return out;
});
var toEntries = /* @__PURE__ */ collect((key, value) => [key, value]);
var keys2 = (self2) => Object.keys(self2);
var make10 = (...elements) => elements;
var allocate = (n232) => new Array(n232);
var makeBy = (n232, f232) => {
  const max322 = Math.max(1, Math.floor(n232));
  const out = new Array(max322);
  for (let i232 = 0; i232 < max322; i232++) {
    out[i232] = f232(i232);
  }
  return out;
};
var range = (start, end) => start <= end ? makeBy(end - start + 1, (i232) => start + i232) : [start];
var replicate = /* @__PURE__ */ dual2(2, (a232, n232) => makeBy(n232, () => a232));
var fromIterable4 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var fromRecord = toEntries;
var fromOption2 = toArray2;
var match4 = /* @__PURE__ */ dual2(2, (self2, {
  onEmpty,
  onNonEmpty
}) => isNonEmptyReadonlyArray(self2) ? onNonEmpty(self2) : onEmpty());
var matchLeft = /* @__PURE__ */ dual2(2, (self2, {
  onEmpty,
  onNonEmpty
}) => isNonEmptyReadonlyArray(self2) ? onNonEmpty(headNonEmpty2(self2), tailNonEmpty2(self2)) : onEmpty());
var matchRight = /* @__PURE__ */ dual2(2, (self2, {
  onEmpty,
  onNonEmpty
}) => isNonEmptyReadonlyArray(self2) ? onNonEmpty(initNonEmpty(self2), lastNonEmpty(self2)) : onEmpty());
var prepend2 = /* @__PURE__ */ dual2(2, (self2, head232) => [head232, ...self2]);
var prependAll = /* @__PURE__ */ dual2(2, (self2, that) => fromIterable4(that).concat(fromIterable4(self2)));
var append = /* @__PURE__ */ dual2(2, (self2, last222) => [...self2, last222]);
var appendAll2 = /* @__PURE__ */ dual2(2, (self2, that) => fromIterable4(self2).concat(fromIterable4(that)));
var scan = /* @__PURE__ */ dual2(3, (self2, b232, f232) => {
  const out = [b232];
  let i232 = 0;
  for (const a232 of self2) {
    out[i232 + 1] = f232(out[i232], a232);
    i232++;
  }
  return out;
});
var scanRight = /* @__PURE__ */ dual2(3, (self2, b232, f232) => {
  const input = fromIterable4(self2);
  const out = new Array(input.length + 1);
  out[input.length] = b232;
  for (let i232 = input.length - 1; i232 >= 0; i232--) {
    out[i232] = f232(out[i232 + 1], input[i232]);
  }
  return out;
});
var isArray = Array.isArray;
var isEmptyArray = (self2) => self2.length === 0;
var isEmptyReadonlyArray = isEmptyArray;
var isNonEmptyArray2 = isNonEmptyArray;
var isNonEmptyReadonlyArray = isNonEmptyArray;
var length = (self2) => self2.length;
var isOutOfBound = (i232, as432) => i232 < 0 || i232 >= as432.length;
var clamp = (i232, as432) => Math.floor(Math.min(Math.max(0, i232), as432.length));
var get = /* @__PURE__ */ dual2(2, (self2, index) => {
  const i232 = Math.floor(index);
  return isOutOfBound(i232, self2) ? none4() : some6(self2[i232]);
});
var unsafeGet = /* @__PURE__ */ dual2(2, (self2, index) => {
  const i232 = Math.floor(index);
  if (isOutOfBound(i232, self2)) {
    throw new Error(`Index ${i232} out of bounds`);
  }
  return self2[i232];
});
var unprepend = (self2) => [headNonEmpty2(self2), tailNonEmpty2(self2)];
var unappend = (self2) => [initNonEmpty(self2), lastNonEmpty(self2)];
var head = /* @__PURE__ */ get(0);
var headNonEmpty2 = /* @__PURE__ */ unsafeGet(0);
var last = (self2) => isNonEmptyReadonlyArray(self2) ? some6(lastNonEmpty(self2)) : none4();
var lastNonEmpty = (self2) => self2[self2.length - 1];
var tail = (self2) => {
  const input = fromIterable4(self2);
  return isNonEmptyReadonlyArray(input) ? some6(tailNonEmpty2(input)) : none4();
};
var tailNonEmpty2 = (self2) => self2.slice(1);
var init = (self2) => {
  const input = fromIterable4(self2);
  return isNonEmptyReadonlyArray(input) ? some6(initNonEmpty(input)) : none4();
};
var initNonEmpty = (self2) => self2.slice(0, -1);
var take = /* @__PURE__ */ dual2(2, (self2, n232) => {
  const input = fromIterable4(self2);
  return input.slice(0, clamp(n232, input));
});
var takeRight = /* @__PURE__ */ dual2(2, (self2, n232) => {
  const input = fromIterable4(self2);
  const i232 = clamp(n232, input);
  return i232 === 0 ? [] : input.slice(-i232);
});
var takeWhile = /* @__PURE__ */ dual2(2, (self2, predicate) => {
  let i232 = 0;
  const out = [];
  for (const a232 of self2) {
    if (!predicate(a232, i232)) {
      break;
    }
    out.push(a232);
    i232++;
  }
  return out;
});
var spanIndex = (self2, predicate) => {
  let i232 = 0;
  for (const a232 of self2) {
    if (!predicate(a232, i232)) {
      break;
    }
    i232++;
  }
  return i232;
};
var span = /* @__PURE__ */ dual2(2, (self2, predicate) => splitAt(self2, spanIndex(self2, predicate)));
var drop2 = /* @__PURE__ */ dual2(2, (self2, n232) => {
  const input = fromIterable4(self2);
  return input.slice(clamp(n232, input), input.length);
});
var dropRight = /* @__PURE__ */ dual2(2, (self2, n232) => {
  const input = fromIterable4(self2);
  return input.slice(0, input.length - clamp(n232, input));
});
var dropWhile = /* @__PURE__ */ dual2(2, (self2, predicate) => fromIterable4(self2).slice(spanIndex(self2, predicate)));
var findFirstIndex = /* @__PURE__ */ dual2(2, (self2, predicate) => {
  let i232 = 0;
  for (const a232 of self2) {
    if (predicate(a232, i232)) {
      return some6(i232);
    }
    i232++;
  }
  return none4();
});
var findLastIndex = /* @__PURE__ */ dual2(2, (self2, predicate) => {
  const input = fromIterable4(self2);
  for (let i232 = input.length - 1; i232 >= 0; i232--) {
    if (predicate(input[i232], i232)) {
      return some6(i232);
    }
  }
  return none4();
});
var findFirst2 = findFirst;
var findLast = /* @__PURE__ */ dual2(2, (self2, f232) => {
  const input = fromIterable4(self2);
  for (let i232 = input.length - 1; i232 >= 0; i232--) {
    const a232 = input[i232];
    const o232 = f232(a232, i232);
    if (isBoolean2(o232)) {
      if (o232) {
        return some6(a232);
      }
    } else {
      if (isSome4(o232)) {
        return o232;
      }
    }
  }
  return none4();
});
var insertAt = /* @__PURE__ */ dual2(3, (self2, i232, b232) => {
  const out = Array.from(self2);
  if (i232 < 0 || i232 > out.length) {
    return none4();
  }
  out.splice(i232, 0, b232);
  return some6(out);
});
var replace2 = /* @__PURE__ */ dual2(3, (self2, i232, b232) => modify(self2, i232, () => b232));
var replaceOption = /* @__PURE__ */ dual2(3, (self2, i232, b232) => modifyOption(self2, i232, () => b232));
var modify = /* @__PURE__ */ dual2(3, (self2, i232, f232) => getOrElse2(modifyOption(self2, i232, f232), () => Array.from(self2)));
var modifyOption = /* @__PURE__ */ dual2(3, (self2, i232, f232) => {
  const out = Array.from(self2);
  if (isOutOfBound(i232, out)) {
    return none4();
  }
  const next = f232(out[i232]);
  out[i232] = next;
  return some6(out);
});
var remove = /* @__PURE__ */ dual2(2, (self2, i232) => {
  const out = Array.from(self2);
  if (isOutOfBound(i232, out)) {
    return out;
  }
  out.splice(i232, 1);
  return out;
});
var reverse3 = (self2) => Array.from(self2).reverse();
var sort = /* @__PURE__ */ dual2(2, (self2, O232) => {
  const out = Array.from(self2);
  out.sort(O232);
  return out;
});
var sortWith = /* @__PURE__ */ dual2(3, (self2, f232, order) => sort(self2, mapInput3(order, f232)));
var sortBy = (...orders) => {
  const sortByAll = sort(combineAll(orders));
  return (self2) => {
    const input = fromIterable4(self2);
    if (isNonEmptyReadonlyArray(input)) {
      return sortByAll(input);
    }
    return [];
  };
};
var zip = /* @__PURE__ */ dual2(2, (self2, that) => zipWith3(self2, that, make9));
var zipWith3 = /* @__PURE__ */ dual2(3, (self2, that, f232) => {
  const as432 = fromIterable4(self2);
  const bs = fromIterable4(that);
  if (isNonEmptyReadonlyArray(as432) && isNonEmptyReadonlyArray(bs)) {
    const out = [f232(headNonEmpty2(as432), headNonEmpty2(bs))];
    const len = Math.min(as432.length, bs.length);
    for (let i232 = 1; i232 < len; i232++) {
      out[i232] = f232(as432[i232], bs[i232]);
    }
    return out;
  }
  return [];
});
var unzip = (self2) => {
  const input = fromIterable4(self2);
  if (isNonEmptyReadonlyArray(input)) {
    const fa = [input[0][0]];
    const fb = [input[0][1]];
    for (let i232 = 1; i232 < input.length; i232++) {
      fa[i232] = input[i232][0];
      fb[i232] = input[i232][1];
    }
    return [fa, fb];
  }
  return [[], []];
};
var intersperse = /* @__PURE__ */ dual2(2, (self2, middle) => {
  const input = fromIterable4(self2);
  if (isNonEmptyReadonlyArray(input)) {
    const out = [headNonEmpty2(input)];
    const tail232 = tailNonEmpty2(input);
    for (let i232 = 0; i232 < tail232.length; i232++) {
      if (i232 < tail232.length) {
        out.push(middle);
      }
      out.push(tail232[i232]);
    }
    return out;
  }
  return [];
});
var modifyNonEmptyHead = /* @__PURE__ */ dual2(2, (self2, f232) => [f232(headNonEmpty2(self2)), ...tailNonEmpty2(self2)]);
var setNonEmptyHead = /* @__PURE__ */ dual2(2, (self2, b232) => modifyNonEmptyHead(self2, () => b232));
var modifyNonEmptyLast = /* @__PURE__ */ dual2(2, (self2, f232) => append(initNonEmpty(self2), f232(lastNonEmpty(self2))));
var setNonEmptyLast = /* @__PURE__ */ dual2(2, (self2, b232) => modifyNonEmptyLast(self2, () => b232));
var rotate = /* @__PURE__ */ dual2(2, (self2, n232) => {
  const input = fromIterable4(self2);
  if (isNonEmptyReadonlyArray(input)) {
    const len = input.length;
    const m232 = Math.round(n232) % len;
    if (isOutOfBound(Math.abs(m232), input) || m232 === 0) {
      return copy2(input);
    }
    if (m232 < 0) {
      const [f232, s232] = splitNonEmptyAt(input, -m232);
      return appendAll2(s232, f232);
    } else {
      return rotate(self2, m232 - len);
    }
  }
  return [];
});
var containsWith3 = (isEquivalent) => dual2(2, (self2, a232) => {
  for (const i232 of self2) {
    if (isEquivalent(a232, i232)) {
      return true;
    }
  }
  return false;
});
var _equivalence4 = /* @__PURE__ */ equivalence2();
var contains3 = /* @__PURE__ */ containsWith3(_equivalence4);
var chop = /* @__PURE__ */ dual2(2, (self2, f232) => {
  const input = fromIterable4(self2);
  if (isNonEmptyReadonlyArray(input)) {
    const [b232, rest] = f232(input);
    const out = [b232];
    let next = rest;
    while (isNonEmptyArray(next)) {
      const [b322, rest2] = f232(next);
      out.push(b322);
      next = rest2;
    }
    return out;
  }
  return [];
});
var splitAt = /* @__PURE__ */ dual2(2, (self2, n232) => {
  const input = Array.from(self2);
  const _n = Math.floor(n232);
  if (isNonEmptyReadonlyArray(input)) {
    if (_n >= 1) {
      return splitNonEmptyAt(input, _n);
    }
    return [[], input];
  }
  return [input, []];
});
var splitNonEmptyAt = /* @__PURE__ */ dual2(2, (self2, n232) => {
  const _n = Math.max(1, Math.floor(n232));
  return _n >= self2.length ? [copy2(self2), []] : [prepend2(self2.slice(1, _n), headNonEmpty2(self2)), self2.slice(_n)];
});
var split = /* @__PURE__ */ dual2(2, (self2, n232) => {
  const input = fromIterable4(self2);
  return chunksOf(input, Math.ceil(input.length / Math.floor(n232)));
});
var splitWhere = /* @__PURE__ */ dual2(2, (self2, predicate) => span(self2, (a232, i232) => !predicate(a232, i232)));
var copy2 = (self2) => self2.slice();
var chunksOf = /* @__PURE__ */ dual2(2, (self2, n232) => {
  const input = fromIterable4(self2);
  if (isNonEmptyReadonlyArray(input)) {
    return chop(input, splitNonEmptyAt(n232));
  }
  return [];
});
var groupWith = /* @__PURE__ */ dual2(2, (self2, isEquivalent) => chop(self2, (as432) => {
  const h232 = headNonEmpty2(as432);
  const out = [h232];
  let i232 = 1;
  for (; i232 < as432.length; i232++) {
    const a232 = as432[i232];
    if (isEquivalent(a232, h232)) {
      out.push(a232);
    } else {
      break;
    }
  }
  return [out, as432.slice(i232)];
}));
var group = /* @__PURE__ */ groupWith(/* @__PURE__ */ equivalence2());
var groupBy = /* @__PURE__ */ dual2(2, (self2, f232) => {
  const out = {};
  for (const a232 of self2) {
    const k232 = f232(a232);
    if (Object.prototype.hasOwnProperty.call(out, k232)) {
      out[k232].push(a232);
    } else {
      out[k232] = [a232];
    }
  }
  return out;
});
var unionWith = /* @__PURE__ */ dual2(3, (self2, that, isEquivalent) => {
  const a232 = fromIterable4(self2);
  const b232 = fromIterable4(that);
  if (isNonEmptyReadonlyArray(a232)) {
    if (isNonEmptyReadonlyArray(b232)) {
      const dedupe222 = dedupeWith(isEquivalent);
      return dedupe222(appendAll2(a232, b232));
    }
    return a232;
  }
  return b232;
});
var union = /* @__PURE__ */ dual2(2, (self2, that) => unionWith(self2, that, _equivalence4));
var intersectionWith = (isEquivalent) => {
  const has22 = containsWith3(isEquivalent);
  return dual2(2, (self2, that) => fromIterable4(self2).filter((a232) => has22(that, a232)));
};
var intersection = /* @__PURE__ */ intersectionWith(_equivalence4);
var differenceWith = (isEquivalent) => {
  const has22 = containsWith3(isEquivalent);
  return dual2(2, (self2, that) => fromIterable4(self2).filter((a232) => !has22(that, a232)));
};
var difference = /* @__PURE__ */ differenceWith(_equivalence4);
var empty9 = () => [];
var of2 = (a232) => [a232];
var map3 = /* @__PURE__ */ dual2(2, (self2, f232) => self2.map(f232));
var flatMap3 = /* @__PURE__ */ dual2(2, (self2, f232) => {
  if (isEmptyReadonlyArray(self2)) {
    return [];
  }
  const out = [];
  for (let i232 = 0; i232 < self2.length; i232++) {
    const inner = f232(self2[i232], i232);
    for (let j232 = 0; j232 < inner.length; j232++) {
      out.push(inner[j232]);
    }
  }
  return out;
});
var flatten3 = /* @__PURE__ */ flatMap3(identity2);
var filterMap3 = /* @__PURE__ */ dual2(2, (self2, f232) => {
  const as432 = fromIterable4(self2);
  const out = [];
  for (let i232 = 0; i232 < as432.length; i232++) {
    const o232 = f232(as432[i232], i232);
    if (isSome4(o232)) {
      out.push(o232.value);
    }
  }
  return out;
});
var filterMapWhile = /* @__PURE__ */ dual2(2, (self2, f232) => {
  let i232 = 0;
  const out = [];
  for (const a232 of self2) {
    const b232 = f232(a232, i232);
    if (isSome4(b232)) {
      out.push(b232.value);
    } else {
      break;
    }
    i232++;
  }
  return out;
});
var partitionMap3 = /* @__PURE__ */ dual2(2, (self2, f232) => {
  const left532 = [];
  const right532 = [];
  const as432 = fromIterable4(self2);
  for (let i232 = 0; i232 < as432.length; i232++) {
    const e232 = f232(as432[i232], i232);
    if (isLeft3(e232)) {
      left532.push(e232.left);
    } else {
      right532.push(e232.right);
    }
  }
  return [left532, right532];
});
var getSomes = /* @__PURE__ */ filterMap3(identity2);
var getLefts = (self2) => {
  const out = [];
  for (const a232 of self2) {
    if (isLeft3(a232)) {
      out.push(a232.left);
    }
  }
  return out;
};
var getRights = (self2) => {
  const out = [];
  for (const a232 of self2) {
    if (isRight3(a232)) {
      out.push(a232.right);
    }
  }
  return out;
};
var filter3 = /* @__PURE__ */ dual2(2, (self2, predicate) => {
  const as432 = fromIterable4(self2);
  const out = [];
  for (let i232 = 0; i232 < as432.length; i232++) {
    if (predicate(as432[i232], i232)) {
      out.push(as432[i232]);
    }
  }
  return out;
});
var partition = /* @__PURE__ */ dual2(2, (self2, predicate) => {
  const left532 = [];
  const right532 = [];
  const as432 = fromIterable4(self2);
  for (let i232 = 0; i232 < as432.length; i232++) {
    if (predicate(as432[i232], i232)) {
      right532.push(as432[i232]);
    } else {
      left532.push(as432[i232]);
    }
  }
  return [left532, right532];
});
var separate = /* @__PURE__ */ partitionMap3(identity2);
var reduce3 = /* @__PURE__ */ dual2(3, (self2, b232, f232) => fromIterable4(self2).reduce((b322, a232, i232) => f232(b322, a232, i232), b232));
var reduceRight = /* @__PURE__ */ dual2(3, (self2, b232, f232) => fromIterable4(self2).reduceRight((b322, a232, i232) => f232(b322, a232, i232), b232));
var liftPredicate3 = (predicate) => (b232) => predicate(b232) ? [b232] : [];
var liftOption = (f232) => (...a232) => fromOption2(f232(...a232));
var fromNullable3 = (a232) => a232 == null ? empty9() : [a232];
var liftNullable3 = (f232) => (...a232) => fromNullable3(f232(...a232));
var flatMapNullable3 = /* @__PURE__ */ dual2(2, (self2, f232) => flatMap3(self2, (a232) => fromNullable3(f232(a232))));
var liftEither = (f232) => (...a232) => {
  const e232 = f232(...a232);
  return isLeft3(e232) ? [] : [e232.right];
};
var every3 = /* @__PURE__ */ dual2(2, (self2, refinement) => self2.every(refinement));
var some7 = /* @__PURE__ */ dual2(2, (self2, predicate) => self2.some(predicate));
var extend = /* @__PURE__ */ dual2(2, (self2, f232) => self2.map((_232, i232, as432) => f232(as432.slice(i232))));
var min2 = /* @__PURE__ */ dual2(2, (self2, O232) => self2.reduce(min(O232)));
var max2 = /* @__PURE__ */ dual2(2, (self2, O232) => self2.reduce(max(O232)));
var unfold = (b232, f232) => {
  const out = [];
  let next = b232;
  let o232;
  while (isSome4(o232 = f232(next))) {
    const [a232, b322] = o232.value;
    out.push(a232);
    next = b322;
  }
  return out;
};
var getOrder3 = array4;
var getEquivalence4 = array3;
var forEach3 = /* @__PURE__ */ dual2(2, (self2, f232) => fromIterable4(self2).forEach((a232, i232) => f232(a232, i232)));
var dedupeWith = /* @__PURE__ */ dual2(2, (self2, isEquivalent) => {
  const input = fromIterable4(self2);
  if (isNonEmptyReadonlyArray(input)) {
    const out = [headNonEmpty2(input)];
    const rest = tailNonEmpty2(input);
    for (const r232 of rest) {
      if (out.every((a232) => !isEquivalent(r232, a232))) {
        out.push(r232);
      }
    }
    return out;
  }
  return [];
});
var dedupe = (self2) => dedupeWith(self2, equivalence2());
var dedupeAdjacentWith = /* @__PURE__ */ dual2(2, (self2, isEquivalent) => {
  const out = [];
  let lastA = none4();
  for (const a232 of self2) {
    if (isNone4(lastA) || !isEquivalent(a232, lastA.value)) {
      out.push(a232);
      lastA = some6(a232);
    }
  }
  return out;
});
var dedupeAdjacent = /* @__PURE__ */ dedupeAdjacentWith(/* @__PURE__ */ equivalence2());
var join2 = /* @__PURE__ */ dual2(2, (self2, sep2) => fromIterable4(self2).join(sep2));
var mapAccum = /* @__PURE__ */ dual2(3, (self2, s232, f232) => {
  let i232 = 0;
  let s1 = s232;
  const out = [];
  for (const a232 of self2) {
    const r232 = f232(s1, a232, i232);
    s1 = r232[0];
    out.push(r232[1]);
    i232++;
  }
  return [s1, out];
});
var cartesianWith = /* @__PURE__ */ dual2(3, (self2, that, f232) => flatMap3(self2, (a232) => map3(that, (b232) => f232(a232, b232))));
var cartesian = /* @__PURE__ */ dual2(2, (self2, that) => cartesianWith(self2, that, (a232, b232) => [a232, b232]));
var Do3 = /* @__PURE__ */ of2({});
var bind5 = /* @__PURE__ */ bind3(map3, flatMap3);
var bindTo5 = /* @__PURE__ */ bindTo3(map3);
var let_5 = /* @__PURE__ */ let_3(map3);
var __defProp3 = Object.defineProperty;
var __export3 = (target, all3232) => {
  for (var name22 in all3232)
    __defProp3(target, name22, { get: all3232[name22], enumerable: true });
};
var Function_exports3 = {};
__export3(Function_exports3, {
  SK: () => SK3,
  absurd: () => absurd3,
  apply: () => apply3,
  compose: () => compose5,
  constFalse: () => constFalse3,
  constNull: () => constNull3,
  constTrue: () => constTrue3,
  constUndefined: () => constUndefined3,
  constVoid: () => constVoid3,
  constant: () => constant3,
  dual: () => dual3,
  flip: () => flip3,
  flow: () => flow3,
  hole: () => hole3,
  identity: () => identity3,
  isFunction: () => isFunction6,
  pipe: () => pipe3,
  satisfies: () => satisfies3,
  tupled: () => tupled3,
  unsafeCoerce: () => unsafeCoerce3,
  untupled: () => untupled3
});
var isFunction6 = (input) => typeof input === "function";
var dual3 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a232, b232) {
        if (arguments.length >= 2) {
          return body(a232, b232);
        }
        return function(self2) {
          return body(self2, a232);
        };
      };
    case 3:
      return function(a232, b232, c232) {
        if (arguments.length >= 3) {
          return body(a232, b232, c232);
        }
        return function(self2) {
          return body(self2, a232, b232);
        };
      };
    case 4:
      return function(a232, b232, c232, d232) {
        if (arguments.length >= 4) {
          return body(a232, b232, c232, d232);
        }
        return function(self2) {
          return body(self2, a232, b232, c232);
        };
      };
    case 5:
      return function(a232, b232, c232, d232, e232) {
        if (arguments.length >= 5) {
          return body(a232, b232, c232, d232, e232);
        }
        return function(self2) {
          return body(self2, a232, b232, c232, d232);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply3 = (a232) => (self2) => self2(a232);
var identity3 = (a232) => a232;
var satisfies3 = () => (b232) => b232;
var unsafeCoerce3 = identity3;
var constant3 = (value) => () => value;
var constTrue3 = /* @__PURE__ */ constant3(true);
var constFalse3 = /* @__PURE__ */ constant3(false);
var constNull3 = /* @__PURE__ */ constant3(null);
var constUndefined3 = /* @__PURE__ */ constant3(void 0);
var constVoid3 = constUndefined3;
var flip3 = (f232) => (...b232) => (...a232) => f232(...a232)(...b232);
var compose5 = /* @__PURE__ */ dual3(2, (ab, bc) => (a232) => bc(ab(a232)));
var absurd3 = (_232) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled3 = (f232) => (a232) => f232(...a232);
var untupled3 = (f232) => (...a232) => f232(a232);
function pipe3(a232, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a232;
    case 2:
      return ab(a232);
    case 3:
      return bc(ab(a232));
    case 4:
      return cd(bc(ab(a232)));
    case 5:
      return de(cd(bc(ab(a232))));
    case 6:
      return ef(de(cd(bc(ab(a232)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a232))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a232)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a232))))))));
    default: {
      let ret = arguments[0];
      for (let i232 = 1; i232 < arguments.length; i232++) {
        ret = arguments[i232](ret);
      }
      return ret;
    }
  }
}
function flow3(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole3 = /* @__PURE__ */ unsafeCoerce3(absurd3);
var SK3 = (_232, b232) => b232;
var make11 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_6 = (map3222) => dual3(3, (self2, name22, f232) => map3222(self2, (a232) => Object.assign({}, a232, {
  [name22]: f232(a232)
})));
var bindTo6 = (map3222) => dual3(2, (self2, name22) => map3222(self2, (a232) => ({
  [name22]: a232
})));
var bind6 = (map3222, flatMap3222) => dual3(3, (self2, name22, f232) => flatMap3222(self2, (a232) => map3222(f232(a232), (b232) => Object.assign({}, a232, {
  [name22]: b232
}))));
var moduleVersion3 = "3.2.8";
var getCurrentVersion3 = () => moduleVersion3;
var globalStoreId3 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion3()}`);
if (!(globalStoreId3 in globalThis)) {
  globalThis[globalStoreId3] = /* @__PURE__ */ new Map();
}
var globalStore3 = globalThis[globalStoreId3];
var globalValue3 = (id, compute) => {
  if (!globalStore3.has(id)) {
    globalStore3.set(id, compute());
  }
  return globalStore3.get(id);
};
var isFunction22 = isFunction6;
var isRecordOrArray3 = (input) => typeof input === "object" && input !== null;
var isObject3 = (input) => isRecordOrArray3(input) || isFunction22(input);
var hasProperty3 = /* @__PURE__ */ dual3(2, (self2, property) => isObject3(self2) && property in self2);
var isNullable3 = (input) => input === null || input === void 0;
var getBugErrorMessage3 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId3 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind3 = (u232) => isObject3(u232) && GenKindTypeId3 in u232;
var GenKindImpl3 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity3;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId3] = GenKindTypeId3;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen4(this);
  }
};
var SingleShotGen4 = class _SingleShotGen3 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a232) {
    return this.called ? {
      value: a232,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a232) {
    return {
      value: a232,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e232) {
    throw e232;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen3(this.self);
  }
};
var adapter5 = () => function() {
  let x232 = arguments[0];
  for (let i232 = 1; i232 < arguments.length; i232++) {
    x232 = arguments[i232](x232);
  }
  return new GenKindImpl3(x232);
};
var defaultIncHi3 = 335903614;
var defaultIncLo3 = 4150755663;
var MUL_HI3 = 1481765933 >>> 0;
var MUL_LO3 = 1284865837 >>> 0;
var BIT_533 = 9007199254740992;
var BIT_273 = 134217728;
var PCGRandom3 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable3(seedLo) && isNullable3(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable3(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable3(incLo) && isNullable3(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo3;
      incHi = this._state ? this._state[2] : defaultIncHi3;
    } else if (isNullable3(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add643(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max322) {
    if (!max322) {
      return this._next();
    }
    max322 = max322 >>> 0;
    if ((max322 & max322 - 1) === 0) {
      return this._next() & max322 - 1;
    }
    let num = 0;
    const skew = (-max322 >>> 0) % max322 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max322;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_273 + lo) / BIT_533;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul643(this._state, oldHi, oldLo, MUL_HI3, MUL_LO3);
    add643(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul643(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add643(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId3 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap3 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId3]() {
    return this.#value;
  }
};
function yieldWrapGet3(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId3 in self2) {
    return self2[YieldWrapTypeId3]();
  }
  throw new Error(getBugErrorMessage3("yieldWrapGet"));
}
var structuralRegionState3 = /* @__PURE__ */ globalValue3("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache3 = /* @__PURE__ */ globalValue3(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr3 = /* @__PURE__ */ globalValue3(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom3());
var symbol5 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash3 = (self2) => {
  if (structuralRegionState3.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number4(self2);
    case "bigint":
      return string3(self2.toString(10));
    case "boolean":
      return string3(String(self2));
    case "symbol":
      return string3(String(self2));
    case "string":
      return string3(self2);
    case "undefined":
      return string3("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string3("null");
      } else if (self2 instanceof Date) {
        return hash3(self2.toISOString());
      } else if (isHash3(self2)) {
        return self2[symbol5]();
      } else {
        return random3(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random3 = (self2) => {
  if (!randomHashCache3.has(self2)) {
    randomHashCache3.set(self2, number4(pcgr3.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache3.get(self2);
};
var combine4 = (b232) => (self2) => self2 * 53 ^ b232;
var optimize3 = (n232) => n232 & 3221225471 | n232 >>> 1 & 1073741824;
var isHash3 = (u232) => hasProperty3(u232, symbol5);
var number4 = (n232) => {
  if (n232 !== n232 || n232 === Infinity) {
    return 0;
  }
  let h232 = n232 | 0;
  if (h232 !== n232) {
    h232 ^= n232 * 4294967295;
  }
  while (n232 > 4294967295) {
    h232 ^= n232 /= 4294967295;
  }
  return optimize3(n232);
};
var string3 = (str) => {
  let h232 = 5381, i232 = str.length;
  while (i232) {
    h232 = h232 * 33 ^ str.charCodeAt(--i232);
  }
  return optimize3(h232);
};
var cached3 = function() {
  if (arguments.length === 1) {
    const self3 = arguments[0];
    return function(hash432) {
      Object.defineProperty(self3, symbol5, {
        value() {
          return hash432;
        },
        enumerable: false
      });
      return hash432;
    };
  }
  const self2 = arguments[0];
  const hash3222 = arguments[1];
  Object.defineProperty(self2, symbol5, {
    value() {
      return hash3222;
    },
    enumerable: false
  });
  return hash3222;
};
var symbol22 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals3() {
  if (arguments.length === 1) {
    return (self2) => compareBoth3(self2, arguments[0]);
  }
  return compareBoth3(arguments[0], arguments[1]);
}
function compareBoth3(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual3(self2) && isEqual3(that)) {
        if (hash3(self2) === hash3(that) && self2[symbol22](that)) {
          return true;
        } else {
          return structuralRegionState3.enabled && structuralRegionState3.tester ? structuralRegionState3.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState3.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v232, i232) => compareBoth3(v232, that[i232]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth3(self2[key], that[key]))) {
              return structuralRegionState3.tester ? structuralRegionState3.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState3.tester ? structuralRegionState3.tester(self2, that) : false;
    }
  }
  return structuralRegionState3.enabled && structuralRegionState3.tester ? structuralRegionState3.tester(self2, that) : false;
}
var isEqual3 = (u232) => hasProperty3(u232, symbol22);
var equivalence3 = () => equals3;
var NodeInspectSymbol3 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON3 = (x232) => {
  if (hasProperty3(x232, "toJSON") && isFunction22(x232["toJSON"]) && x232["toJSON"].length === 0) {
    return x232.toJSON();
  } else if (Array.isArray(x232)) {
    return x232.map(toJSON3);
  }
  return x232;
};
var format3 = (x232) => JSON.stringify(x232, null, 2);
var pipeArguments3 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i232 = 0, len = args.length; i232 < len; i232++) {
        ret = args[i232](ret);
      }
      return ret;
    }
  }
};
var EffectTypeId4 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId3 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId3 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId3 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance3 = {
  /* c8 ignore next */
  _R: (_232) => _232,
  /* c8 ignore next */
  _E: (_232) => _232,
  /* c8 ignore next */
  _A: (_232) => _232,
  _V: /* @__PURE__ */ getCurrentVersion3()
};
var sinkVariance3 = {
  /* c8 ignore next */
  _A: (_232) => _232,
  /* c8 ignore next */
  _In: (_232) => _232,
  /* c8 ignore next */
  _L: (_232) => _232,
  /* c8 ignore next */
  _E: (_232) => _232,
  /* c8 ignore next */
  _R: (_232) => _232
};
var channelVariance3 = {
  /* c8 ignore next */
  _Env: (_232) => _232,
  /* c8 ignore next */
  _InErr: (_232) => _232,
  /* c8 ignore next */
  _InElem: (_232) => _232,
  /* c8 ignore next */
  _InDone: (_232) => _232,
  /* c8 ignore next */
  _OutErr: (_232) => _232,
  /* c8 ignore next */
  _OutElem: (_232) => _232,
  /* c8 ignore next */
  _OutDone: (_232) => _232
};
var EffectPrototype3 = {
  [EffectTypeId4]: effectVariance3,
  [StreamTypeId3]: effectVariance3,
  [SinkTypeId3]: sinkVariance3,
  [ChannelTypeId3]: channelVariance3,
  [symbol22](that) {
    return this === that;
  },
  [symbol5]() {
    return cached3(this, random3(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen4(new YieldWrap3(this));
  },
  pipe() {
    return pipeArguments3(this, arguments);
  }
};
var TypeId9 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto5 = {
  ...EffectPrototype3,
  [TypeId9]: {
    _A: (_232) => _232
  },
  [NodeInspectSymbol3]() {
    return this.toJSON();
  },
  toString() {
    return format3(this.toJSON());
  }
};
var SomeProto3 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto5), {
  _tag: "Some",
  _op: "Some",
  [symbol22](that) {
    return isOption5(that) && isSome5(that) && equals3(this.value, that.value);
  },
  [symbol5]() {
    return cached3(this, combine4(hash3(this._tag))(hash3(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON3(this.value)
    };
  }
});
var NoneHash3 = /* @__PURE__ */ hash3("None");
var NoneProto3 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto5), {
  _tag: "None",
  _op: "None",
  [symbol22](that) {
    return isOption5(that) && isNone5(that);
  },
  [symbol5]() {
    return NoneHash3;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption5 = (input) => hasProperty3(input, TypeId9);
var isNone5 = (fa) => fa._tag === "None";
var isSome5 = (fa) => fa._tag === "Some";
var none5 = /* @__PURE__ */ Object.create(NoneProto3);
var some8 = (value) => {
  const a232 = Object.create(SomeProto3);
  a232.value = value;
  return a232;
};
var TypeId22 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto22 = {
  ...EffectPrototype3,
  [TypeId22]: {
    _R: (_232) => _232
  },
  [NodeInspectSymbol3]() {
    return this.toJSON();
  },
  toString() {
    return format3(this.toJSON());
  }
};
var RightProto3 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto22), {
  _tag: "Right",
  _op: "Right",
  [symbol22](that) {
    return isEither3(that) && isRight4(that) && equals3(this.right, that.right);
  },
  [symbol5]() {
    return combine4(hash3(this._tag))(hash3(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON3(this.right)
    };
  }
});
var LeftProto3 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto22), {
  _tag: "Left",
  _op: "Left",
  [symbol22](that) {
    return isEither3(that) && isLeft4(that) && equals3(this.left, that.left);
  },
  [symbol5]() {
    return combine4(hash3(this._tag))(hash3(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON3(this.left)
    };
  }
});
var isEither3 = (input) => hasProperty3(input, TypeId22);
var isLeft4 = (ma) => ma._tag === "Left";
var isRight4 = (ma) => ma._tag === "Right";
var left4 = (left3232) => {
  const a232 = Object.create(LeftProto3);
  a232.left = left3232;
  return a232;
};
var right4 = (right3232) => {
  const a232 = Object.create(RightProto3);
  a232.right = right3232;
  return a232;
};
var getLeft5 = (self2) => isRight4(self2) ? none5 : some8(self2.left);
var getRight5 = (self2) => isLeft4(self2) ? none5 : some8(self2.right);
var Option_exports3 = {};
__export3(Option_exports3, {
  Do: () => Do4,
  TypeId: () => TypeId32,
  all: () => all5,
  andThen: () => andThen3,
  ap: () => ap3,
  as: () => as3,
  asVoid: () => asVoid3,
  bind: () => bind22,
  bindTo: () => bindTo22,
  composeK: () => composeK3,
  contains: () => contains4,
  containsWith: () => containsWith4,
  exists: () => exists3,
  filter: () => filter4,
  filterMap: () => filterMap4,
  firstSomeOf: () => firstSomeOf3,
  flatMap: () => flatMap4,
  flatMapNullable: () => flatMapNullable4,
  flatten: () => flatten4,
  fromIterable: () => fromIterable5,
  fromNullable: () => fromNullable4,
  gen: () => gen3,
  getEquivalence: () => getEquivalence5,
  getLeft: () => getLeft22,
  getOrElse: () => getOrElse3,
  getOrNull: () => getOrNull3,
  getOrThrow: () => getOrThrow3,
  getOrThrowWith: () => getOrThrowWith3,
  getOrUndefined: () => getOrUndefined3,
  getOrder: () => getOrder4,
  getRight: () => getRight22,
  isNone: () => isNone22,
  isOption: () => isOption22,
  isSome: () => isSome22,
  let: () => let_22,
  lift2: () => lift23,
  liftNullable: () => liftNullable4,
  liftPredicate: () => liftPredicate4,
  liftThrowable: () => liftThrowable3,
  map: () => map4,
  match: () => match5,
  none: () => none22,
  orElse: () => orElse3,
  orElseEither: () => orElseEither3,
  orElseSome: () => orElseSome3,
  partitionMap: () => partitionMap4,
  product: () => product5,
  productMany: () => productMany5,
  reduceCompact: () => reduceCompact3,
  some: () => some22,
  tap: () => tap3,
  toArray: () => toArray3,
  toRefinement: () => toRefinement3,
  void: () => void_3,
  zipLeft: () => zipLeft3,
  zipRight: () => zipRight3,
  zipWith: () => zipWith4
});
var make22 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId32 = /* @__PURE__ */ Symbol.for("effect/Option");
var none22 = () => none5;
var some22 = some8;
var isOption22 = isOption5;
var isNone22 = isNone5;
var isSome22 = isSome5;
var match5 = /* @__PURE__ */ dual3(2, (self2, {
  onNone,
  onSome
}) => isNone22(self2) ? onNone() : onSome(self2.value));
var toRefinement3 = (f232) => (a232) => isSome22(f232(a232));
var fromIterable5 = (collection) => {
  for (const a232 of collection) {
    return some22(a232);
  }
  return none22();
};
var getRight22 = getRight5;
var getLeft22 = getLeft5;
var getOrElse3 = /* @__PURE__ */ dual3(2, (self2, onNone) => isNone22(self2) ? onNone() : self2.value);
var orElse3 = /* @__PURE__ */ dual3(2, (self2, that) => isNone22(self2) ? that() : self2);
var orElseSome3 = /* @__PURE__ */ dual3(2, (self2, onNone) => isNone22(self2) ? some22(onNone()) : self2);
var orElseEither3 = /* @__PURE__ */ dual3(2, (self2, that) => isNone22(self2) ? map4(that(), right4) : map4(self2, left4));
var firstSomeOf3 = (collection) => {
  let out = none22();
  for (out of collection) {
    if (isSome22(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable4 = (nullableValue) => nullableValue == null ? none22() : some22(nullableValue);
var liftNullable4 = (f232) => (...a232) => fromNullable4(f232(...a232));
var getOrNull3 = /* @__PURE__ */ getOrElse3(constNull3);
var getOrUndefined3 = /* @__PURE__ */ getOrElse3(constUndefined3);
var liftThrowable3 = (f232) => (...a232) => {
  try {
    return some22(f232(...a232));
  } catch (e232) {
    return none22();
  }
};
var getOrThrowWith3 = /* @__PURE__ */ dual3(2, (self2, onNone) => {
  if (isSome22(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow3 = /* @__PURE__ */ getOrThrowWith3(() => new Error("getOrThrow called on a None"));
var map4 = /* @__PURE__ */ dual3(2, (self2, f232) => isNone22(self2) ? none22() : some22(f232(self2.value)));
var as3 = /* @__PURE__ */ dual3(2, (self2, b232) => map4(self2, () => b232));
var asVoid3 = /* @__PURE__ */ as3(void 0);
var void_3 = /* @__PURE__ */ some22(void 0);
var flatMap4 = /* @__PURE__ */ dual3(2, (self2, f232) => isNone22(self2) ? none22() : f232(self2.value));
var andThen3 = /* @__PURE__ */ dual3(2, (self2, f232) => flatMap4(self2, (a232) => {
  const b232 = isFunction6(f232) ? f232(a232) : f232;
  return isOption22(b232) ? b232 : some22(b232);
}));
var flatMapNullable4 = /* @__PURE__ */ dual3(2, (self2, f232) => isNone22(self2) ? none22() : fromNullable4(f232(self2.value)));
var flatten4 = /* @__PURE__ */ flatMap4(identity3);
var zipRight3 = /* @__PURE__ */ dual3(2, (self2, that) => flatMap4(self2, () => that));
var composeK3 = /* @__PURE__ */ dual3(2, (afb, bfc) => (a232) => flatMap4(afb(a232), bfc));
var zipLeft3 = /* @__PURE__ */ dual3(2, (self2, that) => tap3(self2, () => that));
var tap3 = /* @__PURE__ */ dual3(2, (self2, f232) => flatMap4(self2, (a232) => map4(f232(a232), () => a232)));
var product5 = (self2, that) => isSome22(self2) && isSome22(that) ? some22([self2.value, that.value]) : none22();
var productMany5 = (self2, collection) => {
  if (isNone22(self2)) {
    return none22();
  }
  const out = [self2.value];
  for (const o232 of collection) {
    if (isNone22(o232)) {
      return none22();
    }
    out.push(o232.value);
  }
  return some22(out);
};
var all5 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o232 of input) {
      if (isNone22(o232)) {
        return none22();
      }
      out2.push(o232.value);
    }
    return some22(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o232 = input[key];
    if (isNone22(o232)) {
      return none22();
    }
    out[key] = o232.value;
  }
  return some22(out);
};
var zipWith4 = /* @__PURE__ */ dual3(3, (self2, that, f232) => map4(product5(self2, that), ([a232, b232]) => f232(a232, b232)));
var ap3 = /* @__PURE__ */ dual3(2, (self2, that) => zipWith4(self2, that, (f232, a232) => f232(a232)));
var reduceCompact3 = /* @__PURE__ */ dual3(3, (self2, b232, f232) => {
  let out = b232;
  for (const oa of self2) {
    if (isSome22(oa)) {
      out = f232(out, oa.value);
    }
  }
  return out;
});
var toArray3 = (self2) => isNone22(self2) ? [] : [self2.value];
var partitionMap4 = /* @__PURE__ */ dual3(2, (self2, f232) => {
  if (isNone22(self2)) {
    return [none22(), none22()];
  }
  const e232 = f232(self2.value);
  return isLeft4(e232) ? [some22(e232.left), none22()] : [none22(), some22(e232.right)];
});
var filterMap4 = /* @__PURE__ */ dual3(2, (self2, f232) => isNone22(self2) ? none22() : f232(self2.value));
var filter4 = /* @__PURE__ */ dual3(2, (self2, predicate) => filterMap4(self2, (b232) => predicate(b232) ? some8(b232) : none5));
var getEquivalence5 = (isEquivalent) => make11((x232, y232) => x232 === y232 || (isNone22(x232) ? isNone22(y232) : isNone22(y232) ? false : isEquivalent(x232.value, y232.value)));
var getOrder4 = (O232) => make22((self2, that) => isSome22(self2) ? isSome22(that) ? O232(self2.value, that.value) : 1 : -1);
var lift23 = (f232) => dual3(2, (self2, that) => zipWith4(self2, that, f232));
var liftPredicate4 = (predicate) => (b232) => predicate(b232) ? some22(b232) : none22();
var containsWith4 = (isEquivalent) => dual3(2, (self2, a232) => isNone22(self2) ? false : isEquivalent(self2.value, a232));
var _equivalence5 = /* @__PURE__ */ equivalence3();
var contains4 = /* @__PURE__ */ containsWith4(_equivalence5);
var exists3 = /* @__PURE__ */ dual3(2, (self2, refinement) => isNone22(self2) ? false : refinement(self2.value));
var bindTo22 = /* @__PURE__ */ bindTo6(map4);
var let_22 = /* @__PURE__ */ let_6(map4);
var bind22 = /* @__PURE__ */ bind6(map4, flatMap4);
var Do4 = /* @__PURE__ */ some22({});
var adapter22 = /* @__PURE__ */ adapter5();
var gen3 = (f232) => {
  const iterator = f232(adapter22);
  let state = iterator.next();
  if (state.done) {
    return some22(state.value);
  } else {
    let current = state.value;
    if (isGenKind3(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet3(current);
    }
    if (isNone22(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind3(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet3(current);
        }
        if (isNone22(current)) {
          return current;
        }
      }
    }
    return some22(state.value);
  }
};
var MutableRef_exports2 = {};
__export3(MutableRef_exports2, {
  compareAndSet: () => compareAndSet,
  decrement: () => decrement,
  decrementAndGet: () => decrementAndGet,
  get: () => get2,
  getAndDecrement: () => getAndDecrement,
  getAndIncrement: () => getAndIncrement,
  getAndSet: () => getAndSet,
  getAndUpdate: () => getAndUpdate,
  increment: () => increment,
  incrementAndGet: () => incrementAndGet,
  make: () => make32,
  set: () => set2,
  setAndGet: () => setAndGet,
  toggle: () => toggle,
  update: () => update,
  updateAndGet: () => updateAndGet
});
var TypeId42 = /* @__PURE__ */ Symbol.for("effect/MutableRef");
var MutableRefProto = {
  [TypeId42]: TypeId42,
  toString() {
    return format3(this.toJSON());
  },
  toJSON() {
    return {
      _id: "MutableRef",
      current: toJSON3(this.current)
    };
  },
  [NodeInspectSymbol3]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments3(this, arguments);
  }
};
var make32 = (value) => {
  const ref = Object.create(MutableRefProto);
  ref.current = value;
  return ref;
};
var compareAndSet = /* @__PURE__ */ dual3(3, (self2, oldValue, newValue) => {
  if (equals3(oldValue, self2.current)) {
    self2.current = newValue;
    return true;
  }
  return false;
});
var decrement = (self2) => update(self2, (n232) => n232 - 1);
var decrementAndGet = (self2) => updateAndGet(self2, (n232) => n232 - 1);
var get2 = (self2) => self2.current;
var getAndDecrement = (self2) => getAndUpdate(self2, (n232) => n232 - 1);
var getAndIncrement = (self2) => getAndUpdate(self2, (n232) => n232 + 1);
var getAndSet = /* @__PURE__ */ dual3(2, (self2, value) => {
  const ret = self2.current;
  self2.current = value;
  return ret;
});
var getAndUpdate = /* @__PURE__ */ dual3(2, (self2, f232) => getAndSet(self2, f232(get2(self2))));
var increment = (self2) => update(self2, (n232) => n232 + 1);
var incrementAndGet = (self2) => updateAndGet(self2, (n232) => n232 + 1);
var set2 = /* @__PURE__ */ dual3(2, (self2, value) => {
  self2.current = value;
  return self2;
});
var setAndGet = /* @__PURE__ */ dual3(2, (self2, value) => {
  self2.current = value;
  return self2.current;
});
var update = /* @__PURE__ */ dual3(2, (self2, f232) => set2(self2, f232(get2(self2))));
var updateAndGet = /* @__PURE__ */ dual3(2, (self2, f232) => setAndGet(self2, f232(get2(self2))));
var toggle = (self2) => update(self2, (_232) => !_232);
function getVariables(initialScope) {
  const scopeRef = MutableRef_exports2.make(initialScope);
  const variablesRef = MutableRef_exports2.make(MutableRef_exports2.get(scopeRef).variables);
  while (MutableRef_exports2.get(scopeRef).type !== scopeManager.ScopeType.global) {
    MutableRef_exports2.set(scopeRef, MutableRef_exports2.get(scopeRef).upper);
    MutableRef_exports2.update(variablesRef, (variables) => variables.concat(MutableRef_exports2.get(scopeRef).variables));
  }
  return MutableRef_exports2.get(variablesRef).reverse();
}
var findVariable2 = Function_exports3.dual(2, (name22, initialScope) => {
  return Option_exports3.fromNullable(getVariables(initialScope).find((variable) => variable.name === name22));
});
var t2 = Symbol.for("@ts-pattern/matcher");
var e2 = Symbol.for("@ts-pattern/isVariadic");
var n2 = "@ts-pattern/anonymous-select-key";
var r2 = (t232) => Boolean(t232 && "object" == typeof t232);
var i2 = (e232) => e232 && !!e232[t2];
var o2 = (n232, s232, c232) => {
  if (i2(n232)) {
    const e232 = n232[t2](), { matched: r232, selections: i232 } = e232.match(s232);
    return r232 && i232 && Object.keys(i232).forEach((t232) => c232(t232, i232[t232])), r232;
  }
  if (r2(n232)) {
    if (!r2(s232)) return false;
    if (Array.isArray(n232)) {
      if (!Array.isArray(s232)) return false;
      let t232 = [], r232 = [], a232 = [];
      for (const o232 of n232.keys()) {
        const s322 = n232[o232];
        i2(s322) && s322[e2] ? a232.push(s322) : a232.length ? r232.push(s322) : t232.push(s322);
      }
      if (a232.length) {
        if (a232.length > 1) throw new Error("Pattern error: Using `...P.array(...)` several times in a single pattern is not allowed.");
        if (s232.length < t232.length + r232.length) return false;
        const e232 = s232.slice(0, t232.length), n322 = 0 === r232.length ? [] : s232.slice(-r232.length), i232 = s232.slice(t232.length, 0 === r232.length ? Infinity : -r232.length);
        return t232.every((t322, n422) => o2(t322, e232[n422], c232)) && r232.every((t322, e322) => o2(t322, n322[e322], c232)) && (0 === a232.length || o2(a232[0], i232, c232));
      }
      return n232.length === s232.length && n232.every((t322, e232) => o2(t322, s232[e232], c232));
    }
    return Object.keys(n232).every((e232) => {
      const r232 = n232[e232];
      return (e232 in s232 || i2(a232 = r232) && "optional" === a232[t2]().matcherType) && o2(r232, s232[e232], c232);
      var a232;
    });
  }
  return Object.is(s232, n232);
};
var s2 = (e232) => {
  var n232, o232, a232;
  return r2(e232) ? i2(e232) ? null != (n232 = null == (o232 = (a232 = e232[t2]()).getSelectionKeys) ? void 0 : o232.call(a232)) ? n232 : [] : Array.isArray(e232) ? c2(e232, s2) : c2(Object.values(e232), s2) : [];
};
var c2 = (t232, e232) => t232.reduce((t322, n232) => t322.concat(e232(n232)), []);
function a2(...t232) {
  if (1 === t232.length) {
    const [e232] = t232;
    return (t322) => o2(e232, t322, () => {
    });
  }
  if (2 === t232.length) {
    const [e232, n232] = t232;
    return o2(e232, n232, () => {
    });
  }
  throw new Error(`isMatching wasn't given the right number of arguments: expected 1 or 2, received ${t232.length}.`);
}
function u2(t232) {
  return Object.assign(t232, { optional: () => l2(t232), and: (e232) => m2(t232, e232), or: (e232) => d2(t232, e232), select: (e232) => void 0 === e232 ? p2(t232) : p2(e232, t232) });
}
function h2(t232) {
  return Object.assign(((t322) => Object.assign(t322, { [Symbol.iterator]() {
    let n232 = 0;
    const r232 = [{ value: Object.assign(t322, { [e2]: true }), done: false }, { done: true, value: void 0 }];
    return { next: () => {
      var t422;
      return null != (t422 = r232[n232++]) ? t422 : r232.at(-1);
    } };
  } }))(t232), { optional: () => h2(l2(t232)), select: (e232) => h2(void 0 === e232 ? p2(t232) : p2(e232, t232)) });
}
function l2(e232) {
  return u2({ [t2]: () => ({ match: (t232) => {
    let n232 = {};
    const r232 = (t322, e322) => {
      n232[t322] = e322;
    };
    return void 0 === t232 ? (s2(e232).forEach((t322) => r232(t322, void 0)), { matched: true, selections: n232 }) : { matched: o2(e232, t232, r232), selections: n232 };
  }, getSelectionKeys: () => s2(e232), matcherType: "optional" }) });
}
var f2 = (t232, e232) => {
  for (const n232 of t232) if (!e232(n232)) return false;
  return true;
};
var g2 = (t232, e232) => {
  for (const [n232, r232] of t232.entries()) if (!e232(r232, n232)) return false;
  return true;
};
function m2(...e232) {
  return u2({ [t2]: () => ({ match: (t232) => {
    let n232 = {};
    const r232 = (t322, e322) => {
      n232[t322] = e322;
    };
    return { matched: e232.every((e322) => o2(e322, t232, r232)), selections: n232 };
  }, getSelectionKeys: () => c2(e232, s2), matcherType: "and" }) });
}
function d2(...e232) {
  return u2({ [t2]: () => ({ match: (t232) => {
    let n232 = {};
    const r232 = (t322, e322) => {
      n232[t322] = e322;
    };
    return c2(e232, s2).forEach((t322) => r232(t322, void 0)), { matched: e232.some((e322) => o2(e322, t232, r232)), selections: n232 };
  }, getSelectionKeys: () => c2(e232, s2), matcherType: "or" }) });
}
function y2(e232) {
  return { [t2]: () => ({ match: (t232) => ({ matched: Boolean(e232(t232)) }) }) };
}
function p2(...e232) {
  const r232 = "string" == typeof e232[0] ? e232[0] : void 0, i232 = 2 === e232.length ? e232[1] : "string" == typeof e232[0] ? void 0 : e232[0];
  return u2({ [t2]: () => ({ match: (t232) => {
    let e322 = { [null != r232 ? r232 : n2]: t232 };
    return { matched: void 0 === i232 || o2(i232, t232, (t322, n232) => {
      e322[t322] = n232;
    }), selections: e322 };
  }, getSelectionKeys: () => [null != r232 ? r232 : n2].concat(void 0 === i232 ? [] : s2(i232)) }) });
}
function v2(t232) {
  return "number" == typeof t232;
}
function b2(t232) {
  return "string" == typeof t232;
}
function w2(t232) {
  return "bigint" == typeof t232;
}
var S2 = u2(y2(function(t232) {
  return true;
}));
var O2 = S2;
var j2 = (t232) => Object.assign(u2(t232), { startsWith: (e232) => {
  return j2(m2(t232, (n232 = e232, y2((t322) => b2(t322) && t322.startsWith(n232)))));
  var n232;
}, endsWith: (e232) => {
  return j2(m2(t232, (n232 = e232, y2((t322) => b2(t322) && t322.endsWith(n232)))));
  var n232;
}, minLength: (e232) => j2(m2(t232, ((t322) => y2((e322) => b2(e322) && e322.length >= t322))(e232))), maxLength: (e232) => j2(m2(t232, ((t322) => y2((e322) => b2(e322) && e322.length <= t322))(e232))), includes: (e232) => {
  return j2(m2(t232, (n232 = e232, y2((t322) => b2(t322) && t322.includes(n232)))));
  var n232;
}, regex: (e232) => {
  return j2(m2(t232, (n232 = e232, y2((t322) => b2(t322) && Boolean(t322.match(n232))))));
  var n232;
} });
var E2 = j2(y2(b2));
var K2 = (t232) => Object.assign(u2(t232), { between: (e232, n232) => K2(m2(t232, ((t322, e322) => y2((n322) => v2(n322) && t322 <= n322 && e322 >= n322))(e232, n232))), lt: (e232) => K2(m2(t232, ((t322) => y2((e322) => v2(e322) && e322 < t322))(e232))), gt: (e232) => K2(m2(t232, ((t322) => y2((e322) => v2(e322) && e322 > t322))(e232))), lte: (e232) => K2(m2(t232, ((t322) => y2((e322) => v2(e322) && e322 <= t322))(e232))), gte: (e232) => K2(m2(t232, ((t322) => y2((e322) => v2(e322) && e322 >= t322))(e232))), int: () => K2(m2(t232, y2((t322) => v2(t322) && Number.isInteger(t322)))), finite: () => K2(m2(t232, y2((t322) => v2(t322) && Number.isFinite(t322)))), positive: () => K2(m2(t232, y2((t322) => v2(t322) && t322 > 0))), negative: () => K2(m2(t232, y2((t322) => v2(t322) && t322 < 0))) });
var x2 = K2(y2(v2));
var A2 = (t232) => Object.assign(u2(t232), { between: (e232, n232) => A2(m2(t232, ((t322, e322) => y2((n322) => w2(n322) && t322 <= n322 && e322 >= n322))(e232, n232))), lt: (e232) => A2(m2(t232, ((t322) => y2((e322) => w2(e322) && e322 < t322))(e232))), gt: (e232) => A2(m2(t232, ((t322) => y2((e322) => w2(e322) && e322 > t322))(e232))), lte: (e232) => A2(m2(t232, ((t322) => y2((e322) => w2(e322) && e322 <= t322))(e232))), gte: (e232) => A2(m2(t232, ((t322) => y2((e322) => w2(e322) && e322 >= t322))(e232))), positive: () => A2(m2(t232, y2((t322) => w2(t322) && t322 > 0))), negative: () => A2(m2(t232, y2((t322) => w2(t322) && t322 < 0))) });
var P2 = A2(y2(w2));
var T2 = u2(y2(function(t232) {
  return "boolean" == typeof t232;
}));
var k2 = u2(y2(function(t232) {
  return "symbol" == typeof t232;
}));
var B2 = u2(y2(function(t232) {
  return null == t232;
}));
var _2 = u2(y2(function(t232) {
  return null != t232;
}));
var N2 = { __proto__: null, matcher: t2, optional: l2, array: function(...e232) {
  return h2({ [t2]: () => ({ match: (t232) => {
    if (!Array.isArray(t232)) return { matched: false };
    if (0 === e232.length) return { matched: true };
    const n232 = e232[0];
    let r232 = {};
    if (0 === t232.length) return s2(n232).forEach((t322) => {
      r232[t322] = [];
    }), { matched: true, selections: r232 };
    const i232 = (t322, e322) => {
      r232[t322] = (r232[t322] || []).concat([e322]);
    };
    return { matched: t232.every((t322) => o2(n232, t322, i232)), selections: r232 };
  }, getSelectionKeys: () => 0 === e232.length ? [] : s2(e232[0]) }) });
}, set: function(...e232) {
  return u2({ [t2]: () => ({ match: (t232) => {
    if (!(t232 instanceof Set)) return { matched: false };
    let n232 = {};
    if (0 === t232.size) return { matched: true, selections: n232 };
    if (0 === e232.length) return { matched: true };
    const r232 = (t322, e322) => {
      n232[t322] = (n232[t322] || []).concat([e322]);
    }, i232 = e232[0];
    return { matched: f2(t232, (t322) => o2(i232, t322, r232)), selections: n232 };
  }, getSelectionKeys: () => 0 === e232.length ? [] : s2(e232[0]) }) });
}, map: function(...e232) {
  return u2({ [t2]: () => ({ match: (t232) => {
    if (!(t232 instanceof Map)) return { matched: false };
    let n232 = {};
    if (0 === t232.size) return { matched: true, selections: n232 };
    const r232 = (t322, e322) => {
      n232[t322] = (n232[t322] || []).concat([e322]);
    };
    if (0 === e232.length) return { matched: true };
    var i232;
    if (1 === e232.length) throw new Error(`\`P.map\` wasn't given enough arguments. Expected (key, value), received ${null == (i232 = e232[0]) ? void 0 : i232.toString()}`);
    const [s232, c232] = e232;
    return { matched: g2(t232, (t322, e322) => {
      const n322 = o2(s232, e322, r232), i322 = o2(c232, t322, r232);
      return n322 && i322;
    }), selections: n232 };
  }, getSelectionKeys: () => 0 === e232.length ? [] : [...s2(e232[0]), ...s2(e232[1])] }) });
}, intersection: m2, union: d2, not: function(e232) {
  return u2({ [t2]: () => ({ match: (t232) => ({ matched: !o2(e232, t232, () => {
  }) }), getSelectionKeys: () => [], matcherType: "not" }) });
}, when: y2, select: p2, any: S2, _: O2, string: E2, number: x2, bigint: P2, boolean: T2, symbol: k2, nullish: B2, nonNullable: _2, instanceOf: function(t232) {
  return u2(y2(/* @__PURE__ */ function(t322) {
    return (e232) => e232 instanceof t322;
  }(t232)));
}, shape: function(t232) {
  return u2(y2(a2(t232)));
} };
var KEYS2 = {
  ArrayExpression: [
    "elements"
  ],
  ArrayPattern: [
    "elements"
  ],
  ArrowFunctionExpression: [
    "params",
    "body"
  ],
  AssignmentExpression: [
    "left",
    "right"
  ],
  AssignmentPattern: [
    "left",
    "right"
  ],
  AwaitExpression: [
    "argument"
  ],
  BinaryExpression: [
    "left",
    "right"
  ],
  BlockStatement: [
    "body"
  ],
  BreakStatement: [
    "label"
  ],
  CallExpression: [
    "callee",
    "arguments"
  ],
  CatchClause: [
    "param",
    "body"
  ],
  ChainExpression: [
    "expression"
  ],
  ClassBody: [
    "body"
  ],
  ClassDeclaration: [
    "id",
    "superClass",
    "body"
  ],
  ClassExpression: [
    "id",
    "superClass",
    "body"
  ],
  ConditionalExpression: [
    "test",
    "consequent",
    "alternate"
  ],
  ContinueStatement: [
    "label"
  ],
  DebuggerStatement: [],
  DoWhileStatement: [
    "body",
    "test"
  ],
  EmptyStatement: [],
  ExperimentalRestProperty: [
    "argument"
  ],
  ExperimentalSpreadProperty: [
    "argument"
  ],
  ExportAllDeclaration: [
    "exported",
    "source"
  ],
  ExportDefaultDeclaration: [
    "declaration"
  ],
  ExportNamedDeclaration: [
    "declaration",
    "specifiers",
    "source"
  ],
  ExportSpecifier: [
    "exported",
    "local"
  ],
  ExpressionStatement: [
    "expression"
  ],
  ForInStatement: [
    "left",
    "right",
    "body"
  ],
  ForOfStatement: [
    "left",
    "right",
    "body"
  ],
  ForStatement: [
    "init",
    "test",
    "update",
    "body"
  ],
  FunctionDeclaration: [
    "id",
    "params",
    "body"
  ],
  FunctionExpression: [
    "id",
    "params",
    "body"
  ],
  Identifier: [],
  IfStatement: [
    "test",
    "consequent",
    "alternate"
  ],
  ImportDeclaration: [
    "specifiers",
    "source"
  ],
  ImportDefaultSpecifier: [
    "local"
  ],
  ImportExpression: [
    "source"
  ],
  ImportNamespaceSpecifier: [
    "local"
  ],
  ImportSpecifier: [
    "imported",
    "local"
  ],
  JSXAttribute: [
    "name",
    "value"
  ],
  JSXClosingElement: [
    "name"
  ],
  JSXClosingFragment: [],
  JSXElement: [
    "openingElement",
    "children",
    "closingElement"
  ],
  JSXEmptyExpression: [],
  JSXExpressionContainer: [
    "expression"
  ],
  JSXFragment: [
    "openingFragment",
    "children",
    "closingFragment"
  ],
  JSXIdentifier: [],
  JSXMemberExpression: [
    "object",
    "property"
  ],
  JSXNamespacedName: [
    "namespace",
    "name"
  ],
  JSXOpeningElement: [
    "name",
    "attributes"
  ],
  JSXOpeningFragment: [],
  JSXSpreadAttribute: [
    "argument"
  ],
  JSXSpreadChild: [
    "expression"
  ],
  JSXText: [],
  LabeledStatement: [
    "label",
    "body"
  ],
  Literal: [],
  LogicalExpression: [
    "left",
    "right"
  ],
  MemberExpression: [
    "object",
    "property"
  ],
  MetaProperty: [
    "meta",
    "property"
  ],
  MethodDefinition: [
    "key",
    "value"
  ],
  NewExpression: [
    "callee",
    "arguments"
  ],
  ObjectExpression: [
    "properties"
  ],
  ObjectPattern: [
    "properties"
  ],
  PrivateIdentifier: [],
  Program: [
    "body"
  ],
  Property: [
    "key",
    "value"
  ],
  PropertyDefinition: [
    "key",
    "value"
  ],
  RestElement: [
    "argument"
  ],
  ReturnStatement: [
    "argument"
  ],
  SequenceExpression: [
    "expressions"
  ],
  SpreadElement: [
    "argument"
  ],
  StaticBlock: [
    "body"
  ],
  Super: [],
  SwitchCase: [
    "test",
    "consequent"
  ],
  SwitchStatement: [
    "discriminant",
    "cases"
  ],
  TaggedTemplateExpression: [
    "tag",
    "quasi"
  ],
  TemplateElement: [],
  TemplateLiteral: [
    "quasis",
    "expressions"
  ],
  ThisExpression: [],
  ThrowStatement: [
    "argument"
  ],
  TryStatement: [
    "block",
    "handler",
    "finalizer"
  ],
  UnaryExpression: [
    "argument"
  ],
  UpdateExpression: [
    "argument"
  ],
  VariableDeclaration: [
    "declarations"
  ],
  VariableDeclarator: [
    "id",
    "init"
  ],
  WhileStatement: [
    "test",
    "body"
  ],
  WithStatement: [
    "object",
    "body"
  ],
  YieldExpression: [
    "argument"
  ]
};
var NODE_TYPES2 = Object.keys(KEYS2);
for (const type of NODE_TYPES2) {
  Object.freeze(KEYS2[type]);
}
Object.freeze(KEYS2);
var visitor_keys_default2 = KEYS2;
var KEY_BLACKLIST2 = /* @__PURE__ */ new Set([
  "parent",
  "leadingComments",
  "trailingComments"
]);
function filterKey2(key) {
  return !KEY_BLACKLIST2.has(key) && key[0] !== "_";
}
function getKeys2(node) {
  return Object.keys(node).filter(filterKey2);
}
function getInnermostScope2(initialScope, node) {
  const location = node.range[0];
  let scope = initialScope;
  let found = false;
  do {
    found = false;
    for (const childScope of scope.childScopes) {
      const range222 = childScope.block.range;
      if (range222[0] <= location && location < range222[1]) {
        scope = childScope;
        found = true;
        break;
      }
    }
  } while (found);
  return scope;
}
function findVariable22(initialScope, nameOrNode) {
  let name22 = "";
  let scope = initialScope;
  if (typeof nameOrNode === "string") {
    name22 = nameOrNode;
  } else {
    name22 = nameOrNode.name;
    scope = getInnermostScope2(scope, nameOrNode);
  }
  while (scope != null) {
    const variable = scope.set.get(name22);
    if (variable != null) {
      return variable;
    }
    scope = scope.upper;
  }
  return null;
}
function negate02(token) {
  return !this(token);
}
function negate2(f232) {
  return negate02.bind(f232);
}
function isPunctuatorTokenWithValue2(token, value) {
  return token.type === "Punctuator" && token.value === value;
}
function isArrowToken2(token) {
  return isPunctuatorTokenWithValue2(token, "=>");
}
function isCommaToken2(token) {
  return isPunctuatorTokenWithValue2(token, ",");
}
function isSemicolonToken2(token) {
  return isPunctuatorTokenWithValue2(token, ";");
}
function isColonToken2(token) {
  return isPunctuatorTokenWithValue2(token, ":");
}
function isOpeningParenToken2(token) {
  return isPunctuatorTokenWithValue2(token, "(");
}
function isClosingParenToken2(token) {
  return isPunctuatorTokenWithValue2(token, ")");
}
function isOpeningBracketToken2(token) {
  return isPunctuatorTokenWithValue2(token, "[");
}
function isClosingBracketToken2(token) {
  return isPunctuatorTokenWithValue2(token, "]");
}
function isOpeningBraceToken2(token) {
  return isPunctuatorTokenWithValue2(token, "{");
}
function isClosingBraceToken2(token) {
  return isPunctuatorTokenWithValue2(token, "}");
}
function isCommentToken2(token) {
  return ["Block", "Line", "Shebang"].includes(token.type);
}
negate2(isArrowToken2);
negate2(isCommaToken2);
negate2(isSemicolonToken2);
negate2(isColonToken2);
negate2(isOpeningParenToken2);
negate2(isClosingParenToken2);
negate2(isOpeningBracketToken2);
negate2(isClosingBracketToken2);
negate2(isOpeningBraceToken2);
negate2(isClosingBraceToken2);
negate2(isCommentToken2);
function getOpeningParenOfParams2(node, sourceCode) {
  return node.id ? sourceCode.getTokenAfter(node.id, isOpeningParenToken2) : sourceCode.getFirstToken(node, isOpeningParenToken2);
}
function getFunctionHeadLocation2(node, sourceCode) {
  const parent = node.parent;
  let start = null;
  let end = null;
  if (node.type === "ArrowFunctionExpression") {
    const arrowToken = sourceCode.getTokenBefore(node.body, isArrowToken2);
    start = arrowToken.loc.start;
    end = arrowToken.loc.end;
  } else if (parent.type === "Property" || parent.type === "MethodDefinition" || parent.type === "PropertyDefinition") {
    start = parent.loc.start;
    end = getOpeningParenOfParams2(node, sourceCode).loc.start;
  } else {
    start = node.loc.start;
    end = getOpeningParenOfParams2(node, sourceCode).loc.start;
  }
  return {
    start: { ...start },
    end: { ...end }
  };
}
var globalObject2 = typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {};
var builtinNames2 = Object.freeze(
  /* @__PURE__ */ new Set([
    "Array",
    "ArrayBuffer",
    "BigInt",
    "BigInt64Array",
    "BigUint64Array",
    "Boolean",
    "DataView",
    "Date",
    "decodeURI",
    "decodeURIComponent",
    "encodeURI",
    "encodeURIComponent",
    "escape",
    "Float32Array",
    "Float64Array",
    "Function",
    "Infinity",
    "Int16Array",
    "Int32Array",
    "Int8Array",
    "isFinite",
    "isNaN",
    "isPrototypeOf",
    "JSON",
    "Map",
    "Math",
    "NaN",
    "Number",
    "Object",
    "parseFloat",
    "parseInt",
    "Promise",
    "Proxy",
    "Reflect",
    "RegExp",
    "Set",
    "String",
    "Symbol",
    "Uint16Array",
    "Uint32Array",
    "Uint8Array",
    "Uint8ClampedArray",
    "undefined",
    "unescape",
    "WeakMap",
    "WeakSet"
  ])
);
var callAllowed2 = new Set(
  [
    Array.isArray,
    Array.of,
    Array.prototype.at,
    Array.prototype.concat,
    Array.prototype.entries,
    Array.prototype.every,
    Array.prototype.filter,
    Array.prototype.find,
    Array.prototype.findIndex,
    Array.prototype.flat,
    Array.prototype.includes,
    Array.prototype.indexOf,
    Array.prototype.join,
    Array.prototype.keys,
    Array.prototype.lastIndexOf,
    Array.prototype.slice,
    Array.prototype.some,
    Array.prototype.toString,
    Array.prototype.values,
    typeof BigInt === "function" ? BigInt : void 0,
    Boolean,
    Date,
    Date.parse,
    decodeURI,
    decodeURIComponent,
    encodeURI,
    encodeURIComponent,
    escape,
    isFinite,
    isNaN,
    isPrototypeOf,
    Map,
    Map.prototype.entries,
    Map.prototype.get,
    Map.prototype.has,
    Map.prototype.keys,
    Map.prototype.values,
    ...Object.getOwnPropertyNames(Math).filter((k232) => k232 !== "random").map((k232) => Math[k232]).filter((f232) => typeof f232 === "function"),
    Number,
    Number.isFinite,
    Number.isNaN,
    Number.parseFloat,
    Number.parseInt,
    Number.prototype.toExponential,
    Number.prototype.toFixed,
    Number.prototype.toPrecision,
    Number.prototype.toString,
    Object,
    Object.entries,
    Object.is,
    Object.isExtensible,
    Object.isFrozen,
    Object.isSealed,
    Object.keys,
    Object.values,
    parseFloat,
    parseInt,
    RegExp,
    Set,
    Set.prototype.entries,
    Set.prototype.has,
    Set.prototype.keys,
    Set.prototype.values,
    String,
    String.fromCharCode,
    String.fromCodePoint,
    String.raw,
    String.prototype.at,
    String.prototype.charAt,
    String.prototype.charCodeAt,
    String.prototype.codePointAt,
    String.prototype.concat,
    String.prototype.endsWith,
    String.prototype.includes,
    String.prototype.indexOf,
    String.prototype.lastIndexOf,
    String.prototype.normalize,
    String.prototype.padEnd,
    String.prototype.padStart,
    String.prototype.slice,
    String.prototype.startsWith,
    String.prototype.substr,
    String.prototype.substring,
    String.prototype.toLowerCase,
    String.prototype.toString,
    String.prototype.toUpperCase,
    String.prototype.trim,
    String.prototype.trimEnd,
    String.prototype.trimLeft,
    String.prototype.trimRight,
    String.prototype.trimStart,
    Symbol.for,
    Symbol.keyFor,
    unescape
  ].filter((f232) => typeof f232 === "function")
);
var callPassThrough2 = /* @__PURE__ */ new Set([
  Object.freeze,
  Object.preventExtensions,
  Object.seal
]);
var getterAllowed2 = [
  [Map, /* @__PURE__ */ new Set(["size"])],
  [
    RegExp,
    /* @__PURE__ */ new Set([
      "dotAll",
      "flags",
      "global",
      "hasIndices",
      "ignoreCase",
      "multiline",
      "source",
      "sticky",
      "unicode"
    ])
  ],
  [Set, /* @__PURE__ */ new Set(["size"])]
];
function getPropertyDescriptor2(object32, name22) {
  let x232 = object32;
  while ((typeof x232 === "object" || typeof x232 === "function") && x232 !== null) {
    const d232 = Object.getOwnPropertyDescriptor(x232, name22);
    if (d232) {
      return d232;
    }
    x232 = Object.getPrototypeOf(x232);
  }
  return null;
}
function isGetter2(object32, name22) {
  const d232 = getPropertyDescriptor2(object32, name22);
  return d232 != null && d232.get != null;
}
function getElementValues2(nodeList, initialScope) {
  const valueList = [];
  for (let i232 = 0; i232 < nodeList.length; ++i232) {
    const elementNode = nodeList[i232];
    if (elementNode == null) {
      valueList.length = i232 + 1;
    } else if (elementNode.type === "SpreadElement") {
      const argument = getStaticValueR2(elementNode.argument, initialScope);
      if (argument == null) {
        return null;
      }
      valueList.push(...argument.value);
    } else {
      const element = getStaticValueR2(elementNode, initialScope);
      if (element == null) {
        return null;
      }
      valueList.push(element.value);
    }
  }
  return valueList;
}
function isEffectivelyConst2(variable) {
  const refs = variable.references;
  const inits = refs.filter((r232) => r232.init).length;
  const reads = refs.filter((r232) => r232.isReadOnly()).length;
  if (inits === 1 && reads + inits === refs.length) {
    return true;
  }
  return false;
}
var operations2 = Object.freeze({
  ArrayExpression(node, initialScope) {
    const elements = getElementValues2(node.elements, initialScope);
    return elements != null ? { value: elements } : null;
  },
  AssignmentExpression(node, initialScope) {
    if (node.operator === "=") {
      return getStaticValueR2(node.right, initialScope);
    }
    return null;
  },
  //eslint-disable-next-line complexity
  BinaryExpression(node, initialScope) {
    if (node.operator === "in" || node.operator === "instanceof") {
      return null;
    }
    const left3232 = getStaticValueR2(node.left, initialScope);
    const right3232 = getStaticValueR2(node.right, initialScope);
    if (left3232 != null && right3232 != null) {
      switch (node.operator) {
        case "==":
          return { value: left3232.value == right3232.value };
        case "!=":
          return { value: left3232.value != right3232.value };
        case "===":
          return { value: left3232.value === right3232.value };
        case "!==":
          return { value: left3232.value !== right3232.value };
        case "<":
          return { value: left3232.value < right3232.value };
        case "<=":
          return { value: left3232.value <= right3232.value };
        case ">":
          return { value: left3232.value > right3232.value };
        case ">=":
          return { value: left3232.value >= right3232.value };
        case "<<":
          return { value: left3232.value << right3232.value };
        case ">>":
          return { value: left3232.value >> right3232.value };
        case ">>>":
          return { value: left3232.value >>> right3232.value };
        case "+":
          return { value: left3232.value + right3232.value };
        case "-":
          return { value: left3232.value - right3232.value };
        case "*":
          return { value: left3232.value * right3232.value };
        case "/":
          return { value: left3232.value / right3232.value };
        case "%":
          return { value: left3232.value % right3232.value };
        case "**":
          return { value: left3232.value ** right3232.value };
        case "|":
          return { value: left3232.value | right3232.value };
        case "^":
          return { value: left3232.value ^ right3232.value };
        case "&":
          return { value: left3232.value & right3232.value };
      }
    }
    return null;
  },
  CallExpression(node, initialScope) {
    const calleeNode = node.callee;
    const args = getElementValues2(node.arguments, initialScope);
    if (args != null) {
      if (calleeNode.type === "MemberExpression") {
        if (calleeNode.property.type === "PrivateIdentifier") {
          return null;
        }
        const object32 = getStaticValueR2(calleeNode.object, initialScope);
        if (object32 != null) {
          if (object32.value == null && (object32.optional || node.optional)) {
            return { value: void 0, optional: true };
          }
          const property = getStaticPropertyNameValue2(
            calleeNode,
            initialScope
          );
          if (property != null) {
            const receiver = object32.value;
            const methodName = property.value;
            if (callAllowed2.has(receiver[methodName])) {
              return { value: receiver[methodName](...args) };
            }
            if (callPassThrough2.has(receiver[methodName])) {
              return { value: args[0] };
            }
          }
        }
      } else {
        const callee = getStaticValueR2(calleeNode, initialScope);
        if (callee != null) {
          if (callee.value == null && node.optional) {
            return { value: void 0, optional: true };
          }
          const func = callee.value;
          if (callAllowed2.has(func)) {
            return { value: func(...args) };
          }
          if (callPassThrough2.has(func)) {
            return { value: args[0] };
          }
        }
      }
    }
    return null;
  },
  ConditionalExpression(node, initialScope) {
    const test = getStaticValueR2(node.test, initialScope);
    if (test != null) {
      return test.value ? getStaticValueR2(node.consequent, initialScope) : getStaticValueR2(node.alternate, initialScope);
    }
    return null;
  },
  ExpressionStatement(node, initialScope) {
    return getStaticValueR2(node.expression, initialScope);
  },
  Identifier(node, initialScope) {
    if (initialScope != null) {
      const variable = findVariable22(initialScope, node);
      if (variable != null && variable.defs.length === 0 && builtinNames2.has(variable.name) && variable.name in globalObject2) {
        return { value: globalObject2[variable.name] };
      }
      if (variable != null && variable.defs.length === 1) {
        const def = variable.defs[0];
        if (def.parent && def.type === "Variable" && (def.parent.kind === "const" || isEffectivelyConst2(variable)) && // TODO(mysticatea): don't support destructuring here.
        def.node.id.type === "Identifier") {
          return getStaticValueR2(def.node.init, initialScope);
        }
      }
    }
    return null;
  },
  Literal(node) {
    if ((node.regex != null || node.bigint != null) && node.value == null) {
      return null;
    }
    return { value: node.value };
  },
  LogicalExpression(node, initialScope) {
    const left3232 = getStaticValueR2(node.left, initialScope);
    if (left3232 != null) {
      if (node.operator === "||" && Boolean(left3232.value) === true || node.operator === "&&" && Boolean(left3232.value) === false || node.operator === "??" && left3232.value != null) {
        return left3232;
      }
      const right3232 = getStaticValueR2(node.right, initialScope);
      if (right3232 != null) {
        return right3232;
      }
    }
    return null;
  },
  MemberExpression(node, initialScope) {
    if (node.property.type === "PrivateIdentifier") {
      return null;
    }
    const object32 = getStaticValueR2(node.object, initialScope);
    if (object32 != null) {
      if (object32.value == null && (object32.optional || node.optional)) {
        return { value: void 0, optional: true };
      }
      const property = getStaticPropertyNameValue2(node, initialScope);
      if (property != null) {
        if (!isGetter2(object32.value, property.value)) {
          return { value: object32.value[property.value] };
        }
        for (const [classFn, allowed] of getterAllowed2) {
          if (object32.value instanceof classFn && allowed.has(property.value)) {
            return { value: object32.value[property.value] };
          }
        }
      }
    }
    return null;
  },
  ChainExpression(node, initialScope) {
    const expression = getStaticValueR2(node.expression, initialScope);
    if (expression != null) {
      return { value: expression.value };
    }
    return null;
  },
  NewExpression(node, initialScope) {
    const callee = getStaticValueR2(node.callee, initialScope);
    const args = getElementValues2(node.arguments, initialScope);
    if (callee != null && args != null) {
      const Func = callee.value;
      if (callAllowed2.has(Func)) {
        return { value: new Func(...args) };
      }
    }
    return null;
  },
  ObjectExpression(node, initialScope) {
    const object32 = {};
    for (const propertyNode of node.properties) {
      if (propertyNode.type === "Property") {
        if (propertyNode.kind !== "init") {
          return null;
        }
        const key = getStaticPropertyNameValue2(
          propertyNode,
          initialScope
        );
        const value = getStaticValueR2(propertyNode.value, initialScope);
        if (key == null || value == null) {
          return null;
        }
        object32[key.value] = value.value;
      } else if (propertyNode.type === "SpreadElement" || propertyNode.type === "ExperimentalSpreadProperty") {
        const argument = getStaticValueR2(
          propertyNode.argument,
          initialScope
        );
        if (argument == null) {
          return null;
        }
        Object.assign(object32, argument.value);
      } else {
        return null;
      }
    }
    return { value: object32 };
  },
  SequenceExpression(node, initialScope) {
    const last222 = node.expressions[node.expressions.length - 1];
    return getStaticValueR2(last222, initialScope);
  },
  TaggedTemplateExpression(node, initialScope) {
    const tag = getStaticValueR2(node.tag, initialScope);
    const expressions = getElementValues2(
      node.quasi.expressions,
      initialScope
    );
    if (tag != null && expressions != null) {
      const func = tag.value;
      const strings = node.quasi.quasis.map((q) => q.value.cooked);
      strings.raw = node.quasi.quasis.map((q) => q.value.raw);
      if (func === String.raw) {
        return { value: func(strings, ...expressions) };
      }
    }
    return null;
  },
  TemplateLiteral(node, initialScope) {
    const expressions = getElementValues2(node.expressions, initialScope);
    if (expressions != null) {
      let value = node.quasis[0].value.cooked;
      for (let i232 = 0; i232 < expressions.length; ++i232) {
        value += expressions[i232];
        value += node.quasis[i232 + 1].value.cooked;
      }
      return { value };
    }
    return null;
  },
  UnaryExpression(node, initialScope) {
    if (node.operator === "delete") {
      return null;
    }
    if (node.operator === "void") {
      return { value: void 0 };
    }
    const arg = getStaticValueR2(node.argument, initialScope);
    if (arg != null) {
      switch (node.operator) {
        case "-":
          return { value: -arg.value };
        case "+":
          return { value: +arg.value };
        case "!":
          return { value: !arg.value };
        case "~":
          return { value: ~arg.value };
        case "typeof":
          return { value: typeof arg.value };
      }
    }
    return null;
  }
});
function getStaticValueR2(node, initialScope) {
  if (node != null && Object.hasOwnProperty.call(operations2, node.type)) {
    return operations2[node.type](node, initialScope);
  }
  return null;
}
function getStaticPropertyNameValue2(node, initialScope) {
  const nameNode = node.type === "Property" ? node.key : node.property;
  if (node.computed) {
    return getStaticValueR2(nameNode, initialScope);
  }
  if (nameNode.type === "Identifier") {
    return { value: nameNode.name };
  }
  if (nameNode.type === "Literal") {
    if (nameNode.bigint) {
      return { value: nameNode.bigint };
    }
    return { value: String(nameNode.value) };
  }
  return null;
}
function getStaticValue2(node, initialScope = null) {
  try {
    return getStaticValueR2(node, initialScope);
  } catch (_error) {
    return null;
  }
}
function getStringIfConstant2(node, initialScope = null) {
  if (node && node.type === "Literal" && node.value === null) {
    if (node.regex) {
      return `/${node.regex.pattern}/${node.regex.flags}`;
    }
    if (node.bigint) {
      return node.bigint;
    }
  }
  const evaluated = getStaticValue2(node, initialScope);
  return evaluated && String(evaluated.value);
}
function getPropertyName2(node, initialScope) {
  switch (node.type) {
    case "MemberExpression":
      if (node.computed) {
        return getStringIfConstant2(node.property, initialScope);
      }
      if (node.property.type === "PrivateIdentifier") {
        return null;
      }
      return node.property.name;
    case "Property":
    case "MethodDefinition":
    case "PropertyDefinition":
      if (node.computed) {
        return getStringIfConstant2(node.key, initialScope);
      }
      if (node.key.type === "Literal") {
        return String(node.key.value);
      }
      if (node.key.type === "PrivateIdentifier") {
        return null;
      }
      return node.key.name;
  }
  return null;
}
function getFunctionNameWithKind2(node, sourceCode) {
  const parent = node.parent;
  const tokens = [];
  const isObjectMethod = parent.type === "Property" && parent.value === node;
  const isClassMethod = parent.type === "MethodDefinition" && parent.value === node;
  const isClassFieldMethod = parent.type === "PropertyDefinition" && parent.value === node;
  if (isClassMethod || isClassFieldMethod) {
    if (parent.static) {
      tokens.push("static");
    }
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push("private");
    }
  }
  if (node.async) {
    tokens.push("async");
  }
  if (node.generator) {
    tokens.push("generator");
  }
  if (isObjectMethod || isClassMethod) {
    if (parent.kind === "constructor") {
      return "constructor";
    }
    if (parent.kind === "get") {
      tokens.push("getter");
    } else if (parent.kind === "set") {
      tokens.push("setter");
    } else {
      tokens.push("method");
    }
  } else if (isClassFieldMethod) {
    tokens.push("method");
  } else {
    if (node.type === "ArrowFunctionExpression") {
      tokens.push("arrow");
    }
    tokens.push("function");
  }
  if (isObjectMethod || isClassMethod || isClassFieldMethod) {
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push(`#${parent.key.name}`);
    } else {
      const name22 = getPropertyName2(parent);
      if (name22) {
        tokens.push(`'${name22}'`);
      } else if (sourceCode) {
        const keyText = sourceCode.getText(parent.key);
        if (!keyText.includes("\n")) {
          tokens.push(`[${keyText}]`);
        }
      }
    }
  } else if (node.id) {
    tokens.push(`'${node.id.name}'`);
  } else if (parent.type === "VariableDeclarator" && parent.id && parent.id.type === "Identifier") {
    tokens.push(`'${parent.id.name}'`);
  } else if ((parent.type === "AssignmentExpression" || parent.type === "AssignmentPattern") && parent.left && parent.left.type === "Identifier") {
    tokens.push(`'${parent.left.name}'`);
  } else if (parent.type === "ExportDefaultDeclaration" && parent.declaration === node) {
    tokens.push("'default'");
  }
  return tokens.join(" ");
}
var typeConversionBinaryOps2 = Object.freeze(
  /* @__PURE__ */ new Set([
    "==",
    "!=",
    "<",
    "<=",
    ">",
    ">=",
    "<<",
    ">>",
    ">>>",
    "+",
    "-",
    "*",
    "/",
    "%",
    "|",
    "^",
    "&",
    "in"
  ])
);
var typeConversionUnaryOps2 = Object.freeze(/* @__PURE__ */ new Set(["-", "+", "!", "~"]));
function isNode2(x232) {
  return x232 !== null && typeof x232 === "object" && typeof x232.type === "string";
}
var visitor2 = Object.freeze(
  Object.assign(/* @__PURE__ */ Object.create(null), {
    $visit(node, options, visitorKeys) {
      const { type } = node;
      if (typeof this[type] === "function") {
        return this[type](node, options, visitorKeys);
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    $visitChildren(node, options, visitorKeys) {
      const { type } = node;
      for (const key of visitorKeys[type] || getKeys2(node)) {
        const value = node[key];
        if (Array.isArray(value)) {
          for (const element of value) {
            if (isNode2(element) && this.$visit(element, options, visitorKeys)) {
              return true;
            }
          }
        } else if (isNode2(value) && this.$visit(value, options, visitorKeys)) {
          return true;
        }
      }
      return false;
    },
    ArrowFunctionExpression() {
      return false;
    },
    AssignmentExpression() {
      return true;
    },
    AwaitExpression() {
      return true;
    },
    BinaryExpression(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && typeConversionBinaryOps2.has(node.operator) && (node.left.type !== "Literal" || node.right.type !== "Literal")) {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    CallExpression() {
      return true;
    },
    FunctionExpression() {
      return false;
    },
    ImportExpression() {
      return true;
    },
    MemberExpression(node, options, visitorKeys) {
      if (options.considerGetters) {
        return true;
      }
      if (options.considerImplicitTypeConversion && node.computed && node.property.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    MethodDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    NewExpression() {
      return true;
    },
    Property(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    PropertyDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UnaryExpression(node, options, visitorKeys) {
      if (node.operator === "delete") {
        return true;
      }
      if (options.considerImplicitTypeConversion && typeConversionUnaryOps2.has(node.operator) && node.argument.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UpdateExpression() {
      return true;
    },
    YieldExpression() {
      return true;
    }
  })
);
function hasSideEffect2(node, sourceCode, { considerGetters = false, considerImplicitTypeConversion = false } = {}) {
  return visitor2.$visit(
    node,
    { considerGetters, considerImplicitTypeConversion },
    sourceCode.visitorKeys || visitor_keys_default2
  );
}
function getParentSyntaxParen2(node, sourceCode) {
  const parent = node.parent;
  switch (parent.type) {
    case "CallExpression":
    case "NewExpression":
      if (parent.arguments.length === 1 && parent.arguments[0] === node) {
        return sourceCode.getTokenAfter(
          parent.callee,
          isOpeningParenToken2
        );
      }
      return null;
    case "DoWhileStatement":
      if (parent.test === node) {
        return sourceCode.getTokenAfter(
          parent.body,
          isOpeningParenToken2
        );
      }
      return null;
    case "IfStatement":
    case "WhileStatement":
      if (parent.test === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "ImportExpression":
      if (parent.source === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "SwitchStatement":
      if (parent.discriminant === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "WithStatement":
      if (parent.object === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    default:
      return null;
  }
}
function isParenthesized2(timesOrNode, nodeOrSourceCode, optionalSourceCode) {
  let times, node, sourceCode, maybeLeftParen, maybeRightParen;
  if (typeof timesOrNode === "number") {
    times = timesOrNode | 0;
    node = nodeOrSourceCode;
    sourceCode = optionalSourceCode;
    if (!(times >= 1)) {
      throw new TypeError("'times' should be a positive integer.");
    }
  } else {
    times = 1;
    node = timesOrNode;
    sourceCode = nodeOrSourceCode;
  }
  if (node == null || // `Program` can't be parenthesized
  node.parent == null || // `CatchClause.param` can't be parenthesized, example `try {} catch (error) {}`
  node.parent.type === "CatchClause" && node.parent.param === node) {
    return false;
  }
  maybeLeftParen = maybeRightParen = node;
  do {
    maybeLeftParen = sourceCode.getTokenBefore(maybeLeftParen);
    maybeRightParen = sourceCode.getTokenAfter(maybeRightParen);
  } while (maybeLeftParen != null && maybeRightParen != null && isOpeningParenToken2(maybeLeftParen) && isClosingParenToken2(maybeRightParen) && // Avoid false positive such as `if (a) {}`
  maybeLeftParen !== getParentSyntaxParen2(node, sourceCode) && --times > 0);
  return times === 0;
}
Function.call.bind(Object.hasOwnProperty);
var __defProp2222 = Object.defineProperty;
var __export2222 = (target, all3232) => {
  for (var name22 in all3232)
    __defProp2222(target, name22, { get: all3232[name22], enumerable: true });
};
var NodeType2 = types.AST_NODE_TYPES;
var is2 = utils.ASTUtils.isNodeOfType;
var isOneOf2 = utils.ASTUtils.isNodeOfTypes;
isOneOf2([
  NodeType2.ArrowFunctionExpression,
  NodeType2.FunctionDeclaration,
  NodeType2.FunctionExpression
]);
isOneOf2([
  NodeType2.ArrowFunctionExpression,
  NodeType2.FunctionDeclaration,
  NodeType2.FunctionExpression,
  NodeType2.TSCallSignatureDeclaration,
  NodeType2.TSConstructSignatureDeclaration,
  NodeType2.TSDeclareFunction,
  NodeType2.TSEmptyBodyFunctionExpression,
  NodeType2.TSFunctionType,
  NodeType2.TSMethodSignature
]);
isOneOf2([NodeType2.ClassDeclaration, NodeType2.ClassExpression]);
isOneOf2([
  NodeType2.DoWhileStatement,
  NodeType2.ForInStatement,
  NodeType2.ForOfStatement,
  NodeType2.ForStatement,
  NodeType2.WhileStatement
]);
isOneOf2([NodeType2.TSArrayType, NodeType2.TSTupleType]);
isOneOf2([
  NodeType2.PropertyDefinition,
  NodeType2.TSIndexSignature,
  NodeType2.TSParameterProperty,
  NodeType2.TSPropertySignature
]);
is2(NodeType2.JSXElement);
is2(NodeType2.JSXFragment);
isOneOf2([
  NodeType2.JSXAttribute,
  NodeType2.JSXSpreadChild,
  NodeType2.JSXClosingElement,
  NodeType2.JSXClosingFragment,
  NodeType2.JSXElement,
  NodeType2.JSXEmptyExpression,
  NodeType2.JSXExpressionContainer,
  NodeType2.JSXFragment,
  NodeType2.JSXIdentifier,
  NodeType2.JSXMemberExpression,
  NodeType2.JSXNamespacedName,
  NodeType2.JSXOpeningElement,
  NodeType2.JSXOpeningFragment,
  NodeType2.JSXSpreadAttribute,
  NodeType2.JSXSpreadChild,
  NodeType2.JSXText
]);
isOneOf2([
  NodeType2.JSXIdentifier,
  NodeType2.JSXMemberExpression,
  NodeType2.JSXNamespacedName
]);
isOneOf2([
  NodeType2.ArrayPattern,
  NodeType2.AssignmentPattern,
  NodeType2.ObjectPattern,
  NodeType2.RestElement
]);
isOneOf2([
  NodeType2.TSInterfaceDeclaration,
  NodeType2.TSTypeAliasDeclaration
]);
isOneOf2([
  NodeType2.ArrayExpression,
  NodeType2.ArrayPattern,
  NodeType2.ArrowFunctionExpression,
  NodeType2.CallExpression,
  NodeType2.ClassExpression,
  NodeType2.FunctionExpression,
  NodeType2.Identifier,
  NodeType2.JSXElement,
  NodeType2.JSXFragment,
  NodeType2.Literal,
  NodeType2.TemplateLiteral,
  NodeType2.MemberExpression,
  NodeType2.MetaProperty,
  NodeType2.ObjectExpression,
  NodeType2.ObjectPattern,
  NodeType2.SequenceExpression,
  NodeType2.Super,
  NodeType2.TaggedTemplateExpression,
  NodeType2.ThisExpression
]);
isOneOf2([
  NodeType2.ArrayExpression,
  NodeType2.ArrayPattern,
  NodeType2.ArrowFunctionExpression,
  NodeType2.CallExpression,
  NodeType2.ClassExpression,
  NodeType2.FunctionExpression,
  NodeType2.Identifier,
  NodeType2.JSXElement,
  NodeType2.JSXFragment,
  NodeType2.Literal,
  NodeType2.TemplateLiteral,
  NodeType2.MemberExpression,
  NodeType2.MetaProperty,
  NodeType2.ObjectExpression,
  NodeType2.ObjectPattern,
  NodeType2.SequenceExpression,
  NodeType2.Super,
  NodeType2.TaggedTemplateExpression,
  NodeType2.ThisExpression,
  NodeType2.TSAsExpression,
  NodeType2.TSNonNullExpression,
  NodeType2.TSTypeAssertion
]);
var Function_exports22 = {};
__export2222(Function_exports22, {
  SK: () => SK22,
  absurd: () => absurd22,
  apply: () => apply22,
  compose: () => compose22,
  constFalse: () => constFalse22,
  constNull: () => constNull22,
  constTrue: () => constTrue22,
  constUndefined: () => constUndefined22,
  constVoid: () => constVoid22,
  constant: () => constant22,
  dual: () => dual22,
  flip: () => flip22,
  flow: () => flow22,
  hole: () => hole22,
  identity: () => identity22,
  isFunction: () => isFunction222,
  pipe: () => pipe22,
  satisfies: () => satisfies22,
  tupled: () => tupled22,
  unsafeCoerce: () => unsafeCoerce22,
  untupled: () => untupled22
});
var isFunction222 = (input) => typeof input === "function";
var dual22 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a232, b232) {
        if (arguments.length >= 2) {
          return body(a232, b232);
        }
        return function(self2) {
          return body(self2, a232);
        };
      };
    case 3:
      return function(a232, b232, c232) {
        if (arguments.length >= 3) {
          return body(a232, b232, c232);
        }
        return function(self2) {
          return body(self2, a232, b232);
        };
      };
    case 4:
      return function(a232, b232, c232, d232) {
        if (arguments.length >= 4) {
          return body(a232, b232, c232, d232);
        }
        return function(self2) {
          return body(self2, a232, b232, c232);
        };
      };
    case 5:
      return function(a232, b232, c232, d232, e232) {
        if (arguments.length >= 5) {
          return body(a232, b232, c232, d232, e232);
        }
        return function(self2) {
          return body(self2, a232, b232, c232, d232);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply22 = (a232) => (self2) => self2(a232);
var identity22 = (a232) => a232;
var satisfies22 = () => (b232) => b232;
var unsafeCoerce22 = identity22;
var constant22 = (value) => () => value;
var constTrue22 = /* @__PURE__ */ constant22(true);
var constFalse22 = /* @__PURE__ */ constant22(false);
var constNull22 = /* @__PURE__ */ constant22(null);
var constUndefined22 = /* @__PURE__ */ constant22(void 0);
var constVoid22 = constUndefined22;
var flip22 = (f232) => (...b232) => (...a232) => f232(...a232)(...b232);
var compose22 = /* @__PURE__ */ dual22(2, (ab, bc) => (a232) => bc(ab(a232)));
var absurd22 = (_232) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled22 = (f232) => (a232) => f232(...a232);
var untupled22 = (f232) => (...a232) => f232(a232);
function pipe22(a232, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a232;
    case 2:
      return ab(a232);
    case 3:
      return bc(ab(a232));
    case 4:
      return cd(bc(ab(a232)));
    case 5:
      return de(cd(bc(ab(a232))));
    case 6:
      return ef(de(cd(bc(ab(a232)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a232))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a232)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a232))))))));
    default: {
      let ret = arguments[0];
      for (let i232 = 1; i232 < arguments.length; i232++) {
        ret = arguments[i232](ret);
      }
      return ret;
    }
  }
}
function flow22(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole22 = /* @__PURE__ */ unsafeCoerce22(absurd22);
var SK22 = (_232, b232) => b232;
var make42 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_32 = (map632) => dual22(3, (self2, name22, f232) => map632(self2, (a232) => Object.assign({}, a232, {
  [name22]: f232(a232)
})));
var bindTo32 = (map632) => dual22(2, (self2, name22) => map632(self2, (a232) => ({
  [name22]: a232
})));
var bind32 = (map632, flatMap4222) => dual22(3, (self2, name22, f232) => flatMap4222(self2, (a232) => map632(f232(a232), (b232) => Object.assign({}, a232, {
  [name22]: b232
}))));
var moduleVersion22 = "3.2.8";
var getCurrentVersion22 = () => moduleVersion22;
var globalStoreId22 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion22()}`);
if (!(globalStoreId22 in globalThis)) {
  globalThis[globalStoreId22] = /* @__PURE__ */ new Map();
}
var globalStore22 = globalThis[globalStoreId22];
var globalValue22 = (id, compute) => {
  if (!globalStore22.has(id)) {
    globalStore22.set(id, compute());
  }
  return globalStore22.get(id);
};
var Predicate_exports22 = {};
__export2222(Predicate_exports22, {
  all: () => all22,
  and: () => and3,
  compose: () => compose222,
  eqv: () => eqv3,
  every: () => every4,
  hasProperty: () => hasProperty22,
  implies: () => implies3,
  isBigInt: () => isBigInt3,
  isBoolean: () => isBoolean3,
  isDate: () => isDate3,
  isError: () => isError3,
  isFunction: () => isFunction32,
  isIterable: () => isIterable3,
  isMap: () => isMap3,
  isNever: () => isNever3,
  isNotNull: () => isNotNull3,
  isNotNullable: () => isNotNullable3,
  isNotUndefined: () => isNotUndefined3,
  isNull: () => isNull3,
  isNullable: () => isNullable22,
  isNumber: () => isNumber3,
  isObject: () => isObject22,
  isPromise: () => isPromise3,
  isPromiseLike: () => isPromiseLike3,
  isReadonlyRecord: () => isReadonlyRecord3,
  isRecord: () => isRecord3,
  isSet: () => isSet3,
  isString: () => isString3,
  isSymbol: () => isSymbol3,
  isTagged: () => isTagged3,
  isTruthy: () => isTruthy3,
  isUint8Array: () => isUint8Array3,
  isUndefined: () => isUndefined3,
  isUnknown: () => isUnknown3,
  mapInput: () => mapInput4,
  nand: () => nand3,
  nor: () => nor3,
  not: () => not3,
  or: () => or3,
  product: () => product22,
  productMany: () => productMany22,
  some: () => some32,
  struct: () => struct5,
  tuple: () => tuple4,
  xor: () => xor3
});
var mapInput4 = /* @__PURE__ */ dual22(2, (self2, f232) => (b232) => self2(f232(b232)));
var isTruthy3 = (input) => !!input;
var isSet3 = (input) => input instanceof Set;
var isMap3 = (input) => input instanceof Map;
var isString3 = (input) => typeof input === "string";
var isNumber3 = (input) => typeof input === "number";
var isBoolean3 = (input) => typeof input === "boolean";
var isBigInt3 = (input) => typeof input === "bigint";
var isSymbol3 = (input) => typeof input === "symbol";
var isFunction32 = isFunction222;
var isUndefined3 = (input) => input === void 0;
var isNotUndefined3 = (input) => input !== void 0;
var isNull3 = (input) => input === null;
var isNotNull3 = (input) => input !== null;
var isNever3 = (_232) => false;
var isUnknown3 = (_232) => true;
var isRecordOrArray22 = (input) => typeof input === "object" && input !== null;
var isObject22 = (input) => isRecordOrArray22(input) || isFunction32(input);
var hasProperty22 = /* @__PURE__ */ dual22(2, (self2, property) => isObject22(self2) && property in self2);
var isTagged3 = /* @__PURE__ */ dual22(2, (self2, tag) => hasProperty22(self2, "_tag") && self2["_tag"] === tag);
var isNullable22 = (input) => input === null || input === void 0;
var isNotNullable3 = (input) => input !== null && input !== void 0;
var isError3 = (input) => input instanceof Error;
var isUint8Array3 = (input) => input instanceof Uint8Array;
var isDate3 = (input) => input instanceof Date;
var isIterable3 = (input) => hasProperty22(input, Symbol.iterator);
var isRecord3 = (input) => isRecordOrArray22(input) && !Array.isArray(input);
var isReadonlyRecord3 = isRecord3;
var isPromise3 = (input) => hasProperty22(input, "then") && "catch" in input && isFunction32(input.then) && isFunction32(input.catch);
var isPromiseLike3 = (input) => hasProperty22(input, "then") && isFunction32(input.then);
var compose222 = /* @__PURE__ */ dual22(2, (ab, bc) => (a232) => ab(a232) && bc(a232));
var product22 = (self2, that) => ([a232, b232]) => self2(a232) && that(b232);
var all22 = (collection) => {
  return (as22232) => {
    let collectionIndex = 0;
    for (const p232 of collection) {
      if (collectionIndex >= as22232.length) {
        break;
      }
      if (p232(as22232[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany22 = (self2, collection) => {
  const rest = all22(collection);
  return ([head232, ...tail232]) => self2(head232) === false ? false : rest(tail232);
};
var tuple4 = (...elements) => all22(elements);
var struct5 = (fields) => {
  const keys2232 = Object.keys(fields);
  return (a232) => {
    for (const key of keys2232) {
      if (!fields[key](a232[key])) {
        return false;
      }
    }
    return true;
  };
};
var not3 = (self2) => (a232) => !self2(a232);
var or3 = /* @__PURE__ */ dual22(2, (self2, that) => (a232) => self2(a232) || that(a232));
var and3 = /* @__PURE__ */ dual22(2, (self2, that) => (a232) => self2(a232) && that(a232));
var xor3 = /* @__PURE__ */ dual22(2, (self2, that) => (a232) => self2(a232) !== that(a232));
var eqv3 = /* @__PURE__ */ dual22(2, (self2, that) => (a232) => self2(a232) === that(a232));
var implies3 = /* @__PURE__ */ dual22(2, (self2, that) => (a232) => self2(a232) ? that(a232) : true);
var nor3 = /* @__PURE__ */ dual22(2, (self2, that) => (a232) => !(self2(a232) || that(a232)));
var nand3 = /* @__PURE__ */ dual22(2, (self2, that) => (a232) => !(self2(a232) && that(a232)));
var every4 = (collection) => (a232) => {
  for (const p232 of collection) {
    if (!p232(a232)) {
      return false;
    }
  }
  return true;
};
var some32 = (collection) => (a232) => {
  for (const p232 of collection) {
    if (p232(a232)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage22 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId22 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind22 = (u232) => isObject22(u232) && GenKindTypeId22 in u232;
var GenKindImpl22 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity22;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId22] = GenKindTypeId22;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen22(this);
  }
};
var SingleShotGen22 = class _SingleShotGen4 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a232) {
    return this.called ? {
      value: a232,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a232) {
    return {
      value: a232,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e232) {
    throw e232;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen4(this.self);
  }
};
var adapter32 = () => function() {
  let x232 = arguments[0];
  for (let i232 = 1; i232 < arguments.length; i232++) {
    x232 = arguments[i232](x232);
  }
  return new GenKindImpl22(x232);
};
var defaultIncHi22 = 335903614;
var defaultIncLo22 = 4150755663;
var MUL_HI22 = 1481765933 >>> 0;
var MUL_LO22 = 1284865837 >>> 0;
var BIT_5322 = 9007199254740992;
var BIT_2722 = 134217728;
var PCGRandom22 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable22(seedLo) && isNullable22(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable22(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable22(incLo) && isNullable22(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo22;
      incHi = this._state ? this._state[2] : defaultIncHi22;
    } else if (isNullable22(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add6422(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max322) {
    if (!max322) {
      return this._next();
    }
    max322 = max322 >>> 0;
    if ((max322 & max322 - 1) === 0) {
      return this._next() & max322 - 1;
    }
    let num = 0;
    const skew = (-max322 >>> 0) % max322 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max322;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_2722 + lo) / BIT_5322;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul6422(this._state, oldHi, oldLo, MUL_HI22, MUL_LO22);
    add6422(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul6422(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add6422(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId22 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap22 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId22]() {
    return this.#value;
  }
};
function yieldWrapGet22(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId22 in self2) {
    return self2[YieldWrapTypeId22]();
  }
  throw new Error(getBugErrorMessage22("yieldWrapGet"));
}
var structuralRegionState22 = /* @__PURE__ */ globalValue22("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache22 = /* @__PURE__ */ globalValue22(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr22 = /* @__PURE__ */ globalValue22(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom22());
var symbol32 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash22 = (self2) => {
  if (structuralRegionState22.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number22(self2);
    case "bigint":
      return string22(self2.toString(10));
    case "boolean":
      return string22(String(self2));
    case "symbol":
      return string22(String(self2));
    case "string":
      return string22(self2);
    case "undefined":
      return string22("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string22("null");
      } else if (self2 instanceof Date) {
        return hash22(self2.toISOString());
      } else if (isHash22(self2)) {
        return self2[symbol32]();
      } else {
        return random22(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random22 = (self2) => {
  if (!randomHashCache22.has(self2)) {
    randomHashCache22.set(self2, number22(pcgr22.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache22.get(self2);
};
var combine22 = (b232) => (self2) => self2 * 53 ^ b232;
var optimize22 = (n232) => n232 & 3221225471 | n232 >>> 1 & 1073741824;
var isHash22 = (u232) => hasProperty22(u232, symbol32);
var number22 = (n232) => {
  if (n232 !== n232 || n232 === Infinity) {
    return 0;
  }
  let h232 = n232 | 0;
  if (h232 !== n232) {
    h232 ^= n232 * 4294967295;
  }
  while (n232 > 4294967295) {
    h232 ^= n232 /= 4294967295;
  }
  return optimize22(n232);
};
var string22 = (str) => {
  let h232 = 5381, i232 = str.length;
  while (i232) {
    h232 = h232 * 33 ^ str.charCodeAt(--i232);
  }
  return optimize22(h232);
};
var structureKeys22 = (o232, keys2232) => {
  let h232 = 12289;
  for (let i232 = 0; i232 < keys2232.length; i232++) {
    h232 ^= pipe22(string22(keys2232[i232]), combine22(hash22(o232[keys2232[i232]])));
  }
  return optimize22(h232);
};
var structure22 = (o232) => structureKeys22(o232, Object.keys(o232));
var array5 = (arr) => {
  let h232 = 6151;
  for (let i232 = 0; i232 < arr.length; i232++) {
    h232 = pipe22(h232, combine22(hash22(arr[i232])));
  }
  return optimize22(h232);
};
var cached22 = function() {
  if (arguments.length === 1) {
    const self22 = arguments[0];
    return function(hash3222) {
      Object.defineProperty(self22, symbol32, {
        value() {
          return hash3222;
        },
        enumerable: false
      });
      return hash3222;
    };
  }
  const self2 = arguments[0];
  const hash22232 = arguments[1];
  Object.defineProperty(self2, symbol32, {
    value() {
      return hash22232;
    },
    enumerable: false
  });
  return hash22232;
};
var symbol222 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals22() {
  if (arguments.length === 1) {
    return (self2) => compareBoth22(self2, arguments[0]);
  }
  return compareBoth22(arguments[0], arguments[1]);
}
function compareBoth22(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual22(self2) && isEqual22(that)) {
        if (hash22(self2) === hash22(that) && self2[symbol222](that)) {
          return true;
        } else {
          return structuralRegionState22.enabled && structuralRegionState22.tester ? structuralRegionState22.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState22.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v232, i232) => compareBoth22(v232, that[i232]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth22(self2[key], that[key]))) {
              return structuralRegionState22.tester ? structuralRegionState22.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState22.tester ? structuralRegionState22.tester(self2, that) : false;
    }
  }
  return structuralRegionState22.enabled && structuralRegionState22.tester ? structuralRegionState22.tester(self2, that) : false;
}
var isEqual22 = (u232) => hasProperty22(u232, symbol222);
var equivalence22 = () => equals22;
var NodeInspectSymbol22 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON22 = (x232) => {
  if (hasProperty22(x232, "toJSON") && isFunction32(x232["toJSON"]) && x232["toJSON"].length === 0) {
    return x232.toJSON();
  } else if (Array.isArray(x232)) {
    return x232.map(toJSON22);
  }
  return x232;
};
var format22 = (x232) => JSON.stringify(x232, null, 2);
var pipeArguments22 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i232 = 0, len = args.length; i232 < len; i232++) {
        ret = args[i232](ret);
      }
      return ret;
    }
  }
};
var OP_COMMIT22 = "Commit";
var OP_FAILURE2 = "Failure";
var OP_WITH_RUNTIME2 = "WithRuntime";
var EffectTypeId22 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId22 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId22 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId22 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance22 = {
  /* c8 ignore next */
  _R: (_232) => _232,
  /* c8 ignore next */
  _E: (_232) => _232,
  /* c8 ignore next */
  _A: (_232) => _232,
  _V: /* @__PURE__ */ getCurrentVersion22()
};
var sinkVariance22 = {
  /* c8 ignore next */
  _A: (_232) => _232,
  /* c8 ignore next */
  _In: (_232) => _232,
  /* c8 ignore next */
  _L: (_232) => _232,
  /* c8 ignore next */
  _E: (_232) => _232,
  /* c8 ignore next */
  _R: (_232) => _232
};
var channelVariance22 = {
  /* c8 ignore next */
  _Env: (_232) => _232,
  /* c8 ignore next */
  _InErr: (_232) => _232,
  /* c8 ignore next */
  _InElem: (_232) => _232,
  /* c8 ignore next */
  _InDone: (_232) => _232,
  /* c8 ignore next */
  _OutErr: (_232) => _232,
  /* c8 ignore next */
  _OutElem: (_232) => _232,
  /* c8 ignore next */
  _OutDone: (_232) => _232
};
var EffectPrototype22 = {
  [EffectTypeId22]: effectVariance22,
  [StreamTypeId22]: effectVariance22,
  [SinkTypeId22]: sinkVariance22,
  [ChannelTypeId22]: channelVariance22,
  [symbol222](that) {
    return this === that;
  },
  [symbol32]() {
    return cached22(this, random22(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen22(new YieldWrap22(this));
  },
  pipe() {
    return pipeArguments22(this, arguments);
  }
};
var StructuralPrototype22 = {
  [symbol32]() {
    return cached22(this, structure22(this));
  },
  [symbol222](that) {
    const selfKeys = Object.keys(this);
    const thatKeys = Object.keys(that);
    if (selfKeys.length !== thatKeys.length) {
      return false;
    }
    for (const key of selfKeys) {
      if (!(key in that && equals22(this[key], that[key]))) {
        return false;
      }
    }
    return true;
  }
};
var CommitPrototype22 = {
  ...EffectPrototype22,
  _op: OP_COMMIT22
};
var StructuralCommitPrototype22 = {
  ...CommitPrototype22,
  ...StructuralPrototype22
};
var TypeId52 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto32 = {
  ...EffectPrototype22,
  [TypeId52]: {
    _A: (_232) => _232
  },
  [NodeInspectSymbol22]() {
    return this.toJSON();
  },
  toString() {
    return format22(this.toJSON());
  }
};
var SomeProto22 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto32), {
  _tag: "Some",
  _op: "Some",
  [symbol222](that) {
    return isOption32(that) && isSome32(that) && equals22(this.value, that.value);
  },
  [symbol32]() {
    return cached22(this, combine22(hash22(this._tag))(hash22(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON22(this.value)
    };
  }
});
var NoneHash22 = /* @__PURE__ */ hash22("None");
var NoneProto22 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto32), {
  _tag: "None",
  _op: "None",
  [symbol222](that) {
    return isOption32(that) && isNone32(that);
  },
  [symbol32]() {
    return NoneHash22;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption32 = (input) => hasProperty22(input, TypeId52);
var isNone32 = (fa) => fa._tag === "None";
var isSome32 = (fa) => fa._tag === "Some";
var none32 = /* @__PURE__ */ Object.create(NoneProto22);
var some222 = (value) => {
  const a232 = Object.create(SomeProto22);
  a232.value = value;
  return a232;
};
var TypeId222 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto222 = {
  ...EffectPrototype22,
  [TypeId222]: {
    _R: (_232) => _232
  },
  [NodeInspectSymbol22]() {
    return this.toJSON();
  },
  toString() {
    return format22(this.toJSON());
  }
};
var RightProto22 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto222), {
  _tag: "Right",
  _op: "Right",
  [symbol222](that) {
    return isEither22(that) && isRight22(that) && equals22(this.right, that.right);
  },
  [symbol32]() {
    return combine22(hash22(this._tag))(hash22(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON22(this.right)
    };
  }
});
var LeftProto22 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto222), {
  _tag: "Left",
  _op: "Left",
  [symbol222](that) {
    return isEither22(that) && isLeft22(that) && equals22(this.left, that.left);
  },
  [symbol32]() {
    return combine22(hash22(this._tag))(hash22(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON22(this.left)
    };
  }
});
var isEither22 = (input) => hasProperty22(input, TypeId222);
var isLeft22 = (ma) => ma._tag === "Left";
var isRight22 = (ma) => ma._tag === "Right";
var left22 = (left3232) => {
  const a232 = Object.create(LeftProto22);
  a232.left = left3232;
  return a232;
};
var right22 = (right3232) => {
  const a232 = Object.create(RightProto22);
  a232.right = right3232;
  return a232;
};
var getLeft32 = (self2) => isRight22(self2) ? none32 : some222(self2.left);
var getRight32 = (self2) => isLeft22(self2) ? none32 : some222(self2.right);
var right222 = right22;
var left222 = left22;
var Option_exports22 = {};
__export2222(Option_exports22, {
  Do: () => Do22,
  TypeId: () => TypeId322,
  all: () => all222,
  andThen: () => andThen22,
  ap: () => ap22,
  as: () => as22,
  asVoid: () => asVoid22,
  bind: () => bind222,
  bindTo: () => bindTo222,
  composeK: () => composeK22,
  contains: () => contains22,
  containsWith: () => containsWith22,
  exists: () => exists22,
  filter: () => filter22,
  filterMap: () => filterMap22,
  firstSomeOf: () => firstSomeOf22,
  flatMap: () => flatMap22,
  flatMapNullable: () => flatMapNullable22,
  flatten: () => flatten22,
  fromIterable: () => fromIterable22,
  fromNullable: () => fromNullable22,
  gen: () => gen22,
  getEquivalence: () => getEquivalence22,
  getLeft: () => getLeft222,
  getOrElse: () => getOrElse22,
  getOrNull: () => getOrNull22,
  getOrThrow: () => getOrThrow22,
  getOrThrowWith: () => getOrThrowWith22,
  getOrUndefined: () => getOrUndefined22,
  getOrder: () => getOrder22,
  getRight: () => getRight222,
  isNone: () => isNone222,
  isOption: () => isOption222,
  isSome: () => isSome222,
  let: () => let_222,
  lift2: () => lift222,
  liftNullable: () => liftNullable22,
  liftPredicate: () => liftPredicate22,
  liftThrowable: () => liftThrowable22,
  map: () => map22,
  match: () => match22,
  none: () => none222,
  orElse: () => orElse22,
  orElseEither: () => orElseEither22,
  orElseSome: () => orElseSome22,
  partitionMap: () => partitionMap22,
  product: () => product222,
  productMany: () => productMany222,
  reduceCompact: () => reduceCompact22,
  some: () => some322,
  tap: () => tap22,
  toArray: () => toArray22,
  toRefinement: () => toRefinement22,
  void: () => void_22,
  zipLeft: () => zipLeft22,
  zipRight: () => zipRight22,
  zipWith: () => zipWith22
});
var make222 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId322 = /* @__PURE__ */ Symbol.for("effect/Option");
var none222 = () => none32;
var some322 = some222;
var isOption222 = isOption32;
var isNone222 = isNone32;
var isSome222 = isSome32;
var match22 = /* @__PURE__ */ dual22(2, (self2, {
  onNone,
  onSome
}) => isNone222(self2) ? onNone() : onSome(self2.value));
var toRefinement22 = (f232) => (a232) => isSome222(f232(a232));
var fromIterable22 = (collection) => {
  for (const a232 of collection) {
    return some322(a232);
  }
  return none222();
};
var getRight222 = getRight32;
var getLeft222 = getLeft32;
var getOrElse22 = /* @__PURE__ */ dual22(2, (self2, onNone) => isNone222(self2) ? onNone() : self2.value);
var orElse22 = /* @__PURE__ */ dual22(2, (self2, that) => isNone222(self2) ? that() : self2);
var orElseSome22 = /* @__PURE__ */ dual22(2, (self2, onNone) => isNone222(self2) ? some322(onNone()) : self2);
var orElseEither22 = /* @__PURE__ */ dual22(2, (self2, that) => isNone222(self2) ? map22(that(), right22) : map22(self2, left22));
var firstSomeOf22 = (collection) => {
  let out = none222();
  for (out of collection) {
    if (isSome222(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable22 = (nullableValue) => nullableValue == null ? none222() : some322(nullableValue);
var liftNullable22 = (f232) => (...a232) => fromNullable22(f232(...a232));
var getOrNull22 = /* @__PURE__ */ getOrElse22(constNull22);
var getOrUndefined22 = /* @__PURE__ */ getOrElse22(constUndefined22);
var liftThrowable22 = (f232) => (...a232) => {
  try {
    return some322(f232(...a232));
  } catch (e232) {
    return none222();
  }
};
var getOrThrowWith22 = /* @__PURE__ */ dual22(2, (self2, onNone) => {
  if (isSome222(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow22 = /* @__PURE__ */ getOrThrowWith22(() => new Error("getOrThrow called on a None"));
var map22 = /* @__PURE__ */ dual22(2, (self2, f232) => isNone222(self2) ? none222() : some322(f232(self2.value)));
var as22 = /* @__PURE__ */ dual22(2, (self2, b232) => map22(self2, () => b232));
var asVoid22 = /* @__PURE__ */ as22(void 0);
var void_22 = /* @__PURE__ */ some322(void 0);
var flatMap22 = /* @__PURE__ */ dual22(2, (self2, f232) => isNone222(self2) ? none222() : f232(self2.value));
var andThen22 = /* @__PURE__ */ dual22(2, (self2, f232) => flatMap22(self2, (a232) => {
  const b232 = isFunction222(f232) ? f232(a232) : f232;
  return isOption222(b232) ? b232 : some322(b232);
}));
var flatMapNullable22 = /* @__PURE__ */ dual22(2, (self2, f232) => isNone222(self2) ? none222() : fromNullable22(f232(self2.value)));
var flatten22 = /* @__PURE__ */ flatMap22(identity22);
var zipRight22 = /* @__PURE__ */ dual22(2, (self2, that) => flatMap22(self2, () => that));
var composeK22 = /* @__PURE__ */ dual22(2, (afb, bfc) => (a232) => flatMap22(afb(a232), bfc));
var zipLeft22 = /* @__PURE__ */ dual22(2, (self2, that) => tap22(self2, () => that));
var tap22 = /* @__PURE__ */ dual22(2, (self2, f232) => flatMap22(self2, (a232) => map22(f232(a232), () => a232)));
var product222 = (self2, that) => isSome222(self2) && isSome222(that) ? some322([self2.value, that.value]) : none222();
var productMany222 = (self2, collection) => {
  if (isNone222(self2)) {
    return none222();
  }
  const out = [self2.value];
  for (const o232 of collection) {
    if (isNone222(o232)) {
      return none222();
    }
    out.push(o232.value);
  }
  return some322(out);
};
var all222 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o232 of input) {
      if (isNone222(o232)) {
        return none222();
      }
      out2.push(o232.value);
    }
    return some322(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o232 = input[key];
    if (isNone222(o232)) {
      return none222();
    }
    out[key] = o232.value;
  }
  return some322(out);
};
var zipWith22 = /* @__PURE__ */ dual22(3, (self2, that, f232) => map22(product222(self2, that), ([a232, b232]) => f232(a232, b232)));
var ap22 = /* @__PURE__ */ dual22(2, (self2, that) => zipWith22(self2, that, (f232, a232) => f232(a232)));
var reduceCompact22 = /* @__PURE__ */ dual22(3, (self2, b232, f232) => {
  let out = b232;
  for (const oa of self2) {
    if (isSome222(oa)) {
      out = f232(out, oa.value);
    }
  }
  return out;
});
var toArray22 = (self2) => isNone222(self2) ? [] : [self2.value];
var partitionMap22 = /* @__PURE__ */ dual22(2, (self2, f232) => {
  if (isNone222(self2)) {
    return [none222(), none222()];
  }
  const e232 = f232(self2.value);
  return isLeft22(e232) ? [some322(e232.left), none222()] : [none222(), some322(e232.right)];
});
var filterMap22 = /* @__PURE__ */ dual22(2, (self2, f232) => isNone222(self2) ? none222() : f232(self2.value));
var filter22 = /* @__PURE__ */ dual22(2, (self2, predicate) => filterMap22(self2, (b232) => predicate(b232) ? some222(b232) : none32));
var getEquivalence22 = (isEquivalent) => make42((x232, y232) => x232 === y232 || (isNone222(x232) ? isNone222(y232) : isNone222(y232) ? false : isEquivalent(x232.value, y232.value)));
var getOrder22 = (O232) => make222((self2, that) => isSome222(self2) ? isSome222(that) ? O232(self2.value, that.value) : 1 : -1);
var lift222 = (f232) => dual22(2, (self2, that) => zipWith22(self2, that, f232));
var liftPredicate22 = (predicate) => (b232) => predicate(b232) ? some322(b232) : none222();
var containsWith22 = (isEquivalent) => dual22(2, (self2, a232) => isNone222(self2) ? false : isEquivalent(self2.value, a232));
var _equivalence22 = /* @__PURE__ */ equivalence22();
var contains22 = /* @__PURE__ */ containsWith22(_equivalence22);
var exists22 = /* @__PURE__ */ dual22(2, (self2, refinement) => isNone222(self2) ? false : refinement(self2.value));
var bindTo222 = /* @__PURE__ */ bindTo32(map22);
var let_222 = /* @__PURE__ */ let_32(map22);
var bind222 = /* @__PURE__ */ bind32(map22, flatMap22);
var Do22 = /* @__PURE__ */ some322({});
var adapter222 = /* @__PURE__ */ adapter32();
var gen22 = (f232) => {
  const iterator = f232(adapter222);
  let state = iterator.next();
  if (state.done) {
    return some322(state.value);
  } else {
    let current = state.value;
    if (isGenKind22(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet22(current);
    }
    if (isNone222(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind22(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet22(current);
        }
        if (isNone222(current)) {
          return current;
        }
      }
    }
    return some322(state.value);
  }
};
var fromIterable222 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var reverse4 = (self2) => Array.from(self2).reverse();
var reduce5 = /* @__PURE__ */ dual22(3, (self2, b232, f232) => fromIterable222(self2).reduce((b2222, a232, i232) => f232(b2222, a232, i232), b232));
var TagTypeId2 = /* @__PURE__ */ Symbol.for("effect/Context/Tag");
var STMSymbolKey2 = "effect/STM";
var STMTypeId2 = /* @__PURE__ */ Symbol.for(STMSymbolKey2);
var TagProto2 = {
  ...EffectPrototype22,
  _tag: "Tag",
  _op: "Tag",
  [STMTypeId2]: effectVariance22,
  [TagTypeId2]: {
    _Service: (_232) => _232,
    _Identifier: (_232) => _232
  },
  toString() {
    return format22(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Tag",
      key: this.key,
      stack: this.stack
    };
  },
  [NodeInspectSymbol22]() {
    return this.toJSON();
  },
  of(self2) {
    return self2;
  },
  context(self2) {
    return make322(this, self2);
  }
};
var makeGenericTag2 = (key) => {
  const limit = Error.stackTraceLimit;
  Error.stackTraceLimit = 2;
  const creationError = new Error();
  Error.stackTraceLimit = limit;
  const tag = Object.create(TagProto2);
  Object.defineProperty(tag, "stack", {
    get() {
      return creationError.stack;
    }
  });
  tag.key = key;
  return tag;
};
var TypeId422 = /* @__PURE__ */ Symbol.for("effect/Context");
var ContextProto2 = {
  [TypeId422]: {
    _Services: (_232) => _232
  },
  [symbol222](that) {
    if (isContext2(that)) {
      if (this.unsafeMap.size === that.unsafeMap.size) {
        for (const k232 of this.unsafeMap.keys()) {
          if (!that.unsafeMap.has(k232) || !equals22(this.unsafeMap.get(k232), that.unsafeMap.get(k232))) {
            return false;
          }
        }
        return true;
      }
    }
    return false;
  },
  [symbol32]() {
    return cached22(this, number22(this.unsafeMap.size));
  },
  pipe() {
    return pipeArguments22(this, arguments);
  },
  toString() {
    return format22(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Context",
      services: Array.from(this.unsafeMap).map(toJSON22)
    };
  },
  [NodeInspectSymbol22]() {
    return this.toJSON();
  }
};
var makeContext2 = (unsafeMap) => {
  const context = Object.create(ContextProto2);
  context.unsafeMap = unsafeMap;
  return context;
};
var isContext2 = (u232) => hasProperty22(u232, TypeId422);
var _empty6 = /* @__PURE__ */ makeContext2(/* @__PURE__ */ new Map());
var empty10 = () => _empty6;
var make322 = (tag, service) => makeContext2(/* @__PURE__ */ new Map([[tag.key, service]]));
var GenericTag2 = makeGenericTag2;
var empty22 = empty10;
var TypeId522 = /* @__PURE__ */ Symbol.for("effect/Chunk");
function copy3(src, srcPos, dest, destPos, len) {
  for (let i232 = srcPos; i232 < Math.min(src.length, srcPos + len); i232++) {
    dest[destPos + i232 - srcPos] = src[i232];
  }
  return dest;
}
var emptyArray2 = [];
var getEquivalence222 = (isEquivalent) => make42((self2, that) => self2.length === that.length && toReadonlyArray2(self2).every((value, i232) => isEquivalent(value, unsafeGet22(that, i232))));
var _equivalence222 = /* @__PURE__ */ getEquivalence222(equals22);
var ChunkProto2 = {
  [TypeId522]: {
    _A: (_232) => _232
  },
  toString() {
    return format22(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Chunk",
      values: toReadonlyArray2(this).map(toJSON22)
    };
  },
  [NodeInspectSymbol22]() {
    return this.toJSON();
  },
  [symbol222](that) {
    return isChunk2(that) && _equivalence222(this, that);
  },
  [symbol32]() {
    return cached22(this, array5(toReadonlyArray2(this)));
  },
  [Symbol.iterator]() {
    switch (this.backing._tag) {
      case "IArray": {
        return this.backing.array[Symbol.iterator]();
      }
      case "IEmpty": {
        return emptyArray2[Symbol.iterator]();
      }
      default: {
        return toReadonlyArray2(this)[Symbol.iterator]();
      }
    }
  },
  pipe() {
    return pipeArguments22(this, arguments);
  }
};
var makeChunk2 = (backing) => {
  const chunk = Object.create(ChunkProto2);
  chunk.backing = backing;
  switch (backing._tag) {
    case "IEmpty": {
      chunk.length = 0;
      chunk.depth = 0;
      chunk.left = chunk;
      chunk.right = chunk;
      break;
    }
    case "IConcat": {
      chunk.length = backing.left.length + backing.right.length;
      chunk.depth = 1 + Math.max(backing.left.depth, backing.right.depth);
      chunk.left = backing.left;
      chunk.right = backing.right;
      break;
    }
    case "IArray": {
      chunk.length = backing.array.length;
      chunk.depth = 0;
      chunk.left = _empty22;
      chunk.right = _empty22;
      break;
    }
    case "ISingleton": {
      chunk.length = 1;
      chunk.depth = 0;
      chunk.left = _empty22;
      chunk.right = _empty22;
      break;
    }
    case "ISlice": {
      chunk.length = backing.length;
      chunk.depth = backing.chunk.depth + 1;
      chunk.left = _empty22;
      chunk.right = _empty22;
      break;
    }
  }
  return chunk;
};
var isChunk2 = (u232) => hasProperty22(u232, TypeId522);
var _empty22 = /* @__PURE__ */ makeChunk2({
  _tag: "IEmpty"
});
var empty32 = () => _empty22;
var make422 = (...as22232) => as22232.length === 1 ? of3(as22232[0]) : unsafeFromNonEmptyArray2(as22232);
var of3 = (a232) => makeChunk2({
  _tag: "ISingleton",
  a: a232
});
var copyToArray2 = (self2, array3232, initial) => {
  switch (self2.backing._tag) {
    case "IArray": {
      copy3(self2.backing.array, 0, array3232, initial, self2.length);
      break;
    }
    case "IConcat": {
      copyToArray2(self2.left, array3232, initial);
      copyToArray2(self2.right, array3232, initial + self2.left.length);
      break;
    }
    case "ISingleton": {
      array3232[initial] = self2.backing.a;
      break;
    }
    case "ISlice": {
      let i232 = 0;
      let j232 = initial;
      while (i232 < self2.length) {
        array3232[j232] = unsafeGet22(self2, i232);
        i232 += 1;
        j232 += 1;
      }
      break;
    }
  }
};
var toReadonlyArray2 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      return emptyArray2;
    }
    case "IArray": {
      return self2.backing.array;
    }
    default: {
      const arr = new Array(self2.length);
      copyToArray2(self2, arr, 0);
      self2.backing = {
        _tag: "IArray",
        array: arr
      };
      self2.left = _empty22;
      self2.right = _empty22;
      self2.depth = 0;
      return arr;
    }
  }
};
var reverse22 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty":
    case "ISingleton":
      return self2;
    case "IArray": {
      return makeChunk2({
        _tag: "IArray",
        array: reverse4(self2.backing.array)
      });
    }
    case "IConcat": {
      return makeChunk2({
        _tag: "IConcat",
        left: reverse22(self2.backing.right),
        right: reverse22(self2.backing.left)
      });
    }
    case "ISlice":
      return unsafeFromArray2(reverse4(toReadonlyArray2(self2)));
  }
};
var unsafeFromArray2 = (self2) => makeChunk2({
  _tag: "IArray",
  array: self2
});
var unsafeFromNonEmptyArray2 = (self2) => unsafeFromArray2(self2);
var unsafeGet22 = /* @__PURE__ */ dual22(2, (self2, index) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      throw new Error(`Index out of bounds`);
    }
    case "ISingleton": {
      if (index !== 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.a;
    }
    case "IArray": {
      if (index >= self2.length || index < 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.array[index];
    }
    case "IConcat": {
      return index < self2.left.length ? unsafeGet22(self2.left, index) : unsafeGet22(self2.right, index - self2.left.length);
    }
    case "ISlice": {
      return unsafeGet22(self2.backing.chunk, index + self2.backing.offset);
    }
  }
});
var prepend3 = /* @__PURE__ */ dual22(2, (self2, elem) => appendAll3(of3(elem), self2));
var drop3 = /* @__PURE__ */ dual22(2, (self2, n232) => {
  if (n232 <= 0) {
    return self2;
  } else if (n232 >= self2.length) {
    return _empty22;
  } else {
    switch (self2.backing._tag) {
      case "ISlice": {
        return makeChunk2({
          _tag: "ISlice",
          chunk: self2.backing.chunk,
          offset: self2.backing.offset + n232,
          length: self2.backing.length - n232
        });
      }
      case "IConcat": {
        if (n232 > self2.left.length) {
          return drop3(self2.right, n232 - self2.left.length);
        }
        return makeChunk2({
          _tag: "IConcat",
          left: drop3(self2.left, n232),
          right: self2.right
        });
      }
      default: {
        return makeChunk2({
          _tag: "ISlice",
          chunk: self2,
          offset: n232,
          length: self2.length - n232
        });
      }
    }
  }
});
var appendAll3 = /* @__PURE__ */ dual22(2, (self2, that) => {
  if (self2.backing._tag === "IEmpty") {
    return that;
  }
  if (that.backing._tag === "IEmpty") {
    return self2;
  }
  const diff2232 = that.depth - self2.depth;
  if (Math.abs(diff2232) <= 1) {
    return makeChunk2({
      _tag: "IConcat",
      left: self2,
      right: that
    });
  } else if (diff2232 < -1) {
    if (self2.left.depth >= self2.right.depth) {
      const nr = appendAll3(self2.right, that);
      return makeChunk2({
        _tag: "IConcat",
        left: self2.left,
        right: nr
      });
    } else {
      const nrr = appendAll3(self2.right.right, that);
      if (nrr.depth === self2.depth - 3) {
        const nr = makeChunk2({
          _tag: "IConcat",
          left: self2.right.left,
          right: nrr
        });
        return makeChunk2({
          _tag: "IConcat",
          left: self2.left,
          right: nr
        });
      } else {
        const nl = makeChunk2({
          _tag: "IConcat",
          left: self2.left,
          right: self2.right.left
        });
        return makeChunk2({
          _tag: "IConcat",
          left: nl,
          right: nrr
        });
      }
    }
  } else {
    if (that.right.depth >= that.left.depth) {
      const nl = appendAll3(self2, that.left);
      return makeChunk2({
        _tag: "IConcat",
        left: nl,
        right: that.right
      });
    } else {
      const nll = appendAll3(self2, that.left.left);
      if (nll.depth === that.depth - 3) {
        const nl = makeChunk2({
          _tag: "IConcat",
          left: nll,
          right: that.left.right
        });
        return makeChunk2({
          _tag: "IConcat",
          left: nl,
          right: that.right
        });
      } else {
        const nr = makeChunk2({
          _tag: "IConcat",
          left: that.left.right,
          right: that.right
        });
        return makeChunk2({
          _tag: "IConcat",
          left: nll,
          right: nr
        });
      }
    }
  }
});
var isEmpty2 = (self2) => self2.length === 0;
var isNonEmpty2 = (self2) => self2.length > 0;
var unsafeHead2 = (self2) => unsafeGet22(self2, 0);
var headNonEmpty3 = unsafeHead2;
var tailNonEmpty3 = (self2) => drop3(self2, 1);
var SIZE2 = 5;
var BUCKET_SIZE2 = /* @__PURE__ */ Math.pow(2, SIZE2);
var MASK2 = BUCKET_SIZE2 - 1;
var MAX_INDEX_NODE2 = BUCKET_SIZE2 / 2;
var MIN_ARRAY_NODE2 = BUCKET_SIZE2 / 4;
function popcount2(x232) {
  x232 -= x232 >> 1 & 1431655765;
  x232 = (x232 & 858993459) + (x232 >> 2 & 858993459);
  x232 = x232 + (x232 >> 4) & 252645135;
  x232 += x232 >> 8;
  x232 += x232 >> 16;
  return x232 & 127;
}
function hashFragment2(shift32, h232) {
  return h232 >>> shift32 & MASK2;
}
function toBitmap2(x232) {
  return 1 << x232;
}
function fromBitmap2(bitmap, bit) {
  return popcount2(bitmap & bit - 1);
}
var make52 = (value, previous) => ({
  value,
  previous
});
function arrayUpdate2(mutate2232, at, v232, arr) {
  let out = arr;
  if (!mutate2232) {
    const len = arr.length;
    out = new Array(len);
    for (let i232 = 0; i232 < len; ++i232) out[i232] = arr[i232];
  }
  out[at] = v232;
  return out;
}
function arraySpliceOut2(mutate2232, at, arr) {
  const newLen = arr.length - 1;
  let i232 = 0;
  let g232 = 0;
  let out = arr;
  if (mutate2232) {
    i232 = g232 = at;
  } else {
    out = new Array(newLen);
    while (i232 < at) out[g232++] = arr[i232++];
  }
  ++i232;
  while (i232 <= newLen) out[g232++] = arr[i232++];
  if (mutate2232) {
    out.length = newLen;
  }
  return out;
}
function arraySpliceIn2(mutate2232, at, v232, arr) {
  const len = arr.length;
  if (mutate2232) {
    let i2222 = len;
    while (i2222 >= at) arr[i2222--] = arr[i2222];
    arr[at] = v232;
    return arr;
  }
  let i232 = 0, g232 = 0;
  const out = new Array(len + 1);
  while (i232 < at) out[g232++] = arr[i232++];
  out[at] = v232;
  while (i232 < len) out[++g232] = arr[i232++];
  return out;
}
var EmptyNode2 = class _EmptyNode2 {
  _tag = "EmptyNode";
  modify(edit, _shift, f232, hash22232, key, size4232) {
    const v232 = f232(none222());
    if (isNone222(v232)) return new _EmptyNode2();
    ++size4232.value;
    return new LeafNode2(edit, hash22232, key, v232);
  }
};
function isEmptyNode2(a232) {
  return isTagged3(a232, "EmptyNode");
}
function isLeafNode2(node) {
  return isEmptyNode2(node) || node._tag === "LeafNode" || node._tag === "CollisionNode";
}
function canEditNode2(node, edit) {
  return isEmptyNode2(node) ? false : edit === node.edit;
}
var LeafNode2 = class _LeafNode2 {
  edit;
  hash;
  key;
  value;
  _tag = "LeafNode";
  constructor(edit, hash22232, key, value) {
    this.edit = edit;
    this.hash = hash22232;
    this.key = key;
    this.value = value;
  }
  modify(edit, shift32, f232, hash22232, key, size4232) {
    if (equals22(key, this.key)) {
      const v2222 = f232(this.value);
      if (v2222 === this.value) return this;
      else if (isNone222(v2222)) {
        --size4232.value;
        return new EmptyNode2();
      }
      if (canEditNode2(this, edit)) {
        this.value = v2222;
        return this;
      }
      return new _LeafNode2(edit, hash22232, key, v2222);
    }
    const v232 = f232(none222());
    if (isNone222(v232)) return this;
    ++size4232.value;
    return mergeLeaves2(edit, shift32, this.hash, this, hash22232, new _LeafNode2(edit, hash22232, key, v232));
  }
};
var CollisionNode2 = class _CollisionNode2 {
  edit;
  hash;
  children;
  _tag = "CollisionNode";
  constructor(edit, hash22232, children) {
    this.edit = edit;
    this.hash = hash22232;
    this.children = children;
  }
  modify(edit, shift32, f232, hash22232, key, size4232) {
    if (hash22232 === this.hash) {
      const canEdit = canEditNode2(this, edit);
      const list = this.updateCollisionList(canEdit, edit, this.hash, this.children, f232, key, size4232);
      if (list === this.children) return this;
      return list.length > 1 ? new _CollisionNode2(edit, this.hash, list) : list[0];
    }
    const v232 = f232(none222());
    if (isNone222(v232)) return this;
    ++size4232.value;
    return mergeLeaves2(edit, shift32, this.hash, this, hash22232, new LeafNode2(edit, hash22232, key, v232));
  }
  updateCollisionList(mutate2232, edit, hash22232, list, f232, key, size4232) {
    const len = list.length;
    for (let i232 = 0; i232 < len; ++i232) {
      const child = list[i232];
      if ("key" in child && equals22(key, child.key)) {
        const value = child.value;
        const newValue2 = f232(value);
        if (newValue2 === value) return list;
        if (isNone222(newValue2)) {
          --size4232.value;
          return arraySpliceOut2(mutate2232, i232, list);
        }
        return arrayUpdate2(mutate2232, i232, new LeafNode2(edit, hash22232, key, newValue2), list);
      }
    }
    const newValue = f232(none222());
    if (isNone222(newValue)) return list;
    ++size4232.value;
    return arrayUpdate2(mutate2232, len, new LeafNode2(edit, hash22232, key, newValue), list);
  }
};
var IndexedNode2 = class _IndexedNode2 {
  edit;
  mask;
  children;
  _tag = "IndexedNode";
  constructor(edit, mask, children) {
    this.edit = edit;
    this.mask = mask;
    this.children = children;
  }
  modify(edit, shift32, f232, hash22232, key, size4232) {
    const mask = this.mask;
    const children = this.children;
    const frag = hashFragment2(shift32, hash22232);
    const bit = toBitmap2(frag);
    const indx = fromBitmap2(mask, bit);
    const exists22232 = mask & bit;
    const canEdit = canEditNode2(this, edit);
    if (!exists22232) {
      const _newChild = new EmptyNode2().modify(edit, shift32 + SIZE2, f232, hash22232, key, size4232);
      if (!_newChild) return this;
      return children.length >= MAX_INDEX_NODE2 ? expand2(edit, frag, _newChild, mask, children) : new _IndexedNode2(edit, mask | bit, arraySpliceIn2(canEdit, indx, _newChild, children));
    }
    const current = children[indx];
    const child = current.modify(edit, shift32 + SIZE2, f232, hash22232, key, size4232);
    if (current === child) return this;
    let bitmap = mask;
    let newChildren;
    if (isEmptyNode2(child)) {
      bitmap &= ~bit;
      if (!bitmap) return new EmptyNode2();
      if (children.length <= 2 && isLeafNode2(children[indx ^ 1])) {
        return children[indx ^ 1];
      }
      newChildren = arraySpliceOut2(canEdit, indx, children);
    } else {
      newChildren = arrayUpdate2(canEdit, indx, child, children);
    }
    if (canEdit) {
      this.mask = bitmap;
      this.children = newChildren;
      return this;
    }
    return new _IndexedNode2(edit, bitmap, newChildren);
  }
};
var ArrayNode2 = class _ArrayNode2 {
  edit;
  size;
  children;
  _tag = "ArrayNode";
  constructor(edit, size4232, children) {
    this.edit = edit;
    this.size = size4232;
    this.children = children;
  }
  modify(edit, shift32, f232, hash22232, key, size4232) {
    let count = this.size;
    const children = this.children;
    const frag = hashFragment2(shift32, hash22232);
    const child = children[frag];
    const newChild = (child || new EmptyNode2()).modify(edit, shift32 + SIZE2, f232, hash22232, key, size4232);
    if (child === newChild) return this;
    const canEdit = canEditNode2(this, edit);
    let newChildren;
    if (isEmptyNode2(child) && !isEmptyNode2(newChild)) {
      ++count;
      newChildren = arrayUpdate2(canEdit, frag, newChild, children);
    } else if (!isEmptyNode2(child) && isEmptyNode2(newChild)) {
      --count;
      if (count <= MIN_ARRAY_NODE2) {
        return pack2(edit, count, frag, children);
      }
      newChildren = arrayUpdate2(canEdit, frag, new EmptyNode2(), children);
    } else {
      newChildren = arrayUpdate2(canEdit, frag, newChild, children);
    }
    if (canEdit) {
      this.size = count;
      this.children = newChildren;
      return this;
    }
    return new _ArrayNode2(edit, count, newChildren);
  }
};
function pack2(edit, count, removed, elements) {
  const children = new Array(count - 1);
  let g232 = 0;
  let bitmap = 0;
  for (let i232 = 0, len = elements.length; i232 < len; ++i232) {
    if (i232 !== removed) {
      const elem = elements[i232];
      if (elem && !isEmptyNode2(elem)) {
        children[g232++] = elem;
        bitmap |= 1 << i232;
      }
    }
  }
  return new IndexedNode2(edit, bitmap, children);
}
function expand2(edit, frag, child, bitmap, subNodes) {
  const arr = [];
  let bit = bitmap;
  let count = 0;
  for (let i232 = 0; bit; ++i232) {
    if (bit & 1) arr[i232] = subNodes[count++];
    bit >>>= 1;
  }
  arr[frag] = child;
  return new ArrayNode2(edit, count + 1, arr);
}
function mergeLeavesInner2(edit, shift32, h1, n1, h232, n232) {
  if (h1 === h232) return new CollisionNode2(edit, h1, [n232, n1]);
  const subH1 = hashFragment2(shift32, h1);
  const subH2 = hashFragment2(shift32, h232);
  if (subH1 === subH2) {
    return (child) => new IndexedNode2(edit, toBitmap2(subH1) | toBitmap2(subH2), [child]);
  } else {
    const children = subH1 < subH2 ? [n1, n232] : [n232, n1];
    return new IndexedNode2(edit, toBitmap2(subH1) | toBitmap2(subH2), children);
  }
}
function mergeLeaves2(edit, shift32, h1, n1, h232, n232) {
  let stack = void 0;
  let currentShift = shift32;
  while (true) {
    const res = mergeLeavesInner2(edit, currentShift, h1, n1, h232, n232);
    if (typeof res === "function") {
      stack = make52(res, stack);
      currentShift = currentShift + SIZE2;
    } else {
      let final = res;
      while (stack != null) {
        final = stack.value(final);
        stack = stack.previous;
      }
      return final;
    }
  }
}
var HashMapSymbolKey2 = "effect/HashMap";
var HashMapTypeId2 = /* @__PURE__ */ Symbol.for(HashMapSymbolKey2);
var HashMapProto2 = {
  [HashMapTypeId2]: HashMapTypeId2,
  [Symbol.iterator]() {
    return new HashMapIterator2(this, (k232, v232) => [k232, v232]);
  },
  [symbol32]() {
    let hash22232 = hash22(HashMapSymbolKey2);
    for (const item of this) {
      hash22232 ^= pipe22(hash22(item[0]), combine22(hash22(item[1])));
    }
    return cached22(this, hash22232);
  },
  [symbol222](that) {
    if (isHashMap2(that)) {
      if (that._size !== this._size) {
        return false;
      }
      for (const item of this) {
        const elem = pipe22(that, getHash2(item[0], hash22(item[0])));
        if (isNone222(elem)) {
          return false;
        } else {
          if (!equals22(item[1], elem.value)) {
            return false;
          }
        }
      }
      return true;
    }
    return false;
  },
  toString() {
    return format22(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashMap",
      values: Array.from(this).map(toJSON22)
    };
  },
  [NodeInspectSymbol22]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments22(this, arguments);
  }
};
var makeImpl3 = (editable, edit, root, size4232) => {
  const map632 = Object.create(HashMapProto2);
  map632._editable = editable;
  map632._edit = edit;
  map632._root = root;
  map632._size = size4232;
  return map632;
};
var HashMapIterator2 = class _HashMapIterator2 {
  map;
  f;
  v;
  constructor(map632, f232) {
    this.map = map632;
    this.f = f232;
    this.v = visitLazy2(this.map._root, this.f, void 0);
  }
  next() {
    if (isNone222(this.v)) {
      return {
        done: true,
        value: void 0
      };
    }
    const v0 = this.v.value;
    this.v = applyCont2(v0.cont);
    return {
      done: false,
      value: v0.value
    };
  }
  [Symbol.iterator]() {
    return new _HashMapIterator2(this.map, this.f);
  }
};
var applyCont2 = (cont) => cont ? visitLazyChildren2(cont[0], cont[1], cont[2], cont[3], cont[4]) : none222();
var visitLazy2 = (node, f232, cont = void 0) => {
  switch (node._tag) {
    case "LeafNode": {
      if (isSome222(node.value)) {
        return some322({
          value: f232(node.key, node.value.value),
          cont
        });
      }
      return applyCont2(cont);
    }
    case "CollisionNode":
    case "ArrayNode":
    case "IndexedNode": {
      const children = node.children;
      return visitLazyChildren2(children.length, children, 0, f232, cont);
    }
    default: {
      return applyCont2(cont);
    }
  }
};
var visitLazyChildren2 = (len, children, i232, f232, cont) => {
  while (i232 < len) {
    const child = children[i232++];
    if (child && !isEmptyNode2(child)) {
      return visitLazy2(child, f232, [len, children, i232, f232, cont]);
    }
  }
  return applyCont2(cont);
};
var _empty32 = /* @__PURE__ */ makeImpl3(false, 0, /* @__PURE__ */ new EmptyNode2(), 0);
var empty42 = () => _empty32;
var isHashMap2 = (u232) => hasProperty22(u232, HashMapTypeId2);
var getHash2 = /* @__PURE__ */ dual22(3, (self2, key, hash22232) => {
  let node = self2._root;
  let shift32 = 0;
  while (true) {
    switch (node._tag) {
      case "LeafNode": {
        return equals22(key, node.key) ? node.value : none222();
      }
      case "CollisionNode": {
        if (hash22232 === node.hash) {
          const children = node.children;
          for (let i232 = 0, len = children.length; i232 < len; ++i232) {
            const child = children[i232];
            if ("key" in child && equals22(key, child.key)) {
              return child.value;
            }
          }
        }
        return none222();
      }
      case "IndexedNode": {
        const frag = hashFragment2(shift32, hash22232);
        const bit = toBitmap2(frag);
        if (node.mask & bit) {
          node = node.children[fromBitmap2(node.mask, bit)];
          shift32 += SIZE2;
          break;
        }
        return none222();
      }
      case "ArrayNode": {
        node = node.children[hashFragment2(shift32, hash22232)];
        if (node) {
          shift32 += SIZE2;
          break;
        }
        return none222();
      }
      default:
        return none222();
    }
  }
});
var set22 = /* @__PURE__ */ dual22(3, (self2, key, value) => modifyAt2(self2, key, () => some322(value)));
var setTree2 = /* @__PURE__ */ dual22(3, (self2, newRoot, newSize) => {
  if (self2._editable) {
    self2._root = newRoot;
    self2._size = newSize;
    return self2;
  }
  return newRoot === self2._root ? self2 : makeImpl3(self2._editable, self2._edit, newRoot, newSize);
});
var keys3 = (self2) => new HashMapIterator2(self2, (key) => key);
var size4 = (self2) => self2._size;
var beginMutation3 = (self2) => makeImpl3(true, self2._edit + 1, self2._root, self2._size);
var modifyAt2 = /* @__PURE__ */ dual22(3, (self2, key, f232) => modifyHash2(self2, key, hash22(key), f232));
var modifyHash2 = /* @__PURE__ */ dual22(4, (self2, key, hash22232, f232) => {
  const size4232 = {
    value: self2._size
  };
  const newRoot = self2._root.modify(self2._editable ? self2._edit : NaN, 0, f232, hash22232, key, size4232);
  return pipe22(self2, setTree2(newRoot, size4232.value));
});
var forEach4 = /* @__PURE__ */ dual22(2, (self2, f232) => reduce22(self2, void 0, (_232, value, key) => f232(value, key)));
var reduce22 = /* @__PURE__ */ dual22(3, (self2, zero, f232) => {
  const root = self2._root;
  if (root._tag === "LeafNode") {
    return isSome222(root.value) ? f232(zero, root.value.value, root.key) : zero;
  }
  if (root._tag === "EmptyNode") {
    return zero;
  }
  const toVisit = [root.children];
  let children;
  while (children = toVisit.pop()) {
    for (let i232 = 0, len = children.length; i232 < len; ) {
      const child = children[i232++];
      if (child && !isEmptyNode2(child)) {
        if (child._tag === "LeafNode") {
          if (isSome222(child.value)) {
            zero = f232(zero, child.value.value, child.key);
          }
        } else {
          toVisit.push(child.children);
        }
      }
    }
  }
  return zero;
});
var HashSetSymbolKey2 = "effect/HashSet";
var HashSetTypeId2 = /* @__PURE__ */ Symbol.for(HashSetSymbolKey2);
var HashSetProto2 = {
  [HashSetTypeId2]: HashSetTypeId2,
  [Symbol.iterator]() {
    return keys3(this._keyMap);
  },
  [symbol32]() {
    return cached22(this, combine22(hash22(this._keyMap))(hash22(HashSetSymbolKey2)));
  },
  [symbol222](that) {
    if (isHashSet2(that)) {
      return size4(this._keyMap) === size4(that._keyMap) && equals22(this._keyMap, that._keyMap);
    }
    return false;
  },
  toString() {
    return format22(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashSet",
      values: Array.from(this).map(toJSON22)
    };
  },
  [NodeInspectSymbol22]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments22(this, arguments);
  }
};
var makeImpl22 = (keyMap) => {
  const set22232 = Object.create(HashSetProto2);
  set22232._keyMap = keyMap;
  return set22232;
};
var isHashSet2 = (u232) => hasProperty22(u232, HashSetTypeId2);
var _empty42 = /* @__PURE__ */ makeImpl22(/* @__PURE__ */ empty42());
var empty52 = () => _empty42;
var size22 = (self2) => size4(self2._keyMap);
var beginMutation22 = (self2) => makeImpl22(beginMutation3(self2._keyMap));
var endMutation2 = (self2) => {
  self2._keyMap._editable = false;
  return self2;
};
var mutate2 = /* @__PURE__ */ dual22(2, (self2, f232) => {
  const transient = beginMutation22(self2);
  f232(transient);
  return endMutation2(transient);
});
var add22 = /* @__PURE__ */ dual22(2, (self2, value) => self2._keyMap._editable ? (set22(value, true)(self2._keyMap), self2) : makeImpl22(set22(value, true)(self2._keyMap)));
var union22 = /* @__PURE__ */ dual22(2, (self2, that) => mutate2(empty52(), (set22232) => {
  forEach22(self2, (value) => add22(set22232, value));
  for (const value of that) {
    add22(set22232, value);
  }
}));
var forEach22 = /* @__PURE__ */ dual22(2, (self2, f232) => forEach4(self2._keyMap, (_232, k232) => f232(k232)));
var empty62 = empty52;
var size32 = size22;
var add32 = add22;
var union32 = union22;
var ArrayProto2 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(Array.prototype), {
  [symbol32]() {
    return cached22(this, array5(this));
  },
  [symbol222](that) {
    if (Array.isArray(that) && this.length === that.length) {
      return this.every((v232, i232) => equals22(v232, that[i232]));
    } else {
      return false;
    }
  }
});
var Structural3 = /* @__PURE__ */ function() {
  function Structural3232(args) {
    if (args) {
      Object.assign(this, args);
    }
  }
  Structural3232.prototype = StructuralPrototype22;
  return Structural3232;
}();
var struct22 = (as22232) => Object.assign(Object.create(StructuralPrototype22), as22232);
var ContextPatchTypeId2 = /* @__PURE__ */ Symbol.for("effect/DifferContextPatch");
function variance3(a232) {
  return a232;
}
var PatchProto2 = {
  ...Structural3.prototype,
  [ContextPatchTypeId2]: {
    _Value: variance3,
    _Patch: variance3
  }
};
var EmptyProto2 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto2), {
  _tag: "Empty"
});
var _empty52 = /* @__PURE__ */ Object.create(EmptyProto2);
var empty72 = () => _empty52;
var AndThenProto2 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto2), {
  _tag: "AndThen"
});
var makeAndThen2 = (first, second) => {
  const o232 = Object.create(AndThenProto2);
  o232.first = first;
  o232.second = second;
  return o232;
};
var AddServiceProto2 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto2), {
  _tag: "AddService"
});
var makeAddService2 = (key, service) => {
  const o232 = Object.create(AddServiceProto2);
  o232.key = key;
  o232.service = service;
  return o232;
};
var RemoveServiceProto2 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto2), {
  _tag: "RemoveService"
});
var makeRemoveService2 = (key) => {
  const o232 = Object.create(RemoveServiceProto2);
  o232.key = key;
  return o232;
};
var UpdateServiceProto2 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto2), {
  _tag: "UpdateService"
});
var makeUpdateService2 = (key, update232) => {
  const o232 = Object.create(UpdateServiceProto2);
  o232.key = key;
  o232.update = update232;
  return o232;
};
var diff2 = (oldValue, newValue) => {
  const missingServices = new Map(oldValue.unsafeMap);
  let patch2232 = empty72();
  for (const [tag, newService] of newValue.unsafeMap.entries()) {
    if (missingServices.has(tag)) {
      const old = missingServices.get(tag);
      missingServices.delete(tag);
      if (!equals22(old, newService)) {
        patch2232 = combine222(makeUpdateService2(tag, () => newService))(patch2232);
      }
    } else {
      missingServices.delete(tag);
      patch2232 = combine222(makeAddService2(tag, newService))(patch2232);
    }
  }
  for (const [tag] of missingServices.entries()) {
    patch2232 = combine222(makeRemoveService2(tag))(patch2232);
  }
  return patch2232;
};
var combine222 = /* @__PURE__ */ dual22(2, (self2, that) => makeAndThen2(self2, that));
var patch2 = /* @__PURE__ */ dual22(2, (self2, context) => {
  if (self2._tag === "Empty") {
    return context;
  }
  let wasServiceUpdated = false;
  let patches = of3(self2);
  const updatedContext = new Map(context.unsafeMap);
  while (isNonEmpty2(patches)) {
    const head232 = headNonEmpty3(patches);
    const tail232 = tailNonEmpty3(patches);
    switch (head232._tag) {
      case "Empty": {
        patches = tail232;
        break;
      }
      case "AddService": {
        updatedContext.set(head232.key, head232.service);
        patches = tail232;
        break;
      }
      case "AndThen": {
        patches = prepend3(prepend3(tail232, head232.second), head232.first);
        break;
      }
      case "RemoveService": {
        updatedContext.delete(head232.key);
        patches = tail232;
        break;
      }
      case "UpdateService": {
        updatedContext.set(head232.key, head232.update(updatedContext.get(head232.key)));
        wasServiceUpdated = true;
        patches = tail232;
        break;
      }
    }
  }
  if (!wasServiceUpdated) {
    return makeContext2(updatedContext);
  }
  const map632 = /* @__PURE__ */ new Map();
  for (const [tag] of context.unsafeMap) {
    if (updatedContext.has(tag)) {
      map632.set(tag, updatedContext.get(tag));
      updatedContext.delete(tag);
    }
  }
  for (const [tag, s232] of updatedContext) {
    map632.set(tag, s232);
  }
  return makeContext2(map632);
});
var DifferTypeId2 = /* @__PURE__ */ Symbol.for("effect/Differ");
var DifferProto2 = {
  [DifferTypeId2]: {
    _P: identity22,
    _V: identity22
  }
};
var make72 = (params) => {
  const differ = Object.create(DifferProto2);
  differ.empty = params.empty;
  differ.diff = params.diff;
  differ.combine = params.combine;
  differ.patch = params.patch;
  return differ;
};
var environment2 = () => make72({
  empty: empty72(),
  combine: (first, second) => combine222(second)(first),
  diff: (oldValue, newValue) => diff2(oldValue, newValue),
  patch: (patch2232, oldValue) => patch2(oldValue)(patch2232)
});
var OP_DIE2 = "Die";
var OP_EMPTY2 = "Empty";
var OP_FAIL2 = "Fail";
var OP_INTERRUPT2 = "Interrupt";
var OP_PARALLEL2 = "Parallel";
var OP_SEQUENTIAL2 = "Sequential";
var CauseSymbolKey2 = "effect/Cause";
var CauseTypeId2 = /* @__PURE__ */ Symbol.for(CauseSymbolKey2);
var variance22 = {
  /* c8 ignore next */
  _E: (_232) => _232
};
var proto2 = {
  [CauseTypeId2]: variance22,
  [symbol32]() {
    return pipe22(hash22(CauseSymbolKey2), combine22(hash22(flattenCause2(this))), cached22(this));
  },
  [symbol222](that) {
    return isCause2(that) && causeEquals2(this, that);
  },
  pipe() {
    return pipeArguments22(this, arguments);
  },
  toJSON() {
    switch (this._tag) {
      case "Empty":
        return {
          _id: "Cause",
          _tag: this._tag
        };
      case "Die":
        return {
          _id: "Cause",
          _tag: this._tag,
          defect: toJSON22(this.defect)
        };
      case "Interrupt":
        return {
          _id: "Cause",
          _tag: this._tag,
          fiberId: this.fiberId.toJSON()
        };
      case "Fail":
        return {
          _id: "Cause",
          _tag: this._tag,
          failure: toJSON22(this.error)
        };
      case "Sequential":
      case "Parallel":
        return {
          _id: "Cause",
          _tag: this._tag,
          left: toJSON22(this.left),
          right: toJSON22(this.right)
        };
    }
  },
  toString() {
    return pretty2(this);
  },
  [NodeInspectSymbol22]() {
    return this.toJSON();
  }
};
var fail3 = (error) => {
  const o232 = Object.create(proto2);
  o232._tag = OP_FAIL2;
  o232.error = error;
  return o232;
};
var parallel2 = (left3232, right3232) => {
  const o232 = Object.create(proto2);
  o232._tag = OP_PARALLEL2;
  o232.left = left3232;
  o232.right = right3232;
  return o232;
};
var sequential2 = (left3232, right3232) => {
  const o232 = Object.create(proto2);
  o232._tag = OP_SEQUENTIAL2;
  o232.left = left3232;
  o232.right = right3232;
  return o232;
};
var isCause2 = (u232) => hasProperty22(u232, CauseTypeId2);
var isInterruptedOnly2 = (self2) => reduceWithContext2(void 0, IsInterruptedOnlyCauseReducer2)(self2);
var causeEquals2 = (left3232, right3232) => {
  let leftStack = of3(left3232);
  let rightStack = of3(right3232);
  while (isNonEmpty2(leftStack) && isNonEmpty2(rightStack)) {
    const [leftParallel, leftSequential] = pipe22(headNonEmpty3(leftStack), reduce42([empty62(), empty32()], ([parallel2232, sequential2232], cause) => {
      const [par, seq] = evaluateCause2(cause);
      return some322([pipe22(parallel2232, union32(par)), pipe22(sequential2232, appendAll3(seq))]);
    }));
    const [rightParallel, rightSequential] = pipe22(headNonEmpty3(rightStack), reduce42([empty62(), empty32()], ([parallel2232, sequential2232], cause) => {
      const [par, seq] = evaluateCause2(cause);
      return some322([pipe22(parallel2232, union32(par)), pipe22(sequential2232, appendAll3(seq))]);
    }));
    if (!equals22(leftParallel, rightParallel)) {
      return false;
    }
    leftStack = leftSequential;
    rightStack = rightSequential;
  }
  return true;
};
var flattenCause2 = (cause) => {
  return flattenCauseLoop2(of3(cause), empty32());
};
var flattenCauseLoop2 = (causes, flattened) => {
  while (1) {
    const [parallel2232, sequential2232] = pipe22(causes, reduce5([empty62(), empty32()], ([parallel332, sequential332], cause) => {
      const [par, seq] = evaluateCause2(cause);
      return [pipe22(parallel332, union32(par)), pipe22(sequential332, appendAll3(seq))];
    }));
    const updated = size32(parallel2232) > 0 ? pipe22(flattened, prepend3(parallel2232)) : flattened;
    if (isEmpty2(sequential2232)) {
      return reverse22(updated);
    }
    causes = sequential2232;
    flattened = updated;
  }
  throw new Error(getBugErrorMessage22("Cause.flattenCauseLoop"));
};
var evaluateCause2 = (self2) => {
  let cause = self2;
  const stack = [];
  let _parallel = empty62();
  let _sequential = empty32();
  while (cause !== void 0) {
    switch (cause._tag) {
      case OP_EMPTY2: {
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_FAIL2: {
        _parallel = add32(_parallel, make422(cause._tag, cause.error));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_DIE2: {
        _parallel = add32(_parallel, make422(cause._tag, cause.defect));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_INTERRUPT2: {
        _parallel = add32(_parallel, make422(cause._tag, cause.fiberId));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_SEQUENTIAL2: {
        switch (cause.left._tag) {
          case OP_EMPTY2: {
            cause = cause.right;
            break;
          }
          case OP_SEQUENTIAL2: {
            cause = sequential2(cause.left.left, sequential2(cause.left.right, cause.right));
            break;
          }
          case OP_PARALLEL2: {
            cause = parallel2(sequential2(cause.left.left, cause.right), sequential2(cause.left.right, cause.right));
            break;
          }
          default: {
            _sequential = prepend3(_sequential, cause.right);
            cause = cause.left;
            break;
          }
        }
        break;
      }
      case OP_PARALLEL2: {
        stack.push(cause.right);
        cause = cause.left;
        break;
      }
    }
  }
  throw new Error(getBugErrorMessage22("Cause.evaluateCauseLoop"));
};
var IsInterruptedOnlyCauseReducer2 = {
  emptyCase: constTrue22,
  failCase: constFalse22,
  dieCase: constFalse22,
  interruptCase: constTrue22,
  sequentialCase: (_232, left3232, right3232) => left3232 && right3232,
  parallelCase: (_232, left3232, right3232) => left3232 && right3232
};
var OP_SEQUENTIAL_CASE2 = "SequentialCase";
var OP_PARALLEL_CASE2 = "ParallelCase";
var reduce42 = /* @__PURE__ */ dual22(3, (self2, zero, pf) => {
  let accumulator = zero;
  let cause = self2;
  const causes = [];
  while (cause !== void 0) {
    const option = pf(accumulator, cause);
    accumulator = isSome222(option) ? option.value : accumulator;
    switch (cause._tag) {
      case OP_SEQUENTIAL2: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      case OP_PARALLEL2: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      default: {
        cause = void 0;
        break;
      }
    }
    if (cause === void 0 && causes.length > 0) {
      cause = causes.pop();
    }
  }
  return accumulator;
});
var reduceWithContext2 = /* @__PURE__ */ dual22(3, (self2, context, reducer) => {
  const input = [self2];
  const output = [];
  while (input.length > 0) {
    const cause = input.pop();
    switch (cause._tag) {
      case OP_EMPTY2: {
        output.push(right222(reducer.emptyCase(context)));
        break;
      }
      case OP_FAIL2: {
        output.push(right222(reducer.failCase(context, cause.error)));
        break;
      }
      case OP_DIE2: {
        output.push(right222(reducer.dieCase(context, cause.defect)));
        break;
      }
      case OP_INTERRUPT2: {
        output.push(right222(reducer.interruptCase(context, cause.fiberId)));
        break;
      }
      case OP_SEQUENTIAL2: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left222({
          _tag: OP_SEQUENTIAL_CASE2
        }));
        break;
      }
      case OP_PARALLEL2: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left222({
          _tag: OP_PARALLEL_CASE2
        }));
        break;
      }
    }
  }
  const accumulator = [];
  while (output.length > 0) {
    const either = output.pop();
    switch (either._tag) {
      case "Left": {
        switch (either.left._tag) {
          case OP_SEQUENTIAL_CASE2: {
            const left3232 = accumulator.pop();
            const right3232 = accumulator.pop();
            const value = reducer.sequentialCase(context, left3232, right3232);
            accumulator.push(value);
            break;
          }
          case OP_PARALLEL_CASE2: {
            const left3232 = accumulator.pop();
            const right3232 = accumulator.pop();
            const value = reducer.parallelCase(context, left3232, right3232);
            accumulator.push(value);
            break;
          }
        }
        break;
      }
      case "Right": {
        accumulator.push(either.right);
        break;
      }
    }
  }
  if (accumulator.length === 0) {
    throw new Error("BUG: Cause.reduceWithContext - please report an issue at https://github.com/Effect-TS/effect/issues");
  }
  return accumulator.pop();
});
var pretty2 = (cause) => {
  if (isInterruptedOnly2(cause)) {
    return "All fibers interrupted without errors.";
  }
  return prettyErrors2(cause).map((e232) => e232.stack).join("\n");
};
var PrettyError2 = class extends globalThis.Error {
  span = void 0;
  constructor(originalError) {
    const prevLimit = Error.stackTraceLimit;
    Error.stackTraceLimit = 0;
    super(prettyErrorMessage2(originalError));
    Error.stackTraceLimit = prevLimit;
    this.name = originalError instanceof Error ? originalError.name : "Error";
    if (typeof originalError === "object" && originalError !== null) {
      if (spanSymbol3 in originalError) {
        this.span = originalError[spanSymbol3];
      }
      Object.keys(originalError).forEach((key) => {
        if (!(key in this)) {
          this[key] = originalError[key];
        }
      });
    }
    this.stack = prettyErrorStack2(this.message, originalError instanceof Error && originalError.stack ? originalError.stack : "", this.span);
  }
  toJSON() {
    const out = {
      message: this.message,
      stack: this.stack
    };
    if (this.span) {
      out.span = this.span;
    }
    return out;
  }
};
var prettyErrorMessage2 = (u232) => {
  if (typeof u232 === "string") {
    return `Error: ${u232}`;
  }
  try {
    if (hasProperty22(u232, "toString") && isFunction32(u232["toString"]) && u232["toString"] !== Object.prototype.toString && u232["toString"] !== globalThis.Array.prototype.toString) {
      return u232["toString"]();
    }
  } catch {
  }
  return `Error: ${JSON.stringify(u232)}`;
};
var locationRegex2 = /\((.*)\)/;
var spanToTrace2 = /* @__PURE__ */ globalValue22("effect/Tracer/spanToTrace", () => /* @__PURE__ */ new WeakMap());
var prettyErrorStack2 = (message, stack, span222) => {
  const out = [message];
  const lines = stack.split("\n");
  for (let i232 = 1; i232 < lines.length; i232++) {
    if (lines[i232].includes("Generator.next")) {
      break;
    }
    if (lines[i232].includes("effect_internal_function")) {
      out.pop();
      break;
    }
    out.push(lines[i232].replace(/at .*effect_instruction_i.*\((.*)\)/, "at $1").replace(/EffectPrimitive\.\w+/, "<anonymous>"));
  }
  if (span222) {
    let current = span222;
    let i232 = 0;
    while (current && current._tag === "Span" && i232 < 10) {
      const stackFn = spanToTrace2.get(current);
      if (typeof stackFn === "function") {
        const stack2 = stackFn();
        const locationMatch = stack2.match(locationRegex2);
        const location = locationMatch ? locationMatch[1] : stack2.replace(/^at /, "");
        out.push(`    at ${current.name} (${location})`);
      } else {
        out.push(`    at ${current.name}`);
      }
      current = getOrUndefined22(current.parent);
      i232++;
    }
  }
  return out.join("\n");
};
var spanSymbol3 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var prettyErrors2 = (cause) => reduceWithContext2(cause, void 0, {
  emptyCase: () => [],
  dieCase: (_232, unknownError) => {
    return [new PrettyError2(unknownError)];
  },
  failCase: (_232, error) => {
    return [new PrettyError2(error)];
  },
  interruptCase: () => [],
  parallelCase: (_232, l232, r232) => [...l232, ...r232],
  sequentialCase: (_232, l232, r232) => [...l232, ...r232]
});
var SingleShotGen222 = class _SingleShotGen22 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  next(a232) {
    return this.called ? {
      value: a232,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  return(a232) {
    return {
      value: a232,
      done: true
    };
  }
  throw(e232) {
    throw e232;
  }
  [Symbol.iterator]() {
    return new _SingleShotGen22(this.self);
  }
};
var spanTag2 = /* @__PURE__ */ GenericTag2("effect/ParentSpan");
var EffectTypeId222 = /* @__PURE__ */ Symbol.for("effect/Effect");
var EffectPrimitive2 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId222] = effectVariance22;
  constructor(_op) {
    this._op = _op;
  }
  [symbol222](that) {
    return this === that;
  }
  [symbol32]() {
    return cached22(this, random22(this));
  }
  pipe() {
    return pipeArguments22(this, arguments);
  }
  toJSON() {
    return {
      _id: "Effect",
      _op: this._op,
      effect_instruction_i0: toJSON22(this.effect_instruction_i0),
      effect_instruction_i1: toJSON22(this.effect_instruction_i1),
      effect_instruction_i2: toJSON22(this.effect_instruction_i2)
    };
  }
  toString() {
    return format22(this.toJSON());
  }
  [NodeInspectSymbol22]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen222(new YieldWrap22(this));
  }
};
var EffectPrimitiveFailure2 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId222] = effectVariance22;
  constructor(_op) {
    this._op = _op;
    this._tag = _op;
  }
  [symbol222](that) {
    return exitIsExit2(that) && that._op === "Failure" && // @ts-expect-error
    equals22(this.effect_instruction_i0, that.effect_instruction_i0);
  }
  [symbol32]() {
    return pipe22(
      // @ts-expect-error
      string22(this._tag),
      // @ts-expect-error
      combine22(hash22(this.effect_instruction_i0)),
      cached22(this)
    );
  }
  get cause() {
    return this.effect_instruction_i0;
  }
  pipe() {
    return pipeArguments22(this, arguments);
  }
  toJSON() {
    return {
      _id: "Exit",
      _tag: this._op,
      cause: this.cause.toJSON()
    };
  }
  toString() {
    return format22(this.toJSON());
  }
  [NodeInspectSymbol22]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen222(new YieldWrap22(this));
  }
};
var isEffect2 = (u232) => hasProperty22(u232, EffectTypeId222);
var withFiberRuntime2 = (withRuntime) => {
  const effect = new EffectPrimitive2(OP_WITH_RUNTIME2);
  effect.effect_instruction_i0 = withRuntime;
  return effect;
};
var spanSymbol22 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var originalSymbol2 = /* @__PURE__ */ Symbol.for("effect/OriginalAnnotation");
var capture2 = (obj, span222) => {
  if (isSome222(span222)) {
    return new Proxy(obj, {
      has(target, p232) {
        return p232 === spanSymbol22 || p232 === originalSymbol2 || p232 in target;
      },
      get(target, p232) {
        if (p232 === spanSymbol22) {
          return span222.value;
        }
        if (p232 === originalSymbol2) {
          return obj;
        }
        return target[p232];
      }
    });
  }
  return obj;
};
var fail22 = (error) => isObject22(error) && !(spanSymbol22 in error) ? withFiberRuntime2((fiber) => failCause2(fail3(capture2(error, currentSpanFromFiber2(fiber))))) : failCause2(fail3(error));
var failCause2 = (cause) => {
  const effect = new EffectPrimitiveFailure2(OP_FAILURE2);
  effect.effect_instruction_i0 = cause;
  return effect;
};
var FiberRefSymbolKey2 = "effect/FiberRef";
var FiberRefTypeId2 = /* @__PURE__ */ Symbol.for(FiberRefSymbolKey2);
var fiberRefVariance2 = {
  /* c8 ignore next */
  _A: (_232) => _232
};
var fiberRefUnsafeMakeContext2 = (initial) => {
  const differ = environment2();
  return fiberRefUnsafeMakePatch2(initial, {
    differ,
    fork: differ.empty
  });
};
var fiberRefUnsafeMakePatch2 = (initial, options) => ({
  [FiberRefTypeId2]: fiberRefVariance2,
  initial,
  diff: (oldValue, newValue) => options.differ.diff(oldValue, newValue),
  combine: (first, second) => options.differ.combine(first, second),
  patch: (patch2232) => (oldValue) => options.differ.patch(patch2232, oldValue),
  fork: options.fork,
  join: options.join ?? ((_232, n232) => n232),
  pipe() {
    return pipeArguments22(this, arguments);
  }
});
var currentContext2 = /* @__PURE__ */ globalValue22(/* @__PURE__ */ Symbol.for("effect/FiberRef/currentContext"), () => fiberRefUnsafeMakeContext2(empty22()));
var YieldableError2 = /* @__PURE__ */ function() {
  class YieldableError2232 extends globalThis.Error {
    commit() {
      return fail22(this);
    }
    toString() {
      return this.message ? `${this.name}: ${this.message}` : this.name;
    }
    toJSON() {
      return {
        ...this
      };
    }
    [NodeInspectSymbol22]() {
      const stack = this.stack;
      if (stack) {
        return `${this.toString()}
${stack.split("\n").slice(1).join("\n")}`;
      }
      return this.toString();
    }
  }
  Object.assign(YieldableError2232.prototype, StructuralCommitPrototype22);
  return YieldableError2232;
}();
var exitIsExit2 = (u232) => isEffect2(u232) && "_tag" in u232 && (u232._tag === "Success" || u232._tag === "Failure");
var currentSpanFromFiber2 = (fiber) => {
  const span222 = fiber.getFiberRef(currentContext2).unsafeMap.get(spanTag2.key);
  return span222 !== void 0 && span222._tag === "Span" ? some322(span222) : none222();
};
var Data_exports22 = {};
__export2222(Data_exports22, {
  Class: () => Class22,
  Error: () => Error22,
  Structural: () => Structural22,
  TaggedClass: () => TaggedClass2,
  TaggedError: () => TaggedError2,
  array: () => array22,
  case: () => _case2,
  struct: () => struct32,
  tagged: () => tagged2,
  taggedEnum: () => taggedEnum2,
  tuple: () => tuple22,
  unsafeArray: () => unsafeArray2,
  unsafeStruct: () => unsafeStruct2
});
var struct32 = struct22;
var unsafeStruct2 = (as22232) => Object.setPrototypeOf(as22232, StructuralPrototype22);
var tuple22 = (...as22232) => unsafeArray2(as22232);
var array22 = (as22232) => unsafeArray2(as22232.slice(0));
var unsafeArray2 = (as22232) => Object.setPrototypeOf(as22232, ArrayProto2);
var _case2 = () => (args) => args === void 0 ? Object.create(StructuralPrototype22) : struct32(args);
var tagged2 = (tag) => (args) => {
  const value = args === void 0 ? Object.create(StructuralPrototype22) : struct32(args);
  value._tag = tag;
  return value;
};
var Class22 = Structural3;
var TaggedClass2 = (tag) => {
  class Base extends Class22 {
    _tag = tag;
  }
  return Base;
};
var Structural22 = Structural3;
var taggedEnum2 = () => new Proxy({}, {
  get(_target, tag, _receiver) {
    if (tag === "$is") {
      return isTagged3;
    } else if (tag === "$match") {
      return taggedMatch2;
    }
    return tagged2(tag);
  }
});
function taggedMatch2() {
  if (arguments.length === 1) {
    const cases2 = arguments[0];
    return function(value2) {
      return cases2[value2._tag](value2);
    };
  }
  const value = arguments[0];
  const cases = arguments[1];
  return cases[value._tag](value);
}
var Error22 = /* @__PURE__ */ function() {
  return class Base extends YieldableError2 {
    constructor(args) {
      super();
      if (args) {
        Object.assign(this, args);
      }
    }
  };
}();
var TaggedError2 = (tag) => {
  class Base extends Error22 {
    _tag = tag;
  }
  Base.prototype.name = tag;
  return Base;
};
var traverseUp2 = Function_exports22.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType2.Program) return Option_exports22.none();
  return predicate(parent) ? Option_exports22.some(parent) : traverseUp2(parent, predicate);
});
var traverseUpGuard2 = Function_exports22.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType2.Program) return Option_exports22.none();
  return predicate(parent) ? Option_exports22.some(parent) : traverseUpGuard2(parent, predicate);
});
var ESLintCommunityESLintUtils2;
((ESLintCommunityESLintUtils2232) => {
  ESLintCommunityESLintUtils2232.getFunctionHeadLocation = getFunctionHeadLocation2;
  ESLintCommunityESLintUtils2232.getFunctionNameWithKind = getFunctionNameWithKind2;
  ESLintCommunityESLintUtils2232.getPropertyName = getPropertyName2;
  ESLintCommunityESLintUtils2232.getStaticValue = getStaticValue2;
  ESLintCommunityESLintUtils2232.getStringIfConstant = getStringIfConstant2;
  ESLintCommunityESLintUtils2232.hasSideEffect = hasSideEffect2;
  ESLintCommunityESLintUtils2232.isParenthesized = isParenthesized2;
})(ESLintCommunityESLintUtils2 || (ESLintCommunityESLintUtils2 = {}));
var Construction2 = Data_exports22.taggedEnum();
Construction2.None();
a2({
  type: N2.union([NodeType2.FunctionExpression, NodeType2.ArrowFunctionExpression]),
  parent: {
    type: NodeType2.Property,
    parent: {
      type: NodeType2.ObjectExpression
    }
  }
});
a2({
  type: N2.union([NodeType2.FunctionExpression, NodeType2.ArrowFunctionExpression]),
  parent: {
    type: NodeType2.MethodDefinition,
    parent: {
      type: NodeType2.ClassBody
    }
  }
});
a2({
  type: N2.union([NodeType2.FunctionExpression, NodeType2.ArrowFunctionExpression]),
  parent: {
    type: NodeType2.Property,
    parent: {
      type: NodeType2.ClassBody
    }
  }
});
function getVariableInit(at) {
  return (variable) => {
    return Function_exports3.pipe(
      Option_exports3.some(variable),
      Option_exports3.flatMapNullable((v232) => v232.defs.at(at)),
      Option_exports3.flatMap(
        (d232) => "init" in d232.node ? Option_exports3.fromNullable(d232.node.init) : Option_exports3.none()
      )
    );
  };
}
function getPropName(node) {
  return $(node.name).when(is(NodeType.JSXIdentifier), (n232) => n232.name).when(is(NodeType.JSXNamespacedName), (n232) => `${n232.namespace.name}:${n232.name.name}`).exhaustive();
}
function getProp(props, propName, context, initialScope) {
  return findPropInAttributes(props, context, initialScope)(propName);
}
function findPropInProperties(properties, context, initialScope, seenProps = []) {
  return (propName) => {
    return Option_exports2.fromNullable(
      properties.find((prop) => {
        return $(prop).when(is(NodeType.Property), (prop2) => {
          return "name" in prop2.key && prop2.key.name === propName;
        }).when(is(NodeType.SpreadElement), (prop2) => {
          return $(prop2.argument).when(is(NodeType.Identifier), (argument) => {
            const { name: name22 } = argument;
            const maybeInit = Option_exports2.flatMap(
              findVariable2(name22, initialScope),
              getVariableInit(0)
            );
            if (Option_exports2.isNone(maybeInit)) return false;
            const init222 = maybeInit.value;
            if (init222.type !== NodeType.ObjectExpression) return false;
            if (seenProps.includes(name22)) return false;
            return Option_exports2.isSome(
              findPropInProperties(init222.properties, context, initialScope, [...seenProps, name22])(propName)
            );
          }).when(is(NodeType.ObjectExpression), (argument) => {
            return Option_exports2.isSome(findPropInProperties(argument.properties, context, initialScope, seenProps)(propName));
          }).when(is(NodeType.MemberExpression), () => {
          }).when(is(NodeType.CallExpression), () => {
          }).otherwise(Function_exports2.constFalse);
        }).when(is(NodeType.RestElement), () => {
          return false;
        }).otherwise(Function_exports2.constFalse);
      })
    );
  };
}
function findPropInAttributes(attributes, context, initialScope) {
  return (propName) => {
    return Option_exports2.fromNullable(
      attributes.find((attr) => {
        return $(attr).when(is(NodeType.JSXAttribute), (attr2) => getPropName(attr2) === propName).when(is(NodeType.JSXSpreadAttribute), (attr2) => {
          return $(attr2.argument).with({ type: NodeType.Identifier }, (argument) => {
            const { name: name22 } = argument;
            const maybeInit = Option_exports2.flatMap(
              findVariable2(name22, initialScope),
              getVariableInit(0)
            );
            if (Option_exports2.isNone(maybeInit)) return false;
            const init222 = maybeInit.value;
            if (!("properties" in init222)) return false;
            return Option_exports2.isSome(findPropInProperties(init222.properties, context, initialScope)(propName));
          }).when(is(NodeType.ObjectExpression), (argument) => {
            return Option_exports2.isSome(findPropInProperties(argument.properties, context, initialScope)(propName));
          }).when(is(NodeType.MemberExpression), () => {
            return false;
          }).when(is(NodeType.CallExpression), () => {
            return false;
          }).otherwise(Function_exports2.constFalse);
        }).otherwise(Function_exports2.constFalse);
      })
    );
  };
}
function hasProp(attributes, propName, context, initialScope) {
  return Option_exports2.isSome(findPropInAttributes(attributes, context, initialScope)(propName));
}
function traverseUpProp(node, predicate = Function_exports2.constTrue) {
  const guard = (node2) => {
    return node2.type === NodeType.JSXAttribute && predicate(node2);
  };
  return traverseUpGuard(node, guard);
}
function isInsidePropValue(node) {
  if (isStringLiteral(node)) return node.parent.type === NodeType.JSXAttribute;
  return Option_exports2.isSome(traverseUpProp(node, (n232) => n232.value?.type === NodeType.JSXExpressionContainer));
}
var isLiteral = isOneOf([NodeType.Literal, NodeType.JSXText]);
function isWhiteSpace(node) {
  return Predicate_exports2.isString(node.value) && node.value.trim() === "";
}
function isPaddingSpaces(node) {
  return isLiteral(node) && isWhiteSpace(node) && node.raw.includes("\n");
}
var WEBSITE_URL = "https://eslint-react.xyz";
var getDocsUrl = (pluginName) => (ruleName) => {
  return `${WEBSITE_URL}/rules/${ruleName}`;
};
var createRuleForPlugin = (pluginName) => utils.ESLintUtils.RuleCreator(getDocsUrl());
var store2;
function getGlobalMessage(lang) {
  return store2?.get(lang);
}
var store3;
function getSchemaMessage(lang) {
  return store3?.get(lang);
}
var store4;
function getSpecificMessage(reference, lang) {
  return store4?.get(reference)?.get(lang);
}
function _stringify(input) {
  let type = typeof input;
  if (type === "object") {
    type = (input && Object.getPrototypeOf(input)?.constructor?.name) ?? "null";
  }
  return type === "string" ? `"${input}"` : type === "number" || type === "bigint" || type === "boolean" ? `${input}` : type;
}
function _addIssue(context, label, dataset, config2, other) {
  const input = dataset.value;
  const expected = context.expects;
  const received = _stringify(input);
  const issue = {
    kind: context.kind,
    type: context.type,
    input,
    expected,
    received,
    message: `Invalid ${label}: ${expected ? `Expected ${expected} but r` : "R"}eceived ${received}`,
    // @ts-expect-error
    requirement: context.requirement,
    path: other?.path,
    issues: other?.issues,
    lang: config2.lang,
    abortEarly: config2.abortEarly,
    abortPipeEarly: config2.abortPipeEarly,
    skipPipe: config2.skipPipe
  };
  const isSchema = context.kind === "schema";
  const message = (
    // @ts-expect-error
    context.message ?? getSpecificMessage(context.reference, issue.lang) ?? (isSchema ? getSchemaMessage(issue.lang) : null) ?? config2.message ?? getGlobalMessage(issue.lang)
  );
  if (message) {
    issue.message = typeof message === "function" ? message(issue) : message;
  }
  if (isSchema) {
    dataset.typed = false;
  }
  if (dataset.issues) {
    dataset.issues.push(issue);
  } else {
    dataset.issues = [issue];
  }
}
function getDefault(schema4, dataset, config2) {
  return typeof schema4.default === "function" ? (
    // @ts-expect-error
    schema4.default(dataset, config2)
  ) : (
    // @ts-expect-error
    schema4.default
  );
}
function array6(item, message) {
  return {
    kind: "schema",
    type: "array",
    reference: array6,
    expects: "Array",
    async: false,
    item,
    message,
    _run(dataset, config2) {
      const input = dataset.value;
      if (Array.isArray(input)) {
        dataset.typed = true;
        dataset.value = [];
        for (let key = 0; key < input.length; key++) {
          const value2 = input[key];
          const itemDataset = this.item._run({ typed: false, value: value2 }, config2);
          if (itemDataset.issues) {
            const pathItem = {
              type: "array",
              origin: "value",
              input,
              key,
              value: value2
            };
            for (const issue of itemDataset.issues) {
              if (issue.path) {
                issue.path.unshift(pathItem);
              } else {
                issue.path = [pathItem];
              }
              dataset.issues?.push(issue);
            }
            if (!dataset.issues) {
              dataset.issues = itemDataset.issues;
            }
            if (config2.abortEarly) {
              dataset.typed = false;
              break;
            }
          }
          if (!itemDataset.typed) {
            dataset.typed = false;
          }
          dataset.value.push(itemDataset.value);
        }
      } else {
        _addIssue(this, "type", dataset, config2);
      }
      return dataset;
    }
  };
}
function object(entries2, message) {
  return {
    kind: "schema",
    type: "object",
    reference: object,
    expects: "Object",
    async: false,
    entries: entries2,
    message,
    _run(dataset, config2) {
      const input = dataset.value;
      if (input && typeof input === "object") {
        dataset.typed = true;
        dataset.value = {};
        for (const key in this.entries) {
          const value2 = input[key];
          const valueDataset = this.entries[key]._run(
            { typed: false, value: value2 },
            config2
          );
          if (valueDataset.issues) {
            const pathItem = {
              type: "object",
              origin: "value",
              input,
              key,
              value: value2
            };
            for (const issue of valueDataset.issues) {
              if (issue.path) {
                issue.path.unshift(pathItem);
              } else {
                issue.path = [pathItem];
              }
              dataset.issues?.push(issue);
            }
            if (!dataset.issues) {
              dataset.issues = valueDataset.issues;
            }
            if (config2.abortEarly) {
              dataset.typed = false;
              break;
            }
          }
          if (!valueDataset.typed) {
            dataset.typed = false;
          }
          if (valueDataset.value !== void 0 || key in input) {
            dataset.value[key] = valueDataset.value;
          }
        }
      } else {
        _addIssue(this, "type", dataset, config2);
      }
      return dataset;
    }
  };
}
function optional(wrapped, ...args) {
  const schema4 = {
    kind: "schema",
    type: "optional",
    reference: optional,
    expects: `${wrapped.expects} | undefined`,
    async: false,
    wrapped,
    _run(dataset, config2) {
      if (dataset.value === void 0) {
        if ("default" in this) {
          dataset.value = getDefault(
            this,
            dataset,
            config2
          );
        }
        if (dataset.value === void 0) {
          dataset.typed = true;
          return dataset;
        }
      }
      return this.wrapped._run(dataset, config2);
    }
  };
  if (0 in args) {
    schema4.default = args[0];
  }
  return schema4;
}
function string4(message) {
  return {
    kind: "schema",
    type: "string",
    reference: string4,
    expects: "string",
    async: false,
    message,
    _run(dataset, config2) {
      if (typeof dataset.value === "string") {
        dataset.typed = true;
      } else {
        _addIssue(this, "type", dataset, config2);
      }
      return dataset;
    }
  };
}
var ESLintReactSettingsSchema = object({
  additionalHooks: optional(object({
    use: optional(string4()),
    useCallback: optional(array6(string4())),
    useContext: optional(array6(string4())),
    useDebugValue: optional(array6(string4())),
    useDeferredValue: optional(array6(string4())),
    useEffect: optional(array6(string4())),
    useId: optional(array6(string4())),
    useImperativeHandle: optional(array6(string4())),
    useInsertionEffect: optional(array6(string4())),
    useLayoutEffect: optional(array6(string4())),
    useMemo: optional(array6(string4())),
    useOptimistic: optional(array6(string4())),
    useReducer: optional(array6(string4())),
    useRef: optional(array6(string4())),
    useState: optional(array6(string4())),
    useSyncExternalStore: optional(array6(string4())),
    useTransition: optional(array6(string4()))
  })),
  importSource: optional(string4()),
  jsxPragma: optional(string4()),
  jsxPragmaFrag: optional(string4()),
  version: optional(string4())
});
object({
  reactOptions: optional(ESLintReactSettingsSchema)
});
var createRule = createRuleForPlugin();
function getChildrenToArraySelector() {
  return [
    ":matches(",
    "CallExpression",
    "[callee.object.property.name=Children]",
    "[callee.property.name=toArray]",
    ",",
    "CallExpression",
    "[callee.object.name=Children]",
    "[callee.property.name=toArray]",
    ")"
  ].join("");
}
var KEYS3 = {
  ArrayExpression: [
    "elements"
  ],
  ArrayPattern: [
    "elements"
  ],
  ArrowFunctionExpression: [
    "params",
    "body"
  ],
  AssignmentExpression: [
    "left",
    "right"
  ],
  AssignmentPattern: [
    "left",
    "right"
  ],
  AwaitExpression: [
    "argument"
  ],
  BinaryExpression: [
    "left",
    "right"
  ],
  BlockStatement: [
    "body"
  ],
  BreakStatement: [
    "label"
  ],
  CallExpression: [
    "callee",
    "arguments"
  ],
  CatchClause: [
    "param",
    "body"
  ],
  ChainExpression: [
    "expression"
  ],
  ClassBody: [
    "body"
  ],
  ClassDeclaration: [
    "id",
    "superClass",
    "body"
  ],
  ClassExpression: [
    "id",
    "superClass",
    "body"
  ],
  ConditionalExpression: [
    "test",
    "consequent",
    "alternate"
  ],
  ContinueStatement: [
    "label"
  ],
  DebuggerStatement: [],
  DoWhileStatement: [
    "body",
    "test"
  ],
  EmptyStatement: [],
  ExperimentalRestProperty: [
    "argument"
  ],
  ExperimentalSpreadProperty: [
    "argument"
  ],
  ExportAllDeclaration: [
    "exported",
    "source"
  ],
  ExportDefaultDeclaration: [
    "declaration"
  ],
  ExportNamedDeclaration: [
    "declaration",
    "specifiers",
    "source"
  ],
  ExportSpecifier: [
    "exported",
    "local"
  ],
  ExpressionStatement: [
    "expression"
  ],
  ForInStatement: [
    "left",
    "right",
    "body"
  ],
  ForOfStatement: [
    "left",
    "right",
    "body"
  ],
  ForStatement: [
    "init",
    "test",
    "update",
    "body"
  ],
  FunctionDeclaration: [
    "id",
    "params",
    "body"
  ],
  FunctionExpression: [
    "id",
    "params",
    "body"
  ],
  Identifier: [],
  IfStatement: [
    "test",
    "consequent",
    "alternate"
  ],
  ImportDeclaration: [
    "specifiers",
    "source"
  ],
  ImportDefaultSpecifier: [
    "local"
  ],
  ImportExpression: [
    "source"
  ],
  ImportNamespaceSpecifier: [
    "local"
  ],
  ImportSpecifier: [
    "imported",
    "local"
  ],
  JSXAttribute: [
    "name",
    "value"
  ],
  JSXClosingElement: [
    "name"
  ],
  JSXClosingFragment: [],
  JSXElement: [
    "openingElement",
    "children",
    "closingElement"
  ],
  JSXEmptyExpression: [],
  JSXExpressionContainer: [
    "expression"
  ],
  JSXFragment: [
    "openingFragment",
    "children",
    "closingFragment"
  ],
  JSXIdentifier: [],
  JSXMemberExpression: [
    "object",
    "property"
  ],
  JSXNamespacedName: [
    "namespace",
    "name"
  ],
  JSXOpeningElement: [
    "name",
    "attributes"
  ],
  JSXOpeningFragment: [],
  JSXSpreadAttribute: [
    "argument"
  ],
  JSXSpreadChild: [
    "expression"
  ],
  JSXText: [],
  LabeledStatement: [
    "label",
    "body"
  ],
  Literal: [],
  LogicalExpression: [
    "left",
    "right"
  ],
  MemberExpression: [
    "object",
    "property"
  ],
  MetaProperty: [
    "meta",
    "property"
  ],
  MethodDefinition: [
    "key",
    "value"
  ],
  NewExpression: [
    "callee",
    "arguments"
  ],
  ObjectExpression: [
    "properties"
  ],
  ObjectPattern: [
    "properties"
  ],
  PrivateIdentifier: [],
  Program: [
    "body"
  ],
  Property: [
    "key",
    "value"
  ],
  PropertyDefinition: [
    "key",
    "value"
  ],
  RestElement: [
    "argument"
  ],
  ReturnStatement: [
    "argument"
  ],
  SequenceExpression: [
    "expressions"
  ],
  SpreadElement: [
    "argument"
  ],
  StaticBlock: [
    "body"
  ],
  Super: [],
  SwitchCase: [
    "test",
    "consequent"
  ],
  SwitchStatement: [
    "discriminant",
    "cases"
  ],
  TaggedTemplateExpression: [
    "tag",
    "quasi"
  ],
  TemplateElement: [],
  TemplateLiteral: [
    "quasis",
    "expressions"
  ],
  ThisExpression: [],
  ThrowStatement: [
    "argument"
  ],
  TryStatement: [
    "block",
    "handler",
    "finalizer"
  ],
  UnaryExpression: [
    "argument"
  ],
  UpdateExpression: [
    "argument"
  ],
  VariableDeclaration: [
    "declarations"
  ],
  VariableDeclarator: [
    "id",
    "init"
  ],
  WhileStatement: [
    "test",
    "body"
  ],
  WithStatement: [
    "object",
    "body"
  ],
  YieldExpression: [
    "argument"
  ]
};
var NODE_TYPES3 = Object.keys(KEYS3);
for (const type of NODE_TYPES3) {
  Object.freeze(KEYS3[type]);
}
Object.freeze(KEYS3);
var visitor_keys_default3 = KEYS3;
var KEY_BLACKLIST3 = /* @__PURE__ */ new Set([
  "parent",
  "leadingComments",
  "trailingComments"
]);
function filterKey3(key) {
  return !KEY_BLACKLIST3.has(key) && key[0] !== "_";
}
function getKeys3(node) {
  return Object.keys(node).filter(filterKey3);
}
function getInnermostScope3(initialScope, node) {
  const location = node.range[0];
  let scope = initialScope;
  let found = false;
  do {
    found = false;
    for (const childScope of scope.childScopes) {
      const range32 = childScope.block.range;
      if (range32[0] <= location && location < range32[1]) {
        scope = childScope;
        found = true;
        break;
      }
    }
  } while (found);
  return scope;
}
function findVariable3(initialScope, nameOrNode) {
  let name22 = "";
  let scope = initialScope;
  if (typeof nameOrNode === "string") {
    name22 = nameOrNode;
  } else {
    name22 = nameOrNode.name;
    scope = getInnermostScope3(scope, nameOrNode);
  }
  while (scope != null) {
    const variable = scope.set.get(name22);
    if (variable != null) {
      return variable;
    }
    scope = scope.upper;
  }
  return null;
}
function negate03(token) {
  return !this(token);
}
function negate3(f52) {
  return negate03.bind(f52);
}
function isPunctuatorTokenWithValue3(token, value) {
  return token.type === "Punctuator" && token.value === value;
}
function isArrowToken3(token) {
  return isPunctuatorTokenWithValue3(token, "=>");
}
function isCommaToken3(token) {
  return isPunctuatorTokenWithValue3(token, ",");
}
function isSemicolonToken3(token) {
  return isPunctuatorTokenWithValue3(token, ";");
}
function isColonToken3(token) {
  return isPunctuatorTokenWithValue3(token, ":");
}
function isOpeningParenToken3(token) {
  return isPunctuatorTokenWithValue3(token, "(");
}
function isClosingParenToken3(token) {
  return isPunctuatorTokenWithValue3(token, ")");
}
function isOpeningBracketToken3(token) {
  return isPunctuatorTokenWithValue3(token, "[");
}
function isClosingBracketToken3(token) {
  return isPunctuatorTokenWithValue3(token, "]");
}
function isOpeningBraceToken3(token) {
  return isPunctuatorTokenWithValue3(token, "{");
}
function isClosingBraceToken3(token) {
  return isPunctuatorTokenWithValue3(token, "}");
}
function isCommentToken3(token) {
  return ["Block", "Line", "Shebang"].includes(token.type);
}
negate3(isArrowToken3);
negate3(isCommaToken3);
negate3(isSemicolonToken3);
negate3(isColonToken3);
negate3(isOpeningParenToken3);
negate3(isClosingParenToken3);
negate3(isOpeningBracketToken3);
negate3(isClosingBracketToken3);
negate3(isOpeningBraceToken3);
negate3(isClosingBraceToken3);
negate3(isCommentToken3);
function getOpeningParenOfParams3(node, sourceCode) {
  return node.id ? sourceCode.getTokenAfter(node.id, isOpeningParenToken3) : sourceCode.getFirstToken(node, isOpeningParenToken3);
}
function getFunctionHeadLocation3(node, sourceCode) {
  const parent = node.parent;
  let start = null;
  let end = null;
  if (node.type === "ArrowFunctionExpression") {
    const arrowToken = sourceCode.getTokenBefore(node.body, isArrowToken3);
    start = arrowToken.loc.start;
    end = arrowToken.loc.end;
  } else if (parent.type === "Property" || parent.type === "MethodDefinition" || parent.type === "PropertyDefinition") {
    start = parent.loc.start;
    end = getOpeningParenOfParams3(node, sourceCode).loc.start;
  } else {
    start = node.loc.start;
    end = getOpeningParenOfParams3(node, sourceCode).loc.start;
  }
  return {
    start: { ...start },
    end: { ...end }
  };
}
var globalObject3 = typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {};
var builtinNames3 = Object.freeze(
  /* @__PURE__ */ new Set([
    "Array",
    "ArrayBuffer",
    "BigInt",
    "BigInt64Array",
    "BigUint64Array",
    "Boolean",
    "DataView",
    "Date",
    "decodeURI",
    "decodeURIComponent",
    "encodeURI",
    "encodeURIComponent",
    "escape",
    "Float32Array",
    "Float64Array",
    "Function",
    "Infinity",
    "Int16Array",
    "Int32Array",
    "Int8Array",
    "isFinite",
    "isNaN",
    "isPrototypeOf",
    "JSON",
    "Map",
    "Math",
    "NaN",
    "Number",
    "Object",
    "parseFloat",
    "parseInt",
    "Promise",
    "Proxy",
    "Reflect",
    "RegExp",
    "Set",
    "String",
    "Symbol",
    "Uint16Array",
    "Uint32Array",
    "Uint8Array",
    "Uint8ClampedArray",
    "undefined",
    "unescape",
    "WeakMap",
    "WeakSet"
  ])
);
var callAllowed3 = new Set(
  [
    Array.isArray,
    Array.of,
    Array.prototype.at,
    Array.prototype.concat,
    Array.prototype.entries,
    Array.prototype.every,
    Array.prototype.filter,
    Array.prototype.find,
    Array.prototype.findIndex,
    Array.prototype.flat,
    Array.prototype.includes,
    Array.prototype.indexOf,
    Array.prototype.join,
    Array.prototype.keys,
    Array.prototype.lastIndexOf,
    Array.prototype.slice,
    Array.prototype.some,
    Array.prototype.toString,
    Array.prototype.values,
    typeof BigInt === "function" ? BigInt : void 0,
    Boolean,
    Date,
    Date.parse,
    decodeURI,
    decodeURIComponent,
    encodeURI,
    encodeURIComponent,
    escape,
    isFinite,
    isNaN,
    isPrototypeOf,
    Map,
    Map.prototype.entries,
    Map.prototype.get,
    Map.prototype.has,
    Map.prototype.keys,
    Map.prototype.values,
    ...Object.getOwnPropertyNames(Math).filter((k52) => k52 !== "random").map((k52) => Math[k52]).filter((f52) => typeof f52 === "function"),
    Number,
    Number.isFinite,
    Number.isNaN,
    Number.parseFloat,
    Number.parseInt,
    Number.prototype.toExponential,
    Number.prototype.toFixed,
    Number.prototype.toPrecision,
    Number.prototype.toString,
    Object,
    Object.entries,
    Object.is,
    Object.isExtensible,
    Object.isFrozen,
    Object.isSealed,
    Object.keys,
    Object.values,
    parseFloat,
    parseInt,
    RegExp,
    Set,
    Set.prototype.entries,
    Set.prototype.has,
    Set.prototype.keys,
    Set.prototype.values,
    String,
    String.fromCharCode,
    String.fromCodePoint,
    String.raw,
    String.prototype.at,
    String.prototype.charAt,
    String.prototype.charCodeAt,
    String.prototype.codePointAt,
    String.prototype.concat,
    String.prototype.endsWith,
    String.prototype.includes,
    String.prototype.indexOf,
    String.prototype.lastIndexOf,
    String.prototype.normalize,
    String.prototype.padEnd,
    String.prototype.padStart,
    String.prototype.slice,
    String.prototype.startsWith,
    String.prototype.substr,
    String.prototype.substring,
    String.prototype.toLowerCase,
    String.prototype.toString,
    String.prototype.toUpperCase,
    String.prototype.trim,
    String.prototype.trimEnd,
    String.prototype.trimLeft,
    String.prototype.trimRight,
    String.prototype.trimStart,
    Symbol.for,
    Symbol.keyFor,
    unescape
  ].filter((f52) => typeof f52 === "function")
);
var callPassThrough3 = /* @__PURE__ */ new Set([
  Object.freeze,
  Object.preventExtensions,
  Object.seal
]);
var getterAllowed3 = [
  [Map, /* @__PURE__ */ new Set(["size"])],
  [
    RegExp,
    /* @__PURE__ */ new Set([
      "dotAll",
      "flags",
      "global",
      "hasIndices",
      "ignoreCase",
      "multiline",
      "source",
      "sticky",
      "unicode"
    ])
  ],
  [Set, /* @__PURE__ */ new Set(["size"])]
];
function getPropertyDescriptor3(object32, name22) {
  let x52 = object32;
  while ((typeof x52 === "object" || typeof x52 === "function") && x52 !== null) {
    const d52 = Object.getOwnPropertyDescriptor(x52, name22);
    if (d52) {
      return d52;
    }
    x52 = Object.getPrototypeOf(x52);
  }
  return null;
}
function isGetter3(object32, name22) {
  const d52 = getPropertyDescriptor3(object32, name22);
  return d52 != null && d52.get != null;
}
function getElementValues3(nodeList, initialScope) {
  const valueList = [];
  for (let i52 = 0; i52 < nodeList.length; ++i52) {
    const elementNode = nodeList[i52];
    if (elementNode == null) {
      valueList.length = i52 + 1;
    } else if (elementNode.type === "SpreadElement") {
      const argument = getStaticValueR3(elementNode.argument, initialScope);
      if (argument == null) {
        return null;
      }
      valueList.push(...argument.value);
    } else {
      const element = getStaticValueR3(elementNode, initialScope);
      if (element == null) {
        return null;
      }
      valueList.push(element.value);
    }
  }
  return valueList;
}
function isEffectivelyConst3(variable) {
  const refs = variable.references;
  const inits = refs.filter((r52) => r52.init).length;
  const reads = refs.filter((r52) => r52.isReadOnly()).length;
  if (inits === 1 && reads + inits === refs.length) {
    return true;
  }
  return false;
}
var operations3 = Object.freeze({
  ArrayExpression(node, initialScope) {
    const elements = getElementValues3(node.elements, initialScope);
    return elements != null ? { value: elements } : null;
  },
  AssignmentExpression(node, initialScope) {
    if (node.operator === "=") {
      return getStaticValueR3(node.right, initialScope);
    }
    return null;
  },
  //eslint-disable-next-line complexity
  BinaryExpression(node, initialScope) {
    if (node.operator === "in" || node.operator === "instanceof") {
      return null;
    }
    const left94 = getStaticValueR3(node.left, initialScope);
    const right94 = getStaticValueR3(node.right, initialScope);
    if (left94 != null && right94 != null) {
      switch (node.operator) {
        case "==":
          return { value: left94.value == right94.value };
        case "!=":
          return { value: left94.value != right94.value };
        case "===":
          return { value: left94.value === right94.value };
        case "!==":
          return { value: left94.value !== right94.value };
        case "<":
          return { value: left94.value < right94.value };
        case "<=":
          return { value: left94.value <= right94.value };
        case ">":
          return { value: left94.value > right94.value };
        case ">=":
          return { value: left94.value >= right94.value };
        case "<<":
          return { value: left94.value << right94.value };
        case ">>":
          return { value: left94.value >> right94.value };
        case ">>>":
          return { value: left94.value >>> right94.value };
        case "+":
          return { value: left94.value + right94.value };
        case "-":
          return { value: left94.value - right94.value };
        case "*":
          return { value: left94.value * right94.value };
        case "/":
          return { value: left94.value / right94.value };
        case "%":
          return { value: left94.value % right94.value };
        case "**":
          return { value: left94.value ** right94.value };
        case "|":
          return { value: left94.value | right94.value };
        case "^":
          return { value: left94.value ^ right94.value };
        case "&":
          return { value: left94.value & right94.value };
      }
    }
    return null;
  },
  CallExpression(node, initialScope) {
    const calleeNode = node.callee;
    const args = getElementValues3(node.arguments, initialScope);
    if (args != null) {
      if (calleeNode.type === "MemberExpression") {
        if (calleeNode.property.type === "PrivateIdentifier") {
          return null;
        }
        const object32 = getStaticValueR3(calleeNode.object, initialScope);
        if (object32 != null) {
          if (object32.value == null && (object32.optional || node.optional)) {
            return { value: void 0, optional: true };
          }
          const property = getStaticPropertyNameValue3(
            calleeNode,
            initialScope
          );
          if (property != null) {
            const receiver = object32.value;
            const methodName = property.value;
            if (callAllowed3.has(receiver[methodName])) {
              return { value: receiver[methodName](...args) };
            }
            if (callPassThrough3.has(receiver[methodName])) {
              return { value: args[0] };
            }
          }
        }
      } else {
        const callee = getStaticValueR3(calleeNode, initialScope);
        if (callee != null) {
          if (callee.value == null && node.optional) {
            return { value: void 0, optional: true };
          }
          const func = callee.value;
          if (callAllowed3.has(func)) {
            return { value: func(...args) };
          }
          if (callPassThrough3.has(func)) {
            return { value: args[0] };
          }
        }
      }
    }
    return null;
  },
  ConditionalExpression(node, initialScope) {
    const test = getStaticValueR3(node.test, initialScope);
    if (test != null) {
      return test.value ? getStaticValueR3(node.consequent, initialScope) : getStaticValueR3(node.alternate, initialScope);
    }
    return null;
  },
  ExpressionStatement(node, initialScope) {
    return getStaticValueR3(node.expression, initialScope);
  },
  Identifier(node, initialScope) {
    if (initialScope != null) {
      const variable = findVariable3(initialScope, node);
      if (variable != null && variable.defs.length === 0 && builtinNames3.has(variable.name) && variable.name in globalObject3) {
        return { value: globalObject3[variable.name] };
      }
      if (variable != null && variable.defs.length === 1) {
        const def = variable.defs[0];
        if (def.parent && def.type === "Variable" && (def.parent.kind === "const" || isEffectivelyConst3(variable)) && // TODO(mysticatea): don't support destructuring here.
        def.node.id.type === "Identifier") {
          return getStaticValueR3(def.node.init, initialScope);
        }
      }
    }
    return null;
  },
  Literal(node) {
    if ((node.regex != null || node.bigint != null) && node.value == null) {
      return null;
    }
    return { value: node.value };
  },
  LogicalExpression(node, initialScope) {
    const left94 = getStaticValueR3(node.left, initialScope);
    if (left94 != null) {
      if (node.operator === "||" && Boolean(left94.value) === true || node.operator === "&&" && Boolean(left94.value) === false || node.operator === "??" && left94.value != null) {
        return left94;
      }
      const right94 = getStaticValueR3(node.right, initialScope);
      if (right94 != null) {
        return right94;
      }
    }
    return null;
  },
  MemberExpression(node, initialScope) {
    if (node.property.type === "PrivateIdentifier") {
      return null;
    }
    const object32 = getStaticValueR3(node.object, initialScope);
    if (object32 != null) {
      if (object32.value == null && (object32.optional || node.optional)) {
        return { value: void 0, optional: true };
      }
      const property = getStaticPropertyNameValue3(node, initialScope);
      if (property != null) {
        if (!isGetter3(object32.value, property.value)) {
          return { value: object32.value[property.value] };
        }
        for (const [classFn, allowed] of getterAllowed3) {
          if (object32.value instanceof classFn && allowed.has(property.value)) {
            return { value: object32.value[property.value] };
          }
        }
      }
    }
    return null;
  },
  ChainExpression(node, initialScope) {
    const expression = getStaticValueR3(node.expression, initialScope);
    if (expression != null) {
      return { value: expression.value };
    }
    return null;
  },
  NewExpression(node, initialScope) {
    const callee = getStaticValueR3(node.callee, initialScope);
    const args = getElementValues3(node.arguments, initialScope);
    if (callee != null && args != null) {
      const Func = callee.value;
      if (callAllowed3.has(Func)) {
        return { value: new Func(...args) };
      }
    }
    return null;
  },
  ObjectExpression(node, initialScope) {
    const object32 = {};
    for (const propertyNode of node.properties) {
      if (propertyNode.type === "Property") {
        if (propertyNode.kind !== "init") {
          return null;
        }
        const key = getStaticPropertyNameValue3(
          propertyNode,
          initialScope
        );
        const value = getStaticValueR3(propertyNode.value, initialScope);
        if (key == null || value == null) {
          return null;
        }
        object32[key.value] = value.value;
      } else if (propertyNode.type === "SpreadElement" || propertyNode.type === "ExperimentalSpreadProperty") {
        const argument = getStaticValueR3(
          propertyNode.argument,
          initialScope
        );
        if (argument == null) {
          return null;
        }
        Object.assign(object32, argument.value);
      } else {
        return null;
      }
    }
    return { value: object32 };
  },
  SequenceExpression(node, initialScope) {
    const last32 = node.expressions[node.expressions.length - 1];
    return getStaticValueR3(last32, initialScope);
  },
  TaggedTemplateExpression(node, initialScope) {
    const tag = getStaticValueR3(node.tag, initialScope);
    const expressions = getElementValues3(
      node.quasi.expressions,
      initialScope
    );
    if (tag != null && expressions != null) {
      const func = tag.value;
      const strings = node.quasi.quasis.map((q) => q.value.cooked);
      strings.raw = node.quasi.quasis.map((q) => q.value.raw);
      if (func === String.raw) {
        return { value: func(strings, ...expressions) };
      }
    }
    return null;
  },
  TemplateLiteral(node, initialScope) {
    const expressions = getElementValues3(node.expressions, initialScope);
    if (expressions != null) {
      let value = node.quasis[0].value.cooked;
      for (let i52 = 0; i52 < expressions.length; ++i52) {
        value += expressions[i52];
        value += node.quasis[i52 + 1].value.cooked;
      }
      return { value };
    }
    return null;
  },
  UnaryExpression(node, initialScope) {
    if (node.operator === "delete") {
      return null;
    }
    if (node.operator === "void") {
      return { value: void 0 };
    }
    const arg = getStaticValueR3(node.argument, initialScope);
    if (arg != null) {
      switch (node.operator) {
        case "-":
          return { value: -arg.value };
        case "+":
          return { value: +arg.value };
        case "!":
          return { value: !arg.value };
        case "~":
          return { value: ~arg.value };
        case "typeof":
          return { value: typeof arg.value };
      }
    }
    return null;
  }
});
function getStaticValueR3(node, initialScope) {
  if (node != null && Object.hasOwnProperty.call(operations3, node.type)) {
    return operations3[node.type](node, initialScope);
  }
  return null;
}
function getStaticPropertyNameValue3(node, initialScope) {
  const nameNode = node.type === "Property" ? node.key : node.property;
  if (node.computed) {
    return getStaticValueR3(nameNode, initialScope);
  }
  if (nameNode.type === "Identifier") {
    return { value: nameNode.name };
  }
  if (nameNode.type === "Literal") {
    if (nameNode.bigint) {
      return { value: nameNode.bigint };
    }
    return { value: String(nameNode.value) };
  }
  return null;
}
function getStaticValue4(node, initialScope = null) {
  try {
    return getStaticValueR3(node, initialScope);
  } catch (_error) {
    return null;
  }
}
function getStringIfConstant3(node, initialScope = null) {
  if (node && node.type === "Literal" && node.value === null) {
    if (node.regex) {
      return `/${node.regex.pattern}/${node.regex.flags}`;
    }
    if (node.bigint) {
      return node.bigint;
    }
  }
  const evaluated = getStaticValue4(node, initialScope);
  return evaluated && String(evaluated.value);
}
function getPropertyName3(node, initialScope) {
  switch (node.type) {
    case "MemberExpression":
      if (node.computed) {
        return getStringIfConstant3(node.property, initialScope);
      }
      if (node.property.type === "PrivateIdentifier") {
        return null;
      }
      return node.property.name;
    case "Property":
    case "MethodDefinition":
    case "PropertyDefinition":
      if (node.computed) {
        return getStringIfConstant3(node.key, initialScope);
      }
      if (node.key.type === "Literal") {
        return String(node.key.value);
      }
      if (node.key.type === "PrivateIdentifier") {
        return null;
      }
      return node.key.name;
  }
  return null;
}
function getFunctionNameWithKind3(node, sourceCode) {
  const parent = node.parent;
  const tokens = [];
  const isObjectMethod = parent.type === "Property" && parent.value === node;
  const isClassMethod = parent.type === "MethodDefinition" && parent.value === node;
  const isClassFieldMethod = parent.type === "PropertyDefinition" && parent.value === node;
  if (isClassMethod || isClassFieldMethod) {
    if (parent.static) {
      tokens.push("static");
    }
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push("private");
    }
  }
  if (node.async) {
    tokens.push("async");
  }
  if (node.generator) {
    tokens.push("generator");
  }
  if (isObjectMethod || isClassMethod) {
    if (parent.kind === "constructor") {
      return "constructor";
    }
    if (parent.kind === "get") {
      tokens.push("getter");
    } else if (parent.kind === "set") {
      tokens.push("setter");
    } else {
      tokens.push("method");
    }
  } else if (isClassFieldMethod) {
    tokens.push("method");
  } else {
    if (node.type === "ArrowFunctionExpression") {
      tokens.push("arrow");
    }
    tokens.push("function");
  }
  if (isObjectMethod || isClassMethod || isClassFieldMethod) {
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push(`#${parent.key.name}`);
    } else {
      const name22 = getPropertyName3(parent);
      if (name22) {
        tokens.push(`'${name22}'`);
      } else if (sourceCode) {
        const keyText = sourceCode.getText(parent.key);
        if (!keyText.includes("\n")) {
          tokens.push(`[${keyText}]`);
        }
      }
    }
  } else if (node.id) {
    tokens.push(`'${node.id.name}'`);
  } else if (parent.type === "VariableDeclarator" && parent.id && parent.id.type === "Identifier") {
    tokens.push(`'${parent.id.name}'`);
  } else if ((parent.type === "AssignmentExpression" || parent.type === "AssignmentPattern") && parent.left && parent.left.type === "Identifier") {
    tokens.push(`'${parent.left.name}'`);
  } else if (parent.type === "ExportDefaultDeclaration" && parent.declaration === node) {
    tokens.push("'default'");
  }
  return tokens.join(" ");
}
var typeConversionBinaryOps3 = Object.freeze(
  /* @__PURE__ */ new Set([
    "==",
    "!=",
    "<",
    "<=",
    ">",
    ">=",
    "<<",
    ">>",
    ">>>",
    "+",
    "-",
    "*",
    "/",
    "%",
    "|",
    "^",
    "&",
    "in"
  ])
);
var typeConversionUnaryOps3 = Object.freeze(/* @__PURE__ */ new Set(["-", "+", "!", "~"]));
function isNode3(x52) {
  return x52 !== null && typeof x52 === "object" && typeof x52.type === "string";
}
var visitor3 = Object.freeze(
  Object.assign(/* @__PURE__ */ Object.create(null), {
    $visit(node, options, visitorKeys) {
      const { type } = node;
      if (typeof this[type] === "function") {
        return this[type](node, options, visitorKeys);
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    $visitChildren(node, options, visitorKeys) {
      const { type } = node;
      for (const key of visitorKeys[type] || getKeys3(node)) {
        const value = node[key];
        if (Array.isArray(value)) {
          for (const element of value) {
            if (isNode3(element) && this.$visit(element, options, visitorKeys)) {
              return true;
            }
          }
        } else if (isNode3(value) && this.$visit(value, options, visitorKeys)) {
          return true;
        }
      }
      return false;
    },
    ArrowFunctionExpression() {
      return false;
    },
    AssignmentExpression() {
      return true;
    },
    AwaitExpression() {
      return true;
    },
    BinaryExpression(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && typeConversionBinaryOps3.has(node.operator) && (node.left.type !== "Literal" || node.right.type !== "Literal")) {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    CallExpression() {
      return true;
    },
    FunctionExpression() {
      return false;
    },
    ImportExpression() {
      return true;
    },
    MemberExpression(node, options, visitorKeys) {
      if (options.considerGetters) {
        return true;
      }
      if (options.considerImplicitTypeConversion && node.computed && node.property.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    MethodDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    NewExpression() {
      return true;
    },
    Property(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    PropertyDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UnaryExpression(node, options, visitorKeys) {
      if (node.operator === "delete") {
        return true;
      }
      if (options.considerImplicitTypeConversion && typeConversionUnaryOps3.has(node.operator) && node.argument.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UpdateExpression() {
      return true;
    },
    YieldExpression() {
      return true;
    }
  })
);
function hasSideEffect3(node, sourceCode, { considerGetters = false, considerImplicitTypeConversion = false } = {}) {
  return visitor3.$visit(
    node,
    { considerGetters, considerImplicitTypeConversion },
    sourceCode.visitorKeys || visitor_keys_default3
  );
}
function getParentSyntaxParen3(node, sourceCode) {
  const parent = node.parent;
  switch (parent.type) {
    case "CallExpression":
    case "NewExpression":
      if (parent.arguments.length === 1 && parent.arguments[0] === node) {
        return sourceCode.getTokenAfter(
          parent.callee,
          isOpeningParenToken3
        );
      }
      return null;
    case "DoWhileStatement":
      if (parent.test === node) {
        return sourceCode.getTokenAfter(
          parent.body,
          isOpeningParenToken3
        );
      }
      return null;
    case "IfStatement":
    case "WhileStatement":
      if (parent.test === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "ImportExpression":
      if (parent.source === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "SwitchStatement":
      if (parent.discriminant === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "WithStatement":
      if (parent.object === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    default:
      return null;
  }
}
function isParenthesized3(timesOrNode, nodeOrSourceCode, optionalSourceCode) {
  let times, node, sourceCode, maybeLeftParen, maybeRightParen;
  if (typeof timesOrNode === "number") {
    times = timesOrNode | 0;
    node = nodeOrSourceCode;
    sourceCode = optionalSourceCode;
    if (!(times >= 1)) {
      throw new TypeError("'times' should be a positive integer.");
    }
  } else {
    times = 1;
    node = timesOrNode;
    sourceCode = nodeOrSourceCode;
  }
  if (node == null || // `Program` can't be parenthesized
  node.parent == null || // `CatchClause.param` can't be parenthesized, example `try {} catch (error) {}`
  node.parent.type === "CatchClause" && node.parent.param === node) {
    return false;
  }
  maybeLeftParen = maybeRightParen = node;
  do {
    maybeLeftParen = sourceCode.getTokenBefore(maybeLeftParen);
    maybeRightParen = sourceCode.getTokenAfter(maybeRightParen);
  } while (maybeLeftParen != null && maybeRightParen != null && isOpeningParenToken3(maybeLeftParen) && isClosingParenToken3(maybeRightParen) && // Avoid false positive such as `if (a) {}`
  maybeLeftParen !== getParentSyntaxParen3(node, sourceCode) && --times > 0);
  return times === 0;
}
Function.call.bind(Object.hasOwnProperty);
var __defProp4 = Object.defineProperty;
var __export4 = (target, all334) => {
  for (var name22 in all334)
    __defProp4(target, name22, { get: all334[name22], enumerable: true });
};
var NodeType3 = types.AST_NODE_TYPES;
var is3 = utils.ASTUtils.isNodeOfType;
var isOneOf3 = utils.ASTUtils.isNodeOfTypes;
var isFunction = isOneOf3([
  NodeType3.ArrowFunctionExpression,
  NodeType3.FunctionDeclaration,
  NodeType3.FunctionExpression
]);
isOneOf3([
  NodeType3.ArrowFunctionExpression,
  NodeType3.FunctionDeclaration,
  NodeType3.FunctionExpression,
  NodeType3.TSCallSignatureDeclaration,
  NodeType3.TSConstructSignatureDeclaration,
  NodeType3.TSDeclareFunction,
  NodeType3.TSEmptyBodyFunctionExpression,
  NodeType3.TSFunctionType,
  NodeType3.TSMethodSignature
]);
var isClass = isOneOf3([NodeType3.ClassDeclaration, NodeType3.ClassExpression]);
isOneOf3([
  NodeType3.DoWhileStatement,
  NodeType3.ForInStatement,
  NodeType3.ForOfStatement,
  NodeType3.ForStatement,
  NodeType3.WhileStatement
]);
isOneOf3([NodeType3.TSArrayType, NodeType3.TSTupleType]);
isOneOf3([
  NodeType3.PropertyDefinition,
  NodeType3.TSIndexSignature,
  NodeType3.TSParameterProperty,
  NodeType3.TSPropertySignature
]);
is3(NodeType3.JSXElement);
is3(NodeType3.JSXFragment);
var isJSX = isOneOf3([
  NodeType3.JSXAttribute,
  NodeType3.JSXSpreadChild,
  NodeType3.JSXClosingElement,
  NodeType3.JSXClosingFragment,
  NodeType3.JSXElement,
  NodeType3.JSXEmptyExpression,
  NodeType3.JSXExpressionContainer,
  NodeType3.JSXFragment,
  NodeType3.JSXIdentifier,
  NodeType3.JSXMemberExpression,
  NodeType3.JSXNamespacedName,
  NodeType3.JSXOpeningElement,
  NodeType3.JSXOpeningFragment,
  NodeType3.JSXSpreadAttribute,
  NodeType3.JSXSpreadChild,
  NodeType3.JSXText
]);
isOneOf3([
  NodeType3.JSXIdentifier,
  NodeType3.JSXMemberExpression,
  NodeType3.JSXNamespacedName
]);
isOneOf3([
  NodeType3.ArrayPattern,
  NodeType3.AssignmentPattern,
  NodeType3.ObjectPattern,
  NodeType3.RestElement
]);
isOneOf3([
  NodeType3.TSInterfaceDeclaration,
  NodeType3.TSTypeAliasDeclaration
]);
isOneOf3([
  NodeType3.ArrayExpression,
  NodeType3.ArrayPattern,
  NodeType3.ArrowFunctionExpression,
  NodeType3.CallExpression,
  NodeType3.ClassExpression,
  NodeType3.FunctionExpression,
  NodeType3.Identifier,
  NodeType3.JSXElement,
  NodeType3.JSXFragment,
  NodeType3.Literal,
  NodeType3.TemplateLiteral,
  NodeType3.MemberExpression,
  NodeType3.MetaProperty,
  NodeType3.ObjectExpression,
  NodeType3.ObjectPattern,
  NodeType3.SequenceExpression,
  NodeType3.Super,
  NodeType3.TaggedTemplateExpression,
  NodeType3.ThisExpression
]);
isOneOf3([
  NodeType3.ArrayExpression,
  NodeType3.ArrayPattern,
  NodeType3.ArrowFunctionExpression,
  NodeType3.CallExpression,
  NodeType3.ClassExpression,
  NodeType3.FunctionExpression,
  NodeType3.Identifier,
  NodeType3.JSXElement,
  NodeType3.JSXFragment,
  NodeType3.Literal,
  NodeType3.TemplateLiteral,
  NodeType3.MemberExpression,
  NodeType3.MetaProperty,
  NodeType3.ObjectExpression,
  NodeType3.ObjectPattern,
  NodeType3.SequenceExpression,
  NodeType3.Super,
  NodeType3.TaggedTemplateExpression,
  NodeType3.ThisExpression,
  NodeType3.TSAsExpression,
  NodeType3.TSNonNullExpression,
  NodeType3.TSTypeAssertion
]);
function isNodeEqual(a52, b52) {
  if (a52.type !== b52.type) return false;
  if (a52.type === NodeType3.ThisExpression && b52.type === NodeType3.ThisExpression) return true;
  if (a52.type === NodeType3.Literal && b52.type === NodeType3.Literal) return a52.value === b52.value;
  if (a52.type === NodeType3.Identifier && b52.type === NodeType3.Identifier) return a52.name === b52.name;
  if (a52.type === NodeType3.MemberExpression && b52.type === NodeType3.MemberExpression) {
    return isNodeEqual(a52.property, b52.property) && isNodeEqual(a52.object, b52.object);
  }
  return false;
}
function getLiteralValueType(input) {
  return $(input).with(null, () => "Null").with(N.boolean, () => "Boolean").with(N.number, () => "Number").with(N.string, () => "String").with(N.bigint, () => "BigInt").with(N.symbol, () => "Symbol").exhaustive();
}
function readableNodeType(node) {
  if (node.type === NodeType3.Literal) {
    if ("regex" in node) return "RegExp literal";
    return `${getLiteralValueType(node.value)} literal`;
  }
  if (isJSX(node)) return `JSX ${toLowerCase(delimiterCase(replace(node.type, "JSX", ""), " "))}`;
  return toLowerCase(delimiterCase(node.type, " "));
}
var Function_exports4 = {};
__export4(Function_exports4, {
  SK: () => SK4,
  absurd: () => absurd4,
  apply: () => apply4,
  compose: () => compose6,
  constFalse: () => constFalse4,
  constNull: () => constNull4,
  constTrue: () => constTrue4,
  constUndefined: () => constUndefined4,
  constVoid: () => constVoid4,
  constant: () => constant4,
  dual: () => dual4,
  flip: () => flip4,
  flow: () => flow4,
  hole: () => hole4,
  identity: () => identity4,
  isFunction: () => isFunction23,
  pipe: () => pipe4,
  satisfies: () => satisfies4,
  tupled: () => tupled4,
  unsafeCoerce: () => unsafeCoerce4,
  untupled: () => untupled4
});
var isFunction23 = (input) => typeof input === "function";
var dual4 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a52, b52) {
        if (arguments.length >= 2) {
          return body(a52, b52);
        }
        return function(self2) {
          return body(self2, a52);
        };
      };
    case 3:
      return function(a52, b52, c52) {
        if (arguments.length >= 3) {
          return body(a52, b52, c52);
        }
        return function(self2) {
          return body(self2, a52, b52);
        };
      };
    case 4:
      return function(a52, b52, c52, d52) {
        if (arguments.length >= 4) {
          return body(a52, b52, c52, d52);
        }
        return function(self2) {
          return body(self2, a52, b52, c52);
        };
      };
    case 5:
      return function(a52, b52, c52, d52, e52) {
        if (arguments.length >= 5) {
          return body(a52, b52, c52, d52, e52);
        }
        return function(self2) {
          return body(self2, a52, b52, c52, d52);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply4 = (a52) => (self2) => self2(a52);
var identity4 = (a52) => a52;
var satisfies4 = () => (b52) => b52;
var unsafeCoerce4 = identity4;
var constant4 = (value) => () => value;
var constTrue4 = /* @__PURE__ */ constant4(true);
var constFalse4 = /* @__PURE__ */ constant4(false);
var constNull4 = /* @__PURE__ */ constant4(null);
var constUndefined4 = /* @__PURE__ */ constant4(void 0);
var constVoid4 = constUndefined4;
var flip4 = (f52) => (...b52) => (...a52) => f52(...a52)(...b52);
var compose6 = /* @__PURE__ */ dual4(2, (ab, bc) => (a52) => bc(ab(a52)));
var absurd4 = (_52) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled4 = (f52) => (a52) => f52(...a52);
var untupled4 = (f52) => (...a52) => f52(a52);
function pipe4(a52, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a52;
    case 2:
      return ab(a52);
    case 3:
      return bc(ab(a52));
    case 4:
      return cd(bc(ab(a52)));
    case 5:
      return de(cd(bc(ab(a52))));
    case 6:
      return ef(de(cd(bc(ab(a52)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a52))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a52)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a52))))))));
    default: {
      let ret = arguments[0];
      for (let i52 = 1; i52 < arguments.length; i52++) {
        ret = arguments[i52](ret);
      }
      return ret;
    }
  }
}
function flow4(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole4 = /* @__PURE__ */ unsafeCoerce4(absurd4);
var SK4 = (_52, b52) => b52;
var make12 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_7 = (map632) => dual4(3, (self2, name22, f52) => map632(self2, (a52) => Object.assign({}, a52, {
  [name22]: f52(a52)
})));
var bindTo7 = (map632) => dual4(2, (self2, name22) => map632(self2, (a52) => ({
  [name22]: a52
})));
var bind7 = (map632, flatMap432) => dual4(3, (self2, name22, f52) => flatMap432(self2, (a52) => map632(f52(a52), (b52) => Object.assign({}, a52, {
  [name22]: b52
}))));
var moduleVersion4 = "3.2.8";
var getCurrentVersion4 = () => moduleVersion4;
var globalStoreId4 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion4()}`);
if (!(globalStoreId4 in globalThis)) {
  globalThis[globalStoreId4] = /* @__PURE__ */ new Map();
}
var globalStore4 = globalThis[globalStoreId4];
var globalValue4 = (id, compute) => {
  if (!globalStore4.has(id)) {
    globalStore4.set(id, compute());
  }
  return globalStore4.get(id);
};
var Predicate_exports3 = {};
__export4(Predicate_exports3, {
  all: () => all6,
  and: () => and4,
  compose: () => compose23,
  eqv: () => eqv4,
  every: () => every5,
  hasProperty: () => hasProperty4,
  implies: () => implies4,
  isBigInt: () => isBigInt4,
  isBoolean: () => isBoolean4,
  isDate: () => isDate4,
  isError: () => isError4,
  isFunction: () => isFunction33,
  isIterable: () => isIterable4,
  isMap: () => isMap4,
  isNever: () => isNever4,
  isNotNull: () => isNotNull4,
  isNotNullable: () => isNotNullable4,
  isNotUndefined: () => isNotUndefined4,
  isNull: () => isNull4,
  isNullable: () => isNullable4,
  isNumber: () => isNumber4,
  isObject: () => isObject4,
  isPromise: () => isPromise4,
  isPromiseLike: () => isPromiseLike4,
  isReadonlyRecord: () => isReadonlyRecord4,
  isRecord: () => isRecord4,
  isSet: () => isSet4,
  isString: () => isString4,
  isSymbol: () => isSymbol4,
  isTagged: () => isTagged4,
  isTruthy: () => isTruthy4,
  isUint8Array: () => isUint8Array4,
  isUndefined: () => isUndefined4,
  isUnknown: () => isUnknown4,
  mapInput: () => mapInput5,
  nand: () => nand4,
  nor: () => nor4,
  not: () => not4,
  or: () => or4,
  product: () => product6,
  productMany: () => productMany6,
  some: () => some9,
  struct: () => struct6,
  tuple: () => tuple5,
  xor: () => xor4
});
var mapInput5 = /* @__PURE__ */ dual4(2, (self2, f52) => (b52) => self2(f52(b52)));
var isTruthy4 = (input) => !!input;
var isSet4 = (input) => input instanceof Set;
var isMap4 = (input) => input instanceof Map;
var isString4 = (input) => typeof input === "string";
var isNumber4 = (input) => typeof input === "number";
var isBoolean4 = (input) => typeof input === "boolean";
var isBigInt4 = (input) => typeof input === "bigint";
var isSymbol4 = (input) => typeof input === "symbol";
var isFunction33 = isFunction23;
var isUndefined4 = (input) => input === void 0;
var isNotUndefined4 = (input) => input !== void 0;
var isNull4 = (input) => input === null;
var isNotNull4 = (input) => input !== null;
var isNever4 = (_52) => false;
var isUnknown4 = (_52) => true;
var isRecordOrArray4 = (input) => typeof input === "object" && input !== null;
var isObject4 = (input) => isRecordOrArray4(input) || isFunction33(input);
var hasProperty4 = /* @__PURE__ */ dual4(2, (self2, property) => isObject4(self2) && property in self2);
var isTagged4 = /* @__PURE__ */ dual4(2, (self2, tag) => hasProperty4(self2, "_tag") && self2["_tag"] === tag);
var isNullable4 = (input) => input === null || input === void 0;
var isNotNullable4 = (input) => input !== null && input !== void 0;
var isError4 = (input) => input instanceof Error;
var isUint8Array4 = (input) => input instanceof Uint8Array;
var isDate4 = (input) => input instanceof Date;
var isIterable4 = (input) => hasProperty4(input, Symbol.iterator);
var isRecord4 = (input) => isRecordOrArray4(input) && !Array.isArray(input);
var isReadonlyRecord4 = isRecord4;
var isPromise4 = (input) => hasProperty4(input, "then") && "catch" in input && isFunction33(input.then) && isFunction33(input.catch);
var isPromiseLike4 = (input) => hasProperty4(input, "then") && isFunction33(input.then);
var compose23 = /* @__PURE__ */ dual4(2, (ab, bc) => (a52) => ab(a52) && bc(a52));
var product6 = (self2, that) => ([a52, b52]) => self2(a52) && that(b52);
var all6 = (collection) => {
  return (as253) => {
    let collectionIndex = 0;
    for (const p52 of collection) {
      if (collectionIndex >= as253.length) {
        break;
      }
      if (p52(as253[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany6 = (self2, collection) => {
  const rest = all6(collection);
  return ([head232, ...tail42]) => self2(head232) === false ? false : rest(tail42);
};
var tuple5 = (...elements) => all6(elements);
var struct6 = (fields) => {
  const keys234 = Object.keys(fields);
  return (a52) => {
    for (const key of keys234) {
      if (!fields[key](a52[key])) {
        return false;
      }
    }
    return true;
  };
};
var not4 = (self2) => (a52) => !self2(a52);
var or4 = /* @__PURE__ */ dual4(2, (self2, that) => (a52) => self2(a52) || that(a52));
var and4 = /* @__PURE__ */ dual4(2, (self2, that) => (a52) => self2(a52) && that(a52));
var xor4 = /* @__PURE__ */ dual4(2, (self2, that) => (a52) => self2(a52) !== that(a52));
var eqv4 = /* @__PURE__ */ dual4(2, (self2, that) => (a52) => self2(a52) === that(a52));
var implies4 = /* @__PURE__ */ dual4(2, (self2, that) => (a52) => self2(a52) ? that(a52) : true);
var nor4 = /* @__PURE__ */ dual4(2, (self2, that) => (a52) => !(self2(a52) || that(a52)));
var nand4 = /* @__PURE__ */ dual4(2, (self2, that) => (a52) => !(self2(a52) && that(a52)));
var every5 = (collection) => (a52) => {
  for (const p52 of collection) {
    if (!p52(a52)) {
      return false;
    }
  }
  return true;
};
var some9 = (collection) => (a52) => {
  for (const p52 of collection) {
    if (p52(a52)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage4 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId4 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind4 = (u52) => isObject4(u52) && GenKindTypeId4 in u52;
var GenKindImpl4 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity4;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_52) => _52;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_52) => _52;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_52) => _52;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId4] = GenKindTypeId4;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen5(this);
  }
};
var SingleShotGen5 = class _SingleShotGen6 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a52) {
    return this.called ? {
      value: a52,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a52) {
    return {
      value: a52,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e52) {
    throw e52;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen6(this.self);
  }
};
var adapter6 = () => function() {
  let x52 = arguments[0];
  for (let i52 = 1; i52 < arguments.length; i52++) {
    x52 = arguments[i52](x52);
  }
  return new GenKindImpl4(x52);
};
var defaultIncHi4 = 335903614;
var defaultIncLo4 = 4150755663;
var MUL_HI4 = 1481765933 >>> 0;
var MUL_LO4 = 1284865837 >>> 0;
var BIT_534 = 9007199254740992;
var BIT_274 = 134217728;
var PCGRandom4 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable4(seedLo) && isNullable4(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable4(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable4(incLo) && isNullable4(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo4;
      incHi = this._state ? this._state[2] : defaultIncHi4;
    } else if (isNullable4(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add644(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max42) {
    if (!max42) {
      return this._next();
    }
    max42 = max42 >>> 0;
    if ((max42 & max42 - 1) === 0) {
      return this._next() & max42 - 1;
    }
    let num = 0;
    const skew = (-max42 >>> 0) % max42 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max42;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_274 + lo) / BIT_534;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul644(this._state, oldHi, oldLo, MUL_HI4, MUL_LO4);
    add644(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul644(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add644(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId4 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap4 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId4]() {
    return this.#value;
  }
};
function yieldWrapGet4(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId4 in self2) {
    return self2[YieldWrapTypeId4]();
  }
  throw new Error(getBugErrorMessage4("yieldWrapGet"));
}
var structuralRegionState4 = /* @__PURE__ */ globalValue4("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache4 = /* @__PURE__ */ globalValue4(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr4 = /* @__PURE__ */ globalValue4(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom4());
var symbol6 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash4 = (self2) => {
  if (structuralRegionState4.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number5(self2);
    case "bigint":
      return string5(self2.toString(10));
    case "boolean":
      return string5(String(self2));
    case "symbol":
      return string5(String(self2));
    case "string":
      return string5(self2);
    case "undefined":
      return string5("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string5("null");
      } else if (self2 instanceof Date) {
        return hash4(self2.toISOString());
      } else if (isHash4(self2)) {
        return self2[symbol6]();
      } else {
        return random4(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random4 = (self2) => {
  if (!randomHashCache4.has(self2)) {
    randomHashCache4.set(self2, number5(pcgr4.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache4.get(self2);
};
var combine5 = (b52) => (self2) => self2 * 53 ^ b52;
var optimize4 = (n52) => n52 & 3221225471 | n52 >>> 1 & 1073741824;
var isHash4 = (u52) => hasProperty4(u52, symbol6);
var number5 = (n52) => {
  if (n52 !== n52 || n52 === Infinity) {
    return 0;
  }
  let h52 = n52 | 0;
  if (h52 !== n52) {
    h52 ^= n52 * 4294967295;
  }
  while (n52 > 4294967295) {
    h52 ^= n52 /= 4294967295;
  }
  return optimize4(n52);
};
var string5 = (str) => {
  let h52 = 5381, i52 = str.length;
  while (i52) {
    h52 = h52 * 33 ^ str.charCodeAt(--i52);
  }
  return optimize4(h52);
};
var structureKeys2 = (o52, keys234) => {
  let h52 = 12289;
  for (let i52 = 0; i52 < keys234.length; i52++) {
    h52 ^= pipe4(string5(keys234[i52]), combine5(hash4(o52[keys234[i52]])));
  }
  return optimize4(h52);
};
var structure2 = (o52) => structureKeys2(o52, Object.keys(o52));
var array7 = (arr) => {
  let h52 = 6151;
  for (let i52 = 0; i52 < arr.length; i52++) {
    h52 = pipe4(h52, combine5(hash4(arr[i52])));
  }
  return optimize4(h52);
};
var cached4 = function() {
  if (arguments.length === 1) {
    const self22 = arguments[0];
    return function(hash332) {
      Object.defineProperty(self22, symbol6, {
        value() {
          return hash332;
        },
        enumerable: false
      });
      return hash332;
    };
  }
  const self2 = arguments[0];
  const hash253 = arguments[1];
  Object.defineProperty(self2, symbol6, {
    value() {
      return hash253;
    },
    enumerable: false
  });
  return hash253;
};
var symbol23 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals4() {
  if (arguments.length === 1) {
    return (self2) => compareBoth4(self2, arguments[0]);
  }
  return compareBoth4(arguments[0], arguments[1]);
}
function compareBoth4(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual4(self2) && isEqual4(that)) {
        if (hash4(self2) === hash4(that) && self2[symbol23](that)) {
          return true;
        } else {
          return structuralRegionState4.enabled && structuralRegionState4.tester ? structuralRegionState4.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState4.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v52, i52) => compareBoth4(v52, that[i52]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth4(self2[key], that[key]))) {
              return structuralRegionState4.tester ? structuralRegionState4.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState4.tester ? structuralRegionState4.tester(self2, that) : false;
    }
  }
  return structuralRegionState4.enabled && structuralRegionState4.tester ? structuralRegionState4.tester(self2, that) : false;
}
var isEqual4 = (u52) => hasProperty4(u52, symbol23);
var equivalence4 = () => equals4;
var NodeInspectSymbol4 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON4 = (x52) => {
  if (hasProperty4(x52, "toJSON") && isFunction33(x52["toJSON"]) && x52["toJSON"].length === 0) {
    return x52.toJSON();
  } else if (Array.isArray(x52)) {
    return x52.map(toJSON4);
  }
  return x52;
};
var format4 = (x52) => JSON.stringify(x52, null, 2);
var pipeArguments4 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i52 = 0, len = args.length; i52 < len; i52++) {
        ret = args[i52](ret);
      }
      return ret;
    }
  }
};
var OP_COMMIT2 = "Commit";
var OP_FAILURE3 = "Failure";
var OP_WITH_RUNTIME3 = "WithRuntime";
var EffectTypeId5 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId4 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId4 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId4 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance4 = {
  /* c8 ignore next */
  _R: (_52) => _52,
  /* c8 ignore next */
  _E: (_52) => _52,
  /* c8 ignore next */
  _A: (_52) => _52,
  _V: /* @__PURE__ */ getCurrentVersion4()
};
var sinkVariance4 = {
  /* c8 ignore next */
  _A: (_52) => _52,
  /* c8 ignore next */
  _In: (_52) => _52,
  /* c8 ignore next */
  _L: (_52) => _52,
  /* c8 ignore next */
  _E: (_52) => _52,
  /* c8 ignore next */
  _R: (_52) => _52
};
var channelVariance4 = {
  /* c8 ignore next */
  _Env: (_52) => _52,
  /* c8 ignore next */
  _InErr: (_52) => _52,
  /* c8 ignore next */
  _InElem: (_52) => _52,
  /* c8 ignore next */
  _InDone: (_52) => _52,
  /* c8 ignore next */
  _OutErr: (_52) => _52,
  /* c8 ignore next */
  _OutElem: (_52) => _52,
  /* c8 ignore next */
  _OutDone: (_52) => _52
};
var EffectPrototype4 = {
  [EffectTypeId5]: effectVariance4,
  [StreamTypeId4]: effectVariance4,
  [SinkTypeId4]: sinkVariance4,
  [ChannelTypeId4]: channelVariance4,
  [symbol23](that) {
    return this === that;
  },
  [symbol6]() {
    return cached4(this, random4(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen5(new YieldWrap4(this));
  },
  pipe() {
    return pipeArguments4(this, arguments);
  }
};
var StructuralPrototype2 = {
  [symbol6]() {
    return cached4(this, structure2(this));
  },
  [symbol23](that) {
    const selfKeys = Object.keys(this);
    const thatKeys = Object.keys(that);
    if (selfKeys.length !== thatKeys.length) {
      return false;
    }
    for (const key of selfKeys) {
      if (!(key in that && equals4(this[key], that[key]))) {
        return false;
      }
    }
    return true;
  }
};
var CommitPrototype2 = {
  ...EffectPrototype4,
  _op: OP_COMMIT2
};
var StructuralCommitPrototype2 = {
  ...CommitPrototype2,
  ...StructuralPrototype2
};
var TypeId10 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto6 = {
  ...EffectPrototype4,
  [TypeId10]: {
    _A: (_52) => _52
  },
  [NodeInspectSymbol4]() {
    return this.toJSON();
  },
  toString() {
    return format4(this.toJSON());
  }
};
var SomeProto4 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto6), {
  _tag: "Some",
  _op: "Some",
  [symbol23](that) {
    return isOption6(that) && isSome6(that) && equals4(this.value, that.value);
  },
  [symbol6]() {
    return cached4(this, combine5(hash4(this._tag))(hash4(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON4(this.value)
    };
  }
});
var NoneHash4 = /* @__PURE__ */ hash4("None");
var NoneProto4 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto6), {
  _tag: "None",
  _op: "None",
  [symbol23](that) {
    return isOption6(that) && isNone6(that);
  },
  [symbol6]() {
    return NoneHash4;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption6 = (input) => hasProperty4(input, TypeId10);
var isNone6 = (fa) => fa._tag === "None";
var isSome6 = (fa) => fa._tag === "Some";
var none6 = /* @__PURE__ */ Object.create(NoneProto4);
var some23 = (value) => {
  const a52 = Object.create(SomeProto4);
  a52.value = value;
  return a52;
};
var TypeId23 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto23 = {
  ...EffectPrototype4,
  [TypeId23]: {
    _R: (_52) => _52
  },
  [NodeInspectSymbol4]() {
    return this.toJSON();
  },
  toString() {
    return format4(this.toJSON());
  }
};
var RightProto4 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto23), {
  _tag: "Right",
  _op: "Right",
  [symbol23](that) {
    return isEither4(that) && isRight5(that) && equals4(this.right, that.right);
  },
  [symbol6]() {
    return combine5(hash4(this._tag))(hash4(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON4(this.right)
    };
  }
});
var LeftProto4 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto23), {
  _tag: "Left",
  _op: "Left",
  [symbol23](that) {
    return isEither4(that) && isLeft5(that) && equals4(this.left, that.left);
  },
  [symbol6]() {
    return combine5(hash4(this._tag))(hash4(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON4(this.left)
    };
  }
});
var isEither4 = (input) => hasProperty4(input, TypeId23);
var isLeft5 = (ma) => ma._tag === "Left";
var isRight5 = (ma) => ma._tag === "Right";
var left5 = (left334) => {
  const a52 = Object.create(LeftProto4);
  a52.left = left334;
  return a52;
};
var right5 = (right334) => {
  const a52 = Object.create(RightProto4);
  a52.right = right334;
  return a52;
};
var getLeft6 = (self2) => isRight5(self2) ? none6 : some23(self2.left);
var getRight6 = (self2) => isLeft5(self2) ? none6 : some23(self2.right);
var right23 = right5;
var left23 = left5;
var Option_exports4 = {};
__export4(Option_exports4, {
  Do: () => Do5,
  TypeId: () => TypeId33,
  all: () => all23,
  andThen: () => andThen4,
  ap: () => ap4,
  as: () => as4,
  asVoid: () => asVoid4,
  bind: () => bind23,
  bindTo: () => bindTo23,
  composeK: () => composeK4,
  contains: () => contains5,
  containsWith: () => containsWith5,
  exists: () => exists4,
  filter: () => filter5,
  filterMap: () => filterMap5,
  firstSomeOf: () => firstSomeOf4,
  flatMap: () => flatMap5,
  flatMapNullable: () => flatMapNullable5,
  flatten: () => flatten5,
  fromIterable: () => fromIterable6,
  fromNullable: () => fromNullable5,
  gen: () => gen4,
  getEquivalence: () => getEquivalence6,
  getLeft: () => getLeft23,
  getOrElse: () => getOrElse4,
  getOrNull: () => getOrNull4,
  getOrThrow: () => getOrThrow4,
  getOrThrowWith: () => getOrThrowWith4,
  getOrUndefined: () => getOrUndefined4,
  getOrder: () => getOrder5,
  getRight: () => getRight23,
  isNone: () => isNone23,
  isOption: () => isOption23,
  isSome: () => isSome23,
  let: () => let_23,
  lift2: () => lift24,
  liftNullable: () => liftNullable5,
  liftPredicate: () => liftPredicate5,
  liftThrowable: () => liftThrowable4,
  map: () => map5,
  match: () => match23,
  none: () => none23,
  orElse: () => orElse4,
  orElseEither: () => orElseEither4,
  orElseSome: () => orElseSome4,
  partitionMap: () => partitionMap5,
  product: () => product23,
  productMany: () => productMany23,
  reduceCompact: () => reduceCompact4,
  some: () => some33,
  tap: () => tap4,
  toArray: () => toArray4,
  toRefinement: () => toRefinement4,
  void: () => void_4,
  zipLeft: () => zipLeft4,
  zipRight: () => zipRight4,
  zipWith: () => zipWith5
});
var make23 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId33 = /* @__PURE__ */ Symbol.for("effect/Option");
var none23 = () => none6;
var some33 = some23;
var isOption23 = isOption6;
var isNone23 = isNone6;
var isSome23 = isSome6;
var match23 = /* @__PURE__ */ dual4(2, (self2, {
  onNone,
  onSome
}) => isNone23(self2) ? onNone() : onSome(self2.value));
var toRefinement4 = (f52) => (a52) => isSome23(f52(a52));
var fromIterable6 = (collection) => {
  for (const a52 of collection) {
    return some33(a52);
  }
  return none23();
};
var getRight23 = getRight6;
var getLeft23 = getLeft6;
var getOrElse4 = /* @__PURE__ */ dual4(2, (self2, onNone) => isNone23(self2) ? onNone() : self2.value);
var orElse4 = /* @__PURE__ */ dual4(2, (self2, that) => isNone23(self2) ? that() : self2);
var orElseSome4 = /* @__PURE__ */ dual4(2, (self2, onNone) => isNone23(self2) ? some33(onNone()) : self2);
var orElseEither4 = /* @__PURE__ */ dual4(2, (self2, that) => isNone23(self2) ? map5(that(), right5) : map5(self2, left5));
var firstSomeOf4 = (collection) => {
  let out = none23();
  for (out of collection) {
    if (isSome23(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable5 = (nullableValue) => nullableValue == null ? none23() : some33(nullableValue);
var liftNullable5 = (f52) => (...a52) => fromNullable5(f52(...a52));
var getOrNull4 = /* @__PURE__ */ getOrElse4(constNull4);
var getOrUndefined4 = /* @__PURE__ */ getOrElse4(constUndefined4);
var liftThrowable4 = (f52) => (...a52) => {
  try {
    return some33(f52(...a52));
  } catch (e52) {
    return none23();
  }
};
var getOrThrowWith4 = /* @__PURE__ */ dual4(2, (self2, onNone) => {
  if (isSome23(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow4 = /* @__PURE__ */ getOrThrowWith4(() => new Error("getOrThrow called on a None"));
var map5 = /* @__PURE__ */ dual4(2, (self2, f52) => isNone23(self2) ? none23() : some33(f52(self2.value)));
var as4 = /* @__PURE__ */ dual4(2, (self2, b52) => map5(self2, () => b52));
var asVoid4 = /* @__PURE__ */ as4(void 0);
var void_4 = /* @__PURE__ */ some33(void 0);
var flatMap5 = /* @__PURE__ */ dual4(2, (self2, f52) => isNone23(self2) ? none23() : f52(self2.value));
var andThen4 = /* @__PURE__ */ dual4(2, (self2, f52) => flatMap5(self2, (a52) => {
  const b52 = isFunction23(f52) ? f52(a52) : f52;
  return isOption23(b52) ? b52 : some33(b52);
}));
var flatMapNullable5 = /* @__PURE__ */ dual4(2, (self2, f52) => isNone23(self2) ? none23() : fromNullable5(f52(self2.value)));
var flatten5 = /* @__PURE__ */ flatMap5(identity4);
var zipRight4 = /* @__PURE__ */ dual4(2, (self2, that) => flatMap5(self2, () => that));
var composeK4 = /* @__PURE__ */ dual4(2, (afb, bfc) => (a52) => flatMap5(afb(a52), bfc));
var zipLeft4 = /* @__PURE__ */ dual4(2, (self2, that) => tap4(self2, () => that));
var tap4 = /* @__PURE__ */ dual4(2, (self2, f52) => flatMap5(self2, (a52) => map5(f52(a52), () => a52)));
var product23 = (self2, that) => isSome23(self2) && isSome23(that) ? some33([self2.value, that.value]) : none23();
var productMany23 = (self2, collection) => {
  if (isNone23(self2)) {
    return none23();
  }
  const out = [self2.value];
  for (const o52 of collection) {
    if (isNone23(o52)) {
      return none23();
    }
    out.push(o52.value);
  }
  return some33(out);
};
var all23 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o52 of input) {
      if (isNone23(o52)) {
        return none23();
      }
      out2.push(o52.value);
    }
    return some33(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o52 = input[key];
    if (isNone23(o52)) {
      return none23();
    }
    out[key] = o52.value;
  }
  return some33(out);
};
var zipWith5 = /* @__PURE__ */ dual4(3, (self2, that, f52) => map5(product23(self2, that), ([a52, b52]) => f52(a52, b52)));
var ap4 = /* @__PURE__ */ dual4(2, (self2, that) => zipWith5(self2, that, (f52, a52) => f52(a52)));
var reduceCompact4 = /* @__PURE__ */ dual4(3, (self2, b52, f52) => {
  let out = b52;
  for (const oa of self2) {
    if (isSome23(oa)) {
      out = f52(out, oa.value);
    }
  }
  return out;
});
var toArray4 = (self2) => isNone23(self2) ? [] : [self2.value];
var partitionMap5 = /* @__PURE__ */ dual4(2, (self2, f52) => {
  if (isNone23(self2)) {
    return [none23(), none23()];
  }
  const e52 = f52(self2.value);
  return isLeft5(e52) ? [some33(e52.left), none23()] : [none23(), some33(e52.right)];
});
var filterMap5 = /* @__PURE__ */ dual4(2, (self2, f52) => isNone23(self2) ? none23() : f52(self2.value));
var filter5 = /* @__PURE__ */ dual4(2, (self2, predicate) => filterMap5(self2, (b52) => predicate(b52) ? some23(b52) : none6));
var getEquivalence6 = (isEquivalent) => make12((x52, y52) => x52 === y52 || (isNone23(x52) ? isNone23(y52) : isNone23(y52) ? false : isEquivalent(x52.value, y52.value)));
var getOrder5 = (O52) => make23((self2, that) => isSome23(self2) ? isSome23(that) ? O52(self2.value, that.value) : 1 : -1);
var lift24 = (f52) => dual4(2, (self2, that) => zipWith5(self2, that, f52));
var liftPredicate5 = (predicate) => (b52) => predicate(b52) ? some33(b52) : none23();
var containsWith5 = (isEquivalent) => dual4(2, (self2, a52) => isNone23(self2) ? false : isEquivalent(self2.value, a52));
var _equivalence6 = /* @__PURE__ */ equivalence4();
var contains5 = /* @__PURE__ */ containsWith5(_equivalence6);
var exists4 = /* @__PURE__ */ dual4(2, (self2, refinement) => isNone23(self2) ? false : refinement(self2.value));
var bindTo23 = /* @__PURE__ */ bindTo7(map5);
var let_23 = /* @__PURE__ */ let_7(map5);
var bind23 = /* @__PURE__ */ bind7(map5, flatMap5);
var Do5 = /* @__PURE__ */ some33({});
var adapter23 = /* @__PURE__ */ adapter6();
var gen4 = (f52) => {
  const iterator = f52(adapter23);
  let state = iterator.next();
  if (state.done) {
    return some33(state.value);
  } else {
    let current = state.value;
    if (isGenKind4(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet4(current);
    }
    if (isNone23(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind4(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet4(current);
        }
        if (isNone23(current)) {
          return current;
        }
      }
    }
    return some33(state.value);
  }
};
var fromIterable23 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var reverse5 = (self2) => Array.from(self2).reverse();
var reduce6 = /* @__PURE__ */ dual4(3, (self2, b52, f52) => fromIterable23(self2).reduce((b232, a52, i52) => f52(b232, a52, i52), b52));
var TagTypeId3 = /* @__PURE__ */ Symbol.for("effect/Context/Tag");
var STMSymbolKey3 = "effect/STM";
var STMTypeId3 = /* @__PURE__ */ Symbol.for(STMSymbolKey3);
var TagProto3 = {
  ...EffectPrototype4,
  _tag: "Tag",
  _op: "Tag",
  [STMTypeId3]: effectVariance4,
  [TagTypeId3]: {
    _Service: (_52) => _52,
    _Identifier: (_52) => _52
  },
  toString() {
    return format4(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Tag",
      key: this.key,
      stack: this.stack
    };
  },
  [NodeInspectSymbol4]() {
    return this.toJSON();
  },
  of(self2) {
    return self2;
  },
  context(self2) {
    return make33(this, self2);
  }
};
var makeGenericTag3 = (key) => {
  const limit = Error.stackTraceLimit;
  Error.stackTraceLimit = 2;
  const creationError = new Error();
  Error.stackTraceLimit = limit;
  const tag = Object.create(TagProto3);
  Object.defineProperty(tag, "stack", {
    get() {
      return creationError.stack;
    }
  });
  tag.key = key;
  return tag;
};
var TypeId43 = /* @__PURE__ */ Symbol.for("effect/Context");
var ContextProto3 = {
  [TypeId43]: {
    _Services: (_52) => _52
  },
  [symbol23](that) {
    if (isContext3(that)) {
      if (this.unsafeMap.size === that.unsafeMap.size) {
        for (const k52 of this.unsafeMap.keys()) {
          if (!that.unsafeMap.has(k52) || !equals4(this.unsafeMap.get(k52), that.unsafeMap.get(k52))) {
            return false;
          }
        }
        return true;
      }
    }
    return false;
  },
  [symbol6]() {
    return cached4(this, number5(this.unsafeMap.size));
  },
  pipe() {
    return pipeArguments4(this, arguments);
  },
  toString() {
    return format4(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Context",
      services: Array.from(this.unsafeMap).map(toJSON4)
    };
  },
  [NodeInspectSymbol4]() {
    return this.toJSON();
  }
};
var makeContext3 = (unsafeMap) => {
  const context = Object.create(ContextProto3);
  context.unsafeMap = unsafeMap;
  return context;
};
var isContext3 = (u52) => hasProperty4(u52, TypeId43);
var _empty7 = /* @__PURE__ */ makeContext3(/* @__PURE__ */ new Map());
var empty11 = () => _empty7;
var make33 = (tag, service) => makeContext3(/* @__PURE__ */ new Map([[tag.key, service]]));
var GenericTag3 = makeGenericTag3;
var empty23 = empty11;
var TypeId53 = /* @__PURE__ */ Symbol.for("effect/Chunk");
function copy4(src, srcPos, dest, destPos, len) {
  for (let i52 = srcPos; i52 < Math.min(src.length, srcPos + len); i52++) {
    dest[destPos + i52 - srcPos] = src[i52];
  }
  return dest;
}
var emptyArray3 = [];
var getEquivalence23 = (isEquivalent) => make12((self2, that) => self2.length === that.length && toReadonlyArray3(self2).every((value, i52) => isEquivalent(value, unsafeGet23(that, i52))));
var _equivalence23 = /* @__PURE__ */ getEquivalence23(equals4);
var ChunkProto3 = {
  [TypeId53]: {
    _A: (_52) => _52
  },
  toString() {
    return format4(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Chunk",
      values: toReadonlyArray3(this).map(toJSON4)
    };
  },
  [NodeInspectSymbol4]() {
    return this.toJSON();
  },
  [symbol23](that) {
    return isChunk3(that) && _equivalence23(this, that);
  },
  [symbol6]() {
    return cached4(this, array7(toReadonlyArray3(this)));
  },
  [Symbol.iterator]() {
    switch (this.backing._tag) {
      case "IArray": {
        return this.backing.array[Symbol.iterator]();
      }
      case "IEmpty": {
        return emptyArray3[Symbol.iterator]();
      }
      default: {
        return toReadonlyArray3(this)[Symbol.iterator]();
      }
    }
  },
  pipe() {
    return pipeArguments4(this, arguments);
  }
};
var makeChunk3 = (backing) => {
  const chunk = Object.create(ChunkProto3);
  chunk.backing = backing;
  switch (backing._tag) {
    case "IEmpty": {
      chunk.length = 0;
      chunk.depth = 0;
      chunk.left = chunk;
      chunk.right = chunk;
      break;
    }
    case "IConcat": {
      chunk.length = backing.left.length + backing.right.length;
      chunk.depth = 1 + Math.max(backing.left.depth, backing.right.depth);
      chunk.left = backing.left;
      chunk.right = backing.right;
      break;
    }
    case "IArray": {
      chunk.length = backing.array.length;
      chunk.depth = 0;
      chunk.left = _empty23;
      chunk.right = _empty23;
      break;
    }
    case "ISingleton": {
      chunk.length = 1;
      chunk.depth = 0;
      chunk.left = _empty23;
      chunk.right = _empty23;
      break;
    }
    case "ISlice": {
      chunk.length = backing.length;
      chunk.depth = backing.chunk.depth + 1;
      chunk.left = _empty23;
      chunk.right = _empty23;
      break;
    }
  }
  return chunk;
};
var isChunk3 = (u52) => hasProperty4(u52, TypeId53);
var _empty23 = /* @__PURE__ */ makeChunk3({
  _tag: "IEmpty"
});
var empty33 = () => _empty23;
var make43 = (...as253) => as253.length === 1 ? of4(as253[0]) : unsafeFromNonEmptyArray3(as253);
var of4 = (a52) => makeChunk3({
  _tag: "ISingleton",
  a: a52
});
var copyToArray3 = (self2, array334, initial) => {
  switch (self2.backing._tag) {
    case "IArray": {
      copy4(self2.backing.array, 0, array334, initial, self2.length);
      break;
    }
    case "IConcat": {
      copyToArray3(self2.left, array334, initial);
      copyToArray3(self2.right, array334, initial + self2.left.length);
      break;
    }
    case "ISingleton": {
      array334[initial] = self2.backing.a;
      break;
    }
    case "ISlice": {
      let i52 = 0;
      let j52 = initial;
      while (i52 < self2.length) {
        array334[j52] = unsafeGet23(self2, i52);
        i52 += 1;
        j52 += 1;
      }
      break;
    }
  }
};
var toReadonlyArray3 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      return emptyArray3;
    }
    case "IArray": {
      return self2.backing.array;
    }
    default: {
      const arr = new Array(self2.length);
      copyToArray3(self2, arr, 0);
      self2.backing = {
        _tag: "IArray",
        array: arr
      };
      self2.left = _empty23;
      self2.right = _empty23;
      self2.depth = 0;
      return arr;
    }
  }
};
var reverse23 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty":
    case "ISingleton":
      return self2;
    case "IArray": {
      return makeChunk3({
        _tag: "IArray",
        array: reverse5(self2.backing.array)
      });
    }
    case "IConcat": {
      return makeChunk3({
        _tag: "IConcat",
        left: reverse23(self2.backing.right),
        right: reverse23(self2.backing.left)
      });
    }
    case "ISlice":
      return unsafeFromArray3(reverse5(toReadonlyArray3(self2)));
  }
};
var unsafeFromArray3 = (self2) => makeChunk3({
  _tag: "IArray",
  array: self2
});
var unsafeFromNonEmptyArray3 = (self2) => unsafeFromArray3(self2);
var unsafeGet23 = /* @__PURE__ */ dual4(2, (self2, index) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      throw new Error(`Index out of bounds`);
    }
    case "ISingleton": {
      if (index !== 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.a;
    }
    case "IArray": {
      if (index >= self2.length || index < 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.array[index];
    }
    case "IConcat": {
      return index < self2.left.length ? unsafeGet23(self2.left, index) : unsafeGet23(self2.right, index - self2.left.length);
    }
    case "ISlice": {
      return unsafeGet23(self2.backing.chunk, index + self2.backing.offset);
    }
  }
});
var prepend4 = /* @__PURE__ */ dual4(2, (self2, elem) => appendAll4(of4(elem), self2));
var drop4 = /* @__PURE__ */ dual4(2, (self2, n52) => {
  if (n52 <= 0) {
    return self2;
  } else if (n52 >= self2.length) {
    return _empty23;
  } else {
    switch (self2.backing._tag) {
      case "ISlice": {
        return makeChunk3({
          _tag: "ISlice",
          chunk: self2.backing.chunk,
          offset: self2.backing.offset + n52,
          length: self2.backing.length - n52
        });
      }
      case "IConcat": {
        if (n52 > self2.left.length) {
          return drop4(self2.right, n52 - self2.left.length);
        }
        return makeChunk3({
          _tag: "IConcat",
          left: drop4(self2.left, n52),
          right: self2.right
        });
      }
      default: {
        return makeChunk3({
          _tag: "ISlice",
          chunk: self2,
          offset: n52,
          length: self2.length - n52
        });
      }
    }
  }
});
var appendAll4 = /* @__PURE__ */ dual4(2, (self2, that) => {
  if (self2.backing._tag === "IEmpty") {
    return that;
  }
  if (that.backing._tag === "IEmpty") {
    return self2;
  }
  const diff234 = that.depth - self2.depth;
  if (Math.abs(diff234) <= 1) {
    return makeChunk3({
      _tag: "IConcat",
      left: self2,
      right: that
    });
  } else if (diff234 < -1) {
    if (self2.left.depth >= self2.right.depth) {
      const nr = appendAll4(self2.right, that);
      return makeChunk3({
        _tag: "IConcat",
        left: self2.left,
        right: nr
      });
    } else {
      const nrr = appendAll4(self2.right.right, that);
      if (nrr.depth === self2.depth - 3) {
        const nr = makeChunk3({
          _tag: "IConcat",
          left: self2.right.left,
          right: nrr
        });
        return makeChunk3({
          _tag: "IConcat",
          left: self2.left,
          right: nr
        });
      } else {
        const nl = makeChunk3({
          _tag: "IConcat",
          left: self2.left,
          right: self2.right.left
        });
        return makeChunk3({
          _tag: "IConcat",
          left: nl,
          right: nrr
        });
      }
    }
  } else {
    if (that.right.depth >= that.left.depth) {
      const nl = appendAll4(self2, that.left);
      return makeChunk3({
        _tag: "IConcat",
        left: nl,
        right: that.right
      });
    } else {
      const nll = appendAll4(self2, that.left.left);
      if (nll.depth === that.depth - 3) {
        const nl = makeChunk3({
          _tag: "IConcat",
          left: nll,
          right: that.left.right
        });
        return makeChunk3({
          _tag: "IConcat",
          left: nl,
          right: that.right
        });
      } else {
        const nr = makeChunk3({
          _tag: "IConcat",
          left: that.left.right,
          right: that.right
        });
        return makeChunk3({
          _tag: "IConcat",
          left: nll,
          right: nr
        });
      }
    }
  }
});
var isEmpty3 = (self2) => self2.length === 0;
var isNonEmpty3 = (self2) => self2.length > 0;
var unsafeHead3 = (self2) => unsafeGet23(self2, 0);
var headNonEmpty4 = unsafeHead3;
var tailNonEmpty4 = (self2) => drop4(self2, 1);
var SIZE3 = 5;
var BUCKET_SIZE3 = /* @__PURE__ */ Math.pow(2, SIZE3);
var MASK3 = BUCKET_SIZE3 - 1;
var MAX_INDEX_NODE3 = BUCKET_SIZE3 / 2;
var MIN_ARRAY_NODE3 = BUCKET_SIZE3 / 4;
function popcount3(x52) {
  x52 -= x52 >> 1 & 1431655765;
  x52 = (x52 & 858993459) + (x52 >> 2 & 858993459);
  x52 = x52 + (x52 >> 4) & 252645135;
  x52 += x52 >> 8;
  x52 += x52 >> 16;
  return x52 & 127;
}
function hashFragment3(shift32, h52) {
  return h52 >>> shift32 & MASK3;
}
function toBitmap3(x52) {
  return 1 << x52;
}
function fromBitmap3(bitmap, bit) {
  return popcount3(bitmap & bit - 1);
}
var make53 = (value, previous) => ({
  value,
  previous
});
function arrayUpdate3(mutate234, at, v52, arr) {
  let out = arr;
  if (!mutate234) {
    const len = arr.length;
    out = new Array(len);
    for (let i52 = 0; i52 < len; ++i52) out[i52] = arr[i52];
  }
  out[at] = v52;
  return out;
}
function arraySpliceOut3(mutate234, at, arr) {
  const newLen = arr.length - 1;
  let i52 = 0;
  let g52 = 0;
  let out = arr;
  if (mutate234) {
    i52 = g52 = at;
  } else {
    out = new Array(newLen);
    while (i52 < at) out[g52++] = arr[i52++];
  }
  ++i52;
  while (i52 <= newLen) out[g52++] = arr[i52++];
  if (mutate234) {
    out.length = newLen;
  }
  return out;
}
function arraySpliceIn3(mutate234, at, v52, arr) {
  const len = arr.length;
  if (mutate234) {
    let i232 = len;
    while (i232 >= at) arr[i232--] = arr[i232];
    arr[at] = v52;
    return arr;
  }
  let i52 = 0, g52 = 0;
  const out = new Array(len + 1);
  while (i52 < at) out[g52++] = arr[i52++];
  out[at] = v52;
  while (i52 < len) out[++g52] = arr[i52++];
  return out;
}
var EmptyNode3 = class _EmptyNode3 {
  _tag = "EmptyNode";
  modify(edit, _shift, f52, hash253, key, size434) {
    const v52 = f52(none23());
    if (isNone23(v52)) return new _EmptyNode3();
    ++size434.value;
    return new LeafNode3(edit, hash253, key, v52);
  }
};
function isEmptyNode3(a52) {
  return isTagged4(a52, "EmptyNode");
}
function isLeafNode3(node) {
  return isEmptyNode3(node) || node._tag === "LeafNode" || node._tag === "CollisionNode";
}
function canEditNode3(node, edit) {
  return isEmptyNode3(node) ? false : edit === node.edit;
}
var LeafNode3 = class _LeafNode3 {
  edit;
  hash;
  key;
  value;
  _tag = "LeafNode";
  constructor(edit, hash253, key, value) {
    this.edit = edit;
    this.hash = hash253;
    this.key = key;
    this.value = value;
  }
  modify(edit, shift32, f52, hash253, key, size434) {
    if (equals4(key, this.key)) {
      const v232 = f52(this.value);
      if (v232 === this.value) return this;
      else if (isNone23(v232)) {
        --size434.value;
        return new EmptyNode3();
      }
      if (canEditNode3(this, edit)) {
        this.value = v232;
        return this;
      }
      return new _LeafNode3(edit, hash253, key, v232);
    }
    const v52 = f52(none23());
    if (isNone23(v52)) return this;
    ++size434.value;
    return mergeLeaves3(edit, shift32, this.hash, this, hash253, new _LeafNode3(edit, hash253, key, v52));
  }
};
var CollisionNode3 = class _CollisionNode3 {
  edit;
  hash;
  children;
  _tag = "CollisionNode";
  constructor(edit, hash253, children) {
    this.edit = edit;
    this.hash = hash253;
    this.children = children;
  }
  modify(edit, shift32, f52, hash253, key, size434) {
    if (hash253 === this.hash) {
      const canEdit = canEditNode3(this, edit);
      const list = this.updateCollisionList(canEdit, edit, this.hash, this.children, f52, key, size434);
      if (list === this.children) return this;
      return list.length > 1 ? new _CollisionNode3(edit, this.hash, list) : list[0];
    }
    const v52 = f52(none23());
    if (isNone23(v52)) return this;
    ++size434.value;
    return mergeLeaves3(edit, shift32, this.hash, this, hash253, new LeafNode3(edit, hash253, key, v52));
  }
  updateCollisionList(mutate234, edit, hash253, list, f52, key, size434) {
    const len = list.length;
    for (let i52 = 0; i52 < len; ++i52) {
      const child = list[i52];
      if ("key" in child && equals4(key, child.key)) {
        const value = child.value;
        const newValue2 = f52(value);
        if (newValue2 === value) return list;
        if (isNone23(newValue2)) {
          --size434.value;
          return arraySpliceOut3(mutate234, i52, list);
        }
        return arrayUpdate3(mutate234, i52, new LeafNode3(edit, hash253, key, newValue2), list);
      }
    }
    const newValue = f52(none23());
    if (isNone23(newValue)) return list;
    ++size434.value;
    return arrayUpdate3(mutate234, len, new LeafNode3(edit, hash253, key, newValue), list);
  }
};
var IndexedNode3 = class _IndexedNode3 {
  edit;
  mask;
  children;
  _tag = "IndexedNode";
  constructor(edit, mask, children) {
    this.edit = edit;
    this.mask = mask;
    this.children = children;
  }
  modify(edit, shift32, f52, hash253, key, size434) {
    const mask = this.mask;
    const children = this.children;
    const frag = hashFragment3(shift32, hash253);
    const bit = toBitmap3(frag);
    const indx = fromBitmap3(mask, bit);
    const exists253 = mask & bit;
    const canEdit = canEditNode3(this, edit);
    if (!exists253) {
      const _newChild = new EmptyNode3().modify(edit, shift32 + SIZE3, f52, hash253, key, size434);
      if (!_newChild) return this;
      return children.length >= MAX_INDEX_NODE3 ? expand3(edit, frag, _newChild, mask, children) : new _IndexedNode3(edit, mask | bit, arraySpliceIn3(canEdit, indx, _newChild, children));
    }
    const current = children[indx];
    const child = current.modify(edit, shift32 + SIZE3, f52, hash253, key, size434);
    if (current === child) return this;
    let bitmap = mask;
    let newChildren;
    if (isEmptyNode3(child)) {
      bitmap &= ~bit;
      if (!bitmap) return new EmptyNode3();
      if (children.length <= 2 && isLeafNode3(children[indx ^ 1])) {
        return children[indx ^ 1];
      }
      newChildren = arraySpliceOut3(canEdit, indx, children);
    } else {
      newChildren = arrayUpdate3(canEdit, indx, child, children);
    }
    if (canEdit) {
      this.mask = bitmap;
      this.children = newChildren;
      return this;
    }
    return new _IndexedNode3(edit, bitmap, newChildren);
  }
};
var ArrayNode3 = class _ArrayNode3 {
  edit;
  size;
  children;
  _tag = "ArrayNode";
  constructor(edit, size434, children) {
    this.edit = edit;
    this.size = size434;
    this.children = children;
  }
  modify(edit, shift32, f52, hash253, key, size434) {
    let count = this.size;
    const children = this.children;
    const frag = hashFragment3(shift32, hash253);
    const child = children[frag];
    const newChild = (child || new EmptyNode3()).modify(edit, shift32 + SIZE3, f52, hash253, key, size434);
    if (child === newChild) return this;
    const canEdit = canEditNode3(this, edit);
    let newChildren;
    if (isEmptyNode3(child) && !isEmptyNode3(newChild)) {
      ++count;
      newChildren = arrayUpdate3(canEdit, frag, newChild, children);
    } else if (!isEmptyNode3(child) && isEmptyNode3(newChild)) {
      --count;
      if (count <= MIN_ARRAY_NODE3) {
        return pack3(edit, count, frag, children);
      }
      newChildren = arrayUpdate3(canEdit, frag, new EmptyNode3(), children);
    } else {
      newChildren = arrayUpdate3(canEdit, frag, newChild, children);
    }
    if (canEdit) {
      this.size = count;
      this.children = newChildren;
      return this;
    }
    return new _ArrayNode3(edit, count, newChildren);
  }
};
function pack3(edit, count, removed, elements) {
  const children = new Array(count - 1);
  let g52 = 0;
  let bitmap = 0;
  for (let i52 = 0, len = elements.length; i52 < len; ++i52) {
    if (i52 !== removed) {
      const elem = elements[i52];
      if (elem && !isEmptyNode3(elem)) {
        children[g52++] = elem;
        bitmap |= 1 << i52;
      }
    }
  }
  return new IndexedNode3(edit, bitmap, children);
}
function expand3(edit, frag, child, bitmap, subNodes) {
  const arr = [];
  let bit = bitmap;
  let count = 0;
  for (let i52 = 0; bit; ++i52) {
    if (bit & 1) arr[i52] = subNodes[count++];
    bit >>>= 1;
  }
  arr[frag] = child;
  return new ArrayNode3(edit, count + 1, arr);
}
function mergeLeavesInner3(edit, shift32, h1, n1, h232, n232) {
  if (h1 === h232) return new CollisionNode3(edit, h1, [n232, n1]);
  const subH1 = hashFragment3(shift32, h1);
  const subH2 = hashFragment3(shift32, h232);
  if (subH1 === subH2) {
    return (child) => new IndexedNode3(edit, toBitmap3(subH1) | toBitmap3(subH2), [child]);
  } else {
    const children = subH1 < subH2 ? [n1, n232] : [n232, n1];
    return new IndexedNode3(edit, toBitmap3(subH1) | toBitmap3(subH2), children);
  }
}
function mergeLeaves3(edit, shift32, h1, n1, h232, n232) {
  let stack = void 0;
  let currentShift = shift32;
  while (true) {
    const res = mergeLeavesInner3(edit, currentShift, h1, n1, h232, n232);
    if (typeof res === "function") {
      stack = make53(res, stack);
      currentShift = currentShift + SIZE3;
    } else {
      let final = res;
      while (stack != null) {
        final = stack.value(final);
        stack = stack.previous;
      }
      return final;
    }
  }
}
var HashMapSymbolKey3 = "effect/HashMap";
var HashMapTypeId3 = /* @__PURE__ */ Symbol.for(HashMapSymbolKey3);
var HashMapProto3 = {
  [HashMapTypeId3]: HashMapTypeId3,
  [Symbol.iterator]() {
    return new HashMapIterator3(this, (k52, v52) => [k52, v52]);
  },
  [symbol6]() {
    let hash253 = hash4(HashMapSymbolKey3);
    for (const item of this) {
      hash253 ^= pipe4(hash4(item[0]), combine5(hash4(item[1])));
    }
    return cached4(this, hash253);
  },
  [symbol23](that) {
    if (isHashMap3(that)) {
      if (that._size !== this._size) {
        return false;
      }
      for (const item of this) {
        const elem = pipe4(that, getHash3(item[0], hash4(item[0])));
        if (isNone23(elem)) {
          return false;
        } else {
          if (!equals4(item[1], elem.value)) {
            return false;
          }
        }
      }
      return true;
    }
    return false;
  },
  toString() {
    return format4(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashMap",
      values: Array.from(this).map(toJSON4)
    };
  },
  [NodeInspectSymbol4]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments4(this, arguments);
  }
};
var makeImpl4 = (editable, edit, root, size434) => {
  const map632 = Object.create(HashMapProto3);
  map632._editable = editable;
  map632._edit = edit;
  map632._root = root;
  map632._size = size434;
  return map632;
};
var HashMapIterator3 = class _HashMapIterator3 {
  map;
  f;
  v;
  constructor(map632, f52) {
    this.map = map632;
    this.f = f52;
    this.v = visitLazy3(this.map._root, this.f, void 0);
  }
  next() {
    if (isNone23(this.v)) {
      return {
        done: true,
        value: void 0
      };
    }
    const v0 = this.v.value;
    this.v = applyCont3(v0.cont);
    return {
      done: false,
      value: v0.value
    };
  }
  [Symbol.iterator]() {
    return new _HashMapIterator3(this.map, this.f);
  }
};
var applyCont3 = (cont) => cont ? visitLazyChildren3(cont[0], cont[1], cont[2], cont[3], cont[4]) : none23();
var visitLazy3 = (node, f52, cont = void 0) => {
  switch (node._tag) {
    case "LeafNode": {
      if (isSome23(node.value)) {
        return some33({
          value: f52(node.key, node.value.value),
          cont
        });
      }
      return applyCont3(cont);
    }
    case "CollisionNode":
    case "ArrayNode":
    case "IndexedNode": {
      const children = node.children;
      return visitLazyChildren3(children.length, children, 0, f52, cont);
    }
    default: {
      return applyCont3(cont);
    }
  }
};
var visitLazyChildren3 = (len, children, i52, f52, cont) => {
  while (i52 < len) {
    const child = children[i52++];
    if (child && !isEmptyNode3(child)) {
      return visitLazy3(child, f52, [len, children, i52, f52, cont]);
    }
  }
  return applyCont3(cont);
};
var _empty33 = /* @__PURE__ */ makeImpl4(false, 0, /* @__PURE__ */ new EmptyNode3(), 0);
var empty43 = () => _empty33;
var isHashMap3 = (u52) => hasProperty4(u52, HashMapTypeId3);
var getHash3 = /* @__PURE__ */ dual4(3, (self2, key, hash253) => {
  let node = self2._root;
  let shift32 = 0;
  while (true) {
    switch (node._tag) {
      case "LeafNode": {
        return equals4(key, node.key) ? node.value : none23();
      }
      case "CollisionNode": {
        if (hash253 === node.hash) {
          const children = node.children;
          for (let i52 = 0, len = children.length; i52 < len; ++i52) {
            const child = children[i52];
            if ("key" in child && equals4(key, child.key)) {
              return child.value;
            }
          }
        }
        return none23();
      }
      case "IndexedNode": {
        const frag = hashFragment3(shift32, hash253);
        const bit = toBitmap3(frag);
        if (node.mask & bit) {
          node = node.children[fromBitmap3(node.mask, bit)];
          shift32 += SIZE3;
          break;
        }
        return none23();
      }
      case "ArrayNode": {
        node = node.children[hashFragment3(shift32, hash253)];
        if (node) {
          shift32 += SIZE3;
          break;
        }
        return none23();
      }
      default:
        return none23();
    }
  }
});
var set3 = /* @__PURE__ */ dual4(3, (self2, key, value) => modifyAt3(self2, key, () => some33(value)));
var setTree3 = /* @__PURE__ */ dual4(3, (self2, newRoot, newSize) => {
  if (self2._editable) {
    self2._root = newRoot;
    self2._size = newSize;
    return self2;
  }
  return newRoot === self2._root ? self2 : makeImpl4(self2._editable, self2._edit, newRoot, newSize);
});
var keys4 = (self2) => new HashMapIterator3(self2, (key) => key);
var size5 = (self2) => self2._size;
var beginMutation4 = (self2) => makeImpl4(true, self2._edit + 1, self2._root, self2._size);
var modifyAt3 = /* @__PURE__ */ dual4(3, (self2, key, f52) => modifyHash3(self2, key, hash4(key), f52));
var modifyHash3 = /* @__PURE__ */ dual4(4, (self2, key, hash253, f52) => {
  const size434 = {
    value: self2._size
  };
  const newRoot = self2._root.modify(self2._editable ? self2._edit : NaN, 0, f52, hash253, key, size434);
  return pipe4(self2, setTree3(newRoot, size434.value));
});
var forEach5 = /* @__PURE__ */ dual4(2, (self2, f52) => reduce23(self2, void 0, (_52, value, key) => f52(value, key)));
var reduce23 = /* @__PURE__ */ dual4(3, (self2, zero, f52) => {
  const root = self2._root;
  if (root._tag === "LeafNode") {
    return isSome23(root.value) ? f52(zero, root.value.value, root.key) : zero;
  }
  if (root._tag === "EmptyNode") {
    return zero;
  }
  const toVisit = [root.children];
  let children;
  while (children = toVisit.pop()) {
    for (let i52 = 0, len = children.length; i52 < len; ) {
      const child = children[i52++];
      if (child && !isEmptyNode3(child)) {
        if (child._tag === "LeafNode") {
          if (isSome23(child.value)) {
            zero = f52(zero, child.value.value, child.key);
          }
        } else {
          toVisit.push(child.children);
        }
      }
    }
  }
  return zero;
});
var HashSetSymbolKey3 = "effect/HashSet";
var HashSetTypeId3 = /* @__PURE__ */ Symbol.for(HashSetSymbolKey3);
var HashSetProto3 = {
  [HashSetTypeId3]: HashSetTypeId3,
  [Symbol.iterator]() {
    return keys4(this._keyMap);
  },
  [symbol6]() {
    return cached4(this, combine5(hash4(this._keyMap))(hash4(HashSetSymbolKey3)));
  },
  [symbol23](that) {
    if (isHashSet3(that)) {
      return size5(this._keyMap) === size5(that._keyMap) && equals4(this._keyMap, that._keyMap);
    }
    return false;
  },
  toString() {
    return format4(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashSet",
      values: Array.from(this).map(toJSON4)
    };
  },
  [NodeInspectSymbol4]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments4(this, arguments);
  }
};
var makeImpl23 = (keyMap) => {
  const set253 = Object.create(HashSetProto3);
  set253._keyMap = keyMap;
  return set253;
};
var isHashSet3 = (u52) => hasProperty4(u52, HashSetTypeId3);
var _empty43 = /* @__PURE__ */ makeImpl23(/* @__PURE__ */ empty43());
var empty53 = () => _empty43;
var size23 = (self2) => size5(self2._keyMap);
var beginMutation23 = (self2) => makeImpl23(beginMutation4(self2._keyMap));
var endMutation3 = (self2) => {
  self2._keyMap._editable = false;
  return self2;
};
var mutate3 = /* @__PURE__ */ dual4(2, (self2, f52) => {
  const transient = beginMutation23(self2);
  f52(transient);
  return endMutation3(transient);
});
var add23 = /* @__PURE__ */ dual4(2, (self2, value) => self2._keyMap._editable ? (set3(value, true)(self2._keyMap), self2) : makeImpl23(set3(value, true)(self2._keyMap)));
var union23 = /* @__PURE__ */ dual4(2, (self2, that) => mutate3(empty53(), (set253) => {
  forEach23(self2, (value) => add23(set253, value));
  for (const value of that) {
    add23(set253, value);
  }
}));
var forEach23 = /* @__PURE__ */ dual4(2, (self2, f52) => forEach5(self2._keyMap, (_52, k52) => f52(k52)));
var empty63 = empty53;
var size33 = size23;
var add33 = add23;
var union33 = union23;
var ArrayProto3 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(Array.prototype), {
  [symbol6]() {
    return cached4(this, array7(this));
  },
  [symbol23](that) {
    if (Array.isArray(that) && this.length === that.length) {
      return this.every((v52, i52) => equals4(v52, that[i52]));
    } else {
      return false;
    }
  }
});
var Structural4 = /* @__PURE__ */ function() {
  function Structural334(args) {
    if (args) {
      Object.assign(this, args);
    }
  }
  Structural334.prototype = StructuralPrototype2;
  return Structural334;
}();
var struct23 = (as253) => Object.assign(Object.create(StructuralPrototype2), as253);
var ContextPatchTypeId3 = /* @__PURE__ */ Symbol.for("effect/DifferContextPatch");
function variance4(a52) {
  return a52;
}
var PatchProto3 = {
  ...Structural4.prototype,
  [ContextPatchTypeId3]: {
    _Value: variance4,
    _Patch: variance4
  }
};
var EmptyProto3 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto3), {
  _tag: "Empty"
});
var _empty53 = /* @__PURE__ */ Object.create(EmptyProto3);
var empty73 = () => _empty53;
var AndThenProto3 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto3), {
  _tag: "AndThen"
});
var makeAndThen3 = (first, second) => {
  const o52 = Object.create(AndThenProto3);
  o52.first = first;
  o52.second = second;
  return o52;
};
var AddServiceProto3 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto3), {
  _tag: "AddService"
});
var makeAddService3 = (key, service) => {
  const o52 = Object.create(AddServiceProto3);
  o52.key = key;
  o52.service = service;
  return o52;
};
var RemoveServiceProto3 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto3), {
  _tag: "RemoveService"
});
var makeRemoveService3 = (key) => {
  const o52 = Object.create(RemoveServiceProto3);
  o52.key = key;
  return o52;
};
var UpdateServiceProto3 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto3), {
  _tag: "UpdateService"
});
var makeUpdateService3 = (key, update232) => {
  const o52 = Object.create(UpdateServiceProto3);
  o52.key = key;
  o52.update = update232;
  return o52;
};
var diff3 = (oldValue, newValue) => {
  const missingServices = new Map(oldValue.unsafeMap);
  let patch234 = empty73();
  for (const [tag, newService] of newValue.unsafeMap.entries()) {
    if (missingServices.has(tag)) {
      const old = missingServices.get(tag);
      missingServices.delete(tag);
      if (!equals4(old, newService)) {
        patch234 = combine23(makeUpdateService3(tag, () => newService))(patch234);
      }
    } else {
      missingServices.delete(tag);
      patch234 = combine23(makeAddService3(tag, newService))(patch234);
    }
  }
  for (const [tag] of missingServices.entries()) {
    patch234 = combine23(makeRemoveService3(tag))(patch234);
  }
  return patch234;
};
var combine23 = /* @__PURE__ */ dual4(2, (self2, that) => makeAndThen3(self2, that));
var patch3 = /* @__PURE__ */ dual4(2, (self2, context) => {
  if (self2._tag === "Empty") {
    return context;
  }
  let wasServiceUpdated = false;
  let patches = of4(self2);
  const updatedContext = new Map(context.unsafeMap);
  while (isNonEmpty3(patches)) {
    const head232 = headNonEmpty4(patches);
    const tail42 = tailNonEmpty4(patches);
    switch (head232._tag) {
      case "Empty": {
        patches = tail42;
        break;
      }
      case "AddService": {
        updatedContext.set(head232.key, head232.service);
        patches = tail42;
        break;
      }
      case "AndThen": {
        patches = prepend4(prepend4(tail42, head232.second), head232.first);
        break;
      }
      case "RemoveService": {
        updatedContext.delete(head232.key);
        patches = tail42;
        break;
      }
      case "UpdateService": {
        updatedContext.set(head232.key, head232.update(updatedContext.get(head232.key)));
        wasServiceUpdated = true;
        patches = tail42;
        break;
      }
    }
  }
  if (!wasServiceUpdated) {
    return makeContext3(updatedContext);
  }
  const map632 = /* @__PURE__ */ new Map();
  for (const [tag] of context.unsafeMap) {
    if (updatedContext.has(tag)) {
      map632.set(tag, updatedContext.get(tag));
      updatedContext.delete(tag);
    }
  }
  for (const [tag, s52] of updatedContext) {
    map632.set(tag, s52);
  }
  return makeContext3(map632);
});
var DifferTypeId3 = /* @__PURE__ */ Symbol.for("effect/Differ");
var DifferProto3 = {
  [DifferTypeId3]: {
    _P: identity4,
    _V: identity4
  }
};
var make73 = (params) => {
  const differ = Object.create(DifferProto3);
  differ.empty = params.empty;
  differ.diff = params.diff;
  differ.combine = params.combine;
  differ.patch = params.patch;
  return differ;
};
var environment3 = () => make73({
  empty: empty73(),
  combine: (first, second) => combine23(second)(first),
  diff: (oldValue, newValue) => diff3(oldValue, newValue),
  patch: (patch234, oldValue) => patch3(oldValue)(patch234)
});
var OP_DIE3 = "Die";
var OP_EMPTY3 = "Empty";
var OP_FAIL3 = "Fail";
var OP_INTERRUPT3 = "Interrupt";
var OP_PARALLEL3 = "Parallel";
var OP_SEQUENTIAL3 = "Sequential";
var CauseSymbolKey3 = "effect/Cause";
var CauseTypeId3 = /* @__PURE__ */ Symbol.for(CauseSymbolKey3);
var variance23 = {
  /* c8 ignore next */
  _E: (_52) => _52
};
var proto3 = {
  [CauseTypeId3]: variance23,
  [symbol6]() {
    return pipe4(hash4(CauseSymbolKey3), combine5(hash4(flattenCause3(this))), cached4(this));
  },
  [symbol23](that) {
    return isCause3(that) && causeEquals3(this, that);
  },
  pipe() {
    return pipeArguments4(this, arguments);
  },
  toJSON() {
    switch (this._tag) {
      case "Empty":
        return {
          _id: "Cause",
          _tag: this._tag
        };
      case "Die":
        return {
          _id: "Cause",
          _tag: this._tag,
          defect: toJSON4(this.defect)
        };
      case "Interrupt":
        return {
          _id: "Cause",
          _tag: this._tag,
          fiberId: this.fiberId.toJSON()
        };
      case "Fail":
        return {
          _id: "Cause",
          _tag: this._tag,
          failure: toJSON4(this.error)
        };
      case "Sequential":
      case "Parallel":
        return {
          _id: "Cause",
          _tag: this._tag,
          left: toJSON4(this.left),
          right: toJSON4(this.right)
        };
    }
  },
  toString() {
    return pretty3(this);
  },
  [NodeInspectSymbol4]() {
    return this.toJSON();
  }
};
var fail4 = (error) => {
  const o52 = Object.create(proto3);
  o52._tag = OP_FAIL3;
  o52.error = error;
  return o52;
};
var parallel3 = (left334, right334) => {
  const o52 = Object.create(proto3);
  o52._tag = OP_PARALLEL3;
  o52.left = left334;
  o52.right = right334;
  return o52;
};
var sequential3 = (left334, right334) => {
  const o52 = Object.create(proto3);
  o52._tag = OP_SEQUENTIAL3;
  o52.left = left334;
  o52.right = right334;
  return o52;
};
var isCause3 = (u52) => hasProperty4(u52, CauseTypeId3);
var isInterruptedOnly3 = (self2) => reduceWithContext3(void 0, IsInterruptedOnlyCauseReducer3)(self2);
var causeEquals3 = (left334, right334) => {
  let leftStack = of4(left334);
  let rightStack = of4(right334);
  while (isNonEmpty3(leftStack) && isNonEmpty3(rightStack)) {
    const [leftParallel, leftSequential] = pipe4(headNonEmpty4(leftStack), reduce43([empty63(), empty33()], ([parallel234, sequential234], cause) => {
      const [par, seq] = evaluateCause3(cause);
      return some33([pipe4(parallel234, union33(par)), pipe4(sequential234, appendAll4(seq))]);
    }));
    const [rightParallel, rightSequential] = pipe4(headNonEmpty4(rightStack), reduce43([empty63(), empty33()], ([parallel234, sequential234], cause) => {
      const [par, seq] = evaluateCause3(cause);
      return some33([pipe4(parallel234, union33(par)), pipe4(sequential234, appendAll4(seq))]);
    }));
    if (!equals4(leftParallel, rightParallel)) {
      return false;
    }
    leftStack = leftSequential;
    rightStack = rightSequential;
  }
  return true;
};
var flattenCause3 = (cause) => {
  return flattenCauseLoop3(of4(cause), empty33());
};
var flattenCauseLoop3 = (causes, flattened) => {
  while (1) {
    const [parallel234, sequential234] = pipe4(causes, reduce6([empty63(), empty33()], ([parallel332, sequential332], cause) => {
      const [par, seq] = evaluateCause3(cause);
      return [pipe4(parallel332, union33(par)), pipe4(sequential332, appendAll4(seq))];
    }));
    const updated = size33(parallel234) > 0 ? pipe4(flattened, prepend4(parallel234)) : flattened;
    if (isEmpty3(sequential234)) {
      return reverse23(updated);
    }
    causes = sequential234;
    flattened = updated;
  }
  throw new Error(getBugErrorMessage4("Cause.flattenCauseLoop"));
};
var evaluateCause3 = (self2) => {
  let cause = self2;
  const stack = [];
  let _parallel = empty63();
  let _sequential = empty33();
  while (cause !== void 0) {
    switch (cause._tag) {
      case OP_EMPTY3: {
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_FAIL3: {
        _parallel = add33(_parallel, make43(cause._tag, cause.error));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_DIE3: {
        _parallel = add33(_parallel, make43(cause._tag, cause.defect));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_INTERRUPT3: {
        _parallel = add33(_parallel, make43(cause._tag, cause.fiberId));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_SEQUENTIAL3: {
        switch (cause.left._tag) {
          case OP_EMPTY3: {
            cause = cause.right;
            break;
          }
          case OP_SEQUENTIAL3: {
            cause = sequential3(cause.left.left, sequential3(cause.left.right, cause.right));
            break;
          }
          case OP_PARALLEL3: {
            cause = parallel3(sequential3(cause.left.left, cause.right), sequential3(cause.left.right, cause.right));
            break;
          }
          default: {
            _sequential = prepend4(_sequential, cause.right);
            cause = cause.left;
            break;
          }
        }
        break;
      }
      case OP_PARALLEL3: {
        stack.push(cause.right);
        cause = cause.left;
        break;
      }
    }
  }
  throw new Error(getBugErrorMessage4("Cause.evaluateCauseLoop"));
};
var IsInterruptedOnlyCauseReducer3 = {
  emptyCase: constTrue4,
  failCase: constFalse4,
  dieCase: constFalse4,
  interruptCase: constTrue4,
  sequentialCase: (_52, left334, right334) => left334 && right334,
  parallelCase: (_52, left334, right334) => left334 && right334
};
var OP_SEQUENTIAL_CASE3 = "SequentialCase";
var OP_PARALLEL_CASE3 = "ParallelCase";
var reduce43 = /* @__PURE__ */ dual4(3, (self2, zero, pf) => {
  let accumulator = zero;
  let cause = self2;
  const causes = [];
  while (cause !== void 0) {
    const option = pf(accumulator, cause);
    accumulator = isSome23(option) ? option.value : accumulator;
    switch (cause._tag) {
      case OP_SEQUENTIAL3: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      case OP_PARALLEL3: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      default: {
        cause = void 0;
        break;
      }
    }
    if (cause === void 0 && causes.length > 0) {
      cause = causes.pop();
    }
  }
  return accumulator;
});
var reduceWithContext3 = /* @__PURE__ */ dual4(3, (self2, context, reducer) => {
  const input = [self2];
  const output = [];
  while (input.length > 0) {
    const cause = input.pop();
    switch (cause._tag) {
      case OP_EMPTY3: {
        output.push(right23(reducer.emptyCase(context)));
        break;
      }
      case OP_FAIL3: {
        output.push(right23(reducer.failCase(context, cause.error)));
        break;
      }
      case OP_DIE3: {
        output.push(right23(reducer.dieCase(context, cause.defect)));
        break;
      }
      case OP_INTERRUPT3: {
        output.push(right23(reducer.interruptCase(context, cause.fiberId)));
        break;
      }
      case OP_SEQUENTIAL3: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left23({
          _tag: OP_SEQUENTIAL_CASE3
        }));
        break;
      }
      case OP_PARALLEL3: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left23({
          _tag: OP_PARALLEL_CASE3
        }));
        break;
      }
    }
  }
  const accumulator = [];
  while (output.length > 0) {
    const either = output.pop();
    switch (either._tag) {
      case "Left": {
        switch (either.left._tag) {
          case OP_SEQUENTIAL_CASE3: {
            const left334 = accumulator.pop();
            const right334 = accumulator.pop();
            const value = reducer.sequentialCase(context, left334, right334);
            accumulator.push(value);
            break;
          }
          case OP_PARALLEL_CASE3: {
            const left334 = accumulator.pop();
            const right334 = accumulator.pop();
            const value = reducer.parallelCase(context, left334, right334);
            accumulator.push(value);
            break;
          }
        }
        break;
      }
      case "Right": {
        accumulator.push(either.right);
        break;
      }
    }
  }
  if (accumulator.length === 0) {
    throw new Error("BUG: Cause.reduceWithContext - please report an issue at https://github.com/Effect-TS/effect/issues");
  }
  return accumulator.pop();
});
var pretty3 = (cause) => {
  if (isInterruptedOnly3(cause)) {
    return "All fibers interrupted without errors.";
  }
  return prettyErrors3(cause).map((e52) => e52.stack).join("\n");
};
var PrettyError3 = class extends globalThis.Error {
  span = void 0;
  constructor(originalError) {
    const prevLimit = Error.stackTraceLimit;
    Error.stackTraceLimit = 0;
    super(prettyErrorMessage3(originalError));
    Error.stackTraceLimit = prevLimit;
    this.name = originalError instanceof Error ? originalError.name : "Error";
    if (typeof originalError === "object" && originalError !== null) {
      if (spanSymbol4 in originalError) {
        this.span = originalError[spanSymbol4];
      }
      Object.keys(originalError).forEach((key) => {
        if (!(key in this)) {
          this[key] = originalError[key];
        }
      });
    }
    this.stack = prettyErrorStack3(this.message, originalError instanceof Error && originalError.stack ? originalError.stack : "", this.span);
  }
  toJSON() {
    const out = {
      message: this.message,
      stack: this.stack
    };
    if (this.span) {
      out.span = this.span;
    }
    return out;
  }
};
var prettyErrorMessage3 = (u52) => {
  if (typeof u52 === "string") {
    return `Error: ${u52}`;
  }
  try {
    if (hasProperty4(u52, "toString") && isFunction33(u52["toString"]) && u52["toString"] !== Object.prototype.toString && u52["toString"] !== globalThis.Array.prototype.toString) {
      return u52["toString"]();
    }
  } catch {
  }
  return `Error: ${JSON.stringify(u52)}`;
};
var locationRegex3 = /\((.*)\)/;
var spanToTrace3 = /* @__PURE__ */ globalValue4("effect/Tracer/spanToTrace", () => /* @__PURE__ */ new WeakMap());
var prettyErrorStack3 = (message, stack, span32) => {
  const out = [message];
  const lines = stack.split("\n");
  for (let i52 = 1; i52 < lines.length; i52++) {
    if (lines[i52].includes("Generator.next")) {
      break;
    }
    if (lines[i52].includes("effect_internal_function")) {
      out.pop();
      break;
    }
    out.push(lines[i52].replace(/at .*effect_instruction_i.*\((.*)\)/, "at $1").replace(/EffectPrimitive\.\w+/, "<anonymous>"));
  }
  if (span32) {
    let current = span32;
    let i52 = 0;
    while (current && current._tag === "Span" && i52 < 10) {
      const stackFn = spanToTrace3.get(current);
      if (typeof stackFn === "function") {
        const stack2 = stackFn();
        const locationMatch = stack2.match(locationRegex3);
        const location = locationMatch ? locationMatch[1] : stack2.replace(/^at /, "");
        out.push(`    at ${current.name} (${location})`);
      } else {
        out.push(`    at ${current.name}`);
      }
      current = getOrUndefined4(current.parent);
      i52++;
    }
  }
  return out.join("\n");
};
var spanSymbol4 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var prettyErrors3 = (cause) => reduceWithContext3(cause, void 0, {
  emptyCase: () => [],
  dieCase: (_52, unknownError) => {
    return [new PrettyError3(unknownError)];
  },
  failCase: (_52, error) => {
    return [new PrettyError3(error)];
  },
  interruptCase: () => [],
  parallelCase: (_52, l52, r52) => [...l52, ...r52],
  sequentialCase: (_52, l52, r52) => [...l52, ...r52]
});
var SingleShotGen23 = class _SingleShotGen7 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  next(a52) {
    return this.called ? {
      value: a52,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  return(a52) {
    return {
      value: a52,
      done: true
    };
  }
  throw(e52) {
    throw e52;
  }
  [Symbol.iterator]() {
    return new _SingleShotGen7(this.self);
  }
};
var spanTag3 = /* @__PURE__ */ GenericTag3("effect/ParentSpan");
var EffectTypeId23 = /* @__PURE__ */ Symbol.for("effect/Effect");
var EffectPrimitive3 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId23] = effectVariance4;
  constructor(_op) {
    this._op = _op;
  }
  [symbol23](that) {
    return this === that;
  }
  [symbol6]() {
    return cached4(this, random4(this));
  }
  pipe() {
    return pipeArguments4(this, arguments);
  }
  toJSON() {
    return {
      _id: "Effect",
      _op: this._op,
      effect_instruction_i0: toJSON4(this.effect_instruction_i0),
      effect_instruction_i1: toJSON4(this.effect_instruction_i1),
      effect_instruction_i2: toJSON4(this.effect_instruction_i2)
    };
  }
  toString() {
    return format4(this.toJSON());
  }
  [NodeInspectSymbol4]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen23(new YieldWrap4(this));
  }
};
var EffectPrimitiveFailure3 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId23] = effectVariance4;
  constructor(_op) {
    this._op = _op;
    this._tag = _op;
  }
  [symbol23](that) {
    return exitIsExit3(that) && that._op === "Failure" && // @ts-expect-error
    equals4(this.effect_instruction_i0, that.effect_instruction_i0);
  }
  [symbol6]() {
    return pipe4(
      // @ts-expect-error
      string5(this._tag),
      // @ts-expect-error
      combine5(hash4(this.effect_instruction_i0)),
      cached4(this)
    );
  }
  get cause() {
    return this.effect_instruction_i0;
  }
  pipe() {
    return pipeArguments4(this, arguments);
  }
  toJSON() {
    return {
      _id: "Exit",
      _tag: this._op,
      cause: this.cause.toJSON()
    };
  }
  toString() {
    return format4(this.toJSON());
  }
  [NodeInspectSymbol4]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen23(new YieldWrap4(this));
  }
};
var isEffect3 = (u52) => hasProperty4(u52, EffectTypeId23);
var withFiberRuntime3 = (withRuntime) => {
  const effect = new EffectPrimitive3(OP_WITH_RUNTIME3);
  effect.effect_instruction_i0 = withRuntime;
  return effect;
};
var spanSymbol23 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var originalSymbol3 = /* @__PURE__ */ Symbol.for("effect/OriginalAnnotation");
var capture3 = (obj, span32) => {
  if (isSome23(span32)) {
    return new Proxy(obj, {
      has(target, p52) {
        return p52 === spanSymbol23 || p52 === originalSymbol3 || p52 in target;
      },
      get(target, p52) {
        if (p52 === spanSymbol23) {
          return span32.value;
        }
        if (p52 === originalSymbol3) {
          return obj;
        }
        return target[p52];
      }
    });
  }
  return obj;
};
var fail23 = (error) => isObject4(error) && !(spanSymbol23 in error) ? withFiberRuntime3((fiber) => failCause3(fail4(capture3(error, currentSpanFromFiber3(fiber))))) : failCause3(fail4(error));
var failCause3 = (cause) => {
  const effect = new EffectPrimitiveFailure3(OP_FAILURE3);
  effect.effect_instruction_i0 = cause;
  return effect;
};
var FiberRefSymbolKey3 = "effect/FiberRef";
var FiberRefTypeId3 = /* @__PURE__ */ Symbol.for(FiberRefSymbolKey3);
var fiberRefVariance3 = {
  /* c8 ignore next */
  _A: (_52) => _52
};
var fiberRefUnsafeMakeContext3 = (initial) => {
  const differ = environment3();
  return fiberRefUnsafeMakePatch3(initial, {
    differ,
    fork: differ.empty
  });
};
var fiberRefUnsafeMakePatch3 = (initial, options) => ({
  [FiberRefTypeId3]: fiberRefVariance3,
  initial,
  diff: (oldValue, newValue) => options.differ.diff(oldValue, newValue),
  combine: (first, second) => options.differ.combine(first, second),
  patch: (patch234) => (oldValue) => options.differ.patch(patch234, oldValue),
  fork: options.fork,
  join: options.join ?? ((_52, n52) => n52),
  pipe() {
    return pipeArguments4(this, arguments);
  }
});
var currentContext3 = /* @__PURE__ */ globalValue4(/* @__PURE__ */ Symbol.for("effect/FiberRef/currentContext"), () => fiberRefUnsafeMakeContext3(empty23()));
var YieldableError3 = /* @__PURE__ */ function() {
  class YieldableError234 extends globalThis.Error {
    commit() {
      return fail23(this);
    }
    toString() {
      return this.message ? `${this.name}: ${this.message}` : this.name;
    }
    toJSON() {
      return {
        ...this
      };
    }
    [NodeInspectSymbol4]() {
      const stack = this.stack;
      if (stack) {
        return `${this.toString()}
${stack.split("\n").slice(1).join("\n")}`;
      }
      return this.toString();
    }
  }
  Object.assign(YieldableError234.prototype, StructuralCommitPrototype2);
  return YieldableError234;
}();
var exitIsExit3 = (u52) => isEffect3(u52) && "_tag" in u52 && (u52._tag === "Success" || u52._tag === "Failure");
var currentSpanFromFiber3 = (fiber) => {
  const span32 = fiber.getFiberRef(currentContext3).unsafeMap.get(spanTag3.key);
  return span32 !== void 0 && span32._tag === "Span" ? some33(span32) : none23();
};
var Data_exports2 = {};
__export4(Data_exports2, {
  Class: () => Class23,
  Error: () => Error23,
  Structural: () => Structural23,
  TaggedClass: () => TaggedClass3,
  TaggedError: () => TaggedError3,
  array: () => array23,
  case: () => _case3,
  struct: () => struct33,
  tagged: () => tagged3,
  taggedEnum: () => taggedEnum3,
  tuple: () => tuple23,
  unsafeArray: () => unsafeArray3,
  unsafeStruct: () => unsafeStruct3
});
var struct33 = struct23;
var unsafeStruct3 = (as253) => Object.setPrototypeOf(as253, StructuralPrototype2);
var tuple23 = (...as253) => unsafeArray3(as253);
var array23 = (as253) => unsafeArray3(as253.slice(0));
var unsafeArray3 = (as253) => Object.setPrototypeOf(as253, ArrayProto3);
var _case3 = () => (args) => args === void 0 ? Object.create(StructuralPrototype2) : struct33(args);
var tagged3 = (tag) => (args) => {
  const value = args === void 0 ? Object.create(StructuralPrototype2) : struct33(args);
  value._tag = tag;
  return value;
};
var Class23 = Structural4;
var TaggedClass3 = (tag) => {
  class Base extends Class23 {
    _tag = tag;
  }
  return Base;
};
var Structural23 = Structural4;
var taggedEnum3 = () => new Proxy({}, {
  get(_target, tag, _receiver) {
    if (tag === "$is") {
      return isTagged4;
    } else if (tag === "$match") {
      return taggedMatch3;
    }
    return tagged3(tag);
  }
});
function taggedMatch3() {
  if (arguments.length === 1) {
    const cases2 = arguments[0];
    return function(value2) {
      return cases2[value2._tag](value2);
    };
  }
  const value = arguments[0];
  const cases = arguments[1];
  return cases[value._tag](value);
}
var Error23 = /* @__PURE__ */ function() {
  return class Base extends YieldableError3 {
    constructor(args) {
      super();
      if (args) {
        Object.assign(this, args);
      }
    }
  };
}();
var TaggedError3 = (tag) => {
  class Base extends Error23 {
    _tag = tag;
  }
  Base.prototype.name = tag;
  return Base;
};
var traverseUp3 = Function_exports4.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType3.Program) return Option_exports4.none();
  return predicate(parent) ? Option_exports4.some(parent) : traverseUp3(parent, predicate);
});
var traverseUpGuard3 = Function_exports4.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType3.Program) return Option_exports4.none();
  return predicate(parent) ? Option_exports4.some(parent) : traverseUpGuard3(parent, predicate);
});
var ESLintCommunityESLintUtils3;
((ESLintCommunityESLintUtils234) => {
  ESLintCommunityESLintUtils234.getFunctionHeadLocation = getFunctionHeadLocation3;
  ESLintCommunityESLintUtils234.getFunctionNameWithKind = getFunctionNameWithKind3;
  ESLintCommunityESLintUtils234.getPropertyName = getPropertyName3;
  ESLintCommunityESLintUtils234.getStaticValue = getStaticValue4;
  ESLintCommunityESLintUtils234.getStringIfConstant = getStringIfConstant3;
  ESLintCommunityESLintUtils234.hasSideEffect = hasSideEffect3;
  ESLintCommunityESLintUtils234.isParenthesized = isParenthesized3;
})(ESLintCommunityESLintUtils3 || (ESLintCommunityESLintUtils3 = {}));
var Construction3 = Data_exports2.taggedEnum();
var ConstructionHint = {
  None: 0n,
  StrictCallExpression: 1n << 0n
};
var None = Construction3.None();
function inspectConstruction(node, context, hint = ConstructionHint.None) {
  const detect = (node2) => {
    const scope = context.sourceCode.getScope(node2);
    return $(node2).when(is3(NodeType3.ArrayExpression), (node3) => Construction3.Array({ node: node3, usage: Option_exports4.none() })).when(is3(NodeType3.ObjectExpression), (node3) => Construction3.ObjectExpression({ node: node3, usage: Option_exports4.none() })).when(is3(NodeType3.ClassExpression), (node3) => Construction3.ClassExpression({ node: node3, usage: Option_exports4.none() })).when(is3(NodeType3.JSXElement), (node3) => Construction3.JSXElement({ node: node3, usage: Option_exports4.none() })).when(is3(NodeType3.JSXFragment), (node3) => Construction3.JSXFragment({ node: node3, usage: Option_exports4.none() })).when(is3(NodeType3.CallExpression), (node3) => {
      if (hint & ConstructionHint.StrictCallExpression) {
        return Construction3.CallExpression({ node: node3, usage: Option_exports4.none() });
      }
      return None;
    }).when(is3(NodeType3.NewExpression), (node3) => Construction3.NewExpression({ node: node3, usage: Option_exports4.none() })).when(isOneOf3([NodeType3.FunctionExpression, NodeType3.ArrowFunctionExpression]), (node3) => {
      return Construction3.FunctionExpression({ node: node3, usage: Option_exports4.none() });
    }).when(is3(NodeType3.MemberExpression), (node3) => {
      if (!("object" in node3)) return None;
      const object32 = detect(node3.object);
      if (object32._tag === "None") return object32;
      return {
        ...object32,
        usage: Option_exports4.some(node3.object)
      };
    }).when(is3(NodeType3.AssignmentExpression), (node3) => {
      if (!("right" in node3)) return None;
      const right334 = detect(node3.right);
      if (right334._tag === "None") return right334;
      return Construction3.AssignmentExpression({
        node: right334.node,
        usage: Option_exports4.some(node3)
      });
    }).when(is3(NodeType3.AssignmentPattern), (node3) => {
      if (!("right" in node3)) return None;
      const right334 = detect(node3.right);
      if (right334._tag === "None") return right334;
      return Construction3.AssignmentPattern({
        node: right334.node,
        usage: Option_exports4.some(node3)
      });
    }).when(is3(NodeType3.LogicalExpression), (node3) => {
      if (!("left" in node3 && "right" in node3)) return None;
      const left334 = detect(node3.left);
      if (left334._tag !== "None") return left334;
      return detect(node3.right);
    }).when(is3(NodeType3.ConditionalExpression), (node3) => {
      if (!("consequent" in node3 && "alternate" in node3 && !Predicate_exports3.isNullable(node3.alternate))) {
        return None;
      }
      const consequent = detect(node3.consequent);
      if (consequent._tag !== "None") return None;
      return detect(node3.alternate);
    }).when(is3(NodeType3.Identifier), (node3) => {
      if (!("name" in node3 && Predicate_exports3.isString(node3.name))) return None;
      const maybeLatestDef = Option_exports4.fromNullable(scope.set.get(node3.name)?.defs.at(-1));
      if (Option_exports4.isNone(maybeLatestDef)) return None;
      const latestDef = maybeLatestDef.value;
      if (latestDef.type !== scopeManager.DefinitionType.Variable && latestDef.type !== scopeManager.DefinitionType.FunctionName) {
        return None;
      }
      if (latestDef.node.type === NodeType3.FunctionDeclaration) {
        return Construction3.FunctionDeclaration({
          node: latestDef.node,
          usage: Option_exports4.some(node3)
        });
      }
      if (!("init" in latestDef.node) || latestDef.node.init === null) return None;
      return detect(latestDef.node.init);
    }).when(is3(NodeType3.Literal), (node3) => {
      if ("regex" in node3) return Construction3.RegExpLiteral({ node: node3, usage: Option_exports4.none() });
      return None;
    }).when(isOneOf3([NodeType3.TSAsExpression, NodeType3.TSTypeAssertion]), () => {
      if (!("expression" in node2) || !Predicate_exports3.isObject(node2.expression)) return None;
      return detect(node2.expression);
    }).otherwise(() => None);
  };
  return detect(node);
}
function getClassIdentifier(node) {
  if (node.id) return Option_exports4.fromNullable(node.id);
  if (node.parent.type === NodeType3.VariableDeclarator && node.parent.id.type === NodeType3.Identifier) {
    return Option_exports4.fromNullable(node.parent.id);
  }
  return Option_exports4.none();
}
function getFunctionIdentifier(node) {
  if (node.id) return Option_exports4.some(node.id);
  if (node.parent.type === NodeType3.VariableDeclarator && node.parent.init === node && node.parent.id.type === NodeType3.Identifier) {
    return Option_exports4.some(node.parent.id);
  }
  if (node.parent.type === NodeType3.AssignmentExpression && node.parent.right === node && node.parent.operator === "=" && node.parent.left.type === NodeType3.Identifier) {
    return Option_exports4.some(node.parent.left);
  }
  if (node.parent.type === NodeType3.Property && node.parent.value === node && !node.parent.computed && node.parent.key.type === NodeType3.Identifier) {
    return Option_exports4.some(node.parent.key);
  }
  if (isOneOf3([NodeType3.MethodDefinition, NodeType3.PropertyDefinition])(node.parent) && node.parent.value === node && node.parent.key.type === NodeType3.Identifier) {
    return Option_exports4.some(node.parent.key);
  }
  if (node.parent.type === NodeType3.AssignmentPattern && node.parent.right === node && node.parent.left.type === NodeType3.Identifier) {
    return Option_exports4.some(node.parent.left);
  }
  return Option_exports4.none();
}
a({
  type: N.union([NodeType3.FunctionExpression, NodeType3.ArrowFunctionExpression]),
  parent: {
    type: NodeType3.Property,
    parent: {
      type: NodeType3.ObjectExpression
    }
  }
});
a({
  type: N.union([NodeType3.FunctionExpression, NodeType3.ArrowFunctionExpression]),
  parent: {
    type: NodeType3.MethodDefinition,
    parent: {
      type: NodeType3.ClassBody
    }
  }
});
a({
  type: N.union([NodeType3.FunctionExpression, NodeType3.ArrowFunctionExpression]),
  parent: {
    type: NodeType3.Property,
    parent: {
      type: NodeType3.ClassBody
    }
  }
});
function getNestedReturnStatements(node) {
  const returnStatements = [];
  if (node.type === NodeType3.ReturnStatement) {
    returnStatements.push(node);
  }
  if ("body" in node && !Predicate_exports3.isNullable(node.body)) {
    Array.isArray(node.body) ? node.body.forEach((x52) => {
      returnStatements.push(...getNestedReturnStatements(x52));
    }) : returnStatements.push(
      ...getNestedReturnStatements(node.body)
    );
  }
  if ("consequent" in node) {
    Array.isArray(node.consequent) ? node.consequent.forEach((x52) => {
      returnStatements.push(...getNestedReturnStatements(x52));
    }) : returnStatements.push(
      ...getNestedReturnStatements(node.consequent)
    );
  }
  if ("alternate" in node && node.alternate !== null) {
    Array.isArray(node.alternate) ? node.alternate.forEach((x52) => {
      returnStatements.push(...getNestedReturnStatements(x52));
    }) : returnStatements.push(
      ...getNestedReturnStatements(node.alternate)
    );
  }
  if ("cases" in node) {
    node.cases.forEach((x52) => {
      returnStatements.push(...getNestedReturnStatements(x52));
    });
  }
  if ("block" in node) {
    returnStatements.push(...getNestedReturnStatements(node.block));
  }
  if ("handler" in node && node.handler !== null) {
    returnStatements.push(...getNestedReturnStatements(node.handler));
  }
  if ("finalizer" in node && node.finalizer !== null) {
    returnStatements.push(
      ...getNestedReturnStatements(node.finalizer)
    );
  }
  if ("expression" in node && node.expression !== true && node.expression !== false) {
    returnStatements.push(
      ...getNestedReturnStatements(node.expression)
    );
  }
  if ("test" in node && node.test !== null) {
    returnStatements.push(...getNestedReturnStatements(node.test));
  }
  return returnStatements;
}
function isThisExpression(node) {
  if (node.type === NodeType3.TSAsExpression) {
    return isThisExpression(node.expression);
  }
  return node.type === NodeType3.ThisExpression;
}
var import_short_unique_id = __toESM(require_short_unique_id());
var __defProp5 = Object.defineProperty;
var __export5 = (target, all922) => {
  for (var name22 in all922)
    __defProp5(target, name22, { get: all922[name22], enumerable: true });
};
var KEYS4 = {
  ArrayExpression: [
    "elements"
  ],
  ArrayPattern: [
    "elements"
  ],
  ArrowFunctionExpression: [
    "params",
    "body"
  ],
  AssignmentExpression: [
    "left",
    "right"
  ],
  AssignmentPattern: [
    "left",
    "right"
  ],
  AwaitExpression: [
    "argument"
  ],
  BinaryExpression: [
    "left",
    "right"
  ],
  BlockStatement: [
    "body"
  ],
  BreakStatement: [
    "label"
  ],
  CallExpression: [
    "callee",
    "arguments"
  ],
  CatchClause: [
    "param",
    "body"
  ],
  ChainExpression: [
    "expression"
  ],
  ClassBody: [
    "body"
  ],
  ClassDeclaration: [
    "id",
    "superClass",
    "body"
  ],
  ClassExpression: [
    "id",
    "superClass",
    "body"
  ],
  ConditionalExpression: [
    "test",
    "consequent",
    "alternate"
  ],
  ContinueStatement: [
    "label"
  ],
  DebuggerStatement: [],
  DoWhileStatement: [
    "body",
    "test"
  ],
  EmptyStatement: [],
  ExperimentalRestProperty: [
    "argument"
  ],
  ExperimentalSpreadProperty: [
    "argument"
  ],
  ExportAllDeclaration: [
    "exported",
    "source"
  ],
  ExportDefaultDeclaration: [
    "declaration"
  ],
  ExportNamedDeclaration: [
    "declaration",
    "specifiers",
    "source"
  ],
  ExportSpecifier: [
    "exported",
    "local"
  ],
  ExpressionStatement: [
    "expression"
  ],
  ForInStatement: [
    "left",
    "right",
    "body"
  ],
  ForOfStatement: [
    "left",
    "right",
    "body"
  ],
  ForStatement: [
    "init",
    "test",
    "update",
    "body"
  ],
  FunctionDeclaration: [
    "id",
    "params",
    "body"
  ],
  FunctionExpression: [
    "id",
    "params",
    "body"
  ],
  Identifier: [],
  IfStatement: [
    "test",
    "consequent",
    "alternate"
  ],
  ImportDeclaration: [
    "specifiers",
    "source"
  ],
  ImportDefaultSpecifier: [
    "local"
  ],
  ImportExpression: [
    "source"
  ],
  ImportNamespaceSpecifier: [
    "local"
  ],
  ImportSpecifier: [
    "imported",
    "local"
  ],
  JSXAttribute: [
    "name",
    "value"
  ],
  JSXClosingElement: [
    "name"
  ],
  JSXClosingFragment: [],
  JSXElement: [
    "openingElement",
    "children",
    "closingElement"
  ],
  JSXEmptyExpression: [],
  JSXExpressionContainer: [
    "expression"
  ],
  JSXFragment: [
    "openingFragment",
    "children",
    "closingFragment"
  ],
  JSXIdentifier: [],
  JSXMemberExpression: [
    "object",
    "property"
  ],
  JSXNamespacedName: [
    "namespace",
    "name"
  ],
  JSXOpeningElement: [
    "name",
    "attributes"
  ],
  JSXOpeningFragment: [],
  JSXSpreadAttribute: [
    "argument"
  ],
  JSXSpreadChild: [
    "expression"
  ],
  JSXText: [],
  LabeledStatement: [
    "label",
    "body"
  ],
  Literal: [],
  LogicalExpression: [
    "left",
    "right"
  ],
  MemberExpression: [
    "object",
    "property"
  ],
  MetaProperty: [
    "meta",
    "property"
  ],
  MethodDefinition: [
    "key",
    "value"
  ],
  NewExpression: [
    "callee",
    "arguments"
  ],
  ObjectExpression: [
    "properties"
  ],
  ObjectPattern: [
    "properties"
  ],
  PrivateIdentifier: [],
  Program: [
    "body"
  ],
  Property: [
    "key",
    "value"
  ],
  PropertyDefinition: [
    "key",
    "value"
  ],
  RestElement: [
    "argument"
  ],
  ReturnStatement: [
    "argument"
  ],
  SequenceExpression: [
    "expressions"
  ],
  SpreadElement: [
    "argument"
  ],
  StaticBlock: [
    "body"
  ],
  Super: [],
  SwitchCase: [
    "test",
    "consequent"
  ],
  SwitchStatement: [
    "discriminant",
    "cases"
  ],
  TaggedTemplateExpression: [
    "tag",
    "quasi"
  ],
  TemplateElement: [],
  TemplateLiteral: [
    "quasis",
    "expressions"
  ],
  ThisExpression: [],
  ThrowStatement: [
    "argument"
  ],
  TryStatement: [
    "block",
    "handler",
    "finalizer"
  ],
  UnaryExpression: [
    "argument"
  ],
  UpdateExpression: [
    "argument"
  ],
  VariableDeclaration: [
    "declarations"
  ],
  VariableDeclarator: [
    "id",
    "init"
  ],
  WhileStatement: [
    "test",
    "body"
  ],
  WithStatement: [
    "object",
    "body"
  ],
  YieldExpression: [
    "argument"
  ]
};
var NODE_TYPES4 = Object.keys(KEYS4);
for (const type of NODE_TYPES4) {
  Object.freeze(KEYS4[type]);
}
Object.freeze(KEYS4);
var visitor_keys_default4 = KEYS4;
var KEY_BLACKLIST4 = /* @__PURE__ */ new Set([
  "parent",
  "leadingComments",
  "trailingComments"
]);
function filterKey4(key) {
  return !KEY_BLACKLIST4.has(key) && key[0] !== "_";
}
function getKeys4(node) {
  return Object.keys(node).filter(filterKey4);
}
function getInnermostScope4(initialScope, node) {
  const location = node.range[0];
  let scope = initialScope;
  let found = false;
  do {
    found = false;
    for (const childScope of scope.childScopes) {
      const range222 = childScope.block.range;
      if (range222[0] <= location && location < range222[1]) {
        scope = childScope;
        found = true;
        break;
      }
    }
  } while (found);
  return scope;
}
function findVariable4(initialScope, nameOrNode) {
  let name22 = "";
  let scope = initialScope;
  if (typeof nameOrNode === "string") {
    name22 = nameOrNode;
  } else {
    name22 = nameOrNode.name;
    scope = getInnermostScope4(scope, nameOrNode);
  }
  while (scope != null) {
    const variable = scope.set.get(name22);
    if (variable != null) {
      return variable;
    }
    scope = scope.upper;
  }
  return null;
}
function negate04(token) {
  return !this(token);
}
function negate4(f322) {
  return negate04.bind(f322);
}
function isPunctuatorTokenWithValue4(token, value) {
  return token.type === "Punctuator" && token.value === value;
}
function isArrowToken4(token) {
  return isPunctuatorTokenWithValue4(token, "=>");
}
function isCommaToken4(token) {
  return isPunctuatorTokenWithValue4(token, ",");
}
function isSemicolonToken4(token) {
  return isPunctuatorTokenWithValue4(token, ";");
}
function isColonToken4(token) {
  return isPunctuatorTokenWithValue4(token, ":");
}
function isOpeningParenToken4(token) {
  return isPunctuatorTokenWithValue4(token, "(");
}
function isClosingParenToken4(token) {
  return isPunctuatorTokenWithValue4(token, ")");
}
function isOpeningBracketToken4(token) {
  return isPunctuatorTokenWithValue4(token, "[");
}
function isClosingBracketToken4(token) {
  return isPunctuatorTokenWithValue4(token, "]");
}
function isOpeningBraceToken4(token) {
  return isPunctuatorTokenWithValue4(token, "{");
}
function isClosingBraceToken4(token) {
  return isPunctuatorTokenWithValue4(token, "}");
}
function isCommentToken4(token) {
  return ["Block", "Line", "Shebang"].includes(token.type);
}
negate4(isArrowToken4);
negate4(isCommaToken4);
negate4(isSemicolonToken4);
negate4(isColonToken4);
negate4(isOpeningParenToken4);
negate4(isClosingParenToken4);
negate4(isOpeningBracketToken4);
negate4(isClosingBracketToken4);
negate4(isOpeningBraceToken4);
negate4(isClosingBraceToken4);
negate4(isCommentToken4);
function getOpeningParenOfParams4(node, sourceCode) {
  return node.id ? sourceCode.getTokenAfter(node.id, isOpeningParenToken4) : sourceCode.getFirstToken(node, isOpeningParenToken4);
}
function getFunctionHeadLocation4(node, sourceCode) {
  const parent = node.parent;
  let start = null;
  let end = null;
  if (node.type === "ArrowFunctionExpression") {
    const arrowToken = sourceCode.getTokenBefore(node.body, isArrowToken4);
    start = arrowToken.loc.start;
    end = arrowToken.loc.end;
  } else if (parent.type === "Property" || parent.type === "MethodDefinition" || parent.type === "PropertyDefinition") {
    start = parent.loc.start;
    end = getOpeningParenOfParams4(node, sourceCode).loc.start;
  } else {
    start = node.loc.start;
    end = getOpeningParenOfParams4(node, sourceCode).loc.start;
  }
  return {
    start: { ...start },
    end: { ...end }
  };
}
var globalObject4 = typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {};
var builtinNames4 = Object.freeze(
  /* @__PURE__ */ new Set([
    "Array",
    "ArrayBuffer",
    "BigInt",
    "BigInt64Array",
    "BigUint64Array",
    "Boolean",
    "DataView",
    "Date",
    "decodeURI",
    "decodeURIComponent",
    "encodeURI",
    "encodeURIComponent",
    "escape",
    "Float32Array",
    "Float64Array",
    "Function",
    "Infinity",
    "Int16Array",
    "Int32Array",
    "Int8Array",
    "isFinite",
    "isNaN",
    "isPrototypeOf",
    "JSON",
    "Map",
    "Math",
    "NaN",
    "Number",
    "Object",
    "parseFloat",
    "parseInt",
    "Promise",
    "Proxy",
    "Reflect",
    "RegExp",
    "Set",
    "String",
    "Symbol",
    "Uint16Array",
    "Uint32Array",
    "Uint8Array",
    "Uint8ClampedArray",
    "undefined",
    "unescape",
    "WeakMap",
    "WeakSet"
  ])
);
var callAllowed4 = new Set(
  [
    Array.isArray,
    Array.of,
    Array.prototype.at,
    Array.prototype.concat,
    Array.prototype.entries,
    Array.prototype.every,
    Array.prototype.filter,
    Array.prototype.find,
    Array.prototype.findIndex,
    Array.prototype.flat,
    Array.prototype.includes,
    Array.prototype.indexOf,
    Array.prototype.join,
    Array.prototype.keys,
    Array.prototype.lastIndexOf,
    Array.prototype.slice,
    Array.prototype.some,
    Array.prototype.toString,
    Array.prototype.values,
    typeof BigInt === "function" ? BigInt : void 0,
    Boolean,
    Date,
    Date.parse,
    decodeURI,
    decodeURIComponent,
    encodeURI,
    encodeURIComponent,
    escape,
    isFinite,
    isNaN,
    isPrototypeOf,
    Map,
    Map.prototype.entries,
    Map.prototype.get,
    Map.prototype.has,
    Map.prototype.keys,
    Map.prototype.values,
    ...Object.getOwnPropertyNames(Math).filter((k322) => k322 !== "random").map((k322) => Math[k322]).filter((f322) => typeof f322 === "function"),
    Number,
    Number.isFinite,
    Number.isNaN,
    Number.parseFloat,
    Number.parseInt,
    Number.prototype.toExponential,
    Number.prototype.toFixed,
    Number.prototype.toPrecision,
    Number.prototype.toString,
    Object,
    Object.entries,
    Object.is,
    Object.isExtensible,
    Object.isFrozen,
    Object.isSealed,
    Object.keys,
    Object.values,
    parseFloat,
    parseInt,
    RegExp,
    Set,
    Set.prototype.entries,
    Set.prototype.has,
    Set.prototype.keys,
    Set.prototype.values,
    String,
    String.fromCharCode,
    String.fromCodePoint,
    String.raw,
    String.prototype.at,
    String.prototype.charAt,
    String.prototype.charCodeAt,
    String.prototype.codePointAt,
    String.prototype.concat,
    String.prototype.endsWith,
    String.prototype.includes,
    String.prototype.indexOf,
    String.prototype.lastIndexOf,
    String.prototype.normalize,
    String.prototype.padEnd,
    String.prototype.padStart,
    String.prototype.slice,
    String.prototype.startsWith,
    String.prototype.substr,
    String.prototype.substring,
    String.prototype.toLowerCase,
    String.prototype.toString,
    String.prototype.toUpperCase,
    String.prototype.trim,
    String.prototype.trimEnd,
    String.prototype.trimLeft,
    String.prototype.trimRight,
    String.prototype.trimStart,
    Symbol.for,
    Symbol.keyFor,
    unescape
  ].filter((f322) => typeof f322 === "function")
);
var callPassThrough4 = /* @__PURE__ */ new Set([
  Object.freeze,
  Object.preventExtensions,
  Object.seal
]);
var getterAllowed4 = [
  [Map, /* @__PURE__ */ new Set(["size"])],
  [
    RegExp,
    /* @__PURE__ */ new Set([
      "dotAll",
      "flags",
      "global",
      "hasIndices",
      "ignoreCase",
      "multiline",
      "source",
      "sticky",
      "unicode"
    ])
  ],
  [Set, /* @__PURE__ */ new Set(["size"])]
];
function getPropertyDescriptor4(object222, name22) {
  let x322 = object222;
  while ((typeof x322 === "object" || typeof x322 === "function") && x322 !== null) {
    const d322 = Object.getOwnPropertyDescriptor(x322, name22);
    if (d322) {
      return d322;
    }
    x322 = Object.getPrototypeOf(x322);
  }
  return null;
}
function isGetter4(object222, name22) {
  const d322 = getPropertyDescriptor4(object222, name22);
  return d322 != null && d322.get != null;
}
function getElementValues4(nodeList, initialScope) {
  const valueList = [];
  for (let i322 = 0; i322 < nodeList.length; ++i322) {
    const elementNode = nodeList[i322];
    if (elementNode == null) {
      valueList.length = i322 + 1;
    } else if (elementNode.type === "SpreadElement") {
      const argument = getStaticValueR4(elementNode.argument, initialScope);
      if (argument == null) {
        return null;
      }
      valueList.push(...argument.value);
    } else {
      const element = getStaticValueR4(elementNode, initialScope);
      if (element == null) {
        return null;
      }
      valueList.push(element.value);
    }
  }
  return valueList;
}
function isEffectivelyConst4(variable) {
  const refs = variable.references;
  const inits = refs.filter((r322) => r322.init).length;
  const reads = refs.filter((r322) => r322.isReadOnly()).length;
  if (inits === 1 && reads + inits === refs.length) {
    return true;
  }
  return false;
}
var operations4 = Object.freeze({
  ArrayExpression(node, initialScope) {
    const elements = getElementValues4(node.elements, initialScope);
    return elements != null ? { value: elements } : null;
  },
  AssignmentExpression(node, initialScope) {
    if (node.operator === "=") {
      return getStaticValueR4(node.right, initialScope);
    }
    return null;
  },
  //eslint-disable-next-line complexity
  BinaryExpression(node, initialScope) {
    if (node.operator === "in" || node.operator === "instanceof") {
      return null;
    }
    const left722 = getStaticValueR4(node.left, initialScope);
    const right722 = getStaticValueR4(node.right, initialScope);
    if (left722 != null && right722 != null) {
      switch (node.operator) {
        case "==":
          return { value: left722.value == right722.value };
        case "!=":
          return { value: left722.value != right722.value };
        case "===":
          return { value: left722.value === right722.value };
        case "!==":
          return { value: left722.value !== right722.value };
        case "<":
          return { value: left722.value < right722.value };
        case "<=":
          return { value: left722.value <= right722.value };
        case ">":
          return { value: left722.value > right722.value };
        case ">=":
          return { value: left722.value >= right722.value };
        case "<<":
          return { value: left722.value << right722.value };
        case ">>":
          return { value: left722.value >> right722.value };
        case ">>>":
          return { value: left722.value >>> right722.value };
        case "+":
          return { value: left722.value + right722.value };
        case "-":
          return { value: left722.value - right722.value };
        case "*":
          return { value: left722.value * right722.value };
        case "/":
          return { value: left722.value / right722.value };
        case "%":
          return { value: left722.value % right722.value };
        case "**":
          return { value: left722.value ** right722.value };
        case "|":
          return { value: left722.value | right722.value };
        case "^":
          return { value: left722.value ^ right722.value };
        case "&":
          return { value: left722.value & right722.value };
      }
    }
    return null;
  },
  CallExpression(node, initialScope) {
    const calleeNode = node.callee;
    const args = getElementValues4(node.arguments, initialScope);
    if (args != null) {
      if (calleeNode.type === "MemberExpression") {
        if (calleeNode.property.type === "PrivateIdentifier") {
          return null;
        }
        const object222 = getStaticValueR4(calleeNode.object, initialScope);
        if (object222 != null) {
          if (object222.value == null && (object222.optional || node.optional)) {
            return { value: void 0, optional: true };
          }
          const property = getStaticPropertyNameValue4(
            calleeNode,
            initialScope
          );
          if (property != null) {
            const receiver = object222.value;
            const methodName = property.value;
            if (callAllowed4.has(receiver[methodName])) {
              return { value: receiver[methodName](...args) };
            }
            if (callPassThrough4.has(receiver[methodName])) {
              return { value: args[0] };
            }
          }
        }
      } else {
        const callee = getStaticValueR4(calleeNode, initialScope);
        if (callee != null) {
          if (callee.value == null && node.optional) {
            return { value: void 0, optional: true };
          }
          const func = callee.value;
          if (callAllowed4.has(func)) {
            return { value: func(...args) };
          }
          if (callPassThrough4.has(func)) {
            return { value: args[0] };
          }
        }
      }
    }
    return null;
  },
  ConditionalExpression(node, initialScope) {
    const test = getStaticValueR4(node.test, initialScope);
    if (test != null) {
      return test.value ? getStaticValueR4(node.consequent, initialScope) : getStaticValueR4(node.alternate, initialScope);
    }
    return null;
  },
  ExpressionStatement(node, initialScope) {
    return getStaticValueR4(node.expression, initialScope);
  },
  Identifier(node, initialScope) {
    if (initialScope != null) {
      const variable = findVariable4(initialScope, node);
      if (variable != null && variable.defs.length === 0 && builtinNames4.has(variable.name) && variable.name in globalObject4) {
        return { value: globalObject4[variable.name] };
      }
      if (variable != null && variable.defs.length === 1) {
        const def = variable.defs[0];
        if (def.parent && def.type === "Variable" && (def.parent.kind === "const" || isEffectivelyConst4(variable)) && // TODO(mysticatea): don't support destructuring here.
        def.node.id.type === "Identifier") {
          return getStaticValueR4(def.node.init, initialScope);
        }
      }
    }
    return null;
  },
  Literal(node) {
    if ((node.regex != null || node.bigint != null) && node.value == null) {
      return null;
    }
    return { value: node.value };
  },
  LogicalExpression(node, initialScope) {
    const left722 = getStaticValueR4(node.left, initialScope);
    if (left722 != null) {
      if (node.operator === "||" && Boolean(left722.value) === true || node.operator === "&&" && Boolean(left722.value) === false || node.operator === "??" && left722.value != null) {
        return left722;
      }
      const right722 = getStaticValueR4(node.right, initialScope);
      if (right722 != null) {
        return right722;
      }
    }
    return null;
  },
  MemberExpression(node, initialScope) {
    if (node.property.type === "PrivateIdentifier") {
      return null;
    }
    const object222 = getStaticValueR4(node.object, initialScope);
    if (object222 != null) {
      if (object222.value == null && (object222.optional || node.optional)) {
        return { value: void 0, optional: true };
      }
      const property = getStaticPropertyNameValue4(node, initialScope);
      if (property != null) {
        if (!isGetter4(object222.value, property.value)) {
          return { value: object222.value[property.value] };
        }
        for (const [classFn, allowed] of getterAllowed4) {
          if (object222.value instanceof classFn && allowed.has(property.value)) {
            return { value: object222.value[property.value] };
          }
        }
      }
    }
    return null;
  },
  ChainExpression(node, initialScope) {
    const expression = getStaticValueR4(node.expression, initialScope);
    if (expression != null) {
      return { value: expression.value };
    }
    return null;
  },
  NewExpression(node, initialScope) {
    const callee = getStaticValueR4(node.callee, initialScope);
    const args = getElementValues4(node.arguments, initialScope);
    if (callee != null && args != null) {
      const Func = callee.value;
      if (callAllowed4.has(Func)) {
        return { value: new Func(...args) };
      }
    }
    return null;
  },
  ObjectExpression(node, initialScope) {
    const object222 = {};
    for (const propertyNode of node.properties) {
      if (propertyNode.type === "Property") {
        if (propertyNode.kind !== "init") {
          return null;
        }
        const key = getStaticPropertyNameValue4(
          propertyNode,
          initialScope
        );
        const value = getStaticValueR4(propertyNode.value, initialScope);
        if (key == null || value == null) {
          return null;
        }
        object222[key.value] = value.value;
      } else if (propertyNode.type === "SpreadElement" || propertyNode.type === "ExperimentalSpreadProperty") {
        const argument = getStaticValueR4(
          propertyNode.argument,
          initialScope
        );
        if (argument == null) {
          return null;
        }
        Object.assign(object222, argument.value);
      } else {
        return null;
      }
    }
    return { value: object222 };
  },
  SequenceExpression(node, initialScope) {
    const last222 = node.expressions[node.expressions.length - 1];
    return getStaticValueR4(last222, initialScope);
  },
  TaggedTemplateExpression(node, initialScope) {
    const tag = getStaticValueR4(node.tag, initialScope);
    const expressions = getElementValues4(
      node.quasi.expressions,
      initialScope
    );
    if (tag != null && expressions != null) {
      const func = tag.value;
      const strings = node.quasi.quasis.map((q) => q.value.cooked);
      strings.raw = node.quasi.quasis.map((q) => q.value.raw);
      if (func === String.raw) {
        return { value: func(strings, ...expressions) };
      }
    }
    return null;
  },
  TemplateLiteral(node, initialScope) {
    const expressions = getElementValues4(node.expressions, initialScope);
    if (expressions != null) {
      let value = node.quasis[0].value.cooked;
      for (let i322 = 0; i322 < expressions.length; ++i322) {
        value += expressions[i322];
        value += node.quasis[i322 + 1].value.cooked;
      }
      return { value };
    }
    return null;
  },
  UnaryExpression(node, initialScope) {
    if (node.operator === "delete") {
      return null;
    }
    if (node.operator === "void") {
      return { value: void 0 };
    }
    const arg = getStaticValueR4(node.argument, initialScope);
    if (arg != null) {
      switch (node.operator) {
        case "-":
          return { value: -arg.value };
        case "+":
          return { value: +arg.value };
        case "!":
          return { value: !arg.value };
        case "~":
          return { value: ~arg.value };
        case "typeof":
          return { value: typeof arg.value };
      }
    }
    return null;
  }
});
function getStaticValueR4(node, initialScope) {
  if (node != null && Object.hasOwnProperty.call(operations4, node.type)) {
    return operations4[node.type](node, initialScope);
  }
  return null;
}
function getStaticPropertyNameValue4(node, initialScope) {
  const nameNode = node.type === "Property" ? node.key : node.property;
  if (node.computed) {
    return getStaticValueR4(nameNode, initialScope);
  }
  if (nameNode.type === "Identifier") {
    return { value: nameNode.name };
  }
  if (nameNode.type === "Literal") {
    if (nameNode.bigint) {
      return { value: nameNode.bigint };
    }
    return { value: String(nameNode.value) };
  }
  return null;
}
function getStaticValue5(node, initialScope = null) {
  try {
    return getStaticValueR4(node, initialScope);
  } catch (_error) {
    return null;
  }
}
function getStringIfConstant4(node, initialScope = null) {
  if (node && node.type === "Literal" && node.value === null) {
    if (node.regex) {
      return `/${node.regex.pattern}/${node.regex.flags}`;
    }
    if (node.bigint) {
      return node.bigint;
    }
  }
  const evaluated = getStaticValue5(node, initialScope);
  return evaluated && String(evaluated.value);
}
function getPropertyName4(node, initialScope) {
  switch (node.type) {
    case "MemberExpression":
      if (node.computed) {
        return getStringIfConstant4(node.property, initialScope);
      }
      if (node.property.type === "PrivateIdentifier") {
        return null;
      }
      return node.property.name;
    case "Property":
    case "MethodDefinition":
    case "PropertyDefinition":
      if (node.computed) {
        return getStringIfConstant4(node.key, initialScope);
      }
      if (node.key.type === "Literal") {
        return String(node.key.value);
      }
      if (node.key.type === "PrivateIdentifier") {
        return null;
      }
      return node.key.name;
  }
  return null;
}
function getFunctionNameWithKind4(node, sourceCode) {
  const parent = node.parent;
  const tokens = [];
  const isObjectMethod = parent.type === "Property" && parent.value === node;
  const isClassMethod = parent.type === "MethodDefinition" && parent.value === node;
  const isClassFieldMethod = parent.type === "PropertyDefinition" && parent.value === node;
  if (isClassMethod || isClassFieldMethod) {
    if (parent.static) {
      tokens.push("static");
    }
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push("private");
    }
  }
  if (node.async) {
    tokens.push("async");
  }
  if (node.generator) {
    tokens.push("generator");
  }
  if (isObjectMethod || isClassMethod) {
    if (parent.kind === "constructor") {
      return "constructor";
    }
    if (parent.kind === "get") {
      tokens.push("getter");
    } else if (parent.kind === "set") {
      tokens.push("setter");
    } else {
      tokens.push("method");
    }
  } else if (isClassFieldMethod) {
    tokens.push("method");
  } else {
    if (node.type === "ArrowFunctionExpression") {
      tokens.push("arrow");
    }
    tokens.push("function");
  }
  if (isObjectMethod || isClassMethod || isClassFieldMethod) {
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push(`#${parent.key.name}`);
    } else {
      const name22 = getPropertyName4(parent);
      if (name22) {
        tokens.push(`'${name22}'`);
      } else if (sourceCode) {
        const keyText = sourceCode.getText(parent.key);
        if (!keyText.includes("\n")) {
          tokens.push(`[${keyText}]`);
        }
      }
    }
  } else if (node.id) {
    tokens.push(`'${node.id.name}'`);
  } else if (parent.type === "VariableDeclarator" && parent.id && parent.id.type === "Identifier") {
    tokens.push(`'${parent.id.name}'`);
  } else if ((parent.type === "AssignmentExpression" || parent.type === "AssignmentPattern") && parent.left && parent.left.type === "Identifier") {
    tokens.push(`'${parent.left.name}'`);
  } else if (parent.type === "ExportDefaultDeclaration" && parent.declaration === node) {
    tokens.push("'default'");
  }
  return tokens.join(" ");
}
var typeConversionBinaryOps4 = Object.freeze(
  /* @__PURE__ */ new Set([
    "==",
    "!=",
    "<",
    "<=",
    ">",
    ">=",
    "<<",
    ">>",
    ">>>",
    "+",
    "-",
    "*",
    "/",
    "%",
    "|",
    "^",
    "&",
    "in"
  ])
);
var typeConversionUnaryOps4 = Object.freeze(/* @__PURE__ */ new Set(["-", "+", "!", "~"]));
function isNode4(x322) {
  return x322 !== null && typeof x322 === "object" && typeof x322.type === "string";
}
var visitor4 = Object.freeze(
  Object.assign(/* @__PURE__ */ Object.create(null), {
    $visit(node, options, visitorKeys) {
      const { type } = node;
      if (typeof this[type] === "function") {
        return this[type](node, options, visitorKeys);
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    $visitChildren(node, options, visitorKeys) {
      const { type } = node;
      for (const key of visitorKeys[type] || getKeys4(node)) {
        const value = node[key];
        if (Array.isArray(value)) {
          for (const element of value) {
            if (isNode4(element) && this.$visit(element, options, visitorKeys)) {
              return true;
            }
          }
        } else if (isNode4(value) && this.$visit(value, options, visitorKeys)) {
          return true;
        }
      }
      return false;
    },
    ArrowFunctionExpression() {
      return false;
    },
    AssignmentExpression() {
      return true;
    },
    AwaitExpression() {
      return true;
    },
    BinaryExpression(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && typeConversionBinaryOps4.has(node.operator) && (node.left.type !== "Literal" || node.right.type !== "Literal")) {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    CallExpression() {
      return true;
    },
    FunctionExpression() {
      return false;
    },
    ImportExpression() {
      return true;
    },
    MemberExpression(node, options, visitorKeys) {
      if (options.considerGetters) {
        return true;
      }
      if (options.considerImplicitTypeConversion && node.computed && node.property.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    MethodDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    NewExpression() {
      return true;
    },
    Property(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    PropertyDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UnaryExpression(node, options, visitorKeys) {
      if (node.operator === "delete") {
        return true;
      }
      if (options.considerImplicitTypeConversion && typeConversionUnaryOps4.has(node.operator) && node.argument.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UpdateExpression() {
      return true;
    },
    YieldExpression() {
      return true;
    }
  })
);
function hasSideEffect4(node, sourceCode, { considerGetters = false, considerImplicitTypeConversion = false } = {}) {
  return visitor4.$visit(
    node,
    { considerGetters, considerImplicitTypeConversion },
    sourceCode.visitorKeys || visitor_keys_default4
  );
}
function getParentSyntaxParen4(node, sourceCode) {
  const parent = node.parent;
  switch (parent.type) {
    case "CallExpression":
    case "NewExpression":
      if (parent.arguments.length === 1 && parent.arguments[0] === node) {
        return sourceCode.getTokenAfter(
          parent.callee,
          isOpeningParenToken4
        );
      }
      return null;
    case "DoWhileStatement":
      if (parent.test === node) {
        return sourceCode.getTokenAfter(
          parent.body,
          isOpeningParenToken4
        );
      }
      return null;
    case "IfStatement":
    case "WhileStatement":
      if (parent.test === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "ImportExpression":
      if (parent.source === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "SwitchStatement":
      if (parent.discriminant === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "WithStatement":
      if (parent.object === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    default:
      return null;
  }
}
function isParenthesized4(timesOrNode, nodeOrSourceCode, optionalSourceCode) {
  let times, node, sourceCode, maybeLeftParen, maybeRightParen;
  if (typeof timesOrNode === "number") {
    times = timesOrNode | 0;
    node = nodeOrSourceCode;
    sourceCode = optionalSourceCode;
    if (!(times >= 1)) {
      throw new TypeError("'times' should be a positive integer.");
    }
  } else {
    times = 1;
    node = timesOrNode;
    sourceCode = nodeOrSourceCode;
  }
  if (node == null || // `Program` can't be parenthesized
  node.parent == null || // `CatchClause.param` can't be parenthesized, example `try {} catch (error) {}`
  node.parent.type === "CatchClause" && node.parent.param === node) {
    return false;
  }
  maybeLeftParen = maybeRightParen = node;
  do {
    maybeLeftParen = sourceCode.getTokenBefore(maybeLeftParen);
    maybeRightParen = sourceCode.getTokenAfter(maybeRightParen);
  } while (maybeLeftParen != null && maybeRightParen != null && isOpeningParenToken4(maybeLeftParen) && isClosingParenToken4(maybeRightParen) && // Avoid false positive such as `if (a) {}`
  maybeLeftParen !== getParentSyntaxParen4(node, sourceCode) && --times > 0);
  return times === 0;
}
Function.call.bind(Object.hasOwnProperty);
var __defProp23 = Object.defineProperty;
var __export23 = (target, all334) => {
  for (var name22 in all334)
    __defProp23(target, name22, { get: all334[name22], enumerable: true });
};
var NodeType4 = types.AST_NODE_TYPES;
var is4 = utils.ASTUtils.isNodeOfType;
var isOneOf4 = utils.ASTUtils.isNodeOfTypes;
isOneOf4([
  NodeType4.ArrowFunctionExpression,
  NodeType4.FunctionDeclaration,
  NodeType4.FunctionExpression
]);
isOneOf4([
  NodeType4.ArrowFunctionExpression,
  NodeType4.FunctionDeclaration,
  NodeType4.FunctionExpression,
  NodeType4.TSCallSignatureDeclaration,
  NodeType4.TSConstructSignatureDeclaration,
  NodeType4.TSDeclareFunction,
  NodeType4.TSEmptyBodyFunctionExpression,
  NodeType4.TSFunctionType,
  NodeType4.TSMethodSignature
]);
isOneOf4([NodeType4.ClassDeclaration, NodeType4.ClassExpression]);
isOneOf4([
  NodeType4.DoWhileStatement,
  NodeType4.ForInStatement,
  NodeType4.ForOfStatement,
  NodeType4.ForStatement,
  NodeType4.WhileStatement
]);
isOneOf4([NodeType4.TSArrayType, NodeType4.TSTupleType]);
isOneOf4([
  NodeType4.PropertyDefinition,
  NodeType4.TSIndexSignature,
  NodeType4.TSParameterProperty,
  NodeType4.TSPropertySignature
]);
is4(NodeType4.JSXElement);
is4(NodeType4.JSXFragment);
isOneOf4([
  NodeType4.JSXAttribute,
  NodeType4.JSXSpreadChild,
  NodeType4.JSXClosingElement,
  NodeType4.JSXClosingFragment,
  NodeType4.JSXElement,
  NodeType4.JSXEmptyExpression,
  NodeType4.JSXExpressionContainer,
  NodeType4.JSXFragment,
  NodeType4.JSXIdentifier,
  NodeType4.JSXMemberExpression,
  NodeType4.JSXNamespacedName,
  NodeType4.JSXOpeningElement,
  NodeType4.JSXOpeningFragment,
  NodeType4.JSXSpreadAttribute,
  NodeType4.JSXSpreadChild,
  NodeType4.JSXText
]);
isOneOf4([
  NodeType4.JSXIdentifier,
  NodeType4.JSXMemberExpression,
  NodeType4.JSXNamespacedName
]);
isOneOf4([
  NodeType4.ArrayPattern,
  NodeType4.AssignmentPattern,
  NodeType4.ObjectPattern,
  NodeType4.RestElement
]);
isOneOf4([
  NodeType4.TSInterfaceDeclaration,
  NodeType4.TSTypeAliasDeclaration
]);
isOneOf4([
  NodeType4.ArrayExpression,
  NodeType4.ArrayPattern,
  NodeType4.ArrowFunctionExpression,
  NodeType4.CallExpression,
  NodeType4.ClassExpression,
  NodeType4.FunctionExpression,
  NodeType4.Identifier,
  NodeType4.JSXElement,
  NodeType4.JSXFragment,
  NodeType4.Literal,
  NodeType4.TemplateLiteral,
  NodeType4.MemberExpression,
  NodeType4.MetaProperty,
  NodeType4.ObjectExpression,
  NodeType4.ObjectPattern,
  NodeType4.SequenceExpression,
  NodeType4.Super,
  NodeType4.TaggedTemplateExpression,
  NodeType4.ThisExpression
]);
isOneOf4([
  NodeType4.ArrayExpression,
  NodeType4.ArrayPattern,
  NodeType4.ArrowFunctionExpression,
  NodeType4.CallExpression,
  NodeType4.ClassExpression,
  NodeType4.FunctionExpression,
  NodeType4.Identifier,
  NodeType4.JSXElement,
  NodeType4.JSXFragment,
  NodeType4.Literal,
  NodeType4.TemplateLiteral,
  NodeType4.MemberExpression,
  NodeType4.MetaProperty,
  NodeType4.ObjectExpression,
  NodeType4.ObjectPattern,
  NodeType4.SequenceExpression,
  NodeType4.Super,
  NodeType4.TaggedTemplateExpression,
  NodeType4.ThisExpression,
  NodeType4.TSAsExpression,
  NodeType4.TSNonNullExpression,
  NodeType4.TSTypeAssertion
]);
var Function_exports5 = {};
__export23(Function_exports5, {
  SK: () => SK5,
  absurd: () => absurd5,
  apply: () => apply5,
  compose: () => compose7,
  constFalse: () => constFalse5,
  constNull: () => constNull5,
  constTrue: () => constTrue5,
  constUndefined: () => constUndefined5,
  constVoid: () => constVoid5,
  constant: () => constant5,
  dual: () => dual5,
  flip: () => flip5,
  flow: () => flow5,
  hole: () => hole5,
  identity: () => identity5,
  isFunction: () => isFunction24,
  pipe: () => pipe5,
  satisfies: () => satisfies5,
  tupled: () => tupled5,
  unsafeCoerce: () => unsafeCoerce5,
  untupled: () => untupled5
});
var isFunction24 = (input) => typeof input === "function";
var dual5 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a322, b322) {
        if (arguments.length >= 2) {
          return body(a322, b322);
        }
        return function(self2) {
          return body(self2, a322);
        };
      };
    case 3:
      return function(a322, b322, c322) {
        if (arguments.length >= 3) {
          return body(a322, b322, c322);
        }
        return function(self2) {
          return body(self2, a322, b322);
        };
      };
    case 4:
      return function(a322, b322, c322, d322) {
        if (arguments.length >= 4) {
          return body(a322, b322, c322, d322);
        }
        return function(self2) {
          return body(self2, a322, b322, c322);
        };
      };
    case 5:
      return function(a322, b322, c322, d322, e322) {
        if (arguments.length >= 5) {
          return body(a322, b322, c322, d322, e322);
        }
        return function(self2) {
          return body(self2, a322, b322, c322, d322);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply5 = (a322) => (self2) => self2(a322);
var identity5 = (a322) => a322;
var satisfies5 = () => (b322) => b322;
var unsafeCoerce5 = identity5;
var constant5 = (value) => () => value;
var constTrue5 = /* @__PURE__ */ constant5(true);
var constFalse5 = /* @__PURE__ */ constant5(false);
var constNull5 = /* @__PURE__ */ constant5(null);
var constUndefined5 = /* @__PURE__ */ constant5(void 0);
var constVoid5 = constUndefined5;
var flip5 = (f322) => (...b322) => (...a322) => f322(...a322)(...b322);
var compose7 = /* @__PURE__ */ dual5(2, (ab, bc) => (a322) => bc(ab(a322)));
var absurd5 = (_322) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled5 = (f322) => (a322) => f322(...a322);
var untupled5 = (f322) => (...a322) => f322(a322);
function pipe5(a322, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a322;
    case 2:
      return ab(a322);
    case 3:
      return bc(ab(a322));
    case 4:
      return cd(bc(ab(a322)));
    case 5:
      return de(cd(bc(ab(a322))));
    case 6:
      return ef(de(cd(bc(ab(a322)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a322))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a322)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a322))))))));
    default: {
      let ret = arguments[0];
      for (let i322 = 1; i322 < arguments.length; i322++) {
        ret = arguments[i322](ret);
      }
      return ret;
    }
  }
}
function flow5(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole5 = /* @__PURE__ */ unsafeCoerce5(absurd5);
var SK5 = (_322, b322) => b322;
var make13 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_8 = (map622) => dual5(3, (self2, name22, f322) => map622(self2, (a322) => Object.assign({}, a322, {
  [name22]: f322(a322)
})));
var bindTo8 = (map622) => dual5(2, (self2, name22) => map622(self2, (a322) => ({
  [name22]: a322
})));
var bind8 = (map622, flatMap4222) => dual5(3, (self2, name22, f322) => flatMap4222(self2, (a322) => map622(f322(a322), (b322) => Object.assign({}, a322, {
  [name22]: b322
}))));
var moduleVersion5 = "3.2.8";
var getCurrentVersion5 = () => moduleVersion5;
var globalStoreId5 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion5()}`);
if (!(globalStoreId5 in globalThis)) {
  globalThis[globalStoreId5] = /* @__PURE__ */ new Map();
}
var globalStore5 = globalThis[globalStoreId5];
var globalValue5 = (id, compute) => {
  if (!globalStore5.has(id)) {
    globalStore5.set(id, compute());
  }
  return globalStore5.get(id);
};
var Predicate_exports4 = {};
__export23(Predicate_exports4, {
  all: () => all7,
  and: () => and5,
  compose: () => compose24,
  eqv: () => eqv5,
  every: () => every6,
  hasProperty: () => hasProperty5,
  implies: () => implies5,
  isBigInt: () => isBigInt5,
  isBoolean: () => isBoolean5,
  isDate: () => isDate5,
  isError: () => isError5,
  isFunction: () => isFunction34,
  isIterable: () => isIterable5,
  isMap: () => isMap5,
  isNever: () => isNever5,
  isNotNull: () => isNotNull5,
  isNotNullable: () => isNotNullable5,
  isNotUndefined: () => isNotUndefined5,
  isNull: () => isNull5,
  isNullable: () => isNullable5,
  isNumber: () => isNumber5,
  isObject: () => isObject5,
  isPromise: () => isPromise5,
  isPromiseLike: () => isPromiseLike5,
  isReadonlyRecord: () => isReadonlyRecord5,
  isRecord: () => isRecord5,
  isSet: () => isSet5,
  isString: () => isString5,
  isSymbol: () => isSymbol5,
  isTagged: () => isTagged5,
  isTruthy: () => isTruthy5,
  isUint8Array: () => isUint8Array5,
  isUndefined: () => isUndefined5,
  isUnknown: () => isUnknown5,
  mapInput: () => mapInput6,
  nand: () => nand5,
  nor: () => nor5,
  not: () => not5,
  or: () => or5,
  product: () => product7,
  productMany: () => productMany7,
  some: () => some10,
  struct: () => struct7,
  tuple: () => tuple6,
  xor: () => xor5
});
var mapInput6 = /* @__PURE__ */ dual5(2, (self2, f322) => (b322) => self2(f322(b322)));
var isTruthy5 = (input) => !!input;
var isSet5 = (input) => input instanceof Set;
var isMap5 = (input) => input instanceof Map;
var isString5 = (input) => typeof input === "string";
var isNumber5 = (input) => typeof input === "number";
var isBoolean5 = (input) => typeof input === "boolean";
var isBigInt5 = (input) => typeof input === "bigint";
var isSymbol5 = (input) => typeof input === "symbol";
var isFunction34 = isFunction24;
var isUndefined5 = (input) => input === void 0;
var isNotUndefined5 = (input) => input !== void 0;
var isNull5 = (input) => input === null;
var isNotNull5 = (input) => input !== null;
var isNever5 = (_322) => false;
var isUnknown5 = (_322) => true;
var isRecordOrArray5 = (input) => typeof input === "object" && input !== null;
var isObject5 = (input) => isRecordOrArray5(input) || isFunction34(input);
var hasProperty5 = /* @__PURE__ */ dual5(2, (self2, property) => isObject5(self2) && property in self2);
var isTagged5 = /* @__PURE__ */ dual5(2, (self2, tag) => hasProperty5(self2, "_tag") && self2["_tag"] === tag);
var isNullable5 = (input) => input === null || input === void 0;
var isNotNullable5 = (input) => input !== null && input !== void 0;
var isError5 = (input) => input instanceof Error;
var isUint8Array5 = (input) => input instanceof Uint8Array;
var isDate5 = (input) => input instanceof Date;
var isIterable5 = (input) => hasProperty5(input, Symbol.iterator);
var isRecord5 = (input) => isRecordOrArray5(input) && !Array.isArray(input);
var isReadonlyRecord5 = isRecord5;
var isPromise5 = (input) => hasProperty5(input, "then") && "catch" in input && isFunction34(input.then) && isFunction34(input.catch);
var isPromiseLike5 = (input) => hasProperty5(input, "then") && isFunction34(input.then);
var compose24 = /* @__PURE__ */ dual5(2, (ab, bc) => (a322) => ab(a322) && bc(a322));
var product7 = (self2, that) => ([a322, b322]) => self2(a322) && that(b322);
var all7 = (collection) => {
  return (as2422) => {
    let collectionIndex = 0;
    for (const p322 of collection) {
      if (collectionIndex >= as2422.length) {
        break;
      }
      if (p322(as2422[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany7 = (self2, collection) => {
  const rest = all7(collection);
  return ([head222, ...tail322]) => self2(head222) === false ? false : rest(tail322);
};
var tuple6 = (...elements) => all7(elements);
var struct7 = (fields) => {
  const keys234 = Object.keys(fields);
  return (a322) => {
    for (const key of keys234) {
      if (!fields[key](a322[key])) {
        return false;
      }
    }
    return true;
  };
};
var not5 = (self2) => (a322) => !self2(a322);
var or5 = /* @__PURE__ */ dual5(2, (self2, that) => (a322) => self2(a322) || that(a322));
var and5 = /* @__PURE__ */ dual5(2, (self2, that) => (a322) => self2(a322) && that(a322));
var xor5 = /* @__PURE__ */ dual5(2, (self2, that) => (a322) => self2(a322) !== that(a322));
var eqv5 = /* @__PURE__ */ dual5(2, (self2, that) => (a322) => self2(a322) === that(a322));
var implies5 = /* @__PURE__ */ dual5(2, (self2, that) => (a322) => self2(a322) ? that(a322) : true);
var nor5 = /* @__PURE__ */ dual5(2, (self2, that) => (a322) => !(self2(a322) || that(a322)));
var nand5 = /* @__PURE__ */ dual5(2, (self2, that) => (a322) => !(self2(a322) && that(a322)));
var every6 = (collection) => (a322) => {
  for (const p322 of collection) {
    if (!p322(a322)) {
      return false;
    }
  }
  return true;
};
var some10 = (collection) => (a322) => {
  for (const p322 of collection) {
    if (p322(a322)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage5 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId5 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind5 = (u322) => isObject5(u322) && GenKindTypeId5 in u322;
var GenKindImpl5 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity5;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_322) => _322;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_322) => _322;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_322) => _322;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId5] = GenKindTypeId5;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen6(this);
  }
};
var SingleShotGen6 = class _SingleShotGen8 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a322) {
    return this.called ? {
      value: a322,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a322) {
    return {
      value: a322,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e322) {
    throw e322;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen8(this.self);
  }
};
var adapter7 = () => function() {
  let x322 = arguments[0];
  for (let i322 = 1; i322 < arguments.length; i322++) {
    x322 = arguments[i322](x322);
  }
  return new GenKindImpl5(x322);
};
var defaultIncHi5 = 335903614;
var defaultIncLo5 = 4150755663;
var MUL_HI5 = 1481765933 >>> 0;
var MUL_LO5 = 1284865837 >>> 0;
var BIT_535 = 9007199254740992;
var BIT_275 = 134217728;
var PCGRandom5 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable5(seedLo) && isNullable5(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable5(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable5(incLo) && isNullable5(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo5;
      incHi = this._state ? this._state[2] : defaultIncHi5;
    } else if (isNullable5(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add645(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max322) {
    if (!max322) {
      return this._next();
    }
    max322 = max322 >>> 0;
    if ((max322 & max322 - 1) === 0) {
      return this._next() & max322 - 1;
    }
    let num = 0;
    const skew = (-max322 >>> 0) % max322 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max322;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_275 + lo) / BIT_535;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul645(this._state, oldHi, oldLo, MUL_HI5, MUL_LO5);
    add645(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul645(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add645(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId5 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap5 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId5]() {
    return this.#value;
  }
};
function yieldWrapGet5(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId5 in self2) {
    return self2[YieldWrapTypeId5]();
  }
  throw new Error(getBugErrorMessage5("yieldWrapGet"));
}
var structuralRegionState5 = /* @__PURE__ */ globalValue5("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache5 = /* @__PURE__ */ globalValue5(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr5 = /* @__PURE__ */ globalValue5(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom5());
var symbol7 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash5 = (self2) => {
  if (structuralRegionState5.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number6(self2);
    case "bigint":
      return string6(self2.toString(10));
    case "boolean":
      return string6(String(self2));
    case "symbol":
      return string6(String(self2));
    case "string":
      return string6(self2);
    case "undefined":
      return string6("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string6("null");
      } else if (self2 instanceof Date) {
        return hash5(self2.toISOString());
      } else if (isHash5(self2)) {
        return self2[symbol7]();
      } else {
        return random5(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random5 = (self2) => {
  if (!randomHashCache5.has(self2)) {
    randomHashCache5.set(self2, number6(pcgr5.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache5.get(self2);
};
var combine6 = (b322) => (self2) => self2 * 53 ^ b322;
var optimize5 = (n322) => n322 & 3221225471 | n322 >>> 1 & 1073741824;
var isHash5 = (u322) => hasProperty5(u322, symbol7);
var number6 = (n322) => {
  if (n322 !== n322 || n322 === Infinity) {
    return 0;
  }
  let h322 = n322 | 0;
  if (h322 !== n322) {
    h322 ^= n322 * 4294967295;
  }
  while (n322 > 4294967295) {
    h322 ^= n322 /= 4294967295;
  }
  return optimize5(n322);
};
var string6 = (str) => {
  let h322 = 5381, i322 = str.length;
  while (i322) {
    h322 = h322 * 33 ^ str.charCodeAt(--i322);
  }
  return optimize5(h322);
};
var structureKeys3 = (o322, keys234) => {
  let h322 = 12289;
  for (let i322 = 0; i322 < keys234.length; i322++) {
    h322 ^= pipe5(string6(keys234[i322]), combine6(hash5(o322[keys234[i322]])));
  }
  return optimize5(h322);
};
var structure3 = (o322) => structureKeys3(o322, Object.keys(o322));
var array8 = (arr) => {
  let h322 = 6151;
  for (let i322 = 0; i322 < arr.length; i322++) {
    h322 = pipe5(h322, combine6(hash5(arr[i322])));
  }
  return optimize5(h322);
};
var cached5 = function() {
  if (arguments.length === 1) {
    const self22 = arguments[0];
    return function(hash3222) {
      Object.defineProperty(self22, symbol7, {
        value() {
          return hash3222;
        },
        enumerable: false
      });
      return hash3222;
    };
  }
  const self2 = arguments[0];
  const hash2422 = arguments[1];
  Object.defineProperty(self2, symbol7, {
    value() {
      return hash2422;
    },
    enumerable: false
  });
  return hash2422;
};
var symbol24 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals5() {
  if (arguments.length === 1) {
    return (self2) => compareBoth5(self2, arguments[0]);
  }
  return compareBoth5(arguments[0], arguments[1]);
}
function compareBoth5(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual5(self2) && isEqual5(that)) {
        if (hash5(self2) === hash5(that) && self2[symbol24](that)) {
          return true;
        } else {
          return structuralRegionState5.enabled && structuralRegionState5.tester ? structuralRegionState5.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState5.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v322, i322) => compareBoth5(v322, that[i322]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth5(self2[key], that[key]))) {
              return structuralRegionState5.tester ? structuralRegionState5.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState5.tester ? structuralRegionState5.tester(self2, that) : false;
    }
  }
  return structuralRegionState5.enabled && structuralRegionState5.tester ? structuralRegionState5.tester(self2, that) : false;
}
var isEqual5 = (u322) => hasProperty5(u322, symbol24);
var equivalence5 = () => equals5;
var NodeInspectSymbol5 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON5 = (x322) => {
  if (hasProperty5(x322, "toJSON") && isFunction34(x322["toJSON"]) && x322["toJSON"].length === 0) {
    return x322.toJSON();
  } else if (Array.isArray(x322)) {
    return x322.map(toJSON5);
  }
  return x322;
};
var format5 = (x322) => JSON.stringify(x322, null, 2);
var pipeArguments5 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i322 = 0, len = args.length; i322 < len; i322++) {
        ret = args[i322](ret);
      }
      return ret;
    }
  }
};
var OP_COMMIT3 = "Commit";
var OP_FAILURE4 = "Failure";
var OP_WITH_RUNTIME4 = "WithRuntime";
var EffectTypeId6 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId5 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId5 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId5 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance5 = {
  /* c8 ignore next */
  _R: (_322) => _322,
  /* c8 ignore next */
  _E: (_322) => _322,
  /* c8 ignore next */
  _A: (_322) => _322,
  _V: /* @__PURE__ */ getCurrentVersion5()
};
var sinkVariance5 = {
  /* c8 ignore next */
  _A: (_322) => _322,
  /* c8 ignore next */
  _In: (_322) => _322,
  /* c8 ignore next */
  _L: (_322) => _322,
  /* c8 ignore next */
  _E: (_322) => _322,
  /* c8 ignore next */
  _R: (_322) => _322
};
var channelVariance5 = {
  /* c8 ignore next */
  _Env: (_322) => _322,
  /* c8 ignore next */
  _InErr: (_322) => _322,
  /* c8 ignore next */
  _InElem: (_322) => _322,
  /* c8 ignore next */
  _InDone: (_322) => _322,
  /* c8 ignore next */
  _OutErr: (_322) => _322,
  /* c8 ignore next */
  _OutElem: (_322) => _322,
  /* c8 ignore next */
  _OutDone: (_322) => _322
};
var EffectPrototype5 = {
  [EffectTypeId6]: effectVariance5,
  [StreamTypeId5]: effectVariance5,
  [SinkTypeId5]: sinkVariance5,
  [ChannelTypeId5]: channelVariance5,
  [symbol24](that) {
    return this === that;
  },
  [symbol7]() {
    return cached5(this, random5(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen6(new YieldWrap5(this));
  },
  pipe() {
    return pipeArguments5(this, arguments);
  }
};
var StructuralPrototype3 = {
  [symbol7]() {
    return cached5(this, structure3(this));
  },
  [symbol24](that) {
    const selfKeys = Object.keys(this);
    const thatKeys = Object.keys(that);
    if (selfKeys.length !== thatKeys.length) {
      return false;
    }
    for (const key of selfKeys) {
      if (!(key in that && equals5(this[key], that[key]))) {
        return false;
      }
    }
    return true;
  }
};
var CommitPrototype3 = {
  ...EffectPrototype5,
  _op: OP_COMMIT3
};
var StructuralCommitPrototype3 = {
  ...CommitPrototype3,
  ...StructuralPrototype3
};
var TypeId11 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto7 = {
  ...EffectPrototype5,
  [TypeId11]: {
    _A: (_322) => _322
  },
  [NodeInspectSymbol5]() {
    return this.toJSON();
  },
  toString() {
    return format5(this.toJSON());
  }
};
var SomeProto5 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto7), {
  _tag: "Some",
  _op: "Some",
  [symbol24](that) {
    return isOption7(that) && isSome7(that) && equals5(this.value, that.value);
  },
  [symbol7]() {
    return cached5(this, combine6(hash5(this._tag))(hash5(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON5(this.value)
    };
  }
});
var NoneHash5 = /* @__PURE__ */ hash5("None");
var NoneProto5 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto7), {
  _tag: "None",
  _op: "None",
  [symbol24](that) {
    return isOption7(that) && isNone7(that);
  },
  [symbol7]() {
    return NoneHash5;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption7 = (input) => hasProperty5(input, TypeId11);
var isNone7 = (fa) => fa._tag === "None";
var isSome7 = (fa) => fa._tag === "Some";
var none7 = /* @__PURE__ */ Object.create(NoneProto5);
var some24 = (value) => {
  const a322 = Object.create(SomeProto5);
  a322.value = value;
  return a322;
};
var TypeId24 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto24 = {
  ...EffectPrototype5,
  [TypeId24]: {
    _R: (_322) => _322
  },
  [NodeInspectSymbol5]() {
    return this.toJSON();
  },
  toString() {
    return format5(this.toJSON());
  }
};
var RightProto5 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto24), {
  _tag: "Right",
  _op: "Right",
  [symbol24](that) {
    return isEither5(that) && isRight6(that) && equals5(this.right, that.right);
  },
  [symbol7]() {
    return combine6(hash5(this._tag))(hash5(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON5(this.right)
    };
  }
});
var LeftProto5 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto24), {
  _tag: "Left",
  _op: "Left",
  [symbol24](that) {
    return isEither5(that) && isLeft6(that) && equals5(this.left, that.left);
  },
  [symbol7]() {
    return combine6(hash5(this._tag))(hash5(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON5(this.left)
    };
  }
});
var isEither5 = (input) => hasProperty5(input, TypeId24);
var isLeft6 = (ma) => ma._tag === "Left";
var isRight6 = (ma) => ma._tag === "Right";
var left6 = (left334) => {
  const a322 = Object.create(LeftProto5);
  a322.left = left334;
  return a322;
};
var right6 = (right334) => {
  const a322 = Object.create(RightProto5);
  a322.right = right334;
  return a322;
};
var getLeft7 = (self2) => isRight6(self2) ? none7 : some24(self2.left);
var getRight7 = (self2) => isLeft6(self2) ? none7 : some24(self2.right);
var right24 = right6;
var left24 = left6;
var Option_exports5 = {};
__export23(Option_exports5, {
  Do: () => Do6,
  TypeId: () => TypeId34,
  all: () => all24,
  andThen: () => andThen5,
  ap: () => ap5,
  as: () => as5,
  asVoid: () => asVoid5,
  bind: () => bind24,
  bindTo: () => bindTo24,
  composeK: () => composeK5,
  contains: () => contains6,
  containsWith: () => containsWith6,
  exists: () => exists5,
  filter: () => filter6,
  filterMap: () => filterMap6,
  firstSomeOf: () => firstSomeOf5,
  flatMap: () => flatMap6,
  flatMapNullable: () => flatMapNullable6,
  flatten: () => flatten6,
  fromIterable: () => fromIterable7,
  fromNullable: () => fromNullable6,
  gen: () => gen5,
  getEquivalence: () => getEquivalence7,
  getLeft: () => getLeft24,
  getOrElse: () => getOrElse5,
  getOrNull: () => getOrNull5,
  getOrThrow: () => getOrThrow5,
  getOrThrowWith: () => getOrThrowWith5,
  getOrUndefined: () => getOrUndefined5,
  getOrder: () => getOrder6,
  getRight: () => getRight24,
  isNone: () => isNone24,
  isOption: () => isOption24,
  isSome: () => isSome24,
  let: () => let_24,
  lift2: () => lift25,
  liftNullable: () => liftNullable6,
  liftPredicate: () => liftPredicate6,
  liftThrowable: () => liftThrowable5,
  map: () => map6,
  match: () => match24,
  none: () => none24,
  orElse: () => orElse5,
  orElseEither: () => orElseEither5,
  orElseSome: () => orElseSome5,
  partitionMap: () => partitionMap6,
  product: () => product24,
  productMany: () => productMany24,
  reduceCompact: () => reduceCompact5,
  some: () => some34,
  tap: () => tap5,
  toArray: () => toArray5,
  toRefinement: () => toRefinement5,
  void: () => void_5,
  zipLeft: () => zipLeft5,
  zipRight: () => zipRight5,
  zipWith: () => zipWith6
});
var make24 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId34 = /* @__PURE__ */ Symbol.for("effect/Option");
var none24 = () => none7;
var some34 = some24;
var isOption24 = isOption7;
var isNone24 = isNone7;
var isSome24 = isSome7;
var match24 = /* @__PURE__ */ dual5(2, (self2, {
  onNone,
  onSome
}) => isNone24(self2) ? onNone() : onSome(self2.value));
var toRefinement5 = (f322) => (a322) => isSome24(f322(a322));
var fromIterable7 = (collection) => {
  for (const a322 of collection) {
    return some34(a322);
  }
  return none24();
};
var getRight24 = getRight7;
var getLeft24 = getLeft7;
var getOrElse5 = /* @__PURE__ */ dual5(2, (self2, onNone) => isNone24(self2) ? onNone() : self2.value);
var orElse5 = /* @__PURE__ */ dual5(2, (self2, that) => isNone24(self2) ? that() : self2);
var orElseSome5 = /* @__PURE__ */ dual5(2, (self2, onNone) => isNone24(self2) ? some34(onNone()) : self2);
var orElseEither5 = /* @__PURE__ */ dual5(2, (self2, that) => isNone24(self2) ? map6(that(), right6) : map6(self2, left6));
var firstSomeOf5 = (collection) => {
  let out = none24();
  for (out of collection) {
    if (isSome24(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable6 = (nullableValue) => nullableValue == null ? none24() : some34(nullableValue);
var liftNullable6 = (f322) => (...a322) => fromNullable6(f322(...a322));
var getOrNull5 = /* @__PURE__ */ getOrElse5(constNull5);
var getOrUndefined5 = /* @__PURE__ */ getOrElse5(constUndefined5);
var liftThrowable5 = (f322) => (...a322) => {
  try {
    return some34(f322(...a322));
  } catch (e322) {
    return none24();
  }
};
var getOrThrowWith5 = /* @__PURE__ */ dual5(2, (self2, onNone) => {
  if (isSome24(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow5 = /* @__PURE__ */ getOrThrowWith5(() => new Error("getOrThrow called on a None"));
var map6 = /* @__PURE__ */ dual5(2, (self2, f322) => isNone24(self2) ? none24() : some34(f322(self2.value)));
var as5 = /* @__PURE__ */ dual5(2, (self2, b322) => map6(self2, () => b322));
var asVoid5 = /* @__PURE__ */ as5(void 0);
var void_5 = /* @__PURE__ */ some34(void 0);
var flatMap6 = /* @__PURE__ */ dual5(2, (self2, f322) => isNone24(self2) ? none24() : f322(self2.value));
var andThen5 = /* @__PURE__ */ dual5(2, (self2, f322) => flatMap6(self2, (a322) => {
  const b322 = isFunction24(f322) ? f322(a322) : f322;
  return isOption24(b322) ? b322 : some34(b322);
}));
var flatMapNullable6 = /* @__PURE__ */ dual5(2, (self2, f322) => isNone24(self2) ? none24() : fromNullable6(f322(self2.value)));
var flatten6 = /* @__PURE__ */ flatMap6(identity5);
var zipRight5 = /* @__PURE__ */ dual5(2, (self2, that) => flatMap6(self2, () => that));
var composeK5 = /* @__PURE__ */ dual5(2, (afb, bfc) => (a322) => flatMap6(afb(a322), bfc));
var zipLeft5 = /* @__PURE__ */ dual5(2, (self2, that) => tap5(self2, () => that));
var tap5 = /* @__PURE__ */ dual5(2, (self2, f322) => flatMap6(self2, (a322) => map6(f322(a322), () => a322)));
var product24 = (self2, that) => isSome24(self2) && isSome24(that) ? some34([self2.value, that.value]) : none24();
var productMany24 = (self2, collection) => {
  if (isNone24(self2)) {
    return none24();
  }
  const out = [self2.value];
  for (const o322 of collection) {
    if (isNone24(o322)) {
      return none24();
    }
    out.push(o322.value);
  }
  return some34(out);
};
var all24 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o322 of input) {
      if (isNone24(o322)) {
        return none24();
      }
      out2.push(o322.value);
    }
    return some34(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o322 = input[key];
    if (isNone24(o322)) {
      return none24();
    }
    out[key] = o322.value;
  }
  return some34(out);
};
var zipWith6 = /* @__PURE__ */ dual5(3, (self2, that, f322) => map6(product24(self2, that), ([a322, b322]) => f322(a322, b322)));
var ap5 = /* @__PURE__ */ dual5(2, (self2, that) => zipWith6(self2, that, (f322, a322) => f322(a322)));
var reduceCompact5 = /* @__PURE__ */ dual5(3, (self2, b322, f322) => {
  let out = b322;
  for (const oa of self2) {
    if (isSome24(oa)) {
      out = f322(out, oa.value);
    }
  }
  return out;
});
var toArray5 = (self2) => isNone24(self2) ? [] : [self2.value];
var partitionMap6 = /* @__PURE__ */ dual5(2, (self2, f322) => {
  if (isNone24(self2)) {
    return [none24(), none24()];
  }
  const e322 = f322(self2.value);
  return isLeft6(e322) ? [some34(e322.left), none24()] : [none24(), some34(e322.right)];
});
var filterMap6 = /* @__PURE__ */ dual5(2, (self2, f322) => isNone24(self2) ? none24() : f322(self2.value));
var filter6 = /* @__PURE__ */ dual5(2, (self2, predicate) => filterMap6(self2, (b322) => predicate(b322) ? some24(b322) : none7));
var getEquivalence7 = (isEquivalent) => make13((x322, y322) => x322 === y322 || (isNone24(x322) ? isNone24(y322) : isNone24(y322) ? false : isEquivalent(x322.value, y322.value)));
var getOrder6 = (O322) => make24((self2, that) => isSome24(self2) ? isSome24(that) ? O322(self2.value, that.value) : 1 : -1);
var lift25 = (f322) => dual5(2, (self2, that) => zipWith6(self2, that, f322));
var liftPredicate6 = (predicate) => (b322) => predicate(b322) ? some34(b322) : none24();
var containsWith6 = (isEquivalent) => dual5(2, (self2, a322) => isNone24(self2) ? false : isEquivalent(self2.value, a322));
var _equivalence7 = /* @__PURE__ */ equivalence5();
var contains6 = /* @__PURE__ */ containsWith6(_equivalence7);
var exists5 = /* @__PURE__ */ dual5(2, (self2, refinement) => isNone24(self2) ? false : refinement(self2.value));
var bindTo24 = /* @__PURE__ */ bindTo8(map6);
var let_24 = /* @__PURE__ */ let_8(map6);
var bind24 = /* @__PURE__ */ bind8(map6, flatMap6);
var Do6 = /* @__PURE__ */ some34({});
var adapter24 = /* @__PURE__ */ adapter7();
var gen5 = (f322) => {
  const iterator = f322(adapter24);
  let state = iterator.next();
  if (state.done) {
    return some34(state.value);
  } else {
    let current = state.value;
    if (isGenKind5(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet5(current);
    }
    if (isNone24(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind5(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet5(current);
        }
        if (isNone24(current)) {
          return current;
        }
      }
    }
    return some34(state.value);
  }
};
var fromIterable24 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var reverse6 = (self2) => Array.from(self2).reverse();
var reduce7 = /* @__PURE__ */ dual5(3, (self2, b322, f322) => fromIterable24(self2).reduce((b2222, a322, i322) => f322(b2222, a322, i322), b322));
var TagTypeId4 = /* @__PURE__ */ Symbol.for("effect/Context/Tag");
var STMSymbolKey4 = "effect/STM";
var STMTypeId4 = /* @__PURE__ */ Symbol.for(STMSymbolKey4);
var TagProto4 = {
  ...EffectPrototype5,
  _tag: "Tag",
  _op: "Tag",
  [STMTypeId4]: effectVariance5,
  [TagTypeId4]: {
    _Service: (_322) => _322,
    _Identifier: (_322) => _322
  },
  toString() {
    return format5(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Tag",
      key: this.key,
      stack: this.stack
    };
  },
  [NodeInspectSymbol5]() {
    return this.toJSON();
  },
  of(self2) {
    return self2;
  },
  context(self2) {
    return make34(this, self2);
  }
};
var makeGenericTag4 = (key) => {
  const limit = Error.stackTraceLimit;
  Error.stackTraceLimit = 2;
  const creationError = new Error();
  Error.stackTraceLimit = limit;
  const tag = Object.create(TagProto4);
  Object.defineProperty(tag, "stack", {
    get() {
      return creationError.stack;
    }
  });
  tag.key = key;
  return tag;
};
var TypeId44 = /* @__PURE__ */ Symbol.for("effect/Context");
var ContextProto4 = {
  [TypeId44]: {
    _Services: (_322) => _322
  },
  [symbol24](that) {
    if (isContext4(that)) {
      if (this.unsafeMap.size === that.unsafeMap.size) {
        for (const k322 of this.unsafeMap.keys()) {
          if (!that.unsafeMap.has(k322) || !equals5(this.unsafeMap.get(k322), that.unsafeMap.get(k322))) {
            return false;
          }
        }
        return true;
      }
    }
    return false;
  },
  [symbol7]() {
    return cached5(this, number6(this.unsafeMap.size));
  },
  pipe() {
    return pipeArguments5(this, arguments);
  },
  toString() {
    return format5(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Context",
      services: Array.from(this.unsafeMap).map(toJSON5)
    };
  },
  [NodeInspectSymbol5]() {
    return this.toJSON();
  }
};
var makeContext4 = (unsafeMap) => {
  const context = Object.create(ContextProto4);
  context.unsafeMap = unsafeMap;
  return context;
};
var isContext4 = (u322) => hasProperty5(u322, TypeId44);
var _empty8 = /* @__PURE__ */ makeContext4(/* @__PURE__ */ new Map());
var empty12 = () => _empty8;
var make34 = (tag, service) => makeContext4(/* @__PURE__ */ new Map([[tag.key, service]]));
var GenericTag4 = makeGenericTag4;
var empty24 = empty12;
var TypeId54 = /* @__PURE__ */ Symbol.for("effect/Chunk");
function copy5(src, srcPos, dest, destPos, len) {
  for (let i322 = srcPos; i322 < Math.min(src.length, srcPos + len); i322++) {
    dest[destPos + i322 - srcPos] = src[i322];
  }
  return dest;
}
var emptyArray4 = [];
var getEquivalence24 = (isEquivalent) => make13((self2, that) => self2.length === that.length && toReadonlyArray4(self2).every((value, i322) => isEquivalent(value, unsafeGet24(that, i322))));
var _equivalence24 = /* @__PURE__ */ getEquivalence24(equals5);
var ChunkProto4 = {
  [TypeId54]: {
    _A: (_322) => _322
  },
  toString() {
    return format5(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Chunk",
      values: toReadonlyArray4(this).map(toJSON5)
    };
  },
  [NodeInspectSymbol5]() {
    return this.toJSON();
  },
  [symbol24](that) {
    return isChunk4(that) && _equivalence24(this, that);
  },
  [symbol7]() {
    return cached5(this, array8(toReadonlyArray4(this)));
  },
  [Symbol.iterator]() {
    switch (this.backing._tag) {
      case "IArray": {
        return this.backing.array[Symbol.iterator]();
      }
      case "IEmpty": {
        return emptyArray4[Symbol.iterator]();
      }
      default: {
        return toReadonlyArray4(this)[Symbol.iterator]();
      }
    }
  },
  pipe() {
    return pipeArguments5(this, arguments);
  }
};
var makeChunk4 = (backing) => {
  const chunk = Object.create(ChunkProto4);
  chunk.backing = backing;
  switch (backing._tag) {
    case "IEmpty": {
      chunk.length = 0;
      chunk.depth = 0;
      chunk.left = chunk;
      chunk.right = chunk;
      break;
    }
    case "IConcat": {
      chunk.length = backing.left.length + backing.right.length;
      chunk.depth = 1 + Math.max(backing.left.depth, backing.right.depth);
      chunk.left = backing.left;
      chunk.right = backing.right;
      break;
    }
    case "IArray": {
      chunk.length = backing.array.length;
      chunk.depth = 0;
      chunk.left = _empty24;
      chunk.right = _empty24;
      break;
    }
    case "ISingleton": {
      chunk.length = 1;
      chunk.depth = 0;
      chunk.left = _empty24;
      chunk.right = _empty24;
      break;
    }
    case "ISlice": {
      chunk.length = backing.length;
      chunk.depth = backing.chunk.depth + 1;
      chunk.left = _empty24;
      chunk.right = _empty24;
      break;
    }
  }
  return chunk;
};
var isChunk4 = (u322) => hasProperty5(u322, TypeId54);
var _empty24 = /* @__PURE__ */ makeChunk4({
  _tag: "IEmpty"
});
var empty34 = () => _empty24;
var make44 = (...as2422) => as2422.length === 1 ? of5(as2422[0]) : unsafeFromNonEmptyArray4(as2422);
var of5 = (a322) => makeChunk4({
  _tag: "ISingleton",
  a: a322
});
var copyToArray4 = (self2, array334, initial) => {
  switch (self2.backing._tag) {
    case "IArray": {
      copy5(self2.backing.array, 0, array334, initial, self2.length);
      break;
    }
    case "IConcat": {
      copyToArray4(self2.left, array334, initial);
      copyToArray4(self2.right, array334, initial + self2.left.length);
      break;
    }
    case "ISingleton": {
      array334[initial] = self2.backing.a;
      break;
    }
    case "ISlice": {
      let i322 = 0;
      let j322 = initial;
      while (i322 < self2.length) {
        array334[j322] = unsafeGet24(self2, i322);
        i322 += 1;
        j322 += 1;
      }
      break;
    }
  }
};
var toReadonlyArray4 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      return emptyArray4;
    }
    case "IArray": {
      return self2.backing.array;
    }
    default: {
      const arr = new Array(self2.length);
      copyToArray4(self2, arr, 0);
      self2.backing = {
        _tag: "IArray",
        array: arr
      };
      self2.left = _empty24;
      self2.right = _empty24;
      self2.depth = 0;
      return arr;
    }
  }
};
var reverse24 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty":
    case "ISingleton":
      return self2;
    case "IArray": {
      return makeChunk4({
        _tag: "IArray",
        array: reverse6(self2.backing.array)
      });
    }
    case "IConcat": {
      return makeChunk4({
        _tag: "IConcat",
        left: reverse24(self2.backing.right),
        right: reverse24(self2.backing.left)
      });
    }
    case "ISlice":
      return unsafeFromArray4(reverse6(toReadonlyArray4(self2)));
  }
};
var unsafeFromArray4 = (self2) => makeChunk4({
  _tag: "IArray",
  array: self2
});
var unsafeFromNonEmptyArray4 = (self2) => unsafeFromArray4(self2);
var unsafeGet24 = /* @__PURE__ */ dual5(2, (self2, index) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      throw new Error(`Index out of bounds`);
    }
    case "ISingleton": {
      if (index !== 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.a;
    }
    case "IArray": {
      if (index >= self2.length || index < 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.array[index];
    }
    case "IConcat": {
      return index < self2.left.length ? unsafeGet24(self2.left, index) : unsafeGet24(self2.right, index - self2.left.length);
    }
    case "ISlice": {
      return unsafeGet24(self2.backing.chunk, index + self2.backing.offset);
    }
  }
});
var prepend5 = /* @__PURE__ */ dual5(2, (self2, elem) => appendAll5(of5(elem), self2));
var drop5 = /* @__PURE__ */ dual5(2, (self2, n322) => {
  if (n322 <= 0) {
    return self2;
  } else if (n322 >= self2.length) {
    return _empty24;
  } else {
    switch (self2.backing._tag) {
      case "ISlice": {
        return makeChunk4({
          _tag: "ISlice",
          chunk: self2.backing.chunk,
          offset: self2.backing.offset + n322,
          length: self2.backing.length - n322
        });
      }
      case "IConcat": {
        if (n322 > self2.left.length) {
          return drop5(self2.right, n322 - self2.left.length);
        }
        return makeChunk4({
          _tag: "IConcat",
          left: drop5(self2.left, n322),
          right: self2.right
        });
      }
      default: {
        return makeChunk4({
          _tag: "ISlice",
          chunk: self2,
          offset: n322,
          length: self2.length - n322
        });
      }
    }
  }
});
var appendAll5 = /* @__PURE__ */ dual5(2, (self2, that) => {
  if (self2.backing._tag === "IEmpty") {
    return that;
  }
  if (that.backing._tag === "IEmpty") {
    return self2;
  }
  const diff234 = that.depth - self2.depth;
  if (Math.abs(diff234) <= 1) {
    return makeChunk4({
      _tag: "IConcat",
      left: self2,
      right: that
    });
  } else if (diff234 < -1) {
    if (self2.left.depth >= self2.right.depth) {
      const nr = appendAll5(self2.right, that);
      return makeChunk4({
        _tag: "IConcat",
        left: self2.left,
        right: nr
      });
    } else {
      const nrr = appendAll5(self2.right.right, that);
      if (nrr.depth === self2.depth - 3) {
        const nr = makeChunk4({
          _tag: "IConcat",
          left: self2.right.left,
          right: nrr
        });
        return makeChunk4({
          _tag: "IConcat",
          left: self2.left,
          right: nr
        });
      } else {
        const nl = makeChunk4({
          _tag: "IConcat",
          left: self2.left,
          right: self2.right.left
        });
        return makeChunk4({
          _tag: "IConcat",
          left: nl,
          right: nrr
        });
      }
    }
  } else {
    if (that.right.depth >= that.left.depth) {
      const nl = appendAll5(self2, that.left);
      return makeChunk4({
        _tag: "IConcat",
        left: nl,
        right: that.right
      });
    } else {
      const nll = appendAll5(self2, that.left.left);
      if (nll.depth === that.depth - 3) {
        const nl = makeChunk4({
          _tag: "IConcat",
          left: nll,
          right: that.left.right
        });
        return makeChunk4({
          _tag: "IConcat",
          left: nl,
          right: that.right
        });
      } else {
        const nr = makeChunk4({
          _tag: "IConcat",
          left: that.left.right,
          right: that.right
        });
        return makeChunk4({
          _tag: "IConcat",
          left: nll,
          right: nr
        });
      }
    }
  }
});
var isEmpty4 = (self2) => self2.length === 0;
var isNonEmpty4 = (self2) => self2.length > 0;
var unsafeHead4 = (self2) => unsafeGet24(self2, 0);
var headNonEmpty5 = unsafeHead4;
var tailNonEmpty5 = (self2) => drop5(self2, 1);
var SIZE4 = 5;
var BUCKET_SIZE4 = /* @__PURE__ */ Math.pow(2, SIZE4);
var MASK4 = BUCKET_SIZE4 - 1;
var MAX_INDEX_NODE4 = BUCKET_SIZE4 / 2;
var MIN_ARRAY_NODE4 = BUCKET_SIZE4 / 4;
function popcount4(x322) {
  x322 -= x322 >> 1 & 1431655765;
  x322 = (x322 & 858993459) + (x322 >> 2 & 858993459);
  x322 = x322 + (x322 >> 4) & 252645135;
  x322 += x322 >> 8;
  x322 += x322 >> 16;
  return x322 & 127;
}
function hashFragment4(shift22, h322) {
  return h322 >>> shift22 & MASK4;
}
function toBitmap4(x322) {
  return 1 << x322;
}
function fromBitmap4(bitmap, bit) {
  return popcount4(bitmap & bit - 1);
}
var make54 = (value, previous) => ({
  value,
  previous
});
function arrayUpdate4(mutate234, at, v322, arr) {
  let out = arr;
  if (!mutate234) {
    const len = arr.length;
    out = new Array(len);
    for (let i322 = 0; i322 < len; ++i322) out[i322] = arr[i322];
  }
  out[at] = v322;
  return out;
}
function arraySpliceOut4(mutate234, at, arr) {
  const newLen = arr.length - 1;
  let i322 = 0;
  let g322 = 0;
  let out = arr;
  if (mutate234) {
    i322 = g322 = at;
  } else {
    out = new Array(newLen);
    while (i322 < at) out[g322++] = arr[i322++];
  }
  ++i322;
  while (i322 <= newLen) out[g322++] = arr[i322++];
  if (mutate234) {
    out.length = newLen;
  }
  return out;
}
function arraySpliceIn4(mutate234, at, v322, arr) {
  const len = arr.length;
  if (mutate234) {
    let i2222 = len;
    while (i2222 >= at) arr[i2222--] = arr[i2222];
    arr[at] = v322;
    return arr;
  }
  let i322 = 0, g322 = 0;
  const out = new Array(len + 1);
  while (i322 < at) out[g322++] = arr[i322++];
  out[at] = v322;
  while (i322 < len) out[++g322] = arr[i322++];
  return out;
}
var EmptyNode4 = class _EmptyNode4 {
  _tag = "EmptyNode";
  modify(edit, _shift, f322, hash2422, key, size434) {
    const v322 = f322(none24());
    if (isNone24(v322)) return new _EmptyNode4();
    ++size434.value;
    return new LeafNode4(edit, hash2422, key, v322);
  }
};
function isEmptyNode4(a322) {
  return isTagged5(a322, "EmptyNode");
}
function isLeafNode4(node) {
  return isEmptyNode4(node) || node._tag === "LeafNode" || node._tag === "CollisionNode";
}
function canEditNode4(node, edit) {
  return isEmptyNode4(node) ? false : edit === node.edit;
}
var LeafNode4 = class _LeafNode4 {
  edit;
  hash;
  key;
  value;
  _tag = "LeafNode";
  constructor(edit, hash2422, key, value) {
    this.edit = edit;
    this.hash = hash2422;
    this.key = key;
    this.value = value;
  }
  modify(edit, shift22, f322, hash2422, key, size434) {
    if (equals5(key, this.key)) {
      const v2222 = f322(this.value);
      if (v2222 === this.value) return this;
      else if (isNone24(v2222)) {
        --size434.value;
        return new EmptyNode4();
      }
      if (canEditNode4(this, edit)) {
        this.value = v2222;
        return this;
      }
      return new _LeafNode4(edit, hash2422, key, v2222);
    }
    const v322 = f322(none24());
    if (isNone24(v322)) return this;
    ++size434.value;
    return mergeLeaves4(edit, shift22, this.hash, this, hash2422, new _LeafNode4(edit, hash2422, key, v322));
  }
};
var CollisionNode4 = class _CollisionNode4 {
  edit;
  hash;
  children;
  _tag = "CollisionNode";
  constructor(edit, hash2422, children) {
    this.edit = edit;
    this.hash = hash2422;
    this.children = children;
  }
  modify(edit, shift22, f322, hash2422, key, size434) {
    if (hash2422 === this.hash) {
      const canEdit = canEditNode4(this, edit);
      const list = this.updateCollisionList(canEdit, edit, this.hash, this.children, f322, key, size434);
      if (list === this.children) return this;
      return list.length > 1 ? new _CollisionNode4(edit, this.hash, list) : list[0];
    }
    const v322 = f322(none24());
    if (isNone24(v322)) return this;
    ++size434.value;
    return mergeLeaves4(edit, shift22, this.hash, this, hash2422, new LeafNode4(edit, hash2422, key, v322));
  }
  updateCollisionList(mutate234, edit, hash2422, list, f322, key, size434) {
    const len = list.length;
    for (let i322 = 0; i322 < len; ++i322) {
      const child = list[i322];
      if ("key" in child && equals5(key, child.key)) {
        const value = child.value;
        const newValue2 = f322(value);
        if (newValue2 === value) return list;
        if (isNone24(newValue2)) {
          --size434.value;
          return arraySpliceOut4(mutate234, i322, list);
        }
        return arrayUpdate4(mutate234, i322, new LeafNode4(edit, hash2422, key, newValue2), list);
      }
    }
    const newValue = f322(none24());
    if (isNone24(newValue)) return list;
    ++size434.value;
    return arrayUpdate4(mutate234, len, new LeafNode4(edit, hash2422, key, newValue), list);
  }
};
var IndexedNode4 = class _IndexedNode4 {
  edit;
  mask;
  children;
  _tag = "IndexedNode";
  constructor(edit, mask, children) {
    this.edit = edit;
    this.mask = mask;
    this.children = children;
  }
  modify(edit, shift22, f322, hash2422, key, size434) {
    const mask = this.mask;
    const children = this.children;
    const frag = hashFragment4(shift22, hash2422);
    const bit = toBitmap4(frag);
    const indx = fromBitmap4(mask, bit);
    const exists2422 = mask & bit;
    const canEdit = canEditNode4(this, edit);
    if (!exists2422) {
      const _newChild = new EmptyNode4().modify(edit, shift22 + SIZE4, f322, hash2422, key, size434);
      if (!_newChild) return this;
      return children.length >= MAX_INDEX_NODE4 ? expand4(edit, frag, _newChild, mask, children) : new _IndexedNode4(edit, mask | bit, arraySpliceIn4(canEdit, indx, _newChild, children));
    }
    const current = children[indx];
    const child = current.modify(edit, shift22 + SIZE4, f322, hash2422, key, size434);
    if (current === child) return this;
    let bitmap = mask;
    let newChildren;
    if (isEmptyNode4(child)) {
      bitmap &= ~bit;
      if (!bitmap) return new EmptyNode4();
      if (children.length <= 2 && isLeafNode4(children[indx ^ 1])) {
        return children[indx ^ 1];
      }
      newChildren = arraySpliceOut4(canEdit, indx, children);
    } else {
      newChildren = arrayUpdate4(canEdit, indx, child, children);
    }
    if (canEdit) {
      this.mask = bitmap;
      this.children = newChildren;
      return this;
    }
    return new _IndexedNode4(edit, bitmap, newChildren);
  }
};
var ArrayNode4 = class _ArrayNode4 {
  edit;
  size;
  children;
  _tag = "ArrayNode";
  constructor(edit, size434, children) {
    this.edit = edit;
    this.size = size434;
    this.children = children;
  }
  modify(edit, shift22, f322, hash2422, key, size434) {
    let count = this.size;
    const children = this.children;
    const frag = hashFragment4(shift22, hash2422);
    const child = children[frag];
    const newChild = (child || new EmptyNode4()).modify(edit, shift22 + SIZE4, f322, hash2422, key, size434);
    if (child === newChild) return this;
    const canEdit = canEditNode4(this, edit);
    let newChildren;
    if (isEmptyNode4(child) && !isEmptyNode4(newChild)) {
      ++count;
      newChildren = arrayUpdate4(canEdit, frag, newChild, children);
    } else if (!isEmptyNode4(child) && isEmptyNode4(newChild)) {
      --count;
      if (count <= MIN_ARRAY_NODE4) {
        return pack4(edit, count, frag, children);
      }
      newChildren = arrayUpdate4(canEdit, frag, new EmptyNode4(), children);
    } else {
      newChildren = arrayUpdate4(canEdit, frag, newChild, children);
    }
    if (canEdit) {
      this.size = count;
      this.children = newChildren;
      return this;
    }
    return new _ArrayNode4(edit, count, newChildren);
  }
};
function pack4(edit, count, removed, elements) {
  const children = new Array(count - 1);
  let g322 = 0;
  let bitmap = 0;
  for (let i322 = 0, len = elements.length; i322 < len; ++i322) {
    if (i322 !== removed) {
      const elem = elements[i322];
      if (elem && !isEmptyNode4(elem)) {
        children[g322++] = elem;
        bitmap |= 1 << i322;
      }
    }
  }
  return new IndexedNode4(edit, bitmap, children);
}
function expand4(edit, frag, child, bitmap, subNodes) {
  const arr = [];
  let bit = bitmap;
  let count = 0;
  for (let i322 = 0; bit; ++i322) {
    if (bit & 1) arr[i322] = subNodes[count++];
    bit >>>= 1;
  }
  arr[frag] = child;
  return new ArrayNode4(edit, count + 1, arr);
}
function mergeLeavesInner4(edit, shift22, h1, n1, h2222, n2222) {
  if (h1 === h2222) return new CollisionNode4(edit, h1, [n2222, n1]);
  const subH1 = hashFragment4(shift22, h1);
  const subH2 = hashFragment4(shift22, h2222);
  if (subH1 === subH2) {
    return (child) => new IndexedNode4(edit, toBitmap4(subH1) | toBitmap4(subH2), [child]);
  } else {
    const children = subH1 < subH2 ? [n1, n2222] : [n2222, n1];
    return new IndexedNode4(edit, toBitmap4(subH1) | toBitmap4(subH2), children);
  }
}
function mergeLeaves4(edit, shift22, h1, n1, h2222, n2222) {
  let stack = void 0;
  let currentShift = shift22;
  while (true) {
    const res = mergeLeavesInner4(edit, currentShift, h1, n1, h2222, n2222);
    if (typeof res === "function") {
      stack = make54(res, stack);
      currentShift = currentShift + SIZE4;
    } else {
      let final = res;
      while (stack != null) {
        final = stack.value(final);
        stack = stack.previous;
      }
      return final;
    }
  }
}
var HashMapSymbolKey4 = "effect/HashMap";
var HashMapTypeId4 = /* @__PURE__ */ Symbol.for(HashMapSymbolKey4);
var HashMapProto4 = {
  [HashMapTypeId4]: HashMapTypeId4,
  [Symbol.iterator]() {
    return new HashMapIterator4(this, (k322, v322) => [k322, v322]);
  },
  [symbol7]() {
    let hash2422 = hash5(HashMapSymbolKey4);
    for (const item of this) {
      hash2422 ^= pipe5(hash5(item[0]), combine6(hash5(item[1])));
    }
    return cached5(this, hash2422);
  },
  [symbol24](that) {
    if (isHashMap4(that)) {
      if (that._size !== this._size) {
        return false;
      }
      for (const item of this) {
        const elem = pipe5(that, getHash4(item[0], hash5(item[0])));
        if (isNone24(elem)) {
          return false;
        } else {
          if (!equals5(item[1], elem.value)) {
            return false;
          }
        }
      }
      return true;
    }
    return false;
  },
  toString() {
    return format5(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashMap",
      values: Array.from(this).map(toJSON5)
    };
  },
  [NodeInspectSymbol5]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments5(this, arguments);
  }
};
var makeImpl5 = (editable, edit, root, size434) => {
  const map622 = Object.create(HashMapProto4);
  map622._editable = editable;
  map622._edit = edit;
  map622._root = root;
  map622._size = size434;
  return map622;
};
var HashMapIterator4 = class _HashMapIterator4 {
  map;
  f;
  v;
  constructor(map622, f322) {
    this.map = map622;
    this.f = f322;
    this.v = visitLazy4(this.map._root, this.f, void 0);
  }
  next() {
    if (isNone24(this.v)) {
      return {
        done: true,
        value: void 0
      };
    }
    const v0 = this.v.value;
    this.v = applyCont4(v0.cont);
    return {
      done: false,
      value: v0.value
    };
  }
  [Symbol.iterator]() {
    return new _HashMapIterator4(this.map, this.f);
  }
};
var applyCont4 = (cont) => cont ? visitLazyChildren4(cont[0], cont[1], cont[2], cont[3], cont[4]) : none24();
var visitLazy4 = (node, f322, cont = void 0) => {
  switch (node._tag) {
    case "LeafNode": {
      if (isSome24(node.value)) {
        return some34({
          value: f322(node.key, node.value.value),
          cont
        });
      }
      return applyCont4(cont);
    }
    case "CollisionNode":
    case "ArrayNode":
    case "IndexedNode": {
      const children = node.children;
      return visitLazyChildren4(children.length, children, 0, f322, cont);
    }
    default: {
      return applyCont4(cont);
    }
  }
};
var visitLazyChildren4 = (len, children, i322, f322, cont) => {
  while (i322 < len) {
    const child = children[i322++];
    if (child && !isEmptyNode4(child)) {
      return visitLazy4(child, f322, [len, children, i322, f322, cont]);
    }
  }
  return applyCont4(cont);
};
var _empty34 = /* @__PURE__ */ makeImpl5(false, 0, /* @__PURE__ */ new EmptyNode4(), 0);
var empty44 = () => _empty34;
var isHashMap4 = (u322) => hasProperty5(u322, HashMapTypeId4);
var getHash4 = /* @__PURE__ */ dual5(3, (self2, key, hash2422) => {
  let node = self2._root;
  let shift22 = 0;
  while (true) {
    switch (node._tag) {
      case "LeafNode": {
        return equals5(key, node.key) ? node.value : none24();
      }
      case "CollisionNode": {
        if (hash2422 === node.hash) {
          const children = node.children;
          for (let i322 = 0, len = children.length; i322 < len; ++i322) {
            const child = children[i322];
            if ("key" in child && equals5(key, child.key)) {
              return child.value;
            }
          }
        }
        return none24();
      }
      case "IndexedNode": {
        const frag = hashFragment4(shift22, hash2422);
        const bit = toBitmap4(frag);
        if (node.mask & bit) {
          node = node.children[fromBitmap4(node.mask, bit)];
          shift22 += SIZE4;
          break;
        }
        return none24();
      }
      case "ArrayNode": {
        node = node.children[hashFragment4(shift22, hash2422)];
        if (node) {
          shift22 += SIZE4;
          break;
        }
        return none24();
      }
      default:
        return none24();
    }
  }
});
var set4 = /* @__PURE__ */ dual5(3, (self2, key, value) => modifyAt4(self2, key, () => some34(value)));
var setTree4 = /* @__PURE__ */ dual5(3, (self2, newRoot, newSize) => {
  if (self2._editable) {
    self2._root = newRoot;
    self2._size = newSize;
    return self2;
  }
  return newRoot === self2._root ? self2 : makeImpl5(self2._editable, self2._edit, newRoot, newSize);
});
var keys5 = (self2) => new HashMapIterator4(self2, (key) => key);
var size6 = (self2) => self2._size;
var beginMutation5 = (self2) => makeImpl5(true, self2._edit + 1, self2._root, self2._size);
var modifyAt4 = /* @__PURE__ */ dual5(3, (self2, key, f322) => modifyHash4(self2, key, hash5(key), f322));
var modifyHash4 = /* @__PURE__ */ dual5(4, (self2, key, hash2422, f322) => {
  const size434 = {
    value: self2._size
  };
  const newRoot = self2._root.modify(self2._editable ? self2._edit : NaN, 0, f322, hash2422, key, size434);
  return pipe5(self2, setTree4(newRoot, size434.value));
});
var forEach6 = /* @__PURE__ */ dual5(2, (self2, f322) => reduce24(self2, void 0, (_322, value, key) => f322(value, key)));
var reduce24 = /* @__PURE__ */ dual5(3, (self2, zero, f322) => {
  const root = self2._root;
  if (root._tag === "LeafNode") {
    return isSome24(root.value) ? f322(zero, root.value.value, root.key) : zero;
  }
  if (root._tag === "EmptyNode") {
    return zero;
  }
  const toVisit = [root.children];
  let children;
  while (children = toVisit.pop()) {
    for (let i322 = 0, len = children.length; i322 < len; ) {
      const child = children[i322++];
      if (child && !isEmptyNode4(child)) {
        if (child._tag === "LeafNode") {
          if (isSome24(child.value)) {
            zero = f322(zero, child.value.value, child.key);
          }
        } else {
          toVisit.push(child.children);
        }
      }
    }
  }
  return zero;
});
var HashSetSymbolKey4 = "effect/HashSet";
var HashSetTypeId4 = /* @__PURE__ */ Symbol.for(HashSetSymbolKey4);
var HashSetProto4 = {
  [HashSetTypeId4]: HashSetTypeId4,
  [Symbol.iterator]() {
    return keys5(this._keyMap);
  },
  [symbol7]() {
    return cached5(this, combine6(hash5(this._keyMap))(hash5(HashSetSymbolKey4)));
  },
  [symbol24](that) {
    if (isHashSet4(that)) {
      return size6(this._keyMap) === size6(that._keyMap) && equals5(this._keyMap, that._keyMap);
    }
    return false;
  },
  toString() {
    return format5(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashSet",
      values: Array.from(this).map(toJSON5)
    };
  },
  [NodeInspectSymbol5]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments5(this, arguments);
  }
};
var makeImpl24 = (keyMap) => {
  const set2422 = Object.create(HashSetProto4);
  set2422._keyMap = keyMap;
  return set2422;
};
var isHashSet4 = (u322) => hasProperty5(u322, HashSetTypeId4);
var _empty44 = /* @__PURE__ */ makeImpl24(/* @__PURE__ */ empty44());
var empty54 = () => _empty44;
var size24 = (self2) => size6(self2._keyMap);
var beginMutation24 = (self2) => makeImpl24(beginMutation5(self2._keyMap));
var endMutation4 = (self2) => {
  self2._keyMap._editable = false;
  return self2;
};
var mutate4 = /* @__PURE__ */ dual5(2, (self2, f322) => {
  const transient = beginMutation24(self2);
  f322(transient);
  return endMutation4(transient);
});
var add24 = /* @__PURE__ */ dual5(2, (self2, value) => self2._keyMap._editable ? (set4(value, true)(self2._keyMap), self2) : makeImpl24(set4(value, true)(self2._keyMap)));
var union24 = /* @__PURE__ */ dual5(2, (self2, that) => mutate4(empty54(), (set2422) => {
  forEach24(self2, (value) => add24(set2422, value));
  for (const value of that) {
    add24(set2422, value);
  }
}));
var forEach24 = /* @__PURE__ */ dual5(2, (self2, f322) => forEach6(self2._keyMap, (_322, k322) => f322(k322)));
var empty64 = empty54;
var size34 = size24;
var add34 = add24;
var union34 = union24;
var ArrayProto4 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(Array.prototype), {
  [symbol7]() {
    return cached5(this, array8(this));
  },
  [symbol24](that) {
    if (Array.isArray(that) && this.length === that.length) {
      return this.every((v322, i322) => equals5(v322, that[i322]));
    } else {
      return false;
    }
  }
});
var Structural5 = /* @__PURE__ */ function() {
  function Structural334(args) {
    if (args) {
      Object.assign(this, args);
    }
  }
  Structural334.prototype = StructuralPrototype3;
  return Structural334;
}();
var struct24 = (as2422) => Object.assign(Object.create(StructuralPrototype3), as2422);
var ContextPatchTypeId4 = /* @__PURE__ */ Symbol.for("effect/DifferContextPatch");
function variance5(a322) {
  return a322;
}
var PatchProto4 = {
  ...Structural5.prototype,
  [ContextPatchTypeId4]: {
    _Value: variance5,
    _Patch: variance5
  }
};
var EmptyProto4 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto4), {
  _tag: "Empty"
});
var _empty54 = /* @__PURE__ */ Object.create(EmptyProto4);
var empty74 = () => _empty54;
var AndThenProto4 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto4), {
  _tag: "AndThen"
});
var makeAndThen4 = (first, second) => {
  const o322 = Object.create(AndThenProto4);
  o322.first = first;
  o322.second = second;
  return o322;
};
var AddServiceProto4 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto4), {
  _tag: "AddService"
});
var makeAddService4 = (key, service) => {
  const o322 = Object.create(AddServiceProto4);
  o322.key = key;
  o322.service = service;
  return o322;
};
var RemoveServiceProto4 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto4), {
  _tag: "RemoveService"
});
var makeRemoveService4 = (key) => {
  const o322 = Object.create(RemoveServiceProto4);
  o322.key = key;
  return o322;
};
var UpdateServiceProto4 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto4), {
  _tag: "UpdateService"
});
var makeUpdateService4 = (key, update222) => {
  const o322 = Object.create(UpdateServiceProto4);
  o322.key = key;
  o322.update = update222;
  return o322;
};
var diff4 = (oldValue, newValue) => {
  const missingServices = new Map(oldValue.unsafeMap);
  let patch234 = empty74();
  for (const [tag, newService] of newValue.unsafeMap.entries()) {
    if (missingServices.has(tag)) {
      const old = missingServices.get(tag);
      missingServices.delete(tag);
      if (!equals5(old, newService)) {
        patch234 = combine24(makeUpdateService4(tag, () => newService))(patch234);
      }
    } else {
      missingServices.delete(tag);
      patch234 = combine24(makeAddService4(tag, newService))(patch234);
    }
  }
  for (const [tag] of missingServices.entries()) {
    patch234 = combine24(makeRemoveService4(tag))(patch234);
  }
  return patch234;
};
var combine24 = /* @__PURE__ */ dual5(2, (self2, that) => makeAndThen4(self2, that));
var patch4 = /* @__PURE__ */ dual5(2, (self2, context) => {
  if (self2._tag === "Empty") {
    return context;
  }
  let wasServiceUpdated = false;
  let patches = of5(self2);
  const updatedContext = new Map(context.unsafeMap);
  while (isNonEmpty4(patches)) {
    const head222 = headNonEmpty5(patches);
    const tail322 = tailNonEmpty5(patches);
    switch (head222._tag) {
      case "Empty": {
        patches = tail322;
        break;
      }
      case "AddService": {
        updatedContext.set(head222.key, head222.service);
        patches = tail322;
        break;
      }
      case "AndThen": {
        patches = prepend5(prepend5(tail322, head222.second), head222.first);
        break;
      }
      case "RemoveService": {
        updatedContext.delete(head222.key);
        patches = tail322;
        break;
      }
      case "UpdateService": {
        updatedContext.set(head222.key, head222.update(updatedContext.get(head222.key)));
        wasServiceUpdated = true;
        patches = tail322;
        break;
      }
    }
  }
  if (!wasServiceUpdated) {
    return makeContext4(updatedContext);
  }
  const map622 = /* @__PURE__ */ new Map();
  for (const [tag] of context.unsafeMap) {
    if (updatedContext.has(tag)) {
      map622.set(tag, updatedContext.get(tag));
      updatedContext.delete(tag);
    }
  }
  for (const [tag, s322] of updatedContext) {
    map622.set(tag, s322);
  }
  return makeContext4(map622);
});
var DifferTypeId4 = /* @__PURE__ */ Symbol.for("effect/Differ");
var DifferProto4 = {
  [DifferTypeId4]: {
    _P: identity5,
    _V: identity5
  }
};
var make74 = (params) => {
  const differ = Object.create(DifferProto4);
  differ.empty = params.empty;
  differ.diff = params.diff;
  differ.combine = params.combine;
  differ.patch = params.patch;
  return differ;
};
var environment4 = () => make74({
  empty: empty74(),
  combine: (first, second) => combine24(second)(first),
  diff: (oldValue, newValue) => diff4(oldValue, newValue),
  patch: (patch234, oldValue) => patch4(oldValue)(patch234)
});
var OP_DIE4 = "Die";
var OP_EMPTY4 = "Empty";
var OP_FAIL4 = "Fail";
var OP_INTERRUPT4 = "Interrupt";
var OP_PARALLEL4 = "Parallel";
var OP_SEQUENTIAL4 = "Sequential";
var CauseSymbolKey4 = "effect/Cause";
var CauseTypeId4 = /* @__PURE__ */ Symbol.for(CauseSymbolKey4);
var variance24 = {
  /* c8 ignore next */
  _E: (_322) => _322
};
var proto4 = {
  [CauseTypeId4]: variance24,
  [symbol7]() {
    return pipe5(hash5(CauseSymbolKey4), combine6(hash5(flattenCause4(this))), cached5(this));
  },
  [symbol24](that) {
    return isCause4(that) && causeEquals4(this, that);
  },
  pipe() {
    return pipeArguments5(this, arguments);
  },
  toJSON() {
    switch (this._tag) {
      case "Empty":
        return {
          _id: "Cause",
          _tag: this._tag
        };
      case "Die":
        return {
          _id: "Cause",
          _tag: this._tag,
          defect: toJSON5(this.defect)
        };
      case "Interrupt":
        return {
          _id: "Cause",
          _tag: this._tag,
          fiberId: this.fiberId.toJSON()
        };
      case "Fail":
        return {
          _id: "Cause",
          _tag: this._tag,
          failure: toJSON5(this.error)
        };
      case "Sequential":
      case "Parallel":
        return {
          _id: "Cause",
          _tag: this._tag,
          left: toJSON5(this.left),
          right: toJSON5(this.right)
        };
    }
  },
  toString() {
    return pretty4(this);
  },
  [NodeInspectSymbol5]() {
    return this.toJSON();
  }
};
var fail5 = (error) => {
  const o322 = Object.create(proto4);
  o322._tag = OP_FAIL4;
  o322.error = error;
  return o322;
};
var parallel4 = (left334, right334) => {
  const o322 = Object.create(proto4);
  o322._tag = OP_PARALLEL4;
  o322.left = left334;
  o322.right = right334;
  return o322;
};
var sequential4 = (left334, right334) => {
  const o322 = Object.create(proto4);
  o322._tag = OP_SEQUENTIAL4;
  o322.left = left334;
  o322.right = right334;
  return o322;
};
var isCause4 = (u322) => hasProperty5(u322, CauseTypeId4);
var isInterruptedOnly4 = (self2) => reduceWithContext4(void 0, IsInterruptedOnlyCauseReducer4)(self2);
var causeEquals4 = (left334, right334) => {
  let leftStack = of5(left334);
  let rightStack = of5(right334);
  while (isNonEmpty4(leftStack) && isNonEmpty4(rightStack)) {
    const [leftParallel, leftSequential] = pipe5(headNonEmpty5(leftStack), reduce44([empty64(), empty34()], ([parallel234, sequential234], cause) => {
      const [par, seq] = evaluateCause4(cause);
      return some34([pipe5(parallel234, union34(par)), pipe5(sequential234, appendAll5(seq))]);
    }));
    const [rightParallel, rightSequential] = pipe5(headNonEmpty5(rightStack), reduce44([empty64(), empty34()], ([parallel234, sequential234], cause) => {
      const [par, seq] = evaluateCause4(cause);
      return some34([pipe5(parallel234, union34(par)), pipe5(sequential234, appendAll5(seq))]);
    }));
    if (!equals5(leftParallel, rightParallel)) {
      return false;
    }
    leftStack = leftSequential;
    rightStack = rightSequential;
  }
  return true;
};
var flattenCause4 = (cause) => {
  return flattenCauseLoop4(of5(cause), empty34());
};
var flattenCauseLoop4 = (causes, flattened) => {
  while (1) {
    const [parallel234, sequential234] = pipe5(causes, reduce7([empty64(), empty34()], ([parallel322, sequential322], cause) => {
      const [par, seq] = evaluateCause4(cause);
      return [pipe5(parallel322, union34(par)), pipe5(sequential322, appendAll5(seq))];
    }));
    const updated = size34(parallel234) > 0 ? pipe5(flattened, prepend5(parallel234)) : flattened;
    if (isEmpty4(sequential234)) {
      return reverse24(updated);
    }
    causes = sequential234;
    flattened = updated;
  }
  throw new Error(getBugErrorMessage5("Cause.flattenCauseLoop"));
};
var evaluateCause4 = (self2) => {
  let cause = self2;
  const stack = [];
  let _parallel = empty64();
  let _sequential = empty34();
  while (cause !== void 0) {
    switch (cause._tag) {
      case OP_EMPTY4: {
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_FAIL4: {
        _parallel = add34(_parallel, make44(cause._tag, cause.error));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_DIE4: {
        _parallel = add34(_parallel, make44(cause._tag, cause.defect));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_INTERRUPT4: {
        _parallel = add34(_parallel, make44(cause._tag, cause.fiberId));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_SEQUENTIAL4: {
        switch (cause.left._tag) {
          case OP_EMPTY4: {
            cause = cause.right;
            break;
          }
          case OP_SEQUENTIAL4: {
            cause = sequential4(cause.left.left, sequential4(cause.left.right, cause.right));
            break;
          }
          case OP_PARALLEL4: {
            cause = parallel4(sequential4(cause.left.left, cause.right), sequential4(cause.left.right, cause.right));
            break;
          }
          default: {
            _sequential = prepend5(_sequential, cause.right);
            cause = cause.left;
            break;
          }
        }
        break;
      }
      case OP_PARALLEL4: {
        stack.push(cause.right);
        cause = cause.left;
        break;
      }
    }
  }
  throw new Error(getBugErrorMessage5("Cause.evaluateCauseLoop"));
};
var IsInterruptedOnlyCauseReducer4 = {
  emptyCase: constTrue5,
  failCase: constFalse5,
  dieCase: constFalse5,
  interruptCase: constTrue5,
  sequentialCase: (_322, left334, right334) => left334 && right334,
  parallelCase: (_322, left334, right334) => left334 && right334
};
var OP_SEQUENTIAL_CASE4 = "SequentialCase";
var OP_PARALLEL_CASE4 = "ParallelCase";
var reduce44 = /* @__PURE__ */ dual5(3, (self2, zero, pf) => {
  let accumulator = zero;
  let cause = self2;
  const causes = [];
  while (cause !== void 0) {
    const option = pf(accumulator, cause);
    accumulator = isSome24(option) ? option.value : accumulator;
    switch (cause._tag) {
      case OP_SEQUENTIAL4: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      case OP_PARALLEL4: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      default: {
        cause = void 0;
        break;
      }
    }
    if (cause === void 0 && causes.length > 0) {
      cause = causes.pop();
    }
  }
  return accumulator;
});
var reduceWithContext4 = /* @__PURE__ */ dual5(3, (self2, context, reducer) => {
  const input = [self2];
  const output = [];
  while (input.length > 0) {
    const cause = input.pop();
    switch (cause._tag) {
      case OP_EMPTY4: {
        output.push(right24(reducer.emptyCase(context)));
        break;
      }
      case OP_FAIL4: {
        output.push(right24(reducer.failCase(context, cause.error)));
        break;
      }
      case OP_DIE4: {
        output.push(right24(reducer.dieCase(context, cause.defect)));
        break;
      }
      case OP_INTERRUPT4: {
        output.push(right24(reducer.interruptCase(context, cause.fiberId)));
        break;
      }
      case OP_SEQUENTIAL4: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left24({
          _tag: OP_SEQUENTIAL_CASE4
        }));
        break;
      }
      case OP_PARALLEL4: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left24({
          _tag: OP_PARALLEL_CASE4
        }));
        break;
      }
    }
  }
  const accumulator = [];
  while (output.length > 0) {
    const either = output.pop();
    switch (either._tag) {
      case "Left": {
        switch (either.left._tag) {
          case OP_SEQUENTIAL_CASE4: {
            const left334 = accumulator.pop();
            const right334 = accumulator.pop();
            const value = reducer.sequentialCase(context, left334, right334);
            accumulator.push(value);
            break;
          }
          case OP_PARALLEL_CASE4: {
            const left334 = accumulator.pop();
            const right334 = accumulator.pop();
            const value = reducer.parallelCase(context, left334, right334);
            accumulator.push(value);
            break;
          }
        }
        break;
      }
      case "Right": {
        accumulator.push(either.right);
        break;
      }
    }
  }
  if (accumulator.length === 0) {
    throw new Error("BUG: Cause.reduceWithContext - please report an issue at https://github.com/Effect-TS/effect/issues");
  }
  return accumulator.pop();
});
var pretty4 = (cause) => {
  if (isInterruptedOnly4(cause)) {
    return "All fibers interrupted without errors.";
  }
  return prettyErrors4(cause).map((e322) => e322.stack).join("\n");
};
var PrettyError4 = class extends globalThis.Error {
  span = void 0;
  constructor(originalError) {
    const prevLimit = Error.stackTraceLimit;
    Error.stackTraceLimit = 0;
    super(prettyErrorMessage4(originalError));
    Error.stackTraceLimit = prevLimit;
    this.name = originalError instanceof Error ? originalError.name : "Error";
    if (typeof originalError === "object" && originalError !== null) {
      if (spanSymbol5 in originalError) {
        this.span = originalError[spanSymbol5];
      }
      Object.keys(originalError).forEach((key) => {
        if (!(key in this)) {
          this[key] = originalError[key];
        }
      });
    }
    this.stack = prettyErrorStack4(this.message, originalError instanceof Error && originalError.stack ? originalError.stack : "", this.span);
  }
  toJSON() {
    const out = {
      message: this.message,
      stack: this.stack
    };
    if (this.span) {
      out.span = this.span;
    }
    return out;
  }
};
var prettyErrorMessage4 = (u322) => {
  if (typeof u322 === "string") {
    return `Error: ${u322}`;
  }
  try {
    if (hasProperty5(u322, "toString") && isFunction34(u322["toString"]) && u322["toString"] !== Object.prototype.toString && u322["toString"] !== globalThis.Array.prototype.toString) {
      return u322["toString"]();
    }
  } catch {
  }
  return `Error: ${JSON.stringify(u322)}`;
};
var locationRegex4 = /\((.*)\)/;
var spanToTrace4 = /* @__PURE__ */ globalValue5("effect/Tracer/spanToTrace", () => /* @__PURE__ */ new WeakMap());
var prettyErrorStack4 = (message, stack, span222) => {
  const out = [message];
  const lines = stack.split("\n");
  for (let i322 = 1; i322 < lines.length; i322++) {
    if (lines[i322].includes("Generator.next")) {
      break;
    }
    if (lines[i322].includes("effect_internal_function")) {
      out.pop();
      break;
    }
    out.push(lines[i322].replace(/at .*effect_instruction_i.*\((.*)\)/, "at $1").replace(/EffectPrimitive\.\w+/, "<anonymous>"));
  }
  if (span222) {
    let current = span222;
    let i322 = 0;
    while (current && current._tag === "Span" && i322 < 10) {
      const stackFn = spanToTrace4.get(current);
      if (typeof stackFn === "function") {
        const stack2 = stackFn();
        const locationMatch = stack2.match(locationRegex4);
        const location = locationMatch ? locationMatch[1] : stack2.replace(/^at /, "");
        out.push(`    at ${current.name} (${location})`);
      } else {
        out.push(`    at ${current.name}`);
      }
      current = getOrUndefined5(current.parent);
      i322++;
    }
  }
  return out.join("\n");
};
var spanSymbol5 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var prettyErrors4 = (cause) => reduceWithContext4(cause, void 0, {
  emptyCase: () => [],
  dieCase: (_322, unknownError) => {
    return [new PrettyError4(unknownError)];
  },
  failCase: (_322, error) => {
    return [new PrettyError4(error)];
  },
  interruptCase: () => [],
  parallelCase: (_322, l322, r322) => [...l322, ...r322],
  sequentialCase: (_322, l322, r322) => [...l322, ...r322]
});
var SingleShotGen24 = class _SingleShotGen23 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  next(a322) {
    return this.called ? {
      value: a322,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  return(a322) {
    return {
      value: a322,
      done: true
    };
  }
  throw(e322) {
    throw e322;
  }
  [Symbol.iterator]() {
    return new _SingleShotGen23(this.self);
  }
};
var spanTag4 = /* @__PURE__ */ GenericTag4("effect/ParentSpan");
var EffectTypeId24 = /* @__PURE__ */ Symbol.for("effect/Effect");
var EffectPrimitive4 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId24] = effectVariance5;
  constructor(_op) {
    this._op = _op;
  }
  [symbol24](that) {
    return this === that;
  }
  [symbol7]() {
    return cached5(this, random5(this));
  }
  pipe() {
    return pipeArguments5(this, arguments);
  }
  toJSON() {
    return {
      _id: "Effect",
      _op: this._op,
      effect_instruction_i0: toJSON5(this.effect_instruction_i0),
      effect_instruction_i1: toJSON5(this.effect_instruction_i1),
      effect_instruction_i2: toJSON5(this.effect_instruction_i2)
    };
  }
  toString() {
    return format5(this.toJSON());
  }
  [NodeInspectSymbol5]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen24(new YieldWrap5(this));
  }
};
var EffectPrimitiveFailure4 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId24] = effectVariance5;
  constructor(_op) {
    this._op = _op;
    this._tag = _op;
  }
  [symbol24](that) {
    return exitIsExit4(that) && that._op === "Failure" && // @ts-expect-error
    equals5(this.effect_instruction_i0, that.effect_instruction_i0);
  }
  [symbol7]() {
    return pipe5(
      // @ts-expect-error
      string6(this._tag),
      // @ts-expect-error
      combine6(hash5(this.effect_instruction_i0)),
      cached5(this)
    );
  }
  get cause() {
    return this.effect_instruction_i0;
  }
  pipe() {
    return pipeArguments5(this, arguments);
  }
  toJSON() {
    return {
      _id: "Exit",
      _tag: this._op,
      cause: this.cause.toJSON()
    };
  }
  toString() {
    return format5(this.toJSON());
  }
  [NodeInspectSymbol5]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen24(new YieldWrap5(this));
  }
};
var isEffect4 = (u322) => hasProperty5(u322, EffectTypeId24);
var withFiberRuntime4 = (withRuntime) => {
  const effect = new EffectPrimitive4(OP_WITH_RUNTIME4);
  effect.effect_instruction_i0 = withRuntime;
  return effect;
};
var spanSymbol24 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var originalSymbol4 = /* @__PURE__ */ Symbol.for("effect/OriginalAnnotation");
var capture4 = (obj, span222) => {
  if (isSome24(span222)) {
    return new Proxy(obj, {
      has(target, p322) {
        return p322 === spanSymbol24 || p322 === originalSymbol4 || p322 in target;
      },
      get(target, p322) {
        if (p322 === spanSymbol24) {
          return span222.value;
        }
        if (p322 === originalSymbol4) {
          return obj;
        }
        return target[p322];
      }
    });
  }
  return obj;
};
var fail24 = (error) => isObject5(error) && !(spanSymbol24 in error) ? withFiberRuntime4((fiber) => failCause4(fail5(capture4(error, currentSpanFromFiber4(fiber))))) : failCause4(fail5(error));
var failCause4 = (cause) => {
  const effect = new EffectPrimitiveFailure4(OP_FAILURE4);
  effect.effect_instruction_i0 = cause;
  return effect;
};
var FiberRefSymbolKey4 = "effect/FiberRef";
var FiberRefTypeId4 = /* @__PURE__ */ Symbol.for(FiberRefSymbolKey4);
var fiberRefVariance4 = {
  /* c8 ignore next */
  _A: (_322) => _322
};
var fiberRefUnsafeMakeContext4 = (initial) => {
  const differ = environment4();
  return fiberRefUnsafeMakePatch4(initial, {
    differ,
    fork: differ.empty
  });
};
var fiberRefUnsafeMakePatch4 = (initial, options) => ({
  [FiberRefTypeId4]: fiberRefVariance4,
  initial,
  diff: (oldValue, newValue) => options.differ.diff(oldValue, newValue),
  combine: (first, second) => options.differ.combine(first, second),
  patch: (patch234) => (oldValue) => options.differ.patch(patch234, oldValue),
  fork: options.fork,
  join: options.join ?? ((_322, n322) => n322),
  pipe() {
    return pipeArguments5(this, arguments);
  }
});
var currentContext4 = /* @__PURE__ */ globalValue5(/* @__PURE__ */ Symbol.for("effect/FiberRef/currentContext"), () => fiberRefUnsafeMakeContext4(empty24()));
var YieldableError4 = /* @__PURE__ */ function() {
  class YieldableError234 extends globalThis.Error {
    commit() {
      return fail24(this);
    }
    toString() {
      return this.message ? `${this.name}: ${this.message}` : this.name;
    }
    toJSON() {
      return {
        ...this
      };
    }
    [NodeInspectSymbol5]() {
      const stack = this.stack;
      if (stack) {
        return `${this.toString()}
${stack.split("\n").slice(1).join("\n")}`;
      }
      return this.toString();
    }
  }
  Object.assign(YieldableError234.prototype, StructuralCommitPrototype3);
  return YieldableError234;
}();
var exitIsExit4 = (u322) => isEffect4(u322) && "_tag" in u322 && (u322._tag === "Success" || u322._tag === "Failure");
var currentSpanFromFiber4 = (fiber) => {
  const span222 = fiber.getFiberRef(currentContext4).unsafeMap.get(spanTag4.key);
  return span222 !== void 0 && span222._tag === "Span" ? some34(span222) : none24();
};
var Data_exports3 = {};
__export23(Data_exports3, {
  Class: () => Class24,
  Error: () => Error24,
  Structural: () => Structural24,
  TaggedClass: () => TaggedClass4,
  TaggedError: () => TaggedError4,
  array: () => array24,
  case: () => _case4,
  struct: () => struct34,
  tagged: () => tagged4,
  taggedEnum: () => taggedEnum4,
  tuple: () => tuple24,
  unsafeArray: () => unsafeArray4,
  unsafeStruct: () => unsafeStruct4
});
var struct34 = struct24;
var unsafeStruct4 = (as2422) => Object.setPrototypeOf(as2422, StructuralPrototype3);
var tuple24 = (...as2422) => unsafeArray4(as2422);
var array24 = (as2422) => unsafeArray4(as2422.slice(0));
var unsafeArray4 = (as2422) => Object.setPrototypeOf(as2422, ArrayProto4);
var _case4 = () => (args) => args === void 0 ? Object.create(StructuralPrototype3) : struct34(args);
var tagged4 = (tag) => (args) => {
  const value = args === void 0 ? Object.create(StructuralPrototype3) : struct34(args);
  value._tag = tag;
  return value;
};
var Class24 = Structural5;
var TaggedClass4 = (tag) => {
  class Base extends Class24 {
    _tag = tag;
  }
  return Base;
};
var Structural24 = Structural5;
var taggedEnum4 = () => new Proxy({}, {
  get(_target, tag, _receiver) {
    if (tag === "$is") {
      return isTagged5;
    } else if (tag === "$match") {
      return taggedMatch4;
    }
    return tagged4(tag);
  }
});
function taggedMatch4() {
  if (arguments.length === 1) {
    const cases2 = arguments[0];
    return function(value2) {
      return cases2[value2._tag](value2);
    };
  }
  const value = arguments[0];
  const cases = arguments[1];
  return cases[value._tag](value);
}
var Error24 = /* @__PURE__ */ function() {
  return class Base extends YieldableError4 {
    constructor(args) {
      super();
      if (args) {
        Object.assign(this, args);
      }
    }
  };
}();
var TaggedError4 = (tag) => {
  class Base extends Error24 {
    _tag = tag;
  }
  Base.prototype.name = tag;
  return Base;
};
var traverseUp4 = Function_exports5.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType4.Program) return Option_exports5.none();
  return predicate(parent) ? Option_exports5.some(parent) : traverseUp4(parent, predicate);
});
var traverseUpGuard4 = Function_exports5.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType4.Program) return Option_exports5.none();
  return predicate(parent) ? Option_exports5.some(parent) : traverseUpGuard4(parent, predicate);
});
var ESLintCommunityESLintUtils4;
((ESLintCommunityESLintUtils234) => {
  ESLintCommunityESLintUtils234.getFunctionHeadLocation = getFunctionHeadLocation4;
  ESLintCommunityESLintUtils234.getFunctionNameWithKind = getFunctionNameWithKind4;
  ESLintCommunityESLintUtils234.getPropertyName = getPropertyName4;
  ESLintCommunityESLintUtils234.getStaticValue = getStaticValue5;
  ESLintCommunityESLintUtils234.getStringIfConstant = getStringIfConstant4;
  ESLintCommunityESLintUtils234.hasSideEffect = hasSideEffect4;
  ESLintCommunityESLintUtils234.isParenthesized = isParenthesized4;
})(ESLintCommunityESLintUtils4 || (ESLintCommunityESLintUtils4 = {}));
var Construction4 = Data_exports3.taggedEnum();
Construction4.None();
function getClassIdentifier2(node) {
  if (node.id) return Option_exports5.fromNullable(node.id);
  if (node.parent.type === NodeType4.VariableDeclarator && node.parent.id.type === NodeType4.Identifier) {
    return Option_exports5.fromNullable(node.parent.id);
  }
  return Option_exports5.none();
}
function getFunctionIdentifier2(node) {
  if (node.id) return Option_exports5.some(node.id);
  if (node.parent.type === NodeType4.VariableDeclarator && node.parent.init === node && node.parent.id.type === NodeType4.Identifier) {
    return Option_exports5.some(node.parent.id);
  }
  if (node.parent.type === NodeType4.AssignmentExpression && node.parent.right === node && node.parent.operator === "=" && node.parent.left.type === NodeType4.Identifier) {
    return Option_exports5.some(node.parent.left);
  }
  if (node.parent.type === NodeType4.Property && node.parent.value === node && !node.parent.computed && node.parent.key.type === NodeType4.Identifier) {
    return Option_exports5.some(node.parent.key);
  }
  if (isOneOf4([NodeType4.MethodDefinition, NodeType4.PropertyDefinition])(node.parent) && node.parent.value === node && node.parent.key.type === NodeType4.Identifier) {
    return Option_exports5.some(node.parent.key);
  }
  if (node.parent.type === NodeType4.AssignmentPattern && node.parent.right === node && node.parent.left.type === NodeType4.Identifier) {
    return Option_exports5.some(node.parent.left);
  }
  return Option_exports5.none();
}
var isFunctionOfObjectMethod2 = a({
  type: N.union([NodeType4.FunctionExpression, NodeType4.ArrowFunctionExpression]),
  parent: {
    type: NodeType4.Property,
    parent: {
      type: NodeType4.ObjectExpression
    }
  }
});
var isFunctionOfClassMethod2 = a({
  type: N.union([NodeType4.FunctionExpression, NodeType4.ArrowFunctionExpression]),
  parent: {
    type: NodeType4.MethodDefinition,
    parent: {
      type: NodeType4.ClassBody
    }
  }
});
var isFunctionOfClassProperty2 = a({
  type: N.union([NodeType4.FunctionExpression, NodeType4.ArrowFunctionExpression]),
  parent: {
    type: NodeType4.Property,
    parent: {
      type: NodeType4.ClassBody
    }
  }
});
var __defProp32 = Object.defineProperty;
var __export32 = (target, all622) => {
  for (var name22 in all622)
    __defProp32(target, name22, { get: all622[name22], enumerable: true });
};
var KEYS22 = {
  ArrayExpression: [
    "elements"
  ],
  ArrayPattern: [
    "elements"
  ],
  ArrowFunctionExpression: [
    "params",
    "body"
  ],
  AssignmentExpression: [
    "left",
    "right"
  ],
  AssignmentPattern: [
    "left",
    "right"
  ],
  AwaitExpression: [
    "argument"
  ],
  BinaryExpression: [
    "left",
    "right"
  ],
  BlockStatement: [
    "body"
  ],
  BreakStatement: [
    "label"
  ],
  CallExpression: [
    "callee",
    "arguments"
  ],
  CatchClause: [
    "param",
    "body"
  ],
  ChainExpression: [
    "expression"
  ],
  ClassBody: [
    "body"
  ],
  ClassDeclaration: [
    "id",
    "superClass",
    "body"
  ],
  ClassExpression: [
    "id",
    "superClass",
    "body"
  ],
  ConditionalExpression: [
    "test",
    "consequent",
    "alternate"
  ],
  ContinueStatement: [
    "label"
  ],
  DebuggerStatement: [],
  DoWhileStatement: [
    "body",
    "test"
  ],
  EmptyStatement: [],
  ExperimentalRestProperty: [
    "argument"
  ],
  ExperimentalSpreadProperty: [
    "argument"
  ],
  ExportAllDeclaration: [
    "exported",
    "source"
  ],
  ExportDefaultDeclaration: [
    "declaration"
  ],
  ExportNamedDeclaration: [
    "declaration",
    "specifiers",
    "source"
  ],
  ExportSpecifier: [
    "exported",
    "local"
  ],
  ExpressionStatement: [
    "expression"
  ],
  ForInStatement: [
    "left",
    "right",
    "body"
  ],
  ForOfStatement: [
    "left",
    "right",
    "body"
  ],
  ForStatement: [
    "init",
    "test",
    "update",
    "body"
  ],
  FunctionDeclaration: [
    "id",
    "params",
    "body"
  ],
  FunctionExpression: [
    "id",
    "params",
    "body"
  ],
  Identifier: [],
  IfStatement: [
    "test",
    "consequent",
    "alternate"
  ],
  ImportDeclaration: [
    "specifiers",
    "source"
  ],
  ImportDefaultSpecifier: [
    "local"
  ],
  ImportExpression: [
    "source"
  ],
  ImportNamespaceSpecifier: [
    "local"
  ],
  ImportSpecifier: [
    "imported",
    "local"
  ],
  JSXAttribute: [
    "name",
    "value"
  ],
  JSXClosingElement: [
    "name"
  ],
  JSXClosingFragment: [],
  JSXElement: [
    "openingElement",
    "children",
    "closingElement"
  ],
  JSXEmptyExpression: [],
  JSXExpressionContainer: [
    "expression"
  ],
  JSXFragment: [
    "openingFragment",
    "children",
    "closingFragment"
  ],
  JSXIdentifier: [],
  JSXMemberExpression: [
    "object",
    "property"
  ],
  JSXNamespacedName: [
    "namespace",
    "name"
  ],
  JSXOpeningElement: [
    "name",
    "attributes"
  ],
  JSXOpeningFragment: [],
  JSXSpreadAttribute: [
    "argument"
  ],
  JSXSpreadChild: [
    "expression"
  ],
  JSXText: [],
  LabeledStatement: [
    "label",
    "body"
  ],
  Literal: [],
  LogicalExpression: [
    "left",
    "right"
  ],
  MemberExpression: [
    "object",
    "property"
  ],
  MetaProperty: [
    "meta",
    "property"
  ],
  MethodDefinition: [
    "key",
    "value"
  ],
  NewExpression: [
    "callee",
    "arguments"
  ],
  ObjectExpression: [
    "properties"
  ],
  ObjectPattern: [
    "properties"
  ],
  PrivateIdentifier: [],
  Program: [
    "body"
  ],
  Property: [
    "key",
    "value"
  ],
  PropertyDefinition: [
    "key",
    "value"
  ],
  RestElement: [
    "argument"
  ],
  ReturnStatement: [
    "argument"
  ],
  SequenceExpression: [
    "expressions"
  ],
  SpreadElement: [
    "argument"
  ],
  StaticBlock: [
    "body"
  ],
  Super: [],
  SwitchCase: [
    "test",
    "consequent"
  ],
  SwitchStatement: [
    "discriminant",
    "cases"
  ],
  TaggedTemplateExpression: [
    "tag",
    "quasi"
  ],
  TemplateElement: [],
  TemplateLiteral: [
    "quasis",
    "expressions"
  ],
  ThisExpression: [],
  ThrowStatement: [
    "argument"
  ],
  TryStatement: [
    "block",
    "handler",
    "finalizer"
  ],
  UnaryExpression: [
    "argument"
  ],
  UpdateExpression: [
    "argument"
  ],
  VariableDeclaration: [
    "declarations"
  ],
  VariableDeclarator: [
    "id",
    "init"
  ],
  WhileStatement: [
    "test",
    "body"
  ],
  WithStatement: [
    "object",
    "body"
  ],
  YieldExpression: [
    "argument"
  ]
};
var NODE_TYPES22 = Object.keys(KEYS22);
for (const type of NODE_TYPES22) {
  Object.freeze(KEYS22[type]);
}
Object.freeze(KEYS22);
var visitor_keys_default22 = KEYS22;
var KEY_BLACKLIST22 = /* @__PURE__ */ new Set([
  "parent",
  "leadingComments",
  "trailingComments"
]);
function filterKey22(key) {
  return !KEY_BLACKLIST22.has(key) && key[0] !== "_";
}
function getKeys22(node) {
  return Object.keys(node).filter(filterKey22);
}
function getInnermostScope22(initialScope, node) {
  const location = node.range[0];
  let scope = initialScope;
  let found = false;
  do {
    found = false;
    for (const childScope of scope.childScopes) {
      const range222 = childScope.block.range;
      if (range222[0] <= location && location < range222[1]) {
        scope = childScope;
        found = true;
        break;
      }
    }
  } while (found);
  return scope;
}
function findVariable23(initialScope, nameOrNode) {
  let name22 = "";
  let scope = initialScope;
  if (typeof nameOrNode === "string") {
    name22 = nameOrNode;
  } else {
    name22 = nameOrNode.name;
    scope = getInnermostScope22(scope, nameOrNode);
  }
  while (scope != null) {
    const variable = scope.set.get(name22);
    if (variable != null) {
      return variable;
    }
    scope = scope.upper;
  }
  return null;
}
function negate022(token) {
  return !this(token);
}
function negate22(f2222) {
  return negate022.bind(f2222);
}
function isPunctuatorTokenWithValue22(token, value) {
  return token.type === "Punctuator" && token.value === value;
}
function isArrowToken22(token) {
  return isPunctuatorTokenWithValue22(token, "=>");
}
function isCommaToken22(token) {
  return isPunctuatorTokenWithValue22(token, ",");
}
function isSemicolonToken22(token) {
  return isPunctuatorTokenWithValue22(token, ";");
}
function isColonToken22(token) {
  return isPunctuatorTokenWithValue22(token, ":");
}
function isOpeningParenToken22(token) {
  return isPunctuatorTokenWithValue22(token, "(");
}
function isClosingParenToken22(token) {
  return isPunctuatorTokenWithValue22(token, ")");
}
function isOpeningBracketToken22(token) {
  return isPunctuatorTokenWithValue22(token, "[");
}
function isClosingBracketToken22(token) {
  return isPunctuatorTokenWithValue22(token, "]");
}
function isOpeningBraceToken22(token) {
  return isPunctuatorTokenWithValue22(token, "{");
}
function isClosingBraceToken22(token) {
  return isPunctuatorTokenWithValue22(token, "}");
}
function isCommentToken22(token) {
  return ["Block", "Line", "Shebang"].includes(token.type);
}
negate22(isArrowToken22);
negate22(isCommaToken22);
negate22(isSemicolonToken22);
negate22(isColonToken22);
negate22(isOpeningParenToken22);
negate22(isClosingParenToken22);
negate22(isOpeningBracketToken22);
negate22(isClosingBracketToken22);
negate22(isOpeningBraceToken22);
negate22(isClosingBraceToken22);
negate22(isCommentToken22);
function getOpeningParenOfParams22(node, sourceCode) {
  return node.id ? sourceCode.getTokenAfter(node.id, isOpeningParenToken22) : sourceCode.getFirstToken(node, isOpeningParenToken22);
}
function getFunctionHeadLocation22(node, sourceCode) {
  const parent = node.parent;
  let start = null;
  let end = null;
  if (node.type === "ArrowFunctionExpression") {
    const arrowToken = sourceCode.getTokenBefore(node.body, isArrowToken22);
    start = arrowToken.loc.start;
    end = arrowToken.loc.end;
  } else if (parent.type === "Property" || parent.type === "MethodDefinition" || parent.type === "PropertyDefinition") {
    start = parent.loc.start;
    end = getOpeningParenOfParams22(node, sourceCode).loc.start;
  } else {
    start = node.loc.start;
    end = getOpeningParenOfParams22(node, sourceCode).loc.start;
  }
  return {
    start: { ...start },
    end: { ...end }
  };
}
var globalObject22 = typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {};
var builtinNames22 = Object.freeze(
  /* @__PURE__ */ new Set([
    "Array",
    "ArrayBuffer",
    "BigInt",
    "BigInt64Array",
    "BigUint64Array",
    "Boolean",
    "DataView",
    "Date",
    "decodeURI",
    "decodeURIComponent",
    "encodeURI",
    "encodeURIComponent",
    "escape",
    "Float32Array",
    "Float64Array",
    "Function",
    "Infinity",
    "Int16Array",
    "Int32Array",
    "Int8Array",
    "isFinite",
    "isNaN",
    "isPrototypeOf",
    "JSON",
    "Map",
    "Math",
    "NaN",
    "Number",
    "Object",
    "parseFloat",
    "parseInt",
    "Promise",
    "Proxy",
    "Reflect",
    "RegExp",
    "Set",
    "String",
    "Symbol",
    "Uint16Array",
    "Uint32Array",
    "Uint8Array",
    "Uint8ClampedArray",
    "undefined",
    "unescape",
    "WeakMap",
    "WeakSet"
  ])
);
var callAllowed22 = new Set(
  [
    Array.isArray,
    Array.of,
    Array.prototype.at,
    Array.prototype.concat,
    Array.prototype.entries,
    Array.prototype.every,
    Array.prototype.filter,
    Array.prototype.find,
    Array.prototype.findIndex,
    Array.prototype.flat,
    Array.prototype.includes,
    Array.prototype.indexOf,
    Array.prototype.join,
    Array.prototype.keys,
    Array.prototype.lastIndexOf,
    Array.prototype.slice,
    Array.prototype.some,
    Array.prototype.toString,
    Array.prototype.values,
    typeof BigInt === "function" ? BigInt : void 0,
    Boolean,
    Date,
    Date.parse,
    decodeURI,
    decodeURIComponent,
    encodeURI,
    encodeURIComponent,
    escape,
    isFinite,
    isNaN,
    isPrototypeOf,
    Map,
    Map.prototype.entries,
    Map.prototype.get,
    Map.prototype.has,
    Map.prototype.keys,
    Map.prototype.values,
    ...Object.getOwnPropertyNames(Math).filter((k2222) => k2222 !== "random").map((k2222) => Math[k2222]).filter((f2222) => typeof f2222 === "function"),
    Number,
    Number.isFinite,
    Number.isNaN,
    Number.parseFloat,
    Number.parseInt,
    Number.prototype.toExponential,
    Number.prototype.toFixed,
    Number.prototype.toPrecision,
    Number.prototype.toString,
    Object,
    Object.entries,
    Object.is,
    Object.isExtensible,
    Object.isFrozen,
    Object.isSealed,
    Object.keys,
    Object.values,
    parseFloat,
    parseInt,
    RegExp,
    Set,
    Set.prototype.entries,
    Set.prototype.has,
    Set.prototype.keys,
    Set.prototype.values,
    String,
    String.fromCharCode,
    String.fromCodePoint,
    String.raw,
    String.prototype.at,
    String.prototype.charAt,
    String.prototype.charCodeAt,
    String.prototype.codePointAt,
    String.prototype.concat,
    String.prototype.endsWith,
    String.prototype.includes,
    String.prototype.indexOf,
    String.prototype.lastIndexOf,
    String.prototype.normalize,
    String.prototype.padEnd,
    String.prototype.padStart,
    String.prototype.slice,
    String.prototype.startsWith,
    String.prototype.substr,
    String.prototype.substring,
    String.prototype.toLowerCase,
    String.prototype.toString,
    String.prototype.toUpperCase,
    String.prototype.trim,
    String.prototype.trimEnd,
    String.prototype.trimLeft,
    String.prototype.trimRight,
    String.prototype.trimStart,
    Symbol.for,
    Symbol.keyFor,
    unescape
  ].filter((f2222) => typeof f2222 === "function")
);
var callPassThrough22 = /* @__PURE__ */ new Set([
  Object.freeze,
  Object.preventExtensions,
  Object.seal
]);
var getterAllowed22 = [
  [Map, /* @__PURE__ */ new Set(["size"])],
  [
    RegExp,
    /* @__PURE__ */ new Set([
      "dotAll",
      "flags",
      "global",
      "hasIndices",
      "ignoreCase",
      "multiline",
      "source",
      "sticky",
      "unicode"
    ])
  ],
  [Set, /* @__PURE__ */ new Set(["size"])]
];
function getPropertyDescriptor22(object222, name22) {
  let x2222 = object222;
  while ((typeof x2222 === "object" || typeof x2222 === "function") && x2222 !== null) {
    const d2222 = Object.getOwnPropertyDescriptor(x2222, name22);
    if (d2222) {
      return d2222;
    }
    x2222 = Object.getPrototypeOf(x2222);
  }
  return null;
}
function isGetter22(object222, name22) {
  const d2222 = getPropertyDescriptor22(object222, name22);
  return d2222 != null && d2222.get != null;
}
function getElementValues22(nodeList, initialScope) {
  const valueList = [];
  for (let i2222 = 0; i2222 < nodeList.length; ++i2222) {
    const elementNode = nodeList[i2222];
    if (elementNode == null) {
      valueList.length = i2222 + 1;
    } else if (elementNode.type === "SpreadElement") {
      const argument = getStaticValueR22(elementNode.argument, initialScope);
      if (argument == null) {
        return null;
      }
      valueList.push(...argument.value);
    } else {
      const element = getStaticValueR22(elementNode, initialScope);
      if (element == null) {
        return null;
      }
      valueList.push(element.value);
    }
  }
  return valueList;
}
function isEffectivelyConst22(variable) {
  const refs = variable.references;
  const inits = refs.filter((r2222) => r2222.init).length;
  const reads = refs.filter((r2222) => r2222.isReadOnly()).length;
  if (inits === 1 && reads + inits === refs.length) {
    return true;
  }
  return false;
}
var operations22 = Object.freeze({
  ArrayExpression(node, initialScope) {
    const elements = getElementValues22(node.elements, initialScope);
    return elements != null ? { value: elements } : null;
  },
  AssignmentExpression(node, initialScope) {
    if (node.operator === "=") {
      return getStaticValueR22(node.right, initialScope);
    }
    return null;
  },
  //eslint-disable-next-line complexity
  BinaryExpression(node, initialScope) {
    if (node.operator === "in" || node.operator === "instanceof") {
      return null;
    }
    const left522 = getStaticValueR22(node.left, initialScope);
    const right522 = getStaticValueR22(node.right, initialScope);
    if (left522 != null && right522 != null) {
      switch (node.operator) {
        case "==":
          return { value: left522.value == right522.value };
        case "!=":
          return { value: left522.value != right522.value };
        case "===":
          return { value: left522.value === right522.value };
        case "!==":
          return { value: left522.value !== right522.value };
        case "<":
          return { value: left522.value < right522.value };
        case "<=":
          return { value: left522.value <= right522.value };
        case ">":
          return { value: left522.value > right522.value };
        case ">=":
          return { value: left522.value >= right522.value };
        case "<<":
          return { value: left522.value << right522.value };
        case ">>":
          return { value: left522.value >> right522.value };
        case ">>>":
          return { value: left522.value >>> right522.value };
        case "+":
          return { value: left522.value + right522.value };
        case "-":
          return { value: left522.value - right522.value };
        case "*":
          return { value: left522.value * right522.value };
        case "/":
          return { value: left522.value / right522.value };
        case "%":
          return { value: left522.value % right522.value };
        case "**":
          return { value: left522.value ** right522.value };
        case "|":
          return { value: left522.value | right522.value };
        case "^":
          return { value: left522.value ^ right522.value };
        case "&":
          return { value: left522.value & right522.value };
      }
    }
    return null;
  },
  CallExpression(node, initialScope) {
    const calleeNode = node.callee;
    const args = getElementValues22(node.arguments, initialScope);
    if (args != null) {
      if (calleeNode.type === "MemberExpression") {
        if (calleeNode.property.type === "PrivateIdentifier") {
          return null;
        }
        const object222 = getStaticValueR22(calleeNode.object, initialScope);
        if (object222 != null) {
          if (object222.value == null && (object222.optional || node.optional)) {
            return { value: void 0, optional: true };
          }
          const property = getStaticPropertyNameValue22(
            calleeNode,
            initialScope
          );
          if (property != null) {
            const receiver = object222.value;
            const methodName = property.value;
            if (callAllowed22.has(receiver[methodName])) {
              return { value: receiver[methodName](...args) };
            }
            if (callPassThrough22.has(receiver[methodName])) {
              return { value: args[0] };
            }
          }
        }
      } else {
        const callee = getStaticValueR22(calleeNode, initialScope);
        if (callee != null) {
          if (callee.value == null && node.optional) {
            return { value: void 0, optional: true };
          }
          const func = callee.value;
          if (callAllowed22.has(func)) {
            return { value: func(...args) };
          }
          if (callPassThrough22.has(func)) {
            return { value: args[0] };
          }
        }
      }
    }
    return null;
  },
  ConditionalExpression(node, initialScope) {
    const test = getStaticValueR22(node.test, initialScope);
    if (test != null) {
      return test.value ? getStaticValueR22(node.consequent, initialScope) : getStaticValueR22(node.alternate, initialScope);
    }
    return null;
  },
  ExpressionStatement(node, initialScope) {
    return getStaticValueR22(node.expression, initialScope);
  },
  Identifier(node, initialScope) {
    if (initialScope != null) {
      const variable = findVariable23(initialScope, node);
      if (variable != null && variable.defs.length === 0 && builtinNames22.has(variable.name) && variable.name in globalObject22) {
        return { value: globalObject22[variable.name] };
      }
      if (variable != null && variable.defs.length === 1) {
        const def = variable.defs[0];
        if (def.parent && def.type === "Variable" && (def.parent.kind === "const" || isEffectivelyConst22(variable)) && // TODO(mysticatea): don't support destructuring here.
        def.node.id.type === "Identifier") {
          return getStaticValueR22(def.node.init, initialScope);
        }
      }
    }
    return null;
  },
  Literal(node) {
    if ((node.regex != null || node.bigint != null) && node.value == null) {
      return null;
    }
    return { value: node.value };
  },
  LogicalExpression(node, initialScope) {
    const left522 = getStaticValueR22(node.left, initialScope);
    if (left522 != null) {
      if (node.operator === "||" && Boolean(left522.value) === true || node.operator === "&&" && Boolean(left522.value) === false || node.operator === "??" && left522.value != null) {
        return left522;
      }
      const right522 = getStaticValueR22(node.right, initialScope);
      if (right522 != null) {
        return right522;
      }
    }
    return null;
  },
  MemberExpression(node, initialScope) {
    if (node.property.type === "PrivateIdentifier") {
      return null;
    }
    const object222 = getStaticValueR22(node.object, initialScope);
    if (object222 != null) {
      if (object222.value == null && (object222.optional || node.optional)) {
        return { value: void 0, optional: true };
      }
      const property = getStaticPropertyNameValue22(node, initialScope);
      if (property != null) {
        if (!isGetter22(object222.value, property.value)) {
          return { value: object222.value[property.value] };
        }
        for (const [classFn, allowed] of getterAllowed22) {
          if (object222.value instanceof classFn && allowed.has(property.value)) {
            return { value: object222.value[property.value] };
          }
        }
      }
    }
    return null;
  },
  ChainExpression(node, initialScope) {
    const expression = getStaticValueR22(node.expression, initialScope);
    if (expression != null) {
      return { value: expression.value };
    }
    return null;
  },
  NewExpression(node, initialScope) {
    const callee = getStaticValueR22(node.callee, initialScope);
    const args = getElementValues22(node.arguments, initialScope);
    if (callee != null && args != null) {
      const Func = callee.value;
      if (callAllowed22.has(Func)) {
        return { value: new Func(...args) };
      }
    }
    return null;
  },
  ObjectExpression(node, initialScope) {
    const object222 = {};
    for (const propertyNode of node.properties) {
      if (propertyNode.type === "Property") {
        if (propertyNode.kind !== "init") {
          return null;
        }
        const key = getStaticPropertyNameValue22(
          propertyNode,
          initialScope
        );
        const value = getStaticValueR22(propertyNode.value, initialScope);
        if (key == null || value == null) {
          return null;
        }
        object222[key.value] = value.value;
      } else if (propertyNode.type === "SpreadElement" || propertyNode.type === "ExperimentalSpreadProperty") {
        const argument = getStaticValueR22(
          propertyNode.argument,
          initialScope
        );
        if (argument == null) {
          return null;
        }
        Object.assign(object222, argument.value);
      } else {
        return null;
      }
    }
    return { value: object222 };
  },
  SequenceExpression(node, initialScope) {
    const last222 = node.expressions[node.expressions.length - 1];
    return getStaticValueR22(last222, initialScope);
  },
  TaggedTemplateExpression(node, initialScope) {
    const tag = getStaticValueR22(node.tag, initialScope);
    const expressions = getElementValues22(
      node.quasi.expressions,
      initialScope
    );
    if (tag != null && expressions != null) {
      const func = tag.value;
      const strings = node.quasi.quasis.map((q) => q.value.cooked);
      strings.raw = node.quasi.quasis.map((q) => q.value.raw);
      if (func === String.raw) {
        return { value: func(strings, ...expressions) };
      }
    }
    return null;
  },
  TemplateLiteral(node, initialScope) {
    const expressions = getElementValues22(node.expressions, initialScope);
    if (expressions != null) {
      let value = node.quasis[0].value.cooked;
      for (let i2222 = 0; i2222 < expressions.length; ++i2222) {
        value += expressions[i2222];
        value += node.quasis[i2222 + 1].value.cooked;
      }
      return { value };
    }
    return null;
  },
  UnaryExpression(node, initialScope) {
    if (node.operator === "delete") {
      return null;
    }
    if (node.operator === "void") {
      return { value: void 0 };
    }
    const arg = getStaticValueR22(node.argument, initialScope);
    if (arg != null) {
      switch (node.operator) {
        case "-":
          return { value: -arg.value };
        case "+":
          return { value: +arg.value };
        case "!":
          return { value: !arg.value };
        case "~":
          return { value: ~arg.value };
        case "typeof":
          return { value: typeof arg.value };
      }
    }
    return null;
  }
});
function getStaticValueR22(node, initialScope) {
  if (node != null && Object.hasOwnProperty.call(operations22, node.type)) {
    return operations22[node.type](node, initialScope);
  }
  return null;
}
function getStaticPropertyNameValue22(node, initialScope) {
  const nameNode = node.type === "Property" ? node.key : node.property;
  if (node.computed) {
    return getStaticValueR22(nameNode, initialScope);
  }
  if (nameNode.type === "Identifier") {
    return { value: nameNode.name };
  }
  if (nameNode.type === "Literal") {
    if (nameNode.bigint) {
      return { value: nameNode.bigint };
    }
    return { value: String(nameNode.value) };
  }
  return null;
}
function getStaticValue22(node, initialScope = null) {
  try {
    return getStaticValueR22(node, initialScope);
  } catch (_error) {
    return null;
  }
}
function getStringIfConstant22(node, initialScope = null) {
  if (node && node.type === "Literal" && node.value === null) {
    if (node.regex) {
      return `/${node.regex.pattern}/${node.regex.flags}`;
    }
    if (node.bigint) {
      return node.bigint;
    }
  }
  const evaluated = getStaticValue22(node, initialScope);
  return evaluated && String(evaluated.value);
}
function getPropertyName22(node, initialScope) {
  switch (node.type) {
    case "MemberExpression":
      if (node.computed) {
        return getStringIfConstant22(node.property, initialScope);
      }
      if (node.property.type === "PrivateIdentifier") {
        return null;
      }
      return node.property.name;
    case "Property":
    case "MethodDefinition":
    case "PropertyDefinition":
      if (node.computed) {
        return getStringIfConstant22(node.key, initialScope);
      }
      if (node.key.type === "Literal") {
        return String(node.key.value);
      }
      if (node.key.type === "PrivateIdentifier") {
        return null;
      }
      return node.key.name;
  }
  return null;
}
function getFunctionNameWithKind22(node, sourceCode) {
  const parent = node.parent;
  const tokens = [];
  const isObjectMethod = parent.type === "Property" && parent.value === node;
  const isClassMethod = parent.type === "MethodDefinition" && parent.value === node;
  const isClassFieldMethod = parent.type === "PropertyDefinition" && parent.value === node;
  if (isClassMethod || isClassFieldMethod) {
    if (parent.static) {
      tokens.push("static");
    }
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push("private");
    }
  }
  if (node.async) {
    tokens.push("async");
  }
  if (node.generator) {
    tokens.push("generator");
  }
  if (isObjectMethod || isClassMethod) {
    if (parent.kind === "constructor") {
      return "constructor";
    }
    if (parent.kind === "get") {
      tokens.push("getter");
    } else if (parent.kind === "set") {
      tokens.push("setter");
    } else {
      tokens.push("method");
    }
  } else if (isClassFieldMethod) {
    tokens.push("method");
  } else {
    if (node.type === "ArrowFunctionExpression") {
      tokens.push("arrow");
    }
    tokens.push("function");
  }
  if (isObjectMethod || isClassMethod || isClassFieldMethod) {
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push(`#${parent.key.name}`);
    } else {
      const name22 = getPropertyName22(parent);
      if (name22) {
        tokens.push(`'${name22}'`);
      } else if (sourceCode) {
        const keyText = sourceCode.getText(parent.key);
        if (!keyText.includes("\n")) {
          tokens.push(`[${keyText}]`);
        }
      }
    }
  } else if (node.id) {
    tokens.push(`'${node.id.name}'`);
  } else if (parent.type === "VariableDeclarator" && parent.id && parent.id.type === "Identifier") {
    tokens.push(`'${parent.id.name}'`);
  } else if ((parent.type === "AssignmentExpression" || parent.type === "AssignmentPattern") && parent.left && parent.left.type === "Identifier") {
    tokens.push(`'${parent.left.name}'`);
  } else if (parent.type === "ExportDefaultDeclaration" && parent.declaration === node) {
    tokens.push("'default'");
  }
  return tokens.join(" ");
}
var typeConversionBinaryOps22 = Object.freeze(
  /* @__PURE__ */ new Set([
    "==",
    "!=",
    "<",
    "<=",
    ">",
    ">=",
    "<<",
    ">>",
    ">>>",
    "+",
    "-",
    "*",
    "/",
    "%",
    "|",
    "^",
    "&",
    "in"
  ])
);
var typeConversionUnaryOps22 = Object.freeze(/* @__PURE__ */ new Set(["-", "+", "!", "~"]));
function isNode22(x2222) {
  return x2222 !== null && typeof x2222 === "object" && typeof x2222.type === "string";
}
var visitor22 = Object.freeze(
  Object.assign(/* @__PURE__ */ Object.create(null), {
    $visit(node, options, visitorKeys) {
      const { type } = node;
      if (typeof this[type] === "function") {
        return this[type](node, options, visitorKeys);
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    $visitChildren(node, options, visitorKeys) {
      const { type } = node;
      for (const key of visitorKeys[type] || getKeys22(node)) {
        const value = node[key];
        if (Array.isArray(value)) {
          for (const element of value) {
            if (isNode22(element) && this.$visit(element, options, visitorKeys)) {
              return true;
            }
          }
        } else if (isNode22(value) && this.$visit(value, options, visitorKeys)) {
          return true;
        }
      }
      return false;
    },
    ArrowFunctionExpression() {
      return false;
    },
    AssignmentExpression() {
      return true;
    },
    AwaitExpression() {
      return true;
    },
    BinaryExpression(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && typeConversionBinaryOps22.has(node.operator) && (node.left.type !== "Literal" || node.right.type !== "Literal")) {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    CallExpression() {
      return true;
    },
    FunctionExpression() {
      return false;
    },
    ImportExpression() {
      return true;
    },
    MemberExpression(node, options, visitorKeys) {
      if (options.considerGetters) {
        return true;
      }
      if (options.considerImplicitTypeConversion && node.computed && node.property.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    MethodDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    NewExpression() {
      return true;
    },
    Property(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    PropertyDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UnaryExpression(node, options, visitorKeys) {
      if (node.operator === "delete") {
        return true;
      }
      if (options.considerImplicitTypeConversion && typeConversionUnaryOps22.has(node.operator) && node.argument.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UpdateExpression() {
      return true;
    },
    YieldExpression() {
      return true;
    }
  })
);
function hasSideEffect22(node, sourceCode, { considerGetters = false, considerImplicitTypeConversion = false } = {}) {
  return visitor22.$visit(
    node,
    { considerGetters, considerImplicitTypeConversion },
    sourceCode.visitorKeys || visitor_keys_default22
  );
}
function getParentSyntaxParen22(node, sourceCode) {
  const parent = node.parent;
  switch (parent.type) {
    case "CallExpression":
    case "NewExpression":
      if (parent.arguments.length === 1 && parent.arguments[0] === node) {
        return sourceCode.getTokenAfter(
          parent.callee,
          isOpeningParenToken22
        );
      }
      return null;
    case "DoWhileStatement":
      if (parent.test === node) {
        return sourceCode.getTokenAfter(
          parent.body,
          isOpeningParenToken22
        );
      }
      return null;
    case "IfStatement":
    case "WhileStatement":
      if (parent.test === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "ImportExpression":
      if (parent.source === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "SwitchStatement":
      if (parent.discriminant === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "WithStatement":
      if (parent.object === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    default:
      return null;
  }
}
function isParenthesized22(timesOrNode, nodeOrSourceCode, optionalSourceCode) {
  let times, node, sourceCode, maybeLeftParen, maybeRightParen;
  if (typeof timesOrNode === "number") {
    times = timesOrNode | 0;
    node = nodeOrSourceCode;
    sourceCode = optionalSourceCode;
    if (!(times >= 1)) {
      throw new TypeError("'times' should be a positive integer.");
    }
  } else {
    times = 1;
    node = timesOrNode;
    sourceCode = nodeOrSourceCode;
  }
  if (node == null || // `Program` can't be parenthesized
  node.parent == null || // `CatchClause.param` can't be parenthesized, example `try {} catch (error) {}`
  node.parent.type === "CatchClause" && node.parent.param === node) {
    return false;
  }
  maybeLeftParen = maybeRightParen = node;
  do {
    maybeLeftParen = sourceCode.getTokenBefore(maybeLeftParen);
    maybeRightParen = sourceCode.getTokenAfter(maybeRightParen);
  } while (maybeLeftParen != null && maybeRightParen != null && isOpeningParenToken22(maybeLeftParen) && isClosingParenToken22(maybeRightParen) && // Avoid false positive such as `if (a) {}`
  maybeLeftParen !== getParentSyntaxParen22(node, sourceCode) && --times > 0);
  return times === 0;
}
Function.call.bind(Object.hasOwnProperty);
var __defProp223 = Object.defineProperty;
var __export223 = (target, all32222) => {
  for (var name22 in all32222)
    __defProp223(target, name22, { get: all32222[name22], enumerable: true });
};
var NodeType22 = types.AST_NODE_TYPES;
var is22 = utils.ASTUtils.isNodeOfType;
var isOneOf22 = utils.ASTUtils.isNodeOfTypes;
isOneOf22([
  NodeType22.ArrowFunctionExpression,
  NodeType22.FunctionDeclaration,
  NodeType22.FunctionExpression
]);
isOneOf22([
  NodeType22.ArrowFunctionExpression,
  NodeType22.FunctionDeclaration,
  NodeType22.FunctionExpression,
  NodeType22.TSCallSignatureDeclaration,
  NodeType22.TSConstructSignatureDeclaration,
  NodeType22.TSDeclareFunction,
  NodeType22.TSEmptyBodyFunctionExpression,
  NodeType22.TSFunctionType,
  NodeType22.TSMethodSignature
]);
isOneOf22([NodeType22.ClassDeclaration, NodeType22.ClassExpression]);
isOneOf22([
  NodeType22.DoWhileStatement,
  NodeType22.ForInStatement,
  NodeType22.ForOfStatement,
  NodeType22.ForStatement,
  NodeType22.WhileStatement
]);
isOneOf22([NodeType22.TSArrayType, NodeType22.TSTupleType]);
isOneOf22([
  NodeType22.PropertyDefinition,
  NodeType22.TSIndexSignature,
  NodeType22.TSParameterProperty,
  NodeType22.TSPropertySignature
]);
is22(NodeType22.JSXElement);
is22(NodeType22.JSXFragment);
isOneOf22([
  NodeType22.JSXAttribute,
  NodeType22.JSXSpreadChild,
  NodeType22.JSXClosingElement,
  NodeType22.JSXClosingFragment,
  NodeType22.JSXElement,
  NodeType22.JSXEmptyExpression,
  NodeType22.JSXExpressionContainer,
  NodeType22.JSXFragment,
  NodeType22.JSXIdentifier,
  NodeType22.JSXMemberExpression,
  NodeType22.JSXNamespacedName,
  NodeType22.JSXOpeningElement,
  NodeType22.JSXOpeningFragment,
  NodeType22.JSXSpreadAttribute,
  NodeType22.JSXSpreadChild,
  NodeType22.JSXText
]);
var isJSXTagNameExpression22 = isOneOf22([
  NodeType22.JSXIdentifier,
  NodeType22.JSXMemberExpression,
  NodeType22.JSXNamespacedName
]);
isOneOf22([
  NodeType22.ArrayPattern,
  NodeType22.AssignmentPattern,
  NodeType22.ObjectPattern,
  NodeType22.RestElement
]);
isOneOf22([
  NodeType22.TSInterfaceDeclaration,
  NodeType22.TSTypeAliasDeclaration
]);
isOneOf22([
  NodeType22.ArrayExpression,
  NodeType22.ArrayPattern,
  NodeType22.ArrowFunctionExpression,
  NodeType22.CallExpression,
  NodeType22.ClassExpression,
  NodeType22.FunctionExpression,
  NodeType22.Identifier,
  NodeType22.JSXElement,
  NodeType22.JSXFragment,
  NodeType22.Literal,
  NodeType22.TemplateLiteral,
  NodeType22.MemberExpression,
  NodeType22.MetaProperty,
  NodeType22.ObjectExpression,
  NodeType22.ObjectPattern,
  NodeType22.SequenceExpression,
  NodeType22.Super,
  NodeType22.TaggedTemplateExpression,
  NodeType22.ThisExpression
]);
isOneOf22([
  NodeType22.ArrayExpression,
  NodeType22.ArrayPattern,
  NodeType22.ArrowFunctionExpression,
  NodeType22.CallExpression,
  NodeType22.ClassExpression,
  NodeType22.FunctionExpression,
  NodeType22.Identifier,
  NodeType22.JSXElement,
  NodeType22.JSXFragment,
  NodeType22.Literal,
  NodeType22.TemplateLiteral,
  NodeType22.MemberExpression,
  NodeType22.MetaProperty,
  NodeType22.ObjectExpression,
  NodeType22.ObjectPattern,
  NodeType22.SequenceExpression,
  NodeType22.Super,
  NodeType22.TaggedTemplateExpression,
  NodeType22.ThisExpression,
  NodeType22.TSAsExpression,
  NodeType22.TSNonNullExpression,
  NodeType22.TSTypeAssertion
]);
var Function_exports23 = {};
__export223(Function_exports23, {
  SK: () => SK23,
  absurd: () => absurd23,
  apply: () => apply23,
  compose: () => compose32,
  constFalse: () => constFalse23,
  constNull: () => constNull23,
  constTrue: () => constTrue23,
  constUndefined: () => constUndefined23,
  constVoid: () => constVoid23,
  constant: () => constant23,
  dual: () => dual23,
  flip: () => flip23,
  flow: () => flow23,
  hole: () => hole23,
  identity: () => identity23,
  isFunction: () => isFunction223,
  pipe: () => pipe23,
  satisfies: () => satisfies23,
  tupled: () => tupled23,
  unsafeCoerce: () => unsafeCoerce23,
  untupled: () => untupled23
});
var isFunction223 = (input) => typeof input === "function";
var dual23 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a2222, b2222) {
        if (arguments.length >= 2) {
          return body(a2222, b2222);
        }
        return function(self2) {
          return body(self2, a2222);
        };
      };
    case 3:
      return function(a2222, b2222, c2222) {
        if (arguments.length >= 3) {
          return body(a2222, b2222, c2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222);
        };
      };
    case 4:
      return function(a2222, b2222, c2222, d2222) {
        if (arguments.length >= 4) {
          return body(a2222, b2222, c2222, d2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222);
        };
      };
    case 5:
      return function(a2222, b2222, c2222, d2222, e2222) {
        if (arguments.length >= 5) {
          return body(a2222, b2222, c2222, d2222, e2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222, d2222);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply23 = (a2222) => (self2) => self2(a2222);
var identity23 = (a2222) => a2222;
var satisfies23 = () => (b2222) => b2222;
var unsafeCoerce23 = identity23;
var constant23 = (value) => () => value;
var constTrue23 = /* @__PURE__ */ constant23(true);
var constFalse23 = /* @__PURE__ */ constant23(false);
var constNull23 = /* @__PURE__ */ constant23(null);
var constUndefined23 = /* @__PURE__ */ constant23(void 0);
var constVoid23 = constUndefined23;
var flip23 = (f2222) => (...b2222) => (...a2222) => f2222(...a2222)(...b2222);
var compose32 = /* @__PURE__ */ dual23(2, (ab, bc) => (a2222) => bc(ab(a2222)));
var absurd23 = (_2222) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled23 = (f2222) => (a2222) => f2222(...a2222);
var untupled23 = (f2222) => (...a2222) => f2222(a2222);
function pipe23(a2222, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a2222;
    case 2:
      return ab(a2222);
    case 3:
      return bc(ab(a2222));
    case 4:
      return cd(bc(ab(a2222)));
    case 5:
      return de(cd(bc(ab(a2222))));
    case 6:
      return ef(de(cd(bc(ab(a2222)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a2222))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a2222)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a2222))))))));
    default: {
      let ret = arguments[0];
      for (let i2222 = 1; i2222 < arguments.length; i2222++) {
        ret = arguments[i2222](ret);
      }
      return ret;
    }
  }
}
function flow23(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole23 = /* @__PURE__ */ unsafeCoerce23(absurd23);
var SK23 = (_2222, b2222) => b2222;
var make62 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_33 = (map622) => dual23(3, (self2, name22, f2222) => map622(self2, (a2222) => Object.assign({}, a2222, {
  [name22]: f2222(a2222)
})));
var bindTo33 = (map622) => dual23(2, (self2, name22) => map622(self2, (a2222) => ({
  [name22]: a2222
})));
var bind33 = (map622, flatMap4222) => dual23(3, (self2, name22, f2222) => flatMap4222(self2, (a2222) => map622(f2222(a2222), (b2222) => Object.assign({}, a2222, {
  [name22]: b2222
}))));
var moduleVersion23 = "3.2.8";
var getCurrentVersion23 = () => moduleVersion23;
var globalStoreId23 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion23()}`);
if (!(globalStoreId23 in globalThis)) {
  globalThis[globalStoreId23] = /* @__PURE__ */ new Map();
}
var globalStore23 = globalThis[globalStoreId23];
var globalValue23 = (id, compute) => {
  if (!globalStore23.has(id)) {
    globalStore23.set(id, compute());
  }
  return globalStore23.get(id);
};
var Predicate_exports23 = {};
__export223(Predicate_exports23, {
  all: () => all32,
  and: () => and22,
  compose: () => compose223,
  eqv: () => eqv22,
  every: () => every22,
  hasProperty: () => hasProperty23,
  implies: () => implies22,
  isBigInt: () => isBigInt22,
  isBoolean: () => isBoolean22,
  isDate: () => isDate22,
  isError: () => isError22,
  isFunction: () => isFunction322,
  isIterable: () => isIterable22,
  isMap: () => isMap22,
  isNever: () => isNever22,
  isNotNull: () => isNotNull22,
  isNotNullable: () => isNotNullable22,
  isNotUndefined: () => isNotUndefined22,
  isNull: () => isNull22,
  isNullable: () => isNullable23,
  isNumber: () => isNumber22,
  isObject: () => isObject23,
  isPromise: () => isPromise22,
  isPromiseLike: () => isPromiseLike22,
  isReadonlyRecord: () => isReadonlyRecord22,
  isRecord: () => isRecord22,
  isSet: () => isSet22,
  isString: () => isString22,
  isSymbol: () => isSymbol22,
  isTagged: () => isTagged22,
  isTruthy: () => isTruthy22,
  isUint8Array: () => isUint8Array22,
  isUndefined: () => isUndefined22,
  isUnknown: () => isUnknown22,
  mapInput: () => mapInput22,
  nand: () => nand22,
  nor: () => nor22,
  not: () => not22,
  or: () => or22,
  product: () => product32,
  productMany: () => productMany32,
  some: () => some42,
  struct: () => struct42,
  tuple: () => tuple32,
  xor: () => xor22
});
var mapInput22 = /* @__PURE__ */ dual23(2, (self2, f2222) => (b2222) => self2(f2222(b2222)));
var isTruthy22 = (input) => !!input;
var isSet22 = (input) => input instanceof Set;
var isMap22 = (input) => input instanceof Map;
var isString22 = (input) => typeof input === "string";
var isNumber22 = (input) => typeof input === "number";
var isBoolean22 = (input) => typeof input === "boolean";
var isBigInt22 = (input) => typeof input === "bigint";
var isSymbol22 = (input) => typeof input === "symbol";
var isFunction322 = isFunction223;
var isUndefined22 = (input) => input === void 0;
var isNotUndefined22 = (input) => input !== void 0;
var isNull22 = (input) => input === null;
var isNotNull22 = (input) => input !== null;
var isNever22 = (_2222) => false;
var isUnknown22 = (_2222) => true;
var isRecordOrArray23 = (input) => typeof input === "object" && input !== null;
var isObject23 = (input) => isRecordOrArray23(input) || isFunction322(input);
var hasProperty23 = /* @__PURE__ */ dual23(2, (self2, property) => isObject23(self2) && property in self2);
var isTagged22 = /* @__PURE__ */ dual23(2, (self2, tag) => hasProperty23(self2, "_tag") && self2["_tag"] === tag);
var isNullable23 = (input) => input === null || input === void 0;
var isNotNullable22 = (input) => input !== null && input !== void 0;
var isError22 = (input) => input instanceof Error;
var isUint8Array22 = (input) => input instanceof Uint8Array;
var isDate22 = (input) => input instanceof Date;
var isIterable22 = (input) => hasProperty23(input, Symbol.iterator);
var isRecord22 = (input) => isRecordOrArray23(input) && !Array.isArray(input);
var isReadonlyRecord22 = isRecord22;
var isPromise22 = (input) => hasProperty23(input, "then") && "catch" in input && isFunction322(input.then) && isFunction322(input.catch);
var isPromiseLike22 = (input) => hasProperty23(input, "then") && isFunction322(input.then);
var compose223 = /* @__PURE__ */ dual23(2, (ab, bc) => (a2222) => ab(a2222) && bc(a2222));
var product32 = (self2, that) => ([a2222, b2222]) => self2(a2222) && that(b2222);
var all32 = (collection) => {
  return (as2322) => {
    let collectionIndex = 0;
    for (const p2222 of collection) {
      if (collectionIndex >= as2322.length) {
        break;
      }
      if (p2222(as2322[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany32 = (self2, collection) => {
  const rest = all32(collection);
  return ([head222, ...tail222]) => self2(head222) === false ? false : rest(tail222);
};
var tuple32 = (...elements) => all32(elements);
var struct42 = (fields) => {
  const keys22222 = Object.keys(fields);
  return (a2222) => {
    for (const key of keys22222) {
      if (!fields[key](a2222[key])) {
        return false;
      }
    }
    return true;
  };
};
var not22 = (self2) => (a2222) => !self2(a2222);
var or22 = /* @__PURE__ */ dual23(2, (self2, that) => (a2222) => self2(a2222) || that(a2222));
var and22 = /* @__PURE__ */ dual23(2, (self2, that) => (a2222) => self2(a2222) && that(a2222));
var xor22 = /* @__PURE__ */ dual23(2, (self2, that) => (a2222) => self2(a2222) !== that(a2222));
var eqv22 = /* @__PURE__ */ dual23(2, (self2, that) => (a2222) => self2(a2222) === that(a2222));
var implies22 = /* @__PURE__ */ dual23(2, (self2, that) => (a2222) => self2(a2222) ? that(a2222) : true);
var nor22 = /* @__PURE__ */ dual23(2, (self2, that) => (a2222) => !(self2(a2222) || that(a2222)));
var nand22 = /* @__PURE__ */ dual23(2, (self2, that) => (a2222) => !(self2(a2222) && that(a2222)));
var every22 = (collection) => (a2222) => {
  for (const p2222 of collection) {
    if (!p2222(a2222)) {
      return false;
    }
  }
  return true;
};
var some42 = (collection) => (a2222) => {
  for (const p2222 of collection) {
    if (p2222(a2222)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage23 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId23 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind23 = (u2222) => isObject23(u2222) && GenKindTypeId23 in u2222;
var GenKindImpl23 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity23;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId23] = GenKindTypeId23;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen32(this);
  }
};
var SingleShotGen32 = class _SingleShotGen32 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a2222) {
    return this.called ? {
      value: a2222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a2222) {
    return {
      value: a2222,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e2222) {
    throw e2222;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen32(this.self);
  }
};
var adapter33 = () => function() {
  let x2222 = arguments[0];
  for (let i2222 = 1; i2222 < arguments.length; i2222++) {
    x2222 = arguments[i2222](x2222);
  }
  return new GenKindImpl23(x2222);
};
var defaultIncHi23 = 335903614;
var defaultIncLo23 = 4150755663;
var MUL_HI23 = 1481765933 >>> 0;
var MUL_LO23 = 1284865837 >>> 0;
var BIT_5323 = 9007199254740992;
var BIT_2723 = 134217728;
var PCGRandom23 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable23(seedLo) && isNullable23(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable23(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable23(incLo) && isNullable23(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo23;
      incHi = this._state ? this._state[2] : defaultIncHi23;
    } else if (isNullable23(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add6423(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max322) {
    if (!max322) {
      return this._next();
    }
    max322 = max322 >>> 0;
    if ((max322 & max322 - 1) === 0) {
      return this._next() & max322 - 1;
    }
    let num = 0;
    const skew = (-max322 >>> 0) % max322 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max322;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_2723 + lo) / BIT_5323;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul6423(this._state, oldHi, oldLo, MUL_HI23, MUL_LO23);
    add6423(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul6423(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add6423(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId23 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap23 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId23]() {
    return this.#value;
  }
};
function yieldWrapGet23(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId23 in self2) {
    return self2[YieldWrapTypeId23]();
  }
  throw new Error(getBugErrorMessage23("yieldWrapGet"));
}
var structuralRegionState23 = /* @__PURE__ */ globalValue23("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache23 = /* @__PURE__ */ globalValue23(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr23 = /* @__PURE__ */ globalValue23(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom23());
var symbol33 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash23 = (self2) => {
  if (structuralRegionState23.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number23(self2);
    case "bigint":
      return string23(self2.toString(10));
    case "boolean":
      return string23(String(self2));
    case "symbol":
      return string23(String(self2));
    case "string":
      return string23(self2);
    case "undefined":
      return string23("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string23("null");
      } else if (self2 instanceof Date) {
        return hash23(self2.toISOString());
      } else if (isHash23(self2)) {
        return self2[symbol33]();
      } else {
        return random23(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random23 = (self2) => {
  if (!randomHashCache23.has(self2)) {
    randomHashCache23.set(self2, number23(pcgr23.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache23.get(self2);
};
var combine32 = (b2222) => (self2) => self2 * 53 ^ b2222;
var optimize23 = (n2222) => n2222 & 3221225471 | n2222 >>> 1 & 1073741824;
var isHash23 = (u2222) => hasProperty23(u2222, symbol33);
var number23 = (n2222) => {
  if (n2222 !== n2222 || n2222 === Infinity) {
    return 0;
  }
  let h2222 = n2222 | 0;
  if (h2222 !== n2222) {
    h2222 ^= n2222 * 4294967295;
  }
  while (n2222 > 4294967295) {
    h2222 ^= n2222 /= 4294967295;
  }
  return optimize23(n2222);
};
var string23 = (str) => {
  let h2222 = 5381, i2222 = str.length;
  while (i2222) {
    h2222 = h2222 * 33 ^ str.charCodeAt(--i2222);
  }
  return optimize23(h2222);
};
var structureKeys23 = (o2222, keys22222) => {
  let h2222 = 12289;
  for (let i2222 = 0; i2222 < keys22222.length; i2222++) {
    h2222 ^= pipe23(string23(keys22222[i2222]), combine32(hash23(o2222[keys22222[i2222]])));
  }
  return optimize23(h2222);
};
var structure23 = (o2222) => structureKeys23(o2222, Object.keys(o2222));
var array32 = (arr) => {
  let h2222 = 6151;
  for (let i2222 = 0; i2222 < arr.length; i2222++) {
    h2222 = pipe23(h2222, combine32(hash23(arr[i2222])));
  }
  return optimize23(h2222);
};
var cached23 = function() {
  if (arguments.length === 1) {
    const self22 = arguments[0];
    return function(hash3222) {
      Object.defineProperty(self22, symbol33, {
        value() {
          return hash3222;
        },
        enumerable: false
      });
      return hash3222;
    };
  }
  const self2 = arguments[0];
  const hash2322 = arguments[1];
  Object.defineProperty(self2, symbol33, {
    value() {
      return hash2322;
    },
    enumerable: false
  });
  return hash2322;
};
var symbol223 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals23() {
  if (arguments.length === 1) {
    return (self2) => compareBoth23(self2, arguments[0]);
  }
  return compareBoth23(arguments[0], arguments[1]);
}
function compareBoth23(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual23(self2) && isEqual23(that)) {
        if (hash23(self2) === hash23(that) && self2[symbol223](that)) {
          return true;
        } else {
          return structuralRegionState23.enabled && structuralRegionState23.tester ? structuralRegionState23.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState23.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v2222, i2222) => compareBoth23(v2222, that[i2222]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth23(self2[key], that[key]))) {
              return structuralRegionState23.tester ? structuralRegionState23.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState23.tester ? structuralRegionState23.tester(self2, that) : false;
    }
  }
  return structuralRegionState23.enabled && structuralRegionState23.tester ? structuralRegionState23.tester(self2, that) : false;
}
var isEqual23 = (u2222) => hasProperty23(u2222, symbol223);
var equivalence23 = () => equals23;
var NodeInspectSymbol23 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON23 = (x2222) => {
  if (hasProperty23(x2222, "toJSON") && isFunction322(x2222["toJSON"]) && x2222["toJSON"].length === 0) {
    return x2222.toJSON();
  } else if (Array.isArray(x2222)) {
    return x2222.map(toJSON23);
  }
  return x2222;
};
var format23 = (x2222) => JSON.stringify(x2222, null, 2);
var pipeArguments23 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i2222 = 0, len = args.length; i2222 < len; i2222++) {
        ret = args[i2222](ret);
      }
      return ret;
    }
  }
};
var OP_COMMIT23 = "Commit";
var OP_FAILURE22 = "Failure";
var OP_WITH_RUNTIME22 = "WithRuntime";
var EffectTypeId32 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId23 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId23 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId23 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance23 = {
  /* c8 ignore next */
  _R: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _A: (_2222) => _2222,
  _V: /* @__PURE__ */ getCurrentVersion23()
};
var sinkVariance23 = {
  /* c8 ignore next */
  _A: (_2222) => _2222,
  /* c8 ignore next */
  _In: (_2222) => _2222,
  /* c8 ignore next */
  _L: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _R: (_2222) => _2222
};
var channelVariance23 = {
  /* c8 ignore next */
  _Env: (_2222) => _2222,
  /* c8 ignore next */
  _InErr: (_2222) => _2222,
  /* c8 ignore next */
  _InElem: (_2222) => _2222,
  /* c8 ignore next */
  _InDone: (_2222) => _2222,
  /* c8 ignore next */
  _OutErr: (_2222) => _2222,
  /* c8 ignore next */
  _OutElem: (_2222) => _2222,
  /* c8 ignore next */
  _OutDone: (_2222) => _2222
};
var EffectPrototype23 = {
  [EffectTypeId32]: effectVariance23,
  [StreamTypeId23]: effectVariance23,
  [SinkTypeId23]: sinkVariance23,
  [ChannelTypeId23]: channelVariance23,
  [symbol223](that) {
    return this === that;
  },
  [symbol33]() {
    return cached23(this, random23(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen32(new YieldWrap23(this));
  },
  pipe() {
    return pipeArguments23(this, arguments);
  }
};
var StructuralPrototype23 = {
  [symbol33]() {
    return cached23(this, structure23(this));
  },
  [symbol223](that) {
    const selfKeys = Object.keys(this);
    const thatKeys = Object.keys(that);
    if (selfKeys.length !== thatKeys.length) {
      return false;
    }
    for (const key of selfKeys) {
      if (!(key in that && equals23(this[key], that[key]))) {
        return false;
      }
    }
    return true;
  }
};
var CommitPrototype23 = {
  ...EffectPrototype23,
  _op: OP_COMMIT23
};
var StructuralCommitPrototype23 = {
  ...CommitPrototype23,
  ...StructuralPrototype23
};
var TypeId62 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto33 = {
  ...EffectPrototype23,
  [TypeId62]: {
    _A: (_2222) => _2222
  },
  [NodeInspectSymbol23]() {
    return this.toJSON();
  },
  toString() {
    return format23(this.toJSON());
  }
};
var SomeProto23 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto33), {
  _tag: "Some",
  _op: "Some",
  [symbol223](that) {
    return isOption33(that) && isSome33(that) && equals23(this.value, that.value);
  },
  [symbol33]() {
    return cached23(this, combine32(hash23(this._tag))(hash23(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON23(this.value)
    };
  }
});
var NoneHash23 = /* @__PURE__ */ hash23("None");
var NoneProto23 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto33), {
  _tag: "None",
  _op: "None",
  [symbol223](that) {
    return isOption33(that) && isNone33(that);
  },
  [symbol33]() {
    return NoneHash23;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption33 = (input) => hasProperty23(input, TypeId62);
var isNone33 = (fa) => fa._tag === "None";
var isSome33 = (fa) => fa._tag === "Some";
var none33 = /* @__PURE__ */ Object.create(NoneProto23);
var some223 = (value) => {
  const a2222 = Object.create(SomeProto23);
  a2222.value = value;
  return a2222;
};
var TypeId223 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto223 = {
  ...EffectPrototype23,
  [TypeId223]: {
    _R: (_2222) => _2222
  },
  [NodeInspectSymbol23]() {
    return this.toJSON();
  },
  toString() {
    return format23(this.toJSON());
  }
};
var RightProto23 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto223), {
  _tag: "Right",
  _op: "Right",
  [symbol223](that) {
    return isEither23(that) && isRight23(that) && equals23(this.right, that.right);
  },
  [symbol33]() {
    return combine32(hash23(this._tag))(hash23(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON23(this.right)
    };
  }
});
var LeftProto23 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto223), {
  _tag: "Left",
  _op: "Left",
  [symbol223](that) {
    return isEither23(that) && isLeft23(that) && equals23(this.left, that.left);
  },
  [symbol33]() {
    return combine32(hash23(this._tag))(hash23(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON23(this.left)
    };
  }
});
var isEither23 = (input) => hasProperty23(input, TypeId223);
var isLeft23 = (ma) => ma._tag === "Left";
var isRight23 = (ma) => ma._tag === "Right";
var left32 = (left32222) => {
  const a2222 = Object.create(LeftProto23);
  a2222.left = left32222;
  return a2222;
};
var right32 = (right32222) => {
  const a2222 = Object.create(RightProto23);
  a2222.right = right32222;
  return a2222;
};
var getLeft33 = (self2) => isRight23(self2) ? none33 : some223(self2.left);
var getRight33 = (self2) => isLeft23(self2) ? none33 : some223(self2.right);
var right223 = right32;
var left223 = left32;
var Option_exports23 = {};
__export223(Option_exports23, {
  Do: () => Do23,
  TypeId: () => TypeId323,
  all: () => all223,
  andThen: () => andThen23,
  ap: () => ap23,
  as: () => as23,
  asVoid: () => asVoid23,
  bind: () => bind223,
  bindTo: () => bindTo223,
  composeK: () => composeK23,
  contains: () => contains23,
  containsWith: () => containsWith23,
  exists: () => exists23,
  filter: () => filter23,
  filterMap: () => filterMap23,
  firstSomeOf: () => firstSomeOf23,
  flatMap: () => flatMap23,
  flatMapNullable: () => flatMapNullable23,
  flatten: () => flatten23,
  fromIterable: () => fromIterable32,
  fromNullable: () => fromNullable23,
  gen: () => gen23,
  getEquivalence: () => getEquivalence32,
  getLeft: () => getLeft223,
  getOrElse: () => getOrElse23,
  getOrNull: () => getOrNull23,
  getOrThrow: () => getOrThrow23,
  getOrThrowWith: () => getOrThrowWith23,
  getOrUndefined: () => getOrUndefined23,
  getOrder: () => getOrder23,
  getRight: () => getRight223,
  isNone: () => isNone223,
  isOption: () => isOption223,
  isSome: () => isSome223,
  let: () => let_223,
  lift2: () => lift223,
  liftNullable: () => liftNullable23,
  liftPredicate: () => liftPredicate23,
  liftThrowable: () => liftThrowable23,
  map: () => map23,
  match: () => match222,
  none: () => none223,
  orElse: () => orElse23,
  orElseEither: () => orElseEither23,
  orElseSome: () => orElseSome23,
  partitionMap: () => partitionMap23,
  product: () => product223,
  productMany: () => productMany223,
  reduceCompact: () => reduceCompact23,
  some: () => some323,
  tap: () => tap23,
  toArray: () => toArray23,
  toRefinement: () => toRefinement23,
  void: () => void_23,
  zipLeft: () => zipLeft23,
  zipRight: () => zipRight23,
  zipWith: () => zipWith23
});
var make223 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId323 = /* @__PURE__ */ Symbol.for("effect/Option");
var none223 = () => none33;
var some323 = some223;
var isOption223 = isOption33;
var isNone223 = isNone33;
var isSome223 = isSome33;
var match222 = /* @__PURE__ */ dual23(2, (self2, {
  onNone,
  onSome
}) => isNone223(self2) ? onNone() : onSome(self2.value));
var toRefinement23 = (f2222) => (a2222) => isSome223(f2222(a2222));
var fromIterable32 = (collection) => {
  for (const a2222 of collection) {
    return some323(a2222);
  }
  return none223();
};
var getRight223 = getRight33;
var getLeft223 = getLeft33;
var getOrElse23 = /* @__PURE__ */ dual23(2, (self2, onNone) => isNone223(self2) ? onNone() : self2.value);
var orElse23 = /* @__PURE__ */ dual23(2, (self2, that) => isNone223(self2) ? that() : self2);
var orElseSome23 = /* @__PURE__ */ dual23(2, (self2, onNone) => isNone223(self2) ? some323(onNone()) : self2);
var orElseEither23 = /* @__PURE__ */ dual23(2, (self2, that) => isNone223(self2) ? map23(that(), right32) : map23(self2, left32));
var firstSomeOf23 = (collection) => {
  let out = none223();
  for (out of collection) {
    if (isSome223(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable23 = (nullableValue) => nullableValue == null ? none223() : some323(nullableValue);
var liftNullable23 = (f2222) => (...a2222) => fromNullable23(f2222(...a2222));
var getOrNull23 = /* @__PURE__ */ getOrElse23(constNull23);
var getOrUndefined23 = /* @__PURE__ */ getOrElse23(constUndefined23);
var liftThrowable23 = (f2222) => (...a2222) => {
  try {
    return some323(f2222(...a2222));
  } catch (e2222) {
    return none223();
  }
};
var getOrThrowWith23 = /* @__PURE__ */ dual23(2, (self2, onNone) => {
  if (isSome223(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow23 = /* @__PURE__ */ getOrThrowWith23(() => new Error("getOrThrow called on a None"));
var map23 = /* @__PURE__ */ dual23(2, (self2, f2222) => isNone223(self2) ? none223() : some323(f2222(self2.value)));
var as23 = /* @__PURE__ */ dual23(2, (self2, b2222) => map23(self2, () => b2222));
var asVoid23 = /* @__PURE__ */ as23(void 0);
var void_23 = /* @__PURE__ */ some323(void 0);
var flatMap23 = /* @__PURE__ */ dual23(2, (self2, f2222) => isNone223(self2) ? none223() : f2222(self2.value));
var andThen23 = /* @__PURE__ */ dual23(2, (self2, f2222) => flatMap23(self2, (a2222) => {
  const b2222 = isFunction223(f2222) ? f2222(a2222) : f2222;
  return isOption223(b2222) ? b2222 : some323(b2222);
}));
var flatMapNullable23 = /* @__PURE__ */ dual23(2, (self2, f2222) => isNone223(self2) ? none223() : fromNullable23(f2222(self2.value)));
var flatten23 = /* @__PURE__ */ flatMap23(identity23);
var zipRight23 = /* @__PURE__ */ dual23(2, (self2, that) => flatMap23(self2, () => that));
var composeK23 = /* @__PURE__ */ dual23(2, (afb, bfc) => (a2222) => flatMap23(afb(a2222), bfc));
var zipLeft23 = /* @__PURE__ */ dual23(2, (self2, that) => tap23(self2, () => that));
var tap23 = /* @__PURE__ */ dual23(2, (self2, f2222) => flatMap23(self2, (a2222) => map23(f2222(a2222), () => a2222)));
var product223 = (self2, that) => isSome223(self2) && isSome223(that) ? some323([self2.value, that.value]) : none223();
var productMany223 = (self2, collection) => {
  if (isNone223(self2)) {
    return none223();
  }
  const out = [self2.value];
  for (const o2222 of collection) {
    if (isNone223(o2222)) {
      return none223();
    }
    out.push(o2222.value);
  }
  return some323(out);
};
var all223 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o2222 of input) {
      if (isNone223(o2222)) {
        return none223();
      }
      out2.push(o2222.value);
    }
    return some323(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o2222 = input[key];
    if (isNone223(o2222)) {
      return none223();
    }
    out[key] = o2222.value;
  }
  return some323(out);
};
var zipWith23 = /* @__PURE__ */ dual23(3, (self2, that, f2222) => map23(product223(self2, that), ([a2222, b2222]) => f2222(a2222, b2222)));
var ap23 = /* @__PURE__ */ dual23(2, (self2, that) => zipWith23(self2, that, (f2222, a2222) => f2222(a2222)));
var reduceCompact23 = /* @__PURE__ */ dual23(3, (self2, b2222, f2222) => {
  let out = b2222;
  for (const oa of self2) {
    if (isSome223(oa)) {
      out = f2222(out, oa.value);
    }
  }
  return out;
});
var toArray23 = (self2) => isNone223(self2) ? [] : [self2.value];
var partitionMap23 = /* @__PURE__ */ dual23(2, (self2, f2222) => {
  if (isNone223(self2)) {
    return [none223(), none223()];
  }
  const e2222 = f2222(self2.value);
  return isLeft23(e2222) ? [some323(e2222.left), none223()] : [none223(), some323(e2222.right)];
});
var filterMap23 = /* @__PURE__ */ dual23(2, (self2, f2222) => isNone223(self2) ? none223() : f2222(self2.value));
var filter23 = /* @__PURE__ */ dual23(2, (self2, predicate) => filterMap23(self2, (b2222) => predicate(b2222) ? some223(b2222) : none33));
var getEquivalence32 = (isEquivalent) => make62((x2222, y2222) => x2222 === y2222 || (isNone223(x2222) ? isNone223(y2222) : isNone223(y2222) ? false : isEquivalent(x2222.value, y2222.value)));
var getOrder23 = (O2222) => make223((self2, that) => isSome223(self2) ? isSome223(that) ? O2222(self2.value, that.value) : 1 : -1);
var lift223 = (f2222) => dual23(2, (self2, that) => zipWith23(self2, that, f2222));
var liftPredicate23 = (predicate) => (b2222) => predicate(b2222) ? some323(b2222) : none223();
var containsWith23 = (isEquivalent) => dual23(2, (self2, a2222) => isNone223(self2) ? false : isEquivalent(self2.value, a2222));
var _equivalence32 = /* @__PURE__ */ equivalence23();
var contains23 = /* @__PURE__ */ containsWith23(_equivalence32);
var exists23 = /* @__PURE__ */ dual23(2, (self2, refinement) => isNone223(self2) ? false : refinement(self2.value));
var bindTo223 = /* @__PURE__ */ bindTo33(map23);
var let_223 = /* @__PURE__ */ let_33(map23);
var bind223 = /* @__PURE__ */ bind33(map23, flatMap23);
var Do23 = /* @__PURE__ */ some323({});
var adapter223 = /* @__PURE__ */ adapter33();
var gen23 = (f2222) => {
  const iterator = f2222(adapter223);
  let state = iterator.next();
  if (state.done) {
    return some323(state.value);
  } else {
    let current = state.value;
    if (isGenKind23(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet23(current);
    }
    if (isNone223(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind23(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet23(current);
        }
        if (isNone223(current)) {
          return current;
        }
      }
    }
    return some323(state.value);
  }
};
var fromIterable223 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var reverse32 = (self2) => Array.from(self2).reverse();
var reduce32 = /* @__PURE__ */ dual23(3, (self2, b2222, f2222) => fromIterable223(self2).reduce((b22222, a2222, i2222) => f2222(b22222, a2222, i2222), b2222));
var TagTypeId22 = /* @__PURE__ */ Symbol.for("effect/Context/Tag");
var STMSymbolKey22 = "effect/STM";
var STMTypeId22 = /* @__PURE__ */ Symbol.for(STMSymbolKey22);
var TagProto22 = {
  ...EffectPrototype23,
  _tag: "Tag",
  _op: "Tag",
  [STMTypeId22]: effectVariance23,
  [TagTypeId22]: {
    _Service: (_2222) => _2222,
    _Identifier: (_2222) => _2222
  },
  toString() {
    return format23(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Tag",
      key: this.key,
      stack: this.stack
    };
  },
  [NodeInspectSymbol23]() {
    return this.toJSON();
  },
  of(self2) {
    return self2;
  },
  context(self2) {
    return make323(this, self2);
  }
};
var makeGenericTag22 = (key) => {
  const limit = Error.stackTraceLimit;
  Error.stackTraceLimit = 2;
  const creationError = new Error();
  Error.stackTraceLimit = limit;
  const tag = Object.create(TagProto22);
  Object.defineProperty(tag, "stack", {
    get() {
      return creationError.stack;
    }
  });
  tag.key = key;
  return tag;
};
var TypeId423 = /* @__PURE__ */ Symbol.for("effect/Context");
var ContextProto22 = {
  [TypeId423]: {
    _Services: (_2222) => _2222
  },
  [symbol223](that) {
    if (isContext22(that)) {
      if (this.unsafeMap.size === that.unsafeMap.size) {
        for (const k2222 of this.unsafeMap.keys()) {
          if (!that.unsafeMap.has(k2222) || !equals23(this.unsafeMap.get(k2222), that.unsafeMap.get(k2222))) {
            return false;
          }
        }
        return true;
      }
    }
    return false;
  },
  [symbol33]() {
    return cached23(this, number23(this.unsafeMap.size));
  },
  pipe() {
    return pipeArguments23(this, arguments);
  },
  toString() {
    return format23(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Context",
      services: Array.from(this.unsafeMap).map(toJSON23)
    };
  },
  [NodeInspectSymbol23]() {
    return this.toJSON();
  }
};
var makeContext22 = (unsafeMap) => {
  const context = Object.create(ContextProto22);
  context.unsafeMap = unsafeMap;
  return context;
};
var isContext22 = (u2222) => hasProperty23(u2222, TypeId423);
var _empty62 = /* @__PURE__ */ makeContext22(/* @__PURE__ */ new Map());
var empty82 = () => _empty62;
var make323 = (tag, service) => makeContext22(/* @__PURE__ */ new Map([[tag.key, service]]));
var GenericTag22 = makeGenericTag22;
var empty222 = empty82;
var TypeId523 = /* @__PURE__ */ Symbol.for("effect/Chunk");
function copy22(src, srcPos, dest, destPos, len) {
  for (let i2222 = srcPos; i2222 < Math.min(src.length, srcPos + len); i2222++) {
    dest[destPos + i2222 - srcPos] = src[i2222];
  }
  return dest;
}
var emptyArray22 = [];
var getEquivalence223 = (isEquivalent) => make62((self2, that) => self2.length === that.length && toReadonlyArray22(self2).every((value, i2222) => isEquivalent(value, unsafeGet222(that, i2222))));
var _equivalence223 = /* @__PURE__ */ getEquivalence223(equals23);
var ChunkProto22 = {
  [TypeId523]: {
    _A: (_2222) => _2222
  },
  toString() {
    return format23(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Chunk",
      values: toReadonlyArray22(this).map(toJSON23)
    };
  },
  [NodeInspectSymbol23]() {
    return this.toJSON();
  },
  [symbol223](that) {
    return isChunk22(that) && _equivalence223(this, that);
  },
  [symbol33]() {
    return cached23(this, array32(toReadonlyArray22(this)));
  },
  [Symbol.iterator]() {
    switch (this.backing._tag) {
      case "IArray": {
        return this.backing.array[Symbol.iterator]();
      }
      case "IEmpty": {
        return emptyArray22[Symbol.iterator]();
      }
      default: {
        return toReadonlyArray22(this)[Symbol.iterator]();
      }
    }
  },
  pipe() {
    return pipeArguments23(this, arguments);
  }
};
var makeChunk22 = (backing) => {
  const chunk = Object.create(ChunkProto22);
  chunk.backing = backing;
  switch (backing._tag) {
    case "IEmpty": {
      chunk.length = 0;
      chunk.depth = 0;
      chunk.left = chunk;
      chunk.right = chunk;
      break;
    }
    case "IConcat": {
      chunk.length = backing.left.length + backing.right.length;
      chunk.depth = 1 + Math.max(backing.left.depth, backing.right.depth);
      chunk.left = backing.left;
      chunk.right = backing.right;
      break;
    }
    case "IArray": {
      chunk.length = backing.array.length;
      chunk.depth = 0;
      chunk.left = _empty222;
      chunk.right = _empty222;
      break;
    }
    case "ISingleton": {
      chunk.length = 1;
      chunk.depth = 0;
      chunk.left = _empty222;
      chunk.right = _empty222;
      break;
    }
    case "ISlice": {
      chunk.length = backing.length;
      chunk.depth = backing.chunk.depth + 1;
      chunk.left = _empty222;
      chunk.right = _empty222;
      break;
    }
  }
  return chunk;
};
var isChunk22 = (u2222) => hasProperty23(u2222, TypeId523);
var _empty222 = /* @__PURE__ */ makeChunk22({
  _tag: "IEmpty"
});
var empty322 = () => _empty222;
var make423 = (...as2322) => as2322.length === 1 ? of22(as2322[0]) : unsafeFromNonEmptyArray22(as2322);
var of22 = (a2222) => makeChunk22({
  _tag: "ISingleton",
  a: a2222
});
var copyToArray22 = (self2, array32222, initial) => {
  switch (self2.backing._tag) {
    case "IArray": {
      copy22(self2.backing.array, 0, array32222, initial, self2.length);
      break;
    }
    case "IConcat": {
      copyToArray22(self2.left, array32222, initial);
      copyToArray22(self2.right, array32222, initial + self2.left.length);
      break;
    }
    case "ISingleton": {
      array32222[initial] = self2.backing.a;
      break;
    }
    case "ISlice": {
      let i2222 = 0;
      let j2222 = initial;
      while (i2222 < self2.length) {
        array32222[j2222] = unsafeGet222(self2, i2222);
        i2222 += 1;
        j2222 += 1;
      }
      break;
    }
  }
};
var toReadonlyArray22 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      return emptyArray22;
    }
    case "IArray": {
      return self2.backing.array;
    }
    default: {
      const arr = new Array(self2.length);
      copyToArray22(self2, arr, 0);
      self2.backing = {
        _tag: "IArray",
        array: arr
      };
      self2.left = _empty222;
      self2.right = _empty222;
      self2.depth = 0;
      return arr;
    }
  }
};
var reverse222 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty":
    case "ISingleton":
      return self2;
    case "IArray": {
      return makeChunk22({
        _tag: "IArray",
        array: reverse32(self2.backing.array)
      });
    }
    case "IConcat": {
      return makeChunk22({
        _tag: "IConcat",
        left: reverse222(self2.backing.right),
        right: reverse222(self2.backing.left)
      });
    }
    case "ISlice":
      return unsafeFromArray22(reverse32(toReadonlyArray22(self2)));
  }
};
var unsafeFromArray22 = (self2) => makeChunk22({
  _tag: "IArray",
  array: self2
});
var unsafeFromNonEmptyArray22 = (self2) => unsafeFromArray22(self2);
var unsafeGet222 = /* @__PURE__ */ dual23(2, (self2, index) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      throw new Error(`Index out of bounds`);
    }
    case "ISingleton": {
      if (index !== 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.a;
    }
    case "IArray": {
      if (index >= self2.length || index < 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.array[index];
    }
    case "IConcat": {
      return index < self2.left.length ? unsafeGet222(self2.left, index) : unsafeGet222(self2.right, index - self2.left.length);
    }
    case "ISlice": {
      return unsafeGet222(self2.backing.chunk, index + self2.backing.offset);
    }
  }
});
var prepend22 = /* @__PURE__ */ dual23(2, (self2, elem) => appendAll22(of22(elem), self2));
var drop22 = /* @__PURE__ */ dual23(2, (self2, n2222) => {
  if (n2222 <= 0) {
    return self2;
  } else if (n2222 >= self2.length) {
    return _empty222;
  } else {
    switch (self2.backing._tag) {
      case "ISlice": {
        return makeChunk22({
          _tag: "ISlice",
          chunk: self2.backing.chunk,
          offset: self2.backing.offset + n2222,
          length: self2.backing.length - n2222
        });
      }
      case "IConcat": {
        if (n2222 > self2.left.length) {
          return drop22(self2.right, n2222 - self2.left.length);
        }
        return makeChunk22({
          _tag: "IConcat",
          left: drop22(self2.left, n2222),
          right: self2.right
        });
      }
      default: {
        return makeChunk22({
          _tag: "ISlice",
          chunk: self2,
          offset: n2222,
          length: self2.length - n2222
        });
      }
    }
  }
});
var appendAll22 = /* @__PURE__ */ dual23(2, (self2, that) => {
  if (self2.backing._tag === "IEmpty") {
    return that;
  }
  if (that.backing._tag === "IEmpty") {
    return self2;
  }
  const diff22222 = that.depth - self2.depth;
  if (Math.abs(diff22222) <= 1) {
    return makeChunk22({
      _tag: "IConcat",
      left: self2,
      right: that
    });
  } else if (diff22222 < -1) {
    if (self2.left.depth >= self2.right.depth) {
      const nr = appendAll22(self2.right, that);
      return makeChunk22({
        _tag: "IConcat",
        left: self2.left,
        right: nr
      });
    } else {
      const nrr = appendAll22(self2.right.right, that);
      if (nrr.depth === self2.depth - 3) {
        const nr = makeChunk22({
          _tag: "IConcat",
          left: self2.right.left,
          right: nrr
        });
        return makeChunk22({
          _tag: "IConcat",
          left: self2.left,
          right: nr
        });
      } else {
        const nl = makeChunk22({
          _tag: "IConcat",
          left: self2.left,
          right: self2.right.left
        });
        return makeChunk22({
          _tag: "IConcat",
          left: nl,
          right: nrr
        });
      }
    }
  } else {
    if (that.right.depth >= that.left.depth) {
      const nl = appendAll22(self2, that.left);
      return makeChunk22({
        _tag: "IConcat",
        left: nl,
        right: that.right
      });
    } else {
      const nll = appendAll22(self2, that.left.left);
      if (nll.depth === that.depth - 3) {
        const nl = makeChunk22({
          _tag: "IConcat",
          left: nll,
          right: that.left.right
        });
        return makeChunk22({
          _tag: "IConcat",
          left: nl,
          right: that.right
        });
      } else {
        const nr = makeChunk22({
          _tag: "IConcat",
          left: that.left.right,
          right: that.right
        });
        return makeChunk22({
          _tag: "IConcat",
          left: nll,
          right: nr
        });
      }
    }
  }
});
var isEmpty22 = (self2) => self2.length === 0;
var isNonEmpty22 = (self2) => self2.length > 0;
var unsafeHead22 = (self2) => unsafeGet222(self2, 0);
var headNonEmpty22 = unsafeHead22;
var tailNonEmpty22 = (self2) => drop22(self2, 1);
var SIZE22 = 5;
var BUCKET_SIZE22 = /* @__PURE__ */ Math.pow(2, SIZE22);
var MASK22 = BUCKET_SIZE22 - 1;
var MAX_INDEX_NODE22 = BUCKET_SIZE22 / 2;
var MIN_ARRAY_NODE22 = BUCKET_SIZE22 / 4;
function popcount22(x2222) {
  x2222 -= x2222 >> 1 & 1431655765;
  x2222 = (x2222 & 858993459) + (x2222 >> 2 & 858993459);
  x2222 = x2222 + (x2222 >> 4) & 252645135;
  x2222 += x2222 >> 8;
  x2222 += x2222 >> 16;
  return x2222 & 127;
}
function hashFragment22(shift22, h2222) {
  return h2222 >>> shift22 & MASK22;
}
function toBitmap22(x2222) {
  return 1 << x2222;
}
function fromBitmap22(bitmap, bit) {
  return popcount22(bitmap & bit - 1);
}
var make522 = (value, previous) => ({
  value,
  previous
});
function arrayUpdate22(mutate22222, at, v2222, arr) {
  let out = arr;
  if (!mutate22222) {
    const len = arr.length;
    out = new Array(len);
    for (let i2222 = 0; i2222 < len; ++i2222) out[i2222] = arr[i2222];
  }
  out[at] = v2222;
  return out;
}
function arraySpliceOut22(mutate22222, at, arr) {
  const newLen = arr.length - 1;
  let i2222 = 0;
  let g2222 = 0;
  let out = arr;
  if (mutate22222) {
    i2222 = g2222 = at;
  } else {
    out = new Array(newLen);
    while (i2222 < at) out[g2222++] = arr[i2222++];
  }
  ++i2222;
  while (i2222 <= newLen) out[g2222++] = arr[i2222++];
  if (mutate22222) {
    out.length = newLen;
  }
  return out;
}
function arraySpliceIn22(mutate22222, at, v2222, arr) {
  const len = arr.length;
  if (mutate22222) {
    let i22222 = len;
    while (i22222 >= at) arr[i22222--] = arr[i22222];
    arr[at] = v2222;
    return arr;
  }
  let i2222 = 0, g2222 = 0;
  const out = new Array(len + 1);
  while (i2222 < at) out[g2222++] = arr[i2222++];
  out[at] = v2222;
  while (i2222 < len) out[++g2222] = arr[i2222++];
  return out;
}
var EmptyNode22 = class _EmptyNode22 {
  _tag = "EmptyNode";
  modify(edit, _shift, f2222, hash2322, key, size42222) {
    const v2222 = f2222(none223());
    if (isNone223(v2222)) return new _EmptyNode22();
    ++size42222.value;
    return new LeafNode22(edit, hash2322, key, v2222);
  }
};
function isEmptyNode22(a2222) {
  return isTagged22(a2222, "EmptyNode");
}
function isLeafNode22(node) {
  return isEmptyNode22(node) || node._tag === "LeafNode" || node._tag === "CollisionNode";
}
function canEditNode22(node, edit) {
  return isEmptyNode22(node) ? false : edit === node.edit;
}
var LeafNode22 = class _LeafNode22 {
  edit;
  hash;
  key;
  value;
  _tag = "LeafNode";
  constructor(edit, hash2322, key, value) {
    this.edit = edit;
    this.hash = hash2322;
    this.key = key;
    this.value = value;
  }
  modify(edit, shift22, f2222, hash2322, key, size42222) {
    if (equals23(key, this.key)) {
      const v22222 = f2222(this.value);
      if (v22222 === this.value) return this;
      else if (isNone223(v22222)) {
        --size42222.value;
        return new EmptyNode22();
      }
      if (canEditNode22(this, edit)) {
        this.value = v22222;
        return this;
      }
      return new _LeafNode22(edit, hash2322, key, v22222);
    }
    const v2222 = f2222(none223());
    if (isNone223(v2222)) return this;
    ++size42222.value;
    return mergeLeaves22(edit, shift22, this.hash, this, hash2322, new _LeafNode22(edit, hash2322, key, v2222));
  }
};
var CollisionNode22 = class _CollisionNode22 {
  edit;
  hash;
  children;
  _tag = "CollisionNode";
  constructor(edit, hash2322, children) {
    this.edit = edit;
    this.hash = hash2322;
    this.children = children;
  }
  modify(edit, shift22, f2222, hash2322, key, size42222) {
    if (hash2322 === this.hash) {
      const canEdit = canEditNode22(this, edit);
      const list = this.updateCollisionList(canEdit, edit, this.hash, this.children, f2222, key, size42222);
      if (list === this.children) return this;
      return list.length > 1 ? new _CollisionNode22(edit, this.hash, list) : list[0];
    }
    const v2222 = f2222(none223());
    if (isNone223(v2222)) return this;
    ++size42222.value;
    return mergeLeaves22(edit, shift22, this.hash, this, hash2322, new LeafNode22(edit, hash2322, key, v2222));
  }
  updateCollisionList(mutate22222, edit, hash2322, list, f2222, key, size42222) {
    const len = list.length;
    for (let i2222 = 0; i2222 < len; ++i2222) {
      const child = list[i2222];
      if ("key" in child && equals23(key, child.key)) {
        const value = child.value;
        const newValue2 = f2222(value);
        if (newValue2 === value) return list;
        if (isNone223(newValue2)) {
          --size42222.value;
          return arraySpliceOut22(mutate22222, i2222, list);
        }
        return arrayUpdate22(mutate22222, i2222, new LeafNode22(edit, hash2322, key, newValue2), list);
      }
    }
    const newValue = f2222(none223());
    if (isNone223(newValue)) return list;
    ++size42222.value;
    return arrayUpdate22(mutate22222, len, new LeafNode22(edit, hash2322, key, newValue), list);
  }
};
var IndexedNode22 = class _IndexedNode22 {
  edit;
  mask;
  children;
  _tag = "IndexedNode";
  constructor(edit, mask, children) {
    this.edit = edit;
    this.mask = mask;
    this.children = children;
  }
  modify(edit, shift22, f2222, hash2322, key, size42222) {
    const mask = this.mask;
    const children = this.children;
    const frag = hashFragment22(shift22, hash2322);
    const bit = toBitmap22(frag);
    const indx = fromBitmap22(mask, bit);
    const exists2322 = mask & bit;
    const canEdit = canEditNode22(this, edit);
    if (!exists2322) {
      const _newChild = new EmptyNode22().modify(edit, shift22 + SIZE22, f2222, hash2322, key, size42222);
      if (!_newChild) return this;
      return children.length >= MAX_INDEX_NODE22 ? expand22(edit, frag, _newChild, mask, children) : new _IndexedNode22(edit, mask | bit, arraySpliceIn22(canEdit, indx, _newChild, children));
    }
    const current = children[indx];
    const child = current.modify(edit, shift22 + SIZE22, f2222, hash2322, key, size42222);
    if (current === child) return this;
    let bitmap = mask;
    let newChildren;
    if (isEmptyNode22(child)) {
      bitmap &= ~bit;
      if (!bitmap) return new EmptyNode22();
      if (children.length <= 2 && isLeafNode22(children[indx ^ 1])) {
        return children[indx ^ 1];
      }
      newChildren = arraySpliceOut22(canEdit, indx, children);
    } else {
      newChildren = arrayUpdate22(canEdit, indx, child, children);
    }
    if (canEdit) {
      this.mask = bitmap;
      this.children = newChildren;
      return this;
    }
    return new _IndexedNode22(edit, bitmap, newChildren);
  }
};
var ArrayNode22 = class _ArrayNode22 {
  edit;
  size;
  children;
  _tag = "ArrayNode";
  constructor(edit, size42222, children) {
    this.edit = edit;
    this.size = size42222;
    this.children = children;
  }
  modify(edit, shift22, f2222, hash2322, key, size42222) {
    let count = this.size;
    const children = this.children;
    const frag = hashFragment22(shift22, hash2322);
    const child = children[frag];
    const newChild = (child || new EmptyNode22()).modify(edit, shift22 + SIZE22, f2222, hash2322, key, size42222);
    if (child === newChild) return this;
    const canEdit = canEditNode22(this, edit);
    let newChildren;
    if (isEmptyNode22(child) && !isEmptyNode22(newChild)) {
      ++count;
      newChildren = arrayUpdate22(canEdit, frag, newChild, children);
    } else if (!isEmptyNode22(child) && isEmptyNode22(newChild)) {
      --count;
      if (count <= MIN_ARRAY_NODE22) {
        return pack22(edit, count, frag, children);
      }
      newChildren = arrayUpdate22(canEdit, frag, new EmptyNode22(), children);
    } else {
      newChildren = arrayUpdate22(canEdit, frag, newChild, children);
    }
    if (canEdit) {
      this.size = count;
      this.children = newChildren;
      return this;
    }
    return new _ArrayNode22(edit, count, newChildren);
  }
};
function pack22(edit, count, removed, elements) {
  const children = new Array(count - 1);
  let g2222 = 0;
  let bitmap = 0;
  for (let i2222 = 0, len = elements.length; i2222 < len; ++i2222) {
    if (i2222 !== removed) {
      const elem = elements[i2222];
      if (elem && !isEmptyNode22(elem)) {
        children[g2222++] = elem;
        bitmap |= 1 << i2222;
      }
    }
  }
  return new IndexedNode22(edit, bitmap, children);
}
function expand22(edit, frag, child, bitmap, subNodes) {
  const arr = [];
  let bit = bitmap;
  let count = 0;
  for (let i2222 = 0; bit; ++i2222) {
    if (bit & 1) arr[i2222] = subNodes[count++];
    bit >>>= 1;
  }
  arr[frag] = child;
  return new ArrayNode22(edit, count + 1, arr);
}
function mergeLeavesInner22(edit, shift22, h1, n1, h2222, n2222) {
  if (h1 === h2222) return new CollisionNode22(edit, h1, [n2222, n1]);
  const subH1 = hashFragment22(shift22, h1);
  const subH2 = hashFragment22(shift22, h2222);
  if (subH1 === subH2) {
    return (child) => new IndexedNode22(edit, toBitmap22(subH1) | toBitmap22(subH2), [child]);
  } else {
    const children = subH1 < subH2 ? [n1, n2222] : [n2222, n1];
    return new IndexedNode22(edit, toBitmap22(subH1) | toBitmap22(subH2), children);
  }
}
function mergeLeaves22(edit, shift22, h1, n1, h2222, n2222) {
  let stack = void 0;
  let currentShift = shift22;
  while (true) {
    const res = mergeLeavesInner22(edit, currentShift, h1, n1, h2222, n2222);
    if (typeof res === "function") {
      stack = make522(res, stack);
      currentShift = currentShift + SIZE22;
    } else {
      let final = res;
      while (stack != null) {
        final = stack.value(final);
        stack = stack.previous;
      }
      return final;
    }
  }
}
var HashMapSymbolKey22 = "effect/HashMap";
var HashMapTypeId22 = /* @__PURE__ */ Symbol.for(HashMapSymbolKey22);
var HashMapProto22 = {
  [HashMapTypeId22]: HashMapTypeId22,
  [Symbol.iterator]() {
    return new HashMapIterator22(this, (k2222, v2222) => [k2222, v2222]);
  },
  [symbol33]() {
    let hash2322 = hash23(HashMapSymbolKey22);
    for (const item of this) {
      hash2322 ^= pipe23(hash23(item[0]), combine32(hash23(item[1])));
    }
    return cached23(this, hash2322);
  },
  [symbol223](that) {
    if (isHashMap22(that)) {
      if (that._size !== this._size) {
        return false;
      }
      for (const item of this) {
        const elem = pipe23(that, getHash22(item[0], hash23(item[0])));
        if (isNone223(elem)) {
          return false;
        } else {
          if (!equals23(item[1], elem.value)) {
            return false;
          }
        }
      }
      return true;
    }
    return false;
  },
  toString() {
    return format23(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashMap",
      values: Array.from(this).map(toJSON23)
    };
  },
  [NodeInspectSymbol23]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments23(this, arguments);
  }
};
var makeImpl32 = (editable, edit, root, size42222) => {
  const map622 = Object.create(HashMapProto22);
  map622._editable = editable;
  map622._edit = edit;
  map622._root = root;
  map622._size = size42222;
  return map622;
};
var HashMapIterator22 = class _HashMapIterator22 {
  map;
  f;
  v;
  constructor(map622, f2222) {
    this.map = map622;
    this.f = f2222;
    this.v = visitLazy22(this.map._root, this.f, void 0);
  }
  next() {
    if (isNone223(this.v)) {
      return {
        done: true,
        value: void 0
      };
    }
    const v0 = this.v.value;
    this.v = applyCont22(v0.cont);
    return {
      done: false,
      value: v0.value
    };
  }
  [Symbol.iterator]() {
    return new _HashMapIterator22(this.map, this.f);
  }
};
var applyCont22 = (cont) => cont ? visitLazyChildren22(cont[0], cont[1], cont[2], cont[3], cont[4]) : none223();
var visitLazy22 = (node, f2222, cont = void 0) => {
  switch (node._tag) {
    case "LeafNode": {
      if (isSome223(node.value)) {
        return some323({
          value: f2222(node.key, node.value.value),
          cont
        });
      }
      return applyCont22(cont);
    }
    case "CollisionNode":
    case "ArrayNode":
    case "IndexedNode": {
      const children = node.children;
      return visitLazyChildren22(children.length, children, 0, f2222, cont);
    }
    default: {
      return applyCont22(cont);
    }
  }
};
var visitLazyChildren22 = (len, children, i2222, f2222, cont) => {
  while (i2222 < len) {
    const child = children[i2222++];
    if (child && !isEmptyNode22(child)) {
      return visitLazy22(child, f2222, [len, children, i2222, f2222, cont]);
    }
  }
  return applyCont22(cont);
};
var _empty322 = /* @__PURE__ */ makeImpl32(false, 0, /* @__PURE__ */ new EmptyNode22(), 0);
var empty422 = () => _empty322;
var isHashMap22 = (u2222) => hasProperty23(u2222, HashMapTypeId22);
var getHash22 = /* @__PURE__ */ dual23(3, (self2, key, hash2322) => {
  let node = self2._root;
  let shift22 = 0;
  while (true) {
    switch (node._tag) {
      case "LeafNode": {
        return equals23(key, node.key) ? node.value : none223();
      }
      case "CollisionNode": {
        if (hash2322 === node.hash) {
          const children = node.children;
          for (let i2222 = 0, len = children.length; i2222 < len; ++i2222) {
            const child = children[i2222];
            if ("key" in child && equals23(key, child.key)) {
              return child.value;
            }
          }
        }
        return none223();
      }
      case "IndexedNode": {
        const frag = hashFragment22(shift22, hash2322);
        const bit = toBitmap22(frag);
        if (node.mask & bit) {
          node = node.children[fromBitmap22(node.mask, bit)];
          shift22 += SIZE22;
          break;
        }
        return none223();
      }
      case "ArrayNode": {
        node = node.children[hashFragment22(shift22, hash2322)];
        if (node) {
          shift22 += SIZE22;
          break;
        }
        return none223();
      }
      default:
        return none223();
    }
  }
});
var set23 = /* @__PURE__ */ dual23(3, (self2, key, value) => modifyAt22(self2, key, () => some323(value)));
var setTree22 = /* @__PURE__ */ dual23(3, (self2, newRoot, newSize) => {
  if (self2._editable) {
    self2._root = newRoot;
    self2._size = newSize;
    return self2;
  }
  return newRoot === self2._root ? self2 : makeImpl32(self2._editable, self2._edit, newRoot, newSize);
});
var keys22 = (self2) => new HashMapIterator22(self2, (key) => key);
var size42 = (self2) => self2._size;
var beginMutation32 = (self2) => makeImpl32(true, self2._edit + 1, self2._root, self2._size);
var modifyAt22 = /* @__PURE__ */ dual23(3, (self2, key, f2222) => modifyHash22(self2, key, hash23(key), f2222));
var modifyHash22 = /* @__PURE__ */ dual23(4, (self2, key, hash2322, f2222) => {
  const size42222 = {
    value: self2._size
  };
  const newRoot = self2._root.modify(self2._editable ? self2._edit : NaN, 0, f2222, hash2322, key, size42222);
  return pipe23(self2, setTree22(newRoot, size42222.value));
});
var forEach32 = /* @__PURE__ */ dual23(2, (self2, f2222) => reduce222(self2, void 0, (_2222, value, key) => f2222(value, key)));
var reduce222 = /* @__PURE__ */ dual23(3, (self2, zero, f2222) => {
  const root = self2._root;
  if (root._tag === "LeafNode") {
    return isSome223(root.value) ? f2222(zero, root.value.value, root.key) : zero;
  }
  if (root._tag === "EmptyNode") {
    return zero;
  }
  const toVisit = [root.children];
  let children;
  while (children = toVisit.pop()) {
    for (let i2222 = 0, len = children.length; i2222 < len; ) {
      const child = children[i2222++];
      if (child && !isEmptyNode22(child)) {
        if (child._tag === "LeafNode") {
          if (isSome223(child.value)) {
            zero = f2222(zero, child.value.value, child.key);
          }
        } else {
          toVisit.push(child.children);
        }
      }
    }
  }
  return zero;
});
var HashSetSymbolKey22 = "effect/HashSet";
var HashSetTypeId22 = /* @__PURE__ */ Symbol.for(HashSetSymbolKey22);
var HashSetProto22 = {
  [HashSetTypeId22]: HashSetTypeId22,
  [Symbol.iterator]() {
    return keys22(this._keyMap);
  },
  [symbol33]() {
    return cached23(this, combine32(hash23(this._keyMap))(hash23(HashSetSymbolKey22)));
  },
  [symbol223](that) {
    if (isHashSet22(that)) {
      return size42(this._keyMap) === size42(that._keyMap) && equals23(this._keyMap, that._keyMap);
    }
    return false;
  },
  toString() {
    return format23(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashSet",
      values: Array.from(this).map(toJSON23)
    };
  },
  [NodeInspectSymbol23]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments23(this, arguments);
  }
};
var makeImpl222 = (keyMap) => {
  const set2322 = Object.create(HashSetProto22);
  set2322._keyMap = keyMap;
  return set2322;
};
var isHashSet22 = (u2222) => hasProperty23(u2222, HashSetTypeId22);
var _empty422 = /* @__PURE__ */ makeImpl222(/* @__PURE__ */ empty422());
var empty522 = () => _empty422;
var size222 = (self2) => size42(self2._keyMap);
var beginMutation222 = (self2) => makeImpl222(beginMutation32(self2._keyMap));
var endMutation22 = (self2) => {
  self2._keyMap._editable = false;
  return self2;
};
var mutate22 = /* @__PURE__ */ dual23(2, (self2, f2222) => {
  const transient = beginMutation222(self2);
  f2222(transient);
  return endMutation22(transient);
});
var add222 = /* @__PURE__ */ dual23(2, (self2, value) => self2._keyMap._editable ? (set23(value, true)(self2._keyMap), self2) : makeImpl222(set23(value, true)(self2._keyMap)));
var union222 = /* @__PURE__ */ dual23(2, (self2, that) => mutate22(empty522(), (set2322) => {
  forEach222(self2, (value) => add222(set2322, value));
  for (const value of that) {
    add222(set2322, value);
  }
}));
var forEach222 = /* @__PURE__ */ dual23(2, (self2, f2222) => forEach32(self2._keyMap, (_2222, k2222) => f2222(k2222)));
var empty622 = empty522;
var size322 = size222;
var add322 = add222;
var union322 = union222;
var ArrayProto22 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(Array.prototype), {
  [symbol33]() {
    return cached23(this, array32(this));
  },
  [symbol223](that) {
    if (Array.isArray(that) && this.length === that.length) {
      return this.every((v2222, i2222) => equals23(v2222, that[i2222]));
    } else {
      return false;
    }
  }
});
var Structural32 = /* @__PURE__ */ function() {
  function Structural32222(args) {
    if (args) {
      Object.assign(this, args);
    }
  }
  Structural32222.prototype = StructuralPrototype23;
  return Structural32222;
}();
var struct222 = (as2322) => Object.assign(Object.create(StructuralPrototype23), as2322);
var ContextPatchTypeId22 = /* @__PURE__ */ Symbol.for("effect/DifferContextPatch");
function variance32(a2222) {
  return a2222;
}
var PatchProto22 = {
  ...Structural32.prototype,
  [ContextPatchTypeId22]: {
    _Value: variance32,
    _Patch: variance32
  }
};
var EmptyProto22 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto22), {
  _tag: "Empty"
});
var _empty522 = /* @__PURE__ */ Object.create(EmptyProto22);
var empty722 = () => _empty522;
var AndThenProto22 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto22), {
  _tag: "AndThen"
});
var makeAndThen22 = (first, second) => {
  const o2222 = Object.create(AndThenProto22);
  o2222.first = first;
  o2222.second = second;
  return o2222;
};
var AddServiceProto22 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto22), {
  _tag: "AddService"
});
var makeAddService22 = (key, service) => {
  const o2222 = Object.create(AddServiceProto22);
  o2222.key = key;
  o2222.service = service;
  return o2222;
};
var RemoveServiceProto22 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto22), {
  _tag: "RemoveService"
});
var makeRemoveService22 = (key) => {
  const o2222 = Object.create(RemoveServiceProto22);
  o2222.key = key;
  return o2222;
};
var UpdateServiceProto22 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto22), {
  _tag: "UpdateService"
});
var makeUpdateService22 = (key, update222) => {
  const o2222 = Object.create(UpdateServiceProto22);
  o2222.key = key;
  o2222.update = update222;
  return o2222;
};
var diff22 = (oldValue, newValue) => {
  const missingServices = new Map(oldValue.unsafeMap);
  let patch22222 = empty722();
  for (const [tag, newService] of newValue.unsafeMap.entries()) {
    if (missingServices.has(tag)) {
      const old = missingServices.get(tag);
      missingServices.delete(tag);
      if (!equals23(old, newService)) {
        patch22222 = combine223(makeUpdateService22(tag, () => newService))(patch22222);
      }
    } else {
      missingServices.delete(tag);
      patch22222 = combine223(makeAddService22(tag, newService))(patch22222);
    }
  }
  for (const [tag] of missingServices.entries()) {
    patch22222 = combine223(makeRemoveService22(tag))(patch22222);
  }
  return patch22222;
};
var combine223 = /* @__PURE__ */ dual23(2, (self2, that) => makeAndThen22(self2, that));
var patch22 = /* @__PURE__ */ dual23(2, (self2, context) => {
  if (self2._tag === "Empty") {
    return context;
  }
  let wasServiceUpdated = false;
  let patches = of22(self2);
  const updatedContext = new Map(context.unsafeMap);
  while (isNonEmpty22(patches)) {
    const head222 = headNonEmpty22(patches);
    const tail222 = tailNonEmpty22(patches);
    switch (head222._tag) {
      case "Empty": {
        patches = tail222;
        break;
      }
      case "AddService": {
        updatedContext.set(head222.key, head222.service);
        patches = tail222;
        break;
      }
      case "AndThen": {
        patches = prepend22(prepend22(tail222, head222.second), head222.first);
        break;
      }
      case "RemoveService": {
        updatedContext.delete(head222.key);
        patches = tail222;
        break;
      }
      case "UpdateService": {
        updatedContext.set(head222.key, head222.update(updatedContext.get(head222.key)));
        wasServiceUpdated = true;
        patches = tail222;
        break;
      }
    }
  }
  if (!wasServiceUpdated) {
    return makeContext22(updatedContext);
  }
  const map622 = /* @__PURE__ */ new Map();
  for (const [tag] of context.unsafeMap) {
    if (updatedContext.has(tag)) {
      map622.set(tag, updatedContext.get(tag));
      updatedContext.delete(tag);
    }
  }
  for (const [tag, s2222] of updatedContext) {
    map622.set(tag, s2222);
  }
  return makeContext22(map622);
});
var DifferTypeId22 = /* @__PURE__ */ Symbol.for("effect/Differ");
var DifferProto22 = {
  [DifferTypeId22]: {
    _P: identity23,
    _V: identity23
  }
};
var make722 = (params) => {
  const differ = Object.create(DifferProto22);
  differ.empty = params.empty;
  differ.diff = params.diff;
  differ.combine = params.combine;
  differ.patch = params.patch;
  return differ;
};
var environment22 = () => make722({
  empty: empty722(),
  combine: (first, second) => combine223(second)(first),
  diff: (oldValue, newValue) => diff22(oldValue, newValue),
  patch: (patch22222, oldValue) => patch22(oldValue)(patch22222)
});
var OP_DIE22 = "Die";
var OP_EMPTY22 = "Empty";
var OP_FAIL22 = "Fail";
var OP_INTERRUPT22 = "Interrupt";
var OP_PARALLEL22 = "Parallel";
var OP_SEQUENTIAL22 = "Sequential";
var CauseSymbolKey22 = "effect/Cause";
var CauseTypeId22 = /* @__PURE__ */ Symbol.for(CauseSymbolKey22);
var variance222 = {
  /* c8 ignore next */
  _E: (_2222) => _2222
};
var proto22 = {
  [CauseTypeId22]: variance222,
  [symbol33]() {
    return pipe23(hash23(CauseSymbolKey22), combine32(hash23(flattenCause22(this))), cached23(this));
  },
  [symbol223](that) {
    return isCause22(that) && causeEquals22(this, that);
  },
  pipe() {
    return pipeArguments23(this, arguments);
  },
  toJSON() {
    switch (this._tag) {
      case "Empty":
        return {
          _id: "Cause",
          _tag: this._tag
        };
      case "Die":
        return {
          _id: "Cause",
          _tag: this._tag,
          defect: toJSON23(this.defect)
        };
      case "Interrupt":
        return {
          _id: "Cause",
          _tag: this._tag,
          fiberId: this.fiberId.toJSON()
        };
      case "Fail":
        return {
          _id: "Cause",
          _tag: this._tag,
          failure: toJSON23(this.error)
        };
      case "Sequential":
      case "Parallel":
        return {
          _id: "Cause",
          _tag: this._tag,
          left: toJSON23(this.left),
          right: toJSON23(this.right)
        };
    }
  },
  toString() {
    return pretty22(this);
  },
  [NodeInspectSymbol23]() {
    return this.toJSON();
  }
};
var fail32 = (error) => {
  const o2222 = Object.create(proto22);
  o2222._tag = OP_FAIL22;
  o2222.error = error;
  return o2222;
};
var parallel22 = (left32222, right32222) => {
  const o2222 = Object.create(proto22);
  o2222._tag = OP_PARALLEL22;
  o2222.left = left32222;
  o2222.right = right32222;
  return o2222;
};
var sequential22 = (left32222, right32222) => {
  const o2222 = Object.create(proto22);
  o2222._tag = OP_SEQUENTIAL22;
  o2222.left = left32222;
  o2222.right = right32222;
  return o2222;
};
var isCause22 = (u2222) => hasProperty23(u2222, CauseTypeId22);
var isInterruptedOnly22 = (self2) => reduceWithContext22(void 0, IsInterruptedOnlyCauseReducer22)(self2);
var causeEquals22 = (left32222, right32222) => {
  let leftStack = of22(left32222);
  let rightStack = of22(right32222);
  while (isNonEmpty22(leftStack) && isNonEmpty22(rightStack)) {
    const [leftParallel, leftSequential] = pipe23(headNonEmpty22(leftStack), reduce422([empty622(), empty322()], ([parallel22222, sequential22222], cause) => {
      const [par, seq] = evaluateCause22(cause);
      return some323([pipe23(parallel22222, union322(par)), pipe23(sequential22222, appendAll22(seq))]);
    }));
    const [rightParallel, rightSequential] = pipe23(headNonEmpty22(rightStack), reduce422([empty622(), empty322()], ([parallel22222, sequential22222], cause) => {
      const [par, seq] = evaluateCause22(cause);
      return some323([pipe23(parallel22222, union322(par)), pipe23(sequential22222, appendAll22(seq))]);
    }));
    if (!equals23(leftParallel, rightParallel)) {
      return false;
    }
    leftStack = leftSequential;
    rightStack = rightSequential;
  }
  return true;
};
var flattenCause22 = (cause) => {
  return flattenCauseLoop22(of22(cause), empty322());
};
var flattenCauseLoop22 = (causes, flattened) => {
  while (1) {
    const [parallel22222, sequential22222] = pipe23(causes, reduce32([empty622(), empty322()], ([parallel322, sequential322], cause) => {
      const [par, seq] = evaluateCause22(cause);
      return [pipe23(parallel322, union322(par)), pipe23(sequential322, appendAll22(seq))];
    }));
    const updated = size322(parallel22222) > 0 ? pipe23(flattened, prepend22(parallel22222)) : flattened;
    if (isEmpty22(sequential22222)) {
      return reverse222(updated);
    }
    causes = sequential22222;
    flattened = updated;
  }
  throw new Error(getBugErrorMessage23("Cause.flattenCauseLoop"));
};
var evaluateCause22 = (self2) => {
  let cause = self2;
  const stack = [];
  let _parallel = empty622();
  let _sequential = empty322();
  while (cause !== void 0) {
    switch (cause._tag) {
      case OP_EMPTY22: {
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_FAIL22: {
        _parallel = add322(_parallel, make423(cause._tag, cause.error));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_DIE22: {
        _parallel = add322(_parallel, make423(cause._tag, cause.defect));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_INTERRUPT22: {
        _parallel = add322(_parallel, make423(cause._tag, cause.fiberId));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_SEQUENTIAL22: {
        switch (cause.left._tag) {
          case OP_EMPTY22: {
            cause = cause.right;
            break;
          }
          case OP_SEQUENTIAL22: {
            cause = sequential22(cause.left.left, sequential22(cause.left.right, cause.right));
            break;
          }
          case OP_PARALLEL22: {
            cause = parallel22(sequential22(cause.left.left, cause.right), sequential22(cause.left.right, cause.right));
            break;
          }
          default: {
            _sequential = prepend22(_sequential, cause.right);
            cause = cause.left;
            break;
          }
        }
        break;
      }
      case OP_PARALLEL22: {
        stack.push(cause.right);
        cause = cause.left;
        break;
      }
    }
  }
  throw new Error(getBugErrorMessage23("Cause.evaluateCauseLoop"));
};
var IsInterruptedOnlyCauseReducer22 = {
  emptyCase: constTrue23,
  failCase: constFalse23,
  dieCase: constFalse23,
  interruptCase: constTrue23,
  sequentialCase: (_2222, left32222, right32222) => left32222 && right32222,
  parallelCase: (_2222, left32222, right32222) => left32222 && right32222
};
var OP_SEQUENTIAL_CASE22 = "SequentialCase";
var OP_PARALLEL_CASE22 = "ParallelCase";
var reduce422 = /* @__PURE__ */ dual23(3, (self2, zero, pf) => {
  let accumulator = zero;
  let cause = self2;
  const causes = [];
  while (cause !== void 0) {
    const option = pf(accumulator, cause);
    accumulator = isSome223(option) ? option.value : accumulator;
    switch (cause._tag) {
      case OP_SEQUENTIAL22: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      case OP_PARALLEL22: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      default: {
        cause = void 0;
        break;
      }
    }
    if (cause === void 0 && causes.length > 0) {
      cause = causes.pop();
    }
  }
  return accumulator;
});
var reduceWithContext22 = /* @__PURE__ */ dual23(3, (self2, context, reducer) => {
  const input = [self2];
  const output = [];
  while (input.length > 0) {
    const cause = input.pop();
    switch (cause._tag) {
      case OP_EMPTY22: {
        output.push(right223(reducer.emptyCase(context)));
        break;
      }
      case OP_FAIL22: {
        output.push(right223(reducer.failCase(context, cause.error)));
        break;
      }
      case OP_DIE22: {
        output.push(right223(reducer.dieCase(context, cause.defect)));
        break;
      }
      case OP_INTERRUPT22: {
        output.push(right223(reducer.interruptCase(context, cause.fiberId)));
        break;
      }
      case OP_SEQUENTIAL22: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left223({
          _tag: OP_SEQUENTIAL_CASE22
        }));
        break;
      }
      case OP_PARALLEL22: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left223({
          _tag: OP_PARALLEL_CASE22
        }));
        break;
      }
    }
  }
  const accumulator = [];
  while (output.length > 0) {
    const either = output.pop();
    switch (either._tag) {
      case "Left": {
        switch (either.left._tag) {
          case OP_SEQUENTIAL_CASE22: {
            const left32222 = accumulator.pop();
            const right32222 = accumulator.pop();
            const value = reducer.sequentialCase(context, left32222, right32222);
            accumulator.push(value);
            break;
          }
          case OP_PARALLEL_CASE22: {
            const left32222 = accumulator.pop();
            const right32222 = accumulator.pop();
            const value = reducer.parallelCase(context, left32222, right32222);
            accumulator.push(value);
            break;
          }
        }
        break;
      }
      case "Right": {
        accumulator.push(either.right);
        break;
      }
    }
  }
  if (accumulator.length === 0) {
    throw new Error("BUG: Cause.reduceWithContext - please report an issue at https://github.com/Effect-TS/effect/issues");
  }
  return accumulator.pop();
});
var pretty22 = (cause) => {
  if (isInterruptedOnly22(cause)) {
    return "All fibers interrupted without errors.";
  }
  return prettyErrors22(cause).map((e2222) => e2222.stack).join("\n");
};
var PrettyError22 = class extends globalThis.Error {
  span = void 0;
  constructor(originalError) {
    const prevLimit = Error.stackTraceLimit;
    Error.stackTraceLimit = 0;
    super(prettyErrorMessage22(originalError));
    Error.stackTraceLimit = prevLimit;
    this.name = originalError instanceof Error ? originalError.name : "Error";
    if (typeof originalError === "object" && originalError !== null) {
      if (spanSymbol32 in originalError) {
        this.span = originalError[spanSymbol32];
      }
      Object.keys(originalError).forEach((key) => {
        if (!(key in this)) {
          this[key] = originalError[key];
        }
      });
    }
    this.stack = prettyErrorStack22(this.message, originalError instanceof Error && originalError.stack ? originalError.stack : "", this.span);
  }
  toJSON() {
    const out = {
      message: this.message,
      stack: this.stack
    };
    if (this.span) {
      out.span = this.span;
    }
    return out;
  }
};
var prettyErrorMessage22 = (u2222) => {
  if (typeof u2222 === "string") {
    return `Error: ${u2222}`;
  }
  try {
    if (hasProperty23(u2222, "toString") && isFunction322(u2222["toString"]) && u2222["toString"] !== Object.prototype.toString && u2222["toString"] !== globalThis.Array.prototype.toString) {
      return u2222["toString"]();
    }
  } catch {
  }
  return `Error: ${JSON.stringify(u2222)}`;
};
var locationRegex22 = /\((.*)\)/;
var spanToTrace22 = /* @__PURE__ */ globalValue23("effect/Tracer/spanToTrace", () => /* @__PURE__ */ new WeakMap());
var prettyErrorStack22 = (message, stack, span222) => {
  const out = [message];
  const lines = stack.split("\n");
  for (let i2222 = 1; i2222 < lines.length; i2222++) {
    if (lines[i2222].includes("Generator.next")) {
      break;
    }
    if (lines[i2222].includes("effect_internal_function")) {
      out.pop();
      break;
    }
    out.push(lines[i2222].replace(/at .*effect_instruction_i.*\((.*)\)/, "at $1").replace(/EffectPrimitive\.\w+/, "<anonymous>"));
  }
  if (span222) {
    let current = span222;
    let i2222 = 0;
    while (current && current._tag === "Span" && i2222 < 10) {
      const stackFn = spanToTrace22.get(current);
      if (typeof stackFn === "function") {
        const stack2 = stackFn();
        const locationMatch = stack2.match(locationRegex22);
        const location = locationMatch ? locationMatch[1] : stack2.replace(/^at /, "");
        out.push(`    at ${current.name} (${location})`);
      } else {
        out.push(`    at ${current.name}`);
      }
      current = getOrUndefined23(current.parent);
      i2222++;
    }
  }
  return out.join("\n");
};
var spanSymbol32 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var prettyErrors22 = (cause) => reduceWithContext22(cause, void 0, {
  emptyCase: () => [],
  dieCase: (_2222, unknownError) => {
    return [new PrettyError22(unknownError)];
  },
  failCase: (_2222, error) => {
    return [new PrettyError22(error)];
  },
  interruptCase: () => [],
  parallelCase: (_2222, l2222, r2222) => [...l2222, ...r2222],
  sequentialCase: (_2222, l2222, r2222) => [...l2222, ...r2222]
});
var SingleShotGen223 = class _SingleShotGen222 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  next(a2222) {
    return this.called ? {
      value: a2222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  return(a2222) {
    return {
      value: a2222,
      done: true
    };
  }
  throw(e2222) {
    throw e2222;
  }
  [Symbol.iterator]() {
    return new _SingleShotGen222(this.self);
  }
};
var spanTag22 = /* @__PURE__ */ GenericTag22("effect/ParentSpan");
var EffectTypeId223 = /* @__PURE__ */ Symbol.for("effect/Effect");
var EffectPrimitive22 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId223] = effectVariance23;
  constructor(_op) {
    this._op = _op;
  }
  [symbol223](that) {
    return this === that;
  }
  [symbol33]() {
    return cached23(this, random23(this));
  }
  pipe() {
    return pipeArguments23(this, arguments);
  }
  toJSON() {
    return {
      _id: "Effect",
      _op: this._op,
      effect_instruction_i0: toJSON23(this.effect_instruction_i0),
      effect_instruction_i1: toJSON23(this.effect_instruction_i1),
      effect_instruction_i2: toJSON23(this.effect_instruction_i2)
    };
  }
  toString() {
    return format23(this.toJSON());
  }
  [NodeInspectSymbol23]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen223(new YieldWrap23(this));
  }
};
var EffectPrimitiveFailure22 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId223] = effectVariance23;
  constructor(_op) {
    this._op = _op;
    this._tag = _op;
  }
  [symbol223](that) {
    return exitIsExit22(that) && that._op === "Failure" && // @ts-expect-error
    equals23(this.effect_instruction_i0, that.effect_instruction_i0);
  }
  [symbol33]() {
    return pipe23(
      // @ts-expect-error
      string23(this._tag),
      // @ts-expect-error
      combine32(hash23(this.effect_instruction_i0)),
      cached23(this)
    );
  }
  get cause() {
    return this.effect_instruction_i0;
  }
  pipe() {
    return pipeArguments23(this, arguments);
  }
  toJSON() {
    return {
      _id: "Exit",
      _tag: this._op,
      cause: this.cause.toJSON()
    };
  }
  toString() {
    return format23(this.toJSON());
  }
  [NodeInspectSymbol23]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen223(new YieldWrap23(this));
  }
};
var isEffect22 = (u2222) => hasProperty23(u2222, EffectTypeId223);
var withFiberRuntime22 = (withRuntime) => {
  const effect = new EffectPrimitive22(OP_WITH_RUNTIME22);
  effect.effect_instruction_i0 = withRuntime;
  return effect;
};
var spanSymbol222 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var originalSymbol22 = /* @__PURE__ */ Symbol.for("effect/OriginalAnnotation");
var capture22 = (obj, span222) => {
  if (isSome223(span222)) {
    return new Proxy(obj, {
      has(target, p2222) {
        return p2222 === spanSymbol222 || p2222 === originalSymbol22 || p2222 in target;
      },
      get(target, p2222) {
        if (p2222 === spanSymbol222) {
          return span222.value;
        }
        if (p2222 === originalSymbol22) {
          return obj;
        }
        return target[p2222];
      }
    });
  }
  return obj;
};
var fail222 = (error) => isObject23(error) && !(spanSymbol222 in error) ? withFiberRuntime22((fiber) => failCause22(fail32(capture22(error, currentSpanFromFiber22(fiber))))) : failCause22(fail32(error));
var failCause22 = (cause) => {
  const effect = new EffectPrimitiveFailure22(OP_FAILURE22);
  effect.effect_instruction_i0 = cause;
  return effect;
};
var FiberRefSymbolKey22 = "effect/FiberRef";
var FiberRefTypeId22 = /* @__PURE__ */ Symbol.for(FiberRefSymbolKey22);
var fiberRefVariance22 = {
  /* c8 ignore next */
  _A: (_2222) => _2222
};
var fiberRefUnsafeMakeContext22 = (initial) => {
  const differ = environment22();
  return fiberRefUnsafeMakePatch22(initial, {
    differ,
    fork: differ.empty
  });
};
var fiberRefUnsafeMakePatch22 = (initial, options) => ({
  [FiberRefTypeId22]: fiberRefVariance22,
  initial,
  diff: (oldValue, newValue) => options.differ.diff(oldValue, newValue),
  combine: (first, second) => options.differ.combine(first, second),
  patch: (patch22222) => (oldValue) => options.differ.patch(patch22222, oldValue),
  fork: options.fork,
  join: options.join ?? ((_2222, n2222) => n2222),
  pipe() {
    return pipeArguments23(this, arguments);
  }
});
var currentContext22 = /* @__PURE__ */ globalValue23(/* @__PURE__ */ Symbol.for("effect/FiberRef/currentContext"), () => fiberRefUnsafeMakeContext22(empty222()));
var YieldableError22 = /* @__PURE__ */ function() {
  class YieldableError22222 extends globalThis.Error {
    commit() {
      return fail222(this);
    }
    toString() {
      return this.message ? `${this.name}: ${this.message}` : this.name;
    }
    toJSON() {
      return {
        ...this
      };
    }
    [NodeInspectSymbol23]() {
      const stack = this.stack;
      if (stack) {
        return `${this.toString()}
${stack.split("\n").slice(1).join("\n")}`;
      }
      return this.toString();
    }
  }
  Object.assign(YieldableError22222.prototype, StructuralCommitPrototype23);
  return YieldableError22222;
}();
var exitIsExit22 = (u2222) => isEffect22(u2222) && "_tag" in u2222 && (u2222._tag === "Success" || u2222._tag === "Failure");
var currentSpanFromFiber22 = (fiber) => {
  const span222 = fiber.getFiberRef(currentContext22).unsafeMap.get(spanTag22.key);
  return span222 !== void 0 && span222._tag === "Span" ? some323(span222) : none223();
};
var Data_exports23 = {};
__export223(Data_exports23, {
  Class: () => Class222,
  Error: () => Error222,
  Structural: () => Structural222,
  TaggedClass: () => TaggedClass22,
  TaggedError: () => TaggedError22,
  array: () => array222,
  case: () => _case22,
  struct: () => struct322,
  tagged: () => tagged22,
  taggedEnum: () => taggedEnum22,
  tuple: () => tuple222,
  unsafeArray: () => unsafeArray22,
  unsafeStruct: () => unsafeStruct22
});
var struct322 = struct222;
var unsafeStruct22 = (as2322) => Object.setPrototypeOf(as2322, StructuralPrototype23);
var tuple222 = (...as2322) => unsafeArray22(as2322);
var array222 = (as2322) => unsafeArray22(as2322.slice(0));
var unsafeArray22 = (as2322) => Object.setPrototypeOf(as2322, ArrayProto22);
var _case22 = () => (args) => args === void 0 ? Object.create(StructuralPrototype23) : struct322(args);
var tagged22 = (tag) => (args) => {
  const value = args === void 0 ? Object.create(StructuralPrototype23) : struct322(args);
  value._tag = tag;
  return value;
};
var Class222 = Structural32;
var TaggedClass22 = (tag) => {
  class Base extends Class222 {
    _tag = tag;
  }
  return Base;
};
var Structural222 = Structural32;
var taggedEnum22 = () => new Proxy({}, {
  get(_target, tag, _receiver) {
    if (tag === "$is") {
      return isTagged22;
    } else if (tag === "$match") {
      return taggedMatch22;
    }
    return tagged22(tag);
  }
});
function taggedMatch22() {
  if (arguments.length === 1) {
    const cases2 = arguments[0];
    return function(value2) {
      return cases2[value2._tag](value2);
    };
  }
  const value = arguments[0];
  const cases = arguments[1];
  return cases[value._tag](value);
}
var Error222 = /* @__PURE__ */ function() {
  return class Base extends YieldableError22 {
    constructor(args) {
      super();
      if (args) {
        Object.assign(this, args);
      }
    }
  };
}();
var TaggedError22 = (tag) => {
  class Base extends Error222 {
    _tag = tag;
  }
  Base.prototype.name = tag;
  return Base;
};
var traverseUp22 = Function_exports23.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType22.Program) return Option_exports23.none();
  return predicate(parent) ? Option_exports23.some(parent) : traverseUp22(parent, predicate);
});
var traverseUpGuard22 = Function_exports23.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType22.Program) return Option_exports23.none();
  return predicate(parent) ? Option_exports23.some(parent) : traverseUpGuard22(parent, predicate);
});
var ESLintCommunityESLintUtils22;
((ESLintCommunityESLintUtils22222) => {
  ESLintCommunityESLintUtils22222.getFunctionHeadLocation = getFunctionHeadLocation22;
  ESLintCommunityESLintUtils22222.getFunctionNameWithKind = getFunctionNameWithKind22;
  ESLintCommunityESLintUtils22222.getPropertyName = getPropertyName22;
  ESLintCommunityESLintUtils22222.getStaticValue = getStaticValue22;
  ESLintCommunityESLintUtils22222.getStringIfConstant = getStringIfConstant22;
  ESLintCommunityESLintUtils22222.hasSideEffect = hasSideEffect22;
  ESLintCommunityESLintUtils22222.isParenthesized = isParenthesized22;
})(ESLintCommunityESLintUtils22 || (ESLintCommunityESLintUtils22 = {}));
var Construction22 = Data_exports23.taggedEnum();
Construction22.None();
a({
  type: N.union([NodeType22.FunctionExpression, NodeType22.ArrowFunctionExpression]),
  parent: {
    type: NodeType22.Property,
    parent: {
      type: NodeType22.ObjectExpression
    }
  }
});
a({
  type: N.union([NodeType22.FunctionExpression, NodeType22.ArrowFunctionExpression]),
  parent: {
    type: NodeType22.MethodDefinition,
    parent: {
      type: NodeType22.ClassBody
    }
  }
});
a({
  type: N.union([NodeType22.FunctionExpression, NodeType22.ArrowFunctionExpression]),
  parent: {
    type: NodeType22.Property,
    parent: {
      type: NodeType22.ClassBody
    }
  }
});
var Function_exports222 = {};
__export32(Function_exports222, {
  SK: () => SK222,
  absurd: () => absurd222,
  apply: () => apply222,
  compose: () => compose322,
  constFalse: () => constFalse222,
  constNull: () => constNull222,
  constTrue: () => constTrue222,
  constUndefined: () => constUndefined222,
  constVoid: () => constVoid222,
  constant: () => constant222,
  dual: () => dual222,
  flip: () => flip222,
  flow: () => flow222,
  hole: () => hole222,
  identity: () => identity222,
  isFunction: () => isFunction42,
  pipe: () => pipe222,
  satisfies: () => satisfies222,
  tupled: () => tupled222,
  unsafeCoerce: () => unsafeCoerce222,
  untupled: () => untupled222
});
var isFunction42 = (input) => typeof input === "function";
var dual222 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a2222, b2222) {
        if (arguments.length >= 2) {
          return body(a2222, b2222);
        }
        return function(self2) {
          return body(self2, a2222);
        };
      };
    case 3:
      return function(a2222, b2222, c2222) {
        if (arguments.length >= 3) {
          return body(a2222, b2222, c2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222);
        };
      };
    case 4:
      return function(a2222, b2222, c2222, d2222) {
        if (arguments.length >= 4) {
          return body(a2222, b2222, c2222, d2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222);
        };
      };
    case 5:
      return function(a2222, b2222, c2222, d2222, e2222) {
        if (arguments.length >= 5) {
          return body(a2222, b2222, c2222, d2222, e2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222, d2222);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply222 = (a2222) => (self2) => self2(a2222);
var identity222 = (a2222) => a2222;
var satisfies222 = () => (b2222) => b2222;
var unsafeCoerce222 = identity222;
var constant222 = (value) => () => value;
var constTrue222 = /* @__PURE__ */ constant222(true);
var constFalse222 = /* @__PURE__ */ constant222(false);
var constNull222 = /* @__PURE__ */ constant222(null);
var constUndefined222 = /* @__PURE__ */ constant222(void 0);
var constVoid222 = constUndefined222;
var flip222 = (f2222) => (...b2222) => (...a2222) => f2222(...a2222)(...b2222);
var compose322 = /* @__PURE__ */ dual222(2, (ab, bc) => (a2222) => bc(ab(a2222)));
var absurd222 = (_2222) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled222 = (f2222) => (a2222) => f2222(...a2222);
var untupled222 = (f2222) => (...a2222) => f2222(a2222);
function pipe222(a2222, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a2222;
    case 2:
      return ab(a2222);
    case 3:
      return bc(ab(a2222));
    case 4:
      return cd(bc(ab(a2222)));
    case 5:
      return de(cd(bc(ab(a2222))));
    case 6:
      return ef(de(cd(bc(ab(a2222)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a2222))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a2222)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a2222))))))));
    default: {
      let ret = arguments[0];
      for (let i2222 = 1; i2222 < arguments.length; i2222++) {
        ret = arguments[i2222](ret);
      }
      return ret;
    }
  }
}
function flow222(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole222 = /* @__PURE__ */ unsafeCoerce222(absurd222);
var SK222 = (_2222, b2222) => b2222;
var Array_exports2 = {};
__export32(Array_exports2, {
  Do: () => Do32,
  allocate: () => allocate2,
  append: () => append2,
  appendAll: () => appendAll222,
  bind: () => bind52,
  bindTo: () => bindTo52,
  cartesian: () => cartesian2,
  cartesianWith: () => cartesianWith2,
  chop: () => chop2,
  chunksOf: () => chunksOf2,
  contains: () => contains32,
  containsWith: () => containsWith32,
  copy: () => copy222,
  dedupe: () => dedupe2,
  dedupeAdjacent: () => dedupeAdjacent2,
  dedupeAdjacentWith: () => dedupeAdjacentWith2,
  dedupeWith: () => dedupeWith2,
  difference: () => difference2,
  differenceWith: () => differenceWith2,
  drop: () => drop222,
  dropRight: () => dropRight2,
  dropWhile: () => dropWhile2,
  empty: () => empty92,
  every: () => every32,
  extend: () => extend2,
  filter: () => filter32,
  filterMap: () => filterMap32,
  filterMapWhile: () => filterMapWhile2,
  findFirst: () => findFirst22,
  findFirstIndex: () => findFirstIndex2,
  findLast: () => findLast2,
  findLastIndex: () => findLastIndex2,
  flatMap: () => flatMap32,
  flatMapNullable: () => flatMapNullable32,
  flatten: () => flatten32,
  forEach: () => forEach322,
  fromIterable: () => fromIterable42,
  fromNullable: () => fromNullable32,
  fromOption: () => fromOption22,
  fromRecord: () => fromRecord2,
  get: () => get3,
  getEquivalence: () => getEquivalence42,
  getLefts: () => getLefts2,
  getOrder: () => getOrder32,
  getRights: () => getRights2,
  getSomes: () => getSomes2,
  group: () => group2,
  groupBy: () => groupBy2,
  groupWith: () => groupWith2,
  head: () => head2,
  headNonEmpty: () => headNonEmpty222,
  init: () => init2,
  initNonEmpty: () => initNonEmpty2,
  insertAt: () => insertAt2,
  intersection: () => intersection2,
  intersectionWith: () => intersectionWith2,
  intersperse: () => intersperse2,
  isArray: () => isArray2,
  isEmptyArray: () => isEmptyArray2,
  isEmptyReadonlyArray: () => isEmptyReadonlyArray2,
  isNonEmptyArray: () => isNonEmptyArray22,
  isNonEmptyReadonlyArray: () => isNonEmptyReadonlyArray2,
  join: () => join22,
  last: () => last2,
  lastNonEmpty: () => lastNonEmpty2,
  length: () => length2,
  let: () => let_52,
  liftEither: () => liftEither2,
  liftNullable: () => liftNullable32,
  liftOption: () => liftOption2,
  liftPredicate: () => liftPredicate32,
  make: () => make102,
  makeBy: () => makeBy2,
  map: () => map32,
  mapAccum: () => mapAccum2,
  match: () => match42,
  matchLeft: () => matchLeft2,
  matchRight: () => matchRight2,
  max: () => max22,
  min: () => min22,
  modify: () => modify2,
  modifyNonEmptyHead: () => modifyNonEmptyHead2,
  modifyNonEmptyLast: () => modifyNonEmptyLast2,
  modifyOption: () => modifyOption2,
  of: () => of222,
  partition: () => partition2,
  partitionMap: () => partitionMap32,
  prepend: () => prepend222,
  prependAll: () => prependAll2,
  range: () => range2,
  reduce: () => reduce322,
  reduceRight: () => reduceRight2,
  remove: () => remove2,
  replace: () => replace22,
  replaceOption: () => replaceOption2,
  replicate: () => replicate2,
  reverse: () => reverse322,
  rotate: () => rotate2,
  scan: () => scan2,
  scanRight: () => scanRight2,
  separate: () => separate2,
  setNonEmptyHead: () => setNonEmptyHead2,
  setNonEmptyLast: () => setNonEmptyLast2,
  some: () => some72,
  sort: () => sort2,
  sortBy: () => sortBy2,
  sortWith: () => sortWith2,
  span: () => span2,
  split: () => split2,
  splitAt: () => splitAt2,
  splitNonEmptyAt: () => splitNonEmptyAt2,
  splitWhere: () => splitWhere2,
  tail: () => tail2,
  tailNonEmpty: () => tailNonEmpty222,
  take: () => take2,
  takeRight: () => takeRight2,
  takeWhile: () => takeWhile2,
  unappend: () => unappend2,
  unfold: () => unfold2,
  union: () => union4,
  unionWith: () => unionWith2,
  unprepend: () => unprepend2,
  unsafeGet: () => unsafeGet3,
  unzip: () => unzip2,
  zip: () => zip2,
  zipWith: () => zipWith32
});
var make622 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var array322 = (item) => make622((self2, that) => {
  if (self2.length !== that.length) {
    return false;
  }
  for (let i2222 = 0; i2222 < self2.length; i2222++) {
    const isEq = item(self2[i2222], that[i2222]);
    if (!isEq) {
      return false;
    }
  }
  return true;
});
var let_322 = (map522) => dual222(3, (self2, name22, f2222) => map522(self2, (a2222) => Object.assign({}, a2222, {
  [name22]: f2222(a2222)
})));
var bindTo322 = (map522) => dual222(2, (self2, name22) => map522(self2, (a2222) => ({
  [name22]: a2222
})));
var bind322 = (map522, flatMap522) => dual222(3, (self2, name22, f2222) => flatMap522(self2, (a2222) => map522(f2222(a2222), (b2222) => Object.assign({}, a2222, {
  [name22]: b2222
}))));
var moduleVersion222 = "3.2.8";
var getCurrentVersion222 = () => moduleVersion222;
var globalStoreId222 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion222()}`);
if (!(globalStoreId222 in globalThis)) {
  globalThis[globalStoreId222] = /* @__PURE__ */ new Map();
}
var globalStore222 = globalThis[globalStoreId222];
var globalValue222 = (id, compute) => {
  if (!globalStore222.has(id)) {
    globalStore222.set(id, compute());
  }
  return globalStore222.get(id);
};
var Predicate_exports222 = {};
__export32(Predicate_exports222, {
  all: () => all322,
  and: () => and222,
  compose: () => compose42,
  eqv: () => eqv222,
  every: () => every222,
  hasProperty: () => hasProperty222,
  implies: () => implies222,
  isBigInt: () => isBigInt222,
  isBoolean: () => isBoolean222,
  isDate: () => isDate222,
  isError: () => isError222,
  isFunction: () => isFunction52,
  isIterable: () => isIterable222,
  isMap: () => isMap222,
  isNever: () => isNever222,
  isNotNull: () => isNotNull222,
  isNotNullable: () => isNotNullable222,
  isNotUndefined: () => isNotUndefined222,
  isNull: () => isNull222,
  isNullable: () => isNullable222,
  isNumber: () => isNumber222,
  isObject: () => isObject222,
  isPromise: () => isPromise222,
  isPromiseLike: () => isPromiseLike222,
  isReadonlyRecord: () => isReadonlyRecord222,
  isRecord: () => isRecord222,
  isSet: () => isSet222,
  isString: () => isString222,
  isSymbol: () => isSymbol222,
  isTagged: () => isTagged222,
  isTruthy: () => isTruthy222,
  isUint8Array: () => isUint8Array222,
  isUndefined: () => isUndefined222,
  isUnknown: () => isUnknown222,
  mapInput: () => mapInput222,
  nand: () => nand222,
  nor: () => nor222,
  not: () => not222,
  or: () => or222,
  product: () => product322,
  productMany: () => productMany322,
  some: () => some422,
  struct: () => struct422,
  tuple: () => tuple322,
  xor: () => xor222
});
var mapInput222 = /* @__PURE__ */ dual222(2, (self2, f2222) => (b2222) => self2(f2222(b2222)));
var isTruthy222 = (input) => !!input;
var isSet222 = (input) => input instanceof Set;
var isMap222 = (input) => input instanceof Map;
var isString222 = (input) => typeof input === "string";
var isNumber222 = (input) => typeof input === "number";
var isBoolean222 = (input) => typeof input === "boolean";
var isBigInt222 = (input) => typeof input === "bigint";
var isSymbol222 = (input) => typeof input === "symbol";
var isFunction52 = isFunction42;
var isUndefined222 = (input) => input === void 0;
var isNotUndefined222 = (input) => input !== void 0;
var isNull222 = (input) => input === null;
var isNotNull222 = (input) => input !== null;
var isNever222 = (_2222) => false;
var isUnknown222 = (_2222) => true;
var isRecordOrArray222 = (input) => typeof input === "object" && input !== null;
var isObject222 = (input) => isRecordOrArray222(input) || isFunction52(input);
var hasProperty222 = /* @__PURE__ */ dual222(2, (self2, property) => isObject222(self2) && property in self2);
var isTagged222 = /* @__PURE__ */ dual222(2, (self2, tag) => hasProperty222(self2, "_tag") && self2["_tag"] === tag);
var isNullable222 = (input) => input === null || input === void 0;
var isNotNullable222 = (input) => input !== null && input !== void 0;
var isError222 = (input) => input instanceof Error;
var isUint8Array222 = (input) => input instanceof Uint8Array;
var isDate222 = (input) => input instanceof Date;
var isIterable222 = (input) => hasProperty222(input, Symbol.iterator);
var isRecord222 = (input) => isRecordOrArray222(input) && !Array.isArray(input);
var isReadonlyRecord222 = isRecord222;
var isPromise222 = (input) => hasProperty222(input, "then") && "catch" in input && isFunction52(input.then) && isFunction52(input.catch);
var isPromiseLike222 = (input) => hasProperty222(input, "then") && isFunction52(input.then);
var compose42 = /* @__PURE__ */ dual222(2, (ab, bc) => (a2222) => ab(a2222) && bc(a2222));
var product322 = (self2, that) => ([a2222, b2222]) => self2(a2222) && that(b2222);
var all322 = (collection) => {
  return (as422) => {
    let collectionIndex = 0;
    for (const p2222 of collection) {
      if (collectionIndex >= as422.length) {
        break;
      }
      if (p2222(as422[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany322 = (self2, collection) => {
  const rest = all322(collection);
  return ([head222, ...tail222]) => self2(head222) === false ? false : rest(tail222);
};
var tuple322 = (...elements) => all322(elements);
var struct422 = (fields) => {
  const keys422 = Object.keys(fields);
  return (a2222) => {
    for (const key of keys422) {
      if (!fields[key](a2222[key])) {
        return false;
      }
    }
    return true;
  };
};
var not222 = (self2) => (a2222) => !self2(a2222);
var or222 = /* @__PURE__ */ dual222(2, (self2, that) => (a2222) => self2(a2222) || that(a2222));
var and222 = /* @__PURE__ */ dual222(2, (self2, that) => (a2222) => self2(a2222) && that(a2222));
var xor222 = /* @__PURE__ */ dual222(2, (self2, that) => (a2222) => self2(a2222) !== that(a2222));
var eqv222 = /* @__PURE__ */ dual222(2, (self2, that) => (a2222) => self2(a2222) === that(a2222));
var implies222 = /* @__PURE__ */ dual222(2, (self2, that) => (a2222) => self2(a2222) ? that(a2222) : true);
var nor222 = /* @__PURE__ */ dual222(2, (self2, that) => (a2222) => !(self2(a2222) || that(a2222)));
var nand222 = /* @__PURE__ */ dual222(2, (self2, that) => (a2222) => !(self2(a2222) && that(a2222)));
var every222 = (collection) => (a2222) => {
  for (const p2222 of collection) {
    if (!p2222(a2222)) {
      return false;
    }
  }
  return true;
};
var some422 = (collection) => (a2222) => {
  for (const p2222 of collection) {
    if (p2222(a2222)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage222 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId222 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind222 = (u2222) => isObject222(u2222) && GenKindTypeId222 in u2222;
var GenKindImpl222 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity222;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId222] = GenKindTypeId222;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen322(this);
  }
};
var SingleShotGen322 = class _SingleShotGen52 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a2222) {
    return this.called ? {
      value: a2222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a2222) {
    return {
      value: a2222,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e2222) {
    throw e2222;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen52(this.self);
  }
};
var adapter322 = () => function() {
  let x2222 = arguments[0];
  for (let i2222 = 1; i2222 < arguments.length; i2222++) {
    x2222 = arguments[i2222](x2222);
  }
  return new GenKindImpl222(x2222);
};
var defaultIncHi222 = 335903614;
var defaultIncLo222 = 4150755663;
var MUL_HI222 = 1481765933 >>> 0;
var MUL_LO222 = 1284865837 >>> 0;
var BIT_53222 = 9007199254740992;
var BIT_27222 = 134217728;
var PCGRandom222 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable222(seedLo) && isNullable222(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable222(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable222(incLo) && isNullable222(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo222;
      incHi = this._state ? this._state[2] : defaultIncHi222;
    } else if (isNullable222(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add64222(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max322) {
    if (!max322) {
      return this._next();
    }
    max322 = max322 >>> 0;
    if ((max322 & max322 - 1) === 0) {
      return this._next() & max322 - 1;
    }
    let num = 0;
    const skew = (-max322 >>> 0) % max322 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max322;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_27222 + lo) / BIT_53222;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul64222(this._state, oldHi, oldLo, MUL_HI222, MUL_LO222);
    add64222(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul64222(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add64222(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId222 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap222 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId222]() {
    return this.#value;
  }
};
function yieldWrapGet222(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId222 in self2) {
    return self2[YieldWrapTypeId222]();
  }
  throw new Error(getBugErrorMessage222("yieldWrapGet"));
}
var structuralRegionState222 = /* @__PURE__ */ globalValue222("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache222 = /* @__PURE__ */ globalValue222(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr222 = /* @__PURE__ */ globalValue222(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom222());
var symbol322 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash222 = (self2) => {
  if (structuralRegionState222.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number222(self2);
    case "bigint":
      return string222(self2.toString(10));
    case "boolean":
      return string222(String(self2));
    case "symbol":
      return string222(String(self2));
    case "string":
      return string222(self2);
    case "undefined":
      return string222("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string222("null");
      } else if (self2 instanceof Date) {
        return hash222(self2.toISOString());
      } else if (isHash222(self2)) {
        return self2[symbol322]();
      } else {
        return random222(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random222 = (self2) => {
  if (!randomHashCache222.has(self2)) {
    randomHashCache222.set(self2, number222(pcgr222.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache222.get(self2);
};
var combine322 = (b2222) => (self2) => self2 * 53 ^ b2222;
var optimize222 = (n2222) => n2222 & 3221225471 | n2222 >>> 1 & 1073741824;
var isHash222 = (u2222) => hasProperty222(u2222, symbol322);
var number222 = (n2222) => {
  if (n2222 !== n2222 || n2222 === Infinity) {
    return 0;
  }
  let h2222 = n2222 | 0;
  if (h2222 !== n2222) {
    h2222 ^= n2222 * 4294967295;
  }
  while (n2222 > 4294967295) {
    h2222 ^= n2222 /= 4294967295;
  }
  return optimize222(n2222);
};
var string222 = (str) => {
  let h2222 = 5381, i2222 = str.length;
  while (i2222) {
    h2222 = h2222 * 33 ^ str.charCodeAt(--i2222);
  }
  return optimize222(h2222);
};
var cached222 = function() {
  if (arguments.length === 1) {
    const self3 = arguments[0];
    return function(hash522) {
      Object.defineProperty(self3, symbol322, {
        value() {
          return hash522;
        },
        enumerable: false
      });
      return hash522;
    };
  }
  const self2 = arguments[0];
  const hash422 = arguments[1];
  Object.defineProperty(self2, symbol322, {
    value() {
      return hash422;
    },
    enumerable: false
  });
  return hash422;
};
var symbol42 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals222() {
  if (arguments.length === 1) {
    return (self2) => compareBoth222(self2, arguments[0]);
  }
  return compareBoth222(arguments[0], arguments[1]);
}
function compareBoth222(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual222(self2) && isEqual222(that)) {
        if (hash222(self2) === hash222(that) && self2[symbol42](that)) {
          return true;
        } else {
          return structuralRegionState222.enabled && structuralRegionState222.tester ? structuralRegionState222.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState222.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v2222, i2222) => compareBoth222(v2222, that[i2222]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth222(self2[key], that[key]))) {
              return structuralRegionState222.tester ? structuralRegionState222.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState222.tester ? structuralRegionState222.tester(self2, that) : false;
    }
  }
  return structuralRegionState222.enabled && structuralRegionState222.tester ? structuralRegionState222.tester(self2, that) : false;
}
var isEqual222 = (u2222) => hasProperty222(u2222, symbol42);
var equivalence222 = () => equals222;
var NodeInspectSymbol222 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON222 = (x2222) => {
  if (hasProperty222(x2222, "toJSON") && isFunction52(x2222["toJSON"]) && x2222["toJSON"].length === 0) {
    return x2222.toJSON();
  } else if (Array.isArray(x2222)) {
    return x2222.map(toJSON222);
  }
  return x2222;
};
var format222 = (x2222) => JSON.stringify(x2222, null, 2);
var pipeArguments222 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i2222 = 0, len = args.length; i2222 < len; i2222++) {
        ret = args[i2222](ret);
      }
      return ret;
    }
  }
};
var EffectTypeId322 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId222 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId222 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId222 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance222 = {
  /* c8 ignore next */
  _R: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _A: (_2222) => _2222,
  _V: /* @__PURE__ */ getCurrentVersion222()
};
var sinkVariance222 = {
  /* c8 ignore next */
  _A: (_2222) => _2222,
  /* c8 ignore next */
  _In: (_2222) => _2222,
  /* c8 ignore next */
  _L: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _R: (_2222) => _2222
};
var channelVariance222 = {
  /* c8 ignore next */
  _Env: (_2222) => _2222,
  /* c8 ignore next */
  _InErr: (_2222) => _2222,
  /* c8 ignore next */
  _InElem: (_2222) => _2222,
  /* c8 ignore next */
  _InDone: (_2222) => _2222,
  /* c8 ignore next */
  _OutErr: (_2222) => _2222,
  /* c8 ignore next */
  _OutElem: (_2222) => _2222,
  /* c8 ignore next */
  _OutDone: (_2222) => _2222
};
var EffectPrototype222 = {
  [EffectTypeId322]: effectVariance222,
  [StreamTypeId222]: effectVariance222,
  [SinkTypeId222]: sinkVariance222,
  [ChannelTypeId222]: channelVariance222,
  [symbol42](that) {
    return this === that;
  },
  [symbol322]() {
    return cached222(this, random222(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen322(new YieldWrap222(this));
  },
  pipe() {
    return pipeArguments222(this, arguments);
  }
};
var TypeId622 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto322 = {
  ...EffectPrototype222,
  [TypeId622]: {
    _A: (_2222) => _2222
  },
  [NodeInspectSymbol222]() {
    return this.toJSON();
  },
  toString() {
    return format222(this.toJSON());
  }
};
var SomeProto222 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto322), {
  _tag: "Some",
  _op: "Some",
  [symbol42](that) {
    return isOption322(that) && isSome322(that) && equals222(this.value, that.value);
  },
  [symbol322]() {
    return cached222(this, combine322(hash222(this._tag))(hash222(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON222(this.value)
    };
  }
});
var NoneHash222 = /* @__PURE__ */ hash222("None");
var NoneProto222 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto322), {
  _tag: "None",
  _op: "None",
  [symbol42](that) {
    return isOption322(that) && isNone322(that);
  },
  [symbol322]() {
    return NoneHash222;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption322 = (input) => hasProperty222(input, TypeId622);
var isNone322 = (fa) => fa._tag === "None";
var isSome322 = (fa) => fa._tag === "Some";
var none322 = /* @__PURE__ */ Object.create(NoneProto222);
var some52 = (value) => {
  const a2222 = Object.create(SomeProto222);
  a2222.value = value;
  return a2222;
};
var TypeId72 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto42 = {
  ...EffectPrototype222,
  [TypeId72]: {
    _R: (_2222) => _2222
  },
  [NodeInspectSymbol222]() {
    return this.toJSON();
  },
  toString() {
    return format222(this.toJSON());
  }
};
var RightProto222 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto42), {
  _tag: "Right",
  _op: "Right",
  [symbol42](that) {
    return isEither222(that) && isRight222(that) && equals222(this.right, that.right);
  },
  [symbol322]() {
    return combine322(hash222(this._tag))(hash222(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON222(this.right)
    };
  }
});
var LeftProto222 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto42), {
  _tag: "Left",
  _op: "Left",
  [symbol42](that) {
    return isEither222(that) && isLeft222(that) && equals222(this.left, that.left);
  },
  [symbol322]() {
    return combine322(hash222(this._tag))(hash222(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON222(this.left)
    };
  }
});
var isEither222 = (input) => hasProperty222(input, TypeId72);
var isLeft222 = (ma) => ma._tag === "Left";
var isRight222 = (ma) => ma._tag === "Right";
var left322 = (left522) => {
  const a2222 = Object.create(LeftProto222);
  a2222.left = left522;
  return a2222;
};
var right322 = (right522) => {
  const a2222 = Object.create(RightProto222);
  a2222.right = right522;
  return a2222;
};
var getLeft322 = (self2) => isRight222(self2) ? none322 : some52(self2.left);
var getRight322 = (self2) => isLeft222(self2) ? none322 : some52(self2.right);
var isLeft32 = isLeft222;
var isRight32 = isRight222;
var isNonEmptyArray3 = (self2) => self2.length > 0;
var Option_exports222 = {};
__export32(Option_exports222, {
  Do: () => Do222,
  TypeId: () => TypeId82,
  all: () => all42,
  andThen: () => andThen222,
  ap: () => ap222,
  as: () => as222,
  asVoid: () => asVoid222,
  bind: () => bind42,
  bindTo: () => bindTo42,
  composeK: () => composeK222,
  contains: () => contains222,
  containsWith: () => containsWith222,
  exists: () => exists222,
  filter: () => filter222,
  filterMap: () => filterMap222,
  firstSomeOf: () => firstSomeOf222,
  flatMap: () => flatMap222,
  flatMapNullable: () => flatMapNullable222,
  flatten: () => flatten222,
  fromIterable: () => fromIterable322,
  fromNullable: () => fromNullable222,
  gen: () => gen222,
  getEquivalence: () => getEquivalence322,
  getLeft: () => getLeft42,
  getOrElse: () => getOrElse222,
  getOrNull: () => getOrNull222,
  getOrThrow: () => getOrThrow222,
  getOrThrowWith: () => getOrThrowWith222,
  getOrUndefined: () => getOrUndefined222,
  getOrder: () => getOrder222,
  getRight: () => getRight42,
  isNone: () => isNone42,
  isOption: () => isOption42,
  isSome: () => isSome42,
  let: () => let_42,
  lift2: () => lift2222,
  liftNullable: () => liftNullable222,
  liftPredicate: () => liftPredicate222,
  liftThrowable: () => liftThrowable222,
  map: () => map222,
  match: () => match32,
  none: () => none42,
  orElse: () => orElse222,
  orElseEither: () => orElseEither222,
  orElseSome: () => orElseSome222,
  partitionMap: () => partitionMap222,
  product: () => product42,
  productMany: () => productMany42,
  reduceCompact: () => reduceCompact222,
  some: () => some62,
  tap: () => tap222,
  toArray: () => toArray222,
  toRefinement: () => toRefinement222,
  void: () => void_222,
  zipLeft: () => zipLeft222,
  zipRight: () => zipRight222,
  zipWith: () => zipWith222
});
var make82 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var number32 = /* @__PURE__ */ make82((self2, that) => self2 < that ? -1 : 1);
var combineMany2 = /* @__PURE__ */ dual222(2, (self2, collection) => make82((a1, a2222) => {
  let out = self2(a1, a2222);
  if (out !== 0) {
    return out;
  }
  for (const O2222 of collection) {
    out = O2222(a1, a2222);
    if (out !== 0) {
      return out;
    }
  }
  return out;
}));
var empty822 = () => make82(() => 0);
var combineAll2 = (collection) => combineMany2(empty822(), collection);
var mapInput32 = /* @__PURE__ */ dual222(2, (self2, f2222) => make82((b1, b2222) => self2(f2222(b1), f2222(b2222))));
var array42 = (O2222) => make82((self2, that) => {
  const aLen = self2.length;
  const bLen = that.length;
  const len = Math.min(aLen, bLen);
  for (let i2222 = 0; i2222 < len; i2222++) {
    const o2222 = O2222(self2[i2222], that[i2222]);
    if (o2222 !== 0) {
      return o2222;
    }
  }
  return number32(aLen, bLen);
});
var min3 = (O2222) => dual222(2, (self2, that) => self2 === that || O2222(self2, that) < 1 ? self2 : that);
var max3 = (O2222) => dual222(2, (self2, that) => self2 === that || O2222(self2, that) > -1 ? self2 : that);
var TypeId82 = /* @__PURE__ */ Symbol.for("effect/Option");
var none42 = () => none322;
var some62 = some52;
var isOption42 = isOption322;
var isNone42 = isNone322;
var isSome42 = isSome322;
var match32 = /* @__PURE__ */ dual222(2, (self2, {
  onNone,
  onSome
}) => isNone42(self2) ? onNone() : onSome(self2.value));
var toRefinement222 = (f2222) => (a2222) => isSome42(f2222(a2222));
var fromIterable322 = (collection) => {
  for (const a2222 of collection) {
    return some62(a2222);
  }
  return none42();
};
var getRight42 = getRight322;
var getLeft42 = getLeft322;
var getOrElse222 = /* @__PURE__ */ dual222(2, (self2, onNone) => isNone42(self2) ? onNone() : self2.value);
var orElse222 = /* @__PURE__ */ dual222(2, (self2, that) => isNone42(self2) ? that() : self2);
var orElseSome222 = /* @__PURE__ */ dual222(2, (self2, onNone) => isNone42(self2) ? some62(onNone()) : self2);
var orElseEither222 = /* @__PURE__ */ dual222(2, (self2, that) => isNone42(self2) ? map222(that(), right322) : map222(self2, left322));
var firstSomeOf222 = (collection) => {
  let out = none42();
  for (out of collection) {
    if (isSome42(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable222 = (nullableValue) => nullableValue == null ? none42() : some62(nullableValue);
var liftNullable222 = (f2222) => (...a2222) => fromNullable222(f2222(...a2222));
var getOrNull222 = /* @__PURE__ */ getOrElse222(constNull222);
var getOrUndefined222 = /* @__PURE__ */ getOrElse222(constUndefined222);
var liftThrowable222 = (f2222) => (...a2222) => {
  try {
    return some62(f2222(...a2222));
  } catch (e2222) {
    return none42();
  }
};
var getOrThrowWith222 = /* @__PURE__ */ dual222(2, (self2, onNone) => {
  if (isSome42(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow222 = /* @__PURE__ */ getOrThrowWith222(() => new Error("getOrThrow called on a None"));
var map222 = /* @__PURE__ */ dual222(2, (self2, f2222) => isNone42(self2) ? none42() : some62(f2222(self2.value)));
var as222 = /* @__PURE__ */ dual222(2, (self2, b2222) => map222(self2, () => b2222));
var asVoid222 = /* @__PURE__ */ as222(void 0);
var void_222 = /* @__PURE__ */ some62(void 0);
var flatMap222 = /* @__PURE__ */ dual222(2, (self2, f2222) => isNone42(self2) ? none42() : f2222(self2.value));
var andThen222 = /* @__PURE__ */ dual222(2, (self2, f2222) => flatMap222(self2, (a2222) => {
  const b2222 = isFunction42(f2222) ? f2222(a2222) : f2222;
  return isOption42(b2222) ? b2222 : some62(b2222);
}));
var flatMapNullable222 = /* @__PURE__ */ dual222(2, (self2, f2222) => isNone42(self2) ? none42() : fromNullable222(f2222(self2.value)));
var flatten222 = /* @__PURE__ */ flatMap222(identity222);
var zipRight222 = /* @__PURE__ */ dual222(2, (self2, that) => flatMap222(self2, () => that));
var composeK222 = /* @__PURE__ */ dual222(2, (afb, bfc) => (a2222) => flatMap222(afb(a2222), bfc));
var zipLeft222 = /* @__PURE__ */ dual222(2, (self2, that) => tap222(self2, () => that));
var tap222 = /* @__PURE__ */ dual222(2, (self2, f2222) => flatMap222(self2, (a2222) => map222(f2222(a2222), () => a2222)));
var product42 = (self2, that) => isSome42(self2) && isSome42(that) ? some62([self2.value, that.value]) : none42();
var productMany42 = (self2, collection) => {
  if (isNone42(self2)) {
    return none42();
  }
  const out = [self2.value];
  for (const o2222 of collection) {
    if (isNone42(o2222)) {
      return none42();
    }
    out.push(o2222.value);
  }
  return some62(out);
};
var all42 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o2222 of input) {
      if (isNone42(o2222)) {
        return none42();
      }
      out2.push(o2222.value);
    }
    return some62(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o2222 = input[key];
    if (isNone42(o2222)) {
      return none42();
    }
    out[key] = o2222.value;
  }
  return some62(out);
};
var zipWith222 = /* @__PURE__ */ dual222(3, (self2, that, f2222) => map222(product42(self2, that), ([a2222, b2222]) => f2222(a2222, b2222)));
var ap222 = /* @__PURE__ */ dual222(2, (self2, that) => zipWith222(self2, that, (f2222, a2222) => f2222(a2222)));
var reduceCompact222 = /* @__PURE__ */ dual222(3, (self2, b2222, f2222) => {
  let out = b2222;
  for (const oa of self2) {
    if (isSome42(oa)) {
      out = f2222(out, oa.value);
    }
  }
  return out;
});
var toArray222 = (self2) => isNone42(self2) ? [] : [self2.value];
var partitionMap222 = /* @__PURE__ */ dual222(2, (self2, f2222) => {
  if (isNone42(self2)) {
    return [none42(), none42()];
  }
  const e2222 = f2222(self2.value);
  return isLeft222(e2222) ? [some62(e2222.left), none42()] : [none42(), some62(e2222.right)];
});
var filterMap222 = /* @__PURE__ */ dual222(2, (self2, f2222) => isNone42(self2) ? none42() : f2222(self2.value));
var filter222 = /* @__PURE__ */ dual222(2, (self2, predicate) => filterMap222(self2, (b2222) => predicate(b2222) ? some52(b2222) : none322));
var getEquivalence322 = (isEquivalent) => make622((x2222, y2222) => x2222 === y2222 || (isNone42(x2222) ? isNone42(y2222) : isNone42(y2222) ? false : isEquivalent(x2222.value, y2222.value)));
var getOrder222 = (O2222) => make82((self2, that) => isSome42(self2) ? isSome42(that) ? O2222(self2.value, that.value) : 1 : -1);
var lift2222 = (f2222) => dual222(2, (self2, that) => zipWith222(self2, that, f2222));
var liftPredicate222 = (predicate) => (b2222) => predicate(b2222) ? some62(b2222) : none42();
var containsWith222 = (isEquivalent) => dual222(2, (self2, a2222) => isNone42(self2) ? false : isEquivalent(self2.value, a2222));
var _equivalence322 = /* @__PURE__ */ equivalence222();
var contains222 = /* @__PURE__ */ containsWith222(_equivalence322);
var exists222 = /* @__PURE__ */ dual222(2, (self2, refinement) => isNone42(self2) ? false : refinement(self2.value));
var bindTo42 = /* @__PURE__ */ bindTo322(map222);
var let_42 = /* @__PURE__ */ let_322(map222);
var bind42 = /* @__PURE__ */ bind322(map222, flatMap222);
var Do222 = /* @__PURE__ */ some62({});
var adapter42 = /* @__PURE__ */ adapter322();
var gen222 = (f2222) => {
  const iterator = f2222(adapter42);
  let state = iterator.next();
  if (state.done) {
    return some62(state.value);
  } else {
    let current = state.value;
    if (isGenKind222(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet222(current);
    }
    if (isNone42(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind222(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet222(current);
        }
        if (isNone42(current)) {
          return current;
        }
      }
    }
    return some62(state.value);
  }
};
var make92 = (...elements) => elements;
var findFirst3 = /* @__PURE__ */ dual222(2, (self2, f2222) => {
  let i2222 = 0;
  for (const a2222 of self2) {
    const o2222 = f2222(a2222, i2222);
    if (isBoolean222(o2222)) {
      if (o2222) {
        return some62(a2222);
      }
    } else {
      if (isSome42(o2222)) {
        return o2222;
      }
    }
    i2222++;
  }
  return none42();
});
var collect2 = /* @__PURE__ */ dual222(2, (self2, f2222) => {
  const out = [];
  for (const key of keys222(self2)) {
    out.push(f2222(key, self2[key]));
  }
  return out;
});
var toEntries2 = /* @__PURE__ */ collect2((key, value) => [key, value]);
var keys222 = (self2) => Object.keys(self2);
var make102 = (...elements) => elements;
var allocate2 = (n2222) => new Array(n2222);
var makeBy2 = (n2222, f2222) => {
  const max322 = Math.max(1, Math.floor(n2222));
  const out = new Array(max322);
  for (let i2222 = 0; i2222 < max322; i2222++) {
    out[i2222] = f2222(i2222);
  }
  return out;
};
var range2 = (start, end) => start <= end ? makeBy2(end - start + 1, (i2222) => start + i2222) : [start];
var replicate2 = /* @__PURE__ */ dual222(2, (a2222, n2222) => makeBy2(n2222, () => a2222));
var fromIterable42 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var fromRecord2 = toEntries2;
var fromOption22 = toArray222;
var match42 = /* @__PURE__ */ dual222(2, (self2, {
  onEmpty,
  onNonEmpty
}) => isNonEmptyReadonlyArray2(self2) ? onNonEmpty(self2) : onEmpty());
var matchLeft2 = /* @__PURE__ */ dual222(2, (self2, {
  onEmpty,
  onNonEmpty
}) => isNonEmptyReadonlyArray2(self2) ? onNonEmpty(headNonEmpty222(self2), tailNonEmpty222(self2)) : onEmpty());
var matchRight2 = /* @__PURE__ */ dual222(2, (self2, {
  onEmpty,
  onNonEmpty
}) => isNonEmptyReadonlyArray2(self2) ? onNonEmpty(initNonEmpty2(self2), lastNonEmpty2(self2)) : onEmpty());
var prepend222 = /* @__PURE__ */ dual222(2, (self2, head222) => [head222, ...self2]);
var prependAll2 = /* @__PURE__ */ dual222(2, (self2, that) => fromIterable42(that).concat(fromIterable42(self2)));
var append2 = /* @__PURE__ */ dual222(2, (self2, last222) => [...self2, last222]);
var appendAll222 = /* @__PURE__ */ dual222(2, (self2, that) => fromIterable42(self2).concat(fromIterable42(that)));
var scan2 = /* @__PURE__ */ dual222(3, (self2, b2222, f2222) => {
  const out = [b2222];
  let i2222 = 0;
  for (const a2222 of self2) {
    out[i2222 + 1] = f2222(out[i2222], a2222);
    i2222++;
  }
  return out;
});
var scanRight2 = /* @__PURE__ */ dual222(3, (self2, b2222, f2222) => {
  const input = fromIterable42(self2);
  const out = new Array(input.length + 1);
  out[input.length] = b2222;
  for (let i2222 = input.length - 1; i2222 >= 0; i2222--) {
    out[i2222] = f2222(out[i2222 + 1], input[i2222]);
  }
  return out;
});
var isArray2 = Array.isArray;
var isEmptyArray2 = (self2) => self2.length === 0;
var isEmptyReadonlyArray2 = isEmptyArray2;
var isNonEmptyArray22 = isNonEmptyArray3;
var isNonEmptyReadonlyArray2 = isNonEmptyArray3;
var length2 = (self2) => self2.length;
var isOutOfBound2 = (i2222, as422) => i2222 < 0 || i2222 >= as422.length;
var clamp2 = (i2222, as422) => Math.floor(Math.min(Math.max(0, i2222), as422.length));
var get3 = /* @__PURE__ */ dual222(2, (self2, index) => {
  const i2222 = Math.floor(index);
  return isOutOfBound2(i2222, self2) ? none42() : some62(self2[i2222]);
});
var unsafeGet3 = /* @__PURE__ */ dual222(2, (self2, index) => {
  const i2222 = Math.floor(index);
  if (isOutOfBound2(i2222, self2)) {
    throw new Error(`Index ${i2222} out of bounds`);
  }
  return self2[i2222];
});
var unprepend2 = (self2) => [headNonEmpty222(self2), tailNonEmpty222(self2)];
var unappend2 = (self2) => [initNonEmpty2(self2), lastNonEmpty2(self2)];
var head2 = /* @__PURE__ */ get3(0);
var headNonEmpty222 = /* @__PURE__ */ unsafeGet3(0);
var last2 = (self2) => isNonEmptyReadonlyArray2(self2) ? some62(lastNonEmpty2(self2)) : none42();
var lastNonEmpty2 = (self2) => self2[self2.length - 1];
var tail2 = (self2) => {
  const input = fromIterable42(self2);
  return isNonEmptyReadonlyArray2(input) ? some62(tailNonEmpty222(input)) : none42();
};
var tailNonEmpty222 = (self2) => self2.slice(1);
var init2 = (self2) => {
  const input = fromIterable42(self2);
  return isNonEmptyReadonlyArray2(input) ? some62(initNonEmpty2(input)) : none42();
};
var initNonEmpty2 = (self2) => self2.slice(0, -1);
var take2 = /* @__PURE__ */ dual222(2, (self2, n2222) => {
  const input = fromIterable42(self2);
  return input.slice(0, clamp2(n2222, input));
});
var takeRight2 = /* @__PURE__ */ dual222(2, (self2, n2222) => {
  const input = fromIterable42(self2);
  const i2222 = clamp2(n2222, input);
  return i2222 === 0 ? [] : input.slice(-i2222);
});
var takeWhile2 = /* @__PURE__ */ dual222(2, (self2, predicate) => {
  let i2222 = 0;
  const out = [];
  for (const a2222 of self2) {
    if (!predicate(a2222, i2222)) {
      break;
    }
    out.push(a2222);
    i2222++;
  }
  return out;
});
var spanIndex2 = (self2, predicate) => {
  let i2222 = 0;
  for (const a2222 of self2) {
    if (!predicate(a2222, i2222)) {
      break;
    }
    i2222++;
  }
  return i2222;
};
var span2 = /* @__PURE__ */ dual222(2, (self2, predicate) => splitAt2(self2, spanIndex2(self2, predicate)));
var drop222 = /* @__PURE__ */ dual222(2, (self2, n2222) => {
  const input = fromIterable42(self2);
  return input.slice(clamp2(n2222, input), input.length);
});
var dropRight2 = /* @__PURE__ */ dual222(2, (self2, n2222) => {
  const input = fromIterable42(self2);
  return input.slice(0, input.length - clamp2(n2222, input));
});
var dropWhile2 = /* @__PURE__ */ dual222(2, (self2, predicate) => fromIterable42(self2).slice(spanIndex2(self2, predicate)));
var findFirstIndex2 = /* @__PURE__ */ dual222(2, (self2, predicate) => {
  let i2222 = 0;
  for (const a2222 of self2) {
    if (predicate(a2222, i2222)) {
      return some62(i2222);
    }
    i2222++;
  }
  return none42();
});
var findLastIndex2 = /* @__PURE__ */ dual222(2, (self2, predicate) => {
  const input = fromIterable42(self2);
  for (let i2222 = input.length - 1; i2222 >= 0; i2222--) {
    if (predicate(input[i2222], i2222)) {
      return some62(i2222);
    }
  }
  return none42();
});
var findFirst22 = findFirst3;
var findLast2 = /* @__PURE__ */ dual222(2, (self2, f2222) => {
  const input = fromIterable42(self2);
  for (let i2222 = input.length - 1; i2222 >= 0; i2222--) {
    const a2222 = input[i2222];
    const o2222 = f2222(a2222, i2222);
    if (isBoolean222(o2222)) {
      if (o2222) {
        return some62(a2222);
      }
    } else {
      if (isSome42(o2222)) {
        return o2222;
      }
    }
  }
  return none42();
});
var insertAt2 = /* @__PURE__ */ dual222(3, (self2, i2222, b2222) => {
  const out = Array.from(self2);
  if (i2222 < 0 || i2222 > out.length) {
    return none42();
  }
  out.splice(i2222, 0, b2222);
  return some62(out);
});
var replace22 = /* @__PURE__ */ dual222(3, (self2, i2222, b2222) => modify2(self2, i2222, () => b2222));
var replaceOption2 = /* @__PURE__ */ dual222(3, (self2, i2222, b2222) => modifyOption2(self2, i2222, () => b2222));
var modify2 = /* @__PURE__ */ dual222(3, (self2, i2222, f2222) => getOrElse222(modifyOption2(self2, i2222, f2222), () => Array.from(self2)));
var modifyOption2 = /* @__PURE__ */ dual222(3, (self2, i2222, f2222) => {
  const out = Array.from(self2);
  if (isOutOfBound2(i2222, out)) {
    return none42();
  }
  const next = f2222(out[i2222]);
  out[i2222] = next;
  return some62(out);
});
var remove2 = /* @__PURE__ */ dual222(2, (self2, i2222) => {
  const out = Array.from(self2);
  if (isOutOfBound2(i2222, out)) {
    return out;
  }
  out.splice(i2222, 1);
  return out;
});
var reverse322 = (self2) => Array.from(self2).reverse();
var sort2 = /* @__PURE__ */ dual222(2, (self2, O2222) => {
  const out = Array.from(self2);
  out.sort(O2222);
  return out;
});
var sortWith2 = /* @__PURE__ */ dual222(3, (self2, f2222, order) => sort2(self2, mapInput32(order, f2222)));
var sortBy2 = (...orders) => {
  const sortByAll = sort2(combineAll2(orders));
  return (self2) => {
    const input = fromIterable42(self2);
    if (isNonEmptyReadonlyArray2(input)) {
      return sortByAll(input);
    }
    return [];
  };
};
var zip2 = /* @__PURE__ */ dual222(2, (self2, that) => zipWith32(self2, that, make92));
var zipWith32 = /* @__PURE__ */ dual222(3, (self2, that, f2222) => {
  const as422 = fromIterable42(self2);
  const bs = fromIterable42(that);
  if (isNonEmptyReadonlyArray2(as422) && isNonEmptyReadonlyArray2(bs)) {
    const out = [f2222(headNonEmpty222(as422), headNonEmpty222(bs))];
    const len = Math.min(as422.length, bs.length);
    for (let i2222 = 1; i2222 < len; i2222++) {
      out[i2222] = f2222(as422[i2222], bs[i2222]);
    }
    return out;
  }
  return [];
});
var unzip2 = (self2) => {
  const input = fromIterable42(self2);
  if (isNonEmptyReadonlyArray2(input)) {
    const fa = [input[0][0]];
    const fb = [input[0][1]];
    for (let i2222 = 1; i2222 < input.length; i2222++) {
      fa[i2222] = input[i2222][0];
      fb[i2222] = input[i2222][1];
    }
    return [fa, fb];
  }
  return [[], []];
};
var intersperse2 = /* @__PURE__ */ dual222(2, (self2, middle) => {
  const input = fromIterable42(self2);
  if (isNonEmptyReadonlyArray2(input)) {
    const out = [headNonEmpty222(input)];
    const tail222 = tailNonEmpty222(input);
    for (let i2222 = 0; i2222 < tail222.length; i2222++) {
      if (i2222 < tail222.length) {
        out.push(middle);
      }
      out.push(tail222[i2222]);
    }
    return out;
  }
  return [];
});
var modifyNonEmptyHead2 = /* @__PURE__ */ dual222(2, (self2, f2222) => [f2222(headNonEmpty222(self2)), ...tailNonEmpty222(self2)]);
var setNonEmptyHead2 = /* @__PURE__ */ dual222(2, (self2, b2222) => modifyNonEmptyHead2(self2, () => b2222));
var modifyNonEmptyLast2 = /* @__PURE__ */ dual222(2, (self2, f2222) => append2(initNonEmpty2(self2), f2222(lastNonEmpty2(self2))));
var setNonEmptyLast2 = /* @__PURE__ */ dual222(2, (self2, b2222) => modifyNonEmptyLast2(self2, () => b2222));
var rotate2 = /* @__PURE__ */ dual222(2, (self2, n2222) => {
  const input = fromIterable42(self2);
  if (isNonEmptyReadonlyArray2(input)) {
    const len = input.length;
    const m2222 = Math.round(n2222) % len;
    if (isOutOfBound2(Math.abs(m2222), input) || m2222 === 0) {
      return copy222(input);
    }
    if (m2222 < 0) {
      const [f2222, s2222] = splitNonEmptyAt2(input, -m2222);
      return appendAll222(s2222, f2222);
    } else {
      return rotate2(self2, m2222 - len);
    }
  }
  return [];
});
var containsWith32 = (isEquivalent) => dual222(2, (self2, a2222) => {
  for (const i2222 of self2) {
    if (isEquivalent(a2222, i2222)) {
      return true;
    }
  }
  return false;
});
var _equivalence42 = /* @__PURE__ */ equivalence222();
var contains32 = /* @__PURE__ */ containsWith32(_equivalence42);
var chop2 = /* @__PURE__ */ dual222(2, (self2, f2222) => {
  const input = fromIterable42(self2);
  if (isNonEmptyReadonlyArray2(input)) {
    const [b2222, rest] = f2222(input);
    const out = [b2222];
    let next = rest;
    while (isNonEmptyArray3(next)) {
      const [b322, rest2] = f2222(next);
      out.push(b322);
      next = rest2;
    }
    return out;
  }
  return [];
});
var splitAt2 = /* @__PURE__ */ dual222(2, (self2, n2222) => {
  const input = Array.from(self2);
  const _n = Math.floor(n2222);
  if (isNonEmptyReadonlyArray2(input)) {
    if (_n >= 1) {
      return splitNonEmptyAt2(input, _n);
    }
    return [[], input];
  }
  return [input, []];
});
var splitNonEmptyAt2 = /* @__PURE__ */ dual222(2, (self2, n2222) => {
  const _n = Math.max(1, Math.floor(n2222));
  return _n >= self2.length ? [copy222(self2), []] : [prepend222(self2.slice(1, _n), headNonEmpty222(self2)), self2.slice(_n)];
});
var split2 = /* @__PURE__ */ dual222(2, (self2, n2222) => {
  const input = fromIterable42(self2);
  return chunksOf2(input, Math.ceil(input.length / Math.floor(n2222)));
});
var splitWhere2 = /* @__PURE__ */ dual222(2, (self2, predicate) => span2(self2, (a2222, i2222) => !predicate(a2222, i2222)));
var copy222 = (self2) => self2.slice();
var chunksOf2 = /* @__PURE__ */ dual222(2, (self2, n2222) => {
  const input = fromIterable42(self2);
  if (isNonEmptyReadonlyArray2(input)) {
    return chop2(input, splitNonEmptyAt2(n2222));
  }
  return [];
});
var groupWith2 = /* @__PURE__ */ dual222(2, (self2, isEquivalent) => chop2(self2, (as422) => {
  const h2222 = headNonEmpty222(as422);
  const out = [h2222];
  let i2222 = 1;
  for (; i2222 < as422.length; i2222++) {
    const a2222 = as422[i2222];
    if (isEquivalent(a2222, h2222)) {
      out.push(a2222);
    } else {
      break;
    }
  }
  return [out, as422.slice(i2222)];
}));
var group2 = /* @__PURE__ */ groupWith2(/* @__PURE__ */ equivalence222());
var groupBy2 = /* @__PURE__ */ dual222(2, (self2, f2222) => {
  const out = {};
  for (const a2222 of self2) {
    const k2222 = f2222(a2222);
    if (Object.prototype.hasOwnProperty.call(out, k2222)) {
      out[k2222].push(a2222);
    } else {
      out[k2222] = [a2222];
    }
  }
  return out;
});
var unionWith2 = /* @__PURE__ */ dual222(3, (self2, that, isEquivalent) => {
  const a2222 = fromIterable42(self2);
  const b2222 = fromIterable42(that);
  if (isNonEmptyReadonlyArray2(a2222)) {
    if (isNonEmptyReadonlyArray2(b2222)) {
      const dedupe222 = dedupeWith2(isEquivalent);
      return dedupe222(appendAll222(a2222, b2222));
    }
    return a2222;
  }
  return b2222;
});
var union4 = /* @__PURE__ */ dual222(2, (self2, that) => unionWith2(self2, that, _equivalence42));
var intersectionWith2 = (isEquivalent) => {
  const has22 = containsWith32(isEquivalent);
  return dual222(2, (self2, that) => fromIterable42(self2).filter((a2222) => has22(that, a2222)));
};
var intersection2 = /* @__PURE__ */ intersectionWith2(_equivalence42);
var differenceWith2 = (isEquivalent) => {
  const has22 = containsWith32(isEquivalent);
  return dual222(2, (self2, that) => fromIterable42(self2).filter((a2222) => !has22(that, a2222)));
};
var difference2 = /* @__PURE__ */ differenceWith2(_equivalence42);
var empty92 = () => [];
var of222 = (a2222) => [a2222];
var map32 = /* @__PURE__ */ dual222(2, (self2, f2222) => self2.map(f2222));
var flatMap32 = /* @__PURE__ */ dual222(2, (self2, f2222) => {
  if (isEmptyReadonlyArray2(self2)) {
    return [];
  }
  const out = [];
  for (let i2222 = 0; i2222 < self2.length; i2222++) {
    const inner = f2222(self2[i2222], i2222);
    for (let j2222 = 0; j2222 < inner.length; j2222++) {
      out.push(inner[j2222]);
    }
  }
  return out;
});
var flatten32 = /* @__PURE__ */ flatMap32(identity222);
var filterMap32 = /* @__PURE__ */ dual222(2, (self2, f2222) => {
  const as422 = fromIterable42(self2);
  const out = [];
  for (let i2222 = 0; i2222 < as422.length; i2222++) {
    const o2222 = f2222(as422[i2222], i2222);
    if (isSome42(o2222)) {
      out.push(o2222.value);
    }
  }
  return out;
});
var filterMapWhile2 = /* @__PURE__ */ dual222(2, (self2, f2222) => {
  let i2222 = 0;
  const out = [];
  for (const a2222 of self2) {
    const b2222 = f2222(a2222, i2222);
    if (isSome42(b2222)) {
      out.push(b2222.value);
    } else {
      break;
    }
    i2222++;
  }
  return out;
});
var partitionMap32 = /* @__PURE__ */ dual222(2, (self2, f2222) => {
  const left522 = [];
  const right522 = [];
  const as422 = fromIterable42(self2);
  for (let i2222 = 0; i2222 < as422.length; i2222++) {
    const e2222 = f2222(as422[i2222], i2222);
    if (isLeft32(e2222)) {
      left522.push(e2222.left);
    } else {
      right522.push(e2222.right);
    }
  }
  return [left522, right522];
});
var getSomes2 = /* @__PURE__ */ filterMap32(identity222);
var getLefts2 = (self2) => {
  const out = [];
  for (const a2222 of self2) {
    if (isLeft32(a2222)) {
      out.push(a2222.left);
    }
  }
  return out;
};
var getRights2 = (self2) => {
  const out = [];
  for (const a2222 of self2) {
    if (isRight32(a2222)) {
      out.push(a2222.right);
    }
  }
  return out;
};
var filter32 = /* @__PURE__ */ dual222(2, (self2, predicate) => {
  const as422 = fromIterable42(self2);
  const out = [];
  for (let i2222 = 0; i2222 < as422.length; i2222++) {
    if (predicate(as422[i2222], i2222)) {
      out.push(as422[i2222]);
    }
  }
  return out;
});
var partition2 = /* @__PURE__ */ dual222(2, (self2, predicate) => {
  const left522 = [];
  const right522 = [];
  const as422 = fromIterable42(self2);
  for (let i2222 = 0; i2222 < as422.length; i2222++) {
    if (predicate(as422[i2222], i2222)) {
      right522.push(as422[i2222]);
    } else {
      left522.push(as422[i2222]);
    }
  }
  return [left522, right522];
});
var separate2 = /* @__PURE__ */ partitionMap32(identity222);
var reduce322 = /* @__PURE__ */ dual222(3, (self2, b2222, f2222) => fromIterable42(self2).reduce((b322, a2222, i2222) => f2222(b322, a2222, i2222), b2222));
var reduceRight2 = /* @__PURE__ */ dual222(3, (self2, b2222, f2222) => fromIterable42(self2).reduceRight((b322, a2222, i2222) => f2222(b322, a2222, i2222), b2222));
var liftPredicate32 = (predicate) => (b2222) => predicate(b2222) ? [b2222] : [];
var liftOption2 = (f2222) => (...a2222) => fromOption22(f2222(...a2222));
var fromNullable32 = (a2222) => a2222 == null ? empty92() : [a2222];
var liftNullable32 = (f2222) => (...a2222) => fromNullable32(f2222(...a2222));
var flatMapNullable32 = /* @__PURE__ */ dual222(2, (self2, f2222) => flatMap32(self2, (a2222) => fromNullable32(f2222(a2222))));
var liftEither2 = (f2222) => (...a2222) => {
  const e2222 = f2222(...a2222);
  return isLeft32(e2222) ? [] : [e2222.right];
};
var every32 = /* @__PURE__ */ dual222(2, (self2, refinement) => self2.every(refinement));
var some72 = /* @__PURE__ */ dual222(2, (self2, predicate) => self2.some(predicate));
var extend2 = /* @__PURE__ */ dual222(2, (self2, f2222) => self2.map((_2222, i2222, as422) => f2222(as422.slice(i2222))));
var min22 = /* @__PURE__ */ dual222(2, (self2, O2222) => self2.reduce(min3(O2222)));
var max22 = /* @__PURE__ */ dual222(2, (self2, O2222) => self2.reduce(max3(O2222)));
var unfold2 = (b2222, f2222) => {
  const out = [];
  let next = b2222;
  let o2222;
  while (isSome42(o2222 = f2222(next))) {
    const [a2222, b322] = o2222.value;
    out.push(a2222);
    next = b322;
  }
  return out;
};
var getOrder32 = array42;
var getEquivalence42 = array322;
var forEach322 = /* @__PURE__ */ dual222(2, (self2, f2222) => fromIterable42(self2).forEach((a2222, i2222) => f2222(a2222, i2222)));
var dedupeWith2 = /* @__PURE__ */ dual222(2, (self2, isEquivalent) => {
  const input = fromIterable42(self2);
  if (isNonEmptyReadonlyArray2(input)) {
    const out = [headNonEmpty222(input)];
    const rest = tailNonEmpty222(input);
    for (const r2222 of rest) {
      if (out.every((a2222) => !isEquivalent(r2222, a2222))) {
        out.push(r2222);
      }
    }
    return out;
  }
  return [];
});
var dedupe2 = (self2) => dedupeWith2(self2, equivalence222());
var dedupeAdjacentWith2 = /* @__PURE__ */ dual222(2, (self2, isEquivalent) => {
  const out = [];
  let lastA = none42();
  for (const a2222 of self2) {
    if (isNone42(lastA) || !isEquivalent(a2222, lastA.value)) {
      out.push(a2222);
      lastA = some62(a2222);
    }
  }
  return out;
});
var dedupeAdjacent2 = /* @__PURE__ */ dedupeAdjacentWith2(/* @__PURE__ */ equivalence222());
var join22 = /* @__PURE__ */ dual222(2, (self2, sep2) => fromIterable42(self2).join(sep2));
var mapAccum2 = /* @__PURE__ */ dual222(3, (self2, s2222, f2222) => {
  let i2222 = 0;
  let s1 = s2222;
  const out = [];
  for (const a2222 of self2) {
    const r2222 = f2222(s1, a2222, i2222);
    s1 = r2222[0];
    out.push(r2222[1]);
    i2222++;
  }
  return [s1, out];
});
var cartesianWith2 = /* @__PURE__ */ dual222(3, (self2, that, f2222) => flatMap32(self2, (a2222) => map32(that, (b2222) => f2222(a2222, b2222))));
var cartesian2 = /* @__PURE__ */ dual222(2, (self2, that) => cartesianWith2(self2, that, (a2222, b2222) => [a2222, b2222]));
var Do32 = /* @__PURE__ */ of222({});
var bind52 = /* @__PURE__ */ bind322(map32, flatMap32);
var bindTo52 = /* @__PURE__ */ bindTo322(map32);
var let_52 = /* @__PURE__ */ let_322(map32);
var __defProp322 = Object.defineProperty;
var __export322 = (target, all32222) => {
  for (var name22 in all32222)
    __defProp322(target, name22, { get: all32222[name22], enumerable: true });
};
var Function_exports32 = {};
__export322(Function_exports32, {
  SK: () => SK32,
  absurd: () => absurd32,
  apply: () => apply32,
  compose: () => compose52,
  constFalse: () => constFalse32,
  constNull: () => constNull32,
  constTrue: () => constTrue32,
  constUndefined: () => constUndefined32,
  constVoid: () => constVoid32,
  constant: () => constant32,
  dual: () => dual32,
  flip: () => flip32,
  flow: () => flow32,
  hole: () => hole32,
  identity: () => identity32,
  isFunction: () => isFunction62,
  pipe: () => pipe32,
  satisfies: () => satisfies32,
  tupled: () => tupled32,
  unsafeCoerce: () => unsafeCoerce32,
  untupled: () => untupled32
});
var isFunction62 = (input) => typeof input === "function";
var dual32 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a2222, b2222) {
        if (arguments.length >= 2) {
          return body(a2222, b2222);
        }
        return function(self2) {
          return body(self2, a2222);
        };
      };
    case 3:
      return function(a2222, b2222, c2222) {
        if (arguments.length >= 3) {
          return body(a2222, b2222, c2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222);
        };
      };
    case 4:
      return function(a2222, b2222, c2222, d2222) {
        if (arguments.length >= 4) {
          return body(a2222, b2222, c2222, d2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222);
        };
      };
    case 5:
      return function(a2222, b2222, c2222, d2222, e2222) {
        if (arguments.length >= 5) {
          return body(a2222, b2222, c2222, d2222, e2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222, d2222);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply32 = (a2222) => (self2) => self2(a2222);
var identity32 = (a2222) => a2222;
var satisfies32 = () => (b2222) => b2222;
var unsafeCoerce32 = identity32;
var constant32 = (value) => () => value;
var constTrue32 = /* @__PURE__ */ constant32(true);
var constFalse32 = /* @__PURE__ */ constant32(false);
var constNull32 = /* @__PURE__ */ constant32(null);
var constUndefined32 = /* @__PURE__ */ constant32(void 0);
var constVoid32 = constUndefined32;
var flip32 = (f2222) => (...b2222) => (...a2222) => f2222(...a2222)(...b2222);
var compose52 = /* @__PURE__ */ dual32(2, (ab, bc) => (a2222) => bc(ab(a2222)));
var absurd32 = (_2222) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled32 = (f2222) => (a2222) => f2222(...a2222);
var untupled32 = (f2222) => (...a2222) => f2222(a2222);
function pipe32(a2222, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a2222;
    case 2:
      return ab(a2222);
    case 3:
      return bc(ab(a2222));
    case 4:
      return cd(bc(ab(a2222)));
    case 5:
      return de(cd(bc(ab(a2222))));
    case 6:
      return ef(de(cd(bc(ab(a2222)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a2222))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a2222)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a2222))))))));
    default: {
      let ret = arguments[0];
      for (let i2222 = 1; i2222 < arguments.length; i2222++) {
        ret = arguments[i2222](ret);
      }
      return ret;
    }
  }
}
function flow32(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole32 = /* @__PURE__ */ unsafeCoerce32(absurd32);
var SK32 = (_2222, b2222) => b2222;
var make112 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_62 = (map3222) => dual32(3, (self2, name22, f2222) => map3222(self2, (a2222) => Object.assign({}, a2222, {
  [name22]: f2222(a2222)
})));
var bindTo62 = (map3222) => dual32(2, (self2, name22) => map3222(self2, (a2222) => ({
  [name22]: a2222
})));
var bind62 = (map3222, flatMap3222) => dual32(3, (self2, name22, f2222) => flatMap3222(self2, (a2222) => map3222(f2222(a2222), (b2222) => Object.assign({}, a2222, {
  [name22]: b2222
}))));
var moduleVersion32 = "3.2.8";
var getCurrentVersion32 = () => moduleVersion32;
var globalStoreId32 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion32()}`);
if (!(globalStoreId32 in globalThis)) {
  globalThis[globalStoreId32] = /* @__PURE__ */ new Map();
}
var globalStore32 = globalThis[globalStoreId32];
var globalValue32 = (id, compute) => {
  if (!globalStore32.has(id)) {
    globalStore32.set(id, compute());
  }
  return globalStore32.get(id);
};
var isFunction2222 = isFunction62;
var isRecordOrArray32 = (input) => typeof input === "object" && input !== null;
var isObject32 = (input) => isRecordOrArray32(input) || isFunction2222(input);
var hasProperty32 = /* @__PURE__ */ dual32(2, (self2, property) => isObject32(self2) && property in self2);
var isNullable32 = (input) => input === null || input === void 0;
var getBugErrorMessage32 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId32 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind32 = (u2222) => isObject32(u2222) && GenKindTypeId32 in u2222;
var GenKindImpl32 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity32;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId32] = GenKindTypeId32;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen42(this);
  }
};
var SingleShotGen42 = class _SingleShotGen322 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a2222) {
    return this.called ? {
      value: a2222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a2222) {
    return {
      value: a2222,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e2222) {
    throw e2222;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen322(this.self);
  }
};
var adapter52 = () => function() {
  let x2222 = arguments[0];
  for (let i2222 = 1; i2222 < arguments.length; i2222++) {
    x2222 = arguments[i2222](x2222);
  }
  return new GenKindImpl32(x2222);
};
var defaultIncHi32 = 335903614;
var defaultIncLo32 = 4150755663;
var MUL_HI32 = 1481765933 >>> 0;
var MUL_LO32 = 1284865837 >>> 0;
var BIT_5332 = 9007199254740992;
var BIT_2732 = 134217728;
var PCGRandom32 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable32(seedLo) && isNullable32(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable32(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable32(incLo) && isNullable32(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo32;
      incHi = this._state ? this._state[2] : defaultIncHi32;
    } else if (isNullable32(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add6432(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max322) {
    if (!max322) {
      return this._next();
    }
    max322 = max322 >>> 0;
    if ((max322 & max322 - 1) === 0) {
      return this._next() & max322 - 1;
    }
    let num = 0;
    const skew = (-max322 >>> 0) % max322 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max322;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_2732 + lo) / BIT_5332;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul6432(this._state, oldHi, oldLo, MUL_HI32, MUL_LO32);
    add6432(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul6432(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add6432(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId32 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap32 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId32]() {
    return this.#value;
  }
};
function yieldWrapGet32(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId32 in self2) {
    return self2[YieldWrapTypeId32]();
  }
  throw new Error(getBugErrorMessage32("yieldWrapGet"));
}
var structuralRegionState32 = /* @__PURE__ */ globalValue32("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache32 = /* @__PURE__ */ globalValue32(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr32 = /* @__PURE__ */ globalValue32(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom32());
var symbol52 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash32 = (self2) => {
  if (structuralRegionState32.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number42(self2);
    case "bigint":
      return string32(self2.toString(10));
    case "boolean":
      return string32(String(self2));
    case "symbol":
      return string32(String(self2));
    case "string":
      return string32(self2);
    case "undefined":
      return string32("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string32("null");
      } else if (self2 instanceof Date) {
        return hash32(self2.toISOString());
      } else if (isHash32(self2)) {
        return self2[symbol52]();
      } else {
        return random32(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random32 = (self2) => {
  if (!randomHashCache32.has(self2)) {
    randomHashCache32.set(self2, number42(pcgr32.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache32.get(self2);
};
var combine42 = (b2222) => (self2) => self2 * 53 ^ b2222;
var optimize32 = (n2222) => n2222 & 3221225471 | n2222 >>> 1 & 1073741824;
var isHash32 = (u2222) => hasProperty32(u2222, symbol52);
var number42 = (n2222) => {
  if (n2222 !== n2222 || n2222 === Infinity) {
    return 0;
  }
  let h2222 = n2222 | 0;
  if (h2222 !== n2222) {
    h2222 ^= n2222 * 4294967295;
  }
  while (n2222 > 4294967295) {
    h2222 ^= n2222 /= 4294967295;
  }
  return optimize32(n2222);
};
var string32 = (str) => {
  let h2222 = 5381, i2222 = str.length;
  while (i2222) {
    h2222 = h2222 * 33 ^ str.charCodeAt(--i2222);
  }
  return optimize32(h2222);
};
var cached32 = function() {
  if (arguments.length === 1) {
    const self3 = arguments[0];
    return function(hash422) {
      Object.defineProperty(self3, symbol52, {
        value() {
          return hash422;
        },
        enumerable: false
      });
      return hash422;
    };
  }
  const self2 = arguments[0];
  const hash3222 = arguments[1];
  Object.defineProperty(self2, symbol52, {
    value() {
      return hash3222;
    },
    enumerable: false
  });
  return hash3222;
};
var symbol2222 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals32() {
  if (arguments.length === 1) {
    return (self2) => compareBoth32(self2, arguments[0]);
  }
  return compareBoth32(arguments[0], arguments[1]);
}
function compareBoth32(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual32(self2) && isEqual32(that)) {
        if (hash32(self2) === hash32(that) && self2[symbol2222](that)) {
          return true;
        } else {
          return structuralRegionState32.enabled && structuralRegionState32.tester ? structuralRegionState32.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState32.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v2222, i2222) => compareBoth32(v2222, that[i2222]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth32(self2[key], that[key]))) {
              return structuralRegionState32.tester ? structuralRegionState32.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState32.tester ? structuralRegionState32.tester(self2, that) : false;
    }
  }
  return structuralRegionState32.enabled && structuralRegionState32.tester ? structuralRegionState32.tester(self2, that) : false;
}
var isEqual32 = (u2222) => hasProperty32(u2222, symbol2222);
var equivalence32 = () => equals32;
var NodeInspectSymbol32 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON32 = (x2222) => {
  if (hasProperty32(x2222, "toJSON") && isFunction2222(x2222["toJSON"]) && x2222["toJSON"].length === 0) {
    return x2222.toJSON();
  } else if (Array.isArray(x2222)) {
    return x2222.map(toJSON32);
  }
  return x2222;
};
var format32 = (x2222) => JSON.stringify(x2222, null, 2);
var pipeArguments32 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i2222 = 0, len = args.length; i2222 < len; i2222++) {
        ret = args[i2222](ret);
      }
      return ret;
    }
  }
};
var EffectTypeId42 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId32 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId32 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId32 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance32 = {
  /* c8 ignore next */
  _R: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _A: (_2222) => _2222,
  _V: /* @__PURE__ */ getCurrentVersion32()
};
var sinkVariance32 = {
  /* c8 ignore next */
  _A: (_2222) => _2222,
  /* c8 ignore next */
  _In: (_2222) => _2222,
  /* c8 ignore next */
  _L: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _R: (_2222) => _2222
};
var channelVariance32 = {
  /* c8 ignore next */
  _Env: (_2222) => _2222,
  /* c8 ignore next */
  _InErr: (_2222) => _2222,
  /* c8 ignore next */
  _InElem: (_2222) => _2222,
  /* c8 ignore next */
  _InDone: (_2222) => _2222,
  /* c8 ignore next */
  _OutErr: (_2222) => _2222,
  /* c8 ignore next */
  _OutElem: (_2222) => _2222,
  /* c8 ignore next */
  _OutDone: (_2222) => _2222
};
var EffectPrototype32 = {
  [EffectTypeId42]: effectVariance32,
  [StreamTypeId32]: effectVariance32,
  [SinkTypeId32]: sinkVariance32,
  [ChannelTypeId32]: channelVariance32,
  [symbol2222](that) {
    return this === that;
  },
  [symbol52]() {
    return cached32(this, random32(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen42(new YieldWrap32(this));
  },
  pipe() {
    return pipeArguments32(this, arguments);
  }
};
var TypeId92 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto52 = {
  ...EffectPrototype32,
  [TypeId92]: {
    _A: (_2222) => _2222
  },
  [NodeInspectSymbol32]() {
    return this.toJSON();
  },
  toString() {
    return format32(this.toJSON());
  }
};
var SomeProto32 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto52), {
  _tag: "Some",
  _op: "Some",
  [symbol2222](that) {
    return isOption52(that) && isSome52(that) && equals32(this.value, that.value);
  },
  [symbol52]() {
    return cached32(this, combine42(hash32(this._tag))(hash32(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON32(this.value)
    };
  }
});
var NoneHash32 = /* @__PURE__ */ hash32("None");
var NoneProto32 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto52), {
  _tag: "None",
  _op: "None",
  [symbol2222](that) {
    return isOption52(that) && isNone52(that);
  },
  [symbol52]() {
    return NoneHash32;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption52 = (input) => hasProperty32(input, TypeId92);
var isNone52 = (fa) => fa._tag === "None";
var isSome52 = (fa) => fa._tag === "Some";
var none52 = /* @__PURE__ */ Object.create(NoneProto32);
var some82 = (value) => {
  const a2222 = Object.create(SomeProto32);
  a2222.value = value;
  return a2222;
};
var TypeId2222 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto2222 = {
  ...EffectPrototype32,
  [TypeId2222]: {
    _R: (_2222) => _2222
  },
  [NodeInspectSymbol32]() {
    return this.toJSON();
  },
  toString() {
    return format32(this.toJSON());
  }
};
var RightProto32 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto2222), {
  _tag: "Right",
  _op: "Right",
  [symbol2222](that) {
    return isEither32(that) && isRight42(that) && equals32(this.right, that.right);
  },
  [symbol52]() {
    return combine42(hash32(this._tag))(hash32(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON32(this.right)
    };
  }
});
var LeftProto32 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto2222), {
  _tag: "Left",
  _op: "Left",
  [symbol2222](that) {
    return isEither32(that) && isLeft42(that) && equals32(this.left, that.left);
  },
  [symbol52]() {
    return combine42(hash32(this._tag))(hash32(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON32(this.left)
    };
  }
});
var isEither32 = (input) => hasProperty32(input, TypeId2222);
var isLeft42 = (ma) => ma._tag === "Left";
var isRight42 = (ma) => ma._tag === "Right";
var left42 = (left32222) => {
  const a2222 = Object.create(LeftProto32);
  a2222.left = left32222;
  return a2222;
};
var right42 = (right32222) => {
  const a2222 = Object.create(RightProto32);
  a2222.right = right32222;
  return a2222;
};
var getLeft52 = (self2) => isRight42(self2) ? none52 : some82(self2.left);
var getRight52 = (self2) => isLeft42(self2) ? none52 : some82(self2.right);
var Option_exports32 = {};
__export322(Option_exports32, {
  Do: () => Do42,
  TypeId: () => TypeId3222,
  all: () => all52,
  andThen: () => andThen32,
  ap: () => ap32,
  as: () => as32,
  asVoid: () => asVoid32,
  bind: () => bind2222,
  bindTo: () => bindTo2222,
  composeK: () => composeK32,
  contains: () => contains42,
  containsWith: () => containsWith42,
  exists: () => exists32,
  filter: () => filter42,
  filterMap: () => filterMap42,
  firstSomeOf: () => firstSomeOf32,
  flatMap: () => flatMap42,
  flatMapNullable: () => flatMapNullable42,
  flatten: () => flatten42,
  fromIterable: () => fromIterable52,
  fromNullable: () => fromNullable42,
  gen: () => gen32,
  getEquivalence: () => getEquivalence52,
  getLeft: () => getLeft2222,
  getOrElse: () => getOrElse32,
  getOrNull: () => getOrNull32,
  getOrThrow: () => getOrThrow32,
  getOrThrowWith: () => getOrThrowWith32,
  getOrUndefined: () => getOrUndefined32,
  getOrder: () => getOrder42,
  getRight: () => getRight2222,
  isNone: () => isNone2222,
  isOption: () => isOption2222,
  isSome: () => isSome2222,
  let: () => let_2222,
  lift2: () => lift232,
  liftNullable: () => liftNullable42,
  liftPredicate: () => liftPredicate42,
  liftThrowable: () => liftThrowable32,
  map: () => map42,
  match: () => match52,
  none: () => none2222,
  orElse: () => orElse32,
  orElseEither: () => orElseEither32,
  orElseSome: () => orElseSome32,
  partitionMap: () => partitionMap42,
  product: () => product52,
  productMany: () => productMany52,
  reduceCompact: () => reduceCompact32,
  some: () => some2222,
  tap: () => tap32,
  toArray: () => toArray32,
  toRefinement: () => toRefinement32,
  void: () => void_32,
  zipLeft: () => zipLeft32,
  zipRight: () => zipRight32,
  zipWith: () => zipWith42
});
var make2222 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId3222 = /* @__PURE__ */ Symbol.for("effect/Option");
var none2222 = () => none52;
var some2222 = some82;
var isOption2222 = isOption52;
var isNone2222 = isNone52;
var isSome2222 = isSome52;
var match52 = /* @__PURE__ */ dual32(2, (self2, {
  onNone,
  onSome
}) => isNone2222(self2) ? onNone() : onSome(self2.value));
var toRefinement32 = (f2222) => (a2222) => isSome2222(f2222(a2222));
var fromIterable52 = (collection) => {
  for (const a2222 of collection) {
    return some2222(a2222);
  }
  return none2222();
};
var getRight2222 = getRight52;
var getLeft2222 = getLeft52;
var getOrElse32 = /* @__PURE__ */ dual32(2, (self2, onNone) => isNone2222(self2) ? onNone() : self2.value);
var orElse32 = /* @__PURE__ */ dual32(2, (self2, that) => isNone2222(self2) ? that() : self2);
var orElseSome32 = /* @__PURE__ */ dual32(2, (self2, onNone) => isNone2222(self2) ? some2222(onNone()) : self2);
var orElseEither32 = /* @__PURE__ */ dual32(2, (self2, that) => isNone2222(self2) ? map42(that(), right42) : map42(self2, left42));
var firstSomeOf32 = (collection) => {
  let out = none2222();
  for (out of collection) {
    if (isSome2222(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable42 = (nullableValue) => nullableValue == null ? none2222() : some2222(nullableValue);
var liftNullable42 = (f2222) => (...a2222) => fromNullable42(f2222(...a2222));
var getOrNull32 = /* @__PURE__ */ getOrElse32(constNull32);
var getOrUndefined32 = /* @__PURE__ */ getOrElse32(constUndefined32);
var liftThrowable32 = (f2222) => (...a2222) => {
  try {
    return some2222(f2222(...a2222));
  } catch (e2222) {
    return none2222();
  }
};
var getOrThrowWith32 = /* @__PURE__ */ dual32(2, (self2, onNone) => {
  if (isSome2222(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow32 = /* @__PURE__ */ getOrThrowWith32(() => new Error("getOrThrow called on a None"));
var map42 = /* @__PURE__ */ dual32(2, (self2, f2222) => isNone2222(self2) ? none2222() : some2222(f2222(self2.value)));
var as32 = /* @__PURE__ */ dual32(2, (self2, b2222) => map42(self2, () => b2222));
var asVoid32 = /* @__PURE__ */ as32(void 0);
var void_32 = /* @__PURE__ */ some2222(void 0);
var flatMap42 = /* @__PURE__ */ dual32(2, (self2, f2222) => isNone2222(self2) ? none2222() : f2222(self2.value));
var andThen32 = /* @__PURE__ */ dual32(2, (self2, f2222) => flatMap42(self2, (a2222) => {
  const b2222 = isFunction62(f2222) ? f2222(a2222) : f2222;
  return isOption2222(b2222) ? b2222 : some2222(b2222);
}));
var flatMapNullable42 = /* @__PURE__ */ dual32(2, (self2, f2222) => isNone2222(self2) ? none2222() : fromNullable42(f2222(self2.value)));
var flatten42 = /* @__PURE__ */ flatMap42(identity32);
var zipRight32 = /* @__PURE__ */ dual32(2, (self2, that) => flatMap42(self2, () => that));
var composeK32 = /* @__PURE__ */ dual32(2, (afb, bfc) => (a2222) => flatMap42(afb(a2222), bfc));
var zipLeft32 = /* @__PURE__ */ dual32(2, (self2, that) => tap32(self2, () => that));
var tap32 = /* @__PURE__ */ dual32(2, (self2, f2222) => flatMap42(self2, (a2222) => map42(f2222(a2222), () => a2222)));
var product52 = (self2, that) => isSome2222(self2) && isSome2222(that) ? some2222([self2.value, that.value]) : none2222();
var productMany52 = (self2, collection) => {
  if (isNone2222(self2)) {
    return none2222();
  }
  const out = [self2.value];
  for (const o2222 of collection) {
    if (isNone2222(o2222)) {
      return none2222();
    }
    out.push(o2222.value);
  }
  return some2222(out);
};
var all52 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o2222 of input) {
      if (isNone2222(o2222)) {
        return none2222();
      }
      out2.push(o2222.value);
    }
    return some2222(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o2222 = input[key];
    if (isNone2222(o2222)) {
      return none2222();
    }
    out[key] = o2222.value;
  }
  return some2222(out);
};
var zipWith42 = /* @__PURE__ */ dual32(3, (self2, that, f2222) => map42(product52(self2, that), ([a2222, b2222]) => f2222(a2222, b2222)));
var ap32 = /* @__PURE__ */ dual32(2, (self2, that) => zipWith42(self2, that, (f2222, a2222) => f2222(a2222)));
var reduceCompact32 = /* @__PURE__ */ dual32(3, (self2, b2222, f2222) => {
  let out = b2222;
  for (const oa of self2) {
    if (isSome2222(oa)) {
      out = f2222(out, oa.value);
    }
  }
  return out;
});
var toArray32 = (self2) => isNone2222(self2) ? [] : [self2.value];
var partitionMap42 = /* @__PURE__ */ dual32(2, (self2, f2222) => {
  if (isNone2222(self2)) {
    return [none2222(), none2222()];
  }
  const e2222 = f2222(self2.value);
  return isLeft42(e2222) ? [some2222(e2222.left), none2222()] : [none2222(), some2222(e2222.right)];
});
var filterMap42 = /* @__PURE__ */ dual32(2, (self2, f2222) => isNone2222(self2) ? none2222() : f2222(self2.value));
var filter42 = /* @__PURE__ */ dual32(2, (self2, predicate) => filterMap42(self2, (b2222) => predicate(b2222) ? some82(b2222) : none52));
var getEquivalence52 = (isEquivalent) => make112((x2222, y2222) => x2222 === y2222 || (isNone2222(x2222) ? isNone2222(y2222) : isNone2222(y2222) ? false : isEquivalent(x2222.value, y2222.value)));
var getOrder42 = (O2222) => make2222((self2, that) => isSome2222(self2) ? isSome2222(that) ? O2222(self2.value, that.value) : 1 : -1);
var lift232 = (f2222) => dual32(2, (self2, that) => zipWith42(self2, that, f2222));
var liftPredicate42 = (predicate) => (b2222) => predicate(b2222) ? some2222(b2222) : none2222();
var containsWith42 = (isEquivalent) => dual32(2, (self2, a2222) => isNone2222(self2) ? false : isEquivalent(self2.value, a2222));
var _equivalence52 = /* @__PURE__ */ equivalence32();
var contains42 = /* @__PURE__ */ containsWith42(_equivalence52);
var exists32 = /* @__PURE__ */ dual32(2, (self2, refinement) => isNone2222(self2) ? false : refinement(self2.value));
var bindTo2222 = /* @__PURE__ */ bindTo62(map42);
var let_2222 = /* @__PURE__ */ let_62(map42);
var bind2222 = /* @__PURE__ */ bind62(map42, flatMap42);
var Do42 = /* @__PURE__ */ some2222({});
var adapter2222 = /* @__PURE__ */ adapter52();
var gen32 = (f2222) => {
  const iterator = f2222(adapter2222);
  let state = iterator.next();
  if (state.done) {
    return some2222(state.value);
  } else {
    let current = state.value;
    if (isGenKind32(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet32(current);
    }
    if (isNone2222(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind32(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet32(current);
        }
        if (isNone2222(current)) {
          return current;
        }
      }
    }
    return some2222(state.value);
  }
};
var MutableRef_exports22 = {};
__export322(MutableRef_exports22, {
  compareAndSet: () => compareAndSet2,
  decrement: () => decrement2,
  decrementAndGet: () => decrementAndGet2,
  get: () => get22,
  getAndDecrement: () => getAndDecrement2,
  getAndIncrement: () => getAndIncrement2,
  getAndSet: () => getAndSet2,
  getAndUpdate: () => getAndUpdate2,
  increment: () => increment2,
  incrementAndGet: () => incrementAndGet2,
  make: () => make3222,
  set: () => set222,
  setAndGet: () => setAndGet2,
  toggle: () => toggle2,
  update: () => update2,
  updateAndGet: () => updateAndGet2
});
var TypeId4222 = /* @__PURE__ */ Symbol.for("effect/MutableRef");
var MutableRefProto2 = {
  [TypeId4222]: TypeId4222,
  toString() {
    return format32(this.toJSON());
  },
  toJSON() {
    return {
      _id: "MutableRef",
      current: toJSON32(this.current)
    };
  },
  [NodeInspectSymbol32]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments32(this, arguments);
  }
};
var make3222 = (value) => {
  const ref = Object.create(MutableRefProto2);
  ref.current = value;
  return ref;
};
var compareAndSet2 = /* @__PURE__ */ dual32(3, (self2, oldValue, newValue) => {
  if (equals32(oldValue, self2.current)) {
    self2.current = newValue;
    return true;
  }
  return false;
});
var decrement2 = (self2) => update2(self2, (n2222) => n2222 - 1);
var decrementAndGet2 = (self2) => updateAndGet2(self2, (n2222) => n2222 - 1);
var get22 = (self2) => self2.current;
var getAndDecrement2 = (self2) => getAndUpdate2(self2, (n2222) => n2222 - 1);
var getAndIncrement2 = (self2) => getAndUpdate2(self2, (n2222) => n2222 + 1);
var getAndSet2 = /* @__PURE__ */ dual32(2, (self2, value) => {
  const ret = self2.current;
  self2.current = value;
  return ret;
});
var getAndUpdate2 = /* @__PURE__ */ dual32(2, (self2, f2222) => getAndSet2(self2, f2222(get22(self2))));
var increment2 = (self2) => update2(self2, (n2222) => n2222 + 1);
var incrementAndGet2 = (self2) => updateAndGet2(self2, (n2222) => n2222 + 1);
var set222 = /* @__PURE__ */ dual32(2, (self2, value) => {
  self2.current = value;
  return self2;
});
var setAndGet2 = /* @__PURE__ */ dual32(2, (self2, value) => {
  self2.current = value;
  return self2.current;
});
var update2 = /* @__PURE__ */ dual32(2, (self2, f2222) => set222(self2, f2222(get22(self2))));
var updateAndGet2 = /* @__PURE__ */ dual32(2, (self2, f2222) => setAndGet2(self2, f2222(get22(self2))));
var toggle2 = (self2) => update2(self2, (_2222) => !_2222);
function getVariables2(initialScope) {
  const scopeRef = MutableRef_exports22.make(initialScope);
  const variablesRef = MutableRef_exports22.make(MutableRef_exports22.get(scopeRef).variables);
  while (MutableRef_exports22.get(scopeRef).type !== scopeManager.ScopeType.global) {
    MutableRef_exports22.set(scopeRef, MutableRef_exports22.get(scopeRef).upper);
    MutableRef_exports22.update(variablesRef, (variables) => variables.concat(MutableRef_exports22.get(scopeRef).variables));
  }
  return MutableRef_exports22.get(variablesRef).reverse();
}
var findVariable222 = Function_exports32.dual(2, (name22, initialScope) => {
  return Option_exports32.fromNullable(getVariables2(initialScope).find((variable) => variable.name === name22));
});
var t3 = Symbol.for("@ts-pattern/matcher");
var e3 = Symbol.for("@ts-pattern/isVariadic");
var n3 = "@ts-pattern/anonymous-select-key";
var r3 = (t2222) => Boolean(t2222 && "object" == typeof t2222);
var i3 = (e2222) => e2222 && !!e2222[t3];
var o3 = (n2222, s2222, c2222) => {
  if (i3(n2222)) {
    const e2222 = n2222[t3](), { matched: r2222, selections: i2222 } = e2222.match(s2222);
    return r2222 && i2222 && Object.keys(i2222).forEach((t2222) => c2222(t2222, i2222[t2222])), r2222;
  }
  if (r3(n2222)) {
    if (!r3(s2222)) return false;
    if (Array.isArray(n2222)) {
      if (!Array.isArray(s2222)) return false;
      let t2222 = [], r2222 = [], a2222 = [];
      for (const o2222 of n2222.keys()) {
        const s322 = n2222[o2222];
        i3(s322) && s322[e3] ? a2222.push(s322) : a2222.length ? r2222.push(s322) : t2222.push(s322);
      }
      if (a2222.length) {
        if (a2222.length > 1) throw new Error("Pattern error: Using `...P.array(...)` several times in a single pattern is not allowed.");
        if (s2222.length < t2222.length + r2222.length) return false;
        const e2222 = s2222.slice(0, t2222.length), n322 = 0 === r2222.length ? [] : s2222.slice(-r2222.length), i2222 = s2222.slice(t2222.length, 0 === r2222.length ? Infinity : -r2222.length);
        return t2222.every((t322, n422) => o3(t322, e2222[n422], c2222)) && r2222.every((t322, e322) => o3(t322, n322[e322], c2222)) && (0 === a2222.length || o3(a2222[0], i2222, c2222));
      }
      return n2222.length === s2222.length && n2222.every((t322, e2222) => o3(t322, s2222[e2222], c2222));
    }
    return Object.keys(n2222).every((e2222) => {
      const r2222 = n2222[e2222];
      return (e2222 in s2222 || i3(a2222 = r2222) && "optional" === a2222[t3]().matcherType) && o3(r2222, s2222[e2222], c2222);
      var a2222;
    });
  }
  return Object.is(s2222, n2222);
};
var s3 = (e2222) => {
  var n2222, o2222, a2222;
  return r3(e2222) ? i3(e2222) ? null != (n2222 = null == (o2222 = (a2222 = e2222[t3]()).getSelectionKeys) ? void 0 : o2222.call(a2222)) ? n2222 : [] : Array.isArray(e2222) ? c3(e2222, s3) : c3(Object.values(e2222), s3) : [];
};
var c3 = (t2222, e2222) => t2222.reduce((t322, n2222) => t322.concat(e2222(n2222)), []);
function a3(...t2222) {
  if (1 === t2222.length) {
    const [e2222] = t2222;
    return (t322) => o3(e2222, t322, () => {
    });
  }
  if (2 === t2222.length) {
    const [e2222, n2222] = t2222;
    return o3(e2222, n2222, () => {
    });
  }
  throw new Error(`isMatching wasn't given the right number of arguments: expected 1 or 2, received ${t2222.length}.`);
}
function u3(t2222) {
  return Object.assign(t2222, { optional: () => l3(t2222), and: (e2222) => m3(t2222, e2222), or: (e2222) => d3(t2222, e2222), select: (e2222) => void 0 === e2222 ? p3(t2222) : p3(e2222, t2222) });
}
function h3(t2222) {
  return Object.assign(((t322) => Object.assign(t322, { [Symbol.iterator]() {
    let n2222 = 0;
    const r2222 = [{ value: Object.assign(t322, { [e3]: true }), done: false }, { done: true, value: void 0 }];
    return { next: () => {
      var t422;
      return null != (t422 = r2222[n2222++]) ? t422 : r2222.at(-1);
    } };
  } }))(t2222), { optional: () => h3(l3(t2222)), select: (e2222) => h3(void 0 === e2222 ? p3(t2222) : p3(e2222, t2222)) });
}
function l3(e2222) {
  return u3({ [t3]: () => ({ match: (t2222) => {
    let n2222 = {};
    const r2222 = (t322, e322) => {
      n2222[t322] = e322;
    };
    return void 0 === t2222 ? (s3(e2222).forEach((t322) => r2222(t322, void 0)), { matched: true, selections: n2222 }) : { matched: o3(e2222, t2222, r2222), selections: n2222 };
  }, getSelectionKeys: () => s3(e2222), matcherType: "optional" }) });
}
var f3 = (t2222, e2222) => {
  for (const n2222 of t2222) if (!e2222(n2222)) return false;
  return true;
};
var g3 = (t2222, e2222) => {
  for (const [n2222, r2222] of t2222.entries()) if (!e2222(r2222, n2222)) return false;
  return true;
};
function m3(...e2222) {
  return u3({ [t3]: () => ({ match: (t2222) => {
    let n2222 = {};
    const r2222 = (t322, e322) => {
      n2222[t322] = e322;
    };
    return { matched: e2222.every((e322) => o3(e322, t2222, r2222)), selections: n2222 };
  }, getSelectionKeys: () => c3(e2222, s3), matcherType: "and" }) });
}
function d3(...e2222) {
  return u3({ [t3]: () => ({ match: (t2222) => {
    let n2222 = {};
    const r2222 = (t322, e322) => {
      n2222[t322] = e322;
    };
    return c3(e2222, s3).forEach((t322) => r2222(t322, void 0)), { matched: e2222.some((e322) => o3(e322, t2222, r2222)), selections: n2222 };
  }, getSelectionKeys: () => c3(e2222, s3), matcherType: "or" }) });
}
function y3(e2222) {
  return { [t3]: () => ({ match: (t2222) => ({ matched: Boolean(e2222(t2222)) }) }) };
}
function p3(...e2222) {
  const r2222 = "string" == typeof e2222[0] ? e2222[0] : void 0, i2222 = 2 === e2222.length ? e2222[1] : "string" == typeof e2222[0] ? void 0 : e2222[0];
  return u3({ [t3]: () => ({ match: (t2222) => {
    let e322 = { [null != r2222 ? r2222 : n3]: t2222 };
    return { matched: void 0 === i2222 || o3(i2222, t2222, (t322, n2222) => {
      e322[t322] = n2222;
    }), selections: e322 };
  }, getSelectionKeys: () => [null != r2222 ? r2222 : n3].concat(void 0 === i2222 ? [] : s3(i2222)) }) });
}
function v3(t2222) {
  return "number" == typeof t2222;
}
function b3(t2222) {
  return "string" == typeof t2222;
}
function w3(t2222) {
  return "bigint" == typeof t2222;
}
var S3 = u3(y3(function(t2222) {
  return true;
}));
var O3 = S3;
var j3 = (t2222) => Object.assign(u3(t2222), { startsWith: (e2222) => {
  return j3(m3(t2222, (n2222 = e2222, y3((t322) => b3(t322) && t322.startsWith(n2222)))));
  var n2222;
}, endsWith: (e2222) => {
  return j3(m3(t2222, (n2222 = e2222, y3((t322) => b3(t322) && t322.endsWith(n2222)))));
  var n2222;
}, minLength: (e2222) => j3(m3(t2222, ((t322) => y3((e322) => b3(e322) && e322.length >= t322))(e2222))), maxLength: (e2222) => j3(m3(t2222, ((t322) => y3((e322) => b3(e322) && e322.length <= t322))(e2222))), includes: (e2222) => {
  return j3(m3(t2222, (n2222 = e2222, y3((t322) => b3(t322) && t322.includes(n2222)))));
  var n2222;
}, regex: (e2222) => {
  return j3(m3(t2222, (n2222 = e2222, y3((t322) => b3(t322) && Boolean(t322.match(n2222))))));
  var n2222;
} });
var E3 = j3(y3(b3));
var K3 = (t2222) => Object.assign(u3(t2222), { between: (e2222, n2222) => K3(m3(t2222, ((t322, e322) => y3((n322) => v3(n322) && t322 <= n322 && e322 >= n322))(e2222, n2222))), lt: (e2222) => K3(m3(t2222, ((t322) => y3((e322) => v3(e322) && e322 < t322))(e2222))), gt: (e2222) => K3(m3(t2222, ((t322) => y3((e322) => v3(e322) && e322 > t322))(e2222))), lte: (e2222) => K3(m3(t2222, ((t322) => y3((e322) => v3(e322) && e322 <= t322))(e2222))), gte: (e2222) => K3(m3(t2222, ((t322) => y3((e322) => v3(e322) && e322 >= t322))(e2222))), int: () => K3(m3(t2222, y3((t322) => v3(t322) && Number.isInteger(t322)))), finite: () => K3(m3(t2222, y3((t322) => v3(t322) && Number.isFinite(t322)))), positive: () => K3(m3(t2222, y3((t322) => v3(t322) && t322 > 0))), negative: () => K3(m3(t2222, y3((t322) => v3(t322) && t322 < 0))) });
var x3 = K3(y3(v3));
var A3 = (t2222) => Object.assign(u3(t2222), { between: (e2222, n2222) => A3(m3(t2222, ((t322, e322) => y3((n322) => w3(n322) && t322 <= n322 && e322 >= n322))(e2222, n2222))), lt: (e2222) => A3(m3(t2222, ((t322) => y3((e322) => w3(e322) && e322 < t322))(e2222))), gt: (e2222) => A3(m3(t2222, ((t322) => y3((e322) => w3(e322) && e322 > t322))(e2222))), lte: (e2222) => A3(m3(t2222, ((t322) => y3((e322) => w3(e322) && e322 <= t322))(e2222))), gte: (e2222) => A3(m3(t2222, ((t322) => y3((e322) => w3(e322) && e322 >= t322))(e2222))), positive: () => A3(m3(t2222, y3((t322) => w3(t322) && t322 > 0))), negative: () => A3(m3(t2222, y3((t322) => w3(t322) && t322 < 0))) });
var P22 = A3(y3(w3));
var T3 = u3(y3(function(t2222) {
  return "boolean" == typeof t2222;
}));
var k3 = u3(y3(function(t2222) {
  return "symbol" == typeof t2222;
}));
var B3 = u3(y3(function(t2222) {
  return null == t2222;
}));
var _3 = u3(y3(function(t2222) {
  return null != t2222;
}));
var N3 = { __proto__: null, matcher: t3, optional: l3, array: function(...e2222) {
  return h3({ [t3]: () => ({ match: (t2222) => {
    if (!Array.isArray(t2222)) return { matched: false };
    if (0 === e2222.length) return { matched: true };
    const n2222 = e2222[0];
    let r2222 = {};
    if (0 === t2222.length) return s3(n2222).forEach((t322) => {
      r2222[t322] = [];
    }), { matched: true, selections: r2222 };
    const i2222 = (t322, e322) => {
      r2222[t322] = (r2222[t322] || []).concat([e322]);
    };
    return { matched: t2222.every((t322) => o3(n2222, t322, i2222)), selections: r2222 };
  }, getSelectionKeys: () => 0 === e2222.length ? [] : s3(e2222[0]) }) });
}, set: function(...e2222) {
  return u3({ [t3]: () => ({ match: (t2222) => {
    if (!(t2222 instanceof Set)) return { matched: false };
    let n2222 = {};
    if (0 === t2222.size) return { matched: true, selections: n2222 };
    if (0 === e2222.length) return { matched: true };
    const r2222 = (t322, e322) => {
      n2222[t322] = (n2222[t322] || []).concat([e322]);
    }, i2222 = e2222[0];
    return { matched: f3(t2222, (t322) => o3(i2222, t322, r2222)), selections: n2222 };
  }, getSelectionKeys: () => 0 === e2222.length ? [] : s3(e2222[0]) }) });
}, map: function(...e2222) {
  return u3({ [t3]: () => ({ match: (t2222) => {
    if (!(t2222 instanceof Map)) return { matched: false };
    let n2222 = {};
    if (0 === t2222.size) return { matched: true, selections: n2222 };
    const r2222 = (t322, e322) => {
      n2222[t322] = (n2222[t322] || []).concat([e322]);
    };
    if (0 === e2222.length) return { matched: true };
    var i2222;
    if (1 === e2222.length) throw new Error(`\`P.map\` wasn't given enough arguments. Expected (key, value), received ${null == (i2222 = e2222[0]) ? void 0 : i2222.toString()}`);
    const [s2222, c2222] = e2222;
    return { matched: g3(t2222, (t322, e322) => {
      const n322 = o3(s2222, e322, r2222), i322 = o3(c2222, t322, r2222);
      return n322 && i322;
    }), selections: n2222 };
  }, getSelectionKeys: () => 0 === e2222.length ? [] : [...s3(e2222[0]), ...s3(e2222[1])] }) });
}, intersection: m3, union: d3, not: function(e2222) {
  return u3({ [t3]: () => ({ match: (t2222) => ({ matched: !o3(e2222, t2222, () => {
  }) }), getSelectionKeys: () => [], matcherType: "not" }) });
}, when: y3, select: p3, any: S3, _: O3, string: E3, number: x3, bigint: P22, boolean: T3, symbol: k3, nullish: B3, nonNullable: _3, instanceOf: function(t2222) {
  return u3(y3(/* @__PURE__ */ function(t322) {
    return (e2222) => e2222 instanceof t322;
  }(t2222)));
}, shape: function(t2222) {
  return u3(y3(a3(t2222)));
} };
var KEYS222 = {
  ArrayExpression: [
    "elements"
  ],
  ArrayPattern: [
    "elements"
  ],
  ArrowFunctionExpression: [
    "params",
    "body"
  ],
  AssignmentExpression: [
    "left",
    "right"
  ],
  AssignmentPattern: [
    "left",
    "right"
  ],
  AwaitExpression: [
    "argument"
  ],
  BinaryExpression: [
    "left",
    "right"
  ],
  BlockStatement: [
    "body"
  ],
  BreakStatement: [
    "label"
  ],
  CallExpression: [
    "callee",
    "arguments"
  ],
  CatchClause: [
    "param",
    "body"
  ],
  ChainExpression: [
    "expression"
  ],
  ClassBody: [
    "body"
  ],
  ClassDeclaration: [
    "id",
    "superClass",
    "body"
  ],
  ClassExpression: [
    "id",
    "superClass",
    "body"
  ],
  ConditionalExpression: [
    "test",
    "consequent",
    "alternate"
  ],
  ContinueStatement: [
    "label"
  ],
  DebuggerStatement: [],
  DoWhileStatement: [
    "body",
    "test"
  ],
  EmptyStatement: [],
  ExperimentalRestProperty: [
    "argument"
  ],
  ExperimentalSpreadProperty: [
    "argument"
  ],
  ExportAllDeclaration: [
    "exported",
    "source"
  ],
  ExportDefaultDeclaration: [
    "declaration"
  ],
  ExportNamedDeclaration: [
    "declaration",
    "specifiers",
    "source"
  ],
  ExportSpecifier: [
    "exported",
    "local"
  ],
  ExpressionStatement: [
    "expression"
  ],
  ForInStatement: [
    "left",
    "right",
    "body"
  ],
  ForOfStatement: [
    "left",
    "right",
    "body"
  ],
  ForStatement: [
    "init",
    "test",
    "update",
    "body"
  ],
  FunctionDeclaration: [
    "id",
    "params",
    "body"
  ],
  FunctionExpression: [
    "id",
    "params",
    "body"
  ],
  Identifier: [],
  IfStatement: [
    "test",
    "consequent",
    "alternate"
  ],
  ImportDeclaration: [
    "specifiers",
    "source"
  ],
  ImportDefaultSpecifier: [
    "local"
  ],
  ImportExpression: [
    "source"
  ],
  ImportNamespaceSpecifier: [
    "local"
  ],
  ImportSpecifier: [
    "imported",
    "local"
  ],
  JSXAttribute: [
    "name",
    "value"
  ],
  JSXClosingElement: [
    "name"
  ],
  JSXClosingFragment: [],
  JSXElement: [
    "openingElement",
    "children",
    "closingElement"
  ],
  JSXEmptyExpression: [],
  JSXExpressionContainer: [
    "expression"
  ],
  JSXFragment: [
    "openingFragment",
    "children",
    "closingFragment"
  ],
  JSXIdentifier: [],
  JSXMemberExpression: [
    "object",
    "property"
  ],
  JSXNamespacedName: [
    "namespace",
    "name"
  ],
  JSXOpeningElement: [
    "name",
    "attributes"
  ],
  JSXOpeningFragment: [],
  JSXSpreadAttribute: [
    "argument"
  ],
  JSXSpreadChild: [
    "expression"
  ],
  JSXText: [],
  LabeledStatement: [
    "label",
    "body"
  ],
  Literal: [],
  LogicalExpression: [
    "left",
    "right"
  ],
  MemberExpression: [
    "object",
    "property"
  ],
  MetaProperty: [
    "meta",
    "property"
  ],
  MethodDefinition: [
    "key",
    "value"
  ],
  NewExpression: [
    "callee",
    "arguments"
  ],
  ObjectExpression: [
    "properties"
  ],
  ObjectPattern: [
    "properties"
  ],
  PrivateIdentifier: [],
  Program: [
    "body"
  ],
  Property: [
    "key",
    "value"
  ],
  PropertyDefinition: [
    "key",
    "value"
  ],
  RestElement: [
    "argument"
  ],
  ReturnStatement: [
    "argument"
  ],
  SequenceExpression: [
    "expressions"
  ],
  SpreadElement: [
    "argument"
  ],
  StaticBlock: [
    "body"
  ],
  Super: [],
  SwitchCase: [
    "test",
    "consequent"
  ],
  SwitchStatement: [
    "discriminant",
    "cases"
  ],
  TaggedTemplateExpression: [
    "tag",
    "quasi"
  ],
  TemplateElement: [],
  TemplateLiteral: [
    "quasis",
    "expressions"
  ],
  ThisExpression: [],
  ThrowStatement: [
    "argument"
  ],
  TryStatement: [
    "block",
    "handler",
    "finalizer"
  ],
  UnaryExpression: [
    "argument"
  ],
  UpdateExpression: [
    "argument"
  ],
  VariableDeclaration: [
    "declarations"
  ],
  VariableDeclarator: [
    "id",
    "init"
  ],
  WhileStatement: [
    "test",
    "body"
  ],
  WithStatement: [
    "object",
    "body"
  ],
  YieldExpression: [
    "argument"
  ]
};
var NODE_TYPES222 = Object.keys(KEYS222);
for (const type of NODE_TYPES222) {
  Object.freeze(KEYS222[type]);
}
Object.freeze(KEYS222);
var visitor_keys_default222 = KEYS222;
var KEY_BLACKLIST222 = /* @__PURE__ */ new Set([
  "parent",
  "leadingComments",
  "trailingComments"
]);
function filterKey222(key) {
  return !KEY_BLACKLIST222.has(key) && key[0] !== "_";
}
function getKeys222(node) {
  return Object.keys(node).filter(filterKey222);
}
function getInnermostScope222(initialScope, node) {
  const location = node.range[0];
  let scope = initialScope;
  let found = false;
  do {
    found = false;
    for (const childScope of scope.childScopes) {
      const range222 = childScope.block.range;
      if (range222[0] <= location && location < range222[1]) {
        scope = childScope;
        found = true;
        break;
      }
    }
  } while (found);
  return scope;
}
function findVariable2222(initialScope, nameOrNode) {
  let name22 = "";
  let scope = initialScope;
  if (typeof nameOrNode === "string") {
    name22 = nameOrNode;
  } else {
    name22 = nameOrNode.name;
    scope = getInnermostScope222(scope, nameOrNode);
  }
  while (scope != null) {
    const variable = scope.set.get(name22);
    if (variable != null) {
      return variable;
    }
    scope = scope.upper;
  }
  return null;
}
function negate0222(token) {
  return !this(token);
}
function negate222(f2222) {
  return negate0222.bind(f2222);
}
function isPunctuatorTokenWithValue222(token, value) {
  return token.type === "Punctuator" && token.value === value;
}
function isArrowToken222(token) {
  return isPunctuatorTokenWithValue222(token, "=>");
}
function isCommaToken222(token) {
  return isPunctuatorTokenWithValue222(token, ",");
}
function isSemicolonToken222(token) {
  return isPunctuatorTokenWithValue222(token, ";");
}
function isColonToken222(token) {
  return isPunctuatorTokenWithValue222(token, ":");
}
function isOpeningParenToken222(token) {
  return isPunctuatorTokenWithValue222(token, "(");
}
function isClosingParenToken222(token) {
  return isPunctuatorTokenWithValue222(token, ")");
}
function isOpeningBracketToken222(token) {
  return isPunctuatorTokenWithValue222(token, "[");
}
function isClosingBracketToken222(token) {
  return isPunctuatorTokenWithValue222(token, "]");
}
function isOpeningBraceToken222(token) {
  return isPunctuatorTokenWithValue222(token, "{");
}
function isClosingBraceToken222(token) {
  return isPunctuatorTokenWithValue222(token, "}");
}
function isCommentToken222(token) {
  return ["Block", "Line", "Shebang"].includes(token.type);
}
negate222(isArrowToken222);
negate222(isCommaToken222);
negate222(isSemicolonToken222);
negate222(isColonToken222);
negate222(isOpeningParenToken222);
negate222(isClosingParenToken222);
negate222(isOpeningBracketToken222);
negate222(isClosingBracketToken222);
negate222(isOpeningBraceToken222);
negate222(isClosingBraceToken222);
negate222(isCommentToken222);
function getOpeningParenOfParams222(node, sourceCode) {
  return node.id ? sourceCode.getTokenAfter(node.id, isOpeningParenToken222) : sourceCode.getFirstToken(node, isOpeningParenToken222);
}
function getFunctionHeadLocation222(node, sourceCode) {
  const parent = node.parent;
  let start = null;
  let end = null;
  if (node.type === "ArrowFunctionExpression") {
    const arrowToken = sourceCode.getTokenBefore(node.body, isArrowToken222);
    start = arrowToken.loc.start;
    end = arrowToken.loc.end;
  } else if (parent.type === "Property" || parent.type === "MethodDefinition" || parent.type === "PropertyDefinition") {
    start = parent.loc.start;
    end = getOpeningParenOfParams222(node, sourceCode).loc.start;
  } else {
    start = node.loc.start;
    end = getOpeningParenOfParams222(node, sourceCode).loc.start;
  }
  return {
    start: { ...start },
    end: { ...end }
  };
}
var globalObject222 = typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {};
var builtinNames222 = Object.freeze(
  /* @__PURE__ */ new Set([
    "Array",
    "ArrayBuffer",
    "BigInt",
    "BigInt64Array",
    "BigUint64Array",
    "Boolean",
    "DataView",
    "Date",
    "decodeURI",
    "decodeURIComponent",
    "encodeURI",
    "encodeURIComponent",
    "escape",
    "Float32Array",
    "Float64Array",
    "Function",
    "Infinity",
    "Int16Array",
    "Int32Array",
    "Int8Array",
    "isFinite",
    "isNaN",
    "isPrototypeOf",
    "JSON",
    "Map",
    "Math",
    "NaN",
    "Number",
    "Object",
    "parseFloat",
    "parseInt",
    "Promise",
    "Proxy",
    "Reflect",
    "RegExp",
    "Set",
    "String",
    "Symbol",
    "Uint16Array",
    "Uint32Array",
    "Uint8Array",
    "Uint8ClampedArray",
    "undefined",
    "unescape",
    "WeakMap",
    "WeakSet"
  ])
);
var callAllowed222 = new Set(
  [
    Array.isArray,
    Array.of,
    Array.prototype.at,
    Array.prototype.concat,
    Array.prototype.entries,
    Array.prototype.every,
    Array.prototype.filter,
    Array.prototype.find,
    Array.prototype.findIndex,
    Array.prototype.flat,
    Array.prototype.includes,
    Array.prototype.indexOf,
    Array.prototype.join,
    Array.prototype.keys,
    Array.prototype.lastIndexOf,
    Array.prototype.slice,
    Array.prototype.some,
    Array.prototype.toString,
    Array.prototype.values,
    typeof BigInt === "function" ? BigInt : void 0,
    Boolean,
    Date,
    Date.parse,
    decodeURI,
    decodeURIComponent,
    encodeURI,
    encodeURIComponent,
    escape,
    isFinite,
    isNaN,
    isPrototypeOf,
    Map,
    Map.prototype.entries,
    Map.prototype.get,
    Map.prototype.has,
    Map.prototype.keys,
    Map.prototype.values,
    ...Object.getOwnPropertyNames(Math).filter((k2222) => k2222 !== "random").map((k2222) => Math[k2222]).filter((f2222) => typeof f2222 === "function"),
    Number,
    Number.isFinite,
    Number.isNaN,
    Number.parseFloat,
    Number.parseInt,
    Number.prototype.toExponential,
    Number.prototype.toFixed,
    Number.prototype.toPrecision,
    Number.prototype.toString,
    Object,
    Object.entries,
    Object.is,
    Object.isExtensible,
    Object.isFrozen,
    Object.isSealed,
    Object.keys,
    Object.values,
    parseFloat,
    parseInt,
    RegExp,
    Set,
    Set.prototype.entries,
    Set.prototype.has,
    Set.prototype.keys,
    Set.prototype.values,
    String,
    String.fromCharCode,
    String.fromCodePoint,
    String.raw,
    String.prototype.at,
    String.prototype.charAt,
    String.prototype.charCodeAt,
    String.prototype.codePointAt,
    String.prototype.concat,
    String.prototype.endsWith,
    String.prototype.includes,
    String.prototype.indexOf,
    String.prototype.lastIndexOf,
    String.prototype.normalize,
    String.prototype.padEnd,
    String.prototype.padStart,
    String.prototype.slice,
    String.prototype.startsWith,
    String.prototype.substr,
    String.prototype.substring,
    String.prototype.toLowerCase,
    String.prototype.toString,
    String.prototype.toUpperCase,
    String.prototype.trim,
    String.prototype.trimEnd,
    String.prototype.trimLeft,
    String.prototype.trimRight,
    String.prototype.trimStart,
    Symbol.for,
    Symbol.keyFor,
    unescape
  ].filter((f2222) => typeof f2222 === "function")
);
var callPassThrough222 = /* @__PURE__ */ new Set([
  Object.freeze,
  Object.preventExtensions,
  Object.seal
]);
var getterAllowed222 = [
  [Map, /* @__PURE__ */ new Set(["size"])],
  [
    RegExp,
    /* @__PURE__ */ new Set([
      "dotAll",
      "flags",
      "global",
      "hasIndices",
      "ignoreCase",
      "multiline",
      "source",
      "sticky",
      "unicode"
    ])
  ],
  [Set, /* @__PURE__ */ new Set(["size"])]
];
function getPropertyDescriptor222(object222, name22) {
  let x2222 = object222;
  while ((typeof x2222 === "object" || typeof x2222 === "function") && x2222 !== null) {
    const d2222 = Object.getOwnPropertyDescriptor(x2222, name22);
    if (d2222) {
      return d2222;
    }
    x2222 = Object.getPrototypeOf(x2222);
  }
  return null;
}
function isGetter222(object222, name22) {
  const d2222 = getPropertyDescriptor222(object222, name22);
  return d2222 != null && d2222.get != null;
}
function getElementValues222(nodeList, initialScope) {
  const valueList = [];
  for (let i2222 = 0; i2222 < nodeList.length; ++i2222) {
    const elementNode = nodeList[i2222];
    if (elementNode == null) {
      valueList.length = i2222 + 1;
    } else if (elementNode.type === "SpreadElement") {
      const argument = getStaticValueR222(elementNode.argument, initialScope);
      if (argument == null) {
        return null;
      }
      valueList.push(...argument.value);
    } else {
      const element = getStaticValueR222(elementNode, initialScope);
      if (element == null) {
        return null;
      }
      valueList.push(element.value);
    }
  }
  return valueList;
}
function isEffectivelyConst222(variable) {
  const refs = variable.references;
  const inits = refs.filter((r2222) => r2222.init).length;
  const reads = refs.filter((r2222) => r2222.isReadOnly()).length;
  if (inits === 1 && reads + inits === refs.length) {
    return true;
  }
  return false;
}
var operations222 = Object.freeze({
  ArrayExpression(node, initialScope) {
    const elements = getElementValues222(node.elements, initialScope);
    return elements != null ? { value: elements } : null;
  },
  AssignmentExpression(node, initialScope) {
    if (node.operator === "=") {
      return getStaticValueR222(node.right, initialScope);
    }
    return null;
  },
  //eslint-disable-next-line complexity
  BinaryExpression(node, initialScope) {
    if (node.operator === "in" || node.operator === "instanceof") {
      return null;
    }
    const left32222 = getStaticValueR222(node.left, initialScope);
    const right32222 = getStaticValueR222(node.right, initialScope);
    if (left32222 != null && right32222 != null) {
      switch (node.operator) {
        case "==":
          return { value: left32222.value == right32222.value };
        case "!=":
          return { value: left32222.value != right32222.value };
        case "===":
          return { value: left32222.value === right32222.value };
        case "!==":
          return { value: left32222.value !== right32222.value };
        case "<":
          return { value: left32222.value < right32222.value };
        case "<=":
          return { value: left32222.value <= right32222.value };
        case ">":
          return { value: left32222.value > right32222.value };
        case ">=":
          return { value: left32222.value >= right32222.value };
        case "<<":
          return { value: left32222.value << right32222.value };
        case ">>":
          return { value: left32222.value >> right32222.value };
        case ">>>":
          return { value: left32222.value >>> right32222.value };
        case "+":
          return { value: left32222.value + right32222.value };
        case "-":
          return { value: left32222.value - right32222.value };
        case "*":
          return { value: left32222.value * right32222.value };
        case "/":
          return { value: left32222.value / right32222.value };
        case "%":
          return { value: left32222.value % right32222.value };
        case "**":
          return { value: left32222.value ** right32222.value };
        case "|":
          return { value: left32222.value | right32222.value };
        case "^":
          return { value: left32222.value ^ right32222.value };
        case "&":
          return { value: left32222.value & right32222.value };
      }
    }
    return null;
  },
  CallExpression(node, initialScope) {
    const calleeNode = node.callee;
    const args = getElementValues222(node.arguments, initialScope);
    if (args != null) {
      if (calleeNode.type === "MemberExpression") {
        if (calleeNode.property.type === "PrivateIdentifier") {
          return null;
        }
        const object222 = getStaticValueR222(calleeNode.object, initialScope);
        if (object222 != null) {
          if (object222.value == null && (object222.optional || node.optional)) {
            return { value: void 0, optional: true };
          }
          const property = getStaticPropertyNameValue222(
            calleeNode,
            initialScope
          );
          if (property != null) {
            const receiver = object222.value;
            const methodName = property.value;
            if (callAllowed222.has(receiver[methodName])) {
              return { value: receiver[methodName](...args) };
            }
            if (callPassThrough222.has(receiver[methodName])) {
              return { value: args[0] };
            }
          }
        }
      } else {
        const callee = getStaticValueR222(calleeNode, initialScope);
        if (callee != null) {
          if (callee.value == null && node.optional) {
            return { value: void 0, optional: true };
          }
          const func = callee.value;
          if (callAllowed222.has(func)) {
            return { value: func(...args) };
          }
          if (callPassThrough222.has(func)) {
            return { value: args[0] };
          }
        }
      }
    }
    return null;
  },
  ConditionalExpression(node, initialScope) {
    const test = getStaticValueR222(node.test, initialScope);
    if (test != null) {
      return test.value ? getStaticValueR222(node.consequent, initialScope) : getStaticValueR222(node.alternate, initialScope);
    }
    return null;
  },
  ExpressionStatement(node, initialScope) {
    return getStaticValueR222(node.expression, initialScope);
  },
  Identifier(node, initialScope) {
    if (initialScope != null) {
      const variable = findVariable2222(initialScope, node);
      if (variable != null && variable.defs.length === 0 && builtinNames222.has(variable.name) && variable.name in globalObject222) {
        return { value: globalObject222[variable.name] };
      }
      if (variable != null && variable.defs.length === 1) {
        const def = variable.defs[0];
        if (def.parent && def.type === "Variable" && (def.parent.kind === "const" || isEffectivelyConst222(variable)) && // TODO(mysticatea): don't support destructuring here.
        def.node.id.type === "Identifier") {
          return getStaticValueR222(def.node.init, initialScope);
        }
      }
    }
    return null;
  },
  Literal(node) {
    if ((node.regex != null || node.bigint != null) && node.value == null) {
      return null;
    }
    return { value: node.value };
  },
  LogicalExpression(node, initialScope) {
    const left32222 = getStaticValueR222(node.left, initialScope);
    if (left32222 != null) {
      if (node.operator === "||" && Boolean(left32222.value) === true || node.operator === "&&" && Boolean(left32222.value) === false || node.operator === "??" && left32222.value != null) {
        return left32222;
      }
      const right32222 = getStaticValueR222(node.right, initialScope);
      if (right32222 != null) {
        return right32222;
      }
    }
    return null;
  },
  MemberExpression(node, initialScope) {
    if (node.property.type === "PrivateIdentifier") {
      return null;
    }
    const object222 = getStaticValueR222(node.object, initialScope);
    if (object222 != null) {
      if (object222.value == null && (object222.optional || node.optional)) {
        return { value: void 0, optional: true };
      }
      const property = getStaticPropertyNameValue222(node, initialScope);
      if (property != null) {
        if (!isGetter222(object222.value, property.value)) {
          return { value: object222.value[property.value] };
        }
        for (const [classFn, allowed] of getterAllowed222) {
          if (object222.value instanceof classFn && allowed.has(property.value)) {
            return { value: object222.value[property.value] };
          }
        }
      }
    }
    return null;
  },
  ChainExpression(node, initialScope) {
    const expression = getStaticValueR222(node.expression, initialScope);
    if (expression != null) {
      return { value: expression.value };
    }
    return null;
  },
  NewExpression(node, initialScope) {
    const callee = getStaticValueR222(node.callee, initialScope);
    const args = getElementValues222(node.arguments, initialScope);
    if (callee != null && args != null) {
      const Func = callee.value;
      if (callAllowed222.has(Func)) {
        return { value: new Func(...args) };
      }
    }
    return null;
  },
  ObjectExpression(node, initialScope) {
    const object222 = {};
    for (const propertyNode of node.properties) {
      if (propertyNode.type === "Property") {
        if (propertyNode.kind !== "init") {
          return null;
        }
        const key = getStaticPropertyNameValue222(
          propertyNode,
          initialScope
        );
        const value = getStaticValueR222(propertyNode.value, initialScope);
        if (key == null || value == null) {
          return null;
        }
        object222[key.value] = value.value;
      } else if (propertyNode.type === "SpreadElement" || propertyNode.type === "ExperimentalSpreadProperty") {
        const argument = getStaticValueR222(
          propertyNode.argument,
          initialScope
        );
        if (argument == null) {
          return null;
        }
        Object.assign(object222, argument.value);
      } else {
        return null;
      }
    }
    return { value: object222 };
  },
  SequenceExpression(node, initialScope) {
    const last222 = node.expressions[node.expressions.length - 1];
    return getStaticValueR222(last222, initialScope);
  },
  TaggedTemplateExpression(node, initialScope) {
    const tag = getStaticValueR222(node.tag, initialScope);
    const expressions = getElementValues222(
      node.quasi.expressions,
      initialScope
    );
    if (tag != null && expressions != null) {
      const func = tag.value;
      const strings = node.quasi.quasis.map((q) => q.value.cooked);
      strings.raw = node.quasi.quasis.map((q) => q.value.raw);
      if (func === String.raw) {
        return { value: func(strings, ...expressions) };
      }
    }
    return null;
  },
  TemplateLiteral(node, initialScope) {
    const expressions = getElementValues222(node.expressions, initialScope);
    if (expressions != null) {
      let value = node.quasis[0].value.cooked;
      for (let i2222 = 0; i2222 < expressions.length; ++i2222) {
        value += expressions[i2222];
        value += node.quasis[i2222 + 1].value.cooked;
      }
      return { value };
    }
    return null;
  },
  UnaryExpression(node, initialScope) {
    if (node.operator === "delete") {
      return null;
    }
    if (node.operator === "void") {
      return { value: void 0 };
    }
    const arg = getStaticValueR222(node.argument, initialScope);
    if (arg != null) {
      switch (node.operator) {
        case "-":
          return { value: -arg.value };
        case "+":
          return { value: +arg.value };
        case "!":
          return { value: !arg.value };
        case "~":
          return { value: ~arg.value };
        case "typeof":
          return { value: typeof arg.value };
      }
    }
    return null;
  }
});
function getStaticValueR222(node, initialScope) {
  if (node != null && Object.hasOwnProperty.call(operations222, node.type)) {
    return operations222[node.type](node, initialScope);
  }
  return null;
}
function getStaticPropertyNameValue222(node, initialScope) {
  const nameNode = node.type === "Property" ? node.key : node.property;
  if (node.computed) {
    return getStaticValueR222(nameNode, initialScope);
  }
  if (nameNode.type === "Identifier") {
    return { value: nameNode.name };
  }
  if (nameNode.type === "Literal") {
    if (nameNode.bigint) {
      return { value: nameNode.bigint };
    }
    return { value: String(nameNode.value) };
  }
  return null;
}
function getStaticValue222(node, initialScope = null) {
  try {
    return getStaticValueR222(node, initialScope);
  } catch (_error) {
    return null;
  }
}
function getStringIfConstant222(node, initialScope = null) {
  if (node && node.type === "Literal" && node.value === null) {
    if (node.regex) {
      return `/${node.regex.pattern}/${node.regex.flags}`;
    }
    if (node.bigint) {
      return node.bigint;
    }
  }
  const evaluated = getStaticValue222(node, initialScope);
  return evaluated && String(evaluated.value);
}
function getPropertyName222(node, initialScope) {
  switch (node.type) {
    case "MemberExpression":
      if (node.computed) {
        return getStringIfConstant222(node.property, initialScope);
      }
      if (node.property.type === "PrivateIdentifier") {
        return null;
      }
      return node.property.name;
    case "Property":
    case "MethodDefinition":
    case "PropertyDefinition":
      if (node.computed) {
        return getStringIfConstant222(node.key, initialScope);
      }
      if (node.key.type === "Literal") {
        return String(node.key.value);
      }
      if (node.key.type === "PrivateIdentifier") {
        return null;
      }
      return node.key.name;
  }
  return null;
}
function getFunctionNameWithKind222(node, sourceCode) {
  const parent = node.parent;
  const tokens = [];
  const isObjectMethod = parent.type === "Property" && parent.value === node;
  const isClassMethod = parent.type === "MethodDefinition" && parent.value === node;
  const isClassFieldMethod = parent.type === "PropertyDefinition" && parent.value === node;
  if (isClassMethod || isClassFieldMethod) {
    if (parent.static) {
      tokens.push("static");
    }
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push("private");
    }
  }
  if (node.async) {
    tokens.push("async");
  }
  if (node.generator) {
    tokens.push("generator");
  }
  if (isObjectMethod || isClassMethod) {
    if (parent.kind === "constructor") {
      return "constructor";
    }
    if (parent.kind === "get") {
      tokens.push("getter");
    } else if (parent.kind === "set") {
      tokens.push("setter");
    } else {
      tokens.push("method");
    }
  } else if (isClassFieldMethod) {
    tokens.push("method");
  } else {
    if (node.type === "ArrowFunctionExpression") {
      tokens.push("arrow");
    }
    tokens.push("function");
  }
  if (isObjectMethod || isClassMethod || isClassFieldMethod) {
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push(`#${parent.key.name}`);
    } else {
      const name22 = getPropertyName222(parent);
      if (name22) {
        tokens.push(`'${name22}'`);
      } else if (sourceCode) {
        const keyText = sourceCode.getText(parent.key);
        if (!keyText.includes("\n")) {
          tokens.push(`[${keyText}]`);
        }
      }
    }
  } else if (node.id) {
    tokens.push(`'${node.id.name}'`);
  } else if (parent.type === "VariableDeclarator" && parent.id && parent.id.type === "Identifier") {
    tokens.push(`'${parent.id.name}'`);
  } else if ((parent.type === "AssignmentExpression" || parent.type === "AssignmentPattern") && parent.left && parent.left.type === "Identifier") {
    tokens.push(`'${parent.left.name}'`);
  } else if (parent.type === "ExportDefaultDeclaration" && parent.declaration === node) {
    tokens.push("'default'");
  }
  return tokens.join(" ");
}
var typeConversionBinaryOps222 = Object.freeze(
  /* @__PURE__ */ new Set([
    "==",
    "!=",
    "<",
    "<=",
    ">",
    ">=",
    "<<",
    ">>",
    ">>>",
    "+",
    "-",
    "*",
    "/",
    "%",
    "|",
    "^",
    "&",
    "in"
  ])
);
var typeConversionUnaryOps222 = Object.freeze(/* @__PURE__ */ new Set(["-", "+", "!", "~"]));
function isNode222(x2222) {
  return x2222 !== null && typeof x2222 === "object" && typeof x2222.type === "string";
}
var visitor222 = Object.freeze(
  Object.assign(/* @__PURE__ */ Object.create(null), {
    $visit(node, options, visitorKeys) {
      const { type } = node;
      if (typeof this[type] === "function") {
        return this[type](node, options, visitorKeys);
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    $visitChildren(node, options, visitorKeys) {
      const { type } = node;
      for (const key of visitorKeys[type] || getKeys222(node)) {
        const value = node[key];
        if (Array.isArray(value)) {
          for (const element of value) {
            if (isNode222(element) && this.$visit(element, options, visitorKeys)) {
              return true;
            }
          }
        } else if (isNode222(value) && this.$visit(value, options, visitorKeys)) {
          return true;
        }
      }
      return false;
    },
    ArrowFunctionExpression() {
      return false;
    },
    AssignmentExpression() {
      return true;
    },
    AwaitExpression() {
      return true;
    },
    BinaryExpression(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && typeConversionBinaryOps222.has(node.operator) && (node.left.type !== "Literal" || node.right.type !== "Literal")) {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    CallExpression() {
      return true;
    },
    FunctionExpression() {
      return false;
    },
    ImportExpression() {
      return true;
    },
    MemberExpression(node, options, visitorKeys) {
      if (options.considerGetters) {
        return true;
      }
      if (options.considerImplicitTypeConversion && node.computed && node.property.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    MethodDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    NewExpression() {
      return true;
    },
    Property(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    PropertyDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UnaryExpression(node, options, visitorKeys) {
      if (node.operator === "delete") {
        return true;
      }
      if (options.considerImplicitTypeConversion && typeConversionUnaryOps222.has(node.operator) && node.argument.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UpdateExpression() {
      return true;
    },
    YieldExpression() {
      return true;
    }
  })
);
function hasSideEffect222(node, sourceCode, { considerGetters = false, considerImplicitTypeConversion = false } = {}) {
  return visitor222.$visit(
    node,
    { considerGetters, considerImplicitTypeConversion },
    sourceCode.visitorKeys || visitor_keys_default222
  );
}
function getParentSyntaxParen222(node, sourceCode) {
  const parent = node.parent;
  switch (parent.type) {
    case "CallExpression":
    case "NewExpression":
      if (parent.arguments.length === 1 && parent.arguments[0] === node) {
        return sourceCode.getTokenAfter(
          parent.callee,
          isOpeningParenToken222
        );
      }
      return null;
    case "DoWhileStatement":
      if (parent.test === node) {
        return sourceCode.getTokenAfter(
          parent.body,
          isOpeningParenToken222
        );
      }
      return null;
    case "IfStatement":
    case "WhileStatement":
      if (parent.test === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "ImportExpression":
      if (parent.source === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "SwitchStatement":
      if (parent.discriminant === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "WithStatement":
      if (parent.object === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    default:
      return null;
  }
}
function isParenthesized222(timesOrNode, nodeOrSourceCode, optionalSourceCode) {
  let times, node, sourceCode, maybeLeftParen, maybeRightParen;
  if (typeof timesOrNode === "number") {
    times = timesOrNode | 0;
    node = nodeOrSourceCode;
    sourceCode = optionalSourceCode;
    if (!(times >= 1)) {
      throw new TypeError("'times' should be a positive integer.");
    }
  } else {
    times = 1;
    node = timesOrNode;
    sourceCode = nodeOrSourceCode;
  }
  if (node == null || // `Program` can't be parenthesized
  node.parent == null || // `CatchClause.param` can't be parenthesized, example `try {} catch (error) {}`
  node.parent.type === "CatchClause" && node.parent.param === node) {
    return false;
  }
  maybeLeftParen = maybeRightParen = node;
  do {
    maybeLeftParen = sourceCode.getTokenBefore(maybeLeftParen);
    maybeRightParen = sourceCode.getTokenAfter(maybeRightParen);
  } while (maybeLeftParen != null && maybeRightParen != null && isOpeningParenToken222(maybeLeftParen) && isClosingParenToken222(maybeRightParen) && // Avoid false positive such as `if (a) {}`
  maybeLeftParen !== getParentSyntaxParen222(node, sourceCode) && --times > 0);
  return times === 0;
}
Function.call.bind(Object.hasOwnProperty);
var __defProp22222 = Object.defineProperty;
var __export22222 = (target, all32222) => {
  for (var name22 in all32222)
    __defProp22222(target, name22, { get: all32222[name22], enumerable: true });
};
var NodeType222 = types.AST_NODE_TYPES;
var is222 = utils.ASTUtils.isNodeOfType;
var isOneOf222 = utils.ASTUtils.isNodeOfTypes;
isOneOf222([
  NodeType222.ArrowFunctionExpression,
  NodeType222.FunctionDeclaration,
  NodeType222.FunctionExpression
]);
isOneOf222([
  NodeType222.ArrowFunctionExpression,
  NodeType222.FunctionDeclaration,
  NodeType222.FunctionExpression,
  NodeType222.TSCallSignatureDeclaration,
  NodeType222.TSConstructSignatureDeclaration,
  NodeType222.TSDeclareFunction,
  NodeType222.TSEmptyBodyFunctionExpression,
  NodeType222.TSFunctionType,
  NodeType222.TSMethodSignature
]);
isOneOf222([NodeType222.ClassDeclaration, NodeType222.ClassExpression]);
isOneOf222([
  NodeType222.DoWhileStatement,
  NodeType222.ForInStatement,
  NodeType222.ForOfStatement,
  NodeType222.ForStatement,
  NodeType222.WhileStatement
]);
isOneOf222([NodeType222.TSArrayType, NodeType222.TSTupleType]);
isOneOf222([
  NodeType222.PropertyDefinition,
  NodeType222.TSIndexSignature,
  NodeType222.TSParameterProperty,
  NodeType222.TSPropertySignature
]);
is222(NodeType222.JSXElement);
is222(NodeType222.JSXFragment);
isOneOf222([
  NodeType222.JSXAttribute,
  NodeType222.JSXSpreadChild,
  NodeType222.JSXClosingElement,
  NodeType222.JSXClosingFragment,
  NodeType222.JSXElement,
  NodeType222.JSXEmptyExpression,
  NodeType222.JSXExpressionContainer,
  NodeType222.JSXFragment,
  NodeType222.JSXIdentifier,
  NodeType222.JSXMemberExpression,
  NodeType222.JSXNamespacedName,
  NodeType222.JSXOpeningElement,
  NodeType222.JSXOpeningFragment,
  NodeType222.JSXSpreadAttribute,
  NodeType222.JSXSpreadChild,
  NodeType222.JSXText
]);
isOneOf222([
  NodeType222.JSXIdentifier,
  NodeType222.JSXMemberExpression,
  NodeType222.JSXNamespacedName
]);
isOneOf222([
  NodeType222.ArrayPattern,
  NodeType222.AssignmentPattern,
  NodeType222.ObjectPattern,
  NodeType222.RestElement
]);
isOneOf222([
  NodeType222.TSInterfaceDeclaration,
  NodeType222.TSTypeAliasDeclaration
]);
isOneOf222([
  NodeType222.ArrayExpression,
  NodeType222.ArrayPattern,
  NodeType222.ArrowFunctionExpression,
  NodeType222.CallExpression,
  NodeType222.ClassExpression,
  NodeType222.FunctionExpression,
  NodeType222.Identifier,
  NodeType222.JSXElement,
  NodeType222.JSXFragment,
  NodeType222.Literal,
  NodeType222.TemplateLiteral,
  NodeType222.MemberExpression,
  NodeType222.MetaProperty,
  NodeType222.ObjectExpression,
  NodeType222.ObjectPattern,
  NodeType222.SequenceExpression,
  NodeType222.Super,
  NodeType222.TaggedTemplateExpression,
  NodeType222.ThisExpression
]);
isOneOf222([
  NodeType222.ArrayExpression,
  NodeType222.ArrayPattern,
  NodeType222.ArrowFunctionExpression,
  NodeType222.CallExpression,
  NodeType222.ClassExpression,
  NodeType222.FunctionExpression,
  NodeType222.Identifier,
  NodeType222.JSXElement,
  NodeType222.JSXFragment,
  NodeType222.Literal,
  NodeType222.TemplateLiteral,
  NodeType222.MemberExpression,
  NodeType222.MetaProperty,
  NodeType222.ObjectExpression,
  NodeType222.ObjectPattern,
  NodeType222.SequenceExpression,
  NodeType222.Super,
  NodeType222.TaggedTemplateExpression,
  NodeType222.ThisExpression,
  NodeType222.TSAsExpression,
  NodeType222.TSNonNullExpression,
  NodeType222.TSTypeAssertion
]);
var Function_exports2222 = {};
__export22222(Function_exports2222, {
  SK: () => SK2222,
  absurd: () => absurd2222,
  apply: () => apply2222,
  compose: () => compose2222,
  constFalse: () => constFalse2222,
  constNull: () => constNull2222,
  constTrue: () => constTrue2222,
  constUndefined: () => constUndefined2222,
  constVoid: () => constVoid2222,
  constant: () => constant2222,
  dual: () => dual2222,
  flip: () => flip2222,
  flow: () => flow2222,
  hole: () => hole2222,
  identity: () => identity2222,
  isFunction: () => isFunction22222,
  pipe: () => pipe2222,
  satisfies: () => satisfies2222,
  tupled: () => tupled2222,
  unsafeCoerce: () => unsafeCoerce2222,
  untupled: () => untupled2222
});
var isFunction22222 = (input) => typeof input === "function";
var dual2222 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a2222, b2222) {
        if (arguments.length >= 2) {
          return body(a2222, b2222);
        }
        return function(self2) {
          return body(self2, a2222);
        };
      };
    case 3:
      return function(a2222, b2222, c2222) {
        if (arguments.length >= 3) {
          return body(a2222, b2222, c2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222);
        };
      };
    case 4:
      return function(a2222, b2222, c2222, d2222) {
        if (arguments.length >= 4) {
          return body(a2222, b2222, c2222, d2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222);
        };
      };
    case 5:
      return function(a2222, b2222, c2222, d2222, e2222) {
        if (arguments.length >= 5) {
          return body(a2222, b2222, c2222, d2222, e2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222, d2222);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply2222 = (a2222) => (self2) => self2(a2222);
var identity2222 = (a2222) => a2222;
var satisfies2222 = () => (b2222) => b2222;
var unsafeCoerce2222 = identity2222;
var constant2222 = (value) => () => value;
var constTrue2222 = /* @__PURE__ */ constant2222(true);
var constFalse2222 = /* @__PURE__ */ constant2222(false);
var constNull2222 = /* @__PURE__ */ constant2222(null);
var constUndefined2222 = /* @__PURE__ */ constant2222(void 0);
var constVoid2222 = constUndefined2222;
var flip2222 = (f2222) => (...b2222) => (...a2222) => f2222(...a2222)(...b2222);
var compose2222 = /* @__PURE__ */ dual2222(2, (ab, bc) => (a2222) => bc(ab(a2222)));
var absurd2222 = (_2222) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled2222 = (f2222) => (a2222) => f2222(...a2222);
var untupled2222 = (f2222) => (...a2222) => f2222(a2222);
function pipe2222(a2222, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a2222;
    case 2:
      return ab(a2222);
    case 3:
      return bc(ab(a2222));
    case 4:
      return cd(bc(ab(a2222)));
    case 5:
      return de(cd(bc(ab(a2222))));
    case 6:
      return ef(de(cd(bc(ab(a2222)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a2222))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a2222)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a2222))))))));
    default: {
      let ret = arguments[0];
      for (let i2222 = 1; i2222 < arguments.length; i2222++) {
        ret = arguments[i2222](ret);
      }
      return ret;
    }
  }
}
function flow2222(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole2222 = /* @__PURE__ */ unsafeCoerce2222(absurd2222);
var SK2222 = (_2222, b2222) => b2222;
var make4222 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_3222 = (map622) => dual2222(3, (self2, name22, f2222) => map622(self2, (a2222) => Object.assign({}, a2222, {
  [name22]: f2222(a2222)
})));
var bindTo3222 = (map622) => dual2222(2, (self2, name22) => map622(self2, (a2222) => ({
  [name22]: a2222
})));
var bind3222 = (map622, flatMap4222) => dual2222(3, (self2, name22, f2222) => flatMap4222(self2, (a2222) => map622(f2222(a2222), (b2222) => Object.assign({}, a2222, {
  [name22]: b2222
}))));
var moduleVersion2222 = "3.2.8";
var getCurrentVersion2222 = () => moduleVersion2222;
var globalStoreId2222 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion2222()}`);
if (!(globalStoreId2222 in globalThis)) {
  globalThis[globalStoreId2222] = /* @__PURE__ */ new Map();
}
var globalStore2222 = globalThis[globalStoreId2222];
var globalValue2222 = (id, compute) => {
  if (!globalStore2222.has(id)) {
    globalStore2222.set(id, compute());
  }
  return globalStore2222.get(id);
};
var Predicate_exports2222 = {};
__export22222(Predicate_exports2222, {
  all: () => all2222,
  and: () => and32,
  compose: () => compose22222,
  eqv: () => eqv32,
  every: () => every42,
  hasProperty: () => hasProperty2222,
  implies: () => implies32,
  isBigInt: () => isBigInt32,
  isBoolean: () => isBoolean32,
  isDate: () => isDate32,
  isError: () => isError32,
  isFunction: () => isFunction3222,
  isIterable: () => isIterable32,
  isMap: () => isMap32,
  isNever: () => isNever32,
  isNotNull: () => isNotNull32,
  isNotNullable: () => isNotNullable32,
  isNotUndefined: () => isNotUndefined32,
  isNull: () => isNull32,
  isNullable: () => isNullable2222,
  isNumber: () => isNumber32,
  isObject: () => isObject2222,
  isPromise: () => isPromise32,
  isPromiseLike: () => isPromiseLike32,
  isReadonlyRecord: () => isReadonlyRecord32,
  isRecord: () => isRecord32,
  isSet: () => isSet32,
  isString: () => isString32,
  isSymbol: () => isSymbol32,
  isTagged: () => isTagged32,
  isTruthy: () => isTruthy32,
  isUint8Array: () => isUint8Array32,
  isUndefined: () => isUndefined32,
  isUnknown: () => isUnknown32,
  mapInput: () => mapInput42,
  nand: () => nand32,
  nor: () => nor32,
  not: () => not32,
  or: () => or32,
  product: () => product2222,
  productMany: () => productMany2222,
  some: () => some3222,
  struct: () => struct52,
  tuple: () => tuple42,
  xor: () => xor32
});
var mapInput42 = /* @__PURE__ */ dual2222(2, (self2, f2222) => (b2222) => self2(f2222(b2222)));
var isTruthy32 = (input) => !!input;
var isSet32 = (input) => input instanceof Set;
var isMap32 = (input) => input instanceof Map;
var isString32 = (input) => typeof input === "string";
var isNumber32 = (input) => typeof input === "number";
var isBoolean32 = (input) => typeof input === "boolean";
var isBigInt32 = (input) => typeof input === "bigint";
var isSymbol32 = (input) => typeof input === "symbol";
var isFunction3222 = isFunction22222;
var isUndefined32 = (input) => input === void 0;
var isNotUndefined32 = (input) => input !== void 0;
var isNull32 = (input) => input === null;
var isNotNull32 = (input) => input !== null;
var isNever32 = (_2222) => false;
var isUnknown32 = (_2222) => true;
var isRecordOrArray2222 = (input) => typeof input === "object" && input !== null;
var isObject2222 = (input) => isRecordOrArray2222(input) || isFunction3222(input);
var hasProperty2222 = /* @__PURE__ */ dual2222(2, (self2, property) => isObject2222(self2) && property in self2);
var isTagged32 = /* @__PURE__ */ dual2222(2, (self2, tag) => hasProperty2222(self2, "_tag") && self2["_tag"] === tag);
var isNullable2222 = (input) => input === null || input === void 0;
var isNotNullable32 = (input) => input !== null && input !== void 0;
var isError32 = (input) => input instanceof Error;
var isUint8Array32 = (input) => input instanceof Uint8Array;
var isDate32 = (input) => input instanceof Date;
var isIterable32 = (input) => hasProperty2222(input, Symbol.iterator);
var isRecord32 = (input) => isRecordOrArray2222(input) && !Array.isArray(input);
var isReadonlyRecord32 = isRecord32;
var isPromise32 = (input) => hasProperty2222(input, "then") && "catch" in input && isFunction3222(input.then) && isFunction3222(input.catch);
var isPromiseLike32 = (input) => hasProperty2222(input, "then") && isFunction3222(input.then);
var compose22222 = /* @__PURE__ */ dual2222(2, (ab, bc) => (a2222) => ab(a2222) && bc(a2222));
var product2222 = (self2, that) => ([a2222, b2222]) => self2(a2222) && that(b2222);
var all2222 = (collection) => {
  return (as222222) => {
    let collectionIndex = 0;
    for (const p2222 of collection) {
      if (collectionIndex >= as222222.length) {
        break;
      }
      if (p2222(as222222[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany2222 = (self2, collection) => {
  const rest = all2222(collection);
  return ([head222, ...tail222]) => self2(head222) === false ? false : rest(tail222);
};
var tuple42 = (...elements) => all2222(elements);
var struct52 = (fields) => {
  const keys22222 = Object.keys(fields);
  return (a2222) => {
    for (const key of keys22222) {
      if (!fields[key](a2222[key])) {
        return false;
      }
    }
    return true;
  };
};
var not32 = (self2) => (a2222) => !self2(a2222);
var or32 = /* @__PURE__ */ dual2222(2, (self2, that) => (a2222) => self2(a2222) || that(a2222));
var and32 = /* @__PURE__ */ dual2222(2, (self2, that) => (a2222) => self2(a2222) && that(a2222));
var xor32 = /* @__PURE__ */ dual2222(2, (self2, that) => (a2222) => self2(a2222) !== that(a2222));
var eqv32 = /* @__PURE__ */ dual2222(2, (self2, that) => (a2222) => self2(a2222) === that(a2222));
var implies32 = /* @__PURE__ */ dual2222(2, (self2, that) => (a2222) => self2(a2222) ? that(a2222) : true);
var nor32 = /* @__PURE__ */ dual2222(2, (self2, that) => (a2222) => !(self2(a2222) || that(a2222)));
var nand32 = /* @__PURE__ */ dual2222(2, (self2, that) => (a2222) => !(self2(a2222) && that(a2222)));
var every42 = (collection) => (a2222) => {
  for (const p2222 of collection) {
    if (!p2222(a2222)) {
      return false;
    }
  }
  return true;
};
var some3222 = (collection) => (a2222) => {
  for (const p2222 of collection) {
    if (p2222(a2222)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage2222 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId2222 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind2222 = (u2222) => isObject2222(u2222) && GenKindTypeId2222 in u2222;
var GenKindImpl2222 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity2222;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId2222] = GenKindTypeId2222;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen2222(this);
  }
};
var SingleShotGen2222 = class _SingleShotGen42 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a2222) {
    return this.called ? {
      value: a2222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a2222) {
    return {
      value: a2222,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e2222) {
    throw e2222;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen42(this.self);
  }
};
var adapter3222 = () => function() {
  let x2222 = arguments[0];
  for (let i2222 = 1; i2222 < arguments.length; i2222++) {
    x2222 = arguments[i2222](x2222);
  }
  return new GenKindImpl2222(x2222);
};
var defaultIncHi2222 = 335903614;
var defaultIncLo2222 = 4150755663;
var MUL_HI2222 = 1481765933 >>> 0;
var MUL_LO2222 = 1284865837 >>> 0;
var BIT_532222 = 9007199254740992;
var BIT_272222 = 134217728;
var PCGRandom2222 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable2222(seedLo) && isNullable2222(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable2222(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable2222(incLo) && isNullable2222(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo2222;
      incHi = this._state ? this._state[2] : defaultIncHi2222;
    } else if (isNullable2222(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add642222(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max322) {
    if (!max322) {
      return this._next();
    }
    max322 = max322 >>> 0;
    if ((max322 & max322 - 1) === 0) {
      return this._next() & max322 - 1;
    }
    let num = 0;
    const skew = (-max322 >>> 0) % max322 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max322;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_272222 + lo) / BIT_532222;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul642222(this._state, oldHi, oldLo, MUL_HI2222, MUL_LO2222);
    add642222(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul642222(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add642222(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId2222 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap2222 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId2222]() {
    return this.#value;
  }
};
function yieldWrapGet2222(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId2222 in self2) {
    return self2[YieldWrapTypeId2222]();
  }
  throw new Error(getBugErrorMessage2222("yieldWrapGet"));
}
var structuralRegionState2222 = /* @__PURE__ */ globalValue2222("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache2222 = /* @__PURE__ */ globalValue2222(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr2222 = /* @__PURE__ */ globalValue2222(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom2222());
var symbol3222 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash2222 = (self2) => {
  if (structuralRegionState2222.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number2222(self2);
    case "bigint":
      return string2222(self2.toString(10));
    case "boolean":
      return string2222(String(self2));
    case "symbol":
      return string2222(String(self2));
    case "string":
      return string2222(self2);
    case "undefined":
      return string2222("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string2222("null");
      } else if (self2 instanceof Date) {
        return hash2222(self2.toISOString());
      } else if (isHash2222(self2)) {
        return self2[symbol3222]();
      } else {
        return random2222(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random2222 = (self2) => {
  if (!randomHashCache2222.has(self2)) {
    randomHashCache2222.set(self2, number2222(pcgr2222.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache2222.get(self2);
};
var combine2222 = (b2222) => (self2) => self2 * 53 ^ b2222;
var optimize2222 = (n2222) => n2222 & 3221225471 | n2222 >>> 1 & 1073741824;
var isHash2222 = (u2222) => hasProperty2222(u2222, symbol3222);
var number2222 = (n2222) => {
  if (n2222 !== n2222 || n2222 === Infinity) {
    return 0;
  }
  let h2222 = n2222 | 0;
  if (h2222 !== n2222) {
    h2222 ^= n2222 * 4294967295;
  }
  while (n2222 > 4294967295) {
    h2222 ^= n2222 /= 4294967295;
  }
  return optimize2222(n2222);
};
var string2222 = (str) => {
  let h2222 = 5381, i2222 = str.length;
  while (i2222) {
    h2222 = h2222 * 33 ^ str.charCodeAt(--i2222);
  }
  return optimize2222(h2222);
};
var structureKeys222 = (o2222, keys22222) => {
  let h2222 = 12289;
  for (let i2222 = 0; i2222 < keys22222.length; i2222++) {
    h2222 ^= pipe2222(string2222(keys22222[i2222]), combine2222(hash2222(o2222[keys22222[i2222]])));
  }
  return optimize2222(h2222);
};
var structure222 = (o2222) => structureKeys222(o2222, Object.keys(o2222));
var array52 = (arr) => {
  let h2222 = 6151;
  for (let i2222 = 0; i2222 < arr.length; i2222++) {
    h2222 = pipe2222(h2222, combine2222(hash2222(arr[i2222])));
  }
  return optimize2222(h2222);
};
var cached2222 = function() {
  if (arguments.length === 1) {
    const self22 = arguments[0];
    return function(hash3222) {
      Object.defineProperty(self22, symbol3222, {
        value() {
          return hash3222;
        },
        enumerable: false
      });
      return hash3222;
    };
  }
  const self2 = arguments[0];
  const hash222222 = arguments[1];
  Object.defineProperty(self2, symbol3222, {
    value() {
      return hash222222;
    },
    enumerable: false
  });
  return hash222222;
};
var symbol22222 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals2222() {
  if (arguments.length === 1) {
    return (self2) => compareBoth2222(self2, arguments[0]);
  }
  return compareBoth2222(arguments[0], arguments[1]);
}
function compareBoth2222(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual2222(self2) && isEqual2222(that)) {
        if (hash2222(self2) === hash2222(that) && self2[symbol22222](that)) {
          return true;
        } else {
          return structuralRegionState2222.enabled && structuralRegionState2222.tester ? structuralRegionState2222.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState2222.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v2222, i2222) => compareBoth2222(v2222, that[i2222]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth2222(self2[key], that[key]))) {
              return structuralRegionState2222.tester ? structuralRegionState2222.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState2222.tester ? structuralRegionState2222.tester(self2, that) : false;
    }
  }
  return structuralRegionState2222.enabled && structuralRegionState2222.tester ? structuralRegionState2222.tester(self2, that) : false;
}
var isEqual2222 = (u2222) => hasProperty2222(u2222, symbol22222);
var equivalence2222 = () => equals2222;
var NodeInspectSymbol2222 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON2222 = (x2222) => {
  if (hasProperty2222(x2222, "toJSON") && isFunction3222(x2222["toJSON"]) && x2222["toJSON"].length === 0) {
    return x2222.toJSON();
  } else if (Array.isArray(x2222)) {
    return x2222.map(toJSON2222);
  }
  return x2222;
};
var format2222 = (x2222) => JSON.stringify(x2222, null, 2);
var pipeArguments2222 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i2222 = 0, len = args.length; i2222 < len; i2222++) {
        ret = args[i2222](ret);
      }
      return ret;
    }
  }
};
var OP_COMMIT222 = "Commit";
var OP_FAILURE222 = "Failure";
var OP_WITH_RUNTIME222 = "WithRuntime";
var EffectTypeId2222 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId2222 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId2222 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId2222 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance2222 = {
  /* c8 ignore next */
  _R: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _A: (_2222) => _2222,
  _V: /* @__PURE__ */ getCurrentVersion2222()
};
var sinkVariance2222 = {
  /* c8 ignore next */
  _A: (_2222) => _2222,
  /* c8 ignore next */
  _In: (_2222) => _2222,
  /* c8 ignore next */
  _L: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _R: (_2222) => _2222
};
var channelVariance2222 = {
  /* c8 ignore next */
  _Env: (_2222) => _2222,
  /* c8 ignore next */
  _InErr: (_2222) => _2222,
  /* c8 ignore next */
  _InElem: (_2222) => _2222,
  /* c8 ignore next */
  _InDone: (_2222) => _2222,
  /* c8 ignore next */
  _OutErr: (_2222) => _2222,
  /* c8 ignore next */
  _OutElem: (_2222) => _2222,
  /* c8 ignore next */
  _OutDone: (_2222) => _2222
};
var EffectPrototype2222 = {
  [EffectTypeId2222]: effectVariance2222,
  [StreamTypeId2222]: effectVariance2222,
  [SinkTypeId2222]: sinkVariance2222,
  [ChannelTypeId2222]: channelVariance2222,
  [symbol22222](that) {
    return this === that;
  },
  [symbol3222]() {
    return cached2222(this, random2222(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen2222(new YieldWrap2222(this));
  },
  pipe() {
    return pipeArguments2222(this, arguments);
  }
};
var StructuralPrototype222 = {
  [symbol3222]() {
    return cached2222(this, structure222(this));
  },
  [symbol22222](that) {
    const selfKeys = Object.keys(this);
    const thatKeys = Object.keys(that);
    if (selfKeys.length !== thatKeys.length) {
      return false;
    }
    for (const key of selfKeys) {
      if (!(key in that && equals2222(this[key], that[key]))) {
        return false;
      }
    }
    return true;
  }
};
var CommitPrototype222 = {
  ...EffectPrototype2222,
  _op: OP_COMMIT222
};
var StructuralCommitPrototype222 = {
  ...CommitPrototype222,
  ...StructuralPrototype222
};
var TypeId5222 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto3222 = {
  ...EffectPrototype2222,
  [TypeId5222]: {
    _A: (_2222) => _2222
  },
  [NodeInspectSymbol2222]() {
    return this.toJSON();
  },
  toString() {
    return format2222(this.toJSON());
  }
};
var SomeProto2222 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto3222), {
  _tag: "Some",
  _op: "Some",
  [symbol22222](that) {
    return isOption3222(that) && isSome3222(that) && equals2222(this.value, that.value);
  },
  [symbol3222]() {
    return cached2222(this, combine2222(hash2222(this._tag))(hash2222(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON2222(this.value)
    };
  }
});
var NoneHash2222 = /* @__PURE__ */ hash2222("None");
var NoneProto2222 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto3222), {
  _tag: "None",
  _op: "None",
  [symbol22222](that) {
    return isOption3222(that) && isNone3222(that);
  },
  [symbol3222]() {
    return NoneHash2222;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption3222 = (input) => hasProperty2222(input, TypeId5222);
var isNone3222 = (fa) => fa._tag === "None";
var isSome3222 = (fa) => fa._tag === "Some";
var none3222 = /* @__PURE__ */ Object.create(NoneProto2222);
var some22222 = (value) => {
  const a2222 = Object.create(SomeProto2222);
  a2222.value = value;
  return a2222;
};
var TypeId22222 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto22222 = {
  ...EffectPrototype2222,
  [TypeId22222]: {
    _R: (_2222) => _2222
  },
  [NodeInspectSymbol2222]() {
    return this.toJSON();
  },
  toString() {
    return format2222(this.toJSON());
  }
};
var RightProto2222 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto22222), {
  _tag: "Right",
  _op: "Right",
  [symbol22222](that) {
    return isEither2222(that) && isRight2222(that) && equals2222(this.right, that.right);
  },
  [symbol3222]() {
    return combine2222(hash2222(this._tag))(hash2222(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON2222(this.right)
    };
  }
});
var LeftProto2222 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto22222), {
  _tag: "Left",
  _op: "Left",
  [symbol22222](that) {
    return isEither2222(that) && isLeft2222(that) && equals2222(this.left, that.left);
  },
  [symbol3222]() {
    return combine2222(hash2222(this._tag))(hash2222(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON2222(this.left)
    };
  }
});
var isEither2222 = (input) => hasProperty2222(input, TypeId22222);
var isLeft2222 = (ma) => ma._tag === "Left";
var isRight2222 = (ma) => ma._tag === "Right";
var left2222 = (left32222) => {
  const a2222 = Object.create(LeftProto2222);
  a2222.left = left32222;
  return a2222;
};
var right2222 = (right32222) => {
  const a2222 = Object.create(RightProto2222);
  a2222.right = right32222;
  return a2222;
};
var getLeft3222 = (self2) => isRight2222(self2) ? none3222 : some22222(self2.left);
var getRight3222 = (self2) => isLeft2222(self2) ? none3222 : some22222(self2.right);
var right22222 = right2222;
var left22222 = left2222;
var Option_exports2222 = {};
__export22222(Option_exports2222, {
  Do: () => Do2222,
  TypeId: () => TypeId32222,
  all: () => all22222,
  andThen: () => andThen2222,
  ap: () => ap2222,
  as: () => as2222,
  asVoid: () => asVoid2222,
  bind: () => bind22222,
  bindTo: () => bindTo22222,
  composeK: () => composeK2222,
  contains: () => contains2222,
  containsWith: () => containsWith2222,
  exists: () => exists2222,
  filter: () => filter2222,
  filterMap: () => filterMap2222,
  firstSomeOf: () => firstSomeOf2222,
  flatMap: () => flatMap2222,
  flatMapNullable: () => flatMapNullable2222,
  flatten: () => flatten2222,
  fromIterable: () => fromIterable2222,
  fromNullable: () => fromNullable2222,
  gen: () => gen2222,
  getEquivalence: () => getEquivalence2222,
  getLeft: () => getLeft22222,
  getOrElse: () => getOrElse2222,
  getOrNull: () => getOrNull2222,
  getOrThrow: () => getOrThrow2222,
  getOrThrowWith: () => getOrThrowWith2222,
  getOrUndefined: () => getOrUndefined2222,
  getOrder: () => getOrder2222,
  getRight: () => getRight22222,
  isNone: () => isNone22222,
  isOption: () => isOption22222,
  isSome: () => isSome22222,
  let: () => let_22222,
  lift2: () => lift22222,
  liftNullable: () => liftNullable2222,
  liftPredicate: () => liftPredicate2222,
  liftThrowable: () => liftThrowable2222,
  map: () => map2222,
  match: () => match2222,
  none: () => none22222,
  orElse: () => orElse2222,
  orElseEither: () => orElseEither2222,
  orElseSome: () => orElseSome2222,
  partitionMap: () => partitionMap2222,
  product: () => product22222,
  productMany: () => productMany22222,
  reduceCompact: () => reduceCompact2222,
  some: () => some32222,
  tap: () => tap2222,
  toArray: () => toArray2222,
  toRefinement: () => toRefinement2222,
  void: () => void_2222,
  zipLeft: () => zipLeft2222,
  zipRight: () => zipRight2222,
  zipWith: () => zipWith2222
});
var make22222 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId32222 = /* @__PURE__ */ Symbol.for("effect/Option");
var none22222 = () => none3222;
var some32222 = some22222;
var isOption22222 = isOption3222;
var isNone22222 = isNone3222;
var isSome22222 = isSome3222;
var match2222 = /* @__PURE__ */ dual2222(2, (self2, {
  onNone,
  onSome
}) => isNone22222(self2) ? onNone() : onSome(self2.value));
var toRefinement2222 = (f2222) => (a2222) => isSome22222(f2222(a2222));
var fromIterable2222 = (collection) => {
  for (const a2222 of collection) {
    return some32222(a2222);
  }
  return none22222();
};
var getRight22222 = getRight3222;
var getLeft22222 = getLeft3222;
var getOrElse2222 = /* @__PURE__ */ dual2222(2, (self2, onNone) => isNone22222(self2) ? onNone() : self2.value);
var orElse2222 = /* @__PURE__ */ dual2222(2, (self2, that) => isNone22222(self2) ? that() : self2);
var orElseSome2222 = /* @__PURE__ */ dual2222(2, (self2, onNone) => isNone22222(self2) ? some32222(onNone()) : self2);
var orElseEither2222 = /* @__PURE__ */ dual2222(2, (self2, that) => isNone22222(self2) ? map2222(that(), right2222) : map2222(self2, left2222));
var firstSomeOf2222 = (collection) => {
  let out = none22222();
  for (out of collection) {
    if (isSome22222(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable2222 = (nullableValue) => nullableValue == null ? none22222() : some32222(nullableValue);
var liftNullable2222 = (f2222) => (...a2222) => fromNullable2222(f2222(...a2222));
var getOrNull2222 = /* @__PURE__ */ getOrElse2222(constNull2222);
var getOrUndefined2222 = /* @__PURE__ */ getOrElse2222(constUndefined2222);
var liftThrowable2222 = (f2222) => (...a2222) => {
  try {
    return some32222(f2222(...a2222));
  } catch (e2222) {
    return none22222();
  }
};
var getOrThrowWith2222 = /* @__PURE__ */ dual2222(2, (self2, onNone) => {
  if (isSome22222(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow2222 = /* @__PURE__ */ getOrThrowWith2222(() => new Error("getOrThrow called on a None"));
var map2222 = /* @__PURE__ */ dual2222(2, (self2, f2222) => isNone22222(self2) ? none22222() : some32222(f2222(self2.value)));
var as2222 = /* @__PURE__ */ dual2222(2, (self2, b2222) => map2222(self2, () => b2222));
var asVoid2222 = /* @__PURE__ */ as2222(void 0);
var void_2222 = /* @__PURE__ */ some32222(void 0);
var flatMap2222 = /* @__PURE__ */ dual2222(2, (self2, f2222) => isNone22222(self2) ? none22222() : f2222(self2.value));
var andThen2222 = /* @__PURE__ */ dual2222(2, (self2, f2222) => flatMap2222(self2, (a2222) => {
  const b2222 = isFunction22222(f2222) ? f2222(a2222) : f2222;
  return isOption22222(b2222) ? b2222 : some32222(b2222);
}));
var flatMapNullable2222 = /* @__PURE__ */ dual2222(2, (self2, f2222) => isNone22222(self2) ? none22222() : fromNullable2222(f2222(self2.value)));
var flatten2222 = /* @__PURE__ */ flatMap2222(identity2222);
var zipRight2222 = /* @__PURE__ */ dual2222(2, (self2, that) => flatMap2222(self2, () => that));
var composeK2222 = /* @__PURE__ */ dual2222(2, (afb, bfc) => (a2222) => flatMap2222(afb(a2222), bfc));
var zipLeft2222 = /* @__PURE__ */ dual2222(2, (self2, that) => tap2222(self2, () => that));
var tap2222 = /* @__PURE__ */ dual2222(2, (self2, f2222) => flatMap2222(self2, (a2222) => map2222(f2222(a2222), () => a2222)));
var product22222 = (self2, that) => isSome22222(self2) && isSome22222(that) ? some32222([self2.value, that.value]) : none22222();
var productMany22222 = (self2, collection) => {
  if (isNone22222(self2)) {
    return none22222();
  }
  const out = [self2.value];
  for (const o2222 of collection) {
    if (isNone22222(o2222)) {
      return none22222();
    }
    out.push(o2222.value);
  }
  return some32222(out);
};
var all22222 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o2222 of input) {
      if (isNone22222(o2222)) {
        return none22222();
      }
      out2.push(o2222.value);
    }
    return some32222(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o2222 = input[key];
    if (isNone22222(o2222)) {
      return none22222();
    }
    out[key] = o2222.value;
  }
  return some32222(out);
};
var zipWith2222 = /* @__PURE__ */ dual2222(3, (self2, that, f2222) => map2222(product22222(self2, that), ([a2222, b2222]) => f2222(a2222, b2222)));
var ap2222 = /* @__PURE__ */ dual2222(2, (self2, that) => zipWith2222(self2, that, (f2222, a2222) => f2222(a2222)));
var reduceCompact2222 = /* @__PURE__ */ dual2222(3, (self2, b2222, f2222) => {
  let out = b2222;
  for (const oa of self2) {
    if (isSome22222(oa)) {
      out = f2222(out, oa.value);
    }
  }
  return out;
});
var toArray2222 = (self2) => isNone22222(self2) ? [] : [self2.value];
var partitionMap2222 = /* @__PURE__ */ dual2222(2, (self2, f2222) => {
  if (isNone22222(self2)) {
    return [none22222(), none22222()];
  }
  const e2222 = f2222(self2.value);
  return isLeft2222(e2222) ? [some32222(e2222.left), none22222()] : [none22222(), some32222(e2222.right)];
});
var filterMap2222 = /* @__PURE__ */ dual2222(2, (self2, f2222) => isNone22222(self2) ? none22222() : f2222(self2.value));
var filter2222 = /* @__PURE__ */ dual2222(2, (self2, predicate) => filterMap2222(self2, (b2222) => predicate(b2222) ? some22222(b2222) : none3222));
var getEquivalence2222 = (isEquivalent) => make4222((x2222, y2222) => x2222 === y2222 || (isNone22222(x2222) ? isNone22222(y2222) : isNone22222(y2222) ? false : isEquivalent(x2222.value, y2222.value)));
var getOrder2222 = (O2222) => make22222((self2, that) => isSome22222(self2) ? isSome22222(that) ? O2222(self2.value, that.value) : 1 : -1);
var lift22222 = (f2222) => dual2222(2, (self2, that) => zipWith2222(self2, that, f2222));
var liftPredicate2222 = (predicate) => (b2222) => predicate(b2222) ? some32222(b2222) : none22222();
var containsWith2222 = (isEquivalent) => dual2222(2, (self2, a2222) => isNone22222(self2) ? false : isEquivalent(self2.value, a2222));
var _equivalence2222 = /* @__PURE__ */ equivalence2222();
var contains2222 = /* @__PURE__ */ containsWith2222(_equivalence2222);
var exists2222 = /* @__PURE__ */ dual2222(2, (self2, refinement) => isNone22222(self2) ? false : refinement(self2.value));
var bindTo22222 = /* @__PURE__ */ bindTo3222(map2222);
var let_22222 = /* @__PURE__ */ let_3222(map2222);
var bind22222 = /* @__PURE__ */ bind3222(map2222, flatMap2222);
var Do2222 = /* @__PURE__ */ some32222({});
var adapter22222 = /* @__PURE__ */ adapter3222();
var gen2222 = (f2222) => {
  const iterator = f2222(adapter22222);
  let state = iterator.next();
  if (state.done) {
    return some32222(state.value);
  } else {
    let current = state.value;
    if (isGenKind2222(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet2222(current);
    }
    if (isNone22222(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind2222(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet2222(current);
        }
        if (isNone22222(current)) {
          return current;
        }
      }
    }
    return some32222(state.value);
  }
};
var fromIterable22222 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var reverse42 = (self2) => Array.from(self2).reverse();
var reduce52 = /* @__PURE__ */ dual2222(3, (self2, b2222, f2222) => fromIterable22222(self2).reduce((b22222, a2222, i2222) => f2222(b22222, a2222, i2222), b2222));
var TagTypeId222 = /* @__PURE__ */ Symbol.for("effect/Context/Tag");
var STMSymbolKey222 = "effect/STM";
var STMTypeId222 = /* @__PURE__ */ Symbol.for(STMSymbolKey222);
var TagProto222 = {
  ...EffectPrototype2222,
  _tag: "Tag",
  _op: "Tag",
  [STMTypeId222]: effectVariance2222,
  [TagTypeId222]: {
    _Service: (_2222) => _2222,
    _Identifier: (_2222) => _2222
  },
  toString() {
    return format2222(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Tag",
      key: this.key,
      stack: this.stack
    };
  },
  [NodeInspectSymbol2222]() {
    return this.toJSON();
  },
  of(self2) {
    return self2;
  },
  context(self2) {
    return make32222(this, self2);
  }
};
var makeGenericTag222 = (key) => {
  const limit = Error.stackTraceLimit;
  Error.stackTraceLimit = 2;
  const creationError = new Error();
  Error.stackTraceLimit = limit;
  const tag = Object.create(TagProto222);
  Object.defineProperty(tag, "stack", {
    get() {
      return creationError.stack;
    }
  });
  tag.key = key;
  return tag;
};
var TypeId42222 = /* @__PURE__ */ Symbol.for("effect/Context");
var ContextProto222 = {
  [TypeId42222]: {
    _Services: (_2222) => _2222
  },
  [symbol22222](that) {
    if (isContext222(that)) {
      if (this.unsafeMap.size === that.unsafeMap.size) {
        for (const k2222 of this.unsafeMap.keys()) {
          if (!that.unsafeMap.has(k2222) || !equals2222(this.unsafeMap.get(k2222), that.unsafeMap.get(k2222))) {
            return false;
          }
        }
        return true;
      }
    }
    return false;
  },
  [symbol3222]() {
    return cached2222(this, number2222(this.unsafeMap.size));
  },
  pipe() {
    return pipeArguments2222(this, arguments);
  },
  toString() {
    return format2222(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Context",
      services: Array.from(this.unsafeMap).map(toJSON2222)
    };
  },
  [NodeInspectSymbol2222]() {
    return this.toJSON();
  }
};
var makeContext222 = (unsafeMap) => {
  const context = Object.create(ContextProto222);
  context.unsafeMap = unsafeMap;
  return context;
};
var isContext222 = (u2222) => hasProperty2222(u2222, TypeId42222);
var _empty622 = /* @__PURE__ */ makeContext222(/* @__PURE__ */ new Map());
var empty102 = () => _empty622;
var make32222 = (tag, service) => makeContext222(/* @__PURE__ */ new Map([[tag.key, service]]));
var GenericTag222 = makeGenericTag222;
var empty2222 = empty102;
var TypeId52222 = /* @__PURE__ */ Symbol.for("effect/Chunk");
function copy32(src, srcPos, dest, destPos, len) {
  for (let i2222 = srcPos; i2222 < Math.min(src.length, srcPos + len); i2222++) {
    dest[destPos + i2222 - srcPos] = src[i2222];
  }
  return dest;
}
var emptyArray222 = [];
var getEquivalence22222 = (isEquivalent) => make4222((self2, that) => self2.length === that.length && toReadonlyArray222(self2).every((value, i2222) => isEquivalent(value, unsafeGet2222(that, i2222))));
var _equivalence22222 = /* @__PURE__ */ getEquivalence22222(equals2222);
var ChunkProto222 = {
  [TypeId52222]: {
    _A: (_2222) => _2222
  },
  toString() {
    return format2222(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Chunk",
      values: toReadonlyArray222(this).map(toJSON2222)
    };
  },
  [NodeInspectSymbol2222]() {
    return this.toJSON();
  },
  [symbol22222](that) {
    return isChunk222(that) && _equivalence22222(this, that);
  },
  [symbol3222]() {
    return cached2222(this, array52(toReadonlyArray222(this)));
  },
  [Symbol.iterator]() {
    switch (this.backing._tag) {
      case "IArray": {
        return this.backing.array[Symbol.iterator]();
      }
      case "IEmpty": {
        return emptyArray222[Symbol.iterator]();
      }
      default: {
        return toReadonlyArray222(this)[Symbol.iterator]();
      }
    }
  },
  pipe() {
    return pipeArguments2222(this, arguments);
  }
};
var makeChunk222 = (backing) => {
  const chunk = Object.create(ChunkProto222);
  chunk.backing = backing;
  switch (backing._tag) {
    case "IEmpty": {
      chunk.length = 0;
      chunk.depth = 0;
      chunk.left = chunk;
      chunk.right = chunk;
      break;
    }
    case "IConcat": {
      chunk.length = backing.left.length + backing.right.length;
      chunk.depth = 1 + Math.max(backing.left.depth, backing.right.depth);
      chunk.left = backing.left;
      chunk.right = backing.right;
      break;
    }
    case "IArray": {
      chunk.length = backing.array.length;
      chunk.depth = 0;
      chunk.left = _empty2222;
      chunk.right = _empty2222;
      break;
    }
    case "ISingleton": {
      chunk.length = 1;
      chunk.depth = 0;
      chunk.left = _empty2222;
      chunk.right = _empty2222;
      break;
    }
    case "ISlice": {
      chunk.length = backing.length;
      chunk.depth = backing.chunk.depth + 1;
      chunk.left = _empty2222;
      chunk.right = _empty2222;
      break;
    }
  }
  return chunk;
};
var isChunk222 = (u2222) => hasProperty2222(u2222, TypeId52222);
var _empty2222 = /* @__PURE__ */ makeChunk222({
  _tag: "IEmpty"
});
var empty3222 = () => _empty2222;
var make42222 = (...as222222) => as222222.length === 1 ? of32(as222222[0]) : unsafeFromNonEmptyArray222(as222222);
var of32 = (a2222) => makeChunk222({
  _tag: "ISingleton",
  a: a2222
});
var copyToArray222 = (self2, array32222, initial) => {
  switch (self2.backing._tag) {
    case "IArray": {
      copy32(self2.backing.array, 0, array32222, initial, self2.length);
      break;
    }
    case "IConcat": {
      copyToArray222(self2.left, array32222, initial);
      copyToArray222(self2.right, array32222, initial + self2.left.length);
      break;
    }
    case "ISingleton": {
      array32222[initial] = self2.backing.a;
      break;
    }
    case "ISlice": {
      let i2222 = 0;
      let j2222 = initial;
      while (i2222 < self2.length) {
        array32222[j2222] = unsafeGet2222(self2, i2222);
        i2222 += 1;
        j2222 += 1;
      }
      break;
    }
  }
};
var toReadonlyArray222 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      return emptyArray222;
    }
    case "IArray": {
      return self2.backing.array;
    }
    default: {
      const arr = new Array(self2.length);
      copyToArray222(self2, arr, 0);
      self2.backing = {
        _tag: "IArray",
        array: arr
      };
      self2.left = _empty2222;
      self2.right = _empty2222;
      self2.depth = 0;
      return arr;
    }
  }
};
var reverse2222 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty":
    case "ISingleton":
      return self2;
    case "IArray": {
      return makeChunk222({
        _tag: "IArray",
        array: reverse42(self2.backing.array)
      });
    }
    case "IConcat": {
      return makeChunk222({
        _tag: "IConcat",
        left: reverse2222(self2.backing.right),
        right: reverse2222(self2.backing.left)
      });
    }
    case "ISlice":
      return unsafeFromArray222(reverse42(toReadonlyArray222(self2)));
  }
};
var unsafeFromArray222 = (self2) => makeChunk222({
  _tag: "IArray",
  array: self2
});
var unsafeFromNonEmptyArray222 = (self2) => unsafeFromArray222(self2);
var unsafeGet2222 = /* @__PURE__ */ dual2222(2, (self2, index) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      throw new Error(`Index out of bounds`);
    }
    case "ISingleton": {
      if (index !== 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.a;
    }
    case "IArray": {
      if (index >= self2.length || index < 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.array[index];
    }
    case "IConcat": {
      return index < self2.left.length ? unsafeGet2222(self2.left, index) : unsafeGet2222(self2.right, index - self2.left.length);
    }
    case "ISlice": {
      return unsafeGet2222(self2.backing.chunk, index + self2.backing.offset);
    }
  }
});
var prepend32 = /* @__PURE__ */ dual2222(2, (self2, elem) => appendAll32(of32(elem), self2));
var drop32 = /* @__PURE__ */ dual2222(2, (self2, n2222) => {
  if (n2222 <= 0) {
    return self2;
  } else if (n2222 >= self2.length) {
    return _empty2222;
  } else {
    switch (self2.backing._tag) {
      case "ISlice": {
        return makeChunk222({
          _tag: "ISlice",
          chunk: self2.backing.chunk,
          offset: self2.backing.offset + n2222,
          length: self2.backing.length - n2222
        });
      }
      case "IConcat": {
        if (n2222 > self2.left.length) {
          return drop32(self2.right, n2222 - self2.left.length);
        }
        return makeChunk222({
          _tag: "IConcat",
          left: drop32(self2.left, n2222),
          right: self2.right
        });
      }
      default: {
        return makeChunk222({
          _tag: "ISlice",
          chunk: self2,
          offset: n2222,
          length: self2.length - n2222
        });
      }
    }
  }
});
var appendAll32 = /* @__PURE__ */ dual2222(2, (self2, that) => {
  if (self2.backing._tag === "IEmpty") {
    return that;
  }
  if (that.backing._tag === "IEmpty") {
    return self2;
  }
  const diff22222 = that.depth - self2.depth;
  if (Math.abs(diff22222) <= 1) {
    return makeChunk222({
      _tag: "IConcat",
      left: self2,
      right: that
    });
  } else if (diff22222 < -1) {
    if (self2.left.depth >= self2.right.depth) {
      const nr = appendAll32(self2.right, that);
      return makeChunk222({
        _tag: "IConcat",
        left: self2.left,
        right: nr
      });
    } else {
      const nrr = appendAll32(self2.right.right, that);
      if (nrr.depth === self2.depth - 3) {
        const nr = makeChunk222({
          _tag: "IConcat",
          left: self2.right.left,
          right: nrr
        });
        return makeChunk222({
          _tag: "IConcat",
          left: self2.left,
          right: nr
        });
      } else {
        const nl = makeChunk222({
          _tag: "IConcat",
          left: self2.left,
          right: self2.right.left
        });
        return makeChunk222({
          _tag: "IConcat",
          left: nl,
          right: nrr
        });
      }
    }
  } else {
    if (that.right.depth >= that.left.depth) {
      const nl = appendAll32(self2, that.left);
      return makeChunk222({
        _tag: "IConcat",
        left: nl,
        right: that.right
      });
    } else {
      const nll = appendAll32(self2, that.left.left);
      if (nll.depth === that.depth - 3) {
        const nl = makeChunk222({
          _tag: "IConcat",
          left: nll,
          right: that.left.right
        });
        return makeChunk222({
          _tag: "IConcat",
          left: nl,
          right: that.right
        });
      } else {
        const nr = makeChunk222({
          _tag: "IConcat",
          left: that.left.right,
          right: that.right
        });
        return makeChunk222({
          _tag: "IConcat",
          left: nll,
          right: nr
        });
      }
    }
  }
});
var isEmpty222 = (self2) => self2.length === 0;
var isNonEmpty222 = (self2) => self2.length > 0;
var unsafeHead222 = (self2) => unsafeGet2222(self2, 0);
var headNonEmpty32 = unsafeHead222;
var tailNonEmpty32 = (self2) => drop32(self2, 1);
var SIZE222 = 5;
var BUCKET_SIZE222 = /* @__PURE__ */ Math.pow(2, SIZE222);
var MASK222 = BUCKET_SIZE222 - 1;
var MAX_INDEX_NODE222 = BUCKET_SIZE222 / 2;
var MIN_ARRAY_NODE222 = BUCKET_SIZE222 / 4;
function popcount222(x2222) {
  x2222 -= x2222 >> 1 & 1431655765;
  x2222 = (x2222 & 858993459) + (x2222 >> 2 & 858993459);
  x2222 = x2222 + (x2222 >> 4) & 252645135;
  x2222 += x2222 >> 8;
  x2222 += x2222 >> 16;
  return x2222 & 127;
}
function hashFragment222(shift22, h2222) {
  return h2222 >>> shift22 & MASK222;
}
function toBitmap222(x2222) {
  return 1 << x2222;
}
function fromBitmap222(bitmap, bit) {
  return popcount222(bitmap & bit - 1);
}
var make5222 = (value, previous) => ({
  value,
  previous
});
function arrayUpdate222(mutate22222, at, v2222, arr) {
  let out = arr;
  if (!mutate22222) {
    const len = arr.length;
    out = new Array(len);
    for (let i2222 = 0; i2222 < len; ++i2222) out[i2222] = arr[i2222];
  }
  out[at] = v2222;
  return out;
}
function arraySpliceOut222(mutate22222, at, arr) {
  const newLen = arr.length - 1;
  let i2222 = 0;
  let g2222 = 0;
  let out = arr;
  if (mutate22222) {
    i2222 = g2222 = at;
  } else {
    out = new Array(newLen);
    while (i2222 < at) out[g2222++] = arr[i2222++];
  }
  ++i2222;
  while (i2222 <= newLen) out[g2222++] = arr[i2222++];
  if (mutate22222) {
    out.length = newLen;
  }
  return out;
}
function arraySpliceIn222(mutate22222, at, v2222, arr) {
  const len = arr.length;
  if (mutate22222) {
    let i22222 = len;
    while (i22222 >= at) arr[i22222--] = arr[i22222];
    arr[at] = v2222;
    return arr;
  }
  let i2222 = 0, g2222 = 0;
  const out = new Array(len + 1);
  while (i2222 < at) out[g2222++] = arr[i2222++];
  out[at] = v2222;
  while (i2222 < len) out[++g2222] = arr[i2222++];
  return out;
}
var EmptyNode222 = class _EmptyNode222 {
  _tag = "EmptyNode";
  modify(edit, _shift, f2222, hash222222, key, size42222) {
    const v2222 = f2222(none22222());
    if (isNone22222(v2222)) return new _EmptyNode222();
    ++size42222.value;
    return new LeafNode222(edit, hash222222, key, v2222);
  }
};
function isEmptyNode222(a2222) {
  return isTagged32(a2222, "EmptyNode");
}
function isLeafNode222(node) {
  return isEmptyNode222(node) || node._tag === "LeafNode" || node._tag === "CollisionNode";
}
function canEditNode222(node, edit) {
  return isEmptyNode222(node) ? false : edit === node.edit;
}
var LeafNode222 = class _LeafNode222 {
  edit;
  hash;
  key;
  value;
  _tag = "LeafNode";
  constructor(edit, hash222222, key, value) {
    this.edit = edit;
    this.hash = hash222222;
    this.key = key;
    this.value = value;
  }
  modify(edit, shift22, f2222, hash222222, key, size42222) {
    if (equals2222(key, this.key)) {
      const v22222 = f2222(this.value);
      if (v22222 === this.value) return this;
      else if (isNone22222(v22222)) {
        --size42222.value;
        return new EmptyNode222();
      }
      if (canEditNode222(this, edit)) {
        this.value = v22222;
        return this;
      }
      return new _LeafNode222(edit, hash222222, key, v22222);
    }
    const v2222 = f2222(none22222());
    if (isNone22222(v2222)) return this;
    ++size42222.value;
    return mergeLeaves222(edit, shift22, this.hash, this, hash222222, new _LeafNode222(edit, hash222222, key, v2222));
  }
};
var CollisionNode222 = class _CollisionNode222 {
  edit;
  hash;
  children;
  _tag = "CollisionNode";
  constructor(edit, hash222222, children) {
    this.edit = edit;
    this.hash = hash222222;
    this.children = children;
  }
  modify(edit, shift22, f2222, hash222222, key, size42222) {
    if (hash222222 === this.hash) {
      const canEdit = canEditNode222(this, edit);
      const list = this.updateCollisionList(canEdit, edit, this.hash, this.children, f2222, key, size42222);
      if (list === this.children) return this;
      return list.length > 1 ? new _CollisionNode222(edit, this.hash, list) : list[0];
    }
    const v2222 = f2222(none22222());
    if (isNone22222(v2222)) return this;
    ++size42222.value;
    return mergeLeaves222(edit, shift22, this.hash, this, hash222222, new LeafNode222(edit, hash222222, key, v2222));
  }
  updateCollisionList(mutate22222, edit, hash222222, list, f2222, key, size42222) {
    const len = list.length;
    for (let i2222 = 0; i2222 < len; ++i2222) {
      const child = list[i2222];
      if ("key" in child && equals2222(key, child.key)) {
        const value = child.value;
        const newValue2 = f2222(value);
        if (newValue2 === value) return list;
        if (isNone22222(newValue2)) {
          --size42222.value;
          return arraySpliceOut222(mutate22222, i2222, list);
        }
        return arrayUpdate222(mutate22222, i2222, new LeafNode222(edit, hash222222, key, newValue2), list);
      }
    }
    const newValue = f2222(none22222());
    if (isNone22222(newValue)) return list;
    ++size42222.value;
    return arrayUpdate222(mutate22222, len, new LeafNode222(edit, hash222222, key, newValue), list);
  }
};
var IndexedNode222 = class _IndexedNode222 {
  edit;
  mask;
  children;
  _tag = "IndexedNode";
  constructor(edit, mask, children) {
    this.edit = edit;
    this.mask = mask;
    this.children = children;
  }
  modify(edit, shift22, f2222, hash222222, key, size42222) {
    const mask = this.mask;
    const children = this.children;
    const frag = hashFragment222(shift22, hash222222);
    const bit = toBitmap222(frag);
    const indx = fromBitmap222(mask, bit);
    const exists222222 = mask & bit;
    const canEdit = canEditNode222(this, edit);
    if (!exists222222) {
      const _newChild = new EmptyNode222().modify(edit, shift22 + SIZE222, f2222, hash222222, key, size42222);
      if (!_newChild) return this;
      return children.length >= MAX_INDEX_NODE222 ? expand222(edit, frag, _newChild, mask, children) : new _IndexedNode222(edit, mask | bit, arraySpliceIn222(canEdit, indx, _newChild, children));
    }
    const current = children[indx];
    const child = current.modify(edit, shift22 + SIZE222, f2222, hash222222, key, size42222);
    if (current === child) return this;
    let bitmap = mask;
    let newChildren;
    if (isEmptyNode222(child)) {
      bitmap &= ~bit;
      if (!bitmap) return new EmptyNode222();
      if (children.length <= 2 && isLeafNode222(children[indx ^ 1])) {
        return children[indx ^ 1];
      }
      newChildren = arraySpliceOut222(canEdit, indx, children);
    } else {
      newChildren = arrayUpdate222(canEdit, indx, child, children);
    }
    if (canEdit) {
      this.mask = bitmap;
      this.children = newChildren;
      return this;
    }
    return new _IndexedNode222(edit, bitmap, newChildren);
  }
};
var ArrayNode222 = class _ArrayNode222 {
  edit;
  size;
  children;
  _tag = "ArrayNode";
  constructor(edit, size42222, children) {
    this.edit = edit;
    this.size = size42222;
    this.children = children;
  }
  modify(edit, shift22, f2222, hash222222, key, size42222) {
    let count = this.size;
    const children = this.children;
    const frag = hashFragment222(shift22, hash222222);
    const child = children[frag];
    const newChild = (child || new EmptyNode222()).modify(edit, shift22 + SIZE222, f2222, hash222222, key, size42222);
    if (child === newChild) return this;
    const canEdit = canEditNode222(this, edit);
    let newChildren;
    if (isEmptyNode222(child) && !isEmptyNode222(newChild)) {
      ++count;
      newChildren = arrayUpdate222(canEdit, frag, newChild, children);
    } else if (!isEmptyNode222(child) && isEmptyNode222(newChild)) {
      --count;
      if (count <= MIN_ARRAY_NODE222) {
        return pack222(edit, count, frag, children);
      }
      newChildren = arrayUpdate222(canEdit, frag, new EmptyNode222(), children);
    } else {
      newChildren = arrayUpdate222(canEdit, frag, newChild, children);
    }
    if (canEdit) {
      this.size = count;
      this.children = newChildren;
      return this;
    }
    return new _ArrayNode222(edit, count, newChildren);
  }
};
function pack222(edit, count, removed, elements) {
  const children = new Array(count - 1);
  let g2222 = 0;
  let bitmap = 0;
  for (let i2222 = 0, len = elements.length; i2222 < len; ++i2222) {
    if (i2222 !== removed) {
      const elem = elements[i2222];
      if (elem && !isEmptyNode222(elem)) {
        children[g2222++] = elem;
        bitmap |= 1 << i2222;
      }
    }
  }
  return new IndexedNode222(edit, bitmap, children);
}
function expand222(edit, frag, child, bitmap, subNodes) {
  const arr = [];
  let bit = bitmap;
  let count = 0;
  for (let i2222 = 0; bit; ++i2222) {
    if (bit & 1) arr[i2222] = subNodes[count++];
    bit >>>= 1;
  }
  arr[frag] = child;
  return new ArrayNode222(edit, count + 1, arr);
}
function mergeLeavesInner222(edit, shift22, h1, n1, h2222, n2222) {
  if (h1 === h2222) return new CollisionNode222(edit, h1, [n2222, n1]);
  const subH1 = hashFragment222(shift22, h1);
  const subH2 = hashFragment222(shift22, h2222);
  if (subH1 === subH2) {
    return (child) => new IndexedNode222(edit, toBitmap222(subH1) | toBitmap222(subH2), [child]);
  } else {
    const children = subH1 < subH2 ? [n1, n2222] : [n2222, n1];
    return new IndexedNode222(edit, toBitmap222(subH1) | toBitmap222(subH2), children);
  }
}
function mergeLeaves222(edit, shift22, h1, n1, h2222, n2222) {
  let stack = void 0;
  let currentShift = shift22;
  while (true) {
    const res = mergeLeavesInner222(edit, currentShift, h1, n1, h2222, n2222);
    if (typeof res === "function") {
      stack = make5222(res, stack);
      currentShift = currentShift + SIZE222;
    } else {
      let final = res;
      while (stack != null) {
        final = stack.value(final);
        stack = stack.previous;
      }
      return final;
    }
  }
}
var HashMapSymbolKey222 = "effect/HashMap";
var HashMapTypeId222 = /* @__PURE__ */ Symbol.for(HashMapSymbolKey222);
var HashMapProto222 = {
  [HashMapTypeId222]: HashMapTypeId222,
  [Symbol.iterator]() {
    return new HashMapIterator222(this, (k2222, v2222) => [k2222, v2222]);
  },
  [symbol3222]() {
    let hash222222 = hash2222(HashMapSymbolKey222);
    for (const item of this) {
      hash222222 ^= pipe2222(hash2222(item[0]), combine2222(hash2222(item[1])));
    }
    return cached2222(this, hash222222);
  },
  [symbol22222](that) {
    if (isHashMap222(that)) {
      if (that._size !== this._size) {
        return false;
      }
      for (const item of this) {
        const elem = pipe2222(that, getHash222(item[0], hash2222(item[0])));
        if (isNone22222(elem)) {
          return false;
        } else {
          if (!equals2222(item[1], elem.value)) {
            return false;
          }
        }
      }
      return true;
    }
    return false;
  },
  toString() {
    return format2222(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashMap",
      values: Array.from(this).map(toJSON2222)
    };
  },
  [NodeInspectSymbol2222]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments2222(this, arguments);
  }
};
var makeImpl322 = (editable, edit, root, size42222) => {
  const map622 = Object.create(HashMapProto222);
  map622._editable = editable;
  map622._edit = edit;
  map622._root = root;
  map622._size = size42222;
  return map622;
};
var HashMapIterator222 = class _HashMapIterator222 {
  map;
  f;
  v;
  constructor(map622, f2222) {
    this.map = map622;
    this.f = f2222;
    this.v = visitLazy222(this.map._root, this.f, void 0);
  }
  next() {
    if (isNone22222(this.v)) {
      return {
        done: true,
        value: void 0
      };
    }
    const v0 = this.v.value;
    this.v = applyCont222(v0.cont);
    return {
      done: false,
      value: v0.value
    };
  }
  [Symbol.iterator]() {
    return new _HashMapIterator222(this.map, this.f);
  }
};
var applyCont222 = (cont) => cont ? visitLazyChildren222(cont[0], cont[1], cont[2], cont[3], cont[4]) : none22222();
var visitLazy222 = (node, f2222, cont = void 0) => {
  switch (node._tag) {
    case "LeafNode": {
      if (isSome22222(node.value)) {
        return some32222({
          value: f2222(node.key, node.value.value),
          cont
        });
      }
      return applyCont222(cont);
    }
    case "CollisionNode":
    case "ArrayNode":
    case "IndexedNode": {
      const children = node.children;
      return visitLazyChildren222(children.length, children, 0, f2222, cont);
    }
    default: {
      return applyCont222(cont);
    }
  }
};
var visitLazyChildren222 = (len, children, i2222, f2222, cont) => {
  while (i2222 < len) {
    const child = children[i2222++];
    if (child && !isEmptyNode222(child)) {
      return visitLazy222(child, f2222, [len, children, i2222, f2222, cont]);
    }
  }
  return applyCont222(cont);
};
var _empty3222 = /* @__PURE__ */ makeImpl322(false, 0, /* @__PURE__ */ new EmptyNode222(), 0);
var empty4222 = () => _empty3222;
var isHashMap222 = (u2222) => hasProperty2222(u2222, HashMapTypeId222);
var getHash222 = /* @__PURE__ */ dual2222(3, (self2, key, hash222222) => {
  let node = self2._root;
  let shift22 = 0;
  while (true) {
    switch (node._tag) {
      case "LeafNode": {
        return equals2222(key, node.key) ? node.value : none22222();
      }
      case "CollisionNode": {
        if (hash222222 === node.hash) {
          const children = node.children;
          for (let i2222 = 0, len = children.length; i2222 < len; ++i2222) {
            const child = children[i2222];
            if ("key" in child && equals2222(key, child.key)) {
              return child.value;
            }
          }
        }
        return none22222();
      }
      case "IndexedNode": {
        const frag = hashFragment222(shift22, hash222222);
        const bit = toBitmap222(frag);
        if (node.mask & bit) {
          node = node.children[fromBitmap222(node.mask, bit)];
          shift22 += SIZE222;
          break;
        }
        return none22222();
      }
      case "ArrayNode": {
        node = node.children[hashFragment222(shift22, hash222222)];
        if (node) {
          shift22 += SIZE222;
          break;
        }
        return none22222();
      }
      default:
        return none22222();
    }
  }
});
var set2222 = /* @__PURE__ */ dual2222(3, (self2, key, value) => modifyAt222(self2, key, () => some32222(value)));
var setTree222 = /* @__PURE__ */ dual2222(3, (self2, newRoot, newSize) => {
  if (self2._editable) {
    self2._root = newRoot;
    self2._size = newSize;
    return self2;
  }
  return newRoot === self2._root ? self2 : makeImpl322(self2._editable, self2._edit, newRoot, newSize);
});
var keys32 = (self2) => new HashMapIterator222(self2, (key) => key);
var size422 = (self2) => self2._size;
var beginMutation322 = (self2) => makeImpl322(true, self2._edit + 1, self2._root, self2._size);
var modifyAt222 = /* @__PURE__ */ dual2222(3, (self2, key, f2222) => modifyHash222(self2, key, hash2222(key), f2222));
var modifyHash222 = /* @__PURE__ */ dual2222(4, (self2, key, hash222222, f2222) => {
  const size42222 = {
    value: self2._size
  };
  const newRoot = self2._root.modify(self2._editable ? self2._edit : NaN, 0, f2222, hash222222, key, size42222);
  return pipe2222(self2, setTree222(newRoot, size42222.value));
});
var forEach42 = /* @__PURE__ */ dual2222(2, (self2, f2222) => reduce2222(self2, void 0, (_2222, value, key) => f2222(value, key)));
var reduce2222 = /* @__PURE__ */ dual2222(3, (self2, zero, f2222) => {
  const root = self2._root;
  if (root._tag === "LeafNode") {
    return isSome22222(root.value) ? f2222(zero, root.value.value, root.key) : zero;
  }
  if (root._tag === "EmptyNode") {
    return zero;
  }
  const toVisit = [root.children];
  let children;
  while (children = toVisit.pop()) {
    for (let i2222 = 0, len = children.length; i2222 < len; ) {
      const child = children[i2222++];
      if (child && !isEmptyNode222(child)) {
        if (child._tag === "LeafNode") {
          if (isSome22222(child.value)) {
            zero = f2222(zero, child.value.value, child.key);
          }
        } else {
          toVisit.push(child.children);
        }
      }
    }
  }
  return zero;
});
var HashSetSymbolKey222 = "effect/HashSet";
var HashSetTypeId222 = /* @__PURE__ */ Symbol.for(HashSetSymbolKey222);
var HashSetProto222 = {
  [HashSetTypeId222]: HashSetTypeId222,
  [Symbol.iterator]() {
    return keys32(this._keyMap);
  },
  [symbol3222]() {
    return cached2222(this, combine2222(hash2222(this._keyMap))(hash2222(HashSetSymbolKey222)));
  },
  [symbol22222](that) {
    if (isHashSet222(that)) {
      return size422(this._keyMap) === size422(that._keyMap) && equals2222(this._keyMap, that._keyMap);
    }
    return false;
  },
  toString() {
    return format2222(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashSet",
      values: Array.from(this).map(toJSON2222)
    };
  },
  [NodeInspectSymbol2222]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments2222(this, arguments);
  }
};
var makeImpl2222 = (keyMap) => {
  const set222222 = Object.create(HashSetProto222);
  set222222._keyMap = keyMap;
  return set222222;
};
var isHashSet222 = (u2222) => hasProperty2222(u2222, HashSetTypeId222);
var _empty4222 = /* @__PURE__ */ makeImpl2222(/* @__PURE__ */ empty4222());
var empty5222 = () => _empty4222;
var size2222 = (self2) => size422(self2._keyMap);
var beginMutation2222 = (self2) => makeImpl2222(beginMutation322(self2._keyMap));
var endMutation222 = (self2) => {
  self2._keyMap._editable = false;
  return self2;
};
var mutate222 = /* @__PURE__ */ dual2222(2, (self2, f2222) => {
  const transient = beginMutation2222(self2);
  f2222(transient);
  return endMutation222(transient);
});
var add2222 = /* @__PURE__ */ dual2222(2, (self2, value) => self2._keyMap._editable ? (set2222(value, true)(self2._keyMap), self2) : makeImpl2222(set2222(value, true)(self2._keyMap)));
var union2222 = /* @__PURE__ */ dual2222(2, (self2, that) => mutate222(empty5222(), (set222222) => {
  forEach2222(self2, (value) => add2222(set222222, value));
  for (const value of that) {
    add2222(set222222, value);
  }
}));
var forEach2222 = /* @__PURE__ */ dual2222(2, (self2, f2222) => forEach42(self2._keyMap, (_2222, k2222) => f2222(k2222)));
var empty6222 = empty5222;
var size3222 = size2222;
var add3222 = add2222;
var union3222 = union2222;
var ArrayProto222 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(Array.prototype), {
  [symbol3222]() {
    return cached2222(this, array52(this));
  },
  [symbol22222](that) {
    if (Array.isArray(that) && this.length === that.length) {
      return this.every((v2222, i2222) => equals2222(v2222, that[i2222]));
    } else {
      return false;
    }
  }
});
var Structural322 = /* @__PURE__ */ function() {
  function Structural32222(args) {
    if (args) {
      Object.assign(this, args);
    }
  }
  Structural32222.prototype = StructuralPrototype222;
  return Structural32222;
}();
var struct2222 = (as222222) => Object.assign(Object.create(StructuralPrototype222), as222222);
var ContextPatchTypeId222 = /* @__PURE__ */ Symbol.for("effect/DifferContextPatch");
function variance322(a2222) {
  return a2222;
}
var PatchProto222 = {
  ...Structural322.prototype,
  [ContextPatchTypeId222]: {
    _Value: variance322,
    _Patch: variance322
  }
};
var EmptyProto222 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto222), {
  _tag: "Empty"
});
var _empty5222 = /* @__PURE__ */ Object.create(EmptyProto222);
var empty7222 = () => _empty5222;
var AndThenProto222 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto222), {
  _tag: "AndThen"
});
var makeAndThen222 = (first, second) => {
  const o2222 = Object.create(AndThenProto222);
  o2222.first = first;
  o2222.second = second;
  return o2222;
};
var AddServiceProto222 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto222), {
  _tag: "AddService"
});
var makeAddService222 = (key, service) => {
  const o2222 = Object.create(AddServiceProto222);
  o2222.key = key;
  o2222.service = service;
  return o2222;
};
var RemoveServiceProto222 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto222), {
  _tag: "RemoveService"
});
var makeRemoveService222 = (key) => {
  const o2222 = Object.create(RemoveServiceProto222);
  o2222.key = key;
  return o2222;
};
var UpdateServiceProto222 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto222), {
  _tag: "UpdateService"
});
var makeUpdateService222 = (key, update222) => {
  const o2222 = Object.create(UpdateServiceProto222);
  o2222.key = key;
  o2222.update = update222;
  return o2222;
};
var diff222 = (oldValue, newValue) => {
  const missingServices = new Map(oldValue.unsafeMap);
  let patch22222 = empty7222();
  for (const [tag, newService] of newValue.unsafeMap.entries()) {
    if (missingServices.has(tag)) {
      const old = missingServices.get(tag);
      missingServices.delete(tag);
      if (!equals2222(old, newService)) {
        patch22222 = combine22222(makeUpdateService222(tag, () => newService))(patch22222);
      }
    } else {
      missingServices.delete(tag);
      patch22222 = combine22222(makeAddService222(tag, newService))(patch22222);
    }
  }
  for (const [tag] of missingServices.entries()) {
    patch22222 = combine22222(makeRemoveService222(tag))(patch22222);
  }
  return patch22222;
};
var combine22222 = /* @__PURE__ */ dual2222(2, (self2, that) => makeAndThen222(self2, that));
var patch222 = /* @__PURE__ */ dual2222(2, (self2, context) => {
  if (self2._tag === "Empty") {
    return context;
  }
  let wasServiceUpdated = false;
  let patches = of32(self2);
  const updatedContext = new Map(context.unsafeMap);
  while (isNonEmpty222(patches)) {
    const head222 = headNonEmpty32(patches);
    const tail222 = tailNonEmpty32(patches);
    switch (head222._tag) {
      case "Empty": {
        patches = tail222;
        break;
      }
      case "AddService": {
        updatedContext.set(head222.key, head222.service);
        patches = tail222;
        break;
      }
      case "AndThen": {
        patches = prepend32(prepend32(tail222, head222.second), head222.first);
        break;
      }
      case "RemoveService": {
        updatedContext.delete(head222.key);
        patches = tail222;
        break;
      }
      case "UpdateService": {
        updatedContext.set(head222.key, head222.update(updatedContext.get(head222.key)));
        wasServiceUpdated = true;
        patches = tail222;
        break;
      }
    }
  }
  if (!wasServiceUpdated) {
    return makeContext222(updatedContext);
  }
  const map622 = /* @__PURE__ */ new Map();
  for (const [tag] of context.unsafeMap) {
    if (updatedContext.has(tag)) {
      map622.set(tag, updatedContext.get(tag));
      updatedContext.delete(tag);
    }
  }
  for (const [tag, s2222] of updatedContext) {
    map622.set(tag, s2222);
  }
  return makeContext222(map622);
});
var DifferTypeId222 = /* @__PURE__ */ Symbol.for("effect/Differ");
var DifferProto222 = {
  [DifferTypeId222]: {
    _P: identity2222,
    _V: identity2222
  }
};
var make7222 = (params) => {
  const differ = Object.create(DifferProto222);
  differ.empty = params.empty;
  differ.diff = params.diff;
  differ.combine = params.combine;
  differ.patch = params.patch;
  return differ;
};
var environment222 = () => make7222({
  empty: empty7222(),
  combine: (first, second) => combine22222(second)(first),
  diff: (oldValue, newValue) => diff222(oldValue, newValue),
  patch: (patch22222, oldValue) => patch222(oldValue)(patch22222)
});
var OP_DIE222 = "Die";
var OP_EMPTY222 = "Empty";
var OP_FAIL222 = "Fail";
var OP_INTERRUPT222 = "Interrupt";
var OP_PARALLEL222 = "Parallel";
var OP_SEQUENTIAL222 = "Sequential";
var CauseSymbolKey222 = "effect/Cause";
var CauseTypeId222 = /* @__PURE__ */ Symbol.for(CauseSymbolKey222);
var variance2222 = {
  /* c8 ignore next */
  _E: (_2222) => _2222
};
var proto222 = {
  [CauseTypeId222]: variance2222,
  [symbol3222]() {
    return pipe2222(hash2222(CauseSymbolKey222), combine2222(hash2222(flattenCause222(this))), cached2222(this));
  },
  [symbol22222](that) {
    return isCause222(that) && causeEquals222(this, that);
  },
  pipe() {
    return pipeArguments2222(this, arguments);
  },
  toJSON() {
    switch (this._tag) {
      case "Empty":
        return {
          _id: "Cause",
          _tag: this._tag
        };
      case "Die":
        return {
          _id: "Cause",
          _tag: this._tag,
          defect: toJSON2222(this.defect)
        };
      case "Interrupt":
        return {
          _id: "Cause",
          _tag: this._tag,
          fiberId: this.fiberId.toJSON()
        };
      case "Fail":
        return {
          _id: "Cause",
          _tag: this._tag,
          failure: toJSON2222(this.error)
        };
      case "Sequential":
      case "Parallel":
        return {
          _id: "Cause",
          _tag: this._tag,
          left: toJSON2222(this.left),
          right: toJSON2222(this.right)
        };
    }
  },
  toString() {
    return pretty222(this);
  },
  [NodeInspectSymbol2222]() {
    return this.toJSON();
  }
};
var fail322 = (error) => {
  const o2222 = Object.create(proto222);
  o2222._tag = OP_FAIL222;
  o2222.error = error;
  return o2222;
};
var parallel222 = (left32222, right32222) => {
  const o2222 = Object.create(proto222);
  o2222._tag = OP_PARALLEL222;
  o2222.left = left32222;
  o2222.right = right32222;
  return o2222;
};
var sequential222 = (left32222, right32222) => {
  const o2222 = Object.create(proto222);
  o2222._tag = OP_SEQUENTIAL222;
  o2222.left = left32222;
  o2222.right = right32222;
  return o2222;
};
var isCause222 = (u2222) => hasProperty2222(u2222, CauseTypeId222);
var isInterruptedOnly222 = (self2) => reduceWithContext222(void 0, IsInterruptedOnlyCauseReducer222)(self2);
var causeEquals222 = (left32222, right32222) => {
  let leftStack = of32(left32222);
  let rightStack = of32(right32222);
  while (isNonEmpty222(leftStack) && isNonEmpty222(rightStack)) {
    const [leftParallel, leftSequential] = pipe2222(headNonEmpty32(leftStack), reduce4222([empty6222(), empty3222()], ([parallel22222, sequential22222], cause) => {
      const [par, seq] = evaluateCause222(cause);
      return some32222([pipe2222(parallel22222, union3222(par)), pipe2222(sequential22222, appendAll32(seq))]);
    }));
    const [rightParallel, rightSequential] = pipe2222(headNonEmpty32(rightStack), reduce4222([empty6222(), empty3222()], ([parallel22222, sequential22222], cause) => {
      const [par, seq] = evaluateCause222(cause);
      return some32222([pipe2222(parallel22222, union3222(par)), pipe2222(sequential22222, appendAll32(seq))]);
    }));
    if (!equals2222(leftParallel, rightParallel)) {
      return false;
    }
    leftStack = leftSequential;
    rightStack = rightSequential;
  }
  return true;
};
var flattenCause222 = (cause) => {
  return flattenCauseLoop222(of32(cause), empty3222());
};
var flattenCauseLoop222 = (causes, flattened) => {
  while (1) {
    const [parallel22222, sequential22222] = pipe2222(causes, reduce52([empty6222(), empty3222()], ([parallel322, sequential322], cause) => {
      const [par, seq] = evaluateCause222(cause);
      return [pipe2222(parallel322, union3222(par)), pipe2222(sequential322, appendAll32(seq))];
    }));
    const updated = size3222(parallel22222) > 0 ? pipe2222(flattened, prepend32(parallel22222)) : flattened;
    if (isEmpty222(sequential22222)) {
      return reverse2222(updated);
    }
    causes = sequential22222;
    flattened = updated;
  }
  throw new Error(getBugErrorMessage2222("Cause.flattenCauseLoop"));
};
var evaluateCause222 = (self2) => {
  let cause = self2;
  const stack = [];
  let _parallel = empty6222();
  let _sequential = empty3222();
  while (cause !== void 0) {
    switch (cause._tag) {
      case OP_EMPTY222: {
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_FAIL222: {
        _parallel = add3222(_parallel, make42222(cause._tag, cause.error));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_DIE222: {
        _parallel = add3222(_parallel, make42222(cause._tag, cause.defect));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_INTERRUPT222: {
        _parallel = add3222(_parallel, make42222(cause._tag, cause.fiberId));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_SEQUENTIAL222: {
        switch (cause.left._tag) {
          case OP_EMPTY222: {
            cause = cause.right;
            break;
          }
          case OP_SEQUENTIAL222: {
            cause = sequential222(cause.left.left, sequential222(cause.left.right, cause.right));
            break;
          }
          case OP_PARALLEL222: {
            cause = parallel222(sequential222(cause.left.left, cause.right), sequential222(cause.left.right, cause.right));
            break;
          }
          default: {
            _sequential = prepend32(_sequential, cause.right);
            cause = cause.left;
            break;
          }
        }
        break;
      }
      case OP_PARALLEL222: {
        stack.push(cause.right);
        cause = cause.left;
        break;
      }
    }
  }
  throw new Error(getBugErrorMessage2222("Cause.evaluateCauseLoop"));
};
var IsInterruptedOnlyCauseReducer222 = {
  emptyCase: constTrue2222,
  failCase: constFalse2222,
  dieCase: constFalse2222,
  interruptCase: constTrue2222,
  sequentialCase: (_2222, left32222, right32222) => left32222 && right32222,
  parallelCase: (_2222, left32222, right32222) => left32222 && right32222
};
var OP_SEQUENTIAL_CASE222 = "SequentialCase";
var OP_PARALLEL_CASE222 = "ParallelCase";
var reduce4222 = /* @__PURE__ */ dual2222(3, (self2, zero, pf) => {
  let accumulator = zero;
  let cause = self2;
  const causes = [];
  while (cause !== void 0) {
    const option = pf(accumulator, cause);
    accumulator = isSome22222(option) ? option.value : accumulator;
    switch (cause._tag) {
      case OP_SEQUENTIAL222: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      case OP_PARALLEL222: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      default: {
        cause = void 0;
        break;
      }
    }
    if (cause === void 0 && causes.length > 0) {
      cause = causes.pop();
    }
  }
  return accumulator;
});
var reduceWithContext222 = /* @__PURE__ */ dual2222(3, (self2, context, reducer) => {
  const input = [self2];
  const output = [];
  while (input.length > 0) {
    const cause = input.pop();
    switch (cause._tag) {
      case OP_EMPTY222: {
        output.push(right22222(reducer.emptyCase(context)));
        break;
      }
      case OP_FAIL222: {
        output.push(right22222(reducer.failCase(context, cause.error)));
        break;
      }
      case OP_DIE222: {
        output.push(right22222(reducer.dieCase(context, cause.defect)));
        break;
      }
      case OP_INTERRUPT222: {
        output.push(right22222(reducer.interruptCase(context, cause.fiberId)));
        break;
      }
      case OP_SEQUENTIAL222: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left22222({
          _tag: OP_SEQUENTIAL_CASE222
        }));
        break;
      }
      case OP_PARALLEL222: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left22222({
          _tag: OP_PARALLEL_CASE222
        }));
        break;
      }
    }
  }
  const accumulator = [];
  while (output.length > 0) {
    const either = output.pop();
    switch (either._tag) {
      case "Left": {
        switch (either.left._tag) {
          case OP_SEQUENTIAL_CASE222: {
            const left32222 = accumulator.pop();
            const right32222 = accumulator.pop();
            const value = reducer.sequentialCase(context, left32222, right32222);
            accumulator.push(value);
            break;
          }
          case OP_PARALLEL_CASE222: {
            const left32222 = accumulator.pop();
            const right32222 = accumulator.pop();
            const value = reducer.parallelCase(context, left32222, right32222);
            accumulator.push(value);
            break;
          }
        }
        break;
      }
      case "Right": {
        accumulator.push(either.right);
        break;
      }
    }
  }
  if (accumulator.length === 0) {
    throw new Error("BUG: Cause.reduceWithContext - please report an issue at https://github.com/Effect-TS/effect/issues");
  }
  return accumulator.pop();
});
var pretty222 = (cause) => {
  if (isInterruptedOnly222(cause)) {
    return "All fibers interrupted without errors.";
  }
  return prettyErrors222(cause).map((e2222) => e2222.stack).join("\n");
};
var PrettyError222 = class extends globalThis.Error {
  span = void 0;
  constructor(originalError) {
    const prevLimit = Error.stackTraceLimit;
    Error.stackTraceLimit = 0;
    super(prettyErrorMessage222(originalError));
    Error.stackTraceLimit = prevLimit;
    this.name = originalError instanceof Error ? originalError.name : "Error";
    if (typeof originalError === "object" && originalError !== null) {
      if (spanSymbol322 in originalError) {
        this.span = originalError[spanSymbol322];
      }
      Object.keys(originalError).forEach((key) => {
        if (!(key in this)) {
          this[key] = originalError[key];
        }
      });
    }
    this.stack = prettyErrorStack222(this.message, originalError instanceof Error && originalError.stack ? originalError.stack : "", this.span);
  }
  toJSON() {
    const out = {
      message: this.message,
      stack: this.stack
    };
    if (this.span) {
      out.span = this.span;
    }
    return out;
  }
};
var prettyErrorMessage222 = (u2222) => {
  if (typeof u2222 === "string") {
    return `Error: ${u2222}`;
  }
  try {
    if (hasProperty2222(u2222, "toString") && isFunction3222(u2222["toString"]) && u2222["toString"] !== Object.prototype.toString && u2222["toString"] !== globalThis.Array.prototype.toString) {
      return u2222["toString"]();
    }
  } catch {
  }
  return `Error: ${JSON.stringify(u2222)}`;
};
var locationRegex222 = /\((.*)\)/;
var spanToTrace222 = /* @__PURE__ */ globalValue2222("effect/Tracer/spanToTrace", () => /* @__PURE__ */ new WeakMap());
var prettyErrorStack222 = (message, stack, span222) => {
  const out = [message];
  const lines = stack.split("\n");
  for (let i2222 = 1; i2222 < lines.length; i2222++) {
    if (lines[i2222].includes("Generator.next")) {
      break;
    }
    if (lines[i2222].includes("effect_internal_function")) {
      out.pop();
      break;
    }
    out.push(lines[i2222].replace(/at .*effect_instruction_i.*\((.*)\)/, "at $1").replace(/EffectPrimitive\.\w+/, "<anonymous>"));
  }
  if (span222) {
    let current = span222;
    let i2222 = 0;
    while (current && current._tag === "Span" && i2222 < 10) {
      const stackFn = spanToTrace222.get(current);
      if (typeof stackFn === "function") {
        const stack2 = stackFn();
        const locationMatch = stack2.match(locationRegex222);
        const location = locationMatch ? locationMatch[1] : stack2.replace(/^at /, "");
        out.push(`    at ${current.name} (${location})`);
      } else {
        out.push(`    at ${current.name}`);
      }
      current = getOrUndefined2222(current.parent);
      i2222++;
    }
  }
  return out.join("\n");
};
var spanSymbol322 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var prettyErrors222 = (cause) => reduceWithContext222(cause, void 0, {
  emptyCase: () => [],
  dieCase: (_2222, unknownError) => {
    return [new PrettyError222(unknownError)];
  },
  failCase: (_2222, error) => {
    return [new PrettyError222(error)];
  },
  interruptCase: () => [],
  parallelCase: (_2222, l2222, r2222) => [...l2222, ...r2222],
  sequentialCase: (_2222, l2222, r2222) => [...l2222, ...r2222]
});
var SingleShotGen22222 = class _SingleShotGen2222 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  next(a2222) {
    return this.called ? {
      value: a2222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  return(a2222) {
    return {
      value: a2222,
      done: true
    };
  }
  throw(e2222) {
    throw e2222;
  }
  [Symbol.iterator]() {
    return new _SingleShotGen2222(this.self);
  }
};
var spanTag222 = /* @__PURE__ */ GenericTag222("effect/ParentSpan");
var EffectTypeId22222 = /* @__PURE__ */ Symbol.for("effect/Effect");
var EffectPrimitive222 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId22222] = effectVariance2222;
  constructor(_op) {
    this._op = _op;
  }
  [symbol22222](that) {
    return this === that;
  }
  [symbol3222]() {
    return cached2222(this, random2222(this));
  }
  pipe() {
    return pipeArguments2222(this, arguments);
  }
  toJSON() {
    return {
      _id: "Effect",
      _op: this._op,
      effect_instruction_i0: toJSON2222(this.effect_instruction_i0),
      effect_instruction_i1: toJSON2222(this.effect_instruction_i1),
      effect_instruction_i2: toJSON2222(this.effect_instruction_i2)
    };
  }
  toString() {
    return format2222(this.toJSON());
  }
  [NodeInspectSymbol2222]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen22222(new YieldWrap2222(this));
  }
};
var EffectPrimitiveFailure222 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId22222] = effectVariance2222;
  constructor(_op) {
    this._op = _op;
    this._tag = _op;
  }
  [symbol22222](that) {
    return exitIsExit222(that) && that._op === "Failure" && // @ts-expect-error
    equals2222(this.effect_instruction_i0, that.effect_instruction_i0);
  }
  [symbol3222]() {
    return pipe2222(
      // @ts-expect-error
      string2222(this._tag),
      // @ts-expect-error
      combine2222(hash2222(this.effect_instruction_i0)),
      cached2222(this)
    );
  }
  get cause() {
    return this.effect_instruction_i0;
  }
  pipe() {
    return pipeArguments2222(this, arguments);
  }
  toJSON() {
    return {
      _id: "Exit",
      _tag: this._op,
      cause: this.cause.toJSON()
    };
  }
  toString() {
    return format2222(this.toJSON());
  }
  [NodeInspectSymbol2222]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen22222(new YieldWrap2222(this));
  }
};
var isEffect222 = (u2222) => hasProperty2222(u2222, EffectTypeId22222);
var withFiberRuntime222 = (withRuntime) => {
  const effect = new EffectPrimitive222(OP_WITH_RUNTIME222);
  effect.effect_instruction_i0 = withRuntime;
  return effect;
};
var spanSymbol2222 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var originalSymbol222 = /* @__PURE__ */ Symbol.for("effect/OriginalAnnotation");
var capture222 = (obj, span222) => {
  if (isSome22222(span222)) {
    return new Proxy(obj, {
      has(target, p2222) {
        return p2222 === spanSymbol2222 || p2222 === originalSymbol222 || p2222 in target;
      },
      get(target, p2222) {
        if (p2222 === spanSymbol2222) {
          return span222.value;
        }
        if (p2222 === originalSymbol222) {
          return obj;
        }
        return target[p2222];
      }
    });
  }
  return obj;
};
var fail2222 = (error) => isObject2222(error) && !(spanSymbol2222 in error) ? withFiberRuntime222((fiber) => failCause222(fail322(capture222(error, currentSpanFromFiber222(fiber))))) : failCause222(fail322(error));
var failCause222 = (cause) => {
  const effect = new EffectPrimitiveFailure222(OP_FAILURE222);
  effect.effect_instruction_i0 = cause;
  return effect;
};
var FiberRefSymbolKey222 = "effect/FiberRef";
var FiberRefTypeId222 = /* @__PURE__ */ Symbol.for(FiberRefSymbolKey222);
var fiberRefVariance222 = {
  /* c8 ignore next */
  _A: (_2222) => _2222
};
var fiberRefUnsafeMakeContext222 = (initial) => {
  const differ = environment222();
  return fiberRefUnsafeMakePatch222(initial, {
    differ,
    fork: differ.empty
  });
};
var fiberRefUnsafeMakePatch222 = (initial, options) => ({
  [FiberRefTypeId222]: fiberRefVariance222,
  initial,
  diff: (oldValue, newValue) => options.differ.diff(oldValue, newValue),
  combine: (first, second) => options.differ.combine(first, second),
  patch: (patch22222) => (oldValue) => options.differ.patch(patch22222, oldValue),
  fork: options.fork,
  join: options.join ?? ((_2222, n2222) => n2222),
  pipe() {
    return pipeArguments2222(this, arguments);
  }
});
var currentContext222 = /* @__PURE__ */ globalValue2222(/* @__PURE__ */ Symbol.for("effect/FiberRef/currentContext"), () => fiberRefUnsafeMakeContext222(empty2222()));
var YieldableError222 = /* @__PURE__ */ function() {
  class YieldableError22222 extends globalThis.Error {
    commit() {
      return fail2222(this);
    }
    toString() {
      return this.message ? `${this.name}: ${this.message}` : this.name;
    }
    toJSON() {
      return {
        ...this
      };
    }
    [NodeInspectSymbol2222]() {
      const stack = this.stack;
      if (stack) {
        return `${this.toString()}
${stack.split("\n").slice(1).join("\n")}`;
      }
      return this.toString();
    }
  }
  Object.assign(YieldableError22222.prototype, StructuralCommitPrototype222);
  return YieldableError22222;
}();
var exitIsExit222 = (u2222) => isEffect222(u2222) && "_tag" in u2222 && (u2222._tag === "Success" || u2222._tag === "Failure");
var currentSpanFromFiber222 = (fiber) => {
  const span222 = fiber.getFiberRef(currentContext222).unsafeMap.get(spanTag222.key);
  return span222 !== void 0 && span222._tag === "Span" ? some32222(span222) : none22222();
};
var Data_exports222 = {};
__export22222(Data_exports222, {
  Class: () => Class2222,
  Error: () => Error2222,
  Structural: () => Structural2222,
  TaggedClass: () => TaggedClass222,
  TaggedError: () => TaggedError222,
  array: () => array2222,
  case: () => _case222,
  struct: () => struct3222,
  tagged: () => tagged222,
  taggedEnum: () => taggedEnum222,
  tuple: () => tuple2222,
  unsafeArray: () => unsafeArray222,
  unsafeStruct: () => unsafeStruct222
});
var struct3222 = struct2222;
var unsafeStruct222 = (as222222) => Object.setPrototypeOf(as222222, StructuralPrototype222);
var tuple2222 = (...as222222) => unsafeArray222(as222222);
var array2222 = (as222222) => unsafeArray222(as222222.slice(0));
var unsafeArray222 = (as222222) => Object.setPrototypeOf(as222222, ArrayProto222);
var _case222 = () => (args) => args === void 0 ? Object.create(StructuralPrototype222) : struct3222(args);
var tagged222 = (tag) => (args) => {
  const value = args === void 0 ? Object.create(StructuralPrototype222) : struct3222(args);
  value._tag = tag;
  return value;
};
var Class2222 = Structural322;
var TaggedClass222 = (tag) => {
  class Base extends Class2222 {
    _tag = tag;
  }
  return Base;
};
var Structural2222 = Structural322;
var taggedEnum222 = () => new Proxy({}, {
  get(_target, tag, _receiver) {
    if (tag === "$is") {
      return isTagged32;
    } else if (tag === "$match") {
      return taggedMatch222;
    }
    return tagged222(tag);
  }
});
function taggedMatch222() {
  if (arguments.length === 1) {
    const cases2 = arguments[0];
    return function(value2) {
      return cases2[value2._tag](value2);
    };
  }
  const value = arguments[0];
  const cases = arguments[1];
  return cases[value._tag](value);
}
var Error2222 = /* @__PURE__ */ function() {
  return class Base extends YieldableError222 {
    constructor(args) {
      super();
      if (args) {
        Object.assign(this, args);
      }
    }
  };
}();
var TaggedError222 = (tag) => {
  class Base extends Error2222 {
    _tag = tag;
  }
  Base.prototype.name = tag;
  return Base;
};
var traverseUp222 = Function_exports2222.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType222.Program) return Option_exports2222.none();
  return predicate(parent) ? Option_exports2222.some(parent) : traverseUp222(parent, predicate);
});
var traverseUpGuard222 = Function_exports2222.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType222.Program) return Option_exports2222.none();
  return predicate(parent) ? Option_exports2222.some(parent) : traverseUpGuard222(parent, predicate);
});
var ESLintCommunityESLintUtils222;
((ESLintCommunityESLintUtils22222) => {
  ESLintCommunityESLintUtils22222.getFunctionHeadLocation = getFunctionHeadLocation222;
  ESLintCommunityESLintUtils22222.getFunctionNameWithKind = getFunctionNameWithKind222;
  ESLintCommunityESLintUtils22222.getPropertyName = getPropertyName222;
  ESLintCommunityESLintUtils22222.getStaticValue = getStaticValue222;
  ESLintCommunityESLintUtils22222.getStringIfConstant = getStringIfConstant222;
  ESLintCommunityESLintUtils22222.hasSideEffect = hasSideEffect222;
  ESLintCommunityESLintUtils22222.isParenthesized = isParenthesized222;
})(ESLintCommunityESLintUtils222 || (ESLintCommunityESLintUtils222 = {}));
var Construction222 = Data_exports222.taggedEnum();
Construction222.None();
a3({
  type: N3.union([NodeType222.FunctionExpression, NodeType222.ArrowFunctionExpression]),
  parent: {
    type: NodeType222.Property,
    parent: {
      type: NodeType222.ObjectExpression
    }
  }
});
a3({
  type: N3.union([NodeType222.FunctionExpression, NodeType222.ArrowFunctionExpression]),
  parent: {
    type: NodeType222.MethodDefinition,
    parent: {
      type: NodeType222.ClassBody
    }
  }
});
a3({
  type: N3.union([NodeType222.FunctionExpression, NodeType222.ArrowFunctionExpression]),
  parent: {
    type: NodeType222.Property,
    parent: {
      type: NodeType222.ClassBody
    }
  }
});
function getVariableInit2(at) {
  return (variable) => {
    return Function_exports32.pipe(
      Option_exports32.some(variable),
      Option_exports32.flatMapNullable((v2222) => v2222.defs.at(at)),
      Option_exports32.flatMap(
        (d2222) => "init" in d2222.node ? Option_exports32.fromNullable(d2222.node.init) : Option_exports32.none()
      )
    );
  };
}
isOneOf22([NodeType22.Literal, NodeType22.JSXText]);
var JSXValueHint2 = {
  None: 0n,
  SkipNullLiteral: 1n << 0n,
  SkipUndefinedLiteral: 1n << 1n,
  SkipBooleanLiteral: 1n << 2n,
  SkipStringLiteral: 1n << 3n,
  SkipNumberLiteral: 1n << 4n,
  SkipCreateElement: 1n << 5n,
  StrictArray: 1n << 6n,
  StrictLogical: 1n << 7n,
  StrictConditional: 1n << 8n
};
var DEFAULT_JSX_VALUE_HINT2 = JSXValueHint2.SkipUndefinedLiteral | JSXValueHint2.SkipBooleanLiteral;
function isJSXValue(node, context, hint = DEFAULT_JSX_VALUE_HINT2) {
  if (!node) return false;
  return $(node).with({ type: NodeType22.JSXElement }, Function_exports222.constTrue).with({ type: NodeType22.JSXFragment }, Function_exports222.constTrue).with({ type: NodeType22.JSXMemberExpression }, Function_exports222.constTrue).with({ type: NodeType22.JSXNamespacedName }, Function_exports222.constTrue).with({ type: NodeType22.Literal }, (node2) => {
    return $(node2.value).with(null, () => !(hint & JSXValueHint2.SkipNullLiteral)).with(N.boolean, () => !(hint & JSXValueHint2.SkipBooleanLiteral)).with(N.string, () => !(hint & JSXValueHint2.SkipStringLiteral)).with(N.number, () => !(hint & JSXValueHint2.SkipNumberLiteral)).otherwise(Function_exports222.constFalse);
  }).with({ type: NodeType22.TemplateLiteral }, () => !(hint & JSXValueHint2.SkipStringLiteral)).with({ type: NodeType22.ArrayExpression }, (node2) => {
    if (hint & JSXValueHint2.StrictArray) return node2.elements.every((n2222) => isJSXValue(n2222, context, hint));
    return node2.elements.some((n2222) => isJSXValue(n2222, context, hint));
  }).with({ type: NodeType22.ConditionalExpression }, (node2) => {
    function leftHasJSX(node3) {
      if (Array.isArray(node3.consequent)) {
        if (hint & JSXValueHint2.StrictArray) {
          return node3.consequent.every((n2222) => isJSXValue(n2222, context, hint));
        }
        return node3.consequent.some((n2222) => isJSXValue(n2222, context, hint));
      }
      return isJSXValue(node3.consequent, context, hint);
    }
    function rightHasJSX(node3) {
      return isJSXValue(node3.alternate, context, hint);
    }
    if (hint & JSXValueHint2.StrictConditional) {
      return leftHasJSX(node2) && rightHasJSX(node2);
    }
    return leftHasJSX(node2) || rightHasJSX(node2);
  }).with({ type: NodeType22.LogicalExpression }, (node2) => {
    return isJSXValue(node2.left, context, hint) || isJSXValue(node2.right, context, hint);
  }).with({ type: NodeType22.SequenceExpression }, (node2) => {
    const exp = node2.expressions.at(-1);
    return isJSXValue(exp, context, hint);
  }).with({ type: NodeType22.CallExpression }, (node2) => {
    if (hint & JSXValueHint2.SkipCreateElement) return false;
    return $(node2.callee).with({ type: NodeType22.Identifier, name: "createElement" }, Function_exports222.constTrue).with({ type: NodeType22.MemberExpression, property: { name: "createElement" } }, Function_exports222.constTrue).otherwise(Function_exports222.constFalse);
  }).with({ type: NodeType22.Identifier }, (node2) => {
    const { name: name22 } = node2;
    if (name22 === "undefined") return !(hint & JSXValueHint2.SkipUndefinedLiteral);
    if (isJSXTagNameExpression22(node2)) return true;
    const initialScope = context.sourceCode.getScope(node2);
    const maybeVariable = findVariable222(name22, initialScope);
    return Function_exports222.pipe(
      maybeVariable,
      Option_exports222.flatMap(getVariableInit2(0)),
      Option_exports222.exists((n2222) => isJSXValue(n2222, context, hint))
    );
  }).otherwise(Function_exports222.constFalse);
}
var Function_exports42 = {};
__export5(Function_exports42, {
  SK: () => SK42,
  absurd: () => absurd42,
  apply: () => apply42,
  compose: () => compose62,
  constFalse: () => constFalse42,
  constNull: () => constNull42,
  constTrue: () => constTrue42,
  constUndefined: () => constUndefined42,
  constVoid: () => constVoid42,
  constant: () => constant42,
  dual: () => dual42,
  flip: () => flip42,
  flow: () => flow42,
  hole: () => hole42,
  identity: () => identity42,
  isFunction: () => isFunction72,
  pipe: () => pipe42,
  satisfies: () => satisfies42,
  tupled: () => tupled42,
  unsafeCoerce: () => unsafeCoerce42,
  untupled: () => untupled42
});
var isFunction72 = (input) => typeof input === "function";
var dual42 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a322, b322) {
        if (arguments.length >= 2) {
          return body(a322, b322);
        }
        return function(self2) {
          return body(self2, a322);
        };
      };
    case 3:
      return function(a322, b322, c322) {
        if (arguments.length >= 3) {
          return body(a322, b322, c322);
        }
        return function(self2) {
          return body(self2, a322, b322);
        };
      };
    case 4:
      return function(a322, b322, c322, d322) {
        if (arguments.length >= 4) {
          return body(a322, b322, c322, d322);
        }
        return function(self2) {
          return body(self2, a322, b322, c322);
        };
      };
    case 5:
      return function(a322, b322, c322, d322, e322) {
        if (arguments.length >= 5) {
          return body(a322, b322, c322, d322, e322);
        }
        return function(self2) {
          return body(self2, a322, b322, c322, d322);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply42 = (a322) => (self2) => self2(a322);
var identity42 = (a322) => a322;
var satisfies42 = () => (b322) => b322;
var unsafeCoerce42 = identity42;
var constant42 = (value) => () => value;
var constTrue42 = /* @__PURE__ */ constant42(true);
var constFalse42 = /* @__PURE__ */ constant42(false);
var constNull42 = /* @__PURE__ */ constant42(null);
var constUndefined42 = /* @__PURE__ */ constant42(void 0);
var constVoid42 = constUndefined42;
var flip42 = (f322) => (...b322) => (...a322) => f322(...a322)(...b322);
var compose62 = /* @__PURE__ */ dual42(2, (ab, bc) => (a322) => bc(ab(a322)));
var absurd42 = (_322) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled42 = (f322) => (a322) => f322(...a322);
var untupled42 = (f322) => (...a322) => f322(a322);
function pipe42(a322, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a322;
    case 2:
      return ab(a322);
    case 3:
      return bc(ab(a322));
    case 4:
      return cd(bc(ab(a322)));
    case 5:
      return de(cd(bc(ab(a322))));
    case 6:
      return ef(de(cd(bc(ab(a322)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a322))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a322)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a322))))))));
    default: {
      let ret = arguments[0];
      for (let i322 = 1; i322 < arguments.length; i322++) {
        ret = arguments[i322](ret);
      }
      return ret;
    }
  }
}
function flow42(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole42 = /* @__PURE__ */ unsafeCoerce42(absurd42);
var SK42 = (_322, b322) => b322;
var make122 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_72 = (map722) => dual42(3, (self2, name22, f322) => map722(self2, (a322) => Object.assign({}, a322, {
  [name22]: f322(a322)
})));
var bindTo72 = (map722) => dual42(2, (self2, name22) => map722(self2, (a322) => ({
  [name22]: a322
})));
var bind72 = (map722, flatMap722) => dual42(3, (self2, name22, f322) => flatMap722(self2, (a322) => map722(f322(a322), (b322) => Object.assign({}, a322, {
  [name22]: b322
}))));
var moduleVersion42 = "3.2.8";
var getCurrentVersion42 = () => moduleVersion42;
var globalStoreId42 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion42()}`);
if (!(globalStoreId42 in globalThis)) {
  globalThis[globalStoreId42] = /* @__PURE__ */ new Map();
}
var globalStore42 = globalThis[globalStoreId42];
var globalValue42 = (id, compute) => {
  if (!globalStore42.has(id)) {
    globalStore42.set(id, compute());
  }
  return globalStore42.get(id);
};
var Predicate_exports32 = {};
__export5(Predicate_exports32, {
  all: () => all62,
  and: () => and42,
  compose: () => compose72,
  eqv: () => eqv42,
  every: () => every52,
  hasProperty: () => hasProperty42,
  implies: () => implies42,
  isBigInt: () => isBigInt42,
  isBoolean: () => isBoolean42,
  isDate: () => isDate42,
  isError: () => isError42,
  isFunction: () => isFunction8,
  isIterable: () => isIterable42,
  isMap: () => isMap42,
  isNever: () => isNever42,
  isNotNull: () => isNotNull42,
  isNotNullable: () => isNotNullable42,
  isNotUndefined: () => isNotUndefined42,
  isNull: () => isNull42,
  isNullable: () => isNullable42,
  isNumber: () => isNumber42,
  isObject: () => isObject42,
  isPromise: () => isPromise42,
  isPromiseLike: () => isPromiseLike42,
  isReadonlyRecord: () => isReadonlyRecord42,
  isRecord: () => isRecord42,
  isSet: () => isSet42,
  isString: () => isString42,
  isSymbol: () => isSymbol42,
  isTagged: () => isTagged42,
  isTruthy: () => isTruthy42,
  isUint8Array: () => isUint8Array42,
  isUndefined: () => isUndefined42,
  isUnknown: () => isUnknown42,
  mapInput: () => mapInput52,
  nand: () => nand42,
  nor: () => nor42,
  not: () => not42,
  or: () => or42,
  product: () => product62,
  productMany: () => productMany62,
  some: () => some92,
  struct: () => struct62,
  tuple: () => tuple52,
  xor: () => xor42
});
var mapInput52 = /* @__PURE__ */ dual42(2, (self2, f322) => (b322) => self2(f322(b322)));
var isTruthy42 = (input) => !!input;
var isSet42 = (input) => input instanceof Set;
var isMap42 = (input) => input instanceof Map;
var isString42 = (input) => typeof input === "string";
var isNumber42 = (input) => typeof input === "number";
var isBoolean42 = (input) => typeof input === "boolean";
var isBigInt42 = (input) => typeof input === "bigint";
var isSymbol42 = (input) => typeof input === "symbol";
var isFunction8 = isFunction72;
var isUndefined42 = (input) => input === void 0;
var isNotUndefined42 = (input) => input !== void 0;
var isNull42 = (input) => input === null;
var isNotNull42 = (input) => input !== null;
var isNever42 = (_322) => false;
var isUnknown42 = (_322) => true;
var isRecordOrArray42 = (input) => typeof input === "object" && input !== null;
var isObject42 = (input) => isRecordOrArray42(input) || isFunction8(input);
var hasProperty42 = /* @__PURE__ */ dual42(2, (self2, property) => isObject42(self2) && property in self2);
var isTagged42 = /* @__PURE__ */ dual42(2, (self2, tag) => hasProperty42(self2, "_tag") && self2["_tag"] === tag);
var isNullable42 = (input) => input === null || input === void 0;
var isNotNullable42 = (input) => input !== null && input !== void 0;
var isError42 = (input) => input instanceof Error;
var isUint8Array42 = (input) => input instanceof Uint8Array;
var isDate42 = (input) => input instanceof Date;
var isIterable42 = (input) => hasProperty42(input, Symbol.iterator);
var isRecord42 = (input) => isRecordOrArray42(input) && !Array.isArray(input);
var isReadonlyRecord42 = isRecord42;
var isPromise42 = (input) => hasProperty42(input, "then") && "catch" in input && isFunction8(input.then) && isFunction8(input.catch);
var isPromiseLike42 = (input) => hasProperty42(input, "then") && isFunction8(input.then);
var compose72 = /* @__PURE__ */ dual42(2, (ab, bc) => (a322) => ab(a322) && bc(a322));
var product62 = (self2, that) => ([a322, b322]) => self2(a322) && that(b322);
var all62 = (collection) => {
  return (as622) => {
    let collectionIndex = 0;
    for (const p322 of collection) {
      if (collectionIndex >= as622.length) {
        break;
      }
      if (p322(as622[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany62 = (self2, collection) => {
  const rest = all62(collection);
  return ([head322, ...tail322]) => self2(head322) === false ? false : rest(tail322);
};
var tuple52 = (...elements) => all62(elements);
var struct62 = (fields) => {
  const keys522 = Object.keys(fields);
  return (a322) => {
    for (const key of keys522) {
      if (!fields[key](a322[key])) {
        return false;
      }
    }
    return true;
  };
};
var not42 = (self2) => (a322) => !self2(a322);
var or42 = /* @__PURE__ */ dual42(2, (self2, that) => (a322) => self2(a322) || that(a322));
var and42 = /* @__PURE__ */ dual42(2, (self2, that) => (a322) => self2(a322) && that(a322));
var xor42 = /* @__PURE__ */ dual42(2, (self2, that) => (a322) => self2(a322) !== that(a322));
var eqv42 = /* @__PURE__ */ dual42(2, (self2, that) => (a322) => self2(a322) === that(a322));
var implies42 = /* @__PURE__ */ dual42(2, (self2, that) => (a322) => self2(a322) ? that(a322) : true);
var nor42 = /* @__PURE__ */ dual42(2, (self2, that) => (a322) => !(self2(a322) || that(a322)));
var nand42 = /* @__PURE__ */ dual42(2, (self2, that) => (a322) => !(self2(a322) && that(a322)));
var every52 = (collection) => (a322) => {
  for (const p322 of collection) {
    if (!p322(a322)) {
      return false;
    }
  }
  return true;
};
var some92 = (collection) => (a322) => {
  for (const p322 of collection) {
    if (p322(a322)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage42 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId42 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind42 = (u322) => isObject42(u322) && GenKindTypeId42 in u322;
var GenKindImpl42 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity42;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_322) => _322;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_322) => _322;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_322) => _322;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId42] = GenKindTypeId42;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen52(this);
  }
};
var SingleShotGen52 = class _SingleShotGen72 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a322) {
    return this.called ? {
      value: a322,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a322) {
    return {
      value: a322,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e322) {
    throw e322;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen72(this.self);
  }
};
var adapter62 = () => function() {
  let x322 = arguments[0];
  for (let i322 = 1; i322 < arguments.length; i322++) {
    x322 = arguments[i322](x322);
  }
  return new GenKindImpl42(x322);
};
var defaultIncHi42 = 335903614;
var defaultIncLo42 = 4150755663;
var MUL_HI42 = 1481765933 >>> 0;
var MUL_LO42 = 1284865837 >>> 0;
var BIT_5342 = 9007199254740992;
var BIT_2742 = 134217728;
var PCGRandom42 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable42(seedLo) && isNullable42(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable42(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable42(incLo) && isNullable42(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo42;
      incHi = this._state ? this._state[2] : defaultIncHi42;
    } else if (isNullable42(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add6442(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max322) {
    if (!max322) {
      return this._next();
    }
    max322 = max322 >>> 0;
    if ((max322 & max322 - 1) === 0) {
      return this._next() & max322 - 1;
    }
    let num = 0;
    const skew = (-max322 >>> 0) % max322 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max322;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_2742 + lo) / BIT_5342;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul6442(this._state, oldHi, oldLo, MUL_HI42, MUL_LO42);
    add6442(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul6442(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add6442(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId42 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap42 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId42]() {
    return this.#value;
  }
};
function yieldWrapGet42(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId42 in self2) {
    return self2[YieldWrapTypeId42]();
  }
  throw new Error(getBugErrorMessage42("yieldWrapGet"));
}
var structuralRegionState42 = /* @__PURE__ */ globalValue42("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache42 = /* @__PURE__ */ globalValue42(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr42 = /* @__PURE__ */ globalValue42(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom42());
var symbol62 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash42 = (self2) => {
  if (structuralRegionState42.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number52(self2);
    case "bigint":
      return string42(self2.toString(10));
    case "boolean":
      return string42(String(self2));
    case "symbol":
      return string42(String(self2));
    case "string":
      return string42(self2);
    case "undefined":
      return string42("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string42("null");
      } else if (self2 instanceof Date) {
        return hash42(self2.toISOString());
      } else if (isHash42(self2)) {
        return self2[symbol62]();
      } else {
        return random42(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random42 = (self2) => {
  if (!randomHashCache42.has(self2)) {
    randomHashCache42.set(self2, number52(pcgr42.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache42.get(self2);
};
var combine52 = (b322) => (self2) => self2 * 53 ^ b322;
var optimize42 = (n322) => n322 & 3221225471 | n322 >>> 1 & 1073741824;
var isHash42 = (u322) => hasProperty42(u322, symbol62);
var number52 = (n322) => {
  if (n322 !== n322 || n322 === Infinity) {
    return 0;
  }
  let h322 = n322 | 0;
  if (h322 !== n322) {
    h322 ^= n322 * 4294967295;
  }
  while (n322 > 4294967295) {
    h322 ^= n322 /= 4294967295;
  }
  return optimize42(n322);
};
var string42 = (str) => {
  let h322 = 5381, i322 = str.length;
  while (i322) {
    h322 = h322 * 33 ^ str.charCodeAt(--i322);
  }
  return optimize42(h322);
};
var cached42 = function() {
  if (arguments.length === 1) {
    const self3 = arguments[0];
    return function(hash722) {
      Object.defineProperty(self3, symbol62, {
        value() {
          return hash722;
        },
        enumerable: false
      });
      return hash722;
    };
  }
  const self2 = arguments[0];
  const hash622 = arguments[1];
  Object.defineProperty(self2, symbol62, {
    value() {
      return hash622;
    },
    enumerable: false
  });
  return hash622;
};
var symbol72 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals42() {
  if (arguments.length === 1) {
    return (self2) => compareBoth42(self2, arguments[0]);
  }
  return compareBoth42(arguments[0], arguments[1]);
}
function compareBoth42(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual42(self2) && isEqual42(that)) {
        if (hash42(self2) === hash42(that) && self2[symbol72](that)) {
          return true;
        } else {
          return structuralRegionState42.enabled && structuralRegionState42.tester ? structuralRegionState42.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState42.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v322, i322) => compareBoth42(v322, that[i322]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth42(self2[key], that[key]))) {
              return structuralRegionState42.tester ? structuralRegionState42.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState42.tester ? structuralRegionState42.tester(self2, that) : false;
    }
  }
  return structuralRegionState42.enabled && structuralRegionState42.tester ? structuralRegionState42.tester(self2, that) : false;
}
var isEqual42 = (u322) => hasProperty42(u322, symbol72);
var equivalence42 = () => equals42;
var NodeInspectSymbol42 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON42 = (x322) => {
  if (hasProperty42(x322, "toJSON") && isFunction8(x322["toJSON"]) && x322["toJSON"].length === 0) {
    return x322.toJSON();
  } else if (Array.isArray(x322)) {
    return x322.map(toJSON42);
  }
  return x322;
};
var format42 = (x322) => JSON.stringify(x322, null, 2);
var pipeArguments42 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i322 = 0, len = args.length; i322 < len; i322++) {
        ret = args[i322](ret);
      }
      return ret;
    }
  }
};
var EffectTypeId52 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId42 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId42 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId42 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance42 = {
  /* c8 ignore next */
  _R: (_322) => _322,
  /* c8 ignore next */
  _E: (_322) => _322,
  /* c8 ignore next */
  _A: (_322) => _322,
  _V: /* @__PURE__ */ getCurrentVersion42()
};
var sinkVariance42 = {
  /* c8 ignore next */
  _A: (_322) => _322,
  /* c8 ignore next */
  _In: (_322) => _322,
  /* c8 ignore next */
  _L: (_322) => _322,
  /* c8 ignore next */
  _E: (_322) => _322,
  /* c8 ignore next */
  _R: (_322) => _322
};
var channelVariance42 = {
  /* c8 ignore next */
  _Env: (_322) => _322,
  /* c8 ignore next */
  _InErr: (_322) => _322,
  /* c8 ignore next */
  _InElem: (_322) => _322,
  /* c8 ignore next */
  _InDone: (_322) => _322,
  /* c8 ignore next */
  _OutErr: (_322) => _322,
  /* c8 ignore next */
  _OutElem: (_322) => _322,
  /* c8 ignore next */
  _OutDone: (_322) => _322
};
var EffectPrototype42 = {
  [EffectTypeId52]: effectVariance42,
  [StreamTypeId42]: effectVariance42,
  [SinkTypeId42]: sinkVariance42,
  [ChannelTypeId42]: channelVariance42,
  [symbol72](that) {
    return this === that;
  },
  [symbol62]() {
    return cached42(this, random42(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen52(new YieldWrap42(this));
  },
  pipe() {
    return pipeArguments42(this, arguments);
  }
};
var TypeId102 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto62 = {
  ...EffectPrototype42,
  [TypeId102]: {
    _A: (_322) => _322
  },
  [NodeInspectSymbol42]() {
    return this.toJSON();
  },
  toString() {
    return format42(this.toJSON());
  }
};
var SomeProto42 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto62), {
  _tag: "Some",
  _op: "Some",
  [symbol72](that) {
    return isOption62(that) && isSome62(that) && equals42(this.value, that.value);
  },
  [symbol62]() {
    return cached42(this, combine52(hash42(this._tag))(hash42(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON42(this.value)
    };
  }
});
var NoneHash42 = /* @__PURE__ */ hash42("None");
var NoneProto42 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto62), {
  _tag: "None",
  _op: "None",
  [symbol72](that) {
    return isOption62(that) && isNone62(that);
  },
  [symbol62]() {
    return NoneHash42;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption62 = (input) => hasProperty42(input, TypeId102);
var isNone62 = (fa) => fa._tag === "None";
var isSome62 = (fa) => fa._tag === "Some";
var none62 = /* @__PURE__ */ Object.create(NoneProto42);
var some102 = (value) => {
  const a322 = Object.create(SomeProto42);
  a322.value = value;
  return a322;
};
var TypeId112 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto72 = {
  ...EffectPrototype42,
  [TypeId112]: {
    _R: (_322) => _322
  },
  [NodeInspectSymbol42]() {
    return this.toJSON();
  },
  toString() {
    return format42(this.toJSON());
  }
};
var RightProto42 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto72), {
  _tag: "Right",
  _op: "Right",
  [symbol72](that) {
    return isEither42(that) && isRight52(that) && equals42(this.right, that.right);
  },
  [symbol62]() {
    return combine52(hash42(this._tag))(hash42(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON42(this.right)
    };
  }
});
var LeftProto42 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto72), {
  _tag: "Left",
  _op: "Left",
  [symbol72](that) {
    return isEither42(that) && isLeft52(that) && equals42(this.left, that.left);
  },
  [symbol62]() {
    return combine52(hash42(this._tag))(hash42(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON42(this.left)
    };
  }
});
var isEither42 = (input) => hasProperty42(input, TypeId112);
var isLeft52 = (ma) => ma._tag === "Left";
var isRight52 = (ma) => ma._tag === "Right";
var left52 = (left722) => {
  const a322 = Object.create(LeftProto42);
  a322.left = left722;
  return a322;
};
var right52 = (right722) => {
  const a322 = Object.create(RightProto42);
  a322.right = right722;
  return a322;
};
var getLeft62 = (self2) => isRight52(self2) ? none62 : some102(self2.left);
var getRight62 = (self2) => isLeft52(self2) ? none62 : some102(self2.right);
var Option_exports42 = {};
__export5(Option_exports42, {
  Do: () => Do52,
  TypeId: () => TypeId12,
  all: () => all72,
  andThen: () => andThen42,
  ap: () => ap42,
  as: () => as42,
  asVoid: () => asVoid42,
  bind: () => bind82,
  bindTo: () => bindTo82,
  composeK: () => composeK42,
  contains: () => contains52,
  containsWith: () => containsWith52,
  exists: () => exists42,
  filter: () => filter52,
  filterMap: () => filterMap52,
  firstSomeOf: () => firstSomeOf42,
  flatMap: () => flatMap52,
  flatMapNullable: () => flatMapNullable52,
  flatten: () => flatten52,
  fromIterable: () => fromIterable62,
  fromNullable: () => fromNullable52,
  gen: () => gen42,
  getEquivalence: () => getEquivalence62,
  getLeft: () => getLeft72,
  getOrElse: () => getOrElse42,
  getOrNull: () => getOrNull42,
  getOrThrow: () => getOrThrow42,
  getOrThrowWith: () => getOrThrowWith42,
  getOrUndefined: () => getOrUndefined42,
  getOrder: () => getOrder52,
  getRight: () => getRight72,
  isNone: () => isNone72,
  isOption: () => isOption72,
  isSome: () => isSome72,
  let: () => let_82,
  lift2: () => lift242,
  liftNullable: () => liftNullable52,
  liftPredicate: () => liftPredicate52,
  liftThrowable: () => liftThrowable42,
  map: () => map52,
  match: () => match6,
  none: () => none72,
  orElse: () => orElse42,
  orElseEither: () => orElseEither42,
  orElseSome: () => orElseSome42,
  partitionMap: () => partitionMap52,
  product: () => product72,
  productMany: () => productMany72,
  reduceCompact: () => reduceCompact42,
  some: () => some11,
  tap: () => tap42,
  toArray: () => toArray42,
  toRefinement: () => toRefinement42,
  void: () => void_42,
  zipLeft: () => zipLeft42,
  zipRight: () => zipRight42,
  zipWith: () => zipWith52
});
var make132 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId12 = /* @__PURE__ */ Symbol.for("effect/Option");
var none72 = () => none62;
var some11 = some102;
var isOption72 = isOption62;
var isNone72 = isNone62;
var isSome72 = isSome62;
var match6 = /* @__PURE__ */ dual42(2, (self2, {
  onNone,
  onSome
}) => isNone72(self2) ? onNone() : onSome(self2.value));
var toRefinement42 = (f322) => (a322) => isSome72(f322(a322));
var fromIterable62 = (collection) => {
  for (const a322 of collection) {
    return some11(a322);
  }
  return none72();
};
var getRight72 = getRight62;
var getLeft72 = getLeft62;
var getOrElse42 = /* @__PURE__ */ dual42(2, (self2, onNone) => isNone72(self2) ? onNone() : self2.value);
var orElse42 = /* @__PURE__ */ dual42(2, (self2, that) => isNone72(self2) ? that() : self2);
var orElseSome42 = /* @__PURE__ */ dual42(2, (self2, onNone) => isNone72(self2) ? some11(onNone()) : self2);
var orElseEither42 = /* @__PURE__ */ dual42(2, (self2, that) => isNone72(self2) ? map52(that(), right52) : map52(self2, left52));
var firstSomeOf42 = (collection) => {
  let out = none72();
  for (out of collection) {
    if (isSome72(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable52 = (nullableValue) => nullableValue == null ? none72() : some11(nullableValue);
var liftNullable52 = (f322) => (...a322) => fromNullable52(f322(...a322));
var getOrNull42 = /* @__PURE__ */ getOrElse42(constNull42);
var getOrUndefined42 = /* @__PURE__ */ getOrElse42(constUndefined42);
var liftThrowable42 = (f322) => (...a322) => {
  try {
    return some11(f322(...a322));
  } catch (e322) {
    return none72();
  }
};
var getOrThrowWith42 = /* @__PURE__ */ dual42(2, (self2, onNone) => {
  if (isSome72(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow42 = /* @__PURE__ */ getOrThrowWith42(() => new Error("getOrThrow called on a None"));
var map52 = /* @__PURE__ */ dual42(2, (self2, f322) => isNone72(self2) ? none72() : some11(f322(self2.value)));
var as42 = /* @__PURE__ */ dual42(2, (self2, b322) => map52(self2, () => b322));
var asVoid42 = /* @__PURE__ */ as42(void 0);
var void_42 = /* @__PURE__ */ some11(void 0);
var flatMap52 = /* @__PURE__ */ dual42(2, (self2, f322) => isNone72(self2) ? none72() : f322(self2.value));
var andThen42 = /* @__PURE__ */ dual42(2, (self2, f322) => flatMap52(self2, (a322) => {
  const b322 = isFunction72(f322) ? f322(a322) : f322;
  return isOption72(b322) ? b322 : some11(b322);
}));
var flatMapNullable52 = /* @__PURE__ */ dual42(2, (self2, f322) => isNone72(self2) ? none72() : fromNullable52(f322(self2.value)));
var flatten52 = /* @__PURE__ */ flatMap52(identity42);
var zipRight42 = /* @__PURE__ */ dual42(2, (self2, that) => flatMap52(self2, () => that));
var composeK42 = /* @__PURE__ */ dual42(2, (afb, bfc) => (a322) => flatMap52(afb(a322), bfc));
var zipLeft42 = /* @__PURE__ */ dual42(2, (self2, that) => tap42(self2, () => that));
var tap42 = /* @__PURE__ */ dual42(2, (self2, f322) => flatMap52(self2, (a322) => map52(f322(a322), () => a322)));
var product72 = (self2, that) => isSome72(self2) && isSome72(that) ? some11([self2.value, that.value]) : none72();
var productMany72 = (self2, collection) => {
  if (isNone72(self2)) {
    return none72();
  }
  const out = [self2.value];
  for (const o322 of collection) {
    if (isNone72(o322)) {
      return none72();
    }
    out.push(o322.value);
  }
  return some11(out);
};
var all72 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o322 of input) {
      if (isNone72(o322)) {
        return none72();
      }
      out2.push(o322.value);
    }
    return some11(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o322 = input[key];
    if (isNone72(o322)) {
      return none72();
    }
    out[key] = o322.value;
  }
  return some11(out);
};
var zipWith52 = /* @__PURE__ */ dual42(3, (self2, that, f322) => map52(product72(self2, that), ([a322, b322]) => f322(a322, b322)));
var ap42 = /* @__PURE__ */ dual42(2, (self2, that) => zipWith52(self2, that, (f322, a322) => f322(a322)));
var reduceCompact42 = /* @__PURE__ */ dual42(3, (self2, b322, f322) => {
  let out = b322;
  for (const oa of self2) {
    if (isSome72(oa)) {
      out = f322(out, oa.value);
    }
  }
  return out;
});
var toArray42 = (self2) => isNone72(self2) ? [] : [self2.value];
var partitionMap52 = /* @__PURE__ */ dual42(2, (self2, f322) => {
  if (isNone72(self2)) {
    return [none72(), none72()];
  }
  const e322 = f322(self2.value);
  return isLeft52(e322) ? [some11(e322.left), none72()] : [none72(), some11(e322.right)];
});
var filterMap52 = /* @__PURE__ */ dual42(2, (self2, f322) => isNone72(self2) ? none72() : f322(self2.value));
var filter52 = /* @__PURE__ */ dual42(2, (self2, predicate) => filterMap52(self2, (b322) => predicate(b322) ? some102(b322) : none62));
var getEquivalence62 = (isEquivalent) => make122((x322, y322) => x322 === y322 || (isNone72(x322) ? isNone72(y322) : isNone72(y322) ? false : isEquivalent(x322.value, y322.value)));
var getOrder52 = (O322) => make132((self2, that) => isSome72(self2) ? isSome72(that) ? O322(self2.value, that.value) : 1 : -1);
var lift242 = (f322) => dual42(2, (self2, that) => zipWith52(self2, that, f322));
var liftPredicate52 = (predicate) => (b322) => predicate(b322) ? some11(b322) : none72();
var containsWith52 = (isEquivalent) => dual42(2, (self2, a322) => isNone72(self2) ? false : isEquivalent(self2.value, a322));
var _equivalence62 = /* @__PURE__ */ equivalence42();
var contains52 = /* @__PURE__ */ containsWith52(_equivalence62);
var exists42 = /* @__PURE__ */ dual42(2, (self2, refinement) => isNone72(self2) ? false : refinement(self2.value));
var bindTo82 = /* @__PURE__ */ bindTo72(map52);
var let_82 = /* @__PURE__ */ let_72(map52);
var bind82 = /* @__PURE__ */ bind72(map52, flatMap52);
var Do52 = /* @__PURE__ */ some11({});
var adapter72 = /* @__PURE__ */ adapter62();
var gen42 = (f322) => {
  const iterator = f322(adapter72);
  let state = iterator.next();
  if (state.done) {
    return some11(state.value);
  } else {
    let current = state.value;
    if (isGenKind42(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet42(current);
    }
    if (isNone72(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind42(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet42(current);
        }
        if (isNone72(current)) {
          return current;
        }
      }
    }
    return some11(state.value);
  }
};
var MutableRef_exports = {};
__export5(MutableRef_exports, {
  compareAndSet: () => compareAndSet22,
  decrement: () => decrement22,
  decrementAndGet: () => decrementAndGet22,
  get: () => get32,
  getAndDecrement: () => getAndDecrement22,
  getAndIncrement: () => getAndIncrement22,
  getAndSet: () => getAndSet22,
  getAndUpdate: () => getAndUpdate22,
  increment: () => increment22,
  incrementAndGet: () => incrementAndGet22,
  make: () => make14,
  set: () => set32,
  setAndGet: () => setAndGet22,
  toggle: () => toggle22,
  update: () => update22,
  updateAndGet: () => updateAndGet22
});
var TypeId13 = /* @__PURE__ */ Symbol.for("effect/MutableRef");
var MutableRefProto22 = {
  [TypeId13]: TypeId13,
  toString() {
    return format42(this.toJSON());
  },
  toJSON() {
    return {
      _id: "MutableRef",
      current: toJSON42(this.current)
    };
  },
  [NodeInspectSymbol42]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments42(this, arguments);
  }
};
var make14 = (value) => {
  const ref = Object.create(MutableRefProto22);
  ref.current = value;
  return ref;
};
var compareAndSet22 = /* @__PURE__ */ dual42(3, (self2, oldValue, newValue) => {
  if (equals42(oldValue, self2.current)) {
    self2.current = newValue;
    return true;
  }
  return false;
});
var decrement22 = (self2) => update22(self2, (n322) => n322 - 1);
var decrementAndGet22 = (self2) => updateAndGet22(self2, (n322) => n322 - 1);
var get32 = (self2) => self2.current;
var getAndDecrement22 = (self2) => getAndUpdate22(self2, (n322) => n322 - 1);
var getAndIncrement22 = (self2) => getAndUpdate22(self2, (n322) => n322 + 1);
var getAndSet22 = /* @__PURE__ */ dual42(2, (self2, value) => {
  const ret = self2.current;
  self2.current = value;
  return ret;
});
var getAndUpdate22 = /* @__PURE__ */ dual42(2, (self2, f322) => getAndSet22(self2, f322(get32(self2))));
var increment22 = (self2) => update22(self2, (n322) => n322 + 1);
var incrementAndGet22 = (self2) => updateAndGet22(self2, (n322) => n322 + 1);
var set32 = /* @__PURE__ */ dual42(2, (self2, value) => {
  self2.current = value;
  return self2;
});
var setAndGet22 = /* @__PURE__ */ dual42(2, (self2, value) => {
  self2.current = value;
  return self2.current;
});
var update22 = /* @__PURE__ */ dual42(2, (self2, f322) => set32(self2, f322(get32(self2))));
var updateAndGet22 = /* @__PURE__ */ dual42(2, (self2, f322) => setAndGet22(self2, f322(get32(self2))));
var toggle22 = (self2) => update22(self2, (_322) => !_322);
var MutableList_exports = {};
__export5(MutableList_exports, {
  append: () => append22,
  empty: () => empty112,
  forEach: () => forEach52,
  fromIterable: () => fromIterable72,
  head: () => head22,
  isEmpty: () => isEmpty32,
  length: () => length22,
  make: () => make15,
  pop: () => pop,
  prepend: () => prepend42,
  reset: () => reset,
  shift: () => shift,
  tail: () => tail22
});
var TypeId14 = /* @__PURE__ */ Symbol.for("effect/MutableList");
var MutableListProto = {
  [TypeId14]: TypeId14,
  [Symbol.iterator]() {
    let done = false;
    let head322 = this.head;
    return {
      next() {
        if (done) {
          return this.return();
        }
        if (head322 == null) {
          done = true;
          return this.return();
        }
        const value = head322.value;
        head322 = head322.next;
        return {
          done,
          value
        };
      },
      return(value) {
        if (!done) {
          done = true;
        }
        return {
          done: true,
          value
        };
      }
    };
  },
  toString() {
    return format42(this.toJSON());
  },
  toJSON() {
    return {
      _id: "MutableList",
      values: Array.from(this).map(toJSON42)
    };
  },
  [NodeInspectSymbol42]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments42(this, arguments);
  }
};
var makeNode = (value) => ({
  value,
  removed: false,
  prev: void 0,
  next: void 0
});
var empty112 = () => {
  const list = Object.create(MutableListProto);
  list.head = void 0;
  list.tail = void 0;
  list._length = 0;
  return list;
};
var fromIterable72 = (iterable) => {
  const list = empty112();
  for (const element of iterable) {
    append22(list, element);
  }
  return list;
};
var make15 = (...elements) => fromIterable72(elements);
var isEmpty32 = (self2) => length22(self2) === 0;
var length22 = (self2) => self2._length;
var tail22 = (self2) => self2.tail === void 0 ? void 0 : self2.tail.value;
var head22 = (self2) => self2.head === void 0 ? void 0 : self2.head.value;
var forEach52 = /* @__PURE__ */ dual42(2, (self2, f322) => {
  let current = self2.head;
  while (current !== void 0) {
    f322(current.value);
    current = current.next;
  }
});
var reset = (self2) => {
  self2._length = 0;
  self2.head = void 0;
  self2.tail = void 0;
  return self2;
};
var append22 = /* @__PURE__ */ dual42(2, (self2, value) => {
  const node = makeNode(value);
  if (self2.head === void 0) {
    self2.head = node;
  }
  if (self2.tail === void 0) {
    self2.tail = node;
  } else {
    self2.tail.next = node;
    node.prev = self2.tail;
    self2.tail = node;
  }
  self2._length += 1;
  return self2;
});
var shift = (self2) => {
  const head322 = self2.head;
  if (head322 !== void 0) {
    remove22(self2, head322);
    return head322.value;
  }
  return void 0;
};
var pop = (self2) => {
  const tail322 = self2.tail;
  if (tail322 !== void 0) {
    remove22(self2, tail322);
    return tail322.value;
  }
  return void 0;
};
var prepend42 = /* @__PURE__ */ dual42(2, (self2, value) => {
  const node = makeNode(value);
  node.next = self2.head;
  if (self2.head !== void 0) {
    self2.head.prev = node;
  }
  self2.head = node;
  if (self2.tail === void 0) {
    self2.tail = node;
  }
  self2._length += 1;
  return self2;
});
var remove22 = (self2, node) => {
  if (node.removed) {
    return;
  }
  node.removed = true;
  if (node.prev !== void 0 && node.next !== void 0) {
    node.prev.next = node.next;
    node.next.prev = node.prev;
  } else if (node.prev !== void 0) {
    self2.tail = node.prev;
    node.prev.next = void 0;
  } else if (node.next !== void 0) {
    self2.head = node.next;
    node.next.prev = void 0;
  } else {
    self2.tail = void 0;
    self2.head = void 0;
  }
  if (self2._length > 0) {
    self2._length -= 1;
  }
};
var store22;
function getGlobalMessage2(lang) {
  return store22?.get(lang);
}
var store32;
function getSchemaMessage2(lang) {
  return store32?.get(lang);
}
var store42;
function getSpecificMessage2(reference, lang) {
  return store42?.get(reference)?.get(lang);
}
function _stringify2(input) {
  let type = typeof input;
  if (type === "object") {
    type = (input && Object.getPrototypeOf(input)?.constructor?.name) ?? "null";
  }
  return type === "string" ? `"${input}"` : type === "number" || type === "bigint" || type === "boolean" ? `${input}` : type;
}
function _addIssue2(context, label, dataset, config2, other) {
  const input = dataset.value;
  const expected = context.expects;
  const received = _stringify2(input);
  const issue = {
    kind: context.kind,
    type: context.type,
    input,
    expected,
    received,
    message: `Invalid ${label}: ${expected ? `Expected ${expected} but r` : "R"}eceived ${received}`,
    // @ts-expect-error
    requirement: context.requirement,
    path: other?.path,
    issues: other?.issues,
    lang: config2.lang,
    abortEarly: config2.abortEarly,
    abortPipeEarly: config2.abortPipeEarly,
    skipPipe: config2.skipPipe
  };
  const isSchema = context.kind === "schema";
  const message = (
    // @ts-expect-error
    context.message ?? getSpecificMessage2(context.reference, issue.lang) ?? (isSchema ? getSchemaMessage2(issue.lang) : null) ?? config2.message ?? getGlobalMessage2(issue.lang)
  );
  if (message) {
    issue.message = typeof message === "function" ? message(issue) : message;
  }
  if (isSchema) {
    dataset.typed = false;
  }
  if (dataset.issues) {
    dataset.issues.push(issue);
  } else {
    dataset.issues = [issue];
  }
}
function getDefault2(schema4, dataset, config2) {
  return typeof schema4.default === "function" ? (
    // @ts-expect-error
    schema4.default(dataset, config2)
  ) : (
    // @ts-expect-error
    schema4.default
  );
}
function array62(item, message) {
  return {
    kind: "schema",
    type: "array",
    reference: array62,
    expects: "Array",
    async: false,
    item,
    message,
    _run(dataset, config2) {
      const input = dataset.value;
      if (Array.isArray(input)) {
        dataset.typed = true;
        dataset.value = [];
        for (let key = 0; key < input.length; key++) {
          const value2 = input[key];
          const itemDataset = this.item._run({ typed: false, value: value2 }, config2);
          if (itemDataset.issues) {
            const pathItem = {
              type: "array",
              origin: "value",
              input,
              key,
              value: value2
            };
            for (const issue of itemDataset.issues) {
              if (issue.path) {
                issue.path.unshift(pathItem);
              } else {
                issue.path = [pathItem];
              }
              dataset.issues?.push(issue);
            }
            if (!dataset.issues) {
              dataset.issues = itemDataset.issues;
            }
            if (config2.abortEarly) {
              dataset.typed = false;
              break;
            }
          }
          if (!itemDataset.typed) {
            dataset.typed = false;
          }
          dataset.value.push(itemDataset.value);
        }
      } else {
        _addIssue2(this, "type", dataset, config2);
      }
      return dataset;
    }
  };
}
function object2(entries2, message) {
  return {
    kind: "schema",
    type: "object",
    reference: object2,
    expects: "Object",
    async: false,
    entries: entries2,
    message,
    _run(dataset, config2) {
      const input = dataset.value;
      if (input && typeof input === "object") {
        dataset.typed = true;
        dataset.value = {};
        for (const key in this.entries) {
          const value2 = input[key];
          const valueDataset = this.entries[key]._run(
            { typed: false, value: value2 },
            config2
          );
          if (valueDataset.issues) {
            const pathItem = {
              type: "object",
              origin: "value",
              input,
              key,
              value: value2
            };
            for (const issue of valueDataset.issues) {
              if (issue.path) {
                issue.path.unshift(pathItem);
              } else {
                issue.path = [pathItem];
              }
              dataset.issues?.push(issue);
            }
            if (!dataset.issues) {
              dataset.issues = valueDataset.issues;
            }
            if (config2.abortEarly) {
              dataset.typed = false;
              break;
            }
          }
          if (!valueDataset.typed) {
            dataset.typed = false;
          }
          if (valueDataset.value !== void 0 || key in input) {
            dataset.value[key] = valueDataset.value;
          }
        }
      } else {
        _addIssue2(this, "type", dataset, config2);
      }
      return dataset;
    }
  };
}
function optional2(wrapped, ...args) {
  const schema4 = {
    kind: "schema",
    type: "optional",
    reference: optional2,
    expects: `${wrapped.expects} | undefined`,
    async: false,
    wrapped,
    _run(dataset, config2) {
      if (dataset.value === void 0) {
        if ("default" in this) {
          dataset.value = getDefault2(
            this,
            dataset,
            config2
          );
        }
        if (dataset.value === void 0) {
          dataset.typed = true;
          return dataset;
        }
      }
      return this.wrapped._run(dataset, config2);
    }
  };
  if (0 in args) {
    schema4.default = args[0];
  }
  return schema4;
}
function string52(message) {
  return {
    kind: "schema",
    type: "string",
    reference: string52,
    expects: "string",
    async: false,
    message,
    _run(dataset, config2) {
      if (typeof dataset.value === "string") {
        dataset.typed = true;
      } else {
        _addIssue2(this, "type", dataset, config2);
      }
      return dataset;
    }
  };
}
var ESLintReactSettingsSchema2 = object2({
  additionalHooks: optional2(object2({
    use: optional2(string52()),
    useCallback: optional2(array62(string52())),
    useContext: optional2(array62(string52())),
    useDebugValue: optional2(array62(string52())),
    useDeferredValue: optional2(array62(string52())),
    useEffect: optional2(array62(string52())),
    useId: optional2(array62(string52())),
    useImperativeHandle: optional2(array62(string52())),
    useInsertionEffect: optional2(array62(string52())),
    useLayoutEffect: optional2(array62(string52())),
    useMemo: optional2(array62(string52())),
    useOptimistic: optional2(array62(string52())),
    useReducer: optional2(array62(string52())),
    useRef: optional2(array62(string52())),
    useState: optional2(array62(string52())),
    useSyncExternalStore: optional2(array62(string52())),
    useTransition: optional2(array62(string52()))
  })),
  importSource: optional2(string52()),
  jsxPragma: optional2(string52()),
  jsxPragmaFrag: optional2(string52()),
  version: optional2(string52())
});
var ESLintSettingsSchema2 = object2({
  reactOptions: optional2(ESLintReactSettingsSchema2)
});
var __defProp42 = Object.defineProperty;
var __export42 = (target, all334) => {
  for (var name22 in all334)
    __defProp42(target, name22, { get: all334[name22], enumerable: true });
};
var Function_exports52 = {};
__export42(Function_exports52, {
  SK: () => SK52,
  absurd: () => absurd52,
  apply: () => apply52,
  compose: () => compose8,
  constFalse: () => constFalse52,
  constNull: () => constNull52,
  constTrue: () => constTrue52,
  constUndefined: () => constUndefined52,
  constVoid: () => constVoid52,
  constant: () => constant52,
  dual: () => dual52,
  flip: () => flip52,
  flow: () => flow52,
  hole: () => hole52,
  identity: () => identity52,
  isFunction: () => isFunction9,
  pipe: () => pipe52,
  satisfies: () => satisfies52,
  tupled: () => tupled52,
  unsafeCoerce: () => unsafeCoerce52,
  untupled: () => untupled52
});
var isFunction9 = (input) => typeof input === "function";
var dual52 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a2222, b2222) {
        if (arguments.length >= 2) {
          return body(a2222, b2222);
        }
        return function(self2) {
          return body(self2, a2222);
        };
      };
    case 3:
      return function(a2222, b2222, c2222) {
        if (arguments.length >= 3) {
          return body(a2222, b2222, c2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222);
        };
      };
    case 4:
      return function(a2222, b2222, c2222, d2222) {
        if (arguments.length >= 4) {
          return body(a2222, b2222, c2222, d2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222);
        };
      };
    case 5:
      return function(a2222, b2222, c2222, d2222, e2222) {
        if (arguments.length >= 5) {
          return body(a2222, b2222, c2222, d2222, e2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222, d2222);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply52 = (a2222) => (self2) => self2(a2222);
var identity52 = (a2222) => a2222;
var satisfies52 = () => (b2222) => b2222;
var unsafeCoerce52 = identity52;
var constant52 = (value) => () => value;
var constTrue52 = /* @__PURE__ */ constant52(true);
var constFalse52 = /* @__PURE__ */ constant52(false);
var constNull52 = /* @__PURE__ */ constant52(null);
var constUndefined52 = /* @__PURE__ */ constant52(void 0);
var constVoid52 = constUndefined52;
var flip52 = (f2222) => (...b2222) => (...a2222) => f2222(...a2222)(...b2222);
var compose8 = /* @__PURE__ */ dual52(2, (ab, bc) => (a2222) => bc(ab(a2222)));
var absurd52 = (_2222) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled52 = (f2222) => (a2222) => f2222(...a2222);
var untupled52 = (f2222) => (...a2222) => f2222(a2222);
function pipe52(a2222, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a2222;
    case 2:
      return ab(a2222);
    case 3:
      return bc(ab(a2222));
    case 4:
      return cd(bc(ab(a2222)));
    case 5:
      return de(cd(bc(ab(a2222))));
    case 6:
      return ef(de(cd(bc(ab(a2222)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a2222))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a2222)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a2222))))))));
    default: {
      let ret = arguments[0];
      for (let i2222 = 1; i2222 < arguments.length; i2222++) {
        ret = arguments[i2222](ret);
      }
      return ret;
    }
  }
}
function flow52(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole52 = /* @__PURE__ */ unsafeCoerce52(absurd52);
var SK52 = (_2222, b2222) => b2222;
var make16 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_9 = (map3222) => dual52(3, (self2, name22, f2222) => map3222(self2, (a2222) => Object.assign({}, a2222, {
  [name22]: f2222(a2222)
})));
var bindTo9 = (map3222) => dual52(2, (self2, name22) => map3222(self2, (a2222) => ({
  [name22]: a2222
})));
var bind9 = (map3222, flatMap3222) => dual52(3, (self2, name22, f2222) => flatMap3222(self2, (a2222) => map3222(f2222(a2222), (b2222) => Object.assign({}, a2222, {
  [name22]: b2222
}))));
var moduleVersion52 = "3.2.8";
var getCurrentVersion52 = () => moduleVersion52;
var globalStoreId52 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion52()}`);
if (!(globalStoreId52 in globalThis)) {
  globalThis[globalStoreId52] = /* @__PURE__ */ new Map();
}
var globalStore52 = globalThis[globalStoreId52];
var globalValue52 = (id, compute) => {
  if (!globalStore52.has(id)) {
    globalStore52.set(id, compute());
  }
  return globalStore52.get(id);
};
var isFunction232 = isFunction9;
var isRecordOrArray52 = (input) => typeof input === "object" && input !== null;
var isObject52 = (input) => isRecordOrArray52(input) || isFunction232(input);
var hasProperty52 = /* @__PURE__ */ dual52(2, (self2, property) => isObject52(self2) && property in self2);
var isNullable52 = (input) => input === null || input === void 0;
var getBugErrorMessage52 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId52 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind52 = (u2222) => isObject52(u2222) && GenKindTypeId52 in u2222;
var GenKindImpl52 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity52;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId52] = GenKindTypeId52;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen62(this);
  }
};
var SingleShotGen62 = class _SingleShotGen33 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a2222) {
    return this.called ? {
      value: a2222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a2222) {
    return {
      value: a2222,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e2222) {
    throw e2222;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen33(this.self);
  }
};
var adapter8 = () => function() {
  let x2222 = arguments[0];
  for (let i2222 = 1; i2222 < arguments.length; i2222++) {
    x2222 = arguments[i2222](x2222);
  }
  return new GenKindImpl52(x2222);
};
var defaultIncHi52 = 335903614;
var defaultIncLo52 = 4150755663;
var MUL_HI52 = 1481765933 >>> 0;
var MUL_LO52 = 1284865837 >>> 0;
var BIT_5352 = 9007199254740992;
var BIT_2752 = 134217728;
var PCGRandom52 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable52(seedLo) && isNullable52(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable52(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable52(incLo) && isNullable52(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo52;
      incHi = this._state ? this._state[2] : defaultIncHi52;
    } else if (isNullable52(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add6452(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max322) {
    if (!max322) {
      return this._next();
    }
    max322 = max322 >>> 0;
    if ((max322 & max322 - 1) === 0) {
      return this._next() & max322 - 1;
    }
    let num = 0;
    const skew = (-max322 >>> 0) % max322 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max322;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_2752 + lo) / BIT_5352;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul6452(this._state, oldHi, oldLo, MUL_HI52, MUL_LO52);
    add6452(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul6452(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add6452(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId52 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap52 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId52]() {
    return this.#value;
  }
};
function yieldWrapGet52(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId52 in self2) {
    return self2[YieldWrapTypeId52]();
  }
  throw new Error(getBugErrorMessage52("yieldWrapGet"));
}
var structuralRegionState52 = /* @__PURE__ */ globalValue52("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache52 = /* @__PURE__ */ globalValue52(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr52 = /* @__PURE__ */ globalValue52(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom52());
var symbol8 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash52 = (self2) => {
  if (structuralRegionState52.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number62(self2);
    case "bigint":
      return string62(self2.toString(10));
    case "boolean":
      return string62(String(self2));
    case "symbol":
      return string62(String(self2));
    case "string":
      return string62(self2);
    case "undefined":
      return string62("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string62("null");
      } else if (self2 instanceof Date) {
        return hash52(self2.toISOString());
      } else if (isHash52(self2)) {
        return self2[symbol8]();
      } else {
        return random52(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random52 = (self2) => {
  if (!randomHashCache52.has(self2)) {
    randomHashCache52.set(self2, number62(pcgr52.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache52.get(self2);
};
var combine62 = (b2222) => (self2) => self2 * 53 ^ b2222;
var optimize52 = (n2222) => n2222 & 3221225471 | n2222 >>> 1 & 1073741824;
var isHash52 = (u2222) => hasProperty52(u2222, symbol8);
var number62 = (n2222) => {
  if (n2222 !== n2222 || n2222 === Infinity) {
    return 0;
  }
  let h2222 = n2222 | 0;
  if (h2222 !== n2222) {
    h2222 ^= n2222 * 4294967295;
  }
  while (n2222 > 4294967295) {
    h2222 ^= n2222 /= 4294967295;
  }
  return optimize52(n2222);
};
var string62 = (str) => {
  let h2222 = 5381, i2222 = str.length;
  while (i2222) {
    h2222 = h2222 * 33 ^ str.charCodeAt(--i2222);
  }
  return optimize52(h2222);
};
var cached52 = function() {
  if (arguments.length === 1) {
    const self3 = arguments[0];
    return function(hash422) {
      Object.defineProperty(self3, symbol8, {
        value() {
          return hash422;
        },
        enumerable: false
      });
      return hash422;
    };
  }
  const self2 = arguments[0];
  const hash3222 = arguments[1];
  Object.defineProperty(self2, symbol8, {
    value() {
      return hash3222;
    },
    enumerable: false
  });
  return hash3222;
};
var symbol232 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals52() {
  if (arguments.length === 1) {
    return (self2) => compareBoth52(self2, arguments[0]);
  }
  return compareBoth52(arguments[0], arguments[1]);
}
function compareBoth52(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual52(self2) && isEqual52(that)) {
        if (hash52(self2) === hash52(that) && self2[symbol232](that)) {
          return true;
        } else {
          return structuralRegionState52.enabled && structuralRegionState52.tester ? structuralRegionState52.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState52.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v2222, i2222) => compareBoth52(v2222, that[i2222]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth52(self2[key], that[key]))) {
              return structuralRegionState52.tester ? structuralRegionState52.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState52.tester ? structuralRegionState52.tester(self2, that) : false;
    }
  }
  return structuralRegionState52.enabled && structuralRegionState52.tester ? structuralRegionState52.tester(self2, that) : false;
}
var isEqual52 = (u2222) => hasProperty52(u2222, symbol232);
var equivalence52 = () => equals52;
var NodeInspectSymbol52 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON52 = (x2222) => {
  if (hasProperty52(x2222, "toJSON") && isFunction232(x2222["toJSON"]) && x2222["toJSON"].length === 0) {
    return x2222.toJSON();
  } else if (Array.isArray(x2222)) {
    return x2222.map(toJSON52);
  }
  return x2222;
};
var format52 = (x2222) => JSON.stringify(x2222, null, 2);
var pipeArguments52 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i2222 = 0, len = args.length; i2222 < len; i2222++) {
        ret = args[i2222](ret);
      }
      return ret;
    }
  }
};
var EffectTypeId62 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId52 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId52 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId52 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance52 = {
  /* c8 ignore next */
  _R: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _A: (_2222) => _2222,
  _V: /* @__PURE__ */ getCurrentVersion52()
};
var sinkVariance52 = {
  /* c8 ignore next */
  _A: (_2222) => _2222,
  /* c8 ignore next */
  _In: (_2222) => _2222,
  /* c8 ignore next */
  _L: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _R: (_2222) => _2222
};
var channelVariance52 = {
  /* c8 ignore next */
  _Env: (_2222) => _2222,
  /* c8 ignore next */
  _InErr: (_2222) => _2222,
  /* c8 ignore next */
  _InElem: (_2222) => _2222,
  /* c8 ignore next */
  _InDone: (_2222) => _2222,
  /* c8 ignore next */
  _OutErr: (_2222) => _2222,
  /* c8 ignore next */
  _OutElem: (_2222) => _2222,
  /* c8 ignore next */
  _OutDone: (_2222) => _2222
};
var EffectPrototype52 = {
  [EffectTypeId62]: effectVariance52,
  [StreamTypeId52]: effectVariance52,
  [SinkTypeId52]: sinkVariance52,
  [ChannelTypeId52]: channelVariance52,
  [symbol232](that) {
    return this === that;
  },
  [symbol8]() {
    return cached52(this, random52(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen62(new YieldWrap52(this));
  },
  pipe() {
    return pipeArguments52(this, arguments);
  }
};
var TypeId15 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto8 = {
  ...EffectPrototype52,
  [TypeId15]: {
    _A: (_2222) => _2222
  },
  [NodeInspectSymbol52]() {
    return this.toJSON();
  },
  toString() {
    return format52(this.toJSON());
  }
};
var SomeProto52 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto8), {
  _tag: "Some",
  _op: "Some",
  [symbol232](that) {
    return isOption8(that) && isSome8(that) && equals52(this.value, that.value);
  },
  [symbol8]() {
    return cached52(this, combine62(hash52(this._tag))(hash52(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON52(this.value)
    };
  }
});
var NoneHash52 = /* @__PURE__ */ hash52("None");
var NoneProto52 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto8), {
  _tag: "None",
  _op: "None",
  [symbol232](that) {
    return isOption8(that) && isNone8(that);
  },
  [symbol8]() {
    return NoneHash52;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption8 = (input) => hasProperty52(input, TypeId15);
var isNone8 = (fa) => fa._tag === "None";
var isSome8 = (fa) => fa._tag === "Some";
var none8 = /* @__PURE__ */ Object.create(NoneProto52);
var some12 = (value) => {
  const a2222 = Object.create(SomeProto52);
  a2222.value = value;
  return a2222;
};
var TypeId232 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto232 = {
  ...EffectPrototype52,
  [TypeId232]: {
    _R: (_2222) => _2222
  },
  [NodeInspectSymbol52]() {
    return this.toJSON();
  },
  toString() {
    return format52(this.toJSON());
  }
};
var RightProto52 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto232), {
  _tag: "Right",
  _op: "Right",
  [symbol232](that) {
    return isEither52(that) && isRight62(that) && equals52(this.right, that.right);
  },
  [symbol8]() {
    return combine62(hash52(this._tag))(hash52(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON52(this.right)
    };
  }
});
var LeftProto52 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto232), {
  _tag: "Left",
  _op: "Left",
  [symbol232](that) {
    return isEither52(that) && isLeft62(that) && equals52(this.left, that.left);
  },
  [symbol8]() {
    return combine62(hash52(this._tag))(hash52(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON52(this.left)
    };
  }
});
var isEither52 = (input) => hasProperty52(input, TypeId232);
var isLeft62 = (ma) => ma._tag === "Left";
var isRight62 = (ma) => ma._tag === "Right";
var left62 = (left334) => {
  const a2222 = Object.create(LeftProto52);
  a2222.left = left334;
  return a2222;
};
var right62 = (right334) => {
  const a2222 = Object.create(RightProto52);
  a2222.right = right334;
  return a2222;
};
var getLeft8 = (self2) => isRight62(self2) ? none8 : some12(self2.left);
var getRight8 = (self2) => isLeft62(self2) ? none8 : some12(self2.right);
var Option_exports52 = {};
__export42(Option_exports52, {
  Do: () => Do62,
  TypeId: () => TypeId332,
  all: () => all8,
  andThen: () => andThen52,
  ap: () => ap52,
  as: () => as52,
  asVoid: () => asVoid52,
  bind: () => bind232,
  bindTo: () => bindTo232,
  composeK: () => composeK52,
  contains: () => contains62,
  containsWith: () => containsWith62,
  exists: () => exists52,
  filter: () => filter62,
  filterMap: () => filterMap62,
  firstSomeOf: () => firstSomeOf52,
  flatMap: () => flatMap62,
  flatMapNullable: () => flatMapNullable62,
  flatten: () => flatten62,
  fromIterable: () => fromIterable8,
  fromNullable: () => fromNullable62,
  gen: () => gen52,
  getEquivalence: () => getEquivalence72,
  getLeft: () => getLeft232,
  getOrElse: () => getOrElse52,
  getOrNull: () => getOrNull52,
  getOrThrow: () => getOrThrow52,
  getOrThrowWith: () => getOrThrowWith52,
  getOrUndefined: () => getOrUndefined52,
  getOrder: () => getOrder62,
  getRight: () => getRight232,
  isNone: () => isNone232,
  isOption: () => isOption232,
  isSome: () => isSome232,
  let: () => let_232,
  lift2: () => lift252,
  liftNullable: () => liftNullable62,
  liftPredicate: () => liftPredicate62,
  liftThrowable: () => liftThrowable52,
  map: () => map62,
  match: () => match7,
  none: () => none232,
  orElse: () => orElse52,
  orElseEither: () => orElseEither52,
  orElseSome: () => orElseSome52,
  partitionMap: () => partitionMap62,
  product: () => product8,
  productMany: () => productMany8,
  reduceCompact: () => reduceCompact52,
  some: () => some232,
  tap: () => tap52,
  toArray: () => toArray52,
  toRefinement: () => toRefinement52,
  void: () => void_52,
  zipLeft: () => zipLeft52,
  zipRight: () => zipRight52,
  zipWith: () => zipWith62
});
var make232 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId332 = /* @__PURE__ */ Symbol.for("effect/Option");
var none232 = () => none8;
var some232 = some12;
var isOption232 = isOption8;
var isNone232 = isNone8;
var isSome232 = isSome8;
var match7 = /* @__PURE__ */ dual52(2, (self2, {
  onNone,
  onSome
}) => isNone232(self2) ? onNone() : onSome(self2.value));
var toRefinement52 = (f2222) => (a2222) => isSome232(f2222(a2222));
var fromIterable8 = (collection) => {
  for (const a2222 of collection) {
    return some232(a2222);
  }
  return none232();
};
var getRight232 = getRight8;
var getLeft232 = getLeft8;
var getOrElse52 = /* @__PURE__ */ dual52(2, (self2, onNone) => isNone232(self2) ? onNone() : self2.value);
var orElse52 = /* @__PURE__ */ dual52(2, (self2, that) => isNone232(self2) ? that() : self2);
var orElseSome52 = /* @__PURE__ */ dual52(2, (self2, onNone) => isNone232(self2) ? some232(onNone()) : self2);
var orElseEither52 = /* @__PURE__ */ dual52(2, (self2, that) => isNone232(self2) ? map62(that(), right62) : map62(self2, left62));
var firstSomeOf52 = (collection) => {
  let out = none232();
  for (out of collection) {
    if (isSome232(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable62 = (nullableValue) => nullableValue == null ? none232() : some232(nullableValue);
var liftNullable62 = (f2222) => (...a2222) => fromNullable62(f2222(...a2222));
var getOrNull52 = /* @__PURE__ */ getOrElse52(constNull52);
var getOrUndefined52 = /* @__PURE__ */ getOrElse52(constUndefined52);
var liftThrowable52 = (f2222) => (...a2222) => {
  try {
    return some232(f2222(...a2222));
  } catch (e2222) {
    return none232();
  }
};
var getOrThrowWith52 = /* @__PURE__ */ dual52(2, (self2, onNone) => {
  if (isSome232(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow52 = /* @__PURE__ */ getOrThrowWith52(() => new Error("getOrThrow called on a None"));
var map62 = /* @__PURE__ */ dual52(2, (self2, f2222) => isNone232(self2) ? none232() : some232(f2222(self2.value)));
var as52 = /* @__PURE__ */ dual52(2, (self2, b2222) => map62(self2, () => b2222));
var asVoid52 = /* @__PURE__ */ as52(void 0);
var void_52 = /* @__PURE__ */ some232(void 0);
var flatMap62 = /* @__PURE__ */ dual52(2, (self2, f2222) => isNone232(self2) ? none232() : f2222(self2.value));
var andThen52 = /* @__PURE__ */ dual52(2, (self2, f2222) => flatMap62(self2, (a2222) => {
  const b2222 = isFunction9(f2222) ? f2222(a2222) : f2222;
  return isOption232(b2222) ? b2222 : some232(b2222);
}));
var flatMapNullable62 = /* @__PURE__ */ dual52(2, (self2, f2222) => isNone232(self2) ? none232() : fromNullable62(f2222(self2.value)));
var flatten62 = /* @__PURE__ */ flatMap62(identity52);
var zipRight52 = /* @__PURE__ */ dual52(2, (self2, that) => flatMap62(self2, () => that));
var composeK52 = /* @__PURE__ */ dual52(2, (afb, bfc) => (a2222) => flatMap62(afb(a2222), bfc));
var zipLeft52 = /* @__PURE__ */ dual52(2, (self2, that) => tap52(self2, () => that));
var tap52 = /* @__PURE__ */ dual52(2, (self2, f2222) => flatMap62(self2, (a2222) => map62(f2222(a2222), () => a2222)));
var product8 = (self2, that) => isSome232(self2) && isSome232(that) ? some232([self2.value, that.value]) : none232();
var productMany8 = (self2, collection) => {
  if (isNone232(self2)) {
    return none232();
  }
  const out = [self2.value];
  for (const o2222 of collection) {
    if (isNone232(o2222)) {
      return none232();
    }
    out.push(o2222.value);
  }
  return some232(out);
};
var all8 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o2222 of input) {
      if (isNone232(o2222)) {
        return none232();
      }
      out2.push(o2222.value);
    }
    return some232(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o2222 = input[key];
    if (isNone232(o2222)) {
      return none232();
    }
    out[key] = o2222.value;
  }
  return some232(out);
};
var zipWith62 = /* @__PURE__ */ dual52(3, (self2, that, f2222) => map62(product8(self2, that), ([a2222, b2222]) => f2222(a2222, b2222)));
var ap52 = /* @__PURE__ */ dual52(2, (self2, that) => zipWith62(self2, that, (f2222, a2222) => f2222(a2222)));
var reduceCompact52 = /* @__PURE__ */ dual52(3, (self2, b2222, f2222) => {
  let out = b2222;
  for (const oa of self2) {
    if (isSome232(oa)) {
      out = f2222(out, oa.value);
    }
  }
  return out;
});
var toArray52 = (self2) => isNone232(self2) ? [] : [self2.value];
var partitionMap62 = /* @__PURE__ */ dual52(2, (self2, f2222) => {
  if (isNone232(self2)) {
    return [none232(), none232()];
  }
  const e2222 = f2222(self2.value);
  return isLeft62(e2222) ? [some232(e2222.left), none232()] : [none232(), some232(e2222.right)];
});
var filterMap62 = /* @__PURE__ */ dual52(2, (self2, f2222) => isNone232(self2) ? none232() : f2222(self2.value));
var filter62 = /* @__PURE__ */ dual52(2, (self2, predicate) => filterMap62(self2, (b2222) => predicate(b2222) ? some12(b2222) : none8));
var getEquivalence72 = (isEquivalent) => make16((x2222, y2222) => x2222 === y2222 || (isNone232(x2222) ? isNone232(y2222) : isNone232(y2222) ? false : isEquivalent(x2222.value, y2222.value)));
var getOrder62 = (O2222) => make232((self2, that) => isSome232(self2) ? isSome232(that) ? O2222(self2.value, that.value) : 1 : -1);
var lift252 = (f2222) => dual52(2, (self2, that) => zipWith62(self2, that, f2222));
var liftPredicate62 = (predicate) => (b2222) => predicate(b2222) ? some232(b2222) : none232();
var containsWith62 = (isEquivalent) => dual52(2, (self2, a2222) => isNone232(self2) ? false : isEquivalent(self2.value, a2222));
var _equivalence72 = /* @__PURE__ */ equivalence52();
var contains62 = /* @__PURE__ */ containsWith62(_equivalence72);
var exists52 = /* @__PURE__ */ dual52(2, (self2, refinement) => isNone232(self2) ? false : refinement(self2.value));
var bindTo232 = /* @__PURE__ */ bindTo9(map62);
var let_232 = /* @__PURE__ */ let_9(map62);
var bind232 = /* @__PURE__ */ bind9(map62, flatMap62);
var Do62 = /* @__PURE__ */ some232({});
var adapter232 = /* @__PURE__ */ adapter8();
var gen52 = (f2222) => {
  const iterator = f2222(adapter232);
  let state = iterator.next();
  if (state.done) {
    return some232(state.value);
  } else {
    let current = state.value;
    if (isGenKind52(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet52(current);
    }
    if (isNone232(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind52(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet52(current);
        }
        if (isNone232(current)) {
          return current;
        }
      }
    }
    return some232(state.value);
  }
};
var MutableRef_exports3 = {};
__export42(MutableRef_exports3, {
  compareAndSet: () => compareAndSet3,
  decrement: () => decrement3,
  decrementAndGet: () => decrementAndGet3,
  get: () => get4,
  getAndDecrement: () => getAndDecrement3,
  getAndIncrement: () => getAndIncrement3,
  getAndSet: () => getAndSet3,
  getAndUpdate: () => getAndUpdate3,
  increment: () => increment3,
  incrementAndGet: () => incrementAndGet3,
  make: () => make332,
  set: () => set42,
  setAndGet: () => setAndGet3,
  toggle: () => toggle3,
  update: () => update3,
  updateAndGet: () => updateAndGet3
});
var TypeId432 = /* @__PURE__ */ Symbol.for("effect/MutableRef");
var MutableRefProto3 = {
  [TypeId432]: TypeId432,
  toString() {
    return format52(this.toJSON());
  },
  toJSON() {
    return {
      _id: "MutableRef",
      current: toJSON52(this.current)
    };
  },
  [NodeInspectSymbol52]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments52(this, arguments);
  }
};
var make332 = (value) => {
  const ref = Object.create(MutableRefProto3);
  ref.current = value;
  return ref;
};
var compareAndSet3 = /* @__PURE__ */ dual52(3, (self2, oldValue, newValue) => {
  if (equals52(oldValue, self2.current)) {
    self2.current = newValue;
    return true;
  }
  return false;
});
var decrement3 = (self2) => update3(self2, (n2222) => n2222 - 1);
var decrementAndGet3 = (self2) => updateAndGet3(self2, (n2222) => n2222 - 1);
var get4 = (self2) => self2.current;
var getAndDecrement3 = (self2) => getAndUpdate3(self2, (n2222) => n2222 - 1);
var getAndIncrement3 = (self2) => getAndUpdate3(self2, (n2222) => n2222 + 1);
var getAndSet3 = /* @__PURE__ */ dual52(2, (self2, value) => {
  const ret = self2.current;
  self2.current = value;
  return ret;
});
var getAndUpdate3 = /* @__PURE__ */ dual52(2, (self2, f2222) => getAndSet3(self2, f2222(get4(self2))));
var increment3 = (self2) => update3(self2, (n2222) => n2222 + 1);
var incrementAndGet3 = (self2) => updateAndGet3(self2, (n2222) => n2222 + 1);
var set42 = /* @__PURE__ */ dual52(2, (self2, value) => {
  self2.current = value;
  return self2;
});
var setAndGet3 = /* @__PURE__ */ dual52(2, (self2, value) => {
  self2.current = value;
  return self2.current;
});
var update3 = /* @__PURE__ */ dual52(2, (self2, f2222) => set42(self2, f2222(get4(self2))));
var updateAndGet3 = /* @__PURE__ */ dual52(2, (self2, f2222) => setAndGet3(self2, f2222(get4(self2))));
var toggle3 = (self2) => update3(self2, (_2222) => !_2222);
function getVariables22(initialScope) {
  const scopeRef = MutableRef_exports3.make(initialScope);
  const variablesRef = MutableRef_exports3.make(MutableRef_exports3.get(scopeRef).variables);
  while (MutableRef_exports3.get(scopeRef).type !== scopeManager.ScopeType.global) {
    MutableRef_exports3.set(scopeRef, MutableRef_exports3.get(scopeRef).upper);
    MutableRef_exports3.update(variablesRef, (variables) => variables.concat(MutableRef_exports3.get(scopeRef).variables));
  }
  return MutableRef_exports3.get(variablesRef).reverse();
}
var findVariable32 = Function_exports52.dual(2, (name22, initialScope) => {
  return Option_exports52.fromNullable(getVariables22(initialScope).find((variable) => variable.name === name22));
});
var t22 = Symbol.for("@ts-pattern/matcher");
var e22 = Symbol.for("@ts-pattern/isVariadic");
var n22 = "@ts-pattern/anonymous-select-key";
var r22 = (t2222) => Boolean(t2222 && "object" == typeof t2222);
var i22 = (e2222) => e2222 && !!e2222[t22];
var o22 = (n2222, s2222, c2222) => {
  if (i22(n2222)) {
    const e2222 = n2222[t22](), { matched: r2222, selections: i2222 } = e2222.match(s2222);
    return r2222 && i2222 && Object.keys(i2222).forEach((t2222) => c2222(t2222, i2222[t2222])), r2222;
  }
  if (r22(n2222)) {
    if (!r22(s2222)) return false;
    if (Array.isArray(n2222)) {
      if (!Array.isArray(s2222)) return false;
      let t2222 = [], r2222 = [], a2222 = [];
      for (const o2222 of n2222.keys()) {
        const s322 = n2222[o2222];
        i22(s322) && s322[e22] ? a2222.push(s322) : a2222.length ? r2222.push(s322) : t2222.push(s322);
      }
      if (a2222.length) {
        if (a2222.length > 1) throw new Error("Pattern error: Using `...P.array(...)` several times in a single pattern is not allowed.");
        if (s2222.length < t2222.length + r2222.length) return false;
        const e2222 = s2222.slice(0, t2222.length), n322 = 0 === r2222.length ? [] : s2222.slice(-r2222.length), i2222 = s2222.slice(t2222.length, 0 === r2222.length ? Infinity : -r2222.length);
        return t2222.every((t322, n422) => o22(t322, e2222[n422], c2222)) && r2222.every((t322, e322) => o22(t322, n322[e322], c2222)) && (0 === a2222.length || o22(a2222[0], i2222, c2222));
      }
      return n2222.length === s2222.length && n2222.every((t322, e2222) => o22(t322, s2222[e2222], c2222));
    }
    return Object.keys(n2222).every((e2222) => {
      const r2222 = n2222[e2222];
      return (e2222 in s2222 || i22(a2222 = r2222) && "optional" === a2222[t22]().matcherType) && o22(r2222, s2222[e2222], c2222);
      var a2222;
    });
  }
  return Object.is(s2222, n2222);
};
var s22 = (e2222) => {
  var n2222, o2222, a2222;
  return r22(e2222) ? i22(e2222) ? null != (n2222 = null == (o2222 = (a2222 = e2222[t22]()).getSelectionKeys) ? void 0 : o2222.call(a2222)) ? n2222 : [] : Array.isArray(e2222) ? c22(e2222, s22) : c22(Object.values(e2222), s22) : [];
};
var c22 = (t2222, e2222) => t2222.reduce((t322, n2222) => t322.concat(e2222(n2222)), []);
function a22(...t2222) {
  if (1 === t2222.length) {
    const [e2222] = t2222;
    return (t322) => o22(e2222, t322, () => {
    });
  }
  if (2 === t2222.length) {
    const [e2222, n2222] = t2222;
    return o22(e2222, n2222, () => {
    });
  }
  throw new Error(`isMatching wasn't given the right number of arguments: expected 1 or 2, received ${t2222.length}.`);
}
function u22(t2222) {
  return Object.assign(t2222, { optional: () => l22(t2222), and: (e2222) => m22(t2222, e2222), or: (e2222) => d22(t2222, e2222), select: (e2222) => void 0 === e2222 ? p22(t2222) : p22(e2222, t2222) });
}
function h22(t2222) {
  return Object.assign(((t322) => Object.assign(t322, { [Symbol.iterator]() {
    let n2222 = 0;
    const r2222 = [{ value: Object.assign(t322, { [e22]: true }), done: false }, { done: true, value: void 0 }];
    return { next: () => {
      var t422;
      return null != (t422 = r2222[n2222++]) ? t422 : r2222.at(-1);
    } };
  } }))(t2222), { optional: () => h22(l22(t2222)), select: (e2222) => h22(void 0 === e2222 ? p22(t2222) : p22(e2222, t2222)) });
}
function l22(e2222) {
  return u22({ [t22]: () => ({ match: (t2222) => {
    let n2222 = {};
    const r2222 = (t322, e322) => {
      n2222[t322] = e322;
    };
    return void 0 === t2222 ? (s22(e2222).forEach((t322) => r2222(t322, void 0)), { matched: true, selections: n2222 }) : { matched: o22(e2222, t2222, r2222), selections: n2222 };
  }, getSelectionKeys: () => s22(e2222), matcherType: "optional" }) });
}
var f22 = (t2222, e2222) => {
  for (const n2222 of t2222) if (!e2222(n2222)) return false;
  return true;
};
var g22 = (t2222, e2222) => {
  for (const [n2222, r2222] of t2222.entries()) if (!e2222(r2222, n2222)) return false;
  return true;
};
function m22(...e2222) {
  return u22({ [t22]: () => ({ match: (t2222) => {
    let n2222 = {};
    const r2222 = (t322, e322) => {
      n2222[t322] = e322;
    };
    return { matched: e2222.every((e322) => o22(e322, t2222, r2222)), selections: n2222 };
  }, getSelectionKeys: () => c22(e2222, s22), matcherType: "and" }) });
}
function d22(...e2222) {
  return u22({ [t22]: () => ({ match: (t2222) => {
    let n2222 = {};
    const r2222 = (t322, e322) => {
      n2222[t322] = e322;
    };
    return c22(e2222, s22).forEach((t322) => r2222(t322, void 0)), { matched: e2222.some((e322) => o22(e322, t2222, r2222)), selections: n2222 };
  }, getSelectionKeys: () => c22(e2222, s22), matcherType: "or" }) });
}
function y22(e2222) {
  return { [t22]: () => ({ match: (t2222) => ({ matched: Boolean(e2222(t2222)) }) }) };
}
function p22(...e2222) {
  const r2222 = "string" == typeof e2222[0] ? e2222[0] : void 0, i2222 = 2 === e2222.length ? e2222[1] : "string" == typeof e2222[0] ? void 0 : e2222[0];
  return u22({ [t22]: () => ({ match: (t2222) => {
    let e322 = { [null != r2222 ? r2222 : n22]: t2222 };
    return { matched: void 0 === i2222 || o22(i2222, t2222, (t322, n2222) => {
      e322[t322] = n2222;
    }), selections: e322 };
  }, getSelectionKeys: () => [null != r2222 ? r2222 : n22].concat(void 0 === i2222 ? [] : s22(i2222)) }) });
}
function v22(t2222) {
  return "number" == typeof t2222;
}
function b22(t2222) {
  return "string" == typeof t2222;
}
function w22(t2222) {
  return "bigint" == typeof t2222;
}
var S22 = u22(y22(function(t2222) {
  return true;
}));
var O22 = S22;
var j22 = (t2222) => Object.assign(u22(t2222), { startsWith: (e2222) => {
  return j22(m22(t2222, (n2222 = e2222, y22((t322) => b22(t322) && t322.startsWith(n2222)))));
  var n2222;
}, endsWith: (e2222) => {
  return j22(m22(t2222, (n2222 = e2222, y22((t322) => b22(t322) && t322.endsWith(n2222)))));
  var n2222;
}, minLength: (e2222) => j22(m22(t2222, ((t322) => y22((e322) => b22(e322) && e322.length >= t322))(e2222))), maxLength: (e2222) => j22(m22(t2222, ((t322) => y22((e322) => b22(e322) && e322.length <= t322))(e2222))), includes: (e2222) => {
  return j22(m22(t2222, (n2222 = e2222, y22((t322) => b22(t322) && t322.includes(n2222)))));
  var n2222;
}, regex: (e2222) => {
  return j22(m22(t2222, (n2222 = e2222, y22((t322) => b22(t322) && Boolean(t322.match(n2222))))));
  var n2222;
} });
var E22 = j22(y22(b22));
var K22 = (t2222) => Object.assign(u22(t2222), { between: (e2222, n2222) => K22(m22(t2222, ((t322, e322) => y22((n322) => v22(n322) && t322 <= n322 && e322 >= n322))(e2222, n2222))), lt: (e2222) => K22(m22(t2222, ((t322) => y22((e322) => v22(e322) && e322 < t322))(e2222))), gt: (e2222) => K22(m22(t2222, ((t322) => y22((e322) => v22(e322) && e322 > t322))(e2222))), lte: (e2222) => K22(m22(t2222, ((t322) => y22((e322) => v22(e322) && e322 <= t322))(e2222))), gte: (e2222) => K22(m22(t2222, ((t322) => y22((e322) => v22(e322) && e322 >= t322))(e2222))), int: () => K22(m22(t2222, y22((t322) => v22(t322) && Number.isInteger(t322)))), finite: () => K22(m22(t2222, y22((t322) => v22(t322) && Number.isFinite(t322)))), positive: () => K22(m22(t2222, y22((t322) => v22(t322) && t322 > 0))), negative: () => K22(m22(t2222, y22((t322) => v22(t322) && t322 < 0))) });
var x22 = K22(y22(v22));
var A22 = (t2222) => Object.assign(u22(t2222), { between: (e2222, n2222) => A22(m22(t2222, ((t322, e322) => y22((n322) => w22(n322) && t322 <= n322 && e322 >= n322))(e2222, n2222))), lt: (e2222) => A22(m22(t2222, ((t322) => y22((e322) => w22(e322) && e322 < t322))(e2222))), gt: (e2222) => A22(m22(t2222, ((t322) => y22((e322) => w22(e322) && e322 > t322))(e2222))), lte: (e2222) => A22(m22(t2222, ((t322) => y22((e322) => w22(e322) && e322 <= t322))(e2222))), gte: (e2222) => A22(m22(t2222, ((t322) => y22((e322) => w22(e322) && e322 >= t322))(e2222))), positive: () => A22(m22(t2222, y22((t322) => w22(t322) && t322 > 0))), negative: () => A22(m22(t2222, y22((t322) => w22(t322) && t322 < 0))) });
var P3 = A22(y22(w22));
var T22 = u22(y22(function(t2222) {
  return "boolean" == typeof t2222;
}));
var k22 = u22(y22(function(t2222) {
  return "symbol" == typeof t2222;
}));
var B22 = u22(y22(function(t2222) {
  return null == t2222;
}));
var _22 = u22(y22(function(t2222) {
  return null != t2222;
}));
var N22 = { __proto__: null, matcher: t22, optional: l22, array: function(...e2222) {
  return h22({ [t22]: () => ({ match: (t2222) => {
    if (!Array.isArray(t2222)) return { matched: false };
    if (0 === e2222.length) return { matched: true };
    const n2222 = e2222[0];
    let r2222 = {};
    if (0 === t2222.length) return s22(n2222).forEach((t322) => {
      r2222[t322] = [];
    }), { matched: true, selections: r2222 };
    const i2222 = (t322, e322) => {
      r2222[t322] = (r2222[t322] || []).concat([e322]);
    };
    return { matched: t2222.every((t322) => o22(n2222, t322, i2222)), selections: r2222 };
  }, getSelectionKeys: () => 0 === e2222.length ? [] : s22(e2222[0]) }) });
}, set: function(...e2222) {
  return u22({ [t22]: () => ({ match: (t2222) => {
    if (!(t2222 instanceof Set)) return { matched: false };
    let n2222 = {};
    if (0 === t2222.size) return { matched: true, selections: n2222 };
    if (0 === e2222.length) return { matched: true };
    const r2222 = (t322, e322) => {
      n2222[t322] = (n2222[t322] || []).concat([e322]);
    }, i2222 = e2222[0];
    return { matched: f22(t2222, (t322) => o22(i2222, t322, r2222)), selections: n2222 };
  }, getSelectionKeys: () => 0 === e2222.length ? [] : s22(e2222[0]) }) });
}, map: function(...e2222) {
  return u22({ [t22]: () => ({ match: (t2222) => {
    if (!(t2222 instanceof Map)) return { matched: false };
    let n2222 = {};
    if (0 === t2222.size) return { matched: true, selections: n2222 };
    const r2222 = (t322, e322) => {
      n2222[t322] = (n2222[t322] || []).concat([e322]);
    };
    if (0 === e2222.length) return { matched: true };
    var i2222;
    if (1 === e2222.length) throw new Error(`\`P.map\` wasn't given enough arguments. Expected (key, value), received ${null == (i2222 = e2222[0]) ? void 0 : i2222.toString()}`);
    const [s2222, c2222] = e2222;
    return { matched: g22(t2222, (t322, e322) => {
      const n322 = o22(s2222, e322, r2222), i322 = o22(c2222, t322, r2222);
      return n322 && i322;
    }), selections: n2222 };
  }, getSelectionKeys: () => 0 === e2222.length ? [] : [...s22(e2222[0]), ...s22(e2222[1])] }) });
}, intersection: m22, union: d22, not: function(e2222) {
  return u22({ [t22]: () => ({ match: (t2222) => ({ matched: !o22(e2222, t2222, () => {
  }) }), getSelectionKeys: () => [], matcherType: "not" }) });
}, when: y22, select: p22, any: S22, _: O22, string: E22, number: x22, bigint: P3, boolean: T22, symbol: k22, nullish: B22, nonNullable: _22, instanceOf: function(t2222) {
  return u22(y22(/* @__PURE__ */ function(t322) {
    return (e2222) => e2222 instanceof t322;
  }(t2222)));
}, shape: function(t2222) {
  return u22(y22(a22(t2222)));
} };
var KEYS32 = {
  ArrayExpression: [
    "elements"
  ],
  ArrayPattern: [
    "elements"
  ],
  ArrowFunctionExpression: [
    "params",
    "body"
  ],
  AssignmentExpression: [
    "left",
    "right"
  ],
  AssignmentPattern: [
    "left",
    "right"
  ],
  AwaitExpression: [
    "argument"
  ],
  BinaryExpression: [
    "left",
    "right"
  ],
  BlockStatement: [
    "body"
  ],
  BreakStatement: [
    "label"
  ],
  CallExpression: [
    "callee",
    "arguments"
  ],
  CatchClause: [
    "param",
    "body"
  ],
  ChainExpression: [
    "expression"
  ],
  ClassBody: [
    "body"
  ],
  ClassDeclaration: [
    "id",
    "superClass",
    "body"
  ],
  ClassExpression: [
    "id",
    "superClass",
    "body"
  ],
  ConditionalExpression: [
    "test",
    "consequent",
    "alternate"
  ],
  ContinueStatement: [
    "label"
  ],
  DebuggerStatement: [],
  DoWhileStatement: [
    "body",
    "test"
  ],
  EmptyStatement: [],
  ExperimentalRestProperty: [
    "argument"
  ],
  ExperimentalSpreadProperty: [
    "argument"
  ],
  ExportAllDeclaration: [
    "exported",
    "source"
  ],
  ExportDefaultDeclaration: [
    "declaration"
  ],
  ExportNamedDeclaration: [
    "declaration",
    "specifiers",
    "source"
  ],
  ExportSpecifier: [
    "exported",
    "local"
  ],
  ExpressionStatement: [
    "expression"
  ],
  ForInStatement: [
    "left",
    "right",
    "body"
  ],
  ForOfStatement: [
    "left",
    "right",
    "body"
  ],
  ForStatement: [
    "init",
    "test",
    "update",
    "body"
  ],
  FunctionDeclaration: [
    "id",
    "params",
    "body"
  ],
  FunctionExpression: [
    "id",
    "params",
    "body"
  ],
  Identifier: [],
  IfStatement: [
    "test",
    "consequent",
    "alternate"
  ],
  ImportDeclaration: [
    "specifiers",
    "source"
  ],
  ImportDefaultSpecifier: [
    "local"
  ],
  ImportExpression: [
    "source"
  ],
  ImportNamespaceSpecifier: [
    "local"
  ],
  ImportSpecifier: [
    "imported",
    "local"
  ],
  JSXAttribute: [
    "name",
    "value"
  ],
  JSXClosingElement: [
    "name"
  ],
  JSXClosingFragment: [],
  JSXElement: [
    "openingElement",
    "children",
    "closingElement"
  ],
  JSXEmptyExpression: [],
  JSXExpressionContainer: [
    "expression"
  ],
  JSXFragment: [
    "openingFragment",
    "children",
    "closingFragment"
  ],
  JSXIdentifier: [],
  JSXMemberExpression: [
    "object",
    "property"
  ],
  JSXNamespacedName: [
    "namespace",
    "name"
  ],
  JSXOpeningElement: [
    "name",
    "attributes"
  ],
  JSXOpeningFragment: [],
  JSXSpreadAttribute: [
    "argument"
  ],
  JSXSpreadChild: [
    "expression"
  ],
  JSXText: [],
  LabeledStatement: [
    "label",
    "body"
  ],
  Literal: [],
  LogicalExpression: [
    "left",
    "right"
  ],
  MemberExpression: [
    "object",
    "property"
  ],
  MetaProperty: [
    "meta",
    "property"
  ],
  MethodDefinition: [
    "key",
    "value"
  ],
  NewExpression: [
    "callee",
    "arguments"
  ],
  ObjectExpression: [
    "properties"
  ],
  ObjectPattern: [
    "properties"
  ],
  PrivateIdentifier: [],
  Program: [
    "body"
  ],
  Property: [
    "key",
    "value"
  ],
  PropertyDefinition: [
    "key",
    "value"
  ],
  RestElement: [
    "argument"
  ],
  ReturnStatement: [
    "argument"
  ],
  SequenceExpression: [
    "expressions"
  ],
  SpreadElement: [
    "argument"
  ],
  StaticBlock: [
    "body"
  ],
  Super: [],
  SwitchCase: [
    "test",
    "consequent"
  ],
  SwitchStatement: [
    "discriminant",
    "cases"
  ],
  TaggedTemplateExpression: [
    "tag",
    "quasi"
  ],
  TemplateElement: [],
  TemplateLiteral: [
    "quasis",
    "expressions"
  ],
  ThisExpression: [],
  ThrowStatement: [
    "argument"
  ],
  TryStatement: [
    "block",
    "handler",
    "finalizer"
  ],
  UnaryExpression: [
    "argument"
  ],
  UpdateExpression: [
    "argument"
  ],
  VariableDeclaration: [
    "declarations"
  ],
  VariableDeclarator: [
    "id",
    "init"
  ],
  WhileStatement: [
    "test",
    "body"
  ],
  WithStatement: [
    "object",
    "body"
  ],
  YieldExpression: [
    "argument"
  ]
};
var NODE_TYPES32 = Object.keys(KEYS32);
for (const type of NODE_TYPES32) {
  Object.freeze(KEYS32[type]);
}
Object.freeze(KEYS32);
var visitor_keys_default32 = KEYS32;
var KEY_BLACKLIST32 = /* @__PURE__ */ new Set([
  "parent",
  "leadingComments",
  "trailingComments"
]);
function filterKey32(key) {
  return !KEY_BLACKLIST32.has(key) && key[0] !== "_";
}
function getKeys32(node) {
  return Object.keys(node).filter(filterKey32);
}
function getInnermostScope32(initialScope, node) {
  const location = node.range[0];
  let scope = initialScope;
  let found = false;
  do {
    found = false;
    for (const childScope of scope.childScopes) {
      const range222 = childScope.block.range;
      if (range222[0] <= location && location < range222[1]) {
        scope = childScope;
        found = true;
        break;
      }
    }
  } while (found);
  return scope;
}
function findVariable232(initialScope, nameOrNode) {
  let name22 = "";
  let scope = initialScope;
  if (typeof nameOrNode === "string") {
    name22 = nameOrNode;
  } else {
    name22 = nameOrNode.name;
    scope = getInnermostScope32(scope, nameOrNode);
  }
  while (scope != null) {
    const variable = scope.set.get(name22);
    if (variable != null) {
      return variable;
    }
    scope = scope.upper;
  }
  return null;
}
function negate032(token) {
  return !this(token);
}
function negate32(f2222) {
  return negate032.bind(f2222);
}
function isPunctuatorTokenWithValue32(token, value) {
  return token.type === "Punctuator" && token.value === value;
}
function isArrowToken32(token) {
  return isPunctuatorTokenWithValue32(token, "=>");
}
function isCommaToken32(token) {
  return isPunctuatorTokenWithValue32(token, ",");
}
function isSemicolonToken32(token) {
  return isPunctuatorTokenWithValue32(token, ";");
}
function isColonToken32(token) {
  return isPunctuatorTokenWithValue32(token, ":");
}
function isOpeningParenToken32(token) {
  return isPunctuatorTokenWithValue32(token, "(");
}
function isClosingParenToken32(token) {
  return isPunctuatorTokenWithValue32(token, ")");
}
function isOpeningBracketToken32(token) {
  return isPunctuatorTokenWithValue32(token, "[");
}
function isClosingBracketToken32(token) {
  return isPunctuatorTokenWithValue32(token, "]");
}
function isOpeningBraceToken32(token) {
  return isPunctuatorTokenWithValue32(token, "{");
}
function isClosingBraceToken32(token) {
  return isPunctuatorTokenWithValue32(token, "}");
}
function isCommentToken32(token) {
  return ["Block", "Line", "Shebang"].includes(token.type);
}
negate32(isArrowToken32);
negate32(isCommaToken32);
negate32(isSemicolonToken32);
negate32(isColonToken32);
negate32(isOpeningParenToken32);
negate32(isClosingParenToken32);
negate32(isOpeningBracketToken32);
negate32(isClosingBracketToken32);
negate32(isOpeningBraceToken32);
negate32(isClosingBraceToken32);
negate32(isCommentToken32);
function getOpeningParenOfParams32(node, sourceCode) {
  return node.id ? sourceCode.getTokenAfter(node.id, isOpeningParenToken32) : sourceCode.getFirstToken(node, isOpeningParenToken32);
}
function getFunctionHeadLocation32(node, sourceCode) {
  const parent = node.parent;
  let start = null;
  let end = null;
  if (node.type === "ArrowFunctionExpression") {
    const arrowToken = sourceCode.getTokenBefore(node.body, isArrowToken32);
    start = arrowToken.loc.start;
    end = arrowToken.loc.end;
  } else if (parent.type === "Property" || parent.type === "MethodDefinition" || parent.type === "PropertyDefinition") {
    start = parent.loc.start;
    end = getOpeningParenOfParams32(node, sourceCode).loc.start;
  } else {
    start = node.loc.start;
    end = getOpeningParenOfParams32(node, sourceCode).loc.start;
  }
  return {
    start: { ...start },
    end: { ...end }
  };
}
var globalObject32 = typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {};
var builtinNames32 = Object.freeze(
  /* @__PURE__ */ new Set([
    "Array",
    "ArrayBuffer",
    "BigInt",
    "BigInt64Array",
    "BigUint64Array",
    "Boolean",
    "DataView",
    "Date",
    "decodeURI",
    "decodeURIComponent",
    "encodeURI",
    "encodeURIComponent",
    "escape",
    "Float32Array",
    "Float64Array",
    "Function",
    "Infinity",
    "Int16Array",
    "Int32Array",
    "Int8Array",
    "isFinite",
    "isNaN",
    "isPrototypeOf",
    "JSON",
    "Map",
    "Math",
    "NaN",
    "Number",
    "Object",
    "parseFloat",
    "parseInt",
    "Promise",
    "Proxy",
    "Reflect",
    "RegExp",
    "Set",
    "String",
    "Symbol",
    "Uint16Array",
    "Uint32Array",
    "Uint8Array",
    "Uint8ClampedArray",
    "undefined",
    "unescape",
    "WeakMap",
    "WeakSet"
  ])
);
var callAllowed32 = new Set(
  [
    Array.isArray,
    Array.of,
    Array.prototype.at,
    Array.prototype.concat,
    Array.prototype.entries,
    Array.prototype.every,
    Array.prototype.filter,
    Array.prototype.find,
    Array.prototype.findIndex,
    Array.prototype.flat,
    Array.prototype.includes,
    Array.prototype.indexOf,
    Array.prototype.join,
    Array.prototype.keys,
    Array.prototype.lastIndexOf,
    Array.prototype.slice,
    Array.prototype.some,
    Array.prototype.toString,
    Array.prototype.values,
    typeof BigInt === "function" ? BigInt : void 0,
    Boolean,
    Date,
    Date.parse,
    decodeURI,
    decodeURIComponent,
    encodeURI,
    encodeURIComponent,
    escape,
    isFinite,
    isNaN,
    isPrototypeOf,
    Map,
    Map.prototype.entries,
    Map.prototype.get,
    Map.prototype.has,
    Map.prototype.keys,
    Map.prototype.values,
    ...Object.getOwnPropertyNames(Math).filter((k2222) => k2222 !== "random").map((k2222) => Math[k2222]).filter((f2222) => typeof f2222 === "function"),
    Number,
    Number.isFinite,
    Number.isNaN,
    Number.parseFloat,
    Number.parseInt,
    Number.prototype.toExponential,
    Number.prototype.toFixed,
    Number.prototype.toPrecision,
    Number.prototype.toString,
    Object,
    Object.entries,
    Object.is,
    Object.isExtensible,
    Object.isFrozen,
    Object.isSealed,
    Object.keys,
    Object.values,
    parseFloat,
    parseInt,
    RegExp,
    Set,
    Set.prototype.entries,
    Set.prototype.has,
    Set.prototype.keys,
    Set.prototype.values,
    String,
    String.fromCharCode,
    String.fromCodePoint,
    String.raw,
    String.prototype.at,
    String.prototype.charAt,
    String.prototype.charCodeAt,
    String.prototype.codePointAt,
    String.prototype.concat,
    String.prototype.endsWith,
    String.prototype.includes,
    String.prototype.indexOf,
    String.prototype.lastIndexOf,
    String.prototype.normalize,
    String.prototype.padEnd,
    String.prototype.padStart,
    String.prototype.slice,
    String.prototype.startsWith,
    String.prototype.substr,
    String.prototype.substring,
    String.prototype.toLowerCase,
    String.prototype.toString,
    String.prototype.toUpperCase,
    String.prototype.trim,
    String.prototype.trimEnd,
    String.prototype.trimLeft,
    String.prototype.trimRight,
    String.prototype.trimStart,
    Symbol.for,
    Symbol.keyFor,
    unescape
  ].filter((f2222) => typeof f2222 === "function")
);
var callPassThrough32 = /* @__PURE__ */ new Set([
  Object.freeze,
  Object.preventExtensions,
  Object.seal
]);
var getterAllowed32 = [
  [Map, /* @__PURE__ */ new Set(["size"])],
  [
    RegExp,
    /* @__PURE__ */ new Set([
      "dotAll",
      "flags",
      "global",
      "hasIndices",
      "ignoreCase",
      "multiline",
      "source",
      "sticky",
      "unicode"
    ])
  ],
  [Set, /* @__PURE__ */ new Set(["size"])]
];
function getPropertyDescriptor32(object222, name22) {
  let x2222 = object222;
  while ((typeof x2222 === "object" || typeof x2222 === "function") && x2222 !== null) {
    const d2222 = Object.getOwnPropertyDescriptor(x2222, name22);
    if (d2222) {
      return d2222;
    }
    x2222 = Object.getPrototypeOf(x2222);
  }
  return null;
}
function isGetter32(object222, name22) {
  const d2222 = getPropertyDescriptor32(object222, name22);
  return d2222 != null && d2222.get != null;
}
function getElementValues32(nodeList, initialScope) {
  const valueList = [];
  for (let i2222 = 0; i2222 < nodeList.length; ++i2222) {
    const elementNode = nodeList[i2222];
    if (elementNode == null) {
      valueList.length = i2222 + 1;
    } else if (elementNode.type === "SpreadElement") {
      const argument = getStaticValueR32(elementNode.argument, initialScope);
      if (argument == null) {
        return null;
      }
      valueList.push(...argument.value);
    } else {
      const element = getStaticValueR32(elementNode, initialScope);
      if (element == null) {
        return null;
      }
      valueList.push(element.value);
    }
  }
  return valueList;
}
function isEffectivelyConst32(variable) {
  const refs = variable.references;
  const inits = refs.filter((r2222) => r2222.init).length;
  const reads = refs.filter((r2222) => r2222.isReadOnly()).length;
  if (inits === 1 && reads + inits === refs.length) {
    return true;
  }
  return false;
}
var operations32 = Object.freeze({
  ArrayExpression(node, initialScope) {
    const elements = getElementValues32(node.elements, initialScope);
    return elements != null ? { value: elements } : null;
  },
  AssignmentExpression(node, initialScope) {
    if (node.operator === "=") {
      return getStaticValueR32(node.right, initialScope);
    }
    return null;
  },
  //eslint-disable-next-line complexity
  BinaryExpression(node, initialScope) {
    if (node.operator === "in" || node.operator === "instanceof") {
      return null;
    }
    const left334 = getStaticValueR32(node.left, initialScope);
    const right334 = getStaticValueR32(node.right, initialScope);
    if (left334 != null && right334 != null) {
      switch (node.operator) {
        case "==":
          return { value: left334.value == right334.value };
        case "!=":
          return { value: left334.value != right334.value };
        case "===":
          return { value: left334.value === right334.value };
        case "!==":
          return { value: left334.value !== right334.value };
        case "<":
          return { value: left334.value < right334.value };
        case "<=":
          return { value: left334.value <= right334.value };
        case ">":
          return { value: left334.value > right334.value };
        case ">=":
          return { value: left334.value >= right334.value };
        case "<<":
          return { value: left334.value << right334.value };
        case ">>":
          return { value: left334.value >> right334.value };
        case ">>>":
          return { value: left334.value >>> right334.value };
        case "+":
          return { value: left334.value + right334.value };
        case "-":
          return { value: left334.value - right334.value };
        case "*":
          return { value: left334.value * right334.value };
        case "/":
          return { value: left334.value / right334.value };
        case "%":
          return { value: left334.value % right334.value };
        case "**":
          return { value: left334.value ** right334.value };
        case "|":
          return { value: left334.value | right334.value };
        case "^":
          return { value: left334.value ^ right334.value };
        case "&":
          return { value: left334.value & right334.value };
      }
    }
    return null;
  },
  CallExpression(node, initialScope) {
    const calleeNode = node.callee;
    const args = getElementValues32(node.arguments, initialScope);
    if (args != null) {
      if (calleeNode.type === "MemberExpression") {
        if (calleeNode.property.type === "PrivateIdentifier") {
          return null;
        }
        const object222 = getStaticValueR32(calleeNode.object, initialScope);
        if (object222 != null) {
          if (object222.value == null && (object222.optional || node.optional)) {
            return { value: void 0, optional: true };
          }
          const property = getStaticPropertyNameValue32(
            calleeNode,
            initialScope
          );
          if (property != null) {
            const receiver = object222.value;
            const methodName = property.value;
            if (callAllowed32.has(receiver[methodName])) {
              return { value: receiver[methodName](...args) };
            }
            if (callPassThrough32.has(receiver[methodName])) {
              return { value: args[0] };
            }
          }
        }
      } else {
        const callee = getStaticValueR32(calleeNode, initialScope);
        if (callee != null) {
          if (callee.value == null && node.optional) {
            return { value: void 0, optional: true };
          }
          const func = callee.value;
          if (callAllowed32.has(func)) {
            return { value: func(...args) };
          }
          if (callPassThrough32.has(func)) {
            return { value: args[0] };
          }
        }
      }
    }
    return null;
  },
  ConditionalExpression(node, initialScope) {
    const test = getStaticValueR32(node.test, initialScope);
    if (test != null) {
      return test.value ? getStaticValueR32(node.consequent, initialScope) : getStaticValueR32(node.alternate, initialScope);
    }
    return null;
  },
  ExpressionStatement(node, initialScope) {
    return getStaticValueR32(node.expression, initialScope);
  },
  Identifier(node, initialScope) {
    if (initialScope != null) {
      const variable = findVariable232(initialScope, node);
      if (variable != null && variable.defs.length === 0 && builtinNames32.has(variable.name) && variable.name in globalObject32) {
        return { value: globalObject32[variable.name] };
      }
      if (variable != null && variable.defs.length === 1) {
        const def = variable.defs[0];
        if (def.parent && def.type === "Variable" && (def.parent.kind === "const" || isEffectivelyConst32(variable)) && // TODO(mysticatea): don't support destructuring here.
        def.node.id.type === "Identifier") {
          return getStaticValueR32(def.node.init, initialScope);
        }
      }
    }
    return null;
  },
  Literal(node) {
    if ((node.regex != null || node.bigint != null) && node.value == null) {
      return null;
    }
    return { value: node.value };
  },
  LogicalExpression(node, initialScope) {
    const left334 = getStaticValueR32(node.left, initialScope);
    if (left334 != null) {
      if (node.operator === "||" && Boolean(left334.value) === true || node.operator === "&&" && Boolean(left334.value) === false || node.operator === "??" && left334.value != null) {
        return left334;
      }
      const right334 = getStaticValueR32(node.right, initialScope);
      if (right334 != null) {
        return right334;
      }
    }
    return null;
  },
  MemberExpression(node, initialScope) {
    if (node.property.type === "PrivateIdentifier") {
      return null;
    }
    const object222 = getStaticValueR32(node.object, initialScope);
    if (object222 != null) {
      if (object222.value == null && (object222.optional || node.optional)) {
        return { value: void 0, optional: true };
      }
      const property = getStaticPropertyNameValue32(node, initialScope);
      if (property != null) {
        if (!isGetter32(object222.value, property.value)) {
          return { value: object222.value[property.value] };
        }
        for (const [classFn, allowed] of getterAllowed32) {
          if (object222.value instanceof classFn && allowed.has(property.value)) {
            return { value: object222.value[property.value] };
          }
        }
      }
    }
    return null;
  },
  ChainExpression(node, initialScope) {
    const expression = getStaticValueR32(node.expression, initialScope);
    if (expression != null) {
      return { value: expression.value };
    }
    return null;
  },
  NewExpression(node, initialScope) {
    const callee = getStaticValueR32(node.callee, initialScope);
    const args = getElementValues32(node.arguments, initialScope);
    if (callee != null && args != null) {
      const Func = callee.value;
      if (callAllowed32.has(Func)) {
        return { value: new Func(...args) };
      }
    }
    return null;
  },
  ObjectExpression(node, initialScope) {
    const object222 = {};
    for (const propertyNode of node.properties) {
      if (propertyNode.type === "Property") {
        if (propertyNode.kind !== "init") {
          return null;
        }
        const key = getStaticPropertyNameValue32(
          propertyNode,
          initialScope
        );
        const value = getStaticValueR32(propertyNode.value, initialScope);
        if (key == null || value == null) {
          return null;
        }
        object222[key.value] = value.value;
      } else if (propertyNode.type === "SpreadElement" || propertyNode.type === "ExperimentalSpreadProperty") {
        const argument = getStaticValueR32(
          propertyNode.argument,
          initialScope
        );
        if (argument == null) {
          return null;
        }
        Object.assign(object222, argument.value);
      } else {
        return null;
      }
    }
    return { value: object222 };
  },
  SequenceExpression(node, initialScope) {
    const last222 = node.expressions[node.expressions.length - 1];
    return getStaticValueR32(last222, initialScope);
  },
  TaggedTemplateExpression(node, initialScope) {
    const tag = getStaticValueR32(node.tag, initialScope);
    const expressions = getElementValues32(
      node.quasi.expressions,
      initialScope
    );
    if (tag != null && expressions != null) {
      const func = tag.value;
      const strings = node.quasi.quasis.map((q) => q.value.cooked);
      strings.raw = node.quasi.quasis.map((q) => q.value.raw);
      if (func === String.raw) {
        return { value: func(strings, ...expressions) };
      }
    }
    return null;
  },
  TemplateLiteral(node, initialScope) {
    const expressions = getElementValues32(node.expressions, initialScope);
    if (expressions != null) {
      let value = node.quasis[0].value.cooked;
      for (let i2222 = 0; i2222 < expressions.length; ++i2222) {
        value += expressions[i2222];
        value += node.quasis[i2222 + 1].value.cooked;
      }
      return { value };
    }
    return null;
  },
  UnaryExpression(node, initialScope) {
    if (node.operator === "delete") {
      return null;
    }
    if (node.operator === "void") {
      return { value: void 0 };
    }
    const arg = getStaticValueR32(node.argument, initialScope);
    if (arg != null) {
      switch (node.operator) {
        case "-":
          return { value: -arg.value };
        case "+":
          return { value: +arg.value };
        case "!":
          return { value: !arg.value };
        case "~":
          return { value: ~arg.value };
        case "typeof":
          return { value: typeof arg.value };
      }
    }
    return null;
  }
});
function getStaticValueR32(node, initialScope) {
  if (node != null && Object.hasOwnProperty.call(operations32, node.type)) {
    return operations32[node.type](node, initialScope);
  }
  return null;
}
function getStaticPropertyNameValue32(node, initialScope) {
  const nameNode = node.type === "Property" ? node.key : node.property;
  if (node.computed) {
    return getStaticValueR32(nameNode, initialScope);
  }
  if (nameNode.type === "Identifier") {
    return { value: nameNode.name };
  }
  if (nameNode.type === "Literal") {
    if (nameNode.bigint) {
      return { value: nameNode.bigint };
    }
    return { value: String(nameNode.value) };
  }
  return null;
}
function getStaticValue42(node, initialScope = null) {
  try {
    return getStaticValueR32(node, initialScope);
  } catch (_error) {
    return null;
  }
}
function getStringIfConstant32(node, initialScope = null) {
  if (node && node.type === "Literal" && node.value === null) {
    if (node.regex) {
      return `/${node.regex.pattern}/${node.regex.flags}`;
    }
    if (node.bigint) {
      return node.bigint;
    }
  }
  const evaluated = getStaticValue42(node, initialScope);
  return evaluated && String(evaluated.value);
}
function getPropertyName32(node, initialScope) {
  switch (node.type) {
    case "MemberExpression":
      if (node.computed) {
        return getStringIfConstant32(node.property, initialScope);
      }
      if (node.property.type === "PrivateIdentifier") {
        return null;
      }
      return node.property.name;
    case "Property":
    case "MethodDefinition":
    case "PropertyDefinition":
      if (node.computed) {
        return getStringIfConstant32(node.key, initialScope);
      }
      if (node.key.type === "Literal") {
        return String(node.key.value);
      }
      if (node.key.type === "PrivateIdentifier") {
        return null;
      }
      return node.key.name;
  }
  return null;
}
function getFunctionNameWithKind32(node, sourceCode) {
  const parent = node.parent;
  const tokens = [];
  const isObjectMethod = parent.type === "Property" && parent.value === node;
  const isClassMethod = parent.type === "MethodDefinition" && parent.value === node;
  const isClassFieldMethod = parent.type === "PropertyDefinition" && parent.value === node;
  if (isClassMethod || isClassFieldMethod) {
    if (parent.static) {
      tokens.push("static");
    }
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push("private");
    }
  }
  if (node.async) {
    tokens.push("async");
  }
  if (node.generator) {
    tokens.push("generator");
  }
  if (isObjectMethod || isClassMethod) {
    if (parent.kind === "constructor") {
      return "constructor";
    }
    if (parent.kind === "get") {
      tokens.push("getter");
    } else if (parent.kind === "set") {
      tokens.push("setter");
    } else {
      tokens.push("method");
    }
  } else if (isClassFieldMethod) {
    tokens.push("method");
  } else {
    if (node.type === "ArrowFunctionExpression") {
      tokens.push("arrow");
    }
    tokens.push("function");
  }
  if (isObjectMethod || isClassMethod || isClassFieldMethod) {
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push(`#${parent.key.name}`);
    } else {
      const name22 = getPropertyName32(parent);
      if (name22) {
        tokens.push(`'${name22}'`);
      } else if (sourceCode) {
        const keyText = sourceCode.getText(parent.key);
        if (!keyText.includes("\n")) {
          tokens.push(`[${keyText}]`);
        }
      }
    }
  } else if (node.id) {
    tokens.push(`'${node.id.name}'`);
  } else if (parent.type === "VariableDeclarator" && parent.id && parent.id.type === "Identifier") {
    tokens.push(`'${parent.id.name}'`);
  } else if ((parent.type === "AssignmentExpression" || parent.type === "AssignmentPattern") && parent.left && parent.left.type === "Identifier") {
    tokens.push(`'${parent.left.name}'`);
  } else if (parent.type === "ExportDefaultDeclaration" && parent.declaration === node) {
    tokens.push("'default'");
  }
  return tokens.join(" ");
}
var typeConversionBinaryOps32 = Object.freeze(
  /* @__PURE__ */ new Set([
    "==",
    "!=",
    "<",
    "<=",
    ">",
    ">=",
    "<<",
    ">>",
    ">>>",
    "+",
    "-",
    "*",
    "/",
    "%",
    "|",
    "^",
    "&",
    "in"
  ])
);
var typeConversionUnaryOps32 = Object.freeze(/* @__PURE__ */ new Set(["-", "+", "!", "~"]));
function isNode32(x2222) {
  return x2222 !== null && typeof x2222 === "object" && typeof x2222.type === "string";
}
var visitor32 = Object.freeze(
  Object.assign(/* @__PURE__ */ Object.create(null), {
    $visit(node, options, visitorKeys) {
      const { type } = node;
      if (typeof this[type] === "function") {
        return this[type](node, options, visitorKeys);
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    $visitChildren(node, options, visitorKeys) {
      const { type } = node;
      for (const key of visitorKeys[type] || getKeys32(node)) {
        const value = node[key];
        if (Array.isArray(value)) {
          for (const element of value) {
            if (isNode32(element) && this.$visit(element, options, visitorKeys)) {
              return true;
            }
          }
        } else if (isNode32(value) && this.$visit(value, options, visitorKeys)) {
          return true;
        }
      }
      return false;
    },
    ArrowFunctionExpression() {
      return false;
    },
    AssignmentExpression() {
      return true;
    },
    AwaitExpression() {
      return true;
    },
    BinaryExpression(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && typeConversionBinaryOps32.has(node.operator) && (node.left.type !== "Literal" || node.right.type !== "Literal")) {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    CallExpression() {
      return true;
    },
    FunctionExpression() {
      return false;
    },
    ImportExpression() {
      return true;
    },
    MemberExpression(node, options, visitorKeys) {
      if (options.considerGetters) {
        return true;
      }
      if (options.considerImplicitTypeConversion && node.computed && node.property.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    MethodDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    NewExpression() {
      return true;
    },
    Property(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    PropertyDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UnaryExpression(node, options, visitorKeys) {
      if (node.operator === "delete") {
        return true;
      }
      if (options.considerImplicitTypeConversion && typeConversionUnaryOps32.has(node.operator) && node.argument.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UpdateExpression() {
      return true;
    },
    YieldExpression() {
      return true;
    }
  })
);
function hasSideEffect32(node, sourceCode, { considerGetters = false, considerImplicitTypeConversion = false } = {}) {
  return visitor32.$visit(
    node,
    { considerGetters, considerImplicitTypeConversion },
    sourceCode.visitorKeys || visitor_keys_default32
  );
}
function getParentSyntaxParen32(node, sourceCode) {
  const parent = node.parent;
  switch (parent.type) {
    case "CallExpression":
    case "NewExpression":
      if (parent.arguments.length === 1 && parent.arguments[0] === node) {
        return sourceCode.getTokenAfter(
          parent.callee,
          isOpeningParenToken32
        );
      }
      return null;
    case "DoWhileStatement":
      if (parent.test === node) {
        return sourceCode.getTokenAfter(
          parent.body,
          isOpeningParenToken32
        );
      }
      return null;
    case "IfStatement":
    case "WhileStatement":
      if (parent.test === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "ImportExpression":
      if (parent.source === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "SwitchStatement":
      if (parent.discriminant === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "WithStatement":
      if (parent.object === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    default:
      return null;
  }
}
function isParenthesized32(timesOrNode, nodeOrSourceCode, optionalSourceCode) {
  let times, node, sourceCode, maybeLeftParen, maybeRightParen;
  if (typeof timesOrNode === "number") {
    times = timesOrNode | 0;
    node = nodeOrSourceCode;
    sourceCode = optionalSourceCode;
    if (!(times >= 1)) {
      throw new TypeError("'times' should be a positive integer.");
    }
  } else {
    times = 1;
    node = timesOrNode;
    sourceCode = nodeOrSourceCode;
  }
  if (node == null || // `Program` can't be parenthesized
  node.parent == null || // `CatchClause.param` can't be parenthesized, example `try {} catch (error) {}`
  node.parent.type === "CatchClause" && node.parent.param === node) {
    return false;
  }
  maybeLeftParen = maybeRightParen = node;
  do {
    maybeLeftParen = sourceCode.getTokenBefore(maybeLeftParen);
    maybeRightParen = sourceCode.getTokenAfter(maybeRightParen);
  } while (maybeLeftParen != null && maybeRightParen != null && isOpeningParenToken32(maybeLeftParen) && isClosingParenToken32(maybeRightParen) && // Avoid false positive such as `if (a) {}`
  maybeLeftParen !== getParentSyntaxParen32(node, sourceCode) && --times > 0);
  return times === 0;
}
Function.call.bind(Object.hasOwnProperty);
var __defProp232 = Object.defineProperty;
var __export232 = (target, all334) => {
  for (var name22 in all334)
    __defProp232(target, name22, { get: all334[name22], enumerable: true });
};
var NodeType32 = types.AST_NODE_TYPES;
var is32 = utils.ASTUtils.isNodeOfType;
var isOneOf32 = utils.ASTUtils.isNodeOfTypes;
isOneOf32([
  NodeType32.ArrowFunctionExpression,
  NodeType32.FunctionDeclaration,
  NodeType32.FunctionExpression
]);
isOneOf32([
  NodeType32.ArrowFunctionExpression,
  NodeType32.FunctionDeclaration,
  NodeType32.FunctionExpression,
  NodeType32.TSCallSignatureDeclaration,
  NodeType32.TSConstructSignatureDeclaration,
  NodeType32.TSDeclareFunction,
  NodeType32.TSEmptyBodyFunctionExpression,
  NodeType32.TSFunctionType,
  NodeType32.TSMethodSignature
]);
isOneOf32([NodeType32.ClassDeclaration, NodeType32.ClassExpression]);
isOneOf32([
  NodeType32.DoWhileStatement,
  NodeType32.ForInStatement,
  NodeType32.ForOfStatement,
  NodeType32.ForStatement,
  NodeType32.WhileStatement
]);
isOneOf32([NodeType32.TSArrayType, NodeType32.TSTupleType]);
isOneOf32([
  NodeType32.PropertyDefinition,
  NodeType32.TSIndexSignature,
  NodeType32.TSParameterProperty,
  NodeType32.TSPropertySignature
]);
is32(NodeType32.JSXElement);
is32(NodeType32.JSXFragment);
isOneOf32([
  NodeType32.JSXAttribute,
  NodeType32.JSXSpreadChild,
  NodeType32.JSXClosingElement,
  NodeType32.JSXClosingFragment,
  NodeType32.JSXElement,
  NodeType32.JSXEmptyExpression,
  NodeType32.JSXExpressionContainer,
  NodeType32.JSXFragment,
  NodeType32.JSXIdentifier,
  NodeType32.JSXMemberExpression,
  NodeType32.JSXNamespacedName,
  NodeType32.JSXOpeningElement,
  NodeType32.JSXOpeningFragment,
  NodeType32.JSXSpreadAttribute,
  NodeType32.JSXSpreadChild,
  NodeType32.JSXText
]);
isOneOf32([
  NodeType32.JSXIdentifier,
  NodeType32.JSXMemberExpression,
  NodeType32.JSXNamespacedName
]);
isOneOf32([
  NodeType32.ArrayPattern,
  NodeType32.AssignmentPattern,
  NodeType32.ObjectPattern,
  NodeType32.RestElement
]);
isOneOf32([
  NodeType32.TSInterfaceDeclaration,
  NodeType32.TSTypeAliasDeclaration
]);
isOneOf32([
  NodeType32.ArrayExpression,
  NodeType32.ArrayPattern,
  NodeType32.ArrowFunctionExpression,
  NodeType32.CallExpression,
  NodeType32.ClassExpression,
  NodeType32.FunctionExpression,
  NodeType32.Identifier,
  NodeType32.JSXElement,
  NodeType32.JSXFragment,
  NodeType32.Literal,
  NodeType32.TemplateLiteral,
  NodeType32.MemberExpression,
  NodeType32.MetaProperty,
  NodeType32.ObjectExpression,
  NodeType32.ObjectPattern,
  NodeType32.SequenceExpression,
  NodeType32.Super,
  NodeType32.TaggedTemplateExpression,
  NodeType32.ThisExpression
]);
isOneOf32([
  NodeType32.ArrayExpression,
  NodeType32.ArrayPattern,
  NodeType32.ArrowFunctionExpression,
  NodeType32.CallExpression,
  NodeType32.ClassExpression,
  NodeType32.FunctionExpression,
  NodeType32.Identifier,
  NodeType32.JSXElement,
  NodeType32.JSXFragment,
  NodeType32.Literal,
  NodeType32.TemplateLiteral,
  NodeType32.MemberExpression,
  NodeType32.MetaProperty,
  NodeType32.ObjectExpression,
  NodeType32.ObjectPattern,
  NodeType32.SequenceExpression,
  NodeType32.Super,
  NodeType32.TaggedTemplateExpression,
  NodeType32.ThisExpression,
  NodeType32.TSAsExpression,
  NodeType32.TSNonNullExpression,
  NodeType32.TSTypeAssertion
]);
var Function_exports232 = {};
__export232(Function_exports232, {
  SK: () => SK232,
  absurd: () => absurd232,
  apply: () => apply232,
  compose: () => compose232,
  constFalse: () => constFalse232,
  constNull: () => constNull232,
  constTrue: () => constTrue232,
  constUndefined: () => constUndefined232,
  constVoid: () => constVoid232,
  constant: () => constant232,
  dual: () => dual232,
  flip: () => flip232,
  flow: () => flow232,
  hole: () => hole232,
  identity: () => identity232,
  isFunction: () => isFunction2232,
  pipe: () => pipe232,
  satisfies: () => satisfies232,
  tupled: () => tupled232,
  unsafeCoerce: () => unsafeCoerce232,
  untupled: () => untupled232
});
var isFunction2232 = (input) => typeof input === "function";
var dual232 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a2222, b2222) {
        if (arguments.length >= 2) {
          return body(a2222, b2222);
        }
        return function(self2) {
          return body(self2, a2222);
        };
      };
    case 3:
      return function(a2222, b2222, c2222) {
        if (arguments.length >= 3) {
          return body(a2222, b2222, c2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222);
        };
      };
    case 4:
      return function(a2222, b2222, c2222, d2222) {
        if (arguments.length >= 4) {
          return body(a2222, b2222, c2222, d2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222);
        };
      };
    case 5:
      return function(a2222, b2222, c2222, d2222, e2222) {
        if (arguments.length >= 5) {
          return body(a2222, b2222, c2222, d2222, e2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222, d2222);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply232 = (a2222) => (self2) => self2(a2222);
var identity232 = (a2222) => a2222;
var satisfies232 = () => (b2222) => b2222;
var unsafeCoerce232 = identity232;
var constant232 = (value) => () => value;
var constTrue232 = /* @__PURE__ */ constant232(true);
var constFalse232 = /* @__PURE__ */ constant232(false);
var constNull232 = /* @__PURE__ */ constant232(null);
var constUndefined232 = /* @__PURE__ */ constant232(void 0);
var constVoid232 = constUndefined232;
var flip232 = (f2222) => (...b2222) => (...a2222) => f2222(...a2222)(...b2222);
var compose232 = /* @__PURE__ */ dual232(2, (ab, bc) => (a2222) => bc(ab(a2222)));
var absurd232 = (_2222) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled232 = (f2222) => (a2222) => f2222(...a2222);
var untupled232 = (f2222) => (...a2222) => f2222(a2222);
function pipe232(a2222, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a2222;
    case 2:
      return ab(a2222);
    case 3:
      return bc(ab(a2222));
    case 4:
      return cd(bc(ab(a2222)));
    case 5:
      return de(cd(bc(ab(a2222))));
    case 6:
      return ef(de(cd(bc(ab(a2222)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a2222))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a2222)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a2222))))))));
    default: {
      let ret = arguments[0];
      for (let i2222 = 1; i2222 < arguments.length; i2222++) {
        ret = arguments[i2222](ret);
      }
      return ret;
    }
  }
}
function flow232(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole232 = /* @__PURE__ */ unsafeCoerce232(absurd232);
var SK232 = (_2222, b2222) => b2222;
var make432 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_332 = (map622) => dual232(3, (self2, name22, f2222) => map622(self2, (a2222) => Object.assign({}, a2222, {
  [name22]: f2222(a2222)
})));
var bindTo332 = (map622) => dual232(2, (self2, name22) => map622(self2, (a2222) => ({
  [name22]: a2222
})));
var bind332 = (map622, flatMap4222) => dual232(3, (self2, name22, f2222) => flatMap4222(self2, (a2222) => map622(f2222(a2222), (b2222) => Object.assign({}, a2222, {
  [name22]: b2222
}))));
var moduleVersion232 = "3.2.8";
var getCurrentVersion232 = () => moduleVersion232;
var globalStoreId232 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion232()}`);
if (!(globalStoreId232 in globalThis)) {
  globalThis[globalStoreId232] = /* @__PURE__ */ new Map();
}
var globalStore232 = globalThis[globalStoreId232];
var globalValue232 = (id, compute) => {
  if (!globalStore232.has(id)) {
    globalStore232.set(id, compute());
  }
  return globalStore232.get(id);
};
var Predicate_exports232 = {};
__export232(Predicate_exports232, {
  all: () => all232,
  and: () => and52,
  compose: () => compose2232,
  eqv: () => eqv52,
  every: () => every62,
  hasProperty: () => hasProperty232,
  implies: () => implies52,
  isBigInt: () => isBigInt52,
  isBoolean: () => isBoolean52,
  isDate: () => isDate52,
  isError: () => isError52,
  isFunction: () => isFunction323,
  isIterable: () => isIterable52,
  isMap: () => isMap52,
  isNever: () => isNever52,
  isNotNull: () => isNotNull52,
  isNotNullable: () => isNotNullable52,
  isNotUndefined: () => isNotUndefined52,
  isNull: () => isNull52,
  isNullable: () => isNullable232,
  isNumber: () => isNumber52,
  isObject: () => isObject232,
  isPromise: () => isPromise52,
  isPromiseLike: () => isPromiseLike52,
  isReadonlyRecord: () => isReadonlyRecord52,
  isRecord: () => isRecord52,
  isSet: () => isSet52,
  isString: () => isString52,
  isSymbol: () => isSymbol52,
  isTagged: () => isTagged52,
  isTruthy: () => isTruthy52,
  isUint8Array: () => isUint8Array52,
  isUndefined: () => isUndefined52,
  isUnknown: () => isUnknown52,
  mapInput: () => mapInput62,
  nand: () => nand52,
  nor: () => nor52,
  not: () => not52,
  or: () => or52,
  product: () => product232,
  productMany: () => productMany232,
  some: () => some332,
  struct: () => struct72,
  tuple: () => tuple62,
  xor: () => xor52
});
var mapInput62 = /* @__PURE__ */ dual232(2, (self2, f2222) => (b2222) => self2(f2222(b2222)));
var isTruthy52 = (input) => !!input;
var isSet52 = (input) => input instanceof Set;
var isMap52 = (input) => input instanceof Map;
var isString52 = (input) => typeof input === "string";
var isNumber52 = (input) => typeof input === "number";
var isBoolean52 = (input) => typeof input === "boolean";
var isBigInt52 = (input) => typeof input === "bigint";
var isSymbol52 = (input) => typeof input === "symbol";
var isFunction323 = isFunction2232;
var isUndefined52 = (input) => input === void 0;
var isNotUndefined52 = (input) => input !== void 0;
var isNull52 = (input) => input === null;
var isNotNull52 = (input) => input !== null;
var isNever52 = (_2222) => false;
var isUnknown52 = (_2222) => true;
var isRecordOrArray232 = (input) => typeof input === "object" && input !== null;
var isObject232 = (input) => isRecordOrArray232(input) || isFunction323(input);
var hasProperty232 = /* @__PURE__ */ dual232(2, (self2, property) => isObject232(self2) && property in self2);
var isTagged52 = /* @__PURE__ */ dual232(2, (self2, tag) => hasProperty232(self2, "_tag") && self2["_tag"] === tag);
var isNullable232 = (input) => input === null || input === void 0;
var isNotNullable52 = (input) => input !== null && input !== void 0;
var isError52 = (input) => input instanceof Error;
var isUint8Array52 = (input) => input instanceof Uint8Array;
var isDate52 = (input) => input instanceof Date;
var isIterable52 = (input) => hasProperty232(input, Symbol.iterator);
var isRecord52 = (input) => isRecordOrArray232(input) && !Array.isArray(input);
var isReadonlyRecord52 = isRecord52;
var isPromise52 = (input) => hasProperty232(input, "then") && "catch" in input && isFunction323(input.then) && isFunction323(input.catch);
var isPromiseLike52 = (input) => hasProperty232(input, "then") && isFunction323(input.then);
var compose2232 = /* @__PURE__ */ dual232(2, (ab, bc) => (a2222) => ab(a2222) && bc(a2222));
var product232 = (self2, that) => ([a2222, b2222]) => self2(a2222) && that(b2222);
var all232 = (collection) => {
  return (as2234) => {
    let collectionIndex = 0;
    for (const p2222 of collection) {
      if (collectionIndex >= as2234.length) {
        break;
      }
      if (p2222(as2234[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany232 = (self2, collection) => {
  const rest = all232(collection);
  return ([head222, ...tail322]) => self2(head222) === false ? false : rest(tail322);
};
var tuple62 = (...elements) => all232(elements);
var struct72 = (fields) => {
  const keys234 = Object.keys(fields);
  return (a2222) => {
    for (const key of keys234) {
      if (!fields[key](a2222[key])) {
        return false;
      }
    }
    return true;
  };
};
var not52 = (self2) => (a2222) => !self2(a2222);
var or52 = /* @__PURE__ */ dual232(2, (self2, that) => (a2222) => self2(a2222) || that(a2222));
var and52 = /* @__PURE__ */ dual232(2, (self2, that) => (a2222) => self2(a2222) && that(a2222));
var xor52 = /* @__PURE__ */ dual232(2, (self2, that) => (a2222) => self2(a2222) !== that(a2222));
var eqv52 = /* @__PURE__ */ dual232(2, (self2, that) => (a2222) => self2(a2222) === that(a2222));
var implies52 = /* @__PURE__ */ dual232(2, (self2, that) => (a2222) => self2(a2222) ? that(a2222) : true);
var nor52 = /* @__PURE__ */ dual232(2, (self2, that) => (a2222) => !(self2(a2222) || that(a2222)));
var nand52 = /* @__PURE__ */ dual232(2, (self2, that) => (a2222) => !(self2(a2222) && that(a2222)));
var every62 = (collection) => (a2222) => {
  for (const p2222 of collection) {
    if (!p2222(a2222)) {
      return false;
    }
  }
  return true;
};
var some332 = (collection) => (a2222) => {
  for (const p2222 of collection) {
    if (p2222(a2222)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage232 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId232 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind232 = (u2222) => isObject232(u2222) && GenKindTypeId232 in u2222;
var GenKindImpl232 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity232;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId232] = GenKindTypeId232;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen232(this);
  }
};
var SingleShotGen232 = class _SingleShotGen62 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a2222) {
    return this.called ? {
      value: a2222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a2222) {
    return {
      value: a2222,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e2222) {
    throw e2222;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen62(this.self);
  }
};
var adapter332 = () => function() {
  let x2222 = arguments[0];
  for (let i2222 = 1; i2222 < arguments.length; i2222++) {
    x2222 = arguments[i2222](x2222);
  }
  return new GenKindImpl232(x2222);
};
var defaultIncHi232 = 335903614;
var defaultIncLo232 = 4150755663;
var MUL_HI232 = 1481765933 >>> 0;
var MUL_LO232 = 1284865837 >>> 0;
var BIT_53232 = 9007199254740992;
var BIT_27232 = 134217728;
var PCGRandom232 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable232(seedLo) && isNullable232(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable232(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable232(incLo) && isNullable232(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo232;
      incHi = this._state ? this._state[2] : defaultIncHi232;
    } else if (isNullable232(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add64232(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max322) {
    if (!max322) {
      return this._next();
    }
    max322 = max322 >>> 0;
    if ((max322 & max322 - 1) === 0) {
      return this._next() & max322 - 1;
    }
    let num = 0;
    const skew = (-max322 >>> 0) % max322 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max322;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_27232 + lo) / BIT_53232;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul64232(this._state, oldHi, oldLo, MUL_HI232, MUL_LO232);
    add64232(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul64232(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add64232(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId232 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap232 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId232]() {
    return this.#value;
  }
};
function yieldWrapGet232(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId232 in self2) {
    return self2[YieldWrapTypeId232]();
  }
  throw new Error(getBugErrorMessage232("yieldWrapGet"));
}
var structuralRegionState232 = /* @__PURE__ */ globalValue232("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache232 = /* @__PURE__ */ globalValue232(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr232 = /* @__PURE__ */ globalValue232(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom232());
var symbol332 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash232 = (self2) => {
  if (structuralRegionState232.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number232(self2);
    case "bigint":
      return string232(self2.toString(10));
    case "boolean":
      return string232(String(self2));
    case "symbol":
      return string232(String(self2));
    case "string":
      return string232(self2);
    case "undefined":
      return string232("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string232("null");
      } else if (self2 instanceof Date) {
        return hash232(self2.toISOString());
      } else if (isHash232(self2)) {
        return self2[symbol332]();
      } else {
        return random232(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random232 = (self2) => {
  if (!randomHashCache232.has(self2)) {
    randomHashCache232.set(self2, number232(pcgr232.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache232.get(self2);
};
var combine232 = (b2222) => (self2) => self2 * 53 ^ b2222;
var optimize232 = (n2222) => n2222 & 3221225471 | n2222 >>> 1 & 1073741824;
var isHash232 = (u2222) => hasProperty232(u2222, symbol332);
var number232 = (n2222) => {
  if (n2222 !== n2222 || n2222 === Infinity) {
    return 0;
  }
  let h2222 = n2222 | 0;
  if (h2222 !== n2222) {
    h2222 ^= n2222 * 4294967295;
  }
  while (n2222 > 4294967295) {
    h2222 ^= n2222 /= 4294967295;
  }
  return optimize232(n2222);
};
var string232 = (str) => {
  let h2222 = 5381, i2222 = str.length;
  while (i2222) {
    h2222 = h2222 * 33 ^ str.charCodeAt(--i2222);
  }
  return optimize232(h2222);
};
var structureKeys232 = (o2222, keys234) => {
  let h2222 = 12289;
  for (let i2222 = 0; i2222 < keys234.length; i2222++) {
    h2222 ^= pipe232(string232(keys234[i2222]), combine232(hash232(o2222[keys234[i2222]])));
  }
  return optimize232(h2222);
};
var structure232 = (o2222) => structureKeys232(o2222, Object.keys(o2222));
var array72 = (arr) => {
  let h2222 = 6151;
  for (let i2222 = 0; i2222 < arr.length; i2222++) {
    h2222 = pipe232(h2222, combine232(hash232(arr[i2222])));
  }
  return optimize232(h2222);
};
var cached232 = function() {
  if (arguments.length === 1) {
    const self22 = arguments[0];
    return function(hash3222) {
      Object.defineProperty(self22, symbol332, {
        value() {
          return hash3222;
        },
        enumerable: false
      });
      return hash3222;
    };
  }
  const self2 = arguments[0];
  const hash2234 = arguments[1];
  Object.defineProperty(self2, symbol332, {
    value() {
      return hash2234;
    },
    enumerable: false
  });
  return hash2234;
};
var symbol2232 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals232() {
  if (arguments.length === 1) {
    return (self2) => compareBoth232(self2, arguments[0]);
  }
  return compareBoth232(arguments[0], arguments[1]);
}
function compareBoth232(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual232(self2) && isEqual232(that)) {
        if (hash232(self2) === hash232(that) && self2[symbol2232](that)) {
          return true;
        } else {
          return structuralRegionState232.enabled && structuralRegionState232.tester ? structuralRegionState232.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState232.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v2222, i2222) => compareBoth232(v2222, that[i2222]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth232(self2[key], that[key]))) {
              return structuralRegionState232.tester ? structuralRegionState232.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState232.tester ? structuralRegionState232.tester(self2, that) : false;
    }
  }
  return structuralRegionState232.enabled && structuralRegionState232.tester ? structuralRegionState232.tester(self2, that) : false;
}
var isEqual232 = (u2222) => hasProperty232(u2222, symbol2232);
var equivalence232 = () => equals232;
var NodeInspectSymbol232 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON232 = (x2222) => {
  if (hasProperty232(x2222, "toJSON") && isFunction323(x2222["toJSON"]) && x2222["toJSON"].length === 0) {
    return x2222.toJSON();
  } else if (Array.isArray(x2222)) {
    return x2222.map(toJSON232);
  }
  return x2222;
};
var format232 = (x2222) => JSON.stringify(x2222, null, 2);
var pipeArguments232 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i2222 = 0, len = args.length; i2222 < len; i2222++) {
        ret = args[i2222](ret);
      }
      return ret;
    }
  }
};
var OP_COMMIT232 = "Commit";
var OP_FAILURE32 = "Failure";
var OP_WITH_RUNTIME32 = "WithRuntime";
var EffectTypeId232 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId232 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId232 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId232 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance232 = {
  /* c8 ignore next */
  _R: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _A: (_2222) => _2222,
  _V: /* @__PURE__ */ getCurrentVersion232()
};
var sinkVariance232 = {
  /* c8 ignore next */
  _A: (_2222) => _2222,
  /* c8 ignore next */
  _In: (_2222) => _2222,
  /* c8 ignore next */
  _L: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _R: (_2222) => _2222
};
var channelVariance232 = {
  /* c8 ignore next */
  _Env: (_2222) => _2222,
  /* c8 ignore next */
  _InErr: (_2222) => _2222,
  /* c8 ignore next */
  _InElem: (_2222) => _2222,
  /* c8 ignore next */
  _InDone: (_2222) => _2222,
  /* c8 ignore next */
  _OutErr: (_2222) => _2222,
  /* c8 ignore next */
  _OutElem: (_2222) => _2222,
  /* c8 ignore next */
  _OutDone: (_2222) => _2222
};
var EffectPrototype232 = {
  [EffectTypeId232]: effectVariance232,
  [StreamTypeId232]: effectVariance232,
  [SinkTypeId232]: sinkVariance232,
  [ChannelTypeId232]: channelVariance232,
  [symbol2232](that) {
    return this === that;
  },
  [symbol332]() {
    return cached232(this, random232(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen232(new YieldWrap232(this));
  },
  pipe() {
    return pipeArguments232(this, arguments);
  }
};
var StructuralPrototype232 = {
  [symbol332]() {
    return cached232(this, structure232(this));
  },
  [symbol2232](that) {
    const selfKeys = Object.keys(this);
    const thatKeys = Object.keys(that);
    if (selfKeys.length !== thatKeys.length) {
      return false;
    }
    for (const key of selfKeys) {
      if (!(key in that && equals232(this[key], that[key]))) {
        return false;
      }
    }
    return true;
  }
};
var CommitPrototype232 = {
  ...EffectPrototype232,
  _op: OP_COMMIT232
};
var StructuralCommitPrototype232 = {
  ...CommitPrototype232,
  ...StructuralPrototype232
};
var TypeId532 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto332 = {
  ...EffectPrototype232,
  [TypeId532]: {
    _A: (_2222) => _2222
  },
  [NodeInspectSymbol232]() {
    return this.toJSON();
  },
  toString() {
    return format232(this.toJSON());
  }
};
var SomeProto232 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto332), {
  _tag: "Some",
  _op: "Some",
  [symbol2232](that) {
    return isOption332(that) && isSome332(that) && equals232(this.value, that.value);
  },
  [symbol332]() {
    return cached232(this, combine232(hash232(this._tag))(hash232(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON232(this.value)
    };
  }
});
var NoneHash232 = /* @__PURE__ */ hash232("None");
var NoneProto232 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto332), {
  _tag: "None",
  _op: "None",
  [symbol2232](that) {
    return isOption332(that) && isNone332(that);
  },
  [symbol332]() {
    return NoneHash232;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption332 = (input) => hasProperty232(input, TypeId532);
var isNone332 = (fa) => fa._tag === "None";
var isSome332 = (fa) => fa._tag === "Some";
var none332 = /* @__PURE__ */ Object.create(NoneProto232);
var some2232 = (value) => {
  const a2222 = Object.create(SomeProto232);
  a2222.value = value;
  return a2222;
};
var TypeId2232 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto2232 = {
  ...EffectPrototype232,
  [TypeId2232]: {
    _R: (_2222) => _2222
  },
  [NodeInspectSymbol232]() {
    return this.toJSON();
  },
  toString() {
    return format232(this.toJSON());
  }
};
var RightProto232 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto2232), {
  _tag: "Right",
  _op: "Right",
  [symbol2232](that) {
    return isEither232(that) && isRight232(that) && equals232(this.right, that.right);
  },
  [symbol332]() {
    return combine232(hash232(this._tag))(hash232(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON232(this.right)
    };
  }
});
var LeftProto232 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto2232), {
  _tag: "Left",
  _op: "Left",
  [symbol2232](that) {
    return isEither232(that) && isLeft232(that) && equals232(this.left, that.left);
  },
  [symbol332]() {
    return combine232(hash232(this._tag))(hash232(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON232(this.left)
    };
  }
});
var isEither232 = (input) => hasProperty232(input, TypeId2232);
var isLeft232 = (ma) => ma._tag === "Left";
var isRight232 = (ma) => ma._tag === "Right";
var left232 = (left334) => {
  const a2222 = Object.create(LeftProto232);
  a2222.left = left334;
  return a2222;
};
var right232 = (right334) => {
  const a2222 = Object.create(RightProto232);
  a2222.right = right334;
  return a2222;
};
var getLeft332 = (self2) => isRight232(self2) ? none332 : some2232(self2.left);
var getRight332 = (self2) => isLeft232(self2) ? none332 : some2232(self2.right);
var right2232 = right232;
var left2232 = left232;
var Option_exports232 = {};
__export232(Option_exports232, {
  Do: () => Do232,
  TypeId: () => TypeId3232,
  all: () => all2232,
  andThen: () => andThen232,
  ap: () => ap232,
  as: () => as232,
  asVoid: () => asVoid232,
  bind: () => bind2232,
  bindTo: () => bindTo2232,
  composeK: () => composeK232,
  contains: () => contains232,
  containsWith: () => containsWith232,
  exists: () => exists232,
  filter: () => filter232,
  filterMap: () => filterMap232,
  firstSomeOf: () => firstSomeOf232,
  flatMap: () => flatMap232,
  flatMapNullable: () => flatMapNullable232,
  flatten: () => flatten232,
  fromIterable: () => fromIterable232,
  fromNullable: () => fromNullable232,
  gen: () => gen232,
  getEquivalence: () => getEquivalence232,
  getLeft: () => getLeft2232,
  getOrElse: () => getOrElse232,
  getOrNull: () => getOrNull232,
  getOrThrow: () => getOrThrow232,
  getOrThrowWith: () => getOrThrowWith232,
  getOrUndefined: () => getOrUndefined232,
  getOrder: () => getOrder232,
  getRight: () => getRight2232,
  isNone: () => isNone2232,
  isOption: () => isOption2232,
  isSome: () => isSome2232,
  let: () => let_2232,
  lift2: () => lift2232,
  liftNullable: () => liftNullable232,
  liftPredicate: () => liftPredicate232,
  liftThrowable: () => liftThrowable232,
  map: () => map232,
  match: () => match232,
  none: () => none2232,
  orElse: () => orElse232,
  orElseEither: () => orElseEither232,
  orElseSome: () => orElseSome232,
  partitionMap: () => partitionMap232,
  product: () => product2232,
  productMany: () => productMany2232,
  reduceCompact: () => reduceCompact232,
  some: () => some3232,
  tap: () => tap232,
  toArray: () => toArray232,
  toRefinement: () => toRefinement232,
  void: () => void_232,
  zipLeft: () => zipLeft232,
  zipRight: () => zipRight232,
  zipWith: () => zipWith232
});
var make2232 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId3232 = /* @__PURE__ */ Symbol.for("effect/Option");
var none2232 = () => none332;
var some3232 = some2232;
var isOption2232 = isOption332;
var isNone2232 = isNone332;
var isSome2232 = isSome332;
var match232 = /* @__PURE__ */ dual232(2, (self2, {
  onNone,
  onSome
}) => isNone2232(self2) ? onNone() : onSome(self2.value));
var toRefinement232 = (f2222) => (a2222) => isSome2232(f2222(a2222));
var fromIterable232 = (collection) => {
  for (const a2222 of collection) {
    return some3232(a2222);
  }
  return none2232();
};
var getRight2232 = getRight332;
var getLeft2232 = getLeft332;
var getOrElse232 = /* @__PURE__ */ dual232(2, (self2, onNone) => isNone2232(self2) ? onNone() : self2.value);
var orElse232 = /* @__PURE__ */ dual232(2, (self2, that) => isNone2232(self2) ? that() : self2);
var orElseSome232 = /* @__PURE__ */ dual232(2, (self2, onNone) => isNone2232(self2) ? some3232(onNone()) : self2);
var orElseEither232 = /* @__PURE__ */ dual232(2, (self2, that) => isNone2232(self2) ? map232(that(), right232) : map232(self2, left232));
var firstSomeOf232 = (collection) => {
  let out = none2232();
  for (out of collection) {
    if (isSome2232(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable232 = (nullableValue) => nullableValue == null ? none2232() : some3232(nullableValue);
var liftNullable232 = (f2222) => (...a2222) => fromNullable232(f2222(...a2222));
var getOrNull232 = /* @__PURE__ */ getOrElse232(constNull232);
var getOrUndefined232 = /* @__PURE__ */ getOrElse232(constUndefined232);
var liftThrowable232 = (f2222) => (...a2222) => {
  try {
    return some3232(f2222(...a2222));
  } catch (e2222) {
    return none2232();
  }
};
var getOrThrowWith232 = /* @__PURE__ */ dual232(2, (self2, onNone) => {
  if (isSome2232(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow232 = /* @__PURE__ */ getOrThrowWith232(() => new Error("getOrThrow called on a None"));
var map232 = /* @__PURE__ */ dual232(2, (self2, f2222) => isNone2232(self2) ? none2232() : some3232(f2222(self2.value)));
var as232 = /* @__PURE__ */ dual232(2, (self2, b2222) => map232(self2, () => b2222));
var asVoid232 = /* @__PURE__ */ as232(void 0);
var void_232 = /* @__PURE__ */ some3232(void 0);
var flatMap232 = /* @__PURE__ */ dual232(2, (self2, f2222) => isNone2232(self2) ? none2232() : f2222(self2.value));
var andThen232 = /* @__PURE__ */ dual232(2, (self2, f2222) => flatMap232(self2, (a2222) => {
  const b2222 = isFunction2232(f2222) ? f2222(a2222) : f2222;
  return isOption2232(b2222) ? b2222 : some3232(b2222);
}));
var flatMapNullable232 = /* @__PURE__ */ dual232(2, (self2, f2222) => isNone2232(self2) ? none2232() : fromNullable232(f2222(self2.value)));
var flatten232 = /* @__PURE__ */ flatMap232(identity232);
var zipRight232 = /* @__PURE__ */ dual232(2, (self2, that) => flatMap232(self2, () => that));
var composeK232 = /* @__PURE__ */ dual232(2, (afb, bfc) => (a2222) => flatMap232(afb(a2222), bfc));
var zipLeft232 = /* @__PURE__ */ dual232(2, (self2, that) => tap232(self2, () => that));
var tap232 = /* @__PURE__ */ dual232(2, (self2, f2222) => flatMap232(self2, (a2222) => map232(f2222(a2222), () => a2222)));
var product2232 = (self2, that) => isSome2232(self2) && isSome2232(that) ? some3232([self2.value, that.value]) : none2232();
var productMany2232 = (self2, collection) => {
  if (isNone2232(self2)) {
    return none2232();
  }
  const out = [self2.value];
  for (const o2222 of collection) {
    if (isNone2232(o2222)) {
      return none2232();
    }
    out.push(o2222.value);
  }
  return some3232(out);
};
var all2232 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o2222 of input) {
      if (isNone2232(o2222)) {
        return none2232();
      }
      out2.push(o2222.value);
    }
    return some3232(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o2222 = input[key];
    if (isNone2232(o2222)) {
      return none2232();
    }
    out[key] = o2222.value;
  }
  return some3232(out);
};
var zipWith232 = /* @__PURE__ */ dual232(3, (self2, that, f2222) => map232(product2232(self2, that), ([a2222, b2222]) => f2222(a2222, b2222)));
var ap232 = /* @__PURE__ */ dual232(2, (self2, that) => zipWith232(self2, that, (f2222, a2222) => f2222(a2222)));
var reduceCompact232 = /* @__PURE__ */ dual232(3, (self2, b2222, f2222) => {
  let out = b2222;
  for (const oa of self2) {
    if (isSome2232(oa)) {
      out = f2222(out, oa.value);
    }
  }
  return out;
});
var toArray232 = (self2) => isNone2232(self2) ? [] : [self2.value];
var partitionMap232 = /* @__PURE__ */ dual232(2, (self2, f2222) => {
  if (isNone2232(self2)) {
    return [none2232(), none2232()];
  }
  const e2222 = f2222(self2.value);
  return isLeft232(e2222) ? [some3232(e2222.left), none2232()] : [none2232(), some3232(e2222.right)];
});
var filterMap232 = /* @__PURE__ */ dual232(2, (self2, f2222) => isNone2232(self2) ? none2232() : f2222(self2.value));
var filter232 = /* @__PURE__ */ dual232(2, (self2, predicate) => filterMap232(self2, (b2222) => predicate(b2222) ? some2232(b2222) : none332));
var getEquivalence232 = (isEquivalent) => make432((x2222, y2222) => x2222 === y2222 || (isNone2232(x2222) ? isNone2232(y2222) : isNone2232(y2222) ? false : isEquivalent(x2222.value, y2222.value)));
var getOrder232 = (O2222) => make2232((self2, that) => isSome2232(self2) ? isSome2232(that) ? O2222(self2.value, that.value) : 1 : -1);
var lift2232 = (f2222) => dual232(2, (self2, that) => zipWith232(self2, that, f2222));
var liftPredicate232 = (predicate) => (b2222) => predicate(b2222) ? some3232(b2222) : none2232();
var containsWith232 = (isEquivalent) => dual232(2, (self2, a2222) => isNone2232(self2) ? false : isEquivalent(self2.value, a2222));
var _equivalence232 = /* @__PURE__ */ equivalence232();
var contains232 = /* @__PURE__ */ containsWith232(_equivalence232);
var exists232 = /* @__PURE__ */ dual232(2, (self2, refinement) => isNone2232(self2) ? false : refinement(self2.value));
var bindTo2232 = /* @__PURE__ */ bindTo332(map232);
var let_2232 = /* @__PURE__ */ let_332(map232);
var bind2232 = /* @__PURE__ */ bind332(map232, flatMap232);
var Do232 = /* @__PURE__ */ some3232({});
var adapter2232 = /* @__PURE__ */ adapter332();
var gen232 = (f2222) => {
  const iterator = f2222(adapter2232);
  let state = iterator.next();
  if (state.done) {
    return some3232(state.value);
  } else {
    let current = state.value;
    if (isGenKind232(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet232(current);
    }
    if (isNone2232(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind232(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet232(current);
        }
        if (isNone2232(current)) {
          return current;
        }
      }
    }
    return some3232(state.value);
  }
};
var fromIterable2232 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var reverse52 = (self2) => Array.from(self2).reverse();
var reduce62 = /* @__PURE__ */ dual232(3, (self2, b2222, f2222) => fromIterable2232(self2).reduce((b22222, a2222, i2222) => f2222(b22222, a2222, i2222), b2222));
var TagTypeId32 = /* @__PURE__ */ Symbol.for("effect/Context/Tag");
var STMSymbolKey32 = "effect/STM";
var STMTypeId32 = /* @__PURE__ */ Symbol.for(STMSymbolKey32);
var TagProto32 = {
  ...EffectPrototype232,
  _tag: "Tag",
  _op: "Tag",
  [STMTypeId32]: effectVariance232,
  [TagTypeId32]: {
    _Service: (_2222) => _2222,
    _Identifier: (_2222) => _2222
  },
  toString() {
    return format232(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Tag",
      key: this.key,
      stack: this.stack
    };
  },
  [NodeInspectSymbol232]() {
    return this.toJSON();
  },
  of(self2) {
    return self2;
  },
  context(self2) {
    return make3232(this, self2);
  }
};
var makeGenericTag32 = (key) => {
  const limit = Error.stackTraceLimit;
  Error.stackTraceLimit = 2;
  const creationError = new Error();
  Error.stackTraceLimit = limit;
  const tag = Object.create(TagProto32);
  Object.defineProperty(tag, "stack", {
    get() {
      return creationError.stack;
    }
  });
  tag.key = key;
  return tag;
};
var TypeId4232 = /* @__PURE__ */ Symbol.for("effect/Context");
var ContextProto32 = {
  [TypeId4232]: {
    _Services: (_2222) => _2222
  },
  [symbol2232](that) {
    if (isContext32(that)) {
      if (this.unsafeMap.size === that.unsafeMap.size) {
        for (const k2222 of this.unsafeMap.keys()) {
          if (!that.unsafeMap.has(k2222) || !equals232(this.unsafeMap.get(k2222), that.unsafeMap.get(k2222))) {
            return false;
          }
        }
        return true;
      }
    }
    return false;
  },
  [symbol332]() {
    return cached232(this, number232(this.unsafeMap.size));
  },
  pipe() {
    return pipeArguments232(this, arguments);
  },
  toString() {
    return format232(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Context",
      services: Array.from(this.unsafeMap).map(toJSON232)
    };
  },
  [NodeInspectSymbol232]() {
    return this.toJSON();
  }
};
var makeContext32 = (unsafeMap) => {
  const context = Object.create(ContextProto32);
  context.unsafeMap = unsafeMap;
  return context;
};
var isContext32 = (u2222) => hasProperty232(u2222, TypeId4232);
var _empty72 = /* @__PURE__ */ makeContext32(/* @__PURE__ */ new Map());
var empty122 = () => _empty72;
var make3232 = (tag, service) => makeContext32(/* @__PURE__ */ new Map([[tag.key, service]]));
var GenericTag32 = makeGenericTag32;
var empty232 = empty122;
var TypeId5232 = /* @__PURE__ */ Symbol.for("effect/Chunk");
function copy42(src, srcPos, dest, destPos, len) {
  for (let i2222 = srcPos; i2222 < Math.min(src.length, srcPos + len); i2222++) {
    dest[destPos + i2222 - srcPos] = src[i2222];
  }
  return dest;
}
var emptyArray32 = [];
var getEquivalence2232 = (isEquivalent) => make432((self2, that) => self2.length === that.length && toReadonlyArray32(self2).every((value, i2222) => isEquivalent(value, unsafeGet232(that, i2222))));
var _equivalence2232 = /* @__PURE__ */ getEquivalence2232(equals232);
var ChunkProto32 = {
  [TypeId5232]: {
    _A: (_2222) => _2222
  },
  toString() {
    return format232(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Chunk",
      values: toReadonlyArray32(this).map(toJSON232)
    };
  },
  [NodeInspectSymbol232]() {
    return this.toJSON();
  },
  [symbol2232](that) {
    return isChunk32(that) && _equivalence2232(this, that);
  },
  [symbol332]() {
    return cached232(this, array72(toReadonlyArray32(this)));
  },
  [Symbol.iterator]() {
    switch (this.backing._tag) {
      case "IArray": {
        return this.backing.array[Symbol.iterator]();
      }
      case "IEmpty": {
        return emptyArray32[Symbol.iterator]();
      }
      default: {
        return toReadonlyArray32(this)[Symbol.iterator]();
      }
    }
  },
  pipe() {
    return pipeArguments232(this, arguments);
  }
};
var makeChunk32 = (backing) => {
  const chunk = Object.create(ChunkProto32);
  chunk.backing = backing;
  switch (backing._tag) {
    case "IEmpty": {
      chunk.length = 0;
      chunk.depth = 0;
      chunk.left = chunk;
      chunk.right = chunk;
      break;
    }
    case "IConcat": {
      chunk.length = backing.left.length + backing.right.length;
      chunk.depth = 1 + Math.max(backing.left.depth, backing.right.depth);
      chunk.left = backing.left;
      chunk.right = backing.right;
      break;
    }
    case "IArray": {
      chunk.length = backing.array.length;
      chunk.depth = 0;
      chunk.left = _empty232;
      chunk.right = _empty232;
      break;
    }
    case "ISingleton": {
      chunk.length = 1;
      chunk.depth = 0;
      chunk.left = _empty232;
      chunk.right = _empty232;
      break;
    }
    case "ISlice": {
      chunk.length = backing.length;
      chunk.depth = backing.chunk.depth + 1;
      chunk.left = _empty232;
      chunk.right = _empty232;
      break;
    }
  }
  return chunk;
};
var isChunk32 = (u2222) => hasProperty232(u2222, TypeId5232);
var _empty232 = /* @__PURE__ */ makeChunk32({
  _tag: "IEmpty"
});
var empty332 = () => _empty232;
var make4232 = (...as2234) => as2234.length === 1 ? of42(as2234[0]) : unsafeFromNonEmptyArray32(as2234);
var of42 = (a2222) => makeChunk32({
  _tag: "ISingleton",
  a: a2222
});
var copyToArray32 = (self2, array334, initial) => {
  switch (self2.backing._tag) {
    case "IArray": {
      copy42(self2.backing.array, 0, array334, initial, self2.length);
      break;
    }
    case "IConcat": {
      copyToArray32(self2.left, array334, initial);
      copyToArray32(self2.right, array334, initial + self2.left.length);
      break;
    }
    case "ISingleton": {
      array334[initial] = self2.backing.a;
      break;
    }
    case "ISlice": {
      let i2222 = 0;
      let j2222 = initial;
      while (i2222 < self2.length) {
        array334[j2222] = unsafeGet232(self2, i2222);
        i2222 += 1;
        j2222 += 1;
      }
      break;
    }
  }
};
var toReadonlyArray32 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      return emptyArray32;
    }
    case "IArray": {
      return self2.backing.array;
    }
    default: {
      const arr = new Array(self2.length);
      copyToArray32(self2, arr, 0);
      self2.backing = {
        _tag: "IArray",
        array: arr
      };
      self2.left = _empty232;
      self2.right = _empty232;
      self2.depth = 0;
      return arr;
    }
  }
};
var reverse232 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty":
    case "ISingleton":
      return self2;
    case "IArray": {
      return makeChunk32({
        _tag: "IArray",
        array: reverse52(self2.backing.array)
      });
    }
    case "IConcat": {
      return makeChunk32({
        _tag: "IConcat",
        left: reverse232(self2.backing.right),
        right: reverse232(self2.backing.left)
      });
    }
    case "ISlice":
      return unsafeFromArray32(reverse52(toReadonlyArray32(self2)));
  }
};
var unsafeFromArray32 = (self2) => makeChunk32({
  _tag: "IArray",
  array: self2
});
var unsafeFromNonEmptyArray32 = (self2) => unsafeFromArray32(self2);
var unsafeGet232 = /* @__PURE__ */ dual232(2, (self2, index) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      throw new Error(`Index out of bounds`);
    }
    case "ISingleton": {
      if (index !== 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.a;
    }
    case "IArray": {
      if (index >= self2.length || index < 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.array[index];
    }
    case "IConcat": {
      return index < self2.left.length ? unsafeGet232(self2.left, index) : unsafeGet232(self2.right, index - self2.left.length);
    }
    case "ISlice": {
      return unsafeGet232(self2.backing.chunk, index + self2.backing.offset);
    }
  }
});
var prepend52 = /* @__PURE__ */ dual232(2, (self2, elem) => appendAll42(of42(elem), self2));
var drop42 = /* @__PURE__ */ dual232(2, (self2, n2222) => {
  if (n2222 <= 0) {
    return self2;
  } else if (n2222 >= self2.length) {
    return _empty232;
  } else {
    switch (self2.backing._tag) {
      case "ISlice": {
        return makeChunk32({
          _tag: "ISlice",
          chunk: self2.backing.chunk,
          offset: self2.backing.offset + n2222,
          length: self2.backing.length - n2222
        });
      }
      case "IConcat": {
        if (n2222 > self2.left.length) {
          return drop42(self2.right, n2222 - self2.left.length);
        }
        return makeChunk32({
          _tag: "IConcat",
          left: drop42(self2.left, n2222),
          right: self2.right
        });
      }
      default: {
        return makeChunk32({
          _tag: "ISlice",
          chunk: self2,
          offset: n2222,
          length: self2.length - n2222
        });
      }
    }
  }
});
var appendAll42 = /* @__PURE__ */ dual232(2, (self2, that) => {
  if (self2.backing._tag === "IEmpty") {
    return that;
  }
  if (that.backing._tag === "IEmpty") {
    return self2;
  }
  const diff234 = that.depth - self2.depth;
  if (Math.abs(diff234) <= 1) {
    return makeChunk32({
      _tag: "IConcat",
      left: self2,
      right: that
    });
  } else if (diff234 < -1) {
    if (self2.left.depth >= self2.right.depth) {
      const nr = appendAll42(self2.right, that);
      return makeChunk32({
        _tag: "IConcat",
        left: self2.left,
        right: nr
      });
    } else {
      const nrr = appendAll42(self2.right.right, that);
      if (nrr.depth === self2.depth - 3) {
        const nr = makeChunk32({
          _tag: "IConcat",
          left: self2.right.left,
          right: nrr
        });
        return makeChunk32({
          _tag: "IConcat",
          left: self2.left,
          right: nr
        });
      } else {
        const nl = makeChunk32({
          _tag: "IConcat",
          left: self2.left,
          right: self2.right.left
        });
        return makeChunk32({
          _tag: "IConcat",
          left: nl,
          right: nrr
        });
      }
    }
  } else {
    if (that.right.depth >= that.left.depth) {
      const nl = appendAll42(self2, that.left);
      return makeChunk32({
        _tag: "IConcat",
        left: nl,
        right: that.right
      });
    } else {
      const nll = appendAll42(self2, that.left.left);
      if (nll.depth === that.depth - 3) {
        const nl = makeChunk32({
          _tag: "IConcat",
          left: nll,
          right: that.left.right
        });
        return makeChunk32({
          _tag: "IConcat",
          left: nl,
          right: that.right
        });
      } else {
        const nr = makeChunk32({
          _tag: "IConcat",
          left: that.left.right,
          right: that.right
        });
        return makeChunk32({
          _tag: "IConcat",
          left: nll,
          right: nr
        });
      }
    }
  }
});
var isEmpty42 = (self2) => self2.length === 0;
var isNonEmpty32 = (self2) => self2.length > 0;
var unsafeHead32 = (self2) => unsafeGet232(self2, 0);
var headNonEmpty42 = unsafeHead32;
var tailNonEmpty42 = (self2) => drop42(self2, 1);
var SIZE32 = 5;
var BUCKET_SIZE32 = /* @__PURE__ */ Math.pow(2, SIZE32);
var MASK32 = BUCKET_SIZE32 - 1;
var MAX_INDEX_NODE32 = BUCKET_SIZE32 / 2;
var MIN_ARRAY_NODE32 = BUCKET_SIZE32 / 4;
function popcount32(x2222) {
  x2222 -= x2222 >> 1 & 1431655765;
  x2222 = (x2222 & 858993459) + (x2222 >> 2 & 858993459);
  x2222 = x2222 + (x2222 >> 4) & 252645135;
  x2222 += x2222 >> 8;
  x2222 += x2222 >> 16;
  return x2222 & 127;
}
function hashFragment32(shift22, h2222) {
  return h2222 >>> shift22 & MASK32;
}
function toBitmap32(x2222) {
  return 1 << x2222;
}
function fromBitmap32(bitmap, bit) {
  return popcount32(bitmap & bit - 1);
}
var make532 = (value, previous) => ({
  value,
  previous
});
function arrayUpdate32(mutate234, at, v2222, arr) {
  let out = arr;
  if (!mutate234) {
    const len = arr.length;
    out = new Array(len);
    for (let i2222 = 0; i2222 < len; ++i2222) out[i2222] = arr[i2222];
  }
  out[at] = v2222;
  return out;
}
function arraySpliceOut32(mutate234, at, arr) {
  const newLen = arr.length - 1;
  let i2222 = 0;
  let g2222 = 0;
  let out = arr;
  if (mutate234) {
    i2222 = g2222 = at;
  } else {
    out = new Array(newLen);
    while (i2222 < at) out[g2222++] = arr[i2222++];
  }
  ++i2222;
  while (i2222 <= newLen) out[g2222++] = arr[i2222++];
  if (mutate234) {
    out.length = newLen;
  }
  return out;
}
function arraySpliceIn32(mutate234, at, v2222, arr) {
  const len = arr.length;
  if (mutate234) {
    let i22222 = len;
    while (i22222 >= at) arr[i22222--] = arr[i22222];
    arr[at] = v2222;
    return arr;
  }
  let i2222 = 0, g2222 = 0;
  const out = new Array(len + 1);
  while (i2222 < at) out[g2222++] = arr[i2222++];
  out[at] = v2222;
  while (i2222 < len) out[++g2222] = arr[i2222++];
  return out;
}
var EmptyNode32 = class _EmptyNode32 {
  _tag = "EmptyNode";
  modify(edit, _shift, f2222, hash2234, key, size434) {
    const v2222 = f2222(none2232());
    if (isNone2232(v2222)) return new _EmptyNode32();
    ++size434.value;
    return new LeafNode32(edit, hash2234, key, v2222);
  }
};
function isEmptyNode32(a2222) {
  return isTagged52(a2222, "EmptyNode");
}
function isLeafNode32(node) {
  return isEmptyNode32(node) || node._tag === "LeafNode" || node._tag === "CollisionNode";
}
function canEditNode32(node, edit) {
  return isEmptyNode32(node) ? false : edit === node.edit;
}
var LeafNode32 = class _LeafNode32 {
  edit;
  hash;
  key;
  value;
  _tag = "LeafNode";
  constructor(edit, hash2234, key, value) {
    this.edit = edit;
    this.hash = hash2234;
    this.key = key;
    this.value = value;
  }
  modify(edit, shift22, f2222, hash2234, key, size434) {
    if (equals232(key, this.key)) {
      const v22222 = f2222(this.value);
      if (v22222 === this.value) return this;
      else if (isNone2232(v22222)) {
        --size434.value;
        return new EmptyNode32();
      }
      if (canEditNode32(this, edit)) {
        this.value = v22222;
        return this;
      }
      return new _LeafNode32(edit, hash2234, key, v22222);
    }
    const v2222 = f2222(none2232());
    if (isNone2232(v2222)) return this;
    ++size434.value;
    return mergeLeaves32(edit, shift22, this.hash, this, hash2234, new _LeafNode32(edit, hash2234, key, v2222));
  }
};
var CollisionNode32 = class _CollisionNode32 {
  edit;
  hash;
  children;
  _tag = "CollisionNode";
  constructor(edit, hash2234, children) {
    this.edit = edit;
    this.hash = hash2234;
    this.children = children;
  }
  modify(edit, shift22, f2222, hash2234, key, size434) {
    if (hash2234 === this.hash) {
      const canEdit = canEditNode32(this, edit);
      const list = this.updateCollisionList(canEdit, edit, this.hash, this.children, f2222, key, size434);
      if (list === this.children) return this;
      return list.length > 1 ? new _CollisionNode32(edit, this.hash, list) : list[0];
    }
    const v2222 = f2222(none2232());
    if (isNone2232(v2222)) return this;
    ++size434.value;
    return mergeLeaves32(edit, shift22, this.hash, this, hash2234, new LeafNode32(edit, hash2234, key, v2222));
  }
  updateCollisionList(mutate234, edit, hash2234, list, f2222, key, size434) {
    const len = list.length;
    for (let i2222 = 0; i2222 < len; ++i2222) {
      const child = list[i2222];
      if ("key" in child && equals232(key, child.key)) {
        const value = child.value;
        const newValue2 = f2222(value);
        if (newValue2 === value) return list;
        if (isNone2232(newValue2)) {
          --size434.value;
          return arraySpliceOut32(mutate234, i2222, list);
        }
        return arrayUpdate32(mutate234, i2222, new LeafNode32(edit, hash2234, key, newValue2), list);
      }
    }
    const newValue = f2222(none2232());
    if (isNone2232(newValue)) return list;
    ++size434.value;
    return arrayUpdate32(mutate234, len, new LeafNode32(edit, hash2234, key, newValue), list);
  }
};
var IndexedNode32 = class _IndexedNode32 {
  edit;
  mask;
  children;
  _tag = "IndexedNode";
  constructor(edit, mask, children) {
    this.edit = edit;
    this.mask = mask;
    this.children = children;
  }
  modify(edit, shift22, f2222, hash2234, key, size434) {
    const mask = this.mask;
    const children = this.children;
    const frag = hashFragment32(shift22, hash2234);
    const bit = toBitmap32(frag);
    const indx = fromBitmap32(mask, bit);
    const exists2234 = mask & bit;
    const canEdit = canEditNode32(this, edit);
    if (!exists2234) {
      const _newChild = new EmptyNode32().modify(edit, shift22 + SIZE32, f2222, hash2234, key, size434);
      if (!_newChild) return this;
      return children.length >= MAX_INDEX_NODE32 ? expand32(edit, frag, _newChild, mask, children) : new _IndexedNode32(edit, mask | bit, arraySpliceIn32(canEdit, indx, _newChild, children));
    }
    const current = children[indx];
    const child = current.modify(edit, shift22 + SIZE32, f2222, hash2234, key, size434);
    if (current === child) return this;
    let bitmap = mask;
    let newChildren;
    if (isEmptyNode32(child)) {
      bitmap &= ~bit;
      if (!bitmap) return new EmptyNode32();
      if (children.length <= 2 && isLeafNode32(children[indx ^ 1])) {
        return children[indx ^ 1];
      }
      newChildren = arraySpliceOut32(canEdit, indx, children);
    } else {
      newChildren = arrayUpdate32(canEdit, indx, child, children);
    }
    if (canEdit) {
      this.mask = bitmap;
      this.children = newChildren;
      return this;
    }
    return new _IndexedNode32(edit, bitmap, newChildren);
  }
};
var ArrayNode32 = class _ArrayNode32 {
  edit;
  size;
  children;
  _tag = "ArrayNode";
  constructor(edit, size434, children) {
    this.edit = edit;
    this.size = size434;
    this.children = children;
  }
  modify(edit, shift22, f2222, hash2234, key, size434) {
    let count = this.size;
    const children = this.children;
    const frag = hashFragment32(shift22, hash2234);
    const child = children[frag];
    const newChild = (child || new EmptyNode32()).modify(edit, shift22 + SIZE32, f2222, hash2234, key, size434);
    if (child === newChild) return this;
    const canEdit = canEditNode32(this, edit);
    let newChildren;
    if (isEmptyNode32(child) && !isEmptyNode32(newChild)) {
      ++count;
      newChildren = arrayUpdate32(canEdit, frag, newChild, children);
    } else if (!isEmptyNode32(child) && isEmptyNode32(newChild)) {
      --count;
      if (count <= MIN_ARRAY_NODE32) {
        return pack32(edit, count, frag, children);
      }
      newChildren = arrayUpdate32(canEdit, frag, new EmptyNode32(), children);
    } else {
      newChildren = arrayUpdate32(canEdit, frag, newChild, children);
    }
    if (canEdit) {
      this.size = count;
      this.children = newChildren;
      return this;
    }
    return new _ArrayNode32(edit, count, newChildren);
  }
};
function pack32(edit, count, removed, elements) {
  const children = new Array(count - 1);
  let g2222 = 0;
  let bitmap = 0;
  for (let i2222 = 0, len = elements.length; i2222 < len; ++i2222) {
    if (i2222 !== removed) {
      const elem = elements[i2222];
      if (elem && !isEmptyNode32(elem)) {
        children[g2222++] = elem;
        bitmap |= 1 << i2222;
      }
    }
  }
  return new IndexedNode32(edit, bitmap, children);
}
function expand32(edit, frag, child, bitmap, subNodes) {
  const arr = [];
  let bit = bitmap;
  let count = 0;
  for (let i2222 = 0; bit; ++i2222) {
    if (bit & 1) arr[i2222] = subNodes[count++];
    bit >>>= 1;
  }
  arr[frag] = child;
  return new ArrayNode32(edit, count + 1, arr);
}
function mergeLeavesInner32(edit, shift22, h1, n1, h2222, n2222) {
  if (h1 === h2222) return new CollisionNode32(edit, h1, [n2222, n1]);
  const subH1 = hashFragment32(shift22, h1);
  const subH2 = hashFragment32(shift22, h2222);
  if (subH1 === subH2) {
    return (child) => new IndexedNode32(edit, toBitmap32(subH1) | toBitmap32(subH2), [child]);
  } else {
    const children = subH1 < subH2 ? [n1, n2222] : [n2222, n1];
    return new IndexedNode32(edit, toBitmap32(subH1) | toBitmap32(subH2), children);
  }
}
function mergeLeaves32(edit, shift22, h1, n1, h2222, n2222) {
  let stack = void 0;
  let currentShift = shift22;
  while (true) {
    const res = mergeLeavesInner32(edit, currentShift, h1, n1, h2222, n2222);
    if (typeof res === "function") {
      stack = make532(res, stack);
      currentShift = currentShift + SIZE32;
    } else {
      let final = res;
      while (stack != null) {
        final = stack.value(final);
        stack = stack.previous;
      }
      return final;
    }
  }
}
var HashMapSymbolKey32 = "effect/HashMap";
var HashMapTypeId32 = /* @__PURE__ */ Symbol.for(HashMapSymbolKey32);
var HashMapProto32 = {
  [HashMapTypeId32]: HashMapTypeId32,
  [Symbol.iterator]() {
    return new HashMapIterator32(this, (k2222, v2222) => [k2222, v2222]);
  },
  [symbol332]() {
    let hash2234 = hash232(HashMapSymbolKey32);
    for (const item of this) {
      hash2234 ^= pipe232(hash232(item[0]), combine232(hash232(item[1])));
    }
    return cached232(this, hash2234);
  },
  [symbol2232](that) {
    if (isHashMap32(that)) {
      if (that._size !== this._size) {
        return false;
      }
      for (const item of this) {
        const elem = pipe232(that, getHash32(item[0], hash232(item[0])));
        if (isNone2232(elem)) {
          return false;
        } else {
          if (!equals232(item[1], elem.value)) {
            return false;
          }
        }
      }
      return true;
    }
    return false;
  },
  toString() {
    return format232(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashMap",
      values: Array.from(this).map(toJSON232)
    };
  },
  [NodeInspectSymbol232]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments232(this, arguments);
  }
};
var makeImpl42 = (editable, edit, root, size434) => {
  const map622 = Object.create(HashMapProto32);
  map622._editable = editable;
  map622._edit = edit;
  map622._root = root;
  map622._size = size434;
  return map622;
};
var HashMapIterator32 = class _HashMapIterator32 {
  map;
  f;
  v;
  constructor(map622, f2222) {
    this.map = map622;
    this.f = f2222;
    this.v = visitLazy32(this.map._root, this.f, void 0);
  }
  next() {
    if (isNone2232(this.v)) {
      return {
        done: true,
        value: void 0
      };
    }
    const v0 = this.v.value;
    this.v = applyCont32(v0.cont);
    return {
      done: false,
      value: v0.value
    };
  }
  [Symbol.iterator]() {
    return new _HashMapIterator32(this.map, this.f);
  }
};
var applyCont32 = (cont) => cont ? visitLazyChildren32(cont[0], cont[1], cont[2], cont[3], cont[4]) : none2232();
var visitLazy32 = (node, f2222, cont = void 0) => {
  switch (node._tag) {
    case "LeafNode": {
      if (isSome2232(node.value)) {
        return some3232({
          value: f2222(node.key, node.value.value),
          cont
        });
      }
      return applyCont32(cont);
    }
    case "CollisionNode":
    case "ArrayNode":
    case "IndexedNode": {
      const children = node.children;
      return visitLazyChildren32(children.length, children, 0, f2222, cont);
    }
    default: {
      return applyCont32(cont);
    }
  }
};
var visitLazyChildren32 = (len, children, i2222, f2222, cont) => {
  while (i2222 < len) {
    const child = children[i2222++];
    if (child && !isEmptyNode32(child)) {
      return visitLazy32(child, f2222, [len, children, i2222, f2222, cont]);
    }
  }
  return applyCont32(cont);
};
var _empty332 = /* @__PURE__ */ makeImpl42(false, 0, /* @__PURE__ */ new EmptyNode32(), 0);
var empty432 = () => _empty332;
var isHashMap32 = (u2222) => hasProperty232(u2222, HashMapTypeId32);
var getHash32 = /* @__PURE__ */ dual232(3, (self2, key, hash2234) => {
  let node = self2._root;
  let shift22 = 0;
  while (true) {
    switch (node._tag) {
      case "LeafNode": {
        return equals232(key, node.key) ? node.value : none2232();
      }
      case "CollisionNode": {
        if (hash2234 === node.hash) {
          const children = node.children;
          for (let i2222 = 0, len = children.length; i2222 < len; ++i2222) {
            const child = children[i2222];
            if ("key" in child && equals232(key, child.key)) {
              return child.value;
            }
          }
        }
        return none2232();
      }
      case "IndexedNode": {
        const frag = hashFragment32(shift22, hash2234);
        const bit = toBitmap32(frag);
        if (node.mask & bit) {
          node = node.children[fromBitmap32(node.mask, bit)];
          shift22 += SIZE32;
          break;
        }
        return none2232();
      }
      case "ArrayNode": {
        node = node.children[hashFragment32(shift22, hash2234)];
        if (node) {
          shift22 += SIZE32;
          break;
        }
        return none2232();
      }
      default:
        return none2232();
    }
  }
});
var set232 = /* @__PURE__ */ dual232(3, (self2, key, value) => modifyAt32(self2, key, () => some3232(value)));
var setTree32 = /* @__PURE__ */ dual232(3, (self2, newRoot, newSize) => {
  if (self2._editable) {
    self2._root = newRoot;
    self2._size = newSize;
    return self2;
  }
  return newRoot === self2._root ? self2 : makeImpl42(self2._editable, self2._edit, newRoot, newSize);
});
var keys42 = (self2) => new HashMapIterator32(self2, (key) => key);
var size52 = (self2) => self2._size;
var beginMutation42 = (self2) => makeImpl42(true, self2._edit + 1, self2._root, self2._size);
var modifyAt32 = /* @__PURE__ */ dual232(3, (self2, key, f2222) => modifyHash32(self2, key, hash232(key), f2222));
var modifyHash32 = /* @__PURE__ */ dual232(4, (self2, key, hash2234, f2222) => {
  const size434 = {
    value: self2._size
  };
  const newRoot = self2._root.modify(self2._editable ? self2._edit : NaN, 0, f2222, hash2234, key, size434);
  return pipe232(self2, setTree32(newRoot, size434.value));
});
var forEach62 = /* @__PURE__ */ dual232(2, (self2, f2222) => reduce232(self2, void 0, (_2222, value, key) => f2222(value, key)));
var reduce232 = /* @__PURE__ */ dual232(3, (self2, zero, f2222) => {
  const root = self2._root;
  if (root._tag === "LeafNode") {
    return isSome2232(root.value) ? f2222(zero, root.value.value, root.key) : zero;
  }
  if (root._tag === "EmptyNode") {
    return zero;
  }
  const toVisit = [root.children];
  let children;
  while (children = toVisit.pop()) {
    for (let i2222 = 0, len = children.length; i2222 < len; ) {
      const child = children[i2222++];
      if (child && !isEmptyNode32(child)) {
        if (child._tag === "LeafNode") {
          if (isSome2232(child.value)) {
            zero = f2222(zero, child.value.value, child.key);
          }
        } else {
          toVisit.push(child.children);
        }
      }
    }
  }
  return zero;
});
var HashSetSymbolKey32 = "effect/HashSet";
var HashSetTypeId32 = /* @__PURE__ */ Symbol.for(HashSetSymbolKey32);
var HashSetProto32 = {
  [HashSetTypeId32]: HashSetTypeId32,
  [Symbol.iterator]() {
    return keys42(this._keyMap);
  },
  [symbol332]() {
    return cached232(this, combine232(hash232(this._keyMap))(hash232(HashSetSymbolKey32)));
  },
  [symbol2232](that) {
    if (isHashSet32(that)) {
      return size52(this._keyMap) === size52(that._keyMap) && equals232(this._keyMap, that._keyMap);
    }
    return false;
  },
  toString() {
    return format232(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashSet",
      values: Array.from(this).map(toJSON232)
    };
  },
  [NodeInspectSymbol232]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments232(this, arguments);
  }
};
var makeImpl232 = (keyMap) => {
  const set2234 = Object.create(HashSetProto32);
  set2234._keyMap = keyMap;
  return set2234;
};
var isHashSet32 = (u2222) => hasProperty232(u2222, HashSetTypeId32);
var _empty432 = /* @__PURE__ */ makeImpl232(/* @__PURE__ */ empty432());
var empty532 = () => _empty432;
var size232 = (self2) => size52(self2._keyMap);
var beginMutation232 = (self2) => makeImpl232(beginMutation42(self2._keyMap));
var endMutation32 = (self2) => {
  self2._keyMap._editable = false;
  return self2;
};
var mutate32 = /* @__PURE__ */ dual232(2, (self2, f2222) => {
  const transient = beginMutation232(self2);
  f2222(transient);
  return endMutation32(transient);
});
var add232 = /* @__PURE__ */ dual232(2, (self2, value) => self2._keyMap._editable ? (set232(value, true)(self2._keyMap), self2) : makeImpl232(set232(value, true)(self2._keyMap)));
var union232 = /* @__PURE__ */ dual232(2, (self2, that) => mutate32(empty532(), (set2234) => {
  forEach232(self2, (value) => add232(set2234, value));
  for (const value of that) {
    add232(set2234, value);
  }
}));
var forEach232 = /* @__PURE__ */ dual232(2, (self2, f2222) => forEach62(self2._keyMap, (_2222, k2222) => f2222(k2222)));
var empty632 = empty532;
var size332 = size232;
var add332 = add232;
var union332 = union232;
var ArrayProto32 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(Array.prototype), {
  [symbol332]() {
    return cached232(this, array72(this));
  },
  [symbol2232](that) {
    if (Array.isArray(that) && this.length === that.length) {
      return this.every((v2222, i2222) => equals232(v2222, that[i2222]));
    } else {
      return false;
    }
  }
});
var Structural42 = /* @__PURE__ */ function() {
  function Structural334(args) {
    if (args) {
      Object.assign(this, args);
    }
  }
  Structural334.prototype = StructuralPrototype232;
  return Structural334;
}();
var struct232 = (as2234) => Object.assign(Object.create(StructuralPrototype232), as2234);
var ContextPatchTypeId32 = /* @__PURE__ */ Symbol.for("effect/DifferContextPatch");
function variance42(a2222) {
  return a2222;
}
var PatchProto32 = {
  ...Structural42.prototype,
  [ContextPatchTypeId32]: {
    _Value: variance42,
    _Patch: variance42
  }
};
var EmptyProto32 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto32), {
  _tag: "Empty"
});
var _empty532 = /* @__PURE__ */ Object.create(EmptyProto32);
var empty732 = () => _empty532;
var AndThenProto32 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto32), {
  _tag: "AndThen"
});
var makeAndThen32 = (first, second) => {
  const o2222 = Object.create(AndThenProto32);
  o2222.first = first;
  o2222.second = second;
  return o2222;
};
var AddServiceProto32 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto32), {
  _tag: "AddService"
});
var makeAddService32 = (key, service) => {
  const o2222 = Object.create(AddServiceProto32);
  o2222.key = key;
  o2222.service = service;
  return o2222;
};
var RemoveServiceProto32 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto32), {
  _tag: "RemoveService"
});
var makeRemoveService32 = (key) => {
  const o2222 = Object.create(RemoveServiceProto32);
  o2222.key = key;
  return o2222;
};
var UpdateServiceProto32 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto32), {
  _tag: "UpdateService"
});
var makeUpdateService32 = (key, update222) => {
  const o2222 = Object.create(UpdateServiceProto32);
  o2222.key = key;
  o2222.update = update222;
  return o2222;
};
var diff32 = (oldValue, newValue) => {
  const missingServices = new Map(oldValue.unsafeMap);
  let patch234 = empty732();
  for (const [tag, newService] of newValue.unsafeMap.entries()) {
    if (missingServices.has(tag)) {
      const old = missingServices.get(tag);
      missingServices.delete(tag);
      if (!equals232(old, newService)) {
        patch234 = combine2232(makeUpdateService32(tag, () => newService))(patch234);
      }
    } else {
      missingServices.delete(tag);
      patch234 = combine2232(makeAddService32(tag, newService))(patch234);
    }
  }
  for (const [tag] of missingServices.entries()) {
    patch234 = combine2232(makeRemoveService32(tag))(patch234);
  }
  return patch234;
};
var combine2232 = /* @__PURE__ */ dual232(2, (self2, that) => makeAndThen32(self2, that));
var patch32 = /* @__PURE__ */ dual232(2, (self2, context) => {
  if (self2._tag === "Empty") {
    return context;
  }
  let wasServiceUpdated = false;
  let patches = of42(self2);
  const updatedContext = new Map(context.unsafeMap);
  while (isNonEmpty32(patches)) {
    const head222 = headNonEmpty42(patches);
    const tail322 = tailNonEmpty42(patches);
    switch (head222._tag) {
      case "Empty": {
        patches = tail322;
        break;
      }
      case "AddService": {
        updatedContext.set(head222.key, head222.service);
        patches = tail322;
        break;
      }
      case "AndThen": {
        patches = prepend52(prepend52(tail322, head222.second), head222.first);
        break;
      }
      case "RemoveService": {
        updatedContext.delete(head222.key);
        patches = tail322;
        break;
      }
      case "UpdateService": {
        updatedContext.set(head222.key, head222.update(updatedContext.get(head222.key)));
        wasServiceUpdated = true;
        patches = tail322;
        break;
      }
    }
  }
  if (!wasServiceUpdated) {
    return makeContext32(updatedContext);
  }
  const map622 = /* @__PURE__ */ new Map();
  for (const [tag] of context.unsafeMap) {
    if (updatedContext.has(tag)) {
      map622.set(tag, updatedContext.get(tag));
      updatedContext.delete(tag);
    }
  }
  for (const [tag, s2222] of updatedContext) {
    map622.set(tag, s2222);
  }
  return makeContext32(map622);
});
var DifferTypeId32 = /* @__PURE__ */ Symbol.for("effect/Differ");
var DifferProto32 = {
  [DifferTypeId32]: {
    _P: identity232,
    _V: identity232
  }
};
var make732 = (params) => {
  const differ = Object.create(DifferProto32);
  differ.empty = params.empty;
  differ.diff = params.diff;
  differ.combine = params.combine;
  differ.patch = params.patch;
  return differ;
};
var environment32 = () => make732({
  empty: empty732(),
  combine: (first, second) => combine2232(second)(first),
  diff: (oldValue, newValue) => diff32(oldValue, newValue),
  patch: (patch234, oldValue) => patch32(oldValue)(patch234)
});
var OP_DIE32 = "Die";
var OP_EMPTY32 = "Empty";
var OP_FAIL32 = "Fail";
var OP_INTERRUPT32 = "Interrupt";
var OP_PARALLEL32 = "Parallel";
var OP_SEQUENTIAL32 = "Sequential";
var CauseSymbolKey32 = "effect/Cause";
var CauseTypeId32 = /* @__PURE__ */ Symbol.for(CauseSymbolKey32);
var variance232 = {
  /* c8 ignore next */
  _E: (_2222) => _2222
};
var proto32 = {
  [CauseTypeId32]: variance232,
  [symbol332]() {
    return pipe232(hash232(CauseSymbolKey32), combine232(hash232(flattenCause32(this))), cached232(this));
  },
  [symbol2232](that) {
    return isCause32(that) && causeEquals32(this, that);
  },
  pipe() {
    return pipeArguments232(this, arguments);
  },
  toJSON() {
    switch (this._tag) {
      case "Empty":
        return {
          _id: "Cause",
          _tag: this._tag
        };
      case "Die":
        return {
          _id: "Cause",
          _tag: this._tag,
          defect: toJSON232(this.defect)
        };
      case "Interrupt":
        return {
          _id: "Cause",
          _tag: this._tag,
          fiberId: this.fiberId.toJSON()
        };
      case "Fail":
        return {
          _id: "Cause",
          _tag: this._tag,
          failure: toJSON232(this.error)
        };
      case "Sequential":
      case "Parallel":
        return {
          _id: "Cause",
          _tag: this._tag,
          left: toJSON232(this.left),
          right: toJSON232(this.right)
        };
    }
  },
  toString() {
    return pretty32(this);
  },
  [NodeInspectSymbol232]() {
    return this.toJSON();
  }
};
var fail42 = (error) => {
  const o2222 = Object.create(proto32);
  o2222._tag = OP_FAIL32;
  o2222.error = error;
  return o2222;
};
var parallel32 = (left334, right334) => {
  const o2222 = Object.create(proto32);
  o2222._tag = OP_PARALLEL32;
  o2222.left = left334;
  o2222.right = right334;
  return o2222;
};
var sequential32 = (left334, right334) => {
  const o2222 = Object.create(proto32);
  o2222._tag = OP_SEQUENTIAL32;
  o2222.left = left334;
  o2222.right = right334;
  return o2222;
};
var isCause32 = (u2222) => hasProperty232(u2222, CauseTypeId32);
var isInterruptedOnly32 = (self2) => reduceWithContext32(void 0, IsInterruptedOnlyCauseReducer32)(self2);
var causeEquals32 = (left334, right334) => {
  let leftStack = of42(left334);
  let rightStack = of42(right334);
  while (isNonEmpty32(leftStack) && isNonEmpty32(rightStack)) {
    const [leftParallel, leftSequential] = pipe232(headNonEmpty42(leftStack), reduce432([empty632(), empty332()], ([parallel234, sequential234], cause) => {
      const [par, seq] = evaluateCause32(cause);
      return some3232([pipe232(parallel234, union332(par)), pipe232(sequential234, appendAll42(seq))]);
    }));
    const [rightParallel, rightSequential] = pipe232(headNonEmpty42(rightStack), reduce432([empty632(), empty332()], ([parallel234, sequential234], cause) => {
      const [par, seq] = evaluateCause32(cause);
      return some3232([pipe232(parallel234, union332(par)), pipe232(sequential234, appendAll42(seq))]);
    }));
    if (!equals232(leftParallel, rightParallel)) {
      return false;
    }
    leftStack = leftSequential;
    rightStack = rightSequential;
  }
  return true;
};
var flattenCause32 = (cause) => {
  return flattenCauseLoop32(of42(cause), empty332());
};
var flattenCauseLoop32 = (causes, flattened) => {
  while (1) {
    const [parallel234, sequential234] = pipe232(causes, reduce62([empty632(), empty332()], ([parallel322, sequential322], cause) => {
      const [par, seq] = evaluateCause32(cause);
      return [pipe232(parallel322, union332(par)), pipe232(sequential322, appendAll42(seq))];
    }));
    const updated = size332(parallel234) > 0 ? pipe232(flattened, prepend52(parallel234)) : flattened;
    if (isEmpty42(sequential234)) {
      return reverse232(updated);
    }
    causes = sequential234;
    flattened = updated;
  }
  throw new Error(getBugErrorMessage232("Cause.flattenCauseLoop"));
};
var evaluateCause32 = (self2) => {
  let cause = self2;
  const stack = [];
  let _parallel = empty632();
  let _sequential = empty332();
  while (cause !== void 0) {
    switch (cause._tag) {
      case OP_EMPTY32: {
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_FAIL32: {
        _parallel = add332(_parallel, make4232(cause._tag, cause.error));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_DIE32: {
        _parallel = add332(_parallel, make4232(cause._tag, cause.defect));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_INTERRUPT32: {
        _parallel = add332(_parallel, make4232(cause._tag, cause.fiberId));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_SEQUENTIAL32: {
        switch (cause.left._tag) {
          case OP_EMPTY32: {
            cause = cause.right;
            break;
          }
          case OP_SEQUENTIAL32: {
            cause = sequential32(cause.left.left, sequential32(cause.left.right, cause.right));
            break;
          }
          case OP_PARALLEL32: {
            cause = parallel32(sequential32(cause.left.left, cause.right), sequential32(cause.left.right, cause.right));
            break;
          }
          default: {
            _sequential = prepend52(_sequential, cause.right);
            cause = cause.left;
            break;
          }
        }
        break;
      }
      case OP_PARALLEL32: {
        stack.push(cause.right);
        cause = cause.left;
        break;
      }
    }
  }
  throw new Error(getBugErrorMessage232("Cause.evaluateCauseLoop"));
};
var IsInterruptedOnlyCauseReducer32 = {
  emptyCase: constTrue232,
  failCase: constFalse232,
  dieCase: constFalse232,
  interruptCase: constTrue232,
  sequentialCase: (_2222, left334, right334) => left334 && right334,
  parallelCase: (_2222, left334, right334) => left334 && right334
};
var OP_SEQUENTIAL_CASE32 = "SequentialCase";
var OP_PARALLEL_CASE32 = "ParallelCase";
var reduce432 = /* @__PURE__ */ dual232(3, (self2, zero, pf) => {
  let accumulator = zero;
  let cause = self2;
  const causes = [];
  while (cause !== void 0) {
    const option = pf(accumulator, cause);
    accumulator = isSome2232(option) ? option.value : accumulator;
    switch (cause._tag) {
      case OP_SEQUENTIAL32: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      case OP_PARALLEL32: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      default: {
        cause = void 0;
        break;
      }
    }
    if (cause === void 0 && causes.length > 0) {
      cause = causes.pop();
    }
  }
  return accumulator;
});
var reduceWithContext32 = /* @__PURE__ */ dual232(3, (self2, context, reducer) => {
  const input = [self2];
  const output = [];
  while (input.length > 0) {
    const cause = input.pop();
    switch (cause._tag) {
      case OP_EMPTY32: {
        output.push(right2232(reducer.emptyCase(context)));
        break;
      }
      case OP_FAIL32: {
        output.push(right2232(reducer.failCase(context, cause.error)));
        break;
      }
      case OP_DIE32: {
        output.push(right2232(reducer.dieCase(context, cause.defect)));
        break;
      }
      case OP_INTERRUPT32: {
        output.push(right2232(reducer.interruptCase(context, cause.fiberId)));
        break;
      }
      case OP_SEQUENTIAL32: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left2232({
          _tag: OP_SEQUENTIAL_CASE32
        }));
        break;
      }
      case OP_PARALLEL32: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left2232({
          _tag: OP_PARALLEL_CASE32
        }));
        break;
      }
    }
  }
  const accumulator = [];
  while (output.length > 0) {
    const either = output.pop();
    switch (either._tag) {
      case "Left": {
        switch (either.left._tag) {
          case OP_SEQUENTIAL_CASE32: {
            const left334 = accumulator.pop();
            const right334 = accumulator.pop();
            const value = reducer.sequentialCase(context, left334, right334);
            accumulator.push(value);
            break;
          }
          case OP_PARALLEL_CASE32: {
            const left334 = accumulator.pop();
            const right334 = accumulator.pop();
            const value = reducer.parallelCase(context, left334, right334);
            accumulator.push(value);
            break;
          }
        }
        break;
      }
      case "Right": {
        accumulator.push(either.right);
        break;
      }
    }
  }
  if (accumulator.length === 0) {
    throw new Error("BUG: Cause.reduceWithContext - please report an issue at https://github.com/Effect-TS/effect/issues");
  }
  return accumulator.pop();
});
var pretty32 = (cause) => {
  if (isInterruptedOnly32(cause)) {
    return "All fibers interrupted without errors.";
  }
  return prettyErrors32(cause).map((e2222) => e2222.stack).join("\n");
};
var PrettyError32 = class extends globalThis.Error {
  span = void 0;
  constructor(originalError) {
    const prevLimit = Error.stackTraceLimit;
    Error.stackTraceLimit = 0;
    super(prettyErrorMessage32(originalError));
    Error.stackTraceLimit = prevLimit;
    this.name = originalError instanceof Error ? originalError.name : "Error";
    if (typeof originalError === "object" && originalError !== null) {
      if (spanSymbol42 in originalError) {
        this.span = originalError[spanSymbol42];
      }
      Object.keys(originalError).forEach((key) => {
        if (!(key in this)) {
          this[key] = originalError[key];
        }
      });
    }
    this.stack = prettyErrorStack32(this.message, originalError instanceof Error && originalError.stack ? originalError.stack : "", this.span);
  }
  toJSON() {
    const out = {
      message: this.message,
      stack: this.stack
    };
    if (this.span) {
      out.span = this.span;
    }
    return out;
  }
};
var prettyErrorMessage32 = (u2222) => {
  if (typeof u2222 === "string") {
    return `Error: ${u2222}`;
  }
  try {
    if (hasProperty232(u2222, "toString") && isFunction323(u2222["toString"]) && u2222["toString"] !== Object.prototype.toString && u2222["toString"] !== globalThis.Array.prototype.toString) {
      return u2222["toString"]();
    }
  } catch {
  }
  return `Error: ${JSON.stringify(u2222)}`;
};
var locationRegex32 = /\((.*)\)/;
var spanToTrace32 = /* @__PURE__ */ globalValue232("effect/Tracer/spanToTrace", () => /* @__PURE__ */ new WeakMap());
var prettyErrorStack32 = (message, stack, span222) => {
  const out = [message];
  const lines = stack.split("\n");
  for (let i2222 = 1; i2222 < lines.length; i2222++) {
    if (lines[i2222].includes("Generator.next")) {
      break;
    }
    if (lines[i2222].includes("effect_internal_function")) {
      out.pop();
      break;
    }
    out.push(lines[i2222].replace(/at .*effect_instruction_i.*\((.*)\)/, "at $1").replace(/EffectPrimitive\.\w+/, "<anonymous>"));
  }
  if (span222) {
    let current = span222;
    let i2222 = 0;
    while (current && current._tag === "Span" && i2222 < 10) {
      const stackFn = spanToTrace32.get(current);
      if (typeof stackFn === "function") {
        const stack2 = stackFn();
        const locationMatch = stack2.match(locationRegex32);
        const location = locationMatch ? locationMatch[1] : stack2.replace(/^at /, "");
        out.push(`    at ${current.name} (${location})`);
      } else {
        out.push(`    at ${current.name}`);
      }
      current = getOrUndefined232(current.parent);
      i2222++;
    }
  }
  return out.join("\n");
};
var spanSymbol42 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var prettyErrors32 = (cause) => reduceWithContext32(cause, void 0, {
  emptyCase: () => [],
  dieCase: (_2222, unknownError) => {
    return [new PrettyError32(unknownError)];
  },
  failCase: (_2222, error) => {
    return [new PrettyError32(error)];
  },
  interruptCase: () => [],
  parallelCase: (_2222, l2222, r2222) => [...l2222, ...r2222],
  sequentialCase: (_2222, l2222, r2222) => [...l2222, ...r2222]
});
var SingleShotGen2232 = class _SingleShotGen232 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  next(a2222) {
    return this.called ? {
      value: a2222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  return(a2222) {
    return {
      value: a2222,
      done: true
    };
  }
  throw(e2222) {
    throw e2222;
  }
  [Symbol.iterator]() {
    return new _SingleShotGen232(this.self);
  }
};
var spanTag32 = /* @__PURE__ */ GenericTag32("effect/ParentSpan");
var EffectTypeId2232 = /* @__PURE__ */ Symbol.for("effect/Effect");
var EffectPrimitive32 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId2232] = effectVariance232;
  constructor(_op) {
    this._op = _op;
  }
  [symbol2232](that) {
    return this === that;
  }
  [symbol332]() {
    return cached232(this, random232(this));
  }
  pipe() {
    return pipeArguments232(this, arguments);
  }
  toJSON() {
    return {
      _id: "Effect",
      _op: this._op,
      effect_instruction_i0: toJSON232(this.effect_instruction_i0),
      effect_instruction_i1: toJSON232(this.effect_instruction_i1),
      effect_instruction_i2: toJSON232(this.effect_instruction_i2)
    };
  }
  toString() {
    return format232(this.toJSON());
  }
  [NodeInspectSymbol232]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen2232(new YieldWrap232(this));
  }
};
var EffectPrimitiveFailure32 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId2232] = effectVariance232;
  constructor(_op) {
    this._op = _op;
    this._tag = _op;
  }
  [symbol2232](that) {
    return exitIsExit32(that) && that._op === "Failure" && // @ts-expect-error
    equals232(this.effect_instruction_i0, that.effect_instruction_i0);
  }
  [symbol332]() {
    return pipe232(
      // @ts-expect-error
      string232(this._tag),
      // @ts-expect-error
      combine232(hash232(this.effect_instruction_i0)),
      cached232(this)
    );
  }
  get cause() {
    return this.effect_instruction_i0;
  }
  pipe() {
    return pipeArguments232(this, arguments);
  }
  toJSON() {
    return {
      _id: "Exit",
      _tag: this._op,
      cause: this.cause.toJSON()
    };
  }
  toString() {
    return format232(this.toJSON());
  }
  [NodeInspectSymbol232]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen2232(new YieldWrap232(this));
  }
};
var isEffect32 = (u2222) => hasProperty232(u2222, EffectTypeId2232);
var withFiberRuntime32 = (withRuntime) => {
  const effect = new EffectPrimitive32(OP_WITH_RUNTIME32);
  effect.effect_instruction_i0 = withRuntime;
  return effect;
};
var spanSymbol232 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var originalSymbol32 = /* @__PURE__ */ Symbol.for("effect/OriginalAnnotation");
var capture32 = (obj, span222) => {
  if (isSome2232(span222)) {
    return new Proxy(obj, {
      has(target, p2222) {
        return p2222 === spanSymbol232 || p2222 === originalSymbol32 || p2222 in target;
      },
      get(target, p2222) {
        if (p2222 === spanSymbol232) {
          return span222.value;
        }
        if (p2222 === originalSymbol32) {
          return obj;
        }
        return target[p2222];
      }
    });
  }
  return obj;
};
var fail232 = (error) => isObject232(error) && !(spanSymbol232 in error) ? withFiberRuntime32((fiber) => failCause32(fail42(capture32(error, currentSpanFromFiber32(fiber))))) : failCause32(fail42(error));
var failCause32 = (cause) => {
  const effect = new EffectPrimitiveFailure32(OP_FAILURE32);
  effect.effect_instruction_i0 = cause;
  return effect;
};
var FiberRefSymbolKey32 = "effect/FiberRef";
var FiberRefTypeId32 = /* @__PURE__ */ Symbol.for(FiberRefSymbolKey32);
var fiberRefVariance32 = {
  /* c8 ignore next */
  _A: (_2222) => _2222
};
var fiberRefUnsafeMakeContext32 = (initial) => {
  const differ = environment32();
  return fiberRefUnsafeMakePatch32(initial, {
    differ,
    fork: differ.empty
  });
};
var fiberRefUnsafeMakePatch32 = (initial, options) => ({
  [FiberRefTypeId32]: fiberRefVariance32,
  initial,
  diff: (oldValue, newValue) => options.differ.diff(oldValue, newValue),
  combine: (first, second) => options.differ.combine(first, second),
  patch: (patch234) => (oldValue) => options.differ.patch(patch234, oldValue),
  fork: options.fork,
  join: options.join ?? ((_2222, n2222) => n2222),
  pipe() {
    return pipeArguments232(this, arguments);
  }
});
var currentContext32 = /* @__PURE__ */ globalValue232(/* @__PURE__ */ Symbol.for("effect/FiberRef/currentContext"), () => fiberRefUnsafeMakeContext32(empty232()));
var YieldableError32 = /* @__PURE__ */ function() {
  class YieldableError234 extends globalThis.Error {
    commit() {
      return fail232(this);
    }
    toString() {
      return this.message ? `${this.name}: ${this.message}` : this.name;
    }
    toJSON() {
      return {
        ...this
      };
    }
    [NodeInspectSymbol232]() {
      const stack = this.stack;
      if (stack) {
        return `${this.toString()}
${stack.split("\n").slice(1).join("\n")}`;
      }
      return this.toString();
    }
  }
  Object.assign(YieldableError234.prototype, StructuralCommitPrototype232);
  return YieldableError234;
}();
var exitIsExit32 = (u2222) => isEffect32(u2222) && "_tag" in u2222 && (u2222._tag === "Success" || u2222._tag === "Failure");
var currentSpanFromFiber32 = (fiber) => {
  const span222 = fiber.getFiberRef(currentContext32).unsafeMap.get(spanTag32.key);
  return span222 !== void 0 && span222._tag === "Span" ? some3232(span222) : none2232();
};
var Data_exports232 = {};
__export232(Data_exports232, {
  Class: () => Class232,
  Error: () => Error232,
  Structural: () => Structural232,
  TaggedClass: () => TaggedClass32,
  TaggedError: () => TaggedError32,
  array: () => array232,
  case: () => _case32,
  struct: () => struct332,
  tagged: () => tagged32,
  taggedEnum: () => taggedEnum32,
  tuple: () => tuple232,
  unsafeArray: () => unsafeArray32,
  unsafeStruct: () => unsafeStruct32
});
var struct332 = struct232;
var unsafeStruct32 = (as2234) => Object.setPrototypeOf(as2234, StructuralPrototype232);
var tuple232 = (...as2234) => unsafeArray32(as2234);
var array232 = (as2234) => unsafeArray32(as2234.slice(0));
var unsafeArray32 = (as2234) => Object.setPrototypeOf(as2234, ArrayProto32);
var _case32 = () => (args) => args === void 0 ? Object.create(StructuralPrototype232) : struct332(args);
var tagged32 = (tag) => (args) => {
  const value = args === void 0 ? Object.create(StructuralPrototype232) : struct332(args);
  value._tag = tag;
  return value;
};
var Class232 = Structural42;
var TaggedClass32 = (tag) => {
  class Base extends Class232 {
    _tag = tag;
  }
  return Base;
};
var Structural232 = Structural42;
var taggedEnum32 = () => new Proxy({}, {
  get(_target, tag, _receiver) {
    if (tag === "$is") {
      return isTagged52;
    } else if (tag === "$match") {
      return taggedMatch32;
    }
    return tagged32(tag);
  }
});
function taggedMatch32() {
  if (arguments.length === 1) {
    const cases2 = arguments[0];
    return function(value2) {
      return cases2[value2._tag](value2);
    };
  }
  const value = arguments[0];
  const cases = arguments[1];
  return cases[value._tag](value);
}
var Error232 = /* @__PURE__ */ function() {
  return class Base extends YieldableError32 {
    constructor(args) {
      super();
      if (args) {
        Object.assign(this, args);
      }
    }
  };
}();
var TaggedError32 = (tag) => {
  class Base extends Error232 {
    _tag = tag;
  }
  Base.prototype.name = tag;
  return Base;
};
var traverseUp32 = Function_exports232.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType32.Program) return Option_exports232.none();
  return predicate(parent) ? Option_exports232.some(parent) : traverseUp32(parent, predicate);
});
var traverseUpGuard32 = Function_exports232.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType32.Program) return Option_exports232.none();
  return predicate(parent) ? Option_exports232.some(parent) : traverseUpGuard32(parent, predicate);
});
var ESLintCommunityESLintUtils32;
((ESLintCommunityESLintUtils234) => {
  ESLintCommunityESLintUtils234.getFunctionHeadLocation = getFunctionHeadLocation32;
  ESLintCommunityESLintUtils234.getFunctionNameWithKind = getFunctionNameWithKind32;
  ESLintCommunityESLintUtils234.getPropertyName = getPropertyName32;
  ESLintCommunityESLintUtils234.getStaticValue = getStaticValue42;
  ESLintCommunityESLintUtils234.getStringIfConstant = getStringIfConstant32;
  ESLintCommunityESLintUtils234.hasSideEffect = hasSideEffect32;
  ESLintCommunityESLintUtils234.isParenthesized = isParenthesized32;
})(ESLintCommunityESLintUtils32 || (ESLintCommunityESLintUtils32 = {}));
var Construction32 = Data_exports232.taggedEnum();
Construction32.None();
a22({
  type: N22.union([NodeType32.FunctionExpression, NodeType32.ArrowFunctionExpression]),
  parent: {
    type: NodeType32.Property,
    parent: {
      type: NodeType32.ObjectExpression
    }
  }
});
a22({
  type: N22.union([NodeType32.FunctionExpression, NodeType32.ArrowFunctionExpression]),
  parent: {
    type: NodeType32.MethodDefinition,
    parent: {
      type: NodeType32.ClassBody
    }
  }
});
a22({
  type: N22.union([NodeType32.FunctionExpression, NodeType32.ArrowFunctionExpression]),
  parent: {
    type: NodeType32.Property,
    parent: {
      type: NodeType32.ClassBody
    }
  }
});
function isInitializedFromReact(variableName, context, initialScope) {
  if (variableName.toLowerCase() === "react") return true;
  const maybeVariable = findVariable32(variableName, initialScope);
  const maybeLatestDef = Option_exports42.flatMapNullable(maybeVariable, (v322) => v322.defs.at(-1));
  if (Option_exports42.isNone(maybeLatestDef)) return false;
  const latestDef = maybeLatestDef.value;
  const { node, parent } = latestDef;
  const settings = parse(ESLintSettingsSchema2, context.settings);
  const importSource = settings.reactOptions?.importSource ?? "react";
  if (node.type === NodeType4.VariableDeclarator && node.init) {
    const { init: init222 } = node;
    if (init222.type === NodeType4.MemberExpression && init222.object.type === NodeType4.Identifier) {
      return isInitializedFromReact(init222.object.name, context, initialScope);
    }
    if (init222.type === NodeType4.Identifier) {
      return isInitializedFromReact(init222.name, context, initialScope);
    }
    const maybeRequireExpression = $(init222).with({
      type: NodeType4.CallExpression,
      callee: { type: NodeType4.Identifier, name: "require" }
    }, (exp) => Option_exports42.some(exp)).with(
      {
        type: NodeType4.MemberExpression,
        object: {
          type: NodeType4.CallExpression,
          callee: { type: NodeType4.Identifier, name: "require" }
        }
      },
      ({ object: object222 }) => Option_exports42.some(object222)
    ).otherwise(Option_exports42.none);
    if (Option_exports42.isNone(maybeRequireExpression)) return false;
    const requireExpression = maybeRequireExpression.value;
    const [firstArg] = requireExpression.arguments;
    if (firstArg?.type !== NodeType4.Literal || !Predicate_exports32.isString(firstArg.value)) return false;
    return firstArg.value === importSource || firstArg.value.startsWith(`${importSource}/`);
  }
  return a({ type: "ImportDeclaration", source: { value: importSource } }, parent);
}
function isFromReact(name22) {
  return (node, context) => {
    const initialScope = context.sourceCode.getScope(node);
    if (node.type === NodeType4.MemberExpression) {
      return node.object.type === NodeType4.Identifier && node.property.type === NodeType4.Identifier && node.property.name === name22 && isInitializedFromReact(node.object.name, context, initialScope);
    }
    if (node.name === name22) return isInitializedFromReact(name22, context, initialScope);
    return false;
  };
}
function isFromReactMember(memberName, name22) {
  return (node, context) => {
    const initialScope = context.sourceCode.getScope(node);
    if (node.property.type !== NodeType4.Identifier || node.property.name !== name22) return false;
    if (node.object.type === NodeType4.Identifier && node.object.name === memberName) {
      return isInitializedFromReact(node.object.name, context, initialScope);
    }
    if (node.object.type === NodeType4.MemberExpression && node.object.object.type === NodeType4.Identifier && isInitializedFromReact(node.object.object.name, context, initialScope) && node.object.property.type === NodeType4.Identifier) {
      return node.object.property.name === memberName;
    }
    return false;
  };
}
function isCallFromReact(name22) {
  return (node, context) => {
    if (!isOneOf4([NodeType4.Identifier, NodeType4.MemberExpression])(node.callee)) return false;
    return isFromReact(name22)(node.callee, context);
  };
}
function isReactAPIWithName(name22, member) {
  return member ? isFromReactMember(name22, member) : isFromReact(name22);
}
function isReactAPICallWithName(name22, member) {
  return isCallFromReact(name22);
}
var isChildrenCount = isReactAPIWithName("Children", "count");
var isChildrenForEach = isReactAPIWithName("Children", "forEach");
var isChildrenMap = isReactAPIWithName("Children", "map");
var isChildrenOnly = isReactAPIWithName("Children", "only");
var isChildrenToArray = isReactAPIWithName("Children", "toArray");
var isCloneElementCall = isReactAPICallWithName("cloneElement");
var isCreateElementCall = isReactAPICallWithName("createElement");
var isCreateRefCall = isReactAPICallWithName("createRef");
var isForwardRefCall = isReactAPICallWithName("forwardRef");
var isMemoCall = isReactAPICallWithName("memo");
function isInsideCreateElementProps(node, context) {
  return Function_exports42.pipe(
    traverseUp4(node, (n322) => is4(NodeType4.CallExpression)(n322) && isCreateElementCall(n322, context)),
    Option_exports42.filter(is4(NodeType4.CallExpression)),
    Option_exports42.flatMapNullable((c322) => c322.arguments.at(1)),
    Option_exports42.filter(is4(NodeType4.ObjectExpression)),
    Option_exports42.zipWith(traverseUp4(node, is4(NodeType4.ObjectExpression)), (a322, b322) => a322 === b322),
    Option_exports42.getOrElse(Function_exports42.constFalse)
  );
}
function isChildrenOfCreateElement(node, context) {
  return Function_exports42.pipe(
    Option_exports42.fromNullable(node.parent),
    Option_exports42.filter(is4(NodeType4.CallExpression)),
    Option_exports42.filter((n322) => isCreateElementCall(n322, context)),
    Option_exports42.exists(
      (n322) => n322.arguments.slice(2).some((arg) => arg === node)
    )
  );
}
function isFragmentElement(node, context) {
  const fragment = parse(ESLintSettingsSchema2, context.settings).reactOptions?.jsxPragmaFrag ?? "Fragment";
  const { name: name22 } = node.openingElement;
  if (name22.type === NodeType4.JSXIdentifier && name22.name === fragment) return true;
  const initialScope = context.sourceCode.getScope(node);
  return name22.type === NodeType4.JSXMemberExpression && name22.object.type === NodeType4.JSXIdentifier && isInitializedFromReact(name22.object.name, context, initialScope) && name22.property.name === fragment;
}
var RE_HOOK_NAME = /^use[A-Z\d]/u;
function isReactHookName(name22) {
  return name22 === "use" || RE_HOOK_NAME.test(name22);
}
function isReactHookCall(node) {
  if (node.callee.type === NodeType4.Identifier) return isReactHookName(node.callee.name);
  if (node.callee.type === NodeType4.MemberExpression) {
    return node.callee.property.type === NodeType4.Identifier && isReactHookName(node.callee.property.name);
  }
  return false;
}
function isReactHookCallWithNameLoose(name22) {
  return (node) => {
    return $(node.callee).with({ type: NodeType4.Identifier, name: name22 }, Function_exports42.constTrue).with({ type: NodeType4.MemberExpression, property: { name: name22 } }, Function_exports42.constTrue).otherwise(Function_exports42.constFalse);
  };
}
new import_short_unique_id.default({ length: 10 });
var ERComponentHint = {
  ...JSXValueHint2,
  // 1n << 0n - 1n << 63n are reserved for JSXValueHint
  // Skip function component created by React.memo
  SkipMemo: 1n << 64n,
  // Skip function component created by React.forwardRef
  SkipForwardRef: 1n << 65n,
  // Skip function component defined in map function callback
  SkipMapCallback: 1n << 66n,
  // Skip function component defined on object method
  SkipObjectMethod: 1n << 67n,
  // Skip function component defined on class method
  SkipClassMethod: 1n << 68n,
  // Skip function component defined on class property
  SkipClassProperty: 1n << 69n
};
var DEFAULT_COMPONENT_HINT = 0n | ERComponentHint.SkipUndefinedLiteral | ERComponentHint.SkipBooleanLiteral | ERComponentHint.SkipStringLiteral | ERComponentHint.SkipNumberLiteral;
var ERClassComponentFlag = {
  None: 0n,
  PureComponent: 1n << 0n
  // Reserved for future use
  // CreateElement: 1n << 1n,
};
var ERFunctionComponentFlag = {
  None: 0n,
  Memo: 1n << 0n,
  ForwardRef: 1n << 1n
  // Reserved for future use
  // CreateElement: 1n << 2n,
  // Reserved for future use
  // hasHooks: 1n << 3n,
  // Reserved for future use
  // Async: 1n << 4n,
};
function isComponentWrapperCall(node, context) {
  if (node.type !== NodeType4.CallExpression) return false;
  return isMemoCall(node, context) || isForwardRefCall(node, context) || isReactHookCallWithNameLoose("useCallback")(node);
}
function getFunctionComponentIdentifier(node, context) {
  const functionId = getFunctionIdentifier2(node);
  if (Option_exports42.isSome(functionId)) return functionId;
  const { parent } = node;
  if (parent.type === NodeType4.CallExpression && isComponentWrapperCall(parent, context) && parent.parent.type === NodeType4.VariableDeclarator && parent.parent.id.type === NodeType4.Identifier && parent.parent.parent.type === NodeType4.VariableDeclaration) {
    return Option_exports42.some(parent.parent.id);
  }
  if (parent.type === NodeType4.CallExpression && isComponentWrapperCall(parent, context) && parent.parent.type === NodeType4.CallExpression && isComponentWrapperCall(parent.parent, context) && parent.parent.parent.type === NodeType4.VariableDeclarator && parent.parent.parent.id.type === NodeType4.Identifier && parent.parent.parent.parent.type === NodeType4.VariableDeclaration) {
    return Option_exports42.some(parent.parent.parent.id);
  }
  return Option_exports42.none();
}
function getComponentInitPath(node) {
  const { parent } = node;
  if (node.type === NodeType4.FunctionDeclaration) return Option_exports42.some([node]);
  if (parent.type === NodeType4.VariableDeclarator && parent.parent.type === NodeType4.VariableDeclaration) {
    return Option_exports42.some([
      parent.parent,
      parent,
      node
    ]);
  }
  if (parent.type === NodeType4.CallExpression && parent.parent.type === NodeType4.VariableDeclarator && parent.parent.parent.type === NodeType4.VariableDeclaration) {
    return Option_exports42.some([
      parent.parent.parent,
      parent.parent,
      parent,
      node
    ]);
  }
  if (parent.type === NodeType4.CallExpression && parent.parent.type === NodeType4.CallExpression && parent.parent.parent.type === NodeType4.VariableDeclarator && parent.parent.parent.parent.type === NodeType4.VariableDeclaration) {
    return Option_exports42.some([
      parent.parent.parent.parent,
      parent.parent.parent,
      parent.parent,
      parent,
      node
    ]);
  }
  if (parent.type === NodeType4.Property && parent.parent.type === NodeType4.ObjectExpression && parent.parent.parent.type === NodeType4.VariableDeclarator && parent.parent.parent.parent.type === NodeType4.VariableDeclaration) {
    return Option_exports42.some([
      parent.parent.parent.parent,
      parent.parent.parent,
      parent.parent,
      parent,
      node
    ]);
  }
  if (parent.type === NodeType4.MethodDefinition && parent.parent.type === NodeType4.ClassBody && parent.parent.parent.type === NodeType4.ClassDeclaration) {
    return Option_exports42.some([
      parent.parent.parent,
      parent.parent,
      parent,
      node
    ]);
  }
  if (parent.type === NodeType4.PropertyDefinition && parent.parent.type === NodeType4.ClassBody && parent.parent.parent.type === NodeType4.ClassDeclaration) {
    return Option_exports42.some([
      parent.parent.parent,
      parent.parent,
      parent,
      node
    ]);
  }
  return Option_exports42.none();
}
function hasCallInInitPath(callName) {
  return (initPath) => {
    return Function_exports42.pipe(
      initPath,
      Option_exports42.filter((p322) => p322.length > 0),
      Option_exports42.exists((nodes) => {
        return nodes.some(
          // callName.includes(".")
          //   ? n => {
          //     const [objectName, propertyName] = callName.split(".");
          //     return "callee" in n
          //       && n.callee.type === NodeType.MemberExpression
          //       && n.callee.object.type === NodeType.Identifier
          //       && n.callee.object.name === objectName
          //       && n.callee.property.type === NodeType.Identifier
          //       && n.callee.property.name === propertyName;
          //   }
          //   : n => {
          //     return "callee" in n
          //       && n.callee.type === NodeType.Identifier
          //       && n.callee.name === callName;
          //   },
          (n322) => {
            if (n322.type !== NodeType4.CallExpression) return false;
            if (n322.callee.type === NodeType4.Identifier) return n322.callee.name === callName;
            return a({ callee: { property: { name: callName } } }, n322);
          }
        );
      })
    );
  };
}
var RE_COMPONENT_NAME = /^[A-Z]/u;
function getComponentNameFromIdentifier(node) {
  return Array.isArray(node) ? node.map((n322) => n322.name).join(".") : node.name;
}
function isComponentName(name22) {
  return !!name22 && RE_COMPONENT_NAME.test(name22);
}
function hasNoneOrValidComponentName(node, context) {
  return Option_exports42.match(
    getFunctionComponentIdentifier(node, context),
    {
      onNone: Function_exports42.constTrue,
      onSome: (id) => {
        const name22 = Array.isArray(id) ? id.at(-1)?.name : id.name;
        return !!name22 && isComponentName(name22);
      }
    }
  );
}
var uid2 = new import_short_unique_id.default({ length: 10 });
function isClassComponent(node) {
  if (!("superClass" in node && node.superClass)) return false;
  const { superClass } = node;
  return $(superClass).with({ type: NodeType4.Identifier, name: N.string }, ({ name: name22 }) => /^(Pure)?Component$/u.test(name22)).with({
    type: NodeType4.MemberExpression,
    property: { name: N.string }
  }, ({ property }) => /^(Pure)?Component$/u.test(property.name)).otherwise(() => false);
}
function isPureComponent(node) {
  if ("superClass" in node && node.superClass) {
    return $(node.superClass).with({ type: NodeType4.Identifier, name: N.string }, ({ name: name22 }) => /^PureComponent$/u.test(name22)).with({
      type: NodeType4.MemberExpression,
      property: { name: N.string }
    }, ({ property }) => /^PureComponent$/u.test(property.name)).otherwise(() => false);
  }
  return false;
}
function useComponentCollectorLegacy() {
  const components = /* @__PURE__ */ new Map();
  const ctx = {
    getAllComponents(_322) {
      return components;
    },
    getCurrentComponents() {
      return new Map(components);
    }
  };
  const collect222 = (node) => {
    if (!isClassComponent(node)) return;
    const id = getClassIdentifier2(node);
    const key = uid2.rnd();
    const flag = isPureComponent(node) ? ERClassComponentFlag.PureComponent : ERClassComponentFlag.None;
    components.set(
      key,
      {
        _: key,
        id,
        kind: "class",
        name: Option_exports42.flatMapNullable(id, (n322) => n322.name),
        // TODO: get displayName of class component
        displayName: Option_exports42.none(),
        flag,
        hint: 0n,
        // TODO: get methods of class component
        methods: [],
        node
      }
    );
  };
  const listeners = {
    ClassDeclaration: collect222,
    ClassExpression: collect222
  };
  return {
    ctx,
    listeners
  };
}
var isRenderMethodLike = a({
  key: {
    type: NodeType4.Identifier,
    name: "render"
  },
  type: N.union(NodeType4.MethodDefinition, NodeType4.PropertyDefinition),
  parent: {
    type: NodeType4.ClassBody,
    parent: {
      type: NodeType4.ClassDeclaration
    }
  }
});
function isFunctionOfRenderMethod(node) {
  if (!isRenderMethodLike(node.parent)) return false;
  return isClassComponent(node.parent.parent.parent);
}
function isInsideRenderMethod(node) {
  const predicate = (node2) => {
    return isRenderMethodLike(node2) && isClassComponent(node2.parent.parent);
  };
  return Option_exports42.isSome(traverseUp4(node, predicate));
}
var uid3 = new import_short_unique_id.default({ length: 10 });
var isMapCall = a({
  callee: {
    type: NodeType4.MemberExpression,
    property: {
      name: "map"
    }
  }
});
function hasValidHierarchy(node, context, hint) {
  if (isChildrenOfCreateElement(node, context) || isFunctionOfRenderMethod(node)) {
    return false;
  }
  if (hint & ERComponentHint.SkipMapCallback && isMapCall(node.parent)) {
    return false;
  }
  if (hint & ERComponentHint.SkipObjectMethod && isFunctionOfObjectMethod2(node.parent)) {
    return false;
  }
  if (hint & ERComponentHint.SkipClassMethod && isFunctionOfClassMethod2(node.parent)) {
    return false;
  }
  if (hint & ERComponentHint.SkipClassProperty && isFunctionOfClassProperty2(node.parent)) {
    return false;
  }
  return !Function_exports42.pipe(
    traverseUp4(
      node,
      isOneOf4([
        NodeType4.JSXExpressionContainer,
        NodeType4.ArrowFunctionExpression,
        NodeType4.FunctionExpression,
        NodeType4.Property,
        NodeType4.ClassBody
      ])
    ),
    Option_exports42.exists(is4(NodeType4.JSXExpressionContainer))
  );
}
function getComponentFlag(initPath) {
  const flagRef = MutableRef_exports.make(ERFunctionComponentFlag.None);
  if (hasCallInInitPath("memo")(initPath)) {
    MutableRef_exports.update(flagRef, (f322) => f322 | ERFunctionComponentFlag.Memo);
  }
  if (hasCallInInitPath("forwardRef")(initPath)) {
    MutableRef_exports.update(flagRef, (f322) => f322 | ERFunctionComponentFlag.ForwardRef);
  }
  return MutableRef_exports.get(flagRef);
}
function useComponentCollector(context, hint = DEFAULT_COMPONENT_HINT) {
  const components = /* @__PURE__ */ new Map();
  const functionStack = MutableList_exports.make();
  const getCurrentFunction = () => Option_exports42.fromNullable(MutableList_exports.tail(functionStack));
  const onFunctionEnter = (node) => MutableList_exports.append(functionStack, [node, false, []]);
  const onFunctionExit = () => MutableList_exports.pop(functionStack);
  const ctx = {
    getAllComponents(_322) {
      return components;
    },
    getCurrentComponents() {
      return new Map(components);
    },
    getCurrentFunction,
    getCurrentFunctionStack() {
      return [...functionStack];
    }
  };
  const listeners = {
    ":function": onFunctionEnter,
    ":function:exit": onFunctionExit,
    ReturnStatement(node) {
      const maybeCurrentFn = getCurrentFunction();
      if (Option_exports42.isNone(maybeCurrentFn)) return;
      const [currentFn, isKnown, hookCalls] = maybeCurrentFn.value;
      if (isKnown) return;
      const isComponent = hasNoneOrValidComponentName(currentFn, context) && isJSXValue(node.argument, context, hint) && hasValidHierarchy(currentFn, context, hint);
      if (!isComponent) return;
      MutableList_exports.pop(functionStack);
      MutableList_exports.append(functionStack, [currentFn, true, []]);
      const initPath = getComponentInitPath(currentFn);
      const id = getFunctionComponentIdentifier(currentFn, context);
      const name22 = Option_exports42.flatMapNullable(id, getComponentNameFromIdentifier);
      const key = uid3.rnd();
      components.set(key, {
        _: key,
        id,
        kind: "function",
        name: name22,
        displayName: Option_exports42.none(),
        flag: getComponentFlag(initPath),
        hint,
        hookCalls,
        initPath,
        node: currentFn
      });
    },
    // eslint-disable-next-line perfectionist/sort-objects
    "ArrowFunctionExpression[body.type!='BlockStatement']"() {
      const maybeCurrentFn = getCurrentFunction();
      if (Option_exports42.isNone(maybeCurrentFn)) return;
      const [currentFn, _322, hookCalls] = maybeCurrentFn.value;
      const { body } = currentFn;
      const isComponent = Function_exports42.constTrue() && hasNoneOrValidComponentName(currentFn, context) && isJSXValue(body, context, hint) && hasValidHierarchy(currentFn, context, hint);
      if (!isComponent) return;
      const initPath = getComponentInitPath(currentFn);
      const id = getFunctionComponentIdentifier(currentFn, context);
      const name22 = Option_exports42.flatMapNullable(id, getComponentNameFromIdentifier);
      const key = uid3.rnd();
      components.set(key, {
        _: key,
        id,
        kind: "function",
        name: name22,
        displayName: Option_exports42.none(),
        flag: getComponentFlag(initPath),
        hint,
        hookCalls,
        initPath,
        node: currentFn
      });
    },
    "CallExpression:exit"(node) {
      if (!isReactHookCall(node)) return;
      const maybeCurrentFn = getCurrentFunction();
      if (Option_exports42.isNone(maybeCurrentFn)) return;
      const [currentFn, IsComponent, hookCalls] = maybeCurrentFn.value;
      MutableList_exports.pop(functionStack);
      MutableList_exports.append(functionStack, [currentFn, IsComponent, [...hookCalls, node]]);
    },
    // eslint-disable-next-line perfectionist/sort-objects
    "AssignmentExpression[operator='='][left.type='MemberExpression'][left.property.name='displayName']"(node) {
      if (node.type !== NodeType4.AssignmentExpression) return;
      const { left: left722, right: right722 } = node;
      if (left722.type !== NodeType4.MemberExpression) return;
      const maybeComponentName = $(left722.object).with({ type: NodeType4.Identifier }, (n322) => Option_exports42.some(n322.name)).otherwise(Option_exports42.none);
      if (Option_exports42.isNone(maybeComponentName)) return;
      const component = Array.from(components.values()).findLast(({ name: name22 }) => Option_exports42.exists(name22, (n322) => n322 === maybeComponentName.value));
      if (!component) return;
      components.set(component._, {
        ...component,
        displayName: Option_exports42.some(right722)
      });
    }
  };
  return {
    ctx,
    listeners
  };
}
function unsafeIsDirectValueOfRenderProperty(node) {
  const matching = a({
    key: {
      type: NodeType4.Identifier,
      name: N.string.startsWith("render")
    },
    type: NodeType4.Property
  });
  return matching(node) || matching(node.parent);
}
function unsafeIsDeclaredInRenderProp(node) {
  if (unsafeIsDirectValueOfRenderProperty(node)) {
    return true;
  }
  return Function_exports42.pipe(
    traverseUpGuard4(node, is4(NodeType4.JSXExpressionContainer)),
    Option_exports42.flatMapNullable((c322) => c322.parent),
    Option_exports42.filter(is4(NodeType4.JSXAttribute)),
    Option_exports42.flatMapNullable((a322) => a322.name),
    Option_exports42.exists(a({
      type: NodeType4.JSXIdentifier,
      name: N.string.startsWith("render")
    }))
  );
}
var RULE_NAME = "avoid-shorthand-boolean";
var avoid_shorthand_boolean_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "enforce boolean attributes notation in JSX",
      requiresTypeChecking: false
    },
    messages: {
      AVOID_SHORTHAND_BOOLEAN: "Avoid using shorthand boolean attribute '{{propName}}'"
    },
    schema: []
  },
  name: RULE_NAME,
  create(context) {
    return {
      JSXAttribute(node) {
        const { value } = node;
        const propName = getPropName(node);
        if (value === null) {
          context.report({
            data: {
              propName
            },
            messageId: "AVOID_SHORTHAND_BOOLEAN",
            node
          });
        }
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME2 = "avoid-shorthand-fragment";
var avoid_shorthand_fragment_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "enforce using fragment component instead of shorthand fragment syntax",
      requiresTypeChecking: false
    },
    messages: {
      AVOID_SHORTHAND_FRAGMENT: "Avoid shorthand fragment syntax, use fragment component instead."
    },
    schema: []
  },
  name: RULE_NAME2,
  create(context) {
    return {
      JSXFragment(node) {
        context.report({
          messageId: "AVOID_SHORTHAND_FRAGMENT",
          node
        });
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME3 = "ensure-forward-ref-using-ref";
var ensure_forward_ref_using_ref_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "require all 'forwardRef' components include a 'ref' parameter",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      ENSURE_FORWARD_REF_USING_REF: "A 'forwardRef' is used with this component but no 'ref' parameter is set."
    },
    schema: []
  },
  name: RULE_NAME3,
  create(context) {
    return {
      CallExpression(node) {
        if (!isForwardRefCall(node, context)) return;
        const [component] = node.arguments;
        if (!component || !isFunction(component)) return;
        const [_52, ref] = component.params;
        if (!ref) {
          context.report({
            messageId: "ENSURE_FORWARD_REF_USING_REF",
            node: component
          });
        }
      }
    };
  },
  defaultOptions: []
});
var Function_exports6 = {};
__export2(Function_exports6, {
  SK: () => SK6,
  absurd: () => absurd6,
  apply: () => apply6,
  compose: () => compose9,
  constFalse: () => constFalse6,
  constNull: () => constNull6,
  constTrue: () => constTrue6,
  constUndefined: () => constUndefined6,
  constVoid: () => constVoid6,
  constant: () => constant6,
  dual: () => dual6,
  flip: () => flip6,
  flow: () => flow6,
  hole: () => hole6,
  identity: () => identity6,
  isFunction: () => isFunction10,
  pipe: () => pipe6,
  satisfies: () => satisfies6,
  tupled: () => tupled6,
  unsafeCoerce: () => unsafeCoerce6,
  untupled: () => untupled6
});
var isFunction10 = (input) => typeof input === "function";
var dual6 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a52, b52) {
        if (arguments.length >= 2) {
          return body(a52, b52);
        }
        return function(self2) {
          return body(self2, a52);
        };
      };
    case 3:
      return function(a52, b52, c52) {
        if (arguments.length >= 3) {
          return body(a52, b52, c52);
        }
        return function(self2) {
          return body(self2, a52, b52);
        };
      };
    case 4:
      return function(a52, b52, c52, d52) {
        if (arguments.length >= 4) {
          return body(a52, b52, c52, d52);
        }
        return function(self2) {
          return body(self2, a52, b52, c52);
        };
      };
    case 5:
      return function(a52, b52, c52, d52, e52) {
        if (arguments.length >= 5) {
          return body(a52, b52, c52, d52, e52);
        }
        return function(self2) {
          return body(self2, a52, b52, c52, d52);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply6 = (a52) => (self2) => self2(a52);
var identity6 = (a52) => a52;
var satisfies6 = () => (b52) => b52;
var unsafeCoerce6 = identity6;
var constant6 = (value) => () => value;
var constTrue6 = /* @__PURE__ */ constant6(true);
var constFalse6 = /* @__PURE__ */ constant6(false);
var constNull6 = /* @__PURE__ */ constant6(null);
var constUndefined6 = /* @__PURE__ */ constant6(void 0);
var constVoid6 = constUndefined6;
var flip6 = (f52) => (...b52) => (...a52) => f52(...a52)(...b52);
var compose9 = /* @__PURE__ */ dual6(2, (ab, bc) => (a52) => bc(ab(a52)));
var absurd6 = (_52) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled6 = (f52) => (a52) => f52(...a52);
var untupled6 = (f52) => (...a52) => f52(a52);
function pipe6(a52, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a52;
    case 2:
      return ab(a52);
    case 3:
      return bc(ab(a52));
    case 4:
      return cd(bc(ab(a52)));
    case 5:
      return de(cd(bc(ab(a52))));
    case 6:
      return ef(de(cd(bc(ab(a52)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a52))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a52)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a52))))))));
    default: {
      let ret = arguments[0];
      for (let i52 = 1; i52 < arguments.length; i52++) {
        ret = arguments[i52](ret);
      }
      return ret;
    }
  }
}
function flow6(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole6 = /* @__PURE__ */ unsafeCoerce6(absurd6);
var SK6 = (_52, b52) => b52;
var make17 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_10 = (map102) => dual6(3, (self2, name22, f52) => map102(self2, (a52) => Object.assign({}, a52, {
  [name22]: f52(a52)
})));
var bindTo10 = (map102) => dual6(2, (self2, name22) => map102(self2, (a52) => ({
  [name22]: a52
})));
var bind10 = (map102, flatMap94) => dual6(3, (self2, name22, f52) => flatMap94(self2, (a52) => map102(f52(a52), (b52) => Object.assign({}, a52, {
  [name22]: b52
}))));
var moduleVersion6 = "3.2.8";
var getCurrentVersion6 = () => moduleVersion6;
var globalStoreId6 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion6()}`);
if (!(globalStoreId6 in globalThis)) {
  globalThis[globalStoreId6] = /* @__PURE__ */ new Map();
}
var globalStore6 = globalThis[globalStoreId6];
var globalValue6 = (id, compute) => {
  if (!globalStore6.has(id)) {
    globalStore6.set(id, compute());
  }
  return globalStore6.get(id);
};
var Predicate_exports5 = {};
__export2(Predicate_exports5, {
  all: () => all9,
  and: () => and6,
  compose: () => compose10,
  eqv: () => eqv6,
  every: () => every7,
  hasProperty: () => hasProperty6,
  implies: () => implies6,
  isBigInt: () => isBigInt6,
  isBoolean: () => isBoolean6,
  isDate: () => isDate6,
  isError: () => isError6,
  isFunction: () => isFunction11,
  isIterable: () => isIterable6,
  isMap: () => isMap6,
  isNever: () => isNever6,
  isNotNull: () => isNotNull6,
  isNotNullable: () => isNotNullable6,
  isNotUndefined: () => isNotUndefined6,
  isNull: () => isNull6,
  isNullable: () => isNullable6,
  isNumber: () => isNumber6,
  isObject: () => isObject6,
  isPromise: () => isPromise6,
  isPromiseLike: () => isPromiseLike6,
  isReadonlyRecord: () => isReadonlyRecord6,
  isRecord: () => isRecord6,
  isSet: () => isSet6,
  isString: () => isString6,
  isSymbol: () => isSymbol6,
  isTagged: () => isTagged6,
  isTruthy: () => isTruthy6,
  isUint8Array: () => isUint8Array6,
  isUndefined: () => isUndefined6,
  isUnknown: () => isUnknown6,
  mapInput: () => mapInput7,
  nand: () => nand6,
  nor: () => nor6,
  not: () => not6,
  or: () => or6,
  product: () => product9,
  productMany: () => productMany9,
  some: () => some13,
  struct: () => struct8,
  tuple: () => tuple7,
  xor: () => xor6
});
var mapInput7 = /* @__PURE__ */ dual6(2, (self2, f52) => (b52) => self2(f52(b52)));
var isTruthy6 = (input) => !!input;
var isSet6 = (input) => input instanceof Set;
var isMap6 = (input) => input instanceof Map;
var isString6 = (input) => typeof input === "string";
var isNumber6 = (input) => typeof input === "number";
var isBoolean6 = (input) => typeof input === "boolean";
var isBigInt6 = (input) => typeof input === "bigint";
var isSymbol6 = (input) => typeof input === "symbol";
var isFunction11 = isFunction10;
var isUndefined6 = (input) => input === void 0;
var isNotUndefined6 = (input) => input !== void 0;
var isNull6 = (input) => input === null;
var isNotNull6 = (input) => input !== null;
var isNever6 = (_52) => false;
var isUnknown6 = (_52) => true;
var isRecordOrArray6 = (input) => typeof input === "object" && input !== null;
var isObject6 = (input) => isRecordOrArray6(input) || isFunction11(input);
var hasProperty6 = /* @__PURE__ */ dual6(2, (self2, property) => isObject6(self2) && property in self2);
var isTagged6 = /* @__PURE__ */ dual6(2, (self2, tag) => hasProperty6(self2, "_tag") && self2["_tag"] === tag);
var isNullable6 = (input) => input === null || input === void 0;
var isNotNullable6 = (input) => input !== null && input !== void 0;
var isError6 = (input) => input instanceof Error;
var isUint8Array6 = (input) => input instanceof Uint8Array;
var isDate6 = (input) => input instanceof Date;
var isIterable6 = (input) => hasProperty6(input, Symbol.iterator);
var isRecord6 = (input) => isRecordOrArray6(input) && !Array.isArray(input);
var isReadonlyRecord6 = isRecord6;
var isPromise6 = (input) => hasProperty6(input, "then") && "catch" in input && isFunction11(input.then) && isFunction11(input.catch);
var isPromiseLike6 = (input) => hasProperty6(input, "then") && isFunction11(input.then);
var compose10 = /* @__PURE__ */ dual6(2, (ab, bc) => (a52) => ab(a52) && bc(a52));
var product9 = (self2, that) => ([a52, b52]) => self2(a52) && that(b52);
var all9 = (collection) => {
  return (as84) => {
    let collectionIndex = 0;
    for (const p52 of collection) {
      if (collectionIndex >= as84.length) {
        break;
      }
      if (p52(as84[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany9 = (self2, collection) => {
  const rest = all9(collection);
  return ([head42, ...tail42]) => self2(head42) === false ? false : rest(tail42);
};
var tuple7 = (...elements) => all9(elements);
var struct8 = (fields) => {
  const keys82 = Object.keys(fields);
  return (a52) => {
    for (const key of keys82) {
      if (!fields[key](a52[key])) {
        return false;
      }
    }
    return true;
  };
};
var not6 = (self2) => (a52) => !self2(a52);
var or6 = /* @__PURE__ */ dual6(2, (self2, that) => (a52) => self2(a52) || that(a52));
var and6 = /* @__PURE__ */ dual6(2, (self2, that) => (a52) => self2(a52) && that(a52));
var xor6 = /* @__PURE__ */ dual6(2, (self2, that) => (a52) => self2(a52) !== that(a52));
var eqv6 = /* @__PURE__ */ dual6(2, (self2, that) => (a52) => self2(a52) === that(a52));
var implies6 = /* @__PURE__ */ dual6(2, (self2, that) => (a52) => self2(a52) ? that(a52) : true);
var nor6 = /* @__PURE__ */ dual6(2, (self2, that) => (a52) => !(self2(a52) || that(a52)));
var nand6 = /* @__PURE__ */ dual6(2, (self2, that) => (a52) => !(self2(a52) && that(a52)));
var every7 = (collection) => (a52) => {
  for (const p52 of collection) {
    if (!p52(a52)) {
      return false;
    }
  }
  return true;
};
var some13 = (collection) => (a52) => {
  for (const p52 of collection) {
    if (p52(a52)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage6 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId6 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind6 = (u52) => isObject6(u52) && GenKindTypeId6 in u52;
var GenKindImpl6 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity6;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_52) => _52;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_52) => _52;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_52) => _52;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId6] = GenKindTypeId6;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen7(this);
  }
};
var SingleShotGen7 = class _SingleShotGen10 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a52) {
    return this.called ? {
      value: a52,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a52) {
    return {
      value: a52,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e52) {
    throw e52;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen10(this.self);
  }
};
var adapter9 = () => function() {
  let x52 = arguments[0];
  for (let i52 = 1; i52 < arguments.length; i52++) {
    x52 = arguments[i52](x52);
  }
  return new GenKindImpl6(x52);
};
var defaultIncHi6 = 335903614;
var defaultIncLo6 = 4150755663;
var MUL_HI6 = 1481765933 >>> 0;
var MUL_LO6 = 1284865837 >>> 0;
var BIT_536 = 9007199254740992;
var BIT_276 = 134217728;
var PCGRandom6 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable6(seedLo) && isNullable6(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable6(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable6(incLo) && isNullable6(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo6;
      incHi = this._state ? this._state[2] : defaultIncHi6;
    } else if (isNullable6(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add646(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max42) {
    if (!max42) {
      return this._next();
    }
    max42 = max42 >>> 0;
    if ((max42 & max42 - 1) === 0) {
      return this._next() & max42 - 1;
    }
    let num = 0;
    const skew = (-max42 >>> 0) % max42 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max42;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_276 + lo) / BIT_536;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul646(this._state, oldHi, oldLo, MUL_HI6, MUL_LO6);
    add646(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul646(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add646(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId6 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap6 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId6]() {
    return this.#value;
  }
};
function yieldWrapGet6(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId6 in self2) {
    return self2[YieldWrapTypeId6]();
  }
  throw new Error(getBugErrorMessage6("yieldWrapGet"));
}
var structuralRegionState6 = /* @__PURE__ */ globalValue6("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache6 = /* @__PURE__ */ globalValue6(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr6 = /* @__PURE__ */ globalValue6(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom6());
var symbol9 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash6 = (self2) => {
  if (structuralRegionState6.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number7(self2);
    case "bigint":
      return string7(self2.toString(10));
    case "boolean":
      return string7(String(self2));
    case "symbol":
      return string7(String(self2));
    case "string":
      return string7(self2);
    case "undefined":
      return string7("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string7("null");
      } else if (self2 instanceof Date) {
        return hash6(self2.toISOString());
      } else if (isHash6(self2)) {
        return self2[symbol9]();
      } else {
        return random6(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random6 = (self2) => {
  if (!randomHashCache6.has(self2)) {
    randomHashCache6.set(self2, number7(pcgr6.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache6.get(self2);
};
var combine7 = (b52) => (self2) => self2 * 53 ^ b52;
var optimize6 = (n52) => n52 & 3221225471 | n52 >>> 1 & 1073741824;
var isHash6 = (u52) => hasProperty6(u52, symbol9);
var number7 = (n52) => {
  if (n52 !== n52 || n52 === Infinity) {
    return 0;
  }
  let h52 = n52 | 0;
  if (h52 !== n52) {
    h52 ^= n52 * 4294967295;
  }
  while (n52 > 4294967295) {
    h52 ^= n52 /= 4294967295;
  }
  return optimize6(n52);
};
var string7 = (str) => {
  let h52 = 5381, i52 = str.length;
  while (i52) {
    h52 = h52 * 33 ^ str.charCodeAt(--i52);
  }
  return optimize6(h52);
};
var cached6 = function() {
  if (arguments.length === 1) {
    const self3 = arguments[0];
    return function(hash92) {
      Object.defineProperty(self3, symbol9, {
        value() {
          return hash92;
        },
        enumerable: false
      });
      return hash92;
    };
  }
  const self2 = arguments[0];
  const hash84 = arguments[1];
  Object.defineProperty(self2, symbol9, {
    value() {
      return hash84;
    },
    enumerable: false
  });
  return hash84;
};
var symbol10 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals6() {
  if (arguments.length === 1) {
    return (self2) => compareBoth6(self2, arguments[0]);
  }
  return compareBoth6(arguments[0], arguments[1]);
}
function compareBoth6(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual6(self2) && isEqual6(that)) {
        if (hash6(self2) === hash6(that) && self2[symbol10](that)) {
          return true;
        } else {
          return structuralRegionState6.enabled && structuralRegionState6.tester ? structuralRegionState6.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState6.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v52, i52) => compareBoth6(v52, that[i52]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth6(self2[key], that[key]))) {
              return structuralRegionState6.tester ? structuralRegionState6.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState6.tester ? structuralRegionState6.tester(self2, that) : false;
    }
  }
  return structuralRegionState6.enabled && structuralRegionState6.tester ? structuralRegionState6.tester(self2, that) : false;
}
var isEqual6 = (u52) => hasProperty6(u52, symbol10);
var equivalence6 = () => equals6;
var NodeInspectSymbol6 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON6 = (x52) => {
  if (hasProperty6(x52, "toJSON") && isFunction11(x52["toJSON"]) && x52["toJSON"].length === 0) {
    return x52.toJSON();
  } else if (Array.isArray(x52)) {
    return x52.map(toJSON6);
  }
  return x52;
};
var format6 = (x52) => JSON.stringify(x52, null, 2);
var pipeArguments6 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i52 = 0, len = args.length; i52 < len; i52++) {
        ret = args[i52](ret);
      }
      return ret;
    }
  }
};
var EffectTypeId7 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId6 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId6 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId6 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance6 = {
  /* c8 ignore next */
  _R: (_52) => _52,
  /* c8 ignore next */
  _E: (_52) => _52,
  /* c8 ignore next */
  _A: (_52) => _52,
  _V: /* @__PURE__ */ getCurrentVersion6()
};
var sinkVariance6 = {
  /* c8 ignore next */
  _A: (_52) => _52,
  /* c8 ignore next */
  _In: (_52) => _52,
  /* c8 ignore next */
  _L: (_52) => _52,
  /* c8 ignore next */
  _E: (_52) => _52,
  /* c8 ignore next */
  _R: (_52) => _52
};
var channelVariance6 = {
  /* c8 ignore next */
  _Env: (_52) => _52,
  /* c8 ignore next */
  _InErr: (_52) => _52,
  /* c8 ignore next */
  _InElem: (_52) => _52,
  /* c8 ignore next */
  _InDone: (_52) => _52,
  /* c8 ignore next */
  _OutErr: (_52) => _52,
  /* c8 ignore next */
  _OutElem: (_52) => _52,
  /* c8 ignore next */
  _OutDone: (_52) => _52
};
var EffectPrototype6 = {
  [EffectTypeId7]: effectVariance6,
  [StreamTypeId6]: effectVariance6,
  [SinkTypeId6]: sinkVariance6,
  [ChannelTypeId6]: channelVariance6,
  [symbol10](that) {
    return this === that;
  },
  [symbol9]() {
    return cached6(this, random6(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen7(new YieldWrap6(this));
  },
  pipe() {
    return pipeArguments6(this, arguments);
  }
};
var TypeId16 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto9 = {
  ...EffectPrototype6,
  [TypeId16]: {
    _A: (_52) => _52
  },
  [NodeInspectSymbol6]() {
    return this.toJSON();
  },
  toString() {
    return format6(this.toJSON());
  }
};
var SomeProto6 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto9), {
  _tag: "Some",
  _op: "Some",
  [symbol10](that) {
    return isOption9(that) && isSome9(that) && equals6(this.value, that.value);
  },
  [symbol9]() {
    return cached6(this, combine7(hash6(this._tag))(hash6(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON6(this.value)
    };
  }
});
var NoneHash6 = /* @__PURE__ */ hash6("None");
var NoneProto6 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto9), {
  _tag: "None",
  _op: "None",
  [symbol10](that) {
    return isOption9(that) && isNone9(that);
  },
  [symbol9]() {
    return NoneHash6;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption9 = (input) => hasProperty6(input, TypeId16);
var isNone9 = (fa) => fa._tag === "None";
var isSome9 = (fa) => fa._tag === "Some";
var none9 = /* @__PURE__ */ Object.create(NoneProto6);
var some14 = (value) => {
  const a52 = Object.create(SomeProto6);
  a52.value = value;
  return a52;
};
var TypeId17 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto10 = {
  ...EffectPrototype6,
  [TypeId17]: {
    _R: (_52) => _52
  },
  [NodeInspectSymbol6]() {
    return this.toJSON();
  },
  toString() {
    return format6(this.toJSON());
  }
};
var RightProto6 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto10), {
  _tag: "Right",
  _op: "Right",
  [symbol10](that) {
    return isEither6(that) && isRight7(that) && equals6(this.right, that.right);
  },
  [symbol9]() {
    return combine7(hash6(this._tag))(hash6(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON6(this.right)
    };
  }
});
var LeftProto6 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto10), {
  _tag: "Left",
  _op: "Left",
  [symbol10](that) {
    return isEither6(that) && isLeft7(that) && equals6(this.left, that.left);
  },
  [symbol9]() {
    return combine7(hash6(this._tag))(hash6(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON6(this.left)
    };
  }
});
var isEither6 = (input) => hasProperty6(input, TypeId17);
var isLeft7 = (ma) => ma._tag === "Left";
var isRight7 = (ma) => ma._tag === "Right";
var left7 = (left94) => {
  const a52 = Object.create(LeftProto6);
  a52.left = left94;
  return a52;
};
var right7 = (right94) => {
  const a52 = Object.create(RightProto6);
  a52.right = right94;
  return a52;
};
var getLeft9 = (self2) => isRight7(self2) ? none9 : some14(self2.left);
var getRight9 = (self2) => isLeft7(self2) ? none9 : some14(self2.right);
var isLeft8 = isLeft7;
var isRight8 = isRight7;
var Option_exports6 = {};
__export2(Option_exports6, {
  Do: () => Do7,
  TypeId: () => TypeId18,
  all: () => all10,
  andThen: () => andThen6,
  ap: () => ap6,
  as: () => as6,
  asVoid: () => asVoid6,
  bind: () => bind11,
  bindTo: () => bindTo11,
  composeK: () => composeK6,
  contains: () => contains7,
  containsWith: () => containsWith7,
  exists: () => exists6,
  filter: () => filter7,
  filterMap: () => filterMap7,
  firstSomeOf: () => firstSomeOf6,
  flatMap: () => flatMap7,
  flatMapNullable: () => flatMapNullable7,
  flatten: () => flatten7,
  fromIterable: () => fromIterable9,
  fromNullable: () => fromNullable7,
  gen: () => gen6,
  getEquivalence: () => getEquivalence8,
  getLeft: () => getLeft10,
  getOrElse: () => getOrElse6,
  getOrNull: () => getOrNull6,
  getOrThrow: () => getOrThrow6,
  getOrThrowWith: () => getOrThrowWith6,
  getOrUndefined: () => getOrUndefined6,
  getOrder: () => getOrder7,
  getRight: () => getRight10,
  isNone: () => isNone10,
  isOption: () => isOption10,
  isSome: () => isSome10,
  let: () => let_11,
  lift2: () => lift26,
  liftNullable: () => liftNullable7,
  liftPredicate: () => liftPredicate7,
  liftThrowable: () => liftThrowable6,
  map: () => map7,
  match: () => match,
  none: () => none10,
  orElse: () => orElse6,
  orElseEither: () => orElseEither6,
  orElseSome: () => orElseSome6,
  partitionMap: () => partitionMap7,
  product: () => product10,
  productMany: () => productMany10,
  reduceCompact: () => reduceCompact6,
  some: () => some15,
  tap: () => tap6,
  toArray: () => toArray6,
  toRefinement: () => toRefinement6,
  void: () => void_6,
  zipLeft: () => zipLeft6,
  zipRight: () => zipRight6,
  zipWith: () => zipWith7
});
var make18 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId18 = /* @__PURE__ */ Symbol.for("effect/Option");
var none10 = () => none9;
var some15 = some14;
var isOption10 = isOption9;
var isNone10 = isNone9;
var isSome10 = isSome9;
var match = /* @__PURE__ */ dual6(2, (self2, {
  onNone,
  onSome
}) => isNone10(self2) ? onNone() : onSome(self2.value));
var toRefinement6 = (f52) => (a52) => isSome10(f52(a52));
var fromIterable9 = (collection) => {
  for (const a52 of collection) {
    return some15(a52);
  }
  return none10();
};
var getRight10 = getRight9;
var getLeft10 = getLeft9;
var getOrElse6 = /* @__PURE__ */ dual6(2, (self2, onNone) => isNone10(self2) ? onNone() : self2.value);
var orElse6 = /* @__PURE__ */ dual6(2, (self2, that) => isNone10(self2) ? that() : self2);
var orElseSome6 = /* @__PURE__ */ dual6(2, (self2, onNone) => isNone10(self2) ? some15(onNone()) : self2);
var orElseEither6 = /* @__PURE__ */ dual6(2, (self2, that) => isNone10(self2) ? map7(that(), right7) : map7(self2, left7));
var firstSomeOf6 = (collection) => {
  let out = none10();
  for (out of collection) {
    if (isSome10(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable7 = (nullableValue) => nullableValue == null ? none10() : some15(nullableValue);
var liftNullable7 = (f52) => (...a52) => fromNullable7(f52(...a52));
var getOrNull6 = /* @__PURE__ */ getOrElse6(constNull6);
var getOrUndefined6 = /* @__PURE__ */ getOrElse6(constUndefined6);
var liftThrowable6 = (f52) => (...a52) => {
  try {
    return some15(f52(...a52));
  } catch (e52) {
    return none10();
  }
};
var getOrThrowWith6 = /* @__PURE__ */ dual6(2, (self2, onNone) => {
  if (isSome10(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow6 = /* @__PURE__ */ getOrThrowWith6(() => new Error("getOrThrow called on a None"));
var map7 = /* @__PURE__ */ dual6(2, (self2, f52) => isNone10(self2) ? none10() : some15(f52(self2.value)));
var as6 = /* @__PURE__ */ dual6(2, (self2, b52) => map7(self2, () => b52));
var asVoid6 = /* @__PURE__ */ as6(void 0);
var void_6 = /* @__PURE__ */ some15(void 0);
var flatMap7 = /* @__PURE__ */ dual6(2, (self2, f52) => isNone10(self2) ? none10() : f52(self2.value));
var andThen6 = /* @__PURE__ */ dual6(2, (self2, f52) => flatMap7(self2, (a52) => {
  const b52 = isFunction10(f52) ? f52(a52) : f52;
  return isOption10(b52) ? b52 : some15(b52);
}));
var flatMapNullable7 = /* @__PURE__ */ dual6(2, (self2, f52) => isNone10(self2) ? none10() : fromNullable7(f52(self2.value)));
var flatten7 = /* @__PURE__ */ flatMap7(identity6);
var zipRight6 = /* @__PURE__ */ dual6(2, (self2, that) => flatMap7(self2, () => that));
var composeK6 = /* @__PURE__ */ dual6(2, (afb, bfc) => (a52) => flatMap7(afb(a52), bfc));
var zipLeft6 = /* @__PURE__ */ dual6(2, (self2, that) => tap6(self2, () => that));
var tap6 = /* @__PURE__ */ dual6(2, (self2, f52) => flatMap7(self2, (a52) => map7(f52(a52), () => a52)));
var product10 = (self2, that) => isSome10(self2) && isSome10(that) ? some15([self2.value, that.value]) : none10();
var productMany10 = (self2, collection) => {
  if (isNone10(self2)) {
    return none10();
  }
  const out = [self2.value];
  for (const o52 of collection) {
    if (isNone10(o52)) {
      return none10();
    }
    out.push(o52.value);
  }
  return some15(out);
};
var all10 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o52 of input) {
      if (isNone10(o52)) {
        return none10();
      }
      out2.push(o52.value);
    }
    return some15(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o52 = input[key];
    if (isNone10(o52)) {
      return none10();
    }
    out[key] = o52.value;
  }
  return some15(out);
};
var zipWith7 = /* @__PURE__ */ dual6(3, (self2, that, f52) => map7(product10(self2, that), ([a52, b52]) => f52(a52, b52)));
var ap6 = /* @__PURE__ */ dual6(2, (self2, that) => zipWith7(self2, that, (f52, a52) => f52(a52)));
var reduceCompact6 = /* @__PURE__ */ dual6(3, (self2, b52, f52) => {
  let out = b52;
  for (const oa of self2) {
    if (isSome10(oa)) {
      out = f52(out, oa.value);
    }
  }
  return out;
});
var toArray6 = (self2) => isNone10(self2) ? [] : [self2.value];
var partitionMap7 = /* @__PURE__ */ dual6(2, (self2, f52) => {
  if (isNone10(self2)) {
    return [none10(), none10()];
  }
  const e52 = f52(self2.value);
  return isLeft7(e52) ? [some15(e52.left), none10()] : [none10(), some15(e52.right)];
});
var filterMap7 = /* @__PURE__ */ dual6(2, (self2, f52) => isNone10(self2) ? none10() : f52(self2.value));
var filter7 = /* @__PURE__ */ dual6(2, (self2, predicate) => filterMap7(self2, (b52) => predicate(b52) ? some14(b52) : none9));
var getEquivalence8 = (isEquivalent) => make17((x52, y52) => x52 === y52 || (isNone10(x52) ? isNone10(y52) : isNone10(y52) ? false : isEquivalent(x52.value, y52.value)));
var getOrder7 = (O52) => make18((self2, that) => isSome10(self2) ? isSome10(that) ? O52(self2.value, that.value) : 1 : -1);
var lift26 = (f52) => dual6(2, (self2, that) => zipWith7(self2, that, f52));
var liftPredicate7 = (predicate) => (b52) => predicate(b52) ? some15(b52) : none10();
var containsWith7 = (isEquivalent) => dual6(2, (self2, a52) => isNone10(self2) ? false : isEquivalent(self2.value, a52));
var _equivalence8 = /* @__PURE__ */ equivalence6();
var contains7 = /* @__PURE__ */ containsWith7(_equivalence8);
var exists6 = /* @__PURE__ */ dual6(2, (self2, refinement) => isNone10(self2) ? false : refinement(self2.value));
var bindTo11 = /* @__PURE__ */ bindTo10(map7);
var let_11 = /* @__PURE__ */ let_10(map7);
var bind11 = /* @__PURE__ */ bind10(map7, flatMap7);
var Do7 = /* @__PURE__ */ some15({});
var adapter10 = /* @__PURE__ */ adapter9();
var gen6 = (f52) => {
  const iterator = f52(adapter10);
  let state = iterator.next();
  if (state.done) {
    return some15(state.value);
  } else {
    let current = state.value;
    if (isGenKind6(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet6(current);
    }
    if (isNone10(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind6(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet6(current);
        }
        if (isNone10(current)) {
          return current;
        }
      }
    }
    return some15(state.value);
  }
};
var Record_exports = {};
__export2(Record_exports, {
  collect: () => collect3,
  difference: () => difference3,
  empty: () => empty13,
  every: () => every8,
  filter: () => filter8,
  filterMap: () => filterMap8,
  fromEntries: () => fromEntries2,
  fromIterableBy: () => fromIterableBy,
  fromIterableWith: () => fromIterableWith,
  get: () => get5,
  getEquivalence: () => getEquivalence9,
  getLefts: () => getLefts3,
  getRights: () => getRights3,
  getSomes: () => getSomes3,
  has: () => has2,
  intersection: () => intersection3,
  isEmptyReadonlyRecord: () => isEmptyReadonlyRecord,
  isEmptyRecord: () => isEmptyRecord,
  isSubrecord: () => isSubrecord,
  isSubrecordBy: () => isSubrecordBy,
  keys: () => keys6,
  map: () => map8,
  mapEntries: () => mapEntries,
  mapKeys: () => mapKeys,
  modify: () => modify3,
  modifyOption: () => modifyOption3,
  partition: () => partition3,
  partitionMap: () => partitionMap8,
  pop: () => pop2,
  reduce: () => reduce8,
  remove: () => remove3,
  replace: () => replace3,
  replaceOption: () => replaceOption3,
  separate: () => separate3,
  set: () => set5,
  singleton: () => singleton,
  size: () => size7,
  some: () => some16,
  toEntries: () => toEntries3,
  union: () => union5,
  values: () => values
});
var empty13 = () => ({});
var isEmptyRecord = (self2) => keys6(self2).length === 0;
var isEmptyReadonlyRecord = isEmptyRecord;
var fromIterableWith = /* @__PURE__ */ dual6(2, (self2, f52) => {
  const out = empty13();
  for (const a52 of self2) {
    const [k52, b52] = f52(a52);
    out[k52] = b52;
  }
  return out;
});
var fromIterableBy = (items, f52) => fromIterableWith(items, (a52) => [f52(a52), a52]);
var fromEntries2 = Object.fromEntries;
var collect3 = /* @__PURE__ */ dual6(2, (self2, f52) => {
  const out = [];
  for (const key of keys6(self2)) {
    out.push(f52(key, self2[key]));
  }
  return out;
});
var toEntries3 = /* @__PURE__ */ collect3((key, value) => [key, value]);
var size7 = (self2) => keys6(self2).length;
var has2 = /* @__PURE__ */ dual6(2, (self2, key) => Object.prototype.hasOwnProperty.call(self2, key));
var get5 = /* @__PURE__ */ dual6(2, (self2, key) => has2(self2, key) ? some15(self2[key]) : none10());
var modify3 = /* @__PURE__ */ dual6(3, (self2, key, f52) => {
  if (!has2(self2, key)) {
    return {
      ...self2
    };
  }
  return {
    ...self2,
    [key]: f52(self2[key])
  };
});
var modifyOption3 = /* @__PURE__ */ dual6(3, (self2, key, f52) => {
  if (!has2(self2, key)) {
    return none10();
  }
  return some15({
    ...self2,
    [key]: f52(self2[key])
  });
});
var replaceOption3 = /* @__PURE__ */ dual6(3, (self2, key, b52) => modifyOption3(self2, key, () => b52));
var remove3 = /* @__PURE__ */ dual6(2, (self2, key) => {
  if (!has2(self2, key)) {
    return {
      ...self2
    };
  }
  const out = {
    ...self2
  };
  delete out[key];
  return out;
});
var pop2 = /* @__PURE__ */ dual6(2, (self2, key) => has2(self2, key) ? some15([self2[key], remove3(self2, key)]) : none10());
var map8 = /* @__PURE__ */ dual6(2, (self2, f52) => {
  const out = {
    ...self2
  };
  for (const key of keys6(self2)) {
    out[key] = f52(self2[key], key);
  }
  return out;
});
var mapKeys = /* @__PURE__ */ dual6(2, (self2, f52) => {
  const out = {};
  for (const key of keys6(self2)) {
    const a52 = self2[key];
    out[f52(key, a52)] = a52;
  }
  return out;
});
var mapEntries = /* @__PURE__ */ dual6(2, (self2, f52) => {
  const out = {};
  for (const key of keys6(self2)) {
    const [k52, b52] = f52(self2[key], key);
    out[k52] = b52;
  }
  return out;
});
var filterMap8 = /* @__PURE__ */ dual6(2, (self2, f52) => {
  const out = empty13();
  for (const key of keys6(self2)) {
    const o52 = f52(self2[key], key);
    if (isSome10(o52)) {
      out[key] = o52.value;
    }
  }
  return out;
});
var filter8 = /* @__PURE__ */ dual6(2, (self2, predicate) => {
  const out = empty13();
  for (const key of keys6(self2)) {
    if (predicate(self2[key], key)) {
      out[key] = self2[key];
    }
  }
  return out;
});
var getSomes3 = /* @__PURE__ */ filterMap8(identity6);
var getLefts3 = (self2) => {
  const out = empty13();
  for (const key of keys6(self2)) {
    const value = self2[key];
    if (isLeft8(value)) {
      out[key] = value.left;
    }
  }
  return out;
};
var getRights3 = (self2) => {
  const out = empty13();
  for (const key of keys6(self2)) {
    const value = self2[key];
    if (isRight8(value)) {
      out[key] = value.right;
    }
  }
  return out;
};
var partitionMap8 = /* @__PURE__ */ dual6(2, (self2, f52) => {
  const left94 = empty13();
  const right94 = empty13();
  for (const key of keys6(self2)) {
    const e52 = f52(self2[key], key);
    if (isLeft8(e52)) {
      left94[key] = e52.left;
    } else {
      right94[key] = e52.right;
    }
  }
  return [left94, right94];
});
var separate3 = /* @__PURE__ */ partitionMap8(identity6);
var partition3 = /* @__PURE__ */ dual6(2, (self2, predicate) => {
  const left94 = empty13();
  const right94 = empty13();
  for (const key of keys6(self2)) {
    if (predicate(self2[key], key)) {
      right94[key] = self2[key];
    } else {
      left94[key] = self2[key];
    }
  }
  return [left94, right94];
});
var keys6 = (self2) => Object.keys(self2);
var values = (self2) => collect3(self2, (_52, a52) => a52);
var set5 = /* @__PURE__ */ dual6(3, (self2, key, value) => {
  return {
    ...self2,
    [key]: value
  };
});
var replace3 = /* @__PURE__ */ dual6(3, (self2, key, value) => {
  if (has2(self2, key)) {
    return {
      ...self2,
      [key]: value
    };
  }
  return {
    ...self2
  };
});
var isSubrecordBy = (equivalence84) => dual6(2, (self2, that) => {
  for (const key of keys6(self2)) {
    if (!has2(that, key) || !equivalence84(self2[key], that[key])) {
      return false;
    }
  }
  return true;
});
var isSubrecord = /* @__PURE__ */ isSubrecordBy(/* @__PURE__ */ equivalence6());
var reduce8 = /* @__PURE__ */ dual6(3, (self2, zero, f52) => {
  let out = zero;
  for (const key of keys6(self2)) {
    out = f52(out, self2[key], key);
  }
  return out;
});
var every8 = /* @__PURE__ */ dual6(2, (self2, refinement) => {
  for (const key of keys6(self2)) {
    if (!refinement(self2[key], key)) {
      return false;
    }
  }
  return true;
});
var some16 = /* @__PURE__ */ dual6(2, (self2, predicate) => {
  for (const key of keys6(self2)) {
    if (predicate(self2[key], key)) {
      return true;
    }
  }
  return false;
});
var union5 = /* @__PURE__ */ dual6(3, (self2, that, combine94) => {
  if (isEmptyRecord(self2)) {
    return {
      ...that
    };
  }
  if (isEmptyRecord(that)) {
    return {
      ...self2
    };
  }
  const out = empty13();
  for (const key of keys6(self2)) {
    if (has2(that, key)) {
      out[key] = combine94(self2[key], that[key]);
    } else {
      out[key] = self2[key];
    }
  }
  for (const key of keys6(that)) {
    if (!has2(out, key)) {
      out[key] = that[key];
    }
  }
  return out;
});
var intersection3 = /* @__PURE__ */ dual6(3, (self2, that, combine94) => {
  const out = empty13();
  if (isEmptyRecord(self2) || isEmptyRecord(that)) {
    return out;
  }
  for (const key of keys6(self2)) {
    if (has2(that, key)) {
      out[key] = combine94(self2[key], that[key]);
    }
  }
  return out;
});
var difference3 = /* @__PURE__ */ dual6(2, (self2, that) => {
  if (isEmptyRecord(self2)) {
    return {
      ...that
    };
  }
  if (isEmptyRecord(that)) {
    return {
      ...self2
    };
  }
  const out = {};
  for (const key of keys6(self2)) {
    if (!has2(that, key)) {
      out[key] = self2[key];
    }
  }
  for (const key of keys6(that)) {
    if (!has2(self2, key)) {
      out[key] = that[key];
    }
  }
  return out;
});
var getEquivalence9 = (equivalence84) => {
  const is62 = isSubrecordBy(equivalence84);
  return (self2, that) => is62(self2, that) && is62(that, self2);
};
var singleton = (key, value) => ({
  [key]: value
});
var MutableRef_exports4 = {};
__export2(MutableRef_exports4, {
  compareAndSet: () => compareAndSet4,
  decrement: () => decrement4,
  decrementAndGet: () => decrementAndGet4,
  get: () => get6,
  getAndDecrement: () => getAndDecrement4,
  getAndIncrement: () => getAndIncrement4,
  getAndSet: () => getAndSet4,
  getAndUpdate: () => getAndUpdate4,
  increment: () => increment4,
  incrementAndGet: () => incrementAndGet4,
  make: () => make19,
  set: () => set6,
  setAndGet: () => setAndGet4,
  toggle: () => toggle4,
  update: () => update4,
  updateAndGet: () => updateAndGet4
});
var TypeId19 = /* @__PURE__ */ Symbol.for("effect/MutableRef");
var MutableRefProto4 = {
  [TypeId19]: TypeId19,
  toString() {
    return format6(this.toJSON());
  },
  toJSON() {
    return {
      _id: "MutableRef",
      current: toJSON6(this.current)
    };
  },
  [NodeInspectSymbol6]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments6(this, arguments);
  }
};
var make19 = (value) => {
  const ref = Object.create(MutableRefProto4);
  ref.current = value;
  return ref;
};
var compareAndSet4 = /* @__PURE__ */ dual6(3, (self2, oldValue, newValue) => {
  if (equals6(oldValue, self2.current)) {
    self2.current = newValue;
    return true;
  }
  return false;
});
var decrement4 = (self2) => update4(self2, (n52) => n52 - 1);
var decrementAndGet4 = (self2) => updateAndGet4(self2, (n52) => n52 - 1);
var get6 = (self2) => self2.current;
var getAndDecrement4 = (self2) => getAndUpdate4(self2, (n52) => n52 - 1);
var getAndIncrement4 = (self2) => getAndUpdate4(self2, (n52) => n52 + 1);
var getAndSet4 = /* @__PURE__ */ dual6(2, (self2, value) => {
  const ret = self2.current;
  self2.current = value;
  return ret;
});
var getAndUpdate4 = /* @__PURE__ */ dual6(2, (self2, f52) => getAndSet4(self2, f52(get6(self2))));
var increment4 = (self2) => update4(self2, (n52) => n52 + 1);
var incrementAndGet4 = (self2) => updateAndGet4(self2, (n52) => n52 + 1);
var set6 = /* @__PURE__ */ dual6(2, (self2, value) => {
  self2.current = value;
  return self2;
});
var setAndGet4 = /* @__PURE__ */ dual6(2, (self2, value) => {
  self2.current = value;
  return self2.current;
});
var update4 = /* @__PURE__ */ dual6(2, (self2, f52) => set6(self2, f52(get6(self2))));
var updateAndGet4 = /* @__PURE__ */ dual6(2, (self2, f52) => setAndGet4(self2, f52(get6(self2))));
var toggle4 = (self2) => update4(self2, (_52) => !_52);
var MutableList_exports2 = {};
__export2(MutableList_exports2, {
  append: () => append3,
  empty: () => empty14,
  forEach: () => forEach7,
  fromIterable: () => fromIterable10,
  head: () => head3,
  isEmpty: () => isEmpty5,
  length: () => length3,
  make: () => make20,
  pop: () => pop3,
  prepend: () => prepend6,
  reset: () => reset2,
  shift: () => shift2,
  tail: () => tail3
});
var TypeId20 = /* @__PURE__ */ Symbol.for("effect/MutableList");
var MutableListProto2 = {
  [TypeId20]: TypeId20,
  [Symbol.iterator]() {
    let done = false;
    let head42 = this.head;
    return {
      next() {
        if (done) {
          return this.return();
        }
        if (head42 == null) {
          done = true;
          return this.return();
        }
        const value = head42.value;
        head42 = head42.next;
        return {
          done,
          value
        };
      },
      return(value) {
        if (!done) {
          done = true;
        }
        return {
          done: true,
          value
        };
      }
    };
  },
  toString() {
    return format6(this.toJSON());
  },
  toJSON() {
    return {
      _id: "MutableList",
      values: Array.from(this).map(toJSON6)
    };
  },
  [NodeInspectSymbol6]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments6(this, arguments);
  }
};
var makeNode2 = (value) => ({
  value,
  removed: false,
  prev: void 0,
  next: void 0
});
var empty14 = () => {
  const list = Object.create(MutableListProto2);
  list.head = void 0;
  list.tail = void 0;
  list._length = 0;
  return list;
};
var fromIterable10 = (iterable) => {
  const list = empty14();
  for (const element of iterable) {
    append3(list, element);
  }
  return list;
};
var make20 = (...elements) => fromIterable10(elements);
var isEmpty5 = (self2) => length3(self2) === 0;
var length3 = (self2) => self2._length;
var tail3 = (self2) => self2.tail === void 0 ? void 0 : self2.tail.value;
var head3 = (self2) => self2.head === void 0 ? void 0 : self2.head.value;
var forEach7 = /* @__PURE__ */ dual6(2, (self2, f52) => {
  let current = self2.head;
  while (current !== void 0) {
    f52(current.value);
    current = current.next;
  }
});
var reset2 = (self2) => {
  self2._length = 0;
  self2.head = void 0;
  self2.tail = void 0;
  return self2;
};
var append3 = /* @__PURE__ */ dual6(2, (self2, value) => {
  const node = makeNode2(value);
  if (self2.head === void 0) {
    self2.head = node;
  }
  if (self2.tail === void 0) {
    self2.tail = node;
  } else {
    self2.tail.next = node;
    node.prev = self2.tail;
    self2.tail = node;
  }
  self2._length += 1;
  return self2;
});
var shift2 = (self2) => {
  const head42 = self2.head;
  if (head42 !== void 0) {
    remove4(self2, head42);
    return head42.value;
  }
  return void 0;
};
var pop3 = (self2) => {
  const tail42 = self2.tail;
  if (tail42 !== void 0) {
    remove4(self2, tail42);
    return tail42.value;
  }
  return void 0;
};
var prepend6 = /* @__PURE__ */ dual6(2, (self2, value) => {
  const node = makeNode2(value);
  node.next = self2.head;
  if (self2.head !== void 0) {
    self2.head.prev = node;
  }
  self2.head = node;
  if (self2.tail === void 0) {
    self2.tail = node;
  }
  self2._length += 1;
  return self2;
});
var remove4 = (self2, node) => {
  if (node.removed) {
    return;
  }
  node.removed = true;
  if (node.prev !== void 0 && node.next !== void 0) {
    node.prev.next = node.next;
    node.next.prev = node.prev;
  } else if (node.prev !== void 0) {
    self2.tail = node.prev;
    node.prev.next = void 0;
  } else if (node.next !== void 0) {
    self2.head = node.next;
    node.next.prev = void 0;
  } else {
    self2.tail = void 0;
    self2.head = void 0;
  }
  if (self2._length > 0) {
    self2._length -= 1;
  }
};
var RULE_NAME4 = "no-access-state-in-setstate";
function isKeyLiteralLike(node, property) {
  return property.type === NodeType3.Literal || property.type === NodeType3.TemplateLiteral && property.expressions.length === 0 || !node.computed && property.type === NodeType3.Identifier;
}
function isThisSetState(node) {
  const { callee } = node;
  return callee.type === NodeType3.MemberExpression && isThisExpression(callee.object) && callee.property.type === NodeType3.Identifier && callee.property.name === "setState";
}
function getName(node) {
  if (node.type === NodeType3.TSAsExpression) {
    return getName(node.expression);
  }
  if (node.type === NodeType3.Identifier || node.type === NodeType3.PrivateIdentifier) {
    return Option_exports6.some(node.name);
  }
  if (node.type === NodeType3.Literal) {
    return Option_exports6.some(String(node.value));
  }
  if (node.type === NodeType3.TemplateLiteral && node.expressions.length === 0) {
    return Option_exports6.fromNullable(node.quasis[0]?.value.raw);
  }
  return Option_exports6.none();
}
var no_access_state_in_setstate_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow accessing 'this.state' within 'setState'",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_ACCESS_STATE_IN_SETSTATE: "Do not access 'this.state' within 'setState'. Use 'setState' callback instead."
    },
    schema: []
  },
  name: RULE_NAME4,
  create(context) {
    const classStack = MutableList_exports2.make();
    const methodStack = MutableList_exports2.make();
    const setStateStack = MutableList_exports2.make();
    return {
      CallExpression(node) {
        if (!isThisSetState(node)) return;
        MutableList_exports2.append(setStateStack, [node, false]);
      },
      "CallExpression:exit"(node) {
        if (!isThisSetState(node)) return;
        MutableList_exports2.pop(setStateStack);
      },
      ClassDeclaration(node) {
        MutableList_exports2.append(classStack, [node, isClassComponent(node)]);
      },
      "ClassDeclaration:exit"() {
        MutableList_exports2.pop(classStack);
      },
      ClassExpression(node) {
        MutableList_exports2.append(classStack, [node, isClassComponent(node)]);
      },
      "ClassExpression:exit"() {
        MutableList_exports2.pop(classStack);
      },
      MemberExpression(node) {
        if (!isThisExpression(node.object)) return;
        const [currentClass, isComponent] = MutableList_exports2.tail(classStack) ?? [];
        if (!currentClass || !isComponent) return;
        const [currentMethod, isStatic] = MutableList_exports2.tail(methodStack) ?? [];
        if (!currentMethod || isStatic) return;
        const [setState, hasThisState] = MutableList_exports2.tail(setStateStack) ?? [];
        if (!setState || hasThisState) return;
        if (!Option_exports6.exists(getName(node.property), (name22) => name22 === "state")) return;
        context.report({ messageId: "NO_ACCESS_STATE_IN_SETSTATE", node });
      },
      MethodDefinition(node) {
        MutableList_exports2.append(methodStack, [node, node.static]);
      },
      "MethodDefinition:exit"() {
        MutableList_exports2.pop(methodStack);
      },
      PropertyDefinition(node) {
        MutableList_exports2.append(methodStack, [node, node.static]);
      },
      "PropertyDefinition:exit"() {
        MutableList_exports2.pop(methodStack);
      },
      VariableDeclarator(node) {
        const [currentClass, isComponent] = MutableList_exports2.tail(classStack) ?? [];
        if (!currentClass || !isComponent) return;
        const [currentMethod, isStatic] = MutableList_exports2.tail(methodStack) ?? [];
        if (!currentMethod || isStatic) return;
        const [setState, hasThisState] = MutableList_exports2.tail(setStateStack) ?? [];
        if (!setState || hasThisState) return;
        if (!(node.init && isThisExpression(node.init) && node.id.type === NodeType3.ObjectPattern)) return;
        const hasState = node.id.properties.some((prop) => {
          if (prop.type === NodeType3.Property && isKeyLiteralLike(prop, prop.key)) {
            return Option_exports6.exists(getName(prop.key), (name22) => name22 === "state");
          }
          return false;
        });
        if (!hasState) return;
        context.report({ messageId: "NO_ACCESS_STATE_IN_SETSTATE", node });
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME5 = "no-array-index-key";
var reactChildrenMethod = ["forEach", "map"];
function isReactChildrenMethod(name22) {
  return reactChildrenMethod.some((method) => method === name22);
}
var iteratorFunctionIndexParamPosition = {
  every: 1,
  filter: 1,
  find: 1,
  findIndex: 1,
  findLast: 1,
  findLastIndex: 1,
  flatMap: 1,
  forEach: 1,
  map: 1,
  reduce: 2,
  reduceRight: 2,
  some: 1
};
function isUsingReactChildren(node, context) {
  const { callee } = node;
  if (!("property" in callee) || !("object" in callee) || !("name" in callee.property)) {
    return false;
  }
  if (!isReactChildrenMethod(callee.property.name)) return false;
  const initialScope = context.sourceCode.getScope(node);
  return $(callee.object).with({ type: NodeType3.Identifier, name: "Children" }, () => true).with(
    { type: NodeType3.MemberExpression, object: { type: NodeType3.Identifier, name: N.string } },
    ({ object: object32 }) => isInitializedFromReact(object32.name, context, initialScope)
  ).otherwise(() => false);
}
function getMapIndexParamName(node, context) {
  const { callee } = node;
  if (callee.type !== NodeType3.MemberExpression) return Option_exports6.none();
  if (callee.property.type !== NodeType3.Identifier) return Option_exports6.none();
  const { name: name22 } = callee.property;
  if (!Record_exports.has(iteratorFunctionIndexParamPosition, name22)) return Option_exports6.none();
  const callbackArg = node.arguments[isUsingReactChildren(node, context) ? 1 : 0];
  if (!callbackArg) return Option_exports6.none();
  if (!isOneOf3([NodeType3.ArrowFunctionExpression, NodeType3.FunctionExpression])(callbackArg)) return Option_exports6.none();
  const { params } = callbackArg;
  const maybeIndexParamPosition = Record_exports.get(iteratorFunctionIndexParamPosition, name22);
  if (Option_exports6.isNone(maybeIndexParamPosition)) return Option_exports6.none();
  const indexParamPosition = maybeIndexParamPosition.value;
  if (params.length < indexParamPosition + 1) return Option_exports6.none();
  const param = params.at(indexParamPosition);
  return param && "name" in param ? Option_exports6.some(param.name) : Option_exports6.none();
}
function getIdentifiersFromBinaryExpression(side) {
  if (side.type === NodeType3.Identifier) return [side];
  if (side.type === NodeType3.BinaryExpression) {
    return [
      ...getIdentifiersFromBinaryExpression(side.left),
      ...getIdentifiersFromBinaryExpression(side.right)
    ].filter(Boolean);
  }
  return [];
}
var no_array_index_key_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow using Array index as key",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_ARRAY_INDEX_KEY: "Do not use Array index as key."
    },
    schema: []
  },
  name: RULE_NAME5,
  create(context) {
    const indexParamNames = [];
    function pushIndexParamName(node) {
      Option_exports6.map(getMapIndexParamName(node, context), (name22) => indexParamNames.push(name22));
    }
    function popIndexParamName(node) {
      Option_exports6.map(getMapIndexParamName(node, context), () => indexParamNames.pop());
    }
    function isArrayIndex(node) {
      return node.type === NodeType3.Identifier && indexParamNames.some((name22) => name22 === node.name);
    }
    function checkPropValue(node) {
      if (isArrayIndex(node)) {
        return [{ messageId: "NO_ARRAY_INDEX_KEY", node }];
      }
      if (isOneOf3([NodeType3.TemplateLiteral, NodeType3.BinaryExpression])(node)) {
        const exps = NodeType3.TemplateLiteral === node.type ? node.expressions : getIdentifiersFromBinaryExpression(node);
        return exps.reduce((acc, exp) => {
          if (isArrayIndex(exp)) return [...acc, { messageId: "NO_ARRAY_INDEX_KEY", node: exp }];
          return acc;
        }, []);
      }
      const isToStringCall = a({
        type: NodeType3.CallExpression,
        callee: {
          type: NodeType3.MemberExpression,
          property: {
            type: NodeType3.Identifier,
            name: "toString"
          }
        }
      }, node);
      if (isToStringCall) {
        if (!("object" in node.callee && isArrayIndex(node.callee.object))) return [];
        return [{ messageId: "NO_ARRAY_INDEX_KEY", node: node.callee.object }];
      }
      const isStringCall = a({
        type: NodeType3.CallExpression,
        callee: {
          type: NodeType3.Identifier,
          name: "String"
        }
      }, node);
      if (isStringCall) {
        const [arg] = node.arguments;
        if (arg && isArrayIndex(arg)) return [{ messageId: "NO_ARRAY_INDEX_KEY", node: arg }];
      }
      return [];
    }
    return {
      CallExpression(node) {
        if ((isCreateElementCall(node, context) || isCloneElementCall(node, context)) && node.arguments.length > 1) {
          if (indexParamNames.length === 0) return;
          const props = node.arguments[1];
          if (props?.type !== NodeType3.ObjectExpression) return;
          for (const prop of props.properties) {
            if (!a({ key: { name: "key" } }, prop)) continue;
            if (!("value" in prop)) continue;
            const descriptors = checkPropValue(prop.value);
            for (const descriptor of descriptors) {
              context.report(descriptor);
            }
          }
        }
        pushIndexParamName(node);
      },
      "CallExpression:exit": popIndexParamName,
      JSXAttribute(node) {
        if (node.name.name !== "key") return;
        if (indexParamNames.length === 0) return;
        const { value } = node;
        if (value?.type !== NodeType3.JSXExpressionContainer) return;
        const descriptors = checkPropValue(value.expression);
        for (const descriptor of descriptors) {
          context.report(descriptor);
        }
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME6 = "no-children-count";
var no_children_count_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow 'Children.count'",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_CHILDREN_COUNT: "Using 'Children.count' is uncommon and can lead to fragile code. Use alternatives instead."
    },
    schema: []
  },
  name: RULE_NAME6,
  create(context) {
    return {
      MemberExpression(node) {
        if (isChildrenCount(node, context)) {
          context.report({
            messageId: "NO_CHILDREN_COUNT",
            node: node.property
          });
        }
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME7 = "no-children-for-each";
var no_children_for_each_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow 'Children.forEach'",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_CHILDREN_FOR_EACH: "Using 'Children.forEach' is uncommon and can lead to fragile code. Use alternatives instead."
    },
    schema: []
  },
  name: RULE_NAME7,
  create(context) {
    return {
      MemberExpression(node) {
        if (isChildrenForEach(node, context)) {
          context.report({
            messageId: "NO_CHILDREN_FOR_EACH",
            node: node.property
          });
        }
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME8 = "no-children-map";
var no_children_map_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow 'Children.map'",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_CHILDREN_MAP: "Using 'Children.map' is uncommon and can lead to fragile code. Use alternatives instead."
    },
    schema: []
  },
  name: RULE_NAME8,
  create(context) {
    return {
      MemberExpression(node) {
        if (isChildrenMap(node, context)) {
          context.report({
            messageId: "NO_CHILDREN_MAP",
            node: node.property
          });
        }
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME9 = "no-children-only";
var no_children_only_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow 'Children.only'",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_CHILDREN_ONLY: "Using 'Children.only' is uncommon and can lead to fragile code. Use alternatives instead."
    },
    schema: []
  },
  name: RULE_NAME9,
  create(context) {
    return {
      MemberExpression(node) {
        if (isChildrenOnly(node, context)) {
          context.report({
            messageId: "NO_CHILDREN_ONLY",
            node: node.property
          });
        }
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME10 = "no-children-prop";
var no_children_prop_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow passing of 'children' as props",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_CHILDREN_PROP: "Do not pass children as props."
    },
    schema: []
  },
  name: RULE_NAME10,
  create(context) {
    return {
      CallExpression(node) {
        if (node.arguments.length === 0) return;
        const initialScope = context.sourceCode.getScope(node);
        if (!isCreateElementCall(node, context)) return;
        const [_52, props] = node.arguments;
        if (!props || props.type !== NodeType3.ObjectExpression) return;
        Option_exports6.map(findPropInProperties(props.properties, context, initialScope)("children"), (prop) => {
          context.report({
            messageId: "NO_CHILDREN_PROP",
            node: prop
          });
        });
      },
      JSXElement(node) {
        const initialScope = context.sourceCode.getScope(node);
        Option_exports6.map(getProp(node.openingElement.attributes, "children", context, initialScope), (prop) => {
          context.report({
            messageId: "NO_CHILDREN_PROP",
            node: prop
          });
        });
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME11 = "no-children-to-array";
var no_children_to_array_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow 'Children.toArray'",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_CHILDREN_TO_ARRAY: "Using 'Children.toArray' is uncommon and can lead to fragile code. Use alternatives instead."
    },
    schema: []
  },
  name: RULE_NAME11,
  create(context) {
    return {
      MemberExpression(node) {
        if (isChildrenToArray(node, context)) {
          context.report({
            messageId: "NO_CHILDREN_TO_ARRAY",
            node: node.property
          });
        }
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME12 = "no-class-component";
var isComponentDidCatch = a({
  key: {
    type: NodeType3.Identifier,
    name: "componentDidCatch"
  },
  type: N.union(NodeType3.MethodDefinition, NodeType3.PropertyDefinition),
  static: false
});
var isGetDerivedStateFromError = a({
  key: {
    type: NodeType3.Identifier,
    name: "getDerivedStateFromError"
  },
  type: N.union(NodeType3.MethodDefinition, NodeType3.PropertyDefinition),
  static: true
});
var no_class_component_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow class component"
    },
    messages: {
      NO_CLASS_COMPONENT: "Do not use class components. Use function components instead."
    },
    schema: []
  },
  name: RULE_NAME12,
  create(context) {
    const { ctx, listeners } = useComponentCollectorLegacy();
    return {
      ...listeners,
      "Program:exit"(node) {
        const components = ctx.getAllComponents(node);
        for (const { name: name22, node: component } of components.values()) {
          if (component.body.body.some((m52) => isComponentDidCatch(m52) || isGetDerivedStateFromError(m52))) continue;
          context.report({
            data: {
              name: Option_exports6.getOrElse(Function_exports6.constant("anonymous"))(name22)
            },
            messageId: "NO_CLASS_COMPONENT",
            node: component
          });
        }
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME13 = "no-clone-element";
var no_clone_element_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow 'cloneElement'",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_CLONE_ELEMENT: "Using 'cloneElement' is uncommon and can lead to fragile code. Use alternatives instead."
    },
    schema: []
  },
  name: RULE_NAME13,
  create(context) {
    return {
      CallExpression(node) {
        if (!isCloneElementCall(node, context)) return;
        context.report({
          messageId: "NO_CLONE_ELEMENT",
          node
        });
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME14 = "no-comment-textnodes";
var no_comment_textnodes_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow comments from being inserted as text nodes",
      requiresTypeChecking: false
    },
    messages: {
      NO_COMMENT_TEXTNODES: "Possible misused comment in text node. Comments inside children section of tag should be placed inside braces."
    },
    schema: []
  },
  name: RULE_NAME14,
  create(context) {
    function checkText(node) {
      if (isOneOf3([types.AST_NODE_TYPES.JSXAttribute, types.AST_NODE_TYPES.JSXExpressionContainer])(node.parent)) return false;
      const rawValue = context.sourceCode.getText(node);
      return /^\s*\/(\/|\*)/mu.test(rawValue) && node.parent.type.includes("JSX");
    }
    const check = (node) => {
      if (!isOneOf3([types.AST_NODE_TYPES.JSXElement, types.AST_NODE_TYPES.JSXFragment])(node.parent)) return;
      if (!checkText(node)) return;
      context.report({
        messageId: "NO_COMMENT_TEXTNODES",
        node
      });
    };
    return {
      JSXText: check,
      Literal: check
    };
  },
  defaultOptions: []
});
var RULE_NAME15 = "no-complicated-conditional-rendering";
var no_complicated_conditional_rendering_default = createRule({
  meta: {
    type: "problem",
    deprecated: true,
    docs: {
      description: "disallow complicated conditional rendering",
      requiresTypeChecking: true
    },
    messages: {
      NO_COMPLICATED_CONDITIONAL_RENDERING: "Avoid complicated conditional rendering. Extract the logic into separate elements or components."
    },
    schema: []
  },
  name: RULE_NAME15,
  create(context) {
    function check(node) {
      const jsxExpContainer = node.parent?.parent;
      if (!is3(NodeType3.JSXExpressionContainer)(jsxExpContainer)) return;
      if (!isOneOf3([NodeType3.JSXElement, NodeType3.JSXFragment])(jsxExpContainer.parent)) return;
      if (!jsxExpContainer.parent.children.includes(jsxExpContainer)) return;
      context.report({ messageId: "NO_COMPLICATED_CONDITIONAL_RENDERING", node: jsxExpContainer });
    }
    return {
      "JSXExpressionContainer > ConditionalExpression > ConditionalExpression": check,
      "JSXExpressionContainer > ConditionalExpression > LogicalExpression": check,
      "JSXExpressionContainer > LogicalExpression > ConditionalExpression": check,
      "JSXExpressionContainer > LogicalExpression[operator='&&'] > LogicalExpression[operator='||']": check,
      "JSXExpressionContainer > LogicalExpression[operator='||'] > LogicalExpression[operator='&&']": check
    };
  },
  defaultOptions: []
});
var RULE_NAME16 = "no-component-will-mount";
function isComponentWillMount(node) {
  return isOneOf3([NodeType3.MethodDefinition, NodeType3.PropertyDefinition])(node) && node.key.type === NodeType3.Identifier && node.key.name === "componentWillMount";
}
var no_component_will_mount_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow usage of 'componentWillMount'",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_COMPONENT_WILL_MOUNT: "[Deprecated] Use 'UNSAFE_componentWillMount' instead."
    },
    schema: []
  },
  name: RULE_NAME16,
  create(context) {
    const { ctx, listeners } = useComponentCollectorLegacy();
    return {
      ...listeners,
      "Program:exit"(node) {
        const components = ctx.getAllComponents(node);
        for (const { node: component } of components.values()) {
          const { body } = component.body;
          for (const member of body) {
            if (isComponentWillMount(member)) {
              context.report({
                messageId: "NO_COMPONENT_WILL_MOUNT",
                node: member
              });
            }
          }
        }
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME17 = "no-component-will-receive-props";
function isComponentWillUpdate(node) {
  return isOneOf3([NodeType3.MethodDefinition, NodeType3.PropertyDefinition])(node) && node.key.type === NodeType3.Identifier && node.key.name === "componentWillReceiveProps";
}
var no_component_will_receive_props_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow usage of 'componentWillReceiveProps'",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_COMPONENT_WILL_RECEIVE_PROPS: "[Deprecated] Use 'UNSAFE_componentWillReceiveProps' instead."
    },
    schema: []
  },
  name: RULE_NAME17,
  create(context) {
    const { ctx, listeners } = useComponentCollectorLegacy();
    return {
      ...listeners,
      "Program:exit"(node) {
        const components = ctx.getAllComponents(node);
        for (const { node: component } of components.values()) {
          const { body } = component.body;
          for (const member of body) {
            if (isComponentWillUpdate(member)) {
              context.report({
                messageId: "NO_COMPONENT_WILL_RECEIVE_PROPS",
                node: member
              });
            }
          }
        }
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME18 = "no-component-will-update";
function isComponentWillUpdate2(node) {
  return isOneOf3([NodeType3.MethodDefinition, NodeType3.PropertyDefinition])(node) && node.key.type === NodeType3.Identifier && node.key.name === "componentWillUpdate";
}
var no_component_will_update_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow usage of 'componentWillUpdate'",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_COMPONENT_WILL_UPDATE: "[Deprecated] Use 'UNSAFE_componentWillUpdate' instead."
    },
    schema: []
  },
  name: RULE_NAME18,
  create(context) {
    const { ctx, listeners } = useComponentCollectorLegacy();
    return {
      ...listeners,
      "Program:exit"(node) {
        const components = ctx.getAllComponents(node);
        for (const { node: component } of components.values()) {
          const { body } = component.body;
          for (const member of body) {
            if (isComponentWillUpdate2(member)) {
              context.report({
                messageId: "NO_COMPONENT_WILL_UPDATE",
                node: member
              });
            }
          }
        }
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME19 = "no-create-ref";
var no_create_ref_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow 'createRef' in function components",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_CREATE_REF: "A 'createRef' is not allowed in function components. Use 'useRef' instead."
    },
    schema: []
  },
  name: RULE_NAME19,
  create(context) {
    const { ctx, listeners } = useComponentCollector(context);
    const possibleCreateRefCalls = /* @__PURE__ */ new Map();
    return {
      ...listeners,
      CallExpression(node) {
        if (!isCreateRefCall(node, context)) return;
        Option_exports6.map(
          ctx.getCurrentFunction(),
          ([currentFn]) => possibleCreateRefCalls.set(currentFn, [...possibleCreateRefCalls.get(currentFn) ?? [], node])
        );
      },
      "Program:exit"(node) {
        const components = Array.from(ctx.getAllComponents(node).values());
        for (const { node: component } of components) {
          const createRefCalls = possibleCreateRefCalls.get(component);
          if (!createRefCalls) continue;
          for (const createRefCall of createRefCalls) {
            context.report({
              messageId: "NO_CREATE_REF",
              node: createRefCall
            });
          }
        }
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME20 = "no-direct-mutation-state";
function getName2(node) {
  if (node.type === NodeType3.TSAsExpression) {
    return getName2(node.expression);
  }
  if (node.type === NodeType3.Identifier || node.type === NodeType3.PrivateIdentifier) {
    return Option_exports6.some(node.name);
  }
  if (node.type === NodeType3.Literal) {
    return Option_exports6.some(String(node.value));
  }
  if (node.type === NodeType3.TemplateLiteral && node.expressions.length === 0) {
    return Option_exports6.fromNullable(node.quasis[0]?.value.raw);
  }
  return Option_exports6.none();
}
function isAssignmentToThisState(node) {
  const { left: left94 } = node;
  return left94.type === NodeType3.MemberExpression && isThisExpression(left94.object) && Option_exports6.exists(getName2(left94.property), (name22) => name22 === "state");
}
function isConstructorFunction(node) {
  return isOneOf3([NodeType3.FunctionDeclaration, NodeType3.FunctionExpression])(node) && isOneOf3([NodeType3.MethodDefinition, NodeType3.PropertyDefinition])(node.parent) && node.parent.key.type === NodeType3.Identifier && node.parent.key.name === "constructor" && node.parent.parent.type === NodeType3.ClassBody;
}
var no_direct_mutation_state_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow direct mutation of state",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_DIRECT_MUTATION_STATE: "Do not mutate state directly. Use 'setState()' instead."
    },
    schema: []
  },
  name: RULE_NAME20,
  create(context) {
    return {
      AssignmentExpression(node) {
        if (!isAssignmentToThisState(node)) return;
        const maybeParentClass = traverseUpGuard3(node, isOneOf3([NodeType3.ClassDeclaration, NodeType3.ClassExpression]));
        if (Option_exports6.isNone(maybeParentClass)) return;
        const parentClass = maybeParentClass.value;
        if (!isClassComponent(parentClass)) return;
        const maybeParentConstructor = traverseUpGuard3(node, isConstructorFunction);
        if (Option_exports6.exists(maybeParentConstructor, (n52) => context.sourceCode.getScope(node).block === n52)) return;
        context.report({
          messageId: "NO_DIRECT_MUTATION_STATE",
          node
        });
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME21 = "no-duplicate-key";
var no_duplicate_key_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow duplicate keys in 'key' prop when rendering list",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_DUPLICATE_KEY: "A key must be unique. '{{value}}' is duplicated."
    },
    schema: []
  },
  name: RULE_NAME21,
  create(context) {
    const childrenToArraySelector = getChildrenToArraySelector();
    const isWithinChildrenToArrayRef = MutableRef_exports4.make(false);
    function checkIteratorElement(node) {
      if (node.type !== NodeType3.JSXElement) return Option_exports6.none();
      const initialScope = context.sourceCode.getScope(node);
      return Function_exports6.pipe(
        findPropInAttributes(node.openingElement.attributes, context, initialScope)("key"),
        Option_exports6.flatMap((k52) => "value" in k52 ? Option_exports6.fromNullable(k52.value) : Option_exports6.none()),
        Option_exports6.flatMap((v52) => {
          return isNodeEqual(v52, v52) ? Option_exports6.some({
            data: {
              value: context.sourceCode.getText(v52)
            },
            messageId: "NO_DUPLICATE_KEY",
            node: v52
          }) : Option_exports6.none();
        })
      );
    }
    function checkExpression(node) {
      return $(node).with({ type: NodeType3.JSXElement }, checkIteratorElement).with({ type: NodeType3.JSXFragment }, checkIteratorElement).with({ type: NodeType3.ConditionalExpression }, (n52) => {
        if (!("consequent" in n52)) return Option_exports6.none();
        return Option_exports6.orElse(checkIteratorElement(n52.consequent), () => checkIteratorElement(n52.alternate));
      }).with({ type: NodeType3.LogicalExpression }, (n52) => {
        if (!("left" in n52)) return Option_exports6.none();
        return Option_exports6.orElse(checkIteratorElement(n52.left), () => checkIteratorElement(n52.right));
      }).otherwise(Option_exports6.none);
    }
    function checkBlockStatement(node) {
      return getNestedReturnStatements(node).reduce((acc, statement) => {
        if (!statement.argument) return acc;
        const maybeDescriptor = checkIteratorElement(statement.argument);
        if (Option_exports6.isNone(maybeDescriptor)) return acc;
        const descriptor = maybeDescriptor.value;
        return [...acc, descriptor];
      }, []);
    }
    const seen = /* @__PURE__ */ new WeakSet();
    return {
      [`${childrenToArraySelector}:exit`]() {
        MutableRef_exports4.set(isWithinChildrenToArrayRef, false);
      },
      "ArrayExpression, JSXElement > JSXElement"(node) {
        if (MutableRef_exports4.get(isWithinChildrenToArrayRef)) return;
        const elements = $(node).with({ type: NodeType3.ArrayExpression }, ({ elements: elements2 }) => elements2).with({ type: NodeType3.JSXElement }, ({ parent }) => "children" in parent ? parent.children : []).otherwise(() => []).filter(is3(NodeType3.JSXElement)).filter((element) => !seen.has(element));
        const keys82 = elements.reduce(
          (acc, element) => {
            const attr = element.openingElement.attributes.findLast(a({
              type: NodeType3.JSXAttribute,
              name: {
                name: "key"
              }
            }));
            if (!attr || !("value" in attr) || attr.value === null) return acc;
            const { value } = attr;
            if (acc.length === 0) return [[element, attr, value]];
            if (acc.some(([_52, _1, v52]) => isNodeEqual(v52, value))) {
              return [...acc, [element, attr, value]];
            }
            return acc;
          },
          []
        );
        if (keys82.length < 2) return;
        for (const [element, attr, value] of keys82) {
          seen.add(element);
          context.report({
            data: {
              value: context.sourceCode.getText(value)
            },
            messageId: "NO_DUPLICATE_KEY",
            node: attr
          });
        }
      },
      CallExpression(node) {
        const isMapCall22 = a({
          callee: {
            type: NodeType3.MemberExpression,
            property: {
              name: "map"
            }
          }
        }, node);
        const isArrayFromCall = a({
          type: NodeType3.CallExpression,
          callee: {
            type: NodeType3.MemberExpression,
            property: {
              name: "from"
            }
          }
        }, node);
        if (!isMapCall22 && !isArrayFromCall) return;
        if (MutableRef_exports4.get(isWithinChildrenToArrayRef)) return;
        const fn = node.arguments[isMapCall22 ? 0 : 1];
        if (!isOneOf3([NodeType3.ArrowFunctionExpression, NodeType3.FunctionExpression])(fn)) return;
        if (fn.body.type === NodeType3.BlockStatement) {
          for (const descriptor of checkBlockStatement(fn.body)) {
            context.report(descriptor);
          }
          return;
        }
        Option_exports6.map(checkExpression(fn.body), context.report);
      },
      [childrenToArraySelector]() {
        MutableRef_exports4.set(isWithinChildrenToArrayRef, true);
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME22 = "no-implicit-key";
var no_implicit_key_default = createRule({
  meta: {
    type: "problem",
    deprecated: true,
    docs: {
      description: "disallow spreading 'key' from objects.",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_IMPLICIT_KEY: "Prefer specifying key explicitly instead of spreading it from object."
    },
    schema: []
  },
  name: RULE_NAME22,
  create(context) {
    function check(node) {
      const initialScope = context.sourceCode.getScope(node);
      return Function_exports6.pipe(
        findPropInAttributes(node.attributes, context, initialScope)("key"),
        Option_exports6.filter(is3(NodeType3.JSXSpreadAttribute)),
        Option_exports6.map((key) => ({
          messageId: "NO_IMPLICIT_KEY",
          node: key
        }))
      );
    }
    return {
      JSXOpeningElement: Function_exports6.flow(check, Option_exports6.map(context.report))
    };
  },
  defaultOptions: []
});
var __defProp6 = Object.defineProperty;
var __export6 = (target, all334) => {
  for (var name22 in all334)
    __defProp6(target, name22, { get: all334[name22], enumerable: true });
};
var Function_exports7 = {};
__export6(Function_exports7, {
  SK: () => SK7,
  absurd: () => absurd7,
  apply: () => apply7,
  compose: () => compose11,
  constFalse: () => constFalse7,
  constNull: () => constNull7,
  constTrue: () => constTrue7,
  constUndefined: () => constUndefined7,
  constVoid: () => constVoid7,
  constant: () => constant7,
  dual: () => dual7,
  flip: () => flip7,
  flow: () => flow7,
  hole: () => hole7,
  identity: () => identity7,
  isFunction: () => isFunction12,
  pipe: () => pipe7,
  satisfies: () => satisfies7,
  tupled: () => tupled7,
  unsafeCoerce: () => unsafeCoerce7,
  untupled: () => untupled7
});
var isFunction12 = (input) => typeof input === "function";
var dual7 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a232, b232) {
        if (arguments.length >= 2) {
          return body(a232, b232);
        }
        return function(self2) {
          return body(self2, a232);
        };
      };
    case 3:
      return function(a232, b232, c232) {
        if (arguments.length >= 3) {
          return body(a232, b232, c232);
        }
        return function(self2) {
          return body(self2, a232, b232);
        };
      };
    case 4:
      return function(a232, b232, c232, d232) {
        if (arguments.length >= 4) {
          return body(a232, b232, c232, d232);
        }
        return function(self2) {
          return body(self2, a232, b232, c232);
        };
      };
    case 5:
      return function(a232, b232, c232, d232, e232) {
        if (arguments.length >= 5) {
          return body(a232, b232, c232, d232, e232);
        }
        return function(self2) {
          return body(self2, a232, b232, c232, d232);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply7 = (a232) => (self2) => self2(a232);
var identity7 = (a232) => a232;
var satisfies7 = () => (b232) => b232;
var unsafeCoerce7 = identity7;
var constant7 = (value) => () => value;
var constTrue7 = /* @__PURE__ */ constant7(true);
var constFalse7 = /* @__PURE__ */ constant7(false);
var constNull7 = /* @__PURE__ */ constant7(null);
var constUndefined7 = /* @__PURE__ */ constant7(void 0);
var constVoid7 = constUndefined7;
var flip7 = (f232) => (...b232) => (...a232) => f232(...a232)(...b232);
var compose11 = /* @__PURE__ */ dual7(2, (ab, bc) => (a232) => bc(ab(a232)));
var absurd7 = (_232) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled7 = (f232) => (a232) => f232(...a232);
var untupled7 = (f232) => (...a232) => f232(a232);
function pipe7(a232, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a232;
    case 2:
      return ab(a232);
    case 3:
      return bc(ab(a232));
    case 4:
      return cd(bc(ab(a232)));
    case 5:
      return de(cd(bc(ab(a232))));
    case 6:
      return ef(de(cd(bc(ab(a232)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a232))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a232)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a232))))))));
    default: {
      let ret = arguments[0];
      for (let i232 = 1; i232 < arguments.length; i232++) {
        ret = arguments[i232](ret);
      }
      return ret;
    }
  }
}
function flow7(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole7 = /* @__PURE__ */ unsafeCoerce7(absurd7);
var SK7 = (_232, b232) => b232;
var make21 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_12 = (map332) => dual7(3, (self2, name22, f232) => map332(self2, (a232) => Object.assign({}, a232, {
  [name22]: f232(a232)
})));
var bindTo12 = (map332) => dual7(2, (self2, name22) => map332(self2, (a232) => ({
  [name22]: a232
})));
var bind12 = (map332, flatMap332) => dual7(3, (self2, name22, f232) => flatMap332(self2, (a232) => map332(f232(a232), (b232) => Object.assign({}, a232, {
  [name22]: b232
}))));
var moduleVersion7 = "3.2.8";
var getCurrentVersion7 = () => moduleVersion7;
var globalStoreId7 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion7()}`);
if (!(globalStoreId7 in globalThis)) {
  globalThis[globalStoreId7] = /* @__PURE__ */ new Map();
}
var globalStore7 = globalThis[globalStoreId7];
var globalValue7 = (id, compute) => {
  if (!globalStore7.has(id)) {
    globalStore7.set(id, compute());
  }
  return globalStore7.get(id);
};
var isFunction25 = isFunction12;
var isRecordOrArray7 = (input) => typeof input === "object" && input !== null;
var isObject7 = (input) => isRecordOrArray7(input) || isFunction25(input);
var hasProperty7 = /* @__PURE__ */ dual7(2, (self2, property) => isObject7(self2) && property in self2);
var isNullable7 = (input) => input === null || input === void 0;
var getBugErrorMessage7 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId7 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind7 = (u232) => isObject7(u232) && GenKindTypeId7 in u232;
var GenKindImpl7 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity7;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId7] = GenKindTypeId7;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen8(this);
  }
};
var SingleShotGen8 = class _SingleShotGen34 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a232) {
    return this.called ? {
      value: a232,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a232) {
    return {
      value: a232,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e232) {
    throw e232;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen34(this.self);
  }
};
var adapter11 = () => function() {
  let x232 = arguments[0];
  for (let i232 = 1; i232 < arguments.length; i232++) {
    x232 = arguments[i232](x232);
  }
  return new GenKindImpl7(x232);
};
var defaultIncHi7 = 335903614;
var defaultIncLo7 = 4150755663;
var MUL_HI7 = 1481765933 >>> 0;
var MUL_LO7 = 1284865837 >>> 0;
var BIT_537 = 9007199254740992;
var BIT_277 = 134217728;
var PCGRandom7 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable7(seedLo) && isNullable7(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable7(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable7(incLo) && isNullable7(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo7;
      incHi = this._state ? this._state[2] : defaultIncHi7;
    } else if (isNullable7(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add647(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max42) {
    if (!max42) {
      return this._next();
    }
    max42 = max42 >>> 0;
    if ((max42 & max42 - 1) === 0) {
      return this._next() & max42 - 1;
    }
    let num = 0;
    const skew = (-max42 >>> 0) % max42 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max42;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_277 + lo) / BIT_537;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul647(this._state, oldHi, oldLo, MUL_HI7, MUL_LO7);
    add647(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul647(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add647(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId7 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap7 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId7]() {
    return this.#value;
  }
};
function yieldWrapGet7(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId7 in self2) {
    return self2[YieldWrapTypeId7]();
  }
  throw new Error(getBugErrorMessage7("yieldWrapGet"));
}
var structuralRegionState7 = /* @__PURE__ */ globalValue7("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache7 = /* @__PURE__ */ globalValue7(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr7 = /* @__PURE__ */ globalValue7(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom7());
var symbol11 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash7 = (self2) => {
  if (structuralRegionState7.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number8(self2);
    case "bigint":
      return string8(self2.toString(10));
    case "boolean":
      return string8(String(self2));
    case "symbol":
      return string8(String(self2));
    case "string":
      return string8(self2);
    case "undefined":
      return string8("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string8("null");
      } else if (self2 instanceof Date) {
        return hash7(self2.toISOString());
      } else if (isHash7(self2)) {
        return self2[symbol11]();
      } else {
        return random7(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random7 = (self2) => {
  if (!randomHashCache7.has(self2)) {
    randomHashCache7.set(self2, number8(pcgr7.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache7.get(self2);
};
var combine8 = (b232) => (self2) => self2 * 53 ^ b232;
var optimize7 = (n232) => n232 & 3221225471 | n232 >>> 1 & 1073741824;
var isHash7 = (u232) => hasProperty7(u232, symbol11);
var number8 = (n232) => {
  if (n232 !== n232 || n232 === Infinity) {
    return 0;
  }
  let h232 = n232 | 0;
  if (h232 !== n232) {
    h232 ^= n232 * 4294967295;
  }
  while (n232 > 4294967295) {
    h232 ^= n232 /= 4294967295;
  }
  return optimize7(n232);
};
var string8 = (str) => {
  let h232 = 5381, i232 = str.length;
  while (i232) {
    h232 = h232 * 33 ^ str.charCodeAt(--i232);
  }
  return optimize7(h232);
};
var cached7 = function() {
  if (arguments.length === 1) {
    const self3 = arguments[0];
    return function(hash432) {
      Object.defineProperty(self3, symbol11, {
        value() {
          return hash432;
        },
        enumerable: false
      });
      return hash432;
    };
  }
  const self2 = arguments[0];
  const hash332 = arguments[1];
  Object.defineProperty(self2, symbol11, {
    value() {
      return hash332;
    },
    enumerable: false
  });
  return hash332;
};
var symbol25 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals7() {
  if (arguments.length === 1) {
    return (self2) => compareBoth7(self2, arguments[0]);
  }
  return compareBoth7(arguments[0], arguments[1]);
}
function compareBoth7(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual7(self2) && isEqual7(that)) {
        if (hash7(self2) === hash7(that) && self2[symbol25](that)) {
          return true;
        } else {
          return structuralRegionState7.enabled && structuralRegionState7.tester ? structuralRegionState7.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState7.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v232, i232) => compareBoth7(v232, that[i232]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth7(self2[key], that[key]))) {
              return structuralRegionState7.tester ? structuralRegionState7.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState7.tester ? structuralRegionState7.tester(self2, that) : false;
    }
  }
  return structuralRegionState7.enabled && structuralRegionState7.tester ? structuralRegionState7.tester(self2, that) : false;
}
var isEqual7 = (u232) => hasProperty7(u232, symbol25);
var equivalence7 = () => equals7;
var NodeInspectSymbol7 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON7 = (x232) => {
  if (hasProperty7(x232, "toJSON") && isFunction25(x232["toJSON"]) && x232["toJSON"].length === 0) {
    return x232.toJSON();
  } else if (Array.isArray(x232)) {
    return x232.map(toJSON7);
  }
  return x232;
};
var format7 = (x232) => JSON.stringify(x232, null, 2);
var pipeArguments7 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i232 = 0, len = args.length; i232 < len; i232++) {
        ret = args[i232](ret);
      }
      return ret;
    }
  }
};
var EffectTypeId8 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId7 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId7 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId7 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance7 = {
  /* c8 ignore next */
  _R: (_232) => _232,
  /* c8 ignore next */
  _E: (_232) => _232,
  /* c8 ignore next */
  _A: (_232) => _232,
  _V: /* @__PURE__ */ getCurrentVersion7()
};
var sinkVariance7 = {
  /* c8 ignore next */
  _A: (_232) => _232,
  /* c8 ignore next */
  _In: (_232) => _232,
  /* c8 ignore next */
  _L: (_232) => _232,
  /* c8 ignore next */
  _E: (_232) => _232,
  /* c8 ignore next */
  _R: (_232) => _232
};
var channelVariance7 = {
  /* c8 ignore next */
  _Env: (_232) => _232,
  /* c8 ignore next */
  _InErr: (_232) => _232,
  /* c8 ignore next */
  _InElem: (_232) => _232,
  /* c8 ignore next */
  _InDone: (_232) => _232,
  /* c8 ignore next */
  _OutErr: (_232) => _232,
  /* c8 ignore next */
  _OutElem: (_232) => _232,
  /* c8 ignore next */
  _OutDone: (_232) => _232
};
var EffectPrototype7 = {
  [EffectTypeId8]: effectVariance7,
  [StreamTypeId7]: effectVariance7,
  [SinkTypeId7]: sinkVariance7,
  [ChannelTypeId7]: channelVariance7,
  [symbol25](that) {
    return this === that;
  },
  [symbol11]() {
    return cached7(this, random7(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen8(new YieldWrap7(this));
  },
  pipe() {
    return pipeArguments7(this, arguments);
  }
};
var TypeId21 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto11 = {
  ...EffectPrototype7,
  [TypeId21]: {
    _A: (_232) => _232
  },
  [NodeInspectSymbol7]() {
    return this.toJSON();
  },
  toString() {
    return format7(this.toJSON());
  }
};
var SomeProto7 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto11), {
  _tag: "Some",
  _op: "Some",
  [symbol25](that) {
    return isOption11(that) && isSome11(that) && equals7(this.value, that.value);
  },
  [symbol11]() {
    return cached7(this, combine8(hash7(this._tag))(hash7(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON7(this.value)
    };
  }
});
var NoneHash7 = /* @__PURE__ */ hash7("None");
var NoneProto7 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto11), {
  _tag: "None",
  _op: "None",
  [symbol25](that) {
    return isOption11(that) && isNone11(that);
  },
  [symbol11]() {
    return NoneHash7;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption11 = (input) => hasProperty7(input, TypeId21);
var isNone11 = (fa) => fa._tag === "None";
var isSome11 = (fa) => fa._tag === "Some";
var none11 = /* @__PURE__ */ Object.create(NoneProto7);
var some17 = (value) => {
  const a232 = Object.create(SomeProto7);
  a232.value = value;
  return a232;
};
var TypeId25 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto25 = {
  ...EffectPrototype7,
  [TypeId25]: {
    _R: (_232) => _232
  },
  [NodeInspectSymbol7]() {
    return this.toJSON();
  },
  toString() {
    return format7(this.toJSON());
  }
};
var RightProto7 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto25), {
  _tag: "Right",
  _op: "Right",
  [symbol25](that) {
    return isEither7(that) && isRight9(that) && equals7(this.right, that.right);
  },
  [symbol11]() {
    return combine8(hash7(this._tag))(hash7(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON7(this.right)
    };
  }
});
var LeftProto7 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto25), {
  _tag: "Left",
  _op: "Left",
  [symbol25](that) {
    return isEither7(that) && isLeft9(that) && equals7(this.left, that.left);
  },
  [symbol11]() {
    return combine8(hash7(this._tag))(hash7(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON7(this.left)
    };
  }
});
var isEither7 = (input) => hasProperty7(input, TypeId25);
var isLeft9 = (ma) => ma._tag === "Left";
var isRight9 = (ma) => ma._tag === "Right";
var left8 = (left334) => {
  const a232 = Object.create(LeftProto7);
  a232.left = left334;
  return a232;
};
var right8 = (right334) => {
  const a232 = Object.create(RightProto7);
  a232.right = right334;
  return a232;
};
var getLeft11 = (self2) => isRight9(self2) ? none11 : some17(self2.left);
var getRight11 = (self2) => isLeft9(self2) ? none11 : some17(self2.right);
var Option_exports7 = {};
__export6(Option_exports7, {
  Do: () => Do8,
  TypeId: () => TypeId35,
  all: () => all11,
  andThen: () => andThen7,
  ap: () => ap7,
  as: () => as7,
  asVoid: () => asVoid7,
  bind: () => bind25,
  bindTo: () => bindTo25,
  composeK: () => composeK7,
  contains: () => contains8,
  containsWith: () => containsWith8,
  exists: () => exists7,
  filter: () => filter9,
  filterMap: () => filterMap9,
  firstSomeOf: () => firstSomeOf7,
  flatMap: () => flatMap8,
  flatMapNullable: () => flatMapNullable8,
  flatten: () => flatten8,
  fromIterable: () => fromIterable11,
  fromNullable: () => fromNullable8,
  gen: () => gen7,
  getEquivalence: () => getEquivalence10,
  getLeft: () => getLeft25,
  getOrElse: () => getOrElse7,
  getOrNull: () => getOrNull7,
  getOrThrow: () => getOrThrow7,
  getOrThrowWith: () => getOrThrowWith7,
  getOrUndefined: () => getOrUndefined7,
  getOrder: () => getOrder8,
  getRight: () => getRight25,
  isNone: () => isNone25,
  isOption: () => isOption25,
  isSome: () => isSome25,
  let: () => let_25,
  lift2: () => lift27,
  liftNullable: () => liftNullable8,
  liftPredicate: () => liftPredicate8,
  liftThrowable: () => liftThrowable7,
  map: () => map9,
  match: () => match8,
  none: () => none25,
  orElse: () => orElse7,
  orElseEither: () => orElseEither7,
  orElseSome: () => orElseSome7,
  partitionMap: () => partitionMap9,
  product: () => product11,
  productMany: () => productMany11,
  reduceCompact: () => reduceCompact7,
  some: () => some25,
  tap: () => tap7,
  toArray: () => toArray7,
  toRefinement: () => toRefinement7,
  void: () => void_7,
  zipLeft: () => zipLeft7,
  zipRight: () => zipRight7,
  zipWith: () => zipWith8
});
var make25 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId35 = /* @__PURE__ */ Symbol.for("effect/Option");
var none25 = () => none11;
var some25 = some17;
var isOption25 = isOption11;
var isNone25 = isNone11;
var isSome25 = isSome11;
var match8 = /* @__PURE__ */ dual7(2, (self2, {
  onNone,
  onSome
}) => isNone25(self2) ? onNone() : onSome(self2.value));
var toRefinement7 = (f232) => (a232) => isSome25(f232(a232));
var fromIterable11 = (collection) => {
  for (const a232 of collection) {
    return some25(a232);
  }
  return none25();
};
var getRight25 = getRight11;
var getLeft25 = getLeft11;
var getOrElse7 = /* @__PURE__ */ dual7(2, (self2, onNone) => isNone25(self2) ? onNone() : self2.value);
var orElse7 = /* @__PURE__ */ dual7(2, (self2, that) => isNone25(self2) ? that() : self2);
var orElseSome7 = /* @__PURE__ */ dual7(2, (self2, onNone) => isNone25(self2) ? some25(onNone()) : self2);
var orElseEither7 = /* @__PURE__ */ dual7(2, (self2, that) => isNone25(self2) ? map9(that(), right8) : map9(self2, left8));
var firstSomeOf7 = (collection) => {
  let out = none25();
  for (out of collection) {
    if (isSome25(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable8 = (nullableValue) => nullableValue == null ? none25() : some25(nullableValue);
var liftNullable8 = (f232) => (...a232) => fromNullable8(f232(...a232));
var getOrNull7 = /* @__PURE__ */ getOrElse7(constNull7);
var getOrUndefined7 = /* @__PURE__ */ getOrElse7(constUndefined7);
var liftThrowable7 = (f232) => (...a232) => {
  try {
    return some25(f232(...a232));
  } catch (e232) {
    return none25();
  }
};
var getOrThrowWith7 = /* @__PURE__ */ dual7(2, (self2, onNone) => {
  if (isSome25(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow7 = /* @__PURE__ */ getOrThrowWith7(() => new Error("getOrThrow called on a None"));
var map9 = /* @__PURE__ */ dual7(2, (self2, f232) => isNone25(self2) ? none25() : some25(f232(self2.value)));
var as7 = /* @__PURE__ */ dual7(2, (self2, b232) => map9(self2, () => b232));
var asVoid7 = /* @__PURE__ */ as7(void 0);
var void_7 = /* @__PURE__ */ some25(void 0);
var flatMap8 = /* @__PURE__ */ dual7(2, (self2, f232) => isNone25(self2) ? none25() : f232(self2.value));
var andThen7 = /* @__PURE__ */ dual7(2, (self2, f232) => flatMap8(self2, (a232) => {
  const b232 = isFunction12(f232) ? f232(a232) : f232;
  return isOption25(b232) ? b232 : some25(b232);
}));
var flatMapNullable8 = /* @__PURE__ */ dual7(2, (self2, f232) => isNone25(self2) ? none25() : fromNullable8(f232(self2.value)));
var flatten8 = /* @__PURE__ */ flatMap8(identity7);
var zipRight7 = /* @__PURE__ */ dual7(2, (self2, that) => flatMap8(self2, () => that));
var composeK7 = /* @__PURE__ */ dual7(2, (afb, bfc) => (a232) => flatMap8(afb(a232), bfc));
var zipLeft7 = /* @__PURE__ */ dual7(2, (self2, that) => tap7(self2, () => that));
var tap7 = /* @__PURE__ */ dual7(2, (self2, f232) => flatMap8(self2, (a232) => map9(f232(a232), () => a232)));
var product11 = (self2, that) => isSome25(self2) && isSome25(that) ? some25([self2.value, that.value]) : none25();
var productMany11 = (self2, collection) => {
  if (isNone25(self2)) {
    return none25();
  }
  const out = [self2.value];
  for (const o232 of collection) {
    if (isNone25(o232)) {
      return none25();
    }
    out.push(o232.value);
  }
  return some25(out);
};
var all11 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o232 of input) {
      if (isNone25(o232)) {
        return none25();
      }
      out2.push(o232.value);
    }
    return some25(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o232 = input[key];
    if (isNone25(o232)) {
      return none25();
    }
    out[key] = o232.value;
  }
  return some25(out);
};
var zipWith8 = /* @__PURE__ */ dual7(3, (self2, that, f232) => map9(product11(self2, that), ([a232, b232]) => f232(a232, b232)));
var ap7 = /* @__PURE__ */ dual7(2, (self2, that) => zipWith8(self2, that, (f232, a232) => f232(a232)));
var reduceCompact7 = /* @__PURE__ */ dual7(3, (self2, b232, f232) => {
  let out = b232;
  for (const oa of self2) {
    if (isSome25(oa)) {
      out = f232(out, oa.value);
    }
  }
  return out;
});
var toArray7 = (self2) => isNone25(self2) ? [] : [self2.value];
var partitionMap9 = /* @__PURE__ */ dual7(2, (self2, f232) => {
  if (isNone25(self2)) {
    return [none25(), none25()];
  }
  const e232 = f232(self2.value);
  return isLeft9(e232) ? [some25(e232.left), none25()] : [none25(), some25(e232.right)];
});
var filterMap9 = /* @__PURE__ */ dual7(2, (self2, f232) => isNone25(self2) ? none25() : f232(self2.value));
var filter9 = /* @__PURE__ */ dual7(2, (self2, predicate) => filterMap9(self2, (b232) => predicate(b232) ? some17(b232) : none11));
var getEquivalence10 = (isEquivalent) => make21((x232, y232) => x232 === y232 || (isNone25(x232) ? isNone25(y232) : isNone25(y232) ? false : isEquivalent(x232.value, y232.value)));
var getOrder8 = (O232) => make25((self2, that) => isSome25(self2) ? isSome25(that) ? O232(self2.value, that.value) : 1 : -1);
var lift27 = (f232) => dual7(2, (self2, that) => zipWith8(self2, that, f232));
var liftPredicate8 = (predicate) => (b232) => predicate(b232) ? some25(b232) : none25();
var containsWith8 = (isEquivalent) => dual7(2, (self2, a232) => isNone25(self2) ? false : isEquivalent(self2.value, a232));
var _equivalence9 = /* @__PURE__ */ equivalence7();
var contains8 = /* @__PURE__ */ containsWith8(_equivalence9);
var exists7 = /* @__PURE__ */ dual7(2, (self2, refinement) => isNone25(self2) ? false : refinement(self2.value));
var bindTo25 = /* @__PURE__ */ bindTo12(map9);
var let_25 = /* @__PURE__ */ let_12(map9);
var bind25 = /* @__PURE__ */ bind12(map9, flatMap8);
var Do8 = /* @__PURE__ */ some25({});
var adapter25 = /* @__PURE__ */ adapter11();
var gen7 = (f232) => {
  const iterator = f232(adapter25);
  let state = iterator.next();
  if (state.done) {
    return some25(state.value);
  } else {
    let current = state.value;
    if (isGenKind7(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet7(current);
    }
    if (isNone25(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind7(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet7(current);
        }
        if (isNone25(current)) {
          return current;
        }
      }
    }
    return some25(state.value);
  }
};
var MutableRef_exports5 = {};
__export6(MutableRef_exports5, {
  compareAndSet: () => compareAndSet5,
  decrement: () => decrement5,
  decrementAndGet: () => decrementAndGet5,
  get: () => get7,
  getAndDecrement: () => getAndDecrement5,
  getAndIncrement: () => getAndIncrement5,
  getAndSet: () => getAndSet5,
  getAndUpdate: () => getAndUpdate5,
  increment: () => increment5,
  incrementAndGet: () => incrementAndGet5,
  make: () => make35,
  set: () => set7,
  setAndGet: () => setAndGet5,
  toggle: () => toggle5,
  update: () => update5,
  updateAndGet: () => updateAndGet5
});
var TypeId45 = /* @__PURE__ */ Symbol.for("effect/MutableRef");
var MutableRefProto5 = {
  [TypeId45]: TypeId45,
  toString() {
    return format7(this.toJSON());
  },
  toJSON() {
    return {
      _id: "MutableRef",
      current: toJSON7(this.current)
    };
  },
  [NodeInspectSymbol7]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments7(this, arguments);
  }
};
var make35 = (value) => {
  const ref = Object.create(MutableRefProto5);
  ref.current = value;
  return ref;
};
var compareAndSet5 = /* @__PURE__ */ dual7(3, (self2, oldValue, newValue) => {
  if (equals7(oldValue, self2.current)) {
    self2.current = newValue;
    return true;
  }
  return false;
});
var decrement5 = (self2) => update5(self2, (n232) => n232 - 1);
var decrementAndGet5 = (self2) => updateAndGet5(self2, (n232) => n232 - 1);
var get7 = (self2) => self2.current;
var getAndDecrement5 = (self2) => getAndUpdate5(self2, (n232) => n232 - 1);
var getAndIncrement5 = (self2) => getAndUpdate5(self2, (n232) => n232 + 1);
var getAndSet5 = /* @__PURE__ */ dual7(2, (self2, value) => {
  const ret = self2.current;
  self2.current = value;
  return ret;
});
var getAndUpdate5 = /* @__PURE__ */ dual7(2, (self2, f232) => getAndSet5(self2, f232(get7(self2))));
var increment5 = (self2) => update5(self2, (n232) => n232 + 1);
var incrementAndGet5 = (self2) => updateAndGet5(self2, (n232) => n232 + 1);
var set7 = /* @__PURE__ */ dual7(2, (self2, value) => {
  self2.current = value;
  return self2;
});
var setAndGet5 = /* @__PURE__ */ dual7(2, (self2, value) => {
  self2.current = value;
  return self2.current;
});
var update5 = /* @__PURE__ */ dual7(2, (self2, f232) => set7(self2, f232(get7(self2))));
var updateAndGet5 = /* @__PURE__ */ dual7(2, (self2, f232) => setAndGet5(self2, f232(get7(self2))));
var toggle5 = (self2) => update5(self2, (_232) => !_232);
function getVariables3(initialScope) {
  const scopeRef = MutableRef_exports5.make(initialScope);
  const variablesRef = MutableRef_exports5.make(MutableRef_exports5.get(scopeRef).variables);
  while (MutableRef_exports5.get(scopeRef).type !== scopeManager.ScopeType.global) {
    MutableRef_exports5.set(scopeRef, MutableRef_exports5.get(scopeRef).upper);
    MutableRef_exports5.update(variablesRef, (variables) => variables.concat(MutableRef_exports5.get(scopeRef).variables));
  }
  return MutableRef_exports5.get(variablesRef).reverse();
}
var findVariable5 = Function_exports7.dual(2, (name22, initialScope) => {
  return Option_exports7.fromNullable(getVariables3(initialScope).find((variable) => variable.name === name22));
});
var t4 = Symbol.for("@ts-pattern/matcher");
var e4 = Symbol.for("@ts-pattern/isVariadic");
var n4 = "@ts-pattern/anonymous-select-key";
var r4 = (t232) => Boolean(t232 && "object" == typeof t232);
var i4 = (e232) => e232 && !!e232[t4];
var o4 = (n232, s232, c232) => {
  if (i4(n232)) {
    const e232 = n232[t4](), { matched: r232, selections: i232 } = e232.match(s232);
    return r232 && i232 && Object.keys(i232).forEach((t232) => c232(t232, i232[t232])), r232;
  }
  if (r4(n232)) {
    if (!r4(s232)) return false;
    if (Array.isArray(n232)) {
      if (!Array.isArray(s232)) return false;
      let t232 = [], r232 = [], a232 = [];
      for (const o232 of n232.keys()) {
        const s322 = n232[o232];
        i4(s322) && s322[e4] ? a232.push(s322) : a232.length ? r232.push(s322) : t232.push(s322);
      }
      if (a232.length) {
        if (a232.length > 1) throw new Error("Pattern error: Using `...P.array(...)` several times in a single pattern is not allowed.");
        if (s232.length < t232.length + r232.length) return false;
        const e232 = s232.slice(0, t232.length), n322 = 0 === r232.length ? [] : s232.slice(-r232.length), i232 = s232.slice(t232.length, 0 === r232.length ? Infinity : -r232.length);
        return t232.every((t322, n422) => o4(t322, e232[n422], c232)) && r232.every((t322, e322) => o4(t322, n322[e322], c232)) && (0 === a232.length || o4(a232[0], i232, c232));
      }
      return n232.length === s232.length && n232.every((t322, e232) => o4(t322, s232[e232], c232));
    }
    return Object.keys(n232).every((e232) => {
      const r232 = n232[e232];
      return (e232 in s232 || i4(a232 = r232) && "optional" === a232[t4]().matcherType) && o4(r232, s232[e232], c232);
      var a232;
    });
  }
  return Object.is(s232, n232);
};
var s4 = (e232) => {
  var n232, o232, a232;
  return r4(e232) ? i4(e232) ? null != (n232 = null == (o232 = (a232 = e232[t4]()).getSelectionKeys) ? void 0 : o232.call(a232)) ? n232 : [] : Array.isArray(e232) ? c4(e232, s4) : c4(Object.values(e232), s4) : [];
};
var c4 = (t232, e232) => t232.reduce((t322, n232) => t322.concat(e232(n232)), []);
function a4(...t232) {
  if (1 === t232.length) {
    const [e232] = t232;
    return (t322) => o4(e232, t322, () => {
    });
  }
  if (2 === t232.length) {
    const [e232, n232] = t232;
    return o4(e232, n232, () => {
    });
  }
  throw new Error(`isMatching wasn't given the right number of arguments: expected 1 or 2, received ${t232.length}.`);
}
function u4(t232) {
  return Object.assign(t232, { optional: () => l4(t232), and: (e232) => m4(t232, e232), or: (e232) => d4(t232, e232), select: (e232) => void 0 === e232 ? p4(t232) : p4(e232, t232) });
}
function h4(t232) {
  return Object.assign(((t322) => Object.assign(t322, { [Symbol.iterator]() {
    let n232 = 0;
    const r232 = [{ value: Object.assign(t322, { [e4]: true }), done: false }, { done: true, value: void 0 }];
    return { next: () => {
      var t422;
      return null != (t422 = r232[n232++]) ? t422 : r232.at(-1);
    } };
  } }))(t232), { optional: () => h4(l4(t232)), select: (e232) => h4(void 0 === e232 ? p4(t232) : p4(e232, t232)) });
}
function l4(e232) {
  return u4({ [t4]: () => ({ match: (t232) => {
    let n232 = {};
    const r232 = (t322, e322) => {
      n232[t322] = e322;
    };
    return void 0 === t232 ? (s4(e232).forEach((t322) => r232(t322, void 0)), { matched: true, selections: n232 }) : { matched: o4(e232, t232, r232), selections: n232 };
  }, getSelectionKeys: () => s4(e232), matcherType: "optional" }) });
}
var f4 = (t232, e232) => {
  for (const n232 of t232) if (!e232(n232)) return false;
  return true;
};
var g4 = (t232, e232) => {
  for (const [n232, r232] of t232.entries()) if (!e232(r232, n232)) return false;
  return true;
};
function m4(...e232) {
  return u4({ [t4]: () => ({ match: (t232) => {
    let n232 = {};
    const r232 = (t322, e322) => {
      n232[t322] = e322;
    };
    return { matched: e232.every((e322) => o4(e322, t232, r232)), selections: n232 };
  }, getSelectionKeys: () => c4(e232, s4), matcherType: "and" }) });
}
function d4(...e232) {
  return u4({ [t4]: () => ({ match: (t232) => {
    let n232 = {};
    const r232 = (t322, e322) => {
      n232[t322] = e322;
    };
    return c4(e232, s4).forEach((t322) => r232(t322, void 0)), { matched: e232.some((e322) => o4(e322, t232, r232)), selections: n232 };
  }, getSelectionKeys: () => c4(e232, s4), matcherType: "or" }) });
}
function y4(e232) {
  return { [t4]: () => ({ match: (t232) => ({ matched: Boolean(e232(t232)) }) }) };
}
function p4(...e232) {
  const r232 = "string" == typeof e232[0] ? e232[0] : void 0, i232 = 2 === e232.length ? e232[1] : "string" == typeof e232[0] ? void 0 : e232[0];
  return u4({ [t4]: () => ({ match: (t232) => {
    let e322 = { [null != r232 ? r232 : n4]: t232 };
    return { matched: void 0 === i232 || o4(i232, t232, (t322, n232) => {
      e322[t322] = n232;
    }), selections: e322 };
  }, getSelectionKeys: () => [null != r232 ? r232 : n4].concat(void 0 === i232 ? [] : s4(i232)) }) });
}
function v4(t232) {
  return "number" == typeof t232;
}
function b4(t232) {
  return "string" == typeof t232;
}
function w4(t232) {
  return "bigint" == typeof t232;
}
var S4 = u4(y4(function(t232) {
  return true;
}));
var O4 = S4;
var j4 = (t232) => Object.assign(u4(t232), { startsWith: (e232) => {
  return j4(m4(t232, (n232 = e232, y4((t322) => b4(t322) && t322.startsWith(n232)))));
  var n232;
}, endsWith: (e232) => {
  return j4(m4(t232, (n232 = e232, y4((t322) => b4(t322) && t322.endsWith(n232)))));
  var n232;
}, minLength: (e232) => j4(m4(t232, ((t322) => y4((e322) => b4(e322) && e322.length >= t322))(e232))), maxLength: (e232) => j4(m4(t232, ((t322) => y4((e322) => b4(e322) && e322.length <= t322))(e232))), includes: (e232) => {
  return j4(m4(t232, (n232 = e232, y4((t322) => b4(t322) && t322.includes(n232)))));
  var n232;
}, regex: (e232) => {
  return j4(m4(t232, (n232 = e232, y4((t322) => b4(t322) && Boolean(t322.match(n232))))));
  var n232;
} });
var E4 = j4(y4(b4));
var K4 = (t232) => Object.assign(u4(t232), { between: (e232, n232) => K4(m4(t232, ((t322, e322) => y4((n322) => v4(n322) && t322 <= n322 && e322 >= n322))(e232, n232))), lt: (e232) => K4(m4(t232, ((t322) => y4((e322) => v4(e322) && e322 < t322))(e232))), gt: (e232) => K4(m4(t232, ((t322) => y4((e322) => v4(e322) && e322 > t322))(e232))), lte: (e232) => K4(m4(t232, ((t322) => y4((e322) => v4(e322) && e322 <= t322))(e232))), gte: (e232) => K4(m4(t232, ((t322) => y4((e322) => v4(e322) && e322 >= t322))(e232))), int: () => K4(m4(t232, y4((t322) => v4(t322) && Number.isInteger(t322)))), finite: () => K4(m4(t232, y4((t322) => v4(t322) && Number.isFinite(t322)))), positive: () => K4(m4(t232, y4((t322) => v4(t322) && t322 > 0))), negative: () => K4(m4(t232, y4((t322) => v4(t322) && t322 < 0))) });
var x4 = K4(y4(v4));
var A4 = (t232) => Object.assign(u4(t232), { between: (e232, n232) => A4(m4(t232, ((t322, e322) => y4((n322) => w4(n322) && t322 <= n322 && e322 >= n322))(e232, n232))), lt: (e232) => A4(m4(t232, ((t322) => y4((e322) => w4(e322) && e322 < t322))(e232))), gt: (e232) => A4(m4(t232, ((t322) => y4((e322) => w4(e322) && e322 > t322))(e232))), lte: (e232) => A4(m4(t232, ((t322) => y4((e322) => w4(e322) && e322 <= t322))(e232))), gte: (e232) => A4(m4(t232, ((t322) => y4((e322) => w4(e322) && e322 >= t322))(e232))), positive: () => A4(m4(t232, y4((t322) => w4(t322) && t322 > 0))), negative: () => A4(m4(t232, y4((t322) => w4(t322) && t322 < 0))) });
var P4 = A4(y4(w4));
var T4 = u4(y4(function(t232) {
  return "boolean" == typeof t232;
}));
var k4 = u4(y4(function(t232) {
  return "symbol" == typeof t232;
}));
var B4 = u4(y4(function(t232) {
  return null == t232;
}));
var _4 = u4(y4(function(t232) {
  return null != t232;
}));
var N5 = { __proto__: null, matcher: t4, optional: l4, array: function(...e232) {
  return h4({ [t4]: () => ({ match: (t232) => {
    if (!Array.isArray(t232)) return { matched: false };
    if (0 === e232.length) return { matched: true };
    const n232 = e232[0];
    let r232 = {};
    if (0 === t232.length) return s4(n232).forEach((t322) => {
      r232[t322] = [];
    }), { matched: true, selections: r232 };
    const i232 = (t322, e322) => {
      r232[t322] = (r232[t322] || []).concat([e322]);
    };
    return { matched: t232.every((t322) => o4(n232, t322, i232)), selections: r232 };
  }, getSelectionKeys: () => 0 === e232.length ? [] : s4(e232[0]) }) });
}, set: function(...e232) {
  return u4({ [t4]: () => ({ match: (t232) => {
    if (!(t232 instanceof Set)) return { matched: false };
    let n232 = {};
    if (0 === t232.size) return { matched: true, selections: n232 };
    if (0 === e232.length) return { matched: true };
    const r232 = (t322, e322) => {
      n232[t322] = (n232[t322] || []).concat([e322]);
    }, i232 = e232[0];
    return { matched: f4(t232, (t322) => o4(i232, t322, r232)), selections: n232 };
  }, getSelectionKeys: () => 0 === e232.length ? [] : s4(e232[0]) }) });
}, map: function(...e232) {
  return u4({ [t4]: () => ({ match: (t232) => {
    if (!(t232 instanceof Map)) return { matched: false };
    let n232 = {};
    if (0 === t232.size) return { matched: true, selections: n232 };
    const r232 = (t322, e322) => {
      n232[t322] = (n232[t322] || []).concat([e322]);
    };
    if (0 === e232.length) return { matched: true };
    var i232;
    if (1 === e232.length) throw new Error(`\`P.map\` wasn't given enough arguments. Expected (key, value), received ${null == (i232 = e232[0]) ? void 0 : i232.toString()}`);
    const [s232, c232] = e232;
    return { matched: g4(t232, (t322, e322) => {
      const n322 = o4(s232, e322, r232), i322 = o4(c232, t322, r232);
      return n322 && i322;
    }), selections: n232 };
  }, getSelectionKeys: () => 0 === e232.length ? [] : [...s4(e232[0]), ...s4(e232[1])] }) });
}, intersection: m4, union: d4, not: function(e232) {
  return u4({ [t4]: () => ({ match: (t232) => ({ matched: !o4(e232, t232, () => {
  }) }), getSelectionKeys: () => [], matcherType: "not" }) });
}, when: y4, select: p4, any: S4, _: O4, string: E4, number: x4, bigint: P4, boolean: T4, symbol: k4, nullish: B4, nonNullable: _4, instanceOf: function(t232) {
  return u4(y4(/* @__PURE__ */ function(t322) {
    return (e232) => e232 instanceof t322;
  }(t232)));
}, shape: function(t232) {
  return u4(y4(a4(t232)));
} };
var KEYS5 = {
  ArrayExpression: [
    "elements"
  ],
  ArrayPattern: [
    "elements"
  ],
  ArrowFunctionExpression: [
    "params",
    "body"
  ],
  AssignmentExpression: [
    "left",
    "right"
  ],
  AssignmentPattern: [
    "left",
    "right"
  ],
  AwaitExpression: [
    "argument"
  ],
  BinaryExpression: [
    "left",
    "right"
  ],
  BlockStatement: [
    "body"
  ],
  BreakStatement: [
    "label"
  ],
  CallExpression: [
    "callee",
    "arguments"
  ],
  CatchClause: [
    "param",
    "body"
  ],
  ChainExpression: [
    "expression"
  ],
  ClassBody: [
    "body"
  ],
  ClassDeclaration: [
    "id",
    "superClass",
    "body"
  ],
  ClassExpression: [
    "id",
    "superClass",
    "body"
  ],
  ConditionalExpression: [
    "test",
    "consequent",
    "alternate"
  ],
  ContinueStatement: [
    "label"
  ],
  DebuggerStatement: [],
  DoWhileStatement: [
    "body",
    "test"
  ],
  EmptyStatement: [],
  ExperimentalRestProperty: [
    "argument"
  ],
  ExperimentalSpreadProperty: [
    "argument"
  ],
  ExportAllDeclaration: [
    "exported",
    "source"
  ],
  ExportDefaultDeclaration: [
    "declaration"
  ],
  ExportNamedDeclaration: [
    "declaration",
    "specifiers",
    "source"
  ],
  ExportSpecifier: [
    "exported",
    "local"
  ],
  ExpressionStatement: [
    "expression"
  ],
  ForInStatement: [
    "left",
    "right",
    "body"
  ],
  ForOfStatement: [
    "left",
    "right",
    "body"
  ],
  ForStatement: [
    "init",
    "test",
    "update",
    "body"
  ],
  FunctionDeclaration: [
    "id",
    "params",
    "body"
  ],
  FunctionExpression: [
    "id",
    "params",
    "body"
  ],
  Identifier: [],
  IfStatement: [
    "test",
    "consequent",
    "alternate"
  ],
  ImportDeclaration: [
    "specifiers",
    "source"
  ],
  ImportDefaultSpecifier: [
    "local"
  ],
  ImportExpression: [
    "source"
  ],
  ImportNamespaceSpecifier: [
    "local"
  ],
  ImportSpecifier: [
    "imported",
    "local"
  ],
  JSXAttribute: [
    "name",
    "value"
  ],
  JSXClosingElement: [
    "name"
  ],
  JSXClosingFragment: [],
  JSXElement: [
    "openingElement",
    "children",
    "closingElement"
  ],
  JSXEmptyExpression: [],
  JSXExpressionContainer: [
    "expression"
  ],
  JSXFragment: [
    "openingFragment",
    "children",
    "closingFragment"
  ],
  JSXIdentifier: [],
  JSXMemberExpression: [
    "object",
    "property"
  ],
  JSXNamespacedName: [
    "namespace",
    "name"
  ],
  JSXOpeningElement: [
    "name",
    "attributes"
  ],
  JSXOpeningFragment: [],
  JSXSpreadAttribute: [
    "argument"
  ],
  JSXSpreadChild: [
    "expression"
  ],
  JSXText: [],
  LabeledStatement: [
    "label",
    "body"
  ],
  Literal: [],
  LogicalExpression: [
    "left",
    "right"
  ],
  MemberExpression: [
    "object",
    "property"
  ],
  MetaProperty: [
    "meta",
    "property"
  ],
  MethodDefinition: [
    "key",
    "value"
  ],
  NewExpression: [
    "callee",
    "arguments"
  ],
  ObjectExpression: [
    "properties"
  ],
  ObjectPattern: [
    "properties"
  ],
  PrivateIdentifier: [],
  Program: [
    "body"
  ],
  Property: [
    "key",
    "value"
  ],
  PropertyDefinition: [
    "key",
    "value"
  ],
  RestElement: [
    "argument"
  ],
  ReturnStatement: [
    "argument"
  ],
  SequenceExpression: [
    "expressions"
  ],
  SpreadElement: [
    "argument"
  ],
  StaticBlock: [
    "body"
  ],
  Super: [],
  SwitchCase: [
    "test",
    "consequent"
  ],
  SwitchStatement: [
    "discriminant",
    "cases"
  ],
  TaggedTemplateExpression: [
    "tag",
    "quasi"
  ],
  TemplateElement: [],
  TemplateLiteral: [
    "quasis",
    "expressions"
  ],
  ThisExpression: [],
  ThrowStatement: [
    "argument"
  ],
  TryStatement: [
    "block",
    "handler",
    "finalizer"
  ],
  UnaryExpression: [
    "argument"
  ],
  UpdateExpression: [
    "argument"
  ],
  VariableDeclaration: [
    "declarations"
  ],
  VariableDeclarator: [
    "id",
    "init"
  ],
  WhileStatement: [
    "test",
    "body"
  ],
  WithStatement: [
    "object",
    "body"
  ],
  YieldExpression: [
    "argument"
  ]
};
var NODE_TYPES5 = Object.keys(KEYS5);
for (const type of NODE_TYPES5) {
  Object.freeze(KEYS5[type]);
}
Object.freeze(KEYS5);
var visitor_keys_default5 = KEYS5;
var KEY_BLACKLIST5 = /* @__PURE__ */ new Set([
  "parent",
  "leadingComments",
  "trailingComments"
]);
function filterKey5(key) {
  return !KEY_BLACKLIST5.has(key) && key[0] !== "_";
}
function getKeys5(node) {
  return Object.keys(node).filter(filterKey5);
}
function getInnermostScope5(initialScope, node) {
  const location = node.range[0];
  let scope = initialScope;
  let found = false;
  do {
    found = false;
    for (const childScope of scope.childScopes) {
      const range32 = childScope.block.range;
      if (range32[0] <= location && location < range32[1]) {
        scope = childScope;
        found = true;
        break;
      }
    }
  } while (found);
  return scope;
}
function findVariable24(initialScope, nameOrNode) {
  let name22 = "";
  let scope = initialScope;
  if (typeof nameOrNode === "string") {
    name22 = nameOrNode;
  } else {
    name22 = nameOrNode.name;
    scope = getInnermostScope5(scope, nameOrNode);
  }
  while (scope != null) {
    const variable = scope.set.get(name22);
    if (variable != null) {
      return variable;
    }
    scope = scope.upper;
  }
  return null;
}
function negate05(token) {
  return !this(token);
}
function negate5(f232) {
  return negate05.bind(f232);
}
function isPunctuatorTokenWithValue5(token, value) {
  return token.type === "Punctuator" && token.value === value;
}
function isArrowToken5(token) {
  return isPunctuatorTokenWithValue5(token, "=>");
}
function isCommaToken5(token) {
  return isPunctuatorTokenWithValue5(token, ",");
}
function isSemicolonToken5(token) {
  return isPunctuatorTokenWithValue5(token, ";");
}
function isColonToken5(token) {
  return isPunctuatorTokenWithValue5(token, ":");
}
function isOpeningParenToken5(token) {
  return isPunctuatorTokenWithValue5(token, "(");
}
function isClosingParenToken5(token) {
  return isPunctuatorTokenWithValue5(token, ")");
}
function isOpeningBracketToken5(token) {
  return isPunctuatorTokenWithValue5(token, "[");
}
function isClosingBracketToken5(token) {
  return isPunctuatorTokenWithValue5(token, "]");
}
function isOpeningBraceToken5(token) {
  return isPunctuatorTokenWithValue5(token, "{");
}
function isClosingBraceToken5(token) {
  return isPunctuatorTokenWithValue5(token, "}");
}
function isCommentToken5(token) {
  return ["Block", "Line", "Shebang"].includes(token.type);
}
negate5(isArrowToken5);
negate5(isCommaToken5);
negate5(isSemicolonToken5);
negate5(isColonToken5);
negate5(isOpeningParenToken5);
negate5(isClosingParenToken5);
negate5(isOpeningBracketToken5);
negate5(isClosingBracketToken5);
negate5(isOpeningBraceToken5);
negate5(isClosingBraceToken5);
negate5(isCommentToken5);
function getOpeningParenOfParams5(node, sourceCode) {
  return node.id ? sourceCode.getTokenAfter(node.id, isOpeningParenToken5) : sourceCode.getFirstToken(node, isOpeningParenToken5);
}
function getFunctionHeadLocation5(node, sourceCode) {
  const parent = node.parent;
  let start = null;
  let end = null;
  if (node.type === "ArrowFunctionExpression") {
    const arrowToken = sourceCode.getTokenBefore(node.body, isArrowToken5);
    start = arrowToken.loc.start;
    end = arrowToken.loc.end;
  } else if (parent.type === "Property" || parent.type === "MethodDefinition" || parent.type === "PropertyDefinition") {
    start = parent.loc.start;
    end = getOpeningParenOfParams5(node, sourceCode).loc.start;
  } else {
    start = node.loc.start;
    end = getOpeningParenOfParams5(node, sourceCode).loc.start;
  }
  return {
    start: { ...start },
    end: { ...end }
  };
}
var globalObject5 = typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {};
var builtinNames5 = Object.freeze(
  /* @__PURE__ */ new Set([
    "Array",
    "ArrayBuffer",
    "BigInt",
    "BigInt64Array",
    "BigUint64Array",
    "Boolean",
    "DataView",
    "Date",
    "decodeURI",
    "decodeURIComponent",
    "encodeURI",
    "encodeURIComponent",
    "escape",
    "Float32Array",
    "Float64Array",
    "Function",
    "Infinity",
    "Int16Array",
    "Int32Array",
    "Int8Array",
    "isFinite",
    "isNaN",
    "isPrototypeOf",
    "JSON",
    "Map",
    "Math",
    "NaN",
    "Number",
    "Object",
    "parseFloat",
    "parseInt",
    "Promise",
    "Proxy",
    "Reflect",
    "RegExp",
    "Set",
    "String",
    "Symbol",
    "Uint16Array",
    "Uint32Array",
    "Uint8Array",
    "Uint8ClampedArray",
    "undefined",
    "unescape",
    "WeakMap",
    "WeakSet"
  ])
);
var callAllowed5 = new Set(
  [
    Array.isArray,
    Array.of,
    Array.prototype.at,
    Array.prototype.concat,
    Array.prototype.entries,
    Array.prototype.every,
    Array.prototype.filter,
    Array.prototype.find,
    Array.prototype.findIndex,
    Array.prototype.flat,
    Array.prototype.includes,
    Array.prototype.indexOf,
    Array.prototype.join,
    Array.prototype.keys,
    Array.prototype.lastIndexOf,
    Array.prototype.slice,
    Array.prototype.some,
    Array.prototype.toString,
    Array.prototype.values,
    typeof BigInt === "function" ? BigInt : void 0,
    Boolean,
    Date,
    Date.parse,
    decodeURI,
    decodeURIComponent,
    encodeURI,
    encodeURIComponent,
    escape,
    isFinite,
    isNaN,
    isPrototypeOf,
    Map,
    Map.prototype.entries,
    Map.prototype.get,
    Map.prototype.has,
    Map.prototype.keys,
    Map.prototype.values,
    ...Object.getOwnPropertyNames(Math).filter((k232) => k232 !== "random").map((k232) => Math[k232]).filter((f232) => typeof f232 === "function"),
    Number,
    Number.isFinite,
    Number.isNaN,
    Number.parseFloat,
    Number.parseInt,
    Number.prototype.toExponential,
    Number.prototype.toFixed,
    Number.prototype.toPrecision,
    Number.prototype.toString,
    Object,
    Object.entries,
    Object.is,
    Object.isExtensible,
    Object.isFrozen,
    Object.isSealed,
    Object.keys,
    Object.values,
    parseFloat,
    parseInt,
    RegExp,
    Set,
    Set.prototype.entries,
    Set.prototype.has,
    Set.prototype.keys,
    Set.prototype.values,
    String,
    String.fromCharCode,
    String.fromCodePoint,
    String.raw,
    String.prototype.at,
    String.prototype.charAt,
    String.prototype.charCodeAt,
    String.prototype.codePointAt,
    String.prototype.concat,
    String.prototype.endsWith,
    String.prototype.includes,
    String.prototype.indexOf,
    String.prototype.lastIndexOf,
    String.prototype.normalize,
    String.prototype.padEnd,
    String.prototype.padStart,
    String.prototype.slice,
    String.prototype.startsWith,
    String.prototype.substr,
    String.prototype.substring,
    String.prototype.toLowerCase,
    String.prototype.toString,
    String.prototype.toUpperCase,
    String.prototype.trim,
    String.prototype.trimEnd,
    String.prototype.trimLeft,
    String.prototype.trimRight,
    String.prototype.trimStart,
    Symbol.for,
    Symbol.keyFor,
    unescape
  ].filter((f232) => typeof f232 === "function")
);
var callPassThrough5 = /* @__PURE__ */ new Set([
  Object.freeze,
  Object.preventExtensions,
  Object.seal
]);
var getterAllowed5 = [
  [Map, /* @__PURE__ */ new Set(["size"])],
  [
    RegExp,
    /* @__PURE__ */ new Set([
      "dotAll",
      "flags",
      "global",
      "hasIndices",
      "ignoreCase",
      "multiline",
      "source",
      "sticky",
      "unicode"
    ])
  ],
  [Set, /* @__PURE__ */ new Set(["size"])]
];
function getPropertyDescriptor5(object32, name22) {
  let x232 = object32;
  while ((typeof x232 === "object" || typeof x232 === "function") && x232 !== null) {
    const d232 = Object.getOwnPropertyDescriptor(x232, name22);
    if (d232) {
      return d232;
    }
    x232 = Object.getPrototypeOf(x232);
  }
  return null;
}
function isGetter5(object32, name22) {
  const d232 = getPropertyDescriptor5(object32, name22);
  return d232 != null && d232.get != null;
}
function getElementValues5(nodeList, initialScope) {
  const valueList = [];
  for (let i232 = 0; i232 < nodeList.length; ++i232) {
    const elementNode = nodeList[i232];
    if (elementNode == null) {
      valueList.length = i232 + 1;
    } else if (elementNode.type === "SpreadElement") {
      const argument = getStaticValueR5(elementNode.argument, initialScope);
      if (argument == null) {
        return null;
      }
      valueList.push(...argument.value);
    } else {
      const element = getStaticValueR5(elementNode, initialScope);
      if (element == null) {
        return null;
      }
      valueList.push(element.value);
    }
  }
  return valueList;
}
function isEffectivelyConst5(variable) {
  const refs = variable.references;
  const inits = refs.filter((r232) => r232.init).length;
  const reads = refs.filter((r232) => r232.isReadOnly()).length;
  if (inits === 1 && reads + inits === refs.length) {
    return true;
  }
  return false;
}
var operations5 = Object.freeze({
  ArrayExpression(node, initialScope) {
    const elements = getElementValues5(node.elements, initialScope);
    return elements != null ? { value: elements } : null;
  },
  AssignmentExpression(node, initialScope) {
    if (node.operator === "=") {
      return getStaticValueR5(node.right, initialScope);
    }
    return null;
  },
  //eslint-disable-next-line complexity
  BinaryExpression(node, initialScope) {
    if (node.operator === "in" || node.operator === "instanceof") {
      return null;
    }
    const left334 = getStaticValueR5(node.left, initialScope);
    const right334 = getStaticValueR5(node.right, initialScope);
    if (left334 != null && right334 != null) {
      switch (node.operator) {
        case "==":
          return { value: left334.value == right334.value };
        case "!=":
          return { value: left334.value != right334.value };
        case "===":
          return { value: left334.value === right334.value };
        case "!==":
          return { value: left334.value !== right334.value };
        case "<":
          return { value: left334.value < right334.value };
        case "<=":
          return { value: left334.value <= right334.value };
        case ">":
          return { value: left334.value > right334.value };
        case ">=":
          return { value: left334.value >= right334.value };
        case "<<":
          return { value: left334.value << right334.value };
        case ">>":
          return { value: left334.value >> right334.value };
        case ">>>":
          return { value: left334.value >>> right334.value };
        case "+":
          return { value: left334.value + right334.value };
        case "-":
          return { value: left334.value - right334.value };
        case "*":
          return { value: left334.value * right334.value };
        case "/":
          return { value: left334.value / right334.value };
        case "%":
          return { value: left334.value % right334.value };
        case "**":
          return { value: left334.value ** right334.value };
        case "|":
          return { value: left334.value | right334.value };
        case "^":
          return { value: left334.value ^ right334.value };
        case "&":
          return { value: left334.value & right334.value };
      }
    }
    return null;
  },
  CallExpression(node, initialScope) {
    const calleeNode = node.callee;
    const args = getElementValues5(node.arguments, initialScope);
    if (args != null) {
      if (calleeNode.type === "MemberExpression") {
        if (calleeNode.property.type === "PrivateIdentifier") {
          return null;
        }
        const object32 = getStaticValueR5(calleeNode.object, initialScope);
        if (object32 != null) {
          if (object32.value == null && (object32.optional || node.optional)) {
            return { value: void 0, optional: true };
          }
          const property = getStaticPropertyNameValue5(
            calleeNode,
            initialScope
          );
          if (property != null) {
            const receiver = object32.value;
            const methodName = property.value;
            if (callAllowed5.has(receiver[methodName])) {
              return { value: receiver[methodName](...args) };
            }
            if (callPassThrough5.has(receiver[methodName])) {
              return { value: args[0] };
            }
          }
        }
      } else {
        const callee = getStaticValueR5(calleeNode, initialScope);
        if (callee != null) {
          if (callee.value == null && node.optional) {
            return { value: void 0, optional: true };
          }
          const func = callee.value;
          if (callAllowed5.has(func)) {
            return { value: func(...args) };
          }
          if (callPassThrough5.has(func)) {
            return { value: args[0] };
          }
        }
      }
    }
    return null;
  },
  ConditionalExpression(node, initialScope) {
    const test = getStaticValueR5(node.test, initialScope);
    if (test != null) {
      return test.value ? getStaticValueR5(node.consequent, initialScope) : getStaticValueR5(node.alternate, initialScope);
    }
    return null;
  },
  ExpressionStatement(node, initialScope) {
    return getStaticValueR5(node.expression, initialScope);
  },
  Identifier(node, initialScope) {
    if (initialScope != null) {
      const variable = findVariable24(initialScope, node);
      if (variable != null && variable.defs.length === 0 && builtinNames5.has(variable.name) && variable.name in globalObject5) {
        return { value: globalObject5[variable.name] };
      }
      if (variable != null && variable.defs.length === 1) {
        const def = variable.defs[0];
        if (def.parent && def.type === "Variable" && (def.parent.kind === "const" || isEffectivelyConst5(variable)) && // TODO(mysticatea): don't support destructuring here.
        def.node.id.type === "Identifier") {
          return getStaticValueR5(def.node.init, initialScope);
        }
      }
    }
    return null;
  },
  Literal(node) {
    if ((node.regex != null || node.bigint != null) && node.value == null) {
      return null;
    }
    return { value: node.value };
  },
  LogicalExpression(node, initialScope) {
    const left334 = getStaticValueR5(node.left, initialScope);
    if (left334 != null) {
      if (node.operator === "||" && Boolean(left334.value) === true || node.operator === "&&" && Boolean(left334.value) === false || node.operator === "??" && left334.value != null) {
        return left334;
      }
      const right334 = getStaticValueR5(node.right, initialScope);
      if (right334 != null) {
        return right334;
      }
    }
    return null;
  },
  MemberExpression(node, initialScope) {
    if (node.property.type === "PrivateIdentifier") {
      return null;
    }
    const object32 = getStaticValueR5(node.object, initialScope);
    if (object32 != null) {
      if (object32.value == null && (object32.optional || node.optional)) {
        return { value: void 0, optional: true };
      }
      const property = getStaticPropertyNameValue5(node, initialScope);
      if (property != null) {
        if (!isGetter5(object32.value, property.value)) {
          return { value: object32.value[property.value] };
        }
        for (const [classFn, allowed] of getterAllowed5) {
          if (object32.value instanceof classFn && allowed.has(property.value)) {
            return { value: object32.value[property.value] };
          }
        }
      }
    }
    return null;
  },
  ChainExpression(node, initialScope) {
    const expression = getStaticValueR5(node.expression, initialScope);
    if (expression != null) {
      return { value: expression.value };
    }
    return null;
  },
  NewExpression(node, initialScope) {
    const callee = getStaticValueR5(node.callee, initialScope);
    const args = getElementValues5(node.arguments, initialScope);
    if (callee != null && args != null) {
      const Func = callee.value;
      if (callAllowed5.has(Func)) {
        return { value: new Func(...args) };
      }
    }
    return null;
  },
  ObjectExpression(node, initialScope) {
    const object32 = {};
    for (const propertyNode of node.properties) {
      if (propertyNode.type === "Property") {
        if (propertyNode.kind !== "init") {
          return null;
        }
        const key = getStaticPropertyNameValue5(
          propertyNode,
          initialScope
        );
        const value = getStaticValueR5(propertyNode.value, initialScope);
        if (key == null || value == null) {
          return null;
        }
        object32[key.value] = value.value;
      } else if (propertyNode.type === "SpreadElement" || propertyNode.type === "ExperimentalSpreadProperty") {
        const argument = getStaticValueR5(
          propertyNode.argument,
          initialScope
        );
        if (argument == null) {
          return null;
        }
        Object.assign(object32, argument.value);
      } else {
        return null;
      }
    }
    return { value: object32 };
  },
  SequenceExpression(node, initialScope) {
    const last32 = node.expressions[node.expressions.length - 1];
    return getStaticValueR5(last32, initialScope);
  },
  TaggedTemplateExpression(node, initialScope) {
    const tag = getStaticValueR5(node.tag, initialScope);
    const expressions = getElementValues5(
      node.quasi.expressions,
      initialScope
    );
    if (tag != null && expressions != null) {
      const func = tag.value;
      const strings = node.quasi.quasis.map((q) => q.value.cooked);
      strings.raw = node.quasi.quasis.map((q) => q.value.raw);
      if (func === String.raw) {
        return { value: func(strings, ...expressions) };
      }
    }
    return null;
  },
  TemplateLiteral(node, initialScope) {
    const expressions = getElementValues5(node.expressions, initialScope);
    if (expressions != null) {
      let value = node.quasis[0].value.cooked;
      for (let i232 = 0; i232 < expressions.length; ++i232) {
        value += expressions[i232];
        value += node.quasis[i232 + 1].value.cooked;
      }
      return { value };
    }
    return null;
  },
  UnaryExpression(node, initialScope) {
    if (node.operator === "delete") {
      return null;
    }
    if (node.operator === "void") {
      return { value: void 0 };
    }
    const arg = getStaticValueR5(node.argument, initialScope);
    if (arg != null) {
      switch (node.operator) {
        case "-":
          return { value: -arg.value };
        case "+":
          return { value: +arg.value };
        case "!":
          return { value: !arg.value };
        case "~":
          return { value: ~arg.value };
        case "typeof":
          return { value: typeof arg.value };
      }
    }
    return null;
  }
});
function getStaticValueR5(node, initialScope) {
  if (node != null && Object.hasOwnProperty.call(operations5, node.type)) {
    return operations5[node.type](node, initialScope);
  }
  return null;
}
function getStaticPropertyNameValue5(node, initialScope) {
  const nameNode = node.type === "Property" ? node.key : node.property;
  if (node.computed) {
    return getStaticValueR5(nameNode, initialScope);
  }
  if (nameNode.type === "Identifier") {
    return { value: nameNode.name };
  }
  if (nameNode.type === "Literal") {
    if (nameNode.bigint) {
      return { value: nameNode.bigint };
    }
    return { value: String(nameNode.value) };
  }
  return null;
}
function getStaticValue6(node, initialScope = null) {
  try {
    return getStaticValueR5(node, initialScope);
  } catch (_error) {
    return null;
  }
}
function getStringIfConstant5(node, initialScope = null) {
  if (node && node.type === "Literal" && node.value === null) {
    if (node.regex) {
      return `/${node.regex.pattern}/${node.regex.flags}`;
    }
    if (node.bigint) {
      return node.bigint;
    }
  }
  const evaluated = getStaticValue6(node, initialScope);
  return evaluated && String(evaluated.value);
}
function getPropertyName5(node, initialScope) {
  switch (node.type) {
    case "MemberExpression":
      if (node.computed) {
        return getStringIfConstant5(node.property, initialScope);
      }
      if (node.property.type === "PrivateIdentifier") {
        return null;
      }
      return node.property.name;
    case "Property":
    case "MethodDefinition":
    case "PropertyDefinition":
      if (node.computed) {
        return getStringIfConstant5(node.key, initialScope);
      }
      if (node.key.type === "Literal") {
        return String(node.key.value);
      }
      if (node.key.type === "PrivateIdentifier") {
        return null;
      }
      return node.key.name;
  }
  return null;
}
function getFunctionNameWithKind5(node, sourceCode) {
  const parent = node.parent;
  const tokens = [];
  const isObjectMethod = parent.type === "Property" && parent.value === node;
  const isClassMethod = parent.type === "MethodDefinition" && parent.value === node;
  const isClassFieldMethod = parent.type === "PropertyDefinition" && parent.value === node;
  if (isClassMethod || isClassFieldMethod) {
    if (parent.static) {
      tokens.push("static");
    }
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push("private");
    }
  }
  if (node.async) {
    tokens.push("async");
  }
  if (node.generator) {
    tokens.push("generator");
  }
  if (isObjectMethod || isClassMethod) {
    if (parent.kind === "constructor") {
      return "constructor";
    }
    if (parent.kind === "get") {
      tokens.push("getter");
    } else if (parent.kind === "set") {
      tokens.push("setter");
    } else {
      tokens.push("method");
    }
  } else if (isClassFieldMethod) {
    tokens.push("method");
  } else {
    if (node.type === "ArrowFunctionExpression") {
      tokens.push("arrow");
    }
    tokens.push("function");
  }
  if (isObjectMethod || isClassMethod || isClassFieldMethod) {
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push(`#${parent.key.name}`);
    } else {
      const name22 = getPropertyName5(parent);
      if (name22) {
        tokens.push(`'${name22}'`);
      } else if (sourceCode) {
        const keyText = sourceCode.getText(parent.key);
        if (!keyText.includes("\n")) {
          tokens.push(`[${keyText}]`);
        }
      }
    }
  } else if (node.id) {
    tokens.push(`'${node.id.name}'`);
  } else if (parent.type === "VariableDeclarator" && parent.id && parent.id.type === "Identifier") {
    tokens.push(`'${parent.id.name}'`);
  } else if ((parent.type === "AssignmentExpression" || parent.type === "AssignmentPattern") && parent.left && parent.left.type === "Identifier") {
    tokens.push(`'${parent.left.name}'`);
  } else if (parent.type === "ExportDefaultDeclaration" && parent.declaration === node) {
    tokens.push("'default'");
  }
  return tokens.join(" ");
}
var typeConversionBinaryOps5 = Object.freeze(
  /* @__PURE__ */ new Set([
    "==",
    "!=",
    "<",
    "<=",
    ">",
    ">=",
    "<<",
    ">>",
    ">>>",
    "+",
    "-",
    "*",
    "/",
    "%",
    "|",
    "^",
    "&",
    "in"
  ])
);
var typeConversionUnaryOps5 = Object.freeze(/* @__PURE__ */ new Set(["-", "+", "!", "~"]));
function isNode5(x232) {
  return x232 !== null && typeof x232 === "object" && typeof x232.type === "string";
}
var visitor5 = Object.freeze(
  Object.assign(/* @__PURE__ */ Object.create(null), {
    $visit(node, options, visitorKeys) {
      const { type } = node;
      if (typeof this[type] === "function") {
        return this[type](node, options, visitorKeys);
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    $visitChildren(node, options, visitorKeys) {
      const { type } = node;
      for (const key of visitorKeys[type] || getKeys5(node)) {
        const value = node[key];
        if (Array.isArray(value)) {
          for (const element of value) {
            if (isNode5(element) && this.$visit(element, options, visitorKeys)) {
              return true;
            }
          }
        } else if (isNode5(value) && this.$visit(value, options, visitorKeys)) {
          return true;
        }
      }
      return false;
    },
    ArrowFunctionExpression() {
      return false;
    },
    AssignmentExpression() {
      return true;
    },
    AwaitExpression() {
      return true;
    },
    BinaryExpression(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && typeConversionBinaryOps5.has(node.operator) && (node.left.type !== "Literal" || node.right.type !== "Literal")) {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    CallExpression() {
      return true;
    },
    FunctionExpression() {
      return false;
    },
    ImportExpression() {
      return true;
    },
    MemberExpression(node, options, visitorKeys) {
      if (options.considerGetters) {
        return true;
      }
      if (options.considerImplicitTypeConversion && node.computed && node.property.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    MethodDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    NewExpression() {
      return true;
    },
    Property(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    PropertyDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UnaryExpression(node, options, visitorKeys) {
      if (node.operator === "delete") {
        return true;
      }
      if (options.considerImplicitTypeConversion && typeConversionUnaryOps5.has(node.operator) && node.argument.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UpdateExpression() {
      return true;
    },
    YieldExpression() {
      return true;
    }
  })
);
function hasSideEffect5(node, sourceCode, { considerGetters = false, considerImplicitTypeConversion = false } = {}) {
  return visitor5.$visit(
    node,
    { considerGetters, considerImplicitTypeConversion },
    sourceCode.visitorKeys || visitor_keys_default5
  );
}
function getParentSyntaxParen5(node, sourceCode) {
  const parent = node.parent;
  switch (parent.type) {
    case "CallExpression":
    case "NewExpression":
      if (parent.arguments.length === 1 && parent.arguments[0] === node) {
        return sourceCode.getTokenAfter(
          parent.callee,
          isOpeningParenToken5
        );
      }
      return null;
    case "DoWhileStatement":
      if (parent.test === node) {
        return sourceCode.getTokenAfter(
          parent.body,
          isOpeningParenToken5
        );
      }
      return null;
    case "IfStatement":
    case "WhileStatement":
      if (parent.test === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "ImportExpression":
      if (parent.source === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "SwitchStatement":
      if (parent.discriminant === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "WithStatement":
      if (parent.object === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    default:
      return null;
  }
}
function isParenthesized5(timesOrNode, nodeOrSourceCode, optionalSourceCode) {
  let times, node, sourceCode, maybeLeftParen, maybeRightParen;
  if (typeof timesOrNode === "number") {
    times = timesOrNode | 0;
    node = nodeOrSourceCode;
    sourceCode = optionalSourceCode;
    if (!(times >= 1)) {
      throw new TypeError("'times' should be a positive integer.");
    }
  } else {
    times = 1;
    node = timesOrNode;
    sourceCode = nodeOrSourceCode;
  }
  if (node == null || // `Program` can't be parenthesized
  node.parent == null || // `CatchClause.param` can't be parenthesized, example `try {} catch (error) {}`
  node.parent.type === "CatchClause" && node.parent.param === node) {
    return false;
  }
  maybeLeftParen = maybeRightParen = node;
  do {
    maybeLeftParen = sourceCode.getTokenBefore(maybeLeftParen);
    maybeRightParen = sourceCode.getTokenAfter(maybeRightParen);
  } while (maybeLeftParen != null && maybeRightParen != null && isOpeningParenToken5(maybeLeftParen) && isClosingParenToken5(maybeRightParen) && // Avoid false positive such as `if (a) {}`
  maybeLeftParen !== getParentSyntaxParen5(node, sourceCode) && --times > 0);
  return times === 0;
}
Function.call.bind(Object.hasOwnProperty);
var __defProp24 = Object.defineProperty;
var __export24 = (target, all334) => {
  for (var name22 in all334)
    __defProp24(target, name22, { get: all334[name22], enumerable: true });
};
var NodeType5 = types.AST_NODE_TYPES;
var is5 = utils.ASTUtils.isNodeOfType;
var isOneOf5 = utils.ASTUtils.isNodeOfTypes;
isOneOf5([
  NodeType5.ArrowFunctionExpression,
  NodeType5.FunctionDeclaration,
  NodeType5.FunctionExpression
]);
isOneOf5([
  NodeType5.ArrowFunctionExpression,
  NodeType5.FunctionDeclaration,
  NodeType5.FunctionExpression,
  NodeType5.TSCallSignatureDeclaration,
  NodeType5.TSConstructSignatureDeclaration,
  NodeType5.TSDeclareFunction,
  NodeType5.TSEmptyBodyFunctionExpression,
  NodeType5.TSFunctionType,
  NodeType5.TSMethodSignature
]);
isOneOf5([NodeType5.ClassDeclaration, NodeType5.ClassExpression]);
isOneOf5([
  NodeType5.DoWhileStatement,
  NodeType5.ForInStatement,
  NodeType5.ForOfStatement,
  NodeType5.ForStatement,
  NodeType5.WhileStatement
]);
isOneOf5([NodeType5.TSArrayType, NodeType5.TSTupleType]);
isOneOf5([
  NodeType5.PropertyDefinition,
  NodeType5.TSIndexSignature,
  NodeType5.TSParameterProperty,
  NodeType5.TSPropertySignature
]);
is5(NodeType5.JSXElement);
is5(NodeType5.JSXFragment);
isOneOf5([
  NodeType5.JSXAttribute,
  NodeType5.JSXSpreadChild,
  NodeType5.JSXClosingElement,
  NodeType5.JSXClosingFragment,
  NodeType5.JSXElement,
  NodeType5.JSXEmptyExpression,
  NodeType5.JSXExpressionContainer,
  NodeType5.JSXFragment,
  NodeType5.JSXIdentifier,
  NodeType5.JSXMemberExpression,
  NodeType5.JSXNamespacedName,
  NodeType5.JSXOpeningElement,
  NodeType5.JSXOpeningFragment,
  NodeType5.JSXSpreadAttribute,
  NodeType5.JSXSpreadChild,
  NodeType5.JSXText
]);
isOneOf5([
  NodeType5.JSXIdentifier,
  NodeType5.JSXMemberExpression,
  NodeType5.JSXNamespacedName
]);
isOneOf5([
  NodeType5.ArrayPattern,
  NodeType5.AssignmentPattern,
  NodeType5.ObjectPattern,
  NodeType5.RestElement
]);
isOneOf5([
  NodeType5.TSInterfaceDeclaration,
  NodeType5.TSTypeAliasDeclaration
]);
isOneOf5([
  NodeType5.ArrayExpression,
  NodeType5.ArrayPattern,
  NodeType5.ArrowFunctionExpression,
  NodeType5.CallExpression,
  NodeType5.ClassExpression,
  NodeType5.FunctionExpression,
  NodeType5.Identifier,
  NodeType5.JSXElement,
  NodeType5.JSXFragment,
  NodeType5.Literal,
  NodeType5.TemplateLiteral,
  NodeType5.MemberExpression,
  NodeType5.MetaProperty,
  NodeType5.ObjectExpression,
  NodeType5.ObjectPattern,
  NodeType5.SequenceExpression,
  NodeType5.Super,
  NodeType5.TaggedTemplateExpression,
  NodeType5.ThisExpression
]);
isOneOf5([
  NodeType5.ArrayExpression,
  NodeType5.ArrayPattern,
  NodeType5.ArrowFunctionExpression,
  NodeType5.CallExpression,
  NodeType5.ClassExpression,
  NodeType5.FunctionExpression,
  NodeType5.Identifier,
  NodeType5.JSXElement,
  NodeType5.JSXFragment,
  NodeType5.Literal,
  NodeType5.TemplateLiteral,
  NodeType5.MemberExpression,
  NodeType5.MetaProperty,
  NodeType5.ObjectExpression,
  NodeType5.ObjectPattern,
  NodeType5.SequenceExpression,
  NodeType5.Super,
  NodeType5.TaggedTemplateExpression,
  NodeType5.ThisExpression,
  NodeType5.TSAsExpression,
  NodeType5.TSNonNullExpression,
  NodeType5.TSTypeAssertion
]);
var Function_exports24 = {};
__export24(Function_exports24, {
  SK: () => SK24,
  absurd: () => absurd24,
  apply: () => apply24,
  compose: () => compose25,
  constFalse: () => constFalse24,
  constNull: () => constNull24,
  constTrue: () => constTrue24,
  constUndefined: () => constUndefined24,
  constVoid: () => constVoid24,
  constant: () => constant24,
  dual: () => dual24,
  flip: () => flip24,
  flow: () => flow24,
  hole: () => hole24,
  identity: () => identity24,
  isFunction: () => isFunction224,
  pipe: () => pipe24,
  satisfies: () => satisfies24,
  tupled: () => tupled24,
  unsafeCoerce: () => unsafeCoerce24,
  untupled: () => untupled24
});
var isFunction224 = (input) => typeof input === "function";
var dual24 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a232, b232) {
        if (arguments.length >= 2) {
          return body(a232, b232);
        }
        return function(self2) {
          return body(self2, a232);
        };
      };
    case 3:
      return function(a232, b232, c232) {
        if (arguments.length >= 3) {
          return body(a232, b232, c232);
        }
        return function(self2) {
          return body(self2, a232, b232);
        };
      };
    case 4:
      return function(a232, b232, c232, d232) {
        if (arguments.length >= 4) {
          return body(a232, b232, c232, d232);
        }
        return function(self2) {
          return body(self2, a232, b232, c232);
        };
      };
    case 5:
      return function(a232, b232, c232, d232, e232) {
        if (arguments.length >= 5) {
          return body(a232, b232, c232, d232, e232);
        }
        return function(self2) {
          return body(self2, a232, b232, c232, d232);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply24 = (a232) => (self2) => self2(a232);
var identity24 = (a232) => a232;
var satisfies24 = () => (b232) => b232;
var unsafeCoerce24 = identity24;
var constant24 = (value) => () => value;
var constTrue24 = /* @__PURE__ */ constant24(true);
var constFalse24 = /* @__PURE__ */ constant24(false);
var constNull24 = /* @__PURE__ */ constant24(null);
var constUndefined24 = /* @__PURE__ */ constant24(void 0);
var constVoid24 = constUndefined24;
var flip24 = (f232) => (...b232) => (...a232) => f232(...a232)(...b232);
var compose25 = /* @__PURE__ */ dual24(2, (ab, bc) => (a232) => bc(ab(a232)));
var absurd24 = (_232) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled24 = (f232) => (a232) => f232(...a232);
var untupled24 = (f232) => (...a232) => f232(a232);
function pipe24(a232, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a232;
    case 2:
      return ab(a232);
    case 3:
      return bc(ab(a232));
    case 4:
      return cd(bc(ab(a232)));
    case 5:
      return de(cd(bc(ab(a232))));
    case 6:
      return ef(de(cd(bc(ab(a232)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a232))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a232)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a232))))))));
    default: {
      let ret = arguments[0];
      for (let i232 = 1; i232 < arguments.length; i232++) {
        ret = arguments[i232](ret);
      }
      return ret;
    }
  }
}
function flow24(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole24 = /* @__PURE__ */ unsafeCoerce24(absurd24);
var SK24 = (_232, b232) => b232;
var make45 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_34 = (map632) => dual24(3, (self2, name22, f232) => map632(self2, (a232) => Object.assign({}, a232, {
  [name22]: f232(a232)
})));
var bindTo34 = (map632) => dual24(2, (self2, name22) => map632(self2, (a232) => ({
  [name22]: a232
})));
var bind34 = (map632, flatMap432) => dual24(3, (self2, name22, f232) => flatMap432(self2, (a232) => map632(f232(a232), (b232) => Object.assign({}, a232, {
  [name22]: b232
}))));
var moduleVersion24 = "3.2.8";
var getCurrentVersion24 = () => moduleVersion24;
var globalStoreId24 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion24()}`);
if (!(globalStoreId24 in globalThis)) {
  globalThis[globalStoreId24] = /* @__PURE__ */ new Map();
}
var globalStore24 = globalThis[globalStoreId24];
var globalValue24 = (id, compute) => {
  if (!globalStore24.has(id)) {
    globalStore24.set(id, compute());
  }
  return globalStore24.get(id);
};
var Predicate_exports24 = {};
__export24(Predicate_exports24, {
  all: () => all25,
  and: () => and7,
  compose: () => compose224,
  eqv: () => eqv7,
  every: () => every9,
  hasProperty: () => hasProperty24,
  implies: () => implies7,
  isBigInt: () => isBigInt7,
  isBoolean: () => isBoolean7,
  isDate: () => isDate7,
  isError: () => isError7,
  isFunction: () => isFunction324,
  isIterable: () => isIterable7,
  isMap: () => isMap7,
  isNever: () => isNever7,
  isNotNull: () => isNotNull7,
  isNotNullable: () => isNotNullable7,
  isNotUndefined: () => isNotUndefined7,
  isNull: () => isNull7,
  isNullable: () => isNullable24,
  isNumber: () => isNumber7,
  isObject: () => isObject24,
  isPromise: () => isPromise7,
  isPromiseLike: () => isPromiseLike7,
  isReadonlyRecord: () => isReadonlyRecord7,
  isRecord: () => isRecord7,
  isSet: () => isSet7,
  isString: () => isString7,
  isSymbol: () => isSymbol7,
  isTagged: () => isTagged7,
  isTruthy: () => isTruthy7,
  isUint8Array: () => isUint8Array7,
  isUndefined: () => isUndefined7,
  isUnknown: () => isUnknown7,
  mapInput: () => mapInput8,
  nand: () => nand7,
  nor: () => nor7,
  not: () => not7,
  or: () => or7,
  product: () => product25,
  productMany: () => productMany25,
  some: () => some35,
  struct: () => struct9,
  tuple: () => tuple8,
  xor: () => xor7
});
var mapInput8 = /* @__PURE__ */ dual24(2, (self2, f232) => (b232) => self2(f232(b232)));
var isTruthy7 = (input) => !!input;
var isSet7 = (input) => input instanceof Set;
var isMap7 = (input) => input instanceof Map;
var isString7 = (input) => typeof input === "string";
var isNumber7 = (input) => typeof input === "number";
var isBoolean7 = (input) => typeof input === "boolean";
var isBigInt7 = (input) => typeof input === "bigint";
var isSymbol7 = (input) => typeof input === "symbol";
var isFunction324 = isFunction224;
var isUndefined7 = (input) => input === void 0;
var isNotUndefined7 = (input) => input !== void 0;
var isNull7 = (input) => input === null;
var isNotNull7 = (input) => input !== null;
var isNever7 = (_232) => false;
var isUnknown7 = (_232) => true;
var isRecordOrArray24 = (input) => typeof input === "object" && input !== null;
var isObject24 = (input) => isRecordOrArray24(input) || isFunction324(input);
var hasProperty24 = /* @__PURE__ */ dual24(2, (self2, property) => isObject24(self2) && property in self2);
var isTagged7 = /* @__PURE__ */ dual24(2, (self2, tag) => hasProperty24(self2, "_tag") && self2["_tag"] === tag);
var isNullable24 = (input) => input === null || input === void 0;
var isNotNullable7 = (input) => input !== null && input !== void 0;
var isError7 = (input) => input instanceof Error;
var isUint8Array7 = (input) => input instanceof Uint8Array;
var isDate7 = (input) => input instanceof Date;
var isIterable7 = (input) => hasProperty24(input, Symbol.iterator);
var isRecord7 = (input) => isRecordOrArray24(input) && !Array.isArray(input);
var isReadonlyRecord7 = isRecord7;
var isPromise7 = (input) => hasProperty24(input, "then") && "catch" in input && isFunction324(input.then) && isFunction324(input.catch);
var isPromiseLike7 = (input) => hasProperty24(input, "then") && isFunction324(input.then);
var compose224 = /* @__PURE__ */ dual24(2, (ab, bc) => (a232) => ab(a232) && bc(a232));
var product25 = (self2, that) => ([a232, b232]) => self2(a232) && that(b232);
var all25 = (collection) => {
  return (as2234) => {
    let collectionIndex = 0;
    for (const p232 of collection) {
      if (collectionIndex >= as2234.length) {
        break;
      }
      if (p232(as2234[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany25 = (self2, collection) => {
  const rest = all25(collection);
  return ([head232, ...tail42]) => self2(head232) === false ? false : rest(tail42);
};
var tuple8 = (...elements) => all25(elements);
var struct9 = (fields) => {
  const keys234 = Object.keys(fields);
  return (a232) => {
    for (const key of keys234) {
      if (!fields[key](a232[key])) {
        return false;
      }
    }
    return true;
  };
};
var not7 = (self2) => (a232) => !self2(a232);
var or7 = /* @__PURE__ */ dual24(2, (self2, that) => (a232) => self2(a232) || that(a232));
var and7 = /* @__PURE__ */ dual24(2, (self2, that) => (a232) => self2(a232) && that(a232));
var xor7 = /* @__PURE__ */ dual24(2, (self2, that) => (a232) => self2(a232) !== that(a232));
var eqv7 = /* @__PURE__ */ dual24(2, (self2, that) => (a232) => self2(a232) === that(a232));
var implies7 = /* @__PURE__ */ dual24(2, (self2, that) => (a232) => self2(a232) ? that(a232) : true);
var nor7 = /* @__PURE__ */ dual24(2, (self2, that) => (a232) => !(self2(a232) || that(a232)));
var nand7 = /* @__PURE__ */ dual24(2, (self2, that) => (a232) => !(self2(a232) && that(a232)));
var every9 = (collection) => (a232) => {
  for (const p232 of collection) {
    if (!p232(a232)) {
      return false;
    }
  }
  return true;
};
var some35 = (collection) => (a232) => {
  for (const p232 of collection) {
    if (p232(a232)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage24 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId24 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind24 = (u232) => isObject24(u232) && GenKindTypeId24 in u232;
var GenKindImpl24 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity24;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId24] = GenKindTypeId24;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen25(this);
  }
};
var SingleShotGen25 = class _SingleShotGen9 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a232) {
    return this.called ? {
      value: a232,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a232) {
    return {
      value: a232,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e232) {
    throw e232;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen9(this.self);
  }
};
var adapter34 = () => function() {
  let x232 = arguments[0];
  for (let i232 = 1; i232 < arguments.length; i232++) {
    x232 = arguments[i232](x232);
  }
  return new GenKindImpl24(x232);
};
var defaultIncHi24 = 335903614;
var defaultIncLo24 = 4150755663;
var MUL_HI24 = 1481765933 >>> 0;
var MUL_LO24 = 1284865837 >>> 0;
var BIT_5324 = 9007199254740992;
var BIT_2724 = 134217728;
var PCGRandom24 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable24(seedLo) && isNullable24(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable24(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable24(incLo) && isNullable24(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo24;
      incHi = this._state ? this._state[2] : defaultIncHi24;
    } else if (isNullable24(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add6424(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max42) {
    if (!max42) {
      return this._next();
    }
    max42 = max42 >>> 0;
    if ((max42 & max42 - 1) === 0) {
      return this._next() & max42 - 1;
    }
    let num = 0;
    const skew = (-max42 >>> 0) % max42 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max42;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_2724 + lo) / BIT_5324;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul6424(this._state, oldHi, oldLo, MUL_HI24, MUL_LO24);
    add6424(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul6424(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add6424(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId24 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap24 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId24]() {
    return this.#value;
  }
};
function yieldWrapGet24(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId24 in self2) {
    return self2[YieldWrapTypeId24]();
  }
  throw new Error(getBugErrorMessage24("yieldWrapGet"));
}
var structuralRegionState24 = /* @__PURE__ */ globalValue24("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache24 = /* @__PURE__ */ globalValue24(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr24 = /* @__PURE__ */ globalValue24(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom24());
var symbol34 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash24 = (self2) => {
  if (structuralRegionState24.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number24(self2);
    case "bigint":
      return string24(self2.toString(10));
    case "boolean":
      return string24(String(self2));
    case "symbol":
      return string24(String(self2));
    case "string":
      return string24(self2);
    case "undefined":
      return string24("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string24("null");
      } else if (self2 instanceof Date) {
        return hash24(self2.toISOString());
      } else if (isHash24(self2)) {
        return self2[symbol34]();
      } else {
        return random24(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random24 = (self2) => {
  if (!randomHashCache24.has(self2)) {
    randomHashCache24.set(self2, number24(pcgr24.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache24.get(self2);
};
var combine25 = (b232) => (self2) => self2 * 53 ^ b232;
var optimize24 = (n232) => n232 & 3221225471 | n232 >>> 1 & 1073741824;
var isHash24 = (u232) => hasProperty24(u232, symbol34);
var number24 = (n232) => {
  if (n232 !== n232 || n232 === Infinity) {
    return 0;
  }
  let h232 = n232 | 0;
  if (h232 !== n232) {
    h232 ^= n232 * 4294967295;
  }
  while (n232 > 4294967295) {
    h232 ^= n232 /= 4294967295;
  }
  return optimize24(n232);
};
var string24 = (str) => {
  let h232 = 5381, i232 = str.length;
  while (i232) {
    h232 = h232 * 33 ^ str.charCodeAt(--i232);
  }
  return optimize24(h232);
};
var structureKeys24 = (o232, keys234) => {
  let h232 = 12289;
  for (let i232 = 0; i232 < keys234.length; i232++) {
    h232 ^= pipe24(string24(keys234[i232]), combine25(hash24(o232[keys234[i232]])));
  }
  return optimize24(h232);
};
var structure24 = (o232) => structureKeys24(o232, Object.keys(o232));
var array9 = (arr) => {
  let h232 = 6151;
  for (let i232 = 0; i232 < arr.length; i232++) {
    h232 = pipe24(h232, combine25(hash24(arr[i232])));
  }
  return optimize24(h232);
};
var cached24 = function() {
  if (arguments.length === 1) {
    const self22 = arguments[0];
    return function(hash332) {
      Object.defineProperty(self22, symbol34, {
        value() {
          return hash332;
        },
        enumerable: false
      });
      return hash332;
    };
  }
  const self2 = arguments[0];
  const hash2234 = arguments[1];
  Object.defineProperty(self2, symbol34, {
    value() {
      return hash2234;
    },
    enumerable: false
  });
  return hash2234;
};
var symbol224 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals24() {
  if (arguments.length === 1) {
    return (self2) => compareBoth24(self2, arguments[0]);
  }
  return compareBoth24(arguments[0], arguments[1]);
}
function compareBoth24(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual24(self2) && isEqual24(that)) {
        if (hash24(self2) === hash24(that) && self2[symbol224](that)) {
          return true;
        } else {
          return structuralRegionState24.enabled && structuralRegionState24.tester ? structuralRegionState24.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState24.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v232, i232) => compareBoth24(v232, that[i232]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth24(self2[key], that[key]))) {
              return structuralRegionState24.tester ? structuralRegionState24.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState24.tester ? structuralRegionState24.tester(self2, that) : false;
    }
  }
  return structuralRegionState24.enabled && structuralRegionState24.tester ? structuralRegionState24.tester(self2, that) : false;
}
var isEqual24 = (u232) => hasProperty24(u232, symbol224);
var equivalence24 = () => equals24;
var NodeInspectSymbol24 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON24 = (x232) => {
  if (hasProperty24(x232, "toJSON") && isFunction324(x232["toJSON"]) && x232["toJSON"].length === 0) {
    return x232.toJSON();
  } else if (Array.isArray(x232)) {
    return x232.map(toJSON24);
  }
  return x232;
};
var format24 = (x232) => JSON.stringify(x232, null, 2);
var pipeArguments24 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i232 = 0, len = args.length; i232 < len; i232++) {
        ret = args[i232](ret);
      }
      return ret;
    }
  }
};
var OP_COMMIT24 = "Commit";
var OP_FAILURE5 = "Failure";
var OP_WITH_RUNTIME5 = "WithRuntime";
var EffectTypeId25 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId24 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId24 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId24 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance24 = {
  /* c8 ignore next */
  _R: (_232) => _232,
  /* c8 ignore next */
  _E: (_232) => _232,
  /* c8 ignore next */
  _A: (_232) => _232,
  _V: /* @__PURE__ */ getCurrentVersion24()
};
var sinkVariance24 = {
  /* c8 ignore next */
  _A: (_232) => _232,
  /* c8 ignore next */
  _In: (_232) => _232,
  /* c8 ignore next */
  _L: (_232) => _232,
  /* c8 ignore next */
  _E: (_232) => _232,
  /* c8 ignore next */
  _R: (_232) => _232
};
var channelVariance24 = {
  /* c8 ignore next */
  _Env: (_232) => _232,
  /* c8 ignore next */
  _InErr: (_232) => _232,
  /* c8 ignore next */
  _InElem: (_232) => _232,
  /* c8 ignore next */
  _InDone: (_232) => _232,
  /* c8 ignore next */
  _OutErr: (_232) => _232,
  /* c8 ignore next */
  _OutElem: (_232) => _232,
  /* c8 ignore next */
  _OutDone: (_232) => _232
};
var EffectPrototype24 = {
  [EffectTypeId25]: effectVariance24,
  [StreamTypeId24]: effectVariance24,
  [SinkTypeId24]: sinkVariance24,
  [ChannelTypeId24]: channelVariance24,
  [symbol224](that) {
    return this === that;
  },
  [symbol34]() {
    return cached24(this, random24(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen25(new YieldWrap24(this));
  },
  pipe() {
    return pipeArguments24(this, arguments);
  }
};
var StructuralPrototype24 = {
  [symbol34]() {
    return cached24(this, structure24(this));
  },
  [symbol224](that) {
    const selfKeys = Object.keys(this);
    const thatKeys = Object.keys(that);
    if (selfKeys.length !== thatKeys.length) {
      return false;
    }
    for (const key of selfKeys) {
      if (!(key in that && equals24(this[key], that[key]))) {
        return false;
      }
    }
    return true;
  }
};
var CommitPrototype24 = {
  ...EffectPrototype24,
  _op: OP_COMMIT24
};
var StructuralCommitPrototype24 = {
  ...CommitPrototype24,
  ...StructuralPrototype24
};
var TypeId55 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto34 = {
  ...EffectPrototype24,
  [TypeId55]: {
    _A: (_232) => _232
  },
  [NodeInspectSymbol24]() {
    return this.toJSON();
  },
  toString() {
    return format24(this.toJSON());
  }
};
var SomeProto24 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto34), {
  _tag: "Some",
  _op: "Some",
  [symbol224](that) {
    return isOption34(that) && isSome34(that) && equals24(this.value, that.value);
  },
  [symbol34]() {
    return cached24(this, combine25(hash24(this._tag))(hash24(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON24(this.value)
    };
  }
});
var NoneHash24 = /* @__PURE__ */ hash24("None");
var NoneProto24 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto34), {
  _tag: "None",
  _op: "None",
  [symbol224](that) {
    return isOption34(that) && isNone34(that);
  },
  [symbol34]() {
    return NoneHash24;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption34 = (input) => hasProperty24(input, TypeId55);
var isNone34 = (fa) => fa._tag === "None";
var isSome34 = (fa) => fa._tag === "Some";
var none34 = /* @__PURE__ */ Object.create(NoneProto24);
var some224 = (value) => {
  const a232 = Object.create(SomeProto24);
  a232.value = value;
  return a232;
};
var TypeId224 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto224 = {
  ...EffectPrototype24,
  [TypeId224]: {
    _R: (_232) => _232
  },
  [NodeInspectSymbol24]() {
    return this.toJSON();
  },
  toString() {
    return format24(this.toJSON());
  }
};
var RightProto24 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto224), {
  _tag: "Right",
  _op: "Right",
  [symbol224](that) {
    return isEither24(that) && isRight24(that) && equals24(this.right, that.right);
  },
  [symbol34]() {
    return combine25(hash24(this._tag))(hash24(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON24(this.right)
    };
  }
});
var LeftProto24 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto224), {
  _tag: "Left",
  _op: "Left",
  [symbol224](that) {
    return isEither24(that) && isLeft24(that) && equals24(this.left, that.left);
  },
  [symbol34]() {
    return combine25(hash24(this._tag))(hash24(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON24(this.left)
    };
  }
});
var isEither24 = (input) => hasProperty24(input, TypeId224);
var isLeft24 = (ma) => ma._tag === "Left";
var isRight24 = (ma) => ma._tag === "Right";
var left25 = (left334) => {
  const a232 = Object.create(LeftProto24);
  a232.left = left334;
  return a232;
};
var right25 = (right334) => {
  const a232 = Object.create(RightProto24);
  a232.right = right334;
  return a232;
};
var getLeft34 = (self2) => isRight24(self2) ? none34 : some224(self2.left);
var getRight34 = (self2) => isLeft24(self2) ? none34 : some224(self2.right);
var right224 = right25;
var left224 = left25;
var Option_exports24 = {};
__export24(Option_exports24, {
  Do: () => Do24,
  TypeId: () => TypeId324,
  all: () => all224,
  andThen: () => andThen24,
  ap: () => ap24,
  as: () => as24,
  asVoid: () => asVoid24,
  bind: () => bind224,
  bindTo: () => bindTo224,
  composeK: () => composeK24,
  contains: () => contains24,
  containsWith: () => containsWith24,
  exists: () => exists24,
  filter: () => filter24,
  filterMap: () => filterMap24,
  firstSomeOf: () => firstSomeOf24,
  flatMap: () => flatMap24,
  flatMapNullable: () => flatMapNullable24,
  flatten: () => flatten24,
  fromIterable: () => fromIterable25,
  fromNullable: () => fromNullable24,
  gen: () => gen24,
  getEquivalence: () => getEquivalence25,
  getLeft: () => getLeft224,
  getOrElse: () => getOrElse24,
  getOrNull: () => getOrNull24,
  getOrThrow: () => getOrThrow24,
  getOrThrowWith: () => getOrThrowWith24,
  getOrUndefined: () => getOrUndefined24,
  getOrder: () => getOrder24,
  getRight: () => getRight224,
  isNone: () => isNone224,
  isOption: () => isOption224,
  isSome: () => isSome224,
  let: () => let_224,
  lift2: () => lift224,
  liftNullable: () => liftNullable24,
  liftPredicate: () => liftPredicate24,
  liftThrowable: () => liftThrowable24,
  map: () => map24,
  match: () => match25,
  none: () => none224,
  orElse: () => orElse24,
  orElseEither: () => orElseEither24,
  orElseSome: () => orElseSome24,
  partitionMap: () => partitionMap24,
  product: () => product224,
  productMany: () => productMany224,
  reduceCompact: () => reduceCompact24,
  some: () => some324,
  tap: () => tap24,
  toArray: () => toArray24,
  toRefinement: () => toRefinement24,
  void: () => void_24,
  zipLeft: () => zipLeft24,
  zipRight: () => zipRight24,
  zipWith: () => zipWith24
});
var make224 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId324 = /* @__PURE__ */ Symbol.for("effect/Option");
var none224 = () => none34;
var some324 = some224;
var isOption224 = isOption34;
var isNone224 = isNone34;
var isSome224 = isSome34;
var match25 = /* @__PURE__ */ dual24(2, (self2, {
  onNone,
  onSome
}) => isNone224(self2) ? onNone() : onSome(self2.value));
var toRefinement24 = (f232) => (a232) => isSome224(f232(a232));
var fromIterable25 = (collection) => {
  for (const a232 of collection) {
    return some324(a232);
  }
  return none224();
};
var getRight224 = getRight34;
var getLeft224 = getLeft34;
var getOrElse24 = /* @__PURE__ */ dual24(2, (self2, onNone) => isNone224(self2) ? onNone() : self2.value);
var orElse24 = /* @__PURE__ */ dual24(2, (self2, that) => isNone224(self2) ? that() : self2);
var orElseSome24 = /* @__PURE__ */ dual24(2, (self2, onNone) => isNone224(self2) ? some324(onNone()) : self2);
var orElseEither24 = /* @__PURE__ */ dual24(2, (self2, that) => isNone224(self2) ? map24(that(), right25) : map24(self2, left25));
var firstSomeOf24 = (collection) => {
  let out = none224();
  for (out of collection) {
    if (isSome224(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable24 = (nullableValue) => nullableValue == null ? none224() : some324(nullableValue);
var liftNullable24 = (f232) => (...a232) => fromNullable24(f232(...a232));
var getOrNull24 = /* @__PURE__ */ getOrElse24(constNull24);
var getOrUndefined24 = /* @__PURE__ */ getOrElse24(constUndefined24);
var liftThrowable24 = (f232) => (...a232) => {
  try {
    return some324(f232(...a232));
  } catch (e232) {
    return none224();
  }
};
var getOrThrowWith24 = /* @__PURE__ */ dual24(2, (self2, onNone) => {
  if (isSome224(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow24 = /* @__PURE__ */ getOrThrowWith24(() => new Error("getOrThrow called on a None"));
var map24 = /* @__PURE__ */ dual24(2, (self2, f232) => isNone224(self2) ? none224() : some324(f232(self2.value)));
var as24 = /* @__PURE__ */ dual24(2, (self2, b232) => map24(self2, () => b232));
var asVoid24 = /* @__PURE__ */ as24(void 0);
var void_24 = /* @__PURE__ */ some324(void 0);
var flatMap24 = /* @__PURE__ */ dual24(2, (self2, f232) => isNone224(self2) ? none224() : f232(self2.value));
var andThen24 = /* @__PURE__ */ dual24(2, (self2, f232) => flatMap24(self2, (a232) => {
  const b232 = isFunction224(f232) ? f232(a232) : f232;
  return isOption224(b232) ? b232 : some324(b232);
}));
var flatMapNullable24 = /* @__PURE__ */ dual24(2, (self2, f232) => isNone224(self2) ? none224() : fromNullable24(f232(self2.value)));
var flatten24 = /* @__PURE__ */ flatMap24(identity24);
var zipRight24 = /* @__PURE__ */ dual24(2, (self2, that) => flatMap24(self2, () => that));
var composeK24 = /* @__PURE__ */ dual24(2, (afb, bfc) => (a232) => flatMap24(afb(a232), bfc));
var zipLeft24 = /* @__PURE__ */ dual24(2, (self2, that) => tap24(self2, () => that));
var tap24 = /* @__PURE__ */ dual24(2, (self2, f232) => flatMap24(self2, (a232) => map24(f232(a232), () => a232)));
var product224 = (self2, that) => isSome224(self2) && isSome224(that) ? some324([self2.value, that.value]) : none224();
var productMany224 = (self2, collection) => {
  if (isNone224(self2)) {
    return none224();
  }
  const out = [self2.value];
  for (const o232 of collection) {
    if (isNone224(o232)) {
      return none224();
    }
    out.push(o232.value);
  }
  return some324(out);
};
var all224 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o232 of input) {
      if (isNone224(o232)) {
        return none224();
      }
      out2.push(o232.value);
    }
    return some324(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o232 = input[key];
    if (isNone224(o232)) {
      return none224();
    }
    out[key] = o232.value;
  }
  return some324(out);
};
var zipWith24 = /* @__PURE__ */ dual24(3, (self2, that, f232) => map24(product224(self2, that), ([a232, b232]) => f232(a232, b232)));
var ap24 = /* @__PURE__ */ dual24(2, (self2, that) => zipWith24(self2, that, (f232, a232) => f232(a232)));
var reduceCompact24 = /* @__PURE__ */ dual24(3, (self2, b232, f232) => {
  let out = b232;
  for (const oa of self2) {
    if (isSome224(oa)) {
      out = f232(out, oa.value);
    }
  }
  return out;
});
var toArray24 = (self2) => isNone224(self2) ? [] : [self2.value];
var partitionMap24 = /* @__PURE__ */ dual24(2, (self2, f232) => {
  if (isNone224(self2)) {
    return [none224(), none224()];
  }
  const e232 = f232(self2.value);
  return isLeft24(e232) ? [some324(e232.left), none224()] : [none224(), some324(e232.right)];
});
var filterMap24 = /* @__PURE__ */ dual24(2, (self2, f232) => isNone224(self2) ? none224() : f232(self2.value));
var filter24 = /* @__PURE__ */ dual24(2, (self2, predicate) => filterMap24(self2, (b232) => predicate(b232) ? some224(b232) : none34));
var getEquivalence25 = (isEquivalent) => make45((x232, y232) => x232 === y232 || (isNone224(x232) ? isNone224(y232) : isNone224(y232) ? false : isEquivalent(x232.value, y232.value)));
var getOrder24 = (O232) => make224((self2, that) => isSome224(self2) ? isSome224(that) ? O232(self2.value, that.value) : 1 : -1);
var lift224 = (f232) => dual24(2, (self2, that) => zipWith24(self2, that, f232));
var liftPredicate24 = (predicate) => (b232) => predicate(b232) ? some324(b232) : none224();
var containsWith24 = (isEquivalent) => dual24(2, (self2, a232) => isNone224(self2) ? false : isEquivalent(self2.value, a232));
var _equivalence25 = /* @__PURE__ */ equivalence24();
var contains24 = /* @__PURE__ */ containsWith24(_equivalence25);
var exists24 = /* @__PURE__ */ dual24(2, (self2, refinement) => isNone224(self2) ? false : refinement(self2.value));
var bindTo224 = /* @__PURE__ */ bindTo34(map24);
var let_224 = /* @__PURE__ */ let_34(map24);
var bind224 = /* @__PURE__ */ bind34(map24, flatMap24);
var Do24 = /* @__PURE__ */ some324({});
var adapter224 = /* @__PURE__ */ adapter34();
var gen24 = (f232) => {
  const iterator = f232(adapter224);
  let state = iterator.next();
  if (state.done) {
    return some324(state.value);
  } else {
    let current = state.value;
    if (isGenKind24(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet24(current);
    }
    if (isNone224(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind24(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet24(current);
        }
        if (isNone224(current)) {
          return current;
        }
      }
    }
    return some324(state.value);
  }
};
var fromIterable224 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var reverse7 = (self2) => Array.from(self2).reverse();
var reduce9 = /* @__PURE__ */ dual24(3, (self2, b232, f232) => fromIterable224(self2).reduce((b2222, a232, i232) => f232(b2222, a232, i232), b232));
var TagTypeId5 = /* @__PURE__ */ Symbol.for("effect/Context/Tag");
var STMSymbolKey5 = "effect/STM";
var STMTypeId5 = /* @__PURE__ */ Symbol.for(STMSymbolKey5);
var TagProto5 = {
  ...EffectPrototype24,
  _tag: "Tag",
  _op: "Tag",
  [STMTypeId5]: effectVariance24,
  [TagTypeId5]: {
    _Service: (_232) => _232,
    _Identifier: (_232) => _232
  },
  toString() {
    return format24(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Tag",
      key: this.key,
      stack: this.stack
    };
  },
  [NodeInspectSymbol24]() {
    return this.toJSON();
  },
  of(self2) {
    return self2;
  },
  context(self2) {
    return make324(this, self2);
  }
};
var makeGenericTag5 = (key) => {
  const limit = Error.stackTraceLimit;
  Error.stackTraceLimit = 2;
  const creationError = new Error();
  Error.stackTraceLimit = limit;
  const tag = Object.create(TagProto5);
  Object.defineProperty(tag, "stack", {
    get() {
      return creationError.stack;
    }
  });
  tag.key = key;
  return tag;
};
var TypeId424 = /* @__PURE__ */ Symbol.for("effect/Context");
var ContextProto5 = {
  [TypeId424]: {
    _Services: (_232) => _232
  },
  [symbol224](that) {
    if (isContext5(that)) {
      if (this.unsafeMap.size === that.unsafeMap.size) {
        for (const k232 of this.unsafeMap.keys()) {
          if (!that.unsafeMap.has(k232) || !equals24(this.unsafeMap.get(k232), that.unsafeMap.get(k232))) {
            return false;
          }
        }
        return true;
      }
    }
    return false;
  },
  [symbol34]() {
    return cached24(this, number24(this.unsafeMap.size));
  },
  pipe() {
    return pipeArguments24(this, arguments);
  },
  toString() {
    return format24(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Context",
      services: Array.from(this.unsafeMap).map(toJSON24)
    };
  },
  [NodeInspectSymbol24]() {
    return this.toJSON();
  }
};
var makeContext5 = (unsafeMap) => {
  const context = Object.create(ContextProto5);
  context.unsafeMap = unsafeMap;
  return context;
};
var isContext5 = (u232) => hasProperty24(u232, TypeId424);
var _empty9 = /* @__PURE__ */ makeContext5(/* @__PURE__ */ new Map());
var empty15 = () => _empty9;
var make324 = (tag, service) => makeContext5(/* @__PURE__ */ new Map([[tag.key, service]]));
var GenericTag5 = makeGenericTag5;
var empty25 = empty15;
var TypeId524 = /* @__PURE__ */ Symbol.for("effect/Chunk");
function copy6(src, srcPos, dest, destPos, len) {
  for (let i232 = srcPos; i232 < Math.min(src.length, srcPos + len); i232++) {
    dest[destPos + i232 - srcPos] = src[i232];
  }
  return dest;
}
var emptyArray5 = [];
var getEquivalence224 = (isEquivalent) => make45((self2, that) => self2.length === that.length && toReadonlyArray5(self2).every((value, i232) => isEquivalent(value, unsafeGet25(that, i232))));
var _equivalence224 = /* @__PURE__ */ getEquivalence224(equals24);
var ChunkProto5 = {
  [TypeId524]: {
    _A: (_232) => _232
  },
  toString() {
    return format24(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Chunk",
      values: toReadonlyArray5(this).map(toJSON24)
    };
  },
  [NodeInspectSymbol24]() {
    return this.toJSON();
  },
  [symbol224](that) {
    return isChunk5(that) && _equivalence224(this, that);
  },
  [symbol34]() {
    return cached24(this, array9(toReadonlyArray5(this)));
  },
  [Symbol.iterator]() {
    switch (this.backing._tag) {
      case "IArray": {
        return this.backing.array[Symbol.iterator]();
      }
      case "IEmpty": {
        return emptyArray5[Symbol.iterator]();
      }
      default: {
        return toReadonlyArray5(this)[Symbol.iterator]();
      }
    }
  },
  pipe() {
    return pipeArguments24(this, arguments);
  }
};
var makeChunk5 = (backing) => {
  const chunk = Object.create(ChunkProto5);
  chunk.backing = backing;
  switch (backing._tag) {
    case "IEmpty": {
      chunk.length = 0;
      chunk.depth = 0;
      chunk.left = chunk;
      chunk.right = chunk;
      break;
    }
    case "IConcat": {
      chunk.length = backing.left.length + backing.right.length;
      chunk.depth = 1 + Math.max(backing.left.depth, backing.right.depth);
      chunk.left = backing.left;
      chunk.right = backing.right;
      break;
    }
    case "IArray": {
      chunk.length = backing.array.length;
      chunk.depth = 0;
      chunk.left = _empty25;
      chunk.right = _empty25;
      break;
    }
    case "ISingleton": {
      chunk.length = 1;
      chunk.depth = 0;
      chunk.left = _empty25;
      chunk.right = _empty25;
      break;
    }
    case "ISlice": {
      chunk.length = backing.length;
      chunk.depth = backing.chunk.depth + 1;
      chunk.left = _empty25;
      chunk.right = _empty25;
      break;
    }
  }
  return chunk;
};
var isChunk5 = (u232) => hasProperty24(u232, TypeId524);
var _empty25 = /* @__PURE__ */ makeChunk5({
  _tag: "IEmpty"
});
var empty35 = () => _empty25;
var make424 = (...as2234) => as2234.length === 1 ? of6(as2234[0]) : unsafeFromNonEmptyArray5(as2234);
var of6 = (a232) => makeChunk5({
  _tag: "ISingleton",
  a: a232
});
var copyToArray5 = (self2, array334, initial) => {
  switch (self2.backing._tag) {
    case "IArray": {
      copy6(self2.backing.array, 0, array334, initial, self2.length);
      break;
    }
    case "IConcat": {
      copyToArray5(self2.left, array334, initial);
      copyToArray5(self2.right, array334, initial + self2.left.length);
      break;
    }
    case "ISingleton": {
      array334[initial] = self2.backing.a;
      break;
    }
    case "ISlice": {
      let i232 = 0;
      let j232 = initial;
      while (i232 < self2.length) {
        array334[j232] = unsafeGet25(self2, i232);
        i232 += 1;
        j232 += 1;
      }
      break;
    }
  }
};
var toReadonlyArray5 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      return emptyArray5;
    }
    case "IArray": {
      return self2.backing.array;
    }
    default: {
      const arr = new Array(self2.length);
      copyToArray5(self2, arr, 0);
      self2.backing = {
        _tag: "IArray",
        array: arr
      };
      self2.left = _empty25;
      self2.right = _empty25;
      self2.depth = 0;
      return arr;
    }
  }
};
var reverse25 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty":
    case "ISingleton":
      return self2;
    case "IArray": {
      return makeChunk5({
        _tag: "IArray",
        array: reverse7(self2.backing.array)
      });
    }
    case "IConcat": {
      return makeChunk5({
        _tag: "IConcat",
        left: reverse25(self2.backing.right),
        right: reverse25(self2.backing.left)
      });
    }
    case "ISlice":
      return unsafeFromArray5(reverse7(toReadonlyArray5(self2)));
  }
};
var unsafeFromArray5 = (self2) => makeChunk5({
  _tag: "IArray",
  array: self2
});
var unsafeFromNonEmptyArray5 = (self2) => unsafeFromArray5(self2);
var unsafeGet25 = /* @__PURE__ */ dual24(2, (self2, index) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      throw new Error(`Index out of bounds`);
    }
    case "ISingleton": {
      if (index !== 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.a;
    }
    case "IArray": {
      if (index >= self2.length || index < 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.array[index];
    }
    case "IConcat": {
      return index < self2.left.length ? unsafeGet25(self2.left, index) : unsafeGet25(self2.right, index - self2.left.length);
    }
    case "ISlice": {
      return unsafeGet25(self2.backing.chunk, index + self2.backing.offset);
    }
  }
});
var prepend7 = /* @__PURE__ */ dual24(2, (self2, elem) => appendAll6(of6(elem), self2));
var drop6 = /* @__PURE__ */ dual24(2, (self2, n232) => {
  if (n232 <= 0) {
    return self2;
  } else if (n232 >= self2.length) {
    return _empty25;
  } else {
    switch (self2.backing._tag) {
      case "ISlice": {
        return makeChunk5({
          _tag: "ISlice",
          chunk: self2.backing.chunk,
          offset: self2.backing.offset + n232,
          length: self2.backing.length - n232
        });
      }
      case "IConcat": {
        if (n232 > self2.left.length) {
          return drop6(self2.right, n232 - self2.left.length);
        }
        return makeChunk5({
          _tag: "IConcat",
          left: drop6(self2.left, n232),
          right: self2.right
        });
      }
      default: {
        return makeChunk5({
          _tag: "ISlice",
          chunk: self2,
          offset: n232,
          length: self2.length - n232
        });
      }
    }
  }
});
var appendAll6 = /* @__PURE__ */ dual24(2, (self2, that) => {
  if (self2.backing._tag === "IEmpty") {
    return that;
  }
  if (that.backing._tag === "IEmpty") {
    return self2;
  }
  const diff234 = that.depth - self2.depth;
  if (Math.abs(diff234) <= 1) {
    return makeChunk5({
      _tag: "IConcat",
      left: self2,
      right: that
    });
  } else if (diff234 < -1) {
    if (self2.left.depth >= self2.right.depth) {
      const nr = appendAll6(self2.right, that);
      return makeChunk5({
        _tag: "IConcat",
        left: self2.left,
        right: nr
      });
    } else {
      const nrr = appendAll6(self2.right.right, that);
      if (nrr.depth === self2.depth - 3) {
        const nr = makeChunk5({
          _tag: "IConcat",
          left: self2.right.left,
          right: nrr
        });
        return makeChunk5({
          _tag: "IConcat",
          left: self2.left,
          right: nr
        });
      } else {
        const nl = makeChunk5({
          _tag: "IConcat",
          left: self2.left,
          right: self2.right.left
        });
        return makeChunk5({
          _tag: "IConcat",
          left: nl,
          right: nrr
        });
      }
    }
  } else {
    if (that.right.depth >= that.left.depth) {
      const nl = appendAll6(self2, that.left);
      return makeChunk5({
        _tag: "IConcat",
        left: nl,
        right: that.right
      });
    } else {
      const nll = appendAll6(self2, that.left.left);
      if (nll.depth === that.depth - 3) {
        const nl = makeChunk5({
          _tag: "IConcat",
          left: nll,
          right: that.left.right
        });
        return makeChunk5({
          _tag: "IConcat",
          left: nl,
          right: that.right
        });
      } else {
        const nr = makeChunk5({
          _tag: "IConcat",
          left: that.left.right,
          right: that.right
        });
        return makeChunk5({
          _tag: "IConcat",
          left: nll,
          right: nr
        });
      }
    }
  }
});
var isEmpty6 = (self2) => self2.length === 0;
var isNonEmpty5 = (self2) => self2.length > 0;
var unsafeHead5 = (self2) => unsafeGet25(self2, 0);
var headNonEmpty6 = unsafeHead5;
var tailNonEmpty6 = (self2) => drop6(self2, 1);
var SIZE5 = 5;
var BUCKET_SIZE5 = /* @__PURE__ */ Math.pow(2, SIZE5);
var MASK5 = BUCKET_SIZE5 - 1;
var MAX_INDEX_NODE5 = BUCKET_SIZE5 / 2;
var MIN_ARRAY_NODE5 = BUCKET_SIZE5 / 4;
function popcount5(x232) {
  x232 -= x232 >> 1 & 1431655765;
  x232 = (x232 & 858993459) + (x232 >> 2 & 858993459);
  x232 = x232 + (x232 >> 4) & 252645135;
  x232 += x232 >> 8;
  x232 += x232 >> 16;
  return x232 & 127;
}
function hashFragment5(shift32, h232) {
  return h232 >>> shift32 & MASK5;
}
function toBitmap5(x232) {
  return 1 << x232;
}
function fromBitmap5(bitmap, bit) {
  return popcount5(bitmap & bit - 1);
}
var make55 = (value, previous) => ({
  value,
  previous
});
function arrayUpdate5(mutate234, at, v232, arr) {
  let out = arr;
  if (!mutate234) {
    const len = arr.length;
    out = new Array(len);
    for (let i232 = 0; i232 < len; ++i232) out[i232] = arr[i232];
  }
  out[at] = v232;
  return out;
}
function arraySpliceOut5(mutate234, at, arr) {
  const newLen = arr.length - 1;
  let i232 = 0;
  let g232 = 0;
  let out = arr;
  if (mutate234) {
    i232 = g232 = at;
  } else {
    out = new Array(newLen);
    while (i232 < at) out[g232++] = arr[i232++];
  }
  ++i232;
  while (i232 <= newLen) out[g232++] = arr[i232++];
  if (mutate234) {
    out.length = newLen;
  }
  return out;
}
function arraySpliceIn5(mutate234, at, v232, arr) {
  const len = arr.length;
  if (mutate234) {
    let i2222 = len;
    while (i2222 >= at) arr[i2222--] = arr[i2222];
    arr[at] = v232;
    return arr;
  }
  let i232 = 0, g232 = 0;
  const out = new Array(len + 1);
  while (i232 < at) out[g232++] = arr[i232++];
  out[at] = v232;
  while (i232 < len) out[++g232] = arr[i232++];
  return out;
}
var EmptyNode5 = class _EmptyNode5 {
  _tag = "EmptyNode";
  modify(edit, _shift, f232, hash2234, key, size434) {
    const v232 = f232(none224());
    if (isNone224(v232)) return new _EmptyNode5();
    ++size434.value;
    return new LeafNode5(edit, hash2234, key, v232);
  }
};
function isEmptyNode5(a232) {
  return isTagged7(a232, "EmptyNode");
}
function isLeafNode5(node) {
  return isEmptyNode5(node) || node._tag === "LeafNode" || node._tag === "CollisionNode";
}
function canEditNode5(node, edit) {
  return isEmptyNode5(node) ? false : edit === node.edit;
}
var LeafNode5 = class _LeafNode5 {
  edit;
  hash;
  key;
  value;
  _tag = "LeafNode";
  constructor(edit, hash2234, key, value) {
    this.edit = edit;
    this.hash = hash2234;
    this.key = key;
    this.value = value;
  }
  modify(edit, shift32, f232, hash2234, key, size434) {
    if (equals24(key, this.key)) {
      const v2222 = f232(this.value);
      if (v2222 === this.value) return this;
      else if (isNone224(v2222)) {
        --size434.value;
        return new EmptyNode5();
      }
      if (canEditNode5(this, edit)) {
        this.value = v2222;
        return this;
      }
      return new _LeafNode5(edit, hash2234, key, v2222);
    }
    const v232 = f232(none224());
    if (isNone224(v232)) return this;
    ++size434.value;
    return mergeLeaves5(edit, shift32, this.hash, this, hash2234, new _LeafNode5(edit, hash2234, key, v232));
  }
};
var CollisionNode5 = class _CollisionNode5 {
  edit;
  hash;
  children;
  _tag = "CollisionNode";
  constructor(edit, hash2234, children) {
    this.edit = edit;
    this.hash = hash2234;
    this.children = children;
  }
  modify(edit, shift32, f232, hash2234, key, size434) {
    if (hash2234 === this.hash) {
      const canEdit = canEditNode5(this, edit);
      const list = this.updateCollisionList(canEdit, edit, this.hash, this.children, f232, key, size434);
      if (list === this.children) return this;
      return list.length > 1 ? new _CollisionNode5(edit, this.hash, list) : list[0];
    }
    const v232 = f232(none224());
    if (isNone224(v232)) return this;
    ++size434.value;
    return mergeLeaves5(edit, shift32, this.hash, this, hash2234, new LeafNode5(edit, hash2234, key, v232));
  }
  updateCollisionList(mutate234, edit, hash2234, list, f232, key, size434) {
    const len = list.length;
    for (let i232 = 0; i232 < len; ++i232) {
      const child = list[i232];
      if ("key" in child && equals24(key, child.key)) {
        const value = child.value;
        const newValue2 = f232(value);
        if (newValue2 === value) return list;
        if (isNone224(newValue2)) {
          --size434.value;
          return arraySpliceOut5(mutate234, i232, list);
        }
        return arrayUpdate5(mutate234, i232, new LeafNode5(edit, hash2234, key, newValue2), list);
      }
    }
    const newValue = f232(none224());
    if (isNone224(newValue)) return list;
    ++size434.value;
    return arrayUpdate5(mutate234, len, new LeafNode5(edit, hash2234, key, newValue), list);
  }
};
var IndexedNode5 = class _IndexedNode5 {
  edit;
  mask;
  children;
  _tag = "IndexedNode";
  constructor(edit, mask, children) {
    this.edit = edit;
    this.mask = mask;
    this.children = children;
  }
  modify(edit, shift32, f232, hash2234, key, size434) {
    const mask = this.mask;
    const children = this.children;
    const frag = hashFragment5(shift32, hash2234);
    const bit = toBitmap5(frag);
    const indx = fromBitmap5(mask, bit);
    const exists2234 = mask & bit;
    const canEdit = canEditNode5(this, edit);
    if (!exists2234) {
      const _newChild = new EmptyNode5().modify(edit, shift32 + SIZE5, f232, hash2234, key, size434);
      if (!_newChild) return this;
      return children.length >= MAX_INDEX_NODE5 ? expand5(edit, frag, _newChild, mask, children) : new _IndexedNode5(edit, mask | bit, arraySpliceIn5(canEdit, indx, _newChild, children));
    }
    const current = children[indx];
    const child = current.modify(edit, shift32 + SIZE5, f232, hash2234, key, size434);
    if (current === child) return this;
    let bitmap = mask;
    let newChildren;
    if (isEmptyNode5(child)) {
      bitmap &= ~bit;
      if (!bitmap) return new EmptyNode5();
      if (children.length <= 2 && isLeafNode5(children[indx ^ 1])) {
        return children[indx ^ 1];
      }
      newChildren = arraySpliceOut5(canEdit, indx, children);
    } else {
      newChildren = arrayUpdate5(canEdit, indx, child, children);
    }
    if (canEdit) {
      this.mask = bitmap;
      this.children = newChildren;
      return this;
    }
    return new _IndexedNode5(edit, bitmap, newChildren);
  }
};
var ArrayNode5 = class _ArrayNode5 {
  edit;
  size;
  children;
  _tag = "ArrayNode";
  constructor(edit, size434, children) {
    this.edit = edit;
    this.size = size434;
    this.children = children;
  }
  modify(edit, shift32, f232, hash2234, key, size434) {
    let count = this.size;
    const children = this.children;
    const frag = hashFragment5(shift32, hash2234);
    const child = children[frag];
    const newChild = (child || new EmptyNode5()).modify(edit, shift32 + SIZE5, f232, hash2234, key, size434);
    if (child === newChild) return this;
    const canEdit = canEditNode5(this, edit);
    let newChildren;
    if (isEmptyNode5(child) && !isEmptyNode5(newChild)) {
      ++count;
      newChildren = arrayUpdate5(canEdit, frag, newChild, children);
    } else if (!isEmptyNode5(child) && isEmptyNode5(newChild)) {
      --count;
      if (count <= MIN_ARRAY_NODE5) {
        return pack5(edit, count, frag, children);
      }
      newChildren = arrayUpdate5(canEdit, frag, new EmptyNode5(), children);
    } else {
      newChildren = arrayUpdate5(canEdit, frag, newChild, children);
    }
    if (canEdit) {
      this.size = count;
      this.children = newChildren;
      return this;
    }
    return new _ArrayNode5(edit, count, newChildren);
  }
};
function pack5(edit, count, removed, elements) {
  const children = new Array(count - 1);
  let g232 = 0;
  let bitmap = 0;
  for (let i232 = 0, len = elements.length; i232 < len; ++i232) {
    if (i232 !== removed) {
      const elem = elements[i232];
      if (elem && !isEmptyNode5(elem)) {
        children[g232++] = elem;
        bitmap |= 1 << i232;
      }
    }
  }
  return new IndexedNode5(edit, bitmap, children);
}
function expand5(edit, frag, child, bitmap, subNodes) {
  const arr = [];
  let bit = bitmap;
  let count = 0;
  for (let i232 = 0; bit; ++i232) {
    if (bit & 1) arr[i232] = subNodes[count++];
    bit >>>= 1;
  }
  arr[frag] = child;
  return new ArrayNode5(edit, count + 1, arr);
}
function mergeLeavesInner5(edit, shift32, h1, n1, h232, n232) {
  if (h1 === h232) return new CollisionNode5(edit, h1, [n232, n1]);
  const subH1 = hashFragment5(shift32, h1);
  const subH2 = hashFragment5(shift32, h232);
  if (subH1 === subH2) {
    return (child) => new IndexedNode5(edit, toBitmap5(subH1) | toBitmap5(subH2), [child]);
  } else {
    const children = subH1 < subH2 ? [n1, n232] : [n232, n1];
    return new IndexedNode5(edit, toBitmap5(subH1) | toBitmap5(subH2), children);
  }
}
function mergeLeaves5(edit, shift32, h1, n1, h232, n232) {
  let stack = void 0;
  let currentShift = shift32;
  while (true) {
    const res = mergeLeavesInner5(edit, currentShift, h1, n1, h232, n232);
    if (typeof res === "function") {
      stack = make55(res, stack);
      currentShift = currentShift + SIZE5;
    } else {
      let final = res;
      while (stack != null) {
        final = stack.value(final);
        stack = stack.previous;
      }
      return final;
    }
  }
}
var HashMapSymbolKey5 = "effect/HashMap";
var HashMapTypeId5 = /* @__PURE__ */ Symbol.for(HashMapSymbolKey5);
var HashMapProto5 = {
  [HashMapTypeId5]: HashMapTypeId5,
  [Symbol.iterator]() {
    return new HashMapIterator5(this, (k232, v232) => [k232, v232]);
  },
  [symbol34]() {
    let hash2234 = hash24(HashMapSymbolKey5);
    for (const item of this) {
      hash2234 ^= pipe24(hash24(item[0]), combine25(hash24(item[1])));
    }
    return cached24(this, hash2234);
  },
  [symbol224](that) {
    if (isHashMap5(that)) {
      if (that._size !== this._size) {
        return false;
      }
      for (const item of this) {
        const elem = pipe24(that, getHash5(item[0], hash24(item[0])));
        if (isNone224(elem)) {
          return false;
        } else {
          if (!equals24(item[1], elem.value)) {
            return false;
          }
        }
      }
      return true;
    }
    return false;
  },
  toString() {
    return format24(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashMap",
      values: Array.from(this).map(toJSON24)
    };
  },
  [NodeInspectSymbol24]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments24(this, arguments);
  }
};
var makeImpl6 = (editable, edit, root, size434) => {
  const map632 = Object.create(HashMapProto5);
  map632._editable = editable;
  map632._edit = edit;
  map632._root = root;
  map632._size = size434;
  return map632;
};
var HashMapIterator5 = class _HashMapIterator5 {
  map;
  f;
  v;
  constructor(map632, f232) {
    this.map = map632;
    this.f = f232;
    this.v = visitLazy5(this.map._root, this.f, void 0);
  }
  next() {
    if (isNone224(this.v)) {
      return {
        done: true,
        value: void 0
      };
    }
    const v0 = this.v.value;
    this.v = applyCont5(v0.cont);
    return {
      done: false,
      value: v0.value
    };
  }
  [Symbol.iterator]() {
    return new _HashMapIterator5(this.map, this.f);
  }
};
var applyCont5 = (cont) => cont ? visitLazyChildren5(cont[0], cont[1], cont[2], cont[3], cont[4]) : none224();
var visitLazy5 = (node, f232, cont = void 0) => {
  switch (node._tag) {
    case "LeafNode": {
      if (isSome224(node.value)) {
        return some324({
          value: f232(node.key, node.value.value),
          cont
        });
      }
      return applyCont5(cont);
    }
    case "CollisionNode":
    case "ArrayNode":
    case "IndexedNode": {
      const children = node.children;
      return visitLazyChildren5(children.length, children, 0, f232, cont);
    }
    default: {
      return applyCont5(cont);
    }
  }
};
var visitLazyChildren5 = (len, children, i232, f232, cont) => {
  while (i232 < len) {
    const child = children[i232++];
    if (child && !isEmptyNode5(child)) {
      return visitLazy5(child, f232, [len, children, i232, f232, cont]);
    }
  }
  return applyCont5(cont);
};
var _empty35 = /* @__PURE__ */ makeImpl6(false, 0, /* @__PURE__ */ new EmptyNode5(), 0);
var empty45 = () => _empty35;
var isHashMap5 = (u232) => hasProperty24(u232, HashMapTypeId5);
var getHash5 = /* @__PURE__ */ dual24(3, (self2, key, hash2234) => {
  let node = self2._root;
  let shift32 = 0;
  while (true) {
    switch (node._tag) {
      case "LeafNode": {
        return equals24(key, node.key) ? node.value : none224();
      }
      case "CollisionNode": {
        if (hash2234 === node.hash) {
          const children = node.children;
          for (let i232 = 0, len = children.length; i232 < len; ++i232) {
            const child = children[i232];
            if ("key" in child && equals24(key, child.key)) {
              return child.value;
            }
          }
        }
        return none224();
      }
      case "IndexedNode": {
        const frag = hashFragment5(shift32, hash2234);
        const bit = toBitmap5(frag);
        if (node.mask & bit) {
          node = node.children[fromBitmap5(node.mask, bit)];
          shift32 += SIZE5;
          break;
        }
        return none224();
      }
      case "ArrayNode": {
        node = node.children[hashFragment5(shift32, hash2234)];
        if (node) {
          shift32 += SIZE5;
          break;
        }
        return none224();
      }
      default:
        return none224();
    }
  }
});
var set24 = /* @__PURE__ */ dual24(3, (self2, key, value) => modifyAt5(self2, key, () => some324(value)));
var setTree5 = /* @__PURE__ */ dual24(3, (self2, newRoot, newSize) => {
  if (self2._editable) {
    self2._root = newRoot;
    self2._size = newSize;
    return self2;
  }
  return newRoot === self2._root ? self2 : makeImpl6(self2._editable, self2._edit, newRoot, newSize);
});
var keys7 = (self2) => new HashMapIterator5(self2, (key) => key);
var size8 = (self2) => self2._size;
var beginMutation6 = (self2) => makeImpl6(true, self2._edit + 1, self2._root, self2._size);
var modifyAt5 = /* @__PURE__ */ dual24(3, (self2, key, f232) => modifyHash5(self2, key, hash24(key), f232));
var modifyHash5 = /* @__PURE__ */ dual24(4, (self2, key, hash2234, f232) => {
  const size434 = {
    value: self2._size
  };
  const newRoot = self2._root.modify(self2._editable ? self2._edit : NaN, 0, f232, hash2234, key, size434);
  return pipe24(self2, setTree5(newRoot, size434.value));
});
var forEach8 = /* @__PURE__ */ dual24(2, (self2, f232) => reduce25(self2, void 0, (_232, value, key) => f232(value, key)));
var reduce25 = /* @__PURE__ */ dual24(3, (self2, zero, f232) => {
  const root = self2._root;
  if (root._tag === "LeafNode") {
    return isSome224(root.value) ? f232(zero, root.value.value, root.key) : zero;
  }
  if (root._tag === "EmptyNode") {
    return zero;
  }
  const toVisit = [root.children];
  let children;
  while (children = toVisit.pop()) {
    for (let i232 = 0, len = children.length; i232 < len; ) {
      const child = children[i232++];
      if (child && !isEmptyNode5(child)) {
        if (child._tag === "LeafNode") {
          if (isSome224(child.value)) {
            zero = f232(zero, child.value.value, child.key);
          }
        } else {
          toVisit.push(child.children);
        }
      }
    }
  }
  return zero;
});
var HashSetSymbolKey5 = "effect/HashSet";
var HashSetTypeId5 = /* @__PURE__ */ Symbol.for(HashSetSymbolKey5);
var HashSetProto5 = {
  [HashSetTypeId5]: HashSetTypeId5,
  [Symbol.iterator]() {
    return keys7(this._keyMap);
  },
  [symbol34]() {
    return cached24(this, combine25(hash24(this._keyMap))(hash24(HashSetSymbolKey5)));
  },
  [symbol224](that) {
    if (isHashSet5(that)) {
      return size8(this._keyMap) === size8(that._keyMap) && equals24(this._keyMap, that._keyMap);
    }
    return false;
  },
  toString() {
    return format24(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashSet",
      values: Array.from(this).map(toJSON24)
    };
  },
  [NodeInspectSymbol24]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments24(this, arguments);
  }
};
var makeImpl25 = (keyMap) => {
  const set2234 = Object.create(HashSetProto5);
  set2234._keyMap = keyMap;
  return set2234;
};
var isHashSet5 = (u232) => hasProperty24(u232, HashSetTypeId5);
var _empty45 = /* @__PURE__ */ makeImpl25(/* @__PURE__ */ empty45());
var empty55 = () => _empty45;
var size25 = (self2) => size8(self2._keyMap);
var beginMutation25 = (self2) => makeImpl25(beginMutation6(self2._keyMap));
var endMutation5 = (self2) => {
  self2._keyMap._editable = false;
  return self2;
};
var mutate5 = /* @__PURE__ */ dual24(2, (self2, f232) => {
  const transient = beginMutation25(self2);
  f232(transient);
  return endMutation5(transient);
});
var add25 = /* @__PURE__ */ dual24(2, (self2, value) => self2._keyMap._editable ? (set24(value, true)(self2._keyMap), self2) : makeImpl25(set24(value, true)(self2._keyMap)));
var union25 = /* @__PURE__ */ dual24(2, (self2, that) => mutate5(empty55(), (set2234) => {
  forEach25(self2, (value) => add25(set2234, value));
  for (const value of that) {
    add25(set2234, value);
  }
}));
var forEach25 = /* @__PURE__ */ dual24(2, (self2, f232) => forEach8(self2._keyMap, (_232, k232) => f232(k232)));
var empty65 = empty55;
var size35 = size25;
var add35 = add25;
var union35 = union25;
var ArrayProto5 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(Array.prototype), {
  [symbol34]() {
    return cached24(this, array9(this));
  },
  [symbol224](that) {
    if (Array.isArray(that) && this.length === that.length) {
      return this.every((v232, i232) => equals24(v232, that[i232]));
    } else {
      return false;
    }
  }
});
var Structural6 = /* @__PURE__ */ function() {
  function Structural334(args) {
    if (args) {
      Object.assign(this, args);
    }
  }
  Structural334.prototype = StructuralPrototype24;
  return Structural334;
}();
var struct25 = (as2234) => Object.assign(Object.create(StructuralPrototype24), as2234);
var ContextPatchTypeId5 = /* @__PURE__ */ Symbol.for("effect/DifferContextPatch");
function variance6(a232) {
  return a232;
}
var PatchProto5 = {
  ...Structural6.prototype,
  [ContextPatchTypeId5]: {
    _Value: variance6,
    _Patch: variance6
  }
};
var EmptyProto5 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto5), {
  _tag: "Empty"
});
var _empty55 = /* @__PURE__ */ Object.create(EmptyProto5);
var empty75 = () => _empty55;
var AndThenProto5 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto5), {
  _tag: "AndThen"
});
var makeAndThen5 = (first, second) => {
  const o232 = Object.create(AndThenProto5);
  o232.first = first;
  o232.second = second;
  return o232;
};
var AddServiceProto5 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto5), {
  _tag: "AddService"
});
var makeAddService5 = (key, service) => {
  const o232 = Object.create(AddServiceProto5);
  o232.key = key;
  o232.service = service;
  return o232;
};
var RemoveServiceProto5 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto5), {
  _tag: "RemoveService"
});
var makeRemoveService5 = (key) => {
  const o232 = Object.create(RemoveServiceProto5);
  o232.key = key;
  return o232;
};
var UpdateServiceProto5 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto5), {
  _tag: "UpdateService"
});
var makeUpdateService5 = (key, update232) => {
  const o232 = Object.create(UpdateServiceProto5);
  o232.key = key;
  o232.update = update232;
  return o232;
};
var diff5 = (oldValue, newValue) => {
  const missingServices = new Map(oldValue.unsafeMap);
  let patch234 = empty75();
  for (const [tag, newService] of newValue.unsafeMap.entries()) {
    if (missingServices.has(tag)) {
      const old = missingServices.get(tag);
      missingServices.delete(tag);
      if (!equals24(old, newService)) {
        patch234 = combine224(makeUpdateService5(tag, () => newService))(patch234);
      }
    } else {
      missingServices.delete(tag);
      patch234 = combine224(makeAddService5(tag, newService))(patch234);
    }
  }
  for (const [tag] of missingServices.entries()) {
    patch234 = combine224(makeRemoveService5(tag))(patch234);
  }
  return patch234;
};
var combine224 = /* @__PURE__ */ dual24(2, (self2, that) => makeAndThen5(self2, that));
var patch5 = /* @__PURE__ */ dual24(2, (self2, context) => {
  if (self2._tag === "Empty") {
    return context;
  }
  let wasServiceUpdated = false;
  let patches = of6(self2);
  const updatedContext = new Map(context.unsafeMap);
  while (isNonEmpty5(patches)) {
    const head232 = headNonEmpty6(patches);
    const tail42 = tailNonEmpty6(patches);
    switch (head232._tag) {
      case "Empty": {
        patches = tail42;
        break;
      }
      case "AddService": {
        updatedContext.set(head232.key, head232.service);
        patches = tail42;
        break;
      }
      case "AndThen": {
        patches = prepend7(prepend7(tail42, head232.second), head232.first);
        break;
      }
      case "RemoveService": {
        updatedContext.delete(head232.key);
        patches = tail42;
        break;
      }
      case "UpdateService": {
        updatedContext.set(head232.key, head232.update(updatedContext.get(head232.key)));
        wasServiceUpdated = true;
        patches = tail42;
        break;
      }
    }
  }
  if (!wasServiceUpdated) {
    return makeContext5(updatedContext);
  }
  const map632 = /* @__PURE__ */ new Map();
  for (const [tag] of context.unsafeMap) {
    if (updatedContext.has(tag)) {
      map632.set(tag, updatedContext.get(tag));
      updatedContext.delete(tag);
    }
  }
  for (const [tag, s232] of updatedContext) {
    map632.set(tag, s232);
  }
  return makeContext5(map632);
});
var DifferTypeId5 = /* @__PURE__ */ Symbol.for("effect/Differ");
var DifferProto5 = {
  [DifferTypeId5]: {
    _P: identity24,
    _V: identity24
  }
};
var make75 = (params) => {
  const differ = Object.create(DifferProto5);
  differ.empty = params.empty;
  differ.diff = params.diff;
  differ.combine = params.combine;
  differ.patch = params.patch;
  return differ;
};
var environment5 = () => make75({
  empty: empty75(),
  combine: (first, second) => combine224(second)(first),
  diff: (oldValue, newValue) => diff5(oldValue, newValue),
  patch: (patch234, oldValue) => patch5(oldValue)(patch234)
});
var OP_DIE5 = "Die";
var OP_EMPTY5 = "Empty";
var OP_FAIL5 = "Fail";
var OP_INTERRUPT5 = "Interrupt";
var OP_PARALLEL5 = "Parallel";
var OP_SEQUENTIAL5 = "Sequential";
var CauseSymbolKey5 = "effect/Cause";
var CauseTypeId5 = /* @__PURE__ */ Symbol.for(CauseSymbolKey5);
var variance25 = {
  /* c8 ignore next */
  _E: (_232) => _232
};
var proto5 = {
  [CauseTypeId5]: variance25,
  [symbol34]() {
    return pipe24(hash24(CauseSymbolKey5), combine25(hash24(flattenCause5(this))), cached24(this));
  },
  [symbol224](that) {
    return isCause5(that) && causeEquals5(this, that);
  },
  pipe() {
    return pipeArguments24(this, arguments);
  },
  toJSON() {
    switch (this._tag) {
      case "Empty":
        return {
          _id: "Cause",
          _tag: this._tag
        };
      case "Die":
        return {
          _id: "Cause",
          _tag: this._tag,
          defect: toJSON24(this.defect)
        };
      case "Interrupt":
        return {
          _id: "Cause",
          _tag: this._tag,
          fiberId: this.fiberId.toJSON()
        };
      case "Fail":
        return {
          _id: "Cause",
          _tag: this._tag,
          failure: toJSON24(this.error)
        };
      case "Sequential":
      case "Parallel":
        return {
          _id: "Cause",
          _tag: this._tag,
          left: toJSON24(this.left),
          right: toJSON24(this.right)
        };
    }
  },
  toString() {
    return pretty5(this);
  },
  [NodeInspectSymbol24]() {
    return this.toJSON();
  }
};
var fail6 = (error) => {
  const o232 = Object.create(proto5);
  o232._tag = OP_FAIL5;
  o232.error = error;
  return o232;
};
var parallel5 = (left334, right334) => {
  const o232 = Object.create(proto5);
  o232._tag = OP_PARALLEL5;
  o232.left = left334;
  o232.right = right334;
  return o232;
};
var sequential5 = (left334, right334) => {
  const o232 = Object.create(proto5);
  o232._tag = OP_SEQUENTIAL5;
  o232.left = left334;
  o232.right = right334;
  return o232;
};
var isCause5 = (u232) => hasProperty24(u232, CauseTypeId5);
var isInterruptedOnly5 = (self2) => reduceWithContext5(void 0, IsInterruptedOnlyCauseReducer5)(self2);
var causeEquals5 = (left334, right334) => {
  let leftStack = of6(left334);
  let rightStack = of6(right334);
  while (isNonEmpty5(leftStack) && isNonEmpty5(rightStack)) {
    const [leftParallel, leftSequential] = pipe24(headNonEmpty6(leftStack), reduce45([empty65(), empty35()], ([parallel234, sequential234], cause) => {
      const [par, seq] = evaluateCause5(cause);
      return some324([pipe24(parallel234, union35(par)), pipe24(sequential234, appendAll6(seq))]);
    }));
    const [rightParallel, rightSequential] = pipe24(headNonEmpty6(rightStack), reduce45([empty65(), empty35()], ([parallel234, sequential234], cause) => {
      const [par, seq] = evaluateCause5(cause);
      return some324([pipe24(parallel234, union35(par)), pipe24(sequential234, appendAll6(seq))]);
    }));
    if (!equals24(leftParallel, rightParallel)) {
      return false;
    }
    leftStack = leftSequential;
    rightStack = rightSequential;
  }
  return true;
};
var flattenCause5 = (cause) => {
  return flattenCauseLoop5(of6(cause), empty35());
};
var flattenCauseLoop5 = (causes, flattened) => {
  while (1) {
    const [parallel234, sequential234] = pipe24(causes, reduce9([empty65(), empty35()], ([parallel332, sequential332], cause) => {
      const [par, seq] = evaluateCause5(cause);
      return [pipe24(parallel332, union35(par)), pipe24(sequential332, appendAll6(seq))];
    }));
    const updated = size35(parallel234) > 0 ? pipe24(flattened, prepend7(parallel234)) : flattened;
    if (isEmpty6(sequential234)) {
      return reverse25(updated);
    }
    causes = sequential234;
    flattened = updated;
  }
  throw new Error(getBugErrorMessage24("Cause.flattenCauseLoop"));
};
var evaluateCause5 = (self2) => {
  let cause = self2;
  const stack = [];
  let _parallel = empty65();
  let _sequential = empty35();
  while (cause !== void 0) {
    switch (cause._tag) {
      case OP_EMPTY5: {
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_FAIL5: {
        _parallel = add35(_parallel, make424(cause._tag, cause.error));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_DIE5: {
        _parallel = add35(_parallel, make424(cause._tag, cause.defect));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_INTERRUPT5: {
        _parallel = add35(_parallel, make424(cause._tag, cause.fiberId));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_SEQUENTIAL5: {
        switch (cause.left._tag) {
          case OP_EMPTY5: {
            cause = cause.right;
            break;
          }
          case OP_SEQUENTIAL5: {
            cause = sequential5(cause.left.left, sequential5(cause.left.right, cause.right));
            break;
          }
          case OP_PARALLEL5: {
            cause = parallel5(sequential5(cause.left.left, cause.right), sequential5(cause.left.right, cause.right));
            break;
          }
          default: {
            _sequential = prepend7(_sequential, cause.right);
            cause = cause.left;
            break;
          }
        }
        break;
      }
      case OP_PARALLEL5: {
        stack.push(cause.right);
        cause = cause.left;
        break;
      }
    }
  }
  throw new Error(getBugErrorMessage24("Cause.evaluateCauseLoop"));
};
var IsInterruptedOnlyCauseReducer5 = {
  emptyCase: constTrue24,
  failCase: constFalse24,
  dieCase: constFalse24,
  interruptCase: constTrue24,
  sequentialCase: (_232, left334, right334) => left334 && right334,
  parallelCase: (_232, left334, right334) => left334 && right334
};
var OP_SEQUENTIAL_CASE5 = "SequentialCase";
var OP_PARALLEL_CASE5 = "ParallelCase";
var reduce45 = /* @__PURE__ */ dual24(3, (self2, zero, pf) => {
  let accumulator = zero;
  let cause = self2;
  const causes = [];
  while (cause !== void 0) {
    const option = pf(accumulator, cause);
    accumulator = isSome224(option) ? option.value : accumulator;
    switch (cause._tag) {
      case OP_SEQUENTIAL5: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      case OP_PARALLEL5: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      default: {
        cause = void 0;
        break;
      }
    }
    if (cause === void 0 && causes.length > 0) {
      cause = causes.pop();
    }
  }
  return accumulator;
});
var reduceWithContext5 = /* @__PURE__ */ dual24(3, (self2, context, reducer) => {
  const input = [self2];
  const output = [];
  while (input.length > 0) {
    const cause = input.pop();
    switch (cause._tag) {
      case OP_EMPTY5: {
        output.push(right224(reducer.emptyCase(context)));
        break;
      }
      case OP_FAIL5: {
        output.push(right224(reducer.failCase(context, cause.error)));
        break;
      }
      case OP_DIE5: {
        output.push(right224(reducer.dieCase(context, cause.defect)));
        break;
      }
      case OP_INTERRUPT5: {
        output.push(right224(reducer.interruptCase(context, cause.fiberId)));
        break;
      }
      case OP_SEQUENTIAL5: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left224({
          _tag: OP_SEQUENTIAL_CASE5
        }));
        break;
      }
      case OP_PARALLEL5: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left224({
          _tag: OP_PARALLEL_CASE5
        }));
        break;
      }
    }
  }
  const accumulator = [];
  while (output.length > 0) {
    const either = output.pop();
    switch (either._tag) {
      case "Left": {
        switch (either.left._tag) {
          case OP_SEQUENTIAL_CASE5: {
            const left334 = accumulator.pop();
            const right334 = accumulator.pop();
            const value = reducer.sequentialCase(context, left334, right334);
            accumulator.push(value);
            break;
          }
          case OP_PARALLEL_CASE5: {
            const left334 = accumulator.pop();
            const right334 = accumulator.pop();
            const value = reducer.parallelCase(context, left334, right334);
            accumulator.push(value);
            break;
          }
        }
        break;
      }
      case "Right": {
        accumulator.push(either.right);
        break;
      }
    }
  }
  if (accumulator.length === 0) {
    throw new Error("BUG: Cause.reduceWithContext - please report an issue at https://github.com/Effect-TS/effect/issues");
  }
  return accumulator.pop();
});
var pretty5 = (cause) => {
  if (isInterruptedOnly5(cause)) {
    return "All fibers interrupted without errors.";
  }
  return prettyErrors5(cause).map((e232) => e232.stack).join("\n");
};
var PrettyError5 = class extends globalThis.Error {
  span = void 0;
  constructor(originalError) {
    const prevLimit = Error.stackTraceLimit;
    Error.stackTraceLimit = 0;
    super(prettyErrorMessage5(originalError));
    Error.stackTraceLimit = prevLimit;
    this.name = originalError instanceof Error ? originalError.name : "Error";
    if (typeof originalError === "object" && originalError !== null) {
      if (spanSymbol6 in originalError) {
        this.span = originalError[spanSymbol6];
      }
      Object.keys(originalError).forEach((key) => {
        if (!(key in this)) {
          this[key] = originalError[key];
        }
      });
    }
    this.stack = prettyErrorStack5(this.message, originalError instanceof Error && originalError.stack ? originalError.stack : "", this.span);
  }
  toJSON() {
    const out = {
      message: this.message,
      stack: this.stack
    };
    if (this.span) {
      out.span = this.span;
    }
    return out;
  }
};
var prettyErrorMessage5 = (u232) => {
  if (typeof u232 === "string") {
    return `Error: ${u232}`;
  }
  try {
    if (hasProperty24(u232, "toString") && isFunction324(u232["toString"]) && u232["toString"] !== Object.prototype.toString && u232["toString"] !== globalThis.Array.prototype.toString) {
      return u232["toString"]();
    }
  } catch {
  }
  return `Error: ${JSON.stringify(u232)}`;
};
var locationRegex5 = /\((.*)\)/;
var spanToTrace5 = /* @__PURE__ */ globalValue24("effect/Tracer/spanToTrace", () => /* @__PURE__ */ new WeakMap());
var prettyErrorStack5 = (message, stack, span32) => {
  const out = [message];
  const lines = stack.split("\n");
  for (let i232 = 1; i232 < lines.length; i232++) {
    if (lines[i232].includes("Generator.next")) {
      break;
    }
    if (lines[i232].includes("effect_internal_function")) {
      out.pop();
      break;
    }
    out.push(lines[i232].replace(/at .*effect_instruction_i.*\((.*)\)/, "at $1").replace(/EffectPrimitive\.\w+/, "<anonymous>"));
  }
  if (span32) {
    let current = span32;
    let i232 = 0;
    while (current && current._tag === "Span" && i232 < 10) {
      const stackFn = spanToTrace5.get(current);
      if (typeof stackFn === "function") {
        const stack2 = stackFn();
        const locationMatch = stack2.match(locationRegex5);
        const location = locationMatch ? locationMatch[1] : stack2.replace(/^at /, "");
        out.push(`    at ${current.name} (${location})`);
      } else {
        out.push(`    at ${current.name}`);
      }
      current = getOrUndefined24(current.parent);
      i232++;
    }
  }
  return out.join("\n");
};
var spanSymbol6 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var prettyErrors5 = (cause) => reduceWithContext5(cause, void 0, {
  emptyCase: () => [],
  dieCase: (_232, unknownError) => {
    return [new PrettyError5(unknownError)];
  },
  failCase: (_232, error) => {
    return [new PrettyError5(error)];
  },
  interruptCase: () => [],
  parallelCase: (_232, l232, r232) => [...l232, ...r232],
  sequentialCase: (_232, l232, r232) => [...l232, ...r232]
});
var SingleShotGen224 = class _SingleShotGen24 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  next(a232) {
    return this.called ? {
      value: a232,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  return(a232) {
    return {
      value: a232,
      done: true
    };
  }
  throw(e232) {
    throw e232;
  }
  [Symbol.iterator]() {
    return new _SingleShotGen24(this.self);
  }
};
var spanTag5 = /* @__PURE__ */ GenericTag5("effect/ParentSpan");
var EffectTypeId224 = /* @__PURE__ */ Symbol.for("effect/Effect");
var EffectPrimitive5 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId224] = effectVariance24;
  constructor(_op) {
    this._op = _op;
  }
  [symbol224](that) {
    return this === that;
  }
  [symbol34]() {
    return cached24(this, random24(this));
  }
  pipe() {
    return pipeArguments24(this, arguments);
  }
  toJSON() {
    return {
      _id: "Effect",
      _op: this._op,
      effect_instruction_i0: toJSON24(this.effect_instruction_i0),
      effect_instruction_i1: toJSON24(this.effect_instruction_i1),
      effect_instruction_i2: toJSON24(this.effect_instruction_i2)
    };
  }
  toString() {
    return format24(this.toJSON());
  }
  [NodeInspectSymbol24]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen224(new YieldWrap24(this));
  }
};
var EffectPrimitiveFailure5 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId224] = effectVariance24;
  constructor(_op) {
    this._op = _op;
    this._tag = _op;
  }
  [symbol224](that) {
    return exitIsExit5(that) && that._op === "Failure" && // @ts-expect-error
    equals24(this.effect_instruction_i0, that.effect_instruction_i0);
  }
  [symbol34]() {
    return pipe24(
      // @ts-expect-error
      string24(this._tag),
      // @ts-expect-error
      combine25(hash24(this.effect_instruction_i0)),
      cached24(this)
    );
  }
  get cause() {
    return this.effect_instruction_i0;
  }
  pipe() {
    return pipeArguments24(this, arguments);
  }
  toJSON() {
    return {
      _id: "Exit",
      _tag: this._op,
      cause: this.cause.toJSON()
    };
  }
  toString() {
    return format24(this.toJSON());
  }
  [NodeInspectSymbol24]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen224(new YieldWrap24(this));
  }
};
var isEffect5 = (u232) => hasProperty24(u232, EffectTypeId224);
var withFiberRuntime5 = (withRuntime) => {
  const effect = new EffectPrimitive5(OP_WITH_RUNTIME5);
  effect.effect_instruction_i0 = withRuntime;
  return effect;
};
var spanSymbol25 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var originalSymbol5 = /* @__PURE__ */ Symbol.for("effect/OriginalAnnotation");
var capture5 = (obj, span32) => {
  if (isSome224(span32)) {
    return new Proxy(obj, {
      has(target, p232) {
        return p232 === spanSymbol25 || p232 === originalSymbol5 || p232 in target;
      },
      get(target, p232) {
        if (p232 === spanSymbol25) {
          return span32.value;
        }
        if (p232 === originalSymbol5) {
          return obj;
        }
        return target[p232];
      }
    });
  }
  return obj;
};
var fail25 = (error) => isObject24(error) && !(spanSymbol25 in error) ? withFiberRuntime5((fiber) => failCause5(fail6(capture5(error, currentSpanFromFiber5(fiber))))) : failCause5(fail6(error));
var failCause5 = (cause) => {
  const effect = new EffectPrimitiveFailure5(OP_FAILURE5);
  effect.effect_instruction_i0 = cause;
  return effect;
};
var FiberRefSymbolKey5 = "effect/FiberRef";
var FiberRefTypeId5 = /* @__PURE__ */ Symbol.for(FiberRefSymbolKey5);
var fiberRefVariance5 = {
  /* c8 ignore next */
  _A: (_232) => _232
};
var fiberRefUnsafeMakeContext5 = (initial) => {
  const differ = environment5();
  return fiberRefUnsafeMakePatch5(initial, {
    differ,
    fork: differ.empty
  });
};
var fiberRefUnsafeMakePatch5 = (initial, options) => ({
  [FiberRefTypeId5]: fiberRefVariance5,
  initial,
  diff: (oldValue, newValue) => options.differ.diff(oldValue, newValue),
  combine: (first, second) => options.differ.combine(first, second),
  patch: (patch234) => (oldValue) => options.differ.patch(patch234, oldValue),
  fork: options.fork,
  join: options.join ?? ((_232, n232) => n232),
  pipe() {
    return pipeArguments24(this, arguments);
  }
});
var currentContext5 = /* @__PURE__ */ globalValue24(/* @__PURE__ */ Symbol.for("effect/FiberRef/currentContext"), () => fiberRefUnsafeMakeContext5(empty25()));
var YieldableError5 = /* @__PURE__ */ function() {
  class YieldableError234 extends globalThis.Error {
    commit() {
      return fail25(this);
    }
    toString() {
      return this.message ? `${this.name}: ${this.message}` : this.name;
    }
    toJSON() {
      return {
        ...this
      };
    }
    [NodeInspectSymbol24]() {
      const stack = this.stack;
      if (stack) {
        return `${this.toString()}
${stack.split("\n").slice(1).join("\n")}`;
      }
      return this.toString();
    }
  }
  Object.assign(YieldableError234.prototype, StructuralCommitPrototype24);
  return YieldableError234;
}();
var exitIsExit5 = (u232) => isEffect5(u232) && "_tag" in u232 && (u232._tag === "Success" || u232._tag === "Failure");
var currentSpanFromFiber5 = (fiber) => {
  const span32 = fiber.getFiberRef(currentContext5).unsafeMap.get(spanTag5.key);
  return span32 !== void 0 && span32._tag === "Span" ? some324(span32) : none224();
};
var Data_exports24 = {};
__export24(Data_exports24, {
  Class: () => Class25,
  Error: () => Error25,
  Structural: () => Structural25,
  TaggedClass: () => TaggedClass5,
  TaggedError: () => TaggedError5,
  array: () => array25,
  case: () => _case5,
  struct: () => struct35,
  tagged: () => tagged5,
  taggedEnum: () => taggedEnum5,
  tuple: () => tuple25,
  unsafeArray: () => unsafeArray5,
  unsafeStruct: () => unsafeStruct5
});
var struct35 = struct25;
var unsafeStruct5 = (as2234) => Object.setPrototypeOf(as2234, StructuralPrototype24);
var tuple25 = (...as2234) => unsafeArray5(as2234);
var array25 = (as2234) => unsafeArray5(as2234.slice(0));
var unsafeArray5 = (as2234) => Object.setPrototypeOf(as2234, ArrayProto5);
var _case5 = () => (args) => args === void 0 ? Object.create(StructuralPrototype24) : struct35(args);
var tagged5 = (tag) => (args) => {
  const value = args === void 0 ? Object.create(StructuralPrototype24) : struct35(args);
  value._tag = tag;
  return value;
};
var Class25 = Structural6;
var TaggedClass5 = (tag) => {
  class Base extends Class25 {
    _tag = tag;
  }
  return Base;
};
var Structural25 = Structural6;
var taggedEnum5 = () => new Proxy({}, {
  get(_target, tag, _receiver) {
    if (tag === "$is") {
      return isTagged7;
    } else if (tag === "$match") {
      return taggedMatch5;
    }
    return tagged5(tag);
  }
});
function taggedMatch5() {
  if (arguments.length === 1) {
    const cases2 = arguments[0];
    return function(value2) {
      return cases2[value2._tag](value2);
    };
  }
  const value = arguments[0];
  const cases = arguments[1];
  return cases[value._tag](value);
}
var Error25 = /* @__PURE__ */ function() {
  return class Base extends YieldableError5 {
    constructor(args) {
      super();
      if (args) {
        Object.assign(this, args);
      }
    }
  };
}();
var TaggedError5 = (tag) => {
  class Base extends Error25 {
    _tag = tag;
  }
  Base.prototype.name = tag;
  return Base;
};
var traverseUp5 = Function_exports24.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType5.Program) return Option_exports24.none();
  return predicate(parent) ? Option_exports24.some(parent) : traverseUp5(parent, predicate);
});
var traverseUpGuard5 = Function_exports24.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType5.Program) return Option_exports24.none();
  return predicate(parent) ? Option_exports24.some(parent) : traverseUpGuard5(parent, predicate);
});
var ESLintCommunityESLintUtils5;
((ESLintCommunityESLintUtils234) => {
  ESLintCommunityESLintUtils234.getFunctionHeadLocation = getFunctionHeadLocation5;
  ESLintCommunityESLintUtils234.getFunctionNameWithKind = getFunctionNameWithKind5;
  ESLintCommunityESLintUtils234.getPropertyName = getPropertyName5;
  ESLintCommunityESLintUtils234.getStaticValue = getStaticValue6;
  ESLintCommunityESLintUtils234.getStringIfConstant = getStringIfConstant5;
  ESLintCommunityESLintUtils234.hasSideEffect = hasSideEffect5;
  ESLintCommunityESLintUtils234.isParenthesized = isParenthesized5;
})(ESLintCommunityESLintUtils5 || (ESLintCommunityESLintUtils5 = {}));
var Construction5 = Data_exports24.taggedEnum();
Construction5.None();
a4({
  type: N5.union([NodeType5.FunctionExpression, NodeType5.ArrowFunctionExpression]),
  parent: {
    type: NodeType5.Property,
    parent: {
      type: NodeType5.ObjectExpression
    }
  }
});
a4({
  type: N5.union([NodeType5.FunctionExpression, NodeType5.ArrowFunctionExpression]),
  parent: {
    type: NodeType5.MethodDefinition,
    parent: {
      type: NodeType5.ClassBody
    }
  }
});
a4({
  type: N5.union([NodeType5.FunctionExpression, NodeType5.ArrowFunctionExpression]),
  parent: {
    type: NodeType5.Property,
    parent: {
      type: NodeType5.ClassBody
    }
  }
});
function isInitExpression(node) {
  return node.type !== NodeType5.VariableDeclaration;
}
function getVariableInitExpression(at) {
  return (variable) => {
    return Function_exports7.pipe(
      Option_exports7.some(variable),
      Option_exports7.flatMapNullable((v232) => v232.defs.at(at)),
      Option_exports7.flatMap(
        (d232) => "init" in d232.node ? Option_exports7.fromNullable(d232.node.init) : Option_exports7.none()
      ),
      Option_exports7.filter(isInitExpression)
    );
  };
}
var RULE_NAME23 = "no-leaked-conditional-rendering";
var allowedVariants = [
  "nullish",
  "boolean",
  "string",
  "falsy string",
  "truthy boolean",
  "truthy string"
];
function inspectVariantTypes(types) {
  const variantTypes = /* @__PURE__ */ new Set();
  if (types.some((type) => isTypeFlagSet(type, ts25__default.default.TypeFlags.Null | ts25__default.default.TypeFlags.Undefined | ts25__default.default.TypeFlags.VoidLike))) {
    variantTypes.add("nullish");
  }
  const booleans = types.filter((type) => isTypeFlagSet(type, ts25__default.default.TypeFlags.BooleanLike));
  switch (true) {
    case (booleans.length === 1 && !!booleans[0]): {
      const [first] = booleans;
      Function_exports6.pipe(
        $(first).when(isTrueLiteralType, () => Option_exports6.some("truthy boolean")).when(isFalseLiteralType, () => Option_exports6.some("falsy boolean")).otherwise(Option_exports6.none),
        Option_exports6.map((v52) => variantTypes.add(v52))
      );
      break;
    }
    case booleans.length === 2: {
      variantTypes.add("boolean");
      break;
    }
  }
  const strings = types.filter((type) => isTypeFlagSet(type, ts25__default.default.TypeFlags.StringLike));
  if (strings.length > 0) {
    const evaluated = $(strings).when(
      (types2) => types2.every((type) => type.isStringLiteral() && type.value !== ""),
      Function_exports6.constant("truthy string")
    ).when(
      (types2) => types2.every((type) => type.isStringLiteral() && type.value === ""),
      Function_exports6.constant("falsy string")
    ).otherwise(Function_exports6.constant("string"));
    variantTypes.add(evaluated);
  }
  const numbers = types.filter(
    (type) => isTypeFlagSet(
      type,
      ts25__default.default.TypeFlags.NumberLike | ts25__default.default.TypeFlags.BigIntLike
    )
  );
  if (numbers.length > 0) {
    const evaluated = $(numbers).when(
      (types2) => types2.every((type) => type.isNumberLiteral() && type.value !== 0),
      Function_exports6.constant("truthy number")
    ).when(
      (types2) => types2.every((type) => type.isNumberLiteral() && type.value === 0),
      Function_exports6.constant("falsy number")
    ).otherwise(Function_exports6.constant("number"));
    variantTypes.add(evaluated);
  }
  if (types.some((type) => isTypeFlagSet(type, ts25__default.default.TypeFlags.EnumLike))) {
    variantTypes.add("enum");
  }
  if (types.some(
    (type) => !isTypeFlagSet(
      type,
      ts25__default.default.TypeFlags.Null | ts25__default.default.TypeFlags.Undefined | ts25__default.default.TypeFlags.VoidLike | ts25__default.default.TypeFlags.BooleanLike | ts25__default.default.TypeFlags.StringLike | ts25__default.default.TypeFlags.NumberLike | ts25__default.default.TypeFlags.BigIntLike | ts25__default.default.TypeFlags.TypeParameter | ts25__default.default.TypeFlags.Any | ts25__default.default.TypeFlags.Unknown | ts25__default.default.TypeFlags.Never
    )
  )) {
    variantTypes.add("object");
  }
  if (types.some(
    (type) => isTypeFlagSet(
      type,
      ts25__default.default.TypeFlags.TypeParameter | ts25__default.default.TypeFlags.Any | ts25__default.default.TypeFlags.Unknown
    )
  )) {
    variantTypes.add("any");
  }
  if (types.some((type) => isTypeFlagSet(type, ts25__default.default.TypeFlags.Never))) {
    variantTypes.add("never");
  }
  return variantTypes;
}
var no_leaked_conditional_rendering_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow problematic leaked values from being rendered",
      recommended: "recommended",
      requiresTypeChecking: true
    },
    messages: {
      NO_LEAKED_CONDITIONAL_RENDERING: "Potential leaked value that might cause unintentionally rendered values or rendering crashes"
    },
    schema: []
  },
  name: RULE_NAME23,
  create(context) {
    const services = utils.ESLintUtils.getParserServices(context);
    function checkExpression(node) {
      return $(node).when(isJSX, Option_exports6.none).with({ type: NodeType3.LogicalExpression, operator: "&&" }, ({ left: left94, right: right94 }) => {
        const isLeftUnaryNot = a({
          type: NodeType3.UnaryExpression,
          operator: "!"
        }, left94);
        if (isLeftUnaryNot) return checkExpression(right94);
        const leftType = typeUtils.getConstrainedTypeAtLocation(services, left94);
        const leftTypeVariants = inspectVariantTypes(unionTypeParts(leftType));
        const isLeftValid = Array.from(leftTypeVariants.values()).every((type) => allowedVariants.some((allowed) => allowed === type));
        if (isLeftValid) return checkExpression(right94);
        return Option_exports6.some({
          messageId: "NO_LEAKED_CONDITIONAL_RENDERING",
          node: left94
        });
      }).with({ type: NodeType3.ConditionalExpression }, ({ alternate, consequent }) => {
        return Option_exports6.orElse(checkExpression(consequent), () => checkExpression(alternate));
      }).with({ type: NodeType3.Identifier }, (n52) => {
        const initialScope = context.sourceCode.getScope(n52);
        return Function_exports6.pipe(
          findVariable5(n52.name, initialScope),
          Option_exports6.flatMap(getVariableInitExpression(0)),
          Option_exports6.flatMap(checkExpression)
        );
      }).otherwise(Option_exports6.none);
    }
    return {
      "JSXExpressionContainer > ConditionalExpression"(node) {
        Option_exports6.map(checkExpression(node), context.report);
      },
      "JSXExpressionContainer > LogicalExpression"(node) {
        Option_exports6.map(checkExpression(node), context.report);
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME24 = "no-missing-component-display-name";
var no_missing_component_display_name_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "require 'displayName' for memo and forwardRef components",
      requiresTypeChecking: false
    },
    messages: {
      NO_MISSING_COMPONENT_DISPLAY_NAME: "Add missing 'displayName' for component."
    },
    schema: []
  },
  name: RULE_NAME24,
  create(context) {
    const { ctx, listeners } = useComponentCollector(context);
    return {
      ...listeners,
      "Program:exit"(node) {
        const components = ctx.getAllComponents(node);
        for (const { displayName, flag, node: node2 } of components.values()) {
          const isMemoOrForwardRef = Boolean(flag & ERFunctionComponentFlag.ForwardRef) || Boolean(flag & ERFunctionComponentFlag.Memo);
          if (Option_exports6.isSome(getFunctionIdentifier(node2))) continue;
          if (!isMemoOrForwardRef) continue;
          if (Option_exports6.isNone(displayName)) {
            context.report({
              messageId: "NO_MISSING_COMPONENT_DISPLAY_NAME",
              node: node2
            });
          }
        }
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME25 = "no-missing-key";
var no_missing_key_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "require 'key' prop when rendering list",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_MISSING_KEY: "Missing 'key' prop for element when rendering list",
      NO_MISSING_KEY_WITH_FRAGMENT: "Use fragment component instead of '<>' because it does not support key prop"
    },
    schema: []
  },
  name: RULE_NAME25,
  create(context) {
    const childrenToArraySelector = getChildrenToArraySelector();
    const isWithinChildrenToArrayRef = MutableRef_exports4.make(false);
    function checkIteratorElement(node) {
      const initialScope = context.sourceCode.getScope(node);
      if (node.type === NodeType3.JSXElement && !hasProp(node.openingElement.attributes, "key", context, initialScope)) {
        return Option_exports6.some({
          messageId: "NO_MISSING_KEY",
          node
        });
      }
      if (node.type === NodeType3.JSXFragment) {
        return Option_exports6.some({
          messageId: "NO_MISSING_KEY_WITH_FRAGMENT",
          node
        });
      }
      return Option_exports6.none();
    }
    function checkExpression(node) {
      return $(node).with({ type: NodeType3.JSXElement }, checkIteratorElement).with({ type: NodeType3.JSXFragment }, checkIteratorElement).with({ type: NodeType3.ConditionalExpression }, (n52) => {
        if (!("consequent" in n52)) return Option_exports6.none();
        return Option_exports6.orElse(checkIteratorElement(n52.consequent), () => checkIteratorElement(n52.alternate));
      }).with({ type: NodeType3.LogicalExpression }, (n52) => {
        if (!("left" in n52)) return Option_exports6.none();
        return Option_exports6.orElse(checkIteratorElement(n52.left), () => checkIteratorElement(n52.right));
      }).otherwise(Option_exports6.none);
    }
    function checkBlockStatement(node) {
      return getNestedReturnStatements(node).reduce((acc, statement) => {
        if (!statement.argument) return acc;
        const maybeDescriptor = checkIteratorElement(statement.argument);
        if (Option_exports6.isNone(maybeDescriptor)) return acc;
        const descriptor = maybeDescriptor.value;
        return [...acc, descriptor];
      }, []);
    }
    return {
      [`${childrenToArraySelector}:exit`]() {
        MutableRef_exports4.set(isWithinChildrenToArrayRef, false);
      },
      ArrayExpression(node) {
        if (MutableRef_exports4.get(isWithinChildrenToArrayRef)) return;
        const elements = node.elements.filter(is3(NodeType3.JSXElement));
        if (elements.length === 0) return;
        const initialScope = context.sourceCode.getScope(node);
        for (const element of elements) {
          if (!hasProp(element.openingElement.attributes, "key", context, initialScope)) {
            context.report({
              messageId: "NO_MISSING_KEY",
              node: element
            });
          }
        }
      },
      CallExpression(node) {
        const isMapCall22 = a({
          callee: {
            type: NodeType3.MemberExpression,
            property: {
              name: "map"
            }
          }
        }, node);
        const isArrayFromCall = a({
          type: NodeType3.CallExpression,
          callee: {
            type: NodeType3.MemberExpression,
            property: {
              name: "from"
            }
          }
        }, node);
        if (!isMapCall22 && !isArrayFromCall) return;
        if (MutableRef_exports4.get(isWithinChildrenToArrayRef)) return;
        const fn = node.arguments[isMapCall22 ? 0 : 1];
        if (!isOneOf3([NodeType3.ArrowFunctionExpression, NodeType3.FunctionExpression])(fn)) return;
        if (fn.body.type === NodeType3.BlockStatement) {
          for (const descriptor of checkBlockStatement(fn.body)) {
            context.report(descriptor);
          }
          return;
        }
        Option_exports6.map(checkExpression(fn.body), context.report);
      },
      JSXFragment(node) {
        if (MutableRef_exports4.get(isWithinChildrenToArrayRef)) return;
        if (node.parent.type === NodeType3.ArrayExpression) {
          context.report({
            messageId: "NO_MISSING_KEY_WITH_FRAGMENT",
            node
          });
        }
      },
      [childrenToArraySelector]() {
        MutableRef_exports4.set(isWithinChildrenToArrayRef, true);
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME26 = "no-nested-components";
var no_nested_components_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow usage of unstable nested components",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NESTED_COMPONENT: "Do not nest components inside other components. Move it to the top level.",
      NESTED_COMPONENT_IN_PROPS: "Do not nest components inside props. Move it to the top level or pass it as a prop."
    },
    schema: []
  },
  name: RULE_NAME26,
  create(context) {
    const hint = ERComponentHint.SkipMapCallback | ERComponentHint.SkipNullLiteral | ERComponentHint.SkipUndefinedLiteral | ERComponentHint.SkipBooleanLiteral | ERComponentHint.SkipStringLiteral | ERComponentHint.SkipNumberLiteral | ERComponentHint.StrictLogical | ERComponentHint.StrictConditional;
    const collector = useComponentCollector(context, hint);
    const collectorLegacy = useComponentCollectorLegacy();
    return {
      ...collector.listeners,
      ...collectorLegacy.listeners,
      "Program:exit"(node) {
        const functionComponents = Array.from(collector.ctx.getAllComponents(node).values());
        const classComponents = Array.from(collectorLegacy.ctx.getAllComponents(node).values());
        const isFunctionComponent = (node2) => {
          return isFunction(node2) && functionComponents.some((component) => component.node === node2);
        };
        const isClassComponent22 = (node2) => {
          return isClass(node2) && classComponents.some((component) => component.node === node2);
        };
        for (const { name: componentName, node: component } of functionComponents) {
          if (unsafeIsDirectValueOfRenderProperty(component)) continue;
          if (Option_exports6.isNone(componentName)) continue;
          const name22 = componentName.value;
          const isInsideProperty = component.parent.type === NodeType3.Property;
          const isInsideJSXPropValue = isInsidePropValue(component);
          if (isInsideJSXPropValue) {
            if (!unsafeIsDeclaredInRenderProp(component)) {
              context.report({
                data: {
                  name: name22
                },
                messageId: "NESTED_COMPONENT_IN_PROPS",
                node: component
              });
            }
            continue;
          }
          if (isInsideCreateElementProps(component, context)) {
            context.report({
              data: {
                name: name22
              },
              messageId: "NESTED_COMPONENT_IN_PROPS",
              node: component
            });
            continue;
          }
          const maybeParentComponent = traverseUpGuard3(component, isFunctionComponent);
          if (Option_exports6.isSome(maybeParentComponent) && !unsafeIsDirectValueOfRenderProperty(maybeParentComponent.value)) {
            context.report({
              data: {
                name: name22
              },
              messageId: isInsideProperty ? "NESTED_COMPONENT_IN_PROPS" : "NESTED_COMPONENT",
              node: component
            });
            continue;
          }
          const isInsideClassComponentRenderMethod = isInsideRenderMethod(component);
          if (isInsideClassComponentRenderMethod) {
            context.report({
              data: {
                name: name22
              },
              messageId: "NESTED_COMPONENT",
              node: component
            });
          }
        }
        for (const { name: name22, node: component } of classComponents) {
          if (Option_exports6.isNone(traverseUp3(component, (node2) => isClassComponent22(node2) || isFunctionComponent(node2)))) continue;
          context.report({
            data: {
              name: Option_exports6.getOrElse(() => "unknown")(name22)
            },
            messageId: "NESTED_COMPONENT",
            node: component
          });
        }
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME27 = "no-redundant-should-component-update";
function isShouldComponentUpdate(node) {
  return isOneOf3([NodeType3.MethodDefinition, NodeType3.PropertyDefinition])(node) && node.key.type === NodeType3.Identifier && node.key.name === "shouldComponentUpdate";
}
var no_redundant_should_component_update_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow usage of 'shouldComponentUpdate' in class component extends 'React.PureComponent'",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_REDUNDANT_SHOULD_COMPONENT_UPDATE: "'{{componentName}}' does not need 'shouldComponentUpdate' when extending 'React.PureComponent'."
    },
    schema: []
  },
  name: RULE_NAME27,
  create(context) {
    const { ctx, listeners } = useComponentCollectorLegacy();
    return {
      ...listeners,
      "Program:exit"(node) {
        const components = ctx.getAllComponents(node);
        for (const { name: name22, flag, node: component } of components.values()) {
          if (!(flag & ERClassComponentFlag.PureComponent)) continue;
          const { body } = component.body;
          for (const member of body) {
            if (isShouldComponentUpdate(member)) {
              context.report({
                data: {
                  componentName: Option_exports6.getOrElse(() => "PureComponent")(name22)
                },
                messageId: "NO_REDUNDANT_SHOULD_COMPONENT_UPDATE",
                node: member
              });
            }
          }
        }
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME28 = "no-set-state-in-component-did-mount";
function isThisSetState2(node) {
  const { callee } = node;
  return callee.type === NodeType3.MemberExpression && callee.object.type === NodeType3.ThisExpression && callee.property.type === NodeType3.Identifier && callee.property.name === "setState";
}
function isComponentDidMount(node) {
  return isOneOf3([NodeType3.MethodDefinition, NodeType3.PropertyDefinition])(node) && node.key.type === NodeType3.Identifier && node.key.name === "componentDidMount";
}
var no_set_state_in_component_did_mount_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow 'setState' in 'componentDidMount'",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_SET_STATE_IN_COMPONENT_DID_MOUNT: "Do not call `this.setState` in `componentDidMount` outside of functions, such as callbacks."
    },
    schema: []
  },
  name: RULE_NAME28,
  create(context) {
    return {
      CallExpression(node) {
        if (!isThisSetState2(node)) return;
        const maybeParentClass = traverseUp3(node, isOneOf3([NodeType3.ClassDeclaration, NodeType3.ClassExpression]));
        if (Option_exports6.isNone(maybeParentClass)) return;
        const parentClass = maybeParentClass.value;
        if (!isClassComponent(parentClass)) return;
        const maybeParentMethod = traverseUp3(node, isComponentDidMount);
        if (Option_exports6.isNone(maybeParentMethod)) return;
        const parentMethod = maybeParentMethod.value;
        if (parentMethod.parent !== parentClass.body) return;
        if (context.sourceCode.getScope(node).upper !== context.sourceCode.getScope(parentMethod)) return;
        context.report({
          messageId: "NO_SET_STATE_IN_COMPONENT_DID_MOUNT",
          node
        });
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME29 = "no-set-state-in-component-did-update";
function isThisSetState3(node) {
  const { callee } = node;
  return callee.type === NodeType3.MemberExpression && callee.object.type === NodeType3.ThisExpression && callee.property.type === NodeType3.Identifier && callee.property.name === "setState";
}
function isComponentDidUpdate(node) {
  return isOneOf3([NodeType3.MethodDefinition, NodeType3.PropertyDefinition])(node) && node.key.type === NodeType3.Identifier && node.key.name === "componentDidUpdate";
}
var no_set_state_in_component_did_update_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow 'setState' in 'componentDidUpdate'",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_SET_STATE_IN_COMPONENT_DID_UPDATE: "Do not call `this.setState` in `componentDidUpdate` outside of functions, such as callbacks."
    },
    schema: []
  },
  name: RULE_NAME29,
  create(context) {
    return {
      CallExpression(node) {
        if (!isThisSetState3(node)) return;
        const maybeParentClass = traverseUp3(node, isOneOf3([NodeType3.ClassDeclaration, NodeType3.ClassExpression]));
        if (Option_exports6.isNone(maybeParentClass)) return;
        const parentClass = maybeParentClass.value;
        if (!isClassComponent(parentClass)) return;
        const maybeParentMethod = traverseUp3(node, isComponentDidUpdate);
        if (Option_exports6.isNone(maybeParentMethod)) return;
        const parentMethod = maybeParentMethod.value;
        if (parentMethod.parent !== parentClass.body) return;
        if (context.sourceCode.getScope(node).upper !== context.sourceCode.getScope(parentMethod)) return;
        context.report({
          messageId: "NO_SET_STATE_IN_COMPONENT_DID_UPDATE",
          node
        });
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME30 = "no-set-state-in-component-will-update";
function isThisSetState4(node) {
  const { callee } = node;
  return callee.type === NodeType3.MemberExpression && callee.object.type === NodeType3.ThisExpression && callee.property.type === NodeType3.Identifier && callee.property.name === "setState";
}
function isComponentWillUpdate3(node) {
  return isOneOf3([NodeType3.MethodDefinition, NodeType3.PropertyDefinition])(node) && node.key.type === NodeType3.Identifier && node.key.name === "componentWillUpdate";
}
var no_set_state_in_component_will_update_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow 'setState' in 'componentWillUpdate'",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_SET_STATE_IN_COMPONENT_WILL_UPDATE: "Do not call `this.setState` in `componentWillUpdate` outside of functions, such as callbacks."
    },
    schema: []
  },
  name: RULE_NAME30,
  create(context) {
    return {
      CallExpression(node) {
        if (!isThisSetState4(node)) return;
        const maybeParentClass = traverseUp3(node, isOneOf3([NodeType3.ClassDeclaration, NodeType3.ClassExpression]));
        if (Option_exports6.isNone(maybeParentClass)) return;
        const parentClass = maybeParentClass.value;
        if (!isClassComponent(parentClass)) return;
        const maybeParentMethod = traverseUp3(node, isComponentWillUpdate3);
        if (Option_exports6.isNone(maybeParentMethod)) return;
        const parentMethod = maybeParentMethod.value;
        if (parentMethod.parent !== parentClass.body) return;
        if (context.sourceCode.getScope(node).upper !== context.sourceCode.getScope(parentMethod)) return;
        context.report({
          messageId: "NO_SET_STATE_IN_COMPONENT_WILL_UPDATE",
          node
        });
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME31 = "no-string-refs";
function containsStringLiteral({ value }) {
  return value?.type === NodeType3.Literal && Predicate_exports5.isString(value.value);
}
function containsStringExpressionContainer({ value }) {
  if (value?.type !== NodeType3.JSXExpressionContainer) return false;
  if (value.expression.type === NodeType3.Literal) return Predicate_exports5.isString(value.expression.value);
  return value.expression.type === NodeType3.TemplateLiteral;
}
var no_string_refs_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow using deprecated string refs",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_STRING_REFS: "[Deprecated] Use callback refs instead."
    },
    schema: []
  },
  name: RULE_NAME31,
  create(context) {
    return {
      JSXAttribute(node) {
        if (node.name.name !== "ref") return;
        if (containsStringLiteral(node) || containsStringExpressionContainer(node)) {
          context.report({
            messageId: "NO_STRING_REFS",
            node
          });
        }
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME32 = "no-unsafe-component-will-mount";
function isUnsafeComponentWillMount(node) {
  return isOneOf3([NodeType3.MethodDefinition, NodeType3.PropertyDefinition])(node) && node.key.type === NodeType3.Identifier && node.key.name === "UNSAFE_componentWillMount";
}
var no_unsafe_component_will_mount_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow usage of 'UNSAFE_componentWillMount'",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_UNSAFE_COMPONENT_WILL_MOUNT: "Do not use 'UNSAFE_componentWillMount'."
    },
    schema: []
  },
  name: RULE_NAME32,
  create(context) {
    const { ctx, listeners } = useComponentCollectorLegacy();
    return {
      ...listeners,
      "Program:exit"(node) {
        const components = ctx.getAllComponents(node);
        for (const { node: component } of components.values()) {
          const { body } = component.body;
          for (const member of body) {
            if (isUnsafeComponentWillMount(member)) {
              context.report({
                messageId: "NO_UNSAFE_COMPONENT_WILL_MOUNT",
                node: member
              });
            }
          }
        }
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME33 = "no-unsafe-component-will-receive-props";
function isUnsafeComponentWillReceiveProps(node) {
  return isOneOf3([NodeType3.MethodDefinition, NodeType3.PropertyDefinition])(node) && node.key.type === NodeType3.Identifier && node.key.name === "UNSAFE_componentWillReceiveProps";
}
var no_unsafe_component_will_receive_props_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow usage of 'UNSAFE_componentWillReceiveProps'",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_UNSAFE_COMPONENT_WILL_RECEIVE_PROPS: "Do not use 'UNSAFE_componentWillReceiveProps'."
    },
    schema: []
  },
  name: RULE_NAME33,
  create(context) {
    const { ctx, listeners } = useComponentCollectorLegacy();
    return {
      ...listeners,
      "Program:exit"(node) {
        const components = ctx.getAllComponents(node);
        for (const { node: component } of components.values()) {
          const { body } = component.body;
          for (const member of body) {
            if (isUnsafeComponentWillReceiveProps(member)) {
              context.report({
                messageId: "NO_UNSAFE_COMPONENT_WILL_RECEIVE_PROPS",
                node: member
              });
            }
          }
        }
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME34 = "no-unsafe-component-will-update";
function isUnsafeComponentWillMount2(node) {
  return isOneOf3([NodeType3.MethodDefinition, NodeType3.PropertyDefinition])(node) && node.key.type === NodeType3.Identifier && node.key.name === "UNSAFE_componentWillUpdate";
}
var no_unsafe_component_will_update_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow usage of 'UNSAFE_componentWillUpdate'",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_UNSAFE_COMPONENT_WILL_UPDATE: "Do not use 'UNSAFE_componentWillUpdate'."
    },
    schema: []
  },
  name: RULE_NAME34,
  create(context) {
    const { ctx, listeners } = useComponentCollectorLegacy();
    return {
      ...listeners,
      "Program:exit"(node) {
        const components = ctx.getAllComponents(node);
        for (const { node: component } of components.values()) {
          const { body } = component.body;
          for (const member of body) {
            if (isUnsafeComponentWillMount2(member)) {
              context.report({
                messageId: "NO_UNSAFE_COMPONENT_WILL_UPDATE",
                node: member
              });
            }
          }
        }
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME35 = "no-unstable-context-value";
var no_unstable_context_value_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow passing constructed values to context providers",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_UNSTABLE_CONTEXT_VALUE: "A/an '{{type}}' passed as the value prop to the context provider should not be constructed. It will change on every render.",
      NO_UNSTABLE_CONTEXT_VALUE_WITH_FUNCTION: "A/an '{{type}}' passed as the value prop to the context provider should not be constructed. It will change on every render. Consider wrapping it in a useCallback hook.",
      NO_UNSTABLE_CONTEXT_VALUE_WITH_IDENTIFIER: "A/an '{{type}}' passed as the value prop to the context provider should not be constructed. It will change on every render. Consider wrapping it in a useMemo hook."
    },
    schema: []
  },
  name: RULE_NAME35,
  create(context) {
    const { ctx, listeners } = useComponentCollector(context);
    const possibleValueConstructions = /* @__PURE__ */ new Map();
    return {
      ...listeners,
      JSXOpeningElement(node) {
        const openingElementName = node.name;
        if (openingElementName.type !== NodeType3.JSXMemberExpression) return;
        if (openingElementName.property.name !== "Provider") return;
        const maybeJSXValueAttribute = Option_exports6.fromNullable(
          node.attributes.find((attribute) => {
            return attribute.type === NodeType3.JSXAttribute && attribute.name.name === "value";
          })
        );
        if (Option_exports6.isNone(maybeJSXValueAttribute) || !("value" in maybeJSXValueAttribute.value)) return;
        const valueNode = maybeJSXValueAttribute.value.value;
        if (valueNode?.type !== NodeType3.JSXExpressionContainer) return;
        const valueExpression = valueNode.expression;
        const construction = inspectConstruction(valueExpression, context);
        if (construction._tag === "None") return;
        Option_exports6.map(
          ctx.getCurrentFunction(),
          ([currentFn]) => possibleValueConstructions.set(currentFn, [
            ...possibleValueConstructions.get(currentFn) ?? [],
            construction
          ])
        );
      },
      "Program:exit"(node) {
        const components = Array.from(ctx.getAllComponents(node).values());
        for (const { node: component } of components) {
          const constructions = possibleValueConstructions.get(component);
          if (!constructions) continue;
          for (const construction of constructions) {
            if (construction._tag === "None") continue;
            const { _tag, node: constructionNode } = construction;
            const messageId = _tag.startsWith("Function") ? "NO_UNSTABLE_CONTEXT_VALUE_WITH_FUNCTION" : "NO_UNSTABLE_CONTEXT_VALUE_WITH_IDENTIFIER";
            context.report({
              data: {
                type: readableNodeType(constructionNode)
              },
              messageId,
              node: constructionNode
            });
          }
        }
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME36 = "no-unstable-default-props";
var no_unstable_default_props_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow usage of unstable value as default param in function component",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_UNSTABLE_DEFAULT_PROPS: "A/an '{{forbiddenType}}' as default prop. This could lead to potential infinite render loop in React. Use a variable instead of '{{forbiddenType}}'."
    },
    schema: []
  },
  name: RULE_NAME36,
  create(context) {
    const { ctx, listeners } = useComponentCollector(context);
    const possibleDestructuringDeclarators = /* @__PURE__ */ new WeakMap();
    return {
      ...listeners,
      "Program:exit"(node) {
        const components = ctx.getAllComponents(node);
        for (const { node: component } of components.values()) {
          const { params } = component;
          const [props] = params;
          if (!props) continue;
          const properties = $(props).with({ type: NodeType3.ObjectPattern }, ({ properties: properties2 }) => properties2).with({ type: NodeType3.Identifier }, ({ name: name22 }) => {
            const variableDeclarators = possibleDestructuringDeclarators.get(component);
            if (!variableDeclarators) return [];
            const declarators = variableDeclarators.filter((d52) => d52.init.name === name22);
            return declarators.flatMap((d52) => d52.id.properties);
          }).otherwise(() => []);
          for (const prop of properties) {
            if (prop.type !== NodeType3.Property || prop.value.type !== NodeType3.AssignmentPattern) continue;
            const { value } = prop;
            const { right: right94 } = value;
            const construction = inspectConstruction(value, context, ConstructionHint.StrictCallExpression);
            if (construction._tag === "None") continue;
            const forbiddenType = readableNodeType(right94);
            context.report({
              data: {
                forbiddenType
              },
              messageId: "NO_UNSTABLE_DEFAULT_PROPS",
              node: right94
            });
          }
        }
      },
      "VariableDeclarator[id.type='ObjectPattern'][init.type='Identifier']"(node) {
        Option_exports6.map(
          ctx.getCurrentFunction(),
          ([currentFn]) => possibleDestructuringDeclarators.set(currentFn, [
            ...possibleDestructuringDeclarators.get(currentFn) ?? [],
            node
          ])
        );
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME37 = "no-unused-class-component-members";
var LIFECYCLE_METHODS = /* @__PURE__ */ new Set([
  "constructor",
  "componentDidCatch",
  "componentDidMount",
  "componentDidUpdate",
  "componentWillMount",
  "componentWillReceiveProps",
  "componentWillUnmount",
  "componentWillUpdate",
  "getSnapshotBeforeUpdate",
  "shouldComponentUpdate",
  "UNSAFE_componentWillMount",
  "UNSAFE_componentWillReceiveProps",
  "UNSAFE_componentWillUpdate",
  "state",
  "render"
]);
function isKeyLiteralLike2(node, property) {
  return property.type === NodeType3.Literal || property.type === NodeType3.TemplateLiteral && property.expressions.length === 0 || !node.computed && property.type === NodeType3.Identifier;
}
function getName3(node) {
  if (node.type === NodeType3.TSAsExpression) {
    return getName3(node.expression);
  }
  if (node.type === NodeType3.Identifier || node.type === NodeType3.PrivateIdentifier) {
    return Option_exports6.some(node.name);
  }
  if (node.type === NodeType3.Literal) {
    return Option_exports6.some(String(node.value));
  }
  if (node.type === NodeType3.TemplateLiteral && node.expressions.length === 0) {
    return Option_exports6.fromNullable(node.quasis[0]?.value.raw);
  }
  return Option_exports6.none();
}
var no_unused_class_component_members_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow unused class component members",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_UNUSED_CLASS_COMPONENT_MEMBERS: "Unused method or property '{{methodName}}'' of class '{{className}}'."
    },
    schema: []
  },
  name: RULE_NAME37,
  create(context) {
    const classStack = MutableList_exports2.make();
    const methodStack = MutableList_exports2.make();
    const propertyDefs = /* @__PURE__ */ new WeakMap();
    const propertyUsages = /* @__PURE__ */ new WeakMap();
    function classEnter(node) {
      MutableList_exports2.append(classStack, node);
      if (!isClassComponent(node)) return;
      propertyDefs.set(node, /* @__PURE__ */ new Set());
      propertyUsages.set(node, /* @__PURE__ */ new Set());
    }
    function classExit() {
      const currentClass = MutableList_exports2.pop(classStack);
      if (!currentClass || !isClassComponent(currentClass)) return;
      const className = Option_exports6.map(getClassIdentifier(currentClass), (id) => id.name);
      const defs = propertyDefs.get(currentClass);
      const usages = propertyUsages.get(currentClass);
      if (!defs) return;
      for (const def of defs) {
        const name22 = getName3(def);
        if (Option_exports6.isNone(name22)) continue;
        if (!!usages?.has(name22.value) || LIFECYCLE_METHODS.has(name22.value)) continue;
        context.report({
          data: {
            className: Option_exports6.getOrElse(className, () => "Component"),
            methodName: name22.value
          },
          messageId: "NO_UNUSED_CLASS_COMPONENT_MEMBERS",
          node: def
        });
      }
    }
    function methodEnter(node) {
      MutableList_exports2.append(methodStack, node);
      const currentClass = MutableList_exports2.tail(classStack);
      if (!currentClass || !isClassComponent(currentClass)) return;
      if (node.static) return;
      if (isKeyLiteralLike2(node, node.key)) {
        propertyDefs.get(currentClass)?.add(node.key);
      }
    }
    function methodExit() {
      MutableList_exports2.pop(methodStack);
    }
    return {
      ClassDeclaration: classEnter,
      "ClassDeclaration:exit": classExit,
      ClassExpression: classEnter,
      "ClassExpression:exit": classExit,
      MemberExpression(node) {
        const currentClass = MutableList_exports2.tail(classStack);
        const currentMethod = MutableList_exports2.tail(methodStack);
        if (!currentClass || !currentMethod) return;
        if (!isClassComponent(currentClass) || currentMethod.static) return;
        if (!isThisExpression(node.object) || !isKeyLiteralLike2(node, node.property)) return;
        if (node.parent.type === NodeType3.AssignmentExpression && node.parent.left === node) {
          propertyDefs.get(currentClass)?.add(node.property);
          return;
        }
        Option_exports6.map(getName3(node.property), (name22) => propertyUsages.get(currentClass)?.add(name22));
      },
      MethodDefinition: methodEnter,
      "MethodDefinition:exit": methodExit,
      PropertyDefinition: methodEnter,
      "PropertyDefinition:exit": methodExit,
      VariableDeclarator(node) {
        const currentClass = MutableList_exports2.tail(classStack);
        const currentMethod = MutableList_exports2.tail(methodStack);
        if (!currentClass || !currentMethod) return;
        if (!isClassComponent(currentClass) || currentMethod.static) return;
        if (node.init && isThisExpression(node.init) && node.id.type === NodeType3.ObjectPattern) {
          for (const prop of node.id.properties) {
            if (prop.type === NodeType3.Property && isKeyLiteralLike2(prop, prop.key)) {
              Option_exports6.map(getName3(prop.key), (name22) => propertyUsages.get(currentClass)?.add(name22));
            }
          }
        }
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME38 = "no-unused-state";
function isKeyLiteralLike3(node, property) {
  return property.type === NodeType3.Literal || property.type === NodeType3.TemplateLiteral && property.expressions.length === 0 || !node.computed && property.type === NodeType3.Identifier;
}
function getName4(node) {
  if (node.type === NodeType3.TSAsExpression) {
    return getName4(node.expression);
  }
  if (node.type === NodeType3.Identifier || node.type === NodeType3.PrivateIdentifier) {
    return Option_exports6.some(node.name);
  }
  if (node.type === NodeType3.Literal) {
    return Option_exports6.some(String(node.value));
  }
  if (node.type === NodeType3.TemplateLiteral && node.expressions.length === 0) {
    return Option_exports6.fromNullable(node.quasis[0]?.value.raw);
  }
  return Option_exports6.none();
}
function isAssignmentToThisState2(node) {
  const { left: left94 } = node;
  return left94.type === NodeType3.MemberExpression && isThisExpression(left94.object) && Option_exports6.exists(getName4(left94.property), (name22) => name22 === "state");
}
var isGetDerivedStateFromProps = a({
  key: {
    name: "getDerivedStateFromProps"
  },
  static: true,
  value: {
    params: N.array()
  }
});
var no_unused_state_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "Prevents unused state of class component.",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_UNUSED_STATE: "Unused class component state."
    },
    schema: []
  },
  name: RULE_NAME38,
  create(context) {
    const classStack = MutableList_exports2.make();
    const methodStack = MutableList_exports2.make();
    const constructorStack = MutableList_exports2.make();
    const stateDefs = /* @__PURE__ */ new WeakMap();
    function classEnter(node) {
      MutableList_exports2.append(classStack, node);
    }
    function classExit() {
      const currentClass = MutableList_exports2.pop(classStack);
      if (!currentClass || !isClassComponent(currentClass)) return;
      const className = Option_exports6.map(getClassIdentifier(currentClass), (id) => id.name);
      const [def, isUsed] = stateDefs.get(currentClass) ?? [Option_exports6.none(), false];
      if (Option_exports6.isNone(def) || isUsed) return;
      context.report({
        data: {
          className: Option_exports6.getOrElse(className, () => "Component")
        },
        messageId: "NO_UNUSED_STATE",
        node: def.value
      });
    }
    function methodEnter(node) {
      MutableList_exports2.append(methodStack, node);
      const currentClass = MutableList_exports2.tail(classStack);
      if (!currentClass || !isClassComponent(currentClass)) return;
      if (node.static) {
        if (isGetDerivedStateFromProps(node) && node.value.params.length > 1) {
          const [def] = stateDefs.get(currentClass) ?? [Option_exports6.none()];
          stateDefs.set(currentClass, [def, true]);
        }
        return;
      }
      if (Option_exports6.exists(getName4(node.key), (name22) => name22 === "state")) {
        stateDefs.set(currentClass, [Option_exports6.some(node.key), false]);
      }
    }
    function methodExit() {
      MutableList_exports2.pop(methodStack);
    }
    function constructorEnter(node) {
      MutableList_exports2.append(constructorStack, node);
    }
    function constructorExit() {
      MutableList_exports2.pop(constructorStack);
    }
    return {
      AssignmentExpression(node) {
        if (!isAssignmentToThisState2(node)) return;
        const currentClass = MutableList_exports2.tail(classStack);
        if (!currentClass || !isClassComponent(currentClass)) return;
        const currentConstructor = MutableList_exports2.tail(constructorStack);
        if (!currentConstructor || !currentClass.body.body.includes(currentConstructor)) return;
        const [_52, isUsed] = stateDefs.get(currentClass) ?? [Option_exports6.none(), false];
        stateDefs.set(currentClass, [Option_exports6.some(node.left), isUsed]);
      },
      ClassDeclaration: classEnter,
      "ClassDeclaration:exit": classExit,
      ClassExpression: classEnter,
      "ClassExpression:exit": classExit,
      MemberExpression(node) {
        if (!isThisExpression(node.object)) return;
        if (!Option_exports6.exists(getName4(node.property), (name22) => name22 === "state")) return;
        const currentClass = MutableList_exports2.tail(classStack);
        if (!currentClass || !isClassComponent(currentClass)) return;
        const currentMethod = MutableList_exports2.tail(methodStack);
        if (!currentMethod || currentMethod.static) return;
        if (currentMethod === MutableList_exports2.tail(constructorStack)) return;
        if (!currentClass.body.body.includes(currentMethod)) return;
        const [def] = stateDefs.get(currentClass) ?? [Option_exports6.none(), false];
        stateDefs.set(currentClass, [def, true]);
      },
      MethodDefinition: methodEnter,
      "MethodDefinition:exit": methodExit,
      "MethodDefinition[key.name='constructor']": constructorEnter,
      "MethodDefinition[key.name='constructor']:exit": constructorExit,
      PropertyDefinition: methodEnter,
      "PropertyDefinition:exit": methodExit,
      VariableDeclarator(node) {
        const currentClass = MutableList_exports2.tail(classStack);
        if (!currentClass || !isClassComponent(currentClass)) return;
        const currentMethod = MutableList_exports2.tail(methodStack);
        if (!currentMethod || currentMethod.static) return;
        if (currentMethod === MutableList_exports2.tail(constructorStack)) return;
        if (!currentClass.body.body.includes(currentMethod)) return;
        if (!(node.init && isThisExpression(node.init) && node.id.type === NodeType3.ObjectPattern)) return;
        const hasState = node.id.properties.some((prop) => {
          if (prop.type === NodeType3.Property && isKeyLiteralLike3(prop, prop.key)) {
            return Option_exports6.exists(getName4(prop.key), (name22) => name22 === "state");
          }
          return false;
        });
        if (!hasState) return;
        const [def] = stateDefs.get(currentClass) ?? [Option_exports6.none(), false];
        stateDefs.set(currentClass, [def, true]);
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME39 = "no-useless-fragment";
function isFragmentWithOnlyTextAndIsNotChild(node) {
  return node.children.length === 1 && isLiteral(node.children[0]) && !(node.parent.type === NodeType3.JSXElement || node.parent.type === NodeType3.JSXFragment);
}
function containsCallExpression(node) {
  return node.type === NodeType3.JSXExpressionContainer && node.expression.type === NodeType3.CallExpression;
}
function isFragmentHasLessThanTwoChildren(node) {
  const nonPaddingChildren = node.children.filter(
    (child) => !isPaddingSpaces(child)
  );
  if (nonPaddingChildren.length === 1 && nonPaddingChildren[0]) {
    return !containsCallExpression(nonPaddingChildren[0]);
  }
  return nonPaddingChildren.length === 0;
}
function isFragmentWithSingleExpression(node) {
  const children = node.children.filter((child) => !isPaddingSpaces(child));
  return children.length === 1 && children[0]?.type === NodeType3.JSXExpressionContainer;
}
var no_useless_fragment_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "disallow unnecessary fragments",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_USELESS_FRAGMENT: "A fragment containing a single element is usually unnecessary.",
      NO_USELESS_FRAGMENT_IN_BUILT_IN: "Passing a fragment to a host component is unnecessary."
    },
    schema: []
  },
  name: RULE_NAME39,
  create(context) {
    function checkNode(node) {
      const initialScope = context.sourceCode.getScope(node);
      if (node.type === NodeType3.JSXElement && hasProp(
        node.openingElement.attributes,
        "key",
        context,
        initialScope
      )) {
        return;
      }
      if (isFragmentHasLessThanTwoChildren(node) && !isFragmentWithOnlyTextAndIsNotChild(node) && !isFragmentWithSingleExpression(node)) {
        context.report({
          messageId: "NO_USELESS_FRAGMENT",
          node
        });
      }
      if (node.parent.type === NodeType3.JSXElement && isJSXElementOfBuiltinComponent(node.parent)) {
        context.report({
          messageId: "NO_USELESS_FRAGMENT_IN_BUILT_IN",
          node
        });
      }
    }
    return {
      JSXElement(node) {
        if (isFragmentElement(node, context)) {
          checkNode(node);
        }
      },
      JSXFragment: checkNode
    };
  },
  defaultOptions: []
});
var RULE_NAME40 = "prefer-destructuring-assignment";
function isMemberExpressionWithObjectName(node) {
  return node.object.type === NodeType3.Identifier && "name" in node.object;
}
var prefer_destructuring_assignment_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "enforce using destructuring assignment in component props and context",
      recommended: "recommended"
    },
    messages: {
      PREFER_DESTRUCTURING_ASSIGNMENT: "Prefer destructuring assignment."
    },
    schema: []
  },
  name: RULE_NAME40,
  create(context) {
    const { ctx, listeners } = useComponentCollector(context);
    const memberExpressionWithNames = [];
    return {
      ...listeners,
      MemberExpression(node) {
        if (isMemberExpressionWithObjectName(node)) {
          const scope = context.sourceCode.getScope(node);
          memberExpressionWithNames.push([scope, node]);
        }
      },
      "Program:exit"(node) {
        const components = Array.from(ctx.getAllComponents(node).values());
        function isFunctionComponent(block) {
          if (!isFunction(block)) return false;
          const maybeId = getFunctionIdentifier(block);
          return Option_exports6.isSome(maybeId) && isComponentName(maybeId.value.name) && components.some((component) => component.node === block);
        }
        for (const [scope, memberExpression] of memberExpressionWithNames) {
          const scopeRef = MutableRef_exports4.make(scope);
          const isComponentRef = MutableRef_exports4.make(isFunctionComponent(scope.block));
          while (!MutableRef_exports4.get(isComponentRef) && MutableRef_exports4.get(scopeRef).upper && MutableRef_exports4.get(scopeRef).upper !== MutableRef_exports4.get(scopeRef)) {
            MutableRef_exports4.set(scopeRef, MutableRef_exports4.get(scopeRef).upper);
            MutableRef_exports4.set(isComponentRef, isFunctionComponent(MutableRef_exports4.get(scopeRef).block));
          }
          if (!MutableRef_exports4.get(isComponentRef)) continue;
          const component = MutableRef_exports4.get(scopeRef).block;
          if (!("params" in component)) continue;
          const [props, ctx2] = component.params;
          const isMatch = a({ name: memberExpression.object.name });
          if (isMatch(props)) {
            context.report({
              messageId: "PREFER_DESTRUCTURING_ASSIGNMENT",
              node: memberExpression
            });
          }
          if (isMatch(ctx2)) {
            context.report({
              messageId: "PREFER_DESTRUCTURING_ASSIGNMENT",
              node: memberExpression
            });
          }
        }
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME41 = "prefer-shorthand-boolean";
var prefer_shorthand_boolean_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "enforce boolean attributes notation in JSX",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      PREFER_SHORTHAND_BOOLEAN: "Prefer using shorthand boolean attribute '{{propName}}'"
    },
    schema: []
  },
  name: RULE_NAME41,
  create(context) {
    return {
      JSXAttribute(node) {
        const { value } = node;
        const propName = getPropName(node);
        const hasValueTrue = value?.type === NodeType3.JSXExpressionContainer && value.expression.type === NodeType3.Literal && value.expression.value === true;
        if (!hasValueTrue) return;
        context.report({
          data: {
            propName
          },
          messageId: "PREFER_SHORTHAND_BOOLEAN",
          node
        });
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME42 = "prefer-shorthand-fragment";
var prefer_shorthand_fragment_default = createRule({
  meta: {
    type: "problem",
    docs: {
      description: "enforce using fragment syntax instead of Fragment component",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      PREFER_SHORTHAND_FRAGMENT: "Prefer shorthand fragment syntax instead of fragment component."
    },
    schema: []
  },
  name: RULE_NAME42,
  create(context) {
    return {
      JSXElement(node) {
        if (isFragmentElement(node, context)) {
          const hasAttributes = node.openingElement.attributes.length > 0;
          if (hasAttributes) return;
          context.report({
            messageId: "PREFER_SHORTHAND_FRAGMENT",
            node
          });
        }
      }
    };
  },
  defaultOptions: []
});
var meta = {
  name,
  version
};
var rules = {
  "avoid-shorthand-boolean": avoid_shorthand_boolean_default,
  "avoid-shorthand-fragment": avoid_shorthand_fragment_default,
  "ensure-forward-ref-using-ref": ensure_forward_ref_using_ref_default,
  "no-access-state-in-setstate": no_access_state_in_setstate_default,
  "no-array-index-key": no_array_index_key_default,
  "no-children-count": no_children_count_default,
  "no-children-for-each": no_children_for_each_default,
  "no-children-map": no_children_map_default,
  "no-children-only": no_children_only_default,
  "no-children-prop": no_children_prop_default,
  "no-children-to-array": no_children_to_array_default,
  "no-class-component": no_class_component_default,
  "no-clone-element": no_clone_element_default,
  "no-comment-textnodes": no_comment_textnodes_default,
  "no-complicated-conditional-rendering": no_complicated_conditional_rendering_default,
  "no-component-will-mount": no_component_will_mount_default,
  "no-component-will-receive-props": no_component_will_receive_props_default,
  "no-component-will-update": no_component_will_update_default,
  "no-create-ref": no_create_ref_default,
  "no-direct-mutation-state": no_direct_mutation_state_default,
  "no-duplicate-key": no_duplicate_key_default,
  "no-implicit-key": no_implicit_key_default,
  "no-leaked-conditional-rendering": no_leaked_conditional_rendering_default,
  "no-missing-component-display-name": no_missing_component_display_name_default,
  "no-missing-key": no_missing_key_default,
  "no-nested-components": no_nested_components_default,
  "no-redundant-should-component-update": no_redundant_should_component_update_default,
  "no-set-state-in-component-did-mount": no_set_state_in_component_did_mount_default,
  "no-set-state-in-component-did-update": no_set_state_in_component_did_update_default,
  "no-set-state-in-component-will-update": no_set_state_in_component_will_update_default,
  "no-string-refs": no_string_refs_default,
  "no-unsafe-component-will-mount": no_unsafe_component_will_mount_default,
  "no-unsafe-component-will-receive-props": no_unsafe_component_will_receive_props_default,
  "no-unsafe-component-will-update": no_unsafe_component_will_update_default,
  "no-unstable-context-value": no_unstable_context_value_default,
  "no-unstable-default-props": no_unstable_default_props_default,
  "no-unused-class-component-members": no_unused_class_component_members_default,
  "no-unused-state": no_unused_state_default,
  "no-useless-fragment": no_useless_fragment_default,
  "prefer-destructuring-assignment": prefer_destructuring_assignment_default,
  "prefer-shorthand-boolean": prefer_shorthand_boolean_default,
  "prefer-shorthand-fragment": prefer_shorthand_fragment_default
};

// ../eslint-plugin-react-dom/dist/index.mjs
var dist_exports2 = {};
__export(dist_exports2, {
  meta: () => meta2,
  rules: () => rules2
});
var __create2 = Object.create;
var __defProp7 = Object.defineProperty;
var __getOwnPropDesc2 = Object.getOwnPropertyDescriptor;
var __getOwnPropNames2 = Object.getOwnPropertyNames;
var __getProtoOf2 = Object.getPrototypeOf;
var __hasOwnProp2 = Object.prototype.hasOwnProperty;
var __commonJS2 = (cb, mod) => function __require() {
  return mod || (0, cb[__getOwnPropNames2(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
};
var __export7 = (target, all132) => {
  for (var name22 in all132)
    __defProp7(target, name22, { get: all132[name22], enumerable: true });
};
var __copyProps2 = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames2(from))
      if (!__hasOwnProp2.call(to, key) && key !== except)
        __defProp7(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc2(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM2 = (mod, isNodeMode, target) => (target = mod != null ? __create2(__getProtoOf2(mod)) : {}, __copyProps2(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  __defProp7(target, "default", { value: mod, enumerable: true }),
  mod
));
var require_short_unique_id2 = __commonJS2({
  "../../../node_modules/.pnpm/short-unique-id@5.2.0/node_modules/short-unique-id/dist/short-unique-id.js"(exports, module) {
    var ShortUniqueId2 = (() => {
      var __defProp72 = Object.defineProperty;
      var __getOwnPropDesc22 = Object.getOwnPropertyDescriptor;
      var __getOwnPropNames22 = Object.getOwnPropertyNames;
      var __getOwnPropSymbols = Object.getOwnPropertySymbols;
      var __hasOwnProp22 = Object.prototype.hasOwnProperty;
      var __propIsEnum = Object.prototype.propertyIsEnumerable;
      var __defNormalProp = (obj, key, value) => key in obj ? __defProp72(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
      var __spreadValues = (a52, b52) => {
        for (var prop in b52 || (b52 = {}))
          if (__hasOwnProp22.call(b52, prop))
            __defNormalProp(a52, prop, b52[prop]);
        if (__getOwnPropSymbols)
          for (var prop of __getOwnPropSymbols(b52)) {
            if (__propIsEnum.call(b52, prop))
              __defNormalProp(a52, prop, b52[prop]);
          }
        return a52;
      };
      var __export72 = (target, all132) => {
        for (var name22 in all132)
          __defProp72(target, name22, { get: all132[name22], enumerable: true });
      };
      var __copyProps22 = (to, from, except, desc) => {
        if (from && typeof from === "object" || typeof from === "function") {
          for (let key of __getOwnPropNames22(from))
            if (!__hasOwnProp22.call(to, key) && key !== except)
              __defProp72(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc22(from, key)) || desc.enumerable });
        }
        return to;
      };
      var __toCommonJS = (mod) => __copyProps22(__defProp72({}, "__esModule", { value: true }), mod);
      var __publicField = (obj, key, value) => {
        __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
        return value;
      };
      var src_exports = {};
      __export72(src_exports, {
        DEFAULT_OPTIONS: () => DEFAULT_OPTIONS,
        DEFAULT_UUID_LENGTH: () => DEFAULT_UUID_LENGTH,
        default: () => ShortUniqueId3
      });
      var version22 = "5.2.0";
      var DEFAULT_UUID_LENGTH = 6;
      var DEFAULT_OPTIONS = {
        dictionary: "alphanum",
        shuffle: true,
        debug: false,
        length: DEFAULT_UUID_LENGTH,
        counter: 0
      };
      var _ShortUniqueId = class _ShortUniqueId {
        constructor(argOptions = {}) {
          __publicField(this, "counter");
          __publicField(this, "debug");
          __publicField(this, "dict");
          __publicField(this, "version");
          __publicField(this, "dictIndex", 0);
          __publicField(this, "dictRange", []);
          __publicField(this, "lowerBound", 0);
          __publicField(this, "upperBound", 0);
          __publicField(this, "dictLength", 0);
          __publicField(this, "uuidLength");
          __publicField(this, "_digit_first_ascii", 48);
          __publicField(this, "_digit_last_ascii", 58);
          __publicField(this, "_alpha_lower_first_ascii", 97);
          __publicField(this, "_alpha_lower_last_ascii", 123);
          __publicField(this, "_hex_last_ascii", 103);
          __publicField(this, "_alpha_upper_first_ascii", 65);
          __publicField(this, "_alpha_upper_last_ascii", 91);
          __publicField(this, "_number_dict_ranges", {
            digits: [this._digit_first_ascii, this._digit_last_ascii]
          });
          __publicField(this, "_alpha_dict_ranges", {
            lowerCase: [this._alpha_lower_first_ascii, this._alpha_lower_last_ascii],
            upperCase: [this._alpha_upper_first_ascii, this._alpha_upper_last_ascii]
          });
          __publicField(this, "_alpha_lower_dict_ranges", {
            lowerCase: [this._alpha_lower_first_ascii, this._alpha_lower_last_ascii]
          });
          __publicField(this, "_alpha_upper_dict_ranges", {
            upperCase: [this._alpha_upper_first_ascii, this._alpha_upper_last_ascii]
          });
          __publicField(this, "_alphanum_dict_ranges", {
            digits: [this._digit_first_ascii, this._digit_last_ascii],
            lowerCase: [this._alpha_lower_first_ascii, this._alpha_lower_last_ascii],
            upperCase: [this._alpha_upper_first_ascii, this._alpha_upper_last_ascii]
          });
          __publicField(this, "_alphanum_lower_dict_ranges", {
            digits: [this._digit_first_ascii, this._digit_last_ascii],
            lowerCase: [this._alpha_lower_first_ascii, this._alpha_lower_last_ascii]
          });
          __publicField(this, "_alphanum_upper_dict_ranges", {
            digits: [this._digit_first_ascii, this._digit_last_ascii],
            upperCase: [this._alpha_upper_first_ascii, this._alpha_upper_last_ascii]
          });
          __publicField(this, "_hex_dict_ranges", {
            decDigits: [this._digit_first_ascii, this._digit_last_ascii],
            alphaDigits: [this._alpha_lower_first_ascii, this._hex_last_ascii]
          });
          __publicField(this, "_dict_ranges", {
            _number_dict_ranges: this._number_dict_ranges,
            _alpha_dict_ranges: this._alpha_dict_ranges,
            _alpha_lower_dict_ranges: this._alpha_lower_dict_ranges,
            _alpha_upper_dict_ranges: this._alpha_upper_dict_ranges,
            _alphanum_dict_ranges: this._alphanum_dict_ranges,
            _alphanum_lower_dict_ranges: this._alphanum_lower_dict_ranges,
            _alphanum_upper_dict_ranges: this._alphanum_upper_dict_ranges,
            _hex_dict_ranges: this._hex_dict_ranges
          });
          __publicField(this, "log", (...args) => {
            const finalArgs = [...args];
            finalArgs[0] = `[short-unique-id] ${args[0]}`;
            if (this.debug === true) {
              if (typeof console !== "undefined" && console !== null) {
                return console.log(...finalArgs);
              }
            }
          });
          __publicField(this, "_normalizeDictionary", (dictionary2, shuffle2) => {
            let finalDict;
            if (dictionary2 && Array.isArray(dictionary2) && dictionary2.length > 1) {
              finalDict = dictionary2;
            } else {
              finalDict = [];
              let i52;
              this.dictIndex = i52 = 0;
              const rangesName = `_${dictionary2}_dict_ranges`;
              const ranges = this._dict_ranges[rangesName];
              Object.keys(ranges).forEach((rangeType) => {
                const rangeTypeKey = rangeType;
                this.dictRange = ranges[rangeTypeKey];
                this.lowerBound = this.dictRange[0];
                this.upperBound = this.dictRange[1];
                for (this.dictIndex = i52 = this.lowerBound; this.lowerBound <= this.upperBound ? i52 < this.upperBound : i52 > this.upperBound; this.dictIndex = this.lowerBound <= this.upperBound ? i52 += 1 : i52 -= 1) {
                  finalDict.push(String.fromCharCode(this.dictIndex));
                }
              });
            }
            if (shuffle2) {
              const PROBABILITY = 0.5;
              finalDict = finalDict.sort(() => Math.random() - PROBABILITY);
            }
            return finalDict;
          });
          __publicField(this, "setDictionary", (dictionary2, shuffle2) => {
            this.dict = this._normalizeDictionary(dictionary2, shuffle2);
            this.dictLength = this.dict.length;
            this.setCounter(0);
          });
          __publicField(this, "seq", () => {
            return this.sequentialUUID();
          });
          __publicField(this, "sequentialUUID", () => {
            let counterDiv;
            let counterRem;
            let id = "";
            counterDiv = this.counter;
            do {
              counterRem = counterDiv % this.dictLength;
              counterDiv = Math.trunc(counterDiv / this.dictLength);
              id += this.dict[counterRem];
            } while (counterDiv !== 0);
            this.counter += 1;
            return id;
          });
          __publicField(this, "rnd", (uuidLength = this.uuidLength || DEFAULT_UUID_LENGTH) => {
            return this.randomUUID(uuidLength);
          });
          __publicField(this, "randomUUID", (uuidLength = this.uuidLength || DEFAULT_UUID_LENGTH) => {
            let id;
            let randomPartIdx;
            let j52;
            if (uuidLength === null || typeof uuidLength === "undefined" || uuidLength < 1) {
              throw new Error("Invalid UUID Length Provided");
            }
            id = "";
            for (j52 = 0; j52 < uuidLength; j52 += 1) {
              randomPartIdx = parseInt(
                (Math.random() * this.dictLength).toFixed(0),
                10
              ) % this.dictLength;
              id += this.dict[randomPartIdx];
            }
            return id;
          });
          __publicField(this, "fmt", (format92, date) => {
            return this.formattedUUID(format92, date);
          });
          __publicField(this, "formattedUUID", (format92, date) => {
            const fnMap = {
              "$r": this.randomUUID,
              "$s": this.sequentialUUID,
              "$t": this.stamp
            };
            const result = format92.replace(
              /\$[rs]\d{0,}|\$t0|\$t[1-9]\d{1,}/g,
              (m52) => {
                const fn = m52.slice(0, 2);
                const len = parseInt(m52.slice(2), 10);
                if (fn === "$s") {
                  return fnMap[fn]().padStart(len, "0");
                }
                if (fn === "$t" && date) {
                  return fnMap[fn](len, date);
                }
                return fnMap[fn](len);
              }
            );
            return result;
          });
          __publicField(this, "availableUUIDs", (uuidLength = this.uuidLength) => {
            return parseFloat(
              Math.pow([...new Set(this.dict)].length, uuidLength).toFixed(0)
            );
          });
          __publicField(this, "approxMaxBeforeCollision", (rounds = this.availableUUIDs(this.uuidLength)) => {
            return parseFloat(
              Math.sqrt(Math.PI / 2 * rounds).toFixed(20)
            );
          });
          __publicField(this, "collisionProbability", (rounds = this.availableUUIDs(this.uuidLength), uuidLength = this.uuidLength) => {
            return parseFloat(
              (this.approxMaxBeforeCollision(rounds) / this.availableUUIDs(uuidLength)).toFixed(20)
            );
          });
          __publicField(this, "uniqueness", (rounds = this.availableUUIDs(this.uuidLength)) => {
            const score = parseFloat(
              (1 - this.approxMaxBeforeCollision(rounds) / rounds).toFixed(20)
            );
            return score > 1 ? 1 : score < 0 ? 0 : score;
          });
          __publicField(this, "getVersion", () => {
            return this.version;
          });
          __publicField(this, "stamp", (finalLength, date) => {
            const hexStamp = Math.floor(+(date || /* @__PURE__ */ new Date()) / 1e3).toString(16);
            if (typeof finalLength === "number" && finalLength === 0) {
              return hexStamp;
            }
            if (typeof finalLength !== "number" || finalLength < 10) {
              throw new Error(
                [
                  "Param finalLength must be a number greater than or equal to 10,",
                  "or 0 if you want the raw hexadecimal timestamp"
                ].join("\n")
              );
            }
            const idLength = finalLength - 9;
            const rndIdx = Math.round(Math.random() * (idLength > 15 ? 15 : idLength));
            const id = this.randomUUID(idLength);
            return `${id.substring(0, rndIdx)}${hexStamp}${id.substring(rndIdx)}${rndIdx.toString(16)}`;
          });
          __publicField(this, "parseStamp", (suid, format92) => {
            if (format92 && !/t0|t[1-9]\d{1,}/.test(format92)) {
              throw new Error("Cannot extract date from a formated UUID with no timestamp in the format");
            }
            const stamp = format92 ? format92.replace(
              /\$[rs]\d{0,}|\$t0|\$t[1-9]\d{1,}/g,
              (m52) => {
                const fnMap = {
                  "$r": (len2) => [...Array(len2)].map(() => "r").join(""),
                  "$s": (len2) => [...Array(len2)].map(() => "s").join(""),
                  "$t": (len2) => [...Array(len2)].map(() => "t").join("")
                };
                const fn = m52.slice(0, 2);
                const len = parseInt(m52.slice(2), 10);
                return fnMap[fn](len);
              }
            ).replace(
              /^(.*?)(t{8,})(.*)$/g,
              (_m, p1, p232) => {
                return suid.substring(p1.length, p1.length + p232.length);
              }
            ) : suid;
            if (stamp.length === 8) {
              return new Date(parseInt(stamp, 16) * 1e3);
            }
            if (stamp.length < 10) {
              throw new Error("Stamp length invalid");
            }
            const rndIdx = parseInt(stamp.substring(stamp.length - 1), 16);
            return new Date(parseInt(stamp.substring(rndIdx, rndIdx + 8), 16) * 1e3);
          });
          __publicField(this, "setCounter", (counter2) => {
            this.counter = counter2;
          });
          __publicField(this, "validate", (uid4, dictionary2) => {
            const finalDictionary = dictionary2 ? this._normalizeDictionary(dictionary2) : this.dict;
            return uid4.split("").every((c52) => finalDictionary.includes(c52));
          });
          const options = __spreadValues(__spreadValues({}, DEFAULT_OPTIONS), argOptions);
          this.counter = 0;
          this.debug = false;
          this.dict = [];
          this.version = version22;
          const {
            dictionary,
            shuffle,
            length: length42,
            counter
          } = options;
          this.uuidLength = length42;
          this.setDictionary(dictionary, shuffle);
          this.setCounter(counter);
          this.debug = options.debug;
          this.log(this.dict);
          this.log(
            `Generator instantiated with Dictionary Size ${this.dictLength} and counter set to ${this.counter}`
          );
          this.log = this.log.bind(this);
          this.setDictionary = this.setDictionary.bind(this);
          this.setCounter = this.setCounter.bind(this);
          this.seq = this.seq.bind(this);
          this.sequentialUUID = this.sequentialUUID.bind(this);
          this.rnd = this.rnd.bind(this);
          this.randomUUID = this.randomUUID.bind(this);
          this.fmt = this.fmt.bind(this);
          this.formattedUUID = this.formattedUUID.bind(this);
          this.availableUUIDs = this.availableUUIDs.bind(this);
          this.approxMaxBeforeCollision = this.approxMaxBeforeCollision.bind(this);
          this.collisionProbability = this.collisionProbability.bind(this);
          this.uniqueness = this.uniqueness.bind(this);
          this.getVersion = this.getVersion.bind(this);
          this.stamp = this.stamp.bind(this);
          this.parseStamp = this.parseStamp.bind(this);
          return this;
        }
      };
      __publicField(_ShortUniqueId, "default", _ShortUniqueId);
      var ShortUniqueId3 = _ShortUniqueId;
      return __toCommonJS(src_exports);
    })();
    "undefined" != typeof module && (module.exports = ShortUniqueId2.default), "undefined" != typeof window && (ShortUniqueId2 = ShortUniqueId2.default);
  }
});
var name2 = "@neetly-eslint-react/eslint-plugin-react-dom";
var version2 = "0.0.0-dev.0";
var t5 = Symbol.for("@ts-pattern/matcher");
var e5 = Symbol.for("@ts-pattern/isVariadic");
var n5 = "@ts-pattern/anonymous-select-key";
var r5 = (t52) => Boolean(t52 && "object" == typeof t52);
var i5 = (e52) => e52 && !!e52[t5];
var o5 = (n52, s52, c52) => {
  if (i5(n52)) {
    const e52 = n52[t5](), { matched: r52, selections: i52 } = e52.match(s52);
    return r52 && i52 && Object.keys(i52).forEach((t52) => c52(t52, i52[t52])), r52;
  }
  if (r5(n52)) {
    if (!r5(s52)) return false;
    if (Array.isArray(n52)) {
      if (!Array.isArray(s52)) return false;
      let t52 = [], r52 = [], a52 = [];
      for (const o52 of n52.keys()) {
        const s62 = n52[o52];
        i5(s62) && s62[e5] ? a52.push(s62) : a52.length ? r52.push(s62) : t52.push(s62);
      }
      if (a52.length) {
        if (a52.length > 1) throw new Error("Pattern error: Using `...P.array(...)` several times in a single pattern is not allowed.");
        if (s52.length < t52.length + r52.length) return false;
        const e52 = s52.slice(0, t52.length), n62 = 0 === r52.length ? [] : s52.slice(-r52.length), i52 = s52.slice(t52.length, 0 === r52.length ? Infinity : -r52.length);
        return t52.every((t62, n72) => o5(t62, e52[n72], c52)) && r52.every((t62, e62) => o5(t62, n62[e62], c52)) && (0 === a52.length || o5(a52[0], i52, c52));
      }
      return n52.length === s52.length && n52.every((t62, e52) => o5(t62, s52[e52], c52));
    }
    return Object.keys(n52).every((e52) => {
      const r52 = n52[e52];
      return (e52 in s52 || i5(a52 = r52) && "optional" === a52[t5]().matcherType) && o5(r52, s52[e52], c52);
      var a52;
    });
  }
  return Object.is(s52, n52);
};
var s5 = (e52) => {
  var n52, o52, a52;
  return r5(e52) ? i5(e52) ? null != (n52 = null == (o52 = (a52 = e52[t5]()).getSelectionKeys) ? void 0 : o52.call(a52)) ? n52 : [] : Array.isArray(e52) ? c5(e52, s5) : c5(Object.values(e52), s5) : [];
};
var c5 = (t52, e52) => t52.reduce((t62, n52) => t62.concat(e52(n52)), []);
function a5(...t52) {
  if (1 === t52.length) {
    const [e52] = t52;
    return (t62) => o5(e52, t62, () => {
    });
  }
  if (2 === t52.length) {
    const [e52, n52] = t52;
    return o5(e52, n52, () => {
    });
  }
  throw new Error(`isMatching wasn't given the right number of arguments: expected 1 or 2, received ${t52.length}.`);
}
function u5(t52) {
  return Object.assign(t52, { optional: () => l5(t52), and: (e52) => m5(t52, e52), or: (e52) => d5(t52, e52), select: (e52) => void 0 === e52 ? p5(t52) : p5(e52, t52) });
}
function h5(t52) {
  return Object.assign(((t62) => Object.assign(t62, { [Symbol.iterator]() {
    let n52 = 0;
    const r52 = [{ value: Object.assign(t62, { [e5]: true }), done: false }, { done: true, value: void 0 }];
    return { next: () => {
      var t72;
      return null != (t72 = r52[n52++]) ? t72 : r52.at(-1);
    } };
  } }))(t52), { optional: () => h5(l5(t52)), select: (e52) => h5(void 0 === e52 ? p5(t52) : p5(e52, t52)) });
}
function l5(e52) {
  return u5({ [t5]: () => ({ match: (t52) => {
    let n52 = {};
    const r52 = (t62, e62) => {
      n52[t62] = e62;
    };
    return void 0 === t52 ? (s5(e52).forEach((t62) => r52(t62, void 0)), { matched: true, selections: n52 }) : { matched: o5(e52, t52, r52), selections: n52 };
  }, getSelectionKeys: () => s5(e52), matcherType: "optional" }) });
}
var f5 = (t52, e52) => {
  for (const n52 of t52) if (!e52(n52)) return false;
  return true;
};
var g5 = (t52, e52) => {
  for (const [n52, r52] of t52.entries()) if (!e52(r52, n52)) return false;
  return true;
};
function m5(...e52) {
  return u5({ [t5]: () => ({ match: (t52) => {
    let n52 = {};
    const r52 = (t62, e62) => {
      n52[t62] = e62;
    };
    return { matched: e52.every((e62) => o5(e62, t52, r52)), selections: n52 };
  }, getSelectionKeys: () => c5(e52, s5), matcherType: "and" }) });
}
function d5(...e52) {
  return u5({ [t5]: () => ({ match: (t52) => {
    let n52 = {};
    const r52 = (t62, e62) => {
      n52[t62] = e62;
    };
    return c5(e52, s5).forEach((t62) => r52(t62, void 0)), { matched: e52.some((e62) => o5(e62, t52, r52)), selections: n52 };
  }, getSelectionKeys: () => c5(e52, s5), matcherType: "or" }) });
}
function y5(e52) {
  return { [t5]: () => ({ match: (t52) => ({ matched: Boolean(e52(t52)) }) }) };
}
function p5(...e52) {
  const r52 = "string" == typeof e52[0] ? e52[0] : void 0, i52 = 2 === e52.length ? e52[1] : "string" == typeof e52[0] ? void 0 : e52[0];
  return u5({ [t5]: () => ({ match: (t52) => {
    let e62 = { [null != r52 ? r52 : n5]: t52 };
    return { matched: void 0 === i52 || o5(i52, t52, (t62, n52) => {
      e62[t62] = n52;
    }), selections: e62 };
  }, getSelectionKeys: () => [null != r52 ? r52 : n5].concat(void 0 === i52 ? [] : s5(i52)) }) });
}
function v5(t52) {
  return "number" == typeof t52;
}
function b5(t52) {
  return "string" == typeof t52;
}
function w5(t52) {
  return "bigint" == typeof t52;
}
var S5 = u5(y5(function(t52) {
  return true;
}));
var O5 = S5;
var j5 = (t52) => Object.assign(u5(t52), { startsWith: (e52) => {
  return j5(m5(t52, (n52 = e52, y5((t62) => b5(t62) && t62.startsWith(n52)))));
  var n52;
}, endsWith: (e52) => {
  return j5(m5(t52, (n52 = e52, y5((t62) => b5(t62) && t62.endsWith(n52)))));
  var n52;
}, minLength: (e52) => j5(m5(t52, ((t62) => y5((e62) => b5(e62) && e62.length >= t62))(e52))), maxLength: (e52) => j5(m5(t52, ((t62) => y5((e62) => b5(e62) && e62.length <= t62))(e52))), includes: (e52) => {
  return j5(m5(t52, (n52 = e52, y5((t62) => b5(t62) && t62.includes(n52)))));
  var n52;
}, regex: (e52) => {
  return j5(m5(t52, (n52 = e52, y5((t62) => b5(t62) && Boolean(t62.match(n52))))));
  var n52;
} });
var E5 = j5(y5(b5));
var K5 = (t52) => Object.assign(u5(t52), { between: (e52, n52) => K5(m5(t52, ((t62, e62) => y5((n62) => v5(n62) && t62 <= n62 && e62 >= n62))(e52, n52))), lt: (e52) => K5(m5(t52, ((t62) => y5((e62) => v5(e62) && e62 < t62))(e52))), gt: (e52) => K5(m5(t52, ((t62) => y5((e62) => v5(e62) && e62 > t62))(e52))), lte: (e52) => K5(m5(t52, ((t62) => y5((e62) => v5(e62) && e62 <= t62))(e52))), gte: (e52) => K5(m5(t52, ((t62) => y5((e62) => v5(e62) && e62 >= t62))(e52))), int: () => K5(m5(t52, y5((t62) => v5(t62) && Number.isInteger(t62)))), finite: () => K5(m5(t52, y5((t62) => v5(t62) && Number.isFinite(t62)))), positive: () => K5(m5(t52, y5((t62) => v5(t62) && t62 > 0))), negative: () => K5(m5(t52, y5((t62) => v5(t62) && t62 < 0))) });
var x5 = K5(y5(v5));
var A5 = (t52) => Object.assign(u5(t52), { between: (e52, n52) => A5(m5(t52, ((t62, e62) => y5((n62) => w5(n62) && t62 <= n62 && e62 >= n62))(e52, n52))), lt: (e52) => A5(m5(t52, ((t62) => y5((e62) => w5(e62) && e62 < t62))(e52))), gt: (e52) => A5(m5(t52, ((t62) => y5((e62) => w5(e62) && e62 > t62))(e52))), lte: (e52) => A5(m5(t52, ((t62) => y5((e62) => w5(e62) && e62 <= t62))(e52))), gte: (e52) => A5(m5(t52, ((t62) => y5((e62) => w5(e62) && e62 >= t62))(e52))), positive: () => A5(m5(t52, y5((t62) => w5(t62) && t62 > 0))), negative: () => A5(m5(t52, y5((t62) => w5(t62) && t62 < 0))) });
var P5 = A5(y5(w5));
var T5 = u5(y5(function(t52) {
  return "boolean" == typeof t52;
}));
var k5 = u5(y5(function(t52) {
  return "symbol" == typeof t52;
}));
var B5 = u5(y5(function(t52) {
  return null == t52;
}));
var _5 = u5(y5(function(t52) {
  return null != t52;
}));
var N4 = { __proto__: null, matcher: t5, optional: l5, array: function(...e52) {
  return h5({ [t5]: () => ({ match: (t52) => {
    if (!Array.isArray(t52)) return { matched: false };
    if (0 === e52.length) return { matched: true };
    const n52 = e52[0];
    let r52 = {};
    if (0 === t52.length) return s5(n52).forEach((t62) => {
      r52[t62] = [];
    }), { matched: true, selections: r52 };
    const i52 = (t62, e62) => {
      r52[t62] = (r52[t62] || []).concat([e62]);
    };
    return { matched: t52.every((t62) => o5(n52, t62, i52)), selections: r52 };
  }, getSelectionKeys: () => 0 === e52.length ? [] : s5(e52[0]) }) });
}, set: function(...e52) {
  return u5({ [t5]: () => ({ match: (t52) => {
    if (!(t52 instanceof Set)) return { matched: false };
    let n52 = {};
    if (0 === t52.size) return { matched: true, selections: n52 };
    if (0 === e52.length) return { matched: true };
    const r52 = (t62, e62) => {
      n52[t62] = (n52[t62] || []).concat([e62]);
    }, i52 = e52[0];
    return { matched: f5(t52, (t62) => o5(i52, t62, r52)), selections: n52 };
  }, getSelectionKeys: () => 0 === e52.length ? [] : s5(e52[0]) }) });
}, map: function(...e52) {
  return u5({ [t5]: () => ({ match: (t52) => {
    if (!(t52 instanceof Map)) return { matched: false };
    let n52 = {};
    if (0 === t52.size) return { matched: true, selections: n52 };
    const r52 = (t62, e62) => {
      n52[t62] = (n52[t62] || []).concat([e62]);
    };
    if (0 === e52.length) return { matched: true };
    var i52;
    if (1 === e52.length) throw new Error(`\`P.map\` wasn't given enough arguments. Expected (key, value), received ${null == (i52 = e52[0]) ? void 0 : i52.toString()}`);
    const [s52, c52] = e52;
    return { matched: g5(t52, (t62, e62) => {
      const n62 = o5(s52, e62, r52), i62 = o5(c52, t62, r52);
      return n62 && i62;
    }), selections: n52 };
  }, getSelectionKeys: () => 0 === e52.length ? [] : [...s5(e52[0]), ...s5(e52[1])] }) });
}, intersection: m5, union: d5, not: function(e52) {
  return u5({ [t5]: () => ({ match: (t52) => ({ matched: !o5(e52, t52, () => {
  }) }), getSelectionKeys: () => [], matcherType: "not" }) });
}, when: y5, select: p5, any: S5, _: O5, string: E5, number: x5, bigint: P5, boolean: T5, symbol: k5, nullish: B5, nonNullable: _5, instanceOf: function(t52) {
  return u5(y5(/* @__PURE__ */ function(t62) {
    return (e52) => e52 instanceof t62;
  }(t52)));
}, shape: function(t52) {
  return u5(y5(a5(t52)));
} };
var W2 = { matched: false, value: void 0 };
function $2(t52) {
  return new z2(t52, W2);
}
var z2 = class _z2 {
  constructor(t52, e52) {
    this.input = void 0, this.state = void 0, this.input = t52, this.state = e52;
  }
  with(...t52) {
    if (this.state.matched) return this;
    const e52 = t52[t52.length - 1], r52 = [t52[0]];
    let i52;
    3 === t52.length && "function" == typeof t52[1] ? i52 = t52[1] : t52.length > 2 && r52.push(...t52.slice(1, t52.length - 1));
    let s52 = false, c52 = {};
    const a52 = (t62, e62) => {
      s52 = true, c52[t62] = e62;
    }, u52 = !r52.some((t62) => o5(t62, this.input, a52)) || i52 && !Boolean(i52(this.input)) ? W2 : { matched: true, value: e52(s52 ? n5 in c52 ? c52[n5] : c52 : this.input, this.input) };
    return new _z2(this.input, u52);
  }
  when(t52, e52) {
    if (this.state.matched) return this;
    const n52 = Boolean(t52(this.input));
    return new _z2(this.input, n52 ? { matched: true, value: e52(this.input, this.input) } : W2);
  }
  otherwise(t52) {
    return this.state.matched ? this.state.value : t52(this.input);
  }
  exhaustive() {
    if (this.state.matched) return this.state.value;
    let t52;
    try {
      t52 = JSON.stringify(this.input);
    } catch (e52) {
      t52 = this.input;
    }
    throw new Error(`Pattern matching error: no pattern matches value ${t52}`);
  }
  run() {
    return this.exhaustive();
  }
  returnType() {
    return this;
  }
};
var KEYS6 = {
  ArrayExpression: [
    "elements"
  ],
  ArrayPattern: [
    "elements"
  ],
  ArrowFunctionExpression: [
    "params",
    "body"
  ],
  AssignmentExpression: [
    "left",
    "right"
  ],
  AssignmentPattern: [
    "left",
    "right"
  ],
  AwaitExpression: [
    "argument"
  ],
  BinaryExpression: [
    "left",
    "right"
  ],
  BlockStatement: [
    "body"
  ],
  BreakStatement: [
    "label"
  ],
  CallExpression: [
    "callee",
    "arguments"
  ],
  CatchClause: [
    "param",
    "body"
  ],
  ChainExpression: [
    "expression"
  ],
  ClassBody: [
    "body"
  ],
  ClassDeclaration: [
    "id",
    "superClass",
    "body"
  ],
  ClassExpression: [
    "id",
    "superClass",
    "body"
  ],
  ConditionalExpression: [
    "test",
    "consequent",
    "alternate"
  ],
  ContinueStatement: [
    "label"
  ],
  DebuggerStatement: [],
  DoWhileStatement: [
    "body",
    "test"
  ],
  EmptyStatement: [],
  ExperimentalRestProperty: [
    "argument"
  ],
  ExperimentalSpreadProperty: [
    "argument"
  ],
  ExportAllDeclaration: [
    "exported",
    "source"
  ],
  ExportDefaultDeclaration: [
    "declaration"
  ],
  ExportNamedDeclaration: [
    "declaration",
    "specifiers",
    "source"
  ],
  ExportSpecifier: [
    "exported",
    "local"
  ],
  ExpressionStatement: [
    "expression"
  ],
  ForInStatement: [
    "left",
    "right",
    "body"
  ],
  ForOfStatement: [
    "left",
    "right",
    "body"
  ],
  ForStatement: [
    "init",
    "test",
    "update",
    "body"
  ],
  FunctionDeclaration: [
    "id",
    "params",
    "body"
  ],
  FunctionExpression: [
    "id",
    "params",
    "body"
  ],
  Identifier: [],
  IfStatement: [
    "test",
    "consequent",
    "alternate"
  ],
  ImportDeclaration: [
    "specifiers",
    "source"
  ],
  ImportDefaultSpecifier: [
    "local"
  ],
  ImportExpression: [
    "source"
  ],
  ImportNamespaceSpecifier: [
    "local"
  ],
  ImportSpecifier: [
    "imported",
    "local"
  ],
  JSXAttribute: [
    "name",
    "value"
  ],
  JSXClosingElement: [
    "name"
  ],
  JSXClosingFragment: [],
  JSXElement: [
    "openingElement",
    "children",
    "closingElement"
  ],
  JSXEmptyExpression: [],
  JSXExpressionContainer: [
    "expression"
  ],
  JSXFragment: [
    "openingFragment",
    "children",
    "closingFragment"
  ],
  JSXIdentifier: [],
  JSXMemberExpression: [
    "object",
    "property"
  ],
  JSXNamespacedName: [
    "namespace",
    "name"
  ],
  JSXOpeningElement: [
    "name",
    "attributes"
  ],
  JSXOpeningFragment: [],
  JSXSpreadAttribute: [
    "argument"
  ],
  JSXSpreadChild: [
    "expression"
  ],
  JSXText: [],
  LabeledStatement: [
    "label",
    "body"
  ],
  Literal: [],
  LogicalExpression: [
    "left",
    "right"
  ],
  MemberExpression: [
    "object",
    "property"
  ],
  MetaProperty: [
    "meta",
    "property"
  ],
  MethodDefinition: [
    "key",
    "value"
  ],
  NewExpression: [
    "callee",
    "arguments"
  ],
  ObjectExpression: [
    "properties"
  ],
  ObjectPattern: [
    "properties"
  ],
  PrivateIdentifier: [],
  Program: [
    "body"
  ],
  Property: [
    "key",
    "value"
  ],
  PropertyDefinition: [
    "key",
    "value"
  ],
  RestElement: [
    "argument"
  ],
  ReturnStatement: [
    "argument"
  ],
  SequenceExpression: [
    "expressions"
  ],
  SpreadElement: [
    "argument"
  ],
  StaticBlock: [
    "body"
  ],
  Super: [],
  SwitchCase: [
    "test",
    "consequent"
  ],
  SwitchStatement: [
    "discriminant",
    "cases"
  ],
  TaggedTemplateExpression: [
    "tag",
    "quasi"
  ],
  TemplateElement: [],
  TemplateLiteral: [
    "quasis",
    "expressions"
  ],
  ThisExpression: [],
  ThrowStatement: [
    "argument"
  ],
  TryStatement: [
    "block",
    "handler",
    "finalizer"
  ],
  UnaryExpression: [
    "argument"
  ],
  UpdateExpression: [
    "argument"
  ],
  VariableDeclaration: [
    "declarations"
  ],
  VariableDeclarator: [
    "id",
    "init"
  ],
  WhileStatement: [
    "test",
    "body"
  ],
  WithStatement: [
    "object",
    "body"
  ],
  YieldExpression: [
    "argument"
  ]
};
var NODE_TYPES6 = Object.keys(KEYS6);
for (const type of NODE_TYPES6) {
  Object.freeze(KEYS6[type]);
}
Object.freeze(KEYS6);
var visitor_keys_default6 = KEYS6;
var KEY_BLACKLIST6 = /* @__PURE__ */ new Set([
  "parent",
  "leadingComments",
  "trailingComments"
]);
function filterKey6(key) {
  return !KEY_BLACKLIST6.has(key) && key[0] !== "_";
}
function getKeys6(node) {
  return Object.keys(node).filter(filterKey6);
}
function getInnermostScope6(initialScope, node) {
  const location = node.range[0];
  let scope = initialScope;
  let found = false;
  do {
    found = false;
    for (const childScope of scope.childScopes) {
      const range32 = childScope.block.range;
      if (range32[0] <= location && location < range32[1]) {
        scope = childScope;
        found = true;
        break;
      }
    }
  } while (found);
  return scope;
}
function findVariable6(initialScope, nameOrNode) {
  let name22 = "";
  let scope = initialScope;
  if (typeof nameOrNode === "string") {
    name22 = nameOrNode;
  } else {
    name22 = nameOrNode.name;
    scope = getInnermostScope6(scope, nameOrNode);
  }
  while (scope != null) {
    const variable = scope.set.get(name22);
    if (variable != null) {
      return variable;
    }
    scope = scope.upper;
  }
  return null;
}
function negate06(token) {
  return !this(token);
}
function negate6(f52) {
  return negate06.bind(f52);
}
function isPunctuatorTokenWithValue6(token, value) {
  return token.type === "Punctuator" && token.value === value;
}
function isArrowToken6(token) {
  return isPunctuatorTokenWithValue6(token, "=>");
}
function isCommaToken6(token) {
  return isPunctuatorTokenWithValue6(token, ",");
}
function isSemicolonToken6(token) {
  return isPunctuatorTokenWithValue6(token, ";");
}
function isColonToken6(token) {
  return isPunctuatorTokenWithValue6(token, ":");
}
function isOpeningParenToken6(token) {
  return isPunctuatorTokenWithValue6(token, "(");
}
function isClosingParenToken6(token) {
  return isPunctuatorTokenWithValue6(token, ")");
}
function isOpeningBracketToken6(token) {
  return isPunctuatorTokenWithValue6(token, "[");
}
function isClosingBracketToken6(token) {
  return isPunctuatorTokenWithValue6(token, "]");
}
function isOpeningBraceToken6(token) {
  return isPunctuatorTokenWithValue6(token, "{");
}
function isClosingBraceToken6(token) {
  return isPunctuatorTokenWithValue6(token, "}");
}
function isCommentToken6(token) {
  return ["Block", "Line", "Shebang"].includes(token.type);
}
negate6(isArrowToken6);
negate6(isCommaToken6);
negate6(isSemicolonToken6);
negate6(isColonToken6);
negate6(isOpeningParenToken6);
negate6(isClosingParenToken6);
negate6(isOpeningBracketToken6);
negate6(isClosingBracketToken6);
negate6(isOpeningBraceToken6);
negate6(isClosingBraceToken6);
negate6(isCommentToken6);
function getOpeningParenOfParams6(node, sourceCode) {
  return node.id ? sourceCode.getTokenAfter(node.id, isOpeningParenToken6) : sourceCode.getFirstToken(node, isOpeningParenToken6);
}
function getFunctionHeadLocation6(node, sourceCode) {
  const parent = node.parent;
  let start = null;
  let end = null;
  if (node.type === "ArrowFunctionExpression") {
    const arrowToken = sourceCode.getTokenBefore(node.body, isArrowToken6);
    start = arrowToken.loc.start;
    end = arrowToken.loc.end;
  } else if (parent.type === "Property" || parent.type === "MethodDefinition" || parent.type === "PropertyDefinition") {
    start = parent.loc.start;
    end = getOpeningParenOfParams6(node, sourceCode).loc.start;
  } else {
    start = node.loc.start;
    end = getOpeningParenOfParams6(node, sourceCode).loc.start;
  }
  return {
    start: { ...start },
    end: { ...end }
  };
}
var globalObject6 = typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {};
var builtinNames6 = Object.freeze(
  /* @__PURE__ */ new Set([
    "Array",
    "ArrayBuffer",
    "BigInt",
    "BigInt64Array",
    "BigUint64Array",
    "Boolean",
    "DataView",
    "Date",
    "decodeURI",
    "decodeURIComponent",
    "encodeURI",
    "encodeURIComponent",
    "escape",
    "Float32Array",
    "Float64Array",
    "Function",
    "Infinity",
    "Int16Array",
    "Int32Array",
    "Int8Array",
    "isFinite",
    "isNaN",
    "isPrototypeOf",
    "JSON",
    "Map",
    "Math",
    "NaN",
    "Number",
    "Object",
    "parseFloat",
    "parseInt",
    "Promise",
    "Proxy",
    "Reflect",
    "RegExp",
    "Set",
    "String",
    "Symbol",
    "Uint16Array",
    "Uint32Array",
    "Uint8Array",
    "Uint8ClampedArray",
    "undefined",
    "unescape",
    "WeakMap",
    "WeakSet"
  ])
);
var callAllowed6 = new Set(
  [
    Array.isArray,
    Array.of,
    Array.prototype.at,
    Array.prototype.concat,
    Array.prototype.entries,
    Array.prototype.every,
    Array.prototype.filter,
    Array.prototype.find,
    Array.prototype.findIndex,
    Array.prototype.flat,
    Array.prototype.includes,
    Array.prototype.indexOf,
    Array.prototype.join,
    Array.prototype.keys,
    Array.prototype.lastIndexOf,
    Array.prototype.slice,
    Array.prototype.some,
    Array.prototype.toString,
    Array.prototype.values,
    typeof BigInt === "function" ? BigInt : void 0,
    Boolean,
    Date,
    Date.parse,
    decodeURI,
    decodeURIComponent,
    encodeURI,
    encodeURIComponent,
    escape,
    isFinite,
    isNaN,
    isPrototypeOf,
    Map,
    Map.prototype.entries,
    Map.prototype.get,
    Map.prototype.has,
    Map.prototype.keys,
    Map.prototype.values,
    ...Object.getOwnPropertyNames(Math).filter((k52) => k52 !== "random").map((k52) => Math[k52]).filter((f52) => typeof f52 === "function"),
    Number,
    Number.isFinite,
    Number.isNaN,
    Number.parseFloat,
    Number.parseInt,
    Number.prototype.toExponential,
    Number.prototype.toFixed,
    Number.prototype.toPrecision,
    Number.prototype.toString,
    Object,
    Object.entries,
    Object.is,
    Object.isExtensible,
    Object.isFrozen,
    Object.isSealed,
    Object.keys,
    Object.values,
    parseFloat,
    parseInt,
    RegExp,
    Set,
    Set.prototype.entries,
    Set.prototype.has,
    Set.prototype.keys,
    Set.prototype.values,
    String,
    String.fromCharCode,
    String.fromCodePoint,
    String.raw,
    String.prototype.at,
    String.prototype.charAt,
    String.prototype.charCodeAt,
    String.prototype.codePointAt,
    String.prototype.concat,
    String.prototype.endsWith,
    String.prototype.includes,
    String.prototype.indexOf,
    String.prototype.lastIndexOf,
    String.prototype.normalize,
    String.prototype.padEnd,
    String.prototype.padStart,
    String.prototype.slice,
    String.prototype.startsWith,
    String.prototype.substr,
    String.prototype.substring,
    String.prototype.toLowerCase,
    String.prototype.toString,
    String.prototype.toUpperCase,
    String.prototype.trim,
    String.prototype.trimEnd,
    String.prototype.trimLeft,
    String.prototype.trimRight,
    String.prototype.trimStart,
    Symbol.for,
    Symbol.keyFor,
    unescape
  ].filter((f52) => typeof f52 === "function")
);
var callPassThrough6 = /* @__PURE__ */ new Set([
  Object.freeze,
  Object.preventExtensions,
  Object.seal
]);
var getterAllowed6 = [
  [Map, /* @__PURE__ */ new Set(["size"])],
  [
    RegExp,
    /* @__PURE__ */ new Set([
      "dotAll",
      "flags",
      "global",
      "hasIndices",
      "ignoreCase",
      "multiline",
      "source",
      "sticky",
      "unicode"
    ])
  ],
  [Set, /* @__PURE__ */ new Set(["size"])]
];
function getPropertyDescriptor6(object32, name22) {
  let x52 = object32;
  while ((typeof x52 === "object" || typeof x52 === "function") && x52 !== null) {
    const d52 = Object.getOwnPropertyDescriptor(x52, name22);
    if (d52) {
      return d52;
    }
    x52 = Object.getPrototypeOf(x52);
  }
  return null;
}
function isGetter6(object32, name22) {
  const d52 = getPropertyDescriptor6(object32, name22);
  return d52 != null && d52.get != null;
}
function getElementValues6(nodeList, initialScope) {
  const valueList = [];
  for (let i52 = 0; i52 < nodeList.length; ++i52) {
    const elementNode = nodeList[i52];
    if (elementNode == null) {
      valueList.length = i52 + 1;
    } else if (elementNode.type === "SpreadElement") {
      const argument = getStaticValueR6(elementNode.argument, initialScope);
      if (argument == null) {
        return null;
      }
      valueList.push(...argument.value);
    } else {
      const element = getStaticValueR6(elementNode, initialScope);
      if (element == null) {
        return null;
      }
      valueList.push(element.value);
    }
  }
  return valueList;
}
function isEffectivelyConst6(variable) {
  const refs = variable.references;
  const inits = refs.filter((r52) => r52.init).length;
  const reads = refs.filter((r52) => r52.isReadOnly()).length;
  if (inits === 1 && reads + inits === refs.length) {
    return true;
  }
  return false;
}
var operations6 = Object.freeze({
  ArrayExpression(node, initialScope) {
    const elements = getElementValues6(node.elements, initialScope);
    return elements != null ? { value: elements } : null;
  },
  AssignmentExpression(node, initialScope) {
    if (node.operator === "=") {
      return getStaticValueR6(node.right, initialScope);
    }
    return null;
  },
  //eslint-disable-next-line complexity
  BinaryExpression(node, initialScope) {
    if (node.operator === "in" || node.operator === "instanceof") {
      return null;
    }
    const left102 = getStaticValueR6(node.left, initialScope);
    const right102 = getStaticValueR6(node.right, initialScope);
    if (left102 != null && right102 != null) {
      switch (node.operator) {
        case "==":
          return { value: left102.value == right102.value };
        case "!=":
          return { value: left102.value != right102.value };
        case "===":
          return { value: left102.value === right102.value };
        case "!==":
          return { value: left102.value !== right102.value };
        case "<":
          return { value: left102.value < right102.value };
        case "<=":
          return { value: left102.value <= right102.value };
        case ">":
          return { value: left102.value > right102.value };
        case ">=":
          return { value: left102.value >= right102.value };
        case "<<":
          return { value: left102.value << right102.value };
        case ">>":
          return { value: left102.value >> right102.value };
        case ">>>":
          return { value: left102.value >>> right102.value };
        case "+":
          return { value: left102.value + right102.value };
        case "-":
          return { value: left102.value - right102.value };
        case "*":
          return { value: left102.value * right102.value };
        case "/":
          return { value: left102.value / right102.value };
        case "%":
          return { value: left102.value % right102.value };
        case "**":
          return { value: left102.value ** right102.value };
        case "|":
          return { value: left102.value | right102.value };
        case "^":
          return { value: left102.value ^ right102.value };
        case "&":
          return { value: left102.value & right102.value };
      }
    }
    return null;
  },
  CallExpression(node, initialScope) {
    const calleeNode = node.callee;
    const args = getElementValues6(node.arguments, initialScope);
    if (args != null) {
      if (calleeNode.type === "MemberExpression") {
        if (calleeNode.property.type === "PrivateIdentifier") {
          return null;
        }
        const object32 = getStaticValueR6(calleeNode.object, initialScope);
        if (object32 != null) {
          if (object32.value == null && (object32.optional || node.optional)) {
            return { value: void 0, optional: true };
          }
          const property = getStaticPropertyNameValue6(
            calleeNode,
            initialScope
          );
          if (property != null) {
            const receiver = object32.value;
            const methodName = property.value;
            if (callAllowed6.has(receiver[methodName])) {
              return { value: receiver[methodName](...args) };
            }
            if (callPassThrough6.has(receiver[methodName])) {
              return { value: args[0] };
            }
          }
        }
      } else {
        const callee = getStaticValueR6(calleeNode, initialScope);
        if (callee != null) {
          if (callee.value == null && node.optional) {
            return { value: void 0, optional: true };
          }
          const func = callee.value;
          if (callAllowed6.has(func)) {
            return { value: func(...args) };
          }
          if (callPassThrough6.has(func)) {
            return { value: args[0] };
          }
        }
      }
    }
    return null;
  },
  ConditionalExpression(node, initialScope) {
    const test = getStaticValueR6(node.test, initialScope);
    if (test != null) {
      return test.value ? getStaticValueR6(node.consequent, initialScope) : getStaticValueR6(node.alternate, initialScope);
    }
    return null;
  },
  ExpressionStatement(node, initialScope) {
    return getStaticValueR6(node.expression, initialScope);
  },
  Identifier(node, initialScope) {
    if (initialScope != null) {
      const variable = findVariable6(initialScope, node);
      if (variable != null && variable.defs.length === 0 && builtinNames6.has(variable.name) && variable.name in globalObject6) {
        return { value: globalObject6[variable.name] };
      }
      if (variable != null && variable.defs.length === 1) {
        const def = variable.defs[0];
        if (def.parent && def.type === "Variable" && (def.parent.kind === "const" || isEffectivelyConst6(variable)) && // TODO(mysticatea): don't support destructuring here.
        def.node.id.type === "Identifier") {
          return getStaticValueR6(def.node.init, initialScope);
        }
      }
    }
    return null;
  },
  Literal(node) {
    if ((node.regex != null || node.bigint != null) && node.value == null) {
      return null;
    }
    return { value: node.value };
  },
  LogicalExpression(node, initialScope) {
    const left102 = getStaticValueR6(node.left, initialScope);
    if (left102 != null) {
      if (node.operator === "||" && Boolean(left102.value) === true || node.operator === "&&" && Boolean(left102.value) === false || node.operator === "??" && left102.value != null) {
        return left102;
      }
      const right102 = getStaticValueR6(node.right, initialScope);
      if (right102 != null) {
        return right102;
      }
    }
    return null;
  },
  MemberExpression(node, initialScope) {
    if (node.property.type === "PrivateIdentifier") {
      return null;
    }
    const object32 = getStaticValueR6(node.object, initialScope);
    if (object32 != null) {
      if (object32.value == null && (object32.optional || node.optional)) {
        return { value: void 0, optional: true };
      }
      const property = getStaticPropertyNameValue6(node, initialScope);
      if (property != null) {
        if (!isGetter6(object32.value, property.value)) {
          return { value: object32.value[property.value] };
        }
        for (const [classFn, allowed] of getterAllowed6) {
          if (object32.value instanceof classFn && allowed.has(property.value)) {
            return { value: object32.value[property.value] };
          }
        }
      }
    }
    return null;
  },
  ChainExpression(node, initialScope) {
    const expression = getStaticValueR6(node.expression, initialScope);
    if (expression != null) {
      return { value: expression.value };
    }
    return null;
  },
  NewExpression(node, initialScope) {
    const callee = getStaticValueR6(node.callee, initialScope);
    const args = getElementValues6(node.arguments, initialScope);
    if (callee != null && args != null) {
      const Func = callee.value;
      if (callAllowed6.has(Func)) {
        return { value: new Func(...args) };
      }
    }
    return null;
  },
  ObjectExpression(node, initialScope) {
    const object32 = {};
    for (const propertyNode of node.properties) {
      if (propertyNode.type === "Property") {
        if (propertyNode.kind !== "init") {
          return null;
        }
        const key = getStaticPropertyNameValue6(
          propertyNode,
          initialScope
        );
        const value = getStaticValueR6(propertyNode.value, initialScope);
        if (key == null || value == null) {
          return null;
        }
        object32[key.value] = value.value;
      } else if (propertyNode.type === "SpreadElement" || propertyNode.type === "ExperimentalSpreadProperty") {
        const argument = getStaticValueR6(
          propertyNode.argument,
          initialScope
        );
        if (argument == null) {
          return null;
        }
        Object.assign(object32, argument.value);
      } else {
        return null;
      }
    }
    return { value: object32 };
  },
  SequenceExpression(node, initialScope) {
    const last32 = node.expressions[node.expressions.length - 1];
    return getStaticValueR6(last32, initialScope);
  },
  TaggedTemplateExpression(node, initialScope) {
    const tag = getStaticValueR6(node.tag, initialScope);
    const expressions = getElementValues6(
      node.quasi.expressions,
      initialScope
    );
    if (tag != null && expressions != null) {
      const func = tag.value;
      const strings = node.quasi.quasis.map((q) => q.value.cooked);
      strings.raw = node.quasi.quasis.map((q) => q.value.raw);
      if (func === String.raw) {
        return { value: func(strings, ...expressions) };
      }
    }
    return null;
  },
  TemplateLiteral(node, initialScope) {
    const expressions = getElementValues6(node.expressions, initialScope);
    if (expressions != null) {
      let value = node.quasis[0].value.cooked;
      for (let i52 = 0; i52 < expressions.length; ++i52) {
        value += expressions[i52];
        value += node.quasis[i52 + 1].value.cooked;
      }
      return { value };
    }
    return null;
  },
  UnaryExpression(node, initialScope) {
    if (node.operator === "delete") {
      return null;
    }
    if (node.operator === "void") {
      return { value: void 0 };
    }
    const arg = getStaticValueR6(node.argument, initialScope);
    if (arg != null) {
      switch (node.operator) {
        case "-":
          return { value: -arg.value };
        case "+":
          return { value: +arg.value };
        case "!":
          return { value: !arg.value };
        case "~":
          return { value: ~arg.value };
        case "typeof":
          return { value: typeof arg.value };
      }
    }
    return null;
  }
});
function getStaticValueR6(node, initialScope) {
  if (node != null && Object.hasOwnProperty.call(operations6, node.type)) {
    return operations6[node.type](node, initialScope);
  }
  return null;
}
function getStaticPropertyNameValue6(node, initialScope) {
  const nameNode = node.type === "Property" ? node.key : node.property;
  if (node.computed) {
    return getStaticValueR6(nameNode, initialScope);
  }
  if (nameNode.type === "Identifier") {
    return { value: nameNode.name };
  }
  if (nameNode.type === "Literal") {
    if (nameNode.bigint) {
      return { value: nameNode.bigint };
    }
    return { value: String(nameNode.value) };
  }
  return null;
}
function getStaticValue3(node, initialScope = null) {
  try {
    return getStaticValueR6(node, initialScope);
  } catch (_error) {
    return null;
  }
}
function getStringIfConstant6(node, initialScope = null) {
  if (node && node.type === "Literal" && node.value === null) {
    if (node.regex) {
      return `/${node.regex.pattern}/${node.regex.flags}`;
    }
    if (node.bigint) {
      return node.bigint;
    }
  }
  const evaluated = getStaticValue3(node, initialScope);
  return evaluated && String(evaluated.value);
}
function getPropertyName6(node, initialScope) {
  switch (node.type) {
    case "MemberExpression":
      if (node.computed) {
        return getStringIfConstant6(node.property, initialScope);
      }
      if (node.property.type === "PrivateIdentifier") {
        return null;
      }
      return node.property.name;
    case "Property":
    case "MethodDefinition":
    case "PropertyDefinition":
      if (node.computed) {
        return getStringIfConstant6(node.key, initialScope);
      }
      if (node.key.type === "Literal") {
        return String(node.key.value);
      }
      if (node.key.type === "PrivateIdentifier") {
        return null;
      }
      return node.key.name;
  }
  return null;
}
function getFunctionNameWithKind6(node, sourceCode) {
  const parent = node.parent;
  const tokens = [];
  const isObjectMethod = parent.type === "Property" && parent.value === node;
  const isClassMethod = parent.type === "MethodDefinition" && parent.value === node;
  const isClassFieldMethod = parent.type === "PropertyDefinition" && parent.value === node;
  if (isClassMethod || isClassFieldMethod) {
    if (parent.static) {
      tokens.push("static");
    }
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push("private");
    }
  }
  if (node.async) {
    tokens.push("async");
  }
  if (node.generator) {
    tokens.push("generator");
  }
  if (isObjectMethod || isClassMethod) {
    if (parent.kind === "constructor") {
      return "constructor";
    }
    if (parent.kind === "get") {
      tokens.push("getter");
    } else if (parent.kind === "set") {
      tokens.push("setter");
    } else {
      tokens.push("method");
    }
  } else if (isClassFieldMethod) {
    tokens.push("method");
  } else {
    if (node.type === "ArrowFunctionExpression") {
      tokens.push("arrow");
    }
    tokens.push("function");
  }
  if (isObjectMethod || isClassMethod || isClassFieldMethod) {
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push(`#${parent.key.name}`);
    } else {
      const name22 = getPropertyName6(parent);
      if (name22) {
        tokens.push(`'${name22}'`);
      } else if (sourceCode) {
        const keyText = sourceCode.getText(parent.key);
        if (!keyText.includes("\n")) {
          tokens.push(`[${keyText}]`);
        }
      }
    }
  } else if (node.id) {
    tokens.push(`'${node.id.name}'`);
  } else if (parent.type === "VariableDeclarator" && parent.id && parent.id.type === "Identifier") {
    tokens.push(`'${parent.id.name}'`);
  } else if ((parent.type === "AssignmentExpression" || parent.type === "AssignmentPattern") && parent.left && parent.left.type === "Identifier") {
    tokens.push(`'${parent.left.name}'`);
  } else if (parent.type === "ExportDefaultDeclaration" && parent.declaration === node) {
    tokens.push("'default'");
  }
  return tokens.join(" ");
}
var typeConversionBinaryOps6 = Object.freeze(
  /* @__PURE__ */ new Set([
    "==",
    "!=",
    "<",
    "<=",
    ">",
    ">=",
    "<<",
    ">>",
    ">>>",
    "+",
    "-",
    "*",
    "/",
    "%",
    "|",
    "^",
    "&",
    "in"
  ])
);
var typeConversionUnaryOps6 = Object.freeze(/* @__PURE__ */ new Set(["-", "+", "!", "~"]));
function isNode6(x52) {
  return x52 !== null && typeof x52 === "object" && typeof x52.type === "string";
}
var visitor6 = Object.freeze(
  Object.assign(/* @__PURE__ */ Object.create(null), {
    $visit(node, options, visitorKeys) {
      const { type } = node;
      if (typeof this[type] === "function") {
        return this[type](node, options, visitorKeys);
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    $visitChildren(node, options, visitorKeys) {
      const { type } = node;
      for (const key of visitorKeys[type] || getKeys6(node)) {
        const value = node[key];
        if (Array.isArray(value)) {
          for (const element of value) {
            if (isNode6(element) && this.$visit(element, options, visitorKeys)) {
              return true;
            }
          }
        } else if (isNode6(value) && this.$visit(value, options, visitorKeys)) {
          return true;
        }
      }
      return false;
    },
    ArrowFunctionExpression() {
      return false;
    },
    AssignmentExpression() {
      return true;
    },
    AwaitExpression() {
      return true;
    },
    BinaryExpression(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && typeConversionBinaryOps6.has(node.operator) && (node.left.type !== "Literal" || node.right.type !== "Literal")) {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    CallExpression() {
      return true;
    },
    FunctionExpression() {
      return false;
    },
    ImportExpression() {
      return true;
    },
    MemberExpression(node, options, visitorKeys) {
      if (options.considerGetters) {
        return true;
      }
      if (options.considerImplicitTypeConversion && node.computed && node.property.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    MethodDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    NewExpression() {
      return true;
    },
    Property(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    PropertyDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UnaryExpression(node, options, visitorKeys) {
      if (node.operator === "delete") {
        return true;
      }
      if (options.considerImplicitTypeConversion && typeConversionUnaryOps6.has(node.operator) && node.argument.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UpdateExpression() {
      return true;
    },
    YieldExpression() {
      return true;
    }
  })
);
function hasSideEffect6(node, sourceCode, { considerGetters = false, considerImplicitTypeConversion = false } = {}) {
  return visitor6.$visit(
    node,
    { considerGetters, considerImplicitTypeConversion },
    sourceCode.visitorKeys || visitor_keys_default6
  );
}
function getParentSyntaxParen6(node, sourceCode) {
  const parent = node.parent;
  switch (parent.type) {
    case "CallExpression":
    case "NewExpression":
      if (parent.arguments.length === 1 && parent.arguments[0] === node) {
        return sourceCode.getTokenAfter(
          parent.callee,
          isOpeningParenToken6
        );
      }
      return null;
    case "DoWhileStatement":
      if (parent.test === node) {
        return sourceCode.getTokenAfter(
          parent.body,
          isOpeningParenToken6
        );
      }
      return null;
    case "IfStatement":
    case "WhileStatement":
      if (parent.test === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "ImportExpression":
      if (parent.source === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "SwitchStatement":
      if (parent.discriminant === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "WithStatement":
      if (parent.object === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    default:
      return null;
  }
}
function isParenthesized6(timesOrNode, nodeOrSourceCode, optionalSourceCode) {
  let times, node, sourceCode, maybeLeftParen, maybeRightParen;
  if (typeof timesOrNode === "number") {
    times = timesOrNode | 0;
    node = nodeOrSourceCode;
    sourceCode = optionalSourceCode;
    if (!(times >= 1)) {
      throw new TypeError("'times' should be a positive integer.");
    }
  } else {
    times = 1;
    node = timesOrNode;
    sourceCode = nodeOrSourceCode;
  }
  if (node == null || // `Program` can't be parenthesized
  node.parent == null || // `CatchClause.param` can't be parenthesized, example `try {} catch (error) {}`
  node.parent.type === "CatchClause" && node.parent.param === node) {
    return false;
  }
  maybeLeftParen = maybeRightParen = node;
  do {
    maybeLeftParen = sourceCode.getTokenBefore(maybeLeftParen);
    maybeRightParen = sourceCode.getTokenAfter(maybeRightParen);
  } while (maybeLeftParen != null && maybeRightParen != null && isOpeningParenToken6(maybeLeftParen) && isClosingParenToken6(maybeRightParen) && // Avoid false positive such as `if (a) {}`
  maybeLeftParen !== getParentSyntaxParen6(node, sourceCode) && --times > 0);
  return times === 0;
}
Function.call.bind(Object.hasOwnProperty);
var __defProp25 = Object.defineProperty;
var __export25 = (target, all342) => {
  for (var name22 in all342)
    __defProp25(target, name22, { get: all342[name22], enumerable: true });
};
var NodeType6 = types.AST_NODE_TYPES;
var is6 = utils.ASTUtils.isNodeOfType;
var isOneOf6 = utils.ASTUtils.isNodeOfTypes;
isOneOf6([
  NodeType6.ArrowFunctionExpression,
  NodeType6.FunctionDeclaration,
  NodeType6.FunctionExpression
]);
isOneOf6([
  NodeType6.ArrowFunctionExpression,
  NodeType6.FunctionDeclaration,
  NodeType6.FunctionExpression,
  NodeType6.TSCallSignatureDeclaration,
  NodeType6.TSConstructSignatureDeclaration,
  NodeType6.TSDeclareFunction,
  NodeType6.TSEmptyBodyFunctionExpression,
  NodeType6.TSFunctionType,
  NodeType6.TSMethodSignature
]);
isOneOf6([NodeType6.ClassDeclaration, NodeType6.ClassExpression]);
isOneOf6([
  NodeType6.DoWhileStatement,
  NodeType6.ForInStatement,
  NodeType6.ForOfStatement,
  NodeType6.ForStatement,
  NodeType6.WhileStatement
]);
isOneOf6([NodeType6.TSArrayType, NodeType6.TSTupleType]);
isOneOf6([
  NodeType6.PropertyDefinition,
  NodeType6.TSIndexSignature,
  NodeType6.TSParameterProperty,
  NodeType6.TSPropertySignature
]);
is6(NodeType6.JSXElement);
is6(NodeType6.JSXFragment);
isOneOf6([
  NodeType6.JSXAttribute,
  NodeType6.JSXSpreadChild,
  NodeType6.JSXClosingElement,
  NodeType6.JSXClosingFragment,
  NodeType6.JSXElement,
  NodeType6.JSXEmptyExpression,
  NodeType6.JSXExpressionContainer,
  NodeType6.JSXFragment,
  NodeType6.JSXIdentifier,
  NodeType6.JSXMemberExpression,
  NodeType6.JSXNamespacedName,
  NodeType6.JSXOpeningElement,
  NodeType6.JSXOpeningFragment,
  NodeType6.JSXSpreadAttribute,
  NodeType6.JSXSpreadChild,
  NodeType6.JSXText
]);
isOneOf6([
  NodeType6.JSXIdentifier,
  NodeType6.JSXMemberExpression,
  NodeType6.JSXNamespacedName
]);
isOneOf6([
  NodeType6.ArrayPattern,
  NodeType6.AssignmentPattern,
  NodeType6.ObjectPattern,
  NodeType6.RestElement
]);
isOneOf6([
  NodeType6.TSInterfaceDeclaration,
  NodeType6.TSTypeAliasDeclaration
]);
isOneOf6([
  NodeType6.ArrayExpression,
  NodeType6.ArrayPattern,
  NodeType6.ArrowFunctionExpression,
  NodeType6.CallExpression,
  NodeType6.ClassExpression,
  NodeType6.FunctionExpression,
  NodeType6.Identifier,
  NodeType6.JSXElement,
  NodeType6.JSXFragment,
  NodeType6.Literal,
  NodeType6.TemplateLiteral,
  NodeType6.MemberExpression,
  NodeType6.MetaProperty,
  NodeType6.ObjectExpression,
  NodeType6.ObjectPattern,
  NodeType6.SequenceExpression,
  NodeType6.Super,
  NodeType6.TaggedTemplateExpression,
  NodeType6.ThisExpression
]);
isOneOf6([
  NodeType6.ArrayExpression,
  NodeType6.ArrayPattern,
  NodeType6.ArrowFunctionExpression,
  NodeType6.CallExpression,
  NodeType6.ClassExpression,
  NodeType6.FunctionExpression,
  NodeType6.Identifier,
  NodeType6.JSXElement,
  NodeType6.JSXFragment,
  NodeType6.Literal,
  NodeType6.TemplateLiteral,
  NodeType6.MemberExpression,
  NodeType6.MetaProperty,
  NodeType6.ObjectExpression,
  NodeType6.ObjectPattern,
  NodeType6.SequenceExpression,
  NodeType6.Super,
  NodeType6.TaggedTemplateExpression,
  NodeType6.ThisExpression,
  NodeType6.TSAsExpression,
  NodeType6.TSNonNullExpression,
  NodeType6.TSTypeAssertion
]);
var Function_exports8 = {};
__export25(Function_exports8, {
  SK: () => SK8,
  absurd: () => absurd8,
  apply: () => apply8,
  compose: () => compose12,
  constFalse: () => constFalse8,
  constNull: () => constNull8,
  constTrue: () => constTrue8,
  constUndefined: () => constUndefined8,
  constVoid: () => constVoid8,
  constant: () => constant8,
  dual: () => dual8,
  flip: () => flip8,
  flow: () => flow8,
  hole: () => hole8,
  identity: () => identity8,
  isFunction: () => isFunction26,
  pipe: () => pipe8,
  satisfies: () => satisfies8,
  tupled: () => tupled8,
  unsafeCoerce: () => unsafeCoerce8,
  untupled: () => untupled8
});
var isFunction26 = (input) => typeof input === "function";
var dual8 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a52, b52) {
        if (arguments.length >= 2) {
          return body(a52, b52);
        }
        return function(self2) {
          return body(self2, a52);
        };
      };
    case 3:
      return function(a52, b52, c52) {
        if (arguments.length >= 3) {
          return body(a52, b52, c52);
        }
        return function(self2) {
          return body(self2, a52, b52);
        };
      };
    case 4:
      return function(a52, b52, c52, d52) {
        if (arguments.length >= 4) {
          return body(a52, b52, c52, d52);
        }
        return function(self2) {
          return body(self2, a52, b52, c52);
        };
      };
    case 5:
      return function(a52, b52, c52, d52, e52) {
        if (arguments.length >= 5) {
          return body(a52, b52, c52, d52, e52);
        }
        return function(self2) {
          return body(self2, a52, b52, c52, d52);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply8 = (a52) => (self2) => self2(a52);
var identity8 = (a52) => a52;
var satisfies8 = () => (b52) => b52;
var unsafeCoerce8 = identity8;
var constant8 = (value) => () => value;
var constTrue8 = /* @__PURE__ */ constant8(true);
var constFalse8 = /* @__PURE__ */ constant8(false);
var constNull8 = /* @__PURE__ */ constant8(null);
var constUndefined8 = /* @__PURE__ */ constant8(void 0);
var constVoid8 = constUndefined8;
var flip8 = (f52) => (...b52) => (...a52) => f52(...a52)(...b52);
var compose12 = /* @__PURE__ */ dual8(2, (ab, bc) => (a52) => bc(ab(a52)));
var absurd8 = (_52) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled8 = (f52) => (a52) => f52(...a52);
var untupled8 = (f52) => (...a52) => f52(a52);
function pipe8(a52, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a52;
    case 2:
      return ab(a52);
    case 3:
      return bc(ab(a52));
    case 4:
      return cd(bc(ab(a52)));
    case 5:
      return de(cd(bc(ab(a52))));
    case 6:
      return ef(de(cd(bc(ab(a52)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a52))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a52)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a52))))))));
    default: {
      let ret = arguments[0];
      for (let i52 = 1; i52 < arguments.length; i52++) {
        ret = arguments[i52](ret);
      }
      return ret;
    }
  }
}
function flow8(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole8 = /* @__PURE__ */ unsafeCoerce8(absurd8);
var SK8 = (_52, b52) => b52;
var make26 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_13 = (map622) => dual8(3, (self2, name22, f52) => map622(self2, (a52) => Object.assign({}, a52, {
  [name22]: f52(a52)
})));
var bindTo13 = (map622) => dual8(2, (self2, name22) => map622(self2, (a52) => ({
  [name22]: a52
})));
var bind13 = (map622, flatMap432) => dual8(3, (self2, name22, f52) => flatMap432(self2, (a52) => map622(f52(a52), (b52) => Object.assign({}, a52, {
  [name22]: b52
}))));
var moduleVersion8 = "3.2.8";
var getCurrentVersion8 = () => moduleVersion8;
var globalStoreId8 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion8()}`);
if (!(globalStoreId8 in globalThis)) {
  globalThis[globalStoreId8] = /* @__PURE__ */ new Map();
}
var globalStore8 = globalThis[globalStoreId8];
var globalValue8 = (id, compute) => {
  if (!globalStore8.has(id)) {
    globalStore8.set(id, compute());
  }
  return globalStore8.get(id);
};
var Predicate_exports6 = {};
__export25(Predicate_exports6, {
  all: () => all12,
  and: () => and8,
  compose: () => compose26,
  eqv: () => eqv8,
  every: () => every10,
  hasProperty: () => hasProperty8,
  implies: () => implies8,
  isBigInt: () => isBigInt8,
  isBoolean: () => isBoolean8,
  isDate: () => isDate8,
  isError: () => isError8,
  isFunction: () => isFunction35,
  isIterable: () => isIterable8,
  isMap: () => isMap8,
  isNever: () => isNever8,
  isNotNull: () => isNotNull8,
  isNotNullable: () => isNotNullable8,
  isNotUndefined: () => isNotUndefined8,
  isNull: () => isNull8,
  isNullable: () => isNullable8,
  isNumber: () => isNumber8,
  isObject: () => isObject8,
  isPromise: () => isPromise8,
  isPromiseLike: () => isPromiseLike8,
  isReadonlyRecord: () => isReadonlyRecord8,
  isRecord: () => isRecord8,
  isSet: () => isSet8,
  isString: () => isString8,
  isSymbol: () => isSymbol8,
  isTagged: () => isTagged8,
  isTruthy: () => isTruthy8,
  isUint8Array: () => isUint8Array8,
  isUndefined: () => isUndefined8,
  isUnknown: () => isUnknown8,
  mapInput: () => mapInput9,
  nand: () => nand8,
  nor: () => nor8,
  not: () => not8,
  or: () => or8,
  product: () => product12,
  productMany: () => productMany12,
  some: () => some18,
  struct: () => struct10,
  tuple: () => tuple9,
  xor: () => xor8
});
var mapInput9 = /* @__PURE__ */ dual8(2, (self2, f52) => (b52) => self2(f52(b52)));
var isTruthy8 = (input) => !!input;
var isSet8 = (input) => input instanceof Set;
var isMap8 = (input) => input instanceof Map;
var isString8 = (input) => typeof input === "string";
var isNumber8 = (input) => typeof input === "number";
var isBoolean8 = (input) => typeof input === "boolean";
var isBigInt8 = (input) => typeof input === "bigint";
var isSymbol8 = (input) => typeof input === "symbol";
var isFunction35 = isFunction26;
var isUndefined8 = (input) => input === void 0;
var isNotUndefined8 = (input) => input !== void 0;
var isNull8 = (input) => input === null;
var isNotNull8 = (input) => input !== null;
var isNever8 = (_52) => false;
var isUnknown8 = (_52) => true;
var isRecordOrArray8 = (input) => typeof input === "object" && input !== null;
var isObject8 = (input) => isRecordOrArray8(input) || isFunction35(input);
var hasProperty8 = /* @__PURE__ */ dual8(2, (self2, property) => isObject8(self2) && property in self2);
var isTagged8 = /* @__PURE__ */ dual8(2, (self2, tag) => hasProperty8(self2, "_tag") && self2["_tag"] === tag);
var isNullable8 = (input) => input === null || input === void 0;
var isNotNullable8 = (input) => input !== null && input !== void 0;
var isError8 = (input) => input instanceof Error;
var isUint8Array8 = (input) => input instanceof Uint8Array;
var isDate8 = (input) => input instanceof Date;
var isIterable8 = (input) => hasProperty8(input, Symbol.iterator);
var isRecord8 = (input) => isRecordOrArray8(input) && !Array.isArray(input);
var isReadonlyRecord8 = isRecord8;
var isPromise8 = (input) => hasProperty8(input, "then") && "catch" in input && isFunction35(input.then) && isFunction35(input.catch);
var isPromiseLike8 = (input) => hasProperty8(input, "then") && isFunction35(input.then);
var compose26 = /* @__PURE__ */ dual8(2, (ab, bc) => (a52) => ab(a52) && bc(a52));
var product12 = (self2, that) => ([a52, b52]) => self2(a52) && that(b52);
var all12 = (collection) => {
  return (as262) => {
    let collectionIndex = 0;
    for (const p52 of collection) {
      if (collectionIndex >= as262.length) {
        break;
      }
      if (p52(as262[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany12 = (self2, collection) => {
  const rest = all12(collection);
  return ([head222, ...tail42]) => self2(head222) === false ? false : rest(tail42);
};
var tuple9 = (...elements) => all12(elements);
var struct10 = (fields) => {
  const keys242 = Object.keys(fields);
  return (a52) => {
    for (const key of keys242) {
      if (!fields[key](a52[key])) {
        return false;
      }
    }
    return true;
  };
};
var not8 = (self2) => (a52) => !self2(a52);
var or8 = /* @__PURE__ */ dual8(2, (self2, that) => (a52) => self2(a52) || that(a52));
var and8 = /* @__PURE__ */ dual8(2, (self2, that) => (a52) => self2(a52) && that(a52));
var xor8 = /* @__PURE__ */ dual8(2, (self2, that) => (a52) => self2(a52) !== that(a52));
var eqv8 = /* @__PURE__ */ dual8(2, (self2, that) => (a52) => self2(a52) === that(a52));
var implies8 = /* @__PURE__ */ dual8(2, (self2, that) => (a52) => self2(a52) ? that(a52) : true);
var nor8 = /* @__PURE__ */ dual8(2, (self2, that) => (a52) => !(self2(a52) || that(a52)));
var nand8 = /* @__PURE__ */ dual8(2, (self2, that) => (a52) => !(self2(a52) && that(a52)));
var every10 = (collection) => (a52) => {
  for (const p52 of collection) {
    if (!p52(a52)) {
      return false;
    }
  }
  return true;
};
var some18 = (collection) => (a52) => {
  for (const p52 of collection) {
    if (p52(a52)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage8 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId8 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind8 = (u52) => isObject8(u52) && GenKindTypeId8 in u52;
var GenKindImpl8 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity8;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_52) => _52;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_52) => _52;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_52) => _52;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId8] = GenKindTypeId8;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen9(this);
  }
};
var SingleShotGen9 = class _SingleShotGen11 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a52) {
    return this.called ? {
      value: a52,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a52) {
    return {
      value: a52,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e52) {
    throw e52;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen11(this.self);
  }
};
var adapter12 = () => function() {
  let x52 = arguments[0];
  for (let i52 = 1; i52 < arguments.length; i52++) {
    x52 = arguments[i52](x52);
  }
  return new GenKindImpl8(x52);
};
var defaultIncHi8 = 335903614;
var defaultIncLo8 = 4150755663;
var MUL_HI8 = 1481765933 >>> 0;
var MUL_LO8 = 1284865837 >>> 0;
var BIT_538 = 9007199254740992;
var BIT_278 = 134217728;
var PCGRandom8 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable8(seedLo) && isNullable8(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable8(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable8(incLo) && isNullable8(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo8;
      incHi = this._state ? this._state[2] : defaultIncHi8;
    } else if (isNullable8(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add648(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max42) {
    if (!max42) {
      return this._next();
    }
    max42 = max42 >>> 0;
    if ((max42 & max42 - 1) === 0) {
      return this._next() & max42 - 1;
    }
    let num = 0;
    const skew = (-max42 >>> 0) % max42 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max42;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_278 + lo) / BIT_538;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul648(this._state, oldHi, oldLo, MUL_HI8, MUL_LO8);
    add648(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul648(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add648(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId8 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap8 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId8]() {
    return this.#value;
  }
};
function yieldWrapGet8(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId8 in self2) {
    return self2[YieldWrapTypeId8]();
  }
  throw new Error(getBugErrorMessage8("yieldWrapGet"));
}
var structuralRegionState8 = /* @__PURE__ */ globalValue8("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache8 = /* @__PURE__ */ globalValue8(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr8 = /* @__PURE__ */ globalValue8(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom8());
var symbol12 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash8 = (self2) => {
  if (structuralRegionState8.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number9(self2);
    case "bigint":
      return string9(self2.toString(10));
    case "boolean":
      return string9(String(self2));
    case "symbol":
      return string9(String(self2));
    case "string":
      return string9(self2);
    case "undefined":
      return string9("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string9("null");
      } else if (self2 instanceof Date) {
        return hash8(self2.toISOString());
      } else if (isHash8(self2)) {
        return self2[symbol12]();
      } else {
        return random8(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random8 = (self2) => {
  if (!randomHashCache8.has(self2)) {
    randomHashCache8.set(self2, number9(pcgr8.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache8.get(self2);
};
var combine9 = (b52) => (self2) => self2 * 53 ^ b52;
var optimize8 = (n52) => n52 & 3221225471 | n52 >>> 1 & 1073741824;
var isHash8 = (u52) => hasProperty8(u52, symbol12);
var number9 = (n52) => {
  if (n52 !== n52 || n52 === Infinity) {
    return 0;
  }
  let h52 = n52 | 0;
  if (h52 !== n52) {
    h52 ^= n52 * 4294967295;
  }
  while (n52 > 4294967295) {
    h52 ^= n52 /= 4294967295;
  }
  return optimize8(n52);
};
var string9 = (str) => {
  let h52 = 5381, i52 = str.length;
  while (i52) {
    h52 = h52 * 33 ^ str.charCodeAt(--i52);
  }
  return optimize8(h52);
};
var structureKeys4 = (o52, keys242) => {
  let h52 = 12289;
  for (let i52 = 0; i52 < keys242.length; i52++) {
    h52 ^= pipe8(string9(keys242[i52]), combine9(hash8(o52[keys242[i52]])));
  }
  return optimize8(h52);
};
var structure4 = (o52) => structureKeys4(o52, Object.keys(o52));
var array10 = (arr) => {
  let h52 = 6151;
  for (let i52 = 0; i52 < arr.length; i52++) {
    h52 = pipe8(h52, combine9(hash8(arr[i52])));
  }
  return optimize8(h52);
};
var cached8 = function() {
  if (arguments.length === 1) {
    const self22 = arguments[0];
    return function(hash332) {
      Object.defineProperty(self22, symbol12, {
        value() {
          return hash332;
        },
        enumerable: false
      });
      return hash332;
    };
  }
  const self2 = arguments[0];
  const hash262 = arguments[1];
  Object.defineProperty(self2, symbol12, {
    value() {
      return hash262;
    },
    enumerable: false
  });
  return hash262;
};
var symbol26 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals8() {
  if (arguments.length === 1) {
    return (self2) => compareBoth8(self2, arguments[0]);
  }
  return compareBoth8(arguments[0], arguments[1]);
}
function compareBoth8(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual8(self2) && isEqual8(that)) {
        if (hash8(self2) === hash8(that) && self2[symbol26](that)) {
          return true;
        } else {
          return structuralRegionState8.enabled && structuralRegionState8.tester ? structuralRegionState8.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState8.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v52, i52) => compareBoth8(v52, that[i52]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth8(self2[key], that[key]))) {
              return structuralRegionState8.tester ? structuralRegionState8.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState8.tester ? structuralRegionState8.tester(self2, that) : false;
    }
  }
  return structuralRegionState8.enabled && structuralRegionState8.tester ? structuralRegionState8.tester(self2, that) : false;
}
var isEqual8 = (u52) => hasProperty8(u52, symbol26);
var equivalence8 = () => equals8;
var NodeInspectSymbol8 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON8 = (x52) => {
  if (hasProperty8(x52, "toJSON") && isFunction35(x52["toJSON"]) && x52["toJSON"].length === 0) {
    return x52.toJSON();
  } else if (Array.isArray(x52)) {
    return x52.map(toJSON8);
  }
  return x52;
};
var format8 = (x52) => JSON.stringify(x52, null, 2);
var pipeArguments8 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i52 = 0, len = args.length; i52 < len; i52++) {
        ret = args[i52](ret);
      }
      return ret;
    }
  }
};
var OP_COMMIT4 = "Commit";
var OP_FAILURE6 = "Failure";
var OP_WITH_RUNTIME6 = "WithRuntime";
var EffectTypeId9 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId8 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId8 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId8 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance8 = {
  /* c8 ignore next */
  _R: (_52) => _52,
  /* c8 ignore next */
  _E: (_52) => _52,
  /* c8 ignore next */
  _A: (_52) => _52,
  _V: /* @__PURE__ */ getCurrentVersion8()
};
var sinkVariance8 = {
  /* c8 ignore next */
  _A: (_52) => _52,
  /* c8 ignore next */
  _In: (_52) => _52,
  /* c8 ignore next */
  _L: (_52) => _52,
  /* c8 ignore next */
  _E: (_52) => _52,
  /* c8 ignore next */
  _R: (_52) => _52
};
var channelVariance8 = {
  /* c8 ignore next */
  _Env: (_52) => _52,
  /* c8 ignore next */
  _InErr: (_52) => _52,
  /* c8 ignore next */
  _InElem: (_52) => _52,
  /* c8 ignore next */
  _InDone: (_52) => _52,
  /* c8 ignore next */
  _OutErr: (_52) => _52,
  /* c8 ignore next */
  _OutElem: (_52) => _52,
  /* c8 ignore next */
  _OutDone: (_52) => _52
};
var EffectPrototype8 = {
  [EffectTypeId9]: effectVariance8,
  [StreamTypeId8]: effectVariance8,
  [SinkTypeId8]: sinkVariance8,
  [ChannelTypeId8]: channelVariance8,
  [symbol26](that) {
    return this === that;
  },
  [symbol12]() {
    return cached8(this, random8(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen9(new YieldWrap8(this));
  },
  pipe() {
    return pipeArguments8(this, arguments);
  }
};
var StructuralPrototype4 = {
  [symbol12]() {
    return cached8(this, structure4(this));
  },
  [symbol26](that) {
    const selfKeys = Object.keys(this);
    const thatKeys = Object.keys(that);
    if (selfKeys.length !== thatKeys.length) {
      return false;
    }
    for (const key of selfKeys) {
      if (!(key in that && equals8(this[key], that[key]))) {
        return false;
      }
    }
    return true;
  }
};
var CommitPrototype4 = {
  ...EffectPrototype8,
  _op: OP_COMMIT4
};
var StructuralCommitPrototype4 = {
  ...CommitPrototype4,
  ...StructuralPrototype4
};
var TypeId26 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto12 = {
  ...EffectPrototype8,
  [TypeId26]: {
    _A: (_52) => _52
  },
  [NodeInspectSymbol8]() {
    return this.toJSON();
  },
  toString() {
    return format8(this.toJSON());
  }
};
var SomeProto8 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto12), {
  _tag: "Some",
  _op: "Some",
  [symbol26](that) {
    return isOption12(that) && isSome12(that) && equals8(this.value, that.value);
  },
  [symbol12]() {
    return cached8(this, combine9(hash8(this._tag))(hash8(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON8(this.value)
    };
  }
});
var NoneHash8 = /* @__PURE__ */ hash8("None");
var NoneProto8 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto12), {
  _tag: "None",
  _op: "None",
  [symbol26](that) {
    return isOption12(that) && isNone12(that);
  },
  [symbol12]() {
    return NoneHash8;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption12 = (input) => hasProperty8(input, TypeId26);
var isNone12 = (fa) => fa._tag === "None";
var isSome12 = (fa) => fa._tag === "Some";
var none12 = /* @__PURE__ */ Object.create(NoneProto8);
var some26 = (value) => {
  const a52 = Object.create(SomeProto8);
  a52.value = value;
  return a52;
};
var TypeId27 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto26 = {
  ...EffectPrototype8,
  [TypeId27]: {
    _R: (_52) => _52
  },
  [NodeInspectSymbol8]() {
    return this.toJSON();
  },
  toString() {
    return format8(this.toJSON());
  }
};
var RightProto8 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto26), {
  _tag: "Right",
  _op: "Right",
  [symbol26](that) {
    return isEither8(that) && isRight10(that) && equals8(this.right, that.right);
  },
  [symbol12]() {
    return combine9(hash8(this._tag))(hash8(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON8(this.right)
    };
  }
});
var LeftProto8 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto26), {
  _tag: "Left",
  _op: "Left",
  [symbol26](that) {
    return isEither8(that) && isLeft10(that) && equals8(this.left, that.left);
  },
  [symbol12]() {
    return combine9(hash8(this._tag))(hash8(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON8(this.left)
    };
  }
});
var isEither8 = (input) => hasProperty8(input, TypeId27);
var isLeft10 = (ma) => ma._tag === "Left";
var isRight10 = (ma) => ma._tag === "Right";
var left9 = (left342) => {
  const a52 = Object.create(LeftProto8);
  a52.left = left342;
  return a52;
};
var right9 = (right342) => {
  const a52 = Object.create(RightProto8);
  a52.right = right342;
  return a52;
};
var getLeft12 = (self2) => isRight10(self2) ? none12 : some26(self2.left);
var getRight12 = (self2) => isLeft10(self2) ? none12 : some26(self2.right);
var right26 = right9;
var left26 = left9;
var Option_exports8 = {};
__export25(Option_exports8, {
  Do: () => Do9,
  TypeId: () => TypeId36,
  all: () => all26,
  andThen: () => andThen8,
  ap: () => ap8,
  as: () => as8,
  asVoid: () => asVoid8,
  bind: () => bind26,
  bindTo: () => bindTo26,
  composeK: () => composeK8,
  contains: () => contains9,
  containsWith: () => containsWith9,
  exists: () => exists8,
  filter: () => filter10,
  filterMap: () => filterMap10,
  firstSomeOf: () => firstSomeOf8,
  flatMap: () => flatMap9,
  flatMapNullable: () => flatMapNullable9,
  flatten: () => flatten9,
  fromIterable: () => fromIterable12,
  fromNullable: () => fromNullable9,
  gen: () => gen8,
  getEquivalence: () => getEquivalence11,
  getLeft: () => getLeft26,
  getOrElse: () => getOrElse8,
  getOrNull: () => getOrNull8,
  getOrThrow: () => getOrThrow8,
  getOrThrowWith: () => getOrThrowWith8,
  getOrUndefined: () => getOrUndefined8,
  getOrder: () => getOrder9,
  getRight: () => getRight26,
  isNone: () => isNone26,
  isOption: () => isOption26,
  isSome: () => isSome26,
  let: () => let_26,
  lift2: () => lift28,
  liftNullable: () => liftNullable9,
  liftPredicate: () => liftPredicate9,
  liftThrowable: () => liftThrowable8,
  map: () => map10,
  match: () => match26,
  none: () => none26,
  orElse: () => orElse8,
  orElseEither: () => orElseEither8,
  orElseSome: () => orElseSome8,
  partitionMap: () => partitionMap10,
  product: () => product26,
  productMany: () => productMany26,
  reduceCompact: () => reduceCompact8,
  some: () => some36,
  tap: () => tap8,
  toArray: () => toArray8,
  toRefinement: () => toRefinement8,
  void: () => void_8,
  zipLeft: () => zipLeft8,
  zipRight: () => zipRight8,
  zipWith: () => zipWith9
});
var make27 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId36 = /* @__PURE__ */ Symbol.for("effect/Option");
var none26 = () => none12;
var some36 = some26;
var isOption26 = isOption12;
var isNone26 = isNone12;
var isSome26 = isSome12;
var match26 = /* @__PURE__ */ dual8(2, (self2, {
  onNone,
  onSome
}) => isNone26(self2) ? onNone() : onSome(self2.value));
var toRefinement8 = (f52) => (a52) => isSome26(f52(a52));
var fromIterable12 = (collection) => {
  for (const a52 of collection) {
    return some36(a52);
  }
  return none26();
};
var getRight26 = getRight12;
var getLeft26 = getLeft12;
var getOrElse8 = /* @__PURE__ */ dual8(2, (self2, onNone) => isNone26(self2) ? onNone() : self2.value);
var orElse8 = /* @__PURE__ */ dual8(2, (self2, that) => isNone26(self2) ? that() : self2);
var orElseSome8 = /* @__PURE__ */ dual8(2, (self2, onNone) => isNone26(self2) ? some36(onNone()) : self2);
var orElseEither8 = /* @__PURE__ */ dual8(2, (self2, that) => isNone26(self2) ? map10(that(), right9) : map10(self2, left9));
var firstSomeOf8 = (collection) => {
  let out = none26();
  for (out of collection) {
    if (isSome26(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable9 = (nullableValue) => nullableValue == null ? none26() : some36(nullableValue);
var liftNullable9 = (f52) => (...a52) => fromNullable9(f52(...a52));
var getOrNull8 = /* @__PURE__ */ getOrElse8(constNull8);
var getOrUndefined8 = /* @__PURE__ */ getOrElse8(constUndefined8);
var liftThrowable8 = (f52) => (...a52) => {
  try {
    return some36(f52(...a52));
  } catch (e52) {
    return none26();
  }
};
var getOrThrowWith8 = /* @__PURE__ */ dual8(2, (self2, onNone) => {
  if (isSome26(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow8 = /* @__PURE__ */ getOrThrowWith8(() => new Error("getOrThrow called on a None"));
var map10 = /* @__PURE__ */ dual8(2, (self2, f52) => isNone26(self2) ? none26() : some36(f52(self2.value)));
var as8 = /* @__PURE__ */ dual8(2, (self2, b52) => map10(self2, () => b52));
var asVoid8 = /* @__PURE__ */ as8(void 0);
var void_8 = /* @__PURE__ */ some36(void 0);
var flatMap9 = /* @__PURE__ */ dual8(2, (self2, f52) => isNone26(self2) ? none26() : f52(self2.value));
var andThen8 = /* @__PURE__ */ dual8(2, (self2, f52) => flatMap9(self2, (a52) => {
  const b52 = isFunction26(f52) ? f52(a52) : f52;
  return isOption26(b52) ? b52 : some36(b52);
}));
var flatMapNullable9 = /* @__PURE__ */ dual8(2, (self2, f52) => isNone26(self2) ? none26() : fromNullable9(f52(self2.value)));
var flatten9 = /* @__PURE__ */ flatMap9(identity8);
var zipRight8 = /* @__PURE__ */ dual8(2, (self2, that) => flatMap9(self2, () => that));
var composeK8 = /* @__PURE__ */ dual8(2, (afb, bfc) => (a52) => flatMap9(afb(a52), bfc));
var zipLeft8 = /* @__PURE__ */ dual8(2, (self2, that) => tap8(self2, () => that));
var tap8 = /* @__PURE__ */ dual8(2, (self2, f52) => flatMap9(self2, (a52) => map10(f52(a52), () => a52)));
var product26 = (self2, that) => isSome26(self2) && isSome26(that) ? some36([self2.value, that.value]) : none26();
var productMany26 = (self2, collection) => {
  if (isNone26(self2)) {
    return none26();
  }
  const out = [self2.value];
  for (const o52 of collection) {
    if (isNone26(o52)) {
      return none26();
    }
    out.push(o52.value);
  }
  return some36(out);
};
var all26 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o52 of input) {
      if (isNone26(o52)) {
        return none26();
      }
      out2.push(o52.value);
    }
    return some36(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o52 = input[key];
    if (isNone26(o52)) {
      return none26();
    }
    out[key] = o52.value;
  }
  return some36(out);
};
var zipWith9 = /* @__PURE__ */ dual8(3, (self2, that, f52) => map10(product26(self2, that), ([a52, b52]) => f52(a52, b52)));
var ap8 = /* @__PURE__ */ dual8(2, (self2, that) => zipWith9(self2, that, (f52, a52) => f52(a52)));
var reduceCompact8 = /* @__PURE__ */ dual8(3, (self2, b52, f52) => {
  let out = b52;
  for (const oa of self2) {
    if (isSome26(oa)) {
      out = f52(out, oa.value);
    }
  }
  return out;
});
var toArray8 = (self2) => isNone26(self2) ? [] : [self2.value];
var partitionMap10 = /* @__PURE__ */ dual8(2, (self2, f52) => {
  if (isNone26(self2)) {
    return [none26(), none26()];
  }
  const e52 = f52(self2.value);
  return isLeft10(e52) ? [some36(e52.left), none26()] : [none26(), some36(e52.right)];
});
var filterMap10 = /* @__PURE__ */ dual8(2, (self2, f52) => isNone26(self2) ? none26() : f52(self2.value));
var filter10 = /* @__PURE__ */ dual8(2, (self2, predicate) => filterMap10(self2, (b52) => predicate(b52) ? some26(b52) : none12));
var getEquivalence11 = (isEquivalent) => make26((x52, y52) => x52 === y52 || (isNone26(x52) ? isNone26(y52) : isNone26(y52) ? false : isEquivalent(x52.value, y52.value)));
var getOrder9 = (O52) => make27((self2, that) => isSome26(self2) ? isSome26(that) ? O52(self2.value, that.value) : 1 : -1);
var lift28 = (f52) => dual8(2, (self2, that) => zipWith9(self2, that, f52));
var liftPredicate9 = (predicate) => (b52) => predicate(b52) ? some36(b52) : none26();
var containsWith9 = (isEquivalent) => dual8(2, (self2, a52) => isNone26(self2) ? false : isEquivalent(self2.value, a52));
var _equivalence10 = /* @__PURE__ */ equivalence8();
var contains9 = /* @__PURE__ */ containsWith9(_equivalence10);
var exists8 = /* @__PURE__ */ dual8(2, (self2, refinement) => isNone26(self2) ? false : refinement(self2.value));
var bindTo26 = /* @__PURE__ */ bindTo13(map10);
var let_26 = /* @__PURE__ */ let_13(map10);
var bind26 = /* @__PURE__ */ bind13(map10, flatMap9);
var Do9 = /* @__PURE__ */ some36({});
var adapter26 = /* @__PURE__ */ adapter12();
var gen8 = (f52) => {
  const iterator = f52(adapter26);
  let state = iterator.next();
  if (state.done) {
    return some36(state.value);
  } else {
    let current = state.value;
    if (isGenKind8(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet8(current);
    }
    if (isNone26(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind8(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet8(current);
        }
        if (isNone26(current)) {
          return current;
        }
      }
    }
    return some36(state.value);
  }
};
var fromIterable26 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var reverse8 = (self2) => Array.from(self2).reverse();
var reduce10 = /* @__PURE__ */ dual8(3, (self2, b52, f52) => fromIterable26(self2).reduce((b232, a52, i52) => f52(b232, a52, i52), b52));
var TagTypeId6 = /* @__PURE__ */ Symbol.for("effect/Context/Tag");
var STMSymbolKey6 = "effect/STM";
var STMTypeId6 = /* @__PURE__ */ Symbol.for(STMSymbolKey6);
var TagProto6 = {
  ...EffectPrototype8,
  _tag: "Tag",
  _op: "Tag",
  [STMTypeId6]: effectVariance8,
  [TagTypeId6]: {
    _Service: (_52) => _52,
    _Identifier: (_52) => _52
  },
  toString() {
    return format8(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Tag",
      key: this.key,
      stack: this.stack
    };
  },
  [NodeInspectSymbol8]() {
    return this.toJSON();
  },
  of(self2) {
    return self2;
  },
  context(self2) {
    return make36(this, self2);
  }
};
var makeGenericTag6 = (key) => {
  const limit = Error.stackTraceLimit;
  Error.stackTraceLimit = 2;
  const creationError = new Error();
  Error.stackTraceLimit = limit;
  const tag = Object.create(TagProto6);
  Object.defineProperty(tag, "stack", {
    get() {
      return creationError.stack;
    }
  });
  tag.key = key;
  return tag;
};
var TypeId46 = /* @__PURE__ */ Symbol.for("effect/Context");
var ContextProto6 = {
  [TypeId46]: {
    _Services: (_52) => _52
  },
  [symbol26](that) {
    if (isContext6(that)) {
      if (this.unsafeMap.size === that.unsafeMap.size) {
        for (const k52 of this.unsafeMap.keys()) {
          if (!that.unsafeMap.has(k52) || !equals8(this.unsafeMap.get(k52), that.unsafeMap.get(k52))) {
            return false;
          }
        }
        return true;
      }
    }
    return false;
  },
  [symbol12]() {
    return cached8(this, number9(this.unsafeMap.size));
  },
  pipe() {
    return pipeArguments8(this, arguments);
  },
  toString() {
    return format8(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Context",
      services: Array.from(this.unsafeMap).map(toJSON8)
    };
  },
  [NodeInspectSymbol8]() {
    return this.toJSON();
  }
};
var makeContext6 = (unsafeMap) => {
  const context = Object.create(ContextProto6);
  context.unsafeMap = unsafeMap;
  return context;
};
var isContext6 = (u52) => hasProperty8(u52, TypeId46);
var _empty10 = /* @__PURE__ */ makeContext6(/* @__PURE__ */ new Map());
var empty16 = () => _empty10;
var make36 = (tag, service) => makeContext6(/* @__PURE__ */ new Map([[tag.key, service]]));
var GenericTag6 = makeGenericTag6;
var empty26 = empty16;
var TypeId56 = /* @__PURE__ */ Symbol.for("effect/Chunk");
function copy7(src, srcPos, dest, destPos, len) {
  for (let i52 = srcPos; i52 < Math.min(src.length, srcPos + len); i52++) {
    dest[destPos + i52 - srcPos] = src[i52];
  }
  return dest;
}
var emptyArray6 = [];
var getEquivalence26 = (isEquivalent) => make26((self2, that) => self2.length === that.length && toReadonlyArray6(self2).every((value, i52) => isEquivalent(value, unsafeGet26(that, i52))));
var _equivalence26 = /* @__PURE__ */ getEquivalence26(equals8);
var ChunkProto6 = {
  [TypeId56]: {
    _A: (_52) => _52
  },
  toString() {
    return format8(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Chunk",
      values: toReadonlyArray6(this).map(toJSON8)
    };
  },
  [NodeInspectSymbol8]() {
    return this.toJSON();
  },
  [symbol26](that) {
    return isChunk6(that) && _equivalence26(this, that);
  },
  [symbol12]() {
    return cached8(this, array10(toReadonlyArray6(this)));
  },
  [Symbol.iterator]() {
    switch (this.backing._tag) {
      case "IArray": {
        return this.backing.array[Symbol.iterator]();
      }
      case "IEmpty": {
        return emptyArray6[Symbol.iterator]();
      }
      default: {
        return toReadonlyArray6(this)[Symbol.iterator]();
      }
    }
  },
  pipe() {
    return pipeArguments8(this, arguments);
  }
};
var makeChunk6 = (backing) => {
  const chunk = Object.create(ChunkProto6);
  chunk.backing = backing;
  switch (backing._tag) {
    case "IEmpty": {
      chunk.length = 0;
      chunk.depth = 0;
      chunk.left = chunk;
      chunk.right = chunk;
      break;
    }
    case "IConcat": {
      chunk.length = backing.left.length + backing.right.length;
      chunk.depth = 1 + Math.max(backing.left.depth, backing.right.depth);
      chunk.left = backing.left;
      chunk.right = backing.right;
      break;
    }
    case "IArray": {
      chunk.length = backing.array.length;
      chunk.depth = 0;
      chunk.left = _empty26;
      chunk.right = _empty26;
      break;
    }
    case "ISingleton": {
      chunk.length = 1;
      chunk.depth = 0;
      chunk.left = _empty26;
      chunk.right = _empty26;
      break;
    }
    case "ISlice": {
      chunk.length = backing.length;
      chunk.depth = backing.chunk.depth + 1;
      chunk.left = _empty26;
      chunk.right = _empty26;
      break;
    }
  }
  return chunk;
};
var isChunk6 = (u52) => hasProperty8(u52, TypeId56);
var _empty26 = /* @__PURE__ */ makeChunk6({
  _tag: "IEmpty"
});
var empty36 = () => _empty26;
var make46 = (...as262) => as262.length === 1 ? of7(as262[0]) : unsafeFromNonEmptyArray6(as262);
var of7 = (a52) => makeChunk6({
  _tag: "ISingleton",
  a: a52
});
var copyToArray6 = (self2, array342, initial) => {
  switch (self2.backing._tag) {
    case "IArray": {
      copy7(self2.backing.array, 0, array342, initial, self2.length);
      break;
    }
    case "IConcat": {
      copyToArray6(self2.left, array342, initial);
      copyToArray6(self2.right, array342, initial + self2.left.length);
      break;
    }
    case "ISingleton": {
      array342[initial] = self2.backing.a;
      break;
    }
    case "ISlice": {
      let i52 = 0;
      let j52 = initial;
      while (i52 < self2.length) {
        array342[j52] = unsafeGet26(self2, i52);
        i52 += 1;
        j52 += 1;
      }
      break;
    }
  }
};
var toReadonlyArray6 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      return emptyArray6;
    }
    case "IArray": {
      return self2.backing.array;
    }
    default: {
      const arr = new Array(self2.length);
      copyToArray6(self2, arr, 0);
      self2.backing = {
        _tag: "IArray",
        array: arr
      };
      self2.left = _empty26;
      self2.right = _empty26;
      self2.depth = 0;
      return arr;
    }
  }
};
var reverse26 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty":
    case "ISingleton":
      return self2;
    case "IArray": {
      return makeChunk6({
        _tag: "IArray",
        array: reverse8(self2.backing.array)
      });
    }
    case "IConcat": {
      return makeChunk6({
        _tag: "IConcat",
        left: reverse26(self2.backing.right),
        right: reverse26(self2.backing.left)
      });
    }
    case "ISlice":
      return unsafeFromArray6(reverse8(toReadonlyArray6(self2)));
  }
};
var unsafeFromArray6 = (self2) => makeChunk6({
  _tag: "IArray",
  array: self2
});
var unsafeFromNonEmptyArray6 = (self2) => unsafeFromArray6(self2);
var unsafeGet26 = /* @__PURE__ */ dual8(2, (self2, index) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      throw new Error(`Index out of bounds`);
    }
    case "ISingleton": {
      if (index !== 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.a;
    }
    case "IArray": {
      if (index >= self2.length || index < 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.array[index];
    }
    case "IConcat": {
      return index < self2.left.length ? unsafeGet26(self2.left, index) : unsafeGet26(self2.right, index - self2.left.length);
    }
    case "ISlice": {
      return unsafeGet26(self2.backing.chunk, index + self2.backing.offset);
    }
  }
});
var prepend8 = /* @__PURE__ */ dual8(2, (self2, elem) => appendAll7(of7(elem), self2));
var drop7 = /* @__PURE__ */ dual8(2, (self2, n52) => {
  if (n52 <= 0) {
    return self2;
  } else if (n52 >= self2.length) {
    return _empty26;
  } else {
    switch (self2.backing._tag) {
      case "ISlice": {
        return makeChunk6({
          _tag: "ISlice",
          chunk: self2.backing.chunk,
          offset: self2.backing.offset + n52,
          length: self2.backing.length - n52
        });
      }
      case "IConcat": {
        if (n52 > self2.left.length) {
          return drop7(self2.right, n52 - self2.left.length);
        }
        return makeChunk6({
          _tag: "IConcat",
          left: drop7(self2.left, n52),
          right: self2.right
        });
      }
      default: {
        return makeChunk6({
          _tag: "ISlice",
          chunk: self2,
          offset: n52,
          length: self2.length - n52
        });
      }
    }
  }
});
var appendAll7 = /* @__PURE__ */ dual8(2, (self2, that) => {
  if (self2.backing._tag === "IEmpty") {
    return that;
  }
  if (that.backing._tag === "IEmpty") {
    return self2;
  }
  const diff242 = that.depth - self2.depth;
  if (Math.abs(diff242) <= 1) {
    return makeChunk6({
      _tag: "IConcat",
      left: self2,
      right: that
    });
  } else if (diff242 < -1) {
    if (self2.left.depth >= self2.right.depth) {
      const nr = appendAll7(self2.right, that);
      return makeChunk6({
        _tag: "IConcat",
        left: self2.left,
        right: nr
      });
    } else {
      const nrr = appendAll7(self2.right.right, that);
      if (nrr.depth === self2.depth - 3) {
        const nr = makeChunk6({
          _tag: "IConcat",
          left: self2.right.left,
          right: nrr
        });
        return makeChunk6({
          _tag: "IConcat",
          left: self2.left,
          right: nr
        });
      } else {
        const nl = makeChunk6({
          _tag: "IConcat",
          left: self2.left,
          right: self2.right.left
        });
        return makeChunk6({
          _tag: "IConcat",
          left: nl,
          right: nrr
        });
      }
    }
  } else {
    if (that.right.depth >= that.left.depth) {
      const nl = appendAll7(self2, that.left);
      return makeChunk6({
        _tag: "IConcat",
        left: nl,
        right: that.right
      });
    } else {
      const nll = appendAll7(self2, that.left.left);
      if (nll.depth === that.depth - 3) {
        const nl = makeChunk6({
          _tag: "IConcat",
          left: nll,
          right: that.left.right
        });
        return makeChunk6({
          _tag: "IConcat",
          left: nl,
          right: that.right
        });
      } else {
        const nr = makeChunk6({
          _tag: "IConcat",
          left: that.left.right,
          right: that.right
        });
        return makeChunk6({
          _tag: "IConcat",
          left: nll,
          right: nr
        });
      }
    }
  }
});
var isEmpty7 = (self2) => self2.length === 0;
var isNonEmpty6 = (self2) => self2.length > 0;
var unsafeHead6 = (self2) => unsafeGet26(self2, 0);
var headNonEmpty7 = unsafeHead6;
var tailNonEmpty7 = (self2) => drop7(self2, 1);
var SIZE6 = 5;
var BUCKET_SIZE6 = /* @__PURE__ */ Math.pow(2, SIZE6);
var MASK6 = BUCKET_SIZE6 - 1;
var MAX_INDEX_NODE6 = BUCKET_SIZE6 / 2;
var MIN_ARRAY_NODE6 = BUCKET_SIZE6 / 4;
function popcount6(x52) {
  x52 -= x52 >> 1 & 1431655765;
  x52 = (x52 & 858993459) + (x52 >> 2 & 858993459);
  x52 = x52 + (x52 >> 4) & 252645135;
  x52 += x52 >> 8;
  x52 += x52 >> 16;
  return x52 & 127;
}
function hashFragment6(shift22, h52) {
  return h52 >>> shift22 & MASK6;
}
function toBitmap6(x52) {
  return 1 << x52;
}
function fromBitmap6(bitmap, bit) {
  return popcount6(bitmap & bit - 1);
}
var make56 = (value, previous) => ({
  value,
  previous
});
function arrayUpdate6(mutate242, at, v52, arr) {
  let out = arr;
  if (!mutate242) {
    const len = arr.length;
    out = new Array(len);
    for (let i52 = 0; i52 < len; ++i52) out[i52] = arr[i52];
  }
  out[at] = v52;
  return out;
}
function arraySpliceOut6(mutate242, at, arr) {
  const newLen = arr.length - 1;
  let i52 = 0;
  let g52 = 0;
  let out = arr;
  if (mutate242) {
    i52 = g52 = at;
  } else {
    out = new Array(newLen);
    while (i52 < at) out[g52++] = arr[i52++];
  }
  ++i52;
  while (i52 <= newLen) out[g52++] = arr[i52++];
  if (mutate242) {
    out.length = newLen;
  }
  return out;
}
function arraySpliceIn6(mutate242, at, v52, arr) {
  const len = arr.length;
  if (mutate242) {
    let i232 = len;
    while (i232 >= at) arr[i232--] = arr[i232];
    arr[at] = v52;
    return arr;
  }
  let i52 = 0, g52 = 0;
  const out = new Array(len + 1);
  while (i52 < at) out[g52++] = arr[i52++];
  out[at] = v52;
  while (i52 < len) out[++g52] = arr[i52++];
  return out;
}
var EmptyNode6 = class _EmptyNode6 {
  _tag = "EmptyNode";
  modify(edit, _shift, f52, hash262, key, size442) {
    const v52 = f52(none26());
    if (isNone26(v52)) return new _EmptyNode6();
    ++size442.value;
    return new LeafNode6(edit, hash262, key, v52);
  }
};
function isEmptyNode6(a52) {
  return isTagged8(a52, "EmptyNode");
}
function isLeafNode6(node) {
  return isEmptyNode6(node) || node._tag === "LeafNode" || node._tag === "CollisionNode";
}
function canEditNode6(node, edit) {
  return isEmptyNode6(node) ? false : edit === node.edit;
}
var LeafNode6 = class _LeafNode6 {
  edit;
  hash;
  key;
  value;
  _tag = "LeafNode";
  constructor(edit, hash262, key, value) {
    this.edit = edit;
    this.hash = hash262;
    this.key = key;
    this.value = value;
  }
  modify(edit, shift22, f52, hash262, key, size442) {
    if (equals8(key, this.key)) {
      const v232 = f52(this.value);
      if (v232 === this.value) return this;
      else if (isNone26(v232)) {
        --size442.value;
        return new EmptyNode6();
      }
      if (canEditNode6(this, edit)) {
        this.value = v232;
        return this;
      }
      return new _LeafNode6(edit, hash262, key, v232);
    }
    const v52 = f52(none26());
    if (isNone26(v52)) return this;
    ++size442.value;
    return mergeLeaves6(edit, shift22, this.hash, this, hash262, new _LeafNode6(edit, hash262, key, v52));
  }
};
var CollisionNode6 = class _CollisionNode6 {
  edit;
  hash;
  children;
  _tag = "CollisionNode";
  constructor(edit, hash262, children) {
    this.edit = edit;
    this.hash = hash262;
    this.children = children;
  }
  modify(edit, shift22, f52, hash262, key, size442) {
    if (hash262 === this.hash) {
      const canEdit = canEditNode6(this, edit);
      const list = this.updateCollisionList(canEdit, edit, this.hash, this.children, f52, key, size442);
      if (list === this.children) return this;
      return list.length > 1 ? new _CollisionNode6(edit, this.hash, list) : list[0];
    }
    const v52 = f52(none26());
    if (isNone26(v52)) return this;
    ++size442.value;
    return mergeLeaves6(edit, shift22, this.hash, this, hash262, new LeafNode6(edit, hash262, key, v52));
  }
  updateCollisionList(mutate242, edit, hash262, list, f52, key, size442) {
    const len = list.length;
    for (let i52 = 0; i52 < len; ++i52) {
      const child = list[i52];
      if ("key" in child && equals8(key, child.key)) {
        const value = child.value;
        const newValue2 = f52(value);
        if (newValue2 === value) return list;
        if (isNone26(newValue2)) {
          --size442.value;
          return arraySpliceOut6(mutate242, i52, list);
        }
        return arrayUpdate6(mutate242, i52, new LeafNode6(edit, hash262, key, newValue2), list);
      }
    }
    const newValue = f52(none26());
    if (isNone26(newValue)) return list;
    ++size442.value;
    return arrayUpdate6(mutate242, len, new LeafNode6(edit, hash262, key, newValue), list);
  }
};
var IndexedNode6 = class _IndexedNode6 {
  edit;
  mask;
  children;
  _tag = "IndexedNode";
  constructor(edit, mask, children) {
    this.edit = edit;
    this.mask = mask;
    this.children = children;
  }
  modify(edit, shift22, f52, hash262, key, size442) {
    const mask = this.mask;
    const children = this.children;
    const frag = hashFragment6(shift22, hash262);
    const bit = toBitmap6(frag);
    const indx = fromBitmap6(mask, bit);
    const exists262 = mask & bit;
    const canEdit = canEditNode6(this, edit);
    if (!exists262) {
      const _newChild = new EmptyNode6().modify(edit, shift22 + SIZE6, f52, hash262, key, size442);
      if (!_newChild) return this;
      return children.length >= MAX_INDEX_NODE6 ? expand6(edit, frag, _newChild, mask, children) : new _IndexedNode6(edit, mask | bit, arraySpliceIn6(canEdit, indx, _newChild, children));
    }
    const current = children[indx];
    const child = current.modify(edit, shift22 + SIZE6, f52, hash262, key, size442);
    if (current === child) return this;
    let bitmap = mask;
    let newChildren;
    if (isEmptyNode6(child)) {
      bitmap &= ~bit;
      if (!bitmap) return new EmptyNode6();
      if (children.length <= 2 && isLeafNode6(children[indx ^ 1])) {
        return children[indx ^ 1];
      }
      newChildren = arraySpliceOut6(canEdit, indx, children);
    } else {
      newChildren = arrayUpdate6(canEdit, indx, child, children);
    }
    if (canEdit) {
      this.mask = bitmap;
      this.children = newChildren;
      return this;
    }
    return new _IndexedNode6(edit, bitmap, newChildren);
  }
};
var ArrayNode6 = class _ArrayNode6 {
  edit;
  size;
  children;
  _tag = "ArrayNode";
  constructor(edit, size442, children) {
    this.edit = edit;
    this.size = size442;
    this.children = children;
  }
  modify(edit, shift22, f52, hash262, key, size442) {
    let count = this.size;
    const children = this.children;
    const frag = hashFragment6(shift22, hash262);
    const child = children[frag];
    const newChild = (child || new EmptyNode6()).modify(edit, shift22 + SIZE6, f52, hash262, key, size442);
    if (child === newChild) return this;
    const canEdit = canEditNode6(this, edit);
    let newChildren;
    if (isEmptyNode6(child) && !isEmptyNode6(newChild)) {
      ++count;
      newChildren = arrayUpdate6(canEdit, frag, newChild, children);
    } else if (!isEmptyNode6(child) && isEmptyNode6(newChild)) {
      --count;
      if (count <= MIN_ARRAY_NODE6) {
        return pack6(edit, count, frag, children);
      }
      newChildren = arrayUpdate6(canEdit, frag, new EmptyNode6(), children);
    } else {
      newChildren = arrayUpdate6(canEdit, frag, newChild, children);
    }
    if (canEdit) {
      this.size = count;
      this.children = newChildren;
      return this;
    }
    return new _ArrayNode6(edit, count, newChildren);
  }
};
function pack6(edit, count, removed, elements) {
  const children = new Array(count - 1);
  let g52 = 0;
  let bitmap = 0;
  for (let i52 = 0, len = elements.length; i52 < len; ++i52) {
    if (i52 !== removed) {
      const elem = elements[i52];
      if (elem && !isEmptyNode6(elem)) {
        children[g52++] = elem;
        bitmap |= 1 << i52;
      }
    }
  }
  return new IndexedNode6(edit, bitmap, children);
}
function expand6(edit, frag, child, bitmap, subNodes) {
  const arr = [];
  let bit = bitmap;
  let count = 0;
  for (let i52 = 0; bit; ++i52) {
    if (bit & 1) arr[i52] = subNodes[count++];
    bit >>>= 1;
  }
  arr[frag] = child;
  return new ArrayNode6(edit, count + 1, arr);
}
function mergeLeavesInner6(edit, shift22, h1, n1, h232, n232) {
  if (h1 === h232) return new CollisionNode6(edit, h1, [n232, n1]);
  const subH1 = hashFragment6(shift22, h1);
  const subH2 = hashFragment6(shift22, h232);
  if (subH1 === subH2) {
    return (child) => new IndexedNode6(edit, toBitmap6(subH1) | toBitmap6(subH2), [child]);
  } else {
    const children = subH1 < subH2 ? [n1, n232] : [n232, n1];
    return new IndexedNode6(edit, toBitmap6(subH1) | toBitmap6(subH2), children);
  }
}
function mergeLeaves6(edit, shift22, h1, n1, h232, n232) {
  let stack = void 0;
  let currentShift = shift22;
  while (true) {
    const res = mergeLeavesInner6(edit, currentShift, h1, n1, h232, n232);
    if (typeof res === "function") {
      stack = make56(res, stack);
      currentShift = currentShift + SIZE6;
    } else {
      let final = res;
      while (stack != null) {
        final = stack.value(final);
        stack = stack.previous;
      }
      return final;
    }
  }
}
var HashMapSymbolKey6 = "effect/HashMap";
var HashMapTypeId6 = /* @__PURE__ */ Symbol.for(HashMapSymbolKey6);
var HashMapProto6 = {
  [HashMapTypeId6]: HashMapTypeId6,
  [Symbol.iterator]() {
    return new HashMapIterator6(this, (k52, v52) => [k52, v52]);
  },
  [symbol12]() {
    let hash262 = hash8(HashMapSymbolKey6);
    for (const item of this) {
      hash262 ^= pipe8(hash8(item[0]), combine9(hash8(item[1])));
    }
    return cached8(this, hash262);
  },
  [symbol26](that) {
    if (isHashMap6(that)) {
      if (that._size !== this._size) {
        return false;
      }
      for (const item of this) {
        const elem = pipe8(that, getHash6(item[0], hash8(item[0])));
        if (isNone26(elem)) {
          return false;
        } else {
          if (!equals8(item[1], elem.value)) {
            return false;
          }
        }
      }
      return true;
    }
    return false;
  },
  toString() {
    return format8(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashMap",
      values: Array.from(this).map(toJSON8)
    };
  },
  [NodeInspectSymbol8]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments8(this, arguments);
  }
};
var makeImpl7 = (editable, edit, root, size442) => {
  const map622 = Object.create(HashMapProto6);
  map622._editable = editable;
  map622._edit = edit;
  map622._root = root;
  map622._size = size442;
  return map622;
};
var HashMapIterator6 = class _HashMapIterator6 {
  map;
  f;
  v;
  constructor(map622, f52) {
    this.map = map622;
    this.f = f52;
    this.v = visitLazy6(this.map._root, this.f, void 0);
  }
  next() {
    if (isNone26(this.v)) {
      return {
        done: true,
        value: void 0
      };
    }
    const v0 = this.v.value;
    this.v = applyCont6(v0.cont);
    return {
      done: false,
      value: v0.value
    };
  }
  [Symbol.iterator]() {
    return new _HashMapIterator6(this.map, this.f);
  }
};
var applyCont6 = (cont) => cont ? visitLazyChildren6(cont[0], cont[1], cont[2], cont[3], cont[4]) : none26();
var visitLazy6 = (node, f52, cont = void 0) => {
  switch (node._tag) {
    case "LeafNode": {
      if (isSome26(node.value)) {
        return some36({
          value: f52(node.key, node.value.value),
          cont
        });
      }
      return applyCont6(cont);
    }
    case "CollisionNode":
    case "ArrayNode":
    case "IndexedNode": {
      const children = node.children;
      return visitLazyChildren6(children.length, children, 0, f52, cont);
    }
    default: {
      return applyCont6(cont);
    }
  }
};
var visitLazyChildren6 = (len, children, i52, f52, cont) => {
  while (i52 < len) {
    const child = children[i52++];
    if (child && !isEmptyNode6(child)) {
      return visitLazy6(child, f52, [len, children, i52, f52, cont]);
    }
  }
  return applyCont6(cont);
};
var _empty36 = /* @__PURE__ */ makeImpl7(false, 0, /* @__PURE__ */ new EmptyNode6(), 0);
var empty46 = () => _empty36;
var isHashMap6 = (u52) => hasProperty8(u52, HashMapTypeId6);
var getHash6 = /* @__PURE__ */ dual8(3, (self2, key, hash262) => {
  let node = self2._root;
  let shift22 = 0;
  while (true) {
    switch (node._tag) {
      case "LeafNode": {
        return equals8(key, node.key) ? node.value : none26();
      }
      case "CollisionNode": {
        if (hash262 === node.hash) {
          const children = node.children;
          for (let i52 = 0, len = children.length; i52 < len; ++i52) {
            const child = children[i52];
            if ("key" in child && equals8(key, child.key)) {
              return child.value;
            }
          }
        }
        return none26();
      }
      case "IndexedNode": {
        const frag = hashFragment6(shift22, hash262);
        const bit = toBitmap6(frag);
        if (node.mask & bit) {
          node = node.children[fromBitmap6(node.mask, bit)];
          shift22 += SIZE6;
          break;
        }
        return none26();
      }
      case "ArrayNode": {
        node = node.children[hashFragment6(shift22, hash262)];
        if (node) {
          shift22 += SIZE6;
          break;
        }
        return none26();
      }
      default:
        return none26();
    }
  }
});
var set8 = /* @__PURE__ */ dual8(3, (self2, key, value) => modifyAt6(self2, key, () => some36(value)));
var setTree6 = /* @__PURE__ */ dual8(3, (self2, newRoot, newSize) => {
  if (self2._editable) {
    self2._root = newRoot;
    self2._size = newSize;
    return self2;
  }
  return newRoot === self2._root ? self2 : makeImpl7(self2._editable, self2._edit, newRoot, newSize);
});
var keys8 = (self2) => new HashMapIterator6(self2, (key) => key);
var size9 = (self2) => self2._size;
var beginMutation7 = (self2) => makeImpl7(true, self2._edit + 1, self2._root, self2._size);
var modifyAt6 = /* @__PURE__ */ dual8(3, (self2, key, f52) => modifyHash6(self2, key, hash8(key), f52));
var modifyHash6 = /* @__PURE__ */ dual8(4, (self2, key, hash262, f52) => {
  const size442 = {
    value: self2._size
  };
  const newRoot = self2._root.modify(self2._editable ? self2._edit : NaN, 0, f52, hash262, key, size442);
  return pipe8(self2, setTree6(newRoot, size442.value));
});
var forEach9 = /* @__PURE__ */ dual8(2, (self2, f52) => reduce26(self2, void 0, (_52, value, key) => f52(value, key)));
var reduce26 = /* @__PURE__ */ dual8(3, (self2, zero, f52) => {
  const root = self2._root;
  if (root._tag === "LeafNode") {
    return isSome26(root.value) ? f52(zero, root.value.value, root.key) : zero;
  }
  if (root._tag === "EmptyNode") {
    return zero;
  }
  const toVisit = [root.children];
  let children;
  while (children = toVisit.pop()) {
    for (let i52 = 0, len = children.length; i52 < len; ) {
      const child = children[i52++];
      if (child && !isEmptyNode6(child)) {
        if (child._tag === "LeafNode") {
          if (isSome26(child.value)) {
            zero = f52(zero, child.value.value, child.key);
          }
        } else {
          toVisit.push(child.children);
        }
      }
    }
  }
  return zero;
});
var HashSetSymbolKey6 = "effect/HashSet";
var HashSetTypeId6 = /* @__PURE__ */ Symbol.for(HashSetSymbolKey6);
var HashSetProto6 = {
  [HashSetTypeId6]: HashSetTypeId6,
  [Symbol.iterator]() {
    return keys8(this._keyMap);
  },
  [symbol12]() {
    return cached8(this, combine9(hash8(this._keyMap))(hash8(HashSetSymbolKey6)));
  },
  [symbol26](that) {
    if (isHashSet6(that)) {
      return size9(this._keyMap) === size9(that._keyMap) && equals8(this._keyMap, that._keyMap);
    }
    return false;
  },
  toString() {
    return format8(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashSet",
      values: Array.from(this).map(toJSON8)
    };
  },
  [NodeInspectSymbol8]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments8(this, arguments);
  }
};
var makeImpl26 = (keyMap) => {
  const set262 = Object.create(HashSetProto6);
  set262._keyMap = keyMap;
  return set262;
};
var isHashSet6 = (u52) => hasProperty8(u52, HashSetTypeId6);
var _empty46 = /* @__PURE__ */ makeImpl26(/* @__PURE__ */ empty46());
var empty56 = () => _empty46;
var size26 = (self2) => size9(self2._keyMap);
var beginMutation26 = (self2) => makeImpl26(beginMutation7(self2._keyMap));
var endMutation6 = (self2) => {
  self2._keyMap._editable = false;
  return self2;
};
var mutate6 = /* @__PURE__ */ dual8(2, (self2, f52) => {
  const transient = beginMutation26(self2);
  f52(transient);
  return endMutation6(transient);
});
var add26 = /* @__PURE__ */ dual8(2, (self2, value) => self2._keyMap._editable ? (set8(value, true)(self2._keyMap), self2) : makeImpl26(set8(value, true)(self2._keyMap)));
var union26 = /* @__PURE__ */ dual8(2, (self2, that) => mutate6(empty56(), (set262) => {
  forEach26(self2, (value) => add26(set262, value));
  for (const value of that) {
    add26(set262, value);
  }
}));
var forEach26 = /* @__PURE__ */ dual8(2, (self2, f52) => forEach9(self2._keyMap, (_52, k52) => f52(k52)));
var empty66 = empty56;
var size36 = size26;
var add36 = add26;
var union36 = union26;
var ArrayProto6 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(Array.prototype), {
  [symbol12]() {
    return cached8(this, array10(this));
  },
  [symbol26](that) {
    if (Array.isArray(that) && this.length === that.length) {
      return this.every((v52, i52) => equals8(v52, that[i52]));
    } else {
      return false;
    }
  }
});
var Structural7 = /* @__PURE__ */ function() {
  function Structural342(args) {
    if (args) {
      Object.assign(this, args);
    }
  }
  Structural342.prototype = StructuralPrototype4;
  return Structural342;
}();
var struct26 = (as262) => Object.assign(Object.create(StructuralPrototype4), as262);
var ContextPatchTypeId6 = /* @__PURE__ */ Symbol.for("effect/DifferContextPatch");
function variance7(a52) {
  return a52;
}
var PatchProto6 = {
  ...Structural7.prototype,
  [ContextPatchTypeId6]: {
    _Value: variance7,
    _Patch: variance7
  }
};
var EmptyProto6 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto6), {
  _tag: "Empty"
});
var _empty56 = /* @__PURE__ */ Object.create(EmptyProto6);
var empty76 = () => _empty56;
var AndThenProto6 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto6), {
  _tag: "AndThen"
});
var makeAndThen6 = (first, second) => {
  const o52 = Object.create(AndThenProto6);
  o52.first = first;
  o52.second = second;
  return o52;
};
var AddServiceProto6 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto6), {
  _tag: "AddService"
});
var makeAddService6 = (key, service) => {
  const o52 = Object.create(AddServiceProto6);
  o52.key = key;
  o52.service = service;
  return o52;
};
var RemoveServiceProto6 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto6), {
  _tag: "RemoveService"
});
var makeRemoveService6 = (key) => {
  const o52 = Object.create(RemoveServiceProto6);
  o52.key = key;
  return o52;
};
var UpdateServiceProto6 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto6), {
  _tag: "UpdateService"
});
var makeUpdateService6 = (key, update222) => {
  const o52 = Object.create(UpdateServiceProto6);
  o52.key = key;
  o52.update = update222;
  return o52;
};
var diff6 = (oldValue, newValue) => {
  const missingServices = new Map(oldValue.unsafeMap);
  let patch242 = empty76();
  for (const [tag, newService] of newValue.unsafeMap.entries()) {
    if (missingServices.has(tag)) {
      const old = missingServices.get(tag);
      missingServices.delete(tag);
      if (!equals8(old, newService)) {
        patch242 = combine26(makeUpdateService6(tag, () => newService))(patch242);
      }
    } else {
      missingServices.delete(tag);
      patch242 = combine26(makeAddService6(tag, newService))(patch242);
    }
  }
  for (const [tag] of missingServices.entries()) {
    patch242 = combine26(makeRemoveService6(tag))(patch242);
  }
  return patch242;
};
var combine26 = /* @__PURE__ */ dual8(2, (self2, that) => makeAndThen6(self2, that));
var patch6 = /* @__PURE__ */ dual8(2, (self2, context) => {
  if (self2._tag === "Empty") {
    return context;
  }
  let wasServiceUpdated = false;
  let patches = of7(self2);
  const updatedContext = new Map(context.unsafeMap);
  while (isNonEmpty6(patches)) {
    const head222 = headNonEmpty7(patches);
    const tail42 = tailNonEmpty7(patches);
    switch (head222._tag) {
      case "Empty": {
        patches = tail42;
        break;
      }
      case "AddService": {
        updatedContext.set(head222.key, head222.service);
        patches = tail42;
        break;
      }
      case "AndThen": {
        patches = prepend8(prepend8(tail42, head222.second), head222.first);
        break;
      }
      case "RemoveService": {
        updatedContext.delete(head222.key);
        patches = tail42;
        break;
      }
      case "UpdateService": {
        updatedContext.set(head222.key, head222.update(updatedContext.get(head222.key)));
        wasServiceUpdated = true;
        patches = tail42;
        break;
      }
    }
  }
  if (!wasServiceUpdated) {
    return makeContext6(updatedContext);
  }
  const map622 = /* @__PURE__ */ new Map();
  for (const [tag] of context.unsafeMap) {
    if (updatedContext.has(tag)) {
      map622.set(tag, updatedContext.get(tag));
      updatedContext.delete(tag);
    }
  }
  for (const [tag, s52] of updatedContext) {
    map622.set(tag, s52);
  }
  return makeContext6(map622);
});
var DifferTypeId6 = /* @__PURE__ */ Symbol.for("effect/Differ");
var DifferProto6 = {
  [DifferTypeId6]: {
    _P: identity8,
    _V: identity8
  }
};
var make76 = (params) => {
  const differ = Object.create(DifferProto6);
  differ.empty = params.empty;
  differ.diff = params.diff;
  differ.combine = params.combine;
  differ.patch = params.patch;
  return differ;
};
var environment6 = () => make76({
  empty: empty76(),
  combine: (first, second) => combine26(second)(first),
  diff: (oldValue, newValue) => diff6(oldValue, newValue),
  patch: (patch242, oldValue) => patch6(oldValue)(patch242)
});
var OP_DIE6 = "Die";
var OP_EMPTY6 = "Empty";
var OP_FAIL6 = "Fail";
var OP_INTERRUPT6 = "Interrupt";
var OP_PARALLEL6 = "Parallel";
var OP_SEQUENTIAL6 = "Sequential";
var CauseSymbolKey6 = "effect/Cause";
var CauseTypeId6 = /* @__PURE__ */ Symbol.for(CauseSymbolKey6);
var variance26 = {
  /* c8 ignore next */
  _E: (_52) => _52
};
var proto6 = {
  [CauseTypeId6]: variance26,
  [symbol12]() {
    return pipe8(hash8(CauseSymbolKey6), combine9(hash8(flattenCause6(this))), cached8(this));
  },
  [symbol26](that) {
    return isCause6(that) && causeEquals6(this, that);
  },
  pipe() {
    return pipeArguments8(this, arguments);
  },
  toJSON() {
    switch (this._tag) {
      case "Empty":
        return {
          _id: "Cause",
          _tag: this._tag
        };
      case "Die":
        return {
          _id: "Cause",
          _tag: this._tag,
          defect: toJSON8(this.defect)
        };
      case "Interrupt":
        return {
          _id: "Cause",
          _tag: this._tag,
          fiberId: this.fiberId.toJSON()
        };
      case "Fail":
        return {
          _id: "Cause",
          _tag: this._tag,
          failure: toJSON8(this.error)
        };
      case "Sequential":
      case "Parallel":
        return {
          _id: "Cause",
          _tag: this._tag,
          left: toJSON8(this.left),
          right: toJSON8(this.right)
        };
    }
  },
  toString() {
    return pretty6(this);
  },
  [NodeInspectSymbol8]() {
    return this.toJSON();
  }
};
var fail7 = (error) => {
  const o52 = Object.create(proto6);
  o52._tag = OP_FAIL6;
  o52.error = error;
  return o52;
};
var parallel6 = (left342, right342) => {
  const o52 = Object.create(proto6);
  o52._tag = OP_PARALLEL6;
  o52.left = left342;
  o52.right = right342;
  return o52;
};
var sequential6 = (left342, right342) => {
  const o52 = Object.create(proto6);
  o52._tag = OP_SEQUENTIAL6;
  o52.left = left342;
  o52.right = right342;
  return o52;
};
var isCause6 = (u52) => hasProperty8(u52, CauseTypeId6);
var isInterruptedOnly6 = (self2) => reduceWithContext6(void 0, IsInterruptedOnlyCauseReducer6)(self2);
var causeEquals6 = (left342, right342) => {
  let leftStack = of7(left342);
  let rightStack = of7(right342);
  while (isNonEmpty6(leftStack) && isNonEmpty6(rightStack)) {
    const [leftParallel, leftSequential] = pipe8(headNonEmpty7(leftStack), reduce46([empty66(), empty36()], ([parallel242, sequential242], cause) => {
      const [par, seq] = evaluateCause6(cause);
      return some36([pipe8(parallel242, union36(par)), pipe8(sequential242, appendAll7(seq))]);
    }));
    const [rightParallel, rightSequential] = pipe8(headNonEmpty7(rightStack), reduce46([empty66(), empty36()], ([parallel242, sequential242], cause) => {
      const [par, seq] = evaluateCause6(cause);
      return some36([pipe8(parallel242, union36(par)), pipe8(sequential242, appendAll7(seq))]);
    }));
    if (!equals8(leftParallel, rightParallel)) {
      return false;
    }
    leftStack = leftSequential;
    rightStack = rightSequential;
  }
  return true;
};
var flattenCause6 = (cause) => {
  return flattenCauseLoop6(of7(cause), empty36());
};
var flattenCauseLoop6 = (causes, flattened) => {
  while (1) {
    const [parallel242, sequential242] = pipe8(causes, reduce10([empty66(), empty36()], ([parallel322, sequential322], cause) => {
      const [par, seq] = evaluateCause6(cause);
      return [pipe8(parallel322, union36(par)), pipe8(sequential322, appendAll7(seq))];
    }));
    const updated = size36(parallel242) > 0 ? pipe8(flattened, prepend8(parallel242)) : flattened;
    if (isEmpty7(sequential242)) {
      return reverse26(updated);
    }
    causes = sequential242;
    flattened = updated;
  }
  throw new Error(getBugErrorMessage8("Cause.flattenCauseLoop"));
};
var evaluateCause6 = (self2) => {
  let cause = self2;
  const stack = [];
  let _parallel = empty66();
  let _sequential = empty36();
  while (cause !== void 0) {
    switch (cause._tag) {
      case OP_EMPTY6: {
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_FAIL6: {
        _parallel = add36(_parallel, make46(cause._tag, cause.error));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_DIE6: {
        _parallel = add36(_parallel, make46(cause._tag, cause.defect));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_INTERRUPT6: {
        _parallel = add36(_parallel, make46(cause._tag, cause.fiberId));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_SEQUENTIAL6: {
        switch (cause.left._tag) {
          case OP_EMPTY6: {
            cause = cause.right;
            break;
          }
          case OP_SEQUENTIAL6: {
            cause = sequential6(cause.left.left, sequential6(cause.left.right, cause.right));
            break;
          }
          case OP_PARALLEL6: {
            cause = parallel6(sequential6(cause.left.left, cause.right), sequential6(cause.left.right, cause.right));
            break;
          }
          default: {
            _sequential = prepend8(_sequential, cause.right);
            cause = cause.left;
            break;
          }
        }
        break;
      }
      case OP_PARALLEL6: {
        stack.push(cause.right);
        cause = cause.left;
        break;
      }
    }
  }
  throw new Error(getBugErrorMessage8("Cause.evaluateCauseLoop"));
};
var IsInterruptedOnlyCauseReducer6 = {
  emptyCase: constTrue8,
  failCase: constFalse8,
  dieCase: constFalse8,
  interruptCase: constTrue8,
  sequentialCase: (_52, left342, right342) => left342 && right342,
  parallelCase: (_52, left342, right342) => left342 && right342
};
var OP_SEQUENTIAL_CASE6 = "SequentialCase";
var OP_PARALLEL_CASE6 = "ParallelCase";
var reduce46 = /* @__PURE__ */ dual8(3, (self2, zero, pf) => {
  let accumulator = zero;
  let cause = self2;
  const causes = [];
  while (cause !== void 0) {
    const option = pf(accumulator, cause);
    accumulator = isSome26(option) ? option.value : accumulator;
    switch (cause._tag) {
      case OP_SEQUENTIAL6: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      case OP_PARALLEL6: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      default: {
        cause = void 0;
        break;
      }
    }
    if (cause === void 0 && causes.length > 0) {
      cause = causes.pop();
    }
  }
  return accumulator;
});
var reduceWithContext6 = /* @__PURE__ */ dual8(3, (self2, context, reducer) => {
  const input = [self2];
  const output = [];
  while (input.length > 0) {
    const cause = input.pop();
    switch (cause._tag) {
      case OP_EMPTY6: {
        output.push(right26(reducer.emptyCase(context)));
        break;
      }
      case OP_FAIL6: {
        output.push(right26(reducer.failCase(context, cause.error)));
        break;
      }
      case OP_DIE6: {
        output.push(right26(reducer.dieCase(context, cause.defect)));
        break;
      }
      case OP_INTERRUPT6: {
        output.push(right26(reducer.interruptCase(context, cause.fiberId)));
        break;
      }
      case OP_SEQUENTIAL6: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left26({
          _tag: OP_SEQUENTIAL_CASE6
        }));
        break;
      }
      case OP_PARALLEL6: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left26({
          _tag: OP_PARALLEL_CASE6
        }));
        break;
      }
    }
  }
  const accumulator = [];
  while (output.length > 0) {
    const either = output.pop();
    switch (either._tag) {
      case "Left": {
        switch (either.left._tag) {
          case OP_SEQUENTIAL_CASE6: {
            const left342 = accumulator.pop();
            const right342 = accumulator.pop();
            const value = reducer.sequentialCase(context, left342, right342);
            accumulator.push(value);
            break;
          }
          case OP_PARALLEL_CASE6: {
            const left342 = accumulator.pop();
            const right342 = accumulator.pop();
            const value = reducer.parallelCase(context, left342, right342);
            accumulator.push(value);
            break;
          }
        }
        break;
      }
      case "Right": {
        accumulator.push(either.right);
        break;
      }
    }
  }
  if (accumulator.length === 0) {
    throw new Error("BUG: Cause.reduceWithContext - please report an issue at https://github.com/Effect-TS/effect/issues");
  }
  return accumulator.pop();
});
var pretty6 = (cause) => {
  if (isInterruptedOnly6(cause)) {
    return "All fibers interrupted without errors.";
  }
  return prettyErrors6(cause).map((e52) => e52.stack).join("\n");
};
var PrettyError6 = class extends globalThis.Error {
  span = void 0;
  constructor(originalError) {
    const prevLimit = Error.stackTraceLimit;
    Error.stackTraceLimit = 0;
    super(prettyErrorMessage6(originalError));
    Error.stackTraceLimit = prevLimit;
    this.name = originalError instanceof Error ? originalError.name : "Error";
    if (typeof originalError === "object" && originalError !== null) {
      if (spanSymbol7 in originalError) {
        this.span = originalError[spanSymbol7];
      }
      Object.keys(originalError).forEach((key) => {
        if (!(key in this)) {
          this[key] = originalError[key];
        }
      });
    }
    this.stack = prettyErrorStack6(this.message, originalError instanceof Error && originalError.stack ? originalError.stack : "", this.span);
  }
  toJSON() {
    const out = {
      message: this.message,
      stack: this.stack
    };
    if (this.span) {
      out.span = this.span;
    }
    return out;
  }
};
var prettyErrorMessage6 = (u52) => {
  if (typeof u52 === "string") {
    return `Error: ${u52}`;
  }
  try {
    if (hasProperty8(u52, "toString") && isFunction35(u52["toString"]) && u52["toString"] !== Object.prototype.toString && u52["toString"] !== globalThis.Array.prototype.toString) {
      return u52["toString"]();
    }
  } catch {
  }
  return `Error: ${JSON.stringify(u52)}`;
};
var locationRegex6 = /\((.*)\)/;
var spanToTrace6 = /* @__PURE__ */ globalValue8("effect/Tracer/spanToTrace", () => /* @__PURE__ */ new WeakMap());
var prettyErrorStack6 = (message, stack, span32) => {
  const out = [message];
  const lines = stack.split("\n");
  for (let i52 = 1; i52 < lines.length; i52++) {
    if (lines[i52].includes("Generator.next")) {
      break;
    }
    if (lines[i52].includes("effect_internal_function")) {
      out.pop();
      break;
    }
    out.push(lines[i52].replace(/at .*effect_instruction_i.*\((.*)\)/, "at $1").replace(/EffectPrimitive\.\w+/, "<anonymous>"));
  }
  if (span32) {
    let current = span32;
    let i52 = 0;
    while (current && current._tag === "Span" && i52 < 10) {
      const stackFn = spanToTrace6.get(current);
      if (typeof stackFn === "function") {
        const stack2 = stackFn();
        const locationMatch = stack2.match(locationRegex6);
        const location = locationMatch ? locationMatch[1] : stack2.replace(/^at /, "");
        out.push(`    at ${current.name} (${location})`);
      } else {
        out.push(`    at ${current.name}`);
      }
      current = getOrUndefined8(current.parent);
      i52++;
    }
  }
  return out.join("\n");
};
var spanSymbol7 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var prettyErrors6 = (cause) => reduceWithContext6(cause, void 0, {
  emptyCase: () => [],
  dieCase: (_52, unknownError) => {
    return [new PrettyError6(unknownError)];
  },
  failCase: (_52, error) => {
    return [new PrettyError6(error)];
  },
  interruptCase: () => [],
  parallelCase: (_52, l52, r52) => [...l52, ...r52],
  sequentialCase: (_52, l52, r52) => [...l52, ...r52]
});
var SingleShotGen26 = class _SingleShotGen25 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  next(a52) {
    return this.called ? {
      value: a52,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  return(a52) {
    return {
      value: a52,
      done: true
    };
  }
  throw(e52) {
    throw e52;
  }
  [Symbol.iterator]() {
    return new _SingleShotGen25(this.self);
  }
};
var spanTag6 = /* @__PURE__ */ GenericTag6("effect/ParentSpan");
var EffectTypeId26 = /* @__PURE__ */ Symbol.for("effect/Effect");
var EffectPrimitive6 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId26] = effectVariance8;
  constructor(_op) {
    this._op = _op;
  }
  [symbol26](that) {
    return this === that;
  }
  [symbol12]() {
    return cached8(this, random8(this));
  }
  pipe() {
    return pipeArguments8(this, arguments);
  }
  toJSON() {
    return {
      _id: "Effect",
      _op: this._op,
      effect_instruction_i0: toJSON8(this.effect_instruction_i0),
      effect_instruction_i1: toJSON8(this.effect_instruction_i1),
      effect_instruction_i2: toJSON8(this.effect_instruction_i2)
    };
  }
  toString() {
    return format8(this.toJSON());
  }
  [NodeInspectSymbol8]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen26(new YieldWrap8(this));
  }
};
var EffectPrimitiveFailure6 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId26] = effectVariance8;
  constructor(_op) {
    this._op = _op;
    this._tag = _op;
  }
  [symbol26](that) {
    return exitIsExit6(that) && that._op === "Failure" && // @ts-expect-error
    equals8(this.effect_instruction_i0, that.effect_instruction_i0);
  }
  [symbol12]() {
    return pipe8(
      // @ts-expect-error
      string9(this._tag),
      // @ts-expect-error
      combine9(hash8(this.effect_instruction_i0)),
      cached8(this)
    );
  }
  get cause() {
    return this.effect_instruction_i0;
  }
  pipe() {
    return pipeArguments8(this, arguments);
  }
  toJSON() {
    return {
      _id: "Exit",
      _tag: this._op,
      cause: this.cause.toJSON()
    };
  }
  toString() {
    return format8(this.toJSON());
  }
  [NodeInspectSymbol8]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen26(new YieldWrap8(this));
  }
};
var isEffect6 = (u52) => hasProperty8(u52, EffectTypeId26);
var withFiberRuntime6 = (withRuntime) => {
  const effect = new EffectPrimitive6(OP_WITH_RUNTIME6);
  effect.effect_instruction_i0 = withRuntime;
  return effect;
};
var spanSymbol26 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var originalSymbol6 = /* @__PURE__ */ Symbol.for("effect/OriginalAnnotation");
var capture6 = (obj, span32) => {
  if (isSome26(span32)) {
    return new Proxy(obj, {
      has(target, p52) {
        return p52 === spanSymbol26 || p52 === originalSymbol6 || p52 in target;
      },
      get(target, p52) {
        if (p52 === spanSymbol26) {
          return span32.value;
        }
        if (p52 === originalSymbol6) {
          return obj;
        }
        return target[p52];
      }
    });
  }
  return obj;
};
var fail26 = (error) => isObject8(error) && !(spanSymbol26 in error) ? withFiberRuntime6((fiber) => failCause6(fail7(capture6(error, currentSpanFromFiber6(fiber))))) : failCause6(fail7(error));
var failCause6 = (cause) => {
  const effect = new EffectPrimitiveFailure6(OP_FAILURE6);
  effect.effect_instruction_i0 = cause;
  return effect;
};
var FiberRefSymbolKey6 = "effect/FiberRef";
var FiberRefTypeId6 = /* @__PURE__ */ Symbol.for(FiberRefSymbolKey6);
var fiberRefVariance6 = {
  /* c8 ignore next */
  _A: (_52) => _52
};
var fiberRefUnsafeMakeContext6 = (initial) => {
  const differ = environment6();
  return fiberRefUnsafeMakePatch6(initial, {
    differ,
    fork: differ.empty
  });
};
var fiberRefUnsafeMakePatch6 = (initial, options) => ({
  [FiberRefTypeId6]: fiberRefVariance6,
  initial,
  diff: (oldValue, newValue) => options.differ.diff(oldValue, newValue),
  combine: (first, second) => options.differ.combine(first, second),
  patch: (patch242) => (oldValue) => options.differ.patch(patch242, oldValue),
  fork: options.fork,
  join: options.join ?? ((_52, n52) => n52),
  pipe() {
    return pipeArguments8(this, arguments);
  }
});
var currentContext6 = /* @__PURE__ */ globalValue8(/* @__PURE__ */ Symbol.for("effect/FiberRef/currentContext"), () => fiberRefUnsafeMakeContext6(empty26()));
var YieldableError6 = /* @__PURE__ */ function() {
  class YieldableError242 extends globalThis.Error {
    commit() {
      return fail26(this);
    }
    toString() {
      return this.message ? `${this.name}: ${this.message}` : this.name;
    }
    toJSON() {
      return {
        ...this
      };
    }
    [NodeInspectSymbol8]() {
      const stack = this.stack;
      if (stack) {
        return `${this.toString()}
${stack.split("\n").slice(1).join("\n")}`;
      }
      return this.toString();
    }
  }
  Object.assign(YieldableError242.prototype, StructuralCommitPrototype4);
  return YieldableError242;
}();
var exitIsExit6 = (u52) => isEffect6(u52) && "_tag" in u52 && (u52._tag === "Success" || u52._tag === "Failure");
var currentSpanFromFiber6 = (fiber) => {
  const span32 = fiber.getFiberRef(currentContext6).unsafeMap.get(spanTag6.key);
  return span32 !== void 0 && span32._tag === "Span" ? some36(span32) : none26();
};
var Data_exports4 = {};
__export25(Data_exports4, {
  Class: () => Class26,
  Error: () => Error26,
  Structural: () => Structural26,
  TaggedClass: () => TaggedClass6,
  TaggedError: () => TaggedError6,
  array: () => array26,
  case: () => _case6,
  struct: () => struct36,
  tagged: () => tagged6,
  taggedEnum: () => taggedEnum6,
  tuple: () => tuple26,
  unsafeArray: () => unsafeArray6,
  unsafeStruct: () => unsafeStruct6
});
var struct36 = struct26;
var unsafeStruct6 = (as262) => Object.setPrototypeOf(as262, StructuralPrototype4);
var tuple26 = (...as262) => unsafeArray6(as262);
var array26 = (as262) => unsafeArray6(as262.slice(0));
var unsafeArray6 = (as262) => Object.setPrototypeOf(as262, ArrayProto6);
var _case6 = () => (args) => args === void 0 ? Object.create(StructuralPrototype4) : struct36(args);
var tagged6 = (tag) => (args) => {
  const value = args === void 0 ? Object.create(StructuralPrototype4) : struct36(args);
  value._tag = tag;
  return value;
};
var Class26 = Structural7;
var TaggedClass6 = (tag) => {
  class Base extends Class26 {
    _tag = tag;
  }
  return Base;
};
var Structural26 = Structural7;
var taggedEnum6 = () => new Proxy({}, {
  get(_target, tag, _receiver) {
    if (tag === "$is") {
      return isTagged8;
    } else if (tag === "$match") {
      return taggedMatch6;
    }
    return tagged6(tag);
  }
});
function taggedMatch6() {
  if (arguments.length === 1) {
    const cases2 = arguments[0];
    return function(value2) {
      return cases2[value2._tag](value2);
    };
  }
  const value = arguments[0];
  const cases = arguments[1];
  return cases[value._tag](value);
}
var Error26 = /* @__PURE__ */ function() {
  return class Base extends YieldableError6 {
    constructor(args) {
      super();
      if (args) {
        Object.assign(this, args);
      }
    }
  };
}();
var TaggedError6 = (tag) => {
  class Base extends Error26 {
    _tag = tag;
  }
  Base.prototype.name = tag;
  return Base;
};
var traverseUp6 = Function_exports8.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType6.Program) return Option_exports8.none();
  return predicate(parent) ? Option_exports8.some(parent) : traverseUp6(parent, predicate);
});
var traverseUpGuard6 = Function_exports8.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType6.Program) return Option_exports8.none();
  return predicate(parent) ? Option_exports8.some(parent) : traverseUpGuard6(parent, predicate);
});
var ESLintCommunityESLintUtils6;
((ESLintCommunityESLintUtils242) => {
  ESLintCommunityESLintUtils242.getFunctionHeadLocation = getFunctionHeadLocation6;
  ESLintCommunityESLintUtils242.getFunctionNameWithKind = getFunctionNameWithKind6;
  ESLintCommunityESLintUtils242.getPropertyName = getPropertyName6;
  ESLintCommunityESLintUtils242.getStaticValue = getStaticValue3;
  ESLintCommunityESLintUtils242.getStringIfConstant = getStringIfConstant6;
  ESLintCommunityESLintUtils242.hasSideEffect = hasSideEffect6;
  ESLintCommunityESLintUtils242.isParenthesized = isParenthesized6;
})(ESLintCommunityESLintUtils6 || (ESLintCommunityESLintUtils6 = {}));
var Construction6 = Data_exports4.taggedEnum();
Construction6.None();
a5({
  type: N4.union([NodeType6.FunctionExpression, NodeType6.ArrowFunctionExpression]),
  parent: {
    type: NodeType6.Property,
    parent: {
      type: NodeType6.ObjectExpression
    }
  }
});
a5({
  type: N4.union([NodeType6.FunctionExpression, NodeType6.ArrowFunctionExpression]),
  parent: {
    type: NodeType6.MethodDefinition,
    parent: {
      type: NodeType6.ClassBody
    }
  }
});
a5({
  type: N4.union([NodeType6.FunctionExpression, NodeType6.ArrowFunctionExpression]),
  parent: {
    type: NodeType6.Property,
    parent: {
      type: NodeType6.ClassBody
    }
  }
});
var import_short_unique_id2 = __toESM2(require_short_unique_id2());
var __defProp33 = Object.defineProperty;
var __export33 = (target, all922) => {
  for (var name22 in all922)
    __defProp33(target, name22, { get: all922[name22], enumerable: true });
};
var KEYS23 = {
  ArrayExpression: [
    "elements"
  ],
  ArrayPattern: [
    "elements"
  ],
  ArrowFunctionExpression: [
    "params",
    "body"
  ],
  AssignmentExpression: [
    "left",
    "right"
  ],
  AssignmentPattern: [
    "left",
    "right"
  ],
  AwaitExpression: [
    "argument"
  ],
  BinaryExpression: [
    "left",
    "right"
  ],
  BlockStatement: [
    "body"
  ],
  BreakStatement: [
    "label"
  ],
  CallExpression: [
    "callee",
    "arguments"
  ],
  CatchClause: [
    "param",
    "body"
  ],
  ChainExpression: [
    "expression"
  ],
  ClassBody: [
    "body"
  ],
  ClassDeclaration: [
    "id",
    "superClass",
    "body"
  ],
  ClassExpression: [
    "id",
    "superClass",
    "body"
  ],
  ConditionalExpression: [
    "test",
    "consequent",
    "alternate"
  ],
  ContinueStatement: [
    "label"
  ],
  DebuggerStatement: [],
  DoWhileStatement: [
    "body",
    "test"
  ],
  EmptyStatement: [],
  ExperimentalRestProperty: [
    "argument"
  ],
  ExperimentalSpreadProperty: [
    "argument"
  ],
  ExportAllDeclaration: [
    "exported",
    "source"
  ],
  ExportDefaultDeclaration: [
    "declaration"
  ],
  ExportNamedDeclaration: [
    "declaration",
    "specifiers",
    "source"
  ],
  ExportSpecifier: [
    "exported",
    "local"
  ],
  ExpressionStatement: [
    "expression"
  ],
  ForInStatement: [
    "left",
    "right",
    "body"
  ],
  ForOfStatement: [
    "left",
    "right",
    "body"
  ],
  ForStatement: [
    "init",
    "test",
    "update",
    "body"
  ],
  FunctionDeclaration: [
    "id",
    "params",
    "body"
  ],
  FunctionExpression: [
    "id",
    "params",
    "body"
  ],
  Identifier: [],
  IfStatement: [
    "test",
    "consequent",
    "alternate"
  ],
  ImportDeclaration: [
    "specifiers",
    "source"
  ],
  ImportDefaultSpecifier: [
    "local"
  ],
  ImportExpression: [
    "source"
  ],
  ImportNamespaceSpecifier: [
    "local"
  ],
  ImportSpecifier: [
    "imported",
    "local"
  ],
  JSXAttribute: [
    "name",
    "value"
  ],
  JSXClosingElement: [
    "name"
  ],
  JSXClosingFragment: [],
  JSXElement: [
    "openingElement",
    "children",
    "closingElement"
  ],
  JSXEmptyExpression: [],
  JSXExpressionContainer: [
    "expression"
  ],
  JSXFragment: [
    "openingFragment",
    "children",
    "closingFragment"
  ],
  JSXIdentifier: [],
  JSXMemberExpression: [
    "object",
    "property"
  ],
  JSXNamespacedName: [
    "namespace",
    "name"
  ],
  JSXOpeningElement: [
    "name",
    "attributes"
  ],
  JSXOpeningFragment: [],
  JSXSpreadAttribute: [
    "argument"
  ],
  JSXSpreadChild: [
    "expression"
  ],
  JSXText: [],
  LabeledStatement: [
    "label",
    "body"
  ],
  Literal: [],
  LogicalExpression: [
    "left",
    "right"
  ],
  MemberExpression: [
    "object",
    "property"
  ],
  MetaProperty: [
    "meta",
    "property"
  ],
  MethodDefinition: [
    "key",
    "value"
  ],
  NewExpression: [
    "callee",
    "arguments"
  ],
  ObjectExpression: [
    "properties"
  ],
  ObjectPattern: [
    "properties"
  ],
  PrivateIdentifier: [],
  Program: [
    "body"
  ],
  Property: [
    "key",
    "value"
  ],
  PropertyDefinition: [
    "key",
    "value"
  ],
  RestElement: [
    "argument"
  ],
  ReturnStatement: [
    "argument"
  ],
  SequenceExpression: [
    "expressions"
  ],
  SpreadElement: [
    "argument"
  ],
  StaticBlock: [
    "body"
  ],
  Super: [],
  SwitchCase: [
    "test",
    "consequent"
  ],
  SwitchStatement: [
    "discriminant",
    "cases"
  ],
  TaggedTemplateExpression: [
    "tag",
    "quasi"
  ],
  TemplateElement: [],
  TemplateLiteral: [
    "quasis",
    "expressions"
  ],
  ThisExpression: [],
  ThrowStatement: [
    "argument"
  ],
  TryStatement: [
    "block",
    "handler",
    "finalizer"
  ],
  UnaryExpression: [
    "argument"
  ],
  UpdateExpression: [
    "argument"
  ],
  VariableDeclaration: [
    "declarations"
  ],
  VariableDeclarator: [
    "id",
    "init"
  ],
  WhileStatement: [
    "test",
    "body"
  ],
  WithStatement: [
    "object",
    "body"
  ],
  YieldExpression: [
    "argument"
  ]
};
var NODE_TYPES23 = Object.keys(KEYS23);
for (const type of NODE_TYPES23) {
  Object.freeze(KEYS23[type]);
}
Object.freeze(KEYS23);
var visitor_keys_default23 = KEYS23;
var KEY_BLACKLIST23 = /* @__PURE__ */ new Set([
  "parent",
  "leadingComments",
  "trailingComments"
]);
function filterKey23(key) {
  return !KEY_BLACKLIST23.has(key) && key[0] !== "_";
}
function getKeys23(node) {
  return Object.keys(node).filter(filterKey23);
}
function getInnermostScope23(initialScope, node) {
  const location = node.range[0];
  let scope = initialScope;
  let found = false;
  do {
    found = false;
    for (const childScope of scope.childScopes) {
      const range222 = childScope.block.range;
      if (range222[0] <= location && location < range222[1]) {
        scope = childScope;
        found = true;
        break;
      }
    }
  } while (found);
  return scope;
}
function findVariable25(initialScope, nameOrNode) {
  let name22 = "";
  let scope = initialScope;
  if (typeof nameOrNode === "string") {
    name22 = nameOrNode;
  } else {
    name22 = nameOrNode.name;
    scope = getInnermostScope23(scope, nameOrNode);
  }
  while (scope != null) {
    const variable = scope.set.get(name22);
    if (variable != null) {
      return variable;
    }
    scope = scope.upper;
  }
  return null;
}
function negate023(token) {
  return !this(token);
}
function negate23(f322) {
  return negate023.bind(f322);
}
function isPunctuatorTokenWithValue23(token, value) {
  return token.type === "Punctuator" && token.value === value;
}
function isArrowToken23(token) {
  return isPunctuatorTokenWithValue23(token, "=>");
}
function isCommaToken23(token) {
  return isPunctuatorTokenWithValue23(token, ",");
}
function isSemicolonToken23(token) {
  return isPunctuatorTokenWithValue23(token, ";");
}
function isColonToken23(token) {
  return isPunctuatorTokenWithValue23(token, ":");
}
function isOpeningParenToken23(token) {
  return isPunctuatorTokenWithValue23(token, "(");
}
function isClosingParenToken23(token) {
  return isPunctuatorTokenWithValue23(token, ")");
}
function isOpeningBracketToken23(token) {
  return isPunctuatorTokenWithValue23(token, "[");
}
function isClosingBracketToken23(token) {
  return isPunctuatorTokenWithValue23(token, "]");
}
function isOpeningBraceToken23(token) {
  return isPunctuatorTokenWithValue23(token, "{");
}
function isClosingBraceToken23(token) {
  return isPunctuatorTokenWithValue23(token, "}");
}
function isCommentToken23(token) {
  return ["Block", "Line", "Shebang"].includes(token.type);
}
negate23(isArrowToken23);
negate23(isCommaToken23);
negate23(isSemicolonToken23);
negate23(isColonToken23);
negate23(isOpeningParenToken23);
negate23(isClosingParenToken23);
negate23(isOpeningBracketToken23);
negate23(isClosingBracketToken23);
negate23(isOpeningBraceToken23);
negate23(isClosingBraceToken23);
negate23(isCommentToken23);
function getOpeningParenOfParams23(node, sourceCode) {
  return node.id ? sourceCode.getTokenAfter(node.id, isOpeningParenToken23) : sourceCode.getFirstToken(node, isOpeningParenToken23);
}
function getFunctionHeadLocation23(node, sourceCode) {
  const parent = node.parent;
  let start = null;
  let end = null;
  if (node.type === "ArrowFunctionExpression") {
    const arrowToken = sourceCode.getTokenBefore(node.body, isArrowToken23);
    start = arrowToken.loc.start;
    end = arrowToken.loc.end;
  } else if (parent.type === "Property" || parent.type === "MethodDefinition" || parent.type === "PropertyDefinition") {
    start = parent.loc.start;
    end = getOpeningParenOfParams23(node, sourceCode).loc.start;
  } else {
    start = node.loc.start;
    end = getOpeningParenOfParams23(node, sourceCode).loc.start;
  }
  return {
    start: { ...start },
    end: { ...end }
  };
}
var globalObject23 = typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {};
var builtinNames23 = Object.freeze(
  /* @__PURE__ */ new Set([
    "Array",
    "ArrayBuffer",
    "BigInt",
    "BigInt64Array",
    "BigUint64Array",
    "Boolean",
    "DataView",
    "Date",
    "decodeURI",
    "decodeURIComponent",
    "encodeURI",
    "encodeURIComponent",
    "escape",
    "Float32Array",
    "Float64Array",
    "Function",
    "Infinity",
    "Int16Array",
    "Int32Array",
    "Int8Array",
    "isFinite",
    "isNaN",
    "isPrototypeOf",
    "JSON",
    "Map",
    "Math",
    "NaN",
    "Number",
    "Object",
    "parseFloat",
    "parseInt",
    "Promise",
    "Proxy",
    "Reflect",
    "RegExp",
    "Set",
    "String",
    "Symbol",
    "Uint16Array",
    "Uint32Array",
    "Uint8Array",
    "Uint8ClampedArray",
    "undefined",
    "unescape",
    "WeakMap",
    "WeakSet"
  ])
);
var callAllowed23 = new Set(
  [
    Array.isArray,
    Array.of,
    Array.prototype.at,
    Array.prototype.concat,
    Array.prototype.entries,
    Array.prototype.every,
    Array.prototype.filter,
    Array.prototype.find,
    Array.prototype.findIndex,
    Array.prototype.flat,
    Array.prototype.includes,
    Array.prototype.indexOf,
    Array.prototype.join,
    Array.prototype.keys,
    Array.prototype.lastIndexOf,
    Array.prototype.slice,
    Array.prototype.some,
    Array.prototype.toString,
    Array.prototype.values,
    typeof BigInt === "function" ? BigInt : void 0,
    Boolean,
    Date,
    Date.parse,
    decodeURI,
    decodeURIComponent,
    encodeURI,
    encodeURIComponent,
    escape,
    isFinite,
    isNaN,
    isPrototypeOf,
    Map,
    Map.prototype.entries,
    Map.prototype.get,
    Map.prototype.has,
    Map.prototype.keys,
    Map.prototype.values,
    ...Object.getOwnPropertyNames(Math).filter((k322) => k322 !== "random").map((k322) => Math[k322]).filter((f322) => typeof f322 === "function"),
    Number,
    Number.isFinite,
    Number.isNaN,
    Number.parseFloat,
    Number.parseInt,
    Number.prototype.toExponential,
    Number.prototype.toFixed,
    Number.prototype.toPrecision,
    Number.prototype.toString,
    Object,
    Object.entries,
    Object.is,
    Object.isExtensible,
    Object.isFrozen,
    Object.isSealed,
    Object.keys,
    Object.values,
    parseFloat,
    parseInt,
    RegExp,
    Set,
    Set.prototype.entries,
    Set.prototype.has,
    Set.prototype.keys,
    Set.prototype.values,
    String,
    String.fromCharCode,
    String.fromCodePoint,
    String.raw,
    String.prototype.at,
    String.prototype.charAt,
    String.prototype.charCodeAt,
    String.prototype.codePointAt,
    String.prototype.concat,
    String.prototype.endsWith,
    String.prototype.includes,
    String.prototype.indexOf,
    String.prototype.lastIndexOf,
    String.prototype.normalize,
    String.prototype.padEnd,
    String.prototype.padStart,
    String.prototype.slice,
    String.prototype.startsWith,
    String.prototype.substr,
    String.prototype.substring,
    String.prototype.toLowerCase,
    String.prototype.toString,
    String.prototype.toUpperCase,
    String.prototype.trim,
    String.prototype.trimEnd,
    String.prototype.trimLeft,
    String.prototype.trimRight,
    String.prototype.trimStart,
    Symbol.for,
    Symbol.keyFor,
    unescape
  ].filter((f322) => typeof f322 === "function")
);
var callPassThrough23 = /* @__PURE__ */ new Set([
  Object.freeze,
  Object.preventExtensions,
  Object.seal
]);
var getterAllowed23 = [
  [Map, /* @__PURE__ */ new Set(["size"])],
  [
    RegExp,
    /* @__PURE__ */ new Set([
      "dotAll",
      "flags",
      "global",
      "hasIndices",
      "ignoreCase",
      "multiline",
      "source",
      "sticky",
      "unicode"
    ])
  ],
  [Set, /* @__PURE__ */ new Set(["size"])]
];
function getPropertyDescriptor23(object222, name22) {
  let x322 = object222;
  while ((typeof x322 === "object" || typeof x322 === "function") && x322 !== null) {
    const d322 = Object.getOwnPropertyDescriptor(x322, name22);
    if (d322) {
      return d322;
    }
    x322 = Object.getPrototypeOf(x322);
  }
  return null;
}
function isGetter23(object222, name22) {
  const d322 = getPropertyDescriptor23(object222, name22);
  return d322 != null && d322.get != null;
}
function getElementValues23(nodeList, initialScope) {
  const valueList = [];
  for (let i322 = 0; i322 < nodeList.length; ++i322) {
    const elementNode = nodeList[i322];
    if (elementNode == null) {
      valueList.length = i322 + 1;
    } else if (elementNode.type === "SpreadElement") {
      const argument = getStaticValueR23(elementNode.argument, initialScope);
      if (argument == null) {
        return null;
      }
      valueList.push(...argument.value);
    } else {
      const element = getStaticValueR23(elementNode, initialScope);
      if (element == null) {
        return null;
      }
      valueList.push(element.value);
    }
  }
  return valueList;
}
function isEffectivelyConst23(variable) {
  const refs = variable.references;
  const inits = refs.filter((r322) => r322.init).length;
  const reads = refs.filter((r322) => r322.isReadOnly()).length;
  if (inits === 1 && reads + inits === refs.length) {
    return true;
  }
  return false;
}
var operations23 = Object.freeze({
  ArrayExpression(node, initialScope) {
    const elements = getElementValues23(node.elements, initialScope);
    return elements != null ? { value: elements } : null;
  },
  AssignmentExpression(node, initialScope) {
    if (node.operator === "=") {
      return getStaticValueR23(node.right, initialScope);
    }
    return null;
  },
  //eslint-disable-next-line complexity
  BinaryExpression(node, initialScope) {
    if (node.operator === "in" || node.operator === "instanceof") {
      return null;
    }
    const left722 = getStaticValueR23(node.left, initialScope);
    const right722 = getStaticValueR23(node.right, initialScope);
    if (left722 != null && right722 != null) {
      switch (node.operator) {
        case "==":
          return { value: left722.value == right722.value };
        case "!=":
          return { value: left722.value != right722.value };
        case "===":
          return { value: left722.value === right722.value };
        case "!==":
          return { value: left722.value !== right722.value };
        case "<":
          return { value: left722.value < right722.value };
        case "<=":
          return { value: left722.value <= right722.value };
        case ">":
          return { value: left722.value > right722.value };
        case ">=":
          return { value: left722.value >= right722.value };
        case "<<":
          return { value: left722.value << right722.value };
        case ">>":
          return { value: left722.value >> right722.value };
        case ">>>":
          return { value: left722.value >>> right722.value };
        case "+":
          return { value: left722.value + right722.value };
        case "-":
          return { value: left722.value - right722.value };
        case "*":
          return { value: left722.value * right722.value };
        case "/":
          return { value: left722.value / right722.value };
        case "%":
          return { value: left722.value % right722.value };
        case "**":
          return { value: left722.value ** right722.value };
        case "|":
          return { value: left722.value | right722.value };
        case "^":
          return { value: left722.value ^ right722.value };
        case "&":
          return { value: left722.value & right722.value };
      }
    }
    return null;
  },
  CallExpression(node, initialScope) {
    const calleeNode = node.callee;
    const args = getElementValues23(node.arguments, initialScope);
    if (args != null) {
      if (calleeNode.type === "MemberExpression") {
        if (calleeNode.property.type === "PrivateIdentifier") {
          return null;
        }
        const object222 = getStaticValueR23(calleeNode.object, initialScope);
        if (object222 != null) {
          if (object222.value == null && (object222.optional || node.optional)) {
            return { value: void 0, optional: true };
          }
          const property = getStaticPropertyNameValue23(
            calleeNode,
            initialScope
          );
          if (property != null) {
            const receiver = object222.value;
            const methodName = property.value;
            if (callAllowed23.has(receiver[methodName])) {
              return { value: receiver[methodName](...args) };
            }
            if (callPassThrough23.has(receiver[methodName])) {
              return { value: args[0] };
            }
          }
        }
      } else {
        const callee = getStaticValueR23(calleeNode, initialScope);
        if (callee != null) {
          if (callee.value == null && node.optional) {
            return { value: void 0, optional: true };
          }
          const func = callee.value;
          if (callAllowed23.has(func)) {
            return { value: func(...args) };
          }
          if (callPassThrough23.has(func)) {
            return { value: args[0] };
          }
        }
      }
    }
    return null;
  },
  ConditionalExpression(node, initialScope) {
    const test = getStaticValueR23(node.test, initialScope);
    if (test != null) {
      return test.value ? getStaticValueR23(node.consequent, initialScope) : getStaticValueR23(node.alternate, initialScope);
    }
    return null;
  },
  ExpressionStatement(node, initialScope) {
    return getStaticValueR23(node.expression, initialScope);
  },
  Identifier(node, initialScope) {
    if (initialScope != null) {
      const variable = findVariable25(initialScope, node);
      if (variable != null && variable.defs.length === 0 && builtinNames23.has(variable.name) && variable.name in globalObject23) {
        return { value: globalObject23[variable.name] };
      }
      if (variable != null && variable.defs.length === 1) {
        const def = variable.defs[0];
        if (def.parent && def.type === "Variable" && (def.parent.kind === "const" || isEffectivelyConst23(variable)) && // TODO(mysticatea): don't support destructuring here.
        def.node.id.type === "Identifier") {
          return getStaticValueR23(def.node.init, initialScope);
        }
      }
    }
    return null;
  },
  Literal(node) {
    if ((node.regex != null || node.bigint != null) && node.value == null) {
      return null;
    }
    return { value: node.value };
  },
  LogicalExpression(node, initialScope) {
    const left722 = getStaticValueR23(node.left, initialScope);
    if (left722 != null) {
      if (node.operator === "||" && Boolean(left722.value) === true || node.operator === "&&" && Boolean(left722.value) === false || node.operator === "??" && left722.value != null) {
        return left722;
      }
      const right722 = getStaticValueR23(node.right, initialScope);
      if (right722 != null) {
        return right722;
      }
    }
    return null;
  },
  MemberExpression(node, initialScope) {
    if (node.property.type === "PrivateIdentifier") {
      return null;
    }
    const object222 = getStaticValueR23(node.object, initialScope);
    if (object222 != null) {
      if (object222.value == null && (object222.optional || node.optional)) {
        return { value: void 0, optional: true };
      }
      const property = getStaticPropertyNameValue23(node, initialScope);
      if (property != null) {
        if (!isGetter23(object222.value, property.value)) {
          return { value: object222.value[property.value] };
        }
        for (const [classFn, allowed] of getterAllowed23) {
          if (object222.value instanceof classFn && allowed.has(property.value)) {
            return { value: object222.value[property.value] };
          }
        }
      }
    }
    return null;
  },
  ChainExpression(node, initialScope) {
    const expression = getStaticValueR23(node.expression, initialScope);
    if (expression != null) {
      return { value: expression.value };
    }
    return null;
  },
  NewExpression(node, initialScope) {
    const callee = getStaticValueR23(node.callee, initialScope);
    const args = getElementValues23(node.arguments, initialScope);
    if (callee != null && args != null) {
      const Func = callee.value;
      if (callAllowed23.has(Func)) {
        return { value: new Func(...args) };
      }
    }
    return null;
  },
  ObjectExpression(node, initialScope) {
    const object222 = {};
    for (const propertyNode of node.properties) {
      if (propertyNode.type === "Property") {
        if (propertyNode.kind !== "init") {
          return null;
        }
        const key = getStaticPropertyNameValue23(
          propertyNode,
          initialScope
        );
        const value = getStaticValueR23(propertyNode.value, initialScope);
        if (key == null || value == null) {
          return null;
        }
        object222[key.value] = value.value;
      } else if (propertyNode.type === "SpreadElement" || propertyNode.type === "ExperimentalSpreadProperty") {
        const argument = getStaticValueR23(
          propertyNode.argument,
          initialScope
        );
        if (argument == null) {
          return null;
        }
        Object.assign(object222, argument.value);
      } else {
        return null;
      }
    }
    return { value: object222 };
  },
  SequenceExpression(node, initialScope) {
    const last222 = node.expressions[node.expressions.length - 1];
    return getStaticValueR23(last222, initialScope);
  },
  TaggedTemplateExpression(node, initialScope) {
    const tag = getStaticValueR23(node.tag, initialScope);
    const expressions = getElementValues23(
      node.quasi.expressions,
      initialScope
    );
    if (tag != null && expressions != null) {
      const func = tag.value;
      const strings = node.quasi.quasis.map((q) => q.value.cooked);
      strings.raw = node.quasi.quasis.map((q) => q.value.raw);
      if (func === String.raw) {
        return { value: func(strings, ...expressions) };
      }
    }
    return null;
  },
  TemplateLiteral(node, initialScope) {
    const expressions = getElementValues23(node.expressions, initialScope);
    if (expressions != null) {
      let value = node.quasis[0].value.cooked;
      for (let i322 = 0; i322 < expressions.length; ++i322) {
        value += expressions[i322];
        value += node.quasis[i322 + 1].value.cooked;
      }
      return { value };
    }
    return null;
  },
  UnaryExpression(node, initialScope) {
    if (node.operator === "delete") {
      return null;
    }
    if (node.operator === "void") {
      return { value: void 0 };
    }
    const arg = getStaticValueR23(node.argument, initialScope);
    if (arg != null) {
      switch (node.operator) {
        case "-":
          return { value: -arg.value };
        case "+":
          return { value: +arg.value };
        case "!":
          return { value: !arg.value };
        case "~":
          return { value: ~arg.value };
        case "typeof":
          return { value: typeof arg.value };
      }
    }
    return null;
  }
});
function getStaticValueR23(node, initialScope) {
  if (node != null && Object.hasOwnProperty.call(operations23, node.type)) {
    return operations23[node.type](node, initialScope);
  }
  return null;
}
function getStaticPropertyNameValue23(node, initialScope) {
  const nameNode = node.type === "Property" ? node.key : node.property;
  if (node.computed) {
    return getStaticValueR23(nameNode, initialScope);
  }
  if (nameNode.type === "Identifier") {
    return { value: nameNode.name };
  }
  if (nameNode.type === "Literal") {
    if (nameNode.bigint) {
      return { value: nameNode.bigint };
    }
    return { value: String(nameNode.value) };
  }
  return null;
}
function getStaticValue23(node, initialScope = null) {
  try {
    return getStaticValueR23(node, initialScope);
  } catch (_error) {
    return null;
  }
}
function getStringIfConstant23(node, initialScope = null) {
  if (node && node.type === "Literal" && node.value === null) {
    if (node.regex) {
      return `/${node.regex.pattern}/${node.regex.flags}`;
    }
    if (node.bigint) {
      return node.bigint;
    }
  }
  const evaluated = getStaticValue23(node, initialScope);
  return evaluated && String(evaluated.value);
}
function getPropertyName23(node, initialScope) {
  switch (node.type) {
    case "MemberExpression":
      if (node.computed) {
        return getStringIfConstant23(node.property, initialScope);
      }
      if (node.property.type === "PrivateIdentifier") {
        return null;
      }
      return node.property.name;
    case "Property":
    case "MethodDefinition":
    case "PropertyDefinition":
      if (node.computed) {
        return getStringIfConstant23(node.key, initialScope);
      }
      if (node.key.type === "Literal") {
        return String(node.key.value);
      }
      if (node.key.type === "PrivateIdentifier") {
        return null;
      }
      return node.key.name;
  }
  return null;
}
function getFunctionNameWithKind23(node, sourceCode) {
  const parent = node.parent;
  const tokens = [];
  const isObjectMethod = parent.type === "Property" && parent.value === node;
  const isClassMethod = parent.type === "MethodDefinition" && parent.value === node;
  const isClassFieldMethod = parent.type === "PropertyDefinition" && parent.value === node;
  if (isClassMethod || isClassFieldMethod) {
    if (parent.static) {
      tokens.push("static");
    }
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push("private");
    }
  }
  if (node.async) {
    tokens.push("async");
  }
  if (node.generator) {
    tokens.push("generator");
  }
  if (isObjectMethod || isClassMethod) {
    if (parent.kind === "constructor") {
      return "constructor";
    }
    if (parent.kind === "get") {
      tokens.push("getter");
    } else if (parent.kind === "set") {
      tokens.push("setter");
    } else {
      tokens.push("method");
    }
  } else if (isClassFieldMethod) {
    tokens.push("method");
  } else {
    if (node.type === "ArrowFunctionExpression") {
      tokens.push("arrow");
    }
    tokens.push("function");
  }
  if (isObjectMethod || isClassMethod || isClassFieldMethod) {
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push(`#${parent.key.name}`);
    } else {
      const name22 = getPropertyName23(parent);
      if (name22) {
        tokens.push(`'${name22}'`);
      } else if (sourceCode) {
        const keyText = sourceCode.getText(parent.key);
        if (!keyText.includes("\n")) {
          tokens.push(`[${keyText}]`);
        }
      }
    }
  } else if (node.id) {
    tokens.push(`'${node.id.name}'`);
  } else if (parent.type === "VariableDeclarator" && parent.id && parent.id.type === "Identifier") {
    tokens.push(`'${parent.id.name}'`);
  } else if ((parent.type === "AssignmentExpression" || parent.type === "AssignmentPattern") && parent.left && parent.left.type === "Identifier") {
    tokens.push(`'${parent.left.name}'`);
  } else if (parent.type === "ExportDefaultDeclaration" && parent.declaration === node) {
    tokens.push("'default'");
  }
  return tokens.join(" ");
}
var typeConversionBinaryOps23 = Object.freeze(
  /* @__PURE__ */ new Set([
    "==",
    "!=",
    "<",
    "<=",
    ">",
    ">=",
    "<<",
    ">>",
    ">>>",
    "+",
    "-",
    "*",
    "/",
    "%",
    "|",
    "^",
    "&",
    "in"
  ])
);
var typeConversionUnaryOps23 = Object.freeze(/* @__PURE__ */ new Set(["-", "+", "!", "~"]));
function isNode23(x322) {
  return x322 !== null && typeof x322 === "object" && typeof x322.type === "string";
}
var visitor23 = Object.freeze(
  Object.assign(/* @__PURE__ */ Object.create(null), {
    $visit(node, options, visitorKeys) {
      const { type } = node;
      if (typeof this[type] === "function") {
        return this[type](node, options, visitorKeys);
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    $visitChildren(node, options, visitorKeys) {
      const { type } = node;
      for (const key of visitorKeys[type] || getKeys23(node)) {
        const value = node[key];
        if (Array.isArray(value)) {
          for (const element of value) {
            if (isNode23(element) && this.$visit(element, options, visitorKeys)) {
              return true;
            }
          }
        } else if (isNode23(value) && this.$visit(value, options, visitorKeys)) {
          return true;
        }
      }
      return false;
    },
    ArrowFunctionExpression() {
      return false;
    },
    AssignmentExpression() {
      return true;
    },
    AwaitExpression() {
      return true;
    },
    BinaryExpression(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && typeConversionBinaryOps23.has(node.operator) && (node.left.type !== "Literal" || node.right.type !== "Literal")) {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    CallExpression() {
      return true;
    },
    FunctionExpression() {
      return false;
    },
    ImportExpression() {
      return true;
    },
    MemberExpression(node, options, visitorKeys) {
      if (options.considerGetters) {
        return true;
      }
      if (options.considerImplicitTypeConversion && node.computed && node.property.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    MethodDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    NewExpression() {
      return true;
    },
    Property(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    PropertyDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UnaryExpression(node, options, visitorKeys) {
      if (node.operator === "delete") {
        return true;
      }
      if (options.considerImplicitTypeConversion && typeConversionUnaryOps23.has(node.operator) && node.argument.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UpdateExpression() {
      return true;
    },
    YieldExpression() {
      return true;
    }
  })
);
function hasSideEffect23(node, sourceCode, { considerGetters = false, considerImplicitTypeConversion = false } = {}) {
  return visitor23.$visit(
    node,
    { considerGetters, considerImplicitTypeConversion },
    sourceCode.visitorKeys || visitor_keys_default23
  );
}
function getParentSyntaxParen23(node, sourceCode) {
  const parent = node.parent;
  switch (parent.type) {
    case "CallExpression":
    case "NewExpression":
      if (parent.arguments.length === 1 && parent.arguments[0] === node) {
        return sourceCode.getTokenAfter(
          parent.callee,
          isOpeningParenToken23
        );
      }
      return null;
    case "DoWhileStatement":
      if (parent.test === node) {
        return sourceCode.getTokenAfter(
          parent.body,
          isOpeningParenToken23
        );
      }
      return null;
    case "IfStatement":
    case "WhileStatement":
      if (parent.test === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "ImportExpression":
      if (parent.source === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "SwitchStatement":
      if (parent.discriminant === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "WithStatement":
      if (parent.object === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    default:
      return null;
  }
}
function isParenthesized23(timesOrNode, nodeOrSourceCode, optionalSourceCode) {
  let times, node, sourceCode, maybeLeftParen, maybeRightParen;
  if (typeof timesOrNode === "number") {
    times = timesOrNode | 0;
    node = nodeOrSourceCode;
    sourceCode = optionalSourceCode;
    if (!(times >= 1)) {
      throw new TypeError("'times' should be a positive integer.");
    }
  } else {
    times = 1;
    node = timesOrNode;
    sourceCode = nodeOrSourceCode;
  }
  if (node == null || // `Program` can't be parenthesized
  node.parent == null || // `CatchClause.param` can't be parenthesized, example `try {} catch (error) {}`
  node.parent.type === "CatchClause" && node.parent.param === node) {
    return false;
  }
  maybeLeftParen = maybeRightParen = node;
  do {
    maybeLeftParen = sourceCode.getTokenBefore(maybeLeftParen);
    maybeRightParen = sourceCode.getTokenAfter(maybeRightParen);
  } while (maybeLeftParen != null && maybeRightParen != null && isOpeningParenToken23(maybeLeftParen) && isClosingParenToken23(maybeRightParen) && // Avoid false positive such as `if (a) {}`
  maybeLeftParen !== getParentSyntaxParen23(node, sourceCode) && --times > 0);
  return times === 0;
}
Function.call.bind(Object.hasOwnProperty);
var __defProp224 = Object.defineProperty;
var __export224 = (target, all3322) => {
  for (var name22 in all3322)
    __defProp224(target, name22, { get: all3322[name22], enumerable: true });
};
var NodeType23 = types.AST_NODE_TYPES;
var is23 = utils.ASTUtils.isNodeOfType;
var isOneOf23 = utils.ASTUtils.isNodeOfTypes;
isOneOf23([
  NodeType23.ArrowFunctionExpression,
  NodeType23.FunctionDeclaration,
  NodeType23.FunctionExpression
]);
isOneOf23([
  NodeType23.ArrowFunctionExpression,
  NodeType23.FunctionDeclaration,
  NodeType23.FunctionExpression,
  NodeType23.TSCallSignatureDeclaration,
  NodeType23.TSConstructSignatureDeclaration,
  NodeType23.TSDeclareFunction,
  NodeType23.TSEmptyBodyFunctionExpression,
  NodeType23.TSFunctionType,
  NodeType23.TSMethodSignature
]);
isOneOf23([NodeType23.ClassDeclaration, NodeType23.ClassExpression]);
isOneOf23([
  NodeType23.DoWhileStatement,
  NodeType23.ForInStatement,
  NodeType23.ForOfStatement,
  NodeType23.ForStatement,
  NodeType23.WhileStatement
]);
isOneOf23([NodeType23.TSArrayType, NodeType23.TSTupleType]);
isOneOf23([
  NodeType23.PropertyDefinition,
  NodeType23.TSIndexSignature,
  NodeType23.TSParameterProperty,
  NodeType23.TSPropertySignature
]);
is23(NodeType23.JSXElement);
is23(NodeType23.JSXFragment);
isOneOf23([
  NodeType23.JSXAttribute,
  NodeType23.JSXSpreadChild,
  NodeType23.JSXClosingElement,
  NodeType23.JSXClosingFragment,
  NodeType23.JSXElement,
  NodeType23.JSXEmptyExpression,
  NodeType23.JSXExpressionContainer,
  NodeType23.JSXFragment,
  NodeType23.JSXIdentifier,
  NodeType23.JSXMemberExpression,
  NodeType23.JSXNamespacedName,
  NodeType23.JSXOpeningElement,
  NodeType23.JSXOpeningFragment,
  NodeType23.JSXSpreadAttribute,
  NodeType23.JSXSpreadChild,
  NodeType23.JSXText
]);
isOneOf23([
  NodeType23.JSXIdentifier,
  NodeType23.JSXMemberExpression,
  NodeType23.JSXNamespacedName
]);
isOneOf23([
  NodeType23.ArrayPattern,
  NodeType23.AssignmentPattern,
  NodeType23.ObjectPattern,
  NodeType23.RestElement
]);
isOneOf23([
  NodeType23.TSInterfaceDeclaration,
  NodeType23.TSTypeAliasDeclaration
]);
isOneOf23([
  NodeType23.ArrayExpression,
  NodeType23.ArrayPattern,
  NodeType23.ArrowFunctionExpression,
  NodeType23.CallExpression,
  NodeType23.ClassExpression,
  NodeType23.FunctionExpression,
  NodeType23.Identifier,
  NodeType23.JSXElement,
  NodeType23.JSXFragment,
  NodeType23.Literal,
  NodeType23.TemplateLiteral,
  NodeType23.MemberExpression,
  NodeType23.MetaProperty,
  NodeType23.ObjectExpression,
  NodeType23.ObjectPattern,
  NodeType23.SequenceExpression,
  NodeType23.Super,
  NodeType23.TaggedTemplateExpression,
  NodeType23.ThisExpression
]);
isOneOf23([
  NodeType23.ArrayExpression,
  NodeType23.ArrayPattern,
  NodeType23.ArrowFunctionExpression,
  NodeType23.CallExpression,
  NodeType23.ClassExpression,
  NodeType23.FunctionExpression,
  NodeType23.Identifier,
  NodeType23.JSXElement,
  NodeType23.JSXFragment,
  NodeType23.Literal,
  NodeType23.TemplateLiteral,
  NodeType23.MemberExpression,
  NodeType23.MetaProperty,
  NodeType23.ObjectExpression,
  NodeType23.ObjectPattern,
  NodeType23.SequenceExpression,
  NodeType23.Super,
  NodeType23.TaggedTemplateExpression,
  NodeType23.ThisExpression,
  NodeType23.TSAsExpression,
  NodeType23.TSNonNullExpression,
  NodeType23.TSTypeAssertion
]);
var Function_exports25 = {};
__export224(Function_exports25, {
  SK: () => SK25,
  absurd: () => absurd25,
  apply: () => apply25,
  compose: () => compose33,
  constFalse: () => constFalse25,
  constNull: () => constNull25,
  constTrue: () => constTrue25,
  constUndefined: () => constUndefined25,
  constVoid: () => constVoid25,
  constant: () => constant25,
  dual: () => dual25,
  flip: () => flip25,
  flow: () => flow25,
  hole: () => hole25,
  identity: () => identity25,
  isFunction: () => isFunction225,
  pipe: () => pipe25,
  satisfies: () => satisfies25,
  tupled: () => tupled25,
  unsafeCoerce: () => unsafeCoerce25,
  untupled: () => untupled25
});
var isFunction225 = (input) => typeof input === "function";
var dual25 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a322, b322) {
        if (arguments.length >= 2) {
          return body(a322, b322);
        }
        return function(self2) {
          return body(self2, a322);
        };
      };
    case 3:
      return function(a322, b322, c322) {
        if (arguments.length >= 3) {
          return body(a322, b322, c322);
        }
        return function(self2) {
          return body(self2, a322, b322);
        };
      };
    case 4:
      return function(a322, b322, c322, d322) {
        if (arguments.length >= 4) {
          return body(a322, b322, c322, d322);
        }
        return function(self2) {
          return body(self2, a322, b322, c322);
        };
      };
    case 5:
      return function(a322, b322, c322, d322, e322) {
        if (arguments.length >= 5) {
          return body(a322, b322, c322, d322, e322);
        }
        return function(self2) {
          return body(self2, a322, b322, c322, d322);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply25 = (a322) => (self2) => self2(a322);
var identity25 = (a322) => a322;
var satisfies25 = () => (b322) => b322;
var unsafeCoerce25 = identity25;
var constant25 = (value) => () => value;
var constTrue25 = /* @__PURE__ */ constant25(true);
var constFalse25 = /* @__PURE__ */ constant25(false);
var constNull25 = /* @__PURE__ */ constant25(null);
var constUndefined25 = /* @__PURE__ */ constant25(void 0);
var constVoid25 = constUndefined25;
var flip25 = (f322) => (...b322) => (...a322) => f322(...a322)(...b322);
var compose33 = /* @__PURE__ */ dual25(2, (ab, bc) => (a322) => bc(ab(a322)));
var absurd25 = (_322) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled25 = (f322) => (a322) => f322(...a322);
var untupled25 = (f322) => (...a322) => f322(a322);
function pipe25(a322, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a322;
    case 2:
      return ab(a322);
    case 3:
      return bc(ab(a322));
    case 4:
      return cd(bc(ab(a322)));
    case 5:
      return de(cd(bc(ab(a322))));
    case 6:
      return ef(de(cd(bc(ab(a322)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a322))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a322)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a322))))))));
    default: {
      let ret = arguments[0];
      for (let i322 = 1; i322 < arguments.length; i322++) {
        ret = arguments[i322](ret);
      }
      return ret;
    }
  }
}
function flow25(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole25 = /* @__PURE__ */ unsafeCoerce25(absurd25);
var SK25 = (_322, b322) => b322;
var make63 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_35 = (map622) => dual25(3, (self2, name22, f322) => map622(self2, (a322) => Object.assign({}, a322, {
  [name22]: f322(a322)
})));
var bindTo35 = (map622) => dual25(2, (self2, name22) => map622(self2, (a322) => ({
  [name22]: a322
})));
var bind35 = (map622, flatMap4222) => dual25(3, (self2, name22, f322) => flatMap4222(self2, (a322) => map622(f322(a322), (b322) => Object.assign({}, a322, {
  [name22]: b322
}))));
var moduleVersion25 = "3.2.8";
var getCurrentVersion25 = () => moduleVersion25;
var globalStoreId25 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion25()}`);
if (!(globalStoreId25 in globalThis)) {
  globalThis[globalStoreId25] = /* @__PURE__ */ new Map();
}
var globalStore25 = globalThis[globalStoreId25];
var globalValue25 = (id, compute) => {
  if (!globalStore25.has(id)) {
    globalStore25.set(id, compute());
  }
  return globalStore25.get(id);
};
var Predicate_exports25 = {};
__export224(Predicate_exports25, {
  all: () => all33,
  and: () => and23,
  compose: () => compose225,
  eqv: () => eqv23,
  every: () => every23,
  hasProperty: () => hasProperty25,
  implies: () => implies23,
  isBigInt: () => isBigInt23,
  isBoolean: () => isBoolean23,
  isDate: () => isDate23,
  isError: () => isError23,
  isFunction: () => isFunction325,
  isIterable: () => isIterable23,
  isMap: () => isMap23,
  isNever: () => isNever23,
  isNotNull: () => isNotNull23,
  isNotNullable: () => isNotNullable23,
  isNotUndefined: () => isNotUndefined23,
  isNull: () => isNull23,
  isNullable: () => isNullable25,
  isNumber: () => isNumber23,
  isObject: () => isObject25,
  isPromise: () => isPromise23,
  isPromiseLike: () => isPromiseLike23,
  isReadonlyRecord: () => isReadonlyRecord23,
  isRecord: () => isRecord23,
  isSet: () => isSet23,
  isString: () => isString23,
  isSymbol: () => isSymbol23,
  isTagged: () => isTagged23,
  isTruthy: () => isTruthy23,
  isUint8Array: () => isUint8Array23,
  isUndefined: () => isUndefined23,
  isUnknown: () => isUnknown23,
  mapInput: () => mapInput23,
  nand: () => nand23,
  nor: () => nor23,
  not: () => not23,
  or: () => or23,
  product: () => product33,
  productMany: () => productMany33,
  some: () => some43,
  struct: () => struct43,
  tuple: () => tuple33,
  xor: () => xor23
});
var mapInput23 = /* @__PURE__ */ dual25(2, (self2, f322) => (b322) => self2(f322(b322)));
var isTruthy23 = (input) => !!input;
var isSet23 = (input) => input instanceof Set;
var isMap23 = (input) => input instanceof Map;
var isString23 = (input) => typeof input === "string";
var isNumber23 = (input) => typeof input === "number";
var isBoolean23 = (input) => typeof input === "boolean";
var isBigInt23 = (input) => typeof input === "bigint";
var isSymbol23 = (input) => typeof input === "symbol";
var isFunction325 = isFunction225;
var isUndefined23 = (input) => input === void 0;
var isNotUndefined23 = (input) => input !== void 0;
var isNull23 = (input) => input === null;
var isNotNull23 = (input) => input !== null;
var isNever23 = (_322) => false;
var isUnknown23 = (_322) => true;
var isRecordOrArray25 = (input) => typeof input === "object" && input !== null;
var isObject25 = (input) => isRecordOrArray25(input) || isFunction325(input);
var hasProperty25 = /* @__PURE__ */ dual25(2, (self2, property) => isObject25(self2) && property in self2);
var isTagged23 = /* @__PURE__ */ dual25(2, (self2, tag) => hasProperty25(self2, "_tag") && self2["_tag"] === tag);
var isNullable25 = (input) => input === null || input === void 0;
var isNotNullable23 = (input) => input !== null && input !== void 0;
var isError23 = (input) => input instanceof Error;
var isUint8Array23 = (input) => input instanceof Uint8Array;
var isDate23 = (input) => input instanceof Date;
var isIterable23 = (input) => hasProperty25(input, Symbol.iterator);
var isRecord23 = (input) => isRecordOrArray25(input) && !Array.isArray(input);
var isReadonlyRecord23 = isRecord23;
var isPromise23 = (input) => hasProperty25(input, "then") && "catch" in input && isFunction325(input.then) && isFunction325(input.catch);
var isPromiseLike23 = (input) => hasProperty25(input, "then") && isFunction325(input.then);
var compose225 = /* @__PURE__ */ dual25(2, (ab, bc) => (a322) => ab(a322) && bc(a322));
var product33 = (self2, that) => ([a322, b322]) => self2(a322) && that(b322);
var all33 = (collection) => {
  return (as2422) => {
    let collectionIndex = 0;
    for (const p322 of collection) {
      if (collectionIndex >= as2422.length) {
        break;
      }
      if (p322(as2422[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany33 = (self2, collection) => {
  const rest = all33(collection);
  return ([head222, ...tail322]) => self2(head222) === false ? false : rest(tail322);
};
var tuple33 = (...elements) => all33(elements);
var struct43 = (fields) => {
  const keys2322 = Object.keys(fields);
  return (a322) => {
    for (const key of keys2322) {
      if (!fields[key](a322[key])) {
        return false;
      }
    }
    return true;
  };
};
var not23 = (self2) => (a322) => !self2(a322);
var or23 = /* @__PURE__ */ dual25(2, (self2, that) => (a322) => self2(a322) || that(a322));
var and23 = /* @__PURE__ */ dual25(2, (self2, that) => (a322) => self2(a322) && that(a322));
var xor23 = /* @__PURE__ */ dual25(2, (self2, that) => (a322) => self2(a322) !== that(a322));
var eqv23 = /* @__PURE__ */ dual25(2, (self2, that) => (a322) => self2(a322) === that(a322));
var implies23 = /* @__PURE__ */ dual25(2, (self2, that) => (a322) => self2(a322) ? that(a322) : true);
var nor23 = /* @__PURE__ */ dual25(2, (self2, that) => (a322) => !(self2(a322) || that(a322)));
var nand23 = /* @__PURE__ */ dual25(2, (self2, that) => (a322) => !(self2(a322) && that(a322)));
var every23 = (collection) => (a322) => {
  for (const p322 of collection) {
    if (!p322(a322)) {
      return false;
    }
  }
  return true;
};
var some43 = (collection) => (a322) => {
  for (const p322 of collection) {
    if (p322(a322)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage25 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId25 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind25 = (u322) => isObject25(u322) && GenKindTypeId25 in u322;
var GenKindImpl25 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity25;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_322) => _322;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_322) => _322;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_322) => _322;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId25] = GenKindTypeId25;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen33(this);
  }
};
var SingleShotGen33 = class _SingleShotGen35 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a322) {
    return this.called ? {
      value: a322,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a322) {
    return {
      value: a322,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e322) {
    throw e322;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen35(this.self);
  }
};
var adapter35 = () => function() {
  let x322 = arguments[0];
  for (let i322 = 1; i322 < arguments.length; i322++) {
    x322 = arguments[i322](x322);
  }
  return new GenKindImpl25(x322);
};
var defaultIncHi25 = 335903614;
var defaultIncLo25 = 4150755663;
var MUL_HI25 = 1481765933 >>> 0;
var MUL_LO25 = 1284865837 >>> 0;
var BIT_5325 = 9007199254740992;
var BIT_2725 = 134217728;
var PCGRandom25 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable25(seedLo) && isNullable25(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable25(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable25(incLo) && isNullable25(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo25;
      incHi = this._state ? this._state[2] : defaultIncHi25;
    } else if (isNullable25(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add6425(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max322) {
    if (!max322) {
      return this._next();
    }
    max322 = max322 >>> 0;
    if ((max322 & max322 - 1) === 0) {
      return this._next() & max322 - 1;
    }
    let num = 0;
    const skew = (-max322 >>> 0) % max322 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max322;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_2725 + lo) / BIT_5325;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul6425(this._state, oldHi, oldLo, MUL_HI25, MUL_LO25);
    add6425(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul6425(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add6425(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId25 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap25 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId25]() {
    return this.#value;
  }
};
function yieldWrapGet25(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId25 in self2) {
    return self2[YieldWrapTypeId25]();
  }
  throw new Error(getBugErrorMessage25("yieldWrapGet"));
}
var structuralRegionState25 = /* @__PURE__ */ globalValue25("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache25 = /* @__PURE__ */ globalValue25(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr25 = /* @__PURE__ */ globalValue25(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom25());
var symbol35 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash25 = (self2) => {
  if (structuralRegionState25.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number25(self2);
    case "bigint":
      return string25(self2.toString(10));
    case "boolean":
      return string25(String(self2));
    case "symbol":
      return string25(String(self2));
    case "string":
      return string25(self2);
    case "undefined":
      return string25("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string25("null");
      } else if (self2 instanceof Date) {
        return hash25(self2.toISOString());
      } else if (isHash25(self2)) {
        return self2[symbol35]();
      } else {
        return random25(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random25 = (self2) => {
  if (!randomHashCache25.has(self2)) {
    randomHashCache25.set(self2, number25(pcgr25.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache25.get(self2);
};
var combine33 = (b322) => (self2) => self2 * 53 ^ b322;
var optimize25 = (n322) => n322 & 3221225471 | n322 >>> 1 & 1073741824;
var isHash25 = (u322) => hasProperty25(u322, symbol35);
var number25 = (n322) => {
  if (n322 !== n322 || n322 === Infinity) {
    return 0;
  }
  let h322 = n322 | 0;
  if (h322 !== n322) {
    h322 ^= n322 * 4294967295;
  }
  while (n322 > 4294967295) {
    h322 ^= n322 /= 4294967295;
  }
  return optimize25(n322);
};
var string25 = (str) => {
  let h322 = 5381, i322 = str.length;
  while (i322) {
    h322 = h322 * 33 ^ str.charCodeAt(--i322);
  }
  return optimize25(h322);
};
var structureKeys25 = (o322, keys2322) => {
  let h322 = 12289;
  for (let i322 = 0; i322 < keys2322.length; i322++) {
    h322 ^= pipe25(string25(keys2322[i322]), combine33(hash25(o322[keys2322[i322]])));
  }
  return optimize25(h322);
};
var structure25 = (o322) => structureKeys25(o322, Object.keys(o322));
var array33 = (arr) => {
  let h322 = 6151;
  for (let i322 = 0; i322 < arr.length; i322++) {
    h322 = pipe25(h322, combine33(hash25(arr[i322])));
  }
  return optimize25(h322);
};
var cached25 = function() {
  if (arguments.length === 1) {
    const self22 = arguments[0];
    return function(hash3222) {
      Object.defineProperty(self22, symbol35, {
        value() {
          return hash3222;
        },
        enumerable: false
      });
      return hash3222;
    };
  }
  const self2 = arguments[0];
  const hash2422 = arguments[1];
  Object.defineProperty(self2, symbol35, {
    value() {
      return hash2422;
    },
    enumerable: false
  });
  return hash2422;
};
var symbol225 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals25() {
  if (arguments.length === 1) {
    return (self2) => compareBoth25(self2, arguments[0]);
  }
  return compareBoth25(arguments[0], arguments[1]);
}
function compareBoth25(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual25(self2) && isEqual25(that)) {
        if (hash25(self2) === hash25(that) && self2[symbol225](that)) {
          return true;
        } else {
          return structuralRegionState25.enabled && structuralRegionState25.tester ? structuralRegionState25.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState25.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v322, i322) => compareBoth25(v322, that[i322]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth25(self2[key], that[key]))) {
              return structuralRegionState25.tester ? structuralRegionState25.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState25.tester ? structuralRegionState25.tester(self2, that) : false;
    }
  }
  return structuralRegionState25.enabled && structuralRegionState25.tester ? structuralRegionState25.tester(self2, that) : false;
}
var isEqual25 = (u322) => hasProperty25(u322, symbol225);
var equivalence25 = () => equals25;
var NodeInspectSymbol25 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON25 = (x322) => {
  if (hasProperty25(x322, "toJSON") && isFunction325(x322["toJSON"]) && x322["toJSON"].length === 0) {
    return x322.toJSON();
  } else if (Array.isArray(x322)) {
    return x322.map(toJSON25);
  }
  return x322;
};
var format25 = (x322) => JSON.stringify(x322, null, 2);
var pipeArguments25 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i322 = 0, len = args.length; i322 < len; i322++) {
        ret = args[i322](ret);
      }
      return ret;
    }
  }
};
var OP_COMMIT25 = "Commit";
var OP_FAILURE23 = "Failure";
var OP_WITH_RUNTIME23 = "WithRuntime";
var EffectTypeId33 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId25 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId25 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId25 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance25 = {
  /* c8 ignore next */
  _R: (_322) => _322,
  /* c8 ignore next */
  _E: (_322) => _322,
  /* c8 ignore next */
  _A: (_322) => _322,
  _V: /* @__PURE__ */ getCurrentVersion25()
};
var sinkVariance25 = {
  /* c8 ignore next */
  _A: (_322) => _322,
  /* c8 ignore next */
  _In: (_322) => _322,
  /* c8 ignore next */
  _L: (_322) => _322,
  /* c8 ignore next */
  _E: (_322) => _322,
  /* c8 ignore next */
  _R: (_322) => _322
};
var channelVariance25 = {
  /* c8 ignore next */
  _Env: (_322) => _322,
  /* c8 ignore next */
  _InErr: (_322) => _322,
  /* c8 ignore next */
  _InElem: (_322) => _322,
  /* c8 ignore next */
  _InDone: (_322) => _322,
  /* c8 ignore next */
  _OutErr: (_322) => _322,
  /* c8 ignore next */
  _OutElem: (_322) => _322,
  /* c8 ignore next */
  _OutDone: (_322) => _322
};
var EffectPrototype25 = {
  [EffectTypeId33]: effectVariance25,
  [StreamTypeId25]: effectVariance25,
  [SinkTypeId25]: sinkVariance25,
  [ChannelTypeId25]: channelVariance25,
  [symbol225](that) {
    return this === that;
  },
  [symbol35]() {
    return cached25(this, random25(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen33(new YieldWrap25(this));
  },
  pipe() {
    return pipeArguments25(this, arguments);
  }
};
var StructuralPrototype25 = {
  [symbol35]() {
    return cached25(this, structure25(this));
  },
  [symbol225](that) {
    const selfKeys = Object.keys(this);
    const thatKeys = Object.keys(that);
    if (selfKeys.length !== thatKeys.length) {
      return false;
    }
    for (const key of selfKeys) {
      if (!(key in that && equals25(this[key], that[key]))) {
        return false;
      }
    }
    return true;
  }
};
var CommitPrototype25 = {
  ...EffectPrototype25,
  _op: OP_COMMIT25
};
var StructuralCommitPrototype25 = {
  ...CommitPrototype25,
  ...StructuralPrototype25
};
var TypeId63 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto35 = {
  ...EffectPrototype25,
  [TypeId63]: {
    _A: (_322) => _322
  },
  [NodeInspectSymbol25]() {
    return this.toJSON();
  },
  toString() {
    return format25(this.toJSON());
  }
};
var SomeProto25 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto35), {
  _tag: "Some",
  _op: "Some",
  [symbol225](that) {
    return isOption35(that) && isSome35(that) && equals25(this.value, that.value);
  },
  [symbol35]() {
    return cached25(this, combine33(hash25(this._tag))(hash25(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON25(this.value)
    };
  }
});
var NoneHash25 = /* @__PURE__ */ hash25("None");
var NoneProto25 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto35), {
  _tag: "None",
  _op: "None",
  [symbol225](that) {
    return isOption35(that) && isNone35(that);
  },
  [symbol35]() {
    return NoneHash25;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption35 = (input) => hasProperty25(input, TypeId63);
var isNone35 = (fa) => fa._tag === "None";
var isSome35 = (fa) => fa._tag === "Some";
var none35 = /* @__PURE__ */ Object.create(NoneProto25);
var some225 = (value) => {
  const a322 = Object.create(SomeProto25);
  a322.value = value;
  return a322;
};
var TypeId225 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto225 = {
  ...EffectPrototype25,
  [TypeId225]: {
    _R: (_322) => _322
  },
  [NodeInspectSymbol25]() {
    return this.toJSON();
  },
  toString() {
    return format25(this.toJSON());
  }
};
var RightProto25 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto225), {
  _tag: "Right",
  _op: "Right",
  [symbol225](that) {
    return isEither25(that) && isRight25(that) && equals25(this.right, that.right);
  },
  [symbol35]() {
    return combine33(hash25(this._tag))(hash25(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON25(this.right)
    };
  }
});
var LeftProto25 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto225), {
  _tag: "Left",
  _op: "Left",
  [symbol225](that) {
    return isEither25(that) && isLeft25(that) && equals25(this.left, that.left);
  },
  [symbol35]() {
    return combine33(hash25(this._tag))(hash25(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON25(this.left)
    };
  }
});
var isEither25 = (input) => hasProperty25(input, TypeId225);
var isLeft25 = (ma) => ma._tag === "Left";
var isRight25 = (ma) => ma._tag === "Right";
var left33 = (left3322) => {
  const a322 = Object.create(LeftProto25);
  a322.left = left3322;
  return a322;
};
var right33 = (right3322) => {
  const a322 = Object.create(RightProto25);
  a322.right = right3322;
  return a322;
};
var getLeft35 = (self2) => isRight25(self2) ? none35 : some225(self2.left);
var getRight35 = (self2) => isLeft25(self2) ? none35 : some225(self2.right);
var right225 = right33;
var left225 = left33;
var Option_exports25 = {};
__export224(Option_exports25, {
  Do: () => Do25,
  TypeId: () => TypeId325,
  all: () => all225,
  andThen: () => andThen25,
  ap: () => ap25,
  as: () => as25,
  asVoid: () => asVoid25,
  bind: () => bind225,
  bindTo: () => bindTo225,
  composeK: () => composeK25,
  contains: () => contains25,
  containsWith: () => containsWith25,
  exists: () => exists25,
  filter: () => filter25,
  filterMap: () => filterMap25,
  firstSomeOf: () => firstSomeOf25,
  flatMap: () => flatMap25,
  flatMapNullable: () => flatMapNullable25,
  flatten: () => flatten25,
  fromIterable: () => fromIterable33,
  fromNullable: () => fromNullable25,
  gen: () => gen25,
  getEquivalence: () => getEquivalence33,
  getLeft: () => getLeft225,
  getOrElse: () => getOrElse25,
  getOrNull: () => getOrNull25,
  getOrThrow: () => getOrThrow25,
  getOrThrowWith: () => getOrThrowWith25,
  getOrUndefined: () => getOrUndefined25,
  getOrder: () => getOrder25,
  getRight: () => getRight225,
  isNone: () => isNone225,
  isOption: () => isOption225,
  isSome: () => isSome225,
  let: () => let_225,
  lift2: () => lift225,
  liftNullable: () => liftNullable25,
  liftPredicate: () => liftPredicate25,
  liftThrowable: () => liftThrowable25,
  map: () => map25,
  match: () => match223,
  none: () => none225,
  orElse: () => orElse25,
  orElseEither: () => orElseEither25,
  orElseSome: () => orElseSome25,
  partitionMap: () => partitionMap25,
  product: () => product225,
  productMany: () => productMany225,
  reduceCompact: () => reduceCompact25,
  some: () => some325,
  tap: () => tap25,
  toArray: () => toArray25,
  toRefinement: () => toRefinement25,
  void: () => void_25,
  zipLeft: () => zipLeft25,
  zipRight: () => zipRight25,
  zipWith: () => zipWith25
});
var make225 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId325 = /* @__PURE__ */ Symbol.for("effect/Option");
var none225 = () => none35;
var some325 = some225;
var isOption225 = isOption35;
var isNone225 = isNone35;
var isSome225 = isSome35;
var match223 = /* @__PURE__ */ dual25(2, (self2, {
  onNone,
  onSome
}) => isNone225(self2) ? onNone() : onSome(self2.value));
var toRefinement25 = (f322) => (a322) => isSome225(f322(a322));
var fromIterable33 = (collection) => {
  for (const a322 of collection) {
    return some325(a322);
  }
  return none225();
};
var getRight225 = getRight35;
var getLeft225 = getLeft35;
var getOrElse25 = /* @__PURE__ */ dual25(2, (self2, onNone) => isNone225(self2) ? onNone() : self2.value);
var orElse25 = /* @__PURE__ */ dual25(2, (self2, that) => isNone225(self2) ? that() : self2);
var orElseSome25 = /* @__PURE__ */ dual25(2, (self2, onNone) => isNone225(self2) ? some325(onNone()) : self2);
var orElseEither25 = /* @__PURE__ */ dual25(2, (self2, that) => isNone225(self2) ? map25(that(), right33) : map25(self2, left33));
var firstSomeOf25 = (collection) => {
  let out = none225();
  for (out of collection) {
    if (isSome225(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable25 = (nullableValue) => nullableValue == null ? none225() : some325(nullableValue);
var liftNullable25 = (f322) => (...a322) => fromNullable25(f322(...a322));
var getOrNull25 = /* @__PURE__ */ getOrElse25(constNull25);
var getOrUndefined25 = /* @__PURE__ */ getOrElse25(constUndefined25);
var liftThrowable25 = (f322) => (...a322) => {
  try {
    return some325(f322(...a322));
  } catch (e322) {
    return none225();
  }
};
var getOrThrowWith25 = /* @__PURE__ */ dual25(2, (self2, onNone) => {
  if (isSome225(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow25 = /* @__PURE__ */ getOrThrowWith25(() => new Error("getOrThrow called on a None"));
var map25 = /* @__PURE__ */ dual25(2, (self2, f322) => isNone225(self2) ? none225() : some325(f322(self2.value)));
var as25 = /* @__PURE__ */ dual25(2, (self2, b322) => map25(self2, () => b322));
var asVoid25 = /* @__PURE__ */ as25(void 0);
var void_25 = /* @__PURE__ */ some325(void 0);
var flatMap25 = /* @__PURE__ */ dual25(2, (self2, f322) => isNone225(self2) ? none225() : f322(self2.value));
var andThen25 = /* @__PURE__ */ dual25(2, (self2, f322) => flatMap25(self2, (a322) => {
  const b322 = isFunction225(f322) ? f322(a322) : f322;
  return isOption225(b322) ? b322 : some325(b322);
}));
var flatMapNullable25 = /* @__PURE__ */ dual25(2, (self2, f322) => isNone225(self2) ? none225() : fromNullable25(f322(self2.value)));
var flatten25 = /* @__PURE__ */ flatMap25(identity25);
var zipRight25 = /* @__PURE__ */ dual25(2, (self2, that) => flatMap25(self2, () => that));
var composeK25 = /* @__PURE__ */ dual25(2, (afb, bfc) => (a322) => flatMap25(afb(a322), bfc));
var zipLeft25 = /* @__PURE__ */ dual25(2, (self2, that) => tap25(self2, () => that));
var tap25 = /* @__PURE__ */ dual25(2, (self2, f322) => flatMap25(self2, (a322) => map25(f322(a322), () => a322)));
var product225 = (self2, that) => isSome225(self2) && isSome225(that) ? some325([self2.value, that.value]) : none225();
var productMany225 = (self2, collection) => {
  if (isNone225(self2)) {
    return none225();
  }
  const out = [self2.value];
  for (const o322 of collection) {
    if (isNone225(o322)) {
      return none225();
    }
    out.push(o322.value);
  }
  return some325(out);
};
var all225 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o322 of input) {
      if (isNone225(o322)) {
        return none225();
      }
      out2.push(o322.value);
    }
    return some325(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o322 = input[key];
    if (isNone225(o322)) {
      return none225();
    }
    out[key] = o322.value;
  }
  return some325(out);
};
var zipWith25 = /* @__PURE__ */ dual25(3, (self2, that, f322) => map25(product225(self2, that), ([a322, b322]) => f322(a322, b322)));
var ap25 = /* @__PURE__ */ dual25(2, (self2, that) => zipWith25(self2, that, (f322, a322) => f322(a322)));
var reduceCompact25 = /* @__PURE__ */ dual25(3, (self2, b322, f322) => {
  let out = b322;
  for (const oa of self2) {
    if (isSome225(oa)) {
      out = f322(out, oa.value);
    }
  }
  return out;
});
var toArray25 = (self2) => isNone225(self2) ? [] : [self2.value];
var partitionMap25 = /* @__PURE__ */ dual25(2, (self2, f322) => {
  if (isNone225(self2)) {
    return [none225(), none225()];
  }
  const e322 = f322(self2.value);
  return isLeft25(e322) ? [some325(e322.left), none225()] : [none225(), some325(e322.right)];
});
var filterMap25 = /* @__PURE__ */ dual25(2, (self2, f322) => isNone225(self2) ? none225() : f322(self2.value));
var filter25 = /* @__PURE__ */ dual25(2, (self2, predicate) => filterMap25(self2, (b322) => predicate(b322) ? some225(b322) : none35));
var getEquivalence33 = (isEquivalent) => make63((x322, y322) => x322 === y322 || (isNone225(x322) ? isNone225(y322) : isNone225(y322) ? false : isEquivalent(x322.value, y322.value)));
var getOrder25 = (O322) => make225((self2, that) => isSome225(self2) ? isSome225(that) ? O322(self2.value, that.value) : 1 : -1);
var lift225 = (f322) => dual25(2, (self2, that) => zipWith25(self2, that, f322));
var liftPredicate25 = (predicate) => (b322) => predicate(b322) ? some325(b322) : none225();
var containsWith25 = (isEquivalent) => dual25(2, (self2, a322) => isNone225(self2) ? false : isEquivalent(self2.value, a322));
var _equivalence33 = /* @__PURE__ */ equivalence25();
var contains25 = /* @__PURE__ */ containsWith25(_equivalence33);
var exists25 = /* @__PURE__ */ dual25(2, (self2, refinement) => isNone225(self2) ? false : refinement(self2.value));
var bindTo225 = /* @__PURE__ */ bindTo35(map25);
var let_225 = /* @__PURE__ */ let_35(map25);
var bind225 = /* @__PURE__ */ bind35(map25, flatMap25);
var Do25 = /* @__PURE__ */ some325({});
var adapter225 = /* @__PURE__ */ adapter35();
var gen25 = (f322) => {
  const iterator = f322(adapter225);
  let state = iterator.next();
  if (state.done) {
    return some325(state.value);
  } else {
    let current = state.value;
    if (isGenKind25(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet25(current);
    }
    if (isNone225(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind25(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet25(current);
        }
        if (isNone225(current)) {
          return current;
        }
      }
    }
    return some325(state.value);
  }
};
var fromIterable225 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var reverse33 = (self2) => Array.from(self2).reverse();
var reduce33 = /* @__PURE__ */ dual25(3, (self2, b322, f322) => fromIterable225(self2).reduce((b2222, a322, i322) => f322(b2222, a322, i322), b322));
var TagTypeId23 = /* @__PURE__ */ Symbol.for("effect/Context/Tag");
var STMSymbolKey23 = "effect/STM";
var STMTypeId23 = /* @__PURE__ */ Symbol.for(STMSymbolKey23);
var TagProto23 = {
  ...EffectPrototype25,
  _tag: "Tag",
  _op: "Tag",
  [STMTypeId23]: effectVariance25,
  [TagTypeId23]: {
    _Service: (_322) => _322,
    _Identifier: (_322) => _322
  },
  toString() {
    return format25(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Tag",
      key: this.key,
      stack: this.stack
    };
  },
  [NodeInspectSymbol25]() {
    return this.toJSON();
  },
  of(self2) {
    return self2;
  },
  context(self2) {
    return make325(this, self2);
  }
};
var makeGenericTag23 = (key) => {
  const limit = Error.stackTraceLimit;
  Error.stackTraceLimit = 2;
  const creationError = new Error();
  Error.stackTraceLimit = limit;
  const tag = Object.create(TagProto23);
  Object.defineProperty(tag, "stack", {
    get() {
      return creationError.stack;
    }
  });
  tag.key = key;
  return tag;
};
var TypeId425 = /* @__PURE__ */ Symbol.for("effect/Context");
var ContextProto23 = {
  [TypeId425]: {
    _Services: (_322) => _322
  },
  [symbol225](that) {
    if (isContext23(that)) {
      if (this.unsafeMap.size === that.unsafeMap.size) {
        for (const k322 of this.unsafeMap.keys()) {
          if (!that.unsafeMap.has(k322) || !equals25(this.unsafeMap.get(k322), that.unsafeMap.get(k322))) {
            return false;
          }
        }
        return true;
      }
    }
    return false;
  },
  [symbol35]() {
    return cached25(this, number25(this.unsafeMap.size));
  },
  pipe() {
    return pipeArguments25(this, arguments);
  },
  toString() {
    return format25(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Context",
      services: Array.from(this.unsafeMap).map(toJSON25)
    };
  },
  [NodeInspectSymbol25]() {
    return this.toJSON();
  }
};
var makeContext23 = (unsafeMap) => {
  const context = Object.create(ContextProto23);
  context.unsafeMap = unsafeMap;
  return context;
};
var isContext23 = (u322) => hasProperty25(u322, TypeId425);
var _empty63 = /* @__PURE__ */ makeContext23(/* @__PURE__ */ new Map());
var empty83 = () => _empty63;
var make325 = (tag, service) => makeContext23(/* @__PURE__ */ new Map([[tag.key, service]]));
var GenericTag23 = makeGenericTag23;
var empty223 = empty83;
var TypeId525 = /* @__PURE__ */ Symbol.for("effect/Chunk");
function copy23(src, srcPos, dest, destPos, len) {
  for (let i322 = srcPos; i322 < Math.min(src.length, srcPos + len); i322++) {
    dest[destPos + i322 - srcPos] = src[i322];
  }
  return dest;
}
var emptyArray23 = [];
var getEquivalence225 = (isEquivalent) => make63((self2, that) => self2.length === that.length && toReadonlyArray23(self2).every((value, i322) => isEquivalent(value, unsafeGet223(that, i322))));
var _equivalence225 = /* @__PURE__ */ getEquivalence225(equals25);
var ChunkProto23 = {
  [TypeId525]: {
    _A: (_322) => _322
  },
  toString() {
    return format25(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Chunk",
      values: toReadonlyArray23(this).map(toJSON25)
    };
  },
  [NodeInspectSymbol25]() {
    return this.toJSON();
  },
  [symbol225](that) {
    return isChunk23(that) && _equivalence225(this, that);
  },
  [symbol35]() {
    return cached25(this, array33(toReadonlyArray23(this)));
  },
  [Symbol.iterator]() {
    switch (this.backing._tag) {
      case "IArray": {
        return this.backing.array[Symbol.iterator]();
      }
      case "IEmpty": {
        return emptyArray23[Symbol.iterator]();
      }
      default: {
        return toReadonlyArray23(this)[Symbol.iterator]();
      }
    }
  },
  pipe() {
    return pipeArguments25(this, arguments);
  }
};
var makeChunk23 = (backing) => {
  const chunk = Object.create(ChunkProto23);
  chunk.backing = backing;
  switch (backing._tag) {
    case "IEmpty": {
      chunk.length = 0;
      chunk.depth = 0;
      chunk.left = chunk;
      chunk.right = chunk;
      break;
    }
    case "IConcat": {
      chunk.length = backing.left.length + backing.right.length;
      chunk.depth = 1 + Math.max(backing.left.depth, backing.right.depth);
      chunk.left = backing.left;
      chunk.right = backing.right;
      break;
    }
    case "IArray": {
      chunk.length = backing.array.length;
      chunk.depth = 0;
      chunk.left = _empty223;
      chunk.right = _empty223;
      break;
    }
    case "ISingleton": {
      chunk.length = 1;
      chunk.depth = 0;
      chunk.left = _empty223;
      chunk.right = _empty223;
      break;
    }
    case "ISlice": {
      chunk.length = backing.length;
      chunk.depth = backing.chunk.depth + 1;
      chunk.left = _empty223;
      chunk.right = _empty223;
      break;
    }
  }
  return chunk;
};
var isChunk23 = (u322) => hasProperty25(u322, TypeId525);
var _empty223 = /* @__PURE__ */ makeChunk23({
  _tag: "IEmpty"
});
var empty323 = () => _empty223;
var make425 = (...as2422) => as2422.length === 1 ? of23(as2422[0]) : unsafeFromNonEmptyArray23(as2422);
var of23 = (a322) => makeChunk23({
  _tag: "ISingleton",
  a: a322
});
var copyToArray23 = (self2, array3322, initial) => {
  switch (self2.backing._tag) {
    case "IArray": {
      copy23(self2.backing.array, 0, array3322, initial, self2.length);
      break;
    }
    case "IConcat": {
      copyToArray23(self2.left, array3322, initial);
      copyToArray23(self2.right, array3322, initial + self2.left.length);
      break;
    }
    case "ISingleton": {
      array3322[initial] = self2.backing.a;
      break;
    }
    case "ISlice": {
      let i322 = 0;
      let j322 = initial;
      while (i322 < self2.length) {
        array3322[j322] = unsafeGet223(self2, i322);
        i322 += 1;
        j322 += 1;
      }
      break;
    }
  }
};
var toReadonlyArray23 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      return emptyArray23;
    }
    case "IArray": {
      return self2.backing.array;
    }
    default: {
      const arr = new Array(self2.length);
      copyToArray23(self2, arr, 0);
      self2.backing = {
        _tag: "IArray",
        array: arr
      };
      self2.left = _empty223;
      self2.right = _empty223;
      self2.depth = 0;
      return arr;
    }
  }
};
var reverse223 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty":
    case "ISingleton":
      return self2;
    case "IArray": {
      return makeChunk23({
        _tag: "IArray",
        array: reverse33(self2.backing.array)
      });
    }
    case "IConcat": {
      return makeChunk23({
        _tag: "IConcat",
        left: reverse223(self2.backing.right),
        right: reverse223(self2.backing.left)
      });
    }
    case "ISlice":
      return unsafeFromArray23(reverse33(toReadonlyArray23(self2)));
  }
};
var unsafeFromArray23 = (self2) => makeChunk23({
  _tag: "IArray",
  array: self2
});
var unsafeFromNonEmptyArray23 = (self2) => unsafeFromArray23(self2);
var unsafeGet223 = /* @__PURE__ */ dual25(2, (self2, index) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      throw new Error(`Index out of bounds`);
    }
    case "ISingleton": {
      if (index !== 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.a;
    }
    case "IArray": {
      if (index >= self2.length || index < 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.array[index];
    }
    case "IConcat": {
      return index < self2.left.length ? unsafeGet223(self2.left, index) : unsafeGet223(self2.right, index - self2.left.length);
    }
    case "ISlice": {
      return unsafeGet223(self2.backing.chunk, index + self2.backing.offset);
    }
  }
});
var prepend23 = /* @__PURE__ */ dual25(2, (self2, elem) => appendAll23(of23(elem), self2));
var drop23 = /* @__PURE__ */ dual25(2, (self2, n322) => {
  if (n322 <= 0) {
    return self2;
  } else if (n322 >= self2.length) {
    return _empty223;
  } else {
    switch (self2.backing._tag) {
      case "ISlice": {
        return makeChunk23({
          _tag: "ISlice",
          chunk: self2.backing.chunk,
          offset: self2.backing.offset + n322,
          length: self2.backing.length - n322
        });
      }
      case "IConcat": {
        if (n322 > self2.left.length) {
          return drop23(self2.right, n322 - self2.left.length);
        }
        return makeChunk23({
          _tag: "IConcat",
          left: drop23(self2.left, n322),
          right: self2.right
        });
      }
      default: {
        return makeChunk23({
          _tag: "ISlice",
          chunk: self2,
          offset: n322,
          length: self2.length - n322
        });
      }
    }
  }
});
var appendAll23 = /* @__PURE__ */ dual25(2, (self2, that) => {
  if (self2.backing._tag === "IEmpty") {
    return that;
  }
  if (that.backing._tag === "IEmpty") {
    return self2;
  }
  const diff2322 = that.depth - self2.depth;
  if (Math.abs(diff2322) <= 1) {
    return makeChunk23({
      _tag: "IConcat",
      left: self2,
      right: that
    });
  } else if (diff2322 < -1) {
    if (self2.left.depth >= self2.right.depth) {
      const nr = appendAll23(self2.right, that);
      return makeChunk23({
        _tag: "IConcat",
        left: self2.left,
        right: nr
      });
    } else {
      const nrr = appendAll23(self2.right.right, that);
      if (nrr.depth === self2.depth - 3) {
        const nr = makeChunk23({
          _tag: "IConcat",
          left: self2.right.left,
          right: nrr
        });
        return makeChunk23({
          _tag: "IConcat",
          left: self2.left,
          right: nr
        });
      } else {
        const nl = makeChunk23({
          _tag: "IConcat",
          left: self2.left,
          right: self2.right.left
        });
        return makeChunk23({
          _tag: "IConcat",
          left: nl,
          right: nrr
        });
      }
    }
  } else {
    if (that.right.depth >= that.left.depth) {
      const nl = appendAll23(self2, that.left);
      return makeChunk23({
        _tag: "IConcat",
        left: nl,
        right: that.right
      });
    } else {
      const nll = appendAll23(self2, that.left.left);
      if (nll.depth === that.depth - 3) {
        const nl = makeChunk23({
          _tag: "IConcat",
          left: nll,
          right: that.left.right
        });
        return makeChunk23({
          _tag: "IConcat",
          left: nl,
          right: that.right
        });
      } else {
        const nr = makeChunk23({
          _tag: "IConcat",
          left: that.left.right,
          right: that.right
        });
        return makeChunk23({
          _tag: "IConcat",
          left: nll,
          right: nr
        });
      }
    }
  }
});
var isEmpty23 = (self2) => self2.length === 0;
var isNonEmpty23 = (self2) => self2.length > 0;
var unsafeHead23 = (self2) => unsafeGet223(self2, 0);
var headNonEmpty23 = unsafeHead23;
var tailNonEmpty23 = (self2) => drop23(self2, 1);
var SIZE23 = 5;
var BUCKET_SIZE23 = /* @__PURE__ */ Math.pow(2, SIZE23);
var MASK23 = BUCKET_SIZE23 - 1;
var MAX_INDEX_NODE23 = BUCKET_SIZE23 / 2;
var MIN_ARRAY_NODE23 = BUCKET_SIZE23 / 4;
function popcount23(x322) {
  x322 -= x322 >> 1 & 1431655765;
  x322 = (x322 & 858993459) + (x322 >> 2 & 858993459);
  x322 = x322 + (x322 >> 4) & 252645135;
  x322 += x322 >> 8;
  x322 += x322 >> 16;
  return x322 & 127;
}
function hashFragment23(shift22, h322) {
  return h322 >>> shift22 & MASK23;
}
function toBitmap23(x322) {
  return 1 << x322;
}
function fromBitmap23(bitmap, bit) {
  return popcount23(bitmap & bit - 1);
}
var make523 = (value, previous) => ({
  value,
  previous
});
function arrayUpdate23(mutate2322, at, v322, arr) {
  let out = arr;
  if (!mutate2322) {
    const len = arr.length;
    out = new Array(len);
    for (let i322 = 0; i322 < len; ++i322) out[i322] = arr[i322];
  }
  out[at] = v322;
  return out;
}
function arraySpliceOut23(mutate2322, at, arr) {
  const newLen = arr.length - 1;
  let i322 = 0;
  let g322 = 0;
  let out = arr;
  if (mutate2322) {
    i322 = g322 = at;
  } else {
    out = new Array(newLen);
    while (i322 < at) out[g322++] = arr[i322++];
  }
  ++i322;
  while (i322 <= newLen) out[g322++] = arr[i322++];
  if (mutate2322) {
    out.length = newLen;
  }
  return out;
}
function arraySpliceIn23(mutate2322, at, v322, arr) {
  const len = arr.length;
  if (mutate2322) {
    let i2222 = len;
    while (i2222 >= at) arr[i2222--] = arr[i2222];
    arr[at] = v322;
    return arr;
  }
  let i322 = 0, g322 = 0;
  const out = new Array(len + 1);
  while (i322 < at) out[g322++] = arr[i322++];
  out[at] = v322;
  while (i322 < len) out[++g322] = arr[i322++];
  return out;
}
var EmptyNode23 = class _EmptyNode23 {
  _tag = "EmptyNode";
  modify(edit, _shift, f322, hash2422, key, size4322) {
    const v322 = f322(none225());
    if (isNone225(v322)) return new _EmptyNode23();
    ++size4322.value;
    return new LeafNode23(edit, hash2422, key, v322);
  }
};
function isEmptyNode23(a322) {
  return isTagged23(a322, "EmptyNode");
}
function isLeafNode23(node) {
  return isEmptyNode23(node) || node._tag === "LeafNode" || node._tag === "CollisionNode";
}
function canEditNode23(node, edit) {
  return isEmptyNode23(node) ? false : edit === node.edit;
}
var LeafNode23 = class _LeafNode23 {
  edit;
  hash;
  key;
  value;
  _tag = "LeafNode";
  constructor(edit, hash2422, key, value) {
    this.edit = edit;
    this.hash = hash2422;
    this.key = key;
    this.value = value;
  }
  modify(edit, shift22, f322, hash2422, key, size4322) {
    if (equals25(key, this.key)) {
      const v2222 = f322(this.value);
      if (v2222 === this.value) return this;
      else if (isNone225(v2222)) {
        --size4322.value;
        return new EmptyNode23();
      }
      if (canEditNode23(this, edit)) {
        this.value = v2222;
        return this;
      }
      return new _LeafNode23(edit, hash2422, key, v2222);
    }
    const v322 = f322(none225());
    if (isNone225(v322)) return this;
    ++size4322.value;
    return mergeLeaves23(edit, shift22, this.hash, this, hash2422, new _LeafNode23(edit, hash2422, key, v322));
  }
};
var CollisionNode23 = class _CollisionNode23 {
  edit;
  hash;
  children;
  _tag = "CollisionNode";
  constructor(edit, hash2422, children) {
    this.edit = edit;
    this.hash = hash2422;
    this.children = children;
  }
  modify(edit, shift22, f322, hash2422, key, size4322) {
    if (hash2422 === this.hash) {
      const canEdit = canEditNode23(this, edit);
      const list = this.updateCollisionList(canEdit, edit, this.hash, this.children, f322, key, size4322);
      if (list === this.children) return this;
      return list.length > 1 ? new _CollisionNode23(edit, this.hash, list) : list[0];
    }
    const v322 = f322(none225());
    if (isNone225(v322)) return this;
    ++size4322.value;
    return mergeLeaves23(edit, shift22, this.hash, this, hash2422, new LeafNode23(edit, hash2422, key, v322));
  }
  updateCollisionList(mutate2322, edit, hash2422, list, f322, key, size4322) {
    const len = list.length;
    for (let i322 = 0; i322 < len; ++i322) {
      const child = list[i322];
      if ("key" in child && equals25(key, child.key)) {
        const value = child.value;
        const newValue2 = f322(value);
        if (newValue2 === value) return list;
        if (isNone225(newValue2)) {
          --size4322.value;
          return arraySpliceOut23(mutate2322, i322, list);
        }
        return arrayUpdate23(mutate2322, i322, new LeafNode23(edit, hash2422, key, newValue2), list);
      }
    }
    const newValue = f322(none225());
    if (isNone225(newValue)) return list;
    ++size4322.value;
    return arrayUpdate23(mutate2322, len, new LeafNode23(edit, hash2422, key, newValue), list);
  }
};
var IndexedNode23 = class _IndexedNode23 {
  edit;
  mask;
  children;
  _tag = "IndexedNode";
  constructor(edit, mask, children) {
    this.edit = edit;
    this.mask = mask;
    this.children = children;
  }
  modify(edit, shift22, f322, hash2422, key, size4322) {
    const mask = this.mask;
    const children = this.children;
    const frag = hashFragment23(shift22, hash2422);
    const bit = toBitmap23(frag);
    const indx = fromBitmap23(mask, bit);
    const exists2422 = mask & bit;
    const canEdit = canEditNode23(this, edit);
    if (!exists2422) {
      const _newChild = new EmptyNode23().modify(edit, shift22 + SIZE23, f322, hash2422, key, size4322);
      if (!_newChild) return this;
      return children.length >= MAX_INDEX_NODE23 ? expand23(edit, frag, _newChild, mask, children) : new _IndexedNode23(edit, mask | bit, arraySpliceIn23(canEdit, indx, _newChild, children));
    }
    const current = children[indx];
    const child = current.modify(edit, shift22 + SIZE23, f322, hash2422, key, size4322);
    if (current === child) return this;
    let bitmap = mask;
    let newChildren;
    if (isEmptyNode23(child)) {
      bitmap &= ~bit;
      if (!bitmap) return new EmptyNode23();
      if (children.length <= 2 && isLeafNode23(children[indx ^ 1])) {
        return children[indx ^ 1];
      }
      newChildren = arraySpliceOut23(canEdit, indx, children);
    } else {
      newChildren = arrayUpdate23(canEdit, indx, child, children);
    }
    if (canEdit) {
      this.mask = bitmap;
      this.children = newChildren;
      return this;
    }
    return new _IndexedNode23(edit, bitmap, newChildren);
  }
};
var ArrayNode23 = class _ArrayNode23 {
  edit;
  size;
  children;
  _tag = "ArrayNode";
  constructor(edit, size4322, children) {
    this.edit = edit;
    this.size = size4322;
    this.children = children;
  }
  modify(edit, shift22, f322, hash2422, key, size4322) {
    let count = this.size;
    const children = this.children;
    const frag = hashFragment23(shift22, hash2422);
    const child = children[frag];
    const newChild = (child || new EmptyNode23()).modify(edit, shift22 + SIZE23, f322, hash2422, key, size4322);
    if (child === newChild) return this;
    const canEdit = canEditNode23(this, edit);
    let newChildren;
    if (isEmptyNode23(child) && !isEmptyNode23(newChild)) {
      ++count;
      newChildren = arrayUpdate23(canEdit, frag, newChild, children);
    } else if (!isEmptyNode23(child) && isEmptyNode23(newChild)) {
      --count;
      if (count <= MIN_ARRAY_NODE23) {
        return pack23(edit, count, frag, children);
      }
      newChildren = arrayUpdate23(canEdit, frag, new EmptyNode23(), children);
    } else {
      newChildren = arrayUpdate23(canEdit, frag, newChild, children);
    }
    if (canEdit) {
      this.size = count;
      this.children = newChildren;
      return this;
    }
    return new _ArrayNode23(edit, count, newChildren);
  }
};
function pack23(edit, count, removed, elements) {
  const children = new Array(count - 1);
  let g322 = 0;
  let bitmap = 0;
  for (let i322 = 0, len = elements.length; i322 < len; ++i322) {
    if (i322 !== removed) {
      const elem = elements[i322];
      if (elem && !isEmptyNode23(elem)) {
        children[g322++] = elem;
        bitmap |= 1 << i322;
      }
    }
  }
  return new IndexedNode23(edit, bitmap, children);
}
function expand23(edit, frag, child, bitmap, subNodes) {
  const arr = [];
  let bit = bitmap;
  let count = 0;
  for (let i322 = 0; bit; ++i322) {
    if (bit & 1) arr[i322] = subNodes[count++];
    bit >>>= 1;
  }
  arr[frag] = child;
  return new ArrayNode23(edit, count + 1, arr);
}
function mergeLeavesInner23(edit, shift22, h1, n1, h2222, n2222) {
  if (h1 === h2222) return new CollisionNode23(edit, h1, [n2222, n1]);
  const subH1 = hashFragment23(shift22, h1);
  const subH2 = hashFragment23(shift22, h2222);
  if (subH1 === subH2) {
    return (child) => new IndexedNode23(edit, toBitmap23(subH1) | toBitmap23(subH2), [child]);
  } else {
    const children = subH1 < subH2 ? [n1, n2222] : [n2222, n1];
    return new IndexedNode23(edit, toBitmap23(subH1) | toBitmap23(subH2), children);
  }
}
function mergeLeaves23(edit, shift22, h1, n1, h2222, n2222) {
  let stack = void 0;
  let currentShift = shift22;
  while (true) {
    const res = mergeLeavesInner23(edit, currentShift, h1, n1, h2222, n2222);
    if (typeof res === "function") {
      stack = make523(res, stack);
      currentShift = currentShift + SIZE23;
    } else {
      let final = res;
      while (stack != null) {
        final = stack.value(final);
        stack = stack.previous;
      }
      return final;
    }
  }
}
var HashMapSymbolKey23 = "effect/HashMap";
var HashMapTypeId23 = /* @__PURE__ */ Symbol.for(HashMapSymbolKey23);
var HashMapProto23 = {
  [HashMapTypeId23]: HashMapTypeId23,
  [Symbol.iterator]() {
    return new HashMapIterator23(this, (k322, v322) => [k322, v322]);
  },
  [symbol35]() {
    let hash2422 = hash25(HashMapSymbolKey23);
    for (const item of this) {
      hash2422 ^= pipe25(hash25(item[0]), combine33(hash25(item[1])));
    }
    return cached25(this, hash2422);
  },
  [symbol225](that) {
    if (isHashMap23(that)) {
      if (that._size !== this._size) {
        return false;
      }
      for (const item of this) {
        const elem = pipe25(that, getHash23(item[0], hash25(item[0])));
        if (isNone225(elem)) {
          return false;
        } else {
          if (!equals25(item[1], elem.value)) {
            return false;
          }
        }
      }
      return true;
    }
    return false;
  },
  toString() {
    return format25(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashMap",
      values: Array.from(this).map(toJSON25)
    };
  },
  [NodeInspectSymbol25]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments25(this, arguments);
  }
};
var makeImpl33 = (editable, edit, root, size4322) => {
  const map622 = Object.create(HashMapProto23);
  map622._editable = editable;
  map622._edit = edit;
  map622._root = root;
  map622._size = size4322;
  return map622;
};
var HashMapIterator23 = class _HashMapIterator23 {
  map;
  f;
  v;
  constructor(map622, f322) {
    this.map = map622;
    this.f = f322;
    this.v = visitLazy23(this.map._root, this.f, void 0);
  }
  next() {
    if (isNone225(this.v)) {
      return {
        done: true,
        value: void 0
      };
    }
    const v0 = this.v.value;
    this.v = applyCont23(v0.cont);
    return {
      done: false,
      value: v0.value
    };
  }
  [Symbol.iterator]() {
    return new _HashMapIterator23(this.map, this.f);
  }
};
var applyCont23 = (cont) => cont ? visitLazyChildren23(cont[0], cont[1], cont[2], cont[3], cont[4]) : none225();
var visitLazy23 = (node, f322, cont = void 0) => {
  switch (node._tag) {
    case "LeafNode": {
      if (isSome225(node.value)) {
        return some325({
          value: f322(node.key, node.value.value),
          cont
        });
      }
      return applyCont23(cont);
    }
    case "CollisionNode":
    case "ArrayNode":
    case "IndexedNode": {
      const children = node.children;
      return visitLazyChildren23(children.length, children, 0, f322, cont);
    }
    default: {
      return applyCont23(cont);
    }
  }
};
var visitLazyChildren23 = (len, children, i322, f322, cont) => {
  while (i322 < len) {
    const child = children[i322++];
    if (child && !isEmptyNode23(child)) {
      return visitLazy23(child, f322, [len, children, i322, f322, cont]);
    }
  }
  return applyCont23(cont);
};
var _empty323 = /* @__PURE__ */ makeImpl33(false, 0, /* @__PURE__ */ new EmptyNode23(), 0);
var empty423 = () => _empty323;
var isHashMap23 = (u322) => hasProperty25(u322, HashMapTypeId23);
var getHash23 = /* @__PURE__ */ dual25(3, (self2, key, hash2422) => {
  let node = self2._root;
  let shift22 = 0;
  while (true) {
    switch (node._tag) {
      case "LeafNode": {
        return equals25(key, node.key) ? node.value : none225();
      }
      case "CollisionNode": {
        if (hash2422 === node.hash) {
          const children = node.children;
          for (let i322 = 0, len = children.length; i322 < len; ++i322) {
            const child = children[i322];
            if ("key" in child && equals25(key, child.key)) {
              return child.value;
            }
          }
        }
        return none225();
      }
      case "IndexedNode": {
        const frag = hashFragment23(shift22, hash2422);
        const bit = toBitmap23(frag);
        if (node.mask & bit) {
          node = node.children[fromBitmap23(node.mask, bit)];
          shift22 += SIZE23;
          break;
        }
        return none225();
      }
      case "ArrayNode": {
        node = node.children[hashFragment23(shift22, hash2422)];
        if (node) {
          shift22 += SIZE23;
          break;
        }
        return none225();
      }
      default:
        return none225();
    }
  }
});
var set25 = /* @__PURE__ */ dual25(3, (self2, key, value) => modifyAt23(self2, key, () => some325(value)));
var setTree23 = /* @__PURE__ */ dual25(3, (self2, newRoot, newSize) => {
  if (self2._editable) {
    self2._root = newRoot;
    self2._size = newSize;
    return self2;
  }
  return newRoot === self2._root ? self2 : makeImpl33(self2._editable, self2._edit, newRoot, newSize);
});
var keys23 = (self2) => new HashMapIterator23(self2, (key) => key);
var size43 = (self2) => self2._size;
var beginMutation33 = (self2) => makeImpl33(true, self2._edit + 1, self2._root, self2._size);
var modifyAt23 = /* @__PURE__ */ dual25(3, (self2, key, f322) => modifyHash23(self2, key, hash25(key), f322));
var modifyHash23 = /* @__PURE__ */ dual25(4, (self2, key, hash2422, f322) => {
  const size4322 = {
    value: self2._size
  };
  const newRoot = self2._root.modify(self2._editable ? self2._edit : NaN, 0, f322, hash2422, key, size4322);
  return pipe25(self2, setTree23(newRoot, size4322.value));
});
var forEach33 = /* @__PURE__ */ dual25(2, (self2, f322) => reduce223(self2, void 0, (_322, value, key) => f322(value, key)));
var reduce223 = /* @__PURE__ */ dual25(3, (self2, zero, f322) => {
  const root = self2._root;
  if (root._tag === "LeafNode") {
    return isSome225(root.value) ? f322(zero, root.value.value, root.key) : zero;
  }
  if (root._tag === "EmptyNode") {
    return zero;
  }
  const toVisit = [root.children];
  let children;
  while (children = toVisit.pop()) {
    for (let i322 = 0, len = children.length; i322 < len; ) {
      const child = children[i322++];
      if (child && !isEmptyNode23(child)) {
        if (child._tag === "LeafNode") {
          if (isSome225(child.value)) {
            zero = f322(zero, child.value.value, child.key);
          }
        } else {
          toVisit.push(child.children);
        }
      }
    }
  }
  return zero;
});
var HashSetSymbolKey23 = "effect/HashSet";
var HashSetTypeId23 = /* @__PURE__ */ Symbol.for(HashSetSymbolKey23);
var HashSetProto23 = {
  [HashSetTypeId23]: HashSetTypeId23,
  [Symbol.iterator]() {
    return keys23(this._keyMap);
  },
  [symbol35]() {
    return cached25(this, combine33(hash25(this._keyMap))(hash25(HashSetSymbolKey23)));
  },
  [symbol225](that) {
    if (isHashSet23(that)) {
      return size43(this._keyMap) === size43(that._keyMap) && equals25(this._keyMap, that._keyMap);
    }
    return false;
  },
  toString() {
    return format25(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashSet",
      values: Array.from(this).map(toJSON25)
    };
  },
  [NodeInspectSymbol25]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments25(this, arguments);
  }
};
var makeImpl223 = (keyMap) => {
  const set2422 = Object.create(HashSetProto23);
  set2422._keyMap = keyMap;
  return set2422;
};
var isHashSet23 = (u322) => hasProperty25(u322, HashSetTypeId23);
var _empty423 = /* @__PURE__ */ makeImpl223(/* @__PURE__ */ empty423());
var empty523 = () => _empty423;
var size223 = (self2) => size43(self2._keyMap);
var beginMutation223 = (self2) => makeImpl223(beginMutation33(self2._keyMap));
var endMutation23 = (self2) => {
  self2._keyMap._editable = false;
  return self2;
};
var mutate23 = /* @__PURE__ */ dual25(2, (self2, f322) => {
  const transient = beginMutation223(self2);
  f322(transient);
  return endMutation23(transient);
});
var add223 = /* @__PURE__ */ dual25(2, (self2, value) => self2._keyMap._editable ? (set25(value, true)(self2._keyMap), self2) : makeImpl223(set25(value, true)(self2._keyMap)));
var union223 = /* @__PURE__ */ dual25(2, (self2, that) => mutate23(empty523(), (set2422) => {
  forEach223(self2, (value) => add223(set2422, value));
  for (const value of that) {
    add223(set2422, value);
  }
}));
var forEach223 = /* @__PURE__ */ dual25(2, (self2, f322) => forEach33(self2._keyMap, (_322, k322) => f322(k322)));
var empty623 = empty523;
var size323 = size223;
var add323 = add223;
var union323 = union223;
var ArrayProto23 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(Array.prototype), {
  [symbol35]() {
    return cached25(this, array33(this));
  },
  [symbol225](that) {
    if (Array.isArray(that) && this.length === that.length) {
      return this.every((v322, i322) => equals25(v322, that[i322]));
    } else {
      return false;
    }
  }
});
var Structural33 = /* @__PURE__ */ function() {
  function Structural3322(args) {
    if (args) {
      Object.assign(this, args);
    }
  }
  Structural3322.prototype = StructuralPrototype25;
  return Structural3322;
}();
var struct223 = (as2422) => Object.assign(Object.create(StructuralPrototype25), as2422);
var ContextPatchTypeId23 = /* @__PURE__ */ Symbol.for("effect/DifferContextPatch");
function variance33(a322) {
  return a322;
}
var PatchProto23 = {
  ...Structural33.prototype,
  [ContextPatchTypeId23]: {
    _Value: variance33,
    _Patch: variance33
  }
};
var EmptyProto23 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto23), {
  _tag: "Empty"
});
var _empty523 = /* @__PURE__ */ Object.create(EmptyProto23);
var empty723 = () => _empty523;
var AndThenProto23 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto23), {
  _tag: "AndThen"
});
var makeAndThen23 = (first, second) => {
  const o322 = Object.create(AndThenProto23);
  o322.first = first;
  o322.second = second;
  return o322;
};
var AddServiceProto23 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto23), {
  _tag: "AddService"
});
var makeAddService23 = (key, service) => {
  const o322 = Object.create(AddServiceProto23);
  o322.key = key;
  o322.service = service;
  return o322;
};
var RemoveServiceProto23 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto23), {
  _tag: "RemoveService"
});
var makeRemoveService23 = (key) => {
  const o322 = Object.create(RemoveServiceProto23);
  o322.key = key;
  return o322;
};
var UpdateServiceProto23 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto23), {
  _tag: "UpdateService"
});
var makeUpdateService23 = (key, update222) => {
  const o322 = Object.create(UpdateServiceProto23);
  o322.key = key;
  o322.update = update222;
  return o322;
};
var diff23 = (oldValue, newValue) => {
  const missingServices = new Map(oldValue.unsafeMap);
  let patch2322 = empty723();
  for (const [tag, newService] of newValue.unsafeMap.entries()) {
    if (missingServices.has(tag)) {
      const old = missingServices.get(tag);
      missingServices.delete(tag);
      if (!equals25(old, newService)) {
        patch2322 = combine225(makeUpdateService23(tag, () => newService))(patch2322);
      }
    } else {
      missingServices.delete(tag);
      patch2322 = combine225(makeAddService23(tag, newService))(patch2322);
    }
  }
  for (const [tag] of missingServices.entries()) {
    patch2322 = combine225(makeRemoveService23(tag))(patch2322);
  }
  return patch2322;
};
var combine225 = /* @__PURE__ */ dual25(2, (self2, that) => makeAndThen23(self2, that));
var patch23 = /* @__PURE__ */ dual25(2, (self2, context) => {
  if (self2._tag === "Empty") {
    return context;
  }
  let wasServiceUpdated = false;
  let patches = of23(self2);
  const updatedContext = new Map(context.unsafeMap);
  while (isNonEmpty23(patches)) {
    const head222 = headNonEmpty23(patches);
    const tail322 = tailNonEmpty23(patches);
    switch (head222._tag) {
      case "Empty": {
        patches = tail322;
        break;
      }
      case "AddService": {
        updatedContext.set(head222.key, head222.service);
        patches = tail322;
        break;
      }
      case "AndThen": {
        patches = prepend23(prepend23(tail322, head222.second), head222.first);
        break;
      }
      case "RemoveService": {
        updatedContext.delete(head222.key);
        patches = tail322;
        break;
      }
      case "UpdateService": {
        updatedContext.set(head222.key, head222.update(updatedContext.get(head222.key)));
        wasServiceUpdated = true;
        patches = tail322;
        break;
      }
    }
  }
  if (!wasServiceUpdated) {
    return makeContext23(updatedContext);
  }
  const map622 = /* @__PURE__ */ new Map();
  for (const [tag] of context.unsafeMap) {
    if (updatedContext.has(tag)) {
      map622.set(tag, updatedContext.get(tag));
      updatedContext.delete(tag);
    }
  }
  for (const [tag, s322] of updatedContext) {
    map622.set(tag, s322);
  }
  return makeContext23(map622);
});
var DifferTypeId23 = /* @__PURE__ */ Symbol.for("effect/Differ");
var DifferProto23 = {
  [DifferTypeId23]: {
    _P: identity25,
    _V: identity25
  }
};
var make723 = (params) => {
  const differ = Object.create(DifferProto23);
  differ.empty = params.empty;
  differ.diff = params.diff;
  differ.combine = params.combine;
  differ.patch = params.patch;
  return differ;
};
var environment23 = () => make723({
  empty: empty723(),
  combine: (first, second) => combine225(second)(first),
  diff: (oldValue, newValue) => diff23(oldValue, newValue),
  patch: (patch2322, oldValue) => patch23(oldValue)(patch2322)
});
var OP_DIE23 = "Die";
var OP_EMPTY23 = "Empty";
var OP_FAIL23 = "Fail";
var OP_INTERRUPT23 = "Interrupt";
var OP_PARALLEL23 = "Parallel";
var OP_SEQUENTIAL23 = "Sequential";
var CauseSymbolKey23 = "effect/Cause";
var CauseTypeId23 = /* @__PURE__ */ Symbol.for(CauseSymbolKey23);
var variance223 = {
  /* c8 ignore next */
  _E: (_322) => _322
};
var proto23 = {
  [CauseTypeId23]: variance223,
  [symbol35]() {
    return pipe25(hash25(CauseSymbolKey23), combine33(hash25(flattenCause23(this))), cached25(this));
  },
  [symbol225](that) {
    return isCause23(that) && causeEquals23(this, that);
  },
  pipe() {
    return pipeArguments25(this, arguments);
  },
  toJSON() {
    switch (this._tag) {
      case "Empty":
        return {
          _id: "Cause",
          _tag: this._tag
        };
      case "Die":
        return {
          _id: "Cause",
          _tag: this._tag,
          defect: toJSON25(this.defect)
        };
      case "Interrupt":
        return {
          _id: "Cause",
          _tag: this._tag,
          fiberId: this.fiberId.toJSON()
        };
      case "Fail":
        return {
          _id: "Cause",
          _tag: this._tag,
          failure: toJSON25(this.error)
        };
      case "Sequential":
      case "Parallel":
        return {
          _id: "Cause",
          _tag: this._tag,
          left: toJSON25(this.left),
          right: toJSON25(this.right)
        };
    }
  },
  toString() {
    return pretty23(this);
  },
  [NodeInspectSymbol25]() {
    return this.toJSON();
  }
};
var fail33 = (error) => {
  const o322 = Object.create(proto23);
  o322._tag = OP_FAIL23;
  o322.error = error;
  return o322;
};
var parallel23 = (left3322, right3322) => {
  const o322 = Object.create(proto23);
  o322._tag = OP_PARALLEL23;
  o322.left = left3322;
  o322.right = right3322;
  return o322;
};
var sequential23 = (left3322, right3322) => {
  const o322 = Object.create(proto23);
  o322._tag = OP_SEQUENTIAL23;
  o322.left = left3322;
  o322.right = right3322;
  return o322;
};
var isCause23 = (u322) => hasProperty25(u322, CauseTypeId23);
var isInterruptedOnly23 = (self2) => reduceWithContext23(void 0, IsInterruptedOnlyCauseReducer23)(self2);
var causeEquals23 = (left3322, right3322) => {
  let leftStack = of23(left3322);
  let rightStack = of23(right3322);
  while (isNonEmpty23(leftStack) && isNonEmpty23(rightStack)) {
    const [leftParallel, leftSequential] = pipe25(headNonEmpty23(leftStack), reduce423([empty623(), empty323()], ([parallel2322, sequential2322], cause) => {
      const [par, seq] = evaluateCause23(cause);
      return some325([pipe25(parallel2322, union323(par)), pipe25(sequential2322, appendAll23(seq))]);
    }));
    const [rightParallel, rightSequential] = pipe25(headNonEmpty23(rightStack), reduce423([empty623(), empty323()], ([parallel2322, sequential2322], cause) => {
      const [par, seq] = evaluateCause23(cause);
      return some325([pipe25(parallel2322, union323(par)), pipe25(sequential2322, appendAll23(seq))]);
    }));
    if (!equals25(leftParallel, rightParallel)) {
      return false;
    }
    leftStack = leftSequential;
    rightStack = rightSequential;
  }
  return true;
};
var flattenCause23 = (cause) => {
  return flattenCauseLoop23(of23(cause), empty323());
};
var flattenCauseLoop23 = (causes, flattened) => {
  while (1) {
    const [parallel2322, sequential2322] = pipe25(causes, reduce33([empty623(), empty323()], ([parallel322, sequential322], cause) => {
      const [par, seq] = evaluateCause23(cause);
      return [pipe25(parallel322, union323(par)), pipe25(sequential322, appendAll23(seq))];
    }));
    const updated = size323(parallel2322) > 0 ? pipe25(flattened, prepend23(parallel2322)) : flattened;
    if (isEmpty23(sequential2322)) {
      return reverse223(updated);
    }
    causes = sequential2322;
    flattened = updated;
  }
  throw new Error(getBugErrorMessage25("Cause.flattenCauseLoop"));
};
var evaluateCause23 = (self2) => {
  let cause = self2;
  const stack = [];
  let _parallel = empty623();
  let _sequential = empty323();
  while (cause !== void 0) {
    switch (cause._tag) {
      case OP_EMPTY23: {
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_FAIL23: {
        _parallel = add323(_parallel, make425(cause._tag, cause.error));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_DIE23: {
        _parallel = add323(_parallel, make425(cause._tag, cause.defect));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_INTERRUPT23: {
        _parallel = add323(_parallel, make425(cause._tag, cause.fiberId));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_SEQUENTIAL23: {
        switch (cause.left._tag) {
          case OP_EMPTY23: {
            cause = cause.right;
            break;
          }
          case OP_SEQUENTIAL23: {
            cause = sequential23(cause.left.left, sequential23(cause.left.right, cause.right));
            break;
          }
          case OP_PARALLEL23: {
            cause = parallel23(sequential23(cause.left.left, cause.right), sequential23(cause.left.right, cause.right));
            break;
          }
          default: {
            _sequential = prepend23(_sequential, cause.right);
            cause = cause.left;
            break;
          }
        }
        break;
      }
      case OP_PARALLEL23: {
        stack.push(cause.right);
        cause = cause.left;
        break;
      }
    }
  }
  throw new Error(getBugErrorMessage25("Cause.evaluateCauseLoop"));
};
var IsInterruptedOnlyCauseReducer23 = {
  emptyCase: constTrue25,
  failCase: constFalse25,
  dieCase: constFalse25,
  interruptCase: constTrue25,
  sequentialCase: (_322, left3322, right3322) => left3322 && right3322,
  parallelCase: (_322, left3322, right3322) => left3322 && right3322
};
var OP_SEQUENTIAL_CASE23 = "SequentialCase";
var OP_PARALLEL_CASE23 = "ParallelCase";
var reduce423 = /* @__PURE__ */ dual25(3, (self2, zero, pf) => {
  let accumulator = zero;
  let cause = self2;
  const causes = [];
  while (cause !== void 0) {
    const option = pf(accumulator, cause);
    accumulator = isSome225(option) ? option.value : accumulator;
    switch (cause._tag) {
      case OP_SEQUENTIAL23: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      case OP_PARALLEL23: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      default: {
        cause = void 0;
        break;
      }
    }
    if (cause === void 0 && causes.length > 0) {
      cause = causes.pop();
    }
  }
  return accumulator;
});
var reduceWithContext23 = /* @__PURE__ */ dual25(3, (self2, context, reducer) => {
  const input = [self2];
  const output = [];
  while (input.length > 0) {
    const cause = input.pop();
    switch (cause._tag) {
      case OP_EMPTY23: {
        output.push(right225(reducer.emptyCase(context)));
        break;
      }
      case OP_FAIL23: {
        output.push(right225(reducer.failCase(context, cause.error)));
        break;
      }
      case OP_DIE23: {
        output.push(right225(reducer.dieCase(context, cause.defect)));
        break;
      }
      case OP_INTERRUPT23: {
        output.push(right225(reducer.interruptCase(context, cause.fiberId)));
        break;
      }
      case OP_SEQUENTIAL23: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left225({
          _tag: OP_SEQUENTIAL_CASE23
        }));
        break;
      }
      case OP_PARALLEL23: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left225({
          _tag: OP_PARALLEL_CASE23
        }));
        break;
      }
    }
  }
  const accumulator = [];
  while (output.length > 0) {
    const either = output.pop();
    switch (either._tag) {
      case "Left": {
        switch (either.left._tag) {
          case OP_SEQUENTIAL_CASE23: {
            const left3322 = accumulator.pop();
            const right3322 = accumulator.pop();
            const value = reducer.sequentialCase(context, left3322, right3322);
            accumulator.push(value);
            break;
          }
          case OP_PARALLEL_CASE23: {
            const left3322 = accumulator.pop();
            const right3322 = accumulator.pop();
            const value = reducer.parallelCase(context, left3322, right3322);
            accumulator.push(value);
            break;
          }
        }
        break;
      }
      case "Right": {
        accumulator.push(either.right);
        break;
      }
    }
  }
  if (accumulator.length === 0) {
    throw new Error("BUG: Cause.reduceWithContext - please report an issue at https://github.com/Effect-TS/effect/issues");
  }
  return accumulator.pop();
});
var pretty23 = (cause) => {
  if (isInterruptedOnly23(cause)) {
    return "All fibers interrupted without errors.";
  }
  return prettyErrors23(cause).map((e322) => e322.stack).join("\n");
};
var PrettyError23 = class extends globalThis.Error {
  span = void 0;
  constructor(originalError) {
    const prevLimit = Error.stackTraceLimit;
    Error.stackTraceLimit = 0;
    super(prettyErrorMessage23(originalError));
    Error.stackTraceLimit = prevLimit;
    this.name = originalError instanceof Error ? originalError.name : "Error";
    if (typeof originalError === "object" && originalError !== null) {
      if (spanSymbol33 in originalError) {
        this.span = originalError[spanSymbol33];
      }
      Object.keys(originalError).forEach((key) => {
        if (!(key in this)) {
          this[key] = originalError[key];
        }
      });
    }
    this.stack = prettyErrorStack23(this.message, originalError instanceof Error && originalError.stack ? originalError.stack : "", this.span);
  }
  toJSON() {
    const out = {
      message: this.message,
      stack: this.stack
    };
    if (this.span) {
      out.span = this.span;
    }
    return out;
  }
};
var prettyErrorMessage23 = (u322) => {
  if (typeof u322 === "string") {
    return `Error: ${u322}`;
  }
  try {
    if (hasProperty25(u322, "toString") && isFunction325(u322["toString"]) && u322["toString"] !== Object.prototype.toString && u322["toString"] !== globalThis.Array.prototype.toString) {
      return u322["toString"]();
    }
  } catch {
  }
  return `Error: ${JSON.stringify(u322)}`;
};
var locationRegex23 = /\((.*)\)/;
var spanToTrace23 = /* @__PURE__ */ globalValue25("effect/Tracer/spanToTrace", () => /* @__PURE__ */ new WeakMap());
var prettyErrorStack23 = (message, stack, span222) => {
  const out = [message];
  const lines = stack.split("\n");
  for (let i322 = 1; i322 < lines.length; i322++) {
    if (lines[i322].includes("Generator.next")) {
      break;
    }
    if (lines[i322].includes("effect_internal_function")) {
      out.pop();
      break;
    }
    out.push(lines[i322].replace(/at .*effect_instruction_i.*\((.*)\)/, "at $1").replace(/EffectPrimitive\.\w+/, "<anonymous>"));
  }
  if (span222) {
    let current = span222;
    let i322 = 0;
    while (current && current._tag === "Span" && i322 < 10) {
      const stackFn = spanToTrace23.get(current);
      if (typeof stackFn === "function") {
        const stack2 = stackFn();
        const locationMatch = stack2.match(locationRegex23);
        const location = locationMatch ? locationMatch[1] : stack2.replace(/^at /, "");
        out.push(`    at ${current.name} (${location})`);
      } else {
        out.push(`    at ${current.name}`);
      }
      current = getOrUndefined25(current.parent);
      i322++;
    }
  }
  return out.join("\n");
};
var spanSymbol33 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var prettyErrors23 = (cause) => reduceWithContext23(cause, void 0, {
  emptyCase: () => [],
  dieCase: (_322, unknownError) => {
    return [new PrettyError23(unknownError)];
  },
  failCase: (_322, error) => {
    return [new PrettyError23(error)];
  },
  interruptCase: () => [],
  parallelCase: (_322, l322, r322) => [...l322, ...r322],
  sequentialCase: (_322, l322, r322) => [...l322, ...r322]
});
var SingleShotGen225 = class _SingleShotGen223 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  next(a322) {
    return this.called ? {
      value: a322,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  return(a322) {
    return {
      value: a322,
      done: true
    };
  }
  throw(e322) {
    throw e322;
  }
  [Symbol.iterator]() {
    return new _SingleShotGen223(this.self);
  }
};
var spanTag23 = /* @__PURE__ */ GenericTag23("effect/ParentSpan");
var EffectTypeId225 = /* @__PURE__ */ Symbol.for("effect/Effect");
var EffectPrimitive23 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId225] = effectVariance25;
  constructor(_op) {
    this._op = _op;
  }
  [symbol225](that) {
    return this === that;
  }
  [symbol35]() {
    return cached25(this, random25(this));
  }
  pipe() {
    return pipeArguments25(this, arguments);
  }
  toJSON() {
    return {
      _id: "Effect",
      _op: this._op,
      effect_instruction_i0: toJSON25(this.effect_instruction_i0),
      effect_instruction_i1: toJSON25(this.effect_instruction_i1),
      effect_instruction_i2: toJSON25(this.effect_instruction_i2)
    };
  }
  toString() {
    return format25(this.toJSON());
  }
  [NodeInspectSymbol25]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen225(new YieldWrap25(this));
  }
};
var EffectPrimitiveFailure23 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId225] = effectVariance25;
  constructor(_op) {
    this._op = _op;
    this._tag = _op;
  }
  [symbol225](that) {
    return exitIsExit23(that) && that._op === "Failure" && // @ts-expect-error
    equals25(this.effect_instruction_i0, that.effect_instruction_i0);
  }
  [symbol35]() {
    return pipe25(
      // @ts-expect-error
      string25(this._tag),
      // @ts-expect-error
      combine33(hash25(this.effect_instruction_i0)),
      cached25(this)
    );
  }
  get cause() {
    return this.effect_instruction_i0;
  }
  pipe() {
    return pipeArguments25(this, arguments);
  }
  toJSON() {
    return {
      _id: "Exit",
      _tag: this._op,
      cause: this.cause.toJSON()
    };
  }
  toString() {
    return format25(this.toJSON());
  }
  [NodeInspectSymbol25]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen225(new YieldWrap25(this));
  }
};
var isEffect23 = (u322) => hasProperty25(u322, EffectTypeId225);
var withFiberRuntime23 = (withRuntime) => {
  const effect = new EffectPrimitive23(OP_WITH_RUNTIME23);
  effect.effect_instruction_i0 = withRuntime;
  return effect;
};
var spanSymbol223 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var originalSymbol23 = /* @__PURE__ */ Symbol.for("effect/OriginalAnnotation");
var capture23 = (obj, span222) => {
  if (isSome225(span222)) {
    return new Proxy(obj, {
      has(target, p322) {
        return p322 === spanSymbol223 || p322 === originalSymbol23 || p322 in target;
      },
      get(target, p322) {
        if (p322 === spanSymbol223) {
          return span222.value;
        }
        if (p322 === originalSymbol23) {
          return obj;
        }
        return target[p322];
      }
    });
  }
  return obj;
};
var fail223 = (error) => isObject25(error) && !(spanSymbol223 in error) ? withFiberRuntime23((fiber) => failCause23(fail33(capture23(error, currentSpanFromFiber23(fiber))))) : failCause23(fail33(error));
var failCause23 = (cause) => {
  const effect = new EffectPrimitiveFailure23(OP_FAILURE23);
  effect.effect_instruction_i0 = cause;
  return effect;
};
var FiberRefSymbolKey23 = "effect/FiberRef";
var FiberRefTypeId23 = /* @__PURE__ */ Symbol.for(FiberRefSymbolKey23);
var fiberRefVariance23 = {
  /* c8 ignore next */
  _A: (_322) => _322
};
var fiberRefUnsafeMakeContext23 = (initial) => {
  const differ = environment23();
  return fiberRefUnsafeMakePatch23(initial, {
    differ,
    fork: differ.empty
  });
};
var fiberRefUnsafeMakePatch23 = (initial, options) => ({
  [FiberRefTypeId23]: fiberRefVariance23,
  initial,
  diff: (oldValue, newValue) => options.differ.diff(oldValue, newValue),
  combine: (first, second) => options.differ.combine(first, second),
  patch: (patch2322) => (oldValue) => options.differ.patch(patch2322, oldValue),
  fork: options.fork,
  join: options.join ?? ((_322, n322) => n322),
  pipe() {
    return pipeArguments25(this, arguments);
  }
});
var currentContext23 = /* @__PURE__ */ globalValue25(/* @__PURE__ */ Symbol.for("effect/FiberRef/currentContext"), () => fiberRefUnsafeMakeContext23(empty223()));
var YieldableError23 = /* @__PURE__ */ function() {
  class YieldableError2322 extends globalThis.Error {
    commit() {
      return fail223(this);
    }
    toString() {
      return this.message ? `${this.name}: ${this.message}` : this.name;
    }
    toJSON() {
      return {
        ...this
      };
    }
    [NodeInspectSymbol25]() {
      const stack = this.stack;
      if (stack) {
        return `${this.toString()}
${stack.split("\n").slice(1).join("\n")}`;
      }
      return this.toString();
    }
  }
  Object.assign(YieldableError2322.prototype, StructuralCommitPrototype25);
  return YieldableError2322;
}();
var exitIsExit23 = (u322) => isEffect23(u322) && "_tag" in u322 && (u322._tag === "Success" || u322._tag === "Failure");
var currentSpanFromFiber23 = (fiber) => {
  const span222 = fiber.getFiberRef(currentContext23).unsafeMap.get(spanTag23.key);
  return span222 !== void 0 && span222._tag === "Span" ? some325(span222) : none225();
};
var Data_exports25 = {};
__export224(Data_exports25, {
  Class: () => Class223,
  Error: () => Error223,
  Structural: () => Structural223,
  TaggedClass: () => TaggedClass23,
  TaggedError: () => TaggedError23,
  array: () => array223,
  case: () => _case23,
  struct: () => struct323,
  tagged: () => tagged23,
  taggedEnum: () => taggedEnum23,
  tuple: () => tuple223,
  unsafeArray: () => unsafeArray23,
  unsafeStruct: () => unsafeStruct23
});
var struct323 = struct223;
var unsafeStruct23 = (as2422) => Object.setPrototypeOf(as2422, StructuralPrototype25);
var tuple223 = (...as2422) => unsafeArray23(as2422);
var array223 = (as2422) => unsafeArray23(as2422.slice(0));
var unsafeArray23 = (as2422) => Object.setPrototypeOf(as2422, ArrayProto23);
var _case23 = () => (args) => args === void 0 ? Object.create(StructuralPrototype25) : struct323(args);
var tagged23 = (tag) => (args) => {
  const value = args === void 0 ? Object.create(StructuralPrototype25) : struct323(args);
  value._tag = tag;
  return value;
};
var Class223 = Structural33;
var TaggedClass23 = (tag) => {
  class Base extends Class223 {
    _tag = tag;
  }
  return Base;
};
var Structural223 = Structural33;
var taggedEnum23 = () => new Proxy({}, {
  get(_target, tag, _receiver) {
    if (tag === "$is") {
      return isTagged23;
    } else if (tag === "$match") {
      return taggedMatch23;
    }
    return tagged23(tag);
  }
});
function taggedMatch23() {
  if (arguments.length === 1) {
    const cases2 = arguments[0];
    return function(value2) {
      return cases2[value2._tag](value2);
    };
  }
  const value = arguments[0];
  const cases = arguments[1];
  return cases[value._tag](value);
}
var Error223 = /* @__PURE__ */ function() {
  return class Base extends YieldableError23 {
    constructor(args) {
      super();
      if (args) {
        Object.assign(this, args);
      }
    }
  };
}();
var TaggedError23 = (tag) => {
  class Base extends Error223 {
    _tag = tag;
  }
  Base.prototype.name = tag;
  return Base;
};
var traverseUp23 = Function_exports25.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType23.Program) return Option_exports25.none();
  return predicate(parent) ? Option_exports25.some(parent) : traverseUp23(parent, predicate);
});
var traverseUpGuard23 = Function_exports25.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType23.Program) return Option_exports25.none();
  return predicate(parent) ? Option_exports25.some(parent) : traverseUpGuard23(parent, predicate);
});
var ESLintCommunityESLintUtils23;
((ESLintCommunityESLintUtils2322) => {
  ESLintCommunityESLintUtils2322.getFunctionHeadLocation = getFunctionHeadLocation23;
  ESLintCommunityESLintUtils2322.getFunctionNameWithKind = getFunctionNameWithKind23;
  ESLintCommunityESLintUtils2322.getPropertyName = getPropertyName23;
  ESLintCommunityESLintUtils2322.getStaticValue = getStaticValue23;
  ESLintCommunityESLintUtils2322.getStringIfConstant = getStringIfConstant23;
  ESLintCommunityESLintUtils2322.hasSideEffect = hasSideEffect23;
  ESLintCommunityESLintUtils2322.isParenthesized = isParenthesized23;
})(ESLintCommunityESLintUtils23 || (ESLintCommunityESLintUtils23 = {}));
var Construction23 = Data_exports25.taggedEnum();
Construction23.None();
a5({
  type: N4.union([NodeType23.FunctionExpression, NodeType23.ArrowFunctionExpression]),
  parent: {
    type: NodeType23.Property,
    parent: {
      type: NodeType23.ObjectExpression
    }
  }
});
a5({
  type: N4.union([NodeType23.FunctionExpression, NodeType23.ArrowFunctionExpression]),
  parent: {
    type: NodeType23.MethodDefinition,
    parent: {
      type: NodeType23.ClassBody
    }
  }
});
a5({
  type: N4.union([NodeType23.FunctionExpression, NodeType23.ArrowFunctionExpression]),
  parent: {
    type: NodeType23.Property,
    parent: {
      type: NodeType23.ClassBody
    }
  }
});
var __defProp323 = Object.defineProperty;
var __export323 = (target, all622) => {
  for (var name22 in all622)
    __defProp323(target, name22, { get: all622[name22], enumerable: true });
};
var KEYS223 = {
  ArrayExpression: [
    "elements"
  ],
  ArrayPattern: [
    "elements"
  ],
  ArrowFunctionExpression: [
    "params",
    "body"
  ],
  AssignmentExpression: [
    "left",
    "right"
  ],
  AssignmentPattern: [
    "left",
    "right"
  ],
  AwaitExpression: [
    "argument"
  ],
  BinaryExpression: [
    "left",
    "right"
  ],
  BlockStatement: [
    "body"
  ],
  BreakStatement: [
    "label"
  ],
  CallExpression: [
    "callee",
    "arguments"
  ],
  CatchClause: [
    "param",
    "body"
  ],
  ChainExpression: [
    "expression"
  ],
  ClassBody: [
    "body"
  ],
  ClassDeclaration: [
    "id",
    "superClass",
    "body"
  ],
  ClassExpression: [
    "id",
    "superClass",
    "body"
  ],
  ConditionalExpression: [
    "test",
    "consequent",
    "alternate"
  ],
  ContinueStatement: [
    "label"
  ],
  DebuggerStatement: [],
  DoWhileStatement: [
    "body",
    "test"
  ],
  EmptyStatement: [],
  ExperimentalRestProperty: [
    "argument"
  ],
  ExperimentalSpreadProperty: [
    "argument"
  ],
  ExportAllDeclaration: [
    "exported",
    "source"
  ],
  ExportDefaultDeclaration: [
    "declaration"
  ],
  ExportNamedDeclaration: [
    "declaration",
    "specifiers",
    "source"
  ],
  ExportSpecifier: [
    "exported",
    "local"
  ],
  ExpressionStatement: [
    "expression"
  ],
  ForInStatement: [
    "left",
    "right",
    "body"
  ],
  ForOfStatement: [
    "left",
    "right",
    "body"
  ],
  ForStatement: [
    "init",
    "test",
    "update",
    "body"
  ],
  FunctionDeclaration: [
    "id",
    "params",
    "body"
  ],
  FunctionExpression: [
    "id",
    "params",
    "body"
  ],
  Identifier: [],
  IfStatement: [
    "test",
    "consequent",
    "alternate"
  ],
  ImportDeclaration: [
    "specifiers",
    "source"
  ],
  ImportDefaultSpecifier: [
    "local"
  ],
  ImportExpression: [
    "source"
  ],
  ImportNamespaceSpecifier: [
    "local"
  ],
  ImportSpecifier: [
    "imported",
    "local"
  ],
  JSXAttribute: [
    "name",
    "value"
  ],
  JSXClosingElement: [
    "name"
  ],
  JSXClosingFragment: [],
  JSXElement: [
    "openingElement",
    "children",
    "closingElement"
  ],
  JSXEmptyExpression: [],
  JSXExpressionContainer: [
    "expression"
  ],
  JSXFragment: [
    "openingFragment",
    "children",
    "closingFragment"
  ],
  JSXIdentifier: [],
  JSXMemberExpression: [
    "object",
    "property"
  ],
  JSXNamespacedName: [
    "namespace",
    "name"
  ],
  JSXOpeningElement: [
    "name",
    "attributes"
  ],
  JSXOpeningFragment: [],
  JSXSpreadAttribute: [
    "argument"
  ],
  JSXSpreadChild: [
    "expression"
  ],
  JSXText: [],
  LabeledStatement: [
    "label",
    "body"
  ],
  Literal: [],
  LogicalExpression: [
    "left",
    "right"
  ],
  MemberExpression: [
    "object",
    "property"
  ],
  MetaProperty: [
    "meta",
    "property"
  ],
  MethodDefinition: [
    "key",
    "value"
  ],
  NewExpression: [
    "callee",
    "arguments"
  ],
  ObjectExpression: [
    "properties"
  ],
  ObjectPattern: [
    "properties"
  ],
  PrivateIdentifier: [],
  Program: [
    "body"
  ],
  Property: [
    "key",
    "value"
  ],
  PropertyDefinition: [
    "key",
    "value"
  ],
  RestElement: [
    "argument"
  ],
  ReturnStatement: [
    "argument"
  ],
  SequenceExpression: [
    "expressions"
  ],
  SpreadElement: [
    "argument"
  ],
  StaticBlock: [
    "body"
  ],
  Super: [],
  SwitchCase: [
    "test",
    "consequent"
  ],
  SwitchStatement: [
    "discriminant",
    "cases"
  ],
  TaggedTemplateExpression: [
    "tag",
    "quasi"
  ],
  TemplateElement: [],
  TemplateLiteral: [
    "quasis",
    "expressions"
  ],
  ThisExpression: [],
  ThrowStatement: [
    "argument"
  ],
  TryStatement: [
    "block",
    "handler",
    "finalizer"
  ],
  UnaryExpression: [
    "argument"
  ],
  UpdateExpression: [
    "argument"
  ],
  VariableDeclaration: [
    "declarations"
  ],
  VariableDeclarator: [
    "id",
    "init"
  ],
  WhileStatement: [
    "test",
    "body"
  ],
  WithStatement: [
    "object",
    "body"
  ],
  YieldExpression: [
    "argument"
  ]
};
var NODE_TYPES223 = Object.keys(KEYS223);
for (const type of NODE_TYPES223) {
  Object.freeze(KEYS223[type]);
}
Object.freeze(KEYS223);
var visitor_keys_default223 = KEYS223;
var KEY_BLACKLIST223 = /* @__PURE__ */ new Set([
  "parent",
  "leadingComments",
  "trailingComments"
]);
function filterKey223(key) {
  return !KEY_BLACKLIST223.has(key) && key[0] !== "_";
}
function getKeys223(node) {
  return Object.keys(node).filter(filterKey223);
}
function getInnermostScope223(initialScope, node) {
  const location = node.range[0];
  let scope = initialScope;
  let found = false;
  do {
    found = false;
    for (const childScope of scope.childScopes) {
      const range222 = childScope.block.range;
      if (range222[0] <= location && location < range222[1]) {
        scope = childScope;
        found = true;
        break;
      }
    }
  } while (found);
  return scope;
}
function findVariable223(initialScope, nameOrNode) {
  let name22 = "";
  let scope = initialScope;
  if (typeof nameOrNode === "string") {
    name22 = nameOrNode;
  } else {
    name22 = nameOrNode.name;
    scope = getInnermostScope223(scope, nameOrNode);
  }
  while (scope != null) {
    const variable = scope.set.get(name22);
    if (variable != null) {
      return variable;
    }
    scope = scope.upper;
  }
  return null;
}
function negate0223(token) {
  return !this(token);
}
function negate223(f2222) {
  return negate0223.bind(f2222);
}
function isPunctuatorTokenWithValue223(token, value) {
  return token.type === "Punctuator" && token.value === value;
}
function isArrowToken223(token) {
  return isPunctuatorTokenWithValue223(token, "=>");
}
function isCommaToken223(token) {
  return isPunctuatorTokenWithValue223(token, ",");
}
function isSemicolonToken223(token) {
  return isPunctuatorTokenWithValue223(token, ";");
}
function isColonToken223(token) {
  return isPunctuatorTokenWithValue223(token, ":");
}
function isOpeningParenToken223(token) {
  return isPunctuatorTokenWithValue223(token, "(");
}
function isClosingParenToken223(token) {
  return isPunctuatorTokenWithValue223(token, ")");
}
function isOpeningBracketToken223(token) {
  return isPunctuatorTokenWithValue223(token, "[");
}
function isClosingBracketToken223(token) {
  return isPunctuatorTokenWithValue223(token, "]");
}
function isOpeningBraceToken223(token) {
  return isPunctuatorTokenWithValue223(token, "{");
}
function isClosingBraceToken223(token) {
  return isPunctuatorTokenWithValue223(token, "}");
}
function isCommentToken223(token) {
  return ["Block", "Line", "Shebang"].includes(token.type);
}
negate223(isArrowToken223);
negate223(isCommaToken223);
negate223(isSemicolonToken223);
negate223(isColonToken223);
negate223(isOpeningParenToken223);
negate223(isClosingParenToken223);
negate223(isOpeningBracketToken223);
negate223(isClosingBracketToken223);
negate223(isOpeningBraceToken223);
negate223(isClosingBraceToken223);
negate223(isCommentToken223);
function getOpeningParenOfParams223(node, sourceCode) {
  return node.id ? sourceCode.getTokenAfter(node.id, isOpeningParenToken223) : sourceCode.getFirstToken(node, isOpeningParenToken223);
}
function getFunctionHeadLocation223(node, sourceCode) {
  const parent = node.parent;
  let start = null;
  let end = null;
  if (node.type === "ArrowFunctionExpression") {
    const arrowToken = sourceCode.getTokenBefore(node.body, isArrowToken223);
    start = arrowToken.loc.start;
    end = arrowToken.loc.end;
  } else if (parent.type === "Property" || parent.type === "MethodDefinition" || parent.type === "PropertyDefinition") {
    start = parent.loc.start;
    end = getOpeningParenOfParams223(node, sourceCode).loc.start;
  } else {
    start = node.loc.start;
    end = getOpeningParenOfParams223(node, sourceCode).loc.start;
  }
  return {
    start: { ...start },
    end: { ...end }
  };
}
var globalObject223 = typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {};
var builtinNames223 = Object.freeze(
  /* @__PURE__ */ new Set([
    "Array",
    "ArrayBuffer",
    "BigInt",
    "BigInt64Array",
    "BigUint64Array",
    "Boolean",
    "DataView",
    "Date",
    "decodeURI",
    "decodeURIComponent",
    "encodeURI",
    "encodeURIComponent",
    "escape",
    "Float32Array",
    "Float64Array",
    "Function",
    "Infinity",
    "Int16Array",
    "Int32Array",
    "Int8Array",
    "isFinite",
    "isNaN",
    "isPrototypeOf",
    "JSON",
    "Map",
    "Math",
    "NaN",
    "Number",
    "Object",
    "parseFloat",
    "parseInt",
    "Promise",
    "Proxy",
    "Reflect",
    "RegExp",
    "Set",
    "String",
    "Symbol",
    "Uint16Array",
    "Uint32Array",
    "Uint8Array",
    "Uint8ClampedArray",
    "undefined",
    "unescape",
    "WeakMap",
    "WeakSet"
  ])
);
var callAllowed223 = new Set(
  [
    Array.isArray,
    Array.of,
    Array.prototype.at,
    Array.prototype.concat,
    Array.prototype.entries,
    Array.prototype.every,
    Array.prototype.filter,
    Array.prototype.find,
    Array.prototype.findIndex,
    Array.prototype.flat,
    Array.prototype.includes,
    Array.prototype.indexOf,
    Array.prototype.join,
    Array.prototype.keys,
    Array.prototype.lastIndexOf,
    Array.prototype.slice,
    Array.prototype.some,
    Array.prototype.toString,
    Array.prototype.values,
    typeof BigInt === "function" ? BigInt : void 0,
    Boolean,
    Date,
    Date.parse,
    decodeURI,
    decodeURIComponent,
    encodeURI,
    encodeURIComponent,
    escape,
    isFinite,
    isNaN,
    isPrototypeOf,
    Map,
    Map.prototype.entries,
    Map.prototype.get,
    Map.prototype.has,
    Map.prototype.keys,
    Map.prototype.values,
    ...Object.getOwnPropertyNames(Math).filter((k2222) => k2222 !== "random").map((k2222) => Math[k2222]).filter((f2222) => typeof f2222 === "function"),
    Number,
    Number.isFinite,
    Number.isNaN,
    Number.parseFloat,
    Number.parseInt,
    Number.prototype.toExponential,
    Number.prototype.toFixed,
    Number.prototype.toPrecision,
    Number.prototype.toString,
    Object,
    Object.entries,
    Object.is,
    Object.isExtensible,
    Object.isFrozen,
    Object.isSealed,
    Object.keys,
    Object.values,
    parseFloat,
    parseInt,
    RegExp,
    Set,
    Set.prototype.entries,
    Set.prototype.has,
    Set.prototype.keys,
    Set.prototype.values,
    String,
    String.fromCharCode,
    String.fromCodePoint,
    String.raw,
    String.prototype.at,
    String.prototype.charAt,
    String.prototype.charCodeAt,
    String.prototype.codePointAt,
    String.prototype.concat,
    String.prototype.endsWith,
    String.prototype.includes,
    String.prototype.indexOf,
    String.prototype.lastIndexOf,
    String.prototype.normalize,
    String.prototype.padEnd,
    String.prototype.padStart,
    String.prototype.slice,
    String.prototype.startsWith,
    String.prototype.substr,
    String.prototype.substring,
    String.prototype.toLowerCase,
    String.prototype.toString,
    String.prototype.toUpperCase,
    String.prototype.trim,
    String.prototype.trimEnd,
    String.prototype.trimLeft,
    String.prototype.trimRight,
    String.prototype.trimStart,
    Symbol.for,
    Symbol.keyFor,
    unescape
  ].filter((f2222) => typeof f2222 === "function")
);
var callPassThrough223 = /* @__PURE__ */ new Set([
  Object.freeze,
  Object.preventExtensions,
  Object.seal
]);
var getterAllowed223 = [
  [Map, /* @__PURE__ */ new Set(["size"])],
  [
    RegExp,
    /* @__PURE__ */ new Set([
      "dotAll",
      "flags",
      "global",
      "hasIndices",
      "ignoreCase",
      "multiline",
      "source",
      "sticky",
      "unicode"
    ])
  ],
  [Set, /* @__PURE__ */ new Set(["size"])]
];
function getPropertyDescriptor223(object222, name22) {
  let x2222 = object222;
  while ((typeof x2222 === "object" || typeof x2222 === "function") && x2222 !== null) {
    const d2222 = Object.getOwnPropertyDescriptor(x2222, name22);
    if (d2222) {
      return d2222;
    }
    x2222 = Object.getPrototypeOf(x2222);
  }
  return null;
}
function isGetter223(object222, name22) {
  const d2222 = getPropertyDescriptor223(object222, name22);
  return d2222 != null && d2222.get != null;
}
function getElementValues223(nodeList, initialScope) {
  const valueList = [];
  for (let i2222 = 0; i2222 < nodeList.length; ++i2222) {
    const elementNode = nodeList[i2222];
    if (elementNode == null) {
      valueList.length = i2222 + 1;
    } else if (elementNode.type === "SpreadElement") {
      const argument = getStaticValueR223(elementNode.argument, initialScope);
      if (argument == null) {
        return null;
      }
      valueList.push(...argument.value);
    } else {
      const element = getStaticValueR223(elementNode, initialScope);
      if (element == null) {
        return null;
      }
      valueList.push(element.value);
    }
  }
  return valueList;
}
function isEffectivelyConst223(variable) {
  const refs = variable.references;
  const inits = refs.filter((r2222) => r2222.init).length;
  const reads = refs.filter((r2222) => r2222.isReadOnly()).length;
  if (inits === 1 && reads + inits === refs.length) {
    return true;
  }
  return false;
}
var operations223 = Object.freeze({
  ArrayExpression(node, initialScope) {
    const elements = getElementValues223(node.elements, initialScope);
    return elements != null ? { value: elements } : null;
  },
  AssignmentExpression(node, initialScope) {
    if (node.operator === "=") {
      return getStaticValueR223(node.right, initialScope);
    }
    return null;
  },
  //eslint-disable-next-line complexity
  BinaryExpression(node, initialScope) {
    if (node.operator === "in" || node.operator === "instanceof") {
      return null;
    }
    const left522 = getStaticValueR223(node.left, initialScope);
    const right522 = getStaticValueR223(node.right, initialScope);
    if (left522 != null && right522 != null) {
      switch (node.operator) {
        case "==":
          return { value: left522.value == right522.value };
        case "!=":
          return { value: left522.value != right522.value };
        case "===":
          return { value: left522.value === right522.value };
        case "!==":
          return { value: left522.value !== right522.value };
        case "<":
          return { value: left522.value < right522.value };
        case "<=":
          return { value: left522.value <= right522.value };
        case ">":
          return { value: left522.value > right522.value };
        case ">=":
          return { value: left522.value >= right522.value };
        case "<<":
          return { value: left522.value << right522.value };
        case ">>":
          return { value: left522.value >> right522.value };
        case ">>>":
          return { value: left522.value >>> right522.value };
        case "+":
          return { value: left522.value + right522.value };
        case "-":
          return { value: left522.value - right522.value };
        case "*":
          return { value: left522.value * right522.value };
        case "/":
          return { value: left522.value / right522.value };
        case "%":
          return { value: left522.value % right522.value };
        case "**":
          return { value: left522.value ** right522.value };
        case "|":
          return { value: left522.value | right522.value };
        case "^":
          return { value: left522.value ^ right522.value };
        case "&":
          return { value: left522.value & right522.value };
      }
    }
    return null;
  },
  CallExpression(node, initialScope) {
    const calleeNode = node.callee;
    const args = getElementValues223(node.arguments, initialScope);
    if (args != null) {
      if (calleeNode.type === "MemberExpression") {
        if (calleeNode.property.type === "PrivateIdentifier") {
          return null;
        }
        const object222 = getStaticValueR223(calleeNode.object, initialScope);
        if (object222 != null) {
          if (object222.value == null && (object222.optional || node.optional)) {
            return { value: void 0, optional: true };
          }
          const property = getStaticPropertyNameValue223(
            calleeNode,
            initialScope
          );
          if (property != null) {
            const receiver = object222.value;
            const methodName = property.value;
            if (callAllowed223.has(receiver[methodName])) {
              return { value: receiver[methodName](...args) };
            }
            if (callPassThrough223.has(receiver[methodName])) {
              return { value: args[0] };
            }
          }
        }
      } else {
        const callee = getStaticValueR223(calleeNode, initialScope);
        if (callee != null) {
          if (callee.value == null && node.optional) {
            return { value: void 0, optional: true };
          }
          const func = callee.value;
          if (callAllowed223.has(func)) {
            return { value: func(...args) };
          }
          if (callPassThrough223.has(func)) {
            return { value: args[0] };
          }
        }
      }
    }
    return null;
  },
  ConditionalExpression(node, initialScope) {
    const test = getStaticValueR223(node.test, initialScope);
    if (test != null) {
      return test.value ? getStaticValueR223(node.consequent, initialScope) : getStaticValueR223(node.alternate, initialScope);
    }
    return null;
  },
  ExpressionStatement(node, initialScope) {
    return getStaticValueR223(node.expression, initialScope);
  },
  Identifier(node, initialScope) {
    if (initialScope != null) {
      const variable = findVariable223(initialScope, node);
      if (variable != null && variable.defs.length === 0 && builtinNames223.has(variable.name) && variable.name in globalObject223) {
        return { value: globalObject223[variable.name] };
      }
      if (variable != null && variable.defs.length === 1) {
        const def = variable.defs[0];
        if (def.parent && def.type === "Variable" && (def.parent.kind === "const" || isEffectivelyConst223(variable)) && // TODO(mysticatea): don't support destructuring here.
        def.node.id.type === "Identifier") {
          return getStaticValueR223(def.node.init, initialScope);
        }
      }
    }
    return null;
  },
  Literal(node) {
    if ((node.regex != null || node.bigint != null) && node.value == null) {
      return null;
    }
    return { value: node.value };
  },
  LogicalExpression(node, initialScope) {
    const left522 = getStaticValueR223(node.left, initialScope);
    if (left522 != null) {
      if (node.operator === "||" && Boolean(left522.value) === true || node.operator === "&&" && Boolean(left522.value) === false || node.operator === "??" && left522.value != null) {
        return left522;
      }
      const right522 = getStaticValueR223(node.right, initialScope);
      if (right522 != null) {
        return right522;
      }
    }
    return null;
  },
  MemberExpression(node, initialScope) {
    if (node.property.type === "PrivateIdentifier") {
      return null;
    }
    const object222 = getStaticValueR223(node.object, initialScope);
    if (object222 != null) {
      if (object222.value == null && (object222.optional || node.optional)) {
        return { value: void 0, optional: true };
      }
      const property = getStaticPropertyNameValue223(node, initialScope);
      if (property != null) {
        if (!isGetter223(object222.value, property.value)) {
          return { value: object222.value[property.value] };
        }
        for (const [classFn, allowed] of getterAllowed223) {
          if (object222.value instanceof classFn && allowed.has(property.value)) {
            return { value: object222.value[property.value] };
          }
        }
      }
    }
    return null;
  },
  ChainExpression(node, initialScope) {
    const expression = getStaticValueR223(node.expression, initialScope);
    if (expression != null) {
      return { value: expression.value };
    }
    return null;
  },
  NewExpression(node, initialScope) {
    const callee = getStaticValueR223(node.callee, initialScope);
    const args = getElementValues223(node.arguments, initialScope);
    if (callee != null && args != null) {
      const Func = callee.value;
      if (callAllowed223.has(Func)) {
        return { value: new Func(...args) };
      }
    }
    return null;
  },
  ObjectExpression(node, initialScope) {
    const object222 = {};
    for (const propertyNode of node.properties) {
      if (propertyNode.type === "Property") {
        if (propertyNode.kind !== "init") {
          return null;
        }
        const key = getStaticPropertyNameValue223(
          propertyNode,
          initialScope
        );
        const value = getStaticValueR223(propertyNode.value, initialScope);
        if (key == null || value == null) {
          return null;
        }
        object222[key.value] = value.value;
      } else if (propertyNode.type === "SpreadElement" || propertyNode.type === "ExperimentalSpreadProperty") {
        const argument = getStaticValueR223(
          propertyNode.argument,
          initialScope
        );
        if (argument == null) {
          return null;
        }
        Object.assign(object222, argument.value);
      } else {
        return null;
      }
    }
    return { value: object222 };
  },
  SequenceExpression(node, initialScope) {
    const last222 = node.expressions[node.expressions.length - 1];
    return getStaticValueR223(last222, initialScope);
  },
  TaggedTemplateExpression(node, initialScope) {
    const tag = getStaticValueR223(node.tag, initialScope);
    const expressions = getElementValues223(
      node.quasi.expressions,
      initialScope
    );
    if (tag != null && expressions != null) {
      const func = tag.value;
      const strings = node.quasi.quasis.map((q) => q.value.cooked);
      strings.raw = node.quasi.quasis.map((q) => q.value.raw);
      if (func === String.raw) {
        return { value: func(strings, ...expressions) };
      }
    }
    return null;
  },
  TemplateLiteral(node, initialScope) {
    const expressions = getElementValues223(node.expressions, initialScope);
    if (expressions != null) {
      let value = node.quasis[0].value.cooked;
      for (let i2222 = 0; i2222 < expressions.length; ++i2222) {
        value += expressions[i2222];
        value += node.quasis[i2222 + 1].value.cooked;
      }
      return { value };
    }
    return null;
  },
  UnaryExpression(node, initialScope) {
    if (node.operator === "delete") {
      return null;
    }
    if (node.operator === "void") {
      return { value: void 0 };
    }
    const arg = getStaticValueR223(node.argument, initialScope);
    if (arg != null) {
      switch (node.operator) {
        case "-":
          return { value: -arg.value };
        case "+":
          return { value: +arg.value };
        case "!":
          return { value: !arg.value };
        case "~":
          return { value: ~arg.value };
        case "typeof":
          return { value: typeof arg.value };
      }
    }
    return null;
  }
});
function getStaticValueR223(node, initialScope) {
  if (node != null && Object.hasOwnProperty.call(operations223, node.type)) {
    return operations223[node.type](node, initialScope);
  }
  return null;
}
function getStaticPropertyNameValue223(node, initialScope) {
  const nameNode = node.type === "Property" ? node.key : node.property;
  if (node.computed) {
    return getStaticValueR223(nameNode, initialScope);
  }
  if (nameNode.type === "Identifier") {
    return { value: nameNode.name };
  }
  if (nameNode.type === "Literal") {
    if (nameNode.bigint) {
      return { value: nameNode.bigint };
    }
    return { value: String(nameNode.value) };
  }
  return null;
}
function getStaticValue223(node, initialScope = null) {
  try {
    return getStaticValueR223(node, initialScope);
  } catch (_error) {
    return null;
  }
}
function getStringIfConstant223(node, initialScope = null) {
  if (node && node.type === "Literal" && node.value === null) {
    if (node.regex) {
      return `/${node.regex.pattern}/${node.regex.flags}`;
    }
    if (node.bigint) {
      return node.bigint;
    }
  }
  const evaluated = getStaticValue223(node, initialScope);
  return evaluated && String(evaluated.value);
}
function getPropertyName223(node, initialScope) {
  switch (node.type) {
    case "MemberExpression":
      if (node.computed) {
        return getStringIfConstant223(node.property, initialScope);
      }
      if (node.property.type === "PrivateIdentifier") {
        return null;
      }
      return node.property.name;
    case "Property":
    case "MethodDefinition":
    case "PropertyDefinition":
      if (node.computed) {
        return getStringIfConstant223(node.key, initialScope);
      }
      if (node.key.type === "Literal") {
        return String(node.key.value);
      }
      if (node.key.type === "PrivateIdentifier") {
        return null;
      }
      return node.key.name;
  }
  return null;
}
function getFunctionNameWithKind223(node, sourceCode) {
  const parent = node.parent;
  const tokens = [];
  const isObjectMethod = parent.type === "Property" && parent.value === node;
  const isClassMethod = parent.type === "MethodDefinition" && parent.value === node;
  const isClassFieldMethod = parent.type === "PropertyDefinition" && parent.value === node;
  if (isClassMethod || isClassFieldMethod) {
    if (parent.static) {
      tokens.push("static");
    }
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push("private");
    }
  }
  if (node.async) {
    tokens.push("async");
  }
  if (node.generator) {
    tokens.push("generator");
  }
  if (isObjectMethod || isClassMethod) {
    if (parent.kind === "constructor") {
      return "constructor";
    }
    if (parent.kind === "get") {
      tokens.push("getter");
    } else if (parent.kind === "set") {
      tokens.push("setter");
    } else {
      tokens.push("method");
    }
  } else if (isClassFieldMethod) {
    tokens.push("method");
  } else {
    if (node.type === "ArrowFunctionExpression") {
      tokens.push("arrow");
    }
    tokens.push("function");
  }
  if (isObjectMethod || isClassMethod || isClassFieldMethod) {
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push(`#${parent.key.name}`);
    } else {
      const name22 = getPropertyName223(parent);
      if (name22) {
        tokens.push(`'${name22}'`);
      } else if (sourceCode) {
        const keyText = sourceCode.getText(parent.key);
        if (!keyText.includes("\n")) {
          tokens.push(`[${keyText}]`);
        }
      }
    }
  } else if (node.id) {
    tokens.push(`'${node.id.name}'`);
  } else if (parent.type === "VariableDeclarator" && parent.id && parent.id.type === "Identifier") {
    tokens.push(`'${parent.id.name}'`);
  } else if ((parent.type === "AssignmentExpression" || parent.type === "AssignmentPattern") && parent.left && parent.left.type === "Identifier") {
    tokens.push(`'${parent.left.name}'`);
  } else if (parent.type === "ExportDefaultDeclaration" && parent.declaration === node) {
    tokens.push("'default'");
  }
  return tokens.join(" ");
}
var typeConversionBinaryOps223 = Object.freeze(
  /* @__PURE__ */ new Set([
    "==",
    "!=",
    "<",
    "<=",
    ">",
    ">=",
    "<<",
    ">>",
    ">>>",
    "+",
    "-",
    "*",
    "/",
    "%",
    "|",
    "^",
    "&",
    "in"
  ])
);
var typeConversionUnaryOps223 = Object.freeze(/* @__PURE__ */ new Set(["-", "+", "!", "~"]));
function isNode223(x2222) {
  return x2222 !== null && typeof x2222 === "object" && typeof x2222.type === "string";
}
var visitor223 = Object.freeze(
  Object.assign(/* @__PURE__ */ Object.create(null), {
    $visit(node, options, visitorKeys) {
      const { type } = node;
      if (typeof this[type] === "function") {
        return this[type](node, options, visitorKeys);
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    $visitChildren(node, options, visitorKeys) {
      const { type } = node;
      for (const key of visitorKeys[type] || getKeys223(node)) {
        const value = node[key];
        if (Array.isArray(value)) {
          for (const element of value) {
            if (isNode223(element) && this.$visit(element, options, visitorKeys)) {
              return true;
            }
          }
        } else if (isNode223(value) && this.$visit(value, options, visitorKeys)) {
          return true;
        }
      }
      return false;
    },
    ArrowFunctionExpression() {
      return false;
    },
    AssignmentExpression() {
      return true;
    },
    AwaitExpression() {
      return true;
    },
    BinaryExpression(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && typeConversionBinaryOps223.has(node.operator) && (node.left.type !== "Literal" || node.right.type !== "Literal")) {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    CallExpression() {
      return true;
    },
    FunctionExpression() {
      return false;
    },
    ImportExpression() {
      return true;
    },
    MemberExpression(node, options, visitorKeys) {
      if (options.considerGetters) {
        return true;
      }
      if (options.considerImplicitTypeConversion && node.computed && node.property.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    MethodDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    NewExpression() {
      return true;
    },
    Property(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    PropertyDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UnaryExpression(node, options, visitorKeys) {
      if (node.operator === "delete") {
        return true;
      }
      if (options.considerImplicitTypeConversion && typeConversionUnaryOps223.has(node.operator) && node.argument.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UpdateExpression() {
      return true;
    },
    YieldExpression() {
      return true;
    }
  })
);
function hasSideEffect223(node, sourceCode, { considerGetters = false, considerImplicitTypeConversion = false } = {}) {
  return visitor223.$visit(
    node,
    { considerGetters, considerImplicitTypeConversion },
    sourceCode.visitorKeys || visitor_keys_default223
  );
}
function getParentSyntaxParen223(node, sourceCode) {
  const parent = node.parent;
  switch (parent.type) {
    case "CallExpression":
    case "NewExpression":
      if (parent.arguments.length === 1 && parent.arguments[0] === node) {
        return sourceCode.getTokenAfter(
          parent.callee,
          isOpeningParenToken223
        );
      }
      return null;
    case "DoWhileStatement":
      if (parent.test === node) {
        return sourceCode.getTokenAfter(
          parent.body,
          isOpeningParenToken223
        );
      }
      return null;
    case "IfStatement":
    case "WhileStatement":
      if (parent.test === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "ImportExpression":
      if (parent.source === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "SwitchStatement":
      if (parent.discriminant === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "WithStatement":
      if (parent.object === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    default:
      return null;
  }
}
function isParenthesized223(timesOrNode, nodeOrSourceCode, optionalSourceCode) {
  let times, node, sourceCode, maybeLeftParen, maybeRightParen;
  if (typeof timesOrNode === "number") {
    times = timesOrNode | 0;
    node = nodeOrSourceCode;
    sourceCode = optionalSourceCode;
    if (!(times >= 1)) {
      throw new TypeError("'times' should be a positive integer.");
    }
  } else {
    times = 1;
    node = timesOrNode;
    sourceCode = nodeOrSourceCode;
  }
  if (node == null || // `Program` can't be parenthesized
  node.parent == null || // `CatchClause.param` can't be parenthesized, example `try {} catch (error) {}`
  node.parent.type === "CatchClause" && node.parent.param === node) {
    return false;
  }
  maybeLeftParen = maybeRightParen = node;
  do {
    maybeLeftParen = sourceCode.getTokenBefore(maybeLeftParen);
    maybeRightParen = sourceCode.getTokenAfter(maybeRightParen);
  } while (maybeLeftParen != null && maybeRightParen != null && isOpeningParenToken223(maybeLeftParen) && isClosingParenToken223(maybeRightParen) && // Avoid false positive such as `if (a) {}`
  maybeLeftParen !== getParentSyntaxParen223(node, sourceCode) && --times > 0);
  return times === 0;
}
Function.call.bind(Object.hasOwnProperty);
var __defProp2223 = Object.defineProperty;
var __export2223 = (target, all32222) => {
  for (var name22 in all32222)
    __defProp2223(target, name22, { get: all32222[name22], enumerable: true });
};
var NodeType223 = types.AST_NODE_TYPES;
var is223 = utils.ASTUtils.isNodeOfType;
var isOneOf223 = utils.ASTUtils.isNodeOfTypes;
isOneOf223([
  NodeType223.ArrowFunctionExpression,
  NodeType223.FunctionDeclaration,
  NodeType223.FunctionExpression
]);
isOneOf223([
  NodeType223.ArrowFunctionExpression,
  NodeType223.FunctionDeclaration,
  NodeType223.FunctionExpression,
  NodeType223.TSCallSignatureDeclaration,
  NodeType223.TSConstructSignatureDeclaration,
  NodeType223.TSDeclareFunction,
  NodeType223.TSEmptyBodyFunctionExpression,
  NodeType223.TSFunctionType,
  NodeType223.TSMethodSignature
]);
isOneOf223([NodeType223.ClassDeclaration, NodeType223.ClassExpression]);
isOneOf223([
  NodeType223.DoWhileStatement,
  NodeType223.ForInStatement,
  NodeType223.ForOfStatement,
  NodeType223.ForStatement,
  NodeType223.WhileStatement
]);
isOneOf223([NodeType223.TSArrayType, NodeType223.TSTupleType]);
isOneOf223([
  NodeType223.PropertyDefinition,
  NodeType223.TSIndexSignature,
  NodeType223.TSParameterProperty,
  NodeType223.TSPropertySignature
]);
is223(NodeType223.JSXElement);
is223(NodeType223.JSXFragment);
isOneOf223([
  NodeType223.JSXAttribute,
  NodeType223.JSXSpreadChild,
  NodeType223.JSXClosingElement,
  NodeType223.JSXClosingFragment,
  NodeType223.JSXElement,
  NodeType223.JSXEmptyExpression,
  NodeType223.JSXExpressionContainer,
  NodeType223.JSXFragment,
  NodeType223.JSXIdentifier,
  NodeType223.JSXMemberExpression,
  NodeType223.JSXNamespacedName,
  NodeType223.JSXOpeningElement,
  NodeType223.JSXOpeningFragment,
  NodeType223.JSXSpreadAttribute,
  NodeType223.JSXSpreadChild,
  NodeType223.JSXText
]);
isOneOf223([
  NodeType223.JSXIdentifier,
  NodeType223.JSXMemberExpression,
  NodeType223.JSXNamespacedName
]);
isOneOf223([
  NodeType223.ArrayPattern,
  NodeType223.AssignmentPattern,
  NodeType223.ObjectPattern,
  NodeType223.RestElement
]);
isOneOf223([
  NodeType223.TSInterfaceDeclaration,
  NodeType223.TSTypeAliasDeclaration
]);
isOneOf223([
  NodeType223.ArrayExpression,
  NodeType223.ArrayPattern,
  NodeType223.ArrowFunctionExpression,
  NodeType223.CallExpression,
  NodeType223.ClassExpression,
  NodeType223.FunctionExpression,
  NodeType223.Identifier,
  NodeType223.JSXElement,
  NodeType223.JSXFragment,
  NodeType223.Literal,
  NodeType223.TemplateLiteral,
  NodeType223.MemberExpression,
  NodeType223.MetaProperty,
  NodeType223.ObjectExpression,
  NodeType223.ObjectPattern,
  NodeType223.SequenceExpression,
  NodeType223.Super,
  NodeType223.TaggedTemplateExpression,
  NodeType223.ThisExpression
]);
isOneOf223([
  NodeType223.ArrayExpression,
  NodeType223.ArrayPattern,
  NodeType223.ArrowFunctionExpression,
  NodeType223.CallExpression,
  NodeType223.ClassExpression,
  NodeType223.FunctionExpression,
  NodeType223.Identifier,
  NodeType223.JSXElement,
  NodeType223.JSXFragment,
  NodeType223.Literal,
  NodeType223.TemplateLiteral,
  NodeType223.MemberExpression,
  NodeType223.MetaProperty,
  NodeType223.ObjectExpression,
  NodeType223.ObjectPattern,
  NodeType223.SequenceExpression,
  NodeType223.Super,
  NodeType223.TaggedTemplateExpression,
  NodeType223.ThisExpression,
  NodeType223.TSAsExpression,
  NodeType223.TSNonNullExpression,
  NodeType223.TSTypeAssertion
]);
var Function_exports223 = {};
__export2223(Function_exports223, {
  SK: () => SK223,
  absurd: () => absurd223,
  apply: () => apply223,
  compose: () => compose323,
  constFalse: () => constFalse223,
  constNull: () => constNull223,
  constTrue: () => constTrue223,
  constUndefined: () => constUndefined223,
  constVoid: () => constVoid223,
  constant: () => constant223,
  dual: () => dual223,
  flip: () => flip223,
  flow: () => flow223,
  hole: () => hole223,
  identity: () => identity223,
  isFunction: () => isFunction2223,
  pipe: () => pipe223,
  satisfies: () => satisfies223,
  tupled: () => tupled223,
  unsafeCoerce: () => unsafeCoerce223,
  untupled: () => untupled223
});
var isFunction2223 = (input) => typeof input === "function";
var dual223 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a2222, b2222) {
        if (arguments.length >= 2) {
          return body(a2222, b2222);
        }
        return function(self2) {
          return body(self2, a2222);
        };
      };
    case 3:
      return function(a2222, b2222, c2222) {
        if (arguments.length >= 3) {
          return body(a2222, b2222, c2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222);
        };
      };
    case 4:
      return function(a2222, b2222, c2222, d2222) {
        if (arguments.length >= 4) {
          return body(a2222, b2222, c2222, d2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222);
        };
      };
    case 5:
      return function(a2222, b2222, c2222, d2222, e2222) {
        if (arguments.length >= 5) {
          return body(a2222, b2222, c2222, d2222, e2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222, d2222);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply223 = (a2222) => (self2) => self2(a2222);
var identity223 = (a2222) => a2222;
var satisfies223 = () => (b2222) => b2222;
var unsafeCoerce223 = identity223;
var constant223 = (value) => () => value;
var constTrue223 = /* @__PURE__ */ constant223(true);
var constFalse223 = /* @__PURE__ */ constant223(false);
var constNull223 = /* @__PURE__ */ constant223(null);
var constUndefined223 = /* @__PURE__ */ constant223(void 0);
var constVoid223 = constUndefined223;
var flip223 = (f2222) => (...b2222) => (...a2222) => f2222(...a2222)(...b2222);
var compose323 = /* @__PURE__ */ dual223(2, (ab, bc) => (a2222) => bc(ab(a2222)));
var absurd223 = (_2222) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled223 = (f2222) => (a2222) => f2222(...a2222);
var untupled223 = (f2222) => (...a2222) => f2222(a2222);
function pipe223(a2222, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a2222;
    case 2:
      return ab(a2222);
    case 3:
      return bc(ab(a2222));
    case 4:
      return cd(bc(ab(a2222)));
    case 5:
      return de(cd(bc(ab(a2222))));
    case 6:
      return ef(de(cd(bc(ab(a2222)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a2222))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a2222)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a2222))))))));
    default: {
      let ret = arguments[0];
      for (let i2222 = 1; i2222 < arguments.length; i2222++) {
        ret = arguments[i2222](ret);
      }
      return ret;
    }
  }
}
function flow223(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole223 = /* @__PURE__ */ unsafeCoerce223(absurd223);
var SK223 = (_2222, b2222) => b2222;
var make623 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_323 = (map622) => dual223(3, (self2, name22, f2222) => map622(self2, (a2222) => Object.assign({}, a2222, {
  [name22]: f2222(a2222)
})));
var bindTo323 = (map622) => dual223(2, (self2, name22) => map622(self2, (a2222) => ({
  [name22]: a2222
})));
var bind323 = (map622, flatMap4222) => dual223(3, (self2, name22, f2222) => flatMap4222(self2, (a2222) => map622(f2222(a2222), (b2222) => Object.assign({}, a2222, {
  [name22]: b2222
}))));
var moduleVersion223 = "3.2.8";
var getCurrentVersion223 = () => moduleVersion223;
var globalStoreId223 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion223()}`);
if (!(globalStoreId223 in globalThis)) {
  globalThis[globalStoreId223] = /* @__PURE__ */ new Map();
}
var globalStore223 = globalThis[globalStoreId223];
var globalValue223 = (id, compute) => {
  if (!globalStore223.has(id)) {
    globalStore223.set(id, compute());
  }
  return globalStore223.get(id);
};
var Predicate_exports223 = {};
__export2223(Predicate_exports223, {
  all: () => all323,
  and: () => and223,
  compose: () => compose2223,
  eqv: () => eqv223,
  every: () => every223,
  hasProperty: () => hasProperty223,
  implies: () => implies223,
  isBigInt: () => isBigInt223,
  isBoolean: () => isBoolean223,
  isDate: () => isDate223,
  isError: () => isError223,
  isFunction: () => isFunction3223,
  isIterable: () => isIterable223,
  isMap: () => isMap223,
  isNever: () => isNever223,
  isNotNull: () => isNotNull223,
  isNotNullable: () => isNotNullable223,
  isNotUndefined: () => isNotUndefined223,
  isNull: () => isNull223,
  isNullable: () => isNullable223,
  isNumber: () => isNumber223,
  isObject: () => isObject223,
  isPromise: () => isPromise223,
  isPromiseLike: () => isPromiseLike223,
  isReadonlyRecord: () => isReadonlyRecord223,
  isRecord: () => isRecord223,
  isSet: () => isSet223,
  isString: () => isString223,
  isSymbol: () => isSymbol223,
  isTagged: () => isTagged223,
  isTruthy: () => isTruthy223,
  isUint8Array: () => isUint8Array223,
  isUndefined: () => isUndefined223,
  isUnknown: () => isUnknown223,
  mapInput: () => mapInput223,
  nand: () => nand223,
  nor: () => nor223,
  not: () => not223,
  or: () => or223,
  product: () => product323,
  productMany: () => productMany323,
  some: () => some423,
  struct: () => struct423,
  tuple: () => tuple323,
  xor: () => xor223
});
var mapInput223 = /* @__PURE__ */ dual223(2, (self2, f2222) => (b2222) => self2(f2222(b2222)));
var isTruthy223 = (input) => !!input;
var isSet223 = (input) => input instanceof Set;
var isMap223 = (input) => input instanceof Map;
var isString223 = (input) => typeof input === "string";
var isNumber223 = (input) => typeof input === "number";
var isBoolean223 = (input) => typeof input === "boolean";
var isBigInt223 = (input) => typeof input === "bigint";
var isSymbol223 = (input) => typeof input === "symbol";
var isFunction3223 = isFunction2223;
var isUndefined223 = (input) => input === void 0;
var isNotUndefined223 = (input) => input !== void 0;
var isNull223 = (input) => input === null;
var isNotNull223 = (input) => input !== null;
var isNever223 = (_2222) => false;
var isUnknown223 = (_2222) => true;
var isRecordOrArray223 = (input) => typeof input === "object" && input !== null;
var isObject223 = (input) => isRecordOrArray223(input) || isFunction3223(input);
var hasProperty223 = /* @__PURE__ */ dual223(2, (self2, property) => isObject223(self2) && property in self2);
var isTagged223 = /* @__PURE__ */ dual223(2, (self2, tag) => hasProperty223(self2, "_tag") && self2["_tag"] === tag);
var isNullable223 = (input) => input === null || input === void 0;
var isNotNullable223 = (input) => input !== null && input !== void 0;
var isError223 = (input) => input instanceof Error;
var isUint8Array223 = (input) => input instanceof Uint8Array;
var isDate223 = (input) => input instanceof Date;
var isIterable223 = (input) => hasProperty223(input, Symbol.iterator);
var isRecord223 = (input) => isRecordOrArray223(input) && !Array.isArray(input);
var isReadonlyRecord223 = isRecord223;
var isPromise223 = (input) => hasProperty223(input, "then") && "catch" in input && isFunction3223(input.then) && isFunction3223(input.catch);
var isPromiseLike223 = (input) => hasProperty223(input, "then") && isFunction3223(input.then);
var compose2223 = /* @__PURE__ */ dual223(2, (ab, bc) => (a2222) => ab(a2222) && bc(a2222));
var product323 = (self2, that) => ([a2222, b2222]) => self2(a2222) && that(b2222);
var all323 = (collection) => {
  return (as2322) => {
    let collectionIndex = 0;
    for (const p2222 of collection) {
      if (collectionIndex >= as2322.length) {
        break;
      }
      if (p2222(as2322[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany323 = (self2, collection) => {
  const rest = all323(collection);
  return ([head222, ...tail222]) => self2(head222) === false ? false : rest(tail222);
};
var tuple323 = (...elements) => all323(elements);
var struct423 = (fields) => {
  const keys22222 = Object.keys(fields);
  return (a2222) => {
    for (const key of keys22222) {
      if (!fields[key](a2222[key])) {
        return false;
      }
    }
    return true;
  };
};
var not223 = (self2) => (a2222) => !self2(a2222);
var or223 = /* @__PURE__ */ dual223(2, (self2, that) => (a2222) => self2(a2222) || that(a2222));
var and223 = /* @__PURE__ */ dual223(2, (self2, that) => (a2222) => self2(a2222) && that(a2222));
var xor223 = /* @__PURE__ */ dual223(2, (self2, that) => (a2222) => self2(a2222) !== that(a2222));
var eqv223 = /* @__PURE__ */ dual223(2, (self2, that) => (a2222) => self2(a2222) === that(a2222));
var implies223 = /* @__PURE__ */ dual223(2, (self2, that) => (a2222) => self2(a2222) ? that(a2222) : true);
var nor223 = /* @__PURE__ */ dual223(2, (self2, that) => (a2222) => !(self2(a2222) || that(a2222)));
var nand223 = /* @__PURE__ */ dual223(2, (self2, that) => (a2222) => !(self2(a2222) && that(a2222)));
var every223 = (collection) => (a2222) => {
  for (const p2222 of collection) {
    if (!p2222(a2222)) {
      return false;
    }
  }
  return true;
};
var some423 = (collection) => (a2222) => {
  for (const p2222 of collection) {
    if (p2222(a2222)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage223 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId223 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind223 = (u2222) => isObject223(u2222) && GenKindTypeId223 in u2222;
var GenKindImpl223 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity223;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId223] = GenKindTypeId223;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen323(this);
  }
};
var SingleShotGen323 = class _SingleShotGen323 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a2222) {
    return this.called ? {
      value: a2222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a2222) {
    return {
      value: a2222,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e2222) {
    throw e2222;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen323(this.self);
  }
};
var adapter323 = () => function() {
  let x2222 = arguments[0];
  for (let i2222 = 1; i2222 < arguments.length; i2222++) {
    x2222 = arguments[i2222](x2222);
  }
  return new GenKindImpl223(x2222);
};
var defaultIncHi223 = 335903614;
var defaultIncLo223 = 4150755663;
var MUL_HI223 = 1481765933 >>> 0;
var MUL_LO223 = 1284865837 >>> 0;
var BIT_53223 = 9007199254740992;
var BIT_27223 = 134217728;
var PCGRandom223 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable223(seedLo) && isNullable223(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable223(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable223(incLo) && isNullable223(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo223;
      incHi = this._state ? this._state[2] : defaultIncHi223;
    } else if (isNullable223(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add64223(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max322) {
    if (!max322) {
      return this._next();
    }
    max322 = max322 >>> 0;
    if ((max322 & max322 - 1) === 0) {
      return this._next() & max322 - 1;
    }
    let num = 0;
    const skew = (-max322 >>> 0) % max322 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max322;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_27223 + lo) / BIT_53223;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul64223(this._state, oldHi, oldLo, MUL_HI223, MUL_LO223);
    add64223(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul64223(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add64223(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId223 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap223 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId223]() {
    return this.#value;
  }
};
function yieldWrapGet223(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId223 in self2) {
    return self2[YieldWrapTypeId223]();
  }
  throw new Error(getBugErrorMessage223("yieldWrapGet"));
}
var structuralRegionState223 = /* @__PURE__ */ globalValue223("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache223 = /* @__PURE__ */ globalValue223(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr223 = /* @__PURE__ */ globalValue223(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom223());
var symbol323 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash223 = (self2) => {
  if (structuralRegionState223.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number223(self2);
    case "bigint":
      return string223(self2.toString(10));
    case "boolean":
      return string223(String(self2));
    case "symbol":
      return string223(String(self2));
    case "string":
      return string223(self2);
    case "undefined":
      return string223("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string223("null");
      } else if (self2 instanceof Date) {
        return hash223(self2.toISOString());
      } else if (isHash223(self2)) {
        return self2[symbol323]();
      } else {
        return random223(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random223 = (self2) => {
  if (!randomHashCache223.has(self2)) {
    randomHashCache223.set(self2, number223(pcgr223.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache223.get(self2);
};
var combine323 = (b2222) => (self2) => self2 * 53 ^ b2222;
var optimize223 = (n2222) => n2222 & 3221225471 | n2222 >>> 1 & 1073741824;
var isHash223 = (u2222) => hasProperty223(u2222, symbol323);
var number223 = (n2222) => {
  if (n2222 !== n2222 || n2222 === Infinity) {
    return 0;
  }
  let h2222 = n2222 | 0;
  if (h2222 !== n2222) {
    h2222 ^= n2222 * 4294967295;
  }
  while (n2222 > 4294967295) {
    h2222 ^= n2222 /= 4294967295;
  }
  return optimize223(n2222);
};
var string223 = (str) => {
  let h2222 = 5381, i2222 = str.length;
  while (i2222) {
    h2222 = h2222 * 33 ^ str.charCodeAt(--i2222);
  }
  return optimize223(h2222);
};
var structureKeys223 = (o2222, keys22222) => {
  let h2222 = 12289;
  for (let i2222 = 0; i2222 < keys22222.length; i2222++) {
    h2222 ^= pipe223(string223(keys22222[i2222]), combine323(hash223(o2222[keys22222[i2222]])));
  }
  return optimize223(h2222);
};
var structure223 = (o2222) => structureKeys223(o2222, Object.keys(o2222));
var array323 = (arr) => {
  let h2222 = 6151;
  for (let i2222 = 0; i2222 < arr.length; i2222++) {
    h2222 = pipe223(h2222, combine323(hash223(arr[i2222])));
  }
  return optimize223(h2222);
};
var cached223 = function() {
  if (arguments.length === 1) {
    const self22 = arguments[0];
    return function(hash3222) {
      Object.defineProperty(self22, symbol323, {
        value() {
          return hash3222;
        },
        enumerable: false
      });
      return hash3222;
    };
  }
  const self2 = arguments[0];
  const hash2322 = arguments[1];
  Object.defineProperty(self2, symbol323, {
    value() {
      return hash2322;
    },
    enumerable: false
  });
  return hash2322;
};
var symbol2223 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals223() {
  if (arguments.length === 1) {
    return (self2) => compareBoth223(self2, arguments[0]);
  }
  return compareBoth223(arguments[0], arguments[1]);
}
function compareBoth223(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual223(self2) && isEqual223(that)) {
        if (hash223(self2) === hash223(that) && self2[symbol2223](that)) {
          return true;
        } else {
          return structuralRegionState223.enabled && structuralRegionState223.tester ? structuralRegionState223.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState223.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v2222, i2222) => compareBoth223(v2222, that[i2222]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth223(self2[key], that[key]))) {
              return structuralRegionState223.tester ? structuralRegionState223.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState223.tester ? structuralRegionState223.tester(self2, that) : false;
    }
  }
  return structuralRegionState223.enabled && structuralRegionState223.tester ? structuralRegionState223.tester(self2, that) : false;
}
var isEqual223 = (u2222) => hasProperty223(u2222, symbol2223);
var equivalence223 = () => equals223;
var NodeInspectSymbol223 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON223 = (x2222) => {
  if (hasProperty223(x2222, "toJSON") && isFunction3223(x2222["toJSON"]) && x2222["toJSON"].length === 0) {
    return x2222.toJSON();
  } else if (Array.isArray(x2222)) {
    return x2222.map(toJSON223);
  }
  return x2222;
};
var format223 = (x2222) => JSON.stringify(x2222, null, 2);
var pipeArguments223 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i2222 = 0, len = args.length; i2222 < len; i2222++) {
        ret = args[i2222](ret);
      }
      return ret;
    }
  }
};
var OP_COMMIT223 = "Commit";
var OP_FAILURE223 = "Failure";
var OP_WITH_RUNTIME223 = "WithRuntime";
var EffectTypeId323 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId223 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId223 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId223 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance223 = {
  /* c8 ignore next */
  _R: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _A: (_2222) => _2222,
  _V: /* @__PURE__ */ getCurrentVersion223()
};
var sinkVariance223 = {
  /* c8 ignore next */
  _A: (_2222) => _2222,
  /* c8 ignore next */
  _In: (_2222) => _2222,
  /* c8 ignore next */
  _L: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _R: (_2222) => _2222
};
var channelVariance223 = {
  /* c8 ignore next */
  _Env: (_2222) => _2222,
  /* c8 ignore next */
  _InErr: (_2222) => _2222,
  /* c8 ignore next */
  _InElem: (_2222) => _2222,
  /* c8 ignore next */
  _InDone: (_2222) => _2222,
  /* c8 ignore next */
  _OutErr: (_2222) => _2222,
  /* c8 ignore next */
  _OutElem: (_2222) => _2222,
  /* c8 ignore next */
  _OutDone: (_2222) => _2222
};
var EffectPrototype223 = {
  [EffectTypeId323]: effectVariance223,
  [StreamTypeId223]: effectVariance223,
  [SinkTypeId223]: sinkVariance223,
  [ChannelTypeId223]: channelVariance223,
  [symbol2223](that) {
    return this === that;
  },
  [symbol323]() {
    return cached223(this, random223(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen323(new YieldWrap223(this));
  },
  pipe() {
    return pipeArguments223(this, arguments);
  }
};
var StructuralPrototype223 = {
  [symbol323]() {
    return cached223(this, structure223(this));
  },
  [symbol2223](that) {
    const selfKeys = Object.keys(this);
    const thatKeys = Object.keys(that);
    if (selfKeys.length !== thatKeys.length) {
      return false;
    }
    for (const key of selfKeys) {
      if (!(key in that && equals223(this[key], that[key]))) {
        return false;
      }
    }
    return true;
  }
};
var CommitPrototype223 = {
  ...EffectPrototype223,
  _op: OP_COMMIT223
};
var StructuralCommitPrototype223 = {
  ...CommitPrototype223,
  ...StructuralPrototype223
};
var TypeId623 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto323 = {
  ...EffectPrototype223,
  [TypeId623]: {
    _A: (_2222) => _2222
  },
  [NodeInspectSymbol223]() {
    return this.toJSON();
  },
  toString() {
    return format223(this.toJSON());
  }
};
var SomeProto223 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto323), {
  _tag: "Some",
  _op: "Some",
  [symbol2223](that) {
    return isOption323(that) && isSome323(that) && equals223(this.value, that.value);
  },
  [symbol323]() {
    return cached223(this, combine323(hash223(this._tag))(hash223(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON223(this.value)
    };
  }
});
var NoneHash223 = /* @__PURE__ */ hash223("None");
var NoneProto223 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto323), {
  _tag: "None",
  _op: "None",
  [symbol2223](that) {
    return isOption323(that) && isNone323(that);
  },
  [symbol323]() {
    return NoneHash223;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption323 = (input) => hasProperty223(input, TypeId623);
var isNone323 = (fa) => fa._tag === "None";
var isSome323 = (fa) => fa._tag === "Some";
var none323 = /* @__PURE__ */ Object.create(NoneProto223);
var some2223 = (value) => {
  const a2222 = Object.create(SomeProto223);
  a2222.value = value;
  return a2222;
};
var TypeId2223 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto2223 = {
  ...EffectPrototype223,
  [TypeId2223]: {
    _R: (_2222) => _2222
  },
  [NodeInspectSymbol223]() {
    return this.toJSON();
  },
  toString() {
    return format223(this.toJSON());
  }
};
var RightProto223 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto2223), {
  _tag: "Right",
  _op: "Right",
  [symbol2223](that) {
    return isEither223(that) && isRight223(that) && equals223(this.right, that.right);
  },
  [symbol323]() {
    return combine323(hash223(this._tag))(hash223(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON223(this.right)
    };
  }
});
var LeftProto223 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto2223), {
  _tag: "Left",
  _op: "Left",
  [symbol2223](that) {
    return isEither223(that) && isLeft223(that) && equals223(this.left, that.left);
  },
  [symbol323]() {
    return combine323(hash223(this._tag))(hash223(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON223(this.left)
    };
  }
});
var isEither223 = (input) => hasProperty223(input, TypeId2223);
var isLeft223 = (ma) => ma._tag === "Left";
var isRight223 = (ma) => ma._tag === "Right";
var left323 = (left32222) => {
  const a2222 = Object.create(LeftProto223);
  a2222.left = left32222;
  return a2222;
};
var right323 = (right32222) => {
  const a2222 = Object.create(RightProto223);
  a2222.right = right32222;
  return a2222;
};
var getLeft323 = (self2) => isRight223(self2) ? none323 : some2223(self2.left);
var getRight323 = (self2) => isLeft223(self2) ? none323 : some2223(self2.right);
var right2223 = right323;
var left2223 = left323;
var Option_exports223 = {};
__export2223(Option_exports223, {
  Do: () => Do223,
  TypeId: () => TypeId3223,
  all: () => all2223,
  andThen: () => andThen223,
  ap: () => ap223,
  as: () => as223,
  asVoid: () => asVoid223,
  bind: () => bind2223,
  bindTo: () => bindTo2223,
  composeK: () => composeK223,
  contains: () => contains223,
  containsWith: () => containsWith223,
  exists: () => exists223,
  filter: () => filter223,
  filterMap: () => filterMap223,
  firstSomeOf: () => firstSomeOf223,
  flatMap: () => flatMap223,
  flatMapNullable: () => flatMapNullable223,
  flatten: () => flatten223,
  fromIterable: () => fromIterable323,
  fromNullable: () => fromNullable223,
  gen: () => gen223,
  getEquivalence: () => getEquivalence323,
  getLeft: () => getLeft2223,
  getOrElse: () => getOrElse223,
  getOrNull: () => getOrNull223,
  getOrThrow: () => getOrThrow223,
  getOrThrowWith: () => getOrThrowWith223,
  getOrUndefined: () => getOrUndefined223,
  getOrder: () => getOrder223,
  getRight: () => getRight2223,
  isNone: () => isNone2223,
  isOption: () => isOption2223,
  isSome: () => isSome2223,
  let: () => let_2223,
  lift2: () => lift2223,
  liftNullable: () => liftNullable223,
  liftPredicate: () => liftPredicate223,
  liftThrowable: () => liftThrowable223,
  map: () => map223,
  match: () => match2223,
  none: () => none2223,
  orElse: () => orElse223,
  orElseEither: () => orElseEither223,
  orElseSome: () => orElseSome223,
  partitionMap: () => partitionMap223,
  product: () => product2223,
  productMany: () => productMany2223,
  reduceCompact: () => reduceCompact223,
  some: () => some3223,
  tap: () => tap223,
  toArray: () => toArray223,
  toRefinement: () => toRefinement223,
  void: () => void_223,
  zipLeft: () => zipLeft223,
  zipRight: () => zipRight223,
  zipWith: () => zipWith223
});
var make2223 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId3223 = /* @__PURE__ */ Symbol.for("effect/Option");
var none2223 = () => none323;
var some3223 = some2223;
var isOption2223 = isOption323;
var isNone2223 = isNone323;
var isSome2223 = isSome323;
var match2223 = /* @__PURE__ */ dual223(2, (self2, {
  onNone,
  onSome
}) => isNone2223(self2) ? onNone() : onSome(self2.value));
var toRefinement223 = (f2222) => (a2222) => isSome2223(f2222(a2222));
var fromIterable323 = (collection) => {
  for (const a2222 of collection) {
    return some3223(a2222);
  }
  return none2223();
};
var getRight2223 = getRight323;
var getLeft2223 = getLeft323;
var getOrElse223 = /* @__PURE__ */ dual223(2, (self2, onNone) => isNone2223(self2) ? onNone() : self2.value);
var orElse223 = /* @__PURE__ */ dual223(2, (self2, that) => isNone2223(self2) ? that() : self2);
var orElseSome223 = /* @__PURE__ */ dual223(2, (self2, onNone) => isNone2223(self2) ? some3223(onNone()) : self2);
var orElseEither223 = /* @__PURE__ */ dual223(2, (self2, that) => isNone2223(self2) ? map223(that(), right323) : map223(self2, left323));
var firstSomeOf223 = (collection) => {
  let out = none2223();
  for (out of collection) {
    if (isSome2223(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable223 = (nullableValue) => nullableValue == null ? none2223() : some3223(nullableValue);
var liftNullable223 = (f2222) => (...a2222) => fromNullable223(f2222(...a2222));
var getOrNull223 = /* @__PURE__ */ getOrElse223(constNull223);
var getOrUndefined223 = /* @__PURE__ */ getOrElse223(constUndefined223);
var liftThrowable223 = (f2222) => (...a2222) => {
  try {
    return some3223(f2222(...a2222));
  } catch (e2222) {
    return none2223();
  }
};
var getOrThrowWith223 = /* @__PURE__ */ dual223(2, (self2, onNone) => {
  if (isSome2223(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow223 = /* @__PURE__ */ getOrThrowWith223(() => new Error("getOrThrow called on a None"));
var map223 = /* @__PURE__ */ dual223(2, (self2, f2222) => isNone2223(self2) ? none2223() : some3223(f2222(self2.value)));
var as223 = /* @__PURE__ */ dual223(2, (self2, b2222) => map223(self2, () => b2222));
var asVoid223 = /* @__PURE__ */ as223(void 0);
var void_223 = /* @__PURE__ */ some3223(void 0);
var flatMap223 = /* @__PURE__ */ dual223(2, (self2, f2222) => isNone2223(self2) ? none2223() : f2222(self2.value));
var andThen223 = /* @__PURE__ */ dual223(2, (self2, f2222) => flatMap223(self2, (a2222) => {
  const b2222 = isFunction2223(f2222) ? f2222(a2222) : f2222;
  return isOption2223(b2222) ? b2222 : some3223(b2222);
}));
var flatMapNullable223 = /* @__PURE__ */ dual223(2, (self2, f2222) => isNone2223(self2) ? none2223() : fromNullable223(f2222(self2.value)));
var flatten223 = /* @__PURE__ */ flatMap223(identity223);
var zipRight223 = /* @__PURE__ */ dual223(2, (self2, that) => flatMap223(self2, () => that));
var composeK223 = /* @__PURE__ */ dual223(2, (afb, bfc) => (a2222) => flatMap223(afb(a2222), bfc));
var zipLeft223 = /* @__PURE__ */ dual223(2, (self2, that) => tap223(self2, () => that));
var tap223 = /* @__PURE__ */ dual223(2, (self2, f2222) => flatMap223(self2, (a2222) => map223(f2222(a2222), () => a2222)));
var product2223 = (self2, that) => isSome2223(self2) && isSome2223(that) ? some3223([self2.value, that.value]) : none2223();
var productMany2223 = (self2, collection) => {
  if (isNone2223(self2)) {
    return none2223();
  }
  const out = [self2.value];
  for (const o2222 of collection) {
    if (isNone2223(o2222)) {
      return none2223();
    }
    out.push(o2222.value);
  }
  return some3223(out);
};
var all2223 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o2222 of input) {
      if (isNone2223(o2222)) {
        return none2223();
      }
      out2.push(o2222.value);
    }
    return some3223(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o2222 = input[key];
    if (isNone2223(o2222)) {
      return none2223();
    }
    out[key] = o2222.value;
  }
  return some3223(out);
};
var zipWith223 = /* @__PURE__ */ dual223(3, (self2, that, f2222) => map223(product2223(self2, that), ([a2222, b2222]) => f2222(a2222, b2222)));
var ap223 = /* @__PURE__ */ dual223(2, (self2, that) => zipWith223(self2, that, (f2222, a2222) => f2222(a2222)));
var reduceCompact223 = /* @__PURE__ */ dual223(3, (self2, b2222, f2222) => {
  let out = b2222;
  for (const oa of self2) {
    if (isSome2223(oa)) {
      out = f2222(out, oa.value);
    }
  }
  return out;
});
var toArray223 = (self2) => isNone2223(self2) ? [] : [self2.value];
var partitionMap223 = /* @__PURE__ */ dual223(2, (self2, f2222) => {
  if (isNone2223(self2)) {
    return [none2223(), none2223()];
  }
  const e2222 = f2222(self2.value);
  return isLeft223(e2222) ? [some3223(e2222.left), none2223()] : [none2223(), some3223(e2222.right)];
});
var filterMap223 = /* @__PURE__ */ dual223(2, (self2, f2222) => isNone2223(self2) ? none2223() : f2222(self2.value));
var filter223 = /* @__PURE__ */ dual223(2, (self2, predicate) => filterMap223(self2, (b2222) => predicate(b2222) ? some2223(b2222) : none323));
var getEquivalence323 = (isEquivalent) => make623((x2222, y2222) => x2222 === y2222 || (isNone2223(x2222) ? isNone2223(y2222) : isNone2223(y2222) ? false : isEquivalent(x2222.value, y2222.value)));
var getOrder223 = (O2222) => make2223((self2, that) => isSome2223(self2) ? isSome2223(that) ? O2222(self2.value, that.value) : 1 : -1);
var lift2223 = (f2222) => dual223(2, (self2, that) => zipWith223(self2, that, f2222));
var liftPredicate223 = (predicate) => (b2222) => predicate(b2222) ? some3223(b2222) : none2223();
var containsWith223 = (isEquivalent) => dual223(2, (self2, a2222) => isNone2223(self2) ? false : isEquivalent(self2.value, a2222));
var _equivalence323 = /* @__PURE__ */ equivalence223();
var contains223 = /* @__PURE__ */ containsWith223(_equivalence323);
var exists223 = /* @__PURE__ */ dual223(2, (self2, refinement) => isNone2223(self2) ? false : refinement(self2.value));
var bindTo2223 = /* @__PURE__ */ bindTo323(map223);
var let_2223 = /* @__PURE__ */ let_323(map223);
var bind2223 = /* @__PURE__ */ bind323(map223, flatMap223);
var Do223 = /* @__PURE__ */ some3223({});
var adapter2223 = /* @__PURE__ */ adapter323();
var gen223 = (f2222) => {
  const iterator = f2222(adapter2223);
  let state = iterator.next();
  if (state.done) {
    return some3223(state.value);
  } else {
    let current = state.value;
    if (isGenKind223(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet223(current);
    }
    if (isNone2223(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind223(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet223(current);
        }
        if (isNone2223(current)) {
          return current;
        }
      }
    }
    return some3223(state.value);
  }
};
var fromIterable2223 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var reverse323 = (self2) => Array.from(self2).reverse();
var reduce323 = /* @__PURE__ */ dual223(3, (self2, b2222, f2222) => fromIterable2223(self2).reduce((b22222, a2222, i2222) => f2222(b22222, a2222, i2222), b2222));
var TagTypeId223 = /* @__PURE__ */ Symbol.for("effect/Context/Tag");
var STMSymbolKey223 = "effect/STM";
var STMTypeId223 = /* @__PURE__ */ Symbol.for(STMSymbolKey223);
var TagProto223 = {
  ...EffectPrototype223,
  _tag: "Tag",
  _op: "Tag",
  [STMTypeId223]: effectVariance223,
  [TagTypeId223]: {
    _Service: (_2222) => _2222,
    _Identifier: (_2222) => _2222
  },
  toString() {
    return format223(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Tag",
      key: this.key,
      stack: this.stack
    };
  },
  [NodeInspectSymbol223]() {
    return this.toJSON();
  },
  of(self2) {
    return self2;
  },
  context(self2) {
    return make3223(this, self2);
  }
};
var makeGenericTag223 = (key) => {
  const limit = Error.stackTraceLimit;
  Error.stackTraceLimit = 2;
  const creationError = new Error();
  Error.stackTraceLimit = limit;
  const tag = Object.create(TagProto223);
  Object.defineProperty(tag, "stack", {
    get() {
      return creationError.stack;
    }
  });
  tag.key = key;
  return tag;
};
var TypeId4223 = /* @__PURE__ */ Symbol.for("effect/Context");
var ContextProto223 = {
  [TypeId4223]: {
    _Services: (_2222) => _2222
  },
  [symbol2223](that) {
    if (isContext223(that)) {
      if (this.unsafeMap.size === that.unsafeMap.size) {
        for (const k2222 of this.unsafeMap.keys()) {
          if (!that.unsafeMap.has(k2222) || !equals223(this.unsafeMap.get(k2222), that.unsafeMap.get(k2222))) {
            return false;
          }
        }
        return true;
      }
    }
    return false;
  },
  [symbol323]() {
    return cached223(this, number223(this.unsafeMap.size));
  },
  pipe() {
    return pipeArguments223(this, arguments);
  },
  toString() {
    return format223(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Context",
      services: Array.from(this.unsafeMap).map(toJSON223)
    };
  },
  [NodeInspectSymbol223]() {
    return this.toJSON();
  }
};
var makeContext223 = (unsafeMap) => {
  const context = Object.create(ContextProto223);
  context.unsafeMap = unsafeMap;
  return context;
};
var isContext223 = (u2222) => hasProperty223(u2222, TypeId4223);
var _empty623 = /* @__PURE__ */ makeContext223(/* @__PURE__ */ new Map());
var empty823 = () => _empty623;
var make3223 = (tag, service) => makeContext223(/* @__PURE__ */ new Map([[tag.key, service]]));
var GenericTag223 = makeGenericTag223;
var empty2223 = empty823;
var TypeId5223 = /* @__PURE__ */ Symbol.for("effect/Chunk");
function copy223(src, srcPos, dest, destPos, len) {
  for (let i2222 = srcPos; i2222 < Math.min(src.length, srcPos + len); i2222++) {
    dest[destPos + i2222 - srcPos] = src[i2222];
  }
  return dest;
}
var emptyArray223 = [];
var getEquivalence2223 = (isEquivalent) => make623((self2, that) => self2.length === that.length && toReadonlyArray223(self2).every((value, i2222) => isEquivalent(value, unsafeGet2223(that, i2222))));
var _equivalence2223 = /* @__PURE__ */ getEquivalence2223(equals223);
var ChunkProto223 = {
  [TypeId5223]: {
    _A: (_2222) => _2222
  },
  toString() {
    return format223(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Chunk",
      values: toReadonlyArray223(this).map(toJSON223)
    };
  },
  [NodeInspectSymbol223]() {
    return this.toJSON();
  },
  [symbol2223](that) {
    return isChunk223(that) && _equivalence2223(this, that);
  },
  [symbol323]() {
    return cached223(this, array323(toReadonlyArray223(this)));
  },
  [Symbol.iterator]() {
    switch (this.backing._tag) {
      case "IArray": {
        return this.backing.array[Symbol.iterator]();
      }
      case "IEmpty": {
        return emptyArray223[Symbol.iterator]();
      }
      default: {
        return toReadonlyArray223(this)[Symbol.iterator]();
      }
    }
  },
  pipe() {
    return pipeArguments223(this, arguments);
  }
};
var makeChunk223 = (backing) => {
  const chunk = Object.create(ChunkProto223);
  chunk.backing = backing;
  switch (backing._tag) {
    case "IEmpty": {
      chunk.length = 0;
      chunk.depth = 0;
      chunk.left = chunk;
      chunk.right = chunk;
      break;
    }
    case "IConcat": {
      chunk.length = backing.left.length + backing.right.length;
      chunk.depth = 1 + Math.max(backing.left.depth, backing.right.depth);
      chunk.left = backing.left;
      chunk.right = backing.right;
      break;
    }
    case "IArray": {
      chunk.length = backing.array.length;
      chunk.depth = 0;
      chunk.left = _empty2223;
      chunk.right = _empty2223;
      break;
    }
    case "ISingleton": {
      chunk.length = 1;
      chunk.depth = 0;
      chunk.left = _empty2223;
      chunk.right = _empty2223;
      break;
    }
    case "ISlice": {
      chunk.length = backing.length;
      chunk.depth = backing.chunk.depth + 1;
      chunk.left = _empty2223;
      chunk.right = _empty2223;
      break;
    }
  }
  return chunk;
};
var isChunk223 = (u2222) => hasProperty223(u2222, TypeId5223);
var _empty2223 = /* @__PURE__ */ makeChunk223({
  _tag: "IEmpty"
});
var empty3223 = () => _empty2223;
var make4223 = (...as2322) => as2322.length === 1 ? of223(as2322[0]) : unsafeFromNonEmptyArray223(as2322);
var of223 = (a2222) => makeChunk223({
  _tag: "ISingleton",
  a: a2222
});
var copyToArray223 = (self2, array32222, initial) => {
  switch (self2.backing._tag) {
    case "IArray": {
      copy223(self2.backing.array, 0, array32222, initial, self2.length);
      break;
    }
    case "IConcat": {
      copyToArray223(self2.left, array32222, initial);
      copyToArray223(self2.right, array32222, initial + self2.left.length);
      break;
    }
    case "ISingleton": {
      array32222[initial] = self2.backing.a;
      break;
    }
    case "ISlice": {
      let i2222 = 0;
      let j2222 = initial;
      while (i2222 < self2.length) {
        array32222[j2222] = unsafeGet2223(self2, i2222);
        i2222 += 1;
        j2222 += 1;
      }
      break;
    }
  }
};
var toReadonlyArray223 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      return emptyArray223;
    }
    case "IArray": {
      return self2.backing.array;
    }
    default: {
      const arr = new Array(self2.length);
      copyToArray223(self2, arr, 0);
      self2.backing = {
        _tag: "IArray",
        array: arr
      };
      self2.left = _empty2223;
      self2.right = _empty2223;
      self2.depth = 0;
      return arr;
    }
  }
};
var reverse2223 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty":
    case "ISingleton":
      return self2;
    case "IArray": {
      return makeChunk223({
        _tag: "IArray",
        array: reverse323(self2.backing.array)
      });
    }
    case "IConcat": {
      return makeChunk223({
        _tag: "IConcat",
        left: reverse2223(self2.backing.right),
        right: reverse2223(self2.backing.left)
      });
    }
    case "ISlice":
      return unsafeFromArray223(reverse323(toReadonlyArray223(self2)));
  }
};
var unsafeFromArray223 = (self2) => makeChunk223({
  _tag: "IArray",
  array: self2
});
var unsafeFromNonEmptyArray223 = (self2) => unsafeFromArray223(self2);
var unsafeGet2223 = /* @__PURE__ */ dual223(2, (self2, index) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      throw new Error(`Index out of bounds`);
    }
    case "ISingleton": {
      if (index !== 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.a;
    }
    case "IArray": {
      if (index >= self2.length || index < 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.array[index];
    }
    case "IConcat": {
      return index < self2.left.length ? unsafeGet2223(self2.left, index) : unsafeGet2223(self2.right, index - self2.left.length);
    }
    case "ISlice": {
      return unsafeGet2223(self2.backing.chunk, index + self2.backing.offset);
    }
  }
});
var prepend223 = /* @__PURE__ */ dual223(2, (self2, elem) => appendAll223(of223(elem), self2));
var drop223 = /* @__PURE__ */ dual223(2, (self2, n2222) => {
  if (n2222 <= 0) {
    return self2;
  } else if (n2222 >= self2.length) {
    return _empty2223;
  } else {
    switch (self2.backing._tag) {
      case "ISlice": {
        return makeChunk223({
          _tag: "ISlice",
          chunk: self2.backing.chunk,
          offset: self2.backing.offset + n2222,
          length: self2.backing.length - n2222
        });
      }
      case "IConcat": {
        if (n2222 > self2.left.length) {
          return drop223(self2.right, n2222 - self2.left.length);
        }
        return makeChunk223({
          _tag: "IConcat",
          left: drop223(self2.left, n2222),
          right: self2.right
        });
      }
      default: {
        return makeChunk223({
          _tag: "ISlice",
          chunk: self2,
          offset: n2222,
          length: self2.length - n2222
        });
      }
    }
  }
});
var appendAll223 = /* @__PURE__ */ dual223(2, (self2, that) => {
  if (self2.backing._tag === "IEmpty") {
    return that;
  }
  if (that.backing._tag === "IEmpty") {
    return self2;
  }
  const diff22222 = that.depth - self2.depth;
  if (Math.abs(diff22222) <= 1) {
    return makeChunk223({
      _tag: "IConcat",
      left: self2,
      right: that
    });
  } else if (diff22222 < -1) {
    if (self2.left.depth >= self2.right.depth) {
      const nr = appendAll223(self2.right, that);
      return makeChunk223({
        _tag: "IConcat",
        left: self2.left,
        right: nr
      });
    } else {
      const nrr = appendAll223(self2.right.right, that);
      if (nrr.depth === self2.depth - 3) {
        const nr = makeChunk223({
          _tag: "IConcat",
          left: self2.right.left,
          right: nrr
        });
        return makeChunk223({
          _tag: "IConcat",
          left: self2.left,
          right: nr
        });
      } else {
        const nl = makeChunk223({
          _tag: "IConcat",
          left: self2.left,
          right: self2.right.left
        });
        return makeChunk223({
          _tag: "IConcat",
          left: nl,
          right: nrr
        });
      }
    }
  } else {
    if (that.right.depth >= that.left.depth) {
      const nl = appendAll223(self2, that.left);
      return makeChunk223({
        _tag: "IConcat",
        left: nl,
        right: that.right
      });
    } else {
      const nll = appendAll223(self2, that.left.left);
      if (nll.depth === that.depth - 3) {
        const nl = makeChunk223({
          _tag: "IConcat",
          left: nll,
          right: that.left.right
        });
        return makeChunk223({
          _tag: "IConcat",
          left: nl,
          right: that.right
        });
      } else {
        const nr = makeChunk223({
          _tag: "IConcat",
          left: that.left.right,
          right: that.right
        });
        return makeChunk223({
          _tag: "IConcat",
          left: nll,
          right: nr
        });
      }
    }
  }
});
var isEmpty223 = (self2) => self2.length === 0;
var isNonEmpty223 = (self2) => self2.length > 0;
var unsafeHead223 = (self2) => unsafeGet2223(self2, 0);
var headNonEmpty223 = unsafeHead223;
var tailNonEmpty223 = (self2) => drop223(self2, 1);
var SIZE223 = 5;
var BUCKET_SIZE223 = /* @__PURE__ */ Math.pow(2, SIZE223);
var MASK223 = BUCKET_SIZE223 - 1;
var MAX_INDEX_NODE223 = BUCKET_SIZE223 / 2;
var MIN_ARRAY_NODE223 = BUCKET_SIZE223 / 4;
function popcount223(x2222) {
  x2222 -= x2222 >> 1 & 1431655765;
  x2222 = (x2222 & 858993459) + (x2222 >> 2 & 858993459);
  x2222 = x2222 + (x2222 >> 4) & 252645135;
  x2222 += x2222 >> 8;
  x2222 += x2222 >> 16;
  return x2222 & 127;
}
function hashFragment223(shift22, h2222) {
  return h2222 >>> shift22 & MASK223;
}
function toBitmap223(x2222) {
  return 1 << x2222;
}
function fromBitmap223(bitmap, bit) {
  return popcount223(bitmap & bit - 1);
}
var make5223 = (value, previous) => ({
  value,
  previous
});
function arrayUpdate223(mutate22222, at, v2222, arr) {
  let out = arr;
  if (!mutate22222) {
    const len = arr.length;
    out = new Array(len);
    for (let i2222 = 0; i2222 < len; ++i2222) out[i2222] = arr[i2222];
  }
  out[at] = v2222;
  return out;
}
function arraySpliceOut223(mutate22222, at, arr) {
  const newLen = arr.length - 1;
  let i2222 = 0;
  let g2222 = 0;
  let out = arr;
  if (mutate22222) {
    i2222 = g2222 = at;
  } else {
    out = new Array(newLen);
    while (i2222 < at) out[g2222++] = arr[i2222++];
  }
  ++i2222;
  while (i2222 <= newLen) out[g2222++] = arr[i2222++];
  if (mutate22222) {
    out.length = newLen;
  }
  return out;
}
function arraySpliceIn223(mutate22222, at, v2222, arr) {
  const len = arr.length;
  if (mutate22222) {
    let i22222 = len;
    while (i22222 >= at) arr[i22222--] = arr[i22222];
    arr[at] = v2222;
    return arr;
  }
  let i2222 = 0, g2222 = 0;
  const out = new Array(len + 1);
  while (i2222 < at) out[g2222++] = arr[i2222++];
  out[at] = v2222;
  while (i2222 < len) out[++g2222] = arr[i2222++];
  return out;
}
var EmptyNode223 = class _EmptyNode223 {
  _tag = "EmptyNode";
  modify(edit, _shift, f2222, hash2322, key, size42222) {
    const v2222 = f2222(none2223());
    if (isNone2223(v2222)) return new _EmptyNode223();
    ++size42222.value;
    return new LeafNode223(edit, hash2322, key, v2222);
  }
};
function isEmptyNode223(a2222) {
  return isTagged223(a2222, "EmptyNode");
}
function isLeafNode223(node) {
  return isEmptyNode223(node) || node._tag === "LeafNode" || node._tag === "CollisionNode";
}
function canEditNode223(node, edit) {
  return isEmptyNode223(node) ? false : edit === node.edit;
}
var LeafNode223 = class _LeafNode223 {
  edit;
  hash;
  key;
  value;
  _tag = "LeafNode";
  constructor(edit, hash2322, key, value) {
    this.edit = edit;
    this.hash = hash2322;
    this.key = key;
    this.value = value;
  }
  modify(edit, shift22, f2222, hash2322, key, size42222) {
    if (equals223(key, this.key)) {
      const v22222 = f2222(this.value);
      if (v22222 === this.value) return this;
      else if (isNone2223(v22222)) {
        --size42222.value;
        return new EmptyNode223();
      }
      if (canEditNode223(this, edit)) {
        this.value = v22222;
        return this;
      }
      return new _LeafNode223(edit, hash2322, key, v22222);
    }
    const v2222 = f2222(none2223());
    if (isNone2223(v2222)) return this;
    ++size42222.value;
    return mergeLeaves223(edit, shift22, this.hash, this, hash2322, new _LeafNode223(edit, hash2322, key, v2222));
  }
};
var CollisionNode223 = class _CollisionNode223 {
  edit;
  hash;
  children;
  _tag = "CollisionNode";
  constructor(edit, hash2322, children) {
    this.edit = edit;
    this.hash = hash2322;
    this.children = children;
  }
  modify(edit, shift22, f2222, hash2322, key, size42222) {
    if (hash2322 === this.hash) {
      const canEdit = canEditNode223(this, edit);
      const list = this.updateCollisionList(canEdit, edit, this.hash, this.children, f2222, key, size42222);
      if (list === this.children) return this;
      return list.length > 1 ? new _CollisionNode223(edit, this.hash, list) : list[0];
    }
    const v2222 = f2222(none2223());
    if (isNone2223(v2222)) return this;
    ++size42222.value;
    return mergeLeaves223(edit, shift22, this.hash, this, hash2322, new LeafNode223(edit, hash2322, key, v2222));
  }
  updateCollisionList(mutate22222, edit, hash2322, list, f2222, key, size42222) {
    const len = list.length;
    for (let i2222 = 0; i2222 < len; ++i2222) {
      const child = list[i2222];
      if ("key" in child && equals223(key, child.key)) {
        const value = child.value;
        const newValue2 = f2222(value);
        if (newValue2 === value) return list;
        if (isNone2223(newValue2)) {
          --size42222.value;
          return arraySpliceOut223(mutate22222, i2222, list);
        }
        return arrayUpdate223(mutate22222, i2222, new LeafNode223(edit, hash2322, key, newValue2), list);
      }
    }
    const newValue = f2222(none2223());
    if (isNone2223(newValue)) return list;
    ++size42222.value;
    return arrayUpdate223(mutate22222, len, new LeafNode223(edit, hash2322, key, newValue), list);
  }
};
var IndexedNode223 = class _IndexedNode223 {
  edit;
  mask;
  children;
  _tag = "IndexedNode";
  constructor(edit, mask, children) {
    this.edit = edit;
    this.mask = mask;
    this.children = children;
  }
  modify(edit, shift22, f2222, hash2322, key, size42222) {
    const mask = this.mask;
    const children = this.children;
    const frag = hashFragment223(shift22, hash2322);
    const bit = toBitmap223(frag);
    const indx = fromBitmap223(mask, bit);
    const exists2322 = mask & bit;
    const canEdit = canEditNode223(this, edit);
    if (!exists2322) {
      const _newChild = new EmptyNode223().modify(edit, shift22 + SIZE223, f2222, hash2322, key, size42222);
      if (!_newChild) return this;
      return children.length >= MAX_INDEX_NODE223 ? expand223(edit, frag, _newChild, mask, children) : new _IndexedNode223(edit, mask | bit, arraySpliceIn223(canEdit, indx, _newChild, children));
    }
    const current = children[indx];
    const child = current.modify(edit, shift22 + SIZE223, f2222, hash2322, key, size42222);
    if (current === child) return this;
    let bitmap = mask;
    let newChildren;
    if (isEmptyNode223(child)) {
      bitmap &= ~bit;
      if (!bitmap) return new EmptyNode223();
      if (children.length <= 2 && isLeafNode223(children[indx ^ 1])) {
        return children[indx ^ 1];
      }
      newChildren = arraySpliceOut223(canEdit, indx, children);
    } else {
      newChildren = arrayUpdate223(canEdit, indx, child, children);
    }
    if (canEdit) {
      this.mask = bitmap;
      this.children = newChildren;
      return this;
    }
    return new _IndexedNode223(edit, bitmap, newChildren);
  }
};
var ArrayNode223 = class _ArrayNode223 {
  edit;
  size;
  children;
  _tag = "ArrayNode";
  constructor(edit, size42222, children) {
    this.edit = edit;
    this.size = size42222;
    this.children = children;
  }
  modify(edit, shift22, f2222, hash2322, key, size42222) {
    let count = this.size;
    const children = this.children;
    const frag = hashFragment223(shift22, hash2322);
    const child = children[frag];
    const newChild = (child || new EmptyNode223()).modify(edit, shift22 + SIZE223, f2222, hash2322, key, size42222);
    if (child === newChild) return this;
    const canEdit = canEditNode223(this, edit);
    let newChildren;
    if (isEmptyNode223(child) && !isEmptyNode223(newChild)) {
      ++count;
      newChildren = arrayUpdate223(canEdit, frag, newChild, children);
    } else if (!isEmptyNode223(child) && isEmptyNode223(newChild)) {
      --count;
      if (count <= MIN_ARRAY_NODE223) {
        return pack223(edit, count, frag, children);
      }
      newChildren = arrayUpdate223(canEdit, frag, new EmptyNode223(), children);
    } else {
      newChildren = arrayUpdate223(canEdit, frag, newChild, children);
    }
    if (canEdit) {
      this.size = count;
      this.children = newChildren;
      return this;
    }
    return new _ArrayNode223(edit, count, newChildren);
  }
};
function pack223(edit, count, removed, elements) {
  const children = new Array(count - 1);
  let g2222 = 0;
  let bitmap = 0;
  for (let i2222 = 0, len = elements.length; i2222 < len; ++i2222) {
    if (i2222 !== removed) {
      const elem = elements[i2222];
      if (elem && !isEmptyNode223(elem)) {
        children[g2222++] = elem;
        bitmap |= 1 << i2222;
      }
    }
  }
  return new IndexedNode223(edit, bitmap, children);
}
function expand223(edit, frag, child, bitmap, subNodes) {
  const arr = [];
  let bit = bitmap;
  let count = 0;
  for (let i2222 = 0; bit; ++i2222) {
    if (bit & 1) arr[i2222] = subNodes[count++];
    bit >>>= 1;
  }
  arr[frag] = child;
  return new ArrayNode223(edit, count + 1, arr);
}
function mergeLeavesInner223(edit, shift22, h1, n1, h2222, n2222) {
  if (h1 === h2222) return new CollisionNode223(edit, h1, [n2222, n1]);
  const subH1 = hashFragment223(shift22, h1);
  const subH2 = hashFragment223(shift22, h2222);
  if (subH1 === subH2) {
    return (child) => new IndexedNode223(edit, toBitmap223(subH1) | toBitmap223(subH2), [child]);
  } else {
    const children = subH1 < subH2 ? [n1, n2222] : [n2222, n1];
    return new IndexedNode223(edit, toBitmap223(subH1) | toBitmap223(subH2), children);
  }
}
function mergeLeaves223(edit, shift22, h1, n1, h2222, n2222) {
  let stack = void 0;
  let currentShift = shift22;
  while (true) {
    const res = mergeLeavesInner223(edit, currentShift, h1, n1, h2222, n2222);
    if (typeof res === "function") {
      stack = make5223(res, stack);
      currentShift = currentShift + SIZE223;
    } else {
      let final = res;
      while (stack != null) {
        final = stack.value(final);
        stack = stack.previous;
      }
      return final;
    }
  }
}
var HashMapSymbolKey223 = "effect/HashMap";
var HashMapTypeId223 = /* @__PURE__ */ Symbol.for(HashMapSymbolKey223);
var HashMapProto223 = {
  [HashMapTypeId223]: HashMapTypeId223,
  [Symbol.iterator]() {
    return new HashMapIterator223(this, (k2222, v2222) => [k2222, v2222]);
  },
  [symbol323]() {
    let hash2322 = hash223(HashMapSymbolKey223);
    for (const item of this) {
      hash2322 ^= pipe223(hash223(item[0]), combine323(hash223(item[1])));
    }
    return cached223(this, hash2322);
  },
  [symbol2223](that) {
    if (isHashMap223(that)) {
      if (that._size !== this._size) {
        return false;
      }
      for (const item of this) {
        const elem = pipe223(that, getHash223(item[0], hash223(item[0])));
        if (isNone2223(elem)) {
          return false;
        } else {
          if (!equals223(item[1], elem.value)) {
            return false;
          }
        }
      }
      return true;
    }
    return false;
  },
  toString() {
    return format223(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashMap",
      values: Array.from(this).map(toJSON223)
    };
  },
  [NodeInspectSymbol223]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments223(this, arguments);
  }
};
var makeImpl323 = (editable, edit, root, size42222) => {
  const map622 = Object.create(HashMapProto223);
  map622._editable = editable;
  map622._edit = edit;
  map622._root = root;
  map622._size = size42222;
  return map622;
};
var HashMapIterator223 = class _HashMapIterator223 {
  map;
  f;
  v;
  constructor(map622, f2222) {
    this.map = map622;
    this.f = f2222;
    this.v = visitLazy223(this.map._root, this.f, void 0);
  }
  next() {
    if (isNone2223(this.v)) {
      return {
        done: true,
        value: void 0
      };
    }
    const v0 = this.v.value;
    this.v = applyCont223(v0.cont);
    return {
      done: false,
      value: v0.value
    };
  }
  [Symbol.iterator]() {
    return new _HashMapIterator223(this.map, this.f);
  }
};
var applyCont223 = (cont) => cont ? visitLazyChildren223(cont[0], cont[1], cont[2], cont[3], cont[4]) : none2223();
var visitLazy223 = (node, f2222, cont = void 0) => {
  switch (node._tag) {
    case "LeafNode": {
      if (isSome2223(node.value)) {
        return some3223({
          value: f2222(node.key, node.value.value),
          cont
        });
      }
      return applyCont223(cont);
    }
    case "CollisionNode":
    case "ArrayNode":
    case "IndexedNode": {
      const children = node.children;
      return visitLazyChildren223(children.length, children, 0, f2222, cont);
    }
    default: {
      return applyCont223(cont);
    }
  }
};
var visitLazyChildren223 = (len, children, i2222, f2222, cont) => {
  while (i2222 < len) {
    const child = children[i2222++];
    if (child && !isEmptyNode223(child)) {
      return visitLazy223(child, f2222, [len, children, i2222, f2222, cont]);
    }
  }
  return applyCont223(cont);
};
var _empty3223 = /* @__PURE__ */ makeImpl323(false, 0, /* @__PURE__ */ new EmptyNode223(), 0);
var empty4223 = () => _empty3223;
var isHashMap223 = (u2222) => hasProperty223(u2222, HashMapTypeId223);
var getHash223 = /* @__PURE__ */ dual223(3, (self2, key, hash2322) => {
  let node = self2._root;
  let shift22 = 0;
  while (true) {
    switch (node._tag) {
      case "LeafNode": {
        return equals223(key, node.key) ? node.value : none2223();
      }
      case "CollisionNode": {
        if (hash2322 === node.hash) {
          const children = node.children;
          for (let i2222 = 0, len = children.length; i2222 < len; ++i2222) {
            const child = children[i2222];
            if ("key" in child && equals223(key, child.key)) {
              return child.value;
            }
          }
        }
        return none2223();
      }
      case "IndexedNode": {
        const frag = hashFragment223(shift22, hash2322);
        const bit = toBitmap223(frag);
        if (node.mask & bit) {
          node = node.children[fromBitmap223(node.mask, bit)];
          shift22 += SIZE223;
          break;
        }
        return none2223();
      }
      case "ArrayNode": {
        node = node.children[hashFragment223(shift22, hash2322)];
        if (node) {
          shift22 += SIZE223;
          break;
        }
        return none2223();
      }
      default:
        return none2223();
    }
  }
});
var set223 = /* @__PURE__ */ dual223(3, (self2, key, value) => modifyAt223(self2, key, () => some3223(value)));
var setTree223 = /* @__PURE__ */ dual223(3, (self2, newRoot, newSize) => {
  if (self2._editable) {
    self2._root = newRoot;
    self2._size = newSize;
    return self2;
  }
  return newRoot === self2._root ? self2 : makeImpl323(self2._editable, self2._edit, newRoot, newSize);
});
var keys223 = (self2) => new HashMapIterator223(self2, (key) => key);
var size423 = (self2) => self2._size;
var beginMutation323 = (self2) => makeImpl323(true, self2._edit + 1, self2._root, self2._size);
var modifyAt223 = /* @__PURE__ */ dual223(3, (self2, key, f2222) => modifyHash223(self2, key, hash223(key), f2222));
var modifyHash223 = /* @__PURE__ */ dual223(4, (self2, key, hash2322, f2222) => {
  const size42222 = {
    value: self2._size
  };
  const newRoot = self2._root.modify(self2._editable ? self2._edit : NaN, 0, f2222, hash2322, key, size42222);
  return pipe223(self2, setTree223(newRoot, size42222.value));
});
var forEach323 = /* @__PURE__ */ dual223(2, (self2, f2222) => reduce2223(self2, void 0, (_2222, value, key) => f2222(value, key)));
var reduce2223 = /* @__PURE__ */ dual223(3, (self2, zero, f2222) => {
  const root = self2._root;
  if (root._tag === "LeafNode") {
    return isSome2223(root.value) ? f2222(zero, root.value.value, root.key) : zero;
  }
  if (root._tag === "EmptyNode") {
    return zero;
  }
  const toVisit = [root.children];
  let children;
  while (children = toVisit.pop()) {
    for (let i2222 = 0, len = children.length; i2222 < len; ) {
      const child = children[i2222++];
      if (child && !isEmptyNode223(child)) {
        if (child._tag === "LeafNode") {
          if (isSome2223(child.value)) {
            zero = f2222(zero, child.value.value, child.key);
          }
        } else {
          toVisit.push(child.children);
        }
      }
    }
  }
  return zero;
});
var HashSetSymbolKey223 = "effect/HashSet";
var HashSetTypeId223 = /* @__PURE__ */ Symbol.for(HashSetSymbolKey223);
var HashSetProto223 = {
  [HashSetTypeId223]: HashSetTypeId223,
  [Symbol.iterator]() {
    return keys223(this._keyMap);
  },
  [symbol323]() {
    return cached223(this, combine323(hash223(this._keyMap))(hash223(HashSetSymbolKey223)));
  },
  [symbol2223](that) {
    if (isHashSet223(that)) {
      return size423(this._keyMap) === size423(that._keyMap) && equals223(this._keyMap, that._keyMap);
    }
    return false;
  },
  toString() {
    return format223(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashSet",
      values: Array.from(this).map(toJSON223)
    };
  },
  [NodeInspectSymbol223]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments223(this, arguments);
  }
};
var makeImpl2223 = (keyMap) => {
  const set2322 = Object.create(HashSetProto223);
  set2322._keyMap = keyMap;
  return set2322;
};
var isHashSet223 = (u2222) => hasProperty223(u2222, HashSetTypeId223);
var _empty4223 = /* @__PURE__ */ makeImpl2223(/* @__PURE__ */ empty4223());
var empty5223 = () => _empty4223;
var size2223 = (self2) => size423(self2._keyMap);
var beginMutation2223 = (self2) => makeImpl2223(beginMutation323(self2._keyMap));
var endMutation223 = (self2) => {
  self2._keyMap._editable = false;
  return self2;
};
var mutate223 = /* @__PURE__ */ dual223(2, (self2, f2222) => {
  const transient = beginMutation2223(self2);
  f2222(transient);
  return endMutation223(transient);
});
var add2223 = /* @__PURE__ */ dual223(2, (self2, value) => self2._keyMap._editable ? (set223(value, true)(self2._keyMap), self2) : makeImpl2223(set223(value, true)(self2._keyMap)));
var union2223 = /* @__PURE__ */ dual223(2, (self2, that) => mutate223(empty5223(), (set2322) => {
  forEach2223(self2, (value) => add2223(set2322, value));
  for (const value of that) {
    add2223(set2322, value);
  }
}));
var forEach2223 = /* @__PURE__ */ dual223(2, (self2, f2222) => forEach323(self2._keyMap, (_2222, k2222) => f2222(k2222)));
var empty6223 = empty5223;
var size3223 = size2223;
var add3223 = add2223;
var union3223 = union2223;
var ArrayProto223 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(Array.prototype), {
  [symbol323]() {
    return cached223(this, array323(this));
  },
  [symbol2223](that) {
    if (Array.isArray(that) && this.length === that.length) {
      return this.every((v2222, i2222) => equals223(v2222, that[i2222]));
    } else {
      return false;
    }
  }
});
var Structural323 = /* @__PURE__ */ function() {
  function Structural32222(args) {
    if (args) {
      Object.assign(this, args);
    }
  }
  Structural32222.prototype = StructuralPrototype223;
  return Structural32222;
}();
var struct2223 = (as2322) => Object.assign(Object.create(StructuralPrototype223), as2322);
var ContextPatchTypeId223 = /* @__PURE__ */ Symbol.for("effect/DifferContextPatch");
function variance323(a2222) {
  return a2222;
}
var PatchProto223 = {
  ...Structural323.prototype,
  [ContextPatchTypeId223]: {
    _Value: variance323,
    _Patch: variance323
  }
};
var EmptyProto223 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto223), {
  _tag: "Empty"
});
var _empty5223 = /* @__PURE__ */ Object.create(EmptyProto223);
var empty7223 = () => _empty5223;
var AndThenProto223 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto223), {
  _tag: "AndThen"
});
var makeAndThen223 = (first, second) => {
  const o2222 = Object.create(AndThenProto223);
  o2222.first = first;
  o2222.second = second;
  return o2222;
};
var AddServiceProto223 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto223), {
  _tag: "AddService"
});
var makeAddService223 = (key, service) => {
  const o2222 = Object.create(AddServiceProto223);
  o2222.key = key;
  o2222.service = service;
  return o2222;
};
var RemoveServiceProto223 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto223), {
  _tag: "RemoveService"
});
var makeRemoveService223 = (key) => {
  const o2222 = Object.create(RemoveServiceProto223);
  o2222.key = key;
  return o2222;
};
var UpdateServiceProto223 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto223), {
  _tag: "UpdateService"
});
var makeUpdateService223 = (key, update222) => {
  const o2222 = Object.create(UpdateServiceProto223);
  o2222.key = key;
  o2222.update = update222;
  return o2222;
};
var diff223 = (oldValue, newValue) => {
  const missingServices = new Map(oldValue.unsafeMap);
  let patch22222 = empty7223();
  for (const [tag, newService] of newValue.unsafeMap.entries()) {
    if (missingServices.has(tag)) {
      const old = missingServices.get(tag);
      missingServices.delete(tag);
      if (!equals223(old, newService)) {
        patch22222 = combine2223(makeUpdateService223(tag, () => newService))(patch22222);
      }
    } else {
      missingServices.delete(tag);
      patch22222 = combine2223(makeAddService223(tag, newService))(patch22222);
    }
  }
  for (const [tag] of missingServices.entries()) {
    patch22222 = combine2223(makeRemoveService223(tag))(patch22222);
  }
  return patch22222;
};
var combine2223 = /* @__PURE__ */ dual223(2, (self2, that) => makeAndThen223(self2, that));
var patch223 = /* @__PURE__ */ dual223(2, (self2, context) => {
  if (self2._tag === "Empty") {
    return context;
  }
  let wasServiceUpdated = false;
  let patches = of223(self2);
  const updatedContext = new Map(context.unsafeMap);
  while (isNonEmpty223(patches)) {
    const head222 = headNonEmpty223(patches);
    const tail222 = tailNonEmpty223(patches);
    switch (head222._tag) {
      case "Empty": {
        patches = tail222;
        break;
      }
      case "AddService": {
        updatedContext.set(head222.key, head222.service);
        patches = tail222;
        break;
      }
      case "AndThen": {
        patches = prepend223(prepend223(tail222, head222.second), head222.first);
        break;
      }
      case "RemoveService": {
        updatedContext.delete(head222.key);
        patches = tail222;
        break;
      }
      case "UpdateService": {
        updatedContext.set(head222.key, head222.update(updatedContext.get(head222.key)));
        wasServiceUpdated = true;
        patches = tail222;
        break;
      }
    }
  }
  if (!wasServiceUpdated) {
    return makeContext223(updatedContext);
  }
  const map622 = /* @__PURE__ */ new Map();
  for (const [tag] of context.unsafeMap) {
    if (updatedContext.has(tag)) {
      map622.set(tag, updatedContext.get(tag));
      updatedContext.delete(tag);
    }
  }
  for (const [tag, s2222] of updatedContext) {
    map622.set(tag, s2222);
  }
  return makeContext223(map622);
});
var DifferTypeId223 = /* @__PURE__ */ Symbol.for("effect/Differ");
var DifferProto223 = {
  [DifferTypeId223]: {
    _P: identity223,
    _V: identity223
  }
};
var make7223 = (params) => {
  const differ = Object.create(DifferProto223);
  differ.empty = params.empty;
  differ.diff = params.diff;
  differ.combine = params.combine;
  differ.patch = params.patch;
  return differ;
};
var environment223 = () => make7223({
  empty: empty7223(),
  combine: (first, second) => combine2223(second)(first),
  diff: (oldValue, newValue) => diff223(oldValue, newValue),
  patch: (patch22222, oldValue) => patch223(oldValue)(patch22222)
});
var OP_DIE223 = "Die";
var OP_EMPTY223 = "Empty";
var OP_FAIL223 = "Fail";
var OP_INTERRUPT223 = "Interrupt";
var OP_PARALLEL223 = "Parallel";
var OP_SEQUENTIAL223 = "Sequential";
var CauseSymbolKey223 = "effect/Cause";
var CauseTypeId223 = /* @__PURE__ */ Symbol.for(CauseSymbolKey223);
var variance2223 = {
  /* c8 ignore next */
  _E: (_2222) => _2222
};
var proto223 = {
  [CauseTypeId223]: variance2223,
  [symbol323]() {
    return pipe223(hash223(CauseSymbolKey223), combine323(hash223(flattenCause223(this))), cached223(this));
  },
  [symbol2223](that) {
    return isCause223(that) && causeEquals223(this, that);
  },
  pipe() {
    return pipeArguments223(this, arguments);
  },
  toJSON() {
    switch (this._tag) {
      case "Empty":
        return {
          _id: "Cause",
          _tag: this._tag
        };
      case "Die":
        return {
          _id: "Cause",
          _tag: this._tag,
          defect: toJSON223(this.defect)
        };
      case "Interrupt":
        return {
          _id: "Cause",
          _tag: this._tag,
          fiberId: this.fiberId.toJSON()
        };
      case "Fail":
        return {
          _id: "Cause",
          _tag: this._tag,
          failure: toJSON223(this.error)
        };
      case "Sequential":
      case "Parallel":
        return {
          _id: "Cause",
          _tag: this._tag,
          left: toJSON223(this.left),
          right: toJSON223(this.right)
        };
    }
  },
  toString() {
    return pretty223(this);
  },
  [NodeInspectSymbol223]() {
    return this.toJSON();
  }
};
var fail323 = (error) => {
  const o2222 = Object.create(proto223);
  o2222._tag = OP_FAIL223;
  o2222.error = error;
  return o2222;
};
var parallel223 = (left32222, right32222) => {
  const o2222 = Object.create(proto223);
  o2222._tag = OP_PARALLEL223;
  o2222.left = left32222;
  o2222.right = right32222;
  return o2222;
};
var sequential223 = (left32222, right32222) => {
  const o2222 = Object.create(proto223);
  o2222._tag = OP_SEQUENTIAL223;
  o2222.left = left32222;
  o2222.right = right32222;
  return o2222;
};
var isCause223 = (u2222) => hasProperty223(u2222, CauseTypeId223);
var isInterruptedOnly223 = (self2) => reduceWithContext223(void 0, IsInterruptedOnlyCauseReducer223)(self2);
var causeEquals223 = (left32222, right32222) => {
  let leftStack = of223(left32222);
  let rightStack = of223(right32222);
  while (isNonEmpty223(leftStack) && isNonEmpty223(rightStack)) {
    const [leftParallel, leftSequential] = pipe223(headNonEmpty223(leftStack), reduce4223([empty6223(), empty3223()], ([parallel22222, sequential22222], cause) => {
      const [par, seq] = evaluateCause223(cause);
      return some3223([pipe223(parallel22222, union3223(par)), pipe223(sequential22222, appendAll223(seq))]);
    }));
    const [rightParallel, rightSequential] = pipe223(headNonEmpty223(rightStack), reduce4223([empty6223(), empty3223()], ([parallel22222, sequential22222], cause) => {
      const [par, seq] = evaluateCause223(cause);
      return some3223([pipe223(parallel22222, union3223(par)), pipe223(sequential22222, appendAll223(seq))]);
    }));
    if (!equals223(leftParallel, rightParallel)) {
      return false;
    }
    leftStack = leftSequential;
    rightStack = rightSequential;
  }
  return true;
};
var flattenCause223 = (cause) => {
  return flattenCauseLoop223(of223(cause), empty3223());
};
var flattenCauseLoop223 = (causes, flattened) => {
  while (1) {
    const [parallel22222, sequential22222] = pipe223(causes, reduce323([empty6223(), empty3223()], ([parallel322, sequential322], cause) => {
      const [par, seq] = evaluateCause223(cause);
      return [pipe223(parallel322, union3223(par)), pipe223(sequential322, appendAll223(seq))];
    }));
    const updated = size3223(parallel22222) > 0 ? pipe223(flattened, prepend223(parallel22222)) : flattened;
    if (isEmpty223(sequential22222)) {
      return reverse2223(updated);
    }
    causes = sequential22222;
    flattened = updated;
  }
  throw new Error(getBugErrorMessage223("Cause.flattenCauseLoop"));
};
var evaluateCause223 = (self2) => {
  let cause = self2;
  const stack = [];
  let _parallel = empty6223();
  let _sequential = empty3223();
  while (cause !== void 0) {
    switch (cause._tag) {
      case OP_EMPTY223: {
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_FAIL223: {
        _parallel = add3223(_parallel, make4223(cause._tag, cause.error));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_DIE223: {
        _parallel = add3223(_parallel, make4223(cause._tag, cause.defect));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_INTERRUPT223: {
        _parallel = add3223(_parallel, make4223(cause._tag, cause.fiberId));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_SEQUENTIAL223: {
        switch (cause.left._tag) {
          case OP_EMPTY223: {
            cause = cause.right;
            break;
          }
          case OP_SEQUENTIAL223: {
            cause = sequential223(cause.left.left, sequential223(cause.left.right, cause.right));
            break;
          }
          case OP_PARALLEL223: {
            cause = parallel223(sequential223(cause.left.left, cause.right), sequential223(cause.left.right, cause.right));
            break;
          }
          default: {
            _sequential = prepend223(_sequential, cause.right);
            cause = cause.left;
            break;
          }
        }
        break;
      }
      case OP_PARALLEL223: {
        stack.push(cause.right);
        cause = cause.left;
        break;
      }
    }
  }
  throw new Error(getBugErrorMessage223("Cause.evaluateCauseLoop"));
};
var IsInterruptedOnlyCauseReducer223 = {
  emptyCase: constTrue223,
  failCase: constFalse223,
  dieCase: constFalse223,
  interruptCase: constTrue223,
  sequentialCase: (_2222, left32222, right32222) => left32222 && right32222,
  parallelCase: (_2222, left32222, right32222) => left32222 && right32222
};
var OP_SEQUENTIAL_CASE223 = "SequentialCase";
var OP_PARALLEL_CASE223 = "ParallelCase";
var reduce4223 = /* @__PURE__ */ dual223(3, (self2, zero, pf) => {
  let accumulator = zero;
  let cause = self2;
  const causes = [];
  while (cause !== void 0) {
    const option = pf(accumulator, cause);
    accumulator = isSome2223(option) ? option.value : accumulator;
    switch (cause._tag) {
      case OP_SEQUENTIAL223: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      case OP_PARALLEL223: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      default: {
        cause = void 0;
        break;
      }
    }
    if (cause === void 0 && causes.length > 0) {
      cause = causes.pop();
    }
  }
  return accumulator;
});
var reduceWithContext223 = /* @__PURE__ */ dual223(3, (self2, context, reducer) => {
  const input = [self2];
  const output = [];
  while (input.length > 0) {
    const cause = input.pop();
    switch (cause._tag) {
      case OP_EMPTY223: {
        output.push(right2223(reducer.emptyCase(context)));
        break;
      }
      case OP_FAIL223: {
        output.push(right2223(reducer.failCase(context, cause.error)));
        break;
      }
      case OP_DIE223: {
        output.push(right2223(reducer.dieCase(context, cause.defect)));
        break;
      }
      case OP_INTERRUPT223: {
        output.push(right2223(reducer.interruptCase(context, cause.fiberId)));
        break;
      }
      case OP_SEQUENTIAL223: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left2223({
          _tag: OP_SEQUENTIAL_CASE223
        }));
        break;
      }
      case OP_PARALLEL223: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left2223({
          _tag: OP_PARALLEL_CASE223
        }));
        break;
      }
    }
  }
  const accumulator = [];
  while (output.length > 0) {
    const either = output.pop();
    switch (either._tag) {
      case "Left": {
        switch (either.left._tag) {
          case OP_SEQUENTIAL_CASE223: {
            const left32222 = accumulator.pop();
            const right32222 = accumulator.pop();
            const value = reducer.sequentialCase(context, left32222, right32222);
            accumulator.push(value);
            break;
          }
          case OP_PARALLEL_CASE223: {
            const left32222 = accumulator.pop();
            const right32222 = accumulator.pop();
            const value = reducer.parallelCase(context, left32222, right32222);
            accumulator.push(value);
            break;
          }
        }
        break;
      }
      case "Right": {
        accumulator.push(either.right);
        break;
      }
    }
  }
  if (accumulator.length === 0) {
    throw new Error("BUG: Cause.reduceWithContext - please report an issue at https://github.com/Effect-TS/effect/issues");
  }
  return accumulator.pop();
});
var pretty223 = (cause) => {
  if (isInterruptedOnly223(cause)) {
    return "All fibers interrupted without errors.";
  }
  return prettyErrors223(cause).map((e2222) => e2222.stack).join("\n");
};
var PrettyError223 = class extends globalThis.Error {
  span = void 0;
  constructor(originalError) {
    const prevLimit = Error.stackTraceLimit;
    Error.stackTraceLimit = 0;
    super(prettyErrorMessage223(originalError));
    Error.stackTraceLimit = prevLimit;
    this.name = originalError instanceof Error ? originalError.name : "Error";
    if (typeof originalError === "object" && originalError !== null) {
      if (spanSymbol323 in originalError) {
        this.span = originalError[spanSymbol323];
      }
      Object.keys(originalError).forEach((key) => {
        if (!(key in this)) {
          this[key] = originalError[key];
        }
      });
    }
    this.stack = prettyErrorStack223(this.message, originalError instanceof Error && originalError.stack ? originalError.stack : "", this.span);
  }
  toJSON() {
    const out = {
      message: this.message,
      stack: this.stack
    };
    if (this.span) {
      out.span = this.span;
    }
    return out;
  }
};
var prettyErrorMessage223 = (u2222) => {
  if (typeof u2222 === "string") {
    return `Error: ${u2222}`;
  }
  try {
    if (hasProperty223(u2222, "toString") && isFunction3223(u2222["toString"]) && u2222["toString"] !== Object.prototype.toString && u2222["toString"] !== globalThis.Array.prototype.toString) {
      return u2222["toString"]();
    }
  } catch {
  }
  return `Error: ${JSON.stringify(u2222)}`;
};
var locationRegex223 = /\((.*)\)/;
var spanToTrace223 = /* @__PURE__ */ globalValue223("effect/Tracer/spanToTrace", () => /* @__PURE__ */ new WeakMap());
var prettyErrorStack223 = (message, stack, span222) => {
  const out = [message];
  const lines = stack.split("\n");
  for (let i2222 = 1; i2222 < lines.length; i2222++) {
    if (lines[i2222].includes("Generator.next")) {
      break;
    }
    if (lines[i2222].includes("effect_internal_function")) {
      out.pop();
      break;
    }
    out.push(lines[i2222].replace(/at .*effect_instruction_i.*\((.*)\)/, "at $1").replace(/EffectPrimitive\.\w+/, "<anonymous>"));
  }
  if (span222) {
    let current = span222;
    let i2222 = 0;
    while (current && current._tag === "Span" && i2222 < 10) {
      const stackFn = spanToTrace223.get(current);
      if (typeof stackFn === "function") {
        const stack2 = stackFn();
        const locationMatch = stack2.match(locationRegex223);
        const location = locationMatch ? locationMatch[1] : stack2.replace(/^at /, "");
        out.push(`    at ${current.name} (${location})`);
      } else {
        out.push(`    at ${current.name}`);
      }
      current = getOrUndefined223(current.parent);
      i2222++;
    }
  }
  return out.join("\n");
};
var spanSymbol323 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var prettyErrors223 = (cause) => reduceWithContext223(cause, void 0, {
  emptyCase: () => [],
  dieCase: (_2222, unknownError) => {
    return [new PrettyError223(unknownError)];
  },
  failCase: (_2222, error) => {
    return [new PrettyError223(error)];
  },
  interruptCase: () => [],
  parallelCase: (_2222, l2222, r2222) => [...l2222, ...r2222],
  sequentialCase: (_2222, l2222, r2222) => [...l2222, ...r2222]
});
var SingleShotGen2223 = class _SingleShotGen2223 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  next(a2222) {
    return this.called ? {
      value: a2222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  return(a2222) {
    return {
      value: a2222,
      done: true
    };
  }
  throw(e2222) {
    throw e2222;
  }
  [Symbol.iterator]() {
    return new _SingleShotGen2223(this.self);
  }
};
var spanTag223 = /* @__PURE__ */ GenericTag223("effect/ParentSpan");
var EffectTypeId2223 = /* @__PURE__ */ Symbol.for("effect/Effect");
var EffectPrimitive223 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId2223] = effectVariance223;
  constructor(_op) {
    this._op = _op;
  }
  [symbol2223](that) {
    return this === that;
  }
  [symbol323]() {
    return cached223(this, random223(this));
  }
  pipe() {
    return pipeArguments223(this, arguments);
  }
  toJSON() {
    return {
      _id: "Effect",
      _op: this._op,
      effect_instruction_i0: toJSON223(this.effect_instruction_i0),
      effect_instruction_i1: toJSON223(this.effect_instruction_i1),
      effect_instruction_i2: toJSON223(this.effect_instruction_i2)
    };
  }
  toString() {
    return format223(this.toJSON());
  }
  [NodeInspectSymbol223]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen2223(new YieldWrap223(this));
  }
};
var EffectPrimitiveFailure223 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId2223] = effectVariance223;
  constructor(_op) {
    this._op = _op;
    this._tag = _op;
  }
  [symbol2223](that) {
    return exitIsExit223(that) && that._op === "Failure" && // @ts-expect-error
    equals223(this.effect_instruction_i0, that.effect_instruction_i0);
  }
  [symbol323]() {
    return pipe223(
      // @ts-expect-error
      string223(this._tag),
      // @ts-expect-error
      combine323(hash223(this.effect_instruction_i0)),
      cached223(this)
    );
  }
  get cause() {
    return this.effect_instruction_i0;
  }
  pipe() {
    return pipeArguments223(this, arguments);
  }
  toJSON() {
    return {
      _id: "Exit",
      _tag: this._op,
      cause: this.cause.toJSON()
    };
  }
  toString() {
    return format223(this.toJSON());
  }
  [NodeInspectSymbol223]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen2223(new YieldWrap223(this));
  }
};
var isEffect223 = (u2222) => hasProperty223(u2222, EffectTypeId2223);
var withFiberRuntime223 = (withRuntime) => {
  const effect = new EffectPrimitive223(OP_WITH_RUNTIME223);
  effect.effect_instruction_i0 = withRuntime;
  return effect;
};
var spanSymbol2223 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var originalSymbol223 = /* @__PURE__ */ Symbol.for("effect/OriginalAnnotation");
var capture223 = (obj, span222) => {
  if (isSome2223(span222)) {
    return new Proxy(obj, {
      has(target, p2222) {
        return p2222 === spanSymbol2223 || p2222 === originalSymbol223 || p2222 in target;
      },
      get(target, p2222) {
        if (p2222 === spanSymbol2223) {
          return span222.value;
        }
        if (p2222 === originalSymbol223) {
          return obj;
        }
        return target[p2222];
      }
    });
  }
  return obj;
};
var fail2223 = (error) => isObject223(error) && !(spanSymbol2223 in error) ? withFiberRuntime223((fiber) => failCause223(fail323(capture223(error, currentSpanFromFiber223(fiber))))) : failCause223(fail323(error));
var failCause223 = (cause) => {
  const effect = new EffectPrimitiveFailure223(OP_FAILURE223);
  effect.effect_instruction_i0 = cause;
  return effect;
};
var FiberRefSymbolKey223 = "effect/FiberRef";
var FiberRefTypeId223 = /* @__PURE__ */ Symbol.for(FiberRefSymbolKey223);
var fiberRefVariance223 = {
  /* c8 ignore next */
  _A: (_2222) => _2222
};
var fiberRefUnsafeMakeContext223 = (initial) => {
  const differ = environment223();
  return fiberRefUnsafeMakePatch223(initial, {
    differ,
    fork: differ.empty
  });
};
var fiberRefUnsafeMakePatch223 = (initial, options) => ({
  [FiberRefTypeId223]: fiberRefVariance223,
  initial,
  diff: (oldValue, newValue) => options.differ.diff(oldValue, newValue),
  combine: (first, second) => options.differ.combine(first, second),
  patch: (patch22222) => (oldValue) => options.differ.patch(patch22222, oldValue),
  fork: options.fork,
  join: options.join ?? ((_2222, n2222) => n2222),
  pipe() {
    return pipeArguments223(this, arguments);
  }
});
var currentContext223 = /* @__PURE__ */ globalValue223(/* @__PURE__ */ Symbol.for("effect/FiberRef/currentContext"), () => fiberRefUnsafeMakeContext223(empty2223()));
var YieldableError223 = /* @__PURE__ */ function() {
  class YieldableError22222 extends globalThis.Error {
    commit() {
      return fail2223(this);
    }
    toString() {
      return this.message ? `${this.name}: ${this.message}` : this.name;
    }
    toJSON() {
      return {
        ...this
      };
    }
    [NodeInspectSymbol223]() {
      const stack = this.stack;
      if (stack) {
        return `${this.toString()}
${stack.split("\n").slice(1).join("\n")}`;
      }
      return this.toString();
    }
  }
  Object.assign(YieldableError22222.prototype, StructuralCommitPrototype223);
  return YieldableError22222;
}();
var exitIsExit223 = (u2222) => isEffect223(u2222) && "_tag" in u2222 && (u2222._tag === "Success" || u2222._tag === "Failure");
var currentSpanFromFiber223 = (fiber) => {
  const span222 = fiber.getFiberRef(currentContext223).unsafeMap.get(spanTag223.key);
  return span222 !== void 0 && span222._tag === "Span" ? some3223(span222) : none2223();
};
var Data_exports223 = {};
__export2223(Data_exports223, {
  Class: () => Class2223,
  Error: () => Error2223,
  Structural: () => Structural2223,
  TaggedClass: () => TaggedClass223,
  TaggedError: () => TaggedError223,
  array: () => array2223,
  case: () => _case223,
  struct: () => struct3223,
  tagged: () => tagged223,
  taggedEnum: () => taggedEnum223,
  tuple: () => tuple2223,
  unsafeArray: () => unsafeArray223,
  unsafeStruct: () => unsafeStruct223
});
var struct3223 = struct2223;
var unsafeStruct223 = (as2322) => Object.setPrototypeOf(as2322, StructuralPrototype223);
var tuple2223 = (...as2322) => unsafeArray223(as2322);
var array2223 = (as2322) => unsafeArray223(as2322.slice(0));
var unsafeArray223 = (as2322) => Object.setPrototypeOf(as2322, ArrayProto223);
var _case223 = () => (args) => args === void 0 ? Object.create(StructuralPrototype223) : struct3223(args);
var tagged223 = (tag) => (args) => {
  const value = args === void 0 ? Object.create(StructuralPrototype223) : struct3223(args);
  value._tag = tag;
  return value;
};
var Class2223 = Structural323;
var TaggedClass223 = (tag) => {
  class Base extends Class2223 {
    _tag = tag;
  }
  return Base;
};
var Structural2223 = Structural323;
var taggedEnum223 = () => new Proxy({}, {
  get(_target, tag, _receiver) {
    if (tag === "$is") {
      return isTagged223;
    } else if (tag === "$match") {
      return taggedMatch223;
    }
    return tagged223(tag);
  }
});
function taggedMatch223() {
  if (arguments.length === 1) {
    const cases2 = arguments[0];
    return function(value2) {
      return cases2[value2._tag](value2);
    };
  }
  const value = arguments[0];
  const cases = arguments[1];
  return cases[value._tag](value);
}
var Error2223 = /* @__PURE__ */ function() {
  return class Base extends YieldableError223 {
    constructor(args) {
      super();
      if (args) {
        Object.assign(this, args);
      }
    }
  };
}();
var TaggedError223 = (tag) => {
  class Base extends Error2223 {
    _tag = tag;
  }
  Base.prototype.name = tag;
  return Base;
};
var traverseUp223 = Function_exports223.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType223.Program) return Option_exports223.none();
  return predicate(parent) ? Option_exports223.some(parent) : traverseUp223(parent, predicate);
});
var traverseUpGuard223 = Function_exports223.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType223.Program) return Option_exports223.none();
  return predicate(parent) ? Option_exports223.some(parent) : traverseUpGuard223(parent, predicate);
});
var ESLintCommunityESLintUtils223;
((ESLintCommunityESLintUtils22222) => {
  ESLintCommunityESLintUtils22222.getFunctionHeadLocation = getFunctionHeadLocation223;
  ESLintCommunityESLintUtils22222.getFunctionNameWithKind = getFunctionNameWithKind223;
  ESLintCommunityESLintUtils22222.getPropertyName = getPropertyName223;
  ESLintCommunityESLintUtils22222.getStaticValue = getStaticValue223;
  ESLintCommunityESLintUtils22222.getStringIfConstant = getStringIfConstant223;
  ESLintCommunityESLintUtils22222.hasSideEffect = hasSideEffect223;
  ESLintCommunityESLintUtils22222.isParenthesized = isParenthesized223;
})(ESLintCommunityESLintUtils223 || (ESLintCommunityESLintUtils223 = {}));
var Construction223 = Data_exports223.taggedEnum();
Construction223.None();
a5({
  type: N4.union([NodeType223.FunctionExpression, NodeType223.ArrowFunctionExpression]),
  parent: {
    type: NodeType223.Property,
    parent: {
      type: NodeType223.ObjectExpression
    }
  }
});
a5({
  type: N4.union([NodeType223.FunctionExpression, NodeType223.ArrowFunctionExpression]),
  parent: {
    type: NodeType223.MethodDefinition,
    parent: {
      type: NodeType223.ClassBody
    }
  }
});
a5({
  type: N4.union([NodeType223.FunctionExpression, NodeType223.ArrowFunctionExpression]),
  parent: {
    type: NodeType223.Property,
    parent: {
      type: NodeType223.ClassBody
    }
  }
});
var Function_exports2223 = {};
__export323(Function_exports2223, {
  SK: () => SK2223,
  absurd: () => absurd2223,
  apply: () => apply2223,
  compose: () => compose3222,
  constFalse: () => constFalse2223,
  constNull: () => constNull2223,
  constTrue: () => constTrue2223,
  constUndefined: () => constUndefined2223,
  constVoid: () => constVoid2223,
  constant: () => constant2223,
  dual: () => dual2223,
  flip: () => flip2223,
  flow: () => flow2223,
  hole: () => hole2223,
  identity: () => identity2223,
  isFunction: () => isFunction422,
  pipe: () => pipe2223,
  satisfies: () => satisfies2223,
  tupled: () => tupled2223,
  unsafeCoerce: () => unsafeCoerce2223,
  untupled: () => untupled2223
});
var isFunction422 = (input) => typeof input === "function";
var dual2223 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a2222, b2222) {
        if (arguments.length >= 2) {
          return body(a2222, b2222);
        }
        return function(self2) {
          return body(self2, a2222);
        };
      };
    case 3:
      return function(a2222, b2222, c2222) {
        if (arguments.length >= 3) {
          return body(a2222, b2222, c2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222);
        };
      };
    case 4:
      return function(a2222, b2222, c2222, d2222) {
        if (arguments.length >= 4) {
          return body(a2222, b2222, c2222, d2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222);
        };
      };
    case 5:
      return function(a2222, b2222, c2222, d2222, e2222) {
        if (arguments.length >= 5) {
          return body(a2222, b2222, c2222, d2222, e2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222, d2222);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply2223 = (a2222) => (self2) => self2(a2222);
var identity2223 = (a2222) => a2222;
var satisfies2223 = () => (b2222) => b2222;
var unsafeCoerce2223 = identity2223;
var constant2223 = (value) => () => value;
var constTrue2223 = /* @__PURE__ */ constant2223(true);
var constFalse2223 = /* @__PURE__ */ constant2223(false);
var constNull2223 = /* @__PURE__ */ constant2223(null);
var constUndefined2223 = /* @__PURE__ */ constant2223(void 0);
var constVoid2223 = constUndefined2223;
var flip2223 = (f2222) => (...b2222) => (...a2222) => f2222(...a2222)(...b2222);
var compose3222 = /* @__PURE__ */ dual2223(2, (ab, bc) => (a2222) => bc(ab(a2222)));
var absurd2223 = (_2222) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled2223 = (f2222) => (a2222) => f2222(...a2222);
var untupled2223 = (f2222) => (...a2222) => f2222(a2222);
function pipe2223(a2222, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a2222;
    case 2:
      return ab(a2222);
    case 3:
      return bc(ab(a2222));
    case 4:
      return cd(bc(ab(a2222)));
    case 5:
      return de(cd(bc(ab(a2222))));
    case 6:
      return ef(de(cd(bc(ab(a2222)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a2222))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a2222)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a2222))))))));
    default: {
      let ret = arguments[0];
      for (let i2222 = 1; i2222 < arguments.length; i2222++) {
        ret = arguments[i2222](ret);
      }
      return ret;
    }
  }
}
function flow2223(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole2223 = /* @__PURE__ */ unsafeCoerce2223(absurd2223);
var SK2223 = (_2222, b2222) => b2222;
var Array_exports3 = {};
__export323(Array_exports3, {
  Do: () => Do33,
  allocate: () => allocate3,
  append: () => append4,
  appendAll: () => appendAll2222,
  bind: () => bind53,
  bindTo: () => bindTo53,
  cartesian: () => cartesian3,
  cartesianWith: () => cartesianWith3,
  chop: () => chop3,
  chunksOf: () => chunksOf3,
  contains: () => contains33,
  containsWith: () => containsWith33,
  copy: () => copy2222,
  dedupe: () => dedupe3,
  dedupeAdjacent: () => dedupeAdjacent3,
  dedupeAdjacentWith: () => dedupeAdjacentWith3,
  dedupeWith: () => dedupeWith3,
  difference: () => difference4,
  differenceWith: () => differenceWith3,
  drop: () => drop2222,
  dropRight: () => dropRight3,
  dropWhile: () => dropWhile3,
  empty: () => empty93,
  every: () => every33,
  extend: () => extend3,
  filter: () => filter33,
  filterMap: () => filterMap33,
  filterMapWhile: () => filterMapWhile3,
  findFirst: () => findFirst23,
  findFirstIndex: () => findFirstIndex3,
  findLast: () => findLast3,
  findLastIndex: () => findLastIndex3,
  flatMap: () => flatMap33,
  flatMapNullable: () => flatMapNullable33,
  flatten: () => flatten33,
  forEach: () => forEach3222,
  fromIterable: () => fromIterable43,
  fromNullable: () => fromNullable33,
  fromOption: () => fromOption23,
  fromRecord: () => fromRecord3,
  get: () => get8,
  getEquivalence: () => getEquivalence43,
  getLefts: () => getLefts4,
  getOrder: () => getOrder33,
  getRights: () => getRights4,
  getSomes: () => getSomes4,
  group: () => group3,
  groupBy: () => groupBy3,
  groupWith: () => groupWith3,
  head: () => head4,
  headNonEmpty: () => headNonEmpty2222,
  init: () => init3,
  initNonEmpty: () => initNonEmpty3,
  insertAt: () => insertAt3,
  intersection: () => intersection4,
  intersectionWith: () => intersectionWith3,
  intersperse: () => intersperse3,
  isArray: () => isArray3,
  isEmptyArray: () => isEmptyArray3,
  isEmptyReadonlyArray: () => isEmptyReadonlyArray3,
  isNonEmptyArray: () => isNonEmptyArray23,
  isNonEmptyReadonlyArray: () => isNonEmptyReadonlyArray3,
  join: () => join3,
  last: () => last3,
  lastNonEmpty: () => lastNonEmpty3,
  length: () => length4,
  let: () => let_53,
  liftEither: () => liftEither3,
  liftNullable: () => liftNullable33,
  liftOption: () => liftOption3,
  liftPredicate: () => liftPredicate33,
  make: () => make103,
  makeBy: () => makeBy3,
  map: () => map33,
  mapAccum: () => mapAccum3,
  match: () => match43,
  matchLeft: () => matchLeft3,
  matchRight: () => matchRight3,
  max: () => max23,
  min: () => min23,
  modify: () => modify4,
  modifyNonEmptyHead: () => modifyNonEmptyHead3,
  modifyNonEmptyLast: () => modifyNonEmptyLast3,
  modifyOption: () => modifyOption4,
  of: () => of2222,
  partition: () => partition4,
  partitionMap: () => partitionMap33,
  prepend: () => prepend2222,
  prependAll: () => prependAll3,
  range: () => range3,
  reduce: () => reduce3222,
  reduceRight: () => reduceRight3,
  remove: () => remove5,
  replace: () => replace23,
  replaceOption: () => replaceOption4,
  replicate: () => replicate3,
  reverse: () => reverse3222,
  rotate: () => rotate3,
  scan: () => scan3,
  scanRight: () => scanRight3,
  separate: () => separate4,
  setNonEmptyHead: () => setNonEmptyHead3,
  setNonEmptyLast: () => setNonEmptyLast3,
  some: () => some73,
  sort: () => sort3,
  sortBy: () => sortBy3,
  sortWith: () => sortWith3,
  span: () => span3,
  split: () => split3,
  splitAt: () => splitAt3,
  splitNonEmptyAt: () => splitNonEmptyAt3,
  splitWhere: () => splitWhere3,
  tail: () => tail4,
  tailNonEmpty: () => tailNonEmpty2222,
  take: () => take3,
  takeRight: () => takeRight3,
  takeWhile: () => takeWhile3,
  unappend: () => unappend3,
  unfold: () => unfold3,
  union: () => union6,
  unionWith: () => unionWith3,
  unprepend: () => unprepend3,
  unsafeGet: () => unsafeGet4,
  unzip: () => unzip3,
  zip: () => zip3,
  zipWith: () => zipWith33
});
var make6222 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var array3222 = (item) => make6222((self2, that) => {
  if (self2.length !== that.length) {
    return false;
  }
  for (let i2222 = 0; i2222 < self2.length; i2222++) {
    const isEq = item(self2[i2222], that[i2222]);
    if (!isEq) {
      return false;
    }
  }
  return true;
});
var let_3223 = (map522) => dual2223(3, (self2, name22, f2222) => map522(self2, (a2222) => Object.assign({}, a2222, {
  [name22]: f2222(a2222)
})));
var bindTo3223 = (map522) => dual2223(2, (self2, name22) => map522(self2, (a2222) => ({
  [name22]: a2222
})));
var bind3223 = (map522, flatMap522) => dual2223(3, (self2, name22, f2222) => flatMap522(self2, (a2222) => map522(f2222(a2222), (b2222) => Object.assign({}, a2222, {
  [name22]: b2222
}))));
var moduleVersion2223 = "3.2.8";
var getCurrentVersion2223 = () => moduleVersion2223;
var globalStoreId2223 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion2223()}`);
if (!(globalStoreId2223 in globalThis)) {
  globalThis[globalStoreId2223] = /* @__PURE__ */ new Map();
}
var globalStore2223 = globalThis[globalStoreId2223];
var globalValue2223 = (id, compute) => {
  if (!globalStore2223.has(id)) {
    globalStore2223.set(id, compute());
  }
  return globalStore2223.get(id);
};
var Predicate_exports2223 = {};
__export323(Predicate_exports2223, {
  all: () => all3222,
  and: () => and2222,
  compose: () => compose43,
  eqv: () => eqv2222,
  every: () => every2222,
  hasProperty: () => hasProperty2223,
  implies: () => implies2222,
  isBigInt: () => isBigInt2222,
  isBoolean: () => isBoolean2222,
  isDate: () => isDate2222,
  isError: () => isError2222,
  isFunction: () => isFunction53,
  isIterable: () => isIterable2222,
  isMap: () => isMap2222,
  isNever: () => isNever2222,
  isNotNull: () => isNotNull2222,
  isNotNullable: () => isNotNullable2222,
  isNotUndefined: () => isNotUndefined2222,
  isNull: () => isNull2222,
  isNullable: () => isNullable2223,
  isNumber: () => isNumber2222,
  isObject: () => isObject2223,
  isPromise: () => isPromise2222,
  isPromiseLike: () => isPromiseLike2222,
  isReadonlyRecord: () => isReadonlyRecord2222,
  isRecord: () => isRecord2222,
  isSet: () => isSet2222,
  isString: () => isString2222,
  isSymbol: () => isSymbol2222,
  isTagged: () => isTagged2222,
  isTruthy: () => isTruthy2222,
  isUint8Array: () => isUint8Array2222,
  isUndefined: () => isUndefined2222,
  isUnknown: () => isUnknown2222,
  mapInput: () => mapInput2222,
  nand: () => nand2222,
  nor: () => nor2222,
  not: () => not2222,
  or: () => or2222,
  product: () => product3222,
  productMany: () => productMany3222,
  some: () => some4222,
  struct: () => struct4222,
  tuple: () => tuple3222,
  xor: () => xor2222
});
var mapInput2222 = /* @__PURE__ */ dual2223(2, (self2, f2222) => (b2222) => self2(f2222(b2222)));
var isTruthy2222 = (input) => !!input;
var isSet2222 = (input) => input instanceof Set;
var isMap2222 = (input) => input instanceof Map;
var isString2222 = (input) => typeof input === "string";
var isNumber2222 = (input) => typeof input === "number";
var isBoolean2222 = (input) => typeof input === "boolean";
var isBigInt2222 = (input) => typeof input === "bigint";
var isSymbol2222 = (input) => typeof input === "symbol";
var isFunction53 = isFunction422;
var isUndefined2222 = (input) => input === void 0;
var isNotUndefined2222 = (input) => input !== void 0;
var isNull2222 = (input) => input === null;
var isNotNull2222 = (input) => input !== null;
var isNever2222 = (_2222) => false;
var isUnknown2222 = (_2222) => true;
var isRecordOrArray2223 = (input) => typeof input === "object" && input !== null;
var isObject2223 = (input) => isRecordOrArray2223(input) || isFunction53(input);
var hasProperty2223 = /* @__PURE__ */ dual2223(2, (self2, property) => isObject2223(self2) && property in self2);
var isTagged2222 = /* @__PURE__ */ dual2223(2, (self2, tag) => hasProperty2223(self2, "_tag") && self2["_tag"] === tag);
var isNullable2223 = (input) => input === null || input === void 0;
var isNotNullable2222 = (input) => input !== null && input !== void 0;
var isError2222 = (input) => input instanceof Error;
var isUint8Array2222 = (input) => input instanceof Uint8Array;
var isDate2222 = (input) => input instanceof Date;
var isIterable2222 = (input) => hasProperty2223(input, Symbol.iterator);
var isRecord2222 = (input) => isRecordOrArray2223(input) && !Array.isArray(input);
var isReadonlyRecord2222 = isRecord2222;
var isPromise2222 = (input) => hasProperty2223(input, "then") && "catch" in input && isFunction53(input.then) && isFunction53(input.catch);
var isPromiseLike2222 = (input) => hasProperty2223(input, "then") && isFunction53(input.then);
var compose43 = /* @__PURE__ */ dual2223(2, (ab, bc) => (a2222) => ab(a2222) && bc(a2222));
var product3222 = (self2, that) => ([a2222, b2222]) => self2(a2222) && that(b2222);
var all3222 = (collection) => {
  return (as422) => {
    let collectionIndex = 0;
    for (const p2222 of collection) {
      if (collectionIndex >= as422.length) {
        break;
      }
      if (p2222(as422[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany3222 = (self2, collection) => {
  const rest = all3222(collection);
  return ([head222, ...tail222]) => self2(head222) === false ? false : rest(tail222);
};
var tuple3222 = (...elements) => all3222(elements);
var struct4222 = (fields) => {
  const keys422 = Object.keys(fields);
  return (a2222) => {
    for (const key of keys422) {
      if (!fields[key](a2222[key])) {
        return false;
      }
    }
    return true;
  };
};
var not2222 = (self2) => (a2222) => !self2(a2222);
var or2222 = /* @__PURE__ */ dual2223(2, (self2, that) => (a2222) => self2(a2222) || that(a2222));
var and2222 = /* @__PURE__ */ dual2223(2, (self2, that) => (a2222) => self2(a2222) && that(a2222));
var xor2222 = /* @__PURE__ */ dual2223(2, (self2, that) => (a2222) => self2(a2222) !== that(a2222));
var eqv2222 = /* @__PURE__ */ dual2223(2, (self2, that) => (a2222) => self2(a2222) === that(a2222));
var implies2222 = /* @__PURE__ */ dual2223(2, (self2, that) => (a2222) => self2(a2222) ? that(a2222) : true);
var nor2222 = /* @__PURE__ */ dual2223(2, (self2, that) => (a2222) => !(self2(a2222) || that(a2222)));
var nand2222 = /* @__PURE__ */ dual2223(2, (self2, that) => (a2222) => !(self2(a2222) && that(a2222)));
var every2222 = (collection) => (a2222) => {
  for (const p2222 of collection) {
    if (!p2222(a2222)) {
      return false;
    }
  }
  return true;
};
var some4222 = (collection) => (a2222) => {
  for (const p2222 of collection) {
    if (p2222(a2222)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage2223 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId2223 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind2223 = (u2222) => isObject2223(u2222) && GenKindTypeId2223 in u2222;
var GenKindImpl2223 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity2223;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId2223] = GenKindTypeId2223;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen3222(this);
  }
};
var SingleShotGen3222 = class _SingleShotGen53 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a2222) {
    return this.called ? {
      value: a2222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a2222) {
    return {
      value: a2222,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e2222) {
    throw e2222;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen53(this.self);
  }
};
var adapter3223 = () => function() {
  let x2222 = arguments[0];
  for (let i2222 = 1; i2222 < arguments.length; i2222++) {
    x2222 = arguments[i2222](x2222);
  }
  return new GenKindImpl2223(x2222);
};
var defaultIncHi2223 = 335903614;
var defaultIncLo2223 = 4150755663;
var MUL_HI2223 = 1481765933 >>> 0;
var MUL_LO2223 = 1284865837 >>> 0;
var BIT_532223 = 9007199254740992;
var BIT_272223 = 134217728;
var PCGRandom2223 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable2223(seedLo) && isNullable2223(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable2223(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable2223(incLo) && isNullable2223(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo2223;
      incHi = this._state ? this._state[2] : defaultIncHi2223;
    } else if (isNullable2223(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add642223(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max322) {
    if (!max322) {
      return this._next();
    }
    max322 = max322 >>> 0;
    if ((max322 & max322 - 1) === 0) {
      return this._next() & max322 - 1;
    }
    let num = 0;
    const skew = (-max322 >>> 0) % max322 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max322;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_272223 + lo) / BIT_532223;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul642223(this._state, oldHi, oldLo, MUL_HI2223, MUL_LO2223);
    add642223(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul642223(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add642223(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId2223 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap2223 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId2223]() {
    return this.#value;
  }
};
function yieldWrapGet2223(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId2223 in self2) {
    return self2[YieldWrapTypeId2223]();
  }
  throw new Error(getBugErrorMessage2223("yieldWrapGet"));
}
var structuralRegionState2223 = /* @__PURE__ */ globalValue2223("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache2223 = /* @__PURE__ */ globalValue2223(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr2223 = /* @__PURE__ */ globalValue2223(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom2223());
var symbol3223 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash2223 = (self2) => {
  if (structuralRegionState2223.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number2223(self2);
    case "bigint":
      return string2223(self2.toString(10));
    case "boolean":
      return string2223(String(self2));
    case "symbol":
      return string2223(String(self2));
    case "string":
      return string2223(self2);
    case "undefined":
      return string2223("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string2223("null");
      } else if (self2 instanceof Date) {
        return hash2223(self2.toISOString());
      } else if (isHash2223(self2)) {
        return self2[symbol3223]();
      } else {
        return random2223(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random2223 = (self2) => {
  if (!randomHashCache2223.has(self2)) {
    randomHashCache2223.set(self2, number2223(pcgr2223.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache2223.get(self2);
};
var combine3222 = (b2222) => (self2) => self2 * 53 ^ b2222;
var optimize2223 = (n2222) => n2222 & 3221225471 | n2222 >>> 1 & 1073741824;
var isHash2223 = (u2222) => hasProperty2223(u2222, symbol3223);
var number2223 = (n2222) => {
  if (n2222 !== n2222 || n2222 === Infinity) {
    return 0;
  }
  let h2222 = n2222 | 0;
  if (h2222 !== n2222) {
    h2222 ^= n2222 * 4294967295;
  }
  while (n2222 > 4294967295) {
    h2222 ^= n2222 /= 4294967295;
  }
  return optimize2223(n2222);
};
var string2223 = (str) => {
  let h2222 = 5381, i2222 = str.length;
  while (i2222) {
    h2222 = h2222 * 33 ^ str.charCodeAt(--i2222);
  }
  return optimize2223(h2222);
};
var cached2223 = function() {
  if (arguments.length === 1) {
    const self3 = arguments[0];
    return function(hash522) {
      Object.defineProperty(self3, symbol3223, {
        value() {
          return hash522;
        },
        enumerable: false
      });
      return hash522;
    };
  }
  const self2 = arguments[0];
  const hash422 = arguments[1];
  Object.defineProperty(self2, symbol3223, {
    value() {
      return hash422;
    },
    enumerable: false
  });
  return hash422;
};
var symbol43 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals2223() {
  if (arguments.length === 1) {
    return (self2) => compareBoth2223(self2, arguments[0]);
  }
  return compareBoth2223(arguments[0], arguments[1]);
}
function compareBoth2223(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual2223(self2) && isEqual2223(that)) {
        if (hash2223(self2) === hash2223(that) && self2[symbol43](that)) {
          return true;
        } else {
          return structuralRegionState2223.enabled && structuralRegionState2223.tester ? structuralRegionState2223.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState2223.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v2222, i2222) => compareBoth2223(v2222, that[i2222]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth2223(self2[key], that[key]))) {
              return structuralRegionState2223.tester ? structuralRegionState2223.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState2223.tester ? structuralRegionState2223.tester(self2, that) : false;
    }
  }
  return structuralRegionState2223.enabled && structuralRegionState2223.tester ? structuralRegionState2223.tester(self2, that) : false;
}
var isEqual2223 = (u2222) => hasProperty2223(u2222, symbol43);
var equivalence2223 = () => equals2223;
var NodeInspectSymbol2223 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON2223 = (x2222) => {
  if (hasProperty2223(x2222, "toJSON") && isFunction53(x2222["toJSON"]) && x2222["toJSON"].length === 0) {
    return x2222.toJSON();
  } else if (Array.isArray(x2222)) {
    return x2222.map(toJSON2223);
  }
  return x2222;
};
var format2223 = (x2222) => JSON.stringify(x2222, null, 2);
var pipeArguments2223 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i2222 = 0, len = args.length; i2222 < len; i2222++) {
        ret = args[i2222](ret);
      }
      return ret;
    }
  }
};
var EffectTypeId3222 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId2223 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId2223 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId2223 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance2223 = {
  /* c8 ignore next */
  _R: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _A: (_2222) => _2222,
  _V: /* @__PURE__ */ getCurrentVersion2223()
};
var sinkVariance2223 = {
  /* c8 ignore next */
  _A: (_2222) => _2222,
  /* c8 ignore next */
  _In: (_2222) => _2222,
  /* c8 ignore next */
  _L: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _R: (_2222) => _2222
};
var channelVariance2223 = {
  /* c8 ignore next */
  _Env: (_2222) => _2222,
  /* c8 ignore next */
  _InErr: (_2222) => _2222,
  /* c8 ignore next */
  _InElem: (_2222) => _2222,
  /* c8 ignore next */
  _InDone: (_2222) => _2222,
  /* c8 ignore next */
  _OutErr: (_2222) => _2222,
  /* c8 ignore next */
  _OutElem: (_2222) => _2222,
  /* c8 ignore next */
  _OutDone: (_2222) => _2222
};
var EffectPrototype2223 = {
  [EffectTypeId3222]: effectVariance2223,
  [StreamTypeId2223]: effectVariance2223,
  [SinkTypeId2223]: sinkVariance2223,
  [ChannelTypeId2223]: channelVariance2223,
  [symbol43](that) {
    return this === that;
  },
  [symbol3223]() {
    return cached2223(this, random2223(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen3222(new YieldWrap2223(this));
  },
  pipe() {
    return pipeArguments2223(this, arguments);
  }
};
var TypeId6222 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto3223 = {
  ...EffectPrototype2223,
  [TypeId6222]: {
    _A: (_2222) => _2222
  },
  [NodeInspectSymbol2223]() {
    return this.toJSON();
  },
  toString() {
    return format2223(this.toJSON());
  }
};
var SomeProto2223 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto3223), {
  _tag: "Some",
  _op: "Some",
  [symbol43](that) {
    return isOption3223(that) && isSome3223(that) && equals2223(this.value, that.value);
  },
  [symbol3223]() {
    return cached2223(this, combine3222(hash2223(this._tag))(hash2223(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON2223(this.value)
    };
  }
});
var NoneHash2223 = /* @__PURE__ */ hash2223("None");
var NoneProto2223 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto3223), {
  _tag: "None",
  _op: "None",
  [symbol43](that) {
    return isOption3223(that) && isNone3223(that);
  },
  [symbol3223]() {
    return NoneHash2223;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption3223 = (input) => hasProperty2223(input, TypeId6222);
var isNone3223 = (fa) => fa._tag === "None";
var isSome3223 = (fa) => fa._tag === "Some";
var none3223 = /* @__PURE__ */ Object.create(NoneProto2223);
var some53 = (value) => {
  const a2222 = Object.create(SomeProto2223);
  a2222.value = value;
  return a2222;
};
var TypeId73 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto43 = {
  ...EffectPrototype2223,
  [TypeId73]: {
    _R: (_2222) => _2222
  },
  [NodeInspectSymbol2223]() {
    return this.toJSON();
  },
  toString() {
    return format2223(this.toJSON());
  }
};
var RightProto2223 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto43), {
  _tag: "Right",
  _op: "Right",
  [symbol43](that) {
    return isEither2223(that) && isRight2223(that) && equals2223(this.right, that.right);
  },
  [symbol3223]() {
    return combine3222(hash2223(this._tag))(hash2223(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON2223(this.right)
    };
  }
});
var LeftProto2223 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto43), {
  _tag: "Left",
  _op: "Left",
  [symbol43](that) {
    return isEither2223(that) && isLeft2223(that) && equals2223(this.left, that.left);
  },
  [symbol3223]() {
    return combine3222(hash2223(this._tag))(hash2223(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON2223(this.left)
    };
  }
});
var isEither2223 = (input) => hasProperty2223(input, TypeId73);
var isLeft2223 = (ma) => ma._tag === "Left";
var isRight2223 = (ma) => ma._tag === "Right";
var left3222 = (left522) => {
  const a2222 = Object.create(LeftProto2223);
  a2222.left = left522;
  return a2222;
};
var right3222 = (right522) => {
  const a2222 = Object.create(RightProto2223);
  a2222.right = right522;
  return a2222;
};
var getLeft3223 = (self2) => isRight2223(self2) ? none3223 : some53(self2.left);
var getRight3223 = (self2) => isLeft2223(self2) ? none3223 : some53(self2.right);
var isLeft33 = isLeft2223;
var isRight33 = isRight2223;
var isNonEmptyArray4 = (self2) => self2.length > 0;
var Option_exports2223 = {};
__export323(Option_exports2223, {
  Do: () => Do2223,
  TypeId: () => TypeId83,
  all: () => all43,
  andThen: () => andThen2223,
  ap: () => ap2223,
  as: () => as2223,
  asVoid: () => asVoid2223,
  bind: () => bind43,
  bindTo: () => bindTo43,
  composeK: () => composeK2223,
  contains: () => contains2223,
  containsWith: () => containsWith2223,
  exists: () => exists2223,
  filter: () => filter2223,
  filterMap: () => filterMap2223,
  firstSomeOf: () => firstSomeOf2223,
  flatMap: () => flatMap2223,
  flatMapNullable: () => flatMapNullable2223,
  flatten: () => flatten2223,
  fromIterable: () => fromIterable3222,
  fromNullable: () => fromNullable2223,
  gen: () => gen2223,
  getEquivalence: () => getEquivalence3222,
  getLeft: () => getLeft43,
  getOrElse: () => getOrElse2223,
  getOrNull: () => getOrNull2223,
  getOrThrow: () => getOrThrow2223,
  getOrThrowWith: () => getOrThrowWith2223,
  getOrUndefined: () => getOrUndefined2223,
  getOrder: () => getOrder2223,
  getRight: () => getRight43,
  isNone: () => isNone43,
  isOption: () => isOption43,
  isSome: () => isSome43,
  let: () => let_43,
  lift2: () => lift22223,
  liftNullable: () => liftNullable2223,
  liftPredicate: () => liftPredicate2223,
  liftThrowable: () => liftThrowable2223,
  map: () => map2223,
  match: () => match322,
  none: () => none43,
  orElse: () => orElse2223,
  orElseEither: () => orElseEither2223,
  orElseSome: () => orElseSome2223,
  partitionMap: () => partitionMap2223,
  product: () => product43,
  productMany: () => productMany43,
  reduceCompact: () => reduceCompact2223,
  some: () => some63,
  tap: () => tap2223,
  toArray: () => toArray2223,
  toRefinement: () => toRefinement2223,
  void: () => void_2223,
  zipLeft: () => zipLeft2223,
  zipRight: () => zipRight2223,
  zipWith: () => zipWith2223
});
var make83 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var number33 = /* @__PURE__ */ make83((self2, that) => self2 < that ? -1 : 1);
var combineMany3 = /* @__PURE__ */ dual2223(2, (self2, collection) => make83((a1, a2222) => {
  let out = self2(a1, a2222);
  if (out !== 0) {
    return out;
  }
  for (const O2222 of collection) {
    out = O2222(a1, a2222);
    if (out !== 0) {
      return out;
    }
  }
  return out;
}));
var empty8222 = () => make83(() => 0);
var combineAll3 = (collection) => combineMany3(empty8222(), collection);
var mapInput33 = /* @__PURE__ */ dual2223(2, (self2, f2222) => make83((b1, b2222) => self2(f2222(b1), f2222(b2222))));
var array43 = (O2222) => make83((self2, that) => {
  const aLen = self2.length;
  const bLen = that.length;
  const len = Math.min(aLen, bLen);
  for (let i2222 = 0; i2222 < len; i2222++) {
    const o2222 = O2222(self2[i2222], that[i2222]);
    if (o2222 !== 0) {
      return o2222;
    }
  }
  return number33(aLen, bLen);
});
var min4 = (O2222) => dual2223(2, (self2, that) => self2 === that || O2222(self2, that) < 1 ? self2 : that);
var max4 = (O2222) => dual2223(2, (self2, that) => self2 === that || O2222(self2, that) > -1 ? self2 : that);
var TypeId83 = /* @__PURE__ */ Symbol.for("effect/Option");
var none43 = () => none3223;
var some63 = some53;
var isOption43 = isOption3223;
var isNone43 = isNone3223;
var isSome43 = isSome3223;
var match322 = /* @__PURE__ */ dual2223(2, (self2, {
  onNone,
  onSome
}) => isNone43(self2) ? onNone() : onSome(self2.value));
var toRefinement2223 = (f2222) => (a2222) => isSome43(f2222(a2222));
var fromIterable3222 = (collection) => {
  for (const a2222 of collection) {
    return some63(a2222);
  }
  return none43();
};
var getRight43 = getRight3223;
var getLeft43 = getLeft3223;
var getOrElse2223 = /* @__PURE__ */ dual2223(2, (self2, onNone) => isNone43(self2) ? onNone() : self2.value);
var orElse2223 = /* @__PURE__ */ dual2223(2, (self2, that) => isNone43(self2) ? that() : self2);
var orElseSome2223 = /* @__PURE__ */ dual2223(2, (self2, onNone) => isNone43(self2) ? some63(onNone()) : self2);
var orElseEither2223 = /* @__PURE__ */ dual2223(2, (self2, that) => isNone43(self2) ? map2223(that(), right3222) : map2223(self2, left3222));
var firstSomeOf2223 = (collection) => {
  let out = none43();
  for (out of collection) {
    if (isSome43(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable2223 = (nullableValue) => nullableValue == null ? none43() : some63(nullableValue);
var liftNullable2223 = (f2222) => (...a2222) => fromNullable2223(f2222(...a2222));
var getOrNull2223 = /* @__PURE__ */ getOrElse2223(constNull2223);
var getOrUndefined2223 = /* @__PURE__ */ getOrElse2223(constUndefined2223);
var liftThrowable2223 = (f2222) => (...a2222) => {
  try {
    return some63(f2222(...a2222));
  } catch (e2222) {
    return none43();
  }
};
var getOrThrowWith2223 = /* @__PURE__ */ dual2223(2, (self2, onNone) => {
  if (isSome43(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow2223 = /* @__PURE__ */ getOrThrowWith2223(() => new Error("getOrThrow called on a None"));
var map2223 = /* @__PURE__ */ dual2223(2, (self2, f2222) => isNone43(self2) ? none43() : some63(f2222(self2.value)));
var as2223 = /* @__PURE__ */ dual2223(2, (self2, b2222) => map2223(self2, () => b2222));
var asVoid2223 = /* @__PURE__ */ as2223(void 0);
var void_2223 = /* @__PURE__ */ some63(void 0);
var flatMap2223 = /* @__PURE__ */ dual2223(2, (self2, f2222) => isNone43(self2) ? none43() : f2222(self2.value));
var andThen2223 = /* @__PURE__ */ dual2223(2, (self2, f2222) => flatMap2223(self2, (a2222) => {
  const b2222 = isFunction422(f2222) ? f2222(a2222) : f2222;
  return isOption43(b2222) ? b2222 : some63(b2222);
}));
var flatMapNullable2223 = /* @__PURE__ */ dual2223(2, (self2, f2222) => isNone43(self2) ? none43() : fromNullable2223(f2222(self2.value)));
var flatten2223 = /* @__PURE__ */ flatMap2223(identity2223);
var zipRight2223 = /* @__PURE__ */ dual2223(2, (self2, that) => flatMap2223(self2, () => that));
var composeK2223 = /* @__PURE__ */ dual2223(2, (afb, bfc) => (a2222) => flatMap2223(afb(a2222), bfc));
var zipLeft2223 = /* @__PURE__ */ dual2223(2, (self2, that) => tap2223(self2, () => that));
var tap2223 = /* @__PURE__ */ dual2223(2, (self2, f2222) => flatMap2223(self2, (a2222) => map2223(f2222(a2222), () => a2222)));
var product43 = (self2, that) => isSome43(self2) && isSome43(that) ? some63([self2.value, that.value]) : none43();
var productMany43 = (self2, collection) => {
  if (isNone43(self2)) {
    return none43();
  }
  const out = [self2.value];
  for (const o2222 of collection) {
    if (isNone43(o2222)) {
      return none43();
    }
    out.push(o2222.value);
  }
  return some63(out);
};
var all43 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o2222 of input) {
      if (isNone43(o2222)) {
        return none43();
      }
      out2.push(o2222.value);
    }
    return some63(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o2222 = input[key];
    if (isNone43(o2222)) {
      return none43();
    }
    out[key] = o2222.value;
  }
  return some63(out);
};
var zipWith2223 = /* @__PURE__ */ dual2223(3, (self2, that, f2222) => map2223(product43(self2, that), ([a2222, b2222]) => f2222(a2222, b2222)));
var ap2223 = /* @__PURE__ */ dual2223(2, (self2, that) => zipWith2223(self2, that, (f2222, a2222) => f2222(a2222)));
var reduceCompact2223 = /* @__PURE__ */ dual2223(3, (self2, b2222, f2222) => {
  let out = b2222;
  for (const oa of self2) {
    if (isSome43(oa)) {
      out = f2222(out, oa.value);
    }
  }
  return out;
});
var toArray2223 = (self2) => isNone43(self2) ? [] : [self2.value];
var partitionMap2223 = /* @__PURE__ */ dual2223(2, (self2, f2222) => {
  if (isNone43(self2)) {
    return [none43(), none43()];
  }
  const e2222 = f2222(self2.value);
  return isLeft2223(e2222) ? [some63(e2222.left), none43()] : [none43(), some63(e2222.right)];
});
var filterMap2223 = /* @__PURE__ */ dual2223(2, (self2, f2222) => isNone43(self2) ? none43() : f2222(self2.value));
var filter2223 = /* @__PURE__ */ dual2223(2, (self2, predicate) => filterMap2223(self2, (b2222) => predicate(b2222) ? some53(b2222) : none3223));
var getEquivalence3222 = (isEquivalent) => make6222((x2222, y2222) => x2222 === y2222 || (isNone43(x2222) ? isNone43(y2222) : isNone43(y2222) ? false : isEquivalent(x2222.value, y2222.value)));
var getOrder2223 = (O2222) => make83((self2, that) => isSome43(self2) ? isSome43(that) ? O2222(self2.value, that.value) : 1 : -1);
var lift22223 = (f2222) => dual2223(2, (self2, that) => zipWith2223(self2, that, f2222));
var liftPredicate2223 = (predicate) => (b2222) => predicate(b2222) ? some63(b2222) : none43();
var containsWith2223 = (isEquivalent) => dual2223(2, (self2, a2222) => isNone43(self2) ? false : isEquivalent(self2.value, a2222));
var _equivalence3222 = /* @__PURE__ */ equivalence2223();
var contains2223 = /* @__PURE__ */ containsWith2223(_equivalence3222);
var exists2223 = /* @__PURE__ */ dual2223(2, (self2, refinement) => isNone43(self2) ? false : refinement(self2.value));
var bindTo43 = /* @__PURE__ */ bindTo3223(map2223);
var let_43 = /* @__PURE__ */ let_3223(map2223);
var bind43 = /* @__PURE__ */ bind3223(map2223, flatMap2223);
var Do2223 = /* @__PURE__ */ some63({});
var adapter43 = /* @__PURE__ */ adapter3223();
var gen2223 = (f2222) => {
  const iterator = f2222(adapter43);
  let state = iterator.next();
  if (state.done) {
    return some63(state.value);
  } else {
    let current = state.value;
    if (isGenKind2223(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet2223(current);
    }
    if (isNone43(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind2223(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet2223(current);
        }
        if (isNone43(current)) {
          return current;
        }
      }
    }
    return some63(state.value);
  }
};
var make93 = (...elements) => elements;
var findFirst4 = /* @__PURE__ */ dual2223(2, (self2, f2222) => {
  let i2222 = 0;
  for (const a2222 of self2) {
    const o2222 = f2222(a2222, i2222);
    if (isBoolean2222(o2222)) {
      if (o2222) {
        return some63(a2222);
      }
    } else {
      if (isSome43(o2222)) {
        return o2222;
      }
    }
    i2222++;
  }
  return none43();
});
var collect4 = /* @__PURE__ */ dual2223(2, (self2, f2222) => {
  const out = [];
  for (const key of keys2222(self2)) {
    out.push(f2222(key, self2[key]));
  }
  return out;
});
var toEntries4 = /* @__PURE__ */ collect4((key, value) => [key, value]);
var keys2222 = (self2) => Object.keys(self2);
var make103 = (...elements) => elements;
var allocate3 = (n2222) => new Array(n2222);
var makeBy3 = (n2222, f2222) => {
  const max322 = Math.max(1, Math.floor(n2222));
  const out = new Array(max322);
  for (let i2222 = 0; i2222 < max322; i2222++) {
    out[i2222] = f2222(i2222);
  }
  return out;
};
var range3 = (start, end) => start <= end ? makeBy3(end - start + 1, (i2222) => start + i2222) : [start];
var replicate3 = /* @__PURE__ */ dual2223(2, (a2222, n2222) => makeBy3(n2222, () => a2222));
var fromIterable43 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var fromRecord3 = toEntries4;
var fromOption23 = toArray2223;
var match43 = /* @__PURE__ */ dual2223(2, (self2, {
  onEmpty,
  onNonEmpty
}) => isNonEmptyReadonlyArray3(self2) ? onNonEmpty(self2) : onEmpty());
var matchLeft3 = /* @__PURE__ */ dual2223(2, (self2, {
  onEmpty,
  onNonEmpty
}) => isNonEmptyReadonlyArray3(self2) ? onNonEmpty(headNonEmpty2222(self2), tailNonEmpty2222(self2)) : onEmpty());
var matchRight3 = /* @__PURE__ */ dual2223(2, (self2, {
  onEmpty,
  onNonEmpty
}) => isNonEmptyReadonlyArray3(self2) ? onNonEmpty(initNonEmpty3(self2), lastNonEmpty3(self2)) : onEmpty());
var prepend2222 = /* @__PURE__ */ dual2223(2, (self2, head222) => [head222, ...self2]);
var prependAll3 = /* @__PURE__ */ dual2223(2, (self2, that) => fromIterable43(that).concat(fromIterable43(self2)));
var append4 = /* @__PURE__ */ dual2223(2, (self2, last222) => [...self2, last222]);
var appendAll2222 = /* @__PURE__ */ dual2223(2, (self2, that) => fromIterable43(self2).concat(fromIterable43(that)));
var scan3 = /* @__PURE__ */ dual2223(3, (self2, b2222, f2222) => {
  const out = [b2222];
  let i2222 = 0;
  for (const a2222 of self2) {
    out[i2222 + 1] = f2222(out[i2222], a2222);
    i2222++;
  }
  return out;
});
var scanRight3 = /* @__PURE__ */ dual2223(3, (self2, b2222, f2222) => {
  const input = fromIterable43(self2);
  const out = new Array(input.length + 1);
  out[input.length] = b2222;
  for (let i2222 = input.length - 1; i2222 >= 0; i2222--) {
    out[i2222] = f2222(out[i2222 + 1], input[i2222]);
  }
  return out;
});
var isArray3 = Array.isArray;
var isEmptyArray3 = (self2) => self2.length === 0;
var isEmptyReadonlyArray3 = isEmptyArray3;
var isNonEmptyArray23 = isNonEmptyArray4;
var isNonEmptyReadonlyArray3 = isNonEmptyArray4;
var length4 = (self2) => self2.length;
var isOutOfBound3 = (i2222, as422) => i2222 < 0 || i2222 >= as422.length;
var clamp3 = (i2222, as422) => Math.floor(Math.min(Math.max(0, i2222), as422.length));
var get8 = /* @__PURE__ */ dual2223(2, (self2, index) => {
  const i2222 = Math.floor(index);
  return isOutOfBound3(i2222, self2) ? none43() : some63(self2[i2222]);
});
var unsafeGet4 = /* @__PURE__ */ dual2223(2, (self2, index) => {
  const i2222 = Math.floor(index);
  if (isOutOfBound3(i2222, self2)) {
    throw new Error(`Index ${i2222} out of bounds`);
  }
  return self2[i2222];
});
var unprepend3 = (self2) => [headNonEmpty2222(self2), tailNonEmpty2222(self2)];
var unappend3 = (self2) => [initNonEmpty3(self2), lastNonEmpty3(self2)];
var head4 = /* @__PURE__ */ get8(0);
var headNonEmpty2222 = /* @__PURE__ */ unsafeGet4(0);
var last3 = (self2) => isNonEmptyReadonlyArray3(self2) ? some63(lastNonEmpty3(self2)) : none43();
var lastNonEmpty3 = (self2) => self2[self2.length - 1];
var tail4 = (self2) => {
  const input = fromIterable43(self2);
  return isNonEmptyReadonlyArray3(input) ? some63(tailNonEmpty2222(input)) : none43();
};
var tailNonEmpty2222 = (self2) => self2.slice(1);
var init3 = (self2) => {
  const input = fromIterable43(self2);
  return isNonEmptyReadonlyArray3(input) ? some63(initNonEmpty3(input)) : none43();
};
var initNonEmpty3 = (self2) => self2.slice(0, -1);
var take3 = /* @__PURE__ */ dual2223(2, (self2, n2222) => {
  const input = fromIterable43(self2);
  return input.slice(0, clamp3(n2222, input));
});
var takeRight3 = /* @__PURE__ */ dual2223(2, (self2, n2222) => {
  const input = fromIterable43(self2);
  const i2222 = clamp3(n2222, input);
  return i2222 === 0 ? [] : input.slice(-i2222);
});
var takeWhile3 = /* @__PURE__ */ dual2223(2, (self2, predicate) => {
  let i2222 = 0;
  const out = [];
  for (const a2222 of self2) {
    if (!predicate(a2222, i2222)) {
      break;
    }
    out.push(a2222);
    i2222++;
  }
  return out;
});
var spanIndex3 = (self2, predicate) => {
  let i2222 = 0;
  for (const a2222 of self2) {
    if (!predicate(a2222, i2222)) {
      break;
    }
    i2222++;
  }
  return i2222;
};
var span3 = /* @__PURE__ */ dual2223(2, (self2, predicate) => splitAt3(self2, spanIndex3(self2, predicate)));
var drop2222 = /* @__PURE__ */ dual2223(2, (self2, n2222) => {
  const input = fromIterable43(self2);
  return input.slice(clamp3(n2222, input), input.length);
});
var dropRight3 = /* @__PURE__ */ dual2223(2, (self2, n2222) => {
  const input = fromIterable43(self2);
  return input.slice(0, input.length - clamp3(n2222, input));
});
var dropWhile3 = /* @__PURE__ */ dual2223(2, (self2, predicate) => fromIterable43(self2).slice(spanIndex3(self2, predicate)));
var findFirstIndex3 = /* @__PURE__ */ dual2223(2, (self2, predicate) => {
  let i2222 = 0;
  for (const a2222 of self2) {
    if (predicate(a2222, i2222)) {
      return some63(i2222);
    }
    i2222++;
  }
  return none43();
});
var findLastIndex3 = /* @__PURE__ */ dual2223(2, (self2, predicate) => {
  const input = fromIterable43(self2);
  for (let i2222 = input.length - 1; i2222 >= 0; i2222--) {
    if (predicate(input[i2222], i2222)) {
      return some63(i2222);
    }
  }
  return none43();
});
var findFirst23 = findFirst4;
var findLast3 = /* @__PURE__ */ dual2223(2, (self2, f2222) => {
  const input = fromIterable43(self2);
  for (let i2222 = input.length - 1; i2222 >= 0; i2222--) {
    const a2222 = input[i2222];
    const o2222 = f2222(a2222, i2222);
    if (isBoolean2222(o2222)) {
      if (o2222) {
        return some63(a2222);
      }
    } else {
      if (isSome43(o2222)) {
        return o2222;
      }
    }
  }
  return none43();
});
var insertAt3 = /* @__PURE__ */ dual2223(3, (self2, i2222, b2222) => {
  const out = Array.from(self2);
  if (i2222 < 0 || i2222 > out.length) {
    return none43();
  }
  out.splice(i2222, 0, b2222);
  return some63(out);
});
var replace23 = /* @__PURE__ */ dual2223(3, (self2, i2222, b2222) => modify4(self2, i2222, () => b2222));
var replaceOption4 = /* @__PURE__ */ dual2223(3, (self2, i2222, b2222) => modifyOption4(self2, i2222, () => b2222));
var modify4 = /* @__PURE__ */ dual2223(3, (self2, i2222, f2222) => getOrElse2223(modifyOption4(self2, i2222, f2222), () => Array.from(self2)));
var modifyOption4 = /* @__PURE__ */ dual2223(3, (self2, i2222, f2222) => {
  const out = Array.from(self2);
  if (isOutOfBound3(i2222, out)) {
    return none43();
  }
  const next = f2222(out[i2222]);
  out[i2222] = next;
  return some63(out);
});
var remove5 = /* @__PURE__ */ dual2223(2, (self2, i2222) => {
  const out = Array.from(self2);
  if (isOutOfBound3(i2222, out)) {
    return out;
  }
  out.splice(i2222, 1);
  return out;
});
var reverse3222 = (self2) => Array.from(self2).reverse();
var sort3 = /* @__PURE__ */ dual2223(2, (self2, O2222) => {
  const out = Array.from(self2);
  out.sort(O2222);
  return out;
});
var sortWith3 = /* @__PURE__ */ dual2223(3, (self2, f2222, order) => sort3(self2, mapInput33(order, f2222)));
var sortBy3 = (...orders) => {
  const sortByAll = sort3(combineAll3(orders));
  return (self2) => {
    const input = fromIterable43(self2);
    if (isNonEmptyReadonlyArray3(input)) {
      return sortByAll(input);
    }
    return [];
  };
};
var zip3 = /* @__PURE__ */ dual2223(2, (self2, that) => zipWith33(self2, that, make93));
var zipWith33 = /* @__PURE__ */ dual2223(3, (self2, that, f2222) => {
  const as422 = fromIterable43(self2);
  const bs = fromIterable43(that);
  if (isNonEmptyReadonlyArray3(as422) && isNonEmptyReadonlyArray3(bs)) {
    const out = [f2222(headNonEmpty2222(as422), headNonEmpty2222(bs))];
    const len = Math.min(as422.length, bs.length);
    for (let i2222 = 1; i2222 < len; i2222++) {
      out[i2222] = f2222(as422[i2222], bs[i2222]);
    }
    return out;
  }
  return [];
});
var unzip3 = (self2) => {
  const input = fromIterable43(self2);
  if (isNonEmptyReadonlyArray3(input)) {
    const fa = [input[0][0]];
    const fb = [input[0][1]];
    for (let i2222 = 1; i2222 < input.length; i2222++) {
      fa[i2222] = input[i2222][0];
      fb[i2222] = input[i2222][1];
    }
    return [fa, fb];
  }
  return [[], []];
};
var intersperse3 = /* @__PURE__ */ dual2223(2, (self2, middle) => {
  const input = fromIterable43(self2);
  if (isNonEmptyReadonlyArray3(input)) {
    const out = [headNonEmpty2222(input)];
    const tail222 = tailNonEmpty2222(input);
    for (let i2222 = 0; i2222 < tail222.length; i2222++) {
      if (i2222 < tail222.length) {
        out.push(middle);
      }
      out.push(tail222[i2222]);
    }
    return out;
  }
  return [];
});
var modifyNonEmptyHead3 = /* @__PURE__ */ dual2223(2, (self2, f2222) => [f2222(headNonEmpty2222(self2)), ...tailNonEmpty2222(self2)]);
var setNonEmptyHead3 = /* @__PURE__ */ dual2223(2, (self2, b2222) => modifyNonEmptyHead3(self2, () => b2222));
var modifyNonEmptyLast3 = /* @__PURE__ */ dual2223(2, (self2, f2222) => append4(initNonEmpty3(self2), f2222(lastNonEmpty3(self2))));
var setNonEmptyLast3 = /* @__PURE__ */ dual2223(2, (self2, b2222) => modifyNonEmptyLast3(self2, () => b2222));
var rotate3 = /* @__PURE__ */ dual2223(2, (self2, n2222) => {
  const input = fromIterable43(self2);
  if (isNonEmptyReadonlyArray3(input)) {
    const len = input.length;
    const m2222 = Math.round(n2222) % len;
    if (isOutOfBound3(Math.abs(m2222), input) || m2222 === 0) {
      return copy2222(input);
    }
    if (m2222 < 0) {
      const [f2222, s2222] = splitNonEmptyAt3(input, -m2222);
      return appendAll2222(s2222, f2222);
    } else {
      return rotate3(self2, m2222 - len);
    }
  }
  return [];
});
var containsWith33 = (isEquivalent) => dual2223(2, (self2, a2222) => {
  for (const i2222 of self2) {
    if (isEquivalent(a2222, i2222)) {
      return true;
    }
  }
  return false;
});
var _equivalence43 = /* @__PURE__ */ equivalence2223();
var contains33 = /* @__PURE__ */ containsWith33(_equivalence43);
var chop3 = /* @__PURE__ */ dual2223(2, (self2, f2222) => {
  const input = fromIterable43(self2);
  if (isNonEmptyReadonlyArray3(input)) {
    const [b2222, rest] = f2222(input);
    const out = [b2222];
    let next = rest;
    while (isNonEmptyArray4(next)) {
      const [b322, rest2] = f2222(next);
      out.push(b322);
      next = rest2;
    }
    return out;
  }
  return [];
});
var splitAt3 = /* @__PURE__ */ dual2223(2, (self2, n2222) => {
  const input = Array.from(self2);
  const _n = Math.floor(n2222);
  if (isNonEmptyReadonlyArray3(input)) {
    if (_n >= 1) {
      return splitNonEmptyAt3(input, _n);
    }
    return [[], input];
  }
  return [input, []];
});
var splitNonEmptyAt3 = /* @__PURE__ */ dual2223(2, (self2, n2222) => {
  const _n = Math.max(1, Math.floor(n2222));
  return _n >= self2.length ? [copy2222(self2), []] : [prepend2222(self2.slice(1, _n), headNonEmpty2222(self2)), self2.slice(_n)];
});
var split3 = /* @__PURE__ */ dual2223(2, (self2, n2222) => {
  const input = fromIterable43(self2);
  return chunksOf3(input, Math.ceil(input.length / Math.floor(n2222)));
});
var splitWhere3 = /* @__PURE__ */ dual2223(2, (self2, predicate) => span3(self2, (a2222, i2222) => !predicate(a2222, i2222)));
var copy2222 = (self2) => self2.slice();
var chunksOf3 = /* @__PURE__ */ dual2223(2, (self2, n2222) => {
  const input = fromIterable43(self2);
  if (isNonEmptyReadonlyArray3(input)) {
    return chop3(input, splitNonEmptyAt3(n2222));
  }
  return [];
});
var groupWith3 = /* @__PURE__ */ dual2223(2, (self2, isEquivalent) => chop3(self2, (as422) => {
  const h2222 = headNonEmpty2222(as422);
  const out = [h2222];
  let i2222 = 1;
  for (; i2222 < as422.length; i2222++) {
    const a2222 = as422[i2222];
    if (isEquivalent(a2222, h2222)) {
      out.push(a2222);
    } else {
      break;
    }
  }
  return [out, as422.slice(i2222)];
}));
var group3 = /* @__PURE__ */ groupWith3(/* @__PURE__ */ equivalence2223());
var groupBy3 = /* @__PURE__ */ dual2223(2, (self2, f2222) => {
  const out = {};
  for (const a2222 of self2) {
    const k2222 = f2222(a2222);
    if (Object.prototype.hasOwnProperty.call(out, k2222)) {
      out[k2222].push(a2222);
    } else {
      out[k2222] = [a2222];
    }
  }
  return out;
});
var unionWith3 = /* @__PURE__ */ dual2223(3, (self2, that, isEquivalent) => {
  const a2222 = fromIterable43(self2);
  const b2222 = fromIterable43(that);
  if (isNonEmptyReadonlyArray3(a2222)) {
    if (isNonEmptyReadonlyArray3(b2222)) {
      const dedupe222 = dedupeWith3(isEquivalent);
      return dedupe222(appendAll2222(a2222, b2222));
    }
    return a2222;
  }
  return b2222;
});
var union6 = /* @__PURE__ */ dual2223(2, (self2, that) => unionWith3(self2, that, _equivalence43));
var intersectionWith3 = (isEquivalent) => {
  const has22 = containsWith33(isEquivalent);
  return dual2223(2, (self2, that) => fromIterable43(self2).filter((a2222) => has22(that, a2222)));
};
var intersection4 = /* @__PURE__ */ intersectionWith3(_equivalence43);
var differenceWith3 = (isEquivalent) => {
  const has22 = containsWith33(isEquivalent);
  return dual2223(2, (self2, that) => fromIterable43(self2).filter((a2222) => !has22(that, a2222)));
};
var difference4 = /* @__PURE__ */ differenceWith3(_equivalence43);
var empty93 = () => [];
var of2222 = (a2222) => [a2222];
var map33 = /* @__PURE__ */ dual2223(2, (self2, f2222) => self2.map(f2222));
var flatMap33 = /* @__PURE__ */ dual2223(2, (self2, f2222) => {
  if (isEmptyReadonlyArray3(self2)) {
    return [];
  }
  const out = [];
  for (let i2222 = 0; i2222 < self2.length; i2222++) {
    const inner = f2222(self2[i2222], i2222);
    for (let j2222 = 0; j2222 < inner.length; j2222++) {
      out.push(inner[j2222]);
    }
  }
  return out;
});
var flatten33 = /* @__PURE__ */ flatMap33(identity2223);
var filterMap33 = /* @__PURE__ */ dual2223(2, (self2, f2222) => {
  const as422 = fromIterable43(self2);
  const out = [];
  for (let i2222 = 0; i2222 < as422.length; i2222++) {
    const o2222 = f2222(as422[i2222], i2222);
    if (isSome43(o2222)) {
      out.push(o2222.value);
    }
  }
  return out;
});
var filterMapWhile3 = /* @__PURE__ */ dual2223(2, (self2, f2222) => {
  let i2222 = 0;
  const out = [];
  for (const a2222 of self2) {
    const b2222 = f2222(a2222, i2222);
    if (isSome43(b2222)) {
      out.push(b2222.value);
    } else {
      break;
    }
    i2222++;
  }
  return out;
});
var partitionMap33 = /* @__PURE__ */ dual2223(2, (self2, f2222) => {
  const left522 = [];
  const right522 = [];
  const as422 = fromIterable43(self2);
  for (let i2222 = 0; i2222 < as422.length; i2222++) {
    const e2222 = f2222(as422[i2222], i2222);
    if (isLeft33(e2222)) {
      left522.push(e2222.left);
    } else {
      right522.push(e2222.right);
    }
  }
  return [left522, right522];
});
var getSomes4 = /* @__PURE__ */ filterMap33(identity2223);
var getLefts4 = (self2) => {
  const out = [];
  for (const a2222 of self2) {
    if (isLeft33(a2222)) {
      out.push(a2222.left);
    }
  }
  return out;
};
var getRights4 = (self2) => {
  const out = [];
  for (const a2222 of self2) {
    if (isRight33(a2222)) {
      out.push(a2222.right);
    }
  }
  return out;
};
var filter33 = /* @__PURE__ */ dual2223(2, (self2, predicate) => {
  const as422 = fromIterable43(self2);
  const out = [];
  for (let i2222 = 0; i2222 < as422.length; i2222++) {
    if (predicate(as422[i2222], i2222)) {
      out.push(as422[i2222]);
    }
  }
  return out;
});
var partition4 = /* @__PURE__ */ dual2223(2, (self2, predicate) => {
  const left522 = [];
  const right522 = [];
  const as422 = fromIterable43(self2);
  for (let i2222 = 0; i2222 < as422.length; i2222++) {
    if (predicate(as422[i2222], i2222)) {
      right522.push(as422[i2222]);
    } else {
      left522.push(as422[i2222]);
    }
  }
  return [left522, right522];
});
var separate4 = /* @__PURE__ */ partitionMap33(identity2223);
var reduce3222 = /* @__PURE__ */ dual2223(3, (self2, b2222, f2222) => fromIterable43(self2).reduce((b322, a2222, i2222) => f2222(b322, a2222, i2222), b2222));
var reduceRight3 = /* @__PURE__ */ dual2223(3, (self2, b2222, f2222) => fromIterable43(self2).reduceRight((b322, a2222, i2222) => f2222(b322, a2222, i2222), b2222));
var liftPredicate33 = (predicate) => (b2222) => predicate(b2222) ? [b2222] : [];
var liftOption3 = (f2222) => (...a2222) => fromOption23(f2222(...a2222));
var fromNullable33 = (a2222) => a2222 == null ? empty93() : [a2222];
var liftNullable33 = (f2222) => (...a2222) => fromNullable33(f2222(...a2222));
var flatMapNullable33 = /* @__PURE__ */ dual2223(2, (self2, f2222) => flatMap33(self2, (a2222) => fromNullable33(f2222(a2222))));
var liftEither3 = (f2222) => (...a2222) => {
  const e2222 = f2222(...a2222);
  return isLeft33(e2222) ? [] : [e2222.right];
};
var every33 = /* @__PURE__ */ dual2223(2, (self2, refinement) => self2.every(refinement));
var some73 = /* @__PURE__ */ dual2223(2, (self2, predicate) => self2.some(predicate));
var extend3 = /* @__PURE__ */ dual2223(2, (self2, f2222) => self2.map((_2222, i2222, as422) => f2222(as422.slice(i2222))));
var min23 = /* @__PURE__ */ dual2223(2, (self2, O2222) => self2.reduce(min4(O2222)));
var max23 = /* @__PURE__ */ dual2223(2, (self2, O2222) => self2.reduce(max4(O2222)));
var unfold3 = (b2222, f2222) => {
  const out = [];
  let next = b2222;
  let o2222;
  while (isSome43(o2222 = f2222(next))) {
    const [a2222, b322] = o2222.value;
    out.push(a2222);
    next = b322;
  }
  return out;
};
var getOrder33 = array43;
var getEquivalence43 = array3222;
var forEach3222 = /* @__PURE__ */ dual2223(2, (self2, f2222) => fromIterable43(self2).forEach((a2222, i2222) => f2222(a2222, i2222)));
var dedupeWith3 = /* @__PURE__ */ dual2223(2, (self2, isEquivalent) => {
  const input = fromIterable43(self2);
  if (isNonEmptyReadonlyArray3(input)) {
    const out = [headNonEmpty2222(input)];
    const rest = tailNonEmpty2222(input);
    for (const r2222 of rest) {
      if (out.every((a2222) => !isEquivalent(r2222, a2222))) {
        out.push(r2222);
      }
    }
    return out;
  }
  return [];
});
var dedupe3 = (self2) => dedupeWith3(self2, equivalence2223());
var dedupeAdjacentWith3 = /* @__PURE__ */ dual2223(2, (self2, isEquivalent) => {
  const out = [];
  let lastA = none43();
  for (const a2222 of self2) {
    if (isNone43(lastA) || !isEquivalent(a2222, lastA.value)) {
      out.push(a2222);
      lastA = some63(a2222);
    }
  }
  return out;
});
var dedupeAdjacent3 = /* @__PURE__ */ dedupeAdjacentWith3(/* @__PURE__ */ equivalence2223());
var join3 = /* @__PURE__ */ dual2223(2, (self2, sep2) => fromIterable43(self2).join(sep2));
var mapAccum3 = /* @__PURE__ */ dual2223(3, (self2, s2222, f2222) => {
  let i2222 = 0;
  let s1 = s2222;
  const out = [];
  for (const a2222 of self2) {
    const r2222 = f2222(s1, a2222, i2222);
    s1 = r2222[0];
    out.push(r2222[1]);
    i2222++;
  }
  return [s1, out];
});
var cartesianWith3 = /* @__PURE__ */ dual2223(3, (self2, that, f2222) => flatMap33(self2, (a2222) => map33(that, (b2222) => f2222(a2222, b2222))));
var cartesian3 = /* @__PURE__ */ dual2223(2, (self2, that) => cartesianWith3(self2, that, (a2222, b2222) => [a2222, b2222]));
var Do33 = /* @__PURE__ */ of2222({});
var bind53 = /* @__PURE__ */ bind3223(map33, flatMap33);
var bindTo53 = /* @__PURE__ */ bindTo3223(map33);
var let_53 = /* @__PURE__ */ let_3223(map33);
var __defProp3222 = Object.defineProperty;
var __export3222 = (target, all32222) => {
  for (var name22 in all32222)
    __defProp3222(target, name22, { get: all32222[name22], enumerable: true });
};
var Function_exports33 = {};
__export3222(Function_exports33, {
  SK: () => SK33,
  absurd: () => absurd33,
  apply: () => apply33,
  compose: () => compose53,
  constFalse: () => constFalse33,
  constNull: () => constNull33,
  constTrue: () => constTrue33,
  constUndefined: () => constUndefined33,
  constVoid: () => constVoid33,
  constant: () => constant33,
  dual: () => dual33,
  flip: () => flip33,
  flow: () => flow33,
  hole: () => hole33,
  identity: () => identity33,
  isFunction: () => isFunction63,
  pipe: () => pipe33,
  satisfies: () => satisfies33,
  tupled: () => tupled33,
  unsafeCoerce: () => unsafeCoerce33,
  untupled: () => untupled33
});
var isFunction63 = (input) => typeof input === "function";
var dual33 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a2222, b2222) {
        if (arguments.length >= 2) {
          return body(a2222, b2222);
        }
        return function(self2) {
          return body(self2, a2222);
        };
      };
    case 3:
      return function(a2222, b2222, c2222) {
        if (arguments.length >= 3) {
          return body(a2222, b2222, c2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222);
        };
      };
    case 4:
      return function(a2222, b2222, c2222, d2222) {
        if (arguments.length >= 4) {
          return body(a2222, b2222, c2222, d2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222);
        };
      };
    case 5:
      return function(a2222, b2222, c2222, d2222, e2222) {
        if (arguments.length >= 5) {
          return body(a2222, b2222, c2222, d2222, e2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222, d2222);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply33 = (a2222) => (self2) => self2(a2222);
var identity33 = (a2222) => a2222;
var satisfies33 = () => (b2222) => b2222;
var unsafeCoerce33 = identity33;
var constant33 = (value) => () => value;
var constTrue33 = /* @__PURE__ */ constant33(true);
var constFalse33 = /* @__PURE__ */ constant33(false);
var constNull33 = /* @__PURE__ */ constant33(null);
var constUndefined33 = /* @__PURE__ */ constant33(void 0);
var constVoid33 = constUndefined33;
var flip33 = (f2222) => (...b2222) => (...a2222) => f2222(...a2222)(...b2222);
var compose53 = /* @__PURE__ */ dual33(2, (ab, bc) => (a2222) => bc(ab(a2222)));
var absurd33 = (_2222) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled33 = (f2222) => (a2222) => f2222(...a2222);
var untupled33 = (f2222) => (...a2222) => f2222(a2222);
function pipe33(a2222, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a2222;
    case 2:
      return ab(a2222);
    case 3:
      return bc(ab(a2222));
    case 4:
      return cd(bc(ab(a2222)));
    case 5:
      return de(cd(bc(ab(a2222))));
    case 6:
      return ef(de(cd(bc(ab(a2222)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a2222))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a2222)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a2222))))))));
    default: {
      let ret = arguments[0];
      for (let i2222 = 1; i2222 < arguments.length; i2222++) {
        ret = arguments[i2222](ret);
      }
      return ret;
    }
  }
}
function flow33(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole33 = /* @__PURE__ */ unsafeCoerce33(absurd33);
var SK33 = (_2222, b2222) => b2222;
var make113 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_63 = (map3222) => dual33(3, (self2, name22, f2222) => map3222(self2, (a2222) => Object.assign({}, a2222, {
  [name22]: f2222(a2222)
})));
var bindTo63 = (map3222) => dual33(2, (self2, name22) => map3222(self2, (a2222) => ({
  [name22]: a2222
})));
var bind63 = (map3222, flatMap3222) => dual33(3, (self2, name22, f2222) => flatMap3222(self2, (a2222) => map3222(f2222(a2222), (b2222) => Object.assign({}, a2222, {
  [name22]: b2222
}))));
var moduleVersion33 = "3.2.8";
var getCurrentVersion33 = () => moduleVersion33;
var globalStoreId33 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion33()}`);
if (!(globalStoreId33 in globalThis)) {
  globalThis[globalStoreId33] = /* @__PURE__ */ new Map();
}
var globalStore33 = globalThis[globalStoreId33];
var globalValue33 = (id, compute) => {
  if (!globalStore33.has(id)) {
    globalStore33.set(id, compute());
  }
  return globalStore33.get(id);
};
var isFunction22223 = isFunction63;
var isRecordOrArray33 = (input) => typeof input === "object" && input !== null;
var isObject33 = (input) => isRecordOrArray33(input) || isFunction22223(input);
var hasProperty33 = /* @__PURE__ */ dual33(2, (self2, property) => isObject33(self2) && property in self2);
var isNullable33 = (input) => input === null || input === void 0;
var getBugErrorMessage33 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId33 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind33 = (u2222) => isObject33(u2222) && GenKindTypeId33 in u2222;
var GenKindImpl33 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity33;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId33] = GenKindTypeId33;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen43(this);
  }
};
var SingleShotGen43 = class _SingleShotGen3222 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a2222) {
    return this.called ? {
      value: a2222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a2222) {
    return {
      value: a2222,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e2222) {
    throw e2222;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen3222(this.self);
  }
};
var adapter53 = () => function() {
  let x2222 = arguments[0];
  for (let i2222 = 1; i2222 < arguments.length; i2222++) {
    x2222 = arguments[i2222](x2222);
  }
  return new GenKindImpl33(x2222);
};
var defaultIncHi33 = 335903614;
var defaultIncLo33 = 4150755663;
var MUL_HI33 = 1481765933 >>> 0;
var MUL_LO33 = 1284865837 >>> 0;
var BIT_5333 = 9007199254740992;
var BIT_2733 = 134217728;
var PCGRandom33 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable33(seedLo) && isNullable33(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable33(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable33(incLo) && isNullable33(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo33;
      incHi = this._state ? this._state[2] : defaultIncHi33;
    } else if (isNullable33(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add6433(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max322) {
    if (!max322) {
      return this._next();
    }
    max322 = max322 >>> 0;
    if ((max322 & max322 - 1) === 0) {
      return this._next() & max322 - 1;
    }
    let num = 0;
    const skew = (-max322 >>> 0) % max322 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max322;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_2733 + lo) / BIT_5333;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul6433(this._state, oldHi, oldLo, MUL_HI33, MUL_LO33);
    add6433(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul6433(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add6433(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId33 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap33 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId33]() {
    return this.#value;
  }
};
function yieldWrapGet33(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId33 in self2) {
    return self2[YieldWrapTypeId33]();
  }
  throw new Error(getBugErrorMessage33("yieldWrapGet"));
}
var structuralRegionState33 = /* @__PURE__ */ globalValue33("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache33 = /* @__PURE__ */ globalValue33(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr33 = /* @__PURE__ */ globalValue33(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom33());
var symbol53 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash33 = (self2) => {
  if (structuralRegionState33.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number43(self2);
    case "bigint":
      return string33(self2.toString(10));
    case "boolean":
      return string33(String(self2));
    case "symbol":
      return string33(String(self2));
    case "string":
      return string33(self2);
    case "undefined":
      return string33("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string33("null");
      } else if (self2 instanceof Date) {
        return hash33(self2.toISOString());
      } else if (isHash33(self2)) {
        return self2[symbol53]();
      } else {
        return random33(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random33 = (self2) => {
  if (!randomHashCache33.has(self2)) {
    randomHashCache33.set(self2, number43(pcgr33.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache33.get(self2);
};
var combine43 = (b2222) => (self2) => self2 * 53 ^ b2222;
var optimize33 = (n2222) => n2222 & 3221225471 | n2222 >>> 1 & 1073741824;
var isHash33 = (u2222) => hasProperty33(u2222, symbol53);
var number43 = (n2222) => {
  if (n2222 !== n2222 || n2222 === Infinity) {
    return 0;
  }
  let h2222 = n2222 | 0;
  if (h2222 !== n2222) {
    h2222 ^= n2222 * 4294967295;
  }
  while (n2222 > 4294967295) {
    h2222 ^= n2222 /= 4294967295;
  }
  return optimize33(n2222);
};
var string33 = (str) => {
  let h2222 = 5381, i2222 = str.length;
  while (i2222) {
    h2222 = h2222 * 33 ^ str.charCodeAt(--i2222);
  }
  return optimize33(h2222);
};
var cached33 = function() {
  if (arguments.length === 1) {
    const self3 = arguments[0];
    return function(hash422) {
      Object.defineProperty(self3, symbol53, {
        value() {
          return hash422;
        },
        enumerable: false
      });
      return hash422;
    };
  }
  const self2 = arguments[0];
  const hash3222 = arguments[1];
  Object.defineProperty(self2, symbol53, {
    value() {
      return hash3222;
    },
    enumerable: false
  });
  return hash3222;
};
var symbol22223 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals33() {
  if (arguments.length === 1) {
    return (self2) => compareBoth33(self2, arguments[0]);
  }
  return compareBoth33(arguments[0], arguments[1]);
}
function compareBoth33(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual33(self2) && isEqual33(that)) {
        if (hash33(self2) === hash33(that) && self2[symbol22223](that)) {
          return true;
        } else {
          return structuralRegionState33.enabled && structuralRegionState33.tester ? structuralRegionState33.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState33.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v2222, i2222) => compareBoth33(v2222, that[i2222]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth33(self2[key], that[key]))) {
              return structuralRegionState33.tester ? structuralRegionState33.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState33.tester ? structuralRegionState33.tester(self2, that) : false;
    }
  }
  return structuralRegionState33.enabled && structuralRegionState33.tester ? structuralRegionState33.tester(self2, that) : false;
}
var isEqual33 = (u2222) => hasProperty33(u2222, symbol22223);
var equivalence33 = () => equals33;
var NodeInspectSymbol33 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON33 = (x2222) => {
  if (hasProperty33(x2222, "toJSON") && isFunction22223(x2222["toJSON"]) && x2222["toJSON"].length === 0) {
    return x2222.toJSON();
  } else if (Array.isArray(x2222)) {
    return x2222.map(toJSON33);
  }
  return x2222;
};
var format33 = (x2222) => JSON.stringify(x2222, null, 2);
var pipeArguments33 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i2222 = 0, len = args.length; i2222 < len; i2222++) {
        ret = args[i2222](ret);
      }
      return ret;
    }
  }
};
var EffectTypeId43 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId33 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId33 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId33 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance33 = {
  /* c8 ignore next */
  _R: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _A: (_2222) => _2222,
  _V: /* @__PURE__ */ getCurrentVersion33()
};
var sinkVariance33 = {
  /* c8 ignore next */
  _A: (_2222) => _2222,
  /* c8 ignore next */
  _In: (_2222) => _2222,
  /* c8 ignore next */
  _L: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _R: (_2222) => _2222
};
var channelVariance33 = {
  /* c8 ignore next */
  _Env: (_2222) => _2222,
  /* c8 ignore next */
  _InErr: (_2222) => _2222,
  /* c8 ignore next */
  _InElem: (_2222) => _2222,
  /* c8 ignore next */
  _InDone: (_2222) => _2222,
  /* c8 ignore next */
  _OutErr: (_2222) => _2222,
  /* c8 ignore next */
  _OutElem: (_2222) => _2222,
  /* c8 ignore next */
  _OutDone: (_2222) => _2222
};
var EffectPrototype33 = {
  [EffectTypeId43]: effectVariance33,
  [StreamTypeId33]: effectVariance33,
  [SinkTypeId33]: sinkVariance33,
  [ChannelTypeId33]: channelVariance33,
  [symbol22223](that) {
    return this === that;
  },
  [symbol53]() {
    return cached33(this, random33(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen43(new YieldWrap33(this));
  },
  pipe() {
    return pipeArguments33(this, arguments);
  }
};
var TypeId93 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto53 = {
  ...EffectPrototype33,
  [TypeId93]: {
    _A: (_2222) => _2222
  },
  [NodeInspectSymbol33]() {
    return this.toJSON();
  },
  toString() {
    return format33(this.toJSON());
  }
};
var SomeProto33 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto53), {
  _tag: "Some",
  _op: "Some",
  [symbol22223](that) {
    return isOption53(that) && isSome53(that) && equals33(this.value, that.value);
  },
  [symbol53]() {
    return cached33(this, combine43(hash33(this._tag))(hash33(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON33(this.value)
    };
  }
});
var NoneHash33 = /* @__PURE__ */ hash33("None");
var NoneProto33 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto53), {
  _tag: "None",
  _op: "None",
  [symbol22223](that) {
    return isOption53(that) && isNone53(that);
  },
  [symbol53]() {
    return NoneHash33;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption53 = (input) => hasProperty33(input, TypeId93);
var isNone53 = (fa) => fa._tag === "None";
var isSome53 = (fa) => fa._tag === "Some";
var none53 = /* @__PURE__ */ Object.create(NoneProto33);
var some83 = (value) => {
  const a2222 = Object.create(SomeProto33);
  a2222.value = value;
  return a2222;
};
var TypeId22223 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto22223 = {
  ...EffectPrototype33,
  [TypeId22223]: {
    _R: (_2222) => _2222
  },
  [NodeInspectSymbol33]() {
    return this.toJSON();
  },
  toString() {
    return format33(this.toJSON());
  }
};
var RightProto33 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto22223), {
  _tag: "Right",
  _op: "Right",
  [symbol22223](that) {
    return isEither33(that) && isRight43(that) && equals33(this.right, that.right);
  },
  [symbol53]() {
    return combine43(hash33(this._tag))(hash33(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON33(this.right)
    };
  }
});
var LeftProto33 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto22223), {
  _tag: "Left",
  _op: "Left",
  [symbol22223](that) {
    return isEither33(that) && isLeft43(that) && equals33(this.left, that.left);
  },
  [symbol53]() {
    return combine43(hash33(this._tag))(hash33(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON33(this.left)
    };
  }
});
var isEither33 = (input) => hasProperty33(input, TypeId22223);
var isLeft43 = (ma) => ma._tag === "Left";
var isRight43 = (ma) => ma._tag === "Right";
var left43 = (left32222) => {
  const a2222 = Object.create(LeftProto33);
  a2222.left = left32222;
  return a2222;
};
var right43 = (right32222) => {
  const a2222 = Object.create(RightProto33);
  a2222.right = right32222;
  return a2222;
};
var getLeft53 = (self2) => isRight43(self2) ? none53 : some83(self2.left);
var getRight53 = (self2) => isLeft43(self2) ? none53 : some83(self2.right);
var Option_exports33 = {};
__export3222(Option_exports33, {
  Do: () => Do43,
  TypeId: () => TypeId32223,
  all: () => all53,
  andThen: () => andThen33,
  ap: () => ap33,
  as: () => as33,
  asVoid: () => asVoid33,
  bind: () => bind22223,
  bindTo: () => bindTo22223,
  composeK: () => composeK33,
  contains: () => contains43,
  containsWith: () => containsWith43,
  exists: () => exists33,
  filter: () => filter43,
  filterMap: () => filterMap43,
  firstSomeOf: () => firstSomeOf33,
  flatMap: () => flatMap43,
  flatMapNullable: () => flatMapNullable43,
  flatten: () => flatten43,
  fromIterable: () => fromIterable53,
  fromNullable: () => fromNullable43,
  gen: () => gen33,
  getEquivalence: () => getEquivalence53,
  getLeft: () => getLeft22223,
  getOrElse: () => getOrElse33,
  getOrNull: () => getOrNull33,
  getOrThrow: () => getOrThrow33,
  getOrThrowWith: () => getOrThrowWith33,
  getOrUndefined: () => getOrUndefined33,
  getOrder: () => getOrder43,
  getRight: () => getRight22223,
  isNone: () => isNone22223,
  isOption: () => isOption22223,
  isSome: () => isSome22223,
  let: () => let_22223,
  lift2: () => lift233,
  liftNullable: () => liftNullable43,
  liftPredicate: () => liftPredicate43,
  liftThrowable: () => liftThrowable33,
  map: () => map43,
  match: () => match53,
  none: () => none22223,
  orElse: () => orElse33,
  orElseEither: () => orElseEither33,
  orElseSome: () => orElseSome33,
  partitionMap: () => partitionMap43,
  product: () => product53,
  productMany: () => productMany53,
  reduceCompact: () => reduceCompact33,
  some: () => some22223,
  tap: () => tap33,
  toArray: () => toArray33,
  toRefinement: () => toRefinement33,
  void: () => void_33,
  zipLeft: () => zipLeft33,
  zipRight: () => zipRight33,
  zipWith: () => zipWith43
});
var make22223 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId32223 = /* @__PURE__ */ Symbol.for("effect/Option");
var none22223 = () => none53;
var some22223 = some83;
var isOption22223 = isOption53;
var isNone22223 = isNone53;
var isSome22223 = isSome53;
var match53 = /* @__PURE__ */ dual33(2, (self2, {
  onNone,
  onSome
}) => isNone22223(self2) ? onNone() : onSome(self2.value));
var toRefinement33 = (f2222) => (a2222) => isSome22223(f2222(a2222));
var fromIterable53 = (collection) => {
  for (const a2222 of collection) {
    return some22223(a2222);
  }
  return none22223();
};
var getRight22223 = getRight53;
var getLeft22223 = getLeft53;
var getOrElse33 = /* @__PURE__ */ dual33(2, (self2, onNone) => isNone22223(self2) ? onNone() : self2.value);
var orElse33 = /* @__PURE__ */ dual33(2, (self2, that) => isNone22223(self2) ? that() : self2);
var orElseSome33 = /* @__PURE__ */ dual33(2, (self2, onNone) => isNone22223(self2) ? some22223(onNone()) : self2);
var orElseEither33 = /* @__PURE__ */ dual33(2, (self2, that) => isNone22223(self2) ? map43(that(), right43) : map43(self2, left43));
var firstSomeOf33 = (collection) => {
  let out = none22223();
  for (out of collection) {
    if (isSome22223(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable43 = (nullableValue) => nullableValue == null ? none22223() : some22223(nullableValue);
var liftNullable43 = (f2222) => (...a2222) => fromNullable43(f2222(...a2222));
var getOrNull33 = /* @__PURE__ */ getOrElse33(constNull33);
var getOrUndefined33 = /* @__PURE__ */ getOrElse33(constUndefined33);
var liftThrowable33 = (f2222) => (...a2222) => {
  try {
    return some22223(f2222(...a2222));
  } catch (e2222) {
    return none22223();
  }
};
var getOrThrowWith33 = /* @__PURE__ */ dual33(2, (self2, onNone) => {
  if (isSome22223(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow33 = /* @__PURE__ */ getOrThrowWith33(() => new Error("getOrThrow called on a None"));
var map43 = /* @__PURE__ */ dual33(2, (self2, f2222) => isNone22223(self2) ? none22223() : some22223(f2222(self2.value)));
var as33 = /* @__PURE__ */ dual33(2, (self2, b2222) => map43(self2, () => b2222));
var asVoid33 = /* @__PURE__ */ as33(void 0);
var void_33 = /* @__PURE__ */ some22223(void 0);
var flatMap43 = /* @__PURE__ */ dual33(2, (self2, f2222) => isNone22223(self2) ? none22223() : f2222(self2.value));
var andThen33 = /* @__PURE__ */ dual33(2, (self2, f2222) => flatMap43(self2, (a2222) => {
  const b2222 = isFunction63(f2222) ? f2222(a2222) : f2222;
  return isOption22223(b2222) ? b2222 : some22223(b2222);
}));
var flatMapNullable43 = /* @__PURE__ */ dual33(2, (self2, f2222) => isNone22223(self2) ? none22223() : fromNullable43(f2222(self2.value)));
var flatten43 = /* @__PURE__ */ flatMap43(identity33);
var zipRight33 = /* @__PURE__ */ dual33(2, (self2, that) => flatMap43(self2, () => that));
var composeK33 = /* @__PURE__ */ dual33(2, (afb, bfc) => (a2222) => flatMap43(afb(a2222), bfc));
var zipLeft33 = /* @__PURE__ */ dual33(2, (self2, that) => tap33(self2, () => that));
var tap33 = /* @__PURE__ */ dual33(2, (self2, f2222) => flatMap43(self2, (a2222) => map43(f2222(a2222), () => a2222)));
var product53 = (self2, that) => isSome22223(self2) && isSome22223(that) ? some22223([self2.value, that.value]) : none22223();
var productMany53 = (self2, collection) => {
  if (isNone22223(self2)) {
    return none22223();
  }
  const out = [self2.value];
  for (const o2222 of collection) {
    if (isNone22223(o2222)) {
      return none22223();
    }
    out.push(o2222.value);
  }
  return some22223(out);
};
var all53 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o2222 of input) {
      if (isNone22223(o2222)) {
        return none22223();
      }
      out2.push(o2222.value);
    }
    return some22223(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o2222 = input[key];
    if (isNone22223(o2222)) {
      return none22223();
    }
    out[key] = o2222.value;
  }
  return some22223(out);
};
var zipWith43 = /* @__PURE__ */ dual33(3, (self2, that, f2222) => map43(product53(self2, that), ([a2222, b2222]) => f2222(a2222, b2222)));
var ap33 = /* @__PURE__ */ dual33(2, (self2, that) => zipWith43(self2, that, (f2222, a2222) => f2222(a2222)));
var reduceCompact33 = /* @__PURE__ */ dual33(3, (self2, b2222, f2222) => {
  let out = b2222;
  for (const oa of self2) {
    if (isSome22223(oa)) {
      out = f2222(out, oa.value);
    }
  }
  return out;
});
var toArray33 = (self2) => isNone22223(self2) ? [] : [self2.value];
var partitionMap43 = /* @__PURE__ */ dual33(2, (self2, f2222) => {
  if (isNone22223(self2)) {
    return [none22223(), none22223()];
  }
  const e2222 = f2222(self2.value);
  return isLeft43(e2222) ? [some22223(e2222.left), none22223()] : [none22223(), some22223(e2222.right)];
});
var filterMap43 = /* @__PURE__ */ dual33(2, (self2, f2222) => isNone22223(self2) ? none22223() : f2222(self2.value));
var filter43 = /* @__PURE__ */ dual33(2, (self2, predicate) => filterMap43(self2, (b2222) => predicate(b2222) ? some83(b2222) : none53));
var getEquivalence53 = (isEquivalent) => make113((x2222, y2222) => x2222 === y2222 || (isNone22223(x2222) ? isNone22223(y2222) : isNone22223(y2222) ? false : isEquivalent(x2222.value, y2222.value)));
var getOrder43 = (O2222) => make22223((self2, that) => isSome22223(self2) ? isSome22223(that) ? O2222(self2.value, that.value) : 1 : -1);
var lift233 = (f2222) => dual33(2, (self2, that) => zipWith43(self2, that, f2222));
var liftPredicate43 = (predicate) => (b2222) => predicate(b2222) ? some22223(b2222) : none22223();
var containsWith43 = (isEquivalent) => dual33(2, (self2, a2222) => isNone22223(self2) ? false : isEquivalent(self2.value, a2222));
var _equivalence53 = /* @__PURE__ */ equivalence33();
var contains43 = /* @__PURE__ */ containsWith43(_equivalence53);
var exists33 = /* @__PURE__ */ dual33(2, (self2, refinement) => isNone22223(self2) ? false : refinement(self2.value));
var bindTo22223 = /* @__PURE__ */ bindTo63(map43);
var let_22223 = /* @__PURE__ */ let_63(map43);
var bind22223 = /* @__PURE__ */ bind63(map43, flatMap43);
var Do43 = /* @__PURE__ */ some22223({});
var adapter22223 = /* @__PURE__ */ adapter53();
var gen33 = (f2222) => {
  const iterator = f2222(adapter22223);
  let state = iterator.next();
  if (state.done) {
    return some22223(state.value);
  } else {
    let current = state.value;
    if (isGenKind33(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet33(current);
    }
    if (isNone22223(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind33(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet33(current);
        }
        if (isNone22223(current)) {
          return current;
        }
      }
    }
    return some22223(state.value);
  }
};
var MutableRef_exports23 = {};
__export3222(MutableRef_exports23, {
  compareAndSet: () => compareAndSet6,
  decrement: () => decrement6,
  decrementAndGet: () => decrementAndGet6,
  get: () => get23,
  getAndDecrement: () => getAndDecrement6,
  getAndIncrement: () => getAndIncrement6,
  getAndSet: () => getAndSet6,
  getAndUpdate: () => getAndUpdate6,
  increment: () => increment6,
  incrementAndGet: () => incrementAndGet6,
  make: () => make32223,
  set: () => set2223,
  setAndGet: () => setAndGet6,
  toggle: () => toggle6,
  update: () => update6,
  updateAndGet: () => updateAndGet6
});
var TypeId42223 = /* @__PURE__ */ Symbol.for("effect/MutableRef");
var MutableRefProto6 = {
  [TypeId42223]: TypeId42223,
  toString() {
    return format33(this.toJSON());
  },
  toJSON() {
    return {
      _id: "MutableRef",
      current: toJSON33(this.current)
    };
  },
  [NodeInspectSymbol33]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments33(this, arguments);
  }
};
var make32223 = (value) => {
  const ref = Object.create(MutableRefProto6);
  ref.current = value;
  return ref;
};
var compareAndSet6 = /* @__PURE__ */ dual33(3, (self2, oldValue, newValue) => {
  if (equals33(oldValue, self2.current)) {
    self2.current = newValue;
    return true;
  }
  return false;
});
var decrement6 = (self2) => update6(self2, (n2222) => n2222 - 1);
var decrementAndGet6 = (self2) => updateAndGet6(self2, (n2222) => n2222 - 1);
var get23 = (self2) => self2.current;
var getAndDecrement6 = (self2) => getAndUpdate6(self2, (n2222) => n2222 - 1);
var getAndIncrement6 = (self2) => getAndUpdate6(self2, (n2222) => n2222 + 1);
var getAndSet6 = /* @__PURE__ */ dual33(2, (self2, value) => {
  const ret = self2.current;
  self2.current = value;
  return ret;
});
var getAndUpdate6 = /* @__PURE__ */ dual33(2, (self2, f2222) => getAndSet6(self2, f2222(get23(self2))));
var increment6 = (self2) => update6(self2, (n2222) => n2222 + 1);
var incrementAndGet6 = (self2) => updateAndGet6(self2, (n2222) => n2222 + 1);
var set2223 = /* @__PURE__ */ dual33(2, (self2, value) => {
  self2.current = value;
  return self2;
});
var setAndGet6 = /* @__PURE__ */ dual33(2, (self2, value) => {
  self2.current = value;
  return self2.current;
});
var update6 = /* @__PURE__ */ dual33(2, (self2, f2222) => set2223(self2, f2222(get23(self2))));
var updateAndGet6 = /* @__PURE__ */ dual33(2, (self2, f2222) => setAndGet6(self2, f2222(get23(self2))));
var toggle6 = (self2) => update6(self2, (_2222) => !_2222);
function getVariables4(initialScope) {
  const scopeRef = MutableRef_exports23.make(initialScope);
  const variablesRef = MutableRef_exports23.make(MutableRef_exports23.get(scopeRef).variables);
  while (MutableRef_exports23.get(scopeRef).type !== scopeManager.ScopeType.global) {
    MutableRef_exports23.set(scopeRef, MutableRef_exports23.get(scopeRef).upper);
    MutableRef_exports23.update(variablesRef, (variables) => variables.concat(MutableRef_exports23.get(scopeRef).variables));
  }
  return MutableRef_exports23.get(variablesRef).reverse();
}
Function_exports33.dual(2, (name22, initialScope) => {
  return Option_exports33.fromNullable(getVariables4(initialScope).find((variable) => variable.name === name22));
});
var t23 = Symbol.for("@ts-pattern/matcher");
var e23 = Symbol.for("@ts-pattern/isVariadic");
var n23 = "@ts-pattern/anonymous-select-key";
var r23 = (t2222) => Boolean(t2222 && "object" == typeof t2222);
var i23 = (e2222) => e2222 && !!e2222[t23];
var o23 = (n2222, s2222, c2222) => {
  if (i23(n2222)) {
    const e2222 = n2222[t23](), { matched: r2222, selections: i2222 } = e2222.match(s2222);
    return r2222 && i2222 && Object.keys(i2222).forEach((t2222) => c2222(t2222, i2222[t2222])), r2222;
  }
  if (r23(n2222)) {
    if (!r23(s2222)) return false;
    if (Array.isArray(n2222)) {
      if (!Array.isArray(s2222)) return false;
      let t2222 = [], r2222 = [], a2222 = [];
      for (const o2222 of n2222.keys()) {
        const s322 = n2222[o2222];
        i23(s322) && s322[e23] ? a2222.push(s322) : a2222.length ? r2222.push(s322) : t2222.push(s322);
      }
      if (a2222.length) {
        if (a2222.length > 1) throw new Error("Pattern error: Using `...P.array(...)` several times in a single pattern is not allowed.");
        if (s2222.length < t2222.length + r2222.length) return false;
        const e2222 = s2222.slice(0, t2222.length), n322 = 0 === r2222.length ? [] : s2222.slice(-r2222.length), i2222 = s2222.slice(t2222.length, 0 === r2222.length ? Infinity : -r2222.length);
        return t2222.every((t322, n422) => o23(t322, e2222[n422], c2222)) && r2222.every((t322, e322) => o23(t322, n322[e322], c2222)) && (0 === a2222.length || o23(a2222[0], i2222, c2222));
      }
      return n2222.length === s2222.length && n2222.every((t322, e2222) => o23(t322, s2222[e2222], c2222));
    }
    return Object.keys(n2222).every((e2222) => {
      const r2222 = n2222[e2222];
      return (e2222 in s2222 || i23(a2222 = r2222) && "optional" === a2222[t23]().matcherType) && o23(r2222, s2222[e2222], c2222);
      var a2222;
    });
  }
  return Object.is(s2222, n2222);
};
var s23 = (e2222) => {
  var n2222, o2222, a2222;
  return r23(e2222) ? i23(e2222) ? null != (n2222 = null == (o2222 = (a2222 = e2222[t23]()).getSelectionKeys) ? void 0 : o2222.call(a2222)) ? n2222 : [] : Array.isArray(e2222) ? c23(e2222, s23) : c23(Object.values(e2222), s23) : [];
};
var c23 = (t2222, e2222) => t2222.reduce((t322, n2222) => t322.concat(e2222(n2222)), []);
function a23(...t2222) {
  if (1 === t2222.length) {
    const [e2222] = t2222;
    return (t322) => o23(e2222, t322, () => {
    });
  }
  if (2 === t2222.length) {
    const [e2222, n2222] = t2222;
    return o23(e2222, n2222, () => {
    });
  }
  throw new Error(`isMatching wasn't given the right number of arguments: expected 1 or 2, received ${t2222.length}.`);
}
function u23(t2222) {
  return Object.assign(t2222, { optional: () => l23(t2222), and: (e2222) => m23(t2222, e2222), or: (e2222) => d23(t2222, e2222), select: (e2222) => void 0 === e2222 ? p23(t2222) : p23(e2222, t2222) });
}
function h23(t2222) {
  return Object.assign(((t322) => Object.assign(t322, { [Symbol.iterator]() {
    let n2222 = 0;
    const r2222 = [{ value: Object.assign(t322, { [e23]: true }), done: false }, { done: true, value: void 0 }];
    return { next: () => {
      var t422;
      return null != (t422 = r2222[n2222++]) ? t422 : r2222.at(-1);
    } };
  } }))(t2222), { optional: () => h23(l23(t2222)), select: (e2222) => h23(void 0 === e2222 ? p23(t2222) : p23(e2222, t2222)) });
}
function l23(e2222) {
  return u23({ [t23]: () => ({ match: (t2222) => {
    let n2222 = {};
    const r2222 = (t322, e322) => {
      n2222[t322] = e322;
    };
    return void 0 === t2222 ? (s23(e2222).forEach((t322) => r2222(t322, void 0)), { matched: true, selections: n2222 }) : { matched: o23(e2222, t2222, r2222), selections: n2222 };
  }, getSelectionKeys: () => s23(e2222), matcherType: "optional" }) });
}
var f23 = (t2222, e2222) => {
  for (const n2222 of t2222) if (!e2222(n2222)) return false;
  return true;
};
var g23 = (t2222, e2222) => {
  for (const [n2222, r2222] of t2222.entries()) if (!e2222(r2222, n2222)) return false;
  return true;
};
function m23(...e2222) {
  return u23({ [t23]: () => ({ match: (t2222) => {
    let n2222 = {};
    const r2222 = (t322, e322) => {
      n2222[t322] = e322;
    };
    return { matched: e2222.every((e322) => o23(e322, t2222, r2222)), selections: n2222 };
  }, getSelectionKeys: () => c23(e2222, s23), matcherType: "and" }) });
}
function d23(...e2222) {
  return u23({ [t23]: () => ({ match: (t2222) => {
    let n2222 = {};
    const r2222 = (t322, e322) => {
      n2222[t322] = e322;
    };
    return c23(e2222, s23).forEach((t322) => r2222(t322, void 0)), { matched: e2222.some((e322) => o23(e322, t2222, r2222)), selections: n2222 };
  }, getSelectionKeys: () => c23(e2222, s23), matcherType: "or" }) });
}
function y23(e2222) {
  return { [t23]: () => ({ match: (t2222) => ({ matched: Boolean(e2222(t2222)) }) }) };
}
function p23(...e2222) {
  const r2222 = "string" == typeof e2222[0] ? e2222[0] : void 0, i2222 = 2 === e2222.length ? e2222[1] : "string" == typeof e2222[0] ? void 0 : e2222[0];
  return u23({ [t23]: () => ({ match: (t2222) => {
    let e322 = { [null != r2222 ? r2222 : n23]: t2222 };
    return { matched: void 0 === i2222 || o23(i2222, t2222, (t322, n2222) => {
      e322[t322] = n2222;
    }), selections: e322 };
  }, getSelectionKeys: () => [null != r2222 ? r2222 : n23].concat(void 0 === i2222 ? [] : s23(i2222)) }) });
}
function v23(t2222) {
  return "number" == typeof t2222;
}
function b23(t2222) {
  return "string" == typeof t2222;
}
function w23(t2222) {
  return "bigint" == typeof t2222;
}
var S23 = u23(y23(function(t2222) {
  return true;
}));
var O23 = S23;
var j23 = (t2222) => Object.assign(u23(t2222), { startsWith: (e2222) => {
  return j23(m23(t2222, (n2222 = e2222, y23((t322) => b23(t322) && t322.startsWith(n2222)))));
  var n2222;
}, endsWith: (e2222) => {
  return j23(m23(t2222, (n2222 = e2222, y23((t322) => b23(t322) && t322.endsWith(n2222)))));
  var n2222;
}, minLength: (e2222) => j23(m23(t2222, ((t322) => y23((e322) => b23(e322) && e322.length >= t322))(e2222))), maxLength: (e2222) => j23(m23(t2222, ((t322) => y23((e322) => b23(e322) && e322.length <= t322))(e2222))), includes: (e2222) => {
  return j23(m23(t2222, (n2222 = e2222, y23((t322) => b23(t322) && t322.includes(n2222)))));
  var n2222;
}, regex: (e2222) => {
  return j23(m23(t2222, (n2222 = e2222, y23((t322) => b23(t322) && Boolean(t322.match(n2222))))));
  var n2222;
} });
var E23 = j23(y23(b23));
var K23 = (t2222) => Object.assign(u23(t2222), { between: (e2222, n2222) => K23(m23(t2222, ((t322, e322) => y23((n322) => v23(n322) && t322 <= n322 && e322 >= n322))(e2222, n2222))), lt: (e2222) => K23(m23(t2222, ((t322) => y23((e322) => v23(e322) && e322 < t322))(e2222))), gt: (e2222) => K23(m23(t2222, ((t322) => y23((e322) => v23(e322) && e322 > t322))(e2222))), lte: (e2222) => K23(m23(t2222, ((t322) => y23((e322) => v23(e322) && e322 <= t322))(e2222))), gte: (e2222) => K23(m23(t2222, ((t322) => y23((e322) => v23(e322) && e322 >= t322))(e2222))), int: () => K23(m23(t2222, y23((t322) => v23(t322) && Number.isInteger(t322)))), finite: () => K23(m23(t2222, y23((t322) => v23(t322) && Number.isFinite(t322)))), positive: () => K23(m23(t2222, y23((t322) => v23(t322) && t322 > 0))), negative: () => K23(m23(t2222, y23((t322) => v23(t322) && t322 < 0))) });
var x23 = K23(y23(v23));
var A23 = (t2222) => Object.assign(u23(t2222), { between: (e2222, n2222) => A23(m23(t2222, ((t322, e322) => y23((n322) => w23(n322) && t322 <= n322 && e322 >= n322))(e2222, n2222))), lt: (e2222) => A23(m23(t2222, ((t322) => y23((e322) => w23(e322) && e322 < t322))(e2222))), gt: (e2222) => A23(m23(t2222, ((t322) => y23((e322) => w23(e322) && e322 > t322))(e2222))), lte: (e2222) => A23(m23(t2222, ((t322) => y23((e322) => w23(e322) && e322 <= t322))(e2222))), gte: (e2222) => A23(m23(t2222, ((t322) => y23((e322) => w23(e322) && e322 >= t322))(e2222))), positive: () => A23(m23(t2222, y23((t322) => w23(t322) && t322 > 0))), negative: () => A23(m23(t2222, y23((t322) => w23(t322) && t322 < 0))) });
var P222 = A23(y23(w23));
var T23 = u23(y23(function(t2222) {
  return "boolean" == typeof t2222;
}));
var k23 = u23(y23(function(t2222) {
  return "symbol" == typeof t2222;
}));
var B23 = u23(y23(function(t2222) {
  return null == t2222;
}));
var _23 = u23(y23(function(t2222) {
  return null != t2222;
}));
var N23 = { __proto__: null, matcher: t23, optional: l23, array: function(...e2222) {
  return h23({ [t23]: () => ({ match: (t2222) => {
    if (!Array.isArray(t2222)) return { matched: false };
    if (0 === e2222.length) return { matched: true };
    const n2222 = e2222[0];
    let r2222 = {};
    if (0 === t2222.length) return s23(n2222).forEach((t322) => {
      r2222[t322] = [];
    }), { matched: true, selections: r2222 };
    const i2222 = (t322, e322) => {
      r2222[t322] = (r2222[t322] || []).concat([e322]);
    };
    return { matched: t2222.every((t322) => o23(n2222, t322, i2222)), selections: r2222 };
  }, getSelectionKeys: () => 0 === e2222.length ? [] : s23(e2222[0]) }) });
}, set: function(...e2222) {
  return u23({ [t23]: () => ({ match: (t2222) => {
    if (!(t2222 instanceof Set)) return { matched: false };
    let n2222 = {};
    if (0 === t2222.size) return { matched: true, selections: n2222 };
    if (0 === e2222.length) return { matched: true };
    const r2222 = (t322, e322) => {
      n2222[t322] = (n2222[t322] || []).concat([e322]);
    }, i2222 = e2222[0];
    return { matched: f23(t2222, (t322) => o23(i2222, t322, r2222)), selections: n2222 };
  }, getSelectionKeys: () => 0 === e2222.length ? [] : s23(e2222[0]) }) });
}, map: function(...e2222) {
  return u23({ [t23]: () => ({ match: (t2222) => {
    if (!(t2222 instanceof Map)) return { matched: false };
    let n2222 = {};
    if (0 === t2222.size) return { matched: true, selections: n2222 };
    const r2222 = (t322, e322) => {
      n2222[t322] = (n2222[t322] || []).concat([e322]);
    };
    if (0 === e2222.length) return { matched: true };
    var i2222;
    if (1 === e2222.length) throw new Error(`\`P.map\` wasn't given enough arguments. Expected (key, value), received ${null == (i2222 = e2222[0]) ? void 0 : i2222.toString()}`);
    const [s2222, c2222] = e2222;
    return { matched: g23(t2222, (t322, e322) => {
      const n322 = o23(s2222, e322, r2222), i322 = o23(c2222, t322, r2222);
      return n322 && i322;
    }), selections: n2222 };
  }, getSelectionKeys: () => 0 === e2222.length ? [] : [...s23(e2222[0]), ...s23(e2222[1])] }) });
}, intersection: m23, union: d23, not: function(e2222) {
  return u23({ [t23]: () => ({ match: (t2222) => ({ matched: !o23(e2222, t2222, () => {
  }) }), getSelectionKeys: () => [], matcherType: "not" }) });
}, when: y23, select: p23, any: S23, _: O23, string: E23, number: x23, bigint: P222, boolean: T23, symbol: k23, nullish: B23, nonNullable: _23, instanceOf: function(t2222) {
  return u23(y23(/* @__PURE__ */ function(t322) {
    return (e2222) => e2222 instanceof t322;
  }(t2222)));
}, shape: function(t2222) {
  return u23(y23(a23(t2222)));
} };
var KEYS2222 = {
  ArrayExpression: [
    "elements"
  ],
  ArrayPattern: [
    "elements"
  ],
  ArrowFunctionExpression: [
    "params",
    "body"
  ],
  AssignmentExpression: [
    "left",
    "right"
  ],
  AssignmentPattern: [
    "left",
    "right"
  ],
  AwaitExpression: [
    "argument"
  ],
  BinaryExpression: [
    "left",
    "right"
  ],
  BlockStatement: [
    "body"
  ],
  BreakStatement: [
    "label"
  ],
  CallExpression: [
    "callee",
    "arguments"
  ],
  CatchClause: [
    "param",
    "body"
  ],
  ChainExpression: [
    "expression"
  ],
  ClassBody: [
    "body"
  ],
  ClassDeclaration: [
    "id",
    "superClass",
    "body"
  ],
  ClassExpression: [
    "id",
    "superClass",
    "body"
  ],
  ConditionalExpression: [
    "test",
    "consequent",
    "alternate"
  ],
  ContinueStatement: [
    "label"
  ],
  DebuggerStatement: [],
  DoWhileStatement: [
    "body",
    "test"
  ],
  EmptyStatement: [],
  ExperimentalRestProperty: [
    "argument"
  ],
  ExperimentalSpreadProperty: [
    "argument"
  ],
  ExportAllDeclaration: [
    "exported",
    "source"
  ],
  ExportDefaultDeclaration: [
    "declaration"
  ],
  ExportNamedDeclaration: [
    "declaration",
    "specifiers",
    "source"
  ],
  ExportSpecifier: [
    "exported",
    "local"
  ],
  ExpressionStatement: [
    "expression"
  ],
  ForInStatement: [
    "left",
    "right",
    "body"
  ],
  ForOfStatement: [
    "left",
    "right",
    "body"
  ],
  ForStatement: [
    "init",
    "test",
    "update",
    "body"
  ],
  FunctionDeclaration: [
    "id",
    "params",
    "body"
  ],
  FunctionExpression: [
    "id",
    "params",
    "body"
  ],
  Identifier: [],
  IfStatement: [
    "test",
    "consequent",
    "alternate"
  ],
  ImportDeclaration: [
    "specifiers",
    "source"
  ],
  ImportDefaultSpecifier: [
    "local"
  ],
  ImportExpression: [
    "source"
  ],
  ImportNamespaceSpecifier: [
    "local"
  ],
  ImportSpecifier: [
    "imported",
    "local"
  ],
  JSXAttribute: [
    "name",
    "value"
  ],
  JSXClosingElement: [
    "name"
  ],
  JSXClosingFragment: [],
  JSXElement: [
    "openingElement",
    "children",
    "closingElement"
  ],
  JSXEmptyExpression: [],
  JSXExpressionContainer: [
    "expression"
  ],
  JSXFragment: [
    "openingFragment",
    "children",
    "closingFragment"
  ],
  JSXIdentifier: [],
  JSXMemberExpression: [
    "object",
    "property"
  ],
  JSXNamespacedName: [
    "namespace",
    "name"
  ],
  JSXOpeningElement: [
    "name",
    "attributes"
  ],
  JSXOpeningFragment: [],
  JSXSpreadAttribute: [
    "argument"
  ],
  JSXSpreadChild: [
    "expression"
  ],
  JSXText: [],
  LabeledStatement: [
    "label",
    "body"
  ],
  Literal: [],
  LogicalExpression: [
    "left",
    "right"
  ],
  MemberExpression: [
    "object",
    "property"
  ],
  MetaProperty: [
    "meta",
    "property"
  ],
  MethodDefinition: [
    "key",
    "value"
  ],
  NewExpression: [
    "callee",
    "arguments"
  ],
  ObjectExpression: [
    "properties"
  ],
  ObjectPattern: [
    "properties"
  ],
  PrivateIdentifier: [],
  Program: [
    "body"
  ],
  Property: [
    "key",
    "value"
  ],
  PropertyDefinition: [
    "key",
    "value"
  ],
  RestElement: [
    "argument"
  ],
  ReturnStatement: [
    "argument"
  ],
  SequenceExpression: [
    "expressions"
  ],
  SpreadElement: [
    "argument"
  ],
  StaticBlock: [
    "body"
  ],
  Super: [],
  SwitchCase: [
    "test",
    "consequent"
  ],
  SwitchStatement: [
    "discriminant",
    "cases"
  ],
  TaggedTemplateExpression: [
    "tag",
    "quasi"
  ],
  TemplateElement: [],
  TemplateLiteral: [
    "quasis",
    "expressions"
  ],
  ThisExpression: [],
  ThrowStatement: [
    "argument"
  ],
  TryStatement: [
    "block",
    "handler",
    "finalizer"
  ],
  UnaryExpression: [
    "argument"
  ],
  UpdateExpression: [
    "argument"
  ],
  VariableDeclaration: [
    "declarations"
  ],
  VariableDeclarator: [
    "id",
    "init"
  ],
  WhileStatement: [
    "test",
    "body"
  ],
  WithStatement: [
    "object",
    "body"
  ],
  YieldExpression: [
    "argument"
  ]
};
var NODE_TYPES2222 = Object.keys(KEYS2222);
for (const type of NODE_TYPES2222) {
  Object.freeze(KEYS2222[type]);
}
Object.freeze(KEYS2222);
var visitor_keys_default2222 = KEYS2222;
var KEY_BLACKLIST2222 = /* @__PURE__ */ new Set([
  "parent",
  "leadingComments",
  "trailingComments"
]);
function filterKey2222(key) {
  return !KEY_BLACKLIST2222.has(key) && key[0] !== "_";
}
function getKeys2222(node) {
  return Object.keys(node).filter(filterKey2222);
}
function getInnermostScope2222(initialScope, node) {
  const location = node.range[0];
  let scope = initialScope;
  let found = false;
  do {
    found = false;
    for (const childScope of scope.childScopes) {
      const range222 = childScope.block.range;
      if (range222[0] <= location && location < range222[1]) {
        scope = childScope;
        found = true;
        break;
      }
    }
  } while (found);
  return scope;
}
function findVariable22222(initialScope, nameOrNode) {
  let name22 = "";
  let scope = initialScope;
  if (typeof nameOrNode === "string") {
    name22 = nameOrNode;
  } else {
    name22 = nameOrNode.name;
    scope = getInnermostScope2222(scope, nameOrNode);
  }
  while (scope != null) {
    const variable = scope.set.get(name22);
    if (variable != null) {
      return variable;
    }
    scope = scope.upper;
  }
  return null;
}
function negate02222(token) {
  return !this(token);
}
function negate2222(f2222) {
  return negate02222.bind(f2222);
}
function isPunctuatorTokenWithValue2222(token, value) {
  return token.type === "Punctuator" && token.value === value;
}
function isArrowToken2222(token) {
  return isPunctuatorTokenWithValue2222(token, "=>");
}
function isCommaToken2222(token) {
  return isPunctuatorTokenWithValue2222(token, ",");
}
function isSemicolonToken2222(token) {
  return isPunctuatorTokenWithValue2222(token, ";");
}
function isColonToken2222(token) {
  return isPunctuatorTokenWithValue2222(token, ":");
}
function isOpeningParenToken2222(token) {
  return isPunctuatorTokenWithValue2222(token, "(");
}
function isClosingParenToken2222(token) {
  return isPunctuatorTokenWithValue2222(token, ")");
}
function isOpeningBracketToken2222(token) {
  return isPunctuatorTokenWithValue2222(token, "[");
}
function isClosingBracketToken2222(token) {
  return isPunctuatorTokenWithValue2222(token, "]");
}
function isOpeningBraceToken2222(token) {
  return isPunctuatorTokenWithValue2222(token, "{");
}
function isClosingBraceToken2222(token) {
  return isPunctuatorTokenWithValue2222(token, "}");
}
function isCommentToken2222(token) {
  return ["Block", "Line", "Shebang"].includes(token.type);
}
negate2222(isArrowToken2222);
negate2222(isCommaToken2222);
negate2222(isSemicolonToken2222);
negate2222(isColonToken2222);
negate2222(isOpeningParenToken2222);
negate2222(isClosingParenToken2222);
negate2222(isOpeningBracketToken2222);
negate2222(isClosingBracketToken2222);
negate2222(isOpeningBraceToken2222);
negate2222(isClosingBraceToken2222);
negate2222(isCommentToken2222);
function getOpeningParenOfParams2222(node, sourceCode) {
  return node.id ? sourceCode.getTokenAfter(node.id, isOpeningParenToken2222) : sourceCode.getFirstToken(node, isOpeningParenToken2222);
}
function getFunctionHeadLocation2222(node, sourceCode) {
  const parent = node.parent;
  let start = null;
  let end = null;
  if (node.type === "ArrowFunctionExpression") {
    const arrowToken = sourceCode.getTokenBefore(node.body, isArrowToken2222);
    start = arrowToken.loc.start;
    end = arrowToken.loc.end;
  } else if (parent.type === "Property" || parent.type === "MethodDefinition" || parent.type === "PropertyDefinition") {
    start = parent.loc.start;
    end = getOpeningParenOfParams2222(node, sourceCode).loc.start;
  } else {
    start = node.loc.start;
    end = getOpeningParenOfParams2222(node, sourceCode).loc.start;
  }
  return {
    start: { ...start },
    end: { ...end }
  };
}
var globalObject2222 = typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {};
var builtinNames2222 = Object.freeze(
  /* @__PURE__ */ new Set([
    "Array",
    "ArrayBuffer",
    "BigInt",
    "BigInt64Array",
    "BigUint64Array",
    "Boolean",
    "DataView",
    "Date",
    "decodeURI",
    "decodeURIComponent",
    "encodeURI",
    "encodeURIComponent",
    "escape",
    "Float32Array",
    "Float64Array",
    "Function",
    "Infinity",
    "Int16Array",
    "Int32Array",
    "Int8Array",
    "isFinite",
    "isNaN",
    "isPrototypeOf",
    "JSON",
    "Map",
    "Math",
    "NaN",
    "Number",
    "Object",
    "parseFloat",
    "parseInt",
    "Promise",
    "Proxy",
    "Reflect",
    "RegExp",
    "Set",
    "String",
    "Symbol",
    "Uint16Array",
    "Uint32Array",
    "Uint8Array",
    "Uint8ClampedArray",
    "undefined",
    "unescape",
    "WeakMap",
    "WeakSet"
  ])
);
var callAllowed2222 = new Set(
  [
    Array.isArray,
    Array.of,
    Array.prototype.at,
    Array.prototype.concat,
    Array.prototype.entries,
    Array.prototype.every,
    Array.prototype.filter,
    Array.prototype.find,
    Array.prototype.findIndex,
    Array.prototype.flat,
    Array.prototype.includes,
    Array.prototype.indexOf,
    Array.prototype.join,
    Array.prototype.keys,
    Array.prototype.lastIndexOf,
    Array.prototype.slice,
    Array.prototype.some,
    Array.prototype.toString,
    Array.prototype.values,
    typeof BigInt === "function" ? BigInt : void 0,
    Boolean,
    Date,
    Date.parse,
    decodeURI,
    decodeURIComponent,
    encodeURI,
    encodeURIComponent,
    escape,
    isFinite,
    isNaN,
    isPrototypeOf,
    Map,
    Map.prototype.entries,
    Map.prototype.get,
    Map.prototype.has,
    Map.prototype.keys,
    Map.prototype.values,
    ...Object.getOwnPropertyNames(Math).filter((k2222) => k2222 !== "random").map((k2222) => Math[k2222]).filter((f2222) => typeof f2222 === "function"),
    Number,
    Number.isFinite,
    Number.isNaN,
    Number.parseFloat,
    Number.parseInt,
    Number.prototype.toExponential,
    Number.prototype.toFixed,
    Number.prototype.toPrecision,
    Number.prototype.toString,
    Object,
    Object.entries,
    Object.is,
    Object.isExtensible,
    Object.isFrozen,
    Object.isSealed,
    Object.keys,
    Object.values,
    parseFloat,
    parseInt,
    RegExp,
    Set,
    Set.prototype.entries,
    Set.prototype.has,
    Set.prototype.keys,
    Set.prototype.values,
    String,
    String.fromCharCode,
    String.fromCodePoint,
    String.raw,
    String.prototype.at,
    String.prototype.charAt,
    String.prototype.charCodeAt,
    String.prototype.codePointAt,
    String.prototype.concat,
    String.prototype.endsWith,
    String.prototype.includes,
    String.prototype.indexOf,
    String.prototype.lastIndexOf,
    String.prototype.normalize,
    String.prototype.padEnd,
    String.prototype.padStart,
    String.prototype.slice,
    String.prototype.startsWith,
    String.prototype.substr,
    String.prototype.substring,
    String.prototype.toLowerCase,
    String.prototype.toString,
    String.prototype.toUpperCase,
    String.prototype.trim,
    String.prototype.trimEnd,
    String.prototype.trimLeft,
    String.prototype.trimRight,
    String.prototype.trimStart,
    Symbol.for,
    Symbol.keyFor,
    unescape
  ].filter((f2222) => typeof f2222 === "function")
);
var callPassThrough2222 = /* @__PURE__ */ new Set([
  Object.freeze,
  Object.preventExtensions,
  Object.seal
]);
var getterAllowed2222 = [
  [Map, /* @__PURE__ */ new Set(["size"])],
  [
    RegExp,
    /* @__PURE__ */ new Set([
      "dotAll",
      "flags",
      "global",
      "hasIndices",
      "ignoreCase",
      "multiline",
      "source",
      "sticky",
      "unicode"
    ])
  ],
  [Set, /* @__PURE__ */ new Set(["size"])]
];
function getPropertyDescriptor2222(object222, name22) {
  let x2222 = object222;
  while ((typeof x2222 === "object" || typeof x2222 === "function") && x2222 !== null) {
    const d2222 = Object.getOwnPropertyDescriptor(x2222, name22);
    if (d2222) {
      return d2222;
    }
    x2222 = Object.getPrototypeOf(x2222);
  }
  return null;
}
function isGetter2222(object222, name22) {
  const d2222 = getPropertyDescriptor2222(object222, name22);
  return d2222 != null && d2222.get != null;
}
function getElementValues2222(nodeList, initialScope) {
  const valueList = [];
  for (let i2222 = 0; i2222 < nodeList.length; ++i2222) {
    const elementNode = nodeList[i2222];
    if (elementNode == null) {
      valueList.length = i2222 + 1;
    } else if (elementNode.type === "SpreadElement") {
      const argument = getStaticValueR2222(elementNode.argument, initialScope);
      if (argument == null) {
        return null;
      }
      valueList.push(...argument.value);
    } else {
      const element = getStaticValueR2222(elementNode, initialScope);
      if (element == null) {
        return null;
      }
      valueList.push(element.value);
    }
  }
  return valueList;
}
function isEffectivelyConst2222(variable) {
  const refs = variable.references;
  const inits = refs.filter((r2222) => r2222.init).length;
  const reads = refs.filter((r2222) => r2222.isReadOnly()).length;
  if (inits === 1 && reads + inits === refs.length) {
    return true;
  }
  return false;
}
var operations2222 = Object.freeze({
  ArrayExpression(node, initialScope) {
    const elements = getElementValues2222(node.elements, initialScope);
    return elements != null ? { value: elements } : null;
  },
  AssignmentExpression(node, initialScope) {
    if (node.operator === "=") {
      return getStaticValueR2222(node.right, initialScope);
    }
    return null;
  },
  //eslint-disable-next-line complexity
  BinaryExpression(node, initialScope) {
    if (node.operator === "in" || node.operator === "instanceof") {
      return null;
    }
    const left32222 = getStaticValueR2222(node.left, initialScope);
    const right32222 = getStaticValueR2222(node.right, initialScope);
    if (left32222 != null && right32222 != null) {
      switch (node.operator) {
        case "==":
          return { value: left32222.value == right32222.value };
        case "!=":
          return { value: left32222.value != right32222.value };
        case "===":
          return { value: left32222.value === right32222.value };
        case "!==":
          return { value: left32222.value !== right32222.value };
        case "<":
          return { value: left32222.value < right32222.value };
        case "<=":
          return { value: left32222.value <= right32222.value };
        case ">":
          return { value: left32222.value > right32222.value };
        case ">=":
          return { value: left32222.value >= right32222.value };
        case "<<":
          return { value: left32222.value << right32222.value };
        case ">>":
          return { value: left32222.value >> right32222.value };
        case ">>>":
          return { value: left32222.value >>> right32222.value };
        case "+":
          return { value: left32222.value + right32222.value };
        case "-":
          return { value: left32222.value - right32222.value };
        case "*":
          return { value: left32222.value * right32222.value };
        case "/":
          return { value: left32222.value / right32222.value };
        case "%":
          return { value: left32222.value % right32222.value };
        case "**":
          return { value: left32222.value ** right32222.value };
        case "|":
          return { value: left32222.value | right32222.value };
        case "^":
          return { value: left32222.value ^ right32222.value };
        case "&":
          return { value: left32222.value & right32222.value };
      }
    }
    return null;
  },
  CallExpression(node, initialScope) {
    const calleeNode = node.callee;
    const args = getElementValues2222(node.arguments, initialScope);
    if (args != null) {
      if (calleeNode.type === "MemberExpression") {
        if (calleeNode.property.type === "PrivateIdentifier") {
          return null;
        }
        const object222 = getStaticValueR2222(calleeNode.object, initialScope);
        if (object222 != null) {
          if (object222.value == null && (object222.optional || node.optional)) {
            return { value: void 0, optional: true };
          }
          const property = getStaticPropertyNameValue2222(
            calleeNode,
            initialScope
          );
          if (property != null) {
            const receiver = object222.value;
            const methodName = property.value;
            if (callAllowed2222.has(receiver[methodName])) {
              return { value: receiver[methodName](...args) };
            }
            if (callPassThrough2222.has(receiver[methodName])) {
              return { value: args[0] };
            }
          }
        }
      } else {
        const callee = getStaticValueR2222(calleeNode, initialScope);
        if (callee != null) {
          if (callee.value == null && node.optional) {
            return { value: void 0, optional: true };
          }
          const func = callee.value;
          if (callAllowed2222.has(func)) {
            return { value: func(...args) };
          }
          if (callPassThrough2222.has(func)) {
            return { value: args[0] };
          }
        }
      }
    }
    return null;
  },
  ConditionalExpression(node, initialScope) {
    const test = getStaticValueR2222(node.test, initialScope);
    if (test != null) {
      return test.value ? getStaticValueR2222(node.consequent, initialScope) : getStaticValueR2222(node.alternate, initialScope);
    }
    return null;
  },
  ExpressionStatement(node, initialScope) {
    return getStaticValueR2222(node.expression, initialScope);
  },
  Identifier(node, initialScope) {
    if (initialScope != null) {
      const variable = findVariable22222(initialScope, node);
      if (variable != null && variable.defs.length === 0 && builtinNames2222.has(variable.name) && variable.name in globalObject2222) {
        return { value: globalObject2222[variable.name] };
      }
      if (variable != null && variable.defs.length === 1) {
        const def = variable.defs[0];
        if (def.parent && def.type === "Variable" && (def.parent.kind === "const" || isEffectivelyConst2222(variable)) && // TODO(mysticatea): don't support destructuring here.
        def.node.id.type === "Identifier") {
          return getStaticValueR2222(def.node.init, initialScope);
        }
      }
    }
    return null;
  },
  Literal(node) {
    if ((node.regex != null || node.bigint != null) && node.value == null) {
      return null;
    }
    return { value: node.value };
  },
  LogicalExpression(node, initialScope) {
    const left32222 = getStaticValueR2222(node.left, initialScope);
    if (left32222 != null) {
      if (node.operator === "||" && Boolean(left32222.value) === true || node.operator === "&&" && Boolean(left32222.value) === false || node.operator === "??" && left32222.value != null) {
        return left32222;
      }
      const right32222 = getStaticValueR2222(node.right, initialScope);
      if (right32222 != null) {
        return right32222;
      }
    }
    return null;
  },
  MemberExpression(node, initialScope) {
    if (node.property.type === "PrivateIdentifier") {
      return null;
    }
    const object222 = getStaticValueR2222(node.object, initialScope);
    if (object222 != null) {
      if (object222.value == null && (object222.optional || node.optional)) {
        return { value: void 0, optional: true };
      }
      const property = getStaticPropertyNameValue2222(node, initialScope);
      if (property != null) {
        if (!isGetter2222(object222.value, property.value)) {
          return { value: object222.value[property.value] };
        }
        for (const [classFn, allowed] of getterAllowed2222) {
          if (object222.value instanceof classFn && allowed.has(property.value)) {
            return { value: object222.value[property.value] };
          }
        }
      }
    }
    return null;
  },
  ChainExpression(node, initialScope) {
    const expression = getStaticValueR2222(node.expression, initialScope);
    if (expression != null) {
      return { value: expression.value };
    }
    return null;
  },
  NewExpression(node, initialScope) {
    const callee = getStaticValueR2222(node.callee, initialScope);
    const args = getElementValues2222(node.arguments, initialScope);
    if (callee != null && args != null) {
      const Func = callee.value;
      if (callAllowed2222.has(Func)) {
        return { value: new Func(...args) };
      }
    }
    return null;
  },
  ObjectExpression(node, initialScope) {
    const object222 = {};
    for (const propertyNode of node.properties) {
      if (propertyNode.type === "Property") {
        if (propertyNode.kind !== "init") {
          return null;
        }
        const key = getStaticPropertyNameValue2222(
          propertyNode,
          initialScope
        );
        const value = getStaticValueR2222(propertyNode.value, initialScope);
        if (key == null || value == null) {
          return null;
        }
        object222[key.value] = value.value;
      } else if (propertyNode.type === "SpreadElement" || propertyNode.type === "ExperimentalSpreadProperty") {
        const argument = getStaticValueR2222(
          propertyNode.argument,
          initialScope
        );
        if (argument == null) {
          return null;
        }
        Object.assign(object222, argument.value);
      } else {
        return null;
      }
    }
    return { value: object222 };
  },
  SequenceExpression(node, initialScope) {
    const last222 = node.expressions[node.expressions.length - 1];
    return getStaticValueR2222(last222, initialScope);
  },
  TaggedTemplateExpression(node, initialScope) {
    const tag = getStaticValueR2222(node.tag, initialScope);
    const expressions = getElementValues2222(
      node.quasi.expressions,
      initialScope
    );
    if (tag != null && expressions != null) {
      const func = tag.value;
      const strings = node.quasi.quasis.map((q) => q.value.cooked);
      strings.raw = node.quasi.quasis.map((q) => q.value.raw);
      if (func === String.raw) {
        return { value: func(strings, ...expressions) };
      }
    }
    return null;
  },
  TemplateLiteral(node, initialScope) {
    const expressions = getElementValues2222(node.expressions, initialScope);
    if (expressions != null) {
      let value = node.quasis[0].value.cooked;
      for (let i2222 = 0; i2222 < expressions.length; ++i2222) {
        value += expressions[i2222];
        value += node.quasis[i2222 + 1].value.cooked;
      }
      return { value };
    }
    return null;
  },
  UnaryExpression(node, initialScope) {
    if (node.operator === "delete") {
      return null;
    }
    if (node.operator === "void") {
      return { value: void 0 };
    }
    const arg = getStaticValueR2222(node.argument, initialScope);
    if (arg != null) {
      switch (node.operator) {
        case "-":
          return { value: -arg.value };
        case "+":
          return { value: +arg.value };
        case "!":
          return { value: !arg.value };
        case "~":
          return { value: ~arg.value };
        case "typeof":
          return { value: typeof arg.value };
      }
    }
    return null;
  }
});
function getStaticValueR2222(node, initialScope) {
  if (node != null && Object.hasOwnProperty.call(operations2222, node.type)) {
    return operations2222[node.type](node, initialScope);
  }
  return null;
}
function getStaticPropertyNameValue2222(node, initialScope) {
  const nameNode = node.type === "Property" ? node.key : node.property;
  if (node.computed) {
    return getStaticValueR2222(nameNode, initialScope);
  }
  if (nameNode.type === "Identifier") {
    return { value: nameNode.name };
  }
  if (nameNode.type === "Literal") {
    if (nameNode.bigint) {
      return { value: nameNode.bigint };
    }
    return { value: String(nameNode.value) };
  }
  return null;
}
function getStaticValue2222(node, initialScope = null) {
  try {
    return getStaticValueR2222(node, initialScope);
  } catch (_error) {
    return null;
  }
}
function getStringIfConstant2222(node, initialScope = null) {
  if (node && node.type === "Literal" && node.value === null) {
    if (node.regex) {
      return `/${node.regex.pattern}/${node.regex.flags}`;
    }
    if (node.bigint) {
      return node.bigint;
    }
  }
  const evaluated = getStaticValue2222(node, initialScope);
  return evaluated && String(evaluated.value);
}
function getPropertyName2222(node, initialScope) {
  switch (node.type) {
    case "MemberExpression":
      if (node.computed) {
        return getStringIfConstant2222(node.property, initialScope);
      }
      if (node.property.type === "PrivateIdentifier") {
        return null;
      }
      return node.property.name;
    case "Property":
    case "MethodDefinition":
    case "PropertyDefinition":
      if (node.computed) {
        return getStringIfConstant2222(node.key, initialScope);
      }
      if (node.key.type === "Literal") {
        return String(node.key.value);
      }
      if (node.key.type === "PrivateIdentifier") {
        return null;
      }
      return node.key.name;
  }
  return null;
}
function getFunctionNameWithKind2222(node, sourceCode) {
  const parent = node.parent;
  const tokens = [];
  const isObjectMethod = parent.type === "Property" && parent.value === node;
  const isClassMethod = parent.type === "MethodDefinition" && parent.value === node;
  const isClassFieldMethod = parent.type === "PropertyDefinition" && parent.value === node;
  if (isClassMethod || isClassFieldMethod) {
    if (parent.static) {
      tokens.push("static");
    }
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push("private");
    }
  }
  if (node.async) {
    tokens.push("async");
  }
  if (node.generator) {
    tokens.push("generator");
  }
  if (isObjectMethod || isClassMethod) {
    if (parent.kind === "constructor") {
      return "constructor";
    }
    if (parent.kind === "get") {
      tokens.push("getter");
    } else if (parent.kind === "set") {
      tokens.push("setter");
    } else {
      tokens.push("method");
    }
  } else if (isClassFieldMethod) {
    tokens.push("method");
  } else {
    if (node.type === "ArrowFunctionExpression") {
      tokens.push("arrow");
    }
    tokens.push("function");
  }
  if (isObjectMethod || isClassMethod || isClassFieldMethod) {
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push(`#${parent.key.name}`);
    } else {
      const name22 = getPropertyName2222(parent);
      if (name22) {
        tokens.push(`'${name22}'`);
      } else if (sourceCode) {
        const keyText = sourceCode.getText(parent.key);
        if (!keyText.includes("\n")) {
          tokens.push(`[${keyText}]`);
        }
      }
    }
  } else if (node.id) {
    tokens.push(`'${node.id.name}'`);
  } else if (parent.type === "VariableDeclarator" && parent.id && parent.id.type === "Identifier") {
    tokens.push(`'${parent.id.name}'`);
  } else if ((parent.type === "AssignmentExpression" || parent.type === "AssignmentPattern") && parent.left && parent.left.type === "Identifier") {
    tokens.push(`'${parent.left.name}'`);
  } else if (parent.type === "ExportDefaultDeclaration" && parent.declaration === node) {
    tokens.push("'default'");
  }
  return tokens.join(" ");
}
var typeConversionBinaryOps2222 = Object.freeze(
  /* @__PURE__ */ new Set([
    "==",
    "!=",
    "<",
    "<=",
    ">",
    ">=",
    "<<",
    ">>",
    ">>>",
    "+",
    "-",
    "*",
    "/",
    "%",
    "|",
    "^",
    "&",
    "in"
  ])
);
var typeConversionUnaryOps2222 = Object.freeze(/* @__PURE__ */ new Set(["-", "+", "!", "~"]));
function isNode2222(x2222) {
  return x2222 !== null && typeof x2222 === "object" && typeof x2222.type === "string";
}
var visitor2222 = Object.freeze(
  Object.assign(/* @__PURE__ */ Object.create(null), {
    $visit(node, options, visitorKeys) {
      const { type } = node;
      if (typeof this[type] === "function") {
        return this[type](node, options, visitorKeys);
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    $visitChildren(node, options, visitorKeys) {
      const { type } = node;
      for (const key of visitorKeys[type] || getKeys2222(node)) {
        const value = node[key];
        if (Array.isArray(value)) {
          for (const element of value) {
            if (isNode2222(element) && this.$visit(element, options, visitorKeys)) {
              return true;
            }
          }
        } else if (isNode2222(value) && this.$visit(value, options, visitorKeys)) {
          return true;
        }
      }
      return false;
    },
    ArrowFunctionExpression() {
      return false;
    },
    AssignmentExpression() {
      return true;
    },
    AwaitExpression() {
      return true;
    },
    BinaryExpression(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && typeConversionBinaryOps2222.has(node.operator) && (node.left.type !== "Literal" || node.right.type !== "Literal")) {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    CallExpression() {
      return true;
    },
    FunctionExpression() {
      return false;
    },
    ImportExpression() {
      return true;
    },
    MemberExpression(node, options, visitorKeys) {
      if (options.considerGetters) {
        return true;
      }
      if (options.considerImplicitTypeConversion && node.computed && node.property.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    MethodDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    NewExpression() {
      return true;
    },
    Property(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    PropertyDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UnaryExpression(node, options, visitorKeys) {
      if (node.operator === "delete") {
        return true;
      }
      if (options.considerImplicitTypeConversion && typeConversionUnaryOps2222.has(node.operator) && node.argument.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UpdateExpression() {
      return true;
    },
    YieldExpression() {
      return true;
    }
  })
);
function hasSideEffect2222(node, sourceCode, { considerGetters = false, considerImplicitTypeConversion = false } = {}) {
  return visitor2222.$visit(
    node,
    { considerGetters, considerImplicitTypeConversion },
    sourceCode.visitorKeys || visitor_keys_default2222
  );
}
function getParentSyntaxParen2222(node, sourceCode) {
  const parent = node.parent;
  switch (parent.type) {
    case "CallExpression":
    case "NewExpression":
      if (parent.arguments.length === 1 && parent.arguments[0] === node) {
        return sourceCode.getTokenAfter(
          parent.callee,
          isOpeningParenToken2222
        );
      }
      return null;
    case "DoWhileStatement":
      if (parent.test === node) {
        return sourceCode.getTokenAfter(
          parent.body,
          isOpeningParenToken2222
        );
      }
      return null;
    case "IfStatement":
    case "WhileStatement":
      if (parent.test === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "ImportExpression":
      if (parent.source === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "SwitchStatement":
      if (parent.discriminant === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "WithStatement":
      if (parent.object === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    default:
      return null;
  }
}
function isParenthesized2222(timesOrNode, nodeOrSourceCode, optionalSourceCode) {
  let times, node, sourceCode, maybeLeftParen, maybeRightParen;
  if (typeof timesOrNode === "number") {
    times = timesOrNode | 0;
    node = nodeOrSourceCode;
    sourceCode = optionalSourceCode;
    if (!(times >= 1)) {
      throw new TypeError("'times' should be a positive integer.");
    }
  } else {
    times = 1;
    node = timesOrNode;
    sourceCode = nodeOrSourceCode;
  }
  if (node == null || // `Program` can't be parenthesized
  node.parent == null || // `CatchClause.param` can't be parenthesized, example `try {} catch (error) {}`
  node.parent.type === "CatchClause" && node.parent.param === node) {
    return false;
  }
  maybeLeftParen = maybeRightParen = node;
  do {
    maybeLeftParen = sourceCode.getTokenBefore(maybeLeftParen);
    maybeRightParen = sourceCode.getTokenAfter(maybeRightParen);
  } while (maybeLeftParen != null && maybeRightParen != null && isOpeningParenToken2222(maybeLeftParen) && isClosingParenToken2222(maybeRightParen) && // Avoid false positive such as `if (a) {}`
  maybeLeftParen !== getParentSyntaxParen2222(node, sourceCode) && --times > 0);
  return times === 0;
}
Function.call.bind(Object.hasOwnProperty);
var __defProp22223 = Object.defineProperty;
var __export22223 = (target, all32222) => {
  for (var name22 in all32222)
    __defProp22223(target, name22, { get: all32222[name22], enumerable: true });
};
var NodeType2222 = types.AST_NODE_TYPES;
var is2222 = utils.ASTUtils.isNodeOfType;
var isOneOf2222 = utils.ASTUtils.isNodeOfTypes;
isOneOf2222([
  NodeType2222.ArrowFunctionExpression,
  NodeType2222.FunctionDeclaration,
  NodeType2222.FunctionExpression
]);
isOneOf2222([
  NodeType2222.ArrowFunctionExpression,
  NodeType2222.FunctionDeclaration,
  NodeType2222.FunctionExpression,
  NodeType2222.TSCallSignatureDeclaration,
  NodeType2222.TSConstructSignatureDeclaration,
  NodeType2222.TSDeclareFunction,
  NodeType2222.TSEmptyBodyFunctionExpression,
  NodeType2222.TSFunctionType,
  NodeType2222.TSMethodSignature
]);
isOneOf2222([NodeType2222.ClassDeclaration, NodeType2222.ClassExpression]);
isOneOf2222([
  NodeType2222.DoWhileStatement,
  NodeType2222.ForInStatement,
  NodeType2222.ForOfStatement,
  NodeType2222.ForStatement,
  NodeType2222.WhileStatement
]);
isOneOf2222([NodeType2222.TSArrayType, NodeType2222.TSTupleType]);
isOneOf2222([
  NodeType2222.PropertyDefinition,
  NodeType2222.TSIndexSignature,
  NodeType2222.TSParameterProperty,
  NodeType2222.TSPropertySignature
]);
is2222(NodeType2222.JSXElement);
is2222(NodeType2222.JSXFragment);
isOneOf2222([
  NodeType2222.JSXAttribute,
  NodeType2222.JSXSpreadChild,
  NodeType2222.JSXClosingElement,
  NodeType2222.JSXClosingFragment,
  NodeType2222.JSXElement,
  NodeType2222.JSXEmptyExpression,
  NodeType2222.JSXExpressionContainer,
  NodeType2222.JSXFragment,
  NodeType2222.JSXIdentifier,
  NodeType2222.JSXMemberExpression,
  NodeType2222.JSXNamespacedName,
  NodeType2222.JSXOpeningElement,
  NodeType2222.JSXOpeningFragment,
  NodeType2222.JSXSpreadAttribute,
  NodeType2222.JSXSpreadChild,
  NodeType2222.JSXText
]);
isOneOf2222([
  NodeType2222.JSXIdentifier,
  NodeType2222.JSXMemberExpression,
  NodeType2222.JSXNamespacedName
]);
isOneOf2222([
  NodeType2222.ArrayPattern,
  NodeType2222.AssignmentPattern,
  NodeType2222.ObjectPattern,
  NodeType2222.RestElement
]);
isOneOf2222([
  NodeType2222.TSInterfaceDeclaration,
  NodeType2222.TSTypeAliasDeclaration
]);
isOneOf2222([
  NodeType2222.ArrayExpression,
  NodeType2222.ArrayPattern,
  NodeType2222.ArrowFunctionExpression,
  NodeType2222.CallExpression,
  NodeType2222.ClassExpression,
  NodeType2222.FunctionExpression,
  NodeType2222.Identifier,
  NodeType2222.JSXElement,
  NodeType2222.JSXFragment,
  NodeType2222.Literal,
  NodeType2222.TemplateLiteral,
  NodeType2222.MemberExpression,
  NodeType2222.MetaProperty,
  NodeType2222.ObjectExpression,
  NodeType2222.ObjectPattern,
  NodeType2222.SequenceExpression,
  NodeType2222.Super,
  NodeType2222.TaggedTemplateExpression,
  NodeType2222.ThisExpression
]);
isOneOf2222([
  NodeType2222.ArrayExpression,
  NodeType2222.ArrayPattern,
  NodeType2222.ArrowFunctionExpression,
  NodeType2222.CallExpression,
  NodeType2222.ClassExpression,
  NodeType2222.FunctionExpression,
  NodeType2222.Identifier,
  NodeType2222.JSXElement,
  NodeType2222.JSXFragment,
  NodeType2222.Literal,
  NodeType2222.TemplateLiteral,
  NodeType2222.MemberExpression,
  NodeType2222.MetaProperty,
  NodeType2222.ObjectExpression,
  NodeType2222.ObjectPattern,
  NodeType2222.SequenceExpression,
  NodeType2222.Super,
  NodeType2222.TaggedTemplateExpression,
  NodeType2222.ThisExpression,
  NodeType2222.TSAsExpression,
  NodeType2222.TSNonNullExpression,
  NodeType2222.TSTypeAssertion
]);
var Function_exports22222 = {};
__export22223(Function_exports22222, {
  SK: () => SK22222,
  absurd: () => absurd22222,
  apply: () => apply22222,
  compose: () => compose22223,
  constFalse: () => constFalse22222,
  constNull: () => constNull22222,
  constTrue: () => constTrue22222,
  constUndefined: () => constUndefined22222,
  constVoid: () => constVoid22222,
  constant: () => constant22222,
  dual: () => dual22222,
  flip: () => flip22222,
  flow: () => flow22222,
  hole: () => hole22222,
  identity: () => identity22222,
  isFunction: () => isFunction222222,
  pipe: () => pipe22222,
  satisfies: () => satisfies22222,
  tupled: () => tupled22222,
  unsafeCoerce: () => unsafeCoerce22222,
  untupled: () => untupled22222
});
var isFunction222222 = (input) => typeof input === "function";
var dual22222 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a2222, b2222) {
        if (arguments.length >= 2) {
          return body(a2222, b2222);
        }
        return function(self2) {
          return body(self2, a2222);
        };
      };
    case 3:
      return function(a2222, b2222, c2222) {
        if (arguments.length >= 3) {
          return body(a2222, b2222, c2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222);
        };
      };
    case 4:
      return function(a2222, b2222, c2222, d2222) {
        if (arguments.length >= 4) {
          return body(a2222, b2222, c2222, d2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222);
        };
      };
    case 5:
      return function(a2222, b2222, c2222, d2222, e2222) {
        if (arguments.length >= 5) {
          return body(a2222, b2222, c2222, d2222, e2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222, d2222);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply22222 = (a2222) => (self2) => self2(a2222);
var identity22222 = (a2222) => a2222;
var satisfies22222 = () => (b2222) => b2222;
var unsafeCoerce22222 = identity22222;
var constant22222 = (value) => () => value;
var constTrue22222 = /* @__PURE__ */ constant22222(true);
var constFalse22222 = /* @__PURE__ */ constant22222(false);
var constNull22222 = /* @__PURE__ */ constant22222(null);
var constUndefined22222 = /* @__PURE__ */ constant22222(void 0);
var constVoid22222 = constUndefined22222;
var flip22222 = (f2222) => (...b2222) => (...a2222) => f2222(...a2222)(...b2222);
var compose22223 = /* @__PURE__ */ dual22222(2, (ab, bc) => (a2222) => bc(ab(a2222)));
var absurd22222 = (_2222) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled22222 = (f2222) => (a2222) => f2222(...a2222);
var untupled22222 = (f2222) => (...a2222) => f2222(a2222);
function pipe22222(a2222, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a2222;
    case 2:
      return ab(a2222);
    case 3:
      return bc(ab(a2222));
    case 4:
      return cd(bc(ab(a2222)));
    case 5:
      return de(cd(bc(ab(a2222))));
    case 6:
      return ef(de(cd(bc(ab(a2222)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a2222))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a2222)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a2222))))))));
    default: {
      let ret = arguments[0];
      for (let i2222 = 1; i2222 < arguments.length; i2222++) {
        ret = arguments[i2222](ret);
      }
      return ret;
    }
  }
}
function flow22222(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole22222 = /* @__PURE__ */ unsafeCoerce22222(absurd22222);
var SK22222 = (_2222, b2222) => b2222;
var make42223 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_32222 = (map622) => dual22222(3, (self2, name22, f2222) => map622(self2, (a2222) => Object.assign({}, a2222, {
  [name22]: f2222(a2222)
})));
var bindTo32222 = (map622) => dual22222(2, (self2, name22) => map622(self2, (a2222) => ({
  [name22]: a2222
})));
var bind32222 = (map622, flatMap4222) => dual22222(3, (self2, name22, f2222) => flatMap4222(self2, (a2222) => map622(f2222(a2222), (b2222) => Object.assign({}, a2222, {
  [name22]: b2222
}))));
var moduleVersion22222 = "3.2.8";
var getCurrentVersion22222 = () => moduleVersion22222;
var globalStoreId22222 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion22222()}`);
if (!(globalStoreId22222 in globalThis)) {
  globalThis[globalStoreId22222] = /* @__PURE__ */ new Map();
}
var globalStore22222 = globalThis[globalStoreId22222];
var globalValue22222 = (id, compute) => {
  if (!globalStore22222.has(id)) {
    globalStore22222.set(id, compute());
  }
  return globalStore22222.get(id);
};
var Predicate_exports22222 = {};
__export22223(Predicate_exports22222, {
  all: () => all22223,
  and: () => and33,
  compose: () => compose222222,
  eqv: () => eqv33,
  every: () => every43,
  hasProperty: () => hasProperty22222,
  implies: () => implies33,
  isBigInt: () => isBigInt33,
  isBoolean: () => isBoolean33,
  isDate: () => isDate33,
  isError: () => isError33,
  isFunction: () => isFunction32222,
  isIterable: () => isIterable33,
  isMap: () => isMap33,
  isNever: () => isNever33,
  isNotNull: () => isNotNull33,
  isNotNullable: () => isNotNullable33,
  isNotUndefined: () => isNotUndefined33,
  isNull: () => isNull33,
  isNullable: () => isNullable22222,
  isNumber: () => isNumber33,
  isObject: () => isObject22222,
  isPromise: () => isPromise33,
  isPromiseLike: () => isPromiseLike33,
  isReadonlyRecord: () => isReadonlyRecord33,
  isRecord: () => isRecord33,
  isSet: () => isSet33,
  isString: () => isString33,
  isSymbol: () => isSymbol33,
  isTagged: () => isTagged33,
  isTruthy: () => isTruthy33,
  isUint8Array: () => isUint8Array33,
  isUndefined: () => isUndefined33,
  isUnknown: () => isUnknown33,
  mapInput: () => mapInput43,
  nand: () => nand33,
  nor: () => nor33,
  not: () => not33,
  or: () => or33,
  product: () => product22223,
  productMany: () => productMany22223,
  some: () => some32223,
  struct: () => struct53,
  tuple: () => tuple43,
  xor: () => xor33
});
var mapInput43 = /* @__PURE__ */ dual22222(2, (self2, f2222) => (b2222) => self2(f2222(b2222)));
var isTruthy33 = (input) => !!input;
var isSet33 = (input) => input instanceof Set;
var isMap33 = (input) => input instanceof Map;
var isString33 = (input) => typeof input === "string";
var isNumber33 = (input) => typeof input === "number";
var isBoolean33 = (input) => typeof input === "boolean";
var isBigInt33 = (input) => typeof input === "bigint";
var isSymbol33 = (input) => typeof input === "symbol";
var isFunction32222 = isFunction222222;
var isUndefined33 = (input) => input === void 0;
var isNotUndefined33 = (input) => input !== void 0;
var isNull33 = (input) => input === null;
var isNotNull33 = (input) => input !== null;
var isNever33 = (_2222) => false;
var isUnknown33 = (_2222) => true;
var isRecordOrArray22222 = (input) => typeof input === "object" && input !== null;
var isObject22222 = (input) => isRecordOrArray22222(input) || isFunction32222(input);
var hasProperty22222 = /* @__PURE__ */ dual22222(2, (self2, property) => isObject22222(self2) && property in self2);
var isTagged33 = /* @__PURE__ */ dual22222(2, (self2, tag) => hasProperty22222(self2, "_tag") && self2["_tag"] === tag);
var isNullable22222 = (input) => input === null || input === void 0;
var isNotNullable33 = (input) => input !== null && input !== void 0;
var isError33 = (input) => input instanceof Error;
var isUint8Array33 = (input) => input instanceof Uint8Array;
var isDate33 = (input) => input instanceof Date;
var isIterable33 = (input) => hasProperty22222(input, Symbol.iterator);
var isRecord33 = (input) => isRecordOrArray22222(input) && !Array.isArray(input);
var isReadonlyRecord33 = isRecord33;
var isPromise33 = (input) => hasProperty22222(input, "then") && "catch" in input && isFunction32222(input.then) && isFunction32222(input.catch);
var isPromiseLike33 = (input) => hasProperty22222(input, "then") && isFunction32222(input.then);
var compose222222 = /* @__PURE__ */ dual22222(2, (ab, bc) => (a2222) => ab(a2222) && bc(a2222));
var product22223 = (self2, that) => ([a2222, b2222]) => self2(a2222) && that(b2222);
var all22223 = (collection) => {
  return (as222222) => {
    let collectionIndex = 0;
    for (const p2222 of collection) {
      if (collectionIndex >= as222222.length) {
        break;
      }
      if (p2222(as222222[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany22223 = (self2, collection) => {
  const rest = all22223(collection);
  return ([head222, ...tail222]) => self2(head222) === false ? false : rest(tail222);
};
var tuple43 = (...elements) => all22223(elements);
var struct53 = (fields) => {
  const keys22222 = Object.keys(fields);
  return (a2222) => {
    for (const key of keys22222) {
      if (!fields[key](a2222[key])) {
        return false;
      }
    }
    return true;
  };
};
var not33 = (self2) => (a2222) => !self2(a2222);
var or33 = /* @__PURE__ */ dual22222(2, (self2, that) => (a2222) => self2(a2222) || that(a2222));
var and33 = /* @__PURE__ */ dual22222(2, (self2, that) => (a2222) => self2(a2222) && that(a2222));
var xor33 = /* @__PURE__ */ dual22222(2, (self2, that) => (a2222) => self2(a2222) !== that(a2222));
var eqv33 = /* @__PURE__ */ dual22222(2, (self2, that) => (a2222) => self2(a2222) === that(a2222));
var implies33 = /* @__PURE__ */ dual22222(2, (self2, that) => (a2222) => self2(a2222) ? that(a2222) : true);
var nor33 = /* @__PURE__ */ dual22222(2, (self2, that) => (a2222) => !(self2(a2222) || that(a2222)));
var nand33 = /* @__PURE__ */ dual22222(2, (self2, that) => (a2222) => !(self2(a2222) && that(a2222)));
var every43 = (collection) => (a2222) => {
  for (const p2222 of collection) {
    if (!p2222(a2222)) {
      return false;
    }
  }
  return true;
};
var some32223 = (collection) => (a2222) => {
  for (const p2222 of collection) {
    if (p2222(a2222)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage22222 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId22222 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind22222 = (u2222) => isObject22222(u2222) && GenKindTypeId22222 in u2222;
var GenKindImpl22222 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity22222;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId22222] = GenKindTypeId22222;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen22223(this);
  }
};
var SingleShotGen22223 = class _SingleShotGen43 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a2222) {
    return this.called ? {
      value: a2222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a2222) {
    return {
      value: a2222,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e2222) {
    throw e2222;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen43(this.self);
  }
};
var adapter32222 = () => function() {
  let x2222 = arguments[0];
  for (let i2222 = 1; i2222 < arguments.length; i2222++) {
    x2222 = arguments[i2222](x2222);
  }
  return new GenKindImpl22222(x2222);
};
var defaultIncHi22222 = 335903614;
var defaultIncLo22222 = 4150755663;
var MUL_HI22222 = 1481765933 >>> 0;
var MUL_LO22222 = 1284865837 >>> 0;
var BIT_5322222 = 9007199254740992;
var BIT_2722222 = 134217728;
var PCGRandom22222 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable22222(seedLo) && isNullable22222(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable22222(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable22222(incLo) && isNullable22222(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo22222;
      incHi = this._state ? this._state[2] : defaultIncHi22222;
    } else if (isNullable22222(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add6422222(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max322) {
    if (!max322) {
      return this._next();
    }
    max322 = max322 >>> 0;
    if ((max322 & max322 - 1) === 0) {
      return this._next() & max322 - 1;
    }
    let num = 0;
    const skew = (-max322 >>> 0) % max322 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max322;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_2722222 + lo) / BIT_5322222;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul6422222(this._state, oldHi, oldLo, MUL_HI22222, MUL_LO22222);
    add6422222(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul6422222(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add6422222(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId22222 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap22222 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId22222]() {
    return this.#value;
  }
};
function yieldWrapGet22222(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId22222 in self2) {
    return self2[YieldWrapTypeId22222]();
  }
  throw new Error(getBugErrorMessage22222("yieldWrapGet"));
}
var structuralRegionState22222 = /* @__PURE__ */ globalValue22222("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache22222 = /* @__PURE__ */ globalValue22222(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr22222 = /* @__PURE__ */ globalValue22222(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom22222());
var symbol32222 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash22222 = (self2) => {
  if (structuralRegionState22222.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number22222(self2);
    case "bigint":
      return string22222(self2.toString(10));
    case "boolean":
      return string22222(String(self2));
    case "symbol":
      return string22222(String(self2));
    case "string":
      return string22222(self2);
    case "undefined":
      return string22222("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string22222("null");
      } else if (self2 instanceof Date) {
        return hash22222(self2.toISOString());
      } else if (isHash22222(self2)) {
        return self2[symbol32222]();
      } else {
        return random22222(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random22222 = (self2) => {
  if (!randomHashCache22222.has(self2)) {
    randomHashCache22222.set(self2, number22222(pcgr22222.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache22222.get(self2);
};
var combine22223 = (b2222) => (self2) => self2 * 53 ^ b2222;
var optimize22222 = (n2222) => n2222 & 3221225471 | n2222 >>> 1 & 1073741824;
var isHash22222 = (u2222) => hasProperty22222(u2222, symbol32222);
var number22222 = (n2222) => {
  if (n2222 !== n2222 || n2222 === Infinity) {
    return 0;
  }
  let h2222 = n2222 | 0;
  if (h2222 !== n2222) {
    h2222 ^= n2222 * 4294967295;
  }
  while (n2222 > 4294967295) {
    h2222 ^= n2222 /= 4294967295;
  }
  return optimize22222(n2222);
};
var string22222 = (str) => {
  let h2222 = 5381, i2222 = str.length;
  while (i2222) {
    h2222 = h2222 * 33 ^ str.charCodeAt(--i2222);
  }
  return optimize22222(h2222);
};
var structureKeys2222 = (o2222, keys22222) => {
  let h2222 = 12289;
  for (let i2222 = 0; i2222 < keys22222.length; i2222++) {
    h2222 ^= pipe22222(string22222(keys22222[i2222]), combine22223(hash22222(o2222[keys22222[i2222]])));
  }
  return optimize22222(h2222);
};
var structure2222 = (o2222) => structureKeys2222(o2222, Object.keys(o2222));
var array53 = (arr) => {
  let h2222 = 6151;
  for (let i2222 = 0; i2222 < arr.length; i2222++) {
    h2222 = pipe22222(h2222, combine22223(hash22222(arr[i2222])));
  }
  return optimize22222(h2222);
};
var cached22222 = function() {
  if (arguments.length === 1) {
    const self22 = arguments[0];
    return function(hash3222) {
      Object.defineProperty(self22, symbol32222, {
        value() {
          return hash3222;
        },
        enumerable: false
      });
      return hash3222;
    };
  }
  const self2 = arguments[0];
  const hash222222 = arguments[1];
  Object.defineProperty(self2, symbol32222, {
    value() {
      return hash222222;
    },
    enumerable: false
  });
  return hash222222;
};
var symbol222222 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals22222() {
  if (arguments.length === 1) {
    return (self2) => compareBoth22222(self2, arguments[0]);
  }
  return compareBoth22222(arguments[0], arguments[1]);
}
function compareBoth22222(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual22222(self2) && isEqual22222(that)) {
        if (hash22222(self2) === hash22222(that) && self2[symbol222222](that)) {
          return true;
        } else {
          return structuralRegionState22222.enabled && structuralRegionState22222.tester ? structuralRegionState22222.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState22222.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v2222, i2222) => compareBoth22222(v2222, that[i2222]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth22222(self2[key], that[key]))) {
              return structuralRegionState22222.tester ? structuralRegionState22222.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState22222.tester ? structuralRegionState22222.tester(self2, that) : false;
    }
  }
  return structuralRegionState22222.enabled && structuralRegionState22222.tester ? structuralRegionState22222.tester(self2, that) : false;
}
var isEqual22222 = (u2222) => hasProperty22222(u2222, symbol222222);
var equivalence22222 = () => equals22222;
var NodeInspectSymbol22222 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON22222 = (x2222) => {
  if (hasProperty22222(x2222, "toJSON") && isFunction32222(x2222["toJSON"]) && x2222["toJSON"].length === 0) {
    return x2222.toJSON();
  } else if (Array.isArray(x2222)) {
    return x2222.map(toJSON22222);
  }
  return x2222;
};
var format22222 = (x2222) => JSON.stringify(x2222, null, 2);
var pipeArguments22222 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i2222 = 0, len = args.length; i2222 < len; i2222++) {
        ret = args[i2222](ret);
      }
      return ret;
    }
  }
};
var OP_COMMIT2222 = "Commit";
var OP_FAILURE2222 = "Failure";
var OP_WITH_RUNTIME2222 = "WithRuntime";
var EffectTypeId22223 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId22222 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId22222 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId22222 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance22222 = {
  /* c8 ignore next */
  _R: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _A: (_2222) => _2222,
  _V: /* @__PURE__ */ getCurrentVersion22222()
};
var sinkVariance22222 = {
  /* c8 ignore next */
  _A: (_2222) => _2222,
  /* c8 ignore next */
  _In: (_2222) => _2222,
  /* c8 ignore next */
  _L: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _R: (_2222) => _2222
};
var channelVariance22222 = {
  /* c8 ignore next */
  _Env: (_2222) => _2222,
  /* c8 ignore next */
  _InErr: (_2222) => _2222,
  /* c8 ignore next */
  _InElem: (_2222) => _2222,
  /* c8 ignore next */
  _InDone: (_2222) => _2222,
  /* c8 ignore next */
  _OutErr: (_2222) => _2222,
  /* c8 ignore next */
  _OutElem: (_2222) => _2222,
  /* c8 ignore next */
  _OutDone: (_2222) => _2222
};
var EffectPrototype22222 = {
  [EffectTypeId22223]: effectVariance22222,
  [StreamTypeId22222]: effectVariance22222,
  [SinkTypeId22222]: sinkVariance22222,
  [ChannelTypeId22222]: channelVariance22222,
  [symbol222222](that) {
    return this === that;
  },
  [symbol32222]() {
    return cached22222(this, random22222(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen22223(new YieldWrap22222(this));
  },
  pipe() {
    return pipeArguments22222(this, arguments);
  }
};
var StructuralPrototype2222 = {
  [symbol32222]() {
    return cached22222(this, structure2222(this));
  },
  [symbol222222](that) {
    const selfKeys = Object.keys(this);
    const thatKeys = Object.keys(that);
    if (selfKeys.length !== thatKeys.length) {
      return false;
    }
    for (const key of selfKeys) {
      if (!(key in that && equals22222(this[key], that[key]))) {
        return false;
      }
    }
    return true;
  }
};
var CommitPrototype2222 = {
  ...EffectPrototype22222,
  _op: OP_COMMIT2222
};
var StructuralCommitPrototype2222 = {
  ...CommitPrototype2222,
  ...StructuralPrototype2222
};
var TypeId52223 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto32222 = {
  ...EffectPrototype22222,
  [TypeId52223]: {
    _A: (_2222) => _2222
  },
  [NodeInspectSymbol22222]() {
    return this.toJSON();
  },
  toString() {
    return format22222(this.toJSON());
  }
};
var SomeProto22222 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto32222), {
  _tag: "Some",
  _op: "Some",
  [symbol222222](that) {
    return isOption32222(that) && isSome32222(that) && equals22222(this.value, that.value);
  },
  [symbol32222]() {
    return cached22222(this, combine22223(hash22222(this._tag))(hash22222(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON22222(this.value)
    };
  }
});
var NoneHash22222 = /* @__PURE__ */ hash22222("None");
var NoneProto22222 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto32222), {
  _tag: "None",
  _op: "None",
  [symbol222222](that) {
    return isOption32222(that) && isNone32222(that);
  },
  [symbol32222]() {
    return NoneHash22222;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption32222 = (input) => hasProperty22222(input, TypeId52223);
var isNone32222 = (fa) => fa._tag === "None";
var isSome32222 = (fa) => fa._tag === "Some";
var none32222 = /* @__PURE__ */ Object.create(NoneProto22222);
var some222222 = (value) => {
  const a2222 = Object.create(SomeProto22222);
  a2222.value = value;
  return a2222;
};
var TypeId222222 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto222222 = {
  ...EffectPrototype22222,
  [TypeId222222]: {
    _R: (_2222) => _2222
  },
  [NodeInspectSymbol22222]() {
    return this.toJSON();
  },
  toString() {
    return format22222(this.toJSON());
  }
};
var RightProto22222 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto222222), {
  _tag: "Right",
  _op: "Right",
  [symbol222222](that) {
    return isEither22222(that) && isRight22222(that) && equals22222(this.right, that.right);
  },
  [symbol32222]() {
    return combine22223(hash22222(this._tag))(hash22222(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON22222(this.right)
    };
  }
});
var LeftProto22222 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto222222), {
  _tag: "Left",
  _op: "Left",
  [symbol222222](that) {
    return isEither22222(that) && isLeft22222(that) && equals22222(this.left, that.left);
  },
  [symbol32222]() {
    return combine22223(hash22222(this._tag))(hash22222(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON22222(this.left)
    };
  }
});
var isEither22222 = (input) => hasProperty22222(input, TypeId222222);
var isLeft22222 = (ma) => ma._tag === "Left";
var isRight22222 = (ma) => ma._tag === "Right";
var left22223 = (left32222) => {
  const a2222 = Object.create(LeftProto22222);
  a2222.left = left32222;
  return a2222;
};
var right22223 = (right32222) => {
  const a2222 = Object.create(RightProto22222);
  a2222.right = right32222;
  return a2222;
};
var getLeft32222 = (self2) => isRight22222(self2) ? none32222 : some222222(self2.left);
var getRight32222 = (self2) => isLeft22222(self2) ? none32222 : some222222(self2.right);
var right222222 = right22223;
var left222222 = left22223;
var Option_exports22222 = {};
__export22223(Option_exports22222, {
  Do: () => Do22222,
  TypeId: () => TypeId322222,
  all: () => all222222,
  andThen: () => andThen22222,
  ap: () => ap22222,
  as: () => as22222,
  asVoid: () => asVoid22222,
  bind: () => bind222222,
  bindTo: () => bindTo222222,
  composeK: () => composeK22222,
  contains: () => contains22222,
  containsWith: () => containsWith22222,
  exists: () => exists22222,
  filter: () => filter22222,
  filterMap: () => filterMap22222,
  firstSomeOf: () => firstSomeOf22222,
  flatMap: () => flatMap22222,
  flatMapNullable: () => flatMapNullable22222,
  flatten: () => flatten22222,
  fromIterable: () => fromIterable22223,
  fromNullable: () => fromNullable22222,
  gen: () => gen22222,
  getEquivalence: () => getEquivalence22223,
  getLeft: () => getLeft222222,
  getOrElse: () => getOrElse22222,
  getOrNull: () => getOrNull22222,
  getOrThrow: () => getOrThrow22222,
  getOrThrowWith: () => getOrThrowWith22222,
  getOrUndefined: () => getOrUndefined22222,
  getOrder: () => getOrder22222,
  getRight: () => getRight222222,
  isNone: () => isNone222222,
  isOption: () => isOption222222,
  isSome: () => isSome222222,
  let: () => let_222222,
  lift2: () => lift222222,
  liftNullable: () => liftNullable22222,
  liftPredicate: () => liftPredicate22222,
  liftThrowable: () => liftThrowable22222,
  map: () => map22222,
  match: () => match22222,
  none: () => none222222,
  orElse: () => orElse22222,
  orElseEither: () => orElseEither22222,
  orElseSome: () => orElseSome22222,
  partitionMap: () => partitionMap22222,
  product: () => product222222,
  productMany: () => productMany222222,
  reduceCompact: () => reduceCompact22222,
  some: () => some322222,
  tap: () => tap22222,
  toArray: () => toArray22222,
  toRefinement: () => toRefinement22222,
  void: () => void_22222,
  zipLeft: () => zipLeft22222,
  zipRight: () => zipRight22222,
  zipWith: () => zipWith22222
});
var make222222 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId322222 = /* @__PURE__ */ Symbol.for("effect/Option");
var none222222 = () => none32222;
var some322222 = some222222;
var isOption222222 = isOption32222;
var isNone222222 = isNone32222;
var isSome222222 = isSome32222;
var match22222 = /* @__PURE__ */ dual22222(2, (self2, {
  onNone,
  onSome
}) => isNone222222(self2) ? onNone() : onSome(self2.value));
var toRefinement22222 = (f2222) => (a2222) => isSome222222(f2222(a2222));
var fromIterable22223 = (collection) => {
  for (const a2222 of collection) {
    return some322222(a2222);
  }
  return none222222();
};
var getRight222222 = getRight32222;
var getLeft222222 = getLeft32222;
var getOrElse22222 = /* @__PURE__ */ dual22222(2, (self2, onNone) => isNone222222(self2) ? onNone() : self2.value);
var orElse22222 = /* @__PURE__ */ dual22222(2, (self2, that) => isNone222222(self2) ? that() : self2);
var orElseSome22222 = /* @__PURE__ */ dual22222(2, (self2, onNone) => isNone222222(self2) ? some322222(onNone()) : self2);
var orElseEither22222 = /* @__PURE__ */ dual22222(2, (self2, that) => isNone222222(self2) ? map22222(that(), right22223) : map22222(self2, left22223));
var firstSomeOf22222 = (collection) => {
  let out = none222222();
  for (out of collection) {
    if (isSome222222(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable22222 = (nullableValue) => nullableValue == null ? none222222() : some322222(nullableValue);
var liftNullable22222 = (f2222) => (...a2222) => fromNullable22222(f2222(...a2222));
var getOrNull22222 = /* @__PURE__ */ getOrElse22222(constNull22222);
var getOrUndefined22222 = /* @__PURE__ */ getOrElse22222(constUndefined22222);
var liftThrowable22222 = (f2222) => (...a2222) => {
  try {
    return some322222(f2222(...a2222));
  } catch (e2222) {
    return none222222();
  }
};
var getOrThrowWith22222 = /* @__PURE__ */ dual22222(2, (self2, onNone) => {
  if (isSome222222(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow22222 = /* @__PURE__ */ getOrThrowWith22222(() => new Error("getOrThrow called on a None"));
var map22222 = /* @__PURE__ */ dual22222(2, (self2, f2222) => isNone222222(self2) ? none222222() : some322222(f2222(self2.value)));
var as22222 = /* @__PURE__ */ dual22222(2, (self2, b2222) => map22222(self2, () => b2222));
var asVoid22222 = /* @__PURE__ */ as22222(void 0);
var void_22222 = /* @__PURE__ */ some322222(void 0);
var flatMap22222 = /* @__PURE__ */ dual22222(2, (self2, f2222) => isNone222222(self2) ? none222222() : f2222(self2.value));
var andThen22222 = /* @__PURE__ */ dual22222(2, (self2, f2222) => flatMap22222(self2, (a2222) => {
  const b2222 = isFunction222222(f2222) ? f2222(a2222) : f2222;
  return isOption222222(b2222) ? b2222 : some322222(b2222);
}));
var flatMapNullable22222 = /* @__PURE__ */ dual22222(2, (self2, f2222) => isNone222222(self2) ? none222222() : fromNullable22222(f2222(self2.value)));
var flatten22222 = /* @__PURE__ */ flatMap22222(identity22222);
var zipRight22222 = /* @__PURE__ */ dual22222(2, (self2, that) => flatMap22222(self2, () => that));
var composeK22222 = /* @__PURE__ */ dual22222(2, (afb, bfc) => (a2222) => flatMap22222(afb(a2222), bfc));
var zipLeft22222 = /* @__PURE__ */ dual22222(2, (self2, that) => tap22222(self2, () => that));
var tap22222 = /* @__PURE__ */ dual22222(2, (self2, f2222) => flatMap22222(self2, (a2222) => map22222(f2222(a2222), () => a2222)));
var product222222 = (self2, that) => isSome222222(self2) && isSome222222(that) ? some322222([self2.value, that.value]) : none222222();
var productMany222222 = (self2, collection) => {
  if (isNone222222(self2)) {
    return none222222();
  }
  const out = [self2.value];
  for (const o2222 of collection) {
    if (isNone222222(o2222)) {
      return none222222();
    }
    out.push(o2222.value);
  }
  return some322222(out);
};
var all222222 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o2222 of input) {
      if (isNone222222(o2222)) {
        return none222222();
      }
      out2.push(o2222.value);
    }
    return some322222(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o2222 = input[key];
    if (isNone222222(o2222)) {
      return none222222();
    }
    out[key] = o2222.value;
  }
  return some322222(out);
};
var zipWith22222 = /* @__PURE__ */ dual22222(3, (self2, that, f2222) => map22222(product222222(self2, that), ([a2222, b2222]) => f2222(a2222, b2222)));
var ap22222 = /* @__PURE__ */ dual22222(2, (self2, that) => zipWith22222(self2, that, (f2222, a2222) => f2222(a2222)));
var reduceCompact22222 = /* @__PURE__ */ dual22222(3, (self2, b2222, f2222) => {
  let out = b2222;
  for (const oa of self2) {
    if (isSome222222(oa)) {
      out = f2222(out, oa.value);
    }
  }
  return out;
});
var toArray22222 = (self2) => isNone222222(self2) ? [] : [self2.value];
var partitionMap22222 = /* @__PURE__ */ dual22222(2, (self2, f2222) => {
  if (isNone222222(self2)) {
    return [none222222(), none222222()];
  }
  const e2222 = f2222(self2.value);
  return isLeft22222(e2222) ? [some322222(e2222.left), none222222()] : [none222222(), some322222(e2222.right)];
});
var filterMap22222 = /* @__PURE__ */ dual22222(2, (self2, f2222) => isNone222222(self2) ? none222222() : f2222(self2.value));
var filter22222 = /* @__PURE__ */ dual22222(2, (self2, predicate) => filterMap22222(self2, (b2222) => predicate(b2222) ? some222222(b2222) : none32222));
var getEquivalence22223 = (isEquivalent) => make42223((x2222, y2222) => x2222 === y2222 || (isNone222222(x2222) ? isNone222222(y2222) : isNone222222(y2222) ? false : isEquivalent(x2222.value, y2222.value)));
var getOrder22222 = (O2222) => make222222((self2, that) => isSome222222(self2) ? isSome222222(that) ? O2222(self2.value, that.value) : 1 : -1);
var lift222222 = (f2222) => dual22222(2, (self2, that) => zipWith22222(self2, that, f2222));
var liftPredicate22222 = (predicate) => (b2222) => predicate(b2222) ? some322222(b2222) : none222222();
var containsWith22222 = (isEquivalent) => dual22222(2, (self2, a2222) => isNone222222(self2) ? false : isEquivalent(self2.value, a2222));
var _equivalence22223 = /* @__PURE__ */ equivalence22222();
var contains22222 = /* @__PURE__ */ containsWith22222(_equivalence22223);
var exists22222 = /* @__PURE__ */ dual22222(2, (self2, refinement) => isNone222222(self2) ? false : refinement(self2.value));
var bindTo222222 = /* @__PURE__ */ bindTo32222(map22222);
var let_222222 = /* @__PURE__ */ let_32222(map22222);
var bind222222 = /* @__PURE__ */ bind32222(map22222, flatMap22222);
var Do22222 = /* @__PURE__ */ some322222({});
var adapter222222 = /* @__PURE__ */ adapter32222();
var gen22222 = (f2222) => {
  const iterator = f2222(adapter222222);
  let state = iterator.next();
  if (state.done) {
    return some322222(state.value);
  } else {
    let current = state.value;
    if (isGenKind22222(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet22222(current);
    }
    if (isNone222222(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind22222(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet22222(current);
        }
        if (isNone222222(current)) {
          return current;
        }
      }
    }
    return some322222(state.value);
  }
};
var fromIterable222222 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var reverse43 = (self2) => Array.from(self2).reverse();
var reduce53 = /* @__PURE__ */ dual22222(3, (self2, b2222, f2222) => fromIterable222222(self2).reduce((b22222, a2222, i2222) => f2222(b22222, a2222, i2222), b2222));
var TagTypeId2222 = /* @__PURE__ */ Symbol.for("effect/Context/Tag");
var STMSymbolKey2222 = "effect/STM";
var STMTypeId2222 = /* @__PURE__ */ Symbol.for(STMSymbolKey2222);
var TagProto2222 = {
  ...EffectPrototype22222,
  _tag: "Tag",
  _op: "Tag",
  [STMTypeId2222]: effectVariance22222,
  [TagTypeId2222]: {
    _Service: (_2222) => _2222,
    _Identifier: (_2222) => _2222
  },
  toString() {
    return format22222(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Tag",
      key: this.key,
      stack: this.stack
    };
  },
  [NodeInspectSymbol22222]() {
    return this.toJSON();
  },
  of(self2) {
    return self2;
  },
  context(self2) {
    return make322222(this, self2);
  }
};
var makeGenericTag2222 = (key) => {
  const limit = Error.stackTraceLimit;
  Error.stackTraceLimit = 2;
  const creationError = new Error();
  Error.stackTraceLimit = limit;
  const tag = Object.create(TagProto2222);
  Object.defineProperty(tag, "stack", {
    get() {
      return creationError.stack;
    }
  });
  tag.key = key;
  return tag;
};
var TypeId422222 = /* @__PURE__ */ Symbol.for("effect/Context");
var ContextProto2222 = {
  [TypeId422222]: {
    _Services: (_2222) => _2222
  },
  [symbol222222](that) {
    if (isContext2222(that)) {
      if (this.unsafeMap.size === that.unsafeMap.size) {
        for (const k2222 of this.unsafeMap.keys()) {
          if (!that.unsafeMap.has(k2222) || !equals22222(this.unsafeMap.get(k2222), that.unsafeMap.get(k2222))) {
            return false;
          }
        }
        return true;
      }
    }
    return false;
  },
  [symbol32222]() {
    return cached22222(this, number22222(this.unsafeMap.size));
  },
  pipe() {
    return pipeArguments22222(this, arguments);
  },
  toString() {
    return format22222(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Context",
      services: Array.from(this.unsafeMap).map(toJSON22222)
    };
  },
  [NodeInspectSymbol22222]() {
    return this.toJSON();
  }
};
var makeContext2222 = (unsafeMap) => {
  const context = Object.create(ContextProto2222);
  context.unsafeMap = unsafeMap;
  return context;
};
var isContext2222 = (u2222) => hasProperty22222(u2222, TypeId422222);
var _empty6222 = /* @__PURE__ */ makeContext2222(/* @__PURE__ */ new Map());
var empty103 = () => _empty6222;
var make322222 = (tag, service) => makeContext2222(/* @__PURE__ */ new Map([[tag.key, service]]));
var GenericTag2222 = makeGenericTag2222;
var empty22222 = empty103;
var TypeId522222 = /* @__PURE__ */ Symbol.for("effect/Chunk");
function copy33(src, srcPos, dest, destPos, len) {
  for (let i2222 = srcPos; i2222 < Math.min(src.length, srcPos + len); i2222++) {
    dest[destPos + i2222 - srcPos] = src[i2222];
  }
  return dest;
}
var emptyArray2222 = [];
var getEquivalence222222 = (isEquivalent) => make42223((self2, that) => self2.length === that.length && toReadonlyArray2222(self2).every((value, i2222) => isEquivalent(value, unsafeGet22222(that, i2222))));
var _equivalence222222 = /* @__PURE__ */ getEquivalence222222(equals22222);
var ChunkProto2222 = {
  [TypeId522222]: {
    _A: (_2222) => _2222
  },
  toString() {
    return format22222(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Chunk",
      values: toReadonlyArray2222(this).map(toJSON22222)
    };
  },
  [NodeInspectSymbol22222]() {
    return this.toJSON();
  },
  [symbol222222](that) {
    return isChunk2222(that) && _equivalence222222(this, that);
  },
  [symbol32222]() {
    return cached22222(this, array53(toReadonlyArray2222(this)));
  },
  [Symbol.iterator]() {
    switch (this.backing._tag) {
      case "IArray": {
        return this.backing.array[Symbol.iterator]();
      }
      case "IEmpty": {
        return emptyArray2222[Symbol.iterator]();
      }
      default: {
        return toReadonlyArray2222(this)[Symbol.iterator]();
      }
    }
  },
  pipe() {
    return pipeArguments22222(this, arguments);
  }
};
var makeChunk2222 = (backing) => {
  const chunk = Object.create(ChunkProto2222);
  chunk.backing = backing;
  switch (backing._tag) {
    case "IEmpty": {
      chunk.length = 0;
      chunk.depth = 0;
      chunk.left = chunk;
      chunk.right = chunk;
      break;
    }
    case "IConcat": {
      chunk.length = backing.left.length + backing.right.length;
      chunk.depth = 1 + Math.max(backing.left.depth, backing.right.depth);
      chunk.left = backing.left;
      chunk.right = backing.right;
      break;
    }
    case "IArray": {
      chunk.length = backing.array.length;
      chunk.depth = 0;
      chunk.left = _empty22222;
      chunk.right = _empty22222;
      break;
    }
    case "ISingleton": {
      chunk.length = 1;
      chunk.depth = 0;
      chunk.left = _empty22222;
      chunk.right = _empty22222;
      break;
    }
    case "ISlice": {
      chunk.length = backing.length;
      chunk.depth = backing.chunk.depth + 1;
      chunk.left = _empty22222;
      chunk.right = _empty22222;
      break;
    }
  }
  return chunk;
};
var isChunk2222 = (u2222) => hasProperty22222(u2222, TypeId522222);
var _empty22222 = /* @__PURE__ */ makeChunk2222({
  _tag: "IEmpty"
});
var empty32222 = () => _empty22222;
var make422222 = (...as222222) => as222222.length === 1 ? of33(as222222[0]) : unsafeFromNonEmptyArray2222(as222222);
var of33 = (a2222) => makeChunk2222({
  _tag: "ISingleton",
  a: a2222
});
var copyToArray2222 = (self2, array32222, initial) => {
  switch (self2.backing._tag) {
    case "IArray": {
      copy33(self2.backing.array, 0, array32222, initial, self2.length);
      break;
    }
    case "IConcat": {
      copyToArray2222(self2.left, array32222, initial);
      copyToArray2222(self2.right, array32222, initial + self2.left.length);
      break;
    }
    case "ISingleton": {
      array32222[initial] = self2.backing.a;
      break;
    }
    case "ISlice": {
      let i2222 = 0;
      let j2222 = initial;
      while (i2222 < self2.length) {
        array32222[j2222] = unsafeGet22222(self2, i2222);
        i2222 += 1;
        j2222 += 1;
      }
      break;
    }
  }
};
var toReadonlyArray2222 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      return emptyArray2222;
    }
    case "IArray": {
      return self2.backing.array;
    }
    default: {
      const arr = new Array(self2.length);
      copyToArray2222(self2, arr, 0);
      self2.backing = {
        _tag: "IArray",
        array: arr
      };
      self2.left = _empty22222;
      self2.right = _empty22222;
      self2.depth = 0;
      return arr;
    }
  }
};
var reverse22222 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty":
    case "ISingleton":
      return self2;
    case "IArray": {
      return makeChunk2222({
        _tag: "IArray",
        array: reverse43(self2.backing.array)
      });
    }
    case "IConcat": {
      return makeChunk2222({
        _tag: "IConcat",
        left: reverse22222(self2.backing.right),
        right: reverse22222(self2.backing.left)
      });
    }
    case "ISlice":
      return unsafeFromArray2222(reverse43(toReadonlyArray2222(self2)));
  }
};
var unsafeFromArray2222 = (self2) => makeChunk2222({
  _tag: "IArray",
  array: self2
});
var unsafeFromNonEmptyArray2222 = (self2) => unsafeFromArray2222(self2);
var unsafeGet22222 = /* @__PURE__ */ dual22222(2, (self2, index) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      throw new Error(`Index out of bounds`);
    }
    case "ISingleton": {
      if (index !== 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.a;
    }
    case "IArray": {
      if (index >= self2.length || index < 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.array[index];
    }
    case "IConcat": {
      return index < self2.left.length ? unsafeGet22222(self2.left, index) : unsafeGet22222(self2.right, index - self2.left.length);
    }
    case "ISlice": {
      return unsafeGet22222(self2.backing.chunk, index + self2.backing.offset);
    }
  }
});
var prepend33 = /* @__PURE__ */ dual22222(2, (self2, elem) => appendAll33(of33(elem), self2));
var drop33 = /* @__PURE__ */ dual22222(2, (self2, n2222) => {
  if (n2222 <= 0) {
    return self2;
  } else if (n2222 >= self2.length) {
    return _empty22222;
  } else {
    switch (self2.backing._tag) {
      case "ISlice": {
        return makeChunk2222({
          _tag: "ISlice",
          chunk: self2.backing.chunk,
          offset: self2.backing.offset + n2222,
          length: self2.backing.length - n2222
        });
      }
      case "IConcat": {
        if (n2222 > self2.left.length) {
          return drop33(self2.right, n2222 - self2.left.length);
        }
        return makeChunk2222({
          _tag: "IConcat",
          left: drop33(self2.left, n2222),
          right: self2.right
        });
      }
      default: {
        return makeChunk2222({
          _tag: "ISlice",
          chunk: self2,
          offset: n2222,
          length: self2.length - n2222
        });
      }
    }
  }
});
var appendAll33 = /* @__PURE__ */ dual22222(2, (self2, that) => {
  if (self2.backing._tag === "IEmpty") {
    return that;
  }
  if (that.backing._tag === "IEmpty") {
    return self2;
  }
  const diff22222 = that.depth - self2.depth;
  if (Math.abs(diff22222) <= 1) {
    return makeChunk2222({
      _tag: "IConcat",
      left: self2,
      right: that
    });
  } else if (diff22222 < -1) {
    if (self2.left.depth >= self2.right.depth) {
      const nr = appendAll33(self2.right, that);
      return makeChunk2222({
        _tag: "IConcat",
        left: self2.left,
        right: nr
      });
    } else {
      const nrr = appendAll33(self2.right.right, that);
      if (nrr.depth === self2.depth - 3) {
        const nr = makeChunk2222({
          _tag: "IConcat",
          left: self2.right.left,
          right: nrr
        });
        return makeChunk2222({
          _tag: "IConcat",
          left: self2.left,
          right: nr
        });
      } else {
        const nl = makeChunk2222({
          _tag: "IConcat",
          left: self2.left,
          right: self2.right.left
        });
        return makeChunk2222({
          _tag: "IConcat",
          left: nl,
          right: nrr
        });
      }
    }
  } else {
    if (that.right.depth >= that.left.depth) {
      const nl = appendAll33(self2, that.left);
      return makeChunk2222({
        _tag: "IConcat",
        left: nl,
        right: that.right
      });
    } else {
      const nll = appendAll33(self2, that.left.left);
      if (nll.depth === that.depth - 3) {
        const nl = makeChunk2222({
          _tag: "IConcat",
          left: nll,
          right: that.left.right
        });
        return makeChunk2222({
          _tag: "IConcat",
          left: nl,
          right: that.right
        });
      } else {
        const nr = makeChunk2222({
          _tag: "IConcat",
          left: that.left.right,
          right: that.right
        });
        return makeChunk2222({
          _tag: "IConcat",
          left: nll,
          right: nr
        });
      }
    }
  }
});
var isEmpty2222 = (self2) => self2.length === 0;
var isNonEmpty2222 = (self2) => self2.length > 0;
var unsafeHead2222 = (self2) => unsafeGet22222(self2, 0);
var headNonEmpty33 = unsafeHead2222;
var tailNonEmpty33 = (self2) => drop33(self2, 1);
var SIZE2222 = 5;
var BUCKET_SIZE2222 = /* @__PURE__ */ Math.pow(2, SIZE2222);
var MASK2222 = BUCKET_SIZE2222 - 1;
var MAX_INDEX_NODE2222 = BUCKET_SIZE2222 / 2;
var MIN_ARRAY_NODE2222 = BUCKET_SIZE2222 / 4;
function popcount2222(x2222) {
  x2222 -= x2222 >> 1 & 1431655765;
  x2222 = (x2222 & 858993459) + (x2222 >> 2 & 858993459);
  x2222 = x2222 + (x2222 >> 4) & 252645135;
  x2222 += x2222 >> 8;
  x2222 += x2222 >> 16;
  return x2222 & 127;
}
function hashFragment2222(shift22, h2222) {
  return h2222 >>> shift22 & MASK2222;
}
function toBitmap2222(x2222) {
  return 1 << x2222;
}
function fromBitmap2222(bitmap, bit) {
  return popcount2222(bitmap & bit - 1);
}
var make52222 = (value, previous) => ({
  value,
  previous
});
function arrayUpdate2222(mutate22222, at, v2222, arr) {
  let out = arr;
  if (!mutate22222) {
    const len = arr.length;
    out = new Array(len);
    for (let i2222 = 0; i2222 < len; ++i2222) out[i2222] = arr[i2222];
  }
  out[at] = v2222;
  return out;
}
function arraySpliceOut2222(mutate22222, at, arr) {
  const newLen = arr.length - 1;
  let i2222 = 0;
  let g2222 = 0;
  let out = arr;
  if (mutate22222) {
    i2222 = g2222 = at;
  } else {
    out = new Array(newLen);
    while (i2222 < at) out[g2222++] = arr[i2222++];
  }
  ++i2222;
  while (i2222 <= newLen) out[g2222++] = arr[i2222++];
  if (mutate22222) {
    out.length = newLen;
  }
  return out;
}
function arraySpliceIn2222(mutate22222, at, v2222, arr) {
  const len = arr.length;
  if (mutate22222) {
    let i22222 = len;
    while (i22222 >= at) arr[i22222--] = arr[i22222];
    arr[at] = v2222;
    return arr;
  }
  let i2222 = 0, g2222 = 0;
  const out = new Array(len + 1);
  while (i2222 < at) out[g2222++] = arr[i2222++];
  out[at] = v2222;
  while (i2222 < len) out[++g2222] = arr[i2222++];
  return out;
}
var EmptyNode2222 = class _EmptyNode2222 {
  _tag = "EmptyNode";
  modify(edit, _shift, f2222, hash222222, key, size42222) {
    const v2222 = f2222(none222222());
    if (isNone222222(v2222)) return new _EmptyNode2222();
    ++size42222.value;
    return new LeafNode2222(edit, hash222222, key, v2222);
  }
};
function isEmptyNode2222(a2222) {
  return isTagged33(a2222, "EmptyNode");
}
function isLeafNode2222(node) {
  return isEmptyNode2222(node) || node._tag === "LeafNode" || node._tag === "CollisionNode";
}
function canEditNode2222(node, edit) {
  return isEmptyNode2222(node) ? false : edit === node.edit;
}
var LeafNode2222 = class _LeafNode2222 {
  edit;
  hash;
  key;
  value;
  _tag = "LeafNode";
  constructor(edit, hash222222, key, value) {
    this.edit = edit;
    this.hash = hash222222;
    this.key = key;
    this.value = value;
  }
  modify(edit, shift22, f2222, hash222222, key, size42222) {
    if (equals22222(key, this.key)) {
      const v22222 = f2222(this.value);
      if (v22222 === this.value) return this;
      else if (isNone222222(v22222)) {
        --size42222.value;
        return new EmptyNode2222();
      }
      if (canEditNode2222(this, edit)) {
        this.value = v22222;
        return this;
      }
      return new _LeafNode2222(edit, hash222222, key, v22222);
    }
    const v2222 = f2222(none222222());
    if (isNone222222(v2222)) return this;
    ++size42222.value;
    return mergeLeaves2222(edit, shift22, this.hash, this, hash222222, new _LeafNode2222(edit, hash222222, key, v2222));
  }
};
var CollisionNode2222 = class _CollisionNode2222 {
  edit;
  hash;
  children;
  _tag = "CollisionNode";
  constructor(edit, hash222222, children) {
    this.edit = edit;
    this.hash = hash222222;
    this.children = children;
  }
  modify(edit, shift22, f2222, hash222222, key, size42222) {
    if (hash222222 === this.hash) {
      const canEdit = canEditNode2222(this, edit);
      const list = this.updateCollisionList(canEdit, edit, this.hash, this.children, f2222, key, size42222);
      if (list === this.children) return this;
      return list.length > 1 ? new _CollisionNode2222(edit, this.hash, list) : list[0];
    }
    const v2222 = f2222(none222222());
    if (isNone222222(v2222)) return this;
    ++size42222.value;
    return mergeLeaves2222(edit, shift22, this.hash, this, hash222222, new LeafNode2222(edit, hash222222, key, v2222));
  }
  updateCollisionList(mutate22222, edit, hash222222, list, f2222, key, size42222) {
    const len = list.length;
    for (let i2222 = 0; i2222 < len; ++i2222) {
      const child = list[i2222];
      if ("key" in child && equals22222(key, child.key)) {
        const value = child.value;
        const newValue2 = f2222(value);
        if (newValue2 === value) return list;
        if (isNone222222(newValue2)) {
          --size42222.value;
          return arraySpliceOut2222(mutate22222, i2222, list);
        }
        return arrayUpdate2222(mutate22222, i2222, new LeafNode2222(edit, hash222222, key, newValue2), list);
      }
    }
    const newValue = f2222(none222222());
    if (isNone222222(newValue)) return list;
    ++size42222.value;
    return arrayUpdate2222(mutate22222, len, new LeafNode2222(edit, hash222222, key, newValue), list);
  }
};
var IndexedNode2222 = class _IndexedNode2222 {
  edit;
  mask;
  children;
  _tag = "IndexedNode";
  constructor(edit, mask, children) {
    this.edit = edit;
    this.mask = mask;
    this.children = children;
  }
  modify(edit, shift22, f2222, hash222222, key, size42222) {
    const mask = this.mask;
    const children = this.children;
    const frag = hashFragment2222(shift22, hash222222);
    const bit = toBitmap2222(frag);
    const indx = fromBitmap2222(mask, bit);
    const exists222222 = mask & bit;
    const canEdit = canEditNode2222(this, edit);
    if (!exists222222) {
      const _newChild = new EmptyNode2222().modify(edit, shift22 + SIZE2222, f2222, hash222222, key, size42222);
      if (!_newChild) return this;
      return children.length >= MAX_INDEX_NODE2222 ? expand2222(edit, frag, _newChild, mask, children) : new _IndexedNode2222(edit, mask | bit, arraySpliceIn2222(canEdit, indx, _newChild, children));
    }
    const current = children[indx];
    const child = current.modify(edit, shift22 + SIZE2222, f2222, hash222222, key, size42222);
    if (current === child) return this;
    let bitmap = mask;
    let newChildren;
    if (isEmptyNode2222(child)) {
      bitmap &= ~bit;
      if (!bitmap) return new EmptyNode2222();
      if (children.length <= 2 && isLeafNode2222(children[indx ^ 1])) {
        return children[indx ^ 1];
      }
      newChildren = arraySpliceOut2222(canEdit, indx, children);
    } else {
      newChildren = arrayUpdate2222(canEdit, indx, child, children);
    }
    if (canEdit) {
      this.mask = bitmap;
      this.children = newChildren;
      return this;
    }
    return new _IndexedNode2222(edit, bitmap, newChildren);
  }
};
var ArrayNode2222 = class _ArrayNode2222 {
  edit;
  size;
  children;
  _tag = "ArrayNode";
  constructor(edit, size42222, children) {
    this.edit = edit;
    this.size = size42222;
    this.children = children;
  }
  modify(edit, shift22, f2222, hash222222, key, size42222) {
    let count = this.size;
    const children = this.children;
    const frag = hashFragment2222(shift22, hash222222);
    const child = children[frag];
    const newChild = (child || new EmptyNode2222()).modify(edit, shift22 + SIZE2222, f2222, hash222222, key, size42222);
    if (child === newChild) return this;
    const canEdit = canEditNode2222(this, edit);
    let newChildren;
    if (isEmptyNode2222(child) && !isEmptyNode2222(newChild)) {
      ++count;
      newChildren = arrayUpdate2222(canEdit, frag, newChild, children);
    } else if (!isEmptyNode2222(child) && isEmptyNode2222(newChild)) {
      --count;
      if (count <= MIN_ARRAY_NODE2222) {
        return pack2222(edit, count, frag, children);
      }
      newChildren = arrayUpdate2222(canEdit, frag, new EmptyNode2222(), children);
    } else {
      newChildren = arrayUpdate2222(canEdit, frag, newChild, children);
    }
    if (canEdit) {
      this.size = count;
      this.children = newChildren;
      return this;
    }
    return new _ArrayNode2222(edit, count, newChildren);
  }
};
function pack2222(edit, count, removed, elements) {
  const children = new Array(count - 1);
  let g2222 = 0;
  let bitmap = 0;
  for (let i2222 = 0, len = elements.length; i2222 < len; ++i2222) {
    if (i2222 !== removed) {
      const elem = elements[i2222];
      if (elem && !isEmptyNode2222(elem)) {
        children[g2222++] = elem;
        bitmap |= 1 << i2222;
      }
    }
  }
  return new IndexedNode2222(edit, bitmap, children);
}
function expand2222(edit, frag, child, bitmap, subNodes) {
  const arr = [];
  let bit = bitmap;
  let count = 0;
  for (let i2222 = 0; bit; ++i2222) {
    if (bit & 1) arr[i2222] = subNodes[count++];
    bit >>>= 1;
  }
  arr[frag] = child;
  return new ArrayNode2222(edit, count + 1, arr);
}
function mergeLeavesInner2222(edit, shift22, h1, n1, h2222, n2222) {
  if (h1 === h2222) return new CollisionNode2222(edit, h1, [n2222, n1]);
  const subH1 = hashFragment2222(shift22, h1);
  const subH2 = hashFragment2222(shift22, h2222);
  if (subH1 === subH2) {
    return (child) => new IndexedNode2222(edit, toBitmap2222(subH1) | toBitmap2222(subH2), [child]);
  } else {
    const children = subH1 < subH2 ? [n1, n2222] : [n2222, n1];
    return new IndexedNode2222(edit, toBitmap2222(subH1) | toBitmap2222(subH2), children);
  }
}
function mergeLeaves2222(edit, shift22, h1, n1, h2222, n2222) {
  let stack = void 0;
  let currentShift = shift22;
  while (true) {
    const res = mergeLeavesInner2222(edit, currentShift, h1, n1, h2222, n2222);
    if (typeof res === "function") {
      stack = make52222(res, stack);
      currentShift = currentShift + SIZE2222;
    } else {
      let final = res;
      while (stack != null) {
        final = stack.value(final);
        stack = stack.previous;
      }
      return final;
    }
  }
}
var HashMapSymbolKey2222 = "effect/HashMap";
var HashMapTypeId2222 = /* @__PURE__ */ Symbol.for(HashMapSymbolKey2222);
var HashMapProto2222 = {
  [HashMapTypeId2222]: HashMapTypeId2222,
  [Symbol.iterator]() {
    return new HashMapIterator2222(this, (k2222, v2222) => [k2222, v2222]);
  },
  [symbol32222]() {
    let hash222222 = hash22222(HashMapSymbolKey2222);
    for (const item of this) {
      hash222222 ^= pipe22222(hash22222(item[0]), combine22223(hash22222(item[1])));
    }
    return cached22222(this, hash222222);
  },
  [symbol222222](that) {
    if (isHashMap2222(that)) {
      if (that._size !== this._size) {
        return false;
      }
      for (const item of this) {
        const elem = pipe22222(that, getHash2222(item[0], hash22222(item[0])));
        if (isNone222222(elem)) {
          return false;
        } else {
          if (!equals22222(item[1], elem.value)) {
            return false;
          }
        }
      }
      return true;
    }
    return false;
  },
  toString() {
    return format22222(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashMap",
      values: Array.from(this).map(toJSON22222)
    };
  },
  [NodeInspectSymbol22222]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments22222(this, arguments);
  }
};
var makeImpl3222 = (editable, edit, root, size42222) => {
  const map622 = Object.create(HashMapProto2222);
  map622._editable = editable;
  map622._edit = edit;
  map622._root = root;
  map622._size = size42222;
  return map622;
};
var HashMapIterator2222 = class _HashMapIterator2222 {
  map;
  f;
  v;
  constructor(map622, f2222) {
    this.map = map622;
    this.f = f2222;
    this.v = visitLazy2222(this.map._root, this.f, void 0);
  }
  next() {
    if (isNone222222(this.v)) {
      return {
        done: true,
        value: void 0
      };
    }
    const v0 = this.v.value;
    this.v = applyCont2222(v0.cont);
    return {
      done: false,
      value: v0.value
    };
  }
  [Symbol.iterator]() {
    return new _HashMapIterator2222(this.map, this.f);
  }
};
var applyCont2222 = (cont) => cont ? visitLazyChildren2222(cont[0], cont[1], cont[2], cont[3], cont[4]) : none222222();
var visitLazy2222 = (node, f2222, cont = void 0) => {
  switch (node._tag) {
    case "LeafNode": {
      if (isSome222222(node.value)) {
        return some322222({
          value: f2222(node.key, node.value.value),
          cont
        });
      }
      return applyCont2222(cont);
    }
    case "CollisionNode":
    case "ArrayNode":
    case "IndexedNode": {
      const children = node.children;
      return visitLazyChildren2222(children.length, children, 0, f2222, cont);
    }
    default: {
      return applyCont2222(cont);
    }
  }
};
var visitLazyChildren2222 = (len, children, i2222, f2222, cont) => {
  while (i2222 < len) {
    const child = children[i2222++];
    if (child && !isEmptyNode2222(child)) {
      return visitLazy2222(child, f2222, [len, children, i2222, f2222, cont]);
    }
  }
  return applyCont2222(cont);
};
var _empty32222 = /* @__PURE__ */ makeImpl3222(false, 0, /* @__PURE__ */ new EmptyNode2222(), 0);
var empty42222 = () => _empty32222;
var isHashMap2222 = (u2222) => hasProperty22222(u2222, HashMapTypeId2222);
var getHash2222 = /* @__PURE__ */ dual22222(3, (self2, key, hash222222) => {
  let node = self2._root;
  let shift22 = 0;
  while (true) {
    switch (node._tag) {
      case "LeafNode": {
        return equals22222(key, node.key) ? node.value : none222222();
      }
      case "CollisionNode": {
        if (hash222222 === node.hash) {
          const children = node.children;
          for (let i2222 = 0, len = children.length; i2222 < len; ++i2222) {
            const child = children[i2222];
            if ("key" in child && equals22222(key, child.key)) {
              return child.value;
            }
          }
        }
        return none222222();
      }
      case "IndexedNode": {
        const frag = hashFragment2222(shift22, hash222222);
        const bit = toBitmap2222(frag);
        if (node.mask & bit) {
          node = node.children[fromBitmap2222(node.mask, bit)];
          shift22 += SIZE2222;
          break;
        }
        return none222222();
      }
      case "ArrayNode": {
        node = node.children[hashFragment2222(shift22, hash222222)];
        if (node) {
          shift22 += SIZE2222;
          break;
        }
        return none222222();
      }
      default:
        return none222222();
    }
  }
});
var set22222 = /* @__PURE__ */ dual22222(3, (self2, key, value) => modifyAt2222(self2, key, () => some322222(value)));
var setTree2222 = /* @__PURE__ */ dual22222(3, (self2, newRoot, newSize) => {
  if (self2._editable) {
    self2._root = newRoot;
    self2._size = newSize;
    return self2;
  }
  return newRoot === self2._root ? self2 : makeImpl3222(self2._editable, self2._edit, newRoot, newSize);
});
var keys33 = (self2) => new HashMapIterator2222(self2, (key) => key);
var size4222 = (self2) => self2._size;
var beginMutation3222 = (self2) => makeImpl3222(true, self2._edit + 1, self2._root, self2._size);
var modifyAt2222 = /* @__PURE__ */ dual22222(3, (self2, key, f2222) => modifyHash2222(self2, key, hash22222(key), f2222));
var modifyHash2222 = /* @__PURE__ */ dual22222(4, (self2, key, hash222222, f2222) => {
  const size42222 = {
    value: self2._size
  };
  const newRoot = self2._root.modify(self2._editable ? self2._edit : NaN, 0, f2222, hash222222, key, size42222);
  return pipe22222(self2, setTree2222(newRoot, size42222.value));
});
var forEach43 = /* @__PURE__ */ dual22222(2, (self2, f2222) => reduce22222(self2, void 0, (_2222, value, key) => f2222(value, key)));
var reduce22222 = /* @__PURE__ */ dual22222(3, (self2, zero, f2222) => {
  const root = self2._root;
  if (root._tag === "LeafNode") {
    return isSome222222(root.value) ? f2222(zero, root.value.value, root.key) : zero;
  }
  if (root._tag === "EmptyNode") {
    return zero;
  }
  const toVisit = [root.children];
  let children;
  while (children = toVisit.pop()) {
    for (let i2222 = 0, len = children.length; i2222 < len; ) {
      const child = children[i2222++];
      if (child && !isEmptyNode2222(child)) {
        if (child._tag === "LeafNode") {
          if (isSome222222(child.value)) {
            zero = f2222(zero, child.value.value, child.key);
          }
        } else {
          toVisit.push(child.children);
        }
      }
    }
  }
  return zero;
});
var HashSetSymbolKey2222 = "effect/HashSet";
var HashSetTypeId2222 = /* @__PURE__ */ Symbol.for(HashSetSymbolKey2222);
var HashSetProto2222 = {
  [HashSetTypeId2222]: HashSetTypeId2222,
  [Symbol.iterator]() {
    return keys33(this._keyMap);
  },
  [symbol32222]() {
    return cached22222(this, combine22223(hash22222(this._keyMap))(hash22222(HashSetSymbolKey2222)));
  },
  [symbol222222](that) {
    if (isHashSet2222(that)) {
      return size4222(this._keyMap) === size4222(that._keyMap) && equals22222(this._keyMap, that._keyMap);
    }
    return false;
  },
  toString() {
    return format22222(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashSet",
      values: Array.from(this).map(toJSON22222)
    };
  },
  [NodeInspectSymbol22222]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments22222(this, arguments);
  }
};
var makeImpl22222 = (keyMap) => {
  const set222222 = Object.create(HashSetProto2222);
  set222222._keyMap = keyMap;
  return set222222;
};
var isHashSet2222 = (u2222) => hasProperty22222(u2222, HashSetTypeId2222);
var _empty42222 = /* @__PURE__ */ makeImpl22222(/* @__PURE__ */ empty42222());
var empty52222 = () => _empty42222;
var size22222 = (self2) => size4222(self2._keyMap);
var beginMutation22222 = (self2) => makeImpl22222(beginMutation3222(self2._keyMap));
var endMutation2222 = (self2) => {
  self2._keyMap._editable = false;
  return self2;
};
var mutate2222 = /* @__PURE__ */ dual22222(2, (self2, f2222) => {
  const transient = beginMutation22222(self2);
  f2222(transient);
  return endMutation2222(transient);
});
var add22222 = /* @__PURE__ */ dual22222(2, (self2, value) => self2._keyMap._editable ? (set22222(value, true)(self2._keyMap), self2) : makeImpl22222(set22222(value, true)(self2._keyMap)));
var union22222 = /* @__PURE__ */ dual22222(2, (self2, that) => mutate2222(empty52222(), (set222222) => {
  forEach22222(self2, (value) => add22222(set222222, value));
  for (const value of that) {
    add22222(set222222, value);
  }
}));
var forEach22222 = /* @__PURE__ */ dual22222(2, (self2, f2222) => forEach43(self2._keyMap, (_2222, k2222) => f2222(k2222)));
var empty62222 = empty52222;
var size32222 = size22222;
var add32222 = add22222;
var union32222 = union22222;
var ArrayProto2222 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(Array.prototype), {
  [symbol32222]() {
    return cached22222(this, array53(this));
  },
  [symbol222222](that) {
    if (Array.isArray(that) && this.length === that.length) {
      return this.every((v2222, i2222) => equals22222(v2222, that[i2222]));
    } else {
      return false;
    }
  }
});
var Structural3222 = /* @__PURE__ */ function() {
  function Structural32222(args) {
    if (args) {
      Object.assign(this, args);
    }
  }
  Structural32222.prototype = StructuralPrototype2222;
  return Structural32222;
}();
var struct22222 = (as222222) => Object.assign(Object.create(StructuralPrototype2222), as222222);
var ContextPatchTypeId2222 = /* @__PURE__ */ Symbol.for("effect/DifferContextPatch");
function variance3222(a2222) {
  return a2222;
}
var PatchProto2222 = {
  ...Structural3222.prototype,
  [ContextPatchTypeId2222]: {
    _Value: variance3222,
    _Patch: variance3222
  }
};
var EmptyProto2222 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto2222), {
  _tag: "Empty"
});
var _empty52222 = /* @__PURE__ */ Object.create(EmptyProto2222);
var empty72222 = () => _empty52222;
var AndThenProto2222 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto2222), {
  _tag: "AndThen"
});
var makeAndThen2222 = (first, second) => {
  const o2222 = Object.create(AndThenProto2222);
  o2222.first = first;
  o2222.second = second;
  return o2222;
};
var AddServiceProto2222 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto2222), {
  _tag: "AddService"
});
var makeAddService2222 = (key, service) => {
  const o2222 = Object.create(AddServiceProto2222);
  o2222.key = key;
  o2222.service = service;
  return o2222;
};
var RemoveServiceProto2222 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto2222), {
  _tag: "RemoveService"
});
var makeRemoveService2222 = (key) => {
  const o2222 = Object.create(RemoveServiceProto2222);
  o2222.key = key;
  return o2222;
};
var UpdateServiceProto2222 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto2222), {
  _tag: "UpdateService"
});
var makeUpdateService2222 = (key, update222) => {
  const o2222 = Object.create(UpdateServiceProto2222);
  o2222.key = key;
  o2222.update = update222;
  return o2222;
};
var diff2222 = (oldValue, newValue) => {
  const missingServices = new Map(oldValue.unsafeMap);
  let patch22222 = empty72222();
  for (const [tag, newService] of newValue.unsafeMap.entries()) {
    if (missingServices.has(tag)) {
      const old = missingServices.get(tag);
      missingServices.delete(tag);
      if (!equals22222(old, newService)) {
        patch22222 = combine222222(makeUpdateService2222(tag, () => newService))(patch22222);
      }
    } else {
      missingServices.delete(tag);
      patch22222 = combine222222(makeAddService2222(tag, newService))(patch22222);
    }
  }
  for (const [tag] of missingServices.entries()) {
    patch22222 = combine222222(makeRemoveService2222(tag))(patch22222);
  }
  return patch22222;
};
var combine222222 = /* @__PURE__ */ dual22222(2, (self2, that) => makeAndThen2222(self2, that));
var patch2222 = /* @__PURE__ */ dual22222(2, (self2, context) => {
  if (self2._tag === "Empty") {
    return context;
  }
  let wasServiceUpdated = false;
  let patches = of33(self2);
  const updatedContext = new Map(context.unsafeMap);
  while (isNonEmpty2222(patches)) {
    const head222 = headNonEmpty33(patches);
    const tail222 = tailNonEmpty33(patches);
    switch (head222._tag) {
      case "Empty": {
        patches = tail222;
        break;
      }
      case "AddService": {
        updatedContext.set(head222.key, head222.service);
        patches = tail222;
        break;
      }
      case "AndThen": {
        patches = prepend33(prepend33(tail222, head222.second), head222.first);
        break;
      }
      case "RemoveService": {
        updatedContext.delete(head222.key);
        patches = tail222;
        break;
      }
      case "UpdateService": {
        updatedContext.set(head222.key, head222.update(updatedContext.get(head222.key)));
        wasServiceUpdated = true;
        patches = tail222;
        break;
      }
    }
  }
  if (!wasServiceUpdated) {
    return makeContext2222(updatedContext);
  }
  const map622 = /* @__PURE__ */ new Map();
  for (const [tag] of context.unsafeMap) {
    if (updatedContext.has(tag)) {
      map622.set(tag, updatedContext.get(tag));
      updatedContext.delete(tag);
    }
  }
  for (const [tag, s2222] of updatedContext) {
    map622.set(tag, s2222);
  }
  return makeContext2222(map622);
});
var DifferTypeId2222 = /* @__PURE__ */ Symbol.for("effect/Differ");
var DifferProto2222 = {
  [DifferTypeId2222]: {
    _P: identity22222,
    _V: identity22222
  }
};
var make72222 = (params) => {
  const differ = Object.create(DifferProto2222);
  differ.empty = params.empty;
  differ.diff = params.diff;
  differ.combine = params.combine;
  differ.patch = params.patch;
  return differ;
};
var environment2222 = () => make72222({
  empty: empty72222(),
  combine: (first, second) => combine222222(second)(first),
  diff: (oldValue, newValue) => diff2222(oldValue, newValue),
  patch: (patch22222, oldValue) => patch2222(oldValue)(patch22222)
});
var OP_DIE2222 = "Die";
var OP_EMPTY2222 = "Empty";
var OP_FAIL2222 = "Fail";
var OP_INTERRUPT2222 = "Interrupt";
var OP_PARALLEL2222 = "Parallel";
var OP_SEQUENTIAL2222 = "Sequential";
var CauseSymbolKey2222 = "effect/Cause";
var CauseTypeId2222 = /* @__PURE__ */ Symbol.for(CauseSymbolKey2222);
var variance22222 = {
  /* c8 ignore next */
  _E: (_2222) => _2222
};
var proto2222 = {
  [CauseTypeId2222]: variance22222,
  [symbol32222]() {
    return pipe22222(hash22222(CauseSymbolKey2222), combine22223(hash22222(flattenCause2222(this))), cached22222(this));
  },
  [symbol222222](that) {
    return isCause2222(that) && causeEquals2222(this, that);
  },
  pipe() {
    return pipeArguments22222(this, arguments);
  },
  toJSON() {
    switch (this._tag) {
      case "Empty":
        return {
          _id: "Cause",
          _tag: this._tag
        };
      case "Die":
        return {
          _id: "Cause",
          _tag: this._tag,
          defect: toJSON22222(this.defect)
        };
      case "Interrupt":
        return {
          _id: "Cause",
          _tag: this._tag,
          fiberId: this.fiberId.toJSON()
        };
      case "Fail":
        return {
          _id: "Cause",
          _tag: this._tag,
          failure: toJSON22222(this.error)
        };
      case "Sequential":
      case "Parallel":
        return {
          _id: "Cause",
          _tag: this._tag,
          left: toJSON22222(this.left),
          right: toJSON22222(this.right)
        };
    }
  },
  toString() {
    return pretty2222(this);
  },
  [NodeInspectSymbol22222]() {
    return this.toJSON();
  }
};
var fail3222 = (error) => {
  const o2222 = Object.create(proto2222);
  o2222._tag = OP_FAIL2222;
  o2222.error = error;
  return o2222;
};
var parallel2222 = (left32222, right32222) => {
  const o2222 = Object.create(proto2222);
  o2222._tag = OP_PARALLEL2222;
  o2222.left = left32222;
  o2222.right = right32222;
  return o2222;
};
var sequential2222 = (left32222, right32222) => {
  const o2222 = Object.create(proto2222);
  o2222._tag = OP_SEQUENTIAL2222;
  o2222.left = left32222;
  o2222.right = right32222;
  return o2222;
};
var isCause2222 = (u2222) => hasProperty22222(u2222, CauseTypeId2222);
var isInterruptedOnly2222 = (self2) => reduceWithContext2222(void 0, IsInterruptedOnlyCauseReducer2222)(self2);
var causeEquals2222 = (left32222, right32222) => {
  let leftStack = of33(left32222);
  let rightStack = of33(right32222);
  while (isNonEmpty2222(leftStack) && isNonEmpty2222(rightStack)) {
    const [leftParallel, leftSequential] = pipe22222(headNonEmpty33(leftStack), reduce42222([empty62222(), empty32222()], ([parallel22222, sequential22222], cause) => {
      const [par, seq] = evaluateCause2222(cause);
      return some322222([pipe22222(parallel22222, union32222(par)), pipe22222(sequential22222, appendAll33(seq))]);
    }));
    const [rightParallel, rightSequential] = pipe22222(headNonEmpty33(rightStack), reduce42222([empty62222(), empty32222()], ([parallel22222, sequential22222], cause) => {
      const [par, seq] = evaluateCause2222(cause);
      return some322222([pipe22222(parallel22222, union32222(par)), pipe22222(sequential22222, appendAll33(seq))]);
    }));
    if (!equals22222(leftParallel, rightParallel)) {
      return false;
    }
    leftStack = leftSequential;
    rightStack = rightSequential;
  }
  return true;
};
var flattenCause2222 = (cause) => {
  return flattenCauseLoop2222(of33(cause), empty32222());
};
var flattenCauseLoop2222 = (causes, flattened) => {
  while (1) {
    const [parallel22222, sequential22222] = pipe22222(causes, reduce53([empty62222(), empty32222()], ([parallel322, sequential322], cause) => {
      const [par, seq] = evaluateCause2222(cause);
      return [pipe22222(parallel322, union32222(par)), pipe22222(sequential322, appendAll33(seq))];
    }));
    const updated = size32222(parallel22222) > 0 ? pipe22222(flattened, prepend33(parallel22222)) : flattened;
    if (isEmpty2222(sequential22222)) {
      return reverse22222(updated);
    }
    causes = sequential22222;
    flattened = updated;
  }
  throw new Error(getBugErrorMessage22222("Cause.flattenCauseLoop"));
};
var evaluateCause2222 = (self2) => {
  let cause = self2;
  const stack = [];
  let _parallel = empty62222();
  let _sequential = empty32222();
  while (cause !== void 0) {
    switch (cause._tag) {
      case OP_EMPTY2222: {
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_FAIL2222: {
        _parallel = add32222(_parallel, make422222(cause._tag, cause.error));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_DIE2222: {
        _parallel = add32222(_parallel, make422222(cause._tag, cause.defect));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_INTERRUPT2222: {
        _parallel = add32222(_parallel, make422222(cause._tag, cause.fiberId));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_SEQUENTIAL2222: {
        switch (cause.left._tag) {
          case OP_EMPTY2222: {
            cause = cause.right;
            break;
          }
          case OP_SEQUENTIAL2222: {
            cause = sequential2222(cause.left.left, sequential2222(cause.left.right, cause.right));
            break;
          }
          case OP_PARALLEL2222: {
            cause = parallel2222(sequential2222(cause.left.left, cause.right), sequential2222(cause.left.right, cause.right));
            break;
          }
          default: {
            _sequential = prepend33(_sequential, cause.right);
            cause = cause.left;
            break;
          }
        }
        break;
      }
      case OP_PARALLEL2222: {
        stack.push(cause.right);
        cause = cause.left;
        break;
      }
    }
  }
  throw new Error(getBugErrorMessage22222("Cause.evaluateCauseLoop"));
};
var IsInterruptedOnlyCauseReducer2222 = {
  emptyCase: constTrue22222,
  failCase: constFalse22222,
  dieCase: constFalse22222,
  interruptCase: constTrue22222,
  sequentialCase: (_2222, left32222, right32222) => left32222 && right32222,
  parallelCase: (_2222, left32222, right32222) => left32222 && right32222
};
var OP_SEQUENTIAL_CASE2222 = "SequentialCase";
var OP_PARALLEL_CASE2222 = "ParallelCase";
var reduce42222 = /* @__PURE__ */ dual22222(3, (self2, zero, pf) => {
  let accumulator = zero;
  let cause = self2;
  const causes = [];
  while (cause !== void 0) {
    const option = pf(accumulator, cause);
    accumulator = isSome222222(option) ? option.value : accumulator;
    switch (cause._tag) {
      case OP_SEQUENTIAL2222: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      case OP_PARALLEL2222: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      default: {
        cause = void 0;
        break;
      }
    }
    if (cause === void 0 && causes.length > 0) {
      cause = causes.pop();
    }
  }
  return accumulator;
});
var reduceWithContext2222 = /* @__PURE__ */ dual22222(3, (self2, context, reducer) => {
  const input = [self2];
  const output = [];
  while (input.length > 0) {
    const cause = input.pop();
    switch (cause._tag) {
      case OP_EMPTY2222: {
        output.push(right222222(reducer.emptyCase(context)));
        break;
      }
      case OP_FAIL2222: {
        output.push(right222222(reducer.failCase(context, cause.error)));
        break;
      }
      case OP_DIE2222: {
        output.push(right222222(reducer.dieCase(context, cause.defect)));
        break;
      }
      case OP_INTERRUPT2222: {
        output.push(right222222(reducer.interruptCase(context, cause.fiberId)));
        break;
      }
      case OP_SEQUENTIAL2222: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left222222({
          _tag: OP_SEQUENTIAL_CASE2222
        }));
        break;
      }
      case OP_PARALLEL2222: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left222222({
          _tag: OP_PARALLEL_CASE2222
        }));
        break;
      }
    }
  }
  const accumulator = [];
  while (output.length > 0) {
    const either = output.pop();
    switch (either._tag) {
      case "Left": {
        switch (either.left._tag) {
          case OP_SEQUENTIAL_CASE2222: {
            const left32222 = accumulator.pop();
            const right32222 = accumulator.pop();
            const value = reducer.sequentialCase(context, left32222, right32222);
            accumulator.push(value);
            break;
          }
          case OP_PARALLEL_CASE2222: {
            const left32222 = accumulator.pop();
            const right32222 = accumulator.pop();
            const value = reducer.parallelCase(context, left32222, right32222);
            accumulator.push(value);
            break;
          }
        }
        break;
      }
      case "Right": {
        accumulator.push(either.right);
        break;
      }
    }
  }
  if (accumulator.length === 0) {
    throw new Error("BUG: Cause.reduceWithContext - please report an issue at https://github.com/Effect-TS/effect/issues");
  }
  return accumulator.pop();
});
var pretty2222 = (cause) => {
  if (isInterruptedOnly2222(cause)) {
    return "All fibers interrupted without errors.";
  }
  return prettyErrors2222(cause).map((e2222) => e2222.stack).join("\n");
};
var PrettyError2222 = class extends globalThis.Error {
  span = void 0;
  constructor(originalError) {
    const prevLimit = Error.stackTraceLimit;
    Error.stackTraceLimit = 0;
    super(prettyErrorMessage2222(originalError));
    Error.stackTraceLimit = prevLimit;
    this.name = originalError instanceof Error ? originalError.name : "Error";
    if (typeof originalError === "object" && originalError !== null) {
      if (spanSymbol3222 in originalError) {
        this.span = originalError[spanSymbol3222];
      }
      Object.keys(originalError).forEach((key) => {
        if (!(key in this)) {
          this[key] = originalError[key];
        }
      });
    }
    this.stack = prettyErrorStack2222(this.message, originalError instanceof Error && originalError.stack ? originalError.stack : "", this.span);
  }
  toJSON() {
    const out = {
      message: this.message,
      stack: this.stack
    };
    if (this.span) {
      out.span = this.span;
    }
    return out;
  }
};
var prettyErrorMessage2222 = (u2222) => {
  if (typeof u2222 === "string") {
    return `Error: ${u2222}`;
  }
  try {
    if (hasProperty22222(u2222, "toString") && isFunction32222(u2222["toString"]) && u2222["toString"] !== Object.prototype.toString && u2222["toString"] !== globalThis.Array.prototype.toString) {
      return u2222["toString"]();
    }
  } catch {
  }
  return `Error: ${JSON.stringify(u2222)}`;
};
var locationRegex2222 = /\((.*)\)/;
var spanToTrace2222 = /* @__PURE__ */ globalValue22222("effect/Tracer/spanToTrace", () => /* @__PURE__ */ new WeakMap());
var prettyErrorStack2222 = (message, stack, span222) => {
  const out = [message];
  const lines = stack.split("\n");
  for (let i2222 = 1; i2222 < lines.length; i2222++) {
    if (lines[i2222].includes("Generator.next")) {
      break;
    }
    if (lines[i2222].includes("effect_internal_function")) {
      out.pop();
      break;
    }
    out.push(lines[i2222].replace(/at .*effect_instruction_i.*\((.*)\)/, "at $1").replace(/EffectPrimitive\.\w+/, "<anonymous>"));
  }
  if (span222) {
    let current = span222;
    let i2222 = 0;
    while (current && current._tag === "Span" && i2222 < 10) {
      const stackFn = spanToTrace2222.get(current);
      if (typeof stackFn === "function") {
        const stack2 = stackFn();
        const locationMatch = stack2.match(locationRegex2222);
        const location = locationMatch ? locationMatch[1] : stack2.replace(/^at /, "");
        out.push(`    at ${current.name} (${location})`);
      } else {
        out.push(`    at ${current.name}`);
      }
      current = getOrUndefined22222(current.parent);
      i2222++;
    }
  }
  return out.join("\n");
};
var spanSymbol3222 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var prettyErrors2222 = (cause) => reduceWithContext2222(cause, void 0, {
  emptyCase: () => [],
  dieCase: (_2222, unknownError) => {
    return [new PrettyError2222(unknownError)];
  },
  failCase: (_2222, error) => {
    return [new PrettyError2222(error)];
  },
  interruptCase: () => [],
  parallelCase: (_2222, l2222, r2222) => [...l2222, ...r2222],
  sequentialCase: (_2222, l2222, r2222) => [...l2222, ...r2222]
});
var SingleShotGen222222 = class _SingleShotGen22222 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  next(a2222) {
    return this.called ? {
      value: a2222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  return(a2222) {
    return {
      value: a2222,
      done: true
    };
  }
  throw(e2222) {
    throw e2222;
  }
  [Symbol.iterator]() {
    return new _SingleShotGen22222(this.self);
  }
};
var spanTag2222 = /* @__PURE__ */ GenericTag2222("effect/ParentSpan");
var EffectTypeId222222 = /* @__PURE__ */ Symbol.for("effect/Effect");
var EffectPrimitive2222 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId222222] = effectVariance22222;
  constructor(_op) {
    this._op = _op;
  }
  [symbol222222](that) {
    return this === that;
  }
  [symbol32222]() {
    return cached22222(this, random22222(this));
  }
  pipe() {
    return pipeArguments22222(this, arguments);
  }
  toJSON() {
    return {
      _id: "Effect",
      _op: this._op,
      effect_instruction_i0: toJSON22222(this.effect_instruction_i0),
      effect_instruction_i1: toJSON22222(this.effect_instruction_i1),
      effect_instruction_i2: toJSON22222(this.effect_instruction_i2)
    };
  }
  toString() {
    return format22222(this.toJSON());
  }
  [NodeInspectSymbol22222]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen222222(new YieldWrap22222(this));
  }
};
var EffectPrimitiveFailure2222 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId222222] = effectVariance22222;
  constructor(_op) {
    this._op = _op;
    this._tag = _op;
  }
  [symbol222222](that) {
    return exitIsExit2222(that) && that._op === "Failure" && // @ts-expect-error
    equals22222(this.effect_instruction_i0, that.effect_instruction_i0);
  }
  [symbol32222]() {
    return pipe22222(
      // @ts-expect-error
      string22222(this._tag),
      // @ts-expect-error
      combine22223(hash22222(this.effect_instruction_i0)),
      cached22222(this)
    );
  }
  get cause() {
    return this.effect_instruction_i0;
  }
  pipe() {
    return pipeArguments22222(this, arguments);
  }
  toJSON() {
    return {
      _id: "Exit",
      _tag: this._op,
      cause: this.cause.toJSON()
    };
  }
  toString() {
    return format22222(this.toJSON());
  }
  [NodeInspectSymbol22222]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen222222(new YieldWrap22222(this));
  }
};
var isEffect2222 = (u2222) => hasProperty22222(u2222, EffectTypeId222222);
var withFiberRuntime2222 = (withRuntime) => {
  const effect = new EffectPrimitive2222(OP_WITH_RUNTIME2222);
  effect.effect_instruction_i0 = withRuntime;
  return effect;
};
var spanSymbol22222 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var originalSymbol2222 = /* @__PURE__ */ Symbol.for("effect/OriginalAnnotation");
var capture2222 = (obj, span222) => {
  if (isSome222222(span222)) {
    return new Proxy(obj, {
      has(target, p2222) {
        return p2222 === spanSymbol22222 || p2222 === originalSymbol2222 || p2222 in target;
      },
      get(target, p2222) {
        if (p2222 === spanSymbol22222) {
          return span222.value;
        }
        if (p2222 === originalSymbol2222) {
          return obj;
        }
        return target[p2222];
      }
    });
  }
  return obj;
};
var fail22222 = (error) => isObject22222(error) && !(spanSymbol22222 in error) ? withFiberRuntime2222((fiber) => failCause2222(fail3222(capture2222(error, currentSpanFromFiber2222(fiber))))) : failCause2222(fail3222(error));
var failCause2222 = (cause) => {
  const effect = new EffectPrimitiveFailure2222(OP_FAILURE2222);
  effect.effect_instruction_i0 = cause;
  return effect;
};
var FiberRefSymbolKey2222 = "effect/FiberRef";
var FiberRefTypeId2222 = /* @__PURE__ */ Symbol.for(FiberRefSymbolKey2222);
var fiberRefVariance2222 = {
  /* c8 ignore next */
  _A: (_2222) => _2222
};
var fiberRefUnsafeMakeContext2222 = (initial) => {
  const differ = environment2222();
  return fiberRefUnsafeMakePatch2222(initial, {
    differ,
    fork: differ.empty
  });
};
var fiberRefUnsafeMakePatch2222 = (initial, options) => ({
  [FiberRefTypeId2222]: fiberRefVariance2222,
  initial,
  diff: (oldValue, newValue) => options.differ.diff(oldValue, newValue),
  combine: (first, second) => options.differ.combine(first, second),
  patch: (patch22222) => (oldValue) => options.differ.patch(patch22222, oldValue),
  fork: options.fork,
  join: options.join ?? ((_2222, n2222) => n2222),
  pipe() {
    return pipeArguments22222(this, arguments);
  }
});
var currentContext2222 = /* @__PURE__ */ globalValue22222(/* @__PURE__ */ Symbol.for("effect/FiberRef/currentContext"), () => fiberRefUnsafeMakeContext2222(empty22222()));
var YieldableError2222 = /* @__PURE__ */ function() {
  class YieldableError22222 extends globalThis.Error {
    commit() {
      return fail22222(this);
    }
    toString() {
      return this.message ? `${this.name}: ${this.message}` : this.name;
    }
    toJSON() {
      return {
        ...this
      };
    }
    [NodeInspectSymbol22222]() {
      const stack = this.stack;
      if (stack) {
        return `${this.toString()}
${stack.split("\n").slice(1).join("\n")}`;
      }
      return this.toString();
    }
  }
  Object.assign(YieldableError22222.prototype, StructuralCommitPrototype2222);
  return YieldableError22222;
}();
var exitIsExit2222 = (u2222) => isEffect2222(u2222) && "_tag" in u2222 && (u2222._tag === "Success" || u2222._tag === "Failure");
var currentSpanFromFiber2222 = (fiber) => {
  const span222 = fiber.getFiberRef(currentContext2222).unsafeMap.get(spanTag2222.key);
  return span222 !== void 0 && span222._tag === "Span" ? some322222(span222) : none222222();
};
var Data_exports2222 = {};
__export22223(Data_exports2222, {
  Class: () => Class22222,
  Error: () => Error22222,
  Structural: () => Structural22222,
  TaggedClass: () => TaggedClass2222,
  TaggedError: () => TaggedError2222,
  array: () => array22222,
  case: () => _case2222,
  struct: () => struct32222,
  tagged: () => tagged2222,
  taggedEnum: () => taggedEnum2222,
  tuple: () => tuple22222,
  unsafeArray: () => unsafeArray2222,
  unsafeStruct: () => unsafeStruct2222
});
var struct32222 = struct22222;
var unsafeStruct2222 = (as222222) => Object.setPrototypeOf(as222222, StructuralPrototype2222);
var tuple22222 = (...as222222) => unsafeArray2222(as222222);
var array22222 = (as222222) => unsafeArray2222(as222222.slice(0));
var unsafeArray2222 = (as222222) => Object.setPrototypeOf(as222222, ArrayProto2222);
var _case2222 = () => (args) => args === void 0 ? Object.create(StructuralPrototype2222) : struct32222(args);
var tagged2222 = (tag) => (args) => {
  const value = args === void 0 ? Object.create(StructuralPrototype2222) : struct32222(args);
  value._tag = tag;
  return value;
};
var Class22222 = Structural3222;
var TaggedClass2222 = (tag) => {
  class Base extends Class22222 {
    _tag = tag;
  }
  return Base;
};
var Structural22222 = Structural3222;
var taggedEnum2222 = () => new Proxy({}, {
  get(_target, tag, _receiver) {
    if (tag === "$is") {
      return isTagged33;
    } else if (tag === "$match") {
      return taggedMatch2222;
    }
    return tagged2222(tag);
  }
});
function taggedMatch2222() {
  if (arguments.length === 1) {
    const cases2 = arguments[0];
    return function(value2) {
      return cases2[value2._tag](value2);
    };
  }
  const value = arguments[0];
  const cases = arguments[1];
  return cases[value._tag](value);
}
var Error22222 = /* @__PURE__ */ function() {
  return class Base extends YieldableError2222 {
    constructor(args) {
      super();
      if (args) {
        Object.assign(this, args);
      }
    }
  };
}();
var TaggedError2222 = (tag) => {
  class Base extends Error22222 {
    _tag = tag;
  }
  Base.prototype.name = tag;
  return Base;
};
var traverseUp2222 = Function_exports22222.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType2222.Program) return Option_exports22222.none();
  return predicate(parent) ? Option_exports22222.some(parent) : traverseUp2222(parent, predicate);
});
var traverseUpGuard2222 = Function_exports22222.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType2222.Program) return Option_exports22222.none();
  return predicate(parent) ? Option_exports22222.some(parent) : traverseUpGuard2222(parent, predicate);
});
var ESLintCommunityESLintUtils2222;
((ESLintCommunityESLintUtils22222) => {
  ESLintCommunityESLintUtils22222.getFunctionHeadLocation = getFunctionHeadLocation2222;
  ESLintCommunityESLintUtils22222.getFunctionNameWithKind = getFunctionNameWithKind2222;
  ESLintCommunityESLintUtils22222.getPropertyName = getPropertyName2222;
  ESLintCommunityESLintUtils22222.getStaticValue = getStaticValue2222;
  ESLintCommunityESLintUtils22222.getStringIfConstant = getStringIfConstant2222;
  ESLintCommunityESLintUtils22222.hasSideEffect = hasSideEffect2222;
  ESLintCommunityESLintUtils22222.isParenthesized = isParenthesized2222;
})(ESLintCommunityESLintUtils2222 || (ESLintCommunityESLintUtils2222 = {}));
var Construction2222 = Data_exports2222.taggedEnum();
Construction2222.None();
a23({
  type: N23.union([NodeType2222.FunctionExpression, NodeType2222.ArrowFunctionExpression]),
  parent: {
    type: NodeType2222.Property,
    parent: {
      type: NodeType2222.ObjectExpression
    }
  }
});
a23({
  type: N23.union([NodeType2222.FunctionExpression, NodeType2222.ArrowFunctionExpression]),
  parent: {
    type: NodeType2222.MethodDefinition,
    parent: {
      type: NodeType2222.ClassBody
    }
  }
});
a23({
  type: N23.union([NodeType2222.FunctionExpression, NodeType2222.ArrowFunctionExpression]),
  parent: {
    type: NodeType2222.Property,
    parent: {
      type: NodeType2222.ClassBody
    }
  }
});
isOneOf223([NodeType223.Literal, NodeType223.JSXText]);
var Function_exports43 = {};
__export33(Function_exports43, {
  SK: () => SK43,
  absurd: () => absurd43,
  apply: () => apply43,
  compose: () => compose63,
  constFalse: () => constFalse43,
  constNull: () => constNull43,
  constTrue: () => constTrue43,
  constUndefined: () => constUndefined43,
  constVoid: () => constVoid43,
  constant: () => constant43,
  dual: () => dual43,
  flip: () => flip43,
  flow: () => flow43,
  hole: () => hole43,
  identity: () => identity43,
  isFunction: () => isFunction7,
  pipe: () => pipe43,
  satisfies: () => satisfies43,
  tupled: () => tupled43,
  unsafeCoerce: () => unsafeCoerce43,
  untupled: () => untupled43
});
var isFunction7 = (input) => typeof input === "function";
var dual43 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a322, b322) {
        if (arguments.length >= 2) {
          return body(a322, b322);
        }
        return function(self2) {
          return body(self2, a322);
        };
      };
    case 3:
      return function(a322, b322, c322) {
        if (arguments.length >= 3) {
          return body(a322, b322, c322);
        }
        return function(self2) {
          return body(self2, a322, b322);
        };
      };
    case 4:
      return function(a322, b322, c322, d322) {
        if (arguments.length >= 4) {
          return body(a322, b322, c322, d322);
        }
        return function(self2) {
          return body(self2, a322, b322, c322);
        };
      };
    case 5:
      return function(a322, b322, c322, d322, e322) {
        if (arguments.length >= 5) {
          return body(a322, b322, c322, d322, e322);
        }
        return function(self2) {
          return body(self2, a322, b322, c322, d322);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply43 = (a322) => (self2) => self2(a322);
var identity43 = (a322) => a322;
var satisfies43 = () => (b322) => b322;
var unsafeCoerce43 = identity43;
var constant43 = (value) => () => value;
var constTrue43 = /* @__PURE__ */ constant43(true);
var constFalse43 = /* @__PURE__ */ constant43(false);
var constNull43 = /* @__PURE__ */ constant43(null);
var constUndefined43 = /* @__PURE__ */ constant43(void 0);
var constVoid43 = constUndefined43;
var flip43 = (f322) => (...b322) => (...a322) => f322(...a322)(...b322);
var compose63 = /* @__PURE__ */ dual43(2, (ab, bc) => (a322) => bc(ab(a322)));
var absurd43 = (_322) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled43 = (f322) => (a322) => f322(...a322);
var untupled43 = (f322) => (...a322) => f322(a322);
function pipe43(a322, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a322;
    case 2:
      return ab(a322);
    case 3:
      return bc(ab(a322));
    case 4:
      return cd(bc(ab(a322)));
    case 5:
      return de(cd(bc(ab(a322))));
    case 6:
      return ef(de(cd(bc(ab(a322)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a322))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a322)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a322))))))));
    default: {
      let ret = arguments[0];
      for (let i322 = 1; i322 < arguments.length; i322++) {
        ret = arguments[i322](ret);
      }
      return ret;
    }
  }
}
function flow43(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole43 = /* @__PURE__ */ unsafeCoerce43(absurd43);
var SK43 = (_322, b322) => b322;
var make123 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_73 = (map722) => dual43(3, (self2, name22, f322) => map722(self2, (a322) => Object.assign({}, a322, {
  [name22]: f322(a322)
})));
var bindTo73 = (map722) => dual43(2, (self2, name22) => map722(self2, (a322) => ({
  [name22]: a322
})));
var bind73 = (map722, flatMap722) => dual43(3, (self2, name22, f322) => flatMap722(self2, (a322) => map722(f322(a322), (b322) => Object.assign({}, a322, {
  [name22]: b322
}))));
var moduleVersion43 = "3.2.8";
var getCurrentVersion43 = () => moduleVersion43;
var globalStoreId43 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion43()}`);
if (!(globalStoreId43 in globalThis)) {
  globalThis[globalStoreId43] = /* @__PURE__ */ new Map();
}
var globalStore43 = globalThis[globalStoreId43];
var globalValue43 = (id, compute) => {
  if (!globalStore43.has(id)) {
    globalStore43.set(id, compute());
  }
  return globalStore43.get(id);
};
var Predicate_exports33 = {};
__export33(Predicate_exports33, {
  all: () => all63,
  and: () => and43,
  compose: () => compose73,
  eqv: () => eqv43,
  every: () => every53,
  hasProperty: () => hasProperty43,
  implies: () => implies43,
  isBigInt: () => isBigInt43,
  isBoolean: () => isBoolean43,
  isDate: () => isDate43,
  isError: () => isError43,
  isFunction: () => isFunction82,
  isIterable: () => isIterable43,
  isMap: () => isMap43,
  isNever: () => isNever43,
  isNotNull: () => isNotNull43,
  isNotNullable: () => isNotNullable43,
  isNotUndefined: () => isNotUndefined43,
  isNull: () => isNull43,
  isNullable: () => isNullable43,
  isNumber: () => isNumber43,
  isObject: () => isObject43,
  isPromise: () => isPromise43,
  isPromiseLike: () => isPromiseLike43,
  isReadonlyRecord: () => isReadonlyRecord43,
  isRecord: () => isRecord43,
  isSet: () => isSet43,
  isString: () => isString43,
  isSymbol: () => isSymbol43,
  isTagged: () => isTagged43,
  isTruthy: () => isTruthy43,
  isUint8Array: () => isUint8Array43,
  isUndefined: () => isUndefined43,
  isUnknown: () => isUnknown43,
  mapInput: () => mapInput53,
  nand: () => nand43,
  nor: () => nor43,
  not: () => not43,
  or: () => or43,
  product: () => product63,
  productMany: () => productMany63,
  some: () => some93,
  struct: () => struct63,
  tuple: () => tuple53,
  xor: () => xor43
});
var mapInput53 = /* @__PURE__ */ dual43(2, (self2, f322) => (b322) => self2(f322(b322)));
var isTruthy43 = (input) => !!input;
var isSet43 = (input) => input instanceof Set;
var isMap43 = (input) => input instanceof Map;
var isString43 = (input) => typeof input === "string";
var isNumber43 = (input) => typeof input === "number";
var isBoolean43 = (input) => typeof input === "boolean";
var isBigInt43 = (input) => typeof input === "bigint";
var isSymbol43 = (input) => typeof input === "symbol";
var isFunction82 = isFunction7;
var isUndefined43 = (input) => input === void 0;
var isNotUndefined43 = (input) => input !== void 0;
var isNull43 = (input) => input === null;
var isNotNull43 = (input) => input !== null;
var isNever43 = (_322) => false;
var isUnknown43 = (_322) => true;
var isRecordOrArray43 = (input) => typeof input === "object" && input !== null;
var isObject43 = (input) => isRecordOrArray43(input) || isFunction82(input);
var hasProperty43 = /* @__PURE__ */ dual43(2, (self2, property) => isObject43(self2) && property in self2);
var isTagged43 = /* @__PURE__ */ dual43(2, (self2, tag) => hasProperty43(self2, "_tag") && self2["_tag"] === tag);
var isNullable43 = (input) => input === null || input === void 0;
var isNotNullable43 = (input) => input !== null && input !== void 0;
var isError43 = (input) => input instanceof Error;
var isUint8Array43 = (input) => input instanceof Uint8Array;
var isDate43 = (input) => input instanceof Date;
var isIterable43 = (input) => hasProperty43(input, Symbol.iterator);
var isRecord43 = (input) => isRecordOrArray43(input) && !Array.isArray(input);
var isReadonlyRecord43 = isRecord43;
var isPromise43 = (input) => hasProperty43(input, "then") && "catch" in input && isFunction82(input.then) && isFunction82(input.catch);
var isPromiseLike43 = (input) => hasProperty43(input, "then") && isFunction82(input.then);
var compose73 = /* @__PURE__ */ dual43(2, (ab, bc) => (a322) => ab(a322) && bc(a322));
var product63 = (self2, that) => ([a322, b322]) => self2(a322) && that(b322);
var all63 = (collection) => {
  return (as622) => {
    let collectionIndex = 0;
    for (const p322 of collection) {
      if (collectionIndex >= as622.length) {
        break;
      }
      if (p322(as622[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany63 = (self2, collection) => {
  const rest = all63(collection);
  return ([head322, ...tail322]) => self2(head322) === false ? false : rest(tail322);
};
var tuple53 = (...elements) => all63(elements);
var struct63 = (fields) => {
  const keys522 = Object.keys(fields);
  return (a322) => {
    for (const key of keys522) {
      if (!fields[key](a322[key])) {
        return false;
      }
    }
    return true;
  };
};
var not43 = (self2) => (a322) => !self2(a322);
var or43 = /* @__PURE__ */ dual43(2, (self2, that) => (a322) => self2(a322) || that(a322));
var and43 = /* @__PURE__ */ dual43(2, (self2, that) => (a322) => self2(a322) && that(a322));
var xor43 = /* @__PURE__ */ dual43(2, (self2, that) => (a322) => self2(a322) !== that(a322));
var eqv43 = /* @__PURE__ */ dual43(2, (self2, that) => (a322) => self2(a322) === that(a322));
var implies43 = /* @__PURE__ */ dual43(2, (self2, that) => (a322) => self2(a322) ? that(a322) : true);
var nor43 = /* @__PURE__ */ dual43(2, (self2, that) => (a322) => !(self2(a322) || that(a322)));
var nand43 = /* @__PURE__ */ dual43(2, (self2, that) => (a322) => !(self2(a322) && that(a322)));
var every53 = (collection) => (a322) => {
  for (const p322 of collection) {
    if (!p322(a322)) {
      return false;
    }
  }
  return true;
};
var some93 = (collection) => (a322) => {
  for (const p322 of collection) {
    if (p322(a322)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage43 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId43 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind43 = (u322) => isObject43(u322) && GenKindTypeId43 in u322;
var GenKindImpl43 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity43;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_322) => _322;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_322) => _322;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_322) => _322;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId43] = GenKindTypeId43;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen53(this);
  }
};
var SingleShotGen53 = class _SingleShotGen73 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a322) {
    return this.called ? {
      value: a322,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a322) {
    return {
      value: a322,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e322) {
    throw e322;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen73(this.self);
  }
};
var adapter63 = () => function() {
  let x322 = arguments[0];
  for (let i322 = 1; i322 < arguments.length; i322++) {
    x322 = arguments[i322](x322);
  }
  return new GenKindImpl43(x322);
};
var defaultIncHi43 = 335903614;
var defaultIncLo43 = 4150755663;
var MUL_HI43 = 1481765933 >>> 0;
var MUL_LO43 = 1284865837 >>> 0;
var BIT_5343 = 9007199254740992;
var BIT_2743 = 134217728;
var PCGRandom43 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable43(seedLo) && isNullable43(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable43(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable43(incLo) && isNullable43(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo43;
      incHi = this._state ? this._state[2] : defaultIncHi43;
    } else if (isNullable43(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add6443(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max322) {
    if (!max322) {
      return this._next();
    }
    max322 = max322 >>> 0;
    if ((max322 & max322 - 1) === 0) {
      return this._next() & max322 - 1;
    }
    let num = 0;
    const skew = (-max322 >>> 0) % max322 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max322;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_2743 + lo) / BIT_5343;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul6443(this._state, oldHi, oldLo, MUL_HI43, MUL_LO43);
    add6443(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul6443(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add6443(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId43 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap43 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId43]() {
    return this.#value;
  }
};
function yieldWrapGet43(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId43 in self2) {
    return self2[YieldWrapTypeId43]();
  }
  throw new Error(getBugErrorMessage43("yieldWrapGet"));
}
var structuralRegionState43 = /* @__PURE__ */ globalValue43("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache43 = /* @__PURE__ */ globalValue43(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr43 = /* @__PURE__ */ globalValue43(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom43());
var symbol63 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash43 = (self2) => {
  if (structuralRegionState43.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number53(self2);
    case "bigint":
      return string43(self2.toString(10));
    case "boolean":
      return string43(String(self2));
    case "symbol":
      return string43(String(self2));
    case "string":
      return string43(self2);
    case "undefined":
      return string43("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string43("null");
      } else if (self2 instanceof Date) {
        return hash43(self2.toISOString());
      } else if (isHash43(self2)) {
        return self2[symbol63]();
      } else {
        return random43(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random43 = (self2) => {
  if (!randomHashCache43.has(self2)) {
    randomHashCache43.set(self2, number53(pcgr43.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache43.get(self2);
};
var combine53 = (b322) => (self2) => self2 * 53 ^ b322;
var optimize43 = (n322) => n322 & 3221225471 | n322 >>> 1 & 1073741824;
var isHash43 = (u322) => hasProperty43(u322, symbol63);
var number53 = (n322) => {
  if (n322 !== n322 || n322 === Infinity) {
    return 0;
  }
  let h322 = n322 | 0;
  if (h322 !== n322) {
    h322 ^= n322 * 4294967295;
  }
  while (n322 > 4294967295) {
    h322 ^= n322 /= 4294967295;
  }
  return optimize43(n322);
};
var string43 = (str) => {
  let h322 = 5381, i322 = str.length;
  while (i322) {
    h322 = h322 * 33 ^ str.charCodeAt(--i322);
  }
  return optimize43(h322);
};
var cached43 = function() {
  if (arguments.length === 1) {
    const self3 = arguments[0];
    return function(hash722) {
      Object.defineProperty(self3, symbol63, {
        value() {
          return hash722;
        },
        enumerable: false
      });
      return hash722;
    };
  }
  const self2 = arguments[0];
  const hash622 = arguments[1];
  Object.defineProperty(self2, symbol63, {
    value() {
      return hash622;
    },
    enumerable: false
  });
  return hash622;
};
var symbol73 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals43() {
  if (arguments.length === 1) {
    return (self2) => compareBoth43(self2, arguments[0]);
  }
  return compareBoth43(arguments[0], arguments[1]);
}
function compareBoth43(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual43(self2) && isEqual43(that)) {
        if (hash43(self2) === hash43(that) && self2[symbol73](that)) {
          return true;
        } else {
          return structuralRegionState43.enabled && structuralRegionState43.tester ? structuralRegionState43.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState43.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v322, i322) => compareBoth43(v322, that[i322]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth43(self2[key], that[key]))) {
              return structuralRegionState43.tester ? structuralRegionState43.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState43.tester ? structuralRegionState43.tester(self2, that) : false;
    }
  }
  return structuralRegionState43.enabled && structuralRegionState43.tester ? structuralRegionState43.tester(self2, that) : false;
}
var isEqual43 = (u322) => hasProperty43(u322, symbol73);
var equivalence43 = () => equals43;
var NodeInspectSymbol43 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON43 = (x322) => {
  if (hasProperty43(x322, "toJSON") && isFunction82(x322["toJSON"]) && x322["toJSON"].length === 0) {
    return x322.toJSON();
  } else if (Array.isArray(x322)) {
    return x322.map(toJSON43);
  }
  return x322;
};
var format43 = (x322) => JSON.stringify(x322, null, 2);
var pipeArguments43 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i322 = 0, len = args.length; i322 < len; i322++) {
        ret = args[i322](ret);
      }
      return ret;
    }
  }
};
var EffectTypeId53 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId43 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId43 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId43 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance43 = {
  /* c8 ignore next */
  _R: (_322) => _322,
  /* c8 ignore next */
  _E: (_322) => _322,
  /* c8 ignore next */
  _A: (_322) => _322,
  _V: /* @__PURE__ */ getCurrentVersion43()
};
var sinkVariance43 = {
  /* c8 ignore next */
  _A: (_322) => _322,
  /* c8 ignore next */
  _In: (_322) => _322,
  /* c8 ignore next */
  _L: (_322) => _322,
  /* c8 ignore next */
  _E: (_322) => _322,
  /* c8 ignore next */
  _R: (_322) => _322
};
var channelVariance43 = {
  /* c8 ignore next */
  _Env: (_322) => _322,
  /* c8 ignore next */
  _InErr: (_322) => _322,
  /* c8 ignore next */
  _InElem: (_322) => _322,
  /* c8 ignore next */
  _InDone: (_322) => _322,
  /* c8 ignore next */
  _OutErr: (_322) => _322,
  /* c8 ignore next */
  _OutElem: (_322) => _322,
  /* c8 ignore next */
  _OutDone: (_322) => _322
};
var EffectPrototype43 = {
  [EffectTypeId53]: effectVariance43,
  [StreamTypeId43]: effectVariance43,
  [SinkTypeId43]: sinkVariance43,
  [ChannelTypeId43]: channelVariance43,
  [symbol73](that) {
    return this === that;
  },
  [symbol63]() {
    return cached43(this, random43(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen53(new YieldWrap43(this));
  },
  pipe() {
    return pipeArguments43(this, arguments);
  }
};
var TypeId103 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto63 = {
  ...EffectPrototype43,
  [TypeId103]: {
    _A: (_322) => _322
  },
  [NodeInspectSymbol43]() {
    return this.toJSON();
  },
  toString() {
    return format43(this.toJSON());
  }
};
var SomeProto43 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto63), {
  _tag: "Some",
  _op: "Some",
  [symbol73](that) {
    return isOption63(that) && isSome63(that) && equals43(this.value, that.value);
  },
  [symbol63]() {
    return cached43(this, combine53(hash43(this._tag))(hash43(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON43(this.value)
    };
  }
});
var NoneHash43 = /* @__PURE__ */ hash43("None");
var NoneProto43 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto63), {
  _tag: "None",
  _op: "None",
  [symbol73](that) {
    return isOption63(that) && isNone63(that);
  },
  [symbol63]() {
    return NoneHash43;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption63 = (input) => hasProperty43(input, TypeId103);
var isNone63 = (fa) => fa._tag === "None";
var isSome63 = (fa) => fa._tag === "Some";
var none63 = /* @__PURE__ */ Object.create(NoneProto43);
var some103 = (value) => {
  const a322 = Object.create(SomeProto43);
  a322.value = value;
  return a322;
};
var TypeId113 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto73 = {
  ...EffectPrototype43,
  [TypeId113]: {
    _R: (_322) => _322
  },
  [NodeInspectSymbol43]() {
    return this.toJSON();
  },
  toString() {
    return format43(this.toJSON());
  }
};
var RightProto43 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto73), {
  _tag: "Right",
  _op: "Right",
  [symbol73](that) {
    return isEither43(that) && isRight53(that) && equals43(this.right, that.right);
  },
  [symbol63]() {
    return combine53(hash43(this._tag))(hash43(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON43(this.right)
    };
  }
});
var LeftProto43 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto73), {
  _tag: "Left",
  _op: "Left",
  [symbol73](that) {
    return isEither43(that) && isLeft53(that) && equals43(this.left, that.left);
  },
  [symbol63]() {
    return combine53(hash43(this._tag))(hash43(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON43(this.left)
    };
  }
});
var isEither43 = (input) => hasProperty43(input, TypeId113);
var isLeft53 = (ma) => ma._tag === "Left";
var isRight53 = (ma) => ma._tag === "Right";
var left53 = (left722) => {
  const a322 = Object.create(LeftProto43);
  a322.left = left722;
  return a322;
};
var right53 = (right722) => {
  const a322 = Object.create(RightProto43);
  a322.right = right722;
  return a322;
};
var getLeft63 = (self2) => isRight53(self2) ? none63 : some103(self2.left);
var getRight63 = (self2) => isLeft53(self2) ? none63 : some103(self2.right);
var Option_exports43 = {};
__export33(Option_exports43, {
  Do: () => Do53,
  TypeId: () => TypeId122,
  all: () => all73,
  andThen: () => andThen43,
  ap: () => ap43,
  as: () => as43,
  asVoid: () => asVoid43,
  bind: () => bind83,
  bindTo: () => bindTo83,
  composeK: () => composeK43,
  contains: () => contains53,
  containsWith: () => containsWith53,
  exists: () => exists43,
  filter: () => filter53,
  filterMap: () => filterMap53,
  firstSomeOf: () => firstSomeOf43,
  flatMap: () => flatMap53,
  flatMapNullable: () => flatMapNullable53,
  flatten: () => flatten53,
  fromIterable: () => fromIterable63,
  fromNullable: () => fromNullable53,
  gen: () => gen43,
  getEquivalence: () => getEquivalence63,
  getLeft: () => getLeft73,
  getOrElse: () => getOrElse43,
  getOrNull: () => getOrNull43,
  getOrThrow: () => getOrThrow43,
  getOrThrowWith: () => getOrThrowWith43,
  getOrUndefined: () => getOrUndefined43,
  getOrder: () => getOrder53,
  getRight: () => getRight73,
  isNone: () => isNone73,
  isOption: () => isOption73,
  isSome: () => isSome73,
  let: () => let_83,
  lift2: () => lift243,
  liftNullable: () => liftNullable53,
  liftPredicate: () => liftPredicate53,
  liftThrowable: () => liftThrowable43,
  map: () => map53,
  match: () => match62,
  none: () => none73,
  orElse: () => orElse43,
  orElseEither: () => orElseEither43,
  orElseSome: () => orElseSome43,
  partitionMap: () => partitionMap53,
  product: () => product73,
  productMany: () => productMany73,
  reduceCompact: () => reduceCompact43,
  some: () => some112,
  tap: () => tap43,
  toArray: () => toArray43,
  toRefinement: () => toRefinement43,
  void: () => void_43,
  zipLeft: () => zipLeft43,
  zipRight: () => zipRight43,
  zipWith: () => zipWith53
});
var make133 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId122 = /* @__PURE__ */ Symbol.for("effect/Option");
var none73 = () => none63;
var some112 = some103;
var isOption73 = isOption63;
var isNone73 = isNone63;
var isSome73 = isSome63;
var match62 = /* @__PURE__ */ dual43(2, (self2, {
  onNone,
  onSome
}) => isNone73(self2) ? onNone() : onSome(self2.value));
var toRefinement43 = (f322) => (a322) => isSome73(f322(a322));
var fromIterable63 = (collection) => {
  for (const a322 of collection) {
    return some112(a322);
  }
  return none73();
};
var getRight73 = getRight63;
var getLeft73 = getLeft63;
var getOrElse43 = /* @__PURE__ */ dual43(2, (self2, onNone) => isNone73(self2) ? onNone() : self2.value);
var orElse43 = /* @__PURE__ */ dual43(2, (self2, that) => isNone73(self2) ? that() : self2);
var orElseSome43 = /* @__PURE__ */ dual43(2, (self2, onNone) => isNone73(self2) ? some112(onNone()) : self2);
var orElseEither43 = /* @__PURE__ */ dual43(2, (self2, that) => isNone73(self2) ? map53(that(), right53) : map53(self2, left53));
var firstSomeOf43 = (collection) => {
  let out = none73();
  for (out of collection) {
    if (isSome73(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable53 = (nullableValue) => nullableValue == null ? none73() : some112(nullableValue);
var liftNullable53 = (f322) => (...a322) => fromNullable53(f322(...a322));
var getOrNull43 = /* @__PURE__ */ getOrElse43(constNull43);
var getOrUndefined43 = /* @__PURE__ */ getOrElse43(constUndefined43);
var liftThrowable43 = (f322) => (...a322) => {
  try {
    return some112(f322(...a322));
  } catch (e322) {
    return none73();
  }
};
var getOrThrowWith43 = /* @__PURE__ */ dual43(2, (self2, onNone) => {
  if (isSome73(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow43 = /* @__PURE__ */ getOrThrowWith43(() => new Error("getOrThrow called on a None"));
var map53 = /* @__PURE__ */ dual43(2, (self2, f322) => isNone73(self2) ? none73() : some112(f322(self2.value)));
var as43 = /* @__PURE__ */ dual43(2, (self2, b322) => map53(self2, () => b322));
var asVoid43 = /* @__PURE__ */ as43(void 0);
var void_43 = /* @__PURE__ */ some112(void 0);
var flatMap53 = /* @__PURE__ */ dual43(2, (self2, f322) => isNone73(self2) ? none73() : f322(self2.value));
var andThen43 = /* @__PURE__ */ dual43(2, (self2, f322) => flatMap53(self2, (a322) => {
  const b322 = isFunction7(f322) ? f322(a322) : f322;
  return isOption73(b322) ? b322 : some112(b322);
}));
var flatMapNullable53 = /* @__PURE__ */ dual43(2, (self2, f322) => isNone73(self2) ? none73() : fromNullable53(f322(self2.value)));
var flatten53 = /* @__PURE__ */ flatMap53(identity43);
var zipRight43 = /* @__PURE__ */ dual43(2, (self2, that) => flatMap53(self2, () => that));
var composeK43 = /* @__PURE__ */ dual43(2, (afb, bfc) => (a322) => flatMap53(afb(a322), bfc));
var zipLeft43 = /* @__PURE__ */ dual43(2, (self2, that) => tap43(self2, () => that));
var tap43 = /* @__PURE__ */ dual43(2, (self2, f322) => flatMap53(self2, (a322) => map53(f322(a322), () => a322)));
var product73 = (self2, that) => isSome73(self2) && isSome73(that) ? some112([self2.value, that.value]) : none73();
var productMany73 = (self2, collection) => {
  if (isNone73(self2)) {
    return none73();
  }
  const out = [self2.value];
  for (const o322 of collection) {
    if (isNone73(o322)) {
      return none73();
    }
    out.push(o322.value);
  }
  return some112(out);
};
var all73 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o322 of input) {
      if (isNone73(o322)) {
        return none73();
      }
      out2.push(o322.value);
    }
    return some112(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o322 = input[key];
    if (isNone73(o322)) {
      return none73();
    }
    out[key] = o322.value;
  }
  return some112(out);
};
var zipWith53 = /* @__PURE__ */ dual43(3, (self2, that, f322) => map53(product73(self2, that), ([a322, b322]) => f322(a322, b322)));
var ap43 = /* @__PURE__ */ dual43(2, (self2, that) => zipWith53(self2, that, (f322, a322) => f322(a322)));
var reduceCompact43 = /* @__PURE__ */ dual43(3, (self2, b322, f322) => {
  let out = b322;
  for (const oa of self2) {
    if (isSome73(oa)) {
      out = f322(out, oa.value);
    }
  }
  return out;
});
var toArray43 = (self2) => isNone73(self2) ? [] : [self2.value];
var partitionMap53 = /* @__PURE__ */ dual43(2, (self2, f322) => {
  if (isNone73(self2)) {
    return [none73(), none73()];
  }
  const e322 = f322(self2.value);
  return isLeft53(e322) ? [some112(e322.left), none73()] : [none73(), some112(e322.right)];
});
var filterMap53 = /* @__PURE__ */ dual43(2, (self2, f322) => isNone73(self2) ? none73() : f322(self2.value));
var filter53 = /* @__PURE__ */ dual43(2, (self2, predicate) => filterMap53(self2, (b322) => predicate(b322) ? some103(b322) : none63));
var getEquivalence63 = (isEquivalent) => make123((x322, y322) => x322 === y322 || (isNone73(x322) ? isNone73(y322) : isNone73(y322) ? false : isEquivalent(x322.value, y322.value)));
var getOrder53 = (O322) => make133((self2, that) => isSome73(self2) ? isSome73(that) ? O322(self2.value, that.value) : 1 : -1);
var lift243 = (f322) => dual43(2, (self2, that) => zipWith53(self2, that, f322));
var liftPredicate53 = (predicate) => (b322) => predicate(b322) ? some112(b322) : none73();
var containsWith53 = (isEquivalent) => dual43(2, (self2, a322) => isNone73(self2) ? false : isEquivalent(self2.value, a322));
var _equivalence63 = /* @__PURE__ */ equivalence43();
var contains53 = /* @__PURE__ */ containsWith53(_equivalence63);
var exists43 = /* @__PURE__ */ dual43(2, (self2, refinement) => isNone73(self2) ? false : refinement(self2.value));
var bindTo83 = /* @__PURE__ */ bindTo73(map53);
var let_83 = /* @__PURE__ */ let_73(map53);
var bind83 = /* @__PURE__ */ bind73(map53, flatMap53);
var Do53 = /* @__PURE__ */ some112({});
var adapter73 = /* @__PURE__ */ adapter63();
var gen43 = (f322) => {
  const iterator = f322(adapter73);
  let state = iterator.next();
  if (state.done) {
    return some112(state.value);
  } else {
    let current = state.value;
    if (isGenKind43(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet43(current);
    }
    if (isNone73(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind43(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet43(current);
        }
        if (isNone73(current)) {
          return current;
        }
      }
    }
    return some112(state.value);
  }
};
var MutableRef_exports6 = {};
__export33(MutableRef_exports6, {
  compareAndSet: () => compareAndSet23,
  decrement: () => decrement23,
  decrementAndGet: () => decrementAndGet23,
  get: () => get33,
  getAndDecrement: () => getAndDecrement23,
  getAndIncrement: () => getAndIncrement23,
  getAndSet: () => getAndSet23,
  getAndUpdate: () => getAndUpdate23,
  increment: () => increment23,
  incrementAndGet: () => incrementAndGet23,
  make: () => make142,
  set: () => set33,
  setAndGet: () => setAndGet23,
  toggle: () => toggle23,
  update: () => update23,
  updateAndGet: () => updateAndGet23
});
var TypeId132 = /* @__PURE__ */ Symbol.for("effect/MutableRef");
var MutableRefProto23 = {
  [TypeId132]: TypeId132,
  toString() {
    return format43(this.toJSON());
  },
  toJSON() {
    return {
      _id: "MutableRef",
      current: toJSON43(this.current)
    };
  },
  [NodeInspectSymbol43]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments43(this, arguments);
  }
};
var make142 = (value) => {
  const ref = Object.create(MutableRefProto23);
  ref.current = value;
  return ref;
};
var compareAndSet23 = /* @__PURE__ */ dual43(3, (self2, oldValue, newValue) => {
  if (equals43(oldValue, self2.current)) {
    self2.current = newValue;
    return true;
  }
  return false;
});
var decrement23 = (self2) => update23(self2, (n322) => n322 - 1);
var decrementAndGet23 = (self2) => updateAndGet23(self2, (n322) => n322 - 1);
var get33 = (self2) => self2.current;
var getAndDecrement23 = (self2) => getAndUpdate23(self2, (n322) => n322 - 1);
var getAndIncrement23 = (self2) => getAndUpdate23(self2, (n322) => n322 + 1);
var getAndSet23 = /* @__PURE__ */ dual43(2, (self2, value) => {
  const ret = self2.current;
  self2.current = value;
  return ret;
});
var getAndUpdate23 = /* @__PURE__ */ dual43(2, (self2, f322) => getAndSet23(self2, f322(get33(self2))));
var increment23 = (self2) => update23(self2, (n322) => n322 + 1);
var incrementAndGet23 = (self2) => updateAndGet23(self2, (n322) => n322 + 1);
var set33 = /* @__PURE__ */ dual43(2, (self2, value) => {
  self2.current = value;
  return self2;
});
var setAndGet23 = /* @__PURE__ */ dual43(2, (self2, value) => {
  self2.current = value;
  return self2.current;
});
var update23 = /* @__PURE__ */ dual43(2, (self2, f322) => set33(self2, f322(get33(self2))));
var updateAndGet23 = /* @__PURE__ */ dual43(2, (self2, f322) => setAndGet23(self2, f322(get33(self2))));
var toggle23 = (self2) => update23(self2, (_322) => !_322);
var MutableList_exports3 = {};
__export33(MutableList_exports3, {
  append: () => append23,
  empty: () => empty113,
  forEach: () => forEach53,
  fromIterable: () => fromIterable73,
  head: () => head23,
  isEmpty: () => isEmpty33,
  length: () => length23,
  make: () => make152,
  pop: () => pop4,
  prepend: () => prepend43,
  reset: () => reset3,
  shift: () => shift3,
  tail: () => tail23
});
var TypeId142 = /* @__PURE__ */ Symbol.for("effect/MutableList");
var MutableListProto3 = {
  [TypeId142]: TypeId142,
  [Symbol.iterator]() {
    let done = false;
    let head322 = this.head;
    return {
      next() {
        if (done) {
          return this.return();
        }
        if (head322 == null) {
          done = true;
          return this.return();
        }
        const value = head322.value;
        head322 = head322.next;
        return {
          done,
          value
        };
      },
      return(value) {
        if (!done) {
          done = true;
        }
        return {
          done: true,
          value
        };
      }
    };
  },
  toString() {
    return format43(this.toJSON());
  },
  toJSON() {
    return {
      _id: "MutableList",
      values: Array.from(this).map(toJSON43)
    };
  },
  [NodeInspectSymbol43]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments43(this, arguments);
  }
};
var makeNode3 = (value) => ({
  value,
  removed: false,
  prev: void 0,
  next: void 0
});
var empty113 = () => {
  const list = Object.create(MutableListProto3);
  list.head = void 0;
  list.tail = void 0;
  list._length = 0;
  return list;
};
var fromIterable73 = (iterable) => {
  const list = empty113();
  for (const element of iterable) {
    append23(list, element);
  }
  return list;
};
var make152 = (...elements) => fromIterable73(elements);
var isEmpty33 = (self2) => length23(self2) === 0;
var length23 = (self2) => self2._length;
var tail23 = (self2) => self2.tail === void 0 ? void 0 : self2.tail.value;
var head23 = (self2) => self2.head === void 0 ? void 0 : self2.head.value;
var forEach53 = /* @__PURE__ */ dual43(2, (self2, f322) => {
  let current = self2.head;
  while (current !== void 0) {
    f322(current.value);
    current = current.next;
  }
});
var reset3 = (self2) => {
  self2._length = 0;
  self2.head = void 0;
  self2.tail = void 0;
  return self2;
};
var append23 = /* @__PURE__ */ dual43(2, (self2, value) => {
  const node = makeNode3(value);
  if (self2.head === void 0) {
    self2.head = node;
  }
  if (self2.tail === void 0) {
    self2.tail = node;
  } else {
    self2.tail.next = node;
    node.prev = self2.tail;
    self2.tail = node;
  }
  self2._length += 1;
  return self2;
});
var shift3 = (self2) => {
  const head322 = self2.head;
  if (head322 !== void 0) {
    remove23(self2, head322);
    return head322.value;
  }
  return void 0;
};
var pop4 = (self2) => {
  const tail322 = self2.tail;
  if (tail322 !== void 0) {
    remove23(self2, tail322);
    return tail322.value;
  }
  return void 0;
};
var prepend43 = /* @__PURE__ */ dual43(2, (self2, value) => {
  const node = makeNode3(value);
  node.next = self2.head;
  if (self2.head !== void 0) {
    self2.head.prev = node;
  }
  self2.head = node;
  if (self2.tail === void 0) {
    self2.tail = node;
  }
  self2._length += 1;
  return self2;
});
var remove23 = (self2, node) => {
  if (node.removed) {
    return;
  }
  node.removed = true;
  if (node.prev !== void 0 && node.next !== void 0) {
    node.prev.next = node.next;
    node.next.prev = node.prev;
  } else if (node.prev !== void 0) {
    self2.tail = node.prev;
    node.prev.next = void 0;
  } else if (node.next !== void 0) {
    self2.head = node.next;
    node.next.prev = void 0;
  } else {
    self2.tail = void 0;
    self2.head = void 0;
  }
  if (self2._length > 0) {
    self2._length -= 1;
  }
};
var store23;
function getGlobalMessage3(lang) {
  return store23?.get(lang);
}
var store33;
function getSchemaMessage3(lang) {
  return store33?.get(lang);
}
var store43;
function getSpecificMessage3(reference, lang) {
  return store43?.get(reference)?.get(lang);
}
function _stringify3(input) {
  let type = typeof input;
  if (type === "object") {
    type = (input && Object.getPrototypeOf(input)?.constructor?.name) ?? "null";
  }
  return type === "string" ? `"${input}"` : type === "number" || type === "bigint" || type === "boolean" ? `${input}` : type;
}
function _addIssue3(context, label, dataset, config2, other) {
  const input = dataset.value;
  const expected = context.expects;
  const received = _stringify3(input);
  const issue = {
    kind: context.kind,
    type: context.type,
    input,
    expected,
    received,
    message: `Invalid ${label}: ${expected ? `Expected ${expected} but r` : "R"}eceived ${received}`,
    // @ts-expect-error
    requirement: context.requirement,
    path: other?.path,
    issues: other?.issues,
    lang: config2.lang,
    abortEarly: config2.abortEarly,
    abortPipeEarly: config2.abortPipeEarly,
    skipPipe: config2.skipPipe
  };
  const isSchema = context.kind === "schema";
  const message = (
    // @ts-expect-error
    context.message ?? getSpecificMessage3(context.reference, issue.lang) ?? (isSchema ? getSchemaMessage3(issue.lang) : null) ?? config2.message ?? getGlobalMessage3(issue.lang)
  );
  if (message) {
    issue.message = typeof message === "function" ? message(issue) : message;
  }
  if (isSchema) {
    dataset.typed = false;
  }
  if (dataset.issues) {
    dataset.issues.push(issue);
  } else {
    dataset.issues = [issue];
  }
}
function getDefault3(schema4, dataset, config2) {
  return typeof schema4.default === "function" ? (
    // @ts-expect-error
    schema4.default(dataset, config2)
  ) : (
    // @ts-expect-error
    schema4.default
  );
}
function array63(item, message) {
  return {
    kind: "schema",
    type: "array",
    reference: array63,
    expects: "Array",
    async: false,
    item,
    message,
    _run(dataset, config2) {
      const input = dataset.value;
      if (Array.isArray(input)) {
        dataset.typed = true;
        dataset.value = [];
        for (let key = 0; key < input.length; key++) {
          const value2 = input[key];
          const itemDataset = this.item._run({ typed: false, value: value2 }, config2);
          if (itemDataset.issues) {
            const pathItem = {
              type: "array",
              origin: "value",
              input,
              key,
              value: value2
            };
            for (const issue of itemDataset.issues) {
              if (issue.path) {
                issue.path.unshift(pathItem);
              } else {
                issue.path = [pathItem];
              }
              dataset.issues?.push(issue);
            }
            if (!dataset.issues) {
              dataset.issues = itemDataset.issues;
            }
            if (config2.abortEarly) {
              dataset.typed = false;
              break;
            }
          }
          if (!itemDataset.typed) {
            dataset.typed = false;
          }
          dataset.value.push(itemDataset.value);
        }
      } else {
        _addIssue3(this, "type", dataset, config2);
      }
      return dataset;
    }
  };
}
function object3(entries2, message) {
  return {
    kind: "schema",
    type: "object",
    reference: object3,
    expects: "Object",
    async: false,
    entries: entries2,
    message,
    _run(dataset, config2) {
      const input = dataset.value;
      if (input && typeof input === "object") {
        dataset.typed = true;
        dataset.value = {};
        for (const key in this.entries) {
          const value2 = input[key];
          const valueDataset = this.entries[key]._run(
            { typed: false, value: value2 },
            config2
          );
          if (valueDataset.issues) {
            const pathItem = {
              type: "object",
              origin: "value",
              input,
              key,
              value: value2
            };
            for (const issue of valueDataset.issues) {
              if (issue.path) {
                issue.path.unshift(pathItem);
              } else {
                issue.path = [pathItem];
              }
              dataset.issues?.push(issue);
            }
            if (!dataset.issues) {
              dataset.issues = valueDataset.issues;
            }
            if (config2.abortEarly) {
              dataset.typed = false;
              break;
            }
          }
          if (!valueDataset.typed) {
            dataset.typed = false;
          }
          if (valueDataset.value !== void 0 || key in input) {
            dataset.value[key] = valueDataset.value;
          }
        }
      } else {
        _addIssue3(this, "type", dataset, config2);
      }
      return dataset;
    }
  };
}
function optional3(wrapped, ...args) {
  const schema4 = {
    kind: "schema",
    type: "optional",
    reference: optional3,
    expects: `${wrapped.expects} | undefined`,
    async: false,
    wrapped,
    _run(dataset, config2) {
      if (dataset.value === void 0) {
        if ("default" in this) {
          dataset.value = getDefault3(
            this,
            dataset,
            config2
          );
        }
        if (dataset.value === void 0) {
          dataset.typed = true;
          return dataset;
        }
      }
      return this.wrapped._run(dataset, config2);
    }
  };
  if (0 in args) {
    schema4.default = args[0];
  }
  return schema4;
}
function string53(message) {
  return {
    kind: "schema",
    type: "string",
    reference: string53,
    expects: "string",
    async: false,
    message,
    _run(dataset, config2) {
      if (typeof dataset.value === "string") {
        dataset.typed = true;
      } else {
        _addIssue3(this, "type", dataset, config2);
      }
      return dataset;
    }
  };
}
var ESLintReactSettingsSchema3 = object3({
  additionalHooks: optional3(object3({
    use: optional3(string53()),
    useCallback: optional3(array63(string53())),
    useContext: optional3(array63(string53())),
    useDebugValue: optional3(array63(string53())),
    useDeferredValue: optional3(array63(string53())),
    useEffect: optional3(array63(string53())),
    useId: optional3(array63(string53())),
    useImperativeHandle: optional3(array63(string53())),
    useInsertionEffect: optional3(array63(string53())),
    useLayoutEffect: optional3(array63(string53())),
    useMemo: optional3(array63(string53())),
    useOptimistic: optional3(array63(string53())),
    useReducer: optional3(array63(string53())),
    useRef: optional3(array63(string53())),
    useState: optional3(array63(string53())),
    useSyncExternalStore: optional3(array63(string53())),
    useTransition: optional3(array63(string53()))
  })),
  importSource: optional3(string53()),
  jsxPragma: optional3(string53()),
  jsxPragmaFrag: optional3(string53()),
  version: optional3(string53())
});
var ESLintSettingsSchema = object3({
  reactOptions: optional3(ESLintReactSettingsSchema3)
});
var __defProp43 = Object.defineProperty;
var __export43 = (target, all3322) => {
  for (var name22 in all3322)
    __defProp43(target, name22, { get: all3322[name22], enumerable: true });
};
var Function_exports53 = {};
__export43(Function_exports53, {
  SK: () => SK53,
  absurd: () => absurd53,
  apply: () => apply53,
  compose: () => compose82,
  constFalse: () => constFalse53,
  constNull: () => constNull53,
  constTrue: () => constTrue53,
  constUndefined: () => constUndefined53,
  constVoid: () => constVoid53,
  constant: () => constant53,
  dual: () => dual53,
  flip: () => flip53,
  flow: () => flow53,
  hole: () => hole53,
  identity: () => identity53,
  isFunction: () => isFunction92,
  pipe: () => pipe53,
  satisfies: () => satisfies53,
  tupled: () => tupled53,
  unsafeCoerce: () => unsafeCoerce53,
  untupled: () => untupled53
});
var isFunction92 = (input) => typeof input === "function";
var dual53 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a2222, b2222) {
        if (arguments.length >= 2) {
          return body(a2222, b2222);
        }
        return function(self2) {
          return body(self2, a2222);
        };
      };
    case 3:
      return function(a2222, b2222, c2222) {
        if (arguments.length >= 3) {
          return body(a2222, b2222, c2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222);
        };
      };
    case 4:
      return function(a2222, b2222, c2222, d2222) {
        if (arguments.length >= 4) {
          return body(a2222, b2222, c2222, d2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222);
        };
      };
    case 5:
      return function(a2222, b2222, c2222, d2222, e2222) {
        if (arguments.length >= 5) {
          return body(a2222, b2222, c2222, d2222, e2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222, d2222);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply53 = (a2222) => (self2) => self2(a2222);
var identity53 = (a2222) => a2222;
var satisfies53 = () => (b2222) => b2222;
var unsafeCoerce53 = identity53;
var constant53 = (value) => () => value;
var constTrue53 = /* @__PURE__ */ constant53(true);
var constFalse53 = /* @__PURE__ */ constant53(false);
var constNull53 = /* @__PURE__ */ constant53(null);
var constUndefined53 = /* @__PURE__ */ constant53(void 0);
var constVoid53 = constUndefined53;
var flip53 = (f2222) => (...b2222) => (...a2222) => f2222(...a2222)(...b2222);
var compose82 = /* @__PURE__ */ dual53(2, (ab, bc) => (a2222) => bc(ab(a2222)));
var absurd53 = (_2222) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled53 = (f2222) => (a2222) => f2222(...a2222);
var untupled53 = (f2222) => (...a2222) => f2222(a2222);
function pipe53(a2222, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a2222;
    case 2:
      return ab(a2222);
    case 3:
      return bc(ab(a2222));
    case 4:
      return cd(bc(ab(a2222)));
    case 5:
      return de(cd(bc(ab(a2222))));
    case 6:
      return ef(de(cd(bc(ab(a2222)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a2222))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a2222)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a2222))))))));
    default: {
      let ret = arguments[0];
      for (let i2222 = 1; i2222 < arguments.length; i2222++) {
        ret = arguments[i2222](ret);
      }
      return ret;
    }
  }
}
function flow53(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole53 = /* @__PURE__ */ unsafeCoerce53(absurd53);
var SK53 = (_2222, b2222) => b2222;
var make162 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_92 = (map3222) => dual53(3, (self2, name22, f2222) => map3222(self2, (a2222) => Object.assign({}, a2222, {
  [name22]: f2222(a2222)
})));
var bindTo92 = (map3222) => dual53(2, (self2, name22) => map3222(self2, (a2222) => ({
  [name22]: a2222
})));
var bind92 = (map3222, flatMap3222) => dual53(3, (self2, name22, f2222) => flatMap3222(self2, (a2222) => map3222(f2222(a2222), (b2222) => Object.assign({}, a2222, {
  [name22]: b2222
}))));
var moduleVersion53 = "3.2.8";
var getCurrentVersion53 = () => moduleVersion53;
var globalStoreId53 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion53()}`);
if (!(globalStoreId53 in globalThis)) {
  globalThis[globalStoreId53] = /* @__PURE__ */ new Map();
}
var globalStore53 = globalThis[globalStoreId53];
var globalValue53 = (id, compute) => {
  if (!globalStore53.has(id)) {
    globalStore53.set(id, compute());
  }
  return globalStore53.get(id);
};
var isFunction233 = isFunction92;
var isRecordOrArray53 = (input) => typeof input === "object" && input !== null;
var isObject53 = (input) => isRecordOrArray53(input) || isFunction233(input);
var hasProperty53 = /* @__PURE__ */ dual53(2, (self2, property) => isObject53(self2) && property in self2);
var isNullable53 = (input) => input === null || input === void 0;
var getBugErrorMessage53 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId53 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind53 = (u2222) => isObject53(u2222) && GenKindTypeId53 in u2222;
var GenKindImpl53 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity53;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId53] = GenKindTypeId53;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen63(this);
  }
};
var SingleShotGen63 = class _SingleShotGen332 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a2222) {
    return this.called ? {
      value: a2222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a2222) {
    return {
      value: a2222,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e2222) {
    throw e2222;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen332(this.self);
  }
};
var adapter82 = () => function() {
  let x2222 = arguments[0];
  for (let i2222 = 1; i2222 < arguments.length; i2222++) {
    x2222 = arguments[i2222](x2222);
  }
  return new GenKindImpl53(x2222);
};
var defaultIncHi53 = 335903614;
var defaultIncLo53 = 4150755663;
var MUL_HI53 = 1481765933 >>> 0;
var MUL_LO53 = 1284865837 >>> 0;
var BIT_5353 = 9007199254740992;
var BIT_2753 = 134217728;
var PCGRandom53 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable53(seedLo) && isNullable53(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable53(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable53(incLo) && isNullable53(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo53;
      incHi = this._state ? this._state[2] : defaultIncHi53;
    } else if (isNullable53(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add6453(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max322) {
    if (!max322) {
      return this._next();
    }
    max322 = max322 >>> 0;
    if ((max322 & max322 - 1) === 0) {
      return this._next() & max322 - 1;
    }
    let num = 0;
    const skew = (-max322 >>> 0) % max322 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max322;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_2753 + lo) / BIT_5353;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul6453(this._state, oldHi, oldLo, MUL_HI53, MUL_LO53);
    add6453(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul6453(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add6453(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId53 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap53 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId53]() {
    return this.#value;
  }
};
function yieldWrapGet53(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId53 in self2) {
    return self2[YieldWrapTypeId53]();
  }
  throw new Error(getBugErrorMessage53("yieldWrapGet"));
}
var structuralRegionState53 = /* @__PURE__ */ globalValue53("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache53 = /* @__PURE__ */ globalValue53(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr53 = /* @__PURE__ */ globalValue53(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom53());
var symbol82 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash53 = (self2) => {
  if (structuralRegionState53.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number63(self2);
    case "bigint":
      return string63(self2.toString(10));
    case "boolean":
      return string63(String(self2));
    case "symbol":
      return string63(String(self2));
    case "string":
      return string63(self2);
    case "undefined":
      return string63("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string63("null");
      } else if (self2 instanceof Date) {
        return hash53(self2.toISOString());
      } else if (isHash53(self2)) {
        return self2[symbol82]();
      } else {
        return random53(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random53 = (self2) => {
  if (!randomHashCache53.has(self2)) {
    randomHashCache53.set(self2, number63(pcgr53.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache53.get(self2);
};
var combine63 = (b2222) => (self2) => self2 * 53 ^ b2222;
var optimize53 = (n2222) => n2222 & 3221225471 | n2222 >>> 1 & 1073741824;
var isHash53 = (u2222) => hasProperty53(u2222, symbol82);
var number63 = (n2222) => {
  if (n2222 !== n2222 || n2222 === Infinity) {
    return 0;
  }
  let h2222 = n2222 | 0;
  if (h2222 !== n2222) {
    h2222 ^= n2222 * 4294967295;
  }
  while (n2222 > 4294967295) {
    h2222 ^= n2222 /= 4294967295;
  }
  return optimize53(n2222);
};
var string63 = (str) => {
  let h2222 = 5381, i2222 = str.length;
  while (i2222) {
    h2222 = h2222 * 33 ^ str.charCodeAt(--i2222);
  }
  return optimize53(h2222);
};
var cached53 = function() {
  if (arguments.length === 1) {
    const self3 = arguments[0];
    return function(hash422) {
      Object.defineProperty(self3, symbol82, {
        value() {
          return hash422;
        },
        enumerable: false
      });
      return hash422;
    };
  }
  const self2 = arguments[0];
  const hash3222 = arguments[1];
  Object.defineProperty(self2, symbol82, {
    value() {
      return hash3222;
    },
    enumerable: false
  });
  return hash3222;
};
var symbol233 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals53() {
  if (arguments.length === 1) {
    return (self2) => compareBoth53(self2, arguments[0]);
  }
  return compareBoth53(arguments[0], arguments[1]);
}
function compareBoth53(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual53(self2) && isEqual53(that)) {
        if (hash53(self2) === hash53(that) && self2[symbol233](that)) {
          return true;
        } else {
          return structuralRegionState53.enabled && structuralRegionState53.tester ? structuralRegionState53.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState53.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v2222, i2222) => compareBoth53(v2222, that[i2222]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth53(self2[key], that[key]))) {
              return structuralRegionState53.tester ? structuralRegionState53.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState53.tester ? structuralRegionState53.tester(self2, that) : false;
    }
  }
  return structuralRegionState53.enabled && structuralRegionState53.tester ? structuralRegionState53.tester(self2, that) : false;
}
var isEqual53 = (u2222) => hasProperty53(u2222, symbol233);
var equivalence53 = () => equals53;
var NodeInspectSymbol53 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON53 = (x2222) => {
  if (hasProperty53(x2222, "toJSON") && isFunction233(x2222["toJSON"]) && x2222["toJSON"].length === 0) {
    return x2222.toJSON();
  } else if (Array.isArray(x2222)) {
    return x2222.map(toJSON53);
  }
  return x2222;
};
var format53 = (x2222) => JSON.stringify(x2222, null, 2);
var pipeArguments53 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i2222 = 0, len = args.length; i2222 < len; i2222++) {
        ret = args[i2222](ret);
      }
      return ret;
    }
  }
};
var EffectTypeId63 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId53 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId53 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId53 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance53 = {
  /* c8 ignore next */
  _R: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _A: (_2222) => _2222,
  _V: /* @__PURE__ */ getCurrentVersion53()
};
var sinkVariance53 = {
  /* c8 ignore next */
  _A: (_2222) => _2222,
  /* c8 ignore next */
  _In: (_2222) => _2222,
  /* c8 ignore next */
  _L: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _R: (_2222) => _2222
};
var channelVariance53 = {
  /* c8 ignore next */
  _Env: (_2222) => _2222,
  /* c8 ignore next */
  _InErr: (_2222) => _2222,
  /* c8 ignore next */
  _InElem: (_2222) => _2222,
  /* c8 ignore next */
  _InDone: (_2222) => _2222,
  /* c8 ignore next */
  _OutErr: (_2222) => _2222,
  /* c8 ignore next */
  _OutElem: (_2222) => _2222,
  /* c8 ignore next */
  _OutDone: (_2222) => _2222
};
var EffectPrototype53 = {
  [EffectTypeId63]: effectVariance53,
  [StreamTypeId53]: effectVariance53,
  [SinkTypeId53]: sinkVariance53,
  [ChannelTypeId53]: channelVariance53,
  [symbol233](that) {
    return this === that;
  },
  [symbol82]() {
    return cached53(this, random53(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen63(new YieldWrap53(this));
  },
  pipe() {
    return pipeArguments53(this, arguments);
  }
};
var TypeId152 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto82 = {
  ...EffectPrototype53,
  [TypeId152]: {
    _A: (_2222) => _2222
  },
  [NodeInspectSymbol53]() {
    return this.toJSON();
  },
  toString() {
    return format53(this.toJSON());
  }
};
var SomeProto53 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto82), {
  _tag: "Some",
  _op: "Some",
  [symbol233](that) {
    return isOption82(that) && isSome82(that) && equals53(this.value, that.value);
  },
  [symbol82]() {
    return cached53(this, combine63(hash53(this._tag))(hash53(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON53(this.value)
    };
  }
});
var NoneHash53 = /* @__PURE__ */ hash53("None");
var NoneProto53 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto82), {
  _tag: "None",
  _op: "None",
  [symbol233](that) {
    return isOption82(that) && isNone82(that);
  },
  [symbol82]() {
    return NoneHash53;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption82 = (input) => hasProperty53(input, TypeId152);
var isNone82 = (fa) => fa._tag === "None";
var isSome82 = (fa) => fa._tag === "Some";
var none82 = /* @__PURE__ */ Object.create(NoneProto53);
var some122 = (value) => {
  const a2222 = Object.create(SomeProto53);
  a2222.value = value;
  return a2222;
};
var TypeId233 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto233 = {
  ...EffectPrototype53,
  [TypeId233]: {
    _R: (_2222) => _2222
  },
  [NodeInspectSymbol53]() {
    return this.toJSON();
  },
  toString() {
    return format53(this.toJSON());
  }
};
var RightProto53 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto233), {
  _tag: "Right",
  _op: "Right",
  [symbol233](that) {
    return isEither53(that) && isRight63(that) && equals53(this.right, that.right);
  },
  [symbol82]() {
    return combine63(hash53(this._tag))(hash53(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON53(this.right)
    };
  }
});
var LeftProto53 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto233), {
  _tag: "Left",
  _op: "Left",
  [symbol233](that) {
    return isEither53(that) && isLeft63(that) && equals53(this.left, that.left);
  },
  [symbol82]() {
    return combine63(hash53(this._tag))(hash53(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON53(this.left)
    };
  }
});
var isEither53 = (input) => hasProperty53(input, TypeId233);
var isLeft63 = (ma) => ma._tag === "Left";
var isRight63 = (ma) => ma._tag === "Right";
var left63 = (left3322) => {
  const a2222 = Object.create(LeftProto53);
  a2222.left = left3322;
  return a2222;
};
var right63 = (right3322) => {
  const a2222 = Object.create(RightProto53);
  a2222.right = right3322;
  return a2222;
};
var getLeft82 = (self2) => isRight63(self2) ? none82 : some122(self2.left);
var getRight82 = (self2) => isLeft63(self2) ? none82 : some122(self2.right);
var Option_exports53 = {};
__export43(Option_exports53, {
  Do: () => Do63,
  TypeId: () => TypeId333,
  all: () => all82,
  andThen: () => andThen53,
  ap: () => ap53,
  as: () => as53,
  asVoid: () => asVoid53,
  bind: () => bind233,
  bindTo: () => bindTo233,
  composeK: () => composeK53,
  contains: () => contains63,
  containsWith: () => containsWith63,
  exists: () => exists53,
  filter: () => filter63,
  filterMap: () => filterMap63,
  firstSomeOf: () => firstSomeOf53,
  flatMap: () => flatMap63,
  flatMapNullable: () => flatMapNullable63,
  flatten: () => flatten63,
  fromIterable: () => fromIterable82,
  fromNullable: () => fromNullable63,
  gen: () => gen53,
  getEquivalence: () => getEquivalence73,
  getLeft: () => getLeft233,
  getOrElse: () => getOrElse53,
  getOrNull: () => getOrNull53,
  getOrThrow: () => getOrThrow53,
  getOrThrowWith: () => getOrThrowWith53,
  getOrUndefined: () => getOrUndefined53,
  getOrder: () => getOrder63,
  getRight: () => getRight233,
  isNone: () => isNone233,
  isOption: () => isOption233,
  isSome: () => isSome233,
  let: () => let_233,
  lift2: () => lift253,
  liftNullable: () => liftNullable63,
  liftPredicate: () => liftPredicate63,
  liftThrowable: () => liftThrowable53,
  map: () => map63,
  match: () => match72,
  none: () => none233,
  orElse: () => orElse53,
  orElseEither: () => orElseEither53,
  orElseSome: () => orElseSome53,
  partitionMap: () => partitionMap63,
  product: () => product82,
  productMany: () => productMany82,
  reduceCompact: () => reduceCompact53,
  some: () => some233,
  tap: () => tap53,
  toArray: () => toArray53,
  toRefinement: () => toRefinement53,
  void: () => void_53,
  zipLeft: () => zipLeft53,
  zipRight: () => zipRight53,
  zipWith: () => zipWith63
});
var make233 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId333 = /* @__PURE__ */ Symbol.for("effect/Option");
var none233 = () => none82;
var some233 = some122;
var isOption233 = isOption82;
var isNone233 = isNone82;
var isSome233 = isSome82;
var match72 = /* @__PURE__ */ dual53(2, (self2, {
  onNone,
  onSome
}) => isNone233(self2) ? onNone() : onSome(self2.value));
var toRefinement53 = (f2222) => (a2222) => isSome233(f2222(a2222));
var fromIterable82 = (collection) => {
  for (const a2222 of collection) {
    return some233(a2222);
  }
  return none233();
};
var getRight233 = getRight82;
var getLeft233 = getLeft82;
var getOrElse53 = /* @__PURE__ */ dual53(2, (self2, onNone) => isNone233(self2) ? onNone() : self2.value);
var orElse53 = /* @__PURE__ */ dual53(2, (self2, that) => isNone233(self2) ? that() : self2);
var orElseSome53 = /* @__PURE__ */ dual53(2, (self2, onNone) => isNone233(self2) ? some233(onNone()) : self2);
var orElseEither53 = /* @__PURE__ */ dual53(2, (self2, that) => isNone233(self2) ? map63(that(), right63) : map63(self2, left63));
var firstSomeOf53 = (collection) => {
  let out = none233();
  for (out of collection) {
    if (isSome233(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable63 = (nullableValue) => nullableValue == null ? none233() : some233(nullableValue);
var liftNullable63 = (f2222) => (...a2222) => fromNullable63(f2222(...a2222));
var getOrNull53 = /* @__PURE__ */ getOrElse53(constNull53);
var getOrUndefined53 = /* @__PURE__ */ getOrElse53(constUndefined53);
var liftThrowable53 = (f2222) => (...a2222) => {
  try {
    return some233(f2222(...a2222));
  } catch (e2222) {
    return none233();
  }
};
var getOrThrowWith53 = /* @__PURE__ */ dual53(2, (self2, onNone) => {
  if (isSome233(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow53 = /* @__PURE__ */ getOrThrowWith53(() => new Error("getOrThrow called on a None"));
var map63 = /* @__PURE__ */ dual53(2, (self2, f2222) => isNone233(self2) ? none233() : some233(f2222(self2.value)));
var as53 = /* @__PURE__ */ dual53(2, (self2, b2222) => map63(self2, () => b2222));
var asVoid53 = /* @__PURE__ */ as53(void 0);
var void_53 = /* @__PURE__ */ some233(void 0);
var flatMap63 = /* @__PURE__ */ dual53(2, (self2, f2222) => isNone233(self2) ? none233() : f2222(self2.value));
var andThen53 = /* @__PURE__ */ dual53(2, (self2, f2222) => flatMap63(self2, (a2222) => {
  const b2222 = isFunction92(f2222) ? f2222(a2222) : f2222;
  return isOption233(b2222) ? b2222 : some233(b2222);
}));
var flatMapNullable63 = /* @__PURE__ */ dual53(2, (self2, f2222) => isNone233(self2) ? none233() : fromNullable63(f2222(self2.value)));
var flatten63 = /* @__PURE__ */ flatMap63(identity53);
var zipRight53 = /* @__PURE__ */ dual53(2, (self2, that) => flatMap63(self2, () => that));
var composeK53 = /* @__PURE__ */ dual53(2, (afb, bfc) => (a2222) => flatMap63(afb(a2222), bfc));
var zipLeft53 = /* @__PURE__ */ dual53(2, (self2, that) => tap53(self2, () => that));
var tap53 = /* @__PURE__ */ dual53(2, (self2, f2222) => flatMap63(self2, (a2222) => map63(f2222(a2222), () => a2222)));
var product82 = (self2, that) => isSome233(self2) && isSome233(that) ? some233([self2.value, that.value]) : none233();
var productMany82 = (self2, collection) => {
  if (isNone233(self2)) {
    return none233();
  }
  const out = [self2.value];
  for (const o2222 of collection) {
    if (isNone233(o2222)) {
      return none233();
    }
    out.push(o2222.value);
  }
  return some233(out);
};
var all82 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o2222 of input) {
      if (isNone233(o2222)) {
        return none233();
      }
      out2.push(o2222.value);
    }
    return some233(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o2222 = input[key];
    if (isNone233(o2222)) {
      return none233();
    }
    out[key] = o2222.value;
  }
  return some233(out);
};
var zipWith63 = /* @__PURE__ */ dual53(3, (self2, that, f2222) => map63(product82(self2, that), ([a2222, b2222]) => f2222(a2222, b2222)));
var ap53 = /* @__PURE__ */ dual53(2, (self2, that) => zipWith63(self2, that, (f2222, a2222) => f2222(a2222)));
var reduceCompact53 = /* @__PURE__ */ dual53(3, (self2, b2222, f2222) => {
  let out = b2222;
  for (const oa of self2) {
    if (isSome233(oa)) {
      out = f2222(out, oa.value);
    }
  }
  return out;
});
var toArray53 = (self2) => isNone233(self2) ? [] : [self2.value];
var partitionMap63 = /* @__PURE__ */ dual53(2, (self2, f2222) => {
  if (isNone233(self2)) {
    return [none233(), none233()];
  }
  const e2222 = f2222(self2.value);
  return isLeft63(e2222) ? [some233(e2222.left), none233()] : [none233(), some233(e2222.right)];
});
var filterMap63 = /* @__PURE__ */ dual53(2, (self2, f2222) => isNone233(self2) ? none233() : f2222(self2.value));
var filter63 = /* @__PURE__ */ dual53(2, (self2, predicate) => filterMap63(self2, (b2222) => predicate(b2222) ? some122(b2222) : none82));
var getEquivalence73 = (isEquivalent) => make162((x2222, y2222) => x2222 === y2222 || (isNone233(x2222) ? isNone233(y2222) : isNone233(y2222) ? false : isEquivalent(x2222.value, y2222.value)));
var getOrder63 = (O2222) => make233((self2, that) => isSome233(self2) ? isSome233(that) ? O2222(self2.value, that.value) : 1 : -1);
var lift253 = (f2222) => dual53(2, (self2, that) => zipWith63(self2, that, f2222));
var liftPredicate63 = (predicate) => (b2222) => predicate(b2222) ? some233(b2222) : none233();
var containsWith63 = (isEquivalent) => dual53(2, (self2, a2222) => isNone233(self2) ? false : isEquivalent(self2.value, a2222));
var _equivalence73 = /* @__PURE__ */ equivalence53();
var contains63 = /* @__PURE__ */ containsWith63(_equivalence73);
var exists53 = /* @__PURE__ */ dual53(2, (self2, refinement) => isNone233(self2) ? false : refinement(self2.value));
var bindTo233 = /* @__PURE__ */ bindTo92(map63);
var let_233 = /* @__PURE__ */ let_92(map63);
var bind233 = /* @__PURE__ */ bind92(map63, flatMap63);
var Do63 = /* @__PURE__ */ some233({});
var adapter233 = /* @__PURE__ */ adapter82();
var gen53 = (f2222) => {
  const iterator = f2222(adapter233);
  let state = iterator.next();
  if (state.done) {
    return some233(state.value);
  } else {
    let current = state.value;
    if (isGenKind53(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet53(current);
    }
    if (isNone233(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind53(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet53(current);
        }
        if (isNone233(current)) {
          return current;
        }
      }
    }
    return some233(state.value);
  }
};
var MutableRef_exports32 = {};
__export43(MutableRef_exports32, {
  compareAndSet: () => compareAndSet32,
  decrement: () => decrement32,
  decrementAndGet: () => decrementAndGet32,
  get: () => get42,
  getAndDecrement: () => getAndDecrement32,
  getAndIncrement: () => getAndIncrement32,
  getAndSet: () => getAndSet32,
  getAndUpdate: () => getAndUpdate32,
  increment: () => increment32,
  incrementAndGet: () => incrementAndGet32,
  make: () => make333,
  set: () => set43,
  setAndGet: () => setAndGet32,
  toggle: () => toggle32,
  update: () => update32,
  updateAndGet: () => updateAndGet32
});
var TypeId433 = /* @__PURE__ */ Symbol.for("effect/MutableRef");
var MutableRefProto32 = {
  [TypeId433]: TypeId433,
  toString() {
    return format53(this.toJSON());
  },
  toJSON() {
    return {
      _id: "MutableRef",
      current: toJSON53(this.current)
    };
  },
  [NodeInspectSymbol53]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments53(this, arguments);
  }
};
var make333 = (value) => {
  const ref = Object.create(MutableRefProto32);
  ref.current = value;
  return ref;
};
var compareAndSet32 = /* @__PURE__ */ dual53(3, (self2, oldValue, newValue) => {
  if (equals53(oldValue, self2.current)) {
    self2.current = newValue;
    return true;
  }
  return false;
});
var decrement32 = (self2) => update32(self2, (n2222) => n2222 - 1);
var decrementAndGet32 = (self2) => updateAndGet32(self2, (n2222) => n2222 - 1);
var get42 = (self2) => self2.current;
var getAndDecrement32 = (self2) => getAndUpdate32(self2, (n2222) => n2222 - 1);
var getAndIncrement32 = (self2) => getAndUpdate32(self2, (n2222) => n2222 + 1);
var getAndSet32 = /* @__PURE__ */ dual53(2, (self2, value) => {
  const ret = self2.current;
  self2.current = value;
  return ret;
});
var getAndUpdate32 = /* @__PURE__ */ dual53(2, (self2, f2222) => getAndSet32(self2, f2222(get42(self2))));
var increment32 = (self2) => update32(self2, (n2222) => n2222 + 1);
var incrementAndGet32 = (self2) => updateAndGet32(self2, (n2222) => n2222 + 1);
var set43 = /* @__PURE__ */ dual53(2, (self2, value) => {
  self2.current = value;
  return self2;
});
var setAndGet32 = /* @__PURE__ */ dual53(2, (self2, value) => {
  self2.current = value;
  return self2.current;
});
var update32 = /* @__PURE__ */ dual53(2, (self2, f2222) => set43(self2, f2222(get42(self2))));
var updateAndGet32 = /* @__PURE__ */ dual53(2, (self2, f2222) => setAndGet32(self2, f2222(get42(self2))));
var toggle32 = (self2) => update32(self2, (_2222) => !_2222);
function getVariables23(initialScope) {
  const scopeRef = MutableRef_exports32.make(initialScope);
  const variablesRef = MutableRef_exports32.make(MutableRef_exports32.get(scopeRef).variables);
  while (MutableRef_exports32.get(scopeRef).type !== scopeManager.ScopeType.global) {
    MutableRef_exports32.set(scopeRef, MutableRef_exports32.get(scopeRef).upper);
    MutableRef_exports32.update(variablesRef, (variables) => variables.concat(MutableRef_exports32.get(scopeRef).variables));
  }
  return MutableRef_exports32.get(variablesRef).reverse();
}
var findVariable33 = Function_exports53.dual(2, (name22, initialScope) => {
  return Option_exports53.fromNullable(getVariables23(initialScope).find((variable) => variable.name === name22));
});
var t222 = Symbol.for("@ts-pattern/matcher");
var e222 = Symbol.for("@ts-pattern/isVariadic");
var n222 = "@ts-pattern/anonymous-select-key";
var r222 = (t2222) => Boolean(t2222 && "object" == typeof t2222);
var i222 = (e2222) => e2222 && !!e2222[t222];
var o222 = (n2222, s2222, c2222) => {
  if (i222(n2222)) {
    const e2222 = n2222[t222](), { matched: r2222, selections: i2222 } = e2222.match(s2222);
    return r2222 && i2222 && Object.keys(i2222).forEach((t2222) => c2222(t2222, i2222[t2222])), r2222;
  }
  if (r222(n2222)) {
    if (!r222(s2222)) return false;
    if (Array.isArray(n2222)) {
      if (!Array.isArray(s2222)) return false;
      let t2222 = [], r2222 = [], a2222 = [];
      for (const o2222 of n2222.keys()) {
        const s322 = n2222[o2222];
        i222(s322) && s322[e222] ? a2222.push(s322) : a2222.length ? r2222.push(s322) : t2222.push(s322);
      }
      if (a2222.length) {
        if (a2222.length > 1) throw new Error("Pattern error: Using `...P.array(...)` several times in a single pattern is not allowed.");
        if (s2222.length < t2222.length + r2222.length) return false;
        const e2222 = s2222.slice(0, t2222.length), n322 = 0 === r2222.length ? [] : s2222.slice(-r2222.length), i2222 = s2222.slice(t2222.length, 0 === r2222.length ? Infinity : -r2222.length);
        return t2222.every((t322, n422) => o222(t322, e2222[n422], c2222)) && r2222.every((t322, e322) => o222(t322, n322[e322], c2222)) && (0 === a2222.length || o222(a2222[0], i2222, c2222));
      }
      return n2222.length === s2222.length && n2222.every((t322, e2222) => o222(t322, s2222[e2222], c2222));
    }
    return Object.keys(n2222).every((e2222) => {
      const r2222 = n2222[e2222];
      return (e2222 in s2222 || i222(a2222 = r2222) && "optional" === a2222[t222]().matcherType) && o222(r2222, s2222[e2222], c2222);
      var a2222;
    });
  }
  return Object.is(s2222, n2222);
};
var s222 = (e2222) => {
  var n2222, o2222, a2222;
  return r222(e2222) ? i222(e2222) ? null != (n2222 = null == (o2222 = (a2222 = e2222[t222]()).getSelectionKeys) ? void 0 : o2222.call(a2222)) ? n2222 : [] : Array.isArray(e2222) ? c222(e2222, s222) : c222(Object.values(e2222), s222) : [];
};
var c222 = (t2222, e2222) => t2222.reduce((t322, n2222) => t322.concat(e2222(n2222)), []);
function a222(...t2222) {
  if (1 === t2222.length) {
    const [e2222] = t2222;
    return (t322) => o222(e2222, t322, () => {
    });
  }
  if (2 === t2222.length) {
    const [e2222, n2222] = t2222;
    return o222(e2222, n2222, () => {
    });
  }
  throw new Error(`isMatching wasn't given the right number of arguments: expected 1 or 2, received ${t2222.length}.`);
}
function u222(t2222) {
  return Object.assign(t2222, { optional: () => l222(t2222), and: (e2222) => m222(t2222, e2222), or: (e2222) => d222(t2222, e2222), select: (e2222) => void 0 === e2222 ? p222(t2222) : p222(e2222, t2222) });
}
function h222(t2222) {
  return Object.assign(((t322) => Object.assign(t322, { [Symbol.iterator]() {
    let n2222 = 0;
    const r2222 = [{ value: Object.assign(t322, { [e222]: true }), done: false }, { done: true, value: void 0 }];
    return { next: () => {
      var t422;
      return null != (t422 = r2222[n2222++]) ? t422 : r2222.at(-1);
    } };
  } }))(t2222), { optional: () => h222(l222(t2222)), select: (e2222) => h222(void 0 === e2222 ? p222(t2222) : p222(e2222, t2222)) });
}
function l222(e2222) {
  return u222({ [t222]: () => ({ match: (t2222) => {
    let n2222 = {};
    const r2222 = (t322, e322) => {
      n2222[t322] = e322;
    };
    return void 0 === t2222 ? (s222(e2222).forEach((t322) => r2222(t322, void 0)), { matched: true, selections: n2222 }) : { matched: o222(e2222, t2222, r2222), selections: n2222 };
  }, getSelectionKeys: () => s222(e2222), matcherType: "optional" }) });
}
var f222 = (t2222, e2222) => {
  for (const n2222 of t2222) if (!e2222(n2222)) return false;
  return true;
};
var g222 = (t2222, e2222) => {
  for (const [n2222, r2222] of t2222.entries()) if (!e2222(r2222, n2222)) return false;
  return true;
};
function m222(...e2222) {
  return u222({ [t222]: () => ({ match: (t2222) => {
    let n2222 = {};
    const r2222 = (t322, e322) => {
      n2222[t322] = e322;
    };
    return { matched: e2222.every((e322) => o222(e322, t2222, r2222)), selections: n2222 };
  }, getSelectionKeys: () => c222(e2222, s222), matcherType: "and" }) });
}
function d222(...e2222) {
  return u222({ [t222]: () => ({ match: (t2222) => {
    let n2222 = {};
    const r2222 = (t322, e322) => {
      n2222[t322] = e322;
    };
    return c222(e2222, s222).forEach((t322) => r2222(t322, void 0)), { matched: e2222.some((e322) => o222(e322, t2222, r2222)), selections: n2222 };
  }, getSelectionKeys: () => c222(e2222, s222), matcherType: "or" }) });
}
function y222(e2222) {
  return { [t222]: () => ({ match: (t2222) => ({ matched: Boolean(e2222(t2222)) }) }) };
}
function p222(...e2222) {
  const r2222 = "string" == typeof e2222[0] ? e2222[0] : void 0, i2222 = 2 === e2222.length ? e2222[1] : "string" == typeof e2222[0] ? void 0 : e2222[0];
  return u222({ [t222]: () => ({ match: (t2222) => {
    let e322 = { [null != r2222 ? r2222 : n222]: t2222 };
    return { matched: void 0 === i2222 || o222(i2222, t2222, (t322, n2222) => {
      e322[t322] = n2222;
    }), selections: e322 };
  }, getSelectionKeys: () => [null != r2222 ? r2222 : n222].concat(void 0 === i2222 ? [] : s222(i2222)) }) });
}
function v222(t2222) {
  return "number" == typeof t2222;
}
function b222(t2222) {
  return "string" == typeof t2222;
}
function w222(t2222) {
  return "bigint" == typeof t2222;
}
var S222 = u222(y222(function(t2222) {
  return true;
}));
var O222 = S222;
var j222 = (t2222) => Object.assign(u222(t2222), { startsWith: (e2222) => {
  return j222(m222(t2222, (n2222 = e2222, y222((t322) => b222(t322) && t322.startsWith(n2222)))));
  var n2222;
}, endsWith: (e2222) => {
  return j222(m222(t2222, (n2222 = e2222, y222((t322) => b222(t322) && t322.endsWith(n2222)))));
  var n2222;
}, minLength: (e2222) => j222(m222(t2222, ((t322) => y222((e322) => b222(e322) && e322.length >= t322))(e2222))), maxLength: (e2222) => j222(m222(t2222, ((t322) => y222((e322) => b222(e322) && e322.length <= t322))(e2222))), includes: (e2222) => {
  return j222(m222(t2222, (n2222 = e2222, y222((t322) => b222(t322) && t322.includes(n2222)))));
  var n2222;
}, regex: (e2222) => {
  return j222(m222(t2222, (n2222 = e2222, y222((t322) => b222(t322) && Boolean(t322.match(n2222))))));
  var n2222;
} });
var E222 = j222(y222(b222));
var K222 = (t2222) => Object.assign(u222(t2222), { between: (e2222, n2222) => K222(m222(t2222, ((t322, e322) => y222((n322) => v222(n322) && t322 <= n322 && e322 >= n322))(e2222, n2222))), lt: (e2222) => K222(m222(t2222, ((t322) => y222((e322) => v222(e322) && e322 < t322))(e2222))), gt: (e2222) => K222(m222(t2222, ((t322) => y222((e322) => v222(e322) && e322 > t322))(e2222))), lte: (e2222) => K222(m222(t2222, ((t322) => y222((e322) => v222(e322) && e322 <= t322))(e2222))), gte: (e2222) => K222(m222(t2222, ((t322) => y222((e322) => v222(e322) && e322 >= t322))(e2222))), int: () => K222(m222(t2222, y222((t322) => v222(t322) && Number.isInteger(t322)))), finite: () => K222(m222(t2222, y222((t322) => v222(t322) && Number.isFinite(t322)))), positive: () => K222(m222(t2222, y222((t322) => v222(t322) && t322 > 0))), negative: () => K222(m222(t2222, y222((t322) => v222(t322) && t322 < 0))) });
var x222 = K222(y222(v222));
var A222 = (t2222) => Object.assign(u222(t2222), { between: (e2222, n2222) => A222(m222(t2222, ((t322, e322) => y222((n322) => w222(n322) && t322 <= n322 && e322 >= n322))(e2222, n2222))), lt: (e2222) => A222(m222(t2222, ((t322) => y222((e322) => w222(e322) && e322 < t322))(e2222))), gt: (e2222) => A222(m222(t2222, ((t322) => y222((e322) => w222(e322) && e322 > t322))(e2222))), lte: (e2222) => A222(m222(t2222, ((t322) => y222((e322) => w222(e322) && e322 <= t322))(e2222))), gte: (e2222) => A222(m222(t2222, ((t322) => y222((e322) => w222(e322) && e322 >= t322))(e2222))), positive: () => A222(m222(t2222, y222((t322) => w222(t322) && t322 > 0))), negative: () => A222(m222(t2222, y222((t322) => w222(t322) && t322 < 0))) });
var P32 = A222(y222(w222));
var T222 = u222(y222(function(t2222) {
  return "boolean" == typeof t2222;
}));
var k222 = u222(y222(function(t2222) {
  return "symbol" == typeof t2222;
}));
var B222 = u222(y222(function(t2222) {
  return null == t2222;
}));
var _222 = u222(y222(function(t2222) {
  return null != t2222;
}));
var N222 = { __proto__: null, matcher: t222, optional: l222, array: function(...e2222) {
  return h222({ [t222]: () => ({ match: (t2222) => {
    if (!Array.isArray(t2222)) return { matched: false };
    if (0 === e2222.length) return { matched: true };
    const n2222 = e2222[0];
    let r2222 = {};
    if (0 === t2222.length) return s222(n2222).forEach((t322) => {
      r2222[t322] = [];
    }), { matched: true, selections: r2222 };
    const i2222 = (t322, e322) => {
      r2222[t322] = (r2222[t322] || []).concat([e322]);
    };
    return { matched: t2222.every((t322) => o222(n2222, t322, i2222)), selections: r2222 };
  }, getSelectionKeys: () => 0 === e2222.length ? [] : s222(e2222[0]) }) });
}, set: function(...e2222) {
  return u222({ [t222]: () => ({ match: (t2222) => {
    if (!(t2222 instanceof Set)) return { matched: false };
    let n2222 = {};
    if (0 === t2222.size) return { matched: true, selections: n2222 };
    if (0 === e2222.length) return { matched: true };
    const r2222 = (t322, e322) => {
      n2222[t322] = (n2222[t322] || []).concat([e322]);
    }, i2222 = e2222[0];
    return { matched: f222(t2222, (t322) => o222(i2222, t322, r2222)), selections: n2222 };
  }, getSelectionKeys: () => 0 === e2222.length ? [] : s222(e2222[0]) }) });
}, map: function(...e2222) {
  return u222({ [t222]: () => ({ match: (t2222) => {
    if (!(t2222 instanceof Map)) return { matched: false };
    let n2222 = {};
    if (0 === t2222.size) return { matched: true, selections: n2222 };
    const r2222 = (t322, e322) => {
      n2222[t322] = (n2222[t322] || []).concat([e322]);
    };
    if (0 === e2222.length) return { matched: true };
    var i2222;
    if (1 === e2222.length) throw new Error(`\`P.map\` wasn't given enough arguments. Expected (key, value), received ${null == (i2222 = e2222[0]) ? void 0 : i2222.toString()}`);
    const [s2222, c2222] = e2222;
    return { matched: g222(t2222, (t322, e322) => {
      const n322 = o222(s2222, e322, r2222), i322 = o222(c2222, t322, r2222);
      return n322 && i322;
    }), selections: n2222 };
  }, getSelectionKeys: () => 0 === e2222.length ? [] : [...s222(e2222[0]), ...s222(e2222[1])] }) });
}, intersection: m222, union: d222, not: function(e2222) {
  return u222({ [t222]: () => ({ match: (t2222) => ({ matched: !o222(e2222, t2222, () => {
  }) }), getSelectionKeys: () => [], matcherType: "not" }) });
}, when: y222, select: p222, any: S222, _: O222, string: E222, number: x222, bigint: P32, boolean: T222, symbol: k222, nullish: B222, nonNullable: _222, instanceOf: function(t2222) {
  return u222(y222(/* @__PURE__ */ function(t322) {
    return (e2222) => e2222 instanceof t322;
  }(t2222)));
}, shape: function(t2222) {
  return u222(y222(a222(t2222)));
} };
var KEYS33 = {
  ArrayExpression: [
    "elements"
  ],
  ArrayPattern: [
    "elements"
  ],
  ArrowFunctionExpression: [
    "params",
    "body"
  ],
  AssignmentExpression: [
    "left",
    "right"
  ],
  AssignmentPattern: [
    "left",
    "right"
  ],
  AwaitExpression: [
    "argument"
  ],
  BinaryExpression: [
    "left",
    "right"
  ],
  BlockStatement: [
    "body"
  ],
  BreakStatement: [
    "label"
  ],
  CallExpression: [
    "callee",
    "arguments"
  ],
  CatchClause: [
    "param",
    "body"
  ],
  ChainExpression: [
    "expression"
  ],
  ClassBody: [
    "body"
  ],
  ClassDeclaration: [
    "id",
    "superClass",
    "body"
  ],
  ClassExpression: [
    "id",
    "superClass",
    "body"
  ],
  ConditionalExpression: [
    "test",
    "consequent",
    "alternate"
  ],
  ContinueStatement: [
    "label"
  ],
  DebuggerStatement: [],
  DoWhileStatement: [
    "body",
    "test"
  ],
  EmptyStatement: [],
  ExperimentalRestProperty: [
    "argument"
  ],
  ExperimentalSpreadProperty: [
    "argument"
  ],
  ExportAllDeclaration: [
    "exported",
    "source"
  ],
  ExportDefaultDeclaration: [
    "declaration"
  ],
  ExportNamedDeclaration: [
    "declaration",
    "specifiers",
    "source"
  ],
  ExportSpecifier: [
    "exported",
    "local"
  ],
  ExpressionStatement: [
    "expression"
  ],
  ForInStatement: [
    "left",
    "right",
    "body"
  ],
  ForOfStatement: [
    "left",
    "right",
    "body"
  ],
  ForStatement: [
    "init",
    "test",
    "update",
    "body"
  ],
  FunctionDeclaration: [
    "id",
    "params",
    "body"
  ],
  FunctionExpression: [
    "id",
    "params",
    "body"
  ],
  Identifier: [],
  IfStatement: [
    "test",
    "consequent",
    "alternate"
  ],
  ImportDeclaration: [
    "specifiers",
    "source"
  ],
  ImportDefaultSpecifier: [
    "local"
  ],
  ImportExpression: [
    "source"
  ],
  ImportNamespaceSpecifier: [
    "local"
  ],
  ImportSpecifier: [
    "imported",
    "local"
  ],
  JSXAttribute: [
    "name",
    "value"
  ],
  JSXClosingElement: [
    "name"
  ],
  JSXClosingFragment: [],
  JSXElement: [
    "openingElement",
    "children",
    "closingElement"
  ],
  JSXEmptyExpression: [],
  JSXExpressionContainer: [
    "expression"
  ],
  JSXFragment: [
    "openingFragment",
    "children",
    "closingFragment"
  ],
  JSXIdentifier: [],
  JSXMemberExpression: [
    "object",
    "property"
  ],
  JSXNamespacedName: [
    "namespace",
    "name"
  ],
  JSXOpeningElement: [
    "name",
    "attributes"
  ],
  JSXOpeningFragment: [],
  JSXSpreadAttribute: [
    "argument"
  ],
  JSXSpreadChild: [
    "expression"
  ],
  JSXText: [],
  LabeledStatement: [
    "label",
    "body"
  ],
  Literal: [],
  LogicalExpression: [
    "left",
    "right"
  ],
  MemberExpression: [
    "object",
    "property"
  ],
  MetaProperty: [
    "meta",
    "property"
  ],
  MethodDefinition: [
    "key",
    "value"
  ],
  NewExpression: [
    "callee",
    "arguments"
  ],
  ObjectExpression: [
    "properties"
  ],
  ObjectPattern: [
    "properties"
  ],
  PrivateIdentifier: [],
  Program: [
    "body"
  ],
  Property: [
    "key",
    "value"
  ],
  PropertyDefinition: [
    "key",
    "value"
  ],
  RestElement: [
    "argument"
  ],
  ReturnStatement: [
    "argument"
  ],
  SequenceExpression: [
    "expressions"
  ],
  SpreadElement: [
    "argument"
  ],
  StaticBlock: [
    "body"
  ],
  Super: [],
  SwitchCase: [
    "test",
    "consequent"
  ],
  SwitchStatement: [
    "discriminant",
    "cases"
  ],
  TaggedTemplateExpression: [
    "tag",
    "quasi"
  ],
  TemplateElement: [],
  TemplateLiteral: [
    "quasis",
    "expressions"
  ],
  ThisExpression: [],
  ThrowStatement: [
    "argument"
  ],
  TryStatement: [
    "block",
    "handler",
    "finalizer"
  ],
  UnaryExpression: [
    "argument"
  ],
  UpdateExpression: [
    "argument"
  ],
  VariableDeclaration: [
    "declarations"
  ],
  VariableDeclarator: [
    "id",
    "init"
  ],
  WhileStatement: [
    "test",
    "body"
  ],
  WithStatement: [
    "object",
    "body"
  ],
  YieldExpression: [
    "argument"
  ]
};
var NODE_TYPES33 = Object.keys(KEYS33);
for (const type of NODE_TYPES33) {
  Object.freeze(KEYS33[type]);
}
Object.freeze(KEYS33);
var visitor_keys_default33 = KEYS33;
var KEY_BLACKLIST33 = /* @__PURE__ */ new Set([
  "parent",
  "leadingComments",
  "trailingComments"
]);
function filterKey33(key) {
  return !KEY_BLACKLIST33.has(key) && key[0] !== "_";
}
function getKeys33(node) {
  return Object.keys(node).filter(filterKey33);
}
function getInnermostScope33(initialScope, node) {
  const location = node.range[0];
  let scope = initialScope;
  let found = false;
  do {
    found = false;
    for (const childScope of scope.childScopes) {
      const range222 = childScope.block.range;
      if (range222[0] <= location && location < range222[1]) {
        scope = childScope;
        found = true;
        break;
      }
    }
  } while (found);
  return scope;
}
function findVariable233(initialScope, nameOrNode) {
  let name22 = "";
  let scope = initialScope;
  if (typeof nameOrNode === "string") {
    name22 = nameOrNode;
  } else {
    name22 = nameOrNode.name;
    scope = getInnermostScope33(scope, nameOrNode);
  }
  while (scope != null) {
    const variable = scope.set.get(name22);
    if (variable != null) {
      return variable;
    }
    scope = scope.upper;
  }
  return null;
}
function negate033(token) {
  return !this(token);
}
function negate33(f2222) {
  return negate033.bind(f2222);
}
function isPunctuatorTokenWithValue33(token, value) {
  return token.type === "Punctuator" && token.value === value;
}
function isArrowToken33(token) {
  return isPunctuatorTokenWithValue33(token, "=>");
}
function isCommaToken33(token) {
  return isPunctuatorTokenWithValue33(token, ",");
}
function isSemicolonToken33(token) {
  return isPunctuatorTokenWithValue33(token, ";");
}
function isColonToken33(token) {
  return isPunctuatorTokenWithValue33(token, ":");
}
function isOpeningParenToken33(token) {
  return isPunctuatorTokenWithValue33(token, "(");
}
function isClosingParenToken33(token) {
  return isPunctuatorTokenWithValue33(token, ")");
}
function isOpeningBracketToken33(token) {
  return isPunctuatorTokenWithValue33(token, "[");
}
function isClosingBracketToken33(token) {
  return isPunctuatorTokenWithValue33(token, "]");
}
function isOpeningBraceToken33(token) {
  return isPunctuatorTokenWithValue33(token, "{");
}
function isClosingBraceToken33(token) {
  return isPunctuatorTokenWithValue33(token, "}");
}
function isCommentToken33(token) {
  return ["Block", "Line", "Shebang"].includes(token.type);
}
negate33(isArrowToken33);
negate33(isCommaToken33);
negate33(isSemicolonToken33);
negate33(isColonToken33);
negate33(isOpeningParenToken33);
negate33(isClosingParenToken33);
negate33(isOpeningBracketToken33);
negate33(isClosingBracketToken33);
negate33(isOpeningBraceToken33);
negate33(isClosingBraceToken33);
negate33(isCommentToken33);
function getOpeningParenOfParams33(node, sourceCode) {
  return node.id ? sourceCode.getTokenAfter(node.id, isOpeningParenToken33) : sourceCode.getFirstToken(node, isOpeningParenToken33);
}
function getFunctionHeadLocation33(node, sourceCode) {
  const parent = node.parent;
  let start = null;
  let end = null;
  if (node.type === "ArrowFunctionExpression") {
    const arrowToken = sourceCode.getTokenBefore(node.body, isArrowToken33);
    start = arrowToken.loc.start;
    end = arrowToken.loc.end;
  } else if (parent.type === "Property" || parent.type === "MethodDefinition" || parent.type === "PropertyDefinition") {
    start = parent.loc.start;
    end = getOpeningParenOfParams33(node, sourceCode).loc.start;
  } else {
    start = node.loc.start;
    end = getOpeningParenOfParams33(node, sourceCode).loc.start;
  }
  return {
    start: { ...start },
    end: { ...end }
  };
}
var globalObject33 = typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {};
var builtinNames33 = Object.freeze(
  /* @__PURE__ */ new Set([
    "Array",
    "ArrayBuffer",
    "BigInt",
    "BigInt64Array",
    "BigUint64Array",
    "Boolean",
    "DataView",
    "Date",
    "decodeURI",
    "decodeURIComponent",
    "encodeURI",
    "encodeURIComponent",
    "escape",
    "Float32Array",
    "Float64Array",
    "Function",
    "Infinity",
    "Int16Array",
    "Int32Array",
    "Int8Array",
    "isFinite",
    "isNaN",
    "isPrototypeOf",
    "JSON",
    "Map",
    "Math",
    "NaN",
    "Number",
    "Object",
    "parseFloat",
    "parseInt",
    "Promise",
    "Proxy",
    "Reflect",
    "RegExp",
    "Set",
    "String",
    "Symbol",
    "Uint16Array",
    "Uint32Array",
    "Uint8Array",
    "Uint8ClampedArray",
    "undefined",
    "unescape",
    "WeakMap",
    "WeakSet"
  ])
);
var callAllowed33 = new Set(
  [
    Array.isArray,
    Array.of,
    Array.prototype.at,
    Array.prototype.concat,
    Array.prototype.entries,
    Array.prototype.every,
    Array.prototype.filter,
    Array.prototype.find,
    Array.prototype.findIndex,
    Array.prototype.flat,
    Array.prototype.includes,
    Array.prototype.indexOf,
    Array.prototype.join,
    Array.prototype.keys,
    Array.prototype.lastIndexOf,
    Array.prototype.slice,
    Array.prototype.some,
    Array.prototype.toString,
    Array.prototype.values,
    typeof BigInt === "function" ? BigInt : void 0,
    Boolean,
    Date,
    Date.parse,
    decodeURI,
    decodeURIComponent,
    encodeURI,
    encodeURIComponent,
    escape,
    isFinite,
    isNaN,
    isPrototypeOf,
    Map,
    Map.prototype.entries,
    Map.prototype.get,
    Map.prototype.has,
    Map.prototype.keys,
    Map.prototype.values,
    ...Object.getOwnPropertyNames(Math).filter((k2222) => k2222 !== "random").map((k2222) => Math[k2222]).filter((f2222) => typeof f2222 === "function"),
    Number,
    Number.isFinite,
    Number.isNaN,
    Number.parseFloat,
    Number.parseInt,
    Number.prototype.toExponential,
    Number.prototype.toFixed,
    Number.prototype.toPrecision,
    Number.prototype.toString,
    Object,
    Object.entries,
    Object.is,
    Object.isExtensible,
    Object.isFrozen,
    Object.isSealed,
    Object.keys,
    Object.values,
    parseFloat,
    parseInt,
    RegExp,
    Set,
    Set.prototype.entries,
    Set.prototype.has,
    Set.prototype.keys,
    Set.prototype.values,
    String,
    String.fromCharCode,
    String.fromCodePoint,
    String.raw,
    String.prototype.at,
    String.prototype.charAt,
    String.prototype.charCodeAt,
    String.prototype.codePointAt,
    String.prototype.concat,
    String.prototype.endsWith,
    String.prototype.includes,
    String.prototype.indexOf,
    String.prototype.lastIndexOf,
    String.prototype.normalize,
    String.prototype.padEnd,
    String.prototype.padStart,
    String.prototype.slice,
    String.prototype.startsWith,
    String.prototype.substr,
    String.prototype.substring,
    String.prototype.toLowerCase,
    String.prototype.toString,
    String.prototype.toUpperCase,
    String.prototype.trim,
    String.prototype.trimEnd,
    String.prototype.trimLeft,
    String.prototype.trimRight,
    String.prototype.trimStart,
    Symbol.for,
    Symbol.keyFor,
    unescape
  ].filter((f2222) => typeof f2222 === "function")
);
var callPassThrough33 = /* @__PURE__ */ new Set([
  Object.freeze,
  Object.preventExtensions,
  Object.seal
]);
var getterAllowed33 = [
  [Map, /* @__PURE__ */ new Set(["size"])],
  [
    RegExp,
    /* @__PURE__ */ new Set([
      "dotAll",
      "flags",
      "global",
      "hasIndices",
      "ignoreCase",
      "multiline",
      "source",
      "sticky",
      "unicode"
    ])
  ],
  [Set, /* @__PURE__ */ new Set(["size"])]
];
function getPropertyDescriptor33(object222, name22) {
  let x2222 = object222;
  while ((typeof x2222 === "object" || typeof x2222 === "function") && x2222 !== null) {
    const d2222 = Object.getOwnPropertyDescriptor(x2222, name22);
    if (d2222) {
      return d2222;
    }
    x2222 = Object.getPrototypeOf(x2222);
  }
  return null;
}
function isGetter33(object222, name22) {
  const d2222 = getPropertyDescriptor33(object222, name22);
  return d2222 != null && d2222.get != null;
}
function getElementValues33(nodeList, initialScope) {
  const valueList = [];
  for (let i2222 = 0; i2222 < nodeList.length; ++i2222) {
    const elementNode = nodeList[i2222];
    if (elementNode == null) {
      valueList.length = i2222 + 1;
    } else if (elementNode.type === "SpreadElement") {
      const argument = getStaticValueR33(elementNode.argument, initialScope);
      if (argument == null) {
        return null;
      }
      valueList.push(...argument.value);
    } else {
      const element = getStaticValueR33(elementNode, initialScope);
      if (element == null) {
        return null;
      }
      valueList.push(element.value);
    }
  }
  return valueList;
}
function isEffectivelyConst33(variable) {
  const refs = variable.references;
  const inits = refs.filter((r2222) => r2222.init).length;
  const reads = refs.filter((r2222) => r2222.isReadOnly()).length;
  if (inits === 1 && reads + inits === refs.length) {
    return true;
  }
  return false;
}
var operations33 = Object.freeze({
  ArrayExpression(node, initialScope) {
    const elements = getElementValues33(node.elements, initialScope);
    return elements != null ? { value: elements } : null;
  },
  AssignmentExpression(node, initialScope) {
    if (node.operator === "=") {
      return getStaticValueR33(node.right, initialScope);
    }
    return null;
  },
  //eslint-disable-next-line complexity
  BinaryExpression(node, initialScope) {
    if (node.operator === "in" || node.operator === "instanceof") {
      return null;
    }
    const left3322 = getStaticValueR33(node.left, initialScope);
    const right3322 = getStaticValueR33(node.right, initialScope);
    if (left3322 != null && right3322 != null) {
      switch (node.operator) {
        case "==":
          return { value: left3322.value == right3322.value };
        case "!=":
          return { value: left3322.value != right3322.value };
        case "===":
          return { value: left3322.value === right3322.value };
        case "!==":
          return { value: left3322.value !== right3322.value };
        case "<":
          return { value: left3322.value < right3322.value };
        case "<=":
          return { value: left3322.value <= right3322.value };
        case ">":
          return { value: left3322.value > right3322.value };
        case ">=":
          return { value: left3322.value >= right3322.value };
        case "<<":
          return { value: left3322.value << right3322.value };
        case ">>":
          return { value: left3322.value >> right3322.value };
        case ">>>":
          return { value: left3322.value >>> right3322.value };
        case "+":
          return { value: left3322.value + right3322.value };
        case "-":
          return { value: left3322.value - right3322.value };
        case "*":
          return { value: left3322.value * right3322.value };
        case "/":
          return { value: left3322.value / right3322.value };
        case "%":
          return { value: left3322.value % right3322.value };
        case "**":
          return { value: left3322.value ** right3322.value };
        case "|":
          return { value: left3322.value | right3322.value };
        case "^":
          return { value: left3322.value ^ right3322.value };
        case "&":
          return { value: left3322.value & right3322.value };
      }
    }
    return null;
  },
  CallExpression(node, initialScope) {
    const calleeNode = node.callee;
    const args = getElementValues33(node.arguments, initialScope);
    if (args != null) {
      if (calleeNode.type === "MemberExpression") {
        if (calleeNode.property.type === "PrivateIdentifier") {
          return null;
        }
        const object222 = getStaticValueR33(calleeNode.object, initialScope);
        if (object222 != null) {
          if (object222.value == null && (object222.optional || node.optional)) {
            return { value: void 0, optional: true };
          }
          const property = getStaticPropertyNameValue33(
            calleeNode,
            initialScope
          );
          if (property != null) {
            const receiver = object222.value;
            const methodName = property.value;
            if (callAllowed33.has(receiver[methodName])) {
              return { value: receiver[methodName](...args) };
            }
            if (callPassThrough33.has(receiver[methodName])) {
              return { value: args[0] };
            }
          }
        }
      } else {
        const callee = getStaticValueR33(calleeNode, initialScope);
        if (callee != null) {
          if (callee.value == null && node.optional) {
            return { value: void 0, optional: true };
          }
          const func = callee.value;
          if (callAllowed33.has(func)) {
            return { value: func(...args) };
          }
          if (callPassThrough33.has(func)) {
            return { value: args[0] };
          }
        }
      }
    }
    return null;
  },
  ConditionalExpression(node, initialScope) {
    const test = getStaticValueR33(node.test, initialScope);
    if (test != null) {
      return test.value ? getStaticValueR33(node.consequent, initialScope) : getStaticValueR33(node.alternate, initialScope);
    }
    return null;
  },
  ExpressionStatement(node, initialScope) {
    return getStaticValueR33(node.expression, initialScope);
  },
  Identifier(node, initialScope) {
    if (initialScope != null) {
      const variable = findVariable233(initialScope, node);
      if (variable != null && variable.defs.length === 0 && builtinNames33.has(variable.name) && variable.name in globalObject33) {
        return { value: globalObject33[variable.name] };
      }
      if (variable != null && variable.defs.length === 1) {
        const def = variable.defs[0];
        if (def.parent && def.type === "Variable" && (def.parent.kind === "const" || isEffectivelyConst33(variable)) && // TODO(mysticatea): don't support destructuring here.
        def.node.id.type === "Identifier") {
          return getStaticValueR33(def.node.init, initialScope);
        }
      }
    }
    return null;
  },
  Literal(node) {
    if ((node.regex != null || node.bigint != null) && node.value == null) {
      return null;
    }
    return { value: node.value };
  },
  LogicalExpression(node, initialScope) {
    const left3322 = getStaticValueR33(node.left, initialScope);
    if (left3322 != null) {
      if (node.operator === "||" && Boolean(left3322.value) === true || node.operator === "&&" && Boolean(left3322.value) === false || node.operator === "??" && left3322.value != null) {
        return left3322;
      }
      const right3322 = getStaticValueR33(node.right, initialScope);
      if (right3322 != null) {
        return right3322;
      }
    }
    return null;
  },
  MemberExpression(node, initialScope) {
    if (node.property.type === "PrivateIdentifier") {
      return null;
    }
    const object222 = getStaticValueR33(node.object, initialScope);
    if (object222 != null) {
      if (object222.value == null && (object222.optional || node.optional)) {
        return { value: void 0, optional: true };
      }
      const property = getStaticPropertyNameValue33(node, initialScope);
      if (property != null) {
        if (!isGetter33(object222.value, property.value)) {
          return { value: object222.value[property.value] };
        }
        for (const [classFn, allowed] of getterAllowed33) {
          if (object222.value instanceof classFn && allowed.has(property.value)) {
            return { value: object222.value[property.value] };
          }
        }
      }
    }
    return null;
  },
  ChainExpression(node, initialScope) {
    const expression = getStaticValueR33(node.expression, initialScope);
    if (expression != null) {
      return { value: expression.value };
    }
    return null;
  },
  NewExpression(node, initialScope) {
    const callee = getStaticValueR33(node.callee, initialScope);
    const args = getElementValues33(node.arguments, initialScope);
    if (callee != null && args != null) {
      const Func = callee.value;
      if (callAllowed33.has(Func)) {
        return { value: new Func(...args) };
      }
    }
    return null;
  },
  ObjectExpression(node, initialScope) {
    const object222 = {};
    for (const propertyNode of node.properties) {
      if (propertyNode.type === "Property") {
        if (propertyNode.kind !== "init") {
          return null;
        }
        const key = getStaticPropertyNameValue33(
          propertyNode,
          initialScope
        );
        const value = getStaticValueR33(propertyNode.value, initialScope);
        if (key == null || value == null) {
          return null;
        }
        object222[key.value] = value.value;
      } else if (propertyNode.type === "SpreadElement" || propertyNode.type === "ExperimentalSpreadProperty") {
        const argument = getStaticValueR33(
          propertyNode.argument,
          initialScope
        );
        if (argument == null) {
          return null;
        }
        Object.assign(object222, argument.value);
      } else {
        return null;
      }
    }
    return { value: object222 };
  },
  SequenceExpression(node, initialScope) {
    const last222 = node.expressions[node.expressions.length - 1];
    return getStaticValueR33(last222, initialScope);
  },
  TaggedTemplateExpression(node, initialScope) {
    const tag = getStaticValueR33(node.tag, initialScope);
    const expressions = getElementValues33(
      node.quasi.expressions,
      initialScope
    );
    if (tag != null && expressions != null) {
      const func = tag.value;
      const strings = node.quasi.quasis.map((q) => q.value.cooked);
      strings.raw = node.quasi.quasis.map((q) => q.value.raw);
      if (func === String.raw) {
        return { value: func(strings, ...expressions) };
      }
    }
    return null;
  },
  TemplateLiteral(node, initialScope) {
    const expressions = getElementValues33(node.expressions, initialScope);
    if (expressions != null) {
      let value = node.quasis[0].value.cooked;
      for (let i2222 = 0; i2222 < expressions.length; ++i2222) {
        value += expressions[i2222];
        value += node.quasis[i2222 + 1].value.cooked;
      }
      return { value };
    }
    return null;
  },
  UnaryExpression(node, initialScope) {
    if (node.operator === "delete") {
      return null;
    }
    if (node.operator === "void") {
      return { value: void 0 };
    }
    const arg = getStaticValueR33(node.argument, initialScope);
    if (arg != null) {
      switch (node.operator) {
        case "-":
          return { value: -arg.value };
        case "+":
          return { value: +arg.value };
        case "!":
          return { value: !arg.value };
        case "~":
          return { value: ~arg.value };
        case "typeof":
          return { value: typeof arg.value };
      }
    }
    return null;
  }
});
function getStaticValueR33(node, initialScope) {
  if (node != null && Object.hasOwnProperty.call(operations33, node.type)) {
    return operations33[node.type](node, initialScope);
  }
  return null;
}
function getStaticPropertyNameValue33(node, initialScope) {
  const nameNode = node.type === "Property" ? node.key : node.property;
  if (node.computed) {
    return getStaticValueR33(nameNode, initialScope);
  }
  if (nameNode.type === "Identifier") {
    return { value: nameNode.name };
  }
  if (nameNode.type === "Literal") {
    if (nameNode.bigint) {
      return { value: nameNode.bigint };
    }
    return { value: String(nameNode.value) };
  }
  return null;
}
function getStaticValue43(node, initialScope = null) {
  try {
    return getStaticValueR33(node, initialScope);
  } catch (_error) {
    return null;
  }
}
function getStringIfConstant33(node, initialScope = null) {
  if (node && node.type === "Literal" && node.value === null) {
    if (node.regex) {
      return `/${node.regex.pattern}/${node.regex.flags}`;
    }
    if (node.bigint) {
      return node.bigint;
    }
  }
  const evaluated = getStaticValue43(node, initialScope);
  return evaluated && String(evaluated.value);
}
function getPropertyName33(node, initialScope) {
  switch (node.type) {
    case "MemberExpression":
      if (node.computed) {
        return getStringIfConstant33(node.property, initialScope);
      }
      if (node.property.type === "PrivateIdentifier") {
        return null;
      }
      return node.property.name;
    case "Property":
    case "MethodDefinition":
    case "PropertyDefinition":
      if (node.computed) {
        return getStringIfConstant33(node.key, initialScope);
      }
      if (node.key.type === "Literal") {
        return String(node.key.value);
      }
      if (node.key.type === "PrivateIdentifier") {
        return null;
      }
      return node.key.name;
  }
  return null;
}
function getFunctionNameWithKind33(node, sourceCode) {
  const parent = node.parent;
  const tokens = [];
  const isObjectMethod = parent.type === "Property" && parent.value === node;
  const isClassMethod = parent.type === "MethodDefinition" && parent.value === node;
  const isClassFieldMethod = parent.type === "PropertyDefinition" && parent.value === node;
  if (isClassMethod || isClassFieldMethod) {
    if (parent.static) {
      tokens.push("static");
    }
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push("private");
    }
  }
  if (node.async) {
    tokens.push("async");
  }
  if (node.generator) {
    tokens.push("generator");
  }
  if (isObjectMethod || isClassMethod) {
    if (parent.kind === "constructor") {
      return "constructor";
    }
    if (parent.kind === "get") {
      tokens.push("getter");
    } else if (parent.kind === "set") {
      tokens.push("setter");
    } else {
      tokens.push("method");
    }
  } else if (isClassFieldMethod) {
    tokens.push("method");
  } else {
    if (node.type === "ArrowFunctionExpression") {
      tokens.push("arrow");
    }
    tokens.push("function");
  }
  if (isObjectMethod || isClassMethod || isClassFieldMethod) {
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push(`#${parent.key.name}`);
    } else {
      const name22 = getPropertyName33(parent);
      if (name22) {
        tokens.push(`'${name22}'`);
      } else if (sourceCode) {
        const keyText = sourceCode.getText(parent.key);
        if (!keyText.includes("\n")) {
          tokens.push(`[${keyText}]`);
        }
      }
    }
  } else if (node.id) {
    tokens.push(`'${node.id.name}'`);
  } else if (parent.type === "VariableDeclarator" && parent.id && parent.id.type === "Identifier") {
    tokens.push(`'${parent.id.name}'`);
  } else if ((parent.type === "AssignmentExpression" || parent.type === "AssignmentPattern") && parent.left && parent.left.type === "Identifier") {
    tokens.push(`'${parent.left.name}'`);
  } else if (parent.type === "ExportDefaultDeclaration" && parent.declaration === node) {
    tokens.push("'default'");
  }
  return tokens.join(" ");
}
var typeConversionBinaryOps33 = Object.freeze(
  /* @__PURE__ */ new Set([
    "==",
    "!=",
    "<",
    "<=",
    ">",
    ">=",
    "<<",
    ">>",
    ">>>",
    "+",
    "-",
    "*",
    "/",
    "%",
    "|",
    "^",
    "&",
    "in"
  ])
);
var typeConversionUnaryOps33 = Object.freeze(/* @__PURE__ */ new Set(["-", "+", "!", "~"]));
function isNode33(x2222) {
  return x2222 !== null && typeof x2222 === "object" && typeof x2222.type === "string";
}
var visitor33 = Object.freeze(
  Object.assign(/* @__PURE__ */ Object.create(null), {
    $visit(node, options, visitorKeys) {
      const { type } = node;
      if (typeof this[type] === "function") {
        return this[type](node, options, visitorKeys);
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    $visitChildren(node, options, visitorKeys) {
      const { type } = node;
      for (const key of visitorKeys[type] || getKeys33(node)) {
        const value = node[key];
        if (Array.isArray(value)) {
          for (const element of value) {
            if (isNode33(element) && this.$visit(element, options, visitorKeys)) {
              return true;
            }
          }
        } else if (isNode33(value) && this.$visit(value, options, visitorKeys)) {
          return true;
        }
      }
      return false;
    },
    ArrowFunctionExpression() {
      return false;
    },
    AssignmentExpression() {
      return true;
    },
    AwaitExpression() {
      return true;
    },
    BinaryExpression(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && typeConversionBinaryOps33.has(node.operator) && (node.left.type !== "Literal" || node.right.type !== "Literal")) {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    CallExpression() {
      return true;
    },
    FunctionExpression() {
      return false;
    },
    ImportExpression() {
      return true;
    },
    MemberExpression(node, options, visitorKeys) {
      if (options.considerGetters) {
        return true;
      }
      if (options.considerImplicitTypeConversion && node.computed && node.property.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    MethodDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    NewExpression() {
      return true;
    },
    Property(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    PropertyDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UnaryExpression(node, options, visitorKeys) {
      if (node.operator === "delete") {
        return true;
      }
      if (options.considerImplicitTypeConversion && typeConversionUnaryOps33.has(node.operator) && node.argument.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UpdateExpression() {
      return true;
    },
    YieldExpression() {
      return true;
    }
  })
);
function hasSideEffect33(node, sourceCode, { considerGetters = false, considerImplicitTypeConversion = false } = {}) {
  return visitor33.$visit(
    node,
    { considerGetters, considerImplicitTypeConversion },
    sourceCode.visitorKeys || visitor_keys_default33
  );
}
function getParentSyntaxParen33(node, sourceCode) {
  const parent = node.parent;
  switch (parent.type) {
    case "CallExpression":
    case "NewExpression":
      if (parent.arguments.length === 1 && parent.arguments[0] === node) {
        return sourceCode.getTokenAfter(
          parent.callee,
          isOpeningParenToken33
        );
      }
      return null;
    case "DoWhileStatement":
      if (parent.test === node) {
        return sourceCode.getTokenAfter(
          parent.body,
          isOpeningParenToken33
        );
      }
      return null;
    case "IfStatement":
    case "WhileStatement":
      if (parent.test === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "ImportExpression":
      if (parent.source === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "SwitchStatement":
      if (parent.discriminant === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "WithStatement":
      if (parent.object === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    default:
      return null;
  }
}
function isParenthesized33(timesOrNode, nodeOrSourceCode, optionalSourceCode) {
  let times, node, sourceCode, maybeLeftParen, maybeRightParen;
  if (typeof timesOrNode === "number") {
    times = timesOrNode | 0;
    node = nodeOrSourceCode;
    sourceCode = optionalSourceCode;
    if (!(times >= 1)) {
      throw new TypeError("'times' should be a positive integer.");
    }
  } else {
    times = 1;
    node = timesOrNode;
    sourceCode = nodeOrSourceCode;
  }
  if (node == null || // `Program` can't be parenthesized
  node.parent == null || // `CatchClause.param` can't be parenthesized, example `try {} catch (error) {}`
  node.parent.type === "CatchClause" && node.parent.param === node) {
    return false;
  }
  maybeLeftParen = maybeRightParen = node;
  do {
    maybeLeftParen = sourceCode.getTokenBefore(maybeLeftParen);
    maybeRightParen = sourceCode.getTokenAfter(maybeRightParen);
  } while (maybeLeftParen != null && maybeRightParen != null && isOpeningParenToken33(maybeLeftParen) && isClosingParenToken33(maybeRightParen) && // Avoid false positive such as `if (a) {}`
  maybeLeftParen !== getParentSyntaxParen33(node, sourceCode) && --times > 0);
  return times === 0;
}
Function.call.bind(Object.hasOwnProperty);
var __defProp233 = Object.defineProperty;
var __export233 = (target, all3322) => {
  for (var name22 in all3322)
    __defProp233(target, name22, { get: all3322[name22], enumerable: true });
};
var NodeType33 = types.AST_NODE_TYPES;
var is33 = utils.ASTUtils.isNodeOfType;
var isOneOf33 = utils.ASTUtils.isNodeOfTypes;
isOneOf33([
  NodeType33.ArrowFunctionExpression,
  NodeType33.FunctionDeclaration,
  NodeType33.FunctionExpression
]);
isOneOf33([
  NodeType33.ArrowFunctionExpression,
  NodeType33.FunctionDeclaration,
  NodeType33.FunctionExpression,
  NodeType33.TSCallSignatureDeclaration,
  NodeType33.TSConstructSignatureDeclaration,
  NodeType33.TSDeclareFunction,
  NodeType33.TSEmptyBodyFunctionExpression,
  NodeType33.TSFunctionType,
  NodeType33.TSMethodSignature
]);
isOneOf33([NodeType33.ClassDeclaration, NodeType33.ClassExpression]);
isOneOf33([
  NodeType33.DoWhileStatement,
  NodeType33.ForInStatement,
  NodeType33.ForOfStatement,
  NodeType33.ForStatement,
  NodeType33.WhileStatement
]);
isOneOf33([NodeType33.TSArrayType, NodeType33.TSTupleType]);
isOneOf33([
  NodeType33.PropertyDefinition,
  NodeType33.TSIndexSignature,
  NodeType33.TSParameterProperty,
  NodeType33.TSPropertySignature
]);
is33(NodeType33.JSXElement);
is33(NodeType33.JSXFragment);
isOneOf33([
  NodeType33.JSXAttribute,
  NodeType33.JSXSpreadChild,
  NodeType33.JSXClosingElement,
  NodeType33.JSXClosingFragment,
  NodeType33.JSXElement,
  NodeType33.JSXEmptyExpression,
  NodeType33.JSXExpressionContainer,
  NodeType33.JSXFragment,
  NodeType33.JSXIdentifier,
  NodeType33.JSXMemberExpression,
  NodeType33.JSXNamespacedName,
  NodeType33.JSXOpeningElement,
  NodeType33.JSXOpeningFragment,
  NodeType33.JSXSpreadAttribute,
  NodeType33.JSXSpreadChild,
  NodeType33.JSXText
]);
isOneOf33([
  NodeType33.JSXIdentifier,
  NodeType33.JSXMemberExpression,
  NodeType33.JSXNamespacedName
]);
isOneOf33([
  NodeType33.ArrayPattern,
  NodeType33.AssignmentPattern,
  NodeType33.ObjectPattern,
  NodeType33.RestElement
]);
isOneOf33([
  NodeType33.TSInterfaceDeclaration,
  NodeType33.TSTypeAliasDeclaration
]);
isOneOf33([
  NodeType33.ArrayExpression,
  NodeType33.ArrayPattern,
  NodeType33.ArrowFunctionExpression,
  NodeType33.CallExpression,
  NodeType33.ClassExpression,
  NodeType33.FunctionExpression,
  NodeType33.Identifier,
  NodeType33.JSXElement,
  NodeType33.JSXFragment,
  NodeType33.Literal,
  NodeType33.TemplateLiteral,
  NodeType33.MemberExpression,
  NodeType33.MetaProperty,
  NodeType33.ObjectExpression,
  NodeType33.ObjectPattern,
  NodeType33.SequenceExpression,
  NodeType33.Super,
  NodeType33.TaggedTemplateExpression,
  NodeType33.ThisExpression
]);
isOneOf33([
  NodeType33.ArrayExpression,
  NodeType33.ArrayPattern,
  NodeType33.ArrowFunctionExpression,
  NodeType33.CallExpression,
  NodeType33.ClassExpression,
  NodeType33.FunctionExpression,
  NodeType33.Identifier,
  NodeType33.JSXElement,
  NodeType33.JSXFragment,
  NodeType33.Literal,
  NodeType33.TemplateLiteral,
  NodeType33.MemberExpression,
  NodeType33.MetaProperty,
  NodeType33.ObjectExpression,
  NodeType33.ObjectPattern,
  NodeType33.SequenceExpression,
  NodeType33.Super,
  NodeType33.TaggedTemplateExpression,
  NodeType33.ThisExpression,
  NodeType33.TSAsExpression,
  NodeType33.TSNonNullExpression,
  NodeType33.TSTypeAssertion
]);
var Function_exports233 = {};
__export233(Function_exports233, {
  SK: () => SK233,
  absurd: () => absurd233,
  apply: () => apply233,
  compose: () => compose233,
  constFalse: () => constFalse233,
  constNull: () => constNull233,
  constTrue: () => constTrue233,
  constUndefined: () => constUndefined233,
  constVoid: () => constVoid233,
  constant: () => constant233,
  dual: () => dual233,
  flip: () => flip233,
  flow: () => flow233,
  hole: () => hole233,
  identity: () => identity233,
  isFunction: () => isFunction2233,
  pipe: () => pipe233,
  satisfies: () => satisfies233,
  tupled: () => tupled233,
  unsafeCoerce: () => unsafeCoerce233,
  untupled: () => untupled233
});
var isFunction2233 = (input) => typeof input === "function";
var dual233 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a2222, b2222) {
        if (arguments.length >= 2) {
          return body(a2222, b2222);
        }
        return function(self2) {
          return body(self2, a2222);
        };
      };
    case 3:
      return function(a2222, b2222, c2222) {
        if (arguments.length >= 3) {
          return body(a2222, b2222, c2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222);
        };
      };
    case 4:
      return function(a2222, b2222, c2222, d2222) {
        if (arguments.length >= 4) {
          return body(a2222, b2222, c2222, d2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222);
        };
      };
    case 5:
      return function(a2222, b2222, c2222, d2222, e2222) {
        if (arguments.length >= 5) {
          return body(a2222, b2222, c2222, d2222, e2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222, d2222);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply233 = (a2222) => (self2) => self2(a2222);
var identity233 = (a2222) => a2222;
var satisfies233 = () => (b2222) => b2222;
var unsafeCoerce233 = identity233;
var constant233 = (value) => () => value;
var constTrue233 = /* @__PURE__ */ constant233(true);
var constFalse233 = /* @__PURE__ */ constant233(false);
var constNull233 = /* @__PURE__ */ constant233(null);
var constUndefined233 = /* @__PURE__ */ constant233(void 0);
var constVoid233 = constUndefined233;
var flip233 = (f2222) => (...b2222) => (...a2222) => f2222(...a2222)(...b2222);
var compose233 = /* @__PURE__ */ dual233(2, (ab, bc) => (a2222) => bc(ab(a2222)));
var absurd233 = (_2222) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled233 = (f2222) => (a2222) => f2222(...a2222);
var untupled233 = (f2222) => (...a2222) => f2222(a2222);
function pipe233(a2222, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a2222;
    case 2:
      return ab(a2222);
    case 3:
      return bc(ab(a2222));
    case 4:
      return cd(bc(ab(a2222)));
    case 5:
      return de(cd(bc(ab(a2222))));
    case 6:
      return ef(de(cd(bc(ab(a2222)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a2222))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a2222)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a2222))))))));
    default: {
      let ret = arguments[0];
      for (let i2222 = 1; i2222 < arguments.length; i2222++) {
        ret = arguments[i2222](ret);
      }
      return ret;
    }
  }
}
function flow233(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole233 = /* @__PURE__ */ unsafeCoerce233(absurd233);
var SK233 = (_2222, b2222) => b2222;
var make433 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_333 = (map622) => dual233(3, (self2, name22, f2222) => map622(self2, (a2222) => Object.assign({}, a2222, {
  [name22]: f2222(a2222)
})));
var bindTo333 = (map622) => dual233(2, (self2, name22) => map622(self2, (a2222) => ({
  [name22]: a2222
})));
var bind333 = (map622, flatMap4222) => dual233(3, (self2, name22, f2222) => flatMap4222(self2, (a2222) => map622(f2222(a2222), (b2222) => Object.assign({}, a2222, {
  [name22]: b2222
}))));
var moduleVersion233 = "3.2.8";
var getCurrentVersion233 = () => moduleVersion233;
var globalStoreId233 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion233()}`);
if (!(globalStoreId233 in globalThis)) {
  globalThis[globalStoreId233] = /* @__PURE__ */ new Map();
}
var globalStore233 = globalThis[globalStoreId233];
var globalValue233 = (id, compute) => {
  if (!globalStore233.has(id)) {
    globalStore233.set(id, compute());
  }
  return globalStore233.get(id);
};
var Predicate_exports233 = {};
__export233(Predicate_exports233, {
  all: () => all233,
  and: () => and53,
  compose: () => compose2233,
  eqv: () => eqv53,
  every: () => every63,
  hasProperty: () => hasProperty233,
  implies: () => implies53,
  isBigInt: () => isBigInt53,
  isBoolean: () => isBoolean53,
  isDate: () => isDate53,
  isError: () => isError53,
  isFunction: () => isFunction3232,
  isIterable: () => isIterable53,
  isMap: () => isMap53,
  isNever: () => isNever53,
  isNotNull: () => isNotNull53,
  isNotNullable: () => isNotNullable53,
  isNotUndefined: () => isNotUndefined53,
  isNull: () => isNull53,
  isNullable: () => isNullable233,
  isNumber: () => isNumber53,
  isObject: () => isObject233,
  isPromise: () => isPromise53,
  isPromiseLike: () => isPromiseLike53,
  isReadonlyRecord: () => isReadonlyRecord53,
  isRecord: () => isRecord53,
  isSet: () => isSet53,
  isString: () => isString53,
  isSymbol: () => isSymbol53,
  isTagged: () => isTagged53,
  isTruthy: () => isTruthy53,
  isUint8Array: () => isUint8Array53,
  isUndefined: () => isUndefined53,
  isUnknown: () => isUnknown53,
  mapInput: () => mapInput63,
  nand: () => nand53,
  nor: () => nor53,
  not: () => not53,
  or: () => or53,
  product: () => product233,
  productMany: () => productMany233,
  some: () => some333,
  struct: () => struct73,
  tuple: () => tuple63,
  xor: () => xor53
});
var mapInput63 = /* @__PURE__ */ dual233(2, (self2, f2222) => (b2222) => self2(f2222(b2222)));
var isTruthy53 = (input) => !!input;
var isSet53 = (input) => input instanceof Set;
var isMap53 = (input) => input instanceof Map;
var isString53 = (input) => typeof input === "string";
var isNumber53 = (input) => typeof input === "number";
var isBoolean53 = (input) => typeof input === "boolean";
var isBigInt53 = (input) => typeof input === "bigint";
var isSymbol53 = (input) => typeof input === "symbol";
var isFunction3232 = isFunction2233;
var isUndefined53 = (input) => input === void 0;
var isNotUndefined53 = (input) => input !== void 0;
var isNull53 = (input) => input === null;
var isNotNull53 = (input) => input !== null;
var isNever53 = (_2222) => false;
var isUnknown53 = (_2222) => true;
var isRecordOrArray233 = (input) => typeof input === "object" && input !== null;
var isObject233 = (input) => isRecordOrArray233(input) || isFunction3232(input);
var hasProperty233 = /* @__PURE__ */ dual233(2, (self2, property) => isObject233(self2) && property in self2);
var isTagged53 = /* @__PURE__ */ dual233(2, (self2, tag) => hasProperty233(self2, "_tag") && self2["_tag"] === tag);
var isNullable233 = (input) => input === null || input === void 0;
var isNotNullable53 = (input) => input !== null && input !== void 0;
var isError53 = (input) => input instanceof Error;
var isUint8Array53 = (input) => input instanceof Uint8Array;
var isDate53 = (input) => input instanceof Date;
var isIterable53 = (input) => hasProperty233(input, Symbol.iterator);
var isRecord53 = (input) => isRecordOrArray233(input) && !Array.isArray(input);
var isReadonlyRecord53 = isRecord53;
var isPromise53 = (input) => hasProperty233(input, "then") && "catch" in input && isFunction3232(input.then) && isFunction3232(input.catch);
var isPromiseLike53 = (input) => hasProperty233(input, "then") && isFunction3232(input.then);
var compose2233 = /* @__PURE__ */ dual233(2, (ab, bc) => (a2222) => ab(a2222) && bc(a2222));
var product233 = (self2, that) => ([a2222, b2222]) => self2(a2222) && that(b2222);
var all233 = (collection) => {
  return (as22322) => {
    let collectionIndex = 0;
    for (const p2222 of collection) {
      if (collectionIndex >= as22322.length) {
        break;
      }
      if (p2222(as22322[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany233 = (self2, collection) => {
  const rest = all233(collection);
  return ([head222, ...tail322]) => self2(head222) === false ? false : rest(tail322);
};
var tuple63 = (...elements) => all233(elements);
var struct73 = (fields) => {
  const keys2322 = Object.keys(fields);
  return (a2222) => {
    for (const key of keys2322) {
      if (!fields[key](a2222[key])) {
        return false;
      }
    }
    return true;
  };
};
var not53 = (self2) => (a2222) => !self2(a2222);
var or53 = /* @__PURE__ */ dual233(2, (self2, that) => (a2222) => self2(a2222) || that(a2222));
var and53 = /* @__PURE__ */ dual233(2, (self2, that) => (a2222) => self2(a2222) && that(a2222));
var xor53 = /* @__PURE__ */ dual233(2, (self2, that) => (a2222) => self2(a2222) !== that(a2222));
var eqv53 = /* @__PURE__ */ dual233(2, (self2, that) => (a2222) => self2(a2222) === that(a2222));
var implies53 = /* @__PURE__ */ dual233(2, (self2, that) => (a2222) => self2(a2222) ? that(a2222) : true);
var nor53 = /* @__PURE__ */ dual233(2, (self2, that) => (a2222) => !(self2(a2222) || that(a2222)));
var nand53 = /* @__PURE__ */ dual233(2, (self2, that) => (a2222) => !(self2(a2222) && that(a2222)));
var every63 = (collection) => (a2222) => {
  for (const p2222 of collection) {
    if (!p2222(a2222)) {
      return false;
    }
  }
  return true;
};
var some333 = (collection) => (a2222) => {
  for (const p2222 of collection) {
    if (p2222(a2222)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage233 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId233 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind233 = (u2222) => isObject233(u2222) && GenKindTypeId233 in u2222;
var GenKindImpl233 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity233;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId233] = GenKindTypeId233;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen233(this);
  }
};
var SingleShotGen233 = class _SingleShotGen63 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a2222) {
    return this.called ? {
      value: a2222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a2222) {
    return {
      value: a2222,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e2222) {
    throw e2222;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen63(this.self);
  }
};
var adapter333 = () => function() {
  let x2222 = arguments[0];
  for (let i2222 = 1; i2222 < arguments.length; i2222++) {
    x2222 = arguments[i2222](x2222);
  }
  return new GenKindImpl233(x2222);
};
var defaultIncHi233 = 335903614;
var defaultIncLo233 = 4150755663;
var MUL_HI233 = 1481765933 >>> 0;
var MUL_LO233 = 1284865837 >>> 0;
var BIT_53233 = 9007199254740992;
var BIT_27233 = 134217728;
var PCGRandom233 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable233(seedLo) && isNullable233(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable233(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable233(incLo) && isNullable233(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo233;
      incHi = this._state ? this._state[2] : defaultIncHi233;
    } else if (isNullable233(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add64233(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max322) {
    if (!max322) {
      return this._next();
    }
    max322 = max322 >>> 0;
    if ((max322 & max322 - 1) === 0) {
      return this._next() & max322 - 1;
    }
    let num = 0;
    const skew = (-max322 >>> 0) % max322 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max322;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_27233 + lo) / BIT_53233;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul64233(this._state, oldHi, oldLo, MUL_HI233, MUL_LO233);
    add64233(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul64233(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add64233(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId233 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap233 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId233]() {
    return this.#value;
  }
};
function yieldWrapGet233(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId233 in self2) {
    return self2[YieldWrapTypeId233]();
  }
  throw new Error(getBugErrorMessage233("yieldWrapGet"));
}
var structuralRegionState233 = /* @__PURE__ */ globalValue233("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache233 = /* @__PURE__ */ globalValue233(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr233 = /* @__PURE__ */ globalValue233(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom233());
var symbol333 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash233 = (self2) => {
  if (structuralRegionState233.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number233(self2);
    case "bigint":
      return string233(self2.toString(10));
    case "boolean":
      return string233(String(self2));
    case "symbol":
      return string233(String(self2));
    case "string":
      return string233(self2);
    case "undefined":
      return string233("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string233("null");
      } else if (self2 instanceof Date) {
        return hash233(self2.toISOString());
      } else if (isHash233(self2)) {
        return self2[symbol333]();
      } else {
        return random233(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random233 = (self2) => {
  if (!randomHashCache233.has(self2)) {
    randomHashCache233.set(self2, number233(pcgr233.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache233.get(self2);
};
var combine233 = (b2222) => (self2) => self2 * 53 ^ b2222;
var optimize233 = (n2222) => n2222 & 3221225471 | n2222 >>> 1 & 1073741824;
var isHash233 = (u2222) => hasProperty233(u2222, symbol333);
var number233 = (n2222) => {
  if (n2222 !== n2222 || n2222 === Infinity) {
    return 0;
  }
  let h2222 = n2222 | 0;
  if (h2222 !== n2222) {
    h2222 ^= n2222 * 4294967295;
  }
  while (n2222 > 4294967295) {
    h2222 ^= n2222 /= 4294967295;
  }
  return optimize233(n2222);
};
var string233 = (str) => {
  let h2222 = 5381, i2222 = str.length;
  while (i2222) {
    h2222 = h2222 * 33 ^ str.charCodeAt(--i2222);
  }
  return optimize233(h2222);
};
var structureKeys233 = (o2222, keys2322) => {
  let h2222 = 12289;
  for (let i2222 = 0; i2222 < keys2322.length; i2222++) {
    h2222 ^= pipe233(string233(keys2322[i2222]), combine233(hash233(o2222[keys2322[i2222]])));
  }
  return optimize233(h2222);
};
var structure233 = (o2222) => structureKeys233(o2222, Object.keys(o2222));
var array73 = (arr) => {
  let h2222 = 6151;
  for (let i2222 = 0; i2222 < arr.length; i2222++) {
    h2222 = pipe233(h2222, combine233(hash233(arr[i2222])));
  }
  return optimize233(h2222);
};
var cached233 = function() {
  if (arguments.length === 1) {
    const self22 = arguments[0];
    return function(hash3222) {
      Object.defineProperty(self22, symbol333, {
        value() {
          return hash3222;
        },
        enumerable: false
      });
      return hash3222;
    };
  }
  const self2 = arguments[0];
  const hash22322 = arguments[1];
  Object.defineProperty(self2, symbol333, {
    value() {
      return hash22322;
    },
    enumerable: false
  });
  return hash22322;
};
var symbol2233 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals233() {
  if (arguments.length === 1) {
    return (self2) => compareBoth233(self2, arguments[0]);
  }
  return compareBoth233(arguments[0], arguments[1]);
}
function compareBoth233(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual233(self2) && isEqual233(that)) {
        if (hash233(self2) === hash233(that) && self2[symbol2233](that)) {
          return true;
        } else {
          return structuralRegionState233.enabled && structuralRegionState233.tester ? structuralRegionState233.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState233.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v2222, i2222) => compareBoth233(v2222, that[i2222]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth233(self2[key], that[key]))) {
              return structuralRegionState233.tester ? structuralRegionState233.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState233.tester ? structuralRegionState233.tester(self2, that) : false;
    }
  }
  return structuralRegionState233.enabled && structuralRegionState233.tester ? structuralRegionState233.tester(self2, that) : false;
}
var isEqual233 = (u2222) => hasProperty233(u2222, symbol2233);
var equivalence233 = () => equals233;
var NodeInspectSymbol233 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON233 = (x2222) => {
  if (hasProperty233(x2222, "toJSON") && isFunction3232(x2222["toJSON"]) && x2222["toJSON"].length === 0) {
    return x2222.toJSON();
  } else if (Array.isArray(x2222)) {
    return x2222.map(toJSON233);
  }
  return x2222;
};
var format233 = (x2222) => JSON.stringify(x2222, null, 2);
var pipeArguments233 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i2222 = 0, len = args.length; i2222 < len; i2222++) {
        ret = args[i2222](ret);
      }
      return ret;
    }
  }
};
var OP_COMMIT233 = "Commit";
var OP_FAILURE33 = "Failure";
var OP_WITH_RUNTIME33 = "WithRuntime";
var EffectTypeId233 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId233 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId233 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId233 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance233 = {
  /* c8 ignore next */
  _R: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _A: (_2222) => _2222,
  _V: /* @__PURE__ */ getCurrentVersion233()
};
var sinkVariance233 = {
  /* c8 ignore next */
  _A: (_2222) => _2222,
  /* c8 ignore next */
  _In: (_2222) => _2222,
  /* c8 ignore next */
  _L: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _R: (_2222) => _2222
};
var channelVariance233 = {
  /* c8 ignore next */
  _Env: (_2222) => _2222,
  /* c8 ignore next */
  _InErr: (_2222) => _2222,
  /* c8 ignore next */
  _InElem: (_2222) => _2222,
  /* c8 ignore next */
  _InDone: (_2222) => _2222,
  /* c8 ignore next */
  _OutErr: (_2222) => _2222,
  /* c8 ignore next */
  _OutElem: (_2222) => _2222,
  /* c8 ignore next */
  _OutDone: (_2222) => _2222
};
var EffectPrototype233 = {
  [EffectTypeId233]: effectVariance233,
  [StreamTypeId233]: effectVariance233,
  [SinkTypeId233]: sinkVariance233,
  [ChannelTypeId233]: channelVariance233,
  [symbol2233](that) {
    return this === that;
  },
  [symbol333]() {
    return cached233(this, random233(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen233(new YieldWrap233(this));
  },
  pipe() {
    return pipeArguments233(this, arguments);
  }
};
var StructuralPrototype233 = {
  [symbol333]() {
    return cached233(this, structure233(this));
  },
  [symbol2233](that) {
    const selfKeys = Object.keys(this);
    const thatKeys = Object.keys(that);
    if (selfKeys.length !== thatKeys.length) {
      return false;
    }
    for (const key of selfKeys) {
      if (!(key in that && equals233(this[key], that[key]))) {
        return false;
      }
    }
    return true;
  }
};
var CommitPrototype233 = {
  ...EffectPrototype233,
  _op: OP_COMMIT233
};
var StructuralCommitPrototype233 = {
  ...CommitPrototype233,
  ...StructuralPrototype233
};
var TypeId533 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto333 = {
  ...EffectPrototype233,
  [TypeId533]: {
    _A: (_2222) => _2222
  },
  [NodeInspectSymbol233]() {
    return this.toJSON();
  },
  toString() {
    return format233(this.toJSON());
  }
};
var SomeProto233 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto333), {
  _tag: "Some",
  _op: "Some",
  [symbol2233](that) {
    return isOption333(that) && isSome333(that) && equals233(this.value, that.value);
  },
  [symbol333]() {
    return cached233(this, combine233(hash233(this._tag))(hash233(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON233(this.value)
    };
  }
});
var NoneHash233 = /* @__PURE__ */ hash233("None");
var NoneProto233 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto333), {
  _tag: "None",
  _op: "None",
  [symbol2233](that) {
    return isOption333(that) && isNone333(that);
  },
  [symbol333]() {
    return NoneHash233;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption333 = (input) => hasProperty233(input, TypeId533);
var isNone333 = (fa) => fa._tag === "None";
var isSome333 = (fa) => fa._tag === "Some";
var none333 = /* @__PURE__ */ Object.create(NoneProto233);
var some2233 = (value) => {
  const a2222 = Object.create(SomeProto233);
  a2222.value = value;
  return a2222;
};
var TypeId2233 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto2233 = {
  ...EffectPrototype233,
  [TypeId2233]: {
    _R: (_2222) => _2222
  },
  [NodeInspectSymbol233]() {
    return this.toJSON();
  },
  toString() {
    return format233(this.toJSON());
  }
};
var RightProto233 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto2233), {
  _tag: "Right",
  _op: "Right",
  [symbol2233](that) {
    return isEither233(that) && isRight233(that) && equals233(this.right, that.right);
  },
  [symbol333]() {
    return combine233(hash233(this._tag))(hash233(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON233(this.right)
    };
  }
});
var LeftProto233 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto2233), {
  _tag: "Left",
  _op: "Left",
  [symbol2233](that) {
    return isEither233(that) && isLeft233(that) && equals233(this.left, that.left);
  },
  [symbol333]() {
    return combine233(hash233(this._tag))(hash233(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON233(this.left)
    };
  }
});
var isEither233 = (input) => hasProperty233(input, TypeId2233);
var isLeft233 = (ma) => ma._tag === "Left";
var isRight233 = (ma) => ma._tag === "Right";
var left233 = (left3322) => {
  const a2222 = Object.create(LeftProto233);
  a2222.left = left3322;
  return a2222;
};
var right233 = (right3322) => {
  const a2222 = Object.create(RightProto233);
  a2222.right = right3322;
  return a2222;
};
var getLeft333 = (self2) => isRight233(self2) ? none333 : some2233(self2.left);
var getRight333 = (self2) => isLeft233(self2) ? none333 : some2233(self2.right);
var right2233 = right233;
var left2233 = left233;
var Option_exports233 = {};
__export233(Option_exports233, {
  Do: () => Do233,
  TypeId: () => TypeId3233,
  all: () => all2233,
  andThen: () => andThen233,
  ap: () => ap233,
  as: () => as233,
  asVoid: () => asVoid233,
  bind: () => bind2233,
  bindTo: () => bindTo2233,
  composeK: () => composeK233,
  contains: () => contains233,
  containsWith: () => containsWith233,
  exists: () => exists233,
  filter: () => filter233,
  filterMap: () => filterMap233,
  firstSomeOf: () => firstSomeOf233,
  flatMap: () => flatMap233,
  flatMapNullable: () => flatMapNullable233,
  flatten: () => flatten233,
  fromIterable: () => fromIterable233,
  fromNullable: () => fromNullable233,
  gen: () => gen233,
  getEquivalence: () => getEquivalence233,
  getLeft: () => getLeft2233,
  getOrElse: () => getOrElse233,
  getOrNull: () => getOrNull233,
  getOrThrow: () => getOrThrow233,
  getOrThrowWith: () => getOrThrowWith233,
  getOrUndefined: () => getOrUndefined233,
  getOrder: () => getOrder233,
  getRight: () => getRight2233,
  isNone: () => isNone2233,
  isOption: () => isOption2233,
  isSome: () => isSome2233,
  let: () => let_2233,
  lift2: () => lift2233,
  liftNullable: () => liftNullable233,
  liftPredicate: () => liftPredicate233,
  liftThrowable: () => liftThrowable233,
  map: () => map233,
  match: () => match233,
  none: () => none2233,
  orElse: () => orElse233,
  orElseEither: () => orElseEither233,
  orElseSome: () => orElseSome233,
  partitionMap: () => partitionMap233,
  product: () => product2233,
  productMany: () => productMany2233,
  reduceCompact: () => reduceCompact233,
  some: () => some3233,
  tap: () => tap233,
  toArray: () => toArray233,
  toRefinement: () => toRefinement233,
  void: () => void_233,
  zipLeft: () => zipLeft233,
  zipRight: () => zipRight233,
  zipWith: () => zipWith233
});
var make2233 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId3233 = /* @__PURE__ */ Symbol.for("effect/Option");
var none2233 = () => none333;
var some3233 = some2233;
var isOption2233 = isOption333;
var isNone2233 = isNone333;
var isSome2233 = isSome333;
var match233 = /* @__PURE__ */ dual233(2, (self2, {
  onNone,
  onSome
}) => isNone2233(self2) ? onNone() : onSome(self2.value));
var toRefinement233 = (f2222) => (a2222) => isSome2233(f2222(a2222));
var fromIterable233 = (collection) => {
  for (const a2222 of collection) {
    return some3233(a2222);
  }
  return none2233();
};
var getRight2233 = getRight333;
var getLeft2233 = getLeft333;
var getOrElse233 = /* @__PURE__ */ dual233(2, (self2, onNone) => isNone2233(self2) ? onNone() : self2.value);
var orElse233 = /* @__PURE__ */ dual233(2, (self2, that) => isNone2233(self2) ? that() : self2);
var orElseSome233 = /* @__PURE__ */ dual233(2, (self2, onNone) => isNone2233(self2) ? some3233(onNone()) : self2);
var orElseEither233 = /* @__PURE__ */ dual233(2, (self2, that) => isNone2233(self2) ? map233(that(), right233) : map233(self2, left233));
var firstSomeOf233 = (collection) => {
  let out = none2233();
  for (out of collection) {
    if (isSome2233(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable233 = (nullableValue) => nullableValue == null ? none2233() : some3233(nullableValue);
var liftNullable233 = (f2222) => (...a2222) => fromNullable233(f2222(...a2222));
var getOrNull233 = /* @__PURE__ */ getOrElse233(constNull233);
var getOrUndefined233 = /* @__PURE__ */ getOrElse233(constUndefined233);
var liftThrowable233 = (f2222) => (...a2222) => {
  try {
    return some3233(f2222(...a2222));
  } catch (e2222) {
    return none2233();
  }
};
var getOrThrowWith233 = /* @__PURE__ */ dual233(2, (self2, onNone) => {
  if (isSome2233(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow233 = /* @__PURE__ */ getOrThrowWith233(() => new Error("getOrThrow called on a None"));
var map233 = /* @__PURE__ */ dual233(2, (self2, f2222) => isNone2233(self2) ? none2233() : some3233(f2222(self2.value)));
var as233 = /* @__PURE__ */ dual233(2, (self2, b2222) => map233(self2, () => b2222));
var asVoid233 = /* @__PURE__ */ as233(void 0);
var void_233 = /* @__PURE__ */ some3233(void 0);
var flatMap233 = /* @__PURE__ */ dual233(2, (self2, f2222) => isNone2233(self2) ? none2233() : f2222(self2.value));
var andThen233 = /* @__PURE__ */ dual233(2, (self2, f2222) => flatMap233(self2, (a2222) => {
  const b2222 = isFunction2233(f2222) ? f2222(a2222) : f2222;
  return isOption2233(b2222) ? b2222 : some3233(b2222);
}));
var flatMapNullable233 = /* @__PURE__ */ dual233(2, (self2, f2222) => isNone2233(self2) ? none2233() : fromNullable233(f2222(self2.value)));
var flatten233 = /* @__PURE__ */ flatMap233(identity233);
var zipRight233 = /* @__PURE__ */ dual233(2, (self2, that) => flatMap233(self2, () => that));
var composeK233 = /* @__PURE__ */ dual233(2, (afb, bfc) => (a2222) => flatMap233(afb(a2222), bfc));
var zipLeft233 = /* @__PURE__ */ dual233(2, (self2, that) => tap233(self2, () => that));
var tap233 = /* @__PURE__ */ dual233(2, (self2, f2222) => flatMap233(self2, (a2222) => map233(f2222(a2222), () => a2222)));
var product2233 = (self2, that) => isSome2233(self2) && isSome2233(that) ? some3233([self2.value, that.value]) : none2233();
var productMany2233 = (self2, collection) => {
  if (isNone2233(self2)) {
    return none2233();
  }
  const out = [self2.value];
  for (const o2222 of collection) {
    if (isNone2233(o2222)) {
      return none2233();
    }
    out.push(o2222.value);
  }
  return some3233(out);
};
var all2233 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o2222 of input) {
      if (isNone2233(o2222)) {
        return none2233();
      }
      out2.push(o2222.value);
    }
    return some3233(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o2222 = input[key];
    if (isNone2233(o2222)) {
      return none2233();
    }
    out[key] = o2222.value;
  }
  return some3233(out);
};
var zipWith233 = /* @__PURE__ */ dual233(3, (self2, that, f2222) => map233(product2233(self2, that), ([a2222, b2222]) => f2222(a2222, b2222)));
var ap233 = /* @__PURE__ */ dual233(2, (self2, that) => zipWith233(self2, that, (f2222, a2222) => f2222(a2222)));
var reduceCompact233 = /* @__PURE__ */ dual233(3, (self2, b2222, f2222) => {
  let out = b2222;
  for (const oa of self2) {
    if (isSome2233(oa)) {
      out = f2222(out, oa.value);
    }
  }
  return out;
});
var toArray233 = (self2) => isNone2233(self2) ? [] : [self2.value];
var partitionMap233 = /* @__PURE__ */ dual233(2, (self2, f2222) => {
  if (isNone2233(self2)) {
    return [none2233(), none2233()];
  }
  const e2222 = f2222(self2.value);
  return isLeft233(e2222) ? [some3233(e2222.left), none2233()] : [none2233(), some3233(e2222.right)];
});
var filterMap233 = /* @__PURE__ */ dual233(2, (self2, f2222) => isNone2233(self2) ? none2233() : f2222(self2.value));
var filter233 = /* @__PURE__ */ dual233(2, (self2, predicate) => filterMap233(self2, (b2222) => predicate(b2222) ? some2233(b2222) : none333));
var getEquivalence233 = (isEquivalent) => make433((x2222, y2222) => x2222 === y2222 || (isNone2233(x2222) ? isNone2233(y2222) : isNone2233(y2222) ? false : isEquivalent(x2222.value, y2222.value)));
var getOrder233 = (O2222) => make2233((self2, that) => isSome2233(self2) ? isSome2233(that) ? O2222(self2.value, that.value) : 1 : -1);
var lift2233 = (f2222) => dual233(2, (self2, that) => zipWith233(self2, that, f2222));
var liftPredicate233 = (predicate) => (b2222) => predicate(b2222) ? some3233(b2222) : none2233();
var containsWith233 = (isEquivalent) => dual233(2, (self2, a2222) => isNone2233(self2) ? false : isEquivalent(self2.value, a2222));
var _equivalence233 = /* @__PURE__ */ equivalence233();
var contains233 = /* @__PURE__ */ containsWith233(_equivalence233);
var exists233 = /* @__PURE__ */ dual233(2, (self2, refinement) => isNone2233(self2) ? false : refinement(self2.value));
var bindTo2233 = /* @__PURE__ */ bindTo333(map233);
var let_2233 = /* @__PURE__ */ let_333(map233);
var bind2233 = /* @__PURE__ */ bind333(map233, flatMap233);
var Do233 = /* @__PURE__ */ some3233({});
var adapter2233 = /* @__PURE__ */ adapter333();
var gen233 = (f2222) => {
  const iterator = f2222(adapter2233);
  let state = iterator.next();
  if (state.done) {
    return some3233(state.value);
  } else {
    let current = state.value;
    if (isGenKind233(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet233(current);
    }
    if (isNone2233(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind233(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet233(current);
        }
        if (isNone2233(current)) {
          return current;
        }
      }
    }
    return some3233(state.value);
  }
};
var fromIterable2233 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var reverse53 = (self2) => Array.from(self2).reverse();
var reduce63 = /* @__PURE__ */ dual233(3, (self2, b2222, f2222) => fromIterable2233(self2).reduce((b22222, a2222, i2222) => f2222(b22222, a2222, i2222), b2222));
var TagTypeId33 = /* @__PURE__ */ Symbol.for("effect/Context/Tag");
var STMSymbolKey33 = "effect/STM";
var STMTypeId33 = /* @__PURE__ */ Symbol.for(STMSymbolKey33);
var TagProto33 = {
  ...EffectPrototype233,
  _tag: "Tag",
  _op: "Tag",
  [STMTypeId33]: effectVariance233,
  [TagTypeId33]: {
    _Service: (_2222) => _2222,
    _Identifier: (_2222) => _2222
  },
  toString() {
    return format233(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Tag",
      key: this.key,
      stack: this.stack
    };
  },
  [NodeInspectSymbol233]() {
    return this.toJSON();
  },
  of(self2) {
    return self2;
  },
  context(self2) {
    return make3233(this, self2);
  }
};
var makeGenericTag33 = (key) => {
  const limit = Error.stackTraceLimit;
  Error.stackTraceLimit = 2;
  const creationError = new Error();
  Error.stackTraceLimit = limit;
  const tag = Object.create(TagProto33);
  Object.defineProperty(tag, "stack", {
    get() {
      return creationError.stack;
    }
  });
  tag.key = key;
  return tag;
};
var TypeId4233 = /* @__PURE__ */ Symbol.for("effect/Context");
var ContextProto33 = {
  [TypeId4233]: {
    _Services: (_2222) => _2222
  },
  [symbol2233](that) {
    if (isContext33(that)) {
      if (this.unsafeMap.size === that.unsafeMap.size) {
        for (const k2222 of this.unsafeMap.keys()) {
          if (!that.unsafeMap.has(k2222) || !equals233(this.unsafeMap.get(k2222), that.unsafeMap.get(k2222))) {
            return false;
          }
        }
        return true;
      }
    }
    return false;
  },
  [symbol333]() {
    return cached233(this, number233(this.unsafeMap.size));
  },
  pipe() {
    return pipeArguments233(this, arguments);
  },
  toString() {
    return format233(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Context",
      services: Array.from(this.unsafeMap).map(toJSON233)
    };
  },
  [NodeInspectSymbol233]() {
    return this.toJSON();
  }
};
var makeContext33 = (unsafeMap) => {
  const context = Object.create(ContextProto33);
  context.unsafeMap = unsafeMap;
  return context;
};
var isContext33 = (u2222) => hasProperty233(u2222, TypeId4233);
var _empty73 = /* @__PURE__ */ makeContext33(/* @__PURE__ */ new Map());
var empty123 = () => _empty73;
var make3233 = (tag, service) => makeContext33(/* @__PURE__ */ new Map([[tag.key, service]]));
var GenericTag33 = makeGenericTag33;
var empty233 = empty123;
var TypeId5233 = /* @__PURE__ */ Symbol.for("effect/Chunk");
function copy43(src, srcPos, dest, destPos, len) {
  for (let i2222 = srcPos; i2222 < Math.min(src.length, srcPos + len); i2222++) {
    dest[destPos + i2222 - srcPos] = src[i2222];
  }
  return dest;
}
var emptyArray33 = [];
var getEquivalence2233 = (isEquivalent) => make433((self2, that) => self2.length === that.length && toReadonlyArray33(self2).every((value, i2222) => isEquivalent(value, unsafeGet233(that, i2222))));
var _equivalence2233 = /* @__PURE__ */ getEquivalence2233(equals233);
var ChunkProto33 = {
  [TypeId5233]: {
    _A: (_2222) => _2222
  },
  toString() {
    return format233(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Chunk",
      values: toReadonlyArray33(this).map(toJSON233)
    };
  },
  [NodeInspectSymbol233]() {
    return this.toJSON();
  },
  [symbol2233](that) {
    return isChunk33(that) && _equivalence2233(this, that);
  },
  [symbol333]() {
    return cached233(this, array73(toReadonlyArray33(this)));
  },
  [Symbol.iterator]() {
    switch (this.backing._tag) {
      case "IArray": {
        return this.backing.array[Symbol.iterator]();
      }
      case "IEmpty": {
        return emptyArray33[Symbol.iterator]();
      }
      default: {
        return toReadonlyArray33(this)[Symbol.iterator]();
      }
    }
  },
  pipe() {
    return pipeArguments233(this, arguments);
  }
};
var makeChunk33 = (backing) => {
  const chunk = Object.create(ChunkProto33);
  chunk.backing = backing;
  switch (backing._tag) {
    case "IEmpty": {
      chunk.length = 0;
      chunk.depth = 0;
      chunk.left = chunk;
      chunk.right = chunk;
      break;
    }
    case "IConcat": {
      chunk.length = backing.left.length + backing.right.length;
      chunk.depth = 1 + Math.max(backing.left.depth, backing.right.depth);
      chunk.left = backing.left;
      chunk.right = backing.right;
      break;
    }
    case "IArray": {
      chunk.length = backing.array.length;
      chunk.depth = 0;
      chunk.left = _empty233;
      chunk.right = _empty233;
      break;
    }
    case "ISingleton": {
      chunk.length = 1;
      chunk.depth = 0;
      chunk.left = _empty233;
      chunk.right = _empty233;
      break;
    }
    case "ISlice": {
      chunk.length = backing.length;
      chunk.depth = backing.chunk.depth + 1;
      chunk.left = _empty233;
      chunk.right = _empty233;
      break;
    }
  }
  return chunk;
};
var isChunk33 = (u2222) => hasProperty233(u2222, TypeId5233);
var _empty233 = /* @__PURE__ */ makeChunk33({
  _tag: "IEmpty"
});
var empty333 = () => _empty233;
var make4233 = (...as22322) => as22322.length === 1 ? of43(as22322[0]) : unsafeFromNonEmptyArray33(as22322);
var of43 = (a2222) => makeChunk33({
  _tag: "ISingleton",
  a: a2222
});
var copyToArray33 = (self2, array3322, initial) => {
  switch (self2.backing._tag) {
    case "IArray": {
      copy43(self2.backing.array, 0, array3322, initial, self2.length);
      break;
    }
    case "IConcat": {
      copyToArray33(self2.left, array3322, initial);
      copyToArray33(self2.right, array3322, initial + self2.left.length);
      break;
    }
    case "ISingleton": {
      array3322[initial] = self2.backing.a;
      break;
    }
    case "ISlice": {
      let i2222 = 0;
      let j2222 = initial;
      while (i2222 < self2.length) {
        array3322[j2222] = unsafeGet233(self2, i2222);
        i2222 += 1;
        j2222 += 1;
      }
      break;
    }
  }
};
var toReadonlyArray33 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      return emptyArray33;
    }
    case "IArray": {
      return self2.backing.array;
    }
    default: {
      const arr = new Array(self2.length);
      copyToArray33(self2, arr, 0);
      self2.backing = {
        _tag: "IArray",
        array: arr
      };
      self2.left = _empty233;
      self2.right = _empty233;
      self2.depth = 0;
      return arr;
    }
  }
};
var reverse233 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty":
    case "ISingleton":
      return self2;
    case "IArray": {
      return makeChunk33({
        _tag: "IArray",
        array: reverse53(self2.backing.array)
      });
    }
    case "IConcat": {
      return makeChunk33({
        _tag: "IConcat",
        left: reverse233(self2.backing.right),
        right: reverse233(self2.backing.left)
      });
    }
    case "ISlice":
      return unsafeFromArray33(reverse53(toReadonlyArray33(self2)));
  }
};
var unsafeFromArray33 = (self2) => makeChunk33({
  _tag: "IArray",
  array: self2
});
var unsafeFromNonEmptyArray33 = (self2) => unsafeFromArray33(self2);
var unsafeGet233 = /* @__PURE__ */ dual233(2, (self2, index) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      throw new Error(`Index out of bounds`);
    }
    case "ISingleton": {
      if (index !== 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.a;
    }
    case "IArray": {
      if (index >= self2.length || index < 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.array[index];
    }
    case "IConcat": {
      return index < self2.left.length ? unsafeGet233(self2.left, index) : unsafeGet233(self2.right, index - self2.left.length);
    }
    case "ISlice": {
      return unsafeGet233(self2.backing.chunk, index + self2.backing.offset);
    }
  }
});
var prepend53 = /* @__PURE__ */ dual233(2, (self2, elem) => appendAll43(of43(elem), self2));
var drop43 = /* @__PURE__ */ dual233(2, (self2, n2222) => {
  if (n2222 <= 0) {
    return self2;
  } else if (n2222 >= self2.length) {
    return _empty233;
  } else {
    switch (self2.backing._tag) {
      case "ISlice": {
        return makeChunk33({
          _tag: "ISlice",
          chunk: self2.backing.chunk,
          offset: self2.backing.offset + n2222,
          length: self2.backing.length - n2222
        });
      }
      case "IConcat": {
        if (n2222 > self2.left.length) {
          return drop43(self2.right, n2222 - self2.left.length);
        }
        return makeChunk33({
          _tag: "IConcat",
          left: drop43(self2.left, n2222),
          right: self2.right
        });
      }
      default: {
        return makeChunk33({
          _tag: "ISlice",
          chunk: self2,
          offset: n2222,
          length: self2.length - n2222
        });
      }
    }
  }
});
var appendAll43 = /* @__PURE__ */ dual233(2, (self2, that) => {
  if (self2.backing._tag === "IEmpty") {
    return that;
  }
  if (that.backing._tag === "IEmpty") {
    return self2;
  }
  const diff2322 = that.depth - self2.depth;
  if (Math.abs(diff2322) <= 1) {
    return makeChunk33({
      _tag: "IConcat",
      left: self2,
      right: that
    });
  } else if (diff2322 < -1) {
    if (self2.left.depth >= self2.right.depth) {
      const nr = appendAll43(self2.right, that);
      return makeChunk33({
        _tag: "IConcat",
        left: self2.left,
        right: nr
      });
    } else {
      const nrr = appendAll43(self2.right.right, that);
      if (nrr.depth === self2.depth - 3) {
        const nr = makeChunk33({
          _tag: "IConcat",
          left: self2.right.left,
          right: nrr
        });
        return makeChunk33({
          _tag: "IConcat",
          left: self2.left,
          right: nr
        });
      } else {
        const nl = makeChunk33({
          _tag: "IConcat",
          left: self2.left,
          right: self2.right.left
        });
        return makeChunk33({
          _tag: "IConcat",
          left: nl,
          right: nrr
        });
      }
    }
  } else {
    if (that.right.depth >= that.left.depth) {
      const nl = appendAll43(self2, that.left);
      return makeChunk33({
        _tag: "IConcat",
        left: nl,
        right: that.right
      });
    } else {
      const nll = appendAll43(self2, that.left.left);
      if (nll.depth === that.depth - 3) {
        const nl = makeChunk33({
          _tag: "IConcat",
          left: nll,
          right: that.left.right
        });
        return makeChunk33({
          _tag: "IConcat",
          left: nl,
          right: that.right
        });
      } else {
        const nr = makeChunk33({
          _tag: "IConcat",
          left: that.left.right,
          right: that.right
        });
        return makeChunk33({
          _tag: "IConcat",
          left: nll,
          right: nr
        });
      }
    }
  }
});
var isEmpty43 = (self2) => self2.length === 0;
var isNonEmpty33 = (self2) => self2.length > 0;
var unsafeHead33 = (self2) => unsafeGet233(self2, 0);
var headNonEmpty43 = unsafeHead33;
var tailNonEmpty43 = (self2) => drop43(self2, 1);
var SIZE33 = 5;
var BUCKET_SIZE33 = /* @__PURE__ */ Math.pow(2, SIZE33);
var MASK33 = BUCKET_SIZE33 - 1;
var MAX_INDEX_NODE33 = BUCKET_SIZE33 / 2;
var MIN_ARRAY_NODE33 = BUCKET_SIZE33 / 4;
function popcount33(x2222) {
  x2222 -= x2222 >> 1 & 1431655765;
  x2222 = (x2222 & 858993459) + (x2222 >> 2 & 858993459);
  x2222 = x2222 + (x2222 >> 4) & 252645135;
  x2222 += x2222 >> 8;
  x2222 += x2222 >> 16;
  return x2222 & 127;
}
function hashFragment33(shift22, h2222) {
  return h2222 >>> shift22 & MASK33;
}
function toBitmap33(x2222) {
  return 1 << x2222;
}
function fromBitmap33(bitmap, bit) {
  return popcount33(bitmap & bit - 1);
}
var make533 = (value, previous) => ({
  value,
  previous
});
function arrayUpdate33(mutate2322, at, v2222, arr) {
  let out = arr;
  if (!mutate2322) {
    const len = arr.length;
    out = new Array(len);
    for (let i2222 = 0; i2222 < len; ++i2222) out[i2222] = arr[i2222];
  }
  out[at] = v2222;
  return out;
}
function arraySpliceOut33(mutate2322, at, arr) {
  const newLen = arr.length - 1;
  let i2222 = 0;
  let g2222 = 0;
  let out = arr;
  if (mutate2322) {
    i2222 = g2222 = at;
  } else {
    out = new Array(newLen);
    while (i2222 < at) out[g2222++] = arr[i2222++];
  }
  ++i2222;
  while (i2222 <= newLen) out[g2222++] = arr[i2222++];
  if (mutate2322) {
    out.length = newLen;
  }
  return out;
}
function arraySpliceIn33(mutate2322, at, v2222, arr) {
  const len = arr.length;
  if (mutate2322) {
    let i22222 = len;
    while (i22222 >= at) arr[i22222--] = arr[i22222];
    arr[at] = v2222;
    return arr;
  }
  let i2222 = 0, g2222 = 0;
  const out = new Array(len + 1);
  while (i2222 < at) out[g2222++] = arr[i2222++];
  out[at] = v2222;
  while (i2222 < len) out[++g2222] = arr[i2222++];
  return out;
}
var EmptyNode33 = class _EmptyNode33 {
  _tag = "EmptyNode";
  modify(edit, _shift, f2222, hash22322, key, size4322) {
    const v2222 = f2222(none2233());
    if (isNone2233(v2222)) return new _EmptyNode33();
    ++size4322.value;
    return new LeafNode33(edit, hash22322, key, v2222);
  }
};
function isEmptyNode33(a2222) {
  return isTagged53(a2222, "EmptyNode");
}
function isLeafNode33(node) {
  return isEmptyNode33(node) || node._tag === "LeafNode" || node._tag === "CollisionNode";
}
function canEditNode33(node, edit) {
  return isEmptyNode33(node) ? false : edit === node.edit;
}
var LeafNode33 = class _LeafNode33 {
  edit;
  hash;
  key;
  value;
  _tag = "LeafNode";
  constructor(edit, hash22322, key, value) {
    this.edit = edit;
    this.hash = hash22322;
    this.key = key;
    this.value = value;
  }
  modify(edit, shift22, f2222, hash22322, key, size4322) {
    if (equals233(key, this.key)) {
      const v22222 = f2222(this.value);
      if (v22222 === this.value) return this;
      else if (isNone2233(v22222)) {
        --size4322.value;
        return new EmptyNode33();
      }
      if (canEditNode33(this, edit)) {
        this.value = v22222;
        return this;
      }
      return new _LeafNode33(edit, hash22322, key, v22222);
    }
    const v2222 = f2222(none2233());
    if (isNone2233(v2222)) return this;
    ++size4322.value;
    return mergeLeaves33(edit, shift22, this.hash, this, hash22322, new _LeafNode33(edit, hash22322, key, v2222));
  }
};
var CollisionNode33 = class _CollisionNode33 {
  edit;
  hash;
  children;
  _tag = "CollisionNode";
  constructor(edit, hash22322, children) {
    this.edit = edit;
    this.hash = hash22322;
    this.children = children;
  }
  modify(edit, shift22, f2222, hash22322, key, size4322) {
    if (hash22322 === this.hash) {
      const canEdit = canEditNode33(this, edit);
      const list = this.updateCollisionList(canEdit, edit, this.hash, this.children, f2222, key, size4322);
      if (list === this.children) return this;
      return list.length > 1 ? new _CollisionNode33(edit, this.hash, list) : list[0];
    }
    const v2222 = f2222(none2233());
    if (isNone2233(v2222)) return this;
    ++size4322.value;
    return mergeLeaves33(edit, shift22, this.hash, this, hash22322, new LeafNode33(edit, hash22322, key, v2222));
  }
  updateCollisionList(mutate2322, edit, hash22322, list, f2222, key, size4322) {
    const len = list.length;
    for (let i2222 = 0; i2222 < len; ++i2222) {
      const child = list[i2222];
      if ("key" in child && equals233(key, child.key)) {
        const value = child.value;
        const newValue2 = f2222(value);
        if (newValue2 === value) return list;
        if (isNone2233(newValue2)) {
          --size4322.value;
          return arraySpliceOut33(mutate2322, i2222, list);
        }
        return arrayUpdate33(mutate2322, i2222, new LeafNode33(edit, hash22322, key, newValue2), list);
      }
    }
    const newValue = f2222(none2233());
    if (isNone2233(newValue)) return list;
    ++size4322.value;
    return arrayUpdate33(mutate2322, len, new LeafNode33(edit, hash22322, key, newValue), list);
  }
};
var IndexedNode33 = class _IndexedNode33 {
  edit;
  mask;
  children;
  _tag = "IndexedNode";
  constructor(edit, mask, children) {
    this.edit = edit;
    this.mask = mask;
    this.children = children;
  }
  modify(edit, shift22, f2222, hash22322, key, size4322) {
    const mask = this.mask;
    const children = this.children;
    const frag = hashFragment33(shift22, hash22322);
    const bit = toBitmap33(frag);
    const indx = fromBitmap33(mask, bit);
    const exists22322 = mask & bit;
    const canEdit = canEditNode33(this, edit);
    if (!exists22322) {
      const _newChild = new EmptyNode33().modify(edit, shift22 + SIZE33, f2222, hash22322, key, size4322);
      if (!_newChild) return this;
      return children.length >= MAX_INDEX_NODE33 ? expand33(edit, frag, _newChild, mask, children) : new _IndexedNode33(edit, mask | bit, arraySpliceIn33(canEdit, indx, _newChild, children));
    }
    const current = children[indx];
    const child = current.modify(edit, shift22 + SIZE33, f2222, hash22322, key, size4322);
    if (current === child) return this;
    let bitmap = mask;
    let newChildren;
    if (isEmptyNode33(child)) {
      bitmap &= ~bit;
      if (!bitmap) return new EmptyNode33();
      if (children.length <= 2 && isLeafNode33(children[indx ^ 1])) {
        return children[indx ^ 1];
      }
      newChildren = arraySpliceOut33(canEdit, indx, children);
    } else {
      newChildren = arrayUpdate33(canEdit, indx, child, children);
    }
    if (canEdit) {
      this.mask = bitmap;
      this.children = newChildren;
      return this;
    }
    return new _IndexedNode33(edit, bitmap, newChildren);
  }
};
var ArrayNode33 = class _ArrayNode33 {
  edit;
  size;
  children;
  _tag = "ArrayNode";
  constructor(edit, size4322, children) {
    this.edit = edit;
    this.size = size4322;
    this.children = children;
  }
  modify(edit, shift22, f2222, hash22322, key, size4322) {
    let count = this.size;
    const children = this.children;
    const frag = hashFragment33(shift22, hash22322);
    const child = children[frag];
    const newChild = (child || new EmptyNode33()).modify(edit, shift22 + SIZE33, f2222, hash22322, key, size4322);
    if (child === newChild) return this;
    const canEdit = canEditNode33(this, edit);
    let newChildren;
    if (isEmptyNode33(child) && !isEmptyNode33(newChild)) {
      ++count;
      newChildren = arrayUpdate33(canEdit, frag, newChild, children);
    } else if (!isEmptyNode33(child) && isEmptyNode33(newChild)) {
      --count;
      if (count <= MIN_ARRAY_NODE33) {
        return pack33(edit, count, frag, children);
      }
      newChildren = arrayUpdate33(canEdit, frag, new EmptyNode33(), children);
    } else {
      newChildren = arrayUpdate33(canEdit, frag, newChild, children);
    }
    if (canEdit) {
      this.size = count;
      this.children = newChildren;
      return this;
    }
    return new _ArrayNode33(edit, count, newChildren);
  }
};
function pack33(edit, count, removed, elements) {
  const children = new Array(count - 1);
  let g2222 = 0;
  let bitmap = 0;
  for (let i2222 = 0, len = elements.length; i2222 < len; ++i2222) {
    if (i2222 !== removed) {
      const elem = elements[i2222];
      if (elem && !isEmptyNode33(elem)) {
        children[g2222++] = elem;
        bitmap |= 1 << i2222;
      }
    }
  }
  return new IndexedNode33(edit, bitmap, children);
}
function expand33(edit, frag, child, bitmap, subNodes) {
  const arr = [];
  let bit = bitmap;
  let count = 0;
  for (let i2222 = 0; bit; ++i2222) {
    if (bit & 1) arr[i2222] = subNodes[count++];
    bit >>>= 1;
  }
  arr[frag] = child;
  return new ArrayNode33(edit, count + 1, arr);
}
function mergeLeavesInner33(edit, shift22, h1, n1, h2222, n2222) {
  if (h1 === h2222) return new CollisionNode33(edit, h1, [n2222, n1]);
  const subH1 = hashFragment33(shift22, h1);
  const subH2 = hashFragment33(shift22, h2222);
  if (subH1 === subH2) {
    return (child) => new IndexedNode33(edit, toBitmap33(subH1) | toBitmap33(subH2), [child]);
  } else {
    const children = subH1 < subH2 ? [n1, n2222] : [n2222, n1];
    return new IndexedNode33(edit, toBitmap33(subH1) | toBitmap33(subH2), children);
  }
}
function mergeLeaves33(edit, shift22, h1, n1, h2222, n2222) {
  let stack = void 0;
  let currentShift = shift22;
  while (true) {
    const res = mergeLeavesInner33(edit, currentShift, h1, n1, h2222, n2222);
    if (typeof res === "function") {
      stack = make533(res, stack);
      currentShift = currentShift + SIZE33;
    } else {
      let final = res;
      while (stack != null) {
        final = stack.value(final);
        stack = stack.previous;
      }
      return final;
    }
  }
}
var HashMapSymbolKey33 = "effect/HashMap";
var HashMapTypeId33 = /* @__PURE__ */ Symbol.for(HashMapSymbolKey33);
var HashMapProto33 = {
  [HashMapTypeId33]: HashMapTypeId33,
  [Symbol.iterator]() {
    return new HashMapIterator33(this, (k2222, v2222) => [k2222, v2222]);
  },
  [symbol333]() {
    let hash22322 = hash233(HashMapSymbolKey33);
    for (const item of this) {
      hash22322 ^= pipe233(hash233(item[0]), combine233(hash233(item[1])));
    }
    return cached233(this, hash22322);
  },
  [symbol2233](that) {
    if (isHashMap33(that)) {
      if (that._size !== this._size) {
        return false;
      }
      for (const item of this) {
        const elem = pipe233(that, getHash33(item[0], hash233(item[0])));
        if (isNone2233(elem)) {
          return false;
        } else {
          if (!equals233(item[1], elem.value)) {
            return false;
          }
        }
      }
      return true;
    }
    return false;
  },
  toString() {
    return format233(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashMap",
      values: Array.from(this).map(toJSON233)
    };
  },
  [NodeInspectSymbol233]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments233(this, arguments);
  }
};
var makeImpl43 = (editable, edit, root, size4322) => {
  const map622 = Object.create(HashMapProto33);
  map622._editable = editable;
  map622._edit = edit;
  map622._root = root;
  map622._size = size4322;
  return map622;
};
var HashMapIterator33 = class _HashMapIterator33 {
  map;
  f;
  v;
  constructor(map622, f2222) {
    this.map = map622;
    this.f = f2222;
    this.v = visitLazy33(this.map._root, this.f, void 0);
  }
  next() {
    if (isNone2233(this.v)) {
      return {
        done: true,
        value: void 0
      };
    }
    const v0 = this.v.value;
    this.v = applyCont33(v0.cont);
    return {
      done: false,
      value: v0.value
    };
  }
  [Symbol.iterator]() {
    return new _HashMapIterator33(this.map, this.f);
  }
};
var applyCont33 = (cont) => cont ? visitLazyChildren33(cont[0], cont[1], cont[2], cont[3], cont[4]) : none2233();
var visitLazy33 = (node, f2222, cont = void 0) => {
  switch (node._tag) {
    case "LeafNode": {
      if (isSome2233(node.value)) {
        return some3233({
          value: f2222(node.key, node.value.value),
          cont
        });
      }
      return applyCont33(cont);
    }
    case "CollisionNode":
    case "ArrayNode":
    case "IndexedNode": {
      const children = node.children;
      return visitLazyChildren33(children.length, children, 0, f2222, cont);
    }
    default: {
      return applyCont33(cont);
    }
  }
};
var visitLazyChildren33 = (len, children, i2222, f2222, cont) => {
  while (i2222 < len) {
    const child = children[i2222++];
    if (child && !isEmptyNode33(child)) {
      return visitLazy33(child, f2222, [len, children, i2222, f2222, cont]);
    }
  }
  return applyCont33(cont);
};
var _empty333 = /* @__PURE__ */ makeImpl43(false, 0, /* @__PURE__ */ new EmptyNode33(), 0);
var empty433 = () => _empty333;
var isHashMap33 = (u2222) => hasProperty233(u2222, HashMapTypeId33);
var getHash33 = /* @__PURE__ */ dual233(3, (self2, key, hash22322) => {
  let node = self2._root;
  let shift22 = 0;
  while (true) {
    switch (node._tag) {
      case "LeafNode": {
        return equals233(key, node.key) ? node.value : none2233();
      }
      case "CollisionNode": {
        if (hash22322 === node.hash) {
          const children = node.children;
          for (let i2222 = 0, len = children.length; i2222 < len; ++i2222) {
            const child = children[i2222];
            if ("key" in child && equals233(key, child.key)) {
              return child.value;
            }
          }
        }
        return none2233();
      }
      case "IndexedNode": {
        const frag = hashFragment33(shift22, hash22322);
        const bit = toBitmap33(frag);
        if (node.mask & bit) {
          node = node.children[fromBitmap33(node.mask, bit)];
          shift22 += SIZE33;
          break;
        }
        return none2233();
      }
      case "ArrayNode": {
        node = node.children[hashFragment33(shift22, hash22322)];
        if (node) {
          shift22 += SIZE33;
          break;
        }
        return none2233();
      }
      default:
        return none2233();
    }
  }
});
var set233 = /* @__PURE__ */ dual233(3, (self2, key, value) => modifyAt33(self2, key, () => some3233(value)));
var setTree33 = /* @__PURE__ */ dual233(3, (self2, newRoot, newSize) => {
  if (self2._editable) {
    self2._root = newRoot;
    self2._size = newSize;
    return self2;
  }
  return newRoot === self2._root ? self2 : makeImpl43(self2._editable, self2._edit, newRoot, newSize);
});
var keys43 = (self2) => new HashMapIterator33(self2, (key) => key);
var size53 = (self2) => self2._size;
var beginMutation43 = (self2) => makeImpl43(true, self2._edit + 1, self2._root, self2._size);
var modifyAt33 = /* @__PURE__ */ dual233(3, (self2, key, f2222) => modifyHash33(self2, key, hash233(key), f2222));
var modifyHash33 = /* @__PURE__ */ dual233(4, (self2, key, hash22322, f2222) => {
  const size4322 = {
    value: self2._size
  };
  const newRoot = self2._root.modify(self2._editable ? self2._edit : NaN, 0, f2222, hash22322, key, size4322);
  return pipe233(self2, setTree33(newRoot, size4322.value));
});
var forEach63 = /* @__PURE__ */ dual233(2, (self2, f2222) => reduce233(self2, void 0, (_2222, value, key) => f2222(value, key)));
var reduce233 = /* @__PURE__ */ dual233(3, (self2, zero, f2222) => {
  const root = self2._root;
  if (root._tag === "LeafNode") {
    return isSome2233(root.value) ? f2222(zero, root.value.value, root.key) : zero;
  }
  if (root._tag === "EmptyNode") {
    return zero;
  }
  const toVisit = [root.children];
  let children;
  while (children = toVisit.pop()) {
    for (let i2222 = 0, len = children.length; i2222 < len; ) {
      const child = children[i2222++];
      if (child && !isEmptyNode33(child)) {
        if (child._tag === "LeafNode") {
          if (isSome2233(child.value)) {
            zero = f2222(zero, child.value.value, child.key);
          }
        } else {
          toVisit.push(child.children);
        }
      }
    }
  }
  return zero;
});
var HashSetSymbolKey33 = "effect/HashSet";
var HashSetTypeId33 = /* @__PURE__ */ Symbol.for(HashSetSymbolKey33);
var HashSetProto33 = {
  [HashSetTypeId33]: HashSetTypeId33,
  [Symbol.iterator]() {
    return keys43(this._keyMap);
  },
  [symbol333]() {
    return cached233(this, combine233(hash233(this._keyMap))(hash233(HashSetSymbolKey33)));
  },
  [symbol2233](that) {
    if (isHashSet33(that)) {
      return size53(this._keyMap) === size53(that._keyMap) && equals233(this._keyMap, that._keyMap);
    }
    return false;
  },
  toString() {
    return format233(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashSet",
      values: Array.from(this).map(toJSON233)
    };
  },
  [NodeInspectSymbol233]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments233(this, arguments);
  }
};
var makeImpl233 = (keyMap) => {
  const set22322 = Object.create(HashSetProto33);
  set22322._keyMap = keyMap;
  return set22322;
};
var isHashSet33 = (u2222) => hasProperty233(u2222, HashSetTypeId33);
var _empty433 = /* @__PURE__ */ makeImpl233(/* @__PURE__ */ empty433());
var empty533 = () => _empty433;
var size233 = (self2) => size53(self2._keyMap);
var beginMutation233 = (self2) => makeImpl233(beginMutation43(self2._keyMap));
var endMutation33 = (self2) => {
  self2._keyMap._editable = false;
  return self2;
};
var mutate33 = /* @__PURE__ */ dual233(2, (self2, f2222) => {
  const transient = beginMutation233(self2);
  f2222(transient);
  return endMutation33(transient);
});
var add233 = /* @__PURE__ */ dual233(2, (self2, value) => self2._keyMap._editable ? (set233(value, true)(self2._keyMap), self2) : makeImpl233(set233(value, true)(self2._keyMap)));
var union233 = /* @__PURE__ */ dual233(2, (self2, that) => mutate33(empty533(), (set22322) => {
  forEach233(self2, (value) => add233(set22322, value));
  for (const value of that) {
    add233(set22322, value);
  }
}));
var forEach233 = /* @__PURE__ */ dual233(2, (self2, f2222) => forEach63(self2._keyMap, (_2222, k2222) => f2222(k2222)));
var empty633 = empty533;
var size333 = size233;
var add333 = add233;
var union333 = union233;
var ArrayProto33 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(Array.prototype), {
  [symbol333]() {
    return cached233(this, array73(this));
  },
  [symbol2233](that) {
    if (Array.isArray(that) && this.length === that.length) {
      return this.every((v2222, i2222) => equals233(v2222, that[i2222]));
    } else {
      return false;
    }
  }
});
var Structural43 = /* @__PURE__ */ function() {
  function Structural3322(args) {
    if (args) {
      Object.assign(this, args);
    }
  }
  Structural3322.prototype = StructuralPrototype233;
  return Structural3322;
}();
var struct233 = (as22322) => Object.assign(Object.create(StructuralPrototype233), as22322);
var ContextPatchTypeId33 = /* @__PURE__ */ Symbol.for("effect/DifferContextPatch");
function variance43(a2222) {
  return a2222;
}
var PatchProto33 = {
  ...Structural43.prototype,
  [ContextPatchTypeId33]: {
    _Value: variance43,
    _Patch: variance43
  }
};
var EmptyProto33 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto33), {
  _tag: "Empty"
});
var _empty533 = /* @__PURE__ */ Object.create(EmptyProto33);
var empty733 = () => _empty533;
var AndThenProto33 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto33), {
  _tag: "AndThen"
});
var makeAndThen33 = (first, second) => {
  const o2222 = Object.create(AndThenProto33);
  o2222.first = first;
  o2222.second = second;
  return o2222;
};
var AddServiceProto33 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto33), {
  _tag: "AddService"
});
var makeAddService33 = (key, service) => {
  const o2222 = Object.create(AddServiceProto33);
  o2222.key = key;
  o2222.service = service;
  return o2222;
};
var RemoveServiceProto33 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto33), {
  _tag: "RemoveService"
});
var makeRemoveService33 = (key) => {
  const o2222 = Object.create(RemoveServiceProto33);
  o2222.key = key;
  return o2222;
};
var UpdateServiceProto33 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto33), {
  _tag: "UpdateService"
});
var makeUpdateService33 = (key, update222) => {
  const o2222 = Object.create(UpdateServiceProto33);
  o2222.key = key;
  o2222.update = update222;
  return o2222;
};
var diff33 = (oldValue, newValue) => {
  const missingServices = new Map(oldValue.unsafeMap);
  let patch2322 = empty733();
  for (const [tag, newService] of newValue.unsafeMap.entries()) {
    if (missingServices.has(tag)) {
      const old = missingServices.get(tag);
      missingServices.delete(tag);
      if (!equals233(old, newService)) {
        patch2322 = combine2233(makeUpdateService33(tag, () => newService))(patch2322);
      }
    } else {
      missingServices.delete(tag);
      patch2322 = combine2233(makeAddService33(tag, newService))(patch2322);
    }
  }
  for (const [tag] of missingServices.entries()) {
    patch2322 = combine2233(makeRemoveService33(tag))(patch2322);
  }
  return patch2322;
};
var combine2233 = /* @__PURE__ */ dual233(2, (self2, that) => makeAndThen33(self2, that));
var patch33 = /* @__PURE__ */ dual233(2, (self2, context) => {
  if (self2._tag === "Empty") {
    return context;
  }
  let wasServiceUpdated = false;
  let patches = of43(self2);
  const updatedContext = new Map(context.unsafeMap);
  while (isNonEmpty33(patches)) {
    const head222 = headNonEmpty43(patches);
    const tail322 = tailNonEmpty43(patches);
    switch (head222._tag) {
      case "Empty": {
        patches = tail322;
        break;
      }
      case "AddService": {
        updatedContext.set(head222.key, head222.service);
        patches = tail322;
        break;
      }
      case "AndThen": {
        patches = prepend53(prepend53(tail322, head222.second), head222.first);
        break;
      }
      case "RemoveService": {
        updatedContext.delete(head222.key);
        patches = tail322;
        break;
      }
      case "UpdateService": {
        updatedContext.set(head222.key, head222.update(updatedContext.get(head222.key)));
        wasServiceUpdated = true;
        patches = tail322;
        break;
      }
    }
  }
  if (!wasServiceUpdated) {
    return makeContext33(updatedContext);
  }
  const map622 = /* @__PURE__ */ new Map();
  for (const [tag] of context.unsafeMap) {
    if (updatedContext.has(tag)) {
      map622.set(tag, updatedContext.get(tag));
      updatedContext.delete(tag);
    }
  }
  for (const [tag, s2222] of updatedContext) {
    map622.set(tag, s2222);
  }
  return makeContext33(map622);
});
var DifferTypeId33 = /* @__PURE__ */ Symbol.for("effect/Differ");
var DifferProto33 = {
  [DifferTypeId33]: {
    _P: identity233,
    _V: identity233
  }
};
var make733 = (params) => {
  const differ = Object.create(DifferProto33);
  differ.empty = params.empty;
  differ.diff = params.diff;
  differ.combine = params.combine;
  differ.patch = params.patch;
  return differ;
};
var environment33 = () => make733({
  empty: empty733(),
  combine: (first, second) => combine2233(second)(first),
  diff: (oldValue, newValue) => diff33(oldValue, newValue),
  patch: (patch2322, oldValue) => patch33(oldValue)(patch2322)
});
var OP_DIE33 = "Die";
var OP_EMPTY33 = "Empty";
var OP_FAIL33 = "Fail";
var OP_INTERRUPT33 = "Interrupt";
var OP_PARALLEL33 = "Parallel";
var OP_SEQUENTIAL33 = "Sequential";
var CauseSymbolKey33 = "effect/Cause";
var CauseTypeId33 = /* @__PURE__ */ Symbol.for(CauseSymbolKey33);
var variance233 = {
  /* c8 ignore next */
  _E: (_2222) => _2222
};
var proto33 = {
  [CauseTypeId33]: variance233,
  [symbol333]() {
    return pipe233(hash233(CauseSymbolKey33), combine233(hash233(flattenCause33(this))), cached233(this));
  },
  [symbol2233](that) {
    return isCause33(that) && causeEquals33(this, that);
  },
  pipe() {
    return pipeArguments233(this, arguments);
  },
  toJSON() {
    switch (this._tag) {
      case "Empty":
        return {
          _id: "Cause",
          _tag: this._tag
        };
      case "Die":
        return {
          _id: "Cause",
          _tag: this._tag,
          defect: toJSON233(this.defect)
        };
      case "Interrupt":
        return {
          _id: "Cause",
          _tag: this._tag,
          fiberId: this.fiberId.toJSON()
        };
      case "Fail":
        return {
          _id: "Cause",
          _tag: this._tag,
          failure: toJSON233(this.error)
        };
      case "Sequential":
      case "Parallel":
        return {
          _id: "Cause",
          _tag: this._tag,
          left: toJSON233(this.left),
          right: toJSON233(this.right)
        };
    }
  },
  toString() {
    return pretty33(this);
  },
  [NodeInspectSymbol233]() {
    return this.toJSON();
  }
};
var fail43 = (error) => {
  const o2222 = Object.create(proto33);
  o2222._tag = OP_FAIL33;
  o2222.error = error;
  return o2222;
};
var parallel33 = (left3322, right3322) => {
  const o2222 = Object.create(proto33);
  o2222._tag = OP_PARALLEL33;
  o2222.left = left3322;
  o2222.right = right3322;
  return o2222;
};
var sequential33 = (left3322, right3322) => {
  const o2222 = Object.create(proto33);
  o2222._tag = OP_SEQUENTIAL33;
  o2222.left = left3322;
  o2222.right = right3322;
  return o2222;
};
var isCause33 = (u2222) => hasProperty233(u2222, CauseTypeId33);
var isInterruptedOnly33 = (self2) => reduceWithContext33(void 0, IsInterruptedOnlyCauseReducer33)(self2);
var causeEquals33 = (left3322, right3322) => {
  let leftStack = of43(left3322);
  let rightStack = of43(right3322);
  while (isNonEmpty33(leftStack) && isNonEmpty33(rightStack)) {
    const [leftParallel, leftSequential] = pipe233(headNonEmpty43(leftStack), reduce433([empty633(), empty333()], ([parallel2322, sequential2322], cause) => {
      const [par, seq] = evaluateCause33(cause);
      return some3233([pipe233(parallel2322, union333(par)), pipe233(sequential2322, appendAll43(seq))]);
    }));
    const [rightParallel, rightSequential] = pipe233(headNonEmpty43(rightStack), reduce433([empty633(), empty333()], ([parallel2322, sequential2322], cause) => {
      const [par, seq] = evaluateCause33(cause);
      return some3233([pipe233(parallel2322, union333(par)), pipe233(sequential2322, appendAll43(seq))]);
    }));
    if (!equals233(leftParallel, rightParallel)) {
      return false;
    }
    leftStack = leftSequential;
    rightStack = rightSequential;
  }
  return true;
};
var flattenCause33 = (cause) => {
  return flattenCauseLoop33(of43(cause), empty333());
};
var flattenCauseLoop33 = (causes, flattened) => {
  while (1) {
    const [parallel2322, sequential2322] = pipe233(causes, reduce63([empty633(), empty333()], ([parallel322, sequential322], cause) => {
      const [par, seq] = evaluateCause33(cause);
      return [pipe233(parallel322, union333(par)), pipe233(sequential322, appendAll43(seq))];
    }));
    const updated = size333(parallel2322) > 0 ? pipe233(flattened, prepend53(parallel2322)) : flattened;
    if (isEmpty43(sequential2322)) {
      return reverse233(updated);
    }
    causes = sequential2322;
    flattened = updated;
  }
  throw new Error(getBugErrorMessage233("Cause.flattenCauseLoop"));
};
var evaluateCause33 = (self2) => {
  let cause = self2;
  const stack = [];
  let _parallel = empty633();
  let _sequential = empty333();
  while (cause !== void 0) {
    switch (cause._tag) {
      case OP_EMPTY33: {
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_FAIL33: {
        _parallel = add333(_parallel, make4233(cause._tag, cause.error));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_DIE33: {
        _parallel = add333(_parallel, make4233(cause._tag, cause.defect));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_INTERRUPT33: {
        _parallel = add333(_parallel, make4233(cause._tag, cause.fiberId));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_SEQUENTIAL33: {
        switch (cause.left._tag) {
          case OP_EMPTY33: {
            cause = cause.right;
            break;
          }
          case OP_SEQUENTIAL33: {
            cause = sequential33(cause.left.left, sequential33(cause.left.right, cause.right));
            break;
          }
          case OP_PARALLEL33: {
            cause = parallel33(sequential33(cause.left.left, cause.right), sequential33(cause.left.right, cause.right));
            break;
          }
          default: {
            _sequential = prepend53(_sequential, cause.right);
            cause = cause.left;
            break;
          }
        }
        break;
      }
      case OP_PARALLEL33: {
        stack.push(cause.right);
        cause = cause.left;
        break;
      }
    }
  }
  throw new Error(getBugErrorMessage233("Cause.evaluateCauseLoop"));
};
var IsInterruptedOnlyCauseReducer33 = {
  emptyCase: constTrue233,
  failCase: constFalse233,
  dieCase: constFalse233,
  interruptCase: constTrue233,
  sequentialCase: (_2222, left3322, right3322) => left3322 && right3322,
  parallelCase: (_2222, left3322, right3322) => left3322 && right3322
};
var OP_SEQUENTIAL_CASE33 = "SequentialCase";
var OP_PARALLEL_CASE33 = "ParallelCase";
var reduce433 = /* @__PURE__ */ dual233(3, (self2, zero, pf) => {
  let accumulator = zero;
  let cause = self2;
  const causes = [];
  while (cause !== void 0) {
    const option = pf(accumulator, cause);
    accumulator = isSome2233(option) ? option.value : accumulator;
    switch (cause._tag) {
      case OP_SEQUENTIAL33: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      case OP_PARALLEL33: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      default: {
        cause = void 0;
        break;
      }
    }
    if (cause === void 0 && causes.length > 0) {
      cause = causes.pop();
    }
  }
  return accumulator;
});
var reduceWithContext33 = /* @__PURE__ */ dual233(3, (self2, context, reducer) => {
  const input = [self2];
  const output = [];
  while (input.length > 0) {
    const cause = input.pop();
    switch (cause._tag) {
      case OP_EMPTY33: {
        output.push(right2233(reducer.emptyCase(context)));
        break;
      }
      case OP_FAIL33: {
        output.push(right2233(reducer.failCase(context, cause.error)));
        break;
      }
      case OP_DIE33: {
        output.push(right2233(reducer.dieCase(context, cause.defect)));
        break;
      }
      case OP_INTERRUPT33: {
        output.push(right2233(reducer.interruptCase(context, cause.fiberId)));
        break;
      }
      case OP_SEQUENTIAL33: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left2233({
          _tag: OP_SEQUENTIAL_CASE33
        }));
        break;
      }
      case OP_PARALLEL33: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left2233({
          _tag: OP_PARALLEL_CASE33
        }));
        break;
      }
    }
  }
  const accumulator = [];
  while (output.length > 0) {
    const either = output.pop();
    switch (either._tag) {
      case "Left": {
        switch (either.left._tag) {
          case OP_SEQUENTIAL_CASE33: {
            const left3322 = accumulator.pop();
            const right3322 = accumulator.pop();
            const value = reducer.sequentialCase(context, left3322, right3322);
            accumulator.push(value);
            break;
          }
          case OP_PARALLEL_CASE33: {
            const left3322 = accumulator.pop();
            const right3322 = accumulator.pop();
            const value = reducer.parallelCase(context, left3322, right3322);
            accumulator.push(value);
            break;
          }
        }
        break;
      }
      case "Right": {
        accumulator.push(either.right);
        break;
      }
    }
  }
  if (accumulator.length === 0) {
    throw new Error("BUG: Cause.reduceWithContext - please report an issue at https://github.com/Effect-TS/effect/issues");
  }
  return accumulator.pop();
});
var pretty33 = (cause) => {
  if (isInterruptedOnly33(cause)) {
    return "All fibers interrupted without errors.";
  }
  return prettyErrors33(cause).map((e2222) => e2222.stack).join("\n");
};
var PrettyError33 = class extends globalThis.Error {
  span = void 0;
  constructor(originalError) {
    const prevLimit = Error.stackTraceLimit;
    Error.stackTraceLimit = 0;
    super(prettyErrorMessage33(originalError));
    Error.stackTraceLimit = prevLimit;
    this.name = originalError instanceof Error ? originalError.name : "Error";
    if (typeof originalError === "object" && originalError !== null) {
      if (spanSymbol43 in originalError) {
        this.span = originalError[spanSymbol43];
      }
      Object.keys(originalError).forEach((key) => {
        if (!(key in this)) {
          this[key] = originalError[key];
        }
      });
    }
    this.stack = prettyErrorStack33(this.message, originalError instanceof Error && originalError.stack ? originalError.stack : "", this.span);
  }
  toJSON() {
    const out = {
      message: this.message,
      stack: this.stack
    };
    if (this.span) {
      out.span = this.span;
    }
    return out;
  }
};
var prettyErrorMessage33 = (u2222) => {
  if (typeof u2222 === "string") {
    return `Error: ${u2222}`;
  }
  try {
    if (hasProperty233(u2222, "toString") && isFunction3232(u2222["toString"]) && u2222["toString"] !== Object.prototype.toString && u2222["toString"] !== globalThis.Array.prototype.toString) {
      return u2222["toString"]();
    }
  } catch {
  }
  return `Error: ${JSON.stringify(u2222)}`;
};
var locationRegex33 = /\((.*)\)/;
var spanToTrace33 = /* @__PURE__ */ globalValue233("effect/Tracer/spanToTrace", () => /* @__PURE__ */ new WeakMap());
var prettyErrorStack33 = (message, stack, span222) => {
  const out = [message];
  const lines = stack.split("\n");
  for (let i2222 = 1; i2222 < lines.length; i2222++) {
    if (lines[i2222].includes("Generator.next")) {
      break;
    }
    if (lines[i2222].includes("effect_internal_function")) {
      out.pop();
      break;
    }
    out.push(lines[i2222].replace(/at .*effect_instruction_i.*\((.*)\)/, "at $1").replace(/EffectPrimitive\.\w+/, "<anonymous>"));
  }
  if (span222) {
    let current = span222;
    let i2222 = 0;
    while (current && current._tag === "Span" && i2222 < 10) {
      const stackFn = spanToTrace33.get(current);
      if (typeof stackFn === "function") {
        const stack2 = stackFn();
        const locationMatch = stack2.match(locationRegex33);
        const location = locationMatch ? locationMatch[1] : stack2.replace(/^at /, "");
        out.push(`    at ${current.name} (${location})`);
      } else {
        out.push(`    at ${current.name}`);
      }
      current = getOrUndefined233(current.parent);
      i2222++;
    }
  }
  return out.join("\n");
};
var spanSymbol43 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var prettyErrors33 = (cause) => reduceWithContext33(cause, void 0, {
  emptyCase: () => [],
  dieCase: (_2222, unknownError) => {
    return [new PrettyError33(unknownError)];
  },
  failCase: (_2222, error) => {
    return [new PrettyError33(error)];
  },
  interruptCase: () => [],
  parallelCase: (_2222, l2222, r2222) => [...l2222, ...r2222],
  sequentialCase: (_2222, l2222, r2222) => [...l2222, ...r2222]
});
var SingleShotGen2233 = class _SingleShotGen233 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  next(a2222) {
    return this.called ? {
      value: a2222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  return(a2222) {
    return {
      value: a2222,
      done: true
    };
  }
  throw(e2222) {
    throw e2222;
  }
  [Symbol.iterator]() {
    return new _SingleShotGen233(this.self);
  }
};
var spanTag33 = /* @__PURE__ */ GenericTag33("effect/ParentSpan");
var EffectTypeId2233 = /* @__PURE__ */ Symbol.for("effect/Effect");
var EffectPrimitive33 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId2233] = effectVariance233;
  constructor(_op) {
    this._op = _op;
  }
  [symbol2233](that) {
    return this === that;
  }
  [symbol333]() {
    return cached233(this, random233(this));
  }
  pipe() {
    return pipeArguments233(this, arguments);
  }
  toJSON() {
    return {
      _id: "Effect",
      _op: this._op,
      effect_instruction_i0: toJSON233(this.effect_instruction_i0),
      effect_instruction_i1: toJSON233(this.effect_instruction_i1),
      effect_instruction_i2: toJSON233(this.effect_instruction_i2)
    };
  }
  toString() {
    return format233(this.toJSON());
  }
  [NodeInspectSymbol233]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen2233(new YieldWrap233(this));
  }
};
var EffectPrimitiveFailure33 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId2233] = effectVariance233;
  constructor(_op) {
    this._op = _op;
    this._tag = _op;
  }
  [symbol2233](that) {
    return exitIsExit33(that) && that._op === "Failure" && // @ts-expect-error
    equals233(this.effect_instruction_i0, that.effect_instruction_i0);
  }
  [symbol333]() {
    return pipe233(
      // @ts-expect-error
      string233(this._tag),
      // @ts-expect-error
      combine233(hash233(this.effect_instruction_i0)),
      cached233(this)
    );
  }
  get cause() {
    return this.effect_instruction_i0;
  }
  pipe() {
    return pipeArguments233(this, arguments);
  }
  toJSON() {
    return {
      _id: "Exit",
      _tag: this._op,
      cause: this.cause.toJSON()
    };
  }
  toString() {
    return format233(this.toJSON());
  }
  [NodeInspectSymbol233]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen2233(new YieldWrap233(this));
  }
};
var isEffect33 = (u2222) => hasProperty233(u2222, EffectTypeId2233);
var withFiberRuntime33 = (withRuntime) => {
  const effect = new EffectPrimitive33(OP_WITH_RUNTIME33);
  effect.effect_instruction_i0 = withRuntime;
  return effect;
};
var spanSymbol233 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var originalSymbol33 = /* @__PURE__ */ Symbol.for("effect/OriginalAnnotation");
var capture33 = (obj, span222) => {
  if (isSome2233(span222)) {
    return new Proxy(obj, {
      has(target, p2222) {
        return p2222 === spanSymbol233 || p2222 === originalSymbol33 || p2222 in target;
      },
      get(target, p2222) {
        if (p2222 === spanSymbol233) {
          return span222.value;
        }
        if (p2222 === originalSymbol33) {
          return obj;
        }
        return target[p2222];
      }
    });
  }
  return obj;
};
var fail233 = (error) => isObject233(error) && !(spanSymbol233 in error) ? withFiberRuntime33((fiber) => failCause33(fail43(capture33(error, currentSpanFromFiber33(fiber))))) : failCause33(fail43(error));
var failCause33 = (cause) => {
  const effect = new EffectPrimitiveFailure33(OP_FAILURE33);
  effect.effect_instruction_i0 = cause;
  return effect;
};
var FiberRefSymbolKey33 = "effect/FiberRef";
var FiberRefTypeId33 = /* @__PURE__ */ Symbol.for(FiberRefSymbolKey33);
var fiberRefVariance33 = {
  /* c8 ignore next */
  _A: (_2222) => _2222
};
var fiberRefUnsafeMakeContext33 = (initial) => {
  const differ = environment33();
  return fiberRefUnsafeMakePatch33(initial, {
    differ,
    fork: differ.empty
  });
};
var fiberRefUnsafeMakePatch33 = (initial, options) => ({
  [FiberRefTypeId33]: fiberRefVariance33,
  initial,
  diff: (oldValue, newValue) => options.differ.diff(oldValue, newValue),
  combine: (first, second) => options.differ.combine(first, second),
  patch: (patch2322) => (oldValue) => options.differ.patch(patch2322, oldValue),
  fork: options.fork,
  join: options.join ?? ((_2222, n2222) => n2222),
  pipe() {
    return pipeArguments233(this, arguments);
  }
});
var currentContext33 = /* @__PURE__ */ globalValue233(/* @__PURE__ */ Symbol.for("effect/FiberRef/currentContext"), () => fiberRefUnsafeMakeContext33(empty233()));
var YieldableError33 = /* @__PURE__ */ function() {
  class YieldableError2322 extends globalThis.Error {
    commit() {
      return fail233(this);
    }
    toString() {
      return this.message ? `${this.name}: ${this.message}` : this.name;
    }
    toJSON() {
      return {
        ...this
      };
    }
    [NodeInspectSymbol233]() {
      const stack = this.stack;
      if (stack) {
        return `${this.toString()}
${stack.split("\n").slice(1).join("\n")}`;
      }
      return this.toString();
    }
  }
  Object.assign(YieldableError2322.prototype, StructuralCommitPrototype233);
  return YieldableError2322;
}();
var exitIsExit33 = (u2222) => isEffect33(u2222) && "_tag" in u2222 && (u2222._tag === "Success" || u2222._tag === "Failure");
var currentSpanFromFiber33 = (fiber) => {
  const span222 = fiber.getFiberRef(currentContext33).unsafeMap.get(spanTag33.key);
  return span222 !== void 0 && span222._tag === "Span" ? some3233(span222) : none2233();
};
var Data_exports233 = {};
__export233(Data_exports233, {
  Class: () => Class233,
  Error: () => Error233,
  Structural: () => Structural233,
  TaggedClass: () => TaggedClass33,
  TaggedError: () => TaggedError33,
  array: () => array233,
  case: () => _case33,
  struct: () => struct333,
  tagged: () => tagged33,
  taggedEnum: () => taggedEnum33,
  tuple: () => tuple233,
  unsafeArray: () => unsafeArray33,
  unsafeStruct: () => unsafeStruct33
});
var struct333 = struct233;
var unsafeStruct33 = (as22322) => Object.setPrototypeOf(as22322, StructuralPrototype233);
var tuple233 = (...as22322) => unsafeArray33(as22322);
var array233 = (as22322) => unsafeArray33(as22322.slice(0));
var unsafeArray33 = (as22322) => Object.setPrototypeOf(as22322, ArrayProto33);
var _case33 = () => (args) => args === void 0 ? Object.create(StructuralPrototype233) : struct333(args);
var tagged33 = (tag) => (args) => {
  const value = args === void 0 ? Object.create(StructuralPrototype233) : struct333(args);
  value._tag = tag;
  return value;
};
var Class233 = Structural43;
var TaggedClass33 = (tag) => {
  class Base extends Class233 {
    _tag = tag;
  }
  return Base;
};
var Structural233 = Structural43;
var taggedEnum33 = () => new Proxy({}, {
  get(_target, tag, _receiver) {
    if (tag === "$is") {
      return isTagged53;
    } else if (tag === "$match") {
      return taggedMatch33;
    }
    return tagged33(tag);
  }
});
function taggedMatch33() {
  if (arguments.length === 1) {
    const cases2 = arguments[0];
    return function(value2) {
      return cases2[value2._tag](value2);
    };
  }
  const value = arguments[0];
  const cases = arguments[1];
  return cases[value._tag](value);
}
var Error233 = /* @__PURE__ */ function() {
  return class Base extends YieldableError33 {
    constructor(args) {
      super();
      if (args) {
        Object.assign(this, args);
      }
    }
  };
}();
var TaggedError33 = (tag) => {
  class Base extends Error233 {
    _tag = tag;
  }
  Base.prototype.name = tag;
  return Base;
};
var traverseUp33 = Function_exports233.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType33.Program) return Option_exports233.none();
  return predicate(parent) ? Option_exports233.some(parent) : traverseUp33(parent, predicate);
});
var traverseUpGuard33 = Function_exports233.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType33.Program) return Option_exports233.none();
  return predicate(parent) ? Option_exports233.some(parent) : traverseUpGuard33(parent, predicate);
});
var ESLintCommunityESLintUtils33;
((ESLintCommunityESLintUtils2322) => {
  ESLintCommunityESLintUtils2322.getFunctionHeadLocation = getFunctionHeadLocation33;
  ESLintCommunityESLintUtils2322.getFunctionNameWithKind = getFunctionNameWithKind33;
  ESLintCommunityESLintUtils2322.getPropertyName = getPropertyName33;
  ESLintCommunityESLintUtils2322.getStaticValue = getStaticValue43;
  ESLintCommunityESLintUtils2322.getStringIfConstant = getStringIfConstant33;
  ESLintCommunityESLintUtils2322.hasSideEffect = hasSideEffect33;
  ESLintCommunityESLintUtils2322.isParenthesized = isParenthesized33;
})(ESLintCommunityESLintUtils33 || (ESLintCommunityESLintUtils33 = {}));
var Construction33 = Data_exports233.taggedEnum();
Construction33.None();
a222({
  type: N222.union([NodeType33.FunctionExpression, NodeType33.ArrowFunctionExpression]),
  parent: {
    type: NodeType33.Property,
    parent: {
      type: NodeType33.ObjectExpression
    }
  }
});
a222({
  type: N222.union([NodeType33.FunctionExpression, NodeType33.ArrowFunctionExpression]),
  parent: {
    type: NodeType33.MethodDefinition,
    parent: {
      type: NodeType33.ClassBody
    }
  }
});
a222({
  type: N222.union([NodeType33.FunctionExpression, NodeType33.ArrowFunctionExpression]),
  parent: {
    type: NodeType33.Property,
    parent: {
      type: NodeType33.ClassBody
    }
  }
});
function isInitializedFromReact2(variableName, context, initialScope) {
  if (variableName.toLowerCase() === "react") return true;
  const maybeVariable = findVariable33(variableName, initialScope);
  const maybeLatestDef = Option_exports43.flatMapNullable(maybeVariable, (v322) => v322.defs.at(-1));
  if (Option_exports43.isNone(maybeLatestDef)) return false;
  const latestDef = maybeLatestDef.value;
  const { node, parent } = latestDef;
  const settings = parse(ESLintSettingsSchema, context.settings);
  const importSource = settings.reactOptions?.importSource ?? "react";
  if (node.type === NodeType23.VariableDeclarator && node.init) {
    const { init: init222 } = node;
    if (init222.type === NodeType23.MemberExpression && init222.object.type === NodeType23.Identifier) {
      return isInitializedFromReact2(init222.object.name, context, initialScope);
    }
    if (init222.type === NodeType23.Identifier) {
      return isInitializedFromReact2(init222.name, context, initialScope);
    }
    const maybeRequireExpression = $2(init222).with({
      type: NodeType23.CallExpression,
      callee: { type: NodeType23.Identifier, name: "require" }
    }, (exp) => Option_exports43.some(exp)).with(
      {
        type: NodeType23.MemberExpression,
        object: {
          type: NodeType23.CallExpression,
          callee: { type: NodeType23.Identifier, name: "require" }
        }
      },
      ({ object: object222 }) => Option_exports43.some(object222)
    ).otherwise(Option_exports43.none);
    if (Option_exports43.isNone(maybeRequireExpression)) return false;
    const requireExpression = maybeRequireExpression.value;
    const [firstArg] = requireExpression.arguments;
    if (firstArg?.type !== NodeType23.Literal || !Predicate_exports33.isString(firstArg.value)) return false;
    return firstArg.value === importSource || firstArg.value.startsWith(`${importSource}/`);
  }
  return a5({ type: "ImportDeclaration", source: { value: importSource } }, parent);
}
function isFromReact2(name22) {
  return (node, context) => {
    const initialScope = context.sourceCode.getScope(node);
    if (node.type === NodeType23.MemberExpression) {
      return node.object.type === NodeType23.Identifier && node.property.type === NodeType23.Identifier && node.property.name === name22 && isInitializedFromReact2(node.object.name, context, initialScope);
    }
    if (node.name === name22) return isInitializedFromReact2(name22, context, initialScope);
    return false;
  };
}
function isCallFromReact2(name22) {
  return (node, context) => {
    if (!isOneOf23([NodeType23.Identifier, NodeType23.MemberExpression])(node.callee)) return false;
    return isFromReact2(name22)(node.callee, context);
  };
}
function isReactAPICallWithName2(name22, member) {
  return isCallFromReact2(name22);
}
var isCreateElementCall2 = isReactAPICallWithName2("createElement");
function hasChildren(node, predicate) {
  if (Predicate_exports33.isFunction(predicate)) return node.children.some(predicate);
  return node.children.length > 0;
}
new import_short_unique_id2.default({ length: 10 });
new import_short_unique_id2.default({ length: 10 });
a5({
  key: {
    type: NodeType23.Identifier,
    name: "render"
  },
  type: N4.union(NodeType23.MethodDefinition, NodeType23.PropertyDefinition),
  parent: {
    type: NodeType23.ClassBody,
    parent: {
      type: NodeType23.ClassDeclaration
    }
  }
});
new import_short_unique_id2.default({ length: 10 });
a5({
  callee: {
    type: NodeType23.MemberExpression,
    property: {
      name: "map"
    }
  }
});
var __defProp52 = Object.defineProperty;
var __export52 = (target, all622) => {
  for (var name22 in all622)
    __defProp52(target, name22, { get: all622[name22], enumerable: true });
};
function resolveMemberExpressions(object32, property) {
  if (object32.type === types.AST_NODE_TYPES.JSXMemberExpression) {
    return `${resolveMemberExpressions(object32.object, object32.property)}.${property.name}`;
  }
  if (object32.type === types.AST_NODE_TYPES.JSXNamespacedName) {
    return `${object32.namespace.name}:${object32.name.name}.${property.name}`;
  }
  return `${object32.name}.${property.name}`;
}
function elementType(node) {
  if (node.type === types.AST_NODE_TYPES.JSXOpeningFragment) {
    return "<>";
  }
  const { name: name22 } = node;
  if (name22.type === types.AST_NODE_TYPES.JSXMemberExpression) {
    const { object: object32, property } = name22;
    return resolveMemberExpressions(object32, property);
  }
  if (name22.type === types.AST_NODE_TYPES.JSXNamespacedName) {
    return `${name22.namespace.name}:${name22.name.name}`;
  }
  return name22.name;
}
var KEYS42 = {
  ArrayExpression: [
    "elements"
  ],
  ArrayPattern: [
    "elements"
  ],
  ArrowFunctionExpression: [
    "params",
    "body"
  ],
  AssignmentExpression: [
    "left",
    "right"
  ],
  AssignmentPattern: [
    "left",
    "right"
  ],
  AwaitExpression: [
    "argument"
  ],
  BinaryExpression: [
    "left",
    "right"
  ],
  BlockStatement: [
    "body"
  ],
  BreakStatement: [
    "label"
  ],
  CallExpression: [
    "callee",
    "arguments"
  ],
  CatchClause: [
    "param",
    "body"
  ],
  ChainExpression: [
    "expression"
  ],
  ClassBody: [
    "body"
  ],
  ClassDeclaration: [
    "id",
    "superClass",
    "body"
  ],
  ClassExpression: [
    "id",
    "superClass",
    "body"
  ],
  ConditionalExpression: [
    "test",
    "consequent",
    "alternate"
  ],
  ContinueStatement: [
    "label"
  ],
  DebuggerStatement: [],
  DoWhileStatement: [
    "body",
    "test"
  ],
  EmptyStatement: [],
  ExperimentalRestProperty: [
    "argument"
  ],
  ExperimentalSpreadProperty: [
    "argument"
  ],
  ExportAllDeclaration: [
    "exported",
    "source"
  ],
  ExportDefaultDeclaration: [
    "declaration"
  ],
  ExportNamedDeclaration: [
    "declaration",
    "specifiers",
    "source"
  ],
  ExportSpecifier: [
    "exported",
    "local"
  ],
  ExpressionStatement: [
    "expression"
  ],
  ForInStatement: [
    "left",
    "right",
    "body"
  ],
  ForOfStatement: [
    "left",
    "right",
    "body"
  ],
  ForStatement: [
    "init",
    "test",
    "update",
    "body"
  ],
  FunctionDeclaration: [
    "id",
    "params",
    "body"
  ],
  FunctionExpression: [
    "id",
    "params",
    "body"
  ],
  Identifier: [],
  IfStatement: [
    "test",
    "consequent",
    "alternate"
  ],
  ImportDeclaration: [
    "specifiers",
    "source"
  ],
  ImportDefaultSpecifier: [
    "local"
  ],
  ImportExpression: [
    "source"
  ],
  ImportNamespaceSpecifier: [
    "local"
  ],
  ImportSpecifier: [
    "imported",
    "local"
  ],
  JSXAttribute: [
    "name",
    "value"
  ],
  JSXClosingElement: [
    "name"
  ],
  JSXClosingFragment: [],
  JSXElement: [
    "openingElement",
    "children",
    "closingElement"
  ],
  JSXEmptyExpression: [],
  JSXExpressionContainer: [
    "expression"
  ],
  JSXFragment: [
    "openingFragment",
    "children",
    "closingFragment"
  ],
  JSXIdentifier: [],
  JSXMemberExpression: [
    "object",
    "property"
  ],
  JSXNamespacedName: [
    "namespace",
    "name"
  ],
  JSXOpeningElement: [
    "name",
    "attributes"
  ],
  JSXOpeningFragment: [],
  JSXSpreadAttribute: [
    "argument"
  ],
  JSXSpreadChild: [
    "expression"
  ],
  JSXText: [],
  LabeledStatement: [
    "label",
    "body"
  ],
  Literal: [],
  LogicalExpression: [
    "left",
    "right"
  ],
  MemberExpression: [
    "object",
    "property"
  ],
  MetaProperty: [
    "meta",
    "property"
  ],
  MethodDefinition: [
    "key",
    "value"
  ],
  NewExpression: [
    "callee",
    "arguments"
  ],
  ObjectExpression: [
    "properties"
  ],
  ObjectPattern: [
    "properties"
  ],
  PrivateIdentifier: [],
  Program: [
    "body"
  ],
  Property: [
    "key",
    "value"
  ],
  PropertyDefinition: [
    "key",
    "value"
  ],
  RestElement: [
    "argument"
  ],
  ReturnStatement: [
    "argument"
  ],
  SequenceExpression: [
    "expressions"
  ],
  SpreadElement: [
    "argument"
  ],
  StaticBlock: [
    "body"
  ],
  Super: [],
  SwitchCase: [
    "test",
    "consequent"
  ],
  SwitchStatement: [
    "discriminant",
    "cases"
  ],
  TaggedTemplateExpression: [
    "tag",
    "quasi"
  ],
  TemplateElement: [],
  TemplateLiteral: [
    "quasis",
    "expressions"
  ],
  ThisExpression: [],
  ThrowStatement: [
    "argument"
  ],
  TryStatement: [
    "block",
    "handler",
    "finalizer"
  ],
  UnaryExpression: [
    "argument"
  ],
  UpdateExpression: [
    "argument"
  ],
  VariableDeclaration: [
    "declarations"
  ],
  VariableDeclarator: [
    "id",
    "init"
  ],
  WhileStatement: [
    "test",
    "body"
  ],
  WithStatement: [
    "object",
    "body"
  ],
  YieldExpression: [
    "argument"
  ]
};
var NODE_TYPES42 = Object.keys(KEYS42);
for (const type of NODE_TYPES42) {
  Object.freeze(KEYS42[type]);
}
Object.freeze(KEYS42);
var visitor_keys_default42 = KEYS42;
var KEY_BLACKLIST42 = /* @__PURE__ */ new Set([
  "parent",
  "leadingComments",
  "trailingComments"
]);
function filterKey42(key) {
  return !KEY_BLACKLIST42.has(key) && key[0] !== "_";
}
function getKeys42(node) {
  return Object.keys(node).filter(filterKey42);
}
function getInnermostScope42(initialScope, node) {
  const location = node.range[0];
  let scope = initialScope;
  let found = false;
  do {
    found = false;
    for (const childScope of scope.childScopes) {
      const range222 = childScope.block.range;
      if (range222[0] <= location && location < range222[1]) {
        scope = childScope;
        found = true;
        break;
      }
    }
  } while (found);
  return scope;
}
function findVariable42(initialScope, nameOrNode) {
  let name22 = "";
  let scope = initialScope;
  if (typeof nameOrNode === "string") {
    name22 = nameOrNode;
  } else {
    name22 = nameOrNode.name;
    scope = getInnermostScope42(scope, nameOrNode);
  }
  while (scope != null) {
    const variable = scope.set.get(name22);
    if (variable != null) {
      return variable;
    }
    scope = scope.upper;
  }
  return null;
}
function negate042(token) {
  return !this(token);
}
function negate42(f232) {
  return negate042.bind(f232);
}
function isPunctuatorTokenWithValue42(token, value) {
  return token.type === "Punctuator" && token.value === value;
}
function isArrowToken42(token) {
  return isPunctuatorTokenWithValue42(token, "=>");
}
function isCommaToken42(token) {
  return isPunctuatorTokenWithValue42(token, ",");
}
function isSemicolonToken42(token) {
  return isPunctuatorTokenWithValue42(token, ";");
}
function isColonToken42(token) {
  return isPunctuatorTokenWithValue42(token, ":");
}
function isOpeningParenToken42(token) {
  return isPunctuatorTokenWithValue42(token, "(");
}
function isClosingParenToken42(token) {
  return isPunctuatorTokenWithValue42(token, ")");
}
function isOpeningBracketToken42(token) {
  return isPunctuatorTokenWithValue42(token, "[");
}
function isClosingBracketToken42(token) {
  return isPunctuatorTokenWithValue42(token, "]");
}
function isOpeningBraceToken42(token) {
  return isPunctuatorTokenWithValue42(token, "{");
}
function isClosingBraceToken42(token) {
  return isPunctuatorTokenWithValue42(token, "}");
}
function isCommentToken42(token) {
  return ["Block", "Line", "Shebang"].includes(token.type);
}
negate42(isArrowToken42);
negate42(isCommaToken42);
negate42(isSemicolonToken42);
negate42(isColonToken42);
negate42(isOpeningParenToken42);
negate42(isClosingParenToken42);
negate42(isOpeningBracketToken42);
negate42(isClosingBracketToken42);
negate42(isOpeningBraceToken42);
negate42(isClosingBraceToken42);
negate42(isCommentToken42);
function getOpeningParenOfParams42(node, sourceCode) {
  return node.id ? sourceCode.getTokenAfter(node.id, isOpeningParenToken42) : sourceCode.getFirstToken(node, isOpeningParenToken42);
}
function getFunctionHeadLocation42(node, sourceCode) {
  const parent = node.parent;
  let start = null;
  let end = null;
  if (node.type === "ArrowFunctionExpression") {
    const arrowToken = sourceCode.getTokenBefore(node.body, isArrowToken42);
    start = arrowToken.loc.start;
    end = arrowToken.loc.end;
  } else if (parent.type === "Property" || parent.type === "MethodDefinition" || parent.type === "PropertyDefinition") {
    start = parent.loc.start;
    end = getOpeningParenOfParams42(node, sourceCode).loc.start;
  } else {
    start = node.loc.start;
    end = getOpeningParenOfParams42(node, sourceCode).loc.start;
  }
  return {
    start: { ...start },
    end: { ...end }
  };
}
var globalObject42 = typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {};
var builtinNames42 = Object.freeze(
  /* @__PURE__ */ new Set([
    "Array",
    "ArrayBuffer",
    "BigInt",
    "BigInt64Array",
    "BigUint64Array",
    "Boolean",
    "DataView",
    "Date",
    "decodeURI",
    "decodeURIComponent",
    "encodeURI",
    "encodeURIComponent",
    "escape",
    "Float32Array",
    "Float64Array",
    "Function",
    "Infinity",
    "Int16Array",
    "Int32Array",
    "Int8Array",
    "isFinite",
    "isNaN",
    "isPrototypeOf",
    "JSON",
    "Map",
    "Math",
    "NaN",
    "Number",
    "Object",
    "parseFloat",
    "parseInt",
    "Promise",
    "Proxy",
    "Reflect",
    "RegExp",
    "Set",
    "String",
    "Symbol",
    "Uint16Array",
    "Uint32Array",
    "Uint8Array",
    "Uint8ClampedArray",
    "undefined",
    "unescape",
    "WeakMap",
    "WeakSet"
  ])
);
var callAllowed42 = new Set(
  [
    Array.isArray,
    Array.of,
    Array.prototype.at,
    Array.prototype.concat,
    Array.prototype.entries,
    Array.prototype.every,
    Array.prototype.filter,
    Array.prototype.find,
    Array.prototype.findIndex,
    Array.prototype.flat,
    Array.prototype.includes,
    Array.prototype.indexOf,
    Array.prototype.join,
    Array.prototype.keys,
    Array.prototype.lastIndexOf,
    Array.prototype.slice,
    Array.prototype.some,
    Array.prototype.toString,
    Array.prototype.values,
    typeof BigInt === "function" ? BigInt : void 0,
    Boolean,
    Date,
    Date.parse,
    decodeURI,
    decodeURIComponent,
    encodeURI,
    encodeURIComponent,
    escape,
    isFinite,
    isNaN,
    isPrototypeOf,
    Map,
    Map.prototype.entries,
    Map.prototype.get,
    Map.prototype.has,
    Map.prototype.keys,
    Map.prototype.values,
    ...Object.getOwnPropertyNames(Math).filter((k232) => k232 !== "random").map((k232) => Math[k232]).filter((f232) => typeof f232 === "function"),
    Number,
    Number.isFinite,
    Number.isNaN,
    Number.parseFloat,
    Number.parseInt,
    Number.prototype.toExponential,
    Number.prototype.toFixed,
    Number.prototype.toPrecision,
    Number.prototype.toString,
    Object,
    Object.entries,
    Object.is,
    Object.isExtensible,
    Object.isFrozen,
    Object.isSealed,
    Object.keys,
    Object.values,
    parseFloat,
    parseInt,
    RegExp,
    Set,
    Set.prototype.entries,
    Set.prototype.has,
    Set.prototype.keys,
    Set.prototype.values,
    String,
    String.fromCharCode,
    String.fromCodePoint,
    String.raw,
    String.prototype.at,
    String.prototype.charAt,
    String.prototype.charCodeAt,
    String.prototype.codePointAt,
    String.prototype.concat,
    String.prototype.endsWith,
    String.prototype.includes,
    String.prototype.indexOf,
    String.prototype.lastIndexOf,
    String.prototype.normalize,
    String.prototype.padEnd,
    String.prototype.padStart,
    String.prototype.slice,
    String.prototype.startsWith,
    String.prototype.substr,
    String.prototype.substring,
    String.prototype.toLowerCase,
    String.prototype.toString,
    String.prototype.toUpperCase,
    String.prototype.trim,
    String.prototype.trimEnd,
    String.prototype.trimLeft,
    String.prototype.trimRight,
    String.prototype.trimStart,
    Symbol.for,
    Symbol.keyFor,
    unescape
  ].filter((f232) => typeof f232 === "function")
);
var callPassThrough42 = /* @__PURE__ */ new Set([
  Object.freeze,
  Object.preventExtensions,
  Object.seal
]);
var getterAllowed42 = [
  [Map, /* @__PURE__ */ new Set(["size"])],
  [
    RegExp,
    /* @__PURE__ */ new Set([
      "dotAll",
      "flags",
      "global",
      "hasIndices",
      "ignoreCase",
      "multiline",
      "source",
      "sticky",
      "unicode"
    ])
  ],
  [Set, /* @__PURE__ */ new Set(["size"])]
];
function getPropertyDescriptor42(object32, name22) {
  let x232 = object32;
  while ((typeof x232 === "object" || typeof x232 === "function") && x232 !== null) {
    const d232 = Object.getOwnPropertyDescriptor(x232, name22);
    if (d232) {
      return d232;
    }
    x232 = Object.getPrototypeOf(x232);
  }
  return null;
}
function isGetter42(object32, name22) {
  const d232 = getPropertyDescriptor42(object32, name22);
  return d232 != null && d232.get != null;
}
function getElementValues42(nodeList, initialScope) {
  const valueList = [];
  for (let i232 = 0; i232 < nodeList.length; ++i232) {
    const elementNode = nodeList[i232];
    if (elementNode == null) {
      valueList.length = i232 + 1;
    } else if (elementNode.type === "SpreadElement") {
      const argument = getStaticValueR42(elementNode.argument, initialScope);
      if (argument == null) {
        return null;
      }
      valueList.push(...argument.value);
    } else {
      const element = getStaticValueR42(elementNode, initialScope);
      if (element == null) {
        return null;
      }
      valueList.push(element.value);
    }
  }
  return valueList;
}
function isEffectivelyConst42(variable) {
  const refs = variable.references;
  const inits = refs.filter((r232) => r232.init).length;
  const reads = refs.filter((r232) => r232.isReadOnly()).length;
  if (inits === 1 && reads + inits === refs.length) {
    return true;
  }
  return false;
}
var operations42 = Object.freeze({
  ArrayExpression(node, initialScope) {
    const elements = getElementValues42(node.elements, initialScope);
    return elements != null ? { value: elements } : null;
  },
  AssignmentExpression(node, initialScope) {
    if (node.operator === "=") {
      return getStaticValueR42(node.right, initialScope);
    }
    return null;
  },
  //eslint-disable-next-line complexity
  BinaryExpression(node, initialScope) {
    if (node.operator === "in" || node.operator === "instanceof") {
      return null;
    }
    const left522 = getStaticValueR42(node.left, initialScope);
    const right522 = getStaticValueR42(node.right, initialScope);
    if (left522 != null && right522 != null) {
      switch (node.operator) {
        case "==":
          return { value: left522.value == right522.value };
        case "!=":
          return { value: left522.value != right522.value };
        case "===":
          return { value: left522.value === right522.value };
        case "!==":
          return { value: left522.value !== right522.value };
        case "<":
          return { value: left522.value < right522.value };
        case "<=":
          return { value: left522.value <= right522.value };
        case ">":
          return { value: left522.value > right522.value };
        case ">=":
          return { value: left522.value >= right522.value };
        case "<<":
          return { value: left522.value << right522.value };
        case ">>":
          return { value: left522.value >> right522.value };
        case ">>>":
          return { value: left522.value >>> right522.value };
        case "+":
          return { value: left522.value + right522.value };
        case "-":
          return { value: left522.value - right522.value };
        case "*":
          return { value: left522.value * right522.value };
        case "/":
          return { value: left522.value / right522.value };
        case "%":
          return { value: left522.value % right522.value };
        case "**":
          return { value: left522.value ** right522.value };
        case "|":
          return { value: left522.value | right522.value };
        case "^":
          return { value: left522.value ^ right522.value };
        case "&":
          return { value: left522.value & right522.value };
      }
    }
    return null;
  },
  CallExpression(node, initialScope) {
    const calleeNode = node.callee;
    const args = getElementValues42(node.arguments, initialScope);
    if (args != null) {
      if (calleeNode.type === "MemberExpression") {
        if (calleeNode.property.type === "PrivateIdentifier") {
          return null;
        }
        const object32 = getStaticValueR42(calleeNode.object, initialScope);
        if (object32 != null) {
          if (object32.value == null && (object32.optional || node.optional)) {
            return { value: void 0, optional: true };
          }
          const property = getStaticPropertyNameValue42(
            calleeNode,
            initialScope
          );
          if (property != null) {
            const receiver = object32.value;
            const methodName = property.value;
            if (callAllowed42.has(receiver[methodName])) {
              return { value: receiver[methodName](...args) };
            }
            if (callPassThrough42.has(receiver[methodName])) {
              return { value: args[0] };
            }
          }
        }
      } else {
        const callee = getStaticValueR42(calleeNode, initialScope);
        if (callee != null) {
          if (callee.value == null && node.optional) {
            return { value: void 0, optional: true };
          }
          const func = callee.value;
          if (callAllowed42.has(func)) {
            return { value: func(...args) };
          }
          if (callPassThrough42.has(func)) {
            return { value: args[0] };
          }
        }
      }
    }
    return null;
  },
  ConditionalExpression(node, initialScope) {
    const test = getStaticValueR42(node.test, initialScope);
    if (test != null) {
      return test.value ? getStaticValueR42(node.consequent, initialScope) : getStaticValueR42(node.alternate, initialScope);
    }
    return null;
  },
  ExpressionStatement(node, initialScope) {
    return getStaticValueR42(node.expression, initialScope);
  },
  Identifier(node, initialScope) {
    if (initialScope != null) {
      const variable = findVariable42(initialScope, node);
      if (variable != null && variable.defs.length === 0 && builtinNames42.has(variable.name) && variable.name in globalObject42) {
        return { value: globalObject42[variable.name] };
      }
      if (variable != null && variable.defs.length === 1) {
        const def = variable.defs[0];
        if (def.parent && def.type === "Variable" && (def.parent.kind === "const" || isEffectivelyConst42(variable)) && // TODO(mysticatea): don't support destructuring here.
        def.node.id.type === "Identifier") {
          return getStaticValueR42(def.node.init, initialScope);
        }
      }
    }
    return null;
  },
  Literal(node) {
    if ((node.regex != null || node.bigint != null) && node.value == null) {
      return null;
    }
    return { value: node.value };
  },
  LogicalExpression(node, initialScope) {
    const left522 = getStaticValueR42(node.left, initialScope);
    if (left522 != null) {
      if (node.operator === "||" && Boolean(left522.value) === true || node.operator === "&&" && Boolean(left522.value) === false || node.operator === "??" && left522.value != null) {
        return left522;
      }
      const right522 = getStaticValueR42(node.right, initialScope);
      if (right522 != null) {
        return right522;
      }
    }
    return null;
  },
  MemberExpression(node, initialScope) {
    if (node.property.type === "PrivateIdentifier") {
      return null;
    }
    const object32 = getStaticValueR42(node.object, initialScope);
    if (object32 != null) {
      if (object32.value == null && (object32.optional || node.optional)) {
        return { value: void 0, optional: true };
      }
      const property = getStaticPropertyNameValue42(node, initialScope);
      if (property != null) {
        if (!isGetter42(object32.value, property.value)) {
          return { value: object32.value[property.value] };
        }
        for (const [classFn, allowed] of getterAllowed42) {
          if (object32.value instanceof classFn && allowed.has(property.value)) {
            return { value: object32.value[property.value] };
          }
        }
      }
    }
    return null;
  },
  ChainExpression(node, initialScope) {
    const expression = getStaticValueR42(node.expression, initialScope);
    if (expression != null) {
      return { value: expression.value };
    }
    return null;
  },
  NewExpression(node, initialScope) {
    const callee = getStaticValueR42(node.callee, initialScope);
    const args = getElementValues42(node.arguments, initialScope);
    if (callee != null && args != null) {
      const Func = callee.value;
      if (callAllowed42.has(Func)) {
        return { value: new Func(...args) };
      }
    }
    return null;
  },
  ObjectExpression(node, initialScope) {
    const object32 = {};
    for (const propertyNode of node.properties) {
      if (propertyNode.type === "Property") {
        if (propertyNode.kind !== "init") {
          return null;
        }
        const key = getStaticPropertyNameValue42(
          propertyNode,
          initialScope
        );
        const value = getStaticValueR42(propertyNode.value, initialScope);
        if (key == null || value == null) {
          return null;
        }
        object32[key.value] = value.value;
      } else if (propertyNode.type === "SpreadElement" || propertyNode.type === "ExperimentalSpreadProperty") {
        const argument = getStaticValueR42(
          propertyNode.argument,
          initialScope
        );
        if (argument == null) {
          return null;
        }
        Object.assign(object32, argument.value);
      } else {
        return null;
      }
    }
    return { value: object32 };
  },
  SequenceExpression(node, initialScope) {
    const last222 = node.expressions[node.expressions.length - 1];
    return getStaticValueR42(last222, initialScope);
  },
  TaggedTemplateExpression(node, initialScope) {
    const tag = getStaticValueR42(node.tag, initialScope);
    const expressions = getElementValues42(
      node.quasi.expressions,
      initialScope
    );
    if (tag != null && expressions != null) {
      const func = tag.value;
      const strings = node.quasi.quasis.map((q) => q.value.cooked);
      strings.raw = node.quasi.quasis.map((q) => q.value.raw);
      if (func === String.raw) {
        return { value: func(strings, ...expressions) };
      }
    }
    return null;
  },
  TemplateLiteral(node, initialScope) {
    const expressions = getElementValues42(node.expressions, initialScope);
    if (expressions != null) {
      let value = node.quasis[0].value.cooked;
      for (let i232 = 0; i232 < expressions.length; ++i232) {
        value += expressions[i232];
        value += node.quasis[i232 + 1].value.cooked;
      }
      return { value };
    }
    return null;
  },
  UnaryExpression(node, initialScope) {
    if (node.operator === "delete") {
      return null;
    }
    if (node.operator === "void") {
      return { value: void 0 };
    }
    const arg = getStaticValueR42(node.argument, initialScope);
    if (arg != null) {
      switch (node.operator) {
        case "-":
          return { value: -arg.value };
        case "+":
          return { value: +arg.value };
        case "!":
          return { value: !arg.value };
        case "~":
          return { value: ~arg.value };
        case "typeof":
          return { value: typeof arg.value };
      }
    }
    return null;
  }
});
function getStaticValueR42(node, initialScope) {
  if (node != null && Object.hasOwnProperty.call(operations42, node.type)) {
    return operations42[node.type](node, initialScope);
  }
  return null;
}
function getStaticPropertyNameValue42(node, initialScope) {
  const nameNode = node.type === "Property" ? node.key : node.property;
  if (node.computed) {
    return getStaticValueR42(nameNode, initialScope);
  }
  if (nameNode.type === "Identifier") {
    return { value: nameNode.name };
  }
  if (nameNode.type === "Literal") {
    if (nameNode.bigint) {
      return { value: nameNode.bigint };
    }
    return { value: String(nameNode.value) };
  }
  return null;
}
function getStaticValue32(node, initialScope = null) {
  try {
    return getStaticValueR42(node, initialScope);
  } catch (_error) {
    return null;
  }
}
function getStringIfConstant42(node, initialScope = null) {
  if (node && node.type === "Literal" && node.value === null) {
    if (node.regex) {
      return `/${node.regex.pattern}/${node.regex.flags}`;
    }
    if (node.bigint) {
      return node.bigint;
    }
  }
  const evaluated = getStaticValue32(node, initialScope);
  return evaluated && String(evaluated.value);
}
function getPropertyName42(node, initialScope) {
  switch (node.type) {
    case "MemberExpression":
      if (node.computed) {
        return getStringIfConstant42(node.property, initialScope);
      }
      if (node.property.type === "PrivateIdentifier") {
        return null;
      }
      return node.property.name;
    case "Property":
    case "MethodDefinition":
    case "PropertyDefinition":
      if (node.computed) {
        return getStringIfConstant42(node.key, initialScope);
      }
      if (node.key.type === "Literal") {
        return String(node.key.value);
      }
      if (node.key.type === "PrivateIdentifier") {
        return null;
      }
      return node.key.name;
  }
  return null;
}
function getFunctionNameWithKind42(node, sourceCode) {
  const parent = node.parent;
  const tokens = [];
  const isObjectMethod = parent.type === "Property" && parent.value === node;
  const isClassMethod = parent.type === "MethodDefinition" && parent.value === node;
  const isClassFieldMethod = parent.type === "PropertyDefinition" && parent.value === node;
  if (isClassMethod || isClassFieldMethod) {
    if (parent.static) {
      tokens.push("static");
    }
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push("private");
    }
  }
  if (node.async) {
    tokens.push("async");
  }
  if (node.generator) {
    tokens.push("generator");
  }
  if (isObjectMethod || isClassMethod) {
    if (parent.kind === "constructor") {
      return "constructor";
    }
    if (parent.kind === "get") {
      tokens.push("getter");
    } else if (parent.kind === "set") {
      tokens.push("setter");
    } else {
      tokens.push("method");
    }
  } else if (isClassFieldMethod) {
    tokens.push("method");
  } else {
    if (node.type === "ArrowFunctionExpression") {
      tokens.push("arrow");
    }
    tokens.push("function");
  }
  if (isObjectMethod || isClassMethod || isClassFieldMethod) {
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push(`#${parent.key.name}`);
    } else {
      const name22 = getPropertyName42(parent);
      if (name22) {
        tokens.push(`'${name22}'`);
      } else if (sourceCode) {
        const keyText = sourceCode.getText(parent.key);
        if (!keyText.includes("\n")) {
          tokens.push(`[${keyText}]`);
        }
      }
    }
  } else if (node.id) {
    tokens.push(`'${node.id.name}'`);
  } else if (parent.type === "VariableDeclarator" && parent.id && parent.id.type === "Identifier") {
    tokens.push(`'${parent.id.name}'`);
  } else if ((parent.type === "AssignmentExpression" || parent.type === "AssignmentPattern") && parent.left && parent.left.type === "Identifier") {
    tokens.push(`'${parent.left.name}'`);
  } else if (parent.type === "ExportDefaultDeclaration" && parent.declaration === node) {
    tokens.push("'default'");
  }
  return tokens.join(" ");
}
var typeConversionBinaryOps42 = Object.freeze(
  /* @__PURE__ */ new Set([
    "==",
    "!=",
    "<",
    "<=",
    ">",
    ">=",
    "<<",
    ">>",
    ">>>",
    "+",
    "-",
    "*",
    "/",
    "%",
    "|",
    "^",
    "&",
    "in"
  ])
);
var typeConversionUnaryOps42 = Object.freeze(/* @__PURE__ */ new Set(["-", "+", "!", "~"]));
function isNode42(x232) {
  return x232 !== null && typeof x232 === "object" && typeof x232.type === "string";
}
var visitor42 = Object.freeze(
  Object.assign(/* @__PURE__ */ Object.create(null), {
    $visit(node, options, visitorKeys) {
      const { type } = node;
      if (typeof this[type] === "function") {
        return this[type](node, options, visitorKeys);
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    $visitChildren(node, options, visitorKeys) {
      const { type } = node;
      for (const key of visitorKeys[type] || getKeys42(node)) {
        const value = node[key];
        if (Array.isArray(value)) {
          for (const element of value) {
            if (isNode42(element) && this.$visit(element, options, visitorKeys)) {
              return true;
            }
          }
        } else if (isNode42(value) && this.$visit(value, options, visitorKeys)) {
          return true;
        }
      }
      return false;
    },
    ArrowFunctionExpression() {
      return false;
    },
    AssignmentExpression() {
      return true;
    },
    AwaitExpression() {
      return true;
    },
    BinaryExpression(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && typeConversionBinaryOps42.has(node.operator) && (node.left.type !== "Literal" || node.right.type !== "Literal")) {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    CallExpression() {
      return true;
    },
    FunctionExpression() {
      return false;
    },
    ImportExpression() {
      return true;
    },
    MemberExpression(node, options, visitorKeys) {
      if (options.considerGetters) {
        return true;
      }
      if (options.considerImplicitTypeConversion && node.computed && node.property.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    MethodDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    NewExpression() {
      return true;
    },
    Property(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    PropertyDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UnaryExpression(node, options, visitorKeys) {
      if (node.operator === "delete") {
        return true;
      }
      if (options.considerImplicitTypeConversion && typeConversionUnaryOps42.has(node.operator) && node.argument.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UpdateExpression() {
      return true;
    },
    YieldExpression() {
      return true;
    }
  })
);
function hasSideEffect42(node, sourceCode, { considerGetters = false, considerImplicitTypeConversion = false } = {}) {
  return visitor42.$visit(
    node,
    { considerGetters, considerImplicitTypeConversion },
    sourceCode.visitorKeys || visitor_keys_default42
  );
}
function getParentSyntaxParen42(node, sourceCode) {
  const parent = node.parent;
  switch (parent.type) {
    case "CallExpression":
    case "NewExpression":
      if (parent.arguments.length === 1 && parent.arguments[0] === node) {
        return sourceCode.getTokenAfter(
          parent.callee,
          isOpeningParenToken42
        );
      }
      return null;
    case "DoWhileStatement":
      if (parent.test === node) {
        return sourceCode.getTokenAfter(
          parent.body,
          isOpeningParenToken42
        );
      }
      return null;
    case "IfStatement":
    case "WhileStatement":
      if (parent.test === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "ImportExpression":
      if (parent.source === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "SwitchStatement":
      if (parent.discriminant === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "WithStatement":
      if (parent.object === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    default:
      return null;
  }
}
function isParenthesized42(timesOrNode, nodeOrSourceCode, optionalSourceCode) {
  let times, node, sourceCode, maybeLeftParen, maybeRightParen;
  if (typeof timesOrNode === "number") {
    times = timesOrNode | 0;
    node = nodeOrSourceCode;
    sourceCode = optionalSourceCode;
    if (!(times >= 1)) {
      throw new TypeError("'times' should be a positive integer.");
    }
  } else {
    times = 1;
    node = timesOrNode;
    sourceCode = nodeOrSourceCode;
  }
  if (node == null || // `Program` can't be parenthesized
  node.parent == null || // `CatchClause.param` can't be parenthesized, example `try {} catch (error) {}`
  node.parent.type === "CatchClause" && node.parent.param === node) {
    return false;
  }
  maybeLeftParen = maybeRightParen = node;
  do {
    maybeLeftParen = sourceCode.getTokenBefore(maybeLeftParen);
    maybeRightParen = sourceCode.getTokenAfter(maybeRightParen);
  } while (maybeLeftParen != null && maybeRightParen != null && isOpeningParenToken42(maybeLeftParen) && isClosingParenToken42(maybeRightParen) && // Avoid false positive such as `if (a) {}`
  maybeLeftParen !== getParentSyntaxParen42(node, sourceCode) && --times > 0);
  return times === 0;
}
Function.call.bind(Object.hasOwnProperty);
var __defProp242 = Object.defineProperty;
var __export242 = (target, all3232) => {
  for (var name22 in all3232)
    __defProp242(target, name22, { get: all3232[name22], enumerable: true });
};
var NodeType42 = types.AST_NODE_TYPES;
var is42 = utils.ASTUtils.isNodeOfType;
var isOneOf42 = utils.ASTUtils.isNodeOfTypes;
isOneOf42([
  NodeType42.ArrowFunctionExpression,
  NodeType42.FunctionDeclaration,
  NodeType42.FunctionExpression
]);
isOneOf42([
  NodeType42.ArrowFunctionExpression,
  NodeType42.FunctionDeclaration,
  NodeType42.FunctionExpression,
  NodeType42.TSCallSignatureDeclaration,
  NodeType42.TSConstructSignatureDeclaration,
  NodeType42.TSDeclareFunction,
  NodeType42.TSEmptyBodyFunctionExpression,
  NodeType42.TSFunctionType,
  NodeType42.TSMethodSignature
]);
isOneOf42([NodeType42.ClassDeclaration, NodeType42.ClassExpression]);
isOneOf42([
  NodeType42.DoWhileStatement,
  NodeType42.ForInStatement,
  NodeType42.ForOfStatement,
  NodeType42.ForStatement,
  NodeType42.WhileStatement
]);
isOneOf42([NodeType42.TSArrayType, NodeType42.TSTupleType]);
isOneOf42([
  NodeType42.PropertyDefinition,
  NodeType42.TSIndexSignature,
  NodeType42.TSParameterProperty,
  NodeType42.TSPropertySignature
]);
is42(NodeType42.JSXElement);
is42(NodeType42.JSXFragment);
isOneOf42([
  NodeType42.JSXAttribute,
  NodeType42.JSXSpreadChild,
  NodeType42.JSXClosingElement,
  NodeType42.JSXClosingFragment,
  NodeType42.JSXElement,
  NodeType42.JSXEmptyExpression,
  NodeType42.JSXExpressionContainer,
  NodeType42.JSXFragment,
  NodeType42.JSXIdentifier,
  NodeType42.JSXMemberExpression,
  NodeType42.JSXNamespacedName,
  NodeType42.JSXOpeningElement,
  NodeType42.JSXOpeningFragment,
  NodeType42.JSXSpreadAttribute,
  NodeType42.JSXSpreadChild,
  NodeType42.JSXText
]);
isOneOf42([
  NodeType42.JSXIdentifier,
  NodeType42.JSXMemberExpression,
  NodeType42.JSXNamespacedName
]);
isOneOf42([
  NodeType42.ArrayPattern,
  NodeType42.AssignmentPattern,
  NodeType42.ObjectPattern,
  NodeType42.RestElement
]);
isOneOf42([
  NodeType42.TSInterfaceDeclaration,
  NodeType42.TSTypeAliasDeclaration
]);
isOneOf42([
  NodeType42.ArrayExpression,
  NodeType42.ArrayPattern,
  NodeType42.ArrowFunctionExpression,
  NodeType42.CallExpression,
  NodeType42.ClassExpression,
  NodeType42.FunctionExpression,
  NodeType42.Identifier,
  NodeType42.JSXElement,
  NodeType42.JSXFragment,
  NodeType42.Literal,
  NodeType42.TemplateLiteral,
  NodeType42.MemberExpression,
  NodeType42.MetaProperty,
  NodeType42.ObjectExpression,
  NodeType42.ObjectPattern,
  NodeType42.SequenceExpression,
  NodeType42.Super,
  NodeType42.TaggedTemplateExpression,
  NodeType42.ThisExpression
]);
isOneOf42([
  NodeType42.ArrayExpression,
  NodeType42.ArrayPattern,
  NodeType42.ArrowFunctionExpression,
  NodeType42.CallExpression,
  NodeType42.ClassExpression,
  NodeType42.FunctionExpression,
  NodeType42.Identifier,
  NodeType42.JSXElement,
  NodeType42.JSXFragment,
  NodeType42.Literal,
  NodeType42.TemplateLiteral,
  NodeType42.MemberExpression,
  NodeType42.MetaProperty,
  NodeType42.ObjectExpression,
  NodeType42.ObjectPattern,
  NodeType42.SequenceExpression,
  NodeType42.Super,
  NodeType42.TaggedTemplateExpression,
  NodeType42.ThisExpression,
  NodeType42.TSAsExpression,
  NodeType42.TSNonNullExpression,
  NodeType42.TSTypeAssertion
]);
function isMultiLine(node) {
  return node.loc.start.line !== node.loc.end.line;
}
var Function_exports62 = {};
__export242(Function_exports62, {
  SK: () => SK62,
  absurd: () => absurd62,
  apply: () => apply62,
  compose: () => compose92,
  constFalse: () => constFalse62,
  constNull: () => constNull62,
  constTrue: () => constTrue62,
  constUndefined: () => constUndefined62,
  constVoid: () => constVoid62,
  constant: () => constant62,
  dual: () => dual62,
  flip: () => flip62,
  flow: () => flow62,
  hole: () => hole62,
  identity: () => identity62,
  isFunction: () => isFunction242,
  pipe: () => pipe62,
  satisfies: () => satisfies62,
  tupled: () => tupled62,
  unsafeCoerce: () => unsafeCoerce62,
  untupled: () => untupled62
});
var isFunction242 = (input) => typeof input === "function";
var dual62 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a232, b232) {
        if (arguments.length >= 2) {
          return body(a232, b232);
        }
        return function(self2) {
          return body(self2, a232);
        };
      };
    case 3:
      return function(a232, b232, c232) {
        if (arguments.length >= 3) {
          return body(a232, b232, c232);
        }
        return function(self2) {
          return body(self2, a232, b232);
        };
      };
    case 4:
      return function(a232, b232, c232, d232) {
        if (arguments.length >= 4) {
          return body(a232, b232, c232, d232);
        }
        return function(self2) {
          return body(self2, a232, b232, c232);
        };
      };
    case 5:
      return function(a232, b232, c232, d232, e232) {
        if (arguments.length >= 5) {
          return body(a232, b232, c232, d232, e232);
        }
        return function(self2) {
          return body(self2, a232, b232, c232, d232);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply62 = (a232) => (self2) => self2(a232);
var identity62 = (a232) => a232;
var satisfies62 = () => (b232) => b232;
var unsafeCoerce62 = identity62;
var constant62 = (value) => () => value;
var constTrue62 = /* @__PURE__ */ constant62(true);
var constFalse62 = /* @__PURE__ */ constant62(false);
var constNull62 = /* @__PURE__ */ constant62(null);
var constUndefined62 = /* @__PURE__ */ constant62(void 0);
var constVoid62 = constUndefined62;
var flip62 = (f232) => (...b232) => (...a232) => f232(...a232)(...b232);
var compose92 = /* @__PURE__ */ dual62(2, (ab, bc) => (a232) => bc(ab(a232)));
var absurd62 = (_232) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled62 = (f232) => (a232) => f232(...a232);
var untupled62 = (f232) => (...a232) => f232(a232);
function pipe62(a232, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a232;
    case 2:
      return ab(a232);
    case 3:
      return bc(ab(a232));
    case 4:
      return cd(bc(ab(a232)));
    case 5:
      return de(cd(bc(ab(a232))));
    case 6:
      return ef(de(cd(bc(ab(a232)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a232))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a232)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a232))))))));
    default: {
      let ret = arguments[0];
      for (let i232 = 1; i232 < arguments.length; i232++) {
        ret = arguments[i232](ret);
      }
      return ret;
    }
  }
}
function flow62(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole62 = /* @__PURE__ */ unsafeCoerce62(absurd62);
var SK62 = (_232, b232) => b232;
var make172 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_102 = (map622) => dual62(3, (self2, name22, f232) => map622(self2, (a232) => Object.assign({}, a232, {
  [name22]: f232(a232)
})));
var bindTo102 = (map622) => dual62(2, (self2, name22) => map622(self2, (a232) => ({
  [name22]: a232
})));
var bind102 = (map622, flatMap4222) => dual62(3, (self2, name22, f232) => flatMap4222(self2, (a232) => map622(f232(a232), (b232) => Object.assign({}, a232, {
  [name22]: b232
}))));
var moduleVersion62 = "3.2.8";
var getCurrentVersion62 = () => moduleVersion62;
var globalStoreId62 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion62()}`);
if (!(globalStoreId62 in globalThis)) {
  globalThis[globalStoreId62] = /* @__PURE__ */ new Map();
}
var globalStore62 = globalThis[globalStoreId62];
var globalValue62 = (id, compute) => {
  if (!globalStore62.has(id)) {
    globalStore62.set(id, compute());
  }
  return globalStore62.get(id);
};
var Predicate_exports42 = {};
__export242(Predicate_exports42, {
  all: () => all92,
  and: () => and62,
  compose: () => compose242,
  eqv: () => eqv62,
  every: () => every72,
  hasProperty: () => hasProperty62,
  implies: () => implies62,
  isBigInt: () => isBigInt62,
  isBoolean: () => isBoolean62,
  isDate: () => isDate62,
  isError: () => isError62,
  isFunction: () => isFunction332,
  isIterable: () => isIterable62,
  isMap: () => isMap62,
  isNever: () => isNever62,
  isNotNull: () => isNotNull62,
  isNotNullable: () => isNotNullable62,
  isNotUndefined: () => isNotUndefined62,
  isNull: () => isNull62,
  isNullable: () => isNullable62,
  isNumber: () => isNumber62,
  isObject: () => isObject62,
  isPromise: () => isPromise62,
  isPromiseLike: () => isPromiseLike62,
  isReadonlyRecord: () => isReadonlyRecord62,
  isRecord: () => isRecord62,
  isSet: () => isSet62,
  isString: () => isString62,
  isSymbol: () => isSymbol62,
  isTagged: () => isTagged62,
  isTruthy: () => isTruthy62,
  isUint8Array: () => isUint8Array62,
  isUndefined: () => isUndefined62,
  isUnknown: () => isUnknown62,
  mapInput: () => mapInput72,
  nand: () => nand62,
  nor: () => nor62,
  not: () => not62,
  or: () => or62,
  product: () => product92,
  productMany: () => productMany92,
  some: () => some132,
  struct: () => struct82,
  tuple: () => tuple72,
  xor: () => xor62
});
var mapInput72 = /* @__PURE__ */ dual62(2, (self2, f232) => (b232) => self2(f232(b232)));
var isTruthy62 = (input) => !!input;
var isSet62 = (input) => input instanceof Set;
var isMap62 = (input) => input instanceof Map;
var isString62 = (input) => typeof input === "string";
var isNumber62 = (input) => typeof input === "number";
var isBoolean62 = (input) => typeof input === "boolean";
var isBigInt62 = (input) => typeof input === "bigint";
var isSymbol62 = (input) => typeof input === "symbol";
var isFunction332 = isFunction242;
var isUndefined62 = (input) => input === void 0;
var isNotUndefined62 = (input) => input !== void 0;
var isNull62 = (input) => input === null;
var isNotNull62 = (input) => input !== null;
var isNever62 = (_232) => false;
var isUnknown62 = (_232) => true;
var isRecordOrArray62 = (input) => typeof input === "object" && input !== null;
var isObject62 = (input) => isRecordOrArray62(input) || isFunction332(input);
var hasProperty62 = /* @__PURE__ */ dual62(2, (self2, property) => isObject62(self2) && property in self2);
var isTagged62 = /* @__PURE__ */ dual62(2, (self2, tag) => hasProperty62(self2, "_tag") && self2["_tag"] === tag);
var isNullable62 = (input) => input === null || input === void 0;
var isNotNullable62 = (input) => input !== null && input !== void 0;
var isError62 = (input) => input instanceof Error;
var isUint8Array62 = (input) => input instanceof Uint8Array;
var isDate62 = (input) => input instanceof Date;
var isIterable62 = (input) => hasProperty62(input, Symbol.iterator);
var isRecord62 = (input) => isRecordOrArray62(input) && !Array.isArray(input);
var isReadonlyRecord62 = isRecord62;
var isPromise62 = (input) => hasProperty62(input, "then") && "catch" in input && isFunction332(input.then) && isFunction332(input.catch);
var isPromiseLike62 = (input) => hasProperty62(input, "then") && isFunction332(input.then);
var compose242 = /* @__PURE__ */ dual62(2, (ab, bc) => (a232) => ab(a232) && bc(a232));
var product92 = (self2, that) => ([a232, b232]) => self2(a232) && that(b232);
var all92 = (collection) => {
  return (as2322) => {
    let collectionIndex = 0;
    for (const p232 of collection) {
      if (collectionIndex >= as2322.length) {
        break;
      }
      if (p232(as2322[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany92 = (self2, collection) => {
  const rest = all92(collection);
  return ([head222, ...tail222]) => self2(head222) === false ? false : rest(tail222);
};
var tuple72 = (...elements) => all92(elements);
var struct82 = (fields) => {
  const keys2232 = Object.keys(fields);
  return (a232) => {
    for (const key of keys2232) {
      if (!fields[key](a232[key])) {
        return false;
      }
    }
    return true;
  };
};
var not62 = (self2) => (a232) => !self2(a232);
var or62 = /* @__PURE__ */ dual62(2, (self2, that) => (a232) => self2(a232) || that(a232));
var and62 = /* @__PURE__ */ dual62(2, (self2, that) => (a232) => self2(a232) && that(a232));
var xor62 = /* @__PURE__ */ dual62(2, (self2, that) => (a232) => self2(a232) !== that(a232));
var eqv62 = /* @__PURE__ */ dual62(2, (self2, that) => (a232) => self2(a232) === that(a232));
var implies62 = /* @__PURE__ */ dual62(2, (self2, that) => (a232) => self2(a232) ? that(a232) : true);
var nor62 = /* @__PURE__ */ dual62(2, (self2, that) => (a232) => !(self2(a232) || that(a232)));
var nand62 = /* @__PURE__ */ dual62(2, (self2, that) => (a232) => !(self2(a232) && that(a232)));
var every72 = (collection) => (a232) => {
  for (const p232 of collection) {
    if (!p232(a232)) {
      return false;
    }
  }
  return true;
};
var some132 = (collection) => (a232) => {
  for (const p232 of collection) {
    if (p232(a232)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage62 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId62 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind62 = (u232) => isObject62(u232) && GenKindTypeId62 in u232;
var GenKindImpl62 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity62;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId62] = GenKindTypeId62;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen72(this);
  }
};
var SingleShotGen72 = class _SingleShotGen82 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a232) {
    return this.called ? {
      value: a232,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a232) {
    return {
      value: a232,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e232) {
    throw e232;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen82(this.self);
  }
};
var adapter92 = () => function() {
  let x232 = arguments[0];
  for (let i232 = 1; i232 < arguments.length; i232++) {
    x232 = arguments[i232](x232);
  }
  return new GenKindImpl62(x232);
};
var defaultIncHi62 = 335903614;
var defaultIncLo62 = 4150755663;
var MUL_HI62 = 1481765933 >>> 0;
var MUL_LO62 = 1284865837 >>> 0;
var BIT_5362 = 9007199254740992;
var BIT_2762 = 134217728;
var PCGRandom62 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable62(seedLo) && isNullable62(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable62(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable62(incLo) && isNullable62(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo62;
      incHi = this._state ? this._state[2] : defaultIncHi62;
    } else if (isNullable62(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add6462(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max322) {
    if (!max322) {
      return this._next();
    }
    max322 = max322 >>> 0;
    if ((max322 & max322 - 1) === 0) {
      return this._next() & max322 - 1;
    }
    let num = 0;
    const skew = (-max322 >>> 0) % max322 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max322;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_2762 + lo) / BIT_5362;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul6462(this._state, oldHi, oldLo, MUL_HI62, MUL_LO62);
    add6462(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul6462(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add6462(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId62 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap62 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId62]() {
    return this.#value;
  }
};
function yieldWrapGet62(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId62 in self2) {
    return self2[YieldWrapTypeId62]();
  }
  throw new Error(getBugErrorMessage62("yieldWrapGet"));
}
var structuralRegionState62 = /* @__PURE__ */ globalValue62("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache62 = /* @__PURE__ */ globalValue62(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr62 = /* @__PURE__ */ globalValue62(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom62());
var symbol92 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash62 = (self2) => {
  if (structuralRegionState62.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number72(self2);
    case "bigint":
      return string72(self2.toString(10));
    case "boolean":
      return string72(String(self2));
    case "symbol":
      return string72(String(self2));
    case "string":
      return string72(self2);
    case "undefined":
      return string72("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string72("null");
      } else if (self2 instanceof Date) {
        return hash62(self2.toISOString());
      } else if (isHash62(self2)) {
        return self2[symbol92]();
      } else {
        return random62(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random62 = (self2) => {
  if (!randomHashCache62.has(self2)) {
    randomHashCache62.set(self2, number72(pcgr62.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache62.get(self2);
};
var combine72 = (b232) => (self2) => self2 * 53 ^ b232;
var optimize62 = (n232) => n232 & 3221225471 | n232 >>> 1 & 1073741824;
var isHash62 = (u232) => hasProperty62(u232, symbol92);
var number72 = (n232) => {
  if (n232 !== n232 || n232 === Infinity) {
    return 0;
  }
  let h232 = n232 | 0;
  if (h232 !== n232) {
    h232 ^= n232 * 4294967295;
  }
  while (n232 > 4294967295) {
    h232 ^= n232 /= 4294967295;
  }
  return optimize62(n232);
};
var string72 = (str) => {
  let h232 = 5381, i232 = str.length;
  while (i232) {
    h232 = h232 * 33 ^ str.charCodeAt(--i232);
  }
  return optimize62(h232);
};
var structureKeys32 = (o232, keys2232) => {
  let h232 = 12289;
  for (let i232 = 0; i232 < keys2232.length; i232++) {
    h232 ^= pipe62(string72(keys2232[i232]), combine72(hash62(o232[keys2232[i232]])));
  }
  return optimize62(h232);
};
var structure32 = (o232) => structureKeys32(o232, Object.keys(o232));
var array82 = (arr) => {
  let h232 = 6151;
  for (let i232 = 0; i232 < arr.length; i232++) {
    h232 = pipe62(h232, combine72(hash62(arr[i232])));
  }
  return optimize62(h232);
};
var cached62 = function() {
  if (arguments.length === 1) {
    const self22 = arguments[0];
    return function(hash3222) {
      Object.defineProperty(self22, symbol92, {
        value() {
          return hash3222;
        },
        enumerable: false
      });
      return hash3222;
    };
  }
  const self2 = arguments[0];
  const hash2322 = arguments[1];
  Object.defineProperty(self2, symbol92, {
    value() {
      return hash2322;
    },
    enumerable: false
  });
  return hash2322;
};
var symbol242 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals62() {
  if (arguments.length === 1) {
    return (self2) => compareBoth62(self2, arguments[0]);
  }
  return compareBoth62(arguments[0], arguments[1]);
}
function compareBoth62(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual62(self2) && isEqual62(that)) {
        if (hash62(self2) === hash62(that) && self2[symbol242](that)) {
          return true;
        } else {
          return structuralRegionState62.enabled && structuralRegionState62.tester ? structuralRegionState62.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState62.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v232, i232) => compareBoth62(v232, that[i232]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth62(self2[key], that[key]))) {
              return structuralRegionState62.tester ? structuralRegionState62.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState62.tester ? structuralRegionState62.tester(self2, that) : false;
    }
  }
  return structuralRegionState62.enabled && structuralRegionState62.tester ? structuralRegionState62.tester(self2, that) : false;
}
var isEqual62 = (u232) => hasProperty62(u232, symbol242);
var equivalence62 = () => equals62;
var NodeInspectSymbol62 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON62 = (x232) => {
  if (hasProperty62(x232, "toJSON") && isFunction332(x232["toJSON"]) && x232["toJSON"].length === 0) {
    return x232.toJSON();
  } else if (Array.isArray(x232)) {
    return x232.map(toJSON62);
  }
  return x232;
};
var format62 = (x232) => JSON.stringify(x232, null, 2);
var pipeArguments62 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i232 = 0, len = args.length; i232 < len; i232++) {
        ret = args[i232](ret);
      }
      return ret;
    }
  }
};
var OP_COMMIT32 = "Commit";
var OP_FAILURE42 = "Failure";
var OP_WITH_RUNTIME42 = "WithRuntime";
var EffectTypeId72 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId62 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId62 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId62 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance62 = {
  /* c8 ignore next */
  _R: (_232) => _232,
  /* c8 ignore next */
  _E: (_232) => _232,
  /* c8 ignore next */
  _A: (_232) => _232,
  _V: /* @__PURE__ */ getCurrentVersion62()
};
var sinkVariance62 = {
  /* c8 ignore next */
  _A: (_232) => _232,
  /* c8 ignore next */
  _In: (_232) => _232,
  /* c8 ignore next */
  _L: (_232) => _232,
  /* c8 ignore next */
  _E: (_232) => _232,
  /* c8 ignore next */
  _R: (_232) => _232
};
var channelVariance62 = {
  /* c8 ignore next */
  _Env: (_232) => _232,
  /* c8 ignore next */
  _InErr: (_232) => _232,
  /* c8 ignore next */
  _InElem: (_232) => _232,
  /* c8 ignore next */
  _InDone: (_232) => _232,
  /* c8 ignore next */
  _OutErr: (_232) => _232,
  /* c8 ignore next */
  _OutElem: (_232) => _232,
  /* c8 ignore next */
  _OutDone: (_232) => _232
};
var EffectPrototype62 = {
  [EffectTypeId72]: effectVariance62,
  [StreamTypeId62]: effectVariance62,
  [SinkTypeId62]: sinkVariance62,
  [ChannelTypeId62]: channelVariance62,
  [symbol242](that) {
    return this === that;
  },
  [symbol92]() {
    return cached62(this, random62(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen72(new YieldWrap62(this));
  },
  pipe() {
    return pipeArguments62(this, arguments);
  }
};
var StructuralPrototype32 = {
  [symbol92]() {
    return cached62(this, structure32(this));
  },
  [symbol242](that) {
    const selfKeys = Object.keys(this);
    const thatKeys = Object.keys(that);
    if (selfKeys.length !== thatKeys.length) {
      return false;
    }
    for (const key of selfKeys) {
      if (!(key in that && equals62(this[key], that[key]))) {
        return false;
      }
    }
    return true;
  }
};
var CommitPrototype32 = {
  ...EffectPrototype62,
  _op: OP_COMMIT32
};
var StructuralCommitPrototype32 = {
  ...CommitPrototype32,
  ...StructuralPrototype32
};
var TypeId162 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto92 = {
  ...EffectPrototype62,
  [TypeId162]: {
    _A: (_232) => _232
  },
  [NodeInspectSymbol62]() {
    return this.toJSON();
  },
  toString() {
    return format62(this.toJSON());
  }
};
var SomeProto62 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto92), {
  _tag: "Some",
  _op: "Some",
  [symbol242](that) {
    return isOption92(that) && isSome92(that) && equals62(this.value, that.value);
  },
  [symbol92]() {
    return cached62(this, combine72(hash62(this._tag))(hash62(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON62(this.value)
    };
  }
});
var NoneHash62 = /* @__PURE__ */ hash62("None");
var NoneProto62 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto92), {
  _tag: "None",
  _op: "None",
  [symbol242](that) {
    return isOption92(that) && isNone92(that);
  },
  [symbol92]() {
    return NoneHash62;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption92 = (input) => hasProperty62(input, TypeId162);
var isNone92 = (fa) => fa._tag === "None";
var isSome92 = (fa) => fa._tag === "Some";
var none92 = /* @__PURE__ */ Object.create(NoneProto62);
var some242 = (value) => {
  const a232 = Object.create(SomeProto62);
  a232.value = value;
  return a232;
};
var TypeId242 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto242 = {
  ...EffectPrototype62,
  [TypeId242]: {
    _R: (_232) => _232
  },
  [NodeInspectSymbol62]() {
    return this.toJSON();
  },
  toString() {
    return format62(this.toJSON());
  }
};
var RightProto62 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto242), {
  _tag: "Right",
  _op: "Right",
  [symbol242](that) {
    return isEither62(that) && isRight72(that) && equals62(this.right, that.right);
  },
  [symbol92]() {
    return combine72(hash62(this._tag))(hash62(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON62(this.right)
    };
  }
});
var LeftProto62 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto242), {
  _tag: "Left",
  _op: "Left",
  [symbol242](that) {
    return isEither62(that) && isLeft72(that) && equals62(this.left, that.left);
  },
  [symbol92]() {
    return combine72(hash62(this._tag))(hash62(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON62(this.left)
    };
  }
});
var isEither62 = (input) => hasProperty62(input, TypeId242);
var isLeft72 = (ma) => ma._tag === "Left";
var isRight72 = (ma) => ma._tag === "Right";
var left72 = (left3232) => {
  const a232 = Object.create(LeftProto62);
  a232.left = left3232;
  return a232;
};
var right72 = (right3232) => {
  const a232 = Object.create(RightProto62);
  a232.right = right3232;
  return a232;
};
var getLeft92 = (self2) => isRight72(self2) ? none92 : some242(self2.left);
var getRight92 = (self2) => isLeft72(self2) ? none92 : some242(self2.right);
var right242 = right72;
var left242 = left72;
var Option_exports62 = {};
__export242(Option_exports62, {
  Do: () => Do72,
  TypeId: () => TypeId342,
  all: () => all242,
  andThen: () => andThen62,
  ap: () => ap62,
  as: () => as62,
  asVoid: () => asVoid62,
  bind: () => bind242,
  bindTo: () => bindTo242,
  composeK: () => composeK62,
  contains: () => contains72,
  containsWith: () => containsWith72,
  exists: () => exists62,
  filter: () => filter72,
  filterMap: () => filterMap72,
  firstSomeOf: () => firstSomeOf62,
  flatMap: () => flatMap72,
  flatMapNullable: () => flatMapNullable72,
  flatten: () => flatten72,
  fromIterable: () => fromIterable92,
  fromNullable: () => fromNullable72,
  gen: () => gen62,
  getEquivalence: () => getEquivalence82,
  getLeft: () => getLeft242,
  getOrElse: () => getOrElse62,
  getOrNull: () => getOrNull62,
  getOrThrow: () => getOrThrow62,
  getOrThrowWith: () => getOrThrowWith62,
  getOrUndefined: () => getOrUndefined62,
  getOrder: () => getOrder72,
  getRight: () => getRight242,
  isNone: () => isNone242,
  isOption: () => isOption242,
  isSome: () => isSome242,
  let: () => let_242,
  lift2: () => lift262,
  liftNullable: () => liftNullable72,
  liftPredicate: () => liftPredicate72,
  liftThrowable: () => liftThrowable62,
  map: () => map72,
  match: () => match242,
  none: () => none242,
  orElse: () => orElse62,
  orElseEither: () => orElseEither62,
  orElseSome: () => orElseSome62,
  partitionMap: () => partitionMap72,
  product: () => product242,
  productMany: () => productMany242,
  reduceCompact: () => reduceCompact62,
  some: () => some342,
  tap: () => tap62,
  toArray: () => toArray62,
  toRefinement: () => toRefinement62,
  void: () => void_62,
  zipLeft: () => zipLeft62,
  zipRight: () => zipRight62,
  zipWith: () => zipWith72
});
var make242 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId342 = /* @__PURE__ */ Symbol.for("effect/Option");
var none242 = () => none92;
var some342 = some242;
var isOption242 = isOption92;
var isNone242 = isNone92;
var isSome242 = isSome92;
var match242 = /* @__PURE__ */ dual62(2, (self2, {
  onNone,
  onSome
}) => isNone242(self2) ? onNone() : onSome(self2.value));
var toRefinement62 = (f232) => (a232) => isSome242(f232(a232));
var fromIterable92 = (collection) => {
  for (const a232 of collection) {
    return some342(a232);
  }
  return none242();
};
var getRight242 = getRight92;
var getLeft242 = getLeft92;
var getOrElse62 = /* @__PURE__ */ dual62(2, (self2, onNone) => isNone242(self2) ? onNone() : self2.value);
var orElse62 = /* @__PURE__ */ dual62(2, (self2, that) => isNone242(self2) ? that() : self2);
var orElseSome62 = /* @__PURE__ */ dual62(2, (self2, onNone) => isNone242(self2) ? some342(onNone()) : self2);
var orElseEither62 = /* @__PURE__ */ dual62(2, (self2, that) => isNone242(self2) ? map72(that(), right72) : map72(self2, left72));
var firstSomeOf62 = (collection) => {
  let out = none242();
  for (out of collection) {
    if (isSome242(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable72 = (nullableValue) => nullableValue == null ? none242() : some342(nullableValue);
var liftNullable72 = (f232) => (...a232) => fromNullable72(f232(...a232));
var getOrNull62 = /* @__PURE__ */ getOrElse62(constNull62);
var getOrUndefined62 = /* @__PURE__ */ getOrElse62(constUndefined62);
var liftThrowable62 = (f232) => (...a232) => {
  try {
    return some342(f232(...a232));
  } catch (e232) {
    return none242();
  }
};
var getOrThrowWith62 = /* @__PURE__ */ dual62(2, (self2, onNone) => {
  if (isSome242(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow62 = /* @__PURE__ */ getOrThrowWith62(() => new Error("getOrThrow called on a None"));
var map72 = /* @__PURE__ */ dual62(2, (self2, f232) => isNone242(self2) ? none242() : some342(f232(self2.value)));
var as62 = /* @__PURE__ */ dual62(2, (self2, b232) => map72(self2, () => b232));
var asVoid62 = /* @__PURE__ */ as62(void 0);
var void_62 = /* @__PURE__ */ some342(void 0);
var flatMap72 = /* @__PURE__ */ dual62(2, (self2, f232) => isNone242(self2) ? none242() : f232(self2.value));
var andThen62 = /* @__PURE__ */ dual62(2, (self2, f232) => flatMap72(self2, (a232) => {
  const b232 = isFunction242(f232) ? f232(a232) : f232;
  return isOption242(b232) ? b232 : some342(b232);
}));
var flatMapNullable72 = /* @__PURE__ */ dual62(2, (self2, f232) => isNone242(self2) ? none242() : fromNullable72(f232(self2.value)));
var flatten72 = /* @__PURE__ */ flatMap72(identity62);
var zipRight62 = /* @__PURE__ */ dual62(2, (self2, that) => flatMap72(self2, () => that));
var composeK62 = /* @__PURE__ */ dual62(2, (afb, bfc) => (a232) => flatMap72(afb(a232), bfc));
var zipLeft62 = /* @__PURE__ */ dual62(2, (self2, that) => tap62(self2, () => that));
var tap62 = /* @__PURE__ */ dual62(2, (self2, f232) => flatMap72(self2, (a232) => map72(f232(a232), () => a232)));
var product242 = (self2, that) => isSome242(self2) && isSome242(that) ? some342([self2.value, that.value]) : none242();
var productMany242 = (self2, collection) => {
  if (isNone242(self2)) {
    return none242();
  }
  const out = [self2.value];
  for (const o232 of collection) {
    if (isNone242(o232)) {
      return none242();
    }
    out.push(o232.value);
  }
  return some342(out);
};
var all242 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o232 of input) {
      if (isNone242(o232)) {
        return none242();
      }
      out2.push(o232.value);
    }
    return some342(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o232 = input[key];
    if (isNone242(o232)) {
      return none242();
    }
    out[key] = o232.value;
  }
  return some342(out);
};
var zipWith72 = /* @__PURE__ */ dual62(3, (self2, that, f232) => map72(product242(self2, that), ([a232, b232]) => f232(a232, b232)));
var ap62 = /* @__PURE__ */ dual62(2, (self2, that) => zipWith72(self2, that, (f232, a232) => f232(a232)));
var reduceCompact62 = /* @__PURE__ */ dual62(3, (self2, b232, f232) => {
  let out = b232;
  for (const oa of self2) {
    if (isSome242(oa)) {
      out = f232(out, oa.value);
    }
  }
  return out;
});
var toArray62 = (self2) => isNone242(self2) ? [] : [self2.value];
var partitionMap72 = /* @__PURE__ */ dual62(2, (self2, f232) => {
  if (isNone242(self2)) {
    return [none242(), none242()];
  }
  const e232 = f232(self2.value);
  return isLeft72(e232) ? [some342(e232.left), none242()] : [none242(), some342(e232.right)];
});
var filterMap72 = /* @__PURE__ */ dual62(2, (self2, f232) => isNone242(self2) ? none242() : f232(self2.value));
var filter72 = /* @__PURE__ */ dual62(2, (self2, predicate) => filterMap72(self2, (b232) => predicate(b232) ? some242(b232) : none92));
var getEquivalence82 = (isEquivalent) => make172((x232, y232) => x232 === y232 || (isNone242(x232) ? isNone242(y232) : isNone242(y232) ? false : isEquivalent(x232.value, y232.value)));
var getOrder72 = (O232) => make242((self2, that) => isSome242(self2) ? isSome242(that) ? O232(self2.value, that.value) : 1 : -1);
var lift262 = (f232) => dual62(2, (self2, that) => zipWith72(self2, that, f232));
var liftPredicate72 = (predicate) => (b232) => predicate(b232) ? some342(b232) : none242();
var containsWith72 = (isEquivalent) => dual62(2, (self2, a232) => isNone242(self2) ? false : isEquivalent(self2.value, a232));
var _equivalence82 = /* @__PURE__ */ equivalence62();
var contains72 = /* @__PURE__ */ containsWith72(_equivalence82);
var exists62 = /* @__PURE__ */ dual62(2, (self2, refinement) => isNone242(self2) ? false : refinement(self2.value));
var bindTo242 = /* @__PURE__ */ bindTo102(map72);
var let_242 = /* @__PURE__ */ let_102(map72);
var bind242 = /* @__PURE__ */ bind102(map72, flatMap72);
var Do72 = /* @__PURE__ */ some342({});
var adapter242 = /* @__PURE__ */ adapter92();
var gen62 = (f232) => {
  const iterator = f232(adapter242);
  let state = iterator.next();
  if (state.done) {
    return some342(state.value);
  } else {
    let current = state.value;
    if (isGenKind62(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet62(current);
    }
    if (isNone242(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind62(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet62(current);
        }
        if (isNone242(current)) {
          return current;
        }
      }
    }
    return some342(state.value);
  }
};
var fromIterable242 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var reverse62 = (self2) => Array.from(self2).reverse();
var reduce72 = /* @__PURE__ */ dual62(3, (self2, b232, f232) => fromIterable242(self2).reduce((b2222, a232, i232) => f232(b2222, a232, i232), b232));
var TagTypeId42 = /* @__PURE__ */ Symbol.for("effect/Context/Tag");
var STMSymbolKey42 = "effect/STM";
var STMTypeId42 = /* @__PURE__ */ Symbol.for(STMSymbolKey42);
var TagProto42 = {
  ...EffectPrototype62,
  _tag: "Tag",
  _op: "Tag",
  [STMTypeId42]: effectVariance62,
  [TagTypeId42]: {
    _Service: (_232) => _232,
    _Identifier: (_232) => _232
  },
  toString() {
    return format62(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Tag",
      key: this.key,
      stack: this.stack
    };
  },
  [NodeInspectSymbol62]() {
    return this.toJSON();
  },
  of(self2) {
    return self2;
  },
  context(self2) {
    return make342(this, self2);
  }
};
var makeGenericTag42 = (key) => {
  const limit = Error.stackTraceLimit;
  Error.stackTraceLimit = 2;
  const creationError = new Error();
  Error.stackTraceLimit = limit;
  const tag = Object.create(TagProto42);
  Object.defineProperty(tag, "stack", {
    get() {
      return creationError.stack;
    }
  });
  tag.key = key;
  return tag;
};
var TypeId442 = /* @__PURE__ */ Symbol.for("effect/Context");
var ContextProto42 = {
  [TypeId442]: {
    _Services: (_232) => _232
  },
  [symbol242](that) {
    if (isContext42(that)) {
      if (this.unsafeMap.size === that.unsafeMap.size) {
        for (const k232 of this.unsafeMap.keys()) {
          if (!that.unsafeMap.has(k232) || !equals62(this.unsafeMap.get(k232), that.unsafeMap.get(k232))) {
            return false;
          }
        }
        return true;
      }
    }
    return false;
  },
  [symbol92]() {
    return cached62(this, number72(this.unsafeMap.size));
  },
  pipe() {
    return pipeArguments62(this, arguments);
  },
  toString() {
    return format62(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Context",
      services: Array.from(this.unsafeMap).map(toJSON62)
    };
  },
  [NodeInspectSymbol62]() {
    return this.toJSON();
  }
};
var makeContext42 = (unsafeMap) => {
  const context = Object.create(ContextProto42);
  context.unsafeMap = unsafeMap;
  return context;
};
var isContext42 = (u232) => hasProperty62(u232, TypeId442);
var _empty82 = /* @__PURE__ */ makeContext42(/* @__PURE__ */ new Map());
var empty132 = () => _empty82;
var make342 = (tag, service) => makeContext42(/* @__PURE__ */ new Map([[tag.key, service]]));
var GenericTag42 = makeGenericTag42;
var empty242 = empty132;
var TypeId542 = /* @__PURE__ */ Symbol.for("effect/Chunk");
function copy52(src, srcPos, dest, destPos, len) {
  for (let i232 = srcPos; i232 < Math.min(src.length, srcPos + len); i232++) {
    dest[destPos + i232 - srcPos] = src[i232];
  }
  return dest;
}
var emptyArray42 = [];
var getEquivalence242 = (isEquivalent) => make172((self2, that) => self2.length === that.length && toReadonlyArray42(self2).every((value, i232) => isEquivalent(value, unsafeGet242(that, i232))));
var _equivalence242 = /* @__PURE__ */ getEquivalence242(equals62);
var ChunkProto42 = {
  [TypeId542]: {
    _A: (_232) => _232
  },
  toString() {
    return format62(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Chunk",
      values: toReadonlyArray42(this).map(toJSON62)
    };
  },
  [NodeInspectSymbol62]() {
    return this.toJSON();
  },
  [symbol242](that) {
    return isChunk42(that) && _equivalence242(this, that);
  },
  [symbol92]() {
    return cached62(this, array82(toReadonlyArray42(this)));
  },
  [Symbol.iterator]() {
    switch (this.backing._tag) {
      case "IArray": {
        return this.backing.array[Symbol.iterator]();
      }
      case "IEmpty": {
        return emptyArray42[Symbol.iterator]();
      }
      default: {
        return toReadonlyArray42(this)[Symbol.iterator]();
      }
    }
  },
  pipe() {
    return pipeArguments62(this, arguments);
  }
};
var makeChunk42 = (backing) => {
  const chunk = Object.create(ChunkProto42);
  chunk.backing = backing;
  switch (backing._tag) {
    case "IEmpty": {
      chunk.length = 0;
      chunk.depth = 0;
      chunk.left = chunk;
      chunk.right = chunk;
      break;
    }
    case "IConcat": {
      chunk.length = backing.left.length + backing.right.length;
      chunk.depth = 1 + Math.max(backing.left.depth, backing.right.depth);
      chunk.left = backing.left;
      chunk.right = backing.right;
      break;
    }
    case "IArray": {
      chunk.length = backing.array.length;
      chunk.depth = 0;
      chunk.left = _empty242;
      chunk.right = _empty242;
      break;
    }
    case "ISingleton": {
      chunk.length = 1;
      chunk.depth = 0;
      chunk.left = _empty242;
      chunk.right = _empty242;
      break;
    }
    case "ISlice": {
      chunk.length = backing.length;
      chunk.depth = backing.chunk.depth + 1;
      chunk.left = _empty242;
      chunk.right = _empty242;
      break;
    }
  }
  return chunk;
};
var isChunk42 = (u232) => hasProperty62(u232, TypeId542);
var _empty242 = /* @__PURE__ */ makeChunk42({
  _tag: "IEmpty"
});
var empty342 = () => _empty242;
var make442 = (...as2322) => as2322.length === 1 ? of52(as2322[0]) : unsafeFromNonEmptyArray42(as2322);
var of52 = (a232) => makeChunk42({
  _tag: "ISingleton",
  a: a232
});
var copyToArray42 = (self2, array3232, initial) => {
  switch (self2.backing._tag) {
    case "IArray": {
      copy52(self2.backing.array, 0, array3232, initial, self2.length);
      break;
    }
    case "IConcat": {
      copyToArray42(self2.left, array3232, initial);
      copyToArray42(self2.right, array3232, initial + self2.left.length);
      break;
    }
    case "ISingleton": {
      array3232[initial] = self2.backing.a;
      break;
    }
    case "ISlice": {
      let i232 = 0;
      let j232 = initial;
      while (i232 < self2.length) {
        array3232[j232] = unsafeGet242(self2, i232);
        i232 += 1;
        j232 += 1;
      }
      break;
    }
  }
};
var toReadonlyArray42 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      return emptyArray42;
    }
    case "IArray": {
      return self2.backing.array;
    }
    default: {
      const arr = new Array(self2.length);
      copyToArray42(self2, arr, 0);
      self2.backing = {
        _tag: "IArray",
        array: arr
      };
      self2.left = _empty242;
      self2.right = _empty242;
      self2.depth = 0;
      return arr;
    }
  }
};
var reverse242 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty":
    case "ISingleton":
      return self2;
    case "IArray": {
      return makeChunk42({
        _tag: "IArray",
        array: reverse62(self2.backing.array)
      });
    }
    case "IConcat": {
      return makeChunk42({
        _tag: "IConcat",
        left: reverse242(self2.backing.right),
        right: reverse242(self2.backing.left)
      });
    }
    case "ISlice":
      return unsafeFromArray42(reverse62(toReadonlyArray42(self2)));
  }
};
var unsafeFromArray42 = (self2) => makeChunk42({
  _tag: "IArray",
  array: self2
});
var unsafeFromNonEmptyArray42 = (self2) => unsafeFromArray42(self2);
var unsafeGet242 = /* @__PURE__ */ dual62(2, (self2, index) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      throw new Error(`Index out of bounds`);
    }
    case "ISingleton": {
      if (index !== 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.a;
    }
    case "IArray": {
      if (index >= self2.length || index < 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.array[index];
    }
    case "IConcat": {
      return index < self2.left.length ? unsafeGet242(self2.left, index) : unsafeGet242(self2.right, index - self2.left.length);
    }
    case "ISlice": {
      return unsafeGet242(self2.backing.chunk, index + self2.backing.offset);
    }
  }
});
var prepend62 = /* @__PURE__ */ dual62(2, (self2, elem) => appendAll52(of52(elem), self2));
var drop52 = /* @__PURE__ */ dual62(2, (self2, n232) => {
  if (n232 <= 0) {
    return self2;
  } else if (n232 >= self2.length) {
    return _empty242;
  } else {
    switch (self2.backing._tag) {
      case "ISlice": {
        return makeChunk42({
          _tag: "ISlice",
          chunk: self2.backing.chunk,
          offset: self2.backing.offset + n232,
          length: self2.backing.length - n232
        });
      }
      case "IConcat": {
        if (n232 > self2.left.length) {
          return drop52(self2.right, n232 - self2.left.length);
        }
        return makeChunk42({
          _tag: "IConcat",
          left: drop52(self2.left, n232),
          right: self2.right
        });
      }
      default: {
        return makeChunk42({
          _tag: "ISlice",
          chunk: self2,
          offset: n232,
          length: self2.length - n232
        });
      }
    }
  }
});
var appendAll52 = /* @__PURE__ */ dual62(2, (self2, that) => {
  if (self2.backing._tag === "IEmpty") {
    return that;
  }
  if (that.backing._tag === "IEmpty") {
    return self2;
  }
  const diff2232 = that.depth - self2.depth;
  if (Math.abs(diff2232) <= 1) {
    return makeChunk42({
      _tag: "IConcat",
      left: self2,
      right: that
    });
  } else if (diff2232 < -1) {
    if (self2.left.depth >= self2.right.depth) {
      const nr = appendAll52(self2.right, that);
      return makeChunk42({
        _tag: "IConcat",
        left: self2.left,
        right: nr
      });
    } else {
      const nrr = appendAll52(self2.right.right, that);
      if (nrr.depth === self2.depth - 3) {
        const nr = makeChunk42({
          _tag: "IConcat",
          left: self2.right.left,
          right: nrr
        });
        return makeChunk42({
          _tag: "IConcat",
          left: self2.left,
          right: nr
        });
      } else {
        const nl = makeChunk42({
          _tag: "IConcat",
          left: self2.left,
          right: self2.right.left
        });
        return makeChunk42({
          _tag: "IConcat",
          left: nl,
          right: nrr
        });
      }
    }
  } else {
    if (that.right.depth >= that.left.depth) {
      const nl = appendAll52(self2, that.left);
      return makeChunk42({
        _tag: "IConcat",
        left: nl,
        right: that.right
      });
    } else {
      const nll = appendAll52(self2, that.left.left);
      if (nll.depth === that.depth - 3) {
        const nl = makeChunk42({
          _tag: "IConcat",
          left: nll,
          right: that.left.right
        });
        return makeChunk42({
          _tag: "IConcat",
          left: nl,
          right: that.right
        });
      } else {
        const nr = makeChunk42({
          _tag: "IConcat",
          left: that.left.right,
          right: that.right
        });
        return makeChunk42({
          _tag: "IConcat",
          left: nll,
          right: nr
        });
      }
    }
  }
});
var isEmpty52 = (self2) => self2.length === 0;
var isNonEmpty42 = (self2) => self2.length > 0;
var unsafeHead42 = (self2) => unsafeGet242(self2, 0);
var headNonEmpty52 = unsafeHead42;
var tailNonEmpty52 = (self2) => drop52(self2, 1);
var SIZE42 = 5;
var BUCKET_SIZE42 = /* @__PURE__ */ Math.pow(2, SIZE42);
var MASK42 = BUCKET_SIZE42 - 1;
var MAX_INDEX_NODE42 = BUCKET_SIZE42 / 2;
var MIN_ARRAY_NODE42 = BUCKET_SIZE42 / 4;
function popcount42(x232) {
  x232 -= x232 >> 1 & 1431655765;
  x232 = (x232 & 858993459) + (x232 >> 2 & 858993459);
  x232 = x232 + (x232 >> 4) & 252645135;
  x232 += x232 >> 8;
  x232 += x232 >> 16;
  return x232 & 127;
}
function hashFragment42(shift22, h232) {
  return h232 >>> shift22 & MASK42;
}
function toBitmap42(x232) {
  return 1 << x232;
}
function fromBitmap42(bitmap, bit) {
  return popcount42(bitmap & bit - 1);
}
var make542 = (value, previous) => ({
  value,
  previous
});
function arrayUpdate42(mutate2232, at, v232, arr) {
  let out = arr;
  if (!mutate2232) {
    const len = arr.length;
    out = new Array(len);
    for (let i232 = 0; i232 < len; ++i232) out[i232] = arr[i232];
  }
  out[at] = v232;
  return out;
}
function arraySpliceOut42(mutate2232, at, arr) {
  const newLen = arr.length - 1;
  let i232 = 0;
  let g232 = 0;
  let out = arr;
  if (mutate2232) {
    i232 = g232 = at;
  } else {
    out = new Array(newLen);
    while (i232 < at) out[g232++] = arr[i232++];
  }
  ++i232;
  while (i232 <= newLen) out[g232++] = arr[i232++];
  if (mutate2232) {
    out.length = newLen;
  }
  return out;
}
function arraySpliceIn42(mutate2232, at, v232, arr) {
  const len = arr.length;
  if (mutate2232) {
    let i2222 = len;
    while (i2222 >= at) arr[i2222--] = arr[i2222];
    arr[at] = v232;
    return arr;
  }
  let i232 = 0, g232 = 0;
  const out = new Array(len + 1);
  while (i232 < at) out[g232++] = arr[i232++];
  out[at] = v232;
  while (i232 < len) out[++g232] = arr[i232++];
  return out;
}
var EmptyNode42 = class _EmptyNode42 {
  _tag = "EmptyNode";
  modify(edit, _shift, f232, hash2322, key, size4232) {
    const v232 = f232(none242());
    if (isNone242(v232)) return new _EmptyNode42();
    ++size4232.value;
    return new LeafNode42(edit, hash2322, key, v232);
  }
};
function isEmptyNode42(a232) {
  return isTagged62(a232, "EmptyNode");
}
function isLeafNode42(node) {
  return isEmptyNode42(node) || node._tag === "LeafNode" || node._tag === "CollisionNode";
}
function canEditNode42(node, edit) {
  return isEmptyNode42(node) ? false : edit === node.edit;
}
var LeafNode42 = class _LeafNode42 {
  edit;
  hash;
  key;
  value;
  _tag = "LeafNode";
  constructor(edit, hash2322, key, value) {
    this.edit = edit;
    this.hash = hash2322;
    this.key = key;
    this.value = value;
  }
  modify(edit, shift22, f232, hash2322, key, size4232) {
    if (equals62(key, this.key)) {
      const v2222 = f232(this.value);
      if (v2222 === this.value) return this;
      else if (isNone242(v2222)) {
        --size4232.value;
        return new EmptyNode42();
      }
      if (canEditNode42(this, edit)) {
        this.value = v2222;
        return this;
      }
      return new _LeafNode42(edit, hash2322, key, v2222);
    }
    const v232 = f232(none242());
    if (isNone242(v232)) return this;
    ++size4232.value;
    return mergeLeaves42(edit, shift22, this.hash, this, hash2322, new _LeafNode42(edit, hash2322, key, v232));
  }
};
var CollisionNode42 = class _CollisionNode42 {
  edit;
  hash;
  children;
  _tag = "CollisionNode";
  constructor(edit, hash2322, children) {
    this.edit = edit;
    this.hash = hash2322;
    this.children = children;
  }
  modify(edit, shift22, f232, hash2322, key, size4232) {
    if (hash2322 === this.hash) {
      const canEdit = canEditNode42(this, edit);
      const list = this.updateCollisionList(canEdit, edit, this.hash, this.children, f232, key, size4232);
      if (list === this.children) return this;
      return list.length > 1 ? new _CollisionNode42(edit, this.hash, list) : list[0];
    }
    const v232 = f232(none242());
    if (isNone242(v232)) return this;
    ++size4232.value;
    return mergeLeaves42(edit, shift22, this.hash, this, hash2322, new LeafNode42(edit, hash2322, key, v232));
  }
  updateCollisionList(mutate2232, edit, hash2322, list, f232, key, size4232) {
    const len = list.length;
    for (let i232 = 0; i232 < len; ++i232) {
      const child = list[i232];
      if ("key" in child && equals62(key, child.key)) {
        const value = child.value;
        const newValue2 = f232(value);
        if (newValue2 === value) return list;
        if (isNone242(newValue2)) {
          --size4232.value;
          return arraySpliceOut42(mutate2232, i232, list);
        }
        return arrayUpdate42(mutate2232, i232, new LeafNode42(edit, hash2322, key, newValue2), list);
      }
    }
    const newValue = f232(none242());
    if (isNone242(newValue)) return list;
    ++size4232.value;
    return arrayUpdate42(mutate2232, len, new LeafNode42(edit, hash2322, key, newValue), list);
  }
};
var IndexedNode42 = class _IndexedNode42 {
  edit;
  mask;
  children;
  _tag = "IndexedNode";
  constructor(edit, mask, children) {
    this.edit = edit;
    this.mask = mask;
    this.children = children;
  }
  modify(edit, shift22, f232, hash2322, key, size4232) {
    const mask = this.mask;
    const children = this.children;
    const frag = hashFragment42(shift22, hash2322);
    const bit = toBitmap42(frag);
    const indx = fromBitmap42(mask, bit);
    const exists2322 = mask & bit;
    const canEdit = canEditNode42(this, edit);
    if (!exists2322) {
      const _newChild = new EmptyNode42().modify(edit, shift22 + SIZE42, f232, hash2322, key, size4232);
      if (!_newChild) return this;
      return children.length >= MAX_INDEX_NODE42 ? expand42(edit, frag, _newChild, mask, children) : new _IndexedNode42(edit, mask | bit, arraySpliceIn42(canEdit, indx, _newChild, children));
    }
    const current = children[indx];
    const child = current.modify(edit, shift22 + SIZE42, f232, hash2322, key, size4232);
    if (current === child) return this;
    let bitmap = mask;
    let newChildren;
    if (isEmptyNode42(child)) {
      bitmap &= ~bit;
      if (!bitmap) return new EmptyNode42();
      if (children.length <= 2 && isLeafNode42(children[indx ^ 1])) {
        return children[indx ^ 1];
      }
      newChildren = arraySpliceOut42(canEdit, indx, children);
    } else {
      newChildren = arrayUpdate42(canEdit, indx, child, children);
    }
    if (canEdit) {
      this.mask = bitmap;
      this.children = newChildren;
      return this;
    }
    return new _IndexedNode42(edit, bitmap, newChildren);
  }
};
var ArrayNode42 = class _ArrayNode42 {
  edit;
  size;
  children;
  _tag = "ArrayNode";
  constructor(edit, size4232, children) {
    this.edit = edit;
    this.size = size4232;
    this.children = children;
  }
  modify(edit, shift22, f232, hash2322, key, size4232) {
    let count = this.size;
    const children = this.children;
    const frag = hashFragment42(shift22, hash2322);
    const child = children[frag];
    const newChild = (child || new EmptyNode42()).modify(edit, shift22 + SIZE42, f232, hash2322, key, size4232);
    if (child === newChild) return this;
    const canEdit = canEditNode42(this, edit);
    let newChildren;
    if (isEmptyNode42(child) && !isEmptyNode42(newChild)) {
      ++count;
      newChildren = arrayUpdate42(canEdit, frag, newChild, children);
    } else if (!isEmptyNode42(child) && isEmptyNode42(newChild)) {
      --count;
      if (count <= MIN_ARRAY_NODE42) {
        return pack42(edit, count, frag, children);
      }
      newChildren = arrayUpdate42(canEdit, frag, new EmptyNode42(), children);
    } else {
      newChildren = arrayUpdate42(canEdit, frag, newChild, children);
    }
    if (canEdit) {
      this.size = count;
      this.children = newChildren;
      return this;
    }
    return new _ArrayNode42(edit, count, newChildren);
  }
};
function pack42(edit, count, removed, elements) {
  const children = new Array(count - 1);
  let g232 = 0;
  let bitmap = 0;
  for (let i232 = 0, len = elements.length; i232 < len; ++i232) {
    if (i232 !== removed) {
      const elem = elements[i232];
      if (elem && !isEmptyNode42(elem)) {
        children[g232++] = elem;
        bitmap |= 1 << i232;
      }
    }
  }
  return new IndexedNode42(edit, bitmap, children);
}
function expand42(edit, frag, child, bitmap, subNodes) {
  const arr = [];
  let bit = bitmap;
  let count = 0;
  for (let i232 = 0; bit; ++i232) {
    if (bit & 1) arr[i232] = subNodes[count++];
    bit >>>= 1;
  }
  arr[frag] = child;
  return new ArrayNode42(edit, count + 1, arr);
}
function mergeLeavesInner42(edit, shift22, h1, n1, h232, n232) {
  if (h1 === h232) return new CollisionNode42(edit, h1, [n232, n1]);
  const subH1 = hashFragment42(shift22, h1);
  const subH2 = hashFragment42(shift22, h232);
  if (subH1 === subH2) {
    return (child) => new IndexedNode42(edit, toBitmap42(subH1) | toBitmap42(subH2), [child]);
  } else {
    const children = subH1 < subH2 ? [n1, n232] : [n232, n1];
    return new IndexedNode42(edit, toBitmap42(subH1) | toBitmap42(subH2), children);
  }
}
function mergeLeaves42(edit, shift22, h1, n1, h232, n232) {
  let stack = void 0;
  let currentShift = shift22;
  while (true) {
    const res = mergeLeavesInner42(edit, currentShift, h1, n1, h232, n232);
    if (typeof res === "function") {
      stack = make542(res, stack);
      currentShift = currentShift + SIZE42;
    } else {
      let final = res;
      while (stack != null) {
        final = stack.value(final);
        stack = stack.previous;
      }
      return final;
    }
  }
}
var HashMapSymbolKey42 = "effect/HashMap";
var HashMapTypeId42 = /* @__PURE__ */ Symbol.for(HashMapSymbolKey42);
var HashMapProto42 = {
  [HashMapTypeId42]: HashMapTypeId42,
  [Symbol.iterator]() {
    return new HashMapIterator42(this, (k232, v232) => [k232, v232]);
  },
  [symbol92]() {
    let hash2322 = hash62(HashMapSymbolKey42);
    for (const item of this) {
      hash2322 ^= pipe62(hash62(item[0]), combine72(hash62(item[1])));
    }
    return cached62(this, hash2322);
  },
  [symbol242](that) {
    if (isHashMap42(that)) {
      if (that._size !== this._size) {
        return false;
      }
      for (const item of this) {
        const elem = pipe62(that, getHash42(item[0], hash62(item[0])));
        if (isNone242(elem)) {
          return false;
        } else {
          if (!equals62(item[1], elem.value)) {
            return false;
          }
        }
      }
      return true;
    }
    return false;
  },
  toString() {
    return format62(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashMap",
      values: Array.from(this).map(toJSON62)
    };
  },
  [NodeInspectSymbol62]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments62(this, arguments);
  }
};
var makeImpl52 = (editable, edit, root, size4232) => {
  const map622 = Object.create(HashMapProto42);
  map622._editable = editable;
  map622._edit = edit;
  map622._root = root;
  map622._size = size4232;
  return map622;
};
var HashMapIterator42 = class _HashMapIterator42 {
  map;
  f;
  v;
  constructor(map622, f232) {
    this.map = map622;
    this.f = f232;
    this.v = visitLazy42(this.map._root, this.f, void 0);
  }
  next() {
    if (isNone242(this.v)) {
      return {
        done: true,
        value: void 0
      };
    }
    const v0 = this.v.value;
    this.v = applyCont42(v0.cont);
    return {
      done: false,
      value: v0.value
    };
  }
  [Symbol.iterator]() {
    return new _HashMapIterator42(this.map, this.f);
  }
};
var applyCont42 = (cont) => cont ? visitLazyChildren42(cont[0], cont[1], cont[2], cont[3], cont[4]) : none242();
var visitLazy42 = (node, f232, cont = void 0) => {
  switch (node._tag) {
    case "LeafNode": {
      if (isSome242(node.value)) {
        return some342({
          value: f232(node.key, node.value.value),
          cont
        });
      }
      return applyCont42(cont);
    }
    case "CollisionNode":
    case "ArrayNode":
    case "IndexedNode": {
      const children = node.children;
      return visitLazyChildren42(children.length, children, 0, f232, cont);
    }
    default: {
      return applyCont42(cont);
    }
  }
};
var visitLazyChildren42 = (len, children, i232, f232, cont) => {
  while (i232 < len) {
    const child = children[i232++];
    if (child && !isEmptyNode42(child)) {
      return visitLazy42(child, f232, [len, children, i232, f232, cont]);
    }
  }
  return applyCont42(cont);
};
var _empty342 = /* @__PURE__ */ makeImpl52(false, 0, /* @__PURE__ */ new EmptyNode42(), 0);
var empty442 = () => _empty342;
var isHashMap42 = (u232) => hasProperty62(u232, HashMapTypeId42);
var getHash42 = /* @__PURE__ */ dual62(3, (self2, key, hash2322) => {
  let node = self2._root;
  let shift22 = 0;
  while (true) {
    switch (node._tag) {
      case "LeafNode": {
        return equals62(key, node.key) ? node.value : none242();
      }
      case "CollisionNode": {
        if (hash2322 === node.hash) {
          const children = node.children;
          for (let i232 = 0, len = children.length; i232 < len; ++i232) {
            const child = children[i232];
            if ("key" in child && equals62(key, child.key)) {
              return child.value;
            }
          }
        }
        return none242();
      }
      case "IndexedNode": {
        const frag = hashFragment42(shift22, hash2322);
        const bit = toBitmap42(frag);
        if (node.mask & bit) {
          node = node.children[fromBitmap42(node.mask, bit)];
          shift22 += SIZE42;
          break;
        }
        return none242();
      }
      case "ArrayNode": {
        node = node.children[hashFragment42(shift22, hash2322)];
        if (node) {
          shift22 += SIZE42;
          break;
        }
        return none242();
      }
      default:
        return none242();
    }
  }
});
var set52 = /* @__PURE__ */ dual62(3, (self2, key, value) => modifyAt42(self2, key, () => some342(value)));
var setTree42 = /* @__PURE__ */ dual62(3, (self2, newRoot, newSize) => {
  if (self2._editable) {
    self2._root = newRoot;
    self2._size = newSize;
    return self2;
  }
  return newRoot === self2._root ? self2 : makeImpl52(self2._editable, self2._edit, newRoot, newSize);
});
var keys52 = (self2) => new HashMapIterator42(self2, (key) => key);
var size62 = (self2) => self2._size;
var beginMutation52 = (self2) => makeImpl52(true, self2._edit + 1, self2._root, self2._size);
var modifyAt42 = /* @__PURE__ */ dual62(3, (self2, key, f232) => modifyHash42(self2, key, hash62(key), f232));
var modifyHash42 = /* @__PURE__ */ dual62(4, (self2, key, hash2322, f232) => {
  const size4232 = {
    value: self2._size
  };
  const newRoot = self2._root.modify(self2._editable ? self2._edit : NaN, 0, f232, hash2322, key, size4232);
  return pipe62(self2, setTree42(newRoot, size4232.value));
});
var forEach72 = /* @__PURE__ */ dual62(2, (self2, f232) => reduce242(self2, void 0, (_232, value, key) => f232(value, key)));
var reduce242 = /* @__PURE__ */ dual62(3, (self2, zero, f232) => {
  const root = self2._root;
  if (root._tag === "LeafNode") {
    return isSome242(root.value) ? f232(zero, root.value.value, root.key) : zero;
  }
  if (root._tag === "EmptyNode") {
    return zero;
  }
  const toVisit = [root.children];
  let children;
  while (children = toVisit.pop()) {
    for (let i232 = 0, len = children.length; i232 < len; ) {
      const child = children[i232++];
      if (child && !isEmptyNode42(child)) {
        if (child._tag === "LeafNode") {
          if (isSome242(child.value)) {
            zero = f232(zero, child.value.value, child.key);
          }
        } else {
          toVisit.push(child.children);
        }
      }
    }
  }
  return zero;
});
var HashSetSymbolKey42 = "effect/HashSet";
var HashSetTypeId42 = /* @__PURE__ */ Symbol.for(HashSetSymbolKey42);
var HashSetProto42 = {
  [HashSetTypeId42]: HashSetTypeId42,
  [Symbol.iterator]() {
    return keys52(this._keyMap);
  },
  [symbol92]() {
    return cached62(this, combine72(hash62(this._keyMap))(hash62(HashSetSymbolKey42)));
  },
  [symbol242](that) {
    if (isHashSet42(that)) {
      return size62(this._keyMap) === size62(that._keyMap) && equals62(this._keyMap, that._keyMap);
    }
    return false;
  },
  toString() {
    return format62(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashSet",
      values: Array.from(this).map(toJSON62)
    };
  },
  [NodeInspectSymbol62]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments62(this, arguments);
  }
};
var makeImpl242 = (keyMap) => {
  const set2322 = Object.create(HashSetProto42);
  set2322._keyMap = keyMap;
  return set2322;
};
var isHashSet42 = (u232) => hasProperty62(u232, HashSetTypeId42);
var _empty442 = /* @__PURE__ */ makeImpl242(/* @__PURE__ */ empty442());
var empty542 = () => _empty442;
var size242 = (self2) => size62(self2._keyMap);
var beginMutation242 = (self2) => makeImpl242(beginMutation52(self2._keyMap));
var endMutation42 = (self2) => {
  self2._keyMap._editable = false;
  return self2;
};
var mutate42 = /* @__PURE__ */ dual62(2, (self2, f232) => {
  const transient = beginMutation242(self2);
  f232(transient);
  return endMutation42(transient);
});
var add242 = /* @__PURE__ */ dual62(2, (self2, value) => self2._keyMap._editable ? (set52(value, true)(self2._keyMap), self2) : makeImpl242(set52(value, true)(self2._keyMap)));
var union242 = /* @__PURE__ */ dual62(2, (self2, that) => mutate42(empty542(), (set2322) => {
  forEach242(self2, (value) => add242(set2322, value));
  for (const value of that) {
    add242(set2322, value);
  }
}));
var forEach242 = /* @__PURE__ */ dual62(2, (self2, f232) => forEach72(self2._keyMap, (_232, k232) => f232(k232)));
var empty642 = empty542;
var size342 = size242;
var add342 = add242;
var union342 = union242;
var ArrayProto42 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(Array.prototype), {
  [symbol92]() {
    return cached62(this, array82(this));
  },
  [symbol242](that) {
    if (Array.isArray(that) && this.length === that.length) {
      return this.every((v232, i232) => equals62(v232, that[i232]));
    } else {
      return false;
    }
  }
});
var Structural52 = /* @__PURE__ */ function() {
  function Structural3232(args) {
    if (args) {
      Object.assign(this, args);
    }
  }
  Structural3232.prototype = StructuralPrototype32;
  return Structural3232;
}();
var struct242 = (as2322) => Object.assign(Object.create(StructuralPrototype32), as2322);
var ContextPatchTypeId42 = /* @__PURE__ */ Symbol.for("effect/DifferContextPatch");
function variance52(a232) {
  return a232;
}
var PatchProto42 = {
  ...Structural52.prototype,
  [ContextPatchTypeId42]: {
    _Value: variance52,
    _Patch: variance52
  }
};
var EmptyProto42 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto42), {
  _tag: "Empty"
});
var _empty542 = /* @__PURE__ */ Object.create(EmptyProto42);
var empty742 = () => _empty542;
var AndThenProto42 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto42), {
  _tag: "AndThen"
});
var makeAndThen42 = (first, second) => {
  const o232 = Object.create(AndThenProto42);
  o232.first = first;
  o232.second = second;
  return o232;
};
var AddServiceProto42 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto42), {
  _tag: "AddService"
});
var makeAddService42 = (key, service) => {
  const o232 = Object.create(AddServiceProto42);
  o232.key = key;
  o232.service = service;
  return o232;
};
var RemoveServiceProto42 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto42), {
  _tag: "RemoveService"
});
var makeRemoveService42 = (key) => {
  const o232 = Object.create(RemoveServiceProto42);
  o232.key = key;
  return o232;
};
var UpdateServiceProto42 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto42), {
  _tag: "UpdateService"
});
var makeUpdateService42 = (key, update222) => {
  const o232 = Object.create(UpdateServiceProto42);
  o232.key = key;
  o232.update = update222;
  return o232;
};
var diff42 = (oldValue, newValue) => {
  const missingServices = new Map(oldValue.unsafeMap);
  let patch2232 = empty742();
  for (const [tag, newService] of newValue.unsafeMap.entries()) {
    if (missingServices.has(tag)) {
      const old = missingServices.get(tag);
      missingServices.delete(tag);
      if (!equals62(old, newService)) {
        patch2232 = combine242(makeUpdateService42(tag, () => newService))(patch2232);
      }
    } else {
      missingServices.delete(tag);
      patch2232 = combine242(makeAddService42(tag, newService))(patch2232);
    }
  }
  for (const [tag] of missingServices.entries()) {
    patch2232 = combine242(makeRemoveService42(tag))(patch2232);
  }
  return patch2232;
};
var combine242 = /* @__PURE__ */ dual62(2, (self2, that) => makeAndThen42(self2, that));
var patch42 = /* @__PURE__ */ dual62(2, (self2, context) => {
  if (self2._tag === "Empty") {
    return context;
  }
  let wasServiceUpdated = false;
  let patches = of52(self2);
  const updatedContext = new Map(context.unsafeMap);
  while (isNonEmpty42(patches)) {
    const head222 = headNonEmpty52(patches);
    const tail222 = tailNonEmpty52(patches);
    switch (head222._tag) {
      case "Empty": {
        patches = tail222;
        break;
      }
      case "AddService": {
        updatedContext.set(head222.key, head222.service);
        patches = tail222;
        break;
      }
      case "AndThen": {
        patches = prepend62(prepend62(tail222, head222.second), head222.first);
        break;
      }
      case "RemoveService": {
        updatedContext.delete(head222.key);
        patches = tail222;
        break;
      }
      case "UpdateService": {
        updatedContext.set(head222.key, head222.update(updatedContext.get(head222.key)));
        wasServiceUpdated = true;
        patches = tail222;
        break;
      }
    }
  }
  if (!wasServiceUpdated) {
    return makeContext42(updatedContext);
  }
  const map622 = /* @__PURE__ */ new Map();
  for (const [tag] of context.unsafeMap) {
    if (updatedContext.has(tag)) {
      map622.set(tag, updatedContext.get(tag));
      updatedContext.delete(tag);
    }
  }
  for (const [tag, s232] of updatedContext) {
    map622.set(tag, s232);
  }
  return makeContext42(map622);
});
var DifferTypeId42 = /* @__PURE__ */ Symbol.for("effect/Differ");
var DifferProto42 = {
  [DifferTypeId42]: {
    _P: identity62,
    _V: identity62
  }
};
var make742 = (params) => {
  const differ = Object.create(DifferProto42);
  differ.empty = params.empty;
  differ.diff = params.diff;
  differ.combine = params.combine;
  differ.patch = params.patch;
  return differ;
};
var environment42 = () => make742({
  empty: empty742(),
  combine: (first, second) => combine242(second)(first),
  diff: (oldValue, newValue) => diff42(oldValue, newValue),
  patch: (patch2232, oldValue) => patch42(oldValue)(patch2232)
});
var OP_DIE42 = "Die";
var OP_EMPTY42 = "Empty";
var OP_FAIL42 = "Fail";
var OP_INTERRUPT42 = "Interrupt";
var OP_PARALLEL42 = "Parallel";
var OP_SEQUENTIAL42 = "Sequential";
var CauseSymbolKey42 = "effect/Cause";
var CauseTypeId42 = /* @__PURE__ */ Symbol.for(CauseSymbolKey42);
var variance242 = {
  /* c8 ignore next */
  _E: (_232) => _232
};
var proto42 = {
  [CauseTypeId42]: variance242,
  [symbol92]() {
    return pipe62(hash62(CauseSymbolKey42), combine72(hash62(flattenCause42(this))), cached62(this));
  },
  [symbol242](that) {
    return isCause42(that) && causeEquals42(this, that);
  },
  pipe() {
    return pipeArguments62(this, arguments);
  },
  toJSON() {
    switch (this._tag) {
      case "Empty":
        return {
          _id: "Cause",
          _tag: this._tag
        };
      case "Die":
        return {
          _id: "Cause",
          _tag: this._tag,
          defect: toJSON62(this.defect)
        };
      case "Interrupt":
        return {
          _id: "Cause",
          _tag: this._tag,
          fiberId: this.fiberId.toJSON()
        };
      case "Fail":
        return {
          _id: "Cause",
          _tag: this._tag,
          failure: toJSON62(this.error)
        };
      case "Sequential":
      case "Parallel":
        return {
          _id: "Cause",
          _tag: this._tag,
          left: toJSON62(this.left),
          right: toJSON62(this.right)
        };
    }
  },
  toString() {
    return pretty42(this);
  },
  [NodeInspectSymbol62]() {
    return this.toJSON();
  }
};
var fail52 = (error) => {
  const o232 = Object.create(proto42);
  o232._tag = OP_FAIL42;
  o232.error = error;
  return o232;
};
var parallel42 = (left3232, right3232) => {
  const o232 = Object.create(proto42);
  o232._tag = OP_PARALLEL42;
  o232.left = left3232;
  o232.right = right3232;
  return o232;
};
var sequential42 = (left3232, right3232) => {
  const o232 = Object.create(proto42);
  o232._tag = OP_SEQUENTIAL42;
  o232.left = left3232;
  o232.right = right3232;
  return o232;
};
var isCause42 = (u232) => hasProperty62(u232, CauseTypeId42);
var isInterruptedOnly42 = (self2) => reduceWithContext42(void 0, IsInterruptedOnlyCauseReducer42)(self2);
var causeEquals42 = (left3232, right3232) => {
  let leftStack = of52(left3232);
  let rightStack = of52(right3232);
  while (isNonEmpty42(leftStack) && isNonEmpty42(rightStack)) {
    const [leftParallel, leftSequential] = pipe62(headNonEmpty52(leftStack), reduce442([empty642(), empty342()], ([parallel2232, sequential2232], cause) => {
      const [par, seq] = evaluateCause42(cause);
      return some342([pipe62(parallel2232, union342(par)), pipe62(sequential2232, appendAll52(seq))]);
    }));
    const [rightParallel, rightSequential] = pipe62(headNonEmpty52(rightStack), reduce442([empty642(), empty342()], ([parallel2232, sequential2232], cause) => {
      const [par, seq] = evaluateCause42(cause);
      return some342([pipe62(parallel2232, union342(par)), pipe62(sequential2232, appendAll52(seq))]);
    }));
    if (!equals62(leftParallel, rightParallel)) {
      return false;
    }
    leftStack = leftSequential;
    rightStack = rightSequential;
  }
  return true;
};
var flattenCause42 = (cause) => {
  return flattenCauseLoop42(of52(cause), empty342());
};
var flattenCauseLoop42 = (causes, flattened) => {
  while (1) {
    const [parallel2232, sequential2232] = pipe62(causes, reduce72([empty642(), empty342()], ([parallel322, sequential322], cause) => {
      const [par, seq] = evaluateCause42(cause);
      return [pipe62(parallel322, union342(par)), pipe62(sequential322, appendAll52(seq))];
    }));
    const updated = size342(parallel2232) > 0 ? pipe62(flattened, prepend62(parallel2232)) : flattened;
    if (isEmpty52(sequential2232)) {
      return reverse242(updated);
    }
    causes = sequential2232;
    flattened = updated;
  }
  throw new Error(getBugErrorMessage62("Cause.flattenCauseLoop"));
};
var evaluateCause42 = (self2) => {
  let cause = self2;
  const stack = [];
  let _parallel = empty642();
  let _sequential = empty342();
  while (cause !== void 0) {
    switch (cause._tag) {
      case OP_EMPTY42: {
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_FAIL42: {
        _parallel = add342(_parallel, make442(cause._tag, cause.error));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_DIE42: {
        _parallel = add342(_parallel, make442(cause._tag, cause.defect));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_INTERRUPT42: {
        _parallel = add342(_parallel, make442(cause._tag, cause.fiberId));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_SEQUENTIAL42: {
        switch (cause.left._tag) {
          case OP_EMPTY42: {
            cause = cause.right;
            break;
          }
          case OP_SEQUENTIAL42: {
            cause = sequential42(cause.left.left, sequential42(cause.left.right, cause.right));
            break;
          }
          case OP_PARALLEL42: {
            cause = parallel42(sequential42(cause.left.left, cause.right), sequential42(cause.left.right, cause.right));
            break;
          }
          default: {
            _sequential = prepend62(_sequential, cause.right);
            cause = cause.left;
            break;
          }
        }
        break;
      }
      case OP_PARALLEL42: {
        stack.push(cause.right);
        cause = cause.left;
        break;
      }
    }
  }
  throw new Error(getBugErrorMessage62("Cause.evaluateCauseLoop"));
};
var IsInterruptedOnlyCauseReducer42 = {
  emptyCase: constTrue62,
  failCase: constFalse62,
  dieCase: constFalse62,
  interruptCase: constTrue62,
  sequentialCase: (_232, left3232, right3232) => left3232 && right3232,
  parallelCase: (_232, left3232, right3232) => left3232 && right3232
};
var OP_SEQUENTIAL_CASE42 = "SequentialCase";
var OP_PARALLEL_CASE42 = "ParallelCase";
var reduce442 = /* @__PURE__ */ dual62(3, (self2, zero, pf) => {
  let accumulator = zero;
  let cause = self2;
  const causes = [];
  while (cause !== void 0) {
    const option = pf(accumulator, cause);
    accumulator = isSome242(option) ? option.value : accumulator;
    switch (cause._tag) {
      case OP_SEQUENTIAL42: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      case OP_PARALLEL42: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      default: {
        cause = void 0;
        break;
      }
    }
    if (cause === void 0 && causes.length > 0) {
      cause = causes.pop();
    }
  }
  return accumulator;
});
var reduceWithContext42 = /* @__PURE__ */ dual62(3, (self2, context, reducer) => {
  const input = [self2];
  const output = [];
  while (input.length > 0) {
    const cause = input.pop();
    switch (cause._tag) {
      case OP_EMPTY42: {
        output.push(right242(reducer.emptyCase(context)));
        break;
      }
      case OP_FAIL42: {
        output.push(right242(reducer.failCase(context, cause.error)));
        break;
      }
      case OP_DIE42: {
        output.push(right242(reducer.dieCase(context, cause.defect)));
        break;
      }
      case OP_INTERRUPT42: {
        output.push(right242(reducer.interruptCase(context, cause.fiberId)));
        break;
      }
      case OP_SEQUENTIAL42: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left242({
          _tag: OP_SEQUENTIAL_CASE42
        }));
        break;
      }
      case OP_PARALLEL42: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left242({
          _tag: OP_PARALLEL_CASE42
        }));
        break;
      }
    }
  }
  const accumulator = [];
  while (output.length > 0) {
    const either = output.pop();
    switch (either._tag) {
      case "Left": {
        switch (either.left._tag) {
          case OP_SEQUENTIAL_CASE42: {
            const left3232 = accumulator.pop();
            const right3232 = accumulator.pop();
            const value = reducer.sequentialCase(context, left3232, right3232);
            accumulator.push(value);
            break;
          }
          case OP_PARALLEL_CASE42: {
            const left3232 = accumulator.pop();
            const right3232 = accumulator.pop();
            const value = reducer.parallelCase(context, left3232, right3232);
            accumulator.push(value);
            break;
          }
        }
        break;
      }
      case "Right": {
        accumulator.push(either.right);
        break;
      }
    }
  }
  if (accumulator.length === 0) {
    throw new Error("BUG: Cause.reduceWithContext - please report an issue at https://github.com/Effect-TS/effect/issues");
  }
  return accumulator.pop();
});
var pretty42 = (cause) => {
  if (isInterruptedOnly42(cause)) {
    return "All fibers interrupted without errors.";
  }
  return prettyErrors42(cause).map((e232) => e232.stack).join("\n");
};
var PrettyError42 = class extends globalThis.Error {
  span = void 0;
  constructor(originalError) {
    const prevLimit = Error.stackTraceLimit;
    Error.stackTraceLimit = 0;
    super(prettyErrorMessage42(originalError));
    Error.stackTraceLimit = prevLimit;
    this.name = originalError instanceof Error ? originalError.name : "Error";
    if (typeof originalError === "object" && originalError !== null) {
      if (spanSymbol52 in originalError) {
        this.span = originalError[spanSymbol52];
      }
      Object.keys(originalError).forEach((key) => {
        if (!(key in this)) {
          this[key] = originalError[key];
        }
      });
    }
    this.stack = prettyErrorStack42(this.message, originalError instanceof Error && originalError.stack ? originalError.stack : "", this.span);
  }
  toJSON() {
    const out = {
      message: this.message,
      stack: this.stack
    };
    if (this.span) {
      out.span = this.span;
    }
    return out;
  }
};
var prettyErrorMessage42 = (u232) => {
  if (typeof u232 === "string") {
    return `Error: ${u232}`;
  }
  try {
    if (hasProperty62(u232, "toString") && isFunction332(u232["toString"]) && u232["toString"] !== Object.prototype.toString && u232["toString"] !== globalThis.Array.prototype.toString) {
      return u232["toString"]();
    }
  } catch {
  }
  return `Error: ${JSON.stringify(u232)}`;
};
var locationRegex42 = /\((.*)\)/;
var spanToTrace42 = /* @__PURE__ */ globalValue62("effect/Tracer/spanToTrace", () => /* @__PURE__ */ new WeakMap());
var prettyErrorStack42 = (message, stack, span222) => {
  const out = [message];
  const lines = stack.split("\n");
  for (let i232 = 1; i232 < lines.length; i232++) {
    if (lines[i232].includes("Generator.next")) {
      break;
    }
    if (lines[i232].includes("effect_internal_function")) {
      out.pop();
      break;
    }
    out.push(lines[i232].replace(/at .*effect_instruction_i.*\((.*)\)/, "at $1").replace(/EffectPrimitive\.\w+/, "<anonymous>"));
  }
  if (span222) {
    let current = span222;
    let i232 = 0;
    while (current && current._tag === "Span" && i232 < 10) {
      const stackFn = spanToTrace42.get(current);
      if (typeof stackFn === "function") {
        const stack2 = stackFn();
        const locationMatch = stack2.match(locationRegex42);
        const location = locationMatch ? locationMatch[1] : stack2.replace(/^at /, "");
        out.push(`    at ${current.name} (${location})`);
      } else {
        out.push(`    at ${current.name}`);
      }
      current = getOrUndefined62(current.parent);
      i232++;
    }
  }
  return out.join("\n");
};
var spanSymbol52 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var prettyErrors42 = (cause) => reduceWithContext42(cause, void 0, {
  emptyCase: () => [],
  dieCase: (_232, unknownError) => {
    return [new PrettyError42(unknownError)];
  },
  failCase: (_232, error) => {
    return [new PrettyError42(error)];
  },
  interruptCase: () => [],
  parallelCase: (_232, l232, r232) => [...l232, ...r232],
  sequentialCase: (_232, l232, r232) => [...l232, ...r232]
});
var SingleShotGen242 = class _SingleShotGen242 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  next(a232) {
    return this.called ? {
      value: a232,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  return(a232) {
    return {
      value: a232,
      done: true
    };
  }
  throw(e232) {
    throw e232;
  }
  [Symbol.iterator]() {
    return new _SingleShotGen242(this.self);
  }
};
var spanTag42 = /* @__PURE__ */ GenericTag42("effect/ParentSpan");
var EffectTypeId242 = /* @__PURE__ */ Symbol.for("effect/Effect");
var EffectPrimitive42 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId242] = effectVariance62;
  constructor(_op) {
    this._op = _op;
  }
  [symbol242](that) {
    return this === that;
  }
  [symbol92]() {
    return cached62(this, random62(this));
  }
  pipe() {
    return pipeArguments62(this, arguments);
  }
  toJSON() {
    return {
      _id: "Effect",
      _op: this._op,
      effect_instruction_i0: toJSON62(this.effect_instruction_i0),
      effect_instruction_i1: toJSON62(this.effect_instruction_i1),
      effect_instruction_i2: toJSON62(this.effect_instruction_i2)
    };
  }
  toString() {
    return format62(this.toJSON());
  }
  [NodeInspectSymbol62]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen242(new YieldWrap62(this));
  }
};
var EffectPrimitiveFailure42 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId242] = effectVariance62;
  constructor(_op) {
    this._op = _op;
    this._tag = _op;
  }
  [symbol242](that) {
    return exitIsExit42(that) && that._op === "Failure" && // @ts-expect-error
    equals62(this.effect_instruction_i0, that.effect_instruction_i0);
  }
  [symbol92]() {
    return pipe62(
      // @ts-expect-error
      string72(this._tag),
      // @ts-expect-error
      combine72(hash62(this.effect_instruction_i0)),
      cached62(this)
    );
  }
  get cause() {
    return this.effect_instruction_i0;
  }
  pipe() {
    return pipeArguments62(this, arguments);
  }
  toJSON() {
    return {
      _id: "Exit",
      _tag: this._op,
      cause: this.cause.toJSON()
    };
  }
  toString() {
    return format62(this.toJSON());
  }
  [NodeInspectSymbol62]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen242(new YieldWrap62(this));
  }
};
var isEffect42 = (u232) => hasProperty62(u232, EffectTypeId242);
var withFiberRuntime42 = (withRuntime) => {
  const effect = new EffectPrimitive42(OP_WITH_RUNTIME42);
  effect.effect_instruction_i0 = withRuntime;
  return effect;
};
var spanSymbol242 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var originalSymbol42 = /* @__PURE__ */ Symbol.for("effect/OriginalAnnotation");
var capture42 = (obj, span222) => {
  if (isSome242(span222)) {
    return new Proxy(obj, {
      has(target, p232) {
        return p232 === spanSymbol242 || p232 === originalSymbol42 || p232 in target;
      },
      get(target, p232) {
        if (p232 === spanSymbol242) {
          return span222.value;
        }
        if (p232 === originalSymbol42) {
          return obj;
        }
        return target[p232];
      }
    });
  }
  return obj;
};
var fail242 = (error) => isObject62(error) && !(spanSymbol242 in error) ? withFiberRuntime42((fiber) => failCause42(fail52(capture42(error, currentSpanFromFiber42(fiber))))) : failCause42(fail52(error));
var failCause42 = (cause) => {
  const effect = new EffectPrimitiveFailure42(OP_FAILURE42);
  effect.effect_instruction_i0 = cause;
  return effect;
};
var FiberRefSymbolKey42 = "effect/FiberRef";
var FiberRefTypeId42 = /* @__PURE__ */ Symbol.for(FiberRefSymbolKey42);
var fiberRefVariance42 = {
  /* c8 ignore next */
  _A: (_232) => _232
};
var fiberRefUnsafeMakeContext42 = (initial) => {
  const differ = environment42();
  return fiberRefUnsafeMakePatch42(initial, {
    differ,
    fork: differ.empty
  });
};
var fiberRefUnsafeMakePatch42 = (initial, options) => ({
  [FiberRefTypeId42]: fiberRefVariance42,
  initial,
  diff: (oldValue, newValue) => options.differ.diff(oldValue, newValue),
  combine: (first, second) => options.differ.combine(first, second),
  patch: (patch2232) => (oldValue) => options.differ.patch(patch2232, oldValue),
  fork: options.fork,
  join: options.join ?? ((_232, n232) => n232),
  pipe() {
    return pipeArguments62(this, arguments);
  }
});
var currentContext42 = /* @__PURE__ */ globalValue62(/* @__PURE__ */ Symbol.for("effect/FiberRef/currentContext"), () => fiberRefUnsafeMakeContext42(empty242()));
var YieldableError42 = /* @__PURE__ */ function() {
  class YieldableError2232 extends globalThis.Error {
    commit() {
      return fail242(this);
    }
    toString() {
      return this.message ? `${this.name}: ${this.message}` : this.name;
    }
    toJSON() {
      return {
        ...this
      };
    }
    [NodeInspectSymbol62]() {
      const stack = this.stack;
      if (stack) {
        return `${this.toString()}
${stack.split("\n").slice(1).join("\n")}`;
      }
      return this.toString();
    }
  }
  Object.assign(YieldableError2232.prototype, StructuralCommitPrototype32);
  return YieldableError2232;
}();
var exitIsExit42 = (u232) => isEffect42(u232) && "_tag" in u232 && (u232._tag === "Success" || u232._tag === "Failure");
var currentSpanFromFiber42 = (fiber) => {
  const span222 = fiber.getFiberRef(currentContext42).unsafeMap.get(spanTag42.key);
  return span222 !== void 0 && span222._tag === "Span" ? some342(span222) : none242();
};
var Data_exports32 = {};
__export242(Data_exports32, {
  Class: () => Class242,
  Error: () => Error242,
  Structural: () => Structural242,
  TaggedClass: () => TaggedClass42,
  TaggedError: () => TaggedError42,
  array: () => array242,
  case: () => _case42,
  struct: () => struct342,
  tagged: () => tagged42,
  taggedEnum: () => taggedEnum42,
  tuple: () => tuple242,
  unsafeArray: () => unsafeArray42,
  unsafeStruct: () => unsafeStruct42
});
var struct342 = struct242;
var unsafeStruct42 = (as2322) => Object.setPrototypeOf(as2322, StructuralPrototype32);
var tuple242 = (...as2322) => unsafeArray42(as2322);
var array242 = (as2322) => unsafeArray42(as2322.slice(0));
var unsafeArray42 = (as2322) => Object.setPrototypeOf(as2322, ArrayProto42);
var _case42 = () => (args) => args === void 0 ? Object.create(StructuralPrototype32) : struct342(args);
var tagged42 = (tag) => (args) => {
  const value = args === void 0 ? Object.create(StructuralPrototype32) : struct342(args);
  value._tag = tag;
  return value;
};
var Class242 = Structural52;
var TaggedClass42 = (tag) => {
  class Base extends Class242 {
    _tag = tag;
  }
  return Base;
};
var Structural242 = Structural52;
var taggedEnum42 = () => new Proxy({}, {
  get(_target, tag, _receiver) {
    if (tag === "$is") {
      return isTagged62;
    } else if (tag === "$match") {
      return taggedMatch42;
    }
    return tagged42(tag);
  }
});
function taggedMatch42() {
  if (arguments.length === 1) {
    const cases2 = arguments[0];
    return function(value2) {
      return cases2[value2._tag](value2);
    };
  }
  const value = arguments[0];
  const cases = arguments[1];
  return cases[value._tag](value);
}
var Error242 = /* @__PURE__ */ function() {
  return class Base extends YieldableError42 {
    constructor(args) {
      super();
      if (args) {
        Object.assign(this, args);
      }
    }
  };
}();
var TaggedError42 = (tag) => {
  class Base extends Error242 {
    _tag = tag;
  }
  Base.prototype.name = tag;
  return Base;
};
var traverseUp42 = Function_exports62.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType42.Program) return Option_exports62.none();
  return predicate(parent) ? Option_exports62.some(parent) : traverseUp42(parent, predicate);
});
var traverseUpGuard42 = Function_exports62.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType42.Program) return Option_exports62.none();
  return predicate(parent) ? Option_exports62.some(parent) : traverseUpGuard42(parent, predicate);
});
var ESLintCommunityESLintUtils42;
((ESLintCommunityESLintUtils2232) => {
  ESLintCommunityESLintUtils2232.getFunctionHeadLocation = getFunctionHeadLocation42;
  ESLintCommunityESLintUtils2232.getFunctionNameWithKind = getFunctionNameWithKind42;
  ESLintCommunityESLintUtils2232.getPropertyName = getPropertyName42;
  ESLintCommunityESLintUtils2232.getStaticValue = getStaticValue32;
  ESLintCommunityESLintUtils2232.getStringIfConstant = getStringIfConstant42;
  ESLintCommunityESLintUtils2232.hasSideEffect = hasSideEffect42;
  ESLintCommunityESLintUtils2232.isParenthesized = isParenthesized42;
})(ESLintCommunityESLintUtils42 || (ESLintCommunityESLintUtils42 = {}));
var Construction42 = Data_exports32.taggedEnum();
Construction42.None();
a5({
  type: N4.union([NodeType42.FunctionExpression, NodeType42.ArrowFunctionExpression]),
  parent: {
    type: NodeType42.Property,
    parent: {
      type: NodeType42.ObjectExpression
    }
  }
});
a5({
  type: N4.union([NodeType42.FunctionExpression, NodeType42.ArrowFunctionExpression]),
  parent: {
    type: NodeType42.MethodDefinition,
    parent: {
      type: NodeType42.ClassBody
    }
  }
});
a5({
  type: N4.union([NodeType42.FunctionExpression, NodeType42.ArrowFunctionExpression]),
  parent: {
    type: NodeType42.Property,
    parent: {
      type: NodeType42.ClassBody
    }
  }
});
var Function_exports242 = {};
__export52(Function_exports242, {
  SK: () => SK242,
  absurd: () => absurd242,
  apply: () => apply242,
  compose: () => compose332,
  constFalse: () => constFalse242,
  constNull: () => constNull242,
  constTrue: () => constTrue242,
  constUndefined: () => constUndefined242,
  constVoid: () => constVoid242,
  constant: () => constant242,
  dual: () => dual242,
  flip: () => flip242,
  flow: () => flow242,
  hole: () => hole242,
  identity: () => identity242,
  isFunction: () => isFunction43,
  pipe: () => pipe242,
  satisfies: () => satisfies242,
  tupled: () => tupled242,
  unsafeCoerce: () => unsafeCoerce242,
  untupled: () => untupled242
});
var isFunction43 = (input) => typeof input === "function";
var dual242 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a232, b232) {
        if (arguments.length >= 2) {
          return body(a232, b232);
        }
        return function(self2) {
          return body(self2, a232);
        };
      };
    case 3:
      return function(a232, b232, c232) {
        if (arguments.length >= 3) {
          return body(a232, b232, c232);
        }
        return function(self2) {
          return body(self2, a232, b232);
        };
      };
    case 4:
      return function(a232, b232, c232, d232) {
        if (arguments.length >= 4) {
          return body(a232, b232, c232, d232);
        }
        return function(self2) {
          return body(self2, a232, b232, c232);
        };
      };
    case 5:
      return function(a232, b232, c232, d232, e232) {
        if (arguments.length >= 5) {
          return body(a232, b232, c232, d232, e232);
        }
        return function(self2) {
          return body(self2, a232, b232, c232, d232);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply242 = (a232) => (self2) => self2(a232);
var identity242 = (a232) => a232;
var satisfies242 = () => (b232) => b232;
var unsafeCoerce242 = identity242;
var constant242 = (value) => () => value;
var constTrue242 = /* @__PURE__ */ constant242(true);
var constFalse242 = /* @__PURE__ */ constant242(false);
var constNull242 = /* @__PURE__ */ constant242(null);
var constUndefined242 = /* @__PURE__ */ constant242(void 0);
var constVoid242 = constUndefined242;
var flip242 = (f232) => (...b232) => (...a232) => f232(...a232)(...b232);
var compose332 = /* @__PURE__ */ dual242(2, (ab, bc) => (a232) => bc(ab(a232)));
var absurd242 = (_232) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled242 = (f232) => (a232) => f232(...a232);
var untupled242 = (f232) => (...a232) => f232(a232);
function pipe242(a232, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a232;
    case 2:
      return ab(a232);
    case 3:
      return bc(ab(a232));
    case 4:
      return cd(bc(ab(a232)));
    case 5:
      return de(cd(bc(ab(a232))));
    case 6:
      return ef(de(cd(bc(ab(a232)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a232))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a232)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a232))))))));
    default: {
      let ret = arguments[0];
      for (let i232 = 1; i232 < arguments.length; i232++) {
        ret = arguments[i232](ret);
      }
      return ret;
    }
  }
}
function flow242(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole242 = /* @__PURE__ */ unsafeCoerce242(absurd242);
var SK242 = (_232, b232) => b232;
var Array_exports22 = {};
__export52(Array_exports22, {
  Do: () => Do322,
  allocate: () => allocate22,
  append: () => append32,
  appendAll: () => appendAll232,
  bind: () => bind522,
  bindTo: () => bindTo522,
  cartesian: () => cartesian22,
  cartesianWith: () => cartesianWith22,
  chop: () => chop22,
  chunksOf: () => chunksOf22,
  contains: () => contains322,
  containsWith: () => containsWith322,
  copy: () => copy232,
  dedupe: () => dedupe22,
  dedupeAdjacent: () => dedupeAdjacent22,
  dedupeAdjacentWith: () => dedupeAdjacentWith22,
  dedupeWith: () => dedupeWith22,
  difference: () => difference22,
  differenceWith: () => differenceWith22,
  drop: () => drop232,
  dropRight: () => dropRight22,
  dropWhile: () => dropWhile22,
  empty: () => empty922,
  every: () => every322,
  extend: () => extend22,
  filter: () => filter322,
  filterMap: () => filterMap322,
  filterMapWhile: () => filterMapWhile22,
  findFirst: () => findFirst222,
  findFirstIndex: () => findFirstIndex22,
  findLast: () => findLast22,
  findLastIndex: () => findLastIndex22,
  flatMap: () => flatMap322,
  flatMapNullable: () => flatMapNullable322,
  flatten: () => flatten322,
  forEach: () => forEach332,
  fromIterable: () => fromIterable422,
  fromNullable: () => fromNullable322,
  fromOption: () => fromOption222,
  fromRecord: () => fromRecord22,
  get: () => get52,
  getEquivalence: () => getEquivalence422,
  getLefts: () => getLefts22,
  getOrder: () => getOrder322,
  getRights: () => getRights22,
  getSomes: () => getSomes22,
  group: () => group22,
  groupBy: () => groupBy22,
  groupWith: () => groupWith22,
  head: () => head32,
  headNonEmpty: () => headNonEmpty232,
  init: () => init22,
  initNonEmpty: () => initNonEmpty22,
  insertAt: () => insertAt22,
  intersection: () => intersection22,
  intersectionWith: () => intersectionWith22,
  intersperse: () => intersperse22,
  isArray: () => isArray22,
  isEmptyArray: () => isEmptyArray22,
  isEmptyReadonlyArray: () => isEmptyReadonlyArray22,
  isNonEmptyArray: () => isNonEmptyArray222,
  isNonEmptyReadonlyArray: () => isNonEmptyReadonlyArray22,
  join: () => join23,
  last: () => last22,
  lastNonEmpty: () => lastNonEmpty22,
  length: () => length32,
  let: () => let_522,
  liftEither: () => liftEither22,
  liftNullable: () => liftNullable322,
  liftOption: () => liftOption22,
  liftPredicate: () => liftPredicate322,
  make: () => make1022,
  makeBy: () => makeBy22,
  map: () => map322,
  mapAccum: () => mapAccum22,
  match: () => match422,
  matchLeft: () => matchLeft22,
  matchRight: () => matchRight22,
  max: () => max222,
  min: () => min222,
  modify: () => modify22,
  modifyNonEmptyHead: () => modifyNonEmptyHead22,
  modifyNonEmptyLast: () => modifyNonEmptyLast22,
  modifyOption: () => modifyOption22,
  of: () => of232,
  partition: () => partition22,
  partitionMap: () => partitionMap322,
  prepend: () => prepend232,
  prependAll: () => prependAll22,
  range: () => range22,
  reduce: () => reduce332,
  reduceRight: () => reduceRight22,
  remove: () => remove32,
  replace: () => replace222,
  replaceOption: () => replaceOption22,
  replicate: () => replicate22,
  reverse: () => reverse332,
  rotate: () => rotate22,
  scan: () => scan22,
  scanRight: () => scanRight22,
  separate: () => separate22,
  setNonEmptyHead: () => setNonEmptyHead22,
  setNonEmptyLast: () => setNonEmptyLast22,
  some: () => some722,
  sort: () => sort22,
  sortBy: () => sortBy22,
  sortWith: () => sortWith22,
  span: () => span22,
  split: () => split22,
  splitAt: () => splitAt22,
  splitNonEmptyAt: () => splitNonEmptyAt22,
  splitWhere: () => splitWhere22,
  tail: () => tail32,
  tailNonEmpty: () => tailNonEmpty232,
  take: () => take22,
  takeRight: () => takeRight22,
  takeWhile: () => takeWhile22,
  unappend: () => unappend22,
  unfold: () => unfold22,
  union: () => union42,
  unionWith: () => unionWith22,
  unprepend: () => unprepend22,
  unsafeGet: () => unsafeGet32,
  unzip: () => unzip22,
  zip: () => zip22,
  zipWith: () => zipWith322
});
var make632 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var array332 = (item) => make632((self2, that) => {
  if (self2.length !== that.length) {
    return false;
  }
  for (let i232 = 0; i232 < self2.length; i232++) {
    const isEq = item(self2[i232], that[i232]);
    if (!isEq) {
      return false;
    }
  }
  return true;
});
var let_342 = (map522) => dual242(3, (self2, name22, f232) => map522(self2, (a232) => Object.assign({}, a232, {
  [name22]: f232(a232)
})));
var bindTo342 = (map522) => dual242(2, (self2, name22) => map522(self2, (a232) => ({
  [name22]: a232
})));
var bind342 = (map522, flatMap522) => dual242(3, (self2, name22, f232) => flatMap522(self2, (a232) => map522(f232(a232), (b232) => Object.assign({}, a232, {
  [name22]: b232
}))));
var moduleVersion242 = "3.2.8";
var getCurrentVersion242 = () => moduleVersion242;
var globalStoreId242 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion242()}`);
if (!(globalStoreId242 in globalThis)) {
  globalThis[globalStoreId242] = /* @__PURE__ */ new Map();
}
var globalStore242 = globalThis[globalStoreId242];
var globalValue242 = (id, compute) => {
  if (!globalStore242.has(id)) {
    globalStore242.set(id, compute());
  }
  return globalStore242.get(id);
};
var Predicate_exports242 = {};
__export52(Predicate_exports242, {
  all: () => all332,
  and: () => and232,
  compose: () => compose422,
  eqv: () => eqv232,
  every: () => every232,
  hasProperty: () => hasProperty242,
  implies: () => implies232,
  isBigInt: () => isBigInt232,
  isBoolean: () => isBoolean232,
  isDate: () => isDate232,
  isError: () => isError232,
  isFunction: () => isFunction522,
  isIterable: () => isIterable232,
  isMap: () => isMap232,
  isNever: () => isNever232,
  isNotNull: () => isNotNull232,
  isNotNullable: () => isNotNullable232,
  isNotUndefined: () => isNotUndefined232,
  isNull: () => isNull232,
  isNullable: () => isNullable242,
  isNumber: () => isNumber232,
  isObject: () => isObject242,
  isPromise: () => isPromise232,
  isPromiseLike: () => isPromiseLike232,
  isReadonlyRecord: () => isReadonlyRecord232,
  isRecord: () => isRecord232,
  isSet: () => isSet232,
  isString: () => isString232,
  isSymbol: () => isSymbol232,
  isTagged: () => isTagged232,
  isTruthy: () => isTruthy232,
  isUint8Array: () => isUint8Array232,
  isUndefined: () => isUndefined232,
  isUnknown: () => isUnknown232,
  mapInput: () => mapInput232,
  nand: () => nand232,
  nor: () => nor232,
  not: () => not232,
  or: () => or232,
  product: () => product332,
  productMany: () => productMany332,
  some: () => some432,
  struct: () => struct432,
  tuple: () => tuple332,
  xor: () => xor232
});
var mapInput232 = /* @__PURE__ */ dual242(2, (self2, f232) => (b232) => self2(f232(b232)));
var isTruthy232 = (input) => !!input;
var isSet232 = (input) => input instanceof Set;
var isMap232 = (input) => input instanceof Map;
var isString232 = (input) => typeof input === "string";
var isNumber232 = (input) => typeof input === "number";
var isBoolean232 = (input) => typeof input === "boolean";
var isBigInt232 = (input) => typeof input === "bigint";
var isSymbol232 = (input) => typeof input === "symbol";
var isFunction522 = isFunction43;
var isUndefined232 = (input) => input === void 0;
var isNotUndefined232 = (input) => input !== void 0;
var isNull232 = (input) => input === null;
var isNotNull232 = (input) => input !== null;
var isNever232 = (_232) => false;
var isUnknown232 = (_232) => true;
var isRecordOrArray242 = (input) => typeof input === "object" && input !== null;
var isObject242 = (input) => isRecordOrArray242(input) || isFunction522(input);
var hasProperty242 = /* @__PURE__ */ dual242(2, (self2, property) => isObject242(self2) && property in self2);
var isTagged232 = /* @__PURE__ */ dual242(2, (self2, tag) => hasProperty242(self2, "_tag") && self2["_tag"] === tag);
var isNullable242 = (input) => input === null || input === void 0;
var isNotNullable232 = (input) => input !== null && input !== void 0;
var isError232 = (input) => input instanceof Error;
var isUint8Array232 = (input) => input instanceof Uint8Array;
var isDate232 = (input) => input instanceof Date;
var isIterable232 = (input) => hasProperty242(input, Symbol.iterator);
var isRecord232 = (input) => isRecordOrArray242(input) && !Array.isArray(input);
var isReadonlyRecord232 = isRecord232;
var isPromise232 = (input) => hasProperty242(input, "then") && "catch" in input && isFunction522(input.then) && isFunction522(input.catch);
var isPromiseLike232 = (input) => hasProperty242(input, "then") && isFunction522(input.then);
var compose422 = /* @__PURE__ */ dual242(2, (ab, bc) => (a232) => ab(a232) && bc(a232));
var product332 = (self2, that) => ([a232, b232]) => self2(a232) && that(b232);
var all332 = (collection) => {
  return (as422) => {
    let collectionIndex = 0;
    for (const p232 of collection) {
      if (collectionIndex >= as422.length) {
        break;
      }
      if (p232(as422[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany332 = (self2, collection) => {
  const rest = all332(collection);
  return ([head222, ...tail222]) => self2(head222) === false ? false : rest(tail222);
};
var tuple332 = (...elements) => all332(elements);
var struct432 = (fields) => {
  const keys422 = Object.keys(fields);
  return (a232) => {
    for (const key of keys422) {
      if (!fields[key](a232[key])) {
        return false;
      }
    }
    return true;
  };
};
var not232 = (self2) => (a232) => !self2(a232);
var or232 = /* @__PURE__ */ dual242(2, (self2, that) => (a232) => self2(a232) || that(a232));
var and232 = /* @__PURE__ */ dual242(2, (self2, that) => (a232) => self2(a232) && that(a232));
var xor232 = /* @__PURE__ */ dual242(2, (self2, that) => (a232) => self2(a232) !== that(a232));
var eqv232 = /* @__PURE__ */ dual242(2, (self2, that) => (a232) => self2(a232) === that(a232));
var implies232 = /* @__PURE__ */ dual242(2, (self2, that) => (a232) => self2(a232) ? that(a232) : true);
var nor232 = /* @__PURE__ */ dual242(2, (self2, that) => (a232) => !(self2(a232) || that(a232)));
var nand232 = /* @__PURE__ */ dual242(2, (self2, that) => (a232) => !(self2(a232) && that(a232)));
var every232 = (collection) => (a232) => {
  for (const p232 of collection) {
    if (!p232(a232)) {
      return false;
    }
  }
  return true;
};
var some432 = (collection) => (a232) => {
  for (const p232 of collection) {
    if (p232(a232)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage242 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId242 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind242 = (u232) => isObject242(u232) && GenKindTypeId242 in u232;
var GenKindImpl242 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity242;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId242] = GenKindTypeId242;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen332(this);
  }
};
var SingleShotGen332 = class _SingleShotGen522 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a232) {
    return this.called ? {
      value: a232,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a232) {
    return {
      value: a232,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e232) {
    throw e232;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen522(this.self);
  }
};
var adapter342 = () => function() {
  let x232 = arguments[0];
  for (let i232 = 1; i232 < arguments.length; i232++) {
    x232 = arguments[i232](x232);
  }
  return new GenKindImpl242(x232);
};
var defaultIncHi242 = 335903614;
var defaultIncLo242 = 4150755663;
var MUL_HI242 = 1481765933 >>> 0;
var MUL_LO242 = 1284865837 >>> 0;
var BIT_53242 = 9007199254740992;
var BIT_27242 = 134217728;
var PCGRandom242 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable242(seedLo) && isNullable242(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable242(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable242(incLo) && isNullable242(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo242;
      incHi = this._state ? this._state[2] : defaultIncHi242;
    } else if (isNullable242(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add64242(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max322) {
    if (!max322) {
      return this._next();
    }
    max322 = max322 >>> 0;
    if ((max322 & max322 - 1) === 0) {
      return this._next() & max322 - 1;
    }
    let num = 0;
    const skew = (-max322 >>> 0) % max322 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max322;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_27242 + lo) / BIT_53242;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul64242(this._state, oldHi, oldLo, MUL_HI242, MUL_LO242);
    add64242(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul64242(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add64242(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId242 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap242 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId242]() {
    return this.#value;
  }
};
function yieldWrapGet242(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId242 in self2) {
    return self2[YieldWrapTypeId242]();
  }
  throw new Error(getBugErrorMessage242("yieldWrapGet"));
}
var structuralRegionState242 = /* @__PURE__ */ globalValue242("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache242 = /* @__PURE__ */ globalValue242(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr242 = /* @__PURE__ */ globalValue242(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom242());
var symbol342 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash242 = (self2) => {
  if (structuralRegionState242.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number242(self2);
    case "bigint":
      return string242(self2.toString(10));
    case "boolean":
      return string242(String(self2));
    case "symbol":
      return string242(String(self2));
    case "string":
      return string242(self2);
    case "undefined":
      return string242("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string242("null");
      } else if (self2 instanceof Date) {
        return hash242(self2.toISOString());
      } else if (isHash242(self2)) {
        return self2[symbol342]();
      } else {
        return random242(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random242 = (self2) => {
  if (!randomHashCache242.has(self2)) {
    randomHashCache242.set(self2, number242(pcgr242.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache242.get(self2);
};
var combine332 = (b232) => (self2) => self2 * 53 ^ b232;
var optimize242 = (n232) => n232 & 3221225471 | n232 >>> 1 & 1073741824;
var isHash242 = (u232) => hasProperty242(u232, symbol342);
var number242 = (n232) => {
  if (n232 !== n232 || n232 === Infinity) {
    return 0;
  }
  let h232 = n232 | 0;
  if (h232 !== n232) {
    h232 ^= n232 * 4294967295;
  }
  while (n232 > 4294967295) {
    h232 ^= n232 /= 4294967295;
  }
  return optimize242(n232);
};
var string242 = (str) => {
  let h232 = 5381, i232 = str.length;
  while (i232) {
    h232 = h232 * 33 ^ str.charCodeAt(--i232);
  }
  return optimize242(h232);
};
var cached242 = function() {
  if (arguments.length === 1) {
    const self3 = arguments[0];
    return function(hash522) {
      Object.defineProperty(self3, symbol342, {
        value() {
          return hash522;
        },
        enumerable: false
      });
      return hash522;
    };
  }
  const self2 = arguments[0];
  const hash422 = arguments[1];
  Object.defineProperty(self2, symbol342, {
    value() {
      return hash422;
    },
    enumerable: false
  });
  return hash422;
};
var symbol422 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals242() {
  if (arguments.length === 1) {
    return (self2) => compareBoth242(self2, arguments[0]);
  }
  return compareBoth242(arguments[0], arguments[1]);
}
function compareBoth242(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual242(self2) && isEqual242(that)) {
        if (hash242(self2) === hash242(that) && self2[symbol422](that)) {
          return true;
        } else {
          return structuralRegionState242.enabled && structuralRegionState242.tester ? structuralRegionState242.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState242.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v232, i232) => compareBoth242(v232, that[i232]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth242(self2[key], that[key]))) {
              return structuralRegionState242.tester ? structuralRegionState242.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState242.tester ? structuralRegionState242.tester(self2, that) : false;
    }
  }
  return structuralRegionState242.enabled && structuralRegionState242.tester ? structuralRegionState242.tester(self2, that) : false;
}
var isEqual242 = (u232) => hasProperty242(u232, symbol422);
var equivalence242 = () => equals242;
var NodeInspectSymbol242 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON242 = (x232) => {
  if (hasProperty242(x232, "toJSON") && isFunction522(x232["toJSON"]) && x232["toJSON"].length === 0) {
    return x232.toJSON();
  } else if (Array.isArray(x232)) {
    return x232.map(toJSON242);
  }
  return x232;
};
var format242 = (x232) => JSON.stringify(x232, null, 2);
var pipeArguments242 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i232 = 0, len = args.length; i232 < len; i232++) {
        ret = args[i232](ret);
      }
      return ret;
    }
  }
};
var EffectTypeId332 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId242 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId242 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId242 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance242 = {
  /* c8 ignore next */
  _R: (_232) => _232,
  /* c8 ignore next */
  _E: (_232) => _232,
  /* c8 ignore next */
  _A: (_232) => _232,
  _V: /* @__PURE__ */ getCurrentVersion242()
};
var sinkVariance242 = {
  /* c8 ignore next */
  _A: (_232) => _232,
  /* c8 ignore next */
  _In: (_232) => _232,
  /* c8 ignore next */
  _L: (_232) => _232,
  /* c8 ignore next */
  _E: (_232) => _232,
  /* c8 ignore next */
  _R: (_232) => _232
};
var channelVariance242 = {
  /* c8 ignore next */
  _Env: (_232) => _232,
  /* c8 ignore next */
  _InErr: (_232) => _232,
  /* c8 ignore next */
  _InElem: (_232) => _232,
  /* c8 ignore next */
  _InDone: (_232) => _232,
  /* c8 ignore next */
  _OutErr: (_232) => _232,
  /* c8 ignore next */
  _OutElem: (_232) => _232,
  /* c8 ignore next */
  _OutDone: (_232) => _232
};
var EffectPrototype242 = {
  [EffectTypeId332]: effectVariance242,
  [StreamTypeId242]: effectVariance242,
  [SinkTypeId242]: sinkVariance242,
  [ChannelTypeId242]: channelVariance242,
  [symbol422](that) {
    return this === that;
  },
  [symbol342]() {
    return cached242(this, random242(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen332(new YieldWrap242(this));
  },
  pipe() {
    return pipeArguments242(this, arguments);
  }
};
var TypeId632 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto342 = {
  ...EffectPrototype242,
  [TypeId632]: {
    _A: (_232) => _232
  },
  [NodeInspectSymbol242]() {
    return this.toJSON();
  },
  toString() {
    return format242(this.toJSON());
  }
};
var SomeProto242 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto342), {
  _tag: "Some",
  _op: "Some",
  [symbol422](that) {
    return isOption342(that) && isSome342(that) && equals242(this.value, that.value);
  },
  [symbol342]() {
    return cached242(this, combine332(hash242(this._tag))(hash242(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON242(this.value)
    };
  }
});
var NoneHash242 = /* @__PURE__ */ hash242("None");
var NoneProto242 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto342), {
  _tag: "None",
  _op: "None",
  [symbol422](that) {
    return isOption342(that) && isNone342(that);
  },
  [symbol342]() {
    return NoneHash242;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption342 = (input) => hasProperty242(input, TypeId632);
var isNone342 = (fa) => fa._tag === "None";
var isSome342 = (fa) => fa._tag === "Some";
var none342 = /* @__PURE__ */ Object.create(NoneProto242);
var some522 = (value) => {
  const a232 = Object.create(SomeProto242);
  a232.value = value;
  return a232;
};
var TypeId722 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto422 = {
  ...EffectPrototype242,
  [TypeId722]: {
    _R: (_232) => _232
  },
  [NodeInspectSymbol242]() {
    return this.toJSON();
  },
  toString() {
    return format242(this.toJSON());
  }
};
var RightProto242 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto422), {
  _tag: "Right",
  _op: "Right",
  [symbol422](that) {
    return isEither242(that) && isRight242(that) && equals242(this.right, that.right);
  },
  [symbol342]() {
    return combine332(hash242(this._tag))(hash242(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON242(this.right)
    };
  }
});
var LeftProto242 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto422), {
  _tag: "Left",
  _op: "Left",
  [symbol422](that) {
    return isEither242(that) && isLeft242(that) && equals242(this.left, that.left);
  },
  [symbol342]() {
    return combine332(hash242(this._tag))(hash242(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON242(this.left)
    };
  }
});
var isEither242 = (input) => hasProperty242(input, TypeId722);
var isLeft242 = (ma) => ma._tag === "Left";
var isRight242 = (ma) => ma._tag === "Right";
var left332 = (left522) => {
  const a232 = Object.create(LeftProto242);
  a232.left = left522;
  return a232;
};
var right332 = (right522) => {
  const a232 = Object.create(RightProto242);
  a232.right = right522;
  return a232;
};
var getLeft342 = (self2) => isRight242(self2) ? none342 : some522(self2.left);
var getRight342 = (self2) => isLeft242(self2) ? none342 : some522(self2.right);
var isLeft322 = isLeft242;
var isRight322 = isRight242;
var isNonEmptyArray32 = (self2) => self2.length > 0;
var Option_exports242 = {};
__export52(Option_exports242, {
  Do: () => Do242,
  TypeId: () => TypeId822,
  all: () => all422,
  andThen: () => andThen242,
  ap: () => ap242,
  as: () => as242,
  asVoid: () => asVoid242,
  bind: () => bind422,
  bindTo: () => bindTo422,
  composeK: () => composeK242,
  contains: () => contains242,
  containsWith: () => containsWith242,
  exists: () => exists242,
  filter: () => filter242,
  filterMap: () => filterMap242,
  firstSomeOf: () => firstSomeOf242,
  flatMap: () => flatMap242,
  flatMapNullable: () => flatMapNullable242,
  flatten: () => flatten242,
  fromIterable: () => fromIterable332,
  fromNullable: () => fromNullable242,
  gen: () => gen242,
  getEquivalence: () => getEquivalence332,
  getLeft: () => getLeft422,
  getOrElse: () => getOrElse242,
  getOrNull: () => getOrNull242,
  getOrThrow: () => getOrThrow242,
  getOrThrowWith: () => getOrThrowWith242,
  getOrUndefined: () => getOrUndefined242,
  getOrder: () => getOrder242,
  getRight: () => getRight422,
  isNone: () => isNone422,
  isOption: () => isOption422,
  isSome: () => isSome422,
  let: () => let_422,
  lift2: () => lift2242,
  liftNullable: () => liftNullable242,
  liftPredicate: () => liftPredicate242,
  liftThrowable: () => liftThrowable242,
  map: () => map242,
  match: () => match33,
  none: () => none422,
  orElse: () => orElse242,
  orElseEither: () => orElseEither242,
  orElseSome: () => orElseSome242,
  partitionMap: () => partitionMap242,
  product: () => product422,
  productMany: () => productMany422,
  reduceCompact: () => reduceCompact242,
  some: () => some622,
  tap: () => tap242,
  toArray: () => toArray242,
  toRefinement: () => toRefinement242,
  void: () => void_242,
  zipLeft: () => zipLeft242,
  zipRight: () => zipRight242,
  zipWith: () => zipWith242
});
var make822 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var number322 = /* @__PURE__ */ make822((self2, that) => self2 < that ? -1 : 1);
var combineMany22 = /* @__PURE__ */ dual242(2, (self2, collection) => make822((a1, a232) => {
  let out = self2(a1, a232);
  if (out !== 0) {
    return out;
  }
  for (const O232 of collection) {
    out = O232(a1, a232);
    if (out !== 0) {
      return out;
    }
  }
  return out;
}));
var empty832 = () => make822(() => 0);
var combineAll22 = (collection) => combineMany22(empty832(), collection);
var mapInput322 = /* @__PURE__ */ dual242(2, (self2, f232) => make822((b1, b232) => self2(f232(b1), f232(b232))));
var array422 = (O232) => make822((self2, that) => {
  const aLen = self2.length;
  const bLen = that.length;
  const len = Math.min(aLen, bLen);
  for (let i232 = 0; i232 < len; i232++) {
    const o232 = O232(self2[i232], that[i232]);
    if (o232 !== 0) {
      return o232;
    }
  }
  return number322(aLen, bLen);
});
var min32 = (O232) => dual242(2, (self2, that) => self2 === that || O232(self2, that) < 1 ? self2 : that);
var max32 = (O232) => dual242(2, (self2, that) => self2 === that || O232(self2, that) > -1 ? self2 : that);
var TypeId822 = /* @__PURE__ */ Symbol.for("effect/Option");
var none422 = () => none342;
var some622 = some522;
var isOption422 = isOption342;
var isNone422 = isNone342;
var isSome422 = isSome342;
var match33 = /* @__PURE__ */ dual242(2, (self2, {
  onNone,
  onSome
}) => isNone422(self2) ? onNone() : onSome(self2.value));
var toRefinement242 = (f232) => (a232) => isSome422(f232(a232));
var fromIterable332 = (collection) => {
  for (const a232 of collection) {
    return some622(a232);
  }
  return none422();
};
var getRight422 = getRight342;
var getLeft422 = getLeft342;
var getOrElse242 = /* @__PURE__ */ dual242(2, (self2, onNone) => isNone422(self2) ? onNone() : self2.value);
var orElse242 = /* @__PURE__ */ dual242(2, (self2, that) => isNone422(self2) ? that() : self2);
var orElseSome242 = /* @__PURE__ */ dual242(2, (self2, onNone) => isNone422(self2) ? some622(onNone()) : self2);
var orElseEither242 = /* @__PURE__ */ dual242(2, (self2, that) => isNone422(self2) ? map242(that(), right332) : map242(self2, left332));
var firstSomeOf242 = (collection) => {
  let out = none422();
  for (out of collection) {
    if (isSome422(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable242 = (nullableValue) => nullableValue == null ? none422() : some622(nullableValue);
var liftNullable242 = (f232) => (...a232) => fromNullable242(f232(...a232));
var getOrNull242 = /* @__PURE__ */ getOrElse242(constNull242);
var getOrUndefined242 = /* @__PURE__ */ getOrElse242(constUndefined242);
var liftThrowable242 = (f232) => (...a232) => {
  try {
    return some622(f232(...a232));
  } catch (e232) {
    return none422();
  }
};
var getOrThrowWith242 = /* @__PURE__ */ dual242(2, (self2, onNone) => {
  if (isSome422(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow242 = /* @__PURE__ */ getOrThrowWith242(() => new Error("getOrThrow called on a None"));
var map242 = /* @__PURE__ */ dual242(2, (self2, f232) => isNone422(self2) ? none422() : some622(f232(self2.value)));
var as242 = /* @__PURE__ */ dual242(2, (self2, b232) => map242(self2, () => b232));
var asVoid242 = /* @__PURE__ */ as242(void 0);
var void_242 = /* @__PURE__ */ some622(void 0);
var flatMap242 = /* @__PURE__ */ dual242(2, (self2, f232) => isNone422(self2) ? none422() : f232(self2.value));
var andThen242 = /* @__PURE__ */ dual242(2, (self2, f232) => flatMap242(self2, (a232) => {
  const b232 = isFunction43(f232) ? f232(a232) : f232;
  return isOption422(b232) ? b232 : some622(b232);
}));
var flatMapNullable242 = /* @__PURE__ */ dual242(2, (self2, f232) => isNone422(self2) ? none422() : fromNullable242(f232(self2.value)));
var flatten242 = /* @__PURE__ */ flatMap242(identity242);
var zipRight242 = /* @__PURE__ */ dual242(2, (self2, that) => flatMap242(self2, () => that));
var composeK242 = /* @__PURE__ */ dual242(2, (afb, bfc) => (a232) => flatMap242(afb(a232), bfc));
var zipLeft242 = /* @__PURE__ */ dual242(2, (self2, that) => tap242(self2, () => that));
var tap242 = /* @__PURE__ */ dual242(2, (self2, f232) => flatMap242(self2, (a232) => map242(f232(a232), () => a232)));
var product422 = (self2, that) => isSome422(self2) && isSome422(that) ? some622([self2.value, that.value]) : none422();
var productMany422 = (self2, collection) => {
  if (isNone422(self2)) {
    return none422();
  }
  const out = [self2.value];
  for (const o232 of collection) {
    if (isNone422(o232)) {
      return none422();
    }
    out.push(o232.value);
  }
  return some622(out);
};
var all422 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o232 of input) {
      if (isNone422(o232)) {
        return none422();
      }
      out2.push(o232.value);
    }
    return some622(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o232 = input[key];
    if (isNone422(o232)) {
      return none422();
    }
    out[key] = o232.value;
  }
  return some622(out);
};
var zipWith242 = /* @__PURE__ */ dual242(3, (self2, that, f232) => map242(product422(self2, that), ([a232, b232]) => f232(a232, b232)));
var ap242 = /* @__PURE__ */ dual242(2, (self2, that) => zipWith242(self2, that, (f232, a232) => f232(a232)));
var reduceCompact242 = /* @__PURE__ */ dual242(3, (self2, b232, f232) => {
  let out = b232;
  for (const oa of self2) {
    if (isSome422(oa)) {
      out = f232(out, oa.value);
    }
  }
  return out;
});
var toArray242 = (self2) => isNone422(self2) ? [] : [self2.value];
var partitionMap242 = /* @__PURE__ */ dual242(2, (self2, f232) => {
  if (isNone422(self2)) {
    return [none422(), none422()];
  }
  const e232 = f232(self2.value);
  return isLeft242(e232) ? [some622(e232.left), none422()] : [none422(), some622(e232.right)];
});
var filterMap242 = /* @__PURE__ */ dual242(2, (self2, f232) => isNone422(self2) ? none422() : f232(self2.value));
var filter242 = /* @__PURE__ */ dual242(2, (self2, predicate) => filterMap242(self2, (b232) => predicate(b232) ? some522(b232) : none342));
var getEquivalence332 = (isEquivalent) => make632((x232, y232) => x232 === y232 || (isNone422(x232) ? isNone422(y232) : isNone422(y232) ? false : isEquivalent(x232.value, y232.value)));
var getOrder242 = (O232) => make822((self2, that) => isSome422(self2) ? isSome422(that) ? O232(self2.value, that.value) : 1 : -1);
var lift2242 = (f232) => dual242(2, (self2, that) => zipWith242(self2, that, f232));
var liftPredicate242 = (predicate) => (b232) => predicate(b232) ? some622(b232) : none422();
var containsWith242 = (isEquivalent) => dual242(2, (self2, a232) => isNone422(self2) ? false : isEquivalent(self2.value, a232));
var _equivalence332 = /* @__PURE__ */ equivalence242();
var contains242 = /* @__PURE__ */ containsWith242(_equivalence332);
var exists242 = /* @__PURE__ */ dual242(2, (self2, refinement) => isNone422(self2) ? false : refinement(self2.value));
var bindTo422 = /* @__PURE__ */ bindTo342(map242);
var let_422 = /* @__PURE__ */ let_342(map242);
var bind422 = /* @__PURE__ */ bind342(map242, flatMap242);
var Do242 = /* @__PURE__ */ some622({});
var adapter422 = /* @__PURE__ */ adapter342();
var gen242 = (f232) => {
  const iterator = f232(adapter422);
  let state = iterator.next();
  if (state.done) {
    return some622(state.value);
  } else {
    let current = state.value;
    if (isGenKind242(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet242(current);
    }
    if (isNone422(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind242(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet242(current);
        }
        if (isNone422(current)) {
          return current;
        }
      }
    }
    return some622(state.value);
  }
};
var make922 = (...elements) => elements;
var findFirst32 = /* @__PURE__ */ dual242(2, (self2, f232) => {
  let i232 = 0;
  for (const a232 of self2) {
    const o232 = f232(a232, i232);
    if (isBoolean232(o232)) {
      if (o232) {
        return some622(a232);
      }
    } else {
      if (isSome422(o232)) {
        return o232;
      }
    }
    i232++;
  }
  return none422();
});
var collect22 = /* @__PURE__ */ dual242(2, (self2, f232) => {
  const out = [];
  for (const key of keys232(self2)) {
    out.push(f232(key, self2[key]));
  }
  return out;
});
var toEntries22 = /* @__PURE__ */ collect22((key, value) => [key, value]);
var keys232 = (self2) => Object.keys(self2);
var make1022 = (...elements) => elements;
var allocate22 = (n232) => new Array(n232);
var makeBy22 = (n232, f232) => {
  const max322 = Math.max(1, Math.floor(n232));
  const out = new Array(max322);
  for (let i232 = 0; i232 < max322; i232++) {
    out[i232] = f232(i232);
  }
  return out;
};
var range22 = (start, end) => start <= end ? makeBy22(end - start + 1, (i232) => start + i232) : [start];
var replicate22 = /* @__PURE__ */ dual242(2, (a232, n232) => makeBy22(n232, () => a232));
var fromIterable422 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var fromRecord22 = toEntries22;
var fromOption222 = toArray242;
var match422 = /* @__PURE__ */ dual242(2, (self2, {
  onEmpty,
  onNonEmpty
}) => isNonEmptyReadonlyArray22(self2) ? onNonEmpty(self2) : onEmpty());
var matchLeft22 = /* @__PURE__ */ dual242(2, (self2, {
  onEmpty,
  onNonEmpty
}) => isNonEmptyReadonlyArray22(self2) ? onNonEmpty(headNonEmpty232(self2), tailNonEmpty232(self2)) : onEmpty());
var matchRight22 = /* @__PURE__ */ dual242(2, (self2, {
  onEmpty,
  onNonEmpty
}) => isNonEmptyReadonlyArray22(self2) ? onNonEmpty(initNonEmpty22(self2), lastNonEmpty22(self2)) : onEmpty());
var prepend232 = /* @__PURE__ */ dual242(2, (self2, head222) => [head222, ...self2]);
var prependAll22 = /* @__PURE__ */ dual242(2, (self2, that) => fromIterable422(that).concat(fromIterable422(self2)));
var append32 = /* @__PURE__ */ dual242(2, (self2, last222) => [...self2, last222]);
var appendAll232 = /* @__PURE__ */ dual242(2, (self2, that) => fromIterable422(self2).concat(fromIterable422(that)));
var scan22 = /* @__PURE__ */ dual242(3, (self2, b232, f232) => {
  const out = [b232];
  let i232 = 0;
  for (const a232 of self2) {
    out[i232 + 1] = f232(out[i232], a232);
    i232++;
  }
  return out;
});
var scanRight22 = /* @__PURE__ */ dual242(3, (self2, b232, f232) => {
  const input = fromIterable422(self2);
  const out = new Array(input.length + 1);
  out[input.length] = b232;
  for (let i232 = input.length - 1; i232 >= 0; i232--) {
    out[i232] = f232(out[i232 + 1], input[i232]);
  }
  return out;
});
var isArray22 = Array.isArray;
var isEmptyArray22 = (self2) => self2.length === 0;
var isEmptyReadonlyArray22 = isEmptyArray22;
var isNonEmptyArray222 = isNonEmptyArray32;
var isNonEmptyReadonlyArray22 = isNonEmptyArray32;
var length32 = (self2) => self2.length;
var isOutOfBound22 = (i232, as422) => i232 < 0 || i232 >= as422.length;
var clamp22 = (i232, as422) => Math.floor(Math.min(Math.max(0, i232), as422.length));
var get52 = /* @__PURE__ */ dual242(2, (self2, index) => {
  const i232 = Math.floor(index);
  return isOutOfBound22(i232, self2) ? none422() : some622(self2[i232]);
});
var unsafeGet32 = /* @__PURE__ */ dual242(2, (self2, index) => {
  const i232 = Math.floor(index);
  if (isOutOfBound22(i232, self2)) {
    throw new Error(`Index ${i232} out of bounds`);
  }
  return self2[i232];
});
var unprepend22 = (self2) => [headNonEmpty232(self2), tailNonEmpty232(self2)];
var unappend22 = (self2) => [initNonEmpty22(self2), lastNonEmpty22(self2)];
var head32 = /* @__PURE__ */ get52(0);
var headNonEmpty232 = /* @__PURE__ */ unsafeGet32(0);
var last22 = (self2) => isNonEmptyReadonlyArray22(self2) ? some622(lastNonEmpty22(self2)) : none422();
var lastNonEmpty22 = (self2) => self2[self2.length - 1];
var tail32 = (self2) => {
  const input = fromIterable422(self2);
  return isNonEmptyReadonlyArray22(input) ? some622(tailNonEmpty232(input)) : none422();
};
var tailNonEmpty232 = (self2) => self2.slice(1);
var init22 = (self2) => {
  const input = fromIterable422(self2);
  return isNonEmptyReadonlyArray22(input) ? some622(initNonEmpty22(input)) : none422();
};
var initNonEmpty22 = (self2) => self2.slice(0, -1);
var take22 = /* @__PURE__ */ dual242(2, (self2, n232) => {
  const input = fromIterable422(self2);
  return input.slice(0, clamp22(n232, input));
});
var takeRight22 = /* @__PURE__ */ dual242(2, (self2, n232) => {
  const input = fromIterable422(self2);
  const i232 = clamp22(n232, input);
  return i232 === 0 ? [] : input.slice(-i232);
});
var takeWhile22 = /* @__PURE__ */ dual242(2, (self2, predicate) => {
  let i232 = 0;
  const out = [];
  for (const a232 of self2) {
    if (!predicate(a232, i232)) {
      break;
    }
    out.push(a232);
    i232++;
  }
  return out;
});
var spanIndex22 = (self2, predicate) => {
  let i232 = 0;
  for (const a232 of self2) {
    if (!predicate(a232, i232)) {
      break;
    }
    i232++;
  }
  return i232;
};
var span22 = /* @__PURE__ */ dual242(2, (self2, predicate) => splitAt22(self2, spanIndex22(self2, predicate)));
var drop232 = /* @__PURE__ */ dual242(2, (self2, n232) => {
  const input = fromIterable422(self2);
  return input.slice(clamp22(n232, input), input.length);
});
var dropRight22 = /* @__PURE__ */ dual242(2, (self2, n232) => {
  const input = fromIterable422(self2);
  return input.slice(0, input.length - clamp22(n232, input));
});
var dropWhile22 = /* @__PURE__ */ dual242(2, (self2, predicate) => fromIterable422(self2).slice(spanIndex22(self2, predicate)));
var findFirstIndex22 = /* @__PURE__ */ dual242(2, (self2, predicate) => {
  let i232 = 0;
  for (const a232 of self2) {
    if (predicate(a232, i232)) {
      return some622(i232);
    }
    i232++;
  }
  return none422();
});
var findLastIndex22 = /* @__PURE__ */ dual242(2, (self2, predicate) => {
  const input = fromIterable422(self2);
  for (let i232 = input.length - 1; i232 >= 0; i232--) {
    if (predicate(input[i232], i232)) {
      return some622(i232);
    }
  }
  return none422();
});
var findFirst222 = findFirst32;
var findLast22 = /* @__PURE__ */ dual242(2, (self2, f232) => {
  const input = fromIterable422(self2);
  for (let i232 = input.length - 1; i232 >= 0; i232--) {
    const a232 = input[i232];
    const o232 = f232(a232, i232);
    if (isBoolean232(o232)) {
      if (o232) {
        return some622(a232);
      }
    } else {
      if (isSome422(o232)) {
        return o232;
      }
    }
  }
  return none422();
});
var insertAt22 = /* @__PURE__ */ dual242(3, (self2, i232, b232) => {
  const out = Array.from(self2);
  if (i232 < 0 || i232 > out.length) {
    return none422();
  }
  out.splice(i232, 0, b232);
  return some622(out);
});
var replace222 = /* @__PURE__ */ dual242(3, (self2, i232, b232) => modify22(self2, i232, () => b232));
var replaceOption22 = /* @__PURE__ */ dual242(3, (self2, i232, b232) => modifyOption22(self2, i232, () => b232));
var modify22 = /* @__PURE__ */ dual242(3, (self2, i232, f232) => getOrElse242(modifyOption22(self2, i232, f232), () => Array.from(self2)));
var modifyOption22 = /* @__PURE__ */ dual242(3, (self2, i232, f232) => {
  const out = Array.from(self2);
  if (isOutOfBound22(i232, out)) {
    return none422();
  }
  const next = f232(out[i232]);
  out[i232] = next;
  return some622(out);
});
var remove32 = /* @__PURE__ */ dual242(2, (self2, i232) => {
  const out = Array.from(self2);
  if (isOutOfBound22(i232, out)) {
    return out;
  }
  out.splice(i232, 1);
  return out;
});
var reverse332 = (self2) => Array.from(self2).reverse();
var sort22 = /* @__PURE__ */ dual242(2, (self2, O232) => {
  const out = Array.from(self2);
  out.sort(O232);
  return out;
});
var sortWith22 = /* @__PURE__ */ dual242(3, (self2, f232, order) => sort22(self2, mapInput322(order, f232)));
var sortBy22 = (...orders) => {
  const sortByAll = sort22(combineAll22(orders));
  return (self2) => {
    const input = fromIterable422(self2);
    if (isNonEmptyReadonlyArray22(input)) {
      return sortByAll(input);
    }
    return [];
  };
};
var zip22 = /* @__PURE__ */ dual242(2, (self2, that) => zipWith322(self2, that, make922));
var zipWith322 = /* @__PURE__ */ dual242(3, (self2, that, f232) => {
  const as422 = fromIterable422(self2);
  const bs = fromIterable422(that);
  if (isNonEmptyReadonlyArray22(as422) && isNonEmptyReadonlyArray22(bs)) {
    const out = [f232(headNonEmpty232(as422), headNonEmpty232(bs))];
    const len = Math.min(as422.length, bs.length);
    for (let i232 = 1; i232 < len; i232++) {
      out[i232] = f232(as422[i232], bs[i232]);
    }
    return out;
  }
  return [];
});
var unzip22 = (self2) => {
  const input = fromIterable422(self2);
  if (isNonEmptyReadonlyArray22(input)) {
    const fa = [input[0][0]];
    const fb = [input[0][1]];
    for (let i232 = 1; i232 < input.length; i232++) {
      fa[i232] = input[i232][0];
      fb[i232] = input[i232][1];
    }
    return [fa, fb];
  }
  return [[], []];
};
var intersperse22 = /* @__PURE__ */ dual242(2, (self2, middle) => {
  const input = fromIterable422(self2);
  if (isNonEmptyReadonlyArray22(input)) {
    const out = [headNonEmpty232(input)];
    const tail222 = tailNonEmpty232(input);
    for (let i232 = 0; i232 < tail222.length; i232++) {
      if (i232 < tail222.length) {
        out.push(middle);
      }
      out.push(tail222[i232]);
    }
    return out;
  }
  return [];
});
var modifyNonEmptyHead22 = /* @__PURE__ */ dual242(2, (self2, f232) => [f232(headNonEmpty232(self2)), ...tailNonEmpty232(self2)]);
var setNonEmptyHead22 = /* @__PURE__ */ dual242(2, (self2, b232) => modifyNonEmptyHead22(self2, () => b232));
var modifyNonEmptyLast22 = /* @__PURE__ */ dual242(2, (self2, f232) => append32(initNonEmpty22(self2), f232(lastNonEmpty22(self2))));
var setNonEmptyLast22 = /* @__PURE__ */ dual242(2, (self2, b232) => modifyNonEmptyLast22(self2, () => b232));
var rotate22 = /* @__PURE__ */ dual242(2, (self2, n232) => {
  const input = fromIterable422(self2);
  if (isNonEmptyReadonlyArray22(input)) {
    const len = input.length;
    const m232 = Math.round(n232) % len;
    if (isOutOfBound22(Math.abs(m232), input) || m232 === 0) {
      return copy232(input);
    }
    if (m232 < 0) {
      const [f232, s232] = splitNonEmptyAt22(input, -m232);
      return appendAll232(s232, f232);
    } else {
      return rotate22(self2, m232 - len);
    }
  }
  return [];
});
var containsWith322 = (isEquivalent) => dual242(2, (self2, a232) => {
  for (const i232 of self2) {
    if (isEquivalent(a232, i232)) {
      return true;
    }
  }
  return false;
});
var _equivalence422 = /* @__PURE__ */ equivalence242();
var contains322 = /* @__PURE__ */ containsWith322(_equivalence422);
var chop22 = /* @__PURE__ */ dual242(2, (self2, f232) => {
  const input = fromIterable422(self2);
  if (isNonEmptyReadonlyArray22(input)) {
    const [b232, rest] = f232(input);
    const out = [b232];
    let next = rest;
    while (isNonEmptyArray32(next)) {
      const [b322, rest2] = f232(next);
      out.push(b322);
      next = rest2;
    }
    return out;
  }
  return [];
});
var splitAt22 = /* @__PURE__ */ dual242(2, (self2, n232) => {
  const input = Array.from(self2);
  const _n = Math.floor(n232);
  if (isNonEmptyReadonlyArray22(input)) {
    if (_n >= 1) {
      return splitNonEmptyAt22(input, _n);
    }
    return [[], input];
  }
  return [input, []];
});
var splitNonEmptyAt22 = /* @__PURE__ */ dual242(2, (self2, n232) => {
  const _n = Math.max(1, Math.floor(n232));
  return _n >= self2.length ? [copy232(self2), []] : [prepend232(self2.slice(1, _n), headNonEmpty232(self2)), self2.slice(_n)];
});
var split22 = /* @__PURE__ */ dual242(2, (self2, n232) => {
  const input = fromIterable422(self2);
  return chunksOf22(input, Math.ceil(input.length / Math.floor(n232)));
});
var splitWhere22 = /* @__PURE__ */ dual242(2, (self2, predicate) => span22(self2, (a232, i232) => !predicate(a232, i232)));
var copy232 = (self2) => self2.slice();
var chunksOf22 = /* @__PURE__ */ dual242(2, (self2, n232) => {
  const input = fromIterable422(self2);
  if (isNonEmptyReadonlyArray22(input)) {
    return chop22(input, splitNonEmptyAt22(n232));
  }
  return [];
});
var groupWith22 = /* @__PURE__ */ dual242(2, (self2, isEquivalent) => chop22(self2, (as422) => {
  const h232 = headNonEmpty232(as422);
  const out = [h232];
  let i232 = 1;
  for (; i232 < as422.length; i232++) {
    const a232 = as422[i232];
    if (isEquivalent(a232, h232)) {
      out.push(a232);
    } else {
      break;
    }
  }
  return [out, as422.slice(i232)];
}));
var group22 = /* @__PURE__ */ groupWith22(/* @__PURE__ */ equivalence242());
var groupBy22 = /* @__PURE__ */ dual242(2, (self2, f232) => {
  const out = {};
  for (const a232 of self2) {
    const k232 = f232(a232);
    if (Object.prototype.hasOwnProperty.call(out, k232)) {
      out[k232].push(a232);
    } else {
      out[k232] = [a232];
    }
  }
  return out;
});
var unionWith22 = /* @__PURE__ */ dual242(3, (self2, that, isEquivalent) => {
  const a232 = fromIterable422(self2);
  const b232 = fromIterable422(that);
  if (isNonEmptyReadonlyArray22(a232)) {
    if (isNonEmptyReadonlyArray22(b232)) {
      const dedupe222 = dedupeWith22(isEquivalent);
      return dedupe222(appendAll232(a232, b232));
    }
    return a232;
  }
  return b232;
});
var union42 = /* @__PURE__ */ dual242(2, (self2, that) => unionWith22(self2, that, _equivalence422));
var intersectionWith22 = (isEquivalent) => {
  const has22 = containsWith322(isEquivalent);
  return dual242(2, (self2, that) => fromIterable422(self2).filter((a232) => has22(that, a232)));
};
var intersection22 = /* @__PURE__ */ intersectionWith22(_equivalence422);
var differenceWith22 = (isEquivalent) => {
  const has22 = containsWith322(isEquivalent);
  return dual242(2, (self2, that) => fromIterable422(self2).filter((a232) => !has22(that, a232)));
};
var difference22 = /* @__PURE__ */ differenceWith22(_equivalence422);
var empty922 = () => [];
var of232 = (a232) => [a232];
var map322 = /* @__PURE__ */ dual242(2, (self2, f232) => self2.map(f232));
var flatMap322 = /* @__PURE__ */ dual242(2, (self2, f232) => {
  if (isEmptyReadonlyArray22(self2)) {
    return [];
  }
  const out = [];
  for (let i232 = 0; i232 < self2.length; i232++) {
    const inner = f232(self2[i232], i232);
    for (let j232 = 0; j232 < inner.length; j232++) {
      out.push(inner[j232]);
    }
  }
  return out;
});
var flatten322 = /* @__PURE__ */ flatMap322(identity242);
var filterMap322 = /* @__PURE__ */ dual242(2, (self2, f232) => {
  const as422 = fromIterable422(self2);
  const out = [];
  for (let i232 = 0; i232 < as422.length; i232++) {
    const o232 = f232(as422[i232], i232);
    if (isSome422(o232)) {
      out.push(o232.value);
    }
  }
  return out;
});
var filterMapWhile22 = /* @__PURE__ */ dual242(2, (self2, f232) => {
  let i232 = 0;
  const out = [];
  for (const a232 of self2) {
    const b232 = f232(a232, i232);
    if (isSome422(b232)) {
      out.push(b232.value);
    } else {
      break;
    }
    i232++;
  }
  return out;
});
var partitionMap322 = /* @__PURE__ */ dual242(2, (self2, f232) => {
  const left522 = [];
  const right522 = [];
  const as422 = fromIterable422(self2);
  for (let i232 = 0; i232 < as422.length; i232++) {
    const e232 = f232(as422[i232], i232);
    if (isLeft322(e232)) {
      left522.push(e232.left);
    } else {
      right522.push(e232.right);
    }
  }
  return [left522, right522];
});
var getSomes22 = /* @__PURE__ */ filterMap322(identity242);
var getLefts22 = (self2) => {
  const out = [];
  for (const a232 of self2) {
    if (isLeft322(a232)) {
      out.push(a232.left);
    }
  }
  return out;
};
var getRights22 = (self2) => {
  const out = [];
  for (const a232 of self2) {
    if (isRight322(a232)) {
      out.push(a232.right);
    }
  }
  return out;
};
var filter322 = /* @__PURE__ */ dual242(2, (self2, predicate) => {
  const as422 = fromIterable422(self2);
  const out = [];
  for (let i232 = 0; i232 < as422.length; i232++) {
    if (predicate(as422[i232], i232)) {
      out.push(as422[i232]);
    }
  }
  return out;
});
var partition22 = /* @__PURE__ */ dual242(2, (self2, predicate) => {
  const left522 = [];
  const right522 = [];
  const as422 = fromIterable422(self2);
  for (let i232 = 0; i232 < as422.length; i232++) {
    if (predicate(as422[i232], i232)) {
      right522.push(as422[i232]);
    } else {
      left522.push(as422[i232]);
    }
  }
  return [left522, right522];
});
var separate22 = /* @__PURE__ */ partitionMap322(identity242);
var reduce332 = /* @__PURE__ */ dual242(3, (self2, b232, f232) => fromIterable422(self2).reduce((b322, a232, i232) => f232(b322, a232, i232), b232));
var reduceRight22 = /* @__PURE__ */ dual242(3, (self2, b232, f232) => fromIterable422(self2).reduceRight((b322, a232, i232) => f232(b322, a232, i232), b232));
var liftPredicate322 = (predicate) => (b232) => predicate(b232) ? [b232] : [];
var liftOption22 = (f232) => (...a232) => fromOption222(f232(...a232));
var fromNullable322 = (a232) => a232 == null ? empty922() : [a232];
var liftNullable322 = (f232) => (...a232) => fromNullable322(f232(...a232));
var flatMapNullable322 = /* @__PURE__ */ dual242(2, (self2, f232) => flatMap322(self2, (a232) => fromNullable322(f232(a232))));
var liftEither22 = (f232) => (...a232) => {
  const e232 = f232(...a232);
  return isLeft322(e232) ? [] : [e232.right];
};
var every322 = /* @__PURE__ */ dual242(2, (self2, refinement) => self2.every(refinement));
var some722 = /* @__PURE__ */ dual242(2, (self2, predicate) => self2.some(predicate));
var extend22 = /* @__PURE__ */ dual242(2, (self2, f232) => self2.map((_232, i232, as422) => f232(as422.slice(i232))));
var min222 = /* @__PURE__ */ dual242(2, (self2, O232) => self2.reduce(min32(O232)));
var max222 = /* @__PURE__ */ dual242(2, (self2, O232) => self2.reduce(max32(O232)));
var unfold22 = (b232, f232) => {
  const out = [];
  let next = b232;
  let o232;
  while (isSome422(o232 = f232(next))) {
    const [a232, b322] = o232.value;
    out.push(a232);
    next = b322;
  }
  return out;
};
var getOrder322 = array422;
var getEquivalence422 = array332;
var forEach332 = /* @__PURE__ */ dual242(2, (self2, f232) => fromIterable422(self2).forEach((a232, i232) => f232(a232, i232)));
var dedupeWith22 = /* @__PURE__ */ dual242(2, (self2, isEquivalent) => {
  const input = fromIterable422(self2);
  if (isNonEmptyReadonlyArray22(input)) {
    const out = [headNonEmpty232(input)];
    const rest = tailNonEmpty232(input);
    for (const r232 of rest) {
      if (out.every((a232) => !isEquivalent(r232, a232))) {
        out.push(r232);
      }
    }
    return out;
  }
  return [];
});
var dedupe22 = (self2) => dedupeWith22(self2, equivalence242());
var dedupeAdjacentWith22 = /* @__PURE__ */ dual242(2, (self2, isEquivalent) => {
  const out = [];
  let lastA = none422();
  for (const a232 of self2) {
    if (isNone422(lastA) || !isEquivalent(a232, lastA.value)) {
      out.push(a232);
      lastA = some622(a232);
    }
  }
  return out;
});
var dedupeAdjacent22 = /* @__PURE__ */ dedupeAdjacentWith22(/* @__PURE__ */ equivalence242());
var join23 = /* @__PURE__ */ dual242(2, (self2, sep2) => fromIterable422(self2).join(sep2));
var mapAccum22 = /* @__PURE__ */ dual242(3, (self2, s232, f232) => {
  let i232 = 0;
  let s1 = s232;
  const out = [];
  for (const a232 of self2) {
    const r232 = f232(s1, a232, i232);
    s1 = r232[0];
    out.push(r232[1]);
    i232++;
  }
  return [s1, out];
});
var cartesianWith22 = /* @__PURE__ */ dual242(3, (self2, that, f232) => flatMap322(self2, (a232) => map322(that, (b232) => f232(a232, b232))));
var cartesian22 = /* @__PURE__ */ dual242(2, (self2, that) => cartesianWith22(self2, that, (a232, b232) => [a232, b232]));
var Do322 = /* @__PURE__ */ of232({});
var bind522 = /* @__PURE__ */ bind342(map322, flatMap322);
var bindTo522 = /* @__PURE__ */ bindTo342(map322);
var let_522 = /* @__PURE__ */ let_342(map322);
var __defProp332 = Object.defineProperty;
var __export332 = (target, all3232) => {
  for (var name22 in all3232)
    __defProp332(target, name22, { get: all3232[name22], enumerable: true });
};
var Function_exports322 = {};
__export332(Function_exports322, {
  SK: () => SK322,
  absurd: () => absurd322,
  apply: () => apply322,
  compose: () => compose522,
  constFalse: () => constFalse322,
  constNull: () => constNull322,
  constTrue: () => constTrue322,
  constUndefined: () => constUndefined322,
  constVoid: () => constVoid322,
  constant: () => constant322,
  dual: () => dual322,
  flip: () => flip322,
  flow: () => flow322,
  hole: () => hole322,
  identity: () => identity322,
  isFunction: () => isFunction622,
  pipe: () => pipe322,
  satisfies: () => satisfies322,
  tupled: () => tupled322,
  unsafeCoerce: () => unsafeCoerce322,
  untupled: () => untupled322
});
var isFunction622 = (input) => typeof input === "function";
var dual322 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a232, b232) {
        if (arguments.length >= 2) {
          return body(a232, b232);
        }
        return function(self2) {
          return body(self2, a232);
        };
      };
    case 3:
      return function(a232, b232, c232) {
        if (arguments.length >= 3) {
          return body(a232, b232, c232);
        }
        return function(self2) {
          return body(self2, a232, b232);
        };
      };
    case 4:
      return function(a232, b232, c232, d232) {
        if (arguments.length >= 4) {
          return body(a232, b232, c232, d232);
        }
        return function(self2) {
          return body(self2, a232, b232, c232);
        };
      };
    case 5:
      return function(a232, b232, c232, d232, e232) {
        if (arguments.length >= 5) {
          return body(a232, b232, c232, d232, e232);
        }
        return function(self2) {
          return body(self2, a232, b232, c232, d232);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply322 = (a232) => (self2) => self2(a232);
var identity322 = (a232) => a232;
var satisfies322 = () => (b232) => b232;
var unsafeCoerce322 = identity322;
var constant322 = (value) => () => value;
var constTrue322 = /* @__PURE__ */ constant322(true);
var constFalse322 = /* @__PURE__ */ constant322(false);
var constNull322 = /* @__PURE__ */ constant322(null);
var constUndefined322 = /* @__PURE__ */ constant322(void 0);
var constVoid322 = constUndefined322;
var flip322 = (f232) => (...b232) => (...a232) => f232(...a232)(...b232);
var compose522 = /* @__PURE__ */ dual322(2, (ab, bc) => (a232) => bc(ab(a232)));
var absurd322 = (_232) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled322 = (f232) => (a232) => f232(...a232);
var untupled322 = (f232) => (...a232) => f232(a232);
function pipe322(a232, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a232;
    case 2:
      return ab(a232);
    case 3:
      return bc(ab(a232));
    case 4:
      return cd(bc(ab(a232)));
    case 5:
      return de(cd(bc(ab(a232))));
    case 6:
      return ef(de(cd(bc(ab(a232)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a232))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a232)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a232))))))));
    default: {
      let ret = arguments[0];
      for (let i232 = 1; i232 < arguments.length; i232++) {
        ret = arguments[i232](ret);
      }
      return ret;
    }
  }
}
function flow322(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole322 = /* @__PURE__ */ unsafeCoerce322(absurd322);
var SK322 = (_232, b232) => b232;
var make1122 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_622 = (map3222) => dual322(3, (self2, name22, f232) => map3222(self2, (a232) => Object.assign({}, a232, {
  [name22]: f232(a232)
})));
var bindTo622 = (map3222) => dual322(2, (self2, name22) => map3222(self2, (a232) => ({
  [name22]: a232
})));
var bind622 = (map3222, flatMap3222) => dual322(3, (self2, name22, f232) => flatMap3222(self2, (a232) => map3222(f232(a232), (b232) => Object.assign({}, a232, {
  [name22]: b232
}))));
var moduleVersion322 = "3.2.8";
var getCurrentVersion322 = () => moduleVersion322;
var globalStoreId322 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion322()}`);
if (!(globalStoreId322 in globalThis)) {
  globalThis[globalStoreId322] = /* @__PURE__ */ new Map();
}
var globalStore322 = globalThis[globalStoreId322];
var globalValue322 = (id, compute) => {
  if (!globalStore322.has(id)) {
    globalStore322.set(id, compute());
  }
  return globalStore322.get(id);
};
var isFunction2242 = isFunction622;
var isRecordOrArray322 = (input) => typeof input === "object" && input !== null;
var isObject322 = (input) => isRecordOrArray322(input) || isFunction2242(input);
var hasProperty322 = /* @__PURE__ */ dual322(2, (self2, property) => isObject322(self2) && property in self2);
var isNullable322 = (input) => input === null || input === void 0;
var getBugErrorMessage322 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId322 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind322 = (u232) => isObject322(u232) && GenKindTypeId322 in u232;
var GenKindImpl322 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity322;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId322] = GenKindTypeId322;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen422(this);
  }
};
var SingleShotGen422 = class _SingleShotGen342 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a232) {
    return this.called ? {
      value: a232,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a232) {
    return {
      value: a232,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e232) {
    throw e232;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen342(this.self);
  }
};
var adapter522 = () => function() {
  let x232 = arguments[0];
  for (let i232 = 1; i232 < arguments.length; i232++) {
    x232 = arguments[i232](x232);
  }
  return new GenKindImpl322(x232);
};
var defaultIncHi322 = 335903614;
var defaultIncLo322 = 4150755663;
var MUL_HI322 = 1481765933 >>> 0;
var MUL_LO322 = 1284865837 >>> 0;
var BIT_53322 = 9007199254740992;
var BIT_27322 = 134217728;
var PCGRandom322 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable322(seedLo) && isNullable322(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable322(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable322(incLo) && isNullable322(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo322;
      incHi = this._state ? this._state[2] : defaultIncHi322;
    } else if (isNullable322(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add64322(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max322) {
    if (!max322) {
      return this._next();
    }
    max322 = max322 >>> 0;
    if ((max322 & max322 - 1) === 0) {
      return this._next() & max322 - 1;
    }
    let num = 0;
    const skew = (-max322 >>> 0) % max322 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max322;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_27322 + lo) / BIT_53322;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul64322(this._state, oldHi, oldLo, MUL_HI322, MUL_LO322);
    add64322(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul64322(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add64322(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId322 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap322 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId322]() {
    return this.#value;
  }
};
function yieldWrapGet322(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId322 in self2) {
    return self2[YieldWrapTypeId322]();
  }
  throw new Error(getBugErrorMessage322("yieldWrapGet"));
}
var structuralRegionState322 = /* @__PURE__ */ globalValue322("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache322 = /* @__PURE__ */ globalValue322(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr322 = /* @__PURE__ */ globalValue322(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom322());
var symbol522 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash322 = (self2) => {
  if (structuralRegionState322.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number422(self2);
    case "bigint":
      return string322(self2.toString(10));
    case "boolean":
      return string322(String(self2));
    case "symbol":
      return string322(String(self2));
    case "string":
      return string322(self2);
    case "undefined":
      return string322("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string322("null");
      } else if (self2 instanceof Date) {
        return hash322(self2.toISOString());
      } else if (isHash322(self2)) {
        return self2[symbol522]();
      } else {
        return random322(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random322 = (self2) => {
  if (!randomHashCache322.has(self2)) {
    randomHashCache322.set(self2, number422(pcgr322.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache322.get(self2);
};
var combine422 = (b232) => (self2) => self2 * 53 ^ b232;
var optimize322 = (n232) => n232 & 3221225471 | n232 >>> 1 & 1073741824;
var isHash322 = (u232) => hasProperty322(u232, symbol522);
var number422 = (n232) => {
  if (n232 !== n232 || n232 === Infinity) {
    return 0;
  }
  let h232 = n232 | 0;
  if (h232 !== n232) {
    h232 ^= n232 * 4294967295;
  }
  while (n232 > 4294967295) {
    h232 ^= n232 /= 4294967295;
  }
  return optimize322(n232);
};
var string322 = (str) => {
  let h232 = 5381, i232 = str.length;
  while (i232) {
    h232 = h232 * 33 ^ str.charCodeAt(--i232);
  }
  return optimize322(h232);
};
var cached322 = function() {
  if (arguments.length === 1) {
    const self3 = arguments[0];
    return function(hash422) {
      Object.defineProperty(self3, symbol522, {
        value() {
          return hash422;
        },
        enumerable: false
      });
      return hash422;
    };
  }
  const self2 = arguments[0];
  const hash3222 = arguments[1];
  Object.defineProperty(self2, symbol522, {
    value() {
      return hash3222;
    },
    enumerable: false
  });
  return hash3222;
};
var symbol2242 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals322() {
  if (arguments.length === 1) {
    return (self2) => compareBoth322(self2, arguments[0]);
  }
  return compareBoth322(arguments[0], arguments[1]);
}
function compareBoth322(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual322(self2) && isEqual322(that)) {
        if (hash322(self2) === hash322(that) && self2[symbol2242](that)) {
          return true;
        } else {
          return structuralRegionState322.enabled && structuralRegionState322.tester ? structuralRegionState322.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState322.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v232, i232) => compareBoth322(v232, that[i232]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth322(self2[key], that[key]))) {
              return structuralRegionState322.tester ? structuralRegionState322.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState322.tester ? structuralRegionState322.tester(self2, that) : false;
    }
  }
  return structuralRegionState322.enabled && structuralRegionState322.tester ? structuralRegionState322.tester(self2, that) : false;
}
var isEqual322 = (u232) => hasProperty322(u232, symbol2242);
var equivalence322 = () => equals322;
var NodeInspectSymbol322 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON322 = (x232) => {
  if (hasProperty322(x232, "toJSON") && isFunction2242(x232["toJSON"]) && x232["toJSON"].length === 0) {
    return x232.toJSON();
  } else if (Array.isArray(x232)) {
    return x232.map(toJSON322);
  }
  return x232;
};
var format322 = (x232) => JSON.stringify(x232, null, 2);
var pipeArguments322 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i232 = 0, len = args.length; i232 < len; i232++) {
        ret = args[i232](ret);
      }
      return ret;
    }
  }
};
var EffectTypeId422 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId322 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId322 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId322 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance322 = {
  /* c8 ignore next */
  _R: (_232) => _232,
  /* c8 ignore next */
  _E: (_232) => _232,
  /* c8 ignore next */
  _A: (_232) => _232,
  _V: /* @__PURE__ */ getCurrentVersion322()
};
var sinkVariance322 = {
  /* c8 ignore next */
  _A: (_232) => _232,
  /* c8 ignore next */
  _In: (_232) => _232,
  /* c8 ignore next */
  _L: (_232) => _232,
  /* c8 ignore next */
  _E: (_232) => _232,
  /* c8 ignore next */
  _R: (_232) => _232
};
var channelVariance322 = {
  /* c8 ignore next */
  _Env: (_232) => _232,
  /* c8 ignore next */
  _InErr: (_232) => _232,
  /* c8 ignore next */
  _InElem: (_232) => _232,
  /* c8 ignore next */
  _InDone: (_232) => _232,
  /* c8 ignore next */
  _OutErr: (_232) => _232,
  /* c8 ignore next */
  _OutElem: (_232) => _232,
  /* c8 ignore next */
  _OutDone: (_232) => _232
};
var EffectPrototype322 = {
  [EffectTypeId422]: effectVariance322,
  [StreamTypeId322]: effectVariance322,
  [SinkTypeId322]: sinkVariance322,
  [ChannelTypeId322]: channelVariance322,
  [symbol2242](that) {
    return this === that;
  },
  [symbol522]() {
    return cached322(this, random322(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen422(new YieldWrap322(this));
  },
  pipe() {
    return pipeArguments322(this, arguments);
  }
};
var TypeId922 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto522 = {
  ...EffectPrototype322,
  [TypeId922]: {
    _A: (_232) => _232
  },
  [NodeInspectSymbol322]() {
    return this.toJSON();
  },
  toString() {
    return format322(this.toJSON());
  }
};
var SomeProto322 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto522), {
  _tag: "Some",
  _op: "Some",
  [symbol2242](that) {
    return isOption522(that) && isSome522(that) && equals322(this.value, that.value);
  },
  [symbol522]() {
    return cached322(this, combine422(hash322(this._tag))(hash322(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON322(this.value)
    };
  }
});
var NoneHash322 = /* @__PURE__ */ hash322("None");
var NoneProto322 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto522), {
  _tag: "None",
  _op: "None",
  [symbol2242](that) {
    return isOption522(that) && isNone522(that);
  },
  [symbol522]() {
    return NoneHash322;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption522 = (input) => hasProperty322(input, TypeId922);
var isNone522 = (fa) => fa._tag === "None";
var isSome522 = (fa) => fa._tag === "Some";
var none522 = /* @__PURE__ */ Object.create(NoneProto322);
var some822 = (value) => {
  const a232 = Object.create(SomeProto322);
  a232.value = value;
  return a232;
};
var TypeId2242 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto2242 = {
  ...EffectPrototype322,
  [TypeId2242]: {
    _R: (_232) => _232
  },
  [NodeInspectSymbol322]() {
    return this.toJSON();
  },
  toString() {
    return format322(this.toJSON());
  }
};
var RightProto322 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto2242), {
  _tag: "Right",
  _op: "Right",
  [symbol2242](that) {
    return isEither322(that) && isRight422(that) && equals322(this.right, that.right);
  },
  [symbol522]() {
    return combine422(hash322(this._tag))(hash322(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON322(this.right)
    };
  }
});
var LeftProto322 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto2242), {
  _tag: "Left",
  _op: "Left",
  [symbol2242](that) {
    return isEither322(that) && isLeft422(that) && equals322(this.left, that.left);
  },
  [symbol522]() {
    return combine422(hash322(this._tag))(hash322(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON322(this.left)
    };
  }
});
var isEither322 = (input) => hasProperty322(input, TypeId2242);
var isLeft422 = (ma) => ma._tag === "Left";
var isRight422 = (ma) => ma._tag === "Right";
var left422 = (left3232) => {
  const a232 = Object.create(LeftProto322);
  a232.left = left3232;
  return a232;
};
var right422 = (right3232) => {
  const a232 = Object.create(RightProto322);
  a232.right = right3232;
  return a232;
};
var getLeft522 = (self2) => isRight422(self2) ? none522 : some822(self2.left);
var getRight522 = (self2) => isLeft422(self2) ? none522 : some822(self2.right);
var Option_exports322 = {};
__export332(Option_exports322, {
  Do: () => Do422,
  TypeId: () => TypeId3242,
  all: () => all522,
  andThen: () => andThen322,
  ap: () => ap322,
  as: () => as322,
  asVoid: () => asVoid322,
  bind: () => bind2242,
  bindTo: () => bindTo2242,
  composeK: () => composeK322,
  contains: () => contains422,
  containsWith: () => containsWith422,
  exists: () => exists322,
  filter: () => filter422,
  filterMap: () => filterMap422,
  firstSomeOf: () => firstSomeOf322,
  flatMap: () => flatMap422,
  flatMapNullable: () => flatMapNullable422,
  flatten: () => flatten422,
  fromIterable: () => fromIterable522,
  fromNullable: () => fromNullable422,
  gen: () => gen322,
  getEquivalence: () => getEquivalence522,
  getLeft: () => getLeft2242,
  getOrElse: () => getOrElse322,
  getOrNull: () => getOrNull322,
  getOrThrow: () => getOrThrow322,
  getOrThrowWith: () => getOrThrowWith322,
  getOrUndefined: () => getOrUndefined322,
  getOrder: () => getOrder422,
  getRight: () => getRight2242,
  isNone: () => isNone2242,
  isOption: () => isOption2242,
  isSome: () => isSome2242,
  let: () => let_2242,
  lift2: () => lift2322,
  liftNullable: () => liftNullable422,
  liftPredicate: () => liftPredicate422,
  liftThrowable: () => liftThrowable322,
  map: () => map422,
  match: () => match522,
  none: () => none2242,
  orElse: () => orElse322,
  orElseEither: () => orElseEither322,
  orElseSome: () => orElseSome322,
  partitionMap: () => partitionMap422,
  product: () => product522,
  productMany: () => productMany522,
  reduceCompact: () => reduceCompact322,
  some: () => some2242,
  tap: () => tap322,
  toArray: () => toArray322,
  toRefinement: () => toRefinement322,
  void: () => void_322,
  zipLeft: () => zipLeft322,
  zipRight: () => zipRight322,
  zipWith: () => zipWith422
});
var make2242 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId3242 = /* @__PURE__ */ Symbol.for("effect/Option");
var none2242 = () => none522;
var some2242 = some822;
var isOption2242 = isOption522;
var isNone2242 = isNone522;
var isSome2242 = isSome522;
var match522 = /* @__PURE__ */ dual322(2, (self2, {
  onNone,
  onSome
}) => isNone2242(self2) ? onNone() : onSome(self2.value));
var toRefinement322 = (f232) => (a232) => isSome2242(f232(a232));
var fromIterable522 = (collection) => {
  for (const a232 of collection) {
    return some2242(a232);
  }
  return none2242();
};
var getRight2242 = getRight522;
var getLeft2242 = getLeft522;
var getOrElse322 = /* @__PURE__ */ dual322(2, (self2, onNone) => isNone2242(self2) ? onNone() : self2.value);
var orElse322 = /* @__PURE__ */ dual322(2, (self2, that) => isNone2242(self2) ? that() : self2);
var orElseSome322 = /* @__PURE__ */ dual322(2, (self2, onNone) => isNone2242(self2) ? some2242(onNone()) : self2);
var orElseEither322 = /* @__PURE__ */ dual322(2, (self2, that) => isNone2242(self2) ? map422(that(), right422) : map422(self2, left422));
var firstSomeOf322 = (collection) => {
  let out = none2242();
  for (out of collection) {
    if (isSome2242(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable422 = (nullableValue) => nullableValue == null ? none2242() : some2242(nullableValue);
var liftNullable422 = (f232) => (...a232) => fromNullable422(f232(...a232));
var getOrNull322 = /* @__PURE__ */ getOrElse322(constNull322);
var getOrUndefined322 = /* @__PURE__ */ getOrElse322(constUndefined322);
var liftThrowable322 = (f232) => (...a232) => {
  try {
    return some2242(f232(...a232));
  } catch (e232) {
    return none2242();
  }
};
var getOrThrowWith322 = /* @__PURE__ */ dual322(2, (self2, onNone) => {
  if (isSome2242(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow322 = /* @__PURE__ */ getOrThrowWith322(() => new Error("getOrThrow called on a None"));
var map422 = /* @__PURE__ */ dual322(2, (self2, f232) => isNone2242(self2) ? none2242() : some2242(f232(self2.value)));
var as322 = /* @__PURE__ */ dual322(2, (self2, b232) => map422(self2, () => b232));
var asVoid322 = /* @__PURE__ */ as322(void 0);
var void_322 = /* @__PURE__ */ some2242(void 0);
var flatMap422 = /* @__PURE__ */ dual322(2, (self2, f232) => isNone2242(self2) ? none2242() : f232(self2.value));
var andThen322 = /* @__PURE__ */ dual322(2, (self2, f232) => flatMap422(self2, (a232) => {
  const b232 = isFunction622(f232) ? f232(a232) : f232;
  return isOption2242(b232) ? b232 : some2242(b232);
}));
var flatMapNullable422 = /* @__PURE__ */ dual322(2, (self2, f232) => isNone2242(self2) ? none2242() : fromNullable422(f232(self2.value)));
var flatten422 = /* @__PURE__ */ flatMap422(identity322);
var zipRight322 = /* @__PURE__ */ dual322(2, (self2, that) => flatMap422(self2, () => that));
var composeK322 = /* @__PURE__ */ dual322(2, (afb, bfc) => (a232) => flatMap422(afb(a232), bfc));
var zipLeft322 = /* @__PURE__ */ dual322(2, (self2, that) => tap322(self2, () => that));
var tap322 = /* @__PURE__ */ dual322(2, (self2, f232) => flatMap422(self2, (a232) => map422(f232(a232), () => a232)));
var product522 = (self2, that) => isSome2242(self2) && isSome2242(that) ? some2242([self2.value, that.value]) : none2242();
var productMany522 = (self2, collection) => {
  if (isNone2242(self2)) {
    return none2242();
  }
  const out = [self2.value];
  for (const o232 of collection) {
    if (isNone2242(o232)) {
      return none2242();
    }
    out.push(o232.value);
  }
  return some2242(out);
};
var all522 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o232 of input) {
      if (isNone2242(o232)) {
        return none2242();
      }
      out2.push(o232.value);
    }
    return some2242(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o232 = input[key];
    if (isNone2242(o232)) {
      return none2242();
    }
    out[key] = o232.value;
  }
  return some2242(out);
};
var zipWith422 = /* @__PURE__ */ dual322(3, (self2, that, f232) => map422(product522(self2, that), ([a232, b232]) => f232(a232, b232)));
var ap322 = /* @__PURE__ */ dual322(2, (self2, that) => zipWith422(self2, that, (f232, a232) => f232(a232)));
var reduceCompact322 = /* @__PURE__ */ dual322(3, (self2, b232, f232) => {
  let out = b232;
  for (const oa of self2) {
    if (isSome2242(oa)) {
      out = f232(out, oa.value);
    }
  }
  return out;
});
var toArray322 = (self2) => isNone2242(self2) ? [] : [self2.value];
var partitionMap422 = /* @__PURE__ */ dual322(2, (self2, f232) => {
  if (isNone2242(self2)) {
    return [none2242(), none2242()];
  }
  const e232 = f232(self2.value);
  return isLeft422(e232) ? [some2242(e232.left), none2242()] : [none2242(), some2242(e232.right)];
});
var filterMap422 = /* @__PURE__ */ dual322(2, (self2, f232) => isNone2242(self2) ? none2242() : f232(self2.value));
var filter422 = /* @__PURE__ */ dual322(2, (self2, predicate) => filterMap422(self2, (b232) => predicate(b232) ? some822(b232) : none522));
var getEquivalence522 = (isEquivalent) => make1122((x232, y232) => x232 === y232 || (isNone2242(x232) ? isNone2242(y232) : isNone2242(y232) ? false : isEquivalent(x232.value, y232.value)));
var getOrder422 = (O232) => make2242((self2, that) => isSome2242(self2) ? isSome2242(that) ? O232(self2.value, that.value) : 1 : -1);
var lift2322 = (f232) => dual322(2, (self2, that) => zipWith422(self2, that, f232));
var liftPredicate422 = (predicate) => (b232) => predicate(b232) ? some2242(b232) : none2242();
var containsWith422 = (isEquivalent) => dual322(2, (self2, a232) => isNone2242(self2) ? false : isEquivalent(self2.value, a232));
var _equivalence522 = /* @__PURE__ */ equivalence322();
var contains422 = /* @__PURE__ */ containsWith422(_equivalence522);
var exists322 = /* @__PURE__ */ dual322(2, (self2, refinement) => isNone2242(self2) ? false : refinement(self2.value));
var bindTo2242 = /* @__PURE__ */ bindTo622(map422);
var let_2242 = /* @__PURE__ */ let_622(map422);
var bind2242 = /* @__PURE__ */ bind622(map422, flatMap422);
var Do422 = /* @__PURE__ */ some2242({});
var adapter2242 = /* @__PURE__ */ adapter522();
var gen322 = (f232) => {
  const iterator = f232(adapter2242);
  let state = iterator.next();
  if (state.done) {
    return some2242(state.value);
  } else {
    let current = state.value;
    if (isGenKind322(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet322(current);
    }
    if (isNone2242(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind322(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet322(current);
        }
        if (isNone2242(current)) {
          return current;
        }
      }
    }
    return some2242(state.value);
  }
};
var MutableRef_exports222 = {};
__export332(MutableRef_exports222, {
  compareAndSet: () => compareAndSet42,
  decrement: () => decrement42,
  decrementAndGet: () => decrementAndGet42,
  get: () => get222,
  getAndDecrement: () => getAndDecrement42,
  getAndIncrement: () => getAndIncrement42,
  getAndSet: () => getAndSet42,
  getAndUpdate: () => getAndUpdate42,
  increment: () => increment42,
  incrementAndGet: () => incrementAndGet42,
  make: () => make3242,
  set: () => set242,
  setAndGet: () => setAndGet42,
  toggle: () => toggle42,
  update: () => update42,
  updateAndGet: () => updateAndGet42
});
var TypeId4242 = /* @__PURE__ */ Symbol.for("effect/MutableRef");
var MutableRefProto42 = {
  [TypeId4242]: TypeId4242,
  toString() {
    return format322(this.toJSON());
  },
  toJSON() {
    return {
      _id: "MutableRef",
      current: toJSON322(this.current)
    };
  },
  [NodeInspectSymbol322]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments322(this, arguments);
  }
};
var make3242 = (value) => {
  const ref = Object.create(MutableRefProto42);
  ref.current = value;
  return ref;
};
var compareAndSet42 = /* @__PURE__ */ dual322(3, (self2, oldValue, newValue) => {
  if (equals322(oldValue, self2.current)) {
    self2.current = newValue;
    return true;
  }
  return false;
});
var decrement42 = (self2) => update42(self2, (n232) => n232 - 1);
var decrementAndGet42 = (self2) => updateAndGet42(self2, (n232) => n232 - 1);
var get222 = (self2) => self2.current;
var getAndDecrement42 = (self2) => getAndUpdate42(self2, (n232) => n232 - 1);
var getAndIncrement42 = (self2) => getAndUpdate42(self2, (n232) => n232 + 1);
var getAndSet42 = /* @__PURE__ */ dual322(2, (self2, value) => {
  const ret = self2.current;
  self2.current = value;
  return ret;
});
var getAndUpdate42 = /* @__PURE__ */ dual322(2, (self2, f232) => getAndSet42(self2, f232(get222(self2))));
var increment42 = (self2) => update42(self2, (n232) => n232 + 1);
var incrementAndGet42 = (self2) => updateAndGet42(self2, (n232) => n232 + 1);
var set242 = /* @__PURE__ */ dual322(2, (self2, value) => {
  self2.current = value;
  return self2;
});
var setAndGet42 = /* @__PURE__ */ dual322(2, (self2, value) => {
  self2.current = value;
  return self2.current;
});
var update42 = /* @__PURE__ */ dual322(2, (self2, f232) => set242(self2, f232(get222(self2))));
var updateAndGet42 = /* @__PURE__ */ dual322(2, (self2, f232) => setAndGet42(self2, f232(get222(self2))));
var toggle42 = (self2) => update42(self2, (_232) => !_232);
function getVariables32(initialScope) {
  const scopeRef = MutableRef_exports222.make(initialScope);
  const variablesRef = MutableRef_exports222.make(MutableRef_exports222.get(scopeRef).variables);
  while (MutableRef_exports222.get(scopeRef).type !== scopeManager.ScopeType.global) {
    MutableRef_exports222.set(scopeRef, MutableRef_exports222.get(scopeRef).upper);
    MutableRef_exports222.update(variablesRef, (variables) => variables.concat(MutableRef_exports222.get(scopeRef).variables));
  }
  return MutableRef_exports222.get(variablesRef).reverse();
}
var findVariable242 = Function_exports322.dual(2, (name22, initialScope) => {
  return Option_exports322.fromNullable(getVariables32(initialScope).find((variable) => variable.name === name22));
});
var t32 = Symbol.for("@ts-pattern/matcher");
var e32 = Symbol.for("@ts-pattern/isVariadic");
var n32 = "@ts-pattern/anonymous-select-key";
var r32 = (t232) => Boolean(t232 && "object" == typeof t232);
var i32 = (e232) => e232 && !!e232[t32];
var o32 = (n232, s232, c232) => {
  if (i32(n232)) {
    const e232 = n232[t32](), { matched: r232, selections: i232 } = e232.match(s232);
    return r232 && i232 && Object.keys(i232).forEach((t232) => c232(t232, i232[t232])), r232;
  }
  if (r32(n232)) {
    if (!r32(s232)) return false;
    if (Array.isArray(n232)) {
      if (!Array.isArray(s232)) return false;
      let t232 = [], r232 = [], a232 = [];
      for (const o232 of n232.keys()) {
        const s322 = n232[o232];
        i32(s322) && s322[e32] ? a232.push(s322) : a232.length ? r232.push(s322) : t232.push(s322);
      }
      if (a232.length) {
        if (a232.length > 1) throw new Error("Pattern error: Using `...P.array(...)` several times in a single pattern is not allowed.");
        if (s232.length < t232.length + r232.length) return false;
        const e232 = s232.slice(0, t232.length), n322 = 0 === r232.length ? [] : s232.slice(-r232.length), i232 = s232.slice(t232.length, 0 === r232.length ? Infinity : -r232.length);
        return t232.every((t322, n422) => o32(t322, e232[n422], c232)) && r232.every((t322, e322) => o32(t322, n322[e322], c232)) && (0 === a232.length || o32(a232[0], i232, c232));
      }
      return n232.length === s232.length && n232.every((t322, e232) => o32(t322, s232[e232], c232));
    }
    return Object.keys(n232).every((e232) => {
      const r232 = n232[e232];
      return (e232 in s232 || i32(a232 = r232) && "optional" === a232[t32]().matcherType) && o32(r232, s232[e232], c232);
      var a232;
    });
  }
  return Object.is(s232, n232);
};
var s32 = (e232) => {
  var n232, o232, a232;
  return r32(e232) ? i32(e232) ? null != (n232 = null == (o232 = (a232 = e232[t32]()).getSelectionKeys) ? void 0 : o232.call(a232)) ? n232 : [] : Array.isArray(e232) ? c32(e232, s32) : c32(Object.values(e232), s32) : [];
};
var c32 = (t232, e232) => t232.reduce((t322, n232) => t322.concat(e232(n232)), []);
function a32(...t232) {
  if (1 === t232.length) {
    const [e232] = t232;
    return (t322) => o32(e232, t322, () => {
    });
  }
  if (2 === t232.length) {
    const [e232, n232] = t232;
    return o32(e232, n232, () => {
    });
  }
  throw new Error(`isMatching wasn't given the right number of arguments: expected 1 or 2, received ${t232.length}.`);
}
function u32(t232) {
  return Object.assign(t232, { optional: () => l32(t232), and: (e232) => m32(t232, e232), or: (e232) => d32(t232, e232), select: (e232) => void 0 === e232 ? p32(t232) : p32(e232, t232) });
}
function h32(t232) {
  return Object.assign(((t322) => Object.assign(t322, { [Symbol.iterator]() {
    let n232 = 0;
    const r232 = [{ value: Object.assign(t322, { [e32]: true }), done: false }, { done: true, value: void 0 }];
    return { next: () => {
      var t422;
      return null != (t422 = r232[n232++]) ? t422 : r232.at(-1);
    } };
  } }))(t232), { optional: () => h32(l32(t232)), select: (e232) => h32(void 0 === e232 ? p32(t232) : p32(e232, t232)) });
}
function l32(e232) {
  return u32({ [t32]: () => ({ match: (t232) => {
    let n232 = {};
    const r232 = (t322, e322) => {
      n232[t322] = e322;
    };
    return void 0 === t232 ? (s32(e232).forEach((t322) => r232(t322, void 0)), { matched: true, selections: n232 }) : { matched: o32(e232, t232, r232), selections: n232 };
  }, getSelectionKeys: () => s32(e232), matcherType: "optional" }) });
}
var f32 = (t232, e232) => {
  for (const n232 of t232) if (!e232(n232)) return false;
  return true;
};
var g32 = (t232, e232) => {
  for (const [n232, r232] of t232.entries()) if (!e232(r232, n232)) return false;
  return true;
};
function m32(...e232) {
  return u32({ [t32]: () => ({ match: (t232) => {
    let n232 = {};
    const r232 = (t322, e322) => {
      n232[t322] = e322;
    };
    return { matched: e232.every((e322) => o32(e322, t232, r232)), selections: n232 };
  }, getSelectionKeys: () => c32(e232, s32), matcherType: "and" }) });
}
function d32(...e232) {
  return u32({ [t32]: () => ({ match: (t232) => {
    let n232 = {};
    const r232 = (t322, e322) => {
      n232[t322] = e322;
    };
    return c32(e232, s32).forEach((t322) => r232(t322, void 0)), { matched: e232.some((e322) => o32(e322, t232, r232)), selections: n232 };
  }, getSelectionKeys: () => c32(e232, s32), matcherType: "or" }) });
}
function y32(e232) {
  return { [t32]: () => ({ match: (t232) => ({ matched: Boolean(e232(t232)) }) }) };
}
function p32(...e232) {
  const r232 = "string" == typeof e232[0] ? e232[0] : void 0, i232 = 2 === e232.length ? e232[1] : "string" == typeof e232[0] ? void 0 : e232[0];
  return u32({ [t32]: () => ({ match: (t232) => {
    let e322 = { [null != r232 ? r232 : n32]: t232 };
    return { matched: void 0 === i232 || o32(i232, t232, (t322, n232) => {
      e322[t322] = n232;
    }), selections: e322 };
  }, getSelectionKeys: () => [null != r232 ? r232 : n32].concat(void 0 === i232 ? [] : s32(i232)) }) });
}
function v32(t232) {
  return "number" == typeof t232;
}
function b32(t232) {
  return "string" == typeof t232;
}
function w32(t232) {
  return "bigint" == typeof t232;
}
var S32 = u32(y32(function(t232) {
  return true;
}));
var O32 = S32;
var j32 = (t232) => Object.assign(u32(t232), { startsWith: (e232) => {
  return j32(m32(t232, (n232 = e232, y32((t322) => b32(t322) && t322.startsWith(n232)))));
  var n232;
}, endsWith: (e232) => {
  return j32(m32(t232, (n232 = e232, y32((t322) => b32(t322) && t322.endsWith(n232)))));
  var n232;
}, minLength: (e232) => j32(m32(t232, ((t322) => y32((e322) => b32(e322) && e322.length >= t322))(e232))), maxLength: (e232) => j32(m32(t232, ((t322) => y32((e322) => b32(e322) && e322.length <= t322))(e232))), includes: (e232) => {
  return j32(m32(t232, (n232 = e232, y32((t322) => b32(t322) && t322.includes(n232)))));
  var n232;
}, regex: (e232) => {
  return j32(m32(t232, (n232 = e232, y32((t322) => b32(t322) && Boolean(t322.match(n232))))));
  var n232;
} });
var E32 = j32(y32(b32));
var K32 = (t232) => Object.assign(u32(t232), { between: (e232, n232) => K32(m32(t232, ((t322, e322) => y32((n322) => v32(n322) && t322 <= n322 && e322 >= n322))(e232, n232))), lt: (e232) => K32(m32(t232, ((t322) => y32((e322) => v32(e322) && e322 < t322))(e232))), gt: (e232) => K32(m32(t232, ((t322) => y32((e322) => v32(e322) && e322 > t322))(e232))), lte: (e232) => K32(m32(t232, ((t322) => y32((e322) => v32(e322) && e322 <= t322))(e232))), gte: (e232) => K32(m32(t232, ((t322) => y32((e322) => v32(e322) && e322 >= t322))(e232))), int: () => K32(m32(t232, y32((t322) => v32(t322) && Number.isInteger(t322)))), finite: () => K32(m32(t232, y32((t322) => v32(t322) && Number.isFinite(t322)))), positive: () => K32(m32(t232, y32((t322) => v32(t322) && t322 > 0))), negative: () => K32(m32(t232, y32((t322) => v32(t322) && t322 < 0))) });
var x32 = K32(y32(v32));
var A32 = (t232) => Object.assign(u32(t232), { between: (e232, n232) => A32(m32(t232, ((t322, e322) => y32((n322) => w32(n322) && t322 <= n322 && e322 >= n322))(e232, n232))), lt: (e232) => A32(m32(t232, ((t322) => y32((e322) => w32(e322) && e322 < t322))(e232))), gt: (e232) => A32(m32(t232, ((t322) => y32((e322) => w32(e322) && e322 > t322))(e232))), lte: (e232) => A32(m32(t232, ((t322) => y32((e322) => w32(e322) && e322 <= t322))(e232))), gte: (e232) => A32(m32(t232, ((t322) => y32((e322) => w32(e322) && e322 >= t322))(e232))), positive: () => A32(m32(t232, y32((t322) => w32(t322) && t322 > 0))), negative: () => A32(m32(t232, y32((t322) => w32(t322) && t322 < 0))) });
var P23 = A32(y32(w32));
var T32 = u32(y32(function(t232) {
  return "boolean" == typeof t232;
}));
var k32 = u32(y32(function(t232) {
  return "symbol" == typeof t232;
}));
var B32 = u32(y32(function(t232) {
  return null == t232;
}));
var _32 = u32(y32(function(t232) {
  return null != t232;
}));
var N32 = { __proto__: null, matcher: t32, optional: l32, array: function(...e232) {
  return h32({ [t32]: () => ({ match: (t232) => {
    if (!Array.isArray(t232)) return { matched: false };
    if (0 === e232.length) return { matched: true };
    const n232 = e232[0];
    let r232 = {};
    if (0 === t232.length) return s32(n232).forEach((t322) => {
      r232[t322] = [];
    }), { matched: true, selections: r232 };
    const i232 = (t322, e322) => {
      r232[t322] = (r232[t322] || []).concat([e322]);
    };
    return { matched: t232.every((t322) => o32(n232, t322, i232)), selections: r232 };
  }, getSelectionKeys: () => 0 === e232.length ? [] : s32(e232[0]) }) });
}, set: function(...e232) {
  return u32({ [t32]: () => ({ match: (t232) => {
    if (!(t232 instanceof Set)) return { matched: false };
    let n232 = {};
    if (0 === t232.size) return { matched: true, selections: n232 };
    if (0 === e232.length) return { matched: true };
    const r232 = (t322, e322) => {
      n232[t322] = (n232[t322] || []).concat([e322]);
    }, i232 = e232[0];
    return { matched: f32(t232, (t322) => o32(i232, t322, r232)), selections: n232 };
  }, getSelectionKeys: () => 0 === e232.length ? [] : s32(e232[0]) }) });
}, map: function(...e232) {
  return u32({ [t32]: () => ({ match: (t232) => {
    if (!(t232 instanceof Map)) return { matched: false };
    let n232 = {};
    if (0 === t232.size) return { matched: true, selections: n232 };
    const r232 = (t322, e322) => {
      n232[t322] = (n232[t322] || []).concat([e322]);
    };
    if (0 === e232.length) return { matched: true };
    var i232;
    if (1 === e232.length) throw new Error(`\`P.map\` wasn't given enough arguments. Expected (key, value), received ${null == (i232 = e232[0]) ? void 0 : i232.toString()}`);
    const [s232, c232] = e232;
    return { matched: g32(t232, (t322, e322) => {
      const n322 = o32(s232, e322, r232), i322 = o32(c232, t322, r232);
      return n322 && i322;
    }), selections: n232 };
  }, getSelectionKeys: () => 0 === e232.length ? [] : [...s32(e232[0]), ...s32(e232[1])] }) });
}, intersection: m32, union: d32, not: function(e232) {
  return u32({ [t32]: () => ({ match: (t232) => ({ matched: !o32(e232, t232, () => {
  }) }), getSelectionKeys: () => [], matcherType: "not" }) });
}, when: y32, select: p32, any: S32, _: O32, string: E32, number: x32, bigint: P23, boolean: T32, symbol: k32, nullish: B32, nonNullable: _32, instanceOf: function(t232) {
  return u32(y32(/* @__PURE__ */ function(t322) {
    return (e232) => e232 instanceof t322;
  }(t232)));
}, shape: function(t232) {
  return u32(y32(a32(t232)));
} };
var KEYS232 = {
  ArrayExpression: [
    "elements"
  ],
  ArrayPattern: [
    "elements"
  ],
  ArrowFunctionExpression: [
    "params",
    "body"
  ],
  AssignmentExpression: [
    "left",
    "right"
  ],
  AssignmentPattern: [
    "left",
    "right"
  ],
  AwaitExpression: [
    "argument"
  ],
  BinaryExpression: [
    "left",
    "right"
  ],
  BlockStatement: [
    "body"
  ],
  BreakStatement: [
    "label"
  ],
  CallExpression: [
    "callee",
    "arguments"
  ],
  CatchClause: [
    "param",
    "body"
  ],
  ChainExpression: [
    "expression"
  ],
  ClassBody: [
    "body"
  ],
  ClassDeclaration: [
    "id",
    "superClass",
    "body"
  ],
  ClassExpression: [
    "id",
    "superClass",
    "body"
  ],
  ConditionalExpression: [
    "test",
    "consequent",
    "alternate"
  ],
  ContinueStatement: [
    "label"
  ],
  DebuggerStatement: [],
  DoWhileStatement: [
    "body",
    "test"
  ],
  EmptyStatement: [],
  ExperimentalRestProperty: [
    "argument"
  ],
  ExperimentalSpreadProperty: [
    "argument"
  ],
  ExportAllDeclaration: [
    "exported",
    "source"
  ],
  ExportDefaultDeclaration: [
    "declaration"
  ],
  ExportNamedDeclaration: [
    "declaration",
    "specifiers",
    "source"
  ],
  ExportSpecifier: [
    "exported",
    "local"
  ],
  ExpressionStatement: [
    "expression"
  ],
  ForInStatement: [
    "left",
    "right",
    "body"
  ],
  ForOfStatement: [
    "left",
    "right",
    "body"
  ],
  ForStatement: [
    "init",
    "test",
    "update",
    "body"
  ],
  FunctionDeclaration: [
    "id",
    "params",
    "body"
  ],
  FunctionExpression: [
    "id",
    "params",
    "body"
  ],
  Identifier: [],
  IfStatement: [
    "test",
    "consequent",
    "alternate"
  ],
  ImportDeclaration: [
    "specifiers",
    "source"
  ],
  ImportDefaultSpecifier: [
    "local"
  ],
  ImportExpression: [
    "source"
  ],
  ImportNamespaceSpecifier: [
    "local"
  ],
  ImportSpecifier: [
    "imported",
    "local"
  ],
  JSXAttribute: [
    "name",
    "value"
  ],
  JSXClosingElement: [
    "name"
  ],
  JSXClosingFragment: [],
  JSXElement: [
    "openingElement",
    "children",
    "closingElement"
  ],
  JSXEmptyExpression: [],
  JSXExpressionContainer: [
    "expression"
  ],
  JSXFragment: [
    "openingFragment",
    "children",
    "closingFragment"
  ],
  JSXIdentifier: [],
  JSXMemberExpression: [
    "object",
    "property"
  ],
  JSXNamespacedName: [
    "namespace",
    "name"
  ],
  JSXOpeningElement: [
    "name",
    "attributes"
  ],
  JSXOpeningFragment: [],
  JSXSpreadAttribute: [
    "argument"
  ],
  JSXSpreadChild: [
    "expression"
  ],
  JSXText: [],
  LabeledStatement: [
    "label",
    "body"
  ],
  Literal: [],
  LogicalExpression: [
    "left",
    "right"
  ],
  MemberExpression: [
    "object",
    "property"
  ],
  MetaProperty: [
    "meta",
    "property"
  ],
  MethodDefinition: [
    "key",
    "value"
  ],
  NewExpression: [
    "callee",
    "arguments"
  ],
  ObjectExpression: [
    "properties"
  ],
  ObjectPattern: [
    "properties"
  ],
  PrivateIdentifier: [],
  Program: [
    "body"
  ],
  Property: [
    "key",
    "value"
  ],
  PropertyDefinition: [
    "key",
    "value"
  ],
  RestElement: [
    "argument"
  ],
  ReturnStatement: [
    "argument"
  ],
  SequenceExpression: [
    "expressions"
  ],
  SpreadElement: [
    "argument"
  ],
  StaticBlock: [
    "body"
  ],
  Super: [],
  SwitchCase: [
    "test",
    "consequent"
  ],
  SwitchStatement: [
    "discriminant",
    "cases"
  ],
  TaggedTemplateExpression: [
    "tag",
    "quasi"
  ],
  TemplateElement: [],
  TemplateLiteral: [
    "quasis",
    "expressions"
  ],
  ThisExpression: [],
  ThrowStatement: [
    "argument"
  ],
  TryStatement: [
    "block",
    "handler",
    "finalizer"
  ],
  UnaryExpression: [
    "argument"
  ],
  UpdateExpression: [
    "argument"
  ],
  VariableDeclaration: [
    "declarations"
  ],
  VariableDeclarator: [
    "id",
    "init"
  ],
  WhileStatement: [
    "test",
    "body"
  ],
  WithStatement: [
    "object",
    "body"
  ],
  YieldExpression: [
    "argument"
  ]
};
var NODE_TYPES232 = Object.keys(KEYS232);
for (const type of NODE_TYPES232) {
  Object.freeze(KEYS232[type]);
}
Object.freeze(KEYS232);
var visitor_keys_default232 = KEYS232;
var KEY_BLACKLIST232 = /* @__PURE__ */ new Set([
  "parent",
  "leadingComments",
  "trailingComments"
]);
function filterKey232(key) {
  return !KEY_BLACKLIST232.has(key) && key[0] !== "_";
}
function getKeys232(node) {
  return Object.keys(node).filter(filterKey232);
}
function getInnermostScope232(initialScope, node) {
  const location = node.range[0];
  let scope = initialScope;
  let found = false;
  do {
    found = false;
    for (const childScope of scope.childScopes) {
      const range222 = childScope.block.range;
      if (range222[0] <= location && location < range222[1]) {
        scope = childScope;
        found = true;
        break;
      }
    }
  } while (found);
  return scope;
}
function findVariable2232(initialScope, nameOrNode) {
  let name22 = "";
  let scope = initialScope;
  if (typeof nameOrNode === "string") {
    name22 = nameOrNode;
  } else {
    name22 = nameOrNode.name;
    scope = getInnermostScope232(scope, nameOrNode);
  }
  while (scope != null) {
    const variable = scope.set.get(name22);
    if (variable != null) {
      return variable;
    }
    scope = scope.upper;
  }
  return null;
}
function negate0232(token) {
  return !this(token);
}
function negate232(f232) {
  return negate0232.bind(f232);
}
function isPunctuatorTokenWithValue232(token, value) {
  return token.type === "Punctuator" && token.value === value;
}
function isArrowToken232(token) {
  return isPunctuatorTokenWithValue232(token, "=>");
}
function isCommaToken232(token) {
  return isPunctuatorTokenWithValue232(token, ",");
}
function isSemicolonToken232(token) {
  return isPunctuatorTokenWithValue232(token, ";");
}
function isColonToken232(token) {
  return isPunctuatorTokenWithValue232(token, ":");
}
function isOpeningParenToken232(token) {
  return isPunctuatorTokenWithValue232(token, "(");
}
function isClosingParenToken232(token) {
  return isPunctuatorTokenWithValue232(token, ")");
}
function isOpeningBracketToken232(token) {
  return isPunctuatorTokenWithValue232(token, "[");
}
function isClosingBracketToken232(token) {
  return isPunctuatorTokenWithValue232(token, "]");
}
function isOpeningBraceToken232(token) {
  return isPunctuatorTokenWithValue232(token, "{");
}
function isClosingBraceToken232(token) {
  return isPunctuatorTokenWithValue232(token, "}");
}
function isCommentToken232(token) {
  return ["Block", "Line", "Shebang"].includes(token.type);
}
negate232(isArrowToken232);
negate232(isCommaToken232);
negate232(isSemicolonToken232);
negate232(isColonToken232);
negate232(isOpeningParenToken232);
negate232(isClosingParenToken232);
negate232(isOpeningBracketToken232);
negate232(isClosingBracketToken232);
negate232(isOpeningBraceToken232);
negate232(isClosingBraceToken232);
negate232(isCommentToken232);
function getOpeningParenOfParams232(node, sourceCode) {
  return node.id ? sourceCode.getTokenAfter(node.id, isOpeningParenToken232) : sourceCode.getFirstToken(node, isOpeningParenToken232);
}
function getFunctionHeadLocation232(node, sourceCode) {
  const parent = node.parent;
  let start = null;
  let end = null;
  if (node.type === "ArrowFunctionExpression") {
    const arrowToken = sourceCode.getTokenBefore(node.body, isArrowToken232);
    start = arrowToken.loc.start;
    end = arrowToken.loc.end;
  } else if (parent.type === "Property" || parent.type === "MethodDefinition" || parent.type === "PropertyDefinition") {
    start = parent.loc.start;
    end = getOpeningParenOfParams232(node, sourceCode).loc.start;
  } else {
    start = node.loc.start;
    end = getOpeningParenOfParams232(node, sourceCode).loc.start;
  }
  return {
    start: { ...start },
    end: { ...end }
  };
}
var globalObject232 = typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {};
var builtinNames232 = Object.freeze(
  /* @__PURE__ */ new Set([
    "Array",
    "ArrayBuffer",
    "BigInt",
    "BigInt64Array",
    "BigUint64Array",
    "Boolean",
    "DataView",
    "Date",
    "decodeURI",
    "decodeURIComponent",
    "encodeURI",
    "encodeURIComponent",
    "escape",
    "Float32Array",
    "Float64Array",
    "Function",
    "Infinity",
    "Int16Array",
    "Int32Array",
    "Int8Array",
    "isFinite",
    "isNaN",
    "isPrototypeOf",
    "JSON",
    "Map",
    "Math",
    "NaN",
    "Number",
    "Object",
    "parseFloat",
    "parseInt",
    "Promise",
    "Proxy",
    "Reflect",
    "RegExp",
    "Set",
    "String",
    "Symbol",
    "Uint16Array",
    "Uint32Array",
    "Uint8Array",
    "Uint8ClampedArray",
    "undefined",
    "unescape",
    "WeakMap",
    "WeakSet"
  ])
);
var callAllowed232 = new Set(
  [
    Array.isArray,
    Array.of,
    Array.prototype.at,
    Array.prototype.concat,
    Array.prototype.entries,
    Array.prototype.every,
    Array.prototype.filter,
    Array.prototype.find,
    Array.prototype.findIndex,
    Array.prototype.flat,
    Array.prototype.includes,
    Array.prototype.indexOf,
    Array.prototype.join,
    Array.prototype.keys,
    Array.prototype.lastIndexOf,
    Array.prototype.slice,
    Array.prototype.some,
    Array.prototype.toString,
    Array.prototype.values,
    typeof BigInt === "function" ? BigInt : void 0,
    Boolean,
    Date,
    Date.parse,
    decodeURI,
    decodeURIComponent,
    encodeURI,
    encodeURIComponent,
    escape,
    isFinite,
    isNaN,
    isPrototypeOf,
    Map,
    Map.prototype.entries,
    Map.prototype.get,
    Map.prototype.has,
    Map.prototype.keys,
    Map.prototype.values,
    ...Object.getOwnPropertyNames(Math).filter((k232) => k232 !== "random").map((k232) => Math[k232]).filter((f232) => typeof f232 === "function"),
    Number,
    Number.isFinite,
    Number.isNaN,
    Number.parseFloat,
    Number.parseInt,
    Number.prototype.toExponential,
    Number.prototype.toFixed,
    Number.prototype.toPrecision,
    Number.prototype.toString,
    Object,
    Object.entries,
    Object.is,
    Object.isExtensible,
    Object.isFrozen,
    Object.isSealed,
    Object.keys,
    Object.values,
    parseFloat,
    parseInt,
    RegExp,
    Set,
    Set.prototype.entries,
    Set.prototype.has,
    Set.prototype.keys,
    Set.prototype.values,
    String,
    String.fromCharCode,
    String.fromCodePoint,
    String.raw,
    String.prototype.at,
    String.prototype.charAt,
    String.prototype.charCodeAt,
    String.prototype.codePointAt,
    String.prototype.concat,
    String.prototype.endsWith,
    String.prototype.includes,
    String.prototype.indexOf,
    String.prototype.lastIndexOf,
    String.prototype.normalize,
    String.prototype.padEnd,
    String.prototype.padStart,
    String.prototype.slice,
    String.prototype.startsWith,
    String.prototype.substr,
    String.prototype.substring,
    String.prototype.toLowerCase,
    String.prototype.toString,
    String.prototype.toUpperCase,
    String.prototype.trim,
    String.prototype.trimEnd,
    String.prototype.trimLeft,
    String.prototype.trimRight,
    String.prototype.trimStart,
    Symbol.for,
    Symbol.keyFor,
    unescape
  ].filter((f232) => typeof f232 === "function")
);
var callPassThrough232 = /* @__PURE__ */ new Set([
  Object.freeze,
  Object.preventExtensions,
  Object.seal
]);
var getterAllowed232 = [
  [Map, /* @__PURE__ */ new Set(["size"])],
  [
    RegExp,
    /* @__PURE__ */ new Set([
      "dotAll",
      "flags",
      "global",
      "hasIndices",
      "ignoreCase",
      "multiline",
      "source",
      "sticky",
      "unicode"
    ])
  ],
  [Set, /* @__PURE__ */ new Set(["size"])]
];
function getPropertyDescriptor232(object32, name22) {
  let x232 = object32;
  while ((typeof x232 === "object" || typeof x232 === "function") && x232 !== null) {
    const d232 = Object.getOwnPropertyDescriptor(x232, name22);
    if (d232) {
      return d232;
    }
    x232 = Object.getPrototypeOf(x232);
  }
  return null;
}
function isGetter232(object32, name22) {
  const d232 = getPropertyDescriptor232(object32, name22);
  return d232 != null && d232.get != null;
}
function getElementValues232(nodeList, initialScope) {
  const valueList = [];
  for (let i232 = 0; i232 < nodeList.length; ++i232) {
    const elementNode = nodeList[i232];
    if (elementNode == null) {
      valueList.length = i232 + 1;
    } else if (elementNode.type === "SpreadElement") {
      const argument = getStaticValueR232(elementNode.argument, initialScope);
      if (argument == null) {
        return null;
      }
      valueList.push(...argument.value);
    } else {
      const element = getStaticValueR232(elementNode, initialScope);
      if (element == null) {
        return null;
      }
      valueList.push(element.value);
    }
  }
  return valueList;
}
function isEffectivelyConst232(variable) {
  const refs = variable.references;
  const inits = refs.filter((r232) => r232.init).length;
  const reads = refs.filter((r232) => r232.isReadOnly()).length;
  if (inits === 1 && reads + inits === refs.length) {
    return true;
  }
  return false;
}
var operations232 = Object.freeze({
  ArrayExpression(node, initialScope) {
    const elements = getElementValues232(node.elements, initialScope);
    return elements != null ? { value: elements } : null;
  },
  AssignmentExpression(node, initialScope) {
    if (node.operator === "=") {
      return getStaticValueR232(node.right, initialScope);
    }
    return null;
  },
  //eslint-disable-next-line complexity
  BinaryExpression(node, initialScope) {
    if (node.operator === "in" || node.operator === "instanceof") {
      return null;
    }
    const left3232 = getStaticValueR232(node.left, initialScope);
    const right3232 = getStaticValueR232(node.right, initialScope);
    if (left3232 != null && right3232 != null) {
      switch (node.operator) {
        case "==":
          return { value: left3232.value == right3232.value };
        case "!=":
          return { value: left3232.value != right3232.value };
        case "===":
          return { value: left3232.value === right3232.value };
        case "!==":
          return { value: left3232.value !== right3232.value };
        case "<":
          return { value: left3232.value < right3232.value };
        case "<=":
          return { value: left3232.value <= right3232.value };
        case ">":
          return { value: left3232.value > right3232.value };
        case ">=":
          return { value: left3232.value >= right3232.value };
        case "<<":
          return { value: left3232.value << right3232.value };
        case ">>":
          return { value: left3232.value >> right3232.value };
        case ">>>":
          return { value: left3232.value >>> right3232.value };
        case "+":
          return { value: left3232.value + right3232.value };
        case "-":
          return { value: left3232.value - right3232.value };
        case "*":
          return { value: left3232.value * right3232.value };
        case "/":
          return { value: left3232.value / right3232.value };
        case "%":
          return { value: left3232.value % right3232.value };
        case "**":
          return { value: left3232.value ** right3232.value };
        case "|":
          return { value: left3232.value | right3232.value };
        case "^":
          return { value: left3232.value ^ right3232.value };
        case "&":
          return { value: left3232.value & right3232.value };
      }
    }
    return null;
  },
  CallExpression(node, initialScope) {
    const calleeNode = node.callee;
    const args = getElementValues232(node.arguments, initialScope);
    if (args != null) {
      if (calleeNode.type === "MemberExpression") {
        if (calleeNode.property.type === "PrivateIdentifier") {
          return null;
        }
        const object32 = getStaticValueR232(calleeNode.object, initialScope);
        if (object32 != null) {
          if (object32.value == null && (object32.optional || node.optional)) {
            return { value: void 0, optional: true };
          }
          const property = getStaticPropertyNameValue232(
            calleeNode,
            initialScope
          );
          if (property != null) {
            const receiver = object32.value;
            const methodName = property.value;
            if (callAllowed232.has(receiver[methodName])) {
              return { value: receiver[methodName](...args) };
            }
            if (callPassThrough232.has(receiver[methodName])) {
              return { value: args[0] };
            }
          }
        }
      } else {
        const callee = getStaticValueR232(calleeNode, initialScope);
        if (callee != null) {
          if (callee.value == null && node.optional) {
            return { value: void 0, optional: true };
          }
          const func = callee.value;
          if (callAllowed232.has(func)) {
            return { value: func(...args) };
          }
          if (callPassThrough232.has(func)) {
            return { value: args[0] };
          }
        }
      }
    }
    return null;
  },
  ConditionalExpression(node, initialScope) {
    const test = getStaticValueR232(node.test, initialScope);
    if (test != null) {
      return test.value ? getStaticValueR232(node.consequent, initialScope) : getStaticValueR232(node.alternate, initialScope);
    }
    return null;
  },
  ExpressionStatement(node, initialScope) {
    return getStaticValueR232(node.expression, initialScope);
  },
  Identifier(node, initialScope) {
    if (initialScope != null) {
      const variable = findVariable2232(initialScope, node);
      if (variable != null && variable.defs.length === 0 && builtinNames232.has(variable.name) && variable.name in globalObject232) {
        return { value: globalObject232[variable.name] };
      }
      if (variable != null && variable.defs.length === 1) {
        const def = variable.defs[0];
        if (def.parent && def.type === "Variable" && (def.parent.kind === "const" || isEffectivelyConst232(variable)) && // TODO(mysticatea): don't support destructuring here.
        def.node.id.type === "Identifier") {
          return getStaticValueR232(def.node.init, initialScope);
        }
      }
    }
    return null;
  },
  Literal(node) {
    if ((node.regex != null || node.bigint != null) && node.value == null) {
      return null;
    }
    return { value: node.value };
  },
  LogicalExpression(node, initialScope) {
    const left3232 = getStaticValueR232(node.left, initialScope);
    if (left3232 != null) {
      if (node.operator === "||" && Boolean(left3232.value) === true || node.operator === "&&" && Boolean(left3232.value) === false || node.operator === "??" && left3232.value != null) {
        return left3232;
      }
      const right3232 = getStaticValueR232(node.right, initialScope);
      if (right3232 != null) {
        return right3232;
      }
    }
    return null;
  },
  MemberExpression(node, initialScope) {
    if (node.property.type === "PrivateIdentifier") {
      return null;
    }
    const object32 = getStaticValueR232(node.object, initialScope);
    if (object32 != null) {
      if (object32.value == null && (object32.optional || node.optional)) {
        return { value: void 0, optional: true };
      }
      const property = getStaticPropertyNameValue232(node, initialScope);
      if (property != null) {
        if (!isGetter232(object32.value, property.value)) {
          return { value: object32.value[property.value] };
        }
        for (const [classFn, allowed] of getterAllowed232) {
          if (object32.value instanceof classFn && allowed.has(property.value)) {
            return { value: object32.value[property.value] };
          }
        }
      }
    }
    return null;
  },
  ChainExpression(node, initialScope) {
    const expression = getStaticValueR232(node.expression, initialScope);
    if (expression != null) {
      return { value: expression.value };
    }
    return null;
  },
  NewExpression(node, initialScope) {
    const callee = getStaticValueR232(node.callee, initialScope);
    const args = getElementValues232(node.arguments, initialScope);
    if (callee != null && args != null) {
      const Func = callee.value;
      if (callAllowed232.has(Func)) {
        return { value: new Func(...args) };
      }
    }
    return null;
  },
  ObjectExpression(node, initialScope) {
    const object32 = {};
    for (const propertyNode of node.properties) {
      if (propertyNode.type === "Property") {
        if (propertyNode.kind !== "init") {
          return null;
        }
        const key = getStaticPropertyNameValue232(
          propertyNode,
          initialScope
        );
        const value = getStaticValueR232(propertyNode.value, initialScope);
        if (key == null || value == null) {
          return null;
        }
        object32[key.value] = value.value;
      } else if (propertyNode.type === "SpreadElement" || propertyNode.type === "ExperimentalSpreadProperty") {
        const argument = getStaticValueR232(
          propertyNode.argument,
          initialScope
        );
        if (argument == null) {
          return null;
        }
        Object.assign(object32, argument.value);
      } else {
        return null;
      }
    }
    return { value: object32 };
  },
  SequenceExpression(node, initialScope) {
    const last222 = node.expressions[node.expressions.length - 1];
    return getStaticValueR232(last222, initialScope);
  },
  TaggedTemplateExpression(node, initialScope) {
    const tag = getStaticValueR232(node.tag, initialScope);
    const expressions = getElementValues232(
      node.quasi.expressions,
      initialScope
    );
    if (tag != null && expressions != null) {
      const func = tag.value;
      const strings = node.quasi.quasis.map((q) => q.value.cooked);
      strings.raw = node.quasi.quasis.map((q) => q.value.raw);
      if (func === String.raw) {
        return { value: func(strings, ...expressions) };
      }
    }
    return null;
  },
  TemplateLiteral(node, initialScope) {
    const expressions = getElementValues232(node.expressions, initialScope);
    if (expressions != null) {
      let value = node.quasis[0].value.cooked;
      for (let i232 = 0; i232 < expressions.length; ++i232) {
        value += expressions[i232];
        value += node.quasis[i232 + 1].value.cooked;
      }
      return { value };
    }
    return null;
  },
  UnaryExpression(node, initialScope) {
    if (node.operator === "delete") {
      return null;
    }
    if (node.operator === "void") {
      return { value: void 0 };
    }
    const arg = getStaticValueR232(node.argument, initialScope);
    if (arg != null) {
      switch (node.operator) {
        case "-":
          return { value: -arg.value };
        case "+":
          return { value: +arg.value };
        case "!":
          return { value: !arg.value };
        case "~":
          return { value: ~arg.value };
        case "typeof":
          return { value: typeof arg.value };
      }
    }
    return null;
  }
});
function getStaticValueR232(node, initialScope) {
  if (node != null && Object.hasOwnProperty.call(operations232, node.type)) {
    return operations232[node.type](node, initialScope);
  }
  return null;
}
function getStaticPropertyNameValue232(node, initialScope) {
  const nameNode = node.type === "Property" ? node.key : node.property;
  if (node.computed) {
    return getStaticValueR232(nameNode, initialScope);
  }
  if (nameNode.type === "Identifier") {
    return { value: nameNode.name };
  }
  if (nameNode.type === "Literal") {
    if (nameNode.bigint) {
      return { value: nameNode.bigint };
    }
    return { value: String(nameNode.value) };
  }
  return null;
}
function getStaticValue232(node, initialScope = null) {
  try {
    return getStaticValueR232(node, initialScope);
  } catch (_error) {
    return null;
  }
}
function getStringIfConstant232(node, initialScope = null) {
  if (node && node.type === "Literal" && node.value === null) {
    if (node.regex) {
      return `/${node.regex.pattern}/${node.regex.flags}`;
    }
    if (node.bigint) {
      return node.bigint;
    }
  }
  const evaluated = getStaticValue232(node, initialScope);
  return evaluated && String(evaluated.value);
}
function getPropertyName232(node, initialScope) {
  switch (node.type) {
    case "MemberExpression":
      if (node.computed) {
        return getStringIfConstant232(node.property, initialScope);
      }
      if (node.property.type === "PrivateIdentifier") {
        return null;
      }
      return node.property.name;
    case "Property":
    case "MethodDefinition":
    case "PropertyDefinition":
      if (node.computed) {
        return getStringIfConstant232(node.key, initialScope);
      }
      if (node.key.type === "Literal") {
        return String(node.key.value);
      }
      if (node.key.type === "PrivateIdentifier") {
        return null;
      }
      return node.key.name;
  }
  return null;
}
function getFunctionNameWithKind232(node, sourceCode) {
  const parent = node.parent;
  const tokens = [];
  const isObjectMethod = parent.type === "Property" && parent.value === node;
  const isClassMethod = parent.type === "MethodDefinition" && parent.value === node;
  const isClassFieldMethod = parent.type === "PropertyDefinition" && parent.value === node;
  if (isClassMethod || isClassFieldMethod) {
    if (parent.static) {
      tokens.push("static");
    }
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push("private");
    }
  }
  if (node.async) {
    tokens.push("async");
  }
  if (node.generator) {
    tokens.push("generator");
  }
  if (isObjectMethod || isClassMethod) {
    if (parent.kind === "constructor") {
      return "constructor";
    }
    if (parent.kind === "get") {
      tokens.push("getter");
    } else if (parent.kind === "set") {
      tokens.push("setter");
    } else {
      tokens.push("method");
    }
  } else if (isClassFieldMethod) {
    tokens.push("method");
  } else {
    if (node.type === "ArrowFunctionExpression") {
      tokens.push("arrow");
    }
    tokens.push("function");
  }
  if (isObjectMethod || isClassMethod || isClassFieldMethod) {
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push(`#${parent.key.name}`);
    } else {
      const name22 = getPropertyName232(parent);
      if (name22) {
        tokens.push(`'${name22}'`);
      } else if (sourceCode) {
        const keyText = sourceCode.getText(parent.key);
        if (!keyText.includes("\n")) {
          tokens.push(`[${keyText}]`);
        }
      }
    }
  } else if (node.id) {
    tokens.push(`'${node.id.name}'`);
  } else if (parent.type === "VariableDeclarator" && parent.id && parent.id.type === "Identifier") {
    tokens.push(`'${parent.id.name}'`);
  } else if ((parent.type === "AssignmentExpression" || parent.type === "AssignmentPattern") && parent.left && parent.left.type === "Identifier") {
    tokens.push(`'${parent.left.name}'`);
  } else if (parent.type === "ExportDefaultDeclaration" && parent.declaration === node) {
    tokens.push("'default'");
  }
  return tokens.join(" ");
}
var typeConversionBinaryOps232 = Object.freeze(
  /* @__PURE__ */ new Set([
    "==",
    "!=",
    "<",
    "<=",
    ">",
    ">=",
    "<<",
    ">>",
    ">>>",
    "+",
    "-",
    "*",
    "/",
    "%",
    "|",
    "^",
    "&",
    "in"
  ])
);
var typeConversionUnaryOps232 = Object.freeze(/* @__PURE__ */ new Set(["-", "+", "!", "~"]));
function isNode232(x232) {
  return x232 !== null && typeof x232 === "object" && typeof x232.type === "string";
}
var visitor232 = Object.freeze(
  Object.assign(/* @__PURE__ */ Object.create(null), {
    $visit(node, options, visitorKeys) {
      const { type } = node;
      if (typeof this[type] === "function") {
        return this[type](node, options, visitorKeys);
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    $visitChildren(node, options, visitorKeys) {
      const { type } = node;
      for (const key of visitorKeys[type] || getKeys232(node)) {
        const value = node[key];
        if (Array.isArray(value)) {
          for (const element of value) {
            if (isNode232(element) && this.$visit(element, options, visitorKeys)) {
              return true;
            }
          }
        } else if (isNode232(value) && this.$visit(value, options, visitorKeys)) {
          return true;
        }
      }
      return false;
    },
    ArrowFunctionExpression() {
      return false;
    },
    AssignmentExpression() {
      return true;
    },
    AwaitExpression() {
      return true;
    },
    BinaryExpression(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && typeConversionBinaryOps232.has(node.operator) && (node.left.type !== "Literal" || node.right.type !== "Literal")) {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    CallExpression() {
      return true;
    },
    FunctionExpression() {
      return false;
    },
    ImportExpression() {
      return true;
    },
    MemberExpression(node, options, visitorKeys) {
      if (options.considerGetters) {
        return true;
      }
      if (options.considerImplicitTypeConversion && node.computed && node.property.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    MethodDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    NewExpression() {
      return true;
    },
    Property(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    PropertyDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UnaryExpression(node, options, visitorKeys) {
      if (node.operator === "delete") {
        return true;
      }
      if (options.considerImplicitTypeConversion && typeConversionUnaryOps232.has(node.operator) && node.argument.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UpdateExpression() {
      return true;
    },
    YieldExpression() {
      return true;
    }
  })
);
function hasSideEffect232(node, sourceCode, { considerGetters = false, considerImplicitTypeConversion = false } = {}) {
  return visitor232.$visit(
    node,
    { considerGetters, considerImplicitTypeConversion },
    sourceCode.visitorKeys || visitor_keys_default232
  );
}
function getParentSyntaxParen232(node, sourceCode) {
  const parent = node.parent;
  switch (parent.type) {
    case "CallExpression":
    case "NewExpression":
      if (parent.arguments.length === 1 && parent.arguments[0] === node) {
        return sourceCode.getTokenAfter(
          parent.callee,
          isOpeningParenToken232
        );
      }
      return null;
    case "DoWhileStatement":
      if (parent.test === node) {
        return sourceCode.getTokenAfter(
          parent.body,
          isOpeningParenToken232
        );
      }
      return null;
    case "IfStatement":
    case "WhileStatement":
      if (parent.test === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "ImportExpression":
      if (parent.source === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "SwitchStatement":
      if (parent.discriminant === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "WithStatement":
      if (parent.object === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    default:
      return null;
  }
}
function isParenthesized232(timesOrNode, nodeOrSourceCode, optionalSourceCode) {
  let times, node, sourceCode, maybeLeftParen, maybeRightParen;
  if (typeof timesOrNode === "number") {
    times = timesOrNode | 0;
    node = nodeOrSourceCode;
    sourceCode = optionalSourceCode;
    if (!(times >= 1)) {
      throw new TypeError("'times' should be a positive integer.");
    }
  } else {
    times = 1;
    node = timesOrNode;
    sourceCode = nodeOrSourceCode;
  }
  if (node == null || // `Program` can't be parenthesized
  node.parent == null || // `CatchClause.param` can't be parenthesized, example `try {} catch (error) {}`
  node.parent.type === "CatchClause" && node.parent.param === node) {
    return false;
  }
  maybeLeftParen = maybeRightParen = node;
  do {
    maybeLeftParen = sourceCode.getTokenBefore(maybeLeftParen);
    maybeRightParen = sourceCode.getTokenAfter(maybeRightParen);
  } while (maybeLeftParen != null && maybeRightParen != null && isOpeningParenToken232(maybeLeftParen) && isClosingParenToken232(maybeRightParen) && // Avoid false positive such as `if (a) {}`
  maybeLeftParen !== getParentSyntaxParen232(node, sourceCode) && --times > 0);
  return times === 0;
}
Function.call.bind(Object.hasOwnProperty);
var __defProp2232 = Object.defineProperty;
var __export2232 = (target, all3232) => {
  for (var name22 in all3232)
    __defProp2232(target, name22, { get: all3232[name22], enumerable: true });
};
var NodeType232 = types.AST_NODE_TYPES;
var is232 = utils.ASTUtils.isNodeOfType;
var isOneOf232 = utils.ASTUtils.isNodeOfTypes;
isOneOf232([
  NodeType232.ArrowFunctionExpression,
  NodeType232.FunctionDeclaration,
  NodeType232.FunctionExpression
]);
isOneOf232([
  NodeType232.ArrowFunctionExpression,
  NodeType232.FunctionDeclaration,
  NodeType232.FunctionExpression,
  NodeType232.TSCallSignatureDeclaration,
  NodeType232.TSConstructSignatureDeclaration,
  NodeType232.TSDeclareFunction,
  NodeType232.TSEmptyBodyFunctionExpression,
  NodeType232.TSFunctionType,
  NodeType232.TSMethodSignature
]);
isOneOf232([NodeType232.ClassDeclaration, NodeType232.ClassExpression]);
isOneOf232([
  NodeType232.DoWhileStatement,
  NodeType232.ForInStatement,
  NodeType232.ForOfStatement,
  NodeType232.ForStatement,
  NodeType232.WhileStatement
]);
isOneOf232([NodeType232.TSArrayType, NodeType232.TSTupleType]);
isOneOf232([
  NodeType232.PropertyDefinition,
  NodeType232.TSIndexSignature,
  NodeType232.TSParameterProperty,
  NodeType232.TSPropertySignature
]);
is232(NodeType232.JSXElement);
is232(NodeType232.JSXFragment);
isOneOf232([
  NodeType232.JSXAttribute,
  NodeType232.JSXSpreadChild,
  NodeType232.JSXClosingElement,
  NodeType232.JSXClosingFragment,
  NodeType232.JSXElement,
  NodeType232.JSXEmptyExpression,
  NodeType232.JSXExpressionContainer,
  NodeType232.JSXFragment,
  NodeType232.JSXIdentifier,
  NodeType232.JSXMemberExpression,
  NodeType232.JSXNamespacedName,
  NodeType232.JSXOpeningElement,
  NodeType232.JSXOpeningFragment,
  NodeType232.JSXSpreadAttribute,
  NodeType232.JSXSpreadChild,
  NodeType232.JSXText
]);
isOneOf232([
  NodeType232.JSXIdentifier,
  NodeType232.JSXMemberExpression,
  NodeType232.JSXNamespacedName
]);
isOneOf232([
  NodeType232.ArrayPattern,
  NodeType232.AssignmentPattern,
  NodeType232.ObjectPattern,
  NodeType232.RestElement
]);
isOneOf232([
  NodeType232.TSInterfaceDeclaration,
  NodeType232.TSTypeAliasDeclaration
]);
isOneOf232([
  NodeType232.ArrayExpression,
  NodeType232.ArrayPattern,
  NodeType232.ArrowFunctionExpression,
  NodeType232.CallExpression,
  NodeType232.ClassExpression,
  NodeType232.FunctionExpression,
  NodeType232.Identifier,
  NodeType232.JSXElement,
  NodeType232.JSXFragment,
  NodeType232.Literal,
  NodeType232.TemplateLiteral,
  NodeType232.MemberExpression,
  NodeType232.MetaProperty,
  NodeType232.ObjectExpression,
  NodeType232.ObjectPattern,
  NodeType232.SequenceExpression,
  NodeType232.Super,
  NodeType232.TaggedTemplateExpression,
  NodeType232.ThisExpression
]);
isOneOf232([
  NodeType232.ArrayExpression,
  NodeType232.ArrayPattern,
  NodeType232.ArrowFunctionExpression,
  NodeType232.CallExpression,
  NodeType232.ClassExpression,
  NodeType232.FunctionExpression,
  NodeType232.Identifier,
  NodeType232.JSXElement,
  NodeType232.JSXFragment,
  NodeType232.Literal,
  NodeType232.TemplateLiteral,
  NodeType232.MemberExpression,
  NodeType232.MetaProperty,
  NodeType232.ObjectExpression,
  NodeType232.ObjectPattern,
  NodeType232.SequenceExpression,
  NodeType232.Super,
  NodeType232.TaggedTemplateExpression,
  NodeType232.ThisExpression,
  NodeType232.TSAsExpression,
  NodeType232.TSNonNullExpression,
  NodeType232.TSTypeAssertion
]);
var Function_exports2232 = {};
__export2232(Function_exports2232, {
  SK: () => SK2232,
  absurd: () => absurd2232,
  apply: () => apply2232,
  compose: () => compose2242,
  constFalse: () => constFalse2232,
  constNull: () => constNull2232,
  constTrue: () => constTrue2232,
  constUndefined: () => constUndefined2232,
  constVoid: () => constVoid2232,
  constant: () => constant2232,
  dual: () => dual2232,
  flip: () => flip2232,
  flow: () => flow2232,
  hole: () => hole2232,
  identity: () => identity2232,
  isFunction: () => isFunction22232,
  pipe: () => pipe2232,
  satisfies: () => satisfies2232,
  tupled: () => tupled2232,
  unsafeCoerce: () => unsafeCoerce2232,
  untupled: () => untupled2232
});
var isFunction22232 = (input) => typeof input === "function";
var dual2232 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a232, b232) {
        if (arguments.length >= 2) {
          return body(a232, b232);
        }
        return function(self2) {
          return body(self2, a232);
        };
      };
    case 3:
      return function(a232, b232, c232) {
        if (arguments.length >= 3) {
          return body(a232, b232, c232);
        }
        return function(self2) {
          return body(self2, a232, b232);
        };
      };
    case 4:
      return function(a232, b232, c232, d232) {
        if (arguments.length >= 4) {
          return body(a232, b232, c232, d232);
        }
        return function(self2) {
          return body(self2, a232, b232, c232);
        };
      };
    case 5:
      return function(a232, b232, c232, d232, e232) {
        if (arguments.length >= 5) {
          return body(a232, b232, c232, d232, e232);
        }
        return function(self2) {
          return body(self2, a232, b232, c232, d232);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply2232 = (a232) => (self2) => self2(a232);
var identity2232 = (a232) => a232;
var satisfies2232 = () => (b232) => b232;
var unsafeCoerce2232 = identity2232;
var constant2232 = (value) => () => value;
var constTrue2232 = /* @__PURE__ */ constant2232(true);
var constFalse2232 = /* @__PURE__ */ constant2232(false);
var constNull2232 = /* @__PURE__ */ constant2232(null);
var constUndefined2232 = /* @__PURE__ */ constant2232(void 0);
var constVoid2232 = constUndefined2232;
var flip2232 = (f232) => (...b232) => (...a232) => f232(...a232)(...b232);
var compose2242 = /* @__PURE__ */ dual2232(2, (ab, bc) => (a232) => bc(ab(a232)));
var absurd2232 = (_232) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled2232 = (f232) => (a232) => f232(...a232);
var untupled2232 = (f232) => (...a232) => f232(a232);
function pipe2232(a232, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a232;
    case 2:
      return ab(a232);
    case 3:
      return bc(ab(a232));
    case 4:
      return cd(bc(ab(a232)));
    case 5:
      return de(cd(bc(ab(a232))));
    case 6:
      return ef(de(cd(bc(ab(a232)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a232))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a232)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a232))))))));
    default: {
      let ret = arguments[0];
      for (let i232 = 1; i232 < arguments.length; i232++) {
        ret = arguments[i232](ret);
      }
      return ret;
    }
  }
}
function flow2232(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole2232 = /* @__PURE__ */ unsafeCoerce2232(absurd2232);
var SK2232 = (_232, b232) => b232;
var make4242 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_3232 = (map622) => dual2232(3, (self2, name22, f232) => map622(self2, (a232) => Object.assign({}, a232, {
  [name22]: f232(a232)
})));
var bindTo3232 = (map622) => dual2232(2, (self2, name22) => map622(self2, (a232) => ({
  [name22]: a232
})));
var bind3232 = (map622, flatMap4222) => dual2232(3, (self2, name22, f232) => flatMap4222(self2, (a232) => map622(f232(a232), (b232) => Object.assign({}, a232, {
  [name22]: b232
}))));
var moduleVersion2232 = "3.2.8";
var getCurrentVersion2232 = () => moduleVersion2232;
var globalStoreId2232 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion2232()}`);
if (!(globalStoreId2232 in globalThis)) {
  globalThis[globalStoreId2232] = /* @__PURE__ */ new Map();
}
var globalStore2232 = globalThis[globalStoreId2232];
var globalValue2232 = (id, compute) => {
  if (!globalStore2232.has(id)) {
    globalStore2232.set(id, compute());
  }
  return globalStore2232.get(id);
};
var Predicate_exports2232 = {};
__export2232(Predicate_exports2232, {
  all: () => all2242,
  and: () => and322,
  compose: () => compose22232,
  eqv: () => eqv322,
  every: () => every422,
  hasProperty: () => hasProperty2232,
  implies: () => implies322,
  isBigInt: () => isBigInt322,
  isBoolean: () => isBoolean322,
  isDate: () => isDate322,
  isError: () => isError322,
  isFunction: () => isFunction3242,
  isIterable: () => isIterable322,
  isMap: () => isMap322,
  isNever: () => isNever322,
  isNotNull: () => isNotNull322,
  isNotNullable: () => isNotNullable322,
  isNotUndefined: () => isNotUndefined322,
  isNull: () => isNull322,
  isNullable: () => isNullable2232,
  isNumber: () => isNumber322,
  isObject: () => isObject2232,
  isPromise: () => isPromise322,
  isPromiseLike: () => isPromiseLike322,
  isReadonlyRecord: () => isReadonlyRecord322,
  isRecord: () => isRecord322,
  isSet: () => isSet322,
  isString: () => isString322,
  isSymbol: () => isSymbol322,
  isTagged: () => isTagged322,
  isTruthy: () => isTruthy322,
  isUint8Array: () => isUint8Array322,
  isUndefined: () => isUndefined322,
  isUnknown: () => isUnknown322,
  mapInput: () => mapInput422,
  nand: () => nand322,
  nor: () => nor322,
  not: () => not322,
  or: () => or322,
  product: () => product2242,
  productMany: () => productMany2242,
  some: () => some3242,
  struct: () => struct522,
  tuple: () => tuple422,
  xor: () => xor322
});
var mapInput422 = /* @__PURE__ */ dual2232(2, (self2, f232) => (b232) => self2(f232(b232)));
var isTruthy322 = (input) => !!input;
var isSet322 = (input) => input instanceof Set;
var isMap322 = (input) => input instanceof Map;
var isString322 = (input) => typeof input === "string";
var isNumber322 = (input) => typeof input === "number";
var isBoolean322 = (input) => typeof input === "boolean";
var isBigInt322 = (input) => typeof input === "bigint";
var isSymbol322 = (input) => typeof input === "symbol";
var isFunction3242 = isFunction22232;
var isUndefined322 = (input) => input === void 0;
var isNotUndefined322 = (input) => input !== void 0;
var isNull322 = (input) => input === null;
var isNotNull322 = (input) => input !== null;
var isNever322 = (_232) => false;
var isUnknown322 = (_232) => true;
var isRecordOrArray2232 = (input) => typeof input === "object" && input !== null;
var isObject2232 = (input) => isRecordOrArray2232(input) || isFunction3242(input);
var hasProperty2232 = /* @__PURE__ */ dual2232(2, (self2, property) => isObject2232(self2) && property in self2);
var isTagged322 = /* @__PURE__ */ dual2232(2, (self2, tag) => hasProperty2232(self2, "_tag") && self2["_tag"] === tag);
var isNullable2232 = (input) => input === null || input === void 0;
var isNotNullable322 = (input) => input !== null && input !== void 0;
var isError322 = (input) => input instanceof Error;
var isUint8Array322 = (input) => input instanceof Uint8Array;
var isDate322 = (input) => input instanceof Date;
var isIterable322 = (input) => hasProperty2232(input, Symbol.iterator);
var isRecord322 = (input) => isRecordOrArray2232(input) && !Array.isArray(input);
var isReadonlyRecord322 = isRecord322;
var isPromise322 = (input) => hasProperty2232(input, "then") && "catch" in input && isFunction3242(input.then) && isFunction3242(input.catch);
var isPromiseLike322 = (input) => hasProperty2232(input, "then") && isFunction3242(input.then);
var compose22232 = /* @__PURE__ */ dual2232(2, (ab, bc) => (a232) => ab(a232) && bc(a232));
var product2242 = (self2, that) => ([a232, b232]) => self2(a232) && that(b232);
var all2242 = (collection) => {
  return (as22232) => {
    let collectionIndex = 0;
    for (const p232 of collection) {
      if (collectionIndex >= as22232.length) {
        break;
      }
      if (p232(as22232[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany2242 = (self2, collection) => {
  const rest = all2242(collection);
  return ([head222, ...tail222]) => self2(head222) === false ? false : rest(tail222);
};
var tuple422 = (...elements) => all2242(elements);
var struct522 = (fields) => {
  const keys2232 = Object.keys(fields);
  return (a232) => {
    for (const key of keys2232) {
      if (!fields[key](a232[key])) {
        return false;
      }
    }
    return true;
  };
};
var not322 = (self2) => (a232) => !self2(a232);
var or322 = /* @__PURE__ */ dual2232(2, (self2, that) => (a232) => self2(a232) || that(a232));
var and322 = /* @__PURE__ */ dual2232(2, (self2, that) => (a232) => self2(a232) && that(a232));
var xor322 = /* @__PURE__ */ dual2232(2, (self2, that) => (a232) => self2(a232) !== that(a232));
var eqv322 = /* @__PURE__ */ dual2232(2, (self2, that) => (a232) => self2(a232) === that(a232));
var implies322 = /* @__PURE__ */ dual2232(2, (self2, that) => (a232) => self2(a232) ? that(a232) : true);
var nor322 = /* @__PURE__ */ dual2232(2, (self2, that) => (a232) => !(self2(a232) || that(a232)));
var nand322 = /* @__PURE__ */ dual2232(2, (self2, that) => (a232) => !(self2(a232) && that(a232)));
var every422 = (collection) => (a232) => {
  for (const p232 of collection) {
    if (!p232(a232)) {
      return false;
    }
  }
  return true;
};
var some3242 = (collection) => (a232) => {
  for (const p232 of collection) {
    if (p232(a232)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage2232 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId2232 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind2232 = (u232) => isObject2232(u232) && GenKindTypeId2232 in u232;
var GenKindImpl2232 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity2232;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId2232] = GenKindTypeId2232;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen2242(this);
  }
};
var SingleShotGen2242 = class _SingleShotGen422 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a232) {
    return this.called ? {
      value: a232,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a232) {
    return {
      value: a232,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e232) {
    throw e232;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen422(this.self);
  }
};
var adapter3232 = () => function() {
  let x232 = arguments[0];
  for (let i232 = 1; i232 < arguments.length; i232++) {
    x232 = arguments[i232](x232);
  }
  return new GenKindImpl2232(x232);
};
var defaultIncHi2232 = 335903614;
var defaultIncLo2232 = 4150755663;
var MUL_HI2232 = 1481765933 >>> 0;
var MUL_LO2232 = 1284865837 >>> 0;
var BIT_532232 = 9007199254740992;
var BIT_272232 = 134217728;
var PCGRandom2232 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable2232(seedLo) && isNullable2232(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable2232(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable2232(incLo) && isNullable2232(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo2232;
      incHi = this._state ? this._state[2] : defaultIncHi2232;
    } else if (isNullable2232(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add642232(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max322) {
    if (!max322) {
      return this._next();
    }
    max322 = max322 >>> 0;
    if ((max322 & max322 - 1) === 0) {
      return this._next() & max322 - 1;
    }
    let num = 0;
    const skew = (-max322 >>> 0) % max322 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max322;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_272232 + lo) / BIT_532232;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul642232(this._state, oldHi, oldLo, MUL_HI2232, MUL_LO2232);
    add642232(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul642232(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add642232(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId2232 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap2232 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId2232]() {
    return this.#value;
  }
};
function yieldWrapGet2232(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId2232 in self2) {
    return self2[YieldWrapTypeId2232]();
  }
  throw new Error(getBugErrorMessage2232("yieldWrapGet"));
}
var structuralRegionState2232 = /* @__PURE__ */ globalValue2232("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache2232 = /* @__PURE__ */ globalValue2232(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr2232 = /* @__PURE__ */ globalValue2232(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom2232());
var symbol3232 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash2232 = (self2) => {
  if (structuralRegionState2232.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number2232(self2);
    case "bigint":
      return string2232(self2.toString(10));
    case "boolean":
      return string2232(String(self2));
    case "symbol":
      return string2232(String(self2));
    case "string":
      return string2232(self2);
    case "undefined":
      return string2232("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string2232("null");
      } else if (self2 instanceof Date) {
        return hash2232(self2.toISOString());
      } else if (isHash2232(self2)) {
        return self2[symbol3232]();
      } else {
        return random2232(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random2232 = (self2) => {
  if (!randomHashCache2232.has(self2)) {
    randomHashCache2232.set(self2, number2232(pcgr2232.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache2232.get(self2);
};
var combine2242 = (b232) => (self2) => self2 * 53 ^ b232;
var optimize2232 = (n232) => n232 & 3221225471 | n232 >>> 1 & 1073741824;
var isHash2232 = (u232) => hasProperty2232(u232, symbol3232);
var number2232 = (n232) => {
  if (n232 !== n232 || n232 === Infinity) {
    return 0;
  }
  let h232 = n232 | 0;
  if (h232 !== n232) {
    h232 ^= n232 * 4294967295;
  }
  while (n232 > 4294967295) {
    h232 ^= n232 /= 4294967295;
  }
  return optimize2232(n232);
};
var string2232 = (str) => {
  let h232 = 5381, i232 = str.length;
  while (i232) {
    h232 = h232 * 33 ^ str.charCodeAt(--i232);
  }
  return optimize2232(h232);
};
var structureKeys2232 = (o232, keys2232) => {
  let h232 = 12289;
  for (let i232 = 0; i232 < keys2232.length; i232++) {
    h232 ^= pipe2232(string2232(keys2232[i232]), combine2242(hash2232(o232[keys2232[i232]])));
  }
  return optimize2232(h232);
};
var structure2232 = (o232) => structureKeys2232(o232, Object.keys(o232));
var array522 = (arr) => {
  let h232 = 6151;
  for (let i232 = 0; i232 < arr.length; i232++) {
    h232 = pipe2232(h232, combine2242(hash2232(arr[i232])));
  }
  return optimize2232(h232);
};
var cached2232 = function() {
  if (arguments.length === 1) {
    const self22 = arguments[0];
    return function(hash3222) {
      Object.defineProperty(self22, symbol3232, {
        value() {
          return hash3222;
        },
        enumerable: false
      });
      return hash3222;
    };
  }
  const self2 = arguments[0];
  const hash22232 = arguments[1];
  Object.defineProperty(self2, symbol3232, {
    value() {
      return hash22232;
    },
    enumerable: false
  });
  return hash22232;
};
var symbol22232 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals2232() {
  if (arguments.length === 1) {
    return (self2) => compareBoth2232(self2, arguments[0]);
  }
  return compareBoth2232(arguments[0], arguments[1]);
}
function compareBoth2232(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual2232(self2) && isEqual2232(that)) {
        if (hash2232(self2) === hash2232(that) && self2[symbol22232](that)) {
          return true;
        } else {
          return structuralRegionState2232.enabled && structuralRegionState2232.tester ? structuralRegionState2232.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState2232.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v232, i232) => compareBoth2232(v232, that[i232]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth2232(self2[key], that[key]))) {
              return structuralRegionState2232.tester ? structuralRegionState2232.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState2232.tester ? structuralRegionState2232.tester(self2, that) : false;
    }
  }
  return structuralRegionState2232.enabled && structuralRegionState2232.tester ? structuralRegionState2232.tester(self2, that) : false;
}
var isEqual2232 = (u232) => hasProperty2232(u232, symbol22232);
var equivalence2232 = () => equals2232;
var NodeInspectSymbol2232 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON2232 = (x232) => {
  if (hasProperty2232(x232, "toJSON") && isFunction3242(x232["toJSON"]) && x232["toJSON"].length === 0) {
    return x232.toJSON();
  } else if (Array.isArray(x232)) {
    return x232.map(toJSON2232);
  }
  return x232;
};
var format2232 = (x232) => JSON.stringify(x232, null, 2);
var pipeArguments2232 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i232 = 0, len = args.length; i232 < len; i232++) {
        ret = args[i232](ret);
      }
      return ret;
    }
  }
};
var OP_COMMIT2232 = "Commit";
var OP_FAILURE232 = "Failure";
var OP_WITH_RUNTIME232 = "WithRuntime";
var EffectTypeId2242 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId2232 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId2232 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId2232 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance2232 = {
  /* c8 ignore next */
  _R: (_232) => _232,
  /* c8 ignore next */
  _E: (_232) => _232,
  /* c8 ignore next */
  _A: (_232) => _232,
  _V: /* @__PURE__ */ getCurrentVersion2232()
};
var sinkVariance2232 = {
  /* c8 ignore next */
  _A: (_232) => _232,
  /* c8 ignore next */
  _In: (_232) => _232,
  /* c8 ignore next */
  _L: (_232) => _232,
  /* c8 ignore next */
  _E: (_232) => _232,
  /* c8 ignore next */
  _R: (_232) => _232
};
var channelVariance2232 = {
  /* c8 ignore next */
  _Env: (_232) => _232,
  /* c8 ignore next */
  _InErr: (_232) => _232,
  /* c8 ignore next */
  _InElem: (_232) => _232,
  /* c8 ignore next */
  _InDone: (_232) => _232,
  /* c8 ignore next */
  _OutErr: (_232) => _232,
  /* c8 ignore next */
  _OutElem: (_232) => _232,
  /* c8 ignore next */
  _OutDone: (_232) => _232
};
var EffectPrototype2232 = {
  [EffectTypeId2242]: effectVariance2232,
  [StreamTypeId2232]: effectVariance2232,
  [SinkTypeId2232]: sinkVariance2232,
  [ChannelTypeId2232]: channelVariance2232,
  [symbol22232](that) {
    return this === that;
  },
  [symbol3232]() {
    return cached2232(this, random2232(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen2242(new YieldWrap2232(this));
  },
  pipe() {
    return pipeArguments2232(this, arguments);
  }
};
var StructuralPrototype2232 = {
  [symbol3232]() {
    return cached2232(this, structure2232(this));
  },
  [symbol22232](that) {
    const selfKeys = Object.keys(this);
    const thatKeys = Object.keys(that);
    if (selfKeys.length !== thatKeys.length) {
      return false;
    }
    for (const key of selfKeys) {
      if (!(key in that && equals2232(this[key], that[key]))) {
        return false;
      }
    }
    return true;
  }
};
var CommitPrototype2232 = {
  ...EffectPrototype2232,
  _op: OP_COMMIT2232
};
var StructuralCommitPrototype2232 = {
  ...CommitPrototype2232,
  ...StructuralPrototype2232
};
var TypeId5242 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto3232 = {
  ...EffectPrototype2232,
  [TypeId5242]: {
    _A: (_232) => _232
  },
  [NodeInspectSymbol2232]() {
    return this.toJSON();
  },
  toString() {
    return format2232(this.toJSON());
  }
};
var SomeProto2232 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto3232), {
  _tag: "Some",
  _op: "Some",
  [symbol22232](that) {
    return isOption3232(that) && isSome3232(that) && equals2232(this.value, that.value);
  },
  [symbol3232]() {
    return cached2232(this, combine2242(hash2232(this._tag))(hash2232(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON2232(this.value)
    };
  }
});
var NoneHash2232 = /* @__PURE__ */ hash2232("None");
var NoneProto2232 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto3232), {
  _tag: "None",
  _op: "None",
  [symbol22232](that) {
    return isOption3232(that) && isNone3232(that);
  },
  [symbol3232]() {
    return NoneHash2232;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption3232 = (input) => hasProperty2232(input, TypeId5242);
var isNone3232 = (fa) => fa._tag === "None";
var isSome3232 = (fa) => fa._tag === "Some";
var none3232 = /* @__PURE__ */ Object.create(NoneProto2232);
var some22232 = (value) => {
  const a232 = Object.create(SomeProto2232);
  a232.value = value;
  return a232;
};
var TypeId22232 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto22232 = {
  ...EffectPrototype2232,
  [TypeId22232]: {
    _R: (_232) => _232
  },
  [NodeInspectSymbol2232]() {
    return this.toJSON();
  },
  toString() {
    return format2232(this.toJSON());
  }
};
var RightProto2232 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto22232), {
  _tag: "Right",
  _op: "Right",
  [symbol22232](that) {
    return isEither2232(that) && isRight2232(that) && equals2232(this.right, that.right);
  },
  [symbol3232]() {
    return combine2242(hash2232(this._tag))(hash2232(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON2232(this.right)
    };
  }
});
var LeftProto2232 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto22232), {
  _tag: "Left",
  _op: "Left",
  [symbol22232](that) {
    return isEither2232(that) && isLeft2232(that) && equals2232(this.left, that.left);
  },
  [symbol3232]() {
    return combine2242(hash2232(this._tag))(hash2232(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON2232(this.left)
    };
  }
});
var isEither2232 = (input) => hasProperty2232(input, TypeId22232);
var isLeft2232 = (ma) => ma._tag === "Left";
var isRight2232 = (ma) => ma._tag === "Right";
var left2242 = (left3232) => {
  const a232 = Object.create(LeftProto2232);
  a232.left = left3232;
  return a232;
};
var right2242 = (right3232) => {
  const a232 = Object.create(RightProto2232);
  a232.right = right3232;
  return a232;
};
var getLeft3232 = (self2) => isRight2232(self2) ? none3232 : some22232(self2.left);
var getRight3232 = (self2) => isLeft2232(self2) ? none3232 : some22232(self2.right);
var right22232 = right2242;
var left22232 = left2242;
var Option_exports2232 = {};
__export2232(Option_exports2232, {
  Do: () => Do2232,
  TypeId: () => TypeId32232,
  all: () => all22232,
  andThen: () => andThen2232,
  ap: () => ap2232,
  as: () => as2232,
  asVoid: () => asVoid2232,
  bind: () => bind22232,
  bindTo: () => bindTo22232,
  composeK: () => composeK2232,
  contains: () => contains2232,
  containsWith: () => containsWith2232,
  exists: () => exists2232,
  filter: () => filter2232,
  filterMap: () => filterMap2232,
  firstSomeOf: () => firstSomeOf2232,
  flatMap: () => flatMap2232,
  flatMapNullable: () => flatMapNullable2232,
  flatten: () => flatten2232,
  fromIterable: () => fromIterable2242,
  fromNullable: () => fromNullable2232,
  gen: () => gen2232,
  getEquivalence: () => getEquivalence2242,
  getLeft: () => getLeft22232,
  getOrElse: () => getOrElse2232,
  getOrNull: () => getOrNull2232,
  getOrThrow: () => getOrThrow2232,
  getOrThrowWith: () => getOrThrowWith2232,
  getOrUndefined: () => getOrUndefined2232,
  getOrder: () => getOrder2232,
  getRight: () => getRight22232,
  isNone: () => isNone22232,
  isOption: () => isOption22232,
  isSome: () => isSome22232,
  let: () => let_22232,
  lift2: () => lift22232,
  liftNullable: () => liftNullable2232,
  liftPredicate: () => liftPredicate2232,
  liftThrowable: () => liftThrowable2232,
  map: () => map2232,
  match: () => match2232,
  none: () => none22232,
  orElse: () => orElse2232,
  orElseEither: () => orElseEither2232,
  orElseSome: () => orElseSome2232,
  partitionMap: () => partitionMap2232,
  product: () => product22232,
  productMany: () => productMany22232,
  reduceCompact: () => reduceCompact2232,
  some: () => some32232,
  tap: () => tap2232,
  toArray: () => toArray2232,
  toRefinement: () => toRefinement2232,
  void: () => void_2232,
  zipLeft: () => zipLeft2232,
  zipRight: () => zipRight2232,
  zipWith: () => zipWith2232
});
var make22232 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId32232 = /* @__PURE__ */ Symbol.for("effect/Option");
var none22232 = () => none3232;
var some32232 = some22232;
var isOption22232 = isOption3232;
var isNone22232 = isNone3232;
var isSome22232 = isSome3232;
var match2232 = /* @__PURE__ */ dual2232(2, (self2, {
  onNone,
  onSome
}) => isNone22232(self2) ? onNone() : onSome(self2.value));
var toRefinement2232 = (f232) => (a232) => isSome22232(f232(a232));
var fromIterable2242 = (collection) => {
  for (const a232 of collection) {
    return some32232(a232);
  }
  return none22232();
};
var getRight22232 = getRight3232;
var getLeft22232 = getLeft3232;
var getOrElse2232 = /* @__PURE__ */ dual2232(2, (self2, onNone) => isNone22232(self2) ? onNone() : self2.value);
var orElse2232 = /* @__PURE__ */ dual2232(2, (self2, that) => isNone22232(self2) ? that() : self2);
var orElseSome2232 = /* @__PURE__ */ dual2232(2, (self2, onNone) => isNone22232(self2) ? some32232(onNone()) : self2);
var orElseEither2232 = /* @__PURE__ */ dual2232(2, (self2, that) => isNone22232(self2) ? map2232(that(), right2242) : map2232(self2, left2242));
var firstSomeOf2232 = (collection) => {
  let out = none22232();
  for (out of collection) {
    if (isSome22232(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable2232 = (nullableValue) => nullableValue == null ? none22232() : some32232(nullableValue);
var liftNullable2232 = (f232) => (...a232) => fromNullable2232(f232(...a232));
var getOrNull2232 = /* @__PURE__ */ getOrElse2232(constNull2232);
var getOrUndefined2232 = /* @__PURE__ */ getOrElse2232(constUndefined2232);
var liftThrowable2232 = (f232) => (...a232) => {
  try {
    return some32232(f232(...a232));
  } catch (e232) {
    return none22232();
  }
};
var getOrThrowWith2232 = /* @__PURE__ */ dual2232(2, (self2, onNone) => {
  if (isSome22232(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow2232 = /* @__PURE__ */ getOrThrowWith2232(() => new Error("getOrThrow called on a None"));
var map2232 = /* @__PURE__ */ dual2232(2, (self2, f232) => isNone22232(self2) ? none22232() : some32232(f232(self2.value)));
var as2232 = /* @__PURE__ */ dual2232(2, (self2, b232) => map2232(self2, () => b232));
var asVoid2232 = /* @__PURE__ */ as2232(void 0);
var void_2232 = /* @__PURE__ */ some32232(void 0);
var flatMap2232 = /* @__PURE__ */ dual2232(2, (self2, f232) => isNone22232(self2) ? none22232() : f232(self2.value));
var andThen2232 = /* @__PURE__ */ dual2232(2, (self2, f232) => flatMap2232(self2, (a232) => {
  const b232 = isFunction22232(f232) ? f232(a232) : f232;
  return isOption22232(b232) ? b232 : some32232(b232);
}));
var flatMapNullable2232 = /* @__PURE__ */ dual2232(2, (self2, f232) => isNone22232(self2) ? none22232() : fromNullable2232(f232(self2.value)));
var flatten2232 = /* @__PURE__ */ flatMap2232(identity2232);
var zipRight2232 = /* @__PURE__ */ dual2232(2, (self2, that) => flatMap2232(self2, () => that));
var composeK2232 = /* @__PURE__ */ dual2232(2, (afb, bfc) => (a232) => flatMap2232(afb(a232), bfc));
var zipLeft2232 = /* @__PURE__ */ dual2232(2, (self2, that) => tap2232(self2, () => that));
var tap2232 = /* @__PURE__ */ dual2232(2, (self2, f232) => flatMap2232(self2, (a232) => map2232(f232(a232), () => a232)));
var product22232 = (self2, that) => isSome22232(self2) && isSome22232(that) ? some32232([self2.value, that.value]) : none22232();
var productMany22232 = (self2, collection) => {
  if (isNone22232(self2)) {
    return none22232();
  }
  const out = [self2.value];
  for (const o232 of collection) {
    if (isNone22232(o232)) {
      return none22232();
    }
    out.push(o232.value);
  }
  return some32232(out);
};
var all22232 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o232 of input) {
      if (isNone22232(o232)) {
        return none22232();
      }
      out2.push(o232.value);
    }
    return some32232(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o232 = input[key];
    if (isNone22232(o232)) {
      return none22232();
    }
    out[key] = o232.value;
  }
  return some32232(out);
};
var zipWith2232 = /* @__PURE__ */ dual2232(3, (self2, that, f232) => map2232(product22232(self2, that), ([a232, b232]) => f232(a232, b232)));
var ap2232 = /* @__PURE__ */ dual2232(2, (self2, that) => zipWith2232(self2, that, (f232, a232) => f232(a232)));
var reduceCompact2232 = /* @__PURE__ */ dual2232(3, (self2, b232, f232) => {
  let out = b232;
  for (const oa of self2) {
    if (isSome22232(oa)) {
      out = f232(out, oa.value);
    }
  }
  return out;
});
var toArray2232 = (self2) => isNone22232(self2) ? [] : [self2.value];
var partitionMap2232 = /* @__PURE__ */ dual2232(2, (self2, f232) => {
  if (isNone22232(self2)) {
    return [none22232(), none22232()];
  }
  const e232 = f232(self2.value);
  return isLeft2232(e232) ? [some32232(e232.left), none22232()] : [none22232(), some32232(e232.right)];
});
var filterMap2232 = /* @__PURE__ */ dual2232(2, (self2, f232) => isNone22232(self2) ? none22232() : f232(self2.value));
var filter2232 = /* @__PURE__ */ dual2232(2, (self2, predicate) => filterMap2232(self2, (b232) => predicate(b232) ? some22232(b232) : none3232));
var getEquivalence2242 = (isEquivalent) => make4242((x232, y232) => x232 === y232 || (isNone22232(x232) ? isNone22232(y232) : isNone22232(y232) ? false : isEquivalent(x232.value, y232.value)));
var getOrder2232 = (O232) => make22232((self2, that) => isSome22232(self2) ? isSome22232(that) ? O232(self2.value, that.value) : 1 : -1);
var lift22232 = (f232) => dual2232(2, (self2, that) => zipWith2232(self2, that, f232));
var liftPredicate2232 = (predicate) => (b232) => predicate(b232) ? some32232(b232) : none22232();
var containsWith2232 = (isEquivalent) => dual2232(2, (self2, a232) => isNone22232(self2) ? false : isEquivalent(self2.value, a232));
var _equivalence2242 = /* @__PURE__ */ equivalence2232();
var contains2232 = /* @__PURE__ */ containsWith2232(_equivalence2242);
var exists2232 = /* @__PURE__ */ dual2232(2, (self2, refinement) => isNone22232(self2) ? false : refinement(self2.value));
var bindTo22232 = /* @__PURE__ */ bindTo3232(map2232);
var let_22232 = /* @__PURE__ */ let_3232(map2232);
var bind22232 = /* @__PURE__ */ bind3232(map2232, flatMap2232);
var Do2232 = /* @__PURE__ */ some32232({});
var adapter22232 = /* @__PURE__ */ adapter3232();
var gen2232 = (f232) => {
  const iterator = f232(adapter22232);
  let state = iterator.next();
  if (state.done) {
    return some32232(state.value);
  } else {
    let current = state.value;
    if (isGenKind2232(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet2232(current);
    }
    if (isNone22232(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind2232(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet2232(current);
        }
        if (isNone22232(current)) {
          return current;
        }
      }
    }
    return some32232(state.value);
  }
};
var fromIterable22232 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var reverse422 = (self2) => Array.from(self2).reverse();
var reduce522 = /* @__PURE__ */ dual2232(3, (self2, b232, f232) => fromIterable22232(self2).reduce((b2222, a232, i232) => f232(b2222, a232, i232), b232));
var TagTypeId232 = /* @__PURE__ */ Symbol.for("effect/Context/Tag");
var STMSymbolKey232 = "effect/STM";
var STMTypeId232 = /* @__PURE__ */ Symbol.for(STMSymbolKey232);
var TagProto232 = {
  ...EffectPrototype2232,
  _tag: "Tag",
  _op: "Tag",
  [STMTypeId232]: effectVariance2232,
  [TagTypeId232]: {
    _Service: (_232) => _232,
    _Identifier: (_232) => _232
  },
  toString() {
    return format2232(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Tag",
      key: this.key,
      stack: this.stack
    };
  },
  [NodeInspectSymbol2232]() {
    return this.toJSON();
  },
  of(self2) {
    return self2;
  },
  context(self2) {
    return make32232(this, self2);
  }
};
var makeGenericTag232 = (key) => {
  const limit = Error.stackTraceLimit;
  Error.stackTraceLimit = 2;
  const creationError = new Error();
  Error.stackTraceLimit = limit;
  const tag = Object.create(TagProto232);
  Object.defineProperty(tag, "stack", {
    get() {
      return creationError.stack;
    }
  });
  tag.key = key;
  return tag;
};
var TypeId42232 = /* @__PURE__ */ Symbol.for("effect/Context");
var ContextProto232 = {
  [TypeId42232]: {
    _Services: (_232) => _232
  },
  [symbol22232](that) {
    if (isContext232(that)) {
      if (this.unsafeMap.size === that.unsafeMap.size) {
        for (const k232 of this.unsafeMap.keys()) {
          if (!that.unsafeMap.has(k232) || !equals2232(this.unsafeMap.get(k232), that.unsafeMap.get(k232))) {
            return false;
          }
        }
        return true;
      }
    }
    return false;
  },
  [symbol3232]() {
    return cached2232(this, number2232(this.unsafeMap.size));
  },
  pipe() {
    return pipeArguments2232(this, arguments);
  },
  toString() {
    return format2232(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Context",
      services: Array.from(this.unsafeMap).map(toJSON2232)
    };
  },
  [NodeInspectSymbol2232]() {
    return this.toJSON();
  }
};
var makeContext232 = (unsafeMap) => {
  const context = Object.create(ContextProto232);
  context.unsafeMap = unsafeMap;
  return context;
};
var isContext232 = (u232) => hasProperty2232(u232, TypeId42232);
var _empty632 = /* @__PURE__ */ makeContext232(/* @__PURE__ */ new Map());
var empty1022 = () => _empty632;
var make32232 = (tag, service) => makeContext232(/* @__PURE__ */ new Map([[tag.key, service]]));
var GenericTag232 = makeGenericTag232;
var empty2232 = empty1022;
var TypeId52232 = /* @__PURE__ */ Symbol.for("effect/Chunk");
function copy322(src, srcPos, dest, destPos, len) {
  for (let i232 = srcPos; i232 < Math.min(src.length, srcPos + len); i232++) {
    dest[destPos + i232 - srcPos] = src[i232];
  }
  return dest;
}
var emptyArray232 = [];
var getEquivalence22232 = (isEquivalent) => make4242((self2, that) => self2.length === that.length && toReadonlyArray232(self2).every((value, i232) => isEquivalent(value, unsafeGet2232(that, i232))));
var _equivalence22232 = /* @__PURE__ */ getEquivalence22232(equals2232);
var ChunkProto232 = {
  [TypeId52232]: {
    _A: (_232) => _232
  },
  toString() {
    return format2232(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Chunk",
      values: toReadonlyArray232(this).map(toJSON2232)
    };
  },
  [NodeInspectSymbol2232]() {
    return this.toJSON();
  },
  [symbol22232](that) {
    return isChunk232(that) && _equivalence22232(this, that);
  },
  [symbol3232]() {
    return cached2232(this, array522(toReadonlyArray232(this)));
  },
  [Symbol.iterator]() {
    switch (this.backing._tag) {
      case "IArray": {
        return this.backing.array[Symbol.iterator]();
      }
      case "IEmpty": {
        return emptyArray232[Symbol.iterator]();
      }
      default: {
        return toReadonlyArray232(this)[Symbol.iterator]();
      }
    }
  },
  pipe() {
    return pipeArguments2232(this, arguments);
  }
};
var makeChunk232 = (backing) => {
  const chunk = Object.create(ChunkProto232);
  chunk.backing = backing;
  switch (backing._tag) {
    case "IEmpty": {
      chunk.length = 0;
      chunk.depth = 0;
      chunk.left = chunk;
      chunk.right = chunk;
      break;
    }
    case "IConcat": {
      chunk.length = backing.left.length + backing.right.length;
      chunk.depth = 1 + Math.max(backing.left.depth, backing.right.depth);
      chunk.left = backing.left;
      chunk.right = backing.right;
      break;
    }
    case "IArray": {
      chunk.length = backing.array.length;
      chunk.depth = 0;
      chunk.left = _empty2232;
      chunk.right = _empty2232;
      break;
    }
    case "ISingleton": {
      chunk.length = 1;
      chunk.depth = 0;
      chunk.left = _empty2232;
      chunk.right = _empty2232;
      break;
    }
    case "ISlice": {
      chunk.length = backing.length;
      chunk.depth = backing.chunk.depth + 1;
      chunk.left = _empty2232;
      chunk.right = _empty2232;
      break;
    }
  }
  return chunk;
};
var isChunk232 = (u232) => hasProperty2232(u232, TypeId52232);
var _empty2232 = /* @__PURE__ */ makeChunk232({
  _tag: "IEmpty"
});
var empty3232 = () => _empty2232;
var make42232 = (...as22232) => as22232.length === 1 ? of322(as22232[0]) : unsafeFromNonEmptyArray232(as22232);
var of322 = (a232) => makeChunk232({
  _tag: "ISingleton",
  a: a232
});
var copyToArray232 = (self2, array3232, initial) => {
  switch (self2.backing._tag) {
    case "IArray": {
      copy322(self2.backing.array, 0, array3232, initial, self2.length);
      break;
    }
    case "IConcat": {
      copyToArray232(self2.left, array3232, initial);
      copyToArray232(self2.right, array3232, initial + self2.left.length);
      break;
    }
    case "ISingleton": {
      array3232[initial] = self2.backing.a;
      break;
    }
    case "ISlice": {
      let i232 = 0;
      let j232 = initial;
      while (i232 < self2.length) {
        array3232[j232] = unsafeGet2232(self2, i232);
        i232 += 1;
        j232 += 1;
      }
      break;
    }
  }
};
var toReadonlyArray232 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      return emptyArray232;
    }
    case "IArray": {
      return self2.backing.array;
    }
    default: {
      const arr = new Array(self2.length);
      copyToArray232(self2, arr, 0);
      self2.backing = {
        _tag: "IArray",
        array: arr
      };
      self2.left = _empty2232;
      self2.right = _empty2232;
      self2.depth = 0;
      return arr;
    }
  }
};
var reverse2232 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty":
    case "ISingleton":
      return self2;
    case "IArray": {
      return makeChunk232({
        _tag: "IArray",
        array: reverse422(self2.backing.array)
      });
    }
    case "IConcat": {
      return makeChunk232({
        _tag: "IConcat",
        left: reverse2232(self2.backing.right),
        right: reverse2232(self2.backing.left)
      });
    }
    case "ISlice":
      return unsafeFromArray232(reverse422(toReadonlyArray232(self2)));
  }
};
var unsafeFromArray232 = (self2) => makeChunk232({
  _tag: "IArray",
  array: self2
});
var unsafeFromNonEmptyArray232 = (self2) => unsafeFromArray232(self2);
var unsafeGet2232 = /* @__PURE__ */ dual2232(2, (self2, index) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      throw new Error(`Index out of bounds`);
    }
    case "ISingleton": {
      if (index !== 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.a;
    }
    case "IArray": {
      if (index >= self2.length || index < 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.array[index];
    }
    case "IConcat": {
      return index < self2.left.length ? unsafeGet2232(self2.left, index) : unsafeGet2232(self2.right, index - self2.left.length);
    }
    case "ISlice": {
      return unsafeGet2232(self2.backing.chunk, index + self2.backing.offset);
    }
  }
});
var prepend322 = /* @__PURE__ */ dual2232(2, (self2, elem) => appendAll322(of322(elem), self2));
var drop322 = /* @__PURE__ */ dual2232(2, (self2, n232) => {
  if (n232 <= 0) {
    return self2;
  } else if (n232 >= self2.length) {
    return _empty2232;
  } else {
    switch (self2.backing._tag) {
      case "ISlice": {
        return makeChunk232({
          _tag: "ISlice",
          chunk: self2.backing.chunk,
          offset: self2.backing.offset + n232,
          length: self2.backing.length - n232
        });
      }
      case "IConcat": {
        if (n232 > self2.left.length) {
          return drop322(self2.right, n232 - self2.left.length);
        }
        return makeChunk232({
          _tag: "IConcat",
          left: drop322(self2.left, n232),
          right: self2.right
        });
      }
      default: {
        return makeChunk232({
          _tag: "ISlice",
          chunk: self2,
          offset: n232,
          length: self2.length - n232
        });
      }
    }
  }
});
var appendAll322 = /* @__PURE__ */ dual2232(2, (self2, that) => {
  if (self2.backing._tag === "IEmpty") {
    return that;
  }
  if (that.backing._tag === "IEmpty") {
    return self2;
  }
  const diff2232 = that.depth - self2.depth;
  if (Math.abs(diff2232) <= 1) {
    return makeChunk232({
      _tag: "IConcat",
      left: self2,
      right: that
    });
  } else if (diff2232 < -1) {
    if (self2.left.depth >= self2.right.depth) {
      const nr = appendAll322(self2.right, that);
      return makeChunk232({
        _tag: "IConcat",
        left: self2.left,
        right: nr
      });
    } else {
      const nrr = appendAll322(self2.right.right, that);
      if (nrr.depth === self2.depth - 3) {
        const nr = makeChunk232({
          _tag: "IConcat",
          left: self2.right.left,
          right: nrr
        });
        return makeChunk232({
          _tag: "IConcat",
          left: self2.left,
          right: nr
        });
      } else {
        const nl = makeChunk232({
          _tag: "IConcat",
          left: self2.left,
          right: self2.right.left
        });
        return makeChunk232({
          _tag: "IConcat",
          left: nl,
          right: nrr
        });
      }
    }
  } else {
    if (that.right.depth >= that.left.depth) {
      const nl = appendAll322(self2, that.left);
      return makeChunk232({
        _tag: "IConcat",
        left: nl,
        right: that.right
      });
    } else {
      const nll = appendAll322(self2, that.left.left);
      if (nll.depth === that.depth - 3) {
        const nl = makeChunk232({
          _tag: "IConcat",
          left: nll,
          right: that.left.right
        });
        return makeChunk232({
          _tag: "IConcat",
          left: nl,
          right: that.right
        });
      } else {
        const nr = makeChunk232({
          _tag: "IConcat",
          left: that.left.right,
          right: that.right
        });
        return makeChunk232({
          _tag: "IConcat",
          left: nll,
          right: nr
        });
      }
    }
  }
});
var isEmpty232 = (self2) => self2.length === 0;
var isNonEmpty232 = (self2) => self2.length > 0;
var unsafeHead232 = (self2) => unsafeGet2232(self2, 0);
var headNonEmpty322 = unsafeHead232;
var tailNonEmpty322 = (self2) => drop322(self2, 1);
var SIZE232 = 5;
var BUCKET_SIZE232 = /* @__PURE__ */ Math.pow(2, SIZE232);
var MASK232 = BUCKET_SIZE232 - 1;
var MAX_INDEX_NODE232 = BUCKET_SIZE232 / 2;
var MIN_ARRAY_NODE232 = BUCKET_SIZE232 / 4;
function popcount232(x232) {
  x232 -= x232 >> 1 & 1431655765;
  x232 = (x232 & 858993459) + (x232 >> 2 & 858993459);
  x232 = x232 + (x232 >> 4) & 252645135;
  x232 += x232 >> 8;
  x232 += x232 >> 16;
  return x232 & 127;
}
function hashFragment232(shift22, h232) {
  return h232 >>> shift22 & MASK232;
}
function toBitmap232(x232) {
  return 1 << x232;
}
function fromBitmap232(bitmap, bit) {
  return popcount232(bitmap & bit - 1);
}
var make5232 = (value, previous) => ({
  value,
  previous
});
function arrayUpdate232(mutate2232, at, v232, arr) {
  let out = arr;
  if (!mutate2232) {
    const len = arr.length;
    out = new Array(len);
    for (let i232 = 0; i232 < len; ++i232) out[i232] = arr[i232];
  }
  out[at] = v232;
  return out;
}
function arraySpliceOut232(mutate2232, at, arr) {
  const newLen = arr.length - 1;
  let i232 = 0;
  let g232 = 0;
  let out = arr;
  if (mutate2232) {
    i232 = g232 = at;
  } else {
    out = new Array(newLen);
    while (i232 < at) out[g232++] = arr[i232++];
  }
  ++i232;
  while (i232 <= newLen) out[g232++] = arr[i232++];
  if (mutate2232) {
    out.length = newLen;
  }
  return out;
}
function arraySpliceIn232(mutate2232, at, v232, arr) {
  const len = arr.length;
  if (mutate2232) {
    let i2222 = len;
    while (i2222 >= at) arr[i2222--] = arr[i2222];
    arr[at] = v232;
    return arr;
  }
  let i232 = 0, g232 = 0;
  const out = new Array(len + 1);
  while (i232 < at) out[g232++] = arr[i232++];
  out[at] = v232;
  while (i232 < len) out[++g232] = arr[i232++];
  return out;
}
var EmptyNode232 = class _EmptyNode232 {
  _tag = "EmptyNode";
  modify(edit, _shift, f232, hash22232, key, size4232) {
    const v232 = f232(none22232());
    if (isNone22232(v232)) return new _EmptyNode232();
    ++size4232.value;
    return new LeafNode232(edit, hash22232, key, v232);
  }
};
function isEmptyNode232(a232) {
  return isTagged322(a232, "EmptyNode");
}
function isLeafNode232(node) {
  return isEmptyNode232(node) || node._tag === "LeafNode" || node._tag === "CollisionNode";
}
function canEditNode232(node, edit) {
  return isEmptyNode232(node) ? false : edit === node.edit;
}
var LeafNode232 = class _LeafNode232 {
  edit;
  hash;
  key;
  value;
  _tag = "LeafNode";
  constructor(edit, hash22232, key, value) {
    this.edit = edit;
    this.hash = hash22232;
    this.key = key;
    this.value = value;
  }
  modify(edit, shift22, f232, hash22232, key, size4232) {
    if (equals2232(key, this.key)) {
      const v2222 = f232(this.value);
      if (v2222 === this.value) return this;
      else if (isNone22232(v2222)) {
        --size4232.value;
        return new EmptyNode232();
      }
      if (canEditNode232(this, edit)) {
        this.value = v2222;
        return this;
      }
      return new _LeafNode232(edit, hash22232, key, v2222);
    }
    const v232 = f232(none22232());
    if (isNone22232(v232)) return this;
    ++size4232.value;
    return mergeLeaves232(edit, shift22, this.hash, this, hash22232, new _LeafNode232(edit, hash22232, key, v232));
  }
};
var CollisionNode232 = class _CollisionNode232 {
  edit;
  hash;
  children;
  _tag = "CollisionNode";
  constructor(edit, hash22232, children) {
    this.edit = edit;
    this.hash = hash22232;
    this.children = children;
  }
  modify(edit, shift22, f232, hash22232, key, size4232) {
    if (hash22232 === this.hash) {
      const canEdit = canEditNode232(this, edit);
      const list = this.updateCollisionList(canEdit, edit, this.hash, this.children, f232, key, size4232);
      if (list === this.children) return this;
      return list.length > 1 ? new _CollisionNode232(edit, this.hash, list) : list[0];
    }
    const v232 = f232(none22232());
    if (isNone22232(v232)) return this;
    ++size4232.value;
    return mergeLeaves232(edit, shift22, this.hash, this, hash22232, new LeafNode232(edit, hash22232, key, v232));
  }
  updateCollisionList(mutate2232, edit, hash22232, list, f232, key, size4232) {
    const len = list.length;
    for (let i232 = 0; i232 < len; ++i232) {
      const child = list[i232];
      if ("key" in child && equals2232(key, child.key)) {
        const value = child.value;
        const newValue2 = f232(value);
        if (newValue2 === value) return list;
        if (isNone22232(newValue2)) {
          --size4232.value;
          return arraySpliceOut232(mutate2232, i232, list);
        }
        return arrayUpdate232(mutate2232, i232, new LeafNode232(edit, hash22232, key, newValue2), list);
      }
    }
    const newValue = f232(none22232());
    if (isNone22232(newValue)) return list;
    ++size4232.value;
    return arrayUpdate232(mutate2232, len, new LeafNode232(edit, hash22232, key, newValue), list);
  }
};
var IndexedNode232 = class _IndexedNode232 {
  edit;
  mask;
  children;
  _tag = "IndexedNode";
  constructor(edit, mask, children) {
    this.edit = edit;
    this.mask = mask;
    this.children = children;
  }
  modify(edit, shift22, f232, hash22232, key, size4232) {
    const mask = this.mask;
    const children = this.children;
    const frag = hashFragment232(shift22, hash22232);
    const bit = toBitmap232(frag);
    const indx = fromBitmap232(mask, bit);
    const exists22232 = mask & bit;
    const canEdit = canEditNode232(this, edit);
    if (!exists22232) {
      const _newChild = new EmptyNode232().modify(edit, shift22 + SIZE232, f232, hash22232, key, size4232);
      if (!_newChild) return this;
      return children.length >= MAX_INDEX_NODE232 ? expand232(edit, frag, _newChild, mask, children) : new _IndexedNode232(edit, mask | bit, arraySpliceIn232(canEdit, indx, _newChild, children));
    }
    const current = children[indx];
    const child = current.modify(edit, shift22 + SIZE232, f232, hash22232, key, size4232);
    if (current === child) return this;
    let bitmap = mask;
    let newChildren;
    if (isEmptyNode232(child)) {
      bitmap &= ~bit;
      if (!bitmap) return new EmptyNode232();
      if (children.length <= 2 && isLeafNode232(children[indx ^ 1])) {
        return children[indx ^ 1];
      }
      newChildren = arraySpliceOut232(canEdit, indx, children);
    } else {
      newChildren = arrayUpdate232(canEdit, indx, child, children);
    }
    if (canEdit) {
      this.mask = bitmap;
      this.children = newChildren;
      return this;
    }
    return new _IndexedNode232(edit, bitmap, newChildren);
  }
};
var ArrayNode232 = class _ArrayNode232 {
  edit;
  size;
  children;
  _tag = "ArrayNode";
  constructor(edit, size4232, children) {
    this.edit = edit;
    this.size = size4232;
    this.children = children;
  }
  modify(edit, shift22, f232, hash22232, key, size4232) {
    let count = this.size;
    const children = this.children;
    const frag = hashFragment232(shift22, hash22232);
    const child = children[frag];
    const newChild = (child || new EmptyNode232()).modify(edit, shift22 + SIZE232, f232, hash22232, key, size4232);
    if (child === newChild) return this;
    const canEdit = canEditNode232(this, edit);
    let newChildren;
    if (isEmptyNode232(child) && !isEmptyNode232(newChild)) {
      ++count;
      newChildren = arrayUpdate232(canEdit, frag, newChild, children);
    } else if (!isEmptyNode232(child) && isEmptyNode232(newChild)) {
      --count;
      if (count <= MIN_ARRAY_NODE232) {
        return pack232(edit, count, frag, children);
      }
      newChildren = arrayUpdate232(canEdit, frag, new EmptyNode232(), children);
    } else {
      newChildren = arrayUpdate232(canEdit, frag, newChild, children);
    }
    if (canEdit) {
      this.size = count;
      this.children = newChildren;
      return this;
    }
    return new _ArrayNode232(edit, count, newChildren);
  }
};
function pack232(edit, count, removed, elements) {
  const children = new Array(count - 1);
  let g232 = 0;
  let bitmap = 0;
  for (let i232 = 0, len = elements.length; i232 < len; ++i232) {
    if (i232 !== removed) {
      const elem = elements[i232];
      if (elem && !isEmptyNode232(elem)) {
        children[g232++] = elem;
        bitmap |= 1 << i232;
      }
    }
  }
  return new IndexedNode232(edit, bitmap, children);
}
function expand232(edit, frag, child, bitmap, subNodes) {
  const arr = [];
  let bit = bitmap;
  let count = 0;
  for (let i232 = 0; bit; ++i232) {
    if (bit & 1) arr[i232] = subNodes[count++];
    bit >>>= 1;
  }
  arr[frag] = child;
  return new ArrayNode232(edit, count + 1, arr);
}
function mergeLeavesInner232(edit, shift22, h1, n1, h232, n232) {
  if (h1 === h232) return new CollisionNode232(edit, h1, [n232, n1]);
  const subH1 = hashFragment232(shift22, h1);
  const subH2 = hashFragment232(shift22, h232);
  if (subH1 === subH2) {
    return (child) => new IndexedNode232(edit, toBitmap232(subH1) | toBitmap232(subH2), [child]);
  } else {
    const children = subH1 < subH2 ? [n1, n232] : [n232, n1];
    return new IndexedNode232(edit, toBitmap232(subH1) | toBitmap232(subH2), children);
  }
}
function mergeLeaves232(edit, shift22, h1, n1, h232, n232) {
  let stack = void 0;
  let currentShift = shift22;
  while (true) {
    const res = mergeLeavesInner232(edit, currentShift, h1, n1, h232, n232);
    if (typeof res === "function") {
      stack = make5232(res, stack);
      currentShift = currentShift + SIZE232;
    } else {
      let final = res;
      while (stack != null) {
        final = stack.value(final);
        stack = stack.previous;
      }
      return final;
    }
  }
}
var HashMapSymbolKey232 = "effect/HashMap";
var HashMapTypeId232 = /* @__PURE__ */ Symbol.for(HashMapSymbolKey232);
var HashMapProto232 = {
  [HashMapTypeId232]: HashMapTypeId232,
  [Symbol.iterator]() {
    return new HashMapIterator232(this, (k232, v232) => [k232, v232]);
  },
  [symbol3232]() {
    let hash22232 = hash2232(HashMapSymbolKey232);
    for (const item of this) {
      hash22232 ^= pipe2232(hash2232(item[0]), combine2242(hash2232(item[1])));
    }
    return cached2232(this, hash22232);
  },
  [symbol22232](that) {
    if (isHashMap232(that)) {
      if (that._size !== this._size) {
        return false;
      }
      for (const item of this) {
        const elem = pipe2232(that, getHash232(item[0], hash2232(item[0])));
        if (isNone22232(elem)) {
          return false;
        } else {
          if (!equals2232(item[1], elem.value)) {
            return false;
          }
        }
      }
      return true;
    }
    return false;
  },
  toString() {
    return format2232(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashMap",
      values: Array.from(this).map(toJSON2232)
    };
  },
  [NodeInspectSymbol2232]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments2232(this, arguments);
  }
};
var makeImpl332 = (editable, edit, root, size4232) => {
  const map622 = Object.create(HashMapProto232);
  map622._editable = editable;
  map622._edit = edit;
  map622._root = root;
  map622._size = size4232;
  return map622;
};
var HashMapIterator232 = class _HashMapIterator232 {
  map;
  f;
  v;
  constructor(map622, f232) {
    this.map = map622;
    this.f = f232;
    this.v = visitLazy232(this.map._root, this.f, void 0);
  }
  next() {
    if (isNone22232(this.v)) {
      return {
        done: true,
        value: void 0
      };
    }
    const v0 = this.v.value;
    this.v = applyCont232(v0.cont);
    return {
      done: false,
      value: v0.value
    };
  }
  [Symbol.iterator]() {
    return new _HashMapIterator232(this.map, this.f);
  }
};
var applyCont232 = (cont) => cont ? visitLazyChildren232(cont[0], cont[1], cont[2], cont[3], cont[4]) : none22232();
var visitLazy232 = (node, f232, cont = void 0) => {
  switch (node._tag) {
    case "LeafNode": {
      if (isSome22232(node.value)) {
        return some32232({
          value: f232(node.key, node.value.value),
          cont
        });
      }
      return applyCont232(cont);
    }
    case "CollisionNode":
    case "ArrayNode":
    case "IndexedNode": {
      const children = node.children;
      return visitLazyChildren232(children.length, children, 0, f232, cont);
    }
    default: {
      return applyCont232(cont);
    }
  }
};
var visitLazyChildren232 = (len, children, i232, f232, cont) => {
  while (i232 < len) {
    const child = children[i232++];
    if (child && !isEmptyNode232(child)) {
      return visitLazy232(child, f232, [len, children, i232, f232, cont]);
    }
  }
  return applyCont232(cont);
};
var _empty3232 = /* @__PURE__ */ makeImpl332(false, 0, /* @__PURE__ */ new EmptyNode232(), 0);
var empty4232 = () => _empty3232;
var isHashMap232 = (u232) => hasProperty2232(u232, HashMapTypeId232);
var getHash232 = /* @__PURE__ */ dual2232(3, (self2, key, hash22232) => {
  let node = self2._root;
  let shift22 = 0;
  while (true) {
    switch (node._tag) {
      case "LeafNode": {
        return equals2232(key, node.key) ? node.value : none22232();
      }
      case "CollisionNode": {
        if (hash22232 === node.hash) {
          const children = node.children;
          for (let i232 = 0, len = children.length; i232 < len; ++i232) {
            const child = children[i232];
            if ("key" in child && equals2232(key, child.key)) {
              return child.value;
            }
          }
        }
        return none22232();
      }
      case "IndexedNode": {
        const frag = hashFragment232(shift22, hash22232);
        const bit = toBitmap232(frag);
        if (node.mask & bit) {
          node = node.children[fromBitmap232(node.mask, bit)];
          shift22 += SIZE232;
          break;
        }
        return none22232();
      }
      case "ArrayNode": {
        node = node.children[hashFragment232(shift22, hash22232)];
        if (node) {
          shift22 += SIZE232;
          break;
        }
        return none22232();
      }
      default:
        return none22232();
    }
  }
});
var set2232 = /* @__PURE__ */ dual2232(3, (self2, key, value) => modifyAt232(self2, key, () => some32232(value)));
var setTree232 = /* @__PURE__ */ dual2232(3, (self2, newRoot, newSize) => {
  if (self2._editable) {
    self2._root = newRoot;
    self2._size = newSize;
    return self2;
  }
  return newRoot === self2._root ? self2 : makeImpl332(self2._editable, self2._edit, newRoot, newSize);
});
var keys322 = (self2) => new HashMapIterator232(self2, (key) => key);
var size432 = (self2) => self2._size;
var beginMutation332 = (self2) => makeImpl332(true, self2._edit + 1, self2._root, self2._size);
var modifyAt232 = /* @__PURE__ */ dual2232(3, (self2, key, f232) => modifyHash232(self2, key, hash2232(key), f232));
var modifyHash232 = /* @__PURE__ */ dual2232(4, (self2, key, hash22232, f232) => {
  const size4232 = {
    value: self2._size
  };
  const newRoot = self2._root.modify(self2._editable ? self2._edit : NaN, 0, f232, hash22232, key, size4232);
  return pipe2232(self2, setTree232(newRoot, size4232.value));
});
var forEach422 = /* @__PURE__ */ dual2232(2, (self2, f232) => reduce2232(self2, void 0, (_232, value, key) => f232(value, key)));
var reduce2232 = /* @__PURE__ */ dual2232(3, (self2, zero, f232) => {
  const root = self2._root;
  if (root._tag === "LeafNode") {
    return isSome22232(root.value) ? f232(zero, root.value.value, root.key) : zero;
  }
  if (root._tag === "EmptyNode") {
    return zero;
  }
  const toVisit = [root.children];
  let children;
  while (children = toVisit.pop()) {
    for (let i232 = 0, len = children.length; i232 < len; ) {
      const child = children[i232++];
      if (child && !isEmptyNode232(child)) {
        if (child._tag === "LeafNode") {
          if (isSome22232(child.value)) {
            zero = f232(zero, child.value.value, child.key);
          }
        } else {
          toVisit.push(child.children);
        }
      }
    }
  }
  return zero;
});
var HashSetSymbolKey232 = "effect/HashSet";
var HashSetTypeId232 = /* @__PURE__ */ Symbol.for(HashSetSymbolKey232);
var HashSetProto232 = {
  [HashSetTypeId232]: HashSetTypeId232,
  [Symbol.iterator]() {
    return keys322(this._keyMap);
  },
  [symbol3232]() {
    return cached2232(this, combine2242(hash2232(this._keyMap))(hash2232(HashSetSymbolKey232)));
  },
  [symbol22232](that) {
    if (isHashSet232(that)) {
      return size432(this._keyMap) === size432(that._keyMap) && equals2232(this._keyMap, that._keyMap);
    }
    return false;
  },
  toString() {
    return format2232(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashSet",
      values: Array.from(this).map(toJSON2232)
    };
  },
  [NodeInspectSymbol2232]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments2232(this, arguments);
  }
};
var makeImpl2232 = (keyMap) => {
  const set22232 = Object.create(HashSetProto232);
  set22232._keyMap = keyMap;
  return set22232;
};
var isHashSet232 = (u232) => hasProperty2232(u232, HashSetTypeId232);
var _empty4232 = /* @__PURE__ */ makeImpl2232(/* @__PURE__ */ empty4232());
var empty5232 = () => _empty4232;
var size2232 = (self2) => size432(self2._keyMap);
var beginMutation2232 = (self2) => makeImpl2232(beginMutation332(self2._keyMap));
var endMutation232 = (self2) => {
  self2._keyMap._editable = false;
  return self2;
};
var mutate232 = /* @__PURE__ */ dual2232(2, (self2, f232) => {
  const transient = beginMutation2232(self2);
  f232(transient);
  return endMutation232(transient);
});
var add2232 = /* @__PURE__ */ dual2232(2, (self2, value) => self2._keyMap._editable ? (set2232(value, true)(self2._keyMap), self2) : makeImpl2232(set2232(value, true)(self2._keyMap)));
var union2232 = /* @__PURE__ */ dual2232(2, (self2, that) => mutate232(empty5232(), (set22232) => {
  forEach2232(self2, (value) => add2232(set22232, value));
  for (const value of that) {
    add2232(set22232, value);
  }
}));
var forEach2232 = /* @__PURE__ */ dual2232(2, (self2, f232) => forEach422(self2._keyMap, (_232, k232) => f232(k232)));
var empty6232 = empty5232;
var size3232 = size2232;
var add3232 = add2232;
var union3232 = union2232;
var ArrayProto232 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(Array.prototype), {
  [symbol3232]() {
    return cached2232(this, array522(this));
  },
  [symbol22232](that) {
    if (Array.isArray(that) && this.length === that.length) {
      return this.every((v232, i232) => equals2232(v232, that[i232]));
    } else {
      return false;
    }
  }
});
var Structural332 = /* @__PURE__ */ function() {
  function Structural3232(args) {
    if (args) {
      Object.assign(this, args);
    }
  }
  Structural3232.prototype = StructuralPrototype2232;
  return Structural3232;
}();
var struct2232 = (as22232) => Object.assign(Object.create(StructuralPrototype2232), as22232);
var ContextPatchTypeId232 = /* @__PURE__ */ Symbol.for("effect/DifferContextPatch");
function variance332(a232) {
  return a232;
}
var PatchProto232 = {
  ...Structural332.prototype,
  [ContextPatchTypeId232]: {
    _Value: variance332,
    _Patch: variance332
  }
};
var EmptyProto232 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto232), {
  _tag: "Empty"
});
var _empty5232 = /* @__PURE__ */ Object.create(EmptyProto232);
var empty7232 = () => _empty5232;
var AndThenProto232 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto232), {
  _tag: "AndThen"
});
var makeAndThen232 = (first, second) => {
  const o232 = Object.create(AndThenProto232);
  o232.first = first;
  o232.second = second;
  return o232;
};
var AddServiceProto232 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto232), {
  _tag: "AddService"
});
var makeAddService232 = (key, service) => {
  const o232 = Object.create(AddServiceProto232);
  o232.key = key;
  o232.service = service;
  return o232;
};
var RemoveServiceProto232 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto232), {
  _tag: "RemoveService"
});
var makeRemoveService232 = (key) => {
  const o232 = Object.create(RemoveServiceProto232);
  o232.key = key;
  return o232;
};
var UpdateServiceProto232 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto232), {
  _tag: "UpdateService"
});
var makeUpdateService232 = (key, update222) => {
  const o232 = Object.create(UpdateServiceProto232);
  o232.key = key;
  o232.update = update222;
  return o232;
};
var diff232 = (oldValue, newValue) => {
  const missingServices = new Map(oldValue.unsafeMap);
  let patch2232 = empty7232();
  for (const [tag, newService] of newValue.unsafeMap.entries()) {
    if (missingServices.has(tag)) {
      const old = missingServices.get(tag);
      missingServices.delete(tag);
      if (!equals2232(old, newService)) {
        patch2232 = combine22232(makeUpdateService232(tag, () => newService))(patch2232);
      }
    } else {
      missingServices.delete(tag);
      patch2232 = combine22232(makeAddService232(tag, newService))(patch2232);
    }
  }
  for (const [tag] of missingServices.entries()) {
    patch2232 = combine22232(makeRemoveService232(tag))(patch2232);
  }
  return patch2232;
};
var combine22232 = /* @__PURE__ */ dual2232(2, (self2, that) => makeAndThen232(self2, that));
var patch232 = /* @__PURE__ */ dual2232(2, (self2, context) => {
  if (self2._tag === "Empty") {
    return context;
  }
  let wasServiceUpdated = false;
  let patches = of322(self2);
  const updatedContext = new Map(context.unsafeMap);
  while (isNonEmpty232(patches)) {
    const head222 = headNonEmpty322(patches);
    const tail222 = tailNonEmpty322(patches);
    switch (head222._tag) {
      case "Empty": {
        patches = tail222;
        break;
      }
      case "AddService": {
        updatedContext.set(head222.key, head222.service);
        patches = tail222;
        break;
      }
      case "AndThen": {
        patches = prepend322(prepend322(tail222, head222.second), head222.first);
        break;
      }
      case "RemoveService": {
        updatedContext.delete(head222.key);
        patches = tail222;
        break;
      }
      case "UpdateService": {
        updatedContext.set(head222.key, head222.update(updatedContext.get(head222.key)));
        wasServiceUpdated = true;
        patches = tail222;
        break;
      }
    }
  }
  if (!wasServiceUpdated) {
    return makeContext232(updatedContext);
  }
  const map622 = /* @__PURE__ */ new Map();
  for (const [tag] of context.unsafeMap) {
    if (updatedContext.has(tag)) {
      map622.set(tag, updatedContext.get(tag));
      updatedContext.delete(tag);
    }
  }
  for (const [tag, s232] of updatedContext) {
    map622.set(tag, s232);
  }
  return makeContext232(map622);
});
var DifferTypeId232 = /* @__PURE__ */ Symbol.for("effect/Differ");
var DifferProto232 = {
  [DifferTypeId232]: {
    _P: identity2232,
    _V: identity2232
  }
};
var make7232 = (params) => {
  const differ = Object.create(DifferProto232);
  differ.empty = params.empty;
  differ.diff = params.diff;
  differ.combine = params.combine;
  differ.patch = params.patch;
  return differ;
};
var environment232 = () => make7232({
  empty: empty7232(),
  combine: (first, second) => combine22232(second)(first),
  diff: (oldValue, newValue) => diff232(oldValue, newValue),
  patch: (patch2232, oldValue) => patch232(oldValue)(patch2232)
});
var OP_DIE232 = "Die";
var OP_EMPTY232 = "Empty";
var OP_FAIL232 = "Fail";
var OP_INTERRUPT232 = "Interrupt";
var OP_PARALLEL232 = "Parallel";
var OP_SEQUENTIAL232 = "Sequential";
var CauseSymbolKey232 = "effect/Cause";
var CauseTypeId232 = /* @__PURE__ */ Symbol.for(CauseSymbolKey232);
var variance2232 = {
  /* c8 ignore next */
  _E: (_232) => _232
};
var proto232 = {
  [CauseTypeId232]: variance2232,
  [symbol3232]() {
    return pipe2232(hash2232(CauseSymbolKey232), combine2242(hash2232(flattenCause232(this))), cached2232(this));
  },
  [symbol22232](that) {
    return isCause232(that) && causeEquals232(this, that);
  },
  pipe() {
    return pipeArguments2232(this, arguments);
  },
  toJSON() {
    switch (this._tag) {
      case "Empty":
        return {
          _id: "Cause",
          _tag: this._tag
        };
      case "Die":
        return {
          _id: "Cause",
          _tag: this._tag,
          defect: toJSON2232(this.defect)
        };
      case "Interrupt":
        return {
          _id: "Cause",
          _tag: this._tag,
          fiberId: this.fiberId.toJSON()
        };
      case "Fail":
        return {
          _id: "Cause",
          _tag: this._tag,
          failure: toJSON2232(this.error)
        };
      case "Sequential":
      case "Parallel":
        return {
          _id: "Cause",
          _tag: this._tag,
          left: toJSON2232(this.left),
          right: toJSON2232(this.right)
        };
    }
  },
  toString() {
    return pretty232(this);
  },
  [NodeInspectSymbol2232]() {
    return this.toJSON();
  }
};
var fail332 = (error) => {
  const o232 = Object.create(proto232);
  o232._tag = OP_FAIL232;
  o232.error = error;
  return o232;
};
var parallel232 = (left3232, right3232) => {
  const o232 = Object.create(proto232);
  o232._tag = OP_PARALLEL232;
  o232.left = left3232;
  o232.right = right3232;
  return o232;
};
var sequential232 = (left3232, right3232) => {
  const o232 = Object.create(proto232);
  o232._tag = OP_SEQUENTIAL232;
  o232.left = left3232;
  o232.right = right3232;
  return o232;
};
var isCause232 = (u232) => hasProperty2232(u232, CauseTypeId232);
var isInterruptedOnly232 = (self2) => reduceWithContext232(void 0, IsInterruptedOnlyCauseReducer232)(self2);
var causeEquals232 = (left3232, right3232) => {
  let leftStack = of322(left3232);
  let rightStack = of322(right3232);
  while (isNonEmpty232(leftStack) && isNonEmpty232(rightStack)) {
    const [leftParallel, leftSequential] = pipe2232(headNonEmpty322(leftStack), reduce4232([empty6232(), empty3232()], ([parallel2232, sequential2232], cause) => {
      const [par, seq] = evaluateCause232(cause);
      return some32232([pipe2232(parallel2232, union3232(par)), pipe2232(sequential2232, appendAll322(seq))]);
    }));
    const [rightParallel, rightSequential] = pipe2232(headNonEmpty322(rightStack), reduce4232([empty6232(), empty3232()], ([parallel2232, sequential2232], cause) => {
      const [par, seq] = evaluateCause232(cause);
      return some32232([pipe2232(parallel2232, union3232(par)), pipe2232(sequential2232, appendAll322(seq))]);
    }));
    if (!equals2232(leftParallel, rightParallel)) {
      return false;
    }
    leftStack = leftSequential;
    rightStack = rightSequential;
  }
  return true;
};
var flattenCause232 = (cause) => {
  return flattenCauseLoop232(of322(cause), empty3232());
};
var flattenCauseLoop232 = (causes, flattened) => {
  while (1) {
    const [parallel2232, sequential2232] = pipe2232(causes, reduce522([empty6232(), empty3232()], ([parallel322, sequential322], cause) => {
      const [par, seq] = evaluateCause232(cause);
      return [pipe2232(parallel322, union3232(par)), pipe2232(sequential322, appendAll322(seq))];
    }));
    const updated = size3232(parallel2232) > 0 ? pipe2232(flattened, prepend322(parallel2232)) : flattened;
    if (isEmpty232(sequential2232)) {
      return reverse2232(updated);
    }
    causes = sequential2232;
    flattened = updated;
  }
  throw new Error(getBugErrorMessage2232("Cause.flattenCauseLoop"));
};
var evaluateCause232 = (self2) => {
  let cause = self2;
  const stack = [];
  let _parallel = empty6232();
  let _sequential = empty3232();
  while (cause !== void 0) {
    switch (cause._tag) {
      case OP_EMPTY232: {
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_FAIL232: {
        _parallel = add3232(_parallel, make42232(cause._tag, cause.error));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_DIE232: {
        _parallel = add3232(_parallel, make42232(cause._tag, cause.defect));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_INTERRUPT232: {
        _parallel = add3232(_parallel, make42232(cause._tag, cause.fiberId));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_SEQUENTIAL232: {
        switch (cause.left._tag) {
          case OP_EMPTY232: {
            cause = cause.right;
            break;
          }
          case OP_SEQUENTIAL232: {
            cause = sequential232(cause.left.left, sequential232(cause.left.right, cause.right));
            break;
          }
          case OP_PARALLEL232: {
            cause = parallel232(sequential232(cause.left.left, cause.right), sequential232(cause.left.right, cause.right));
            break;
          }
          default: {
            _sequential = prepend322(_sequential, cause.right);
            cause = cause.left;
            break;
          }
        }
        break;
      }
      case OP_PARALLEL232: {
        stack.push(cause.right);
        cause = cause.left;
        break;
      }
    }
  }
  throw new Error(getBugErrorMessage2232("Cause.evaluateCauseLoop"));
};
var IsInterruptedOnlyCauseReducer232 = {
  emptyCase: constTrue2232,
  failCase: constFalse2232,
  dieCase: constFalse2232,
  interruptCase: constTrue2232,
  sequentialCase: (_232, left3232, right3232) => left3232 && right3232,
  parallelCase: (_232, left3232, right3232) => left3232 && right3232
};
var OP_SEQUENTIAL_CASE232 = "SequentialCase";
var OP_PARALLEL_CASE232 = "ParallelCase";
var reduce4232 = /* @__PURE__ */ dual2232(3, (self2, zero, pf) => {
  let accumulator = zero;
  let cause = self2;
  const causes = [];
  while (cause !== void 0) {
    const option = pf(accumulator, cause);
    accumulator = isSome22232(option) ? option.value : accumulator;
    switch (cause._tag) {
      case OP_SEQUENTIAL232: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      case OP_PARALLEL232: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      default: {
        cause = void 0;
        break;
      }
    }
    if (cause === void 0 && causes.length > 0) {
      cause = causes.pop();
    }
  }
  return accumulator;
});
var reduceWithContext232 = /* @__PURE__ */ dual2232(3, (self2, context, reducer) => {
  const input = [self2];
  const output = [];
  while (input.length > 0) {
    const cause = input.pop();
    switch (cause._tag) {
      case OP_EMPTY232: {
        output.push(right22232(reducer.emptyCase(context)));
        break;
      }
      case OP_FAIL232: {
        output.push(right22232(reducer.failCase(context, cause.error)));
        break;
      }
      case OP_DIE232: {
        output.push(right22232(reducer.dieCase(context, cause.defect)));
        break;
      }
      case OP_INTERRUPT232: {
        output.push(right22232(reducer.interruptCase(context, cause.fiberId)));
        break;
      }
      case OP_SEQUENTIAL232: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left22232({
          _tag: OP_SEQUENTIAL_CASE232
        }));
        break;
      }
      case OP_PARALLEL232: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left22232({
          _tag: OP_PARALLEL_CASE232
        }));
        break;
      }
    }
  }
  const accumulator = [];
  while (output.length > 0) {
    const either = output.pop();
    switch (either._tag) {
      case "Left": {
        switch (either.left._tag) {
          case OP_SEQUENTIAL_CASE232: {
            const left3232 = accumulator.pop();
            const right3232 = accumulator.pop();
            const value = reducer.sequentialCase(context, left3232, right3232);
            accumulator.push(value);
            break;
          }
          case OP_PARALLEL_CASE232: {
            const left3232 = accumulator.pop();
            const right3232 = accumulator.pop();
            const value = reducer.parallelCase(context, left3232, right3232);
            accumulator.push(value);
            break;
          }
        }
        break;
      }
      case "Right": {
        accumulator.push(either.right);
        break;
      }
    }
  }
  if (accumulator.length === 0) {
    throw new Error("BUG: Cause.reduceWithContext - please report an issue at https://github.com/Effect-TS/effect/issues");
  }
  return accumulator.pop();
});
var pretty232 = (cause) => {
  if (isInterruptedOnly232(cause)) {
    return "All fibers interrupted without errors.";
  }
  return prettyErrors232(cause).map((e232) => e232.stack).join("\n");
};
var PrettyError232 = class extends globalThis.Error {
  span = void 0;
  constructor(originalError) {
    const prevLimit = Error.stackTraceLimit;
    Error.stackTraceLimit = 0;
    super(prettyErrorMessage232(originalError));
    Error.stackTraceLimit = prevLimit;
    this.name = originalError instanceof Error ? originalError.name : "Error";
    if (typeof originalError === "object" && originalError !== null) {
      if (spanSymbol332 in originalError) {
        this.span = originalError[spanSymbol332];
      }
      Object.keys(originalError).forEach((key) => {
        if (!(key in this)) {
          this[key] = originalError[key];
        }
      });
    }
    this.stack = prettyErrorStack232(this.message, originalError instanceof Error && originalError.stack ? originalError.stack : "", this.span);
  }
  toJSON() {
    const out = {
      message: this.message,
      stack: this.stack
    };
    if (this.span) {
      out.span = this.span;
    }
    return out;
  }
};
var prettyErrorMessage232 = (u232) => {
  if (typeof u232 === "string") {
    return `Error: ${u232}`;
  }
  try {
    if (hasProperty2232(u232, "toString") && isFunction3242(u232["toString"]) && u232["toString"] !== Object.prototype.toString && u232["toString"] !== globalThis.Array.prototype.toString) {
      return u232["toString"]();
    }
  } catch {
  }
  return `Error: ${JSON.stringify(u232)}`;
};
var locationRegex232 = /\((.*)\)/;
var spanToTrace232 = /* @__PURE__ */ globalValue2232("effect/Tracer/spanToTrace", () => /* @__PURE__ */ new WeakMap());
var prettyErrorStack232 = (message, stack, span222) => {
  const out = [message];
  const lines = stack.split("\n");
  for (let i232 = 1; i232 < lines.length; i232++) {
    if (lines[i232].includes("Generator.next")) {
      break;
    }
    if (lines[i232].includes("effect_internal_function")) {
      out.pop();
      break;
    }
    out.push(lines[i232].replace(/at .*effect_instruction_i.*\((.*)\)/, "at $1").replace(/EffectPrimitive\.\w+/, "<anonymous>"));
  }
  if (span222) {
    let current = span222;
    let i232 = 0;
    while (current && current._tag === "Span" && i232 < 10) {
      const stackFn = spanToTrace232.get(current);
      if (typeof stackFn === "function") {
        const stack2 = stackFn();
        const locationMatch = stack2.match(locationRegex232);
        const location = locationMatch ? locationMatch[1] : stack2.replace(/^at /, "");
        out.push(`    at ${current.name} (${location})`);
      } else {
        out.push(`    at ${current.name}`);
      }
      current = getOrUndefined2232(current.parent);
      i232++;
    }
  }
  return out.join("\n");
};
var spanSymbol332 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var prettyErrors232 = (cause) => reduceWithContext232(cause, void 0, {
  emptyCase: () => [],
  dieCase: (_232, unknownError) => {
    return [new PrettyError232(unknownError)];
  },
  failCase: (_232, error) => {
    return [new PrettyError232(error)];
  },
  interruptCase: () => [],
  parallelCase: (_232, l232, r232) => [...l232, ...r232],
  sequentialCase: (_232, l232, r232) => [...l232, ...r232]
});
var SingleShotGen22232 = class _SingleShotGen2232 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  next(a232) {
    return this.called ? {
      value: a232,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  return(a232) {
    return {
      value: a232,
      done: true
    };
  }
  throw(e232) {
    throw e232;
  }
  [Symbol.iterator]() {
    return new _SingleShotGen2232(this.self);
  }
};
var spanTag232 = /* @__PURE__ */ GenericTag232("effect/ParentSpan");
var EffectTypeId22232 = /* @__PURE__ */ Symbol.for("effect/Effect");
var EffectPrimitive232 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId22232] = effectVariance2232;
  constructor(_op) {
    this._op = _op;
  }
  [symbol22232](that) {
    return this === that;
  }
  [symbol3232]() {
    return cached2232(this, random2232(this));
  }
  pipe() {
    return pipeArguments2232(this, arguments);
  }
  toJSON() {
    return {
      _id: "Effect",
      _op: this._op,
      effect_instruction_i0: toJSON2232(this.effect_instruction_i0),
      effect_instruction_i1: toJSON2232(this.effect_instruction_i1),
      effect_instruction_i2: toJSON2232(this.effect_instruction_i2)
    };
  }
  toString() {
    return format2232(this.toJSON());
  }
  [NodeInspectSymbol2232]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen22232(new YieldWrap2232(this));
  }
};
var EffectPrimitiveFailure232 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId22232] = effectVariance2232;
  constructor(_op) {
    this._op = _op;
    this._tag = _op;
  }
  [symbol22232](that) {
    return exitIsExit232(that) && that._op === "Failure" && // @ts-expect-error
    equals2232(this.effect_instruction_i0, that.effect_instruction_i0);
  }
  [symbol3232]() {
    return pipe2232(
      // @ts-expect-error
      string2232(this._tag),
      // @ts-expect-error
      combine2242(hash2232(this.effect_instruction_i0)),
      cached2232(this)
    );
  }
  get cause() {
    return this.effect_instruction_i0;
  }
  pipe() {
    return pipeArguments2232(this, arguments);
  }
  toJSON() {
    return {
      _id: "Exit",
      _tag: this._op,
      cause: this.cause.toJSON()
    };
  }
  toString() {
    return format2232(this.toJSON());
  }
  [NodeInspectSymbol2232]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen22232(new YieldWrap2232(this));
  }
};
var isEffect232 = (u232) => hasProperty2232(u232, EffectTypeId22232);
var withFiberRuntime232 = (withRuntime) => {
  const effect = new EffectPrimitive232(OP_WITH_RUNTIME232);
  effect.effect_instruction_i0 = withRuntime;
  return effect;
};
var spanSymbol2232 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var originalSymbol232 = /* @__PURE__ */ Symbol.for("effect/OriginalAnnotation");
var capture232 = (obj, span222) => {
  if (isSome22232(span222)) {
    return new Proxy(obj, {
      has(target, p232) {
        return p232 === spanSymbol2232 || p232 === originalSymbol232 || p232 in target;
      },
      get(target, p232) {
        if (p232 === spanSymbol2232) {
          return span222.value;
        }
        if (p232 === originalSymbol232) {
          return obj;
        }
        return target[p232];
      }
    });
  }
  return obj;
};
var fail2232 = (error) => isObject2232(error) && !(spanSymbol2232 in error) ? withFiberRuntime232((fiber) => failCause232(fail332(capture232(error, currentSpanFromFiber232(fiber))))) : failCause232(fail332(error));
var failCause232 = (cause) => {
  const effect = new EffectPrimitiveFailure232(OP_FAILURE232);
  effect.effect_instruction_i0 = cause;
  return effect;
};
var FiberRefSymbolKey232 = "effect/FiberRef";
var FiberRefTypeId232 = /* @__PURE__ */ Symbol.for(FiberRefSymbolKey232);
var fiberRefVariance232 = {
  /* c8 ignore next */
  _A: (_232) => _232
};
var fiberRefUnsafeMakeContext232 = (initial) => {
  const differ = environment232();
  return fiberRefUnsafeMakePatch232(initial, {
    differ,
    fork: differ.empty
  });
};
var fiberRefUnsafeMakePatch232 = (initial, options) => ({
  [FiberRefTypeId232]: fiberRefVariance232,
  initial,
  diff: (oldValue, newValue) => options.differ.diff(oldValue, newValue),
  combine: (first, second) => options.differ.combine(first, second),
  patch: (patch2232) => (oldValue) => options.differ.patch(patch2232, oldValue),
  fork: options.fork,
  join: options.join ?? ((_232, n232) => n232),
  pipe() {
    return pipeArguments2232(this, arguments);
  }
});
var currentContext232 = /* @__PURE__ */ globalValue2232(/* @__PURE__ */ Symbol.for("effect/FiberRef/currentContext"), () => fiberRefUnsafeMakeContext232(empty2232()));
var YieldableError232 = /* @__PURE__ */ function() {
  class YieldableError2232 extends globalThis.Error {
    commit() {
      return fail2232(this);
    }
    toString() {
      return this.message ? `${this.name}: ${this.message}` : this.name;
    }
    toJSON() {
      return {
        ...this
      };
    }
    [NodeInspectSymbol2232]() {
      const stack = this.stack;
      if (stack) {
        return `${this.toString()}
${stack.split("\n").slice(1).join("\n")}`;
      }
      return this.toString();
    }
  }
  Object.assign(YieldableError2232.prototype, StructuralCommitPrototype2232);
  return YieldableError2232;
}();
var exitIsExit232 = (u232) => isEffect232(u232) && "_tag" in u232 && (u232._tag === "Success" || u232._tag === "Failure");
var currentSpanFromFiber232 = (fiber) => {
  const span222 = fiber.getFiberRef(currentContext232).unsafeMap.get(spanTag232.key);
  return span222 !== void 0 && span222._tag === "Span" ? some32232(span222) : none22232();
};
var Data_exports2232 = {};
__export2232(Data_exports2232, {
  Class: () => Class2232,
  Error: () => Error2232,
  Structural: () => Structural2232,
  TaggedClass: () => TaggedClass232,
  TaggedError: () => TaggedError232,
  array: () => array2232,
  case: () => _case232,
  struct: () => struct3232,
  tagged: () => tagged232,
  taggedEnum: () => taggedEnum232,
  tuple: () => tuple2232,
  unsafeArray: () => unsafeArray232,
  unsafeStruct: () => unsafeStruct232
});
var struct3232 = struct2232;
var unsafeStruct232 = (as22232) => Object.setPrototypeOf(as22232, StructuralPrototype2232);
var tuple2232 = (...as22232) => unsafeArray232(as22232);
var array2232 = (as22232) => unsafeArray232(as22232.slice(0));
var unsafeArray232 = (as22232) => Object.setPrototypeOf(as22232, ArrayProto232);
var _case232 = () => (args) => args === void 0 ? Object.create(StructuralPrototype2232) : struct3232(args);
var tagged232 = (tag) => (args) => {
  const value = args === void 0 ? Object.create(StructuralPrototype2232) : struct3232(args);
  value._tag = tag;
  return value;
};
var Class2232 = Structural332;
var TaggedClass232 = (tag) => {
  class Base extends Class2232 {
    _tag = tag;
  }
  return Base;
};
var Structural2232 = Structural332;
var taggedEnum232 = () => new Proxy({}, {
  get(_target, tag, _receiver) {
    if (tag === "$is") {
      return isTagged322;
    } else if (tag === "$match") {
      return taggedMatch232;
    }
    return tagged232(tag);
  }
});
function taggedMatch232() {
  if (arguments.length === 1) {
    const cases2 = arguments[0];
    return function(value2) {
      return cases2[value2._tag](value2);
    };
  }
  const value = arguments[0];
  const cases = arguments[1];
  return cases[value._tag](value);
}
var Error2232 = /* @__PURE__ */ function() {
  return class Base extends YieldableError232 {
    constructor(args) {
      super();
      if (args) {
        Object.assign(this, args);
      }
    }
  };
}();
var TaggedError232 = (tag) => {
  class Base extends Error2232 {
    _tag = tag;
  }
  Base.prototype.name = tag;
  return Base;
};
var traverseUp232 = Function_exports2232.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType232.Program) return Option_exports2232.none();
  return predicate(parent) ? Option_exports2232.some(parent) : traverseUp232(parent, predicate);
});
var traverseUpGuard232 = Function_exports2232.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType232.Program) return Option_exports2232.none();
  return predicate(parent) ? Option_exports2232.some(parent) : traverseUpGuard232(parent, predicate);
});
var ESLintCommunityESLintUtils232;
((ESLintCommunityESLintUtils2232) => {
  ESLintCommunityESLintUtils2232.getFunctionHeadLocation = getFunctionHeadLocation232;
  ESLintCommunityESLintUtils2232.getFunctionNameWithKind = getFunctionNameWithKind232;
  ESLintCommunityESLintUtils2232.getPropertyName = getPropertyName232;
  ESLintCommunityESLintUtils2232.getStaticValue = getStaticValue232;
  ESLintCommunityESLintUtils2232.getStringIfConstant = getStringIfConstant232;
  ESLintCommunityESLintUtils2232.hasSideEffect = hasSideEffect232;
  ESLintCommunityESLintUtils2232.isParenthesized = isParenthesized232;
})(ESLintCommunityESLintUtils232 || (ESLintCommunityESLintUtils232 = {}));
var Construction232 = Data_exports2232.taggedEnum();
Construction232.None();
a32({
  type: N32.union([NodeType232.FunctionExpression, NodeType232.ArrowFunctionExpression]),
  parent: {
    type: NodeType232.Property,
    parent: {
      type: NodeType232.ObjectExpression
    }
  }
});
a32({
  type: N32.union([NodeType232.FunctionExpression, NodeType232.ArrowFunctionExpression]),
  parent: {
    type: NodeType232.MethodDefinition,
    parent: {
      type: NodeType232.ClassBody
    }
  }
});
a32({
  type: N32.union([NodeType232.FunctionExpression, NodeType232.ArrowFunctionExpression]),
  parent: {
    type: NodeType232.Property,
    parent: {
      type: NodeType232.ClassBody
    }
  }
});
function getVariableInit3(at) {
  return (variable) => {
    return Function_exports322.pipe(
      Option_exports322.some(variable),
      Option_exports322.flatMapNullable((v232) => v232.defs.at(at)),
      Option_exports322.flatMap(
        (d232) => "init" in d232.node ? Option_exports322.fromNullable(d232.node.init) : Option_exports322.none()
      )
    );
  };
}
var { getStaticValue: getStaticValue322 } = ESLintCommunityESLintUtils42;
function getPropName2(node) {
  return $2(node.name).when(is42(NodeType42.JSXIdentifier), (n232) => n232.name).when(is42(NodeType42.JSXNamespacedName), (n232) => `${n232.namespace.name}:${n232.name.name}`).exhaustive();
}
function getPropValue(attribute, context) {
  const initialScope = context.sourceCode.getScope(attribute);
  if (attribute.type === NodeType42.JSXAttribute && "value" in attribute) {
    const { value } = attribute;
    if (value === null) return Option_exports242.none();
    if (value.type === NodeType42.Literal) return Option_exports242.some(getStaticValue322(value, initialScope));
    if (value.type === NodeType42.JSXExpressionContainer) return Option_exports242.some(getStaticValue322(value.expression, initialScope));
    return Option_exports242.none();
  }
  const { argument } = attribute;
  return Option_exports242.some(getStaticValue322(argument, initialScope));
}
function findPropInProperties2(properties, context, initialScope, seenProps = []) {
  return (propName) => {
    return Option_exports242.fromNullable(
      properties.find((prop) => {
        return $2(prop).when(is42(NodeType42.Property), (prop2) => {
          return "name" in prop2.key && prop2.key.name === propName;
        }).when(is42(NodeType42.SpreadElement), (prop2) => {
          return $2(prop2.argument).when(is42(NodeType42.Identifier), (argument) => {
            const { name: name22 } = argument;
            const maybeInit = Option_exports242.flatMap(
              findVariable242(name22, initialScope),
              getVariableInit3(0)
            );
            if (Option_exports242.isNone(maybeInit)) return false;
            const init222 = maybeInit.value;
            if (init222.type !== NodeType42.ObjectExpression) return false;
            if (seenProps.includes(name22)) return false;
            return Option_exports242.isSome(
              findPropInProperties2(init222.properties, context, initialScope, [...seenProps, name22])(propName)
            );
          }).when(is42(NodeType42.ObjectExpression), (argument) => {
            return Option_exports242.isSome(findPropInProperties2(argument.properties, context, initialScope, seenProps)(propName));
          }).when(is42(NodeType42.MemberExpression), () => {
          }).when(is42(NodeType42.CallExpression), () => {
          }).otherwise(Function_exports242.constFalse);
        }).when(is42(NodeType42.RestElement), () => {
          return false;
        }).otherwise(Function_exports242.constFalse);
      })
    );
  };
}
function findPropInAttributes2(attributes, context, initialScope) {
  return (propName) => {
    return Option_exports242.fromNullable(
      attributes.find((attr) => {
        return $2(attr).when(is42(NodeType42.JSXAttribute), (attr2) => getPropName2(attr2) === propName).when(is42(NodeType42.JSXSpreadAttribute), (attr2) => {
          return $2(attr2.argument).with({ type: NodeType42.Identifier }, (argument) => {
            const { name: name22 } = argument;
            const maybeInit = Option_exports242.flatMap(
              findVariable242(name22, initialScope),
              getVariableInit3(0)
            );
            if (Option_exports242.isNone(maybeInit)) return false;
            const init222 = maybeInit.value;
            if (!("properties" in init222)) return false;
            return Option_exports242.isSome(findPropInProperties2(init222.properties, context, initialScope)(propName));
          }).when(is42(NodeType42.ObjectExpression), (argument) => {
            return Option_exports242.isSome(findPropInProperties2(argument.properties, context, initialScope)(propName));
          }).when(is42(NodeType42.MemberExpression), () => {
            return false;
          }).when(is42(NodeType42.CallExpression), () => {
            return false;
          }).otherwise(Function_exports242.constFalse);
        }).otherwise(Function_exports242.constFalse);
      })
    );
  };
}
function hasProp2(attributes, propName, context, initialScope) {
  return Option_exports242.isSome(findPropInAttributes2(attributes, context, initialScope)(propName));
}
var isLiteral2 = isOneOf42([NodeType42.Literal, NodeType42.JSXText]);
function isWhiteSpace2(node) {
  return Predicate_exports242.isString(node.value) && node.value.trim() === "";
}
function isLineBreak(node) {
  return isLiteral2(node) && isWhiteSpace2(node) && isMultiLine(node);
}
var Function_exports72 = {};
__export7(Function_exports72, {
  SK: () => SK72,
  absurd: () => absurd72,
  apply: () => apply72,
  compose: () => compose102,
  constFalse: () => constFalse72,
  constNull: () => constNull72,
  constTrue: () => constTrue72,
  constUndefined: () => constUndefined72,
  constVoid: () => constVoid72,
  constant: () => constant72,
  dual: () => dual72,
  flip: () => flip72,
  flow: () => flow72,
  hole: () => hole72,
  identity: () => identity72,
  isFunction: () => isFunction102,
  pipe: () => pipe72,
  satisfies: () => satisfies72,
  tupled: () => tupled72,
  unsafeCoerce: () => unsafeCoerce72,
  untupled: () => untupled72
});
var isFunction102 = (input) => typeof input === "function";
var dual72 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a52, b52) {
        if (arguments.length >= 2) {
          return body(a52, b52);
        }
        return function(self2) {
          return body(self2, a52);
        };
      };
    case 3:
      return function(a52, b52, c52) {
        if (arguments.length >= 3) {
          return body(a52, b52, c52);
        }
        return function(self2) {
          return body(self2, a52, b52);
        };
      };
    case 4:
      return function(a52, b52, c52, d52) {
        if (arguments.length >= 4) {
          return body(a52, b52, c52, d52);
        }
        return function(self2) {
          return body(self2, a52, b52, c52);
        };
      };
    case 5:
      return function(a52, b52, c52, d52, e52) {
        if (arguments.length >= 5) {
          return body(a52, b52, c52, d52, e52);
        }
        return function(self2) {
          return body(self2, a52, b52, c52, d52);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply72 = (a52) => (self2) => self2(a52);
var identity72 = (a52) => a52;
var satisfies72 = () => (b52) => b52;
var unsafeCoerce72 = identity72;
var constant72 = (value) => () => value;
var constTrue72 = /* @__PURE__ */ constant72(true);
var constFalse72 = /* @__PURE__ */ constant72(false);
var constNull72 = /* @__PURE__ */ constant72(null);
var constUndefined72 = /* @__PURE__ */ constant72(void 0);
var constVoid72 = constUndefined72;
var flip72 = (f52) => (...b52) => (...a52) => f52(...a52)(...b52);
var compose102 = /* @__PURE__ */ dual72(2, (ab, bc) => (a52) => bc(ab(a52)));
var absurd72 = (_52) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled72 = (f52) => (a52) => f52(...a52);
var untupled72 = (f52) => (...a52) => f52(a52);
function pipe72(a52, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a52;
    case 2:
      return ab(a52);
    case 3:
      return bc(ab(a52));
    case 4:
      return cd(bc(ab(a52)));
    case 5:
      return de(cd(bc(ab(a52))));
    case 6:
      return ef(de(cd(bc(ab(a52)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a52))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a52)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a52))))))));
    default: {
      let ret = arguments[0];
      for (let i52 = 1; i52 < arguments.length; i52++) {
        ret = arguments[i52](ret);
      }
      return ret;
    }
  }
}
function flow72(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole72 = /* @__PURE__ */ unsafeCoerce72(absurd72);
var SK72 = (_52, b52) => b52;
var make182 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_112 = (map102) => dual72(3, (self2, name22, f52) => map102(self2, (a52) => Object.assign({}, a52, {
  [name22]: f52(a52)
})));
var bindTo112 = (map102) => dual72(2, (self2, name22) => map102(self2, (a52) => ({
  [name22]: a52
})));
var bind112 = (map102, flatMap102) => dual72(3, (self2, name22, f52) => flatMap102(self2, (a52) => map102(f52(a52), (b52) => Object.assign({}, a52, {
  [name22]: b52
}))));
var moduleVersion72 = "3.2.8";
var getCurrentVersion72 = () => moduleVersion72;
var globalStoreId72 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion72()}`);
if (!(globalStoreId72 in globalThis)) {
  globalThis[globalStoreId72] = /* @__PURE__ */ new Map();
}
var globalStore72 = globalThis[globalStoreId72];
var globalValue72 = (id, compute) => {
  if (!globalStore72.has(id)) {
    globalStore72.set(id, compute());
  }
  return globalStore72.get(id);
};
var Predicate_exports52 = {};
__export7(Predicate_exports52, {
  all: () => all102,
  and: () => and72,
  compose: () => compose112,
  eqv: () => eqv72,
  every: () => every82,
  hasProperty: () => hasProperty72,
  implies: () => implies72,
  isBigInt: () => isBigInt72,
  isBoolean: () => isBoolean72,
  isDate: () => isDate72,
  isError: () => isError72,
  isFunction: () => isFunction112,
  isIterable: () => isIterable72,
  isMap: () => isMap72,
  isNever: () => isNever72,
  isNotNull: () => isNotNull72,
  isNotNullable: () => isNotNullable72,
  isNotUndefined: () => isNotUndefined72,
  isNull: () => isNull72,
  isNullable: () => isNullable72,
  isNumber: () => isNumber72,
  isObject: () => isObject72,
  isPromise: () => isPromise72,
  isPromiseLike: () => isPromiseLike72,
  isReadonlyRecord: () => isReadonlyRecord72,
  isRecord: () => isRecord72,
  isSet: () => isSet72,
  isString: () => isString72,
  isSymbol: () => isSymbol72,
  isTagged: () => isTagged72,
  isTruthy: () => isTruthy72,
  isUint8Array: () => isUint8Array72,
  isUndefined: () => isUndefined72,
  isUnknown: () => isUnknown72,
  mapInput: () => mapInput82,
  nand: () => nand72,
  nor: () => nor72,
  not: () => not72,
  or: () => or72,
  product: () => product102,
  productMany: () => productMany102,
  some: () => some142,
  struct: () => struct92,
  tuple: () => tuple82,
  xor: () => xor72
});
var mapInput82 = /* @__PURE__ */ dual72(2, (self2, f52) => (b52) => self2(f52(b52)));
var isTruthy72 = (input) => !!input;
var isSet72 = (input) => input instanceof Set;
var isMap72 = (input) => input instanceof Map;
var isString72 = (input) => typeof input === "string";
var isNumber72 = (input) => typeof input === "number";
var isBoolean72 = (input) => typeof input === "boolean";
var isBigInt72 = (input) => typeof input === "bigint";
var isSymbol72 = (input) => typeof input === "symbol";
var isFunction112 = isFunction102;
var isUndefined72 = (input) => input === void 0;
var isNotUndefined72 = (input) => input !== void 0;
var isNull72 = (input) => input === null;
var isNotNull72 = (input) => input !== null;
var isNever72 = (_52) => false;
var isUnknown72 = (_52) => true;
var isRecordOrArray72 = (input) => typeof input === "object" && input !== null;
var isObject72 = (input) => isRecordOrArray72(input) || isFunction112(input);
var hasProperty72 = /* @__PURE__ */ dual72(2, (self2, property) => isObject72(self2) && property in self2);
var isTagged72 = /* @__PURE__ */ dual72(2, (self2, tag) => hasProperty72(self2, "_tag") && self2["_tag"] === tag);
var isNullable72 = (input) => input === null || input === void 0;
var isNotNullable72 = (input) => input !== null && input !== void 0;
var isError72 = (input) => input instanceof Error;
var isUint8Array72 = (input) => input instanceof Uint8Array;
var isDate72 = (input) => input instanceof Date;
var isIterable72 = (input) => hasProperty72(input, Symbol.iterator);
var isRecord72 = (input) => isRecordOrArray72(input) && !Array.isArray(input);
var isReadonlyRecord72 = isRecord72;
var isPromise72 = (input) => hasProperty72(input, "then") && "catch" in input && isFunction112(input.then) && isFunction112(input.catch);
var isPromiseLike72 = (input) => hasProperty72(input, "then") && isFunction112(input.then);
var compose112 = /* @__PURE__ */ dual72(2, (ab, bc) => (a52) => ab(a52) && bc(a52));
var product102 = (self2, that) => ([a52, b52]) => self2(a52) && that(b52);
var all102 = (collection) => {
  return (as92) => {
    let collectionIndex = 0;
    for (const p52 of collection) {
      if (collectionIndex >= as92.length) {
        break;
      }
      if (p52(as92[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany102 = (self2, collection) => {
  const rest = all102(collection);
  return ([head42, ...tail42]) => self2(head42) === false ? false : rest(tail42);
};
var tuple82 = (...elements) => all102(elements);
var struct92 = (fields) => {
  const keys72 = Object.keys(fields);
  return (a52) => {
    for (const key of keys72) {
      if (!fields[key](a52[key])) {
        return false;
      }
    }
    return true;
  };
};
var not72 = (self2) => (a52) => !self2(a52);
var or72 = /* @__PURE__ */ dual72(2, (self2, that) => (a52) => self2(a52) || that(a52));
var and72 = /* @__PURE__ */ dual72(2, (self2, that) => (a52) => self2(a52) && that(a52));
var xor72 = /* @__PURE__ */ dual72(2, (self2, that) => (a52) => self2(a52) !== that(a52));
var eqv72 = /* @__PURE__ */ dual72(2, (self2, that) => (a52) => self2(a52) === that(a52));
var implies72 = /* @__PURE__ */ dual72(2, (self2, that) => (a52) => self2(a52) ? that(a52) : true);
var nor72 = /* @__PURE__ */ dual72(2, (self2, that) => (a52) => !(self2(a52) || that(a52)));
var nand72 = /* @__PURE__ */ dual72(2, (self2, that) => (a52) => !(self2(a52) && that(a52)));
var every82 = (collection) => (a52) => {
  for (const p52 of collection) {
    if (!p52(a52)) {
      return false;
    }
  }
  return true;
};
var some142 = (collection) => (a52) => {
  for (const p52 of collection) {
    if (p52(a52)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage72 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId72 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind72 = (u52) => isObject72(u52) && GenKindTypeId72 in u52;
var GenKindImpl72 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity72;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_52) => _52;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_52) => _52;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_52) => _52;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId72] = GenKindTypeId72;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen82(this);
  }
};
var SingleShotGen82 = class _SingleShotGen102 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a52) {
    return this.called ? {
      value: a52,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a52) {
    return {
      value: a52,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e52) {
    throw e52;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen102(this.self);
  }
};
var adapter102 = () => function() {
  let x52 = arguments[0];
  for (let i52 = 1; i52 < arguments.length; i52++) {
    x52 = arguments[i52](x52);
  }
  return new GenKindImpl72(x52);
};
var defaultIncHi72 = 335903614;
var defaultIncLo72 = 4150755663;
var MUL_HI72 = 1481765933 >>> 0;
var MUL_LO72 = 1284865837 >>> 0;
var BIT_5372 = 9007199254740992;
var BIT_2772 = 134217728;
var PCGRandom72 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable72(seedLo) && isNullable72(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable72(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable72(incLo) && isNullable72(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo72;
      incHi = this._state ? this._state[2] : defaultIncHi72;
    } else if (isNullable72(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add6472(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max42) {
    if (!max42) {
      return this._next();
    }
    max42 = max42 >>> 0;
    if ((max42 & max42 - 1) === 0) {
      return this._next() & max42 - 1;
    }
    let num = 0;
    const skew = (-max42 >>> 0) % max42 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max42;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_2772 + lo) / BIT_5372;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul6472(this._state, oldHi, oldLo, MUL_HI72, MUL_LO72);
    add6472(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul6472(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add6472(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId72 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap72 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId72]() {
    return this.#value;
  }
};
function yieldWrapGet72(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId72 in self2) {
    return self2[YieldWrapTypeId72]();
  }
  throw new Error(getBugErrorMessage72("yieldWrapGet"));
}
var structuralRegionState72 = /* @__PURE__ */ globalValue72("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache72 = /* @__PURE__ */ globalValue72(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr72 = /* @__PURE__ */ globalValue72(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom72());
var symbol102 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash72 = (self2) => {
  if (structuralRegionState72.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number82(self2);
    case "bigint":
      return string82(self2.toString(10));
    case "boolean":
      return string82(String(self2));
    case "symbol":
      return string82(String(self2));
    case "string":
      return string82(self2);
    case "undefined":
      return string82("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string82("null");
      } else if (self2 instanceof Date) {
        return hash72(self2.toISOString());
      } else if (isHash72(self2)) {
        return self2[symbol102]();
      } else {
        return random72(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random72 = (self2) => {
  if (!randomHashCache72.has(self2)) {
    randomHashCache72.set(self2, number82(pcgr72.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache72.get(self2);
};
var combine82 = (b52) => (self2) => self2 * 53 ^ b52;
var optimize72 = (n52) => n52 & 3221225471 | n52 >>> 1 & 1073741824;
var isHash72 = (u52) => hasProperty72(u52, symbol102);
var number82 = (n52) => {
  if (n52 !== n52 || n52 === Infinity) {
    return 0;
  }
  let h52 = n52 | 0;
  if (h52 !== n52) {
    h52 ^= n52 * 4294967295;
  }
  while (n52 > 4294967295) {
    h52 ^= n52 /= 4294967295;
  }
  return optimize72(n52);
};
var string82 = (str) => {
  let h52 = 5381, i52 = str.length;
  while (i52) {
    h52 = h52 * 33 ^ str.charCodeAt(--i52);
  }
  return optimize72(h52);
};
var cached72 = function() {
  if (arguments.length === 1) {
    const self3 = arguments[0];
    return function(hash102) {
      Object.defineProperty(self3, symbol102, {
        value() {
          return hash102;
        },
        enumerable: false
      });
      return hash102;
    };
  }
  const self2 = arguments[0];
  const hash92 = arguments[1];
  Object.defineProperty(self2, symbol102, {
    value() {
      return hash92;
    },
    enumerable: false
  });
  return hash92;
};
var symbol112 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals72() {
  if (arguments.length === 1) {
    return (self2) => compareBoth72(self2, arguments[0]);
  }
  return compareBoth72(arguments[0], arguments[1]);
}
function compareBoth72(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual72(self2) && isEqual72(that)) {
        if (hash72(self2) === hash72(that) && self2[symbol112](that)) {
          return true;
        } else {
          return structuralRegionState72.enabled && structuralRegionState72.tester ? structuralRegionState72.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState72.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v52, i52) => compareBoth72(v52, that[i52]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth72(self2[key], that[key]))) {
              return structuralRegionState72.tester ? structuralRegionState72.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState72.tester ? structuralRegionState72.tester(self2, that) : false;
    }
  }
  return structuralRegionState72.enabled && structuralRegionState72.tester ? structuralRegionState72.tester(self2, that) : false;
}
var isEqual72 = (u52) => hasProperty72(u52, symbol112);
var equivalence72 = () => equals72;
var NodeInspectSymbol72 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON72 = (x52) => {
  if (hasProperty72(x52, "toJSON") && isFunction112(x52["toJSON"]) && x52["toJSON"].length === 0) {
    return x52.toJSON();
  } else if (Array.isArray(x52)) {
    return x52.map(toJSON72);
  }
  return x52;
};
var format72 = (x52) => JSON.stringify(x52, null, 2);
var pipeArguments72 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i52 = 0, len = args.length; i52 < len; i52++) {
        ret = args[i52](ret);
      }
      return ret;
    }
  }
};
var EffectTypeId82 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId72 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId72 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId72 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance72 = {
  /* c8 ignore next */
  _R: (_52) => _52,
  /* c8 ignore next */
  _E: (_52) => _52,
  /* c8 ignore next */
  _A: (_52) => _52,
  _V: /* @__PURE__ */ getCurrentVersion72()
};
var sinkVariance72 = {
  /* c8 ignore next */
  _A: (_52) => _52,
  /* c8 ignore next */
  _In: (_52) => _52,
  /* c8 ignore next */
  _L: (_52) => _52,
  /* c8 ignore next */
  _E: (_52) => _52,
  /* c8 ignore next */
  _R: (_52) => _52
};
var channelVariance72 = {
  /* c8 ignore next */
  _Env: (_52) => _52,
  /* c8 ignore next */
  _InErr: (_52) => _52,
  /* c8 ignore next */
  _InElem: (_52) => _52,
  /* c8 ignore next */
  _InDone: (_52) => _52,
  /* c8 ignore next */
  _OutErr: (_52) => _52,
  /* c8 ignore next */
  _OutElem: (_52) => _52,
  /* c8 ignore next */
  _OutDone: (_52) => _52
};
var EffectPrototype72 = {
  [EffectTypeId82]: effectVariance72,
  [StreamTypeId72]: effectVariance72,
  [SinkTypeId72]: sinkVariance72,
  [ChannelTypeId72]: channelVariance72,
  [symbol112](that) {
    return this === that;
  },
  [symbol102]() {
    return cached72(this, random72(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen82(new YieldWrap72(this));
  },
  pipe() {
    return pipeArguments72(this, arguments);
  }
};
var TypeId172 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto102 = {
  ...EffectPrototype72,
  [TypeId172]: {
    _A: (_52) => _52
  },
  [NodeInspectSymbol72]() {
    return this.toJSON();
  },
  toString() {
    return format72(this.toJSON());
  }
};
var SomeProto72 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto102), {
  _tag: "Some",
  _op: "Some",
  [symbol112](that) {
    return isOption102(that) && isSome102(that) && equals72(this.value, that.value);
  },
  [symbol102]() {
    return cached72(this, combine82(hash72(this._tag))(hash72(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON72(this.value)
    };
  }
});
var NoneHash72 = /* @__PURE__ */ hash72("None");
var NoneProto72 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto102), {
  _tag: "None",
  _op: "None",
  [symbol112](that) {
    return isOption102(that) && isNone102(that);
  },
  [symbol102]() {
    return NoneHash72;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption102 = (input) => hasProperty72(input, TypeId172);
var isNone102 = (fa) => fa._tag === "None";
var isSome102 = (fa) => fa._tag === "Some";
var none102 = /* @__PURE__ */ Object.create(NoneProto72);
var some152 = (value) => {
  const a52 = Object.create(SomeProto72);
  a52.value = value;
  return a52;
};
var TypeId182 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto112 = {
  ...EffectPrototype72,
  [TypeId182]: {
    _R: (_52) => _52
  },
  [NodeInspectSymbol72]() {
    return this.toJSON();
  },
  toString() {
    return format72(this.toJSON());
  }
};
var RightProto72 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto112), {
  _tag: "Right",
  _op: "Right",
  [symbol112](that) {
    return isEither72(that) && isRight82(that) && equals72(this.right, that.right);
  },
  [symbol102]() {
    return combine82(hash72(this._tag))(hash72(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON72(this.right)
    };
  }
});
var LeftProto72 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto112), {
  _tag: "Left",
  _op: "Left",
  [symbol112](that) {
    return isEither72(that) && isLeft82(that) && equals72(this.left, that.left);
  },
  [symbol102]() {
    return combine82(hash72(this._tag))(hash72(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON72(this.left)
    };
  }
});
var isEither72 = (input) => hasProperty72(input, TypeId182);
var isLeft82 = (ma) => ma._tag === "Left";
var isRight82 = (ma) => ma._tag === "Right";
var left82 = (left102) => {
  const a52 = Object.create(LeftProto72);
  a52.left = left102;
  return a52;
};
var right82 = (right102) => {
  const a52 = Object.create(RightProto72);
  a52.right = right102;
  return a52;
};
var getLeft102 = (self2) => isRight82(self2) ? none102 : some152(self2.left);
var getRight102 = (self2) => isLeft82(self2) ? none102 : some152(self2.right);
var Option_exports72 = {};
__export7(Option_exports72, {
  Do: () => Do82,
  TypeId: () => TypeId192,
  all: () => all112,
  andThen: () => andThen72,
  ap: () => ap72,
  as: () => as72,
  asVoid: () => asVoid72,
  bind: () => bind122,
  bindTo: () => bindTo122,
  composeK: () => composeK72,
  contains: () => contains82,
  containsWith: () => containsWith82,
  exists: () => exists72,
  filter: () => filter82,
  filterMap: () => filterMap82,
  firstSomeOf: () => firstSomeOf72,
  flatMap: () => flatMap82,
  flatMapNullable: () => flatMapNullable82,
  flatten: () => flatten82,
  fromIterable: () => fromIterable102,
  fromNullable: () => fromNullable82,
  gen: () => gen72,
  getEquivalence: () => getEquivalence92,
  getLeft: () => getLeft112,
  getOrElse: () => getOrElse72,
  getOrNull: () => getOrNull72,
  getOrThrow: () => getOrThrow72,
  getOrThrowWith: () => getOrThrowWith72,
  getOrUndefined: () => getOrUndefined72,
  getOrder: () => getOrder82,
  getRight: () => getRight112,
  isNone: () => isNone112,
  isOption: () => isOption112,
  isSome: () => isSome112,
  let: () => let_122,
  lift2: () => lift272,
  liftNullable: () => liftNullable82,
  liftPredicate: () => liftPredicate82,
  liftThrowable: () => liftThrowable72,
  map: () => map82,
  match: () => match9,
  none: () => none112,
  orElse: () => orElse72,
  orElseEither: () => orElseEither72,
  orElseSome: () => orElseSome72,
  partitionMap: () => partitionMap82,
  product: () => product112,
  productMany: () => productMany112,
  reduceCompact: () => reduceCompact72,
  some: () => some162,
  tap: () => tap72,
  toArray: () => toArray72,
  toRefinement: () => toRefinement72,
  void: () => void_72,
  zipLeft: () => zipLeft72,
  zipRight: () => zipRight72,
  zipWith: () => zipWith82
});
var make192 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId192 = /* @__PURE__ */ Symbol.for("effect/Option");
var none112 = () => none102;
var some162 = some152;
var isOption112 = isOption102;
var isNone112 = isNone102;
var isSome112 = isSome102;
var match9 = /* @__PURE__ */ dual72(2, (self2, {
  onNone,
  onSome
}) => isNone112(self2) ? onNone() : onSome(self2.value));
var toRefinement72 = (f52) => (a52) => isSome112(f52(a52));
var fromIterable102 = (collection) => {
  for (const a52 of collection) {
    return some162(a52);
  }
  return none112();
};
var getRight112 = getRight102;
var getLeft112 = getLeft102;
var getOrElse72 = /* @__PURE__ */ dual72(2, (self2, onNone) => isNone112(self2) ? onNone() : self2.value);
var orElse72 = /* @__PURE__ */ dual72(2, (self2, that) => isNone112(self2) ? that() : self2);
var orElseSome72 = /* @__PURE__ */ dual72(2, (self2, onNone) => isNone112(self2) ? some162(onNone()) : self2);
var orElseEither72 = /* @__PURE__ */ dual72(2, (self2, that) => isNone112(self2) ? map82(that(), right82) : map82(self2, left82));
var firstSomeOf72 = (collection) => {
  let out = none112();
  for (out of collection) {
    if (isSome112(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable82 = (nullableValue) => nullableValue == null ? none112() : some162(nullableValue);
var liftNullable82 = (f52) => (...a52) => fromNullable82(f52(...a52));
var getOrNull72 = /* @__PURE__ */ getOrElse72(constNull72);
var getOrUndefined72 = /* @__PURE__ */ getOrElse72(constUndefined72);
var liftThrowable72 = (f52) => (...a52) => {
  try {
    return some162(f52(...a52));
  } catch (e52) {
    return none112();
  }
};
var getOrThrowWith72 = /* @__PURE__ */ dual72(2, (self2, onNone) => {
  if (isSome112(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow72 = /* @__PURE__ */ getOrThrowWith72(() => new Error("getOrThrow called on a None"));
var map82 = /* @__PURE__ */ dual72(2, (self2, f52) => isNone112(self2) ? none112() : some162(f52(self2.value)));
var as72 = /* @__PURE__ */ dual72(2, (self2, b52) => map82(self2, () => b52));
var asVoid72 = /* @__PURE__ */ as72(void 0);
var void_72 = /* @__PURE__ */ some162(void 0);
var flatMap82 = /* @__PURE__ */ dual72(2, (self2, f52) => isNone112(self2) ? none112() : f52(self2.value));
var andThen72 = /* @__PURE__ */ dual72(2, (self2, f52) => flatMap82(self2, (a52) => {
  const b52 = isFunction102(f52) ? f52(a52) : f52;
  return isOption112(b52) ? b52 : some162(b52);
}));
var flatMapNullable82 = /* @__PURE__ */ dual72(2, (self2, f52) => isNone112(self2) ? none112() : fromNullable82(f52(self2.value)));
var flatten82 = /* @__PURE__ */ flatMap82(identity72);
var zipRight72 = /* @__PURE__ */ dual72(2, (self2, that) => flatMap82(self2, () => that));
var composeK72 = /* @__PURE__ */ dual72(2, (afb, bfc) => (a52) => flatMap82(afb(a52), bfc));
var zipLeft72 = /* @__PURE__ */ dual72(2, (self2, that) => tap72(self2, () => that));
var tap72 = /* @__PURE__ */ dual72(2, (self2, f52) => flatMap82(self2, (a52) => map82(f52(a52), () => a52)));
var product112 = (self2, that) => isSome112(self2) && isSome112(that) ? some162([self2.value, that.value]) : none112();
var productMany112 = (self2, collection) => {
  if (isNone112(self2)) {
    return none112();
  }
  const out = [self2.value];
  for (const o52 of collection) {
    if (isNone112(o52)) {
      return none112();
    }
    out.push(o52.value);
  }
  return some162(out);
};
var all112 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o52 of input) {
      if (isNone112(o52)) {
        return none112();
      }
      out2.push(o52.value);
    }
    return some162(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o52 = input[key];
    if (isNone112(o52)) {
      return none112();
    }
    out[key] = o52.value;
  }
  return some162(out);
};
var zipWith82 = /* @__PURE__ */ dual72(3, (self2, that, f52) => map82(product112(self2, that), ([a52, b52]) => f52(a52, b52)));
var ap72 = /* @__PURE__ */ dual72(2, (self2, that) => zipWith82(self2, that, (f52, a52) => f52(a52)));
var reduceCompact72 = /* @__PURE__ */ dual72(3, (self2, b52, f52) => {
  let out = b52;
  for (const oa of self2) {
    if (isSome112(oa)) {
      out = f52(out, oa.value);
    }
  }
  return out;
});
var toArray72 = (self2) => isNone112(self2) ? [] : [self2.value];
var partitionMap82 = /* @__PURE__ */ dual72(2, (self2, f52) => {
  if (isNone112(self2)) {
    return [none112(), none112()];
  }
  const e52 = f52(self2.value);
  return isLeft82(e52) ? [some162(e52.left), none112()] : [none112(), some162(e52.right)];
});
var filterMap82 = /* @__PURE__ */ dual72(2, (self2, f52) => isNone112(self2) ? none112() : f52(self2.value));
var filter82 = /* @__PURE__ */ dual72(2, (self2, predicate) => filterMap82(self2, (b52) => predicate(b52) ? some152(b52) : none102));
var getEquivalence92 = (isEquivalent) => make182((x52, y52) => x52 === y52 || (isNone112(x52) ? isNone112(y52) : isNone112(y52) ? false : isEquivalent(x52.value, y52.value)));
var getOrder82 = (O52) => make192((self2, that) => isSome112(self2) ? isSome112(that) ? O52(self2.value, that.value) : 1 : -1);
var lift272 = (f52) => dual72(2, (self2, that) => zipWith82(self2, that, f52));
var liftPredicate82 = (predicate) => (b52) => predicate(b52) ? some162(b52) : none112();
var containsWith82 = (isEquivalent) => dual72(2, (self2, a52) => isNone112(self2) ? false : isEquivalent(self2.value, a52));
var _equivalence92 = /* @__PURE__ */ equivalence72();
var contains82 = /* @__PURE__ */ containsWith82(_equivalence92);
var exists72 = /* @__PURE__ */ dual72(2, (self2, refinement) => isNone112(self2) ? false : refinement(self2.value));
var bindTo122 = /* @__PURE__ */ bindTo112(map82);
var let_122 = /* @__PURE__ */ let_112(map82);
var bind122 = /* @__PURE__ */ bind112(map82, flatMap82);
var Do82 = /* @__PURE__ */ some162({});
var adapter112 = /* @__PURE__ */ adapter102();
var gen72 = (f52) => {
  const iterator = f52(adapter112);
  let state = iterator.next();
  if (state.done) {
    return some162(state.value);
  } else {
    let current = state.value;
    if (isGenKind72(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet72(current);
    }
    if (isNone112(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind72(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet72(current);
        }
        if (isNone112(current)) {
          return current;
        }
      }
    }
    return some162(state.value);
  }
};
var WEBSITE_URL2 = "https://eslint-react.xyz";
var RE_JAVASCRIPT_PROTOCOL = /^[\u0000-\u001F ]*j[\t\n\r]*a[\t\n\r]*v[\t\n\r]*a[\t\n\r]*s[\t\n\r]*c[\t\n\r]*r[\t\n\r]*i[\t\n\r]*p[\t\n\r]*t[\t\n\r]*:/iu;
var getDocsUrl2 = (pluginName) => (ruleName) => {
  return `${WEBSITE_URL2}/rules/${pluginName}-${ruleName}`;
};
var createRuleForPlugin2 = (pluginName) => utils.ESLintUtils.RuleCreator(getDocsUrl2(pluginName));
var store222;
function getGlobalMessage22(lang) {
  return store222?.get(lang);
}
var store322;
function getSchemaMessage22(lang) {
  return store322?.get(lang);
}
var store422;
function getSpecificMessage22(reference, lang) {
  return store422?.get(reference)?.get(lang);
}
function _stringify22(input) {
  let type = typeof input;
  if (type === "object") {
    type = (input && Object.getPrototypeOf(input)?.constructor?.name) ?? "null";
  }
  return type === "string" ? `"${input}"` : type === "number" || type === "bigint" || type === "boolean" ? `${input}` : type;
}
function _addIssue22(context, label, dataset, config2, other) {
  const input = dataset.value;
  const expected = context.expects;
  const received = _stringify22(input);
  const issue = {
    kind: context.kind,
    type: context.type,
    input,
    expected,
    received,
    message: `Invalid ${label}: ${expected ? `Expected ${expected} but r` : "R"}eceived ${received}`,
    // @ts-expect-error
    requirement: context.requirement,
    path: other?.path,
    issues: other?.issues,
    lang: config2.lang,
    abortEarly: config2.abortEarly,
    abortPipeEarly: config2.abortPipeEarly,
    skipPipe: config2.skipPipe
  };
  const isSchema = context.kind === "schema";
  const message = (
    // @ts-expect-error
    context.message ?? getSpecificMessage22(context.reference, issue.lang) ?? (isSchema ? getSchemaMessage22(issue.lang) : null) ?? config2.message ?? getGlobalMessage22(issue.lang)
  );
  if (message) {
    issue.message = typeof message === "function" ? message(issue) : message;
  }
  if (isSchema) {
    dataset.typed = false;
  }
  if (dataset.issues) {
    dataset.issues.push(issue);
  } else {
    dataset.issues = [issue];
  }
}
function getDefault22(schema4, dataset, config2) {
  return typeof schema4.default === "function" ? (
    // @ts-expect-error
    schema4.default(dataset, config2)
  ) : (
    // @ts-expect-error
    schema4.default
  );
}
function array92(item, message) {
  return {
    kind: "schema",
    type: "array",
    reference: array92,
    expects: "Array",
    async: false,
    item,
    message,
    _run(dataset, config2) {
      const input = dataset.value;
      if (Array.isArray(input)) {
        dataset.typed = true;
        dataset.value = [];
        for (let key = 0; key < input.length; key++) {
          const value2 = input[key];
          const itemDataset = this.item._run({ typed: false, value: value2 }, config2);
          if (itemDataset.issues) {
            const pathItem = {
              type: "array",
              origin: "value",
              input,
              key,
              value: value2
            };
            for (const issue of itemDataset.issues) {
              if (issue.path) {
                issue.path.unshift(pathItem);
              } else {
                issue.path = [pathItem];
              }
              dataset.issues?.push(issue);
            }
            if (!dataset.issues) {
              dataset.issues = itemDataset.issues;
            }
            if (config2.abortEarly) {
              dataset.typed = false;
              break;
            }
          }
          if (!itemDataset.typed) {
            dataset.typed = false;
          }
          dataset.value.push(itemDataset.value);
        }
      } else {
        _addIssue22(this, "type", dataset, config2);
      }
      return dataset;
    }
  };
}
function object22(entries2, message) {
  return {
    kind: "schema",
    type: "object",
    reference: object22,
    expects: "Object",
    async: false,
    entries: entries2,
    message,
    _run(dataset, config2) {
      const input = dataset.value;
      if (input && typeof input === "object") {
        dataset.typed = true;
        dataset.value = {};
        for (const key in this.entries) {
          const value2 = input[key];
          const valueDataset = this.entries[key]._run(
            { typed: false, value: value2 },
            config2
          );
          if (valueDataset.issues) {
            const pathItem = {
              type: "object",
              origin: "value",
              input,
              key,
              value: value2
            };
            for (const issue of valueDataset.issues) {
              if (issue.path) {
                issue.path.unshift(pathItem);
              } else {
                issue.path = [pathItem];
              }
              dataset.issues?.push(issue);
            }
            if (!dataset.issues) {
              dataset.issues = valueDataset.issues;
            }
            if (config2.abortEarly) {
              dataset.typed = false;
              break;
            }
          }
          if (!valueDataset.typed) {
            dataset.typed = false;
          }
          if (valueDataset.value !== void 0 || key in input) {
            dataset.value[key] = valueDataset.value;
          }
        }
      } else {
        _addIssue22(this, "type", dataset, config2);
      }
      return dataset;
    }
  };
}
function optional22(wrapped, ...args) {
  const schema4 = {
    kind: "schema",
    type: "optional",
    reference: optional22,
    expects: `${wrapped.expects} | undefined`,
    async: false,
    wrapped,
    _run(dataset, config2) {
      if (dataset.value === void 0) {
        if ("default" in this) {
          dataset.value = getDefault22(
            this,
            dataset,
            config2
          );
        }
        if (dataset.value === void 0) {
          dataset.typed = true;
          return dataset;
        }
      }
      return this.wrapped._run(dataset, config2);
    }
  };
  if (0 in args) {
    schema4.default = args[0];
  }
  return schema4;
}
function string92(message) {
  return {
    kind: "schema",
    type: "string",
    reference: string92,
    expects: "string",
    async: false,
    message,
    _run(dataset, config2) {
      if (typeof dataset.value === "string") {
        dataset.typed = true;
      } else {
        _addIssue22(this, "type", dataset, config2);
      }
      return dataset;
    }
  };
}
var ESLintReactSettingsSchema22 = object22({
  additionalHooks: optional22(object22({
    use: optional22(string92()),
    useCallback: optional22(array92(string92())),
    useContext: optional22(array92(string92())),
    useDebugValue: optional22(array92(string92())),
    useDeferredValue: optional22(array92(string92())),
    useEffect: optional22(array92(string92())),
    useId: optional22(array92(string92())),
    useImperativeHandle: optional22(array92(string92())),
    useInsertionEffect: optional22(array92(string92())),
    useLayoutEffect: optional22(array92(string92())),
    useMemo: optional22(array92(string92())),
    useOptimistic: optional22(array92(string92())),
    useReducer: optional22(array92(string92())),
    useRef: optional22(array92(string92())),
    useState: optional22(array92(string92())),
    useSyncExternalStore: optional22(array92(string92())),
    useTransition: optional22(array92(string92()))
  })),
  importSource: optional22(string92()),
  jsxPragma: optional22(string92()),
  jsxPragmaFrag: optional22(string92()),
  version: optional22(string92())
});
object22({
  reactOptions: optional22(ESLintReactSettingsSchema22)
});
var createRule2 = createRuleForPlugin2("dom");
var RULE_NAME43 = "no-children-in-void-dom-elements";
var voidElements = /* @__PURE__ */ new Set([
  "area",
  "base",
  "br",
  "col",
  "embed",
  "hr",
  "img",
  "input",
  "keygen",
  "link",
  "menuitem",
  "meta",
  "param",
  "source",
  "track",
  "wbr"
]);
var no_children_in_void_dom_elements_default = createRule2({
  meta: {
    type: "problem",
    docs: {
      description: "disallow passing 'children' to void DOM elements",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_CHILDREN_IN_VOID_DOM_ELEMENTS: "A void DOM element '<{{element}} />' cannot have children."
    },
    schema: []
  },
  name: RULE_NAME43,
  create(context) {
    return {
      CallExpression(node) {
        if (node.callee.type !== NodeType6.MemberExpression && node.callee.type !== NodeType6.Identifier) {
          return;
        }
        const initialScope = context.sourceCode.getScope(node);
        if (!isCreateElementCall2(node, context)) return;
        const args = node.arguments;
        if (args.length < 2) return;
        const elementNameNode = args[0];
        if (!elementNameNode || !("value" in elementNameNode)) return;
        const elementName = elementNameNode.value;
        if (typeof elementName !== "string" || !voidElements.has(elementName)) return;
        const propsNode = args[1];
        if (propsNode?.type !== NodeType6.ObjectExpression) return;
        const firstChild = args[2];
        if (firstChild) {
          context.report({
            data: {
              element: elementName
            },
            messageId: "NO_CHILDREN_IN_VOID_DOM_ELEMENTS",
            node
          });
        }
        const props = propsNode.properties;
        const findProp = findPropInProperties2(props, context, initialScope);
        const hasChildrenOrDangerProp = Option_exports72.isSome(findProp("children")) || Option_exports72.isSome(findProp("dangerouslySetInnerHTML"));
        if (hasChildrenOrDangerProp) {
          context.report({
            data: {
              element: elementName
            },
            messageId: "NO_CHILDREN_IN_VOID_DOM_ELEMENTS",
            node
          });
        }
      },
      JSXElement(node) {
        const openingElementNameExpression = node.openingElement.name;
        if ("name" in openingElementNameExpression) {
          const elementName = openingElementNameExpression.name;
          if (typeof elementName !== "string" || !voidElements.has(elementName)) return;
          if (node.children.length > 0) {
            context.report({
              data: {
                element: elementName
              },
              messageId: "NO_CHILDREN_IN_VOID_DOM_ELEMENTS",
              node
            });
          }
          const { attributes } = node.openingElement;
          const initialScope = context.sourceCode.getScope(node);
          const findAttr = findPropInAttributes2(attributes, context, initialScope);
          const hasChildrenOrDangerAttr = Option_exports72.isSome(findAttr("children")) || Option_exports72.isSome(findAttr("dangerouslySetInnerHTML"));
          if (hasChildrenOrDangerAttr) {
            context.report({
              data: {
                element: elementName
              },
              messageId: "NO_CHILDREN_IN_VOID_DOM_ELEMENTS",
              node
            });
          }
        }
      }
    };
  },
  defaultOptions: []
});
var __defProp62 = Object.defineProperty;
var __export62 = (target, all342) => {
  for (var name22 in all342)
    __defProp62(target, name22, { get: all342[name22], enumerable: true });
};
var Function_exports82 = {};
__export62(Function_exports82, {
  SK: () => SK82,
  absurd: () => absurd82,
  apply: () => apply82,
  compose: () => compose122,
  constFalse: () => constFalse82,
  constNull: () => constNull82,
  constTrue: () => constTrue82,
  constUndefined: () => constUndefined82,
  constVoid: () => constVoid82,
  constant: () => constant82,
  dual: () => dual82,
  flip: () => flip82,
  flow: () => flow82,
  hole: () => hole82,
  identity: () => identity82,
  isFunction: () => isFunction122,
  pipe: () => pipe82,
  satisfies: () => satisfies82,
  tupled: () => tupled82,
  unsafeCoerce: () => unsafeCoerce82,
  untupled: () => untupled82
});
var isFunction122 = (input) => typeof input === "function";
var dual82 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a232, b232) {
        if (arguments.length >= 2) {
          return body(a232, b232);
        }
        return function(self2) {
          return body(self2, a232);
        };
      };
    case 3:
      return function(a232, b232, c232) {
        if (arguments.length >= 3) {
          return body(a232, b232, c232);
        }
        return function(self2) {
          return body(self2, a232, b232);
        };
      };
    case 4:
      return function(a232, b232, c232, d232) {
        if (arguments.length >= 4) {
          return body(a232, b232, c232, d232);
        }
        return function(self2) {
          return body(self2, a232, b232, c232);
        };
      };
    case 5:
      return function(a232, b232, c232, d232, e232) {
        if (arguments.length >= 5) {
          return body(a232, b232, c232, d232, e232);
        }
        return function(self2) {
          return body(self2, a232, b232, c232, d232);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply82 = (a232) => (self2) => self2(a232);
var identity82 = (a232) => a232;
var satisfies82 = () => (b232) => b232;
var unsafeCoerce82 = identity82;
var constant82 = (value) => () => value;
var constTrue82 = /* @__PURE__ */ constant82(true);
var constFalse82 = /* @__PURE__ */ constant82(false);
var constNull82 = /* @__PURE__ */ constant82(null);
var constUndefined82 = /* @__PURE__ */ constant82(void 0);
var constVoid82 = constUndefined82;
var flip82 = (f232) => (...b232) => (...a232) => f232(...a232)(...b232);
var compose122 = /* @__PURE__ */ dual82(2, (ab, bc) => (a232) => bc(ab(a232)));
var absurd82 = (_232) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled82 = (f232) => (a232) => f232(...a232);
var untupled82 = (f232) => (...a232) => f232(a232);
function pipe82(a232, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a232;
    case 2:
      return ab(a232);
    case 3:
      return bc(ab(a232));
    case 4:
      return cd(bc(ab(a232)));
    case 5:
      return de(cd(bc(ab(a232))));
    case 6:
      return ef(de(cd(bc(ab(a232)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a232))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a232)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a232))))))));
    default: {
      let ret = arguments[0];
      for (let i232 = 1; i232 < arguments.length; i232++) {
        ret = arguments[i232](ret);
      }
      return ret;
    }
  }
}
function flow82(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole82 = /* @__PURE__ */ unsafeCoerce82(absurd82);
var SK82 = (_232, b232) => b232;
var make202 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_132 = (map332) => dual82(3, (self2, name22, f232) => map332(self2, (a232) => Object.assign({}, a232, {
  [name22]: f232(a232)
})));
var bindTo132 = (map332) => dual82(2, (self2, name22) => map332(self2, (a232) => ({
  [name22]: a232
})));
var bind132 = (map332, flatMap332) => dual82(3, (self2, name22, f232) => flatMap332(self2, (a232) => map332(f232(a232), (b232) => Object.assign({}, a232, {
  [name22]: b232
}))));
var moduleVersion82 = "3.2.8";
var getCurrentVersion82 = () => moduleVersion82;
var globalStoreId82 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion82()}`);
if (!(globalStoreId82 in globalThis)) {
  globalThis[globalStoreId82] = /* @__PURE__ */ new Map();
}
var globalStore82 = globalThis[globalStoreId82];
var globalValue82 = (id, compute) => {
  if (!globalStore82.has(id)) {
    globalStore82.set(id, compute());
  }
  return globalStore82.get(id);
};
var isFunction252 = isFunction122;
var isRecordOrArray82 = (input) => typeof input === "object" && input !== null;
var isObject82 = (input) => isRecordOrArray82(input) || isFunction252(input);
var hasProperty82 = /* @__PURE__ */ dual82(2, (self2, property) => isObject82(self2) && property in self2);
var isNullable82 = (input) => input === null || input === void 0;
var getBugErrorMessage82 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId82 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind82 = (u232) => isObject82(u232) && GenKindTypeId82 in u232;
var GenKindImpl82 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity82;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId82] = GenKindTypeId82;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen92(this);
  }
};
var SingleShotGen92 = class _SingleShotGen352 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a232) {
    return this.called ? {
      value: a232,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a232) {
    return {
      value: a232,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e232) {
    throw e232;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen352(this.self);
  }
};
var adapter122 = () => function() {
  let x232 = arguments[0];
  for (let i232 = 1; i232 < arguments.length; i232++) {
    x232 = arguments[i232](x232);
  }
  return new GenKindImpl82(x232);
};
var defaultIncHi82 = 335903614;
var defaultIncLo82 = 4150755663;
var MUL_HI82 = 1481765933 >>> 0;
var MUL_LO82 = 1284865837 >>> 0;
var BIT_5382 = 9007199254740992;
var BIT_2782 = 134217728;
var PCGRandom82 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable82(seedLo) && isNullable82(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable82(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable82(incLo) && isNullable82(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo82;
      incHi = this._state ? this._state[2] : defaultIncHi82;
    } else if (isNullable82(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add6482(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max42) {
    if (!max42) {
      return this._next();
    }
    max42 = max42 >>> 0;
    if ((max42 & max42 - 1) === 0) {
      return this._next() & max42 - 1;
    }
    let num = 0;
    const skew = (-max42 >>> 0) % max42 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max42;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_2782 + lo) / BIT_5382;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul6482(this._state, oldHi, oldLo, MUL_HI82, MUL_LO82);
    add6482(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul6482(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add6482(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId82 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap82 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId82]() {
    return this.#value;
  }
};
function yieldWrapGet82(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId82 in self2) {
    return self2[YieldWrapTypeId82]();
  }
  throw new Error(getBugErrorMessage82("yieldWrapGet"));
}
var structuralRegionState82 = /* @__PURE__ */ globalValue82("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache82 = /* @__PURE__ */ globalValue82(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr82 = /* @__PURE__ */ globalValue82(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom82());
var symbol122 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash82 = (self2) => {
  if (structuralRegionState82.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number92(self2);
    case "bigint":
      return string10(self2.toString(10));
    case "boolean":
      return string10(String(self2));
    case "symbol":
      return string10(String(self2));
    case "string":
      return string10(self2);
    case "undefined":
      return string10("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string10("null");
      } else if (self2 instanceof Date) {
        return hash82(self2.toISOString());
      } else if (isHash82(self2)) {
        return self2[symbol122]();
      } else {
        return random82(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random82 = (self2) => {
  if (!randomHashCache82.has(self2)) {
    randomHashCache82.set(self2, number92(pcgr82.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache82.get(self2);
};
var combine92 = (b232) => (self2) => self2 * 53 ^ b232;
var optimize82 = (n232) => n232 & 3221225471 | n232 >>> 1 & 1073741824;
var isHash82 = (u232) => hasProperty82(u232, symbol122);
var number92 = (n232) => {
  if (n232 !== n232 || n232 === Infinity) {
    return 0;
  }
  let h232 = n232 | 0;
  if (h232 !== n232) {
    h232 ^= n232 * 4294967295;
  }
  while (n232 > 4294967295) {
    h232 ^= n232 /= 4294967295;
  }
  return optimize82(n232);
};
var string10 = (str) => {
  let h232 = 5381, i232 = str.length;
  while (i232) {
    h232 = h232 * 33 ^ str.charCodeAt(--i232);
  }
  return optimize82(h232);
};
var cached82 = function() {
  if (arguments.length === 1) {
    const self3 = arguments[0];
    return function(hash422) {
      Object.defineProperty(self3, symbol122, {
        value() {
          return hash422;
        },
        enumerable: false
      });
      return hash422;
    };
  }
  const self2 = arguments[0];
  const hash332 = arguments[1];
  Object.defineProperty(self2, symbol122, {
    value() {
      return hash332;
    },
    enumerable: false
  });
  return hash332;
};
var symbol252 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals82() {
  if (arguments.length === 1) {
    return (self2) => compareBoth82(self2, arguments[0]);
  }
  return compareBoth82(arguments[0], arguments[1]);
}
function compareBoth82(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual82(self2) && isEqual82(that)) {
        if (hash82(self2) === hash82(that) && self2[symbol252](that)) {
          return true;
        } else {
          return structuralRegionState82.enabled && structuralRegionState82.tester ? structuralRegionState82.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState82.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v232, i232) => compareBoth82(v232, that[i232]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth82(self2[key], that[key]))) {
              return structuralRegionState82.tester ? structuralRegionState82.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState82.tester ? structuralRegionState82.tester(self2, that) : false;
    }
  }
  return structuralRegionState82.enabled && structuralRegionState82.tester ? structuralRegionState82.tester(self2, that) : false;
}
var isEqual82 = (u232) => hasProperty82(u232, symbol252);
var equivalence82 = () => equals82;
var NodeInspectSymbol82 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON82 = (x232) => {
  if (hasProperty82(x232, "toJSON") && isFunction252(x232["toJSON"]) && x232["toJSON"].length === 0) {
    return x232.toJSON();
  } else if (Array.isArray(x232)) {
    return x232.map(toJSON82);
  }
  return x232;
};
var format82 = (x232) => JSON.stringify(x232, null, 2);
var pipeArguments82 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i232 = 0, len = args.length; i232 < len; i232++) {
        ret = args[i232](ret);
      }
      return ret;
    }
  }
};
var EffectTypeId92 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId82 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId82 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId82 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance82 = {
  /* c8 ignore next */
  _R: (_232) => _232,
  /* c8 ignore next */
  _E: (_232) => _232,
  /* c8 ignore next */
  _A: (_232) => _232,
  _V: /* @__PURE__ */ getCurrentVersion82()
};
var sinkVariance82 = {
  /* c8 ignore next */
  _A: (_232) => _232,
  /* c8 ignore next */
  _In: (_232) => _232,
  /* c8 ignore next */
  _L: (_232) => _232,
  /* c8 ignore next */
  _E: (_232) => _232,
  /* c8 ignore next */
  _R: (_232) => _232
};
var channelVariance82 = {
  /* c8 ignore next */
  _Env: (_232) => _232,
  /* c8 ignore next */
  _InErr: (_232) => _232,
  /* c8 ignore next */
  _InElem: (_232) => _232,
  /* c8 ignore next */
  _InDone: (_232) => _232,
  /* c8 ignore next */
  _OutErr: (_232) => _232,
  /* c8 ignore next */
  _OutElem: (_232) => _232,
  /* c8 ignore next */
  _OutDone: (_232) => _232
};
var EffectPrototype82 = {
  [EffectTypeId92]: effectVariance82,
  [StreamTypeId82]: effectVariance82,
  [SinkTypeId82]: sinkVariance82,
  [ChannelTypeId82]: channelVariance82,
  [symbol252](that) {
    return this === that;
  },
  [symbol122]() {
    return cached82(this, random82(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen92(new YieldWrap82(this));
  },
  pipe() {
    return pipeArguments82(this, arguments);
  }
};
var TypeId202 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto122 = {
  ...EffectPrototype82,
  [TypeId202]: {
    _A: (_232) => _232
  },
  [NodeInspectSymbol82]() {
    return this.toJSON();
  },
  toString() {
    return format82(this.toJSON());
  }
};
var SomeProto82 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto122), {
  _tag: "Some",
  _op: "Some",
  [symbol252](that) {
    return isOption122(that) && isSome122(that) && equals82(this.value, that.value);
  },
  [symbol122]() {
    return cached82(this, combine92(hash82(this._tag))(hash82(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON82(this.value)
    };
  }
});
var NoneHash82 = /* @__PURE__ */ hash82("None");
var NoneProto82 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto122), {
  _tag: "None",
  _op: "None",
  [symbol252](that) {
    return isOption122(that) && isNone122(that);
  },
  [symbol122]() {
    return NoneHash82;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption122 = (input) => hasProperty82(input, TypeId202);
var isNone122 = (fa) => fa._tag === "None";
var isSome122 = (fa) => fa._tag === "Some";
var none122 = /* @__PURE__ */ Object.create(NoneProto82);
var some172 = (value) => {
  const a232 = Object.create(SomeProto82);
  a232.value = value;
  return a232;
};
var TypeId252 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto252 = {
  ...EffectPrototype82,
  [TypeId252]: {
    _R: (_232) => _232
  },
  [NodeInspectSymbol82]() {
    return this.toJSON();
  },
  toString() {
    return format82(this.toJSON());
  }
};
var RightProto82 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto252), {
  _tag: "Right",
  _op: "Right",
  [symbol252](that) {
    return isEither82(that) && isRight92(that) && equals82(this.right, that.right);
  },
  [symbol122]() {
    return combine92(hash82(this._tag))(hash82(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON82(this.right)
    };
  }
});
var LeftProto82 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto252), {
  _tag: "Left",
  _op: "Left",
  [symbol252](that) {
    return isEither82(that) && isLeft92(that) && equals82(this.left, that.left);
  },
  [symbol122]() {
    return combine92(hash82(this._tag))(hash82(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON82(this.left)
    };
  }
});
var isEither82 = (input) => hasProperty82(input, TypeId252);
var isLeft92 = (ma) => ma._tag === "Left";
var isRight92 = (ma) => ma._tag === "Right";
var left92 = (left342) => {
  const a232 = Object.create(LeftProto82);
  a232.left = left342;
  return a232;
};
var right92 = (right342) => {
  const a232 = Object.create(RightProto82);
  a232.right = right342;
  return a232;
};
var getLeft122 = (self2) => isRight92(self2) ? none122 : some172(self2.left);
var getRight122 = (self2) => isLeft92(self2) ? none122 : some172(self2.right);
var Option_exports82 = {};
__export62(Option_exports82, {
  Do: () => Do92,
  TypeId: () => TypeId352,
  all: () => all122,
  andThen: () => andThen82,
  ap: () => ap82,
  as: () => as82,
  asVoid: () => asVoid82,
  bind: () => bind252,
  bindTo: () => bindTo252,
  composeK: () => composeK82,
  contains: () => contains92,
  containsWith: () => containsWith92,
  exists: () => exists82,
  filter: () => filter92,
  filterMap: () => filterMap92,
  firstSomeOf: () => firstSomeOf82,
  flatMap: () => flatMap92,
  flatMapNullable: () => flatMapNullable92,
  flatten: () => flatten92,
  fromIterable: () => fromIterable112,
  fromNullable: () => fromNullable92,
  gen: () => gen82,
  getEquivalence: () => getEquivalence102,
  getLeft: () => getLeft252,
  getOrElse: () => getOrElse82,
  getOrNull: () => getOrNull82,
  getOrThrow: () => getOrThrow82,
  getOrThrowWith: () => getOrThrowWith82,
  getOrUndefined: () => getOrUndefined82,
  getOrder: () => getOrder92,
  getRight: () => getRight252,
  isNone: () => isNone252,
  isOption: () => isOption252,
  isSome: () => isSome252,
  let: () => let_252,
  lift2: () => lift282,
  liftNullable: () => liftNullable92,
  liftPredicate: () => liftPredicate92,
  liftThrowable: () => liftThrowable82,
  map: () => map92,
  match: () => match82,
  none: () => none252,
  orElse: () => orElse82,
  orElseEither: () => orElseEither82,
  orElseSome: () => orElseSome82,
  partitionMap: () => partitionMap92,
  product: () => product122,
  productMany: () => productMany122,
  reduceCompact: () => reduceCompact82,
  some: () => some252,
  tap: () => tap82,
  toArray: () => toArray82,
  toRefinement: () => toRefinement82,
  void: () => void_82,
  zipLeft: () => zipLeft82,
  zipRight: () => zipRight82,
  zipWith: () => zipWith92
});
var make252 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId352 = /* @__PURE__ */ Symbol.for("effect/Option");
var none252 = () => none122;
var some252 = some172;
var isOption252 = isOption122;
var isNone252 = isNone122;
var isSome252 = isSome122;
var match82 = /* @__PURE__ */ dual82(2, (self2, {
  onNone,
  onSome
}) => isNone252(self2) ? onNone() : onSome(self2.value));
var toRefinement82 = (f232) => (a232) => isSome252(f232(a232));
var fromIterable112 = (collection) => {
  for (const a232 of collection) {
    return some252(a232);
  }
  return none252();
};
var getRight252 = getRight122;
var getLeft252 = getLeft122;
var getOrElse82 = /* @__PURE__ */ dual82(2, (self2, onNone) => isNone252(self2) ? onNone() : self2.value);
var orElse82 = /* @__PURE__ */ dual82(2, (self2, that) => isNone252(self2) ? that() : self2);
var orElseSome82 = /* @__PURE__ */ dual82(2, (self2, onNone) => isNone252(self2) ? some252(onNone()) : self2);
var orElseEither82 = /* @__PURE__ */ dual82(2, (self2, that) => isNone252(self2) ? map92(that(), right92) : map92(self2, left92));
var firstSomeOf82 = (collection) => {
  let out = none252();
  for (out of collection) {
    if (isSome252(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable92 = (nullableValue) => nullableValue == null ? none252() : some252(nullableValue);
var liftNullable92 = (f232) => (...a232) => fromNullable92(f232(...a232));
var getOrNull82 = /* @__PURE__ */ getOrElse82(constNull82);
var getOrUndefined82 = /* @__PURE__ */ getOrElse82(constUndefined82);
var liftThrowable82 = (f232) => (...a232) => {
  try {
    return some252(f232(...a232));
  } catch (e232) {
    return none252();
  }
};
var getOrThrowWith82 = /* @__PURE__ */ dual82(2, (self2, onNone) => {
  if (isSome252(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow82 = /* @__PURE__ */ getOrThrowWith82(() => new Error("getOrThrow called on a None"));
var map92 = /* @__PURE__ */ dual82(2, (self2, f232) => isNone252(self2) ? none252() : some252(f232(self2.value)));
var as82 = /* @__PURE__ */ dual82(2, (self2, b232) => map92(self2, () => b232));
var asVoid82 = /* @__PURE__ */ as82(void 0);
var void_82 = /* @__PURE__ */ some252(void 0);
var flatMap92 = /* @__PURE__ */ dual82(2, (self2, f232) => isNone252(self2) ? none252() : f232(self2.value));
var andThen82 = /* @__PURE__ */ dual82(2, (self2, f232) => flatMap92(self2, (a232) => {
  const b232 = isFunction122(f232) ? f232(a232) : f232;
  return isOption252(b232) ? b232 : some252(b232);
}));
var flatMapNullable92 = /* @__PURE__ */ dual82(2, (self2, f232) => isNone252(self2) ? none252() : fromNullable92(f232(self2.value)));
var flatten92 = /* @__PURE__ */ flatMap92(identity82);
var zipRight82 = /* @__PURE__ */ dual82(2, (self2, that) => flatMap92(self2, () => that));
var composeK82 = /* @__PURE__ */ dual82(2, (afb, bfc) => (a232) => flatMap92(afb(a232), bfc));
var zipLeft82 = /* @__PURE__ */ dual82(2, (self2, that) => tap82(self2, () => that));
var tap82 = /* @__PURE__ */ dual82(2, (self2, f232) => flatMap92(self2, (a232) => map92(f232(a232), () => a232)));
var product122 = (self2, that) => isSome252(self2) && isSome252(that) ? some252([self2.value, that.value]) : none252();
var productMany122 = (self2, collection) => {
  if (isNone252(self2)) {
    return none252();
  }
  const out = [self2.value];
  for (const o232 of collection) {
    if (isNone252(o232)) {
      return none252();
    }
    out.push(o232.value);
  }
  return some252(out);
};
var all122 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o232 of input) {
      if (isNone252(o232)) {
        return none252();
      }
      out2.push(o232.value);
    }
    return some252(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o232 = input[key];
    if (isNone252(o232)) {
      return none252();
    }
    out[key] = o232.value;
  }
  return some252(out);
};
var zipWith92 = /* @__PURE__ */ dual82(3, (self2, that, f232) => map92(product122(self2, that), ([a232, b232]) => f232(a232, b232)));
var ap82 = /* @__PURE__ */ dual82(2, (self2, that) => zipWith92(self2, that, (f232, a232) => f232(a232)));
var reduceCompact82 = /* @__PURE__ */ dual82(3, (self2, b232, f232) => {
  let out = b232;
  for (const oa of self2) {
    if (isSome252(oa)) {
      out = f232(out, oa.value);
    }
  }
  return out;
});
var toArray82 = (self2) => isNone252(self2) ? [] : [self2.value];
var partitionMap92 = /* @__PURE__ */ dual82(2, (self2, f232) => {
  if (isNone252(self2)) {
    return [none252(), none252()];
  }
  const e232 = f232(self2.value);
  return isLeft92(e232) ? [some252(e232.left), none252()] : [none252(), some252(e232.right)];
});
var filterMap92 = /* @__PURE__ */ dual82(2, (self2, f232) => isNone252(self2) ? none252() : f232(self2.value));
var filter92 = /* @__PURE__ */ dual82(2, (self2, predicate) => filterMap92(self2, (b232) => predicate(b232) ? some172(b232) : none122));
var getEquivalence102 = (isEquivalent) => make202((x232, y232) => x232 === y232 || (isNone252(x232) ? isNone252(y232) : isNone252(y232) ? false : isEquivalent(x232.value, y232.value)));
var getOrder92 = (O232) => make252((self2, that) => isSome252(self2) ? isSome252(that) ? O232(self2.value, that.value) : 1 : -1);
var lift282 = (f232) => dual82(2, (self2, that) => zipWith92(self2, that, f232));
var liftPredicate92 = (predicate) => (b232) => predicate(b232) ? some252(b232) : none252();
var containsWith92 = (isEquivalent) => dual82(2, (self2, a232) => isNone252(self2) ? false : isEquivalent(self2.value, a232));
var _equivalence102 = /* @__PURE__ */ equivalence82();
var contains92 = /* @__PURE__ */ containsWith92(_equivalence102);
var exists82 = /* @__PURE__ */ dual82(2, (self2, refinement) => isNone252(self2) ? false : refinement(self2.value));
var bindTo252 = /* @__PURE__ */ bindTo132(map92);
var let_252 = /* @__PURE__ */ let_132(map92);
var bind252 = /* @__PURE__ */ bind132(map92, flatMap92);
var Do92 = /* @__PURE__ */ some252({});
var adapter252 = /* @__PURE__ */ adapter122();
var gen82 = (f232) => {
  const iterator = f232(adapter252);
  let state = iterator.next();
  if (state.done) {
    return some252(state.value);
  } else {
    let current = state.value;
    if (isGenKind82(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet82(current);
    }
    if (isNone252(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind82(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet82(current);
        }
        if (isNone252(current)) {
          return current;
        }
      }
    }
    return some252(state.value);
  }
};
var MutableRef_exports52 = {};
__export62(MutableRef_exports52, {
  compareAndSet: () => compareAndSet52,
  decrement: () => decrement52,
  decrementAndGet: () => decrementAndGet52,
  get: () => get62,
  getAndDecrement: () => getAndDecrement52,
  getAndIncrement: () => getAndIncrement52,
  getAndSet: () => getAndSet52,
  getAndUpdate: () => getAndUpdate52,
  increment: () => increment52,
  incrementAndGet: () => incrementAndGet52,
  make: () => make352,
  set: () => set62,
  setAndGet: () => setAndGet52,
  toggle: () => toggle52,
  update: () => update52,
  updateAndGet: () => updateAndGet52
});
var TypeId452 = /* @__PURE__ */ Symbol.for("effect/MutableRef");
var MutableRefProto52 = {
  [TypeId452]: TypeId452,
  toString() {
    return format82(this.toJSON());
  },
  toJSON() {
    return {
      _id: "MutableRef",
      current: toJSON82(this.current)
    };
  },
  [NodeInspectSymbol82]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments82(this, arguments);
  }
};
var make352 = (value) => {
  const ref = Object.create(MutableRefProto52);
  ref.current = value;
  return ref;
};
var compareAndSet52 = /* @__PURE__ */ dual82(3, (self2, oldValue, newValue) => {
  if (equals82(oldValue, self2.current)) {
    self2.current = newValue;
    return true;
  }
  return false;
});
var decrement52 = (self2) => update52(self2, (n232) => n232 - 1);
var decrementAndGet52 = (self2) => updateAndGet52(self2, (n232) => n232 - 1);
var get62 = (self2) => self2.current;
var getAndDecrement52 = (self2) => getAndUpdate52(self2, (n232) => n232 - 1);
var getAndIncrement52 = (self2) => getAndUpdate52(self2, (n232) => n232 + 1);
var getAndSet52 = /* @__PURE__ */ dual82(2, (self2, value) => {
  const ret = self2.current;
  self2.current = value;
  return ret;
});
var getAndUpdate52 = /* @__PURE__ */ dual82(2, (self2, f232) => getAndSet52(self2, f232(get62(self2))));
var increment52 = (self2) => update52(self2, (n232) => n232 + 1);
var incrementAndGet52 = (self2) => updateAndGet52(self2, (n232) => n232 + 1);
var set62 = /* @__PURE__ */ dual82(2, (self2, value) => {
  self2.current = value;
  return self2;
});
var setAndGet52 = /* @__PURE__ */ dual82(2, (self2, value) => {
  self2.current = value;
  return self2.current;
});
var update52 = /* @__PURE__ */ dual82(2, (self2, f232) => set62(self2, f232(get62(self2))));
var updateAndGet52 = /* @__PURE__ */ dual82(2, (self2, f232) => setAndGet52(self2, f232(get62(self2))));
var toggle52 = (self2) => update52(self2, (_232) => !_232);
function getVariables42(initialScope) {
  const scopeRef = MutableRef_exports52.make(initialScope);
  const variablesRef = MutableRef_exports52.make(MutableRef_exports52.get(scopeRef).variables);
  while (MutableRef_exports52.get(scopeRef).type !== scopeManager.ScopeType.global) {
    MutableRef_exports52.set(scopeRef, MutableRef_exports52.get(scopeRef).upper);
    MutableRef_exports52.update(variablesRef, (variables) => variables.concat(MutableRef_exports52.get(scopeRef).variables));
  }
  return MutableRef_exports52.get(variablesRef).reverse();
}
var findVariable52 = Function_exports82.dual(2, (name22, initialScope) => {
  return Option_exports82.fromNullable(getVariables42(initialScope).find((variable) => variable.name === name22));
});
var t42 = Symbol.for("@ts-pattern/matcher");
var e42 = Symbol.for("@ts-pattern/isVariadic");
var n42 = "@ts-pattern/anonymous-select-key";
var r42 = (t232) => Boolean(t232 && "object" == typeof t232);
var i42 = (e232) => e232 && !!e232[t42];
var o42 = (n232, s232, c232) => {
  if (i42(n232)) {
    const e232 = n232[t42](), { matched: r232, selections: i232 } = e232.match(s232);
    return r232 && i232 && Object.keys(i232).forEach((t232) => c232(t232, i232[t232])), r232;
  }
  if (r42(n232)) {
    if (!r42(s232)) return false;
    if (Array.isArray(n232)) {
      if (!Array.isArray(s232)) return false;
      let t232 = [], r232 = [], a232 = [];
      for (const o232 of n232.keys()) {
        const s322 = n232[o232];
        i42(s322) && s322[e42] ? a232.push(s322) : a232.length ? r232.push(s322) : t232.push(s322);
      }
      if (a232.length) {
        if (a232.length > 1) throw new Error("Pattern error: Using `...P.array(...)` several times in a single pattern is not allowed.");
        if (s232.length < t232.length + r232.length) return false;
        const e232 = s232.slice(0, t232.length), n322 = 0 === r232.length ? [] : s232.slice(-r232.length), i232 = s232.slice(t232.length, 0 === r232.length ? Infinity : -r232.length);
        return t232.every((t322, n422) => o42(t322, e232[n422], c232)) && r232.every((t322, e322) => o42(t322, n322[e322], c232)) && (0 === a232.length || o42(a232[0], i232, c232));
      }
      return n232.length === s232.length && n232.every((t322, e232) => o42(t322, s232[e232], c232));
    }
    return Object.keys(n232).every((e232) => {
      const r232 = n232[e232];
      return (e232 in s232 || i42(a232 = r232) && "optional" === a232[t42]().matcherType) && o42(r232, s232[e232], c232);
      var a232;
    });
  }
  return Object.is(s232, n232);
};
var s42 = (e232) => {
  var n232, o232, a232;
  return r42(e232) ? i42(e232) ? null != (n232 = null == (o232 = (a232 = e232[t42]()).getSelectionKeys) ? void 0 : o232.call(a232)) ? n232 : [] : Array.isArray(e232) ? c42(e232, s42) : c42(Object.values(e232), s42) : [];
};
var c42 = (t232, e232) => t232.reduce((t322, n232) => t322.concat(e232(n232)), []);
function a42(...t232) {
  if (1 === t232.length) {
    const [e232] = t232;
    return (t322) => o42(e232, t322, () => {
    });
  }
  if (2 === t232.length) {
    const [e232, n232] = t232;
    return o42(e232, n232, () => {
    });
  }
  throw new Error(`isMatching wasn't given the right number of arguments: expected 1 or 2, received ${t232.length}.`);
}
function u42(t232) {
  return Object.assign(t232, { optional: () => l42(t232), and: (e232) => m42(t232, e232), or: (e232) => d42(t232, e232), select: (e232) => void 0 === e232 ? p42(t232) : p42(e232, t232) });
}
function h42(t232) {
  return Object.assign(((t322) => Object.assign(t322, { [Symbol.iterator]() {
    let n232 = 0;
    const r232 = [{ value: Object.assign(t322, { [e42]: true }), done: false }, { done: true, value: void 0 }];
    return { next: () => {
      var t422;
      return null != (t422 = r232[n232++]) ? t422 : r232.at(-1);
    } };
  } }))(t232), { optional: () => h42(l42(t232)), select: (e232) => h42(void 0 === e232 ? p42(t232) : p42(e232, t232)) });
}
function l42(e232) {
  return u42({ [t42]: () => ({ match: (t232) => {
    let n232 = {};
    const r232 = (t322, e322) => {
      n232[t322] = e322;
    };
    return void 0 === t232 ? (s42(e232).forEach((t322) => r232(t322, void 0)), { matched: true, selections: n232 }) : { matched: o42(e232, t232, r232), selections: n232 };
  }, getSelectionKeys: () => s42(e232), matcherType: "optional" }) });
}
var f42 = (t232, e232) => {
  for (const n232 of t232) if (!e232(n232)) return false;
  return true;
};
var g42 = (t232, e232) => {
  for (const [n232, r232] of t232.entries()) if (!e232(r232, n232)) return false;
  return true;
};
function m42(...e232) {
  return u42({ [t42]: () => ({ match: (t232) => {
    let n232 = {};
    const r232 = (t322, e322) => {
      n232[t322] = e322;
    };
    return { matched: e232.every((e322) => o42(e322, t232, r232)), selections: n232 };
  }, getSelectionKeys: () => c42(e232, s42), matcherType: "and" }) });
}
function d42(...e232) {
  return u42({ [t42]: () => ({ match: (t232) => {
    let n232 = {};
    const r232 = (t322, e322) => {
      n232[t322] = e322;
    };
    return c42(e232, s42).forEach((t322) => r232(t322, void 0)), { matched: e232.some((e322) => o42(e322, t232, r232)), selections: n232 };
  }, getSelectionKeys: () => c42(e232, s42), matcherType: "or" }) });
}
function y42(e232) {
  return { [t42]: () => ({ match: (t232) => ({ matched: Boolean(e232(t232)) }) }) };
}
function p42(...e232) {
  const r232 = "string" == typeof e232[0] ? e232[0] : void 0, i232 = 2 === e232.length ? e232[1] : "string" == typeof e232[0] ? void 0 : e232[0];
  return u42({ [t42]: () => ({ match: (t232) => {
    let e322 = { [null != r232 ? r232 : n42]: t232 };
    return { matched: void 0 === i232 || o42(i232, t232, (t322, n232) => {
      e322[t322] = n232;
    }), selections: e322 };
  }, getSelectionKeys: () => [null != r232 ? r232 : n42].concat(void 0 === i232 ? [] : s42(i232)) }) });
}
function v42(t232) {
  return "number" == typeof t232;
}
function b42(t232) {
  return "string" == typeof t232;
}
function w42(t232) {
  return "bigint" == typeof t232;
}
var S42 = u42(y42(function(t232) {
  return true;
}));
var O42 = S42;
var j42 = (t232) => Object.assign(u42(t232), { startsWith: (e232) => {
  return j42(m42(t232, (n232 = e232, y42((t322) => b42(t322) && t322.startsWith(n232)))));
  var n232;
}, endsWith: (e232) => {
  return j42(m42(t232, (n232 = e232, y42((t322) => b42(t322) && t322.endsWith(n232)))));
  var n232;
}, minLength: (e232) => j42(m42(t232, ((t322) => y42((e322) => b42(e322) && e322.length >= t322))(e232))), maxLength: (e232) => j42(m42(t232, ((t322) => y42((e322) => b42(e322) && e322.length <= t322))(e232))), includes: (e232) => {
  return j42(m42(t232, (n232 = e232, y42((t322) => b42(t322) && t322.includes(n232)))));
  var n232;
}, regex: (e232) => {
  return j42(m42(t232, (n232 = e232, y42((t322) => b42(t322) && Boolean(t322.match(n232))))));
  var n232;
} });
var E42 = j42(y42(b42));
var K42 = (t232) => Object.assign(u42(t232), { between: (e232, n232) => K42(m42(t232, ((t322, e322) => y42((n322) => v42(n322) && t322 <= n322 && e322 >= n322))(e232, n232))), lt: (e232) => K42(m42(t232, ((t322) => y42((e322) => v42(e322) && e322 < t322))(e232))), gt: (e232) => K42(m42(t232, ((t322) => y42((e322) => v42(e322) && e322 > t322))(e232))), lte: (e232) => K42(m42(t232, ((t322) => y42((e322) => v42(e322) && e322 <= t322))(e232))), gte: (e232) => K42(m42(t232, ((t322) => y42((e322) => v42(e322) && e322 >= t322))(e232))), int: () => K42(m42(t232, y42((t322) => v42(t322) && Number.isInteger(t322)))), finite: () => K42(m42(t232, y42((t322) => v42(t322) && Number.isFinite(t322)))), positive: () => K42(m42(t232, y42((t322) => v42(t322) && t322 > 0))), negative: () => K42(m42(t232, y42((t322) => v42(t322) && t322 < 0))) });
var x42 = K42(y42(v42));
var A42 = (t232) => Object.assign(u42(t232), { between: (e232, n232) => A42(m42(t232, ((t322, e322) => y42((n322) => w42(n322) && t322 <= n322 && e322 >= n322))(e232, n232))), lt: (e232) => A42(m42(t232, ((t322) => y42((e322) => w42(e322) && e322 < t322))(e232))), gt: (e232) => A42(m42(t232, ((t322) => y42((e322) => w42(e322) && e322 > t322))(e232))), lte: (e232) => A42(m42(t232, ((t322) => y42((e322) => w42(e322) && e322 <= t322))(e232))), gte: (e232) => A42(m42(t232, ((t322) => y42((e322) => w42(e322) && e322 >= t322))(e232))), positive: () => A42(m42(t232, y42((t322) => w42(t322) && t322 > 0))), negative: () => A42(m42(t232, y42((t322) => w42(t322) && t322 < 0))) });
var P42 = A42(y42(w42));
var T42 = u42(y42(function(t232) {
  return "boolean" == typeof t232;
}));
var k42 = u42(y42(function(t232) {
  return "symbol" == typeof t232;
}));
var B42 = u42(y42(function(t232) {
  return null == t232;
}));
var _42 = u42(y42(function(t232) {
  return null != t232;
}));
var N42 = { __proto__: null, matcher: t42, optional: l42, array: function(...e232) {
  return h42({ [t42]: () => ({ match: (t232) => {
    if (!Array.isArray(t232)) return { matched: false };
    if (0 === e232.length) return { matched: true };
    const n232 = e232[0];
    let r232 = {};
    if (0 === t232.length) return s42(n232).forEach((t322) => {
      r232[t322] = [];
    }), { matched: true, selections: r232 };
    const i232 = (t322, e322) => {
      r232[t322] = (r232[t322] || []).concat([e322]);
    };
    return { matched: t232.every((t322) => o42(n232, t322, i232)), selections: r232 };
  }, getSelectionKeys: () => 0 === e232.length ? [] : s42(e232[0]) }) });
}, set: function(...e232) {
  return u42({ [t42]: () => ({ match: (t232) => {
    if (!(t232 instanceof Set)) return { matched: false };
    let n232 = {};
    if (0 === t232.size) return { matched: true, selections: n232 };
    if (0 === e232.length) return { matched: true };
    const r232 = (t322, e322) => {
      n232[t322] = (n232[t322] || []).concat([e322]);
    }, i232 = e232[0];
    return { matched: f42(t232, (t322) => o42(i232, t322, r232)), selections: n232 };
  }, getSelectionKeys: () => 0 === e232.length ? [] : s42(e232[0]) }) });
}, map: function(...e232) {
  return u42({ [t42]: () => ({ match: (t232) => {
    if (!(t232 instanceof Map)) return { matched: false };
    let n232 = {};
    if (0 === t232.size) return { matched: true, selections: n232 };
    const r232 = (t322, e322) => {
      n232[t322] = (n232[t322] || []).concat([e322]);
    };
    if (0 === e232.length) return { matched: true };
    var i232;
    if (1 === e232.length) throw new Error(`\`P.map\` wasn't given enough arguments. Expected (key, value), received ${null == (i232 = e232[0]) ? void 0 : i232.toString()}`);
    const [s232, c232] = e232;
    return { matched: g42(t232, (t322, e322) => {
      const n322 = o42(s232, e322, r232), i322 = o42(c232, t322, r232);
      return n322 && i322;
    }), selections: n232 };
  }, getSelectionKeys: () => 0 === e232.length ? [] : [...s42(e232[0]), ...s42(e232[1])] }) });
}, intersection: m42, union: d42, not: function(e232) {
  return u42({ [t42]: () => ({ match: (t232) => ({ matched: !o42(e232, t232, () => {
  }) }), getSelectionKeys: () => [], matcherType: "not" }) });
}, when: y42, select: p42, any: S42, _: O42, string: E42, number: x42, bigint: P42, boolean: T42, symbol: k42, nullish: B42, nonNullable: _42, instanceOf: function(t232) {
  return u42(y42(/* @__PURE__ */ function(t322) {
    return (e232) => e232 instanceof t322;
  }(t232)));
}, shape: function(t232) {
  return u42(y42(a42(t232)));
} };
var KEYS52 = {
  ArrayExpression: [
    "elements"
  ],
  ArrayPattern: [
    "elements"
  ],
  ArrowFunctionExpression: [
    "params",
    "body"
  ],
  AssignmentExpression: [
    "left",
    "right"
  ],
  AssignmentPattern: [
    "left",
    "right"
  ],
  AwaitExpression: [
    "argument"
  ],
  BinaryExpression: [
    "left",
    "right"
  ],
  BlockStatement: [
    "body"
  ],
  BreakStatement: [
    "label"
  ],
  CallExpression: [
    "callee",
    "arguments"
  ],
  CatchClause: [
    "param",
    "body"
  ],
  ChainExpression: [
    "expression"
  ],
  ClassBody: [
    "body"
  ],
  ClassDeclaration: [
    "id",
    "superClass",
    "body"
  ],
  ClassExpression: [
    "id",
    "superClass",
    "body"
  ],
  ConditionalExpression: [
    "test",
    "consequent",
    "alternate"
  ],
  ContinueStatement: [
    "label"
  ],
  DebuggerStatement: [],
  DoWhileStatement: [
    "body",
    "test"
  ],
  EmptyStatement: [],
  ExperimentalRestProperty: [
    "argument"
  ],
  ExperimentalSpreadProperty: [
    "argument"
  ],
  ExportAllDeclaration: [
    "exported",
    "source"
  ],
  ExportDefaultDeclaration: [
    "declaration"
  ],
  ExportNamedDeclaration: [
    "declaration",
    "specifiers",
    "source"
  ],
  ExportSpecifier: [
    "exported",
    "local"
  ],
  ExpressionStatement: [
    "expression"
  ],
  ForInStatement: [
    "left",
    "right",
    "body"
  ],
  ForOfStatement: [
    "left",
    "right",
    "body"
  ],
  ForStatement: [
    "init",
    "test",
    "update",
    "body"
  ],
  FunctionDeclaration: [
    "id",
    "params",
    "body"
  ],
  FunctionExpression: [
    "id",
    "params",
    "body"
  ],
  Identifier: [],
  IfStatement: [
    "test",
    "consequent",
    "alternate"
  ],
  ImportDeclaration: [
    "specifiers",
    "source"
  ],
  ImportDefaultSpecifier: [
    "local"
  ],
  ImportExpression: [
    "source"
  ],
  ImportNamespaceSpecifier: [
    "local"
  ],
  ImportSpecifier: [
    "imported",
    "local"
  ],
  JSXAttribute: [
    "name",
    "value"
  ],
  JSXClosingElement: [
    "name"
  ],
  JSXClosingFragment: [],
  JSXElement: [
    "openingElement",
    "children",
    "closingElement"
  ],
  JSXEmptyExpression: [],
  JSXExpressionContainer: [
    "expression"
  ],
  JSXFragment: [
    "openingFragment",
    "children",
    "closingFragment"
  ],
  JSXIdentifier: [],
  JSXMemberExpression: [
    "object",
    "property"
  ],
  JSXNamespacedName: [
    "namespace",
    "name"
  ],
  JSXOpeningElement: [
    "name",
    "attributes"
  ],
  JSXOpeningFragment: [],
  JSXSpreadAttribute: [
    "argument"
  ],
  JSXSpreadChild: [
    "expression"
  ],
  JSXText: [],
  LabeledStatement: [
    "label",
    "body"
  ],
  Literal: [],
  LogicalExpression: [
    "left",
    "right"
  ],
  MemberExpression: [
    "object",
    "property"
  ],
  MetaProperty: [
    "meta",
    "property"
  ],
  MethodDefinition: [
    "key",
    "value"
  ],
  NewExpression: [
    "callee",
    "arguments"
  ],
  ObjectExpression: [
    "properties"
  ],
  ObjectPattern: [
    "properties"
  ],
  PrivateIdentifier: [],
  Program: [
    "body"
  ],
  Property: [
    "key",
    "value"
  ],
  PropertyDefinition: [
    "key",
    "value"
  ],
  RestElement: [
    "argument"
  ],
  ReturnStatement: [
    "argument"
  ],
  SequenceExpression: [
    "expressions"
  ],
  SpreadElement: [
    "argument"
  ],
  StaticBlock: [
    "body"
  ],
  Super: [],
  SwitchCase: [
    "test",
    "consequent"
  ],
  SwitchStatement: [
    "discriminant",
    "cases"
  ],
  TaggedTemplateExpression: [
    "tag",
    "quasi"
  ],
  TemplateElement: [],
  TemplateLiteral: [
    "quasis",
    "expressions"
  ],
  ThisExpression: [],
  ThrowStatement: [
    "argument"
  ],
  TryStatement: [
    "block",
    "handler",
    "finalizer"
  ],
  UnaryExpression: [
    "argument"
  ],
  UpdateExpression: [
    "argument"
  ],
  VariableDeclaration: [
    "declarations"
  ],
  VariableDeclarator: [
    "id",
    "init"
  ],
  WhileStatement: [
    "test",
    "body"
  ],
  WithStatement: [
    "object",
    "body"
  ],
  YieldExpression: [
    "argument"
  ]
};
var NODE_TYPES52 = Object.keys(KEYS52);
for (const type of NODE_TYPES52) {
  Object.freeze(KEYS52[type]);
}
Object.freeze(KEYS52);
var visitor_keys_default52 = KEYS52;
var KEY_BLACKLIST52 = /* @__PURE__ */ new Set([
  "parent",
  "leadingComments",
  "trailingComments"
]);
function filterKey52(key) {
  return !KEY_BLACKLIST52.has(key) && key[0] !== "_";
}
function getKeys52(node) {
  return Object.keys(node).filter(filterKey52);
}
function getInnermostScope52(initialScope, node) {
  const location = node.range[0];
  let scope = initialScope;
  let found = false;
  do {
    found = false;
    for (const childScope of scope.childScopes) {
      const range32 = childScope.block.range;
      if (range32[0] <= location && location < range32[1]) {
        scope = childScope;
        found = true;
        break;
      }
    }
  } while (found);
  return scope;
}
function findVariable252(initialScope, nameOrNode) {
  let name22 = "";
  let scope = initialScope;
  if (typeof nameOrNode === "string") {
    name22 = nameOrNode;
  } else {
    name22 = nameOrNode.name;
    scope = getInnermostScope52(scope, nameOrNode);
  }
  while (scope != null) {
    const variable = scope.set.get(name22);
    if (variable != null) {
      return variable;
    }
    scope = scope.upper;
  }
  return null;
}
function negate052(token) {
  return !this(token);
}
function negate52(f232) {
  return negate052.bind(f232);
}
function isPunctuatorTokenWithValue52(token, value) {
  return token.type === "Punctuator" && token.value === value;
}
function isArrowToken52(token) {
  return isPunctuatorTokenWithValue52(token, "=>");
}
function isCommaToken52(token) {
  return isPunctuatorTokenWithValue52(token, ",");
}
function isSemicolonToken52(token) {
  return isPunctuatorTokenWithValue52(token, ";");
}
function isColonToken52(token) {
  return isPunctuatorTokenWithValue52(token, ":");
}
function isOpeningParenToken52(token) {
  return isPunctuatorTokenWithValue52(token, "(");
}
function isClosingParenToken52(token) {
  return isPunctuatorTokenWithValue52(token, ")");
}
function isOpeningBracketToken52(token) {
  return isPunctuatorTokenWithValue52(token, "[");
}
function isClosingBracketToken52(token) {
  return isPunctuatorTokenWithValue52(token, "]");
}
function isOpeningBraceToken52(token) {
  return isPunctuatorTokenWithValue52(token, "{");
}
function isClosingBraceToken52(token) {
  return isPunctuatorTokenWithValue52(token, "}");
}
function isCommentToken52(token) {
  return ["Block", "Line", "Shebang"].includes(token.type);
}
negate52(isArrowToken52);
negate52(isCommaToken52);
negate52(isSemicolonToken52);
negate52(isColonToken52);
negate52(isOpeningParenToken52);
negate52(isClosingParenToken52);
negate52(isOpeningBracketToken52);
negate52(isClosingBracketToken52);
negate52(isOpeningBraceToken52);
negate52(isClosingBraceToken52);
negate52(isCommentToken52);
function getOpeningParenOfParams52(node, sourceCode) {
  return node.id ? sourceCode.getTokenAfter(node.id, isOpeningParenToken52) : sourceCode.getFirstToken(node, isOpeningParenToken52);
}
function getFunctionHeadLocation52(node, sourceCode) {
  const parent = node.parent;
  let start = null;
  let end = null;
  if (node.type === "ArrowFunctionExpression") {
    const arrowToken = sourceCode.getTokenBefore(node.body, isArrowToken52);
    start = arrowToken.loc.start;
    end = arrowToken.loc.end;
  } else if (parent.type === "Property" || parent.type === "MethodDefinition" || parent.type === "PropertyDefinition") {
    start = parent.loc.start;
    end = getOpeningParenOfParams52(node, sourceCode).loc.start;
  } else {
    start = node.loc.start;
    end = getOpeningParenOfParams52(node, sourceCode).loc.start;
  }
  return {
    start: { ...start },
    end: { ...end }
  };
}
var globalObject52 = typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {};
var builtinNames52 = Object.freeze(
  /* @__PURE__ */ new Set([
    "Array",
    "ArrayBuffer",
    "BigInt",
    "BigInt64Array",
    "BigUint64Array",
    "Boolean",
    "DataView",
    "Date",
    "decodeURI",
    "decodeURIComponent",
    "encodeURI",
    "encodeURIComponent",
    "escape",
    "Float32Array",
    "Float64Array",
    "Function",
    "Infinity",
    "Int16Array",
    "Int32Array",
    "Int8Array",
    "isFinite",
    "isNaN",
    "isPrototypeOf",
    "JSON",
    "Map",
    "Math",
    "NaN",
    "Number",
    "Object",
    "parseFloat",
    "parseInt",
    "Promise",
    "Proxy",
    "Reflect",
    "RegExp",
    "Set",
    "String",
    "Symbol",
    "Uint16Array",
    "Uint32Array",
    "Uint8Array",
    "Uint8ClampedArray",
    "undefined",
    "unescape",
    "WeakMap",
    "WeakSet"
  ])
);
var callAllowed52 = new Set(
  [
    Array.isArray,
    Array.of,
    Array.prototype.at,
    Array.prototype.concat,
    Array.prototype.entries,
    Array.prototype.every,
    Array.prototype.filter,
    Array.prototype.find,
    Array.prototype.findIndex,
    Array.prototype.flat,
    Array.prototype.includes,
    Array.prototype.indexOf,
    Array.prototype.join,
    Array.prototype.keys,
    Array.prototype.lastIndexOf,
    Array.prototype.slice,
    Array.prototype.some,
    Array.prototype.toString,
    Array.prototype.values,
    typeof BigInt === "function" ? BigInt : void 0,
    Boolean,
    Date,
    Date.parse,
    decodeURI,
    decodeURIComponent,
    encodeURI,
    encodeURIComponent,
    escape,
    isFinite,
    isNaN,
    isPrototypeOf,
    Map,
    Map.prototype.entries,
    Map.prototype.get,
    Map.prototype.has,
    Map.prototype.keys,
    Map.prototype.values,
    ...Object.getOwnPropertyNames(Math).filter((k232) => k232 !== "random").map((k232) => Math[k232]).filter((f232) => typeof f232 === "function"),
    Number,
    Number.isFinite,
    Number.isNaN,
    Number.parseFloat,
    Number.parseInt,
    Number.prototype.toExponential,
    Number.prototype.toFixed,
    Number.prototype.toPrecision,
    Number.prototype.toString,
    Object,
    Object.entries,
    Object.is,
    Object.isExtensible,
    Object.isFrozen,
    Object.isSealed,
    Object.keys,
    Object.values,
    parseFloat,
    parseInt,
    RegExp,
    Set,
    Set.prototype.entries,
    Set.prototype.has,
    Set.prototype.keys,
    Set.prototype.values,
    String,
    String.fromCharCode,
    String.fromCodePoint,
    String.raw,
    String.prototype.at,
    String.prototype.charAt,
    String.prototype.charCodeAt,
    String.prototype.codePointAt,
    String.prototype.concat,
    String.prototype.endsWith,
    String.prototype.includes,
    String.prototype.indexOf,
    String.prototype.lastIndexOf,
    String.prototype.normalize,
    String.prototype.padEnd,
    String.prototype.padStart,
    String.prototype.slice,
    String.prototype.startsWith,
    String.prototype.substr,
    String.prototype.substring,
    String.prototype.toLowerCase,
    String.prototype.toString,
    String.prototype.toUpperCase,
    String.prototype.trim,
    String.prototype.trimEnd,
    String.prototype.trimLeft,
    String.prototype.trimRight,
    String.prototype.trimStart,
    Symbol.for,
    Symbol.keyFor,
    unescape
  ].filter((f232) => typeof f232 === "function")
);
var callPassThrough52 = /* @__PURE__ */ new Set([
  Object.freeze,
  Object.preventExtensions,
  Object.seal
]);
var getterAllowed52 = [
  [Map, /* @__PURE__ */ new Set(["size"])],
  [
    RegExp,
    /* @__PURE__ */ new Set([
      "dotAll",
      "flags",
      "global",
      "hasIndices",
      "ignoreCase",
      "multiline",
      "source",
      "sticky",
      "unicode"
    ])
  ],
  [Set, /* @__PURE__ */ new Set(["size"])]
];
function getPropertyDescriptor52(object32, name22) {
  let x232 = object32;
  while ((typeof x232 === "object" || typeof x232 === "function") && x232 !== null) {
    const d232 = Object.getOwnPropertyDescriptor(x232, name22);
    if (d232) {
      return d232;
    }
    x232 = Object.getPrototypeOf(x232);
  }
  return null;
}
function isGetter52(object32, name22) {
  const d232 = getPropertyDescriptor52(object32, name22);
  return d232 != null && d232.get != null;
}
function getElementValues52(nodeList, initialScope) {
  const valueList = [];
  for (let i232 = 0; i232 < nodeList.length; ++i232) {
    const elementNode = nodeList[i232];
    if (elementNode == null) {
      valueList.length = i232 + 1;
    } else if (elementNode.type === "SpreadElement") {
      const argument = getStaticValueR52(elementNode.argument, initialScope);
      if (argument == null) {
        return null;
      }
      valueList.push(...argument.value);
    } else {
      const element = getStaticValueR52(elementNode, initialScope);
      if (element == null) {
        return null;
      }
      valueList.push(element.value);
    }
  }
  return valueList;
}
function isEffectivelyConst52(variable) {
  const refs = variable.references;
  const inits = refs.filter((r232) => r232.init).length;
  const reads = refs.filter((r232) => r232.isReadOnly()).length;
  if (inits === 1 && reads + inits === refs.length) {
    return true;
  }
  return false;
}
var operations52 = Object.freeze({
  ArrayExpression(node, initialScope) {
    const elements = getElementValues52(node.elements, initialScope);
    return elements != null ? { value: elements } : null;
  },
  AssignmentExpression(node, initialScope) {
    if (node.operator === "=") {
      return getStaticValueR52(node.right, initialScope);
    }
    return null;
  },
  //eslint-disable-next-line complexity
  BinaryExpression(node, initialScope) {
    if (node.operator === "in" || node.operator === "instanceof") {
      return null;
    }
    const left342 = getStaticValueR52(node.left, initialScope);
    const right342 = getStaticValueR52(node.right, initialScope);
    if (left342 != null && right342 != null) {
      switch (node.operator) {
        case "==":
          return { value: left342.value == right342.value };
        case "!=":
          return { value: left342.value != right342.value };
        case "===":
          return { value: left342.value === right342.value };
        case "!==":
          return { value: left342.value !== right342.value };
        case "<":
          return { value: left342.value < right342.value };
        case "<=":
          return { value: left342.value <= right342.value };
        case ">":
          return { value: left342.value > right342.value };
        case ">=":
          return { value: left342.value >= right342.value };
        case "<<":
          return { value: left342.value << right342.value };
        case ">>":
          return { value: left342.value >> right342.value };
        case ">>>":
          return { value: left342.value >>> right342.value };
        case "+":
          return { value: left342.value + right342.value };
        case "-":
          return { value: left342.value - right342.value };
        case "*":
          return { value: left342.value * right342.value };
        case "/":
          return { value: left342.value / right342.value };
        case "%":
          return { value: left342.value % right342.value };
        case "**":
          return { value: left342.value ** right342.value };
        case "|":
          return { value: left342.value | right342.value };
        case "^":
          return { value: left342.value ^ right342.value };
        case "&":
          return { value: left342.value & right342.value };
      }
    }
    return null;
  },
  CallExpression(node, initialScope) {
    const calleeNode = node.callee;
    const args = getElementValues52(node.arguments, initialScope);
    if (args != null) {
      if (calleeNode.type === "MemberExpression") {
        if (calleeNode.property.type === "PrivateIdentifier") {
          return null;
        }
        const object32 = getStaticValueR52(calleeNode.object, initialScope);
        if (object32 != null) {
          if (object32.value == null && (object32.optional || node.optional)) {
            return { value: void 0, optional: true };
          }
          const property = getStaticPropertyNameValue52(
            calleeNode,
            initialScope
          );
          if (property != null) {
            const receiver = object32.value;
            const methodName = property.value;
            if (callAllowed52.has(receiver[methodName])) {
              return { value: receiver[methodName](...args) };
            }
            if (callPassThrough52.has(receiver[methodName])) {
              return { value: args[0] };
            }
          }
        }
      } else {
        const callee = getStaticValueR52(calleeNode, initialScope);
        if (callee != null) {
          if (callee.value == null && node.optional) {
            return { value: void 0, optional: true };
          }
          const func = callee.value;
          if (callAllowed52.has(func)) {
            return { value: func(...args) };
          }
          if (callPassThrough52.has(func)) {
            return { value: args[0] };
          }
        }
      }
    }
    return null;
  },
  ConditionalExpression(node, initialScope) {
    const test = getStaticValueR52(node.test, initialScope);
    if (test != null) {
      return test.value ? getStaticValueR52(node.consequent, initialScope) : getStaticValueR52(node.alternate, initialScope);
    }
    return null;
  },
  ExpressionStatement(node, initialScope) {
    return getStaticValueR52(node.expression, initialScope);
  },
  Identifier(node, initialScope) {
    if (initialScope != null) {
      const variable = findVariable252(initialScope, node);
      if (variable != null && variable.defs.length === 0 && builtinNames52.has(variable.name) && variable.name in globalObject52) {
        return { value: globalObject52[variable.name] };
      }
      if (variable != null && variable.defs.length === 1) {
        const def = variable.defs[0];
        if (def.parent && def.type === "Variable" && (def.parent.kind === "const" || isEffectivelyConst52(variable)) && // TODO(mysticatea): don't support destructuring here.
        def.node.id.type === "Identifier") {
          return getStaticValueR52(def.node.init, initialScope);
        }
      }
    }
    return null;
  },
  Literal(node) {
    if ((node.regex != null || node.bigint != null) && node.value == null) {
      return null;
    }
    return { value: node.value };
  },
  LogicalExpression(node, initialScope) {
    const left342 = getStaticValueR52(node.left, initialScope);
    if (left342 != null) {
      if (node.operator === "||" && Boolean(left342.value) === true || node.operator === "&&" && Boolean(left342.value) === false || node.operator === "??" && left342.value != null) {
        return left342;
      }
      const right342 = getStaticValueR52(node.right, initialScope);
      if (right342 != null) {
        return right342;
      }
    }
    return null;
  },
  MemberExpression(node, initialScope) {
    if (node.property.type === "PrivateIdentifier") {
      return null;
    }
    const object32 = getStaticValueR52(node.object, initialScope);
    if (object32 != null) {
      if (object32.value == null && (object32.optional || node.optional)) {
        return { value: void 0, optional: true };
      }
      const property = getStaticPropertyNameValue52(node, initialScope);
      if (property != null) {
        if (!isGetter52(object32.value, property.value)) {
          return { value: object32.value[property.value] };
        }
        for (const [classFn, allowed] of getterAllowed52) {
          if (object32.value instanceof classFn && allowed.has(property.value)) {
            return { value: object32.value[property.value] };
          }
        }
      }
    }
    return null;
  },
  ChainExpression(node, initialScope) {
    const expression = getStaticValueR52(node.expression, initialScope);
    if (expression != null) {
      return { value: expression.value };
    }
    return null;
  },
  NewExpression(node, initialScope) {
    const callee = getStaticValueR52(node.callee, initialScope);
    const args = getElementValues52(node.arguments, initialScope);
    if (callee != null && args != null) {
      const Func = callee.value;
      if (callAllowed52.has(Func)) {
        return { value: new Func(...args) };
      }
    }
    return null;
  },
  ObjectExpression(node, initialScope) {
    const object32 = {};
    for (const propertyNode of node.properties) {
      if (propertyNode.type === "Property") {
        if (propertyNode.kind !== "init") {
          return null;
        }
        const key = getStaticPropertyNameValue52(
          propertyNode,
          initialScope
        );
        const value = getStaticValueR52(propertyNode.value, initialScope);
        if (key == null || value == null) {
          return null;
        }
        object32[key.value] = value.value;
      } else if (propertyNode.type === "SpreadElement" || propertyNode.type === "ExperimentalSpreadProperty") {
        const argument = getStaticValueR52(
          propertyNode.argument,
          initialScope
        );
        if (argument == null) {
          return null;
        }
        Object.assign(object32, argument.value);
      } else {
        return null;
      }
    }
    return { value: object32 };
  },
  SequenceExpression(node, initialScope) {
    const last32 = node.expressions[node.expressions.length - 1];
    return getStaticValueR52(last32, initialScope);
  },
  TaggedTemplateExpression(node, initialScope) {
    const tag = getStaticValueR52(node.tag, initialScope);
    const expressions = getElementValues52(
      node.quasi.expressions,
      initialScope
    );
    if (tag != null && expressions != null) {
      const func = tag.value;
      const strings = node.quasi.quasis.map((q) => q.value.cooked);
      strings.raw = node.quasi.quasis.map((q) => q.value.raw);
      if (func === String.raw) {
        return { value: func(strings, ...expressions) };
      }
    }
    return null;
  },
  TemplateLiteral(node, initialScope) {
    const expressions = getElementValues52(node.expressions, initialScope);
    if (expressions != null) {
      let value = node.quasis[0].value.cooked;
      for (let i232 = 0; i232 < expressions.length; ++i232) {
        value += expressions[i232];
        value += node.quasis[i232 + 1].value.cooked;
      }
      return { value };
    }
    return null;
  },
  UnaryExpression(node, initialScope) {
    if (node.operator === "delete") {
      return null;
    }
    if (node.operator === "void") {
      return { value: void 0 };
    }
    const arg = getStaticValueR52(node.argument, initialScope);
    if (arg != null) {
      switch (node.operator) {
        case "-":
          return { value: -arg.value };
        case "+":
          return { value: +arg.value };
        case "!":
          return { value: !arg.value };
        case "~":
          return { value: ~arg.value };
        case "typeof":
          return { value: typeof arg.value };
      }
    }
    return null;
  }
});
function getStaticValueR52(node, initialScope) {
  if (node != null && Object.hasOwnProperty.call(operations52, node.type)) {
    return operations52[node.type](node, initialScope);
  }
  return null;
}
function getStaticPropertyNameValue52(node, initialScope) {
  const nameNode = node.type === "Property" ? node.key : node.property;
  if (node.computed) {
    return getStaticValueR52(nameNode, initialScope);
  }
  if (nameNode.type === "Identifier") {
    return { value: nameNode.name };
  }
  if (nameNode.type === "Literal") {
    if (nameNode.bigint) {
      return { value: nameNode.bigint };
    }
    return { value: String(nameNode.value) };
  }
  return null;
}
function getStaticValue52(node, initialScope = null) {
  try {
    return getStaticValueR52(node, initialScope);
  } catch (_error) {
    return null;
  }
}
function getStringIfConstant52(node, initialScope = null) {
  if (node && node.type === "Literal" && node.value === null) {
    if (node.regex) {
      return `/${node.regex.pattern}/${node.regex.flags}`;
    }
    if (node.bigint) {
      return node.bigint;
    }
  }
  const evaluated = getStaticValue52(node, initialScope);
  return evaluated && String(evaluated.value);
}
function getPropertyName52(node, initialScope) {
  switch (node.type) {
    case "MemberExpression":
      if (node.computed) {
        return getStringIfConstant52(node.property, initialScope);
      }
      if (node.property.type === "PrivateIdentifier") {
        return null;
      }
      return node.property.name;
    case "Property":
    case "MethodDefinition":
    case "PropertyDefinition":
      if (node.computed) {
        return getStringIfConstant52(node.key, initialScope);
      }
      if (node.key.type === "Literal") {
        return String(node.key.value);
      }
      if (node.key.type === "PrivateIdentifier") {
        return null;
      }
      return node.key.name;
  }
  return null;
}
function getFunctionNameWithKind52(node, sourceCode) {
  const parent = node.parent;
  const tokens = [];
  const isObjectMethod = parent.type === "Property" && parent.value === node;
  const isClassMethod = parent.type === "MethodDefinition" && parent.value === node;
  const isClassFieldMethod = parent.type === "PropertyDefinition" && parent.value === node;
  if (isClassMethod || isClassFieldMethod) {
    if (parent.static) {
      tokens.push("static");
    }
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push("private");
    }
  }
  if (node.async) {
    tokens.push("async");
  }
  if (node.generator) {
    tokens.push("generator");
  }
  if (isObjectMethod || isClassMethod) {
    if (parent.kind === "constructor") {
      return "constructor";
    }
    if (parent.kind === "get") {
      tokens.push("getter");
    } else if (parent.kind === "set") {
      tokens.push("setter");
    } else {
      tokens.push("method");
    }
  } else if (isClassFieldMethod) {
    tokens.push("method");
  } else {
    if (node.type === "ArrowFunctionExpression") {
      tokens.push("arrow");
    }
    tokens.push("function");
  }
  if (isObjectMethod || isClassMethod || isClassFieldMethod) {
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push(`#${parent.key.name}`);
    } else {
      const name22 = getPropertyName52(parent);
      if (name22) {
        tokens.push(`'${name22}'`);
      } else if (sourceCode) {
        const keyText = sourceCode.getText(parent.key);
        if (!keyText.includes("\n")) {
          tokens.push(`[${keyText}]`);
        }
      }
    }
  } else if (node.id) {
    tokens.push(`'${node.id.name}'`);
  } else if (parent.type === "VariableDeclarator" && parent.id && parent.id.type === "Identifier") {
    tokens.push(`'${parent.id.name}'`);
  } else if ((parent.type === "AssignmentExpression" || parent.type === "AssignmentPattern") && parent.left && parent.left.type === "Identifier") {
    tokens.push(`'${parent.left.name}'`);
  } else if (parent.type === "ExportDefaultDeclaration" && parent.declaration === node) {
    tokens.push("'default'");
  }
  return tokens.join(" ");
}
var typeConversionBinaryOps52 = Object.freeze(
  /* @__PURE__ */ new Set([
    "==",
    "!=",
    "<",
    "<=",
    ">",
    ">=",
    "<<",
    ">>",
    ">>>",
    "+",
    "-",
    "*",
    "/",
    "%",
    "|",
    "^",
    "&",
    "in"
  ])
);
var typeConversionUnaryOps52 = Object.freeze(/* @__PURE__ */ new Set(["-", "+", "!", "~"]));
function isNode52(x232) {
  return x232 !== null && typeof x232 === "object" && typeof x232.type === "string";
}
var visitor52 = Object.freeze(
  Object.assign(/* @__PURE__ */ Object.create(null), {
    $visit(node, options, visitorKeys) {
      const { type } = node;
      if (typeof this[type] === "function") {
        return this[type](node, options, visitorKeys);
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    $visitChildren(node, options, visitorKeys) {
      const { type } = node;
      for (const key of visitorKeys[type] || getKeys52(node)) {
        const value = node[key];
        if (Array.isArray(value)) {
          for (const element of value) {
            if (isNode52(element) && this.$visit(element, options, visitorKeys)) {
              return true;
            }
          }
        } else if (isNode52(value) && this.$visit(value, options, visitorKeys)) {
          return true;
        }
      }
      return false;
    },
    ArrowFunctionExpression() {
      return false;
    },
    AssignmentExpression() {
      return true;
    },
    AwaitExpression() {
      return true;
    },
    BinaryExpression(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && typeConversionBinaryOps52.has(node.operator) && (node.left.type !== "Literal" || node.right.type !== "Literal")) {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    CallExpression() {
      return true;
    },
    FunctionExpression() {
      return false;
    },
    ImportExpression() {
      return true;
    },
    MemberExpression(node, options, visitorKeys) {
      if (options.considerGetters) {
        return true;
      }
      if (options.considerImplicitTypeConversion && node.computed && node.property.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    MethodDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    NewExpression() {
      return true;
    },
    Property(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    PropertyDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UnaryExpression(node, options, visitorKeys) {
      if (node.operator === "delete") {
        return true;
      }
      if (options.considerImplicitTypeConversion && typeConversionUnaryOps52.has(node.operator) && node.argument.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UpdateExpression() {
      return true;
    },
    YieldExpression() {
      return true;
    }
  })
);
function hasSideEffect52(node, sourceCode, { considerGetters = false, considerImplicitTypeConversion = false } = {}) {
  return visitor52.$visit(
    node,
    { considerGetters, considerImplicitTypeConversion },
    sourceCode.visitorKeys || visitor_keys_default52
  );
}
function getParentSyntaxParen52(node, sourceCode) {
  const parent = node.parent;
  switch (parent.type) {
    case "CallExpression":
    case "NewExpression":
      if (parent.arguments.length === 1 && parent.arguments[0] === node) {
        return sourceCode.getTokenAfter(
          parent.callee,
          isOpeningParenToken52
        );
      }
      return null;
    case "DoWhileStatement":
      if (parent.test === node) {
        return sourceCode.getTokenAfter(
          parent.body,
          isOpeningParenToken52
        );
      }
      return null;
    case "IfStatement":
    case "WhileStatement":
      if (parent.test === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "ImportExpression":
      if (parent.source === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "SwitchStatement":
      if (parent.discriminant === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "WithStatement":
      if (parent.object === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    default:
      return null;
  }
}
function isParenthesized52(timesOrNode, nodeOrSourceCode, optionalSourceCode) {
  let times, node, sourceCode, maybeLeftParen, maybeRightParen;
  if (typeof timesOrNode === "number") {
    times = timesOrNode | 0;
    node = nodeOrSourceCode;
    sourceCode = optionalSourceCode;
    if (!(times >= 1)) {
      throw new TypeError("'times' should be a positive integer.");
    }
  } else {
    times = 1;
    node = timesOrNode;
    sourceCode = nodeOrSourceCode;
  }
  if (node == null || // `Program` can't be parenthesized
  node.parent == null || // `CatchClause.param` can't be parenthesized, example `try {} catch (error) {}`
  node.parent.type === "CatchClause" && node.parent.param === node) {
    return false;
  }
  maybeLeftParen = maybeRightParen = node;
  do {
    maybeLeftParen = sourceCode.getTokenBefore(maybeLeftParen);
    maybeRightParen = sourceCode.getTokenAfter(maybeRightParen);
  } while (maybeLeftParen != null && maybeRightParen != null && isOpeningParenToken52(maybeLeftParen) && isClosingParenToken52(maybeRightParen) && // Avoid false positive such as `if (a) {}`
  maybeLeftParen !== getParentSyntaxParen52(node, sourceCode) && --times > 0);
  return times === 0;
}
Function.call.bind(Object.hasOwnProperty);
var __defProp252 = Object.defineProperty;
var __export252 = (target, all342) => {
  for (var name22 in all342)
    __defProp252(target, name22, { get: all342[name22], enumerable: true });
};
var NodeType52 = types.AST_NODE_TYPES;
var is52 = utils.ASTUtils.isNodeOfType;
var isOneOf52 = utils.ASTUtils.isNodeOfTypes;
isOneOf52([
  NodeType52.ArrowFunctionExpression,
  NodeType52.FunctionDeclaration,
  NodeType52.FunctionExpression
]);
isOneOf52([
  NodeType52.ArrowFunctionExpression,
  NodeType52.FunctionDeclaration,
  NodeType52.FunctionExpression,
  NodeType52.TSCallSignatureDeclaration,
  NodeType52.TSConstructSignatureDeclaration,
  NodeType52.TSDeclareFunction,
  NodeType52.TSEmptyBodyFunctionExpression,
  NodeType52.TSFunctionType,
  NodeType52.TSMethodSignature
]);
isOneOf52([NodeType52.ClassDeclaration, NodeType52.ClassExpression]);
isOneOf52([
  NodeType52.DoWhileStatement,
  NodeType52.ForInStatement,
  NodeType52.ForOfStatement,
  NodeType52.ForStatement,
  NodeType52.WhileStatement
]);
isOneOf52([NodeType52.TSArrayType, NodeType52.TSTupleType]);
isOneOf52([
  NodeType52.PropertyDefinition,
  NodeType52.TSIndexSignature,
  NodeType52.TSParameterProperty,
  NodeType52.TSPropertySignature
]);
is52(NodeType52.JSXElement);
is52(NodeType52.JSXFragment);
isOneOf52([
  NodeType52.JSXAttribute,
  NodeType52.JSXSpreadChild,
  NodeType52.JSXClosingElement,
  NodeType52.JSXClosingFragment,
  NodeType52.JSXElement,
  NodeType52.JSXEmptyExpression,
  NodeType52.JSXExpressionContainer,
  NodeType52.JSXFragment,
  NodeType52.JSXIdentifier,
  NodeType52.JSXMemberExpression,
  NodeType52.JSXNamespacedName,
  NodeType52.JSXOpeningElement,
  NodeType52.JSXOpeningFragment,
  NodeType52.JSXSpreadAttribute,
  NodeType52.JSXSpreadChild,
  NodeType52.JSXText
]);
isOneOf52([
  NodeType52.JSXIdentifier,
  NodeType52.JSXMemberExpression,
  NodeType52.JSXNamespacedName
]);
isOneOf52([
  NodeType52.ArrayPattern,
  NodeType52.AssignmentPattern,
  NodeType52.ObjectPattern,
  NodeType52.RestElement
]);
isOneOf52([
  NodeType52.TSInterfaceDeclaration,
  NodeType52.TSTypeAliasDeclaration
]);
isOneOf52([
  NodeType52.ArrayExpression,
  NodeType52.ArrayPattern,
  NodeType52.ArrowFunctionExpression,
  NodeType52.CallExpression,
  NodeType52.ClassExpression,
  NodeType52.FunctionExpression,
  NodeType52.Identifier,
  NodeType52.JSXElement,
  NodeType52.JSXFragment,
  NodeType52.Literal,
  NodeType52.TemplateLiteral,
  NodeType52.MemberExpression,
  NodeType52.MetaProperty,
  NodeType52.ObjectExpression,
  NodeType52.ObjectPattern,
  NodeType52.SequenceExpression,
  NodeType52.Super,
  NodeType52.TaggedTemplateExpression,
  NodeType52.ThisExpression
]);
isOneOf52([
  NodeType52.ArrayExpression,
  NodeType52.ArrayPattern,
  NodeType52.ArrowFunctionExpression,
  NodeType52.CallExpression,
  NodeType52.ClassExpression,
  NodeType52.FunctionExpression,
  NodeType52.Identifier,
  NodeType52.JSXElement,
  NodeType52.JSXFragment,
  NodeType52.Literal,
  NodeType52.TemplateLiteral,
  NodeType52.MemberExpression,
  NodeType52.MetaProperty,
  NodeType52.ObjectExpression,
  NodeType52.ObjectPattern,
  NodeType52.SequenceExpression,
  NodeType52.Super,
  NodeType52.TaggedTemplateExpression,
  NodeType52.ThisExpression,
  NodeType52.TSAsExpression,
  NodeType52.TSNonNullExpression,
  NodeType52.TSTypeAssertion
]);
var Function_exports252 = {};
__export252(Function_exports252, {
  SK: () => SK252,
  absurd: () => absurd252,
  apply: () => apply252,
  compose: () => compose252,
  constFalse: () => constFalse252,
  constNull: () => constNull252,
  constTrue: () => constTrue252,
  constUndefined: () => constUndefined252,
  constVoid: () => constVoid252,
  constant: () => constant252,
  dual: () => dual252,
  flip: () => flip252,
  flow: () => flow252,
  hole: () => hole252,
  identity: () => identity252,
  isFunction: () => isFunction2252,
  pipe: () => pipe252,
  satisfies: () => satisfies252,
  tupled: () => tupled252,
  unsafeCoerce: () => unsafeCoerce252,
  untupled: () => untupled252
});
var isFunction2252 = (input) => typeof input === "function";
var dual252 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a232, b232) {
        if (arguments.length >= 2) {
          return body(a232, b232);
        }
        return function(self2) {
          return body(self2, a232);
        };
      };
    case 3:
      return function(a232, b232, c232) {
        if (arguments.length >= 3) {
          return body(a232, b232, c232);
        }
        return function(self2) {
          return body(self2, a232, b232);
        };
      };
    case 4:
      return function(a232, b232, c232, d232) {
        if (arguments.length >= 4) {
          return body(a232, b232, c232, d232);
        }
        return function(self2) {
          return body(self2, a232, b232, c232);
        };
      };
    case 5:
      return function(a232, b232, c232, d232, e232) {
        if (arguments.length >= 5) {
          return body(a232, b232, c232, d232, e232);
        }
        return function(self2) {
          return body(self2, a232, b232, c232, d232);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply252 = (a232) => (self2) => self2(a232);
var identity252 = (a232) => a232;
var satisfies252 = () => (b232) => b232;
var unsafeCoerce252 = identity252;
var constant252 = (value) => () => value;
var constTrue252 = /* @__PURE__ */ constant252(true);
var constFalse252 = /* @__PURE__ */ constant252(false);
var constNull252 = /* @__PURE__ */ constant252(null);
var constUndefined252 = /* @__PURE__ */ constant252(void 0);
var constVoid252 = constUndefined252;
var flip252 = (f232) => (...b232) => (...a232) => f232(...a232)(...b232);
var compose252 = /* @__PURE__ */ dual252(2, (ab, bc) => (a232) => bc(ab(a232)));
var absurd252 = (_232) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled252 = (f232) => (a232) => f232(...a232);
var untupled252 = (f232) => (...a232) => f232(a232);
function pipe252(a232, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a232;
    case 2:
      return ab(a232);
    case 3:
      return bc(ab(a232));
    case 4:
      return cd(bc(ab(a232)));
    case 5:
      return de(cd(bc(ab(a232))));
    case 6:
      return ef(de(cd(bc(ab(a232)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a232))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a232)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a232))))))));
    default: {
      let ret = arguments[0];
      for (let i232 = 1; i232 < arguments.length; i232++) {
        ret = arguments[i232](ret);
      }
      return ret;
    }
  }
}
function flow252(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole252 = /* @__PURE__ */ unsafeCoerce252(absurd252);
var SK252 = (_232, b232) => b232;
var make452 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_352 = (map622) => dual252(3, (self2, name22, f232) => map622(self2, (a232) => Object.assign({}, a232, {
  [name22]: f232(a232)
})));
var bindTo352 = (map622) => dual252(2, (self2, name22) => map622(self2, (a232) => ({
  [name22]: a232
})));
var bind352 = (map622, flatMap432) => dual252(3, (self2, name22, f232) => flatMap432(self2, (a232) => map622(f232(a232), (b232) => Object.assign({}, a232, {
  [name22]: b232
}))));
var moduleVersion252 = "3.2.8";
var getCurrentVersion252 = () => moduleVersion252;
var globalStoreId252 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion252()}`);
if (!(globalStoreId252 in globalThis)) {
  globalThis[globalStoreId252] = /* @__PURE__ */ new Map();
}
var globalStore252 = globalThis[globalStoreId252];
var globalValue252 = (id, compute) => {
  if (!globalStore252.has(id)) {
    globalStore252.set(id, compute());
  }
  return globalStore252.get(id);
};
var Predicate_exports252 = {};
__export252(Predicate_exports252, {
  all: () => all252,
  and: () => and82,
  compose: () => compose2252,
  eqv: () => eqv82,
  every: () => every92,
  hasProperty: () => hasProperty252,
  implies: () => implies82,
  isBigInt: () => isBigInt82,
  isBoolean: () => isBoolean82,
  isDate: () => isDate82,
  isError: () => isError82,
  isFunction: () => isFunction3252,
  isIterable: () => isIterable82,
  isMap: () => isMap82,
  isNever: () => isNever82,
  isNotNull: () => isNotNull82,
  isNotNullable: () => isNotNullable82,
  isNotUndefined: () => isNotUndefined82,
  isNull: () => isNull82,
  isNullable: () => isNullable252,
  isNumber: () => isNumber82,
  isObject: () => isObject252,
  isPromise: () => isPromise82,
  isPromiseLike: () => isPromiseLike82,
  isReadonlyRecord: () => isReadonlyRecord82,
  isRecord: () => isRecord82,
  isSet: () => isSet82,
  isString: () => isString82,
  isSymbol: () => isSymbol82,
  isTagged: () => isTagged82,
  isTruthy: () => isTruthy82,
  isUint8Array: () => isUint8Array82,
  isUndefined: () => isUndefined82,
  isUnknown: () => isUnknown82,
  mapInput: () => mapInput92,
  nand: () => nand82,
  nor: () => nor82,
  not: () => not82,
  or: () => or82,
  product: () => product252,
  productMany: () => productMany252,
  some: () => some352,
  struct: () => struct102,
  tuple: () => tuple92,
  xor: () => xor82
});
var mapInput92 = /* @__PURE__ */ dual252(2, (self2, f232) => (b232) => self2(f232(b232)));
var isTruthy82 = (input) => !!input;
var isSet82 = (input) => input instanceof Set;
var isMap82 = (input) => input instanceof Map;
var isString82 = (input) => typeof input === "string";
var isNumber82 = (input) => typeof input === "number";
var isBoolean82 = (input) => typeof input === "boolean";
var isBigInt82 = (input) => typeof input === "bigint";
var isSymbol82 = (input) => typeof input === "symbol";
var isFunction3252 = isFunction2252;
var isUndefined82 = (input) => input === void 0;
var isNotUndefined82 = (input) => input !== void 0;
var isNull82 = (input) => input === null;
var isNotNull82 = (input) => input !== null;
var isNever82 = (_232) => false;
var isUnknown82 = (_232) => true;
var isRecordOrArray252 = (input) => typeof input === "object" && input !== null;
var isObject252 = (input) => isRecordOrArray252(input) || isFunction3252(input);
var hasProperty252 = /* @__PURE__ */ dual252(2, (self2, property) => isObject252(self2) && property in self2);
var isTagged82 = /* @__PURE__ */ dual252(2, (self2, tag) => hasProperty252(self2, "_tag") && self2["_tag"] === tag);
var isNullable252 = (input) => input === null || input === void 0;
var isNotNullable82 = (input) => input !== null && input !== void 0;
var isError82 = (input) => input instanceof Error;
var isUint8Array82 = (input) => input instanceof Uint8Array;
var isDate82 = (input) => input instanceof Date;
var isIterable82 = (input) => hasProperty252(input, Symbol.iterator);
var isRecord82 = (input) => isRecordOrArray252(input) && !Array.isArray(input);
var isReadonlyRecord82 = isRecord82;
var isPromise82 = (input) => hasProperty252(input, "then") && "catch" in input && isFunction3252(input.then) && isFunction3252(input.catch);
var isPromiseLike82 = (input) => hasProperty252(input, "then") && isFunction3252(input.then);
var compose2252 = /* @__PURE__ */ dual252(2, (ab, bc) => (a232) => ab(a232) && bc(a232));
var product252 = (self2, that) => ([a232, b232]) => self2(a232) && that(b232);
var all252 = (collection) => {
  return (as2242) => {
    let collectionIndex = 0;
    for (const p232 of collection) {
      if (collectionIndex >= as2242.length) {
        break;
      }
      if (p232(as2242[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany252 = (self2, collection) => {
  const rest = all252(collection);
  return ([head222, ...tail42]) => self2(head222) === false ? false : rest(tail42);
};
var tuple92 = (...elements) => all252(elements);
var struct102 = (fields) => {
  const keys242 = Object.keys(fields);
  return (a232) => {
    for (const key of keys242) {
      if (!fields[key](a232[key])) {
        return false;
      }
    }
    return true;
  };
};
var not82 = (self2) => (a232) => !self2(a232);
var or82 = /* @__PURE__ */ dual252(2, (self2, that) => (a232) => self2(a232) || that(a232));
var and82 = /* @__PURE__ */ dual252(2, (self2, that) => (a232) => self2(a232) && that(a232));
var xor82 = /* @__PURE__ */ dual252(2, (self2, that) => (a232) => self2(a232) !== that(a232));
var eqv82 = /* @__PURE__ */ dual252(2, (self2, that) => (a232) => self2(a232) === that(a232));
var implies82 = /* @__PURE__ */ dual252(2, (self2, that) => (a232) => self2(a232) ? that(a232) : true);
var nor82 = /* @__PURE__ */ dual252(2, (self2, that) => (a232) => !(self2(a232) || that(a232)));
var nand82 = /* @__PURE__ */ dual252(2, (self2, that) => (a232) => !(self2(a232) && that(a232)));
var every92 = (collection) => (a232) => {
  for (const p232 of collection) {
    if (!p232(a232)) {
      return false;
    }
  }
  return true;
};
var some352 = (collection) => (a232) => {
  for (const p232 of collection) {
    if (p232(a232)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage252 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId252 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind252 = (u232) => isObject252(u232) && GenKindTypeId252 in u232;
var GenKindImpl252 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity252;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId252] = GenKindTypeId252;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen252(this);
  }
};
var SingleShotGen252 = class _SingleShotGen92 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a232) {
    return this.called ? {
      value: a232,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a232) {
    return {
      value: a232,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e232) {
    throw e232;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen92(this.self);
  }
};
var adapter352 = () => function() {
  let x232 = arguments[0];
  for (let i232 = 1; i232 < arguments.length; i232++) {
    x232 = arguments[i232](x232);
  }
  return new GenKindImpl252(x232);
};
var defaultIncHi252 = 335903614;
var defaultIncLo252 = 4150755663;
var MUL_HI252 = 1481765933 >>> 0;
var MUL_LO252 = 1284865837 >>> 0;
var BIT_53252 = 9007199254740992;
var BIT_27252 = 134217728;
var PCGRandom252 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable252(seedLo) && isNullable252(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable252(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable252(incLo) && isNullable252(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo252;
      incHi = this._state ? this._state[2] : defaultIncHi252;
    } else if (isNullable252(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add64252(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max42) {
    if (!max42) {
      return this._next();
    }
    max42 = max42 >>> 0;
    if ((max42 & max42 - 1) === 0) {
      return this._next() & max42 - 1;
    }
    let num = 0;
    const skew = (-max42 >>> 0) % max42 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max42;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_27252 + lo) / BIT_53252;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul64252(this._state, oldHi, oldLo, MUL_HI252, MUL_LO252);
    add64252(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul64252(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add64252(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId252 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap252 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId252]() {
    return this.#value;
  }
};
function yieldWrapGet252(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId252 in self2) {
    return self2[YieldWrapTypeId252]();
  }
  throw new Error(getBugErrorMessage252("yieldWrapGet"));
}
var structuralRegionState252 = /* @__PURE__ */ globalValue252("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache252 = /* @__PURE__ */ globalValue252(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr252 = /* @__PURE__ */ globalValue252(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom252());
var symbol352 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash252 = (self2) => {
  if (structuralRegionState252.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number252(self2);
    case "bigint":
      return string252(self2.toString(10));
    case "boolean":
      return string252(String(self2));
    case "symbol":
      return string252(String(self2));
    case "string":
      return string252(self2);
    case "undefined":
      return string252("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string252("null");
      } else if (self2 instanceof Date) {
        return hash252(self2.toISOString());
      } else if (isHash252(self2)) {
        return self2[symbol352]();
      } else {
        return random252(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random252 = (self2) => {
  if (!randomHashCache252.has(self2)) {
    randomHashCache252.set(self2, number252(pcgr252.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache252.get(self2);
};
var combine252 = (b232) => (self2) => self2 * 53 ^ b232;
var optimize252 = (n232) => n232 & 3221225471 | n232 >>> 1 & 1073741824;
var isHash252 = (u232) => hasProperty252(u232, symbol352);
var number252 = (n232) => {
  if (n232 !== n232 || n232 === Infinity) {
    return 0;
  }
  let h232 = n232 | 0;
  if (h232 !== n232) {
    h232 ^= n232 * 4294967295;
  }
  while (n232 > 4294967295) {
    h232 ^= n232 /= 4294967295;
  }
  return optimize252(n232);
};
var string252 = (str) => {
  let h232 = 5381, i232 = str.length;
  while (i232) {
    h232 = h232 * 33 ^ str.charCodeAt(--i232);
  }
  return optimize252(h232);
};
var structureKeys242 = (o232, keys242) => {
  let h232 = 12289;
  for (let i232 = 0; i232 < keys242.length; i232++) {
    h232 ^= pipe252(string252(keys242[i232]), combine252(hash252(o232[keys242[i232]])));
  }
  return optimize252(h232);
};
var structure242 = (o232) => structureKeys242(o232, Object.keys(o232));
var array102 = (arr) => {
  let h232 = 6151;
  for (let i232 = 0; i232 < arr.length; i232++) {
    h232 = pipe252(h232, combine252(hash252(arr[i232])));
  }
  return optimize252(h232);
};
var cached252 = function() {
  if (arguments.length === 1) {
    const self22 = arguments[0];
    return function(hash332) {
      Object.defineProperty(self22, symbol352, {
        value() {
          return hash332;
        },
        enumerable: false
      });
      return hash332;
    };
  }
  const self2 = arguments[0];
  const hash2242 = arguments[1];
  Object.defineProperty(self2, symbol352, {
    value() {
      return hash2242;
    },
    enumerable: false
  });
  return hash2242;
};
var symbol2252 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals252() {
  if (arguments.length === 1) {
    return (self2) => compareBoth252(self2, arguments[0]);
  }
  return compareBoth252(arguments[0], arguments[1]);
}
function compareBoth252(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual252(self2) && isEqual252(that)) {
        if (hash252(self2) === hash252(that) && self2[symbol2252](that)) {
          return true;
        } else {
          return structuralRegionState252.enabled && structuralRegionState252.tester ? structuralRegionState252.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState252.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v232, i232) => compareBoth252(v232, that[i232]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth252(self2[key], that[key]))) {
              return structuralRegionState252.tester ? structuralRegionState252.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState252.tester ? structuralRegionState252.tester(self2, that) : false;
    }
  }
  return structuralRegionState252.enabled && structuralRegionState252.tester ? structuralRegionState252.tester(self2, that) : false;
}
var isEqual252 = (u232) => hasProperty252(u232, symbol2252);
var equivalence252 = () => equals252;
var NodeInspectSymbol252 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON252 = (x232) => {
  if (hasProperty252(x232, "toJSON") && isFunction3252(x232["toJSON"]) && x232["toJSON"].length === 0) {
    return x232.toJSON();
  } else if (Array.isArray(x232)) {
    return x232.map(toJSON252);
  }
  return x232;
};
var format252 = (x232) => JSON.stringify(x232, null, 2);
var pipeArguments252 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i232 = 0, len = args.length; i232 < len; i232++) {
        ret = args[i232](ret);
      }
      return ret;
    }
  }
};
var OP_COMMIT242 = "Commit";
var OP_FAILURE52 = "Failure";
var OP_WITH_RUNTIME52 = "WithRuntime";
var EffectTypeId252 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId252 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId252 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId252 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance252 = {
  /* c8 ignore next */
  _R: (_232) => _232,
  /* c8 ignore next */
  _E: (_232) => _232,
  /* c8 ignore next */
  _A: (_232) => _232,
  _V: /* @__PURE__ */ getCurrentVersion252()
};
var sinkVariance252 = {
  /* c8 ignore next */
  _A: (_232) => _232,
  /* c8 ignore next */
  _In: (_232) => _232,
  /* c8 ignore next */
  _L: (_232) => _232,
  /* c8 ignore next */
  _E: (_232) => _232,
  /* c8 ignore next */
  _R: (_232) => _232
};
var channelVariance252 = {
  /* c8 ignore next */
  _Env: (_232) => _232,
  /* c8 ignore next */
  _InErr: (_232) => _232,
  /* c8 ignore next */
  _InElem: (_232) => _232,
  /* c8 ignore next */
  _InDone: (_232) => _232,
  /* c8 ignore next */
  _OutErr: (_232) => _232,
  /* c8 ignore next */
  _OutElem: (_232) => _232,
  /* c8 ignore next */
  _OutDone: (_232) => _232
};
var EffectPrototype252 = {
  [EffectTypeId252]: effectVariance252,
  [StreamTypeId252]: effectVariance252,
  [SinkTypeId252]: sinkVariance252,
  [ChannelTypeId252]: channelVariance252,
  [symbol2252](that) {
    return this === that;
  },
  [symbol352]() {
    return cached252(this, random252(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen252(new YieldWrap252(this));
  },
  pipe() {
    return pipeArguments252(this, arguments);
  }
};
var StructuralPrototype242 = {
  [symbol352]() {
    return cached252(this, structure242(this));
  },
  [symbol2252](that) {
    const selfKeys = Object.keys(this);
    const thatKeys = Object.keys(that);
    if (selfKeys.length !== thatKeys.length) {
      return false;
    }
    for (const key of selfKeys) {
      if (!(key in that && equals252(this[key], that[key]))) {
        return false;
      }
    }
    return true;
  }
};
var CommitPrototype242 = {
  ...EffectPrototype252,
  _op: OP_COMMIT242
};
var StructuralCommitPrototype242 = {
  ...CommitPrototype242,
  ...StructuralPrototype242
};
var TypeId552 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto352 = {
  ...EffectPrototype252,
  [TypeId552]: {
    _A: (_232) => _232
  },
  [NodeInspectSymbol252]() {
    return this.toJSON();
  },
  toString() {
    return format252(this.toJSON());
  }
};
var SomeProto252 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto352), {
  _tag: "Some",
  _op: "Some",
  [symbol2252](that) {
    return isOption352(that) && isSome352(that) && equals252(this.value, that.value);
  },
  [symbol352]() {
    return cached252(this, combine252(hash252(this._tag))(hash252(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON252(this.value)
    };
  }
});
var NoneHash252 = /* @__PURE__ */ hash252("None");
var NoneProto252 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto352), {
  _tag: "None",
  _op: "None",
  [symbol2252](that) {
    return isOption352(that) && isNone352(that);
  },
  [symbol352]() {
    return NoneHash252;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption352 = (input) => hasProperty252(input, TypeId552);
var isNone352 = (fa) => fa._tag === "None";
var isSome352 = (fa) => fa._tag === "Some";
var none352 = /* @__PURE__ */ Object.create(NoneProto252);
var some2252 = (value) => {
  const a232 = Object.create(SomeProto252);
  a232.value = value;
  return a232;
};
var TypeId2252 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto2252 = {
  ...EffectPrototype252,
  [TypeId2252]: {
    _R: (_232) => _232
  },
  [NodeInspectSymbol252]() {
    return this.toJSON();
  },
  toString() {
    return format252(this.toJSON());
  }
};
var RightProto252 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto2252), {
  _tag: "Right",
  _op: "Right",
  [symbol2252](that) {
    return isEither252(that) && isRight252(that) && equals252(this.right, that.right);
  },
  [symbol352]() {
    return combine252(hash252(this._tag))(hash252(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON252(this.right)
    };
  }
});
var LeftProto252 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto2252), {
  _tag: "Left",
  _op: "Left",
  [symbol2252](that) {
    return isEither252(that) && isLeft252(that) && equals252(this.left, that.left);
  },
  [symbol352]() {
    return combine252(hash252(this._tag))(hash252(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON252(this.left)
    };
  }
});
var isEither252 = (input) => hasProperty252(input, TypeId2252);
var isLeft252 = (ma) => ma._tag === "Left";
var isRight252 = (ma) => ma._tag === "Right";
var left252 = (left342) => {
  const a232 = Object.create(LeftProto252);
  a232.left = left342;
  return a232;
};
var right252 = (right342) => {
  const a232 = Object.create(RightProto252);
  a232.right = right342;
  return a232;
};
var getLeft352 = (self2) => isRight252(self2) ? none352 : some2252(self2.left);
var getRight352 = (self2) => isLeft252(self2) ? none352 : some2252(self2.right);
var right2252 = right252;
var left2252 = left252;
var Option_exports252 = {};
__export252(Option_exports252, {
  Do: () => Do252,
  TypeId: () => TypeId3252,
  all: () => all2252,
  andThen: () => andThen252,
  ap: () => ap252,
  as: () => as252,
  asVoid: () => asVoid252,
  bind: () => bind2252,
  bindTo: () => bindTo2252,
  composeK: () => composeK252,
  contains: () => contains252,
  containsWith: () => containsWith252,
  exists: () => exists252,
  filter: () => filter252,
  filterMap: () => filterMap252,
  firstSomeOf: () => firstSomeOf252,
  flatMap: () => flatMap252,
  flatMapNullable: () => flatMapNullable252,
  flatten: () => flatten252,
  fromIterable: () => fromIterable252,
  fromNullable: () => fromNullable252,
  gen: () => gen252,
  getEquivalence: () => getEquivalence252,
  getLeft: () => getLeft2252,
  getOrElse: () => getOrElse252,
  getOrNull: () => getOrNull252,
  getOrThrow: () => getOrThrow252,
  getOrThrowWith: () => getOrThrowWith252,
  getOrUndefined: () => getOrUndefined252,
  getOrder: () => getOrder252,
  getRight: () => getRight2252,
  isNone: () => isNone2252,
  isOption: () => isOption2252,
  isSome: () => isSome2252,
  let: () => let_2252,
  lift2: () => lift2252,
  liftNullable: () => liftNullable252,
  liftPredicate: () => liftPredicate252,
  liftThrowable: () => liftThrowable252,
  map: () => map252,
  match: () => match252,
  none: () => none2252,
  orElse: () => orElse252,
  orElseEither: () => orElseEither252,
  orElseSome: () => orElseSome252,
  partitionMap: () => partitionMap252,
  product: () => product2252,
  productMany: () => productMany2252,
  reduceCompact: () => reduceCompact252,
  some: () => some3252,
  tap: () => tap252,
  toArray: () => toArray252,
  toRefinement: () => toRefinement252,
  void: () => void_252,
  zipLeft: () => zipLeft252,
  zipRight: () => zipRight252,
  zipWith: () => zipWith252
});
var make2252 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId3252 = /* @__PURE__ */ Symbol.for("effect/Option");
var none2252 = () => none352;
var some3252 = some2252;
var isOption2252 = isOption352;
var isNone2252 = isNone352;
var isSome2252 = isSome352;
var match252 = /* @__PURE__ */ dual252(2, (self2, {
  onNone,
  onSome
}) => isNone2252(self2) ? onNone() : onSome(self2.value));
var toRefinement252 = (f232) => (a232) => isSome2252(f232(a232));
var fromIterable252 = (collection) => {
  for (const a232 of collection) {
    return some3252(a232);
  }
  return none2252();
};
var getRight2252 = getRight352;
var getLeft2252 = getLeft352;
var getOrElse252 = /* @__PURE__ */ dual252(2, (self2, onNone) => isNone2252(self2) ? onNone() : self2.value);
var orElse252 = /* @__PURE__ */ dual252(2, (self2, that) => isNone2252(self2) ? that() : self2);
var orElseSome252 = /* @__PURE__ */ dual252(2, (self2, onNone) => isNone2252(self2) ? some3252(onNone()) : self2);
var orElseEither252 = /* @__PURE__ */ dual252(2, (self2, that) => isNone2252(self2) ? map252(that(), right252) : map252(self2, left252));
var firstSomeOf252 = (collection) => {
  let out = none2252();
  for (out of collection) {
    if (isSome2252(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable252 = (nullableValue) => nullableValue == null ? none2252() : some3252(nullableValue);
var liftNullable252 = (f232) => (...a232) => fromNullable252(f232(...a232));
var getOrNull252 = /* @__PURE__ */ getOrElse252(constNull252);
var getOrUndefined252 = /* @__PURE__ */ getOrElse252(constUndefined252);
var liftThrowable252 = (f232) => (...a232) => {
  try {
    return some3252(f232(...a232));
  } catch (e232) {
    return none2252();
  }
};
var getOrThrowWith252 = /* @__PURE__ */ dual252(2, (self2, onNone) => {
  if (isSome2252(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow252 = /* @__PURE__ */ getOrThrowWith252(() => new Error("getOrThrow called on a None"));
var map252 = /* @__PURE__ */ dual252(2, (self2, f232) => isNone2252(self2) ? none2252() : some3252(f232(self2.value)));
var as252 = /* @__PURE__ */ dual252(2, (self2, b232) => map252(self2, () => b232));
var asVoid252 = /* @__PURE__ */ as252(void 0);
var void_252 = /* @__PURE__ */ some3252(void 0);
var flatMap252 = /* @__PURE__ */ dual252(2, (self2, f232) => isNone2252(self2) ? none2252() : f232(self2.value));
var andThen252 = /* @__PURE__ */ dual252(2, (self2, f232) => flatMap252(self2, (a232) => {
  const b232 = isFunction2252(f232) ? f232(a232) : f232;
  return isOption2252(b232) ? b232 : some3252(b232);
}));
var flatMapNullable252 = /* @__PURE__ */ dual252(2, (self2, f232) => isNone2252(self2) ? none2252() : fromNullable252(f232(self2.value)));
var flatten252 = /* @__PURE__ */ flatMap252(identity252);
var zipRight252 = /* @__PURE__ */ dual252(2, (self2, that) => flatMap252(self2, () => that));
var composeK252 = /* @__PURE__ */ dual252(2, (afb, bfc) => (a232) => flatMap252(afb(a232), bfc));
var zipLeft252 = /* @__PURE__ */ dual252(2, (self2, that) => tap252(self2, () => that));
var tap252 = /* @__PURE__ */ dual252(2, (self2, f232) => flatMap252(self2, (a232) => map252(f232(a232), () => a232)));
var product2252 = (self2, that) => isSome2252(self2) && isSome2252(that) ? some3252([self2.value, that.value]) : none2252();
var productMany2252 = (self2, collection) => {
  if (isNone2252(self2)) {
    return none2252();
  }
  const out = [self2.value];
  for (const o232 of collection) {
    if (isNone2252(o232)) {
      return none2252();
    }
    out.push(o232.value);
  }
  return some3252(out);
};
var all2252 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o232 of input) {
      if (isNone2252(o232)) {
        return none2252();
      }
      out2.push(o232.value);
    }
    return some3252(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o232 = input[key];
    if (isNone2252(o232)) {
      return none2252();
    }
    out[key] = o232.value;
  }
  return some3252(out);
};
var zipWith252 = /* @__PURE__ */ dual252(3, (self2, that, f232) => map252(product2252(self2, that), ([a232, b232]) => f232(a232, b232)));
var ap252 = /* @__PURE__ */ dual252(2, (self2, that) => zipWith252(self2, that, (f232, a232) => f232(a232)));
var reduceCompact252 = /* @__PURE__ */ dual252(3, (self2, b232, f232) => {
  let out = b232;
  for (const oa of self2) {
    if (isSome2252(oa)) {
      out = f232(out, oa.value);
    }
  }
  return out;
});
var toArray252 = (self2) => isNone2252(self2) ? [] : [self2.value];
var partitionMap252 = /* @__PURE__ */ dual252(2, (self2, f232) => {
  if (isNone2252(self2)) {
    return [none2252(), none2252()];
  }
  const e232 = f232(self2.value);
  return isLeft252(e232) ? [some3252(e232.left), none2252()] : [none2252(), some3252(e232.right)];
});
var filterMap252 = /* @__PURE__ */ dual252(2, (self2, f232) => isNone2252(self2) ? none2252() : f232(self2.value));
var filter252 = /* @__PURE__ */ dual252(2, (self2, predicate) => filterMap252(self2, (b232) => predicate(b232) ? some2252(b232) : none352));
var getEquivalence252 = (isEquivalent) => make452((x232, y232) => x232 === y232 || (isNone2252(x232) ? isNone2252(y232) : isNone2252(y232) ? false : isEquivalent(x232.value, y232.value)));
var getOrder252 = (O232) => make2252((self2, that) => isSome2252(self2) ? isSome2252(that) ? O232(self2.value, that.value) : 1 : -1);
var lift2252 = (f232) => dual252(2, (self2, that) => zipWith252(self2, that, f232));
var liftPredicate252 = (predicate) => (b232) => predicate(b232) ? some3252(b232) : none2252();
var containsWith252 = (isEquivalent) => dual252(2, (self2, a232) => isNone2252(self2) ? false : isEquivalent(self2.value, a232));
var _equivalence252 = /* @__PURE__ */ equivalence252();
var contains252 = /* @__PURE__ */ containsWith252(_equivalence252);
var exists252 = /* @__PURE__ */ dual252(2, (self2, refinement) => isNone2252(self2) ? false : refinement(self2.value));
var bindTo2252 = /* @__PURE__ */ bindTo352(map252);
var let_2252 = /* @__PURE__ */ let_352(map252);
var bind2252 = /* @__PURE__ */ bind352(map252, flatMap252);
var Do252 = /* @__PURE__ */ some3252({});
var adapter2252 = /* @__PURE__ */ adapter352();
var gen252 = (f232) => {
  const iterator = f232(adapter2252);
  let state = iterator.next();
  if (state.done) {
    return some3252(state.value);
  } else {
    let current = state.value;
    if (isGenKind252(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet252(current);
    }
    if (isNone2252(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind252(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet252(current);
        }
        if (isNone2252(current)) {
          return current;
        }
      }
    }
    return some3252(state.value);
  }
};
var fromIterable2252 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var reverse72 = (self2) => Array.from(self2).reverse();
var reduce82 = /* @__PURE__ */ dual252(3, (self2, b232, f232) => fromIterable2252(self2).reduce((b2222, a232, i232) => f232(b2222, a232, i232), b232));
var TagTypeId52 = /* @__PURE__ */ Symbol.for("effect/Context/Tag");
var STMSymbolKey52 = "effect/STM";
var STMTypeId52 = /* @__PURE__ */ Symbol.for(STMSymbolKey52);
var TagProto52 = {
  ...EffectPrototype252,
  _tag: "Tag",
  _op: "Tag",
  [STMTypeId52]: effectVariance252,
  [TagTypeId52]: {
    _Service: (_232) => _232,
    _Identifier: (_232) => _232
  },
  toString() {
    return format252(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Tag",
      key: this.key,
      stack: this.stack
    };
  },
  [NodeInspectSymbol252]() {
    return this.toJSON();
  },
  of(self2) {
    return self2;
  },
  context(self2) {
    return make3252(this, self2);
  }
};
var makeGenericTag52 = (key) => {
  const limit = Error.stackTraceLimit;
  Error.stackTraceLimit = 2;
  const creationError = new Error();
  Error.stackTraceLimit = limit;
  const tag = Object.create(TagProto52);
  Object.defineProperty(tag, "stack", {
    get() {
      return creationError.stack;
    }
  });
  tag.key = key;
  return tag;
};
var TypeId4252 = /* @__PURE__ */ Symbol.for("effect/Context");
var ContextProto52 = {
  [TypeId4252]: {
    _Services: (_232) => _232
  },
  [symbol2252](that) {
    if (isContext52(that)) {
      if (this.unsafeMap.size === that.unsafeMap.size) {
        for (const k232 of this.unsafeMap.keys()) {
          if (!that.unsafeMap.has(k232) || !equals252(this.unsafeMap.get(k232), that.unsafeMap.get(k232))) {
            return false;
          }
        }
        return true;
      }
    }
    return false;
  },
  [symbol352]() {
    return cached252(this, number252(this.unsafeMap.size));
  },
  pipe() {
    return pipeArguments252(this, arguments);
  },
  toString() {
    return format252(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Context",
      services: Array.from(this.unsafeMap).map(toJSON252)
    };
  },
  [NodeInspectSymbol252]() {
    return this.toJSON();
  }
};
var makeContext52 = (unsafeMap) => {
  const context = Object.create(ContextProto52);
  context.unsafeMap = unsafeMap;
  return context;
};
var isContext52 = (u232) => hasProperty252(u232, TypeId4252);
var _empty92 = /* @__PURE__ */ makeContext52(/* @__PURE__ */ new Map());
var empty142 = () => _empty92;
var make3252 = (tag, service) => makeContext52(/* @__PURE__ */ new Map([[tag.key, service]]));
var GenericTag52 = makeGenericTag52;
var empty252 = empty142;
var TypeId5252 = /* @__PURE__ */ Symbol.for("effect/Chunk");
function copy62(src, srcPos, dest, destPos, len) {
  for (let i232 = srcPos; i232 < Math.min(src.length, srcPos + len); i232++) {
    dest[destPos + i232 - srcPos] = src[i232];
  }
  return dest;
}
var emptyArray52 = [];
var getEquivalence2252 = (isEquivalent) => make452((self2, that) => self2.length === that.length && toReadonlyArray52(self2).every((value, i232) => isEquivalent(value, unsafeGet252(that, i232))));
var _equivalence2252 = /* @__PURE__ */ getEquivalence2252(equals252);
var ChunkProto52 = {
  [TypeId5252]: {
    _A: (_232) => _232
  },
  toString() {
    return format252(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Chunk",
      values: toReadonlyArray52(this).map(toJSON252)
    };
  },
  [NodeInspectSymbol252]() {
    return this.toJSON();
  },
  [symbol2252](that) {
    return isChunk52(that) && _equivalence2252(this, that);
  },
  [symbol352]() {
    return cached252(this, array102(toReadonlyArray52(this)));
  },
  [Symbol.iterator]() {
    switch (this.backing._tag) {
      case "IArray": {
        return this.backing.array[Symbol.iterator]();
      }
      case "IEmpty": {
        return emptyArray52[Symbol.iterator]();
      }
      default: {
        return toReadonlyArray52(this)[Symbol.iterator]();
      }
    }
  },
  pipe() {
    return pipeArguments252(this, arguments);
  }
};
var makeChunk52 = (backing) => {
  const chunk = Object.create(ChunkProto52);
  chunk.backing = backing;
  switch (backing._tag) {
    case "IEmpty": {
      chunk.length = 0;
      chunk.depth = 0;
      chunk.left = chunk;
      chunk.right = chunk;
      break;
    }
    case "IConcat": {
      chunk.length = backing.left.length + backing.right.length;
      chunk.depth = 1 + Math.max(backing.left.depth, backing.right.depth);
      chunk.left = backing.left;
      chunk.right = backing.right;
      break;
    }
    case "IArray": {
      chunk.length = backing.array.length;
      chunk.depth = 0;
      chunk.left = _empty252;
      chunk.right = _empty252;
      break;
    }
    case "ISingleton": {
      chunk.length = 1;
      chunk.depth = 0;
      chunk.left = _empty252;
      chunk.right = _empty252;
      break;
    }
    case "ISlice": {
      chunk.length = backing.length;
      chunk.depth = backing.chunk.depth + 1;
      chunk.left = _empty252;
      chunk.right = _empty252;
      break;
    }
  }
  return chunk;
};
var isChunk52 = (u232) => hasProperty252(u232, TypeId5252);
var _empty252 = /* @__PURE__ */ makeChunk52({
  _tag: "IEmpty"
});
var empty352 = () => _empty252;
var make4252 = (...as2242) => as2242.length === 1 ? of62(as2242[0]) : unsafeFromNonEmptyArray52(as2242);
var of62 = (a232) => makeChunk52({
  _tag: "ISingleton",
  a: a232
});
var copyToArray52 = (self2, array342, initial) => {
  switch (self2.backing._tag) {
    case "IArray": {
      copy62(self2.backing.array, 0, array342, initial, self2.length);
      break;
    }
    case "IConcat": {
      copyToArray52(self2.left, array342, initial);
      copyToArray52(self2.right, array342, initial + self2.left.length);
      break;
    }
    case "ISingleton": {
      array342[initial] = self2.backing.a;
      break;
    }
    case "ISlice": {
      let i232 = 0;
      let j232 = initial;
      while (i232 < self2.length) {
        array342[j232] = unsafeGet252(self2, i232);
        i232 += 1;
        j232 += 1;
      }
      break;
    }
  }
};
var toReadonlyArray52 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      return emptyArray52;
    }
    case "IArray": {
      return self2.backing.array;
    }
    default: {
      const arr = new Array(self2.length);
      copyToArray52(self2, arr, 0);
      self2.backing = {
        _tag: "IArray",
        array: arr
      };
      self2.left = _empty252;
      self2.right = _empty252;
      self2.depth = 0;
      return arr;
    }
  }
};
var reverse252 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty":
    case "ISingleton":
      return self2;
    case "IArray": {
      return makeChunk52({
        _tag: "IArray",
        array: reverse72(self2.backing.array)
      });
    }
    case "IConcat": {
      return makeChunk52({
        _tag: "IConcat",
        left: reverse252(self2.backing.right),
        right: reverse252(self2.backing.left)
      });
    }
    case "ISlice":
      return unsafeFromArray52(reverse72(toReadonlyArray52(self2)));
  }
};
var unsafeFromArray52 = (self2) => makeChunk52({
  _tag: "IArray",
  array: self2
});
var unsafeFromNonEmptyArray52 = (self2) => unsafeFromArray52(self2);
var unsafeGet252 = /* @__PURE__ */ dual252(2, (self2, index) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      throw new Error(`Index out of bounds`);
    }
    case "ISingleton": {
      if (index !== 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.a;
    }
    case "IArray": {
      if (index >= self2.length || index < 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.array[index];
    }
    case "IConcat": {
      return index < self2.left.length ? unsafeGet252(self2.left, index) : unsafeGet252(self2.right, index - self2.left.length);
    }
    case "ISlice": {
      return unsafeGet252(self2.backing.chunk, index + self2.backing.offset);
    }
  }
});
var prepend72 = /* @__PURE__ */ dual252(2, (self2, elem) => appendAll62(of62(elem), self2));
var drop62 = /* @__PURE__ */ dual252(2, (self2, n232) => {
  if (n232 <= 0) {
    return self2;
  } else if (n232 >= self2.length) {
    return _empty252;
  } else {
    switch (self2.backing._tag) {
      case "ISlice": {
        return makeChunk52({
          _tag: "ISlice",
          chunk: self2.backing.chunk,
          offset: self2.backing.offset + n232,
          length: self2.backing.length - n232
        });
      }
      case "IConcat": {
        if (n232 > self2.left.length) {
          return drop62(self2.right, n232 - self2.left.length);
        }
        return makeChunk52({
          _tag: "IConcat",
          left: drop62(self2.left, n232),
          right: self2.right
        });
      }
      default: {
        return makeChunk52({
          _tag: "ISlice",
          chunk: self2,
          offset: n232,
          length: self2.length - n232
        });
      }
    }
  }
});
var appendAll62 = /* @__PURE__ */ dual252(2, (self2, that) => {
  if (self2.backing._tag === "IEmpty") {
    return that;
  }
  if (that.backing._tag === "IEmpty") {
    return self2;
  }
  const diff242 = that.depth - self2.depth;
  if (Math.abs(diff242) <= 1) {
    return makeChunk52({
      _tag: "IConcat",
      left: self2,
      right: that
    });
  } else if (diff242 < -1) {
    if (self2.left.depth >= self2.right.depth) {
      const nr = appendAll62(self2.right, that);
      return makeChunk52({
        _tag: "IConcat",
        left: self2.left,
        right: nr
      });
    } else {
      const nrr = appendAll62(self2.right.right, that);
      if (nrr.depth === self2.depth - 3) {
        const nr = makeChunk52({
          _tag: "IConcat",
          left: self2.right.left,
          right: nrr
        });
        return makeChunk52({
          _tag: "IConcat",
          left: self2.left,
          right: nr
        });
      } else {
        const nl = makeChunk52({
          _tag: "IConcat",
          left: self2.left,
          right: self2.right.left
        });
        return makeChunk52({
          _tag: "IConcat",
          left: nl,
          right: nrr
        });
      }
    }
  } else {
    if (that.right.depth >= that.left.depth) {
      const nl = appendAll62(self2, that.left);
      return makeChunk52({
        _tag: "IConcat",
        left: nl,
        right: that.right
      });
    } else {
      const nll = appendAll62(self2, that.left.left);
      if (nll.depth === that.depth - 3) {
        const nl = makeChunk52({
          _tag: "IConcat",
          left: nll,
          right: that.left.right
        });
        return makeChunk52({
          _tag: "IConcat",
          left: nl,
          right: that.right
        });
      } else {
        const nr = makeChunk52({
          _tag: "IConcat",
          left: that.left.right,
          right: that.right
        });
        return makeChunk52({
          _tag: "IConcat",
          left: nll,
          right: nr
        });
      }
    }
  }
});
var isEmpty62 = (self2) => self2.length === 0;
var isNonEmpty52 = (self2) => self2.length > 0;
var unsafeHead52 = (self2) => unsafeGet252(self2, 0);
var headNonEmpty62 = unsafeHead52;
var tailNonEmpty62 = (self2) => drop62(self2, 1);
var SIZE52 = 5;
var BUCKET_SIZE52 = /* @__PURE__ */ Math.pow(2, SIZE52);
var MASK52 = BUCKET_SIZE52 - 1;
var MAX_INDEX_NODE52 = BUCKET_SIZE52 / 2;
var MIN_ARRAY_NODE52 = BUCKET_SIZE52 / 4;
function popcount52(x232) {
  x232 -= x232 >> 1 & 1431655765;
  x232 = (x232 & 858993459) + (x232 >> 2 & 858993459);
  x232 = x232 + (x232 >> 4) & 252645135;
  x232 += x232 >> 8;
  x232 += x232 >> 16;
  return x232 & 127;
}
function hashFragment52(shift22, h232) {
  return h232 >>> shift22 & MASK52;
}
function toBitmap52(x232) {
  return 1 << x232;
}
function fromBitmap52(bitmap, bit) {
  return popcount52(bitmap & bit - 1);
}
var make552 = (value, previous) => ({
  value,
  previous
});
function arrayUpdate52(mutate242, at, v232, arr) {
  let out = arr;
  if (!mutate242) {
    const len = arr.length;
    out = new Array(len);
    for (let i232 = 0; i232 < len; ++i232) out[i232] = arr[i232];
  }
  out[at] = v232;
  return out;
}
function arraySpliceOut52(mutate242, at, arr) {
  const newLen = arr.length - 1;
  let i232 = 0;
  let g232 = 0;
  let out = arr;
  if (mutate242) {
    i232 = g232 = at;
  } else {
    out = new Array(newLen);
    while (i232 < at) out[g232++] = arr[i232++];
  }
  ++i232;
  while (i232 <= newLen) out[g232++] = arr[i232++];
  if (mutate242) {
    out.length = newLen;
  }
  return out;
}
function arraySpliceIn52(mutate242, at, v232, arr) {
  const len = arr.length;
  if (mutate242) {
    let i2222 = len;
    while (i2222 >= at) arr[i2222--] = arr[i2222];
    arr[at] = v232;
    return arr;
  }
  let i232 = 0, g232 = 0;
  const out = new Array(len + 1);
  while (i232 < at) out[g232++] = arr[i232++];
  out[at] = v232;
  while (i232 < len) out[++g232] = arr[i232++];
  return out;
}
var EmptyNode52 = class _EmptyNode52 {
  _tag = "EmptyNode";
  modify(edit, _shift, f232, hash2242, key, size442) {
    const v232 = f232(none2252());
    if (isNone2252(v232)) return new _EmptyNode52();
    ++size442.value;
    return new LeafNode52(edit, hash2242, key, v232);
  }
};
function isEmptyNode52(a232) {
  return isTagged82(a232, "EmptyNode");
}
function isLeafNode52(node) {
  return isEmptyNode52(node) || node._tag === "LeafNode" || node._tag === "CollisionNode";
}
function canEditNode52(node, edit) {
  return isEmptyNode52(node) ? false : edit === node.edit;
}
var LeafNode52 = class _LeafNode52 {
  edit;
  hash;
  key;
  value;
  _tag = "LeafNode";
  constructor(edit, hash2242, key, value) {
    this.edit = edit;
    this.hash = hash2242;
    this.key = key;
    this.value = value;
  }
  modify(edit, shift22, f232, hash2242, key, size442) {
    if (equals252(key, this.key)) {
      const v2222 = f232(this.value);
      if (v2222 === this.value) return this;
      else if (isNone2252(v2222)) {
        --size442.value;
        return new EmptyNode52();
      }
      if (canEditNode52(this, edit)) {
        this.value = v2222;
        return this;
      }
      return new _LeafNode52(edit, hash2242, key, v2222);
    }
    const v232 = f232(none2252());
    if (isNone2252(v232)) return this;
    ++size442.value;
    return mergeLeaves52(edit, shift22, this.hash, this, hash2242, new _LeafNode52(edit, hash2242, key, v232));
  }
};
var CollisionNode52 = class _CollisionNode52 {
  edit;
  hash;
  children;
  _tag = "CollisionNode";
  constructor(edit, hash2242, children) {
    this.edit = edit;
    this.hash = hash2242;
    this.children = children;
  }
  modify(edit, shift22, f232, hash2242, key, size442) {
    if (hash2242 === this.hash) {
      const canEdit = canEditNode52(this, edit);
      const list = this.updateCollisionList(canEdit, edit, this.hash, this.children, f232, key, size442);
      if (list === this.children) return this;
      return list.length > 1 ? new _CollisionNode52(edit, this.hash, list) : list[0];
    }
    const v232 = f232(none2252());
    if (isNone2252(v232)) return this;
    ++size442.value;
    return mergeLeaves52(edit, shift22, this.hash, this, hash2242, new LeafNode52(edit, hash2242, key, v232));
  }
  updateCollisionList(mutate242, edit, hash2242, list, f232, key, size442) {
    const len = list.length;
    for (let i232 = 0; i232 < len; ++i232) {
      const child = list[i232];
      if ("key" in child && equals252(key, child.key)) {
        const value = child.value;
        const newValue2 = f232(value);
        if (newValue2 === value) return list;
        if (isNone2252(newValue2)) {
          --size442.value;
          return arraySpliceOut52(mutate242, i232, list);
        }
        return arrayUpdate52(mutate242, i232, new LeafNode52(edit, hash2242, key, newValue2), list);
      }
    }
    const newValue = f232(none2252());
    if (isNone2252(newValue)) return list;
    ++size442.value;
    return arrayUpdate52(mutate242, len, new LeafNode52(edit, hash2242, key, newValue), list);
  }
};
var IndexedNode52 = class _IndexedNode52 {
  edit;
  mask;
  children;
  _tag = "IndexedNode";
  constructor(edit, mask, children) {
    this.edit = edit;
    this.mask = mask;
    this.children = children;
  }
  modify(edit, shift22, f232, hash2242, key, size442) {
    const mask = this.mask;
    const children = this.children;
    const frag = hashFragment52(shift22, hash2242);
    const bit = toBitmap52(frag);
    const indx = fromBitmap52(mask, bit);
    const exists2242 = mask & bit;
    const canEdit = canEditNode52(this, edit);
    if (!exists2242) {
      const _newChild = new EmptyNode52().modify(edit, shift22 + SIZE52, f232, hash2242, key, size442);
      if (!_newChild) return this;
      return children.length >= MAX_INDEX_NODE52 ? expand52(edit, frag, _newChild, mask, children) : new _IndexedNode52(edit, mask | bit, arraySpliceIn52(canEdit, indx, _newChild, children));
    }
    const current = children[indx];
    const child = current.modify(edit, shift22 + SIZE52, f232, hash2242, key, size442);
    if (current === child) return this;
    let bitmap = mask;
    let newChildren;
    if (isEmptyNode52(child)) {
      bitmap &= ~bit;
      if (!bitmap) return new EmptyNode52();
      if (children.length <= 2 && isLeafNode52(children[indx ^ 1])) {
        return children[indx ^ 1];
      }
      newChildren = arraySpliceOut52(canEdit, indx, children);
    } else {
      newChildren = arrayUpdate52(canEdit, indx, child, children);
    }
    if (canEdit) {
      this.mask = bitmap;
      this.children = newChildren;
      return this;
    }
    return new _IndexedNode52(edit, bitmap, newChildren);
  }
};
var ArrayNode52 = class _ArrayNode52 {
  edit;
  size;
  children;
  _tag = "ArrayNode";
  constructor(edit, size442, children) {
    this.edit = edit;
    this.size = size442;
    this.children = children;
  }
  modify(edit, shift22, f232, hash2242, key, size442) {
    let count = this.size;
    const children = this.children;
    const frag = hashFragment52(shift22, hash2242);
    const child = children[frag];
    const newChild = (child || new EmptyNode52()).modify(edit, shift22 + SIZE52, f232, hash2242, key, size442);
    if (child === newChild) return this;
    const canEdit = canEditNode52(this, edit);
    let newChildren;
    if (isEmptyNode52(child) && !isEmptyNode52(newChild)) {
      ++count;
      newChildren = arrayUpdate52(canEdit, frag, newChild, children);
    } else if (!isEmptyNode52(child) && isEmptyNode52(newChild)) {
      --count;
      if (count <= MIN_ARRAY_NODE52) {
        return pack52(edit, count, frag, children);
      }
      newChildren = arrayUpdate52(canEdit, frag, new EmptyNode52(), children);
    } else {
      newChildren = arrayUpdate52(canEdit, frag, newChild, children);
    }
    if (canEdit) {
      this.size = count;
      this.children = newChildren;
      return this;
    }
    return new _ArrayNode52(edit, count, newChildren);
  }
};
function pack52(edit, count, removed, elements) {
  const children = new Array(count - 1);
  let g232 = 0;
  let bitmap = 0;
  for (let i232 = 0, len = elements.length; i232 < len; ++i232) {
    if (i232 !== removed) {
      const elem = elements[i232];
      if (elem && !isEmptyNode52(elem)) {
        children[g232++] = elem;
        bitmap |= 1 << i232;
      }
    }
  }
  return new IndexedNode52(edit, bitmap, children);
}
function expand52(edit, frag, child, bitmap, subNodes) {
  const arr = [];
  let bit = bitmap;
  let count = 0;
  for (let i232 = 0; bit; ++i232) {
    if (bit & 1) arr[i232] = subNodes[count++];
    bit >>>= 1;
  }
  arr[frag] = child;
  return new ArrayNode52(edit, count + 1, arr);
}
function mergeLeavesInner52(edit, shift22, h1, n1, h232, n232) {
  if (h1 === h232) return new CollisionNode52(edit, h1, [n232, n1]);
  const subH1 = hashFragment52(shift22, h1);
  const subH2 = hashFragment52(shift22, h232);
  if (subH1 === subH2) {
    return (child) => new IndexedNode52(edit, toBitmap52(subH1) | toBitmap52(subH2), [child]);
  } else {
    const children = subH1 < subH2 ? [n1, n232] : [n232, n1];
    return new IndexedNode52(edit, toBitmap52(subH1) | toBitmap52(subH2), children);
  }
}
function mergeLeaves52(edit, shift22, h1, n1, h232, n232) {
  let stack = void 0;
  let currentShift = shift22;
  while (true) {
    const res = mergeLeavesInner52(edit, currentShift, h1, n1, h232, n232);
    if (typeof res === "function") {
      stack = make552(res, stack);
      currentShift = currentShift + SIZE52;
    } else {
      let final = res;
      while (stack != null) {
        final = stack.value(final);
        stack = stack.previous;
      }
      return final;
    }
  }
}
var HashMapSymbolKey52 = "effect/HashMap";
var HashMapTypeId52 = /* @__PURE__ */ Symbol.for(HashMapSymbolKey52);
var HashMapProto52 = {
  [HashMapTypeId52]: HashMapTypeId52,
  [Symbol.iterator]() {
    return new HashMapIterator52(this, (k232, v232) => [k232, v232]);
  },
  [symbol352]() {
    let hash2242 = hash252(HashMapSymbolKey52);
    for (const item of this) {
      hash2242 ^= pipe252(hash252(item[0]), combine252(hash252(item[1])));
    }
    return cached252(this, hash2242);
  },
  [symbol2252](that) {
    if (isHashMap52(that)) {
      if (that._size !== this._size) {
        return false;
      }
      for (const item of this) {
        const elem = pipe252(that, getHash52(item[0], hash252(item[0])));
        if (isNone2252(elem)) {
          return false;
        } else {
          if (!equals252(item[1], elem.value)) {
            return false;
          }
        }
      }
      return true;
    }
    return false;
  },
  toString() {
    return format252(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashMap",
      values: Array.from(this).map(toJSON252)
    };
  },
  [NodeInspectSymbol252]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments252(this, arguments);
  }
};
var makeImpl62 = (editable, edit, root, size442) => {
  const map622 = Object.create(HashMapProto52);
  map622._editable = editable;
  map622._edit = edit;
  map622._root = root;
  map622._size = size442;
  return map622;
};
var HashMapIterator52 = class _HashMapIterator52 {
  map;
  f;
  v;
  constructor(map622, f232) {
    this.map = map622;
    this.f = f232;
    this.v = visitLazy52(this.map._root, this.f, void 0);
  }
  next() {
    if (isNone2252(this.v)) {
      return {
        done: true,
        value: void 0
      };
    }
    const v0 = this.v.value;
    this.v = applyCont52(v0.cont);
    return {
      done: false,
      value: v0.value
    };
  }
  [Symbol.iterator]() {
    return new _HashMapIterator52(this.map, this.f);
  }
};
var applyCont52 = (cont) => cont ? visitLazyChildren52(cont[0], cont[1], cont[2], cont[3], cont[4]) : none2252();
var visitLazy52 = (node, f232, cont = void 0) => {
  switch (node._tag) {
    case "LeafNode": {
      if (isSome2252(node.value)) {
        return some3252({
          value: f232(node.key, node.value.value),
          cont
        });
      }
      return applyCont52(cont);
    }
    case "CollisionNode":
    case "ArrayNode":
    case "IndexedNode": {
      const children = node.children;
      return visitLazyChildren52(children.length, children, 0, f232, cont);
    }
    default: {
      return applyCont52(cont);
    }
  }
};
var visitLazyChildren52 = (len, children, i232, f232, cont) => {
  while (i232 < len) {
    const child = children[i232++];
    if (child && !isEmptyNode52(child)) {
      return visitLazy52(child, f232, [len, children, i232, f232, cont]);
    }
  }
  return applyCont52(cont);
};
var _empty352 = /* @__PURE__ */ makeImpl62(false, 0, /* @__PURE__ */ new EmptyNode52(), 0);
var empty452 = () => _empty352;
var isHashMap52 = (u232) => hasProperty252(u232, HashMapTypeId52);
var getHash52 = /* @__PURE__ */ dual252(3, (self2, key, hash2242) => {
  let node = self2._root;
  let shift22 = 0;
  while (true) {
    switch (node._tag) {
      case "LeafNode": {
        return equals252(key, node.key) ? node.value : none2252();
      }
      case "CollisionNode": {
        if (hash2242 === node.hash) {
          const children = node.children;
          for (let i232 = 0, len = children.length; i232 < len; ++i232) {
            const child = children[i232];
            if ("key" in child && equals252(key, child.key)) {
              return child.value;
            }
          }
        }
        return none2252();
      }
      case "IndexedNode": {
        const frag = hashFragment52(shift22, hash2242);
        const bit = toBitmap52(frag);
        if (node.mask & bit) {
          node = node.children[fromBitmap52(node.mask, bit)];
          shift22 += SIZE52;
          break;
        }
        return none2252();
      }
      case "ArrayNode": {
        node = node.children[hashFragment52(shift22, hash2242)];
        if (node) {
          shift22 += SIZE52;
          break;
        }
        return none2252();
      }
      default:
        return none2252();
    }
  }
});
var set252 = /* @__PURE__ */ dual252(3, (self2, key, value) => modifyAt52(self2, key, () => some3252(value)));
var setTree52 = /* @__PURE__ */ dual252(3, (self2, newRoot, newSize) => {
  if (self2._editable) {
    self2._root = newRoot;
    self2._size = newSize;
    return self2;
  }
  return newRoot === self2._root ? self2 : makeImpl62(self2._editable, self2._edit, newRoot, newSize);
});
var keys62 = (self2) => new HashMapIterator52(self2, (key) => key);
var size72 = (self2) => self2._size;
var beginMutation62 = (self2) => makeImpl62(true, self2._edit + 1, self2._root, self2._size);
var modifyAt52 = /* @__PURE__ */ dual252(3, (self2, key, f232) => modifyHash52(self2, key, hash252(key), f232));
var modifyHash52 = /* @__PURE__ */ dual252(4, (self2, key, hash2242, f232) => {
  const size442 = {
    value: self2._size
  };
  const newRoot = self2._root.modify(self2._editable ? self2._edit : NaN, 0, f232, hash2242, key, size442);
  return pipe252(self2, setTree52(newRoot, size442.value));
});
var forEach82 = /* @__PURE__ */ dual252(2, (self2, f232) => reduce252(self2, void 0, (_232, value, key) => f232(value, key)));
var reduce252 = /* @__PURE__ */ dual252(3, (self2, zero, f232) => {
  const root = self2._root;
  if (root._tag === "LeafNode") {
    return isSome2252(root.value) ? f232(zero, root.value.value, root.key) : zero;
  }
  if (root._tag === "EmptyNode") {
    return zero;
  }
  const toVisit = [root.children];
  let children;
  while (children = toVisit.pop()) {
    for (let i232 = 0, len = children.length; i232 < len; ) {
      const child = children[i232++];
      if (child && !isEmptyNode52(child)) {
        if (child._tag === "LeafNode") {
          if (isSome2252(child.value)) {
            zero = f232(zero, child.value.value, child.key);
          }
        } else {
          toVisit.push(child.children);
        }
      }
    }
  }
  return zero;
});
var HashSetSymbolKey52 = "effect/HashSet";
var HashSetTypeId52 = /* @__PURE__ */ Symbol.for(HashSetSymbolKey52);
var HashSetProto52 = {
  [HashSetTypeId52]: HashSetTypeId52,
  [Symbol.iterator]() {
    return keys62(this._keyMap);
  },
  [symbol352]() {
    return cached252(this, combine252(hash252(this._keyMap))(hash252(HashSetSymbolKey52)));
  },
  [symbol2252](that) {
    if (isHashSet52(that)) {
      return size72(this._keyMap) === size72(that._keyMap) && equals252(this._keyMap, that._keyMap);
    }
    return false;
  },
  toString() {
    return format252(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashSet",
      values: Array.from(this).map(toJSON252)
    };
  },
  [NodeInspectSymbol252]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments252(this, arguments);
  }
};
var makeImpl252 = (keyMap) => {
  const set2242 = Object.create(HashSetProto52);
  set2242._keyMap = keyMap;
  return set2242;
};
var isHashSet52 = (u232) => hasProperty252(u232, HashSetTypeId52);
var _empty452 = /* @__PURE__ */ makeImpl252(/* @__PURE__ */ empty452());
var empty552 = () => _empty452;
var size252 = (self2) => size72(self2._keyMap);
var beginMutation252 = (self2) => makeImpl252(beginMutation62(self2._keyMap));
var endMutation52 = (self2) => {
  self2._keyMap._editable = false;
  return self2;
};
var mutate52 = /* @__PURE__ */ dual252(2, (self2, f232) => {
  const transient = beginMutation252(self2);
  f232(transient);
  return endMutation52(transient);
});
var add252 = /* @__PURE__ */ dual252(2, (self2, value) => self2._keyMap._editable ? (set252(value, true)(self2._keyMap), self2) : makeImpl252(set252(value, true)(self2._keyMap)));
var union252 = /* @__PURE__ */ dual252(2, (self2, that) => mutate52(empty552(), (set2242) => {
  forEach252(self2, (value) => add252(set2242, value));
  for (const value of that) {
    add252(set2242, value);
  }
}));
var forEach252 = /* @__PURE__ */ dual252(2, (self2, f232) => forEach82(self2._keyMap, (_232, k232) => f232(k232)));
var empty652 = empty552;
var size352 = size252;
var add352 = add252;
var union352 = union252;
var ArrayProto52 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(Array.prototype), {
  [symbol352]() {
    return cached252(this, array102(this));
  },
  [symbol2252](that) {
    if (Array.isArray(that) && this.length === that.length) {
      return this.every((v232, i232) => equals252(v232, that[i232]));
    } else {
      return false;
    }
  }
});
var Structural62 = /* @__PURE__ */ function() {
  function Structural342(args) {
    if (args) {
      Object.assign(this, args);
    }
  }
  Structural342.prototype = StructuralPrototype242;
  return Structural342;
}();
var struct252 = (as2242) => Object.assign(Object.create(StructuralPrototype242), as2242);
var ContextPatchTypeId52 = /* @__PURE__ */ Symbol.for("effect/DifferContextPatch");
function variance62(a232) {
  return a232;
}
var PatchProto52 = {
  ...Structural62.prototype,
  [ContextPatchTypeId52]: {
    _Value: variance62,
    _Patch: variance62
  }
};
var EmptyProto52 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto52), {
  _tag: "Empty"
});
var _empty552 = /* @__PURE__ */ Object.create(EmptyProto52);
var empty752 = () => _empty552;
var AndThenProto52 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto52), {
  _tag: "AndThen"
});
var makeAndThen52 = (first, second) => {
  const o232 = Object.create(AndThenProto52);
  o232.first = first;
  o232.second = second;
  return o232;
};
var AddServiceProto52 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto52), {
  _tag: "AddService"
});
var makeAddService52 = (key, service) => {
  const o232 = Object.create(AddServiceProto52);
  o232.key = key;
  o232.service = service;
  return o232;
};
var RemoveServiceProto52 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto52), {
  _tag: "RemoveService"
});
var makeRemoveService52 = (key) => {
  const o232 = Object.create(RemoveServiceProto52);
  o232.key = key;
  return o232;
};
var UpdateServiceProto52 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto52), {
  _tag: "UpdateService"
});
var makeUpdateService52 = (key, update222) => {
  const o232 = Object.create(UpdateServiceProto52);
  o232.key = key;
  o232.update = update222;
  return o232;
};
var diff52 = (oldValue, newValue) => {
  const missingServices = new Map(oldValue.unsafeMap);
  let patch242 = empty752();
  for (const [tag, newService] of newValue.unsafeMap.entries()) {
    if (missingServices.has(tag)) {
      const old = missingServices.get(tag);
      missingServices.delete(tag);
      if (!equals252(old, newService)) {
        patch242 = combine2252(makeUpdateService52(tag, () => newService))(patch242);
      }
    } else {
      missingServices.delete(tag);
      patch242 = combine2252(makeAddService52(tag, newService))(patch242);
    }
  }
  for (const [tag] of missingServices.entries()) {
    patch242 = combine2252(makeRemoveService52(tag))(patch242);
  }
  return patch242;
};
var combine2252 = /* @__PURE__ */ dual252(2, (self2, that) => makeAndThen52(self2, that));
var patch52 = /* @__PURE__ */ dual252(2, (self2, context) => {
  if (self2._tag === "Empty") {
    return context;
  }
  let wasServiceUpdated = false;
  let patches = of62(self2);
  const updatedContext = new Map(context.unsafeMap);
  while (isNonEmpty52(patches)) {
    const head222 = headNonEmpty62(patches);
    const tail42 = tailNonEmpty62(patches);
    switch (head222._tag) {
      case "Empty": {
        patches = tail42;
        break;
      }
      case "AddService": {
        updatedContext.set(head222.key, head222.service);
        patches = tail42;
        break;
      }
      case "AndThen": {
        patches = prepend72(prepend72(tail42, head222.second), head222.first);
        break;
      }
      case "RemoveService": {
        updatedContext.delete(head222.key);
        patches = tail42;
        break;
      }
      case "UpdateService": {
        updatedContext.set(head222.key, head222.update(updatedContext.get(head222.key)));
        wasServiceUpdated = true;
        patches = tail42;
        break;
      }
    }
  }
  if (!wasServiceUpdated) {
    return makeContext52(updatedContext);
  }
  const map622 = /* @__PURE__ */ new Map();
  for (const [tag] of context.unsafeMap) {
    if (updatedContext.has(tag)) {
      map622.set(tag, updatedContext.get(tag));
      updatedContext.delete(tag);
    }
  }
  for (const [tag, s232] of updatedContext) {
    map622.set(tag, s232);
  }
  return makeContext52(map622);
});
var DifferTypeId52 = /* @__PURE__ */ Symbol.for("effect/Differ");
var DifferProto52 = {
  [DifferTypeId52]: {
    _P: identity252,
    _V: identity252
  }
};
var make752 = (params) => {
  const differ = Object.create(DifferProto52);
  differ.empty = params.empty;
  differ.diff = params.diff;
  differ.combine = params.combine;
  differ.patch = params.patch;
  return differ;
};
var environment52 = () => make752({
  empty: empty752(),
  combine: (first, second) => combine2252(second)(first),
  diff: (oldValue, newValue) => diff52(oldValue, newValue),
  patch: (patch242, oldValue) => patch52(oldValue)(patch242)
});
var OP_DIE52 = "Die";
var OP_EMPTY52 = "Empty";
var OP_FAIL52 = "Fail";
var OP_INTERRUPT52 = "Interrupt";
var OP_PARALLEL52 = "Parallel";
var OP_SEQUENTIAL52 = "Sequential";
var CauseSymbolKey52 = "effect/Cause";
var CauseTypeId52 = /* @__PURE__ */ Symbol.for(CauseSymbolKey52);
var variance252 = {
  /* c8 ignore next */
  _E: (_232) => _232
};
var proto52 = {
  [CauseTypeId52]: variance252,
  [symbol352]() {
    return pipe252(hash252(CauseSymbolKey52), combine252(hash252(flattenCause52(this))), cached252(this));
  },
  [symbol2252](that) {
    return isCause52(that) && causeEquals52(this, that);
  },
  pipe() {
    return pipeArguments252(this, arguments);
  },
  toJSON() {
    switch (this._tag) {
      case "Empty":
        return {
          _id: "Cause",
          _tag: this._tag
        };
      case "Die":
        return {
          _id: "Cause",
          _tag: this._tag,
          defect: toJSON252(this.defect)
        };
      case "Interrupt":
        return {
          _id: "Cause",
          _tag: this._tag,
          fiberId: this.fiberId.toJSON()
        };
      case "Fail":
        return {
          _id: "Cause",
          _tag: this._tag,
          failure: toJSON252(this.error)
        };
      case "Sequential":
      case "Parallel":
        return {
          _id: "Cause",
          _tag: this._tag,
          left: toJSON252(this.left),
          right: toJSON252(this.right)
        };
    }
  },
  toString() {
    return pretty52(this);
  },
  [NodeInspectSymbol252]() {
    return this.toJSON();
  }
};
var fail62 = (error) => {
  const o232 = Object.create(proto52);
  o232._tag = OP_FAIL52;
  o232.error = error;
  return o232;
};
var parallel52 = (left342, right342) => {
  const o232 = Object.create(proto52);
  o232._tag = OP_PARALLEL52;
  o232.left = left342;
  o232.right = right342;
  return o232;
};
var sequential52 = (left342, right342) => {
  const o232 = Object.create(proto52);
  o232._tag = OP_SEQUENTIAL52;
  o232.left = left342;
  o232.right = right342;
  return o232;
};
var isCause52 = (u232) => hasProperty252(u232, CauseTypeId52);
var isInterruptedOnly52 = (self2) => reduceWithContext52(void 0, IsInterruptedOnlyCauseReducer52)(self2);
var causeEquals52 = (left342, right342) => {
  let leftStack = of62(left342);
  let rightStack = of62(right342);
  while (isNonEmpty52(leftStack) && isNonEmpty52(rightStack)) {
    const [leftParallel, leftSequential] = pipe252(headNonEmpty62(leftStack), reduce452([empty652(), empty352()], ([parallel242, sequential242], cause) => {
      const [par, seq] = evaluateCause52(cause);
      return some3252([pipe252(parallel242, union352(par)), pipe252(sequential242, appendAll62(seq))]);
    }));
    const [rightParallel, rightSequential] = pipe252(headNonEmpty62(rightStack), reduce452([empty652(), empty352()], ([parallel242, sequential242], cause) => {
      const [par, seq] = evaluateCause52(cause);
      return some3252([pipe252(parallel242, union352(par)), pipe252(sequential242, appendAll62(seq))]);
    }));
    if (!equals252(leftParallel, rightParallel)) {
      return false;
    }
    leftStack = leftSequential;
    rightStack = rightSequential;
  }
  return true;
};
var flattenCause52 = (cause) => {
  return flattenCauseLoop52(of62(cause), empty352());
};
var flattenCauseLoop52 = (causes, flattened) => {
  while (1) {
    const [parallel242, sequential242] = pipe252(causes, reduce82([empty652(), empty352()], ([parallel322, sequential322], cause) => {
      const [par, seq] = evaluateCause52(cause);
      return [pipe252(parallel322, union352(par)), pipe252(sequential322, appendAll62(seq))];
    }));
    const updated = size352(parallel242) > 0 ? pipe252(flattened, prepend72(parallel242)) : flattened;
    if (isEmpty62(sequential242)) {
      return reverse252(updated);
    }
    causes = sequential242;
    flattened = updated;
  }
  throw new Error(getBugErrorMessage252("Cause.flattenCauseLoop"));
};
var evaluateCause52 = (self2) => {
  let cause = self2;
  const stack = [];
  let _parallel = empty652();
  let _sequential = empty352();
  while (cause !== void 0) {
    switch (cause._tag) {
      case OP_EMPTY52: {
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_FAIL52: {
        _parallel = add352(_parallel, make4252(cause._tag, cause.error));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_DIE52: {
        _parallel = add352(_parallel, make4252(cause._tag, cause.defect));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_INTERRUPT52: {
        _parallel = add352(_parallel, make4252(cause._tag, cause.fiberId));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_SEQUENTIAL52: {
        switch (cause.left._tag) {
          case OP_EMPTY52: {
            cause = cause.right;
            break;
          }
          case OP_SEQUENTIAL52: {
            cause = sequential52(cause.left.left, sequential52(cause.left.right, cause.right));
            break;
          }
          case OP_PARALLEL52: {
            cause = parallel52(sequential52(cause.left.left, cause.right), sequential52(cause.left.right, cause.right));
            break;
          }
          default: {
            _sequential = prepend72(_sequential, cause.right);
            cause = cause.left;
            break;
          }
        }
        break;
      }
      case OP_PARALLEL52: {
        stack.push(cause.right);
        cause = cause.left;
        break;
      }
    }
  }
  throw new Error(getBugErrorMessage252("Cause.evaluateCauseLoop"));
};
var IsInterruptedOnlyCauseReducer52 = {
  emptyCase: constTrue252,
  failCase: constFalse252,
  dieCase: constFalse252,
  interruptCase: constTrue252,
  sequentialCase: (_232, left342, right342) => left342 && right342,
  parallelCase: (_232, left342, right342) => left342 && right342
};
var OP_SEQUENTIAL_CASE52 = "SequentialCase";
var OP_PARALLEL_CASE52 = "ParallelCase";
var reduce452 = /* @__PURE__ */ dual252(3, (self2, zero, pf) => {
  let accumulator = zero;
  let cause = self2;
  const causes = [];
  while (cause !== void 0) {
    const option = pf(accumulator, cause);
    accumulator = isSome2252(option) ? option.value : accumulator;
    switch (cause._tag) {
      case OP_SEQUENTIAL52: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      case OP_PARALLEL52: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      default: {
        cause = void 0;
        break;
      }
    }
    if (cause === void 0 && causes.length > 0) {
      cause = causes.pop();
    }
  }
  return accumulator;
});
var reduceWithContext52 = /* @__PURE__ */ dual252(3, (self2, context, reducer) => {
  const input = [self2];
  const output = [];
  while (input.length > 0) {
    const cause = input.pop();
    switch (cause._tag) {
      case OP_EMPTY52: {
        output.push(right2252(reducer.emptyCase(context)));
        break;
      }
      case OP_FAIL52: {
        output.push(right2252(reducer.failCase(context, cause.error)));
        break;
      }
      case OP_DIE52: {
        output.push(right2252(reducer.dieCase(context, cause.defect)));
        break;
      }
      case OP_INTERRUPT52: {
        output.push(right2252(reducer.interruptCase(context, cause.fiberId)));
        break;
      }
      case OP_SEQUENTIAL52: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left2252({
          _tag: OP_SEQUENTIAL_CASE52
        }));
        break;
      }
      case OP_PARALLEL52: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left2252({
          _tag: OP_PARALLEL_CASE52
        }));
        break;
      }
    }
  }
  const accumulator = [];
  while (output.length > 0) {
    const either = output.pop();
    switch (either._tag) {
      case "Left": {
        switch (either.left._tag) {
          case OP_SEQUENTIAL_CASE52: {
            const left342 = accumulator.pop();
            const right342 = accumulator.pop();
            const value = reducer.sequentialCase(context, left342, right342);
            accumulator.push(value);
            break;
          }
          case OP_PARALLEL_CASE52: {
            const left342 = accumulator.pop();
            const right342 = accumulator.pop();
            const value = reducer.parallelCase(context, left342, right342);
            accumulator.push(value);
            break;
          }
        }
        break;
      }
      case "Right": {
        accumulator.push(either.right);
        break;
      }
    }
  }
  if (accumulator.length === 0) {
    throw new Error("BUG: Cause.reduceWithContext - please report an issue at https://github.com/Effect-TS/effect/issues");
  }
  return accumulator.pop();
});
var pretty52 = (cause) => {
  if (isInterruptedOnly52(cause)) {
    return "All fibers interrupted without errors.";
  }
  return prettyErrors52(cause).map((e232) => e232.stack).join("\n");
};
var PrettyError52 = class extends globalThis.Error {
  span = void 0;
  constructor(originalError) {
    const prevLimit = Error.stackTraceLimit;
    Error.stackTraceLimit = 0;
    super(prettyErrorMessage52(originalError));
    Error.stackTraceLimit = prevLimit;
    this.name = originalError instanceof Error ? originalError.name : "Error";
    if (typeof originalError === "object" && originalError !== null) {
      if (spanSymbol62 in originalError) {
        this.span = originalError[spanSymbol62];
      }
      Object.keys(originalError).forEach((key) => {
        if (!(key in this)) {
          this[key] = originalError[key];
        }
      });
    }
    this.stack = prettyErrorStack52(this.message, originalError instanceof Error && originalError.stack ? originalError.stack : "", this.span);
  }
  toJSON() {
    const out = {
      message: this.message,
      stack: this.stack
    };
    if (this.span) {
      out.span = this.span;
    }
    return out;
  }
};
var prettyErrorMessage52 = (u232) => {
  if (typeof u232 === "string") {
    return `Error: ${u232}`;
  }
  try {
    if (hasProperty252(u232, "toString") && isFunction3252(u232["toString"]) && u232["toString"] !== Object.prototype.toString && u232["toString"] !== globalThis.Array.prototype.toString) {
      return u232["toString"]();
    }
  } catch {
  }
  return `Error: ${JSON.stringify(u232)}`;
};
var locationRegex52 = /\((.*)\)/;
var spanToTrace52 = /* @__PURE__ */ globalValue252("effect/Tracer/spanToTrace", () => /* @__PURE__ */ new WeakMap());
var prettyErrorStack52 = (message, stack, span32) => {
  const out = [message];
  const lines = stack.split("\n");
  for (let i232 = 1; i232 < lines.length; i232++) {
    if (lines[i232].includes("Generator.next")) {
      break;
    }
    if (lines[i232].includes("effect_internal_function")) {
      out.pop();
      break;
    }
    out.push(lines[i232].replace(/at .*effect_instruction_i.*\((.*)\)/, "at $1").replace(/EffectPrimitive\.\w+/, "<anonymous>"));
  }
  if (span32) {
    let current = span32;
    let i232 = 0;
    while (current && current._tag === "Span" && i232 < 10) {
      const stackFn = spanToTrace52.get(current);
      if (typeof stackFn === "function") {
        const stack2 = stackFn();
        const locationMatch = stack2.match(locationRegex52);
        const location = locationMatch ? locationMatch[1] : stack2.replace(/^at /, "");
        out.push(`    at ${current.name} (${location})`);
      } else {
        out.push(`    at ${current.name}`);
      }
      current = getOrUndefined252(current.parent);
      i232++;
    }
  }
  return out.join("\n");
};
var spanSymbol62 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var prettyErrors52 = (cause) => reduceWithContext52(cause, void 0, {
  emptyCase: () => [],
  dieCase: (_232, unknownError) => {
    return [new PrettyError52(unknownError)];
  },
  failCase: (_232, error) => {
    return [new PrettyError52(error)];
  },
  interruptCase: () => [],
  parallelCase: (_232, l232, r232) => [...l232, ...r232],
  sequentialCase: (_232, l232, r232) => [...l232, ...r232]
});
var SingleShotGen2252 = class _SingleShotGen252 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  next(a232) {
    return this.called ? {
      value: a232,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  return(a232) {
    return {
      value: a232,
      done: true
    };
  }
  throw(e232) {
    throw e232;
  }
  [Symbol.iterator]() {
    return new _SingleShotGen252(this.self);
  }
};
var spanTag52 = /* @__PURE__ */ GenericTag52("effect/ParentSpan");
var EffectTypeId2252 = /* @__PURE__ */ Symbol.for("effect/Effect");
var EffectPrimitive52 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId2252] = effectVariance252;
  constructor(_op) {
    this._op = _op;
  }
  [symbol2252](that) {
    return this === that;
  }
  [symbol352]() {
    return cached252(this, random252(this));
  }
  pipe() {
    return pipeArguments252(this, arguments);
  }
  toJSON() {
    return {
      _id: "Effect",
      _op: this._op,
      effect_instruction_i0: toJSON252(this.effect_instruction_i0),
      effect_instruction_i1: toJSON252(this.effect_instruction_i1),
      effect_instruction_i2: toJSON252(this.effect_instruction_i2)
    };
  }
  toString() {
    return format252(this.toJSON());
  }
  [NodeInspectSymbol252]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen2252(new YieldWrap252(this));
  }
};
var EffectPrimitiveFailure52 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId2252] = effectVariance252;
  constructor(_op) {
    this._op = _op;
    this._tag = _op;
  }
  [symbol2252](that) {
    return exitIsExit52(that) && that._op === "Failure" && // @ts-expect-error
    equals252(this.effect_instruction_i0, that.effect_instruction_i0);
  }
  [symbol352]() {
    return pipe252(
      // @ts-expect-error
      string252(this._tag),
      // @ts-expect-error
      combine252(hash252(this.effect_instruction_i0)),
      cached252(this)
    );
  }
  get cause() {
    return this.effect_instruction_i0;
  }
  pipe() {
    return pipeArguments252(this, arguments);
  }
  toJSON() {
    return {
      _id: "Exit",
      _tag: this._op,
      cause: this.cause.toJSON()
    };
  }
  toString() {
    return format252(this.toJSON());
  }
  [NodeInspectSymbol252]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen2252(new YieldWrap252(this));
  }
};
var isEffect52 = (u232) => hasProperty252(u232, EffectTypeId2252);
var withFiberRuntime52 = (withRuntime) => {
  const effect = new EffectPrimitive52(OP_WITH_RUNTIME52);
  effect.effect_instruction_i0 = withRuntime;
  return effect;
};
var spanSymbol252 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var originalSymbol52 = /* @__PURE__ */ Symbol.for("effect/OriginalAnnotation");
var capture52 = (obj, span32) => {
  if (isSome2252(span32)) {
    return new Proxy(obj, {
      has(target, p232) {
        return p232 === spanSymbol252 || p232 === originalSymbol52 || p232 in target;
      },
      get(target, p232) {
        if (p232 === spanSymbol252) {
          return span32.value;
        }
        if (p232 === originalSymbol52) {
          return obj;
        }
        return target[p232];
      }
    });
  }
  return obj;
};
var fail252 = (error) => isObject252(error) && !(spanSymbol252 in error) ? withFiberRuntime52((fiber) => failCause52(fail62(capture52(error, currentSpanFromFiber52(fiber))))) : failCause52(fail62(error));
var failCause52 = (cause) => {
  const effect = new EffectPrimitiveFailure52(OP_FAILURE52);
  effect.effect_instruction_i0 = cause;
  return effect;
};
var FiberRefSymbolKey52 = "effect/FiberRef";
var FiberRefTypeId52 = /* @__PURE__ */ Symbol.for(FiberRefSymbolKey52);
var fiberRefVariance52 = {
  /* c8 ignore next */
  _A: (_232) => _232
};
var fiberRefUnsafeMakeContext52 = (initial) => {
  const differ = environment52();
  return fiberRefUnsafeMakePatch52(initial, {
    differ,
    fork: differ.empty
  });
};
var fiberRefUnsafeMakePatch52 = (initial, options) => ({
  [FiberRefTypeId52]: fiberRefVariance52,
  initial,
  diff: (oldValue, newValue) => options.differ.diff(oldValue, newValue),
  combine: (first, second) => options.differ.combine(first, second),
  patch: (patch242) => (oldValue) => options.differ.patch(patch242, oldValue),
  fork: options.fork,
  join: options.join ?? ((_232, n232) => n232),
  pipe() {
    return pipeArguments252(this, arguments);
  }
});
var currentContext52 = /* @__PURE__ */ globalValue252(/* @__PURE__ */ Symbol.for("effect/FiberRef/currentContext"), () => fiberRefUnsafeMakeContext52(empty252()));
var YieldableError52 = /* @__PURE__ */ function() {
  class YieldableError242 extends globalThis.Error {
    commit() {
      return fail252(this);
    }
    toString() {
      return this.message ? `${this.name}: ${this.message}` : this.name;
    }
    toJSON() {
      return {
        ...this
      };
    }
    [NodeInspectSymbol252]() {
      const stack = this.stack;
      if (stack) {
        return `${this.toString()}
${stack.split("\n").slice(1).join("\n")}`;
      }
      return this.toString();
    }
  }
  Object.assign(YieldableError242.prototype, StructuralCommitPrototype242);
  return YieldableError242;
}();
var exitIsExit52 = (u232) => isEffect52(u232) && "_tag" in u232 && (u232._tag === "Success" || u232._tag === "Failure");
var currentSpanFromFiber52 = (fiber) => {
  const span32 = fiber.getFiberRef(currentContext52).unsafeMap.get(spanTag52.key);
  return span32 !== void 0 && span32._tag === "Span" ? some3252(span32) : none2252();
};
var Data_exports242 = {};
__export252(Data_exports242, {
  Class: () => Class252,
  Error: () => Error252,
  Structural: () => Structural252,
  TaggedClass: () => TaggedClass52,
  TaggedError: () => TaggedError52,
  array: () => array252,
  case: () => _case52,
  struct: () => struct352,
  tagged: () => tagged52,
  taggedEnum: () => taggedEnum52,
  tuple: () => tuple252,
  unsafeArray: () => unsafeArray52,
  unsafeStruct: () => unsafeStruct52
});
var struct352 = struct252;
var unsafeStruct52 = (as2242) => Object.setPrototypeOf(as2242, StructuralPrototype242);
var tuple252 = (...as2242) => unsafeArray52(as2242);
var array252 = (as2242) => unsafeArray52(as2242.slice(0));
var unsafeArray52 = (as2242) => Object.setPrototypeOf(as2242, ArrayProto52);
var _case52 = () => (args) => args === void 0 ? Object.create(StructuralPrototype242) : struct352(args);
var tagged52 = (tag) => (args) => {
  const value = args === void 0 ? Object.create(StructuralPrototype242) : struct352(args);
  value._tag = tag;
  return value;
};
var Class252 = Structural62;
var TaggedClass52 = (tag) => {
  class Base extends Class252 {
    _tag = tag;
  }
  return Base;
};
var Structural252 = Structural62;
var taggedEnum52 = () => new Proxy({}, {
  get(_target, tag, _receiver) {
    if (tag === "$is") {
      return isTagged82;
    } else if (tag === "$match") {
      return taggedMatch52;
    }
    return tagged52(tag);
  }
});
function taggedMatch52() {
  if (arguments.length === 1) {
    const cases2 = arguments[0];
    return function(value2) {
      return cases2[value2._tag](value2);
    };
  }
  const value = arguments[0];
  const cases = arguments[1];
  return cases[value._tag](value);
}
var Error252 = /* @__PURE__ */ function() {
  return class Base extends YieldableError52 {
    constructor(args) {
      super();
      if (args) {
        Object.assign(this, args);
      }
    }
  };
}();
var TaggedError52 = (tag) => {
  class Base extends Error252 {
    _tag = tag;
  }
  Base.prototype.name = tag;
  return Base;
};
var traverseUp52 = Function_exports252.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType52.Program) return Option_exports252.none();
  return predicate(parent) ? Option_exports252.some(parent) : traverseUp52(parent, predicate);
});
var traverseUpGuard52 = Function_exports252.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType52.Program) return Option_exports252.none();
  return predicate(parent) ? Option_exports252.some(parent) : traverseUpGuard52(parent, predicate);
});
var ESLintCommunityESLintUtils52;
((ESLintCommunityESLintUtils242) => {
  ESLintCommunityESLintUtils242.getFunctionHeadLocation = getFunctionHeadLocation52;
  ESLintCommunityESLintUtils242.getFunctionNameWithKind = getFunctionNameWithKind52;
  ESLintCommunityESLintUtils242.getPropertyName = getPropertyName52;
  ESLintCommunityESLintUtils242.getStaticValue = getStaticValue52;
  ESLintCommunityESLintUtils242.getStringIfConstant = getStringIfConstant52;
  ESLintCommunityESLintUtils242.hasSideEffect = hasSideEffect52;
  ESLintCommunityESLintUtils242.isParenthesized = isParenthesized52;
})(ESLintCommunityESLintUtils52 || (ESLintCommunityESLintUtils52 = {}));
var Construction52 = Data_exports242.taggedEnum();
Construction52.None();
a42({
  type: N42.union([NodeType52.FunctionExpression, NodeType52.ArrowFunctionExpression]),
  parent: {
    type: NodeType52.Property,
    parent: {
      type: NodeType52.ObjectExpression
    }
  }
});
a42({
  type: N42.union([NodeType52.FunctionExpression, NodeType52.ArrowFunctionExpression]),
  parent: {
    type: NodeType52.MethodDefinition,
    parent: {
      type: NodeType52.ClassBody
    }
  }
});
a42({
  type: N42.union([NodeType52.FunctionExpression, NodeType52.ArrowFunctionExpression]),
  parent: {
    type: NodeType52.Property,
    parent: {
      type: NodeType52.ClassBody
    }
  }
});
function getVariableInit22(at) {
  return (variable) => {
    return Function_exports82.pipe(
      Option_exports82.some(variable),
      Option_exports82.flatMapNullable((v232) => v232.defs.at(at)),
      Option_exports82.flatMap(
        (d232) => "init" in d232.node ? Option_exports82.fromNullable(d232.node.init) : Option_exports82.none()
      )
    );
  };
}
var RULE_NAME210 = "no-dangerously-set-innerhtml";
var no_dangerously_set_innerhtml_default = createRule2({
  meta: {
    type: "problem",
    docs: {
      description: "disallow when a DOM component is using 'dangerouslySetInnerHTML'",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_DANGEROUSLY_SET_INNERHTML: "Using 'dangerouslySetInnerHTML' may have security implications."
    },
    schema: []
  },
  name: RULE_NAME210,
  create(context) {
    return {
      CallExpression(node) {
        const initialScope = context.sourceCode.getScope(node);
        if (node.arguments.length < 2 || !isCreateElementCall2(node, context)) return;
        const props = node.arguments[1];
        if (!props) return;
        const maybeProperties = $2(props).when(isOneOf6([NodeType6.ObjectExpression, NodeType6.ObjectPattern]), (n52) => {
          return "properties" in n52 ? Option_exports72.some(n52.properties) : Option_exports72.none();
        }).when(is6(NodeType6.Identifier), (n52) => {
          const initialScope2 = context.sourceCode.getScope(n52);
          return Function_exports72.pipe(
            findVariable52(n52.name, initialScope2),
            Option_exports72.flatMap(getVariableInit22(0)),
            Option_exports72.flatMap((n62) => "properties" in n62 ? Option_exports72.fromNullable(n62.properties) : Option_exports72.none())
          );
        }).otherwise(Option_exports72.none);
        if (Option_exports72.isNone(maybeProperties)) return;
        const properties = maybeProperties.value;
        const hasDanger = Option_exports72.isSome(findPropInProperties2(properties, context, initialScope)("dangerouslySetInnerHTML"));
        if (hasDanger) {
          context.report({
            messageId: "NO_DANGEROUSLY_SET_INNERHTML",
            node
          });
        }
      },
      JSXElement(node) {
        const initialScope = context.sourceCode.getScope(node);
        const maybeDanger = findPropInAttributes2(node.openingElement.attributes, context, initialScope)(
          "dangerouslySetInnerHTML"
        );
        if (Option_exports72.isSome(maybeDanger)) {
          context.report({
            messageId: "NO_DANGEROUSLY_SET_INNERHTML",
            node
          });
        }
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME310 = "no-dangerously-set-innerhtml-with-children";
function firstChildIsText(node) {
  const [firstChild] = node.children;
  return node.children.length > 0 && !Predicate_exports52.isNullable(firstChild) && !isLineBreak(firstChild);
}
var no_dangerously_set_innerhtml_with_children_default = createRule2({
  meta: {
    type: "problem",
    docs: {
      description: "disallow when a DOM component is using both 'children' and 'dangerouslySetInnerHTML'",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_DANGEROUSLY_SET_INNERHTML_WITH_CHILDREN: "A DOM component cannot use both 'children' and 'dangerouslySetInnerHTML'."
    },
    schema: []
  },
  name: RULE_NAME310,
  create(context) {
    return {
      CallExpression(node) {
        const initialScope = context.sourceCode.getScope(node);
        if (node.arguments.length < 2 || !isCreateElementCall2(node, context)) return;
        const props = node.arguments[1];
        const maybeProperties = $2(props).when(isOneOf6([NodeType6.ObjectExpression, NodeType6.ObjectPattern]), (n52) => {
          return "properties" in n52 ? Option_exports72.some(n52.properties) : Option_exports72.none();
        }).when(is6(NodeType6.Identifier), (n52) => {
          const initialScope2 = context.sourceCode.getScope(n52);
          return Function_exports72.pipe(
            findVariable52(n52.name, initialScope2),
            Option_exports72.flatMap(getVariableInit22(0)),
            Option_exports72.flatMap((n62) => "properties" in n62 ? Option_exports72.fromNullable(n62.properties) : Option_exports72.none())
          );
        }).otherwise(Option_exports72.none);
        if (Option_exports72.isNone(maybeProperties)) return;
        const properties = maybeProperties.value;
        const hasDanger = Option_exports72.isSome(findPropInProperties2(properties, context, initialScope)("dangerouslySetInnerHTML"));
        const hasRestChildren = node.arguments.length > 2;
        if (hasDanger && (hasRestChildren || Option_exports72.isSome(findPropInProperties2(properties, context, initialScope)("children")))) {
          context.report({
            messageId: "NO_DANGEROUSLY_SET_INNERHTML_WITH_CHILDREN",
            node
          });
        }
      },
      JSXElement(node) {
        const initialScope = context.sourceCode.getScope(node);
        const hasChildrenWithIn = () => hasChildren(node) && firstChildIsText(node);
        const hasChildrenProp = () => hasProp2(node.openingElement.attributes, "children", context, initialScope);
        const hasDanger = () => hasProp2(node.openingElement.attributes, "dangerouslySetInnerHTML", context, initialScope);
        if (!(hasChildrenWithIn() || hasChildrenProp()) || !hasDanger()) return;
        context.report({
          messageId: "NO_DANGEROUSLY_SET_INNERHTML_WITH_CHILDREN",
          node
        });
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME44 = "no-find-dom-node";
var no_find_dom_node_default = createRule2({
  meta: {
    type: "problem",
    docs: {
      description: "disallow 'findDOMNode'",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_FIND_DOM_NODE: "[Deprecated] Use alternatives instead."
    },
    schema: []
  },
  name: RULE_NAME44,
  create(context) {
    return {
      CallExpression(node) {
        const { callee } = node;
        const isFindDOMNode = $2(callee).with({ type: NodeType6.Identifier }, ({ name: name22 }) => name22 === "findDOMNode").with(
          { type: NodeType6.MemberExpression },
          ({ property }) => "name" in property && property.name === "findDOMNode"
        ).otherwise(Function_exports72.constFalse);
        if (!isFindDOMNode) return;
        context.report({
          messageId: "NO_FIND_DOM_NODE",
          node
        });
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME52 = "no-missing-button-type";
var no_missing_button_type_default = createRule2({
  meta: {
    type: "problem",
    docs: {
      description: "enforce that button component have an explicit 'type' attribute",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_MISSING_BUTTON_TYPE: "Add missing 'type' attribute on 'button' component."
    },
    schema: []
  },
  name: RULE_NAME52,
  create(context) {
    return {
      CallExpression(node) {
        const initialScope = context.sourceCode.getScope(node);
        if (!isCreateElementCall2(node, context)) return;
        const [name22, props] = node.arguments;
        if (!a5({ type: NodeType6.Literal, value: "button" }, name22)) return;
        if (!props || props.type !== NodeType6.ObjectExpression) {
          context.report({
            messageId: "NO_MISSING_BUTTON_TYPE",
            node: props ?? node
          });
          return;
        }
        const maybeTypeProperty = findPropInProperties2(props.properties, context, initialScope)("type");
        if (Option_exports72.isSome(maybeTypeProperty)) return;
        context.report({
          messageId: "NO_MISSING_BUTTON_TYPE",
          node: props
        });
      },
      JSXElement(node) {
        const { name: name22 } = node.openingElement;
        if (name22.type !== NodeType6.JSXIdentifier || name22.name !== "button") return;
        const { attributes } = node.openingElement;
        const initialScope = context.sourceCode.getScope(node);
        const maybeTypeAttribute = findPropInAttributes2(attributes, context, initialScope)("type");
        if (Option_exports72.isSome(maybeTypeAttribute)) return;
        context.report({
          messageId: "NO_MISSING_BUTTON_TYPE",
          node: node.openingElement
        });
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME62 = "no-missing-iframe-sandbox";
var validTypes = [
  "allow-downloads",
  "allow-downloads-without-user-activation",
  "allow-forms",
  "allow-modals",
  "allow-orientation-lock",
  "allow-pointer-lock",
  "allow-popups",
  "allow-popups-to-escape-sandbox",
  "allow-presentation",
  "allow-same-origin",
  "allow-scripts",
  "allow-storage-access-by-user-activation",
  "allow-top-navigation",
  "allow-top-navigation-by-user-activation",
  "allow-top-navigation-to-custom-protocols"
];
var no_missing_iframe_sandbox_default = createRule2({
  meta: {
    type: "problem",
    docs: {
      description: "enforce that 'iframe' component have an explicit 'sandbox' attribute",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_MISSING_IFRAME_SANDBOX: "Add missing 'sandbox' attribute on 'iframe' component."
    },
    schema: []
  },
  name: RULE_NAME62,
  create(context) {
    return {
      CallExpression(node) {
        const initialScope = context.sourceCode.getScope(node);
        if (!isCreateElementCall2(node, context)) return;
        const [name22, props] = node.arguments;
        if (!a5({ type: NodeType6.Literal, value: "iframe" }, name22)) return;
        if (!props || props.type !== NodeType6.ObjectExpression) {
          context.report({
            messageId: "NO_MISSING_IFRAME_SANDBOX",
            node: props ?? node
          });
          return;
        }
        const maybeSandboxProperty = findPropInProperties2(props.properties, context, initialScope)("sandbox");
        if (Option_exports72.isNone(maybeSandboxProperty)) {
          context.report({
            messageId: "NO_MISSING_IFRAME_SANDBOX",
            node: props
          });
          return;
        }
        const sandboxProperty = maybeSandboxProperty.value;
        const hasValidSandbox = a5({
          type: NodeType6.Property,
          value: {
            type: NodeType6.Literal,
            value: N4.union(...validTypes)
          }
        }, sandboxProperty);
        if (hasValidSandbox) return;
        context.report({
          messageId: "NO_MISSING_IFRAME_SANDBOX",
          node: sandboxProperty
        });
      },
      JSXElement(node) {
        const { name: name22 } = node.openingElement;
        if (name22.type !== NodeType6.JSXIdentifier || name22.name !== "iframe") return;
        const { attributes } = node.openingElement;
        const initialScope = context.sourceCode.getScope(node);
        const maybeSandboxAttribute = findPropInAttributes2(attributes, context, initialScope)("sandbox");
        if (Option_exports72.isNone(maybeSandboxAttribute)) {
          context.report({
            messageId: "NO_MISSING_IFRAME_SANDBOX",
            node: node.openingElement
          });
          return;
        }
        const sandboxAttribute = maybeSandboxAttribute.value;
        const hasValidSandbox = Function_exports72.pipe(
          getPropValue(sandboxAttribute, context),
          Option_exports72.flatMapNullable((v52) => v52?.value),
          Option_exports72.filter(Predicate_exports52.isString),
          Option_exports72.map((value) => value.split(" ")),
          Option_exports72.exists((values2) => values2.every((value) => validTypes.some((validType) => validType === value)))
        );
        if (hasValidSandbox) return;
        context.report({
          messageId: "NO_MISSING_IFRAME_SANDBOX",
          node: sandboxAttribute
        });
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME72 = "no-namespace";
var no_namespace_default = createRule2({
  meta: {
    type: "problem",
    docs: {
      description: "enforce that namespaces are not used in React elements"
    },
    messages: {
      NO_NAMESPACE: "A React component '{{name}}' must not be in a namespace, as React does not support them."
    },
    schema: []
  },
  name: RULE_NAME72,
  create(context) {
    return {
      CallExpression(node) {
        if (isCreateElementCall2(node, context) && node.arguments.length > 0 && node.arguments[0]?.type === types.AST_NODE_TYPES.Literal) {
          const name22 = node.arguments[0].value;
          if (!Predicate_exports52.isString(name22) || !name22.includes(":")) return;
          context.report({
            data: {
              name: name22
            },
            messageId: "NO_NAMESPACE",
            node
          });
        }
      },
      JSXOpeningElement(node) {
        const name22 = elementType(node);
        if (!Predicate_exports52.isString(name22) || !name22.includes(":")) return;
        context.report({
          data: {
            name: name22
          },
          messageId: "NO_NAMESPACE",
          node
        });
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME82 = "no-render-return-value";
var banParentTypes = [
  NodeType6.VariableDeclarator,
  NodeType6.Property,
  NodeType6.ReturnStatement,
  NodeType6.ArrowFunctionExpression,
  NodeType6.AssignmentExpression
];
var no_render_return_value_default = createRule2({
  meta: {
    type: "problem",
    docs: {
      description: "disallow usage of the return value of 'ReactDOM.render'",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_RENDER_RETURN_VALUE: "Do not depend on the return value from '{{objectName}}.render'."
    },
    schema: []
  },
  name: RULE_NAME82,
  create(context) {
    return {
      CallExpression(node) {
        const { callee, parent } = node;
        if (callee.type !== NodeType6.MemberExpression) return;
        if (callee.object.type !== NodeType6.Identifier) return;
        if (!("name" in callee.object)) return;
        const objectName = callee.object.name;
        if (objectName.toLowerCase() !== "reactdom" || callee.property.type !== NodeType6.Identifier || callee.property.name !== "render" || !isOneOf6(banParentTypes)(parent)) {
          return;
        }
        context.report({
          data: {
            objectName
          },
          messageId: "NO_RENDER_RETURN_VALUE",
          node
        });
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME92 = "no-script-url";
var no_script_url_default = createRule2({
  meta: {
    type: "problem",
    docs: {
      description: "disallow 'javascript:' URLs as JSX event handler prop's value",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_SCRIPT_URL: "Using a `javascript:` URL is a security risk and should be avoided."
    },
    schema: []
  },
  name: RULE_NAME92,
  create(context) {
    return {
      JSXAttribute(node) {
        if (node.name.type !== NodeType6.JSXIdentifier || !node.value) return;
        const isJavaScript = Function_exports72.pipe(
          getPropValue(node, context),
          Option_exports72.flatMapNullable((v52) => v52?.value),
          Option_exports72.filter(Predicate_exports52.isString),
          Option_exports72.exists((v52) => RE_JAVASCRIPT_PROTOCOL.test(v52))
        );
        if (isJavaScript) {
          context.report({
            messageId: "NO_SCRIPT_URL",
            node: node.value
          });
        }
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME102 = "no-unsafe-iframe-sandbox";
var unsafeCombinations = [
  ["allow-scripts", "allow-same-origin"]
  // ...
];
var no_unsafe_iframe_sandbox_default = createRule2({
  meta: {
    type: "problem",
    docs: {
      description: "disallow unsafe iframe 'sandbox' attribute combinations",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_UNSAFE_IFRAME_SANDBOX: "Unsafe 'sandbox' attribute value on 'iframe' component."
    },
    schema: []
  },
  name: RULE_NAME102,
  create(context) {
    return {
      CallExpression(node) {
        const initialScope = context.sourceCode.getScope(node);
        if (!isCreateElementCall2(node, context)) return;
        const [name22, props] = node.arguments;
        if (!a5({ type: NodeType6.Literal, value: "iframe" }, name22)) return;
        if (!props || props.type !== NodeType6.ObjectExpression) return;
        const maybeSandboxProperty = findPropInProperties2(props.properties, context, initialScope)("sandbox");
        if (Option_exports72.isNone(maybeSandboxProperty)) return;
        const isSafeSandboxValue = !Function_exports72.pipe(
          maybeSandboxProperty,
          Option_exports72.filter(a5({
            type: NodeType6.Property,
            value: {
              type: NodeType6.Literal,
              value: N4.string
            }
          })),
          Option_exports72.flatMapNullable((v52) => "value" in v52 ? v52.value : null),
          Option_exports72.flatMapNullable((v52) => "value" in v52 ? v52.value : null),
          Option_exports72.filter(Predicate_exports52.isString),
          Option_exports72.map((v52) => v52.split(" ")),
          Option_exports72.exists(
            (values2) => unsafeCombinations.some((combinations) => combinations.every((unsafeValue) => values2.includes(unsafeValue)))
          )
        );
        if (isSafeSandboxValue) return;
        context.report({
          messageId: "NO_UNSAFE_IFRAME_SANDBOX",
          node: maybeSandboxProperty.value
        });
      },
      JSXElement(node) {
        const { name: name22 } = node.openingElement;
        if (name22.type !== NodeType6.JSXIdentifier || name22.name !== "iframe") return;
        const { attributes } = node.openingElement;
        const initialScope = context.sourceCode.getScope(node);
        const maybeSandboxAttribute = findPropInAttributes2(attributes, context, initialScope)("sandbox");
        if (Option_exports72.isNone(maybeSandboxAttribute)) return;
        const isSafeSandboxValue = !Function_exports72.pipe(
          getPropValue(maybeSandboxAttribute.value, context),
          Option_exports72.flatMapNullable((v52) => v52?.value),
          Option_exports72.filter(Predicate_exports52.isString),
          Option_exports72.map((value) => value.split(" ")),
          Option_exports72.exists(
            (values2) => unsafeCombinations.some((combinations) => combinations.every((unsafeValue) => values2.includes(unsafeValue)))
          )
        );
        if (isSafeSandboxValue) return;
        context.report({
          messageId: "NO_UNSAFE_IFRAME_SANDBOX",
          node: maybeSandboxAttribute.value
        });
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME112 = "no-unsafe-target-blank";
function isExternalLinkLike(value) {
  return /^(?:\w+:|\/\/)/u.test(value);
}
function isSafeRel(value) {
  return /\bnoreferrer\b/u.test(value) && /\bnoopener\b/u.test(value);
}
var no_unsafe_target_blank_default = createRule2({
  meta: {
    type: "problem",
    docs: {
      description: `disallow 'target="_blank"' on an external link without 'rel="noreferrer noopener"'.`,
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      NO_UNSAFE_TARGET_BLANK: `Using 'target="_blank"' on an external link without 'rel="noreferrer noopener"' is a security risk.`
    },
    schema: []
  },
  name: RULE_NAME112,
  create(context) {
    return {
      JSXElement(node) {
        const { attributes } = node.openingElement;
        const initialScope = context.sourceCode.getScope(node);
        const hasTargetBlank = Function_exports72.pipe(
          findPropInAttributes2(attributes, context, initialScope)("target"),
          Option_exports72.flatMap((attr) => getPropValue(attr, context)),
          Option_exports72.exists((v52) => v52?.value === "_blank")
        );
        if (!hasTargetBlank) return;
        const hasExternalLinkLike = attributes.some((attr) => {
          if (attr.type !== NodeType6.JSXAttribute) return false;
          return Function_exports72.pipe(
            getPropValue(attr, context),
            Option_exports72.flatMapNullable((v52) => v52?.value),
            Option_exports72.filter(Predicate_exports52.isString),
            Option_exports72.exists(isExternalLinkLike)
          );
        });
        if (!hasExternalLinkLike) return;
        const hasUnsafeRel = !Function_exports72.pipe(
          findPropInAttributes2(attributes, context, initialScope)("rel"),
          Option_exports72.flatMap((attr) => getPropValue(attr, context)),
          Option_exports72.flatMapNullable((v52) => v52?.value),
          Option_exports72.filter(Predicate_exports52.isString),
          Option_exports72.exists(isSafeRel)
        );
        if (!hasUnsafeRel) return;
        context.report({
          messageId: "NO_UNSAFE_TARGET_BLANK",
          node
        });
      }
    };
  },
  defaultOptions: []
});
var meta2 = {
  name: name2,
  version: version2
};
var rules2 = {
  "no-children-in-void-dom-elements": no_children_in_void_dom_elements_default,
  "no-dangerously-set-innerhtml": no_dangerously_set_innerhtml_default,
  "no-dangerously-set-innerhtml-with-children": no_dangerously_set_innerhtml_with_children_default,
  "no-find-dom-node": no_find_dom_node_default,
  "no-missing-button-type": no_missing_button_type_default,
  "no-missing-iframe-sandbox": no_missing_iframe_sandbox_default,
  "no-namespace": no_namespace_default,
  "no-render-return-value": no_render_return_value_default,
  "no-script-url": no_script_url_default,
  "no-unsafe-iframe-sandbox": no_unsafe_iframe_sandbox_default,
  "no-unsafe-target-blank": no_unsafe_target_blank_default
};

// ../eslint-plugin-react-hooks-extra/dist/index.mjs
var dist_exports3 = {};
__export(dist_exports3, {
  meta: () => meta3,
  rules: () => rules3
});
var __create3 = Object.create;
var __defProp8 = Object.defineProperty;
var __getOwnPropDesc3 = Object.getOwnPropertyDescriptor;
var __getOwnPropNames3 = Object.getOwnPropertyNames;
var __getProtoOf3 = Object.getPrototypeOf;
var __hasOwnProp3 = Object.prototype.hasOwnProperty;
var __commonJS3 = (cb, mod) => function __require() {
  return mod || (0, cb[__getOwnPropNames3(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
};
var __export8 = (target, all123) => {
  for (var name22 in all123)
    __defProp8(target, name22, { get: all123[name22], enumerable: true });
};
var __copyProps3 = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames3(from))
      if (!__hasOwnProp3.call(to, key) && key !== except)
        __defProp8(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc3(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM3 = (mod, isNodeMode, target) => (target = mod != null ? __create3(__getProtoOf3(mod)) : {}, __copyProps3(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  __defProp8(target, "default", { value: mod, enumerable: true }),
  mod
));
var require_short_unique_id3 = __commonJS3({
  "../../../node_modules/.pnpm/short-unique-id@5.2.0/node_modules/short-unique-id/dist/short-unique-id.js"(exports, module) {
    var ShortUniqueId2 = (() => {
      var __defProp72 = Object.defineProperty;
      var __getOwnPropDesc22 = Object.getOwnPropertyDescriptor;
      var __getOwnPropNames22 = Object.getOwnPropertyNames;
      var __getOwnPropSymbols = Object.getOwnPropertySymbols;
      var __hasOwnProp22 = Object.prototype.hasOwnProperty;
      var __propIsEnum = Object.prototype.propertyIsEnumerable;
      var __defNormalProp = (obj, key, value) => key in obj ? __defProp72(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
      var __spreadValues = (a43, b43) => {
        for (var prop in b43 || (b43 = {}))
          if (__hasOwnProp22.call(b43, prop))
            __defNormalProp(a43, prop, b43[prop]);
        if (__getOwnPropSymbols)
          for (var prop of __getOwnPropSymbols(b43)) {
            if (__propIsEnum.call(b43, prop))
              __defNormalProp(a43, prop, b43[prop]);
          }
        return a43;
      };
      var __export72 = (target, all123) => {
        for (var name22 in all123)
          __defProp72(target, name22, { get: all123[name22], enumerable: true });
      };
      var __copyProps22 = (to, from, except, desc) => {
        if (from && typeof from === "object" || typeof from === "function") {
          for (let key of __getOwnPropNames22(from))
            if (!__hasOwnProp22.call(to, key) && key !== except)
              __defProp72(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc22(from, key)) || desc.enumerable });
        }
        return to;
      };
      var __toCommonJS = (mod) => __copyProps22(__defProp72({}, "__esModule", { value: true }), mod);
      var __publicField = (obj, key, value) => {
        __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
        return value;
      };
      var src_exports = {};
      __export72(src_exports, {
        DEFAULT_OPTIONS: () => DEFAULT_OPTIONS,
        DEFAULT_UUID_LENGTH: () => DEFAULT_UUID_LENGTH,
        default: () => ShortUniqueId3
      });
      var version22 = "5.2.0";
      var DEFAULT_UUID_LENGTH = 6;
      var DEFAULT_OPTIONS = {
        dictionary: "alphanum",
        shuffle: true,
        debug: false,
        length: DEFAULT_UUID_LENGTH,
        counter: 0
      };
      var _ShortUniqueId = class _ShortUniqueId {
        constructor(argOptions = {}) {
          __publicField(this, "counter");
          __publicField(this, "debug");
          __publicField(this, "dict");
          __publicField(this, "version");
          __publicField(this, "dictIndex", 0);
          __publicField(this, "dictRange", []);
          __publicField(this, "lowerBound", 0);
          __publicField(this, "upperBound", 0);
          __publicField(this, "dictLength", 0);
          __publicField(this, "uuidLength");
          __publicField(this, "_digit_first_ascii", 48);
          __publicField(this, "_digit_last_ascii", 58);
          __publicField(this, "_alpha_lower_first_ascii", 97);
          __publicField(this, "_alpha_lower_last_ascii", 123);
          __publicField(this, "_hex_last_ascii", 103);
          __publicField(this, "_alpha_upper_first_ascii", 65);
          __publicField(this, "_alpha_upper_last_ascii", 91);
          __publicField(this, "_number_dict_ranges", {
            digits: [this._digit_first_ascii, this._digit_last_ascii]
          });
          __publicField(this, "_alpha_dict_ranges", {
            lowerCase: [this._alpha_lower_first_ascii, this._alpha_lower_last_ascii],
            upperCase: [this._alpha_upper_first_ascii, this._alpha_upper_last_ascii]
          });
          __publicField(this, "_alpha_lower_dict_ranges", {
            lowerCase: [this._alpha_lower_first_ascii, this._alpha_lower_last_ascii]
          });
          __publicField(this, "_alpha_upper_dict_ranges", {
            upperCase: [this._alpha_upper_first_ascii, this._alpha_upper_last_ascii]
          });
          __publicField(this, "_alphanum_dict_ranges", {
            digits: [this._digit_first_ascii, this._digit_last_ascii],
            lowerCase: [this._alpha_lower_first_ascii, this._alpha_lower_last_ascii],
            upperCase: [this._alpha_upper_first_ascii, this._alpha_upper_last_ascii]
          });
          __publicField(this, "_alphanum_lower_dict_ranges", {
            digits: [this._digit_first_ascii, this._digit_last_ascii],
            lowerCase: [this._alpha_lower_first_ascii, this._alpha_lower_last_ascii]
          });
          __publicField(this, "_alphanum_upper_dict_ranges", {
            digits: [this._digit_first_ascii, this._digit_last_ascii],
            upperCase: [this._alpha_upper_first_ascii, this._alpha_upper_last_ascii]
          });
          __publicField(this, "_hex_dict_ranges", {
            decDigits: [this._digit_first_ascii, this._digit_last_ascii],
            alphaDigits: [this._alpha_lower_first_ascii, this._hex_last_ascii]
          });
          __publicField(this, "_dict_ranges", {
            _number_dict_ranges: this._number_dict_ranges,
            _alpha_dict_ranges: this._alpha_dict_ranges,
            _alpha_lower_dict_ranges: this._alpha_lower_dict_ranges,
            _alpha_upper_dict_ranges: this._alpha_upper_dict_ranges,
            _alphanum_dict_ranges: this._alphanum_dict_ranges,
            _alphanum_lower_dict_ranges: this._alphanum_lower_dict_ranges,
            _alphanum_upper_dict_ranges: this._alphanum_upper_dict_ranges,
            _hex_dict_ranges: this._hex_dict_ranges
          });
          __publicField(this, "log", (...args) => {
            const finalArgs = [...args];
            finalArgs[0] = `[short-unique-id] ${args[0]}`;
            if (this.debug === true) {
              if (typeof console !== "undefined" && console !== null) {
                return console.log(...finalArgs);
              }
            }
          });
          __publicField(this, "_normalizeDictionary", (dictionary2, shuffle2) => {
            let finalDict;
            if (dictionary2 && Array.isArray(dictionary2) && dictionary2.length > 1) {
              finalDict = dictionary2;
            } else {
              finalDict = [];
              let i43;
              this.dictIndex = i43 = 0;
              const rangesName = `_${dictionary2}_dict_ranges`;
              const ranges = this._dict_ranges[rangesName];
              Object.keys(ranges).forEach((rangeType) => {
                const rangeTypeKey = rangeType;
                this.dictRange = ranges[rangeTypeKey];
                this.lowerBound = this.dictRange[0];
                this.upperBound = this.dictRange[1];
                for (this.dictIndex = i43 = this.lowerBound; this.lowerBound <= this.upperBound ? i43 < this.upperBound : i43 > this.upperBound; this.dictIndex = this.lowerBound <= this.upperBound ? i43 += 1 : i43 -= 1) {
                  finalDict.push(String.fromCharCode(this.dictIndex));
                }
              });
            }
            if (shuffle2) {
              const PROBABILITY = 0.5;
              finalDict = finalDict.sort(() => Math.random() - PROBABILITY);
            }
            return finalDict;
          });
          __publicField(this, "setDictionary", (dictionary2, shuffle2) => {
            this.dict = this._normalizeDictionary(dictionary2, shuffle2);
            this.dictLength = this.dict.length;
            this.setCounter(0);
          });
          __publicField(this, "seq", () => {
            return this.sequentialUUID();
          });
          __publicField(this, "sequentialUUID", () => {
            let counterDiv;
            let counterRem;
            let id = "";
            counterDiv = this.counter;
            do {
              counterRem = counterDiv % this.dictLength;
              counterDiv = Math.trunc(counterDiv / this.dictLength);
              id += this.dict[counterRem];
            } while (counterDiv !== 0);
            this.counter += 1;
            return id;
          });
          __publicField(this, "rnd", (uuidLength = this.uuidLength || DEFAULT_UUID_LENGTH) => {
            return this.randomUUID(uuidLength);
          });
          __publicField(this, "randomUUID", (uuidLength = this.uuidLength || DEFAULT_UUID_LENGTH) => {
            let id;
            let randomPartIdx;
            let j43;
            if (uuidLength === null || typeof uuidLength === "undefined" || uuidLength < 1) {
              throw new Error("Invalid UUID Length Provided");
            }
            id = "";
            for (j43 = 0; j43 < uuidLength; j43 += 1) {
              randomPartIdx = parseInt(
                (Math.random() * this.dictLength).toFixed(0),
                10
              ) % this.dictLength;
              id += this.dict[randomPartIdx];
            }
            return id;
          });
          __publicField(this, "fmt", (format92, date) => {
            return this.formattedUUID(format92, date);
          });
          __publicField(this, "formattedUUID", (format92, date) => {
            const fnMap = {
              "$r": this.randomUUID,
              "$s": this.sequentialUUID,
              "$t": this.stamp
            };
            const result = format92.replace(
              /\$[rs]\d{0,}|\$t0|\$t[1-9]\d{1,}/g,
              (m43) => {
                const fn = m43.slice(0, 2);
                const len = parseInt(m43.slice(2), 10);
                if (fn === "$s") {
                  return fnMap[fn]().padStart(len, "0");
                }
                if (fn === "$t" && date) {
                  return fnMap[fn](len, date);
                }
                return fnMap[fn](len);
              }
            );
            return result;
          });
          __publicField(this, "availableUUIDs", (uuidLength = this.uuidLength) => {
            return parseFloat(
              Math.pow([...new Set(this.dict)].length, uuidLength).toFixed(0)
            );
          });
          __publicField(this, "approxMaxBeforeCollision", (rounds = this.availableUUIDs(this.uuidLength)) => {
            return parseFloat(
              Math.sqrt(Math.PI / 2 * rounds).toFixed(20)
            );
          });
          __publicField(this, "collisionProbability", (rounds = this.availableUUIDs(this.uuidLength), uuidLength = this.uuidLength) => {
            return parseFloat(
              (this.approxMaxBeforeCollision(rounds) / this.availableUUIDs(uuidLength)).toFixed(20)
            );
          });
          __publicField(this, "uniqueness", (rounds = this.availableUUIDs(this.uuidLength)) => {
            const score = parseFloat(
              (1 - this.approxMaxBeforeCollision(rounds) / rounds).toFixed(20)
            );
            return score > 1 ? 1 : score < 0 ? 0 : score;
          });
          __publicField(this, "getVersion", () => {
            return this.version;
          });
          __publicField(this, "stamp", (finalLength, date) => {
            const hexStamp = Math.floor(+(date || /* @__PURE__ */ new Date()) / 1e3).toString(16);
            if (typeof finalLength === "number" && finalLength === 0) {
              return hexStamp;
            }
            if (typeof finalLength !== "number" || finalLength < 10) {
              throw new Error(
                [
                  "Param finalLength must be a number greater than or equal to 10,",
                  "or 0 if you want the raw hexadecimal timestamp"
                ].join("\n")
              );
            }
            const idLength = finalLength - 9;
            const rndIdx = Math.round(Math.random() * (idLength > 15 ? 15 : idLength));
            const id = this.randomUUID(idLength);
            return `${id.substring(0, rndIdx)}${hexStamp}${id.substring(rndIdx)}${rndIdx.toString(16)}`;
          });
          __publicField(this, "parseStamp", (suid, format92) => {
            if (format92 && !/t0|t[1-9]\d{1,}/.test(format92)) {
              throw new Error("Cannot extract date from a formated UUID with no timestamp in the format");
            }
            const stamp = format92 ? format92.replace(
              /\$[rs]\d{0,}|\$t0|\$t[1-9]\d{1,}/g,
              (m43) => {
                const fnMap = {
                  "$r": (len2) => [...Array(len2)].map(() => "r").join(""),
                  "$s": (len2) => [...Array(len2)].map(() => "s").join(""),
                  "$t": (len2) => [...Array(len2)].map(() => "t").join("")
                };
                const fn = m43.slice(0, 2);
                const len = parseInt(m43.slice(2), 10);
                return fnMap[fn](len);
              }
            ).replace(
              /^(.*?)(t{8,})(.*)$/g,
              (_m, p1, p232) => {
                return suid.substring(p1.length, p1.length + p232.length);
              }
            ) : suid;
            if (stamp.length === 8) {
              return new Date(parseInt(stamp, 16) * 1e3);
            }
            if (stamp.length < 10) {
              throw new Error("Stamp length invalid");
            }
            const rndIdx = parseInt(stamp.substring(stamp.length - 1), 16);
            return new Date(parseInt(stamp.substring(rndIdx, rndIdx + 8), 16) * 1e3);
          });
          __publicField(this, "setCounter", (counter2) => {
            this.counter = counter2;
          });
          __publicField(this, "validate", (uid4, dictionary2) => {
            const finalDictionary = dictionary2 ? this._normalizeDictionary(dictionary2) : this.dict;
            return uid4.split("").every((c43) => finalDictionary.includes(c43));
          });
          const options = __spreadValues(__spreadValues({}, DEFAULT_OPTIONS), argOptions);
          this.counter = 0;
          this.debug = false;
          this.dict = [];
          this.version = version22;
          const {
            dictionary,
            shuffle,
            length: length34,
            counter
          } = options;
          this.uuidLength = length34;
          this.setDictionary(dictionary, shuffle);
          this.setCounter(counter);
          this.debug = options.debug;
          this.log(this.dict);
          this.log(
            `Generator instantiated with Dictionary Size ${this.dictLength} and counter set to ${this.counter}`
          );
          this.log = this.log.bind(this);
          this.setDictionary = this.setDictionary.bind(this);
          this.setCounter = this.setCounter.bind(this);
          this.seq = this.seq.bind(this);
          this.sequentialUUID = this.sequentialUUID.bind(this);
          this.rnd = this.rnd.bind(this);
          this.randomUUID = this.randomUUID.bind(this);
          this.fmt = this.fmt.bind(this);
          this.formattedUUID = this.formattedUUID.bind(this);
          this.availableUUIDs = this.availableUUIDs.bind(this);
          this.approxMaxBeforeCollision = this.approxMaxBeforeCollision.bind(this);
          this.collisionProbability = this.collisionProbability.bind(this);
          this.uniqueness = this.uniqueness.bind(this);
          this.getVersion = this.getVersion.bind(this);
          this.stamp = this.stamp.bind(this);
          this.parseStamp = this.parseStamp.bind(this);
          return this;
        }
      };
      __publicField(_ShortUniqueId, "default", _ShortUniqueId);
      var ShortUniqueId3 = _ShortUniqueId;
      return __toCommonJS(src_exports);
    })();
    "undefined" != typeof module && (module.exports = ShortUniqueId2.default), "undefined" != typeof window && (ShortUniqueId2 = ShortUniqueId2.default);
  }
});
var name3 = "@neetly-eslint-react/eslint-plugin-react-hooks-extra";
var version3 = "0.0.0-dev.0";
var t6 = Symbol.for("@ts-pattern/matcher");
var e6 = Symbol.for("@ts-pattern/isVariadic");
var n6 = "@ts-pattern/anonymous-select-key";
var r6 = (t43) => Boolean(t43 && "object" == typeof t43);
var i6 = (e43) => e43 && !!e43[t6];
var o6 = (n43, s43, c43) => {
  if (i6(n43)) {
    const e43 = n43[t6](), { matched: r43, selections: i43 } = e43.match(s43);
    return r43 && i43 && Object.keys(i43).forEach((t43) => c43(t43, i43[t43])), r43;
  }
  if (r6(n43)) {
    if (!r6(s43)) return false;
    if (Array.isArray(n43)) {
      if (!Array.isArray(s43)) return false;
      let t43 = [], r43 = [], a43 = [];
      for (const o43 of n43.keys()) {
        const s52 = n43[o43];
        i6(s52) && s52[e6] ? a43.push(s52) : a43.length ? r43.push(s52) : t43.push(s52);
      }
      if (a43.length) {
        if (a43.length > 1) throw new Error("Pattern error: Using `...P.array(...)` several times in a single pattern is not allowed.");
        if (s43.length < t43.length + r43.length) return false;
        const e43 = s43.slice(0, t43.length), n52 = 0 === r43.length ? [] : s43.slice(-r43.length), i43 = s43.slice(t43.length, 0 === r43.length ? Infinity : -r43.length);
        return t43.every((t52, n62) => o6(t52, e43[n62], c43)) && r43.every((t52, e52) => o6(t52, n52[e52], c43)) && (0 === a43.length || o6(a43[0], i43, c43));
      }
      return n43.length === s43.length && n43.every((t52, e43) => o6(t52, s43[e43], c43));
    }
    return Object.keys(n43).every((e43) => {
      const r43 = n43[e43];
      return (e43 in s43 || i6(a43 = r43) && "optional" === a43[t6]().matcherType) && o6(r43, s43[e43], c43);
      var a43;
    });
  }
  return Object.is(s43, n43);
};
var s6 = (e43) => {
  var n43, o43, a43;
  return r6(e43) ? i6(e43) ? null != (n43 = null == (o43 = (a43 = e43[t6]()).getSelectionKeys) ? void 0 : o43.call(a43)) ? n43 : [] : Array.isArray(e43) ? c6(e43, s6) : c6(Object.values(e43), s6) : [];
};
var c6 = (t43, e43) => t43.reduce((t52, n43) => t52.concat(e43(n43)), []);
function a6(...t43) {
  if (1 === t43.length) {
    const [e43] = t43;
    return (t52) => o6(e43, t52, () => {
    });
  }
  if (2 === t43.length) {
    const [e43, n43] = t43;
    return o6(e43, n43, () => {
    });
  }
  throw new Error(`isMatching wasn't given the right number of arguments: expected 1 or 2, received ${t43.length}.`);
}
function u6(t43) {
  return Object.assign(t43, { optional: () => l6(t43), and: (e43) => m6(t43, e43), or: (e43) => d6(t43, e43), select: (e43) => void 0 === e43 ? p6(t43) : p6(e43, t43) });
}
function h6(t43) {
  return Object.assign(((t52) => Object.assign(t52, { [Symbol.iterator]() {
    let n43 = 0;
    const r43 = [{ value: Object.assign(t52, { [e6]: true }), done: false }, { done: true, value: void 0 }];
    return { next: () => {
      var t62;
      return null != (t62 = r43[n43++]) ? t62 : r43.at(-1);
    } };
  } }))(t43), { optional: () => h6(l6(t43)), select: (e43) => h6(void 0 === e43 ? p6(t43) : p6(e43, t43)) });
}
function l6(e43) {
  return u6({ [t6]: () => ({ match: (t43) => {
    let n43 = {};
    const r43 = (t52, e52) => {
      n43[t52] = e52;
    };
    return void 0 === t43 ? (s6(e43).forEach((t52) => r43(t52, void 0)), { matched: true, selections: n43 }) : { matched: o6(e43, t43, r43), selections: n43 };
  }, getSelectionKeys: () => s6(e43), matcherType: "optional" }) });
}
var f6 = (t43, e43) => {
  for (const n43 of t43) if (!e43(n43)) return false;
  return true;
};
var g6 = (t43, e43) => {
  for (const [n43, r43] of t43.entries()) if (!e43(r43, n43)) return false;
  return true;
};
function m6(...e43) {
  return u6({ [t6]: () => ({ match: (t43) => {
    let n43 = {};
    const r43 = (t52, e52) => {
      n43[t52] = e52;
    };
    return { matched: e43.every((e52) => o6(e52, t43, r43)), selections: n43 };
  }, getSelectionKeys: () => c6(e43, s6), matcherType: "and" }) });
}
function d6(...e43) {
  return u6({ [t6]: () => ({ match: (t43) => {
    let n43 = {};
    const r43 = (t52, e52) => {
      n43[t52] = e52;
    };
    return c6(e43, s6).forEach((t52) => r43(t52, void 0)), { matched: e43.some((e52) => o6(e52, t43, r43)), selections: n43 };
  }, getSelectionKeys: () => c6(e43, s6), matcherType: "or" }) });
}
function y6(e43) {
  return { [t6]: () => ({ match: (t43) => ({ matched: Boolean(e43(t43)) }) }) };
}
function p6(...e43) {
  const r43 = "string" == typeof e43[0] ? e43[0] : void 0, i43 = 2 === e43.length ? e43[1] : "string" == typeof e43[0] ? void 0 : e43[0];
  return u6({ [t6]: () => ({ match: (t43) => {
    let e52 = { [null != r43 ? r43 : n6]: t43 };
    return { matched: void 0 === i43 || o6(i43, t43, (t52, n43) => {
      e52[t52] = n43;
    }), selections: e52 };
  }, getSelectionKeys: () => [null != r43 ? r43 : n6].concat(void 0 === i43 ? [] : s6(i43)) }) });
}
function v6(t43) {
  return "number" == typeof t43;
}
function b6(t43) {
  return "string" == typeof t43;
}
function w6(t43) {
  return "bigint" == typeof t43;
}
var S6 = u6(y6(function(t43) {
  return true;
}));
var O6 = S6;
var j6 = (t43) => Object.assign(u6(t43), { startsWith: (e43) => {
  return j6(m6(t43, (n43 = e43, y6((t52) => b6(t52) && t52.startsWith(n43)))));
  var n43;
}, endsWith: (e43) => {
  return j6(m6(t43, (n43 = e43, y6((t52) => b6(t52) && t52.endsWith(n43)))));
  var n43;
}, minLength: (e43) => j6(m6(t43, ((t52) => y6((e52) => b6(e52) && e52.length >= t52))(e43))), maxLength: (e43) => j6(m6(t43, ((t52) => y6((e52) => b6(e52) && e52.length <= t52))(e43))), includes: (e43) => {
  return j6(m6(t43, (n43 = e43, y6((t52) => b6(t52) && t52.includes(n43)))));
  var n43;
}, regex: (e43) => {
  return j6(m6(t43, (n43 = e43, y6((t52) => b6(t52) && Boolean(t52.match(n43))))));
  var n43;
} });
var E6 = j6(y6(b6));
var K6 = (t43) => Object.assign(u6(t43), { between: (e43, n43) => K6(m6(t43, ((t52, e52) => y6((n52) => v6(n52) && t52 <= n52 && e52 >= n52))(e43, n43))), lt: (e43) => K6(m6(t43, ((t52) => y6((e52) => v6(e52) && e52 < t52))(e43))), gt: (e43) => K6(m6(t43, ((t52) => y6((e52) => v6(e52) && e52 > t52))(e43))), lte: (e43) => K6(m6(t43, ((t52) => y6((e52) => v6(e52) && e52 <= t52))(e43))), gte: (e43) => K6(m6(t43, ((t52) => y6((e52) => v6(e52) && e52 >= t52))(e43))), int: () => K6(m6(t43, y6((t52) => v6(t52) && Number.isInteger(t52)))), finite: () => K6(m6(t43, y6((t52) => v6(t52) && Number.isFinite(t52)))), positive: () => K6(m6(t43, y6((t52) => v6(t52) && t52 > 0))), negative: () => K6(m6(t43, y6((t52) => v6(t52) && t52 < 0))) });
var x6 = K6(y6(v6));
var A6 = (t43) => Object.assign(u6(t43), { between: (e43, n43) => A6(m6(t43, ((t52, e52) => y6((n52) => w6(n52) && t52 <= n52 && e52 >= n52))(e43, n43))), lt: (e43) => A6(m6(t43, ((t52) => y6((e52) => w6(e52) && e52 < t52))(e43))), gt: (e43) => A6(m6(t43, ((t52) => y6((e52) => w6(e52) && e52 > t52))(e43))), lte: (e43) => A6(m6(t43, ((t52) => y6((e52) => w6(e52) && e52 <= t52))(e43))), gte: (e43) => A6(m6(t43, ((t52) => y6((e52) => w6(e52) && e52 >= t52))(e43))), positive: () => A6(m6(t43, y6((t52) => w6(t52) && t52 > 0))), negative: () => A6(m6(t43, y6((t52) => w6(t52) && t52 < 0))) });
var P6 = A6(y6(w6));
var T6 = u6(y6(function(t43) {
  return "boolean" == typeof t43;
}));
var k6 = u6(y6(function(t43) {
  return "symbol" == typeof t43;
}));
var B6 = u6(y6(function(t43) {
  return null == t43;
}));
var _6 = u6(y6(function(t43) {
  return null != t43;
}));
var N6 = { __proto__: null, matcher: t6, optional: l6, array: function(...e43) {
  return h6({ [t6]: () => ({ match: (t43) => {
    if (!Array.isArray(t43)) return { matched: false };
    if (0 === e43.length) return { matched: true };
    const n43 = e43[0];
    let r43 = {};
    if (0 === t43.length) return s6(n43).forEach((t52) => {
      r43[t52] = [];
    }), { matched: true, selections: r43 };
    const i43 = (t52, e52) => {
      r43[t52] = (r43[t52] || []).concat([e52]);
    };
    return { matched: t43.every((t52) => o6(n43, t52, i43)), selections: r43 };
  }, getSelectionKeys: () => 0 === e43.length ? [] : s6(e43[0]) }) });
}, set: function(...e43) {
  return u6({ [t6]: () => ({ match: (t43) => {
    if (!(t43 instanceof Set)) return { matched: false };
    let n43 = {};
    if (0 === t43.size) return { matched: true, selections: n43 };
    if (0 === e43.length) return { matched: true };
    const r43 = (t52, e52) => {
      n43[t52] = (n43[t52] || []).concat([e52]);
    }, i43 = e43[0];
    return { matched: f6(t43, (t52) => o6(i43, t52, r43)), selections: n43 };
  }, getSelectionKeys: () => 0 === e43.length ? [] : s6(e43[0]) }) });
}, map: function(...e43) {
  return u6({ [t6]: () => ({ match: (t43) => {
    if (!(t43 instanceof Map)) return { matched: false };
    let n43 = {};
    if (0 === t43.size) return { matched: true, selections: n43 };
    const r43 = (t52, e52) => {
      n43[t52] = (n43[t52] || []).concat([e52]);
    };
    if (0 === e43.length) return { matched: true };
    var i43;
    if (1 === e43.length) throw new Error(`\`P.map\` wasn't given enough arguments. Expected (key, value), received ${null == (i43 = e43[0]) ? void 0 : i43.toString()}`);
    const [s43, c43] = e43;
    return { matched: g6(t43, (t52, e52) => {
      const n52 = o6(s43, e52, r43), i52 = o6(c43, t52, r43);
      return n52 && i52;
    }), selections: n43 };
  }, getSelectionKeys: () => 0 === e43.length ? [] : [...s6(e43[0]), ...s6(e43[1])] }) });
}, intersection: m6, union: d6, not: function(e43) {
  return u6({ [t6]: () => ({ match: (t43) => ({ matched: !o6(e43, t43, () => {
  }) }), getSelectionKeys: () => [], matcherType: "not" }) });
}, when: y6, select: p6, any: S6, _: O6, string: E6, number: x6, bigint: P6, boolean: T6, symbol: k6, nullish: B6, nonNullable: _6, instanceOf: function(t43) {
  return u6(y6(/* @__PURE__ */ function(t52) {
    return (e43) => e43 instanceof t52;
  }(t43)));
}, shape: function(t43) {
  return u6(y6(a6(t43)));
} };
var W3 = { matched: false, value: void 0 };
function $3(t43) {
  return new z3(t43, W3);
}
var z3 = class _z3 {
  constructor(t43, e43) {
    this.input = void 0, this.state = void 0, this.input = t43, this.state = e43;
  }
  with(...t43) {
    if (this.state.matched) return this;
    const e43 = t43[t43.length - 1], r43 = [t43[0]];
    let i43;
    3 === t43.length && "function" == typeof t43[1] ? i43 = t43[1] : t43.length > 2 && r43.push(...t43.slice(1, t43.length - 1));
    let s43 = false, c43 = {};
    const a43 = (t52, e52) => {
      s43 = true, c43[t52] = e52;
    }, u43 = !r43.some((t52) => o6(t52, this.input, a43)) || i43 && !Boolean(i43(this.input)) ? W3 : { matched: true, value: e43(s43 ? n6 in c43 ? c43[n6] : c43 : this.input, this.input) };
    return new _z3(this.input, u43);
  }
  when(t43, e43) {
    if (this.state.matched) return this;
    const n43 = Boolean(t43(this.input));
    return new _z3(this.input, n43 ? { matched: true, value: e43(this.input, this.input) } : W3);
  }
  otherwise(t43) {
    return this.state.matched ? this.state.value : t43(this.input);
  }
  exhaustive() {
    if (this.state.matched) return this.state.value;
    let t43;
    try {
      t43 = JSON.stringify(this.input);
    } catch (e43) {
      t43 = this.input;
    }
    throw new Error(`Pattern matching error: no pattern matches value ${t43}`);
  }
  run() {
    return this.exhaustive();
  }
  returnType() {
    return this;
  }
};
var import_short_unique_id3 = __toESM3(require_short_unique_id3());
var __defProp26 = Object.defineProperty;
var __export26 = (target, all922) => {
  for (var name22 in all922)
    __defProp26(target, name22, { get: all922[name22], enumerable: true });
};
var KEYS7 = {
  ArrayExpression: [
    "elements"
  ],
  ArrayPattern: [
    "elements"
  ],
  ArrowFunctionExpression: [
    "params",
    "body"
  ],
  AssignmentExpression: [
    "left",
    "right"
  ],
  AssignmentPattern: [
    "left",
    "right"
  ],
  AwaitExpression: [
    "argument"
  ],
  BinaryExpression: [
    "left",
    "right"
  ],
  BlockStatement: [
    "body"
  ],
  BreakStatement: [
    "label"
  ],
  CallExpression: [
    "callee",
    "arguments"
  ],
  CatchClause: [
    "param",
    "body"
  ],
  ChainExpression: [
    "expression"
  ],
  ClassBody: [
    "body"
  ],
  ClassDeclaration: [
    "id",
    "superClass",
    "body"
  ],
  ClassExpression: [
    "id",
    "superClass",
    "body"
  ],
  ConditionalExpression: [
    "test",
    "consequent",
    "alternate"
  ],
  ContinueStatement: [
    "label"
  ],
  DebuggerStatement: [],
  DoWhileStatement: [
    "body",
    "test"
  ],
  EmptyStatement: [],
  ExperimentalRestProperty: [
    "argument"
  ],
  ExperimentalSpreadProperty: [
    "argument"
  ],
  ExportAllDeclaration: [
    "exported",
    "source"
  ],
  ExportDefaultDeclaration: [
    "declaration"
  ],
  ExportNamedDeclaration: [
    "declaration",
    "specifiers",
    "source"
  ],
  ExportSpecifier: [
    "exported",
    "local"
  ],
  ExpressionStatement: [
    "expression"
  ],
  ForInStatement: [
    "left",
    "right",
    "body"
  ],
  ForOfStatement: [
    "left",
    "right",
    "body"
  ],
  ForStatement: [
    "init",
    "test",
    "update",
    "body"
  ],
  FunctionDeclaration: [
    "id",
    "params",
    "body"
  ],
  FunctionExpression: [
    "id",
    "params",
    "body"
  ],
  Identifier: [],
  IfStatement: [
    "test",
    "consequent",
    "alternate"
  ],
  ImportDeclaration: [
    "specifiers",
    "source"
  ],
  ImportDefaultSpecifier: [
    "local"
  ],
  ImportExpression: [
    "source"
  ],
  ImportNamespaceSpecifier: [
    "local"
  ],
  ImportSpecifier: [
    "imported",
    "local"
  ],
  JSXAttribute: [
    "name",
    "value"
  ],
  JSXClosingElement: [
    "name"
  ],
  JSXClosingFragment: [],
  JSXElement: [
    "openingElement",
    "children",
    "closingElement"
  ],
  JSXEmptyExpression: [],
  JSXExpressionContainer: [
    "expression"
  ],
  JSXFragment: [
    "openingFragment",
    "children",
    "closingFragment"
  ],
  JSXIdentifier: [],
  JSXMemberExpression: [
    "object",
    "property"
  ],
  JSXNamespacedName: [
    "namespace",
    "name"
  ],
  JSXOpeningElement: [
    "name",
    "attributes"
  ],
  JSXOpeningFragment: [],
  JSXSpreadAttribute: [
    "argument"
  ],
  JSXSpreadChild: [
    "expression"
  ],
  JSXText: [],
  LabeledStatement: [
    "label",
    "body"
  ],
  Literal: [],
  LogicalExpression: [
    "left",
    "right"
  ],
  MemberExpression: [
    "object",
    "property"
  ],
  MetaProperty: [
    "meta",
    "property"
  ],
  MethodDefinition: [
    "key",
    "value"
  ],
  NewExpression: [
    "callee",
    "arguments"
  ],
  ObjectExpression: [
    "properties"
  ],
  ObjectPattern: [
    "properties"
  ],
  PrivateIdentifier: [],
  Program: [
    "body"
  ],
  Property: [
    "key",
    "value"
  ],
  PropertyDefinition: [
    "key",
    "value"
  ],
  RestElement: [
    "argument"
  ],
  ReturnStatement: [
    "argument"
  ],
  SequenceExpression: [
    "expressions"
  ],
  SpreadElement: [
    "argument"
  ],
  StaticBlock: [
    "body"
  ],
  Super: [],
  SwitchCase: [
    "test",
    "consequent"
  ],
  SwitchStatement: [
    "discriminant",
    "cases"
  ],
  TaggedTemplateExpression: [
    "tag",
    "quasi"
  ],
  TemplateElement: [],
  TemplateLiteral: [
    "quasis",
    "expressions"
  ],
  ThisExpression: [],
  ThrowStatement: [
    "argument"
  ],
  TryStatement: [
    "block",
    "handler",
    "finalizer"
  ],
  UnaryExpression: [
    "argument"
  ],
  UpdateExpression: [
    "argument"
  ],
  VariableDeclaration: [
    "declarations"
  ],
  VariableDeclarator: [
    "id",
    "init"
  ],
  WhileStatement: [
    "test",
    "body"
  ],
  WithStatement: [
    "object",
    "body"
  ],
  YieldExpression: [
    "argument"
  ]
};
var NODE_TYPES7 = Object.keys(KEYS7);
for (const type of NODE_TYPES7) {
  Object.freeze(KEYS7[type]);
}
Object.freeze(KEYS7);
var visitor_keys_default7 = KEYS7;
var KEY_BLACKLIST7 = /* @__PURE__ */ new Set([
  "parent",
  "leadingComments",
  "trailingComments"
]);
function filterKey7(key) {
  return !KEY_BLACKLIST7.has(key) && key[0] !== "_";
}
function getKeys7(node) {
  return Object.keys(node).filter(filterKey7);
}
function getInnermostScope7(initialScope, node) {
  const location = node.range[0];
  let scope = initialScope;
  let found = false;
  do {
    found = false;
    for (const childScope of scope.childScopes) {
      const range24 = childScope.block.range;
      if (range24[0] <= location && location < range24[1]) {
        scope = childScope;
        found = true;
        break;
      }
    }
  } while (found);
  return scope;
}
function findVariable7(initialScope, nameOrNode) {
  let name22 = "";
  let scope = initialScope;
  if (typeof nameOrNode === "string") {
    name22 = nameOrNode;
  } else {
    name22 = nameOrNode.name;
    scope = getInnermostScope7(scope, nameOrNode);
  }
  while (scope != null) {
    const variable = scope.set.get(name22);
    if (variable != null) {
      return variable;
    }
    scope = scope.upper;
  }
  return null;
}
function negate07(token) {
  return !this(token);
}
function negate7(f322) {
  return negate07.bind(f322);
}
function isPunctuatorTokenWithValue7(token, value) {
  return token.type === "Punctuator" && token.value === value;
}
function isArrowToken7(token) {
  return isPunctuatorTokenWithValue7(token, "=>");
}
function isCommaToken7(token) {
  return isPunctuatorTokenWithValue7(token, ",");
}
function isSemicolonToken7(token) {
  return isPunctuatorTokenWithValue7(token, ";");
}
function isColonToken7(token) {
  return isPunctuatorTokenWithValue7(token, ":");
}
function isOpeningParenToken7(token) {
  return isPunctuatorTokenWithValue7(token, "(");
}
function isClosingParenToken7(token) {
  return isPunctuatorTokenWithValue7(token, ")");
}
function isOpeningBracketToken7(token) {
  return isPunctuatorTokenWithValue7(token, "[");
}
function isClosingBracketToken7(token) {
  return isPunctuatorTokenWithValue7(token, "]");
}
function isOpeningBraceToken7(token) {
  return isPunctuatorTokenWithValue7(token, "{");
}
function isClosingBraceToken7(token) {
  return isPunctuatorTokenWithValue7(token, "}");
}
function isCommentToken7(token) {
  return ["Block", "Line", "Shebang"].includes(token.type);
}
negate7(isArrowToken7);
negate7(isCommaToken7);
negate7(isSemicolonToken7);
negate7(isColonToken7);
negate7(isOpeningParenToken7);
negate7(isClosingParenToken7);
negate7(isOpeningBracketToken7);
negate7(isClosingBracketToken7);
negate7(isOpeningBraceToken7);
negate7(isClosingBraceToken7);
negate7(isCommentToken7);
function getOpeningParenOfParams7(node, sourceCode) {
  return node.id ? sourceCode.getTokenAfter(node.id, isOpeningParenToken7) : sourceCode.getFirstToken(node, isOpeningParenToken7);
}
function getFunctionHeadLocation7(node, sourceCode) {
  const parent = node.parent;
  let start = null;
  let end = null;
  if (node.type === "ArrowFunctionExpression") {
    const arrowToken = sourceCode.getTokenBefore(node.body, isArrowToken7);
    start = arrowToken.loc.start;
    end = arrowToken.loc.end;
  } else if (parent.type === "Property" || parent.type === "MethodDefinition" || parent.type === "PropertyDefinition") {
    start = parent.loc.start;
    end = getOpeningParenOfParams7(node, sourceCode).loc.start;
  } else {
    start = node.loc.start;
    end = getOpeningParenOfParams7(node, sourceCode).loc.start;
  }
  return {
    start: { ...start },
    end: { ...end }
  };
}
var globalObject7 = typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {};
var builtinNames7 = Object.freeze(
  /* @__PURE__ */ new Set([
    "Array",
    "ArrayBuffer",
    "BigInt",
    "BigInt64Array",
    "BigUint64Array",
    "Boolean",
    "DataView",
    "Date",
    "decodeURI",
    "decodeURIComponent",
    "encodeURI",
    "encodeURIComponent",
    "escape",
    "Float32Array",
    "Float64Array",
    "Function",
    "Infinity",
    "Int16Array",
    "Int32Array",
    "Int8Array",
    "isFinite",
    "isNaN",
    "isPrototypeOf",
    "JSON",
    "Map",
    "Math",
    "NaN",
    "Number",
    "Object",
    "parseFloat",
    "parseInt",
    "Promise",
    "Proxy",
    "Reflect",
    "RegExp",
    "Set",
    "String",
    "Symbol",
    "Uint16Array",
    "Uint32Array",
    "Uint8Array",
    "Uint8ClampedArray",
    "undefined",
    "unescape",
    "WeakMap",
    "WeakSet"
  ])
);
var callAllowed7 = new Set(
  [
    Array.isArray,
    Array.of,
    Array.prototype.at,
    Array.prototype.concat,
    Array.prototype.entries,
    Array.prototype.every,
    Array.prototype.filter,
    Array.prototype.find,
    Array.prototype.findIndex,
    Array.prototype.flat,
    Array.prototype.includes,
    Array.prototype.indexOf,
    Array.prototype.join,
    Array.prototype.keys,
    Array.prototype.lastIndexOf,
    Array.prototype.slice,
    Array.prototype.some,
    Array.prototype.toString,
    Array.prototype.values,
    typeof BigInt === "function" ? BigInt : void 0,
    Boolean,
    Date,
    Date.parse,
    decodeURI,
    decodeURIComponent,
    encodeURI,
    encodeURIComponent,
    escape,
    isFinite,
    isNaN,
    isPrototypeOf,
    Map,
    Map.prototype.entries,
    Map.prototype.get,
    Map.prototype.has,
    Map.prototype.keys,
    Map.prototype.values,
    ...Object.getOwnPropertyNames(Math).filter((k322) => k322 !== "random").map((k322) => Math[k322]).filter((f322) => typeof f322 === "function"),
    Number,
    Number.isFinite,
    Number.isNaN,
    Number.parseFloat,
    Number.parseInt,
    Number.prototype.toExponential,
    Number.prototype.toFixed,
    Number.prototype.toPrecision,
    Number.prototype.toString,
    Object,
    Object.entries,
    Object.is,
    Object.isExtensible,
    Object.isFrozen,
    Object.isSealed,
    Object.keys,
    Object.values,
    parseFloat,
    parseInt,
    RegExp,
    Set,
    Set.prototype.entries,
    Set.prototype.has,
    Set.prototype.keys,
    Set.prototype.values,
    String,
    String.fromCharCode,
    String.fromCodePoint,
    String.raw,
    String.prototype.at,
    String.prototype.charAt,
    String.prototype.charCodeAt,
    String.prototype.codePointAt,
    String.prototype.concat,
    String.prototype.endsWith,
    String.prototype.includes,
    String.prototype.indexOf,
    String.prototype.lastIndexOf,
    String.prototype.normalize,
    String.prototype.padEnd,
    String.prototype.padStart,
    String.prototype.slice,
    String.prototype.startsWith,
    String.prototype.substr,
    String.prototype.substring,
    String.prototype.toLowerCase,
    String.prototype.toString,
    String.prototype.toUpperCase,
    String.prototype.trim,
    String.prototype.trimEnd,
    String.prototype.trimLeft,
    String.prototype.trimRight,
    String.prototype.trimStart,
    Symbol.for,
    Symbol.keyFor,
    unescape
  ].filter((f322) => typeof f322 === "function")
);
var callPassThrough7 = /* @__PURE__ */ new Set([
  Object.freeze,
  Object.preventExtensions,
  Object.seal
]);
var getterAllowed7 = [
  [Map, /* @__PURE__ */ new Set(["size"])],
  [
    RegExp,
    /* @__PURE__ */ new Set([
      "dotAll",
      "flags",
      "global",
      "hasIndices",
      "ignoreCase",
      "multiline",
      "source",
      "sticky",
      "unicode"
    ])
  ],
  [Set, /* @__PURE__ */ new Set(["size"])]
];
function getPropertyDescriptor7(object222, name22) {
  let x322 = object222;
  while ((typeof x322 === "object" || typeof x322 === "function") && x322 !== null) {
    const d322 = Object.getOwnPropertyDescriptor(x322, name22);
    if (d322) {
      return d322;
    }
    x322 = Object.getPrototypeOf(x322);
  }
  return null;
}
function isGetter7(object222, name22) {
  const d322 = getPropertyDescriptor7(object222, name22);
  return d322 != null && d322.get != null;
}
function getElementValues7(nodeList, initialScope) {
  const valueList = [];
  for (let i322 = 0; i322 < nodeList.length; ++i322) {
    const elementNode = nodeList[i322];
    if (elementNode == null) {
      valueList.length = i322 + 1;
    } else if (elementNode.type === "SpreadElement") {
      const argument = getStaticValueR7(elementNode.argument, initialScope);
      if (argument == null) {
        return null;
      }
      valueList.push(...argument.value);
    } else {
      const element = getStaticValueR7(elementNode, initialScope);
      if (element == null) {
        return null;
      }
      valueList.push(element.value);
    }
  }
  return valueList;
}
function isEffectivelyConst7(variable) {
  const refs = variable.references;
  const inits = refs.filter((r322) => r322.init).length;
  const reads = refs.filter((r322) => r322.isReadOnly()).length;
  if (inits === 1 && reads + inits === refs.length) {
    return true;
  }
  return false;
}
var operations7 = Object.freeze({
  ArrayExpression(node, initialScope) {
    const elements = getElementValues7(node.elements, initialScope);
    return elements != null ? { value: elements } : null;
  },
  AssignmentExpression(node, initialScope) {
    if (node.operator === "=") {
      return getStaticValueR7(node.right, initialScope);
    }
    return null;
  },
  //eslint-disable-next-line complexity
  BinaryExpression(node, initialScope) {
    if (node.operator === "in" || node.operator === "instanceof") {
      return null;
    }
    const left722 = getStaticValueR7(node.left, initialScope);
    const right722 = getStaticValueR7(node.right, initialScope);
    if (left722 != null && right722 != null) {
      switch (node.operator) {
        case "==":
          return { value: left722.value == right722.value };
        case "!=":
          return { value: left722.value != right722.value };
        case "===":
          return { value: left722.value === right722.value };
        case "!==":
          return { value: left722.value !== right722.value };
        case "<":
          return { value: left722.value < right722.value };
        case "<=":
          return { value: left722.value <= right722.value };
        case ">":
          return { value: left722.value > right722.value };
        case ">=":
          return { value: left722.value >= right722.value };
        case "<<":
          return { value: left722.value << right722.value };
        case ">>":
          return { value: left722.value >> right722.value };
        case ">>>":
          return { value: left722.value >>> right722.value };
        case "+":
          return { value: left722.value + right722.value };
        case "-":
          return { value: left722.value - right722.value };
        case "*":
          return { value: left722.value * right722.value };
        case "/":
          return { value: left722.value / right722.value };
        case "%":
          return { value: left722.value % right722.value };
        case "**":
          return { value: left722.value ** right722.value };
        case "|":
          return { value: left722.value | right722.value };
        case "^":
          return { value: left722.value ^ right722.value };
        case "&":
          return { value: left722.value & right722.value };
      }
    }
    return null;
  },
  CallExpression(node, initialScope) {
    const calleeNode = node.callee;
    const args = getElementValues7(node.arguments, initialScope);
    if (args != null) {
      if (calleeNode.type === "MemberExpression") {
        if (calleeNode.property.type === "PrivateIdentifier") {
          return null;
        }
        const object222 = getStaticValueR7(calleeNode.object, initialScope);
        if (object222 != null) {
          if (object222.value == null && (object222.optional || node.optional)) {
            return { value: void 0, optional: true };
          }
          const property = getStaticPropertyNameValue7(
            calleeNode,
            initialScope
          );
          if (property != null) {
            const receiver = object222.value;
            const methodName = property.value;
            if (callAllowed7.has(receiver[methodName])) {
              return { value: receiver[methodName](...args) };
            }
            if (callPassThrough7.has(receiver[methodName])) {
              return { value: args[0] };
            }
          }
        }
      } else {
        const callee = getStaticValueR7(calleeNode, initialScope);
        if (callee != null) {
          if (callee.value == null && node.optional) {
            return { value: void 0, optional: true };
          }
          const func = callee.value;
          if (callAllowed7.has(func)) {
            return { value: func(...args) };
          }
          if (callPassThrough7.has(func)) {
            return { value: args[0] };
          }
        }
      }
    }
    return null;
  },
  ConditionalExpression(node, initialScope) {
    const test = getStaticValueR7(node.test, initialScope);
    if (test != null) {
      return test.value ? getStaticValueR7(node.consequent, initialScope) : getStaticValueR7(node.alternate, initialScope);
    }
    return null;
  },
  ExpressionStatement(node, initialScope) {
    return getStaticValueR7(node.expression, initialScope);
  },
  Identifier(node, initialScope) {
    if (initialScope != null) {
      const variable = findVariable7(initialScope, node);
      if (variable != null && variable.defs.length === 0 && builtinNames7.has(variable.name) && variable.name in globalObject7) {
        return { value: globalObject7[variable.name] };
      }
      if (variable != null && variable.defs.length === 1) {
        const def = variable.defs[0];
        if (def.parent && def.type === "Variable" && (def.parent.kind === "const" || isEffectivelyConst7(variable)) && // TODO(mysticatea): don't support destructuring here.
        def.node.id.type === "Identifier") {
          return getStaticValueR7(def.node.init, initialScope);
        }
      }
    }
    return null;
  },
  Literal(node) {
    if ((node.regex != null || node.bigint != null) && node.value == null) {
      return null;
    }
    return { value: node.value };
  },
  LogicalExpression(node, initialScope) {
    const left722 = getStaticValueR7(node.left, initialScope);
    if (left722 != null) {
      if (node.operator === "||" && Boolean(left722.value) === true || node.operator === "&&" && Boolean(left722.value) === false || node.operator === "??" && left722.value != null) {
        return left722;
      }
      const right722 = getStaticValueR7(node.right, initialScope);
      if (right722 != null) {
        return right722;
      }
    }
    return null;
  },
  MemberExpression(node, initialScope) {
    if (node.property.type === "PrivateIdentifier") {
      return null;
    }
    const object222 = getStaticValueR7(node.object, initialScope);
    if (object222 != null) {
      if (object222.value == null && (object222.optional || node.optional)) {
        return { value: void 0, optional: true };
      }
      const property = getStaticPropertyNameValue7(node, initialScope);
      if (property != null) {
        if (!isGetter7(object222.value, property.value)) {
          return { value: object222.value[property.value] };
        }
        for (const [classFn, allowed] of getterAllowed7) {
          if (object222.value instanceof classFn && allowed.has(property.value)) {
            return { value: object222.value[property.value] };
          }
        }
      }
    }
    return null;
  },
  ChainExpression(node, initialScope) {
    const expression = getStaticValueR7(node.expression, initialScope);
    if (expression != null) {
      return { value: expression.value };
    }
    return null;
  },
  NewExpression(node, initialScope) {
    const callee = getStaticValueR7(node.callee, initialScope);
    const args = getElementValues7(node.arguments, initialScope);
    if (callee != null && args != null) {
      const Func = callee.value;
      if (callAllowed7.has(Func)) {
        return { value: new Func(...args) };
      }
    }
    return null;
  },
  ObjectExpression(node, initialScope) {
    const object222 = {};
    for (const propertyNode of node.properties) {
      if (propertyNode.type === "Property") {
        if (propertyNode.kind !== "init") {
          return null;
        }
        const key = getStaticPropertyNameValue7(
          propertyNode,
          initialScope
        );
        const value = getStaticValueR7(propertyNode.value, initialScope);
        if (key == null || value == null) {
          return null;
        }
        object222[key.value] = value.value;
      } else if (propertyNode.type === "SpreadElement" || propertyNode.type === "ExperimentalSpreadProperty") {
        const argument = getStaticValueR7(
          propertyNode.argument,
          initialScope
        );
        if (argument == null) {
          return null;
        }
        Object.assign(object222, argument.value);
      } else {
        return null;
      }
    }
    return { value: object222 };
  },
  SequenceExpression(node, initialScope) {
    const last24 = node.expressions[node.expressions.length - 1];
    return getStaticValueR7(last24, initialScope);
  },
  TaggedTemplateExpression(node, initialScope) {
    const tag = getStaticValueR7(node.tag, initialScope);
    const expressions = getElementValues7(
      node.quasi.expressions,
      initialScope
    );
    if (tag != null && expressions != null) {
      const func = tag.value;
      const strings = node.quasi.quasis.map((q) => q.value.cooked);
      strings.raw = node.quasi.quasis.map((q) => q.value.raw);
      if (func === String.raw) {
        return { value: func(strings, ...expressions) };
      }
    }
    return null;
  },
  TemplateLiteral(node, initialScope) {
    const expressions = getElementValues7(node.expressions, initialScope);
    if (expressions != null) {
      let value = node.quasis[0].value.cooked;
      for (let i322 = 0; i322 < expressions.length; ++i322) {
        value += expressions[i322];
        value += node.quasis[i322 + 1].value.cooked;
      }
      return { value };
    }
    return null;
  },
  UnaryExpression(node, initialScope) {
    if (node.operator === "delete") {
      return null;
    }
    if (node.operator === "void") {
      return { value: void 0 };
    }
    const arg = getStaticValueR7(node.argument, initialScope);
    if (arg != null) {
      switch (node.operator) {
        case "-":
          return { value: -arg.value };
        case "+":
          return { value: +arg.value };
        case "!":
          return { value: !arg.value };
        case "~":
          return { value: ~arg.value };
        case "typeof":
          return { value: typeof arg.value };
      }
    }
    return null;
  }
});
function getStaticValueR7(node, initialScope) {
  if (node != null && Object.hasOwnProperty.call(operations7, node.type)) {
    return operations7[node.type](node, initialScope);
  }
  return null;
}
function getStaticPropertyNameValue7(node, initialScope) {
  const nameNode = node.type === "Property" ? node.key : node.property;
  if (node.computed) {
    return getStaticValueR7(nameNode, initialScope);
  }
  if (nameNode.type === "Identifier") {
    return { value: nameNode.name };
  }
  if (nameNode.type === "Literal") {
    if (nameNode.bigint) {
      return { value: nameNode.bigint };
    }
    return { value: String(nameNode.value) };
  }
  return null;
}
function getStaticValue7(node, initialScope = null) {
  try {
    return getStaticValueR7(node, initialScope);
  } catch (_error) {
    return null;
  }
}
function getStringIfConstant7(node, initialScope = null) {
  if (node && node.type === "Literal" && node.value === null) {
    if (node.regex) {
      return `/${node.regex.pattern}/${node.regex.flags}`;
    }
    if (node.bigint) {
      return node.bigint;
    }
  }
  const evaluated = getStaticValue7(node, initialScope);
  return evaluated && String(evaluated.value);
}
function getPropertyName7(node, initialScope) {
  switch (node.type) {
    case "MemberExpression":
      if (node.computed) {
        return getStringIfConstant7(node.property, initialScope);
      }
      if (node.property.type === "PrivateIdentifier") {
        return null;
      }
      return node.property.name;
    case "Property":
    case "MethodDefinition":
    case "PropertyDefinition":
      if (node.computed) {
        return getStringIfConstant7(node.key, initialScope);
      }
      if (node.key.type === "Literal") {
        return String(node.key.value);
      }
      if (node.key.type === "PrivateIdentifier") {
        return null;
      }
      return node.key.name;
  }
  return null;
}
function getFunctionNameWithKind7(node, sourceCode) {
  const parent = node.parent;
  const tokens = [];
  const isObjectMethod = parent.type === "Property" && parent.value === node;
  const isClassMethod = parent.type === "MethodDefinition" && parent.value === node;
  const isClassFieldMethod = parent.type === "PropertyDefinition" && parent.value === node;
  if (isClassMethod || isClassFieldMethod) {
    if (parent.static) {
      tokens.push("static");
    }
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push("private");
    }
  }
  if (node.async) {
    tokens.push("async");
  }
  if (node.generator) {
    tokens.push("generator");
  }
  if (isObjectMethod || isClassMethod) {
    if (parent.kind === "constructor") {
      return "constructor";
    }
    if (parent.kind === "get") {
      tokens.push("getter");
    } else if (parent.kind === "set") {
      tokens.push("setter");
    } else {
      tokens.push("method");
    }
  } else if (isClassFieldMethod) {
    tokens.push("method");
  } else {
    if (node.type === "ArrowFunctionExpression") {
      tokens.push("arrow");
    }
    tokens.push("function");
  }
  if (isObjectMethod || isClassMethod || isClassFieldMethod) {
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push(`#${parent.key.name}`);
    } else {
      const name22 = getPropertyName7(parent);
      if (name22) {
        tokens.push(`'${name22}'`);
      } else if (sourceCode) {
        const keyText = sourceCode.getText(parent.key);
        if (!keyText.includes("\n")) {
          tokens.push(`[${keyText}]`);
        }
      }
    }
  } else if (node.id) {
    tokens.push(`'${node.id.name}'`);
  } else if (parent.type === "VariableDeclarator" && parent.id && parent.id.type === "Identifier") {
    tokens.push(`'${parent.id.name}'`);
  } else if ((parent.type === "AssignmentExpression" || parent.type === "AssignmentPattern") && parent.left && parent.left.type === "Identifier") {
    tokens.push(`'${parent.left.name}'`);
  } else if (parent.type === "ExportDefaultDeclaration" && parent.declaration === node) {
    tokens.push("'default'");
  }
  return tokens.join(" ");
}
var typeConversionBinaryOps7 = Object.freeze(
  /* @__PURE__ */ new Set([
    "==",
    "!=",
    "<",
    "<=",
    ">",
    ">=",
    "<<",
    ">>",
    ">>>",
    "+",
    "-",
    "*",
    "/",
    "%",
    "|",
    "^",
    "&",
    "in"
  ])
);
var typeConversionUnaryOps7 = Object.freeze(/* @__PURE__ */ new Set(["-", "+", "!", "~"]));
function isNode7(x322) {
  return x322 !== null && typeof x322 === "object" && typeof x322.type === "string";
}
var visitor7 = Object.freeze(
  Object.assign(/* @__PURE__ */ Object.create(null), {
    $visit(node, options, visitorKeys) {
      const { type } = node;
      if (typeof this[type] === "function") {
        return this[type](node, options, visitorKeys);
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    $visitChildren(node, options, visitorKeys) {
      const { type } = node;
      for (const key of visitorKeys[type] || getKeys7(node)) {
        const value = node[key];
        if (Array.isArray(value)) {
          for (const element of value) {
            if (isNode7(element) && this.$visit(element, options, visitorKeys)) {
              return true;
            }
          }
        } else if (isNode7(value) && this.$visit(value, options, visitorKeys)) {
          return true;
        }
      }
      return false;
    },
    ArrowFunctionExpression() {
      return false;
    },
    AssignmentExpression() {
      return true;
    },
    AwaitExpression() {
      return true;
    },
    BinaryExpression(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && typeConversionBinaryOps7.has(node.operator) && (node.left.type !== "Literal" || node.right.type !== "Literal")) {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    CallExpression() {
      return true;
    },
    FunctionExpression() {
      return false;
    },
    ImportExpression() {
      return true;
    },
    MemberExpression(node, options, visitorKeys) {
      if (options.considerGetters) {
        return true;
      }
      if (options.considerImplicitTypeConversion && node.computed && node.property.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    MethodDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    NewExpression() {
      return true;
    },
    Property(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    PropertyDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UnaryExpression(node, options, visitorKeys) {
      if (node.operator === "delete") {
        return true;
      }
      if (options.considerImplicitTypeConversion && typeConversionUnaryOps7.has(node.operator) && node.argument.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UpdateExpression() {
      return true;
    },
    YieldExpression() {
      return true;
    }
  })
);
function hasSideEffect7(node, sourceCode, { considerGetters = false, considerImplicitTypeConversion = false } = {}) {
  return visitor7.$visit(
    node,
    { considerGetters, considerImplicitTypeConversion },
    sourceCode.visitorKeys || visitor_keys_default7
  );
}
function getParentSyntaxParen7(node, sourceCode) {
  const parent = node.parent;
  switch (parent.type) {
    case "CallExpression":
    case "NewExpression":
      if (parent.arguments.length === 1 && parent.arguments[0] === node) {
        return sourceCode.getTokenAfter(
          parent.callee,
          isOpeningParenToken7
        );
      }
      return null;
    case "DoWhileStatement":
      if (parent.test === node) {
        return sourceCode.getTokenAfter(
          parent.body,
          isOpeningParenToken7
        );
      }
      return null;
    case "IfStatement":
    case "WhileStatement":
      if (parent.test === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "ImportExpression":
      if (parent.source === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "SwitchStatement":
      if (parent.discriminant === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "WithStatement":
      if (parent.object === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    default:
      return null;
  }
}
function isParenthesized7(timesOrNode, nodeOrSourceCode, optionalSourceCode) {
  let times, node, sourceCode, maybeLeftParen, maybeRightParen;
  if (typeof timesOrNode === "number") {
    times = timesOrNode | 0;
    node = nodeOrSourceCode;
    sourceCode = optionalSourceCode;
    if (!(times >= 1)) {
      throw new TypeError("'times' should be a positive integer.");
    }
  } else {
    times = 1;
    node = timesOrNode;
    sourceCode = nodeOrSourceCode;
  }
  if (node == null || // `Program` can't be parenthesized
  node.parent == null || // `CatchClause.param` can't be parenthesized, example `try {} catch (error) {}`
  node.parent.type === "CatchClause" && node.parent.param === node) {
    return false;
  }
  maybeLeftParen = maybeRightParen = node;
  do {
    maybeLeftParen = sourceCode.getTokenBefore(maybeLeftParen);
    maybeRightParen = sourceCode.getTokenAfter(maybeRightParen);
  } while (maybeLeftParen != null && maybeRightParen != null && isOpeningParenToken7(maybeLeftParen) && isClosingParenToken7(maybeRightParen) && // Avoid false positive such as `if (a) {}`
  maybeLeftParen !== getParentSyntaxParen7(node, sourceCode) && --times > 0);
  return times === 0;
}
Function.call.bind(Object.hasOwnProperty);
var __defProp225 = Object.defineProperty;
var __export225 = (target, all334) => {
  for (var name22 in all334)
    __defProp225(target, name22, { get: all334[name22], enumerable: true });
};
var NodeType7 = types.AST_NODE_TYPES;
var is7 = utils.ASTUtils.isNodeOfType;
var isOneOf7 = utils.ASTUtils.isNodeOfTypes;
isOneOf7([
  NodeType7.ArrowFunctionExpression,
  NodeType7.FunctionDeclaration,
  NodeType7.FunctionExpression
]);
isOneOf7([
  NodeType7.ArrowFunctionExpression,
  NodeType7.FunctionDeclaration,
  NodeType7.FunctionExpression,
  NodeType7.TSCallSignatureDeclaration,
  NodeType7.TSConstructSignatureDeclaration,
  NodeType7.TSDeclareFunction,
  NodeType7.TSEmptyBodyFunctionExpression,
  NodeType7.TSFunctionType,
  NodeType7.TSMethodSignature
]);
isOneOf7([NodeType7.ClassDeclaration, NodeType7.ClassExpression]);
isOneOf7([
  NodeType7.DoWhileStatement,
  NodeType7.ForInStatement,
  NodeType7.ForOfStatement,
  NodeType7.ForStatement,
  NodeType7.WhileStatement
]);
isOneOf7([NodeType7.TSArrayType, NodeType7.TSTupleType]);
isOneOf7([
  NodeType7.PropertyDefinition,
  NodeType7.TSIndexSignature,
  NodeType7.TSParameterProperty,
  NodeType7.TSPropertySignature
]);
is7(NodeType7.JSXElement);
is7(NodeType7.JSXFragment);
isOneOf7([
  NodeType7.JSXAttribute,
  NodeType7.JSXSpreadChild,
  NodeType7.JSXClosingElement,
  NodeType7.JSXClosingFragment,
  NodeType7.JSXElement,
  NodeType7.JSXEmptyExpression,
  NodeType7.JSXExpressionContainer,
  NodeType7.JSXFragment,
  NodeType7.JSXIdentifier,
  NodeType7.JSXMemberExpression,
  NodeType7.JSXNamespacedName,
  NodeType7.JSXOpeningElement,
  NodeType7.JSXOpeningFragment,
  NodeType7.JSXSpreadAttribute,
  NodeType7.JSXSpreadChild,
  NodeType7.JSXText
]);
isOneOf7([
  NodeType7.JSXIdentifier,
  NodeType7.JSXMemberExpression,
  NodeType7.JSXNamespacedName
]);
isOneOf7([
  NodeType7.ArrayPattern,
  NodeType7.AssignmentPattern,
  NodeType7.ObjectPattern,
  NodeType7.RestElement
]);
isOneOf7([
  NodeType7.TSInterfaceDeclaration,
  NodeType7.TSTypeAliasDeclaration
]);
isOneOf7([
  NodeType7.ArrayExpression,
  NodeType7.ArrayPattern,
  NodeType7.ArrowFunctionExpression,
  NodeType7.CallExpression,
  NodeType7.ClassExpression,
  NodeType7.FunctionExpression,
  NodeType7.Identifier,
  NodeType7.JSXElement,
  NodeType7.JSXFragment,
  NodeType7.Literal,
  NodeType7.TemplateLiteral,
  NodeType7.MemberExpression,
  NodeType7.MetaProperty,
  NodeType7.ObjectExpression,
  NodeType7.ObjectPattern,
  NodeType7.SequenceExpression,
  NodeType7.Super,
  NodeType7.TaggedTemplateExpression,
  NodeType7.ThisExpression
]);
isOneOf7([
  NodeType7.ArrayExpression,
  NodeType7.ArrayPattern,
  NodeType7.ArrowFunctionExpression,
  NodeType7.CallExpression,
  NodeType7.ClassExpression,
  NodeType7.FunctionExpression,
  NodeType7.Identifier,
  NodeType7.JSXElement,
  NodeType7.JSXFragment,
  NodeType7.Literal,
  NodeType7.TemplateLiteral,
  NodeType7.MemberExpression,
  NodeType7.MetaProperty,
  NodeType7.ObjectExpression,
  NodeType7.ObjectPattern,
  NodeType7.SequenceExpression,
  NodeType7.Super,
  NodeType7.TaggedTemplateExpression,
  NodeType7.ThisExpression,
  NodeType7.TSAsExpression,
  NodeType7.TSNonNullExpression,
  NodeType7.TSTypeAssertion
]);
var Function_exports9 = {};
__export225(Function_exports9, {
  SK: () => SK9,
  absurd: () => absurd9,
  apply: () => apply9,
  compose: () => compose13,
  constFalse: () => constFalse9,
  constNull: () => constNull9,
  constTrue: () => constTrue9,
  constUndefined: () => constUndefined9,
  constVoid: () => constVoid9,
  constant: () => constant9,
  dual: () => dual9,
  flip: () => flip9,
  flow: () => flow9,
  hole: () => hole9,
  identity: () => identity9,
  isFunction: () => isFunction27,
  pipe: () => pipe9,
  satisfies: () => satisfies9,
  tupled: () => tupled9,
  unsafeCoerce: () => unsafeCoerce9,
  untupled: () => untupled9
});
var isFunction27 = (input) => typeof input === "function";
var dual9 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a322, b322) {
        if (arguments.length >= 2) {
          return body(a322, b322);
        }
        return function(self2) {
          return body(self2, a322);
        };
      };
    case 3:
      return function(a322, b322, c322) {
        if (arguments.length >= 3) {
          return body(a322, b322, c322);
        }
        return function(self2) {
          return body(self2, a322, b322);
        };
      };
    case 4:
      return function(a322, b322, c322, d322) {
        if (arguments.length >= 4) {
          return body(a322, b322, c322, d322);
        }
        return function(self2) {
          return body(self2, a322, b322, c322);
        };
      };
    case 5:
      return function(a322, b322, c322, d322, e322) {
        if (arguments.length >= 5) {
          return body(a322, b322, c322, d322, e322);
        }
        return function(self2) {
          return body(self2, a322, b322, c322, d322);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply9 = (a322) => (self2) => self2(a322);
var identity9 = (a322) => a322;
var satisfies9 = () => (b322) => b322;
var unsafeCoerce9 = identity9;
var constant9 = (value) => () => value;
var constTrue9 = /* @__PURE__ */ constant9(true);
var constFalse9 = /* @__PURE__ */ constant9(false);
var constNull9 = /* @__PURE__ */ constant9(null);
var constUndefined9 = /* @__PURE__ */ constant9(void 0);
var constVoid9 = constUndefined9;
var flip9 = (f322) => (...b322) => (...a322) => f322(...a322)(...b322);
var compose13 = /* @__PURE__ */ dual9(2, (ab, bc) => (a322) => bc(ab(a322)));
var absurd9 = (_322) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled9 = (f322) => (a322) => f322(...a322);
var untupled9 = (f322) => (...a322) => f322(a322);
function pipe9(a322, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a322;
    case 2:
      return ab(a322);
    case 3:
      return bc(ab(a322));
    case 4:
      return cd(bc(ab(a322)));
    case 5:
      return de(cd(bc(ab(a322))));
    case 6:
      return ef(de(cd(bc(ab(a322)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a322))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a322)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a322))))))));
    default: {
      let ret = arguments[0];
      for (let i322 = 1; i322 < arguments.length; i322++) {
        ret = arguments[i322](ret);
      }
      return ret;
    }
  }
}
function flow9(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole9 = /* @__PURE__ */ unsafeCoerce9(absurd9);
var SK9 = (_322, b322) => b322;
var make28 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_14 = (map622) => dual9(3, (self2, name22, f322) => map622(self2, (a322) => Object.assign({}, a322, {
  [name22]: f322(a322)
})));
var bindTo14 = (map622) => dual9(2, (self2, name22) => map622(self2, (a322) => ({
  [name22]: a322
})));
var bind14 = (map622, flatMap424) => dual9(3, (self2, name22, f322) => flatMap424(self2, (a322) => map622(f322(a322), (b322) => Object.assign({}, a322, {
  [name22]: b322
}))));
var moduleVersion9 = "3.2.8";
var getCurrentVersion9 = () => moduleVersion9;
var globalStoreId9 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion9()}`);
if (!(globalStoreId9 in globalThis)) {
  globalThis[globalStoreId9] = /* @__PURE__ */ new Map();
}
var globalStore9 = globalThis[globalStoreId9];
var globalValue9 = (id, compute) => {
  if (!globalStore9.has(id)) {
    globalStore9.set(id, compute());
  }
  return globalStore9.get(id);
};
var Predicate_exports7 = {};
__export225(Predicate_exports7, {
  all: () => all13,
  and: () => and9,
  compose: () => compose27,
  eqv: () => eqv9,
  every: () => every11,
  hasProperty: () => hasProperty9,
  implies: () => implies9,
  isBigInt: () => isBigInt9,
  isBoolean: () => isBoolean9,
  isDate: () => isDate9,
  isError: () => isError9,
  isFunction: () => isFunction36,
  isIterable: () => isIterable9,
  isMap: () => isMap9,
  isNever: () => isNever9,
  isNotNull: () => isNotNull9,
  isNotNullable: () => isNotNullable9,
  isNotUndefined: () => isNotUndefined9,
  isNull: () => isNull9,
  isNullable: () => isNullable9,
  isNumber: () => isNumber9,
  isObject: () => isObject9,
  isPromise: () => isPromise9,
  isPromiseLike: () => isPromiseLike9,
  isReadonlyRecord: () => isReadonlyRecord9,
  isRecord: () => isRecord9,
  isSet: () => isSet9,
  isString: () => isString9,
  isSymbol: () => isSymbol9,
  isTagged: () => isTagged9,
  isTruthy: () => isTruthy9,
  isUint8Array: () => isUint8Array9,
  isUndefined: () => isUndefined9,
  isUnknown: () => isUnknown9,
  mapInput: () => mapInput10,
  nand: () => nand9,
  nor: () => nor9,
  not: () => not9,
  or: () => or9,
  product: () => product13,
  productMany: () => productMany13,
  some: () => some19,
  struct: () => struct11,
  tuple: () => tuple10,
  xor: () => xor9
});
var mapInput10 = /* @__PURE__ */ dual9(2, (self2, f322) => (b322) => self2(f322(b322)));
var isTruthy9 = (input) => !!input;
var isSet9 = (input) => input instanceof Set;
var isMap9 = (input) => input instanceof Map;
var isString9 = (input) => typeof input === "string";
var isNumber9 = (input) => typeof input === "number";
var isBoolean9 = (input) => typeof input === "boolean";
var isBigInt9 = (input) => typeof input === "bigint";
var isSymbol9 = (input) => typeof input === "symbol";
var isFunction36 = isFunction27;
var isUndefined9 = (input) => input === void 0;
var isNotUndefined9 = (input) => input !== void 0;
var isNull9 = (input) => input === null;
var isNotNull9 = (input) => input !== null;
var isNever9 = (_322) => false;
var isUnknown9 = (_322) => true;
var isRecordOrArray9 = (input) => typeof input === "object" && input !== null;
var isObject9 = (input) => isRecordOrArray9(input) || isFunction36(input);
var hasProperty9 = /* @__PURE__ */ dual9(2, (self2, property) => isObject9(self2) && property in self2);
var isTagged9 = /* @__PURE__ */ dual9(2, (self2, tag) => hasProperty9(self2, "_tag") && self2["_tag"] === tag);
var isNullable9 = (input) => input === null || input === void 0;
var isNotNullable9 = (input) => input !== null && input !== void 0;
var isError9 = (input) => input instanceof Error;
var isUint8Array9 = (input) => input instanceof Uint8Array;
var isDate9 = (input) => input instanceof Date;
var isIterable9 = (input) => hasProperty9(input, Symbol.iterator);
var isRecord9 = (input) => isRecordOrArray9(input) && !Array.isArray(input);
var isReadonlyRecord9 = isRecord9;
var isPromise9 = (input) => hasProperty9(input, "then") && "catch" in input && isFunction36(input.then) && isFunction36(input.catch);
var isPromiseLike9 = (input) => hasProperty9(input, "then") && isFunction36(input.then);
var compose27 = /* @__PURE__ */ dual9(2, (ab, bc) => (a322) => ab(a322) && bc(a322));
var product13 = (self2, that) => ([a322, b322]) => self2(a322) && that(b322);
var all13 = (collection) => {
  return (as2422) => {
    let collectionIndex = 0;
    for (const p322 of collection) {
      if (collectionIndex >= as2422.length) {
        break;
      }
      if (p322(as2422[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany13 = (self2, collection) => {
  const rest = all13(collection);
  return ([head222, ...tail34]) => self2(head222) === false ? false : rest(tail34);
};
var tuple10 = (...elements) => all13(elements);
var struct11 = (fields) => {
  const keys234 = Object.keys(fields);
  return (a322) => {
    for (const key of keys234) {
      if (!fields[key](a322[key])) {
        return false;
      }
    }
    return true;
  };
};
var not9 = (self2) => (a322) => !self2(a322);
var or9 = /* @__PURE__ */ dual9(2, (self2, that) => (a322) => self2(a322) || that(a322));
var and9 = /* @__PURE__ */ dual9(2, (self2, that) => (a322) => self2(a322) && that(a322));
var xor9 = /* @__PURE__ */ dual9(2, (self2, that) => (a322) => self2(a322) !== that(a322));
var eqv9 = /* @__PURE__ */ dual9(2, (self2, that) => (a322) => self2(a322) === that(a322));
var implies9 = /* @__PURE__ */ dual9(2, (self2, that) => (a322) => self2(a322) ? that(a322) : true);
var nor9 = /* @__PURE__ */ dual9(2, (self2, that) => (a322) => !(self2(a322) || that(a322)));
var nand9 = /* @__PURE__ */ dual9(2, (self2, that) => (a322) => !(self2(a322) && that(a322)));
var every11 = (collection) => (a322) => {
  for (const p322 of collection) {
    if (!p322(a322)) {
      return false;
    }
  }
  return true;
};
var some19 = (collection) => (a322) => {
  for (const p322 of collection) {
    if (p322(a322)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage9 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId9 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind9 = (u322) => isObject9(u322) && GenKindTypeId9 in u322;
var GenKindImpl9 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity9;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_322) => _322;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_322) => _322;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_322) => _322;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId9] = GenKindTypeId9;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen10(this);
  }
};
var SingleShotGen10 = class _SingleShotGen12 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a322) {
    return this.called ? {
      value: a322,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a322) {
    return {
      value: a322,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e322) {
    throw e322;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen12(this.self);
  }
};
var adapter13 = () => function() {
  let x322 = arguments[0];
  for (let i322 = 1; i322 < arguments.length; i322++) {
    x322 = arguments[i322](x322);
  }
  return new GenKindImpl9(x322);
};
var defaultIncHi9 = 335903614;
var defaultIncLo9 = 4150755663;
var MUL_HI9 = 1481765933 >>> 0;
var MUL_LO9 = 1284865837 >>> 0;
var BIT_539 = 9007199254740992;
var BIT_279 = 134217728;
var PCGRandom9 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable9(seedLo) && isNullable9(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable9(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable9(incLo) && isNullable9(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo9;
      incHi = this._state ? this._state[2] : defaultIncHi9;
    } else if (isNullable9(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add649(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max34) {
    if (!max34) {
      return this._next();
    }
    max34 = max34 >>> 0;
    if ((max34 & max34 - 1) === 0) {
      return this._next() & max34 - 1;
    }
    let num = 0;
    const skew = (-max34 >>> 0) % max34 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max34;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_279 + lo) / BIT_539;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul649(this._state, oldHi, oldLo, MUL_HI9, MUL_LO9);
    add649(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul649(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add649(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId9 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap9 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId9]() {
    return this.#value;
  }
};
function yieldWrapGet9(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId9 in self2) {
    return self2[YieldWrapTypeId9]();
  }
  throw new Error(getBugErrorMessage9("yieldWrapGet"));
}
var structuralRegionState9 = /* @__PURE__ */ globalValue9("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache9 = /* @__PURE__ */ globalValue9(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr9 = /* @__PURE__ */ globalValue9(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom9());
var symbol13 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash9 = (self2) => {
  if (structuralRegionState9.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number10(self2);
    case "bigint":
      return string11(self2.toString(10));
    case "boolean":
      return string11(String(self2));
    case "symbol":
      return string11(String(self2));
    case "string":
      return string11(self2);
    case "undefined":
      return string11("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string11("null");
      } else if (self2 instanceof Date) {
        return hash9(self2.toISOString());
      } else if (isHash9(self2)) {
        return self2[symbol13]();
      } else {
        return random9(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random9 = (self2) => {
  if (!randomHashCache9.has(self2)) {
    randomHashCache9.set(self2, number10(pcgr9.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache9.get(self2);
};
var combine10 = (b322) => (self2) => self2 * 53 ^ b322;
var optimize9 = (n322) => n322 & 3221225471 | n322 >>> 1 & 1073741824;
var isHash9 = (u322) => hasProperty9(u322, symbol13);
var number10 = (n322) => {
  if (n322 !== n322 || n322 === Infinity) {
    return 0;
  }
  let h322 = n322 | 0;
  if (h322 !== n322) {
    h322 ^= n322 * 4294967295;
  }
  while (n322 > 4294967295) {
    h322 ^= n322 /= 4294967295;
  }
  return optimize9(n322);
};
var string11 = (str) => {
  let h322 = 5381, i322 = str.length;
  while (i322) {
    h322 = h322 * 33 ^ str.charCodeAt(--i322);
  }
  return optimize9(h322);
};
var structureKeys5 = (o322, keys234) => {
  let h322 = 12289;
  for (let i322 = 0; i322 < keys234.length; i322++) {
    h322 ^= pipe9(string11(keys234[i322]), combine10(hash9(o322[keys234[i322]])));
  }
  return optimize9(h322);
};
var structure5 = (o322) => structureKeys5(o322, Object.keys(o322));
var array11 = (arr) => {
  let h322 = 6151;
  for (let i322 = 0; i322 < arr.length; i322++) {
    h322 = pipe9(h322, combine10(hash9(arr[i322])));
  }
  return optimize9(h322);
};
var cached9 = function() {
  if (arguments.length === 1) {
    const self22 = arguments[0];
    return function(hash324) {
      Object.defineProperty(self22, symbol13, {
        value() {
          return hash324;
        },
        enumerable: false
      });
      return hash324;
    };
  }
  const self2 = arguments[0];
  const hash2422 = arguments[1];
  Object.defineProperty(self2, symbol13, {
    value() {
      return hash2422;
    },
    enumerable: false
  });
  return hash2422;
};
var symbol27 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals9() {
  if (arguments.length === 1) {
    return (self2) => compareBoth9(self2, arguments[0]);
  }
  return compareBoth9(arguments[0], arguments[1]);
}
function compareBoth9(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual9(self2) && isEqual9(that)) {
        if (hash9(self2) === hash9(that) && self2[symbol27](that)) {
          return true;
        } else {
          return structuralRegionState9.enabled && structuralRegionState9.tester ? structuralRegionState9.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState9.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v322, i322) => compareBoth9(v322, that[i322]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth9(self2[key], that[key]))) {
              return structuralRegionState9.tester ? structuralRegionState9.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState9.tester ? structuralRegionState9.tester(self2, that) : false;
    }
  }
  return structuralRegionState9.enabled && structuralRegionState9.tester ? structuralRegionState9.tester(self2, that) : false;
}
var isEqual9 = (u322) => hasProperty9(u322, symbol27);
var equivalence9 = () => equals9;
var NodeInspectSymbol9 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON9 = (x322) => {
  if (hasProperty9(x322, "toJSON") && isFunction36(x322["toJSON"]) && x322["toJSON"].length === 0) {
    return x322.toJSON();
  } else if (Array.isArray(x322)) {
    return x322.map(toJSON9);
  }
  return x322;
};
var format9 = (x322) => JSON.stringify(x322, null, 2);
var pipeArguments9 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i322 = 0, len = args.length; i322 < len; i322++) {
        ret = args[i322](ret);
      }
      return ret;
    }
  }
};
var OP_COMMIT5 = "Commit";
var OP_FAILURE7 = "Failure";
var OP_WITH_RUNTIME7 = "WithRuntime";
var EffectTypeId10 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId9 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId9 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId9 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance9 = {
  /* c8 ignore next */
  _R: (_322) => _322,
  /* c8 ignore next */
  _E: (_322) => _322,
  /* c8 ignore next */
  _A: (_322) => _322,
  _V: /* @__PURE__ */ getCurrentVersion9()
};
var sinkVariance9 = {
  /* c8 ignore next */
  _A: (_322) => _322,
  /* c8 ignore next */
  _In: (_322) => _322,
  /* c8 ignore next */
  _L: (_322) => _322,
  /* c8 ignore next */
  _E: (_322) => _322,
  /* c8 ignore next */
  _R: (_322) => _322
};
var channelVariance9 = {
  /* c8 ignore next */
  _Env: (_322) => _322,
  /* c8 ignore next */
  _InErr: (_322) => _322,
  /* c8 ignore next */
  _InElem: (_322) => _322,
  /* c8 ignore next */
  _InDone: (_322) => _322,
  /* c8 ignore next */
  _OutErr: (_322) => _322,
  /* c8 ignore next */
  _OutElem: (_322) => _322,
  /* c8 ignore next */
  _OutDone: (_322) => _322
};
var EffectPrototype9 = {
  [EffectTypeId10]: effectVariance9,
  [StreamTypeId9]: effectVariance9,
  [SinkTypeId9]: sinkVariance9,
  [ChannelTypeId9]: channelVariance9,
  [symbol27](that) {
    return this === that;
  },
  [symbol13]() {
    return cached9(this, random9(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen10(new YieldWrap9(this));
  },
  pipe() {
    return pipeArguments9(this, arguments);
  }
};
var StructuralPrototype5 = {
  [symbol13]() {
    return cached9(this, structure5(this));
  },
  [symbol27](that) {
    const selfKeys = Object.keys(this);
    const thatKeys = Object.keys(that);
    if (selfKeys.length !== thatKeys.length) {
      return false;
    }
    for (const key of selfKeys) {
      if (!(key in that && equals9(this[key], that[key]))) {
        return false;
      }
    }
    return true;
  }
};
var CommitPrototype5 = {
  ...EffectPrototype9,
  _op: OP_COMMIT5
};
var StructuralCommitPrototype5 = {
  ...CommitPrototype5,
  ...StructuralPrototype5
};
var TypeId28 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto13 = {
  ...EffectPrototype9,
  [TypeId28]: {
    _A: (_322) => _322
  },
  [NodeInspectSymbol9]() {
    return this.toJSON();
  },
  toString() {
    return format9(this.toJSON());
  }
};
var SomeProto9 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto13), {
  _tag: "Some",
  _op: "Some",
  [symbol27](that) {
    return isOption13(that) && isSome13(that) && equals9(this.value, that.value);
  },
  [symbol13]() {
    return cached9(this, combine10(hash9(this._tag))(hash9(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON9(this.value)
    };
  }
});
var NoneHash9 = /* @__PURE__ */ hash9("None");
var NoneProto9 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto13), {
  _tag: "None",
  _op: "None",
  [symbol27](that) {
    return isOption13(that) && isNone13(that);
  },
  [symbol13]() {
    return NoneHash9;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption13 = (input) => hasProperty9(input, TypeId28);
var isNone13 = (fa) => fa._tag === "None";
var isSome13 = (fa) => fa._tag === "Some";
var none13 = /* @__PURE__ */ Object.create(NoneProto9);
var some27 = (value) => {
  const a322 = Object.create(SomeProto9);
  a322.value = value;
  return a322;
};
var TypeId29 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto27 = {
  ...EffectPrototype9,
  [TypeId29]: {
    _R: (_322) => _322
  },
  [NodeInspectSymbol9]() {
    return this.toJSON();
  },
  toString() {
    return format9(this.toJSON());
  }
};
var RightProto9 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto27), {
  _tag: "Right",
  _op: "Right",
  [symbol27](that) {
    return isEither9(that) && isRight11(that) && equals9(this.right, that.right);
  },
  [symbol13]() {
    return combine10(hash9(this._tag))(hash9(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON9(this.right)
    };
  }
});
var LeftProto9 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto27), {
  _tag: "Left",
  _op: "Left",
  [symbol27](that) {
    return isEither9(that) && isLeft11(that) && equals9(this.left, that.left);
  },
  [symbol13]() {
    return combine10(hash9(this._tag))(hash9(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON9(this.left)
    };
  }
});
var isEither9 = (input) => hasProperty9(input, TypeId29);
var isLeft11 = (ma) => ma._tag === "Left";
var isRight11 = (ma) => ma._tag === "Right";
var left10 = (left334) => {
  const a322 = Object.create(LeftProto9);
  a322.left = left334;
  return a322;
};
var right10 = (right334) => {
  const a322 = Object.create(RightProto9);
  a322.right = right334;
  return a322;
};
var getLeft13 = (self2) => isRight11(self2) ? none13 : some27(self2.left);
var getRight13 = (self2) => isLeft11(self2) ? none13 : some27(self2.right);
var right27 = right10;
var left27 = left10;
var Option_exports9 = {};
__export225(Option_exports9, {
  Do: () => Do10,
  TypeId: () => TypeId37,
  all: () => all27,
  andThen: () => andThen9,
  ap: () => ap9,
  as: () => as9,
  asVoid: () => asVoid9,
  bind: () => bind27,
  bindTo: () => bindTo27,
  composeK: () => composeK9,
  contains: () => contains10,
  containsWith: () => containsWith10,
  exists: () => exists9,
  filter: () => filter11,
  filterMap: () => filterMap11,
  firstSomeOf: () => firstSomeOf9,
  flatMap: () => flatMap10,
  flatMapNullable: () => flatMapNullable10,
  flatten: () => flatten10,
  fromIterable: () => fromIterable13,
  fromNullable: () => fromNullable10,
  gen: () => gen9,
  getEquivalence: () => getEquivalence12,
  getLeft: () => getLeft27,
  getOrElse: () => getOrElse9,
  getOrNull: () => getOrNull9,
  getOrThrow: () => getOrThrow9,
  getOrThrowWith: () => getOrThrowWith9,
  getOrUndefined: () => getOrUndefined9,
  getOrder: () => getOrder10,
  getRight: () => getRight27,
  isNone: () => isNone27,
  isOption: () => isOption27,
  isSome: () => isSome27,
  let: () => let_27,
  lift2: () => lift29,
  liftNullable: () => liftNullable10,
  liftPredicate: () => liftPredicate10,
  liftThrowable: () => liftThrowable9,
  map: () => map11,
  match: () => match27,
  none: () => none27,
  orElse: () => orElse9,
  orElseEither: () => orElseEither9,
  orElseSome: () => orElseSome9,
  partitionMap: () => partitionMap11,
  product: () => product27,
  productMany: () => productMany27,
  reduceCompact: () => reduceCompact9,
  some: () => some37,
  tap: () => tap9,
  toArray: () => toArray9,
  toRefinement: () => toRefinement9,
  void: () => void_9,
  zipLeft: () => zipLeft9,
  zipRight: () => zipRight9,
  zipWith: () => zipWith10
});
var make29 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId37 = /* @__PURE__ */ Symbol.for("effect/Option");
var none27 = () => none13;
var some37 = some27;
var isOption27 = isOption13;
var isNone27 = isNone13;
var isSome27 = isSome13;
var match27 = /* @__PURE__ */ dual9(2, (self2, {
  onNone,
  onSome
}) => isNone27(self2) ? onNone() : onSome(self2.value));
var toRefinement9 = (f322) => (a322) => isSome27(f322(a322));
var fromIterable13 = (collection) => {
  for (const a322 of collection) {
    return some37(a322);
  }
  return none27();
};
var getRight27 = getRight13;
var getLeft27 = getLeft13;
var getOrElse9 = /* @__PURE__ */ dual9(2, (self2, onNone) => isNone27(self2) ? onNone() : self2.value);
var orElse9 = /* @__PURE__ */ dual9(2, (self2, that) => isNone27(self2) ? that() : self2);
var orElseSome9 = /* @__PURE__ */ dual9(2, (self2, onNone) => isNone27(self2) ? some37(onNone()) : self2);
var orElseEither9 = /* @__PURE__ */ dual9(2, (self2, that) => isNone27(self2) ? map11(that(), right10) : map11(self2, left10));
var firstSomeOf9 = (collection) => {
  let out = none27();
  for (out of collection) {
    if (isSome27(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable10 = (nullableValue) => nullableValue == null ? none27() : some37(nullableValue);
var liftNullable10 = (f322) => (...a322) => fromNullable10(f322(...a322));
var getOrNull9 = /* @__PURE__ */ getOrElse9(constNull9);
var getOrUndefined9 = /* @__PURE__ */ getOrElse9(constUndefined9);
var liftThrowable9 = (f322) => (...a322) => {
  try {
    return some37(f322(...a322));
  } catch (e322) {
    return none27();
  }
};
var getOrThrowWith9 = /* @__PURE__ */ dual9(2, (self2, onNone) => {
  if (isSome27(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow9 = /* @__PURE__ */ getOrThrowWith9(() => new Error("getOrThrow called on a None"));
var map11 = /* @__PURE__ */ dual9(2, (self2, f322) => isNone27(self2) ? none27() : some37(f322(self2.value)));
var as9 = /* @__PURE__ */ dual9(2, (self2, b322) => map11(self2, () => b322));
var asVoid9 = /* @__PURE__ */ as9(void 0);
var void_9 = /* @__PURE__ */ some37(void 0);
var flatMap10 = /* @__PURE__ */ dual9(2, (self2, f322) => isNone27(self2) ? none27() : f322(self2.value));
var andThen9 = /* @__PURE__ */ dual9(2, (self2, f322) => flatMap10(self2, (a322) => {
  const b322 = isFunction27(f322) ? f322(a322) : f322;
  return isOption27(b322) ? b322 : some37(b322);
}));
var flatMapNullable10 = /* @__PURE__ */ dual9(2, (self2, f322) => isNone27(self2) ? none27() : fromNullable10(f322(self2.value)));
var flatten10 = /* @__PURE__ */ flatMap10(identity9);
var zipRight9 = /* @__PURE__ */ dual9(2, (self2, that) => flatMap10(self2, () => that));
var composeK9 = /* @__PURE__ */ dual9(2, (afb, bfc) => (a322) => flatMap10(afb(a322), bfc));
var zipLeft9 = /* @__PURE__ */ dual9(2, (self2, that) => tap9(self2, () => that));
var tap9 = /* @__PURE__ */ dual9(2, (self2, f322) => flatMap10(self2, (a322) => map11(f322(a322), () => a322)));
var product27 = (self2, that) => isSome27(self2) && isSome27(that) ? some37([self2.value, that.value]) : none27();
var productMany27 = (self2, collection) => {
  if (isNone27(self2)) {
    return none27();
  }
  const out = [self2.value];
  for (const o322 of collection) {
    if (isNone27(o322)) {
      return none27();
    }
    out.push(o322.value);
  }
  return some37(out);
};
var all27 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o322 of input) {
      if (isNone27(o322)) {
        return none27();
      }
      out2.push(o322.value);
    }
    return some37(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o322 = input[key];
    if (isNone27(o322)) {
      return none27();
    }
    out[key] = o322.value;
  }
  return some37(out);
};
var zipWith10 = /* @__PURE__ */ dual9(3, (self2, that, f322) => map11(product27(self2, that), ([a322, b322]) => f322(a322, b322)));
var ap9 = /* @__PURE__ */ dual9(2, (self2, that) => zipWith10(self2, that, (f322, a322) => f322(a322)));
var reduceCompact9 = /* @__PURE__ */ dual9(3, (self2, b322, f322) => {
  let out = b322;
  for (const oa of self2) {
    if (isSome27(oa)) {
      out = f322(out, oa.value);
    }
  }
  return out;
});
var toArray9 = (self2) => isNone27(self2) ? [] : [self2.value];
var partitionMap11 = /* @__PURE__ */ dual9(2, (self2, f322) => {
  if (isNone27(self2)) {
    return [none27(), none27()];
  }
  const e322 = f322(self2.value);
  return isLeft11(e322) ? [some37(e322.left), none27()] : [none27(), some37(e322.right)];
});
var filterMap11 = /* @__PURE__ */ dual9(2, (self2, f322) => isNone27(self2) ? none27() : f322(self2.value));
var filter11 = /* @__PURE__ */ dual9(2, (self2, predicate) => filterMap11(self2, (b322) => predicate(b322) ? some27(b322) : none13));
var getEquivalence12 = (isEquivalent) => make28((x322, y322) => x322 === y322 || (isNone27(x322) ? isNone27(y322) : isNone27(y322) ? false : isEquivalent(x322.value, y322.value)));
var getOrder10 = (O322) => make29((self2, that) => isSome27(self2) ? isSome27(that) ? O322(self2.value, that.value) : 1 : -1);
var lift29 = (f322) => dual9(2, (self2, that) => zipWith10(self2, that, f322));
var liftPredicate10 = (predicate) => (b322) => predicate(b322) ? some37(b322) : none27();
var containsWith10 = (isEquivalent) => dual9(2, (self2, a322) => isNone27(self2) ? false : isEquivalent(self2.value, a322));
var _equivalence11 = /* @__PURE__ */ equivalence9();
var contains10 = /* @__PURE__ */ containsWith10(_equivalence11);
var exists9 = /* @__PURE__ */ dual9(2, (self2, refinement) => isNone27(self2) ? false : refinement(self2.value));
var bindTo27 = /* @__PURE__ */ bindTo14(map11);
var let_27 = /* @__PURE__ */ let_14(map11);
var bind27 = /* @__PURE__ */ bind14(map11, flatMap10);
var Do10 = /* @__PURE__ */ some37({});
var adapter27 = /* @__PURE__ */ adapter13();
var gen9 = (f322) => {
  const iterator = f322(adapter27);
  let state = iterator.next();
  if (state.done) {
    return some37(state.value);
  } else {
    let current = state.value;
    if (isGenKind9(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet9(current);
    }
    if (isNone27(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind9(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet9(current);
        }
        if (isNone27(current)) {
          return current;
        }
      }
    }
    return some37(state.value);
  }
};
var fromIterable27 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var reverse9 = (self2) => Array.from(self2).reverse();
var reduce11 = /* @__PURE__ */ dual9(3, (self2, b322, f322) => fromIterable27(self2).reduce((b2222, a322, i322) => f322(b2222, a322, i322), b322));
var TagTypeId7 = /* @__PURE__ */ Symbol.for("effect/Context/Tag");
var STMSymbolKey7 = "effect/STM";
var STMTypeId7 = /* @__PURE__ */ Symbol.for(STMSymbolKey7);
var TagProto7 = {
  ...EffectPrototype9,
  _tag: "Tag",
  _op: "Tag",
  [STMTypeId7]: effectVariance9,
  [TagTypeId7]: {
    _Service: (_322) => _322,
    _Identifier: (_322) => _322
  },
  toString() {
    return format9(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Tag",
      key: this.key,
      stack: this.stack
    };
  },
  [NodeInspectSymbol9]() {
    return this.toJSON();
  },
  of(self2) {
    return self2;
  },
  context(self2) {
    return make37(this, self2);
  }
};
var makeGenericTag7 = (key) => {
  const limit = Error.stackTraceLimit;
  Error.stackTraceLimit = 2;
  const creationError = new Error();
  Error.stackTraceLimit = limit;
  const tag = Object.create(TagProto7);
  Object.defineProperty(tag, "stack", {
    get() {
      return creationError.stack;
    }
  });
  tag.key = key;
  return tag;
};
var TypeId47 = /* @__PURE__ */ Symbol.for("effect/Context");
var ContextProto7 = {
  [TypeId47]: {
    _Services: (_322) => _322
  },
  [symbol27](that) {
    if (isContext7(that)) {
      if (this.unsafeMap.size === that.unsafeMap.size) {
        for (const k322 of this.unsafeMap.keys()) {
          if (!that.unsafeMap.has(k322) || !equals9(this.unsafeMap.get(k322), that.unsafeMap.get(k322))) {
            return false;
          }
        }
        return true;
      }
    }
    return false;
  },
  [symbol13]() {
    return cached9(this, number10(this.unsafeMap.size));
  },
  pipe() {
    return pipeArguments9(this, arguments);
  },
  toString() {
    return format9(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Context",
      services: Array.from(this.unsafeMap).map(toJSON9)
    };
  },
  [NodeInspectSymbol9]() {
    return this.toJSON();
  }
};
var makeContext7 = (unsafeMap) => {
  const context = Object.create(ContextProto7);
  context.unsafeMap = unsafeMap;
  return context;
};
var isContext7 = (u322) => hasProperty9(u322, TypeId47);
var _empty11 = /* @__PURE__ */ makeContext7(/* @__PURE__ */ new Map());
var empty17 = () => _empty11;
var make37 = (tag, service) => makeContext7(/* @__PURE__ */ new Map([[tag.key, service]]));
var GenericTag7 = makeGenericTag7;
var empty27 = empty17;
var TypeId57 = /* @__PURE__ */ Symbol.for("effect/Chunk");
function copy8(src, srcPos, dest, destPos, len) {
  for (let i322 = srcPos; i322 < Math.min(src.length, srcPos + len); i322++) {
    dest[destPos + i322 - srcPos] = src[i322];
  }
  return dest;
}
var emptyArray7 = [];
var getEquivalence27 = (isEquivalent) => make28((self2, that) => self2.length === that.length && toReadonlyArray7(self2).every((value, i322) => isEquivalent(value, unsafeGet27(that, i322))));
var _equivalence27 = /* @__PURE__ */ getEquivalence27(equals9);
var ChunkProto7 = {
  [TypeId57]: {
    _A: (_322) => _322
  },
  toString() {
    return format9(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Chunk",
      values: toReadonlyArray7(this).map(toJSON9)
    };
  },
  [NodeInspectSymbol9]() {
    return this.toJSON();
  },
  [symbol27](that) {
    return isChunk7(that) && _equivalence27(this, that);
  },
  [symbol13]() {
    return cached9(this, array11(toReadonlyArray7(this)));
  },
  [Symbol.iterator]() {
    switch (this.backing._tag) {
      case "IArray": {
        return this.backing.array[Symbol.iterator]();
      }
      case "IEmpty": {
        return emptyArray7[Symbol.iterator]();
      }
      default: {
        return toReadonlyArray7(this)[Symbol.iterator]();
      }
    }
  },
  pipe() {
    return pipeArguments9(this, arguments);
  }
};
var makeChunk7 = (backing) => {
  const chunk = Object.create(ChunkProto7);
  chunk.backing = backing;
  switch (backing._tag) {
    case "IEmpty": {
      chunk.length = 0;
      chunk.depth = 0;
      chunk.left = chunk;
      chunk.right = chunk;
      break;
    }
    case "IConcat": {
      chunk.length = backing.left.length + backing.right.length;
      chunk.depth = 1 + Math.max(backing.left.depth, backing.right.depth);
      chunk.left = backing.left;
      chunk.right = backing.right;
      break;
    }
    case "IArray": {
      chunk.length = backing.array.length;
      chunk.depth = 0;
      chunk.left = _empty27;
      chunk.right = _empty27;
      break;
    }
    case "ISingleton": {
      chunk.length = 1;
      chunk.depth = 0;
      chunk.left = _empty27;
      chunk.right = _empty27;
      break;
    }
    case "ISlice": {
      chunk.length = backing.length;
      chunk.depth = backing.chunk.depth + 1;
      chunk.left = _empty27;
      chunk.right = _empty27;
      break;
    }
  }
  return chunk;
};
var isChunk7 = (u322) => hasProperty9(u322, TypeId57);
var _empty27 = /* @__PURE__ */ makeChunk7({
  _tag: "IEmpty"
});
var empty37 = () => _empty27;
var make47 = (...as2422) => as2422.length === 1 ? of8(as2422[0]) : unsafeFromNonEmptyArray7(as2422);
var of8 = (a322) => makeChunk7({
  _tag: "ISingleton",
  a: a322
});
var copyToArray7 = (self2, array334, initial) => {
  switch (self2.backing._tag) {
    case "IArray": {
      copy8(self2.backing.array, 0, array334, initial, self2.length);
      break;
    }
    case "IConcat": {
      copyToArray7(self2.left, array334, initial);
      copyToArray7(self2.right, array334, initial + self2.left.length);
      break;
    }
    case "ISingleton": {
      array334[initial] = self2.backing.a;
      break;
    }
    case "ISlice": {
      let i322 = 0;
      let j322 = initial;
      while (i322 < self2.length) {
        array334[j322] = unsafeGet27(self2, i322);
        i322 += 1;
        j322 += 1;
      }
      break;
    }
  }
};
var toReadonlyArray7 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      return emptyArray7;
    }
    case "IArray": {
      return self2.backing.array;
    }
    default: {
      const arr = new Array(self2.length);
      copyToArray7(self2, arr, 0);
      self2.backing = {
        _tag: "IArray",
        array: arr
      };
      self2.left = _empty27;
      self2.right = _empty27;
      self2.depth = 0;
      return arr;
    }
  }
};
var reverse27 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty":
    case "ISingleton":
      return self2;
    case "IArray": {
      return makeChunk7({
        _tag: "IArray",
        array: reverse9(self2.backing.array)
      });
    }
    case "IConcat": {
      return makeChunk7({
        _tag: "IConcat",
        left: reverse27(self2.backing.right),
        right: reverse27(self2.backing.left)
      });
    }
    case "ISlice":
      return unsafeFromArray7(reverse9(toReadonlyArray7(self2)));
  }
};
var unsafeFromArray7 = (self2) => makeChunk7({
  _tag: "IArray",
  array: self2
});
var unsafeFromNonEmptyArray7 = (self2) => unsafeFromArray7(self2);
var unsafeGet27 = /* @__PURE__ */ dual9(2, (self2, index) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      throw new Error(`Index out of bounds`);
    }
    case "ISingleton": {
      if (index !== 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.a;
    }
    case "IArray": {
      if (index >= self2.length || index < 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.array[index];
    }
    case "IConcat": {
      return index < self2.left.length ? unsafeGet27(self2.left, index) : unsafeGet27(self2.right, index - self2.left.length);
    }
    case "ISlice": {
      return unsafeGet27(self2.backing.chunk, index + self2.backing.offset);
    }
  }
});
var prepend9 = /* @__PURE__ */ dual9(2, (self2, elem) => appendAll8(of8(elem), self2));
var drop8 = /* @__PURE__ */ dual9(2, (self2, n322) => {
  if (n322 <= 0) {
    return self2;
  } else if (n322 >= self2.length) {
    return _empty27;
  } else {
    switch (self2.backing._tag) {
      case "ISlice": {
        return makeChunk7({
          _tag: "ISlice",
          chunk: self2.backing.chunk,
          offset: self2.backing.offset + n322,
          length: self2.backing.length - n322
        });
      }
      case "IConcat": {
        if (n322 > self2.left.length) {
          return drop8(self2.right, n322 - self2.left.length);
        }
        return makeChunk7({
          _tag: "IConcat",
          left: drop8(self2.left, n322),
          right: self2.right
        });
      }
      default: {
        return makeChunk7({
          _tag: "ISlice",
          chunk: self2,
          offset: n322,
          length: self2.length - n322
        });
      }
    }
  }
});
var appendAll8 = /* @__PURE__ */ dual9(2, (self2, that) => {
  if (self2.backing._tag === "IEmpty") {
    return that;
  }
  if (that.backing._tag === "IEmpty") {
    return self2;
  }
  const diff234 = that.depth - self2.depth;
  if (Math.abs(diff234) <= 1) {
    return makeChunk7({
      _tag: "IConcat",
      left: self2,
      right: that
    });
  } else if (diff234 < -1) {
    if (self2.left.depth >= self2.right.depth) {
      const nr = appendAll8(self2.right, that);
      return makeChunk7({
        _tag: "IConcat",
        left: self2.left,
        right: nr
      });
    } else {
      const nrr = appendAll8(self2.right.right, that);
      if (nrr.depth === self2.depth - 3) {
        const nr = makeChunk7({
          _tag: "IConcat",
          left: self2.right.left,
          right: nrr
        });
        return makeChunk7({
          _tag: "IConcat",
          left: self2.left,
          right: nr
        });
      } else {
        const nl = makeChunk7({
          _tag: "IConcat",
          left: self2.left,
          right: self2.right.left
        });
        return makeChunk7({
          _tag: "IConcat",
          left: nl,
          right: nrr
        });
      }
    }
  } else {
    if (that.right.depth >= that.left.depth) {
      const nl = appendAll8(self2, that.left);
      return makeChunk7({
        _tag: "IConcat",
        left: nl,
        right: that.right
      });
    } else {
      const nll = appendAll8(self2, that.left.left);
      if (nll.depth === that.depth - 3) {
        const nl = makeChunk7({
          _tag: "IConcat",
          left: nll,
          right: that.left.right
        });
        return makeChunk7({
          _tag: "IConcat",
          left: nl,
          right: that.right
        });
      } else {
        const nr = makeChunk7({
          _tag: "IConcat",
          left: that.left.right,
          right: that.right
        });
        return makeChunk7({
          _tag: "IConcat",
          left: nll,
          right: nr
        });
      }
    }
  }
});
var isEmpty8 = (self2) => self2.length === 0;
var isNonEmpty7 = (self2) => self2.length > 0;
var unsafeHead7 = (self2) => unsafeGet27(self2, 0);
var headNonEmpty8 = unsafeHead7;
var tailNonEmpty8 = (self2) => drop8(self2, 1);
var SIZE7 = 5;
var BUCKET_SIZE7 = /* @__PURE__ */ Math.pow(2, SIZE7);
var MASK7 = BUCKET_SIZE7 - 1;
var MAX_INDEX_NODE7 = BUCKET_SIZE7 / 2;
var MIN_ARRAY_NODE7 = BUCKET_SIZE7 / 4;
function popcount7(x322) {
  x322 -= x322 >> 1 & 1431655765;
  x322 = (x322 & 858993459) + (x322 >> 2 & 858993459);
  x322 = x322 + (x322 >> 4) & 252645135;
  x322 += x322 >> 8;
  x322 += x322 >> 16;
  return x322 & 127;
}
function hashFragment7(shift22, h322) {
  return h322 >>> shift22 & MASK7;
}
function toBitmap7(x322) {
  return 1 << x322;
}
function fromBitmap7(bitmap, bit) {
  return popcount7(bitmap & bit - 1);
}
var make57 = (value, previous) => ({
  value,
  previous
});
function arrayUpdate7(mutate234, at, v322, arr) {
  let out = arr;
  if (!mutate234) {
    const len = arr.length;
    out = new Array(len);
    for (let i322 = 0; i322 < len; ++i322) out[i322] = arr[i322];
  }
  out[at] = v322;
  return out;
}
function arraySpliceOut7(mutate234, at, arr) {
  const newLen = arr.length - 1;
  let i322 = 0;
  let g322 = 0;
  let out = arr;
  if (mutate234) {
    i322 = g322 = at;
  } else {
    out = new Array(newLen);
    while (i322 < at) out[g322++] = arr[i322++];
  }
  ++i322;
  while (i322 <= newLen) out[g322++] = arr[i322++];
  if (mutate234) {
    out.length = newLen;
  }
  return out;
}
function arraySpliceIn7(mutate234, at, v322, arr) {
  const len = arr.length;
  if (mutate234) {
    let i2222 = len;
    while (i2222 >= at) arr[i2222--] = arr[i2222];
    arr[at] = v322;
    return arr;
  }
  let i322 = 0, g322 = 0;
  const out = new Array(len + 1);
  while (i322 < at) out[g322++] = arr[i322++];
  out[at] = v322;
  while (i322 < len) out[++g322] = arr[i322++];
  return out;
}
var EmptyNode7 = class _EmptyNode7 {
  _tag = "EmptyNode";
  modify(edit, _shift, f322, hash2422, key, size434) {
    const v322 = f322(none27());
    if (isNone27(v322)) return new _EmptyNode7();
    ++size434.value;
    return new LeafNode7(edit, hash2422, key, v322);
  }
};
function isEmptyNode7(a322) {
  return isTagged9(a322, "EmptyNode");
}
function isLeafNode7(node) {
  return isEmptyNode7(node) || node._tag === "LeafNode" || node._tag === "CollisionNode";
}
function canEditNode7(node, edit) {
  return isEmptyNode7(node) ? false : edit === node.edit;
}
var LeafNode7 = class _LeafNode7 {
  edit;
  hash;
  key;
  value;
  _tag = "LeafNode";
  constructor(edit, hash2422, key, value) {
    this.edit = edit;
    this.hash = hash2422;
    this.key = key;
    this.value = value;
  }
  modify(edit, shift22, f322, hash2422, key, size434) {
    if (equals9(key, this.key)) {
      const v2222 = f322(this.value);
      if (v2222 === this.value) return this;
      else if (isNone27(v2222)) {
        --size434.value;
        return new EmptyNode7();
      }
      if (canEditNode7(this, edit)) {
        this.value = v2222;
        return this;
      }
      return new _LeafNode7(edit, hash2422, key, v2222);
    }
    const v322 = f322(none27());
    if (isNone27(v322)) return this;
    ++size434.value;
    return mergeLeaves7(edit, shift22, this.hash, this, hash2422, new _LeafNode7(edit, hash2422, key, v322));
  }
};
var CollisionNode7 = class _CollisionNode7 {
  edit;
  hash;
  children;
  _tag = "CollisionNode";
  constructor(edit, hash2422, children) {
    this.edit = edit;
    this.hash = hash2422;
    this.children = children;
  }
  modify(edit, shift22, f322, hash2422, key, size434) {
    if (hash2422 === this.hash) {
      const canEdit = canEditNode7(this, edit);
      const list = this.updateCollisionList(canEdit, edit, this.hash, this.children, f322, key, size434);
      if (list === this.children) return this;
      return list.length > 1 ? new _CollisionNode7(edit, this.hash, list) : list[0];
    }
    const v322 = f322(none27());
    if (isNone27(v322)) return this;
    ++size434.value;
    return mergeLeaves7(edit, shift22, this.hash, this, hash2422, new LeafNode7(edit, hash2422, key, v322));
  }
  updateCollisionList(mutate234, edit, hash2422, list, f322, key, size434) {
    const len = list.length;
    for (let i322 = 0; i322 < len; ++i322) {
      const child = list[i322];
      if ("key" in child && equals9(key, child.key)) {
        const value = child.value;
        const newValue2 = f322(value);
        if (newValue2 === value) return list;
        if (isNone27(newValue2)) {
          --size434.value;
          return arraySpliceOut7(mutate234, i322, list);
        }
        return arrayUpdate7(mutate234, i322, new LeafNode7(edit, hash2422, key, newValue2), list);
      }
    }
    const newValue = f322(none27());
    if (isNone27(newValue)) return list;
    ++size434.value;
    return arrayUpdate7(mutate234, len, new LeafNode7(edit, hash2422, key, newValue), list);
  }
};
var IndexedNode7 = class _IndexedNode7 {
  edit;
  mask;
  children;
  _tag = "IndexedNode";
  constructor(edit, mask, children) {
    this.edit = edit;
    this.mask = mask;
    this.children = children;
  }
  modify(edit, shift22, f322, hash2422, key, size434) {
    const mask = this.mask;
    const children = this.children;
    const frag = hashFragment7(shift22, hash2422);
    const bit = toBitmap7(frag);
    const indx = fromBitmap7(mask, bit);
    const exists2422 = mask & bit;
    const canEdit = canEditNode7(this, edit);
    if (!exists2422) {
      const _newChild = new EmptyNode7().modify(edit, shift22 + SIZE7, f322, hash2422, key, size434);
      if (!_newChild) return this;
      return children.length >= MAX_INDEX_NODE7 ? expand7(edit, frag, _newChild, mask, children) : new _IndexedNode7(edit, mask | bit, arraySpliceIn7(canEdit, indx, _newChild, children));
    }
    const current = children[indx];
    const child = current.modify(edit, shift22 + SIZE7, f322, hash2422, key, size434);
    if (current === child) return this;
    let bitmap = mask;
    let newChildren;
    if (isEmptyNode7(child)) {
      bitmap &= ~bit;
      if (!bitmap) return new EmptyNode7();
      if (children.length <= 2 && isLeafNode7(children[indx ^ 1])) {
        return children[indx ^ 1];
      }
      newChildren = arraySpliceOut7(canEdit, indx, children);
    } else {
      newChildren = arrayUpdate7(canEdit, indx, child, children);
    }
    if (canEdit) {
      this.mask = bitmap;
      this.children = newChildren;
      return this;
    }
    return new _IndexedNode7(edit, bitmap, newChildren);
  }
};
var ArrayNode7 = class _ArrayNode7 {
  edit;
  size;
  children;
  _tag = "ArrayNode";
  constructor(edit, size434, children) {
    this.edit = edit;
    this.size = size434;
    this.children = children;
  }
  modify(edit, shift22, f322, hash2422, key, size434) {
    let count = this.size;
    const children = this.children;
    const frag = hashFragment7(shift22, hash2422);
    const child = children[frag];
    const newChild = (child || new EmptyNode7()).modify(edit, shift22 + SIZE7, f322, hash2422, key, size434);
    if (child === newChild) return this;
    const canEdit = canEditNode7(this, edit);
    let newChildren;
    if (isEmptyNode7(child) && !isEmptyNode7(newChild)) {
      ++count;
      newChildren = arrayUpdate7(canEdit, frag, newChild, children);
    } else if (!isEmptyNode7(child) && isEmptyNode7(newChild)) {
      --count;
      if (count <= MIN_ARRAY_NODE7) {
        return pack7(edit, count, frag, children);
      }
      newChildren = arrayUpdate7(canEdit, frag, new EmptyNode7(), children);
    } else {
      newChildren = arrayUpdate7(canEdit, frag, newChild, children);
    }
    if (canEdit) {
      this.size = count;
      this.children = newChildren;
      return this;
    }
    return new _ArrayNode7(edit, count, newChildren);
  }
};
function pack7(edit, count, removed, elements) {
  const children = new Array(count - 1);
  let g322 = 0;
  let bitmap = 0;
  for (let i322 = 0, len = elements.length; i322 < len; ++i322) {
    if (i322 !== removed) {
      const elem = elements[i322];
      if (elem && !isEmptyNode7(elem)) {
        children[g322++] = elem;
        bitmap |= 1 << i322;
      }
    }
  }
  return new IndexedNode7(edit, bitmap, children);
}
function expand7(edit, frag, child, bitmap, subNodes) {
  const arr = [];
  let bit = bitmap;
  let count = 0;
  for (let i322 = 0; bit; ++i322) {
    if (bit & 1) arr[i322] = subNodes[count++];
    bit >>>= 1;
  }
  arr[frag] = child;
  return new ArrayNode7(edit, count + 1, arr);
}
function mergeLeavesInner7(edit, shift22, h1, n1, h2222, n2222) {
  if (h1 === h2222) return new CollisionNode7(edit, h1, [n2222, n1]);
  const subH1 = hashFragment7(shift22, h1);
  const subH2 = hashFragment7(shift22, h2222);
  if (subH1 === subH2) {
    return (child) => new IndexedNode7(edit, toBitmap7(subH1) | toBitmap7(subH2), [child]);
  } else {
    const children = subH1 < subH2 ? [n1, n2222] : [n2222, n1];
    return new IndexedNode7(edit, toBitmap7(subH1) | toBitmap7(subH2), children);
  }
}
function mergeLeaves7(edit, shift22, h1, n1, h2222, n2222) {
  let stack = void 0;
  let currentShift = shift22;
  while (true) {
    const res = mergeLeavesInner7(edit, currentShift, h1, n1, h2222, n2222);
    if (typeof res === "function") {
      stack = make57(res, stack);
      currentShift = currentShift + SIZE7;
    } else {
      let final = res;
      while (stack != null) {
        final = stack.value(final);
        stack = stack.previous;
      }
      return final;
    }
  }
}
var HashMapSymbolKey7 = "effect/HashMap";
var HashMapTypeId7 = /* @__PURE__ */ Symbol.for(HashMapSymbolKey7);
var HashMapProto7 = {
  [HashMapTypeId7]: HashMapTypeId7,
  [Symbol.iterator]() {
    return new HashMapIterator7(this, (k322, v322) => [k322, v322]);
  },
  [symbol13]() {
    let hash2422 = hash9(HashMapSymbolKey7);
    for (const item of this) {
      hash2422 ^= pipe9(hash9(item[0]), combine10(hash9(item[1])));
    }
    return cached9(this, hash2422);
  },
  [symbol27](that) {
    if (isHashMap7(that)) {
      if (that._size !== this._size) {
        return false;
      }
      for (const item of this) {
        const elem = pipe9(that, getHash7(item[0], hash9(item[0])));
        if (isNone27(elem)) {
          return false;
        } else {
          if (!equals9(item[1], elem.value)) {
            return false;
          }
        }
      }
      return true;
    }
    return false;
  },
  toString() {
    return format9(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashMap",
      values: Array.from(this).map(toJSON9)
    };
  },
  [NodeInspectSymbol9]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments9(this, arguments);
  }
};
var makeImpl8 = (editable, edit, root, size434) => {
  const map622 = Object.create(HashMapProto7);
  map622._editable = editable;
  map622._edit = edit;
  map622._root = root;
  map622._size = size434;
  return map622;
};
var HashMapIterator7 = class _HashMapIterator7 {
  map;
  f;
  v;
  constructor(map622, f322) {
    this.map = map622;
    this.f = f322;
    this.v = visitLazy7(this.map._root, this.f, void 0);
  }
  next() {
    if (isNone27(this.v)) {
      return {
        done: true,
        value: void 0
      };
    }
    const v0 = this.v.value;
    this.v = applyCont7(v0.cont);
    return {
      done: false,
      value: v0.value
    };
  }
  [Symbol.iterator]() {
    return new _HashMapIterator7(this.map, this.f);
  }
};
var applyCont7 = (cont) => cont ? visitLazyChildren7(cont[0], cont[1], cont[2], cont[3], cont[4]) : none27();
var visitLazy7 = (node, f322, cont = void 0) => {
  switch (node._tag) {
    case "LeafNode": {
      if (isSome27(node.value)) {
        return some37({
          value: f322(node.key, node.value.value),
          cont
        });
      }
      return applyCont7(cont);
    }
    case "CollisionNode":
    case "ArrayNode":
    case "IndexedNode": {
      const children = node.children;
      return visitLazyChildren7(children.length, children, 0, f322, cont);
    }
    default: {
      return applyCont7(cont);
    }
  }
};
var visitLazyChildren7 = (len, children, i322, f322, cont) => {
  while (i322 < len) {
    const child = children[i322++];
    if (child && !isEmptyNode7(child)) {
      return visitLazy7(child, f322, [len, children, i322, f322, cont]);
    }
  }
  return applyCont7(cont);
};
var _empty37 = /* @__PURE__ */ makeImpl8(false, 0, /* @__PURE__ */ new EmptyNode7(), 0);
var empty47 = () => _empty37;
var isHashMap7 = (u322) => hasProperty9(u322, HashMapTypeId7);
var getHash7 = /* @__PURE__ */ dual9(3, (self2, key, hash2422) => {
  let node = self2._root;
  let shift22 = 0;
  while (true) {
    switch (node._tag) {
      case "LeafNode": {
        return equals9(key, node.key) ? node.value : none27();
      }
      case "CollisionNode": {
        if (hash2422 === node.hash) {
          const children = node.children;
          for (let i322 = 0, len = children.length; i322 < len; ++i322) {
            const child = children[i322];
            if ("key" in child && equals9(key, child.key)) {
              return child.value;
            }
          }
        }
        return none27();
      }
      case "IndexedNode": {
        const frag = hashFragment7(shift22, hash2422);
        const bit = toBitmap7(frag);
        if (node.mask & bit) {
          node = node.children[fromBitmap7(node.mask, bit)];
          shift22 += SIZE7;
          break;
        }
        return none27();
      }
      case "ArrayNode": {
        node = node.children[hashFragment7(shift22, hash2422)];
        if (node) {
          shift22 += SIZE7;
          break;
        }
        return none27();
      }
      default:
        return none27();
    }
  }
});
var set9 = /* @__PURE__ */ dual9(3, (self2, key, value) => modifyAt7(self2, key, () => some37(value)));
var setTree7 = /* @__PURE__ */ dual9(3, (self2, newRoot, newSize) => {
  if (self2._editable) {
    self2._root = newRoot;
    self2._size = newSize;
    return self2;
  }
  return newRoot === self2._root ? self2 : makeImpl8(self2._editable, self2._edit, newRoot, newSize);
});
var keys9 = (self2) => new HashMapIterator7(self2, (key) => key);
var size10 = (self2) => self2._size;
var beginMutation8 = (self2) => makeImpl8(true, self2._edit + 1, self2._root, self2._size);
var modifyAt7 = /* @__PURE__ */ dual9(3, (self2, key, f322) => modifyHash7(self2, key, hash9(key), f322));
var modifyHash7 = /* @__PURE__ */ dual9(4, (self2, key, hash2422, f322) => {
  const size434 = {
    value: self2._size
  };
  const newRoot = self2._root.modify(self2._editable ? self2._edit : NaN, 0, f322, hash2422, key, size434);
  return pipe9(self2, setTree7(newRoot, size434.value));
});
var forEach10 = /* @__PURE__ */ dual9(2, (self2, f322) => reduce27(self2, void 0, (_322, value, key) => f322(value, key)));
var reduce27 = /* @__PURE__ */ dual9(3, (self2, zero, f322) => {
  const root = self2._root;
  if (root._tag === "LeafNode") {
    return isSome27(root.value) ? f322(zero, root.value.value, root.key) : zero;
  }
  if (root._tag === "EmptyNode") {
    return zero;
  }
  const toVisit = [root.children];
  let children;
  while (children = toVisit.pop()) {
    for (let i322 = 0, len = children.length; i322 < len; ) {
      const child = children[i322++];
      if (child && !isEmptyNode7(child)) {
        if (child._tag === "LeafNode") {
          if (isSome27(child.value)) {
            zero = f322(zero, child.value.value, child.key);
          }
        } else {
          toVisit.push(child.children);
        }
      }
    }
  }
  return zero;
});
var HashSetSymbolKey7 = "effect/HashSet";
var HashSetTypeId7 = /* @__PURE__ */ Symbol.for(HashSetSymbolKey7);
var HashSetProto7 = {
  [HashSetTypeId7]: HashSetTypeId7,
  [Symbol.iterator]() {
    return keys9(this._keyMap);
  },
  [symbol13]() {
    return cached9(this, combine10(hash9(this._keyMap))(hash9(HashSetSymbolKey7)));
  },
  [symbol27](that) {
    if (isHashSet7(that)) {
      return size10(this._keyMap) === size10(that._keyMap) && equals9(this._keyMap, that._keyMap);
    }
    return false;
  },
  toString() {
    return format9(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashSet",
      values: Array.from(this).map(toJSON9)
    };
  },
  [NodeInspectSymbol9]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments9(this, arguments);
  }
};
var makeImpl27 = (keyMap) => {
  const set2422 = Object.create(HashSetProto7);
  set2422._keyMap = keyMap;
  return set2422;
};
var isHashSet7 = (u322) => hasProperty9(u322, HashSetTypeId7);
var _empty47 = /* @__PURE__ */ makeImpl27(/* @__PURE__ */ empty47());
var empty57 = () => _empty47;
var size27 = (self2) => size10(self2._keyMap);
var beginMutation27 = (self2) => makeImpl27(beginMutation8(self2._keyMap));
var endMutation7 = (self2) => {
  self2._keyMap._editable = false;
  return self2;
};
var mutate7 = /* @__PURE__ */ dual9(2, (self2, f322) => {
  const transient = beginMutation27(self2);
  f322(transient);
  return endMutation7(transient);
});
var add27 = /* @__PURE__ */ dual9(2, (self2, value) => self2._keyMap._editable ? (set9(value, true)(self2._keyMap), self2) : makeImpl27(set9(value, true)(self2._keyMap)));
var union27 = /* @__PURE__ */ dual9(2, (self2, that) => mutate7(empty57(), (set2422) => {
  forEach27(self2, (value) => add27(set2422, value));
  for (const value of that) {
    add27(set2422, value);
  }
}));
var forEach27 = /* @__PURE__ */ dual9(2, (self2, f322) => forEach10(self2._keyMap, (_322, k322) => f322(k322)));
var empty67 = empty57;
var size37 = size27;
var add37 = add27;
var union37 = union27;
var ArrayProto7 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(Array.prototype), {
  [symbol13]() {
    return cached9(this, array11(this));
  },
  [symbol27](that) {
    if (Array.isArray(that) && this.length === that.length) {
      return this.every((v322, i322) => equals9(v322, that[i322]));
    } else {
      return false;
    }
  }
});
var Structural8 = /* @__PURE__ */ function() {
  function Structural334(args) {
    if (args) {
      Object.assign(this, args);
    }
  }
  Structural334.prototype = StructuralPrototype5;
  return Structural334;
}();
var struct27 = (as2422) => Object.assign(Object.create(StructuralPrototype5), as2422);
var ContextPatchTypeId7 = /* @__PURE__ */ Symbol.for("effect/DifferContextPatch");
function variance8(a322) {
  return a322;
}
var PatchProto7 = {
  ...Structural8.prototype,
  [ContextPatchTypeId7]: {
    _Value: variance8,
    _Patch: variance8
  }
};
var EmptyProto7 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto7), {
  _tag: "Empty"
});
var _empty57 = /* @__PURE__ */ Object.create(EmptyProto7);
var empty77 = () => _empty57;
var AndThenProto7 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto7), {
  _tag: "AndThen"
});
var makeAndThen7 = (first, second) => {
  const o322 = Object.create(AndThenProto7);
  o322.first = first;
  o322.second = second;
  return o322;
};
var AddServiceProto7 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto7), {
  _tag: "AddService"
});
var makeAddService7 = (key, service) => {
  const o322 = Object.create(AddServiceProto7);
  o322.key = key;
  o322.service = service;
  return o322;
};
var RemoveServiceProto7 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto7), {
  _tag: "RemoveService"
});
var makeRemoveService7 = (key) => {
  const o322 = Object.create(RemoveServiceProto7);
  o322.key = key;
  return o322;
};
var UpdateServiceProto7 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto7), {
  _tag: "UpdateService"
});
var makeUpdateService7 = (key, update222) => {
  const o322 = Object.create(UpdateServiceProto7);
  o322.key = key;
  o322.update = update222;
  return o322;
};
var diff7 = (oldValue, newValue) => {
  const missingServices = new Map(oldValue.unsafeMap);
  let patch234 = empty77();
  for (const [tag, newService] of newValue.unsafeMap.entries()) {
    if (missingServices.has(tag)) {
      const old = missingServices.get(tag);
      missingServices.delete(tag);
      if (!equals9(old, newService)) {
        patch234 = combine27(makeUpdateService7(tag, () => newService))(patch234);
      }
    } else {
      missingServices.delete(tag);
      patch234 = combine27(makeAddService7(tag, newService))(patch234);
    }
  }
  for (const [tag] of missingServices.entries()) {
    patch234 = combine27(makeRemoveService7(tag))(patch234);
  }
  return patch234;
};
var combine27 = /* @__PURE__ */ dual9(2, (self2, that) => makeAndThen7(self2, that));
var patch7 = /* @__PURE__ */ dual9(2, (self2, context) => {
  if (self2._tag === "Empty") {
    return context;
  }
  let wasServiceUpdated = false;
  let patches = of8(self2);
  const updatedContext = new Map(context.unsafeMap);
  while (isNonEmpty7(patches)) {
    const head222 = headNonEmpty8(patches);
    const tail34 = tailNonEmpty8(patches);
    switch (head222._tag) {
      case "Empty": {
        patches = tail34;
        break;
      }
      case "AddService": {
        updatedContext.set(head222.key, head222.service);
        patches = tail34;
        break;
      }
      case "AndThen": {
        patches = prepend9(prepend9(tail34, head222.second), head222.first);
        break;
      }
      case "RemoveService": {
        updatedContext.delete(head222.key);
        patches = tail34;
        break;
      }
      case "UpdateService": {
        updatedContext.set(head222.key, head222.update(updatedContext.get(head222.key)));
        wasServiceUpdated = true;
        patches = tail34;
        break;
      }
    }
  }
  if (!wasServiceUpdated) {
    return makeContext7(updatedContext);
  }
  const map622 = /* @__PURE__ */ new Map();
  for (const [tag] of context.unsafeMap) {
    if (updatedContext.has(tag)) {
      map622.set(tag, updatedContext.get(tag));
      updatedContext.delete(tag);
    }
  }
  for (const [tag, s322] of updatedContext) {
    map622.set(tag, s322);
  }
  return makeContext7(map622);
});
var DifferTypeId7 = /* @__PURE__ */ Symbol.for("effect/Differ");
var DifferProto7 = {
  [DifferTypeId7]: {
    _P: identity9,
    _V: identity9
  }
};
var make77 = (params) => {
  const differ = Object.create(DifferProto7);
  differ.empty = params.empty;
  differ.diff = params.diff;
  differ.combine = params.combine;
  differ.patch = params.patch;
  return differ;
};
var environment7 = () => make77({
  empty: empty77(),
  combine: (first, second) => combine27(second)(first),
  diff: (oldValue, newValue) => diff7(oldValue, newValue),
  patch: (patch234, oldValue) => patch7(oldValue)(patch234)
});
var OP_DIE7 = "Die";
var OP_EMPTY7 = "Empty";
var OP_FAIL7 = "Fail";
var OP_INTERRUPT7 = "Interrupt";
var OP_PARALLEL7 = "Parallel";
var OP_SEQUENTIAL7 = "Sequential";
var CauseSymbolKey7 = "effect/Cause";
var CauseTypeId7 = /* @__PURE__ */ Symbol.for(CauseSymbolKey7);
var variance27 = {
  /* c8 ignore next */
  _E: (_322) => _322
};
var proto7 = {
  [CauseTypeId7]: variance27,
  [symbol13]() {
    return pipe9(hash9(CauseSymbolKey7), combine10(hash9(flattenCause7(this))), cached9(this));
  },
  [symbol27](that) {
    return isCause7(that) && causeEquals7(this, that);
  },
  pipe() {
    return pipeArguments9(this, arguments);
  },
  toJSON() {
    switch (this._tag) {
      case "Empty":
        return {
          _id: "Cause",
          _tag: this._tag
        };
      case "Die":
        return {
          _id: "Cause",
          _tag: this._tag,
          defect: toJSON9(this.defect)
        };
      case "Interrupt":
        return {
          _id: "Cause",
          _tag: this._tag,
          fiberId: this.fiberId.toJSON()
        };
      case "Fail":
        return {
          _id: "Cause",
          _tag: this._tag,
          failure: toJSON9(this.error)
        };
      case "Sequential":
      case "Parallel":
        return {
          _id: "Cause",
          _tag: this._tag,
          left: toJSON9(this.left),
          right: toJSON9(this.right)
        };
    }
  },
  toString() {
    return pretty7(this);
  },
  [NodeInspectSymbol9]() {
    return this.toJSON();
  }
};
var fail8 = (error) => {
  const o322 = Object.create(proto7);
  o322._tag = OP_FAIL7;
  o322.error = error;
  return o322;
};
var parallel7 = (left334, right334) => {
  const o322 = Object.create(proto7);
  o322._tag = OP_PARALLEL7;
  o322.left = left334;
  o322.right = right334;
  return o322;
};
var sequential7 = (left334, right334) => {
  const o322 = Object.create(proto7);
  o322._tag = OP_SEQUENTIAL7;
  o322.left = left334;
  o322.right = right334;
  return o322;
};
var isCause7 = (u322) => hasProperty9(u322, CauseTypeId7);
var isInterruptedOnly7 = (self2) => reduceWithContext7(void 0, IsInterruptedOnlyCauseReducer7)(self2);
var causeEquals7 = (left334, right334) => {
  let leftStack = of8(left334);
  let rightStack = of8(right334);
  while (isNonEmpty7(leftStack) && isNonEmpty7(rightStack)) {
    const [leftParallel, leftSequential] = pipe9(headNonEmpty8(leftStack), reduce47([empty67(), empty37()], ([parallel234, sequential234], cause) => {
      const [par, seq] = evaluateCause7(cause);
      return some37([pipe9(parallel234, union37(par)), pipe9(sequential234, appendAll8(seq))]);
    }));
    const [rightParallel, rightSequential] = pipe9(headNonEmpty8(rightStack), reduce47([empty67(), empty37()], ([parallel234, sequential234], cause) => {
      const [par, seq] = evaluateCause7(cause);
      return some37([pipe9(parallel234, union37(par)), pipe9(sequential234, appendAll8(seq))]);
    }));
    if (!equals9(leftParallel, rightParallel)) {
      return false;
    }
    leftStack = leftSequential;
    rightStack = rightSequential;
  }
  return true;
};
var flattenCause7 = (cause) => {
  return flattenCauseLoop7(of8(cause), empty37());
};
var flattenCauseLoop7 = (causes, flattened) => {
  while (1) {
    const [parallel234, sequential234] = pipe9(causes, reduce11([empty67(), empty37()], ([parallel322, sequential322], cause) => {
      const [par, seq] = evaluateCause7(cause);
      return [pipe9(parallel322, union37(par)), pipe9(sequential322, appendAll8(seq))];
    }));
    const updated = size37(parallel234) > 0 ? pipe9(flattened, prepend9(parallel234)) : flattened;
    if (isEmpty8(sequential234)) {
      return reverse27(updated);
    }
    causes = sequential234;
    flattened = updated;
  }
  throw new Error(getBugErrorMessage9("Cause.flattenCauseLoop"));
};
var evaluateCause7 = (self2) => {
  let cause = self2;
  const stack = [];
  let _parallel = empty67();
  let _sequential = empty37();
  while (cause !== void 0) {
    switch (cause._tag) {
      case OP_EMPTY7: {
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_FAIL7: {
        _parallel = add37(_parallel, make47(cause._tag, cause.error));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_DIE7: {
        _parallel = add37(_parallel, make47(cause._tag, cause.defect));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_INTERRUPT7: {
        _parallel = add37(_parallel, make47(cause._tag, cause.fiberId));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_SEQUENTIAL7: {
        switch (cause.left._tag) {
          case OP_EMPTY7: {
            cause = cause.right;
            break;
          }
          case OP_SEQUENTIAL7: {
            cause = sequential7(cause.left.left, sequential7(cause.left.right, cause.right));
            break;
          }
          case OP_PARALLEL7: {
            cause = parallel7(sequential7(cause.left.left, cause.right), sequential7(cause.left.right, cause.right));
            break;
          }
          default: {
            _sequential = prepend9(_sequential, cause.right);
            cause = cause.left;
            break;
          }
        }
        break;
      }
      case OP_PARALLEL7: {
        stack.push(cause.right);
        cause = cause.left;
        break;
      }
    }
  }
  throw new Error(getBugErrorMessage9("Cause.evaluateCauseLoop"));
};
var IsInterruptedOnlyCauseReducer7 = {
  emptyCase: constTrue9,
  failCase: constFalse9,
  dieCase: constFalse9,
  interruptCase: constTrue9,
  sequentialCase: (_322, left334, right334) => left334 && right334,
  parallelCase: (_322, left334, right334) => left334 && right334
};
var OP_SEQUENTIAL_CASE7 = "SequentialCase";
var OP_PARALLEL_CASE7 = "ParallelCase";
var reduce47 = /* @__PURE__ */ dual9(3, (self2, zero, pf) => {
  let accumulator = zero;
  let cause = self2;
  const causes = [];
  while (cause !== void 0) {
    const option = pf(accumulator, cause);
    accumulator = isSome27(option) ? option.value : accumulator;
    switch (cause._tag) {
      case OP_SEQUENTIAL7: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      case OP_PARALLEL7: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      default: {
        cause = void 0;
        break;
      }
    }
    if (cause === void 0 && causes.length > 0) {
      cause = causes.pop();
    }
  }
  return accumulator;
});
var reduceWithContext7 = /* @__PURE__ */ dual9(3, (self2, context, reducer) => {
  const input = [self2];
  const output = [];
  while (input.length > 0) {
    const cause = input.pop();
    switch (cause._tag) {
      case OP_EMPTY7: {
        output.push(right27(reducer.emptyCase(context)));
        break;
      }
      case OP_FAIL7: {
        output.push(right27(reducer.failCase(context, cause.error)));
        break;
      }
      case OP_DIE7: {
        output.push(right27(reducer.dieCase(context, cause.defect)));
        break;
      }
      case OP_INTERRUPT7: {
        output.push(right27(reducer.interruptCase(context, cause.fiberId)));
        break;
      }
      case OP_SEQUENTIAL7: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left27({
          _tag: OP_SEQUENTIAL_CASE7
        }));
        break;
      }
      case OP_PARALLEL7: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left27({
          _tag: OP_PARALLEL_CASE7
        }));
        break;
      }
    }
  }
  const accumulator = [];
  while (output.length > 0) {
    const either = output.pop();
    switch (either._tag) {
      case "Left": {
        switch (either.left._tag) {
          case OP_SEQUENTIAL_CASE7: {
            const left334 = accumulator.pop();
            const right334 = accumulator.pop();
            const value = reducer.sequentialCase(context, left334, right334);
            accumulator.push(value);
            break;
          }
          case OP_PARALLEL_CASE7: {
            const left334 = accumulator.pop();
            const right334 = accumulator.pop();
            const value = reducer.parallelCase(context, left334, right334);
            accumulator.push(value);
            break;
          }
        }
        break;
      }
      case "Right": {
        accumulator.push(either.right);
        break;
      }
    }
  }
  if (accumulator.length === 0) {
    throw new Error("BUG: Cause.reduceWithContext - please report an issue at https://github.com/Effect-TS/effect/issues");
  }
  return accumulator.pop();
});
var pretty7 = (cause) => {
  if (isInterruptedOnly7(cause)) {
    return "All fibers interrupted without errors.";
  }
  return prettyErrors7(cause).map((e322) => e322.stack).join("\n");
};
var PrettyError7 = class extends globalThis.Error {
  span = void 0;
  constructor(originalError) {
    const prevLimit = Error.stackTraceLimit;
    Error.stackTraceLimit = 0;
    super(prettyErrorMessage7(originalError));
    Error.stackTraceLimit = prevLimit;
    this.name = originalError instanceof Error ? originalError.name : "Error";
    if (typeof originalError === "object" && originalError !== null) {
      if (spanSymbol8 in originalError) {
        this.span = originalError[spanSymbol8];
      }
      Object.keys(originalError).forEach((key) => {
        if (!(key in this)) {
          this[key] = originalError[key];
        }
      });
    }
    this.stack = prettyErrorStack7(this.message, originalError instanceof Error && originalError.stack ? originalError.stack : "", this.span);
  }
  toJSON() {
    const out = {
      message: this.message,
      stack: this.stack
    };
    if (this.span) {
      out.span = this.span;
    }
    return out;
  }
};
var prettyErrorMessage7 = (u322) => {
  if (typeof u322 === "string") {
    return `Error: ${u322}`;
  }
  try {
    if (hasProperty9(u322, "toString") && isFunction36(u322["toString"]) && u322["toString"] !== Object.prototype.toString && u322["toString"] !== globalThis.Array.prototype.toString) {
      return u322["toString"]();
    }
  } catch {
  }
  return `Error: ${JSON.stringify(u322)}`;
};
var locationRegex7 = /\((.*)\)/;
var spanToTrace7 = /* @__PURE__ */ globalValue9("effect/Tracer/spanToTrace", () => /* @__PURE__ */ new WeakMap());
var prettyErrorStack7 = (message, stack, span24) => {
  const out = [message];
  const lines = stack.split("\n");
  for (let i322 = 1; i322 < lines.length; i322++) {
    if (lines[i322].includes("Generator.next")) {
      break;
    }
    if (lines[i322].includes("effect_internal_function")) {
      out.pop();
      break;
    }
    out.push(lines[i322].replace(/at .*effect_instruction_i.*\((.*)\)/, "at $1").replace(/EffectPrimitive\.\w+/, "<anonymous>"));
  }
  if (span24) {
    let current = span24;
    let i322 = 0;
    while (current && current._tag === "Span" && i322 < 10) {
      const stackFn = spanToTrace7.get(current);
      if (typeof stackFn === "function") {
        const stack2 = stackFn();
        const locationMatch = stack2.match(locationRegex7);
        const location = locationMatch ? locationMatch[1] : stack2.replace(/^at /, "");
        out.push(`    at ${current.name} (${location})`);
      } else {
        out.push(`    at ${current.name}`);
      }
      current = getOrUndefined9(current.parent);
      i322++;
    }
  }
  return out.join("\n");
};
var spanSymbol8 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var prettyErrors7 = (cause) => reduceWithContext7(cause, void 0, {
  emptyCase: () => [],
  dieCase: (_322, unknownError) => {
    return [new PrettyError7(unknownError)];
  },
  failCase: (_322, error) => {
    return [new PrettyError7(error)];
  },
  interruptCase: () => [],
  parallelCase: (_322, l322, r322) => [...l322, ...r322],
  sequentialCase: (_322, l322, r322) => [...l322, ...r322]
});
var SingleShotGen27 = class _SingleShotGen26 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  next(a322) {
    return this.called ? {
      value: a322,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  return(a322) {
    return {
      value: a322,
      done: true
    };
  }
  throw(e322) {
    throw e322;
  }
  [Symbol.iterator]() {
    return new _SingleShotGen26(this.self);
  }
};
var spanTag7 = /* @__PURE__ */ GenericTag7("effect/ParentSpan");
var EffectTypeId27 = /* @__PURE__ */ Symbol.for("effect/Effect");
var EffectPrimitive7 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId27] = effectVariance9;
  constructor(_op) {
    this._op = _op;
  }
  [symbol27](that) {
    return this === that;
  }
  [symbol13]() {
    return cached9(this, random9(this));
  }
  pipe() {
    return pipeArguments9(this, arguments);
  }
  toJSON() {
    return {
      _id: "Effect",
      _op: this._op,
      effect_instruction_i0: toJSON9(this.effect_instruction_i0),
      effect_instruction_i1: toJSON9(this.effect_instruction_i1),
      effect_instruction_i2: toJSON9(this.effect_instruction_i2)
    };
  }
  toString() {
    return format9(this.toJSON());
  }
  [NodeInspectSymbol9]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen27(new YieldWrap9(this));
  }
};
var EffectPrimitiveFailure7 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId27] = effectVariance9;
  constructor(_op) {
    this._op = _op;
    this._tag = _op;
  }
  [symbol27](that) {
    return exitIsExit7(that) && that._op === "Failure" && // @ts-expect-error
    equals9(this.effect_instruction_i0, that.effect_instruction_i0);
  }
  [symbol13]() {
    return pipe9(
      // @ts-expect-error
      string11(this._tag),
      // @ts-expect-error
      combine10(hash9(this.effect_instruction_i0)),
      cached9(this)
    );
  }
  get cause() {
    return this.effect_instruction_i0;
  }
  pipe() {
    return pipeArguments9(this, arguments);
  }
  toJSON() {
    return {
      _id: "Exit",
      _tag: this._op,
      cause: this.cause.toJSON()
    };
  }
  toString() {
    return format9(this.toJSON());
  }
  [NodeInspectSymbol9]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen27(new YieldWrap9(this));
  }
};
var isEffect7 = (u322) => hasProperty9(u322, EffectTypeId27);
var withFiberRuntime7 = (withRuntime) => {
  const effect = new EffectPrimitive7(OP_WITH_RUNTIME7);
  effect.effect_instruction_i0 = withRuntime;
  return effect;
};
var spanSymbol27 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var originalSymbol7 = /* @__PURE__ */ Symbol.for("effect/OriginalAnnotation");
var capture7 = (obj, span24) => {
  if (isSome27(span24)) {
    return new Proxy(obj, {
      has(target, p322) {
        return p322 === spanSymbol27 || p322 === originalSymbol7 || p322 in target;
      },
      get(target, p322) {
        if (p322 === spanSymbol27) {
          return span24.value;
        }
        if (p322 === originalSymbol7) {
          return obj;
        }
        return target[p322];
      }
    });
  }
  return obj;
};
var fail27 = (error) => isObject9(error) && !(spanSymbol27 in error) ? withFiberRuntime7((fiber) => failCause7(fail8(capture7(error, currentSpanFromFiber7(fiber))))) : failCause7(fail8(error));
var failCause7 = (cause) => {
  const effect = new EffectPrimitiveFailure7(OP_FAILURE7);
  effect.effect_instruction_i0 = cause;
  return effect;
};
var FiberRefSymbolKey7 = "effect/FiberRef";
var FiberRefTypeId7 = /* @__PURE__ */ Symbol.for(FiberRefSymbolKey7);
var fiberRefVariance7 = {
  /* c8 ignore next */
  _A: (_322) => _322
};
var fiberRefUnsafeMakeContext7 = (initial) => {
  const differ = environment7();
  return fiberRefUnsafeMakePatch7(initial, {
    differ,
    fork: differ.empty
  });
};
var fiberRefUnsafeMakePatch7 = (initial, options) => ({
  [FiberRefTypeId7]: fiberRefVariance7,
  initial,
  diff: (oldValue, newValue) => options.differ.diff(oldValue, newValue),
  combine: (first, second) => options.differ.combine(first, second),
  patch: (patch234) => (oldValue) => options.differ.patch(patch234, oldValue),
  fork: options.fork,
  join: options.join ?? ((_322, n322) => n322),
  pipe() {
    return pipeArguments9(this, arguments);
  }
});
var currentContext7 = /* @__PURE__ */ globalValue9(/* @__PURE__ */ Symbol.for("effect/FiberRef/currentContext"), () => fiberRefUnsafeMakeContext7(empty27()));
var YieldableError7 = /* @__PURE__ */ function() {
  class YieldableError234 extends globalThis.Error {
    commit() {
      return fail27(this);
    }
    toString() {
      return this.message ? `${this.name}: ${this.message}` : this.name;
    }
    toJSON() {
      return {
        ...this
      };
    }
    [NodeInspectSymbol9]() {
      const stack = this.stack;
      if (stack) {
        return `${this.toString()}
${stack.split("\n").slice(1).join("\n")}`;
      }
      return this.toString();
    }
  }
  Object.assign(YieldableError234.prototype, StructuralCommitPrototype5);
  return YieldableError234;
}();
var exitIsExit7 = (u322) => isEffect7(u322) && "_tag" in u322 && (u322._tag === "Success" || u322._tag === "Failure");
var currentSpanFromFiber7 = (fiber) => {
  const span24 = fiber.getFiberRef(currentContext7).unsafeMap.get(spanTag7.key);
  return span24 !== void 0 && span24._tag === "Span" ? some37(span24) : none27();
};
var Data_exports5 = {};
__export225(Data_exports5, {
  Class: () => Class27,
  Error: () => Error27,
  Structural: () => Structural27,
  TaggedClass: () => TaggedClass7,
  TaggedError: () => TaggedError7,
  array: () => array27,
  case: () => _case7,
  struct: () => struct37,
  tagged: () => tagged7,
  taggedEnum: () => taggedEnum7,
  tuple: () => tuple27,
  unsafeArray: () => unsafeArray7,
  unsafeStruct: () => unsafeStruct7
});
var struct37 = struct27;
var unsafeStruct7 = (as2422) => Object.setPrototypeOf(as2422, StructuralPrototype5);
var tuple27 = (...as2422) => unsafeArray7(as2422);
var array27 = (as2422) => unsafeArray7(as2422.slice(0));
var unsafeArray7 = (as2422) => Object.setPrototypeOf(as2422, ArrayProto7);
var _case7 = () => (args) => args === void 0 ? Object.create(StructuralPrototype5) : struct37(args);
var tagged7 = (tag) => (args) => {
  const value = args === void 0 ? Object.create(StructuralPrototype5) : struct37(args);
  value._tag = tag;
  return value;
};
var Class27 = Structural8;
var TaggedClass7 = (tag) => {
  class Base extends Class27 {
    _tag = tag;
  }
  return Base;
};
var Structural27 = Structural8;
var taggedEnum7 = () => new Proxy({}, {
  get(_target, tag, _receiver) {
    if (tag === "$is") {
      return isTagged9;
    } else if (tag === "$match") {
      return taggedMatch7;
    }
    return tagged7(tag);
  }
});
function taggedMatch7() {
  if (arguments.length === 1) {
    const cases2 = arguments[0];
    return function(value2) {
      return cases2[value2._tag](value2);
    };
  }
  const value = arguments[0];
  const cases = arguments[1];
  return cases[value._tag](value);
}
var Error27 = /* @__PURE__ */ function() {
  return class Base extends YieldableError7 {
    constructor(args) {
      super();
      if (args) {
        Object.assign(this, args);
      }
    }
  };
}();
var TaggedError7 = (tag) => {
  class Base extends Error27 {
    _tag = tag;
  }
  Base.prototype.name = tag;
  return Base;
};
var traverseUp7 = Function_exports9.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType7.Program) return Option_exports9.none();
  return predicate(parent) ? Option_exports9.some(parent) : traverseUp7(parent, predicate);
});
var traverseUpGuard7 = Function_exports9.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType7.Program) return Option_exports9.none();
  return predicate(parent) ? Option_exports9.some(parent) : traverseUpGuard7(parent, predicate);
});
var ESLintCommunityESLintUtils7;
((ESLintCommunityESLintUtils234) => {
  ESLintCommunityESLintUtils234.getFunctionHeadLocation = getFunctionHeadLocation7;
  ESLintCommunityESLintUtils234.getFunctionNameWithKind = getFunctionNameWithKind7;
  ESLintCommunityESLintUtils234.getPropertyName = getPropertyName7;
  ESLintCommunityESLintUtils234.getStaticValue = getStaticValue7;
  ESLintCommunityESLintUtils234.getStringIfConstant = getStringIfConstant7;
  ESLintCommunityESLintUtils234.hasSideEffect = hasSideEffect7;
  ESLintCommunityESLintUtils234.isParenthesized = isParenthesized7;
})(ESLintCommunityESLintUtils7 || (ESLintCommunityESLintUtils7 = {}));
var Construction7 = Data_exports5.taggedEnum();
Construction7.None();
function getFunctionIdentifier3(node) {
  if (node.id) return Option_exports9.some(node.id);
  if (node.parent.type === NodeType7.VariableDeclarator && node.parent.init === node && node.parent.id.type === NodeType7.Identifier) {
    return Option_exports9.some(node.parent.id);
  }
  if (node.parent.type === NodeType7.AssignmentExpression && node.parent.right === node && node.parent.operator === "=" && node.parent.left.type === NodeType7.Identifier) {
    return Option_exports9.some(node.parent.left);
  }
  if (node.parent.type === NodeType7.Property && node.parent.value === node && !node.parent.computed && node.parent.key.type === NodeType7.Identifier) {
    return Option_exports9.some(node.parent.key);
  }
  if (isOneOf7([NodeType7.MethodDefinition, NodeType7.PropertyDefinition])(node.parent) && node.parent.value === node && node.parent.key.type === NodeType7.Identifier) {
    return Option_exports9.some(node.parent.key);
  }
  if (node.parent.type === NodeType7.AssignmentPattern && node.parent.right === node && node.parent.left.type === NodeType7.Identifier) {
    return Option_exports9.some(node.parent.left);
  }
  return Option_exports9.none();
}
a6({
  type: N6.union([NodeType7.FunctionExpression, NodeType7.ArrowFunctionExpression]),
  parent: {
    type: NodeType7.Property,
    parent: {
      type: NodeType7.ObjectExpression
    }
  }
});
a6({
  type: N6.union([NodeType7.FunctionExpression, NodeType7.ArrowFunctionExpression]),
  parent: {
    type: NodeType7.MethodDefinition,
    parent: {
      type: NodeType7.ClassBody
    }
  }
});
a6({
  type: N6.union([NodeType7.FunctionExpression, NodeType7.ArrowFunctionExpression]),
  parent: {
    type: NodeType7.Property,
    parent: {
      type: NodeType7.ClassBody
    }
  }
});
var __defProp34 = Object.defineProperty;
var __export34 = (target, all622) => {
  for (var name22 in all622)
    __defProp34(target, name22, { get: all622[name22], enumerable: true });
};
var KEYS24 = {
  ArrayExpression: [
    "elements"
  ],
  ArrayPattern: [
    "elements"
  ],
  ArrowFunctionExpression: [
    "params",
    "body"
  ],
  AssignmentExpression: [
    "left",
    "right"
  ],
  AssignmentPattern: [
    "left",
    "right"
  ],
  AwaitExpression: [
    "argument"
  ],
  BinaryExpression: [
    "left",
    "right"
  ],
  BlockStatement: [
    "body"
  ],
  BreakStatement: [
    "label"
  ],
  CallExpression: [
    "callee",
    "arguments"
  ],
  CatchClause: [
    "param",
    "body"
  ],
  ChainExpression: [
    "expression"
  ],
  ClassBody: [
    "body"
  ],
  ClassDeclaration: [
    "id",
    "superClass",
    "body"
  ],
  ClassExpression: [
    "id",
    "superClass",
    "body"
  ],
  ConditionalExpression: [
    "test",
    "consequent",
    "alternate"
  ],
  ContinueStatement: [
    "label"
  ],
  DebuggerStatement: [],
  DoWhileStatement: [
    "body",
    "test"
  ],
  EmptyStatement: [],
  ExperimentalRestProperty: [
    "argument"
  ],
  ExperimentalSpreadProperty: [
    "argument"
  ],
  ExportAllDeclaration: [
    "exported",
    "source"
  ],
  ExportDefaultDeclaration: [
    "declaration"
  ],
  ExportNamedDeclaration: [
    "declaration",
    "specifiers",
    "source"
  ],
  ExportSpecifier: [
    "exported",
    "local"
  ],
  ExpressionStatement: [
    "expression"
  ],
  ForInStatement: [
    "left",
    "right",
    "body"
  ],
  ForOfStatement: [
    "left",
    "right",
    "body"
  ],
  ForStatement: [
    "init",
    "test",
    "update",
    "body"
  ],
  FunctionDeclaration: [
    "id",
    "params",
    "body"
  ],
  FunctionExpression: [
    "id",
    "params",
    "body"
  ],
  Identifier: [],
  IfStatement: [
    "test",
    "consequent",
    "alternate"
  ],
  ImportDeclaration: [
    "specifiers",
    "source"
  ],
  ImportDefaultSpecifier: [
    "local"
  ],
  ImportExpression: [
    "source"
  ],
  ImportNamespaceSpecifier: [
    "local"
  ],
  ImportSpecifier: [
    "imported",
    "local"
  ],
  JSXAttribute: [
    "name",
    "value"
  ],
  JSXClosingElement: [
    "name"
  ],
  JSXClosingFragment: [],
  JSXElement: [
    "openingElement",
    "children",
    "closingElement"
  ],
  JSXEmptyExpression: [],
  JSXExpressionContainer: [
    "expression"
  ],
  JSXFragment: [
    "openingFragment",
    "children",
    "closingFragment"
  ],
  JSXIdentifier: [],
  JSXMemberExpression: [
    "object",
    "property"
  ],
  JSXNamespacedName: [
    "namespace",
    "name"
  ],
  JSXOpeningElement: [
    "name",
    "attributes"
  ],
  JSXOpeningFragment: [],
  JSXSpreadAttribute: [
    "argument"
  ],
  JSXSpreadChild: [
    "expression"
  ],
  JSXText: [],
  LabeledStatement: [
    "label",
    "body"
  ],
  Literal: [],
  LogicalExpression: [
    "left",
    "right"
  ],
  MemberExpression: [
    "object",
    "property"
  ],
  MetaProperty: [
    "meta",
    "property"
  ],
  MethodDefinition: [
    "key",
    "value"
  ],
  NewExpression: [
    "callee",
    "arguments"
  ],
  ObjectExpression: [
    "properties"
  ],
  ObjectPattern: [
    "properties"
  ],
  PrivateIdentifier: [],
  Program: [
    "body"
  ],
  Property: [
    "key",
    "value"
  ],
  PropertyDefinition: [
    "key",
    "value"
  ],
  RestElement: [
    "argument"
  ],
  ReturnStatement: [
    "argument"
  ],
  SequenceExpression: [
    "expressions"
  ],
  SpreadElement: [
    "argument"
  ],
  StaticBlock: [
    "body"
  ],
  Super: [],
  SwitchCase: [
    "test",
    "consequent"
  ],
  SwitchStatement: [
    "discriminant",
    "cases"
  ],
  TaggedTemplateExpression: [
    "tag",
    "quasi"
  ],
  TemplateElement: [],
  TemplateLiteral: [
    "quasis",
    "expressions"
  ],
  ThisExpression: [],
  ThrowStatement: [
    "argument"
  ],
  TryStatement: [
    "block",
    "handler",
    "finalizer"
  ],
  UnaryExpression: [
    "argument"
  ],
  UpdateExpression: [
    "argument"
  ],
  VariableDeclaration: [
    "declarations"
  ],
  VariableDeclarator: [
    "id",
    "init"
  ],
  WhileStatement: [
    "test",
    "body"
  ],
  WithStatement: [
    "object",
    "body"
  ],
  YieldExpression: [
    "argument"
  ]
};
var NODE_TYPES24 = Object.keys(KEYS24);
for (const type of NODE_TYPES24) {
  Object.freeze(KEYS24[type]);
}
Object.freeze(KEYS24);
var visitor_keys_default24 = KEYS24;
var KEY_BLACKLIST24 = /* @__PURE__ */ new Set([
  "parent",
  "leadingComments",
  "trailingComments"
]);
function filterKey24(key) {
  return !KEY_BLACKLIST24.has(key) && key[0] !== "_";
}
function getKeys24(node) {
  return Object.keys(node).filter(filterKey24);
}
function getInnermostScope24(initialScope, node) {
  const location = node.range[0];
  let scope = initialScope;
  let found = false;
  do {
    found = false;
    for (const childScope of scope.childScopes) {
      const range24 = childScope.block.range;
      if (range24[0] <= location && location < range24[1]) {
        scope = childScope;
        found = true;
        break;
      }
    }
  } while (found);
  return scope;
}
function findVariable26(initialScope, nameOrNode) {
  let name22 = "";
  let scope = initialScope;
  if (typeof nameOrNode === "string") {
    name22 = nameOrNode;
  } else {
    name22 = nameOrNode.name;
    scope = getInnermostScope24(scope, nameOrNode);
  }
  while (scope != null) {
    const variable = scope.set.get(name22);
    if (variable != null) {
      return variable;
    }
    scope = scope.upper;
  }
  return null;
}
function negate024(token) {
  return !this(token);
}
function negate24(f2222) {
  return negate024.bind(f2222);
}
function isPunctuatorTokenWithValue24(token, value) {
  return token.type === "Punctuator" && token.value === value;
}
function isArrowToken24(token) {
  return isPunctuatorTokenWithValue24(token, "=>");
}
function isCommaToken24(token) {
  return isPunctuatorTokenWithValue24(token, ",");
}
function isSemicolonToken24(token) {
  return isPunctuatorTokenWithValue24(token, ";");
}
function isColonToken24(token) {
  return isPunctuatorTokenWithValue24(token, ":");
}
function isOpeningParenToken24(token) {
  return isPunctuatorTokenWithValue24(token, "(");
}
function isClosingParenToken24(token) {
  return isPunctuatorTokenWithValue24(token, ")");
}
function isOpeningBracketToken24(token) {
  return isPunctuatorTokenWithValue24(token, "[");
}
function isClosingBracketToken24(token) {
  return isPunctuatorTokenWithValue24(token, "]");
}
function isOpeningBraceToken24(token) {
  return isPunctuatorTokenWithValue24(token, "{");
}
function isClosingBraceToken24(token) {
  return isPunctuatorTokenWithValue24(token, "}");
}
function isCommentToken24(token) {
  return ["Block", "Line", "Shebang"].includes(token.type);
}
negate24(isArrowToken24);
negate24(isCommaToken24);
negate24(isSemicolonToken24);
negate24(isColonToken24);
negate24(isOpeningParenToken24);
negate24(isClosingParenToken24);
negate24(isOpeningBracketToken24);
negate24(isClosingBracketToken24);
negate24(isOpeningBraceToken24);
negate24(isClosingBraceToken24);
negate24(isCommentToken24);
function getOpeningParenOfParams24(node, sourceCode) {
  return node.id ? sourceCode.getTokenAfter(node.id, isOpeningParenToken24) : sourceCode.getFirstToken(node, isOpeningParenToken24);
}
function getFunctionHeadLocation24(node, sourceCode) {
  const parent = node.parent;
  let start = null;
  let end = null;
  if (node.type === "ArrowFunctionExpression") {
    const arrowToken = sourceCode.getTokenBefore(node.body, isArrowToken24);
    start = arrowToken.loc.start;
    end = arrowToken.loc.end;
  } else if (parent.type === "Property" || parent.type === "MethodDefinition" || parent.type === "PropertyDefinition") {
    start = parent.loc.start;
    end = getOpeningParenOfParams24(node, sourceCode).loc.start;
  } else {
    start = node.loc.start;
    end = getOpeningParenOfParams24(node, sourceCode).loc.start;
  }
  return {
    start: { ...start },
    end: { ...end }
  };
}
var globalObject24 = typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {};
var builtinNames24 = Object.freeze(
  /* @__PURE__ */ new Set([
    "Array",
    "ArrayBuffer",
    "BigInt",
    "BigInt64Array",
    "BigUint64Array",
    "Boolean",
    "DataView",
    "Date",
    "decodeURI",
    "decodeURIComponent",
    "encodeURI",
    "encodeURIComponent",
    "escape",
    "Float32Array",
    "Float64Array",
    "Function",
    "Infinity",
    "Int16Array",
    "Int32Array",
    "Int8Array",
    "isFinite",
    "isNaN",
    "isPrototypeOf",
    "JSON",
    "Map",
    "Math",
    "NaN",
    "Number",
    "Object",
    "parseFloat",
    "parseInt",
    "Promise",
    "Proxy",
    "Reflect",
    "RegExp",
    "Set",
    "String",
    "Symbol",
    "Uint16Array",
    "Uint32Array",
    "Uint8Array",
    "Uint8ClampedArray",
    "undefined",
    "unescape",
    "WeakMap",
    "WeakSet"
  ])
);
var callAllowed24 = new Set(
  [
    Array.isArray,
    Array.of,
    Array.prototype.at,
    Array.prototype.concat,
    Array.prototype.entries,
    Array.prototype.every,
    Array.prototype.filter,
    Array.prototype.find,
    Array.prototype.findIndex,
    Array.prototype.flat,
    Array.prototype.includes,
    Array.prototype.indexOf,
    Array.prototype.join,
    Array.prototype.keys,
    Array.prototype.lastIndexOf,
    Array.prototype.slice,
    Array.prototype.some,
    Array.prototype.toString,
    Array.prototype.values,
    typeof BigInt === "function" ? BigInt : void 0,
    Boolean,
    Date,
    Date.parse,
    decodeURI,
    decodeURIComponent,
    encodeURI,
    encodeURIComponent,
    escape,
    isFinite,
    isNaN,
    isPrototypeOf,
    Map,
    Map.prototype.entries,
    Map.prototype.get,
    Map.prototype.has,
    Map.prototype.keys,
    Map.prototype.values,
    ...Object.getOwnPropertyNames(Math).filter((k2222) => k2222 !== "random").map((k2222) => Math[k2222]).filter((f2222) => typeof f2222 === "function"),
    Number,
    Number.isFinite,
    Number.isNaN,
    Number.parseFloat,
    Number.parseInt,
    Number.prototype.toExponential,
    Number.prototype.toFixed,
    Number.prototype.toPrecision,
    Number.prototype.toString,
    Object,
    Object.entries,
    Object.is,
    Object.isExtensible,
    Object.isFrozen,
    Object.isSealed,
    Object.keys,
    Object.values,
    parseFloat,
    parseInt,
    RegExp,
    Set,
    Set.prototype.entries,
    Set.prototype.has,
    Set.prototype.keys,
    Set.prototype.values,
    String,
    String.fromCharCode,
    String.fromCodePoint,
    String.raw,
    String.prototype.at,
    String.prototype.charAt,
    String.prototype.charCodeAt,
    String.prototype.codePointAt,
    String.prototype.concat,
    String.prototype.endsWith,
    String.prototype.includes,
    String.prototype.indexOf,
    String.prototype.lastIndexOf,
    String.prototype.normalize,
    String.prototype.padEnd,
    String.prototype.padStart,
    String.prototype.slice,
    String.prototype.startsWith,
    String.prototype.substr,
    String.prototype.substring,
    String.prototype.toLowerCase,
    String.prototype.toString,
    String.prototype.toUpperCase,
    String.prototype.trim,
    String.prototype.trimEnd,
    String.prototype.trimLeft,
    String.prototype.trimRight,
    String.prototype.trimStart,
    Symbol.for,
    Symbol.keyFor,
    unescape
  ].filter((f2222) => typeof f2222 === "function")
);
var callPassThrough24 = /* @__PURE__ */ new Set([
  Object.freeze,
  Object.preventExtensions,
  Object.seal
]);
var getterAllowed24 = [
  [Map, /* @__PURE__ */ new Set(["size"])],
  [
    RegExp,
    /* @__PURE__ */ new Set([
      "dotAll",
      "flags",
      "global",
      "hasIndices",
      "ignoreCase",
      "multiline",
      "source",
      "sticky",
      "unicode"
    ])
  ],
  [Set, /* @__PURE__ */ new Set(["size"])]
];
function getPropertyDescriptor24(object222, name22) {
  let x2222 = object222;
  while ((typeof x2222 === "object" || typeof x2222 === "function") && x2222 !== null) {
    const d2222 = Object.getOwnPropertyDescriptor(x2222, name22);
    if (d2222) {
      return d2222;
    }
    x2222 = Object.getPrototypeOf(x2222);
  }
  return null;
}
function isGetter24(object222, name22) {
  const d2222 = getPropertyDescriptor24(object222, name22);
  return d2222 != null && d2222.get != null;
}
function getElementValues24(nodeList, initialScope) {
  const valueList = [];
  for (let i2222 = 0; i2222 < nodeList.length; ++i2222) {
    const elementNode = nodeList[i2222];
    if (elementNode == null) {
      valueList.length = i2222 + 1;
    } else if (elementNode.type === "SpreadElement") {
      const argument = getStaticValueR24(elementNode.argument, initialScope);
      if (argument == null) {
        return null;
      }
      valueList.push(...argument.value);
    } else {
      const element = getStaticValueR24(elementNode, initialScope);
      if (element == null) {
        return null;
      }
      valueList.push(element.value);
    }
  }
  return valueList;
}
function isEffectivelyConst24(variable) {
  const refs = variable.references;
  const inits = refs.filter((r2222) => r2222.init).length;
  const reads = refs.filter((r2222) => r2222.isReadOnly()).length;
  if (inits === 1 && reads + inits === refs.length) {
    return true;
  }
  return false;
}
var operations24 = Object.freeze({
  ArrayExpression(node, initialScope) {
    const elements = getElementValues24(node.elements, initialScope);
    return elements != null ? { value: elements } : null;
  },
  AssignmentExpression(node, initialScope) {
    if (node.operator === "=") {
      return getStaticValueR24(node.right, initialScope);
    }
    return null;
  },
  //eslint-disable-next-line complexity
  BinaryExpression(node, initialScope) {
    if (node.operator === "in" || node.operator === "instanceof") {
      return null;
    }
    const left522 = getStaticValueR24(node.left, initialScope);
    const right522 = getStaticValueR24(node.right, initialScope);
    if (left522 != null && right522 != null) {
      switch (node.operator) {
        case "==":
          return { value: left522.value == right522.value };
        case "!=":
          return { value: left522.value != right522.value };
        case "===":
          return { value: left522.value === right522.value };
        case "!==":
          return { value: left522.value !== right522.value };
        case "<":
          return { value: left522.value < right522.value };
        case "<=":
          return { value: left522.value <= right522.value };
        case ">":
          return { value: left522.value > right522.value };
        case ">=":
          return { value: left522.value >= right522.value };
        case "<<":
          return { value: left522.value << right522.value };
        case ">>":
          return { value: left522.value >> right522.value };
        case ">>>":
          return { value: left522.value >>> right522.value };
        case "+":
          return { value: left522.value + right522.value };
        case "-":
          return { value: left522.value - right522.value };
        case "*":
          return { value: left522.value * right522.value };
        case "/":
          return { value: left522.value / right522.value };
        case "%":
          return { value: left522.value % right522.value };
        case "**":
          return { value: left522.value ** right522.value };
        case "|":
          return { value: left522.value | right522.value };
        case "^":
          return { value: left522.value ^ right522.value };
        case "&":
          return { value: left522.value & right522.value };
      }
    }
    return null;
  },
  CallExpression(node, initialScope) {
    const calleeNode = node.callee;
    const args = getElementValues24(node.arguments, initialScope);
    if (args != null) {
      if (calleeNode.type === "MemberExpression") {
        if (calleeNode.property.type === "PrivateIdentifier") {
          return null;
        }
        const object222 = getStaticValueR24(calleeNode.object, initialScope);
        if (object222 != null) {
          if (object222.value == null && (object222.optional || node.optional)) {
            return { value: void 0, optional: true };
          }
          const property = getStaticPropertyNameValue24(
            calleeNode,
            initialScope
          );
          if (property != null) {
            const receiver = object222.value;
            const methodName = property.value;
            if (callAllowed24.has(receiver[methodName])) {
              return { value: receiver[methodName](...args) };
            }
            if (callPassThrough24.has(receiver[methodName])) {
              return { value: args[0] };
            }
          }
        }
      } else {
        const callee = getStaticValueR24(calleeNode, initialScope);
        if (callee != null) {
          if (callee.value == null && node.optional) {
            return { value: void 0, optional: true };
          }
          const func = callee.value;
          if (callAllowed24.has(func)) {
            return { value: func(...args) };
          }
          if (callPassThrough24.has(func)) {
            return { value: args[0] };
          }
        }
      }
    }
    return null;
  },
  ConditionalExpression(node, initialScope) {
    const test = getStaticValueR24(node.test, initialScope);
    if (test != null) {
      return test.value ? getStaticValueR24(node.consequent, initialScope) : getStaticValueR24(node.alternate, initialScope);
    }
    return null;
  },
  ExpressionStatement(node, initialScope) {
    return getStaticValueR24(node.expression, initialScope);
  },
  Identifier(node, initialScope) {
    if (initialScope != null) {
      const variable = findVariable26(initialScope, node);
      if (variable != null && variable.defs.length === 0 && builtinNames24.has(variable.name) && variable.name in globalObject24) {
        return { value: globalObject24[variable.name] };
      }
      if (variable != null && variable.defs.length === 1) {
        const def = variable.defs[0];
        if (def.parent && def.type === "Variable" && (def.parent.kind === "const" || isEffectivelyConst24(variable)) && // TODO(mysticatea): don't support destructuring here.
        def.node.id.type === "Identifier") {
          return getStaticValueR24(def.node.init, initialScope);
        }
      }
    }
    return null;
  },
  Literal(node) {
    if ((node.regex != null || node.bigint != null) && node.value == null) {
      return null;
    }
    return { value: node.value };
  },
  LogicalExpression(node, initialScope) {
    const left522 = getStaticValueR24(node.left, initialScope);
    if (left522 != null) {
      if (node.operator === "||" && Boolean(left522.value) === true || node.operator === "&&" && Boolean(left522.value) === false || node.operator === "??" && left522.value != null) {
        return left522;
      }
      const right522 = getStaticValueR24(node.right, initialScope);
      if (right522 != null) {
        return right522;
      }
    }
    return null;
  },
  MemberExpression(node, initialScope) {
    if (node.property.type === "PrivateIdentifier") {
      return null;
    }
    const object222 = getStaticValueR24(node.object, initialScope);
    if (object222 != null) {
      if (object222.value == null && (object222.optional || node.optional)) {
        return { value: void 0, optional: true };
      }
      const property = getStaticPropertyNameValue24(node, initialScope);
      if (property != null) {
        if (!isGetter24(object222.value, property.value)) {
          return { value: object222.value[property.value] };
        }
        for (const [classFn, allowed] of getterAllowed24) {
          if (object222.value instanceof classFn && allowed.has(property.value)) {
            return { value: object222.value[property.value] };
          }
        }
      }
    }
    return null;
  },
  ChainExpression(node, initialScope) {
    const expression = getStaticValueR24(node.expression, initialScope);
    if (expression != null) {
      return { value: expression.value };
    }
    return null;
  },
  NewExpression(node, initialScope) {
    const callee = getStaticValueR24(node.callee, initialScope);
    const args = getElementValues24(node.arguments, initialScope);
    if (callee != null && args != null) {
      const Func = callee.value;
      if (callAllowed24.has(Func)) {
        return { value: new Func(...args) };
      }
    }
    return null;
  },
  ObjectExpression(node, initialScope) {
    const object222 = {};
    for (const propertyNode of node.properties) {
      if (propertyNode.type === "Property") {
        if (propertyNode.kind !== "init") {
          return null;
        }
        const key = getStaticPropertyNameValue24(
          propertyNode,
          initialScope
        );
        const value = getStaticValueR24(propertyNode.value, initialScope);
        if (key == null || value == null) {
          return null;
        }
        object222[key.value] = value.value;
      } else if (propertyNode.type === "SpreadElement" || propertyNode.type === "ExperimentalSpreadProperty") {
        const argument = getStaticValueR24(
          propertyNode.argument,
          initialScope
        );
        if (argument == null) {
          return null;
        }
        Object.assign(object222, argument.value);
      } else {
        return null;
      }
    }
    return { value: object222 };
  },
  SequenceExpression(node, initialScope) {
    const last24 = node.expressions[node.expressions.length - 1];
    return getStaticValueR24(last24, initialScope);
  },
  TaggedTemplateExpression(node, initialScope) {
    const tag = getStaticValueR24(node.tag, initialScope);
    const expressions = getElementValues24(
      node.quasi.expressions,
      initialScope
    );
    if (tag != null && expressions != null) {
      const func = tag.value;
      const strings = node.quasi.quasis.map((q) => q.value.cooked);
      strings.raw = node.quasi.quasis.map((q) => q.value.raw);
      if (func === String.raw) {
        return { value: func(strings, ...expressions) };
      }
    }
    return null;
  },
  TemplateLiteral(node, initialScope) {
    const expressions = getElementValues24(node.expressions, initialScope);
    if (expressions != null) {
      let value = node.quasis[0].value.cooked;
      for (let i2222 = 0; i2222 < expressions.length; ++i2222) {
        value += expressions[i2222];
        value += node.quasis[i2222 + 1].value.cooked;
      }
      return { value };
    }
    return null;
  },
  UnaryExpression(node, initialScope) {
    if (node.operator === "delete") {
      return null;
    }
    if (node.operator === "void") {
      return { value: void 0 };
    }
    const arg = getStaticValueR24(node.argument, initialScope);
    if (arg != null) {
      switch (node.operator) {
        case "-":
          return { value: -arg.value };
        case "+":
          return { value: +arg.value };
        case "!":
          return { value: !arg.value };
        case "~":
          return { value: ~arg.value };
        case "typeof":
          return { value: typeof arg.value };
      }
    }
    return null;
  }
});
function getStaticValueR24(node, initialScope) {
  if (node != null && Object.hasOwnProperty.call(operations24, node.type)) {
    return operations24[node.type](node, initialScope);
  }
  return null;
}
function getStaticPropertyNameValue24(node, initialScope) {
  const nameNode = node.type === "Property" ? node.key : node.property;
  if (node.computed) {
    return getStaticValueR24(nameNode, initialScope);
  }
  if (nameNode.type === "Identifier") {
    return { value: nameNode.name };
  }
  if (nameNode.type === "Literal") {
    if (nameNode.bigint) {
      return { value: nameNode.bigint };
    }
    return { value: String(nameNode.value) };
  }
  return null;
}
function getStaticValue24(node, initialScope = null) {
  try {
    return getStaticValueR24(node, initialScope);
  } catch (_error) {
    return null;
  }
}
function getStringIfConstant24(node, initialScope = null) {
  if (node && node.type === "Literal" && node.value === null) {
    if (node.regex) {
      return `/${node.regex.pattern}/${node.regex.flags}`;
    }
    if (node.bigint) {
      return node.bigint;
    }
  }
  const evaluated = getStaticValue24(node, initialScope);
  return evaluated && String(evaluated.value);
}
function getPropertyName24(node, initialScope) {
  switch (node.type) {
    case "MemberExpression":
      if (node.computed) {
        return getStringIfConstant24(node.property, initialScope);
      }
      if (node.property.type === "PrivateIdentifier") {
        return null;
      }
      return node.property.name;
    case "Property":
    case "MethodDefinition":
    case "PropertyDefinition":
      if (node.computed) {
        return getStringIfConstant24(node.key, initialScope);
      }
      if (node.key.type === "Literal") {
        return String(node.key.value);
      }
      if (node.key.type === "PrivateIdentifier") {
        return null;
      }
      return node.key.name;
  }
  return null;
}
function getFunctionNameWithKind24(node, sourceCode) {
  const parent = node.parent;
  const tokens = [];
  const isObjectMethod = parent.type === "Property" && parent.value === node;
  const isClassMethod = parent.type === "MethodDefinition" && parent.value === node;
  const isClassFieldMethod = parent.type === "PropertyDefinition" && parent.value === node;
  if (isClassMethod || isClassFieldMethod) {
    if (parent.static) {
      tokens.push("static");
    }
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push("private");
    }
  }
  if (node.async) {
    tokens.push("async");
  }
  if (node.generator) {
    tokens.push("generator");
  }
  if (isObjectMethod || isClassMethod) {
    if (parent.kind === "constructor") {
      return "constructor";
    }
    if (parent.kind === "get") {
      tokens.push("getter");
    } else if (parent.kind === "set") {
      tokens.push("setter");
    } else {
      tokens.push("method");
    }
  } else if (isClassFieldMethod) {
    tokens.push("method");
  } else {
    if (node.type === "ArrowFunctionExpression") {
      tokens.push("arrow");
    }
    tokens.push("function");
  }
  if (isObjectMethod || isClassMethod || isClassFieldMethod) {
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push(`#${parent.key.name}`);
    } else {
      const name22 = getPropertyName24(parent);
      if (name22) {
        tokens.push(`'${name22}'`);
      } else if (sourceCode) {
        const keyText = sourceCode.getText(parent.key);
        if (!keyText.includes("\n")) {
          tokens.push(`[${keyText}]`);
        }
      }
    }
  } else if (node.id) {
    tokens.push(`'${node.id.name}'`);
  } else if (parent.type === "VariableDeclarator" && parent.id && parent.id.type === "Identifier") {
    tokens.push(`'${parent.id.name}'`);
  } else if ((parent.type === "AssignmentExpression" || parent.type === "AssignmentPattern") && parent.left && parent.left.type === "Identifier") {
    tokens.push(`'${parent.left.name}'`);
  } else if (parent.type === "ExportDefaultDeclaration" && parent.declaration === node) {
    tokens.push("'default'");
  }
  return tokens.join(" ");
}
var typeConversionBinaryOps24 = Object.freeze(
  /* @__PURE__ */ new Set([
    "==",
    "!=",
    "<",
    "<=",
    ">",
    ">=",
    "<<",
    ">>",
    ">>>",
    "+",
    "-",
    "*",
    "/",
    "%",
    "|",
    "^",
    "&",
    "in"
  ])
);
var typeConversionUnaryOps24 = Object.freeze(/* @__PURE__ */ new Set(["-", "+", "!", "~"]));
function isNode24(x2222) {
  return x2222 !== null && typeof x2222 === "object" && typeof x2222.type === "string";
}
var visitor24 = Object.freeze(
  Object.assign(/* @__PURE__ */ Object.create(null), {
    $visit(node, options, visitorKeys) {
      const { type } = node;
      if (typeof this[type] === "function") {
        return this[type](node, options, visitorKeys);
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    $visitChildren(node, options, visitorKeys) {
      const { type } = node;
      for (const key of visitorKeys[type] || getKeys24(node)) {
        const value = node[key];
        if (Array.isArray(value)) {
          for (const element of value) {
            if (isNode24(element) && this.$visit(element, options, visitorKeys)) {
              return true;
            }
          }
        } else if (isNode24(value) && this.$visit(value, options, visitorKeys)) {
          return true;
        }
      }
      return false;
    },
    ArrowFunctionExpression() {
      return false;
    },
    AssignmentExpression() {
      return true;
    },
    AwaitExpression() {
      return true;
    },
    BinaryExpression(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && typeConversionBinaryOps24.has(node.operator) && (node.left.type !== "Literal" || node.right.type !== "Literal")) {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    CallExpression() {
      return true;
    },
    FunctionExpression() {
      return false;
    },
    ImportExpression() {
      return true;
    },
    MemberExpression(node, options, visitorKeys) {
      if (options.considerGetters) {
        return true;
      }
      if (options.considerImplicitTypeConversion && node.computed && node.property.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    MethodDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    NewExpression() {
      return true;
    },
    Property(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    PropertyDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UnaryExpression(node, options, visitorKeys) {
      if (node.operator === "delete") {
        return true;
      }
      if (options.considerImplicitTypeConversion && typeConversionUnaryOps24.has(node.operator) && node.argument.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UpdateExpression() {
      return true;
    },
    YieldExpression() {
      return true;
    }
  })
);
function hasSideEffect24(node, sourceCode, { considerGetters = false, considerImplicitTypeConversion = false } = {}) {
  return visitor24.$visit(
    node,
    { considerGetters, considerImplicitTypeConversion },
    sourceCode.visitorKeys || visitor_keys_default24
  );
}
function getParentSyntaxParen24(node, sourceCode) {
  const parent = node.parent;
  switch (parent.type) {
    case "CallExpression":
    case "NewExpression":
      if (parent.arguments.length === 1 && parent.arguments[0] === node) {
        return sourceCode.getTokenAfter(
          parent.callee,
          isOpeningParenToken24
        );
      }
      return null;
    case "DoWhileStatement":
      if (parent.test === node) {
        return sourceCode.getTokenAfter(
          parent.body,
          isOpeningParenToken24
        );
      }
      return null;
    case "IfStatement":
    case "WhileStatement":
      if (parent.test === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "ImportExpression":
      if (parent.source === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "SwitchStatement":
      if (parent.discriminant === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "WithStatement":
      if (parent.object === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    default:
      return null;
  }
}
function isParenthesized24(timesOrNode, nodeOrSourceCode, optionalSourceCode) {
  let times, node, sourceCode, maybeLeftParen, maybeRightParen;
  if (typeof timesOrNode === "number") {
    times = timesOrNode | 0;
    node = nodeOrSourceCode;
    sourceCode = optionalSourceCode;
    if (!(times >= 1)) {
      throw new TypeError("'times' should be a positive integer.");
    }
  } else {
    times = 1;
    node = timesOrNode;
    sourceCode = nodeOrSourceCode;
  }
  if (node == null || // `Program` can't be parenthesized
  node.parent == null || // `CatchClause.param` can't be parenthesized, example `try {} catch (error) {}`
  node.parent.type === "CatchClause" && node.parent.param === node) {
    return false;
  }
  maybeLeftParen = maybeRightParen = node;
  do {
    maybeLeftParen = sourceCode.getTokenBefore(maybeLeftParen);
    maybeRightParen = sourceCode.getTokenAfter(maybeRightParen);
  } while (maybeLeftParen != null && maybeRightParen != null && isOpeningParenToken24(maybeLeftParen) && isClosingParenToken24(maybeRightParen) && // Avoid false positive such as `if (a) {}`
  maybeLeftParen !== getParentSyntaxParen24(node, sourceCode) && --times > 0);
  return times === 0;
}
Function.call.bind(Object.hasOwnProperty);
var __defProp2224 = Object.defineProperty;
var __export2224 = (target, all3224) => {
  for (var name22 in all3224)
    __defProp2224(target, name22, { get: all3224[name22], enumerable: true });
};
var NodeType24 = types.AST_NODE_TYPES;
var is24 = utils.ASTUtils.isNodeOfType;
var isOneOf24 = utils.ASTUtils.isNodeOfTypes;
isOneOf24([
  NodeType24.ArrowFunctionExpression,
  NodeType24.FunctionDeclaration,
  NodeType24.FunctionExpression
]);
isOneOf24([
  NodeType24.ArrowFunctionExpression,
  NodeType24.FunctionDeclaration,
  NodeType24.FunctionExpression,
  NodeType24.TSCallSignatureDeclaration,
  NodeType24.TSConstructSignatureDeclaration,
  NodeType24.TSDeclareFunction,
  NodeType24.TSEmptyBodyFunctionExpression,
  NodeType24.TSFunctionType,
  NodeType24.TSMethodSignature
]);
isOneOf24([NodeType24.ClassDeclaration, NodeType24.ClassExpression]);
isOneOf24([
  NodeType24.DoWhileStatement,
  NodeType24.ForInStatement,
  NodeType24.ForOfStatement,
  NodeType24.ForStatement,
  NodeType24.WhileStatement
]);
isOneOf24([NodeType24.TSArrayType, NodeType24.TSTupleType]);
isOneOf24([
  NodeType24.PropertyDefinition,
  NodeType24.TSIndexSignature,
  NodeType24.TSParameterProperty,
  NodeType24.TSPropertySignature
]);
is24(NodeType24.JSXElement);
is24(NodeType24.JSXFragment);
isOneOf24([
  NodeType24.JSXAttribute,
  NodeType24.JSXSpreadChild,
  NodeType24.JSXClosingElement,
  NodeType24.JSXClosingFragment,
  NodeType24.JSXElement,
  NodeType24.JSXEmptyExpression,
  NodeType24.JSXExpressionContainer,
  NodeType24.JSXFragment,
  NodeType24.JSXIdentifier,
  NodeType24.JSXMemberExpression,
  NodeType24.JSXNamespacedName,
  NodeType24.JSXOpeningElement,
  NodeType24.JSXOpeningFragment,
  NodeType24.JSXSpreadAttribute,
  NodeType24.JSXSpreadChild,
  NodeType24.JSXText
]);
isOneOf24([
  NodeType24.JSXIdentifier,
  NodeType24.JSXMemberExpression,
  NodeType24.JSXNamespacedName
]);
isOneOf24([
  NodeType24.ArrayPattern,
  NodeType24.AssignmentPattern,
  NodeType24.ObjectPattern,
  NodeType24.RestElement
]);
isOneOf24([
  NodeType24.TSInterfaceDeclaration,
  NodeType24.TSTypeAliasDeclaration
]);
isOneOf24([
  NodeType24.ArrayExpression,
  NodeType24.ArrayPattern,
  NodeType24.ArrowFunctionExpression,
  NodeType24.CallExpression,
  NodeType24.ClassExpression,
  NodeType24.FunctionExpression,
  NodeType24.Identifier,
  NodeType24.JSXElement,
  NodeType24.JSXFragment,
  NodeType24.Literal,
  NodeType24.TemplateLiteral,
  NodeType24.MemberExpression,
  NodeType24.MetaProperty,
  NodeType24.ObjectExpression,
  NodeType24.ObjectPattern,
  NodeType24.SequenceExpression,
  NodeType24.Super,
  NodeType24.TaggedTemplateExpression,
  NodeType24.ThisExpression
]);
isOneOf24([
  NodeType24.ArrayExpression,
  NodeType24.ArrayPattern,
  NodeType24.ArrowFunctionExpression,
  NodeType24.CallExpression,
  NodeType24.ClassExpression,
  NodeType24.FunctionExpression,
  NodeType24.Identifier,
  NodeType24.JSXElement,
  NodeType24.JSXFragment,
  NodeType24.Literal,
  NodeType24.TemplateLiteral,
  NodeType24.MemberExpression,
  NodeType24.MetaProperty,
  NodeType24.ObjectExpression,
  NodeType24.ObjectPattern,
  NodeType24.SequenceExpression,
  NodeType24.Super,
  NodeType24.TaggedTemplateExpression,
  NodeType24.ThisExpression,
  NodeType24.TSAsExpression,
  NodeType24.TSNonNullExpression,
  NodeType24.TSTypeAssertion
]);
var Function_exports26 = {};
__export2224(Function_exports26, {
  SK: () => SK26,
  absurd: () => absurd26,
  apply: () => apply26,
  compose: () => compose34,
  constFalse: () => constFalse26,
  constNull: () => constNull26,
  constTrue: () => constTrue26,
  constUndefined: () => constUndefined26,
  constVoid: () => constVoid26,
  constant: () => constant26,
  dual: () => dual26,
  flip: () => flip26,
  flow: () => flow26,
  hole: () => hole26,
  identity: () => identity26,
  isFunction: () => isFunction226,
  pipe: () => pipe26,
  satisfies: () => satisfies26,
  tupled: () => tupled26,
  unsafeCoerce: () => unsafeCoerce26,
  untupled: () => untupled26
});
var isFunction226 = (input) => typeof input === "function";
var dual26 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a2222, b2222) {
        if (arguments.length >= 2) {
          return body(a2222, b2222);
        }
        return function(self2) {
          return body(self2, a2222);
        };
      };
    case 3:
      return function(a2222, b2222, c2222) {
        if (arguments.length >= 3) {
          return body(a2222, b2222, c2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222);
        };
      };
    case 4:
      return function(a2222, b2222, c2222, d2222) {
        if (arguments.length >= 4) {
          return body(a2222, b2222, c2222, d2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222);
        };
      };
    case 5:
      return function(a2222, b2222, c2222, d2222, e2222) {
        if (arguments.length >= 5) {
          return body(a2222, b2222, c2222, d2222, e2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222, d2222);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply26 = (a2222) => (self2) => self2(a2222);
var identity26 = (a2222) => a2222;
var satisfies26 = () => (b2222) => b2222;
var unsafeCoerce26 = identity26;
var constant26 = (value) => () => value;
var constTrue26 = /* @__PURE__ */ constant26(true);
var constFalse26 = /* @__PURE__ */ constant26(false);
var constNull26 = /* @__PURE__ */ constant26(null);
var constUndefined26 = /* @__PURE__ */ constant26(void 0);
var constVoid26 = constUndefined26;
var flip26 = (f2222) => (...b2222) => (...a2222) => f2222(...a2222)(...b2222);
var compose34 = /* @__PURE__ */ dual26(2, (ab, bc) => (a2222) => bc(ab(a2222)));
var absurd26 = (_2222) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled26 = (f2222) => (a2222) => f2222(...a2222);
var untupled26 = (f2222) => (...a2222) => f2222(a2222);
function pipe26(a2222, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a2222;
    case 2:
      return ab(a2222);
    case 3:
      return bc(ab(a2222));
    case 4:
      return cd(bc(ab(a2222)));
    case 5:
      return de(cd(bc(ab(a2222))));
    case 6:
      return ef(de(cd(bc(ab(a2222)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a2222))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a2222)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a2222))))))));
    default: {
      let ret = arguments[0];
      for (let i2222 = 1; i2222 < arguments.length; i2222++) {
        ret = arguments[i2222](ret);
      }
      return ret;
    }
  }
}
function flow26(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole26 = /* @__PURE__ */ unsafeCoerce26(absurd26);
var SK26 = (_2222, b2222) => b2222;
var make64 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_36 = (map622) => dual26(3, (self2, name22, f2222) => map622(self2, (a2222) => Object.assign({}, a2222, {
  [name22]: f2222(a2222)
})));
var bindTo36 = (map622) => dual26(2, (self2, name22) => map622(self2, (a2222) => ({
  [name22]: a2222
})));
var bind36 = (map622, flatMap424) => dual26(3, (self2, name22, f2222) => flatMap424(self2, (a2222) => map622(f2222(a2222), (b2222) => Object.assign({}, a2222, {
  [name22]: b2222
}))));
var moduleVersion26 = "3.2.8";
var getCurrentVersion26 = () => moduleVersion26;
var globalStoreId26 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion26()}`);
if (!(globalStoreId26 in globalThis)) {
  globalThis[globalStoreId26] = /* @__PURE__ */ new Map();
}
var globalStore26 = globalThis[globalStoreId26];
var globalValue26 = (id, compute) => {
  if (!globalStore26.has(id)) {
    globalStore26.set(id, compute());
  }
  return globalStore26.get(id);
};
var Predicate_exports26 = {};
__export2224(Predicate_exports26, {
  all: () => all34,
  and: () => and24,
  compose: () => compose226,
  eqv: () => eqv24,
  every: () => every24,
  hasProperty: () => hasProperty26,
  implies: () => implies24,
  isBigInt: () => isBigInt24,
  isBoolean: () => isBoolean24,
  isDate: () => isDate24,
  isError: () => isError24,
  isFunction: () => isFunction326,
  isIterable: () => isIterable24,
  isMap: () => isMap24,
  isNever: () => isNever24,
  isNotNull: () => isNotNull24,
  isNotNullable: () => isNotNullable24,
  isNotUndefined: () => isNotUndefined24,
  isNull: () => isNull24,
  isNullable: () => isNullable26,
  isNumber: () => isNumber24,
  isObject: () => isObject26,
  isPromise: () => isPromise24,
  isPromiseLike: () => isPromiseLike24,
  isReadonlyRecord: () => isReadonlyRecord24,
  isRecord: () => isRecord24,
  isSet: () => isSet24,
  isString: () => isString24,
  isSymbol: () => isSymbol24,
  isTagged: () => isTagged24,
  isTruthy: () => isTruthy24,
  isUint8Array: () => isUint8Array24,
  isUndefined: () => isUndefined24,
  isUnknown: () => isUnknown24,
  mapInput: () => mapInput24,
  nand: () => nand24,
  nor: () => nor24,
  not: () => not24,
  or: () => or24,
  product: () => product34,
  productMany: () => productMany34,
  some: () => some44,
  struct: () => struct44,
  tuple: () => tuple34,
  xor: () => xor24
});
var mapInput24 = /* @__PURE__ */ dual26(2, (self2, f2222) => (b2222) => self2(f2222(b2222)));
var isTruthy24 = (input) => !!input;
var isSet24 = (input) => input instanceof Set;
var isMap24 = (input) => input instanceof Map;
var isString24 = (input) => typeof input === "string";
var isNumber24 = (input) => typeof input === "number";
var isBoolean24 = (input) => typeof input === "boolean";
var isBigInt24 = (input) => typeof input === "bigint";
var isSymbol24 = (input) => typeof input === "symbol";
var isFunction326 = isFunction226;
var isUndefined24 = (input) => input === void 0;
var isNotUndefined24 = (input) => input !== void 0;
var isNull24 = (input) => input === null;
var isNotNull24 = (input) => input !== null;
var isNever24 = (_2222) => false;
var isUnknown24 = (_2222) => true;
var isRecordOrArray26 = (input) => typeof input === "object" && input !== null;
var isObject26 = (input) => isRecordOrArray26(input) || isFunction326(input);
var hasProperty26 = /* @__PURE__ */ dual26(2, (self2, property) => isObject26(self2) && property in self2);
var isTagged24 = /* @__PURE__ */ dual26(2, (self2, tag) => hasProperty26(self2, "_tag") && self2["_tag"] === tag);
var isNullable26 = (input) => input === null || input === void 0;
var isNotNullable24 = (input) => input !== null && input !== void 0;
var isError24 = (input) => input instanceof Error;
var isUint8Array24 = (input) => input instanceof Uint8Array;
var isDate24 = (input) => input instanceof Date;
var isIterable24 = (input) => hasProperty26(input, Symbol.iterator);
var isRecord24 = (input) => isRecordOrArray26(input) && !Array.isArray(input);
var isReadonlyRecord24 = isRecord24;
var isPromise24 = (input) => hasProperty26(input, "then") && "catch" in input && isFunction326(input.then) && isFunction326(input.catch);
var isPromiseLike24 = (input) => hasProperty26(input, "then") && isFunction326(input.then);
var compose226 = /* @__PURE__ */ dual26(2, (ab, bc) => (a2222) => ab(a2222) && bc(a2222));
var product34 = (self2, that) => ([a2222, b2222]) => self2(a2222) && that(b2222);
var all34 = (collection) => {
  return (as2322) => {
    let collectionIndex = 0;
    for (const p2222 of collection) {
      if (collectionIndex >= as2322.length) {
        break;
      }
      if (p2222(as2322[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany34 = (self2, collection) => {
  const rest = all34(collection);
  return ([head222, ...tail222]) => self2(head222) === false ? false : rest(tail222);
};
var tuple34 = (...elements) => all34(elements);
var struct44 = (fields) => {
  const keys2224 = Object.keys(fields);
  return (a2222) => {
    for (const key of keys2224) {
      if (!fields[key](a2222[key])) {
        return false;
      }
    }
    return true;
  };
};
var not24 = (self2) => (a2222) => !self2(a2222);
var or24 = /* @__PURE__ */ dual26(2, (self2, that) => (a2222) => self2(a2222) || that(a2222));
var and24 = /* @__PURE__ */ dual26(2, (self2, that) => (a2222) => self2(a2222) && that(a2222));
var xor24 = /* @__PURE__ */ dual26(2, (self2, that) => (a2222) => self2(a2222) !== that(a2222));
var eqv24 = /* @__PURE__ */ dual26(2, (self2, that) => (a2222) => self2(a2222) === that(a2222));
var implies24 = /* @__PURE__ */ dual26(2, (self2, that) => (a2222) => self2(a2222) ? that(a2222) : true);
var nor24 = /* @__PURE__ */ dual26(2, (self2, that) => (a2222) => !(self2(a2222) || that(a2222)));
var nand24 = /* @__PURE__ */ dual26(2, (self2, that) => (a2222) => !(self2(a2222) && that(a2222)));
var every24 = (collection) => (a2222) => {
  for (const p2222 of collection) {
    if (!p2222(a2222)) {
      return false;
    }
  }
  return true;
};
var some44 = (collection) => (a2222) => {
  for (const p2222 of collection) {
    if (p2222(a2222)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage26 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId26 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind26 = (u2222) => isObject26(u2222) && GenKindTypeId26 in u2222;
var GenKindImpl26 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity26;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId26] = GenKindTypeId26;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen34(this);
  }
};
var SingleShotGen34 = class _SingleShotGen36 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a2222) {
    return this.called ? {
      value: a2222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a2222) {
    return {
      value: a2222,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e2222) {
    throw e2222;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen36(this.self);
  }
};
var adapter36 = () => function() {
  let x2222 = arguments[0];
  for (let i2222 = 1; i2222 < arguments.length; i2222++) {
    x2222 = arguments[i2222](x2222);
  }
  return new GenKindImpl26(x2222);
};
var defaultIncHi26 = 335903614;
var defaultIncLo26 = 4150755663;
var MUL_HI26 = 1481765933 >>> 0;
var MUL_LO26 = 1284865837 >>> 0;
var BIT_5326 = 9007199254740992;
var BIT_2726 = 134217728;
var PCGRandom26 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable26(seedLo) && isNullable26(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable26(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable26(incLo) && isNullable26(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo26;
      incHi = this._state ? this._state[2] : defaultIncHi26;
    } else if (isNullable26(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add6426(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max34) {
    if (!max34) {
      return this._next();
    }
    max34 = max34 >>> 0;
    if ((max34 & max34 - 1) === 0) {
      return this._next() & max34 - 1;
    }
    let num = 0;
    const skew = (-max34 >>> 0) % max34 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max34;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_2726 + lo) / BIT_5326;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul6426(this._state, oldHi, oldLo, MUL_HI26, MUL_LO26);
    add6426(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul6426(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add6426(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId26 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap26 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId26]() {
    return this.#value;
  }
};
function yieldWrapGet26(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId26 in self2) {
    return self2[YieldWrapTypeId26]();
  }
  throw new Error(getBugErrorMessage26("yieldWrapGet"));
}
var structuralRegionState26 = /* @__PURE__ */ globalValue26("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache26 = /* @__PURE__ */ globalValue26(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr26 = /* @__PURE__ */ globalValue26(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom26());
var symbol36 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash26 = (self2) => {
  if (structuralRegionState26.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number26(self2);
    case "bigint":
      return string26(self2.toString(10));
    case "boolean":
      return string26(String(self2));
    case "symbol":
      return string26(String(self2));
    case "string":
      return string26(self2);
    case "undefined":
      return string26("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string26("null");
      } else if (self2 instanceof Date) {
        return hash26(self2.toISOString());
      } else if (isHash26(self2)) {
        return self2[symbol36]();
      } else {
        return random26(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random26 = (self2) => {
  if (!randomHashCache26.has(self2)) {
    randomHashCache26.set(self2, number26(pcgr26.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache26.get(self2);
};
var combine34 = (b2222) => (self2) => self2 * 53 ^ b2222;
var optimize26 = (n2222) => n2222 & 3221225471 | n2222 >>> 1 & 1073741824;
var isHash26 = (u2222) => hasProperty26(u2222, symbol36);
var number26 = (n2222) => {
  if (n2222 !== n2222 || n2222 === Infinity) {
    return 0;
  }
  let h2222 = n2222 | 0;
  if (h2222 !== n2222) {
    h2222 ^= n2222 * 4294967295;
  }
  while (n2222 > 4294967295) {
    h2222 ^= n2222 /= 4294967295;
  }
  return optimize26(n2222);
};
var string26 = (str) => {
  let h2222 = 5381, i2222 = str.length;
  while (i2222) {
    h2222 = h2222 * 33 ^ str.charCodeAt(--i2222);
  }
  return optimize26(h2222);
};
var structureKeys26 = (o2222, keys2224) => {
  let h2222 = 12289;
  for (let i2222 = 0; i2222 < keys2224.length; i2222++) {
    h2222 ^= pipe26(string26(keys2224[i2222]), combine34(hash26(o2222[keys2224[i2222]])));
  }
  return optimize26(h2222);
};
var structure26 = (o2222) => structureKeys26(o2222, Object.keys(o2222));
var array34 = (arr) => {
  let h2222 = 6151;
  for (let i2222 = 0; i2222 < arr.length; i2222++) {
    h2222 = pipe26(h2222, combine34(hash26(arr[i2222])));
  }
  return optimize26(h2222);
};
var cached26 = function() {
  if (arguments.length === 1) {
    const self22 = arguments[0];
    return function(hash324) {
      Object.defineProperty(self22, symbol36, {
        value() {
          return hash324;
        },
        enumerable: false
      });
      return hash324;
    };
  }
  const self2 = arguments[0];
  const hash2322 = arguments[1];
  Object.defineProperty(self2, symbol36, {
    value() {
      return hash2322;
    },
    enumerable: false
  });
  return hash2322;
};
var symbol226 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals26() {
  if (arguments.length === 1) {
    return (self2) => compareBoth26(self2, arguments[0]);
  }
  return compareBoth26(arguments[0], arguments[1]);
}
function compareBoth26(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual26(self2) && isEqual26(that)) {
        if (hash26(self2) === hash26(that) && self2[symbol226](that)) {
          return true;
        } else {
          return structuralRegionState26.enabled && structuralRegionState26.tester ? structuralRegionState26.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState26.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v2222, i2222) => compareBoth26(v2222, that[i2222]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth26(self2[key], that[key]))) {
              return structuralRegionState26.tester ? structuralRegionState26.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState26.tester ? structuralRegionState26.tester(self2, that) : false;
    }
  }
  return structuralRegionState26.enabled && structuralRegionState26.tester ? structuralRegionState26.tester(self2, that) : false;
}
var isEqual26 = (u2222) => hasProperty26(u2222, symbol226);
var equivalence26 = () => equals26;
var NodeInspectSymbol26 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON26 = (x2222) => {
  if (hasProperty26(x2222, "toJSON") && isFunction326(x2222["toJSON"]) && x2222["toJSON"].length === 0) {
    return x2222.toJSON();
  } else if (Array.isArray(x2222)) {
    return x2222.map(toJSON26);
  }
  return x2222;
};
var format26 = (x2222) => JSON.stringify(x2222, null, 2);
var pipeArguments26 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i2222 = 0, len = args.length; i2222 < len; i2222++) {
        ret = args[i2222](ret);
      }
      return ret;
    }
  }
};
var OP_COMMIT26 = "Commit";
var OP_FAILURE24 = "Failure";
var OP_WITH_RUNTIME24 = "WithRuntime";
var EffectTypeId34 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId26 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId26 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId26 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance26 = {
  /* c8 ignore next */
  _R: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _A: (_2222) => _2222,
  _V: /* @__PURE__ */ getCurrentVersion26()
};
var sinkVariance26 = {
  /* c8 ignore next */
  _A: (_2222) => _2222,
  /* c8 ignore next */
  _In: (_2222) => _2222,
  /* c8 ignore next */
  _L: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _R: (_2222) => _2222
};
var channelVariance26 = {
  /* c8 ignore next */
  _Env: (_2222) => _2222,
  /* c8 ignore next */
  _InErr: (_2222) => _2222,
  /* c8 ignore next */
  _InElem: (_2222) => _2222,
  /* c8 ignore next */
  _InDone: (_2222) => _2222,
  /* c8 ignore next */
  _OutErr: (_2222) => _2222,
  /* c8 ignore next */
  _OutElem: (_2222) => _2222,
  /* c8 ignore next */
  _OutDone: (_2222) => _2222
};
var EffectPrototype26 = {
  [EffectTypeId34]: effectVariance26,
  [StreamTypeId26]: effectVariance26,
  [SinkTypeId26]: sinkVariance26,
  [ChannelTypeId26]: channelVariance26,
  [symbol226](that) {
    return this === that;
  },
  [symbol36]() {
    return cached26(this, random26(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen34(new YieldWrap26(this));
  },
  pipe() {
    return pipeArguments26(this, arguments);
  }
};
var StructuralPrototype26 = {
  [symbol36]() {
    return cached26(this, structure26(this));
  },
  [symbol226](that) {
    const selfKeys = Object.keys(this);
    const thatKeys = Object.keys(that);
    if (selfKeys.length !== thatKeys.length) {
      return false;
    }
    for (const key of selfKeys) {
      if (!(key in that && equals26(this[key], that[key]))) {
        return false;
      }
    }
    return true;
  }
};
var CommitPrototype26 = {
  ...EffectPrototype26,
  _op: OP_COMMIT26
};
var StructuralCommitPrototype26 = {
  ...CommitPrototype26,
  ...StructuralPrototype26
};
var TypeId64 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto36 = {
  ...EffectPrototype26,
  [TypeId64]: {
    _A: (_2222) => _2222
  },
  [NodeInspectSymbol26]() {
    return this.toJSON();
  },
  toString() {
    return format26(this.toJSON());
  }
};
var SomeProto26 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto36), {
  _tag: "Some",
  _op: "Some",
  [symbol226](that) {
    return isOption36(that) && isSome36(that) && equals26(this.value, that.value);
  },
  [symbol36]() {
    return cached26(this, combine34(hash26(this._tag))(hash26(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON26(this.value)
    };
  }
});
var NoneHash26 = /* @__PURE__ */ hash26("None");
var NoneProto26 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto36), {
  _tag: "None",
  _op: "None",
  [symbol226](that) {
    return isOption36(that) && isNone36(that);
  },
  [symbol36]() {
    return NoneHash26;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption36 = (input) => hasProperty26(input, TypeId64);
var isNone36 = (fa) => fa._tag === "None";
var isSome36 = (fa) => fa._tag === "Some";
var none36 = /* @__PURE__ */ Object.create(NoneProto26);
var some226 = (value) => {
  const a2222 = Object.create(SomeProto26);
  a2222.value = value;
  return a2222;
};
var TypeId226 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto226 = {
  ...EffectPrototype26,
  [TypeId226]: {
    _R: (_2222) => _2222
  },
  [NodeInspectSymbol26]() {
    return this.toJSON();
  },
  toString() {
    return format26(this.toJSON());
  }
};
var RightProto26 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto226), {
  _tag: "Right",
  _op: "Right",
  [symbol226](that) {
    return isEither26(that) && isRight26(that) && equals26(this.right, that.right);
  },
  [symbol36]() {
    return combine34(hash26(this._tag))(hash26(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON26(this.right)
    };
  }
});
var LeftProto26 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto226), {
  _tag: "Left",
  _op: "Left",
  [symbol226](that) {
    return isEither26(that) && isLeft26(that) && equals26(this.left, that.left);
  },
  [symbol36]() {
    return combine34(hash26(this._tag))(hash26(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON26(this.left)
    };
  }
});
var isEither26 = (input) => hasProperty26(input, TypeId226);
var isLeft26 = (ma) => ma._tag === "Left";
var isRight26 = (ma) => ma._tag === "Right";
var left34 = (left3224) => {
  const a2222 = Object.create(LeftProto26);
  a2222.left = left3224;
  return a2222;
};
var right34 = (right3224) => {
  const a2222 = Object.create(RightProto26);
  a2222.right = right3224;
  return a2222;
};
var getLeft36 = (self2) => isRight26(self2) ? none36 : some226(self2.left);
var getRight36 = (self2) => isLeft26(self2) ? none36 : some226(self2.right);
var right226 = right34;
var left226 = left34;
var Option_exports26 = {};
__export2224(Option_exports26, {
  Do: () => Do26,
  TypeId: () => TypeId326,
  all: () => all226,
  andThen: () => andThen26,
  ap: () => ap26,
  as: () => as26,
  asVoid: () => asVoid26,
  bind: () => bind226,
  bindTo: () => bindTo226,
  composeK: () => composeK26,
  contains: () => contains26,
  containsWith: () => containsWith26,
  exists: () => exists26,
  filter: () => filter26,
  filterMap: () => filterMap26,
  firstSomeOf: () => firstSomeOf26,
  flatMap: () => flatMap26,
  flatMapNullable: () => flatMapNullable26,
  flatten: () => flatten26,
  fromIterable: () => fromIterable34,
  fromNullable: () => fromNullable26,
  gen: () => gen26,
  getEquivalence: () => getEquivalence34,
  getLeft: () => getLeft226,
  getOrElse: () => getOrElse26,
  getOrNull: () => getOrNull26,
  getOrThrow: () => getOrThrow26,
  getOrThrowWith: () => getOrThrowWith26,
  getOrUndefined: () => getOrUndefined26,
  getOrder: () => getOrder26,
  getRight: () => getRight226,
  isNone: () => isNone226,
  isOption: () => isOption226,
  isSome: () => isSome226,
  let: () => let_226,
  lift2: () => lift226,
  liftNullable: () => liftNullable26,
  liftPredicate: () => liftPredicate26,
  liftThrowable: () => liftThrowable26,
  map: () => map26,
  match: () => match224,
  none: () => none226,
  orElse: () => orElse26,
  orElseEither: () => orElseEither26,
  orElseSome: () => orElseSome26,
  partitionMap: () => partitionMap26,
  product: () => product226,
  productMany: () => productMany226,
  reduceCompact: () => reduceCompact26,
  some: () => some326,
  tap: () => tap26,
  toArray: () => toArray26,
  toRefinement: () => toRefinement26,
  void: () => void_26,
  zipLeft: () => zipLeft26,
  zipRight: () => zipRight26,
  zipWith: () => zipWith26
});
var make226 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId326 = /* @__PURE__ */ Symbol.for("effect/Option");
var none226 = () => none36;
var some326 = some226;
var isOption226 = isOption36;
var isNone226 = isNone36;
var isSome226 = isSome36;
var match224 = /* @__PURE__ */ dual26(2, (self2, {
  onNone,
  onSome
}) => isNone226(self2) ? onNone() : onSome(self2.value));
var toRefinement26 = (f2222) => (a2222) => isSome226(f2222(a2222));
var fromIterable34 = (collection) => {
  for (const a2222 of collection) {
    return some326(a2222);
  }
  return none226();
};
var getRight226 = getRight36;
var getLeft226 = getLeft36;
var getOrElse26 = /* @__PURE__ */ dual26(2, (self2, onNone) => isNone226(self2) ? onNone() : self2.value);
var orElse26 = /* @__PURE__ */ dual26(2, (self2, that) => isNone226(self2) ? that() : self2);
var orElseSome26 = /* @__PURE__ */ dual26(2, (self2, onNone) => isNone226(self2) ? some326(onNone()) : self2);
var orElseEither26 = /* @__PURE__ */ dual26(2, (self2, that) => isNone226(self2) ? map26(that(), right34) : map26(self2, left34));
var firstSomeOf26 = (collection) => {
  let out = none226();
  for (out of collection) {
    if (isSome226(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable26 = (nullableValue) => nullableValue == null ? none226() : some326(nullableValue);
var liftNullable26 = (f2222) => (...a2222) => fromNullable26(f2222(...a2222));
var getOrNull26 = /* @__PURE__ */ getOrElse26(constNull26);
var getOrUndefined26 = /* @__PURE__ */ getOrElse26(constUndefined26);
var liftThrowable26 = (f2222) => (...a2222) => {
  try {
    return some326(f2222(...a2222));
  } catch (e2222) {
    return none226();
  }
};
var getOrThrowWith26 = /* @__PURE__ */ dual26(2, (self2, onNone) => {
  if (isSome226(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow26 = /* @__PURE__ */ getOrThrowWith26(() => new Error("getOrThrow called on a None"));
var map26 = /* @__PURE__ */ dual26(2, (self2, f2222) => isNone226(self2) ? none226() : some326(f2222(self2.value)));
var as26 = /* @__PURE__ */ dual26(2, (self2, b2222) => map26(self2, () => b2222));
var asVoid26 = /* @__PURE__ */ as26(void 0);
var void_26 = /* @__PURE__ */ some326(void 0);
var flatMap26 = /* @__PURE__ */ dual26(2, (self2, f2222) => isNone226(self2) ? none226() : f2222(self2.value));
var andThen26 = /* @__PURE__ */ dual26(2, (self2, f2222) => flatMap26(self2, (a2222) => {
  const b2222 = isFunction226(f2222) ? f2222(a2222) : f2222;
  return isOption226(b2222) ? b2222 : some326(b2222);
}));
var flatMapNullable26 = /* @__PURE__ */ dual26(2, (self2, f2222) => isNone226(self2) ? none226() : fromNullable26(f2222(self2.value)));
var flatten26 = /* @__PURE__ */ flatMap26(identity26);
var zipRight26 = /* @__PURE__ */ dual26(2, (self2, that) => flatMap26(self2, () => that));
var composeK26 = /* @__PURE__ */ dual26(2, (afb, bfc) => (a2222) => flatMap26(afb(a2222), bfc));
var zipLeft26 = /* @__PURE__ */ dual26(2, (self2, that) => tap26(self2, () => that));
var tap26 = /* @__PURE__ */ dual26(2, (self2, f2222) => flatMap26(self2, (a2222) => map26(f2222(a2222), () => a2222)));
var product226 = (self2, that) => isSome226(self2) && isSome226(that) ? some326([self2.value, that.value]) : none226();
var productMany226 = (self2, collection) => {
  if (isNone226(self2)) {
    return none226();
  }
  const out = [self2.value];
  for (const o2222 of collection) {
    if (isNone226(o2222)) {
      return none226();
    }
    out.push(o2222.value);
  }
  return some326(out);
};
var all226 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o2222 of input) {
      if (isNone226(o2222)) {
        return none226();
      }
      out2.push(o2222.value);
    }
    return some326(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o2222 = input[key];
    if (isNone226(o2222)) {
      return none226();
    }
    out[key] = o2222.value;
  }
  return some326(out);
};
var zipWith26 = /* @__PURE__ */ dual26(3, (self2, that, f2222) => map26(product226(self2, that), ([a2222, b2222]) => f2222(a2222, b2222)));
var ap26 = /* @__PURE__ */ dual26(2, (self2, that) => zipWith26(self2, that, (f2222, a2222) => f2222(a2222)));
var reduceCompact26 = /* @__PURE__ */ dual26(3, (self2, b2222, f2222) => {
  let out = b2222;
  for (const oa of self2) {
    if (isSome226(oa)) {
      out = f2222(out, oa.value);
    }
  }
  return out;
});
var toArray26 = (self2) => isNone226(self2) ? [] : [self2.value];
var partitionMap26 = /* @__PURE__ */ dual26(2, (self2, f2222) => {
  if (isNone226(self2)) {
    return [none226(), none226()];
  }
  const e2222 = f2222(self2.value);
  return isLeft26(e2222) ? [some326(e2222.left), none226()] : [none226(), some326(e2222.right)];
});
var filterMap26 = /* @__PURE__ */ dual26(2, (self2, f2222) => isNone226(self2) ? none226() : f2222(self2.value));
var filter26 = /* @__PURE__ */ dual26(2, (self2, predicate) => filterMap26(self2, (b2222) => predicate(b2222) ? some226(b2222) : none36));
var getEquivalence34 = (isEquivalent) => make64((x2222, y2222) => x2222 === y2222 || (isNone226(x2222) ? isNone226(y2222) : isNone226(y2222) ? false : isEquivalent(x2222.value, y2222.value)));
var getOrder26 = (O2222) => make226((self2, that) => isSome226(self2) ? isSome226(that) ? O2222(self2.value, that.value) : 1 : -1);
var lift226 = (f2222) => dual26(2, (self2, that) => zipWith26(self2, that, f2222));
var liftPredicate26 = (predicate) => (b2222) => predicate(b2222) ? some326(b2222) : none226();
var containsWith26 = (isEquivalent) => dual26(2, (self2, a2222) => isNone226(self2) ? false : isEquivalent(self2.value, a2222));
var _equivalence34 = /* @__PURE__ */ equivalence26();
var contains26 = /* @__PURE__ */ containsWith26(_equivalence34);
var exists26 = /* @__PURE__ */ dual26(2, (self2, refinement) => isNone226(self2) ? false : refinement(self2.value));
var bindTo226 = /* @__PURE__ */ bindTo36(map26);
var let_226 = /* @__PURE__ */ let_36(map26);
var bind226 = /* @__PURE__ */ bind36(map26, flatMap26);
var Do26 = /* @__PURE__ */ some326({});
var adapter226 = /* @__PURE__ */ adapter36();
var gen26 = (f2222) => {
  const iterator = f2222(adapter226);
  let state = iterator.next();
  if (state.done) {
    return some326(state.value);
  } else {
    let current = state.value;
    if (isGenKind26(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet26(current);
    }
    if (isNone226(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind26(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet26(current);
        }
        if (isNone226(current)) {
          return current;
        }
      }
    }
    return some326(state.value);
  }
};
var fromIterable226 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var reverse34 = (self2) => Array.from(self2).reverse();
var reduce34 = /* @__PURE__ */ dual26(3, (self2, b2222, f2222) => fromIterable226(self2).reduce((b22222, a2222, i2222) => f2222(b22222, a2222, i2222), b2222));
var TagTypeId24 = /* @__PURE__ */ Symbol.for("effect/Context/Tag");
var STMSymbolKey24 = "effect/STM";
var STMTypeId24 = /* @__PURE__ */ Symbol.for(STMSymbolKey24);
var TagProto24 = {
  ...EffectPrototype26,
  _tag: "Tag",
  _op: "Tag",
  [STMTypeId24]: effectVariance26,
  [TagTypeId24]: {
    _Service: (_2222) => _2222,
    _Identifier: (_2222) => _2222
  },
  toString() {
    return format26(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Tag",
      key: this.key,
      stack: this.stack
    };
  },
  [NodeInspectSymbol26]() {
    return this.toJSON();
  },
  of(self2) {
    return self2;
  },
  context(self2) {
    return make326(this, self2);
  }
};
var makeGenericTag24 = (key) => {
  const limit = Error.stackTraceLimit;
  Error.stackTraceLimit = 2;
  const creationError = new Error();
  Error.stackTraceLimit = limit;
  const tag = Object.create(TagProto24);
  Object.defineProperty(tag, "stack", {
    get() {
      return creationError.stack;
    }
  });
  tag.key = key;
  return tag;
};
var TypeId426 = /* @__PURE__ */ Symbol.for("effect/Context");
var ContextProto24 = {
  [TypeId426]: {
    _Services: (_2222) => _2222
  },
  [symbol226](that) {
    if (isContext24(that)) {
      if (this.unsafeMap.size === that.unsafeMap.size) {
        for (const k2222 of this.unsafeMap.keys()) {
          if (!that.unsafeMap.has(k2222) || !equals26(this.unsafeMap.get(k2222), that.unsafeMap.get(k2222))) {
            return false;
          }
        }
        return true;
      }
    }
    return false;
  },
  [symbol36]() {
    return cached26(this, number26(this.unsafeMap.size));
  },
  pipe() {
    return pipeArguments26(this, arguments);
  },
  toString() {
    return format26(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Context",
      services: Array.from(this.unsafeMap).map(toJSON26)
    };
  },
  [NodeInspectSymbol26]() {
    return this.toJSON();
  }
};
var makeContext24 = (unsafeMap) => {
  const context = Object.create(ContextProto24);
  context.unsafeMap = unsafeMap;
  return context;
};
var isContext24 = (u2222) => hasProperty26(u2222, TypeId426);
var _empty64 = /* @__PURE__ */ makeContext24(/* @__PURE__ */ new Map());
var empty84 = () => _empty64;
var make326 = (tag, service) => makeContext24(/* @__PURE__ */ new Map([[tag.key, service]]));
var GenericTag24 = makeGenericTag24;
var empty224 = empty84;
var TypeId526 = /* @__PURE__ */ Symbol.for("effect/Chunk");
function copy24(src, srcPos, dest, destPos, len) {
  for (let i2222 = srcPos; i2222 < Math.min(src.length, srcPos + len); i2222++) {
    dest[destPos + i2222 - srcPos] = src[i2222];
  }
  return dest;
}
var emptyArray24 = [];
var getEquivalence226 = (isEquivalent) => make64((self2, that) => self2.length === that.length && toReadonlyArray24(self2).every((value, i2222) => isEquivalent(value, unsafeGet224(that, i2222))));
var _equivalence226 = /* @__PURE__ */ getEquivalence226(equals26);
var ChunkProto24 = {
  [TypeId526]: {
    _A: (_2222) => _2222
  },
  toString() {
    return format26(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Chunk",
      values: toReadonlyArray24(this).map(toJSON26)
    };
  },
  [NodeInspectSymbol26]() {
    return this.toJSON();
  },
  [symbol226](that) {
    return isChunk24(that) && _equivalence226(this, that);
  },
  [symbol36]() {
    return cached26(this, array34(toReadonlyArray24(this)));
  },
  [Symbol.iterator]() {
    switch (this.backing._tag) {
      case "IArray": {
        return this.backing.array[Symbol.iterator]();
      }
      case "IEmpty": {
        return emptyArray24[Symbol.iterator]();
      }
      default: {
        return toReadonlyArray24(this)[Symbol.iterator]();
      }
    }
  },
  pipe() {
    return pipeArguments26(this, arguments);
  }
};
var makeChunk24 = (backing) => {
  const chunk = Object.create(ChunkProto24);
  chunk.backing = backing;
  switch (backing._tag) {
    case "IEmpty": {
      chunk.length = 0;
      chunk.depth = 0;
      chunk.left = chunk;
      chunk.right = chunk;
      break;
    }
    case "IConcat": {
      chunk.length = backing.left.length + backing.right.length;
      chunk.depth = 1 + Math.max(backing.left.depth, backing.right.depth);
      chunk.left = backing.left;
      chunk.right = backing.right;
      break;
    }
    case "IArray": {
      chunk.length = backing.array.length;
      chunk.depth = 0;
      chunk.left = _empty224;
      chunk.right = _empty224;
      break;
    }
    case "ISingleton": {
      chunk.length = 1;
      chunk.depth = 0;
      chunk.left = _empty224;
      chunk.right = _empty224;
      break;
    }
    case "ISlice": {
      chunk.length = backing.length;
      chunk.depth = backing.chunk.depth + 1;
      chunk.left = _empty224;
      chunk.right = _empty224;
      break;
    }
  }
  return chunk;
};
var isChunk24 = (u2222) => hasProperty26(u2222, TypeId526);
var _empty224 = /* @__PURE__ */ makeChunk24({
  _tag: "IEmpty"
});
var empty324 = () => _empty224;
var make426 = (...as2322) => as2322.length === 1 ? of24(as2322[0]) : unsafeFromNonEmptyArray24(as2322);
var of24 = (a2222) => makeChunk24({
  _tag: "ISingleton",
  a: a2222
});
var copyToArray24 = (self2, array3224, initial) => {
  switch (self2.backing._tag) {
    case "IArray": {
      copy24(self2.backing.array, 0, array3224, initial, self2.length);
      break;
    }
    case "IConcat": {
      copyToArray24(self2.left, array3224, initial);
      copyToArray24(self2.right, array3224, initial + self2.left.length);
      break;
    }
    case "ISingleton": {
      array3224[initial] = self2.backing.a;
      break;
    }
    case "ISlice": {
      let i2222 = 0;
      let j2222 = initial;
      while (i2222 < self2.length) {
        array3224[j2222] = unsafeGet224(self2, i2222);
        i2222 += 1;
        j2222 += 1;
      }
      break;
    }
  }
};
var toReadonlyArray24 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      return emptyArray24;
    }
    case "IArray": {
      return self2.backing.array;
    }
    default: {
      const arr = new Array(self2.length);
      copyToArray24(self2, arr, 0);
      self2.backing = {
        _tag: "IArray",
        array: arr
      };
      self2.left = _empty224;
      self2.right = _empty224;
      self2.depth = 0;
      return arr;
    }
  }
};
var reverse224 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty":
    case "ISingleton":
      return self2;
    case "IArray": {
      return makeChunk24({
        _tag: "IArray",
        array: reverse34(self2.backing.array)
      });
    }
    case "IConcat": {
      return makeChunk24({
        _tag: "IConcat",
        left: reverse224(self2.backing.right),
        right: reverse224(self2.backing.left)
      });
    }
    case "ISlice":
      return unsafeFromArray24(reverse34(toReadonlyArray24(self2)));
  }
};
var unsafeFromArray24 = (self2) => makeChunk24({
  _tag: "IArray",
  array: self2
});
var unsafeFromNonEmptyArray24 = (self2) => unsafeFromArray24(self2);
var unsafeGet224 = /* @__PURE__ */ dual26(2, (self2, index) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      throw new Error(`Index out of bounds`);
    }
    case "ISingleton": {
      if (index !== 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.a;
    }
    case "IArray": {
      if (index >= self2.length || index < 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.array[index];
    }
    case "IConcat": {
      return index < self2.left.length ? unsafeGet224(self2.left, index) : unsafeGet224(self2.right, index - self2.left.length);
    }
    case "ISlice": {
      return unsafeGet224(self2.backing.chunk, index + self2.backing.offset);
    }
  }
});
var prepend24 = /* @__PURE__ */ dual26(2, (self2, elem) => appendAll24(of24(elem), self2));
var drop24 = /* @__PURE__ */ dual26(2, (self2, n2222) => {
  if (n2222 <= 0) {
    return self2;
  } else if (n2222 >= self2.length) {
    return _empty224;
  } else {
    switch (self2.backing._tag) {
      case "ISlice": {
        return makeChunk24({
          _tag: "ISlice",
          chunk: self2.backing.chunk,
          offset: self2.backing.offset + n2222,
          length: self2.backing.length - n2222
        });
      }
      case "IConcat": {
        if (n2222 > self2.left.length) {
          return drop24(self2.right, n2222 - self2.left.length);
        }
        return makeChunk24({
          _tag: "IConcat",
          left: drop24(self2.left, n2222),
          right: self2.right
        });
      }
      default: {
        return makeChunk24({
          _tag: "ISlice",
          chunk: self2,
          offset: n2222,
          length: self2.length - n2222
        });
      }
    }
  }
});
var appendAll24 = /* @__PURE__ */ dual26(2, (self2, that) => {
  if (self2.backing._tag === "IEmpty") {
    return that;
  }
  if (that.backing._tag === "IEmpty") {
    return self2;
  }
  const diff2224 = that.depth - self2.depth;
  if (Math.abs(diff2224) <= 1) {
    return makeChunk24({
      _tag: "IConcat",
      left: self2,
      right: that
    });
  } else if (diff2224 < -1) {
    if (self2.left.depth >= self2.right.depth) {
      const nr = appendAll24(self2.right, that);
      return makeChunk24({
        _tag: "IConcat",
        left: self2.left,
        right: nr
      });
    } else {
      const nrr = appendAll24(self2.right.right, that);
      if (nrr.depth === self2.depth - 3) {
        const nr = makeChunk24({
          _tag: "IConcat",
          left: self2.right.left,
          right: nrr
        });
        return makeChunk24({
          _tag: "IConcat",
          left: self2.left,
          right: nr
        });
      } else {
        const nl = makeChunk24({
          _tag: "IConcat",
          left: self2.left,
          right: self2.right.left
        });
        return makeChunk24({
          _tag: "IConcat",
          left: nl,
          right: nrr
        });
      }
    }
  } else {
    if (that.right.depth >= that.left.depth) {
      const nl = appendAll24(self2, that.left);
      return makeChunk24({
        _tag: "IConcat",
        left: nl,
        right: that.right
      });
    } else {
      const nll = appendAll24(self2, that.left.left);
      if (nll.depth === that.depth - 3) {
        const nl = makeChunk24({
          _tag: "IConcat",
          left: nll,
          right: that.left.right
        });
        return makeChunk24({
          _tag: "IConcat",
          left: nl,
          right: that.right
        });
      } else {
        const nr = makeChunk24({
          _tag: "IConcat",
          left: that.left.right,
          right: that.right
        });
        return makeChunk24({
          _tag: "IConcat",
          left: nll,
          right: nr
        });
      }
    }
  }
});
var isEmpty24 = (self2) => self2.length === 0;
var isNonEmpty24 = (self2) => self2.length > 0;
var unsafeHead24 = (self2) => unsafeGet224(self2, 0);
var headNonEmpty24 = unsafeHead24;
var tailNonEmpty24 = (self2) => drop24(self2, 1);
var SIZE24 = 5;
var BUCKET_SIZE24 = /* @__PURE__ */ Math.pow(2, SIZE24);
var MASK24 = BUCKET_SIZE24 - 1;
var MAX_INDEX_NODE24 = BUCKET_SIZE24 / 2;
var MIN_ARRAY_NODE24 = BUCKET_SIZE24 / 4;
function popcount24(x2222) {
  x2222 -= x2222 >> 1 & 1431655765;
  x2222 = (x2222 & 858993459) + (x2222 >> 2 & 858993459);
  x2222 = x2222 + (x2222 >> 4) & 252645135;
  x2222 += x2222 >> 8;
  x2222 += x2222 >> 16;
  return x2222 & 127;
}
function hashFragment24(shift22, h2222) {
  return h2222 >>> shift22 & MASK24;
}
function toBitmap24(x2222) {
  return 1 << x2222;
}
function fromBitmap24(bitmap, bit) {
  return popcount24(bitmap & bit - 1);
}
var make524 = (value, previous) => ({
  value,
  previous
});
function arrayUpdate24(mutate2224, at, v2222, arr) {
  let out = arr;
  if (!mutate2224) {
    const len = arr.length;
    out = new Array(len);
    for (let i2222 = 0; i2222 < len; ++i2222) out[i2222] = arr[i2222];
  }
  out[at] = v2222;
  return out;
}
function arraySpliceOut24(mutate2224, at, arr) {
  const newLen = arr.length - 1;
  let i2222 = 0;
  let g2222 = 0;
  let out = arr;
  if (mutate2224) {
    i2222 = g2222 = at;
  } else {
    out = new Array(newLen);
    while (i2222 < at) out[g2222++] = arr[i2222++];
  }
  ++i2222;
  while (i2222 <= newLen) out[g2222++] = arr[i2222++];
  if (mutate2224) {
    out.length = newLen;
  }
  return out;
}
function arraySpliceIn24(mutate2224, at, v2222, arr) {
  const len = arr.length;
  if (mutate2224) {
    let i22222 = len;
    while (i22222 >= at) arr[i22222--] = arr[i22222];
    arr[at] = v2222;
    return arr;
  }
  let i2222 = 0, g2222 = 0;
  const out = new Array(len + 1);
  while (i2222 < at) out[g2222++] = arr[i2222++];
  out[at] = v2222;
  while (i2222 < len) out[++g2222] = arr[i2222++];
  return out;
}
var EmptyNode24 = class _EmptyNode24 {
  _tag = "EmptyNode";
  modify(edit, _shift, f2222, hash2322, key, size4224) {
    const v2222 = f2222(none226());
    if (isNone226(v2222)) return new _EmptyNode24();
    ++size4224.value;
    return new LeafNode24(edit, hash2322, key, v2222);
  }
};
function isEmptyNode24(a2222) {
  return isTagged24(a2222, "EmptyNode");
}
function isLeafNode24(node) {
  return isEmptyNode24(node) || node._tag === "LeafNode" || node._tag === "CollisionNode";
}
function canEditNode24(node, edit) {
  return isEmptyNode24(node) ? false : edit === node.edit;
}
var LeafNode24 = class _LeafNode24 {
  edit;
  hash;
  key;
  value;
  _tag = "LeafNode";
  constructor(edit, hash2322, key, value) {
    this.edit = edit;
    this.hash = hash2322;
    this.key = key;
    this.value = value;
  }
  modify(edit, shift22, f2222, hash2322, key, size4224) {
    if (equals26(key, this.key)) {
      const v22222 = f2222(this.value);
      if (v22222 === this.value) return this;
      else if (isNone226(v22222)) {
        --size4224.value;
        return new EmptyNode24();
      }
      if (canEditNode24(this, edit)) {
        this.value = v22222;
        return this;
      }
      return new _LeafNode24(edit, hash2322, key, v22222);
    }
    const v2222 = f2222(none226());
    if (isNone226(v2222)) return this;
    ++size4224.value;
    return mergeLeaves24(edit, shift22, this.hash, this, hash2322, new _LeafNode24(edit, hash2322, key, v2222));
  }
};
var CollisionNode24 = class _CollisionNode24 {
  edit;
  hash;
  children;
  _tag = "CollisionNode";
  constructor(edit, hash2322, children) {
    this.edit = edit;
    this.hash = hash2322;
    this.children = children;
  }
  modify(edit, shift22, f2222, hash2322, key, size4224) {
    if (hash2322 === this.hash) {
      const canEdit = canEditNode24(this, edit);
      const list = this.updateCollisionList(canEdit, edit, this.hash, this.children, f2222, key, size4224);
      if (list === this.children) return this;
      return list.length > 1 ? new _CollisionNode24(edit, this.hash, list) : list[0];
    }
    const v2222 = f2222(none226());
    if (isNone226(v2222)) return this;
    ++size4224.value;
    return mergeLeaves24(edit, shift22, this.hash, this, hash2322, new LeafNode24(edit, hash2322, key, v2222));
  }
  updateCollisionList(mutate2224, edit, hash2322, list, f2222, key, size4224) {
    const len = list.length;
    for (let i2222 = 0; i2222 < len; ++i2222) {
      const child = list[i2222];
      if ("key" in child && equals26(key, child.key)) {
        const value = child.value;
        const newValue2 = f2222(value);
        if (newValue2 === value) return list;
        if (isNone226(newValue2)) {
          --size4224.value;
          return arraySpliceOut24(mutate2224, i2222, list);
        }
        return arrayUpdate24(mutate2224, i2222, new LeafNode24(edit, hash2322, key, newValue2), list);
      }
    }
    const newValue = f2222(none226());
    if (isNone226(newValue)) return list;
    ++size4224.value;
    return arrayUpdate24(mutate2224, len, new LeafNode24(edit, hash2322, key, newValue), list);
  }
};
var IndexedNode24 = class _IndexedNode24 {
  edit;
  mask;
  children;
  _tag = "IndexedNode";
  constructor(edit, mask, children) {
    this.edit = edit;
    this.mask = mask;
    this.children = children;
  }
  modify(edit, shift22, f2222, hash2322, key, size4224) {
    const mask = this.mask;
    const children = this.children;
    const frag = hashFragment24(shift22, hash2322);
    const bit = toBitmap24(frag);
    const indx = fromBitmap24(mask, bit);
    const exists2322 = mask & bit;
    const canEdit = canEditNode24(this, edit);
    if (!exists2322) {
      const _newChild = new EmptyNode24().modify(edit, shift22 + SIZE24, f2222, hash2322, key, size4224);
      if (!_newChild) return this;
      return children.length >= MAX_INDEX_NODE24 ? expand24(edit, frag, _newChild, mask, children) : new _IndexedNode24(edit, mask | bit, arraySpliceIn24(canEdit, indx, _newChild, children));
    }
    const current = children[indx];
    const child = current.modify(edit, shift22 + SIZE24, f2222, hash2322, key, size4224);
    if (current === child) return this;
    let bitmap = mask;
    let newChildren;
    if (isEmptyNode24(child)) {
      bitmap &= ~bit;
      if (!bitmap) return new EmptyNode24();
      if (children.length <= 2 && isLeafNode24(children[indx ^ 1])) {
        return children[indx ^ 1];
      }
      newChildren = arraySpliceOut24(canEdit, indx, children);
    } else {
      newChildren = arrayUpdate24(canEdit, indx, child, children);
    }
    if (canEdit) {
      this.mask = bitmap;
      this.children = newChildren;
      return this;
    }
    return new _IndexedNode24(edit, bitmap, newChildren);
  }
};
var ArrayNode24 = class _ArrayNode24 {
  edit;
  size;
  children;
  _tag = "ArrayNode";
  constructor(edit, size4224, children) {
    this.edit = edit;
    this.size = size4224;
    this.children = children;
  }
  modify(edit, shift22, f2222, hash2322, key, size4224) {
    let count = this.size;
    const children = this.children;
    const frag = hashFragment24(shift22, hash2322);
    const child = children[frag];
    const newChild = (child || new EmptyNode24()).modify(edit, shift22 + SIZE24, f2222, hash2322, key, size4224);
    if (child === newChild) return this;
    const canEdit = canEditNode24(this, edit);
    let newChildren;
    if (isEmptyNode24(child) && !isEmptyNode24(newChild)) {
      ++count;
      newChildren = arrayUpdate24(canEdit, frag, newChild, children);
    } else if (!isEmptyNode24(child) && isEmptyNode24(newChild)) {
      --count;
      if (count <= MIN_ARRAY_NODE24) {
        return pack24(edit, count, frag, children);
      }
      newChildren = arrayUpdate24(canEdit, frag, new EmptyNode24(), children);
    } else {
      newChildren = arrayUpdate24(canEdit, frag, newChild, children);
    }
    if (canEdit) {
      this.size = count;
      this.children = newChildren;
      return this;
    }
    return new _ArrayNode24(edit, count, newChildren);
  }
};
function pack24(edit, count, removed, elements) {
  const children = new Array(count - 1);
  let g2222 = 0;
  let bitmap = 0;
  for (let i2222 = 0, len = elements.length; i2222 < len; ++i2222) {
    if (i2222 !== removed) {
      const elem = elements[i2222];
      if (elem && !isEmptyNode24(elem)) {
        children[g2222++] = elem;
        bitmap |= 1 << i2222;
      }
    }
  }
  return new IndexedNode24(edit, bitmap, children);
}
function expand24(edit, frag, child, bitmap, subNodes) {
  const arr = [];
  let bit = bitmap;
  let count = 0;
  for (let i2222 = 0; bit; ++i2222) {
    if (bit & 1) arr[i2222] = subNodes[count++];
    bit >>>= 1;
  }
  arr[frag] = child;
  return new ArrayNode24(edit, count + 1, arr);
}
function mergeLeavesInner24(edit, shift22, h1, n1, h2222, n2222) {
  if (h1 === h2222) return new CollisionNode24(edit, h1, [n2222, n1]);
  const subH1 = hashFragment24(shift22, h1);
  const subH2 = hashFragment24(shift22, h2222);
  if (subH1 === subH2) {
    return (child) => new IndexedNode24(edit, toBitmap24(subH1) | toBitmap24(subH2), [child]);
  } else {
    const children = subH1 < subH2 ? [n1, n2222] : [n2222, n1];
    return new IndexedNode24(edit, toBitmap24(subH1) | toBitmap24(subH2), children);
  }
}
function mergeLeaves24(edit, shift22, h1, n1, h2222, n2222) {
  let stack = void 0;
  let currentShift = shift22;
  while (true) {
    const res = mergeLeavesInner24(edit, currentShift, h1, n1, h2222, n2222);
    if (typeof res === "function") {
      stack = make524(res, stack);
      currentShift = currentShift + SIZE24;
    } else {
      let final = res;
      while (stack != null) {
        final = stack.value(final);
        stack = stack.previous;
      }
      return final;
    }
  }
}
var HashMapSymbolKey24 = "effect/HashMap";
var HashMapTypeId24 = /* @__PURE__ */ Symbol.for(HashMapSymbolKey24);
var HashMapProto24 = {
  [HashMapTypeId24]: HashMapTypeId24,
  [Symbol.iterator]() {
    return new HashMapIterator24(this, (k2222, v2222) => [k2222, v2222]);
  },
  [symbol36]() {
    let hash2322 = hash26(HashMapSymbolKey24);
    for (const item of this) {
      hash2322 ^= pipe26(hash26(item[0]), combine34(hash26(item[1])));
    }
    return cached26(this, hash2322);
  },
  [symbol226](that) {
    if (isHashMap24(that)) {
      if (that._size !== this._size) {
        return false;
      }
      for (const item of this) {
        const elem = pipe26(that, getHash24(item[0], hash26(item[0])));
        if (isNone226(elem)) {
          return false;
        } else {
          if (!equals26(item[1], elem.value)) {
            return false;
          }
        }
      }
      return true;
    }
    return false;
  },
  toString() {
    return format26(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashMap",
      values: Array.from(this).map(toJSON26)
    };
  },
  [NodeInspectSymbol26]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments26(this, arguments);
  }
};
var makeImpl34 = (editable, edit, root, size4224) => {
  const map622 = Object.create(HashMapProto24);
  map622._editable = editable;
  map622._edit = edit;
  map622._root = root;
  map622._size = size4224;
  return map622;
};
var HashMapIterator24 = class _HashMapIterator24 {
  map;
  f;
  v;
  constructor(map622, f2222) {
    this.map = map622;
    this.f = f2222;
    this.v = visitLazy24(this.map._root, this.f, void 0);
  }
  next() {
    if (isNone226(this.v)) {
      return {
        done: true,
        value: void 0
      };
    }
    const v0 = this.v.value;
    this.v = applyCont24(v0.cont);
    return {
      done: false,
      value: v0.value
    };
  }
  [Symbol.iterator]() {
    return new _HashMapIterator24(this.map, this.f);
  }
};
var applyCont24 = (cont) => cont ? visitLazyChildren24(cont[0], cont[1], cont[2], cont[3], cont[4]) : none226();
var visitLazy24 = (node, f2222, cont = void 0) => {
  switch (node._tag) {
    case "LeafNode": {
      if (isSome226(node.value)) {
        return some326({
          value: f2222(node.key, node.value.value),
          cont
        });
      }
      return applyCont24(cont);
    }
    case "CollisionNode":
    case "ArrayNode":
    case "IndexedNode": {
      const children = node.children;
      return visitLazyChildren24(children.length, children, 0, f2222, cont);
    }
    default: {
      return applyCont24(cont);
    }
  }
};
var visitLazyChildren24 = (len, children, i2222, f2222, cont) => {
  while (i2222 < len) {
    const child = children[i2222++];
    if (child && !isEmptyNode24(child)) {
      return visitLazy24(child, f2222, [len, children, i2222, f2222, cont]);
    }
  }
  return applyCont24(cont);
};
var _empty324 = /* @__PURE__ */ makeImpl34(false, 0, /* @__PURE__ */ new EmptyNode24(), 0);
var empty424 = () => _empty324;
var isHashMap24 = (u2222) => hasProperty26(u2222, HashMapTypeId24);
var getHash24 = /* @__PURE__ */ dual26(3, (self2, key, hash2322) => {
  let node = self2._root;
  let shift22 = 0;
  while (true) {
    switch (node._tag) {
      case "LeafNode": {
        return equals26(key, node.key) ? node.value : none226();
      }
      case "CollisionNode": {
        if (hash2322 === node.hash) {
          const children = node.children;
          for (let i2222 = 0, len = children.length; i2222 < len; ++i2222) {
            const child = children[i2222];
            if ("key" in child && equals26(key, child.key)) {
              return child.value;
            }
          }
        }
        return none226();
      }
      case "IndexedNode": {
        const frag = hashFragment24(shift22, hash2322);
        const bit = toBitmap24(frag);
        if (node.mask & bit) {
          node = node.children[fromBitmap24(node.mask, bit)];
          shift22 += SIZE24;
          break;
        }
        return none226();
      }
      case "ArrayNode": {
        node = node.children[hashFragment24(shift22, hash2322)];
        if (node) {
          shift22 += SIZE24;
          break;
        }
        return none226();
      }
      default:
        return none226();
    }
  }
});
var set26 = /* @__PURE__ */ dual26(3, (self2, key, value) => modifyAt24(self2, key, () => some326(value)));
var setTree24 = /* @__PURE__ */ dual26(3, (self2, newRoot, newSize) => {
  if (self2._editable) {
    self2._root = newRoot;
    self2._size = newSize;
    return self2;
  }
  return newRoot === self2._root ? self2 : makeImpl34(self2._editable, self2._edit, newRoot, newSize);
});
var keys24 = (self2) => new HashMapIterator24(self2, (key) => key);
var size44 = (self2) => self2._size;
var beginMutation34 = (self2) => makeImpl34(true, self2._edit + 1, self2._root, self2._size);
var modifyAt24 = /* @__PURE__ */ dual26(3, (self2, key, f2222) => modifyHash24(self2, key, hash26(key), f2222));
var modifyHash24 = /* @__PURE__ */ dual26(4, (self2, key, hash2322, f2222) => {
  const size4224 = {
    value: self2._size
  };
  const newRoot = self2._root.modify(self2._editable ? self2._edit : NaN, 0, f2222, hash2322, key, size4224);
  return pipe26(self2, setTree24(newRoot, size4224.value));
});
var forEach34 = /* @__PURE__ */ dual26(2, (self2, f2222) => reduce224(self2, void 0, (_2222, value, key) => f2222(value, key)));
var reduce224 = /* @__PURE__ */ dual26(3, (self2, zero, f2222) => {
  const root = self2._root;
  if (root._tag === "LeafNode") {
    return isSome226(root.value) ? f2222(zero, root.value.value, root.key) : zero;
  }
  if (root._tag === "EmptyNode") {
    return zero;
  }
  const toVisit = [root.children];
  let children;
  while (children = toVisit.pop()) {
    for (let i2222 = 0, len = children.length; i2222 < len; ) {
      const child = children[i2222++];
      if (child && !isEmptyNode24(child)) {
        if (child._tag === "LeafNode") {
          if (isSome226(child.value)) {
            zero = f2222(zero, child.value.value, child.key);
          }
        } else {
          toVisit.push(child.children);
        }
      }
    }
  }
  return zero;
});
var HashSetSymbolKey24 = "effect/HashSet";
var HashSetTypeId24 = /* @__PURE__ */ Symbol.for(HashSetSymbolKey24);
var HashSetProto24 = {
  [HashSetTypeId24]: HashSetTypeId24,
  [Symbol.iterator]() {
    return keys24(this._keyMap);
  },
  [symbol36]() {
    return cached26(this, combine34(hash26(this._keyMap))(hash26(HashSetSymbolKey24)));
  },
  [symbol226](that) {
    if (isHashSet24(that)) {
      return size44(this._keyMap) === size44(that._keyMap) && equals26(this._keyMap, that._keyMap);
    }
    return false;
  },
  toString() {
    return format26(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashSet",
      values: Array.from(this).map(toJSON26)
    };
  },
  [NodeInspectSymbol26]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments26(this, arguments);
  }
};
var makeImpl224 = (keyMap) => {
  const set2322 = Object.create(HashSetProto24);
  set2322._keyMap = keyMap;
  return set2322;
};
var isHashSet24 = (u2222) => hasProperty26(u2222, HashSetTypeId24);
var _empty424 = /* @__PURE__ */ makeImpl224(/* @__PURE__ */ empty424());
var empty524 = () => _empty424;
var size224 = (self2) => size44(self2._keyMap);
var beginMutation224 = (self2) => makeImpl224(beginMutation34(self2._keyMap));
var endMutation24 = (self2) => {
  self2._keyMap._editable = false;
  return self2;
};
var mutate24 = /* @__PURE__ */ dual26(2, (self2, f2222) => {
  const transient = beginMutation224(self2);
  f2222(transient);
  return endMutation24(transient);
});
var add224 = /* @__PURE__ */ dual26(2, (self2, value) => self2._keyMap._editable ? (set26(value, true)(self2._keyMap), self2) : makeImpl224(set26(value, true)(self2._keyMap)));
var union224 = /* @__PURE__ */ dual26(2, (self2, that) => mutate24(empty524(), (set2322) => {
  forEach224(self2, (value) => add224(set2322, value));
  for (const value of that) {
    add224(set2322, value);
  }
}));
var forEach224 = /* @__PURE__ */ dual26(2, (self2, f2222) => forEach34(self2._keyMap, (_2222, k2222) => f2222(k2222)));
var empty624 = empty524;
var size324 = size224;
var add324 = add224;
var union324 = union224;
var ArrayProto24 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(Array.prototype), {
  [symbol36]() {
    return cached26(this, array34(this));
  },
  [symbol226](that) {
    if (Array.isArray(that) && this.length === that.length) {
      return this.every((v2222, i2222) => equals26(v2222, that[i2222]));
    } else {
      return false;
    }
  }
});
var Structural34 = /* @__PURE__ */ function() {
  function Structural3224(args) {
    if (args) {
      Object.assign(this, args);
    }
  }
  Structural3224.prototype = StructuralPrototype26;
  return Structural3224;
}();
var struct224 = (as2322) => Object.assign(Object.create(StructuralPrototype26), as2322);
var ContextPatchTypeId24 = /* @__PURE__ */ Symbol.for("effect/DifferContextPatch");
function variance34(a2222) {
  return a2222;
}
var PatchProto24 = {
  ...Structural34.prototype,
  [ContextPatchTypeId24]: {
    _Value: variance34,
    _Patch: variance34
  }
};
var EmptyProto24 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto24), {
  _tag: "Empty"
});
var _empty524 = /* @__PURE__ */ Object.create(EmptyProto24);
var empty724 = () => _empty524;
var AndThenProto24 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto24), {
  _tag: "AndThen"
});
var makeAndThen24 = (first, second) => {
  const o2222 = Object.create(AndThenProto24);
  o2222.first = first;
  o2222.second = second;
  return o2222;
};
var AddServiceProto24 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto24), {
  _tag: "AddService"
});
var makeAddService24 = (key, service) => {
  const o2222 = Object.create(AddServiceProto24);
  o2222.key = key;
  o2222.service = service;
  return o2222;
};
var RemoveServiceProto24 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto24), {
  _tag: "RemoveService"
});
var makeRemoveService24 = (key) => {
  const o2222 = Object.create(RemoveServiceProto24);
  o2222.key = key;
  return o2222;
};
var UpdateServiceProto24 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto24), {
  _tag: "UpdateService"
});
var makeUpdateService24 = (key, update222) => {
  const o2222 = Object.create(UpdateServiceProto24);
  o2222.key = key;
  o2222.update = update222;
  return o2222;
};
var diff24 = (oldValue, newValue) => {
  const missingServices = new Map(oldValue.unsafeMap);
  let patch2224 = empty724();
  for (const [tag, newService] of newValue.unsafeMap.entries()) {
    if (missingServices.has(tag)) {
      const old = missingServices.get(tag);
      missingServices.delete(tag);
      if (!equals26(old, newService)) {
        patch2224 = combine226(makeUpdateService24(tag, () => newService))(patch2224);
      }
    } else {
      missingServices.delete(tag);
      patch2224 = combine226(makeAddService24(tag, newService))(patch2224);
    }
  }
  for (const [tag] of missingServices.entries()) {
    patch2224 = combine226(makeRemoveService24(tag))(patch2224);
  }
  return patch2224;
};
var combine226 = /* @__PURE__ */ dual26(2, (self2, that) => makeAndThen24(self2, that));
var patch24 = /* @__PURE__ */ dual26(2, (self2, context) => {
  if (self2._tag === "Empty") {
    return context;
  }
  let wasServiceUpdated = false;
  let patches = of24(self2);
  const updatedContext = new Map(context.unsafeMap);
  while (isNonEmpty24(patches)) {
    const head222 = headNonEmpty24(patches);
    const tail222 = tailNonEmpty24(patches);
    switch (head222._tag) {
      case "Empty": {
        patches = tail222;
        break;
      }
      case "AddService": {
        updatedContext.set(head222.key, head222.service);
        patches = tail222;
        break;
      }
      case "AndThen": {
        patches = prepend24(prepend24(tail222, head222.second), head222.first);
        break;
      }
      case "RemoveService": {
        updatedContext.delete(head222.key);
        patches = tail222;
        break;
      }
      case "UpdateService": {
        updatedContext.set(head222.key, head222.update(updatedContext.get(head222.key)));
        wasServiceUpdated = true;
        patches = tail222;
        break;
      }
    }
  }
  if (!wasServiceUpdated) {
    return makeContext24(updatedContext);
  }
  const map622 = /* @__PURE__ */ new Map();
  for (const [tag] of context.unsafeMap) {
    if (updatedContext.has(tag)) {
      map622.set(tag, updatedContext.get(tag));
      updatedContext.delete(tag);
    }
  }
  for (const [tag, s2222] of updatedContext) {
    map622.set(tag, s2222);
  }
  return makeContext24(map622);
});
var DifferTypeId24 = /* @__PURE__ */ Symbol.for("effect/Differ");
var DifferProto24 = {
  [DifferTypeId24]: {
    _P: identity26,
    _V: identity26
  }
};
var make724 = (params) => {
  const differ = Object.create(DifferProto24);
  differ.empty = params.empty;
  differ.diff = params.diff;
  differ.combine = params.combine;
  differ.patch = params.patch;
  return differ;
};
var environment24 = () => make724({
  empty: empty724(),
  combine: (first, second) => combine226(second)(first),
  diff: (oldValue, newValue) => diff24(oldValue, newValue),
  patch: (patch2224, oldValue) => patch24(oldValue)(patch2224)
});
var OP_DIE24 = "Die";
var OP_EMPTY24 = "Empty";
var OP_FAIL24 = "Fail";
var OP_INTERRUPT24 = "Interrupt";
var OP_PARALLEL24 = "Parallel";
var OP_SEQUENTIAL24 = "Sequential";
var CauseSymbolKey24 = "effect/Cause";
var CauseTypeId24 = /* @__PURE__ */ Symbol.for(CauseSymbolKey24);
var variance224 = {
  /* c8 ignore next */
  _E: (_2222) => _2222
};
var proto24 = {
  [CauseTypeId24]: variance224,
  [symbol36]() {
    return pipe26(hash26(CauseSymbolKey24), combine34(hash26(flattenCause24(this))), cached26(this));
  },
  [symbol226](that) {
    return isCause24(that) && causeEquals24(this, that);
  },
  pipe() {
    return pipeArguments26(this, arguments);
  },
  toJSON() {
    switch (this._tag) {
      case "Empty":
        return {
          _id: "Cause",
          _tag: this._tag
        };
      case "Die":
        return {
          _id: "Cause",
          _tag: this._tag,
          defect: toJSON26(this.defect)
        };
      case "Interrupt":
        return {
          _id: "Cause",
          _tag: this._tag,
          fiberId: this.fiberId.toJSON()
        };
      case "Fail":
        return {
          _id: "Cause",
          _tag: this._tag,
          failure: toJSON26(this.error)
        };
      case "Sequential":
      case "Parallel":
        return {
          _id: "Cause",
          _tag: this._tag,
          left: toJSON26(this.left),
          right: toJSON26(this.right)
        };
    }
  },
  toString() {
    return pretty24(this);
  },
  [NodeInspectSymbol26]() {
    return this.toJSON();
  }
};
var fail34 = (error) => {
  const o2222 = Object.create(proto24);
  o2222._tag = OP_FAIL24;
  o2222.error = error;
  return o2222;
};
var parallel24 = (left3224, right3224) => {
  const o2222 = Object.create(proto24);
  o2222._tag = OP_PARALLEL24;
  o2222.left = left3224;
  o2222.right = right3224;
  return o2222;
};
var sequential24 = (left3224, right3224) => {
  const o2222 = Object.create(proto24);
  o2222._tag = OP_SEQUENTIAL24;
  o2222.left = left3224;
  o2222.right = right3224;
  return o2222;
};
var isCause24 = (u2222) => hasProperty26(u2222, CauseTypeId24);
var isInterruptedOnly24 = (self2) => reduceWithContext24(void 0, IsInterruptedOnlyCauseReducer24)(self2);
var causeEquals24 = (left3224, right3224) => {
  let leftStack = of24(left3224);
  let rightStack = of24(right3224);
  while (isNonEmpty24(leftStack) && isNonEmpty24(rightStack)) {
    const [leftParallel, leftSequential] = pipe26(headNonEmpty24(leftStack), reduce424([empty624(), empty324()], ([parallel2224, sequential2224], cause) => {
      const [par, seq] = evaluateCause24(cause);
      return some326([pipe26(parallel2224, union324(par)), pipe26(sequential2224, appendAll24(seq))]);
    }));
    const [rightParallel, rightSequential] = pipe26(headNonEmpty24(rightStack), reduce424([empty624(), empty324()], ([parallel2224, sequential2224], cause) => {
      const [par, seq] = evaluateCause24(cause);
      return some326([pipe26(parallel2224, union324(par)), pipe26(sequential2224, appendAll24(seq))]);
    }));
    if (!equals26(leftParallel, rightParallel)) {
      return false;
    }
    leftStack = leftSequential;
    rightStack = rightSequential;
  }
  return true;
};
var flattenCause24 = (cause) => {
  return flattenCauseLoop24(of24(cause), empty324());
};
var flattenCauseLoop24 = (causes, flattened) => {
  while (1) {
    const [parallel2224, sequential2224] = pipe26(causes, reduce34([empty624(), empty324()], ([parallel322, sequential322], cause) => {
      const [par, seq] = evaluateCause24(cause);
      return [pipe26(parallel322, union324(par)), pipe26(sequential322, appendAll24(seq))];
    }));
    const updated = size324(parallel2224) > 0 ? pipe26(flattened, prepend24(parallel2224)) : flattened;
    if (isEmpty24(sequential2224)) {
      return reverse224(updated);
    }
    causes = sequential2224;
    flattened = updated;
  }
  throw new Error(getBugErrorMessage26("Cause.flattenCauseLoop"));
};
var evaluateCause24 = (self2) => {
  let cause = self2;
  const stack = [];
  let _parallel = empty624();
  let _sequential = empty324();
  while (cause !== void 0) {
    switch (cause._tag) {
      case OP_EMPTY24: {
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_FAIL24: {
        _parallel = add324(_parallel, make426(cause._tag, cause.error));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_DIE24: {
        _parallel = add324(_parallel, make426(cause._tag, cause.defect));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_INTERRUPT24: {
        _parallel = add324(_parallel, make426(cause._tag, cause.fiberId));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_SEQUENTIAL24: {
        switch (cause.left._tag) {
          case OP_EMPTY24: {
            cause = cause.right;
            break;
          }
          case OP_SEQUENTIAL24: {
            cause = sequential24(cause.left.left, sequential24(cause.left.right, cause.right));
            break;
          }
          case OP_PARALLEL24: {
            cause = parallel24(sequential24(cause.left.left, cause.right), sequential24(cause.left.right, cause.right));
            break;
          }
          default: {
            _sequential = prepend24(_sequential, cause.right);
            cause = cause.left;
            break;
          }
        }
        break;
      }
      case OP_PARALLEL24: {
        stack.push(cause.right);
        cause = cause.left;
        break;
      }
    }
  }
  throw new Error(getBugErrorMessage26("Cause.evaluateCauseLoop"));
};
var IsInterruptedOnlyCauseReducer24 = {
  emptyCase: constTrue26,
  failCase: constFalse26,
  dieCase: constFalse26,
  interruptCase: constTrue26,
  sequentialCase: (_2222, left3224, right3224) => left3224 && right3224,
  parallelCase: (_2222, left3224, right3224) => left3224 && right3224
};
var OP_SEQUENTIAL_CASE24 = "SequentialCase";
var OP_PARALLEL_CASE24 = "ParallelCase";
var reduce424 = /* @__PURE__ */ dual26(3, (self2, zero, pf) => {
  let accumulator = zero;
  let cause = self2;
  const causes = [];
  while (cause !== void 0) {
    const option = pf(accumulator, cause);
    accumulator = isSome226(option) ? option.value : accumulator;
    switch (cause._tag) {
      case OP_SEQUENTIAL24: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      case OP_PARALLEL24: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      default: {
        cause = void 0;
        break;
      }
    }
    if (cause === void 0 && causes.length > 0) {
      cause = causes.pop();
    }
  }
  return accumulator;
});
var reduceWithContext24 = /* @__PURE__ */ dual26(3, (self2, context, reducer) => {
  const input = [self2];
  const output = [];
  while (input.length > 0) {
    const cause = input.pop();
    switch (cause._tag) {
      case OP_EMPTY24: {
        output.push(right226(reducer.emptyCase(context)));
        break;
      }
      case OP_FAIL24: {
        output.push(right226(reducer.failCase(context, cause.error)));
        break;
      }
      case OP_DIE24: {
        output.push(right226(reducer.dieCase(context, cause.defect)));
        break;
      }
      case OP_INTERRUPT24: {
        output.push(right226(reducer.interruptCase(context, cause.fiberId)));
        break;
      }
      case OP_SEQUENTIAL24: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left226({
          _tag: OP_SEQUENTIAL_CASE24
        }));
        break;
      }
      case OP_PARALLEL24: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left226({
          _tag: OP_PARALLEL_CASE24
        }));
        break;
      }
    }
  }
  const accumulator = [];
  while (output.length > 0) {
    const either = output.pop();
    switch (either._tag) {
      case "Left": {
        switch (either.left._tag) {
          case OP_SEQUENTIAL_CASE24: {
            const left3224 = accumulator.pop();
            const right3224 = accumulator.pop();
            const value = reducer.sequentialCase(context, left3224, right3224);
            accumulator.push(value);
            break;
          }
          case OP_PARALLEL_CASE24: {
            const left3224 = accumulator.pop();
            const right3224 = accumulator.pop();
            const value = reducer.parallelCase(context, left3224, right3224);
            accumulator.push(value);
            break;
          }
        }
        break;
      }
      case "Right": {
        accumulator.push(either.right);
        break;
      }
    }
  }
  if (accumulator.length === 0) {
    throw new Error("BUG: Cause.reduceWithContext - please report an issue at https://github.com/Effect-TS/effect/issues");
  }
  return accumulator.pop();
});
var pretty24 = (cause) => {
  if (isInterruptedOnly24(cause)) {
    return "All fibers interrupted without errors.";
  }
  return prettyErrors24(cause).map((e2222) => e2222.stack).join("\n");
};
var PrettyError24 = class extends globalThis.Error {
  span = void 0;
  constructor(originalError) {
    const prevLimit = Error.stackTraceLimit;
    Error.stackTraceLimit = 0;
    super(prettyErrorMessage24(originalError));
    Error.stackTraceLimit = prevLimit;
    this.name = originalError instanceof Error ? originalError.name : "Error";
    if (typeof originalError === "object" && originalError !== null) {
      if (spanSymbol34 in originalError) {
        this.span = originalError[spanSymbol34];
      }
      Object.keys(originalError).forEach((key) => {
        if (!(key in this)) {
          this[key] = originalError[key];
        }
      });
    }
    this.stack = prettyErrorStack24(this.message, originalError instanceof Error && originalError.stack ? originalError.stack : "", this.span);
  }
  toJSON() {
    const out = {
      message: this.message,
      stack: this.stack
    };
    if (this.span) {
      out.span = this.span;
    }
    return out;
  }
};
var prettyErrorMessage24 = (u2222) => {
  if (typeof u2222 === "string") {
    return `Error: ${u2222}`;
  }
  try {
    if (hasProperty26(u2222, "toString") && isFunction326(u2222["toString"]) && u2222["toString"] !== Object.prototype.toString && u2222["toString"] !== globalThis.Array.prototype.toString) {
      return u2222["toString"]();
    }
  } catch {
  }
  return `Error: ${JSON.stringify(u2222)}`;
};
var locationRegex24 = /\((.*)\)/;
var spanToTrace24 = /* @__PURE__ */ globalValue26("effect/Tracer/spanToTrace", () => /* @__PURE__ */ new WeakMap());
var prettyErrorStack24 = (message, stack, span24) => {
  const out = [message];
  const lines = stack.split("\n");
  for (let i2222 = 1; i2222 < lines.length; i2222++) {
    if (lines[i2222].includes("Generator.next")) {
      break;
    }
    if (lines[i2222].includes("effect_internal_function")) {
      out.pop();
      break;
    }
    out.push(lines[i2222].replace(/at .*effect_instruction_i.*\((.*)\)/, "at $1").replace(/EffectPrimitive\.\w+/, "<anonymous>"));
  }
  if (span24) {
    let current = span24;
    let i2222 = 0;
    while (current && current._tag === "Span" && i2222 < 10) {
      const stackFn = spanToTrace24.get(current);
      if (typeof stackFn === "function") {
        const stack2 = stackFn();
        const locationMatch = stack2.match(locationRegex24);
        const location = locationMatch ? locationMatch[1] : stack2.replace(/^at /, "");
        out.push(`    at ${current.name} (${location})`);
      } else {
        out.push(`    at ${current.name}`);
      }
      current = getOrUndefined26(current.parent);
      i2222++;
    }
  }
  return out.join("\n");
};
var spanSymbol34 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var prettyErrors24 = (cause) => reduceWithContext24(cause, void 0, {
  emptyCase: () => [],
  dieCase: (_2222, unknownError) => {
    return [new PrettyError24(unknownError)];
  },
  failCase: (_2222, error) => {
    return [new PrettyError24(error)];
  },
  interruptCase: () => [],
  parallelCase: (_2222, l2222, r2222) => [...l2222, ...r2222],
  sequentialCase: (_2222, l2222, r2222) => [...l2222, ...r2222]
});
var SingleShotGen226 = class _SingleShotGen224 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  next(a2222) {
    return this.called ? {
      value: a2222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  return(a2222) {
    return {
      value: a2222,
      done: true
    };
  }
  throw(e2222) {
    throw e2222;
  }
  [Symbol.iterator]() {
    return new _SingleShotGen224(this.self);
  }
};
var spanTag24 = /* @__PURE__ */ GenericTag24("effect/ParentSpan");
var EffectTypeId226 = /* @__PURE__ */ Symbol.for("effect/Effect");
var EffectPrimitive24 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId226] = effectVariance26;
  constructor(_op) {
    this._op = _op;
  }
  [symbol226](that) {
    return this === that;
  }
  [symbol36]() {
    return cached26(this, random26(this));
  }
  pipe() {
    return pipeArguments26(this, arguments);
  }
  toJSON() {
    return {
      _id: "Effect",
      _op: this._op,
      effect_instruction_i0: toJSON26(this.effect_instruction_i0),
      effect_instruction_i1: toJSON26(this.effect_instruction_i1),
      effect_instruction_i2: toJSON26(this.effect_instruction_i2)
    };
  }
  toString() {
    return format26(this.toJSON());
  }
  [NodeInspectSymbol26]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen226(new YieldWrap26(this));
  }
};
var EffectPrimitiveFailure24 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId226] = effectVariance26;
  constructor(_op) {
    this._op = _op;
    this._tag = _op;
  }
  [symbol226](that) {
    return exitIsExit24(that) && that._op === "Failure" && // @ts-expect-error
    equals26(this.effect_instruction_i0, that.effect_instruction_i0);
  }
  [symbol36]() {
    return pipe26(
      // @ts-expect-error
      string26(this._tag),
      // @ts-expect-error
      combine34(hash26(this.effect_instruction_i0)),
      cached26(this)
    );
  }
  get cause() {
    return this.effect_instruction_i0;
  }
  pipe() {
    return pipeArguments26(this, arguments);
  }
  toJSON() {
    return {
      _id: "Exit",
      _tag: this._op,
      cause: this.cause.toJSON()
    };
  }
  toString() {
    return format26(this.toJSON());
  }
  [NodeInspectSymbol26]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen226(new YieldWrap26(this));
  }
};
var isEffect24 = (u2222) => hasProperty26(u2222, EffectTypeId226);
var withFiberRuntime24 = (withRuntime) => {
  const effect = new EffectPrimitive24(OP_WITH_RUNTIME24);
  effect.effect_instruction_i0 = withRuntime;
  return effect;
};
var spanSymbol224 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var originalSymbol24 = /* @__PURE__ */ Symbol.for("effect/OriginalAnnotation");
var capture24 = (obj, span24) => {
  if (isSome226(span24)) {
    return new Proxy(obj, {
      has(target, p2222) {
        return p2222 === spanSymbol224 || p2222 === originalSymbol24 || p2222 in target;
      },
      get(target, p2222) {
        if (p2222 === spanSymbol224) {
          return span24.value;
        }
        if (p2222 === originalSymbol24) {
          return obj;
        }
        return target[p2222];
      }
    });
  }
  return obj;
};
var fail224 = (error) => isObject26(error) && !(spanSymbol224 in error) ? withFiberRuntime24((fiber) => failCause24(fail34(capture24(error, currentSpanFromFiber24(fiber))))) : failCause24(fail34(error));
var failCause24 = (cause) => {
  const effect = new EffectPrimitiveFailure24(OP_FAILURE24);
  effect.effect_instruction_i0 = cause;
  return effect;
};
var FiberRefSymbolKey24 = "effect/FiberRef";
var FiberRefTypeId24 = /* @__PURE__ */ Symbol.for(FiberRefSymbolKey24);
var fiberRefVariance24 = {
  /* c8 ignore next */
  _A: (_2222) => _2222
};
var fiberRefUnsafeMakeContext24 = (initial) => {
  const differ = environment24();
  return fiberRefUnsafeMakePatch24(initial, {
    differ,
    fork: differ.empty
  });
};
var fiberRefUnsafeMakePatch24 = (initial, options) => ({
  [FiberRefTypeId24]: fiberRefVariance24,
  initial,
  diff: (oldValue, newValue) => options.differ.diff(oldValue, newValue),
  combine: (first, second) => options.differ.combine(first, second),
  patch: (patch2224) => (oldValue) => options.differ.patch(patch2224, oldValue),
  fork: options.fork,
  join: options.join ?? ((_2222, n2222) => n2222),
  pipe() {
    return pipeArguments26(this, arguments);
  }
});
var currentContext24 = /* @__PURE__ */ globalValue26(/* @__PURE__ */ Symbol.for("effect/FiberRef/currentContext"), () => fiberRefUnsafeMakeContext24(empty224()));
var YieldableError24 = /* @__PURE__ */ function() {
  class YieldableError2224 extends globalThis.Error {
    commit() {
      return fail224(this);
    }
    toString() {
      return this.message ? `${this.name}: ${this.message}` : this.name;
    }
    toJSON() {
      return {
        ...this
      };
    }
    [NodeInspectSymbol26]() {
      const stack = this.stack;
      if (stack) {
        return `${this.toString()}
${stack.split("\n").slice(1).join("\n")}`;
      }
      return this.toString();
    }
  }
  Object.assign(YieldableError2224.prototype, StructuralCommitPrototype26);
  return YieldableError2224;
}();
var exitIsExit24 = (u2222) => isEffect24(u2222) && "_tag" in u2222 && (u2222._tag === "Success" || u2222._tag === "Failure");
var currentSpanFromFiber24 = (fiber) => {
  const span24 = fiber.getFiberRef(currentContext24).unsafeMap.get(spanTag24.key);
  return span24 !== void 0 && span24._tag === "Span" ? some326(span24) : none226();
};
var Data_exports26 = {};
__export2224(Data_exports26, {
  Class: () => Class224,
  Error: () => Error224,
  Structural: () => Structural224,
  TaggedClass: () => TaggedClass24,
  TaggedError: () => TaggedError24,
  array: () => array224,
  case: () => _case24,
  struct: () => struct324,
  tagged: () => tagged24,
  taggedEnum: () => taggedEnum24,
  tuple: () => tuple224,
  unsafeArray: () => unsafeArray24,
  unsafeStruct: () => unsafeStruct24
});
var struct324 = struct224;
var unsafeStruct24 = (as2322) => Object.setPrototypeOf(as2322, StructuralPrototype26);
var tuple224 = (...as2322) => unsafeArray24(as2322);
var array224 = (as2322) => unsafeArray24(as2322.slice(0));
var unsafeArray24 = (as2322) => Object.setPrototypeOf(as2322, ArrayProto24);
var _case24 = () => (args) => args === void 0 ? Object.create(StructuralPrototype26) : struct324(args);
var tagged24 = (tag) => (args) => {
  const value = args === void 0 ? Object.create(StructuralPrototype26) : struct324(args);
  value._tag = tag;
  return value;
};
var Class224 = Structural34;
var TaggedClass24 = (tag) => {
  class Base extends Class224 {
    _tag = tag;
  }
  return Base;
};
var Structural224 = Structural34;
var taggedEnum24 = () => new Proxy({}, {
  get(_target, tag, _receiver) {
    if (tag === "$is") {
      return isTagged24;
    } else if (tag === "$match") {
      return taggedMatch24;
    }
    return tagged24(tag);
  }
});
function taggedMatch24() {
  if (arguments.length === 1) {
    const cases2 = arguments[0];
    return function(value2) {
      return cases2[value2._tag](value2);
    };
  }
  const value = arguments[0];
  const cases = arguments[1];
  return cases[value._tag](value);
}
var Error224 = /* @__PURE__ */ function() {
  return class Base extends YieldableError24 {
    constructor(args) {
      super();
      if (args) {
        Object.assign(this, args);
      }
    }
  };
}();
var TaggedError24 = (tag) => {
  class Base extends Error224 {
    _tag = tag;
  }
  Base.prototype.name = tag;
  return Base;
};
var traverseUp24 = Function_exports26.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType24.Program) return Option_exports26.none();
  return predicate(parent) ? Option_exports26.some(parent) : traverseUp24(parent, predicate);
});
var traverseUpGuard24 = Function_exports26.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType24.Program) return Option_exports26.none();
  return predicate(parent) ? Option_exports26.some(parent) : traverseUpGuard24(parent, predicate);
});
var ESLintCommunityESLintUtils24;
((ESLintCommunityESLintUtils2224) => {
  ESLintCommunityESLintUtils2224.getFunctionHeadLocation = getFunctionHeadLocation24;
  ESLintCommunityESLintUtils2224.getFunctionNameWithKind = getFunctionNameWithKind24;
  ESLintCommunityESLintUtils2224.getPropertyName = getPropertyName24;
  ESLintCommunityESLintUtils2224.getStaticValue = getStaticValue24;
  ESLintCommunityESLintUtils2224.getStringIfConstant = getStringIfConstant24;
  ESLintCommunityESLintUtils2224.hasSideEffect = hasSideEffect24;
  ESLintCommunityESLintUtils2224.isParenthesized = isParenthesized24;
})(ESLintCommunityESLintUtils24 || (ESLintCommunityESLintUtils24 = {}));
var Construction24 = Data_exports26.taggedEnum();
Construction24.None();
a6({
  type: N6.union([NodeType24.FunctionExpression, NodeType24.ArrowFunctionExpression]),
  parent: {
    type: NodeType24.Property,
    parent: {
      type: NodeType24.ObjectExpression
    }
  }
});
a6({
  type: N6.union([NodeType24.FunctionExpression, NodeType24.ArrowFunctionExpression]),
  parent: {
    type: NodeType24.MethodDefinition,
    parent: {
      type: NodeType24.ClassBody
    }
  }
});
a6({
  type: N6.union([NodeType24.FunctionExpression, NodeType24.ArrowFunctionExpression]),
  parent: {
    type: NodeType24.Property,
    parent: {
      type: NodeType24.ClassBody
    }
  }
});
var Function_exports224 = {};
__export34(Function_exports224, {
  SK: () => SK224,
  absurd: () => absurd224,
  apply: () => apply224,
  compose: () => compose324,
  constFalse: () => constFalse224,
  constNull: () => constNull224,
  constTrue: () => constTrue224,
  constUndefined: () => constUndefined224,
  constVoid: () => constVoid224,
  constant: () => constant224,
  dual: () => dual224,
  flip: () => flip224,
  flow: () => flow224,
  hole: () => hole224,
  identity: () => identity224,
  isFunction: () => isFunction44,
  pipe: () => pipe224,
  satisfies: () => satisfies224,
  tupled: () => tupled224,
  unsafeCoerce: () => unsafeCoerce224,
  untupled: () => untupled224
});
var isFunction44 = (input) => typeof input === "function";
var dual224 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a2222, b2222) {
        if (arguments.length >= 2) {
          return body(a2222, b2222);
        }
        return function(self2) {
          return body(self2, a2222);
        };
      };
    case 3:
      return function(a2222, b2222, c2222) {
        if (arguments.length >= 3) {
          return body(a2222, b2222, c2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222);
        };
      };
    case 4:
      return function(a2222, b2222, c2222, d2222) {
        if (arguments.length >= 4) {
          return body(a2222, b2222, c2222, d2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222);
        };
      };
    case 5:
      return function(a2222, b2222, c2222, d2222, e2222) {
        if (arguments.length >= 5) {
          return body(a2222, b2222, c2222, d2222, e2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222, d2222);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply224 = (a2222) => (self2) => self2(a2222);
var identity224 = (a2222) => a2222;
var satisfies224 = () => (b2222) => b2222;
var unsafeCoerce224 = identity224;
var constant224 = (value) => () => value;
var constTrue224 = /* @__PURE__ */ constant224(true);
var constFalse224 = /* @__PURE__ */ constant224(false);
var constNull224 = /* @__PURE__ */ constant224(null);
var constUndefined224 = /* @__PURE__ */ constant224(void 0);
var constVoid224 = constUndefined224;
var flip224 = (f2222) => (...b2222) => (...a2222) => f2222(...a2222)(...b2222);
var compose324 = /* @__PURE__ */ dual224(2, (ab, bc) => (a2222) => bc(ab(a2222)));
var absurd224 = (_2222) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled224 = (f2222) => (a2222) => f2222(...a2222);
var untupled224 = (f2222) => (...a2222) => f2222(a2222);
function pipe224(a2222, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a2222;
    case 2:
      return ab(a2222);
    case 3:
      return bc(ab(a2222));
    case 4:
      return cd(bc(ab(a2222)));
    case 5:
      return de(cd(bc(ab(a2222))));
    case 6:
      return ef(de(cd(bc(ab(a2222)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a2222))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a2222)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a2222))))))));
    default: {
      let ret = arguments[0];
      for (let i2222 = 1; i2222 < arguments.length; i2222++) {
        ret = arguments[i2222](ret);
      }
      return ret;
    }
  }
}
function flow224(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole224 = /* @__PURE__ */ unsafeCoerce224(absurd224);
var SK224 = (_2222, b2222) => b2222;
var Array_exports4 = {};
__export34(Array_exports4, {
  Do: () => Do34,
  allocate: () => allocate4,
  append: () => append5,
  appendAll: () => appendAll224,
  bind: () => bind54,
  bindTo: () => bindTo54,
  cartesian: () => cartesian4,
  cartesianWith: () => cartesianWith4,
  chop: () => chop4,
  chunksOf: () => chunksOf4,
  contains: () => contains34,
  containsWith: () => containsWith34,
  copy: () => copy224,
  dedupe: () => dedupe4,
  dedupeAdjacent: () => dedupeAdjacent4,
  dedupeAdjacentWith: () => dedupeAdjacentWith4,
  dedupeWith: () => dedupeWith4,
  difference: () => difference5,
  differenceWith: () => differenceWith4,
  drop: () => drop224,
  dropRight: () => dropRight4,
  dropWhile: () => dropWhile4,
  empty: () => empty94,
  every: () => every34,
  extend: () => extend4,
  filter: () => filter34,
  filterMap: () => filterMap34,
  filterMapWhile: () => filterMapWhile4,
  findFirst: () => findFirst24,
  findFirstIndex: () => findFirstIndex4,
  findLast: () => findLast4,
  findLastIndex: () => findLastIndex4,
  flatMap: () => flatMap34,
  flatMapNullable: () => flatMapNullable34,
  flatten: () => flatten34,
  forEach: () => forEach324,
  fromIterable: () => fromIterable44,
  fromNullable: () => fromNullable34,
  fromOption: () => fromOption24,
  fromRecord: () => fromRecord4,
  get: () => get9,
  getEquivalence: () => getEquivalence44,
  getLefts: () => getLefts5,
  getOrder: () => getOrder34,
  getRights: () => getRights5,
  getSomes: () => getSomes5,
  group: () => group4,
  groupBy: () => groupBy4,
  groupWith: () => groupWith4,
  head: () => head5,
  headNonEmpty: () => headNonEmpty224,
  init: () => init4,
  initNonEmpty: () => initNonEmpty4,
  insertAt: () => insertAt4,
  intersection: () => intersection5,
  intersectionWith: () => intersectionWith4,
  intersperse: () => intersperse4,
  isArray: () => isArray4,
  isEmptyArray: () => isEmptyArray4,
  isEmptyReadonlyArray: () => isEmptyReadonlyArray4,
  isNonEmptyArray: () => isNonEmptyArray24,
  isNonEmptyReadonlyArray: () => isNonEmptyReadonlyArray4,
  join: () => join4,
  last: () => last4,
  lastNonEmpty: () => lastNonEmpty4,
  length: () => length5,
  let: () => let_54,
  liftEither: () => liftEither4,
  liftNullable: () => liftNullable34,
  liftOption: () => liftOption4,
  liftPredicate: () => liftPredicate34,
  make: () => make104,
  makeBy: () => makeBy4,
  map: () => map34,
  mapAccum: () => mapAccum4,
  match: () => match44,
  matchLeft: () => matchLeft4,
  matchRight: () => matchRight4,
  max: () => max24,
  min: () => min24,
  modify: () => modify5,
  modifyNonEmptyHead: () => modifyNonEmptyHead4,
  modifyNonEmptyLast: () => modifyNonEmptyLast4,
  modifyOption: () => modifyOption5,
  of: () => of224,
  partition: () => partition5,
  partitionMap: () => partitionMap34,
  prepend: () => prepend224,
  prependAll: () => prependAll4,
  range: () => range4,
  reduce: () => reduce324,
  reduceRight: () => reduceRight4,
  remove: () => remove6,
  replace: () => replace24,
  replaceOption: () => replaceOption5,
  replicate: () => replicate4,
  reverse: () => reverse324,
  rotate: () => rotate4,
  scan: () => scan4,
  scanRight: () => scanRight4,
  separate: () => separate5,
  setNonEmptyHead: () => setNonEmptyHead4,
  setNonEmptyLast: () => setNonEmptyLast4,
  some: () => some74,
  sort: () => sort4,
  sortBy: () => sortBy4,
  sortWith: () => sortWith4,
  span: () => span4,
  split: () => split4,
  splitAt: () => splitAt4,
  splitNonEmptyAt: () => splitNonEmptyAt4,
  splitWhere: () => splitWhere4,
  tail: () => tail5,
  tailNonEmpty: () => tailNonEmpty224,
  take: () => take4,
  takeRight: () => takeRight4,
  takeWhile: () => takeWhile4,
  unappend: () => unappend4,
  unfold: () => unfold4,
  union: () => union7,
  unionWith: () => unionWith4,
  unprepend: () => unprepend4,
  unsafeGet: () => unsafeGet5,
  unzip: () => unzip4,
  zip: () => zip4,
  zipWith: () => zipWith34
});
var make624 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var array324 = (item) => make624((self2, that) => {
  if (self2.length !== that.length) {
    return false;
  }
  for (let i2222 = 0; i2222 < self2.length; i2222++) {
    const isEq = item(self2[i2222], that[i2222]);
    if (!isEq) {
      return false;
    }
  }
  return true;
});
var let_324 = (map522) => dual224(3, (self2, name22, f2222) => map522(self2, (a2222) => Object.assign({}, a2222, {
  [name22]: f2222(a2222)
})));
var bindTo324 = (map522) => dual224(2, (self2, name22) => map522(self2, (a2222) => ({
  [name22]: a2222
})));
var bind324 = (map522, flatMap522) => dual224(3, (self2, name22, f2222) => flatMap522(self2, (a2222) => map522(f2222(a2222), (b2222) => Object.assign({}, a2222, {
  [name22]: b2222
}))));
var moduleVersion224 = "3.2.8";
var getCurrentVersion224 = () => moduleVersion224;
var globalStoreId224 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion224()}`);
if (!(globalStoreId224 in globalThis)) {
  globalThis[globalStoreId224] = /* @__PURE__ */ new Map();
}
var globalStore224 = globalThis[globalStoreId224];
var globalValue224 = (id, compute) => {
  if (!globalStore224.has(id)) {
    globalStore224.set(id, compute());
  }
  return globalStore224.get(id);
};
var Predicate_exports224 = {};
__export34(Predicate_exports224, {
  all: () => all324,
  and: () => and224,
  compose: () => compose44,
  eqv: () => eqv224,
  every: () => every224,
  hasProperty: () => hasProperty224,
  implies: () => implies224,
  isBigInt: () => isBigInt224,
  isBoolean: () => isBoolean224,
  isDate: () => isDate224,
  isError: () => isError224,
  isFunction: () => isFunction54,
  isIterable: () => isIterable224,
  isMap: () => isMap224,
  isNever: () => isNever224,
  isNotNull: () => isNotNull224,
  isNotNullable: () => isNotNullable224,
  isNotUndefined: () => isNotUndefined224,
  isNull: () => isNull224,
  isNullable: () => isNullable224,
  isNumber: () => isNumber224,
  isObject: () => isObject224,
  isPromise: () => isPromise224,
  isPromiseLike: () => isPromiseLike224,
  isReadonlyRecord: () => isReadonlyRecord224,
  isRecord: () => isRecord224,
  isSet: () => isSet224,
  isString: () => isString224,
  isSymbol: () => isSymbol224,
  isTagged: () => isTagged224,
  isTruthy: () => isTruthy224,
  isUint8Array: () => isUint8Array224,
  isUndefined: () => isUndefined224,
  isUnknown: () => isUnknown224,
  mapInput: () => mapInput224,
  nand: () => nand224,
  nor: () => nor224,
  not: () => not224,
  or: () => or224,
  product: () => product324,
  productMany: () => productMany324,
  some: () => some424,
  struct: () => struct424,
  tuple: () => tuple324,
  xor: () => xor224
});
var mapInput224 = /* @__PURE__ */ dual224(2, (self2, f2222) => (b2222) => self2(f2222(b2222)));
var isTruthy224 = (input) => !!input;
var isSet224 = (input) => input instanceof Set;
var isMap224 = (input) => input instanceof Map;
var isString224 = (input) => typeof input === "string";
var isNumber224 = (input) => typeof input === "number";
var isBoolean224 = (input) => typeof input === "boolean";
var isBigInt224 = (input) => typeof input === "bigint";
var isSymbol224 = (input) => typeof input === "symbol";
var isFunction54 = isFunction44;
var isUndefined224 = (input) => input === void 0;
var isNotUndefined224 = (input) => input !== void 0;
var isNull224 = (input) => input === null;
var isNotNull224 = (input) => input !== null;
var isNever224 = (_2222) => false;
var isUnknown224 = (_2222) => true;
var isRecordOrArray224 = (input) => typeof input === "object" && input !== null;
var isObject224 = (input) => isRecordOrArray224(input) || isFunction54(input);
var hasProperty224 = /* @__PURE__ */ dual224(2, (self2, property) => isObject224(self2) && property in self2);
var isTagged224 = /* @__PURE__ */ dual224(2, (self2, tag) => hasProperty224(self2, "_tag") && self2["_tag"] === tag);
var isNullable224 = (input) => input === null || input === void 0;
var isNotNullable224 = (input) => input !== null && input !== void 0;
var isError224 = (input) => input instanceof Error;
var isUint8Array224 = (input) => input instanceof Uint8Array;
var isDate224 = (input) => input instanceof Date;
var isIterable224 = (input) => hasProperty224(input, Symbol.iterator);
var isRecord224 = (input) => isRecordOrArray224(input) && !Array.isArray(input);
var isReadonlyRecord224 = isRecord224;
var isPromise224 = (input) => hasProperty224(input, "then") && "catch" in input && isFunction54(input.then) && isFunction54(input.catch);
var isPromiseLike224 = (input) => hasProperty224(input, "then") && isFunction54(input.then);
var compose44 = /* @__PURE__ */ dual224(2, (ab, bc) => (a2222) => ab(a2222) && bc(a2222));
var product324 = (self2, that) => ([a2222, b2222]) => self2(a2222) && that(b2222);
var all324 = (collection) => {
  return (as422) => {
    let collectionIndex = 0;
    for (const p2222 of collection) {
      if (collectionIndex >= as422.length) {
        break;
      }
      if (p2222(as422[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany324 = (self2, collection) => {
  const rest = all324(collection);
  return ([head222, ...tail222]) => self2(head222) === false ? false : rest(tail222);
};
var tuple324 = (...elements) => all324(elements);
var struct424 = (fields) => {
  const keys422 = Object.keys(fields);
  return (a2222) => {
    for (const key of keys422) {
      if (!fields[key](a2222[key])) {
        return false;
      }
    }
    return true;
  };
};
var not224 = (self2) => (a2222) => !self2(a2222);
var or224 = /* @__PURE__ */ dual224(2, (self2, that) => (a2222) => self2(a2222) || that(a2222));
var and224 = /* @__PURE__ */ dual224(2, (self2, that) => (a2222) => self2(a2222) && that(a2222));
var xor224 = /* @__PURE__ */ dual224(2, (self2, that) => (a2222) => self2(a2222) !== that(a2222));
var eqv224 = /* @__PURE__ */ dual224(2, (self2, that) => (a2222) => self2(a2222) === that(a2222));
var implies224 = /* @__PURE__ */ dual224(2, (self2, that) => (a2222) => self2(a2222) ? that(a2222) : true);
var nor224 = /* @__PURE__ */ dual224(2, (self2, that) => (a2222) => !(self2(a2222) || that(a2222)));
var nand224 = /* @__PURE__ */ dual224(2, (self2, that) => (a2222) => !(self2(a2222) && that(a2222)));
var every224 = (collection) => (a2222) => {
  for (const p2222 of collection) {
    if (!p2222(a2222)) {
      return false;
    }
  }
  return true;
};
var some424 = (collection) => (a2222) => {
  for (const p2222 of collection) {
    if (p2222(a2222)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage224 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId224 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind224 = (u2222) => isObject224(u2222) && GenKindTypeId224 in u2222;
var GenKindImpl224 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity224;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId224] = GenKindTypeId224;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen324(this);
  }
};
var SingleShotGen324 = class _SingleShotGen54 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a2222) {
    return this.called ? {
      value: a2222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a2222) {
    return {
      value: a2222,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e2222) {
    throw e2222;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen54(this.self);
  }
};
var adapter324 = () => function() {
  let x2222 = arguments[0];
  for (let i2222 = 1; i2222 < arguments.length; i2222++) {
    x2222 = arguments[i2222](x2222);
  }
  return new GenKindImpl224(x2222);
};
var defaultIncHi224 = 335903614;
var defaultIncLo224 = 4150755663;
var MUL_HI224 = 1481765933 >>> 0;
var MUL_LO224 = 1284865837 >>> 0;
var BIT_53224 = 9007199254740992;
var BIT_27224 = 134217728;
var PCGRandom224 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable224(seedLo) && isNullable224(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable224(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable224(incLo) && isNullable224(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo224;
      incHi = this._state ? this._state[2] : defaultIncHi224;
    } else if (isNullable224(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add64224(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max34) {
    if (!max34) {
      return this._next();
    }
    max34 = max34 >>> 0;
    if ((max34 & max34 - 1) === 0) {
      return this._next() & max34 - 1;
    }
    let num = 0;
    const skew = (-max34 >>> 0) % max34 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max34;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_27224 + lo) / BIT_53224;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul64224(this._state, oldHi, oldLo, MUL_HI224, MUL_LO224);
    add64224(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul64224(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add64224(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId224 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap224 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId224]() {
    return this.#value;
  }
};
function yieldWrapGet224(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId224 in self2) {
    return self2[YieldWrapTypeId224]();
  }
  throw new Error(getBugErrorMessage224("yieldWrapGet"));
}
var structuralRegionState224 = /* @__PURE__ */ globalValue224("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache224 = /* @__PURE__ */ globalValue224(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr224 = /* @__PURE__ */ globalValue224(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom224());
var symbol324 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash224 = (self2) => {
  if (structuralRegionState224.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number224(self2);
    case "bigint":
      return string224(self2.toString(10));
    case "boolean":
      return string224(String(self2));
    case "symbol":
      return string224(String(self2));
    case "string":
      return string224(self2);
    case "undefined":
      return string224("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string224("null");
      } else if (self2 instanceof Date) {
        return hash224(self2.toISOString());
      } else if (isHash224(self2)) {
        return self2[symbol324]();
      } else {
        return random224(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random224 = (self2) => {
  if (!randomHashCache224.has(self2)) {
    randomHashCache224.set(self2, number224(pcgr224.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache224.get(self2);
};
var combine324 = (b2222) => (self2) => self2 * 53 ^ b2222;
var optimize224 = (n2222) => n2222 & 3221225471 | n2222 >>> 1 & 1073741824;
var isHash224 = (u2222) => hasProperty224(u2222, symbol324);
var number224 = (n2222) => {
  if (n2222 !== n2222 || n2222 === Infinity) {
    return 0;
  }
  let h2222 = n2222 | 0;
  if (h2222 !== n2222) {
    h2222 ^= n2222 * 4294967295;
  }
  while (n2222 > 4294967295) {
    h2222 ^= n2222 /= 4294967295;
  }
  return optimize224(n2222);
};
var string224 = (str) => {
  let h2222 = 5381, i2222 = str.length;
  while (i2222) {
    h2222 = h2222 * 33 ^ str.charCodeAt(--i2222);
  }
  return optimize224(h2222);
};
var cached224 = function() {
  if (arguments.length === 1) {
    const self3 = arguments[0];
    return function(hash522) {
      Object.defineProperty(self3, symbol324, {
        value() {
          return hash522;
        },
        enumerable: false
      });
      return hash522;
    };
  }
  const self2 = arguments[0];
  const hash422 = arguments[1];
  Object.defineProperty(self2, symbol324, {
    value() {
      return hash422;
    },
    enumerable: false
  });
  return hash422;
};
var symbol44 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals224() {
  if (arguments.length === 1) {
    return (self2) => compareBoth224(self2, arguments[0]);
  }
  return compareBoth224(arguments[0], arguments[1]);
}
function compareBoth224(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual224(self2) && isEqual224(that)) {
        if (hash224(self2) === hash224(that) && self2[symbol44](that)) {
          return true;
        } else {
          return structuralRegionState224.enabled && structuralRegionState224.tester ? structuralRegionState224.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState224.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v2222, i2222) => compareBoth224(v2222, that[i2222]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth224(self2[key], that[key]))) {
              return structuralRegionState224.tester ? structuralRegionState224.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState224.tester ? structuralRegionState224.tester(self2, that) : false;
    }
  }
  return structuralRegionState224.enabled && structuralRegionState224.tester ? structuralRegionState224.tester(self2, that) : false;
}
var isEqual224 = (u2222) => hasProperty224(u2222, symbol44);
var equivalence224 = () => equals224;
var NodeInspectSymbol224 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON224 = (x2222) => {
  if (hasProperty224(x2222, "toJSON") && isFunction54(x2222["toJSON"]) && x2222["toJSON"].length === 0) {
    return x2222.toJSON();
  } else if (Array.isArray(x2222)) {
    return x2222.map(toJSON224);
  }
  return x2222;
};
var format224 = (x2222) => JSON.stringify(x2222, null, 2);
var pipeArguments224 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i2222 = 0, len = args.length; i2222 < len; i2222++) {
        ret = args[i2222](ret);
      }
      return ret;
    }
  }
};
var EffectTypeId324 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId224 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId224 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId224 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance224 = {
  /* c8 ignore next */
  _R: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _A: (_2222) => _2222,
  _V: /* @__PURE__ */ getCurrentVersion224()
};
var sinkVariance224 = {
  /* c8 ignore next */
  _A: (_2222) => _2222,
  /* c8 ignore next */
  _In: (_2222) => _2222,
  /* c8 ignore next */
  _L: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _R: (_2222) => _2222
};
var channelVariance224 = {
  /* c8 ignore next */
  _Env: (_2222) => _2222,
  /* c8 ignore next */
  _InErr: (_2222) => _2222,
  /* c8 ignore next */
  _InElem: (_2222) => _2222,
  /* c8 ignore next */
  _InDone: (_2222) => _2222,
  /* c8 ignore next */
  _OutErr: (_2222) => _2222,
  /* c8 ignore next */
  _OutElem: (_2222) => _2222,
  /* c8 ignore next */
  _OutDone: (_2222) => _2222
};
var EffectPrototype224 = {
  [EffectTypeId324]: effectVariance224,
  [StreamTypeId224]: effectVariance224,
  [SinkTypeId224]: sinkVariance224,
  [ChannelTypeId224]: channelVariance224,
  [symbol44](that) {
    return this === that;
  },
  [symbol324]() {
    return cached224(this, random224(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen324(new YieldWrap224(this));
  },
  pipe() {
    return pipeArguments224(this, arguments);
  }
};
var TypeId624 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto324 = {
  ...EffectPrototype224,
  [TypeId624]: {
    _A: (_2222) => _2222
  },
  [NodeInspectSymbol224]() {
    return this.toJSON();
  },
  toString() {
    return format224(this.toJSON());
  }
};
var SomeProto224 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto324), {
  _tag: "Some",
  _op: "Some",
  [symbol44](that) {
    return isOption324(that) && isSome324(that) && equals224(this.value, that.value);
  },
  [symbol324]() {
    return cached224(this, combine324(hash224(this._tag))(hash224(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON224(this.value)
    };
  }
});
var NoneHash224 = /* @__PURE__ */ hash224("None");
var NoneProto224 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto324), {
  _tag: "None",
  _op: "None",
  [symbol44](that) {
    return isOption324(that) && isNone324(that);
  },
  [symbol324]() {
    return NoneHash224;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption324 = (input) => hasProperty224(input, TypeId624);
var isNone324 = (fa) => fa._tag === "None";
var isSome324 = (fa) => fa._tag === "Some";
var none324 = /* @__PURE__ */ Object.create(NoneProto224);
var some54 = (value) => {
  const a2222 = Object.create(SomeProto224);
  a2222.value = value;
  return a2222;
};
var TypeId74 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto44 = {
  ...EffectPrototype224,
  [TypeId74]: {
    _R: (_2222) => _2222
  },
  [NodeInspectSymbol224]() {
    return this.toJSON();
  },
  toString() {
    return format224(this.toJSON());
  }
};
var RightProto224 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto44), {
  _tag: "Right",
  _op: "Right",
  [symbol44](that) {
    return isEither224(that) && isRight224(that) && equals224(this.right, that.right);
  },
  [symbol324]() {
    return combine324(hash224(this._tag))(hash224(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON224(this.right)
    };
  }
});
var LeftProto224 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto44), {
  _tag: "Left",
  _op: "Left",
  [symbol44](that) {
    return isEither224(that) && isLeft224(that) && equals224(this.left, that.left);
  },
  [symbol324]() {
    return combine324(hash224(this._tag))(hash224(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON224(this.left)
    };
  }
});
var isEither224 = (input) => hasProperty224(input, TypeId74);
var isLeft224 = (ma) => ma._tag === "Left";
var isRight224 = (ma) => ma._tag === "Right";
var left324 = (left522) => {
  const a2222 = Object.create(LeftProto224);
  a2222.left = left522;
  return a2222;
};
var right324 = (right522) => {
  const a2222 = Object.create(RightProto224);
  a2222.right = right522;
  return a2222;
};
var getLeft324 = (self2) => isRight224(self2) ? none324 : some54(self2.left);
var getRight324 = (self2) => isLeft224(self2) ? none324 : some54(self2.right);
var isLeft34 = isLeft224;
var isRight34 = isRight224;
var isNonEmptyArray5 = (self2) => self2.length > 0;
var Option_exports224 = {};
__export34(Option_exports224, {
  Do: () => Do224,
  TypeId: () => TypeId84,
  all: () => all44,
  andThen: () => andThen224,
  ap: () => ap224,
  as: () => as224,
  asVoid: () => asVoid224,
  bind: () => bind44,
  bindTo: () => bindTo44,
  composeK: () => composeK224,
  contains: () => contains224,
  containsWith: () => containsWith224,
  exists: () => exists224,
  filter: () => filter224,
  filterMap: () => filterMap224,
  firstSomeOf: () => firstSomeOf224,
  flatMap: () => flatMap224,
  flatMapNullable: () => flatMapNullable224,
  flatten: () => flatten224,
  fromIterable: () => fromIterable324,
  fromNullable: () => fromNullable224,
  gen: () => gen224,
  getEquivalence: () => getEquivalence324,
  getLeft: () => getLeft44,
  getOrElse: () => getOrElse224,
  getOrNull: () => getOrNull224,
  getOrThrow: () => getOrThrow224,
  getOrThrowWith: () => getOrThrowWith224,
  getOrUndefined: () => getOrUndefined224,
  getOrder: () => getOrder224,
  getRight: () => getRight44,
  isNone: () => isNone44,
  isOption: () => isOption44,
  isSome: () => isSome44,
  let: () => let_44,
  lift2: () => lift2224,
  liftNullable: () => liftNullable224,
  liftPredicate: () => liftPredicate224,
  liftThrowable: () => liftThrowable224,
  map: () => map224,
  match: () => match323,
  none: () => none44,
  orElse: () => orElse224,
  orElseEither: () => orElseEither224,
  orElseSome: () => orElseSome224,
  partitionMap: () => partitionMap224,
  product: () => product44,
  productMany: () => productMany44,
  reduceCompact: () => reduceCompact224,
  some: () => some64,
  tap: () => tap224,
  toArray: () => toArray224,
  toRefinement: () => toRefinement224,
  void: () => void_224,
  zipLeft: () => zipLeft224,
  zipRight: () => zipRight224,
  zipWith: () => zipWith224
});
var make84 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var number34 = /* @__PURE__ */ make84((self2, that) => self2 < that ? -1 : 1);
var combineMany4 = /* @__PURE__ */ dual224(2, (self2, collection) => make84((a1, a2222) => {
  let out = self2(a1, a2222);
  if (out !== 0) {
    return out;
  }
  for (const O2222 of collection) {
    out = O2222(a1, a2222);
    if (out !== 0) {
      return out;
    }
  }
  return out;
}));
var empty824 = () => make84(() => 0);
var combineAll4 = (collection) => combineMany4(empty824(), collection);
var mapInput34 = /* @__PURE__ */ dual224(2, (self2, f2222) => make84((b1, b2222) => self2(f2222(b1), f2222(b2222))));
var array44 = (O2222) => make84((self2, that) => {
  const aLen = self2.length;
  const bLen = that.length;
  const len = Math.min(aLen, bLen);
  for (let i2222 = 0; i2222 < len; i2222++) {
    const o2222 = O2222(self2[i2222], that[i2222]);
    if (o2222 !== 0) {
      return o2222;
    }
  }
  return number34(aLen, bLen);
});
var min5 = (O2222) => dual224(2, (self2, that) => self2 === that || O2222(self2, that) < 1 ? self2 : that);
var max5 = (O2222) => dual224(2, (self2, that) => self2 === that || O2222(self2, that) > -1 ? self2 : that);
var TypeId84 = /* @__PURE__ */ Symbol.for("effect/Option");
var none44 = () => none324;
var some64 = some54;
var isOption44 = isOption324;
var isNone44 = isNone324;
var isSome44 = isSome324;
var match323 = /* @__PURE__ */ dual224(2, (self2, {
  onNone,
  onSome
}) => isNone44(self2) ? onNone() : onSome(self2.value));
var toRefinement224 = (f2222) => (a2222) => isSome44(f2222(a2222));
var fromIterable324 = (collection) => {
  for (const a2222 of collection) {
    return some64(a2222);
  }
  return none44();
};
var getRight44 = getRight324;
var getLeft44 = getLeft324;
var getOrElse224 = /* @__PURE__ */ dual224(2, (self2, onNone) => isNone44(self2) ? onNone() : self2.value);
var orElse224 = /* @__PURE__ */ dual224(2, (self2, that) => isNone44(self2) ? that() : self2);
var orElseSome224 = /* @__PURE__ */ dual224(2, (self2, onNone) => isNone44(self2) ? some64(onNone()) : self2);
var orElseEither224 = /* @__PURE__ */ dual224(2, (self2, that) => isNone44(self2) ? map224(that(), right324) : map224(self2, left324));
var firstSomeOf224 = (collection) => {
  let out = none44();
  for (out of collection) {
    if (isSome44(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable224 = (nullableValue) => nullableValue == null ? none44() : some64(nullableValue);
var liftNullable224 = (f2222) => (...a2222) => fromNullable224(f2222(...a2222));
var getOrNull224 = /* @__PURE__ */ getOrElse224(constNull224);
var getOrUndefined224 = /* @__PURE__ */ getOrElse224(constUndefined224);
var liftThrowable224 = (f2222) => (...a2222) => {
  try {
    return some64(f2222(...a2222));
  } catch (e2222) {
    return none44();
  }
};
var getOrThrowWith224 = /* @__PURE__ */ dual224(2, (self2, onNone) => {
  if (isSome44(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow224 = /* @__PURE__ */ getOrThrowWith224(() => new Error("getOrThrow called on a None"));
var map224 = /* @__PURE__ */ dual224(2, (self2, f2222) => isNone44(self2) ? none44() : some64(f2222(self2.value)));
var as224 = /* @__PURE__ */ dual224(2, (self2, b2222) => map224(self2, () => b2222));
var asVoid224 = /* @__PURE__ */ as224(void 0);
var void_224 = /* @__PURE__ */ some64(void 0);
var flatMap224 = /* @__PURE__ */ dual224(2, (self2, f2222) => isNone44(self2) ? none44() : f2222(self2.value));
var andThen224 = /* @__PURE__ */ dual224(2, (self2, f2222) => flatMap224(self2, (a2222) => {
  const b2222 = isFunction44(f2222) ? f2222(a2222) : f2222;
  return isOption44(b2222) ? b2222 : some64(b2222);
}));
var flatMapNullable224 = /* @__PURE__ */ dual224(2, (self2, f2222) => isNone44(self2) ? none44() : fromNullable224(f2222(self2.value)));
var flatten224 = /* @__PURE__ */ flatMap224(identity224);
var zipRight224 = /* @__PURE__ */ dual224(2, (self2, that) => flatMap224(self2, () => that));
var composeK224 = /* @__PURE__ */ dual224(2, (afb, bfc) => (a2222) => flatMap224(afb(a2222), bfc));
var zipLeft224 = /* @__PURE__ */ dual224(2, (self2, that) => tap224(self2, () => that));
var tap224 = /* @__PURE__ */ dual224(2, (self2, f2222) => flatMap224(self2, (a2222) => map224(f2222(a2222), () => a2222)));
var product44 = (self2, that) => isSome44(self2) && isSome44(that) ? some64([self2.value, that.value]) : none44();
var productMany44 = (self2, collection) => {
  if (isNone44(self2)) {
    return none44();
  }
  const out = [self2.value];
  for (const o2222 of collection) {
    if (isNone44(o2222)) {
      return none44();
    }
    out.push(o2222.value);
  }
  return some64(out);
};
var all44 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o2222 of input) {
      if (isNone44(o2222)) {
        return none44();
      }
      out2.push(o2222.value);
    }
    return some64(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o2222 = input[key];
    if (isNone44(o2222)) {
      return none44();
    }
    out[key] = o2222.value;
  }
  return some64(out);
};
var zipWith224 = /* @__PURE__ */ dual224(3, (self2, that, f2222) => map224(product44(self2, that), ([a2222, b2222]) => f2222(a2222, b2222)));
var ap224 = /* @__PURE__ */ dual224(2, (self2, that) => zipWith224(self2, that, (f2222, a2222) => f2222(a2222)));
var reduceCompact224 = /* @__PURE__ */ dual224(3, (self2, b2222, f2222) => {
  let out = b2222;
  for (const oa of self2) {
    if (isSome44(oa)) {
      out = f2222(out, oa.value);
    }
  }
  return out;
});
var toArray224 = (self2) => isNone44(self2) ? [] : [self2.value];
var partitionMap224 = /* @__PURE__ */ dual224(2, (self2, f2222) => {
  if (isNone44(self2)) {
    return [none44(), none44()];
  }
  const e2222 = f2222(self2.value);
  return isLeft224(e2222) ? [some64(e2222.left), none44()] : [none44(), some64(e2222.right)];
});
var filterMap224 = /* @__PURE__ */ dual224(2, (self2, f2222) => isNone44(self2) ? none44() : f2222(self2.value));
var filter224 = /* @__PURE__ */ dual224(2, (self2, predicate) => filterMap224(self2, (b2222) => predicate(b2222) ? some54(b2222) : none324));
var getEquivalence324 = (isEquivalent) => make624((x2222, y2222) => x2222 === y2222 || (isNone44(x2222) ? isNone44(y2222) : isNone44(y2222) ? false : isEquivalent(x2222.value, y2222.value)));
var getOrder224 = (O2222) => make84((self2, that) => isSome44(self2) ? isSome44(that) ? O2222(self2.value, that.value) : 1 : -1);
var lift2224 = (f2222) => dual224(2, (self2, that) => zipWith224(self2, that, f2222));
var liftPredicate224 = (predicate) => (b2222) => predicate(b2222) ? some64(b2222) : none44();
var containsWith224 = (isEquivalent) => dual224(2, (self2, a2222) => isNone44(self2) ? false : isEquivalent(self2.value, a2222));
var _equivalence324 = /* @__PURE__ */ equivalence224();
var contains224 = /* @__PURE__ */ containsWith224(_equivalence324);
var exists224 = /* @__PURE__ */ dual224(2, (self2, refinement) => isNone44(self2) ? false : refinement(self2.value));
var bindTo44 = /* @__PURE__ */ bindTo324(map224);
var let_44 = /* @__PURE__ */ let_324(map224);
var bind44 = /* @__PURE__ */ bind324(map224, flatMap224);
var Do224 = /* @__PURE__ */ some64({});
var adapter44 = /* @__PURE__ */ adapter324();
var gen224 = (f2222) => {
  const iterator = f2222(adapter44);
  let state = iterator.next();
  if (state.done) {
    return some64(state.value);
  } else {
    let current = state.value;
    if (isGenKind224(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet224(current);
    }
    if (isNone44(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind224(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet224(current);
        }
        if (isNone44(current)) {
          return current;
        }
      }
    }
    return some64(state.value);
  }
};
var make94 = (...elements) => elements;
var findFirst5 = /* @__PURE__ */ dual224(2, (self2, f2222) => {
  let i2222 = 0;
  for (const a2222 of self2) {
    const o2222 = f2222(a2222, i2222);
    if (isBoolean224(o2222)) {
      if (o2222) {
        return some64(a2222);
      }
    } else {
      if (isSome44(o2222)) {
        return o2222;
      }
    }
    i2222++;
  }
  return none44();
});
var collect5 = /* @__PURE__ */ dual224(2, (self2, f2222) => {
  const out = [];
  for (const key of keys224(self2)) {
    out.push(f2222(key, self2[key]));
  }
  return out;
});
var toEntries5 = /* @__PURE__ */ collect5((key, value) => [key, value]);
var keys224 = (self2) => Object.keys(self2);
var make104 = (...elements) => elements;
var allocate4 = (n2222) => new Array(n2222);
var makeBy4 = (n2222, f2222) => {
  const max34 = Math.max(1, Math.floor(n2222));
  const out = new Array(max34);
  for (let i2222 = 0; i2222 < max34; i2222++) {
    out[i2222] = f2222(i2222);
  }
  return out;
};
var range4 = (start, end) => start <= end ? makeBy4(end - start + 1, (i2222) => start + i2222) : [start];
var replicate4 = /* @__PURE__ */ dual224(2, (a2222, n2222) => makeBy4(n2222, () => a2222));
var fromIterable44 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var fromRecord4 = toEntries5;
var fromOption24 = toArray224;
var match44 = /* @__PURE__ */ dual224(2, (self2, {
  onEmpty,
  onNonEmpty
}) => isNonEmptyReadonlyArray4(self2) ? onNonEmpty(self2) : onEmpty());
var matchLeft4 = /* @__PURE__ */ dual224(2, (self2, {
  onEmpty,
  onNonEmpty
}) => isNonEmptyReadonlyArray4(self2) ? onNonEmpty(headNonEmpty224(self2), tailNonEmpty224(self2)) : onEmpty());
var matchRight4 = /* @__PURE__ */ dual224(2, (self2, {
  onEmpty,
  onNonEmpty
}) => isNonEmptyReadonlyArray4(self2) ? onNonEmpty(initNonEmpty4(self2), lastNonEmpty4(self2)) : onEmpty());
var prepend224 = /* @__PURE__ */ dual224(2, (self2, head222) => [head222, ...self2]);
var prependAll4 = /* @__PURE__ */ dual224(2, (self2, that) => fromIterable44(that).concat(fromIterable44(self2)));
var append5 = /* @__PURE__ */ dual224(2, (self2, last24) => [...self2, last24]);
var appendAll224 = /* @__PURE__ */ dual224(2, (self2, that) => fromIterable44(self2).concat(fromIterable44(that)));
var scan4 = /* @__PURE__ */ dual224(3, (self2, b2222, f2222) => {
  const out = [b2222];
  let i2222 = 0;
  for (const a2222 of self2) {
    out[i2222 + 1] = f2222(out[i2222], a2222);
    i2222++;
  }
  return out;
});
var scanRight4 = /* @__PURE__ */ dual224(3, (self2, b2222, f2222) => {
  const input = fromIterable44(self2);
  const out = new Array(input.length + 1);
  out[input.length] = b2222;
  for (let i2222 = input.length - 1; i2222 >= 0; i2222--) {
    out[i2222] = f2222(out[i2222 + 1], input[i2222]);
  }
  return out;
});
var isArray4 = Array.isArray;
var isEmptyArray4 = (self2) => self2.length === 0;
var isEmptyReadonlyArray4 = isEmptyArray4;
var isNonEmptyArray24 = isNonEmptyArray5;
var isNonEmptyReadonlyArray4 = isNonEmptyArray5;
var length5 = (self2) => self2.length;
var isOutOfBound4 = (i2222, as422) => i2222 < 0 || i2222 >= as422.length;
var clamp4 = (i2222, as422) => Math.floor(Math.min(Math.max(0, i2222), as422.length));
var get9 = /* @__PURE__ */ dual224(2, (self2, index) => {
  const i2222 = Math.floor(index);
  return isOutOfBound4(i2222, self2) ? none44() : some64(self2[i2222]);
});
var unsafeGet5 = /* @__PURE__ */ dual224(2, (self2, index) => {
  const i2222 = Math.floor(index);
  if (isOutOfBound4(i2222, self2)) {
    throw new Error(`Index ${i2222} out of bounds`);
  }
  return self2[i2222];
});
var unprepend4 = (self2) => [headNonEmpty224(self2), tailNonEmpty224(self2)];
var unappend4 = (self2) => [initNonEmpty4(self2), lastNonEmpty4(self2)];
var head5 = /* @__PURE__ */ get9(0);
var headNonEmpty224 = /* @__PURE__ */ unsafeGet5(0);
var last4 = (self2) => isNonEmptyReadonlyArray4(self2) ? some64(lastNonEmpty4(self2)) : none44();
var lastNonEmpty4 = (self2) => self2[self2.length - 1];
var tail5 = (self2) => {
  const input = fromIterable44(self2);
  return isNonEmptyReadonlyArray4(input) ? some64(tailNonEmpty224(input)) : none44();
};
var tailNonEmpty224 = (self2) => self2.slice(1);
var init4 = (self2) => {
  const input = fromIterable44(self2);
  return isNonEmptyReadonlyArray4(input) ? some64(initNonEmpty4(input)) : none44();
};
var initNonEmpty4 = (self2) => self2.slice(0, -1);
var take4 = /* @__PURE__ */ dual224(2, (self2, n2222) => {
  const input = fromIterable44(self2);
  return input.slice(0, clamp4(n2222, input));
});
var takeRight4 = /* @__PURE__ */ dual224(2, (self2, n2222) => {
  const input = fromIterable44(self2);
  const i2222 = clamp4(n2222, input);
  return i2222 === 0 ? [] : input.slice(-i2222);
});
var takeWhile4 = /* @__PURE__ */ dual224(2, (self2, predicate) => {
  let i2222 = 0;
  const out = [];
  for (const a2222 of self2) {
    if (!predicate(a2222, i2222)) {
      break;
    }
    out.push(a2222);
    i2222++;
  }
  return out;
});
var spanIndex4 = (self2, predicate) => {
  let i2222 = 0;
  for (const a2222 of self2) {
    if (!predicate(a2222, i2222)) {
      break;
    }
    i2222++;
  }
  return i2222;
};
var span4 = /* @__PURE__ */ dual224(2, (self2, predicate) => splitAt4(self2, spanIndex4(self2, predicate)));
var drop224 = /* @__PURE__ */ dual224(2, (self2, n2222) => {
  const input = fromIterable44(self2);
  return input.slice(clamp4(n2222, input), input.length);
});
var dropRight4 = /* @__PURE__ */ dual224(2, (self2, n2222) => {
  const input = fromIterable44(self2);
  return input.slice(0, input.length - clamp4(n2222, input));
});
var dropWhile4 = /* @__PURE__ */ dual224(2, (self2, predicate) => fromIterable44(self2).slice(spanIndex4(self2, predicate)));
var findFirstIndex4 = /* @__PURE__ */ dual224(2, (self2, predicate) => {
  let i2222 = 0;
  for (const a2222 of self2) {
    if (predicate(a2222, i2222)) {
      return some64(i2222);
    }
    i2222++;
  }
  return none44();
});
var findLastIndex4 = /* @__PURE__ */ dual224(2, (self2, predicate) => {
  const input = fromIterable44(self2);
  for (let i2222 = input.length - 1; i2222 >= 0; i2222--) {
    if (predicate(input[i2222], i2222)) {
      return some64(i2222);
    }
  }
  return none44();
});
var findFirst24 = findFirst5;
var findLast4 = /* @__PURE__ */ dual224(2, (self2, f2222) => {
  const input = fromIterable44(self2);
  for (let i2222 = input.length - 1; i2222 >= 0; i2222--) {
    const a2222 = input[i2222];
    const o2222 = f2222(a2222, i2222);
    if (isBoolean224(o2222)) {
      if (o2222) {
        return some64(a2222);
      }
    } else {
      if (isSome44(o2222)) {
        return o2222;
      }
    }
  }
  return none44();
});
var insertAt4 = /* @__PURE__ */ dual224(3, (self2, i2222, b2222) => {
  const out = Array.from(self2);
  if (i2222 < 0 || i2222 > out.length) {
    return none44();
  }
  out.splice(i2222, 0, b2222);
  return some64(out);
});
var replace24 = /* @__PURE__ */ dual224(3, (self2, i2222, b2222) => modify5(self2, i2222, () => b2222));
var replaceOption5 = /* @__PURE__ */ dual224(3, (self2, i2222, b2222) => modifyOption5(self2, i2222, () => b2222));
var modify5 = /* @__PURE__ */ dual224(3, (self2, i2222, f2222) => getOrElse224(modifyOption5(self2, i2222, f2222), () => Array.from(self2)));
var modifyOption5 = /* @__PURE__ */ dual224(3, (self2, i2222, f2222) => {
  const out = Array.from(self2);
  if (isOutOfBound4(i2222, out)) {
    return none44();
  }
  const next = f2222(out[i2222]);
  out[i2222] = next;
  return some64(out);
});
var remove6 = /* @__PURE__ */ dual224(2, (self2, i2222) => {
  const out = Array.from(self2);
  if (isOutOfBound4(i2222, out)) {
    return out;
  }
  out.splice(i2222, 1);
  return out;
});
var reverse324 = (self2) => Array.from(self2).reverse();
var sort4 = /* @__PURE__ */ dual224(2, (self2, O2222) => {
  const out = Array.from(self2);
  out.sort(O2222);
  return out;
});
var sortWith4 = /* @__PURE__ */ dual224(3, (self2, f2222, order) => sort4(self2, mapInput34(order, f2222)));
var sortBy4 = (...orders) => {
  const sortByAll = sort4(combineAll4(orders));
  return (self2) => {
    const input = fromIterable44(self2);
    if (isNonEmptyReadonlyArray4(input)) {
      return sortByAll(input);
    }
    return [];
  };
};
var zip4 = /* @__PURE__ */ dual224(2, (self2, that) => zipWith34(self2, that, make94));
var zipWith34 = /* @__PURE__ */ dual224(3, (self2, that, f2222) => {
  const as422 = fromIterable44(self2);
  const bs = fromIterable44(that);
  if (isNonEmptyReadonlyArray4(as422) && isNonEmptyReadonlyArray4(bs)) {
    const out = [f2222(headNonEmpty224(as422), headNonEmpty224(bs))];
    const len = Math.min(as422.length, bs.length);
    for (let i2222 = 1; i2222 < len; i2222++) {
      out[i2222] = f2222(as422[i2222], bs[i2222]);
    }
    return out;
  }
  return [];
});
var unzip4 = (self2) => {
  const input = fromIterable44(self2);
  if (isNonEmptyReadonlyArray4(input)) {
    const fa = [input[0][0]];
    const fb = [input[0][1]];
    for (let i2222 = 1; i2222 < input.length; i2222++) {
      fa[i2222] = input[i2222][0];
      fb[i2222] = input[i2222][1];
    }
    return [fa, fb];
  }
  return [[], []];
};
var intersperse4 = /* @__PURE__ */ dual224(2, (self2, middle) => {
  const input = fromIterable44(self2);
  if (isNonEmptyReadonlyArray4(input)) {
    const out = [headNonEmpty224(input)];
    const tail222 = tailNonEmpty224(input);
    for (let i2222 = 0; i2222 < tail222.length; i2222++) {
      if (i2222 < tail222.length) {
        out.push(middle);
      }
      out.push(tail222[i2222]);
    }
    return out;
  }
  return [];
});
var modifyNonEmptyHead4 = /* @__PURE__ */ dual224(2, (self2, f2222) => [f2222(headNonEmpty224(self2)), ...tailNonEmpty224(self2)]);
var setNonEmptyHead4 = /* @__PURE__ */ dual224(2, (self2, b2222) => modifyNonEmptyHead4(self2, () => b2222));
var modifyNonEmptyLast4 = /* @__PURE__ */ dual224(2, (self2, f2222) => append5(initNonEmpty4(self2), f2222(lastNonEmpty4(self2))));
var setNonEmptyLast4 = /* @__PURE__ */ dual224(2, (self2, b2222) => modifyNonEmptyLast4(self2, () => b2222));
var rotate4 = /* @__PURE__ */ dual224(2, (self2, n2222) => {
  const input = fromIterable44(self2);
  if (isNonEmptyReadonlyArray4(input)) {
    const len = input.length;
    const m2222 = Math.round(n2222) % len;
    if (isOutOfBound4(Math.abs(m2222), input) || m2222 === 0) {
      return copy224(input);
    }
    if (m2222 < 0) {
      const [f2222, s2222] = splitNonEmptyAt4(input, -m2222);
      return appendAll224(s2222, f2222);
    } else {
      return rotate4(self2, m2222 - len);
    }
  }
  return [];
});
var containsWith34 = (isEquivalent) => dual224(2, (self2, a2222) => {
  for (const i2222 of self2) {
    if (isEquivalent(a2222, i2222)) {
      return true;
    }
  }
  return false;
});
var _equivalence44 = /* @__PURE__ */ equivalence224();
var contains34 = /* @__PURE__ */ containsWith34(_equivalence44);
var chop4 = /* @__PURE__ */ dual224(2, (self2, f2222) => {
  const input = fromIterable44(self2);
  if (isNonEmptyReadonlyArray4(input)) {
    const [b2222, rest] = f2222(input);
    const out = [b2222];
    let next = rest;
    while (isNonEmptyArray5(next)) {
      const [b322, rest2] = f2222(next);
      out.push(b322);
      next = rest2;
    }
    return out;
  }
  return [];
});
var splitAt4 = /* @__PURE__ */ dual224(2, (self2, n2222) => {
  const input = Array.from(self2);
  const _n = Math.floor(n2222);
  if (isNonEmptyReadonlyArray4(input)) {
    if (_n >= 1) {
      return splitNonEmptyAt4(input, _n);
    }
    return [[], input];
  }
  return [input, []];
});
var splitNonEmptyAt4 = /* @__PURE__ */ dual224(2, (self2, n2222) => {
  const _n = Math.max(1, Math.floor(n2222));
  return _n >= self2.length ? [copy224(self2), []] : [prepend224(self2.slice(1, _n), headNonEmpty224(self2)), self2.slice(_n)];
});
var split4 = /* @__PURE__ */ dual224(2, (self2, n2222) => {
  const input = fromIterable44(self2);
  return chunksOf4(input, Math.ceil(input.length / Math.floor(n2222)));
});
var splitWhere4 = /* @__PURE__ */ dual224(2, (self2, predicate) => span4(self2, (a2222, i2222) => !predicate(a2222, i2222)));
var copy224 = (self2) => self2.slice();
var chunksOf4 = /* @__PURE__ */ dual224(2, (self2, n2222) => {
  const input = fromIterable44(self2);
  if (isNonEmptyReadonlyArray4(input)) {
    return chop4(input, splitNonEmptyAt4(n2222));
  }
  return [];
});
var groupWith4 = /* @__PURE__ */ dual224(2, (self2, isEquivalent) => chop4(self2, (as422) => {
  const h2222 = headNonEmpty224(as422);
  const out = [h2222];
  let i2222 = 1;
  for (; i2222 < as422.length; i2222++) {
    const a2222 = as422[i2222];
    if (isEquivalent(a2222, h2222)) {
      out.push(a2222);
    } else {
      break;
    }
  }
  return [out, as422.slice(i2222)];
}));
var group4 = /* @__PURE__ */ groupWith4(/* @__PURE__ */ equivalence224());
var groupBy4 = /* @__PURE__ */ dual224(2, (self2, f2222) => {
  const out = {};
  for (const a2222 of self2) {
    const k2222 = f2222(a2222);
    if (Object.prototype.hasOwnProperty.call(out, k2222)) {
      out[k2222].push(a2222);
    } else {
      out[k2222] = [a2222];
    }
  }
  return out;
});
var unionWith4 = /* @__PURE__ */ dual224(3, (self2, that, isEquivalent) => {
  const a2222 = fromIterable44(self2);
  const b2222 = fromIterable44(that);
  if (isNonEmptyReadonlyArray4(a2222)) {
    if (isNonEmptyReadonlyArray4(b2222)) {
      const dedupe24 = dedupeWith4(isEquivalent);
      return dedupe24(appendAll224(a2222, b2222));
    }
    return a2222;
  }
  return b2222;
});
var union7 = /* @__PURE__ */ dual224(2, (self2, that) => unionWith4(self2, that, _equivalence44));
var intersectionWith4 = (isEquivalent) => {
  const has22 = containsWith34(isEquivalent);
  return dual224(2, (self2, that) => fromIterable44(self2).filter((a2222) => has22(that, a2222)));
};
var intersection5 = /* @__PURE__ */ intersectionWith4(_equivalence44);
var differenceWith4 = (isEquivalent) => {
  const has22 = containsWith34(isEquivalent);
  return dual224(2, (self2, that) => fromIterable44(self2).filter((a2222) => !has22(that, a2222)));
};
var difference5 = /* @__PURE__ */ differenceWith4(_equivalence44);
var empty94 = () => [];
var of224 = (a2222) => [a2222];
var map34 = /* @__PURE__ */ dual224(2, (self2, f2222) => self2.map(f2222));
var flatMap34 = /* @__PURE__ */ dual224(2, (self2, f2222) => {
  if (isEmptyReadonlyArray4(self2)) {
    return [];
  }
  const out = [];
  for (let i2222 = 0; i2222 < self2.length; i2222++) {
    const inner = f2222(self2[i2222], i2222);
    for (let j2222 = 0; j2222 < inner.length; j2222++) {
      out.push(inner[j2222]);
    }
  }
  return out;
});
var flatten34 = /* @__PURE__ */ flatMap34(identity224);
var filterMap34 = /* @__PURE__ */ dual224(2, (self2, f2222) => {
  const as422 = fromIterable44(self2);
  const out = [];
  for (let i2222 = 0; i2222 < as422.length; i2222++) {
    const o2222 = f2222(as422[i2222], i2222);
    if (isSome44(o2222)) {
      out.push(o2222.value);
    }
  }
  return out;
});
var filterMapWhile4 = /* @__PURE__ */ dual224(2, (self2, f2222) => {
  let i2222 = 0;
  const out = [];
  for (const a2222 of self2) {
    const b2222 = f2222(a2222, i2222);
    if (isSome44(b2222)) {
      out.push(b2222.value);
    } else {
      break;
    }
    i2222++;
  }
  return out;
});
var partitionMap34 = /* @__PURE__ */ dual224(2, (self2, f2222) => {
  const left522 = [];
  const right522 = [];
  const as422 = fromIterable44(self2);
  for (let i2222 = 0; i2222 < as422.length; i2222++) {
    const e2222 = f2222(as422[i2222], i2222);
    if (isLeft34(e2222)) {
      left522.push(e2222.left);
    } else {
      right522.push(e2222.right);
    }
  }
  return [left522, right522];
});
var getSomes5 = /* @__PURE__ */ filterMap34(identity224);
var getLefts5 = (self2) => {
  const out = [];
  for (const a2222 of self2) {
    if (isLeft34(a2222)) {
      out.push(a2222.left);
    }
  }
  return out;
};
var getRights5 = (self2) => {
  const out = [];
  for (const a2222 of self2) {
    if (isRight34(a2222)) {
      out.push(a2222.right);
    }
  }
  return out;
};
var filter34 = /* @__PURE__ */ dual224(2, (self2, predicate) => {
  const as422 = fromIterable44(self2);
  const out = [];
  for (let i2222 = 0; i2222 < as422.length; i2222++) {
    if (predicate(as422[i2222], i2222)) {
      out.push(as422[i2222]);
    }
  }
  return out;
});
var partition5 = /* @__PURE__ */ dual224(2, (self2, predicate) => {
  const left522 = [];
  const right522 = [];
  const as422 = fromIterable44(self2);
  for (let i2222 = 0; i2222 < as422.length; i2222++) {
    if (predicate(as422[i2222], i2222)) {
      right522.push(as422[i2222]);
    } else {
      left522.push(as422[i2222]);
    }
  }
  return [left522, right522];
});
var separate5 = /* @__PURE__ */ partitionMap34(identity224);
var reduce324 = /* @__PURE__ */ dual224(3, (self2, b2222, f2222) => fromIterable44(self2).reduce((b322, a2222, i2222) => f2222(b322, a2222, i2222), b2222));
var reduceRight4 = /* @__PURE__ */ dual224(3, (self2, b2222, f2222) => fromIterable44(self2).reduceRight((b322, a2222, i2222) => f2222(b322, a2222, i2222), b2222));
var liftPredicate34 = (predicate) => (b2222) => predicate(b2222) ? [b2222] : [];
var liftOption4 = (f2222) => (...a2222) => fromOption24(f2222(...a2222));
var fromNullable34 = (a2222) => a2222 == null ? empty94() : [a2222];
var liftNullable34 = (f2222) => (...a2222) => fromNullable34(f2222(...a2222));
var flatMapNullable34 = /* @__PURE__ */ dual224(2, (self2, f2222) => flatMap34(self2, (a2222) => fromNullable34(f2222(a2222))));
var liftEither4 = (f2222) => (...a2222) => {
  const e2222 = f2222(...a2222);
  return isLeft34(e2222) ? [] : [e2222.right];
};
var every34 = /* @__PURE__ */ dual224(2, (self2, refinement) => self2.every(refinement));
var some74 = /* @__PURE__ */ dual224(2, (self2, predicate) => self2.some(predicate));
var extend4 = /* @__PURE__ */ dual224(2, (self2, f2222) => self2.map((_2222, i2222, as422) => f2222(as422.slice(i2222))));
var min24 = /* @__PURE__ */ dual224(2, (self2, O2222) => self2.reduce(min5(O2222)));
var max24 = /* @__PURE__ */ dual224(2, (self2, O2222) => self2.reduce(max5(O2222)));
var unfold4 = (b2222, f2222) => {
  const out = [];
  let next = b2222;
  let o2222;
  while (isSome44(o2222 = f2222(next))) {
    const [a2222, b322] = o2222.value;
    out.push(a2222);
    next = b322;
  }
  return out;
};
var getOrder34 = array44;
var getEquivalence44 = array324;
var forEach324 = /* @__PURE__ */ dual224(2, (self2, f2222) => fromIterable44(self2).forEach((a2222, i2222) => f2222(a2222, i2222)));
var dedupeWith4 = /* @__PURE__ */ dual224(2, (self2, isEquivalent) => {
  const input = fromIterable44(self2);
  if (isNonEmptyReadonlyArray4(input)) {
    const out = [headNonEmpty224(input)];
    const rest = tailNonEmpty224(input);
    for (const r2222 of rest) {
      if (out.every((a2222) => !isEquivalent(r2222, a2222))) {
        out.push(r2222);
      }
    }
    return out;
  }
  return [];
});
var dedupe4 = (self2) => dedupeWith4(self2, equivalence224());
var dedupeAdjacentWith4 = /* @__PURE__ */ dual224(2, (self2, isEquivalent) => {
  const out = [];
  let lastA = none44();
  for (const a2222 of self2) {
    if (isNone44(lastA) || !isEquivalent(a2222, lastA.value)) {
      out.push(a2222);
      lastA = some64(a2222);
    }
  }
  return out;
});
var dedupeAdjacent4 = /* @__PURE__ */ dedupeAdjacentWith4(/* @__PURE__ */ equivalence224());
var join4 = /* @__PURE__ */ dual224(2, (self2, sep2) => fromIterable44(self2).join(sep2));
var mapAccum4 = /* @__PURE__ */ dual224(3, (self2, s2222, f2222) => {
  let i2222 = 0;
  let s1 = s2222;
  const out = [];
  for (const a2222 of self2) {
    const r2222 = f2222(s1, a2222, i2222);
    s1 = r2222[0];
    out.push(r2222[1]);
    i2222++;
  }
  return [s1, out];
});
var cartesianWith4 = /* @__PURE__ */ dual224(3, (self2, that, f2222) => flatMap34(self2, (a2222) => map34(that, (b2222) => f2222(a2222, b2222))));
var cartesian4 = /* @__PURE__ */ dual224(2, (self2, that) => cartesianWith4(self2, that, (a2222, b2222) => [a2222, b2222]));
var Do34 = /* @__PURE__ */ of224({});
var bind54 = /* @__PURE__ */ bind324(map34, flatMap34);
var bindTo54 = /* @__PURE__ */ bindTo324(map34);
var let_54 = /* @__PURE__ */ let_324(map34);
var __defProp324 = Object.defineProperty;
var __export324 = (target, all3224) => {
  for (var name22 in all3224)
    __defProp324(target, name22, { get: all3224[name22], enumerable: true });
};
var Function_exports34 = {};
__export324(Function_exports34, {
  SK: () => SK34,
  absurd: () => absurd34,
  apply: () => apply34,
  compose: () => compose54,
  constFalse: () => constFalse34,
  constNull: () => constNull34,
  constTrue: () => constTrue34,
  constUndefined: () => constUndefined34,
  constVoid: () => constVoid34,
  constant: () => constant34,
  dual: () => dual34,
  flip: () => flip34,
  flow: () => flow34,
  hole: () => hole34,
  identity: () => identity34,
  isFunction: () => isFunction64,
  pipe: () => pipe34,
  satisfies: () => satisfies34,
  tupled: () => tupled34,
  unsafeCoerce: () => unsafeCoerce34,
  untupled: () => untupled34
});
var isFunction64 = (input) => typeof input === "function";
var dual34 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a2222, b2222) {
        if (arguments.length >= 2) {
          return body(a2222, b2222);
        }
        return function(self2) {
          return body(self2, a2222);
        };
      };
    case 3:
      return function(a2222, b2222, c2222) {
        if (arguments.length >= 3) {
          return body(a2222, b2222, c2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222);
        };
      };
    case 4:
      return function(a2222, b2222, c2222, d2222) {
        if (arguments.length >= 4) {
          return body(a2222, b2222, c2222, d2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222);
        };
      };
    case 5:
      return function(a2222, b2222, c2222, d2222, e2222) {
        if (arguments.length >= 5) {
          return body(a2222, b2222, c2222, d2222, e2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222, d2222);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply34 = (a2222) => (self2) => self2(a2222);
var identity34 = (a2222) => a2222;
var satisfies34 = () => (b2222) => b2222;
var unsafeCoerce34 = identity34;
var constant34 = (value) => () => value;
var constTrue34 = /* @__PURE__ */ constant34(true);
var constFalse34 = /* @__PURE__ */ constant34(false);
var constNull34 = /* @__PURE__ */ constant34(null);
var constUndefined34 = /* @__PURE__ */ constant34(void 0);
var constVoid34 = constUndefined34;
var flip34 = (f2222) => (...b2222) => (...a2222) => f2222(...a2222)(...b2222);
var compose54 = /* @__PURE__ */ dual34(2, (ab, bc) => (a2222) => bc(ab(a2222)));
var absurd34 = (_2222) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled34 = (f2222) => (a2222) => f2222(...a2222);
var untupled34 = (f2222) => (...a2222) => f2222(a2222);
function pipe34(a2222, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a2222;
    case 2:
      return ab(a2222);
    case 3:
      return bc(ab(a2222));
    case 4:
      return cd(bc(ab(a2222)));
    case 5:
      return de(cd(bc(ab(a2222))));
    case 6:
      return ef(de(cd(bc(ab(a2222)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a2222))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a2222)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a2222))))))));
    default: {
      let ret = arguments[0];
      for (let i2222 = 1; i2222 < arguments.length; i2222++) {
        ret = arguments[i2222](ret);
      }
      return ret;
    }
  }
}
function flow34(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole34 = /* @__PURE__ */ unsafeCoerce34(absurd34);
var SK34 = (_2222, b2222) => b2222;
var make114 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_64 = (map324) => dual34(3, (self2, name22, f2222) => map324(self2, (a2222) => Object.assign({}, a2222, {
  [name22]: f2222(a2222)
})));
var bindTo64 = (map324) => dual34(2, (self2, name22) => map324(self2, (a2222) => ({
  [name22]: a2222
})));
var bind64 = (map324, flatMap324) => dual34(3, (self2, name22, f2222) => flatMap324(self2, (a2222) => map324(f2222(a2222), (b2222) => Object.assign({}, a2222, {
  [name22]: b2222
}))));
var moduleVersion34 = "3.2.8";
var getCurrentVersion34 = () => moduleVersion34;
var globalStoreId34 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion34()}`);
if (!(globalStoreId34 in globalThis)) {
  globalThis[globalStoreId34] = /* @__PURE__ */ new Map();
}
var globalStore34 = globalThis[globalStoreId34];
var globalValue34 = (id, compute) => {
  if (!globalStore34.has(id)) {
    globalStore34.set(id, compute());
  }
  return globalStore34.get(id);
};
var isFunction2224 = isFunction64;
var isRecordOrArray34 = (input) => typeof input === "object" && input !== null;
var isObject34 = (input) => isRecordOrArray34(input) || isFunction2224(input);
var hasProperty34 = /* @__PURE__ */ dual34(2, (self2, property) => isObject34(self2) && property in self2);
var isNullable34 = (input) => input === null || input === void 0;
var getBugErrorMessage34 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId34 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind34 = (u2222) => isObject34(u2222) && GenKindTypeId34 in u2222;
var GenKindImpl34 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity34;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId34] = GenKindTypeId34;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen44(this);
  }
};
var SingleShotGen44 = class _SingleShotGen324 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a2222) {
    return this.called ? {
      value: a2222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a2222) {
    return {
      value: a2222,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e2222) {
    throw e2222;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen324(this.self);
  }
};
var adapter54 = () => function() {
  let x2222 = arguments[0];
  for (let i2222 = 1; i2222 < arguments.length; i2222++) {
    x2222 = arguments[i2222](x2222);
  }
  return new GenKindImpl34(x2222);
};
var defaultIncHi34 = 335903614;
var defaultIncLo34 = 4150755663;
var MUL_HI34 = 1481765933 >>> 0;
var MUL_LO34 = 1284865837 >>> 0;
var BIT_5334 = 9007199254740992;
var BIT_2734 = 134217728;
var PCGRandom34 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable34(seedLo) && isNullable34(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable34(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable34(incLo) && isNullable34(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo34;
      incHi = this._state ? this._state[2] : defaultIncHi34;
    } else if (isNullable34(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add6434(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max34) {
    if (!max34) {
      return this._next();
    }
    max34 = max34 >>> 0;
    if ((max34 & max34 - 1) === 0) {
      return this._next() & max34 - 1;
    }
    let num = 0;
    const skew = (-max34 >>> 0) % max34 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max34;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_2734 + lo) / BIT_5334;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul6434(this._state, oldHi, oldLo, MUL_HI34, MUL_LO34);
    add6434(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul6434(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add6434(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId34 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap34 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId34]() {
    return this.#value;
  }
};
function yieldWrapGet34(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId34 in self2) {
    return self2[YieldWrapTypeId34]();
  }
  throw new Error(getBugErrorMessage34("yieldWrapGet"));
}
var structuralRegionState34 = /* @__PURE__ */ globalValue34("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache34 = /* @__PURE__ */ globalValue34(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr34 = /* @__PURE__ */ globalValue34(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom34());
var symbol54 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash34 = (self2) => {
  if (structuralRegionState34.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number44(self2);
    case "bigint":
      return string34(self2.toString(10));
    case "boolean":
      return string34(String(self2));
    case "symbol":
      return string34(String(self2));
    case "string":
      return string34(self2);
    case "undefined":
      return string34("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string34("null");
      } else if (self2 instanceof Date) {
        return hash34(self2.toISOString());
      } else if (isHash34(self2)) {
        return self2[symbol54]();
      } else {
        return random34(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random34 = (self2) => {
  if (!randomHashCache34.has(self2)) {
    randomHashCache34.set(self2, number44(pcgr34.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache34.get(self2);
};
var combine44 = (b2222) => (self2) => self2 * 53 ^ b2222;
var optimize34 = (n2222) => n2222 & 3221225471 | n2222 >>> 1 & 1073741824;
var isHash34 = (u2222) => hasProperty34(u2222, symbol54);
var number44 = (n2222) => {
  if (n2222 !== n2222 || n2222 === Infinity) {
    return 0;
  }
  let h2222 = n2222 | 0;
  if (h2222 !== n2222) {
    h2222 ^= n2222 * 4294967295;
  }
  while (n2222 > 4294967295) {
    h2222 ^= n2222 /= 4294967295;
  }
  return optimize34(n2222);
};
var string34 = (str) => {
  let h2222 = 5381, i2222 = str.length;
  while (i2222) {
    h2222 = h2222 * 33 ^ str.charCodeAt(--i2222);
  }
  return optimize34(h2222);
};
var cached34 = function() {
  if (arguments.length === 1) {
    const self3 = arguments[0];
    return function(hash422) {
      Object.defineProperty(self3, symbol54, {
        value() {
          return hash422;
        },
        enumerable: false
      });
      return hash422;
    };
  }
  const self2 = arguments[0];
  const hash324 = arguments[1];
  Object.defineProperty(self2, symbol54, {
    value() {
      return hash324;
    },
    enumerable: false
  });
  return hash324;
};
var symbol2224 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals34() {
  if (arguments.length === 1) {
    return (self2) => compareBoth34(self2, arguments[0]);
  }
  return compareBoth34(arguments[0], arguments[1]);
}
function compareBoth34(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual34(self2) && isEqual34(that)) {
        if (hash34(self2) === hash34(that) && self2[symbol2224](that)) {
          return true;
        } else {
          return structuralRegionState34.enabled && structuralRegionState34.tester ? structuralRegionState34.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState34.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v2222, i2222) => compareBoth34(v2222, that[i2222]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth34(self2[key], that[key]))) {
              return structuralRegionState34.tester ? structuralRegionState34.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState34.tester ? structuralRegionState34.tester(self2, that) : false;
    }
  }
  return structuralRegionState34.enabled && structuralRegionState34.tester ? structuralRegionState34.tester(self2, that) : false;
}
var isEqual34 = (u2222) => hasProperty34(u2222, symbol2224);
var equivalence34 = () => equals34;
var NodeInspectSymbol34 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON34 = (x2222) => {
  if (hasProperty34(x2222, "toJSON") && isFunction2224(x2222["toJSON"]) && x2222["toJSON"].length === 0) {
    return x2222.toJSON();
  } else if (Array.isArray(x2222)) {
    return x2222.map(toJSON34);
  }
  return x2222;
};
var format34 = (x2222) => JSON.stringify(x2222, null, 2);
var pipeArguments34 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i2222 = 0, len = args.length; i2222 < len; i2222++) {
        ret = args[i2222](ret);
      }
      return ret;
    }
  }
};
var EffectTypeId44 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId34 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId34 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId34 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance34 = {
  /* c8 ignore next */
  _R: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _A: (_2222) => _2222,
  _V: /* @__PURE__ */ getCurrentVersion34()
};
var sinkVariance34 = {
  /* c8 ignore next */
  _A: (_2222) => _2222,
  /* c8 ignore next */
  _In: (_2222) => _2222,
  /* c8 ignore next */
  _L: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _R: (_2222) => _2222
};
var channelVariance34 = {
  /* c8 ignore next */
  _Env: (_2222) => _2222,
  /* c8 ignore next */
  _InErr: (_2222) => _2222,
  /* c8 ignore next */
  _InElem: (_2222) => _2222,
  /* c8 ignore next */
  _InDone: (_2222) => _2222,
  /* c8 ignore next */
  _OutErr: (_2222) => _2222,
  /* c8 ignore next */
  _OutElem: (_2222) => _2222,
  /* c8 ignore next */
  _OutDone: (_2222) => _2222
};
var EffectPrototype34 = {
  [EffectTypeId44]: effectVariance34,
  [StreamTypeId34]: effectVariance34,
  [SinkTypeId34]: sinkVariance34,
  [ChannelTypeId34]: channelVariance34,
  [symbol2224](that) {
    return this === that;
  },
  [symbol54]() {
    return cached34(this, random34(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen44(new YieldWrap34(this));
  },
  pipe() {
    return pipeArguments34(this, arguments);
  }
};
var TypeId94 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto54 = {
  ...EffectPrototype34,
  [TypeId94]: {
    _A: (_2222) => _2222
  },
  [NodeInspectSymbol34]() {
    return this.toJSON();
  },
  toString() {
    return format34(this.toJSON());
  }
};
var SomeProto34 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto54), {
  _tag: "Some",
  _op: "Some",
  [symbol2224](that) {
    return isOption54(that) && isSome54(that) && equals34(this.value, that.value);
  },
  [symbol54]() {
    return cached34(this, combine44(hash34(this._tag))(hash34(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON34(this.value)
    };
  }
});
var NoneHash34 = /* @__PURE__ */ hash34("None");
var NoneProto34 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto54), {
  _tag: "None",
  _op: "None",
  [symbol2224](that) {
    return isOption54(that) && isNone54(that);
  },
  [symbol54]() {
    return NoneHash34;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption54 = (input) => hasProperty34(input, TypeId94);
var isNone54 = (fa) => fa._tag === "None";
var isSome54 = (fa) => fa._tag === "Some";
var none54 = /* @__PURE__ */ Object.create(NoneProto34);
var some84 = (value) => {
  const a2222 = Object.create(SomeProto34);
  a2222.value = value;
  return a2222;
};
var TypeId2224 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto2224 = {
  ...EffectPrototype34,
  [TypeId2224]: {
    _R: (_2222) => _2222
  },
  [NodeInspectSymbol34]() {
    return this.toJSON();
  },
  toString() {
    return format34(this.toJSON());
  }
};
var RightProto34 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto2224), {
  _tag: "Right",
  _op: "Right",
  [symbol2224](that) {
    return isEither34(that) && isRight44(that) && equals34(this.right, that.right);
  },
  [symbol54]() {
    return combine44(hash34(this._tag))(hash34(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON34(this.right)
    };
  }
});
var LeftProto34 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto2224), {
  _tag: "Left",
  _op: "Left",
  [symbol2224](that) {
    return isEither34(that) && isLeft44(that) && equals34(this.left, that.left);
  },
  [symbol54]() {
    return combine44(hash34(this._tag))(hash34(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON34(this.left)
    };
  }
});
var isEither34 = (input) => hasProperty34(input, TypeId2224);
var isLeft44 = (ma) => ma._tag === "Left";
var isRight44 = (ma) => ma._tag === "Right";
var left44 = (left3224) => {
  const a2222 = Object.create(LeftProto34);
  a2222.left = left3224;
  return a2222;
};
var right44 = (right3224) => {
  const a2222 = Object.create(RightProto34);
  a2222.right = right3224;
  return a2222;
};
var getLeft54 = (self2) => isRight44(self2) ? none54 : some84(self2.left);
var getRight54 = (self2) => isLeft44(self2) ? none54 : some84(self2.right);
var Option_exports34 = {};
__export324(Option_exports34, {
  Do: () => Do44,
  TypeId: () => TypeId3224,
  all: () => all54,
  andThen: () => andThen34,
  ap: () => ap34,
  as: () => as34,
  asVoid: () => asVoid34,
  bind: () => bind2224,
  bindTo: () => bindTo2224,
  composeK: () => composeK34,
  contains: () => contains44,
  containsWith: () => containsWith44,
  exists: () => exists34,
  filter: () => filter44,
  filterMap: () => filterMap44,
  firstSomeOf: () => firstSomeOf34,
  flatMap: () => flatMap44,
  flatMapNullable: () => flatMapNullable44,
  flatten: () => flatten44,
  fromIterable: () => fromIterable54,
  fromNullable: () => fromNullable44,
  gen: () => gen34,
  getEquivalence: () => getEquivalence54,
  getLeft: () => getLeft2224,
  getOrElse: () => getOrElse34,
  getOrNull: () => getOrNull34,
  getOrThrow: () => getOrThrow34,
  getOrThrowWith: () => getOrThrowWith34,
  getOrUndefined: () => getOrUndefined34,
  getOrder: () => getOrder44,
  getRight: () => getRight2224,
  isNone: () => isNone2224,
  isOption: () => isOption2224,
  isSome: () => isSome2224,
  let: () => let_2224,
  lift2: () => lift234,
  liftNullable: () => liftNullable44,
  liftPredicate: () => liftPredicate44,
  liftThrowable: () => liftThrowable34,
  map: () => map44,
  match: () => match54,
  none: () => none2224,
  orElse: () => orElse34,
  orElseEither: () => orElseEither34,
  orElseSome: () => orElseSome34,
  partitionMap: () => partitionMap44,
  product: () => product54,
  productMany: () => productMany54,
  reduceCompact: () => reduceCompact34,
  some: () => some2224,
  tap: () => tap34,
  toArray: () => toArray34,
  toRefinement: () => toRefinement34,
  void: () => void_34,
  zipLeft: () => zipLeft34,
  zipRight: () => zipRight34,
  zipWith: () => zipWith44
});
var make2224 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId3224 = /* @__PURE__ */ Symbol.for("effect/Option");
var none2224 = () => none54;
var some2224 = some84;
var isOption2224 = isOption54;
var isNone2224 = isNone54;
var isSome2224 = isSome54;
var match54 = /* @__PURE__ */ dual34(2, (self2, {
  onNone,
  onSome
}) => isNone2224(self2) ? onNone() : onSome(self2.value));
var toRefinement34 = (f2222) => (a2222) => isSome2224(f2222(a2222));
var fromIterable54 = (collection) => {
  for (const a2222 of collection) {
    return some2224(a2222);
  }
  return none2224();
};
var getRight2224 = getRight54;
var getLeft2224 = getLeft54;
var getOrElse34 = /* @__PURE__ */ dual34(2, (self2, onNone) => isNone2224(self2) ? onNone() : self2.value);
var orElse34 = /* @__PURE__ */ dual34(2, (self2, that) => isNone2224(self2) ? that() : self2);
var orElseSome34 = /* @__PURE__ */ dual34(2, (self2, onNone) => isNone2224(self2) ? some2224(onNone()) : self2);
var orElseEither34 = /* @__PURE__ */ dual34(2, (self2, that) => isNone2224(self2) ? map44(that(), right44) : map44(self2, left44));
var firstSomeOf34 = (collection) => {
  let out = none2224();
  for (out of collection) {
    if (isSome2224(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable44 = (nullableValue) => nullableValue == null ? none2224() : some2224(nullableValue);
var liftNullable44 = (f2222) => (...a2222) => fromNullable44(f2222(...a2222));
var getOrNull34 = /* @__PURE__ */ getOrElse34(constNull34);
var getOrUndefined34 = /* @__PURE__ */ getOrElse34(constUndefined34);
var liftThrowable34 = (f2222) => (...a2222) => {
  try {
    return some2224(f2222(...a2222));
  } catch (e2222) {
    return none2224();
  }
};
var getOrThrowWith34 = /* @__PURE__ */ dual34(2, (self2, onNone) => {
  if (isSome2224(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow34 = /* @__PURE__ */ getOrThrowWith34(() => new Error("getOrThrow called on a None"));
var map44 = /* @__PURE__ */ dual34(2, (self2, f2222) => isNone2224(self2) ? none2224() : some2224(f2222(self2.value)));
var as34 = /* @__PURE__ */ dual34(2, (self2, b2222) => map44(self2, () => b2222));
var asVoid34 = /* @__PURE__ */ as34(void 0);
var void_34 = /* @__PURE__ */ some2224(void 0);
var flatMap44 = /* @__PURE__ */ dual34(2, (self2, f2222) => isNone2224(self2) ? none2224() : f2222(self2.value));
var andThen34 = /* @__PURE__ */ dual34(2, (self2, f2222) => flatMap44(self2, (a2222) => {
  const b2222 = isFunction64(f2222) ? f2222(a2222) : f2222;
  return isOption2224(b2222) ? b2222 : some2224(b2222);
}));
var flatMapNullable44 = /* @__PURE__ */ dual34(2, (self2, f2222) => isNone2224(self2) ? none2224() : fromNullable44(f2222(self2.value)));
var flatten44 = /* @__PURE__ */ flatMap44(identity34);
var zipRight34 = /* @__PURE__ */ dual34(2, (self2, that) => flatMap44(self2, () => that));
var composeK34 = /* @__PURE__ */ dual34(2, (afb, bfc) => (a2222) => flatMap44(afb(a2222), bfc));
var zipLeft34 = /* @__PURE__ */ dual34(2, (self2, that) => tap34(self2, () => that));
var tap34 = /* @__PURE__ */ dual34(2, (self2, f2222) => flatMap44(self2, (a2222) => map44(f2222(a2222), () => a2222)));
var product54 = (self2, that) => isSome2224(self2) && isSome2224(that) ? some2224([self2.value, that.value]) : none2224();
var productMany54 = (self2, collection) => {
  if (isNone2224(self2)) {
    return none2224();
  }
  const out = [self2.value];
  for (const o2222 of collection) {
    if (isNone2224(o2222)) {
      return none2224();
    }
    out.push(o2222.value);
  }
  return some2224(out);
};
var all54 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o2222 of input) {
      if (isNone2224(o2222)) {
        return none2224();
      }
      out2.push(o2222.value);
    }
    return some2224(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o2222 = input[key];
    if (isNone2224(o2222)) {
      return none2224();
    }
    out[key] = o2222.value;
  }
  return some2224(out);
};
var zipWith44 = /* @__PURE__ */ dual34(3, (self2, that, f2222) => map44(product54(self2, that), ([a2222, b2222]) => f2222(a2222, b2222)));
var ap34 = /* @__PURE__ */ dual34(2, (self2, that) => zipWith44(self2, that, (f2222, a2222) => f2222(a2222)));
var reduceCompact34 = /* @__PURE__ */ dual34(3, (self2, b2222, f2222) => {
  let out = b2222;
  for (const oa of self2) {
    if (isSome2224(oa)) {
      out = f2222(out, oa.value);
    }
  }
  return out;
});
var toArray34 = (self2) => isNone2224(self2) ? [] : [self2.value];
var partitionMap44 = /* @__PURE__ */ dual34(2, (self2, f2222) => {
  if (isNone2224(self2)) {
    return [none2224(), none2224()];
  }
  const e2222 = f2222(self2.value);
  return isLeft44(e2222) ? [some2224(e2222.left), none2224()] : [none2224(), some2224(e2222.right)];
});
var filterMap44 = /* @__PURE__ */ dual34(2, (self2, f2222) => isNone2224(self2) ? none2224() : f2222(self2.value));
var filter44 = /* @__PURE__ */ dual34(2, (self2, predicate) => filterMap44(self2, (b2222) => predicate(b2222) ? some84(b2222) : none54));
var getEquivalence54 = (isEquivalent) => make114((x2222, y2222) => x2222 === y2222 || (isNone2224(x2222) ? isNone2224(y2222) : isNone2224(y2222) ? false : isEquivalent(x2222.value, y2222.value)));
var getOrder44 = (O2222) => make2224((self2, that) => isSome2224(self2) ? isSome2224(that) ? O2222(self2.value, that.value) : 1 : -1);
var lift234 = (f2222) => dual34(2, (self2, that) => zipWith44(self2, that, f2222));
var liftPredicate44 = (predicate) => (b2222) => predicate(b2222) ? some2224(b2222) : none2224();
var containsWith44 = (isEquivalent) => dual34(2, (self2, a2222) => isNone2224(self2) ? false : isEquivalent(self2.value, a2222));
var _equivalence54 = /* @__PURE__ */ equivalence34();
var contains44 = /* @__PURE__ */ containsWith44(_equivalence54);
var exists34 = /* @__PURE__ */ dual34(2, (self2, refinement) => isNone2224(self2) ? false : refinement(self2.value));
var bindTo2224 = /* @__PURE__ */ bindTo64(map44);
var let_2224 = /* @__PURE__ */ let_64(map44);
var bind2224 = /* @__PURE__ */ bind64(map44, flatMap44);
var Do44 = /* @__PURE__ */ some2224({});
var adapter2224 = /* @__PURE__ */ adapter54();
var gen34 = (f2222) => {
  const iterator = f2222(adapter2224);
  let state = iterator.next();
  if (state.done) {
    return some2224(state.value);
  } else {
    let current = state.value;
    if (isGenKind34(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet34(current);
    }
    if (isNone2224(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind34(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet34(current);
        }
        if (isNone2224(current)) {
          return current;
        }
      }
    }
    return some2224(state.value);
  }
};
var MutableRef_exports24 = {};
__export324(MutableRef_exports24, {
  compareAndSet: () => compareAndSet7,
  decrement: () => decrement7,
  decrementAndGet: () => decrementAndGet7,
  get: () => get24,
  getAndDecrement: () => getAndDecrement7,
  getAndIncrement: () => getAndIncrement7,
  getAndSet: () => getAndSet7,
  getAndUpdate: () => getAndUpdate7,
  increment: () => increment7,
  incrementAndGet: () => incrementAndGet7,
  make: () => make3224,
  set: () => set224,
  setAndGet: () => setAndGet7,
  toggle: () => toggle7,
  update: () => update7,
  updateAndGet: () => updateAndGet7
});
var TypeId4224 = /* @__PURE__ */ Symbol.for("effect/MutableRef");
var MutableRefProto7 = {
  [TypeId4224]: TypeId4224,
  toString() {
    return format34(this.toJSON());
  },
  toJSON() {
    return {
      _id: "MutableRef",
      current: toJSON34(this.current)
    };
  },
  [NodeInspectSymbol34]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments34(this, arguments);
  }
};
var make3224 = (value) => {
  const ref = Object.create(MutableRefProto7);
  ref.current = value;
  return ref;
};
var compareAndSet7 = /* @__PURE__ */ dual34(3, (self2, oldValue, newValue) => {
  if (equals34(oldValue, self2.current)) {
    self2.current = newValue;
    return true;
  }
  return false;
});
var decrement7 = (self2) => update7(self2, (n2222) => n2222 - 1);
var decrementAndGet7 = (self2) => updateAndGet7(self2, (n2222) => n2222 - 1);
var get24 = (self2) => self2.current;
var getAndDecrement7 = (self2) => getAndUpdate7(self2, (n2222) => n2222 - 1);
var getAndIncrement7 = (self2) => getAndUpdate7(self2, (n2222) => n2222 + 1);
var getAndSet7 = /* @__PURE__ */ dual34(2, (self2, value) => {
  const ret = self2.current;
  self2.current = value;
  return ret;
});
var getAndUpdate7 = /* @__PURE__ */ dual34(2, (self2, f2222) => getAndSet7(self2, f2222(get24(self2))));
var increment7 = (self2) => update7(self2, (n2222) => n2222 + 1);
var incrementAndGet7 = (self2) => updateAndGet7(self2, (n2222) => n2222 + 1);
var set224 = /* @__PURE__ */ dual34(2, (self2, value) => {
  self2.current = value;
  return self2;
});
var setAndGet7 = /* @__PURE__ */ dual34(2, (self2, value) => {
  self2.current = value;
  return self2.current;
});
var update7 = /* @__PURE__ */ dual34(2, (self2, f2222) => set224(self2, f2222(get24(self2))));
var updateAndGet7 = /* @__PURE__ */ dual34(2, (self2, f2222) => setAndGet7(self2, f2222(get24(self2))));
var toggle7 = (self2) => update7(self2, (_2222) => !_2222);
function getVariables5(initialScope) {
  const scopeRef = MutableRef_exports24.make(initialScope);
  const variablesRef = MutableRef_exports24.make(MutableRef_exports24.get(scopeRef).variables);
  while (MutableRef_exports24.get(scopeRef).type !== scopeManager.ScopeType.global) {
    MutableRef_exports24.set(scopeRef, MutableRef_exports24.get(scopeRef).upper);
    MutableRef_exports24.update(variablesRef, (variables) => variables.concat(MutableRef_exports24.get(scopeRef).variables));
  }
  return MutableRef_exports24.get(variablesRef).reverse();
}
Function_exports34.dual(2, (name22, initialScope) => {
  return Option_exports34.fromNullable(getVariables5(initialScope).find((variable) => variable.name === name22));
});
var t24 = Symbol.for("@ts-pattern/matcher");
var e24 = Symbol.for("@ts-pattern/isVariadic");
var n24 = "@ts-pattern/anonymous-select-key";
var r24 = (t2222) => Boolean(t2222 && "object" == typeof t2222);
var i24 = (e2222) => e2222 && !!e2222[t24];
var o24 = (n2222, s2222, c2222) => {
  if (i24(n2222)) {
    const e2222 = n2222[t24](), { matched: r2222, selections: i2222 } = e2222.match(s2222);
    return r2222 && i2222 && Object.keys(i2222).forEach((t2222) => c2222(t2222, i2222[t2222])), r2222;
  }
  if (r24(n2222)) {
    if (!r24(s2222)) return false;
    if (Array.isArray(n2222)) {
      if (!Array.isArray(s2222)) return false;
      let t2222 = [], r2222 = [], a2222 = [];
      for (const o2222 of n2222.keys()) {
        const s322 = n2222[o2222];
        i24(s322) && s322[e24] ? a2222.push(s322) : a2222.length ? r2222.push(s322) : t2222.push(s322);
      }
      if (a2222.length) {
        if (a2222.length > 1) throw new Error("Pattern error: Using `...P.array(...)` several times in a single pattern is not allowed.");
        if (s2222.length < t2222.length + r2222.length) return false;
        const e2222 = s2222.slice(0, t2222.length), n322 = 0 === r2222.length ? [] : s2222.slice(-r2222.length), i2222 = s2222.slice(t2222.length, 0 === r2222.length ? Infinity : -r2222.length);
        return t2222.every((t322, n43) => o24(t322, e2222[n43], c2222)) && r2222.every((t322, e322) => o24(t322, n322[e322], c2222)) && (0 === a2222.length || o24(a2222[0], i2222, c2222));
      }
      return n2222.length === s2222.length && n2222.every((t322, e2222) => o24(t322, s2222[e2222], c2222));
    }
    return Object.keys(n2222).every((e2222) => {
      const r2222 = n2222[e2222];
      return (e2222 in s2222 || i24(a2222 = r2222) && "optional" === a2222[t24]().matcherType) && o24(r2222, s2222[e2222], c2222);
      var a2222;
    });
  }
  return Object.is(s2222, n2222);
};
var s24 = (e2222) => {
  var n2222, o2222, a2222;
  return r24(e2222) ? i24(e2222) ? null != (n2222 = null == (o2222 = (a2222 = e2222[t24]()).getSelectionKeys) ? void 0 : o2222.call(a2222)) ? n2222 : [] : Array.isArray(e2222) ? c24(e2222, s24) : c24(Object.values(e2222), s24) : [];
};
var c24 = (t2222, e2222) => t2222.reduce((t322, n2222) => t322.concat(e2222(n2222)), []);
function a24(...t2222) {
  if (1 === t2222.length) {
    const [e2222] = t2222;
    return (t322) => o24(e2222, t322, () => {
    });
  }
  if (2 === t2222.length) {
    const [e2222, n2222] = t2222;
    return o24(e2222, n2222, () => {
    });
  }
  throw new Error(`isMatching wasn't given the right number of arguments: expected 1 or 2, received ${t2222.length}.`);
}
function u24(t2222) {
  return Object.assign(t2222, { optional: () => l24(t2222), and: (e2222) => m24(t2222, e2222), or: (e2222) => d24(t2222, e2222), select: (e2222) => void 0 === e2222 ? p24(t2222) : p24(e2222, t2222) });
}
function h24(t2222) {
  return Object.assign(((t322) => Object.assign(t322, { [Symbol.iterator]() {
    let n2222 = 0;
    const r2222 = [{ value: Object.assign(t322, { [e24]: true }), done: false }, { done: true, value: void 0 }];
    return { next: () => {
      var t43;
      return null != (t43 = r2222[n2222++]) ? t43 : r2222.at(-1);
    } };
  } }))(t2222), { optional: () => h24(l24(t2222)), select: (e2222) => h24(void 0 === e2222 ? p24(t2222) : p24(e2222, t2222)) });
}
function l24(e2222) {
  return u24({ [t24]: () => ({ match: (t2222) => {
    let n2222 = {};
    const r2222 = (t322, e322) => {
      n2222[t322] = e322;
    };
    return void 0 === t2222 ? (s24(e2222).forEach((t322) => r2222(t322, void 0)), { matched: true, selections: n2222 }) : { matched: o24(e2222, t2222, r2222), selections: n2222 };
  }, getSelectionKeys: () => s24(e2222), matcherType: "optional" }) });
}
var f24 = (t2222, e2222) => {
  for (const n2222 of t2222) if (!e2222(n2222)) return false;
  return true;
};
var g24 = (t2222, e2222) => {
  for (const [n2222, r2222] of t2222.entries()) if (!e2222(r2222, n2222)) return false;
  return true;
};
function m24(...e2222) {
  return u24({ [t24]: () => ({ match: (t2222) => {
    let n2222 = {};
    const r2222 = (t322, e322) => {
      n2222[t322] = e322;
    };
    return { matched: e2222.every((e322) => o24(e322, t2222, r2222)), selections: n2222 };
  }, getSelectionKeys: () => c24(e2222, s24), matcherType: "and" }) });
}
function d24(...e2222) {
  return u24({ [t24]: () => ({ match: (t2222) => {
    let n2222 = {};
    const r2222 = (t322, e322) => {
      n2222[t322] = e322;
    };
    return c24(e2222, s24).forEach((t322) => r2222(t322, void 0)), { matched: e2222.some((e322) => o24(e322, t2222, r2222)), selections: n2222 };
  }, getSelectionKeys: () => c24(e2222, s24), matcherType: "or" }) });
}
function y24(e2222) {
  return { [t24]: () => ({ match: (t2222) => ({ matched: Boolean(e2222(t2222)) }) }) };
}
function p24(...e2222) {
  const r2222 = "string" == typeof e2222[0] ? e2222[0] : void 0, i2222 = 2 === e2222.length ? e2222[1] : "string" == typeof e2222[0] ? void 0 : e2222[0];
  return u24({ [t24]: () => ({ match: (t2222) => {
    let e322 = { [null != r2222 ? r2222 : n24]: t2222 };
    return { matched: void 0 === i2222 || o24(i2222, t2222, (t322, n2222) => {
      e322[t322] = n2222;
    }), selections: e322 };
  }, getSelectionKeys: () => [null != r2222 ? r2222 : n24].concat(void 0 === i2222 ? [] : s24(i2222)) }) });
}
function v24(t2222) {
  return "number" == typeof t2222;
}
function b24(t2222) {
  return "string" == typeof t2222;
}
function w24(t2222) {
  return "bigint" == typeof t2222;
}
var S24 = u24(y24(function(t2222) {
  return true;
}));
var O24 = S24;
var j24 = (t2222) => Object.assign(u24(t2222), { startsWith: (e2222) => {
  return j24(m24(t2222, (n2222 = e2222, y24((t322) => b24(t322) && t322.startsWith(n2222)))));
  var n2222;
}, endsWith: (e2222) => {
  return j24(m24(t2222, (n2222 = e2222, y24((t322) => b24(t322) && t322.endsWith(n2222)))));
  var n2222;
}, minLength: (e2222) => j24(m24(t2222, ((t322) => y24((e322) => b24(e322) && e322.length >= t322))(e2222))), maxLength: (e2222) => j24(m24(t2222, ((t322) => y24((e322) => b24(e322) && e322.length <= t322))(e2222))), includes: (e2222) => {
  return j24(m24(t2222, (n2222 = e2222, y24((t322) => b24(t322) && t322.includes(n2222)))));
  var n2222;
}, regex: (e2222) => {
  return j24(m24(t2222, (n2222 = e2222, y24((t322) => b24(t322) && Boolean(t322.match(n2222))))));
  var n2222;
} });
var E24 = j24(y24(b24));
var K24 = (t2222) => Object.assign(u24(t2222), { between: (e2222, n2222) => K24(m24(t2222, ((t322, e322) => y24((n322) => v24(n322) && t322 <= n322 && e322 >= n322))(e2222, n2222))), lt: (e2222) => K24(m24(t2222, ((t322) => y24((e322) => v24(e322) && e322 < t322))(e2222))), gt: (e2222) => K24(m24(t2222, ((t322) => y24((e322) => v24(e322) && e322 > t322))(e2222))), lte: (e2222) => K24(m24(t2222, ((t322) => y24((e322) => v24(e322) && e322 <= t322))(e2222))), gte: (e2222) => K24(m24(t2222, ((t322) => y24((e322) => v24(e322) && e322 >= t322))(e2222))), int: () => K24(m24(t2222, y24((t322) => v24(t322) && Number.isInteger(t322)))), finite: () => K24(m24(t2222, y24((t322) => v24(t322) && Number.isFinite(t322)))), positive: () => K24(m24(t2222, y24((t322) => v24(t322) && t322 > 0))), negative: () => K24(m24(t2222, y24((t322) => v24(t322) && t322 < 0))) });
var x24 = K24(y24(v24));
var A24 = (t2222) => Object.assign(u24(t2222), { between: (e2222, n2222) => A24(m24(t2222, ((t322, e322) => y24((n322) => w24(n322) && t322 <= n322 && e322 >= n322))(e2222, n2222))), lt: (e2222) => A24(m24(t2222, ((t322) => y24((e322) => w24(e322) && e322 < t322))(e2222))), gt: (e2222) => A24(m24(t2222, ((t322) => y24((e322) => w24(e322) && e322 > t322))(e2222))), lte: (e2222) => A24(m24(t2222, ((t322) => y24((e322) => w24(e322) && e322 <= t322))(e2222))), gte: (e2222) => A24(m24(t2222, ((t322) => y24((e322) => w24(e322) && e322 >= t322))(e2222))), positive: () => A24(m24(t2222, y24((t322) => w24(t322) && t322 > 0))), negative: () => A24(m24(t2222, y24((t322) => w24(t322) && t322 < 0))) });
var P223 = A24(y24(w24));
var T24 = u24(y24(function(t2222) {
  return "boolean" == typeof t2222;
}));
var k24 = u24(y24(function(t2222) {
  return "symbol" == typeof t2222;
}));
var B24 = u24(y24(function(t2222) {
  return null == t2222;
}));
var _24 = u24(y24(function(t2222) {
  return null != t2222;
}));
var N24 = { __proto__: null, matcher: t24, optional: l24, array: function(...e2222) {
  return h24({ [t24]: () => ({ match: (t2222) => {
    if (!Array.isArray(t2222)) return { matched: false };
    if (0 === e2222.length) return { matched: true };
    const n2222 = e2222[0];
    let r2222 = {};
    if (0 === t2222.length) return s24(n2222).forEach((t322) => {
      r2222[t322] = [];
    }), { matched: true, selections: r2222 };
    const i2222 = (t322, e322) => {
      r2222[t322] = (r2222[t322] || []).concat([e322]);
    };
    return { matched: t2222.every((t322) => o24(n2222, t322, i2222)), selections: r2222 };
  }, getSelectionKeys: () => 0 === e2222.length ? [] : s24(e2222[0]) }) });
}, set: function(...e2222) {
  return u24({ [t24]: () => ({ match: (t2222) => {
    if (!(t2222 instanceof Set)) return { matched: false };
    let n2222 = {};
    if (0 === t2222.size) return { matched: true, selections: n2222 };
    if (0 === e2222.length) return { matched: true };
    const r2222 = (t322, e322) => {
      n2222[t322] = (n2222[t322] || []).concat([e322]);
    }, i2222 = e2222[0];
    return { matched: f24(t2222, (t322) => o24(i2222, t322, r2222)), selections: n2222 };
  }, getSelectionKeys: () => 0 === e2222.length ? [] : s24(e2222[0]) }) });
}, map: function(...e2222) {
  return u24({ [t24]: () => ({ match: (t2222) => {
    if (!(t2222 instanceof Map)) return { matched: false };
    let n2222 = {};
    if (0 === t2222.size) return { matched: true, selections: n2222 };
    const r2222 = (t322, e322) => {
      n2222[t322] = (n2222[t322] || []).concat([e322]);
    };
    if (0 === e2222.length) return { matched: true };
    var i2222;
    if (1 === e2222.length) throw new Error(`\`P.map\` wasn't given enough arguments. Expected (key, value), received ${null == (i2222 = e2222[0]) ? void 0 : i2222.toString()}`);
    const [s2222, c2222] = e2222;
    return { matched: g24(t2222, (t322, e322) => {
      const n322 = o24(s2222, e322, r2222), i322 = o24(c2222, t322, r2222);
      return n322 && i322;
    }), selections: n2222 };
  }, getSelectionKeys: () => 0 === e2222.length ? [] : [...s24(e2222[0]), ...s24(e2222[1])] }) });
}, intersection: m24, union: d24, not: function(e2222) {
  return u24({ [t24]: () => ({ match: (t2222) => ({ matched: !o24(e2222, t2222, () => {
  }) }), getSelectionKeys: () => [], matcherType: "not" }) });
}, when: y24, select: p24, any: S24, _: O24, string: E24, number: x24, bigint: P223, boolean: T24, symbol: k24, nullish: B24, nonNullable: _24, instanceOf: function(t2222) {
  return u24(y24(/* @__PURE__ */ function(t322) {
    return (e2222) => e2222 instanceof t322;
  }(t2222)));
}, shape: function(t2222) {
  return u24(y24(a24(t2222)));
} };
var KEYS224 = {
  ArrayExpression: [
    "elements"
  ],
  ArrayPattern: [
    "elements"
  ],
  ArrowFunctionExpression: [
    "params",
    "body"
  ],
  AssignmentExpression: [
    "left",
    "right"
  ],
  AssignmentPattern: [
    "left",
    "right"
  ],
  AwaitExpression: [
    "argument"
  ],
  BinaryExpression: [
    "left",
    "right"
  ],
  BlockStatement: [
    "body"
  ],
  BreakStatement: [
    "label"
  ],
  CallExpression: [
    "callee",
    "arguments"
  ],
  CatchClause: [
    "param",
    "body"
  ],
  ChainExpression: [
    "expression"
  ],
  ClassBody: [
    "body"
  ],
  ClassDeclaration: [
    "id",
    "superClass",
    "body"
  ],
  ClassExpression: [
    "id",
    "superClass",
    "body"
  ],
  ConditionalExpression: [
    "test",
    "consequent",
    "alternate"
  ],
  ContinueStatement: [
    "label"
  ],
  DebuggerStatement: [],
  DoWhileStatement: [
    "body",
    "test"
  ],
  EmptyStatement: [],
  ExperimentalRestProperty: [
    "argument"
  ],
  ExperimentalSpreadProperty: [
    "argument"
  ],
  ExportAllDeclaration: [
    "exported",
    "source"
  ],
  ExportDefaultDeclaration: [
    "declaration"
  ],
  ExportNamedDeclaration: [
    "declaration",
    "specifiers",
    "source"
  ],
  ExportSpecifier: [
    "exported",
    "local"
  ],
  ExpressionStatement: [
    "expression"
  ],
  ForInStatement: [
    "left",
    "right",
    "body"
  ],
  ForOfStatement: [
    "left",
    "right",
    "body"
  ],
  ForStatement: [
    "init",
    "test",
    "update",
    "body"
  ],
  FunctionDeclaration: [
    "id",
    "params",
    "body"
  ],
  FunctionExpression: [
    "id",
    "params",
    "body"
  ],
  Identifier: [],
  IfStatement: [
    "test",
    "consequent",
    "alternate"
  ],
  ImportDeclaration: [
    "specifiers",
    "source"
  ],
  ImportDefaultSpecifier: [
    "local"
  ],
  ImportExpression: [
    "source"
  ],
  ImportNamespaceSpecifier: [
    "local"
  ],
  ImportSpecifier: [
    "imported",
    "local"
  ],
  JSXAttribute: [
    "name",
    "value"
  ],
  JSXClosingElement: [
    "name"
  ],
  JSXClosingFragment: [],
  JSXElement: [
    "openingElement",
    "children",
    "closingElement"
  ],
  JSXEmptyExpression: [],
  JSXExpressionContainer: [
    "expression"
  ],
  JSXFragment: [
    "openingFragment",
    "children",
    "closingFragment"
  ],
  JSXIdentifier: [],
  JSXMemberExpression: [
    "object",
    "property"
  ],
  JSXNamespacedName: [
    "namespace",
    "name"
  ],
  JSXOpeningElement: [
    "name",
    "attributes"
  ],
  JSXOpeningFragment: [],
  JSXSpreadAttribute: [
    "argument"
  ],
  JSXSpreadChild: [
    "expression"
  ],
  JSXText: [],
  LabeledStatement: [
    "label",
    "body"
  ],
  Literal: [],
  LogicalExpression: [
    "left",
    "right"
  ],
  MemberExpression: [
    "object",
    "property"
  ],
  MetaProperty: [
    "meta",
    "property"
  ],
  MethodDefinition: [
    "key",
    "value"
  ],
  NewExpression: [
    "callee",
    "arguments"
  ],
  ObjectExpression: [
    "properties"
  ],
  ObjectPattern: [
    "properties"
  ],
  PrivateIdentifier: [],
  Program: [
    "body"
  ],
  Property: [
    "key",
    "value"
  ],
  PropertyDefinition: [
    "key",
    "value"
  ],
  RestElement: [
    "argument"
  ],
  ReturnStatement: [
    "argument"
  ],
  SequenceExpression: [
    "expressions"
  ],
  SpreadElement: [
    "argument"
  ],
  StaticBlock: [
    "body"
  ],
  Super: [],
  SwitchCase: [
    "test",
    "consequent"
  ],
  SwitchStatement: [
    "discriminant",
    "cases"
  ],
  TaggedTemplateExpression: [
    "tag",
    "quasi"
  ],
  TemplateElement: [],
  TemplateLiteral: [
    "quasis",
    "expressions"
  ],
  ThisExpression: [],
  ThrowStatement: [
    "argument"
  ],
  TryStatement: [
    "block",
    "handler",
    "finalizer"
  ],
  UnaryExpression: [
    "argument"
  ],
  UpdateExpression: [
    "argument"
  ],
  VariableDeclaration: [
    "declarations"
  ],
  VariableDeclarator: [
    "id",
    "init"
  ],
  WhileStatement: [
    "test",
    "body"
  ],
  WithStatement: [
    "object",
    "body"
  ],
  YieldExpression: [
    "argument"
  ]
};
var NODE_TYPES224 = Object.keys(KEYS224);
for (const type of NODE_TYPES224) {
  Object.freeze(KEYS224[type]);
}
Object.freeze(KEYS224);
var visitor_keys_default224 = KEYS224;
var KEY_BLACKLIST224 = /* @__PURE__ */ new Set([
  "parent",
  "leadingComments",
  "trailingComments"
]);
function filterKey224(key) {
  return !KEY_BLACKLIST224.has(key) && key[0] !== "_";
}
function getKeys224(node) {
  return Object.keys(node).filter(filterKey224);
}
function getInnermostScope224(initialScope, node) {
  const location = node.range[0];
  let scope = initialScope;
  let found = false;
  do {
    found = false;
    for (const childScope of scope.childScopes) {
      const range24 = childScope.block.range;
      if (range24[0] <= location && location < range24[1]) {
        scope = childScope;
        found = true;
        break;
      }
    }
  } while (found);
  return scope;
}
function findVariable2223(initialScope, nameOrNode) {
  let name22 = "";
  let scope = initialScope;
  if (typeof nameOrNode === "string") {
    name22 = nameOrNode;
  } else {
    name22 = nameOrNode.name;
    scope = getInnermostScope224(scope, nameOrNode);
  }
  while (scope != null) {
    const variable = scope.set.get(name22);
    if (variable != null) {
      return variable;
    }
    scope = scope.upper;
  }
  return null;
}
function negate0224(token) {
  return !this(token);
}
function negate224(f2222) {
  return negate0224.bind(f2222);
}
function isPunctuatorTokenWithValue224(token, value) {
  return token.type === "Punctuator" && token.value === value;
}
function isArrowToken224(token) {
  return isPunctuatorTokenWithValue224(token, "=>");
}
function isCommaToken224(token) {
  return isPunctuatorTokenWithValue224(token, ",");
}
function isSemicolonToken224(token) {
  return isPunctuatorTokenWithValue224(token, ";");
}
function isColonToken224(token) {
  return isPunctuatorTokenWithValue224(token, ":");
}
function isOpeningParenToken224(token) {
  return isPunctuatorTokenWithValue224(token, "(");
}
function isClosingParenToken224(token) {
  return isPunctuatorTokenWithValue224(token, ")");
}
function isOpeningBracketToken224(token) {
  return isPunctuatorTokenWithValue224(token, "[");
}
function isClosingBracketToken224(token) {
  return isPunctuatorTokenWithValue224(token, "]");
}
function isOpeningBraceToken224(token) {
  return isPunctuatorTokenWithValue224(token, "{");
}
function isClosingBraceToken224(token) {
  return isPunctuatorTokenWithValue224(token, "}");
}
function isCommentToken224(token) {
  return ["Block", "Line", "Shebang"].includes(token.type);
}
negate224(isArrowToken224);
negate224(isCommaToken224);
negate224(isSemicolonToken224);
negate224(isColonToken224);
negate224(isOpeningParenToken224);
negate224(isClosingParenToken224);
negate224(isOpeningBracketToken224);
negate224(isClosingBracketToken224);
negate224(isOpeningBraceToken224);
negate224(isClosingBraceToken224);
negate224(isCommentToken224);
function getOpeningParenOfParams224(node, sourceCode) {
  return node.id ? sourceCode.getTokenAfter(node.id, isOpeningParenToken224) : sourceCode.getFirstToken(node, isOpeningParenToken224);
}
function getFunctionHeadLocation224(node, sourceCode) {
  const parent = node.parent;
  let start = null;
  let end = null;
  if (node.type === "ArrowFunctionExpression") {
    const arrowToken = sourceCode.getTokenBefore(node.body, isArrowToken224);
    start = arrowToken.loc.start;
    end = arrowToken.loc.end;
  } else if (parent.type === "Property" || parent.type === "MethodDefinition" || parent.type === "PropertyDefinition") {
    start = parent.loc.start;
    end = getOpeningParenOfParams224(node, sourceCode).loc.start;
  } else {
    start = node.loc.start;
    end = getOpeningParenOfParams224(node, sourceCode).loc.start;
  }
  return {
    start: { ...start },
    end: { ...end }
  };
}
var globalObject224 = typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {};
var builtinNames224 = Object.freeze(
  /* @__PURE__ */ new Set([
    "Array",
    "ArrayBuffer",
    "BigInt",
    "BigInt64Array",
    "BigUint64Array",
    "Boolean",
    "DataView",
    "Date",
    "decodeURI",
    "decodeURIComponent",
    "encodeURI",
    "encodeURIComponent",
    "escape",
    "Float32Array",
    "Float64Array",
    "Function",
    "Infinity",
    "Int16Array",
    "Int32Array",
    "Int8Array",
    "isFinite",
    "isNaN",
    "isPrototypeOf",
    "JSON",
    "Map",
    "Math",
    "NaN",
    "Number",
    "Object",
    "parseFloat",
    "parseInt",
    "Promise",
    "Proxy",
    "Reflect",
    "RegExp",
    "Set",
    "String",
    "Symbol",
    "Uint16Array",
    "Uint32Array",
    "Uint8Array",
    "Uint8ClampedArray",
    "undefined",
    "unescape",
    "WeakMap",
    "WeakSet"
  ])
);
var callAllowed224 = new Set(
  [
    Array.isArray,
    Array.of,
    Array.prototype.at,
    Array.prototype.concat,
    Array.prototype.entries,
    Array.prototype.every,
    Array.prototype.filter,
    Array.prototype.find,
    Array.prototype.findIndex,
    Array.prototype.flat,
    Array.prototype.includes,
    Array.prototype.indexOf,
    Array.prototype.join,
    Array.prototype.keys,
    Array.prototype.lastIndexOf,
    Array.prototype.slice,
    Array.prototype.some,
    Array.prototype.toString,
    Array.prototype.values,
    typeof BigInt === "function" ? BigInt : void 0,
    Boolean,
    Date,
    Date.parse,
    decodeURI,
    decodeURIComponent,
    encodeURI,
    encodeURIComponent,
    escape,
    isFinite,
    isNaN,
    isPrototypeOf,
    Map,
    Map.prototype.entries,
    Map.prototype.get,
    Map.prototype.has,
    Map.prototype.keys,
    Map.prototype.values,
    ...Object.getOwnPropertyNames(Math).filter((k2222) => k2222 !== "random").map((k2222) => Math[k2222]).filter((f2222) => typeof f2222 === "function"),
    Number,
    Number.isFinite,
    Number.isNaN,
    Number.parseFloat,
    Number.parseInt,
    Number.prototype.toExponential,
    Number.prototype.toFixed,
    Number.prototype.toPrecision,
    Number.prototype.toString,
    Object,
    Object.entries,
    Object.is,
    Object.isExtensible,
    Object.isFrozen,
    Object.isSealed,
    Object.keys,
    Object.values,
    parseFloat,
    parseInt,
    RegExp,
    Set,
    Set.prototype.entries,
    Set.prototype.has,
    Set.prototype.keys,
    Set.prototype.values,
    String,
    String.fromCharCode,
    String.fromCodePoint,
    String.raw,
    String.prototype.at,
    String.prototype.charAt,
    String.prototype.charCodeAt,
    String.prototype.codePointAt,
    String.prototype.concat,
    String.prototype.endsWith,
    String.prototype.includes,
    String.prototype.indexOf,
    String.prototype.lastIndexOf,
    String.prototype.normalize,
    String.prototype.padEnd,
    String.prototype.padStart,
    String.prototype.slice,
    String.prototype.startsWith,
    String.prototype.substr,
    String.prototype.substring,
    String.prototype.toLowerCase,
    String.prototype.toString,
    String.prototype.toUpperCase,
    String.prototype.trim,
    String.prototype.trimEnd,
    String.prototype.trimLeft,
    String.prototype.trimRight,
    String.prototype.trimStart,
    Symbol.for,
    Symbol.keyFor,
    unescape
  ].filter((f2222) => typeof f2222 === "function")
);
var callPassThrough224 = /* @__PURE__ */ new Set([
  Object.freeze,
  Object.preventExtensions,
  Object.seal
]);
var getterAllowed224 = [
  [Map, /* @__PURE__ */ new Set(["size"])],
  [
    RegExp,
    /* @__PURE__ */ new Set([
      "dotAll",
      "flags",
      "global",
      "hasIndices",
      "ignoreCase",
      "multiline",
      "source",
      "sticky",
      "unicode"
    ])
  ],
  [Set, /* @__PURE__ */ new Set(["size"])]
];
function getPropertyDescriptor224(object222, name22) {
  let x2222 = object222;
  while ((typeof x2222 === "object" || typeof x2222 === "function") && x2222 !== null) {
    const d2222 = Object.getOwnPropertyDescriptor(x2222, name22);
    if (d2222) {
      return d2222;
    }
    x2222 = Object.getPrototypeOf(x2222);
  }
  return null;
}
function isGetter224(object222, name22) {
  const d2222 = getPropertyDescriptor224(object222, name22);
  return d2222 != null && d2222.get != null;
}
function getElementValues224(nodeList, initialScope) {
  const valueList = [];
  for (let i2222 = 0; i2222 < nodeList.length; ++i2222) {
    const elementNode = nodeList[i2222];
    if (elementNode == null) {
      valueList.length = i2222 + 1;
    } else if (elementNode.type === "SpreadElement") {
      const argument = getStaticValueR224(elementNode.argument, initialScope);
      if (argument == null) {
        return null;
      }
      valueList.push(...argument.value);
    } else {
      const element = getStaticValueR224(elementNode, initialScope);
      if (element == null) {
        return null;
      }
      valueList.push(element.value);
    }
  }
  return valueList;
}
function isEffectivelyConst224(variable) {
  const refs = variable.references;
  const inits = refs.filter((r2222) => r2222.init).length;
  const reads = refs.filter((r2222) => r2222.isReadOnly()).length;
  if (inits === 1 && reads + inits === refs.length) {
    return true;
  }
  return false;
}
var operations224 = Object.freeze({
  ArrayExpression(node, initialScope) {
    const elements = getElementValues224(node.elements, initialScope);
    return elements != null ? { value: elements } : null;
  },
  AssignmentExpression(node, initialScope) {
    if (node.operator === "=") {
      return getStaticValueR224(node.right, initialScope);
    }
    return null;
  },
  //eslint-disable-next-line complexity
  BinaryExpression(node, initialScope) {
    if (node.operator === "in" || node.operator === "instanceof") {
      return null;
    }
    const left3224 = getStaticValueR224(node.left, initialScope);
    const right3224 = getStaticValueR224(node.right, initialScope);
    if (left3224 != null && right3224 != null) {
      switch (node.operator) {
        case "==":
          return { value: left3224.value == right3224.value };
        case "!=":
          return { value: left3224.value != right3224.value };
        case "===":
          return { value: left3224.value === right3224.value };
        case "!==":
          return { value: left3224.value !== right3224.value };
        case "<":
          return { value: left3224.value < right3224.value };
        case "<=":
          return { value: left3224.value <= right3224.value };
        case ">":
          return { value: left3224.value > right3224.value };
        case ">=":
          return { value: left3224.value >= right3224.value };
        case "<<":
          return { value: left3224.value << right3224.value };
        case ">>":
          return { value: left3224.value >> right3224.value };
        case ">>>":
          return { value: left3224.value >>> right3224.value };
        case "+":
          return { value: left3224.value + right3224.value };
        case "-":
          return { value: left3224.value - right3224.value };
        case "*":
          return { value: left3224.value * right3224.value };
        case "/":
          return { value: left3224.value / right3224.value };
        case "%":
          return { value: left3224.value % right3224.value };
        case "**":
          return { value: left3224.value ** right3224.value };
        case "|":
          return { value: left3224.value | right3224.value };
        case "^":
          return { value: left3224.value ^ right3224.value };
        case "&":
          return { value: left3224.value & right3224.value };
      }
    }
    return null;
  },
  CallExpression(node, initialScope) {
    const calleeNode = node.callee;
    const args = getElementValues224(node.arguments, initialScope);
    if (args != null) {
      if (calleeNode.type === "MemberExpression") {
        if (calleeNode.property.type === "PrivateIdentifier") {
          return null;
        }
        const object222 = getStaticValueR224(calleeNode.object, initialScope);
        if (object222 != null) {
          if (object222.value == null && (object222.optional || node.optional)) {
            return { value: void 0, optional: true };
          }
          const property = getStaticPropertyNameValue224(
            calleeNode,
            initialScope
          );
          if (property != null) {
            const receiver = object222.value;
            const methodName = property.value;
            if (callAllowed224.has(receiver[methodName])) {
              return { value: receiver[methodName](...args) };
            }
            if (callPassThrough224.has(receiver[methodName])) {
              return { value: args[0] };
            }
          }
        }
      } else {
        const callee = getStaticValueR224(calleeNode, initialScope);
        if (callee != null) {
          if (callee.value == null && node.optional) {
            return { value: void 0, optional: true };
          }
          const func = callee.value;
          if (callAllowed224.has(func)) {
            return { value: func(...args) };
          }
          if (callPassThrough224.has(func)) {
            return { value: args[0] };
          }
        }
      }
    }
    return null;
  },
  ConditionalExpression(node, initialScope) {
    const test = getStaticValueR224(node.test, initialScope);
    if (test != null) {
      return test.value ? getStaticValueR224(node.consequent, initialScope) : getStaticValueR224(node.alternate, initialScope);
    }
    return null;
  },
  ExpressionStatement(node, initialScope) {
    return getStaticValueR224(node.expression, initialScope);
  },
  Identifier(node, initialScope) {
    if (initialScope != null) {
      const variable = findVariable2223(initialScope, node);
      if (variable != null && variable.defs.length === 0 && builtinNames224.has(variable.name) && variable.name in globalObject224) {
        return { value: globalObject224[variable.name] };
      }
      if (variable != null && variable.defs.length === 1) {
        const def = variable.defs[0];
        if (def.parent && def.type === "Variable" && (def.parent.kind === "const" || isEffectivelyConst224(variable)) && // TODO(mysticatea): don't support destructuring here.
        def.node.id.type === "Identifier") {
          return getStaticValueR224(def.node.init, initialScope);
        }
      }
    }
    return null;
  },
  Literal(node) {
    if ((node.regex != null || node.bigint != null) && node.value == null) {
      return null;
    }
    return { value: node.value };
  },
  LogicalExpression(node, initialScope) {
    const left3224 = getStaticValueR224(node.left, initialScope);
    if (left3224 != null) {
      if (node.operator === "||" && Boolean(left3224.value) === true || node.operator === "&&" && Boolean(left3224.value) === false || node.operator === "??" && left3224.value != null) {
        return left3224;
      }
      const right3224 = getStaticValueR224(node.right, initialScope);
      if (right3224 != null) {
        return right3224;
      }
    }
    return null;
  },
  MemberExpression(node, initialScope) {
    if (node.property.type === "PrivateIdentifier") {
      return null;
    }
    const object222 = getStaticValueR224(node.object, initialScope);
    if (object222 != null) {
      if (object222.value == null && (object222.optional || node.optional)) {
        return { value: void 0, optional: true };
      }
      const property = getStaticPropertyNameValue224(node, initialScope);
      if (property != null) {
        if (!isGetter224(object222.value, property.value)) {
          return { value: object222.value[property.value] };
        }
        for (const [classFn, allowed] of getterAllowed224) {
          if (object222.value instanceof classFn && allowed.has(property.value)) {
            return { value: object222.value[property.value] };
          }
        }
      }
    }
    return null;
  },
  ChainExpression(node, initialScope) {
    const expression = getStaticValueR224(node.expression, initialScope);
    if (expression != null) {
      return { value: expression.value };
    }
    return null;
  },
  NewExpression(node, initialScope) {
    const callee = getStaticValueR224(node.callee, initialScope);
    const args = getElementValues224(node.arguments, initialScope);
    if (callee != null && args != null) {
      const Func = callee.value;
      if (callAllowed224.has(Func)) {
        return { value: new Func(...args) };
      }
    }
    return null;
  },
  ObjectExpression(node, initialScope) {
    const object222 = {};
    for (const propertyNode of node.properties) {
      if (propertyNode.type === "Property") {
        if (propertyNode.kind !== "init") {
          return null;
        }
        const key = getStaticPropertyNameValue224(
          propertyNode,
          initialScope
        );
        const value = getStaticValueR224(propertyNode.value, initialScope);
        if (key == null || value == null) {
          return null;
        }
        object222[key.value] = value.value;
      } else if (propertyNode.type === "SpreadElement" || propertyNode.type === "ExperimentalSpreadProperty") {
        const argument = getStaticValueR224(
          propertyNode.argument,
          initialScope
        );
        if (argument == null) {
          return null;
        }
        Object.assign(object222, argument.value);
      } else {
        return null;
      }
    }
    return { value: object222 };
  },
  SequenceExpression(node, initialScope) {
    const last24 = node.expressions[node.expressions.length - 1];
    return getStaticValueR224(last24, initialScope);
  },
  TaggedTemplateExpression(node, initialScope) {
    const tag = getStaticValueR224(node.tag, initialScope);
    const expressions = getElementValues224(
      node.quasi.expressions,
      initialScope
    );
    if (tag != null && expressions != null) {
      const func = tag.value;
      const strings = node.quasi.quasis.map((q) => q.value.cooked);
      strings.raw = node.quasi.quasis.map((q) => q.value.raw);
      if (func === String.raw) {
        return { value: func(strings, ...expressions) };
      }
    }
    return null;
  },
  TemplateLiteral(node, initialScope) {
    const expressions = getElementValues224(node.expressions, initialScope);
    if (expressions != null) {
      let value = node.quasis[0].value.cooked;
      for (let i2222 = 0; i2222 < expressions.length; ++i2222) {
        value += expressions[i2222];
        value += node.quasis[i2222 + 1].value.cooked;
      }
      return { value };
    }
    return null;
  },
  UnaryExpression(node, initialScope) {
    if (node.operator === "delete") {
      return null;
    }
    if (node.operator === "void") {
      return { value: void 0 };
    }
    const arg = getStaticValueR224(node.argument, initialScope);
    if (arg != null) {
      switch (node.operator) {
        case "-":
          return { value: -arg.value };
        case "+":
          return { value: +arg.value };
        case "!":
          return { value: !arg.value };
        case "~":
          return { value: ~arg.value };
        case "typeof":
          return { value: typeof arg.value };
      }
    }
    return null;
  }
});
function getStaticValueR224(node, initialScope) {
  if (node != null && Object.hasOwnProperty.call(operations224, node.type)) {
    return operations224[node.type](node, initialScope);
  }
  return null;
}
function getStaticPropertyNameValue224(node, initialScope) {
  const nameNode = node.type === "Property" ? node.key : node.property;
  if (node.computed) {
    return getStaticValueR224(nameNode, initialScope);
  }
  if (nameNode.type === "Identifier") {
    return { value: nameNode.name };
  }
  if (nameNode.type === "Literal") {
    if (nameNode.bigint) {
      return { value: nameNode.bigint };
    }
    return { value: String(nameNode.value) };
  }
  return null;
}
function getStaticValue224(node, initialScope = null) {
  try {
    return getStaticValueR224(node, initialScope);
  } catch (_error) {
    return null;
  }
}
function getStringIfConstant224(node, initialScope = null) {
  if (node && node.type === "Literal" && node.value === null) {
    if (node.regex) {
      return `/${node.regex.pattern}/${node.regex.flags}`;
    }
    if (node.bigint) {
      return node.bigint;
    }
  }
  const evaluated = getStaticValue224(node, initialScope);
  return evaluated && String(evaluated.value);
}
function getPropertyName224(node, initialScope) {
  switch (node.type) {
    case "MemberExpression":
      if (node.computed) {
        return getStringIfConstant224(node.property, initialScope);
      }
      if (node.property.type === "PrivateIdentifier") {
        return null;
      }
      return node.property.name;
    case "Property":
    case "MethodDefinition":
    case "PropertyDefinition":
      if (node.computed) {
        return getStringIfConstant224(node.key, initialScope);
      }
      if (node.key.type === "Literal") {
        return String(node.key.value);
      }
      if (node.key.type === "PrivateIdentifier") {
        return null;
      }
      return node.key.name;
  }
  return null;
}
function getFunctionNameWithKind224(node, sourceCode) {
  const parent = node.parent;
  const tokens = [];
  const isObjectMethod = parent.type === "Property" && parent.value === node;
  const isClassMethod = parent.type === "MethodDefinition" && parent.value === node;
  const isClassFieldMethod = parent.type === "PropertyDefinition" && parent.value === node;
  if (isClassMethod || isClassFieldMethod) {
    if (parent.static) {
      tokens.push("static");
    }
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push("private");
    }
  }
  if (node.async) {
    tokens.push("async");
  }
  if (node.generator) {
    tokens.push("generator");
  }
  if (isObjectMethod || isClassMethod) {
    if (parent.kind === "constructor") {
      return "constructor";
    }
    if (parent.kind === "get") {
      tokens.push("getter");
    } else if (parent.kind === "set") {
      tokens.push("setter");
    } else {
      tokens.push("method");
    }
  } else if (isClassFieldMethod) {
    tokens.push("method");
  } else {
    if (node.type === "ArrowFunctionExpression") {
      tokens.push("arrow");
    }
    tokens.push("function");
  }
  if (isObjectMethod || isClassMethod || isClassFieldMethod) {
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push(`#${parent.key.name}`);
    } else {
      const name22 = getPropertyName224(parent);
      if (name22) {
        tokens.push(`'${name22}'`);
      } else if (sourceCode) {
        const keyText = sourceCode.getText(parent.key);
        if (!keyText.includes("\n")) {
          tokens.push(`[${keyText}]`);
        }
      }
    }
  } else if (node.id) {
    tokens.push(`'${node.id.name}'`);
  } else if (parent.type === "VariableDeclarator" && parent.id && parent.id.type === "Identifier") {
    tokens.push(`'${parent.id.name}'`);
  } else if ((parent.type === "AssignmentExpression" || parent.type === "AssignmentPattern") && parent.left && parent.left.type === "Identifier") {
    tokens.push(`'${parent.left.name}'`);
  } else if (parent.type === "ExportDefaultDeclaration" && parent.declaration === node) {
    tokens.push("'default'");
  }
  return tokens.join(" ");
}
var typeConversionBinaryOps224 = Object.freeze(
  /* @__PURE__ */ new Set([
    "==",
    "!=",
    "<",
    "<=",
    ">",
    ">=",
    "<<",
    ">>",
    ">>>",
    "+",
    "-",
    "*",
    "/",
    "%",
    "|",
    "^",
    "&",
    "in"
  ])
);
var typeConversionUnaryOps224 = Object.freeze(/* @__PURE__ */ new Set(["-", "+", "!", "~"]));
function isNode224(x2222) {
  return x2222 !== null && typeof x2222 === "object" && typeof x2222.type === "string";
}
var visitor224 = Object.freeze(
  Object.assign(/* @__PURE__ */ Object.create(null), {
    $visit(node, options, visitorKeys) {
      const { type } = node;
      if (typeof this[type] === "function") {
        return this[type](node, options, visitorKeys);
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    $visitChildren(node, options, visitorKeys) {
      const { type } = node;
      for (const key of visitorKeys[type] || getKeys224(node)) {
        const value = node[key];
        if (Array.isArray(value)) {
          for (const element of value) {
            if (isNode224(element) && this.$visit(element, options, visitorKeys)) {
              return true;
            }
          }
        } else if (isNode224(value) && this.$visit(value, options, visitorKeys)) {
          return true;
        }
      }
      return false;
    },
    ArrowFunctionExpression() {
      return false;
    },
    AssignmentExpression() {
      return true;
    },
    AwaitExpression() {
      return true;
    },
    BinaryExpression(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && typeConversionBinaryOps224.has(node.operator) && (node.left.type !== "Literal" || node.right.type !== "Literal")) {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    CallExpression() {
      return true;
    },
    FunctionExpression() {
      return false;
    },
    ImportExpression() {
      return true;
    },
    MemberExpression(node, options, visitorKeys) {
      if (options.considerGetters) {
        return true;
      }
      if (options.considerImplicitTypeConversion && node.computed && node.property.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    MethodDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    NewExpression() {
      return true;
    },
    Property(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    PropertyDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UnaryExpression(node, options, visitorKeys) {
      if (node.operator === "delete") {
        return true;
      }
      if (options.considerImplicitTypeConversion && typeConversionUnaryOps224.has(node.operator) && node.argument.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UpdateExpression() {
      return true;
    },
    YieldExpression() {
      return true;
    }
  })
);
function hasSideEffect224(node, sourceCode, { considerGetters = false, considerImplicitTypeConversion = false } = {}) {
  return visitor224.$visit(
    node,
    { considerGetters, considerImplicitTypeConversion },
    sourceCode.visitorKeys || visitor_keys_default224
  );
}
function getParentSyntaxParen224(node, sourceCode) {
  const parent = node.parent;
  switch (parent.type) {
    case "CallExpression":
    case "NewExpression":
      if (parent.arguments.length === 1 && parent.arguments[0] === node) {
        return sourceCode.getTokenAfter(
          parent.callee,
          isOpeningParenToken224
        );
      }
      return null;
    case "DoWhileStatement":
      if (parent.test === node) {
        return sourceCode.getTokenAfter(
          parent.body,
          isOpeningParenToken224
        );
      }
      return null;
    case "IfStatement":
    case "WhileStatement":
      if (parent.test === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "ImportExpression":
      if (parent.source === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "SwitchStatement":
      if (parent.discriminant === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "WithStatement":
      if (parent.object === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    default:
      return null;
  }
}
function isParenthesized224(timesOrNode, nodeOrSourceCode, optionalSourceCode) {
  let times, node, sourceCode, maybeLeftParen, maybeRightParen;
  if (typeof timesOrNode === "number") {
    times = timesOrNode | 0;
    node = nodeOrSourceCode;
    sourceCode = optionalSourceCode;
    if (!(times >= 1)) {
      throw new TypeError("'times' should be a positive integer.");
    }
  } else {
    times = 1;
    node = timesOrNode;
    sourceCode = nodeOrSourceCode;
  }
  if (node == null || // `Program` can't be parenthesized
  node.parent == null || // `CatchClause.param` can't be parenthesized, example `try {} catch (error) {}`
  node.parent.type === "CatchClause" && node.parent.param === node) {
    return false;
  }
  maybeLeftParen = maybeRightParen = node;
  do {
    maybeLeftParen = sourceCode.getTokenBefore(maybeLeftParen);
    maybeRightParen = sourceCode.getTokenAfter(maybeRightParen);
  } while (maybeLeftParen != null && maybeRightParen != null && isOpeningParenToken224(maybeLeftParen) && isClosingParenToken224(maybeRightParen) && // Avoid false positive such as `if (a) {}`
  maybeLeftParen !== getParentSyntaxParen224(node, sourceCode) && --times > 0);
  return times === 0;
}
Function.call.bind(Object.hasOwnProperty);
var __defProp22224 = Object.defineProperty;
var __export22224 = (target, all3224) => {
  for (var name22 in all3224)
    __defProp22224(target, name22, { get: all3224[name22], enumerable: true });
};
var NodeType224 = types.AST_NODE_TYPES;
var is224 = utils.ASTUtils.isNodeOfType;
var isOneOf224 = utils.ASTUtils.isNodeOfTypes;
isOneOf224([
  NodeType224.ArrowFunctionExpression,
  NodeType224.FunctionDeclaration,
  NodeType224.FunctionExpression
]);
isOneOf224([
  NodeType224.ArrowFunctionExpression,
  NodeType224.FunctionDeclaration,
  NodeType224.FunctionExpression,
  NodeType224.TSCallSignatureDeclaration,
  NodeType224.TSConstructSignatureDeclaration,
  NodeType224.TSDeclareFunction,
  NodeType224.TSEmptyBodyFunctionExpression,
  NodeType224.TSFunctionType,
  NodeType224.TSMethodSignature
]);
isOneOf224([NodeType224.ClassDeclaration, NodeType224.ClassExpression]);
isOneOf224([
  NodeType224.DoWhileStatement,
  NodeType224.ForInStatement,
  NodeType224.ForOfStatement,
  NodeType224.ForStatement,
  NodeType224.WhileStatement
]);
isOneOf224([NodeType224.TSArrayType, NodeType224.TSTupleType]);
isOneOf224([
  NodeType224.PropertyDefinition,
  NodeType224.TSIndexSignature,
  NodeType224.TSParameterProperty,
  NodeType224.TSPropertySignature
]);
is224(NodeType224.JSXElement);
is224(NodeType224.JSXFragment);
isOneOf224([
  NodeType224.JSXAttribute,
  NodeType224.JSXSpreadChild,
  NodeType224.JSXClosingElement,
  NodeType224.JSXClosingFragment,
  NodeType224.JSXElement,
  NodeType224.JSXEmptyExpression,
  NodeType224.JSXExpressionContainer,
  NodeType224.JSXFragment,
  NodeType224.JSXIdentifier,
  NodeType224.JSXMemberExpression,
  NodeType224.JSXNamespacedName,
  NodeType224.JSXOpeningElement,
  NodeType224.JSXOpeningFragment,
  NodeType224.JSXSpreadAttribute,
  NodeType224.JSXSpreadChild,
  NodeType224.JSXText
]);
isOneOf224([
  NodeType224.JSXIdentifier,
  NodeType224.JSXMemberExpression,
  NodeType224.JSXNamespacedName
]);
isOneOf224([
  NodeType224.ArrayPattern,
  NodeType224.AssignmentPattern,
  NodeType224.ObjectPattern,
  NodeType224.RestElement
]);
isOneOf224([
  NodeType224.TSInterfaceDeclaration,
  NodeType224.TSTypeAliasDeclaration
]);
isOneOf224([
  NodeType224.ArrayExpression,
  NodeType224.ArrayPattern,
  NodeType224.ArrowFunctionExpression,
  NodeType224.CallExpression,
  NodeType224.ClassExpression,
  NodeType224.FunctionExpression,
  NodeType224.Identifier,
  NodeType224.JSXElement,
  NodeType224.JSXFragment,
  NodeType224.Literal,
  NodeType224.TemplateLiteral,
  NodeType224.MemberExpression,
  NodeType224.MetaProperty,
  NodeType224.ObjectExpression,
  NodeType224.ObjectPattern,
  NodeType224.SequenceExpression,
  NodeType224.Super,
  NodeType224.TaggedTemplateExpression,
  NodeType224.ThisExpression
]);
isOneOf224([
  NodeType224.ArrayExpression,
  NodeType224.ArrayPattern,
  NodeType224.ArrowFunctionExpression,
  NodeType224.CallExpression,
  NodeType224.ClassExpression,
  NodeType224.FunctionExpression,
  NodeType224.Identifier,
  NodeType224.JSXElement,
  NodeType224.JSXFragment,
  NodeType224.Literal,
  NodeType224.TemplateLiteral,
  NodeType224.MemberExpression,
  NodeType224.MetaProperty,
  NodeType224.ObjectExpression,
  NodeType224.ObjectPattern,
  NodeType224.SequenceExpression,
  NodeType224.Super,
  NodeType224.TaggedTemplateExpression,
  NodeType224.ThisExpression,
  NodeType224.TSAsExpression,
  NodeType224.TSNonNullExpression,
  NodeType224.TSTypeAssertion
]);
var Function_exports2224 = {};
__export22224(Function_exports2224, {
  SK: () => SK2224,
  absurd: () => absurd2224,
  apply: () => apply2224,
  compose: () => compose2224,
  constFalse: () => constFalse2224,
  constNull: () => constNull2224,
  constTrue: () => constTrue2224,
  constUndefined: () => constUndefined2224,
  constVoid: () => constVoid2224,
  constant: () => constant2224,
  dual: () => dual2224,
  flip: () => flip2224,
  flow: () => flow2224,
  hole: () => hole2224,
  identity: () => identity2224,
  isFunction: () => isFunction22224,
  pipe: () => pipe2224,
  satisfies: () => satisfies2224,
  tupled: () => tupled2224,
  unsafeCoerce: () => unsafeCoerce2224,
  untupled: () => untupled2224
});
var isFunction22224 = (input) => typeof input === "function";
var dual2224 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a2222, b2222) {
        if (arguments.length >= 2) {
          return body(a2222, b2222);
        }
        return function(self2) {
          return body(self2, a2222);
        };
      };
    case 3:
      return function(a2222, b2222, c2222) {
        if (arguments.length >= 3) {
          return body(a2222, b2222, c2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222);
        };
      };
    case 4:
      return function(a2222, b2222, c2222, d2222) {
        if (arguments.length >= 4) {
          return body(a2222, b2222, c2222, d2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222);
        };
      };
    case 5:
      return function(a2222, b2222, c2222, d2222, e2222) {
        if (arguments.length >= 5) {
          return body(a2222, b2222, c2222, d2222, e2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222, d2222);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply2224 = (a2222) => (self2) => self2(a2222);
var identity2224 = (a2222) => a2222;
var satisfies2224 = () => (b2222) => b2222;
var unsafeCoerce2224 = identity2224;
var constant2224 = (value) => () => value;
var constTrue2224 = /* @__PURE__ */ constant2224(true);
var constFalse2224 = /* @__PURE__ */ constant2224(false);
var constNull2224 = /* @__PURE__ */ constant2224(null);
var constUndefined2224 = /* @__PURE__ */ constant2224(void 0);
var constVoid2224 = constUndefined2224;
var flip2224 = (f2222) => (...b2222) => (...a2222) => f2222(...a2222)(...b2222);
var compose2224 = /* @__PURE__ */ dual2224(2, (ab, bc) => (a2222) => bc(ab(a2222)));
var absurd2224 = (_2222) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled2224 = (f2222) => (a2222) => f2222(...a2222);
var untupled2224 = (f2222) => (...a2222) => f2222(a2222);
function pipe2224(a2222, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a2222;
    case 2:
      return ab(a2222);
    case 3:
      return bc(ab(a2222));
    case 4:
      return cd(bc(ab(a2222)));
    case 5:
      return de(cd(bc(ab(a2222))));
    case 6:
      return ef(de(cd(bc(ab(a2222)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a2222))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a2222)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a2222))))))));
    default: {
      let ret = arguments[0];
      for (let i2222 = 1; i2222 < arguments.length; i2222++) {
        ret = arguments[i2222](ret);
      }
      return ret;
    }
  }
}
function flow2224(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole2224 = /* @__PURE__ */ unsafeCoerce2224(absurd2224);
var SK2224 = (_2222, b2222) => b2222;
var make4224 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_3224 = (map622) => dual2224(3, (self2, name22, f2222) => map622(self2, (a2222) => Object.assign({}, a2222, {
  [name22]: f2222(a2222)
})));
var bindTo3224 = (map622) => dual2224(2, (self2, name22) => map622(self2, (a2222) => ({
  [name22]: a2222
})));
var bind3224 = (map622, flatMap424) => dual2224(3, (self2, name22, f2222) => flatMap424(self2, (a2222) => map622(f2222(a2222), (b2222) => Object.assign({}, a2222, {
  [name22]: b2222
}))));
var moduleVersion2224 = "3.2.8";
var getCurrentVersion2224 = () => moduleVersion2224;
var globalStoreId2224 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion2224()}`);
if (!(globalStoreId2224 in globalThis)) {
  globalThis[globalStoreId2224] = /* @__PURE__ */ new Map();
}
var globalStore2224 = globalThis[globalStoreId2224];
var globalValue2224 = (id, compute) => {
  if (!globalStore2224.has(id)) {
    globalStore2224.set(id, compute());
  }
  return globalStore2224.get(id);
};
var Predicate_exports2224 = {};
__export22224(Predicate_exports2224, {
  all: () => all2224,
  and: () => and34,
  compose: () => compose22224,
  eqv: () => eqv34,
  every: () => every44,
  hasProperty: () => hasProperty2224,
  implies: () => implies34,
  isBigInt: () => isBigInt34,
  isBoolean: () => isBoolean34,
  isDate: () => isDate34,
  isError: () => isError34,
  isFunction: () => isFunction3224,
  isIterable: () => isIterable34,
  isMap: () => isMap34,
  isNever: () => isNever34,
  isNotNull: () => isNotNull34,
  isNotNullable: () => isNotNullable34,
  isNotUndefined: () => isNotUndefined34,
  isNull: () => isNull34,
  isNullable: () => isNullable2224,
  isNumber: () => isNumber34,
  isObject: () => isObject2224,
  isPromise: () => isPromise34,
  isPromiseLike: () => isPromiseLike34,
  isReadonlyRecord: () => isReadonlyRecord34,
  isRecord: () => isRecord34,
  isSet: () => isSet34,
  isString: () => isString34,
  isSymbol: () => isSymbol34,
  isTagged: () => isTagged34,
  isTruthy: () => isTruthy34,
  isUint8Array: () => isUint8Array34,
  isUndefined: () => isUndefined34,
  isUnknown: () => isUnknown34,
  mapInput: () => mapInput44,
  nand: () => nand34,
  nor: () => nor34,
  not: () => not34,
  or: () => or34,
  product: () => product2224,
  productMany: () => productMany2224,
  some: () => some3224,
  struct: () => struct54,
  tuple: () => tuple44,
  xor: () => xor34
});
var mapInput44 = /* @__PURE__ */ dual2224(2, (self2, f2222) => (b2222) => self2(f2222(b2222)));
var isTruthy34 = (input) => !!input;
var isSet34 = (input) => input instanceof Set;
var isMap34 = (input) => input instanceof Map;
var isString34 = (input) => typeof input === "string";
var isNumber34 = (input) => typeof input === "number";
var isBoolean34 = (input) => typeof input === "boolean";
var isBigInt34 = (input) => typeof input === "bigint";
var isSymbol34 = (input) => typeof input === "symbol";
var isFunction3224 = isFunction22224;
var isUndefined34 = (input) => input === void 0;
var isNotUndefined34 = (input) => input !== void 0;
var isNull34 = (input) => input === null;
var isNotNull34 = (input) => input !== null;
var isNever34 = (_2222) => false;
var isUnknown34 = (_2222) => true;
var isRecordOrArray2224 = (input) => typeof input === "object" && input !== null;
var isObject2224 = (input) => isRecordOrArray2224(input) || isFunction3224(input);
var hasProperty2224 = /* @__PURE__ */ dual2224(2, (self2, property) => isObject2224(self2) && property in self2);
var isTagged34 = /* @__PURE__ */ dual2224(2, (self2, tag) => hasProperty2224(self2, "_tag") && self2["_tag"] === tag);
var isNullable2224 = (input) => input === null || input === void 0;
var isNotNullable34 = (input) => input !== null && input !== void 0;
var isError34 = (input) => input instanceof Error;
var isUint8Array34 = (input) => input instanceof Uint8Array;
var isDate34 = (input) => input instanceof Date;
var isIterable34 = (input) => hasProperty2224(input, Symbol.iterator);
var isRecord34 = (input) => isRecordOrArray2224(input) && !Array.isArray(input);
var isReadonlyRecord34 = isRecord34;
var isPromise34 = (input) => hasProperty2224(input, "then") && "catch" in input && isFunction3224(input.then) && isFunction3224(input.catch);
var isPromiseLike34 = (input) => hasProperty2224(input, "then") && isFunction3224(input.then);
var compose22224 = /* @__PURE__ */ dual2224(2, (ab, bc) => (a2222) => ab(a2222) && bc(a2222));
var product2224 = (self2, that) => ([a2222, b2222]) => self2(a2222) && that(b2222);
var all2224 = (collection) => {
  return (as22224) => {
    let collectionIndex = 0;
    for (const p2222 of collection) {
      if (collectionIndex >= as22224.length) {
        break;
      }
      if (p2222(as22224[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany2224 = (self2, collection) => {
  const rest = all2224(collection);
  return ([head222, ...tail222]) => self2(head222) === false ? false : rest(tail222);
};
var tuple44 = (...elements) => all2224(elements);
var struct54 = (fields) => {
  const keys2224 = Object.keys(fields);
  return (a2222) => {
    for (const key of keys2224) {
      if (!fields[key](a2222[key])) {
        return false;
      }
    }
    return true;
  };
};
var not34 = (self2) => (a2222) => !self2(a2222);
var or34 = /* @__PURE__ */ dual2224(2, (self2, that) => (a2222) => self2(a2222) || that(a2222));
var and34 = /* @__PURE__ */ dual2224(2, (self2, that) => (a2222) => self2(a2222) && that(a2222));
var xor34 = /* @__PURE__ */ dual2224(2, (self2, that) => (a2222) => self2(a2222) !== that(a2222));
var eqv34 = /* @__PURE__ */ dual2224(2, (self2, that) => (a2222) => self2(a2222) === that(a2222));
var implies34 = /* @__PURE__ */ dual2224(2, (self2, that) => (a2222) => self2(a2222) ? that(a2222) : true);
var nor34 = /* @__PURE__ */ dual2224(2, (self2, that) => (a2222) => !(self2(a2222) || that(a2222)));
var nand34 = /* @__PURE__ */ dual2224(2, (self2, that) => (a2222) => !(self2(a2222) && that(a2222)));
var every44 = (collection) => (a2222) => {
  for (const p2222 of collection) {
    if (!p2222(a2222)) {
      return false;
    }
  }
  return true;
};
var some3224 = (collection) => (a2222) => {
  for (const p2222 of collection) {
    if (p2222(a2222)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage2224 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId2224 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind2224 = (u2222) => isObject2224(u2222) && GenKindTypeId2224 in u2222;
var GenKindImpl2224 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity2224;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId2224] = GenKindTypeId2224;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen2224(this);
  }
};
var SingleShotGen2224 = class _SingleShotGen44 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a2222) {
    return this.called ? {
      value: a2222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a2222) {
    return {
      value: a2222,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e2222) {
    throw e2222;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen44(this.self);
  }
};
var adapter3224 = () => function() {
  let x2222 = arguments[0];
  for (let i2222 = 1; i2222 < arguments.length; i2222++) {
    x2222 = arguments[i2222](x2222);
  }
  return new GenKindImpl2224(x2222);
};
var defaultIncHi2224 = 335903614;
var defaultIncLo2224 = 4150755663;
var MUL_HI2224 = 1481765933 >>> 0;
var MUL_LO2224 = 1284865837 >>> 0;
var BIT_532224 = 9007199254740992;
var BIT_272224 = 134217728;
var PCGRandom2224 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable2224(seedLo) && isNullable2224(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable2224(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable2224(incLo) && isNullable2224(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo2224;
      incHi = this._state ? this._state[2] : defaultIncHi2224;
    } else if (isNullable2224(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add642224(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max34) {
    if (!max34) {
      return this._next();
    }
    max34 = max34 >>> 0;
    if ((max34 & max34 - 1) === 0) {
      return this._next() & max34 - 1;
    }
    let num = 0;
    const skew = (-max34 >>> 0) % max34 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max34;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_272224 + lo) / BIT_532224;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul642224(this._state, oldHi, oldLo, MUL_HI2224, MUL_LO2224);
    add642224(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul642224(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add642224(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId2224 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap2224 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId2224]() {
    return this.#value;
  }
};
function yieldWrapGet2224(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId2224 in self2) {
    return self2[YieldWrapTypeId2224]();
  }
  throw new Error(getBugErrorMessage2224("yieldWrapGet"));
}
var structuralRegionState2224 = /* @__PURE__ */ globalValue2224("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache2224 = /* @__PURE__ */ globalValue2224(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr2224 = /* @__PURE__ */ globalValue2224(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom2224());
var symbol3224 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash2224 = (self2) => {
  if (structuralRegionState2224.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number2224(self2);
    case "bigint":
      return string2224(self2.toString(10));
    case "boolean":
      return string2224(String(self2));
    case "symbol":
      return string2224(String(self2));
    case "string":
      return string2224(self2);
    case "undefined":
      return string2224("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string2224("null");
      } else if (self2 instanceof Date) {
        return hash2224(self2.toISOString());
      } else if (isHash2224(self2)) {
        return self2[symbol3224]();
      } else {
        return random2224(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random2224 = (self2) => {
  if (!randomHashCache2224.has(self2)) {
    randomHashCache2224.set(self2, number2224(pcgr2224.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache2224.get(self2);
};
var combine2224 = (b2222) => (self2) => self2 * 53 ^ b2222;
var optimize2224 = (n2222) => n2222 & 3221225471 | n2222 >>> 1 & 1073741824;
var isHash2224 = (u2222) => hasProperty2224(u2222, symbol3224);
var number2224 = (n2222) => {
  if (n2222 !== n2222 || n2222 === Infinity) {
    return 0;
  }
  let h2222 = n2222 | 0;
  if (h2222 !== n2222) {
    h2222 ^= n2222 * 4294967295;
  }
  while (n2222 > 4294967295) {
    h2222 ^= n2222 /= 4294967295;
  }
  return optimize2224(n2222);
};
var string2224 = (str) => {
  let h2222 = 5381, i2222 = str.length;
  while (i2222) {
    h2222 = h2222 * 33 ^ str.charCodeAt(--i2222);
  }
  return optimize2224(h2222);
};
var structureKeys224 = (o2222, keys2224) => {
  let h2222 = 12289;
  for (let i2222 = 0; i2222 < keys2224.length; i2222++) {
    h2222 ^= pipe2224(string2224(keys2224[i2222]), combine2224(hash2224(o2222[keys2224[i2222]])));
  }
  return optimize2224(h2222);
};
var structure224 = (o2222) => structureKeys224(o2222, Object.keys(o2222));
var array54 = (arr) => {
  let h2222 = 6151;
  for (let i2222 = 0; i2222 < arr.length; i2222++) {
    h2222 = pipe2224(h2222, combine2224(hash2224(arr[i2222])));
  }
  return optimize2224(h2222);
};
var cached2224 = function() {
  if (arguments.length === 1) {
    const self22 = arguments[0];
    return function(hash324) {
      Object.defineProperty(self22, symbol3224, {
        value() {
          return hash324;
        },
        enumerable: false
      });
      return hash324;
    };
  }
  const self2 = arguments[0];
  const hash22224 = arguments[1];
  Object.defineProperty(self2, symbol3224, {
    value() {
      return hash22224;
    },
    enumerable: false
  });
  return hash22224;
};
var symbol22224 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals2224() {
  if (arguments.length === 1) {
    return (self2) => compareBoth2224(self2, arguments[0]);
  }
  return compareBoth2224(arguments[0], arguments[1]);
}
function compareBoth2224(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual2224(self2) && isEqual2224(that)) {
        if (hash2224(self2) === hash2224(that) && self2[symbol22224](that)) {
          return true;
        } else {
          return structuralRegionState2224.enabled && structuralRegionState2224.tester ? structuralRegionState2224.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState2224.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v2222, i2222) => compareBoth2224(v2222, that[i2222]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth2224(self2[key], that[key]))) {
              return structuralRegionState2224.tester ? structuralRegionState2224.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState2224.tester ? structuralRegionState2224.tester(self2, that) : false;
    }
  }
  return structuralRegionState2224.enabled && structuralRegionState2224.tester ? structuralRegionState2224.tester(self2, that) : false;
}
var isEqual2224 = (u2222) => hasProperty2224(u2222, symbol22224);
var equivalence2224 = () => equals2224;
var NodeInspectSymbol2224 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON2224 = (x2222) => {
  if (hasProperty2224(x2222, "toJSON") && isFunction3224(x2222["toJSON"]) && x2222["toJSON"].length === 0) {
    return x2222.toJSON();
  } else if (Array.isArray(x2222)) {
    return x2222.map(toJSON2224);
  }
  return x2222;
};
var format2224 = (x2222) => JSON.stringify(x2222, null, 2);
var pipeArguments2224 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i2222 = 0, len = args.length; i2222 < len; i2222++) {
        ret = args[i2222](ret);
      }
      return ret;
    }
  }
};
var OP_COMMIT224 = "Commit";
var OP_FAILURE224 = "Failure";
var OP_WITH_RUNTIME224 = "WithRuntime";
var EffectTypeId2224 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId2224 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId2224 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId2224 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance2224 = {
  /* c8 ignore next */
  _R: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _A: (_2222) => _2222,
  _V: /* @__PURE__ */ getCurrentVersion2224()
};
var sinkVariance2224 = {
  /* c8 ignore next */
  _A: (_2222) => _2222,
  /* c8 ignore next */
  _In: (_2222) => _2222,
  /* c8 ignore next */
  _L: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _R: (_2222) => _2222
};
var channelVariance2224 = {
  /* c8 ignore next */
  _Env: (_2222) => _2222,
  /* c8 ignore next */
  _InErr: (_2222) => _2222,
  /* c8 ignore next */
  _InElem: (_2222) => _2222,
  /* c8 ignore next */
  _InDone: (_2222) => _2222,
  /* c8 ignore next */
  _OutErr: (_2222) => _2222,
  /* c8 ignore next */
  _OutElem: (_2222) => _2222,
  /* c8 ignore next */
  _OutDone: (_2222) => _2222
};
var EffectPrototype2224 = {
  [EffectTypeId2224]: effectVariance2224,
  [StreamTypeId2224]: effectVariance2224,
  [SinkTypeId2224]: sinkVariance2224,
  [ChannelTypeId2224]: channelVariance2224,
  [symbol22224](that) {
    return this === that;
  },
  [symbol3224]() {
    return cached2224(this, random2224(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen2224(new YieldWrap2224(this));
  },
  pipe() {
    return pipeArguments2224(this, arguments);
  }
};
var StructuralPrototype224 = {
  [symbol3224]() {
    return cached2224(this, structure224(this));
  },
  [symbol22224](that) {
    const selfKeys = Object.keys(this);
    const thatKeys = Object.keys(that);
    if (selfKeys.length !== thatKeys.length) {
      return false;
    }
    for (const key of selfKeys) {
      if (!(key in that && equals2224(this[key], that[key]))) {
        return false;
      }
    }
    return true;
  }
};
var CommitPrototype224 = {
  ...EffectPrototype2224,
  _op: OP_COMMIT224
};
var StructuralCommitPrototype224 = {
  ...CommitPrototype224,
  ...StructuralPrototype224
};
var TypeId5224 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto3224 = {
  ...EffectPrototype2224,
  [TypeId5224]: {
    _A: (_2222) => _2222
  },
  [NodeInspectSymbol2224]() {
    return this.toJSON();
  },
  toString() {
    return format2224(this.toJSON());
  }
};
var SomeProto2224 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto3224), {
  _tag: "Some",
  _op: "Some",
  [symbol22224](that) {
    return isOption3224(that) && isSome3224(that) && equals2224(this.value, that.value);
  },
  [symbol3224]() {
    return cached2224(this, combine2224(hash2224(this._tag))(hash2224(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON2224(this.value)
    };
  }
});
var NoneHash2224 = /* @__PURE__ */ hash2224("None");
var NoneProto2224 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto3224), {
  _tag: "None",
  _op: "None",
  [symbol22224](that) {
    return isOption3224(that) && isNone3224(that);
  },
  [symbol3224]() {
    return NoneHash2224;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption3224 = (input) => hasProperty2224(input, TypeId5224);
var isNone3224 = (fa) => fa._tag === "None";
var isSome3224 = (fa) => fa._tag === "Some";
var none3224 = /* @__PURE__ */ Object.create(NoneProto2224);
var some22224 = (value) => {
  const a2222 = Object.create(SomeProto2224);
  a2222.value = value;
  return a2222;
};
var TypeId22224 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto22224 = {
  ...EffectPrototype2224,
  [TypeId22224]: {
    _R: (_2222) => _2222
  },
  [NodeInspectSymbol2224]() {
    return this.toJSON();
  },
  toString() {
    return format2224(this.toJSON());
  }
};
var RightProto2224 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto22224), {
  _tag: "Right",
  _op: "Right",
  [symbol22224](that) {
    return isEither2224(that) && isRight2224(that) && equals2224(this.right, that.right);
  },
  [symbol3224]() {
    return combine2224(hash2224(this._tag))(hash2224(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON2224(this.right)
    };
  }
});
var LeftProto2224 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto22224), {
  _tag: "Left",
  _op: "Left",
  [symbol22224](that) {
    return isEither2224(that) && isLeft2224(that) && equals2224(this.left, that.left);
  },
  [symbol3224]() {
    return combine2224(hash2224(this._tag))(hash2224(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON2224(this.left)
    };
  }
});
var isEither2224 = (input) => hasProperty2224(input, TypeId22224);
var isLeft2224 = (ma) => ma._tag === "Left";
var isRight2224 = (ma) => ma._tag === "Right";
var left2224 = (left3224) => {
  const a2222 = Object.create(LeftProto2224);
  a2222.left = left3224;
  return a2222;
};
var right2224 = (right3224) => {
  const a2222 = Object.create(RightProto2224);
  a2222.right = right3224;
  return a2222;
};
var getLeft3224 = (self2) => isRight2224(self2) ? none3224 : some22224(self2.left);
var getRight3224 = (self2) => isLeft2224(self2) ? none3224 : some22224(self2.right);
var right22224 = right2224;
var left22224 = left2224;
var Option_exports2224 = {};
__export22224(Option_exports2224, {
  Do: () => Do2224,
  TypeId: () => TypeId32224,
  all: () => all22224,
  andThen: () => andThen2224,
  ap: () => ap2224,
  as: () => as2224,
  asVoid: () => asVoid2224,
  bind: () => bind22224,
  bindTo: () => bindTo22224,
  composeK: () => composeK2224,
  contains: () => contains2224,
  containsWith: () => containsWith2224,
  exists: () => exists2224,
  filter: () => filter2224,
  filterMap: () => filterMap2224,
  firstSomeOf: () => firstSomeOf2224,
  flatMap: () => flatMap2224,
  flatMapNullable: () => flatMapNullable2224,
  flatten: () => flatten2224,
  fromIterable: () => fromIterable2224,
  fromNullable: () => fromNullable2224,
  gen: () => gen2224,
  getEquivalence: () => getEquivalence2224,
  getLeft: () => getLeft22224,
  getOrElse: () => getOrElse2224,
  getOrNull: () => getOrNull2224,
  getOrThrow: () => getOrThrow2224,
  getOrThrowWith: () => getOrThrowWith2224,
  getOrUndefined: () => getOrUndefined2224,
  getOrder: () => getOrder2224,
  getRight: () => getRight22224,
  isNone: () => isNone22224,
  isOption: () => isOption22224,
  isSome: () => isSome22224,
  let: () => let_22224,
  lift2: () => lift22224,
  liftNullable: () => liftNullable2224,
  liftPredicate: () => liftPredicate2224,
  liftThrowable: () => liftThrowable2224,
  map: () => map2224,
  match: () => match2224,
  none: () => none22224,
  orElse: () => orElse2224,
  orElseEither: () => orElseEither2224,
  orElseSome: () => orElseSome2224,
  partitionMap: () => partitionMap2224,
  product: () => product22224,
  productMany: () => productMany22224,
  reduceCompact: () => reduceCompact2224,
  some: () => some32224,
  tap: () => tap2224,
  toArray: () => toArray2224,
  toRefinement: () => toRefinement2224,
  void: () => void_2224,
  zipLeft: () => zipLeft2224,
  zipRight: () => zipRight2224,
  zipWith: () => zipWith2224
});
var make22224 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId32224 = /* @__PURE__ */ Symbol.for("effect/Option");
var none22224 = () => none3224;
var some32224 = some22224;
var isOption22224 = isOption3224;
var isNone22224 = isNone3224;
var isSome22224 = isSome3224;
var match2224 = /* @__PURE__ */ dual2224(2, (self2, {
  onNone,
  onSome
}) => isNone22224(self2) ? onNone() : onSome(self2.value));
var toRefinement2224 = (f2222) => (a2222) => isSome22224(f2222(a2222));
var fromIterable2224 = (collection) => {
  for (const a2222 of collection) {
    return some32224(a2222);
  }
  return none22224();
};
var getRight22224 = getRight3224;
var getLeft22224 = getLeft3224;
var getOrElse2224 = /* @__PURE__ */ dual2224(2, (self2, onNone) => isNone22224(self2) ? onNone() : self2.value);
var orElse2224 = /* @__PURE__ */ dual2224(2, (self2, that) => isNone22224(self2) ? that() : self2);
var orElseSome2224 = /* @__PURE__ */ dual2224(2, (self2, onNone) => isNone22224(self2) ? some32224(onNone()) : self2);
var orElseEither2224 = /* @__PURE__ */ dual2224(2, (self2, that) => isNone22224(self2) ? map2224(that(), right2224) : map2224(self2, left2224));
var firstSomeOf2224 = (collection) => {
  let out = none22224();
  for (out of collection) {
    if (isSome22224(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable2224 = (nullableValue) => nullableValue == null ? none22224() : some32224(nullableValue);
var liftNullable2224 = (f2222) => (...a2222) => fromNullable2224(f2222(...a2222));
var getOrNull2224 = /* @__PURE__ */ getOrElse2224(constNull2224);
var getOrUndefined2224 = /* @__PURE__ */ getOrElse2224(constUndefined2224);
var liftThrowable2224 = (f2222) => (...a2222) => {
  try {
    return some32224(f2222(...a2222));
  } catch (e2222) {
    return none22224();
  }
};
var getOrThrowWith2224 = /* @__PURE__ */ dual2224(2, (self2, onNone) => {
  if (isSome22224(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow2224 = /* @__PURE__ */ getOrThrowWith2224(() => new Error("getOrThrow called on a None"));
var map2224 = /* @__PURE__ */ dual2224(2, (self2, f2222) => isNone22224(self2) ? none22224() : some32224(f2222(self2.value)));
var as2224 = /* @__PURE__ */ dual2224(2, (self2, b2222) => map2224(self2, () => b2222));
var asVoid2224 = /* @__PURE__ */ as2224(void 0);
var void_2224 = /* @__PURE__ */ some32224(void 0);
var flatMap2224 = /* @__PURE__ */ dual2224(2, (self2, f2222) => isNone22224(self2) ? none22224() : f2222(self2.value));
var andThen2224 = /* @__PURE__ */ dual2224(2, (self2, f2222) => flatMap2224(self2, (a2222) => {
  const b2222 = isFunction22224(f2222) ? f2222(a2222) : f2222;
  return isOption22224(b2222) ? b2222 : some32224(b2222);
}));
var flatMapNullable2224 = /* @__PURE__ */ dual2224(2, (self2, f2222) => isNone22224(self2) ? none22224() : fromNullable2224(f2222(self2.value)));
var flatten2224 = /* @__PURE__ */ flatMap2224(identity2224);
var zipRight2224 = /* @__PURE__ */ dual2224(2, (self2, that) => flatMap2224(self2, () => that));
var composeK2224 = /* @__PURE__ */ dual2224(2, (afb, bfc) => (a2222) => flatMap2224(afb(a2222), bfc));
var zipLeft2224 = /* @__PURE__ */ dual2224(2, (self2, that) => tap2224(self2, () => that));
var tap2224 = /* @__PURE__ */ dual2224(2, (self2, f2222) => flatMap2224(self2, (a2222) => map2224(f2222(a2222), () => a2222)));
var product22224 = (self2, that) => isSome22224(self2) && isSome22224(that) ? some32224([self2.value, that.value]) : none22224();
var productMany22224 = (self2, collection) => {
  if (isNone22224(self2)) {
    return none22224();
  }
  const out = [self2.value];
  for (const o2222 of collection) {
    if (isNone22224(o2222)) {
      return none22224();
    }
    out.push(o2222.value);
  }
  return some32224(out);
};
var all22224 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o2222 of input) {
      if (isNone22224(o2222)) {
        return none22224();
      }
      out2.push(o2222.value);
    }
    return some32224(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o2222 = input[key];
    if (isNone22224(o2222)) {
      return none22224();
    }
    out[key] = o2222.value;
  }
  return some32224(out);
};
var zipWith2224 = /* @__PURE__ */ dual2224(3, (self2, that, f2222) => map2224(product22224(self2, that), ([a2222, b2222]) => f2222(a2222, b2222)));
var ap2224 = /* @__PURE__ */ dual2224(2, (self2, that) => zipWith2224(self2, that, (f2222, a2222) => f2222(a2222)));
var reduceCompact2224 = /* @__PURE__ */ dual2224(3, (self2, b2222, f2222) => {
  let out = b2222;
  for (const oa of self2) {
    if (isSome22224(oa)) {
      out = f2222(out, oa.value);
    }
  }
  return out;
});
var toArray2224 = (self2) => isNone22224(self2) ? [] : [self2.value];
var partitionMap2224 = /* @__PURE__ */ dual2224(2, (self2, f2222) => {
  if (isNone22224(self2)) {
    return [none22224(), none22224()];
  }
  const e2222 = f2222(self2.value);
  return isLeft2224(e2222) ? [some32224(e2222.left), none22224()] : [none22224(), some32224(e2222.right)];
});
var filterMap2224 = /* @__PURE__ */ dual2224(2, (self2, f2222) => isNone22224(self2) ? none22224() : f2222(self2.value));
var filter2224 = /* @__PURE__ */ dual2224(2, (self2, predicate) => filterMap2224(self2, (b2222) => predicate(b2222) ? some22224(b2222) : none3224));
var getEquivalence2224 = (isEquivalent) => make4224((x2222, y2222) => x2222 === y2222 || (isNone22224(x2222) ? isNone22224(y2222) : isNone22224(y2222) ? false : isEquivalent(x2222.value, y2222.value)));
var getOrder2224 = (O2222) => make22224((self2, that) => isSome22224(self2) ? isSome22224(that) ? O2222(self2.value, that.value) : 1 : -1);
var lift22224 = (f2222) => dual2224(2, (self2, that) => zipWith2224(self2, that, f2222));
var liftPredicate2224 = (predicate) => (b2222) => predicate(b2222) ? some32224(b2222) : none22224();
var containsWith2224 = (isEquivalent) => dual2224(2, (self2, a2222) => isNone22224(self2) ? false : isEquivalent(self2.value, a2222));
var _equivalence2224 = /* @__PURE__ */ equivalence2224();
var contains2224 = /* @__PURE__ */ containsWith2224(_equivalence2224);
var exists2224 = /* @__PURE__ */ dual2224(2, (self2, refinement) => isNone22224(self2) ? false : refinement(self2.value));
var bindTo22224 = /* @__PURE__ */ bindTo3224(map2224);
var let_22224 = /* @__PURE__ */ let_3224(map2224);
var bind22224 = /* @__PURE__ */ bind3224(map2224, flatMap2224);
var Do2224 = /* @__PURE__ */ some32224({});
var adapter22224 = /* @__PURE__ */ adapter3224();
var gen2224 = (f2222) => {
  const iterator = f2222(adapter22224);
  let state = iterator.next();
  if (state.done) {
    return some32224(state.value);
  } else {
    let current = state.value;
    if (isGenKind2224(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet2224(current);
    }
    if (isNone22224(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind2224(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet2224(current);
        }
        if (isNone22224(current)) {
          return current;
        }
      }
    }
    return some32224(state.value);
  }
};
var fromIterable22224 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var reverse44 = (self2) => Array.from(self2).reverse();
var reduce54 = /* @__PURE__ */ dual2224(3, (self2, b2222, f2222) => fromIterable22224(self2).reduce((b22222, a2222, i2222) => f2222(b22222, a2222, i2222), b2222));
var TagTypeId224 = /* @__PURE__ */ Symbol.for("effect/Context/Tag");
var STMSymbolKey224 = "effect/STM";
var STMTypeId224 = /* @__PURE__ */ Symbol.for(STMSymbolKey224);
var TagProto224 = {
  ...EffectPrototype2224,
  _tag: "Tag",
  _op: "Tag",
  [STMTypeId224]: effectVariance2224,
  [TagTypeId224]: {
    _Service: (_2222) => _2222,
    _Identifier: (_2222) => _2222
  },
  toString() {
    return format2224(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Tag",
      key: this.key,
      stack: this.stack
    };
  },
  [NodeInspectSymbol2224]() {
    return this.toJSON();
  },
  of(self2) {
    return self2;
  },
  context(self2) {
    return make32224(this, self2);
  }
};
var makeGenericTag224 = (key) => {
  const limit = Error.stackTraceLimit;
  Error.stackTraceLimit = 2;
  const creationError = new Error();
  Error.stackTraceLimit = limit;
  const tag = Object.create(TagProto224);
  Object.defineProperty(tag, "stack", {
    get() {
      return creationError.stack;
    }
  });
  tag.key = key;
  return tag;
};
var TypeId42224 = /* @__PURE__ */ Symbol.for("effect/Context");
var ContextProto224 = {
  [TypeId42224]: {
    _Services: (_2222) => _2222
  },
  [symbol22224](that) {
    if (isContext224(that)) {
      if (this.unsafeMap.size === that.unsafeMap.size) {
        for (const k2222 of this.unsafeMap.keys()) {
          if (!that.unsafeMap.has(k2222) || !equals2224(this.unsafeMap.get(k2222), that.unsafeMap.get(k2222))) {
            return false;
          }
        }
        return true;
      }
    }
    return false;
  },
  [symbol3224]() {
    return cached2224(this, number2224(this.unsafeMap.size));
  },
  pipe() {
    return pipeArguments2224(this, arguments);
  },
  toString() {
    return format2224(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Context",
      services: Array.from(this.unsafeMap).map(toJSON2224)
    };
  },
  [NodeInspectSymbol2224]() {
    return this.toJSON();
  }
};
var makeContext224 = (unsafeMap) => {
  const context = Object.create(ContextProto224);
  context.unsafeMap = unsafeMap;
  return context;
};
var isContext224 = (u2222) => hasProperty2224(u2222, TypeId42224);
var _empty624 = /* @__PURE__ */ makeContext224(/* @__PURE__ */ new Map());
var empty104 = () => _empty624;
var make32224 = (tag, service) => makeContext224(/* @__PURE__ */ new Map([[tag.key, service]]));
var GenericTag224 = makeGenericTag224;
var empty2224 = empty104;
var TypeId52224 = /* @__PURE__ */ Symbol.for("effect/Chunk");
function copy34(src, srcPos, dest, destPos, len) {
  for (let i2222 = srcPos; i2222 < Math.min(src.length, srcPos + len); i2222++) {
    dest[destPos + i2222 - srcPos] = src[i2222];
  }
  return dest;
}
var emptyArray224 = [];
var getEquivalence22224 = (isEquivalent) => make4224((self2, that) => self2.length === that.length && toReadonlyArray224(self2).every((value, i2222) => isEquivalent(value, unsafeGet2224(that, i2222))));
var _equivalence22224 = /* @__PURE__ */ getEquivalence22224(equals2224);
var ChunkProto224 = {
  [TypeId52224]: {
    _A: (_2222) => _2222
  },
  toString() {
    return format2224(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Chunk",
      values: toReadonlyArray224(this).map(toJSON2224)
    };
  },
  [NodeInspectSymbol2224]() {
    return this.toJSON();
  },
  [symbol22224](that) {
    return isChunk224(that) && _equivalence22224(this, that);
  },
  [symbol3224]() {
    return cached2224(this, array54(toReadonlyArray224(this)));
  },
  [Symbol.iterator]() {
    switch (this.backing._tag) {
      case "IArray": {
        return this.backing.array[Symbol.iterator]();
      }
      case "IEmpty": {
        return emptyArray224[Symbol.iterator]();
      }
      default: {
        return toReadonlyArray224(this)[Symbol.iterator]();
      }
    }
  },
  pipe() {
    return pipeArguments2224(this, arguments);
  }
};
var makeChunk224 = (backing) => {
  const chunk = Object.create(ChunkProto224);
  chunk.backing = backing;
  switch (backing._tag) {
    case "IEmpty": {
      chunk.length = 0;
      chunk.depth = 0;
      chunk.left = chunk;
      chunk.right = chunk;
      break;
    }
    case "IConcat": {
      chunk.length = backing.left.length + backing.right.length;
      chunk.depth = 1 + Math.max(backing.left.depth, backing.right.depth);
      chunk.left = backing.left;
      chunk.right = backing.right;
      break;
    }
    case "IArray": {
      chunk.length = backing.array.length;
      chunk.depth = 0;
      chunk.left = _empty2224;
      chunk.right = _empty2224;
      break;
    }
    case "ISingleton": {
      chunk.length = 1;
      chunk.depth = 0;
      chunk.left = _empty2224;
      chunk.right = _empty2224;
      break;
    }
    case "ISlice": {
      chunk.length = backing.length;
      chunk.depth = backing.chunk.depth + 1;
      chunk.left = _empty2224;
      chunk.right = _empty2224;
      break;
    }
  }
  return chunk;
};
var isChunk224 = (u2222) => hasProperty2224(u2222, TypeId52224);
var _empty2224 = /* @__PURE__ */ makeChunk224({
  _tag: "IEmpty"
});
var empty3224 = () => _empty2224;
var make42224 = (...as22224) => as22224.length === 1 ? of34(as22224[0]) : unsafeFromNonEmptyArray224(as22224);
var of34 = (a2222) => makeChunk224({
  _tag: "ISingleton",
  a: a2222
});
var copyToArray224 = (self2, array3224, initial) => {
  switch (self2.backing._tag) {
    case "IArray": {
      copy34(self2.backing.array, 0, array3224, initial, self2.length);
      break;
    }
    case "IConcat": {
      copyToArray224(self2.left, array3224, initial);
      copyToArray224(self2.right, array3224, initial + self2.left.length);
      break;
    }
    case "ISingleton": {
      array3224[initial] = self2.backing.a;
      break;
    }
    case "ISlice": {
      let i2222 = 0;
      let j2222 = initial;
      while (i2222 < self2.length) {
        array3224[j2222] = unsafeGet2224(self2, i2222);
        i2222 += 1;
        j2222 += 1;
      }
      break;
    }
  }
};
var toReadonlyArray224 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      return emptyArray224;
    }
    case "IArray": {
      return self2.backing.array;
    }
    default: {
      const arr = new Array(self2.length);
      copyToArray224(self2, arr, 0);
      self2.backing = {
        _tag: "IArray",
        array: arr
      };
      self2.left = _empty2224;
      self2.right = _empty2224;
      self2.depth = 0;
      return arr;
    }
  }
};
var reverse2224 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty":
    case "ISingleton":
      return self2;
    case "IArray": {
      return makeChunk224({
        _tag: "IArray",
        array: reverse44(self2.backing.array)
      });
    }
    case "IConcat": {
      return makeChunk224({
        _tag: "IConcat",
        left: reverse2224(self2.backing.right),
        right: reverse2224(self2.backing.left)
      });
    }
    case "ISlice":
      return unsafeFromArray224(reverse44(toReadonlyArray224(self2)));
  }
};
var unsafeFromArray224 = (self2) => makeChunk224({
  _tag: "IArray",
  array: self2
});
var unsafeFromNonEmptyArray224 = (self2) => unsafeFromArray224(self2);
var unsafeGet2224 = /* @__PURE__ */ dual2224(2, (self2, index) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      throw new Error(`Index out of bounds`);
    }
    case "ISingleton": {
      if (index !== 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.a;
    }
    case "IArray": {
      if (index >= self2.length || index < 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.array[index];
    }
    case "IConcat": {
      return index < self2.left.length ? unsafeGet2224(self2.left, index) : unsafeGet2224(self2.right, index - self2.left.length);
    }
    case "ISlice": {
      return unsafeGet2224(self2.backing.chunk, index + self2.backing.offset);
    }
  }
});
var prepend34 = /* @__PURE__ */ dual2224(2, (self2, elem) => appendAll34(of34(elem), self2));
var drop34 = /* @__PURE__ */ dual2224(2, (self2, n2222) => {
  if (n2222 <= 0) {
    return self2;
  } else if (n2222 >= self2.length) {
    return _empty2224;
  } else {
    switch (self2.backing._tag) {
      case "ISlice": {
        return makeChunk224({
          _tag: "ISlice",
          chunk: self2.backing.chunk,
          offset: self2.backing.offset + n2222,
          length: self2.backing.length - n2222
        });
      }
      case "IConcat": {
        if (n2222 > self2.left.length) {
          return drop34(self2.right, n2222 - self2.left.length);
        }
        return makeChunk224({
          _tag: "IConcat",
          left: drop34(self2.left, n2222),
          right: self2.right
        });
      }
      default: {
        return makeChunk224({
          _tag: "ISlice",
          chunk: self2,
          offset: n2222,
          length: self2.length - n2222
        });
      }
    }
  }
});
var appendAll34 = /* @__PURE__ */ dual2224(2, (self2, that) => {
  if (self2.backing._tag === "IEmpty") {
    return that;
  }
  if (that.backing._tag === "IEmpty") {
    return self2;
  }
  const diff2224 = that.depth - self2.depth;
  if (Math.abs(diff2224) <= 1) {
    return makeChunk224({
      _tag: "IConcat",
      left: self2,
      right: that
    });
  } else if (diff2224 < -1) {
    if (self2.left.depth >= self2.right.depth) {
      const nr = appendAll34(self2.right, that);
      return makeChunk224({
        _tag: "IConcat",
        left: self2.left,
        right: nr
      });
    } else {
      const nrr = appendAll34(self2.right.right, that);
      if (nrr.depth === self2.depth - 3) {
        const nr = makeChunk224({
          _tag: "IConcat",
          left: self2.right.left,
          right: nrr
        });
        return makeChunk224({
          _tag: "IConcat",
          left: self2.left,
          right: nr
        });
      } else {
        const nl = makeChunk224({
          _tag: "IConcat",
          left: self2.left,
          right: self2.right.left
        });
        return makeChunk224({
          _tag: "IConcat",
          left: nl,
          right: nrr
        });
      }
    }
  } else {
    if (that.right.depth >= that.left.depth) {
      const nl = appendAll34(self2, that.left);
      return makeChunk224({
        _tag: "IConcat",
        left: nl,
        right: that.right
      });
    } else {
      const nll = appendAll34(self2, that.left.left);
      if (nll.depth === that.depth - 3) {
        const nl = makeChunk224({
          _tag: "IConcat",
          left: nll,
          right: that.left.right
        });
        return makeChunk224({
          _tag: "IConcat",
          left: nl,
          right: that.right
        });
      } else {
        const nr = makeChunk224({
          _tag: "IConcat",
          left: that.left.right,
          right: that.right
        });
        return makeChunk224({
          _tag: "IConcat",
          left: nll,
          right: nr
        });
      }
    }
  }
});
var isEmpty224 = (self2) => self2.length === 0;
var isNonEmpty224 = (self2) => self2.length > 0;
var unsafeHead224 = (self2) => unsafeGet2224(self2, 0);
var headNonEmpty34 = unsafeHead224;
var tailNonEmpty34 = (self2) => drop34(self2, 1);
var SIZE224 = 5;
var BUCKET_SIZE224 = /* @__PURE__ */ Math.pow(2, SIZE224);
var MASK224 = BUCKET_SIZE224 - 1;
var MAX_INDEX_NODE224 = BUCKET_SIZE224 / 2;
var MIN_ARRAY_NODE224 = BUCKET_SIZE224 / 4;
function popcount224(x2222) {
  x2222 -= x2222 >> 1 & 1431655765;
  x2222 = (x2222 & 858993459) + (x2222 >> 2 & 858993459);
  x2222 = x2222 + (x2222 >> 4) & 252645135;
  x2222 += x2222 >> 8;
  x2222 += x2222 >> 16;
  return x2222 & 127;
}
function hashFragment224(shift22, h2222) {
  return h2222 >>> shift22 & MASK224;
}
function toBitmap224(x2222) {
  return 1 << x2222;
}
function fromBitmap224(bitmap, bit) {
  return popcount224(bitmap & bit - 1);
}
var make5224 = (value, previous) => ({
  value,
  previous
});
function arrayUpdate224(mutate2224, at, v2222, arr) {
  let out = arr;
  if (!mutate2224) {
    const len = arr.length;
    out = new Array(len);
    for (let i2222 = 0; i2222 < len; ++i2222) out[i2222] = arr[i2222];
  }
  out[at] = v2222;
  return out;
}
function arraySpliceOut224(mutate2224, at, arr) {
  const newLen = arr.length - 1;
  let i2222 = 0;
  let g2222 = 0;
  let out = arr;
  if (mutate2224) {
    i2222 = g2222 = at;
  } else {
    out = new Array(newLen);
    while (i2222 < at) out[g2222++] = arr[i2222++];
  }
  ++i2222;
  while (i2222 <= newLen) out[g2222++] = arr[i2222++];
  if (mutate2224) {
    out.length = newLen;
  }
  return out;
}
function arraySpliceIn224(mutate2224, at, v2222, arr) {
  const len = arr.length;
  if (mutate2224) {
    let i22222 = len;
    while (i22222 >= at) arr[i22222--] = arr[i22222];
    arr[at] = v2222;
    return arr;
  }
  let i2222 = 0, g2222 = 0;
  const out = new Array(len + 1);
  while (i2222 < at) out[g2222++] = arr[i2222++];
  out[at] = v2222;
  while (i2222 < len) out[++g2222] = arr[i2222++];
  return out;
}
var EmptyNode224 = class _EmptyNode224 {
  _tag = "EmptyNode";
  modify(edit, _shift, f2222, hash22224, key, size4224) {
    const v2222 = f2222(none22224());
    if (isNone22224(v2222)) return new _EmptyNode224();
    ++size4224.value;
    return new LeafNode224(edit, hash22224, key, v2222);
  }
};
function isEmptyNode224(a2222) {
  return isTagged34(a2222, "EmptyNode");
}
function isLeafNode224(node) {
  return isEmptyNode224(node) || node._tag === "LeafNode" || node._tag === "CollisionNode";
}
function canEditNode224(node, edit) {
  return isEmptyNode224(node) ? false : edit === node.edit;
}
var LeafNode224 = class _LeafNode224 {
  edit;
  hash;
  key;
  value;
  _tag = "LeafNode";
  constructor(edit, hash22224, key, value) {
    this.edit = edit;
    this.hash = hash22224;
    this.key = key;
    this.value = value;
  }
  modify(edit, shift22, f2222, hash22224, key, size4224) {
    if (equals2224(key, this.key)) {
      const v22222 = f2222(this.value);
      if (v22222 === this.value) return this;
      else if (isNone22224(v22222)) {
        --size4224.value;
        return new EmptyNode224();
      }
      if (canEditNode224(this, edit)) {
        this.value = v22222;
        return this;
      }
      return new _LeafNode224(edit, hash22224, key, v22222);
    }
    const v2222 = f2222(none22224());
    if (isNone22224(v2222)) return this;
    ++size4224.value;
    return mergeLeaves224(edit, shift22, this.hash, this, hash22224, new _LeafNode224(edit, hash22224, key, v2222));
  }
};
var CollisionNode224 = class _CollisionNode224 {
  edit;
  hash;
  children;
  _tag = "CollisionNode";
  constructor(edit, hash22224, children) {
    this.edit = edit;
    this.hash = hash22224;
    this.children = children;
  }
  modify(edit, shift22, f2222, hash22224, key, size4224) {
    if (hash22224 === this.hash) {
      const canEdit = canEditNode224(this, edit);
      const list = this.updateCollisionList(canEdit, edit, this.hash, this.children, f2222, key, size4224);
      if (list === this.children) return this;
      return list.length > 1 ? new _CollisionNode224(edit, this.hash, list) : list[0];
    }
    const v2222 = f2222(none22224());
    if (isNone22224(v2222)) return this;
    ++size4224.value;
    return mergeLeaves224(edit, shift22, this.hash, this, hash22224, new LeafNode224(edit, hash22224, key, v2222));
  }
  updateCollisionList(mutate2224, edit, hash22224, list, f2222, key, size4224) {
    const len = list.length;
    for (let i2222 = 0; i2222 < len; ++i2222) {
      const child = list[i2222];
      if ("key" in child && equals2224(key, child.key)) {
        const value = child.value;
        const newValue2 = f2222(value);
        if (newValue2 === value) return list;
        if (isNone22224(newValue2)) {
          --size4224.value;
          return arraySpliceOut224(mutate2224, i2222, list);
        }
        return arrayUpdate224(mutate2224, i2222, new LeafNode224(edit, hash22224, key, newValue2), list);
      }
    }
    const newValue = f2222(none22224());
    if (isNone22224(newValue)) return list;
    ++size4224.value;
    return arrayUpdate224(mutate2224, len, new LeafNode224(edit, hash22224, key, newValue), list);
  }
};
var IndexedNode224 = class _IndexedNode224 {
  edit;
  mask;
  children;
  _tag = "IndexedNode";
  constructor(edit, mask, children) {
    this.edit = edit;
    this.mask = mask;
    this.children = children;
  }
  modify(edit, shift22, f2222, hash22224, key, size4224) {
    const mask = this.mask;
    const children = this.children;
    const frag = hashFragment224(shift22, hash22224);
    const bit = toBitmap224(frag);
    const indx = fromBitmap224(mask, bit);
    const exists22224 = mask & bit;
    const canEdit = canEditNode224(this, edit);
    if (!exists22224) {
      const _newChild = new EmptyNode224().modify(edit, shift22 + SIZE224, f2222, hash22224, key, size4224);
      if (!_newChild) return this;
      return children.length >= MAX_INDEX_NODE224 ? expand224(edit, frag, _newChild, mask, children) : new _IndexedNode224(edit, mask | bit, arraySpliceIn224(canEdit, indx, _newChild, children));
    }
    const current = children[indx];
    const child = current.modify(edit, shift22 + SIZE224, f2222, hash22224, key, size4224);
    if (current === child) return this;
    let bitmap = mask;
    let newChildren;
    if (isEmptyNode224(child)) {
      bitmap &= ~bit;
      if (!bitmap) return new EmptyNode224();
      if (children.length <= 2 && isLeafNode224(children[indx ^ 1])) {
        return children[indx ^ 1];
      }
      newChildren = arraySpliceOut224(canEdit, indx, children);
    } else {
      newChildren = arrayUpdate224(canEdit, indx, child, children);
    }
    if (canEdit) {
      this.mask = bitmap;
      this.children = newChildren;
      return this;
    }
    return new _IndexedNode224(edit, bitmap, newChildren);
  }
};
var ArrayNode224 = class _ArrayNode224 {
  edit;
  size;
  children;
  _tag = "ArrayNode";
  constructor(edit, size4224, children) {
    this.edit = edit;
    this.size = size4224;
    this.children = children;
  }
  modify(edit, shift22, f2222, hash22224, key, size4224) {
    let count = this.size;
    const children = this.children;
    const frag = hashFragment224(shift22, hash22224);
    const child = children[frag];
    const newChild = (child || new EmptyNode224()).modify(edit, shift22 + SIZE224, f2222, hash22224, key, size4224);
    if (child === newChild) return this;
    const canEdit = canEditNode224(this, edit);
    let newChildren;
    if (isEmptyNode224(child) && !isEmptyNode224(newChild)) {
      ++count;
      newChildren = arrayUpdate224(canEdit, frag, newChild, children);
    } else if (!isEmptyNode224(child) && isEmptyNode224(newChild)) {
      --count;
      if (count <= MIN_ARRAY_NODE224) {
        return pack224(edit, count, frag, children);
      }
      newChildren = arrayUpdate224(canEdit, frag, new EmptyNode224(), children);
    } else {
      newChildren = arrayUpdate224(canEdit, frag, newChild, children);
    }
    if (canEdit) {
      this.size = count;
      this.children = newChildren;
      return this;
    }
    return new _ArrayNode224(edit, count, newChildren);
  }
};
function pack224(edit, count, removed, elements) {
  const children = new Array(count - 1);
  let g2222 = 0;
  let bitmap = 0;
  for (let i2222 = 0, len = elements.length; i2222 < len; ++i2222) {
    if (i2222 !== removed) {
      const elem = elements[i2222];
      if (elem && !isEmptyNode224(elem)) {
        children[g2222++] = elem;
        bitmap |= 1 << i2222;
      }
    }
  }
  return new IndexedNode224(edit, bitmap, children);
}
function expand224(edit, frag, child, bitmap, subNodes) {
  const arr = [];
  let bit = bitmap;
  let count = 0;
  for (let i2222 = 0; bit; ++i2222) {
    if (bit & 1) arr[i2222] = subNodes[count++];
    bit >>>= 1;
  }
  arr[frag] = child;
  return new ArrayNode224(edit, count + 1, arr);
}
function mergeLeavesInner224(edit, shift22, h1, n1, h2222, n2222) {
  if (h1 === h2222) return new CollisionNode224(edit, h1, [n2222, n1]);
  const subH1 = hashFragment224(shift22, h1);
  const subH2 = hashFragment224(shift22, h2222);
  if (subH1 === subH2) {
    return (child) => new IndexedNode224(edit, toBitmap224(subH1) | toBitmap224(subH2), [child]);
  } else {
    const children = subH1 < subH2 ? [n1, n2222] : [n2222, n1];
    return new IndexedNode224(edit, toBitmap224(subH1) | toBitmap224(subH2), children);
  }
}
function mergeLeaves224(edit, shift22, h1, n1, h2222, n2222) {
  let stack = void 0;
  let currentShift = shift22;
  while (true) {
    const res = mergeLeavesInner224(edit, currentShift, h1, n1, h2222, n2222);
    if (typeof res === "function") {
      stack = make5224(res, stack);
      currentShift = currentShift + SIZE224;
    } else {
      let final = res;
      while (stack != null) {
        final = stack.value(final);
        stack = stack.previous;
      }
      return final;
    }
  }
}
var HashMapSymbolKey224 = "effect/HashMap";
var HashMapTypeId224 = /* @__PURE__ */ Symbol.for(HashMapSymbolKey224);
var HashMapProto224 = {
  [HashMapTypeId224]: HashMapTypeId224,
  [Symbol.iterator]() {
    return new HashMapIterator224(this, (k2222, v2222) => [k2222, v2222]);
  },
  [symbol3224]() {
    let hash22224 = hash2224(HashMapSymbolKey224);
    for (const item of this) {
      hash22224 ^= pipe2224(hash2224(item[0]), combine2224(hash2224(item[1])));
    }
    return cached2224(this, hash22224);
  },
  [symbol22224](that) {
    if (isHashMap224(that)) {
      if (that._size !== this._size) {
        return false;
      }
      for (const item of this) {
        const elem = pipe2224(that, getHash224(item[0], hash2224(item[0])));
        if (isNone22224(elem)) {
          return false;
        } else {
          if (!equals2224(item[1], elem.value)) {
            return false;
          }
        }
      }
      return true;
    }
    return false;
  },
  toString() {
    return format2224(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashMap",
      values: Array.from(this).map(toJSON2224)
    };
  },
  [NodeInspectSymbol2224]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments2224(this, arguments);
  }
};
var makeImpl324 = (editable, edit, root, size4224) => {
  const map622 = Object.create(HashMapProto224);
  map622._editable = editable;
  map622._edit = edit;
  map622._root = root;
  map622._size = size4224;
  return map622;
};
var HashMapIterator224 = class _HashMapIterator224 {
  map;
  f;
  v;
  constructor(map622, f2222) {
    this.map = map622;
    this.f = f2222;
    this.v = visitLazy224(this.map._root, this.f, void 0);
  }
  next() {
    if (isNone22224(this.v)) {
      return {
        done: true,
        value: void 0
      };
    }
    const v0 = this.v.value;
    this.v = applyCont224(v0.cont);
    return {
      done: false,
      value: v0.value
    };
  }
  [Symbol.iterator]() {
    return new _HashMapIterator224(this.map, this.f);
  }
};
var applyCont224 = (cont) => cont ? visitLazyChildren224(cont[0], cont[1], cont[2], cont[3], cont[4]) : none22224();
var visitLazy224 = (node, f2222, cont = void 0) => {
  switch (node._tag) {
    case "LeafNode": {
      if (isSome22224(node.value)) {
        return some32224({
          value: f2222(node.key, node.value.value),
          cont
        });
      }
      return applyCont224(cont);
    }
    case "CollisionNode":
    case "ArrayNode":
    case "IndexedNode": {
      const children = node.children;
      return visitLazyChildren224(children.length, children, 0, f2222, cont);
    }
    default: {
      return applyCont224(cont);
    }
  }
};
var visitLazyChildren224 = (len, children, i2222, f2222, cont) => {
  while (i2222 < len) {
    const child = children[i2222++];
    if (child && !isEmptyNode224(child)) {
      return visitLazy224(child, f2222, [len, children, i2222, f2222, cont]);
    }
  }
  return applyCont224(cont);
};
var _empty3224 = /* @__PURE__ */ makeImpl324(false, 0, /* @__PURE__ */ new EmptyNode224(), 0);
var empty4224 = () => _empty3224;
var isHashMap224 = (u2222) => hasProperty2224(u2222, HashMapTypeId224);
var getHash224 = /* @__PURE__ */ dual2224(3, (self2, key, hash22224) => {
  let node = self2._root;
  let shift22 = 0;
  while (true) {
    switch (node._tag) {
      case "LeafNode": {
        return equals2224(key, node.key) ? node.value : none22224();
      }
      case "CollisionNode": {
        if (hash22224 === node.hash) {
          const children = node.children;
          for (let i2222 = 0, len = children.length; i2222 < len; ++i2222) {
            const child = children[i2222];
            if ("key" in child && equals2224(key, child.key)) {
              return child.value;
            }
          }
        }
        return none22224();
      }
      case "IndexedNode": {
        const frag = hashFragment224(shift22, hash22224);
        const bit = toBitmap224(frag);
        if (node.mask & bit) {
          node = node.children[fromBitmap224(node.mask, bit)];
          shift22 += SIZE224;
          break;
        }
        return none22224();
      }
      case "ArrayNode": {
        node = node.children[hashFragment224(shift22, hash22224)];
        if (node) {
          shift22 += SIZE224;
          break;
        }
        return none22224();
      }
      default:
        return none22224();
    }
  }
});
var set2224 = /* @__PURE__ */ dual2224(3, (self2, key, value) => modifyAt224(self2, key, () => some32224(value)));
var setTree224 = /* @__PURE__ */ dual2224(3, (self2, newRoot, newSize) => {
  if (self2._editable) {
    self2._root = newRoot;
    self2._size = newSize;
    return self2;
  }
  return newRoot === self2._root ? self2 : makeImpl324(self2._editable, self2._edit, newRoot, newSize);
});
var keys34 = (self2) => new HashMapIterator224(self2, (key) => key);
var size424 = (self2) => self2._size;
var beginMutation324 = (self2) => makeImpl324(true, self2._edit + 1, self2._root, self2._size);
var modifyAt224 = /* @__PURE__ */ dual2224(3, (self2, key, f2222) => modifyHash224(self2, key, hash2224(key), f2222));
var modifyHash224 = /* @__PURE__ */ dual2224(4, (self2, key, hash22224, f2222) => {
  const size4224 = {
    value: self2._size
  };
  const newRoot = self2._root.modify(self2._editable ? self2._edit : NaN, 0, f2222, hash22224, key, size4224);
  return pipe2224(self2, setTree224(newRoot, size4224.value));
});
var forEach44 = /* @__PURE__ */ dual2224(2, (self2, f2222) => reduce2224(self2, void 0, (_2222, value, key) => f2222(value, key)));
var reduce2224 = /* @__PURE__ */ dual2224(3, (self2, zero, f2222) => {
  const root = self2._root;
  if (root._tag === "LeafNode") {
    return isSome22224(root.value) ? f2222(zero, root.value.value, root.key) : zero;
  }
  if (root._tag === "EmptyNode") {
    return zero;
  }
  const toVisit = [root.children];
  let children;
  while (children = toVisit.pop()) {
    for (let i2222 = 0, len = children.length; i2222 < len; ) {
      const child = children[i2222++];
      if (child && !isEmptyNode224(child)) {
        if (child._tag === "LeafNode") {
          if (isSome22224(child.value)) {
            zero = f2222(zero, child.value.value, child.key);
          }
        } else {
          toVisit.push(child.children);
        }
      }
    }
  }
  return zero;
});
var HashSetSymbolKey224 = "effect/HashSet";
var HashSetTypeId224 = /* @__PURE__ */ Symbol.for(HashSetSymbolKey224);
var HashSetProto224 = {
  [HashSetTypeId224]: HashSetTypeId224,
  [Symbol.iterator]() {
    return keys34(this._keyMap);
  },
  [symbol3224]() {
    return cached2224(this, combine2224(hash2224(this._keyMap))(hash2224(HashSetSymbolKey224)));
  },
  [symbol22224](that) {
    if (isHashSet224(that)) {
      return size424(this._keyMap) === size424(that._keyMap) && equals2224(this._keyMap, that._keyMap);
    }
    return false;
  },
  toString() {
    return format2224(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashSet",
      values: Array.from(this).map(toJSON2224)
    };
  },
  [NodeInspectSymbol2224]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments2224(this, arguments);
  }
};
var makeImpl2224 = (keyMap) => {
  const set22224 = Object.create(HashSetProto224);
  set22224._keyMap = keyMap;
  return set22224;
};
var isHashSet224 = (u2222) => hasProperty2224(u2222, HashSetTypeId224);
var _empty4224 = /* @__PURE__ */ makeImpl2224(/* @__PURE__ */ empty4224());
var empty5224 = () => _empty4224;
var size2224 = (self2) => size424(self2._keyMap);
var beginMutation2224 = (self2) => makeImpl2224(beginMutation324(self2._keyMap));
var endMutation224 = (self2) => {
  self2._keyMap._editable = false;
  return self2;
};
var mutate224 = /* @__PURE__ */ dual2224(2, (self2, f2222) => {
  const transient = beginMutation2224(self2);
  f2222(transient);
  return endMutation224(transient);
});
var add2224 = /* @__PURE__ */ dual2224(2, (self2, value) => self2._keyMap._editable ? (set2224(value, true)(self2._keyMap), self2) : makeImpl2224(set2224(value, true)(self2._keyMap)));
var union2224 = /* @__PURE__ */ dual2224(2, (self2, that) => mutate224(empty5224(), (set22224) => {
  forEach2224(self2, (value) => add2224(set22224, value));
  for (const value of that) {
    add2224(set22224, value);
  }
}));
var forEach2224 = /* @__PURE__ */ dual2224(2, (self2, f2222) => forEach44(self2._keyMap, (_2222, k2222) => f2222(k2222)));
var empty6224 = empty5224;
var size3224 = size2224;
var add3224 = add2224;
var union3224 = union2224;
var ArrayProto224 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(Array.prototype), {
  [symbol3224]() {
    return cached2224(this, array54(this));
  },
  [symbol22224](that) {
    if (Array.isArray(that) && this.length === that.length) {
      return this.every((v2222, i2222) => equals2224(v2222, that[i2222]));
    } else {
      return false;
    }
  }
});
var Structural324 = /* @__PURE__ */ function() {
  function Structural3224(args) {
    if (args) {
      Object.assign(this, args);
    }
  }
  Structural3224.prototype = StructuralPrototype224;
  return Structural3224;
}();
var struct2224 = (as22224) => Object.assign(Object.create(StructuralPrototype224), as22224);
var ContextPatchTypeId224 = /* @__PURE__ */ Symbol.for("effect/DifferContextPatch");
function variance324(a2222) {
  return a2222;
}
var PatchProto224 = {
  ...Structural324.prototype,
  [ContextPatchTypeId224]: {
    _Value: variance324,
    _Patch: variance324
  }
};
var EmptyProto224 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto224), {
  _tag: "Empty"
});
var _empty5224 = /* @__PURE__ */ Object.create(EmptyProto224);
var empty7224 = () => _empty5224;
var AndThenProto224 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto224), {
  _tag: "AndThen"
});
var makeAndThen224 = (first, second) => {
  const o2222 = Object.create(AndThenProto224);
  o2222.first = first;
  o2222.second = second;
  return o2222;
};
var AddServiceProto224 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto224), {
  _tag: "AddService"
});
var makeAddService224 = (key, service) => {
  const o2222 = Object.create(AddServiceProto224);
  o2222.key = key;
  o2222.service = service;
  return o2222;
};
var RemoveServiceProto224 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto224), {
  _tag: "RemoveService"
});
var makeRemoveService224 = (key) => {
  const o2222 = Object.create(RemoveServiceProto224);
  o2222.key = key;
  return o2222;
};
var UpdateServiceProto224 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto224), {
  _tag: "UpdateService"
});
var makeUpdateService224 = (key, update222) => {
  const o2222 = Object.create(UpdateServiceProto224);
  o2222.key = key;
  o2222.update = update222;
  return o2222;
};
var diff224 = (oldValue, newValue) => {
  const missingServices = new Map(oldValue.unsafeMap);
  let patch2224 = empty7224();
  for (const [tag, newService] of newValue.unsafeMap.entries()) {
    if (missingServices.has(tag)) {
      const old = missingServices.get(tag);
      missingServices.delete(tag);
      if (!equals2224(old, newService)) {
        patch2224 = combine22224(makeUpdateService224(tag, () => newService))(patch2224);
      }
    } else {
      missingServices.delete(tag);
      patch2224 = combine22224(makeAddService224(tag, newService))(patch2224);
    }
  }
  for (const [tag] of missingServices.entries()) {
    patch2224 = combine22224(makeRemoveService224(tag))(patch2224);
  }
  return patch2224;
};
var combine22224 = /* @__PURE__ */ dual2224(2, (self2, that) => makeAndThen224(self2, that));
var patch224 = /* @__PURE__ */ dual2224(2, (self2, context) => {
  if (self2._tag === "Empty") {
    return context;
  }
  let wasServiceUpdated = false;
  let patches = of34(self2);
  const updatedContext = new Map(context.unsafeMap);
  while (isNonEmpty224(patches)) {
    const head222 = headNonEmpty34(patches);
    const tail222 = tailNonEmpty34(patches);
    switch (head222._tag) {
      case "Empty": {
        patches = tail222;
        break;
      }
      case "AddService": {
        updatedContext.set(head222.key, head222.service);
        patches = tail222;
        break;
      }
      case "AndThen": {
        patches = prepend34(prepend34(tail222, head222.second), head222.first);
        break;
      }
      case "RemoveService": {
        updatedContext.delete(head222.key);
        patches = tail222;
        break;
      }
      case "UpdateService": {
        updatedContext.set(head222.key, head222.update(updatedContext.get(head222.key)));
        wasServiceUpdated = true;
        patches = tail222;
        break;
      }
    }
  }
  if (!wasServiceUpdated) {
    return makeContext224(updatedContext);
  }
  const map622 = /* @__PURE__ */ new Map();
  for (const [tag] of context.unsafeMap) {
    if (updatedContext.has(tag)) {
      map622.set(tag, updatedContext.get(tag));
      updatedContext.delete(tag);
    }
  }
  for (const [tag, s2222] of updatedContext) {
    map622.set(tag, s2222);
  }
  return makeContext224(map622);
});
var DifferTypeId224 = /* @__PURE__ */ Symbol.for("effect/Differ");
var DifferProto224 = {
  [DifferTypeId224]: {
    _P: identity2224,
    _V: identity2224
  }
};
var make7224 = (params) => {
  const differ = Object.create(DifferProto224);
  differ.empty = params.empty;
  differ.diff = params.diff;
  differ.combine = params.combine;
  differ.patch = params.patch;
  return differ;
};
var environment224 = () => make7224({
  empty: empty7224(),
  combine: (first, second) => combine22224(second)(first),
  diff: (oldValue, newValue) => diff224(oldValue, newValue),
  patch: (patch2224, oldValue) => patch224(oldValue)(patch2224)
});
var OP_DIE224 = "Die";
var OP_EMPTY224 = "Empty";
var OP_FAIL224 = "Fail";
var OP_INTERRUPT224 = "Interrupt";
var OP_PARALLEL224 = "Parallel";
var OP_SEQUENTIAL224 = "Sequential";
var CauseSymbolKey224 = "effect/Cause";
var CauseTypeId224 = /* @__PURE__ */ Symbol.for(CauseSymbolKey224);
var variance2224 = {
  /* c8 ignore next */
  _E: (_2222) => _2222
};
var proto224 = {
  [CauseTypeId224]: variance2224,
  [symbol3224]() {
    return pipe2224(hash2224(CauseSymbolKey224), combine2224(hash2224(flattenCause224(this))), cached2224(this));
  },
  [symbol22224](that) {
    return isCause224(that) && causeEquals224(this, that);
  },
  pipe() {
    return pipeArguments2224(this, arguments);
  },
  toJSON() {
    switch (this._tag) {
      case "Empty":
        return {
          _id: "Cause",
          _tag: this._tag
        };
      case "Die":
        return {
          _id: "Cause",
          _tag: this._tag,
          defect: toJSON2224(this.defect)
        };
      case "Interrupt":
        return {
          _id: "Cause",
          _tag: this._tag,
          fiberId: this.fiberId.toJSON()
        };
      case "Fail":
        return {
          _id: "Cause",
          _tag: this._tag,
          failure: toJSON2224(this.error)
        };
      case "Sequential":
      case "Parallel":
        return {
          _id: "Cause",
          _tag: this._tag,
          left: toJSON2224(this.left),
          right: toJSON2224(this.right)
        };
    }
  },
  toString() {
    return pretty224(this);
  },
  [NodeInspectSymbol2224]() {
    return this.toJSON();
  }
};
var fail324 = (error) => {
  const o2222 = Object.create(proto224);
  o2222._tag = OP_FAIL224;
  o2222.error = error;
  return o2222;
};
var parallel224 = (left3224, right3224) => {
  const o2222 = Object.create(proto224);
  o2222._tag = OP_PARALLEL224;
  o2222.left = left3224;
  o2222.right = right3224;
  return o2222;
};
var sequential224 = (left3224, right3224) => {
  const o2222 = Object.create(proto224);
  o2222._tag = OP_SEQUENTIAL224;
  o2222.left = left3224;
  o2222.right = right3224;
  return o2222;
};
var isCause224 = (u2222) => hasProperty2224(u2222, CauseTypeId224);
var isInterruptedOnly224 = (self2) => reduceWithContext224(void 0, IsInterruptedOnlyCauseReducer224)(self2);
var causeEquals224 = (left3224, right3224) => {
  let leftStack = of34(left3224);
  let rightStack = of34(right3224);
  while (isNonEmpty224(leftStack) && isNonEmpty224(rightStack)) {
    const [leftParallel, leftSequential] = pipe2224(headNonEmpty34(leftStack), reduce4224([empty6224(), empty3224()], ([parallel2224, sequential2224], cause) => {
      const [par, seq] = evaluateCause224(cause);
      return some32224([pipe2224(parallel2224, union3224(par)), pipe2224(sequential2224, appendAll34(seq))]);
    }));
    const [rightParallel, rightSequential] = pipe2224(headNonEmpty34(rightStack), reduce4224([empty6224(), empty3224()], ([parallel2224, sequential2224], cause) => {
      const [par, seq] = evaluateCause224(cause);
      return some32224([pipe2224(parallel2224, union3224(par)), pipe2224(sequential2224, appendAll34(seq))]);
    }));
    if (!equals2224(leftParallel, rightParallel)) {
      return false;
    }
    leftStack = leftSequential;
    rightStack = rightSequential;
  }
  return true;
};
var flattenCause224 = (cause) => {
  return flattenCauseLoop224(of34(cause), empty3224());
};
var flattenCauseLoop224 = (causes, flattened) => {
  while (1) {
    const [parallel2224, sequential2224] = pipe2224(causes, reduce54([empty6224(), empty3224()], ([parallel322, sequential322], cause) => {
      const [par, seq] = evaluateCause224(cause);
      return [pipe2224(parallel322, union3224(par)), pipe2224(sequential322, appendAll34(seq))];
    }));
    const updated = size3224(parallel2224) > 0 ? pipe2224(flattened, prepend34(parallel2224)) : flattened;
    if (isEmpty224(sequential2224)) {
      return reverse2224(updated);
    }
    causes = sequential2224;
    flattened = updated;
  }
  throw new Error(getBugErrorMessage2224("Cause.flattenCauseLoop"));
};
var evaluateCause224 = (self2) => {
  let cause = self2;
  const stack = [];
  let _parallel = empty6224();
  let _sequential = empty3224();
  while (cause !== void 0) {
    switch (cause._tag) {
      case OP_EMPTY224: {
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_FAIL224: {
        _parallel = add3224(_parallel, make42224(cause._tag, cause.error));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_DIE224: {
        _parallel = add3224(_parallel, make42224(cause._tag, cause.defect));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_INTERRUPT224: {
        _parallel = add3224(_parallel, make42224(cause._tag, cause.fiberId));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_SEQUENTIAL224: {
        switch (cause.left._tag) {
          case OP_EMPTY224: {
            cause = cause.right;
            break;
          }
          case OP_SEQUENTIAL224: {
            cause = sequential224(cause.left.left, sequential224(cause.left.right, cause.right));
            break;
          }
          case OP_PARALLEL224: {
            cause = parallel224(sequential224(cause.left.left, cause.right), sequential224(cause.left.right, cause.right));
            break;
          }
          default: {
            _sequential = prepend34(_sequential, cause.right);
            cause = cause.left;
            break;
          }
        }
        break;
      }
      case OP_PARALLEL224: {
        stack.push(cause.right);
        cause = cause.left;
        break;
      }
    }
  }
  throw new Error(getBugErrorMessage2224("Cause.evaluateCauseLoop"));
};
var IsInterruptedOnlyCauseReducer224 = {
  emptyCase: constTrue2224,
  failCase: constFalse2224,
  dieCase: constFalse2224,
  interruptCase: constTrue2224,
  sequentialCase: (_2222, left3224, right3224) => left3224 && right3224,
  parallelCase: (_2222, left3224, right3224) => left3224 && right3224
};
var OP_SEQUENTIAL_CASE224 = "SequentialCase";
var OP_PARALLEL_CASE224 = "ParallelCase";
var reduce4224 = /* @__PURE__ */ dual2224(3, (self2, zero, pf) => {
  let accumulator = zero;
  let cause = self2;
  const causes = [];
  while (cause !== void 0) {
    const option = pf(accumulator, cause);
    accumulator = isSome22224(option) ? option.value : accumulator;
    switch (cause._tag) {
      case OP_SEQUENTIAL224: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      case OP_PARALLEL224: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      default: {
        cause = void 0;
        break;
      }
    }
    if (cause === void 0 && causes.length > 0) {
      cause = causes.pop();
    }
  }
  return accumulator;
});
var reduceWithContext224 = /* @__PURE__ */ dual2224(3, (self2, context, reducer) => {
  const input = [self2];
  const output = [];
  while (input.length > 0) {
    const cause = input.pop();
    switch (cause._tag) {
      case OP_EMPTY224: {
        output.push(right22224(reducer.emptyCase(context)));
        break;
      }
      case OP_FAIL224: {
        output.push(right22224(reducer.failCase(context, cause.error)));
        break;
      }
      case OP_DIE224: {
        output.push(right22224(reducer.dieCase(context, cause.defect)));
        break;
      }
      case OP_INTERRUPT224: {
        output.push(right22224(reducer.interruptCase(context, cause.fiberId)));
        break;
      }
      case OP_SEQUENTIAL224: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left22224({
          _tag: OP_SEQUENTIAL_CASE224
        }));
        break;
      }
      case OP_PARALLEL224: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left22224({
          _tag: OP_PARALLEL_CASE224
        }));
        break;
      }
    }
  }
  const accumulator = [];
  while (output.length > 0) {
    const either = output.pop();
    switch (either._tag) {
      case "Left": {
        switch (either.left._tag) {
          case OP_SEQUENTIAL_CASE224: {
            const left3224 = accumulator.pop();
            const right3224 = accumulator.pop();
            const value = reducer.sequentialCase(context, left3224, right3224);
            accumulator.push(value);
            break;
          }
          case OP_PARALLEL_CASE224: {
            const left3224 = accumulator.pop();
            const right3224 = accumulator.pop();
            const value = reducer.parallelCase(context, left3224, right3224);
            accumulator.push(value);
            break;
          }
        }
        break;
      }
      case "Right": {
        accumulator.push(either.right);
        break;
      }
    }
  }
  if (accumulator.length === 0) {
    throw new Error("BUG: Cause.reduceWithContext - please report an issue at https://github.com/Effect-TS/effect/issues");
  }
  return accumulator.pop();
});
var pretty224 = (cause) => {
  if (isInterruptedOnly224(cause)) {
    return "All fibers interrupted without errors.";
  }
  return prettyErrors224(cause).map((e2222) => e2222.stack).join("\n");
};
var PrettyError224 = class extends globalThis.Error {
  span = void 0;
  constructor(originalError) {
    const prevLimit = Error.stackTraceLimit;
    Error.stackTraceLimit = 0;
    super(prettyErrorMessage224(originalError));
    Error.stackTraceLimit = prevLimit;
    this.name = originalError instanceof Error ? originalError.name : "Error";
    if (typeof originalError === "object" && originalError !== null) {
      if (spanSymbol324 in originalError) {
        this.span = originalError[spanSymbol324];
      }
      Object.keys(originalError).forEach((key) => {
        if (!(key in this)) {
          this[key] = originalError[key];
        }
      });
    }
    this.stack = prettyErrorStack224(this.message, originalError instanceof Error && originalError.stack ? originalError.stack : "", this.span);
  }
  toJSON() {
    const out = {
      message: this.message,
      stack: this.stack
    };
    if (this.span) {
      out.span = this.span;
    }
    return out;
  }
};
var prettyErrorMessage224 = (u2222) => {
  if (typeof u2222 === "string") {
    return `Error: ${u2222}`;
  }
  try {
    if (hasProperty2224(u2222, "toString") && isFunction3224(u2222["toString"]) && u2222["toString"] !== Object.prototype.toString && u2222["toString"] !== globalThis.Array.prototype.toString) {
      return u2222["toString"]();
    }
  } catch {
  }
  return `Error: ${JSON.stringify(u2222)}`;
};
var locationRegex224 = /\((.*)\)/;
var spanToTrace224 = /* @__PURE__ */ globalValue2224("effect/Tracer/spanToTrace", () => /* @__PURE__ */ new WeakMap());
var prettyErrorStack224 = (message, stack, span24) => {
  const out = [message];
  const lines = stack.split("\n");
  for (let i2222 = 1; i2222 < lines.length; i2222++) {
    if (lines[i2222].includes("Generator.next")) {
      break;
    }
    if (lines[i2222].includes("effect_internal_function")) {
      out.pop();
      break;
    }
    out.push(lines[i2222].replace(/at .*effect_instruction_i.*\((.*)\)/, "at $1").replace(/EffectPrimitive\.\w+/, "<anonymous>"));
  }
  if (span24) {
    let current = span24;
    let i2222 = 0;
    while (current && current._tag === "Span" && i2222 < 10) {
      const stackFn = spanToTrace224.get(current);
      if (typeof stackFn === "function") {
        const stack2 = stackFn();
        const locationMatch = stack2.match(locationRegex224);
        const location = locationMatch ? locationMatch[1] : stack2.replace(/^at /, "");
        out.push(`    at ${current.name} (${location})`);
      } else {
        out.push(`    at ${current.name}`);
      }
      current = getOrUndefined2224(current.parent);
      i2222++;
    }
  }
  return out.join("\n");
};
var spanSymbol324 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var prettyErrors224 = (cause) => reduceWithContext224(cause, void 0, {
  emptyCase: () => [],
  dieCase: (_2222, unknownError) => {
    return [new PrettyError224(unknownError)];
  },
  failCase: (_2222, error) => {
    return [new PrettyError224(error)];
  },
  interruptCase: () => [],
  parallelCase: (_2222, l2222, r2222) => [...l2222, ...r2222],
  sequentialCase: (_2222, l2222, r2222) => [...l2222, ...r2222]
});
var SingleShotGen22224 = class _SingleShotGen2224 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  next(a2222) {
    return this.called ? {
      value: a2222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  return(a2222) {
    return {
      value: a2222,
      done: true
    };
  }
  throw(e2222) {
    throw e2222;
  }
  [Symbol.iterator]() {
    return new _SingleShotGen2224(this.self);
  }
};
var spanTag224 = /* @__PURE__ */ GenericTag224("effect/ParentSpan");
var EffectTypeId22224 = /* @__PURE__ */ Symbol.for("effect/Effect");
var EffectPrimitive224 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId22224] = effectVariance2224;
  constructor(_op) {
    this._op = _op;
  }
  [symbol22224](that) {
    return this === that;
  }
  [symbol3224]() {
    return cached2224(this, random2224(this));
  }
  pipe() {
    return pipeArguments2224(this, arguments);
  }
  toJSON() {
    return {
      _id: "Effect",
      _op: this._op,
      effect_instruction_i0: toJSON2224(this.effect_instruction_i0),
      effect_instruction_i1: toJSON2224(this.effect_instruction_i1),
      effect_instruction_i2: toJSON2224(this.effect_instruction_i2)
    };
  }
  toString() {
    return format2224(this.toJSON());
  }
  [NodeInspectSymbol2224]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen22224(new YieldWrap2224(this));
  }
};
var EffectPrimitiveFailure224 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId22224] = effectVariance2224;
  constructor(_op) {
    this._op = _op;
    this._tag = _op;
  }
  [symbol22224](that) {
    return exitIsExit224(that) && that._op === "Failure" && // @ts-expect-error
    equals2224(this.effect_instruction_i0, that.effect_instruction_i0);
  }
  [symbol3224]() {
    return pipe2224(
      // @ts-expect-error
      string2224(this._tag),
      // @ts-expect-error
      combine2224(hash2224(this.effect_instruction_i0)),
      cached2224(this)
    );
  }
  get cause() {
    return this.effect_instruction_i0;
  }
  pipe() {
    return pipeArguments2224(this, arguments);
  }
  toJSON() {
    return {
      _id: "Exit",
      _tag: this._op,
      cause: this.cause.toJSON()
    };
  }
  toString() {
    return format2224(this.toJSON());
  }
  [NodeInspectSymbol2224]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen22224(new YieldWrap2224(this));
  }
};
var isEffect224 = (u2222) => hasProperty2224(u2222, EffectTypeId22224);
var withFiberRuntime224 = (withRuntime) => {
  const effect = new EffectPrimitive224(OP_WITH_RUNTIME224);
  effect.effect_instruction_i0 = withRuntime;
  return effect;
};
var spanSymbol2224 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var originalSymbol224 = /* @__PURE__ */ Symbol.for("effect/OriginalAnnotation");
var capture224 = (obj, span24) => {
  if (isSome22224(span24)) {
    return new Proxy(obj, {
      has(target, p2222) {
        return p2222 === spanSymbol2224 || p2222 === originalSymbol224 || p2222 in target;
      },
      get(target, p2222) {
        if (p2222 === spanSymbol2224) {
          return span24.value;
        }
        if (p2222 === originalSymbol224) {
          return obj;
        }
        return target[p2222];
      }
    });
  }
  return obj;
};
var fail2224 = (error) => isObject2224(error) && !(spanSymbol2224 in error) ? withFiberRuntime224((fiber) => failCause224(fail324(capture224(error, currentSpanFromFiber224(fiber))))) : failCause224(fail324(error));
var failCause224 = (cause) => {
  const effect = new EffectPrimitiveFailure224(OP_FAILURE224);
  effect.effect_instruction_i0 = cause;
  return effect;
};
var FiberRefSymbolKey224 = "effect/FiberRef";
var FiberRefTypeId224 = /* @__PURE__ */ Symbol.for(FiberRefSymbolKey224);
var fiberRefVariance224 = {
  /* c8 ignore next */
  _A: (_2222) => _2222
};
var fiberRefUnsafeMakeContext224 = (initial) => {
  const differ = environment224();
  return fiberRefUnsafeMakePatch224(initial, {
    differ,
    fork: differ.empty
  });
};
var fiberRefUnsafeMakePatch224 = (initial, options) => ({
  [FiberRefTypeId224]: fiberRefVariance224,
  initial,
  diff: (oldValue, newValue) => options.differ.diff(oldValue, newValue),
  combine: (first, second) => options.differ.combine(first, second),
  patch: (patch2224) => (oldValue) => options.differ.patch(patch2224, oldValue),
  fork: options.fork,
  join: options.join ?? ((_2222, n2222) => n2222),
  pipe() {
    return pipeArguments2224(this, arguments);
  }
});
var currentContext224 = /* @__PURE__ */ globalValue2224(/* @__PURE__ */ Symbol.for("effect/FiberRef/currentContext"), () => fiberRefUnsafeMakeContext224(empty2224()));
var YieldableError224 = /* @__PURE__ */ function() {
  class YieldableError2224 extends globalThis.Error {
    commit() {
      return fail2224(this);
    }
    toString() {
      return this.message ? `${this.name}: ${this.message}` : this.name;
    }
    toJSON() {
      return {
        ...this
      };
    }
    [NodeInspectSymbol2224]() {
      const stack = this.stack;
      if (stack) {
        return `${this.toString()}
${stack.split("\n").slice(1).join("\n")}`;
      }
      return this.toString();
    }
  }
  Object.assign(YieldableError2224.prototype, StructuralCommitPrototype224);
  return YieldableError2224;
}();
var exitIsExit224 = (u2222) => isEffect224(u2222) && "_tag" in u2222 && (u2222._tag === "Success" || u2222._tag === "Failure");
var currentSpanFromFiber224 = (fiber) => {
  const span24 = fiber.getFiberRef(currentContext224).unsafeMap.get(spanTag224.key);
  return span24 !== void 0 && span24._tag === "Span" ? some32224(span24) : none22224();
};
var Data_exports224 = {};
__export22224(Data_exports224, {
  Class: () => Class2224,
  Error: () => Error2224,
  Structural: () => Structural2224,
  TaggedClass: () => TaggedClass224,
  TaggedError: () => TaggedError224,
  array: () => array2224,
  case: () => _case224,
  struct: () => struct3224,
  tagged: () => tagged224,
  taggedEnum: () => taggedEnum224,
  tuple: () => tuple2224,
  unsafeArray: () => unsafeArray224,
  unsafeStruct: () => unsafeStruct224
});
var struct3224 = struct2224;
var unsafeStruct224 = (as22224) => Object.setPrototypeOf(as22224, StructuralPrototype224);
var tuple2224 = (...as22224) => unsafeArray224(as22224);
var array2224 = (as22224) => unsafeArray224(as22224.slice(0));
var unsafeArray224 = (as22224) => Object.setPrototypeOf(as22224, ArrayProto224);
var _case224 = () => (args) => args === void 0 ? Object.create(StructuralPrototype224) : struct3224(args);
var tagged224 = (tag) => (args) => {
  const value = args === void 0 ? Object.create(StructuralPrototype224) : struct3224(args);
  value._tag = tag;
  return value;
};
var Class2224 = Structural324;
var TaggedClass224 = (tag) => {
  class Base extends Class2224 {
    _tag = tag;
  }
  return Base;
};
var Structural2224 = Structural324;
var taggedEnum224 = () => new Proxy({}, {
  get(_target, tag, _receiver) {
    if (tag === "$is") {
      return isTagged34;
    } else if (tag === "$match") {
      return taggedMatch224;
    }
    return tagged224(tag);
  }
});
function taggedMatch224() {
  if (arguments.length === 1) {
    const cases2 = arguments[0];
    return function(value2) {
      return cases2[value2._tag](value2);
    };
  }
  const value = arguments[0];
  const cases = arguments[1];
  return cases[value._tag](value);
}
var Error2224 = /* @__PURE__ */ function() {
  return class Base extends YieldableError224 {
    constructor(args) {
      super();
      if (args) {
        Object.assign(this, args);
      }
    }
  };
}();
var TaggedError224 = (tag) => {
  class Base extends Error2224 {
    _tag = tag;
  }
  Base.prototype.name = tag;
  return Base;
};
var traverseUp224 = Function_exports2224.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType224.Program) return Option_exports2224.none();
  return predicate(parent) ? Option_exports2224.some(parent) : traverseUp224(parent, predicate);
});
var traverseUpGuard224 = Function_exports2224.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType224.Program) return Option_exports2224.none();
  return predicate(parent) ? Option_exports2224.some(parent) : traverseUpGuard224(parent, predicate);
});
var ESLintCommunityESLintUtils224;
((ESLintCommunityESLintUtils2224) => {
  ESLintCommunityESLintUtils2224.getFunctionHeadLocation = getFunctionHeadLocation224;
  ESLintCommunityESLintUtils2224.getFunctionNameWithKind = getFunctionNameWithKind224;
  ESLintCommunityESLintUtils2224.getPropertyName = getPropertyName224;
  ESLintCommunityESLintUtils2224.getStaticValue = getStaticValue224;
  ESLintCommunityESLintUtils2224.getStringIfConstant = getStringIfConstant224;
  ESLintCommunityESLintUtils2224.hasSideEffect = hasSideEffect224;
  ESLintCommunityESLintUtils2224.isParenthesized = isParenthesized224;
})(ESLintCommunityESLintUtils224 || (ESLintCommunityESLintUtils224 = {}));
var Construction224 = Data_exports224.taggedEnum();
Construction224.None();
a24({
  type: N24.union([NodeType224.FunctionExpression, NodeType224.ArrowFunctionExpression]),
  parent: {
    type: NodeType224.Property,
    parent: {
      type: NodeType224.ObjectExpression
    }
  }
});
a24({
  type: N24.union([NodeType224.FunctionExpression, NodeType224.ArrowFunctionExpression]),
  parent: {
    type: NodeType224.MethodDefinition,
    parent: {
      type: NodeType224.ClassBody
    }
  }
});
a24({
  type: N24.union([NodeType224.FunctionExpression, NodeType224.ArrowFunctionExpression]),
  parent: {
    type: NodeType224.Property,
    parent: {
      type: NodeType224.ClassBody
    }
  }
});
isOneOf24([NodeType24.Literal, NodeType24.JSXText]);
var Function_exports44 = {};
__export26(Function_exports44, {
  SK: () => SK44,
  absurd: () => absurd44,
  apply: () => apply44,
  compose: () => compose64,
  constFalse: () => constFalse44,
  constNull: () => constNull44,
  constTrue: () => constTrue44,
  constUndefined: () => constUndefined44,
  constVoid: () => constVoid44,
  constant: () => constant44,
  dual: () => dual44,
  flip: () => flip44,
  flow: () => flow44,
  hole: () => hole44,
  identity: () => identity44,
  isFunction: () => isFunction73,
  pipe: () => pipe44,
  satisfies: () => satisfies44,
  tupled: () => tupled44,
  unsafeCoerce: () => unsafeCoerce44,
  untupled: () => untupled44
});
var isFunction73 = (input) => typeof input === "function";
var dual44 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a322, b322) {
        if (arguments.length >= 2) {
          return body(a322, b322);
        }
        return function(self2) {
          return body(self2, a322);
        };
      };
    case 3:
      return function(a322, b322, c322) {
        if (arguments.length >= 3) {
          return body(a322, b322, c322);
        }
        return function(self2) {
          return body(self2, a322, b322);
        };
      };
    case 4:
      return function(a322, b322, c322, d322) {
        if (arguments.length >= 4) {
          return body(a322, b322, c322, d322);
        }
        return function(self2) {
          return body(self2, a322, b322, c322);
        };
      };
    case 5:
      return function(a322, b322, c322, d322, e322) {
        if (arguments.length >= 5) {
          return body(a322, b322, c322, d322, e322);
        }
        return function(self2) {
          return body(self2, a322, b322, c322, d322);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply44 = (a322) => (self2) => self2(a322);
var identity44 = (a322) => a322;
var satisfies44 = () => (b322) => b322;
var unsafeCoerce44 = identity44;
var constant44 = (value) => () => value;
var constTrue44 = /* @__PURE__ */ constant44(true);
var constFalse44 = /* @__PURE__ */ constant44(false);
var constNull44 = /* @__PURE__ */ constant44(null);
var constUndefined44 = /* @__PURE__ */ constant44(void 0);
var constVoid44 = constUndefined44;
var flip44 = (f322) => (...b322) => (...a322) => f322(...a322)(...b322);
var compose64 = /* @__PURE__ */ dual44(2, (ab, bc) => (a322) => bc(ab(a322)));
var absurd44 = (_322) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled44 = (f322) => (a322) => f322(...a322);
var untupled44 = (f322) => (...a322) => f322(a322);
function pipe44(a322, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a322;
    case 2:
      return ab(a322);
    case 3:
      return bc(ab(a322));
    case 4:
      return cd(bc(ab(a322)));
    case 5:
      return de(cd(bc(ab(a322))));
    case 6:
      return ef(de(cd(bc(ab(a322)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a322))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a322)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a322))))))));
    default: {
      let ret = arguments[0];
      for (let i322 = 1; i322 < arguments.length; i322++) {
        ret = arguments[i322](ret);
      }
      return ret;
    }
  }
}
function flow44(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole44 = /* @__PURE__ */ unsafeCoerce44(absurd44);
var SK44 = (_322, b322) => b322;
var make124 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_74 = (map722) => dual44(3, (self2, name22, f322) => map722(self2, (a322) => Object.assign({}, a322, {
  [name22]: f322(a322)
})));
var bindTo74 = (map722) => dual44(2, (self2, name22) => map722(self2, (a322) => ({
  [name22]: a322
})));
var bind74 = (map722, flatMap722) => dual44(3, (self2, name22, f322) => flatMap722(self2, (a322) => map722(f322(a322), (b322) => Object.assign({}, a322, {
  [name22]: b322
}))));
var moduleVersion44 = "3.2.8";
var getCurrentVersion44 = () => moduleVersion44;
var globalStoreId44 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion44()}`);
if (!(globalStoreId44 in globalThis)) {
  globalThis[globalStoreId44] = /* @__PURE__ */ new Map();
}
var globalStore44 = globalThis[globalStoreId44];
var globalValue44 = (id, compute) => {
  if (!globalStore44.has(id)) {
    globalStore44.set(id, compute());
  }
  return globalStore44.get(id);
};
var Predicate_exports34 = {};
__export26(Predicate_exports34, {
  all: () => all64,
  and: () => and44,
  compose: () => compose74,
  eqv: () => eqv44,
  every: () => every54,
  hasProperty: () => hasProperty44,
  implies: () => implies44,
  isBigInt: () => isBigInt44,
  isBoolean: () => isBoolean44,
  isDate: () => isDate44,
  isError: () => isError44,
  isFunction: () => isFunction83,
  isIterable: () => isIterable44,
  isMap: () => isMap44,
  isNever: () => isNever44,
  isNotNull: () => isNotNull44,
  isNotNullable: () => isNotNullable44,
  isNotUndefined: () => isNotUndefined44,
  isNull: () => isNull44,
  isNullable: () => isNullable44,
  isNumber: () => isNumber44,
  isObject: () => isObject44,
  isPromise: () => isPromise44,
  isPromiseLike: () => isPromiseLike44,
  isReadonlyRecord: () => isReadonlyRecord44,
  isRecord: () => isRecord44,
  isSet: () => isSet44,
  isString: () => isString44,
  isSymbol: () => isSymbol44,
  isTagged: () => isTagged44,
  isTruthy: () => isTruthy44,
  isUint8Array: () => isUint8Array44,
  isUndefined: () => isUndefined44,
  isUnknown: () => isUnknown44,
  mapInput: () => mapInput54,
  nand: () => nand44,
  nor: () => nor44,
  not: () => not44,
  or: () => or44,
  product: () => product64,
  productMany: () => productMany64,
  some: () => some94,
  struct: () => struct64,
  tuple: () => tuple54,
  xor: () => xor44
});
var mapInput54 = /* @__PURE__ */ dual44(2, (self2, f322) => (b322) => self2(f322(b322)));
var isTruthy44 = (input) => !!input;
var isSet44 = (input) => input instanceof Set;
var isMap44 = (input) => input instanceof Map;
var isString44 = (input) => typeof input === "string";
var isNumber44 = (input) => typeof input === "number";
var isBoolean44 = (input) => typeof input === "boolean";
var isBigInt44 = (input) => typeof input === "bigint";
var isSymbol44 = (input) => typeof input === "symbol";
var isFunction83 = isFunction73;
var isUndefined44 = (input) => input === void 0;
var isNotUndefined44 = (input) => input !== void 0;
var isNull44 = (input) => input === null;
var isNotNull44 = (input) => input !== null;
var isNever44 = (_322) => false;
var isUnknown44 = (_322) => true;
var isRecordOrArray44 = (input) => typeof input === "object" && input !== null;
var isObject44 = (input) => isRecordOrArray44(input) || isFunction83(input);
var hasProperty44 = /* @__PURE__ */ dual44(2, (self2, property) => isObject44(self2) && property in self2);
var isTagged44 = /* @__PURE__ */ dual44(2, (self2, tag) => hasProperty44(self2, "_tag") && self2["_tag"] === tag);
var isNullable44 = (input) => input === null || input === void 0;
var isNotNullable44 = (input) => input !== null && input !== void 0;
var isError44 = (input) => input instanceof Error;
var isUint8Array44 = (input) => input instanceof Uint8Array;
var isDate44 = (input) => input instanceof Date;
var isIterable44 = (input) => hasProperty44(input, Symbol.iterator);
var isRecord44 = (input) => isRecordOrArray44(input) && !Array.isArray(input);
var isReadonlyRecord44 = isRecord44;
var isPromise44 = (input) => hasProperty44(input, "then") && "catch" in input && isFunction83(input.then) && isFunction83(input.catch);
var isPromiseLike44 = (input) => hasProperty44(input, "then") && isFunction83(input.then);
var compose74 = /* @__PURE__ */ dual44(2, (ab, bc) => (a322) => ab(a322) && bc(a322));
var product64 = (self2, that) => ([a322, b322]) => self2(a322) && that(b322);
var all64 = (collection) => {
  return (as622) => {
    let collectionIndex = 0;
    for (const p322 of collection) {
      if (collectionIndex >= as622.length) {
        break;
      }
      if (p322(as622[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany64 = (self2, collection) => {
  const rest = all64(collection);
  return ([head34, ...tail34]) => self2(head34) === false ? false : rest(tail34);
};
var tuple54 = (...elements) => all64(elements);
var struct64 = (fields) => {
  const keys522 = Object.keys(fields);
  return (a322) => {
    for (const key of keys522) {
      if (!fields[key](a322[key])) {
        return false;
      }
    }
    return true;
  };
};
var not44 = (self2) => (a322) => !self2(a322);
var or44 = /* @__PURE__ */ dual44(2, (self2, that) => (a322) => self2(a322) || that(a322));
var and44 = /* @__PURE__ */ dual44(2, (self2, that) => (a322) => self2(a322) && that(a322));
var xor44 = /* @__PURE__ */ dual44(2, (self2, that) => (a322) => self2(a322) !== that(a322));
var eqv44 = /* @__PURE__ */ dual44(2, (self2, that) => (a322) => self2(a322) === that(a322));
var implies44 = /* @__PURE__ */ dual44(2, (self2, that) => (a322) => self2(a322) ? that(a322) : true);
var nor44 = /* @__PURE__ */ dual44(2, (self2, that) => (a322) => !(self2(a322) || that(a322)));
var nand44 = /* @__PURE__ */ dual44(2, (self2, that) => (a322) => !(self2(a322) && that(a322)));
var every54 = (collection) => (a322) => {
  for (const p322 of collection) {
    if (!p322(a322)) {
      return false;
    }
  }
  return true;
};
var some94 = (collection) => (a322) => {
  for (const p322 of collection) {
    if (p322(a322)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage44 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId44 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind44 = (u322) => isObject44(u322) && GenKindTypeId44 in u322;
var GenKindImpl44 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity44;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_322) => _322;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_322) => _322;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_322) => _322;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId44] = GenKindTypeId44;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen54(this);
  }
};
var SingleShotGen54 = class _SingleShotGen74 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a322) {
    return this.called ? {
      value: a322,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a322) {
    return {
      value: a322,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e322) {
    throw e322;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen74(this.self);
  }
};
var adapter64 = () => function() {
  let x322 = arguments[0];
  for (let i322 = 1; i322 < arguments.length; i322++) {
    x322 = arguments[i322](x322);
  }
  return new GenKindImpl44(x322);
};
var defaultIncHi44 = 335903614;
var defaultIncLo44 = 4150755663;
var MUL_HI44 = 1481765933 >>> 0;
var MUL_LO44 = 1284865837 >>> 0;
var BIT_5344 = 9007199254740992;
var BIT_2744 = 134217728;
var PCGRandom44 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable44(seedLo) && isNullable44(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable44(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable44(incLo) && isNullable44(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo44;
      incHi = this._state ? this._state[2] : defaultIncHi44;
    } else if (isNullable44(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add6444(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max34) {
    if (!max34) {
      return this._next();
    }
    max34 = max34 >>> 0;
    if ((max34 & max34 - 1) === 0) {
      return this._next() & max34 - 1;
    }
    let num = 0;
    const skew = (-max34 >>> 0) % max34 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max34;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_2744 + lo) / BIT_5344;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul6444(this._state, oldHi, oldLo, MUL_HI44, MUL_LO44);
    add6444(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul6444(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add6444(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId44 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap44 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId44]() {
    return this.#value;
  }
};
function yieldWrapGet44(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId44 in self2) {
    return self2[YieldWrapTypeId44]();
  }
  throw new Error(getBugErrorMessage44("yieldWrapGet"));
}
var structuralRegionState44 = /* @__PURE__ */ globalValue44("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache44 = /* @__PURE__ */ globalValue44(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr44 = /* @__PURE__ */ globalValue44(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom44());
var symbol64 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash44 = (self2) => {
  if (structuralRegionState44.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number54(self2);
    case "bigint":
      return string44(self2.toString(10));
    case "boolean":
      return string44(String(self2));
    case "symbol":
      return string44(String(self2));
    case "string":
      return string44(self2);
    case "undefined":
      return string44("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string44("null");
      } else if (self2 instanceof Date) {
        return hash44(self2.toISOString());
      } else if (isHash44(self2)) {
        return self2[symbol64]();
      } else {
        return random44(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random44 = (self2) => {
  if (!randomHashCache44.has(self2)) {
    randomHashCache44.set(self2, number54(pcgr44.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache44.get(self2);
};
var combine54 = (b322) => (self2) => self2 * 53 ^ b322;
var optimize44 = (n322) => n322 & 3221225471 | n322 >>> 1 & 1073741824;
var isHash44 = (u322) => hasProperty44(u322, symbol64);
var number54 = (n322) => {
  if (n322 !== n322 || n322 === Infinity) {
    return 0;
  }
  let h322 = n322 | 0;
  if (h322 !== n322) {
    h322 ^= n322 * 4294967295;
  }
  while (n322 > 4294967295) {
    h322 ^= n322 /= 4294967295;
  }
  return optimize44(n322);
};
var string44 = (str) => {
  let h322 = 5381, i322 = str.length;
  while (i322) {
    h322 = h322 * 33 ^ str.charCodeAt(--i322);
  }
  return optimize44(h322);
};
var cached44 = function() {
  if (arguments.length === 1) {
    const self3 = arguments[0];
    return function(hash722) {
      Object.defineProperty(self3, symbol64, {
        value() {
          return hash722;
        },
        enumerable: false
      });
      return hash722;
    };
  }
  const self2 = arguments[0];
  const hash622 = arguments[1];
  Object.defineProperty(self2, symbol64, {
    value() {
      return hash622;
    },
    enumerable: false
  });
  return hash622;
};
var symbol74 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals44() {
  if (arguments.length === 1) {
    return (self2) => compareBoth44(self2, arguments[0]);
  }
  return compareBoth44(arguments[0], arguments[1]);
}
function compareBoth44(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual44(self2) && isEqual44(that)) {
        if (hash44(self2) === hash44(that) && self2[symbol74](that)) {
          return true;
        } else {
          return structuralRegionState44.enabled && structuralRegionState44.tester ? structuralRegionState44.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState44.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v322, i322) => compareBoth44(v322, that[i322]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth44(self2[key], that[key]))) {
              return structuralRegionState44.tester ? structuralRegionState44.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState44.tester ? structuralRegionState44.tester(self2, that) : false;
    }
  }
  return structuralRegionState44.enabled && structuralRegionState44.tester ? structuralRegionState44.tester(self2, that) : false;
}
var isEqual44 = (u322) => hasProperty44(u322, symbol74);
var equivalence44 = () => equals44;
var NodeInspectSymbol44 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON44 = (x322) => {
  if (hasProperty44(x322, "toJSON") && isFunction83(x322["toJSON"]) && x322["toJSON"].length === 0) {
    return x322.toJSON();
  } else if (Array.isArray(x322)) {
    return x322.map(toJSON44);
  }
  return x322;
};
var format44 = (x322) => JSON.stringify(x322, null, 2);
var pipeArguments44 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i322 = 0, len = args.length; i322 < len; i322++) {
        ret = args[i322](ret);
      }
      return ret;
    }
  }
};
var EffectTypeId54 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId44 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId44 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId44 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance44 = {
  /* c8 ignore next */
  _R: (_322) => _322,
  /* c8 ignore next */
  _E: (_322) => _322,
  /* c8 ignore next */
  _A: (_322) => _322,
  _V: /* @__PURE__ */ getCurrentVersion44()
};
var sinkVariance44 = {
  /* c8 ignore next */
  _A: (_322) => _322,
  /* c8 ignore next */
  _In: (_322) => _322,
  /* c8 ignore next */
  _L: (_322) => _322,
  /* c8 ignore next */
  _E: (_322) => _322,
  /* c8 ignore next */
  _R: (_322) => _322
};
var channelVariance44 = {
  /* c8 ignore next */
  _Env: (_322) => _322,
  /* c8 ignore next */
  _InErr: (_322) => _322,
  /* c8 ignore next */
  _InElem: (_322) => _322,
  /* c8 ignore next */
  _InDone: (_322) => _322,
  /* c8 ignore next */
  _OutErr: (_322) => _322,
  /* c8 ignore next */
  _OutElem: (_322) => _322,
  /* c8 ignore next */
  _OutDone: (_322) => _322
};
var EffectPrototype44 = {
  [EffectTypeId54]: effectVariance44,
  [StreamTypeId44]: effectVariance44,
  [SinkTypeId44]: sinkVariance44,
  [ChannelTypeId44]: channelVariance44,
  [symbol74](that) {
    return this === that;
  },
  [symbol64]() {
    return cached44(this, random44(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen54(new YieldWrap44(this));
  },
  pipe() {
    return pipeArguments44(this, arguments);
  }
};
var TypeId104 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto64 = {
  ...EffectPrototype44,
  [TypeId104]: {
    _A: (_322) => _322
  },
  [NodeInspectSymbol44]() {
    return this.toJSON();
  },
  toString() {
    return format44(this.toJSON());
  }
};
var SomeProto44 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto64), {
  _tag: "Some",
  _op: "Some",
  [symbol74](that) {
    return isOption64(that) && isSome64(that) && equals44(this.value, that.value);
  },
  [symbol64]() {
    return cached44(this, combine54(hash44(this._tag))(hash44(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON44(this.value)
    };
  }
});
var NoneHash44 = /* @__PURE__ */ hash44("None");
var NoneProto44 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto64), {
  _tag: "None",
  _op: "None",
  [symbol74](that) {
    return isOption64(that) && isNone64(that);
  },
  [symbol64]() {
    return NoneHash44;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption64 = (input) => hasProperty44(input, TypeId104);
var isNone64 = (fa) => fa._tag === "None";
var isSome64 = (fa) => fa._tag === "Some";
var none64 = /* @__PURE__ */ Object.create(NoneProto44);
var some104 = (value) => {
  const a322 = Object.create(SomeProto44);
  a322.value = value;
  return a322;
};
var TypeId114 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto74 = {
  ...EffectPrototype44,
  [TypeId114]: {
    _R: (_322) => _322
  },
  [NodeInspectSymbol44]() {
    return this.toJSON();
  },
  toString() {
    return format44(this.toJSON());
  }
};
var RightProto44 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto74), {
  _tag: "Right",
  _op: "Right",
  [symbol74](that) {
    return isEither44(that) && isRight54(that) && equals44(this.right, that.right);
  },
  [symbol64]() {
    return combine54(hash44(this._tag))(hash44(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON44(this.right)
    };
  }
});
var LeftProto44 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto74), {
  _tag: "Left",
  _op: "Left",
  [symbol74](that) {
    return isEither44(that) && isLeft54(that) && equals44(this.left, that.left);
  },
  [symbol64]() {
    return combine54(hash44(this._tag))(hash44(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON44(this.left)
    };
  }
});
var isEither44 = (input) => hasProperty44(input, TypeId114);
var isLeft54 = (ma) => ma._tag === "Left";
var isRight54 = (ma) => ma._tag === "Right";
var left54 = (left722) => {
  const a322 = Object.create(LeftProto44);
  a322.left = left722;
  return a322;
};
var right54 = (right722) => {
  const a322 = Object.create(RightProto44);
  a322.right = right722;
  return a322;
};
var getLeft64 = (self2) => isRight54(self2) ? none64 : some104(self2.left);
var getRight64 = (self2) => isLeft54(self2) ? none64 : some104(self2.right);
var Option_exports44 = {};
__export26(Option_exports44, {
  Do: () => Do54,
  TypeId: () => TypeId123,
  all: () => all74,
  andThen: () => andThen44,
  ap: () => ap44,
  as: () => as44,
  asVoid: () => asVoid44,
  bind: () => bind84,
  bindTo: () => bindTo84,
  composeK: () => composeK44,
  contains: () => contains54,
  containsWith: () => containsWith54,
  exists: () => exists44,
  filter: () => filter54,
  filterMap: () => filterMap54,
  firstSomeOf: () => firstSomeOf44,
  flatMap: () => flatMap54,
  flatMapNullable: () => flatMapNullable54,
  flatten: () => flatten54,
  fromIterable: () => fromIterable64,
  fromNullable: () => fromNullable54,
  gen: () => gen44,
  getEquivalence: () => getEquivalence64,
  getLeft: () => getLeft74,
  getOrElse: () => getOrElse44,
  getOrNull: () => getOrNull44,
  getOrThrow: () => getOrThrow44,
  getOrThrowWith: () => getOrThrowWith44,
  getOrUndefined: () => getOrUndefined44,
  getOrder: () => getOrder54,
  getRight: () => getRight74,
  isNone: () => isNone74,
  isOption: () => isOption74,
  isSome: () => isSome74,
  let: () => let_84,
  lift2: () => lift244,
  liftNullable: () => liftNullable54,
  liftPredicate: () => liftPredicate54,
  liftThrowable: () => liftThrowable44,
  map: () => map54,
  match: () => match63,
  none: () => none74,
  orElse: () => orElse44,
  orElseEither: () => orElseEither44,
  orElseSome: () => orElseSome44,
  partitionMap: () => partitionMap54,
  product: () => product74,
  productMany: () => productMany74,
  reduceCompact: () => reduceCompact44,
  some: () => some113,
  tap: () => tap44,
  toArray: () => toArray44,
  toRefinement: () => toRefinement44,
  void: () => void_44,
  zipLeft: () => zipLeft44,
  zipRight: () => zipRight44,
  zipWith: () => zipWith54
});
var make134 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId123 = /* @__PURE__ */ Symbol.for("effect/Option");
var none74 = () => none64;
var some113 = some104;
var isOption74 = isOption64;
var isNone74 = isNone64;
var isSome74 = isSome64;
var match63 = /* @__PURE__ */ dual44(2, (self2, {
  onNone,
  onSome
}) => isNone74(self2) ? onNone() : onSome(self2.value));
var toRefinement44 = (f322) => (a322) => isSome74(f322(a322));
var fromIterable64 = (collection) => {
  for (const a322 of collection) {
    return some113(a322);
  }
  return none74();
};
var getRight74 = getRight64;
var getLeft74 = getLeft64;
var getOrElse44 = /* @__PURE__ */ dual44(2, (self2, onNone) => isNone74(self2) ? onNone() : self2.value);
var orElse44 = /* @__PURE__ */ dual44(2, (self2, that) => isNone74(self2) ? that() : self2);
var orElseSome44 = /* @__PURE__ */ dual44(2, (self2, onNone) => isNone74(self2) ? some113(onNone()) : self2);
var orElseEither44 = /* @__PURE__ */ dual44(2, (self2, that) => isNone74(self2) ? map54(that(), right54) : map54(self2, left54));
var firstSomeOf44 = (collection) => {
  let out = none74();
  for (out of collection) {
    if (isSome74(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable54 = (nullableValue) => nullableValue == null ? none74() : some113(nullableValue);
var liftNullable54 = (f322) => (...a322) => fromNullable54(f322(...a322));
var getOrNull44 = /* @__PURE__ */ getOrElse44(constNull44);
var getOrUndefined44 = /* @__PURE__ */ getOrElse44(constUndefined44);
var liftThrowable44 = (f322) => (...a322) => {
  try {
    return some113(f322(...a322));
  } catch (e322) {
    return none74();
  }
};
var getOrThrowWith44 = /* @__PURE__ */ dual44(2, (self2, onNone) => {
  if (isSome74(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow44 = /* @__PURE__ */ getOrThrowWith44(() => new Error("getOrThrow called on a None"));
var map54 = /* @__PURE__ */ dual44(2, (self2, f322) => isNone74(self2) ? none74() : some113(f322(self2.value)));
var as44 = /* @__PURE__ */ dual44(2, (self2, b322) => map54(self2, () => b322));
var asVoid44 = /* @__PURE__ */ as44(void 0);
var void_44 = /* @__PURE__ */ some113(void 0);
var flatMap54 = /* @__PURE__ */ dual44(2, (self2, f322) => isNone74(self2) ? none74() : f322(self2.value));
var andThen44 = /* @__PURE__ */ dual44(2, (self2, f322) => flatMap54(self2, (a322) => {
  const b322 = isFunction73(f322) ? f322(a322) : f322;
  return isOption74(b322) ? b322 : some113(b322);
}));
var flatMapNullable54 = /* @__PURE__ */ dual44(2, (self2, f322) => isNone74(self2) ? none74() : fromNullable54(f322(self2.value)));
var flatten54 = /* @__PURE__ */ flatMap54(identity44);
var zipRight44 = /* @__PURE__ */ dual44(2, (self2, that) => flatMap54(self2, () => that));
var composeK44 = /* @__PURE__ */ dual44(2, (afb, bfc) => (a322) => flatMap54(afb(a322), bfc));
var zipLeft44 = /* @__PURE__ */ dual44(2, (self2, that) => tap44(self2, () => that));
var tap44 = /* @__PURE__ */ dual44(2, (self2, f322) => flatMap54(self2, (a322) => map54(f322(a322), () => a322)));
var product74 = (self2, that) => isSome74(self2) && isSome74(that) ? some113([self2.value, that.value]) : none74();
var productMany74 = (self2, collection) => {
  if (isNone74(self2)) {
    return none74();
  }
  const out = [self2.value];
  for (const o322 of collection) {
    if (isNone74(o322)) {
      return none74();
    }
    out.push(o322.value);
  }
  return some113(out);
};
var all74 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o322 of input) {
      if (isNone74(o322)) {
        return none74();
      }
      out2.push(o322.value);
    }
    return some113(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o322 = input[key];
    if (isNone74(o322)) {
      return none74();
    }
    out[key] = o322.value;
  }
  return some113(out);
};
var zipWith54 = /* @__PURE__ */ dual44(3, (self2, that, f322) => map54(product74(self2, that), ([a322, b322]) => f322(a322, b322)));
var ap44 = /* @__PURE__ */ dual44(2, (self2, that) => zipWith54(self2, that, (f322, a322) => f322(a322)));
var reduceCompact44 = /* @__PURE__ */ dual44(3, (self2, b322, f322) => {
  let out = b322;
  for (const oa of self2) {
    if (isSome74(oa)) {
      out = f322(out, oa.value);
    }
  }
  return out;
});
var toArray44 = (self2) => isNone74(self2) ? [] : [self2.value];
var partitionMap54 = /* @__PURE__ */ dual44(2, (self2, f322) => {
  if (isNone74(self2)) {
    return [none74(), none74()];
  }
  const e322 = f322(self2.value);
  return isLeft54(e322) ? [some113(e322.left), none74()] : [none74(), some113(e322.right)];
});
var filterMap54 = /* @__PURE__ */ dual44(2, (self2, f322) => isNone74(self2) ? none74() : f322(self2.value));
var filter54 = /* @__PURE__ */ dual44(2, (self2, predicate) => filterMap54(self2, (b322) => predicate(b322) ? some104(b322) : none64));
var getEquivalence64 = (isEquivalent) => make124((x322, y322) => x322 === y322 || (isNone74(x322) ? isNone74(y322) : isNone74(y322) ? false : isEquivalent(x322.value, y322.value)));
var getOrder54 = (O322) => make134((self2, that) => isSome74(self2) ? isSome74(that) ? O322(self2.value, that.value) : 1 : -1);
var lift244 = (f322) => dual44(2, (self2, that) => zipWith54(self2, that, f322));
var liftPredicate54 = (predicate) => (b322) => predicate(b322) ? some113(b322) : none74();
var containsWith54 = (isEquivalent) => dual44(2, (self2, a322) => isNone74(self2) ? false : isEquivalent(self2.value, a322));
var _equivalence64 = /* @__PURE__ */ equivalence44();
var contains54 = /* @__PURE__ */ containsWith54(_equivalence64);
var exists44 = /* @__PURE__ */ dual44(2, (self2, refinement) => isNone74(self2) ? false : refinement(self2.value));
var bindTo84 = /* @__PURE__ */ bindTo74(map54);
var let_84 = /* @__PURE__ */ let_74(map54);
var bind84 = /* @__PURE__ */ bind74(map54, flatMap54);
var Do54 = /* @__PURE__ */ some113({});
var adapter74 = /* @__PURE__ */ adapter64();
var gen44 = (f322) => {
  const iterator = f322(adapter74);
  let state = iterator.next();
  if (state.done) {
    return some113(state.value);
  } else {
    let current = state.value;
    if (isGenKind44(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet44(current);
    }
    if (isNone74(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind44(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet44(current);
        }
        if (isNone74(current)) {
          return current;
        }
      }
    }
    return some113(state.value);
  }
};
var MutableRef_exports7 = {};
__export26(MutableRef_exports7, {
  compareAndSet: () => compareAndSet24,
  decrement: () => decrement24,
  decrementAndGet: () => decrementAndGet24,
  get: () => get34,
  getAndDecrement: () => getAndDecrement24,
  getAndIncrement: () => getAndIncrement24,
  getAndSet: () => getAndSet24,
  getAndUpdate: () => getAndUpdate24,
  increment: () => increment24,
  incrementAndGet: () => incrementAndGet24,
  make: () => make143,
  set: () => set34,
  setAndGet: () => setAndGet24,
  toggle: () => toggle24,
  update: () => update24,
  updateAndGet: () => updateAndGet24
});
var TypeId133 = /* @__PURE__ */ Symbol.for("effect/MutableRef");
var MutableRefProto24 = {
  [TypeId133]: TypeId133,
  toString() {
    return format44(this.toJSON());
  },
  toJSON() {
    return {
      _id: "MutableRef",
      current: toJSON44(this.current)
    };
  },
  [NodeInspectSymbol44]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments44(this, arguments);
  }
};
var make143 = (value) => {
  const ref = Object.create(MutableRefProto24);
  ref.current = value;
  return ref;
};
var compareAndSet24 = /* @__PURE__ */ dual44(3, (self2, oldValue, newValue) => {
  if (equals44(oldValue, self2.current)) {
    self2.current = newValue;
    return true;
  }
  return false;
});
var decrement24 = (self2) => update24(self2, (n322) => n322 - 1);
var decrementAndGet24 = (self2) => updateAndGet24(self2, (n322) => n322 - 1);
var get34 = (self2) => self2.current;
var getAndDecrement24 = (self2) => getAndUpdate24(self2, (n322) => n322 - 1);
var getAndIncrement24 = (self2) => getAndUpdate24(self2, (n322) => n322 + 1);
var getAndSet24 = /* @__PURE__ */ dual44(2, (self2, value) => {
  const ret = self2.current;
  self2.current = value;
  return ret;
});
var getAndUpdate24 = /* @__PURE__ */ dual44(2, (self2, f322) => getAndSet24(self2, f322(get34(self2))));
var increment24 = (self2) => update24(self2, (n322) => n322 + 1);
var incrementAndGet24 = (self2) => updateAndGet24(self2, (n322) => n322 + 1);
var set34 = /* @__PURE__ */ dual44(2, (self2, value) => {
  self2.current = value;
  return self2;
});
var setAndGet24 = /* @__PURE__ */ dual44(2, (self2, value) => {
  self2.current = value;
  return self2.current;
});
var update24 = /* @__PURE__ */ dual44(2, (self2, f322) => set34(self2, f322(get34(self2))));
var updateAndGet24 = /* @__PURE__ */ dual44(2, (self2, f322) => setAndGet24(self2, f322(get34(self2))));
var toggle24 = (self2) => update24(self2, (_322) => !_322);
var MutableList_exports4 = {};
__export26(MutableList_exports4, {
  append: () => append24,
  empty: () => empty114,
  forEach: () => forEach54,
  fromIterable: () => fromIterable74,
  head: () => head24,
  isEmpty: () => isEmpty34,
  length: () => length24,
  make: () => make153,
  pop: () => pop5,
  prepend: () => prepend44,
  reset: () => reset4,
  shift: () => shift4,
  tail: () => tail24
});
var TypeId143 = /* @__PURE__ */ Symbol.for("effect/MutableList");
var MutableListProto4 = {
  [TypeId143]: TypeId143,
  [Symbol.iterator]() {
    let done = false;
    let head34 = this.head;
    return {
      next() {
        if (done) {
          return this.return();
        }
        if (head34 == null) {
          done = true;
          return this.return();
        }
        const value = head34.value;
        head34 = head34.next;
        return {
          done,
          value
        };
      },
      return(value) {
        if (!done) {
          done = true;
        }
        return {
          done: true,
          value
        };
      }
    };
  },
  toString() {
    return format44(this.toJSON());
  },
  toJSON() {
    return {
      _id: "MutableList",
      values: Array.from(this).map(toJSON44)
    };
  },
  [NodeInspectSymbol44]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments44(this, arguments);
  }
};
var makeNode4 = (value) => ({
  value,
  removed: false,
  prev: void 0,
  next: void 0
});
var empty114 = () => {
  const list = Object.create(MutableListProto4);
  list.head = void 0;
  list.tail = void 0;
  list._length = 0;
  return list;
};
var fromIterable74 = (iterable) => {
  const list = empty114();
  for (const element of iterable) {
    append24(list, element);
  }
  return list;
};
var make153 = (...elements) => fromIterable74(elements);
var isEmpty34 = (self2) => length24(self2) === 0;
var length24 = (self2) => self2._length;
var tail24 = (self2) => self2.tail === void 0 ? void 0 : self2.tail.value;
var head24 = (self2) => self2.head === void 0 ? void 0 : self2.head.value;
var forEach54 = /* @__PURE__ */ dual44(2, (self2, f322) => {
  let current = self2.head;
  while (current !== void 0) {
    f322(current.value);
    current = current.next;
  }
});
var reset4 = (self2) => {
  self2._length = 0;
  self2.head = void 0;
  self2.tail = void 0;
  return self2;
};
var append24 = /* @__PURE__ */ dual44(2, (self2, value) => {
  const node = makeNode4(value);
  if (self2.head === void 0) {
    self2.head = node;
  }
  if (self2.tail === void 0) {
    self2.tail = node;
  } else {
    self2.tail.next = node;
    node.prev = self2.tail;
    self2.tail = node;
  }
  self2._length += 1;
  return self2;
});
var shift4 = (self2) => {
  const head34 = self2.head;
  if (head34 !== void 0) {
    remove24(self2, head34);
    return head34.value;
  }
  return void 0;
};
var pop5 = (self2) => {
  const tail34 = self2.tail;
  if (tail34 !== void 0) {
    remove24(self2, tail34);
    return tail34.value;
  }
  return void 0;
};
var prepend44 = /* @__PURE__ */ dual44(2, (self2, value) => {
  const node = makeNode4(value);
  node.next = self2.head;
  if (self2.head !== void 0) {
    self2.head.prev = node;
  }
  self2.head = node;
  if (self2.tail === void 0) {
    self2.tail = node;
  }
  self2._length += 1;
  return self2;
});
var remove24 = (self2, node) => {
  if (node.removed) {
    return;
  }
  node.removed = true;
  if (node.prev !== void 0 && node.next !== void 0) {
    node.prev.next = node.next;
    node.next.prev = node.prev;
  } else if (node.prev !== void 0) {
    self2.tail = node.prev;
    node.prev.next = void 0;
  } else if (node.next !== void 0) {
    self2.head = node.next;
    node.next.prev = void 0;
  } else {
    self2.tail = void 0;
    self2.head = void 0;
  }
  if (self2._length > 0) {
    self2._length -= 1;
  }
};
var store24;
function getGlobalMessage4(lang) {
  return store24?.get(lang);
}
var store34;
function getSchemaMessage4(lang) {
  return store34?.get(lang);
}
var store44;
function getSpecificMessage4(reference, lang) {
  return store44?.get(reference)?.get(lang);
}
function _stringify4(input) {
  let type = typeof input;
  if (type === "object") {
    type = (input && Object.getPrototypeOf(input)?.constructor?.name) ?? "null";
  }
  return type === "string" ? `"${input}"` : type === "number" || type === "bigint" || type === "boolean" ? `${input}` : type;
}
function _addIssue4(context, label, dataset, config2, other) {
  const input = dataset.value;
  const expected = context.expects;
  const received = _stringify4(input);
  const issue = {
    kind: context.kind,
    type: context.type,
    input,
    expected,
    received,
    message: `Invalid ${label}: ${expected ? `Expected ${expected} but r` : "R"}eceived ${received}`,
    // @ts-expect-error
    requirement: context.requirement,
    path: other?.path,
    issues: other?.issues,
    lang: config2.lang,
    abortEarly: config2.abortEarly,
    abortPipeEarly: config2.abortPipeEarly,
    skipPipe: config2.skipPipe
  };
  const isSchema = context.kind === "schema";
  const message = (
    // @ts-expect-error
    context.message ?? getSpecificMessage4(context.reference, issue.lang) ?? (isSchema ? getSchemaMessage4(issue.lang) : null) ?? config2.message ?? getGlobalMessage4(issue.lang)
  );
  if (message) {
    issue.message = typeof message === "function" ? message(issue) : message;
  }
  if (isSchema) {
    dataset.typed = false;
  }
  if (dataset.issues) {
    dataset.issues.push(issue);
  } else {
    dataset.issues = [issue];
  }
}
function getDefault4(schema4, dataset, config2) {
  return typeof schema4.default === "function" ? (
    // @ts-expect-error
    schema4.default(dataset, config2)
  ) : (
    // @ts-expect-error
    schema4.default
  );
}
function array64(item, message) {
  return {
    kind: "schema",
    type: "array",
    reference: array64,
    expects: "Array",
    async: false,
    item,
    message,
    _run(dataset, config2) {
      const input = dataset.value;
      if (Array.isArray(input)) {
        dataset.typed = true;
        dataset.value = [];
        for (let key = 0; key < input.length; key++) {
          const value2 = input[key];
          const itemDataset = this.item._run({ typed: false, value: value2 }, config2);
          if (itemDataset.issues) {
            const pathItem = {
              type: "array",
              origin: "value",
              input,
              key,
              value: value2
            };
            for (const issue of itemDataset.issues) {
              if (issue.path) {
                issue.path.unshift(pathItem);
              } else {
                issue.path = [pathItem];
              }
              dataset.issues?.push(issue);
            }
            if (!dataset.issues) {
              dataset.issues = itemDataset.issues;
            }
            if (config2.abortEarly) {
              dataset.typed = false;
              break;
            }
          }
          if (!itemDataset.typed) {
            dataset.typed = false;
          }
          dataset.value.push(itemDataset.value);
        }
      } else {
        _addIssue4(this, "type", dataset, config2);
      }
      return dataset;
    }
  };
}
function object4(entries2, message) {
  return {
    kind: "schema",
    type: "object",
    reference: object4,
    expects: "Object",
    async: false,
    entries: entries2,
    message,
    _run(dataset, config2) {
      const input = dataset.value;
      if (input && typeof input === "object") {
        dataset.typed = true;
        dataset.value = {};
        for (const key in this.entries) {
          const value2 = input[key];
          const valueDataset = this.entries[key]._run(
            { typed: false, value: value2 },
            config2
          );
          if (valueDataset.issues) {
            const pathItem = {
              type: "object",
              origin: "value",
              input,
              key,
              value: value2
            };
            for (const issue of valueDataset.issues) {
              if (issue.path) {
                issue.path.unshift(pathItem);
              } else {
                issue.path = [pathItem];
              }
              dataset.issues?.push(issue);
            }
            if (!dataset.issues) {
              dataset.issues = valueDataset.issues;
            }
            if (config2.abortEarly) {
              dataset.typed = false;
              break;
            }
          }
          if (!valueDataset.typed) {
            dataset.typed = false;
          }
          if (valueDataset.value !== void 0 || key in input) {
            dataset.value[key] = valueDataset.value;
          }
        }
      } else {
        _addIssue4(this, "type", dataset, config2);
      }
      return dataset;
    }
  };
}
function optional4(wrapped, ...args) {
  const schema4 = {
    kind: "schema",
    type: "optional",
    reference: optional4,
    expects: `${wrapped.expects} | undefined`,
    async: false,
    wrapped,
    _run(dataset, config2) {
      if (dataset.value === void 0) {
        if ("default" in this) {
          dataset.value = getDefault4(
            this,
            dataset,
            config2
          );
        }
        if (dataset.value === void 0) {
          dataset.typed = true;
          return dataset;
        }
      }
      return this.wrapped._run(dataset, config2);
    }
  };
  if (0 in args) {
    schema4.default = args[0];
  }
  return schema4;
}
function string54(message) {
  return {
    kind: "schema",
    type: "string",
    reference: string54,
    expects: "string",
    async: false,
    message,
    _run(dataset, config2) {
      if (typeof dataset.value === "string") {
        dataset.typed = true;
      } else {
        _addIssue4(this, "type", dataset, config2);
      }
      return dataset;
    }
  };
}
var ESLintReactSettingsSchema4 = object4({
  additionalHooks: optional4(object4({
    use: optional4(string54()),
    useCallback: optional4(array64(string54())),
    useContext: optional4(array64(string54())),
    useDebugValue: optional4(array64(string54())),
    useDeferredValue: optional4(array64(string54())),
    useEffect: optional4(array64(string54())),
    useId: optional4(array64(string54())),
    useImperativeHandle: optional4(array64(string54())),
    useInsertionEffect: optional4(array64(string54())),
    useLayoutEffect: optional4(array64(string54())),
    useMemo: optional4(array64(string54())),
    useOptimistic: optional4(array64(string54())),
    useReducer: optional4(array64(string54())),
    useRef: optional4(array64(string54())),
    useState: optional4(array64(string54())),
    useSyncExternalStore: optional4(array64(string54())),
    useTransition: optional4(array64(string54()))
  })),
  importSource: optional4(string54()),
  jsxPragma: optional4(string54()),
  jsxPragmaFrag: optional4(string54()),
  version: optional4(string54())
});
var ESLintSettingsSchema3 = object4({
  reactOptions: optional4(ESLintReactSettingsSchema4)
});
var __defProp44 = Object.defineProperty;
var __export44 = (target, all334) => {
  for (var name22 in all334)
    __defProp44(target, name22, { get: all334[name22], enumerable: true });
};
var Function_exports54 = {};
__export44(Function_exports54, {
  SK: () => SK54,
  absurd: () => absurd54,
  apply: () => apply54,
  compose: () => compose83,
  constFalse: () => constFalse54,
  constNull: () => constNull54,
  constTrue: () => constTrue54,
  constUndefined: () => constUndefined54,
  constVoid: () => constVoid54,
  constant: () => constant54,
  dual: () => dual54,
  flip: () => flip54,
  flow: () => flow54,
  hole: () => hole54,
  identity: () => identity54,
  isFunction: () => isFunction93,
  pipe: () => pipe54,
  satisfies: () => satisfies54,
  tupled: () => tupled54,
  unsafeCoerce: () => unsafeCoerce54,
  untupled: () => untupled54
});
var isFunction93 = (input) => typeof input === "function";
var dual54 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a2222, b2222) {
        if (arguments.length >= 2) {
          return body(a2222, b2222);
        }
        return function(self2) {
          return body(self2, a2222);
        };
      };
    case 3:
      return function(a2222, b2222, c2222) {
        if (arguments.length >= 3) {
          return body(a2222, b2222, c2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222);
        };
      };
    case 4:
      return function(a2222, b2222, c2222, d2222) {
        if (arguments.length >= 4) {
          return body(a2222, b2222, c2222, d2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222);
        };
      };
    case 5:
      return function(a2222, b2222, c2222, d2222, e2222) {
        if (arguments.length >= 5) {
          return body(a2222, b2222, c2222, d2222, e2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222, d2222);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply54 = (a2222) => (self2) => self2(a2222);
var identity54 = (a2222) => a2222;
var satisfies54 = () => (b2222) => b2222;
var unsafeCoerce54 = identity54;
var constant54 = (value) => () => value;
var constTrue54 = /* @__PURE__ */ constant54(true);
var constFalse54 = /* @__PURE__ */ constant54(false);
var constNull54 = /* @__PURE__ */ constant54(null);
var constUndefined54 = /* @__PURE__ */ constant54(void 0);
var constVoid54 = constUndefined54;
var flip54 = (f2222) => (...b2222) => (...a2222) => f2222(...a2222)(...b2222);
var compose83 = /* @__PURE__ */ dual54(2, (ab, bc) => (a2222) => bc(ab(a2222)));
var absurd54 = (_2222) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled54 = (f2222) => (a2222) => f2222(...a2222);
var untupled54 = (f2222) => (...a2222) => f2222(a2222);
function pipe54(a2222, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a2222;
    case 2:
      return ab(a2222);
    case 3:
      return bc(ab(a2222));
    case 4:
      return cd(bc(ab(a2222)));
    case 5:
      return de(cd(bc(ab(a2222))));
    case 6:
      return ef(de(cd(bc(ab(a2222)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a2222))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a2222)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a2222))))))));
    default: {
      let ret = arguments[0];
      for (let i2222 = 1; i2222 < arguments.length; i2222++) {
        ret = arguments[i2222](ret);
      }
      return ret;
    }
  }
}
function flow54(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole54 = /* @__PURE__ */ unsafeCoerce54(absurd54);
var SK54 = (_2222, b2222) => b2222;
var make163 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_93 = (map324) => dual54(3, (self2, name22, f2222) => map324(self2, (a2222) => Object.assign({}, a2222, {
  [name22]: f2222(a2222)
})));
var bindTo93 = (map324) => dual54(2, (self2, name22) => map324(self2, (a2222) => ({
  [name22]: a2222
})));
var bind93 = (map324, flatMap324) => dual54(3, (self2, name22, f2222) => flatMap324(self2, (a2222) => map324(f2222(a2222), (b2222) => Object.assign({}, a2222, {
  [name22]: b2222
}))));
var moduleVersion54 = "3.2.8";
var getCurrentVersion54 = () => moduleVersion54;
var globalStoreId54 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion54()}`);
if (!(globalStoreId54 in globalThis)) {
  globalThis[globalStoreId54] = /* @__PURE__ */ new Map();
}
var globalStore54 = globalThis[globalStoreId54];
var globalValue54 = (id, compute) => {
  if (!globalStore54.has(id)) {
    globalStore54.set(id, compute());
  }
  return globalStore54.get(id);
};
var isFunction234 = isFunction93;
var isRecordOrArray54 = (input) => typeof input === "object" && input !== null;
var isObject54 = (input) => isRecordOrArray54(input) || isFunction234(input);
var hasProperty54 = /* @__PURE__ */ dual54(2, (self2, property) => isObject54(self2) && property in self2);
var isNullable54 = (input) => input === null || input === void 0;
var getBugErrorMessage54 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId54 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind54 = (u2222) => isObject54(u2222) && GenKindTypeId54 in u2222;
var GenKindImpl54 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity54;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId54] = GenKindTypeId54;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen64(this);
  }
};
var SingleShotGen64 = class _SingleShotGen333 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a2222) {
    return this.called ? {
      value: a2222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a2222) {
    return {
      value: a2222,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e2222) {
    throw e2222;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen333(this.self);
  }
};
var adapter83 = () => function() {
  let x2222 = arguments[0];
  for (let i2222 = 1; i2222 < arguments.length; i2222++) {
    x2222 = arguments[i2222](x2222);
  }
  return new GenKindImpl54(x2222);
};
var defaultIncHi54 = 335903614;
var defaultIncLo54 = 4150755663;
var MUL_HI54 = 1481765933 >>> 0;
var MUL_LO54 = 1284865837 >>> 0;
var BIT_5354 = 9007199254740992;
var BIT_2754 = 134217728;
var PCGRandom54 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable54(seedLo) && isNullable54(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable54(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable54(incLo) && isNullable54(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo54;
      incHi = this._state ? this._state[2] : defaultIncHi54;
    } else if (isNullable54(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add6454(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max34) {
    if (!max34) {
      return this._next();
    }
    max34 = max34 >>> 0;
    if ((max34 & max34 - 1) === 0) {
      return this._next() & max34 - 1;
    }
    let num = 0;
    const skew = (-max34 >>> 0) % max34 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max34;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_2754 + lo) / BIT_5354;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul6454(this._state, oldHi, oldLo, MUL_HI54, MUL_LO54);
    add6454(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul6454(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add6454(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId54 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap54 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId54]() {
    return this.#value;
  }
};
function yieldWrapGet54(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId54 in self2) {
    return self2[YieldWrapTypeId54]();
  }
  throw new Error(getBugErrorMessage54("yieldWrapGet"));
}
var structuralRegionState54 = /* @__PURE__ */ globalValue54("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache54 = /* @__PURE__ */ globalValue54(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr54 = /* @__PURE__ */ globalValue54(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom54());
var symbol83 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash54 = (self2) => {
  if (structuralRegionState54.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number64(self2);
    case "bigint":
      return string64(self2.toString(10));
    case "boolean":
      return string64(String(self2));
    case "symbol":
      return string64(String(self2));
    case "string":
      return string64(self2);
    case "undefined":
      return string64("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string64("null");
      } else if (self2 instanceof Date) {
        return hash54(self2.toISOString());
      } else if (isHash54(self2)) {
        return self2[symbol83]();
      } else {
        return random54(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random54 = (self2) => {
  if (!randomHashCache54.has(self2)) {
    randomHashCache54.set(self2, number64(pcgr54.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache54.get(self2);
};
var combine64 = (b2222) => (self2) => self2 * 53 ^ b2222;
var optimize54 = (n2222) => n2222 & 3221225471 | n2222 >>> 1 & 1073741824;
var isHash54 = (u2222) => hasProperty54(u2222, symbol83);
var number64 = (n2222) => {
  if (n2222 !== n2222 || n2222 === Infinity) {
    return 0;
  }
  let h2222 = n2222 | 0;
  if (h2222 !== n2222) {
    h2222 ^= n2222 * 4294967295;
  }
  while (n2222 > 4294967295) {
    h2222 ^= n2222 /= 4294967295;
  }
  return optimize54(n2222);
};
var string64 = (str) => {
  let h2222 = 5381, i2222 = str.length;
  while (i2222) {
    h2222 = h2222 * 33 ^ str.charCodeAt(--i2222);
  }
  return optimize54(h2222);
};
var cached54 = function() {
  if (arguments.length === 1) {
    const self3 = arguments[0];
    return function(hash422) {
      Object.defineProperty(self3, symbol83, {
        value() {
          return hash422;
        },
        enumerable: false
      });
      return hash422;
    };
  }
  const self2 = arguments[0];
  const hash324 = arguments[1];
  Object.defineProperty(self2, symbol83, {
    value() {
      return hash324;
    },
    enumerable: false
  });
  return hash324;
};
var symbol234 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals54() {
  if (arguments.length === 1) {
    return (self2) => compareBoth54(self2, arguments[0]);
  }
  return compareBoth54(arguments[0], arguments[1]);
}
function compareBoth54(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual54(self2) && isEqual54(that)) {
        if (hash54(self2) === hash54(that) && self2[symbol234](that)) {
          return true;
        } else {
          return structuralRegionState54.enabled && structuralRegionState54.tester ? structuralRegionState54.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState54.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v2222, i2222) => compareBoth54(v2222, that[i2222]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth54(self2[key], that[key]))) {
              return structuralRegionState54.tester ? structuralRegionState54.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState54.tester ? structuralRegionState54.tester(self2, that) : false;
    }
  }
  return structuralRegionState54.enabled && structuralRegionState54.tester ? structuralRegionState54.tester(self2, that) : false;
}
var isEqual54 = (u2222) => hasProperty54(u2222, symbol234);
var equivalence54 = () => equals54;
var NodeInspectSymbol54 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON54 = (x2222) => {
  if (hasProperty54(x2222, "toJSON") && isFunction234(x2222["toJSON"]) && x2222["toJSON"].length === 0) {
    return x2222.toJSON();
  } else if (Array.isArray(x2222)) {
    return x2222.map(toJSON54);
  }
  return x2222;
};
var format54 = (x2222) => JSON.stringify(x2222, null, 2);
var pipeArguments54 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i2222 = 0, len = args.length; i2222 < len; i2222++) {
        ret = args[i2222](ret);
      }
      return ret;
    }
  }
};
var EffectTypeId64 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId54 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId54 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId54 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance54 = {
  /* c8 ignore next */
  _R: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _A: (_2222) => _2222,
  _V: /* @__PURE__ */ getCurrentVersion54()
};
var sinkVariance54 = {
  /* c8 ignore next */
  _A: (_2222) => _2222,
  /* c8 ignore next */
  _In: (_2222) => _2222,
  /* c8 ignore next */
  _L: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _R: (_2222) => _2222
};
var channelVariance54 = {
  /* c8 ignore next */
  _Env: (_2222) => _2222,
  /* c8 ignore next */
  _InErr: (_2222) => _2222,
  /* c8 ignore next */
  _InElem: (_2222) => _2222,
  /* c8 ignore next */
  _InDone: (_2222) => _2222,
  /* c8 ignore next */
  _OutErr: (_2222) => _2222,
  /* c8 ignore next */
  _OutElem: (_2222) => _2222,
  /* c8 ignore next */
  _OutDone: (_2222) => _2222
};
var EffectPrototype54 = {
  [EffectTypeId64]: effectVariance54,
  [StreamTypeId54]: effectVariance54,
  [SinkTypeId54]: sinkVariance54,
  [ChannelTypeId54]: channelVariance54,
  [symbol234](that) {
    return this === that;
  },
  [symbol83]() {
    return cached54(this, random54(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen64(new YieldWrap54(this));
  },
  pipe() {
    return pipeArguments54(this, arguments);
  }
};
var TypeId153 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto83 = {
  ...EffectPrototype54,
  [TypeId153]: {
    _A: (_2222) => _2222
  },
  [NodeInspectSymbol54]() {
    return this.toJSON();
  },
  toString() {
    return format54(this.toJSON());
  }
};
var SomeProto54 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto83), {
  _tag: "Some",
  _op: "Some",
  [symbol234](that) {
    return isOption83(that) && isSome83(that) && equals54(this.value, that.value);
  },
  [symbol83]() {
    return cached54(this, combine64(hash54(this._tag))(hash54(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON54(this.value)
    };
  }
});
var NoneHash54 = /* @__PURE__ */ hash54("None");
var NoneProto54 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto83), {
  _tag: "None",
  _op: "None",
  [symbol234](that) {
    return isOption83(that) && isNone83(that);
  },
  [symbol83]() {
    return NoneHash54;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption83 = (input) => hasProperty54(input, TypeId153);
var isNone83 = (fa) => fa._tag === "None";
var isSome83 = (fa) => fa._tag === "Some";
var none83 = /* @__PURE__ */ Object.create(NoneProto54);
var some123 = (value) => {
  const a2222 = Object.create(SomeProto54);
  a2222.value = value;
  return a2222;
};
var TypeId234 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto234 = {
  ...EffectPrototype54,
  [TypeId234]: {
    _R: (_2222) => _2222
  },
  [NodeInspectSymbol54]() {
    return this.toJSON();
  },
  toString() {
    return format54(this.toJSON());
  }
};
var RightProto54 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto234), {
  _tag: "Right",
  _op: "Right",
  [symbol234](that) {
    return isEither54(that) && isRight64(that) && equals54(this.right, that.right);
  },
  [symbol83]() {
    return combine64(hash54(this._tag))(hash54(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON54(this.right)
    };
  }
});
var LeftProto54 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto234), {
  _tag: "Left",
  _op: "Left",
  [symbol234](that) {
    return isEither54(that) && isLeft64(that) && equals54(this.left, that.left);
  },
  [symbol83]() {
    return combine64(hash54(this._tag))(hash54(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON54(this.left)
    };
  }
});
var isEither54 = (input) => hasProperty54(input, TypeId234);
var isLeft64 = (ma) => ma._tag === "Left";
var isRight64 = (ma) => ma._tag === "Right";
var left64 = (left334) => {
  const a2222 = Object.create(LeftProto54);
  a2222.left = left334;
  return a2222;
};
var right64 = (right334) => {
  const a2222 = Object.create(RightProto54);
  a2222.right = right334;
  return a2222;
};
var getLeft83 = (self2) => isRight64(self2) ? none83 : some123(self2.left);
var getRight83 = (self2) => isLeft64(self2) ? none83 : some123(self2.right);
var Option_exports54 = {};
__export44(Option_exports54, {
  Do: () => Do64,
  TypeId: () => TypeId334,
  all: () => all83,
  andThen: () => andThen54,
  ap: () => ap54,
  as: () => as54,
  asVoid: () => asVoid54,
  bind: () => bind234,
  bindTo: () => bindTo234,
  composeK: () => composeK54,
  contains: () => contains64,
  containsWith: () => containsWith64,
  exists: () => exists54,
  filter: () => filter64,
  filterMap: () => filterMap64,
  firstSomeOf: () => firstSomeOf54,
  flatMap: () => flatMap64,
  flatMapNullable: () => flatMapNullable64,
  flatten: () => flatten64,
  fromIterable: () => fromIterable83,
  fromNullable: () => fromNullable64,
  gen: () => gen54,
  getEquivalence: () => getEquivalence74,
  getLeft: () => getLeft234,
  getOrElse: () => getOrElse54,
  getOrNull: () => getOrNull54,
  getOrThrow: () => getOrThrow54,
  getOrThrowWith: () => getOrThrowWith54,
  getOrUndefined: () => getOrUndefined54,
  getOrder: () => getOrder64,
  getRight: () => getRight234,
  isNone: () => isNone234,
  isOption: () => isOption234,
  isSome: () => isSome234,
  let: () => let_234,
  lift2: () => lift254,
  liftNullable: () => liftNullable64,
  liftPredicate: () => liftPredicate64,
  liftThrowable: () => liftThrowable54,
  map: () => map64,
  match: () => match73,
  none: () => none234,
  orElse: () => orElse54,
  orElseEither: () => orElseEither54,
  orElseSome: () => orElseSome54,
  partitionMap: () => partitionMap64,
  product: () => product83,
  productMany: () => productMany83,
  reduceCompact: () => reduceCompact54,
  some: () => some234,
  tap: () => tap54,
  toArray: () => toArray54,
  toRefinement: () => toRefinement54,
  void: () => void_54,
  zipLeft: () => zipLeft54,
  zipRight: () => zipRight54,
  zipWith: () => zipWith64
});
var make234 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId334 = /* @__PURE__ */ Symbol.for("effect/Option");
var none234 = () => none83;
var some234 = some123;
var isOption234 = isOption83;
var isNone234 = isNone83;
var isSome234 = isSome83;
var match73 = /* @__PURE__ */ dual54(2, (self2, {
  onNone,
  onSome
}) => isNone234(self2) ? onNone() : onSome(self2.value));
var toRefinement54 = (f2222) => (a2222) => isSome234(f2222(a2222));
var fromIterable83 = (collection) => {
  for (const a2222 of collection) {
    return some234(a2222);
  }
  return none234();
};
var getRight234 = getRight83;
var getLeft234 = getLeft83;
var getOrElse54 = /* @__PURE__ */ dual54(2, (self2, onNone) => isNone234(self2) ? onNone() : self2.value);
var orElse54 = /* @__PURE__ */ dual54(2, (self2, that) => isNone234(self2) ? that() : self2);
var orElseSome54 = /* @__PURE__ */ dual54(2, (self2, onNone) => isNone234(self2) ? some234(onNone()) : self2);
var orElseEither54 = /* @__PURE__ */ dual54(2, (self2, that) => isNone234(self2) ? map64(that(), right64) : map64(self2, left64));
var firstSomeOf54 = (collection) => {
  let out = none234();
  for (out of collection) {
    if (isSome234(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable64 = (nullableValue) => nullableValue == null ? none234() : some234(nullableValue);
var liftNullable64 = (f2222) => (...a2222) => fromNullable64(f2222(...a2222));
var getOrNull54 = /* @__PURE__ */ getOrElse54(constNull54);
var getOrUndefined54 = /* @__PURE__ */ getOrElse54(constUndefined54);
var liftThrowable54 = (f2222) => (...a2222) => {
  try {
    return some234(f2222(...a2222));
  } catch (e2222) {
    return none234();
  }
};
var getOrThrowWith54 = /* @__PURE__ */ dual54(2, (self2, onNone) => {
  if (isSome234(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow54 = /* @__PURE__ */ getOrThrowWith54(() => new Error("getOrThrow called on a None"));
var map64 = /* @__PURE__ */ dual54(2, (self2, f2222) => isNone234(self2) ? none234() : some234(f2222(self2.value)));
var as54 = /* @__PURE__ */ dual54(2, (self2, b2222) => map64(self2, () => b2222));
var asVoid54 = /* @__PURE__ */ as54(void 0);
var void_54 = /* @__PURE__ */ some234(void 0);
var flatMap64 = /* @__PURE__ */ dual54(2, (self2, f2222) => isNone234(self2) ? none234() : f2222(self2.value));
var andThen54 = /* @__PURE__ */ dual54(2, (self2, f2222) => flatMap64(self2, (a2222) => {
  const b2222 = isFunction93(f2222) ? f2222(a2222) : f2222;
  return isOption234(b2222) ? b2222 : some234(b2222);
}));
var flatMapNullable64 = /* @__PURE__ */ dual54(2, (self2, f2222) => isNone234(self2) ? none234() : fromNullable64(f2222(self2.value)));
var flatten64 = /* @__PURE__ */ flatMap64(identity54);
var zipRight54 = /* @__PURE__ */ dual54(2, (self2, that) => flatMap64(self2, () => that));
var composeK54 = /* @__PURE__ */ dual54(2, (afb, bfc) => (a2222) => flatMap64(afb(a2222), bfc));
var zipLeft54 = /* @__PURE__ */ dual54(2, (self2, that) => tap54(self2, () => that));
var tap54 = /* @__PURE__ */ dual54(2, (self2, f2222) => flatMap64(self2, (a2222) => map64(f2222(a2222), () => a2222)));
var product83 = (self2, that) => isSome234(self2) && isSome234(that) ? some234([self2.value, that.value]) : none234();
var productMany83 = (self2, collection) => {
  if (isNone234(self2)) {
    return none234();
  }
  const out = [self2.value];
  for (const o2222 of collection) {
    if (isNone234(o2222)) {
      return none234();
    }
    out.push(o2222.value);
  }
  return some234(out);
};
var all83 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o2222 of input) {
      if (isNone234(o2222)) {
        return none234();
      }
      out2.push(o2222.value);
    }
    return some234(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o2222 = input[key];
    if (isNone234(o2222)) {
      return none234();
    }
    out[key] = o2222.value;
  }
  return some234(out);
};
var zipWith64 = /* @__PURE__ */ dual54(3, (self2, that, f2222) => map64(product83(self2, that), ([a2222, b2222]) => f2222(a2222, b2222)));
var ap54 = /* @__PURE__ */ dual54(2, (self2, that) => zipWith64(self2, that, (f2222, a2222) => f2222(a2222)));
var reduceCompact54 = /* @__PURE__ */ dual54(3, (self2, b2222, f2222) => {
  let out = b2222;
  for (const oa of self2) {
    if (isSome234(oa)) {
      out = f2222(out, oa.value);
    }
  }
  return out;
});
var toArray54 = (self2) => isNone234(self2) ? [] : [self2.value];
var partitionMap64 = /* @__PURE__ */ dual54(2, (self2, f2222) => {
  if (isNone234(self2)) {
    return [none234(), none234()];
  }
  const e2222 = f2222(self2.value);
  return isLeft64(e2222) ? [some234(e2222.left), none234()] : [none234(), some234(e2222.right)];
});
var filterMap64 = /* @__PURE__ */ dual54(2, (self2, f2222) => isNone234(self2) ? none234() : f2222(self2.value));
var filter64 = /* @__PURE__ */ dual54(2, (self2, predicate) => filterMap64(self2, (b2222) => predicate(b2222) ? some123(b2222) : none83));
var getEquivalence74 = (isEquivalent) => make163((x2222, y2222) => x2222 === y2222 || (isNone234(x2222) ? isNone234(y2222) : isNone234(y2222) ? false : isEquivalent(x2222.value, y2222.value)));
var getOrder64 = (O2222) => make234((self2, that) => isSome234(self2) ? isSome234(that) ? O2222(self2.value, that.value) : 1 : -1);
var lift254 = (f2222) => dual54(2, (self2, that) => zipWith64(self2, that, f2222));
var liftPredicate64 = (predicate) => (b2222) => predicate(b2222) ? some234(b2222) : none234();
var containsWith64 = (isEquivalent) => dual54(2, (self2, a2222) => isNone234(self2) ? false : isEquivalent(self2.value, a2222));
var _equivalence74 = /* @__PURE__ */ equivalence54();
var contains64 = /* @__PURE__ */ containsWith64(_equivalence74);
var exists54 = /* @__PURE__ */ dual54(2, (self2, refinement) => isNone234(self2) ? false : refinement(self2.value));
var bindTo234 = /* @__PURE__ */ bindTo93(map64);
var let_234 = /* @__PURE__ */ let_93(map64);
var bind234 = /* @__PURE__ */ bind93(map64, flatMap64);
var Do64 = /* @__PURE__ */ some234({});
var adapter234 = /* @__PURE__ */ adapter83();
var gen54 = (f2222) => {
  const iterator = f2222(adapter234);
  let state = iterator.next();
  if (state.done) {
    return some234(state.value);
  } else {
    let current = state.value;
    if (isGenKind54(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet54(current);
    }
    if (isNone234(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind54(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet54(current);
        }
        if (isNone234(current)) {
          return current;
        }
      }
    }
    return some234(state.value);
  }
};
var MutableRef_exports33 = {};
__export44(MutableRef_exports33, {
  compareAndSet: () => compareAndSet33,
  decrement: () => decrement33,
  decrementAndGet: () => decrementAndGet33,
  get: () => get43,
  getAndDecrement: () => getAndDecrement33,
  getAndIncrement: () => getAndIncrement33,
  getAndSet: () => getAndSet33,
  getAndUpdate: () => getAndUpdate33,
  increment: () => increment33,
  incrementAndGet: () => incrementAndGet33,
  make: () => make334,
  set: () => set44,
  setAndGet: () => setAndGet33,
  toggle: () => toggle33,
  update: () => update33,
  updateAndGet: () => updateAndGet33
});
var TypeId434 = /* @__PURE__ */ Symbol.for("effect/MutableRef");
var MutableRefProto33 = {
  [TypeId434]: TypeId434,
  toString() {
    return format54(this.toJSON());
  },
  toJSON() {
    return {
      _id: "MutableRef",
      current: toJSON54(this.current)
    };
  },
  [NodeInspectSymbol54]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments54(this, arguments);
  }
};
var make334 = (value) => {
  const ref = Object.create(MutableRefProto33);
  ref.current = value;
  return ref;
};
var compareAndSet33 = /* @__PURE__ */ dual54(3, (self2, oldValue, newValue) => {
  if (equals54(oldValue, self2.current)) {
    self2.current = newValue;
    return true;
  }
  return false;
});
var decrement33 = (self2) => update33(self2, (n2222) => n2222 - 1);
var decrementAndGet33 = (self2) => updateAndGet33(self2, (n2222) => n2222 - 1);
var get43 = (self2) => self2.current;
var getAndDecrement33 = (self2) => getAndUpdate33(self2, (n2222) => n2222 - 1);
var getAndIncrement33 = (self2) => getAndUpdate33(self2, (n2222) => n2222 + 1);
var getAndSet33 = /* @__PURE__ */ dual54(2, (self2, value) => {
  const ret = self2.current;
  self2.current = value;
  return ret;
});
var getAndUpdate33 = /* @__PURE__ */ dual54(2, (self2, f2222) => getAndSet33(self2, f2222(get43(self2))));
var increment33 = (self2) => update33(self2, (n2222) => n2222 + 1);
var incrementAndGet33 = (self2) => updateAndGet33(self2, (n2222) => n2222 + 1);
var set44 = /* @__PURE__ */ dual54(2, (self2, value) => {
  self2.current = value;
  return self2;
});
var setAndGet33 = /* @__PURE__ */ dual54(2, (self2, value) => {
  self2.current = value;
  return self2.current;
});
var update33 = /* @__PURE__ */ dual54(2, (self2, f2222) => set44(self2, f2222(get43(self2))));
var updateAndGet33 = /* @__PURE__ */ dual54(2, (self2, f2222) => setAndGet33(self2, f2222(get43(self2))));
var toggle33 = (self2) => update33(self2, (_2222) => !_2222);
function getVariables24(initialScope) {
  const scopeRef = MutableRef_exports33.make(initialScope);
  const variablesRef = MutableRef_exports33.make(MutableRef_exports33.get(scopeRef).variables);
  while (MutableRef_exports33.get(scopeRef).type !== scopeManager.ScopeType.global) {
    MutableRef_exports33.set(scopeRef, MutableRef_exports33.get(scopeRef).upper);
    MutableRef_exports33.update(variablesRef, (variables) => variables.concat(MutableRef_exports33.get(scopeRef).variables));
  }
  return MutableRef_exports33.get(variablesRef).reverse();
}
var findVariable34 = Function_exports54.dual(2, (name22, initialScope) => {
  return Option_exports54.fromNullable(getVariables24(initialScope).find((variable) => variable.name === name22));
});
var t223 = Symbol.for("@ts-pattern/matcher");
var e223 = Symbol.for("@ts-pattern/isVariadic");
var n223 = "@ts-pattern/anonymous-select-key";
var r223 = (t2222) => Boolean(t2222 && "object" == typeof t2222);
var i223 = (e2222) => e2222 && !!e2222[t223];
var o223 = (n2222, s2222, c2222) => {
  if (i223(n2222)) {
    const e2222 = n2222[t223](), { matched: r2222, selections: i2222 } = e2222.match(s2222);
    return r2222 && i2222 && Object.keys(i2222).forEach((t2222) => c2222(t2222, i2222[t2222])), r2222;
  }
  if (r223(n2222)) {
    if (!r223(s2222)) return false;
    if (Array.isArray(n2222)) {
      if (!Array.isArray(s2222)) return false;
      let t2222 = [], r2222 = [], a2222 = [];
      for (const o2222 of n2222.keys()) {
        const s322 = n2222[o2222];
        i223(s322) && s322[e223] ? a2222.push(s322) : a2222.length ? r2222.push(s322) : t2222.push(s322);
      }
      if (a2222.length) {
        if (a2222.length > 1) throw new Error("Pattern error: Using `...P.array(...)` several times in a single pattern is not allowed.");
        if (s2222.length < t2222.length + r2222.length) return false;
        const e2222 = s2222.slice(0, t2222.length), n322 = 0 === r2222.length ? [] : s2222.slice(-r2222.length), i2222 = s2222.slice(t2222.length, 0 === r2222.length ? Infinity : -r2222.length);
        return t2222.every((t322, n43) => o223(t322, e2222[n43], c2222)) && r2222.every((t322, e322) => o223(t322, n322[e322], c2222)) && (0 === a2222.length || o223(a2222[0], i2222, c2222));
      }
      return n2222.length === s2222.length && n2222.every((t322, e2222) => o223(t322, s2222[e2222], c2222));
    }
    return Object.keys(n2222).every((e2222) => {
      const r2222 = n2222[e2222];
      return (e2222 in s2222 || i223(a2222 = r2222) && "optional" === a2222[t223]().matcherType) && o223(r2222, s2222[e2222], c2222);
      var a2222;
    });
  }
  return Object.is(s2222, n2222);
};
var s223 = (e2222) => {
  var n2222, o2222, a2222;
  return r223(e2222) ? i223(e2222) ? null != (n2222 = null == (o2222 = (a2222 = e2222[t223]()).getSelectionKeys) ? void 0 : o2222.call(a2222)) ? n2222 : [] : Array.isArray(e2222) ? c223(e2222, s223) : c223(Object.values(e2222), s223) : [];
};
var c223 = (t2222, e2222) => t2222.reduce((t322, n2222) => t322.concat(e2222(n2222)), []);
function a223(...t2222) {
  if (1 === t2222.length) {
    const [e2222] = t2222;
    return (t322) => o223(e2222, t322, () => {
    });
  }
  if (2 === t2222.length) {
    const [e2222, n2222] = t2222;
    return o223(e2222, n2222, () => {
    });
  }
  throw new Error(`isMatching wasn't given the right number of arguments: expected 1 or 2, received ${t2222.length}.`);
}
function u223(t2222) {
  return Object.assign(t2222, { optional: () => l223(t2222), and: (e2222) => m223(t2222, e2222), or: (e2222) => d223(t2222, e2222), select: (e2222) => void 0 === e2222 ? p223(t2222) : p223(e2222, t2222) });
}
function h223(t2222) {
  return Object.assign(((t322) => Object.assign(t322, { [Symbol.iterator]() {
    let n2222 = 0;
    const r2222 = [{ value: Object.assign(t322, { [e223]: true }), done: false }, { done: true, value: void 0 }];
    return { next: () => {
      var t43;
      return null != (t43 = r2222[n2222++]) ? t43 : r2222.at(-1);
    } };
  } }))(t2222), { optional: () => h223(l223(t2222)), select: (e2222) => h223(void 0 === e2222 ? p223(t2222) : p223(e2222, t2222)) });
}
function l223(e2222) {
  return u223({ [t223]: () => ({ match: (t2222) => {
    let n2222 = {};
    const r2222 = (t322, e322) => {
      n2222[t322] = e322;
    };
    return void 0 === t2222 ? (s223(e2222).forEach((t322) => r2222(t322, void 0)), { matched: true, selections: n2222 }) : { matched: o223(e2222, t2222, r2222), selections: n2222 };
  }, getSelectionKeys: () => s223(e2222), matcherType: "optional" }) });
}
var f223 = (t2222, e2222) => {
  for (const n2222 of t2222) if (!e2222(n2222)) return false;
  return true;
};
var g223 = (t2222, e2222) => {
  for (const [n2222, r2222] of t2222.entries()) if (!e2222(r2222, n2222)) return false;
  return true;
};
function m223(...e2222) {
  return u223({ [t223]: () => ({ match: (t2222) => {
    let n2222 = {};
    const r2222 = (t322, e322) => {
      n2222[t322] = e322;
    };
    return { matched: e2222.every((e322) => o223(e322, t2222, r2222)), selections: n2222 };
  }, getSelectionKeys: () => c223(e2222, s223), matcherType: "and" }) });
}
function d223(...e2222) {
  return u223({ [t223]: () => ({ match: (t2222) => {
    let n2222 = {};
    const r2222 = (t322, e322) => {
      n2222[t322] = e322;
    };
    return c223(e2222, s223).forEach((t322) => r2222(t322, void 0)), { matched: e2222.some((e322) => o223(e322, t2222, r2222)), selections: n2222 };
  }, getSelectionKeys: () => c223(e2222, s223), matcherType: "or" }) });
}
function y223(e2222) {
  return { [t223]: () => ({ match: (t2222) => ({ matched: Boolean(e2222(t2222)) }) }) };
}
function p223(...e2222) {
  const r2222 = "string" == typeof e2222[0] ? e2222[0] : void 0, i2222 = 2 === e2222.length ? e2222[1] : "string" == typeof e2222[0] ? void 0 : e2222[0];
  return u223({ [t223]: () => ({ match: (t2222) => {
    let e322 = { [null != r2222 ? r2222 : n223]: t2222 };
    return { matched: void 0 === i2222 || o223(i2222, t2222, (t322, n2222) => {
      e322[t322] = n2222;
    }), selections: e322 };
  }, getSelectionKeys: () => [null != r2222 ? r2222 : n223].concat(void 0 === i2222 ? [] : s223(i2222)) }) });
}
function v223(t2222) {
  return "number" == typeof t2222;
}
function b223(t2222) {
  return "string" == typeof t2222;
}
function w223(t2222) {
  return "bigint" == typeof t2222;
}
var S223 = u223(y223(function(t2222) {
  return true;
}));
var O223 = S223;
var j223 = (t2222) => Object.assign(u223(t2222), { startsWith: (e2222) => {
  return j223(m223(t2222, (n2222 = e2222, y223((t322) => b223(t322) && t322.startsWith(n2222)))));
  var n2222;
}, endsWith: (e2222) => {
  return j223(m223(t2222, (n2222 = e2222, y223((t322) => b223(t322) && t322.endsWith(n2222)))));
  var n2222;
}, minLength: (e2222) => j223(m223(t2222, ((t322) => y223((e322) => b223(e322) && e322.length >= t322))(e2222))), maxLength: (e2222) => j223(m223(t2222, ((t322) => y223((e322) => b223(e322) && e322.length <= t322))(e2222))), includes: (e2222) => {
  return j223(m223(t2222, (n2222 = e2222, y223((t322) => b223(t322) && t322.includes(n2222)))));
  var n2222;
}, regex: (e2222) => {
  return j223(m223(t2222, (n2222 = e2222, y223((t322) => b223(t322) && Boolean(t322.match(n2222))))));
  var n2222;
} });
var E223 = j223(y223(b223));
var K223 = (t2222) => Object.assign(u223(t2222), { between: (e2222, n2222) => K223(m223(t2222, ((t322, e322) => y223((n322) => v223(n322) && t322 <= n322 && e322 >= n322))(e2222, n2222))), lt: (e2222) => K223(m223(t2222, ((t322) => y223((e322) => v223(e322) && e322 < t322))(e2222))), gt: (e2222) => K223(m223(t2222, ((t322) => y223((e322) => v223(e322) && e322 > t322))(e2222))), lte: (e2222) => K223(m223(t2222, ((t322) => y223((e322) => v223(e322) && e322 <= t322))(e2222))), gte: (e2222) => K223(m223(t2222, ((t322) => y223((e322) => v223(e322) && e322 >= t322))(e2222))), int: () => K223(m223(t2222, y223((t322) => v223(t322) && Number.isInteger(t322)))), finite: () => K223(m223(t2222, y223((t322) => v223(t322) && Number.isFinite(t322)))), positive: () => K223(m223(t2222, y223((t322) => v223(t322) && t322 > 0))), negative: () => K223(m223(t2222, y223((t322) => v223(t322) && t322 < 0))) });
var x223 = K223(y223(v223));
var A223 = (t2222) => Object.assign(u223(t2222), { between: (e2222, n2222) => A223(m223(t2222, ((t322, e322) => y223((n322) => w223(n322) && t322 <= n322 && e322 >= n322))(e2222, n2222))), lt: (e2222) => A223(m223(t2222, ((t322) => y223((e322) => w223(e322) && e322 < t322))(e2222))), gt: (e2222) => A223(m223(t2222, ((t322) => y223((e322) => w223(e322) && e322 > t322))(e2222))), lte: (e2222) => A223(m223(t2222, ((t322) => y223((e322) => w223(e322) && e322 <= t322))(e2222))), gte: (e2222) => A223(m223(t2222, ((t322) => y223((e322) => w223(e322) && e322 >= t322))(e2222))), positive: () => A223(m223(t2222, y223((t322) => w223(t322) && t322 > 0))), negative: () => A223(m223(t2222, y223((t322) => w223(t322) && t322 < 0))) });
var P33 = A223(y223(w223));
var T223 = u223(y223(function(t2222) {
  return "boolean" == typeof t2222;
}));
var k223 = u223(y223(function(t2222) {
  return "symbol" == typeof t2222;
}));
var B223 = u223(y223(function(t2222) {
  return null == t2222;
}));
var _223 = u223(y223(function(t2222) {
  return null != t2222;
}));
var N223 = { __proto__: null, matcher: t223, optional: l223, array: function(...e2222) {
  return h223({ [t223]: () => ({ match: (t2222) => {
    if (!Array.isArray(t2222)) return { matched: false };
    if (0 === e2222.length) return { matched: true };
    const n2222 = e2222[0];
    let r2222 = {};
    if (0 === t2222.length) return s223(n2222).forEach((t322) => {
      r2222[t322] = [];
    }), { matched: true, selections: r2222 };
    const i2222 = (t322, e322) => {
      r2222[t322] = (r2222[t322] || []).concat([e322]);
    };
    return { matched: t2222.every((t322) => o223(n2222, t322, i2222)), selections: r2222 };
  }, getSelectionKeys: () => 0 === e2222.length ? [] : s223(e2222[0]) }) });
}, set: function(...e2222) {
  return u223({ [t223]: () => ({ match: (t2222) => {
    if (!(t2222 instanceof Set)) return { matched: false };
    let n2222 = {};
    if (0 === t2222.size) return { matched: true, selections: n2222 };
    if (0 === e2222.length) return { matched: true };
    const r2222 = (t322, e322) => {
      n2222[t322] = (n2222[t322] || []).concat([e322]);
    }, i2222 = e2222[0];
    return { matched: f223(t2222, (t322) => o223(i2222, t322, r2222)), selections: n2222 };
  }, getSelectionKeys: () => 0 === e2222.length ? [] : s223(e2222[0]) }) });
}, map: function(...e2222) {
  return u223({ [t223]: () => ({ match: (t2222) => {
    if (!(t2222 instanceof Map)) return { matched: false };
    let n2222 = {};
    if (0 === t2222.size) return { matched: true, selections: n2222 };
    const r2222 = (t322, e322) => {
      n2222[t322] = (n2222[t322] || []).concat([e322]);
    };
    if (0 === e2222.length) return { matched: true };
    var i2222;
    if (1 === e2222.length) throw new Error(`\`P.map\` wasn't given enough arguments. Expected (key, value), received ${null == (i2222 = e2222[0]) ? void 0 : i2222.toString()}`);
    const [s2222, c2222] = e2222;
    return { matched: g223(t2222, (t322, e322) => {
      const n322 = o223(s2222, e322, r2222), i322 = o223(c2222, t322, r2222);
      return n322 && i322;
    }), selections: n2222 };
  }, getSelectionKeys: () => 0 === e2222.length ? [] : [...s223(e2222[0]), ...s223(e2222[1])] }) });
}, intersection: m223, union: d223, not: function(e2222) {
  return u223({ [t223]: () => ({ match: (t2222) => ({ matched: !o223(e2222, t2222, () => {
  }) }), getSelectionKeys: () => [], matcherType: "not" }) });
}, when: y223, select: p223, any: S223, _: O223, string: E223, number: x223, bigint: P33, boolean: T223, symbol: k223, nullish: B223, nonNullable: _223, instanceOf: function(t2222) {
  return u223(y223(/* @__PURE__ */ function(t322) {
    return (e2222) => e2222 instanceof t322;
  }(t2222)));
}, shape: function(t2222) {
  return u223(y223(a223(t2222)));
} };
var KEYS34 = {
  ArrayExpression: [
    "elements"
  ],
  ArrayPattern: [
    "elements"
  ],
  ArrowFunctionExpression: [
    "params",
    "body"
  ],
  AssignmentExpression: [
    "left",
    "right"
  ],
  AssignmentPattern: [
    "left",
    "right"
  ],
  AwaitExpression: [
    "argument"
  ],
  BinaryExpression: [
    "left",
    "right"
  ],
  BlockStatement: [
    "body"
  ],
  BreakStatement: [
    "label"
  ],
  CallExpression: [
    "callee",
    "arguments"
  ],
  CatchClause: [
    "param",
    "body"
  ],
  ChainExpression: [
    "expression"
  ],
  ClassBody: [
    "body"
  ],
  ClassDeclaration: [
    "id",
    "superClass",
    "body"
  ],
  ClassExpression: [
    "id",
    "superClass",
    "body"
  ],
  ConditionalExpression: [
    "test",
    "consequent",
    "alternate"
  ],
  ContinueStatement: [
    "label"
  ],
  DebuggerStatement: [],
  DoWhileStatement: [
    "body",
    "test"
  ],
  EmptyStatement: [],
  ExperimentalRestProperty: [
    "argument"
  ],
  ExperimentalSpreadProperty: [
    "argument"
  ],
  ExportAllDeclaration: [
    "exported",
    "source"
  ],
  ExportDefaultDeclaration: [
    "declaration"
  ],
  ExportNamedDeclaration: [
    "declaration",
    "specifiers",
    "source"
  ],
  ExportSpecifier: [
    "exported",
    "local"
  ],
  ExpressionStatement: [
    "expression"
  ],
  ForInStatement: [
    "left",
    "right",
    "body"
  ],
  ForOfStatement: [
    "left",
    "right",
    "body"
  ],
  ForStatement: [
    "init",
    "test",
    "update",
    "body"
  ],
  FunctionDeclaration: [
    "id",
    "params",
    "body"
  ],
  FunctionExpression: [
    "id",
    "params",
    "body"
  ],
  Identifier: [],
  IfStatement: [
    "test",
    "consequent",
    "alternate"
  ],
  ImportDeclaration: [
    "specifiers",
    "source"
  ],
  ImportDefaultSpecifier: [
    "local"
  ],
  ImportExpression: [
    "source"
  ],
  ImportNamespaceSpecifier: [
    "local"
  ],
  ImportSpecifier: [
    "imported",
    "local"
  ],
  JSXAttribute: [
    "name",
    "value"
  ],
  JSXClosingElement: [
    "name"
  ],
  JSXClosingFragment: [],
  JSXElement: [
    "openingElement",
    "children",
    "closingElement"
  ],
  JSXEmptyExpression: [],
  JSXExpressionContainer: [
    "expression"
  ],
  JSXFragment: [
    "openingFragment",
    "children",
    "closingFragment"
  ],
  JSXIdentifier: [],
  JSXMemberExpression: [
    "object",
    "property"
  ],
  JSXNamespacedName: [
    "namespace",
    "name"
  ],
  JSXOpeningElement: [
    "name",
    "attributes"
  ],
  JSXOpeningFragment: [],
  JSXSpreadAttribute: [
    "argument"
  ],
  JSXSpreadChild: [
    "expression"
  ],
  JSXText: [],
  LabeledStatement: [
    "label",
    "body"
  ],
  Literal: [],
  LogicalExpression: [
    "left",
    "right"
  ],
  MemberExpression: [
    "object",
    "property"
  ],
  MetaProperty: [
    "meta",
    "property"
  ],
  MethodDefinition: [
    "key",
    "value"
  ],
  NewExpression: [
    "callee",
    "arguments"
  ],
  ObjectExpression: [
    "properties"
  ],
  ObjectPattern: [
    "properties"
  ],
  PrivateIdentifier: [],
  Program: [
    "body"
  ],
  Property: [
    "key",
    "value"
  ],
  PropertyDefinition: [
    "key",
    "value"
  ],
  RestElement: [
    "argument"
  ],
  ReturnStatement: [
    "argument"
  ],
  SequenceExpression: [
    "expressions"
  ],
  SpreadElement: [
    "argument"
  ],
  StaticBlock: [
    "body"
  ],
  Super: [],
  SwitchCase: [
    "test",
    "consequent"
  ],
  SwitchStatement: [
    "discriminant",
    "cases"
  ],
  TaggedTemplateExpression: [
    "tag",
    "quasi"
  ],
  TemplateElement: [],
  TemplateLiteral: [
    "quasis",
    "expressions"
  ],
  ThisExpression: [],
  ThrowStatement: [
    "argument"
  ],
  TryStatement: [
    "block",
    "handler",
    "finalizer"
  ],
  UnaryExpression: [
    "argument"
  ],
  UpdateExpression: [
    "argument"
  ],
  VariableDeclaration: [
    "declarations"
  ],
  VariableDeclarator: [
    "id",
    "init"
  ],
  WhileStatement: [
    "test",
    "body"
  ],
  WithStatement: [
    "object",
    "body"
  ],
  YieldExpression: [
    "argument"
  ]
};
var NODE_TYPES34 = Object.keys(KEYS34);
for (const type of NODE_TYPES34) {
  Object.freeze(KEYS34[type]);
}
Object.freeze(KEYS34);
var visitor_keys_default34 = KEYS34;
var KEY_BLACKLIST34 = /* @__PURE__ */ new Set([
  "parent",
  "leadingComments",
  "trailingComments"
]);
function filterKey34(key) {
  return !KEY_BLACKLIST34.has(key) && key[0] !== "_";
}
function getKeys34(node) {
  return Object.keys(node).filter(filterKey34);
}
function getInnermostScope34(initialScope, node) {
  const location = node.range[0];
  let scope = initialScope;
  let found = false;
  do {
    found = false;
    for (const childScope of scope.childScopes) {
      const range24 = childScope.block.range;
      if (range24[0] <= location && location < range24[1]) {
        scope = childScope;
        found = true;
        break;
      }
    }
  } while (found);
  return scope;
}
function findVariable234(initialScope, nameOrNode) {
  let name22 = "";
  let scope = initialScope;
  if (typeof nameOrNode === "string") {
    name22 = nameOrNode;
  } else {
    name22 = nameOrNode.name;
    scope = getInnermostScope34(scope, nameOrNode);
  }
  while (scope != null) {
    const variable = scope.set.get(name22);
    if (variable != null) {
      return variable;
    }
    scope = scope.upper;
  }
  return null;
}
function negate034(token) {
  return !this(token);
}
function negate34(f2222) {
  return negate034.bind(f2222);
}
function isPunctuatorTokenWithValue34(token, value) {
  return token.type === "Punctuator" && token.value === value;
}
function isArrowToken34(token) {
  return isPunctuatorTokenWithValue34(token, "=>");
}
function isCommaToken34(token) {
  return isPunctuatorTokenWithValue34(token, ",");
}
function isSemicolonToken34(token) {
  return isPunctuatorTokenWithValue34(token, ";");
}
function isColonToken34(token) {
  return isPunctuatorTokenWithValue34(token, ":");
}
function isOpeningParenToken34(token) {
  return isPunctuatorTokenWithValue34(token, "(");
}
function isClosingParenToken34(token) {
  return isPunctuatorTokenWithValue34(token, ")");
}
function isOpeningBracketToken34(token) {
  return isPunctuatorTokenWithValue34(token, "[");
}
function isClosingBracketToken34(token) {
  return isPunctuatorTokenWithValue34(token, "]");
}
function isOpeningBraceToken34(token) {
  return isPunctuatorTokenWithValue34(token, "{");
}
function isClosingBraceToken34(token) {
  return isPunctuatorTokenWithValue34(token, "}");
}
function isCommentToken34(token) {
  return ["Block", "Line", "Shebang"].includes(token.type);
}
negate34(isArrowToken34);
negate34(isCommaToken34);
negate34(isSemicolonToken34);
negate34(isColonToken34);
negate34(isOpeningParenToken34);
negate34(isClosingParenToken34);
negate34(isOpeningBracketToken34);
negate34(isClosingBracketToken34);
negate34(isOpeningBraceToken34);
negate34(isClosingBraceToken34);
negate34(isCommentToken34);
function getOpeningParenOfParams34(node, sourceCode) {
  return node.id ? sourceCode.getTokenAfter(node.id, isOpeningParenToken34) : sourceCode.getFirstToken(node, isOpeningParenToken34);
}
function getFunctionHeadLocation34(node, sourceCode) {
  const parent = node.parent;
  let start = null;
  let end = null;
  if (node.type === "ArrowFunctionExpression") {
    const arrowToken = sourceCode.getTokenBefore(node.body, isArrowToken34);
    start = arrowToken.loc.start;
    end = arrowToken.loc.end;
  } else if (parent.type === "Property" || parent.type === "MethodDefinition" || parent.type === "PropertyDefinition") {
    start = parent.loc.start;
    end = getOpeningParenOfParams34(node, sourceCode).loc.start;
  } else {
    start = node.loc.start;
    end = getOpeningParenOfParams34(node, sourceCode).loc.start;
  }
  return {
    start: { ...start },
    end: { ...end }
  };
}
var globalObject34 = typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {};
var builtinNames34 = Object.freeze(
  /* @__PURE__ */ new Set([
    "Array",
    "ArrayBuffer",
    "BigInt",
    "BigInt64Array",
    "BigUint64Array",
    "Boolean",
    "DataView",
    "Date",
    "decodeURI",
    "decodeURIComponent",
    "encodeURI",
    "encodeURIComponent",
    "escape",
    "Float32Array",
    "Float64Array",
    "Function",
    "Infinity",
    "Int16Array",
    "Int32Array",
    "Int8Array",
    "isFinite",
    "isNaN",
    "isPrototypeOf",
    "JSON",
    "Map",
    "Math",
    "NaN",
    "Number",
    "Object",
    "parseFloat",
    "parseInt",
    "Promise",
    "Proxy",
    "Reflect",
    "RegExp",
    "Set",
    "String",
    "Symbol",
    "Uint16Array",
    "Uint32Array",
    "Uint8Array",
    "Uint8ClampedArray",
    "undefined",
    "unescape",
    "WeakMap",
    "WeakSet"
  ])
);
var callAllowed34 = new Set(
  [
    Array.isArray,
    Array.of,
    Array.prototype.at,
    Array.prototype.concat,
    Array.prototype.entries,
    Array.prototype.every,
    Array.prototype.filter,
    Array.prototype.find,
    Array.prototype.findIndex,
    Array.prototype.flat,
    Array.prototype.includes,
    Array.prototype.indexOf,
    Array.prototype.join,
    Array.prototype.keys,
    Array.prototype.lastIndexOf,
    Array.prototype.slice,
    Array.prototype.some,
    Array.prototype.toString,
    Array.prototype.values,
    typeof BigInt === "function" ? BigInt : void 0,
    Boolean,
    Date,
    Date.parse,
    decodeURI,
    decodeURIComponent,
    encodeURI,
    encodeURIComponent,
    escape,
    isFinite,
    isNaN,
    isPrototypeOf,
    Map,
    Map.prototype.entries,
    Map.prototype.get,
    Map.prototype.has,
    Map.prototype.keys,
    Map.prototype.values,
    ...Object.getOwnPropertyNames(Math).filter((k2222) => k2222 !== "random").map((k2222) => Math[k2222]).filter((f2222) => typeof f2222 === "function"),
    Number,
    Number.isFinite,
    Number.isNaN,
    Number.parseFloat,
    Number.parseInt,
    Number.prototype.toExponential,
    Number.prototype.toFixed,
    Number.prototype.toPrecision,
    Number.prototype.toString,
    Object,
    Object.entries,
    Object.is,
    Object.isExtensible,
    Object.isFrozen,
    Object.isSealed,
    Object.keys,
    Object.values,
    parseFloat,
    parseInt,
    RegExp,
    Set,
    Set.prototype.entries,
    Set.prototype.has,
    Set.prototype.keys,
    Set.prototype.values,
    String,
    String.fromCharCode,
    String.fromCodePoint,
    String.raw,
    String.prototype.at,
    String.prototype.charAt,
    String.prototype.charCodeAt,
    String.prototype.codePointAt,
    String.prototype.concat,
    String.prototype.endsWith,
    String.prototype.includes,
    String.prototype.indexOf,
    String.prototype.lastIndexOf,
    String.prototype.normalize,
    String.prototype.padEnd,
    String.prototype.padStart,
    String.prototype.slice,
    String.prototype.startsWith,
    String.prototype.substr,
    String.prototype.substring,
    String.prototype.toLowerCase,
    String.prototype.toString,
    String.prototype.toUpperCase,
    String.prototype.trim,
    String.prototype.trimEnd,
    String.prototype.trimLeft,
    String.prototype.trimRight,
    String.prototype.trimStart,
    Symbol.for,
    Symbol.keyFor,
    unescape
  ].filter((f2222) => typeof f2222 === "function")
);
var callPassThrough34 = /* @__PURE__ */ new Set([
  Object.freeze,
  Object.preventExtensions,
  Object.seal
]);
var getterAllowed34 = [
  [Map, /* @__PURE__ */ new Set(["size"])],
  [
    RegExp,
    /* @__PURE__ */ new Set([
      "dotAll",
      "flags",
      "global",
      "hasIndices",
      "ignoreCase",
      "multiline",
      "source",
      "sticky",
      "unicode"
    ])
  ],
  [Set, /* @__PURE__ */ new Set(["size"])]
];
function getPropertyDescriptor34(object222, name22) {
  let x2222 = object222;
  while ((typeof x2222 === "object" || typeof x2222 === "function") && x2222 !== null) {
    const d2222 = Object.getOwnPropertyDescriptor(x2222, name22);
    if (d2222) {
      return d2222;
    }
    x2222 = Object.getPrototypeOf(x2222);
  }
  return null;
}
function isGetter34(object222, name22) {
  const d2222 = getPropertyDescriptor34(object222, name22);
  return d2222 != null && d2222.get != null;
}
function getElementValues34(nodeList, initialScope) {
  const valueList = [];
  for (let i2222 = 0; i2222 < nodeList.length; ++i2222) {
    const elementNode = nodeList[i2222];
    if (elementNode == null) {
      valueList.length = i2222 + 1;
    } else if (elementNode.type === "SpreadElement") {
      const argument = getStaticValueR34(elementNode.argument, initialScope);
      if (argument == null) {
        return null;
      }
      valueList.push(...argument.value);
    } else {
      const element = getStaticValueR34(elementNode, initialScope);
      if (element == null) {
        return null;
      }
      valueList.push(element.value);
    }
  }
  return valueList;
}
function isEffectivelyConst34(variable) {
  const refs = variable.references;
  const inits = refs.filter((r2222) => r2222.init).length;
  const reads = refs.filter((r2222) => r2222.isReadOnly()).length;
  if (inits === 1 && reads + inits === refs.length) {
    return true;
  }
  return false;
}
var operations34 = Object.freeze({
  ArrayExpression(node, initialScope) {
    const elements = getElementValues34(node.elements, initialScope);
    return elements != null ? { value: elements } : null;
  },
  AssignmentExpression(node, initialScope) {
    if (node.operator === "=") {
      return getStaticValueR34(node.right, initialScope);
    }
    return null;
  },
  //eslint-disable-next-line complexity
  BinaryExpression(node, initialScope) {
    if (node.operator === "in" || node.operator === "instanceof") {
      return null;
    }
    const left334 = getStaticValueR34(node.left, initialScope);
    const right334 = getStaticValueR34(node.right, initialScope);
    if (left334 != null && right334 != null) {
      switch (node.operator) {
        case "==":
          return { value: left334.value == right334.value };
        case "!=":
          return { value: left334.value != right334.value };
        case "===":
          return { value: left334.value === right334.value };
        case "!==":
          return { value: left334.value !== right334.value };
        case "<":
          return { value: left334.value < right334.value };
        case "<=":
          return { value: left334.value <= right334.value };
        case ">":
          return { value: left334.value > right334.value };
        case ">=":
          return { value: left334.value >= right334.value };
        case "<<":
          return { value: left334.value << right334.value };
        case ">>":
          return { value: left334.value >> right334.value };
        case ">>>":
          return { value: left334.value >>> right334.value };
        case "+":
          return { value: left334.value + right334.value };
        case "-":
          return { value: left334.value - right334.value };
        case "*":
          return { value: left334.value * right334.value };
        case "/":
          return { value: left334.value / right334.value };
        case "%":
          return { value: left334.value % right334.value };
        case "**":
          return { value: left334.value ** right334.value };
        case "|":
          return { value: left334.value | right334.value };
        case "^":
          return { value: left334.value ^ right334.value };
        case "&":
          return { value: left334.value & right334.value };
      }
    }
    return null;
  },
  CallExpression(node, initialScope) {
    const calleeNode = node.callee;
    const args = getElementValues34(node.arguments, initialScope);
    if (args != null) {
      if (calleeNode.type === "MemberExpression") {
        if (calleeNode.property.type === "PrivateIdentifier") {
          return null;
        }
        const object222 = getStaticValueR34(calleeNode.object, initialScope);
        if (object222 != null) {
          if (object222.value == null && (object222.optional || node.optional)) {
            return { value: void 0, optional: true };
          }
          const property = getStaticPropertyNameValue34(
            calleeNode,
            initialScope
          );
          if (property != null) {
            const receiver = object222.value;
            const methodName = property.value;
            if (callAllowed34.has(receiver[methodName])) {
              return { value: receiver[methodName](...args) };
            }
            if (callPassThrough34.has(receiver[methodName])) {
              return { value: args[0] };
            }
          }
        }
      } else {
        const callee = getStaticValueR34(calleeNode, initialScope);
        if (callee != null) {
          if (callee.value == null && node.optional) {
            return { value: void 0, optional: true };
          }
          const func = callee.value;
          if (callAllowed34.has(func)) {
            return { value: func(...args) };
          }
          if (callPassThrough34.has(func)) {
            return { value: args[0] };
          }
        }
      }
    }
    return null;
  },
  ConditionalExpression(node, initialScope) {
    const test = getStaticValueR34(node.test, initialScope);
    if (test != null) {
      return test.value ? getStaticValueR34(node.consequent, initialScope) : getStaticValueR34(node.alternate, initialScope);
    }
    return null;
  },
  ExpressionStatement(node, initialScope) {
    return getStaticValueR34(node.expression, initialScope);
  },
  Identifier(node, initialScope) {
    if (initialScope != null) {
      const variable = findVariable234(initialScope, node);
      if (variable != null && variable.defs.length === 0 && builtinNames34.has(variable.name) && variable.name in globalObject34) {
        return { value: globalObject34[variable.name] };
      }
      if (variable != null && variable.defs.length === 1) {
        const def = variable.defs[0];
        if (def.parent && def.type === "Variable" && (def.parent.kind === "const" || isEffectivelyConst34(variable)) && // TODO(mysticatea): don't support destructuring here.
        def.node.id.type === "Identifier") {
          return getStaticValueR34(def.node.init, initialScope);
        }
      }
    }
    return null;
  },
  Literal(node) {
    if ((node.regex != null || node.bigint != null) && node.value == null) {
      return null;
    }
    return { value: node.value };
  },
  LogicalExpression(node, initialScope) {
    const left334 = getStaticValueR34(node.left, initialScope);
    if (left334 != null) {
      if (node.operator === "||" && Boolean(left334.value) === true || node.operator === "&&" && Boolean(left334.value) === false || node.operator === "??" && left334.value != null) {
        return left334;
      }
      const right334 = getStaticValueR34(node.right, initialScope);
      if (right334 != null) {
        return right334;
      }
    }
    return null;
  },
  MemberExpression(node, initialScope) {
    if (node.property.type === "PrivateIdentifier") {
      return null;
    }
    const object222 = getStaticValueR34(node.object, initialScope);
    if (object222 != null) {
      if (object222.value == null && (object222.optional || node.optional)) {
        return { value: void 0, optional: true };
      }
      const property = getStaticPropertyNameValue34(node, initialScope);
      if (property != null) {
        if (!isGetter34(object222.value, property.value)) {
          return { value: object222.value[property.value] };
        }
        for (const [classFn, allowed] of getterAllowed34) {
          if (object222.value instanceof classFn && allowed.has(property.value)) {
            return { value: object222.value[property.value] };
          }
        }
      }
    }
    return null;
  },
  ChainExpression(node, initialScope) {
    const expression = getStaticValueR34(node.expression, initialScope);
    if (expression != null) {
      return { value: expression.value };
    }
    return null;
  },
  NewExpression(node, initialScope) {
    const callee = getStaticValueR34(node.callee, initialScope);
    const args = getElementValues34(node.arguments, initialScope);
    if (callee != null && args != null) {
      const Func = callee.value;
      if (callAllowed34.has(Func)) {
        return { value: new Func(...args) };
      }
    }
    return null;
  },
  ObjectExpression(node, initialScope) {
    const object222 = {};
    for (const propertyNode of node.properties) {
      if (propertyNode.type === "Property") {
        if (propertyNode.kind !== "init") {
          return null;
        }
        const key = getStaticPropertyNameValue34(
          propertyNode,
          initialScope
        );
        const value = getStaticValueR34(propertyNode.value, initialScope);
        if (key == null || value == null) {
          return null;
        }
        object222[key.value] = value.value;
      } else if (propertyNode.type === "SpreadElement" || propertyNode.type === "ExperimentalSpreadProperty") {
        const argument = getStaticValueR34(
          propertyNode.argument,
          initialScope
        );
        if (argument == null) {
          return null;
        }
        Object.assign(object222, argument.value);
      } else {
        return null;
      }
    }
    return { value: object222 };
  },
  SequenceExpression(node, initialScope) {
    const last24 = node.expressions[node.expressions.length - 1];
    return getStaticValueR34(last24, initialScope);
  },
  TaggedTemplateExpression(node, initialScope) {
    const tag = getStaticValueR34(node.tag, initialScope);
    const expressions = getElementValues34(
      node.quasi.expressions,
      initialScope
    );
    if (tag != null && expressions != null) {
      const func = tag.value;
      const strings = node.quasi.quasis.map((q) => q.value.cooked);
      strings.raw = node.quasi.quasis.map((q) => q.value.raw);
      if (func === String.raw) {
        return { value: func(strings, ...expressions) };
      }
    }
    return null;
  },
  TemplateLiteral(node, initialScope) {
    const expressions = getElementValues34(node.expressions, initialScope);
    if (expressions != null) {
      let value = node.quasis[0].value.cooked;
      for (let i2222 = 0; i2222 < expressions.length; ++i2222) {
        value += expressions[i2222];
        value += node.quasis[i2222 + 1].value.cooked;
      }
      return { value };
    }
    return null;
  },
  UnaryExpression(node, initialScope) {
    if (node.operator === "delete") {
      return null;
    }
    if (node.operator === "void") {
      return { value: void 0 };
    }
    const arg = getStaticValueR34(node.argument, initialScope);
    if (arg != null) {
      switch (node.operator) {
        case "-":
          return { value: -arg.value };
        case "+":
          return { value: +arg.value };
        case "!":
          return { value: !arg.value };
        case "~":
          return { value: ~arg.value };
        case "typeof":
          return { value: typeof arg.value };
      }
    }
    return null;
  }
});
function getStaticValueR34(node, initialScope) {
  if (node != null && Object.hasOwnProperty.call(operations34, node.type)) {
    return operations34[node.type](node, initialScope);
  }
  return null;
}
function getStaticPropertyNameValue34(node, initialScope) {
  const nameNode = node.type === "Property" ? node.key : node.property;
  if (node.computed) {
    return getStaticValueR34(nameNode, initialScope);
  }
  if (nameNode.type === "Identifier") {
    return { value: nameNode.name };
  }
  if (nameNode.type === "Literal") {
    if (nameNode.bigint) {
      return { value: nameNode.bigint };
    }
    return { value: String(nameNode.value) };
  }
  return null;
}
function getStaticValue44(node, initialScope = null) {
  try {
    return getStaticValueR34(node, initialScope);
  } catch (_error) {
    return null;
  }
}
function getStringIfConstant34(node, initialScope = null) {
  if (node && node.type === "Literal" && node.value === null) {
    if (node.regex) {
      return `/${node.regex.pattern}/${node.regex.flags}`;
    }
    if (node.bigint) {
      return node.bigint;
    }
  }
  const evaluated = getStaticValue44(node, initialScope);
  return evaluated && String(evaluated.value);
}
function getPropertyName34(node, initialScope) {
  switch (node.type) {
    case "MemberExpression":
      if (node.computed) {
        return getStringIfConstant34(node.property, initialScope);
      }
      if (node.property.type === "PrivateIdentifier") {
        return null;
      }
      return node.property.name;
    case "Property":
    case "MethodDefinition":
    case "PropertyDefinition":
      if (node.computed) {
        return getStringIfConstant34(node.key, initialScope);
      }
      if (node.key.type === "Literal") {
        return String(node.key.value);
      }
      if (node.key.type === "PrivateIdentifier") {
        return null;
      }
      return node.key.name;
  }
  return null;
}
function getFunctionNameWithKind34(node, sourceCode) {
  const parent = node.parent;
  const tokens = [];
  const isObjectMethod = parent.type === "Property" && parent.value === node;
  const isClassMethod = parent.type === "MethodDefinition" && parent.value === node;
  const isClassFieldMethod = parent.type === "PropertyDefinition" && parent.value === node;
  if (isClassMethod || isClassFieldMethod) {
    if (parent.static) {
      tokens.push("static");
    }
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push("private");
    }
  }
  if (node.async) {
    tokens.push("async");
  }
  if (node.generator) {
    tokens.push("generator");
  }
  if (isObjectMethod || isClassMethod) {
    if (parent.kind === "constructor") {
      return "constructor";
    }
    if (parent.kind === "get") {
      tokens.push("getter");
    } else if (parent.kind === "set") {
      tokens.push("setter");
    } else {
      tokens.push("method");
    }
  } else if (isClassFieldMethod) {
    tokens.push("method");
  } else {
    if (node.type === "ArrowFunctionExpression") {
      tokens.push("arrow");
    }
    tokens.push("function");
  }
  if (isObjectMethod || isClassMethod || isClassFieldMethod) {
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push(`#${parent.key.name}`);
    } else {
      const name22 = getPropertyName34(parent);
      if (name22) {
        tokens.push(`'${name22}'`);
      } else if (sourceCode) {
        const keyText = sourceCode.getText(parent.key);
        if (!keyText.includes("\n")) {
          tokens.push(`[${keyText}]`);
        }
      }
    }
  } else if (node.id) {
    tokens.push(`'${node.id.name}'`);
  } else if (parent.type === "VariableDeclarator" && parent.id && parent.id.type === "Identifier") {
    tokens.push(`'${parent.id.name}'`);
  } else if ((parent.type === "AssignmentExpression" || parent.type === "AssignmentPattern") && parent.left && parent.left.type === "Identifier") {
    tokens.push(`'${parent.left.name}'`);
  } else if (parent.type === "ExportDefaultDeclaration" && parent.declaration === node) {
    tokens.push("'default'");
  }
  return tokens.join(" ");
}
var typeConversionBinaryOps34 = Object.freeze(
  /* @__PURE__ */ new Set([
    "==",
    "!=",
    "<",
    "<=",
    ">",
    ">=",
    "<<",
    ">>",
    ">>>",
    "+",
    "-",
    "*",
    "/",
    "%",
    "|",
    "^",
    "&",
    "in"
  ])
);
var typeConversionUnaryOps34 = Object.freeze(/* @__PURE__ */ new Set(["-", "+", "!", "~"]));
function isNode34(x2222) {
  return x2222 !== null && typeof x2222 === "object" && typeof x2222.type === "string";
}
var visitor34 = Object.freeze(
  Object.assign(/* @__PURE__ */ Object.create(null), {
    $visit(node, options, visitorKeys) {
      const { type } = node;
      if (typeof this[type] === "function") {
        return this[type](node, options, visitorKeys);
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    $visitChildren(node, options, visitorKeys) {
      const { type } = node;
      for (const key of visitorKeys[type] || getKeys34(node)) {
        const value = node[key];
        if (Array.isArray(value)) {
          for (const element of value) {
            if (isNode34(element) && this.$visit(element, options, visitorKeys)) {
              return true;
            }
          }
        } else if (isNode34(value) && this.$visit(value, options, visitorKeys)) {
          return true;
        }
      }
      return false;
    },
    ArrowFunctionExpression() {
      return false;
    },
    AssignmentExpression() {
      return true;
    },
    AwaitExpression() {
      return true;
    },
    BinaryExpression(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && typeConversionBinaryOps34.has(node.operator) && (node.left.type !== "Literal" || node.right.type !== "Literal")) {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    CallExpression() {
      return true;
    },
    FunctionExpression() {
      return false;
    },
    ImportExpression() {
      return true;
    },
    MemberExpression(node, options, visitorKeys) {
      if (options.considerGetters) {
        return true;
      }
      if (options.considerImplicitTypeConversion && node.computed && node.property.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    MethodDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    NewExpression() {
      return true;
    },
    Property(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    PropertyDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UnaryExpression(node, options, visitorKeys) {
      if (node.operator === "delete") {
        return true;
      }
      if (options.considerImplicitTypeConversion && typeConversionUnaryOps34.has(node.operator) && node.argument.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UpdateExpression() {
      return true;
    },
    YieldExpression() {
      return true;
    }
  })
);
function hasSideEffect34(node, sourceCode, { considerGetters = false, considerImplicitTypeConversion = false } = {}) {
  return visitor34.$visit(
    node,
    { considerGetters, considerImplicitTypeConversion },
    sourceCode.visitorKeys || visitor_keys_default34
  );
}
function getParentSyntaxParen34(node, sourceCode) {
  const parent = node.parent;
  switch (parent.type) {
    case "CallExpression":
    case "NewExpression":
      if (parent.arguments.length === 1 && parent.arguments[0] === node) {
        return sourceCode.getTokenAfter(
          parent.callee,
          isOpeningParenToken34
        );
      }
      return null;
    case "DoWhileStatement":
      if (parent.test === node) {
        return sourceCode.getTokenAfter(
          parent.body,
          isOpeningParenToken34
        );
      }
      return null;
    case "IfStatement":
    case "WhileStatement":
      if (parent.test === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "ImportExpression":
      if (parent.source === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "SwitchStatement":
      if (parent.discriminant === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "WithStatement":
      if (parent.object === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    default:
      return null;
  }
}
function isParenthesized34(timesOrNode, nodeOrSourceCode, optionalSourceCode) {
  let times, node, sourceCode, maybeLeftParen, maybeRightParen;
  if (typeof timesOrNode === "number") {
    times = timesOrNode | 0;
    node = nodeOrSourceCode;
    sourceCode = optionalSourceCode;
    if (!(times >= 1)) {
      throw new TypeError("'times' should be a positive integer.");
    }
  } else {
    times = 1;
    node = timesOrNode;
    sourceCode = nodeOrSourceCode;
  }
  if (node == null || // `Program` can't be parenthesized
  node.parent == null || // `CatchClause.param` can't be parenthesized, example `try {} catch (error) {}`
  node.parent.type === "CatchClause" && node.parent.param === node) {
    return false;
  }
  maybeLeftParen = maybeRightParen = node;
  do {
    maybeLeftParen = sourceCode.getTokenBefore(maybeLeftParen);
    maybeRightParen = sourceCode.getTokenAfter(maybeRightParen);
  } while (maybeLeftParen != null && maybeRightParen != null && isOpeningParenToken34(maybeLeftParen) && isClosingParenToken34(maybeRightParen) && // Avoid false positive such as `if (a) {}`
  maybeLeftParen !== getParentSyntaxParen34(node, sourceCode) && --times > 0);
  return times === 0;
}
Function.call.bind(Object.hasOwnProperty);
var __defProp234 = Object.defineProperty;
var __export234 = (target, all334) => {
  for (var name22 in all334)
    __defProp234(target, name22, { get: all334[name22], enumerable: true });
};
var NodeType34 = types.AST_NODE_TYPES;
var is34 = utils.ASTUtils.isNodeOfType;
var isOneOf34 = utils.ASTUtils.isNodeOfTypes;
isOneOf34([
  NodeType34.ArrowFunctionExpression,
  NodeType34.FunctionDeclaration,
  NodeType34.FunctionExpression
]);
isOneOf34([
  NodeType34.ArrowFunctionExpression,
  NodeType34.FunctionDeclaration,
  NodeType34.FunctionExpression,
  NodeType34.TSCallSignatureDeclaration,
  NodeType34.TSConstructSignatureDeclaration,
  NodeType34.TSDeclareFunction,
  NodeType34.TSEmptyBodyFunctionExpression,
  NodeType34.TSFunctionType,
  NodeType34.TSMethodSignature
]);
isOneOf34([NodeType34.ClassDeclaration, NodeType34.ClassExpression]);
isOneOf34([
  NodeType34.DoWhileStatement,
  NodeType34.ForInStatement,
  NodeType34.ForOfStatement,
  NodeType34.ForStatement,
  NodeType34.WhileStatement
]);
isOneOf34([NodeType34.TSArrayType, NodeType34.TSTupleType]);
isOneOf34([
  NodeType34.PropertyDefinition,
  NodeType34.TSIndexSignature,
  NodeType34.TSParameterProperty,
  NodeType34.TSPropertySignature
]);
is34(NodeType34.JSXElement);
is34(NodeType34.JSXFragment);
isOneOf34([
  NodeType34.JSXAttribute,
  NodeType34.JSXSpreadChild,
  NodeType34.JSXClosingElement,
  NodeType34.JSXClosingFragment,
  NodeType34.JSXElement,
  NodeType34.JSXEmptyExpression,
  NodeType34.JSXExpressionContainer,
  NodeType34.JSXFragment,
  NodeType34.JSXIdentifier,
  NodeType34.JSXMemberExpression,
  NodeType34.JSXNamespacedName,
  NodeType34.JSXOpeningElement,
  NodeType34.JSXOpeningFragment,
  NodeType34.JSXSpreadAttribute,
  NodeType34.JSXSpreadChild,
  NodeType34.JSXText
]);
isOneOf34([
  NodeType34.JSXIdentifier,
  NodeType34.JSXMemberExpression,
  NodeType34.JSXNamespacedName
]);
isOneOf34([
  NodeType34.ArrayPattern,
  NodeType34.AssignmentPattern,
  NodeType34.ObjectPattern,
  NodeType34.RestElement
]);
isOneOf34([
  NodeType34.TSInterfaceDeclaration,
  NodeType34.TSTypeAliasDeclaration
]);
isOneOf34([
  NodeType34.ArrayExpression,
  NodeType34.ArrayPattern,
  NodeType34.ArrowFunctionExpression,
  NodeType34.CallExpression,
  NodeType34.ClassExpression,
  NodeType34.FunctionExpression,
  NodeType34.Identifier,
  NodeType34.JSXElement,
  NodeType34.JSXFragment,
  NodeType34.Literal,
  NodeType34.TemplateLiteral,
  NodeType34.MemberExpression,
  NodeType34.MetaProperty,
  NodeType34.ObjectExpression,
  NodeType34.ObjectPattern,
  NodeType34.SequenceExpression,
  NodeType34.Super,
  NodeType34.TaggedTemplateExpression,
  NodeType34.ThisExpression
]);
isOneOf34([
  NodeType34.ArrayExpression,
  NodeType34.ArrayPattern,
  NodeType34.ArrowFunctionExpression,
  NodeType34.CallExpression,
  NodeType34.ClassExpression,
  NodeType34.FunctionExpression,
  NodeType34.Identifier,
  NodeType34.JSXElement,
  NodeType34.JSXFragment,
  NodeType34.Literal,
  NodeType34.TemplateLiteral,
  NodeType34.MemberExpression,
  NodeType34.MetaProperty,
  NodeType34.ObjectExpression,
  NodeType34.ObjectPattern,
  NodeType34.SequenceExpression,
  NodeType34.Super,
  NodeType34.TaggedTemplateExpression,
  NodeType34.ThisExpression,
  NodeType34.TSAsExpression,
  NodeType34.TSNonNullExpression,
  NodeType34.TSTypeAssertion
]);
var Function_exports234 = {};
__export234(Function_exports234, {
  SK: () => SK234,
  absurd: () => absurd234,
  apply: () => apply234,
  compose: () => compose234,
  constFalse: () => constFalse234,
  constNull: () => constNull234,
  constTrue: () => constTrue234,
  constUndefined: () => constUndefined234,
  constVoid: () => constVoid234,
  constant: () => constant234,
  dual: () => dual234,
  flip: () => flip234,
  flow: () => flow234,
  hole: () => hole234,
  identity: () => identity234,
  isFunction: () => isFunction2234,
  pipe: () => pipe234,
  satisfies: () => satisfies234,
  tupled: () => tupled234,
  unsafeCoerce: () => unsafeCoerce234,
  untupled: () => untupled234
});
var isFunction2234 = (input) => typeof input === "function";
var dual234 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a2222, b2222) {
        if (arguments.length >= 2) {
          return body(a2222, b2222);
        }
        return function(self2) {
          return body(self2, a2222);
        };
      };
    case 3:
      return function(a2222, b2222, c2222) {
        if (arguments.length >= 3) {
          return body(a2222, b2222, c2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222);
        };
      };
    case 4:
      return function(a2222, b2222, c2222, d2222) {
        if (arguments.length >= 4) {
          return body(a2222, b2222, c2222, d2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222);
        };
      };
    case 5:
      return function(a2222, b2222, c2222, d2222, e2222) {
        if (arguments.length >= 5) {
          return body(a2222, b2222, c2222, d2222, e2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222, d2222);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply234 = (a2222) => (self2) => self2(a2222);
var identity234 = (a2222) => a2222;
var satisfies234 = () => (b2222) => b2222;
var unsafeCoerce234 = identity234;
var constant234 = (value) => () => value;
var constTrue234 = /* @__PURE__ */ constant234(true);
var constFalse234 = /* @__PURE__ */ constant234(false);
var constNull234 = /* @__PURE__ */ constant234(null);
var constUndefined234 = /* @__PURE__ */ constant234(void 0);
var constVoid234 = constUndefined234;
var flip234 = (f2222) => (...b2222) => (...a2222) => f2222(...a2222)(...b2222);
var compose234 = /* @__PURE__ */ dual234(2, (ab, bc) => (a2222) => bc(ab(a2222)));
var absurd234 = (_2222) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled234 = (f2222) => (a2222) => f2222(...a2222);
var untupled234 = (f2222) => (...a2222) => f2222(a2222);
function pipe234(a2222, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a2222;
    case 2:
      return ab(a2222);
    case 3:
      return bc(ab(a2222));
    case 4:
      return cd(bc(ab(a2222)));
    case 5:
      return de(cd(bc(ab(a2222))));
    case 6:
      return ef(de(cd(bc(ab(a2222)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a2222))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a2222)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a2222))))))));
    default: {
      let ret = arguments[0];
      for (let i2222 = 1; i2222 < arguments.length; i2222++) {
        ret = arguments[i2222](ret);
      }
      return ret;
    }
  }
}
function flow234(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole234 = /* @__PURE__ */ unsafeCoerce234(absurd234);
var SK234 = (_2222, b2222) => b2222;
var make434 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_334 = (map622) => dual234(3, (self2, name22, f2222) => map622(self2, (a2222) => Object.assign({}, a2222, {
  [name22]: f2222(a2222)
})));
var bindTo334 = (map622) => dual234(2, (self2, name22) => map622(self2, (a2222) => ({
  [name22]: a2222
})));
var bind334 = (map622, flatMap424) => dual234(3, (self2, name22, f2222) => flatMap424(self2, (a2222) => map622(f2222(a2222), (b2222) => Object.assign({}, a2222, {
  [name22]: b2222
}))));
var moduleVersion234 = "3.2.8";
var getCurrentVersion234 = () => moduleVersion234;
var globalStoreId234 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion234()}`);
if (!(globalStoreId234 in globalThis)) {
  globalThis[globalStoreId234] = /* @__PURE__ */ new Map();
}
var globalStore234 = globalThis[globalStoreId234];
var globalValue234 = (id, compute) => {
  if (!globalStore234.has(id)) {
    globalStore234.set(id, compute());
  }
  return globalStore234.get(id);
};
var Predicate_exports234 = {};
__export234(Predicate_exports234, {
  all: () => all234,
  and: () => and54,
  compose: () => compose2234,
  eqv: () => eqv54,
  every: () => every64,
  hasProperty: () => hasProperty234,
  implies: () => implies54,
  isBigInt: () => isBigInt54,
  isBoolean: () => isBoolean54,
  isDate: () => isDate54,
  isError: () => isError54,
  isFunction: () => isFunction3233,
  isIterable: () => isIterable54,
  isMap: () => isMap54,
  isNever: () => isNever54,
  isNotNull: () => isNotNull54,
  isNotNullable: () => isNotNullable54,
  isNotUndefined: () => isNotUndefined54,
  isNull: () => isNull54,
  isNullable: () => isNullable234,
  isNumber: () => isNumber54,
  isObject: () => isObject234,
  isPromise: () => isPromise54,
  isPromiseLike: () => isPromiseLike54,
  isReadonlyRecord: () => isReadonlyRecord54,
  isRecord: () => isRecord54,
  isSet: () => isSet54,
  isString: () => isString54,
  isSymbol: () => isSymbol54,
  isTagged: () => isTagged54,
  isTruthy: () => isTruthy54,
  isUint8Array: () => isUint8Array54,
  isUndefined: () => isUndefined54,
  isUnknown: () => isUnknown54,
  mapInput: () => mapInput64,
  nand: () => nand54,
  nor: () => nor54,
  not: () => not54,
  or: () => or54,
  product: () => product234,
  productMany: () => productMany234,
  some: () => some334,
  struct: () => struct74,
  tuple: () => tuple64,
  xor: () => xor54
});
var mapInput64 = /* @__PURE__ */ dual234(2, (self2, f2222) => (b2222) => self2(f2222(b2222)));
var isTruthy54 = (input) => !!input;
var isSet54 = (input) => input instanceof Set;
var isMap54 = (input) => input instanceof Map;
var isString54 = (input) => typeof input === "string";
var isNumber54 = (input) => typeof input === "number";
var isBoolean54 = (input) => typeof input === "boolean";
var isBigInt54 = (input) => typeof input === "bigint";
var isSymbol54 = (input) => typeof input === "symbol";
var isFunction3233 = isFunction2234;
var isUndefined54 = (input) => input === void 0;
var isNotUndefined54 = (input) => input !== void 0;
var isNull54 = (input) => input === null;
var isNotNull54 = (input) => input !== null;
var isNever54 = (_2222) => false;
var isUnknown54 = (_2222) => true;
var isRecordOrArray234 = (input) => typeof input === "object" && input !== null;
var isObject234 = (input) => isRecordOrArray234(input) || isFunction3233(input);
var hasProperty234 = /* @__PURE__ */ dual234(2, (self2, property) => isObject234(self2) && property in self2);
var isTagged54 = /* @__PURE__ */ dual234(2, (self2, tag) => hasProperty234(self2, "_tag") && self2["_tag"] === tag);
var isNullable234 = (input) => input === null || input === void 0;
var isNotNullable54 = (input) => input !== null && input !== void 0;
var isError54 = (input) => input instanceof Error;
var isUint8Array54 = (input) => input instanceof Uint8Array;
var isDate54 = (input) => input instanceof Date;
var isIterable54 = (input) => hasProperty234(input, Symbol.iterator);
var isRecord54 = (input) => isRecordOrArray234(input) && !Array.isArray(input);
var isReadonlyRecord54 = isRecord54;
var isPromise54 = (input) => hasProperty234(input, "then") && "catch" in input && isFunction3233(input.then) && isFunction3233(input.catch);
var isPromiseLike54 = (input) => hasProperty234(input, "then") && isFunction3233(input.then);
var compose2234 = /* @__PURE__ */ dual234(2, (ab, bc) => (a2222) => ab(a2222) && bc(a2222));
var product234 = (self2, that) => ([a2222, b2222]) => self2(a2222) && that(b2222);
var all234 = (collection) => {
  return (as2234) => {
    let collectionIndex = 0;
    for (const p2222 of collection) {
      if (collectionIndex >= as2234.length) {
        break;
      }
      if (p2222(as2234[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany234 = (self2, collection) => {
  const rest = all234(collection);
  return ([head222, ...tail34]) => self2(head222) === false ? false : rest(tail34);
};
var tuple64 = (...elements) => all234(elements);
var struct74 = (fields) => {
  const keys234 = Object.keys(fields);
  return (a2222) => {
    for (const key of keys234) {
      if (!fields[key](a2222[key])) {
        return false;
      }
    }
    return true;
  };
};
var not54 = (self2) => (a2222) => !self2(a2222);
var or54 = /* @__PURE__ */ dual234(2, (self2, that) => (a2222) => self2(a2222) || that(a2222));
var and54 = /* @__PURE__ */ dual234(2, (self2, that) => (a2222) => self2(a2222) && that(a2222));
var xor54 = /* @__PURE__ */ dual234(2, (self2, that) => (a2222) => self2(a2222) !== that(a2222));
var eqv54 = /* @__PURE__ */ dual234(2, (self2, that) => (a2222) => self2(a2222) === that(a2222));
var implies54 = /* @__PURE__ */ dual234(2, (self2, that) => (a2222) => self2(a2222) ? that(a2222) : true);
var nor54 = /* @__PURE__ */ dual234(2, (self2, that) => (a2222) => !(self2(a2222) || that(a2222)));
var nand54 = /* @__PURE__ */ dual234(2, (self2, that) => (a2222) => !(self2(a2222) && that(a2222)));
var every64 = (collection) => (a2222) => {
  for (const p2222 of collection) {
    if (!p2222(a2222)) {
      return false;
    }
  }
  return true;
};
var some334 = (collection) => (a2222) => {
  for (const p2222 of collection) {
    if (p2222(a2222)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage234 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId234 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind234 = (u2222) => isObject234(u2222) && GenKindTypeId234 in u2222;
var GenKindImpl234 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity234;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId234] = GenKindTypeId234;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen234(this);
  }
};
var SingleShotGen234 = class _SingleShotGen64 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a2222) {
    return this.called ? {
      value: a2222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a2222) {
    return {
      value: a2222,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e2222) {
    throw e2222;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen64(this.self);
  }
};
var adapter334 = () => function() {
  let x2222 = arguments[0];
  for (let i2222 = 1; i2222 < arguments.length; i2222++) {
    x2222 = arguments[i2222](x2222);
  }
  return new GenKindImpl234(x2222);
};
var defaultIncHi234 = 335903614;
var defaultIncLo234 = 4150755663;
var MUL_HI234 = 1481765933 >>> 0;
var MUL_LO234 = 1284865837 >>> 0;
var BIT_53234 = 9007199254740992;
var BIT_27234 = 134217728;
var PCGRandom234 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable234(seedLo) && isNullable234(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable234(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable234(incLo) && isNullable234(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo234;
      incHi = this._state ? this._state[2] : defaultIncHi234;
    } else if (isNullable234(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add64234(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max34) {
    if (!max34) {
      return this._next();
    }
    max34 = max34 >>> 0;
    if ((max34 & max34 - 1) === 0) {
      return this._next() & max34 - 1;
    }
    let num = 0;
    const skew = (-max34 >>> 0) % max34 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max34;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_27234 + lo) / BIT_53234;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul64234(this._state, oldHi, oldLo, MUL_HI234, MUL_LO234);
    add64234(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul64234(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add64234(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId234 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap234 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId234]() {
    return this.#value;
  }
};
function yieldWrapGet234(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId234 in self2) {
    return self2[YieldWrapTypeId234]();
  }
  throw new Error(getBugErrorMessage234("yieldWrapGet"));
}
var structuralRegionState234 = /* @__PURE__ */ globalValue234("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache234 = /* @__PURE__ */ globalValue234(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr234 = /* @__PURE__ */ globalValue234(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom234());
var symbol334 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash234 = (self2) => {
  if (structuralRegionState234.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number234(self2);
    case "bigint":
      return string234(self2.toString(10));
    case "boolean":
      return string234(String(self2));
    case "symbol":
      return string234(String(self2));
    case "string":
      return string234(self2);
    case "undefined":
      return string234("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string234("null");
      } else if (self2 instanceof Date) {
        return hash234(self2.toISOString());
      } else if (isHash234(self2)) {
        return self2[symbol334]();
      } else {
        return random234(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random234 = (self2) => {
  if (!randomHashCache234.has(self2)) {
    randomHashCache234.set(self2, number234(pcgr234.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache234.get(self2);
};
var combine234 = (b2222) => (self2) => self2 * 53 ^ b2222;
var optimize234 = (n2222) => n2222 & 3221225471 | n2222 >>> 1 & 1073741824;
var isHash234 = (u2222) => hasProperty234(u2222, symbol334);
var number234 = (n2222) => {
  if (n2222 !== n2222 || n2222 === Infinity) {
    return 0;
  }
  let h2222 = n2222 | 0;
  if (h2222 !== n2222) {
    h2222 ^= n2222 * 4294967295;
  }
  while (n2222 > 4294967295) {
    h2222 ^= n2222 /= 4294967295;
  }
  return optimize234(n2222);
};
var string234 = (str) => {
  let h2222 = 5381, i2222 = str.length;
  while (i2222) {
    h2222 = h2222 * 33 ^ str.charCodeAt(--i2222);
  }
  return optimize234(h2222);
};
var structureKeys234 = (o2222, keys234) => {
  let h2222 = 12289;
  for (let i2222 = 0; i2222 < keys234.length; i2222++) {
    h2222 ^= pipe234(string234(keys234[i2222]), combine234(hash234(o2222[keys234[i2222]])));
  }
  return optimize234(h2222);
};
var structure234 = (o2222) => structureKeys234(o2222, Object.keys(o2222));
var array74 = (arr) => {
  let h2222 = 6151;
  for (let i2222 = 0; i2222 < arr.length; i2222++) {
    h2222 = pipe234(h2222, combine234(hash234(arr[i2222])));
  }
  return optimize234(h2222);
};
var cached234 = function() {
  if (arguments.length === 1) {
    const self22 = arguments[0];
    return function(hash324) {
      Object.defineProperty(self22, symbol334, {
        value() {
          return hash324;
        },
        enumerable: false
      });
      return hash324;
    };
  }
  const self2 = arguments[0];
  const hash2234 = arguments[1];
  Object.defineProperty(self2, symbol334, {
    value() {
      return hash2234;
    },
    enumerable: false
  });
  return hash2234;
};
var symbol2234 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals234() {
  if (arguments.length === 1) {
    return (self2) => compareBoth234(self2, arguments[0]);
  }
  return compareBoth234(arguments[0], arguments[1]);
}
function compareBoth234(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual234(self2) && isEqual234(that)) {
        if (hash234(self2) === hash234(that) && self2[symbol2234](that)) {
          return true;
        } else {
          return structuralRegionState234.enabled && structuralRegionState234.tester ? structuralRegionState234.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState234.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v2222, i2222) => compareBoth234(v2222, that[i2222]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth234(self2[key], that[key]))) {
              return structuralRegionState234.tester ? structuralRegionState234.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState234.tester ? structuralRegionState234.tester(self2, that) : false;
    }
  }
  return structuralRegionState234.enabled && structuralRegionState234.tester ? structuralRegionState234.tester(self2, that) : false;
}
var isEqual234 = (u2222) => hasProperty234(u2222, symbol2234);
var equivalence234 = () => equals234;
var NodeInspectSymbol234 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON234 = (x2222) => {
  if (hasProperty234(x2222, "toJSON") && isFunction3233(x2222["toJSON"]) && x2222["toJSON"].length === 0) {
    return x2222.toJSON();
  } else if (Array.isArray(x2222)) {
    return x2222.map(toJSON234);
  }
  return x2222;
};
var format234 = (x2222) => JSON.stringify(x2222, null, 2);
var pipeArguments234 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i2222 = 0, len = args.length; i2222 < len; i2222++) {
        ret = args[i2222](ret);
      }
      return ret;
    }
  }
};
var OP_COMMIT234 = "Commit";
var OP_FAILURE34 = "Failure";
var OP_WITH_RUNTIME34 = "WithRuntime";
var EffectTypeId234 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId234 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId234 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId234 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance234 = {
  /* c8 ignore next */
  _R: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _A: (_2222) => _2222,
  _V: /* @__PURE__ */ getCurrentVersion234()
};
var sinkVariance234 = {
  /* c8 ignore next */
  _A: (_2222) => _2222,
  /* c8 ignore next */
  _In: (_2222) => _2222,
  /* c8 ignore next */
  _L: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _R: (_2222) => _2222
};
var channelVariance234 = {
  /* c8 ignore next */
  _Env: (_2222) => _2222,
  /* c8 ignore next */
  _InErr: (_2222) => _2222,
  /* c8 ignore next */
  _InElem: (_2222) => _2222,
  /* c8 ignore next */
  _InDone: (_2222) => _2222,
  /* c8 ignore next */
  _OutErr: (_2222) => _2222,
  /* c8 ignore next */
  _OutElem: (_2222) => _2222,
  /* c8 ignore next */
  _OutDone: (_2222) => _2222
};
var EffectPrototype234 = {
  [EffectTypeId234]: effectVariance234,
  [StreamTypeId234]: effectVariance234,
  [SinkTypeId234]: sinkVariance234,
  [ChannelTypeId234]: channelVariance234,
  [symbol2234](that) {
    return this === that;
  },
  [symbol334]() {
    return cached234(this, random234(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen234(new YieldWrap234(this));
  },
  pipe() {
    return pipeArguments234(this, arguments);
  }
};
var StructuralPrototype234 = {
  [symbol334]() {
    return cached234(this, structure234(this));
  },
  [symbol2234](that) {
    const selfKeys = Object.keys(this);
    const thatKeys = Object.keys(that);
    if (selfKeys.length !== thatKeys.length) {
      return false;
    }
    for (const key of selfKeys) {
      if (!(key in that && equals234(this[key], that[key]))) {
        return false;
      }
    }
    return true;
  }
};
var CommitPrototype234 = {
  ...EffectPrototype234,
  _op: OP_COMMIT234
};
var StructuralCommitPrototype234 = {
  ...CommitPrototype234,
  ...StructuralPrototype234
};
var TypeId534 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto334 = {
  ...EffectPrototype234,
  [TypeId534]: {
    _A: (_2222) => _2222
  },
  [NodeInspectSymbol234]() {
    return this.toJSON();
  },
  toString() {
    return format234(this.toJSON());
  }
};
var SomeProto234 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto334), {
  _tag: "Some",
  _op: "Some",
  [symbol2234](that) {
    return isOption334(that) && isSome334(that) && equals234(this.value, that.value);
  },
  [symbol334]() {
    return cached234(this, combine234(hash234(this._tag))(hash234(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON234(this.value)
    };
  }
});
var NoneHash234 = /* @__PURE__ */ hash234("None");
var NoneProto234 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto334), {
  _tag: "None",
  _op: "None",
  [symbol2234](that) {
    return isOption334(that) && isNone334(that);
  },
  [symbol334]() {
    return NoneHash234;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption334 = (input) => hasProperty234(input, TypeId534);
var isNone334 = (fa) => fa._tag === "None";
var isSome334 = (fa) => fa._tag === "Some";
var none334 = /* @__PURE__ */ Object.create(NoneProto234);
var some2234 = (value) => {
  const a2222 = Object.create(SomeProto234);
  a2222.value = value;
  return a2222;
};
var TypeId2234 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto2234 = {
  ...EffectPrototype234,
  [TypeId2234]: {
    _R: (_2222) => _2222
  },
  [NodeInspectSymbol234]() {
    return this.toJSON();
  },
  toString() {
    return format234(this.toJSON());
  }
};
var RightProto234 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto2234), {
  _tag: "Right",
  _op: "Right",
  [symbol2234](that) {
    return isEither234(that) && isRight234(that) && equals234(this.right, that.right);
  },
  [symbol334]() {
    return combine234(hash234(this._tag))(hash234(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON234(this.right)
    };
  }
});
var LeftProto234 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto2234), {
  _tag: "Left",
  _op: "Left",
  [symbol2234](that) {
    return isEither234(that) && isLeft234(that) && equals234(this.left, that.left);
  },
  [symbol334]() {
    return combine234(hash234(this._tag))(hash234(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON234(this.left)
    };
  }
});
var isEither234 = (input) => hasProperty234(input, TypeId2234);
var isLeft234 = (ma) => ma._tag === "Left";
var isRight234 = (ma) => ma._tag === "Right";
var left234 = (left334) => {
  const a2222 = Object.create(LeftProto234);
  a2222.left = left334;
  return a2222;
};
var right234 = (right334) => {
  const a2222 = Object.create(RightProto234);
  a2222.right = right334;
  return a2222;
};
var getLeft334 = (self2) => isRight234(self2) ? none334 : some2234(self2.left);
var getRight334 = (self2) => isLeft234(self2) ? none334 : some2234(self2.right);
var right2234 = right234;
var left2234 = left234;
var Option_exports234 = {};
__export234(Option_exports234, {
  Do: () => Do234,
  TypeId: () => TypeId3234,
  all: () => all2234,
  andThen: () => andThen234,
  ap: () => ap234,
  as: () => as234,
  asVoid: () => asVoid234,
  bind: () => bind2234,
  bindTo: () => bindTo2234,
  composeK: () => composeK234,
  contains: () => contains234,
  containsWith: () => containsWith234,
  exists: () => exists234,
  filter: () => filter234,
  filterMap: () => filterMap234,
  firstSomeOf: () => firstSomeOf234,
  flatMap: () => flatMap234,
  flatMapNullable: () => flatMapNullable234,
  flatten: () => flatten234,
  fromIterable: () => fromIterable234,
  fromNullable: () => fromNullable234,
  gen: () => gen234,
  getEquivalence: () => getEquivalence234,
  getLeft: () => getLeft2234,
  getOrElse: () => getOrElse234,
  getOrNull: () => getOrNull234,
  getOrThrow: () => getOrThrow234,
  getOrThrowWith: () => getOrThrowWith234,
  getOrUndefined: () => getOrUndefined234,
  getOrder: () => getOrder234,
  getRight: () => getRight2234,
  isNone: () => isNone2234,
  isOption: () => isOption2234,
  isSome: () => isSome2234,
  let: () => let_2234,
  lift2: () => lift2234,
  liftNullable: () => liftNullable234,
  liftPredicate: () => liftPredicate234,
  liftThrowable: () => liftThrowable234,
  map: () => map234,
  match: () => match234,
  none: () => none2234,
  orElse: () => orElse234,
  orElseEither: () => orElseEither234,
  orElseSome: () => orElseSome234,
  partitionMap: () => partitionMap234,
  product: () => product2234,
  productMany: () => productMany2234,
  reduceCompact: () => reduceCompact234,
  some: () => some3234,
  tap: () => tap234,
  toArray: () => toArray234,
  toRefinement: () => toRefinement234,
  void: () => void_234,
  zipLeft: () => zipLeft234,
  zipRight: () => zipRight234,
  zipWith: () => zipWith234
});
var make2234 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId3234 = /* @__PURE__ */ Symbol.for("effect/Option");
var none2234 = () => none334;
var some3234 = some2234;
var isOption2234 = isOption334;
var isNone2234 = isNone334;
var isSome2234 = isSome334;
var match234 = /* @__PURE__ */ dual234(2, (self2, {
  onNone,
  onSome
}) => isNone2234(self2) ? onNone() : onSome(self2.value));
var toRefinement234 = (f2222) => (a2222) => isSome2234(f2222(a2222));
var fromIterable234 = (collection) => {
  for (const a2222 of collection) {
    return some3234(a2222);
  }
  return none2234();
};
var getRight2234 = getRight334;
var getLeft2234 = getLeft334;
var getOrElse234 = /* @__PURE__ */ dual234(2, (self2, onNone) => isNone2234(self2) ? onNone() : self2.value);
var orElse234 = /* @__PURE__ */ dual234(2, (self2, that) => isNone2234(self2) ? that() : self2);
var orElseSome234 = /* @__PURE__ */ dual234(2, (self2, onNone) => isNone2234(self2) ? some3234(onNone()) : self2);
var orElseEither234 = /* @__PURE__ */ dual234(2, (self2, that) => isNone2234(self2) ? map234(that(), right234) : map234(self2, left234));
var firstSomeOf234 = (collection) => {
  let out = none2234();
  for (out of collection) {
    if (isSome2234(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable234 = (nullableValue) => nullableValue == null ? none2234() : some3234(nullableValue);
var liftNullable234 = (f2222) => (...a2222) => fromNullable234(f2222(...a2222));
var getOrNull234 = /* @__PURE__ */ getOrElse234(constNull234);
var getOrUndefined234 = /* @__PURE__ */ getOrElse234(constUndefined234);
var liftThrowable234 = (f2222) => (...a2222) => {
  try {
    return some3234(f2222(...a2222));
  } catch (e2222) {
    return none2234();
  }
};
var getOrThrowWith234 = /* @__PURE__ */ dual234(2, (self2, onNone) => {
  if (isSome2234(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow234 = /* @__PURE__ */ getOrThrowWith234(() => new Error("getOrThrow called on a None"));
var map234 = /* @__PURE__ */ dual234(2, (self2, f2222) => isNone2234(self2) ? none2234() : some3234(f2222(self2.value)));
var as234 = /* @__PURE__ */ dual234(2, (self2, b2222) => map234(self2, () => b2222));
var asVoid234 = /* @__PURE__ */ as234(void 0);
var void_234 = /* @__PURE__ */ some3234(void 0);
var flatMap234 = /* @__PURE__ */ dual234(2, (self2, f2222) => isNone2234(self2) ? none2234() : f2222(self2.value));
var andThen234 = /* @__PURE__ */ dual234(2, (self2, f2222) => flatMap234(self2, (a2222) => {
  const b2222 = isFunction2234(f2222) ? f2222(a2222) : f2222;
  return isOption2234(b2222) ? b2222 : some3234(b2222);
}));
var flatMapNullable234 = /* @__PURE__ */ dual234(2, (self2, f2222) => isNone2234(self2) ? none2234() : fromNullable234(f2222(self2.value)));
var flatten234 = /* @__PURE__ */ flatMap234(identity234);
var zipRight234 = /* @__PURE__ */ dual234(2, (self2, that) => flatMap234(self2, () => that));
var composeK234 = /* @__PURE__ */ dual234(2, (afb, bfc) => (a2222) => flatMap234(afb(a2222), bfc));
var zipLeft234 = /* @__PURE__ */ dual234(2, (self2, that) => tap234(self2, () => that));
var tap234 = /* @__PURE__ */ dual234(2, (self2, f2222) => flatMap234(self2, (a2222) => map234(f2222(a2222), () => a2222)));
var product2234 = (self2, that) => isSome2234(self2) && isSome2234(that) ? some3234([self2.value, that.value]) : none2234();
var productMany2234 = (self2, collection) => {
  if (isNone2234(self2)) {
    return none2234();
  }
  const out = [self2.value];
  for (const o2222 of collection) {
    if (isNone2234(o2222)) {
      return none2234();
    }
    out.push(o2222.value);
  }
  return some3234(out);
};
var all2234 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o2222 of input) {
      if (isNone2234(o2222)) {
        return none2234();
      }
      out2.push(o2222.value);
    }
    return some3234(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o2222 = input[key];
    if (isNone2234(o2222)) {
      return none2234();
    }
    out[key] = o2222.value;
  }
  return some3234(out);
};
var zipWith234 = /* @__PURE__ */ dual234(3, (self2, that, f2222) => map234(product2234(self2, that), ([a2222, b2222]) => f2222(a2222, b2222)));
var ap234 = /* @__PURE__ */ dual234(2, (self2, that) => zipWith234(self2, that, (f2222, a2222) => f2222(a2222)));
var reduceCompact234 = /* @__PURE__ */ dual234(3, (self2, b2222, f2222) => {
  let out = b2222;
  for (const oa of self2) {
    if (isSome2234(oa)) {
      out = f2222(out, oa.value);
    }
  }
  return out;
});
var toArray234 = (self2) => isNone2234(self2) ? [] : [self2.value];
var partitionMap234 = /* @__PURE__ */ dual234(2, (self2, f2222) => {
  if (isNone2234(self2)) {
    return [none2234(), none2234()];
  }
  const e2222 = f2222(self2.value);
  return isLeft234(e2222) ? [some3234(e2222.left), none2234()] : [none2234(), some3234(e2222.right)];
});
var filterMap234 = /* @__PURE__ */ dual234(2, (self2, f2222) => isNone2234(self2) ? none2234() : f2222(self2.value));
var filter234 = /* @__PURE__ */ dual234(2, (self2, predicate) => filterMap234(self2, (b2222) => predicate(b2222) ? some2234(b2222) : none334));
var getEquivalence234 = (isEquivalent) => make434((x2222, y2222) => x2222 === y2222 || (isNone2234(x2222) ? isNone2234(y2222) : isNone2234(y2222) ? false : isEquivalent(x2222.value, y2222.value)));
var getOrder234 = (O2222) => make2234((self2, that) => isSome2234(self2) ? isSome2234(that) ? O2222(self2.value, that.value) : 1 : -1);
var lift2234 = (f2222) => dual234(2, (self2, that) => zipWith234(self2, that, f2222));
var liftPredicate234 = (predicate) => (b2222) => predicate(b2222) ? some3234(b2222) : none2234();
var containsWith234 = (isEquivalent) => dual234(2, (self2, a2222) => isNone2234(self2) ? false : isEquivalent(self2.value, a2222));
var _equivalence234 = /* @__PURE__ */ equivalence234();
var contains234 = /* @__PURE__ */ containsWith234(_equivalence234);
var exists234 = /* @__PURE__ */ dual234(2, (self2, refinement) => isNone2234(self2) ? false : refinement(self2.value));
var bindTo2234 = /* @__PURE__ */ bindTo334(map234);
var let_2234 = /* @__PURE__ */ let_334(map234);
var bind2234 = /* @__PURE__ */ bind334(map234, flatMap234);
var Do234 = /* @__PURE__ */ some3234({});
var adapter2234 = /* @__PURE__ */ adapter334();
var gen234 = (f2222) => {
  const iterator = f2222(adapter2234);
  let state = iterator.next();
  if (state.done) {
    return some3234(state.value);
  } else {
    let current = state.value;
    if (isGenKind234(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet234(current);
    }
    if (isNone2234(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind234(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet234(current);
        }
        if (isNone2234(current)) {
          return current;
        }
      }
    }
    return some3234(state.value);
  }
};
var fromIterable2234 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var reverse54 = (self2) => Array.from(self2).reverse();
var reduce64 = /* @__PURE__ */ dual234(3, (self2, b2222, f2222) => fromIterable2234(self2).reduce((b22222, a2222, i2222) => f2222(b22222, a2222, i2222), b2222));
var TagTypeId34 = /* @__PURE__ */ Symbol.for("effect/Context/Tag");
var STMSymbolKey34 = "effect/STM";
var STMTypeId34 = /* @__PURE__ */ Symbol.for(STMSymbolKey34);
var TagProto34 = {
  ...EffectPrototype234,
  _tag: "Tag",
  _op: "Tag",
  [STMTypeId34]: effectVariance234,
  [TagTypeId34]: {
    _Service: (_2222) => _2222,
    _Identifier: (_2222) => _2222
  },
  toString() {
    return format234(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Tag",
      key: this.key,
      stack: this.stack
    };
  },
  [NodeInspectSymbol234]() {
    return this.toJSON();
  },
  of(self2) {
    return self2;
  },
  context(self2) {
    return make3234(this, self2);
  }
};
var makeGenericTag34 = (key) => {
  const limit = Error.stackTraceLimit;
  Error.stackTraceLimit = 2;
  const creationError = new Error();
  Error.stackTraceLimit = limit;
  const tag = Object.create(TagProto34);
  Object.defineProperty(tag, "stack", {
    get() {
      return creationError.stack;
    }
  });
  tag.key = key;
  return tag;
};
var TypeId4234 = /* @__PURE__ */ Symbol.for("effect/Context");
var ContextProto34 = {
  [TypeId4234]: {
    _Services: (_2222) => _2222
  },
  [symbol2234](that) {
    if (isContext34(that)) {
      if (this.unsafeMap.size === that.unsafeMap.size) {
        for (const k2222 of this.unsafeMap.keys()) {
          if (!that.unsafeMap.has(k2222) || !equals234(this.unsafeMap.get(k2222), that.unsafeMap.get(k2222))) {
            return false;
          }
        }
        return true;
      }
    }
    return false;
  },
  [symbol334]() {
    return cached234(this, number234(this.unsafeMap.size));
  },
  pipe() {
    return pipeArguments234(this, arguments);
  },
  toString() {
    return format234(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Context",
      services: Array.from(this.unsafeMap).map(toJSON234)
    };
  },
  [NodeInspectSymbol234]() {
    return this.toJSON();
  }
};
var makeContext34 = (unsafeMap) => {
  const context = Object.create(ContextProto34);
  context.unsafeMap = unsafeMap;
  return context;
};
var isContext34 = (u2222) => hasProperty234(u2222, TypeId4234);
var _empty74 = /* @__PURE__ */ makeContext34(/* @__PURE__ */ new Map());
var empty124 = () => _empty74;
var make3234 = (tag, service) => makeContext34(/* @__PURE__ */ new Map([[tag.key, service]]));
var GenericTag34 = makeGenericTag34;
var empty234 = empty124;
var TypeId5234 = /* @__PURE__ */ Symbol.for("effect/Chunk");
function copy44(src, srcPos, dest, destPos, len) {
  for (let i2222 = srcPos; i2222 < Math.min(src.length, srcPos + len); i2222++) {
    dest[destPos + i2222 - srcPos] = src[i2222];
  }
  return dest;
}
var emptyArray34 = [];
var getEquivalence2234 = (isEquivalent) => make434((self2, that) => self2.length === that.length && toReadonlyArray34(self2).every((value, i2222) => isEquivalent(value, unsafeGet234(that, i2222))));
var _equivalence2234 = /* @__PURE__ */ getEquivalence2234(equals234);
var ChunkProto34 = {
  [TypeId5234]: {
    _A: (_2222) => _2222
  },
  toString() {
    return format234(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Chunk",
      values: toReadonlyArray34(this).map(toJSON234)
    };
  },
  [NodeInspectSymbol234]() {
    return this.toJSON();
  },
  [symbol2234](that) {
    return isChunk34(that) && _equivalence2234(this, that);
  },
  [symbol334]() {
    return cached234(this, array74(toReadonlyArray34(this)));
  },
  [Symbol.iterator]() {
    switch (this.backing._tag) {
      case "IArray": {
        return this.backing.array[Symbol.iterator]();
      }
      case "IEmpty": {
        return emptyArray34[Symbol.iterator]();
      }
      default: {
        return toReadonlyArray34(this)[Symbol.iterator]();
      }
    }
  },
  pipe() {
    return pipeArguments234(this, arguments);
  }
};
var makeChunk34 = (backing) => {
  const chunk = Object.create(ChunkProto34);
  chunk.backing = backing;
  switch (backing._tag) {
    case "IEmpty": {
      chunk.length = 0;
      chunk.depth = 0;
      chunk.left = chunk;
      chunk.right = chunk;
      break;
    }
    case "IConcat": {
      chunk.length = backing.left.length + backing.right.length;
      chunk.depth = 1 + Math.max(backing.left.depth, backing.right.depth);
      chunk.left = backing.left;
      chunk.right = backing.right;
      break;
    }
    case "IArray": {
      chunk.length = backing.array.length;
      chunk.depth = 0;
      chunk.left = _empty234;
      chunk.right = _empty234;
      break;
    }
    case "ISingleton": {
      chunk.length = 1;
      chunk.depth = 0;
      chunk.left = _empty234;
      chunk.right = _empty234;
      break;
    }
    case "ISlice": {
      chunk.length = backing.length;
      chunk.depth = backing.chunk.depth + 1;
      chunk.left = _empty234;
      chunk.right = _empty234;
      break;
    }
  }
  return chunk;
};
var isChunk34 = (u2222) => hasProperty234(u2222, TypeId5234);
var _empty234 = /* @__PURE__ */ makeChunk34({
  _tag: "IEmpty"
});
var empty334 = () => _empty234;
var make4234 = (...as2234) => as2234.length === 1 ? of44(as2234[0]) : unsafeFromNonEmptyArray34(as2234);
var of44 = (a2222) => makeChunk34({
  _tag: "ISingleton",
  a: a2222
});
var copyToArray34 = (self2, array334, initial) => {
  switch (self2.backing._tag) {
    case "IArray": {
      copy44(self2.backing.array, 0, array334, initial, self2.length);
      break;
    }
    case "IConcat": {
      copyToArray34(self2.left, array334, initial);
      copyToArray34(self2.right, array334, initial + self2.left.length);
      break;
    }
    case "ISingleton": {
      array334[initial] = self2.backing.a;
      break;
    }
    case "ISlice": {
      let i2222 = 0;
      let j2222 = initial;
      while (i2222 < self2.length) {
        array334[j2222] = unsafeGet234(self2, i2222);
        i2222 += 1;
        j2222 += 1;
      }
      break;
    }
  }
};
var toReadonlyArray34 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      return emptyArray34;
    }
    case "IArray": {
      return self2.backing.array;
    }
    default: {
      const arr = new Array(self2.length);
      copyToArray34(self2, arr, 0);
      self2.backing = {
        _tag: "IArray",
        array: arr
      };
      self2.left = _empty234;
      self2.right = _empty234;
      self2.depth = 0;
      return arr;
    }
  }
};
var reverse234 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty":
    case "ISingleton":
      return self2;
    case "IArray": {
      return makeChunk34({
        _tag: "IArray",
        array: reverse54(self2.backing.array)
      });
    }
    case "IConcat": {
      return makeChunk34({
        _tag: "IConcat",
        left: reverse234(self2.backing.right),
        right: reverse234(self2.backing.left)
      });
    }
    case "ISlice":
      return unsafeFromArray34(reverse54(toReadonlyArray34(self2)));
  }
};
var unsafeFromArray34 = (self2) => makeChunk34({
  _tag: "IArray",
  array: self2
});
var unsafeFromNonEmptyArray34 = (self2) => unsafeFromArray34(self2);
var unsafeGet234 = /* @__PURE__ */ dual234(2, (self2, index) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      throw new Error(`Index out of bounds`);
    }
    case "ISingleton": {
      if (index !== 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.a;
    }
    case "IArray": {
      if (index >= self2.length || index < 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.array[index];
    }
    case "IConcat": {
      return index < self2.left.length ? unsafeGet234(self2.left, index) : unsafeGet234(self2.right, index - self2.left.length);
    }
    case "ISlice": {
      return unsafeGet234(self2.backing.chunk, index + self2.backing.offset);
    }
  }
});
var prepend54 = /* @__PURE__ */ dual234(2, (self2, elem) => appendAll44(of44(elem), self2));
var drop44 = /* @__PURE__ */ dual234(2, (self2, n2222) => {
  if (n2222 <= 0) {
    return self2;
  } else if (n2222 >= self2.length) {
    return _empty234;
  } else {
    switch (self2.backing._tag) {
      case "ISlice": {
        return makeChunk34({
          _tag: "ISlice",
          chunk: self2.backing.chunk,
          offset: self2.backing.offset + n2222,
          length: self2.backing.length - n2222
        });
      }
      case "IConcat": {
        if (n2222 > self2.left.length) {
          return drop44(self2.right, n2222 - self2.left.length);
        }
        return makeChunk34({
          _tag: "IConcat",
          left: drop44(self2.left, n2222),
          right: self2.right
        });
      }
      default: {
        return makeChunk34({
          _tag: "ISlice",
          chunk: self2,
          offset: n2222,
          length: self2.length - n2222
        });
      }
    }
  }
});
var appendAll44 = /* @__PURE__ */ dual234(2, (self2, that) => {
  if (self2.backing._tag === "IEmpty") {
    return that;
  }
  if (that.backing._tag === "IEmpty") {
    return self2;
  }
  const diff234 = that.depth - self2.depth;
  if (Math.abs(diff234) <= 1) {
    return makeChunk34({
      _tag: "IConcat",
      left: self2,
      right: that
    });
  } else if (diff234 < -1) {
    if (self2.left.depth >= self2.right.depth) {
      const nr = appendAll44(self2.right, that);
      return makeChunk34({
        _tag: "IConcat",
        left: self2.left,
        right: nr
      });
    } else {
      const nrr = appendAll44(self2.right.right, that);
      if (nrr.depth === self2.depth - 3) {
        const nr = makeChunk34({
          _tag: "IConcat",
          left: self2.right.left,
          right: nrr
        });
        return makeChunk34({
          _tag: "IConcat",
          left: self2.left,
          right: nr
        });
      } else {
        const nl = makeChunk34({
          _tag: "IConcat",
          left: self2.left,
          right: self2.right.left
        });
        return makeChunk34({
          _tag: "IConcat",
          left: nl,
          right: nrr
        });
      }
    }
  } else {
    if (that.right.depth >= that.left.depth) {
      const nl = appendAll44(self2, that.left);
      return makeChunk34({
        _tag: "IConcat",
        left: nl,
        right: that.right
      });
    } else {
      const nll = appendAll44(self2, that.left.left);
      if (nll.depth === that.depth - 3) {
        const nl = makeChunk34({
          _tag: "IConcat",
          left: nll,
          right: that.left.right
        });
        return makeChunk34({
          _tag: "IConcat",
          left: nl,
          right: that.right
        });
      } else {
        const nr = makeChunk34({
          _tag: "IConcat",
          left: that.left.right,
          right: that.right
        });
        return makeChunk34({
          _tag: "IConcat",
          left: nll,
          right: nr
        });
      }
    }
  }
});
var isEmpty44 = (self2) => self2.length === 0;
var isNonEmpty34 = (self2) => self2.length > 0;
var unsafeHead34 = (self2) => unsafeGet234(self2, 0);
var headNonEmpty44 = unsafeHead34;
var tailNonEmpty44 = (self2) => drop44(self2, 1);
var SIZE34 = 5;
var BUCKET_SIZE34 = /* @__PURE__ */ Math.pow(2, SIZE34);
var MASK34 = BUCKET_SIZE34 - 1;
var MAX_INDEX_NODE34 = BUCKET_SIZE34 / 2;
var MIN_ARRAY_NODE34 = BUCKET_SIZE34 / 4;
function popcount34(x2222) {
  x2222 -= x2222 >> 1 & 1431655765;
  x2222 = (x2222 & 858993459) + (x2222 >> 2 & 858993459);
  x2222 = x2222 + (x2222 >> 4) & 252645135;
  x2222 += x2222 >> 8;
  x2222 += x2222 >> 16;
  return x2222 & 127;
}
function hashFragment34(shift22, h2222) {
  return h2222 >>> shift22 & MASK34;
}
function toBitmap34(x2222) {
  return 1 << x2222;
}
function fromBitmap34(bitmap, bit) {
  return popcount34(bitmap & bit - 1);
}
var make534 = (value, previous) => ({
  value,
  previous
});
function arrayUpdate34(mutate234, at, v2222, arr) {
  let out = arr;
  if (!mutate234) {
    const len = arr.length;
    out = new Array(len);
    for (let i2222 = 0; i2222 < len; ++i2222) out[i2222] = arr[i2222];
  }
  out[at] = v2222;
  return out;
}
function arraySpliceOut34(mutate234, at, arr) {
  const newLen = arr.length - 1;
  let i2222 = 0;
  let g2222 = 0;
  let out = arr;
  if (mutate234) {
    i2222 = g2222 = at;
  } else {
    out = new Array(newLen);
    while (i2222 < at) out[g2222++] = arr[i2222++];
  }
  ++i2222;
  while (i2222 <= newLen) out[g2222++] = arr[i2222++];
  if (mutate234) {
    out.length = newLen;
  }
  return out;
}
function arraySpliceIn34(mutate234, at, v2222, arr) {
  const len = arr.length;
  if (mutate234) {
    let i22222 = len;
    while (i22222 >= at) arr[i22222--] = arr[i22222];
    arr[at] = v2222;
    return arr;
  }
  let i2222 = 0, g2222 = 0;
  const out = new Array(len + 1);
  while (i2222 < at) out[g2222++] = arr[i2222++];
  out[at] = v2222;
  while (i2222 < len) out[++g2222] = arr[i2222++];
  return out;
}
var EmptyNode34 = class _EmptyNode34 {
  _tag = "EmptyNode";
  modify(edit, _shift, f2222, hash2234, key, size434) {
    const v2222 = f2222(none2234());
    if (isNone2234(v2222)) return new _EmptyNode34();
    ++size434.value;
    return new LeafNode34(edit, hash2234, key, v2222);
  }
};
function isEmptyNode34(a2222) {
  return isTagged54(a2222, "EmptyNode");
}
function isLeafNode34(node) {
  return isEmptyNode34(node) || node._tag === "LeafNode" || node._tag === "CollisionNode";
}
function canEditNode34(node, edit) {
  return isEmptyNode34(node) ? false : edit === node.edit;
}
var LeafNode34 = class _LeafNode34 {
  edit;
  hash;
  key;
  value;
  _tag = "LeafNode";
  constructor(edit, hash2234, key, value) {
    this.edit = edit;
    this.hash = hash2234;
    this.key = key;
    this.value = value;
  }
  modify(edit, shift22, f2222, hash2234, key, size434) {
    if (equals234(key, this.key)) {
      const v22222 = f2222(this.value);
      if (v22222 === this.value) return this;
      else if (isNone2234(v22222)) {
        --size434.value;
        return new EmptyNode34();
      }
      if (canEditNode34(this, edit)) {
        this.value = v22222;
        return this;
      }
      return new _LeafNode34(edit, hash2234, key, v22222);
    }
    const v2222 = f2222(none2234());
    if (isNone2234(v2222)) return this;
    ++size434.value;
    return mergeLeaves34(edit, shift22, this.hash, this, hash2234, new _LeafNode34(edit, hash2234, key, v2222));
  }
};
var CollisionNode34 = class _CollisionNode34 {
  edit;
  hash;
  children;
  _tag = "CollisionNode";
  constructor(edit, hash2234, children) {
    this.edit = edit;
    this.hash = hash2234;
    this.children = children;
  }
  modify(edit, shift22, f2222, hash2234, key, size434) {
    if (hash2234 === this.hash) {
      const canEdit = canEditNode34(this, edit);
      const list = this.updateCollisionList(canEdit, edit, this.hash, this.children, f2222, key, size434);
      if (list === this.children) return this;
      return list.length > 1 ? new _CollisionNode34(edit, this.hash, list) : list[0];
    }
    const v2222 = f2222(none2234());
    if (isNone2234(v2222)) return this;
    ++size434.value;
    return mergeLeaves34(edit, shift22, this.hash, this, hash2234, new LeafNode34(edit, hash2234, key, v2222));
  }
  updateCollisionList(mutate234, edit, hash2234, list, f2222, key, size434) {
    const len = list.length;
    for (let i2222 = 0; i2222 < len; ++i2222) {
      const child = list[i2222];
      if ("key" in child && equals234(key, child.key)) {
        const value = child.value;
        const newValue2 = f2222(value);
        if (newValue2 === value) return list;
        if (isNone2234(newValue2)) {
          --size434.value;
          return arraySpliceOut34(mutate234, i2222, list);
        }
        return arrayUpdate34(mutate234, i2222, new LeafNode34(edit, hash2234, key, newValue2), list);
      }
    }
    const newValue = f2222(none2234());
    if (isNone2234(newValue)) return list;
    ++size434.value;
    return arrayUpdate34(mutate234, len, new LeafNode34(edit, hash2234, key, newValue), list);
  }
};
var IndexedNode34 = class _IndexedNode34 {
  edit;
  mask;
  children;
  _tag = "IndexedNode";
  constructor(edit, mask, children) {
    this.edit = edit;
    this.mask = mask;
    this.children = children;
  }
  modify(edit, shift22, f2222, hash2234, key, size434) {
    const mask = this.mask;
    const children = this.children;
    const frag = hashFragment34(shift22, hash2234);
    const bit = toBitmap34(frag);
    const indx = fromBitmap34(mask, bit);
    const exists2234 = mask & bit;
    const canEdit = canEditNode34(this, edit);
    if (!exists2234) {
      const _newChild = new EmptyNode34().modify(edit, shift22 + SIZE34, f2222, hash2234, key, size434);
      if (!_newChild) return this;
      return children.length >= MAX_INDEX_NODE34 ? expand34(edit, frag, _newChild, mask, children) : new _IndexedNode34(edit, mask | bit, arraySpliceIn34(canEdit, indx, _newChild, children));
    }
    const current = children[indx];
    const child = current.modify(edit, shift22 + SIZE34, f2222, hash2234, key, size434);
    if (current === child) return this;
    let bitmap = mask;
    let newChildren;
    if (isEmptyNode34(child)) {
      bitmap &= ~bit;
      if (!bitmap) return new EmptyNode34();
      if (children.length <= 2 && isLeafNode34(children[indx ^ 1])) {
        return children[indx ^ 1];
      }
      newChildren = arraySpliceOut34(canEdit, indx, children);
    } else {
      newChildren = arrayUpdate34(canEdit, indx, child, children);
    }
    if (canEdit) {
      this.mask = bitmap;
      this.children = newChildren;
      return this;
    }
    return new _IndexedNode34(edit, bitmap, newChildren);
  }
};
var ArrayNode34 = class _ArrayNode34 {
  edit;
  size;
  children;
  _tag = "ArrayNode";
  constructor(edit, size434, children) {
    this.edit = edit;
    this.size = size434;
    this.children = children;
  }
  modify(edit, shift22, f2222, hash2234, key, size434) {
    let count = this.size;
    const children = this.children;
    const frag = hashFragment34(shift22, hash2234);
    const child = children[frag];
    const newChild = (child || new EmptyNode34()).modify(edit, shift22 + SIZE34, f2222, hash2234, key, size434);
    if (child === newChild) return this;
    const canEdit = canEditNode34(this, edit);
    let newChildren;
    if (isEmptyNode34(child) && !isEmptyNode34(newChild)) {
      ++count;
      newChildren = arrayUpdate34(canEdit, frag, newChild, children);
    } else if (!isEmptyNode34(child) && isEmptyNode34(newChild)) {
      --count;
      if (count <= MIN_ARRAY_NODE34) {
        return pack34(edit, count, frag, children);
      }
      newChildren = arrayUpdate34(canEdit, frag, new EmptyNode34(), children);
    } else {
      newChildren = arrayUpdate34(canEdit, frag, newChild, children);
    }
    if (canEdit) {
      this.size = count;
      this.children = newChildren;
      return this;
    }
    return new _ArrayNode34(edit, count, newChildren);
  }
};
function pack34(edit, count, removed, elements) {
  const children = new Array(count - 1);
  let g2222 = 0;
  let bitmap = 0;
  for (let i2222 = 0, len = elements.length; i2222 < len; ++i2222) {
    if (i2222 !== removed) {
      const elem = elements[i2222];
      if (elem && !isEmptyNode34(elem)) {
        children[g2222++] = elem;
        bitmap |= 1 << i2222;
      }
    }
  }
  return new IndexedNode34(edit, bitmap, children);
}
function expand34(edit, frag, child, bitmap, subNodes) {
  const arr = [];
  let bit = bitmap;
  let count = 0;
  for (let i2222 = 0; bit; ++i2222) {
    if (bit & 1) arr[i2222] = subNodes[count++];
    bit >>>= 1;
  }
  arr[frag] = child;
  return new ArrayNode34(edit, count + 1, arr);
}
function mergeLeavesInner34(edit, shift22, h1, n1, h2222, n2222) {
  if (h1 === h2222) return new CollisionNode34(edit, h1, [n2222, n1]);
  const subH1 = hashFragment34(shift22, h1);
  const subH2 = hashFragment34(shift22, h2222);
  if (subH1 === subH2) {
    return (child) => new IndexedNode34(edit, toBitmap34(subH1) | toBitmap34(subH2), [child]);
  } else {
    const children = subH1 < subH2 ? [n1, n2222] : [n2222, n1];
    return new IndexedNode34(edit, toBitmap34(subH1) | toBitmap34(subH2), children);
  }
}
function mergeLeaves34(edit, shift22, h1, n1, h2222, n2222) {
  let stack = void 0;
  let currentShift = shift22;
  while (true) {
    const res = mergeLeavesInner34(edit, currentShift, h1, n1, h2222, n2222);
    if (typeof res === "function") {
      stack = make534(res, stack);
      currentShift = currentShift + SIZE34;
    } else {
      let final = res;
      while (stack != null) {
        final = stack.value(final);
        stack = stack.previous;
      }
      return final;
    }
  }
}
var HashMapSymbolKey34 = "effect/HashMap";
var HashMapTypeId34 = /* @__PURE__ */ Symbol.for(HashMapSymbolKey34);
var HashMapProto34 = {
  [HashMapTypeId34]: HashMapTypeId34,
  [Symbol.iterator]() {
    return new HashMapIterator34(this, (k2222, v2222) => [k2222, v2222]);
  },
  [symbol334]() {
    let hash2234 = hash234(HashMapSymbolKey34);
    for (const item of this) {
      hash2234 ^= pipe234(hash234(item[0]), combine234(hash234(item[1])));
    }
    return cached234(this, hash2234);
  },
  [symbol2234](that) {
    if (isHashMap34(that)) {
      if (that._size !== this._size) {
        return false;
      }
      for (const item of this) {
        const elem = pipe234(that, getHash34(item[0], hash234(item[0])));
        if (isNone2234(elem)) {
          return false;
        } else {
          if (!equals234(item[1], elem.value)) {
            return false;
          }
        }
      }
      return true;
    }
    return false;
  },
  toString() {
    return format234(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashMap",
      values: Array.from(this).map(toJSON234)
    };
  },
  [NodeInspectSymbol234]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments234(this, arguments);
  }
};
var makeImpl44 = (editable, edit, root, size434) => {
  const map622 = Object.create(HashMapProto34);
  map622._editable = editable;
  map622._edit = edit;
  map622._root = root;
  map622._size = size434;
  return map622;
};
var HashMapIterator34 = class _HashMapIterator34 {
  map;
  f;
  v;
  constructor(map622, f2222) {
    this.map = map622;
    this.f = f2222;
    this.v = visitLazy34(this.map._root, this.f, void 0);
  }
  next() {
    if (isNone2234(this.v)) {
      return {
        done: true,
        value: void 0
      };
    }
    const v0 = this.v.value;
    this.v = applyCont34(v0.cont);
    return {
      done: false,
      value: v0.value
    };
  }
  [Symbol.iterator]() {
    return new _HashMapIterator34(this.map, this.f);
  }
};
var applyCont34 = (cont) => cont ? visitLazyChildren34(cont[0], cont[1], cont[2], cont[3], cont[4]) : none2234();
var visitLazy34 = (node, f2222, cont = void 0) => {
  switch (node._tag) {
    case "LeafNode": {
      if (isSome2234(node.value)) {
        return some3234({
          value: f2222(node.key, node.value.value),
          cont
        });
      }
      return applyCont34(cont);
    }
    case "CollisionNode":
    case "ArrayNode":
    case "IndexedNode": {
      const children = node.children;
      return visitLazyChildren34(children.length, children, 0, f2222, cont);
    }
    default: {
      return applyCont34(cont);
    }
  }
};
var visitLazyChildren34 = (len, children, i2222, f2222, cont) => {
  while (i2222 < len) {
    const child = children[i2222++];
    if (child && !isEmptyNode34(child)) {
      return visitLazy34(child, f2222, [len, children, i2222, f2222, cont]);
    }
  }
  return applyCont34(cont);
};
var _empty334 = /* @__PURE__ */ makeImpl44(false, 0, /* @__PURE__ */ new EmptyNode34(), 0);
var empty434 = () => _empty334;
var isHashMap34 = (u2222) => hasProperty234(u2222, HashMapTypeId34);
var getHash34 = /* @__PURE__ */ dual234(3, (self2, key, hash2234) => {
  let node = self2._root;
  let shift22 = 0;
  while (true) {
    switch (node._tag) {
      case "LeafNode": {
        return equals234(key, node.key) ? node.value : none2234();
      }
      case "CollisionNode": {
        if (hash2234 === node.hash) {
          const children = node.children;
          for (let i2222 = 0, len = children.length; i2222 < len; ++i2222) {
            const child = children[i2222];
            if ("key" in child && equals234(key, child.key)) {
              return child.value;
            }
          }
        }
        return none2234();
      }
      case "IndexedNode": {
        const frag = hashFragment34(shift22, hash2234);
        const bit = toBitmap34(frag);
        if (node.mask & bit) {
          node = node.children[fromBitmap34(node.mask, bit)];
          shift22 += SIZE34;
          break;
        }
        return none2234();
      }
      case "ArrayNode": {
        node = node.children[hashFragment34(shift22, hash2234)];
        if (node) {
          shift22 += SIZE34;
          break;
        }
        return none2234();
      }
      default:
        return none2234();
    }
  }
});
var set234 = /* @__PURE__ */ dual234(3, (self2, key, value) => modifyAt34(self2, key, () => some3234(value)));
var setTree34 = /* @__PURE__ */ dual234(3, (self2, newRoot, newSize) => {
  if (self2._editable) {
    self2._root = newRoot;
    self2._size = newSize;
    return self2;
  }
  return newRoot === self2._root ? self2 : makeImpl44(self2._editable, self2._edit, newRoot, newSize);
});
var keys44 = (self2) => new HashMapIterator34(self2, (key) => key);
var size54 = (self2) => self2._size;
var beginMutation44 = (self2) => makeImpl44(true, self2._edit + 1, self2._root, self2._size);
var modifyAt34 = /* @__PURE__ */ dual234(3, (self2, key, f2222) => modifyHash34(self2, key, hash234(key), f2222));
var modifyHash34 = /* @__PURE__ */ dual234(4, (self2, key, hash2234, f2222) => {
  const size434 = {
    value: self2._size
  };
  const newRoot = self2._root.modify(self2._editable ? self2._edit : NaN, 0, f2222, hash2234, key, size434);
  return pipe234(self2, setTree34(newRoot, size434.value));
});
var forEach64 = /* @__PURE__ */ dual234(2, (self2, f2222) => reduce234(self2, void 0, (_2222, value, key) => f2222(value, key)));
var reduce234 = /* @__PURE__ */ dual234(3, (self2, zero, f2222) => {
  const root = self2._root;
  if (root._tag === "LeafNode") {
    return isSome2234(root.value) ? f2222(zero, root.value.value, root.key) : zero;
  }
  if (root._tag === "EmptyNode") {
    return zero;
  }
  const toVisit = [root.children];
  let children;
  while (children = toVisit.pop()) {
    for (let i2222 = 0, len = children.length; i2222 < len; ) {
      const child = children[i2222++];
      if (child && !isEmptyNode34(child)) {
        if (child._tag === "LeafNode") {
          if (isSome2234(child.value)) {
            zero = f2222(zero, child.value.value, child.key);
          }
        } else {
          toVisit.push(child.children);
        }
      }
    }
  }
  return zero;
});
var HashSetSymbolKey34 = "effect/HashSet";
var HashSetTypeId34 = /* @__PURE__ */ Symbol.for(HashSetSymbolKey34);
var HashSetProto34 = {
  [HashSetTypeId34]: HashSetTypeId34,
  [Symbol.iterator]() {
    return keys44(this._keyMap);
  },
  [symbol334]() {
    return cached234(this, combine234(hash234(this._keyMap))(hash234(HashSetSymbolKey34)));
  },
  [symbol2234](that) {
    if (isHashSet34(that)) {
      return size54(this._keyMap) === size54(that._keyMap) && equals234(this._keyMap, that._keyMap);
    }
    return false;
  },
  toString() {
    return format234(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashSet",
      values: Array.from(this).map(toJSON234)
    };
  },
  [NodeInspectSymbol234]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments234(this, arguments);
  }
};
var makeImpl234 = (keyMap) => {
  const set2234 = Object.create(HashSetProto34);
  set2234._keyMap = keyMap;
  return set2234;
};
var isHashSet34 = (u2222) => hasProperty234(u2222, HashSetTypeId34);
var _empty434 = /* @__PURE__ */ makeImpl234(/* @__PURE__ */ empty434());
var empty534 = () => _empty434;
var size234 = (self2) => size54(self2._keyMap);
var beginMutation234 = (self2) => makeImpl234(beginMutation44(self2._keyMap));
var endMutation34 = (self2) => {
  self2._keyMap._editable = false;
  return self2;
};
var mutate34 = /* @__PURE__ */ dual234(2, (self2, f2222) => {
  const transient = beginMutation234(self2);
  f2222(transient);
  return endMutation34(transient);
});
var add234 = /* @__PURE__ */ dual234(2, (self2, value) => self2._keyMap._editable ? (set234(value, true)(self2._keyMap), self2) : makeImpl234(set234(value, true)(self2._keyMap)));
var union234 = /* @__PURE__ */ dual234(2, (self2, that) => mutate34(empty534(), (set2234) => {
  forEach234(self2, (value) => add234(set2234, value));
  for (const value of that) {
    add234(set2234, value);
  }
}));
var forEach234 = /* @__PURE__ */ dual234(2, (self2, f2222) => forEach64(self2._keyMap, (_2222, k2222) => f2222(k2222)));
var empty634 = empty534;
var size334 = size234;
var add334 = add234;
var union334 = union234;
var ArrayProto34 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(Array.prototype), {
  [symbol334]() {
    return cached234(this, array74(this));
  },
  [symbol2234](that) {
    if (Array.isArray(that) && this.length === that.length) {
      return this.every((v2222, i2222) => equals234(v2222, that[i2222]));
    } else {
      return false;
    }
  }
});
var Structural44 = /* @__PURE__ */ function() {
  function Structural334(args) {
    if (args) {
      Object.assign(this, args);
    }
  }
  Structural334.prototype = StructuralPrototype234;
  return Structural334;
}();
var struct234 = (as2234) => Object.assign(Object.create(StructuralPrototype234), as2234);
var ContextPatchTypeId34 = /* @__PURE__ */ Symbol.for("effect/DifferContextPatch");
function variance44(a2222) {
  return a2222;
}
var PatchProto34 = {
  ...Structural44.prototype,
  [ContextPatchTypeId34]: {
    _Value: variance44,
    _Patch: variance44
  }
};
var EmptyProto34 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto34), {
  _tag: "Empty"
});
var _empty534 = /* @__PURE__ */ Object.create(EmptyProto34);
var empty734 = () => _empty534;
var AndThenProto34 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto34), {
  _tag: "AndThen"
});
var makeAndThen34 = (first, second) => {
  const o2222 = Object.create(AndThenProto34);
  o2222.first = first;
  o2222.second = second;
  return o2222;
};
var AddServiceProto34 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto34), {
  _tag: "AddService"
});
var makeAddService34 = (key, service) => {
  const o2222 = Object.create(AddServiceProto34);
  o2222.key = key;
  o2222.service = service;
  return o2222;
};
var RemoveServiceProto34 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto34), {
  _tag: "RemoveService"
});
var makeRemoveService34 = (key) => {
  const o2222 = Object.create(RemoveServiceProto34);
  o2222.key = key;
  return o2222;
};
var UpdateServiceProto34 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto34), {
  _tag: "UpdateService"
});
var makeUpdateService34 = (key, update222) => {
  const o2222 = Object.create(UpdateServiceProto34);
  o2222.key = key;
  o2222.update = update222;
  return o2222;
};
var diff34 = (oldValue, newValue) => {
  const missingServices = new Map(oldValue.unsafeMap);
  let patch234 = empty734();
  for (const [tag, newService] of newValue.unsafeMap.entries()) {
    if (missingServices.has(tag)) {
      const old = missingServices.get(tag);
      missingServices.delete(tag);
      if (!equals234(old, newService)) {
        patch234 = combine2234(makeUpdateService34(tag, () => newService))(patch234);
      }
    } else {
      missingServices.delete(tag);
      patch234 = combine2234(makeAddService34(tag, newService))(patch234);
    }
  }
  for (const [tag] of missingServices.entries()) {
    patch234 = combine2234(makeRemoveService34(tag))(patch234);
  }
  return patch234;
};
var combine2234 = /* @__PURE__ */ dual234(2, (self2, that) => makeAndThen34(self2, that));
var patch34 = /* @__PURE__ */ dual234(2, (self2, context) => {
  if (self2._tag === "Empty") {
    return context;
  }
  let wasServiceUpdated = false;
  let patches = of44(self2);
  const updatedContext = new Map(context.unsafeMap);
  while (isNonEmpty34(patches)) {
    const head222 = headNonEmpty44(patches);
    const tail34 = tailNonEmpty44(patches);
    switch (head222._tag) {
      case "Empty": {
        patches = tail34;
        break;
      }
      case "AddService": {
        updatedContext.set(head222.key, head222.service);
        patches = tail34;
        break;
      }
      case "AndThen": {
        patches = prepend54(prepend54(tail34, head222.second), head222.first);
        break;
      }
      case "RemoveService": {
        updatedContext.delete(head222.key);
        patches = tail34;
        break;
      }
      case "UpdateService": {
        updatedContext.set(head222.key, head222.update(updatedContext.get(head222.key)));
        wasServiceUpdated = true;
        patches = tail34;
        break;
      }
    }
  }
  if (!wasServiceUpdated) {
    return makeContext34(updatedContext);
  }
  const map622 = /* @__PURE__ */ new Map();
  for (const [tag] of context.unsafeMap) {
    if (updatedContext.has(tag)) {
      map622.set(tag, updatedContext.get(tag));
      updatedContext.delete(tag);
    }
  }
  for (const [tag, s2222] of updatedContext) {
    map622.set(tag, s2222);
  }
  return makeContext34(map622);
});
var DifferTypeId34 = /* @__PURE__ */ Symbol.for("effect/Differ");
var DifferProto34 = {
  [DifferTypeId34]: {
    _P: identity234,
    _V: identity234
  }
};
var make734 = (params) => {
  const differ = Object.create(DifferProto34);
  differ.empty = params.empty;
  differ.diff = params.diff;
  differ.combine = params.combine;
  differ.patch = params.patch;
  return differ;
};
var environment34 = () => make734({
  empty: empty734(),
  combine: (first, second) => combine2234(second)(first),
  diff: (oldValue, newValue) => diff34(oldValue, newValue),
  patch: (patch234, oldValue) => patch34(oldValue)(patch234)
});
var OP_DIE34 = "Die";
var OP_EMPTY34 = "Empty";
var OP_FAIL34 = "Fail";
var OP_INTERRUPT34 = "Interrupt";
var OP_PARALLEL34 = "Parallel";
var OP_SEQUENTIAL34 = "Sequential";
var CauseSymbolKey34 = "effect/Cause";
var CauseTypeId34 = /* @__PURE__ */ Symbol.for(CauseSymbolKey34);
var variance234 = {
  /* c8 ignore next */
  _E: (_2222) => _2222
};
var proto34 = {
  [CauseTypeId34]: variance234,
  [symbol334]() {
    return pipe234(hash234(CauseSymbolKey34), combine234(hash234(flattenCause34(this))), cached234(this));
  },
  [symbol2234](that) {
    return isCause34(that) && causeEquals34(this, that);
  },
  pipe() {
    return pipeArguments234(this, arguments);
  },
  toJSON() {
    switch (this._tag) {
      case "Empty":
        return {
          _id: "Cause",
          _tag: this._tag
        };
      case "Die":
        return {
          _id: "Cause",
          _tag: this._tag,
          defect: toJSON234(this.defect)
        };
      case "Interrupt":
        return {
          _id: "Cause",
          _tag: this._tag,
          fiberId: this.fiberId.toJSON()
        };
      case "Fail":
        return {
          _id: "Cause",
          _tag: this._tag,
          failure: toJSON234(this.error)
        };
      case "Sequential":
      case "Parallel":
        return {
          _id: "Cause",
          _tag: this._tag,
          left: toJSON234(this.left),
          right: toJSON234(this.right)
        };
    }
  },
  toString() {
    return pretty34(this);
  },
  [NodeInspectSymbol234]() {
    return this.toJSON();
  }
};
var fail44 = (error) => {
  const o2222 = Object.create(proto34);
  o2222._tag = OP_FAIL34;
  o2222.error = error;
  return o2222;
};
var parallel34 = (left334, right334) => {
  const o2222 = Object.create(proto34);
  o2222._tag = OP_PARALLEL34;
  o2222.left = left334;
  o2222.right = right334;
  return o2222;
};
var sequential34 = (left334, right334) => {
  const o2222 = Object.create(proto34);
  o2222._tag = OP_SEQUENTIAL34;
  o2222.left = left334;
  o2222.right = right334;
  return o2222;
};
var isCause34 = (u2222) => hasProperty234(u2222, CauseTypeId34);
var isInterruptedOnly34 = (self2) => reduceWithContext34(void 0, IsInterruptedOnlyCauseReducer34)(self2);
var causeEquals34 = (left334, right334) => {
  let leftStack = of44(left334);
  let rightStack = of44(right334);
  while (isNonEmpty34(leftStack) && isNonEmpty34(rightStack)) {
    const [leftParallel, leftSequential] = pipe234(headNonEmpty44(leftStack), reduce434([empty634(), empty334()], ([parallel234, sequential234], cause) => {
      const [par, seq] = evaluateCause34(cause);
      return some3234([pipe234(parallel234, union334(par)), pipe234(sequential234, appendAll44(seq))]);
    }));
    const [rightParallel, rightSequential] = pipe234(headNonEmpty44(rightStack), reduce434([empty634(), empty334()], ([parallel234, sequential234], cause) => {
      const [par, seq] = evaluateCause34(cause);
      return some3234([pipe234(parallel234, union334(par)), pipe234(sequential234, appendAll44(seq))]);
    }));
    if (!equals234(leftParallel, rightParallel)) {
      return false;
    }
    leftStack = leftSequential;
    rightStack = rightSequential;
  }
  return true;
};
var flattenCause34 = (cause) => {
  return flattenCauseLoop34(of44(cause), empty334());
};
var flattenCauseLoop34 = (causes, flattened) => {
  while (1) {
    const [parallel234, sequential234] = pipe234(causes, reduce64([empty634(), empty334()], ([parallel322, sequential322], cause) => {
      const [par, seq] = evaluateCause34(cause);
      return [pipe234(parallel322, union334(par)), pipe234(sequential322, appendAll44(seq))];
    }));
    const updated = size334(parallel234) > 0 ? pipe234(flattened, prepend54(parallel234)) : flattened;
    if (isEmpty44(sequential234)) {
      return reverse234(updated);
    }
    causes = sequential234;
    flattened = updated;
  }
  throw new Error(getBugErrorMessage234("Cause.flattenCauseLoop"));
};
var evaluateCause34 = (self2) => {
  let cause = self2;
  const stack = [];
  let _parallel = empty634();
  let _sequential = empty334();
  while (cause !== void 0) {
    switch (cause._tag) {
      case OP_EMPTY34: {
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_FAIL34: {
        _parallel = add334(_parallel, make4234(cause._tag, cause.error));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_DIE34: {
        _parallel = add334(_parallel, make4234(cause._tag, cause.defect));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_INTERRUPT34: {
        _parallel = add334(_parallel, make4234(cause._tag, cause.fiberId));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_SEQUENTIAL34: {
        switch (cause.left._tag) {
          case OP_EMPTY34: {
            cause = cause.right;
            break;
          }
          case OP_SEQUENTIAL34: {
            cause = sequential34(cause.left.left, sequential34(cause.left.right, cause.right));
            break;
          }
          case OP_PARALLEL34: {
            cause = parallel34(sequential34(cause.left.left, cause.right), sequential34(cause.left.right, cause.right));
            break;
          }
          default: {
            _sequential = prepend54(_sequential, cause.right);
            cause = cause.left;
            break;
          }
        }
        break;
      }
      case OP_PARALLEL34: {
        stack.push(cause.right);
        cause = cause.left;
        break;
      }
    }
  }
  throw new Error(getBugErrorMessage234("Cause.evaluateCauseLoop"));
};
var IsInterruptedOnlyCauseReducer34 = {
  emptyCase: constTrue234,
  failCase: constFalse234,
  dieCase: constFalse234,
  interruptCase: constTrue234,
  sequentialCase: (_2222, left334, right334) => left334 && right334,
  parallelCase: (_2222, left334, right334) => left334 && right334
};
var OP_SEQUENTIAL_CASE34 = "SequentialCase";
var OP_PARALLEL_CASE34 = "ParallelCase";
var reduce434 = /* @__PURE__ */ dual234(3, (self2, zero, pf) => {
  let accumulator = zero;
  let cause = self2;
  const causes = [];
  while (cause !== void 0) {
    const option = pf(accumulator, cause);
    accumulator = isSome2234(option) ? option.value : accumulator;
    switch (cause._tag) {
      case OP_SEQUENTIAL34: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      case OP_PARALLEL34: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      default: {
        cause = void 0;
        break;
      }
    }
    if (cause === void 0 && causes.length > 0) {
      cause = causes.pop();
    }
  }
  return accumulator;
});
var reduceWithContext34 = /* @__PURE__ */ dual234(3, (self2, context, reducer) => {
  const input = [self2];
  const output = [];
  while (input.length > 0) {
    const cause = input.pop();
    switch (cause._tag) {
      case OP_EMPTY34: {
        output.push(right2234(reducer.emptyCase(context)));
        break;
      }
      case OP_FAIL34: {
        output.push(right2234(reducer.failCase(context, cause.error)));
        break;
      }
      case OP_DIE34: {
        output.push(right2234(reducer.dieCase(context, cause.defect)));
        break;
      }
      case OP_INTERRUPT34: {
        output.push(right2234(reducer.interruptCase(context, cause.fiberId)));
        break;
      }
      case OP_SEQUENTIAL34: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left2234({
          _tag: OP_SEQUENTIAL_CASE34
        }));
        break;
      }
      case OP_PARALLEL34: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left2234({
          _tag: OP_PARALLEL_CASE34
        }));
        break;
      }
    }
  }
  const accumulator = [];
  while (output.length > 0) {
    const either = output.pop();
    switch (either._tag) {
      case "Left": {
        switch (either.left._tag) {
          case OP_SEQUENTIAL_CASE34: {
            const left334 = accumulator.pop();
            const right334 = accumulator.pop();
            const value = reducer.sequentialCase(context, left334, right334);
            accumulator.push(value);
            break;
          }
          case OP_PARALLEL_CASE34: {
            const left334 = accumulator.pop();
            const right334 = accumulator.pop();
            const value = reducer.parallelCase(context, left334, right334);
            accumulator.push(value);
            break;
          }
        }
        break;
      }
      case "Right": {
        accumulator.push(either.right);
        break;
      }
    }
  }
  if (accumulator.length === 0) {
    throw new Error("BUG: Cause.reduceWithContext - please report an issue at https://github.com/Effect-TS/effect/issues");
  }
  return accumulator.pop();
});
var pretty34 = (cause) => {
  if (isInterruptedOnly34(cause)) {
    return "All fibers interrupted without errors.";
  }
  return prettyErrors34(cause).map((e2222) => e2222.stack).join("\n");
};
var PrettyError34 = class extends globalThis.Error {
  span = void 0;
  constructor(originalError) {
    const prevLimit = Error.stackTraceLimit;
    Error.stackTraceLimit = 0;
    super(prettyErrorMessage34(originalError));
    Error.stackTraceLimit = prevLimit;
    this.name = originalError instanceof Error ? originalError.name : "Error";
    if (typeof originalError === "object" && originalError !== null) {
      if (spanSymbol44 in originalError) {
        this.span = originalError[spanSymbol44];
      }
      Object.keys(originalError).forEach((key) => {
        if (!(key in this)) {
          this[key] = originalError[key];
        }
      });
    }
    this.stack = prettyErrorStack34(this.message, originalError instanceof Error && originalError.stack ? originalError.stack : "", this.span);
  }
  toJSON() {
    const out = {
      message: this.message,
      stack: this.stack
    };
    if (this.span) {
      out.span = this.span;
    }
    return out;
  }
};
var prettyErrorMessage34 = (u2222) => {
  if (typeof u2222 === "string") {
    return `Error: ${u2222}`;
  }
  try {
    if (hasProperty234(u2222, "toString") && isFunction3233(u2222["toString"]) && u2222["toString"] !== Object.prototype.toString && u2222["toString"] !== globalThis.Array.prototype.toString) {
      return u2222["toString"]();
    }
  } catch {
  }
  return `Error: ${JSON.stringify(u2222)}`;
};
var locationRegex34 = /\((.*)\)/;
var spanToTrace34 = /* @__PURE__ */ globalValue234("effect/Tracer/spanToTrace", () => /* @__PURE__ */ new WeakMap());
var prettyErrorStack34 = (message, stack, span24) => {
  const out = [message];
  const lines = stack.split("\n");
  for (let i2222 = 1; i2222 < lines.length; i2222++) {
    if (lines[i2222].includes("Generator.next")) {
      break;
    }
    if (lines[i2222].includes("effect_internal_function")) {
      out.pop();
      break;
    }
    out.push(lines[i2222].replace(/at .*effect_instruction_i.*\((.*)\)/, "at $1").replace(/EffectPrimitive\.\w+/, "<anonymous>"));
  }
  if (span24) {
    let current = span24;
    let i2222 = 0;
    while (current && current._tag === "Span" && i2222 < 10) {
      const stackFn = spanToTrace34.get(current);
      if (typeof stackFn === "function") {
        const stack2 = stackFn();
        const locationMatch = stack2.match(locationRegex34);
        const location = locationMatch ? locationMatch[1] : stack2.replace(/^at /, "");
        out.push(`    at ${current.name} (${location})`);
      } else {
        out.push(`    at ${current.name}`);
      }
      current = getOrUndefined234(current.parent);
      i2222++;
    }
  }
  return out.join("\n");
};
var spanSymbol44 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var prettyErrors34 = (cause) => reduceWithContext34(cause, void 0, {
  emptyCase: () => [],
  dieCase: (_2222, unknownError) => {
    return [new PrettyError34(unknownError)];
  },
  failCase: (_2222, error) => {
    return [new PrettyError34(error)];
  },
  interruptCase: () => [],
  parallelCase: (_2222, l2222, r2222) => [...l2222, ...r2222],
  sequentialCase: (_2222, l2222, r2222) => [...l2222, ...r2222]
});
var SingleShotGen2234 = class _SingleShotGen234 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  next(a2222) {
    return this.called ? {
      value: a2222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  return(a2222) {
    return {
      value: a2222,
      done: true
    };
  }
  throw(e2222) {
    throw e2222;
  }
  [Symbol.iterator]() {
    return new _SingleShotGen234(this.self);
  }
};
var spanTag34 = /* @__PURE__ */ GenericTag34("effect/ParentSpan");
var EffectTypeId2234 = /* @__PURE__ */ Symbol.for("effect/Effect");
var EffectPrimitive34 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId2234] = effectVariance234;
  constructor(_op) {
    this._op = _op;
  }
  [symbol2234](that) {
    return this === that;
  }
  [symbol334]() {
    return cached234(this, random234(this));
  }
  pipe() {
    return pipeArguments234(this, arguments);
  }
  toJSON() {
    return {
      _id: "Effect",
      _op: this._op,
      effect_instruction_i0: toJSON234(this.effect_instruction_i0),
      effect_instruction_i1: toJSON234(this.effect_instruction_i1),
      effect_instruction_i2: toJSON234(this.effect_instruction_i2)
    };
  }
  toString() {
    return format234(this.toJSON());
  }
  [NodeInspectSymbol234]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen2234(new YieldWrap234(this));
  }
};
var EffectPrimitiveFailure34 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId2234] = effectVariance234;
  constructor(_op) {
    this._op = _op;
    this._tag = _op;
  }
  [symbol2234](that) {
    return exitIsExit34(that) && that._op === "Failure" && // @ts-expect-error
    equals234(this.effect_instruction_i0, that.effect_instruction_i0);
  }
  [symbol334]() {
    return pipe234(
      // @ts-expect-error
      string234(this._tag),
      // @ts-expect-error
      combine234(hash234(this.effect_instruction_i0)),
      cached234(this)
    );
  }
  get cause() {
    return this.effect_instruction_i0;
  }
  pipe() {
    return pipeArguments234(this, arguments);
  }
  toJSON() {
    return {
      _id: "Exit",
      _tag: this._op,
      cause: this.cause.toJSON()
    };
  }
  toString() {
    return format234(this.toJSON());
  }
  [NodeInspectSymbol234]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen2234(new YieldWrap234(this));
  }
};
var isEffect34 = (u2222) => hasProperty234(u2222, EffectTypeId2234);
var withFiberRuntime34 = (withRuntime) => {
  const effect = new EffectPrimitive34(OP_WITH_RUNTIME34);
  effect.effect_instruction_i0 = withRuntime;
  return effect;
};
var spanSymbol234 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var originalSymbol34 = /* @__PURE__ */ Symbol.for("effect/OriginalAnnotation");
var capture34 = (obj, span24) => {
  if (isSome2234(span24)) {
    return new Proxy(obj, {
      has(target, p2222) {
        return p2222 === spanSymbol234 || p2222 === originalSymbol34 || p2222 in target;
      },
      get(target, p2222) {
        if (p2222 === spanSymbol234) {
          return span24.value;
        }
        if (p2222 === originalSymbol34) {
          return obj;
        }
        return target[p2222];
      }
    });
  }
  return obj;
};
var fail234 = (error) => isObject234(error) && !(spanSymbol234 in error) ? withFiberRuntime34((fiber) => failCause34(fail44(capture34(error, currentSpanFromFiber34(fiber))))) : failCause34(fail44(error));
var failCause34 = (cause) => {
  const effect = new EffectPrimitiveFailure34(OP_FAILURE34);
  effect.effect_instruction_i0 = cause;
  return effect;
};
var FiberRefSymbolKey34 = "effect/FiberRef";
var FiberRefTypeId34 = /* @__PURE__ */ Symbol.for(FiberRefSymbolKey34);
var fiberRefVariance34 = {
  /* c8 ignore next */
  _A: (_2222) => _2222
};
var fiberRefUnsafeMakeContext34 = (initial) => {
  const differ = environment34();
  return fiberRefUnsafeMakePatch34(initial, {
    differ,
    fork: differ.empty
  });
};
var fiberRefUnsafeMakePatch34 = (initial, options) => ({
  [FiberRefTypeId34]: fiberRefVariance34,
  initial,
  diff: (oldValue, newValue) => options.differ.diff(oldValue, newValue),
  combine: (first, second) => options.differ.combine(first, second),
  patch: (patch234) => (oldValue) => options.differ.patch(patch234, oldValue),
  fork: options.fork,
  join: options.join ?? ((_2222, n2222) => n2222),
  pipe() {
    return pipeArguments234(this, arguments);
  }
});
var currentContext34 = /* @__PURE__ */ globalValue234(/* @__PURE__ */ Symbol.for("effect/FiberRef/currentContext"), () => fiberRefUnsafeMakeContext34(empty234()));
var YieldableError34 = /* @__PURE__ */ function() {
  class YieldableError234 extends globalThis.Error {
    commit() {
      return fail234(this);
    }
    toString() {
      return this.message ? `${this.name}: ${this.message}` : this.name;
    }
    toJSON() {
      return {
        ...this
      };
    }
    [NodeInspectSymbol234]() {
      const stack = this.stack;
      if (stack) {
        return `${this.toString()}
${stack.split("\n").slice(1).join("\n")}`;
      }
      return this.toString();
    }
  }
  Object.assign(YieldableError234.prototype, StructuralCommitPrototype234);
  return YieldableError234;
}();
var exitIsExit34 = (u2222) => isEffect34(u2222) && "_tag" in u2222 && (u2222._tag === "Success" || u2222._tag === "Failure");
var currentSpanFromFiber34 = (fiber) => {
  const span24 = fiber.getFiberRef(currentContext34).unsafeMap.get(spanTag34.key);
  return span24 !== void 0 && span24._tag === "Span" ? some3234(span24) : none2234();
};
var Data_exports234 = {};
__export234(Data_exports234, {
  Class: () => Class234,
  Error: () => Error234,
  Structural: () => Structural234,
  TaggedClass: () => TaggedClass34,
  TaggedError: () => TaggedError34,
  array: () => array234,
  case: () => _case34,
  struct: () => struct334,
  tagged: () => tagged34,
  taggedEnum: () => taggedEnum34,
  tuple: () => tuple234,
  unsafeArray: () => unsafeArray34,
  unsafeStruct: () => unsafeStruct34
});
var struct334 = struct234;
var unsafeStruct34 = (as2234) => Object.setPrototypeOf(as2234, StructuralPrototype234);
var tuple234 = (...as2234) => unsafeArray34(as2234);
var array234 = (as2234) => unsafeArray34(as2234.slice(0));
var unsafeArray34 = (as2234) => Object.setPrototypeOf(as2234, ArrayProto34);
var _case34 = () => (args) => args === void 0 ? Object.create(StructuralPrototype234) : struct334(args);
var tagged34 = (tag) => (args) => {
  const value = args === void 0 ? Object.create(StructuralPrototype234) : struct334(args);
  value._tag = tag;
  return value;
};
var Class234 = Structural44;
var TaggedClass34 = (tag) => {
  class Base extends Class234 {
    _tag = tag;
  }
  return Base;
};
var Structural234 = Structural44;
var taggedEnum34 = () => new Proxy({}, {
  get(_target, tag, _receiver) {
    if (tag === "$is") {
      return isTagged54;
    } else if (tag === "$match") {
      return taggedMatch34;
    }
    return tagged34(tag);
  }
});
function taggedMatch34() {
  if (arguments.length === 1) {
    const cases2 = arguments[0];
    return function(value2) {
      return cases2[value2._tag](value2);
    };
  }
  const value = arguments[0];
  const cases = arguments[1];
  return cases[value._tag](value);
}
var Error234 = /* @__PURE__ */ function() {
  return class Base extends YieldableError34 {
    constructor(args) {
      super();
      if (args) {
        Object.assign(this, args);
      }
    }
  };
}();
var TaggedError34 = (tag) => {
  class Base extends Error234 {
    _tag = tag;
  }
  Base.prototype.name = tag;
  return Base;
};
var traverseUp34 = Function_exports234.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType34.Program) return Option_exports234.none();
  return predicate(parent) ? Option_exports234.some(parent) : traverseUp34(parent, predicate);
});
var traverseUpGuard34 = Function_exports234.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType34.Program) return Option_exports234.none();
  return predicate(parent) ? Option_exports234.some(parent) : traverseUpGuard34(parent, predicate);
});
var ESLintCommunityESLintUtils34;
((ESLintCommunityESLintUtils234) => {
  ESLintCommunityESLintUtils234.getFunctionHeadLocation = getFunctionHeadLocation34;
  ESLintCommunityESLintUtils234.getFunctionNameWithKind = getFunctionNameWithKind34;
  ESLintCommunityESLintUtils234.getPropertyName = getPropertyName34;
  ESLintCommunityESLintUtils234.getStaticValue = getStaticValue44;
  ESLintCommunityESLintUtils234.getStringIfConstant = getStringIfConstant34;
  ESLintCommunityESLintUtils234.hasSideEffect = hasSideEffect34;
  ESLintCommunityESLintUtils234.isParenthesized = isParenthesized34;
})(ESLintCommunityESLintUtils34 || (ESLintCommunityESLintUtils34 = {}));
var Construction34 = Data_exports234.taggedEnum();
Construction34.None();
a223({
  type: N223.union([NodeType34.FunctionExpression, NodeType34.ArrowFunctionExpression]),
  parent: {
    type: NodeType34.Property,
    parent: {
      type: NodeType34.ObjectExpression
    }
  }
});
a223({
  type: N223.union([NodeType34.FunctionExpression, NodeType34.ArrowFunctionExpression]),
  parent: {
    type: NodeType34.MethodDefinition,
    parent: {
      type: NodeType34.ClassBody
    }
  }
});
a223({
  type: N223.union([NodeType34.FunctionExpression, NodeType34.ArrowFunctionExpression]),
  parent: {
    type: NodeType34.Property,
    parent: {
      type: NodeType34.ClassBody
    }
  }
});
function isInitializedFromReact3(variableName, context, initialScope) {
  if (variableName.toLowerCase() === "react") return true;
  const maybeVariable = findVariable34(variableName, initialScope);
  const maybeLatestDef = Option_exports44.flatMapNullable(maybeVariable, (v322) => v322.defs.at(-1));
  if (Option_exports44.isNone(maybeLatestDef)) return false;
  const latestDef = maybeLatestDef.value;
  const { node, parent } = latestDef;
  const settings = parse(ESLintSettingsSchema3, context.settings);
  const importSource = settings.reactOptions?.importSource ?? "react";
  if (node.type === NodeType7.VariableDeclarator && node.init) {
    const { init: init24 } = node;
    if (init24.type === NodeType7.MemberExpression && init24.object.type === NodeType7.Identifier) {
      return isInitializedFromReact3(init24.object.name, context, initialScope);
    }
    if (init24.type === NodeType7.Identifier) {
      return isInitializedFromReact3(init24.name, context, initialScope);
    }
    const maybeRequireExpression = $3(init24).with({
      type: NodeType7.CallExpression,
      callee: { type: NodeType7.Identifier, name: "require" }
    }, (exp) => Option_exports44.some(exp)).with(
      {
        type: NodeType7.MemberExpression,
        object: {
          type: NodeType7.CallExpression,
          callee: { type: NodeType7.Identifier, name: "require" }
        }
      },
      ({ object: object222 }) => Option_exports44.some(object222)
    ).otherwise(Option_exports44.none);
    if (Option_exports44.isNone(maybeRequireExpression)) return false;
    const requireExpression = maybeRequireExpression.value;
    const [firstArg] = requireExpression.arguments;
    if (firstArg?.type !== NodeType7.Literal || !Predicate_exports34.isString(firstArg.value)) return false;
    return firstArg.value === importSource || firstArg.value.startsWith(`${importSource}/`);
  }
  return a6({ type: "ImportDeclaration", source: { value: importSource } }, parent);
}
var RE_HOOK_NAME2 = /^use[A-Z\d]/u;
function isReactHookName2(name22) {
  return name22 === "use" || RE_HOOK_NAME2.test(name22);
}
function isReactHookCall2(node) {
  if (node.callee.type === NodeType7.Identifier) return isReactHookName2(node.callee.name);
  if (node.callee.type === NodeType7.MemberExpression) {
    return node.callee.property.type === NodeType7.Identifier && isReactHookName2(node.callee.property.name);
  }
  return false;
}
function isReactHookCallWithName(name22) {
  return (node, context) => {
    const initialScope = context.sourceCode.getScope(node);
    return $3(node.callee).with({ type: NodeType7.Identifier, name: name22 }, (n322) => isInitializedFromReact3(n322.name, context, initialScope)).with({ type: NodeType7.MemberExpression, object: { name: N6.string }, property: { name: name22 } }, (n322) => {
      return isInitializedFromReact3(n322.object.name, context, initialScope);
    }).otherwise(Function_exports44.constFalse);
  };
}
function isReactHookCallWithNameLoose2(name22) {
  return (node) => {
    return $3(node.callee).with({ type: NodeType7.Identifier, name: name22 }, Function_exports44.constTrue).with({ type: NodeType7.MemberExpression, property: { name: name22 } }, Function_exports44.constTrue).otherwise(Function_exports44.constFalse);
  };
}
var isUseCallbackCall = isReactHookCallWithName("useCallback");
var isUseMemoCall = isReactHookCallWithName("useMemo");
var isUseStateCall = isReactHookCallWithName("useState");
var uid = new import_short_unique_id3.default({ length: 10 });
function useHookCollector() {
  const hooks = /* @__PURE__ */ new Map();
  const functionStack = MutableList_exports4.make();
  const getCurrentFunction = () => MutableList_exports4.tail(functionStack);
  const onFunctionEnter = (node) => {
    MutableList_exports4.append(functionStack, node);
    const currentFn = getCurrentFunction();
    if (!currentFn) return;
    const id = getFunctionIdentifier3(currentFn);
    const name22 = Option_exports44.flatMapNullable(id, (id2) => id2.name);
    if (Option_exports44.isSome(id) && Option_exports44.isSome(name22) && isReactHookName2(name22.value)) {
      const key = uid.rnd();
      hooks.set(key, {
        _: key,
        id,
        kind: "function",
        name: name22,
        flag: 0n,
        hint: 0n,
        hookCalls: [],
        node: currentFn
      });
    }
  };
  const onFunctionExit = () => {
    MutableList_exports4.pop(functionStack);
  };
  const ctx = {
    getAllHooks(_322) {
      return hooks;
    },
    getCurrentHooks() {
      return new Map(hooks);
    }
  };
  const listeners = {
    ":function": onFunctionEnter,
    ":function:exit": onFunctionExit,
    CallExpression(node) {
      const currentFn = getCurrentFunction();
      if (!currentFn) return;
      if (isReactHookCall2(node)) {
        const hook = Array.from(hooks.values()).find((hook2) => hook2.node === currentFn);
        if (!hook) return;
        hooks.set(hook._, {
          ...hook,
          hookCalls: [
            ...hook.hookCalls,
            node
          ]
        });
      }
    }
  };
  return {
    ctx,
    listeners
  };
}
new import_short_unique_id3.default({ length: 10 });
a6({
  key: {
    type: NodeType7.Identifier,
    name: "render"
  },
  type: N6.union(NodeType7.MethodDefinition, NodeType7.PropertyDefinition),
  parent: {
    type: NodeType7.ClassBody,
    parent: {
      type: NodeType7.ClassDeclaration
    }
  }
});
new import_short_unique_id3.default({ length: 10 });
a6({
  callee: {
    type: NodeType7.MemberExpression,
    property: {
      name: "map"
    }
  }
});
var WEBSITE_URL3 = "https://eslint-react.xyz";
var getDocsUrl3 = (pluginName) => (ruleName) => {
  return `${WEBSITE_URL3}/rules/${pluginName}-${ruleName}`;
};
var createRuleForPlugin3 = (pluginName) => utils.ESLintUtils.RuleCreator(getDocsUrl3(pluginName));
var store223;
function getGlobalMessage23(lang) {
  return store223?.get(lang);
}
var store323;
function getSchemaMessage23(lang) {
  return store323?.get(lang);
}
var store423;
function getSpecificMessage23(reference, lang) {
  return store423?.get(reference)?.get(lang);
}
function _stringify23(input) {
  let type = typeof input;
  if (type === "object") {
    type = (input && Object.getPrototypeOf(input)?.constructor?.name) ?? "null";
  }
  return type === "string" ? `"${input}"` : type === "number" || type === "bigint" || type === "boolean" ? `${input}` : type;
}
function _addIssue23(context, label, dataset, config2, other) {
  const input = dataset.value;
  const expected = context.expects;
  const received = _stringify23(input);
  const issue = {
    kind: context.kind,
    type: context.type,
    input,
    expected,
    received,
    message: `Invalid ${label}: ${expected ? `Expected ${expected} but r` : "R"}eceived ${received}`,
    // @ts-expect-error
    requirement: context.requirement,
    path: other?.path,
    issues: other?.issues,
    lang: config2.lang,
    abortEarly: config2.abortEarly,
    abortPipeEarly: config2.abortPipeEarly,
    skipPipe: config2.skipPipe
  };
  const isSchema = context.kind === "schema";
  const message = (
    // @ts-expect-error
    context.message ?? getSpecificMessage23(context.reference, issue.lang) ?? (isSchema ? getSchemaMessage23(issue.lang) : null) ?? config2.message ?? getGlobalMessage23(issue.lang)
  );
  if (message) {
    issue.message = typeof message === "function" ? message(issue) : message;
  }
  if (isSchema) {
    dataset.typed = false;
  }
  if (dataset.issues) {
    dataset.issues.push(issue);
  } else {
    dataset.issues = [issue];
  }
}
function getDefault23(schema4, dataset, config2) {
  return typeof schema4.default === "function" ? (
    // @ts-expect-error
    schema4.default(dataset, config2)
  ) : (
    // @ts-expect-error
    schema4.default
  );
}
function array83(item, message) {
  return {
    kind: "schema",
    type: "array",
    reference: array83,
    expects: "Array",
    async: false,
    item,
    message,
    _run(dataset, config2) {
      const input = dataset.value;
      if (Array.isArray(input)) {
        dataset.typed = true;
        dataset.value = [];
        for (let key = 0; key < input.length; key++) {
          const value2 = input[key];
          const itemDataset = this.item._run({ typed: false, value: value2 }, config2);
          if (itemDataset.issues) {
            const pathItem = {
              type: "array",
              origin: "value",
              input,
              key,
              value: value2
            };
            for (const issue of itemDataset.issues) {
              if (issue.path) {
                issue.path.unshift(pathItem);
              } else {
                issue.path = [pathItem];
              }
              dataset.issues?.push(issue);
            }
            if (!dataset.issues) {
              dataset.issues = itemDataset.issues;
            }
            if (config2.abortEarly) {
              dataset.typed = false;
              break;
            }
          }
          if (!itemDataset.typed) {
            dataset.typed = false;
          }
          dataset.value.push(itemDataset.value);
        }
      } else {
        _addIssue23(this, "type", dataset, config2);
      }
      return dataset;
    }
  };
}
function object23(entries2, message) {
  return {
    kind: "schema",
    type: "object",
    reference: object23,
    expects: "Object",
    async: false,
    entries: entries2,
    message,
    _run(dataset, config2) {
      const input = dataset.value;
      if (input && typeof input === "object") {
        dataset.typed = true;
        dataset.value = {};
        for (const key in this.entries) {
          const value2 = input[key];
          const valueDataset = this.entries[key]._run(
            { typed: false, value: value2 },
            config2
          );
          if (valueDataset.issues) {
            const pathItem = {
              type: "object",
              origin: "value",
              input,
              key,
              value: value2
            };
            for (const issue of valueDataset.issues) {
              if (issue.path) {
                issue.path.unshift(pathItem);
              } else {
                issue.path = [pathItem];
              }
              dataset.issues?.push(issue);
            }
            if (!dataset.issues) {
              dataset.issues = valueDataset.issues;
            }
            if (config2.abortEarly) {
              dataset.typed = false;
              break;
            }
          }
          if (!valueDataset.typed) {
            dataset.typed = false;
          }
          if (valueDataset.value !== void 0 || key in input) {
            dataset.value[key] = valueDataset.value;
          }
        }
      } else {
        _addIssue23(this, "type", dataset, config2);
      }
      return dataset;
    }
  };
}
function optional23(wrapped, ...args) {
  const schema4 = {
    kind: "schema",
    type: "optional",
    reference: optional23,
    expects: `${wrapped.expects} | undefined`,
    async: false,
    wrapped,
    _run(dataset, config2) {
      if (dataset.value === void 0) {
        if ("default" in this) {
          dataset.value = getDefault23(
            this,
            dataset,
            config2
          );
        }
        if (dataset.value === void 0) {
          dataset.typed = true;
          return dataset;
        }
      }
      return this.wrapped._run(dataset, config2);
    }
  };
  if (0 in args) {
    schema4.default = args[0];
  }
  return schema4;
}
function string73(message) {
  return {
    kind: "schema",
    type: "string",
    reference: string73,
    expects: "string",
    async: false,
    message,
    _run(dataset, config2) {
      if (typeof dataset.value === "string") {
        dataset.typed = true;
      } else {
        _addIssue23(this, "type", dataset, config2);
      }
      return dataset;
    }
  };
}
var ESLintReactSettingsSchema23 = object23({
  additionalHooks: optional23(object23({
    use: optional23(string73()),
    useCallback: optional23(array83(string73())),
    useContext: optional23(array83(string73())),
    useDebugValue: optional23(array83(string73())),
    useDeferredValue: optional23(array83(string73())),
    useEffect: optional23(array83(string73())),
    useId: optional23(array83(string73())),
    useImperativeHandle: optional23(array83(string73())),
    useInsertionEffect: optional23(array83(string73())),
    useLayoutEffect: optional23(array83(string73())),
    useMemo: optional23(array83(string73())),
    useOptimistic: optional23(array83(string73())),
    useReducer: optional23(array83(string73())),
    useRef: optional23(array83(string73())),
    useState: optional23(array83(string73())),
    useSyncExternalStore: optional23(array83(string73())),
    useTransition: optional23(array83(string73()))
  })),
  importSource: optional23(string73()),
  jsxPragma: optional23(string73()),
  jsxPragmaFrag: optional23(string73()),
  version: optional23(string73())
});
var ESLintSettingsSchema22 = object23({
  reactOptions: optional23(ESLintReactSettingsSchema23)
});
var createRule3 = createRuleForPlugin3("hooks-extra");
var RULE_NAME45 = "ensure-custom-hooks-using-other-hooks";
var ensure_custom_hooks_using_other_hooks_default = createRule3({
  meta: {
    type: "problem",
    docs: {
      description: "enforce custom hooks using other hooks",
      requiresTypeChecking: false
    },
    messages: {
      ENSURE_CUSTOM_HOOKS_USING_OTHER_HOOKS: "A custom hook '{{name}}' should use other hooks"
    },
    schema: []
  },
  name: RULE_NAME45,
  create(context) {
    const { ctx, listeners } = useHookCollector();
    return {
      ...listeners,
      "Program:exit"(node) {
        const allHooks = ctx.getAllHooks(node);
        for (const { name: name22, hookCalls, node: node2 } of allHooks.values()) {
          if (hookCalls.length > 0) continue;
          context.report({
            data: {
              name: name22.value
            },
            messageId: "ENSURE_CUSTOM_HOOKS_USING_OTHER_HOOKS",
            node: node2
          });
        }
      }
    };
  },
  defaultOptions: []
});
var KEYS43 = {
  ArrayExpression: [
    "elements"
  ],
  ArrayPattern: [
    "elements"
  ],
  ArrowFunctionExpression: [
    "params",
    "body"
  ],
  AssignmentExpression: [
    "left",
    "right"
  ],
  AssignmentPattern: [
    "left",
    "right"
  ],
  AwaitExpression: [
    "argument"
  ],
  BinaryExpression: [
    "left",
    "right"
  ],
  BlockStatement: [
    "body"
  ],
  BreakStatement: [
    "label"
  ],
  CallExpression: [
    "callee",
    "arguments"
  ],
  CatchClause: [
    "param",
    "body"
  ],
  ChainExpression: [
    "expression"
  ],
  ClassBody: [
    "body"
  ],
  ClassDeclaration: [
    "id",
    "superClass",
    "body"
  ],
  ClassExpression: [
    "id",
    "superClass",
    "body"
  ],
  ConditionalExpression: [
    "test",
    "consequent",
    "alternate"
  ],
  ContinueStatement: [
    "label"
  ],
  DebuggerStatement: [],
  DoWhileStatement: [
    "body",
    "test"
  ],
  EmptyStatement: [],
  ExperimentalRestProperty: [
    "argument"
  ],
  ExperimentalSpreadProperty: [
    "argument"
  ],
  ExportAllDeclaration: [
    "exported",
    "source"
  ],
  ExportDefaultDeclaration: [
    "declaration"
  ],
  ExportNamedDeclaration: [
    "declaration",
    "specifiers",
    "source"
  ],
  ExportSpecifier: [
    "exported",
    "local"
  ],
  ExpressionStatement: [
    "expression"
  ],
  ForInStatement: [
    "left",
    "right",
    "body"
  ],
  ForOfStatement: [
    "left",
    "right",
    "body"
  ],
  ForStatement: [
    "init",
    "test",
    "update",
    "body"
  ],
  FunctionDeclaration: [
    "id",
    "params",
    "body"
  ],
  FunctionExpression: [
    "id",
    "params",
    "body"
  ],
  Identifier: [],
  IfStatement: [
    "test",
    "consequent",
    "alternate"
  ],
  ImportDeclaration: [
    "specifiers",
    "source"
  ],
  ImportDefaultSpecifier: [
    "local"
  ],
  ImportExpression: [
    "source"
  ],
  ImportNamespaceSpecifier: [
    "local"
  ],
  ImportSpecifier: [
    "imported",
    "local"
  ],
  JSXAttribute: [
    "name",
    "value"
  ],
  JSXClosingElement: [
    "name"
  ],
  JSXClosingFragment: [],
  JSXElement: [
    "openingElement",
    "children",
    "closingElement"
  ],
  JSXEmptyExpression: [],
  JSXExpressionContainer: [
    "expression"
  ],
  JSXFragment: [
    "openingFragment",
    "children",
    "closingFragment"
  ],
  JSXIdentifier: [],
  JSXMemberExpression: [
    "object",
    "property"
  ],
  JSXNamespacedName: [
    "namespace",
    "name"
  ],
  JSXOpeningElement: [
    "name",
    "attributes"
  ],
  JSXOpeningFragment: [],
  JSXSpreadAttribute: [
    "argument"
  ],
  JSXSpreadChild: [
    "expression"
  ],
  JSXText: [],
  LabeledStatement: [
    "label",
    "body"
  ],
  Literal: [],
  LogicalExpression: [
    "left",
    "right"
  ],
  MemberExpression: [
    "object",
    "property"
  ],
  MetaProperty: [
    "meta",
    "property"
  ],
  MethodDefinition: [
    "key",
    "value"
  ],
  NewExpression: [
    "callee",
    "arguments"
  ],
  ObjectExpression: [
    "properties"
  ],
  ObjectPattern: [
    "properties"
  ],
  PrivateIdentifier: [],
  Program: [
    "body"
  ],
  Property: [
    "key",
    "value"
  ],
  PropertyDefinition: [
    "key",
    "value"
  ],
  RestElement: [
    "argument"
  ],
  ReturnStatement: [
    "argument"
  ],
  SequenceExpression: [
    "expressions"
  ],
  SpreadElement: [
    "argument"
  ],
  StaticBlock: [
    "body"
  ],
  Super: [],
  SwitchCase: [
    "test",
    "consequent"
  ],
  SwitchStatement: [
    "discriminant",
    "cases"
  ],
  TaggedTemplateExpression: [
    "tag",
    "quasi"
  ],
  TemplateElement: [],
  TemplateLiteral: [
    "quasis",
    "expressions"
  ],
  ThisExpression: [],
  ThrowStatement: [
    "argument"
  ],
  TryStatement: [
    "block",
    "handler",
    "finalizer"
  ],
  UnaryExpression: [
    "argument"
  ],
  UpdateExpression: [
    "argument"
  ],
  VariableDeclaration: [
    "declarations"
  ],
  VariableDeclarator: [
    "id",
    "init"
  ],
  WhileStatement: [
    "test",
    "body"
  ],
  WithStatement: [
    "object",
    "body"
  ],
  YieldExpression: [
    "argument"
  ]
};
var NODE_TYPES43 = Object.keys(KEYS43);
for (const type of NODE_TYPES43) {
  Object.freeze(KEYS43[type]);
}
Object.freeze(KEYS43);
var visitor_keys_default43 = KEYS43;
var KEY_BLACKLIST43 = /* @__PURE__ */ new Set([
  "parent",
  "leadingComments",
  "trailingComments"
]);
function filterKey43(key) {
  return !KEY_BLACKLIST43.has(key) && key[0] !== "_";
}
function getKeys43(node) {
  return Object.keys(node).filter(filterKey43);
}
function getInnermostScope43(initialScope, node) {
  const location = node.range[0];
  let scope = initialScope;
  let found = false;
  do {
    found = false;
    for (const childScope of scope.childScopes) {
      const range24 = childScope.block.range;
      if (range24[0] <= location && location < range24[1]) {
        scope = childScope;
        found = true;
        break;
      }
    }
  } while (found);
  return scope;
}
function findVariable43(initialScope, nameOrNode) {
  let name22 = "";
  let scope = initialScope;
  if (typeof nameOrNode === "string") {
    name22 = nameOrNode;
  } else {
    name22 = nameOrNode.name;
    scope = getInnermostScope43(scope, nameOrNode);
  }
  while (scope != null) {
    const variable = scope.set.get(name22);
    if (variable != null) {
      return variable;
    }
    scope = scope.upper;
  }
  return null;
}
function negate043(token) {
  return !this(token);
}
function negate43(f43) {
  return negate043.bind(f43);
}
function isPunctuatorTokenWithValue43(token, value) {
  return token.type === "Punctuator" && token.value === value;
}
function isArrowToken43(token) {
  return isPunctuatorTokenWithValue43(token, "=>");
}
function isCommaToken43(token) {
  return isPunctuatorTokenWithValue43(token, ",");
}
function isSemicolonToken43(token) {
  return isPunctuatorTokenWithValue43(token, ";");
}
function isColonToken43(token) {
  return isPunctuatorTokenWithValue43(token, ":");
}
function isOpeningParenToken43(token) {
  return isPunctuatorTokenWithValue43(token, "(");
}
function isClosingParenToken43(token) {
  return isPunctuatorTokenWithValue43(token, ")");
}
function isOpeningBracketToken43(token) {
  return isPunctuatorTokenWithValue43(token, "[");
}
function isClosingBracketToken43(token) {
  return isPunctuatorTokenWithValue43(token, "]");
}
function isOpeningBraceToken43(token) {
  return isPunctuatorTokenWithValue43(token, "{");
}
function isClosingBraceToken43(token) {
  return isPunctuatorTokenWithValue43(token, "}");
}
function isCommentToken43(token) {
  return ["Block", "Line", "Shebang"].includes(token.type);
}
negate43(isArrowToken43);
negate43(isCommaToken43);
negate43(isSemicolonToken43);
negate43(isColonToken43);
negate43(isOpeningParenToken43);
negate43(isClosingParenToken43);
negate43(isOpeningBracketToken43);
negate43(isClosingBracketToken43);
negate43(isOpeningBraceToken43);
negate43(isClosingBraceToken43);
negate43(isCommentToken43);
function getOpeningParenOfParams43(node, sourceCode) {
  return node.id ? sourceCode.getTokenAfter(node.id, isOpeningParenToken43) : sourceCode.getFirstToken(node, isOpeningParenToken43);
}
function getFunctionHeadLocation43(node, sourceCode) {
  const parent = node.parent;
  let start = null;
  let end = null;
  if (node.type === "ArrowFunctionExpression") {
    const arrowToken = sourceCode.getTokenBefore(node.body, isArrowToken43);
    start = arrowToken.loc.start;
    end = arrowToken.loc.end;
  } else if (parent.type === "Property" || parent.type === "MethodDefinition" || parent.type === "PropertyDefinition") {
    start = parent.loc.start;
    end = getOpeningParenOfParams43(node, sourceCode).loc.start;
  } else {
    start = node.loc.start;
    end = getOpeningParenOfParams43(node, sourceCode).loc.start;
  }
  return {
    start: { ...start },
    end: { ...end }
  };
}
var globalObject43 = typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {};
var builtinNames43 = Object.freeze(
  /* @__PURE__ */ new Set([
    "Array",
    "ArrayBuffer",
    "BigInt",
    "BigInt64Array",
    "BigUint64Array",
    "Boolean",
    "DataView",
    "Date",
    "decodeURI",
    "decodeURIComponent",
    "encodeURI",
    "encodeURIComponent",
    "escape",
    "Float32Array",
    "Float64Array",
    "Function",
    "Infinity",
    "Int16Array",
    "Int32Array",
    "Int8Array",
    "isFinite",
    "isNaN",
    "isPrototypeOf",
    "JSON",
    "Map",
    "Math",
    "NaN",
    "Number",
    "Object",
    "parseFloat",
    "parseInt",
    "Promise",
    "Proxy",
    "Reflect",
    "RegExp",
    "Set",
    "String",
    "Symbol",
    "Uint16Array",
    "Uint32Array",
    "Uint8Array",
    "Uint8ClampedArray",
    "undefined",
    "unescape",
    "WeakMap",
    "WeakSet"
  ])
);
var callAllowed43 = new Set(
  [
    Array.isArray,
    Array.of,
    Array.prototype.at,
    Array.prototype.concat,
    Array.prototype.entries,
    Array.prototype.every,
    Array.prototype.filter,
    Array.prototype.find,
    Array.prototype.findIndex,
    Array.prototype.flat,
    Array.prototype.includes,
    Array.prototype.indexOf,
    Array.prototype.join,
    Array.prototype.keys,
    Array.prototype.lastIndexOf,
    Array.prototype.slice,
    Array.prototype.some,
    Array.prototype.toString,
    Array.prototype.values,
    typeof BigInt === "function" ? BigInt : void 0,
    Boolean,
    Date,
    Date.parse,
    decodeURI,
    decodeURIComponent,
    encodeURI,
    encodeURIComponent,
    escape,
    isFinite,
    isNaN,
    isPrototypeOf,
    Map,
    Map.prototype.entries,
    Map.prototype.get,
    Map.prototype.has,
    Map.prototype.keys,
    Map.prototype.values,
    ...Object.getOwnPropertyNames(Math).filter((k43) => k43 !== "random").map((k43) => Math[k43]).filter((f43) => typeof f43 === "function"),
    Number,
    Number.isFinite,
    Number.isNaN,
    Number.parseFloat,
    Number.parseInt,
    Number.prototype.toExponential,
    Number.prototype.toFixed,
    Number.prototype.toPrecision,
    Number.prototype.toString,
    Object,
    Object.entries,
    Object.is,
    Object.isExtensible,
    Object.isFrozen,
    Object.isSealed,
    Object.keys,
    Object.values,
    parseFloat,
    parseInt,
    RegExp,
    Set,
    Set.prototype.entries,
    Set.prototype.has,
    Set.prototype.keys,
    Set.prototype.values,
    String,
    String.fromCharCode,
    String.fromCodePoint,
    String.raw,
    String.prototype.at,
    String.prototype.charAt,
    String.prototype.charCodeAt,
    String.prototype.codePointAt,
    String.prototype.concat,
    String.prototype.endsWith,
    String.prototype.includes,
    String.prototype.indexOf,
    String.prototype.lastIndexOf,
    String.prototype.normalize,
    String.prototype.padEnd,
    String.prototype.padStart,
    String.prototype.slice,
    String.prototype.startsWith,
    String.prototype.substr,
    String.prototype.substring,
    String.prototype.toLowerCase,
    String.prototype.toString,
    String.prototype.toUpperCase,
    String.prototype.trim,
    String.prototype.trimEnd,
    String.prototype.trimLeft,
    String.prototype.trimRight,
    String.prototype.trimStart,
    Symbol.for,
    Symbol.keyFor,
    unescape
  ].filter((f43) => typeof f43 === "function")
);
var callPassThrough43 = /* @__PURE__ */ new Set([
  Object.freeze,
  Object.preventExtensions,
  Object.seal
]);
var getterAllowed43 = [
  [Map, /* @__PURE__ */ new Set(["size"])],
  [
    RegExp,
    /* @__PURE__ */ new Set([
      "dotAll",
      "flags",
      "global",
      "hasIndices",
      "ignoreCase",
      "multiline",
      "source",
      "sticky",
      "unicode"
    ])
  ],
  [Set, /* @__PURE__ */ new Set(["size"])]
];
function getPropertyDescriptor43(object32, name22) {
  let x43 = object32;
  while ((typeof x43 === "object" || typeof x43 === "function") && x43 !== null) {
    const d43 = Object.getOwnPropertyDescriptor(x43, name22);
    if (d43) {
      return d43;
    }
    x43 = Object.getPrototypeOf(x43);
  }
  return null;
}
function isGetter43(object32, name22) {
  const d43 = getPropertyDescriptor43(object32, name22);
  return d43 != null && d43.get != null;
}
function getElementValues43(nodeList, initialScope) {
  const valueList = [];
  for (let i43 = 0; i43 < nodeList.length; ++i43) {
    const elementNode = nodeList[i43];
    if (elementNode == null) {
      valueList.length = i43 + 1;
    } else if (elementNode.type === "SpreadElement") {
      const argument = getStaticValueR43(elementNode.argument, initialScope);
      if (argument == null) {
        return null;
      }
      valueList.push(...argument.value);
    } else {
      const element = getStaticValueR43(elementNode, initialScope);
      if (element == null) {
        return null;
      }
      valueList.push(element.value);
    }
  }
  return valueList;
}
function isEffectivelyConst43(variable) {
  const refs = variable.references;
  const inits = refs.filter((r43) => r43.init).length;
  const reads = refs.filter((r43) => r43.isReadOnly()).length;
  if (inits === 1 && reads + inits === refs.length) {
    return true;
  }
  return false;
}
var operations43 = Object.freeze({
  ArrayExpression(node, initialScope) {
    const elements = getElementValues43(node.elements, initialScope);
    return elements != null ? { value: elements } : null;
  },
  AssignmentExpression(node, initialScope) {
    if (node.operator === "=") {
      return getStaticValueR43(node.right, initialScope);
    }
    return null;
  },
  //eslint-disable-next-line complexity
  BinaryExpression(node, initialScope) {
    if (node.operator === "in" || node.operator === "instanceof") {
      return null;
    }
    const left102 = getStaticValueR43(node.left, initialScope);
    const right102 = getStaticValueR43(node.right, initialScope);
    if (left102 != null && right102 != null) {
      switch (node.operator) {
        case "==":
          return { value: left102.value == right102.value };
        case "!=":
          return { value: left102.value != right102.value };
        case "===":
          return { value: left102.value === right102.value };
        case "!==":
          return { value: left102.value !== right102.value };
        case "<":
          return { value: left102.value < right102.value };
        case "<=":
          return { value: left102.value <= right102.value };
        case ">":
          return { value: left102.value > right102.value };
        case ">=":
          return { value: left102.value >= right102.value };
        case "<<":
          return { value: left102.value << right102.value };
        case ">>":
          return { value: left102.value >> right102.value };
        case ">>>":
          return { value: left102.value >>> right102.value };
        case "+":
          return { value: left102.value + right102.value };
        case "-":
          return { value: left102.value - right102.value };
        case "*":
          return { value: left102.value * right102.value };
        case "/":
          return { value: left102.value / right102.value };
        case "%":
          return { value: left102.value % right102.value };
        case "**":
          return { value: left102.value ** right102.value };
        case "|":
          return { value: left102.value | right102.value };
        case "^":
          return { value: left102.value ^ right102.value };
        case "&":
          return { value: left102.value & right102.value };
      }
    }
    return null;
  },
  CallExpression(node, initialScope) {
    const calleeNode = node.callee;
    const args = getElementValues43(node.arguments, initialScope);
    if (args != null) {
      if (calleeNode.type === "MemberExpression") {
        if (calleeNode.property.type === "PrivateIdentifier") {
          return null;
        }
        const object32 = getStaticValueR43(calleeNode.object, initialScope);
        if (object32 != null) {
          if (object32.value == null && (object32.optional || node.optional)) {
            return { value: void 0, optional: true };
          }
          const property = getStaticPropertyNameValue43(
            calleeNode,
            initialScope
          );
          if (property != null) {
            const receiver = object32.value;
            const methodName = property.value;
            if (callAllowed43.has(receiver[methodName])) {
              return { value: receiver[methodName](...args) };
            }
            if (callPassThrough43.has(receiver[methodName])) {
              return { value: args[0] };
            }
          }
        }
      } else {
        const callee = getStaticValueR43(calleeNode, initialScope);
        if (callee != null) {
          if (callee.value == null && node.optional) {
            return { value: void 0, optional: true };
          }
          const func = callee.value;
          if (callAllowed43.has(func)) {
            return { value: func(...args) };
          }
          if (callPassThrough43.has(func)) {
            return { value: args[0] };
          }
        }
      }
    }
    return null;
  },
  ConditionalExpression(node, initialScope) {
    const test = getStaticValueR43(node.test, initialScope);
    if (test != null) {
      return test.value ? getStaticValueR43(node.consequent, initialScope) : getStaticValueR43(node.alternate, initialScope);
    }
    return null;
  },
  ExpressionStatement(node, initialScope) {
    return getStaticValueR43(node.expression, initialScope);
  },
  Identifier(node, initialScope) {
    if (initialScope != null) {
      const variable = findVariable43(initialScope, node);
      if (variable != null && variable.defs.length === 0 && builtinNames43.has(variable.name) && variable.name in globalObject43) {
        return { value: globalObject43[variable.name] };
      }
      if (variable != null && variable.defs.length === 1) {
        const def = variable.defs[0];
        if (def.parent && def.type === "Variable" && (def.parent.kind === "const" || isEffectivelyConst43(variable)) && // TODO(mysticatea): don't support destructuring here.
        def.node.id.type === "Identifier") {
          return getStaticValueR43(def.node.init, initialScope);
        }
      }
    }
    return null;
  },
  Literal(node) {
    if ((node.regex != null || node.bigint != null) && node.value == null) {
      return null;
    }
    return { value: node.value };
  },
  LogicalExpression(node, initialScope) {
    const left102 = getStaticValueR43(node.left, initialScope);
    if (left102 != null) {
      if (node.operator === "||" && Boolean(left102.value) === true || node.operator === "&&" && Boolean(left102.value) === false || node.operator === "??" && left102.value != null) {
        return left102;
      }
      const right102 = getStaticValueR43(node.right, initialScope);
      if (right102 != null) {
        return right102;
      }
    }
    return null;
  },
  MemberExpression(node, initialScope) {
    if (node.property.type === "PrivateIdentifier") {
      return null;
    }
    const object32 = getStaticValueR43(node.object, initialScope);
    if (object32 != null) {
      if (object32.value == null && (object32.optional || node.optional)) {
        return { value: void 0, optional: true };
      }
      const property = getStaticPropertyNameValue43(node, initialScope);
      if (property != null) {
        if (!isGetter43(object32.value, property.value)) {
          return { value: object32.value[property.value] };
        }
        for (const [classFn, allowed] of getterAllowed43) {
          if (object32.value instanceof classFn && allowed.has(property.value)) {
            return { value: object32.value[property.value] };
          }
        }
      }
    }
    return null;
  },
  ChainExpression(node, initialScope) {
    const expression = getStaticValueR43(node.expression, initialScope);
    if (expression != null) {
      return { value: expression.value };
    }
    return null;
  },
  NewExpression(node, initialScope) {
    const callee = getStaticValueR43(node.callee, initialScope);
    const args = getElementValues43(node.arguments, initialScope);
    if (callee != null && args != null) {
      const Func = callee.value;
      if (callAllowed43.has(Func)) {
        return { value: new Func(...args) };
      }
    }
    return null;
  },
  ObjectExpression(node, initialScope) {
    const object32 = {};
    for (const propertyNode of node.properties) {
      if (propertyNode.type === "Property") {
        if (propertyNode.kind !== "init") {
          return null;
        }
        const key = getStaticPropertyNameValue43(
          propertyNode,
          initialScope
        );
        const value = getStaticValueR43(propertyNode.value, initialScope);
        if (key == null || value == null) {
          return null;
        }
        object32[key.value] = value.value;
      } else if (propertyNode.type === "SpreadElement" || propertyNode.type === "ExperimentalSpreadProperty") {
        const argument = getStaticValueR43(
          propertyNode.argument,
          initialScope
        );
        if (argument == null) {
          return null;
        }
        Object.assign(object32, argument.value);
      } else {
        return null;
      }
    }
    return { value: object32 };
  },
  SequenceExpression(node, initialScope) {
    const last24 = node.expressions[node.expressions.length - 1];
    return getStaticValueR43(last24, initialScope);
  },
  TaggedTemplateExpression(node, initialScope) {
    const tag = getStaticValueR43(node.tag, initialScope);
    const expressions = getElementValues43(
      node.quasi.expressions,
      initialScope
    );
    if (tag != null && expressions != null) {
      const func = tag.value;
      const strings = node.quasi.quasis.map((q) => q.value.cooked);
      strings.raw = node.quasi.quasis.map((q) => q.value.raw);
      if (func === String.raw) {
        return { value: func(strings, ...expressions) };
      }
    }
    return null;
  },
  TemplateLiteral(node, initialScope) {
    const expressions = getElementValues43(node.expressions, initialScope);
    if (expressions != null) {
      let value = node.quasis[0].value.cooked;
      for (let i43 = 0; i43 < expressions.length; ++i43) {
        value += expressions[i43];
        value += node.quasis[i43 + 1].value.cooked;
      }
      return { value };
    }
    return null;
  },
  UnaryExpression(node, initialScope) {
    if (node.operator === "delete") {
      return null;
    }
    if (node.operator === "void") {
      return { value: void 0 };
    }
    const arg = getStaticValueR43(node.argument, initialScope);
    if (arg != null) {
      switch (node.operator) {
        case "-":
          return { value: -arg.value };
        case "+":
          return { value: +arg.value };
        case "!":
          return { value: !arg.value };
        case "~":
          return { value: ~arg.value };
        case "typeof":
          return { value: typeof arg.value };
      }
    }
    return null;
  }
});
function getStaticValueR43(node, initialScope) {
  if (node != null && Object.hasOwnProperty.call(operations43, node.type)) {
    return operations43[node.type](node, initialScope);
  }
  return null;
}
function getStaticPropertyNameValue43(node, initialScope) {
  const nameNode = node.type === "Property" ? node.key : node.property;
  if (node.computed) {
    return getStaticValueR43(nameNode, initialScope);
  }
  if (nameNode.type === "Identifier") {
    return { value: nameNode.name };
  }
  if (nameNode.type === "Literal") {
    if (nameNode.bigint) {
      return { value: nameNode.bigint };
    }
    return { value: String(nameNode.value) };
  }
  return null;
}
function getStaticValue33(node, initialScope = null) {
  try {
    return getStaticValueR43(node, initialScope);
  } catch (_error) {
    return null;
  }
}
function getStringIfConstant43(node, initialScope = null) {
  if (node && node.type === "Literal" && node.value === null) {
    if (node.regex) {
      return `/${node.regex.pattern}/${node.regex.flags}`;
    }
    if (node.bigint) {
      return node.bigint;
    }
  }
  const evaluated = getStaticValue33(node, initialScope);
  return evaluated && String(evaluated.value);
}
function getPropertyName43(node, initialScope) {
  switch (node.type) {
    case "MemberExpression":
      if (node.computed) {
        return getStringIfConstant43(node.property, initialScope);
      }
      if (node.property.type === "PrivateIdentifier") {
        return null;
      }
      return node.property.name;
    case "Property":
    case "MethodDefinition":
    case "PropertyDefinition":
      if (node.computed) {
        return getStringIfConstant43(node.key, initialScope);
      }
      if (node.key.type === "Literal") {
        return String(node.key.value);
      }
      if (node.key.type === "PrivateIdentifier") {
        return null;
      }
      return node.key.name;
  }
  return null;
}
function getFunctionNameWithKind43(node, sourceCode) {
  const parent = node.parent;
  const tokens = [];
  const isObjectMethod = parent.type === "Property" && parent.value === node;
  const isClassMethod = parent.type === "MethodDefinition" && parent.value === node;
  const isClassFieldMethod = parent.type === "PropertyDefinition" && parent.value === node;
  if (isClassMethod || isClassFieldMethod) {
    if (parent.static) {
      tokens.push("static");
    }
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push("private");
    }
  }
  if (node.async) {
    tokens.push("async");
  }
  if (node.generator) {
    tokens.push("generator");
  }
  if (isObjectMethod || isClassMethod) {
    if (parent.kind === "constructor") {
      return "constructor";
    }
    if (parent.kind === "get") {
      tokens.push("getter");
    } else if (parent.kind === "set") {
      tokens.push("setter");
    } else {
      tokens.push("method");
    }
  } else if (isClassFieldMethod) {
    tokens.push("method");
  } else {
    if (node.type === "ArrowFunctionExpression") {
      tokens.push("arrow");
    }
    tokens.push("function");
  }
  if (isObjectMethod || isClassMethod || isClassFieldMethod) {
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push(`#${parent.key.name}`);
    } else {
      const name22 = getPropertyName43(parent);
      if (name22) {
        tokens.push(`'${name22}'`);
      } else if (sourceCode) {
        const keyText = sourceCode.getText(parent.key);
        if (!keyText.includes("\n")) {
          tokens.push(`[${keyText}]`);
        }
      }
    }
  } else if (node.id) {
    tokens.push(`'${node.id.name}'`);
  } else if (parent.type === "VariableDeclarator" && parent.id && parent.id.type === "Identifier") {
    tokens.push(`'${parent.id.name}'`);
  } else if ((parent.type === "AssignmentExpression" || parent.type === "AssignmentPattern") && parent.left && parent.left.type === "Identifier") {
    tokens.push(`'${parent.left.name}'`);
  } else if (parent.type === "ExportDefaultDeclaration" && parent.declaration === node) {
    tokens.push("'default'");
  }
  return tokens.join(" ");
}
var typeConversionBinaryOps43 = Object.freeze(
  /* @__PURE__ */ new Set([
    "==",
    "!=",
    "<",
    "<=",
    ">",
    ">=",
    "<<",
    ">>",
    ">>>",
    "+",
    "-",
    "*",
    "/",
    "%",
    "|",
    "^",
    "&",
    "in"
  ])
);
var typeConversionUnaryOps43 = Object.freeze(/* @__PURE__ */ new Set(["-", "+", "!", "~"]));
function isNode43(x43) {
  return x43 !== null && typeof x43 === "object" && typeof x43.type === "string";
}
var visitor43 = Object.freeze(
  Object.assign(/* @__PURE__ */ Object.create(null), {
    $visit(node, options, visitorKeys) {
      const { type } = node;
      if (typeof this[type] === "function") {
        return this[type](node, options, visitorKeys);
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    $visitChildren(node, options, visitorKeys) {
      const { type } = node;
      for (const key of visitorKeys[type] || getKeys43(node)) {
        const value = node[key];
        if (Array.isArray(value)) {
          for (const element of value) {
            if (isNode43(element) && this.$visit(element, options, visitorKeys)) {
              return true;
            }
          }
        } else if (isNode43(value) && this.$visit(value, options, visitorKeys)) {
          return true;
        }
      }
      return false;
    },
    ArrowFunctionExpression() {
      return false;
    },
    AssignmentExpression() {
      return true;
    },
    AwaitExpression() {
      return true;
    },
    BinaryExpression(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && typeConversionBinaryOps43.has(node.operator) && (node.left.type !== "Literal" || node.right.type !== "Literal")) {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    CallExpression() {
      return true;
    },
    FunctionExpression() {
      return false;
    },
    ImportExpression() {
      return true;
    },
    MemberExpression(node, options, visitorKeys) {
      if (options.considerGetters) {
        return true;
      }
      if (options.considerImplicitTypeConversion && node.computed && node.property.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    MethodDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    NewExpression() {
      return true;
    },
    Property(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    PropertyDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UnaryExpression(node, options, visitorKeys) {
      if (node.operator === "delete") {
        return true;
      }
      if (options.considerImplicitTypeConversion && typeConversionUnaryOps43.has(node.operator) && node.argument.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UpdateExpression() {
      return true;
    },
    YieldExpression() {
      return true;
    }
  })
);
function hasSideEffect43(node, sourceCode, { considerGetters = false, considerImplicitTypeConversion = false } = {}) {
  return visitor43.$visit(
    node,
    { considerGetters, considerImplicitTypeConversion },
    sourceCode.visitorKeys || visitor_keys_default43
  );
}
function getParentSyntaxParen43(node, sourceCode) {
  const parent = node.parent;
  switch (parent.type) {
    case "CallExpression":
    case "NewExpression":
      if (parent.arguments.length === 1 && parent.arguments[0] === node) {
        return sourceCode.getTokenAfter(
          parent.callee,
          isOpeningParenToken43
        );
      }
      return null;
    case "DoWhileStatement":
      if (parent.test === node) {
        return sourceCode.getTokenAfter(
          parent.body,
          isOpeningParenToken43
        );
      }
      return null;
    case "IfStatement":
    case "WhileStatement":
      if (parent.test === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "ImportExpression":
      if (parent.source === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "SwitchStatement":
      if (parent.discriminant === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "WithStatement":
      if (parent.object === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    default:
      return null;
  }
}
function isParenthesized43(timesOrNode, nodeOrSourceCode, optionalSourceCode) {
  let times, node, sourceCode, maybeLeftParen, maybeRightParen;
  if (typeof timesOrNode === "number") {
    times = timesOrNode | 0;
    node = nodeOrSourceCode;
    sourceCode = optionalSourceCode;
    if (!(times >= 1)) {
      throw new TypeError("'times' should be a positive integer.");
    }
  } else {
    times = 1;
    node = timesOrNode;
    sourceCode = nodeOrSourceCode;
  }
  if (node == null || // `Program` can't be parenthesized
  node.parent == null || // `CatchClause.param` can't be parenthesized, example `try {} catch (error) {}`
  node.parent.type === "CatchClause" && node.parent.param === node) {
    return false;
  }
  maybeLeftParen = maybeRightParen = node;
  do {
    maybeLeftParen = sourceCode.getTokenBefore(maybeLeftParen);
    maybeRightParen = sourceCode.getTokenAfter(maybeRightParen);
  } while (maybeLeftParen != null && maybeRightParen != null && isOpeningParenToken43(maybeLeftParen) && isClosingParenToken43(maybeRightParen) && // Avoid false positive such as `if (a) {}`
  maybeLeftParen !== getParentSyntaxParen43(node, sourceCode) && --times > 0);
  return times === 0;
}
Function.call.bind(Object.hasOwnProperty);
var __defProp53 = Object.defineProperty;
var __export53 = (target, all334) => {
  for (var name22 in all334)
    __defProp53(target, name22, { get: all334[name22], enumerable: true });
};
var NodeType43 = types.AST_NODE_TYPES;
var is43 = utils.ASTUtils.isNodeOfType;
var isOneOf43 = utils.ASTUtils.isNodeOfTypes;
isOneOf43([
  NodeType43.ArrowFunctionExpression,
  NodeType43.FunctionDeclaration,
  NodeType43.FunctionExpression
]);
isOneOf43([
  NodeType43.ArrowFunctionExpression,
  NodeType43.FunctionDeclaration,
  NodeType43.FunctionExpression,
  NodeType43.TSCallSignatureDeclaration,
  NodeType43.TSConstructSignatureDeclaration,
  NodeType43.TSDeclareFunction,
  NodeType43.TSEmptyBodyFunctionExpression,
  NodeType43.TSFunctionType,
  NodeType43.TSMethodSignature
]);
isOneOf43([NodeType43.ClassDeclaration, NodeType43.ClassExpression]);
isOneOf43([
  NodeType43.DoWhileStatement,
  NodeType43.ForInStatement,
  NodeType43.ForOfStatement,
  NodeType43.ForStatement,
  NodeType43.WhileStatement
]);
isOneOf43([NodeType43.TSArrayType, NodeType43.TSTupleType]);
isOneOf43([
  NodeType43.PropertyDefinition,
  NodeType43.TSIndexSignature,
  NodeType43.TSParameterProperty,
  NodeType43.TSPropertySignature
]);
is43(NodeType43.JSXElement);
is43(NodeType43.JSXFragment);
isOneOf43([
  NodeType43.JSXAttribute,
  NodeType43.JSXSpreadChild,
  NodeType43.JSXClosingElement,
  NodeType43.JSXClosingFragment,
  NodeType43.JSXElement,
  NodeType43.JSXEmptyExpression,
  NodeType43.JSXExpressionContainer,
  NodeType43.JSXFragment,
  NodeType43.JSXIdentifier,
  NodeType43.JSXMemberExpression,
  NodeType43.JSXNamespacedName,
  NodeType43.JSXOpeningElement,
  NodeType43.JSXOpeningFragment,
  NodeType43.JSXSpreadAttribute,
  NodeType43.JSXSpreadChild,
  NodeType43.JSXText
]);
isOneOf43([
  NodeType43.JSXIdentifier,
  NodeType43.JSXMemberExpression,
  NodeType43.JSXNamespacedName
]);
isOneOf43([
  NodeType43.ArrayPattern,
  NodeType43.AssignmentPattern,
  NodeType43.ObjectPattern,
  NodeType43.RestElement
]);
isOneOf43([
  NodeType43.TSInterfaceDeclaration,
  NodeType43.TSTypeAliasDeclaration
]);
isOneOf43([
  NodeType43.ArrayExpression,
  NodeType43.ArrayPattern,
  NodeType43.ArrowFunctionExpression,
  NodeType43.CallExpression,
  NodeType43.ClassExpression,
  NodeType43.FunctionExpression,
  NodeType43.Identifier,
  NodeType43.JSXElement,
  NodeType43.JSXFragment,
  NodeType43.Literal,
  NodeType43.TemplateLiteral,
  NodeType43.MemberExpression,
  NodeType43.MetaProperty,
  NodeType43.ObjectExpression,
  NodeType43.ObjectPattern,
  NodeType43.SequenceExpression,
  NodeType43.Super,
  NodeType43.TaggedTemplateExpression,
  NodeType43.ThisExpression
]);
isOneOf43([
  NodeType43.ArrayExpression,
  NodeType43.ArrayPattern,
  NodeType43.ArrowFunctionExpression,
  NodeType43.CallExpression,
  NodeType43.ClassExpression,
  NodeType43.FunctionExpression,
  NodeType43.Identifier,
  NodeType43.JSXElement,
  NodeType43.JSXFragment,
  NodeType43.Literal,
  NodeType43.TemplateLiteral,
  NodeType43.MemberExpression,
  NodeType43.MetaProperty,
  NodeType43.ObjectExpression,
  NodeType43.ObjectPattern,
  NodeType43.SequenceExpression,
  NodeType43.Super,
  NodeType43.TaggedTemplateExpression,
  NodeType43.ThisExpression,
  NodeType43.TSAsExpression,
  NodeType43.TSNonNullExpression,
  NodeType43.TSTypeAssertion
]);
var Function_exports63 = {};
__export53(Function_exports63, {
  SK: () => SK63,
  absurd: () => absurd63,
  apply: () => apply63,
  compose: () => compose93,
  constFalse: () => constFalse63,
  constNull: () => constNull63,
  constTrue: () => constTrue63,
  constUndefined: () => constUndefined63,
  constVoid: () => constVoid63,
  constant: () => constant63,
  dual: () => dual63,
  flip: () => flip63,
  flow: () => flow63,
  hole: () => hole63,
  identity: () => identity63,
  isFunction: () => isFunction243,
  pipe: () => pipe63,
  satisfies: () => satisfies63,
  tupled: () => tupled63,
  unsafeCoerce: () => unsafeCoerce63,
  untupled: () => untupled63
});
var isFunction243 = (input) => typeof input === "function";
var dual63 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a43, b43) {
        if (arguments.length >= 2) {
          return body(a43, b43);
        }
        return function(self2) {
          return body(self2, a43);
        };
      };
    case 3:
      return function(a43, b43, c43) {
        if (arguments.length >= 3) {
          return body(a43, b43, c43);
        }
        return function(self2) {
          return body(self2, a43, b43);
        };
      };
    case 4:
      return function(a43, b43, c43, d43) {
        if (arguments.length >= 4) {
          return body(a43, b43, c43, d43);
        }
        return function(self2) {
          return body(self2, a43, b43, c43);
        };
      };
    case 5:
      return function(a43, b43, c43, d43, e43) {
        if (arguments.length >= 5) {
          return body(a43, b43, c43, d43, e43);
        }
        return function(self2) {
          return body(self2, a43, b43, c43, d43);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply63 = (a43) => (self2) => self2(a43);
var identity63 = (a43) => a43;
var satisfies63 = () => (b43) => b43;
var unsafeCoerce63 = identity63;
var constant63 = (value) => () => value;
var constTrue63 = /* @__PURE__ */ constant63(true);
var constFalse63 = /* @__PURE__ */ constant63(false);
var constNull63 = /* @__PURE__ */ constant63(null);
var constUndefined63 = /* @__PURE__ */ constant63(void 0);
var constVoid63 = constUndefined63;
var flip63 = (f43) => (...b43) => (...a43) => f43(...a43)(...b43);
var compose93 = /* @__PURE__ */ dual63(2, (ab, bc) => (a43) => bc(ab(a43)));
var absurd63 = (_43) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled63 = (f43) => (a43) => f43(...a43);
var untupled63 = (f43) => (...a43) => f43(a43);
function pipe63(a43, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a43;
    case 2:
      return ab(a43);
    case 3:
      return bc(ab(a43));
    case 4:
      return cd(bc(ab(a43)));
    case 5:
      return de(cd(bc(ab(a43))));
    case 6:
      return ef(de(cd(bc(ab(a43)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a43))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a43)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a43))))))));
    default: {
      let ret = arguments[0];
      for (let i43 = 1; i43 < arguments.length; i43++) {
        ret = arguments[i43](ret);
      }
      return ret;
    }
  }
}
function flow63(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole63 = /* @__PURE__ */ unsafeCoerce63(absurd63);
var SK63 = (_43, b43) => b43;
var make173 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_103 = (map622) => dual63(3, (self2, name22, f43) => map622(self2, (a43) => Object.assign({}, a43, {
  [name22]: f43(a43)
})));
var bindTo103 = (map622) => dual63(2, (self2, name22) => map622(self2, (a43) => ({
  [name22]: a43
})));
var bind103 = (map622, flatMap424) => dual63(3, (self2, name22, f43) => flatMap424(self2, (a43) => map622(f43(a43), (b43) => Object.assign({}, a43, {
  [name22]: b43
}))));
var moduleVersion63 = "3.2.8";
var getCurrentVersion63 = () => moduleVersion63;
var globalStoreId63 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion63()}`);
if (!(globalStoreId63 in globalThis)) {
  globalThis[globalStoreId63] = /* @__PURE__ */ new Map();
}
var globalStore63 = globalThis[globalStoreId63];
var globalValue63 = (id, compute) => {
  if (!globalStore63.has(id)) {
    globalStore63.set(id, compute());
  }
  return globalStore63.get(id);
};
var Predicate_exports43 = {};
__export53(Predicate_exports43, {
  all: () => all93,
  and: () => and63,
  compose: () => compose243,
  eqv: () => eqv63,
  every: () => every73,
  hasProperty: () => hasProperty63,
  implies: () => implies63,
  isBigInt: () => isBigInt63,
  isBoolean: () => isBoolean63,
  isDate: () => isDate63,
  isError: () => isError63,
  isFunction: () => isFunction333,
  isIterable: () => isIterable63,
  isMap: () => isMap63,
  isNever: () => isNever63,
  isNotNull: () => isNotNull63,
  isNotNullable: () => isNotNullable63,
  isNotUndefined: () => isNotUndefined63,
  isNull: () => isNull63,
  isNullable: () => isNullable63,
  isNumber: () => isNumber63,
  isObject: () => isObject63,
  isPromise: () => isPromise63,
  isPromiseLike: () => isPromiseLike63,
  isReadonlyRecord: () => isReadonlyRecord63,
  isRecord: () => isRecord63,
  isSet: () => isSet63,
  isString: () => isString63,
  isSymbol: () => isSymbol63,
  isTagged: () => isTagged63,
  isTruthy: () => isTruthy63,
  isUint8Array: () => isUint8Array63,
  isUndefined: () => isUndefined63,
  isUnknown: () => isUnknown63,
  mapInput: () => mapInput73,
  nand: () => nand63,
  nor: () => nor63,
  not: () => not63,
  or: () => or63,
  product: () => product93,
  productMany: () => productMany93,
  some: () => some133,
  struct: () => struct83,
  tuple: () => tuple73,
  xor: () => xor63
});
var mapInput73 = /* @__PURE__ */ dual63(2, (self2, f43) => (b43) => self2(f43(b43)));
var isTruthy63 = (input) => !!input;
var isSet63 = (input) => input instanceof Set;
var isMap63 = (input) => input instanceof Map;
var isString63 = (input) => typeof input === "string";
var isNumber63 = (input) => typeof input === "number";
var isBoolean63 = (input) => typeof input === "boolean";
var isBigInt63 = (input) => typeof input === "bigint";
var isSymbol63 = (input) => typeof input === "symbol";
var isFunction333 = isFunction243;
var isUndefined63 = (input) => input === void 0;
var isNotUndefined63 = (input) => input !== void 0;
var isNull63 = (input) => input === null;
var isNotNull63 = (input) => input !== null;
var isNever63 = (_43) => false;
var isUnknown63 = (_43) => true;
var isRecordOrArray63 = (input) => typeof input === "object" && input !== null;
var isObject63 = (input) => isRecordOrArray63(input) || isFunction333(input);
var hasProperty63 = /* @__PURE__ */ dual63(2, (self2, property) => isObject63(self2) && property in self2);
var isTagged63 = /* @__PURE__ */ dual63(2, (self2, tag) => hasProperty63(self2, "_tag") && self2["_tag"] === tag);
var isNullable63 = (input) => input === null || input === void 0;
var isNotNullable63 = (input) => input !== null && input !== void 0;
var isError63 = (input) => input instanceof Error;
var isUint8Array63 = (input) => input instanceof Uint8Array;
var isDate63 = (input) => input instanceof Date;
var isIterable63 = (input) => hasProperty63(input, Symbol.iterator);
var isRecord63 = (input) => isRecordOrArray63(input) && !Array.isArray(input);
var isReadonlyRecord63 = isRecord63;
var isPromise63 = (input) => hasProperty63(input, "then") && "catch" in input && isFunction333(input.then) && isFunction333(input.catch);
var isPromiseLike63 = (input) => hasProperty63(input, "then") && isFunction333(input.then);
var compose243 = /* @__PURE__ */ dual63(2, (ab, bc) => (a43) => ab(a43) && bc(a43));
var product93 = (self2, that) => ([a43, b43]) => self2(a43) && that(b43);
var all93 = (collection) => {
  return (as253) => {
    let collectionIndex = 0;
    for (const p43 of collection) {
      if (collectionIndex >= as253.length) {
        break;
      }
      if (p43(as253[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany93 = (self2, collection) => {
  const rest = all93(collection);
  return ([head222, ...tail34]) => self2(head222) === false ? false : rest(tail34);
};
var tuple73 = (...elements) => all93(elements);
var struct83 = (fields) => {
  const keys234 = Object.keys(fields);
  return (a43) => {
    for (const key of keys234) {
      if (!fields[key](a43[key])) {
        return false;
      }
    }
    return true;
  };
};
var not63 = (self2) => (a43) => !self2(a43);
var or63 = /* @__PURE__ */ dual63(2, (self2, that) => (a43) => self2(a43) || that(a43));
var and63 = /* @__PURE__ */ dual63(2, (self2, that) => (a43) => self2(a43) && that(a43));
var xor63 = /* @__PURE__ */ dual63(2, (self2, that) => (a43) => self2(a43) !== that(a43));
var eqv63 = /* @__PURE__ */ dual63(2, (self2, that) => (a43) => self2(a43) === that(a43));
var implies63 = /* @__PURE__ */ dual63(2, (self2, that) => (a43) => self2(a43) ? that(a43) : true);
var nor63 = /* @__PURE__ */ dual63(2, (self2, that) => (a43) => !(self2(a43) || that(a43)));
var nand63 = /* @__PURE__ */ dual63(2, (self2, that) => (a43) => !(self2(a43) && that(a43)));
var every73 = (collection) => (a43) => {
  for (const p43 of collection) {
    if (!p43(a43)) {
      return false;
    }
  }
  return true;
};
var some133 = (collection) => (a43) => {
  for (const p43 of collection) {
    if (p43(a43)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage63 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId63 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind63 = (u43) => isObject63(u43) && GenKindTypeId63 in u43;
var GenKindImpl63 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity63;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_43) => _43;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_43) => _43;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_43) => _43;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId63] = GenKindTypeId63;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen73(this);
  }
};
var SingleShotGen73 = class _SingleShotGen83 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a43) {
    return this.called ? {
      value: a43,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a43) {
    return {
      value: a43,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e43) {
    throw e43;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen83(this.self);
  }
};
var adapter93 = () => function() {
  let x43 = arguments[0];
  for (let i43 = 1; i43 < arguments.length; i43++) {
    x43 = arguments[i43](x43);
  }
  return new GenKindImpl63(x43);
};
var defaultIncHi63 = 335903614;
var defaultIncLo63 = 4150755663;
var MUL_HI63 = 1481765933 >>> 0;
var MUL_LO63 = 1284865837 >>> 0;
var BIT_5363 = 9007199254740992;
var BIT_2763 = 134217728;
var PCGRandom63 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable63(seedLo) && isNullable63(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable63(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable63(incLo) && isNullable63(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo63;
      incHi = this._state ? this._state[2] : defaultIncHi63;
    } else if (isNullable63(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add6463(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max34) {
    if (!max34) {
      return this._next();
    }
    max34 = max34 >>> 0;
    if ((max34 & max34 - 1) === 0) {
      return this._next() & max34 - 1;
    }
    let num = 0;
    const skew = (-max34 >>> 0) % max34 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max34;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_2763 + lo) / BIT_5363;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul6463(this._state, oldHi, oldLo, MUL_HI63, MUL_LO63);
    add6463(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul6463(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add6463(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId63 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap63 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId63]() {
    return this.#value;
  }
};
function yieldWrapGet63(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId63 in self2) {
    return self2[YieldWrapTypeId63]();
  }
  throw new Error(getBugErrorMessage63("yieldWrapGet"));
}
var structuralRegionState63 = /* @__PURE__ */ globalValue63("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache63 = /* @__PURE__ */ globalValue63(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr63 = /* @__PURE__ */ globalValue63(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom63());
var symbol93 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash63 = (self2) => {
  if (structuralRegionState63.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number73(self2);
    case "bigint":
      return string83(self2.toString(10));
    case "boolean":
      return string83(String(self2));
    case "symbol":
      return string83(String(self2));
    case "string":
      return string83(self2);
    case "undefined":
      return string83("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string83("null");
      } else if (self2 instanceof Date) {
        return hash63(self2.toISOString());
      } else if (isHash63(self2)) {
        return self2[symbol93]();
      } else {
        return random63(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random63 = (self2) => {
  if (!randomHashCache63.has(self2)) {
    randomHashCache63.set(self2, number73(pcgr63.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache63.get(self2);
};
var combine73 = (b43) => (self2) => self2 * 53 ^ b43;
var optimize63 = (n43) => n43 & 3221225471 | n43 >>> 1 & 1073741824;
var isHash63 = (u43) => hasProperty63(u43, symbol93);
var number73 = (n43) => {
  if (n43 !== n43 || n43 === Infinity) {
    return 0;
  }
  let h43 = n43 | 0;
  if (h43 !== n43) {
    h43 ^= n43 * 4294967295;
  }
  while (n43 > 4294967295) {
    h43 ^= n43 /= 4294967295;
  }
  return optimize63(n43);
};
var string83 = (str) => {
  let h43 = 5381, i43 = str.length;
  while (i43) {
    h43 = h43 * 33 ^ str.charCodeAt(--i43);
  }
  return optimize63(h43);
};
var structureKeys33 = (o43, keys234) => {
  let h43 = 12289;
  for (let i43 = 0; i43 < keys234.length; i43++) {
    h43 ^= pipe63(string83(keys234[i43]), combine73(hash63(o43[keys234[i43]])));
  }
  return optimize63(h43);
};
var structure33 = (o43) => structureKeys33(o43, Object.keys(o43));
var array93 = (arr) => {
  let h43 = 6151;
  for (let i43 = 0; i43 < arr.length; i43++) {
    h43 = pipe63(h43, combine73(hash63(arr[i43])));
  }
  return optimize63(h43);
};
var cached63 = function() {
  if (arguments.length === 1) {
    const self22 = arguments[0];
    return function(hash324) {
      Object.defineProperty(self22, symbol93, {
        value() {
          return hash324;
        },
        enumerable: false
      });
      return hash324;
    };
  }
  const self2 = arguments[0];
  const hash253 = arguments[1];
  Object.defineProperty(self2, symbol93, {
    value() {
      return hash253;
    },
    enumerable: false
  });
  return hash253;
};
var symbol243 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals63() {
  if (arguments.length === 1) {
    return (self2) => compareBoth63(self2, arguments[0]);
  }
  return compareBoth63(arguments[0], arguments[1]);
}
function compareBoth63(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual63(self2) && isEqual63(that)) {
        if (hash63(self2) === hash63(that) && self2[symbol243](that)) {
          return true;
        } else {
          return structuralRegionState63.enabled && structuralRegionState63.tester ? structuralRegionState63.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState63.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v43, i43) => compareBoth63(v43, that[i43]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth63(self2[key], that[key]))) {
              return structuralRegionState63.tester ? structuralRegionState63.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState63.tester ? structuralRegionState63.tester(self2, that) : false;
    }
  }
  return structuralRegionState63.enabled && structuralRegionState63.tester ? structuralRegionState63.tester(self2, that) : false;
}
var isEqual63 = (u43) => hasProperty63(u43, symbol243);
var equivalence63 = () => equals63;
var NodeInspectSymbol63 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON63 = (x43) => {
  if (hasProperty63(x43, "toJSON") && isFunction333(x43["toJSON"]) && x43["toJSON"].length === 0) {
    return x43.toJSON();
  } else if (Array.isArray(x43)) {
    return x43.map(toJSON63);
  }
  return x43;
};
var format63 = (x43) => JSON.stringify(x43, null, 2);
var pipeArguments63 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i43 = 0, len = args.length; i43 < len; i43++) {
        ret = args[i43](ret);
      }
      return ret;
    }
  }
};
var OP_COMMIT33 = "Commit";
var OP_FAILURE43 = "Failure";
var OP_WITH_RUNTIME43 = "WithRuntime";
var EffectTypeId73 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId63 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId63 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId63 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance63 = {
  /* c8 ignore next */
  _R: (_43) => _43,
  /* c8 ignore next */
  _E: (_43) => _43,
  /* c8 ignore next */
  _A: (_43) => _43,
  _V: /* @__PURE__ */ getCurrentVersion63()
};
var sinkVariance63 = {
  /* c8 ignore next */
  _A: (_43) => _43,
  /* c8 ignore next */
  _In: (_43) => _43,
  /* c8 ignore next */
  _L: (_43) => _43,
  /* c8 ignore next */
  _E: (_43) => _43,
  /* c8 ignore next */
  _R: (_43) => _43
};
var channelVariance63 = {
  /* c8 ignore next */
  _Env: (_43) => _43,
  /* c8 ignore next */
  _InErr: (_43) => _43,
  /* c8 ignore next */
  _InElem: (_43) => _43,
  /* c8 ignore next */
  _InDone: (_43) => _43,
  /* c8 ignore next */
  _OutErr: (_43) => _43,
  /* c8 ignore next */
  _OutElem: (_43) => _43,
  /* c8 ignore next */
  _OutDone: (_43) => _43
};
var EffectPrototype63 = {
  [EffectTypeId73]: effectVariance63,
  [StreamTypeId63]: effectVariance63,
  [SinkTypeId63]: sinkVariance63,
  [ChannelTypeId63]: channelVariance63,
  [symbol243](that) {
    return this === that;
  },
  [symbol93]() {
    return cached63(this, random63(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen73(new YieldWrap63(this));
  },
  pipe() {
    return pipeArguments63(this, arguments);
  }
};
var StructuralPrototype33 = {
  [symbol93]() {
    return cached63(this, structure33(this));
  },
  [symbol243](that) {
    const selfKeys = Object.keys(this);
    const thatKeys = Object.keys(that);
    if (selfKeys.length !== thatKeys.length) {
      return false;
    }
    for (const key of selfKeys) {
      if (!(key in that && equals63(this[key], that[key]))) {
        return false;
      }
    }
    return true;
  }
};
var CommitPrototype33 = {
  ...EffectPrototype63,
  _op: OP_COMMIT33
};
var StructuralCommitPrototype33 = {
  ...CommitPrototype33,
  ...StructuralPrototype33
};
var TypeId163 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto93 = {
  ...EffectPrototype63,
  [TypeId163]: {
    _A: (_43) => _43
  },
  [NodeInspectSymbol63]() {
    return this.toJSON();
  },
  toString() {
    return format63(this.toJSON());
  }
};
var SomeProto63 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto93), {
  _tag: "Some",
  _op: "Some",
  [symbol243](that) {
    return isOption93(that) && isSome93(that) && equals63(this.value, that.value);
  },
  [symbol93]() {
    return cached63(this, combine73(hash63(this._tag))(hash63(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON63(this.value)
    };
  }
});
var NoneHash63 = /* @__PURE__ */ hash63("None");
var NoneProto63 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto93), {
  _tag: "None",
  _op: "None",
  [symbol243](that) {
    return isOption93(that) && isNone93(that);
  },
  [symbol93]() {
    return NoneHash63;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption93 = (input) => hasProperty63(input, TypeId163);
var isNone93 = (fa) => fa._tag === "None";
var isSome93 = (fa) => fa._tag === "Some";
var none93 = /* @__PURE__ */ Object.create(NoneProto63);
var some243 = (value) => {
  const a43 = Object.create(SomeProto63);
  a43.value = value;
  return a43;
};
var TypeId243 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto243 = {
  ...EffectPrototype63,
  [TypeId243]: {
    _R: (_43) => _43
  },
  [NodeInspectSymbol63]() {
    return this.toJSON();
  },
  toString() {
    return format63(this.toJSON());
  }
};
var RightProto63 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto243), {
  _tag: "Right",
  _op: "Right",
  [symbol243](that) {
    return isEither63(that) && isRight73(that) && equals63(this.right, that.right);
  },
  [symbol93]() {
    return combine73(hash63(this._tag))(hash63(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON63(this.right)
    };
  }
});
var LeftProto63 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto243), {
  _tag: "Left",
  _op: "Left",
  [symbol243](that) {
    return isEither63(that) && isLeft73(that) && equals63(this.left, that.left);
  },
  [symbol93]() {
    return combine73(hash63(this._tag))(hash63(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON63(this.left)
    };
  }
});
var isEither63 = (input) => hasProperty63(input, TypeId243);
var isLeft73 = (ma) => ma._tag === "Left";
var isRight73 = (ma) => ma._tag === "Right";
var left73 = (left334) => {
  const a43 = Object.create(LeftProto63);
  a43.left = left334;
  return a43;
};
var right73 = (right334) => {
  const a43 = Object.create(RightProto63);
  a43.right = right334;
  return a43;
};
var getLeft93 = (self2) => isRight73(self2) ? none93 : some243(self2.left);
var getRight93 = (self2) => isLeft73(self2) ? none93 : some243(self2.right);
var right243 = right73;
var left243 = left73;
var Option_exports63 = {};
__export53(Option_exports63, {
  Do: () => Do73,
  TypeId: () => TypeId343,
  all: () => all243,
  andThen: () => andThen63,
  ap: () => ap63,
  as: () => as63,
  asVoid: () => asVoid63,
  bind: () => bind243,
  bindTo: () => bindTo243,
  composeK: () => composeK63,
  contains: () => contains73,
  containsWith: () => containsWith73,
  exists: () => exists63,
  filter: () => filter73,
  filterMap: () => filterMap73,
  firstSomeOf: () => firstSomeOf63,
  flatMap: () => flatMap73,
  flatMapNullable: () => flatMapNullable73,
  flatten: () => flatten73,
  fromIterable: () => fromIterable93,
  fromNullable: () => fromNullable73,
  gen: () => gen63,
  getEquivalence: () => getEquivalence83,
  getLeft: () => getLeft243,
  getOrElse: () => getOrElse63,
  getOrNull: () => getOrNull63,
  getOrThrow: () => getOrThrow63,
  getOrThrowWith: () => getOrThrowWith63,
  getOrUndefined: () => getOrUndefined63,
  getOrder: () => getOrder73,
  getRight: () => getRight243,
  isNone: () => isNone243,
  isOption: () => isOption243,
  isSome: () => isSome243,
  let: () => let_243,
  lift2: () => lift263,
  liftNullable: () => liftNullable73,
  liftPredicate: () => liftPredicate73,
  liftThrowable: () => liftThrowable63,
  map: () => map73,
  match: () => match243,
  none: () => none243,
  orElse: () => orElse63,
  orElseEither: () => orElseEither63,
  orElseSome: () => orElseSome63,
  partitionMap: () => partitionMap73,
  product: () => product243,
  productMany: () => productMany243,
  reduceCompact: () => reduceCompact63,
  some: () => some343,
  tap: () => tap63,
  toArray: () => toArray63,
  toRefinement: () => toRefinement63,
  void: () => void_63,
  zipLeft: () => zipLeft63,
  zipRight: () => zipRight63,
  zipWith: () => zipWith73
});
var make243 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId343 = /* @__PURE__ */ Symbol.for("effect/Option");
var none243 = () => none93;
var some343 = some243;
var isOption243 = isOption93;
var isNone243 = isNone93;
var isSome243 = isSome93;
var match243 = /* @__PURE__ */ dual63(2, (self2, {
  onNone,
  onSome
}) => isNone243(self2) ? onNone() : onSome(self2.value));
var toRefinement63 = (f43) => (a43) => isSome243(f43(a43));
var fromIterable93 = (collection) => {
  for (const a43 of collection) {
    return some343(a43);
  }
  return none243();
};
var getRight243 = getRight93;
var getLeft243 = getLeft93;
var getOrElse63 = /* @__PURE__ */ dual63(2, (self2, onNone) => isNone243(self2) ? onNone() : self2.value);
var orElse63 = /* @__PURE__ */ dual63(2, (self2, that) => isNone243(self2) ? that() : self2);
var orElseSome63 = /* @__PURE__ */ dual63(2, (self2, onNone) => isNone243(self2) ? some343(onNone()) : self2);
var orElseEither63 = /* @__PURE__ */ dual63(2, (self2, that) => isNone243(self2) ? map73(that(), right73) : map73(self2, left73));
var firstSomeOf63 = (collection) => {
  let out = none243();
  for (out of collection) {
    if (isSome243(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable73 = (nullableValue) => nullableValue == null ? none243() : some343(nullableValue);
var liftNullable73 = (f43) => (...a43) => fromNullable73(f43(...a43));
var getOrNull63 = /* @__PURE__ */ getOrElse63(constNull63);
var getOrUndefined63 = /* @__PURE__ */ getOrElse63(constUndefined63);
var liftThrowable63 = (f43) => (...a43) => {
  try {
    return some343(f43(...a43));
  } catch (e43) {
    return none243();
  }
};
var getOrThrowWith63 = /* @__PURE__ */ dual63(2, (self2, onNone) => {
  if (isSome243(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow63 = /* @__PURE__ */ getOrThrowWith63(() => new Error("getOrThrow called on a None"));
var map73 = /* @__PURE__ */ dual63(2, (self2, f43) => isNone243(self2) ? none243() : some343(f43(self2.value)));
var as63 = /* @__PURE__ */ dual63(2, (self2, b43) => map73(self2, () => b43));
var asVoid63 = /* @__PURE__ */ as63(void 0);
var void_63 = /* @__PURE__ */ some343(void 0);
var flatMap73 = /* @__PURE__ */ dual63(2, (self2, f43) => isNone243(self2) ? none243() : f43(self2.value));
var andThen63 = /* @__PURE__ */ dual63(2, (self2, f43) => flatMap73(self2, (a43) => {
  const b43 = isFunction243(f43) ? f43(a43) : f43;
  return isOption243(b43) ? b43 : some343(b43);
}));
var flatMapNullable73 = /* @__PURE__ */ dual63(2, (self2, f43) => isNone243(self2) ? none243() : fromNullable73(f43(self2.value)));
var flatten73 = /* @__PURE__ */ flatMap73(identity63);
var zipRight63 = /* @__PURE__ */ dual63(2, (self2, that) => flatMap73(self2, () => that));
var composeK63 = /* @__PURE__ */ dual63(2, (afb, bfc) => (a43) => flatMap73(afb(a43), bfc));
var zipLeft63 = /* @__PURE__ */ dual63(2, (self2, that) => tap63(self2, () => that));
var tap63 = /* @__PURE__ */ dual63(2, (self2, f43) => flatMap73(self2, (a43) => map73(f43(a43), () => a43)));
var product243 = (self2, that) => isSome243(self2) && isSome243(that) ? some343([self2.value, that.value]) : none243();
var productMany243 = (self2, collection) => {
  if (isNone243(self2)) {
    return none243();
  }
  const out = [self2.value];
  for (const o43 of collection) {
    if (isNone243(o43)) {
      return none243();
    }
    out.push(o43.value);
  }
  return some343(out);
};
var all243 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o43 of input) {
      if (isNone243(o43)) {
        return none243();
      }
      out2.push(o43.value);
    }
    return some343(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o43 = input[key];
    if (isNone243(o43)) {
      return none243();
    }
    out[key] = o43.value;
  }
  return some343(out);
};
var zipWith73 = /* @__PURE__ */ dual63(3, (self2, that, f43) => map73(product243(self2, that), ([a43, b43]) => f43(a43, b43)));
var ap63 = /* @__PURE__ */ dual63(2, (self2, that) => zipWith73(self2, that, (f43, a43) => f43(a43)));
var reduceCompact63 = /* @__PURE__ */ dual63(3, (self2, b43, f43) => {
  let out = b43;
  for (const oa of self2) {
    if (isSome243(oa)) {
      out = f43(out, oa.value);
    }
  }
  return out;
});
var toArray63 = (self2) => isNone243(self2) ? [] : [self2.value];
var partitionMap73 = /* @__PURE__ */ dual63(2, (self2, f43) => {
  if (isNone243(self2)) {
    return [none243(), none243()];
  }
  const e43 = f43(self2.value);
  return isLeft73(e43) ? [some343(e43.left), none243()] : [none243(), some343(e43.right)];
});
var filterMap73 = /* @__PURE__ */ dual63(2, (self2, f43) => isNone243(self2) ? none243() : f43(self2.value));
var filter73 = /* @__PURE__ */ dual63(2, (self2, predicate) => filterMap73(self2, (b43) => predicate(b43) ? some243(b43) : none93));
var getEquivalence83 = (isEquivalent) => make173((x43, y43) => x43 === y43 || (isNone243(x43) ? isNone243(y43) : isNone243(y43) ? false : isEquivalent(x43.value, y43.value)));
var getOrder73 = (O43) => make243((self2, that) => isSome243(self2) ? isSome243(that) ? O43(self2.value, that.value) : 1 : -1);
var lift263 = (f43) => dual63(2, (self2, that) => zipWith73(self2, that, f43));
var liftPredicate73 = (predicate) => (b43) => predicate(b43) ? some343(b43) : none243();
var containsWith73 = (isEquivalent) => dual63(2, (self2, a43) => isNone243(self2) ? false : isEquivalent(self2.value, a43));
var _equivalence83 = /* @__PURE__ */ equivalence63();
var contains73 = /* @__PURE__ */ containsWith73(_equivalence83);
var exists63 = /* @__PURE__ */ dual63(2, (self2, refinement) => isNone243(self2) ? false : refinement(self2.value));
var bindTo243 = /* @__PURE__ */ bindTo103(map73);
var let_243 = /* @__PURE__ */ let_103(map73);
var bind243 = /* @__PURE__ */ bind103(map73, flatMap73);
var Do73 = /* @__PURE__ */ some343({});
var adapter243 = /* @__PURE__ */ adapter93();
var gen63 = (f43) => {
  const iterator = f43(adapter243);
  let state = iterator.next();
  if (state.done) {
    return some343(state.value);
  } else {
    let current = state.value;
    if (isGenKind63(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet63(current);
    }
    if (isNone243(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind63(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet63(current);
        }
        if (isNone243(current)) {
          return current;
        }
      }
    }
    return some343(state.value);
  }
};
var fromIterable243 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var reverse63 = (self2) => Array.from(self2).reverse();
var reduce73 = /* @__PURE__ */ dual63(3, (self2, b43, f43) => fromIterable243(self2).reduce((b232, a43, i43) => f43(b232, a43, i43), b43));
var TagTypeId43 = /* @__PURE__ */ Symbol.for("effect/Context/Tag");
var STMSymbolKey43 = "effect/STM";
var STMTypeId43 = /* @__PURE__ */ Symbol.for(STMSymbolKey43);
var TagProto43 = {
  ...EffectPrototype63,
  _tag: "Tag",
  _op: "Tag",
  [STMTypeId43]: effectVariance63,
  [TagTypeId43]: {
    _Service: (_43) => _43,
    _Identifier: (_43) => _43
  },
  toString() {
    return format63(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Tag",
      key: this.key,
      stack: this.stack
    };
  },
  [NodeInspectSymbol63]() {
    return this.toJSON();
  },
  of(self2) {
    return self2;
  },
  context(self2) {
    return make343(this, self2);
  }
};
var makeGenericTag43 = (key) => {
  const limit = Error.stackTraceLimit;
  Error.stackTraceLimit = 2;
  const creationError = new Error();
  Error.stackTraceLimit = limit;
  const tag = Object.create(TagProto43);
  Object.defineProperty(tag, "stack", {
    get() {
      return creationError.stack;
    }
  });
  tag.key = key;
  return tag;
};
var TypeId443 = /* @__PURE__ */ Symbol.for("effect/Context");
var ContextProto43 = {
  [TypeId443]: {
    _Services: (_43) => _43
  },
  [symbol243](that) {
    if (isContext43(that)) {
      if (this.unsafeMap.size === that.unsafeMap.size) {
        for (const k43 of this.unsafeMap.keys()) {
          if (!that.unsafeMap.has(k43) || !equals63(this.unsafeMap.get(k43), that.unsafeMap.get(k43))) {
            return false;
          }
        }
        return true;
      }
    }
    return false;
  },
  [symbol93]() {
    return cached63(this, number73(this.unsafeMap.size));
  },
  pipe() {
    return pipeArguments63(this, arguments);
  },
  toString() {
    return format63(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Context",
      services: Array.from(this.unsafeMap).map(toJSON63)
    };
  },
  [NodeInspectSymbol63]() {
    return this.toJSON();
  }
};
var makeContext43 = (unsafeMap) => {
  const context = Object.create(ContextProto43);
  context.unsafeMap = unsafeMap;
  return context;
};
var isContext43 = (u43) => hasProperty63(u43, TypeId443);
var _empty83 = /* @__PURE__ */ makeContext43(/* @__PURE__ */ new Map());
var empty133 = () => _empty83;
var make343 = (tag, service) => makeContext43(/* @__PURE__ */ new Map([[tag.key, service]]));
var GenericTag43 = makeGenericTag43;
var empty243 = empty133;
var TypeId543 = /* @__PURE__ */ Symbol.for("effect/Chunk");
function copy53(src, srcPos, dest, destPos, len) {
  for (let i43 = srcPos; i43 < Math.min(src.length, srcPos + len); i43++) {
    dest[destPos + i43 - srcPos] = src[i43];
  }
  return dest;
}
var emptyArray43 = [];
var getEquivalence243 = (isEquivalent) => make173((self2, that) => self2.length === that.length && toReadonlyArray43(self2).every((value, i43) => isEquivalent(value, unsafeGet243(that, i43))));
var _equivalence243 = /* @__PURE__ */ getEquivalence243(equals63);
var ChunkProto43 = {
  [TypeId543]: {
    _A: (_43) => _43
  },
  toString() {
    return format63(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Chunk",
      values: toReadonlyArray43(this).map(toJSON63)
    };
  },
  [NodeInspectSymbol63]() {
    return this.toJSON();
  },
  [symbol243](that) {
    return isChunk43(that) && _equivalence243(this, that);
  },
  [symbol93]() {
    return cached63(this, array93(toReadonlyArray43(this)));
  },
  [Symbol.iterator]() {
    switch (this.backing._tag) {
      case "IArray": {
        return this.backing.array[Symbol.iterator]();
      }
      case "IEmpty": {
        return emptyArray43[Symbol.iterator]();
      }
      default: {
        return toReadonlyArray43(this)[Symbol.iterator]();
      }
    }
  },
  pipe() {
    return pipeArguments63(this, arguments);
  }
};
var makeChunk43 = (backing) => {
  const chunk = Object.create(ChunkProto43);
  chunk.backing = backing;
  switch (backing._tag) {
    case "IEmpty": {
      chunk.length = 0;
      chunk.depth = 0;
      chunk.left = chunk;
      chunk.right = chunk;
      break;
    }
    case "IConcat": {
      chunk.length = backing.left.length + backing.right.length;
      chunk.depth = 1 + Math.max(backing.left.depth, backing.right.depth);
      chunk.left = backing.left;
      chunk.right = backing.right;
      break;
    }
    case "IArray": {
      chunk.length = backing.array.length;
      chunk.depth = 0;
      chunk.left = _empty243;
      chunk.right = _empty243;
      break;
    }
    case "ISingleton": {
      chunk.length = 1;
      chunk.depth = 0;
      chunk.left = _empty243;
      chunk.right = _empty243;
      break;
    }
    case "ISlice": {
      chunk.length = backing.length;
      chunk.depth = backing.chunk.depth + 1;
      chunk.left = _empty243;
      chunk.right = _empty243;
      break;
    }
  }
  return chunk;
};
var isChunk43 = (u43) => hasProperty63(u43, TypeId543);
var _empty243 = /* @__PURE__ */ makeChunk43({
  _tag: "IEmpty"
});
var empty343 = () => _empty243;
var make443 = (...as253) => as253.length === 1 ? of53(as253[0]) : unsafeFromNonEmptyArray43(as253);
var of53 = (a43) => makeChunk43({
  _tag: "ISingleton",
  a: a43
});
var copyToArray43 = (self2, array334, initial) => {
  switch (self2.backing._tag) {
    case "IArray": {
      copy53(self2.backing.array, 0, array334, initial, self2.length);
      break;
    }
    case "IConcat": {
      copyToArray43(self2.left, array334, initial);
      copyToArray43(self2.right, array334, initial + self2.left.length);
      break;
    }
    case "ISingleton": {
      array334[initial] = self2.backing.a;
      break;
    }
    case "ISlice": {
      let i43 = 0;
      let j43 = initial;
      while (i43 < self2.length) {
        array334[j43] = unsafeGet243(self2, i43);
        i43 += 1;
        j43 += 1;
      }
      break;
    }
  }
};
var toReadonlyArray43 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      return emptyArray43;
    }
    case "IArray": {
      return self2.backing.array;
    }
    default: {
      const arr = new Array(self2.length);
      copyToArray43(self2, arr, 0);
      self2.backing = {
        _tag: "IArray",
        array: arr
      };
      self2.left = _empty243;
      self2.right = _empty243;
      self2.depth = 0;
      return arr;
    }
  }
};
var reverse243 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty":
    case "ISingleton":
      return self2;
    case "IArray": {
      return makeChunk43({
        _tag: "IArray",
        array: reverse63(self2.backing.array)
      });
    }
    case "IConcat": {
      return makeChunk43({
        _tag: "IConcat",
        left: reverse243(self2.backing.right),
        right: reverse243(self2.backing.left)
      });
    }
    case "ISlice":
      return unsafeFromArray43(reverse63(toReadonlyArray43(self2)));
  }
};
var unsafeFromArray43 = (self2) => makeChunk43({
  _tag: "IArray",
  array: self2
});
var unsafeFromNonEmptyArray43 = (self2) => unsafeFromArray43(self2);
var unsafeGet243 = /* @__PURE__ */ dual63(2, (self2, index) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      throw new Error(`Index out of bounds`);
    }
    case "ISingleton": {
      if (index !== 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.a;
    }
    case "IArray": {
      if (index >= self2.length || index < 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.array[index];
    }
    case "IConcat": {
      return index < self2.left.length ? unsafeGet243(self2.left, index) : unsafeGet243(self2.right, index - self2.left.length);
    }
    case "ISlice": {
      return unsafeGet243(self2.backing.chunk, index + self2.backing.offset);
    }
  }
});
var prepend63 = /* @__PURE__ */ dual63(2, (self2, elem) => appendAll53(of53(elem), self2));
var drop53 = /* @__PURE__ */ dual63(2, (self2, n43) => {
  if (n43 <= 0) {
    return self2;
  } else if (n43 >= self2.length) {
    return _empty243;
  } else {
    switch (self2.backing._tag) {
      case "ISlice": {
        return makeChunk43({
          _tag: "ISlice",
          chunk: self2.backing.chunk,
          offset: self2.backing.offset + n43,
          length: self2.backing.length - n43
        });
      }
      case "IConcat": {
        if (n43 > self2.left.length) {
          return drop53(self2.right, n43 - self2.left.length);
        }
        return makeChunk43({
          _tag: "IConcat",
          left: drop53(self2.left, n43),
          right: self2.right
        });
      }
      default: {
        return makeChunk43({
          _tag: "ISlice",
          chunk: self2,
          offset: n43,
          length: self2.length - n43
        });
      }
    }
  }
});
var appendAll53 = /* @__PURE__ */ dual63(2, (self2, that) => {
  if (self2.backing._tag === "IEmpty") {
    return that;
  }
  if (that.backing._tag === "IEmpty") {
    return self2;
  }
  const diff234 = that.depth - self2.depth;
  if (Math.abs(diff234) <= 1) {
    return makeChunk43({
      _tag: "IConcat",
      left: self2,
      right: that
    });
  } else if (diff234 < -1) {
    if (self2.left.depth >= self2.right.depth) {
      const nr = appendAll53(self2.right, that);
      return makeChunk43({
        _tag: "IConcat",
        left: self2.left,
        right: nr
      });
    } else {
      const nrr = appendAll53(self2.right.right, that);
      if (nrr.depth === self2.depth - 3) {
        const nr = makeChunk43({
          _tag: "IConcat",
          left: self2.right.left,
          right: nrr
        });
        return makeChunk43({
          _tag: "IConcat",
          left: self2.left,
          right: nr
        });
      } else {
        const nl = makeChunk43({
          _tag: "IConcat",
          left: self2.left,
          right: self2.right.left
        });
        return makeChunk43({
          _tag: "IConcat",
          left: nl,
          right: nrr
        });
      }
    }
  } else {
    if (that.right.depth >= that.left.depth) {
      const nl = appendAll53(self2, that.left);
      return makeChunk43({
        _tag: "IConcat",
        left: nl,
        right: that.right
      });
    } else {
      const nll = appendAll53(self2, that.left.left);
      if (nll.depth === that.depth - 3) {
        const nl = makeChunk43({
          _tag: "IConcat",
          left: nll,
          right: that.left.right
        });
        return makeChunk43({
          _tag: "IConcat",
          left: nl,
          right: that.right
        });
      } else {
        const nr = makeChunk43({
          _tag: "IConcat",
          left: that.left.right,
          right: that.right
        });
        return makeChunk43({
          _tag: "IConcat",
          left: nll,
          right: nr
        });
      }
    }
  }
});
var isEmpty53 = (self2) => self2.length === 0;
var isNonEmpty43 = (self2) => self2.length > 0;
var unsafeHead43 = (self2) => unsafeGet243(self2, 0);
var headNonEmpty53 = unsafeHead43;
var tailNonEmpty53 = (self2) => drop53(self2, 1);
var SIZE43 = 5;
var BUCKET_SIZE43 = /* @__PURE__ */ Math.pow(2, SIZE43);
var MASK43 = BUCKET_SIZE43 - 1;
var MAX_INDEX_NODE43 = BUCKET_SIZE43 / 2;
var MIN_ARRAY_NODE43 = BUCKET_SIZE43 / 4;
function popcount43(x43) {
  x43 -= x43 >> 1 & 1431655765;
  x43 = (x43 & 858993459) + (x43 >> 2 & 858993459);
  x43 = x43 + (x43 >> 4) & 252645135;
  x43 += x43 >> 8;
  x43 += x43 >> 16;
  return x43 & 127;
}
function hashFragment43(shift22, h43) {
  return h43 >>> shift22 & MASK43;
}
function toBitmap43(x43) {
  return 1 << x43;
}
function fromBitmap43(bitmap, bit) {
  return popcount43(bitmap & bit - 1);
}
var make543 = (value, previous) => ({
  value,
  previous
});
function arrayUpdate43(mutate234, at, v43, arr) {
  let out = arr;
  if (!mutate234) {
    const len = arr.length;
    out = new Array(len);
    for (let i43 = 0; i43 < len; ++i43) out[i43] = arr[i43];
  }
  out[at] = v43;
  return out;
}
function arraySpliceOut43(mutate234, at, arr) {
  const newLen = arr.length - 1;
  let i43 = 0;
  let g43 = 0;
  let out = arr;
  if (mutate234) {
    i43 = g43 = at;
  } else {
    out = new Array(newLen);
    while (i43 < at) out[g43++] = arr[i43++];
  }
  ++i43;
  while (i43 <= newLen) out[g43++] = arr[i43++];
  if (mutate234) {
    out.length = newLen;
  }
  return out;
}
function arraySpliceIn43(mutate234, at, v43, arr) {
  const len = arr.length;
  if (mutate234) {
    let i232 = len;
    while (i232 >= at) arr[i232--] = arr[i232];
    arr[at] = v43;
    return arr;
  }
  let i43 = 0, g43 = 0;
  const out = new Array(len + 1);
  while (i43 < at) out[g43++] = arr[i43++];
  out[at] = v43;
  while (i43 < len) out[++g43] = arr[i43++];
  return out;
}
var EmptyNode43 = class _EmptyNode43 {
  _tag = "EmptyNode";
  modify(edit, _shift, f43, hash253, key, size434) {
    const v43 = f43(none243());
    if (isNone243(v43)) return new _EmptyNode43();
    ++size434.value;
    return new LeafNode43(edit, hash253, key, v43);
  }
};
function isEmptyNode43(a43) {
  return isTagged63(a43, "EmptyNode");
}
function isLeafNode43(node) {
  return isEmptyNode43(node) || node._tag === "LeafNode" || node._tag === "CollisionNode";
}
function canEditNode43(node, edit) {
  return isEmptyNode43(node) ? false : edit === node.edit;
}
var LeafNode43 = class _LeafNode43 {
  edit;
  hash;
  key;
  value;
  _tag = "LeafNode";
  constructor(edit, hash253, key, value) {
    this.edit = edit;
    this.hash = hash253;
    this.key = key;
    this.value = value;
  }
  modify(edit, shift22, f43, hash253, key, size434) {
    if (equals63(key, this.key)) {
      const v232 = f43(this.value);
      if (v232 === this.value) return this;
      else if (isNone243(v232)) {
        --size434.value;
        return new EmptyNode43();
      }
      if (canEditNode43(this, edit)) {
        this.value = v232;
        return this;
      }
      return new _LeafNode43(edit, hash253, key, v232);
    }
    const v43 = f43(none243());
    if (isNone243(v43)) return this;
    ++size434.value;
    return mergeLeaves43(edit, shift22, this.hash, this, hash253, new _LeafNode43(edit, hash253, key, v43));
  }
};
var CollisionNode43 = class _CollisionNode43 {
  edit;
  hash;
  children;
  _tag = "CollisionNode";
  constructor(edit, hash253, children) {
    this.edit = edit;
    this.hash = hash253;
    this.children = children;
  }
  modify(edit, shift22, f43, hash253, key, size434) {
    if (hash253 === this.hash) {
      const canEdit = canEditNode43(this, edit);
      const list = this.updateCollisionList(canEdit, edit, this.hash, this.children, f43, key, size434);
      if (list === this.children) return this;
      return list.length > 1 ? new _CollisionNode43(edit, this.hash, list) : list[0];
    }
    const v43 = f43(none243());
    if (isNone243(v43)) return this;
    ++size434.value;
    return mergeLeaves43(edit, shift22, this.hash, this, hash253, new LeafNode43(edit, hash253, key, v43));
  }
  updateCollisionList(mutate234, edit, hash253, list, f43, key, size434) {
    const len = list.length;
    for (let i43 = 0; i43 < len; ++i43) {
      const child = list[i43];
      if ("key" in child && equals63(key, child.key)) {
        const value = child.value;
        const newValue2 = f43(value);
        if (newValue2 === value) return list;
        if (isNone243(newValue2)) {
          --size434.value;
          return arraySpliceOut43(mutate234, i43, list);
        }
        return arrayUpdate43(mutate234, i43, new LeafNode43(edit, hash253, key, newValue2), list);
      }
    }
    const newValue = f43(none243());
    if (isNone243(newValue)) return list;
    ++size434.value;
    return arrayUpdate43(mutate234, len, new LeafNode43(edit, hash253, key, newValue), list);
  }
};
var IndexedNode43 = class _IndexedNode43 {
  edit;
  mask;
  children;
  _tag = "IndexedNode";
  constructor(edit, mask, children) {
    this.edit = edit;
    this.mask = mask;
    this.children = children;
  }
  modify(edit, shift22, f43, hash253, key, size434) {
    const mask = this.mask;
    const children = this.children;
    const frag = hashFragment43(shift22, hash253);
    const bit = toBitmap43(frag);
    const indx = fromBitmap43(mask, bit);
    const exists253 = mask & bit;
    const canEdit = canEditNode43(this, edit);
    if (!exists253) {
      const _newChild = new EmptyNode43().modify(edit, shift22 + SIZE43, f43, hash253, key, size434);
      if (!_newChild) return this;
      return children.length >= MAX_INDEX_NODE43 ? expand43(edit, frag, _newChild, mask, children) : new _IndexedNode43(edit, mask | bit, arraySpliceIn43(canEdit, indx, _newChild, children));
    }
    const current = children[indx];
    const child = current.modify(edit, shift22 + SIZE43, f43, hash253, key, size434);
    if (current === child) return this;
    let bitmap = mask;
    let newChildren;
    if (isEmptyNode43(child)) {
      bitmap &= ~bit;
      if (!bitmap) return new EmptyNode43();
      if (children.length <= 2 && isLeafNode43(children[indx ^ 1])) {
        return children[indx ^ 1];
      }
      newChildren = arraySpliceOut43(canEdit, indx, children);
    } else {
      newChildren = arrayUpdate43(canEdit, indx, child, children);
    }
    if (canEdit) {
      this.mask = bitmap;
      this.children = newChildren;
      return this;
    }
    return new _IndexedNode43(edit, bitmap, newChildren);
  }
};
var ArrayNode43 = class _ArrayNode43 {
  edit;
  size;
  children;
  _tag = "ArrayNode";
  constructor(edit, size434, children) {
    this.edit = edit;
    this.size = size434;
    this.children = children;
  }
  modify(edit, shift22, f43, hash253, key, size434) {
    let count = this.size;
    const children = this.children;
    const frag = hashFragment43(shift22, hash253);
    const child = children[frag];
    const newChild = (child || new EmptyNode43()).modify(edit, shift22 + SIZE43, f43, hash253, key, size434);
    if (child === newChild) return this;
    const canEdit = canEditNode43(this, edit);
    let newChildren;
    if (isEmptyNode43(child) && !isEmptyNode43(newChild)) {
      ++count;
      newChildren = arrayUpdate43(canEdit, frag, newChild, children);
    } else if (!isEmptyNode43(child) && isEmptyNode43(newChild)) {
      --count;
      if (count <= MIN_ARRAY_NODE43) {
        return pack43(edit, count, frag, children);
      }
      newChildren = arrayUpdate43(canEdit, frag, new EmptyNode43(), children);
    } else {
      newChildren = arrayUpdate43(canEdit, frag, newChild, children);
    }
    if (canEdit) {
      this.size = count;
      this.children = newChildren;
      return this;
    }
    return new _ArrayNode43(edit, count, newChildren);
  }
};
function pack43(edit, count, removed, elements) {
  const children = new Array(count - 1);
  let g43 = 0;
  let bitmap = 0;
  for (let i43 = 0, len = elements.length; i43 < len; ++i43) {
    if (i43 !== removed) {
      const elem = elements[i43];
      if (elem && !isEmptyNode43(elem)) {
        children[g43++] = elem;
        bitmap |= 1 << i43;
      }
    }
  }
  return new IndexedNode43(edit, bitmap, children);
}
function expand43(edit, frag, child, bitmap, subNodes) {
  const arr = [];
  let bit = bitmap;
  let count = 0;
  for (let i43 = 0; bit; ++i43) {
    if (bit & 1) arr[i43] = subNodes[count++];
    bit >>>= 1;
  }
  arr[frag] = child;
  return new ArrayNode43(edit, count + 1, arr);
}
function mergeLeavesInner43(edit, shift22, h1, n1, h232, n232) {
  if (h1 === h232) return new CollisionNode43(edit, h1, [n232, n1]);
  const subH1 = hashFragment43(shift22, h1);
  const subH2 = hashFragment43(shift22, h232);
  if (subH1 === subH2) {
    return (child) => new IndexedNode43(edit, toBitmap43(subH1) | toBitmap43(subH2), [child]);
  } else {
    const children = subH1 < subH2 ? [n1, n232] : [n232, n1];
    return new IndexedNode43(edit, toBitmap43(subH1) | toBitmap43(subH2), children);
  }
}
function mergeLeaves43(edit, shift22, h1, n1, h232, n232) {
  let stack = void 0;
  let currentShift = shift22;
  while (true) {
    const res = mergeLeavesInner43(edit, currentShift, h1, n1, h232, n232);
    if (typeof res === "function") {
      stack = make543(res, stack);
      currentShift = currentShift + SIZE43;
    } else {
      let final = res;
      while (stack != null) {
        final = stack.value(final);
        stack = stack.previous;
      }
      return final;
    }
  }
}
var HashMapSymbolKey43 = "effect/HashMap";
var HashMapTypeId43 = /* @__PURE__ */ Symbol.for(HashMapSymbolKey43);
var HashMapProto43 = {
  [HashMapTypeId43]: HashMapTypeId43,
  [Symbol.iterator]() {
    return new HashMapIterator43(this, (k43, v43) => [k43, v43]);
  },
  [symbol93]() {
    let hash253 = hash63(HashMapSymbolKey43);
    for (const item of this) {
      hash253 ^= pipe63(hash63(item[0]), combine73(hash63(item[1])));
    }
    return cached63(this, hash253);
  },
  [symbol243](that) {
    if (isHashMap43(that)) {
      if (that._size !== this._size) {
        return false;
      }
      for (const item of this) {
        const elem = pipe63(that, getHash43(item[0], hash63(item[0])));
        if (isNone243(elem)) {
          return false;
        } else {
          if (!equals63(item[1], elem.value)) {
            return false;
          }
        }
      }
      return true;
    }
    return false;
  },
  toString() {
    return format63(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashMap",
      values: Array.from(this).map(toJSON63)
    };
  },
  [NodeInspectSymbol63]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments63(this, arguments);
  }
};
var makeImpl53 = (editable, edit, root, size434) => {
  const map622 = Object.create(HashMapProto43);
  map622._editable = editable;
  map622._edit = edit;
  map622._root = root;
  map622._size = size434;
  return map622;
};
var HashMapIterator43 = class _HashMapIterator43 {
  map;
  f;
  v;
  constructor(map622, f43) {
    this.map = map622;
    this.f = f43;
    this.v = visitLazy43(this.map._root, this.f, void 0);
  }
  next() {
    if (isNone243(this.v)) {
      return {
        done: true,
        value: void 0
      };
    }
    const v0 = this.v.value;
    this.v = applyCont43(v0.cont);
    return {
      done: false,
      value: v0.value
    };
  }
  [Symbol.iterator]() {
    return new _HashMapIterator43(this.map, this.f);
  }
};
var applyCont43 = (cont) => cont ? visitLazyChildren43(cont[0], cont[1], cont[2], cont[3], cont[4]) : none243();
var visitLazy43 = (node, f43, cont = void 0) => {
  switch (node._tag) {
    case "LeafNode": {
      if (isSome243(node.value)) {
        return some343({
          value: f43(node.key, node.value.value),
          cont
        });
      }
      return applyCont43(cont);
    }
    case "CollisionNode":
    case "ArrayNode":
    case "IndexedNode": {
      const children = node.children;
      return visitLazyChildren43(children.length, children, 0, f43, cont);
    }
    default: {
      return applyCont43(cont);
    }
  }
};
var visitLazyChildren43 = (len, children, i43, f43, cont) => {
  while (i43 < len) {
    const child = children[i43++];
    if (child && !isEmptyNode43(child)) {
      return visitLazy43(child, f43, [len, children, i43, f43, cont]);
    }
  }
  return applyCont43(cont);
};
var _empty343 = /* @__PURE__ */ makeImpl53(false, 0, /* @__PURE__ */ new EmptyNode43(), 0);
var empty443 = () => _empty343;
var isHashMap43 = (u43) => hasProperty63(u43, HashMapTypeId43);
var getHash43 = /* @__PURE__ */ dual63(3, (self2, key, hash253) => {
  let node = self2._root;
  let shift22 = 0;
  while (true) {
    switch (node._tag) {
      case "LeafNode": {
        return equals63(key, node.key) ? node.value : none243();
      }
      case "CollisionNode": {
        if (hash253 === node.hash) {
          const children = node.children;
          for (let i43 = 0, len = children.length; i43 < len; ++i43) {
            const child = children[i43];
            if ("key" in child && equals63(key, child.key)) {
              return child.value;
            }
          }
        }
        return none243();
      }
      case "IndexedNode": {
        const frag = hashFragment43(shift22, hash253);
        const bit = toBitmap43(frag);
        if (node.mask & bit) {
          node = node.children[fromBitmap43(node.mask, bit)];
          shift22 += SIZE43;
          break;
        }
        return none243();
      }
      case "ArrayNode": {
        node = node.children[hashFragment43(shift22, hash253)];
        if (node) {
          shift22 += SIZE43;
          break;
        }
        return none243();
      }
      default:
        return none243();
    }
  }
});
var set53 = /* @__PURE__ */ dual63(3, (self2, key, value) => modifyAt43(self2, key, () => some343(value)));
var setTree43 = /* @__PURE__ */ dual63(3, (self2, newRoot, newSize) => {
  if (self2._editable) {
    self2._root = newRoot;
    self2._size = newSize;
    return self2;
  }
  return newRoot === self2._root ? self2 : makeImpl53(self2._editable, self2._edit, newRoot, newSize);
});
var keys53 = (self2) => new HashMapIterator43(self2, (key) => key);
var size63 = (self2) => self2._size;
var beginMutation53 = (self2) => makeImpl53(true, self2._edit + 1, self2._root, self2._size);
var modifyAt43 = /* @__PURE__ */ dual63(3, (self2, key, f43) => modifyHash43(self2, key, hash63(key), f43));
var modifyHash43 = /* @__PURE__ */ dual63(4, (self2, key, hash253, f43) => {
  const size434 = {
    value: self2._size
  };
  const newRoot = self2._root.modify(self2._editable ? self2._edit : NaN, 0, f43, hash253, key, size434);
  return pipe63(self2, setTree43(newRoot, size434.value));
});
var forEach73 = /* @__PURE__ */ dual63(2, (self2, f43) => reduce243(self2, void 0, (_43, value, key) => f43(value, key)));
var reduce243 = /* @__PURE__ */ dual63(3, (self2, zero, f43) => {
  const root = self2._root;
  if (root._tag === "LeafNode") {
    return isSome243(root.value) ? f43(zero, root.value.value, root.key) : zero;
  }
  if (root._tag === "EmptyNode") {
    return zero;
  }
  const toVisit = [root.children];
  let children;
  while (children = toVisit.pop()) {
    for (let i43 = 0, len = children.length; i43 < len; ) {
      const child = children[i43++];
      if (child && !isEmptyNode43(child)) {
        if (child._tag === "LeafNode") {
          if (isSome243(child.value)) {
            zero = f43(zero, child.value.value, child.key);
          }
        } else {
          toVisit.push(child.children);
        }
      }
    }
  }
  return zero;
});
var HashSetSymbolKey43 = "effect/HashSet";
var HashSetTypeId43 = /* @__PURE__ */ Symbol.for(HashSetSymbolKey43);
var HashSetProto43 = {
  [HashSetTypeId43]: HashSetTypeId43,
  [Symbol.iterator]() {
    return keys53(this._keyMap);
  },
  [symbol93]() {
    return cached63(this, combine73(hash63(this._keyMap))(hash63(HashSetSymbolKey43)));
  },
  [symbol243](that) {
    if (isHashSet43(that)) {
      return size63(this._keyMap) === size63(that._keyMap) && equals63(this._keyMap, that._keyMap);
    }
    return false;
  },
  toString() {
    return format63(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashSet",
      values: Array.from(this).map(toJSON63)
    };
  },
  [NodeInspectSymbol63]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments63(this, arguments);
  }
};
var makeImpl243 = (keyMap) => {
  const set253 = Object.create(HashSetProto43);
  set253._keyMap = keyMap;
  return set253;
};
var isHashSet43 = (u43) => hasProperty63(u43, HashSetTypeId43);
var _empty443 = /* @__PURE__ */ makeImpl243(/* @__PURE__ */ empty443());
var empty543 = () => _empty443;
var size243 = (self2) => size63(self2._keyMap);
var beginMutation243 = (self2) => makeImpl243(beginMutation53(self2._keyMap));
var endMutation43 = (self2) => {
  self2._keyMap._editable = false;
  return self2;
};
var mutate43 = /* @__PURE__ */ dual63(2, (self2, f43) => {
  const transient = beginMutation243(self2);
  f43(transient);
  return endMutation43(transient);
});
var add243 = /* @__PURE__ */ dual63(2, (self2, value) => self2._keyMap._editable ? (set53(value, true)(self2._keyMap), self2) : makeImpl243(set53(value, true)(self2._keyMap)));
var union243 = /* @__PURE__ */ dual63(2, (self2, that) => mutate43(empty543(), (set253) => {
  forEach243(self2, (value) => add243(set253, value));
  for (const value of that) {
    add243(set253, value);
  }
}));
var forEach243 = /* @__PURE__ */ dual63(2, (self2, f43) => forEach73(self2._keyMap, (_43, k43) => f43(k43)));
var empty643 = empty543;
var size343 = size243;
var add343 = add243;
var union343 = union243;
var ArrayProto43 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(Array.prototype), {
  [symbol93]() {
    return cached63(this, array93(this));
  },
  [symbol243](that) {
    if (Array.isArray(that) && this.length === that.length) {
      return this.every((v43, i43) => equals63(v43, that[i43]));
    } else {
      return false;
    }
  }
});
var Structural53 = /* @__PURE__ */ function() {
  function Structural334(args) {
    if (args) {
      Object.assign(this, args);
    }
  }
  Structural334.prototype = StructuralPrototype33;
  return Structural334;
}();
var struct243 = (as253) => Object.assign(Object.create(StructuralPrototype33), as253);
var ContextPatchTypeId43 = /* @__PURE__ */ Symbol.for("effect/DifferContextPatch");
function variance53(a43) {
  return a43;
}
var PatchProto43 = {
  ...Structural53.prototype,
  [ContextPatchTypeId43]: {
    _Value: variance53,
    _Patch: variance53
  }
};
var EmptyProto43 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto43), {
  _tag: "Empty"
});
var _empty543 = /* @__PURE__ */ Object.create(EmptyProto43);
var empty743 = () => _empty543;
var AndThenProto43 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto43), {
  _tag: "AndThen"
});
var makeAndThen43 = (first, second) => {
  const o43 = Object.create(AndThenProto43);
  o43.first = first;
  o43.second = second;
  return o43;
};
var AddServiceProto43 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto43), {
  _tag: "AddService"
});
var makeAddService43 = (key, service) => {
  const o43 = Object.create(AddServiceProto43);
  o43.key = key;
  o43.service = service;
  return o43;
};
var RemoveServiceProto43 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto43), {
  _tag: "RemoveService"
});
var makeRemoveService43 = (key) => {
  const o43 = Object.create(RemoveServiceProto43);
  o43.key = key;
  return o43;
};
var UpdateServiceProto43 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto43), {
  _tag: "UpdateService"
});
var makeUpdateService43 = (key, update222) => {
  const o43 = Object.create(UpdateServiceProto43);
  o43.key = key;
  o43.update = update222;
  return o43;
};
var diff43 = (oldValue, newValue) => {
  const missingServices = new Map(oldValue.unsafeMap);
  let patch234 = empty743();
  for (const [tag, newService] of newValue.unsafeMap.entries()) {
    if (missingServices.has(tag)) {
      const old = missingServices.get(tag);
      missingServices.delete(tag);
      if (!equals63(old, newService)) {
        patch234 = combine243(makeUpdateService43(tag, () => newService))(patch234);
      }
    } else {
      missingServices.delete(tag);
      patch234 = combine243(makeAddService43(tag, newService))(patch234);
    }
  }
  for (const [tag] of missingServices.entries()) {
    patch234 = combine243(makeRemoveService43(tag))(patch234);
  }
  return patch234;
};
var combine243 = /* @__PURE__ */ dual63(2, (self2, that) => makeAndThen43(self2, that));
var patch43 = /* @__PURE__ */ dual63(2, (self2, context) => {
  if (self2._tag === "Empty") {
    return context;
  }
  let wasServiceUpdated = false;
  let patches = of53(self2);
  const updatedContext = new Map(context.unsafeMap);
  while (isNonEmpty43(patches)) {
    const head222 = headNonEmpty53(patches);
    const tail34 = tailNonEmpty53(patches);
    switch (head222._tag) {
      case "Empty": {
        patches = tail34;
        break;
      }
      case "AddService": {
        updatedContext.set(head222.key, head222.service);
        patches = tail34;
        break;
      }
      case "AndThen": {
        patches = prepend63(prepend63(tail34, head222.second), head222.first);
        break;
      }
      case "RemoveService": {
        updatedContext.delete(head222.key);
        patches = tail34;
        break;
      }
      case "UpdateService": {
        updatedContext.set(head222.key, head222.update(updatedContext.get(head222.key)));
        wasServiceUpdated = true;
        patches = tail34;
        break;
      }
    }
  }
  if (!wasServiceUpdated) {
    return makeContext43(updatedContext);
  }
  const map622 = /* @__PURE__ */ new Map();
  for (const [tag] of context.unsafeMap) {
    if (updatedContext.has(tag)) {
      map622.set(tag, updatedContext.get(tag));
      updatedContext.delete(tag);
    }
  }
  for (const [tag, s43] of updatedContext) {
    map622.set(tag, s43);
  }
  return makeContext43(map622);
});
var DifferTypeId43 = /* @__PURE__ */ Symbol.for("effect/Differ");
var DifferProto43 = {
  [DifferTypeId43]: {
    _P: identity63,
    _V: identity63
  }
};
var make743 = (params) => {
  const differ = Object.create(DifferProto43);
  differ.empty = params.empty;
  differ.diff = params.diff;
  differ.combine = params.combine;
  differ.patch = params.patch;
  return differ;
};
var environment43 = () => make743({
  empty: empty743(),
  combine: (first, second) => combine243(second)(first),
  diff: (oldValue, newValue) => diff43(oldValue, newValue),
  patch: (patch234, oldValue) => patch43(oldValue)(patch234)
});
var OP_DIE43 = "Die";
var OP_EMPTY43 = "Empty";
var OP_FAIL43 = "Fail";
var OP_INTERRUPT43 = "Interrupt";
var OP_PARALLEL43 = "Parallel";
var OP_SEQUENTIAL43 = "Sequential";
var CauseSymbolKey43 = "effect/Cause";
var CauseTypeId43 = /* @__PURE__ */ Symbol.for(CauseSymbolKey43);
var variance243 = {
  /* c8 ignore next */
  _E: (_43) => _43
};
var proto43 = {
  [CauseTypeId43]: variance243,
  [symbol93]() {
    return pipe63(hash63(CauseSymbolKey43), combine73(hash63(flattenCause43(this))), cached63(this));
  },
  [symbol243](that) {
    return isCause43(that) && causeEquals43(this, that);
  },
  pipe() {
    return pipeArguments63(this, arguments);
  },
  toJSON() {
    switch (this._tag) {
      case "Empty":
        return {
          _id: "Cause",
          _tag: this._tag
        };
      case "Die":
        return {
          _id: "Cause",
          _tag: this._tag,
          defect: toJSON63(this.defect)
        };
      case "Interrupt":
        return {
          _id: "Cause",
          _tag: this._tag,
          fiberId: this.fiberId.toJSON()
        };
      case "Fail":
        return {
          _id: "Cause",
          _tag: this._tag,
          failure: toJSON63(this.error)
        };
      case "Sequential":
      case "Parallel":
        return {
          _id: "Cause",
          _tag: this._tag,
          left: toJSON63(this.left),
          right: toJSON63(this.right)
        };
    }
  },
  toString() {
    return pretty43(this);
  },
  [NodeInspectSymbol63]() {
    return this.toJSON();
  }
};
var fail53 = (error) => {
  const o43 = Object.create(proto43);
  o43._tag = OP_FAIL43;
  o43.error = error;
  return o43;
};
var parallel43 = (left334, right334) => {
  const o43 = Object.create(proto43);
  o43._tag = OP_PARALLEL43;
  o43.left = left334;
  o43.right = right334;
  return o43;
};
var sequential43 = (left334, right334) => {
  const o43 = Object.create(proto43);
  o43._tag = OP_SEQUENTIAL43;
  o43.left = left334;
  o43.right = right334;
  return o43;
};
var isCause43 = (u43) => hasProperty63(u43, CauseTypeId43);
var isInterruptedOnly43 = (self2) => reduceWithContext43(void 0, IsInterruptedOnlyCauseReducer43)(self2);
var causeEquals43 = (left334, right334) => {
  let leftStack = of53(left334);
  let rightStack = of53(right334);
  while (isNonEmpty43(leftStack) && isNonEmpty43(rightStack)) {
    const [leftParallel, leftSequential] = pipe63(headNonEmpty53(leftStack), reduce443([empty643(), empty343()], ([parallel234, sequential234], cause) => {
      const [par, seq] = evaluateCause43(cause);
      return some343([pipe63(parallel234, union343(par)), pipe63(sequential234, appendAll53(seq))]);
    }));
    const [rightParallel, rightSequential] = pipe63(headNonEmpty53(rightStack), reduce443([empty643(), empty343()], ([parallel234, sequential234], cause) => {
      const [par, seq] = evaluateCause43(cause);
      return some343([pipe63(parallel234, union343(par)), pipe63(sequential234, appendAll53(seq))]);
    }));
    if (!equals63(leftParallel, rightParallel)) {
      return false;
    }
    leftStack = leftSequential;
    rightStack = rightSequential;
  }
  return true;
};
var flattenCause43 = (cause) => {
  return flattenCauseLoop43(of53(cause), empty343());
};
var flattenCauseLoop43 = (causes, flattened) => {
  while (1) {
    const [parallel234, sequential234] = pipe63(causes, reduce73([empty643(), empty343()], ([parallel322, sequential322], cause) => {
      const [par, seq] = evaluateCause43(cause);
      return [pipe63(parallel322, union343(par)), pipe63(sequential322, appendAll53(seq))];
    }));
    const updated = size343(parallel234) > 0 ? pipe63(flattened, prepend63(parallel234)) : flattened;
    if (isEmpty53(sequential234)) {
      return reverse243(updated);
    }
    causes = sequential234;
    flattened = updated;
  }
  throw new Error(getBugErrorMessage63("Cause.flattenCauseLoop"));
};
var evaluateCause43 = (self2) => {
  let cause = self2;
  const stack = [];
  let _parallel = empty643();
  let _sequential = empty343();
  while (cause !== void 0) {
    switch (cause._tag) {
      case OP_EMPTY43: {
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_FAIL43: {
        _parallel = add343(_parallel, make443(cause._tag, cause.error));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_DIE43: {
        _parallel = add343(_parallel, make443(cause._tag, cause.defect));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_INTERRUPT43: {
        _parallel = add343(_parallel, make443(cause._tag, cause.fiberId));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_SEQUENTIAL43: {
        switch (cause.left._tag) {
          case OP_EMPTY43: {
            cause = cause.right;
            break;
          }
          case OP_SEQUENTIAL43: {
            cause = sequential43(cause.left.left, sequential43(cause.left.right, cause.right));
            break;
          }
          case OP_PARALLEL43: {
            cause = parallel43(sequential43(cause.left.left, cause.right), sequential43(cause.left.right, cause.right));
            break;
          }
          default: {
            _sequential = prepend63(_sequential, cause.right);
            cause = cause.left;
            break;
          }
        }
        break;
      }
      case OP_PARALLEL43: {
        stack.push(cause.right);
        cause = cause.left;
        break;
      }
    }
  }
  throw new Error(getBugErrorMessage63("Cause.evaluateCauseLoop"));
};
var IsInterruptedOnlyCauseReducer43 = {
  emptyCase: constTrue63,
  failCase: constFalse63,
  dieCase: constFalse63,
  interruptCase: constTrue63,
  sequentialCase: (_43, left334, right334) => left334 && right334,
  parallelCase: (_43, left334, right334) => left334 && right334
};
var OP_SEQUENTIAL_CASE43 = "SequentialCase";
var OP_PARALLEL_CASE43 = "ParallelCase";
var reduce443 = /* @__PURE__ */ dual63(3, (self2, zero, pf) => {
  let accumulator = zero;
  let cause = self2;
  const causes = [];
  while (cause !== void 0) {
    const option = pf(accumulator, cause);
    accumulator = isSome243(option) ? option.value : accumulator;
    switch (cause._tag) {
      case OP_SEQUENTIAL43: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      case OP_PARALLEL43: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      default: {
        cause = void 0;
        break;
      }
    }
    if (cause === void 0 && causes.length > 0) {
      cause = causes.pop();
    }
  }
  return accumulator;
});
var reduceWithContext43 = /* @__PURE__ */ dual63(3, (self2, context, reducer) => {
  const input = [self2];
  const output = [];
  while (input.length > 0) {
    const cause = input.pop();
    switch (cause._tag) {
      case OP_EMPTY43: {
        output.push(right243(reducer.emptyCase(context)));
        break;
      }
      case OP_FAIL43: {
        output.push(right243(reducer.failCase(context, cause.error)));
        break;
      }
      case OP_DIE43: {
        output.push(right243(reducer.dieCase(context, cause.defect)));
        break;
      }
      case OP_INTERRUPT43: {
        output.push(right243(reducer.interruptCase(context, cause.fiberId)));
        break;
      }
      case OP_SEQUENTIAL43: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left243({
          _tag: OP_SEQUENTIAL_CASE43
        }));
        break;
      }
      case OP_PARALLEL43: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left243({
          _tag: OP_PARALLEL_CASE43
        }));
        break;
      }
    }
  }
  const accumulator = [];
  while (output.length > 0) {
    const either = output.pop();
    switch (either._tag) {
      case "Left": {
        switch (either.left._tag) {
          case OP_SEQUENTIAL_CASE43: {
            const left334 = accumulator.pop();
            const right334 = accumulator.pop();
            const value = reducer.sequentialCase(context, left334, right334);
            accumulator.push(value);
            break;
          }
          case OP_PARALLEL_CASE43: {
            const left334 = accumulator.pop();
            const right334 = accumulator.pop();
            const value = reducer.parallelCase(context, left334, right334);
            accumulator.push(value);
            break;
          }
        }
        break;
      }
      case "Right": {
        accumulator.push(either.right);
        break;
      }
    }
  }
  if (accumulator.length === 0) {
    throw new Error("BUG: Cause.reduceWithContext - please report an issue at https://github.com/Effect-TS/effect/issues");
  }
  return accumulator.pop();
});
var pretty43 = (cause) => {
  if (isInterruptedOnly43(cause)) {
    return "All fibers interrupted without errors.";
  }
  return prettyErrors43(cause).map((e43) => e43.stack).join("\n");
};
var PrettyError43 = class extends globalThis.Error {
  span = void 0;
  constructor(originalError) {
    const prevLimit = Error.stackTraceLimit;
    Error.stackTraceLimit = 0;
    super(prettyErrorMessage43(originalError));
    Error.stackTraceLimit = prevLimit;
    this.name = originalError instanceof Error ? originalError.name : "Error";
    if (typeof originalError === "object" && originalError !== null) {
      if (spanSymbol53 in originalError) {
        this.span = originalError[spanSymbol53];
      }
      Object.keys(originalError).forEach((key) => {
        if (!(key in this)) {
          this[key] = originalError[key];
        }
      });
    }
    this.stack = prettyErrorStack43(this.message, originalError instanceof Error && originalError.stack ? originalError.stack : "", this.span);
  }
  toJSON() {
    const out = {
      message: this.message,
      stack: this.stack
    };
    if (this.span) {
      out.span = this.span;
    }
    return out;
  }
};
var prettyErrorMessage43 = (u43) => {
  if (typeof u43 === "string") {
    return `Error: ${u43}`;
  }
  try {
    if (hasProperty63(u43, "toString") && isFunction333(u43["toString"]) && u43["toString"] !== Object.prototype.toString && u43["toString"] !== globalThis.Array.prototype.toString) {
      return u43["toString"]();
    }
  } catch {
  }
  return `Error: ${JSON.stringify(u43)}`;
};
var locationRegex43 = /\((.*)\)/;
var spanToTrace43 = /* @__PURE__ */ globalValue63("effect/Tracer/spanToTrace", () => /* @__PURE__ */ new WeakMap());
var prettyErrorStack43 = (message, stack, span24) => {
  const out = [message];
  const lines = stack.split("\n");
  for (let i43 = 1; i43 < lines.length; i43++) {
    if (lines[i43].includes("Generator.next")) {
      break;
    }
    if (lines[i43].includes("effect_internal_function")) {
      out.pop();
      break;
    }
    out.push(lines[i43].replace(/at .*effect_instruction_i.*\((.*)\)/, "at $1").replace(/EffectPrimitive\.\w+/, "<anonymous>"));
  }
  if (span24) {
    let current = span24;
    let i43 = 0;
    while (current && current._tag === "Span" && i43 < 10) {
      const stackFn = spanToTrace43.get(current);
      if (typeof stackFn === "function") {
        const stack2 = stackFn();
        const locationMatch = stack2.match(locationRegex43);
        const location = locationMatch ? locationMatch[1] : stack2.replace(/^at /, "");
        out.push(`    at ${current.name} (${location})`);
      } else {
        out.push(`    at ${current.name}`);
      }
      current = getOrUndefined63(current.parent);
      i43++;
    }
  }
  return out.join("\n");
};
var spanSymbol53 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var prettyErrors43 = (cause) => reduceWithContext43(cause, void 0, {
  emptyCase: () => [],
  dieCase: (_43, unknownError) => {
    return [new PrettyError43(unknownError)];
  },
  failCase: (_43, error) => {
    return [new PrettyError43(error)];
  },
  interruptCase: () => [],
  parallelCase: (_43, l43, r43) => [...l43, ...r43],
  sequentialCase: (_43, l43, r43) => [...l43, ...r43]
});
var SingleShotGen243 = class _SingleShotGen93 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  next(a43) {
    return this.called ? {
      value: a43,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  return(a43) {
    return {
      value: a43,
      done: true
    };
  }
  throw(e43) {
    throw e43;
  }
  [Symbol.iterator]() {
    return new _SingleShotGen93(this.self);
  }
};
var spanTag43 = /* @__PURE__ */ GenericTag43("effect/ParentSpan");
var EffectTypeId243 = /* @__PURE__ */ Symbol.for("effect/Effect");
var EffectPrimitive43 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId243] = effectVariance63;
  constructor(_op) {
    this._op = _op;
  }
  [symbol243](that) {
    return this === that;
  }
  [symbol93]() {
    return cached63(this, random63(this));
  }
  pipe() {
    return pipeArguments63(this, arguments);
  }
  toJSON() {
    return {
      _id: "Effect",
      _op: this._op,
      effect_instruction_i0: toJSON63(this.effect_instruction_i0),
      effect_instruction_i1: toJSON63(this.effect_instruction_i1),
      effect_instruction_i2: toJSON63(this.effect_instruction_i2)
    };
  }
  toString() {
    return format63(this.toJSON());
  }
  [NodeInspectSymbol63]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen243(new YieldWrap63(this));
  }
};
var EffectPrimitiveFailure43 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId243] = effectVariance63;
  constructor(_op) {
    this._op = _op;
    this._tag = _op;
  }
  [symbol243](that) {
    return exitIsExit43(that) && that._op === "Failure" && // @ts-expect-error
    equals63(this.effect_instruction_i0, that.effect_instruction_i0);
  }
  [symbol93]() {
    return pipe63(
      // @ts-expect-error
      string83(this._tag),
      // @ts-expect-error
      combine73(hash63(this.effect_instruction_i0)),
      cached63(this)
    );
  }
  get cause() {
    return this.effect_instruction_i0;
  }
  pipe() {
    return pipeArguments63(this, arguments);
  }
  toJSON() {
    return {
      _id: "Exit",
      _tag: this._op,
      cause: this.cause.toJSON()
    };
  }
  toString() {
    return format63(this.toJSON());
  }
  [NodeInspectSymbol63]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen243(new YieldWrap63(this));
  }
};
var isEffect43 = (u43) => hasProperty63(u43, EffectTypeId243);
var withFiberRuntime43 = (withRuntime) => {
  const effect = new EffectPrimitive43(OP_WITH_RUNTIME43);
  effect.effect_instruction_i0 = withRuntime;
  return effect;
};
var spanSymbol243 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var originalSymbol43 = /* @__PURE__ */ Symbol.for("effect/OriginalAnnotation");
var capture43 = (obj, span24) => {
  if (isSome243(span24)) {
    return new Proxy(obj, {
      has(target, p43) {
        return p43 === spanSymbol243 || p43 === originalSymbol43 || p43 in target;
      },
      get(target, p43) {
        if (p43 === spanSymbol243) {
          return span24.value;
        }
        if (p43 === originalSymbol43) {
          return obj;
        }
        return target[p43];
      }
    });
  }
  return obj;
};
var fail243 = (error) => isObject63(error) && !(spanSymbol243 in error) ? withFiberRuntime43((fiber) => failCause43(fail53(capture43(error, currentSpanFromFiber43(fiber))))) : failCause43(fail53(error));
var failCause43 = (cause) => {
  const effect = new EffectPrimitiveFailure43(OP_FAILURE43);
  effect.effect_instruction_i0 = cause;
  return effect;
};
var FiberRefSymbolKey43 = "effect/FiberRef";
var FiberRefTypeId43 = /* @__PURE__ */ Symbol.for(FiberRefSymbolKey43);
var fiberRefVariance43 = {
  /* c8 ignore next */
  _A: (_43) => _43
};
var fiberRefUnsafeMakeContext43 = (initial) => {
  const differ = environment43();
  return fiberRefUnsafeMakePatch43(initial, {
    differ,
    fork: differ.empty
  });
};
var fiberRefUnsafeMakePatch43 = (initial, options) => ({
  [FiberRefTypeId43]: fiberRefVariance43,
  initial,
  diff: (oldValue, newValue) => options.differ.diff(oldValue, newValue),
  combine: (first, second) => options.differ.combine(first, second),
  patch: (patch234) => (oldValue) => options.differ.patch(patch234, oldValue),
  fork: options.fork,
  join: options.join ?? ((_43, n43) => n43),
  pipe() {
    return pipeArguments63(this, arguments);
  }
});
var currentContext43 = /* @__PURE__ */ globalValue63(/* @__PURE__ */ Symbol.for("effect/FiberRef/currentContext"), () => fiberRefUnsafeMakeContext43(empty243()));
var YieldableError43 = /* @__PURE__ */ function() {
  class YieldableError234 extends globalThis.Error {
    commit() {
      return fail243(this);
    }
    toString() {
      return this.message ? `${this.name}: ${this.message}` : this.name;
    }
    toJSON() {
      return {
        ...this
      };
    }
    [NodeInspectSymbol63]() {
      const stack = this.stack;
      if (stack) {
        return `${this.toString()}
${stack.split("\n").slice(1).join("\n")}`;
      }
      return this.toString();
    }
  }
  Object.assign(YieldableError234.prototype, StructuralCommitPrototype33);
  return YieldableError234;
}();
var exitIsExit43 = (u43) => isEffect43(u43) && "_tag" in u43 && (u43._tag === "Success" || u43._tag === "Failure");
var currentSpanFromFiber43 = (fiber) => {
  const span24 = fiber.getFiberRef(currentContext43).unsafeMap.get(spanTag43.key);
  return span24 !== void 0 && span24._tag === "Span" ? some343(span24) : none243();
};
var Data_exports33 = {};
__export53(Data_exports33, {
  Class: () => Class243,
  Error: () => Error243,
  Structural: () => Structural243,
  TaggedClass: () => TaggedClass43,
  TaggedError: () => TaggedError43,
  array: () => array243,
  case: () => _case43,
  struct: () => struct343,
  tagged: () => tagged43,
  taggedEnum: () => taggedEnum43,
  tuple: () => tuple243,
  unsafeArray: () => unsafeArray43,
  unsafeStruct: () => unsafeStruct43
});
var struct343 = struct243;
var unsafeStruct43 = (as253) => Object.setPrototypeOf(as253, StructuralPrototype33);
var tuple243 = (...as253) => unsafeArray43(as253);
var array243 = (as253) => unsafeArray43(as253.slice(0));
var unsafeArray43 = (as253) => Object.setPrototypeOf(as253, ArrayProto43);
var _case43 = () => (args) => args === void 0 ? Object.create(StructuralPrototype33) : struct343(args);
var tagged43 = (tag) => (args) => {
  const value = args === void 0 ? Object.create(StructuralPrototype33) : struct343(args);
  value._tag = tag;
  return value;
};
var Class243 = Structural53;
var TaggedClass43 = (tag) => {
  class Base extends Class243 {
    _tag = tag;
  }
  return Base;
};
var Structural243 = Structural53;
var taggedEnum43 = () => new Proxy({}, {
  get(_target, tag, _receiver) {
    if (tag === "$is") {
      return isTagged63;
    } else if (tag === "$match") {
      return taggedMatch43;
    }
    return tagged43(tag);
  }
});
function taggedMatch43() {
  if (arguments.length === 1) {
    const cases2 = arguments[0];
    return function(value2) {
      return cases2[value2._tag](value2);
    };
  }
  const value = arguments[0];
  const cases = arguments[1];
  return cases[value._tag](value);
}
var Error243 = /* @__PURE__ */ function() {
  return class Base extends YieldableError43 {
    constructor(args) {
      super();
      if (args) {
        Object.assign(this, args);
      }
    }
  };
}();
var TaggedError43 = (tag) => {
  class Base extends Error243 {
    _tag = tag;
  }
  Base.prototype.name = tag;
  return Base;
};
var traverseUp43 = Function_exports63.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType43.Program) return Option_exports63.none();
  return predicate(parent) ? Option_exports63.some(parent) : traverseUp43(parent, predicate);
});
var traverseUpGuard43 = Function_exports63.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType43.Program) return Option_exports63.none();
  return predicate(parent) ? Option_exports63.some(parent) : traverseUpGuard43(parent, predicate);
});
var ESLintCommunityESLintUtils43;
((ESLintCommunityESLintUtils234) => {
  ESLintCommunityESLintUtils234.getFunctionHeadLocation = getFunctionHeadLocation43;
  ESLintCommunityESLintUtils234.getFunctionNameWithKind = getFunctionNameWithKind43;
  ESLintCommunityESLintUtils234.getPropertyName = getPropertyName43;
  ESLintCommunityESLintUtils234.getStaticValue = getStaticValue33;
  ESLintCommunityESLintUtils234.getStringIfConstant = getStringIfConstant43;
  ESLintCommunityESLintUtils234.hasSideEffect = hasSideEffect43;
  ESLintCommunityESLintUtils234.isParenthesized = isParenthesized43;
})(ESLintCommunityESLintUtils43 || (ESLintCommunityESLintUtils43 = {}));
var Construction43 = Data_exports33.taggedEnum();
Construction43.None();
function getNestedCallExpressions(node) {
  const callExpressions = [];
  if (node.type === NodeType43.CallExpression) {
    callExpressions.push(node);
  }
  if ("arguments" in node) {
    node.arguments.forEach((x43) => {
      callExpressions.push(...getNestedCallExpressions(x43));
    });
  }
  if ("expression" in node && node.expression !== true && node.expression !== false) {
    callExpressions.push(...getNestedCallExpressions(node.expression));
  }
  if ("left" in node) {
    callExpressions.push(...getNestedCallExpressions(node.left));
  }
  if ("right" in node) {
    callExpressions.push(...getNestedCallExpressions(node.right));
  }
  if ("test" in node && node.test !== null) {
    callExpressions.push(...getNestedCallExpressions(node.test));
  }
  if ("consequent" in node) {
    Array.isArray(node.consequent) ? node.consequent.forEach((x43) => {
      callExpressions.push(...getNestedCallExpressions(x43));
    }) : callExpressions.push(...getNestedCallExpressions(node.consequent));
  }
  if ("alternate" in node && node.alternate !== null) {
    Array.isArray(node.alternate) ? node.alternate.forEach((x43) => {
      callExpressions.push(...getNestedCallExpressions(x43));
    }) : callExpressions.push(
      ...getNestedCallExpressions(node.alternate)
    );
  }
  if ("elements" in node) {
    node.elements.forEach((x43) => {
      if (x43 !== null) {
        callExpressions.push(...getNestedCallExpressions(x43));
      }
    });
  }
  if ("properties" in node) {
    node.properties.forEach((x43) => {
      callExpressions.push(...getNestedCallExpressions(x43));
    });
  }
  if ("expressions" in node) {
    node.expressions.forEach((x43) => {
      callExpressions.push(...getNestedCallExpressions(x43));
    });
  }
  if (node.type === NodeType43.Property) {
    callExpressions.push(...getNestedCallExpressions(node.value));
  }
  if (node.type === NodeType43.SpreadElement) {
    callExpressions.push(...getNestedCallExpressions(node.argument));
  }
  if (node.type === NodeType43.MemberExpression) {
    callExpressions.push(...getNestedCallExpressions(node.object));
  }
  if (node.type === NodeType43.UnaryExpression) {
    callExpressions.push(...getNestedCallExpressions(node.argument));
  }
  if (node.type === NodeType43.ChainExpression) {
    callExpressions.push(...getNestedCallExpressions(node.expression));
  }
  if (node.type === NodeType43.TSNonNullExpression) {
    callExpressions.push(...getNestedCallExpressions(node.expression));
  }
  return callExpressions;
}
a6({
  type: N6.union([NodeType43.FunctionExpression, NodeType43.ArrowFunctionExpression]),
  parent: {
    type: NodeType43.Property,
    parent: {
      type: NodeType43.ObjectExpression
    }
  }
});
a6({
  type: N6.union([NodeType43.FunctionExpression, NodeType43.ArrowFunctionExpression]),
  parent: {
    type: NodeType43.MethodDefinition,
    parent: {
      type: NodeType43.ClassBody
    }
  }
});
a6({
  type: N6.union([NodeType43.FunctionExpression, NodeType43.ArrowFunctionExpression]),
  parent: {
    type: NodeType43.Property,
    parent: {
      type: NodeType43.ClassBody
    }
  }
});
var __defProp63 = Object.defineProperty;
var __export63 = (target, all334) => {
  for (var name22 in all334)
    __defProp63(target, name22, { get: all334[name22], enumerable: true });
};
var Function_exports73 = {};
__export63(Function_exports73, {
  SK: () => SK73,
  absurd: () => absurd73,
  apply: () => apply73,
  compose: () => compose103,
  constFalse: () => constFalse73,
  constNull: () => constNull73,
  constTrue: () => constTrue73,
  constUndefined: () => constUndefined73,
  constVoid: () => constVoid73,
  constant: () => constant73,
  dual: () => dual73,
  flip: () => flip73,
  flow: () => flow73,
  hole: () => hole73,
  identity: () => identity73,
  isFunction: () => isFunction113,
  pipe: () => pipe73,
  satisfies: () => satisfies73,
  tupled: () => tupled73,
  unsafeCoerce: () => unsafeCoerce73,
  untupled: () => untupled73
});
var isFunction113 = (input) => typeof input === "function";
var dual73 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a232, b232) {
        if (arguments.length >= 2) {
          return body(a232, b232);
        }
        return function(self2) {
          return body(self2, a232);
        };
      };
    case 3:
      return function(a232, b232, c232) {
        if (arguments.length >= 3) {
          return body(a232, b232, c232);
        }
        return function(self2) {
          return body(self2, a232, b232);
        };
      };
    case 4:
      return function(a232, b232, c232, d232) {
        if (arguments.length >= 4) {
          return body(a232, b232, c232, d232);
        }
        return function(self2) {
          return body(self2, a232, b232, c232);
        };
      };
    case 5:
      return function(a232, b232, c232, d232, e232) {
        if (arguments.length >= 5) {
          return body(a232, b232, c232, d232, e232);
        }
        return function(self2) {
          return body(self2, a232, b232, c232, d232);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply73 = (a232) => (self2) => self2(a232);
var identity73 = (a232) => a232;
var satisfies73 = () => (b232) => b232;
var unsafeCoerce73 = identity73;
var constant73 = (value) => () => value;
var constTrue73 = /* @__PURE__ */ constant73(true);
var constFalse73 = /* @__PURE__ */ constant73(false);
var constNull73 = /* @__PURE__ */ constant73(null);
var constUndefined73 = /* @__PURE__ */ constant73(void 0);
var constVoid73 = constUndefined73;
var flip73 = (f232) => (...b232) => (...a232) => f232(...a232)(...b232);
var compose103 = /* @__PURE__ */ dual73(2, (ab, bc) => (a232) => bc(ab(a232)));
var absurd73 = (_232) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled73 = (f232) => (a232) => f232(...a232);
var untupled73 = (f232) => (...a232) => f232(a232);
function pipe73(a232, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a232;
    case 2:
      return ab(a232);
    case 3:
      return bc(ab(a232));
    case 4:
      return cd(bc(ab(a232)));
    case 5:
      return de(cd(bc(ab(a232))));
    case 6:
      return ef(de(cd(bc(ab(a232)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a232))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a232)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a232))))))));
    default: {
      let ret = arguments[0];
      for (let i232 = 1; i232 < arguments.length; i232++) {
        ret = arguments[i232](ret);
      }
      return ret;
    }
  }
}
function flow73(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole73 = /* @__PURE__ */ unsafeCoerce73(absurd73);
var SK73 = (_232, b232) => b232;
var make183 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_113 = (map324) => dual73(3, (self2, name22, f232) => map324(self2, (a232) => Object.assign({}, a232, {
  [name22]: f232(a232)
})));
var bindTo113 = (map324) => dual73(2, (self2, name22) => map324(self2, (a232) => ({
  [name22]: a232
})));
var bind113 = (map324, flatMap324) => dual73(3, (self2, name22, f232) => flatMap324(self2, (a232) => map324(f232(a232), (b232) => Object.assign({}, a232, {
  [name22]: b232
}))));
var moduleVersion73 = "3.2.8";
var getCurrentVersion73 = () => moduleVersion73;
var globalStoreId73 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion73()}`);
if (!(globalStoreId73 in globalThis)) {
  globalThis[globalStoreId73] = /* @__PURE__ */ new Map();
}
var globalStore73 = globalThis[globalStoreId73];
var globalValue73 = (id, compute) => {
  if (!globalStore73.has(id)) {
    globalStore73.set(id, compute());
  }
  return globalStore73.get(id);
};
var isFunction253 = isFunction113;
var isRecordOrArray73 = (input) => typeof input === "object" && input !== null;
var isObject73 = (input) => isRecordOrArray73(input) || isFunction253(input);
var hasProperty73 = /* @__PURE__ */ dual73(2, (self2, property) => isObject73(self2) && property in self2);
var isNullable73 = (input) => input === null || input === void 0;
var getBugErrorMessage73 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId73 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind73 = (u232) => isObject73(u232) && GenKindTypeId73 in u232;
var GenKindImpl73 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity73;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId73] = GenKindTypeId73;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen83(this);
  }
};
var SingleShotGen83 = class _SingleShotGen343 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a232) {
    return this.called ? {
      value: a232,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a232) {
    return {
      value: a232,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e232) {
    throw e232;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen343(this.self);
  }
};
var adapter103 = () => function() {
  let x232 = arguments[0];
  for (let i232 = 1; i232 < arguments.length; i232++) {
    x232 = arguments[i232](x232);
  }
  return new GenKindImpl73(x232);
};
var defaultIncHi73 = 335903614;
var defaultIncLo73 = 4150755663;
var MUL_HI73 = 1481765933 >>> 0;
var MUL_LO73 = 1284865837 >>> 0;
var BIT_5373 = 9007199254740992;
var BIT_2773 = 134217728;
var PCGRandom73 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable73(seedLo) && isNullable73(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable73(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable73(incLo) && isNullable73(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo73;
      incHi = this._state ? this._state[2] : defaultIncHi73;
    } else if (isNullable73(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add6473(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max34) {
    if (!max34) {
      return this._next();
    }
    max34 = max34 >>> 0;
    if ((max34 & max34 - 1) === 0) {
      return this._next() & max34 - 1;
    }
    let num = 0;
    const skew = (-max34 >>> 0) % max34 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max34;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_2773 + lo) / BIT_5373;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul6473(this._state, oldHi, oldLo, MUL_HI73, MUL_LO73);
    add6473(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul6473(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add6473(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId73 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap73 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId73]() {
    return this.#value;
  }
};
function yieldWrapGet73(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId73 in self2) {
    return self2[YieldWrapTypeId73]();
  }
  throw new Error(getBugErrorMessage73("yieldWrapGet"));
}
var structuralRegionState73 = /* @__PURE__ */ globalValue73("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache73 = /* @__PURE__ */ globalValue73(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr73 = /* @__PURE__ */ globalValue73(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom73());
var symbol103 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash73 = (self2) => {
  if (structuralRegionState73.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number83(self2);
    case "bigint":
      return string93(self2.toString(10));
    case "boolean":
      return string93(String(self2));
    case "symbol":
      return string93(String(self2));
    case "string":
      return string93(self2);
    case "undefined":
      return string93("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string93("null");
      } else if (self2 instanceof Date) {
        return hash73(self2.toISOString());
      } else if (isHash73(self2)) {
        return self2[symbol103]();
      } else {
        return random73(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random73 = (self2) => {
  if (!randomHashCache73.has(self2)) {
    randomHashCache73.set(self2, number83(pcgr73.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache73.get(self2);
};
var combine83 = (b232) => (self2) => self2 * 53 ^ b232;
var optimize73 = (n232) => n232 & 3221225471 | n232 >>> 1 & 1073741824;
var isHash73 = (u232) => hasProperty73(u232, symbol103);
var number83 = (n232) => {
  if (n232 !== n232 || n232 === Infinity) {
    return 0;
  }
  let h232 = n232 | 0;
  if (h232 !== n232) {
    h232 ^= n232 * 4294967295;
  }
  while (n232 > 4294967295) {
    h232 ^= n232 /= 4294967295;
  }
  return optimize73(n232);
};
var string93 = (str) => {
  let h232 = 5381, i232 = str.length;
  while (i232) {
    h232 = h232 * 33 ^ str.charCodeAt(--i232);
  }
  return optimize73(h232);
};
var cached73 = function() {
  if (arguments.length === 1) {
    const self3 = arguments[0];
    return function(hash422) {
      Object.defineProperty(self3, symbol103, {
        value() {
          return hash422;
        },
        enumerable: false
      });
      return hash422;
    };
  }
  const self2 = arguments[0];
  const hash324 = arguments[1];
  Object.defineProperty(self2, symbol103, {
    value() {
      return hash324;
    },
    enumerable: false
  });
  return hash324;
};
var symbol253 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals73() {
  if (arguments.length === 1) {
    return (self2) => compareBoth73(self2, arguments[0]);
  }
  return compareBoth73(arguments[0], arguments[1]);
}
function compareBoth73(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual73(self2) && isEqual73(that)) {
        if (hash73(self2) === hash73(that) && self2[symbol253](that)) {
          return true;
        } else {
          return structuralRegionState73.enabled && structuralRegionState73.tester ? structuralRegionState73.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState73.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v232, i232) => compareBoth73(v232, that[i232]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth73(self2[key], that[key]))) {
              return structuralRegionState73.tester ? structuralRegionState73.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState73.tester ? structuralRegionState73.tester(self2, that) : false;
    }
  }
  return structuralRegionState73.enabled && structuralRegionState73.tester ? structuralRegionState73.tester(self2, that) : false;
}
var isEqual73 = (u232) => hasProperty73(u232, symbol253);
var equivalence73 = () => equals73;
var NodeInspectSymbol73 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON73 = (x232) => {
  if (hasProperty73(x232, "toJSON") && isFunction253(x232["toJSON"]) && x232["toJSON"].length === 0) {
    return x232.toJSON();
  } else if (Array.isArray(x232)) {
    return x232.map(toJSON73);
  }
  return x232;
};
var format73 = (x232) => JSON.stringify(x232, null, 2);
var pipeArguments73 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i232 = 0, len = args.length; i232 < len; i232++) {
        ret = args[i232](ret);
      }
      return ret;
    }
  }
};
var EffectTypeId83 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId73 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId73 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId73 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance73 = {
  /* c8 ignore next */
  _R: (_232) => _232,
  /* c8 ignore next */
  _E: (_232) => _232,
  /* c8 ignore next */
  _A: (_232) => _232,
  _V: /* @__PURE__ */ getCurrentVersion73()
};
var sinkVariance73 = {
  /* c8 ignore next */
  _A: (_232) => _232,
  /* c8 ignore next */
  _In: (_232) => _232,
  /* c8 ignore next */
  _L: (_232) => _232,
  /* c8 ignore next */
  _E: (_232) => _232,
  /* c8 ignore next */
  _R: (_232) => _232
};
var channelVariance73 = {
  /* c8 ignore next */
  _Env: (_232) => _232,
  /* c8 ignore next */
  _InErr: (_232) => _232,
  /* c8 ignore next */
  _InElem: (_232) => _232,
  /* c8 ignore next */
  _InDone: (_232) => _232,
  /* c8 ignore next */
  _OutErr: (_232) => _232,
  /* c8 ignore next */
  _OutElem: (_232) => _232,
  /* c8 ignore next */
  _OutDone: (_232) => _232
};
var EffectPrototype73 = {
  [EffectTypeId83]: effectVariance73,
  [StreamTypeId73]: effectVariance73,
  [SinkTypeId73]: sinkVariance73,
  [ChannelTypeId73]: channelVariance73,
  [symbol253](that) {
    return this === that;
  },
  [symbol103]() {
    return cached73(this, random73(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen83(new YieldWrap73(this));
  },
  pipe() {
    return pipeArguments73(this, arguments);
  }
};
var TypeId173 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto103 = {
  ...EffectPrototype73,
  [TypeId173]: {
    _A: (_232) => _232
  },
  [NodeInspectSymbol73]() {
    return this.toJSON();
  },
  toString() {
    return format73(this.toJSON());
  }
};
var SomeProto73 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto103), {
  _tag: "Some",
  _op: "Some",
  [symbol253](that) {
    return isOption103(that) && isSome103(that) && equals73(this.value, that.value);
  },
  [symbol103]() {
    return cached73(this, combine83(hash73(this._tag))(hash73(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON73(this.value)
    };
  }
});
var NoneHash73 = /* @__PURE__ */ hash73("None");
var NoneProto73 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto103), {
  _tag: "None",
  _op: "None",
  [symbol253](that) {
    return isOption103(that) && isNone103(that);
  },
  [symbol103]() {
    return NoneHash73;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption103 = (input) => hasProperty73(input, TypeId173);
var isNone103 = (fa) => fa._tag === "None";
var isSome103 = (fa) => fa._tag === "Some";
var none103 = /* @__PURE__ */ Object.create(NoneProto73);
var some143 = (value) => {
  const a232 = Object.create(SomeProto73);
  a232.value = value;
  return a232;
};
var TypeId253 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto253 = {
  ...EffectPrototype73,
  [TypeId253]: {
    _R: (_232) => _232
  },
  [NodeInspectSymbol73]() {
    return this.toJSON();
  },
  toString() {
    return format73(this.toJSON());
  }
};
var RightProto73 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto253), {
  _tag: "Right",
  _op: "Right",
  [symbol253](that) {
    return isEither73(that) && isRight83(that) && equals73(this.right, that.right);
  },
  [symbol103]() {
    return combine83(hash73(this._tag))(hash73(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON73(this.right)
    };
  }
});
var LeftProto73 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto253), {
  _tag: "Left",
  _op: "Left",
  [symbol253](that) {
    return isEither73(that) && isLeft83(that) && equals73(this.left, that.left);
  },
  [symbol103]() {
    return combine83(hash73(this._tag))(hash73(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON73(this.left)
    };
  }
});
var isEither73 = (input) => hasProperty73(input, TypeId253);
var isLeft83 = (ma) => ma._tag === "Left";
var isRight83 = (ma) => ma._tag === "Right";
var left83 = (left334) => {
  const a232 = Object.create(LeftProto73);
  a232.left = left334;
  return a232;
};
var right83 = (right334) => {
  const a232 = Object.create(RightProto73);
  a232.right = right334;
  return a232;
};
var getLeft103 = (self2) => isRight83(self2) ? none103 : some143(self2.left);
var getRight103 = (self2) => isLeft83(self2) ? none103 : some143(self2.right);
var Option_exports73 = {};
__export63(Option_exports73, {
  Do: () => Do83,
  TypeId: () => TypeId353,
  all: () => all103,
  andThen: () => andThen73,
  ap: () => ap73,
  as: () => as73,
  asVoid: () => asVoid73,
  bind: () => bind253,
  bindTo: () => bindTo253,
  composeK: () => composeK73,
  contains: () => contains83,
  containsWith: () => containsWith83,
  exists: () => exists73,
  filter: () => filter83,
  filterMap: () => filterMap83,
  firstSomeOf: () => firstSomeOf73,
  flatMap: () => flatMap83,
  flatMapNullable: () => flatMapNullable83,
  flatten: () => flatten83,
  fromIterable: () => fromIterable103,
  fromNullable: () => fromNullable83,
  gen: () => gen73,
  getEquivalence: () => getEquivalence93,
  getLeft: () => getLeft253,
  getOrElse: () => getOrElse73,
  getOrNull: () => getOrNull73,
  getOrThrow: () => getOrThrow73,
  getOrThrowWith: () => getOrThrowWith73,
  getOrUndefined: () => getOrUndefined73,
  getOrder: () => getOrder83,
  getRight: () => getRight253,
  isNone: () => isNone253,
  isOption: () => isOption253,
  isSome: () => isSome253,
  let: () => let_253,
  lift2: () => lift273,
  liftNullable: () => liftNullable83,
  liftPredicate: () => liftPredicate83,
  liftThrowable: () => liftThrowable73,
  map: () => map83,
  match: () => match10,
  none: () => none253,
  orElse: () => orElse73,
  orElseEither: () => orElseEither73,
  orElseSome: () => orElseSome73,
  partitionMap: () => partitionMap83,
  product: () => product103,
  productMany: () => productMany103,
  reduceCompact: () => reduceCompact73,
  some: () => some253,
  tap: () => tap73,
  toArray: () => toArray73,
  toRefinement: () => toRefinement73,
  void: () => void_73,
  zipLeft: () => zipLeft73,
  zipRight: () => zipRight73,
  zipWith: () => zipWith83
});
var make253 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId353 = /* @__PURE__ */ Symbol.for("effect/Option");
var none253 = () => none103;
var some253 = some143;
var isOption253 = isOption103;
var isNone253 = isNone103;
var isSome253 = isSome103;
var match10 = /* @__PURE__ */ dual73(2, (self2, {
  onNone,
  onSome
}) => isNone253(self2) ? onNone() : onSome(self2.value));
var toRefinement73 = (f232) => (a232) => isSome253(f232(a232));
var fromIterable103 = (collection) => {
  for (const a232 of collection) {
    return some253(a232);
  }
  return none253();
};
var getRight253 = getRight103;
var getLeft253 = getLeft103;
var getOrElse73 = /* @__PURE__ */ dual73(2, (self2, onNone) => isNone253(self2) ? onNone() : self2.value);
var orElse73 = /* @__PURE__ */ dual73(2, (self2, that) => isNone253(self2) ? that() : self2);
var orElseSome73 = /* @__PURE__ */ dual73(2, (self2, onNone) => isNone253(self2) ? some253(onNone()) : self2);
var orElseEither73 = /* @__PURE__ */ dual73(2, (self2, that) => isNone253(self2) ? map83(that(), right83) : map83(self2, left83));
var firstSomeOf73 = (collection) => {
  let out = none253();
  for (out of collection) {
    if (isSome253(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable83 = (nullableValue) => nullableValue == null ? none253() : some253(nullableValue);
var liftNullable83 = (f232) => (...a232) => fromNullable83(f232(...a232));
var getOrNull73 = /* @__PURE__ */ getOrElse73(constNull73);
var getOrUndefined73 = /* @__PURE__ */ getOrElse73(constUndefined73);
var liftThrowable73 = (f232) => (...a232) => {
  try {
    return some253(f232(...a232));
  } catch (e232) {
    return none253();
  }
};
var getOrThrowWith73 = /* @__PURE__ */ dual73(2, (self2, onNone) => {
  if (isSome253(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow73 = /* @__PURE__ */ getOrThrowWith73(() => new Error("getOrThrow called on a None"));
var map83 = /* @__PURE__ */ dual73(2, (self2, f232) => isNone253(self2) ? none253() : some253(f232(self2.value)));
var as73 = /* @__PURE__ */ dual73(2, (self2, b232) => map83(self2, () => b232));
var asVoid73 = /* @__PURE__ */ as73(void 0);
var void_73 = /* @__PURE__ */ some253(void 0);
var flatMap83 = /* @__PURE__ */ dual73(2, (self2, f232) => isNone253(self2) ? none253() : f232(self2.value));
var andThen73 = /* @__PURE__ */ dual73(2, (self2, f232) => flatMap83(self2, (a232) => {
  const b232 = isFunction113(f232) ? f232(a232) : f232;
  return isOption253(b232) ? b232 : some253(b232);
}));
var flatMapNullable83 = /* @__PURE__ */ dual73(2, (self2, f232) => isNone253(self2) ? none253() : fromNullable83(f232(self2.value)));
var flatten83 = /* @__PURE__ */ flatMap83(identity73);
var zipRight73 = /* @__PURE__ */ dual73(2, (self2, that) => flatMap83(self2, () => that));
var composeK73 = /* @__PURE__ */ dual73(2, (afb, bfc) => (a232) => flatMap83(afb(a232), bfc));
var zipLeft73 = /* @__PURE__ */ dual73(2, (self2, that) => tap73(self2, () => that));
var tap73 = /* @__PURE__ */ dual73(2, (self2, f232) => flatMap83(self2, (a232) => map83(f232(a232), () => a232)));
var product103 = (self2, that) => isSome253(self2) && isSome253(that) ? some253([self2.value, that.value]) : none253();
var productMany103 = (self2, collection) => {
  if (isNone253(self2)) {
    return none253();
  }
  const out = [self2.value];
  for (const o232 of collection) {
    if (isNone253(o232)) {
      return none253();
    }
    out.push(o232.value);
  }
  return some253(out);
};
var all103 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o232 of input) {
      if (isNone253(o232)) {
        return none253();
      }
      out2.push(o232.value);
    }
    return some253(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o232 = input[key];
    if (isNone253(o232)) {
      return none253();
    }
    out[key] = o232.value;
  }
  return some253(out);
};
var zipWith83 = /* @__PURE__ */ dual73(3, (self2, that, f232) => map83(product103(self2, that), ([a232, b232]) => f232(a232, b232)));
var ap73 = /* @__PURE__ */ dual73(2, (self2, that) => zipWith83(self2, that, (f232, a232) => f232(a232)));
var reduceCompact73 = /* @__PURE__ */ dual73(3, (self2, b232, f232) => {
  let out = b232;
  for (const oa of self2) {
    if (isSome253(oa)) {
      out = f232(out, oa.value);
    }
  }
  return out;
});
var toArray73 = (self2) => isNone253(self2) ? [] : [self2.value];
var partitionMap83 = /* @__PURE__ */ dual73(2, (self2, f232) => {
  if (isNone253(self2)) {
    return [none253(), none253()];
  }
  const e232 = f232(self2.value);
  return isLeft83(e232) ? [some253(e232.left), none253()] : [none253(), some253(e232.right)];
});
var filterMap83 = /* @__PURE__ */ dual73(2, (self2, f232) => isNone253(self2) ? none253() : f232(self2.value));
var filter83 = /* @__PURE__ */ dual73(2, (self2, predicate) => filterMap83(self2, (b232) => predicate(b232) ? some143(b232) : none103));
var getEquivalence93 = (isEquivalent) => make183((x232, y232) => x232 === y232 || (isNone253(x232) ? isNone253(y232) : isNone253(y232) ? false : isEquivalent(x232.value, y232.value)));
var getOrder83 = (O232) => make253((self2, that) => isSome253(self2) ? isSome253(that) ? O232(self2.value, that.value) : 1 : -1);
var lift273 = (f232) => dual73(2, (self2, that) => zipWith83(self2, that, f232));
var liftPredicate83 = (predicate) => (b232) => predicate(b232) ? some253(b232) : none253();
var containsWith83 = (isEquivalent) => dual73(2, (self2, a232) => isNone253(self2) ? false : isEquivalent(self2.value, a232));
var _equivalence93 = /* @__PURE__ */ equivalence73();
var contains83 = /* @__PURE__ */ containsWith83(_equivalence93);
var exists73 = /* @__PURE__ */ dual73(2, (self2, refinement) => isNone253(self2) ? false : refinement(self2.value));
var bindTo253 = /* @__PURE__ */ bindTo113(map83);
var let_253 = /* @__PURE__ */ let_113(map83);
var bind253 = /* @__PURE__ */ bind113(map83, flatMap83);
var Do83 = /* @__PURE__ */ some253({});
var adapter253 = /* @__PURE__ */ adapter103();
var gen73 = (f232) => {
  const iterator = f232(adapter253);
  let state = iterator.next();
  if (state.done) {
    return some253(state.value);
  } else {
    let current = state.value;
    if (isGenKind73(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet73(current);
    }
    if (isNone253(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind73(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet73(current);
        }
        if (isNone253(current)) {
          return current;
        }
      }
    }
    return some253(state.value);
  }
};
var MutableRef_exports42 = {};
__export63(MutableRef_exports42, {
  compareAndSet: () => compareAndSet43,
  decrement: () => decrement43,
  decrementAndGet: () => decrementAndGet43,
  get: () => get53,
  getAndDecrement: () => getAndDecrement43,
  getAndIncrement: () => getAndIncrement43,
  getAndSet: () => getAndSet43,
  getAndUpdate: () => getAndUpdate43,
  increment: () => increment43,
  incrementAndGet: () => incrementAndGet43,
  make: () => make353,
  set: () => set63,
  setAndGet: () => setAndGet43,
  toggle: () => toggle43,
  update: () => update43,
  updateAndGet: () => updateAndGet43
});
var TypeId453 = /* @__PURE__ */ Symbol.for("effect/MutableRef");
var MutableRefProto43 = {
  [TypeId453]: TypeId453,
  toString() {
    return format73(this.toJSON());
  },
  toJSON() {
    return {
      _id: "MutableRef",
      current: toJSON73(this.current)
    };
  },
  [NodeInspectSymbol73]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments73(this, arguments);
  }
};
var make353 = (value) => {
  const ref = Object.create(MutableRefProto43);
  ref.current = value;
  return ref;
};
var compareAndSet43 = /* @__PURE__ */ dual73(3, (self2, oldValue, newValue) => {
  if (equals73(oldValue, self2.current)) {
    self2.current = newValue;
    return true;
  }
  return false;
});
var decrement43 = (self2) => update43(self2, (n232) => n232 - 1);
var decrementAndGet43 = (self2) => updateAndGet43(self2, (n232) => n232 - 1);
var get53 = (self2) => self2.current;
var getAndDecrement43 = (self2) => getAndUpdate43(self2, (n232) => n232 - 1);
var getAndIncrement43 = (self2) => getAndUpdate43(self2, (n232) => n232 + 1);
var getAndSet43 = /* @__PURE__ */ dual73(2, (self2, value) => {
  const ret = self2.current;
  self2.current = value;
  return ret;
});
var getAndUpdate43 = /* @__PURE__ */ dual73(2, (self2, f232) => getAndSet43(self2, f232(get53(self2))));
var increment43 = (self2) => update43(self2, (n232) => n232 + 1);
var incrementAndGet43 = (self2) => updateAndGet43(self2, (n232) => n232 + 1);
var set63 = /* @__PURE__ */ dual73(2, (self2, value) => {
  self2.current = value;
  return self2;
});
var setAndGet43 = /* @__PURE__ */ dual73(2, (self2, value) => {
  self2.current = value;
  return self2.current;
});
var update43 = /* @__PURE__ */ dual73(2, (self2, f232) => set63(self2, f232(get53(self2))));
var updateAndGet43 = /* @__PURE__ */ dual73(2, (self2, f232) => setAndGet43(self2, f232(get53(self2))));
var toggle43 = (self2) => update43(self2, (_232) => !_232);
function getVariables33(initialScope) {
  const scopeRef = MutableRef_exports42.make(initialScope);
  const variablesRef = MutableRef_exports42.make(MutableRef_exports42.get(scopeRef).variables);
  while (MutableRef_exports42.get(scopeRef).type !== scopeManager.ScopeType.global) {
    MutableRef_exports42.set(scopeRef, MutableRef_exports42.get(scopeRef).upper);
    MutableRef_exports42.update(variablesRef, (variables) => variables.concat(MutableRef_exports42.get(scopeRef).variables));
  }
  return MutableRef_exports42.get(variablesRef).reverse();
}
var findVariable53 = Function_exports73.dual(2, (name22, initialScope) => {
  return Option_exports73.fromNullable(getVariables33(initialScope).find((variable) => variable.name === name22));
});
var t33 = Symbol.for("@ts-pattern/matcher");
var e33 = Symbol.for("@ts-pattern/isVariadic");
var n33 = "@ts-pattern/anonymous-select-key";
var r33 = (t232) => Boolean(t232 && "object" == typeof t232);
var i33 = (e232) => e232 && !!e232[t33];
var o33 = (n232, s232, c232) => {
  if (i33(n232)) {
    const e232 = n232[t33](), { matched: r232, selections: i232 } = e232.match(s232);
    return r232 && i232 && Object.keys(i232).forEach((t232) => c232(t232, i232[t232])), r232;
  }
  if (r33(n232)) {
    if (!r33(s232)) return false;
    if (Array.isArray(n232)) {
      if (!Array.isArray(s232)) return false;
      let t232 = [], r232 = [], a232 = [];
      for (const o232 of n232.keys()) {
        const s322 = n232[o232];
        i33(s322) && s322[e33] ? a232.push(s322) : a232.length ? r232.push(s322) : t232.push(s322);
      }
      if (a232.length) {
        if (a232.length > 1) throw new Error("Pattern error: Using `...P.array(...)` several times in a single pattern is not allowed.");
        if (s232.length < t232.length + r232.length) return false;
        const e232 = s232.slice(0, t232.length), n322 = 0 === r232.length ? [] : s232.slice(-r232.length), i232 = s232.slice(t232.length, 0 === r232.length ? Infinity : -r232.length);
        return t232.every((t322, n43) => o33(t322, e232[n43], c232)) && r232.every((t322, e322) => o33(t322, n322[e322], c232)) && (0 === a232.length || o33(a232[0], i232, c232));
      }
      return n232.length === s232.length && n232.every((t322, e232) => o33(t322, s232[e232], c232));
    }
    return Object.keys(n232).every((e232) => {
      const r232 = n232[e232];
      return (e232 in s232 || i33(a232 = r232) && "optional" === a232[t33]().matcherType) && o33(r232, s232[e232], c232);
      var a232;
    });
  }
  return Object.is(s232, n232);
};
var s33 = (e232) => {
  var n232, o232, a232;
  return r33(e232) ? i33(e232) ? null != (n232 = null == (o232 = (a232 = e232[t33]()).getSelectionKeys) ? void 0 : o232.call(a232)) ? n232 : [] : Array.isArray(e232) ? c33(e232, s33) : c33(Object.values(e232), s33) : [];
};
var c33 = (t232, e232) => t232.reduce((t322, n232) => t322.concat(e232(n232)), []);
function a33(...t232) {
  if (1 === t232.length) {
    const [e232] = t232;
    return (t322) => o33(e232, t322, () => {
    });
  }
  if (2 === t232.length) {
    const [e232, n232] = t232;
    return o33(e232, n232, () => {
    });
  }
  throw new Error(`isMatching wasn't given the right number of arguments: expected 1 or 2, received ${t232.length}.`);
}
function u33(t232) {
  return Object.assign(t232, { optional: () => l33(t232), and: (e232) => m33(t232, e232), or: (e232) => d33(t232, e232), select: (e232) => void 0 === e232 ? p33(t232) : p33(e232, t232) });
}
function h33(t232) {
  return Object.assign(((t322) => Object.assign(t322, { [Symbol.iterator]() {
    let n232 = 0;
    const r232 = [{ value: Object.assign(t322, { [e33]: true }), done: false }, { done: true, value: void 0 }];
    return { next: () => {
      var t43;
      return null != (t43 = r232[n232++]) ? t43 : r232.at(-1);
    } };
  } }))(t232), { optional: () => h33(l33(t232)), select: (e232) => h33(void 0 === e232 ? p33(t232) : p33(e232, t232)) });
}
function l33(e232) {
  return u33({ [t33]: () => ({ match: (t232) => {
    let n232 = {};
    const r232 = (t322, e322) => {
      n232[t322] = e322;
    };
    return void 0 === t232 ? (s33(e232).forEach((t322) => r232(t322, void 0)), { matched: true, selections: n232 }) : { matched: o33(e232, t232, r232), selections: n232 };
  }, getSelectionKeys: () => s33(e232), matcherType: "optional" }) });
}
var f33 = (t232, e232) => {
  for (const n232 of t232) if (!e232(n232)) return false;
  return true;
};
var g33 = (t232, e232) => {
  for (const [n232, r232] of t232.entries()) if (!e232(r232, n232)) return false;
  return true;
};
function m33(...e232) {
  return u33({ [t33]: () => ({ match: (t232) => {
    let n232 = {};
    const r232 = (t322, e322) => {
      n232[t322] = e322;
    };
    return { matched: e232.every((e322) => o33(e322, t232, r232)), selections: n232 };
  }, getSelectionKeys: () => c33(e232, s33), matcherType: "and" }) });
}
function d33(...e232) {
  return u33({ [t33]: () => ({ match: (t232) => {
    let n232 = {};
    const r232 = (t322, e322) => {
      n232[t322] = e322;
    };
    return c33(e232, s33).forEach((t322) => r232(t322, void 0)), { matched: e232.some((e322) => o33(e322, t232, r232)), selections: n232 };
  }, getSelectionKeys: () => c33(e232, s33), matcherType: "or" }) });
}
function y33(e232) {
  return { [t33]: () => ({ match: (t232) => ({ matched: Boolean(e232(t232)) }) }) };
}
function p33(...e232) {
  const r232 = "string" == typeof e232[0] ? e232[0] : void 0, i232 = 2 === e232.length ? e232[1] : "string" == typeof e232[0] ? void 0 : e232[0];
  return u33({ [t33]: () => ({ match: (t232) => {
    let e322 = { [null != r232 ? r232 : n33]: t232 };
    return { matched: void 0 === i232 || o33(i232, t232, (t322, n232) => {
      e322[t322] = n232;
    }), selections: e322 };
  }, getSelectionKeys: () => [null != r232 ? r232 : n33].concat(void 0 === i232 ? [] : s33(i232)) }) });
}
function v33(t232) {
  return "number" == typeof t232;
}
function b33(t232) {
  return "string" == typeof t232;
}
function w33(t232) {
  return "bigint" == typeof t232;
}
var S33 = u33(y33(function(t232) {
  return true;
}));
var O33 = S33;
var j33 = (t232) => Object.assign(u33(t232), { startsWith: (e232) => {
  return j33(m33(t232, (n232 = e232, y33((t322) => b33(t322) && t322.startsWith(n232)))));
  var n232;
}, endsWith: (e232) => {
  return j33(m33(t232, (n232 = e232, y33((t322) => b33(t322) && t322.endsWith(n232)))));
  var n232;
}, minLength: (e232) => j33(m33(t232, ((t322) => y33((e322) => b33(e322) && e322.length >= t322))(e232))), maxLength: (e232) => j33(m33(t232, ((t322) => y33((e322) => b33(e322) && e322.length <= t322))(e232))), includes: (e232) => {
  return j33(m33(t232, (n232 = e232, y33((t322) => b33(t322) && t322.includes(n232)))));
  var n232;
}, regex: (e232) => {
  return j33(m33(t232, (n232 = e232, y33((t322) => b33(t322) && Boolean(t322.match(n232))))));
  var n232;
} });
var E33 = j33(y33(b33));
var K33 = (t232) => Object.assign(u33(t232), { between: (e232, n232) => K33(m33(t232, ((t322, e322) => y33((n322) => v33(n322) && t322 <= n322 && e322 >= n322))(e232, n232))), lt: (e232) => K33(m33(t232, ((t322) => y33((e322) => v33(e322) && e322 < t322))(e232))), gt: (e232) => K33(m33(t232, ((t322) => y33((e322) => v33(e322) && e322 > t322))(e232))), lte: (e232) => K33(m33(t232, ((t322) => y33((e322) => v33(e322) && e322 <= t322))(e232))), gte: (e232) => K33(m33(t232, ((t322) => y33((e322) => v33(e322) && e322 >= t322))(e232))), int: () => K33(m33(t232, y33((t322) => v33(t322) && Number.isInteger(t322)))), finite: () => K33(m33(t232, y33((t322) => v33(t322) && Number.isFinite(t322)))), positive: () => K33(m33(t232, y33((t322) => v33(t322) && t322 > 0))), negative: () => K33(m33(t232, y33((t322) => v33(t322) && t322 < 0))) });
var x33 = K33(y33(v33));
var A33 = (t232) => Object.assign(u33(t232), { between: (e232, n232) => A33(m33(t232, ((t322, e322) => y33((n322) => w33(n322) && t322 <= n322 && e322 >= n322))(e232, n232))), lt: (e232) => A33(m33(t232, ((t322) => y33((e322) => w33(e322) && e322 < t322))(e232))), gt: (e232) => A33(m33(t232, ((t322) => y33((e322) => w33(e322) && e322 > t322))(e232))), lte: (e232) => A33(m33(t232, ((t322) => y33((e322) => w33(e322) && e322 <= t322))(e232))), gte: (e232) => A33(m33(t232, ((t322) => y33((e322) => w33(e322) && e322 >= t322))(e232))), positive: () => A33(m33(t232, y33((t322) => w33(t322) && t322 > 0))), negative: () => A33(m33(t232, y33((t322) => w33(t322) && t322 < 0))) });
var P24 = A33(y33(w33));
var T33 = u33(y33(function(t232) {
  return "boolean" == typeof t232;
}));
var k33 = u33(y33(function(t232) {
  return "symbol" == typeof t232;
}));
var B33 = u33(y33(function(t232) {
  return null == t232;
}));
var _33 = u33(y33(function(t232) {
  return null != t232;
}));
var N33 = { __proto__: null, matcher: t33, optional: l33, array: function(...e232) {
  return h33({ [t33]: () => ({ match: (t232) => {
    if (!Array.isArray(t232)) return { matched: false };
    if (0 === e232.length) return { matched: true };
    const n232 = e232[0];
    let r232 = {};
    if (0 === t232.length) return s33(n232).forEach((t322) => {
      r232[t322] = [];
    }), { matched: true, selections: r232 };
    const i232 = (t322, e322) => {
      r232[t322] = (r232[t322] || []).concat([e322]);
    };
    return { matched: t232.every((t322) => o33(n232, t322, i232)), selections: r232 };
  }, getSelectionKeys: () => 0 === e232.length ? [] : s33(e232[0]) }) });
}, set: function(...e232) {
  return u33({ [t33]: () => ({ match: (t232) => {
    if (!(t232 instanceof Set)) return { matched: false };
    let n232 = {};
    if (0 === t232.size) return { matched: true, selections: n232 };
    if (0 === e232.length) return { matched: true };
    const r232 = (t322, e322) => {
      n232[t322] = (n232[t322] || []).concat([e322]);
    }, i232 = e232[0];
    return { matched: f33(t232, (t322) => o33(i232, t322, r232)), selections: n232 };
  }, getSelectionKeys: () => 0 === e232.length ? [] : s33(e232[0]) }) });
}, map: function(...e232) {
  return u33({ [t33]: () => ({ match: (t232) => {
    if (!(t232 instanceof Map)) return { matched: false };
    let n232 = {};
    if (0 === t232.size) return { matched: true, selections: n232 };
    const r232 = (t322, e322) => {
      n232[t322] = (n232[t322] || []).concat([e322]);
    };
    if (0 === e232.length) return { matched: true };
    var i232;
    if (1 === e232.length) throw new Error(`\`P.map\` wasn't given enough arguments. Expected (key, value), received ${null == (i232 = e232[0]) ? void 0 : i232.toString()}`);
    const [s232, c232] = e232;
    return { matched: g33(t232, (t322, e322) => {
      const n322 = o33(s232, e322, r232), i322 = o33(c232, t322, r232);
      return n322 && i322;
    }), selections: n232 };
  }, getSelectionKeys: () => 0 === e232.length ? [] : [...s33(e232[0]), ...s33(e232[1])] }) });
}, intersection: m33, union: d33, not: function(e232) {
  return u33({ [t33]: () => ({ match: (t232) => ({ matched: !o33(e232, t232, () => {
  }) }), getSelectionKeys: () => [], matcherType: "not" }) });
}, when: y33, select: p33, any: S33, _: O33, string: E33, number: x33, bigint: P24, boolean: T33, symbol: k33, nullish: B33, nonNullable: _33, instanceOf: function(t232) {
  return u33(y33(/* @__PURE__ */ function(t322) {
    return (e232) => e232 instanceof t322;
  }(t232)));
}, shape: function(t232) {
  return u33(y33(a33(t232)));
} };
var KEYS53 = {
  ArrayExpression: [
    "elements"
  ],
  ArrayPattern: [
    "elements"
  ],
  ArrowFunctionExpression: [
    "params",
    "body"
  ],
  AssignmentExpression: [
    "left",
    "right"
  ],
  AssignmentPattern: [
    "left",
    "right"
  ],
  AwaitExpression: [
    "argument"
  ],
  BinaryExpression: [
    "left",
    "right"
  ],
  BlockStatement: [
    "body"
  ],
  BreakStatement: [
    "label"
  ],
  CallExpression: [
    "callee",
    "arguments"
  ],
  CatchClause: [
    "param",
    "body"
  ],
  ChainExpression: [
    "expression"
  ],
  ClassBody: [
    "body"
  ],
  ClassDeclaration: [
    "id",
    "superClass",
    "body"
  ],
  ClassExpression: [
    "id",
    "superClass",
    "body"
  ],
  ConditionalExpression: [
    "test",
    "consequent",
    "alternate"
  ],
  ContinueStatement: [
    "label"
  ],
  DebuggerStatement: [],
  DoWhileStatement: [
    "body",
    "test"
  ],
  EmptyStatement: [],
  ExperimentalRestProperty: [
    "argument"
  ],
  ExperimentalSpreadProperty: [
    "argument"
  ],
  ExportAllDeclaration: [
    "exported",
    "source"
  ],
  ExportDefaultDeclaration: [
    "declaration"
  ],
  ExportNamedDeclaration: [
    "declaration",
    "specifiers",
    "source"
  ],
  ExportSpecifier: [
    "exported",
    "local"
  ],
  ExpressionStatement: [
    "expression"
  ],
  ForInStatement: [
    "left",
    "right",
    "body"
  ],
  ForOfStatement: [
    "left",
    "right",
    "body"
  ],
  ForStatement: [
    "init",
    "test",
    "update",
    "body"
  ],
  FunctionDeclaration: [
    "id",
    "params",
    "body"
  ],
  FunctionExpression: [
    "id",
    "params",
    "body"
  ],
  Identifier: [],
  IfStatement: [
    "test",
    "consequent",
    "alternate"
  ],
  ImportDeclaration: [
    "specifiers",
    "source"
  ],
  ImportDefaultSpecifier: [
    "local"
  ],
  ImportExpression: [
    "source"
  ],
  ImportNamespaceSpecifier: [
    "local"
  ],
  ImportSpecifier: [
    "imported",
    "local"
  ],
  JSXAttribute: [
    "name",
    "value"
  ],
  JSXClosingElement: [
    "name"
  ],
  JSXClosingFragment: [],
  JSXElement: [
    "openingElement",
    "children",
    "closingElement"
  ],
  JSXEmptyExpression: [],
  JSXExpressionContainer: [
    "expression"
  ],
  JSXFragment: [
    "openingFragment",
    "children",
    "closingFragment"
  ],
  JSXIdentifier: [],
  JSXMemberExpression: [
    "object",
    "property"
  ],
  JSXNamespacedName: [
    "namespace",
    "name"
  ],
  JSXOpeningElement: [
    "name",
    "attributes"
  ],
  JSXOpeningFragment: [],
  JSXSpreadAttribute: [
    "argument"
  ],
  JSXSpreadChild: [
    "expression"
  ],
  JSXText: [],
  LabeledStatement: [
    "label",
    "body"
  ],
  Literal: [],
  LogicalExpression: [
    "left",
    "right"
  ],
  MemberExpression: [
    "object",
    "property"
  ],
  MetaProperty: [
    "meta",
    "property"
  ],
  MethodDefinition: [
    "key",
    "value"
  ],
  NewExpression: [
    "callee",
    "arguments"
  ],
  ObjectExpression: [
    "properties"
  ],
  ObjectPattern: [
    "properties"
  ],
  PrivateIdentifier: [],
  Program: [
    "body"
  ],
  Property: [
    "key",
    "value"
  ],
  PropertyDefinition: [
    "key",
    "value"
  ],
  RestElement: [
    "argument"
  ],
  ReturnStatement: [
    "argument"
  ],
  SequenceExpression: [
    "expressions"
  ],
  SpreadElement: [
    "argument"
  ],
  StaticBlock: [
    "body"
  ],
  Super: [],
  SwitchCase: [
    "test",
    "consequent"
  ],
  SwitchStatement: [
    "discriminant",
    "cases"
  ],
  TaggedTemplateExpression: [
    "tag",
    "quasi"
  ],
  TemplateElement: [],
  TemplateLiteral: [
    "quasis",
    "expressions"
  ],
  ThisExpression: [],
  ThrowStatement: [
    "argument"
  ],
  TryStatement: [
    "block",
    "handler",
    "finalizer"
  ],
  UnaryExpression: [
    "argument"
  ],
  UpdateExpression: [
    "argument"
  ],
  VariableDeclaration: [
    "declarations"
  ],
  VariableDeclarator: [
    "id",
    "init"
  ],
  WhileStatement: [
    "test",
    "body"
  ],
  WithStatement: [
    "object",
    "body"
  ],
  YieldExpression: [
    "argument"
  ]
};
var NODE_TYPES53 = Object.keys(KEYS53);
for (const type of NODE_TYPES53) {
  Object.freeze(KEYS53[type]);
}
Object.freeze(KEYS53);
var visitor_keys_default53 = KEYS53;
var KEY_BLACKLIST53 = /* @__PURE__ */ new Set([
  "parent",
  "leadingComments",
  "trailingComments"
]);
function filterKey53(key) {
  return !KEY_BLACKLIST53.has(key) && key[0] !== "_";
}
function getKeys53(node) {
  return Object.keys(node).filter(filterKey53);
}
function getInnermostScope53(initialScope, node) {
  const location = node.range[0];
  let scope = initialScope;
  let found = false;
  do {
    found = false;
    for (const childScope of scope.childScopes) {
      const range24 = childScope.block.range;
      if (range24[0] <= location && location < range24[1]) {
        scope = childScope;
        found = true;
        break;
      }
    }
  } while (found);
  return scope;
}
function findVariable243(initialScope, nameOrNode) {
  let name22 = "";
  let scope = initialScope;
  if (typeof nameOrNode === "string") {
    name22 = nameOrNode;
  } else {
    name22 = nameOrNode.name;
    scope = getInnermostScope53(scope, nameOrNode);
  }
  while (scope != null) {
    const variable = scope.set.get(name22);
    if (variable != null) {
      return variable;
    }
    scope = scope.upper;
  }
  return null;
}
function negate053(token) {
  return !this(token);
}
function negate53(f232) {
  return negate053.bind(f232);
}
function isPunctuatorTokenWithValue53(token, value) {
  return token.type === "Punctuator" && token.value === value;
}
function isArrowToken53(token) {
  return isPunctuatorTokenWithValue53(token, "=>");
}
function isCommaToken53(token) {
  return isPunctuatorTokenWithValue53(token, ",");
}
function isSemicolonToken53(token) {
  return isPunctuatorTokenWithValue53(token, ";");
}
function isColonToken53(token) {
  return isPunctuatorTokenWithValue53(token, ":");
}
function isOpeningParenToken53(token) {
  return isPunctuatorTokenWithValue53(token, "(");
}
function isClosingParenToken53(token) {
  return isPunctuatorTokenWithValue53(token, ")");
}
function isOpeningBracketToken53(token) {
  return isPunctuatorTokenWithValue53(token, "[");
}
function isClosingBracketToken53(token) {
  return isPunctuatorTokenWithValue53(token, "]");
}
function isOpeningBraceToken53(token) {
  return isPunctuatorTokenWithValue53(token, "{");
}
function isClosingBraceToken53(token) {
  return isPunctuatorTokenWithValue53(token, "}");
}
function isCommentToken53(token) {
  return ["Block", "Line", "Shebang"].includes(token.type);
}
negate53(isArrowToken53);
negate53(isCommaToken53);
negate53(isSemicolonToken53);
negate53(isColonToken53);
negate53(isOpeningParenToken53);
negate53(isClosingParenToken53);
negate53(isOpeningBracketToken53);
negate53(isClosingBracketToken53);
negate53(isOpeningBraceToken53);
negate53(isClosingBraceToken53);
negate53(isCommentToken53);
function getOpeningParenOfParams53(node, sourceCode) {
  return node.id ? sourceCode.getTokenAfter(node.id, isOpeningParenToken53) : sourceCode.getFirstToken(node, isOpeningParenToken53);
}
function getFunctionHeadLocation53(node, sourceCode) {
  const parent = node.parent;
  let start = null;
  let end = null;
  if (node.type === "ArrowFunctionExpression") {
    const arrowToken = sourceCode.getTokenBefore(node.body, isArrowToken53);
    start = arrowToken.loc.start;
    end = arrowToken.loc.end;
  } else if (parent.type === "Property" || parent.type === "MethodDefinition" || parent.type === "PropertyDefinition") {
    start = parent.loc.start;
    end = getOpeningParenOfParams53(node, sourceCode).loc.start;
  } else {
    start = node.loc.start;
    end = getOpeningParenOfParams53(node, sourceCode).loc.start;
  }
  return {
    start: { ...start },
    end: { ...end }
  };
}
var globalObject53 = typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {};
var builtinNames53 = Object.freeze(
  /* @__PURE__ */ new Set([
    "Array",
    "ArrayBuffer",
    "BigInt",
    "BigInt64Array",
    "BigUint64Array",
    "Boolean",
    "DataView",
    "Date",
    "decodeURI",
    "decodeURIComponent",
    "encodeURI",
    "encodeURIComponent",
    "escape",
    "Float32Array",
    "Float64Array",
    "Function",
    "Infinity",
    "Int16Array",
    "Int32Array",
    "Int8Array",
    "isFinite",
    "isNaN",
    "isPrototypeOf",
    "JSON",
    "Map",
    "Math",
    "NaN",
    "Number",
    "Object",
    "parseFloat",
    "parseInt",
    "Promise",
    "Proxy",
    "Reflect",
    "RegExp",
    "Set",
    "String",
    "Symbol",
    "Uint16Array",
    "Uint32Array",
    "Uint8Array",
    "Uint8ClampedArray",
    "undefined",
    "unescape",
    "WeakMap",
    "WeakSet"
  ])
);
var callAllowed53 = new Set(
  [
    Array.isArray,
    Array.of,
    Array.prototype.at,
    Array.prototype.concat,
    Array.prototype.entries,
    Array.prototype.every,
    Array.prototype.filter,
    Array.prototype.find,
    Array.prototype.findIndex,
    Array.prototype.flat,
    Array.prototype.includes,
    Array.prototype.indexOf,
    Array.prototype.join,
    Array.prototype.keys,
    Array.prototype.lastIndexOf,
    Array.prototype.slice,
    Array.prototype.some,
    Array.prototype.toString,
    Array.prototype.values,
    typeof BigInt === "function" ? BigInt : void 0,
    Boolean,
    Date,
    Date.parse,
    decodeURI,
    decodeURIComponent,
    encodeURI,
    encodeURIComponent,
    escape,
    isFinite,
    isNaN,
    isPrototypeOf,
    Map,
    Map.prototype.entries,
    Map.prototype.get,
    Map.prototype.has,
    Map.prototype.keys,
    Map.prototype.values,
    ...Object.getOwnPropertyNames(Math).filter((k232) => k232 !== "random").map((k232) => Math[k232]).filter((f232) => typeof f232 === "function"),
    Number,
    Number.isFinite,
    Number.isNaN,
    Number.parseFloat,
    Number.parseInt,
    Number.prototype.toExponential,
    Number.prototype.toFixed,
    Number.prototype.toPrecision,
    Number.prototype.toString,
    Object,
    Object.entries,
    Object.is,
    Object.isExtensible,
    Object.isFrozen,
    Object.isSealed,
    Object.keys,
    Object.values,
    parseFloat,
    parseInt,
    RegExp,
    Set,
    Set.prototype.entries,
    Set.prototype.has,
    Set.prototype.keys,
    Set.prototype.values,
    String,
    String.fromCharCode,
    String.fromCodePoint,
    String.raw,
    String.prototype.at,
    String.prototype.charAt,
    String.prototype.charCodeAt,
    String.prototype.codePointAt,
    String.prototype.concat,
    String.prototype.endsWith,
    String.prototype.includes,
    String.prototype.indexOf,
    String.prototype.lastIndexOf,
    String.prototype.normalize,
    String.prototype.padEnd,
    String.prototype.padStart,
    String.prototype.slice,
    String.prototype.startsWith,
    String.prototype.substr,
    String.prototype.substring,
    String.prototype.toLowerCase,
    String.prototype.toString,
    String.prototype.toUpperCase,
    String.prototype.trim,
    String.prototype.trimEnd,
    String.prototype.trimLeft,
    String.prototype.trimRight,
    String.prototype.trimStart,
    Symbol.for,
    Symbol.keyFor,
    unescape
  ].filter((f232) => typeof f232 === "function")
);
var callPassThrough53 = /* @__PURE__ */ new Set([
  Object.freeze,
  Object.preventExtensions,
  Object.seal
]);
var getterAllowed53 = [
  [Map, /* @__PURE__ */ new Set(["size"])],
  [
    RegExp,
    /* @__PURE__ */ new Set([
      "dotAll",
      "flags",
      "global",
      "hasIndices",
      "ignoreCase",
      "multiline",
      "source",
      "sticky",
      "unicode"
    ])
  ],
  [Set, /* @__PURE__ */ new Set(["size"])]
];
function getPropertyDescriptor53(object32, name22) {
  let x232 = object32;
  while ((typeof x232 === "object" || typeof x232 === "function") && x232 !== null) {
    const d232 = Object.getOwnPropertyDescriptor(x232, name22);
    if (d232) {
      return d232;
    }
    x232 = Object.getPrototypeOf(x232);
  }
  return null;
}
function isGetter53(object32, name22) {
  const d232 = getPropertyDescriptor53(object32, name22);
  return d232 != null && d232.get != null;
}
function getElementValues53(nodeList, initialScope) {
  const valueList = [];
  for (let i232 = 0; i232 < nodeList.length; ++i232) {
    const elementNode = nodeList[i232];
    if (elementNode == null) {
      valueList.length = i232 + 1;
    } else if (elementNode.type === "SpreadElement") {
      const argument = getStaticValueR53(elementNode.argument, initialScope);
      if (argument == null) {
        return null;
      }
      valueList.push(...argument.value);
    } else {
      const element = getStaticValueR53(elementNode, initialScope);
      if (element == null) {
        return null;
      }
      valueList.push(element.value);
    }
  }
  return valueList;
}
function isEffectivelyConst53(variable) {
  const refs = variable.references;
  const inits = refs.filter((r232) => r232.init).length;
  const reads = refs.filter((r232) => r232.isReadOnly()).length;
  if (inits === 1 && reads + inits === refs.length) {
    return true;
  }
  return false;
}
var operations53 = Object.freeze({
  ArrayExpression(node, initialScope) {
    const elements = getElementValues53(node.elements, initialScope);
    return elements != null ? { value: elements } : null;
  },
  AssignmentExpression(node, initialScope) {
    if (node.operator === "=") {
      return getStaticValueR53(node.right, initialScope);
    }
    return null;
  },
  //eslint-disable-next-line complexity
  BinaryExpression(node, initialScope) {
    if (node.operator === "in" || node.operator === "instanceof") {
      return null;
    }
    const left334 = getStaticValueR53(node.left, initialScope);
    const right334 = getStaticValueR53(node.right, initialScope);
    if (left334 != null && right334 != null) {
      switch (node.operator) {
        case "==":
          return { value: left334.value == right334.value };
        case "!=":
          return { value: left334.value != right334.value };
        case "===":
          return { value: left334.value === right334.value };
        case "!==":
          return { value: left334.value !== right334.value };
        case "<":
          return { value: left334.value < right334.value };
        case "<=":
          return { value: left334.value <= right334.value };
        case ">":
          return { value: left334.value > right334.value };
        case ">=":
          return { value: left334.value >= right334.value };
        case "<<":
          return { value: left334.value << right334.value };
        case ">>":
          return { value: left334.value >> right334.value };
        case ">>>":
          return { value: left334.value >>> right334.value };
        case "+":
          return { value: left334.value + right334.value };
        case "-":
          return { value: left334.value - right334.value };
        case "*":
          return { value: left334.value * right334.value };
        case "/":
          return { value: left334.value / right334.value };
        case "%":
          return { value: left334.value % right334.value };
        case "**":
          return { value: left334.value ** right334.value };
        case "|":
          return { value: left334.value | right334.value };
        case "^":
          return { value: left334.value ^ right334.value };
        case "&":
          return { value: left334.value & right334.value };
      }
    }
    return null;
  },
  CallExpression(node, initialScope) {
    const calleeNode = node.callee;
    const args = getElementValues53(node.arguments, initialScope);
    if (args != null) {
      if (calleeNode.type === "MemberExpression") {
        if (calleeNode.property.type === "PrivateIdentifier") {
          return null;
        }
        const object32 = getStaticValueR53(calleeNode.object, initialScope);
        if (object32 != null) {
          if (object32.value == null && (object32.optional || node.optional)) {
            return { value: void 0, optional: true };
          }
          const property = getStaticPropertyNameValue53(
            calleeNode,
            initialScope
          );
          if (property != null) {
            const receiver = object32.value;
            const methodName = property.value;
            if (callAllowed53.has(receiver[methodName])) {
              return { value: receiver[methodName](...args) };
            }
            if (callPassThrough53.has(receiver[methodName])) {
              return { value: args[0] };
            }
          }
        }
      } else {
        const callee = getStaticValueR53(calleeNode, initialScope);
        if (callee != null) {
          if (callee.value == null && node.optional) {
            return { value: void 0, optional: true };
          }
          const func = callee.value;
          if (callAllowed53.has(func)) {
            return { value: func(...args) };
          }
          if (callPassThrough53.has(func)) {
            return { value: args[0] };
          }
        }
      }
    }
    return null;
  },
  ConditionalExpression(node, initialScope) {
    const test = getStaticValueR53(node.test, initialScope);
    if (test != null) {
      return test.value ? getStaticValueR53(node.consequent, initialScope) : getStaticValueR53(node.alternate, initialScope);
    }
    return null;
  },
  ExpressionStatement(node, initialScope) {
    return getStaticValueR53(node.expression, initialScope);
  },
  Identifier(node, initialScope) {
    if (initialScope != null) {
      const variable = findVariable243(initialScope, node);
      if (variable != null && variable.defs.length === 0 && builtinNames53.has(variable.name) && variable.name in globalObject53) {
        return { value: globalObject53[variable.name] };
      }
      if (variable != null && variable.defs.length === 1) {
        const def = variable.defs[0];
        if (def.parent && def.type === "Variable" && (def.parent.kind === "const" || isEffectivelyConst53(variable)) && // TODO(mysticatea): don't support destructuring here.
        def.node.id.type === "Identifier") {
          return getStaticValueR53(def.node.init, initialScope);
        }
      }
    }
    return null;
  },
  Literal(node) {
    if ((node.regex != null || node.bigint != null) && node.value == null) {
      return null;
    }
    return { value: node.value };
  },
  LogicalExpression(node, initialScope) {
    const left334 = getStaticValueR53(node.left, initialScope);
    if (left334 != null) {
      if (node.operator === "||" && Boolean(left334.value) === true || node.operator === "&&" && Boolean(left334.value) === false || node.operator === "??" && left334.value != null) {
        return left334;
      }
      const right334 = getStaticValueR53(node.right, initialScope);
      if (right334 != null) {
        return right334;
      }
    }
    return null;
  },
  MemberExpression(node, initialScope) {
    if (node.property.type === "PrivateIdentifier") {
      return null;
    }
    const object32 = getStaticValueR53(node.object, initialScope);
    if (object32 != null) {
      if (object32.value == null && (object32.optional || node.optional)) {
        return { value: void 0, optional: true };
      }
      const property = getStaticPropertyNameValue53(node, initialScope);
      if (property != null) {
        if (!isGetter53(object32.value, property.value)) {
          return { value: object32.value[property.value] };
        }
        for (const [classFn, allowed] of getterAllowed53) {
          if (object32.value instanceof classFn && allowed.has(property.value)) {
            return { value: object32.value[property.value] };
          }
        }
      }
    }
    return null;
  },
  ChainExpression(node, initialScope) {
    const expression = getStaticValueR53(node.expression, initialScope);
    if (expression != null) {
      return { value: expression.value };
    }
    return null;
  },
  NewExpression(node, initialScope) {
    const callee = getStaticValueR53(node.callee, initialScope);
    const args = getElementValues53(node.arguments, initialScope);
    if (callee != null && args != null) {
      const Func = callee.value;
      if (callAllowed53.has(Func)) {
        return { value: new Func(...args) };
      }
    }
    return null;
  },
  ObjectExpression(node, initialScope) {
    const object32 = {};
    for (const propertyNode of node.properties) {
      if (propertyNode.type === "Property") {
        if (propertyNode.kind !== "init") {
          return null;
        }
        const key = getStaticPropertyNameValue53(
          propertyNode,
          initialScope
        );
        const value = getStaticValueR53(propertyNode.value, initialScope);
        if (key == null || value == null) {
          return null;
        }
        object32[key.value] = value.value;
      } else if (propertyNode.type === "SpreadElement" || propertyNode.type === "ExperimentalSpreadProperty") {
        const argument = getStaticValueR53(
          propertyNode.argument,
          initialScope
        );
        if (argument == null) {
          return null;
        }
        Object.assign(object32, argument.value);
      } else {
        return null;
      }
    }
    return { value: object32 };
  },
  SequenceExpression(node, initialScope) {
    const last24 = node.expressions[node.expressions.length - 1];
    return getStaticValueR53(last24, initialScope);
  },
  TaggedTemplateExpression(node, initialScope) {
    const tag = getStaticValueR53(node.tag, initialScope);
    const expressions = getElementValues53(
      node.quasi.expressions,
      initialScope
    );
    if (tag != null && expressions != null) {
      const func = tag.value;
      const strings = node.quasi.quasis.map((q) => q.value.cooked);
      strings.raw = node.quasi.quasis.map((q) => q.value.raw);
      if (func === String.raw) {
        return { value: func(strings, ...expressions) };
      }
    }
    return null;
  },
  TemplateLiteral(node, initialScope) {
    const expressions = getElementValues53(node.expressions, initialScope);
    if (expressions != null) {
      let value = node.quasis[0].value.cooked;
      for (let i232 = 0; i232 < expressions.length; ++i232) {
        value += expressions[i232];
        value += node.quasis[i232 + 1].value.cooked;
      }
      return { value };
    }
    return null;
  },
  UnaryExpression(node, initialScope) {
    if (node.operator === "delete") {
      return null;
    }
    if (node.operator === "void") {
      return { value: void 0 };
    }
    const arg = getStaticValueR53(node.argument, initialScope);
    if (arg != null) {
      switch (node.operator) {
        case "-":
          return { value: -arg.value };
        case "+":
          return { value: +arg.value };
        case "!":
          return { value: !arg.value };
        case "~":
          return { value: ~arg.value };
        case "typeof":
          return { value: typeof arg.value };
      }
    }
    return null;
  }
});
function getStaticValueR53(node, initialScope) {
  if (node != null && Object.hasOwnProperty.call(operations53, node.type)) {
    return operations53[node.type](node, initialScope);
  }
  return null;
}
function getStaticPropertyNameValue53(node, initialScope) {
  const nameNode = node.type === "Property" ? node.key : node.property;
  if (node.computed) {
    return getStaticValueR53(nameNode, initialScope);
  }
  if (nameNode.type === "Identifier") {
    return { value: nameNode.name };
  }
  if (nameNode.type === "Literal") {
    if (nameNode.bigint) {
      return { value: nameNode.bigint };
    }
    return { value: String(nameNode.value) };
  }
  return null;
}
function getStaticValue53(node, initialScope = null) {
  try {
    return getStaticValueR53(node, initialScope);
  } catch (_error) {
    return null;
  }
}
function getStringIfConstant53(node, initialScope = null) {
  if (node && node.type === "Literal" && node.value === null) {
    if (node.regex) {
      return `/${node.regex.pattern}/${node.regex.flags}`;
    }
    if (node.bigint) {
      return node.bigint;
    }
  }
  const evaluated = getStaticValue53(node, initialScope);
  return evaluated && String(evaluated.value);
}
function getPropertyName53(node, initialScope) {
  switch (node.type) {
    case "MemberExpression":
      if (node.computed) {
        return getStringIfConstant53(node.property, initialScope);
      }
      if (node.property.type === "PrivateIdentifier") {
        return null;
      }
      return node.property.name;
    case "Property":
    case "MethodDefinition":
    case "PropertyDefinition":
      if (node.computed) {
        return getStringIfConstant53(node.key, initialScope);
      }
      if (node.key.type === "Literal") {
        return String(node.key.value);
      }
      if (node.key.type === "PrivateIdentifier") {
        return null;
      }
      return node.key.name;
  }
  return null;
}
function getFunctionNameWithKind53(node, sourceCode) {
  const parent = node.parent;
  const tokens = [];
  const isObjectMethod = parent.type === "Property" && parent.value === node;
  const isClassMethod = parent.type === "MethodDefinition" && parent.value === node;
  const isClassFieldMethod = parent.type === "PropertyDefinition" && parent.value === node;
  if (isClassMethod || isClassFieldMethod) {
    if (parent.static) {
      tokens.push("static");
    }
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push("private");
    }
  }
  if (node.async) {
    tokens.push("async");
  }
  if (node.generator) {
    tokens.push("generator");
  }
  if (isObjectMethod || isClassMethod) {
    if (parent.kind === "constructor") {
      return "constructor";
    }
    if (parent.kind === "get") {
      tokens.push("getter");
    } else if (parent.kind === "set") {
      tokens.push("setter");
    } else {
      tokens.push("method");
    }
  } else if (isClassFieldMethod) {
    tokens.push("method");
  } else {
    if (node.type === "ArrowFunctionExpression") {
      tokens.push("arrow");
    }
    tokens.push("function");
  }
  if (isObjectMethod || isClassMethod || isClassFieldMethod) {
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push(`#${parent.key.name}`);
    } else {
      const name22 = getPropertyName53(parent);
      if (name22) {
        tokens.push(`'${name22}'`);
      } else if (sourceCode) {
        const keyText = sourceCode.getText(parent.key);
        if (!keyText.includes("\n")) {
          tokens.push(`[${keyText}]`);
        }
      }
    }
  } else if (node.id) {
    tokens.push(`'${node.id.name}'`);
  } else if (parent.type === "VariableDeclarator" && parent.id && parent.id.type === "Identifier") {
    tokens.push(`'${parent.id.name}'`);
  } else if ((parent.type === "AssignmentExpression" || parent.type === "AssignmentPattern") && parent.left && parent.left.type === "Identifier") {
    tokens.push(`'${parent.left.name}'`);
  } else if (parent.type === "ExportDefaultDeclaration" && parent.declaration === node) {
    tokens.push("'default'");
  }
  return tokens.join(" ");
}
var typeConversionBinaryOps53 = Object.freeze(
  /* @__PURE__ */ new Set([
    "==",
    "!=",
    "<",
    "<=",
    ">",
    ">=",
    "<<",
    ">>",
    ">>>",
    "+",
    "-",
    "*",
    "/",
    "%",
    "|",
    "^",
    "&",
    "in"
  ])
);
var typeConversionUnaryOps53 = Object.freeze(/* @__PURE__ */ new Set(["-", "+", "!", "~"]));
function isNode53(x232) {
  return x232 !== null && typeof x232 === "object" && typeof x232.type === "string";
}
var visitor53 = Object.freeze(
  Object.assign(/* @__PURE__ */ Object.create(null), {
    $visit(node, options, visitorKeys) {
      const { type } = node;
      if (typeof this[type] === "function") {
        return this[type](node, options, visitorKeys);
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    $visitChildren(node, options, visitorKeys) {
      const { type } = node;
      for (const key of visitorKeys[type] || getKeys53(node)) {
        const value = node[key];
        if (Array.isArray(value)) {
          for (const element of value) {
            if (isNode53(element) && this.$visit(element, options, visitorKeys)) {
              return true;
            }
          }
        } else if (isNode53(value) && this.$visit(value, options, visitorKeys)) {
          return true;
        }
      }
      return false;
    },
    ArrowFunctionExpression() {
      return false;
    },
    AssignmentExpression() {
      return true;
    },
    AwaitExpression() {
      return true;
    },
    BinaryExpression(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && typeConversionBinaryOps53.has(node.operator) && (node.left.type !== "Literal" || node.right.type !== "Literal")) {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    CallExpression() {
      return true;
    },
    FunctionExpression() {
      return false;
    },
    ImportExpression() {
      return true;
    },
    MemberExpression(node, options, visitorKeys) {
      if (options.considerGetters) {
        return true;
      }
      if (options.considerImplicitTypeConversion && node.computed && node.property.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    MethodDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    NewExpression() {
      return true;
    },
    Property(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    PropertyDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UnaryExpression(node, options, visitorKeys) {
      if (node.operator === "delete") {
        return true;
      }
      if (options.considerImplicitTypeConversion && typeConversionUnaryOps53.has(node.operator) && node.argument.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UpdateExpression() {
      return true;
    },
    YieldExpression() {
      return true;
    }
  })
);
function hasSideEffect53(node, sourceCode, { considerGetters = false, considerImplicitTypeConversion = false } = {}) {
  return visitor53.$visit(
    node,
    { considerGetters, considerImplicitTypeConversion },
    sourceCode.visitorKeys || visitor_keys_default53
  );
}
function getParentSyntaxParen53(node, sourceCode) {
  const parent = node.parent;
  switch (parent.type) {
    case "CallExpression":
    case "NewExpression":
      if (parent.arguments.length === 1 && parent.arguments[0] === node) {
        return sourceCode.getTokenAfter(
          parent.callee,
          isOpeningParenToken53
        );
      }
      return null;
    case "DoWhileStatement":
      if (parent.test === node) {
        return sourceCode.getTokenAfter(
          parent.body,
          isOpeningParenToken53
        );
      }
      return null;
    case "IfStatement":
    case "WhileStatement":
      if (parent.test === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "ImportExpression":
      if (parent.source === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "SwitchStatement":
      if (parent.discriminant === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "WithStatement":
      if (parent.object === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    default:
      return null;
  }
}
function isParenthesized53(timesOrNode, nodeOrSourceCode, optionalSourceCode) {
  let times, node, sourceCode, maybeLeftParen, maybeRightParen;
  if (typeof timesOrNode === "number") {
    times = timesOrNode | 0;
    node = nodeOrSourceCode;
    sourceCode = optionalSourceCode;
    if (!(times >= 1)) {
      throw new TypeError("'times' should be a positive integer.");
    }
  } else {
    times = 1;
    node = timesOrNode;
    sourceCode = nodeOrSourceCode;
  }
  if (node == null || // `Program` can't be parenthesized
  node.parent == null || // `CatchClause.param` can't be parenthesized, example `try {} catch (error) {}`
  node.parent.type === "CatchClause" && node.parent.param === node) {
    return false;
  }
  maybeLeftParen = maybeRightParen = node;
  do {
    maybeLeftParen = sourceCode.getTokenBefore(maybeLeftParen);
    maybeRightParen = sourceCode.getTokenAfter(maybeRightParen);
  } while (maybeLeftParen != null && maybeRightParen != null && isOpeningParenToken53(maybeLeftParen) && isClosingParenToken53(maybeRightParen) && // Avoid false positive such as `if (a) {}`
  maybeLeftParen !== getParentSyntaxParen53(node, sourceCode) && --times > 0);
  return times === 0;
}
Function.call.bind(Object.hasOwnProperty);
var __defProp243 = Object.defineProperty;
var __export243 = (target, all334) => {
  for (var name22 in all334)
    __defProp243(target, name22, { get: all334[name22], enumerable: true });
};
var NodeType53 = types.AST_NODE_TYPES;
var is53 = utils.ASTUtils.isNodeOfType;
var isOneOf53 = utils.ASTUtils.isNodeOfTypes;
isOneOf53([
  NodeType53.ArrowFunctionExpression,
  NodeType53.FunctionDeclaration,
  NodeType53.FunctionExpression
]);
isOneOf53([
  NodeType53.ArrowFunctionExpression,
  NodeType53.FunctionDeclaration,
  NodeType53.FunctionExpression,
  NodeType53.TSCallSignatureDeclaration,
  NodeType53.TSConstructSignatureDeclaration,
  NodeType53.TSDeclareFunction,
  NodeType53.TSEmptyBodyFunctionExpression,
  NodeType53.TSFunctionType,
  NodeType53.TSMethodSignature
]);
isOneOf53([NodeType53.ClassDeclaration, NodeType53.ClassExpression]);
isOneOf53([
  NodeType53.DoWhileStatement,
  NodeType53.ForInStatement,
  NodeType53.ForOfStatement,
  NodeType53.ForStatement,
  NodeType53.WhileStatement
]);
isOneOf53([NodeType53.TSArrayType, NodeType53.TSTupleType]);
isOneOf53([
  NodeType53.PropertyDefinition,
  NodeType53.TSIndexSignature,
  NodeType53.TSParameterProperty,
  NodeType53.TSPropertySignature
]);
is53(NodeType53.JSXElement);
is53(NodeType53.JSXFragment);
isOneOf53([
  NodeType53.JSXAttribute,
  NodeType53.JSXSpreadChild,
  NodeType53.JSXClosingElement,
  NodeType53.JSXClosingFragment,
  NodeType53.JSXElement,
  NodeType53.JSXEmptyExpression,
  NodeType53.JSXExpressionContainer,
  NodeType53.JSXFragment,
  NodeType53.JSXIdentifier,
  NodeType53.JSXMemberExpression,
  NodeType53.JSXNamespacedName,
  NodeType53.JSXOpeningElement,
  NodeType53.JSXOpeningFragment,
  NodeType53.JSXSpreadAttribute,
  NodeType53.JSXSpreadChild,
  NodeType53.JSXText
]);
isOneOf53([
  NodeType53.JSXIdentifier,
  NodeType53.JSXMemberExpression,
  NodeType53.JSXNamespacedName
]);
isOneOf53([
  NodeType53.ArrayPattern,
  NodeType53.AssignmentPattern,
  NodeType53.ObjectPattern,
  NodeType53.RestElement
]);
isOneOf53([
  NodeType53.TSInterfaceDeclaration,
  NodeType53.TSTypeAliasDeclaration
]);
isOneOf53([
  NodeType53.ArrayExpression,
  NodeType53.ArrayPattern,
  NodeType53.ArrowFunctionExpression,
  NodeType53.CallExpression,
  NodeType53.ClassExpression,
  NodeType53.FunctionExpression,
  NodeType53.Identifier,
  NodeType53.JSXElement,
  NodeType53.JSXFragment,
  NodeType53.Literal,
  NodeType53.TemplateLiteral,
  NodeType53.MemberExpression,
  NodeType53.MetaProperty,
  NodeType53.ObjectExpression,
  NodeType53.ObjectPattern,
  NodeType53.SequenceExpression,
  NodeType53.Super,
  NodeType53.TaggedTemplateExpression,
  NodeType53.ThisExpression
]);
isOneOf53([
  NodeType53.ArrayExpression,
  NodeType53.ArrayPattern,
  NodeType53.ArrowFunctionExpression,
  NodeType53.CallExpression,
  NodeType53.ClassExpression,
  NodeType53.FunctionExpression,
  NodeType53.Identifier,
  NodeType53.JSXElement,
  NodeType53.JSXFragment,
  NodeType53.Literal,
  NodeType53.TemplateLiteral,
  NodeType53.MemberExpression,
  NodeType53.MetaProperty,
  NodeType53.ObjectExpression,
  NodeType53.ObjectPattern,
  NodeType53.SequenceExpression,
  NodeType53.Super,
  NodeType53.TaggedTemplateExpression,
  NodeType53.ThisExpression,
  NodeType53.TSAsExpression,
  NodeType53.TSNonNullExpression,
  NodeType53.TSTypeAssertion
]);
var Function_exports243 = {};
__export243(Function_exports243, {
  SK: () => SK243,
  absurd: () => absurd243,
  apply: () => apply243,
  compose: () => compose253,
  constFalse: () => constFalse243,
  constNull: () => constNull243,
  constTrue: () => constTrue243,
  constUndefined: () => constUndefined243,
  constVoid: () => constVoid243,
  constant: () => constant243,
  dual: () => dual243,
  flip: () => flip243,
  flow: () => flow243,
  hole: () => hole243,
  identity: () => identity243,
  isFunction: () => isFunction2243,
  pipe: () => pipe243,
  satisfies: () => satisfies243,
  tupled: () => tupled243,
  unsafeCoerce: () => unsafeCoerce243,
  untupled: () => untupled243
});
var isFunction2243 = (input) => typeof input === "function";
var dual243 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a232, b232) {
        if (arguments.length >= 2) {
          return body(a232, b232);
        }
        return function(self2) {
          return body(self2, a232);
        };
      };
    case 3:
      return function(a232, b232, c232) {
        if (arguments.length >= 3) {
          return body(a232, b232, c232);
        }
        return function(self2) {
          return body(self2, a232, b232);
        };
      };
    case 4:
      return function(a232, b232, c232, d232) {
        if (arguments.length >= 4) {
          return body(a232, b232, c232, d232);
        }
        return function(self2) {
          return body(self2, a232, b232, c232);
        };
      };
    case 5:
      return function(a232, b232, c232, d232, e232) {
        if (arguments.length >= 5) {
          return body(a232, b232, c232, d232, e232);
        }
        return function(self2) {
          return body(self2, a232, b232, c232, d232);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply243 = (a232) => (self2) => self2(a232);
var identity243 = (a232) => a232;
var satisfies243 = () => (b232) => b232;
var unsafeCoerce243 = identity243;
var constant243 = (value) => () => value;
var constTrue243 = /* @__PURE__ */ constant243(true);
var constFalse243 = /* @__PURE__ */ constant243(false);
var constNull243 = /* @__PURE__ */ constant243(null);
var constUndefined243 = /* @__PURE__ */ constant243(void 0);
var constVoid243 = constUndefined243;
var flip243 = (f232) => (...b232) => (...a232) => f232(...a232)(...b232);
var compose253 = /* @__PURE__ */ dual243(2, (ab, bc) => (a232) => bc(ab(a232)));
var absurd243 = (_232) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled243 = (f232) => (a232) => f232(...a232);
var untupled243 = (f232) => (...a232) => f232(a232);
function pipe243(a232, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a232;
    case 2:
      return ab(a232);
    case 3:
      return bc(ab(a232));
    case 4:
      return cd(bc(ab(a232)));
    case 5:
      return de(cd(bc(ab(a232))));
    case 6:
      return ef(de(cd(bc(ab(a232)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a232))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a232)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a232))))))));
    default: {
      let ret = arguments[0];
      for (let i232 = 1; i232 < arguments.length; i232++) {
        ret = arguments[i232](ret);
      }
      return ret;
    }
  }
}
function flow243(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole243 = /* @__PURE__ */ unsafeCoerce243(absurd243);
var SK243 = (_232, b232) => b232;
var make453 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_343 = (map622) => dual243(3, (self2, name22, f232) => map622(self2, (a232) => Object.assign({}, a232, {
  [name22]: f232(a232)
})));
var bindTo343 = (map622) => dual243(2, (self2, name22) => map622(self2, (a232) => ({
  [name22]: a232
})));
var bind343 = (map622, flatMap424) => dual243(3, (self2, name22, f232) => flatMap424(self2, (a232) => map622(f232(a232), (b232) => Object.assign({}, a232, {
  [name22]: b232
}))));
var moduleVersion243 = "3.2.8";
var getCurrentVersion243 = () => moduleVersion243;
var globalStoreId243 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion243()}`);
if (!(globalStoreId243 in globalThis)) {
  globalThis[globalStoreId243] = /* @__PURE__ */ new Map();
}
var globalStore243 = globalThis[globalStoreId243];
var globalValue243 = (id, compute) => {
  if (!globalStore243.has(id)) {
    globalStore243.set(id, compute());
  }
  return globalStore243.get(id);
};
var Predicate_exports243 = {};
__export243(Predicate_exports243, {
  all: () => all253,
  and: () => and73,
  compose: () => compose2243,
  eqv: () => eqv73,
  every: () => every83,
  hasProperty: () => hasProperty243,
  implies: () => implies73,
  isBigInt: () => isBigInt73,
  isBoolean: () => isBoolean73,
  isDate: () => isDate73,
  isError: () => isError73,
  isFunction: () => isFunction3243,
  isIterable: () => isIterable73,
  isMap: () => isMap73,
  isNever: () => isNever73,
  isNotNull: () => isNotNull73,
  isNotNullable: () => isNotNullable73,
  isNotUndefined: () => isNotUndefined73,
  isNull: () => isNull73,
  isNullable: () => isNullable243,
  isNumber: () => isNumber73,
  isObject: () => isObject243,
  isPromise: () => isPromise73,
  isPromiseLike: () => isPromiseLike73,
  isReadonlyRecord: () => isReadonlyRecord73,
  isRecord: () => isRecord73,
  isSet: () => isSet73,
  isString: () => isString73,
  isSymbol: () => isSymbol73,
  isTagged: () => isTagged73,
  isTruthy: () => isTruthy73,
  isUint8Array: () => isUint8Array73,
  isUndefined: () => isUndefined73,
  isUnknown: () => isUnknown73,
  mapInput: () => mapInput83,
  nand: () => nand73,
  nor: () => nor73,
  not: () => not73,
  or: () => or73,
  product: () => product253,
  productMany: () => productMany253,
  some: () => some353,
  struct: () => struct93,
  tuple: () => tuple83,
  xor: () => xor73
});
var mapInput83 = /* @__PURE__ */ dual243(2, (self2, f232) => (b232) => self2(f232(b232)));
var isTruthy73 = (input) => !!input;
var isSet73 = (input) => input instanceof Set;
var isMap73 = (input) => input instanceof Map;
var isString73 = (input) => typeof input === "string";
var isNumber73 = (input) => typeof input === "number";
var isBoolean73 = (input) => typeof input === "boolean";
var isBigInt73 = (input) => typeof input === "bigint";
var isSymbol73 = (input) => typeof input === "symbol";
var isFunction3243 = isFunction2243;
var isUndefined73 = (input) => input === void 0;
var isNotUndefined73 = (input) => input !== void 0;
var isNull73 = (input) => input === null;
var isNotNull73 = (input) => input !== null;
var isNever73 = (_232) => false;
var isUnknown73 = (_232) => true;
var isRecordOrArray243 = (input) => typeof input === "object" && input !== null;
var isObject243 = (input) => isRecordOrArray243(input) || isFunction3243(input);
var hasProperty243 = /* @__PURE__ */ dual243(2, (self2, property) => isObject243(self2) && property in self2);
var isTagged73 = /* @__PURE__ */ dual243(2, (self2, tag) => hasProperty243(self2, "_tag") && self2["_tag"] === tag);
var isNullable243 = (input) => input === null || input === void 0;
var isNotNullable73 = (input) => input !== null && input !== void 0;
var isError73 = (input) => input instanceof Error;
var isUint8Array73 = (input) => input instanceof Uint8Array;
var isDate73 = (input) => input instanceof Date;
var isIterable73 = (input) => hasProperty243(input, Symbol.iterator);
var isRecord73 = (input) => isRecordOrArray243(input) && !Array.isArray(input);
var isReadonlyRecord73 = isRecord73;
var isPromise73 = (input) => hasProperty243(input, "then") && "catch" in input && isFunction3243(input.then) && isFunction3243(input.catch);
var isPromiseLike73 = (input) => hasProperty243(input, "then") && isFunction3243(input.then);
var compose2243 = /* @__PURE__ */ dual243(2, (ab, bc) => (a232) => ab(a232) && bc(a232));
var product253 = (self2, that) => ([a232, b232]) => self2(a232) && that(b232);
var all253 = (collection) => {
  return (as2234) => {
    let collectionIndex = 0;
    for (const p232 of collection) {
      if (collectionIndex >= as2234.length) {
        break;
      }
      if (p232(as2234[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany253 = (self2, collection) => {
  const rest = all253(collection);
  return ([head222, ...tail34]) => self2(head222) === false ? false : rest(tail34);
};
var tuple83 = (...elements) => all253(elements);
var struct93 = (fields) => {
  const keys234 = Object.keys(fields);
  return (a232) => {
    for (const key of keys234) {
      if (!fields[key](a232[key])) {
        return false;
      }
    }
    return true;
  };
};
var not73 = (self2) => (a232) => !self2(a232);
var or73 = /* @__PURE__ */ dual243(2, (self2, that) => (a232) => self2(a232) || that(a232));
var and73 = /* @__PURE__ */ dual243(2, (self2, that) => (a232) => self2(a232) && that(a232));
var xor73 = /* @__PURE__ */ dual243(2, (self2, that) => (a232) => self2(a232) !== that(a232));
var eqv73 = /* @__PURE__ */ dual243(2, (self2, that) => (a232) => self2(a232) === that(a232));
var implies73 = /* @__PURE__ */ dual243(2, (self2, that) => (a232) => self2(a232) ? that(a232) : true);
var nor73 = /* @__PURE__ */ dual243(2, (self2, that) => (a232) => !(self2(a232) || that(a232)));
var nand73 = /* @__PURE__ */ dual243(2, (self2, that) => (a232) => !(self2(a232) && that(a232)));
var every83 = (collection) => (a232) => {
  for (const p232 of collection) {
    if (!p232(a232)) {
      return false;
    }
  }
  return true;
};
var some353 = (collection) => (a232) => {
  for (const p232 of collection) {
    if (p232(a232)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage243 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId243 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind243 = (u232) => isObject243(u232) && GenKindTypeId243 in u232;
var GenKindImpl243 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity243;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId243] = GenKindTypeId243;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen253(this);
  }
};
var SingleShotGen253 = class _SingleShotGen103 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a232) {
    return this.called ? {
      value: a232,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a232) {
    return {
      value: a232,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e232) {
    throw e232;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen103(this.self);
  }
};
var adapter343 = () => function() {
  let x232 = arguments[0];
  for (let i232 = 1; i232 < arguments.length; i232++) {
    x232 = arguments[i232](x232);
  }
  return new GenKindImpl243(x232);
};
var defaultIncHi243 = 335903614;
var defaultIncLo243 = 4150755663;
var MUL_HI243 = 1481765933 >>> 0;
var MUL_LO243 = 1284865837 >>> 0;
var BIT_53243 = 9007199254740992;
var BIT_27243 = 134217728;
var PCGRandom243 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable243(seedLo) && isNullable243(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable243(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable243(incLo) && isNullable243(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo243;
      incHi = this._state ? this._state[2] : defaultIncHi243;
    } else if (isNullable243(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add64243(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max34) {
    if (!max34) {
      return this._next();
    }
    max34 = max34 >>> 0;
    if ((max34 & max34 - 1) === 0) {
      return this._next() & max34 - 1;
    }
    let num = 0;
    const skew = (-max34 >>> 0) % max34 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max34;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_27243 + lo) / BIT_53243;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul64243(this._state, oldHi, oldLo, MUL_HI243, MUL_LO243);
    add64243(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul64243(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add64243(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId243 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap243 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId243]() {
    return this.#value;
  }
};
function yieldWrapGet243(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId243 in self2) {
    return self2[YieldWrapTypeId243]();
  }
  throw new Error(getBugErrorMessage243("yieldWrapGet"));
}
var structuralRegionState243 = /* @__PURE__ */ globalValue243("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache243 = /* @__PURE__ */ globalValue243(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr243 = /* @__PURE__ */ globalValue243(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom243());
var symbol343 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash243 = (self2) => {
  if (structuralRegionState243.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number243(self2);
    case "bigint":
      return string243(self2.toString(10));
    case "boolean":
      return string243(String(self2));
    case "symbol":
      return string243(String(self2));
    case "string":
      return string243(self2);
    case "undefined":
      return string243("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string243("null");
      } else if (self2 instanceof Date) {
        return hash243(self2.toISOString());
      } else if (isHash243(self2)) {
        return self2[symbol343]();
      } else {
        return random243(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random243 = (self2) => {
  if (!randomHashCache243.has(self2)) {
    randomHashCache243.set(self2, number243(pcgr243.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache243.get(self2);
};
var combine253 = (b232) => (self2) => self2 * 53 ^ b232;
var optimize243 = (n232) => n232 & 3221225471 | n232 >>> 1 & 1073741824;
var isHash243 = (u232) => hasProperty243(u232, symbol343);
var number243 = (n232) => {
  if (n232 !== n232 || n232 === Infinity) {
    return 0;
  }
  let h232 = n232 | 0;
  if (h232 !== n232) {
    h232 ^= n232 * 4294967295;
  }
  while (n232 > 4294967295) {
    h232 ^= n232 /= 4294967295;
  }
  return optimize243(n232);
};
var string243 = (str) => {
  let h232 = 5381, i232 = str.length;
  while (i232) {
    h232 = h232 * 33 ^ str.charCodeAt(--i232);
  }
  return optimize243(h232);
};
var structureKeys243 = (o232, keys234) => {
  let h232 = 12289;
  for (let i232 = 0; i232 < keys234.length; i232++) {
    h232 ^= pipe243(string243(keys234[i232]), combine253(hash243(o232[keys234[i232]])));
  }
  return optimize243(h232);
};
var structure243 = (o232) => structureKeys243(o232, Object.keys(o232));
var array103 = (arr) => {
  let h232 = 6151;
  for (let i232 = 0; i232 < arr.length; i232++) {
    h232 = pipe243(h232, combine253(hash243(arr[i232])));
  }
  return optimize243(h232);
};
var cached243 = function() {
  if (arguments.length === 1) {
    const self22 = arguments[0];
    return function(hash324) {
      Object.defineProperty(self22, symbol343, {
        value() {
          return hash324;
        },
        enumerable: false
      });
      return hash324;
    };
  }
  const self2 = arguments[0];
  const hash2234 = arguments[1];
  Object.defineProperty(self2, symbol343, {
    value() {
      return hash2234;
    },
    enumerable: false
  });
  return hash2234;
};
var symbol2243 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals243() {
  if (arguments.length === 1) {
    return (self2) => compareBoth243(self2, arguments[0]);
  }
  return compareBoth243(arguments[0], arguments[1]);
}
function compareBoth243(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual243(self2) && isEqual243(that)) {
        if (hash243(self2) === hash243(that) && self2[symbol2243](that)) {
          return true;
        } else {
          return structuralRegionState243.enabled && structuralRegionState243.tester ? structuralRegionState243.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState243.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v232, i232) => compareBoth243(v232, that[i232]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth243(self2[key], that[key]))) {
              return structuralRegionState243.tester ? structuralRegionState243.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState243.tester ? structuralRegionState243.tester(self2, that) : false;
    }
  }
  return structuralRegionState243.enabled && structuralRegionState243.tester ? structuralRegionState243.tester(self2, that) : false;
}
var isEqual243 = (u232) => hasProperty243(u232, symbol2243);
var equivalence243 = () => equals243;
var NodeInspectSymbol243 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON243 = (x232) => {
  if (hasProperty243(x232, "toJSON") && isFunction3243(x232["toJSON"]) && x232["toJSON"].length === 0) {
    return x232.toJSON();
  } else if (Array.isArray(x232)) {
    return x232.map(toJSON243);
  }
  return x232;
};
var format243 = (x232) => JSON.stringify(x232, null, 2);
var pipeArguments243 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i232 = 0, len = args.length; i232 < len; i232++) {
        ret = args[i232](ret);
      }
      return ret;
    }
  }
};
var OP_COMMIT243 = "Commit";
var OP_FAILURE53 = "Failure";
var OP_WITH_RUNTIME53 = "WithRuntime";
var EffectTypeId253 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId243 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId243 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId243 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance243 = {
  /* c8 ignore next */
  _R: (_232) => _232,
  /* c8 ignore next */
  _E: (_232) => _232,
  /* c8 ignore next */
  _A: (_232) => _232,
  _V: /* @__PURE__ */ getCurrentVersion243()
};
var sinkVariance243 = {
  /* c8 ignore next */
  _A: (_232) => _232,
  /* c8 ignore next */
  _In: (_232) => _232,
  /* c8 ignore next */
  _L: (_232) => _232,
  /* c8 ignore next */
  _E: (_232) => _232,
  /* c8 ignore next */
  _R: (_232) => _232
};
var channelVariance243 = {
  /* c8 ignore next */
  _Env: (_232) => _232,
  /* c8 ignore next */
  _InErr: (_232) => _232,
  /* c8 ignore next */
  _InElem: (_232) => _232,
  /* c8 ignore next */
  _InDone: (_232) => _232,
  /* c8 ignore next */
  _OutErr: (_232) => _232,
  /* c8 ignore next */
  _OutElem: (_232) => _232,
  /* c8 ignore next */
  _OutDone: (_232) => _232
};
var EffectPrototype243 = {
  [EffectTypeId253]: effectVariance243,
  [StreamTypeId243]: effectVariance243,
  [SinkTypeId243]: sinkVariance243,
  [ChannelTypeId243]: channelVariance243,
  [symbol2243](that) {
    return this === that;
  },
  [symbol343]() {
    return cached243(this, random243(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen253(new YieldWrap243(this));
  },
  pipe() {
    return pipeArguments243(this, arguments);
  }
};
var StructuralPrototype243 = {
  [symbol343]() {
    return cached243(this, structure243(this));
  },
  [symbol2243](that) {
    const selfKeys = Object.keys(this);
    const thatKeys = Object.keys(that);
    if (selfKeys.length !== thatKeys.length) {
      return false;
    }
    for (const key of selfKeys) {
      if (!(key in that && equals243(this[key], that[key]))) {
        return false;
      }
    }
    return true;
  }
};
var CommitPrototype243 = {
  ...EffectPrototype243,
  _op: OP_COMMIT243
};
var StructuralCommitPrototype243 = {
  ...CommitPrototype243,
  ...StructuralPrototype243
};
var TypeId553 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto343 = {
  ...EffectPrototype243,
  [TypeId553]: {
    _A: (_232) => _232
  },
  [NodeInspectSymbol243]() {
    return this.toJSON();
  },
  toString() {
    return format243(this.toJSON());
  }
};
var SomeProto243 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto343), {
  _tag: "Some",
  _op: "Some",
  [symbol2243](that) {
    return isOption343(that) && isSome343(that) && equals243(this.value, that.value);
  },
  [symbol343]() {
    return cached243(this, combine253(hash243(this._tag))(hash243(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON243(this.value)
    };
  }
});
var NoneHash243 = /* @__PURE__ */ hash243("None");
var NoneProto243 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto343), {
  _tag: "None",
  _op: "None",
  [symbol2243](that) {
    return isOption343(that) && isNone343(that);
  },
  [symbol343]() {
    return NoneHash243;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption343 = (input) => hasProperty243(input, TypeId553);
var isNone343 = (fa) => fa._tag === "None";
var isSome343 = (fa) => fa._tag === "Some";
var none343 = /* @__PURE__ */ Object.create(NoneProto243);
var some2243 = (value) => {
  const a232 = Object.create(SomeProto243);
  a232.value = value;
  return a232;
};
var TypeId2243 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto2243 = {
  ...EffectPrototype243,
  [TypeId2243]: {
    _R: (_232) => _232
  },
  [NodeInspectSymbol243]() {
    return this.toJSON();
  },
  toString() {
    return format243(this.toJSON());
  }
};
var RightProto243 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto2243), {
  _tag: "Right",
  _op: "Right",
  [symbol2243](that) {
    return isEither243(that) && isRight243(that) && equals243(this.right, that.right);
  },
  [symbol343]() {
    return combine253(hash243(this._tag))(hash243(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON243(this.right)
    };
  }
});
var LeftProto243 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto2243), {
  _tag: "Left",
  _op: "Left",
  [symbol2243](that) {
    return isEither243(that) && isLeft243(that) && equals243(this.left, that.left);
  },
  [symbol343]() {
    return combine253(hash243(this._tag))(hash243(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON243(this.left)
    };
  }
});
var isEither243 = (input) => hasProperty243(input, TypeId2243);
var isLeft243 = (ma) => ma._tag === "Left";
var isRight243 = (ma) => ma._tag === "Right";
var left253 = (left334) => {
  const a232 = Object.create(LeftProto243);
  a232.left = left334;
  return a232;
};
var right253 = (right334) => {
  const a232 = Object.create(RightProto243);
  a232.right = right334;
  return a232;
};
var getLeft343 = (self2) => isRight243(self2) ? none343 : some2243(self2.left);
var getRight343 = (self2) => isLeft243(self2) ? none343 : some2243(self2.right);
var right2243 = right253;
var left2243 = left253;
var Option_exports243 = {};
__export243(Option_exports243, {
  Do: () => Do243,
  TypeId: () => TypeId3243,
  all: () => all2243,
  andThen: () => andThen243,
  ap: () => ap243,
  as: () => as243,
  asVoid: () => asVoid243,
  bind: () => bind2243,
  bindTo: () => bindTo2243,
  composeK: () => composeK243,
  contains: () => contains243,
  containsWith: () => containsWith243,
  exists: () => exists243,
  filter: () => filter243,
  filterMap: () => filterMap243,
  firstSomeOf: () => firstSomeOf243,
  flatMap: () => flatMap243,
  flatMapNullable: () => flatMapNullable243,
  flatten: () => flatten243,
  fromIterable: () => fromIterable253,
  fromNullable: () => fromNullable243,
  gen: () => gen243,
  getEquivalence: () => getEquivalence253,
  getLeft: () => getLeft2243,
  getOrElse: () => getOrElse243,
  getOrNull: () => getOrNull243,
  getOrThrow: () => getOrThrow243,
  getOrThrowWith: () => getOrThrowWith243,
  getOrUndefined: () => getOrUndefined243,
  getOrder: () => getOrder243,
  getRight: () => getRight2243,
  isNone: () => isNone2243,
  isOption: () => isOption2243,
  isSome: () => isSome2243,
  let: () => let_2243,
  lift2: () => lift2243,
  liftNullable: () => liftNullable243,
  liftPredicate: () => liftPredicate243,
  liftThrowable: () => liftThrowable243,
  map: () => map243,
  match: () => match253,
  none: () => none2243,
  orElse: () => orElse243,
  orElseEither: () => orElseEither243,
  orElseSome: () => orElseSome243,
  partitionMap: () => partitionMap243,
  product: () => product2243,
  productMany: () => productMany2243,
  reduceCompact: () => reduceCompact243,
  some: () => some3243,
  tap: () => tap243,
  toArray: () => toArray243,
  toRefinement: () => toRefinement243,
  void: () => void_243,
  zipLeft: () => zipLeft243,
  zipRight: () => zipRight243,
  zipWith: () => zipWith243
});
var make2243 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId3243 = /* @__PURE__ */ Symbol.for("effect/Option");
var none2243 = () => none343;
var some3243 = some2243;
var isOption2243 = isOption343;
var isNone2243 = isNone343;
var isSome2243 = isSome343;
var match253 = /* @__PURE__ */ dual243(2, (self2, {
  onNone,
  onSome
}) => isNone2243(self2) ? onNone() : onSome(self2.value));
var toRefinement243 = (f232) => (a232) => isSome2243(f232(a232));
var fromIterable253 = (collection) => {
  for (const a232 of collection) {
    return some3243(a232);
  }
  return none2243();
};
var getRight2243 = getRight343;
var getLeft2243 = getLeft343;
var getOrElse243 = /* @__PURE__ */ dual243(2, (self2, onNone) => isNone2243(self2) ? onNone() : self2.value);
var orElse243 = /* @__PURE__ */ dual243(2, (self2, that) => isNone2243(self2) ? that() : self2);
var orElseSome243 = /* @__PURE__ */ dual243(2, (self2, onNone) => isNone2243(self2) ? some3243(onNone()) : self2);
var orElseEither243 = /* @__PURE__ */ dual243(2, (self2, that) => isNone2243(self2) ? map243(that(), right253) : map243(self2, left253));
var firstSomeOf243 = (collection) => {
  let out = none2243();
  for (out of collection) {
    if (isSome2243(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable243 = (nullableValue) => nullableValue == null ? none2243() : some3243(nullableValue);
var liftNullable243 = (f232) => (...a232) => fromNullable243(f232(...a232));
var getOrNull243 = /* @__PURE__ */ getOrElse243(constNull243);
var getOrUndefined243 = /* @__PURE__ */ getOrElse243(constUndefined243);
var liftThrowable243 = (f232) => (...a232) => {
  try {
    return some3243(f232(...a232));
  } catch (e232) {
    return none2243();
  }
};
var getOrThrowWith243 = /* @__PURE__ */ dual243(2, (self2, onNone) => {
  if (isSome2243(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow243 = /* @__PURE__ */ getOrThrowWith243(() => new Error("getOrThrow called on a None"));
var map243 = /* @__PURE__ */ dual243(2, (self2, f232) => isNone2243(self2) ? none2243() : some3243(f232(self2.value)));
var as243 = /* @__PURE__ */ dual243(2, (self2, b232) => map243(self2, () => b232));
var asVoid243 = /* @__PURE__ */ as243(void 0);
var void_243 = /* @__PURE__ */ some3243(void 0);
var flatMap243 = /* @__PURE__ */ dual243(2, (self2, f232) => isNone2243(self2) ? none2243() : f232(self2.value));
var andThen243 = /* @__PURE__ */ dual243(2, (self2, f232) => flatMap243(self2, (a232) => {
  const b232 = isFunction2243(f232) ? f232(a232) : f232;
  return isOption2243(b232) ? b232 : some3243(b232);
}));
var flatMapNullable243 = /* @__PURE__ */ dual243(2, (self2, f232) => isNone2243(self2) ? none2243() : fromNullable243(f232(self2.value)));
var flatten243 = /* @__PURE__ */ flatMap243(identity243);
var zipRight243 = /* @__PURE__ */ dual243(2, (self2, that) => flatMap243(self2, () => that));
var composeK243 = /* @__PURE__ */ dual243(2, (afb, bfc) => (a232) => flatMap243(afb(a232), bfc));
var zipLeft243 = /* @__PURE__ */ dual243(2, (self2, that) => tap243(self2, () => that));
var tap243 = /* @__PURE__ */ dual243(2, (self2, f232) => flatMap243(self2, (a232) => map243(f232(a232), () => a232)));
var product2243 = (self2, that) => isSome2243(self2) && isSome2243(that) ? some3243([self2.value, that.value]) : none2243();
var productMany2243 = (self2, collection) => {
  if (isNone2243(self2)) {
    return none2243();
  }
  const out = [self2.value];
  for (const o232 of collection) {
    if (isNone2243(o232)) {
      return none2243();
    }
    out.push(o232.value);
  }
  return some3243(out);
};
var all2243 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o232 of input) {
      if (isNone2243(o232)) {
        return none2243();
      }
      out2.push(o232.value);
    }
    return some3243(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o232 = input[key];
    if (isNone2243(o232)) {
      return none2243();
    }
    out[key] = o232.value;
  }
  return some3243(out);
};
var zipWith243 = /* @__PURE__ */ dual243(3, (self2, that, f232) => map243(product2243(self2, that), ([a232, b232]) => f232(a232, b232)));
var ap243 = /* @__PURE__ */ dual243(2, (self2, that) => zipWith243(self2, that, (f232, a232) => f232(a232)));
var reduceCompact243 = /* @__PURE__ */ dual243(3, (self2, b232, f232) => {
  let out = b232;
  for (const oa of self2) {
    if (isSome2243(oa)) {
      out = f232(out, oa.value);
    }
  }
  return out;
});
var toArray243 = (self2) => isNone2243(self2) ? [] : [self2.value];
var partitionMap243 = /* @__PURE__ */ dual243(2, (self2, f232) => {
  if (isNone2243(self2)) {
    return [none2243(), none2243()];
  }
  const e232 = f232(self2.value);
  return isLeft243(e232) ? [some3243(e232.left), none2243()] : [none2243(), some3243(e232.right)];
});
var filterMap243 = /* @__PURE__ */ dual243(2, (self2, f232) => isNone2243(self2) ? none2243() : f232(self2.value));
var filter243 = /* @__PURE__ */ dual243(2, (self2, predicate) => filterMap243(self2, (b232) => predicate(b232) ? some2243(b232) : none343));
var getEquivalence253 = (isEquivalent) => make453((x232, y232) => x232 === y232 || (isNone2243(x232) ? isNone2243(y232) : isNone2243(y232) ? false : isEquivalent(x232.value, y232.value)));
var getOrder243 = (O232) => make2243((self2, that) => isSome2243(self2) ? isSome2243(that) ? O232(self2.value, that.value) : 1 : -1);
var lift2243 = (f232) => dual243(2, (self2, that) => zipWith243(self2, that, f232));
var liftPredicate243 = (predicate) => (b232) => predicate(b232) ? some3243(b232) : none2243();
var containsWith243 = (isEquivalent) => dual243(2, (self2, a232) => isNone2243(self2) ? false : isEquivalent(self2.value, a232));
var _equivalence253 = /* @__PURE__ */ equivalence243();
var contains243 = /* @__PURE__ */ containsWith243(_equivalence253);
var exists243 = /* @__PURE__ */ dual243(2, (self2, refinement) => isNone2243(self2) ? false : refinement(self2.value));
var bindTo2243 = /* @__PURE__ */ bindTo343(map243);
var let_2243 = /* @__PURE__ */ let_343(map243);
var bind2243 = /* @__PURE__ */ bind343(map243, flatMap243);
var Do243 = /* @__PURE__ */ some3243({});
var adapter2243 = /* @__PURE__ */ adapter343();
var gen243 = (f232) => {
  const iterator = f232(adapter2243);
  let state = iterator.next();
  if (state.done) {
    return some3243(state.value);
  } else {
    let current = state.value;
    if (isGenKind243(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet243(current);
    }
    if (isNone2243(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind243(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet243(current);
        }
        if (isNone2243(current)) {
          return current;
        }
      }
    }
    return some3243(state.value);
  }
};
var fromIterable2243 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var reverse73 = (self2) => Array.from(self2).reverse();
var reduce83 = /* @__PURE__ */ dual243(3, (self2, b232, f232) => fromIterable2243(self2).reduce((b2222, a232, i232) => f232(b2222, a232, i232), b232));
var TagTypeId53 = /* @__PURE__ */ Symbol.for("effect/Context/Tag");
var STMSymbolKey53 = "effect/STM";
var STMTypeId53 = /* @__PURE__ */ Symbol.for(STMSymbolKey53);
var TagProto53 = {
  ...EffectPrototype243,
  _tag: "Tag",
  _op: "Tag",
  [STMTypeId53]: effectVariance243,
  [TagTypeId53]: {
    _Service: (_232) => _232,
    _Identifier: (_232) => _232
  },
  toString() {
    return format243(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Tag",
      key: this.key,
      stack: this.stack
    };
  },
  [NodeInspectSymbol243]() {
    return this.toJSON();
  },
  of(self2) {
    return self2;
  },
  context(self2) {
    return make3243(this, self2);
  }
};
var makeGenericTag53 = (key) => {
  const limit = Error.stackTraceLimit;
  Error.stackTraceLimit = 2;
  const creationError = new Error();
  Error.stackTraceLimit = limit;
  const tag = Object.create(TagProto53);
  Object.defineProperty(tag, "stack", {
    get() {
      return creationError.stack;
    }
  });
  tag.key = key;
  return tag;
};
var TypeId4243 = /* @__PURE__ */ Symbol.for("effect/Context");
var ContextProto53 = {
  [TypeId4243]: {
    _Services: (_232) => _232
  },
  [symbol2243](that) {
    if (isContext53(that)) {
      if (this.unsafeMap.size === that.unsafeMap.size) {
        for (const k232 of this.unsafeMap.keys()) {
          if (!that.unsafeMap.has(k232) || !equals243(this.unsafeMap.get(k232), that.unsafeMap.get(k232))) {
            return false;
          }
        }
        return true;
      }
    }
    return false;
  },
  [symbol343]() {
    return cached243(this, number243(this.unsafeMap.size));
  },
  pipe() {
    return pipeArguments243(this, arguments);
  },
  toString() {
    return format243(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Context",
      services: Array.from(this.unsafeMap).map(toJSON243)
    };
  },
  [NodeInspectSymbol243]() {
    return this.toJSON();
  }
};
var makeContext53 = (unsafeMap) => {
  const context = Object.create(ContextProto53);
  context.unsafeMap = unsafeMap;
  return context;
};
var isContext53 = (u232) => hasProperty243(u232, TypeId4243);
var _empty93 = /* @__PURE__ */ makeContext53(/* @__PURE__ */ new Map());
var empty143 = () => _empty93;
var make3243 = (tag, service) => makeContext53(/* @__PURE__ */ new Map([[tag.key, service]]));
var GenericTag53 = makeGenericTag53;
var empty253 = empty143;
var TypeId5243 = /* @__PURE__ */ Symbol.for("effect/Chunk");
function copy63(src, srcPos, dest, destPos, len) {
  for (let i232 = srcPos; i232 < Math.min(src.length, srcPos + len); i232++) {
    dest[destPos + i232 - srcPos] = src[i232];
  }
  return dest;
}
var emptyArray53 = [];
var getEquivalence2243 = (isEquivalent) => make453((self2, that) => self2.length === that.length && toReadonlyArray53(self2).every((value, i232) => isEquivalent(value, unsafeGet253(that, i232))));
var _equivalence2243 = /* @__PURE__ */ getEquivalence2243(equals243);
var ChunkProto53 = {
  [TypeId5243]: {
    _A: (_232) => _232
  },
  toString() {
    return format243(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Chunk",
      values: toReadonlyArray53(this).map(toJSON243)
    };
  },
  [NodeInspectSymbol243]() {
    return this.toJSON();
  },
  [symbol2243](that) {
    return isChunk53(that) && _equivalence2243(this, that);
  },
  [symbol343]() {
    return cached243(this, array103(toReadonlyArray53(this)));
  },
  [Symbol.iterator]() {
    switch (this.backing._tag) {
      case "IArray": {
        return this.backing.array[Symbol.iterator]();
      }
      case "IEmpty": {
        return emptyArray53[Symbol.iterator]();
      }
      default: {
        return toReadonlyArray53(this)[Symbol.iterator]();
      }
    }
  },
  pipe() {
    return pipeArguments243(this, arguments);
  }
};
var makeChunk53 = (backing) => {
  const chunk = Object.create(ChunkProto53);
  chunk.backing = backing;
  switch (backing._tag) {
    case "IEmpty": {
      chunk.length = 0;
      chunk.depth = 0;
      chunk.left = chunk;
      chunk.right = chunk;
      break;
    }
    case "IConcat": {
      chunk.length = backing.left.length + backing.right.length;
      chunk.depth = 1 + Math.max(backing.left.depth, backing.right.depth);
      chunk.left = backing.left;
      chunk.right = backing.right;
      break;
    }
    case "IArray": {
      chunk.length = backing.array.length;
      chunk.depth = 0;
      chunk.left = _empty253;
      chunk.right = _empty253;
      break;
    }
    case "ISingleton": {
      chunk.length = 1;
      chunk.depth = 0;
      chunk.left = _empty253;
      chunk.right = _empty253;
      break;
    }
    case "ISlice": {
      chunk.length = backing.length;
      chunk.depth = backing.chunk.depth + 1;
      chunk.left = _empty253;
      chunk.right = _empty253;
      break;
    }
  }
  return chunk;
};
var isChunk53 = (u232) => hasProperty243(u232, TypeId5243);
var _empty253 = /* @__PURE__ */ makeChunk53({
  _tag: "IEmpty"
});
var empty353 = () => _empty253;
var make4243 = (...as2234) => as2234.length === 1 ? of63(as2234[0]) : unsafeFromNonEmptyArray53(as2234);
var of63 = (a232) => makeChunk53({
  _tag: "ISingleton",
  a: a232
});
var copyToArray53 = (self2, array334, initial) => {
  switch (self2.backing._tag) {
    case "IArray": {
      copy63(self2.backing.array, 0, array334, initial, self2.length);
      break;
    }
    case "IConcat": {
      copyToArray53(self2.left, array334, initial);
      copyToArray53(self2.right, array334, initial + self2.left.length);
      break;
    }
    case "ISingleton": {
      array334[initial] = self2.backing.a;
      break;
    }
    case "ISlice": {
      let i232 = 0;
      let j232 = initial;
      while (i232 < self2.length) {
        array334[j232] = unsafeGet253(self2, i232);
        i232 += 1;
        j232 += 1;
      }
      break;
    }
  }
};
var toReadonlyArray53 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      return emptyArray53;
    }
    case "IArray": {
      return self2.backing.array;
    }
    default: {
      const arr = new Array(self2.length);
      copyToArray53(self2, arr, 0);
      self2.backing = {
        _tag: "IArray",
        array: arr
      };
      self2.left = _empty253;
      self2.right = _empty253;
      self2.depth = 0;
      return arr;
    }
  }
};
var reverse253 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty":
    case "ISingleton":
      return self2;
    case "IArray": {
      return makeChunk53({
        _tag: "IArray",
        array: reverse73(self2.backing.array)
      });
    }
    case "IConcat": {
      return makeChunk53({
        _tag: "IConcat",
        left: reverse253(self2.backing.right),
        right: reverse253(self2.backing.left)
      });
    }
    case "ISlice":
      return unsafeFromArray53(reverse73(toReadonlyArray53(self2)));
  }
};
var unsafeFromArray53 = (self2) => makeChunk53({
  _tag: "IArray",
  array: self2
});
var unsafeFromNonEmptyArray53 = (self2) => unsafeFromArray53(self2);
var unsafeGet253 = /* @__PURE__ */ dual243(2, (self2, index) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      throw new Error(`Index out of bounds`);
    }
    case "ISingleton": {
      if (index !== 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.a;
    }
    case "IArray": {
      if (index >= self2.length || index < 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.array[index];
    }
    case "IConcat": {
      return index < self2.left.length ? unsafeGet253(self2.left, index) : unsafeGet253(self2.right, index - self2.left.length);
    }
    case "ISlice": {
      return unsafeGet253(self2.backing.chunk, index + self2.backing.offset);
    }
  }
});
var prepend73 = /* @__PURE__ */ dual243(2, (self2, elem) => appendAll63(of63(elem), self2));
var drop63 = /* @__PURE__ */ dual243(2, (self2, n232) => {
  if (n232 <= 0) {
    return self2;
  } else if (n232 >= self2.length) {
    return _empty253;
  } else {
    switch (self2.backing._tag) {
      case "ISlice": {
        return makeChunk53({
          _tag: "ISlice",
          chunk: self2.backing.chunk,
          offset: self2.backing.offset + n232,
          length: self2.backing.length - n232
        });
      }
      case "IConcat": {
        if (n232 > self2.left.length) {
          return drop63(self2.right, n232 - self2.left.length);
        }
        return makeChunk53({
          _tag: "IConcat",
          left: drop63(self2.left, n232),
          right: self2.right
        });
      }
      default: {
        return makeChunk53({
          _tag: "ISlice",
          chunk: self2,
          offset: n232,
          length: self2.length - n232
        });
      }
    }
  }
});
var appendAll63 = /* @__PURE__ */ dual243(2, (self2, that) => {
  if (self2.backing._tag === "IEmpty") {
    return that;
  }
  if (that.backing._tag === "IEmpty") {
    return self2;
  }
  const diff234 = that.depth - self2.depth;
  if (Math.abs(diff234) <= 1) {
    return makeChunk53({
      _tag: "IConcat",
      left: self2,
      right: that
    });
  } else if (diff234 < -1) {
    if (self2.left.depth >= self2.right.depth) {
      const nr = appendAll63(self2.right, that);
      return makeChunk53({
        _tag: "IConcat",
        left: self2.left,
        right: nr
      });
    } else {
      const nrr = appendAll63(self2.right.right, that);
      if (nrr.depth === self2.depth - 3) {
        const nr = makeChunk53({
          _tag: "IConcat",
          left: self2.right.left,
          right: nrr
        });
        return makeChunk53({
          _tag: "IConcat",
          left: self2.left,
          right: nr
        });
      } else {
        const nl = makeChunk53({
          _tag: "IConcat",
          left: self2.left,
          right: self2.right.left
        });
        return makeChunk53({
          _tag: "IConcat",
          left: nl,
          right: nrr
        });
      }
    }
  } else {
    if (that.right.depth >= that.left.depth) {
      const nl = appendAll63(self2, that.left);
      return makeChunk53({
        _tag: "IConcat",
        left: nl,
        right: that.right
      });
    } else {
      const nll = appendAll63(self2, that.left.left);
      if (nll.depth === that.depth - 3) {
        const nl = makeChunk53({
          _tag: "IConcat",
          left: nll,
          right: that.left.right
        });
        return makeChunk53({
          _tag: "IConcat",
          left: nl,
          right: that.right
        });
      } else {
        const nr = makeChunk53({
          _tag: "IConcat",
          left: that.left.right,
          right: that.right
        });
        return makeChunk53({
          _tag: "IConcat",
          left: nll,
          right: nr
        });
      }
    }
  }
});
var isEmpty63 = (self2) => self2.length === 0;
var isNonEmpty53 = (self2) => self2.length > 0;
var unsafeHead53 = (self2) => unsafeGet253(self2, 0);
var headNonEmpty63 = unsafeHead53;
var tailNonEmpty63 = (self2) => drop63(self2, 1);
var SIZE53 = 5;
var BUCKET_SIZE53 = /* @__PURE__ */ Math.pow(2, SIZE53);
var MASK53 = BUCKET_SIZE53 - 1;
var MAX_INDEX_NODE53 = BUCKET_SIZE53 / 2;
var MIN_ARRAY_NODE53 = BUCKET_SIZE53 / 4;
function popcount53(x232) {
  x232 -= x232 >> 1 & 1431655765;
  x232 = (x232 & 858993459) + (x232 >> 2 & 858993459);
  x232 = x232 + (x232 >> 4) & 252645135;
  x232 += x232 >> 8;
  x232 += x232 >> 16;
  return x232 & 127;
}
function hashFragment53(shift22, h232) {
  return h232 >>> shift22 & MASK53;
}
function toBitmap53(x232) {
  return 1 << x232;
}
function fromBitmap53(bitmap, bit) {
  return popcount53(bitmap & bit - 1);
}
var make553 = (value, previous) => ({
  value,
  previous
});
function arrayUpdate53(mutate234, at, v232, arr) {
  let out = arr;
  if (!mutate234) {
    const len = arr.length;
    out = new Array(len);
    for (let i232 = 0; i232 < len; ++i232) out[i232] = arr[i232];
  }
  out[at] = v232;
  return out;
}
function arraySpliceOut53(mutate234, at, arr) {
  const newLen = arr.length - 1;
  let i232 = 0;
  let g232 = 0;
  let out = arr;
  if (mutate234) {
    i232 = g232 = at;
  } else {
    out = new Array(newLen);
    while (i232 < at) out[g232++] = arr[i232++];
  }
  ++i232;
  while (i232 <= newLen) out[g232++] = arr[i232++];
  if (mutate234) {
    out.length = newLen;
  }
  return out;
}
function arraySpliceIn53(mutate234, at, v232, arr) {
  const len = arr.length;
  if (mutate234) {
    let i2222 = len;
    while (i2222 >= at) arr[i2222--] = arr[i2222];
    arr[at] = v232;
    return arr;
  }
  let i232 = 0, g232 = 0;
  const out = new Array(len + 1);
  while (i232 < at) out[g232++] = arr[i232++];
  out[at] = v232;
  while (i232 < len) out[++g232] = arr[i232++];
  return out;
}
var EmptyNode53 = class _EmptyNode53 {
  _tag = "EmptyNode";
  modify(edit, _shift, f232, hash2234, key, size434) {
    const v232 = f232(none2243());
    if (isNone2243(v232)) return new _EmptyNode53();
    ++size434.value;
    return new LeafNode53(edit, hash2234, key, v232);
  }
};
function isEmptyNode53(a232) {
  return isTagged73(a232, "EmptyNode");
}
function isLeafNode53(node) {
  return isEmptyNode53(node) || node._tag === "LeafNode" || node._tag === "CollisionNode";
}
function canEditNode53(node, edit) {
  return isEmptyNode53(node) ? false : edit === node.edit;
}
var LeafNode53 = class _LeafNode53 {
  edit;
  hash;
  key;
  value;
  _tag = "LeafNode";
  constructor(edit, hash2234, key, value) {
    this.edit = edit;
    this.hash = hash2234;
    this.key = key;
    this.value = value;
  }
  modify(edit, shift22, f232, hash2234, key, size434) {
    if (equals243(key, this.key)) {
      const v2222 = f232(this.value);
      if (v2222 === this.value) return this;
      else if (isNone2243(v2222)) {
        --size434.value;
        return new EmptyNode53();
      }
      if (canEditNode53(this, edit)) {
        this.value = v2222;
        return this;
      }
      return new _LeafNode53(edit, hash2234, key, v2222);
    }
    const v232 = f232(none2243());
    if (isNone2243(v232)) return this;
    ++size434.value;
    return mergeLeaves53(edit, shift22, this.hash, this, hash2234, new _LeafNode53(edit, hash2234, key, v232));
  }
};
var CollisionNode53 = class _CollisionNode53 {
  edit;
  hash;
  children;
  _tag = "CollisionNode";
  constructor(edit, hash2234, children) {
    this.edit = edit;
    this.hash = hash2234;
    this.children = children;
  }
  modify(edit, shift22, f232, hash2234, key, size434) {
    if (hash2234 === this.hash) {
      const canEdit = canEditNode53(this, edit);
      const list = this.updateCollisionList(canEdit, edit, this.hash, this.children, f232, key, size434);
      if (list === this.children) return this;
      return list.length > 1 ? new _CollisionNode53(edit, this.hash, list) : list[0];
    }
    const v232 = f232(none2243());
    if (isNone2243(v232)) return this;
    ++size434.value;
    return mergeLeaves53(edit, shift22, this.hash, this, hash2234, new LeafNode53(edit, hash2234, key, v232));
  }
  updateCollisionList(mutate234, edit, hash2234, list, f232, key, size434) {
    const len = list.length;
    for (let i232 = 0; i232 < len; ++i232) {
      const child = list[i232];
      if ("key" in child && equals243(key, child.key)) {
        const value = child.value;
        const newValue2 = f232(value);
        if (newValue2 === value) return list;
        if (isNone2243(newValue2)) {
          --size434.value;
          return arraySpliceOut53(mutate234, i232, list);
        }
        return arrayUpdate53(mutate234, i232, new LeafNode53(edit, hash2234, key, newValue2), list);
      }
    }
    const newValue = f232(none2243());
    if (isNone2243(newValue)) return list;
    ++size434.value;
    return arrayUpdate53(mutate234, len, new LeafNode53(edit, hash2234, key, newValue), list);
  }
};
var IndexedNode53 = class _IndexedNode53 {
  edit;
  mask;
  children;
  _tag = "IndexedNode";
  constructor(edit, mask, children) {
    this.edit = edit;
    this.mask = mask;
    this.children = children;
  }
  modify(edit, shift22, f232, hash2234, key, size434) {
    const mask = this.mask;
    const children = this.children;
    const frag = hashFragment53(shift22, hash2234);
    const bit = toBitmap53(frag);
    const indx = fromBitmap53(mask, bit);
    const exists2234 = mask & bit;
    const canEdit = canEditNode53(this, edit);
    if (!exists2234) {
      const _newChild = new EmptyNode53().modify(edit, shift22 + SIZE53, f232, hash2234, key, size434);
      if (!_newChild) return this;
      return children.length >= MAX_INDEX_NODE53 ? expand53(edit, frag, _newChild, mask, children) : new _IndexedNode53(edit, mask | bit, arraySpliceIn53(canEdit, indx, _newChild, children));
    }
    const current = children[indx];
    const child = current.modify(edit, shift22 + SIZE53, f232, hash2234, key, size434);
    if (current === child) return this;
    let bitmap = mask;
    let newChildren;
    if (isEmptyNode53(child)) {
      bitmap &= ~bit;
      if (!bitmap) return new EmptyNode53();
      if (children.length <= 2 && isLeafNode53(children[indx ^ 1])) {
        return children[indx ^ 1];
      }
      newChildren = arraySpliceOut53(canEdit, indx, children);
    } else {
      newChildren = arrayUpdate53(canEdit, indx, child, children);
    }
    if (canEdit) {
      this.mask = bitmap;
      this.children = newChildren;
      return this;
    }
    return new _IndexedNode53(edit, bitmap, newChildren);
  }
};
var ArrayNode53 = class _ArrayNode53 {
  edit;
  size;
  children;
  _tag = "ArrayNode";
  constructor(edit, size434, children) {
    this.edit = edit;
    this.size = size434;
    this.children = children;
  }
  modify(edit, shift22, f232, hash2234, key, size434) {
    let count = this.size;
    const children = this.children;
    const frag = hashFragment53(shift22, hash2234);
    const child = children[frag];
    const newChild = (child || new EmptyNode53()).modify(edit, shift22 + SIZE53, f232, hash2234, key, size434);
    if (child === newChild) return this;
    const canEdit = canEditNode53(this, edit);
    let newChildren;
    if (isEmptyNode53(child) && !isEmptyNode53(newChild)) {
      ++count;
      newChildren = arrayUpdate53(canEdit, frag, newChild, children);
    } else if (!isEmptyNode53(child) && isEmptyNode53(newChild)) {
      --count;
      if (count <= MIN_ARRAY_NODE53) {
        return pack53(edit, count, frag, children);
      }
      newChildren = arrayUpdate53(canEdit, frag, new EmptyNode53(), children);
    } else {
      newChildren = arrayUpdate53(canEdit, frag, newChild, children);
    }
    if (canEdit) {
      this.size = count;
      this.children = newChildren;
      return this;
    }
    return new _ArrayNode53(edit, count, newChildren);
  }
};
function pack53(edit, count, removed, elements) {
  const children = new Array(count - 1);
  let g232 = 0;
  let bitmap = 0;
  for (let i232 = 0, len = elements.length; i232 < len; ++i232) {
    if (i232 !== removed) {
      const elem = elements[i232];
      if (elem && !isEmptyNode53(elem)) {
        children[g232++] = elem;
        bitmap |= 1 << i232;
      }
    }
  }
  return new IndexedNode53(edit, bitmap, children);
}
function expand53(edit, frag, child, bitmap, subNodes) {
  const arr = [];
  let bit = bitmap;
  let count = 0;
  for (let i232 = 0; bit; ++i232) {
    if (bit & 1) arr[i232] = subNodes[count++];
    bit >>>= 1;
  }
  arr[frag] = child;
  return new ArrayNode53(edit, count + 1, arr);
}
function mergeLeavesInner53(edit, shift22, h1, n1, h232, n232) {
  if (h1 === h232) return new CollisionNode53(edit, h1, [n232, n1]);
  const subH1 = hashFragment53(shift22, h1);
  const subH2 = hashFragment53(shift22, h232);
  if (subH1 === subH2) {
    return (child) => new IndexedNode53(edit, toBitmap53(subH1) | toBitmap53(subH2), [child]);
  } else {
    const children = subH1 < subH2 ? [n1, n232] : [n232, n1];
    return new IndexedNode53(edit, toBitmap53(subH1) | toBitmap53(subH2), children);
  }
}
function mergeLeaves53(edit, shift22, h1, n1, h232, n232) {
  let stack = void 0;
  let currentShift = shift22;
  while (true) {
    const res = mergeLeavesInner53(edit, currentShift, h1, n1, h232, n232);
    if (typeof res === "function") {
      stack = make553(res, stack);
      currentShift = currentShift + SIZE53;
    } else {
      let final = res;
      while (stack != null) {
        final = stack.value(final);
        stack = stack.previous;
      }
      return final;
    }
  }
}
var HashMapSymbolKey53 = "effect/HashMap";
var HashMapTypeId53 = /* @__PURE__ */ Symbol.for(HashMapSymbolKey53);
var HashMapProto53 = {
  [HashMapTypeId53]: HashMapTypeId53,
  [Symbol.iterator]() {
    return new HashMapIterator53(this, (k232, v232) => [k232, v232]);
  },
  [symbol343]() {
    let hash2234 = hash243(HashMapSymbolKey53);
    for (const item of this) {
      hash2234 ^= pipe243(hash243(item[0]), combine253(hash243(item[1])));
    }
    return cached243(this, hash2234);
  },
  [symbol2243](that) {
    if (isHashMap53(that)) {
      if (that._size !== this._size) {
        return false;
      }
      for (const item of this) {
        const elem = pipe243(that, getHash53(item[0], hash243(item[0])));
        if (isNone2243(elem)) {
          return false;
        } else {
          if (!equals243(item[1], elem.value)) {
            return false;
          }
        }
      }
      return true;
    }
    return false;
  },
  toString() {
    return format243(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashMap",
      values: Array.from(this).map(toJSON243)
    };
  },
  [NodeInspectSymbol243]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments243(this, arguments);
  }
};
var makeImpl63 = (editable, edit, root, size434) => {
  const map622 = Object.create(HashMapProto53);
  map622._editable = editable;
  map622._edit = edit;
  map622._root = root;
  map622._size = size434;
  return map622;
};
var HashMapIterator53 = class _HashMapIterator53 {
  map;
  f;
  v;
  constructor(map622, f232) {
    this.map = map622;
    this.f = f232;
    this.v = visitLazy53(this.map._root, this.f, void 0);
  }
  next() {
    if (isNone2243(this.v)) {
      return {
        done: true,
        value: void 0
      };
    }
    const v0 = this.v.value;
    this.v = applyCont53(v0.cont);
    return {
      done: false,
      value: v0.value
    };
  }
  [Symbol.iterator]() {
    return new _HashMapIterator53(this.map, this.f);
  }
};
var applyCont53 = (cont) => cont ? visitLazyChildren53(cont[0], cont[1], cont[2], cont[3], cont[4]) : none2243();
var visitLazy53 = (node, f232, cont = void 0) => {
  switch (node._tag) {
    case "LeafNode": {
      if (isSome2243(node.value)) {
        return some3243({
          value: f232(node.key, node.value.value),
          cont
        });
      }
      return applyCont53(cont);
    }
    case "CollisionNode":
    case "ArrayNode":
    case "IndexedNode": {
      const children = node.children;
      return visitLazyChildren53(children.length, children, 0, f232, cont);
    }
    default: {
      return applyCont53(cont);
    }
  }
};
var visitLazyChildren53 = (len, children, i232, f232, cont) => {
  while (i232 < len) {
    const child = children[i232++];
    if (child && !isEmptyNode53(child)) {
      return visitLazy53(child, f232, [len, children, i232, f232, cont]);
    }
  }
  return applyCont53(cont);
};
var _empty353 = /* @__PURE__ */ makeImpl63(false, 0, /* @__PURE__ */ new EmptyNode53(), 0);
var empty453 = () => _empty353;
var isHashMap53 = (u232) => hasProperty243(u232, HashMapTypeId53);
var getHash53 = /* @__PURE__ */ dual243(3, (self2, key, hash2234) => {
  let node = self2._root;
  let shift22 = 0;
  while (true) {
    switch (node._tag) {
      case "LeafNode": {
        return equals243(key, node.key) ? node.value : none2243();
      }
      case "CollisionNode": {
        if (hash2234 === node.hash) {
          const children = node.children;
          for (let i232 = 0, len = children.length; i232 < len; ++i232) {
            const child = children[i232];
            if ("key" in child && equals243(key, child.key)) {
              return child.value;
            }
          }
        }
        return none2243();
      }
      case "IndexedNode": {
        const frag = hashFragment53(shift22, hash2234);
        const bit = toBitmap53(frag);
        if (node.mask & bit) {
          node = node.children[fromBitmap53(node.mask, bit)];
          shift22 += SIZE53;
          break;
        }
        return none2243();
      }
      case "ArrayNode": {
        node = node.children[hashFragment53(shift22, hash2234)];
        if (node) {
          shift22 += SIZE53;
          break;
        }
        return none2243();
      }
      default:
        return none2243();
    }
  }
});
var set243 = /* @__PURE__ */ dual243(3, (self2, key, value) => modifyAt53(self2, key, () => some3243(value)));
var setTree53 = /* @__PURE__ */ dual243(3, (self2, newRoot, newSize) => {
  if (self2._editable) {
    self2._root = newRoot;
    self2._size = newSize;
    return self2;
  }
  return newRoot === self2._root ? self2 : makeImpl63(self2._editable, self2._edit, newRoot, newSize);
});
var keys63 = (self2) => new HashMapIterator53(self2, (key) => key);
var size73 = (self2) => self2._size;
var beginMutation63 = (self2) => makeImpl63(true, self2._edit + 1, self2._root, self2._size);
var modifyAt53 = /* @__PURE__ */ dual243(3, (self2, key, f232) => modifyHash53(self2, key, hash243(key), f232));
var modifyHash53 = /* @__PURE__ */ dual243(4, (self2, key, hash2234, f232) => {
  const size434 = {
    value: self2._size
  };
  const newRoot = self2._root.modify(self2._editable ? self2._edit : NaN, 0, f232, hash2234, key, size434);
  return pipe243(self2, setTree53(newRoot, size434.value));
});
var forEach83 = /* @__PURE__ */ dual243(2, (self2, f232) => reduce253(self2, void 0, (_232, value, key) => f232(value, key)));
var reduce253 = /* @__PURE__ */ dual243(3, (self2, zero, f232) => {
  const root = self2._root;
  if (root._tag === "LeafNode") {
    return isSome2243(root.value) ? f232(zero, root.value.value, root.key) : zero;
  }
  if (root._tag === "EmptyNode") {
    return zero;
  }
  const toVisit = [root.children];
  let children;
  while (children = toVisit.pop()) {
    for (let i232 = 0, len = children.length; i232 < len; ) {
      const child = children[i232++];
      if (child && !isEmptyNode53(child)) {
        if (child._tag === "LeafNode") {
          if (isSome2243(child.value)) {
            zero = f232(zero, child.value.value, child.key);
          }
        } else {
          toVisit.push(child.children);
        }
      }
    }
  }
  return zero;
});
var HashSetSymbolKey53 = "effect/HashSet";
var HashSetTypeId53 = /* @__PURE__ */ Symbol.for(HashSetSymbolKey53);
var HashSetProto53 = {
  [HashSetTypeId53]: HashSetTypeId53,
  [Symbol.iterator]() {
    return keys63(this._keyMap);
  },
  [symbol343]() {
    return cached243(this, combine253(hash243(this._keyMap))(hash243(HashSetSymbolKey53)));
  },
  [symbol2243](that) {
    if (isHashSet53(that)) {
      return size73(this._keyMap) === size73(that._keyMap) && equals243(this._keyMap, that._keyMap);
    }
    return false;
  },
  toString() {
    return format243(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashSet",
      values: Array.from(this).map(toJSON243)
    };
  },
  [NodeInspectSymbol243]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments243(this, arguments);
  }
};
var makeImpl253 = (keyMap) => {
  const set2234 = Object.create(HashSetProto53);
  set2234._keyMap = keyMap;
  return set2234;
};
var isHashSet53 = (u232) => hasProperty243(u232, HashSetTypeId53);
var _empty453 = /* @__PURE__ */ makeImpl253(/* @__PURE__ */ empty453());
var empty553 = () => _empty453;
var size253 = (self2) => size73(self2._keyMap);
var beginMutation253 = (self2) => makeImpl253(beginMutation63(self2._keyMap));
var endMutation53 = (self2) => {
  self2._keyMap._editable = false;
  return self2;
};
var mutate53 = /* @__PURE__ */ dual243(2, (self2, f232) => {
  const transient = beginMutation253(self2);
  f232(transient);
  return endMutation53(transient);
});
var add253 = /* @__PURE__ */ dual243(2, (self2, value) => self2._keyMap._editable ? (set243(value, true)(self2._keyMap), self2) : makeImpl253(set243(value, true)(self2._keyMap)));
var union253 = /* @__PURE__ */ dual243(2, (self2, that) => mutate53(empty553(), (set2234) => {
  forEach253(self2, (value) => add253(set2234, value));
  for (const value of that) {
    add253(set2234, value);
  }
}));
var forEach253 = /* @__PURE__ */ dual243(2, (self2, f232) => forEach83(self2._keyMap, (_232, k232) => f232(k232)));
var empty653 = empty553;
var size353 = size253;
var add353 = add253;
var union353 = union253;
var ArrayProto53 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(Array.prototype), {
  [symbol343]() {
    return cached243(this, array103(this));
  },
  [symbol2243](that) {
    if (Array.isArray(that) && this.length === that.length) {
      return this.every((v232, i232) => equals243(v232, that[i232]));
    } else {
      return false;
    }
  }
});
var Structural63 = /* @__PURE__ */ function() {
  function Structural334(args) {
    if (args) {
      Object.assign(this, args);
    }
  }
  Structural334.prototype = StructuralPrototype243;
  return Structural334;
}();
var struct253 = (as2234) => Object.assign(Object.create(StructuralPrototype243), as2234);
var ContextPatchTypeId53 = /* @__PURE__ */ Symbol.for("effect/DifferContextPatch");
function variance63(a232) {
  return a232;
}
var PatchProto53 = {
  ...Structural63.prototype,
  [ContextPatchTypeId53]: {
    _Value: variance63,
    _Patch: variance63
  }
};
var EmptyProto53 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto53), {
  _tag: "Empty"
});
var _empty553 = /* @__PURE__ */ Object.create(EmptyProto53);
var empty753 = () => _empty553;
var AndThenProto53 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto53), {
  _tag: "AndThen"
});
var makeAndThen53 = (first, second) => {
  const o232 = Object.create(AndThenProto53);
  o232.first = first;
  o232.second = second;
  return o232;
};
var AddServiceProto53 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto53), {
  _tag: "AddService"
});
var makeAddService53 = (key, service) => {
  const o232 = Object.create(AddServiceProto53);
  o232.key = key;
  o232.service = service;
  return o232;
};
var RemoveServiceProto53 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto53), {
  _tag: "RemoveService"
});
var makeRemoveService53 = (key) => {
  const o232 = Object.create(RemoveServiceProto53);
  o232.key = key;
  return o232;
};
var UpdateServiceProto53 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto53), {
  _tag: "UpdateService"
});
var makeUpdateService53 = (key, update222) => {
  const o232 = Object.create(UpdateServiceProto53);
  o232.key = key;
  o232.update = update222;
  return o232;
};
var diff53 = (oldValue, newValue) => {
  const missingServices = new Map(oldValue.unsafeMap);
  let patch234 = empty753();
  for (const [tag, newService] of newValue.unsafeMap.entries()) {
    if (missingServices.has(tag)) {
      const old = missingServices.get(tag);
      missingServices.delete(tag);
      if (!equals243(old, newService)) {
        patch234 = combine2243(makeUpdateService53(tag, () => newService))(patch234);
      }
    } else {
      missingServices.delete(tag);
      patch234 = combine2243(makeAddService53(tag, newService))(patch234);
    }
  }
  for (const [tag] of missingServices.entries()) {
    patch234 = combine2243(makeRemoveService53(tag))(patch234);
  }
  return patch234;
};
var combine2243 = /* @__PURE__ */ dual243(2, (self2, that) => makeAndThen53(self2, that));
var patch53 = /* @__PURE__ */ dual243(2, (self2, context) => {
  if (self2._tag === "Empty") {
    return context;
  }
  let wasServiceUpdated = false;
  let patches = of63(self2);
  const updatedContext = new Map(context.unsafeMap);
  while (isNonEmpty53(patches)) {
    const head222 = headNonEmpty63(patches);
    const tail34 = tailNonEmpty63(patches);
    switch (head222._tag) {
      case "Empty": {
        patches = tail34;
        break;
      }
      case "AddService": {
        updatedContext.set(head222.key, head222.service);
        patches = tail34;
        break;
      }
      case "AndThen": {
        patches = prepend73(prepend73(tail34, head222.second), head222.first);
        break;
      }
      case "RemoveService": {
        updatedContext.delete(head222.key);
        patches = tail34;
        break;
      }
      case "UpdateService": {
        updatedContext.set(head222.key, head222.update(updatedContext.get(head222.key)));
        wasServiceUpdated = true;
        patches = tail34;
        break;
      }
    }
  }
  if (!wasServiceUpdated) {
    return makeContext53(updatedContext);
  }
  const map622 = /* @__PURE__ */ new Map();
  for (const [tag] of context.unsafeMap) {
    if (updatedContext.has(tag)) {
      map622.set(tag, updatedContext.get(tag));
      updatedContext.delete(tag);
    }
  }
  for (const [tag, s232] of updatedContext) {
    map622.set(tag, s232);
  }
  return makeContext53(map622);
});
var DifferTypeId53 = /* @__PURE__ */ Symbol.for("effect/Differ");
var DifferProto53 = {
  [DifferTypeId53]: {
    _P: identity243,
    _V: identity243
  }
};
var make753 = (params) => {
  const differ = Object.create(DifferProto53);
  differ.empty = params.empty;
  differ.diff = params.diff;
  differ.combine = params.combine;
  differ.patch = params.patch;
  return differ;
};
var environment53 = () => make753({
  empty: empty753(),
  combine: (first, second) => combine2243(second)(first),
  diff: (oldValue, newValue) => diff53(oldValue, newValue),
  patch: (patch234, oldValue) => patch53(oldValue)(patch234)
});
var OP_DIE53 = "Die";
var OP_EMPTY53 = "Empty";
var OP_FAIL53 = "Fail";
var OP_INTERRUPT53 = "Interrupt";
var OP_PARALLEL53 = "Parallel";
var OP_SEQUENTIAL53 = "Sequential";
var CauseSymbolKey53 = "effect/Cause";
var CauseTypeId53 = /* @__PURE__ */ Symbol.for(CauseSymbolKey53);
var variance253 = {
  /* c8 ignore next */
  _E: (_232) => _232
};
var proto53 = {
  [CauseTypeId53]: variance253,
  [symbol343]() {
    return pipe243(hash243(CauseSymbolKey53), combine253(hash243(flattenCause53(this))), cached243(this));
  },
  [symbol2243](that) {
    return isCause53(that) && causeEquals53(this, that);
  },
  pipe() {
    return pipeArguments243(this, arguments);
  },
  toJSON() {
    switch (this._tag) {
      case "Empty":
        return {
          _id: "Cause",
          _tag: this._tag
        };
      case "Die":
        return {
          _id: "Cause",
          _tag: this._tag,
          defect: toJSON243(this.defect)
        };
      case "Interrupt":
        return {
          _id: "Cause",
          _tag: this._tag,
          fiberId: this.fiberId.toJSON()
        };
      case "Fail":
        return {
          _id: "Cause",
          _tag: this._tag,
          failure: toJSON243(this.error)
        };
      case "Sequential":
      case "Parallel":
        return {
          _id: "Cause",
          _tag: this._tag,
          left: toJSON243(this.left),
          right: toJSON243(this.right)
        };
    }
  },
  toString() {
    return pretty53(this);
  },
  [NodeInspectSymbol243]() {
    return this.toJSON();
  }
};
var fail63 = (error) => {
  const o232 = Object.create(proto53);
  o232._tag = OP_FAIL53;
  o232.error = error;
  return o232;
};
var parallel53 = (left334, right334) => {
  const o232 = Object.create(proto53);
  o232._tag = OP_PARALLEL53;
  o232.left = left334;
  o232.right = right334;
  return o232;
};
var sequential53 = (left334, right334) => {
  const o232 = Object.create(proto53);
  o232._tag = OP_SEQUENTIAL53;
  o232.left = left334;
  o232.right = right334;
  return o232;
};
var isCause53 = (u232) => hasProperty243(u232, CauseTypeId53);
var isInterruptedOnly53 = (self2) => reduceWithContext53(void 0, IsInterruptedOnlyCauseReducer53)(self2);
var causeEquals53 = (left334, right334) => {
  let leftStack = of63(left334);
  let rightStack = of63(right334);
  while (isNonEmpty53(leftStack) && isNonEmpty53(rightStack)) {
    const [leftParallel, leftSequential] = pipe243(headNonEmpty63(leftStack), reduce453([empty653(), empty353()], ([parallel234, sequential234], cause) => {
      const [par, seq] = evaluateCause53(cause);
      return some3243([pipe243(parallel234, union353(par)), pipe243(sequential234, appendAll63(seq))]);
    }));
    const [rightParallel, rightSequential] = pipe243(headNonEmpty63(rightStack), reduce453([empty653(), empty353()], ([parallel234, sequential234], cause) => {
      const [par, seq] = evaluateCause53(cause);
      return some3243([pipe243(parallel234, union353(par)), pipe243(sequential234, appendAll63(seq))]);
    }));
    if (!equals243(leftParallel, rightParallel)) {
      return false;
    }
    leftStack = leftSequential;
    rightStack = rightSequential;
  }
  return true;
};
var flattenCause53 = (cause) => {
  return flattenCauseLoop53(of63(cause), empty353());
};
var flattenCauseLoop53 = (causes, flattened) => {
  while (1) {
    const [parallel234, sequential234] = pipe243(causes, reduce83([empty653(), empty353()], ([parallel322, sequential322], cause) => {
      const [par, seq] = evaluateCause53(cause);
      return [pipe243(parallel322, union353(par)), pipe243(sequential322, appendAll63(seq))];
    }));
    const updated = size353(parallel234) > 0 ? pipe243(flattened, prepend73(parallel234)) : flattened;
    if (isEmpty63(sequential234)) {
      return reverse253(updated);
    }
    causes = sequential234;
    flattened = updated;
  }
  throw new Error(getBugErrorMessage243("Cause.flattenCauseLoop"));
};
var evaluateCause53 = (self2) => {
  let cause = self2;
  const stack = [];
  let _parallel = empty653();
  let _sequential = empty353();
  while (cause !== void 0) {
    switch (cause._tag) {
      case OP_EMPTY53: {
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_FAIL53: {
        _parallel = add353(_parallel, make4243(cause._tag, cause.error));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_DIE53: {
        _parallel = add353(_parallel, make4243(cause._tag, cause.defect));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_INTERRUPT53: {
        _parallel = add353(_parallel, make4243(cause._tag, cause.fiberId));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_SEQUENTIAL53: {
        switch (cause.left._tag) {
          case OP_EMPTY53: {
            cause = cause.right;
            break;
          }
          case OP_SEQUENTIAL53: {
            cause = sequential53(cause.left.left, sequential53(cause.left.right, cause.right));
            break;
          }
          case OP_PARALLEL53: {
            cause = parallel53(sequential53(cause.left.left, cause.right), sequential53(cause.left.right, cause.right));
            break;
          }
          default: {
            _sequential = prepend73(_sequential, cause.right);
            cause = cause.left;
            break;
          }
        }
        break;
      }
      case OP_PARALLEL53: {
        stack.push(cause.right);
        cause = cause.left;
        break;
      }
    }
  }
  throw new Error(getBugErrorMessage243("Cause.evaluateCauseLoop"));
};
var IsInterruptedOnlyCauseReducer53 = {
  emptyCase: constTrue243,
  failCase: constFalse243,
  dieCase: constFalse243,
  interruptCase: constTrue243,
  sequentialCase: (_232, left334, right334) => left334 && right334,
  parallelCase: (_232, left334, right334) => left334 && right334
};
var OP_SEQUENTIAL_CASE53 = "SequentialCase";
var OP_PARALLEL_CASE53 = "ParallelCase";
var reduce453 = /* @__PURE__ */ dual243(3, (self2, zero, pf) => {
  let accumulator = zero;
  let cause = self2;
  const causes = [];
  while (cause !== void 0) {
    const option = pf(accumulator, cause);
    accumulator = isSome2243(option) ? option.value : accumulator;
    switch (cause._tag) {
      case OP_SEQUENTIAL53: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      case OP_PARALLEL53: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      default: {
        cause = void 0;
        break;
      }
    }
    if (cause === void 0 && causes.length > 0) {
      cause = causes.pop();
    }
  }
  return accumulator;
});
var reduceWithContext53 = /* @__PURE__ */ dual243(3, (self2, context, reducer) => {
  const input = [self2];
  const output = [];
  while (input.length > 0) {
    const cause = input.pop();
    switch (cause._tag) {
      case OP_EMPTY53: {
        output.push(right2243(reducer.emptyCase(context)));
        break;
      }
      case OP_FAIL53: {
        output.push(right2243(reducer.failCase(context, cause.error)));
        break;
      }
      case OP_DIE53: {
        output.push(right2243(reducer.dieCase(context, cause.defect)));
        break;
      }
      case OP_INTERRUPT53: {
        output.push(right2243(reducer.interruptCase(context, cause.fiberId)));
        break;
      }
      case OP_SEQUENTIAL53: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left2243({
          _tag: OP_SEQUENTIAL_CASE53
        }));
        break;
      }
      case OP_PARALLEL53: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left2243({
          _tag: OP_PARALLEL_CASE53
        }));
        break;
      }
    }
  }
  const accumulator = [];
  while (output.length > 0) {
    const either = output.pop();
    switch (either._tag) {
      case "Left": {
        switch (either.left._tag) {
          case OP_SEQUENTIAL_CASE53: {
            const left334 = accumulator.pop();
            const right334 = accumulator.pop();
            const value = reducer.sequentialCase(context, left334, right334);
            accumulator.push(value);
            break;
          }
          case OP_PARALLEL_CASE53: {
            const left334 = accumulator.pop();
            const right334 = accumulator.pop();
            const value = reducer.parallelCase(context, left334, right334);
            accumulator.push(value);
            break;
          }
        }
        break;
      }
      case "Right": {
        accumulator.push(either.right);
        break;
      }
    }
  }
  if (accumulator.length === 0) {
    throw new Error("BUG: Cause.reduceWithContext - please report an issue at https://github.com/Effect-TS/effect/issues");
  }
  return accumulator.pop();
});
var pretty53 = (cause) => {
  if (isInterruptedOnly53(cause)) {
    return "All fibers interrupted without errors.";
  }
  return prettyErrors53(cause).map((e232) => e232.stack).join("\n");
};
var PrettyError53 = class extends globalThis.Error {
  span = void 0;
  constructor(originalError) {
    const prevLimit = Error.stackTraceLimit;
    Error.stackTraceLimit = 0;
    super(prettyErrorMessage53(originalError));
    Error.stackTraceLimit = prevLimit;
    this.name = originalError instanceof Error ? originalError.name : "Error";
    if (typeof originalError === "object" && originalError !== null) {
      if (spanSymbol63 in originalError) {
        this.span = originalError[spanSymbol63];
      }
      Object.keys(originalError).forEach((key) => {
        if (!(key in this)) {
          this[key] = originalError[key];
        }
      });
    }
    this.stack = prettyErrorStack53(this.message, originalError instanceof Error && originalError.stack ? originalError.stack : "", this.span);
  }
  toJSON() {
    const out = {
      message: this.message,
      stack: this.stack
    };
    if (this.span) {
      out.span = this.span;
    }
    return out;
  }
};
var prettyErrorMessage53 = (u232) => {
  if (typeof u232 === "string") {
    return `Error: ${u232}`;
  }
  try {
    if (hasProperty243(u232, "toString") && isFunction3243(u232["toString"]) && u232["toString"] !== Object.prototype.toString && u232["toString"] !== globalThis.Array.prototype.toString) {
      return u232["toString"]();
    }
  } catch {
  }
  return `Error: ${JSON.stringify(u232)}`;
};
var locationRegex53 = /\((.*)\)/;
var spanToTrace53 = /* @__PURE__ */ globalValue243("effect/Tracer/spanToTrace", () => /* @__PURE__ */ new WeakMap());
var prettyErrorStack53 = (message, stack, span24) => {
  const out = [message];
  const lines = stack.split("\n");
  for (let i232 = 1; i232 < lines.length; i232++) {
    if (lines[i232].includes("Generator.next")) {
      break;
    }
    if (lines[i232].includes("effect_internal_function")) {
      out.pop();
      break;
    }
    out.push(lines[i232].replace(/at .*effect_instruction_i.*\((.*)\)/, "at $1").replace(/EffectPrimitive\.\w+/, "<anonymous>"));
  }
  if (span24) {
    let current = span24;
    let i232 = 0;
    while (current && current._tag === "Span" && i232 < 10) {
      const stackFn = spanToTrace53.get(current);
      if (typeof stackFn === "function") {
        const stack2 = stackFn();
        const locationMatch = stack2.match(locationRegex53);
        const location = locationMatch ? locationMatch[1] : stack2.replace(/^at /, "");
        out.push(`    at ${current.name} (${location})`);
      } else {
        out.push(`    at ${current.name}`);
      }
      current = getOrUndefined243(current.parent);
      i232++;
    }
  }
  return out.join("\n");
};
var spanSymbol63 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var prettyErrors53 = (cause) => reduceWithContext53(cause, void 0, {
  emptyCase: () => [],
  dieCase: (_232, unknownError) => {
    return [new PrettyError53(unknownError)];
  },
  failCase: (_232, error) => {
    return [new PrettyError53(error)];
  },
  interruptCase: () => [],
  parallelCase: (_232, l232, r232) => [...l232, ...r232],
  sequentialCase: (_232, l232, r232) => [...l232, ...r232]
});
var SingleShotGen2243 = class _SingleShotGen243 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  next(a232) {
    return this.called ? {
      value: a232,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  return(a232) {
    return {
      value: a232,
      done: true
    };
  }
  throw(e232) {
    throw e232;
  }
  [Symbol.iterator]() {
    return new _SingleShotGen243(this.self);
  }
};
var spanTag53 = /* @__PURE__ */ GenericTag53("effect/ParentSpan");
var EffectTypeId2243 = /* @__PURE__ */ Symbol.for("effect/Effect");
var EffectPrimitive53 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId2243] = effectVariance243;
  constructor(_op) {
    this._op = _op;
  }
  [symbol2243](that) {
    return this === that;
  }
  [symbol343]() {
    return cached243(this, random243(this));
  }
  pipe() {
    return pipeArguments243(this, arguments);
  }
  toJSON() {
    return {
      _id: "Effect",
      _op: this._op,
      effect_instruction_i0: toJSON243(this.effect_instruction_i0),
      effect_instruction_i1: toJSON243(this.effect_instruction_i1),
      effect_instruction_i2: toJSON243(this.effect_instruction_i2)
    };
  }
  toString() {
    return format243(this.toJSON());
  }
  [NodeInspectSymbol243]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen2243(new YieldWrap243(this));
  }
};
var EffectPrimitiveFailure53 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId2243] = effectVariance243;
  constructor(_op) {
    this._op = _op;
    this._tag = _op;
  }
  [symbol2243](that) {
    return exitIsExit53(that) && that._op === "Failure" && // @ts-expect-error
    equals243(this.effect_instruction_i0, that.effect_instruction_i0);
  }
  [symbol343]() {
    return pipe243(
      // @ts-expect-error
      string243(this._tag),
      // @ts-expect-error
      combine253(hash243(this.effect_instruction_i0)),
      cached243(this)
    );
  }
  get cause() {
    return this.effect_instruction_i0;
  }
  pipe() {
    return pipeArguments243(this, arguments);
  }
  toJSON() {
    return {
      _id: "Exit",
      _tag: this._op,
      cause: this.cause.toJSON()
    };
  }
  toString() {
    return format243(this.toJSON());
  }
  [NodeInspectSymbol243]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen2243(new YieldWrap243(this));
  }
};
var isEffect53 = (u232) => hasProperty243(u232, EffectTypeId2243);
var withFiberRuntime53 = (withRuntime) => {
  const effect = new EffectPrimitive53(OP_WITH_RUNTIME53);
  effect.effect_instruction_i0 = withRuntime;
  return effect;
};
var spanSymbol253 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var originalSymbol53 = /* @__PURE__ */ Symbol.for("effect/OriginalAnnotation");
var capture53 = (obj, span24) => {
  if (isSome2243(span24)) {
    return new Proxy(obj, {
      has(target, p232) {
        return p232 === spanSymbol253 || p232 === originalSymbol53 || p232 in target;
      },
      get(target, p232) {
        if (p232 === spanSymbol253) {
          return span24.value;
        }
        if (p232 === originalSymbol53) {
          return obj;
        }
        return target[p232];
      }
    });
  }
  return obj;
};
var fail253 = (error) => isObject243(error) && !(spanSymbol253 in error) ? withFiberRuntime53((fiber) => failCause53(fail63(capture53(error, currentSpanFromFiber53(fiber))))) : failCause53(fail63(error));
var failCause53 = (cause) => {
  const effect = new EffectPrimitiveFailure53(OP_FAILURE53);
  effect.effect_instruction_i0 = cause;
  return effect;
};
var FiberRefSymbolKey53 = "effect/FiberRef";
var FiberRefTypeId53 = /* @__PURE__ */ Symbol.for(FiberRefSymbolKey53);
var fiberRefVariance53 = {
  /* c8 ignore next */
  _A: (_232) => _232
};
var fiberRefUnsafeMakeContext53 = (initial) => {
  const differ = environment53();
  return fiberRefUnsafeMakePatch53(initial, {
    differ,
    fork: differ.empty
  });
};
var fiberRefUnsafeMakePatch53 = (initial, options) => ({
  [FiberRefTypeId53]: fiberRefVariance53,
  initial,
  diff: (oldValue, newValue) => options.differ.diff(oldValue, newValue),
  combine: (first, second) => options.differ.combine(first, second),
  patch: (patch234) => (oldValue) => options.differ.patch(patch234, oldValue),
  fork: options.fork,
  join: options.join ?? ((_232, n232) => n232),
  pipe() {
    return pipeArguments243(this, arguments);
  }
});
var currentContext53 = /* @__PURE__ */ globalValue243(/* @__PURE__ */ Symbol.for("effect/FiberRef/currentContext"), () => fiberRefUnsafeMakeContext53(empty253()));
var YieldableError53 = /* @__PURE__ */ function() {
  class YieldableError234 extends globalThis.Error {
    commit() {
      return fail253(this);
    }
    toString() {
      return this.message ? `${this.name}: ${this.message}` : this.name;
    }
    toJSON() {
      return {
        ...this
      };
    }
    [NodeInspectSymbol243]() {
      const stack = this.stack;
      if (stack) {
        return `${this.toString()}
${stack.split("\n").slice(1).join("\n")}`;
      }
      return this.toString();
    }
  }
  Object.assign(YieldableError234.prototype, StructuralCommitPrototype243);
  return YieldableError234;
}();
var exitIsExit53 = (u232) => isEffect53(u232) && "_tag" in u232 && (u232._tag === "Success" || u232._tag === "Failure");
var currentSpanFromFiber53 = (fiber) => {
  const span24 = fiber.getFiberRef(currentContext53).unsafeMap.get(spanTag53.key);
  return span24 !== void 0 && span24._tag === "Span" ? some3243(span24) : none2243();
};
var Data_exports243 = {};
__export243(Data_exports243, {
  Class: () => Class253,
  Error: () => Error253,
  Structural: () => Structural253,
  TaggedClass: () => TaggedClass53,
  TaggedError: () => TaggedError53,
  array: () => array253,
  case: () => _case53,
  struct: () => struct353,
  tagged: () => tagged53,
  taggedEnum: () => taggedEnum53,
  tuple: () => tuple253,
  unsafeArray: () => unsafeArray53,
  unsafeStruct: () => unsafeStruct53
});
var struct353 = struct253;
var unsafeStruct53 = (as2234) => Object.setPrototypeOf(as2234, StructuralPrototype243);
var tuple253 = (...as2234) => unsafeArray53(as2234);
var array253 = (as2234) => unsafeArray53(as2234.slice(0));
var unsafeArray53 = (as2234) => Object.setPrototypeOf(as2234, ArrayProto53);
var _case53 = () => (args) => args === void 0 ? Object.create(StructuralPrototype243) : struct353(args);
var tagged53 = (tag) => (args) => {
  const value = args === void 0 ? Object.create(StructuralPrototype243) : struct353(args);
  value._tag = tag;
  return value;
};
var Class253 = Structural63;
var TaggedClass53 = (tag) => {
  class Base extends Class253 {
    _tag = tag;
  }
  return Base;
};
var Structural253 = Structural63;
var taggedEnum53 = () => new Proxy({}, {
  get(_target, tag, _receiver) {
    if (tag === "$is") {
      return isTagged73;
    } else if (tag === "$match") {
      return taggedMatch53;
    }
    return tagged53(tag);
  }
});
function taggedMatch53() {
  if (arguments.length === 1) {
    const cases2 = arguments[0];
    return function(value2) {
      return cases2[value2._tag](value2);
    };
  }
  const value = arguments[0];
  const cases = arguments[1];
  return cases[value._tag](value);
}
var Error253 = /* @__PURE__ */ function() {
  return class Base extends YieldableError53 {
    constructor(args) {
      super();
      if (args) {
        Object.assign(this, args);
      }
    }
  };
}();
var TaggedError53 = (tag) => {
  class Base extends Error253 {
    _tag = tag;
  }
  Base.prototype.name = tag;
  return Base;
};
var traverseUp53 = Function_exports243.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType53.Program) return Option_exports243.none();
  return predicate(parent) ? Option_exports243.some(parent) : traverseUp53(parent, predicate);
});
var traverseUpGuard53 = Function_exports243.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType53.Program) return Option_exports243.none();
  return predicate(parent) ? Option_exports243.some(parent) : traverseUpGuard53(parent, predicate);
});
var ESLintCommunityESLintUtils53;
((ESLintCommunityESLintUtils234) => {
  ESLintCommunityESLintUtils234.getFunctionHeadLocation = getFunctionHeadLocation53;
  ESLintCommunityESLintUtils234.getFunctionNameWithKind = getFunctionNameWithKind53;
  ESLintCommunityESLintUtils234.getPropertyName = getPropertyName53;
  ESLintCommunityESLintUtils234.getStaticValue = getStaticValue53;
  ESLintCommunityESLintUtils234.getStringIfConstant = getStringIfConstant53;
  ESLintCommunityESLintUtils234.hasSideEffect = hasSideEffect53;
  ESLintCommunityESLintUtils234.isParenthesized = isParenthesized53;
})(ESLintCommunityESLintUtils53 || (ESLintCommunityESLintUtils53 = {}));
var Construction53 = Data_exports243.taggedEnum();
Construction53.None();
a33({
  type: N33.union([NodeType53.FunctionExpression, NodeType53.ArrowFunctionExpression]),
  parent: {
    type: NodeType53.Property,
    parent: {
      type: NodeType53.ObjectExpression
    }
  }
});
a33({
  type: N33.union([NodeType53.FunctionExpression, NodeType53.ArrowFunctionExpression]),
  parent: {
    type: NodeType53.MethodDefinition,
    parent: {
      type: NodeType53.ClassBody
    }
  }
});
a33({
  type: N33.union([NodeType53.FunctionExpression, NodeType53.ArrowFunctionExpression]),
  parent: {
    type: NodeType53.Property,
    parent: {
      type: NodeType53.ClassBody
    }
  }
});
function getVariableInit4(at) {
  return (variable) => {
    return Function_exports73.pipe(
      Option_exports73.some(variable),
      Option_exports73.flatMapNullable((v232) => v232.defs.at(at)),
      Option_exports73.flatMap(
        (d232) => "init" in d232.node ? Option_exports73.fromNullable(d232.node.init) : Option_exports73.none()
      )
    );
  };
}
var Function_exports83 = {};
__export8(Function_exports83, {
  SK: () => SK83,
  absurd: () => absurd83,
  apply: () => apply83,
  compose: () => compose113,
  constFalse: () => constFalse83,
  constNull: () => constNull83,
  constTrue: () => constTrue83,
  constUndefined: () => constUndefined83,
  constVoid: () => constVoid83,
  constant: () => constant83,
  dual: () => dual83,
  flip: () => flip83,
  flow: () => flow83,
  hole: () => hole83,
  identity: () => identity83,
  isFunction: () => isFunction123,
  pipe: () => pipe83,
  satisfies: () => satisfies83,
  tupled: () => tupled83,
  unsafeCoerce: () => unsafeCoerce83,
  untupled: () => untupled83
});
var isFunction123 = (input) => typeof input === "function";
var dual83 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a43, b43) {
        if (arguments.length >= 2) {
          return body(a43, b43);
        }
        return function(self2) {
          return body(self2, a43);
        };
      };
    case 3:
      return function(a43, b43, c43) {
        if (arguments.length >= 3) {
          return body(a43, b43, c43);
        }
        return function(self2) {
          return body(self2, a43, b43);
        };
      };
    case 4:
      return function(a43, b43, c43, d43) {
        if (arguments.length >= 4) {
          return body(a43, b43, c43, d43);
        }
        return function(self2) {
          return body(self2, a43, b43, c43);
        };
      };
    case 5:
      return function(a43, b43, c43, d43, e43) {
        if (arguments.length >= 5) {
          return body(a43, b43, c43, d43, e43);
        }
        return function(self2) {
          return body(self2, a43, b43, c43, d43);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply83 = (a43) => (self2) => self2(a43);
var identity83 = (a43) => a43;
var satisfies83 = () => (b43) => b43;
var unsafeCoerce83 = identity83;
var constant83 = (value) => () => value;
var constTrue83 = /* @__PURE__ */ constant83(true);
var constFalse83 = /* @__PURE__ */ constant83(false);
var constNull83 = /* @__PURE__ */ constant83(null);
var constUndefined83 = /* @__PURE__ */ constant83(void 0);
var constVoid83 = constUndefined83;
var flip83 = (f43) => (...b43) => (...a43) => f43(...a43)(...b43);
var compose113 = /* @__PURE__ */ dual83(2, (ab, bc) => (a43) => bc(ab(a43)));
var absurd83 = (_43) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled83 = (f43) => (a43) => f43(...a43);
var untupled83 = (f43) => (...a43) => f43(a43);
function pipe83(a43, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a43;
    case 2:
      return ab(a43);
    case 3:
      return bc(ab(a43));
    case 4:
      return cd(bc(ab(a43)));
    case 5:
      return de(cd(bc(ab(a43))));
    case 6:
      return ef(de(cd(bc(ab(a43)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a43))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a43)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a43))))))));
    default: {
      let ret = arguments[0];
      for (let i43 = 1; i43 < arguments.length; i43++) {
        ret = arguments[i43](ret);
      }
      return ret;
    }
  }
}
function flow83(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole83 = /* @__PURE__ */ unsafeCoerce83(absurd83);
var SK83 = (_43, b43) => b43;
var make193 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_123 = (map102) => dual83(3, (self2, name22, f43) => map102(self2, (a43) => Object.assign({}, a43, {
  [name22]: f43(a43)
})));
var bindTo123 = (map102) => dual83(2, (self2, name22) => map102(self2, (a43) => ({
  [name22]: a43
})));
var bind123 = (map102, flatMap102) => dual83(3, (self2, name22, f43) => flatMap102(self2, (a43) => map102(f43(a43), (b43) => Object.assign({}, a43, {
  [name22]: b43
}))));
var moduleVersion83 = "3.2.8";
var getCurrentVersion83 = () => moduleVersion83;
var globalStoreId83 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion83()}`);
if (!(globalStoreId83 in globalThis)) {
  globalThis[globalStoreId83] = /* @__PURE__ */ new Map();
}
var globalStore83 = globalThis[globalStoreId83];
var globalValue83 = (id, compute) => {
  if (!globalStore83.has(id)) {
    globalStore83.set(id, compute());
  }
  return globalStore83.get(id);
};
var isFunction13 = isFunction123;
var isRecordOrArray83 = (input) => typeof input === "object" && input !== null;
var isObject83 = (input) => isRecordOrArray83(input) || isFunction13(input);
var hasProperty83 = /* @__PURE__ */ dual83(2, (self2, property) => isObject83(self2) && property in self2);
var isNullable83 = (input) => input === null || input === void 0;
var getBugErrorMessage83 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId83 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind83 = (u43) => isObject83(u43) && GenKindTypeId83 in u43;
var GenKindImpl83 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity83;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_43) => _43;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_43) => _43;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_43) => _43;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId83] = GenKindTypeId83;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen93(this);
  }
};
var SingleShotGen93 = class _SingleShotGen112 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a43) {
    return this.called ? {
      value: a43,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a43) {
    return {
      value: a43,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e43) {
    throw e43;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen112(this.self);
  }
};
var adapter113 = () => function() {
  let x43 = arguments[0];
  for (let i43 = 1; i43 < arguments.length; i43++) {
    x43 = arguments[i43](x43);
  }
  return new GenKindImpl83(x43);
};
var defaultIncHi83 = 335903614;
var defaultIncLo83 = 4150755663;
var MUL_HI83 = 1481765933 >>> 0;
var MUL_LO83 = 1284865837 >>> 0;
var BIT_5383 = 9007199254740992;
var BIT_2783 = 134217728;
var PCGRandom83 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable83(seedLo) && isNullable83(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable83(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable83(incLo) && isNullable83(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo83;
      incHi = this._state ? this._state[2] : defaultIncHi83;
    } else if (isNullable83(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add6483(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max34) {
    if (!max34) {
      return this._next();
    }
    max34 = max34 >>> 0;
    if ((max34 & max34 - 1) === 0) {
      return this._next() & max34 - 1;
    }
    let num = 0;
    const skew = (-max34 >>> 0) % max34 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max34;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_2783 + lo) / BIT_5383;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul6483(this._state, oldHi, oldLo, MUL_HI83, MUL_LO83);
    add6483(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul6483(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add6483(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId83 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap83 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId83]() {
    return this.#value;
  }
};
function yieldWrapGet83(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId83 in self2) {
    return self2[YieldWrapTypeId83]();
  }
  throw new Error(getBugErrorMessage83("yieldWrapGet"));
}
var structuralRegionState83 = /* @__PURE__ */ globalValue83("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache83 = /* @__PURE__ */ globalValue83(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr83 = /* @__PURE__ */ globalValue83(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom83());
var symbol113 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash83 = (self2) => {
  if (structuralRegionState83.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number93(self2);
    case "bigint":
      return string102(self2.toString(10));
    case "boolean":
      return string102(String(self2));
    case "symbol":
      return string102(String(self2));
    case "string":
      return string102(self2);
    case "undefined":
      return string102("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string102("null");
      } else if (self2 instanceof Date) {
        return hash83(self2.toISOString());
      } else if (isHash83(self2)) {
        return self2[symbol113]();
      } else {
        return random83(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random83 = (self2) => {
  if (!randomHashCache83.has(self2)) {
    randomHashCache83.set(self2, number93(pcgr83.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache83.get(self2);
};
var combine93 = (b43) => (self2) => self2 * 53 ^ b43;
var optimize83 = (n43) => n43 & 3221225471 | n43 >>> 1 & 1073741824;
var isHash83 = (u43) => hasProperty83(u43, symbol113);
var number93 = (n43) => {
  if (n43 !== n43 || n43 === Infinity) {
    return 0;
  }
  let h43 = n43 | 0;
  if (h43 !== n43) {
    h43 ^= n43 * 4294967295;
  }
  while (n43 > 4294967295) {
    h43 ^= n43 /= 4294967295;
  }
  return optimize83(n43);
};
var string102 = (str) => {
  let h43 = 5381, i43 = str.length;
  while (i43) {
    h43 = h43 * 33 ^ str.charCodeAt(--i43);
  }
  return optimize83(h43);
};
var cached83 = function() {
  if (arguments.length === 1) {
    const self3 = arguments[0];
    return function(hash102) {
      Object.defineProperty(self3, symbol113, {
        value() {
          return hash102;
        },
        enumerable: false
      });
      return hash102;
    };
  }
  const self2 = arguments[0];
  const hash92 = arguments[1];
  Object.defineProperty(self2, symbol113, {
    value() {
      return hash92;
    },
    enumerable: false
  });
  return hash92;
};
var symbol123 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals83() {
  if (arguments.length === 1) {
    return (self2) => compareBoth83(self2, arguments[0]);
  }
  return compareBoth83(arguments[0], arguments[1]);
}
function compareBoth83(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual83(self2) && isEqual83(that)) {
        if (hash83(self2) === hash83(that) && self2[symbol123](that)) {
          return true;
        } else {
          return structuralRegionState83.enabled && structuralRegionState83.tester ? structuralRegionState83.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState83.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v43, i43) => compareBoth83(v43, that[i43]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth83(self2[key], that[key]))) {
              return structuralRegionState83.tester ? structuralRegionState83.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState83.tester ? structuralRegionState83.tester(self2, that) : false;
    }
  }
  return structuralRegionState83.enabled && structuralRegionState83.tester ? structuralRegionState83.tester(self2, that) : false;
}
var isEqual83 = (u43) => hasProperty83(u43, symbol123);
var equivalence83 = () => equals83;
var NodeInspectSymbol83 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON83 = (x43) => {
  if (hasProperty83(x43, "toJSON") && isFunction13(x43["toJSON"]) && x43["toJSON"].length === 0) {
    return x43.toJSON();
  } else if (Array.isArray(x43)) {
    return x43.map(toJSON83);
  }
  return x43;
};
var format83 = (x43) => JSON.stringify(x43, null, 2);
var pipeArguments83 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i43 = 0, len = args.length; i43 < len; i43++) {
        ret = args[i43](ret);
      }
      return ret;
    }
  }
};
var EffectTypeId93 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId83 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId83 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId83 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance83 = {
  /* c8 ignore next */
  _R: (_43) => _43,
  /* c8 ignore next */
  _E: (_43) => _43,
  /* c8 ignore next */
  _A: (_43) => _43,
  _V: /* @__PURE__ */ getCurrentVersion83()
};
var sinkVariance83 = {
  /* c8 ignore next */
  _A: (_43) => _43,
  /* c8 ignore next */
  _In: (_43) => _43,
  /* c8 ignore next */
  _L: (_43) => _43,
  /* c8 ignore next */
  _E: (_43) => _43,
  /* c8 ignore next */
  _R: (_43) => _43
};
var channelVariance83 = {
  /* c8 ignore next */
  _Env: (_43) => _43,
  /* c8 ignore next */
  _InErr: (_43) => _43,
  /* c8 ignore next */
  _InElem: (_43) => _43,
  /* c8 ignore next */
  _InDone: (_43) => _43,
  /* c8 ignore next */
  _OutErr: (_43) => _43,
  /* c8 ignore next */
  _OutElem: (_43) => _43,
  /* c8 ignore next */
  _OutDone: (_43) => _43
};
var EffectPrototype83 = {
  [EffectTypeId93]: effectVariance83,
  [StreamTypeId83]: effectVariance83,
  [SinkTypeId83]: sinkVariance83,
  [ChannelTypeId83]: channelVariance83,
  [symbol123](that) {
    return this === that;
  },
  [symbol113]() {
    return cached83(this, random83(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen93(new YieldWrap83(this));
  },
  pipe() {
    return pipeArguments83(this, arguments);
  }
};
var TypeId183 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto113 = {
  ...EffectPrototype83,
  [TypeId183]: {
    _A: (_43) => _43
  },
  [NodeInspectSymbol83]() {
    return this.toJSON();
  },
  toString() {
    return format83(this.toJSON());
  }
};
var SomeProto83 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto113), {
  _tag: "Some",
  _op: "Some",
  [symbol123](that) {
    return isOption113(that) && isSome113(that) && equals83(this.value, that.value);
  },
  [symbol113]() {
    return cached83(this, combine93(hash83(this._tag))(hash83(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON83(this.value)
    };
  }
});
var NoneHash83 = /* @__PURE__ */ hash83("None");
var NoneProto83 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto113), {
  _tag: "None",
  _op: "None",
  [symbol123](that) {
    return isOption113(that) && isNone113(that);
  },
  [symbol113]() {
    return NoneHash83;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption113 = (input) => hasProperty83(input, TypeId183);
var isNone113 = (fa) => fa._tag === "None";
var isSome113 = (fa) => fa._tag === "Some";
var none113 = /* @__PURE__ */ Object.create(NoneProto83);
var some153 = (value) => {
  const a43 = Object.create(SomeProto83);
  a43.value = value;
  return a43;
};
var TypeId193 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto123 = {
  ...EffectPrototype83,
  [TypeId193]: {
    _R: (_43) => _43
  },
  [NodeInspectSymbol83]() {
    return this.toJSON();
  },
  toString() {
    return format83(this.toJSON());
  }
};
var RightProto83 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto123), {
  _tag: "Right",
  _op: "Right",
  [symbol123](that) {
    return isEither83(that) && isRight93(that) && equals83(this.right, that.right);
  },
  [symbol113]() {
    return combine93(hash83(this._tag))(hash83(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON83(this.right)
    };
  }
});
var LeftProto83 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto123), {
  _tag: "Left",
  _op: "Left",
  [symbol123](that) {
    return isEither83(that) && isLeft93(that) && equals83(this.left, that.left);
  },
  [symbol113]() {
    return combine93(hash83(this._tag))(hash83(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON83(this.left)
    };
  }
});
var isEither83 = (input) => hasProperty83(input, TypeId193);
var isLeft93 = (ma) => ma._tag === "Left";
var isRight93 = (ma) => ma._tag === "Right";
var left93 = (left102) => {
  const a43 = Object.create(LeftProto83);
  a43.left = left102;
  return a43;
};
var right93 = (right102) => {
  const a43 = Object.create(RightProto83);
  a43.right = right102;
  return a43;
};
var getLeft113 = (self2) => isRight93(self2) ? none113 : some153(self2.left);
var getRight113 = (self2) => isLeft93(self2) ? none113 : some153(self2.right);
var Option_exports83 = {};
__export8(Option_exports83, {
  Do: () => Do93,
  TypeId: () => TypeId203,
  all: () => all113,
  andThen: () => andThen83,
  ap: () => ap83,
  as: () => as83,
  asVoid: () => asVoid83,
  bind: () => bind133,
  bindTo: () => bindTo133,
  composeK: () => composeK83,
  contains: () => contains93,
  containsWith: () => containsWith93,
  exists: () => exists83,
  filter: () => filter93,
  filterMap: () => filterMap93,
  firstSomeOf: () => firstSomeOf83,
  flatMap: () => flatMap93,
  flatMapNullable: () => flatMapNullable93,
  flatten: () => flatten93,
  fromIterable: () => fromIterable113,
  fromNullable: () => fromNullable93,
  gen: () => gen83,
  getEquivalence: () => getEquivalence103,
  getLeft: () => getLeft123,
  getOrElse: () => getOrElse83,
  getOrNull: () => getOrNull83,
  getOrThrow: () => getOrThrow83,
  getOrThrowWith: () => getOrThrowWith83,
  getOrUndefined: () => getOrUndefined83,
  getOrder: () => getOrder93,
  getRight: () => getRight123,
  isNone: () => isNone123,
  isOption: () => isOption123,
  isSome: () => isSome123,
  let: () => let_133,
  lift2: () => lift283,
  liftNullable: () => liftNullable93,
  liftPredicate: () => liftPredicate93,
  liftThrowable: () => liftThrowable83,
  map: () => map93,
  match: () => match34,
  none: () => none123,
  orElse: () => orElse83,
  orElseEither: () => orElseEither83,
  orElseSome: () => orElseSome83,
  partitionMap: () => partitionMap93,
  product: () => product113,
  productMany: () => productMany113,
  reduceCompact: () => reduceCompact83,
  some: () => some163,
  tap: () => tap83,
  toArray: () => toArray83,
  toRefinement: () => toRefinement83,
  void: () => void_83,
  zipLeft: () => zipLeft83,
  zipRight: () => zipRight83,
  zipWith: () => zipWith93
});
var make203 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId203 = /* @__PURE__ */ Symbol.for("effect/Option");
var none123 = () => none113;
var some163 = some153;
var isOption123 = isOption113;
var isNone123 = isNone113;
var isSome123 = isSome113;
var match34 = /* @__PURE__ */ dual83(2, (self2, {
  onNone,
  onSome
}) => isNone123(self2) ? onNone() : onSome(self2.value));
var toRefinement83 = (f43) => (a43) => isSome123(f43(a43));
var fromIterable113 = (collection) => {
  for (const a43 of collection) {
    return some163(a43);
  }
  return none123();
};
var getRight123 = getRight113;
var getLeft123 = getLeft113;
var getOrElse83 = /* @__PURE__ */ dual83(2, (self2, onNone) => isNone123(self2) ? onNone() : self2.value);
var orElse83 = /* @__PURE__ */ dual83(2, (self2, that) => isNone123(self2) ? that() : self2);
var orElseSome83 = /* @__PURE__ */ dual83(2, (self2, onNone) => isNone123(self2) ? some163(onNone()) : self2);
var orElseEither83 = /* @__PURE__ */ dual83(2, (self2, that) => isNone123(self2) ? map93(that(), right93) : map93(self2, left93));
var firstSomeOf83 = (collection) => {
  let out = none123();
  for (out of collection) {
    if (isSome123(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable93 = (nullableValue) => nullableValue == null ? none123() : some163(nullableValue);
var liftNullable93 = (f43) => (...a43) => fromNullable93(f43(...a43));
var getOrNull83 = /* @__PURE__ */ getOrElse83(constNull83);
var getOrUndefined83 = /* @__PURE__ */ getOrElse83(constUndefined83);
var liftThrowable83 = (f43) => (...a43) => {
  try {
    return some163(f43(...a43));
  } catch (e43) {
    return none123();
  }
};
var getOrThrowWith83 = /* @__PURE__ */ dual83(2, (self2, onNone) => {
  if (isSome123(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow83 = /* @__PURE__ */ getOrThrowWith83(() => new Error("getOrThrow called on a None"));
var map93 = /* @__PURE__ */ dual83(2, (self2, f43) => isNone123(self2) ? none123() : some163(f43(self2.value)));
var as83 = /* @__PURE__ */ dual83(2, (self2, b43) => map93(self2, () => b43));
var asVoid83 = /* @__PURE__ */ as83(void 0);
var void_83 = /* @__PURE__ */ some163(void 0);
var flatMap93 = /* @__PURE__ */ dual83(2, (self2, f43) => isNone123(self2) ? none123() : f43(self2.value));
var andThen83 = /* @__PURE__ */ dual83(2, (self2, f43) => flatMap93(self2, (a43) => {
  const b43 = isFunction123(f43) ? f43(a43) : f43;
  return isOption123(b43) ? b43 : some163(b43);
}));
var flatMapNullable93 = /* @__PURE__ */ dual83(2, (self2, f43) => isNone123(self2) ? none123() : fromNullable93(f43(self2.value)));
var flatten93 = /* @__PURE__ */ flatMap93(identity83);
var zipRight83 = /* @__PURE__ */ dual83(2, (self2, that) => flatMap93(self2, () => that));
var composeK83 = /* @__PURE__ */ dual83(2, (afb, bfc) => (a43) => flatMap93(afb(a43), bfc));
var zipLeft83 = /* @__PURE__ */ dual83(2, (self2, that) => tap83(self2, () => that));
var tap83 = /* @__PURE__ */ dual83(2, (self2, f43) => flatMap93(self2, (a43) => map93(f43(a43), () => a43)));
var product113 = (self2, that) => isSome123(self2) && isSome123(that) ? some163([self2.value, that.value]) : none123();
var productMany113 = (self2, collection) => {
  if (isNone123(self2)) {
    return none123();
  }
  const out = [self2.value];
  for (const o43 of collection) {
    if (isNone123(o43)) {
      return none123();
    }
    out.push(o43.value);
  }
  return some163(out);
};
var all113 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o43 of input) {
      if (isNone123(o43)) {
        return none123();
      }
      out2.push(o43.value);
    }
    return some163(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o43 = input[key];
    if (isNone123(o43)) {
      return none123();
    }
    out[key] = o43.value;
  }
  return some163(out);
};
var zipWith93 = /* @__PURE__ */ dual83(3, (self2, that, f43) => map93(product113(self2, that), ([a43, b43]) => f43(a43, b43)));
var ap83 = /* @__PURE__ */ dual83(2, (self2, that) => zipWith93(self2, that, (f43, a43) => f43(a43)));
var reduceCompact83 = /* @__PURE__ */ dual83(3, (self2, b43, f43) => {
  let out = b43;
  for (const oa of self2) {
    if (isSome123(oa)) {
      out = f43(out, oa.value);
    }
  }
  return out;
});
var toArray83 = (self2) => isNone123(self2) ? [] : [self2.value];
var partitionMap93 = /* @__PURE__ */ dual83(2, (self2, f43) => {
  if (isNone123(self2)) {
    return [none123(), none123()];
  }
  const e43 = f43(self2.value);
  return isLeft93(e43) ? [some163(e43.left), none123()] : [none123(), some163(e43.right)];
});
var filterMap93 = /* @__PURE__ */ dual83(2, (self2, f43) => isNone123(self2) ? none123() : f43(self2.value));
var filter93 = /* @__PURE__ */ dual83(2, (self2, predicate) => filterMap93(self2, (b43) => predicate(b43) ? some153(b43) : none113));
var getEquivalence103 = (isEquivalent) => make193((x43, y43) => x43 === y43 || (isNone123(x43) ? isNone123(y43) : isNone123(y43) ? false : isEquivalent(x43.value, y43.value)));
var getOrder93 = (O43) => make203((self2, that) => isSome123(self2) ? isSome123(that) ? O43(self2.value, that.value) : 1 : -1);
var lift283 = (f43) => dual83(2, (self2, that) => zipWith93(self2, that, f43));
var liftPredicate93 = (predicate) => (b43) => predicate(b43) ? some163(b43) : none123();
var containsWith93 = (isEquivalent) => dual83(2, (self2, a43) => isNone123(self2) ? false : isEquivalent(self2.value, a43));
var _equivalence103 = /* @__PURE__ */ equivalence83();
var contains93 = /* @__PURE__ */ containsWith93(_equivalence103);
var exists83 = /* @__PURE__ */ dual83(2, (self2, refinement) => isNone123(self2) ? false : refinement(self2.value));
var bindTo133 = /* @__PURE__ */ bindTo123(map93);
var let_133 = /* @__PURE__ */ let_123(map93);
var bind133 = /* @__PURE__ */ bind123(map93, flatMap93);
var Do93 = /* @__PURE__ */ some163({});
var adapter123 = /* @__PURE__ */ adapter113();
var gen83 = (f43) => {
  const iterator = f43(adapter123);
  let state = iterator.next();
  if (state.done) {
    return some163(state.value);
  } else {
    let current = state.value;
    if (isGenKind83(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet83(current);
    }
    if (isNone123(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind83(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet83(current);
        }
        if (isNone123(current)) {
          return current;
        }
      }
    }
    return some163(state.value);
  }
};
var RULE_NAME211 = "ensure-use-callback-has-non-empty-deps";
var ensure_use_callback_has_non_empty_deps_default = createRule3({
  meta: {
    type: "problem",
    docs: {
      description: "enforce 'useCallback' has non-empty dependencies array",
      requiresTypeChecking: false
    },
    messages: {
      ENSURE_USE_CALLBACK_HAS_NON_EMPTY_DEPS: "An useCallback should have a non-empty dependencies array"
    },
    schema: []
  },
  name: RULE_NAME211,
  create(context) {
    const alias = parse(ESLintSettingsSchema22, context.settings).reactOptions?.additionalHooks?.useCallback ?? [];
    return {
      CallExpression(node) {
        const initialScope = context.sourceCode.getScope(node);
        if (!isReactHookCall2(node)) return;
        if (!isUseCallbackCall(node, context) && !alias.some(Function_exports83.flip(isReactHookCallWithNameLoose2)(node))) {
          return;
        }
        const [_43, deps] = node.arguments;
        if (!deps) {
          context.report({
            messageId: "ENSURE_USE_CALLBACK_HAS_NON_EMPTY_DEPS",
            node
          });
          return;
        }
        const maybeDescriptor = Function_exports83.pipe(
          $3(deps).with({ type: NodeType43.ArrayExpression }, Option_exports83.some).with({ type: NodeType43.Identifier }, (n43) => {
            return Function_exports83.pipe(
              findVariable53(n43.name, initialScope),
              Option_exports83.flatMap(getVariableInit4(0)),
              Option_exports83.filter(is43(NodeType43.ArrayExpression))
            );
          }).otherwise(Option_exports83.none),
          Option_exports83.filter((x43) => x43.elements.length === 0),
          Option_exports83.map(() => ({
            messageId: "ENSURE_USE_CALLBACK_HAS_NON_EMPTY_DEPS",
            node
          }))
        );
        Option_exports83.map(maybeDescriptor, context.report);
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME311 = "ensure-use-memo-has-non-empty-deps";
var ensure_use_memo_has_non_empty_deps_default = createRule3({
  meta: {
    type: "problem",
    docs: {
      description: "enforce 'useMemo' has non-empty dependencies array",
      requiresTypeChecking: false
    },
    messages: {
      ENSURE_USE_MEMO_HAS_NON_EMPTY_DEPS: "An useMemo should have a non-empty dependencies array"
    },
    schema: []
  },
  name: RULE_NAME311,
  create(context) {
    const alias = parse(ESLintSettingsSchema22, context.settings).reactOptions?.additionalHooks?.useMemo ?? [];
    return {
      CallExpression(node) {
        const initialScope = context.sourceCode.getScope(node);
        if (!isReactHookCall2(node)) return;
        if (!isUseMemoCall(node, context) && !alias.some(Function_exports83.flip(isReactHookCallWithNameLoose2)(node))) return;
        const [_43, deps] = node.arguments;
        if (!deps) {
          context.report({
            messageId: "ENSURE_USE_MEMO_HAS_NON_EMPTY_DEPS",
            node
          });
          return;
        }
        const maybeDescriptor = Function_exports83.pipe(
          $3(deps).with({ type: NodeType43.ArrayExpression }, Option_exports83.some).with({ type: NodeType43.Identifier }, (n43) => {
            return Function_exports83.pipe(
              findVariable53(n43.name, initialScope),
              Option_exports83.flatMap(getVariableInit4(0)),
              Option_exports83.filter(is43(NodeType43.ArrayExpression))
            );
          }).otherwise(Option_exports83.none),
          Option_exports83.filter((x43) => x43.elements.length === 0),
          Option_exports83.map(() => ({
            messageId: "ENSURE_USE_MEMO_HAS_NON_EMPTY_DEPS",
            node
          }))
        );
        Option_exports83.map(maybeDescriptor, context.report);
      }
    };
  },
  defaultOptions: []
});
var RULE_NAME46 = "prefer-use-state-lazy-initialization";
var ALLOW_LIST = ["Boolean", "String", "Number"];
var prefer_use_state_lazy_initialization_default = createRule3({
  meta: {
    type: "problem",
    docs: {
      description: "disallow function calls in 'useState' that aren't wrapped in an initializer function",
      requiresTypeChecking: false
    },
    messages: {
      PREFER_USE_STATE_LAZY_INITIALIZATION: "To prevent re-computation, consider using lazy initial state for useState calls that involve function calls. Ex: 'useState(() => getValue())'"
    },
    schema: []
  },
  name: RULE_NAME46,
  create(context) {
    const alias = parse(ESLintSettingsSchema22, context.settings).reactOptions?.additionalHooks?.useState ?? [];
    return {
      CallExpression(node) {
        if (!isReactHookCall2(node)) return;
        if (!isUseStateCall(node, context) && !alias.some(Function_exports83.flip(isReactHookCallWithNameLoose2)(node))) return;
        const [useStateInput] = node.arguments;
        if (!useStateInput) return;
        const nestedCallExpressions = getNestedCallExpressions(useStateInput);
        const hasFunctionCall = nestedCallExpressions.some((n43) => {
          return "name" in n43.callee && !ALLOW_LIST.includes(n43.callee.name);
        });
        if (!hasFunctionCall) return;
        context.report({
          messageId: "PREFER_USE_STATE_LAZY_INITIALIZATION",
          node: useStateInput
        });
      }
    };
  },
  defaultOptions: []
});
var meta3 = {
  name: name3,
  version: version3
};
var rules3 = {
  "ensure-custom-hooks-using-other-hooks": ensure_custom_hooks_using_other_hooks_default,
  "ensure-use-callback-has-non-empty-deps": ensure_use_callback_has_non_empty_deps_default,
  "ensure-use-memo-has-non-empty-deps": ensure_use_memo_has_non_empty_deps_default,
  "prefer-use-state-lazy-initialization": prefer_use_state_lazy_initialization_default
};

// ../eslint-plugin-react-naming-convention/dist/index.mjs
var dist_exports4 = {};
__export(dist_exports4, {
  meta: () => meta4,
  rules: () => rules4
});
var __create4 = Object.create;
var __defProp9 = Object.defineProperty;
var __getOwnPropDesc4 = Object.getOwnPropertyDescriptor;
var __getOwnPropNames4 = Object.getOwnPropertyNames;
var __getProtoOf4 = Object.getPrototypeOf;
var __hasOwnProp4 = Object.prototype.hasOwnProperty;
var __commonJS4 = (cb, mod) => function __require() {
  return mod || (0, cb[__getOwnPropNames4(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
};
var __export9 = (target, all123) => {
  for (var name22 in all123)
    __defProp9(target, name22, { get: all123[name22], enumerable: true });
};
var __copyProps4 = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames4(from))
      if (!__hasOwnProp4.call(to, key) && key !== except)
        __defProp9(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc4(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM4 = (mod, isNodeMode, target) => (target = mod != null ? __create4(__getProtoOf4(mod)) : {}, __copyProps4(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  __defProp9(target, "default", { value: mod, enumerable: true }),
  mod
));
var require_short_unique_id4 = __commonJS4({
  "../../../node_modules/.pnpm/short-unique-id@5.2.0/node_modules/short-unique-id/dist/short-unique-id.js"(exports, module) {
    var ShortUniqueId2 = (() => {
      var __defProp64 = Object.defineProperty;
      var __getOwnPropDesc22 = Object.getOwnPropertyDescriptor;
      var __getOwnPropNames22 = Object.getOwnPropertyNames;
      var __getOwnPropSymbols = Object.getOwnPropertySymbols;
      var __hasOwnProp22 = Object.prototype.hasOwnProperty;
      var __propIsEnum = Object.prototype.propertyIsEnumerable;
      var __defNormalProp = (obj, key, value) => key in obj ? __defProp64(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
      var __spreadValues = (a43, b43) => {
        for (var prop in b43 || (b43 = {}))
          if (__hasOwnProp22.call(b43, prop))
            __defNormalProp(a43, prop, b43[prop]);
        if (__getOwnPropSymbols)
          for (var prop of __getOwnPropSymbols(b43)) {
            if (__propIsEnum.call(b43, prop))
              __defNormalProp(a43, prop, b43[prop]);
          }
        return a43;
      };
      var __export64 = (target, all123) => {
        for (var name22 in all123)
          __defProp64(target, name22, { get: all123[name22], enumerable: true });
      };
      var __copyProps22 = (to, from, except, desc) => {
        if (from && typeof from === "object" || typeof from === "function") {
          for (let key of __getOwnPropNames22(from))
            if (!__hasOwnProp22.call(to, key) && key !== except)
              __defProp64(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc22(from, key)) || desc.enumerable });
        }
        return to;
      };
      var __toCommonJS = (mod) => __copyProps22(__defProp64({}, "__esModule", { value: true }), mod);
      var __publicField = (obj, key, value) => {
        __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
        return value;
      };
      var src_exports = {};
      __export64(src_exports, {
        DEFAULT_OPTIONS: () => DEFAULT_OPTIONS,
        DEFAULT_UUID_LENGTH: () => DEFAULT_UUID_LENGTH,
        default: () => ShortUniqueId3
      });
      var version22 = "5.2.0";
      var DEFAULT_UUID_LENGTH = 6;
      var DEFAULT_OPTIONS = {
        dictionary: "alphanum",
        shuffle: true,
        debug: false,
        length: DEFAULT_UUID_LENGTH,
        counter: 0
      };
      var _ShortUniqueId = class _ShortUniqueId {
        constructor(argOptions = {}) {
          __publicField(this, "counter");
          __publicField(this, "debug");
          __publicField(this, "dict");
          __publicField(this, "version");
          __publicField(this, "dictIndex", 0);
          __publicField(this, "dictRange", []);
          __publicField(this, "lowerBound", 0);
          __publicField(this, "upperBound", 0);
          __publicField(this, "dictLength", 0);
          __publicField(this, "uuidLength");
          __publicField(this, "_digit_first_ascii", 48);
          __publicField(this, "_digit_last_ascii", 58);
          __publicField(this, "_alpha_lower_first_ascii", 97);
          __publicField(this, "_alpha_lower_last_ascii", 123);
          __publicField(this, "_hex_last_ascii", 103);
          __publicField(this, "_alpha_upper_first_ascii", 65);
          __publicField(this, "_alpha_upper_last_ascii", 91);
          __publicField(this, "_number_dict_ranges", {
            digits: [this._digit_first_ascii, this._digit_last_ascii]
          });
          __publicField(this, "_alpha_dict_ranges", {
            lowerCase: [this._alpha_lower_first_ascii, this._alpha_lower_last_ascii],
            upperCase: [this._alpha_upper_first_ascii, this._alpha_upper_last_ascii]
          });
          __publicField(this, "_alpha_lower_dict_ranges", {
            lowerCase: [this._alpha_lower_first_ascii, this._alpha_lower_last_ascii]
          });
          __publicField(this, "_alpha_upper_dict_ranges", {
            upperCase: [this._alpha_upper_first_ascii, this._alpha_upper_last_ascii]
          });
          __publicField(this, "_alphanum_dict_ranges", {
            digits: [this._digit_first_ascii, this._digit_last_ascii],
            lowerCase: [this._alpha_lower_first_ascii, this._alpha_lower_last_ascii],
            upperCase: [this._alpha_upper_first_ascii, this._alpha_upper_last_ascii]
          });
          __publicField(this, "_alphanum_lower_dict_ranges", {
            digits: [this._digit_first_ascii, this._digit_last_ascii],
            lowerCase: [this._alpha_lower_first_ascii, this._alpha_lower_last_ascii]
          });
          __publicField(this, "_alphanum_upper_dict_ranges", {
            digits: [this._digit_first_ascii, this._digit_last_ascii],
            upperCase: [this._alpha_upper_first_ascii, this._alpha_upper_last_ascii]
          });
          __publicField(this, "_hex_dict_ranges", {
            decDigits: [this._digit_first_ascii, this._digit_last_ascii],
            alphaDigits: [this._alpha_lower_first_ascii, this._hex_last_ascii]
          });
          __publicField(this, "_dict_ranges", {
            _number_dict_ranges: this._number_dict_ranges,
            _alpha_dict_ranges: this._alpha_dict_ranges,
            _alpha_lower_dict_ranges: this._alpha_lower_dict_ranges,
            _alpha_upper_dict_ranges: this._alpha_upper_dict_ranges,
            _alphanum_dict_ranges: this._alphanum_dict_ranges,
            _alphanum_lower_dict_ranges: this._alphanum_lower_dict_ranges,
            _alphanum_upper_dict_ranges: this._alphanum_upper_dict_ranges,
            _hex_dict_ranges: this._hex_dict_ranges
          });
          __publicField(this, "log", (...args) => {
            const finalArgs = [...args];
            finalArgs[0] = `[short-unique-id] ${args[0]}`;
            if (this.debug === true) {
              if (typeof console !== "undefined" && console !== null) {
                return console.log(...finalArgs);
              }
            }
          });
          __publicField(this, "_normalizeDictionary", (dictionary2, shuffle2) => {
            let finalDict;
            if (dictionary2 && Array.isArray(dictionary2) && dictionary2.length > 1) {
              finalDict = dictionary2;
            } else {
              finalDict = [];
              let i43;
              this.dictIndex = i43 = 0;
              const rangesName = `_${dictionary2}_dict_ranges`;
              const ranges = this._dict_ranges[rangesName];
              Object.keys(ranges).forEach((rangeType) => {
                const rangeTypeKey = rangeType;
                this.dictRange = ranges[rangeTypeKey];
                this.lowerBound = this.dictRange[0];
                this.upperBound = this.dictRange[1];
                for (this.dictIndex = i43 = this.lowerBound; this.lowerBound <= this.upperBound ? i43 < this.upperBound : i43 > this.upperBound; this.dictIndex = this.lowerBound <= this.upperBound ? i43 += 1 : i43 -= 1) {
                  finalDict.push(String.fromCharCode(this.dictIndex));
                }
              });
            }
            if (shuffle2) {
              const PROBABILITY = 0.5;
              finalDict = finalDict.sort(() => Math.random() - PROBABILITY);
            }
            return finalDict;
          });
          __publicField(this, "setDictionary", (dictionary2, shuffle2) => {
            this.dict = this._normalizeDictionary(dictionary2, shuffle2);
            this.dictLength = this.dict.length;
            this.setCounter(0);
          });
          __publicField(this, "seq", () => {
            return this.sequentialUUID();
          });
          __publicField(this, "sequentialUUID", () => {
            let counterDiv;
            let counterRem;
            let id = "";
            counterDiv = this.counter;
            do {
              counterRem = counterDiv % this.dictLength;
              counterDiv = Math.trunc(counterDiv / this.dictLength);
              id += this.dict[counterRem];
            } while (counterDiv !== 0);
            this.counter += 1;
            return id;
          });
          __publicField(this, "rnd", (uuidLength = this.uuidLength || DEFAULT_UUID_LENGTH) => {
            return this.randomUUID(uuidLength);
          });
          __publicField(this, "randomUUID", (uuidLength = this.uuidLength || DEFAULT_UUID_LENGTH) => {
            let id;
            let randomPartIdx;
            let j43;
            if (uuidLength === null || typeof uuidLength === "undefined" || uuidLength < 1) {
              throw new Error("Invalid UUID Length Provided");
            }
            id = "";
            for (j43 = 0; j43 < uuidLength; j43 += 1) {
              randomPartIdx = parseInt(
                (Math.random() * this.dictLength).toFixed(0),
                10
              ) % this.dictLength;
              id += this.dict[randomPartIdx];
            }
            return id;
          });
          __publicField(this, "fmt", (format92, date) => {
            return this.formattedUUID(format92, date);
          });
          __publicField(this, "formattedUUID", (format92, date) => {
            const fnMap = {
              "$r": this.randomUUID,
              "$s": this.sequentialUUID,
              "$t": this.stamp
            };
            const result = format92.replace(
              /\$[rs]\d{0,}|\$t0|\$t[1-9]\d{1,}/g,
              (m43) => {
                const fn = m43.slice(0, 2);
                const len = parseInt(m43.slice(2), 10);
                if (fn === "$s") {
                  return fnMap[fn]().padStart(len, "0");
                }
                if (fn === "$t" && date) {
                  return fnMap[fn](len, date);
                }
                return fnMap[fn](len);
              }
            );
            return result;
          });
          __publicField(this, "availableUUIDs", (uuidLength = this.uuidLength) => {
            return parseFloat(
              Math.pow([...new Set(this.dict)].length, uuidLength).toFixed(0)
            );
          });
          __publicField(this, "approxMaxBeforeCollision", (rounds = this.availableUUIDs(this.uuidLength)) => {
            return parseFloat(
              Math.sqrt(Math.PI / 2 * rounds).toFixed(20)
            );
          });
          __publicField(this, "collisionProbability", (rounds = this.availableUUIDs(this.uuidLength), uuidLength = this.uuidLength) => {
            return parseFloat(
              (this.approxMaxBeforeCollision(rounds) / this.availableUUIDs(uuidLength)).toFixed(20)
            );
          });
          __publicField(this, "uniqueness", (rounds = this.availableUUIDs(this.uuidLength)) => {
            const score = parseFloat(
              (1 - this.approxMaxBeforeCollision(rounds) / rounds).toFixed(20)
            );
            return score > 1 ? 1 : score < 0 ? 0 : score;
          });
          __publicField(this, "getVersion", () => {
            return this.version;
          });
          __publicField(this, "stamp", (finalLength, date) => {
            const hexStamp = Math.floor(+(date || /* @__PURE__ */ new Date()) / 1e3).toString(16);
            if (typeof finalLength === "number" && finalLength === 0) {
              return hexStamp;
            }
            if (typeof finalLength !== "number" || finalLength < 10) {
              throw new Error(
                [
                  "Param finalLength must be a number greater than or equal to 10,",
                  "or 0 if you want the raw hexadecimal timestamp"
                ].join("\n")
              );
            }
            const idLength = finalLength - 9;
            const rndIdx = Math.round(Math.random() * (idLength > 15 ? 15 : idLength));
            const id = this.randomUUID(idLength);
            return `${id.substring(0, rndIdx)}${hexStamp}${id.substring(rndIdx)}${rndIdx.toString(16)}`;
          });
          __publicField(this, "parseStamp", (suid, format92) => {
            if (format92 && !/t0|t[1-9]\d{1,}/.test(format92)) {
              throw new Error("Cannot extract date from a formated UUID with no timestamp in the format");
            }
            const stamp = format92 ? format92.replace(
              /\$[rs]\d{0,}|\$t0|\$t[1-9]\d{1,}/g,
              (m43) => {
                const fnMap = {
                  "$r": (len2) => [...Array(len2)].map(() => "r").join(""),
                  "$s": (len2) => [...Array(len2)].map(() => "s").join(""),
                  "$t": (len2) => [...Array(len2)].map(() => "t").join("")
                };
                const fn = m43.slice(0, 2);
                const len = parseInt(m43.slice(2), 10);
                return fnMap[fn](len);
              }
            ).replace(
              /^(.*?)(t{8,})(.*)$/g,
              (_m, p1, p232) => {
                return suid.substring(p1.length, p1.length + p232.length);
              }
            ) : suid;
            if (stamp.length === 8) {
              return new Date(parseInt(stamp, 16) * 1e3);
            }
            if (stamp.length < 10) {
              throw new Error("Stamp length invalid");
            }
            const rndIdx = parseInt(stamp.substring(stamp.length - 1), 16);
            return new Date(parseInt(stamp.substring(rndIdx, rndIdx + 8), 16) * 1e3);
          });
          __publicField(this, "setCounter", (counter2) => {
            this.counter = counter2;
          });
          __publicField(this, "validate", (uid4, dictionary2) => {
            const finalDictionary = dictionary2 ? this._normalizeDictionary(dictionary2) : this.dict;
            return uid4.split("").every((c43) => finalDictionary.includes(c43));
          });
          const options = __spreadValues(__spreadValues({}, DEFAULT_OPTIONS), argOptions);
          this.counter = 0;
          this.debug = false;
          this.dict = [];
          this.version = version22;
          const {
            dictionary,
            shuffle,
            length: length42,
            counter
          } = options;
          this.uuidLength = length42;
          this.setDictionary(dictionary, shuffle);
          this.setCounter(counter);
          this.debug = options.debug;
          this.log(this.dict);
          this.log(
            `Generator instantiated with Dictionary Size ${this.dictLength} and counter set to ${this.counter}`
          );
          this.log = this.log.bind(this);
          this.setDictionary = this.setDictionary.bind(this);
          this.setCounter = this.setCounter.bind(this);
          this.seq = this.seq.bind(this);
          this.sequentialUUID = this.sequentialUUID.bind(this);
          this.rnd = this.rnd.bind(this);
          this.randomUUID = this.randomUUID.bind(this);
          this.fmt = this.fmt.bind(this);
          this.formattedUUID = this.formattedUUID.bind(this);
          this.availableUUIDs = this.availableUUIDs.bind(this);
          this.approxMaxBeforeCollision = this.approxMaxBeforeCollision.bind(this);
          this.collisionProbability = this.collisionProbability.bind(this);
          this.uniqueness = this.uniqueness.bind(this);
          this.getVersion = this.getVersion.bind(this);
          this.stamp = this.stamp.bind(this);
          this.parseStamp = this.parseStamp.bind(this);
          return this;
        }
      };
      __publicField(_ShortUniqueId, "default", _ShortUniqueId);
      var ShortUniqueId3 = _ShortUniqueId;
      return __toCommonJS(src_exports);
    })();
    "undefined" != typeof module && (module.exports = ShortUniqueId2.default), "undefined" != typeof window && (ShortUniqueId2 = ShortUniqueId2.default);
  }
});
var name4 = "@neetly-eslint-react/eslint-plugin-react-naming-convention";
var version4 = "0.0.0-dev.0";
var t7 = Symbol.for("@ts-pattern/matcher");
var e7 = Symbol.for("@ts-pattern/isVariadic");
var n7 = "@ts-pattern/anonymous-select-key";
var r7 = (t43) => Boolean(t43 && "object" == typeof t43);
var i7 = (e43) => e43 && !!e43[t7];
var o7 = (n43, s43, c43) => {
  if (i7(n43)) {
    const e43 = n43[t7](), { matched: r43, selections: i43 } = e43.match(s43);
    return r43 && i43 && Object.keys(i43).forEach((t43) => c43(t43, i43[t43])), r43;
  }
  if (r7(n43)) {
    if (!r7(s43)) return false;
    if (Array.isArray(n43)) {
      if (!Array.isArray(s43)) return false;
      let t43 = [], r43 = [], a43 = [];
      for (const o43 of n43.keys()) {
        const s52 = n43[o43];
        i7(s52) && s52[e7] ? a43.push(s52) : a43.length ? r43.push(s52) : t43.push(s52);
      }
      if (a43.length) {
        if (a43.length > 1) throw new Error("Pattern error: Using `...P.array(...)` several times in a single pattern is not allowed.");
        if (s43.length < t43.length + r43.length) return false;
        const e43 = s43.slice(0, t43.length), n52 = 0 === r43.length ? [] : s43.slice(-r43.length), i43 = s43.slice(t43.length, 0 === r43.length ? Infinity : -r43.length);
        return t43.every((t52, n62) => o7(t52, e43[n62], c43)) && r43.every((t52, e52) => o7(t52, n52[e52], c43)) && (0 === a43.length || o7(a43[0], i43, c43));
      }
      return n43.length === s43.length && n43.every((t52, e43) => o7(t52, s43[e43], c43));
    }
    return Object.keys(n43).every((e43) => {
      const r43 = n43[e43];
      return (e43 in s43 || i7(a43 = r43) && "optional" === a43[t7]().matcherType) && o7(r43, s43[e43], c43);
      var a43;
    });
  }
  return Object.is(s43, n43);
};
var s7 = (e43) => {
  var n43, o43, a43;
  return r7(e43) ? i7(e43) ? null != (n43 = null == (o43 = (a43 = e43[t7]()).getSelectionKeys) ? void 0 : o43.call(a43)) ? n43 : [] : Array.isArray(e43) ? c7(e43, s7) : c7(Object.values(e43), s7) : [];
};
var c7 = (t43, e43) => t43.reduce((t52, n43) => t52.concat(e43(n43)), []);
function a7(...t43) {
  if (1 === t43.length) {
    const [e43] = t43;
    return (t52) => o7(e43, t52, () => {
    });
  }
  if (2 === t43.length) {
    const [e43, n43] = t43;
    return o7(e43, n43, () => {
    });
  }
  throw new Error(`isMatching wasn't given the right number of arguments: expected 1 or 2, received ${t43.length}.`);
}
function u7(t43) {
  return Object.assign(t43, { optional: () => l7(t43), and: (e43) => m7(t43, e43), or: (e43) => d7(t43, e43), select: (e43) => void 0 === e43 ? p7(t43) : p7(e43, t43) });
}
function h7(t43) {
  return Object.assign(((t52) => Object.assign(t52, { [Symbol.iterator]() {
    let n43 = 0;
    const r43 = [{ value: Object.assign(t52, { [e7]: true }), done: false }, { done: true, value: void 0 }];
    return { next: () => {
      var t62;
      return null != (t62 = r43[n43++]) ? t62 : r43.at(-1);
    } };
  } }))(t43), { optional: () => h7(l7(t43)), select: (e43) => h7(void 0 === e43 ? p7(t43) : p7(e43, t43)) });
}
function l7(e43) {
  return u7({ [t7]: () => ({ match: (t43) => {
    let n43 = {};
    const r43 = (t52, e52) => {
      n43[t52] = e52;
    };
    return void 0 === t43 ? (s7(e43).forEach((t52) => r43(t52, void 0)), { matched: true, selections: n43 }) : { matched: o7(e43, t43, r43), selections: n43 };
  }, getSelectionKeys: () => s7(e43), matcherType: "optional" }) });
}
var f7 = (t43, e43) => {
  for (const n43 of t43) if (!e43(n43)) return false;
  return true;
};
var g7 = (t43, e43) => {
  for (const [n43, r43] of t43.entries()) if (!e43(r43, n43)) return false;
  return true;
};
function m7(...e43) {
  return u7({ [t7]: () => ({ match: (t43) => {
    let n43 = {};
    const r43 = (t52, e52) => {
      n43[t52] = e52;
    };
    return { matched: e43.every((e52) => o7(e52, t43, r43)), selections: n43 };
  }, getSelectionKeys: () => c7(e43, s7), matcherType: "and" }) });
}
function d7(...e43) {
  return u7({ [t7]: () => ({ match: (t43) => {
    let n43 = {};
    const r43 = (t52, e52) => {
      n43[t52] = e52;
    };
    return c7(e43, s7).forEach((t52) => r43(t52, void 0)), { matched: e43.some((e52) => o7(e52, t43, r43)), selections: n43 };
  }, getSelectionKeys: () => c7(e43, s7), matcherType: "or" }) });
}
function y7(e43) {
  return { [t7]: () => ({ match: (t43) => ({ matched: Boolean(e43(t43)) }) }) };
}
function p7(...e43) {
  const r43 = "string" == typeof e43[0] ? e43[0] : void 0, i43 = 2 === e43.length ? e43[1] : "string" == typeof e43[0] ? void 0 : e43[0];
  return u7({ [t7]: () => ({ match: (t43) => {
    let e52 = { [null != r43 ? r43 : n7]: t43 };
    return { matched: void 0 === i43 || o7(i43, t43, (t52, n43) => {
      e52[t52] = n43;
    }), selections: e52 };
  }, getSelectionKeys: () => [null != r43 ? r43 : n7].concat(void 0 === i43 ? [] : s7(i43)) }) });
}
function v7(t43) {
  return "number" == typeof t43;
}
function b7(t43) {
  return "string" == typeof t43;
}
function w7(t43) {
  return "bigint" == typeof t43;
}
var S7 = u7(y7(function(t43) {
  return true;
}));
var O7 = S7;
var j7 = (t43) => Object.assign(u7(t43), { startsWith: (e43) => {
  return j7(m7(t43, (n43 = e43, y7((t52) => b7(t52) && t52.startsWith(n43)))));
  var n43;
}, endsWith: (e43) => {
  return j7(m7(t43, (n43 = e43, y7((t52) => b7(t52) && t52.endsWith(n43)))));
  var n43;
}, minLength: (e43) => j7(m7(t43, ((t52) => y7((e52) => b7(e52) && e52.length >= t52))(e43))), maxLength: (e43) => j7(m7(t43, ((t52) => y7((e52) => b7(e52) && e52.length <= t52))(e43))), includes: (e43) => {
  return j7(m7(t43, (n43 = e43, y7((t52) => b7(t52) && t52.includes(n43)))));
  var n43;
}, regex: (e43) => {
  return j7(m7(t43, (n43 = e43, y7((t52) => b7(t52) && Boolean(t52.match(n43))))));
  var n43;
} });
var E7 = j7(y7(b7));
var K7 = (t43) => Object.assign(u7(t43), { between: (e43, n43) => K7(m7(t43, ((t52, e52) => y7((n52) => v7(n52) && t52 <= n52 && e52 >= n52))(e43, n43))), lt: (e43) => K7(m7(t43, ((t52) => y7((e52) => v7(e52) && e52 < t52))(e43))), gt: (e43) => K7(m7(t43, ((t52) => y7((e52) => v7(e52) && e52 > t52))(e43))), lte: (e43) => K7(m7(t43, ((t52) => y7((e52) => v7(e52) && e52 <= t52))(e43))), gte: (e43) => K7(m7(t43, ((t52) => y7((e52) => v7(e52) && e52 >= t52))(e43))), int: () => K7(m7(t43, y7((t52) => v7(t52) && Number.isInteger(t52)))), finite: () => K7(m7(t43, y7((t52) => v7(t52) && Number.isFinite(t52)))), positive: () => K7(m7(t43, y7((t52) => v7(t52) && t52 > 0))), negative: () => K7(m7(t43, y7((t52) => v7(t52) && t52 < 0))) });
var x7 = K7(y7(v7));
var A7 = (t43) => Object.assign(u7(t43), { between: (e43, n43) => A7(m7(t43, ((t52, e52) => y7((n52) => w7(n52) && t52 <= n52 && e52 >= n52))(e43, n43))), lt: (e43) => A7(m7(t43, ((t52) => y7((e52) => w7(e52) && e52 < t52))(e43))), gt: (e43) => A7(m7(t43, ((t52) => y7((e52) => w7(e52) && e52 > t52))(e43))), lte: (e43) => A7(m7(t43, ((t52) => y7((e52) => w7(e52) && e52 <= t52))(e43))), gte: (e43) => A7(m7(t43, ((t52) => y7((e52) => w7(e52) && e52 >= t52))(e43))), positive: () => A7(m7(t43, y7((t52) => w7(t52) && t52 > 0))), negative: () => A7(m7(t43, y7((t52) => w7(t52) && t52 < 0))) });
var P7 = A7(y7(w7));
var T7 = u7(y7(function(t43) {
  return "boolean" == typeof t43;
}));
var k7 = u7(y7(function(t43) {
  return "symbol" == typeof t43;
}));
var B7 = u7(y7(function(t43) {
  return null == t43;
}));
var _7 = u7(y7(function(t43) {
  return null != t43;
}));
var N7 = { __proto__: null, matcher: t7, optional: l7, array: function(...e43) {
  return h7({ [t7]: () => ({ match: (t43) => {
    if (!Array.isArray(t43)) return { matched: false };
    if (0 === e43.length) return { matched: true };
    const n43 = e43[0];
    let r43 = {};
    if (0 === t43.length) return s7(n43).forEach((t52) => {
      r43[t52] = [];
    }), { matched: true, selections: r43 };
    const i43 = (t52, e52) => {
      r43[t52] = (r43[t52] || []).concat([e52]);
    };
    return { matched: t43.every((t52) => o7(n43, t52, i43)), selections: r43 };
  }, getSelectionKeys: () => 0 === e43.length ? [] : s7(e43[0]) }) });
}, set: function(...e43) {
  return u7({ [t7]: () => ({ match: (t43) => {
    if (!(t43 instanceof Set)) return { matched: false };
    let n43 = {};
    if (0 === t43.size) return { matched: true, selections: n43 };
    if (0 === e43.length) return { matched: true };
    const r43 = (t52, e52) => {
      n43[t52] = (n43[t52] || []).concat([e52]);
    }, i43 = e43[0];
    return { matched: f7(t43, (t52) => o7(i43, t52, r43)), selections: n43 };
  }, getSelectionKeys: () => 0 === e43.length ? [] : s7(e43[0]) }) });
}, map: function(...e43) {
  return u7({ [t7]: () => ({ match: (t43) => {
    if (!(t43 instanceof Map)) return { matched: false };
    let n43 = {};
    if (0 === t43.size) return { matched: true, selections: n43 };
    const r43 = (t52, e52) => {
      n43[t52] = (n43[t52] || []).concat([e52]);
    };
    if (0 === e43.length) return { matched: true };
    var i43;
    if (1 === e43.length) throw new Error(`\`P.map\` wasn't given enough arguments. Expected (key, value), received ${null == (i43 = e43[0]) ? void 0 : i43.toString()}`);
    const [s43, c43] = e43;
    return { matched: g7(t43, (t52, e52) => {
      const n52 = o7(s43, e52, r43), i52 = o7(c43, t52, r43);
      return n52 && i52;
    }), selections: n43 };
  }, getSelectionKeys: () => 0 === e43.length ? [] : [...s7(e43[0]), ...s7(e43[1])] }) });
}, intersection: m7, union: d7, not: function(e43) {
  return u7({ [t7]: () => ({ match: (t43) => ({ matched: !o7(e43, t43, () => {
  }) }), getSelectionKeys: () => [], matcherType: "not" }) });
}, when: y7, select: p7, any: S7, _: O7, string: E7, number: x7, bigint: P7, boolean: T7, symbol: k7, nullish: B7, nonNullable: _7, instanceOf: function(t43) {
  return u7(y7(/* @__PURE__ */ function(t52) {
    return (e43) => e43 instanceof t52;
  }(t43)));
}, shape: function(t43) {
  return u7(y7(a7(t43)));
} };
var W4 = { matched: false, value: void 0 };
function $4(t43) {
  return new z4(t43, W4);
}
var z4 = class _z4 {
  constructor(t43, e43) {
    this.input = void 0, this.state = void 0, this.input = t43, this.state = e43;
  }
  with(...t43) {
    if (this.state.matched) return this;
    const e43 = t43[t43.length - 1], r43 = [t43[0]];
    let i43;
    3 === t43.length && "function" == typeof t43[1] ? i43 = t43[1] : t43.length > 2 && r43.push(...t43.slice(1, t43.length - 1));
    let s43 = false, c43 = {};
    const a43 = (t52, e52) => {
      s43 = true, c43[t52] = e52;
    }, u43 = !r43.some((t52) => o7(t52, this.input, a43)) || i43 && !Boolean(i43(this.input)) ? W4 : { matched: true, value: e43(s43 ? n7 in c43 ? c43[n7] : c43 : this.input, this.input) };
    return new _z4(this.input, u43);
  }
  when(t43, e43) {
    if (this.state.matched) return this;
    const n43 = Boolean(t43(this.input));
    return new _z4(this.input, n43 ? { matched: true, value: e43(this.input, this.input) } : W4);
  }
  otherwise(t43) {
    return this.state.matched ? this.state.value : t43(this.input);
  }
  exhaustive() {
    if (this.state.matched) return this.state.value;
    let t43;
    try {
      t43 = JSON.stringify(this.input);
    } catch (e43) {
      t43 = this.input;
    }
    throw new Error(`Pattern matching error: no pattern matches value ${t43}`);
  }
  run() {
    return this.exhaustive();
  }
  returnType() {
    return this;
  }
};
var KEYS8 = {
  ArrayExpression: [
    "elements"
  ],
  ArrayPattern: [
    "elements"
  ],
  ArrowFunctionExpression: [
    "params",
    "body"
  ],
  AssignmentExpression: [
    "left",
    "right"
  ],
  AssignmentPattern: [
    "left",
    "right"
  ],
  AwaitExpression: [
    "argument"
  ],
  BinaryExpression: [
    "left",
    "right"
  ],
  BlockStatement: [
    "body"
  ],
  BreakStatement: [
    "label"
  ],
  CallExpression: [
    "callee",
    "arguments"
  ],
  CatchClause: [
    "param",
    "body"
  ],
  ChainExpression: [
    "expression"
  ],
  ClassBody: [
    "body"
  ],
  ClassDeclaration: [
    "id",
    "superClass",
    "body"
  ],
  ClassExpression: [
    "id",
    "superClass",
    "body"
  ],
  ConditionalExpression: [
    "test",
    "consequent",
    "alternate"
  ],
  ContinueStatement: [
    "label"
  ],
  DebuggerStatement: [],
  DoWhileStatement: [
    "body",
    "test"
  ],
  EmptyStatement: [],
  ExperimentalRestProperty: [
    "argument"
  ],
  ExperimentalSpreadProperty: [
    "argument"
  ],
  ExportAllDeclaration: [
    "exported",
    "source"
  ],
  ExportDefaultDeclaration: [
    "declaration"
  ],
  ExportNamedDeclaration: [
    "declaration",
    "specifiers",
    "source"
  ],
  ExportSpecifier: [
    "exported",
    "local"
  ],
  ExpressionStatement: [
    "expression"
  ],
  ForInStatement: [
    "left",
    "right",
    "body"
  ],
  ForOfStatement: [
    "left",
    "right",
    "body"
  ],
  ForStatement: [
    "init",
    "test",
    "update",
    "body"
  ],
  FunctionDeclaration: [
    "id",
    "params",
    "body"
  ],
  FunctionExpression: [
    "id",
    "params",
    "body"
  ],
  Identifier: [],
  IfStatement: [
    "test",
    "consequent",
    "alternate"
  ],
  ImportDeclaration: [
    "specifiers",
    "source"
  ],
  ImportDefaultSpecifier: [
    "local"
  ],
  ImportExpression: [
    "source"
  ],
  ImportNamespaceSpecifier: [
    "local"
  ],
  ImportSpecifier: [
    "imported",
    "local"
  ],
  JSXAttribute: [
    "name",
    "value"
  ],
  JSXClosingElement: [
    "name"
  ],
  JSXClosingFragment: [],
  JSXElement: [
    "openingElement",
    "children",
    "closingElement"
  ],
  JSXEmptyExpression: [],
  JSXExpressionContainer: [
    "expression"
  ],
  JSXFragment: [
    "openingFragment",
    "children",
    "closingFragment"
  ],
  JSXIdentifier: [],
  JSXMemberExpression: [
    "object",
    "property"
  ],
  JSXNamespacedName: [
    "namespace",
    "name"
  ],
  JSXOpeningElement: [
    "name",
    "attributes"
  ],
  JSXOpeningFragment: [],
  JSXSpreadAttribute: [
    "argument"
  ],
  JSXSpreadChild: [
    "expression"
  ],
  JSXText: [],
  LabeledStatement: [
    "label",
    "body"
  ],
  Literal: [],
  LogicalExpression: [
    "left",
    "right"
  ],
  MemberExpression: [
    "object",
    "property"
  ],
  MetaProperty: [
    "meta",
    "property"
  ],
  MethodDefinition: [
    "key",
    "value"
  ],
  NewExpression: [
    "callee",
    "arguments"
  ],
  ObjectExpression: [
    "properties"
  ],
  ObjectPattern: [
    "properties"
  ],
  PrivateIdentifier: [],
  Program: [
    "body"
  ],
  Property: [
    "key",
    "value"
  ],
  PropertyDefinition: [
    "key",
    "value"
  ],
  RestElement: [
    "argument"
  ],
  ReturnStatement: [
    "argument"
  ],
  SequenceExpression: [
    "expressions"
  ],
  SpreadElement: [
    "argument"
  ],
  StaticBlock: [
    "body"
  ],
  Super: [],
  SwitchCase: [
    "test",
    "consequent"
  ],
  SwitchStatement: [
    "discriminant",
    "cases"
  ],
  TaggedTemplateExpression: [
    "tag",
    "quasi"
  ],
  TemplateElement: [],
  TemplateLiteral: [
    "quasis",
    "expressions"
  ],
  ThisExpression: [],
  ThrowStatement: [
    "argument"
  ],
  TryStatement: [
    "block",
    "handler",
    "finalizer"
  ],
  UnaryExpression: [
    "argument"
  ],
  UpdateExpression: [
    "argument"
  ],
  VariableDeclaration: [
    "declarations"
  ],
  VariableDeclarator: [
    "id",
    "init"
  ],
  WhileStatement: [
    "test",
    "body"
  ],
  WithStatement: [
    "object",
    "body"
  ],
  YieldExpression: [
    "argument"
  ]
};
var NODE_TYPES8 = Object.keys(KEYS8);
for (const type of NODE_TYPES8) {
  Object.freeze(KEYS8[type]);
}
Object.freeze(KEYS8);
var visitor_keys_default8 = KEYS8;
var KEY_BLACKLIST8 = /* @__PURE__ */ new Set([
  "parent",
  "leadingComments",
  "trailingComments"
]);
function filterKey8(key) {
  return !KEY_BLACKLIST8.has(key) && key[0] !== "_";
}
function getKeys8(node) {
  return Object.keys(node).filter(filterKey8);
}
function getInnermostScope8(initialScope, node) {
  const location = node.range[0];
  let scope = initialScope;
  let found = false;
  do {
    found = false;
    for (const childScope of scope.childScopes) {
      const range32 = childScope.block.range;
      if (range32[0] <= location && location < range32[1]) {
        scope = childScope;
        found = true;
        break;
      }
    }
  } while (found);
  return scope;
}
function findVariable8(initialScope, nameOrNode) {
  let name22 = "";
  let scope = initialScope;
  if (typeof nameOrNode === "string") {
    name22 = nameOrNode;
  } else {
    name22 = nameOrNode.name;
    scope = getInnermostScope8(scope, nameOrNode);
  }
  while (scope != null) {
    const variable = scope.set.get(name22);
    if (variable != null) {
      return variable;
    }
    scope = scope.upper;
  }
  return null;
}
function negate08(token) {
  return !this(token);
}
function negate8(f43) {
  return negate08.bind(f43);
}
function isPunctuatorTokenWithValue8(token, value) {
  return token.type === "Punctuator" && token.value === value;
}
function isArrowToken8(token) {
  return isPunctuatorTokenWithValue8(token, "=>");
}
function isCommaToken8(token) {
  return isPunctuatorTokenWithValue8(token, ",");
}
function isSemicolonToken8(token) {
  return isPunctuatorTokenWithValue8(token, ";");
}
function isColonToken8(token) {
  return isPunctuatorTokenWithValue8(token, ":");
}
function isOpeningParenToken8(token) {
  return isPunctuatorTokenWithValue8(token, "(");
}
function isClosingParenToken8(token) {
  return isPunctuatorTokenWithValue8(token, ")");
}
function isOpeningBracketToken8(token) {
  return isPunctuatorTokenWithValue8(token, "[");
}
function isClosingBracketToken8(token) {
  return isPunctuatorTokenWithValue8(token, "]");
}
function isOpeningBraceToken8(token) {
  return isPunctuatorTokenWithValue8(token, "{");
}
function isClosingBraceToken8(token) {
  return isPunctuatorTokenWithValue8(token, "}");
}
function isCommentToken8(token) {
  return ["Block", "Line", "Shebang"].includes(token.type);
}
negate8(isArrowToken8);
negate8(isCommaToken8);
negate8(isSemicolonToken8);
negate8(isColonToken8);
negate8(isOpeningParenToken8);
negate8(isClosingParenToken8);
negate8(isOpeningBracketToken8);
negate8(isClosingBracketToken8);
negate8(isOpeningBraceToken8);
negate8(isClosingBraceToken8);
negate8(isCommentToken8);
function getOpeningParenOfParams8(node, sourceCode) {
  return node.id ? sourceCode.getTokenAfter(node.id, isOpeningParenToken8) : sourceCode.getFirstToken(node, isOpeningParenToken8);
}
function getFunctionHeadLocation8(node, sourceCode) {
  const parent = node.parent;
  let start = null;
  let end = null;
  if (node.type === "ArrowFunctionExpression") {
    const arrowToken = sourceCode.getTokenBefore(node.body, isArrowToken8);
    start = arrowToken.loc.start;
    end = arrowToken.loc.end;
  } else if (parent.type === "Property" || parent.type === "MethodDefinition" || parent.type === "PropertyDefinition") {
    start = parent.loc.start;
    end = getOpeningParenOfParams8(node, sourceCode).loc.start;
  } else {
    start = node.loc.start;
    end = getOpeningParenOfParams8(node, sourceCode).loc.start;
  }
  return {
    start: { ...start },
    end: { ...end }
  };
}
var globalObject8 = typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {};
var builtinNames8 = Object.freeze(
  /* @__PURE__ */ new Set([
    "Array",
    "ArrayBuffer",
    "BigInt",
    "BigInt64Array",
    "BigUint64Array",
    "Boolean",
    "DataView",
    "Date",
    "decodeURI",
    "decodeURIComponent",
    "encodeURI",
    "encodeURIComponent",
    "escape",
    "Float32Array",
    "Float64Array",
    "Function",
    "Infinity",
    "Int16Array",
    "Int32Array",
    "Int8Array",
    "isFinite",
    "isNaN",
    "isPrototypeOf",
    "JSON",
    "Map",
    "Math",
    "NaN",
    "Number",
    "Object",
    "parseFloat",
    "parseInt",
    "Promise",
    "Proxy",
    "Reflect",
    "RegExp",
    "Set",
    "String",
    "Symbol",
    "Uint16Array",
    "Uint32Array",
    "Uint8Array",
    "Uint8ClampedArray",
    "undefined",
    "unescape",
    "WeakMap",
    "WeakSet"
  ])
);
var callAllowed8 = new Set(
  [
    Array.isArray,
    Array.of,
    Array.prototype.at,
    Array.prototype.concat,
    Array.prototype.entries,
    Array.prototype.every,
    Array.prototype.filter,
    Array.prototype.find,
    Array.prototype.findIndex,
    Array.prototype.flat,
    Array.prototype.includes,
    Array.prototype.indexOf,
    Array.prototype.join,
    Array.prototype.keys,
    Array.prototype.lastIndexOf,
    Array.prototype.slice,
    Array.prototype.some,
    Array.prototype.toString,
    Array.prototype.values,
    typeof BigInt === "function" ? BigInt : void 0,
    Boolean,
    Date,
    Date.parse,
    decodeURI,
    decodeURIComponent,
    encodeURI,
    encodeURIComponent,
    escape,
    isFinite,
    isNaN,
    isPrototypeOf,
    Map,
    Map.prototype.entries,
    Map.prototype.get,
    Map.prototype.has,
    Map.prototype.keys,
    Map.prototype.values,
    ...Object.getOwnPropertyNames(Math).filter((k43) => k43 !== "random").map((k43) => Math[k43]).filter((f43) => typeof f43 === "function"),
    Number,
    Number.isFinite,
    Number.isNaN,
    Number.parseFloat,
    Number.parseInt,
    Number.prototype.toExponential,
    Number.prototype.toFixed,
    Number.prototype.toPrecision,
    Number.prototype.toString,
    Object,
    Object.entries,
    Object.is,
    Object.isExtensible,
    Object.isFrozen,
    Object.isSealed,
    Object.keys,
    Object.values,
    parseFloat,
    parseInt,
    RegExp,
    Set,
    Set.prototype.entries,
    Set.prototype.has,
    Set.prototype.keys,
    Set.prototype.values,
    String,
    String.fromCharCode,
    String.fromCodePoint,
    String.raw,
    String.prototype.at,
    String.prototype.charAt,
    String.prototype.charCodeAt,
    String.prototype.codePointAt,
    String.prototype.concat,
    String.prototype.endsWith,
    String.prototype.includes,
    String.prototype.indexOf,
    String.prototype.lastIndexOf,
    String.prototype.normalize,
    String.prototype.padEnd,
    String.prototype.padStart,
    String.prototype.slice,
    String.prototype.startsWith,
    String.prototype.substr,
    String.prototype.substring,
    String.prototype.toLowerCase,
    String.prototype.toString,
    String.prototype.toUpperCase,
    String.prototype.trim,
    String.prototype.trimEnd,
    String.prototype.trimLeft,
    String.prototype.trimRight,
    String.prototype.trimStart,
    Symbol.for,
    Symbol.keyFor,
    unescape
  ].filter((f43) => typeof f43 === "function")
);
var callPassThrough8 = /* @__PURE__ */ new Set([
  Object.freeze,
  Object.preventExtensions,
  Object.seal
]);
var getterAllowed8 = [
  [Map, /* @__PURE__ */ new Set(["size"])],
  [
    RegExp,
    /* @__PURE__ */ new Set([
      "dotAll",
      "flags",
      "global",
      "hasIndices",
      "ignoreCase",
      "multiline",
      "source",
      "sticky",
      "unicode"
    ])
  ],
  [Set, /* @__PURE__ */ new Set(["size"])]
];
function getPropertyDescriptor8(object32, name22) {
  let x43 = object32;
  while ((typeof x43 === "object" || typeof x43 === "function") && x43 !== null) {
    const d43 = Object.getOwnPropertyDescriptor(x43, name22);
    if (d43) {
      return d43;
    }
    x43 = Object.getPrototypeOf(x43);
  }
  return null;
}
function isGetter8(object32, name22) {
  const d43 = getPropertyDescriptor8(object32, name22);
  return d43 != null && d43.get != null;
}
function getElementValues8(nodeList, initialScope) {
  const valueList = [];
  for (let i43 = 0; i43 < nodeList.length; ++i43) {
    const elementNode = nodeList[i43];
    if (elementNode == null) {
      valueList.length = i43 + 1;
    } else if (elementNode.type === "SpreadElement") {
      const argument = getStaticValueR8(elementNode.argument, initialScope);
      if (argument == null) {
        return null;
      }
      valueList.push(...argument.value);
    } else {
      const element = getStaticValueR8(elementNode, initialScope);
      if (element == null) {
        return null;
      }
      valueList.push(element.value);
    }
  }
  return valueList;
}
function isEffectivelyConst8(variable) {
  const refs = variable.references;
  const inits = refs.filter((r43) => r43.init).length;
  const reads = refs.filter((r43) => r43.isReadOnly()).length;
  if (inits === 1 && reads + inits === refs.length) {
    return true;
  }
  return false;
}
var operations8 = Object.freeze({
  ArrayExpression(node, initialScope) {
    const elements = getElementValues8(node.elements, initialScope);
    return elements != null ? { value: elements } : null;
  },
  AssignmentExpression(node, initialScope) {
    if (node.operator === "=") {
      return getStaticValueR8(node.right, initialScope);
    }
    return null;
  },
  //eslint-disable-next-line complexity
  BinaryExpression(node, initialScope) {
    if (node.operator === "in" || node.operator === "instanceof") {
      return null;
    }
    const left94 = getStaticValueR8(node.left, initialScope);
    const right94 = getStaticValueR8(node.right, initialScope);
    if (left94 != null && right94 != null) {
      switch (node.operator) {
        case "==":
          return { value: left94.value == right94.value };
        case "!=":
          return { value: left94.value != right94.value };
        case "===":
          return { value: left94.value === right94.value };
        case "!==":
          return { value: left94.value !== right94.value };
        case "<":
          return { value: left94.value < right94.value };
        case "<=":
          return { value: left94.value <= right94.value };
        case ">":
          return { value: left94.value > right94.value };
        case ">=":
          return { value: left94.value >= right94.value };
        case "<<":
          return { value: left94.value << right94.value };
        case ">>":
          return { value: left94.value >> right94.value };
        case ">>>":
          return { value: left94.value >>> right94.value };
        case "+":
          return { value: left94.value + right94.value };
        case "-":
          return { value: left94.value - right94.value };
        case "*":
          return { value: left94.value * right94.value };
        case "/":
          return { value: left94.value / right94.value };
        case "%":
          return { value: left94.value % right94.value };
        case "**":
          return { value: left94.value ** right94.value };
        case "|":
          return { value: left94.value | right94.value };
        case "^":
          return { value: left94.value ^ right94.value };
        case "&":
          return { value: left94.value & right94.value };
      }
    }
    return null;
  },
  CallExpression(node, initialScope) {
    const calleeNode = node.callee;
    const args = getElementValues8(node.arguments, initialScope);
    if (args != null) {
      if (calleeNode.type === "MemberExpression") {
        if (calleeNode.property.type === "PrivateIdentifier") {
          return null;
        }
        const object32 = getStaticValueR8(calleeNode.object, initialScope);
        if (object32 != null) {
          if (object32.value == null && (object32.optional || node.optional)) {
            return { value: void 0, optional: true };
          }
          const property = getStaticPropertyNameValue8(
            calleeNode,
            initialScope
          );
          if (property != null) {
            const receiver = object32.value;
            const methodName = property.value;
            if (callAllowed8.has(receiver[methodName])) {
              return { value: receiver[methodName](...args) };
            }
            if (callPassThrough8.has(receiver[methodName])) {
              return { value: args[0] };
            }
          }
        }
      } else {
        const callee = getStaticValueR8(calleeNode, initialScope);
        if (callee != null) {
          if (callee.value == null && node.optional) {
            return { value: void 0, optional: true };
          }
          const func = callee.value;
          if (callAllowed8.has(func)) {
            return { value: func(...args) };
          }
          if (callPassThrough8.has(func)) {
            return { value: args[0] };
          }
        }
      }
    }
    return null;
  },
  ConditionalExpression(node, initialScope) {
    const test = getStaticValueR8(node.test, initialScope);
    if (test != null) {
      return test.value ? getStaticValueR8(node.consequent, initialScope) : getStaticValueR8(node.alternate, initialScope);
    }
    return null;
  },
  ExpressionStatement(node, initialScope) {
    return getStaticValueR8(node.expression, initialScope);
  },
  Identifier(node, initialScope) {
    if (initialScope != null) {
      const variable = findVariable8(initialScope, node);
      if (variable != null && variable.defs.length === 0 && builtinNames8.has(variable.name) && variable.name in globalObject8) {
        return { value: globalObject8[variable.name] };
      }
      if (variable != null && variable.defs.length === 1) {
        const def = variable.defs[0];
        if (def.parent && def.type === "Variable" && (def.parent.kind === "const" || isEffectivelyConst8(variable)) && // TODO(mysticatea): don't support destructuring here.
        def.node.id.type === "Identifier") {
          return getStaticValueR8(def.node.init, initialScope);
        }
      }
    }
    return null;
  },
  Literal(node) {
    if ((node.regex != null || node.bigint != null) && node.value == null) {
      return null;
    }
    return { value: node.value };
  },
  LogicalExpression(node, initialScope) {
    const left94 = getStaticValueR8(node.left, initialScope);
    if (left94 != null) {
      if (node.operator === "||" && Boolean(left94.value) === true || node.operator === "&&" && Boolean(left94.value) === false || node.operator === "??" && left94.value != null) {
        return left94;
      }
      const right94 = getStaticValueR8(node.right, initialScope);
      if (right94 != null) {
        return right94;
      }
    }
    return null;
  },
  MemberExpression(node, initialScope) {
    if (node.property.type === "PrivateIdentifier") {
      return null;
    }
    const object32 = getStaticValueR8(node.object, initialScope);
    if (object32 != null) {
      if (object32.value == null && (object32.optional || node.optional)) {
        return { value: void 0, optional: true };
      }
      const property = getStaticPropertyNameValue8(node, initialScope);
      if (property != null) {
        if (!isGetter8(object32.value, property.value)) {
          return { value: object32.value[property.value] };
        }
        for (const [classFn, allowed] of getterAllowed8) {
          if (object32.value instanceof classFn && allowed.has(property.value)) {
            return { value: object32.value[property.value] };
          }
        }
      }
    }
    return null;
  },
  ChainExpression(node, initialScope) {
    const expression = getStaticValueR8(node.expression, initialScope);
    if (expression != null) {
      return { value: expression.value };
    }
    return null;
  },
  NewExpression(node, initialScope) {
    const callee = getStaticValueR8(node.callee, initialScope);
    const args = getElementValues8(node.arguments, initialScope);
    if (callee != null && args != null) {
      const Func = callee.value;
      if (callAllowed8.has(Func)) {
        return { value: new Func(...args) };
      }
    }
    return null;
  },
  ObjectExpression(node, initialScope) {
    const object32 = {};
    for (const propertyNode of node.properties) {
      if (propertyNode.type === "Property") {
        if (propertyNode.kind !== "init") {
          return null;
        }
        const key = getStaticPropertyNameValue8(
          propertyNode,
          initialScope
        );
        const value = getStaticValueR8(propertyNode.value, initialScope);
        if (key == null || value == null) {
          return null;
        }
        object32[key.value] = value.value;
      } else if (propertyNode.type === "SpreadElement" || propertyNode.type === "ExperimentalSpreadProperty") {
        const argument = getStaticValueR8(
          propertyNode.argument,
          initialScope
        );
        if (argument == null) {
          return null;
        }
        Object.assign(object32, argument.value);
      } else {
        return null;
      }
    }
    return { value: object32 };
  },
  SequenceExpression(node, initialScope) {
    const last32 = node.expressions[node.expressions.length - 1];
    return getStaticValueR8(last32, initialScope);
  },
  TaggedTemplateExpression(node, initialScope) {
    const tag = getStaticValueR8(node.tag, initialScope);
    const expressions = getElementValues8(
      node.quasi.expressions,
      initialScope
    );
    if (tag != null && expressions != null) {
      const func = tag.value;
      const strings = node.quasi.quasis.map((q) => q.value.cooked);
      strings.raw = node.quasi.quasis.map((q) => q.value.raw);
      if (func === String.raw) {
        return { value: func(strings, ...expressions) };
      }
    }
    return null;
  },
  TemplateLiteral(node, initialScope) {
    const expressions = getElementValues8(node.expressions, initialScope);
    if (expressions != null) {
      let value = node.quasis[0].value.cooked;
      for (let i43 = 0; i43 < expressions.length; ++i43) {
        value += expressions[i43];
        value += node.quasis[i43 + 1].value.cooked;
      }
      return { value };
    }
    return null;
  },
  UnaryExpression(node, initialScope) {
    if (node.operator === "delete") {
      return null;
    }
    if (node.operator === "void") {
      return { value: void 0 };
    }
    const arg = getStaticValueR8(node.argument, initialScope);
    if (arg != null) {
      switch (node.operator) {
        case "-":
          return { value: -arg.value };
        case "+":
          return { value: +arg.value };
        case "!":
          return { value: !arg.value };
        case "~":
          return { value: ~arg.value };
        case "typeof":
          return { value: typeof arg.value };
      }
    }
    return null;
  }
});
function getStaticValueR8(node, initialScope) {
  if (node != null && Object.hasOwnProperty.call(operations8, node.type)) {
    return operations8[node.type](node, initialScope);
  }
  return null;
}
function getStaticPropertyNameValue8(node, initialScope) {
  const nameNode = node.type === "Property" ? node.key : node.property;
  if (node.computed) {
    return getStaticValueR8(nameNode, initialScope);
  }
  if (nameNode.type === "Identifier") {
    return { value: nameNode.name };
  }
  if (nameNode.type === "Literal") {
    if (nameNode.bigint) {
      return { value: nameNode.bigint };
    }
    return { value: String(nameNode.value) };
  }
  return null;
}
function getStaticValue8(node, initialScope = null) {
  try {
    return getStaticValueR8(node, initialScope);
  } catch (_error) {
    return null;
  }
}
function getStringIfConstant8(node, initialScope = null) {
  if (node && node.type === "Literal" && node.value === null) {
    if (node.regex) {
      return `/${node.regex.pattern}/${node.regex.flags}`;
    }
    if (node.bigint) {
      return node.bigint;
    }
  }
  const evaluated = getStaticValue8(node, initialScope);
  return evaluated && String(evaluated.value);
}
function getPropertyName8(node, initialScope) {
  switch (node.type) {
    case "MemberExpression":
      if (node.computed) {
        return getStringIfConstant8(node.property, initialScope);
      }
      if (node.property.type === "PrivateIdentifier") {
        return null;
      }
      return node.property.name;
    case "Property":
    case "MethodDefinition":
    case "PropertyDefinition":
      if (node.computed) {
        return getStringIfConstant8(node.key, initialScope);
      }
      if (node.key.type === "Literal") {
        return String(node.key.value);
      }
      if (node.key.type === "PrivateIdentifier") {
        return null;
      }
      return node.key.name;
  }
  return null;
}
function getFunctionNameWithKind8(node, sourceCode) {
  const parent = node.parent;
  const tokens = [];
  const isObjectMethod = parent.type === "Property" && parent.value === node;
  const isClassMethod = parent.type === "MethodDefinition" && parent.value === node;
  const isClassFieldMethod = parent.type === "PropertyDefinition" && parent.value === node;
  if (isClassMethod || isClassFieldMethod) {
    if (parent.static) {
      tokens.push("static");
    }
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push("private");
    }
  }
  if (node.async) {
    tokens.push("async");
  }
  if (node.generator) {
    tokens.push("generator");
  }
  if (isObjectMethod || isClassMethod) {
    if (parent.kind === "constructor") {
      return "constructor";
    }
    if (parent.kind === "get") {
      tokens.push("getter");
    } else if (parent.kind === "set") {
      tokens.push("setter");
    } else {
      tokens.push("method");
    }
  } else if (isClassFieldMethod) {
    tokens.push("method");
  } else {
    if (node.type === "ArrowFunctionExpression") {
      tokens.push("arrow");
    }
    tokens.push("function");
  }
  if (isObjectMethod || isClassMethod || isClassFieldMethod) {
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push(`#${parent.key.name}`);
    } else {
      const name22 = getPropertyName8(parent);
      if (name22) {
        tokens.push(`'${name22}'`);
      } else if (sourceCode) {
        const keyText = sourceCode.getText(parent.key);
        if (!keyText.includes("\n")) {
          tokens.push(`[${keyText}]`);
        }
      }
    }
  } else if (node.id) {
    tokens.push(`'${node.id.name}'`);
  } else if (parent.type === "VariableDeclarator" && parent.id && parent.id.type === "Identifier") {
    tokens.push(`'${parent.id.name}'`);
  } else if ((parent.type === "AssignmentExpression" || parent.type === "AssignmentPattern") && parent.left && parent.left.type === "Identifier") {
    tokens.push(`'${parent.left.name}'`);
  } else if (parent.type === "ExportDefaultDeclaration" && parent.declaration === node) {
    tokens.push("'default'");
  }
  return tokens.join(" ");
}
var typeConversionBinaryOps8 = Object.freeze(
  /* @__PURE__ */ new Set([
    "==",
    "!=",
    "<",
    "<=",
    ">",
    ">=",
    "<<",
    ">>",
    ">>>",
    "+",
    "-",
    "*",
    "/",
    "%",
    "|",
    "^",
    "&",
    "in"
  ])
);
var typeConversionUnaryOps8 = Object.freeze(/* @__PURE__ */ new Set(["-", "+", "!", "~"]));
function isNode8(x43) {
  return x43 !== null && typeof x43 === "object" && typeof x43.type === "string";
}
var visitor8 = Object.freeze(
  Object.assign(/* @__PURE__ */ Object.create(null), {
    $visit(node, options, visitorKeys) {
      const { type } = node;
      if (typeof this[type] === "function") {
        return this[type](node, options, visitorKeys);
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    $visitChildren(node, options, visitorKeys) {
      const { type } = node;
      for (const key of visitorKeys[type] || getKeys8(node)) {
        const value = node[key];
        if (Array.isArray(value)) {
          for (const element of value) {
            if (isNode8(element) && this.$visit(element, options, visitorKeys)) {
              return true;
            }
          }
        } else if (isNode8(value) && this.$visit(value, options, visitorKeys)) {
          return true;
        }
      }
      return false;
    },
    ArrowFunctionExpression() {
      return false;
    },
    AssignmentExpression() {
      return true;
    },
    AwaitExpression() {
      return true;
    },
    BinaryExpression(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && typeConversionBinaryOps8.has(node.operator) && (node.left.type !== "Literal" || node.right.type !== "Literal")) {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    CallExpression() {
      return true;
    },
    FunctionExpression() {
      return false;
    },
    ImportExpression() {
      return true;
    },
    MemberExpression(node, options, visitorKeys) {
      if (options.considerGetters) {
        return true;
      }
      if (options.considerImplicitTypeConversion && node.computed && node.property.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    MethodDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    NewExpression() {
      return true;
    },
    Property(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    PropertyDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UnaryExpression(node, options, visitorKeys) {
      if (node.operator === "delete") {
        return true;
      }
      if (options.considerImplicitTypeConversion && typeConversionUnaryOps8.has(node.operator) && node.argument.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UpdateExpression() {
      return true;
    },
    YieldExpression() {
      return true;
    }
  })
);
function hasSideEffect8(node, sourceCode, { considerGetters = false, considerImplicitTypeConversion = false } = {}) {
  return visitor8.$visit(
    node,
    { considerGetters, considerImplicitTypeConversion },
    sourceCode.visitorKeys || visitor_keys_default8
  );
}
function getParentSyntaxParen8(node, sourceCode) {
  const parent = node.parent;
  switch (parent.type) {
    case "CallExpression":
    case "NewExpression":
      if (parent.arguments.length === 1 && parent.arguments[0] === node) {
        return sourceCode.getTokenAfter(
          parent.callee,
          isOpeningParenToken8
        );
      }
      return null;
    case "DoWhileStatement":
      if (parent.test === node) {
        return sourceCode.getTokenAfter(
          parent.body,
          isOpeningParenToken8
        );
      }
      return null;
    case "IfStatement":
    case "WhileStatement":
      if (parent.test === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "ImportExpression":
      if (parent.source === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "SwitchStatement":
      if (parent.discriminant === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "WithStatement":
      if (parent.object === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    default:
      return null;
  }
}
function isParenthesized8(timesOrNode, nodeOrSourceCode, optionalSourceCode) {
  let times, node, sourceCode, maybeLeftParen, maybeRightParen;
  if (typeof timesOrNode === "number") {
    times = timesOrNode | 0;
    node = nodeOrSourceCode;
    sourceCode = optionalSourceCode;
    if (!(times >= 1)) {
      throw new TypeError("'times' should be a positive integer.");
    }
  } else {
    times = 1;
    node = timesOrNode;
    sourceCode = nodeOrSourceCode;
  }
  if (node == null || // `Program` can't be parenthesized
  node.parent == null || // `CatchClause.param` can't be parenthesized, example `try {} catch (error) {}`
  node.parent.type === "CatchClause" && node.parent.param === node) {
    return false;
  }
  maybeLeftParen = maybeRightParen = node;
  do {
    maybeLeftParen = sourceCode.getTokenBefore(maybeLeftParen);
    maybeRightParen = sourceCode.getTokenAfter(maybeRightParen);
  } while (maybeLeftParen != null && maybeRightParen != null && isOpeningParenToken8(maybeLeftParen) && isClosingParenToken8(maybeRightParen) && // Avoid false positive such as `if (a) {}`
  maybeLeftParen !== getParentSyntaxParen8(node, sourceCode) && --times > 0);
  return times === 0;
}
Function.call.bind(Object.hasOwnProperty);
var __defProp27 = Object.defineProperty;
var __export27 = (target, all342) => {
  for (var name22 in all342)
    __defProp27(target, name22, { get: all342[name22], enumerable: true });
};
var NodeType8 = types.AST_NODE_TYPES;
var is8 = utils.ASTUtils.isNodeOfType;
var isOneOf8 = utils.ASTUtils.isNodeOfTypes;
isOneOf8([
  NodeType8.ArrowFunctionExpression,
  NodeType8.FunctionDeclaration,
  NodeType8.FunctionExpression
]);
isOneOf8([
  NodeType8.ArrowFunctionExpression,
  NodeType8.FunctionDeclaration,
  NodeType8.FunctionExpression,
  NodeType8.TSCallSignatureDeclaration,
  NodeType8.TSConstructSignatureDeclaration,
  NodeType8.TSDeclareFunction,
  NodeType8.TSEmptyBodyFunctionExpression,
  NodeType8.TSFunctionType,
  NodeType8.TSMethodSignature
]);
isOneOf8([NodeType8.ClassDeclaration, NodeType8.ClassExpression]);
isOneOf8([
  NodeType8.DoWhileStatement,
  NodeType8.ForInStatement,
  NodeType8.ForOfStatement,
  NodeType8.ForStatement,
  NodeType8.WhileStatement
]);
isOneOf8([NodeType8.TSArrayType, NodeType8.TSTupleType]);
isOneOf8([
  NodeType8.PropertyDefinition,
  NodeType8.TSIndexSignature,
  NodeType8.TSParameterProperty,
  NodeType8.TSPropertySignature
]);
is8(NodeType8.JSXElement);
is8(NodeType8.JSXFragment);
isOneOf8([
  NodeType8.JSXAttribute,
  NodeType8.JSXSpreadChild,
  NodeType8.JSXClosingElement,
  NodeType8.JSXClosingFragment,
  NodeType8.JSXElement,
  NodeType8.JSXEmptyExpression,
  NodeType8.JSXExpressionContainer,
  NodeType8.JSXFragment,
  NodeType8.JSXIdentifier,
  NodeType8.JSXMemberExpression,
  NodeType8.JSXNamespacedName,
  NodeType8.JSXOpeningElement,
  NodeType8.JSXOpeningFragment,
  NodeType8.JSXSpreadAttribute,
  NodeType8.JSXSpreadChild,
  NodeType8.JSXText
]);
isOneOf8([
  NodeType8.JSXIdentifier,
  NodeType8.JSXMemberExpression,
  NodeType8.JSXNamespacedName
]);
isOneOf8([
  NodeType8.ArrayPattern,
  NodeType8.AssignmentPattern,
  NodeType8.ObjectPattern,
  NodeType8.RestElement
]);
isOneOf8([
  NodeType8.TSInterfaceDeclaration,
  NodeType8.TSTypeAliasDeclaration
]);
isOneOf8([
  NodeType8.ArrayExpression,
  NodeType8.ArrayPattern,
  NodeType8.ArrowFunctionExpression,
  NodeType8.CallExpression,
  NodeType8.ClassExpression,
  NodeType8.FunctionExpression,
  NodeType8.Identifier,
  NodeType8.JSXElement,
  NodeType8.JSXFragment,
  NodeType8.Literal,
  NodeType8.TemplateLiteral,
  NodeType8.MemberExpression,
  NodeType8.MetaProperty,
  NodeType8.ObjectExpression,
  NodeType8.ObjectPattern,
  NodeType8.SequenceExpression,
  NodeType8.Super,
  NodeType8.TaggedTemplateExpression,
  NodeType8.ThisExpression
]);
isOneOf8([
  NodeType8.ArrayExpression,
  NodeType8.ArrayPattern,
  NodeType8.ArrowFunctionExpression,
  NodeType8.CallExpression,
  NodeType8.ClassExpression,
  NodeType8.FunctionExpression,
  NodeType8.Identifier,
  NodeType8.JSXElement,
  NodeType8.JSXFragment,
  NodeType8.Literal,
  NodeType8.TemplateLiteral,
  NodeType8.MemberExpression,
  NodeType8.MetaProperty,
  NodeType8.ObjectExpression,
  NodeType8.ObjectPattern,
  NodeType8.SequenceExpression,
  NodeType8.Super,
  NodeType8.TaggedTemplateExpression,
  NodeType8.ThisExpression,
  NodeType8.TSAsExpression,
  NodeType8.TSNonNullExpression,
  NodeType8.TSTypeAssertion
]);
var Function_exports10 = {};
__export27(Function_exports10, {
  SK: () => SK10,
  absurd: () => absurd10,
  apply: () => apply10,
  compose: () => compose14,
  constFalse: () => constFalse10,
  constNull: () => constNull10,
  constTrue: () => constTrue10,
  constUndefined: () => constUndefined10,
  constVoid: () => constVoid10,
  constant: () => constant10,
  dual: () => dual10,
  flip: () => flip10,
  flow: () => flow10,
  hole: () => hole10,
  identity: () => identity10,
  isFunction: () => isFunction28,
  pipe: () => pipe10,
  satisfies: () => satisfies10,
  tupled: () => tupled10,
  unsafeCoerce: () => unsafeCoerce10,
  untupled: () => untupled10
});
var isFunction28 = (input) => typeof input === "function";
var dual10 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a43, b43) {
        if (arguments.length >= 2) {
          return body(a43, b43);
        }
        return function(self2) {
          return body(self2, a43);
        };
      };
    case 3:
      return function(a43, b43, c43) {
        if (arguments.length >= 3) {
          return body(a43, b43, c43);
        }
        return function(self2) {
          return body(self2, a43, b43);
        };
      };
    case 4:
      return function(a43, b43, c43, d43) {
        if (arguments.length >= 4) {
          return body(a43, b43, c43, d43);
        }
        return function(self2) {
          return body(self2, a43, b43, c43);
        };
      };
    case 5:
      return function(a43, b43, c43, d43, e43) {
        if (arguments.length >= 5) {
          return body(a43, b43, c43, d43, e43);
        }
        return function(self2) {
          return body(self2, a43, b43, c43, d43);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply10 = (a43) => (self2) => self2(a43);
var identity10 = (a43) => a43;
var satisfies10 = () => (b43) => b43;
var unsafeCoerce10 = identity10;
var constant10 = (value) => () => value;
var constTrue10 = /* @__PURE__ */ constant10(true);
var constFalse10 = /* @__PURE__ */ constant10(false);
var constNull10 = /* @__PURE__ */ constant10(null);
var constUndefined10 = /* @__PURE__ */ constant10(void 0);
var constVoid10 = constUndefined10;
var flip10 = (f43) => (...b43) => (...a43) => f43(...a43)(...b43);
var compose14 = /* @__PURE__ */ dual10(2, (ab, bc) => (a43) => bc(ab(a43)));
var absurd10 = (_43) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled10 = (f43) => (a43) => f43(...a43);
var untupled10 = (f43) => (...a43) => f43(a43);
function pipe10(a43, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a43;
    case 2:
      return ab(a43);
    case 3:
      return bc(ab(a43));
    case 4:
      return cd(bc(ab(a43)));
    case 5:
      return de(cd(bc(ab(a43))));
    case 6:
      return ef(de(cd(bc(ab(a43)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a43))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a43)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a43))))))));
    default: {
      let ret = arguments[0];
      for (let i43 = 1; i43 < arguments.length; i43++) {
        ret = arguments[i43](ret);
      }
      return ret;
    }
  }
}
function flow10(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole10 = /* @__PURE__ */ unsafeCoerce10(absurd10);
var SK10 = (_43, b43) => b43;
var make30 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_15 = (map622) => dual10(3, (self2, name22, f43) => map622(self2, (a43) => Object.assign({}, a43, {
  [name22]: f43(a43)
})));
var bindTo15 = (map622) => dual10(2, (self2, name22) => map622(self2, (a43) => ({
  [name22]: a43
})));
var bind15 = (map622, flatMap432) => dual10(3, (self2, name22, f43) => flatMap432(self2, (a43) => map622(f43(a43), (b43) => Object.assign({}, a43, {
  [name22]: b43
}))));
var moduleVersion10 = "3.2.8";
var getCurrentVersion10 = () => moduleVersion10;
var globalStoreId10 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion10()}`);
if (!(globalStoreId10 in globalThis)) {
  globalThis[globalStoreId10] = /* @__PURE__ */ new Map();
}
var globalStore10 = globalThis[globalStoreId10];
var globalValue10 = (id, compute) => {
  if (!globalStore10.has(id)) {
    globalStore10.set(id, compute());
  }
  return globalStore10.get(id);
};
var Predicate_exports8 = {};
__export27(Predicate_exports8, {
  all: () => all14,
  and: () => and10,
  compose: () => compose28,
  eqv: () => eqv10,
  every: () => every12,
  hasProperty: () => hasProperty10,
  implies: () => implies10,
  isBigInt: () => isBigInt10,
  isBoolean: () => isBoolean10,
  isDate: () => isDate10,
  isError: () => isError10,
  isFunction: () => isFunction37,
  isIterable: () => isIterable10,
  isMap: () => isMap10,
  isNever: () => isNever10,
  isNotNull: () => isNotNull10,
  isNotNullable: () => isNotNullable10,
  isNotUndefined: () => isNotUndefined10,
  isNull: () => isNull10,
  isNullable: () => isNullable10,
  isNumber: () => isNumber10,
  isObject: () => isObject10,
  isPromise: () => isPromise10,
  isPromiseLike: () => isPromiseLike10,
  isReadonlyRecord: () => isReadonlyRecord10,
  isRecord: () => isRecord10,
  isSet: () => isSet10,
  isString: () => isString10,
  isSymbol: () => isSymbol10,
  isTagged: () => isTagged10,
  isTruthy: () => isTruthy10,
  isUint8Array: () => isUint8Array10,
  isUndefined: () => isUndefined10,
  isUnknown: () => isUnknown10,
  mapInput: () => mapInput11,
  nand: () => nand10,
  nor: () => nor10,
  not: () => not10,
  or: () => or10,
  product: () => product14,
  productMany: () => productMany14,
  some: () => some20,
  struct: () => struct12,
  tuple: () => tuple11,
  xor: () => xor10
});
var mapInput11 = /* @__PURE__ */ dual10(2, (self2, f43) => (b43) => self2(f43(b43)));
var isTruthy10 = (input) => !!input;
var isSet10 = (input) => input instanceof Set;
var isMap10 = (input) => input instanceof Map;
var isString10 = (input) => typeof input === "string";
var isNumber10 = (input) => typeof input === "number";
var isBoolean10 = (input) => typeof input === "boolean";
var isBigInt10 = (input) => typeof input === "bigint";
var isSymbol10 = (input) => typeof input === "symbol";
var isFunction37 = isFunction28;
var isUndefined10 = (input) => input === void 0;
var isNotUndefined10 = (input) => input !== void 0;
var isNull10 = (input) => input === null;
var isNotNull10 = (input) => input !== null;
var isNever10 = (_43) => false;
var isUnknown10 = (_43) => true;
var isRecordOrArray10 = (input) => typeof input === "object" && input !== null;
var isObject10 = (input) => isRecordOrArray10(input) || isFunction37(input);
var hasProperty10 = /* @__PURE__ */ dual10(2, (self2, property) => isObject10(self2) && property in self2);
var isTagged10 = /* @__PURE__ */ dual10(2, (self2, tag) => hasProperty10(self2, "_tag") && self2["_tag"] === tag);
var isNullable10 = (input) => input === null || input === void 0;
var isNotNullable10 = (input) => input !== null && input !== void 0;
var isError10 = (input) => input instanceof Error;
var isUint8Array10 = (input) => input instanceof Uint8Array;
var isDate10 = (input) => input instanceof Date;
var isIterable10 = (input) => hasProperty10(input, Symbol.iterator);
var isRecord10 = (input) => isRecordOrArray10(input) && !Array.isArray(input);
var isReadonlyRecord10 = isRecord10;
var isPromise10 = (input) => hasProperty10(input, "then") && "catch" in input && isFunction37(input.then) && isFunction37(input.catch);
var isPromiseLike10 = (input) => hasProperty10(input, "then") && isFunction37(input.then);
var compose28 = /* @__PURE__ */ dual10(2, (ab, bc) => (a43) => ab(a43) && bc(a43));
var product14 = (self2, that) => ([a43, b43]) => self2(a43) && that(b43);
var all14 = (collection) => {
  return (as253) => {
    let collectionIndex = 0;
    for (const p43 of collection) {
      if (collectionIndex >= as253.length) {
        break;
      }
      if (p43(as253[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany14 = (self2, collection) => {
  const rest = all14(collection);
  return ([head222, ...tail42]) => self2(head222) === false ? false : rest(tail42);
};
var tuple11 = (...elements) => all14(elements);
var struct12 = (fields) => {
  const keys242 = Object.keys(fields);
  return (a43) => {
    for (const key of keys242) {
      if (!fields[key](a43[key])) {
        return false;
      }
    }
    return true;
  };
};
var not10 = (self2) => (a43) => !self2(a43);
var or10 = /* @__PURE__ */ dual10(2, (self2, that) => (a43) => self2(a43) || that(a43));
var and10 = /* @__PURE__ */ dual10(2, (self2, that) => (a43) => self2(a43) && that(a43));
var xor10 = /* @__PURE__ */ dual10(2, (self2, that) => (a43) => self2(a43) !== that(a43));
var eqv10 = /* @__PURE__ */ dual10(2, (self2, that) => (a43) => self2(a43) === that(a43));
var implies10 = /* @__PURE__ */ dual10(2, (self2, that) => (a43) => self2(a43) ? that(a43) : true);
var nor10 = /* @__PURE__ */ dual10(2, (self2, that) => (a43) => !(self2(a43) || that(a43)));
var nand10 = /* @__PURE__ */ dual10(2, (self2, that) => (a43) => !(self2(a43) && that(a43)));
var every12 = (collection) => (a43) => {
  for (const p43 of collection) {
    if (!p43(a43)) {
      return false;
    }
  }
  return true;
};
var some20 = (collection) => (a43) => {
  for (const p43 of collection) {
    if (p43(a43)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage10 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId10 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind10 = (u43) => isObject10(u43) && GenKindTypeId10 in u43;
var GenKindImpl10 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity10;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_43) => _43;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_43) => _43;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_43) => _43;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId10] = GenKindTypeId10;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen11(this);
  }
};
var SingleShotGen11 = class _SingleShotGen13 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a43) {
    return this.called ? {
      value: a43,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a43) {
    return {
      value: a43,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e43) {
    throw e43;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen13(this.self);
  }
};
var adapter14 = () => function() {
  let x43 = arguments[0];
  for (let i43 = 1; i43 < arguments.length; i43++) {
    x43 = arguments[i43](x43);
  }
  return new GenKindImpl10(x43);
};
var defaultIncHi10 = 335903614;
var defaultIncLo10 = 4150755663;
var MUL_HI10 = 1481765933 >>> 0;
var MUL_LO10 = 1284865837 >>> 0;
var BIT_5310 = 9007199254740992;
var BIT_2710 = 134217728;
var PCGRandom10 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable10(seedLo) && isNullable10(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable10(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable10(incLo) && isNullable10(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo10;
      incHi = this._state ? this._state[2] : defaultIncHi10;
    } else if (isNullable10(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add6410(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max42) {
    if (!max42) {
      return this._next();
    }
    max42 = max42 >>> 0;
    if ((max42 & max42 - 1) === 0) {
      return this._next() & max42 - 1;
    }
    let num = 0;
    const skew = (-max42 >>> 0) % max42 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max42;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_2710 + lo) / BIT_5310;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul6410(this._state, oldHi, oldLo, MUL_HI10, MUL_LO10);
    add6410(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul6410(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add6410(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId10 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap10 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId10]() {
    return this.#value;
  }
};
function yieldWrapGet10(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId10 in self2) {
    return self2[YieldWrapTypeId10]();
  }
  throw new Error(getBugErrorMessage10("yieldWrapGet"));
}
var structuralRegionState10 = /* @__PURE__ */ globalValue10("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache10 = /* @__PURE__ */ globalValue10(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr10 = /* @__PURE__ */ globalValue10(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom10());
var symbol14 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash10 = (self2) => {
  if (structuralRegionState10.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number11(self2);
    case "bigint":
      return string12(self2.toString(10));
    case "boolean":
      return string12(String(self2));
    case "symbol":
      return string12(String(self2));
    case "string":
      return string12(self2);
    case "undefined":
      return string12("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string12("null");
      } else if (self2 instanceof Date) {
        return hash10(self2.toISOString());
      } else if (isHash10(self2)) {
        return self2[symbol14]();
      } else {
        return random10(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random10 = (self2) => {
  if (!randomHashCache10.has(self2)) {
    randomHashCache10.set(self2, number11(pcgr10.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache10.get(self2);
};
var combine11 = (b43) => (self2) => self2 * 53 ^ b43;
var optimize10 = (n43) => n43 & 3221225471 | n43 >>> 1 & 1073741824;
var isHash10 = (u43) => hasProperty10(u43, symbol14);
var number11 = (n43) => {
  if (n43 !== n43 || n43 === Infinity) {
    return 0;
  }
  let h43 = n43 | 0;
  if (h43 !== n43) {
    h43 ^= n43 * 4294967295;
  }
  while (n43 > 4294967295) {
    h43 ^= n43 /= 4294967295;
  }
  return optimize10(n43);
};
var string12 = (str) => {
  let h43 = 5381, i43 = str.length;
  while (i43) {
    h43 = h43 * 33 ^ str.charCodeAt(--i43);
  }
  return optimize10(h43);
};
var structureKeys6 = (o43, keys242) => {
  let h43 = 12289;
  for (let i43 = 0; i43 < keys242.length; i43++) {
    h43 ^= pipe10(string12(keys242[i43]), combine11(hash10(o43[keys242[i43]])));
  }
  return optimize10(h43);
};
var structure6 = (o43) => structureKeys6(o43, Object.keys(o43));
var array12 = (arr) => {
  let h43 = 6151;
  for (let i43 = 0; i43 < arr.length; i43++) {
    h43 = pipe10(h43, combine11(hash10(arr[i43])));
  }
  return optimize10(h43);
};
var cached10 = function() {
  if (arguments.length === 1) {
    const self22 = arguments[0];
    return function(hash332) {
      Object.defineProperty(self22, symbol14, {
        value() {
          return hash332;
        },
        enumerable: false
      });
      return hash332;
    };
  }
  const self2 = arguments[0];
  const hash253 = arguments[1];
  Object.defineProperty(self2, symbol14, {
    value() {
      return hash253;
    },
    enumerable: false
  });
  return hash253;
};
var symbol28 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals10() {
  if (arguments.length === 1) {
    return (self2) => compareBoth10(self2, arguments[0]);
  }
  return compareBoth10(arguments[0], arguments[1]);
}
function compareBoth10(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual10(self2) && isEqual10(that)) {
        if (hash10(self2) === hash10(that) && self2[symbol28](that)) {
          return true;
        } else {
          return structuralRegionState10.enabled && structuralRegionState10.tester ? structuralRegionState10.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState10.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v43, i43) => compareBoth10(v43, that[i43]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth10(self2[key], that[key]))) {
              return structuralRegionState10.tester ? structuralRegionState10.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState10.tester ? structuralRegionState10.tester(self2, that) : false;
    }
  }
  return structuralRegionState10.enabled && structuralRegionState10.tester ? structuralRegionState10.tester(self2, that) : false;
}
var isEqual10 = (u43) => hasProperty10(u43, symbol28);
var equivalence10 = () => equals10;
var NodeInspectSymbol10 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON10 = (x43) => {
  if (hasProperty10(x43, "toJSON") && isFunction37(x43["toJSON"]) && x43["toJSON"].length === 0) {
    return x43.toJSON();
  } else if (Array.isArray(x43)) {
    return x43.map(toJSON10);
  }
  return x43;
};
var format10 = (x43) => JSON.stringify(x43, null, 2);
var pipeArguments10 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i43 = 0, len = args.length; i43 < len; i43++) {
        ret = args[i43](ret);
      }
      return ret;
    }
  }
};
var OP_COMMIT6 = "Commit";
var OP_FAILURE8 = "Failure";
var OP_WITH_RUNTIME8 = "WithRuntime";
var EffectTypeId11 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId10 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId10 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId10 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance10 = {
  /* c8 ignore next */
  _R: (_43) => _43,
  /* c8 ignore next */
  _E: (_43) => _43,
  /* c8 ignore next */
  _A: (_43) => _43,
  _V: /* @__PURE__ */ getCurrentVersion10()
};
var sinkVariance10 = {
  /* c8 ignore next */
  _A: (_43) => _43,
  /* c8 ignore next */
  _In: (_43) => _43,
  /* c8 ignore next */
  _L: (_43) => _43,
  /* c8 ignore next */
  _E: (_43) => _43,
  /* c8 ignore next */
  _R: (_43) => _43
};
var channelVariance10 = {
  /* c8 ignore next */
  _Env: (_43) => _43,
  /* c8 ignore next */
  _InErr: (_43) => _43,
  /* c8 ignore next */
  _InElem: (_43) => _43,
  /* c8 ignore next */
  _InDone: (_43) => _43,
  /* c8 ignore next */
  _OutErr: (_43) => _43,
  /* c8 ignore next */
  _OutElem: (_43) => _43,
  /* c8 ignore next */
  _OutDone: (_43) => _43
};
var EffectPrototype10 = {
  [EffectTypeId11]: effectVariance10,
  [StreamTypeId10]: effectVariance10,
  [SinkTypeId10]: sinkVariance10,
  [ChannelTypeId10]: channelVariance10,
  [symbol28](that) {
    return this === that;
  },
  [symbol14]() {
    return cached10(this, random10(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen11(new YieldWrap10(this));
  },
  pipe() {
    return pipeArguments10(this, arguments);
  }
};
var StructuralPrototype6 = {
  [symbol14]() {
    return cached10(this, structure6(this));
  },
  [symbol28](that) {
    const selfKeys = Object.keys(this);
    const thatKeys = Object.keys(that);
    if (selfKeys.length !== thatKeys.length) {
      return false;
    }
    for (const key of selfKeys) {
      if (!(key in that && equals10(this[key], that[key]))) {
        return false;
      }
    }
    return true;
  }
};
var CommitPrototype6 = {
  ...EffectPrototype10,
  _op: OP_COMMIT6
};
var StructuralCommitPrototype6 = {
  ...CommitPrototype6,
  ...StructuralPrototype6
};
var TypeId30 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto14 = {
  ...EffectPrototype10,
  [TypeId30]: {
    _A: (_43) => _43
  },
  [NodeInspectSymbol10]() {
    return this.toJSON();
  },
  toString() {
    return format10(this.toJSON());
  }
};
var SomeProto10 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto14), {
  _tag: "Some",
  _op: "Some",
  [symbol28](that) {
    return isOption14(that) && isSome14(that) && equals10(this.value, that.value);
  },
  [symbol14]() {
    return cached10(this, combine11(hash10(this._tag))(hash10(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON10(this.value)
    };
  }
});
var NoneHash10 = /* @__PURE__ */ hash10("None");
var NoneProto10 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto14), {
  _tag: "None",
  _op: "None",
  [symbol28](that) {
    return isOption14(that) && isNone14(that);
  },
  [symbol14]() {
    return NoneHash10;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption14 = (input) => hasProperty10(input, TypeId30);
var isNone14 = (fa) => fa._tag === "None";
var isSome14 = (fa) => fa._tag === "Some";
var none14 = /* @__PURE__ */ Object.create(NoneProto10);
var some28 = (value) => {
  const a43 = Object.create(SomeProto10);
  a43.value = value;
  return a43;
};
var TypeId210 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto28 = {
  ...EffectPrototype10,
  [TypeId210]: {
    _R: (_43) => _43
  },
  [NodeInspectSymbol10]() {
    return this.toJSON();
  },
  toString() {
    return format10(this.toJSON());
  }
};
var RightProto10 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto28), {
  _tag: "Right",
  _op: "Right",
  [symbol28](that) {
    return isEither10(that) && isRight12(that) && equals10(this.right, that.right);
  },
  [symbol14]() {
    return combine11(hash10(this._tag))(hash10(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON10(this.right)
    };
  }
});
var LeftProto10 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto28), {
  _tag: "Left",
  _op: "Left",
  [symbol28](that) {
    return isEither10(that) && isLeft12(that) && equals10(this.left, that.left);
  },
  [symbol14]() {
    return combine11(hash10(this._tag))(hash10(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON10(this.left)
    };
  }
});
var isEither10 = (input) => hasProperty10(input, TypeId210);
var isLeft12 = (ma) => ma._tag === "Left";
var isRight12 = (ma) => ma._tag === "Right";
var left11 = (left342) => {
  const a43 = Object.create(LeftProto10);
  a43.left = left342;
  return a43;
};
var right11 = (right342) => {
  const a43 = Object.create(RightProto10);
  a43.right = right342;
  return a43;
};
var getLeft14 = (self2) => isRight12(self2) ? none14 : some28(self2.left);
var getRight14 = (self2) => isLeft12(self2) ? none14 : some28(self2.right);
var right28 = right11;
var left28 = left11;
var Option_exports10 = {};
__export27(Option_exports10, {
  Do: () => Do11,
  TypeId: () => TypeId38,
  all: () => all28,
  andThen: () => andThen10,
  ap: () => ap10,
  as: () => as10,
  asVoid: () => asVoid10,
  bind: () => bind28,
  bindTo: () => bindTo28,
  composeK: () => composeK10,
  contains: () => contains11,
  containsWith: () => containsWith11,
  exists: () => exists10,
  filter: () => filter12,
  filterMap: () => filterMap12,
  firstSomeOf: () => firstSomeOf10,
  flatMap: () => flatMap11,
  flatMapNullable: () => flatMapNullable11,
  flatten: () => flatten11,
  fromIterable: () => fromIterable14,
  fromNullable: () => fromNullable11,
  gen: () => gen10,
  getEquivalence: () => getEquivalence13,
  getLeft: () => getLeft28,
  getOrElse: () => getOrElse10,
  getOrNull: () => getOrNull10,
  getOrThrow: () => getOrThrow10,
  getOrThrowWith: () => getOrThrowWith10,
  getOrUndefined: () => getOrUndefined10,
  getOrder: () => getOrder11,
  getRight: () => getRight28,
  isNone: () => isNone28,
  isOption: () => isOption28,
  isSome: () => isSome28,
  let: () => let_28,
  lift2: () => lift210,
  liftNullable: () => liftNullable11,
  liftPredicate: () => liftPredicate11,
  liftThrowable: () => liftThrowable10,
  map: () => map12,
  match: () => match28,
  none: () => none28,
  orElse: () => orElse10,
  orElseEither: () => orElseEither10,
  orElseSome: () => orElseSome10,
  partitionMap: () => partitionMap12,
  product: () => product28,
  productMany: () => productMany28,
  reduceCompact: () => reduceCompact10,
  some: () => some38,
  tap: () => tap10,
  toArray: () => toArray10,
  toRefinement: () => toRefinement10,
  void: () => void_10,
  zipLeft: () => zipLeft10,
  zipRight: () => zipRight10,
  zipWith: () => zipWith11
});
var make210 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId38 = /* @__PURE__ */ Symbol.for("effect/Option");
var none28 = () => none14;
var some38 = some28;
var isOption28 = isOption14;
var isNone28 = isNone14;
var isSome28 = isSome14;
var match28 = /* @__PURE__ */ dual10(2, (self2, {
  onNone,
  onSome
}) => isNone28(self2) ? onNone() : onSome(self2.value));
var toRefinement10 = (f43) => (a43) => isSome28(f43(a43));
var fromIterable14 = (collection) => {
  for (const a43 of collection) {
    return some38(a43);
  }
  return none28();
};
var getRight28 = getRight14;
var getLeft28 = getLeft14;
var getOrElse10 = /* @__PURE__ */ dual10(2, (self2, onNone) => isNone28(self2) ? onNone() : self2.value);
var orElse10 = /* @__PURE__ */ dual10(2, (self2, that) => isNone28(self2) ? that() : self2);
var orElseSome10 = /* @__PURE__ */ dual10(2, (self2, onNone) => isNone28(self2) ? some38(onNone()) : self2);
var orElseEither10 = /* @__PURE__ */ dual10(2, (self2, that) => isNone28(self2) ? map12(that(), right11) : map12(self2, left11));
var firstSomeOf10 = (collection) => {
  let out = none28();
  for (out of collection) {
    if (isSome28(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable11 = (nullableValue) => nullableValue == null ? none28() : some38(nullableValue);
var liftNullable11 = (f43) => (...a43) => fromNullable11(f43(...a43));
var getOrNull10 = /* @__PURE__ */ getOrElse10(constNull10);
var getOrUndefined10 = /* @__PURE__ */ getOrElse10(constUndefined10);
var liftThrowable10 = (f43) => (...a43) => {
  try {
    return some38(f43(...a43));
  } catch (e43) {
    return none28();
  }
};
var getOrThrowWith10 = /* @__PURE__ */ dual10(2, (self2, onNone) => {
  if (isSome28(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow10 = /* @__PURE__ */ getOrThrowWith10(() => new Error("getOrThrow called on a None"));
var map12 = /* @__PURE__ */ dual10(2, (self2, f43) => isNone28(self2) ? none28() : some38(f43(self2.value)));
var as10 = /* @__PURE__ */ dual10(2, (self2, b43) => map12(self2, () => b43));
var asVoid10 = /* @__PURE__ */ as10(void 0);
var void_10 = /* @__PURE__ */ some38(void 0);
var flatMap11 = /* @__PURE__ */ dual10(2, (self2, f43) => isNone28(self2) ? none28() : f43(self2.value));
var andThen10 = /* @__PURE__ */ dual10(2, (self2, f43) => flatMap11(self2, (a43) => {
  const b43 = isFunction28(f43) ? f43(a43) : f43;
  return isOption28(b43) ? b43 : some38(b43);
}));
var flatMapNullable11 = /* @__PURE__ */ dual10(2, (self2, f43) => isNone28(self2) ? none28() : fromNullable11(f43(self2.value)));
var flatten11 = /* @__PURE__ */ flatMap11(identity10);
var zipRight10 = /* @__PURE__ */ dual10(2, (self2, that) => flatMap11(self2, () => that));
var composeK10 = /* @__PURE__ */ dual10(2, (afb, bfc) => (a43) => flatMap11(afb(a43), bfc));
var zipLeft10 = /* @__PURE__ */ dual10(2, (self2, that) => tap10(self2, () => that));
var tap10 = /* @__PURE__ */ dual10(2, (self2, f43) => flatMap11(self2, (a43) => map12(f43(a43), () => a43)));
var product28 = (self2, that) => isSome28(self2) && isSome28(that) ? some38([self2.value, that.value]) : none28();
var productMany28 = (self2, collection) => {
  if (isNone28(self2)) {
    return none28();
  }
  const out = [self2.value];
  for (const o43 of collection) {
    if (isNone28(o43)) {
      return none28();
    }
    out.push(o43.value);
  }
  return some38(out);
};
var all28 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o43 of input) {
      if (isNone28(o43)) {
        return none28();
      }
      out2.push(o43.value);
    }
    return some38(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o43 = input[key];
    if (isNone28(o43)) {
      return none28();
    }
    out[key] = o43.value;
  }
  return some38(out);
};
var zipWith11 = /* @__PURE__ */ dual10(3, (self2, that, f43) => map12(product28(self2, that), ([a43, b43]) => f43(a43, b43)));
var ap10 = /* @__PURE__ */ dual10(2, (self2, that) => zipWith11(self2, that, (f43, a43) => f43(a43)));
var reduceCompact10 = /* @__PURE__ */ dual10(3, (self2, b43, f43) => {
  let out = b43;
  for (const oa of self2) {
    if (isSome28(oa)) {
      out = f43(out, oa.value);
    }
  }
  return out;
});
var toArray10 = (self2) => isNone28(self2) ? [] : [self2.value];
var partitionMap12 = /* @__PURE__ */ dual10(2, (self2, f43) => {
  if (isNone28(self2)) {
    return [none28(), none28()];
  }
  const e43 = f43(self2.value);
  return isLeft12(e43) ? [some38(e43.left), none28()] : [none28(), some38(e43.right)];
});
var filterMap12 = /* @__PURE__ */ dual10(2, (self2, f43) => isNone28(self2) ? none28() : f43(self2.value));
var filter12 = /* @__PURE__ */ dual10(2, (self2, predicate) => filterMap12(self2, (b43) => predicate(b43) ? some28(b43) : none14));
var getEquivalence13 = (isEquivalent) => make30((x43, y43) => x43 === y43 || (isNone28(x43) ? isNone28(y43) : isNone28(y43) ? false : isEquivalent(x43.value, y43.value)));
var getOrder11 = (O43) => make210((self2, that) => isSome28(self2) ? isSome28(that) ? O43(self2.value, that.value) : 1 : -1);
var lift210 = (f43) => dual10(2, (self2, that) => zipWith11(self2, that, f43));
var liftPredicate11 = (predicate) => (b43) => predicate(b43) ? some38(b43) : none28();
var containsWith11 = (isEquivalent) => dual10(2, (self2, a43) => isNone28(self2) ? false : isEquivalent(self2.value, a43));
var _equivalence12 = /* @__PURE__ */ equivalence10();
var contains11 = /* @__PURE__ */ containsWith11(_equivalence12);
var exists10 = /* @__PURE__ */ dual10(2, (self2, refinement) => isNone28(self2) ? false : refinement(self2.value));
var bindTo28 = /* @__PURE__ */ bindTo15(map12);
var let_28 = /* @__PURE__ */ let_15(map12);
var bind28 = /* @__PURE__ */ bind15(map12, flatMap11);
var Do11 = /* @__PURE__ */ some38({});
var adapter28 = /* @__PURE__ */ adapter14();
var gen10 = (f43) => {
  const iterator = f43(adapter28);
  let state = iterator.next();
  if (state.done) {
    return some38(state.value);
  } else {
    let current = state.value;
    if (isGenKind10(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet10(current);
    }
    if (isNone28(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind10(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet10(current);
        }
        if (isNone28(current)) {
          return current;
        }
      }
    }
    return some38(state.value);
  }
};
var fromIterable28 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var reverse10 = (self2) => Array.from(self2).reverse();
var reduce12 = /* @__PURE__ */ dual10(3, (self2, b43, f43) => fromIterable28(self2).reduce((b232, a43, i43) => f43(b232, a43, i43), b43));
var TagTypeId8 = /* @__PURE__ */ Symbol.for("effect/Context/Tag");
var STMSymbolKey8 = "effect/STM";
var STMTypeId8 = /* @__PURE__ */ Symbol.for(STMSymbolKey8);
var TagProto8 = {
  ...EffectPrototype10,
  _tag: "Tag",
  _op: "Tag",
  [STMTypeId8]: effectVariance10,
  [TagTypeId8]: {
    _Service: (_43) => _43,
    _Identifier: (_43) => _43
  },
  toString() {
    return format10(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Tag",
      key: this.key,
      stack: this.stack
    };
  },
  [NodeInspectSymbol10]() {
    return this.toJSON();
  },
  of(self2) {
    return self2;
  },
  context(self2) {
    return make38(this, self2);
  }
};
var makeGenericTag8 = (key) => {
  const limit = Error.stackTraceLimit;
  Error.stackTraceLimit = 2;
  const creationError = new Error();
  Error.stackTraceLimit = limit;
  const tag = Object.create(TagProto8);
  Object.defineProperty(tag, "stack", {
    get() {
      return creationError.stack;
    }
  });
  tag.key = key;
  return tag;
};
var TypeId48 = /* @__PURE__ */ Symbol.for("effect/Context");
var ContextProto8 = {
  [TypeId48]: {
    _Services: (_43) => _43
  },
  [symbol28](that) {
    if (isContext8(that)) {
      if (this.unsafeMap.size === that.unsafeMap.size) {
        for (const k43 of this.unsafeMap.keys()) {
          if (!that.unsafeMap.has(k43) || !equals10(this.unsafeMap.get(k43), that.unsafeMap.get(k43))) {
            return false;
          }
        }
        return true;
      }
    }
    return false;
  },
  [symbol14]() {
    return cached10(this, number11(this.unsafeMap.size));
  },
  pipe() {
    return pipeArguments10(this, arguments);
  },
  toString() {
    return format10(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Context",
      services: Array.from(this.unsafeMap).map(toJSON10)
    };
  },
  [NodeInspectSymbol10]() {
    return this.toJSON();
  }
};
var makeContext8 = (unsafeMap) => {
  const context = Object.create(ContextProto8);
  context.unsafeMap = unsafeMap;
  return context;
};
var isContext8 = (u43) => hasProperty10(u43, TypeId48);
var _empty12 = /* @__PURE__ */ makeContext8(/* @__PURE__ */ new Map());
var empty18 = () => _empty12;
var make38 = (tag, service) => makeContext8(/* @__PURE__ */ new Map([[tag.key, service]]));
var GenericTag8 = makeGenericTag8;
var empty28 = empty18;
var TypeId58 = /* @__PURE__ */ Symbol.for("effect/Chunk");
function copy9(src, srcPos, dest, destPos, len) {
  for (let i43 = srcPos; i43 < Math.min(src.length, srcPos + len); i43++) {
    dest[destPos + i43 - srcPos] = src[i43];
  }
  return dest;
}
var emptyArray8 = [];
var getEquivalence28 = (isEquivalent) => make30((self2, that) => self2.length === that.length && toReadonlyArray8(self2).every((value, i43) => isEquivalent(value, unsafeGet28(that, i43))));
var _equivalence28 = /* @__PURE__ */ getEquivalence28(equals10);
var ChunkProto8 = {
  [TypeId58]: {
    _A: (_43) => _43
  },
  toString() {
    return format10(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Chunk",
      values: toReadonlyArray8(this).map(toJSON10)
    };
  },
  [NodeInspectSymbol10]() {
    return this.toJSON();
  },
  [symbol28](that) {
    return isChunk8(that) && _equivalence28(this, that);
  },
  [symbol14]() {
    return cached10(this, array12(toReadonlyArray8(this)));
  },
  [Symbol.iterator]() {
    switch (this.backing._tag) {
      case "IArray": {
        return this.backing.array[Symbol.iterator]();
      }
      case "IEmpty": {
        return emptyArray8[Symbol.iterator]();
      }
      default: {
        return toReadonlyArray8(this)[Symbol.iterator]();
      }
    }
  },
  pipe() {
    return pipeArguments10(this, arguments);
  }
};
var makeChunk8 = (backing) => {
  const chunk = Object.create(ChunkProto8);
  chunk.backing = backing;
  switch (backing._tag) {
    case "IEmpty": {
      chunk.length = 0;
      chunk.depth = 0;
      chunk.left = chunk;
      chunk.right = chunk;
      break;
    }
    case "IConcat": {
      chunk.length = backing.left.length + backing.right.length;
      chunk.depth = 1 + Math.max(backing.left.depth, backing.right.depth);
      chunk.left = backing.left;
      chunk.right = backing.right;
      break;
    }
    case "IArray": {
      chunk.length = backing.array.length;
      chunk.depth = 0;
      chunk.left = _empty28;
      chunk.right = _empty28;
      break;
    }
    case "ISingleton": {
      chunk.length = 1;
      chunk.depth = 0;
      chunk.left = _empty28;
      chunk.right = _empty28;
      break;
    }
    case "ISlice": {
      chunk.length = backing.length;
      chunk.depth = backing.chunk.depth + 1;
      chunk.left = _empty28;
      chunk.right = _empty28;
      break;
    }
  }
  return chunk;
};
var isChunk8 = (u43) => hasProperty10(u43, TypeId58);
var _empty28 = /* @__PURE__ */ makeChunk8({
  _tag: "IEmpty"
});
var empty38 = () => _empty28;
var make48 = (...as253) => as253.length === 1 ? of9(as253[0]) : unsafeFromNonEmptyArray8(as253);
var of9 = (a43) => makeChunk8({
  _tag: "ISingleton",
  a: a43
});
var copyToArray8 = (self2, array342, initial) => {
  switch (self2.backing._tag) {
    case "IArray": {
      copy9(self2.backing.array, 0, array342, initial, self2.length);
      break;
    }
    case "IConcat": {
      copyToArray8(self2.left, array342, initial);
      copyToArray8(self2.right, array342, initial + self2.left.length);
      break;
    }
    case "ISingleton": {
      array342[initial] = self2.backing.a;
      break;
    }
    case "ISlice": {
      let i43 = 0;
      let j43 = initial;
      while (i43 < self2.length) {
        array342[j43] = unsafeGet28(self2, i43);
        i43 += 1;
        j43 += 1;
      }
      break;
    }
  }
};
var toReadonlyArray8 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      return emptyArray8;
    }
    case "IArray": {
      return self2.backing.array;
    }
    default: {
      const arr = new Array(self2.length);
      copyToArray8(self2, arr, 0);
      self2.backing = {
        _tag: "IArray",
        array: arr
      };
      self2.left = _empty28;
      self2.right = _empty28;
      self2.depth = 0;
      return arr;
    }
  }
};
var reverse28 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty":
    case "ISingleton":
      return self2;
    case "IArray": {
      return makeChunk8({
        _tag: "IArray",
        array: reverse10(self2.backing.array)
      });
    }
    case "IConcat": {
      return makeChunk8({
        _tag: "IConcat",
        left: reverse28(self2.backing.right),
        right: reverse28(self2.backing.left)
      });
    }
    case "ISlice":
      return unsafeFromArray8(reverse10(toReadonlyArray8(self2)));
  }
};
var unsafeFromArray8 = (self2) => makeChunk8({
  _tag: "IArray",
  array: self2
});
var unsafeFromNonEmptyArray8 = (self2) => unsafeFromArray8(self2);
var unsafeGet28 = /* @__PURE__ */ dual10(2, (self2, index) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      throw new Error(`Index out of bounds`);
    }
    case "ISingleton": {
      if (index !== 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.a;
    }
    case "IArray": {
      if (index >= self2.length || index < 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.array[index];
    }
    case "IConcat": {
      return index < self2.left.length ? unsafeGet28(self2.left, index) : unsafeGet28(self2.right, index - self2.left.length);
    }
    case "ISlice": {
      return unsafeGet28(self2.backing.chunk, index + self2.backing.offset);
    }
  }
});
var prepend10 = /* @__PURE__ */ dual10(2, (self2, elem) => appendAll9(of9(elem), self2));
var drop9 = /* @__PURE__ */ dual10(2, (self2, n43) => {
  if (n43 <= 0) {
    return self2;
  } else if (n43 >= self2.length) {
    return _empty28;
  } else {
    switch (self2.backing._tag) {
      case "ISlice": {
        return makeChunk8({
          _tag: "ISlice",
          chunk: self2.backing.chunk,
          offset: self2.backing.offset + n43,
          length: self2.backing.length - n43
        });
      }
      case "IConcat": {
        if (n43 > self2.left.length) {
          return drop9(self2.right, n43 - self2.left.length);
        }
        return makeChunk8({
          _tag: "IConcat",
          left: drop9(self2.left, n43),
          right: self2.right
        });
      }
      default: {
        return makeChunk8({
          _tag: "ISlice",
          chunk: self2,
          offset: n43,
          length: self2.length - n43
        });
      }
    }
  }
});
var appendAll9 = /* @__PURE__ */ dual10(2, (self2, that) => {
  if (self2.backing._tag === "IEmpty") {
    return that;
  }
  if (that.backing._tag === "IEmpty") {
    return self2;
  }
  const diff242 = that.depth - self2.depth;
  if (Math.abs(diff242) <= 1) {
    return makeChunk8({
      _tag: "IConcat",
      left: self2,
      right: that
    });
  } else if (diff242 < -1) {
    if (self2.left.depth >= self2.right.depth) {
      const nr = appendAll9(self2.right, that);
      return makeChunk8({
        _tag: "IConcat",
        left: self2.left,
        right: nr
      });
    } else {
      const nrr = appendAll9(self2.right.right, that);
      if (nrr.depth === self2.depth - 3) {
        const nr = makeChunk8({
          _tag: "IConcat",
          left: self2.right.left,
          right: nrr
        });
        return makeChunk8({
          _tag: "IConcat",
          left: self2.left,
          right: nr
        });
      } else {
        const nl = makeChunk8({
          _tag: "IConcat",
          left: self2.left,
          right: self2.right.left
        });
        return makeChunk8({
          _tag: "IConcat",
          left: nl,
          right: nrr
        });
      }
    }
  } else {
    if (that.right.depth >= that.left.depth) {
      const nl = appendAll9(self2, that.left);
      return makeChunk8({
        _tag: "IConcat",
        left: nl,
        right: that.right
      });
    } else {
      const nll = appendAll9(self2, that.left.left);
      if (nll.depth === that.depth - 3) {
        const nl = makeChunk8({
          _tag: "IConcat",
          left: nll,
          right: that.left.right
        });
        return makeChunk8({
          _tag: "IConcat",
          left: nl,
          right: that.right
        });
      } else {
        const nr = makeChunk8({
          _tag: "IConcat",
          left: that.left.right,
          right: that.right
        });
        return makeChunk8({
          _tag: "IConcat",
          left: nll,
          right: nr
        });
      }
    }
  }
});
var isEmpty9 = (self2) => self2.length === 0;
var isNonEmpty8 = (self2) => self2.length > 0;
var unsafeHead8 = (self2) => unsafeGet28(self2, 0);
var headNonEmpty9 = unsafeHead8;
var tailNonEmpty9 = (self2) => drop9(self2, 1);
var SIZE8 = 5;
var BUCKET_SIZE8 = /* @__PURE__ */ Math.pow(2, SIZE8);
var MASK8 = BUCKET_SIZE8 - 1;
var MAX_INDEX_NODE8 = BUCKET_SIZE8 / 2;
var MIN_ARRAY_NODE8 = BUCKET_SIZE8 / 4;
function popcount8(x43) {
  x43 -= x43 >> 1 & 1431655765;
  x43 = (x43 & 858993459) + (x43 >> 2 & 858993459);
  x43 = x43 + (x43 >> 4) & 252645135;
  x43 += x43 >> 8;
  x43 += x43 >> 16;
  return x43 & 127;
}
function hashFragment8(shift22, h43) {
  return h43 >>> shift22 & MASK8;
}
function toBitmap8(x43) {
  return 1 << x43;
}
function fromBitmap8(bitmap, bit) {
  return popcount8(bitmap & bit - 1);
}
var make58 = (value, previous) => ({
  value,
  previous
});
function arrayUpdate8(mutate242, at, v43, arr) {
  let out = arr;
  if (!mutate242) {
    const len = arr.length;
    out = new Array(len);
    for (let i43 = 0; i43 < len; ++i43) out[i43] = arr[i43];
  }
  out[at] = v43;
  return out;
}
function arraySpliceOut8(mutate242, at, arr) {
  const newLen = arr.length - 1;
  let i43 = 0;
  let g43 = 0;
  let out = arr;
  if (mutate242) {
    i43 = g43 = at;
  } else {
    out = new Array(newLen);
    while (i43 < at) out[g43++] = arr[i43++];
  }
  ++i43;
  while (i43 <= newLen) out[g43++] = arr[i43++];
  if (mutate242) {
    out.length = newLen;
  }
  return out;
}
function arraySpliceIn8(mutate242, at, v43, arr) {
  const len = arr.length;
  if (mutate242) {
    let i232 = len;
    while (i232 >= at) arr[i232--] = arr[i232];
    arr[at] = v43;
    return arr;
  }
  let i43 = 0, g43 = 0;
  const out = new Array(len + 1);
  while (i43 < at) out[g43++] = arr[i43++];
  out[at] = v43;
  while (i43 < len) out[++g43] = arr[i43++];
  return out;
}
var EmptyNode8 = class _EmptyNode8 {
  _tag = "EmptyNode";
  modify(edit, _shift, f43, hash253, key, size442) {
    const v43 = f43(none28());
    if (isNone28(v43)) return new _EmptyNode8();
    ++size442.value;
    return new LeafNode8(edit, hash253, key, v43);
  }
};
function isEmptyNode8(a43) {
  return isTagged10(a43, "EmptyNode");
}
function isLeafNode8(node) {
  return isEmptyNode8(node) || node._tag === "LeafNode" || node._tag === "CollisionNode";
}
function canEditNode8(node, edit) {
  return isEmptyNode8(node) ? false : edit === node.edit;
}
var LeafNode8 = class _LeafNode8 {
  edit;
  hash;
  key;
  value;
  _tag = "LeafNode";
  constructor(edit, hash253, key, value) {
    this.edit = edit;
    this.hash = hash253;
    this.key = key;
    this.value = value;
  }
  modify(edit, shift22, f43, hash253, key, size442) {
    if (equals10(key, this.key)) {
      const v232 = f43(this.value);
      if (v232 === this.value) return this;
      else if (isNone28(v232)) {
        --size442.value;
        return new EmptyNode8();
      }
      if (canEditNode8(this, edit)) {
        this.value = v232;
        return this;
      }
      return new _LeafNode8(edit, hash253, key, v232);
    }
    const v43 = f43(none28());
    if (isNone28(v43)) return this;
    ++size442.value;
    return mergeLeaves8(edit, shift22, this.hash, this, hash253, new _LeafNode8(edit, hash253, key, v43));
  }
};
var CollisionNode8 = class _CollisionNode8 {
  edit;
  hash;
  children;
  _tag = "CollisionNode";
  constructor(edit, hash253, children) {
    this.edit = edit;
    this.hash = hash253;
    this.children = children;
  }
  modify(edit, shift22, f43, hash253, key, size442) {
    if (hash253 === this.hash) {
      const canEdit = canEditNode8(this, edit);
      const list = this.updateCollisionList(canEdit, edit, this.hash, this.children, f43, key, size442);
      if (list === this.children) return this;
      return list.length > 1 ? new _CollisionNode8(edit, this.hash, list) : list[0];
    }
    const v43 = f43(none28());
    if (isNone28(v43)) return this;
    ++size442.value;
    return mergeLeaves8(edit, shift22, this.hash, this, hash253, new LeafNode8(edit, hash253, key, v43));
  }
  updateCollisionList(mutate242, edit, hash253, list, f43, key, size442) {
    const len = list.length;
    for (let i43 = 0; i43 < len; ++i43) {
      const child = list[i43];
      if ("key" in child && equals10(key, child.key)) {
        const value = child.value;
        const newValue2 = f43(value);
        if (newValue2 === value) return list;
        if (isNone28(newValue2)) {
          --size442.value;
          return arraySpliceOut8(mutate242, i43, list);
        }
        return arrayUpdate8(mutate242, i43, new LeafNode8(edit, hash253, key, newValue2), list);
      }
    }
    const newValue = f43(none28());
    if (isNone28(newValue)) return list;
    ++size442.value;
    return arrayUpdate8(mutate242, len, new LeafNode8(edit, hash253, key, newValue), list);
  }
};
var IndexedNode8 = class _IndexedNode8 {
  edit;
  mask;
  children;
  _tag = "IndexedNode";
  constructor(edit, mask, children) {
    this.edit = edit;
    this.mask = mask;
    this.children = children;
  }
  modify(edit, shift22, f43, hash253, key, size442) {
    const mask = this.mask;
    const children = this.children;
    const frag = hashFragment8(shift22, hash253);
    const bit = toBitmap8(frag);
    const indx = fromBitmap8(mask, bit);
    const exists253 = mask & bit;
    const canEdit = canEditNode8(this, edit);
    if (!exists253) {
      const _newChild = new EmptyNode8().modify(edit, shift22 + SIZE8, f43, hash253, key, size442);
      if (!_newChild) return this;
      return children.length >= MAX_INDEX_NODE8 ? expand8(edit, frag, _newChild, mask, children) : new _IndexedNode8(edit, mask | bit, arraySpliceIn8(canEdit, indx, _newChild, children));
    }
    const current = children[indx];
    const child = current.modify(edit, shift22 + SIZE8, f43, hash253, key, size442);
    if (current === child) return this;
    let bitmap = mask;
    let newChildren;
    if (isEmptyNode8(child)) {
      bitmap &= ~bit;
      if (!bitmap) return new EmptyNode8();
      if (children.length <= 2 && isLeafNode8(children[indx ^ 1])) {
        return children[indx ^ 1];
      }
      newChildren = arraySpliceOut8(canEdit, indx, children);
    } else {
      newChildren = arrayUpdate8(canEdit, indx, child, children);
    }
    if (canEdit) {
      this.mask = bitmap;
      this.children = newChildren;
      return this;
    }
    return new _IndexedNode8(edit, bitmap, newChildren);
  }
};
var ArrayNode8 = class _ArrayNode8 {
  edit;
  size;
  children;
  _tag = "ArrayNode";
  constructor(edit, size442, children) {
    this.edit = edit;
    this.size = size442;
    this.children = children;
  }
  modify(edit, shift22, f43, hash253, key, size442) {
    let count = this.size;
    const children = this.children;
    const frag = hashFragment8(shift22, hash253);
    const child = children[frag];
    const newChild = (child || new EmptyNode8()).modify(edit, shift22 + SIZE8, f43, hash253, key, size442);
    if (child === newChild) return this;
    const canEdit = canEditNode8(this, edit);
    let newChildren;
    if (isEmptyNode8(child) && !isEmptyNode8(newChild)) {
      ++count;
      newChildren = arrayUpdate8(canEdit, frag, newChild, children);
    } else if (!isEmptyNode8(child) && isEmptyNode8(newChild)) {
      --count;
      if (count <= MIN_ARRAY_NODE8) {
        return pack8(edit, count, frag, children);
      }
      newChildren = arrayUpdate8(canEdit, frag, new EmptyNode8(), children);
    } else {
      newChildren = arrayUpdate8(canEdit, frag, newChild, children);
    }
    if (canEdit) {
      this.size = count;
      this.children = newChildren;
      return this;
    }
    return new _ArrayNode8(edit, count, newChildren);
  }
};
function pack8(edit, count, removed, elements) {
  const children = new Array(count - 1);
  let g43 = 0;
  let bitmap = 0;
  for (let i43 = 0, len = elements.length; i43 < len; ++i43) {
    if (i43 !== removed) {
      const elem = elements[i43];
      if (elem && !isEmptyNode8(elem)) {
        children[g43++] = elem;
        bitmap |= 1 << i43;
      }
    }
  }
  return new IndexedNode8(edit, bitmap, children);
}
function expand8(edit, frag, child, bitmap, subNodes) {
  const arr = [];
  let bit = bitmap;
  let count = 0;
  for (let i43 = 0; bit; ++i43) {
    if (bit & 1) arr[i43] = subNodes[count++];
    bit >>>= 1;
  }
  arr[frag] = child;
  return new ArrayNode8(edit, count + 1, arr);
}
function mergeLeavesInner8(edit, shift22, h1, n1, h232, n232) {
  if (h1 === h232) return new CollisionNode8(edit, h1, [n232, n1]);
  const subH1 = hashFragment8(shift22, h1);
  const subH2 = hashFragment8(shift22, h232);
  if (subH1 === subH2) {
    return (child) => new IndexedNode8(edit, toBitmap8(subH1) | toBitmap8(subH2), [child]);
  } else {
    const children = subH1 < subH2 ? [n1, n232] : [n232, n1];
    return new IndexedNode8(edit, toBitmap8(subH1) | toBitmap8(subH2), children);
  }
}
function mergeLeaves8(edit, shift22, h1, n1, h232, n232) {
  let stack = void 0;
  let currentShift = shift22;
  while (true) {
    const res = mergeLeavesInner8(edit, currentShift, h1, n1, h232, n232);
    if (typeof res === "function") {
      stack = make58(res, stack);
      currentShift = currentShift + SIZE8;
    } else {
      let final = res;
      while (stack != null) {
        final = stack.value(final);
        stack = stack.previous;
      }
      return final;
    }
  }
}
var HashMapSymbolKey8 = "effect/HashMap";
var HashMapTypeId8 = /* @__PURE__ */ Symbol.for(HashMapSymbolKey8);
var HashMapProto8 = {
  [HashMapTypeId8]: HashMapTypeId8,
  [Symbol.iterator]() {
    return new HashMapIterator8(this, (k43, v43) => [k43, v43]);
  },
  [symbol14]() {
    let hash253 = hash10(HashMapSymbolKey8);
    for (const item of this) {
      hash253 ^= pipe10(hash10(item[0]), combine11(hash10(item[1])));
    }
    return cached10(this, hash253);
  },
  [symbol28](that) {
    if (isHashMap8(that)) {
      if (that._size !== this._size) {
        return false;
      }
      for (const item of this) {
        const elem = pipe10(that, getHash8(item[0], hash10(item[0])));
        if (isNone28(elem)) {
          return false;
        } else {
          if (!equals10(item[1], elem.value)) {
            return false;
          }
        }
      }
      return true;
    }
    return false;
  },
  toString() {
    return format10(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashMap",
      values: Array.from(this).map(toJSON10)
    };
  },
  [NodeInspectSymbol10]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments10(this, arguments);
  }
};
var makeImpl9 = (editable, edit, root, size442) => {
  const map622 = Object.create(HashMapProto8);
  map622._editable = editable;
  map622._edit = edit;
  map622._root = root;
  map622._size = size442;
  return map622;
};
var HashMapIterator8 = class _HashMapIterator8 {
  map;
  f;
  v;
  constructor(map622, f43) {
    this.map = map622;
    this.f = f43;
    this.v = visitLazy8(this.map._root, this.f, void 0);
  }
  next() {
    if (isNone28(this.v)) {
      return {
        done: true,
        value: void 0
      };
    }
    const v0 = this.v.value;
    this.v = applyCont8(v0.cont);
    return {
      done: false,
      value: v0.value
    };
  }
  [Symbol.iterator]() {
    return new _HashMapIterator8(this.map, this.f);
  }
};
var applyCont8 = (cont) => cont ? visitLazyChildren8(cont[0], cont[1], cont[2], cont[3], cont[4]) : none28();
var visitLazy8 = (node, f43, cont = void 0) => {
  switch (node._tag) {
    case "LeafNode": {
      if (isSome28(node.value)) {
        return some38({
          value: f43(node.key, node.value.value),
          cont
        });
      }
      return applyCont8(cont);
    }
    case "CollisionNode":
    case "ArrayNode":
    case "IndexedNode": {
      const children = node.children;
      return visitLazyChildren8(children.length, children, 0, f43, cont);
    }
    default: {
      return applyCont8(cont);
    }
  }
};
var visitLazyChildren8 = (len, children, i43, f43, cont) => {
  while (i43 < len) {
    const child = children[i43++];
    if (child && !isEmptyNode8(child)) {
      return visitLazy8(child, f43, [len, children, i43, f43, cont]);
    }
  }
  return applyCont8(cont);
};
var _empty38 = /* @__PURE__ */ makeImpl9(false, 0, /* @__PURE__ */ new EmptyNode8(), 0);
var empty48 = () => _empty38;
var isHashMap8 = (u43) => hasProperty10(u43, HashMapTypeId8);
var getHash8 = /* @__PURE__ */ dual10(3, (self2, key, hash253) => {
  let node = self2._root;
  let shift22 = 0;
  while (true) {
    switch (node._tag) {
      case "LeafNode": {
        return equals10(key, node.key) ? node.value : none28();
      }
      case "CollisionNode": {
        if (hash253 === node.hash) {
          const children = node.children;
          for (let i43 = 0, len = children.length; i43 < len; ++i43) {
            const child = children[i43];
            if ("key" in child && equals10(key, child.key)) {
              return child.value;
            }
          }
        }
        return none28();
      }
      case "IndexedNode": {
        const frag = hashFragment8(shift22, hash253);
        const bit = toBitmap8(frag);
        if (node.mask & bit) {
          node = node.children[fromBitmap8(node.mask, bit)];
          shift22 += SIZE8;
          break;
        }
        return none28();
      }
      case "ArrayNode": {
        node = node.children[hashFragment8(shift22, hash253)];
        if (node) {
          shift22 += SIZE8;
          break;
        }
        return none28();
      }
      default:
        return none28();
    }
  }
});
var set10 = /* @__PURE__ */ dual10(3, (self2, key, value) => modifyAt8(self2, key, () => some38(value)));
var setTree8 = /* @__PURE__ */ dual10(3, (self2, newRoot, newSize) => {
  if (self2._editable) {
    self2._root = newRoot;
    self2._size = newSize;
    return self2;
  }
  return newRoot === self2._root ? self2 : makeImpl9(self2._editable, self2._edit, newRoot, newSize);
});
var keys10 = (self2) => new HashMapIterator8(self2, (key) => key);
var size11 = (self2) => self2._size;
var beginMutation9 = (self2) => makeImpl9(true, self2._edit + 1, self2._root, self2._size);
var modifyAt8 = /* @__PURE__ */ dual10(3, (self2, key, f43) => modifyHash8(self2, key, hash10(key), f43));
var modifyHash8 = /* @__PURE__ */ dual10(4, (self2, key, hash253, f43) => {
  const size442 = {
    value: self2._size
  };
  const newRoot = self2._root.modify(self2._editable ? self2._edit : NaN, 0, f43, hash253, key, size442);
  return pipe10(self2, setTree8(newRoot, size442.value));
});
var forEach11 = /* @__PURE__ */ dual10(2, (self2, f43) => reduce28(self2, void 0, (_43, value, key) => f43(value, key)));
var reduce28 = /* @__PURE__ */ dual10(3, (self2, zero, f43) => {
  const root = self2._root;
  if (root._tag === "LeafNode") {
    return isSome28(root.value) ? f43(zero, root.value.value, root.key) : zero;
  }
  if (root._tag === "EmptyNode") {
    return zero;
  }
  const toVisit = [root.children];
  let children;
  while (children = toVisit.pop()) {
    for (let i43 = 0, len = children.length; i43 < len; ) {
      const child = children[i43++];
      if (child && !isEmptyNode8(child)) {
        if (child._tag === "LeafNode") {
          if (isSome28(child.value)) {
            zero = f43(zero, child.value.value, child.key);
          }
        } else {
          toVisit.push(child.children);
        }
      }
    }
  }
  return zero;
});
var HashSetSymbolKey8 = "effect/HashSet";
var HashSetTypeId8 = /* @__PURE__ */ Symbol.for(HashSetSymbolKey8);
var HashSetProto8 = {
  [HashSetTypeId8]: HashSetTypeId8,
  [Symbol.iterator]() {
    return keys10(this._keyMap);
  },
  [symbol14]() {
    return cached10(this, combine11(hash10(this._keyMap))(hash10(HashSetSymbolKey8)));
  },
  [symbol28](that) {
    if (isHashSet8(that)) {
      return size11(this._keyMap) === size11(that._keyMap) && equals10(this._keyMap, that._keyMap);
    }
    return false;
  },
  toString() {
    return format10(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashSet",
      values: Array.from(this).map(toJSON10)
    };
  },
  [NodeInspectSymbol10]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments10(this, arguments);
  }
};
var makeImpl28 = (keyMap) => {
  const set253 = Object.create(HashSetProto8);
  set253._keyMap = keyMap;
  return set253;
};
var isHashSet8 = (u43) => hasProperty10(u43, HashSetTypeId8);
var _empty48 = /* @__PURE__ */ makeImpl28(/* @__PURE__ */ empty48());
var empty58 = () => _empty48;
var size28 = (self2) => size11(self2._keyMap);
var beginMutation28 = (self2) => makeImpl28(beginMutation9(self2._keyMap));
var endMutation8 = (self2) => {
  self2._keyMap._editable = false;
  return self2;
};
var mutate8 = /* @__PURE__ */ dual10(2, (self2, f43) => {
  const transient = beginMutation28(self2);
  f43(transient);
  return endMutation8(transient);
});
var add28 = /* @__PURE__ */ dual10(2, (self2, value) => self2._keyMap._editable ? (set10(value, true)(self2._keyMap), self2) : makeImpl28(set10(value, true)(self2._keyMap)));
var union28 = /* @__PURE__ */ dual10(2, (self2, that) => mutate8(empty58(), (set253) => {
  forEach28(self2, (value) => add28(set253, value));
  for (const value of that) {
    add28(set253, value);
  }
}));
var forEach28 = /* @__PURE__ */ dual10(2, (self2, f43) => forEach11(self2._keyMap, (_43, k43) => f43(k43)));
var empty68 = empty58;
var size38 = size28;
var add38 = add28;
var union38 = union28;
var ArrayProto8 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(Array.prototype), {
  [symbol14]() {
    return cached10(this, array12(this));
  },
  [symbol28](that) {
    if (Array.isArray(that) && this.length === that.length) {
      return this.every((v43, i43) => equals10(v43, that[i43]));
    } else {
      return false;
    }
  }
});
var Structural9 = /* @__PURE__ */ function() {
  function Structural342(args) {
    if (args) {
      Object.assign(this, args);
    }
  }
  Structural342.prototype = StructuralPrototype6;
  return Structural342;
}();
var struct28 = (as253) => Object.assign(Object.create(StructuralPrototype6), as253);
var ContextPatchTypeId8 = /* @__PURE__ */ Symbol.for("effect/DifferContextPatch");
function variance9(a43) {
  return a43;
}
var PatchProto8 = {
  ...Structural9.prototype,
  [ContextPatchTypeId8]: {
    _Value: variance9,
    _Patch: variance9
  }
};
var EmptyProto8 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto8), {
  _tag: "Empty"
});
var _empty58 = /* @__PURE__ */ Object.create(EmptyProto8);
var empty78 = () => _empty58;
var AndThenProto8 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto8), {
  _tag: "AndThen"
});
var makeAndThen8 = (first, second) => {
  const o43 = Object.create(AndThenProto8);
  o43.first = first;
  o43.second = second;
  return o43;
};
var AddServiceProto8 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto8), {
  _tag: "AddService"
});
var makeAddService8 = (key, service) => {
  const o43 = Object.create(AddServiceProto8);
  o43.key = key;
  o43.service = service;
  return o43;
};
var RemoveServiceProto8 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto8), {
  _tag: "RemoveService"
});
var makeRemoveService8 = (key) => {
  const o43 = Object.create(RemoveServiceProto8);
  o43.key = key;
  return o43;
};
var UpdateServiceProto8 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto8), {
  _tag: "UpdateService"
});
var makeUpdateService8 = (key, update222) => {
  const o43 = Object.create(UpdateServiceProto8);
  o43.key = key;
  o43.update = update222;
  return o43;
};
var diff8 = (oldValue, newValue) => {
  const missingServices = new Map(oldValue.unsafeMap);
  let patch242 = empty78();
  for (const [tag, newService] of newValue.unsafeMap.entries()) {
    if (missingServices.has(tag)) {
      const old = missingServices.get(tag);
      missingServices.delete(tag);
      if (!equals10(old, newService)) {
        patch242 = combine28(makeUpdateService8(tag, () => newService))(patch242);
      }
    } else {
      missingServices.delete(tag);
      patch242 = combine28(makeAddService8(tag, newService))(patch242);
    }
  }
  for (const [tag] of missingServices.entries()) {
    patch242 = combine28(makeRemoveService8(tag))(patch242);
  }
  return patch242;
};
var combine28 = /* @__PURE__ */ dual10(2, (self2, that) => makeAndThen8(self2, that));
var patch8 = /* @__PURE__ */ dual10(2, (self2, context) => {
  if (self2._tag === "Empty") {
    return context;
  }
  let wasServiceUpdated = false;
  let patches = of9(self2);
  const updatedContext = new Map(context.unsafeMap);
  while (isNonEmpty8(patches)) {
    const head222 = headNonEmpty9(patches);
    const tail42 = tailNonEmpty9(patches);
    switch (head222._tag) {
      case "Empty": {
        patches = tail42;
        break;
      }
      case "AddService": {
        updatedContext.set(head222.key, head222.service);
        patches = tail42;
        break;
      }
      case "AndThen": {
        patches = prepend10(prepend10(tail42, head222.second), head222.first);
        break;
      }
      case "RemoveService": {
        updatedContext.delete(head222.key);
        patches = tail42;
        break;
      }
      case "UpdateService": {
        updatedContext.set(head222.key, head222.update(updatedContext.get(head222.key)));
        wasServiceUpdated = true;
        patches = tail42;
        break;
      }
    }
  }
  if (!wasServiceUpdated) {
    return makeContext8(updatedContext);
  }
  const map622 = /* @__PURE__ */ new Map();
  for (const [tag] of context.unsafeMap) {
    if (updatedContext.has(tag)) {
      map622.set(tag, updatedContext.get(tag));
      updatedContext.delete(tag);
    }
  }
  for (const [tag, s43] of updatedContext) {
    map622.set(tag, s43);
  }
  return makeContext8(map622);
});
var DifferTypeId8 = /* @__PURE__ */ Symbol.for("effect/Differ");
var DifferProto8 = {
  [DifferTypeId8]: {
    _P: identity10,
    _V: identity10
  }
};
var make78 = (params) => {
  const differ = Object.create(DifferProto8);
  differ.empty = params.empty;
  differ.diff = params.diff;
  differ.combine = params.combine;
  differ.patch = params.patch;
  return differ;
};
var environment8 = () => make78({
  empty: empty78(),
  combine: (first, second) => combine28(second)(first),
  diff: (oldValue, newValue) => diff8(oldValue, newValue),
  patch: (patch242, oldValue) => patch8(oldValue)(patch242)
});
var OP_DIE8 = "Die";
var OP_EMPTY8 = "Empty";
var OP_FAIL8 = "Fail";
var OP_INTERRUPT8 = "Interrupt";
var OP_PARALLEL8 = "Parallel";
var OP_SEQUENTIAL8 = "Sequential";
var CauseSymbolKey8 = "effect/Cause";
var CauseTypeId8 = /* @__PURE__ */ Symbol.for(CauseSymbolKey8);
var variance28 = {
  /* c8 ignore next */
  _E: (_43) => _43
};
var proto8 = {
  [CauseTypeId8]: variance28,
  [symbol14]() {
    return pipe10(hash10(CauseSymbolKey8), combine11(hash10(flattenCause8(this))), cached10(this));
  },
  [symbol28](that) {
    return isCause8(that) && causeEquals8(this, that);
  },
  pipe() {
    return pipeArguments10(this, arguments);
  },
  toJSON() {
    switch (this._tag) {
      case "Empty":
        return {
          _id: "Cause",
          _tag: this._tag
        };
      case "Die":
        return {
          _id: "Cause",
          _tag: this._tag,
          defect: toJSON10(this.defect)
        };
      case "Interrupt":
        return {
          _id: "Cause",
          _tag: this._tag,
          fiberId: this.fiberId.toJSON()
        };
      case "Fail":
        return {
          _id: "Cause",
          _tag: this._tag,
          failure: toJSON10(this.error)
        };
      case "Sequential":
      case "Parallel":
        return {
          _id: "Cause",
          _tag: this._tag,
          left: toJSON10(this.left),
          right: toJSON10(this.right)
        };
    }
  },
  toString() {
    return pretty8(this);
  },
  [NodeInspectSymbol10]() {
    return this.toJSON();
  }
};
var fail9 = (error) => {
  const o43 = Object.create(proto8);
  o43._tag = OP_FAIL8;
  o43.error = error;
  return o43;
};
var parallel8 = (left342, right342) => {
  const o43 = Object.create(proto8);
  o43._tag = OP_PARALLEL8;
  o43.left = left342;
  o43.right = right342;
  return o43;
};
var sequential8 = (left342, right342) => {
  const o43 = Object.create(proto8);
  o43._tag = OP_SEQUENTIAL8;
  o43.left = left342;
  o43.right = right342;
  return o43;
};
var isCause8 = (u43) => hasProperty10(u43, CauseTypeId8);
var isInterruptedOnly8 = (self2) => reduceWithContext8(void 0, IsInterruptedOnlyCauseReducer8)(self2);
var causeEquals8 = (left342, right342) => {
  let leftStack = of9(left342);
  let rightStack = of9(right342);
  while (isNonEmpty8(leftStack) && isNonEmpty8(rightStack)) {
    const [leftParallel, leftSequential] = pipe10(headNonEmpty9(leftStack), reduce48([empty68(), empty38()], ([parallel242, sequential242], cause) => {
      const [par, seq] = evaluateCause8(cause);
      return some38([pipe10(parallel242, union38(par)), pipe10(sequential242, appendAll9(seq))]);
    }));
    const [rightParallel, rightSequential] = pipe10(headNonEmpty9(rightStack), reduce48([empty68(), empty38()], ([parallel242, sequential242], cause) => {
      const [par, seq] = evaluateCause8(cause);
      return some38([pipe10(parallel242, union38(par)), pipe10(sequential242, appendAll9(seq))]);
    }));
    if (!equals10(leftParallel, rightParallel)) {
      return false;
    }
    leftStack = leftSequential;
    rightStack = rightSequential;
  }
  return true;
};
var flattenCause8 = (cause) => {
  return flattenCauseLoop8(of9(cause), empty38());
};
var flattenCauseLoop8 = (causes, flattened) => {
  while (1) {
    const [parallel242, sequential242] = pipe10(causes, reduce12([empty68(), empty38()], ([parallel322, sequential322], cause) => {
      const [par, seq] = evaluateCause8(cause);
      return [pipe10(parallel322, union38(par)), pipe10(sequential322, appendAll9(seq))];
    }));
    const updated = size38(parallel242) > 0 ? pipe10(flattened, prepend10(parallel242)) : flattened;
    if (isEmpty9(sequential242)) {
      return reverse28(updated);
    }
    causes = sequential242;
    flattened = updated;
  }
  throw new Error(getBugErrorMessage10("Cause.flattenCauseLoop"));
};
var evaluateCause8 = (self2) => {
  let cause = self2;
  const stack = [];
  let _parallel = empty68();
  let _sequential = empty38();
  while (cause !== void 0) {
    switch (cause._tag) {
      case OP_EMPTY8: {
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_FAIL8: {
        _parallel = add38(_parallel, make48(cause._tag, cause.error));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_DIE8: {
        _parallel = add38(_parallel, make48(cause._tag, cause.defect));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_INTERRUPT8: {
        _parallel = add38(_parallel, make48(cause._tag, cause.fiberId));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_SEQUENTIAL8: {
        switch (cause.left._tag) {
          case OP_EMPTY8: {
            cause = cause.right;
            break;
          }
          case OP_SEQUENTIAL8: {
            cause = sequential8(cause.left.left, sequential8(cause.left.right, cause.right));
            break;
          }
          case OP_PARALLEL8: {
            cause = parallel8(sequential8(cause.left.left, cause.right), sequential8(cause.left.right, cause.right));
            break;
          }
          default: {
            _sequential = prepend10(_sequential, cause.right);
            cause = cause.left;
            break;
          }
        }
        break;
      }
      case OP_PARALLEL8: {
        stack.push(cause.right);
        cause = cause.left;
        break;
      }
    }
  }
  throw new Error(getBugErrorMessage10("Cause.evaluateCauseLoop"));
};
var IsInterruptedOnlyCauseReducer8 = {
  emptyCase: constTrue10,
  failCase: constFalse10,
  dieCase: constFalse10,
  interruptCase: constTrue10,
  sequentialCase: (_43, left342, right342) => left342 && right342,
  parallelCase: (_43, left342, right342) => left342 && right342
};
var OP_SEQUENTIAL_CASE8 = "SequentialCase";
var OP_PARALLEL_CASE8 = "ParallelCase";
var reduce48 = /* @__PURE__ */ dual10(3, (self2, zero, pf) => {
  let accumulator = zero;
  let cause = self2;
  const causes = [];
  while (cause !== void 0) {
    const option = pf(accumulator, cause);
    accumulator = isSome28(option) ? option.value : accumulator;
    switch (cause._tag) {
      case OP_SEQUENTIAL8: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      case OP_PARALLEL8: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      default: {
        cause = void 0;
        break;
      }
    }
    if (cause === void 0 && causes.length > 0) {
      cause = causes.pop();
    }
  }
  return accumulator;
});
var reduceWithContext8 = /* @__PURE__ */ dual10(3, (self2, context, reducer) => {
  const input = [self2];
  const output = [];
  while (input.length > 0) {
    const cause = input.pop();
    switch (cause._tag) {
      case OP_EMPTY8: {
        output.push(right28(reducer.emptyCase(context)));
        break;
      }
      case OP_FAIL8: {
        output.push(right28(reducer.failCase(context, cause.error)));
        break;
      }
      case OP_DIE8: {
        output.push(right28(reducer.dieCase(context, cause.defect)));
        break;
      }
      case OP_INTERRUPT8: {
        output.push(right28(reducer.interruptCase(context, cause.fiberId)));
        break;
      }
      case OP_SEQUENTIAL8: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left28({
          _tag: OP_SEQUENTIAL_CASE8
        }));
        break;
      }
      case OP_PARALLEL8: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left28({
          _tag: OP_PARALLEL_CASE8
        }));
        break;
      }
    }
  }
  const accumulator = [];
  while (output.length > 0) {
    const either = output.pop();
    switch (either._tag) {
      case "Left": {
        switch (either.left._tag) {
          case OP_SEQUENTIAL_CASE8: {
            const left342 = accumulator.pop();
            const right342 = accumulator.pop();
            const value = reducer.sequentialCase(context, left342, right342);
            accumulator.push(value);
            break;
          }
          case OP_PARALLEL_CASE8: {
            const left342 = accumulator.pop();
            const right342 = accumulator.pop();
            const value = reducer.parallelCase(context, left342, right342);
            accumulator.push(value);
            break;
          }
        }
        break;
      }
      case "Right": {
        accumulator.push(either.right);
        break;
      }
    }
  }
  if (accumulator.length === 0) {
    throw new Error("BUG: Cause.reduceWithContext - please report an issue at https://github.com/Effect-TS/effect/issues");
  }
  return accumulator.pop();
});
var pretty8 = (cause) => {
  if (isInterruptedOnly8(cause)) {
    return "All fibers interrupted without errors.";
  }
  return prettyErrors8(cause).map((e43) => e43.stack).join("\n");
};
var PrettyError8 = class extends globalThis.Error {
  span = void 0;
  constructor(originalError) {
    const prevLimit = Error.stackTraceLimit;
    Error.stackTraceLimit = 0;
    super(prettyErrorMessage8(originalError));
    Error.stackTraceLimit = prevLimit;
    this.name = originalError instanceof Error ? originalError.name : "Error";
    if (typeof originalError === "object" && originalError !== null) {
      if (spanSymbol9 in originalError) {
        this.span = originalError[spanSymbol9];
      }
      Object.keys(originalError).forEach((key) => {
        if (!(key in this)) {
          this[key] = originalError[key];
        }
      });
    }
    this.stack = prettyErrorStack8(this.message, originalError instanceof Error && originalError.stack ? originalError.stack : "", this.span);
  }
  toJSON() {
    const out = {
      message: this.message,
      stack: this.stack
    };
    if (this.span) {
      out.span = this.span;
    }
    return out;
  }
};
var prettyErrorMessage8 = (u43) => {
  if (typeof u43 === "string") {
    return `Error: ${u43}`;
  }
  try {
    if (hasProperty10(u43, "toString") && isFunction37(u43["toString"]) && u43["toString"] !== Object.prototype.toString && u43["toString"] !== globalThis.Array.prototype.toString) {
      return u43["toString"]();
    }
  } catch {
  }
  return `Error: ${JSON.stringify(u43)}`;
};
var locationRegex8 = /\((.*)\)/;
var spanToTrace8 = /* @__PURE__ */ globalValue10("effect/Tracer/spanToTrace", () => /* @__PURE__ */ new WeakMap());
var prettyErrorStack8 = (message, stack, span32) => {
  const out = [message];
  const lines = stack.split("\n");
  for (let i43 = 1; i43 < lines.length; i43++) {
    if (lines[i43].includes("Generator.next")) {
      break;
    }
    if (lines[i43].includes("effect_internal_function")) {
      out.pop();
      break;
    }
    out.push(lines[i43].replace(/at .*effect_instruction_i.*\((.*)\)/, "at $1").replace(/EffectPrimitive\.\w+/, "<anonymous>"));
  }
  if (span32) {
    let current = span32;
    let i43 = 0;
    while (current && current._tag === "Span" && i43 < 10) {
      const stackFn = spanToTrace8.get(current);
      if (typeof stackFn === "function") {
        const stack2 = stackFn();
        const locationMatch = stack2.match(locationRegex8);
        const location = locationMatch ? locationMatch[1] : stack2.replace(/^at /, "");
        out.push(`    at ${current.name} (${location})`);
      } else {
        out.push(`    at ${current.name}`);
      }
      current = getOrUndefined10(current.parent);
      i43++;
    }
  }
  return out.join("\n");
};
var spanSymbol9 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var prettyErrors8 = (cause) => reduceWithContext8(cause, void 0, {
  emptyCase: () => [],
  dieCase: (_43, unknownError) => {
    return [new PrettyError8(unknownError)];
  },
  failCase: (_43, error) => {
    return [new PrettyError8(error)];
  },
  interruptCase: () => [],
  parallelCase: (_43, l43, r43) => [...l43, ...r43],
  sequentialCase: (_43, l43, r43) => [...l43, ...r43]
});
var SingleShotGen28 = class _SingleShotGen27 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  next(a43) {
    return this.called ? {
      value: a43,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  return(a43) {
    return {
      value: a43,
      done: true
    };
  }
  throw(e43) {
    throw e43;
  }
  [Symbol.iterator]() {
    return new _SingleShotGen27(this.self);
  }
};
var spanTag8 = /* @__PURE__ */ GenericTag8("effect/ParentSpan");
var EffectTypeId28 = /* @__PURE__ */ Symbol.for("effect/Effect");
var EffectPrimitive8 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId28] = effectVariance10;
  constructor(_op) {
    this._op = _op;
  }
  [symbol28](that) {
    return this === that;
  }
  [symbol14]() {
    return cached10(this, random10(this));
  }
  pipe() {
    return pipeArguments10(this, arguments);
  }
  toJSON() {
    return {
      _id: "Effect",
      _op: this._op,
      effect_instruction_i0: toJSON10(this.effect_instruction_i0),
      effect_instruction_i1: toJSON10(this.effect_instruction_i1),
      effect_instruction_i2: toJSON10(this.effect_instruction_i2)
    };
  }
  toString() {
    return format10(this.toJSON());
  }
  [NodeInspectSymbol10]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen28(new YieldWrap10(this));
  }
};
var EffectPrimitiveFailure8 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId28] = effectVariance10;
  constructor(_op) {
    this._op = _op;
    this._tag = _op;
  }
  [symbol28](that) {
    return exitIsExit8(that) && that._op === "Failure" && // @ts-expect-error
    equals10(this.effect_instruction_i0, that.effect_instruction_i0);
  }
  [symbol14]() {
    return pipe10(
      // @ts-expect-error
      string12(this._tag),
      // @ts-expect-error
      combine11(hash10(this.effect_instruction_i0)),
      cached10(this)
    );
  }
  get cause() {
    return this.effect_instruction_i0;
  }
  pipe() {
    return pipeArguments10(this, arguments);
  }
  toJSON() {
    return {
      _id: "Exit",
      _tag: this._op,
      cause: this.cause.toJSON()
    };
  }
  toString() {
    return format10(this.toJSON());
  }
  [NodeInspectSymbol10]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen28(new YieldWrap10(this));
  }
};
var isEffect8 = (u43) => hasProperty10(u43, EffectTypeId28);
var withFiberRuntime8 = (withRuntime) => {
  const effect = new EffectPrimitive8(OP_WITH_RUNTIME8);
  effect.effect_instruction_i0 = withRuntime;
  return effect;
};
var spanSymbol28 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var originalSymbol8 = /* @__PURE__ */ Symbol.for("effect/OriginalAnnotation");
var capture8 = (obj, span32) => {
  if (isSome28(span32)) {
    return new Proxy(obj, {
      has(target, p43) {
        return p43 === spanSymbol28 || p43 === originalSymbol8 || p43 in target;
      },
      get(target, p43) {
        if (p43 === spanSymbol28) {
          return span32.value;
        }
        if (p43 === originalSymbol8) {
          return obj;
        }
        return target[p43];
      }
    });
  }
  return obj;
};
var fail28 = (error) => isObject10(error) && !(spanSymbol28 in error) ? withFiberRuntime8((fiber) => failCause8(fail9(capture8(error, currentSpanFromFiber8(fiber))))) : failCause8(fail9(error));
var failCause8 = (cause) => {
  const effect = new EffectPrimitiveFailure8(OP_FAILURE8);
  effect.effect_instruction_i0 = cause;
  return effect;
};
var FiberRefSymbolKey8 = "effect/FiberRef";
var FiberRefTypeId8 = /* @__PURE__ */ Symbol.for(FiberRefSymbolKey8);
var fiberRefVariance8 = {
  /* c8 ignore next */
  _A: (_43) => _43
};
var fiberRefUnsafeMakeContext8 = (initial) => {
  const differ = environment8();
  return fiberRefUnsafeMakePatch8(initial, {
    differ,
    fork: differ.empty
  });
};
var fiberRefUnsafeMakePatch8 = (initial, options) => ({
  [FiberRefTypeId8]: fiberRefVariance8,
  initial,
  diff: (oldValue, newValue) => options.differ.diff(oldValue, newValue),
  combine: (first, second) => options.differ.combine(first, second),
  patch: (patch242) => (oldValue) => options.differ.patch(patch242, oldValue),
  fork: options.fork,
  join: options.join ?? ((_43, n43) => n43),
  pipe() {
    return pipeArguments10(this, arguments);
  }
});
var currentContext8 = /* @__PURE__ */ globalValue10(/* @__PURE__ */ Symbol.for("effect/FiberRef/currentContext"), () => fiberRefUnsafeMakeContext8(empty28()));
var YieldableError8 = /* @__PURE__ */ function() {
  class YieldableError242 extends globalThis.Error {
    commit() {
      return fail28(this);
    }
    toString() {
      return this.message ? `${this.name}: ${this.message}` : this.name;
    }
    toJSON() {
      return {
        ...this
      };
    }
    [NodeInspectSymbol10]() {
      const stack = this.stack;
      if (stack) {
        return `${this.toString()}
${stack.split("\n").slice(1).join("\n")}`;
      }
      return this.toString();
    }
  }
  Object.assign(YieldableError242.prototype, StructuralCommitPrototype6);
  return YieldableError242;
}();
var exitIsExit8 = (u43) => isEffect8(u43) && "_tag" in u43 && (u43._tag === "Success" || u43._tag === "Failure");
var currentSpanFromFiber8 = (fiber) => {
  const span32 = fiber.getFiberRef(currentContext8).unsafeMap.get(spanTag8.key);
  return span32 !== void 0 && span32._tag === "Span" ? some38(span32) : none28();
};
var Data_exports6 = {};
__export27(Data_exports6, {
  Class: () => Class28,
  Error: () => Error28,
  Structural: () => Structural28,
  TaggedClass: () => TaggedClass8,
  TaggedError: () => TaggedError8,
  array: () => array28,
  case: () => _case8,
  struct: () => struct38,
  tagged: () => tagged8,
  taggedEnum: () => taggedEnum8,
  tuple: () => tuple28,
  unsafeArray: () => unsafeArray8,
  unsafeStruct: () => unsafeStruct8
});
var struct38 = struct28;
var unsafeStruct8 = (as253) => Object.setPrototypeOf(as253, StructuralPrototype6);
var tuple28 = (...as253) => unsafeArray8(as253);
var array28 = (as253) => unsafeArray8(as253.slice(0));
var unsafeArray8 = (as253) => Object.setPrototypeOf(as253, ArrayProto8);
var _case8 = () => (args) => args === void 0 ? Object.create(StructuralPrototype6) : struct38(args);
var tagged8 = (tag) => (args) => {
  const value = args === void 0 ? Object.create(StructuralPrototype6) : struct38(args);
  value._tag = tag;
  return value;
};
var Class28 = Structural9;
var TaggedClass8 = (tag) => {
  class Base extends Class28 {
    _tag = tag;
  }
  return Base;
};
var Structural28 = Structural9;
var taggedEnum8 = () => new Proxy({}, {
  get(_target, tag, _receiver) {
    if (tag === "$is") {
      return isTagged10;
    } else if (tag === "$match") {
      return taggedMatch8;
    }
    return tagged8(tag);
  }
});
function taggedMatch8() {
  if (arguments.length === 1) {
    const cases2 = arguments[0];
    return function(value2) {
      return cases2[value2._tag](value2);
    };
  }
  const value = arguments[0];
  const cases = arguments[1];
  return cases[value._tag](value);
}
var Error28 = /* @__PURE__ */ function() {
  return class Base extends YieldableError8 {
    constructor(args) {
      super();
      if (args) {
        Object.assign(this, args);
      }
    }
  };
}();
var TaggedError8 = (tag) => {
  class Base extends Error28 {
    _tag = tag;
  }
  Base.prototype.name = tag;
  return Base;
};
var traverseUp8 = Function_exports10.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType8.Program) return Option_exports10.none();
  return predicate(parent) ? Option_exports10.some(parent) : traverseUp8(parent, predicate);
});
var traverseUpGuard8 = Function_exports10.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType8.Program) return Option_exports10.none();
  return predicate(parent) ? Option_exports10.some(parent) : traverseUpGuard8(parent, predicate);
});
var ESLintCommunityESLintUtils8;
((ESLintCommunityESLintUtils242) => {
  ESLintCommunityESLintUtils242.getFunctionHeadLocation = getFunctionHeadLocation8;
  ESLintCommunityESLintUtils242.getFunctionNameWithKind = getFunctionNameWithKind8;
  ESLintCommunityESLintUtils242.getPropertyName = getPropertyName8;
  ESLintCommunityESLintUtils242.getStaticValue = getStaticValue8;
  ESLintCommunityESLintUtils242.getStringIfConstant = getStringIfConstant8;
  ESLintCommunityESLintUtils242.hasSideEffect = hasSideEffect8;
  ESLintCommunityESLintUtils242.isParenthesized = isParenthesized8;
})(ESLintCommunityESLintUtils8 || (ESLintCommunityESLintUtils8 = {}));
var Construction8 = Data_exports6.taggedEnum();
Construction8.None();
function getClassIdentifier3(node) {
  if (node.id) return Option_exports10.fromNullable(node.id);
  if (node.parent.type === NodeType8.VariableDeclarator && node.parent.id.type === NodeType8.Identifier) {
    return Option_exports10.fromNullable(node.parent.id);
  }
  return Option_exports10.none();
}
function getFunctionIdentifier4(node) {
  if (node.id) return Option_exports10.some(node.id);
  if (node.parent.type === NodeType8.VariableDeclarator && node.parent.init === node && node.parent.id.type === NodeType8.Identifier) {
    return Option_exports10.some(node.parent.id);
  }
  if (node.parent.type === NodeType8.AssignmentExpression && node.parent.right === node && node.parent.operator === "=" && node.parent.left.type === NodeType8.Identifier) {
    return Option_exports10.some(node.parent.left);
  }
  if (node.parent.type === NodeType8.Property && node.parent.value === node && !node.parent.computed && node.parent.key.type === NodeType8.Identifier) {
    return Option_exports10.some(node.parent.key);
  }
  if (isOneOf8([NodeType8.MethodDefinition, NodeType8.PropertyDefinition])(node.parent) && node.parent.value === node && node.parent.key.type === NodeType8.Identifier) {
    return Option_exports10.some(node.parent.key);
  }
  if (node.parent.type === NodeType8.AssignmentPattern && node.parent.right === node && node.parent.left.type === NodeType8.Identifier) {
    return Option_exports10.some(node.parent.left);
  }
  return Option_exports10.none();
}
a7({
  type: N7.union([NodeType8.FunctionExpression, NodeType8.ArrowFunctionExpression]),
  parent: {
    type: NodeType8.Property,
    parent: {
      type: NodeType8.ObjectExpression
    }
  }
});
a7({
  type: N7.union([NodeType8.FunctionExpression, NodeType8.ArrowFunctionExpression]),
  parent: {
    type: NodeType8.MethodDefinition,
    parent: {
      type: NodeType8.ClassBody
    }
  }
});
a7({
  type: N7.union([NodeType8.FunctionExpression, NodeType8.ArrowFunctionExpression]),
  parent: {
    type: NodeType8.Property,
    parent: {
      type: NodeType8.ClassBody
    }
  }
});
var import_short_unique_id4 = __toESM4(require_short_unique_id4());
var __defProp35 = Object.defineProperty;
var __export35 = (target, all922) => {
  for (var name22 in all922)
    __defProp35(target, name22, { get: all922[name22], enumerable: true });
};
var KEYS25 = {
  ArrayExpression: [
    "elements"
  ],
  ArrayPattern: [
    "elements"
  ],
  ArrowFunctionExpression: [
    "params",
    "body"
  ],
  AssignmentExpression: [
    "left",
    "right"
  ],
  AssignmentPattern: [
    "left",
    "right"
  ],
  AwaitExpression: [
    "argument"
  ],
  BinaryExpression: [
    "left",
    "right"
  ],
  BlockStatement: [
    "body"
  ],
  BreakStatement: [
    "label"
  ],
  CallExpression: [
    "callee",
    "arguments"
  ],
  CatchClause: [
    "param",
    "body"
  ],
  ChainExpression: [
    "expression"
  ],
  ClassBody: [
    "body"
  ],
  ClassDeclaration: [
    "id",
    "superClass",
    "body"
  ],
  ClassExpression: [
    "id",
    "superClass",
    "body"
  ],
  ConditionalExpression: [
    "test",
    "consequent",
    "alternate"
  ],
  ContinueStatement: [
    "label"
  ],
  DebuggerStatement: [],
  DoWhileStatement: [
    "body",
    "test"
  ],
  EmptyStatement: [],
  ExperimentalRestProperty: [
    "argument"
  ],
  ExperimentalSpreadProperty: [
    "argument"
  ],
  ExportAllDeclaration: [
    "exported",
    "source"
  ],
  ExportDefaultDeclaration: [
    "declaration"
  ],
  ExportNamedDeclaration: [
    "declaration",
    "specifiers",
    "source"
  ],
  ExportSpecifier: [
    "exported",
    "local"
  ],
  ExpressionStatement: [
    "expression"
  ],
  ForInStatement: [
    "left",
    "right",
    "body"
  ],
  ForOfStatement: [
    "left",
    "right",
    "body"
  ],
  ForStatement: [
    "init",
    "test",
    "update",
    "body"
  ],
  FunctionDeclaration: [
    "id",
    "params",
    "body"
  ],
  FunctionExpression: [
    "id",
    "params",
    "body"
  ],
  Identifier: [],
  IfStatement: [
    "test",
    "consequent",
    "alternate"
  ],
  ImportDeclaration: [
    "specifiers",
    "source"
  ],
  ImportDefaultSpecifier: [
    "local"
  ],
  ImportExpression: [
    "source"
  ],
  ImportNamespaceSpecifier: [
    "local"
  ],
  ImportSpecifier: [
    "imported",
    "local"
  ],
  JSXAttribute: [
    "name",
    "value"
  ],
  JSXClosingElement: [
    "name"
  ],
  JSXClosingFragment: [],
  JSXElement: [
    "openingElement",
    "children",
    "closingElement"
  ],
  JSXEmptyExpression: [],
  JSXExpressionContainer: [
    "expression"
  ],
  JSXFragment: [
    "openingFragment",
    "children",
    "closingFragment"
  ],
  JSXIdentifier: [],
  JSXMemberExpression: [
    "object",
    "property"
  ],
  JSXNamespacedName: [
    "namespace",
    "name"
  ],
  JSXOpeningElement: [
    "name",
    "attributes"
  ],
  JSXOpeningFragment: [],
  JSXSpreadAttribute: [
    "argument"
  ],
  JSXSpreadChild: [
    "expression"
  ],
  JSXText: [],
  LabeledStatement: [
    "label",
    "body"
  ],
  Literal: [],
  LogicalExpression: [
    "left",
    "right"
  ],
  MemberExpression: [
    "object",
    "property"
  ],
  MetaProperty: [
    "meta",
    "property"
  ],
  MethodDefinition: [
    "key",
    "value"
  ],
  NewExpression: [
    "callee",
    "arguments"
  ],
  ObjectExpression: [
    "properties"
  ],
  ObjectPattern: [
    "properties"
  ],
  PrivateIdentifier: [],
  Program: [
    "body"
  ],
  Property: [
    "key",
    "value"
  ],
  PropertyDefinition: [
    "key",
    "value"
  ],
  RestElement: [
    "argument"
  ],
  ReturnStatement: [
    "argument"
  ],
  SequenceExpression: [
    "expressions"
  ],
  SpreadElement: [
    "argument"
  ],
  StaticBlock: [
    "body"
  ],
  Super: [],
  SwitchCase: [
    "test",
    "consequent"
  ],
  SwitchStatement: [
    "discriminant",
    "cases"
  ],
  TaggedTemplateExpression: [
    "tag",
    "quasi"
  ],
  TemplateElement: [],
  TemplateLiteral: [
    "quasis",
    "expressions"
  ],
  ThisExpression: [],
  ThrowStatement: [
    "argument"
  ],
  TryStatement: [
    "block",
    "handler",
    "finalizer"
  ],
  UnaryExpression: [
    "argument"
  ],
  UpdateExpression: [
    "argument"
  ],
  VariableDeclaration: [
    "declarations"
  ],
  VariableDeclarator: [
    "id",
    "init"
  ],
  WhileStatement: [
    "test",
    "body"
  ],
  WithStatement: [
    "object",
    "body"
  ],
  YieldExpression: [
    "argument"
  ]
};
var NODE_TYPES25 = Object.keys(KEYS25);
for (const type of NODE_TYPES25) {
  Object.freeze(KEYS25[type]);
}
Object.freeze(KEYS25);
var visitor_keys_default25 = KEYS25;
var KEY_BLACKLIST25 = /* @__PURE__ */ new Set([
  "parent",
  "leadingComments",
  "trailingComments"
]);
function filterKey25(key) {
  return !KEY_BLACKLIST25.has(key) && key[0] !== "_";
}
function getKeys25(node) {
  return Object.keys(node).filter(filterKey25);
}
function getInnermostScope25(initialScope, node) {
  const location = node.range[0];
  let scope = initialScope;
  let found = false;
  do {
    found = false;
    for (const childScope of scope.childScopes) {
      const range222 = childScope.block.range;
      if (range222[0] <= location && location < range222[1]) {
        scope = childScope;
        found = true;
        break;
      }
    }
  } while (found);
  return scope;
}
function findVariable27(initialScope, nameOrNode) {
  let name22 = "";
  let scope = initialScope;
  if (typeof nameOrNode === "string") {
    name22 = nameOrNode;
  } else {
    name22 = nameOrNode.name;
    scope = getInnermostScope25(scope, nameOrNode);
  }
  while (scope != null) {
    const variable = scope.set.get(name22);
    if (variable != null) {
      return variable;
    }
    scope = scope.upper;
  }
  return null;
}
function negate025(token) {
  return !this(token);
}
function negate25(f322) {
  return negate025.bind(f322);
}
function isPunctuatorTokenWithValue25(token, value) {
  return token.type === "Punctuator" && token.value === value;
}
function isArrowToken25(token) {
  return isPunctuatorTokenWithValue25(token, "=>");
}
function isCommaToken25(token) {
  return isPunctuatorTokenWithValue25(token, ",");
}
function isSemicolonToken25(token) {
  return isPunctuatorTokenWithValue25(token, ";");
}
function isColonToken25(token) {
  return isPunctuatorTokenWithValue25(token, ":");
}
function isOpeningParenToken25(token) {
  return isPunctuatorTokenWithValue25(token, "(");
}
function isClosingParenToken25(token) {
  return isPunctuatorTokenWithValue25(token, ")");
}
function isOpeningBracketToken25(token) {
  return isPunctuatorTokenWithValue25(token, "[");
}
function isClosingBracketToken25(token) {
  return isPunctuatorTokenWithValue25(token, "]");
}
function isOpeningBraceToken25(token) {
  return isPunctuatorTokenWithValue25(token, "{");
}
function isClosingBraceToken25(token) {
  return isPunctuatorTokenWithValue25(token, "}");
}
function isCommentToken25(token) {
  return ["Block", "Line", "Shebang"].includes(token.type);
}
negate25(isArrowToken25);
negate25(isCommaToken25);
negate25(isSemicolonToken25);
negate25(isColonToken25);
negate25(isOpeningParenToken25);
negate25(isClosingParenToken25);
negate25(isOpeningBracketToken25);
negate25(isClosingBracketToken25);
negate25(isOpeningBraceToken25);
negate25(isClosingBraceToken25);
negate25(isCommentToken25);
function getOpeningParenOfParams25(node, sourceCode) {
  return node.id ? sourceCode.getTokenAfter(node.id, isOpeningParenToken25) : sourceCode.getFirstToken(node, isOpeningParenToken25);
}
function getFunctionHeadLocation25(node, sourceCode) {
  const parent = node.parent;
  let start = null;
  let end = null;
  if (node.type === "ArrowFunctionExpression") {
    const arrowToken = sourceCode.getTokenBefore(node.body, isArrowToken25);
    start = arrowToken.loc.start;
    end = arrowToken.loc.end;
  } else if (parent.type === "Property" || parent.type === "MethodDefinition" || parent.type === "PropertyDefinition") {
    start = parent.loc.start;
    end = getOpeningParenOfParams25(node, sourceCode).loc.start;
  } else {
    start = node.loc.start;
    end = getOpeningParenOfParams25(node, sourceCode).loc.start;
  }
  return {
    start: { ...start },
    end: { ...end }
  };
}
var globalObject25 = typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {};
var builtinNames25 = Object.freeze(
  /* @__PURE__ */ new Set([
    "Array",
    "ArrayBuffer",
    "BigInt",
    "BigInt64Array",
    "BigUint64Array",
    "Boolean",
    "DataView",
    "Date",
    "decodeURI",
    "decodeURIComponent",
    "encodeURI",
    "encodeURIComponent",
    "escape",
    "Float32Array",
    "Float64Array",
    "Function",
    "Infinity",
    "Int16Array",
    "Int32Array",
    "Int8Array",
    "isFinite",
    "isNaN",
    "isPrototypeOf",
    "JSON",
    "Map",
    "Math",
    "NaN",
    "Number",
    "Object",
    "parseFloat",
    "parseInt",
    "Promise",
    "Proxy",
    "Reflect",
    "RegExp",
    "Set",
    "String",
    "Symbol",
    "Uint16Array",
    "Uint32Array",
    "Uint8Array",
    "Uint8ClampedArray",
    "undefined",
    "unescape",
    "WeakMap",
    "WeakSet"
  ])
);
var callAllowed25 = new Set(
  [
    Array.isArray,
    Array.of,
    Array.prototype.at,
    Array.prototype.concat,
    Array.prototype.entries,
    Array.prototype.every,
    Array.prototype.filter,
    Array.prototype.find,
    Array.prototype.findIndex,
    Array.prototype.flat,
    Array.prototype.includes,
    Array.prototype.indexOf,
    Array.prototype.join,
    Array.prototype.keys,
    Array.prototype.lastIndexOf,
    Array.prototype.slice,
    Array.prototype.some,
    Array.prototype.toString,
    Array.prototype.values,
    typeof BigInt === "function" ? BigInt : void 0,
    Boolean,
    Date,
    Date.parse,
    decodeURI,
    decodeURIComponent,
    encodeURI,
    encodeURIComponent,
    escape,
    isFinite,
    isNaN,
    isPrototypeOf,
    Map,
    Map.prototype.entries,
    Map.prototype.get,
    Map.prototype.has,
    Map.prototype.keys,
    Map.prototype.values,
    ...Object.getOwnPropertyNames(Math).filter((k322) => k322 !== "random").map((k322) => Math[k322]).filter((f322) => typeof f322 === "function"),
    Number,
    Number.isFinite,
    Number.isNaN,
    Number.parseFloat,
    Number.parseInt,
    Number.prototype.toExponential,
    Number.prototype.toFixed,
    Number.prototype.toPrecision,
    Number.prototype.toString,
    Object,
    Object.entries,
    Object.is,
    Object.isExtensible,
    Object.isFrozen,
    Object.isSealed,
    Object.keys,
    Object.values,
    parseFloat,
    parseInt,
    RegExp,
    Set,
    Set.prototype.entries,
    Set.prototype.has,
    Set.prototype.keys,
    Set.prototype.values,
    String,
    String.fromCharCode,
    String.fromCodePoint,
    String.raw,
    String.prototype.at,
    String.prototype.charAt,
    String.prototype.charCodeAt,
    String.prototype.codePointAt,
    String.prototype.concat,
    String.prototype.endsWith,
    String.prototype.includes,
    String.prototype.indexOf,
    String.prototype.lastIndexOf,
    String.prototype.normalize,
    String.prototype.padEnd,
    String.prototype.padStart,
    String.prototype.slice,
    String.prototype.startsWith,
    String.prototype.substr,
    String.prototype.substring,
    String.prototype.toLowerCase,
    String.prototype.toString,
    String.prototype.toUpperCase,
    String.prototype.trim,
    String.prototype.trimEnd,
    String.prototype.trimLeft,
    String.prototype.trimRight,
    String.prototype.trimStart,
    Symbol.for,
    Symbol.keyFor,
    unescape
  ].filter((f322) => typeof f322 === "function")
);
var callPassThrough25 = /* @__PURE__ */ new Set([
  Object.freeze,
  Object.preventExtensions,
  Object.seal
]);
var getterAllowed25 = [
  [Map, /* @__PURE__ */ new Set(["size"])],
  [
    RegExp,
    /* @__PURE__ */ new Set([
      "dotAll",
      "flags",
      "global",
      "hasIndices",
      "ignoreCase",
      "multiline",
      "source",
      "sticky",
      "unicode"
    ])
  ],
  [Set, /* @__PURE__ */ new Set(["size"])]
];
function getPropertyDescriptor25(object222, name22) {
  let x322 = object222;
  while ((typeof x322 === "object" || typeof x322 === "function") && x322 !== null) {
    const d322 = Object.getOwnPropertyDescriptor(x322, name22);
    if (d322) {
      return d322;
    }
    x322 = Object.getPrototypeOf(x322);
  }
  return null;
}
function isGetter25(object222, name22) {
  const d322 = getPropertyDescriptor25(object222, name22);
  return d322 != null && d322.get != null;
}
function getElementValues25(nodeList, initialScope) {
  const valueList = [];
  for (let i322 = 0; i322 < nodeList.length; ++i322) {
    const elementNode = nodeList[i322];
    if (elementNode == null) {
      valueList.length = i322 + 1;
    } else if (elementNode.type === "SpreadElement") {
      const argument = getStaticValueR25(elementNode.argument, initialScope);
      if (argument == null) {
        return null;
      }
      valueList.push(...argument.value);
    } else {
      const element = getStaticValueR25(elementNode, initialScope);
      if (element == null) {
        return null;
      }
      valueList.push(element.value);
    }
  }
  return valueList;
}
function isEffectivelyConst25(variable) {
  const refs = variable.references;
  const inits = refs.filter((r322) => r322.init).length;
  const reads = refs.filter((r322) => r322.isReadOnly()).length;
  if (inits === 1 && reads + inits === refs.length) {
    return true;
  }
  return false;
}
var operations25 = Object.freeze({
  ArrayExpression(node, initialScope) {
    const elements = getElementValues25(node.elements, initialScope);
    return elements != null ? { value: elements } : null;
  },
  AssignmentExpression(node, initialScope) {
    if (node.operator === "=") {
      return getStaticValueR25(node.right, initialScope);
    }
    return null;
  },
  //eslint-disable-next-line complexity
  BinaryExpression(node, initialScope) {
    if (node.operator === "in" || node.operator === "instanceof") {
      return null;
    }
    const left722 = getStaticValueR25(node.left, initialScope);
    const right722 = getStaticValueR25(node.right, initialScope);
    if (left722 != null && right722 != null) {
      switch (node.operator) {
        case "==":
          return { value: left722.value == right722.value };
        case "!=":
          return { value: left722.value != right722.value };
        case "===":
          return { value: left722.value === right722.value };
        case "!==":
          return { value: left722.value !== right722.value };
        case "<":
          return { value: left722.value < right722.value };
        case "<=":
          return { value: left722.value <= right722.value };
        case ">":
          return { value: left722.value > right722.value };
        case ">=":
          return { value: left722.value >= right722.value };
        case "<<":
          return { value: left722.value << right722.value };
        case ">>":
          return { value: left722.value >> right722.value };
        case ">>>":
          return { value: left722.value >>> right722.value };
        case "+":
          return { value: left722.value + right722.value };
        case "-":
          return { value: left722.value - right722.value };
        case "*":
          return { value: left722.value * right722.value };
        case "/":
          return { value: left722.value / right722.value };
        case "%":
          return { value: left722.value % right722.value };
        case "**":
          return { value: left722.value ** right722.value };
        case "|":
          return { value: left722.value | right722.value };
        case "^":
          return { value: left722.value ^ right722.value };
        case "&":
          return { value: left722.value & right722.value };
      }
    }
    return null;
  },
  CallExpression(node, initialScope) {
    const calleeNode = node.callee;
    const args = getElementValues25(node.arguments, initialScope);
    if (args != null) {
      if (calleeNode.type === "MemberExpression") {
        if (calleeNode.property.type === "PrivateIdentifier") {
          return null;
        }
        const object222 = getStaticValueR25(calleeNode.object, initialScope);
        if (object222 != null) {
          if (object222.value == null && (object222.optional || node.optional)) {
            return { value: void 0, optional: true };
          }
          const property = getStaticPropertyNameValue25(
            calleeNode,
            initialScope
          );
          if (property != null) {
            const receiver = object222.value;
            const methodName = property.value;
            if (callAllowed25.has(receiver[methodName])) {
              return { value: receiver[methodName](...args) };
            }
            if (callPassThrough25.has(receiver[methodName])) {
              return { value: args[0] };
            }
          }
        }
      } else {
        const callee = getStaticValueR25(calleeNode, initialScope);
        if (callee != null) {
          if (callee.value == null && node.optional) {
            return { value: void 0, optional: true };
          }
          const func = callee.value;
          if (callAllowed25.has(func)) {
            return { value: func(...args) };
          }
          if (callPassThrough25.has(func)) {
            return { value: args[0] };
          }
        }
      }
    }
    return null;
  },
  ConditionalExpression(node, initialScope) {
    const test = getStaticValueR25(node.test, initialScope);
    if (test != null) {
      return test.value ? getStaticValueR25(node.consequent, initialScope) : getStaticValueR25(node.alternate, initialScope);
    }
    return null;
  },
  ExpressionStatement(node, initialScope) {
    return getStaticValueR25(node.expression, initialScope);
  },
  Identifier(node, initialScope) {
    if (initialScope != null) {
      const variable = findVariable27(initialScope, node);
      if (variable != null && variable.defs.length === 0 && builtinNames25.has(variable.name) && variable.name in globalObject25) {
        return { value: globalObject25[variable.name] };
      }
      if (variable != null && variable.defs.length === 1) {
        const def = variable.defs[0];
        if (def.parent && def.type === "Variable" && (def.parent.kind === "const" || isEffectivelyConst25(variable)) && // TODO(mysticatea): don't support destructuring here.
        def.node.id.type === "Identifier") {
          return getStaticValueR25(def.node.init, initialScope);
        }
      }
    }
    return null;
  },
  Literal(node) {
    if ((node.regex != null || node.bigint != null) && node.value == null) {
      return null;
    }
    return { value: node.value };
  },
  LogicalExpression(node, initialScope) {
    const left722 = getStaticValueR25(node.left, initialScope);
    if (left722 != null) {
      if (node.operator === "||" && Boolean(left722.value) === true || node.operator === "&&" && Boolean(left722.value) === false || node.operator === "??" && left722.value != null) {
        return left722;
      }
      const right722 = getStaticValueR25(node.right, initialScope);
      if (right722 != null) {
        return right722;
      }
    }
    return null;
  },
  MemberExpression(node, initialScope) {
    if (node.property.type === "PrivateIdentifier") {
      return null;
    }
    const object222 = getStaticValueR25(node.object, initialScope);
    if (object222 != null) {
      if (object222.value == null && (object222.optional || node.optional)) {
        return { value: void 0, optional: true };
      }
      const property = getStaticPropertyNameValue25(node, initialScope);
      if (property != null) {
        if (!isGetter25(object222.value, property.value)) {
          return { value: object222.value[property.value] };
        }
        for (const [classFn, allowed] of getterAllowed25) {
          if (object222.value instanceof classFn && allowed.has(property.value)) {
            return { value: object222.value[property.value] };
          }
        }
      }
    }
    return null;
  },
  ChainExpression(node, initialScope) {
    const expression = getStaticValueR25(node.expression, initialScope);
    if (expression != null) {
      return { value: expression.value };
    }
    return null;
  },
  NewExpression(node, initialScope) {
    const callee = getStaticValueR25(node.callee, initialScope);
    const args = getElementValues25(node.arguments, initialScope);
    if (callee != null && args != null) {
      const Func = callee.value;
      if (callAllowed25.has(Func)) {
        return { value: new Func(...args) };
      }
    }
    return null;
  },
  ObjectExpression(node, initialScope) {
    const object222 = {};
    for (const propertyNode of node.properties) {
      if (propertyNode.type === "Property") {
        if (propertyNode.kind !== "init") {
          return null;
        }
        const key = getStaticPropertyNameValue25(
          propertyNode,
          initialScope
        );
        const value = getStaticValueR25(propertyNode.value, initialScope);
        if (key == null || value == null) {
          return null;
        }
        object222[key.value] = value.value;
      } else if (propertyNode.type === "SpreadElement" || propertyNode.type === "ExperimentalSpreadProperty") {
        const argument = getStaticValueR25(
          propertyNode.argument,
          initialScope
        );
        if (argument == null) {
          return null;
        }
        Object.assign(object222, argument.value);
      } else {
        return null;
      }
    }
    return { value: object222 };
  },
  SequenceExpression(node, initialScope) {
    const last222 = node.expressions[node.expressions.length - 1];
    return getStaticValueR25(last222, initialScope);
  },
  TaggedTemplateExpression(node, initialScope) {
    const tag = getStaticValueR25(node.tag, initialScope);
    const expressions = getElementValues25(
      node.quasi.expressions,
      initialScope
    );
    if (tag != null && expressions != null) {
      const func = tag.value;
      const strings = node.quasi.quasis.map((q) => q.value.cooked);
      strings.raw = node.quasi.quasis.map((q) => q.value.raw);
      if (func === String.raw) {
        return { value: func(strings, ...expressions) };
      }
    }
    return null;
  },
  TemplateLiteral(node, initialScope) {
    const expressions = getElementValues25(node.expressions, initialScope);
    if (expressions != null) {
      let value = node.quasis[0].value.cooked;
      for (let i322 = 0; i322 < expressions.length; ++i322) {
        value += expressions[i322];
        value += node.quasis[i322 + 1].value.cooked;
      }
      return { value };
    }
    return null;
  },
  UnaryExpression(node, initialScope) {
    if (node.operator === "delete") {
      return null;
    }
    if (node.operator === "void") {
      return { value: void 0 };
    }
    const arg = getStaticValueR25(node.argument, initialScope);
    if (arg != null) {
      switch (node.operator) {
        case "-":
          return { value: -arg.value };
        case "+":
          return { value: +arg.value };
        case "!":
          return { value: !arg.value };
        case "~":
          return { value: ~arg.value };
        case "typeof":
          return { value: typeof arg.value };
      }
    }
    return null;
  }
});
function getStaticValueR25(node, initialScope) {
  if (node != null && Object.hasOwnProperty.call(operations25, node.type)) {
    return operations25[node.type](node, initialScope);
  }
  return null;
}
function getStaticPropertyNameValue25(node, initialScope) {
  const nameNode = node.type === "Property" ? node.key : node.property;
  if (node.computed) {
    return getStaticValueR25(nameNode, initialScope);
  }
  if (nameNode.type === "Identifier") {
    return { value: nameNode.name };
  }
  if (nameNode.type === "Literal") {
    if (nameNode.bigint) {
      return { value: nameNode.bigint };
    }
    return { value: String(nameNode.value) };
  }
  return null;
}
function getStaticValue25(node, initialScope = null) {
  try {
    return getStaticValueR25(node, initialScope);
  } catch (_error) {
    return null;
  }
}
function getStringIfConstant25(node, initialScope = null) {
  if (node && node.type === "Literal" && node.value === null) {
    if (node.regex) {
      return `/${node.regex.pattern}/${node.regex.flags}`;
    }
    if (node.bigint) {
      return node.bigint;
    }
  }
  const evaluated = getStaticValue25(node, initialScope);
  return evaluated && String(evaluated.value);
}
function getPropertyName25(node, initialScope) {
  switch (node.type) {
    case "MemberExpression":
      if (node.computed) {
        return getStringIfConstant25(node.property, initialScope);
      }
      if (node.property.type === "PrivateIdentifier") {
        return null;
      }
      return node.property.name;
    case "Property":
    case "MethodDefinition":
    case "PropertyDefinition":
      if (node.computed) {
        return getStringIfConstant25(node.key, initialScope);
      }
      if (node.key.type === "Literal") {
        return String(node.key.value);
      }
      if (node.key.type === "PrivateIdentifier") {
        return null;
      }
      return node.key.name;
  }
  return null;
}
function getFunctionNameWithKind25(node, sourceCode) {
  const parent = node.parent;
  const tokens = [];
  const isObjectMethod = parent.type === "Property" && parent.value === node;
  const isClassMethod = parent.type === "MethodDefinition" && parent.value === node;
  const isClassFieldMethod = parent.type === "PropertyDefinition" && parent.value === node;
  if (isClassMethod || isClassFieldMethod) {
    if (parent.static) {
      tokens.push("static");
    }
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push("private");
    }
  }
  if (node.async) {
    tokens.push("async");
  }
  if (node.generator) {
    tokens.push("generator");
  }
  if (isObjectMethod || isClassMethod) {
    if (parent.kind === "constructor") {
      return "constructor";
    }
    if (parent.kind === "get") {
      tokens.push("getter");
    } else if (parent.kind === "set") {
      tokens.push("setter");
    } else {
      tokens.push("method");
    }
  } else if (isClassFieldMethod) {
    tokens.push("method");
  } else {
    if (node.type === "ArrowFunctionExpression") {
      tokens.push("arrow");
    }
    tokens.push("function");
  }
  if (isObjectMethod || isClassMethod || isClassFieldMethod) {
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push(`#${parent.key.name}`);
    } else {
      const name22 = getPropertyName25(parent);
      if (name22) {
        tokens.push(`'${name22}'`);
      } else if (sourceCode) {
        const keyText = sourceCode.getText(parent.key);
        if (!keyText.includes("\n")) {
          tokens.push(`[${keyText}]`);
        }
      }
    }
  } else if (node.id) {
    tokens.push(`'${node.id.name}'`);
  } else if (parent.type === "VariableDeclarator" && parent.id && parent.id.type === "Identifier") {
    tokens.push(`'${parent.id.name}'`);
  } else if ((parent.type === "AssignmentExpression" || parent.type === "AssignmentPattern") && parent.left && parent.left.type === "Identifier") {
    tokens.push(`'${parent.left.name}'`);
  } else if (parent.type === "ExportDefaultDeclaration" && parent.declaration === node) {
    tokens.push("'default'");
  }
  return tokens.join(" ");
}
var typeConversionBinaryOps25 = Object.freeze(
  /* @__PURE__ */ new Set([
    "==",
    "!=",
    "<",
    "<=",
    ">",
    ">=",
    "<<",
    ">>",
    ">>>",
    "+",
    "-",
    "*",
    "/",
    "%",
    "|",
    "^",
    "&",
    "in"
  ])
);
var typeConversionUnaryOps25 = Object.freeze(/* @__PURE__ */ new Set(["-", "+", "!", "~"]));
function isNode25(x322) {
  return x322 !== null && typeof x322 === "object" && typeof x322.type === "string";
}
var visitor25 = Object.freeze(
  Object.assign(/* @__PURE__ */ Object.create(null), {
    $visit(node, options, visitorKeys) {
      const { type } = node;
      if (typeof this[type] === "function") {
        return this[type](node, options, visitorKeys);
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    $visitChildren(node, options, visitorKeys) {
      const { type } = node;
      for (const key of visitorKeys[type] || getKeys25(node)) {
        const value = node[key];
        if (Array.isArray(value)) {
          for (const element of value) {
            if (isNode25(element) && this.$visit(element, options, visitorKeys)) {
              return true;
            }
          }
        } else if (isNode25(value) && this.$visit(value, options, visitorKeys)) {
          return true;
        }
      }
      return false;
    },
    ArrowFunctionExpression() {
      return false;
    },
    AssignmentExpression() {
      return true;
    },
    AwaitExpression() {
      return true;
    },
    BinaryExpression(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && typeConversionBinaryOps25.has(node.operator) && (node.left.type !== "Literal" || node.right.type !== "Literal")) {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    CallExpression() {
      return true;
    },
    FunctionExpression() {
      return false;
    },
    ImportExpression() {
      return true;
    },
    MemberExpression(node, options, visitorKeys) {
      if (options.considerGetters) {
        return true;
      }
      if (options.considerImplicitTypeConversion && node.computed && node.property.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    MethodDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    NewExpression() {
      return true;
    },
    Property(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    PropertyDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UnaryExpression(node, options, visitorKeys) {
      if (node.operator === "delete") {
        return true;
      }
      if (options.considerImplicitTypeConversion && typeConversionUnaryOps25.has(node.operator) && node.argument.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UpdateExpression() {
      return true;
    },
    YieldExpression() {
      return true;
    }
  })
);
function hasSideEffect25(node, sourceCode, { considerGetters = false, considerImplicitTypeConversion = false } = {}) {
  return visitor25.$visit(
    node,
    { considerGetters, considerImplicitTypeConversion },
    sourceCode.visitorKeys || visitor_keys_default25
  );
}
function getParentSyntaxParen25(node, sourceCode) {
  const parent = node.parent;
  switch (parent.type) {
    case "CallExpression":
    case "NewExpression":
      if (parent.arguments.length === 1 && parent.arguments[0] === node) {
        return sourceCode.getTokenAfter(
          parent.callee,
          isOpeningParenToken25
        );
      }
      return null;
    case "DoWhileStatement":
      if (parent.test === node) {
        return sourceCode.getTokenAfter(
          parent.body,
          isOpeningParenToken25
        );
      }
      return null;
    case "IfStatement":
    case "WhileStatement":
      if (parent.test === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "ImportExpression":
      if (parent.source === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "SwitchStatement":
      if (parent.discriminant === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "WithStatement":
      if (parent.object === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    default:
      return null;
  }
}
function isParenthesized25(timesOrNode, nodeOrSourceCode, optionalSourceCode) {
  let times, node, sourceCode, maybeLeftParen, maybeRightParen;
  if (typeof timesOrNode === "number") {
    times = timesOrNode | 0;
    node = nodeOrSourceCode;
    sourceCode = optionalSourceCode;
    if (!(times >= 1)) {
      throw new TypeError("'times' should be a positive integer.");
    }
  } else {
    times = 1;
    node = timesOrNode;
    sourceCode = nodeOrSourceCode;
  }
  if (node == null || // `Program` can't be parenthesized
  node.parent == null || // `CatchClause.param` can't be parenthesized, example `try {} catch (error) {}`
  node.parent.type === "CatchClause" && node.parent.param === node) {
    return false;
  }
  maybeLeftParen = maybeRightParen = node;
  do {
    maybeLeftParen = sourceCode.getTokenBefore(maybeLeftParen);
    maybeRightParen = sourceCode.getTokenAfter(maybeRightParen);
  } while (maybeLeftParen != null && maybeRightParen != null && isOpeningParenToken25(maybeLeftParen) && isClosingParenToken25(maybeRightParen) && // Avoid false positive such as `if (a) {}`
  maybeLeftParen !== getParentSyntaxParen25(node, sourceCode) && --times > 0);
  return times === 0;
}
Function.call.bind(Object.hasOwnProperty);
var __defProp226 = Object.defineProperty;
var __export226 = (target, all3322) => {
  for (var name22 in all3322)
    __defProp226(target, name22, { get: all3322[name22], enumerable: true });
};
var NodeType25 = types.AST_NODE_TYPES;
var is25 = utils.ASTUtils.isNodeOfType;
var isOneOf25 = utils.ASTUtils.isNodeOfTypes;
isOneOf25([
  NodeType25.ArrowFunctionExpression,
  NodeType25.FunctionDeclaration,
  NodeType25.FunctionExpression
]);
isOneOf25([
  NodeType25.ArrowFunctionExpression,
  NodeType25.FunctionDeclaration,
  NodeType25.FunctionExpression,
  NodeType25.TSCallSignatureDeclaration,
  NodeType25.TSConstructSignatureDeclaration,
  NodeType25.TSDeclareFunction,
  NodeType25.TSEmptyBodyFunctionExpression,
  NodeType25.TSFunctionType,
  NodeType25.TSMethodSignature
]);
isOneOf25([NodeType25.ClassDeclaration, NodeType25.ClassExpression]);
isOneOf25([
  NodeType25.DoWhileStatement,
  NodeType25.ForInStatement,
  NodeType25.ForOfStatement,
  NodeType25.ForStatement,
  NodeType25.WhileStatement
]);
isOneOf25([NodeType25.TSArrayType, NodeType25.TSTupleType]);
isOneOf25([
  NodeType25.PropertyDefinition,
  NodeType25.TSIndexSignature,
  NodeType25.TSParameterProperty,
  NodeType25.TSPropertySignature
]);
is25(NodeType25.JSXElement);
is25(NodeType25.JSXFragment);
isOneOf25([
  NodeType25.JSXAttribute,
  NodeType25.JSXSpreadChild,
  NodeType25.JSXClosingElement,
  NodeType25.JSXClosingFragment,
  NodeType25.JSXElement,
  NodeType25.JSXEmptyExpression,
  NodeType25.JSXExpressionContainer,
  NodeType25.JSXFragment,
  NodeType25.JSXIdentifier,
  NodeType25.JSXMemberExpression,
  NodeType25.JSXNamespacedName,
  NodeType25.JSXOpeningElement,
  NodeType25.JSXOpeningFragment,
  NodeType25.JSXSpreadAttribute,
  NodeType25.JSXSpreadChild,
  NodeType25.JSXText
]);
isOneOf25([
  NodeType25.JSXIdentifier,
  NodeType25.JSXMemberExpression,
  NodeType25.JSXNamespacedName
]);
isOneOf25([
  NodeType25.ArrayPattern,
  NodeType25.AssignmentPattern,
  NodeType25.ObjectPattern,
  NodeType25.RestElement
]);
isOneOf25([
  NodeType25.TSInterfaceDeclaration,
  NodeType25.TSTypeAliasDeclaration
]);
isOneOf25([
  NodeType25.ArrayExpression,
  NodeType25.ArrayPattern,
  NodeType25.ArrowFunctionExpression,
  NodeType25.CallExpression,
  NodeType25.ClassExpression,
  NodeType25.FunctionExpression,
  NodeType25.Identifier,
  NodeType25.JSXElement,
  NodeType25.JSXFragment,
  NodeType25.Literal,
  NodeType25.TemplateLiteral,
  NodeType25.MemberExpression,
  NodeType25.MetaProperty,
  NodeType25.ObjectExpression,
  NodeType25.ObjectPattern,
  NodeType25.SequenceExpression,
  NodeType25.Super,
  NodeType25.TaggedTemplateExpression,
  NodeType25.ThisExpression
]);
isOneOf25([
  NodeType25.ArrayExpression,
  NodeType25.ArrayPattern,
  NodeType25.ArrowFunctionExpression,
  NodeType25.CallExpression,
  NodeType25.ClassExpression,
  NodeType25.FunctionExpression,
  NodeType25.Identifier,
  NodeType25.JSXElement,
  NodeType25.JSXFragment,
  NodeType25.Literal,
  NodeType25.TemplateLiteral,
  NodeType25.MemberExpression,
  NodeType25.MetaProperty,
  NodeType25.ObjectExpression,
  NodeType25.ObjectPattern,
  NodeType25.SequenceExpression,
  NodeType25.Super,
  NodeType25.TaggedTemplateExpression,
  NodeType25.ThisExpression,
  NodeType25.TSAsExpression,
  NodeType25.TSNonNullExpression,
  NodeType25.TSTypeAssertion
]);
var Function_exports27 = {};
__export226(Function_exports27, {
  SK: () => SK27,
  absurd: () => absurd27,
  apply: () => apply27,
  compose: () => compose35,
  constFalse: () => constFalse27,
  constNull: () => constNull27,
  constTrue: () => constTrue27,
  constUndefined: () => constUndefined27,
  constVoid: () => constVoid27,
  constant: () => constant27,
  dual: () => dual27,
  flip: () => flip27,
  flow: () => flow27,
  hole: () => hole27,
  identity: () => identity27,
  isFunction: () => isFunction227,
  pipe: () => pipe27,
  satisfies: () => satisfies27,
  tupled: () => tupled27,
  unsafeCoerce: () => unsafeCoerce27,
  untupled: () => untupled27
});
var isFunction227 = (input) => typeof input === "function";
var dual27 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a322, b322) {
        if (arguments.length >= 2) {
          return body(a322, b322);
        }
        return function(self2) {
          return body(self2, a322);
        };
      };
    case 3:
      return function(a322, b322, c322) {
        if (arguments.length >= 3) {
          return body(a322, b322, c322);
        }
        return function(self2) {
          return body(self2, a322, b322);
        };
      };
    case 4:
      return function(a322, b322, c322, d322) {
        if (arguments.length >= 4) {
          return body(a322, b322, c322, d322);
        }
        return function(self2) {
          return body(self2, a322, b322, c322);
        };
      };
    case 5:
      return function(a322, b322, c322, d322, e322) {
        if (arguments.length >= 5) {
          return body(a322, b322, c322, d322, e322);
        }
        return function(self2) {
          return body(self2, a322, b322, c322, d322);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply27 = (a322) => (self2) => self2(a322);
var identity27 = (a322) => a322;
var satisfies27 = () => (b322) => b322;
var unsafeCoerce27 = identity27;
var constant27 = (value) => () => value;
var constTrue27 = /* @__PURE__ */ constant27(true);
var constFalse27 = /* @__PURE__ */ constant27(false);
var constNull27 = /* @__PURE__ */ constant27(null);
var constUndefined27 = /* @__PURE__ */ constant27(void 0);
var constVoid27 = constUndefined27;
var flip27 = (f322) => (...b322) => (...a322) => f322(...a322)(...b322);
var compose35 = /* @__PURE__ */ dual27(2, (ab, bc) => (a322) => bc(ab(a322)));
var absurd27 = (_322) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled27 = (f322) => (a322) => f322(...a322);
var untupled27 = (f322) => (...a322) => f322(a322);
function pipe27(a322, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a322;
    case 2:
      return ab(a322);
    case 3:
      return bc(ab(a322));
    case 4:
      return cd(bc(ab(a322)));
    case 5:
      return de(cd(bc(ab(a322))));
    case 6:
      return ef(de(cd(bc(ab(a322)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a322))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a322)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a322))))))));
    default: {
      let ret = arguments[0];
      for (let i322 = 1; i322 < arguments.length; i322++) {
        ret = arguments[i322](ret);
      }
      return ret;
    }
  }
}
function flow27(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole27 = /* @__PURE__ */ unsafeCoerce27(absurd27);
var SK27 = (_322, b322) => b322;
var make65 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_37 = (map622) => dual27(3, (self2, name22, f322) => map622(self2, (a322) => Object.assign({}, a322, {
  [name22]: f322(a322)
})));
var bindTo37 = (map622) => dual27(2, (self2, name22) => map622(self2, (a322) => ({
  [name22]: a322
})));
var bind37 = (map622, flatMap4222) => dual27(3, (self2, name22, f322) => flatMap4222(self2, (a322) => map622(f322(a322), (b322) => Object.assign({}, a322, {
  [name22]: b322
}))));
var moduleVersion27 = "3.2.8";
var getCurrentVersion27 = () => moduleVersion27;
var globalStoreId27 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion27()}`);
if (!(globalStoreId27 in globalThis)) {
  globalThis[globalStoreId27] = /* @__PURE__ */ new Map();
}
var globalStore27 = globalThis[globalStoreId27];
var globalValue27 = (id, compute) => {
  if (!globalStore27.has(id)) {
    globalStore27.set(id, compute());
  }
  return globalStore27.get(id);
};
var Predicate_exports27 = {};
__export226(Predicate_exports27, {
  all: () => all35,
  and: () => and25,
  compose: () => compose227,
  eqv: () => eqv25,
  every: () => every25,
  hasProperty: () => hasProperty27,
  implies: () => implies25,
  isBigInt: () => isBigInt25,
  isBoolean: () => isBoolean25,
  isDate: () => isDate25,
  isError: () => isError25,
  isFunction: () => isFunction327,
  isIterable: () => isIterable25,
  isMap: () => isMap25,
  isNever: () => isNever25,
  isNotNull: () => isNotNull25,
  isNotNullable: () => isNotNullable25,
  isNotUndefined: () => isNotUndefined25,
  isNull: () => isNull25,
  isNullable: () => isNullable27,
  isNumber: () => isNumber25,
  isObject: () => isObject27,
  isPromise: () => isPromise25,
  isPromiseLike: () => isPromiseLike25,
  isReadonlyRecord: () => isReadonlyRecord25,
  isRecord: () => isRecord25,
  isSet: () => isSet25,
  isString: () => isString25,
  isSymbol: () => isSymbol25,
  isTagged: () => isTagged25,
  isTruthy: () => isTruthy25,
  isUint8Array: () => isUint8Array25,
  isUndefined: () => isUndefined25,
  isUnknown: () => isUnknown25,
  mapInput: () => mapInput25,
  nand: () => nand25,
  nor: () => nor25,
  not: () => not25,
  or: () => or25,
  product: () => product35,
  productMany: () => productMany35,
  some: () => some45,
  struct: () => struct45,
  tuple: () => tuple35,
  xor: () => xor25
});
var mapInput25 = /* @__PURE__ */ dual27(2, (self2, f322) => (b322) => self2(f322(b322)));
var isTruthy25 = (input) => !!input;
var isSet25 = (input) => input instanceof Set;
var isMap25 = (input) => input instanceof Map;
var isString25 = (input) => typeof input === "string";
var isNumber25 = (input) => typeof input === "number";
var isBoolean25 = (input) => typeof input === "boolean";
var isBigInt25 = (input) => typeof input === "bigint";
var isSymbol25 = (input) => typeof input === "symbol";
var isFunction327 = isFunction227;
var isUndefined25 = (input) => input === void 0;
var isNotUndefined25 = (input) => input !== void 0;
var isNull25 = (input) => input === null;
var isNotNull25 = (input) => input !== null;
var isNever25 = (_322) => false;
var isUnknown25 = (_322) => true;
var isRecordOrArray27 = (input) => typeof input === "object" && input !== null;
var isObject27 = (input) => isRecordOrArray27(input) || isFunction327(input);
var hasProperty27 = /* @__PURE__ */ dual27(2, (self2, property) => isObject27(self2) && property in self2);
var isTagged25 = /* @__PURE__ */ dual27(2, (self2, tag) => hasProperty27(self2, "_tag") && self2["_tag"] === tag);
var isNullable27 = (input) => input === null || input === void 0;
var isNotNullable25 = (input) => input !== null && input !== void 0;
var isError25 = (input) => input instanceof Error;
var isUint8Array25 = (input) => input instanceof Uint8Array;
var isDate25 = (input) => input instanceof Date;
var isIterable25 = (input) => hasProperty27(input, Symbol.iterator);
var isRecord25 = (input) => isRecordOrArray27(input) && !Array.isArray(input);
var isReadonlyRecord25 = isRecord25;
var isPromise25 = (input) => hasProperty27(input, "then") && "catch" in input && isFunction327(input.then) && isFunction327(input.catch);
var isPromiseLike25 = (input) => hasProperty27(input, "then") && isFunction327(input.then);
var compose227 = /* @__PURE__ */ dual27(2, (ab, bc) => (a322) => ab(a322) && bc(a322));
var product35 = (self2, that) => ([a322, b322]) => self2(a322) && that(b322);
var all35 = (collection) => {
  return (as2422) => {
    let collectionIndex = 0;
    for (const p322 of collection) {
      if (collectionIndex >= as2422.length) {
        break;
      }
      if (p322(as2422[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany35 = (self2, collection) => {
  const rest = all35(collection);
  return ([head222, ...tail322]) => self2(head222) === false ? false : rest(tail322);
};
var tuple35 = (...elements) => all35(elements);
var struct45 = (fields) => {
  const keys2322 = Object.keys(fields);
  return (a322) => {
    for (const key of keys2322) {
      if (!fields[key](a322[key])) {
        return false;
      }
    }
    return true;
  };
};
var not25 = (self2) => (a322) => !self2(a322);
var or25 = /* @__PURE__ */ dual27(2, (self2, that) => (a322) => self2(a322) || that(a322));
var and25 = /* @__PURE__ */ dual27(2, (self2, that) => (a322) => self2(a322) && that(a322));
var xor25 = /* @__PURE__ */ dual27(2, (self2, that) => (a322) => self2(a322) !== that(a322));
var eqv25 = /* @__PURE__ */ dual27(2, (self2, that) => (a322) => self2(a322) === that(a322));
var implies25 = /* @__PURE__ */ dual27(2, (self2, that) => (a322) => self2(a322) ? that(a322) : true);
var nor25 = /* @__PURE__ */ dual27(2, (self2, that) => (a322) => !(self2(a322) || that(a322)));
var nand25 = /* @__PURE__ */ dual27(2, (self2, that) => (a322) => !(self2(a322) && that(a322)));
var every25 = (collection) => (a322) => {
  for (const p322 of collection) {
    if (!p322(a322)) {
      return false;
    }
  }
  return true;
};
var some45 = (collection) => (a322) => {
  for (const p322 of collection) {
    if (p322(a322)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage27 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId27 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind27 = (u322) => isObject27(u322) && GenKindTypeId27 in u322;
var GenKindImpl27 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity27;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_322) => _322;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_322) => _322;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_322) => _322;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId27] = GenKindTypeId27;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen35(this);
  }
};
var SingleShotGen35 = class _SingleShotGen37 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a322) {
    return this.called ? {
      value: a322,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a322) {
    return {
      value: a322,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e322) {
    throw e322;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen37(this.self);
  }
};
var adapter37 = () => function() {
  let x322 = arguments[0];
  for (let i322 = 1; i322 < arguments.length; i322++) {
    x322 = arguments[i322](x322);
  }
  return new GenKindImpl27(x322);
};
var defaultIncHi27 = 335903614;
var defaultIncLo27 = 4150755663;
var MUL_HI27 = 1481765933 >>> 0;
var MUL_LO27 = 1284865837 >>> 0;
var BIT_5327 = 9007199254740992;
var BIT_2727 = 134217728;
var PCGRandom27 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable27(seedLo) && isNullable27(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable27(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable27(incLo) && isNullable27(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo27;
      incHi = this._state ? this._state[2] : defaultIncHi27;
    } else if (isNullable27(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add6427(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max322) {
    if (!max322) {
      return this._next();
    }
    max322 = max322 >>> 0;
    if ((max322 & max322 - 1) === 0) {
      return this._next() & max322 - 1;
    }
    let num = 0;
    const skew = (-max322 >>> 0) % max322 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max322;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_2727 + lo) / BIT_5327;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul6427(this._state, oldHi, oldLo, MUL_HI27, MUL_LO27);
    add6427(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul6427(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add6427(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId27 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap27 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId27]() {
    return this.#value;
  }
};
function yieldWrapGet27(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId27 in self2) {
    return self2[YieldWrapTypeId27]();
  }
  throw new Error(getBugErrorMessage27("yieldWrapGet"));
}
var structuralRegionState27 = /* @__PURE__ */ globalValue27("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache27 = /* @__PURE__ */ globalValue27(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr27 = /* @__PURE__ */ globalValue27(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom27());
var symbol37 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash27 = (self2) => {
  if (structuralRegionState27.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number27(self2);
    case "bigint":
      return string27(self2.toString(10));
    case "boolean":
      return string27(String(self2));
    case "symbol":
      return string27(String(self2));
    case "string":
      return string27(self2);
    case "undefined":
      return string27("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string27("null");
      } else if (self2 instanceof Date) {
        return hash27(self2.toISOString());
      } else if (isHash27(self2)) {
        return self2[symbol37]();
      } else {
        return random27(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random27 = (self2) => {
  if (!randomHashCache27.has(self2)) {
    randomHashCache27.set(self2, number27(pcgr27.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache27.get(self2);
};
var combine35 = (b322) => (self2) => self2 * 53 ^ b322;
var optimize27 = (n322) => n322 & 3221225471 | n322 >>> 1 & 1073741824;
var isHash27 = (u322) => hasProperty27(u322, symbol37);
var number27 = (n322) => {
  if (n322 !== n322 || n322 === Infinity) {
    return 0;
  }
  let h322 = n322 | 0;
  if (h322 !== n322) {
    h322 ^= n322 * 4294967295;
  }
  while (n322 > 4294967295) {
    h322 ^= n322 /= 4294967295;
  }
  return optimize27(n322);
};
var string27 = (str) => {
  let h322 = 5381, i322 = str.length;
  while (i322) {
    h322 = h322 * 33 ^ str.charCodeAt(--i322);
  }
  return optimize27(h322);
};
var structureKeys27 = (o322, keys2322) => {
  let h322 = 12289;
  for (let i322 = 0; i322 < keys2322.length; i322++) {
    h322 ^= pipe27(string27(keys2322[i322]), combine35(hash27(o322[keys2322[i322]])));
  }
  return optimize27(h322);
};
var structure27 = (o322) => structureKeys27(o322, Object.keys(o322));
var array35 = (arr) => {
  let h322 = 6151;
  for (let i322 = 0; i322 < arr.length; i322++) {
    h322 = pipe27(h322, combine35(hash27(arr[i322])));
  }
  return optimize27(h322);
};
var cached27 = function() {
  if (arguments.length === 1) {
    const self22 = arguments[0];
    return function(hash3222) {
      Object.defineProperty(self22, symbol37, {
        value() {
          return hash3222;
        },
        enumerable: false
      });
      return hash3222;
    };
  }
  const self2 = arguments[0];
  const hash2422 = arguments[1];
  Object.defineProperty(self2, symbol37, {
    value() {
      return hash2422;
    },
    enumerable: false
  });
  return hash2422;
};
var symbol227 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals27() {
  if (arguments.length === 1) {
    return (self2) => compareBoth27(self2, arguments[0]);
  }
  return compareBoth27(arguments[0], arguments[1]);
}
function compareBoth27(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual27(self2) && isEqual27(that)) {
        if (hash27(self2) === hash27(that) && self2[symbol227](that)) {
          return true;
        } else {
          return structuralRegionState27.enabled && structuralRegionState27.tester ? structuralRegionState27.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState27.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v322, i322) => compareBoth27(v322, that[i322]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth27(self2[key], that[key]))) {
              return structuralRegionState27.tester ? structuralRegionState27.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState27.tester ? structuralRegionState27.tester(self2, that) : false;
    }
  }
  return structuralRegionState27.enabled && structuralRegionState27.tester ? structuralRegionState27.tester(self2, that) : false;
}
var isEqual27 = (u322) => hasProperty27(u322, symbol227);
var equivalence27 = () => equals27;
var NodeInspectSymbol27 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON27 = (x322) => {
  if (hasProperty27(x322, "toJSON") && isFunction327(x322["toJSON"]) && x322["toJSON"].length === 0) {
    return x322.toJSON();
  } else if (Array.isArray(x322)) {
    return x322.map(toJSON27);
  }
  return x322;
};
var format27 = (x322) => JSON.stringify(x322, null, 2);
var pipeArguments27 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i322 = 0, len = args.length; i322 < len; i322++) {
        ret = args[i322](ret);
      }
      return ret;
    }
  }
};
var OP_COMMIT27 = "Commit";
var OP_FAILURE25 = "Failure";
var OP_WITH_RUNTIME25 = "WithRuntime";
var EffectTypeId35 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId27 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId27 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId27 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance27 = {
  /* c8 ignore next */
  _R: (_322) => _322,
  /* c8 ignore next */
  _E: (_322) => _322,
  /* c8 ignore next */
  _A: (_322) => _322,
  _V: /* @__PURE__ */ getCurrentVersion27()
};
var sinkVariance27 = {
  /* c8 ignore next */
  _A: (_322) => _322,
  /* c8 ignore next */
  _In: (_322) => _322,
  /* c8 ignore next */
  _L: (_322) => _322,
  /* c8 ignore next */
  _E: (_322) => _322,
  /* c8 ignore next */
  _R: (_322) => _322
};
var channelVariance27 = {
  /* c8 ignore next */
  _Env: (_322) => _322,
  /* c8 ignore next */
  _InErr: (_322) => _322,
  /* c8 ignore next */
  _InElem: (_322) => _322,
  /* c8 ignore next */
  _InDone: (_322) => _322,
  /* c8 ignore next */
  _OutErr: (_322) => _322,
  /* c8 ignore next */
  _OutElem: (_322) => _322,
  /* c8 ignore next */
  _OutDone: (_322) => _322
};
var EffectPrototype27 = {
  [EffectTypeId35]: effectVariance27,
  [StreamTypeId27]: effectVariance27,
  [SinkTypeId27]: sinkVariance27,
  [ChannelTypeId27]: channelVariance27,
  [symbol227](that) {
    return this === that;
  },
  [symbol37]() {
    return cached27(this, random27(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen35(new YieldWrap27(this));
  },
  pipe() {
    return pipeArguments27(this, arguments);
  }
};
var StructuralPrototype27 = {
  [symbol37]() {
    return cached27(this, structure27(this));
  },
  [symbol227](that) {
    const selfKeys = Object.keys(this);
    const thatKeys = Object.keys(that);
    if (selfKeys.length !== thatKeys.length) {
      return false;
    }
    for (const key of selfKeys) {
      if (!(key in that && equals27(this[key], that[key]))) {
        return false;
      }
    }
    return true;
  }
};
var CommitPrototype27 = {
  ...EffectPrototype27,
  _op: OP_COMMIT27
};
var StructuralCommitPrototype27 = {
  ...CommitPrototype27,
  ...StructuralPrototype27
};
var TypeId65 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto37 = {
  ...EffectPrototype27,
  [TypeId65]: {
    _A: (_322) => _322
  },
  [NodeInspectSymbol27]() {
    return this.toJSON();
  },
  toString() {
    return format27(this.toJSON());
  }
};
var SomeProto27 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto37), {
  _tag: "Some",
  _op: "Some",
  [symbol227](that) {
    return isOption37(that) && isSome37(that) && equals27(this.value, that.value);
  },
  [symbol37]() {
    return cached27(this, combine35(hash27(this._tag))(hash27(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON27(this.value)
    };
  }
});
var NoneHash27 = /* @__PURE__ */ hash27("None");
var NoneProto27 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto37), {
  _tag: "None",
  _op: "None",
  [symbol227](that) {
    return isOption37(that) && isNone37(that);
  },
  [symbol37]() {
    return NoneHash27;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption37 = (input) => hasProperty27(input, TypeId65);
var isNone37 = (fa) => fa._tag === "None";
var isSome37 = (fa) => fa._tag === "Some";
var none37 = /* @__PURE__ */ Object.create(NoneProto27);
var some227 = (value) => {
  const a322 = Object.create(SomeProto27);
  a322.value = value;
  return a322;
};
var TypeId227 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto227 = {
  ...EffectPrototype27,
  [TypeId227]: {
    _R: (_322) => _322
  },
  [NodeInspectSymbol27]() {
    return this.toJSON();
  },
  toString() {
    return format27(this.toJSON());
  }
};
var RightProto27 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto227), {
  _tag: "Right",
  _op: "Right",
  [symbol227](that) {
    return isEither27(that) && isRight27(that) && equals27(this.right, that.right);
  },
  [symbol37]() {
    return combine35(hash27(this._tag))(hash27(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON27(this.right)
    };
  }
});
var LeftProto27 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto227), {
  _tag: "Left",
  _op: "Left",
  [symbol227](that) {
    return isEither27(that) && isLeft27(that) && equals27(this.left, that.left);
  },
  [symbol37]() {
    return combine35(hash27(this._tag))(hash27(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON27(this.left)
    };
  }
});
var isEither27 = (input) => hasProperty27(input, TypeId227);
var isLeft27 = (ma) => ma._tag === "Left";
var isRight27 = (ma) => ma._tag === "Right";
var left35 = (left3322) => {
  const a322 = Object.create(LeftProto27);
  a322.left = left3322;
  return a322;
};
var right35 = (right3322) => {
  const a322 = Object.create(RightProto27);
  a322.right = right3322;
  return a322;
};
var getLeft37 = (self2) => isRight27(self2) ? none37 : some227(self2.left);
var getRight37 = (self2) => isLeft27(self2) ? none37 : some227(self2.right);
var right227 = right35;
var left227 = left35;
var Option_exports27 = {};
__export226(Option_exports27, {
  Do: () => Do27,
  TypeId: () => TypeId327,
  all: () => all227,
  andThen: () => andThen27,
  ap: () => ap27,
  as: () => as27,
  asVoid: () => asVoid27,
  bind: () => bind227,
  bindTo: () => bindTo227,
  composeK: () => composeK27,
  contains: () => contains27,
  containsWith: () => containsWith27,
  exists: () => exists27,
  filter: () => filter27,
  filterMap: () => filterMap27,
  firstSomeOf: () => firstSomeOf27,
  flatMap: () => flatMap27,
  flatMapNullable: () => flatMapNullable27,
  flatten: () => flatten27,
  fromIterable: () => fromIterable35,
  fromNullable: () => fromNullable27,
  gen: () => gen27,
  getEquivalence: () => getEquivalence35,
  getLeft: () => getLeft227,
  getOrElse: () => getOrElse27,
  getOrNull: () => getOrNull27,
  getOrThrow: () => getOrThrow27,
  getOrThrowWith: () => getOrThrowWith27,
  getOrUndefined: () => getOrUndefined27,
  getOrder: () => getOrder27,
  getRight: () => getRight227,
  isNone: () => isNone227,
  isOption: () => isOption227,
  isSome: () => isSome227,
  let: () => let_227,
  lift2: () => lift227,
  liftNullable: () => liftNullable27,
  liftPredicate: () => liftPredicate27,
  liftThrowable: () => liftThrowable27,
  map: () => map27,
  match: () => match225,
  none: () => none227,
  orElse: () => orElse27,
  orElseEither: () => orElseEither27,
  orElseSome: () => orElseSome27,
  partitionMap: () => partitionMap27,
  product: () => product227,
  productMany: () => productMany227,
  reduceCompact: () => reduceCompact27,
  some: () => some327,
  tap: () => tap27,
  toArray: () => toArray27,
  toRefinement: () => toRefinement27,
  void: () => void_27,
  zipLeft: () => zipLeft27,
  zipRight: () => zipRight27,
  zipWith: () => zipWith27
});
var make227 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId327 = /* @__PURE__ */ Symbol.for("effect/Option");
var none227 = () => none37;
var some327 = some227;
var isOption227 = isOption37;
var isNone227 = isNone37;
var isSome227 = isSome37;
var match225 = /* @__PURE__ */ dual27(2, (self2, {
  onNone,
  onSome
}) => isNone227(self2) ? onNone() : onSome(self2.value));
var toRefinement27 = (f322) => (a322) => isSome227(f322(a322));
var fromIterable35 = (collection) => {
  for (const a322 of collection) {
    return some327(a322);
  }
  return none227();
};
var getRight227 = getRight37;
var getLeft227 = getLeft37;
var getOrElse27 = /* @__PURE__ */ dual27(2, (self2, onNone) => isNone227(self2) ? onNone() : self2.value);
var orElse27 = /* @__PURE__ */ dual27(2, (self2, that) => isNone227(self2) ? that() : self2);
var orElseSome27 = /* @__PURE__ */ dual27(2, (self2, onNone) => isNone227(self2) ? some327(onNone()) : self2);
var orElseEither27 = /* @__PURE__ */ dual27(2, (self2, that) => isNone227(self2) ? map27(that(), right35) : map27(self2, left35));
var firstSomeOf27 = (collection) => {
  let out = none227();
  for (out of collection) {
    if (isSome227(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable27 = (nullableValue) => nullableValue == null ? none227() : some327(nullableValue);
var liftNullable27 = (f322) => (...a322) => fromNullable27(f322(...a322));
var getOrNull27 = /* @__PURE__ */ getOrElse27(constNull27);
var getOrUndefined27 = /* @__PURE__ */ getOrElse27(constUndefined27);
var liftThrowable27 = (f322) => (...a322) => {
  try {
    return some327(f322(...a322));
  } catch (e322) {
    return none227();
  }
};
var getOrThrowWith27 = /* @__PURE__ */ dual27(2, (self2, onNone) => {
  if (isSome227(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow27 = /* @__PURE__ */ getOrThrowWith27(() => new Error("getOrThrow called on a None"));
var map27 = /* @__PURE__ */ dual27(2, (self2, f322) => isNone227(self2) ? none227() : some327(f322(self2.value)));
var as27 = /* @__PURE__ */ dual27(2, (self2, b322) => map27(self2, () => b322));
var asVoid27 = /* @__PURE__ */ as27(void 0);
var void_27 = /* @__PURE__ */ some327(void 0);
var flatMap27 = /* @__PURE__ */ dual27(2, (self2, f322) => isNone227(self2) ? none227() : f322(self2.value));
var andThen27 = /* @__PURE__ */ dual27(2, (self2, f322) => flatMap27(self2, (a322) => {
  const b322 = isFunction227(f322) ? f322(a322) : f322;
  return isOption227(b322) ? b322 : some327(b322);
}));
var flatMapNullable27 = /* @__PURE__ */ dual27(2, (self2, f322) => isNone227(self2) ? none227() : fromNullable27(f322(self2.value)));
var flatten27 = /* @__PURE__ */ flatMap27(identity27);
var zipRight27 = /* @__PURE__ */ dual27(2, (self2, that) => flatMap27(self2, () => that));
var composeK27 = /* @__PURE__ */ dual27(2, (afb, bfc) => (a322) => flatMap27(afb(a322), bfc));
var zipLeft27 = /* @__PURE__ */ dual27(2, (self2, that) => tap27(self2, () => that));
var tap27 = /* @__PURE__ */ dual27(2, (self2, f322) => flatMap27(self2, (a322) => map27(f322(a322), () => a322)));
var product227 = (self2, that) => isSome227(self2) && isSome227(that) ? some327([self2.value, that.value]) : none227();
var productMany227 = (self2, collection) => {
  if (isNone227(self2)) {
    return none227();
  }
  const out = [self2.value];
  for (const o322 of collection) {
    if (isNone227(o322)) {
      return none227();
    }
    out.push(o322.value);
  }
  return some327(out);
};
var all227 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o322 of input) {
      if (isNone227(o322)) {
        return none227();
      }
      out2.push(o322.value);
    }
    return some327(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o322 = input[key];
    if (isNone227(o322)) {
      return none227();
    }
    out[key] = o322.value;
  }
  return some327(out);
};
var zipWith27 = /* @__PURE__ */ dual27(3, (self2, that, f322) => map27(product227(self2, that), ([a322, b322]) => f322(a322, b322)));
var ap27 = /* @__PURE__ */ dual27(2, (self2, that) => zipWith27(self2, that, (f322, a322) => f322(a322)));
var reduceCompact27 = /* @__PURE__ */ dual27(3, (self2, b322, f322) => {
  let out = b322;
  for (const oa of self2) {
    if (isSome227(oa)) {
      out = f322(out, oa.value);
    }
  }
  return out;
});
var toArray27 = (self2) => isNone227(self2) ? [] : [self2.value];
var partitionMap27 = /* @__PURE__ */ dual27(2, (self2, f322) => {
  if (isNone227(self2)) {
    return [none227(), none227()];
  }
  const e322 = f322(self2.value);
  return isLeft27(e322) ? [some327(e322.left), none227()] : [none227(), some327(e322.right)];
});
var filterMap27 = /* @__PURE__ */ dual27(2, (self2, f322) => isNone227(self2) ? none227() : f322(self2.value));
var filter27 = /* @__PURE__ */ dual27(2, (self2, predicate) => filterMap27(self2, (b322) => predicate(b322) ? some227(b322) : none37));
var getEquivalence35 = (isEquivalent) => make65((x322, y322) => x322 === y322 || (isNone227(x322) ? isNone227(y322) : isNone227(y322) ? false : isEquivalent(x322.value, y322.value)));
var getOrder27 = (O322) => make227((self2, that) => isSome227(self2) ? isSome227(that) ? O322(self2.value, that.value) : 1 : -1);
var lift227 = (f322) => dual27(2, (self2, that) => zipWith27(self2, that, f322));
var liftPredicate27 = (predicate) => (b322) => predicate(b322) ? some327(b322) : none227();
var containsWith27 = (isEquivalent) => dual27(2, (self2, a322) => isNone227(self2) ? false : isEquivalent(self2.value, a322));
var _equivalence35 = /* @__PURE__ */ equivalence27();
var contains27 = /* @__PURE__ */ containsWith27(_equivalence35);
var exists27 = /* @__PURE__ */ dual27(2, (self2, refinement) => isNone227(self2) ? false : refinement(self2.value));
var bindTo227 = /* @__PURE__ */ bindTo37(map27);
var let_227 = /* @__PURE__ */ let_37(map27);
var bind227 = /* @__PURE__ */ bind37(map27, flatMap27);
var Do27 = /* @__PURE__ */ some327({});
var adapter227 = /* @__PURE__ */ adapter37();
var gen27 = (f322) => {
  const iterator = f322(adapter227);
  let state = iterator.next();
  if (state.done) {
    return some327(state.value);
  } else {
    let current = state.value;
    if (isGenKind27(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet27(current);
    }
    if (isNone227(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind27(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet27(current);
        }
        if (isNone227(current)) {
          return current;
        }
      }
    }
    return some327(state.value);
  }
};
var fromIterable227 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var reverse35 = (self2) => Array.from(self2).reverse();
var reduce35 = /* @__PURE__ */ dual27(3, (self2, b322, f322) => fromIterable227(self2).reduce((b2222, a322, i322) => f322(b2222, a322, i322), b322));
var TagTypeId25 = /* @__PURE__ */ Symbol.for("effect/Context/Tag");
var STMSymbolKey25 = "effect/STM";
var STMTypeId25 = /* @__PURE__ */ Symbol.for(STMSymbolKey25);
var TagProto25 = {
  ...EffectPrototype27,
  _tag: "Tag",
  _op: "Tag",
  [STMTypeId25]: effectVariance27,
  [TagTypeId25]: {
    _Service: (_322) => _322,
    _Identifier: (_322) => _322
  },
  toString() {
    return format27(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Tag",
      key: this.key,
      stack: this.stack
    };
  },
  [NodeInspectSymbol27]() {
    return this.toJSON();
  },
  of(self2) {
    return self2;
  },
  context(self2) {
    return make327(this, self2);
  }
};
var makeGenericTag25 = (key) => {
  const limit = Error.stackTraceLimit;
  Error.stackTraceLimit = 2;
  const creationError = new Error();
  Error.stackTraceLimit = limit;
  const tag = Object.create(TagProto25);
  Object.defineProperty(tag, "stack", {
    get() {
      return creationError.stack;
    }
  });
  tag.key = key;
  return tag;
};
var TypeId427 = /* @__PURE__ */ Symbol.for("effect/Context");
var ContextProto25 = {
  [TypeId427]: {
    _Services: (_322) => _322
  },
  [symbol227](that) {
    if (isContext25(that)) {
      if (this.unsafeMap.size === that.unsafeMap.size) {
        for (const k322 of this.unsafeMap.keys()) {
          if (!that.unsafeMap.has(k322) || !equals27(this.unsafeMap.get(k322), that.unsafeMap.get(k322))) {
            return false;
          }
        }
        return true;
      }
    }
    return false;
  },
  [symbol37]() {
    return cached27(this, number27(this.unsafeMap.size));
  },
  pipe() {
    return pipeArguments27(this, arguments);
  },
  toString() {
    return format27(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Context",
      services: Array.from(this.unsafeMap).map(toJSON27)
    };
  },
  [NodeInspectSymbol27]() {
    return this.toJSON();
  }
};
var makeContext25 = (unsafeMap) => {
  const context = Object.create(ContextProto25);
  context.unsafeMap = unsafeMap;
  return context;
};
var isContext25 = (u322) => hasProperty27(u322, TypeId427);
var _empty65 = /* @__PURE__ */ makeContext25(/* @__PURE__ */ new Map());
var empty85 = () => _empty65;
var make327 = (tag, service) => makeContext25(/* @__PURE__ */ new Map([[tag.key, service]]));
var GenericTag25 = makeGenericTag25;
var empty225 = empty85;
var TypeId527 = /* @__PURE__ */ Symbol.for("effect/Chunk");
function copy25(src, srcPos, dest, destPos, len) {
  for (let i322 = srcPos; i322 < Math.min(src.length, srcPos + len); i322++) {
    dest[destPos + i322 - srcPos] = src[i322];
  }
  return dest;
}
var emptyArray25 = [];
var getEquivalence227 = (isEquivalent) => make65((self2, that) => self2.length === that.length && toReadonlyArray25(self2).every((value, i322) => isEquivalent(value, unsafeGet225(that, i322))));
var _equivalence227 = /* @__PURE__ */ getEquivalence227(equals27);
var ChunkProto25 = {
  [TypeId527]: {
    _A: (_322) => _322
  },
  toString() {
    return format27(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Chunk",
      values: toReadonlyArray25(this).map(toJSON27)
    };
  },
  [NodeInspectSymbol27]() {
    return this.toJSON();
  },
  [symbol227](that) {
    return isChunk25(that) && _equivalence227(this, that);
  },
  [symbol37]() {
    return cached27(this, array35(toReadonlyArray25(this)));
  },
  [Symbol.iterator]() {
    switch (this.backing._tag) {
      case "IArray": {
        return this.backing.array[Symbol.iterator]();
      }
      case "IEmpty": {
        return emptyArray25[Symbol.iterator]();
      }
      default: {
        return toReadonlyArray25(this)[Symbol.iterator]();
      }
    }
  },
  pipe() {
    return pipeArguments27(this, arguments);
  }
};
var makeChunk25 = (backing) => {
  const chunk = Object.create(ChunkProto25);
  chunk.backing = backing;
  switch (backing._tag) {
    case "IEmpty": {
      chunk.length = 0;
      chunk.depth = 0;
      chunk.left = chunk;
      chunk.right = chunk;
      break;
    }
    case "IConcat": {
      chunk.length = backing.left.length + backing.right.length;
      chunk.depth = 1 + Math.max(backing.left.depth, backing.right.depth);
      chunk.left = backing.left;
      chunk.right = backing.right;
      break;
    }
    case "IArray": {
      chunk.length = backing.array.length;
      chunk.depth = 0;
      chunk.left = _empty225;
      chunk.right = _empty225;
      break;
    }
    case "ISingleton": {
      chunk.length = 1;
      chunk.depth = 0;
      chunk.left = _empty225;
      chunk.right = _empty225;
      break;
    }
    case "ISlice": {
      chunk.length = backing.length;
      chunk.depth = backing.chunk.depth + 1;
      chunk.left = _empty225;
      chunk.right = _empty225;
      break;
    }
  }
  return chunk;
};
var isChunk25 = (u322) => hasProperty27(u322, TypeId527);
var _empty225 = /* @__PURE__ */ makeChunk25({
  _tag: "IEmpty"
});
var empty325 = () => _empty225;
var make427 = (...as2422) => as2422.length === 1 ? of25(as2422[0]) : unsafeFromNonEmptyArray25(as2422);
var of25 = (a322) => makeChunk25({
  _tag: "ISingleton",
  a: a322
});
var copyToArray25 = (self2, array3322, initial) => {
  switch (self2.backing._tag) {
    case "IArray": {
      copy25(self2.backing.array, 0, array3322, initial, self2.length);
      break;
    }
    case "IConcat": {
      copyToArray25(self2.left, array3322, initial);
      copyToArray25(self2.right, array3322, initial + self2.left.length);
      break;
    }
    case "ISingleton": {
      array3322[initial] = self2.backing.a;
      break;
    }
    case "ISlice": {
      let i322 = 0;
      let j322 = initial;
      while (i322 < self2.length) {
        array3322[j322] = unsafeGet225(self2, i322);
        i322 += 1;
        j322 += 1;
      }
      break;
    }
  }
};
var toReadonlyArray25 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      return emptyArray25;
    }
    case "IArray": {
      return self2.backing.array;
    }
    default: {
      const arr = new Array(self2.length);
      copyToArray25(self2, arr, 0);
      self2.backing = {
        _tag: "IArray",
        array: arr
      };
      self2.left = _empty225;
      self2.right = _empty225;
      self2.depth = 0;
      return arr;
    }
  }
};
var reverse225 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty":
    case "ISingleton":
      return self2;
    case "IArray": {
      return makeChunk25({
        _tag: "IArray",
        array: reverse35(self2.backing.array)
      });
    }
    case "IConcat": {
      return makeChunk25({
        _tag: "IConcat",
        left: reverse225(self2.backing.right),
        right: reverse225(self2.backing.left)
      });
    }
    case "ISlice":
      return unsafeFromArray25(reverse35(toReadonlyArray25(self2)));
  }
};
var unsafeFromArray25 = (self2) => makeChunk25({
  _tag: "IArray",
  array: self2
});
var unsafeFromNonEmptyArray25 = (self2) => unsafeFromArray25(self2);
var unsafeGet225 = /* @__PURE__ */ dual27(2, (self2, index) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      throw new Error(`Index out of bounds`);
    }
    case "ISingleton": {
      if (index !== 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.a;
    }
    case "IArray": {
      if (index >= self2.length || index < 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.array[index];
    }
    case "IConcat": {
      return index < self2.left.length ? unsafeGet225(self2.left, index) : unsafeGet225(self2.right, index - self2.left.length);
    }
    case "ISlice": {
      return unsafeGet225(self2.backing.chunk, index + self2.backing.offset);
    }
  }
});
var prepend25 = /* @__PURE__ */ dual27(2, (self2, elem) => appendAll25(of25(elem), self2));
var drop25 = /* @__PURE__ */ dual27(2, (self2, n322) => {
  if (n322 <= 0) {
    return self2;
  } else if (n322 >= self2.length) {
    return _empty225;
  } else {
    switch (self2.backing._tag) {
      case "ISlice": {
        return makeChunk25({
          _tag: "ISlice",
          chunk: self2.backing.chunk,
          offset: self2.backing.offset + n322,
          length: self2.backing.length - n322
        });
      }
      case "IConcat": {
        if (n322 > self2.left.length) {
          return drop25(self2.right, n322 - self2.left.length);
        }
        return makeChunk25({
          _tag: "IConcat",
          left: drop25(self2.left, n322),
          right: self2.right
        });
      }
      default: {
        return makeChunk25({
          _tag: "ISlice",
          chunk: self2,
          offset: n322,
          length: self2.length - n322
        });
      }
    }
  }
});
var appendAll25 = /* @__PURE__ */ dual27(2, (self2, that) => {
  if (self2.backing._tag === "IEmpty") {
    return that;
  }
  if (that.backing._tag === "IEmpty") {
    return self2;
  }
  const diff2322 = that.depth - self2.depth;
  if (Math.abs(diff2322) <= 1) {
    return makeChunk25({
      _tag: "IConcat",
      left: self2,
      right: that
    });
  } else if (diff2322 < -1) {
    if (self2.left.depth >= self2.right.depth) {
      const nr = appendAll25(self2.right, that);
      return makeChunk25({
        _tag: "IConcat",
        left: self2.left,
        right: nr
      });
    } else {
      const nrr = appendAll25(self2.right.right, that);
      if (nrr.depth === self2.depth - 3) {
        const nr = makeChunk25({
          _tag: "IConcat",
          left: self2.right.left,
          right: nrr
        });
        return makeChunk25({
          _tag: "IConcat",
          left: self2.left,
          right: nr
        });
      } else {
        const nl = makeChunk25({
          _tag: "IConcat",
          left: self2.left,
          right: self2.right.left
        });
        return makeChunk25({
          _tag: "IConcat",
          left: nl,
          right: nrr
        });
      }
    }
  } else {
    if (that.right.depth >= that.left.depth) {
      const nl = appendAll25(self2, that.left);
      return makeChunk25({
        _tag: "IConcat",
        left: nl,
        right: that.right
      });
    } else {
      const nll = appendAll25(self2, that.left.left);
      if (nll.depth === that.depth - 3) {
        const nl = makeChunk25({
          _tag: "IConcat",
          left: nll,
          right: that.left.right
        });
        return makeChunk25({
          _tag: "IConcat",
          left: nl,
          right: that.right
        });
      } else {
        const nr = makeChunk25({
          _tag: "IConcat",
          left: that.left.right,
          right: that.right
        });
        return makeChunk25({
          _tag: "IConcat",
          left: nll,
          right: nr
        });
      }
    }
  }
});
var isEmpty25 = (self2) => self2.length === 0;
var isNonEmpty25 = (self2) => self2.length > 0;
var unsafeHead25 = (self2) => unsafeGet225(self2, 0);
var headNonEmpty25 = unsafeHead25;
var tailNonEmpty25 = (self2) => drop25(self2, 1);
var SIZE25 = 5;
var BUCKET_SIZE25 = /* @__PURE__ */ Math.pow(2, SIZE25);
var MASK25 = BUCKET_SIZE25 - 1;
var MAX_INDEX_NODE25 = BUCKET_SIZE25 / 2;
var MIN_ARRAY_NODE25 = BUCKET_SIZE25 / 4;
function popcount25(x322) {
  x322 -= x322 >> 1 & 1431655765;
  x322 = (x322 & 858993459) + (x322 >> 2 & 858993459);
  x322 = x322 + (x322 >> 4) & 252645135;
  x322 += x322 >> 8;
  x322 += x322 >> 16;
  return x322 & 127;
}
function hashFragment25(shift22, h322) {
  return h322 >>> shift22 & MASK25;
}
function toBitmap25(x322) {
  return 1 << x322;
}
function fromBitmap25(bitmap, bit) {
  return popcount25(bitmap & bit - 1);
}
var make525 = (value, previous) => ({
  value,
  previous
});
function arrayUpdate25(mutate2322, at, v322, arr) {
  let out = arr;
  if (!mutate2322) {
    const len = arr.length;
    out = new Array(len);
    for (let i322 = 0; i322 < len; ++i322) out[i322] = arr[i322];
  }
  out[at] = v322;
  return out;
}
function arraySpliceOut25(mutate2322, at, arr) {
  const newLen = arr.length - 1;
  let i322 = 0;
  let g322 = 0;
  let out = arr;
  if (mutate2322) {
    i322 = g322 = at;
  } else {
    out = new Array(newLen);
    while (i322 < at) out[g322++] = arr[i322++];
  }
  ++i322;
  while (i322 <= newLen) out[g322++] = arr[i322++];
  if (mutate2322) {
    out.length = newLen;
  }
  return out;
}
function arraySpliceIn25(mutate2322, at, v322, arr) {
  const len = arr.length;
  if (mutate2322) {
    let i2222 = len;
    while (i2222 >= at) arr[i2222--] = arr[i2222];
    arr[at] = v322;
    return arr;
  }
  let i322 = 0, g322 = 0;
  const out = new Array(len + 1);
  while (i322 < at) out[g322++] = arr[i322++];
  out[at] = v322;
  while (i322 < len) out[++g322] = arr[i322++];
  return out;
}
var EmptyNode25 = class _EmptyNode25 {
  _tag = "EmptyNode";
  modify(edit, _shift, f322, hash2422, key, size4322) {
    const v322 = f322(none227());
    if (isNone227(v322)) return new _EmptyNode25();
    ++size4322.value;
    return new LeafNode25(edit, hash2422, key, v322);
  }
};
function isEmptyNode25(a322) {
  return isTagged25(a322, "EmptyNode");
}
function isLeafNode25(node) {
  return isEmptyNode25(node) || node._tag === "LeafNode" || node._tag === "CollisionNode";
}
function canEditNode25(node, edit) {
  return isEmptyNode25(node) ? false : edit === node.edit;
}
var LeafNode25 = class _LeafNode25 {
  edit;
  hash;
  key;
  value;
  _tag = "LeafNode";
  constructor(edit, hash2422, key, value) {
    this.edit = edit;
    this.hash = hash2422;
    this.key = key;
    this.value = value;
  }
  modify(edit, shift22, f322, hash2422, key, size4322) {
    if (equals27(key, this.key)) {
      const v2222 = f322(this.value);
      if (v2222 === this.value) return this;
      else if (isNone227(v2222)) {
        --size4322.value;
        return new EmptyNode25();
      }
      if (canEditNode25(this, edit)) {
        this.value = v2222;
        return this;
      }
      return new _LeafNode25(edit, hash2422, key, v2222);
    }
    const v322 = f322(none227());
    if (isNone227(v322)) return this;
    ++size4322.value;
    return mergeLeaves25(edit, shift22, this.hash, this, hash2422, new _LeafNode25(edit, hash2422, key, v322));
  }
};
var CollisionNode25 = class _CollisionNode25 {
  edit;
  hash;
  children;
  _tag = "CollisionNode";
  constructor(edit, hash2422, children) {
    this.edit = edit;
    this.hash = hash2422;
    this.children = children;
  }
  modify(edit, shift22, f322, hash2422, key, size4322) {
    if (hash2422 === this.hash) {
      const canEdit = canEditNode25(this, edit);
      const list = this.updateCollisionList(canEdit, edit, this.hash, this.children, f322, key, size4322);
      if (list === this.children) return this;
      return list.length > 1 ? new _CollisionNode25(edit, this.hash, list) : list[0];
    }
    const v322 = f322(none227());
    if (isNone227(v322)) return this;
    ++size4322.value;
    return mergeLeaves25(edit, shift22, this.hash, this, hash2422, new LeafNode25(edit, hash2422, key, v322));
  }
  updateCollisionList(mutate2322, edit, hash2422, list, f322, key, size4322) {
    const len = list.length;
    for (let i322 = 0; i322 < len; ++i322) {
      const child = list[i322];
      if ("key" in child && equals27(key, child.key)) {
        const value = child.value;
        const newValue2 = f322(value);
        if (newValue2 === value) return list;
        if (isNone227(newValue2)) {
          --size4322.value;
          return arraySpliceOut25(mutate2322, i322, list);
        }
        return arrayUpdate25(mutate2322, i322, new LeafNode25(edit, hash2422, key, newValue2), list);
      }
    }
    const newValue = f322(none227());
    if (isNone227(newValue)) return list;
    ++size4322.value;
    return arrayUpdate25(mutate2322, len, new LeafNode25(edit, hash2422, key, newValue), list);
  }
};
var IndexedNode25 = class _IndexedNode25 {
  edit;
  mask;
  children;
  _tag = "IndexedNode";
  constructor(edit, mask, children) {
    this.edit = edit;
    this.mask = mask;
    this.children = children;
  }
  modify(edit, shift22, f322, hash2422, key, size4322) {
    const mask = this.mask;
    const children = this.children;
    const frag = hashFragment25(shift22, hash2422);
    const bit = toBitmap25(frag);
    const indx = fromBitmap25(mask, bit);
    const exists2422 = mask & bit;
    const canEdit = canEditNode25(this, edit);
    if (!exists2422) {
      const _newChild = new EmptyNode25().modify(edit, shift22 + SIZE25, f322, hash2422, key, size4322);
      if (!_newChild) return this;
      return children.length >= MAX_INDEX_NODE25 ? expand25(edit, frag, _newChild, mask, children) : new _IndexedNode25(edit, mask | bit, arraySpliceIn25(canEdit, indx, _newChild, children));
    }
    const current = children[indx];
    const child = current.modify(edit, shift22 + SIZE25, f322, hash2422, key, size4322);
    if (current === child) return this;
    let bitmap = mask;
    let newChildren;
    if (isEmptyNode25(child)) {
      bitmap &= ~bit;
      if (!bitmap) return new EmptyNode25();
      if (children.length <= 2 && isLeafNode25(children[indx ^ 1])) {
        return children[indx ^ 1];
      }
      newChildren = arraySpliceOut25(canEdit, indx, children);
    } else {
      newChildren = arrayUpdate25(canEdit, indx, child, children);
    }
    if (canEdit) {
      this.mask = bitmap;
      this.children = newChildren;
      return this;
    }
    return new _IndexedNode25(edit, bitmap, newChildren);
  }
};
var ArrayNode25 = class _ArrayNode25 {
  edit;
  size;
  children;
  _tag = "ArrayNode";
  constructor(edit, size4322, children) {
    this.edit = edit;
    this.size = size4322;
    this.children = children;
  }
  modify(edit, shift22, f322, hash2422, key, size4322) {
    let count = this.size;
    const children = this.children;
    const frag = hashFragment25(shift22, hash2422);
    const child = children[frag];
    const newChild = (child || new EmptyNode25()).modify(edit, shift22 + SIZE25, f322, hash2422, key, size4322);
    if (child === newChild) return this;
    const canEdit = canEditNode25(this, edit);
    let newChildren;
    if (isEmptyNode25(child) && !isEmptyNode25(newChild)) {
      ++count;
      newChildren = arrayUpdate25(canEdit, frag, newChild, children);
    } else if (!isEmptyNode25(child) && isEmptyNode25(newChild)) {
      --count;
      if (count <= MIN_ARRAY_NODE25) {
        return pack25(edit, count, frag, children);
      }
      newChildren = arrayUpdate25(canEdit, frag, new EmptyNode25(), children);
    } else {
      newChildren = arrayUpdate25(canEdit, frag, newChild, children);
    }
    if (canEdit) {
      this.size = count;
      this.children = newChildren;
      return this;
    }
    return new _ArrayNode25(edit, count, newChildren);
  }
};
function pack25(edit, count, removed, elements) {
  const children = new Array(count - 1);
  let g322 = 0;
  let bitmap = 0;
  for (let i322 = 0, len = elements.length; i322 < len; ++i322) {
    if (i322 !== removed) {
      const elem = elements[i322];
      if (elem && !isEmptyNode25(elem)) {
        children[g322++] = elem;
        bitmap |= 1 << i322;
      }
    }
  }
  return new IndexedNode25(edit, bitmap, children);
}
function expand25(edit, frag, child, bitmap, subNodes) {
  const arr = [];
  let bit = bitmap;
  let count = 0;
  for (let i322 = 0; bit; ++i322) {
    if (bit & 1) arr[i322] = subNodes[count++];
    bit >>>= 1;
  }
  arr[frag] = child;
  return new ArrayNode25(edit, count + 1, arr);
}
function mergeLeavesInner25(edit, shift22, h1, n1, h2222, n2222) {
  if (h1 === h2222) return new CollisionNode25(edit, h1, [n2222, n1]);
  const subH1 = hashFragment25(shift22, h1);
  const subH2 = hashFragment25(shift22, h2222);
  if (subH1 === subH2) {
    return (child) => new IndexedNode25(edit, toBitmap25(subH1) | toBitmap25(subH2), [child]);
  } else {
    const children = subH1 < subH2 ? [n1, n2222] : [n2222, n1];
    return new IndexedNode25(edit, toBitmap25(subH1) | toBitmap25(subH2), children);
  }
}
function mergeLeaves25(edit, shift22, h1, n1, h2222, n2222) {
  let stack = void 0;
  let currentShift = shift22;
  while (true) {
    const res = mergeLeavesInner25(edit, currentShift, h1, n1, h2222, n2222);
    if (typeof res === "function") {
      stack = make525(res, stack);
      currentShift = currentShift + SIZE25;
    } else {
      let final = res;
      while (stack != null) {
        final = stack.value(final);
        stack = stack.previous;
      }
      return final;
    }
  }
}
var HashMapSymbolKey25 = "effect/HashMap";
var HashMapTypeId25 = /* @__PURE__ */ Symbol.for(HashMapSymbolKey25);
var HashMapProto25 = {
  [HashMapTypeId25]: HashMapTypeId25,
  [Symbol.iterator]() {
    return new HashMapIterator25(this, (k322, v322) => [k322, v322]);
  },
  [symbol37]() {
    let hash2422 = hash27(HashMapSymbolKey25);
    for (const item of this) {
      hash2422 ^= pipe27(hash27(item[0]), combine35(hash27(item[1])));
    }
    return cached27(this, hash2422);
  },
  [symbol227](that) {
    if (isHashMap25(that)) {
      if (that._size !== this._size) {
        return false;
      }
      for (const item of this) {
        const elem = pipe27(that, getHash25(item[0], hash27(item[0])));
        if (isNone227(elem)) {
          return false;
        } else {
          if (!equals27(item[1], elem.value)) {
            return false;
          }
        }
      }
      return true;
    }
    return false;
  },
  toString() {
    return format27(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashMap",
      values: Array.from(this).map(toJSON27)
    };
  },
  [NodeInspectSymbol27]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments27(this, arguments);
  }
};
var makeImpl35 = (editable, edit, root, size4322) => {
  const map622 = Object.create(HashMapProto25);
  map622._editable = editable;
  map622._edit = edit;
  map622._root = root;
  map622._size = size4322;
  return map622;
};
var HashMapIterator25 = class _HashMapIterator25 {
  map;
  f;
  v;
  constructor(map622, f322) {
    this.map = map622;
    this.f = f322;
    this.v = visitLazy25(this.map._root, this.f, void 0);
  }
  next() {
    if (isNone227(this.v)) {
      return {
        done: true,
        value: void 0
      };
    }
    const v0 = this.v.value;
    this.v = applyCont25(v0.cont);
    return {
      done: false,
      value: v0.value
    };
  }
  [Symbol.iterator]() {
    return new _HashMapIterator25(this.map, this.f);
  }
};
var applyCont25 = (cont) => cont ? visitLazyChildren25(cont[0], cont[1], cont[2], cont[3], cont[4]) : none227();
var visitLazy25 = (node, f322, cont = void 0) => {
  switch (node._tag) {
    case "LeafNode": {
      if (isSome227(node.value)) {
        return some327({
          value: f322(node.key, node.value.value),
          cont
        });
      }
      return applyCont25(cont);
    }
    case "CollisionNode":
    case "ArrayNode":
    case "IndexedNode": {
      const children = node.children;
      return visitLazyChildren25(children.length, children, 0, f322, cont);
    }
    default: {
      return applyCont25(cont);
    }
  }
};
var visitLazyChildren25 = (len, children, i322, f322, cont) => {
  while (i322 < len) {
    const child = children[i322++];
    if (child && !isEmptyNode25(child)) {
      return visitLazy25(child, f322, [len, children, i322, f322, cont]);
    }
  }
  return applyCont25(cont);
};
var _empty325 = /* @__PURE__ */ makeImpl35(false, 0, /* @__PURE__ */ new EmptyNode25(), 0);
var empty425 = () => _empty325;
var isHashMap25 = (u322) => hasProperty27(u322, HashMapTypeId25);
var getHash25 = /* @__PURE__ */ dual27(3, (self2, key, hash2422) => {
  let node = self2._root;
  let shift22 = 0;
  while (true) {
    switch (node._tag) {
      case "LeafNode": {
        return equals27(key, node.key) ? node.value : none227();
      }
      case "CollisionNode": {
        if (hash2422 === node.hash) {
          const children = node.children;
          for (let i322 = 0, len = children.length; i322 < len; ++i322) {
            const child = children[i322];
            if ("key" in child && equals27(key, child.key)) {
              return child.value;
            }
          }
        }
        return none227();
      }
      case "IndexedNode": {
        const frag = hashFragment25(shift22, hash2422);
        const bit = toBitmap25(frag);
        if (node.mask & bit) {
          node = node.children[fromBitmap25(node.mask, bit)];
          shift22 += SIZE25;
          break;
        }
        return none227();
      }
      case "ArrayNode": {
        node = node.children[hashFragment25(shift22, hash2422)];
        if (node) {
          shift22 += SIZE25;
          break;
        }
        return none227();
      }
      default:
        return none227();
    }
  }
});
var set27 = /* @__PURE__ */ dual27(3, (self2, key, value) => modifyAt25(self2, key, () => some327(value)));
var setTree25 = /* @__PURE__ */ dual27(3, (self2, newRoot, newSize) => {
  if (self2._editable) {
    self2._root = newRoot;
    self2._size = newSize;
    return self2;
  }
  return newRoot === self2._root ? self2 : makeImpl35(self2._editable, self2._edit, newRoot, newSize);
});
var keys25 = (self2) => new HashMapIterator25(self2, (key) => key);
var size45 = (self2) => self2._size;
var beginMutation35 = (self2) => makeImpl35(true, self2._edit + 1, self2._root, self2._size);
var modifyAt25 = /* @__PURE__ */ dual27(3, (self2, key, f322) => modifyHash25(self2, key, hash27(key), f322));
var modifyHash25 = /* @__PURE__ */ dual27(4, (self2, key, hash2422, f322) => {
  const size4322 = {
    value: self2._size
  };
  const newRoot = self2._root.modify(self2._editable ? self2._edit : NaN, 0, f322, hash2422, key, size4322);
  return pipe27(self2, setTree25(newRoot, size4322.value));
});
var forEach35 = /* @__PURE__ */ dual27(2, (self2, f322) => reduce225(self2, void 0, (_322, value, key) => f322(value, key)));
var reduce225 = /* @__PURE__ */ dual27(3, (self2, zero, f322) => {
  const root = self2._root;
  if (root._tag === "LeafNode") {
    return isSome227(root.value) ? f322(zero, root.value.value, root.key) : zero;
  }
  if (root._tag === "EmptyNode") {
    return zero;
  }
  const toVisit = [root.children];
  let children;
  while (children = toVisit.pop()) {
    for (let i322 = 0, len = children.length; i322 < len; ) {
      const child = children[i322++];
      if (child && !isEmptyNode25(child)) {
        if (child._tag === "LeafNode") {
          if (isSome227(child.value)) {
            zero = f322(zero, child.value.value, child.key);
          }
        } else {
          toVisit.push(child.children);
        }
      }
    }
  }
  return zero;
});
var HashSetSymbolKey25 = "effect/HashSet";
var HashSetTypeId25 = /* @__PURE__ */ Symbol.for(HashSetSymbolKey25);
var HashSetProto25 = {
  [HashSetTypeId25]: HashSetTypeId25,
  [Symbol.iterator]() {
    return keys25(this._keyMap);
  },
  [symbol37]() {
    return cached27(this, combine35(hash27(this._keyMap))(hash27(HashSetSymbolKey25)));
  },
  [symbol227](that) {
    if (isHashSet25(that)) {
      return size45(this._keyMap) === size45(that._keyMap) && equals27(this._keyMap, that._keyMap);
    }
    return false;
  },
  toString() {
    return format27(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashSet",
      values: Array.from(this).map(toJSON27)
    };
  },
  [NodeInspectSymbol27]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments27(this, arguments);
  }
};
var makeImpl225 = (keyMap) => {
  const set2422 = Object.create(HashSetProto25);
  set2422._keyMap = keyMap;
  return set2422;
};
var isHashSet25 = (u322) => hasProperty27(u322, HashSetTypeId25);
var _empty425 = /* @__PURE__ */ makeImpl225(/* @__PURE__ */ empty425());
var empty525 = () => _empty425;
var size225 = (self2) => size45(self2._keyMap);
var beginMutation225 = (self2) => makeImpl225(beginMutation35(self2._keyMap));
var endMutation25 = (self2) => {
  self2._keyMap._editable = false;
  return self2;
};
var mutate25 = /* @__PURE__ */ dual27(2, (self2, f322) => {
  const transient = beginMutation225(self2);
  f322(transient);
  return endMutation25(transient);
});
var add225 = /* @__PURE__ */ dual27(2, (self2, value) => self2._keyMap._editable ? (set27(value, true)(self2._keyMap), self2) : makeImpl225(set27(value, true)(self2._keyMap)));
var union225 = /* @__PURE__ */ dual27(2, (self2, that) => mutate25(empty525(), (set2422) => {
  forEach225(self2, (value) => add225(set2422, value));
  for (const value of that) {
    add225(set2422, value);
  }
}));
var forEach225 = /* @__PURE__ */ dual27(2, (self2, f322) => forEach35(self2._keyMap, (_322, k322) => f322(k322)));
var empty625 = empty525;
var size325 = size225;
var add325 = add225;
var union325 = union225;
var ArrayProto25 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(Array.prototype), {
  [symbol37]() {
    return cached27(this, array35(this));
  },
  [symbol227](that) {
    if (Array.isArray(that) && this.length === that.length) {
      return this.every((v322, i322) => equals27(v322, that[i322]));
    } else {
      return false;
    }
  }
});
var Structural35 = /* @__PURE__ */ function() {
  function Structural3322(args) {
    if (args) {
      Object.assign(this, args);
    }
  }
  Structural3322.prototype = StructuralPrototype27;
  return Structural3322;
}();
var struct225 = (as2422) => Object.assign(Object.create(StructuralPrototype27), as2422);
var ContextPatchTypeId25 = /* @__PURE__ */ Symbol.for("effect/DifferContextPatch");
function variance35(a322) {
  return a322;
}
var PatchProto25 = {
  ...Structural35.prototype,
  [ContextPatchTypeId25]: {
    _Value: variance35,
    _Patch: variance35
  }
};
var EmptyProto25 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto25), {
  _tag: "Empty"
});
var _empty525 = /* @__PURE__ */ Object.create(EmptyProto25);
var empty725 = () => _empty525;
var AndThenProto25 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto25), {
  _tag: "AndThen"
});
var makeAndThen25 = (first, second) => {
  const o322 = Object.create(AndThenProto25);
  o322.first = first;
  o322.second = second;
  return o322;
};
var AddServiceProto25 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto25), {
  _tag: "AddService"
});
var makeAddService25 = (key, service) => {
  const o322 = Object.create(AddServiceProto25);
  o322.key = key;
  o322.service = service;
  return o322;
};
var RemoveServiceProto25 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto25), {
  _tag: "RemoveService"
});
var makeRemoveService25 = (key) => {
  const o322 = Object.create(RemoveServiceProto25);
  o322.key = key;
  return o322;
};
var UpdateServiceProto25 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto25), {
  _tag: "UpdateService"
});
var makeUpdateService25 = (key, update222) => {
  const o322 = Object.create(UpdateServiceProto25);
  o322.key = key;
  o322.update = update222;
  return o322;
};
var diff25 = (oldValue, newValue) => {
  const missingServices = new Map(oldValue.unsafeMap);
  let patch2322 = empty725();
  for (const [tag, newService] of newValue.unsafeMap.entries()) {
    if (missingServices.has(tag)) {
      const old = missingServices.get(tag);
      missingServices.delete(tag);
      if (!equals27(old, newService)) {
        patch2322 = combine227(makeUpdateService25(tag, () => newService))(patch2322);
      }
    } else {
      missingServices.delete(tag);
      patch2322 = combine227(makeAddService25(tag, newService))(patch2322);
    }
  }
  for (const [tag] of missingServices.entries()) {
    patch2322 = combine227(makeRemoveService25(tag))(patch2322);
  }
  return patch2322;
};
var combine227 = /* @__PURE__ */ dual27(2, (self2, that) => makeAndThen25(self2, that));
var patch25 = /* @__PURE__ */ dual27(2, (self2, context) => {
  if (self2._tag === "Empty") {
    return context;
  }
  let wasServiceUpdated = false;
  let patches = of25(self2);
  const updatedContext = new Map(context.unsafeMap);
  while (isNonEmpty25(patches)) {
    const head222 = headNonEmpty25(patches);
    const tail322 = tailNonEmpty25(patches);
    switch (head222._tag) {
      case "Empty": {
        patches = tail322;
        break;
      }
      case "AddService": {
        updatedContext.set(head222.key, head222.service);
        patches = tail322;
        break;
      }
      case "AndThen": {
        patches = prepend25(prepend25(tail322, head222.second), head222.first);
        break;
      }
      case "RemoveService": {
        updatedContext.delete(head222.key);
        patches = tail322;
        break;
      }
      case "UpdateService": {
        updatedContext.set(head222.key, head222.update(updatedContext.get(head222.key)));
        wasServiceUpdated = true;
        patches = tail322;
        break;
      }
    }
  }
  if (!wasServiceUpdated) {
    return makeContext25(updatedContext);
  }
  const map622 = /* @__PURE__ */ new Map();
  for (const [tag] of context.unsafeMap) {
    if (updatedContext.has(tag)) {
      map622.set(tag, updatedContext.get(tag));
      updatedContext.delete(tag);
    }
  }
  for (const [tag, s322] of updatedContext) {
    map622.set(tag, s322);
  }
  return makeContext25(map622);
});
var DifferTypeId25 = /* @__PURE__ */ Symbol.for("effect/Differ");
var DifferProto25 = {
  [DifferTypeId25]: {
    _P: identity27,
    _V: identity27
  }
};
var make725 = (params) => {
  const differ = Object.create(DifferProto25);
  differ.empty = params.empty;
  differ.diff = params.diff;
  differ.combine = params.combine;
  differ.patch = params.patch;
  return differ;
};
var environment25 = () => make725({
  empty: empty725(),
  combine: (first, second) => combine227(second)(first),
  diff: (oldValue, newValue) => diff25(oldValue, newValue),
  patch: (patch2322, oldValue) => patch25(oldValue)(patch2322)
});
var OP_DIE25 = "Die";
var OP_EMPTY25 = "Empty";
var OP_FAIL25 = "Fail";
var OP_INTERRUPT25 = "Interrupt";
var OP_PARALLEL25 = "Parallel";
var OP_SEQUENTIAL25 = "Sequential";
var CauseSymbolKey25 = "effect/Cause";
var CauseTypeId25 = /* @__PURE__ */ Symbol.for(CauseSymbolKey25);
var variance225 = {
  /* c8 ignore next */
  _E: (_322) => _322
};
var proto25 = {
  [CauseTypeId25]: variance225,
  [symbol37]() {
    return pipe27(hash27(CauseSymbolKey25), combine35(hash27(flattenCause25(this))), cached27(this));
  },
  [symbol227](that) {
    return isCause25(that) && causeEquals25(this, that);
  },
  pipe() {
    return pipeArguments27(this, arguments);
  },
  toJSON() {
    switch (this._tag) {
      case "Empty":
        return {
          _id: "Cause",
          _tag: this._tag
        };
      case "Die":
        return {
          _id: "Cause",
          _tag: this._tag,
          defect: toJSON27(this.defect)
        };
      case "Interrupt":
        return {
          _id: "Cause",
          _tag: this._tag,
          fiberId: this.fiberId.toJSON()
        };
      case "Fail":
        return {
          _id: "Cause",
          _tag: this._tag,
          failure: toJSON27(this.error)
        };
      case "Sequential":
      case "Parallel":
        return {
          _id: "Cause",
          _tag: this._tag,
          left: toJSON27(this.left),
          right: toJSON27(this.right)
        };
    }
  },
  toString() {
    return pretty25(this);
  },
  [NodeInspectSymbol27]() {
    return this.toJSON();
  }
};
var fail35 = (error) => {
  const o322 = Object.create(proto25);
  o322._tag = OP_FAIL25;
  o322.error = error;
  return o322;
};
var parallel25 = (left3322, right3322) => {
  const o322 = Object.create(proto25);
  o322._tag = OP_PARALLEL25;
  o322.left = left3322;
  o322.right = right3322;
  return o322;
};
var sequential25 = (left3322, right3322) => {
  const o322 = Object.create(proto25);
  o322._tag = OP_SEQUENTIAL25;
  o322.left = left3322;
  o322.right = right3322;
  return o322;
};
var isCause25 = (u322) => hasProperty27(u322, CauseTypeId25);
var isInterruptedOnly25 = (self2) => reduceWithContext25(void 0, IsInterruptedOnlyCauseReducer25)(self2);
var causeEquals25 = (left3322, right3322) => {
  let leftStack = of25(left3322);
  let rightStack = of25(right3322);
  while (isNonEmpty25(leftStack) && isNonEmpty25(rightStack)) {
    const [leftParallel, leftSequential] = pipe27(headNonEmpty25(leftStack), reduce425([empty625(), empty325()], ([parallel2322, sequential2322], cause) => {
      const [par, seq] = evaluateCause25(cause);
      return some327([pipe27(parallel2322, union325(par)), pipe27(sequential2322, appendAll25(seq))]);
    }));
    const [rightParallel, rightSequential] = pipe27(headNonEmpty25(rightStack), reduce425([empty625(), empty325()], ([parallel2322, sequential2322], cause) => {
      const [par, seq] = evaluateCause25(cause);
      return some327([pipe27(parallel2322, union325(par)), pipe27(sequential2322, appendAll25(seq))]);
    }));
    if (!equals27(leftParallel, rightParallel)) {
      return false;
    }
    leftStack = leftSequential;
    rightStack = rightSequential;
  }
  return true;
};
var flattenCause25 = (cause) => {
  return flattenCauseLoop25(of25(cause), empty325());
};
var flattenCauseLoop25 = (causes, flattened) => {
  while (1) {
    const [parallel2322, sequential2322] = pipe27(causes, reduce35([empty625(), empty325()], ([parallel322, sequential322], cause) => {
      const [par, seq] = evaluateCause25(cause);
      return [pipe27(parallel322, union325(par)), pipe27(sequential322, appendAll25(seq))];
    }));
    const updated = size325(parallel2322) > 0 ? pipe27(flattened, prepend25(parallel2322)) : flattened;
    if (isEmpty25(sequential2322)) {
      return reverse225(updated);
    }
    causes = sequential2322;
    flattened = updated;
  }
  throw new Error(getBugErrorMessage27("Cause.flattenCauseLoop"));
};
var evaluateCause25 = (self2) => {
  let cause = self2;
  const stack = [];
  let _parallel = empty625();
  let _sequential = empty325();
  while (cause !== void 0) {
    switch (cause._tag) {
      case OP_EMPTY25: {
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_FAIL25: {
        _parallel = add325(_parallel, make427(cause._tag, cause.error));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_DIE25: {
        _parallel = add325(_parallel, make427(cause._tag, cause.defect));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_INTERRUPT25: {
        _parallel = add325(_parallel, make427(cause._tag, cause.fiberId));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_SEQUENTIAL25: {
        switch (cause.left._tag) {
          case OP_EMPTY25: {
            cause = cause.right;
            break;
          }
          case OP_SEQUENTIAL25: {
            cause = sequential25(cause.left.left, sequential25(cause.left.right, cause.right));
            break;
          }
          case OP_PARALLEL25: {
            cause = parallel25(sequential25(cause.left.left, cause.right), sequential25(cause.left.right, cause.right));
            break;
          }
          default: {
            _sequential = prepend25(_sequential, cause.right);
            cause = cause.left;
            break;
          }
        }
        break;
      }
      case OP_PARALLEL25: {
        stack.push(cause.right);
        cause = cause.left;
        break;
      }
    }
  }
  throw new Error(getBugErrorMessage27("Cause.evaluateCauseLoop"));
};
var IsInterruptedOnlyCauseReducer25 = {
  emptyCase: constTrue27,
  failCase: constFalse27,
  dieCase: constFalse27,
  interruptCase: constTrue27,
  sequentialCase: (_322, left3322, right3322) => left3322 && right3322,
  parallelCase: (_322, left3322, right3322) => left3322 && right3322
};
var OP_SEQUENTIAL_CASE25 = "SequentialCase";
var OP_PARALLEL_CASE25 = "ParallelCase";
var reduce425 = /* @__PURE__ */ dual27(3, (self2, zero, pf) => {
  let accumulator = zero;
  let cause = self2;
  const causes = [];
  while (cause !== void 0) {
    const option = pf(accumulator, cause);
    accumulator = isSome227(option) ? option.value : accumulator;
    switch (cause._tag) {
      case OP_SEQUENTIAL25: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      case OP_PARALLEL25: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      default: {
        cause = void 0;
        break;
      }
    }
    if (cause === void 0 && causes.length > 0) {
      cause = causes.pop();
    }
  }
  return accumulator;
});
var reduceWithContext25 = /* @__PURE__ */ dual27(3, (self2, context, reducer) => {
  const input = [self2];
  const output = [];
  while (input.length > 0) {
    const cause = input.pop();
    switch (cause._tag) {
      case OP_EMPTY25: {
        output.push(right227(reducer.emptyCase(context)));
        break;
      }
      case OP_FAIL25: {
        output.push(right227(reducer.failCase(context, cause.error)));
        break;
      }
      case OP_DIE25: {
        output.push(right227(reducer.dieCase(context, cause.defect)));
        break;
      }
      case OP_INTERRUPT25: {
        output.push(right227(reducer.interruptCase(context, cause.fiberId)));
        break;
      }
      case OP_SEQUENTIAL25: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left227({
          _tag: OP_SEQUENTIAL_CASE25
        }));
        break;
      }
      case OP_PARALLEL25: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left227({
          _tag: OP_PARALLEL_CASE25
        }));
        break;
      }
    }
  }
  const accumulator = [];
  while (output.length > 0) {
    const either = output.pop();
    switch (either._tag) {
      case "Left": {
        switch (either.left._tag) {
          case OP_SEQUENTIAL_CASE25: {
            const left3322 = accumulator.pop();
            const right3322 = accumulator.pop();
            const value = reducer.sequentialCase(context, left3322, right3322);
            accumulator.push(value);
            break;
          }
          case OP_PARALLEL_CASE25: {
            const left3322 = accumulator.pop();
            const right3322 = accumulator.pop();
            const value = reducer.parallelCase(context, left3322, right3322);
            accumulator.push(value);
            break;
          }
        }
        break;
      }
      case "Right": {
        accumulator.push(either.right);
        break;
      }
    }
  }
  if (accumulator.length === 0) {
    throw new Error("BUG: Cause.reduceWithContext - please report an issue at https://github.com/Effect-TS/effect/issues");
  }
  return accumulator.pop();
});
var pretty25 = (cause) => {
  if (isInterruptedOnly25(cause)) {
    return "All fibers interrupted without errors.";
  }
  return prettyErrors25(cause).map((e322) => e322.stack).join("\n");
};
var PrettyError25 = class extends globalThis.Error {
  span = void 0;
  constructor(originalError) {
    const prevLimit = Error.stackTraceLimit;
    Error.stackTraceLimit = 0;
    super(prettyErrorMessage25(originalError));
    Error.stackTraceLimit = prevLimit;
    this.name = originalError instanceof Error ? originalError.name : "Error";
    if (typeof originalError === "object" && originalError !== null) {
      if (spanSymbol35 in originalError) {
        this.span = originalError[spanSymbol35];
      }
      Object.keys(originalError).forEach((key) => {
        if (!(key in this)) {
          this[key] = originalError[key];
        }
      });
    }
    this.stack = prettyErrorStack25(this.message, originalError instanceof Error && originalError.stack ? originalError.stack : "", this.span);
  }
  toJSON() {
    const out = {
      message: this.message,
      stack: this.stack
    };
    if (this.span) {
      out.span = this.span;
    }
    return out;
  }
};
var prettyErrorMessage25 = (u322) => {
  if (typeof u322 === "string") {
    return `Error: ${u322}`;
  }
  try {
    if (hasProperty27(u322, "toString") && isFunction327(u322["toString"]) && u322["toString"] !== Object.prototype.toString && u322["toString"] !== globalThis.Array.prototype.toString) {
      return u322["toString"]();
    }
  } catch {
  }
  return `Error: ${JSON.stringify(u322)}`;
};
var locationRegex25 = /\((.*)\)/;
var spanToTrace25 = /* @__PURE__ */ globalValue27("effect/Tracer/spanToTrace", () => /* @__PURE__ */ new WeakMap());
var prettyErrorStack25 = (message, stack, span222) => {
  const out = [message];
  const lines = stack.split("\n");
  for (let i322 = 1; i322 < lines.length; i322++) {
    if (lines[i322].includes("Generator.next")) {
      break;
    }
    if (lines[i322].includes("effect_internal_function")) {
      out.pop();
      break;
    }
    out.push(lines[i322].replace(/at .*effect_instruction_i.*\((.*)\)/, "at $1").replace(/EffectPrimitive\.\w+/, "<anonymous>"));
  }
  if (span222) {
    let current = span222;
    let i322 = 0;
    while (current && current._tag === "Span" && i322 < 10) {
      const stackFn = spanToTrace25.get(current);
      if (typeof stackFn === "function") {
        const stack2 = stackFn();
        const locationMatch = stack2.match(locationRegex25);
        const location = locationMatch ? locationMatch[1] : stack2.replace(/^at /, "");
        out.push(`    at ${current.name} (${location})`);
      } else {
        out.push(`    at ${current.name}`);
      }
      current = getOrUndefined27(current.parent);
      i322++;
    }
  }
  return out.join("\n");
};
var spanSymbol35 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var prettyErrors25 = (cause) => reduceWithContext25(cause, void 0, {
  emptyCase: () => [],
  dieCase: (_322, unknownError) => {
    return [new PrettyError25(unknownError)];
  },
  failCase: (_322, error) => {
    return [new PrettyError25(error)];
  },
  interruptCase: () => [],
  parallelCase: (_322, l322, r322) => [...l322, ...r322],
  sequentialCase: (_322, l322, r322) => [...l322, ...r322]
});
var SingleShotGen227 = class _SingleShotGen225 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  next(a322) {
    return this.called ? {
      value: a322,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  return(a322) {
    return {
      value: a322,
      done: true
    };
  }
  throw(e322) {
    throw e322;
  }
  [Symbol.iterator]() {
    return new _SingleShotGen225(this.self);
  }
};
var spanTag25 = /* @__PURE__ */ GenericTag25("effect/ParentSpan");
var EffectTypeId227 = /* @__PURE__ */ Symbol.for("effect/Effect");
var EffectPrimitive25 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId227] = effectVariance27;
  constructor(_op) {
    this._op = _op;
  }
  [symbol227](that) {
    return this === that;
  }
  [symbol37]() {
    return cached27(this, random27(this));
  }
  pipe() {
    return pipeArguments27(this, arguments);
  }
  toJSON() {
    return {
      _id: "Effect",
      _op: this._op,
      effect_instruction_i0: toJSON27(this.effect_instruction_i0),
      effect_instruction_i1: toJSON27(this.effect_instruction_i1),
      effect_instruction_i2: toJSON27(this.effect_instruction_i2)
    };
  }
  toString() {
    return format27(this.toJSON());
  }
  [NodeInspectSymbol27]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen227(new YieldWrap27(this));
  }
};
var EffectPrimitiveFailure25 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId227] = effectVariance27;
  constructor(_op) {
    this._op = _op;
    this._tag = _op;
  }
  [symbol227](that) {
    return exitIsExit25(that) && that._op === "Failure" && // @ts-expect-error
    equals27(this.effect_instruction_i0, that.effect_instruction_i0);
  }
  [symbol37]() {
    return pipe27(
      // @ts-expect-error
      string27(this._tag),
      // @ts-expect-error
      combine35(hash27(this.effect_instruction_i0)),
      cached27(this)
    );
  }
  get cause() {
    return this.effect_instruction_i0;
  }
  pipe() {
    return pipeArguments27(this, arguments);
  }
  toJSON() {
    return {
      _id: "Exit",
      _tag: this._op,
      cause: this.cause.toJSON()
    };
  }
  toString() {
    return format27(this.toJSON());
  }
  [NodeInspectSymbol27]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen227(new YieldWrap27(this));
  }
};
var isEffect25 = (u322) => hasProperty27(u322, EffectTypeId227);
var withFiberRuntime25 = (withRuntime) => {
  const effect = new EffectPrimitive25(OP_WITH_RUNTIME25);
  effect.effect_instruction_i0 = withRuntime;
  return effect;
};
var spanSymbol225 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var originalSymbol25 = /* @__PURE__ */ Symbol.for("effect/OriginalAnnotation");
var capture25 = (obj, span222) => {
  if (isSome227(span222)) {
    return new Proxy(obj, {
      has(target, p322) {
        return p322 === spanSymbol225 || p322 === originalSymbol25 || p322 in target;
      },
      get(target, p322) {
        if (p322 === spanSymbol225) {
          return span222.value;
        }
        if (p322 === originalSymbol25) {
          return obj;
        }
        return target[p322];
      }
    });
  }
  return obj;
};
var fail225 = (error) => isObject27(error) && !(spanSymbol225 in error) ? withFiberRuntime25((fiber) => failCause25(fail35(capture25(error, currentSpanFromFiber25(fiber))))) : failCause25(fail35(error));
var failCause25 = (cause) => {
  const effect = new EffectPrimitiveFailure25(OP_FAILURE25);
  effect.effect_instruction_i0 = cause;
  return effect;
};
var FiberRefSymbolKey25 = "effect/FiberRef";
var FiberRefTypeId25 = /* @__PURE__ */ Symbol.for(FiberRefSymbolKey25);
var fiberRefVariance25 = {
  /* c8 ignore next */
  _A: (_322) => _322
};
var fiberRefUnsafeMakeContext25 = (initial) => {
  const differ = environment25();
  return fiberRefUnsafeMakePatch25(initial, {
    differ,
    fork: differ.empty
  });
};
var fiberRefUnsafeMakePatch25 = (initial, options) => ({
  [FiberRefTypeId25]: fiberRefVariance25,
  initial,
  diff: (oldValue, newValue) => options.differ.diff(oldValue, newValue),
  combine: (first, second) => options.differ.combine(first, second),
  patch: (patch2322) => (oldValue) => options.differ.patch(patch2322, oldValue),
  fork: options.fork,
  join: options.join ?? ((_322, n322) => n322),
  pipe() {
    return pipeArguments27(this, arguments);
  }
});
var currentContext25 = /* @__PURE__ */ globalValue27(/* @__PURE__ */ Symbol.for("effect/FiberRef/currentContext"), () => fiberRefUnsafeMakeContext25(empty225()));
var YieldableError25 = /* @__PURE__ */ function() {
  class YieldableError2322 extends globalThis.Error {
    commit() {
      return fail225(this);
    }
    toString() {
      return this.message ? `${this.name}: ${this.message}` : this.name;
    }
    toJSON() {
      return {
        ...this
      };
    }
    [NodeInspectSymbol27]() {
      const stack = this.stack;
      if (stack) {
        return `${this.toString()}
${stack.split("\n").slice(1).join("\n")}`;
      }
      return this.toString();
    }
  }
  Object.assign(YieldableError2322.prototype, StructuralCommitPrototype27);
  return YieldableError2322;
}();
var exitIsExit25 = (u322) => isEffect25(u322) && "_tag" in u322 && (u322._tag === "Success" || u322._tag === "Failure");
var currentSpanFromFiber25 = (fiber) => {
  const span222 = fiber.getFiberRef(currentContext25).unsafeMap.get(spanTag25.key);
  return span222 !== void 0 && span222._tag === "Span" ? some327(span222) : none227();
};
var Data_exports27 = {};
__export226(Data_exports27, {
  Class: () => Class225,
  Error: () => Error225,
  Structural: () => Structural225,
  TaggedClass: () => TaggedClass25,
  TaggedError: () => TaggedError25,
  array: () => array225,
  case: () => _case25,
  struct: () => struct325,
  tagged: () => tagged25,
  taggedEnum: () => taggedEnum25,
  tuple: () => tuple225,
  unsafeArray: () => unsafeArray25,
  unsafeStruct: () => unsafeStruct25
});
var struct325 = struct225;
var unsafeStruct25 = (as2422) => Object.setPrototypeOf(as2422, StructuralPrototype27);
var tuple225 = (...as2422) => unsafeArray25(as2422);
var array225 = (as2422) => unsafeArray25(as2422.slice(0));
var unsafeArray25 = (as2422) => Object.setPrototypeOf(as2422, ArrayProto25);
var _case25 = () => (args) => args === void 0 ? Object.create(StructuralPrototype27) : struct325(args);
var tagged25 = (tag) => (args) => {
  const value = args === void 0 ? Object.create(StructuralPrototype27) : struct325(args);
  value._tag = tag;
  return value;
};
var Class225 = Structural35;
var TaggedClass25 = (tag) => {
  class Base extends Class225 {
    _tag = tag;
  }
  return Base;
};
var Structural225 = Structural35;
var taggedEnum25 = () => new Proxy({}, {
  get(_target, tag, _receiver) {
    if (tag === "$is") {
      return isTagged25;
    } else if (tag === "$match") {
      return taggedMatch25;
    }
    return tagged25(tag);
  }
});
function taggedMatch25() {
  if (arguments.length === 1) {
    const cases2 = arguments[0];
    return function(value2) {
      return cases2[value2._tag](value2);
    };
  }
  const value = arguments[0];
  const cases = arguments[1];
  return cases[value._tag](value);
}
var Error225 = /* @__PURE__ */ function() {
  return class Base extends YieldableError25 {
    constructor(args) {
      super();
      if (args) {
        Object.assign(this, args);
      }
    }
  };
}();
var TaggedError25 = (tag) => {
  class Base extends Error225 {
    _tag = tag;
  }
  Base.prototype.name = tag;
  return Base;
};
var traverseUp25 = Function_exports27.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType25.Program) return Option_exports27.none();
  return predicate(parent) ? Option_exports27.some(parent) : traverseUp25(parent, predicate);
});
var traverseUpGuard25 = Function_exports27.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType25.Program) return Option_exports27.none();
  return predicate(parent) ? Option_exports27.some(parent) : traverseUpGuard25(parent, predicate);
});
var ESLintCommunityESLintUtils25;
((ESLintCommunityESLintUtils2322) => {
  ESLintCommunityESLintUtils2322.getFunctionHeadLocation = getFunctionHeadLocation25;
  ESLintCommunityESLintUtils2322.getFunctionNameWithKind = getFunctionNameWithKind25;
  ESLintCommunityESLintUtils2322.getPropertyName = getPropertyName25;
  ESLintCommunityESLintUtils2322.getStaticValue = getStaticValue25;
  ESLintCommunityESLintUtils2322.getStringIfConstant = getStringIfConstant25;
  ESLintCommunityESLintUtils2322.hasSideEffect = hasSideEffect25;
  ESLintCommunityESLintUtils2322.isParenthesized = isParenthesized25;
})(ESLintCommunityESLintUtils25 || (ESLintCommunityESLintUtils25 = {}));
var Construction25 = Data_exports27.taggedEnum();
Construction25.None();
function getClassIdentifier22(node) {
  if (node.id) return Option_exports27.fromNullable(node.id);
  if (node.parent.type === NodeType25.VariableDeclarator && node.parent.id.type === NodeType25.Identifier) {
    return Option_exports27.fromNullable(node.parent.id);
  }
  return Option_exports27.none();
}
function getFunctionIdentifier22(node) {
  if (node.id) return Option_exports27.some(node.id);
  if (node.parent.type === NodeType25.VariableDeclarator && node.parent.init === node && node.parent.id.type === NodeType25.Identifier) {
    return Option_exports27.some(node.parent.id);
  }
  if (node.parent.type === NodeType25.AssignmentExpression && node.parent.right === node && node.parent.operator === "=" && node.parent.left.type === NodeType25.Identifier) {
    return Option_exports27.some(node.parent.left);
  }
  if (node.parent.type === NodeType25.Property && node.parent.value === node && !node.parent.computed && node.parent.key.type === NodeType25.Identifier) {
    return Option_exports27.some(node.parent.key);
  }
  if (isOneOf25([NodeType25.MethodDefinition, NodeType25.PropertyDefinition])(node.parent) && node.parent.value === node && node.parent.key.type === NodeType25.Identifier) {
    return Option_exports27.some(node.parent.key);
  }
  if (node.parent.type === NodeType25.AssignmentPattern && node.parent.right === node && node.parent.left.type === NodeType25.Identifier) {
    return Option_exports27.some(node.parent.left);
  }
  return Option_exports27.none();
}
var isFunctionOfObjectMethod22 = a7({
  type: N7.union([NodeType25.FunctionExpression, NodeType25.ArrowFunctionExpression]),
  parent: {
    type: NodeType25.Property,
    parent: {
      type: NodeType25.ObjectExpression
    }
  }
});
var isFunctionOfClassMethod22 = a7({
  type: N7.union([NodeType25.FunctionExpression, NodeType25.ArrowFunctionExpression]),
  parent: {
    type: NodeType25.MethodDefinition,
    parent: {
      type: NodeType25.ClassBody
    }
  }
});
var isFunctionOfClassProperty22 = a7({
  type: N7.union([NodeType25.FunctionExpression, NodeType25.ArrowFunctionExpression]),
  parent: {
    type: NodeType25.Property,
    parent: {
      type: NodeType25.ClassBody
    }
  }
});
var __defProp325 = Object.defineProperty;
var __export325 = (target, all622) => {
  for (var name22 in all622)
    __defProp325(target, name22, { get: all622[name22], enumerable: true });
};
var KEYS225 = {
  ArrayExpression: [
    "elements"
  ],
  ArrayPattern: [
    "elements"
  ],
  ArrowFunctionExpression: [
    "params",
    "body"
  ],
  AssignmentExpression: [
    "left",
    "right"
  ],
  AssignmentPattern: [
    "left",
    "right"
  ],
  AwaitExpression: [
    "argument"
  ],
  BinaryExpression: [
    "left",
    "right"
  ],
  BlockStatement: [
    "body"
  ],
  BreakStatement: [
    "label"
  ],
  CallExpression: [
    "callee",
    "arguments"
  ],
  CatchClause: [
    "param",
    "body"
  ],
  ChainExpression: [
    "expression"
  ],
  ClassBody: [
    "body"
  ],
  ClassDeclaration: [
    "id",
    "superClass",
    "body"
  ],
  ClassExpression: [
    "id",
    "superClass",
    "body"
  ],
  ConditionalExpression: [
    "test",
    "consequent",
    "alternate"
  ],
  ContinueStatement: [
    "label"
  ],
  DebuggerStatement: [],
  DoWhileStatement: [
    "body",
    "test"
  ],
  EmptyStatement: [],
  ExperimentalRestProperty: [
    "argument"
  ],
  ExperimentalSpreadProperty: [
    "argument"
  ],
  ExportAllDeclaration: [
    "exported",
    "source"
  ],
  ExportDefaultDeclaration: [
    "declaration"
  ],
  ExportNamedDeclaration: [
    "declaration",
    "specifiers",
    "source"
  ],
  ExportSpecifier: [
    "exported",
    "local"
  ],
  ExpressionStatement: [
    "expression"
  ],
  ForInStatement: [
    "left",
    "right",
    "body"
  ],
  ForOfStatement: [
    "left",
    "right",
    "body"
  ],
  ForStatement: [
    "init",
    "test",
    "update",
    "body"
  ],
  FunctionDeclaration: [
    "id",
    "params",
    "body"
  ],
  FunctionExpression: [
    "id",
    "params",
    "body"
  ],
  Identifier: [],
  IfStatement: [
    "test",
    "consequent",
    "alternate"
  ],
  ImportDeclaration: [
    "specifiers",
    "source"
  ],
  ImportDefaultSpecifier: [
    "local"
  ],
  ImportExpression: [
    "source"
  ],
  ImportNamespaceSpecifier: [
    "local"
  ],
  ImportSpecifier: [
    "imported",
    "local"
  ],
  JSXAttribute: [
    "name",
    "value"
  ],
  JSXClosingElement: [
    "name"
  ],
  JSXClosingFragment: [],
  JSXElement: [
    "openingElement",
    "children",
    "closingElement"
  ],
  JSXEmptyExpression: [],
  JSXExpressionContainer: [
    "expression"
  ],
  JSXFragment: [
    "openingFragment",
    "children",
    "closingFragment"
  ],
  JSXIdentifier: [],
  JSXMemberExpression: [
    "object",
    "property"
  ],
  JSXNamespacedName: [
    "namespace",
    "name"
  ],
  JSXOpeningElement: [
    "name",
    "attributes"
  ],
  JSXOpeningFragment: [],
  JSXSpreadAttribute: [
    "argument"
  ],
  JSXSpreadChild: [
    "expression"
  ],
  JSXText: [],
  LabeledStatement: [
    "label",
    "body"
  ],
  Literal: [],
  LogicalExpression: [
    "left",
    "right"
  ],
  MemberExpression: [
    "object",
    "property"
  ],
  MetaProperty: [
    "meta",
    "property"
  ],
  MethodDefinition: [
    "key",
    "value"
  ],
  NewExpression: [
    "callee",
    "arguments"
  ],
  ObjectExpression: [
    "properties"
  ],
  ObjectPattern: [
    "properties"
  ],
  PrivateIdentifier: [],
  Program: [
    "body"
  ],
  Property: [
    "key",
    "value"
  ],
  PropertyDefinition: [
    "key",
    "value"
  ],
  RestElement: [
    "argument"
  ],
  ReturnStatement: [
    "argument"
  ],
  SequenceExpression: [
    "expressions"
  ],
  SpreadElement: [
    "argument"
  ],
  StaticBlock: [
    "body"
  ],
  Super: [],
  SwitchCase: [
    "test",
    "consequent"
  ],
  SwitchStatement: [
    "discriminant",
    "cases"
  ],
  TaggedTemplateExpression: [
    "tag",
    "quasi"
  ],
  TemplateElement: [],
  TemplateLiteral: [
    "quasis",
    "expressions"
  ],
  ThisExpression: [],
  ThrowStatement: [
    "argument"
  ],
  TryStatement: [
    "block",
    "handler",
    "finalizer"
  ],
  UnaryExpression: [
    "argument"
  ],
  UpdateExpression: [
    "argument"
  ],
  VariableDeclaration: [
    "declarations"
  ],
  VariableDeclarator: [
    "id",
    "init"
  ],
  WhileStatement: [
    "test",
    "body"
  ],
  WithStatement: [
    "object",
    "body"
  ],
  YieldExpression: [
    "argument"
  ]
};
var NODE_TYPES225 = Object.keys(KEYS225);
for (const type of NODE_TYPES225) {
  Object.freeze(KEYS225[type]);
}
Object.freeze(KEYS225);
var visitor_keys_default225 = KEYS225;
var KEY_BLACKLIST225 = /* @__PURE__ */ new Set([
  "parent",
  "leadingComments",
  "trailingComments"
]);
function filterKey225(key) {
  return !KEY_BLACKLIST225.has(key) && key[0] !== "_";
}
function getKeys225(node) {
  return Object.keys(node).filter(filterKey225);
}
function getInnermostScope225(initialScope, node) {
  const location = node.range[0];
  let scope = initialScope;
  let found = false;
  do {
    found = false;
    for (const childScope of scope.childScopes) {
      const range222 = childScope.block.range;
      if (range222[0] <= location && location < range222[1]) {
        scope = childScope;
        found = true;
        break;
      }
    }
  } while (found);
  return scope;
}
function findVariable224(initialScope, nameOrNode) {
  let name22 = "";
  let scope = initialScope;
  if (typeof nameOrNode === "string") {
    name22 = nameOrNode;
  } else {
    name22 = nameOrNode.name;
    scope = getInnermostScope225(scope, nameOrNode);
  }
  while (scope != null) {
    const variable = scope.set.get(name22);
    if (variable != null) {
      return variable;
    }
    scope = scope.upper;
  }
  return null;
}
function negate0225(token) {
  return !this(token);
}
function negate225(f2222) {
  return negate0225.bind(f2222);
}
function isPunctuatorTokenWithValue225(token, value) {
  return token.type === "Punctuator" && token.value === value;
}
function isArrowToken225(token) {
  return isPunctuatorTokenWithValue225(token, "=>");
}
function isCommaToken225(token) {
  return isPunctuatorTokenWithValue225(token, ",");
}
function isSemicolonToken225(token) {
  return isPunctuatorTokenWithValue225(token, ";");
}
function isColonToken225(token) {
  return isPunctuatorTokenWithValue225(token, ":");
}
function isOpeningParenToken225(token) {
  return isPunctuatorTokenWithValue225(token, "(");
}
function isClosingParenToken225(token) {
  return isPunctuatorTokenWithValue225(token, ")");
}
function isOpeningBracketToken225(token) {
  return isPunctuatorTokenWithValue225(token, "[");
}
function isClosingBracketToken225(token) {
  return isPunctuatorTokenWithValue225(token, "]");
}
function isOpeningBraceToken225(token) {
  return isPunctuatorTokenWithValue225(token, "{");
}
function isClosingBraceToken225(token) {
  return isPunctuatorTokenWithValue225(token, "}");
}
function isCommentToken225(token) {
  return ["Block", "Line", "Shebang"].includes(token.type);
}
negate225(isArrowToken225);
negate225(isCommaToken225);
negate225(isSemicolonToken225);
negate225(isColonToken225);
negate225(isOpeningParenToken225);
negate225(isClosingParenToken225);
negate225(isOpeningBracketToken225);
negate225(isClosingBracketToken225);
negate225(isOpeningBraceToken225);
negate225(isClosingBraceToken225);
negate225(isCommentToken225);
function getOpeningParenOfParams225(node, sourceCode) {
  return node.id ? sourceCode.getTokenAfter(node.id, isOpeningParenToken225) : sourceCode.getFirstToken(node, isOpeningParenToken225);
}
function getFunctionHeadLocation225(node, sourceCode) {
  const parent = node.parent;
  let start = null;
  let end = null;
  if (node.type === "ArrowFunctionExpression") {
    const arrowToken = sourceCode.getTokenBefore(node.body, isArrowToken225);
    start = arrowToken.loc.start;
    end = arrowToken.loc.end;
  } else if (parent.type === "Property" || parent.type === "MethodDefinition" || parent.type === "PropertyDefinition") {
    start = parent.loc.start;
    end = getOpeningParenOfParams225(node, sourceCode).loc.start;
  } else {
    start = node.loc.start;
    end = getOpeningParenOfParams225(node, sourceCode).loc.start;
  }
  return {
    start: { ...start },
    end: { ...end }
  };
}
var globalObject225 = typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {};
var builtinNames225 = Object.freeze(
  /* @__PURE__ */ new Set([
    "Array",
    "ArrayBuffer",
    "BigInt",
    "BigInt64Array",
    "BigUint64Array",
    "Boolean",
    "DataView",
    "Date",
    "decodeURI",
    "decodeURIComponent",
    "encodeURI",
    "encodeURIComponent",
    "escape",
    "Float32Array",
    "Float64Array",
    "Function",
    "Infinity",
    "Int16Array",
    "Int32Array",
    "Int8Array",
    "isFinite",
    "isNaN",
    "isPrototypeOf",
    "JSON",
    "Map",
    "Math",
    "NaN",
    "Number",
    "Object",
    "parseFloat",
    "parseInt",
    "Promise",
    "Proxy",
    "Reflect",
    "RegExp",
    "Set",
    "String",
    "Symbol",
    "Uint16Array",
    "Uint32Array",
    "Uint8Array",
    "Uint8ClampedArray",
    "undefined",
    "unescape",
    "WeakMap",
    "WeakSet"
  ])
);
var callAllowed225 = new Set(
  [
    Array.isArray,
    Array.of,
    Array.prototype.at,
    Array.prototype.concat,
    Array.prototype.entries,
    Array.prototype.every,
    Array.prototype.filter,
    Array.prototype.find,
    Array.prototype.findIndex,
    Array.prototype.flat,
    Array.prototype.includes,
    Array.prototype.indexOf,
    Array.prototype.join,
    Array.prototype.keys,
    Array.prototype.lastIndexOf,
    Array.prototype.slice,
    Array.prototype.some,
    Array.prototype.toString,
    Array.prototype.values,
    typeof BigInt === "function" ? BigInt : void 0,
    Boolean,
    Date,
    Date.parse,
    decodeURI,
    decodeURIComponent,
    encodeURI,
    encodeURIComponent,
    escape,
    isFinite,
    isNaN,
    isPrototypeOf,
    Map,
    Map.prototype.entries,
    Map.prototype.get,
    Map.prototype.has,
    Map.prototype.keys,
    Map.prototype.values,
    ...Object.getOwnPropertyNames(Math).filter((k2222) => k2222 !== "random").map((k2222) => Math[k2222]).filter((f2222) => typeof f2222 === "function"),
    Number,
    Number.isFinite,
    Number.isNaN,
    Number.parseFloat,
    Number.parseInt,
    Number.prototype.toExponential,
    Number.prototype.toFixed,
    Number.prototype.toPrecision,
    Number.prototype.toString,
    Object,
    Object.entries,
    Object.is,
    Object.isExtensible,
    Object.isFrozen,
    Object.isSealed,
    Object.keys,
    Object.values,
    parseFloat,
    parseInt,
    RegExp,
    Set,
    Set.prototype.entries,
    Set.prototype.has,
    Set.prototype.keys,
    Set.prototype.values,
    String,
    String.fromCharCode,
    String.fromCodePoint,
    String.raw,
    String.prototype.at,
    String.prototype.charAt,
    String.prototype.charCodeAt,
    String.prototype.codePointAt,
    String.prototype.concat,
    String.prototype.endsWith,
    String.prototype.includes,
    String.prototype.indexOf,
    String.prototype.lastIndexOf,
    String.prototype.normalize,
    String.prototype.padEnd,
    String.prototype.padStart,
    String.prototype.slice,
    String.prototype.startsWith,
    String.prototype.substr,
    String.prototype.substring,
    String.prototype.toLowerCase,
    String.prototype.toString,
    String.prototype.toUpperCase,
    String.prototype.trim,
    String.prototype.trimEnd,
    String.prototype.trimLeft,
    String.prototype.trimRight,
    String.prototype.trimStart,
    Symbol.for,
    Symbol.keyFor,
    unescape
  ].filter((f2222) => typeof f2222 === "function")
);
var callPassThrough225 = /* @__PURE__ */ new Set([
  Object.freeze,
  Object.preventExtensions,
  Object.seal
]);
var getterAllowed225 = [
  [Map, /* @__PURE__ */ new Set(["size"])],
  [
    RegExp,
    /* @__PURE__ */ new Set([
      "dotAll",
      "flags",
      "global",
      "hasIndices",
      "ignoreCase",
      "multiline",
      "source",
      "sticky",
      "unicode"
    ])
  ],
  [Set, /* @__PURE__ */ new Set(["size"])]
];
function getPropertyDescriptor225(object222, name22) {
  let x2222 = object222;
  while ((typeof x2222 === "object" || typeof x2222 === "function") && x2222 !== null) {
    const d2222 = Object.getOwnPropertyDescriptor(x2222, name22);
    if (d2222) {
      return d2222;
    }
    x2222 = Object.getPrototypeOf(x2222);
  }
  return null;
}
function isGetter225(object222, name22) {
  const d2222 = getPropertyDescriptor225(object222, name22);
  return d2222 != null && d2222.get != null;
}
function getElementValues225(nodeList, initialScope) {
  const valueList = [];
  for (let i2222 = 0; i2222 < nodeList.length; ++i2222) {
    const elementNode = nodeList[i2222];
    if (elementNode == null) {
      valueList.length = i2222 + 1;
    } else if (elementNode.type === "SpreadElement") {
      const argument = getStaticValueR225(elementNode.argument, initialScope);
      if (argument == null) {
        return null;
      }
      valueList.push(...argument.value);
    } else {
      const element = getStaticValueR225(elementNode, initialScope);
      if (element == null) {
        return null;
      }
      valueList.push(element.value);
    }
  }
  return valueList;
}
function isEffectivelyConst225(variable) {
  const refs = variable.references;
  const inits = refs.filter((r2222) => r2222.init).length;
  const reads = refs.filter((r2222) => r2222.isReadOnly()).length;
  if (inits === 1 && reads + inits === refs.length) {
    return true;
  }
  return false;
}
var operations225 = Object.freeze({
  ArrayExpression(node, initialScope) {
    const elements = getElementValues225(node.elements, initialScope);
    return elements != null ? { value: elements } : null;
  },
  AssignmentExpression(node, initialScope) {
    if (node.operator === "=") {
      return getStaticValueR225(node.right, initialScope);
    }
    return null;
  },
  //eslint-disable-next-line complexity
  BinaryExpression(node, initialScope) {
    if (node.operator === "in" || node.operator === "instanceof") {
      return null;
    }
    const left522 = getStaticValueR225(node.left, initialScope);
    const right522 = getStaticValueR225(node.right, initialScope);
    if (left522 != null && right522 != null) {
      switch (node.operator) {
        case "==":
          return { value: left522.value == right522.value };
        case "!=":
          return { value: left522.value != right522.value };
        case "===":
          return { value: left522.value === right522.value };
        case "!==":
          return { value: left522.value !== right522.value };
        case "<":
          return { value: left522.value < right522.value };
        case "<=":
          return { value: left522.value <= right522.value };
        case ">":
          return { value: left522.value > right522.value };
        case ">=":
          return { value: left522.value >= right522.value };
        case "<<":
          return { value: left522.value << right522.value };
        case ">>":
          return { value: left522.value >> right522.value };
        case ">>>":
          return { value: left522.value >>> right522.value };
        case "+":
          return { value: left522.value + right522.value };
        case "-":
          return { value: left522.value - right522.value };
        case "*":
          return { value: left522.value * right522.value };
        case "/":
          return { value: left522.value / right522.value };
        case "%":
          return { value: left522.value % right522.value };
        case "**":
          return { value: left522.value ** right522.value };
        case "|":
          return { value: left522.value | right522.value };
        case "^":
          return { value: left522.value ^ right522.value };
        case "&":
          return { value: left522.value & right522.value };
      }
    }
    return null;
  },
  CallExpression(node, initialScope) {
    const calleeNode = node.callee;
    const args = getElementValues225(node.arguments, initialScope);
    if (args != null) {
      if (calleeNode.type === "MemberExpression") {
        if (calleeNode.property.type === "PrivateIdentifier") {
          return null;
        }
        const object222 = getStaticValueR225(calleeNode.object, initialScope);
        if (object222 != null) {
          if (object222.value == null && (object222.optional || node.optional)) {
            return { value: void 0, optional: true };
          }
          const property = getStaticPropertyNameValue225(
            calleeNode,
            initialScope
          );
          if (property != null) {
            const receiver = object222.value;
            const methodName = property.value;
            if (callAllowed225.has(receiver[methodName])) {
              return { value: receiver[methodName](...args) };
            }
            if (callPassThrough225.has(receiver[methodName])) {
              return { value: args[0] };
            }
          }
        }
      } else {
        const callee = getStaticValueR225(calleeNode, initialScope);
        if (callee != null) {
          if (callee.value == null && node.optional) {
            return { value: void 0, optional: true };
          }
          const func = callee.value;
          if (callAllowed225.has(func)) {
            return { value: func(...args) };
          }
          if (callPassThrough225.has(func)) {
            return { value: args[0] };
          }
        }
      }
    }
    return null;
  },
  ConditionalExpression(node, initialScope) {
    const test = getStaticValueR225(node.test, initialScope);
    if (test != null) {
      return test.value ? getStaticValueR225(node.consequent, initialScope) : getStaticValueR225(node.alternate, initialScope);
    }
    return null;
  },
  ExpressionStatement(node, initialScope) {
    return getStaticValueR225(node.expression, initialScope);
  },
  Identifier(node, initialScope) {
    if (initialScope != null) {
      const variable = findVariable224(initialScope, node);
      if (variable != null && variable.defs.length === 0 && builtinNames225.has(variable.name) && variable.name in globalObject225) {
        return { value: globalObject225[variable.name] };
      }
      if (variable != null && variable.defs.length === 1) {
        const def = variable.defs[0];
        if (def.parent && def.type === "Variable" && (def.parent.kind === "const" || isEffectivelyConst225(variable)) && // TODO(mysticatea): don't support destructuring here.
        def.node.id.type === "Identifier") {
          return getStaticValueR225(def.node.init, initialScope);
        }
      }
    }
    return null;
  },
  Literal(node) {
    if ((node.regex != null || node.bigint != null) && node.value == null) {
      return null;
    }
    return { value: node.value };
  },
  LogicalExpression(node, initialScope) {
    const left522 = getStaticValueR225(node.left, initialScope);
    if (left522 != null) {
      if (node.operator === "||" && Boolean(left522.value) === true || node.operator === "&&" && Boolean(left522.value) === false || node.operator === "??" && left522.value != null) {
        return left522;
      }
      const right522 = getStaticValueR225(node.right, initialScope);
      if (right522 != null) {
        return right522;
      }
    }
    return null;
  },
  MemberExpression(node, initialScope) {
    if (node.property.type === "PrivateIdentifier") {
      return null;
    }
    const object222 = getStaticValueR225(node.object, initialScope);
    if (object222 != null) {
      if (object222.value == null && (object222.optional || node.optional)) {
        return { value: void 0, optional: true };
      }
      const property = getStaticPropertyNameValue225(node, initialScope);
      if (property != null) {
        if (!isGetter225(object222.value, property.value)) {
          return { value: object222.value[property.value] };
        }
        for (const [classFn, allowed] of getterAllowed225) {
          if (object222.value instanceof classFn && allowed.has(property.value)) {
            return { value: object222.value[property.value] };
          }
        }
      }
    }
    return null;
  },
  ChainExpression(node, initialScope) {
    const expression = getStaticValueR225(node.expression, initialScope);
    if (expression != null) {
      return { value: expression.value };
    }
    return null;
  },
  NewExpression(node, initialScope) {
    const callee = getStaticValueR225(node.callee, initialScope);
    const args = getElementValues225(node.arguments, initialScope);
    if (callee != null && args != null) {
      const Func = callee.value;
      if (callAllowed225.has(Func)) {
        return { value: new Func(...args) };
      }
    }
    return null;
  },
  ObjectExpression(node, initialScope) {
    const object222 = {};
    for (const propertyNode of node.properties) {
      if (propertyNode.type === "Property") {
        if (propertyNode.kind !== "init") {
          return null;
        }
        const key = getStaticPropertyNameValue225(
          propertyNode,
          initialScope
        );
        const value = getStaticValueR225(propertyNode.value, initialScope);
        if (key == null || value == null) {
          return null;
        }
        object222[key.value] = value.value;
      } else if (propertyNode.type === "SpreadElement" || propertyNode.type === "ExperimentalSpreadProperty") {
        const argument = getStaticValueR225(
          propertyNode.argument,
          initialScope
        );
        if (argument == null) {
          return null;
        }
        Object.assign(object222, argument.value);
      } else {
        return null;
      }
    }
    return { value: object222 };
  },
  SequenceExpression(node, initialScope) {
    const last222 = node.expressions[node.expressions.length - 1];
    return getStaticValueR225(last222, initialScope);
  },
  TaggedTemplateExpression(node, initialScope) {
    const tag = getStaticValueR225(node.tag, initialScope);
    const expressions = getElementValues225(
      node.quasi.expressions,
      initialScope
    );
    if (tag != null && expressions != null) {
      const func = tag.value;
      const strings = node.quasi.quasis.map((q) => q.value.cooked);
      strings.raw = node.quasi.quasis.map((q) => q.value.raw);
      if (func === String.raw) {
        return { value: func(strings, ...expressions) };
      }
    }
    return null;
  },
  TemplateLiteral(node, initialScope) {
    const expressions = getElementValues225(node.expressions, initialScope);
    if (expressions != null) {
      let value = node.quasis[0].value.cooked;
      for (let i2222 = 0; i2222 < expressions.length; ++i2222) {
        value += expressions[i2222];
        value += node.quasis[i2222 + 1].value.cooked;
      }
      return { value };
    }
    return null;
  },
  UnaryExpression(node, initialScope) {
    if (node.operator === "delete") {
      return null;
    }
    if (node.operator === "void") {
      return { value: void 0 };
    }
    const arg = getStaticValueR225(node.argument, initialScope);
    if (arg != null) {
      switch (node.operator) {
        case "-":
          return { value: -arg.value };
        case "+":
          return { value: +arg.value };
        case "!":
          return { value: !arg.value };
        case "~":
          return { value: ~arg.value };
        case "typeof":
          return { value: typeof arg.value };
      }
    }
    return null;
  }
});
function getStaticValueR225(node, initialScope) {
  if (node != null && Object.hasOwnProperty.call(operations225, node.type)) {
    return operations225[node.type](node, initialScope);
  }
  return null;
}
function getStaticPropertyNameValue225(node, initialScope) {
  const nameNode = node.type === "Property" ? node.key : node.property;
  if (node.computed) {
    return getStaticValueR225(nameNode, initialScope);
  }
  if (nameNode.type === "Identifier") {
    return { value: nameNode.name };
  }
  if (nameNode.type === "Literal") {
    if (nameNode.bigint) {
      return { value: nameNode.bigint };
    }
    return { value: String(nameNode.value) };
  }
  return null;
}
function getStaticValue225(node, initialScope = null) {
  try {
    return getStaticValueR225(node, initialScope);
  } catch (_error) {
    return null;
  }
}
function getStringIfConstant225(node, initialScope = null) {
  if (node && node.type === "Literal" && node.value === null) {
    if (node.regex) {
      return `/${node.regex.pattern}/${node.regex.flags}`;
    }
    if (node.bigint) {
      return node.bigint;
    }
  }
  const evaluated = getStaticValue225(node, initialScope);
  return evaluated && String(evaluated.value);
}
function getPropertyName225(node, initialScope) {
  switch (node.type) {
    case "MemberExpression":
      if (node.computed) {
        return getStringIfConstant225(node.property, initialScope);
      }
      if (node.property.type === "PrivateIdentifier") {
        return null;
      }
      return node.property.name;
    case "Property":
    case "MethodDefinition":
    case "PropertyDefinition":
      if (node.computed) {
        return getStringIfConstant225(node.key, initialScope);
      }
      if (node.key.type === "Literal") {
        return String(node.key.value);
      }
      if (node.key.type === "PrivateIdentifier") {
        return null;
      }
      return node.key.name;
  }
  return null;
}
function getFunctionNameWithKind225(node, sourceCode) {
  const parent = node.parent;
  const tokens = [];
  const isObjectMethod = parent.type === "Property" && parent.value === node;
  const isClassMethod = parent.type === "MethodDefinition" && parent.value === node;
  const isClassFieldMethod = parent.type === "PropertyDefinition" && parent.value === node;
  if (isClassMethod || isClassFieldMethod) {
    if (parent.static) {
      tokens.push("static");
    }
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push("private");
    }
  }
  if (node.async) {
    tokens.push("async");
  }
  if (node.generator) {
    tokens.push("generator");
  }
  if (isObjectMethod || isClassMethod) {
    if (parent.kind === "constructor") {
      return "constructor";
    }
    if (parent.kind === "get") {
      tokens.push("getter");
    } else if (parent.kind === "set") {
      tokens.push("setter");
    } else {
      tokens.push("method");
    }
  } else if (isClassFieldMethod) {
    tokens.push("method");
  } else {
    if (node.type === "ArrowFunctionExpression") {
      tokens.push("arrow");
    }
    tokens.push("function");
  }
  if (isObjectMethod || isClassMethod || isClassFieldMethod) {
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push(`#${parent.key.name}`);
    } else {
      const name22 = getPropertyName225(parent);
      if (name22) {
        tokens.push(`'${name22}'`);
      } else if (sourceCode) {
        const keyText = sourceCode.getText(parent.key);
        if (!keyText.includes("\n")) {
          tokens.push(`[${keyText}]`);
        }
      }
    }
  } else if (node.id) {
    tokens.push(`'${node.id.name}'`);
  } else if (parent.type === "VariableDeclarator" && parent.id && parent.id.type === "Identifier") {
    tokens.push(`'${parent.id.name}'`);
  } else if ((parent.type === "AssignmentExpression" || parent.type === "AssignmentPattern") && parent.left && parent.left.type === "Identifier") {
    tokens.push(`'${parent.left.name}'`);
  } else if (parent.type === "ExportDefaultDeclaration" && parent.declaration === node) {
    tokens.push("'default'");
  }
  return tokens.join(" ");
}
var typeConversionBinaryOps225 = Object.freeze(
  /* @__PURE__ */ new Set([
    "==",
    "!=",
    "<",
    "<=",
    ">",
    ">=",
    "<<",
    ">>",
    ">>>",
    "+",
    "-",
    "*",
    "/",
    "%",
    "|",
    "^",
    "&",
    "in"
  ])
);
var typeConversionUnaryOps225 = Object.freeze(/* @__PURE__ */ new Set(["-", "+", "!", "~"]));
function isNode225(x2222) {
  return x2222 !== null && typeof x2222 === "object" && typeof x2222.type === "string";
}
var visitor225 = Object.freeze(
  Object.assign(/* @__PURE__ */ Object.create(null), {
    $visit(node, options, visitorKeys) {
      const { type } = node;
      if (typeof this[type] === "function") {
        return this[type](node, options, visitorKeys);
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    $visitChildren(node, options, visitorKeys) {
      const { type } = node;
      for (const key of visitorKeys[type] || getKeys225(node)) {
        const value = node[key];
        if (Array.isArray(value)) {
          for (const element of value) {
            if (isNode225(element) && this.$visit(element, options, visitorKeys)) {
              return true;
            }
          }
        } else if (isNode225(value) && this.$visit(value, options, visitorKeys)) {
          return true;
        }
      }
      return false;
    },
    ArrowFunctionExpression() {
      return false;
    },
    AssignmentExpression() {
      return true;
    },
    AwaitExpression() {
      return true;
    },
    BinaryExpression(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && typeConversionBinaryOps225.has(node.operator) && (node.left.type !== "Literal" || node.right.type !== "Literal")) {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    CallExpression() {
      return true;
    },
    FunctionExpression() {
      return false;
    },
    ImportExpression() {
      return true;
    },
    MemberExpression(node, options, visitorKeys) {
      if (options.considerGetters) {
        return true;
      }
      if (options.considerImplicitTypeConversion && node.computed && node.property.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    MethodDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    NewExpression() {
      return true;
    },
    Property(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    PropertyDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UnaryExpression(node, options, visitorKeys) {
      if (node.operator === "delete") {
        return true;
      }
      if (options.considerImplicitTypeConversion && typeConversionUnaryOps225.has(node.operator) && node.argument.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UpdateExpression() {
      return true;
    },
    YieldExpression() {
      return true;
    }
  })
);
function hasSideEffect225(node, sourceCode, { considerGetters = false, considerImplicitTypeConversion = false } = {}) {
  return visitor225.$visit(
    node,
    { considerGetters, considerImplicitTypeConversion },
    sourceCode.visitorKeys || visitor_keys_default225
  );
}
function getParentSyntaxParen225(node, sourceCode) {
  const parent = node.parent;
  switch (parent.type) {
    case "CallExpression":
    case "NewExpression":
      if (parent.arguments.length === 1 && parent.arguments[0] === node) {
        return sourceCode.getTokenAfter(
          parent.callee,
          isOpeningParenToken225
        );
      }
      return null;
    case "DoWhileStatement":
      if (parent.test === node) {
        return sourceCode.getTokenAfter(
          parent.body,
          isOpeningParenToken225
        );
      }
      return null;
    case "IfStatement":
    case "WhileStatement":
      if (parent.test === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "ImportExpression":
      if (parent.source === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "SwitchStatement":
      if (parent.discriminant === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "WithStatement":
      if (parent.object === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    default:
      return null;
  }
}
function isParenthesized225(timesOrNode, nodeOrSourceCode, optionalSourceCode) {
  let times, node, sourceCode, maybeLeftParen, maybeRightParen;
  if (typeof timesOrNode === "number") {
    times = timesOrNode | 0;
    node = nodeOrSourceCode;
    sourceCode = optionalSourceCode;
    if (!(times >= 1)) {
      throw new TypeError("'times' should be a positive integer.");
    }
  } else {
    times = 1;
    node = timesOrNode;
    sourceCode = nodeOrSourceCode;
  }
  if (node == null || // `Program` can't be parenthesized
  node.parent == null || // `CatchClause.param` can't be parenthesized, example `try {} catch (error) {}`
  node.parent.type === "CatchClause" && node.parent.param === node) {
    return false;
  }
  maybeLeftParen = maybeRightParen = node;
  do {
    maybeLeftParen = sourceCode.getTokenBefore(maybeLeftParen);
    maybeRightParen = sourceCode.getTokenAfter(maybeRightParen);
  } while (maybeLeftParen != null && maybeRightParen != null && isOpeningParenToken225(maybeLeftParen) && isClosingParenToken225(maybeRightParen) && // Avoid false positive such as `if (a) {}`
  maybeLeftParen !== getParentSyntaxParen225(node, sourceCode) && --times > 0);
  return times === 0;
}
Function.call.bind(Object.hasOwnProperty);
var __defProp2225 = Object.defineProperty;
var __export2225 = (target, all32222) => {
  for (var name22 in all32222)
    __defProp2225(target, name22, { get: all32222[name22], enumerable: true });
};
var NodeType225 = types.AST_NODE_TYPES;
var is225 = utils.ASTUtils.isNodeOfType;
var isOneOf225 = utils.ASTUtils.isNodeOfTypes;
isOneOf225([
  NodeType225.ArrowFunctionExpression,
  NodeType225.FunctionDeclaration,
  NodeType225.FunctionExpression
]);
isOneOf225([
  NodeType225.ArrowFunctionExpression,
  NodeType225.FunctionDeclaration,
  NodeType225.FunctionExpression,
  NodeType225.TSCallSignatureDeclaration,
  NodeType225.TSConstructSignatureDeclaration,
  NodeType225.TSDeclareFunction,
  NodeType225.TSEmptyBodyFunctionExpression,
  NodeType225.TSFunctionType,
  NodeType225.TSMethodSignature
]);
isOneOf225([NodeType225.ClassDeclaration, NodeType225.ClassExpression]);
isOneOf225([
  NodeType225.DoWhileStatement,
  NodeType225.ForInStatement,
  NodeType225.ForOfStatement,
  NodeType225.ForStatement,
  NodeType225.WhileStatement
]);
isOneOf225([NodeType225.TSArrayType, NodeType225.TSTupleType]);
isOneOf225([
  NodeType225.PropertyDefinition,
  NodeType225.TSIndexSignature,
  NodeType225.TSParameterProperty,
  NodeType225.TSPropertySignature
]);
is225(NodeType225.JSXElement);
is225(NodeType225.JSXFragment);
isOneOf225([
  NodeType225.JSXAttribute,
  NodeType225.JSXSpreadChild,
  NodeType225.JSXClosingElement,
  NodeType225.JSXClosingFragment,
  NodeType225.JSXElement,
  NodeType225.JSXEmptyExpression,
  NodeType225.JSXExpressionContainer,
  NodeType225.JSXFragment,
  NodeType225.JSXIdentifier,
  NodeType225.JSXMemberExpression,
  NodeType225.JSXNamespacedName,
  NodeType225.JSXOpeningElement,
  NodeType225.JSXOpeningFragment,
  NodeType225.JSXSpreadAttribute,
  NodeType225.JSXSpreadChild,
  NodeType225.JSXText
]);
var isJSXTagNameExpression2 = isOneOf225([
  NodeType225.JSXIdentifier,
  NodeType225.JSXMemberExpression,
  NodeType225.JSXNamespacedName
]);
isOneOf225([
  NodeType225.ArrayPattern,
  NodeType225.AssignmentPattern,
  NodeType225.ObjectPattern,
  NodeType225.RestElement
]);
isOneOf225([
  NodeType225.TSInterfaceDeclaration,
  NodeType225.TSTypeAliasDeclaration
]);
isOneOf225([
  NodeType225.ArrayExpression,
  NodeType225.ArrayPattern,
  NodeType225.ArrowFunctionExpression,
  NodeType225.CallExpression,
  NodeType225.ClassExpression,
  NodeType225.FunctionExpression,
  NodeType225.Identifier,
  NodeType225.JSXElement,
  NodeType225.JSXFragment,
  NodeType225.Literal,
  NodeType225.TemplateLiteral,
  NodeType225.MemberExpression,
  NodeType225.MetaProperty,
  NodeType225.ObjectExpression,
  NodeType225.ObjectPattern,
  NodeType225.SequenceExpression,
  NodeType225.Super,
  NodeType225.TaggedTemplateExpression,
  NodeType225.ThisExpression
]);
isOneOf225([
  NodeType225.ArrayExpression,
  NodeType225.ArrayPattern,
  NodeType225.ArrowFunctionExpression,
  NodeType225.CallExpression,
  NodeType225.ClassExpression,
  NodeType225.FunctionExpression,
  NodeType225.Identifier,
  NodeType225.JSXElement,
  NodeType225.JSXFragment,
  NodeType225.Literal,
  NodeType225.TemplateLiteral,
  NodeType225.MemberExpression,
  NodeType225.MetaProperty,
  NodeType225.ObjectExpression,
  NodeType225.ObjectPattern,
  NodeType225.SequenceExpression,
  NodeType225.Super,
  NodeType225.TaggedTemplateExpression,
  NodeType225.ThisExpression,
  NodeType225.TSAsExpression,
  NodeType225.TSNonNullExpression,
  NodeType225.TSTypeAssertion
]);
var Function_exports225 = {};
__export2225(Function_exports225, {
  SK: () => SK225,
  absurd: () => absurd225,
  apply: () => apply225,
  compose: () => compose325,
  constFalse: () => constFalse225,
  constNull: () => constNull225,
  constTrue: () => constTrue225,
  constUndefined: () => constUndefined225,
  constVoid: () => constVoid225,
  constant: () => constant225,
  dual: () => dual225,
  flip: () => flip225,
  flow: () => flow225,
  hole: () => hole225,
  identity: () => identity225,
  isFunction: () => isFunction2225,
  pipe: () => pipe225,
  satisfies: () => satisfies225,
  tupled: () => tupled225,
  unsafeCoerce: () => unsafeCoerce225,
  untupled: () => untupled225
});
var isFunction2225 = (input) => typeof input === "function";
var dual225 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a2222, b2222) {
        if (arguments.length >= 2) {
          return body(a2222, b2222);
        }
        return function(self2) {
          return body(self2, a2222);
        };
      };
    case 3:
      return function(a2222, b2222, c2222) {
        if (arguments.length >= 3) {
          return body(a2222, b2222, c2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222);
        };
      };
    case 4:
      return function(a2222, b2222, c2222, d2222) {
        if (arguments.length >= 4) {
          return body(a2222, b2222, c2222, d2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222);
        };
      };
    case 5:
      return function(a2222, b2222, c2222, d2222, e2222) {
        if (arguments.length >= 5) {
          return body(a2222, b2222, c2222, d2222, e2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222, d2222);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply225 = (a2222) => (self2) => self2(a2222);
var identity225 = (a2222) => a2222;
var satisfies225 = () => (b2222) => b2222;
var unsafeCoerce225 = identity225;
var constant225 = (value) => () => value;
var constTrue225 = /* @__PURE__ */ constant225(true);
var constFalse225 = /* @__PURE__ */ constant225(false);
var constNull225 = /* @__PURE__ */ constant225(null);
var constUndefined225 = /* @__PURE__ */ constant225(void 0);
var constVoid225 = constUndefined225;
var flip225 = (f2222) => (...b2222) => (...a2222) => f2222(...a2222)(...b2222);
var compose325 = /* @__PURE__ */ dual225(2, (ab, bc) => (a2222) => bc(ab(a2222)));
var absurd225 = (_2222) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled225 = (f2222) => (a2222) => f2222(...a2222);
var untupled225 = (f2222) => (...a2222) => f2222(a2222);
function pipe225(a2222, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a2222;
    case 2:
      return ab(a2222);
    case 3:
      return bc(ab(a2222));
    case 4:
      return cd(bc(ab(a2222)));
    case 5:
      return de(cd(bc(ab(a2222))));
    case 6:
      return ef(de(cd(bc(ab(a2222)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a2222))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a2222)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a2222))))))));
    default: {
      let ret = arguments[0];
      for (let i2222 = 1; i2222 < arguments.length; i2222++) {
        ret = arguments[i2222](ret);
      }
      return ret;
    }
  }
}
function flow225(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole225 = /* @__PURE__ */ unsafeCoerce225(absurd225);
var SK225 = (_2222, b2222) => b2222;
var make625 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_325 = (map622) => dual225(3, (self2, name22, f2222) => map622(self2, (a2222) => Object.assign({}, a2222, {
  [name22]: f2222(a2222)
})));
var bindTo325 = (map622) => dual225(2, (self2, name22) => map622(self2, (a2222) => ({
  [name22]: a2222
})));
var bind325 = (map622, flatMap4222) => dual225(3, (self2, name22, f2222) => flatMap4222(self2, (a2222) => map622(f2222(a2222), (b2222) => Object.assign({}, a2222, {
  [name22]: b2222
}))));
var moduleVersion225 = "3.2.8";
var getCurrentVersion225 = () => moduleVersion225;
var globalStoreId225 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion225()}`);
if (!(globalStoreId225 in globalThis)) {
  globalThis[globalStoreId225] = /* @__PURE__ */ new Map();
}
var globalStore225 = globalThis[globalStoreId225];
var globalValue225 = (id, compute) => {
  if (!globalStore225.has(id)) {
    globalStore225.set(id, compute());
  }
  return globalStore225.get(id);
};
var Predicate_exports225 = {};
__export2225(Predicate_exports225, {
  all: () => all325,
  and: () => and225,
  compose: () => compose2225,
  eqv: () => eqv225,
  every: () => every225,
  hasProperty: () => hasProperty225,
  implies: () => implies225,
  isBigInt: () => isBigInt225,
  isBoolean: () => isBoolean225,
  isDate: () => isDate225,
  isError: () => isError225,
  isFunction: () => isFunction3225,
  isIterable: () => isIterable225,
  isMap: () => isMap225,
  isNever: () => isNever225,
  isNotNull: () => isNotNull225,
  isNotNullable: () => isNotNullable225,
  isNotUndefined: () => isNotUndefined225,
  isNull: () => isNull225,
  isNullable: () => isNullable225,
  isNumber: () => isNumber225,
  isObject: () => isObject225,
  isPromise: () => isPromise225,
  isPromiseLike: () => isPromiseLike225,
  isReadonlyRecord: () => isReadonlyRecord225,
  isRecord: () => isRecord225,
  isSet: () => isSet225,
  isString: () => isString225,
  isSymbol: () => isSymbol225,
  isTagged: () => isTagged225,
  isTruthy: () => isTruthy225,
  isUint8Array: () => isUint8Array225,
  isUndefined: () => isUndefined225,
  isUnknown: () => isUnknown225,
  mapInput: () => mapInput225,
  nand: () => nand225,
  nor: () => nor225,
  not: () => not225,
  or: () => or225,
  product: () => product325,
  productMany: () => productMany325,
  some: () => some425,
  struct: () => struct425,
  tuple: () => tuple325,
  xor: () => xor225
});
var mapInput225 = /* @__PURE__ */ dual225(2, (self2, f2222) => (b2222) => self2(f2222(b2222)));
var isTruthy225 = (input) => !!input;
var isSet225 = (input) => input instanceof Set;
var isMap225 = (input) => input instanceof Map;
var isString225 = (input) => typeof input === "string";
var isNumber225 = (input) => typeof input === "number";
var isBoolean225 = (input) => typeof input === "boolean";
var isBigInt225 = (input) => typeof input === "bigint";
var isSymbol225 = (input) => typeof input === "symbol";
var isFunction3225 = isFunction2225;
var isUndefined225 = (input) => input === void 0;
var isNotUndefined225 = (input) => input !== void 0;
var isNull225 = (input) => input === null;
var isNotNull225 = (input) => input !== null;
var isNever225 = (_2222) => false;
var isUnknown225 = (_2222) => true;
var isRecordOrArray225 = (input) => typeof input === "object" && input !== null;
var isObject225 = (input) => isRecordOrArray225(input) || isFunction3225(input);
var hasProperty225 = /* @__PURE__ */ dual225(2, (self2, property) => isObject225(self2) && property in self2);
var isTagged225 = /* @__PURE__ */ dual225(2, (self2, tag) => hasProperty225(self2, "_tag") && self2["_tag"] === tag);
var isNullable225 = (input) => input === null || input === void 0;
var isNotNullable225 = (input) => input !== null && input !== void 0;
var isError225 = (input) => input instanceof Error;
var isUint8Array225 = (input) => input instanceof Uint8Array;
var isDate225 = (input) => input instanceof Date;
var isIterable225 = (input) => hasProperty225(input, Symbol.iterator);
var isRecord225 = (input) => isRecordOrArray225(input) && !Array.isArray(input);
var isReadonlyRecord225 = isRecord225;
var isPromise225 = (input) => hasProperty225(input, "then") && "catch" in input && isFunction3225(input.then) && isFunction3225(input.catch);
var isPromiseLike225 = (input) => hasProperty225(input, "then") && isFunction3225(input.then);
var compose2225 = /* @__PURE__ */ dual225(2, (ab, bc) => (a2222) => ab(a2222) && bc(a2222));
var product325 = (self2, that) => ([a2222, b2222]) => self2(a2222) && that(b2222);
var all325 = (collection) => {
  return (as2322) => {
    let collectionIndex = 0;
    for (const p2222 of collection) {
      if (collectionIndex >= as2322.length) {
        break;
      }
      if (p2222(as2322[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany325 = (self2, collection) => {
  const rest = all325(collection);
  return ([head222, ...tail222]) => self2(head222) === false ? false : rest(tail222);
};
var tuple325 = (...elements) => all325(elements);
var struct425 = (fields) => {
  const keys22222 = Object.keys(fields);
  return (a2222) => {
    for (const key of keys22222) {
      if (!fields[key](a2222[key])) {
        return false;
      }
    }
    return true;
  };
};
var not225 = (self2) => (a2222) => !self2(a2222);
var or225 = /* @__PURE__ */ dual225(2, (self2, that) => (a2222) => self2(a2222) || that(a2222));
var and225 = /* @__PURE__ */ dual225(2, (self2, that) => (a2222) => self2(a2222) && that(a2222));
var xor225 = /* @__PURE__ */ dual225(2, (self2, that) => (a2222) => self2(a2222) !== that(a2222));
var eqv225 = /* @__PURE__ */ dual225(2, (self2, that) => (a2222) => self2(a2222) === that(a2222));
var implies225 = /* @__PURE__ */ dual225(2, (self2, that) => (a2222) => self2(a2222) ? that(a2222) : true);
var nor225 = /* @__PURE__ */ dual225(2, (self2, that) => (a2222) => !(self2(a2222) || that(a2222)));
var nand225 = /* @__PURE__ */ dual225(2, (self2, that) => (a2222) => !(self2(a2222) && that(a2222)));
var every225 = (collection) => (a2222) => {
  for (const p2222 of collection) {
    if (!p2222(a2222)) {
      return false;
    }
  }
  return true;
};
var some425 = (collection) => (a2222) => {
  for (const p2222 of collection) {
    if (p2222(a2222)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage225 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId225 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind225 = (u2222) => isObject225(u2222) && GenKindTypeId225 in u2222;
var GenKindImpl225 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity225;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId225] = GenKindTypeId225;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen325(this);
  }
};
var SingleShotGen325 = class _SingleShotGen325 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a2222) {
    return this.called ? {
      value: a2222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a2222) {
    return {
      value: a2222,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e2222) {
    throw e2222;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen325(this.self);
  }
};
var adapter325 = () => function() {
  let x2222 = arguments[0];
  for (let i2222 = 1; i2222 < arguments.length; i2222++) {
    x2222 = arguments[i2222](x2222);
  }
  return new GenKindImpl225(x2222);
};
var defaultIncHi225 = 335903614;
var defaultIncLo225 = 4150755663;
var MUL_HI225 = 1481765933 >>> 0;
var MUL_LO225 = 1284865837 >>> 0;
var BIT_53225 = 9007199254740992;
var BIT_27225 = 134217728;
var PCGRandom225 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable225(seedLo) && isNullable225(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable225(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable225(incLo) && isNullable225(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo225;
      incHi = this._state ? this._state[2] : defaultIncHi225;
    } else if (isNullable225(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add64225(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max322) {
    if (!max322) {
      return this._next();
    }
    max322 = max322 >>> 0;
    if ((max322 & max322 - 1) === 0) {
      return this._next() & max322 - 1;
    }
    let num = 0;
    const skew = (-max322 >>> 0) % max322 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max322;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_27225 + lo) / BIT_53225;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul64225(this._state, oldHi, oldLo, MUL_HI225, MUL_LO225);
    add64225(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul64225(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add64225(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId225 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap225 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId225]() {
    return this.#value;
  }
};
function yieldWrapGet225(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId225 in self2) {
    return self2[YieldWrapTypeId225]();
  }
  throw new Error(getBugErrorMessage225("yieldWrapGet"));
}
var structuralRegionState225 = /* @__PURE__ */ globalValue225("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache225 = /* @__PURE__ */ globalValue225(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr225 = /* @__PURE__ */ globalValue225(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom225());
var symbol325 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash225 = (self2) => {
  if (structuralRegionState225.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number225(self2);
    case "bigint":
      return string225(self2.toString(10));
    case "boolean":
      return string225(String(self2));
    case "symbol":
      return string225(String(self2));
    case "string":
      return string225(self2);
    case "undefined":
      return string225("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string225("null");
      } else if (self2 instanceof Date) {
        return hash225(self2.toISOString());
      } else if (isHash225(self2)) {
        return self2[symbol325]();
      } else {
        return random225(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random225 = (self2) => {
  if (!randomHashCache225.has(self2)) {
    randomHashCache225.set(self2, number225(pcgr225.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache225.get(self2);
};
var combine325 = (b2222) => (self2) => self2 * 53 ^ b2222;
var optimize225 = (n2222) => n2222 & 3221225471 | n2222 >>> 1 & 1073741824;
var isHash225 = (u2222) => hasProperty225(u2222, symbol325);
var number225 = (n2222) => {
  if (n2222 !== n2222 || n2222 === Infinity) {
    return 0;
  }
  let h2222 = n2222 | 0;
  if (h2222 !== n2222) {
    h2222 ^= n2222 * 4294967295;
  }
  while (n2222 > 4294967295) {
    h2222 ^= n2222 /= 4294967295;
  }
  return optimize225(n2222);
};
var string225 = (str) => {
  let h2222 = 5381, i2222 = str.length;
  while (i2222) {
    h2222 = h2222 * 33 ^ str.charCodeAt(--i2222);
  }
  return optimize225(h2222);
};
var structureKeys225 = (o2222, keys22222) => {
  let h2222 = 12289;
  for (let i2222 = 0; i2222 < keys22222.length; i2222++) {
    h2222 ^= pipe225(string225(keys22222[i2222]), combine325(hash225(o2222[keys22222[i2222]])));
  }
  return optimize225(h2222);
};
var structure225 = (o2222) => structureKeys225(o2222, Object.keys(o2222));
var array325 = (arr) => {
  let h2222 = 6151;
  for (let i2222 = 0; i2222 < arr.length; i2222++) {
    h2222 = pipe225(h2222, combine325(hash225(arr[i2222])));
  }
  return optimize225(h2222);
};
var cached225 = function() {
  if (arguments.length === 1) {
    const self22 = arguments[0];
    return function(hash3222) {
      Object.defineProperty(self22, symbol325, {
        value() {
          return hash3222;
        },
        enumerable: false
      });
      return hash3222;
    };
  }
  const self2 = arguments[0];
  const hash2322 = arguments[1];
  Object.defineProperty(self2, symbol325, {
    value() {
      return hash2322;
    },
    enumerable: false
  });
  return hash2322;
};
var symbol2225 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals225() {
  if (arguments.length === 1) {
    return (self2) => compareBoth225(self2, arguments[0]);
  }
  return compareBoth225(arguments[0], arguments[1]);
}
function compareBoth225(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual225(self2) && isEqual225(that)) {
        if (hash225(self2) === hash225(that) && self2[symbol2225](that)) {
          return true;
        } else {
          return structuralRegionState225.enabled && structuralRegionState225.tester ? structuralRegionState225.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState225.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v2222, i2222) => compareBoth225(v2222, that[i2222]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth225(self2[key], that[key]))) {
              return structuralRegionState225.tester ? structuralRegionState225.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState225.tester ? structuralRegionState225.tester(self2, that) : false;
    }
  }
  return structuralRegionState225.enabled && structuralRegionState225.tester ? structuralRegionState225.tester(self2, that) : false;
}
var isEqual225 = (u2222) => hasProperty225(u2222, symbol2225);
var equivalence225 = () => equals225;
var NodeInspectSymbol225 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON225 = (x2222) => {
  if (hasProperty225(x2222, "toJSON") && isFunction3225(x2222["toJSON"]) && x2222["toJSON"].length === 0) {
    return x2222.toJSON();
  } else if (Array.isArray(x2222)) {
    return x2222.map(toJSON225);
  }
  return x2222;
};
var format225 = (x2222) => JSON.stringify(x2222, null, 2);
var pipeArguments225 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i2222 = 0, len = args.length; i2222 < len; i2222++) {
        ret = args[i2222](ret);
      }
      return ret;
    }
  }
};
var OP_COMMIT225 = "Commit";
var OP_FAILURE225 = "Failure";
var OP_WITH_RUNTIME225 = "WithRuntime";
var EffectTypeId325 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId225 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId225 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId225 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance225 = {
  /* c8 ignore next */
  _R: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _A: (_2222) => _2222,
  _V: /* @__PURE__ */ getCurrentVersion225()
};
var sinkVariance225 = {
  /* c8 ignore next */
  _A: (_2222) => _2222,
  /* c8 ignore next */
  _In: (_2222) => _2222,
  /* c8 ignore next */
  _L: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _R: (_2222) => _2222
};
var channelVariance225 = {
  /* c8 ignore next */
  _Env: (_2222) => _2222,
  /* c8 ignore next */
  _InErr: (_2222) => _2222,
  /* c8 ignore next */
  _InElem: (_2222) => _2222,
  /* c8 ignore next */
  _InDone: (_2222) => _2222,
  /* c8 ignore next */
  _OutErr: (_2222) => _2222,
  /* c8 ignore next */
  _OutElem: (_2222) => _2222,
  /* c8 ignore next */
  _OutDone: (_2222) => _2222
};
var EffectPrototype225 = {
  [EffectTypeId325]: effectVariance225,
  [StreamTypeId225]: effectVariance225,
  [SinkTypeId225]: sinkVariance225,
  [ChannelTypeId225]: channelVariance225,
  [symbol2225](that) {
    return this === that;
  },
  [symbol325]() {
    return cached225(this, random225(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen325(new YieldWrap225(this));
  },
  pipe() {
    return pipeArguments225(this, arguments);
  }
};
var StructuralPrototype225 = {
  [symbol325]() {
    return cached225(this, structure225(this));
  },
  [symbol2225](that) {
    const selfKeys = Object.keys(this);
    const thatKeys = Object.keys(that);
    if (selfKeys.length !== thatKeys.length) {
      return false;
    }
    for (const key of selfKeys) {
      if (!(key in that && equals225(this[key], that[key]))) {
        return false;
      }
    }
    return true;
  }
};
var CommitPrototype225 = {
  ...EffectPrototype225,
  _op: OP_COMMIT225
};
var StructuralCommitPrototype225 = {
  ...CommitPrototype225,
  ...StructuralPrototype225
};
var TypeId625 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto325 = {
  ...EffectPrototype225,
  [TypeId625]: {
    _A: (_2222) => _2222
  },
  [NodeInspectSymbol225]() {
    return this.toJSON();
  },
  toString() {
    return format225(this.toJSON());
  }
};
var SomeProto225 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto325), {
  _tag: "Some",
  _op: "Some",
  [symbol2225](that) {
    return isOption325(that) && isSome325(that) && equals225(this.value, that.value);
  },
  [symbol325]() {
    return cached225(this, combine325(hash225(this._tag))(hash225(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON225(this.value)
    };
  }
});
var NoneHash225 = /* @__PURE__ */ hash225("None");
var NoneProto225 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto325), {
  _tag: "None",
  _op: "None",
  [symbol2225](that) {
    return isOption325(that) && isNone325(that);
  },
  [symbol325]() {
    return NoneHash225;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption325 = (input) => hasProperty225(input, TypeId625);
var isNone325 = (fa) => fa._tag === "None";
var isSome325 = (fa) => fa._tag === "Some";
var none325 = /* @__PURE__ */ Object.create(NoneProto225);
var some2225 = (value) => {
  const a2222 = Object.create(SomeProto225);
  a2222.value = value;
  return a2222;
};
var TypeId2225 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto2225 = {
  ...EffectPrototype225,
  [TypeId2225]: {
    _R: (_2222) => _2222
  },
  [NodeInspectSymbol225]() {
    return this.toJSON();
  },
  toString() {
    return format225(this.toJSON());
  }
};
var RightProto225 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto2225), {
  _tag: "Right",
  _op: "Right",
  [symbol2225](that) {
    return isEither225(that) && isRight225(that) && equals225(this.right, that.right);
  },
  [symbol325]() {
    return combine325(hash225(this._tag))(hash225(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON225(this.right)
    };
  }
});
var LeftProto225 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto2225), {
  _tag: "Left",
  _op: "Left",
  [symbol2225](that) {
    return isEither225(that) && isLeft225(that) && equals225(this.left, that.left);
  },
  [symbol325]() {
    return combine325(hash225(this._tag))(hash225(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON225(this.left)
    };
  }
});
var isEither225 = (input) => hasProperty225(input, TypeId2225);
var isLeft225 = (ma) => ma._tag === "Left";
var isRight225 = (ma) => ma._tag === "Right";
var left325 = (left32222) => {
  const a2222 = Object.create(LeftProto225);
  a2222.left = left32222;
  return a2222;
};
var right325 = (right32222) => {
  const a2222 = Object.create(RightProto225);
  a2222.right = right32222;
  return a2222;
};
var getLeft325 = (self2) => isRight225(self2) ? none325 : some2225(self2.left);
var getRight325 = (self2) => isLeft225(self2) ? none325 : some2225(self2.right);
var right2225 = right325;
var left2225 = left325;
var Option_exports225 = {};
__export2225(Option_exports225, {
  Do: () => Do225,
  TypeId: () => TypeId3225,
  all: () => all2225,
  andThen: () => andThen225,
  ap: () => ap225,
  as: () => as225,
  asVoid: () => asVoid225,
  bind: () => bind2225,
  bindTo: () => bindTo2225,
  composeK: () => composeK225,
  contains: () => contains225,
  containsWith: () => containsWith225,
  exists: () => exists225,
  filter: () => filter225,
  filterMap: () => filterMap225,
  firstSomeOf: () => firstSomeOf225,
  flatMap: () => flatMap225,
  flatMapNullable: () => flatMapNullable225,
  flatten: () => flatten225,
  fromIterable: () => fromIterable325,
  fromNullable: () => fromNullable225,
  gen: () => gen225,
  getEquivalence: () => getEquivalence325,
  getLeft: () => getLeft2225,
  getOrElse: () => getOrElse225,
  getOrNull: () => getOrNull225,
  getOrThrow: () => getOrThrow225,
  getOrThrowWith: () => getOrThrowWith225,
  getOrUndefined: () => getOrUndefined225,
  getOrder: () => getOrder225,
  getRight: () => getRight2225,
  isNone: () => isNone2225,
  isOption: () => isOption2225,
  isSome: () => isSome2225,
  let: () => let_2225,
  lift2: () => lift2225,
  liftNullable: () => liftNullable225,
  liftPredicate: () => liftPredicate225,
  liftThrowable: () => liftThrowable225,
  map: () => map225,
  match: () => match2225,
  none: () => none2225,
  orElse: () => orElse225,
  orElseEither: () => orElseEither225,
  orElseSome: () => orElseSome225,
  partitionMap: () => partitionMap225,
  product: () => product2225,
  productMany: () => productMany2225,
  reduceCompact: () => reduceCompact225,
  some: () => some3225,
  tap: () => tap225,
  toArray: () => toArray225,
  toRefinement: () => toRefinement225,
  void: () => void_225,
  zipLeft: () => zipLeft225,
  zipRight: () => zipRight225,
  zipWith: () => zipWith225
});
var make2225 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId3225 = /* @__PURE__ */ Symbol.for("effect/Option");
var none2225 = () => none325;
var some3225 = some2225;
var isOption2225 = isOption325;
var isNone2225 = isNone325;
var isSome2225 = isSome325;
var match2225 = /* @__PURE__ */ dual225(2, (self2, {
  onNone,
  onSome
}) => isNone2225(self2) ? onNone() : onSome(self2.value));
var toRefinement225 = (f2222) => (a2222) => isSome2225(f2222(a2222));
var fromIterable325 = (collection) => {
  for (const a2222 of collection) {
    return some3225(a2222);
  }
  return none2225();
};
var getRight2225 = getRight325;
var getLeft2225 = getLeft325;
var getOrElse225 = /* @__PURE__ */ dual225(2, (self2, onNone) => isNone2225(self2) ? onNone() : self2.value);
var orElse225 = /* @__PURE__ */ dual225(2, (self2, that) => isNone2225(self2) ? that() : self2);
var orElseSome225 = /* @__PURE__ */ dual225(2, (self2, onNone) => isNone2225(self2) ? some3225(onNone()) : self2);
var orElseEither225 = /* @__PURE__ */ dual225(2, (self2, that) => isNone2225(self2) ? map225(that(), right325) : map225(self2, left325));
var firstSomeOf225 = (collection) => {
  let out = none2225();
  for (out of collection) {
    if (isSome2225(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable225 = (nullableValue) => nullableValue == null ? none2225() : some3225(nullableValue);
var liftNullable225 = (f2222) => (...a2222) => fromNullable225(f2222(...a2222));
var getOrNull225 = /* @__PURE__ */ getOrElse225(constNull225);
var getOrUndefined225 = /* @__PURE__ */ getOrElse225(constUndefined225);
var liftThrowable225 = (f2222) => (...a2222) => {
  try {
    return some3225(f2222(...a2222));
  } catch (e2222) {
    return none2225();
  }
};
var getOrThrowWith225 = /* @__PURE__ */ dual225(2, (self2, onNone) => {
  if (isSome2225(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow225 = /* @__PURE__ */ getOrThrowWith225(() => new Error("getOrThrow called on a None"));
var map225 = /* @__PURE__ */ dual225(2, (self2, f2222) => isNone2225(self2) ? none2225() : some3225(f2222(self2.value)));
var as225 = /* @__PURE__ */ dual225(2, (self2, b2222) => map225(self2, () => b2222));
var asVoid225 = /* @__PURE__ */ as225(void 0);
var void_225 = /* @__PURE__ */ some3225(void 0);
var flatMap225 = /* @__PURE__ */ dual225(2, (self2, f2222) => isNone2225(self2) ? none2225() : f2222(self2.value));
var andThen225 = /* @__PURE__ */ dual225(2, (self2, f2222) => flatMap225(self2, (a2222) => {
  const b2222 = isFunction2225(f2222) ? f2222(a2222) : f2222;
  return isOption2225(b2222) ? b2222 : some3225(b2222);
}));
var flatMapNullable225 = /* @__PURE__ */ dual225(2, (self2, f2222) => isNone2225(self2) ? none2225() : fromNullable225(f2222(self2.value)));
var flatten225 = /* @__PURE__ */ flatMap225(identity225);
var zipRight225 = /* @__PURE__ */ dual225(2, (self2, that) => flatMap225(self2, () => that));
var composeK225 = /* @__PURE__ */ dual225(2, (afb, bfc) => (a2222) => flatMap225(afb(a2222), bfc));
var zipLeft225 = /* @__PURE__ */ dual225(2, (self2, that) => tap225(self2, () => that));
var tap225 = /* @__PURE__ */ dual225(2, (self2, f2222) => flatMap225(self2, (a2222) => map225(f2222(a2222), () => a2222)));
var product2225 = (self2, that) => isSome2225(self2) && isSome2225(that) ? some3225([self2.value, that.value]) : none2225();
var productMany2225 = (self2, collection) => {
  if (isNone2225(self2)) {
    return none2225();
  }
  const out = [self2.value];
  for (const o2222 of collection) {
    if (isNone2225(o2222)) {
      return none2225();
    }
    out.push(o2222.value);
  }
  return some3225(out);
};
var all2225 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o2222 of input) {
      if (isNone2225(o2222)) {
        return none2225();
      }
      out2.push(o2222.value);
    }
    return some3225(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o2222 = input[key];
    if (isNone2225(o2222)) {
      return none2225();
    }
    out[key] = o2222.value;
  }
  return some3225(out);
};
var zipWith225 = /* @__PURE__ */ dual225(3, (self2, that, f2222) => map225(product2225(self2, that), ([a2222, b2222]) => f2222(a2222, b2222)));
var ap225 = /* @__PURE__ */ dual225(2, (self2, that) => zipWith225(self2, that, (f2222, a2222) => f2222(a2222)));
var reduceCompact225 = /* @__PURE__ */ dual225(3, (self2, b2222, f2222) => {
  let out = b2222;
  for (const oa of self2) {
    if (isSome2225(oa)) {
      out = f2222(out, oa.value);
    }
  }
  return out;
});
var toArray225 = (self2) => isNone2225(self2) ? [] : [self2.value];
var partitionMap225 = /* @__PURE__ */ dual225(2, (self2, f2222) => {
  if (isNone2225(self2)) {
    return [none2225(), none2225()];
  }
  const e2222 = f2222(self2.value);
  return isLeft225(e2222) ? [some3225(e2222.left), none2225()] : [none2225(), some3225(e2222.right)];
});
var filterMap225 = /* @__PURE__ */ dual225(2, (self2, f2222) => isNone2225(self2) ? none2225() : f2222(self2.value));
var filter225 = /* @__PURE__ */ dual225(2, (self2, predicate) => filterMap225(self2, (b2222) => predicate(b2222) ? some2225(b2222) : none325));
var getEquivalence325 = (isEquivalent) => make625((x2222, y2222) => x2222 === y2222 || (isNone2225(x2222) ? isNone2225(y2222) : isNone2225(y2222) ? false : isEquivalent(x2222.value, y2222.value)));
var getOrder225 = (O2222) => make2225((self2, that) => isSome2225(self2) ? isSome2225(that) ? O2222(self2.value, that.value) : 1 : -1);
var lift2225 = (f2222) => dual225(2, (self2, that) => zipWith225(self2, that, f2222));
var liftPredicate225 = (predicate) => (b2222) => predicate(b2222) ? some3225(b2222) : none2225();
var containsWith225 = (isEquivalent) => dual225(2, (self2, a2222) => isNone2225(self2) ? false : isEquivalent(self2.value, a2222));
var _equivalence325 = /* @__PURE__ */ equivalence225();
var contains225 = /* @__PURE__ */ containsWith225(_equivalence325);
var exists225 = /* @__PURE__ */ dual225(2, (self2, refinement) => isNone2225(self2) ? false : refinement(self2.value));
var bindTo2225 = /* @__PURE__ */ bindTo325(map225);
var let_2225 = /* @__PURE__ */ let_325(map225);
var bind2225 = /* @__PURE__ */ bind325(map225, flatMap225);
var Do225 = /* @__PURE__ */ some3225({});
var adapter2225 = /* @__PURE__ */ adapter325();
var gen225 = (f2222) => {
  const iterator = f2222(adapter2225);
  let state = iterator.next();
  if (state.done) {
    return some3225(state.value);
  } else {
    let current = state.value;
    if (isGenKind225(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet225(current);
    }
    if (isNone2225(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind225(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet225(current);
        }
        if (isNone2225(current)) {
          return current;
        }
      }
    }
    return some3225(state.value);
  }
};
var fromIterable2225 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var reverse325 = (self2) => Array.from(self2).reverse();
var reduce325 = /* @__PURE__ */ dual225(3, (self2, b2222, f2222) => fromIterable2225(self2).reduce((b22222, a2222, i2222) => f2222(b22222, a2222, i2222), b2222));
var TagTypeId225 = /* @__PURE__ */ Symbol.for("effect/Context/Tag");
var STMSymbolKey225 = "effect/STM";
var STMTypeId225 = /* @__PURE__ */ Symbol.for(STMSymbolKey225);
var TagProto225 = {
  ...EffectPrototype225,
  _tag: "Tag",
  _op: "Tag",
  [STMTypeId225]: effectVariance225,
  [TagTypeId225]: {
    _Service: (_2222) => _2222,
    _Identifier: (_2222) => _2222
  },
  toString() {
    return format225(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Tag",
      key: this.key,
      stack: this.stack
    };
  },
  [NodeInspectSymbol225]() {
    return this.toJSON();
  },
  of(self2) {
    return self2;
  },
  context(self2) {
    return make3225(this, self2);
  }
};
var makeGenericTag225 = (key) => {
  const limit = Error.stackTraceLimit;
  Error.stackTraceLimit = 2;
  const creationError = new Error();
  Error.stackTraceLimit = limit;
  const tag = Object.create(TagProto225);
  Object.defineProperty(tag, "stack", {
    get() {
      return creationError.stack;
    }
  });
  tag.key = key;
  return tag;
};
var TypeId4225 = /* @__PURE__ */ Symbol.for("effect/Context");
var ContextProto225 = {
  [TypeId4225]: {
    _Services: (_2222) => _2222
  },
  [symbol2225](that) {
    if (isContext225(that)) {
      if (this.unsafeMap.size === that.unsafeMap.size) {
        for (const k2222 of this.unsafeMap.keys()) {
          if (!that.unsafeMap.has(k2222) || !equals225(this.unsafeMap.get(k2222), that.unsafeMap.get(k2222))) {
            return false;
          }
        }
        return true;
      }
    }
    return false;
  },
  [symbol325]() {
    return cached225(this, number225(this.unsafeMap.size));
  },
  pipe() {
    return pipeArguments225(this, arguments);
  },
  toString() {
    return format225(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Context",
      services: Array.from(this.unsafeMap).map(toJSON225)
    };
  },
  [NodeInspectSymbol225]() {
    return this.toJSON();
  }
};
var makeContext225 = (unsafeMap) => {
  const context = Object.create(ContextProto225);
  context.unsafeMap = unsafeMap;
  return context;
};
var isContext225 = (u2222) => hasProperty225(u2222, TypeId4225);
var _empty625 = /* @__PURE__ */ makeContext225(/* @__PURE__ */ new Map());
var empty825 = () => _empty625;
var make3225 = (tag, service) => makeContext225(/* @__PURE__ */ new Map([[tag.key, service]]));
var GenericTag225 = makeGenericTag225;
var empty2225 = empty825;
var TypeId5225 = /* @__PURE__ */ Symbol.for("effect/Chunk");
function copy225(src, srcPos, dest, destPos, len) {
  for (let i2222 = srcPos; i2222 < Math.min(src.length, srcPos + len); i2222++) {
    dest[destPos + i2222 - srcPos] = src[i2222];
  }
  return dest;
}
var emptyArray225 = [];
var getEquivalence2225 = (isEquivalent) => make625((self2, that) => self2.length === that.length && toReadonlyArray225(self2).every((value, i2222) => isEquivalent(value, unsafeGet2225(that, i2222))));
var _equivalence2225 = /* @__PURE__ */ getEquivalence2225(equals225);
var ChunkProto225 = {
  [TypeId5225]: {
    _A: (_2222) => _2222
  },
  toString() {
    return format225(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Chunk",
      values: toReadonlyArray225(this).map(toJSON225)
    };
  },
  [NodeInspectSymbol225]() {
    return this.toJSON();
  },
  [symbol2225](that) {
    return isChunk225(that) && _equivalence2225(this, that);
  },
  [symbol325]() {
    return cached225(this, array325(toReadonlyArray225(this)));
  },
  [Symbol.iterator]() {
    switch (this.backing._tag) {
      case "IArray": {
        return this.backing.array[Symbol.iterator]();
      }
      case "IEmpty": {
        return emptyArray225[Symbol.iterator]();
      }
      default: {
        return toReadonlyArray225(this)[Symbol.iterator]();
      }
    }
  },
  pipe() {
    return pipeArguments225(this, arguments);
  }
};
var makeChunk225 = (backing) => {
  const chunk = Object.create(ChunkProto225);
  chunk.backing = backing;
  switch (backing._tag) {
    case "IEmpty": {
      chunk.length = 0;
      chunk.depth = 0;
      chunk.left = chunk;
      chunk.right = chunk;
      break;
    }
    case "IConcat": {
      chunk.length = backing.left.length + backing.right.length;
      chunk.depth = 1 + Math.max(backing.left.depth, backing.right.depth);
      chunk.left = backing.left;
      chunk.right = backing.right;
      break;
    }
    case "IArray": {
      chunk.length = backing.array.length;
      chunk.depth = 0;
      chunk.left = _empty2225;
      chunk.right = _empty2225;
      break;
    }
    case "ISingleton": {
      chunk.length = 1;
      chunk.depth = 0;
      chunk.left = _empty2225;
      chunk.right = _empty2225;
      break;
    }
    case "ISlice": {
      chunk.length = backing.length;
      chunk.depth = backing.chunk.depth + 1;
      chunk.left = _empty2225;
      chunk.right = _empty2225;
      break;
    }
  }
  return chunk;
};
var isChunk225 = (u2222) => hasProperty225(u2222, TypeId5225);
var _empty2225 = /* @__PURE__ */ makeChunk225({
  _tag: "IEmpty"
});
var empty3225 = () => _empty2225;
var make4225 = (...as2322) => as2322.length === 1 ? of225(as2322[0]) : unsafeFromNonEmptyArray225(as2322);
var of225 = (a2222) => makeChunk225({
  _tag: "ISingleton",
  a: a2222
});
var copyToArray225 = (self2, array32222, initial) => {
  switch (self2.backing._tag) {
    case "IArray": {
      copy225(self2.backing.array, 0, array32222, initial, self2.length);
      break;
    }
    case "IConcat": {
      copyToArray225(self2.left, array32222, initial);
      copyToArray225(self2.right, array32222, initial + self2.left.length);
      break;
    }
    case "ISingleton": {
      array32222[initial] = self2.backing.a;
      break;
    }
    case "ISlice": {
      let i2222 = 0;
      let j2222 = initial;
      while (i2222 < self2.length) {
        array32222[j2222] = unsafeGet2225(self2, i2222);
        i2222 += 1;
        j2222 += 1;
      }
      break;
    }
  }
};
var toReadonlyArray225 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      return emptyArray225;
    }
    case "IArray": {
      return self2.backing.array;
    }
    default: {
      const arr = new Array(self2.length);
      copyToArray225(self2, arr, 0);
      self2.backing = {
        _tag: "IArray",
        array: arr
      };
      self2.left = _empty2225;
      self2.right = _empty2225;
      self2.depth = 0;
      return arr;
    }
  }
};
var reverse2225 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty":
    case "ISingleton":
      return self2;
    case "IArray": {
      return makeChunk225({
        _tag: "IArray",
        array: reverse325(self2.backing.array)
      });
    }
    case "IConcat": {
      return makeChunk225({
        _tag: "IConcat",
        left: reverse2225(self2.backing.right),
        right: reverse2225(self2.backing.left)
      });
    }
    case "ISlice":
      return unsafeFromArray225(reverse325(toReadonlyArray225(self2)));
  }
};
var unsafeFromArray225 = (self2) => makeChunk225({
  _tag: "IArray",
  array: self2
});
var unsafeFromNonEmptyArray225 = (self2) => unsafeFromArray225(self2);
var unsafeGet2225 = /* @__PURE__ */ dual225(2, (self2, index) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      throw new Error(`Index out of bounds`);
    }
    case "ISingleton": {
      if (index !== 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.a;
    }
    case "IArray": {
      if (index >= self2.length || index < 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.array[index];
    }
    case "IConcat": {
      return index < self2.left.length ? unsafeGet2225(self2.left, index) : unsafeGet2225(self2.right, index - self2.left.length);
    }
    case "ISlice": {
      return unsafeGet2225(self2.backing.chunk, index + self2.backing.offset);
    }
  }
});
var prepend225 = /* @__PURE__ */ dual225(2, (self2, elem) => appendAll225(of225(elem), self2));
var drop225 = /* @__PURE__ */ dual225(2, (self2, n2222) => {
  if (n2222 <= 0) {
    return self2;
  } else if (n2222 >= self2.length) {
    return _empty2225;
  } else {
    switch (self2.backing._tag) {
      case "ISlice": {
        return makeChunk225({
          _tag: "ISlice",
          chunk: self2.backing.chunk,
          offset: self2.backing.offset + n2222,
          length: self2.backing.length - n2222
        });
      }
      case "IConcat": {
        if (n2222 > self2.left.length) {
          return drop225(self2.right, n2222 - self2.left.length);
        }
        return makeChunk225({
          _tag: "IConcat",
          left: drop225(self2.left, n2222),
          right: self2.right
        });
      }
      default: {
        return makeChunk225({
          _tag: "ISlice",
          chunk: self2,
          offset: n2222,
          length: self2.length - n2222
        });
      }
    }
  }
});
var appendAll225 = /* @__PURE__ */ dual225(2, (self2, that) => {
  if (self2.backing._tag === "IEmpty") {
    return that;
  }
  if (that.backing._tag === "IEmpty") {
    return self2;
  }
  const diff22222 = that.depth - self2.depth;
  if (Math.abs(diff22222) <= 1) {
    return makeChunk225({
      _tag: "IConcat",
      left: self2,
      right: that
    });
  } else if (diff22222 < -1) {
    if (self2.left.depth >= self2.right.depth) {
      const nr = appendAll225(self2.right, that);
      return makeChunk225({
        _tag: "IConcat",
        left: self2.left,
        right: nr
      });
    } else {
      const nrr = appendAll225(self2.right.right, that);
      if (nrr.depth === self2.depth - 3) {
        const nr = makeChunk225({
          _tag: "IConcat",
          left: self2.right.left,
          right: nrr
        });
        return makeChunk225({
          _tag: "IConcat",
          left: self2.left,
          right: nr
        });
      } else {
        const nl = makeChunk225({
          _tag: "IConcat",
          left: self2.left,
          right: self2.right.left
        });
        return makeChunk225({
          _tag: "IConcat",
          left: nl,
          right: nrr
        });
      }
    }
  } else {
    if (that.right.depth >= that.left.depth) {
      const nl = appendAll225(self2, that.left);
      return makeChunk225({
        _tag: "IConcat",
        left: nl,
        right: that.right
      });
    } else {
      const nll = appendAll225(self2, that.left.left);
      if (nll.depth === that.depth - 3) {
        const nl = makeChunk225({
          _tag: "IConcat",
          left: nll,
          right: that.left.right
        });
        return makeChunk225({
          _tag: "IConcat",
          left: nl,
          right: that.right
        });
      } else {
        const nr = makeChunk225({
          _tag: "IConcat",
          left: that.left.right,
          right: that.right
        });
        return makeChunk225({
          _tag: "IConcat",
          left: nll,
          right: nr
        });
      }
    }
  }
});
var isEmpty225 = (self2) => self2.length === 0;
var isNonEmpty225 = (self2) => self2.length > 0;
var unsafeHead225 = (self2) => unsafeGet2225(self2, 0);
var headNonEmpty225 = unsafeHead225;
var tailNonEmpty225 = (self2) => drop225(self2, 1);
var SIZE225 = 5;
var BUCKET_SIZE225 = /* @__PURE__ */ Math.pow(2, SIZE225);
var MASK225 = BUCKET_SIZE225 - 1;
var MAX_INDEX_NODE225 = BUCKET_SIZE225 / 2;
var MIN_ARRAY_NODE225 = BUCKET_SIZE225 / 4;
function popcount225(x2222) {
  x2222 -= x2222 >> 1 & 1431655765;
  x2222 = (x2222 & 858993459) + (x2222 >> 2 & 858993459);
  x2222 = x2222 + (x2222 >> 4) & 252645135;
  x2222 += x2222 >> 8;
  x2222 += x2222 >> 16;
  return x2222 & 127;
}
function hashFragment225(shift22, h2222) {
  return h2222 >>> shift22 & MASK225;
}
function toBitmap225(x2222) {
  return 1 << x2222;
}
function fromBitmap225(bitmap, bit) {
  return popcount225(bitmap & bit - 1);
}
var make5225 = (value, previous) => ({
  value,
  previous
});
function arrayUpdate225(mutate22222, at, v2222, arr) {
  let out = arr;
  if (!mutate22222) {
    const len = arr.length;
    out = new Array(len);
    for (let i2222 = 0; i2222 < len; ++i2222) out[i2222] = arr[i2222];
  }
  out[at] = v2222;
  return out;
}
function arraySpliceOut225(mutate22222, at, arr) {
  const newLen = arr.length - 1;
  let i2222 = 0;
  let g2222 = 0;
  let out = arr;
  if (mutate22222) {
    i2222 = g2222 = at;
  } else {
    out = new Array(newLen);
    while (i2222 < at) out[g2222++] = arr[i2222++];
  }
  ++i2222;
  while (i2222 <= newLen) out[g2222++] = arr[i2222++];
  if (mutate22222) {
    out.length = newLen;
  }
  return out;
}
function arraySpliceIn225(mutate22222, at, v2222, arr) {
  const len = arr.length;
  if (mutate22222) {
    let i22222 = len;
    while (i22222 >= at) arr[i22222--] = arr[i22222];
    arr[at] = v2222;
    return arr;
  }
  let i2222 = 0, g2222 = 0;
  const out = new Array(len + 1);
  while (i2222 < at) out[g2222++] = arr[i2222++];
  out[at] = v2222;
  while (i2222 < len) out[++g2222] = arr[i2222++];
  return out;
}
var EmptyNode225 = class _EmptyNode225 {
  _tag = "EmptyNode";
  modify(edit, _shift, f2222, hash2322, key, size42222) {
    const v2222 = f2222(none2225());
    if (isNone2225(v2222)) return new _EmptyNode225();
    ++size42222.value;
    return new LeafNode225(edit, hash2322, key, v2222);
  }
};
function isEmptyNode225(a2222) {
  return isTagged225(a2222, "EmptyNode");
}
function isLeafNode225(node) {
  return isEmptyNode225(node) || node._tag === "LeafNode" || node._tag === "CollisionNode";
}
function canEditNode225(node, edit) {
  return isEmptyNode225(node) ? false : edit === node.edit;
}
var LeafNode225 = class _LeafNode225 {
  edit;
  hash;
  key;
  value;
  _tag = "LeafNode";
  constructor(edit, hash2322, key, value) {
    this.edit = edit;
    this.hash = hash2322;
    this.key = key;
    this.value = value;
  }
  modify(edit, shift22, f2222, hash2322, key, size42222) {
    if (equals225(key, this.key)) {
      const v22222 = f2222(this.value);
      if (v22222 === this.value) return this;
      else if (isNone2225(v22222)) {
        --size42222.value;
        return new EmptyNode225();
      }
      if (canEditNode225(this, edit)) {
        this.value = v22222;
        return this;
      }
      return new _LeafNode225(edit, hash2322, key, v22222);
    }
    const v2222 = f2222(none2225());
    if (isNone2225(v2222)) return this;
    ++size42222.value;
    return mergeLeaves225(edit, shift22, this.hash, this, hash2322, new _LeafNode225(edit, hash2322, key, v2222));
  }
};
var CollisionNode225 = class _CollisionNode225 {
  edit;
  hash;
  children;
  _tag = "CollisionNode";
  constructor(edit, hash2322, children) {
    this.edit = edit;
    this.hash = hash2322;
    this.children = children;
  }
  modify(edit, shift22, f2222, hash2322, key, size42222) {
    if (hash2322 === this.hash) {
      const canEdit = canEditNode225(this, edit);
      const list = this.updateCollisionList(canEdit, edit, this.hash, this.children, f2222, key, size42222);
      if (list === this.children) return this;
      return list.length > 1 ? new _CollisionNode225(edit, this.hash, list) : list[0];
    }
    const v2222 = f2222(none2225());
    if (isNone2225(v2222)) return this;
    ++size42222.value;
    return mergeLeaves225(edit, shift22, this.hash, this, hash2322, new LeafNode225(edit, hash2322, key, v2222));
  }
  updateCollisionList(mutate22222, edit, hash2322, list, f2222, key, size42222) {
    const len = list.length;
    for (let i2222 = 0; i2222 < len; ++i2222) {
      const child = list[i2222];
      if ("key" in child && equals225(key, child.key)) {
        const value = child.value;
        const newValue2 = f2222(value);
        if (newValue2 === value) return list;
        if (isNone2225(newValue2)) {
          --size42222.value;
          return arraySpliceOut225(mutate22222, i2222, list);
        }
        return arrayUpdate225(mutate22222, i2222, new LeafNode225(edit, hash2322, key, newValue2), list);
      }
    }
    const newValue = f2222(none2225());
    if (isNone2225(newValue)) return list;
    ++size42222.value;
    return arrayUpdate225(mutate22222, len, new LeafNode225(edit, hash2322, key, newValue), list);
  }
};
var IndexedNode225 = class _IndexedNode225 {
  edit;
  mask;
  children;
  _tag = "IndexedNode";
  constructor(edit, mask, children) {
    this.edit = edit;
    this.mask = mask;
    this.children = children;
  }
  modify(edit, shift22, f2222, hash2322, key, size42222) {
    const mask = this.mask;
    const children = this.children;
    const frag = hashFragment225(shift22, hash2322);
    const bit = toBitmap225(frag);
    const indx = fromBitmap225(mask, bit);
    const exists2322 = mask & bit;
    const canEdit = canEditNode225(this, edit);
    if (!exists2322) {
      const _newChild = new EmptyNode225().modify(edit, shift22 + SIZE225, f2222, hash2322, key, size42222);
      if (!_newChild) return this;
      return children.length >= MAX_INDEX_NODE225 ? expand225(edit, frag, _newChild, mask, children) : new _IndexedNode225(edit, mask | bit, arraySpliceIn225(canEdit, indx, _newChild, children));
    }
    const current = children[indx];
    const child = current.modify(edit, shift22 + SIZE225, f2222, hash2322, key, size42222);
    if (current === child) return this;
    let bitmap = mask;
    let newChildren;
    if (isEmptyNode225(child)) {
      bitmap &= ~bit;
      if (!bitmap) return new EmptyNode225();
      if (children.length <= 2 && isLeafNode225(children[indx ^ 1])) {
        return children[indx ^ 1];
      }
      newChildren = arraySpliceOut225(canEdit, indx, children);
    } else {
      newChildren = arrayUpdate225(canEdit, indx, child, children);
    }
    if (canEdit) {
      this.mask = bitmap;
      this.children = newChildren;
      return this;
    }
    return new _IndexedNode225(edit, bitmap, newChildren);
  }
};
var ArrayNode225 = class _ArrayNode225 {
  edit;
  size;
  children;
  _tag = "ArrayNode";
  constructor(edit, size42222, children) {
    this.edit = edit;
    this.size = size42222;
    this.children = children;
  }
  modify(edit, shift22, f2222, hash2322, key, size42222) {
    let count = this.size;
    const children = this.children;
    const frag = hashFragment225(shift22, hash2322);
    const child = children[frag];
    const newChild = (child || new EmptyNode225()).modify(edit, shift22 + SIZE225, f2222, hash2322, key, size42222);
    if (child === newChild) return this;
    const canEdit = canEditNode225(this, edit);
    let newChildren;
    if (isEmptyNode225(child) && !isEmptyNode225(newChild)) {
      ++count;
      newChildren = arrayUpdate225(canEdit, frag, newChild, children);
    } else if (!isEmptyNode225(child) && isEmptyNode225(newChild)) {
      --count;
      if (count <= MIN_ARRAY_NODE225) {
        return pack225(edit, count, frag, children);
      }
      newChildren = arrayUpdate225(canEdit, frag, new EmptyNode225(), children);
    } else {
      newChildren = arrayUpdate225(canEdit, frag, newChild, children);
    }
    if (canEdit) {
      this.size = count;
      this.children = newChildren;
      return this;
    }
    return new _ArrayNode225(edit, count, newChildren);
  }
};
function pack225(edit, count, removed, elements) {
  const children = new Array(count - 1);
  let g2222 = 0;
  let bitmap = 0;
  for (let i2222 = 0, len = elements.length; i2222 < len; ++i2222) {
    if (i2222 !== removed) {
      const elem = elements[i2222];
      if (elem && !isEmptyNode225(elem)) {
        children[g2222++] = elem;
        bitmap |= 1 << i2222;
      }
    }
  }
  return new IndexedNode225(edit, bitmap, children);
}
function expand225(edit, frag, child, bitmap, subNodes) {
  const arr = [];
  let bit = bitmap;
  let count = 0;
  for (let i2222 = 0; bit; ++i2222) {
    if (bit & 1) arr[i2222] = subNodes[count++];
    bit >>>= 1;
  }
  arr[frag] = child;
  return new ArrayNode225(edit, count + 1, arr);
}
function mergeLeavesInner225(edit, shift22, h1, n1, h2222, n2222) {
  if (h1 === h2222) return new CollisionNode225(edit, h1, [n2222, n1]);
  const subH1 = hashFragment225(shift22, h1);
  const subH2 = hashFragment225(shift22, h2222);
  if (subH1 === subH2) {
    return (child) => new IndexedNode225(edit, toBitmap225(subH1) | toBitmap225(subH2), [child]);
  } else {
    const children = subH1 < subH2 ? [n1, n2222] : [n2222, n1];
    return new IndexedNode225(edit, toBitmap225(subH1) | toBitmap225(subH2), children);
  }
}
function mergeLeaves225(edit, shift22, h1, n1, h2222, n2222) {
  let stack = void 0;
  let currentShift = shift22;
  while (true) {
    const res = mergeLeavesInner225(edit, currentShift, h1, n1, h2222, n2222);
    if (typeof res === "function") {
      stack = make5225(res, stack);
      currentShift = currentShift + SIZE225;
    } else {
      let final = res;
      while (stack != null) {
        final = stack.value(final);
        stack = stack.previous;
      }
      return final;
    }
  }
}
var HashMapSymbolKey225 = "effect/HashMap";
var HashMapTypeId225 = /* @__PURE__ */ Symbol.for(HashMapSymbolKey225);
var HashMapProto225 = {
  [HashMapTypeId225]: HashMapTypeId225,
  [Symbol.iterator]() {
    return new HashMapIterator225(this, (k2222, v2222) => [k2222, v2222]);
  },
  [symbol325]() {
    let hash2322 = hash225(HashMapSymbolKey225);
    for (const item of this) {
      hash2322 ^= pipe225(hash225(item[0]), combine325(hash225(item[1])));
    }
    return cached225(this, hash2322);
  },
  [symbol2225](that) {
    if (isHashMap225(that)) {
      if (that._size !== this._size) {
        return false;
      }
      for (const item of this) {
        const elem = pipe225(that, getHash225(item[0], hash225(item[0])));
        if (isNone2225(elem)) {
          return false;
        } else {
          if (!equals225(item[1], elem.value)) {
            return false;
          }
        }
      }
      return true;
    }
    return false;
  },
  toString() {
    return format225(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashMap",
      values: Array.from(this).map(toJSON225)
    };
  },
  [NodeInspectSymbol225]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments225(this, arguments);
  }
};
var makeImpl325 = (editable, edit, root, size42222) => {
  const map622 = Object.create(HashMapProto225);
  map622._editable = editable;
  map622._edit = edit;
  map622._root = root;
  map622._size = size42222;
  return map622;
};
var HashMapIterator225 = class _HashMapIterator225 {
  map;
  f;
  v;
  constructor(map622, f2222) {
    this.map = map622;
    this.f = f2222;
    this.v = visitLazy225(this.map._root, this.f, void 0);
  }
  next() {
    if (isNone2225(this.v)) {
      return {
        done: true,
        value: void 0
      };
    }
    const v0 = this.v.value;
    this.v = applyCont225(v0.cont);
    return {
      done: false,
      value: v0.value
    };
  }
  [Symbol.iterator]() {
    return new _HashMapIterator225(this.map, this.f);
  }
};
var applyCont225 = (cont) => cont ? visitLazyChildren225(cont[0], cont[1], cont[2], cont[3], cont[4]) : none2225();
var visitLazy225 = (node, f2222, cont = void 0) => {
  switch (node._tag) {
    case "LeafNode": {
      if (isSome2225(node.value)) {
        return some3225({
          value: f2222(node.key, node.value.value),
          cont
        });
      }
      return applyCont225(cont);
    }
    case "CollisionNode":
    case "ArrayNode":
    case "IndexedNode": {
      const children = node.children;
      return visitLazyChildren225(children.length, children, 0, f2222, cont);
    }
    default: {
      return applyCont225(cont);
    }
  }
};
var visitLazyChildren225 = (len, children, i2222, f2222, cont) => {
  while (i2222 < len) {
    const child = children[i2222++];
    if (child && !isEmptyNode225(child)) {
      return visitLazy225(child, f2222, [len, children, i2222, f2222, cont]);
    }
  }
  return applyCont225(cont);
};
var _empty3225 = /* @__PURE__ */ makeImpl325(false, 0, /* @__PURE__ */ new EmptyNode225(), 0);
var empty4225 = () => _empty3225;
var isHashMap225 = (u2222) => hasProperty225(u2222, HashMapTypeId225);
var getHash225 = /* @__PURE__ */ dual225(3, (self2, key, hash2322) => {
  let node = self2._root;
  let shift22 = 0;
  while (true) {
    switch (node._tag) {
      case "LeafNode": {
        return equals225(key, node.key) ? node.value : none2225();
      }
      case "CollisionNode": {
        if (hash2322 === node.hash) {
          const children = node.children;
          for (let i2222 = 0, len = children.length; i2222 < len; ++i2222) {
            const child = children[i2222];
            if ("key" in child && equals225(key, child.key)) {
              return child.value;
            }
          }
        }
        return none2225();
      }
      case "IndexedNode": {
        const frag = hashFragment225(shift22, hash2322);
        const bit = toBitmap225(frag);
        if (node.mask & bit) {
          node = node.children[fromBitmap225(node.mask, bit)];
          shift22 += SIZE225;
          break;
        }
        return none2225();
      }
      case "ArrayNode": {
        node = node.children[hashFragment225(shift22, hash2322)];
        if (node) {
          shift22 += SIZE225;
          break;
        }
        return none2225();
      }
      default:
        return none2225();
    }
  }
});
var set225 = /* @__PURE__ */ dual225(3, (self2, key, value) => modifyAt225(self2, key, () => some3225(value)));
var setTree225 = /* @__PURE__ */ dual225(3, (self2, newRoot, newSize) => {
  if (self2._editable) {
    self2._root = newRoot;
    self2._size = newSize;
    return self2;
  }
  return newRoot === self2._root ? self2 : makeImpl325(self2._editable, self2._edit, newRoot, newSize);
});
var keys225 = (self2) => new HashMapIterator225(self2, (key) => key);
var size425 = (self2) => self2._size;
var beginMutation325 = (self2) => makeImpl325(true, self2._edit + 1, self2._root, self2._size);
var modifyAt225 = /* @__PURE__ */ dual225(3, (self2, key, f2222) => modifyHash225(self2, key, hash225(key), f2222));
var modifyHash225 = /* @__PURE__ */ dual225(4, (self2, key, hash2322, f2222) => {
  const size42222 = {
    value: self2._size
  };
  const newRoot = self2._root.modify(self2._editable ? self2._edit : NaN, 0, f2222, hash2322, key, size42222);
  return pipe225(self2, setTree225(newRoot, size42222.value));
});
var forEach325 = /* @__PURE__ */ dual225(2, (self2, f2222) => reduce2225(self2, void 0, (_2222, value, key) => f2222(value, key)));
var reduce2225 = /* @__PURE__ */ dual225(3, (self2, zero, f2222) => {
  const root = self2._root;
  if (root._tag === "LeafNode") {
    return isSome2225(root.value) ? f2222(zero, root.value.value, root.key) : zero;
  }
  if (root._tag === "EmptyNode") {
    return zero;
  }
  const toVisit = [root.children];
  let children;
  while (children = toVisit.pop()) {
    for (let i2222 = 0, len = children.length; i2222 < len; ) {
      const child = children[i2222++];
      if (child && !isEmptyNode225(child)) {
        if (child._tag === "LeafNode") {
          if (isSome2225(child.value)) {
            zero = f2222(zero, child.value.value, child.key);
          }
        } else {
          toVisit.push(child.children);
        }
      }
    }
  }
  return zero;
});
var HashSetSymbolKey225 = "effect/HashSet";
var HashSetTypeId225 = /* @__PURE__ */ Symbol.for(HashSetSymbolKey225);
var HashSetProto225 = {
  [HashSetTypeId225]: HashSetTypeId225,
  [Symbol.iterator]() {
    return keys225(this._keyMap);
  },
  [symbol325]() {
    return cached225(this, combine325(hash225(this._keyMap))(hash225(HashSetSymbolKey225)));
  },
  [symbol2225](that) {
    if (isHashSet225(that)) {
      return size425(this._keyMap) === size425(that._keyMap) && equals225(this._keyMap, that._keyMap);
    }
    return false;
  },
  toString() {
    return format225(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashSet",
      values: Array.from(this).map(toJSON225)
    };
  },
  [NodeInspectSymbol225]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments225(this, arguments);
  }
};
var makeImpl2225 = (keyMap) => {
  const set2322 = Object.create(HashSetProto225);
  set2322._keyMap = keyMap;
  return set2322;
};
var isHashSet225 = (u2222) => hasProperty225(u2222, HashSetTypeId225);
var _empty4225 = /* @__PURE__ */ makeImpl2225(/* @__PURE__ */ empty4225());
var empty5225 = () => _empty4225;
var size2225 = (self2) => size425(self2._keyMap);
var beginMutation2225 = (self2) => makeImpl2225(beginMutation325(self2._keyMap));
var endMutation225 = (self2) => {
  self2._keyMap._editable = false;
  return self2;
};
var mutate225 = /* @__PURE__ */ dual225(2, (self2, f2222) => {
  const transient = beginMutation2225(self2);
  f2222(transient);
  return endMutation225(transient);
});
var add2225 = /* @__PURE__ */ dual225(2, (self2, value) => self2._keyMap._editable ? (set225(value, true)(self2._keyMap), self2) : makeImpl2225(set225(value, true)(self2._keyMap)));
var union2225 = /* @__PURE__ */ dual225(2, (self2, that) => mutate225(empty5225(), (set2322) => {
  forEach2225(self2, (value) => add2225(set2322, value));
  for (const value of that) {
    add2225(set2322, value);
  }
}));
var forEach2225 = /* @__PURE__ */ dual225(2, (self2, f2222) => forEach325(self2._keyMap, (_2222, k2222) => f2222(k2222)));
var empty6225 = empty5225;
var size3225 = size2225;
var add3225 = add2225;
var union3225 = union2225;
var ArrayProto225 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(Array.prototype), {
  [symbol325]() {
    return cached225(this, array325(this));
  },
  [symbol2225](that) {
    if (Array.isArray(that) && this.length === that.length) {
      return this.every((v2222, i2222) => equals225(v2222, that[i2222]));
    } else {
      return false;
    }
  }
});
var Structural325 = /* @__PURE__ */ function() {
  function Structural32222(args) {
    if (args) {
      Object.assign(this, args);
    }
  }
  Structural32222.prototype = StructuralPrototype225;
  return Structural32222;
}();
var struct2225 = (as2322) => Object.assign(Object.create(StructuralPrototype225), as2322);
var ContextPatchTypeId225 = /* @__PURE__ */ Symbol.for("effect/DifferContextPatch");
function variance325(a2222) {
  return a2222;
}
var PatchProto225 = {
  ...Structural325.prototype,
  [ContextPatchTypeId225]: {
    _Value: variance325,
    _Patch: variance325
  }
};
var EmptyProto225 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto225), {
  _tag: "Empty"
});
var _empty5225 = /* @__PURE__ */ Object.create(EmptyProto225);
var empty7225 = () => _empty5225;
var AndThenProto225 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto225), {
  _tag: "AndThen"
});
var makeAndThen225 = (first, second) => {
  const o2222 = Object.create(AndThenProto225);
  o2222.first = first;
  o2222.second = second;
  return o2222;
};
var AddServiceProto225 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto225), {
  _tag: "AddService"
});
var makeAddService225 = (key, service) => {
  const o2222 = Object.create(AddServiceProto225);
  o2222.key = key;
  o2222.service = service;
  return o2222;
};
var RemoveServiceProto225 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto225), {
  _tag: "RemoveService"
});
var makeRemoveService225 = (key) => {
  const o2222 = Object.create(RemoveServiceProto225);
  o2222.key = key;
  return o2222;
};
var UpdateServiceProto225 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto225), {
  _tag: "UpdateService"
});
var makeUpdateService225 = (key, update222) => {
  const o2222 = Object.create(UpdateServiceProto225);
  o2222.key = key;
  o2222.update = update222;
  return o2222;
};
var diff225 = (oldValue, newValue) => {
  const missingServices = new Map(oldValue.unsafeMap);
  let patch22222 = empty7225();
  for (const [tag, newService] of newValue.unsafeMap.entries()) {
    if (missingServices.has(tag)) {
      const old = missingServices.get(tag);
      missingServices.delete(tag);
      if (!equals225(old, newService)) {
        patch22222 = combine2225(makeUpdateService225(tag, () => newService))(patch22222);
      }
    } else {
      missingServices.delete(tag);
      patch22222 = combine2225(makeAddService225(tag, newService))(patch22222);
    }
  }
  for (const [tag] of missingServices.entries()) {
    patch22222 = combine2225(makeRemoveService225(tag))(patch22222);
  }
  return patch22222;
};
var combine2225 = /* @__PURE__ */ dual225(2, (self2, that) => makeAndThen225(self2, that));
var patch225 = /* @__PURE__ */ dual225(2, (self2, context) => {
  if (self2._tag === "Empty") {
    return context;
  }
  let wasServiceUpdated = false;
  let patches = of225(self2);
  const updatedContext = new Map(context.unsafeMap);
  while (isNonEmpty225(patches)) {
    const head222 = headNonEmpty225(patches);
    const tail222 = tailNonEmpty225(patches);
    switch (head222._tag) {
      case "Empty": {
        patches = tail222;
        break;
      }
      case "AddService": {
        updatedContext.set(head222.key, head222.service);
        patches = tail222;
        break;
      }
      case "AndThen": {
        patches = prepend225(prepend225(tail222, head222.second), head222.first);
        break;
      }
      case "RemoveService": {
        updatedContext.delete(head222.key);
        patches = tail222;
        break;
      }
      case "UpdateService": {
        updatedContext.set(head222.key, head222.update(updatedContext.get(head222.key)));
        wasServiceUpdated = true;
        patches = tail222;
        break;
      }
    }
  }
  if (!wasServiceUpdated) {
    return makeContext225(updatedContext);
  }
  const map622 = /* @__PURE__ */ new Map();
  for (const [tag] of context.unsafeMap) {
    if (updatedContext.has(tag)) {
      map622.set(tag, updatedContext.get(tag));
      updatedContext.delete(tag);
    }
  }
  for (const [tag, s2222] of updatedContext) {
    map622.set(tag, s2222);
  }
  return makeContext225(map622);
});
var DifferTypeId225 = /* @__PURE__ */ Symbol.for("effect/Differ");
var DifferProto225 = {
  [DifferTypeId225]: {
    _P: identity225,
    _V: identity225
  }
};
var make7225 = (params) => {
  const differ = Object.create(DifferProto225);
  differ.empty = params.empty;
  differ.diff = params.diff;
  differ.combine = params.combine;
  differ.patch = params.patch;
  return differ;
};
var environment225 = () => make7225({
  empty: empty7225(),
  combine: (first, second) => combine2225(second)(first),
  diff: (oldValue, newValue) => diff225(oldValue, newValue),
  patch: (patch22222, oldValue) => patch225(oldValue)(patch22222)
});
var OP_DIE225 = "Die";
var OP_EMPTY225 = "Empty";
var OP_FAIL225 = "Fail";
var OP_INTERRUPT225 = "Interrupt";
var OP_PARALLEL225 = "Parallel";
var OP_SEQUENTIAL225 = "Sequential";
var CauseSymbolKey225 = "effect/Cause";
var CauseTypeId225 = /* @__PURE__ */ Symbol.for(CauseSymbolKey225);
var variance2225 = {
  /* c8 ignore next */
  _E: (_2222) => _2222
};
var proto225 = {
  [CauseTypeId225]: variance2225,
  [symbol325]() {
    return pipe225(hash225(CauseSymbolKey225), combine325(hash225(flattenCause225(this))), cached225(this));
  },
  [symbol2225](that) {
    return isCause225(that) && causeEquals225(this, that);
  },
  pipe() {
    return pipeArguments225(this, arguments);
  },
  toJSON() {
    switch (this._tag) {
      case "Empty":
        return {
          _id: "Cause",
          _tag: this._tag
        };
      case "Die":
        return {
          _id: "Cause",
          _tag: this._tag,
          defect: toJSON225(this.defect)
        };
      case "Interrupt":
        return {
          _id: "Cause",
          _tag: this._tag,
          fiberId: this.fiberId.toJSON()
        };
      case "Fail":
        return {
          _id: "Cause",
          _tag: this._tag,
          failure: toJSON225(this.error)
        };
      case "Sequential":
      case "Parallel":
        return {
          _id: "Cause",
          _tag: this._tag,
          left: toJSON225(this.left),
          right: toJSON225(this.right)
        };
    }
  },
  toString() {
    return pretty225(this);
  },
  [NodeInspectSymbol225]() {
    return this.toJSON();
  }
};
var fail325 = (error) => {
  const o2222 = Object.create(proto225);
  o2222._tag = OP_FAIL225;
  o2222.error = error;
  return o2222;
};
var parallel225 = (left32222, right32222) => {
  const o2222 = Object.create(proto225);
  o2222._tag = OP_PARALLEL225;
  o2222.left = left32222;
  o2222.right = right32222;
  return o2222;
};
var sequential225 = (left32222, right32222) => {
  const o2222 = Object.create(proto225);
  o2222._tag = OP_SEQUENTIAL225;
  o2222.left = left32222;
  o2222.right = right32222;
  return o2222;
};
var isCause225 = (u2222) => hasProperty225(u2222, CauseTypeId225);
var isInterruptedOnly225 = (self2) => reduceWithContext225(void 0, IsInterruptedOnlyCauseReducer225)(self2);
var causeEquals225 = (left32222, right32222) => {
  let leftStack = of225(left32222);
  let rightStack = of225(right32222);
  while (isNonEmpty225(leftStack) && isNonEmpty225(rightStack)) {
    const [leftParallel, leftSequential] = pipe225(headNonEmpty225(leftStack), reduce4225([empty6225(), empty3225()], ([parallel22222, sequential22222], cause) => {
      const [par, seq] = evaluateCause225(cause);
      return some3225([pipe225(parallel22222, union3225(par)), pipe225(sequential22222, appendAll225(seq))]);
    }));
    const [rightParallel, rightSequential] = pipe225(headNonEmpty225(rightStack), reduce4225([empty6225(), empty3225()], ([parallel22222, sequential22222], cause) => {
      const [par, seq] = evaluateCause225(cause);
      return some3225([pipe225(parallel22222, union3225(par)), pipe225(sequential22222, appendAll225(seq))]);
    }));
    if (!equals225(leftParallel, rightParallel)) {
      return false;
    }
    leftStack = leftSequential;
    rightStack = rightSequential;
  }
  return true;
};
var flattenCause225 = (cause) => {
  return flattenCauseLoop225(of225(cause), empty3225());
};
var flattenCauseLoop225 = (causes, flattened) => {
  while (1) {
    const [parallel22222, sequential22222] = pipe225(causes, reduce325([empty6225(), empty3225()], ([parallel322, sequential322], cause) => {
      const [par, seq] = evaluateCause225(cause);
      return [pipe225(parallel322, union3225(par)), pipe225(sequential322, appendAll225(seq))];
    }));
    const updated = size3225(parallel22222) > 0 ? pipe225(flattened, prepend225(parallel22222)) : flattened;
    if (isEmpty225(sequential22222)) {
      return reverse2225(updated);
    }
    causes = sequential22222;
    flattened = updated;
  }
  throw new Error(getBugErrorMessage225("Cause.flattenCauseLoop"));
};
var evaluateCause225 = (self2) => {
  let cause = self2;
  const stack = [];
  let _parallel = empty6225();
  let _sequential = empty3225();
  while (cause !== void 0) {
    switch (cause._tag) {
      case OP_EMPTY225: {
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_FAIL225: {
        _parallel = add3225(_parallel, make4225(cause._tag, cause.error));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_DIE225: {
        _parallel = add3225(_parallel, make4225(cause._tag, cause.defect));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_INTERRUPT225: {
        _parallel = add3225(_parallel, make4225(cause._tag, cause.fiberId));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_SEQUENTIAL225: {
        switch (cause.left._tag) {
          case OP_EMPTY225: {
            cause = cause.right;
            break;
          }
          case OP_SEQUENTIAL225: {
            cause = sequential225(cause.left.left, sequential225(cause.left.right, cause.right));
            break;
          }
          case OP_PARALLEL225: {
            cause = parallel225(sequential225(cause.left.left, cause.right), sequential225(cause.left.right, cause.right));
            break;
          }
          default: {
            _sequential = prepend225(_sequential, cause.right);
            cause = cause.left;
            break;
          }
        }
        break;
      }
      case OP_PARALLEL225: {
        stack.push(cause.right);
        cause = cause.left;
        break;
      }
    }
  }
  throw new Error(getBugErrorMessage225("Cause.evaluateCauseLoop"));
};
var IsInterruptedOnlyCauseReducer225 = {
  emptyCase: constTrue225,
  failCase: constFalse225,
  dieCase: constFalse225,
  interruptCase: constTrue225,
  sequentialCase: (_2222, left32222, right32222) => left32222 && right32222,
  parallelCase: (_2222, left32222, right32222) => left32222 && right32222
};
var OP_SEQUENTIAL_CASE225 = "SequentialCase";
var OP_PARALLEL_CASE225 = "ParallelCase";
var reduce4225 = /* @__PURE__ */ dual225(3, (self2, zero, pf) => {
  let accumulator = zero;
  let cause = self2;
  const causes = [];
  while (cause !== void 0) {
    const option = pf(accumulator, cause);
    accumulator = isSome2225(option) ? option.value : accumulator;
    switch (cause._tag) {
      case OP_SEQUENTIAL225: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      case OP_PARALLEL225: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      default: {
        cause = void 0;
        break;
      }
    }
    if (cause === void 0 && causes.length > 0) {
      cause = causes.pop();
    }
  }
  return accumulator;
});
var reduceWithContext225 = /* @__PURE__ */ dual225(3, (self2, context, reducer) => {
  const input = [self2];
  const output = [];
  while (input.length > 0) {
    const cause = input.pop();
    switch (cause._tag) {
      case OP_EMPTY225: {
        output.push(right2225(reducer.emptyCase(context)));
        break;
      }
      case OP_FAIL225: {
        output.push(right2225(reducer.failCase(context, cause.error)));
        break;
      }
      case OP_DIE225: {
        output.push(right2225(reducer.dieCase(context, cause.defect)));
        break;
      }
      case OP_INTERRUPT225: {
        output.push(right2225(reducer.interruptCase(context, cause.fiberId)));
        break;
      }
      case OP_SEQUENTIAL225: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left2225({
          _tag: OP_SEQUENTIAL_CASE225
        }));
        break;
      }
      case OP_PARALLEL225: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left2225({
          _tag: OP_PARALLEL_CASE225
        }));
        break;
      }
    }
  }
  const accumulator = [];
  while (output.length > 0) {
    const either = output.pop();
    switch (either._tag) {
      case "Left": {
        switch (either.left._tag) {
          case OP_SEQUENTIAL_CASE225: {
            const left32222 = accumulator.pop();
            const right32222 = accumulator.pop();
            const value = reducer.sequentialCase(context, left32222, right32222);
            accumulator.push(value);
            break;
          }
          case OP_PARALLEL_CASE225: {
            const left32222 = accumulator.pop();
            const right32222 = accumulator.pop();
            const value = reducer.parallelCase(context, left32222, right32222);
            accumulator.push(value);
            break;
          }
        }
        break;
      }
      case "Right": {
        accumulator.push(either.right);
        break;
      }
    }
  }
  if (accumulator.length === 0) {
    throw new Error("BUG: Cause.reduceWithContext - please report an issue at https://github.com/Effect-TS/effect/issues");
  }
  return accumulator.pop();
});
var pretty225 = (cause) => {
  if (isInterruptedOnly225(cause)) {
    return "All fibers interrupted without errors.";
  }
  return prettyErrors225(cause).map((e2222) => e2222.stack).join("\n");
};
var PrettyError225 = class extends globalThis.Error {
  span = void 0;
  constructor(originalError) {
    const prevLimit = Error.stackTraceLimit;
    Error.stackTraceLimit = 0;
    super(prettyErrorMessage225(originalError));
    Error.stackTraceLimit = prevLimit;
    this.name = originalError instanceof Error ? originalError.name : "Error";
    if (typeof originalError === "object" && originalError !== null) {
      if (spanSymbol325 in originalError) {
        this.span = originalError[spanSymbol325];
      }
      Object.keys(originalError).forEach((key) => {
        if (!(key in this)) {
          this[key] = originalError[key];
        }
      });
    }
    this.stack = prettyErrorStack225(this.message, originalError instanceof Error && originalError.stack ? originalError.stack : "", this.span);
  }
  toJSON() {
    const out = {
      message: this.message,
      stack: this.stack
    };
    if (this.span) {
      out.span = this.span;
    }
    return out;
  }
};
var prettyErrorMessage225 = (u2222) => {
  if (typeof u2222 === "string") {
    return `Error: ${u2222}`;
  }
  try {
    if (hasProperty225(u2222, "toString") && isFunction3225(u2222["toString"]) && u2222["toString"] !== Object.prototype.toString && u2222["toString"] !== globalThis.Array.prototype.toString) {
      return u2222["toString"]();
    }
  } catch {
  }
  return `Error: ${JSON.stringify(u2222)}`;
};
var locationRegex225 = /\((.*)\)/;
var spanToTrace225 = /* @__PURE__ */ globalValue225("effect/Tracer/spanToTrace", () => /* @__PURE__ */ new WeakMap());
var prettyErrorStack225 = (message, stack, span222) => {
  const out = [message];
  const lines = stack.split("\n");
  for (let i2222 = 1; i2222 < lines.length; i2222++) {
    if (lines[i2222].includes("Generator.next")) {
      break;
    }
    if (lines[i2222].includes("effect_internal_function")) {
      out.pop();
      break;
    }
    out.push(lines[i2222].replace(/at .*effect_instruction_i.*\((.*)\)/, "at $1").replace(/EffectPrimitive\.\w+/, "<anonymous>"));
  }
  if (span222) {
    let current = span222;
    let i2222 = 0;
    while (current && current._tag === "Span" && i2222 < 10) {
      const stackFn = spanToTrace225.get(current);
      if (typeof stackFn === "function") {
        const stack2 = stackFn();
        const locationMatch = stack2.match(locationRegex225);
        const location = locationMatch ? locationMatch[1] : stack2.replace(/^at /, "");
        out.push(`    at ${current.name} (${location})`);
      } else {
        out.push(`    at ${current.name}`);
      }
      current = getOrUndefined225(current.parent);
      i2222++;
    }
  }
  return out.join("\n");
};
var spanSymbol325 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var prettyErrors225 = (cause) => reduceWithContext225(cause, void 0, {
  emptyCase: () => [],
  dieCase: (_2222, unknownError) => {
    return [new PrettyError225(unknownError)];
  },
  failCase: (_2222, error) => {
    return [new PrettyError225(error)];
  },
  interruptCase: () => [],
  parallelCase: (_2222, l2222, r2222) => [...l2222, ...r2222],
  sequentialCase: (_2222, l2222, r2222) => [...l2222, ...r2222]
});
var SingleShotGen2225 = class _SingleShotGen2225 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  next(a2222) {
    return this.called ? {
      value: a2222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  return(a2222) {
    return {
      value: a2222,
      done: true
    };
  }
  throw(e2222) {
    throw e2222;
  }
  [Symbol.iterator]() {
    return new _SingleShotGen2225(this.self);
  }
};
var spanTag225 = /* @__PURE__ */ GenericTag225("effect/ParentSpan");
var EffectTypeId2225 = /* @__PURE__ */ Symbol.for("effect/Effect");
var EffectPrimitive225 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId2225] = effectVariance225;
  constructor(_op) {
    this._op = _op;
  }
  [symbol2225](that) {
    return this === that;
  }
  [symbol325]() {
    return cached225(this, random225(this));
  }
  pipe() {
    return pipeArguments225(this, arguments);
  }
  toJSON() {
    return {
      _id: "Effect",
      _op: this._op,
      effect_instruction_i0: toJSON225(this.effect_instruction_i0),
      effect_instruction_i1: toJSON225(this.effect_instruction_i1),
      effect_instruction_i2: toJSON225(this.effect_instruction_i2)
    };
  }
  toString() {
    return format225(this.toJSON());
  }
  [NodeInspectSymbol225]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen2225(new YieldWrap225(this));
  }
};
var EffectPrimitiveFailure225 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId2225] = effectVariance225;
  constructor(_op) {
    this._op = _op;
    this._tag = _op;
  }
  [symbol2225](that) {
    return exitIsExit225(that) && that._op === "Failure" && // @ts-expect-error
    equals225(this.effect_instruction_i0, that.effect_instruction_i0);
  }
  [symbol325]() {
    return pipe225(
      // @ts-expect-error
      string225(this._tag),
      // @ts-expect-error
      combine325(hash225(this.effect_instruction_i0)),
      cached225(this)
    );
  }
  get cause() {
    return this.effect_instruction_i0;
  }
  pipe() {
    return pipeArguments225(this, arguments);
  }
  toJSON() {
    return {
      _id: "Exit",
      _tag: this._op,
      cause: this.cause.toJSON()
    };
  }
  toString() {
    return format225(this.toJSON());
  }
  [NodeInspectSymbol225]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen2225(new YieldWrap225(this));
  }
};
var isEffect225 = (u2222) => hasProperty225(u2222, EffectTypeId2225);
var withFiberRuntime225 = (withRuntime) => {
  const effect = new EffectPrimitive225(OP_WITH_RUNTIME225);
  effect.effect_instruction_i0 = withRuntime;
  return effect;
};
var spanSymbol2225 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var originalSymbol225 = /* @__PURE__ */ Symbol.for("effect/OriginalAnnotation");
var capture225 = (obj, span222) => {
  if (isSome2225(span222)) {
    return new Proxy(obj, {
      has(target, p2222) {
        return p2222 === spanSymbol2225 || p2222 === originalSymbol225 || p2222 in target;
      },
      get(target, p2222) {
        if (p2222 === spanSymbol2225) {
          return span222.value;
        }
        if (p2222 === originalSymbol225) {
          return obj;
        }
        return target[p2222];
      }
    });
  }
  return obj;
};
var fail2225 = (error) => isObject225(error) && !(spanSymbol2225 in error) ? withFiberRuntime225((fiber) => failCause225(fail325(capture225(error, currentSpanFromFiber225(fiber))))) : failCause225(fail325(error));
var failCause225 = (cause) => {
  const effect = new EffectPrimitiveFailure225(OP_FAILURE225);
  effect.effect_instruction_i0 = cause;
  return effect;
};
var FiberRefSymbolKey225 = "effect/FiberRef";
var FiberRefTypeId225 = /* @__PURE__ */ Symbol.for(FiberRefSymbolKey225);
var fiberRefVariance225 = {
  /* c8 ignore next */
  _A: (_2222) => _2222
};
var fiberRefUnsafeMakeContext225 = (initial) => {
  const differ = environment225();
  return fiberRefUnsafeMakePatch225(initial, {
    differ,
    fork: differ.empty
  });
};
var fiberRefUnsafeMakePatch225 = (initial, options) => ({
  [FiberRefTypeId225]: fiberRefVariance225,
  initial,
  diff: (oldValue, newValue) => options.differ.diff(oldValue, newValue),
  combine: (first, second) => options.differ.combine(first, second),
  patch: (patch22222) => (oldValue) => options.differ.patch(patch22222, oldValue),
  fork: options.fork,
  join: options.join ?? ((_2222, n2222) => n2222),
  pipe() {
    return pipeArguments225(this, arguments);
  }
});
var currentContext225 = /* @__PURE__ */ globalValue225(/* @__PURE__ */ Symbol.for("effect/FiberRef/currentContext"), () => fiberRefUnsafeMakeContext225(empty2225()));
var YieldableError225 = /* @__PURE__ */ function() {
  class YieldableError22222 extends globalThis.Error {
    commit() {
      return fail2225(this);
    }
    toString() {
      return this.message ? `${this.name}: ${this.message}` : this.name;
    }
    toJSON() {
      return {
        ...this
      };
    }
    [NodeInspectSymbol225]() {
      const stack = this.stack;
      if (stack) {
        return `${this.toString()}
${stack.split("\n").slice(1).join("\n")}`;
      }
      return this.toString();
    }
  }
  Object.assign(YieldableError22222.prototype, StructuralCommitPrototype225);
  return YieldableError22222;
}();
var exitIsExit225 = (u2222) => isEffect225(u2222) && "_tag" in u2222 && (u2222._tag === "Success" || u2222._tag === "Failure");
var currentSpanFromFiber225 = (fiber) => {
  const span222 = fiber.getFiberRef(currentContext225).unsafeMap.get(spanTag225.key);
  return span222 !== void 0 && span222._tag === "Span" ? some3225(span222) : none2225();
};
var Data_exports225 = {};
__export2225(Data_exports225, {
  Class: () => Class2225,
  Error: () => Error2225,
  Structural: () => Structural2225,
  TaggedClass: () => TaggedClass225,
  TaggedError: () => TaggedError225,
  array: () => array2225,
  case: () => _case225,
  struct: () => struct3225,
  tagged: () => tagged225,
  taggedEnum: () => taggedEnum225,
  tuple: () => tuple2225,
  unsafeArray: () => unsafeArray225,
  unsafeStruct: () => unsafeStruct225
});
var struct3225 = struct2225;
var unsafeStruct225 = (as2322) => Object.setPrototypeOf(as2322, StructuralPrototype225);
var tuple2225 = (...as2322) => unsafeArray225(as2322);
var array2225 = (as2322) => unsafeArray225(as2322.slice(0));
var unsafeArray225 = (as2322) => Object.setPrototypeOf(as2322, ArrayProto225);
var _case225 = () => (args) => args === void 0 ? Object.create(StructuralPrototype225) : struct3225(args);
var tagged225 = (tag) => (args) => {
  const value = args === void 0 ? Object.create(StructuralPrototype225) : struct3225(args);
  value._tag = tag;
  return value;
};
var Class2225 = Structural325;
var TaggedClass225 = (tag) => {
  class Base extends Class2225 {
    _tag = tag;
  }
  return Base;
};
var Structural2225 = Structural325;
var taggedEnum225 = () => new Proxy({}, {
  get(_target, tag, _receiver) {
    if (tag === "$is") {
      return isTagged225;
    } else if (tag === "$match") {
      return taggedMatch225;
    }
    return tagged225(tag);
  }
});
function taggedMatch225() {
  if (arguments.length === 1) {
    const cases2 = arguments[0];
    return function(value2) {
      return cases2[value2._tag](value2);
    };
  }
  const value = arguments[0];
  const cases = arguments[1];
  return cases[value._tag](value);
}
var Error2225 = /* @__PURE__ */ function() {
  return class Base extends YieldableError225 {
    constructor(args) {
      super();
      if (args) {
        Object.assign(this, args);
      }
    }
  };
}();
var TaggedError225 = (tag) => {
  class Base extends Error2225 {
    _tag = tag;
  }
  Base.prototype.name = tag;
  return Base;
};
var traverseUp225 = Function_exports225.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType225.Program) return Option_exports225.none();
  return predicate(parent) ? Option_exports225.some(parent) : traverseUp225(parent, predicate);
});
var traverseUpGuard225 = Function_exports225.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType225.Program) return Option_exports225.none();
  return predicate(parent) ? Option_exports225.some(parent) : traverseUpGuard225(parent, predicate);
});
var ESLintCommunityESLintUtils225;
((ESLintCommunityESLintUtils22222) => {
  ESLintCommunityESLintUtils22222.getFunctionHeadLocation = getFunctionHeadLocation225;
  ESLintCommunityESLintUtils22222.getFunctionNameWithKind = getFunctionNameWithKind225;
  ESLintCommunityESLintUtils22222.getPropertyName = getPropertyName225;
  ESLintCommunityESLintUtils22222.getStaticValue = getStaticValue225;
  ESLintCommunityESLintUtils22222.getStringIfConstant = getStringIfConstant225;
  ESLintCommunityESLintUtils22222.hasSideEffect = hasSideEffect225;
  ESLintCommunityESLintUtils22222.isParenthesized = isParenthesized225;
})(ESLintCommunityESLintUtils225 || (ESLintCommunityESLintUtils225 = {}));
var Construction225 = Data_exports225.taggedEnum();
Construction225.None();
a7({
  type: N7.union([NodeType225.FunctionExpression, NodeType225.ArrowFunctionExpression]),
  parent: {
    type: NodeType225.Property,
    parent: {
      type: NodeType225.ObjectExpression
    }
  }
});
a7({
  type: N7.union([NodeType225.FunctionExpression, NodeType225.ArrowFunctionExpression]),
  parent: {
    type: NodeType225.MethodDefinition,
    parent: {
      type: NodeType225.ClassBody
    }
  }
});
a7({
  type: N7.union([NodeType225.FunctionExpression, NodeType225.ArrowFunctionExpression]),
  parent: {
    type: NodeType225.Property,
    parent: {
      type: NodeType225.ClassBody
    }
  }
});
var Function_exports2225 = {};
__export325(Function_exports2225, {
  SK: () => SK2225,
  absurd: () => absurd2225,
  apply: () => apply2225,
  compose: () => compose3223,
  constFalse: () => constFalse2225,
  constNull: () => constNull2225,
  constTrue: () => constTrue2225,
  constUndefined: () => constUndefined2225,
  constVoid: () => constVoid2225,
  constant: () => constant2225,
  dual: () => dual2225,
  flip: () => flip2225,
  flow: () => flow2225,
  hole: () => hole2225,
  identity: () => identity2225,
  isFunction: () => isFunction423,
  pipe: () => pipe2225,
  satisfies: () => satisfies2225,
  tupled: () => tupled2225,
  unsafeCoerce: () => unsafeCoerce2225,
  untupled: () => untupled2225
});
var isFunction423 = (input) => typeof input === "function";
var dual2225 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a2222, b2222) {
        if (arguments.length >= 2) {
          return body(a2222, b2222);
        }
        return function(self2) {
          return body(self2, a2222);
        };
      };
    case 3:
      return function(a2222, b2222, c2222) {
        if (arguments.length >= 3) {
          return body(a2222, b2222, c2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222);
        };
      };
    case 4:
      return function(a2222, b2222, c2222, d2222) {
        if (arguments.length >= 4) {
          return body(a2222, b2222, c2222, d2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222);
        };
      };
    case 5:
      return function(a2222, b2222, c2222, d2222, e2222) {
        if (arguments.length >= 5) {
          return body(a2222, b2222, c2222, d2222, e2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222, d2222);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply2225 = (a2222) => (self2) => self2(a2222);
var identity2225 = (a2222) => a2222;
var satisfies2225 = () => (b2222) => b2222;
var unsafeCoerce2225 = identity2225;
var constant2225 = (value) => () => value;
var constTrue2225 = /* @__PURE__ */ constant2225(true);
var constFalse2225 = /* @__PURE__ */ constant2225(false);
var constNull2225 = /* @__PURE__ */ constant2225(null);
var constUndefined2225 = /* @__PURE__ */ constant2225(void 0);
var constVoid2225 = constUndefined2225;
var flip2225 = (f2222) => (...b2222) => (...a2222) => f2222(...a2222)(...b2222);
var compose3223 = /* @__PURE__ */ dual2225(2, (ab, bc) => (a2222) => bc(ab(a2222)));
var absurd2225 = (_2222) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled2225 = (f2222) => (a2222) => f2222(...a2222);
var untupled2225 = (f2222) => (...a2222) => f2222(a2222);
function pipe2225(a2222, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a2222;
    case 2:
      return ab(a2222);
    case 3:
      return bc(ab(a2222));
    case 4:
      return cd(bc(ab(a2222)));
    case 5:
      return de(cd(bc(ab(a2222))));
    case 6:
      return ef(de(cd(bc(ab(a2222)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a2222))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a2222)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a2222))))))));
    default: {
      let ret = arguments[0];
      for (let i2222 = 1; i2222 < arguments.length; i2222++) {
        ret = arguments[i2222](ret);
      }
      return ret;
    }
  }
}
function flow2225(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole2225 = /* @__PURE__ */ unsafeCoerce2225(absurd2225);
var SK2225 = (_2222, b2222) => b2222;
var Array_exports5 = {};
__export325(Array_exports5, {
  Do: () => Do35,
  allocate: () => allocate5,
  append: () => append6,
  appendAll: () => appendAll2223,
  bind: () => bind55,
  bindTo: () => bindTo55,
  cartesian: () => cartesian5,
  cartesianWith: () => cartesianWith5,
  chop: () => chop5,
  chunksOf: () => chunksOf5,
  contains: () => contains35,
  containsWith: () => containsWith35,
  copy: () => copy2223,
  dedupe: () => dedupe5,
  dedupeAdjacent: () => dedupeAdjacent5,
  dedupeAdjacentWith: () => dedupeAdjacentWith5,
  dedupeWith: () => dedupeWith5,
  difference: () => difference6,
  differenceWith: () => differenceWith5,
  drop: () => drop2223,
  dropRight: () => dropRight5,
  dropWhile: () => dropWhile5,
  empty: () => empty95,
  every: () => every35,
  extend: () => extend5,
  filter: () => filter35,
  filterMap: () => filterMap35,
  filterMapWhile: () => filterMapWhile5,
  findFirst: () => findFirst25,
  findFirstIndex: () => findFirstIndex5,
  findLast: () => findLast5,
  findLastIndex: () => findLastIndex5,
  flatMap: () => flatMap35,
  flatMapNullable: () => flatMapNullable35,
  flatten: () => flatten35,
  forEach: () => forEach3223,
  fromIterable: () => fromIterable45,
  fromNullable: () => fromNullable35,
  fromOption: () => fromOption25,
  fromRecord: () => fromRecord5,
  get: () => get10,
  getEquivalence: () => getEquivalence45,
  getLefts: () => getLefts6,
  getOrder: () => getOrder35,
  getRights: () => getRights6,
  getSomes: () => getSomes6,
  group: () => group5,
  groupBy: () => groupBy5,
  groupWith: () => groupWith5,
  head: () => head6,
  headNonEmpty: () => headNonEmpty2223,
  init: () => init5,
  initNonEmpty: () => initNonEmpty5,
  insertAt: () => insertAt5,
  intersection: () => intersection6,
  intersectionWith: () => intersectionWith5,
  intersperse: () => intersperse5,
  isArray: () => isArray5,
  isEmptyArray: () => isEmptyArray5,
  isEmptyReadonlyArray: () => isEmptyReadonlyArray5,
  isNonEmptyArray: () => isNonEmptyArray25,
  isNonEmptyReadonlyArray: () => isNonEmptyReadonlyArray5,
  join: () => join5,
  last: () => last5,
  lastNonEmpty: () => lastNonEmpty5,
  length: () => length6,
  let: () => let_55,
  liftEither: () => liftEither5,
  liftNullable: () => liftNullable35,
  liftOption: () => liftOption5,
  liftPredicate: () => liftPredicate35,
  make: () => make105,
  makeBy: () => makeBy5,
  map: () => map35,
  mapAccum: () => mapAccum5,
  match: () => match45,
  matchLeft: () => matchLeft5,
  matchRight: () => matchRight5,
  max: () => max25,
  min: () => min25,
  modify: () => modify6,
  modifyNonEmptyHead: () => modifyNonEmptyHead5,
  modifyNonEmptyLast: () => modifyNonEmptyLast5,
  modifyOption: () => modifyOption6,
  of: () => of2223,
  partition: () => partition6,
  partitionMap: () => partitionMap35,
  prepend: () => prepend2223,
  prependAll: () => prependAll5,
  range: () => range5,
  reduce: () => reduce3223,
  reduceRight: () => reduceRight5,
  remove: () => remove7,
  replace: () => replace25,
  replaceOption: () => replaceOption6,
  replicate: () => replicate5,
  reverse: () => reverse3223,
  rotate: () => rotate5,
  scan: () => scan5,
  scanRight: () => scanRight5,
  separate: () => separate6,
  setNonEmptyHead: () => setNonEmptyHead5,
  setNonEmptyLast: () => setNonEmptyLast5,
  some: () => some75,
  sort: () => sort5,
  sortBy: () => sortBy5,
  sortWith: () => sortWith5,
  span: () => span5,
  split: () => split5,
  splitAt: () => splitAt5,
  splitNonEmptyAt: () => splitNonEmptyAt5,
  splitWhere: () => splitWhere5,
  tail: () => tail6,
  tailNonEmpty: () => tailNonEmpty2223,
  take: () => take5,
  takeRight: () => takeRight5,
  takeWhile: () => takeWhile5,
  unappend: () => unappend5,
  unfold: () => unfold5,
  union: () => union8,
  unionWith: () => unionWith5,
  unprepend: () => unprepend5,
  unsafeGet: () => unsafeGet6,
  unzip: () => unzip5,
  zip: () => zip5,
  zipWith: () => zipWith35
});
var make6223 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var array3223 = (item) => make6223((self2, that) => {
  if (self2.length !== that.length) {
    return false;
  }
  for (let i2222 = 0; i2222 < self2.length; i2222++) {
    const isEq = item(self2[i2222], that[i2222]);
    if (!isEq) {
      return false;
    }
  }
  return true;
});
var let_3225 = (map522) => dual2225(3, (self2, name22, f2222) => map522(self2, (a2222) => Object.assign({}, a2222, {
  [name22]: f2222(a2222)
})));
var bindTo3225 = (map522) => dual2225(2, (self2, name22) => map522(self2, (a2222) => ({
  [name22]: a2222
})));
var bind3225 = (map522, flatMap522) => dual2225(3, (self2, name22, f2222) => flatMap522(self2, (a2222) => map522(f2222(a2222), (b2222) => Object.assign({}, a2222, {
  [name22]: b2222
}))));
var moduleVersion2225 = "3.2.8";
var getCurrentVersion2225 = () => moduleVersion2225;
var globalStoreId2225 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion2225()}`);
if (!(globalStoreId2225 in globalThis)) {
  globalThis[globalStoreId2225] = /* @__PURE__ */ new Map();
}
var globalStore2225 = globalThis[globalStoreId2225];
var globalValue2225 = (id, compute) => {
  if (!globalStore2225.has(id)) {
    globalStore2225.set(id, compute());
  }
  return globalStore2225.get(id);
};
var Predicate_exports2225 = {};
__export325(Predicate_exports2225, {
  all: () => all3223,
  and: () => and2223,
  compose: () => compose45,
  eqv: () => eqv2223,
  every: () => every2223,
  hasProperty: () => hasProperty2225,
  implies: () => implies2223,
  isBigInt: () => isBigInt2223,
  isBoolean: () => isBoolean2223,
  isDate: () => isDate2223,
  isError: () => isError2223,
  isFunction: () => isFunction55,
  isIterable: () => isIterable2223,
  isMap: () => isMap2223,
  isNever: () => isNever2223,
  isNotNull: () => isNotNull2223,
  isNotNullable: () => isNotNullable2223,
  isNotUndefined: () => isNotUndefined2223,
  isNull: () => isNull2223,
  isNullable: () => isNullable2225,
  isNumber: () => isNumber2223,
  isObject: () => isObject2225,
  isPromise: () => isPromise2223,
  isPromiseLike: () => isPromiseLike2223,
  isReadonlyRecord: () => isReadonlyRecord2223,
  isRecord: () => isRecord2223,
  isSet: () => isSet2223,
  isString: () => isString2223,
  isSymbol: () => isSymbol2223,
  isTagged: () => isTagged2223,
  isTruthy: () => isTruthy2223,
  isUint8Array: () => isUint8Array2223,
  isUndefined: () => isUndefined2223,
  isUnknown: () => isUnknown2223,
  mapInput: () => mapInput2223,
  nand: () => nand2223,
  nor: () => nor2223,
  not: () => not2223,
  or: () => or2223,
  product: () => product3223,
  productMany: () => productMany3223,
  some: () => some4223,
  struct: () => struct4223,
  tuple: () => tuple3223,
  xor: () => xor2223
});
var mapInput2223 = /* @__PURE__ */ dual2225(2, (self2, f2222) => (b2222) => self2(f2222(b2222)));
var isTruthy2223 = (input) => !!input;
var isSet2223 = (input) => input instanceof Set;
var isMap2223 = (input) => input instanceof Map;
var isString2223 = (input) => typeof input === "string";
var isNumber2223 = (input) => typeof input === "number";
var isBoolean2223 = (input) => typeof input === "boolean";
var isBigInt2223 = (input) => typeof input === "bigint";
var isSymbol2223 = (input) => typeof input === "symbol";
var isFunction55 = isFunction423;
var isUndefined2223 = (input) => input === void 0;
var isNotUndefined2223 = (input) => input !== void 0;
var isNull2223 = (input) => input === null;
var isNotNull2223 = (input) => input !== null;
var isNever2223 = (_2222) => false;
var isUnknown2223 = (_2222) => true;
var isRecordOrArray2225 = (input) => typeof input === "object" && input !== null;
var isObject2225 = (input) => isRecordOrArray2225(input) || isFunction55(input);
var hasProperty2225 = /* @__PURE__ */ dual2225(2, (self2, property) => isObject2225(self2) && property in self2);
var isTagged2223 = /* @__PURE__ */ dual2225(2, (self2, tag) => hasProperty2225(self2, "_tag") && self2["_tag"] === tag);
var isNullable2225 = (input) => input === null || input === void 0;
var isNotNullable2223 = (input) => input !== null && input !== void 0;
var isError2223 = (input) => input instanceof Error;
var isUint8Array2223 = (input) => input instanceof Uint8Array;
var isDate2223 = (input) => input instanceof Date;
var isIterable2223 = (input) => hasProperty2225(input, Symbol.iterator);
var isRecord2223 = (input) => isRecordOrArray2225(input) && !Array.isArray(input);
var isReadonlyRecord2223 = isRecord2223;
var isPromise2223 = (input) => hasProperty2225(input, "then") && "catch" in input && isFunction55(input.then) && isFunction55(input.catch);
var isPromiseLike2223 = (input) => hasProperty2225(input, "then") && isFunction55(input.then);
var compose45 = /* @__PURE__ */ dual2225(2, (ab, bc) => (a2222) => ab(a2222) && bc(a2222));
var product3223 = (self2, that) => ([a2222, b2222]) => self2(a2222) && that(b2222);
var all3223 = (collection) => {
  return (as422) => {
    let collectionIndex = 0;
    for (const p2222 of collection) {
      if (collectionIndex >= as422.length) {
        break;
      }
      if (p2222(as422[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany3223 = (self2, collection) => {
  const rest = all3223(collection);
  return ([head222, ...tail222]) => self2(head222) === false ? false : rest(tail222);
};
var tuple3223 = (...elements) => all3223(elements);
var struct4223 = (fields) => {
  const keys422 = Object.keys(fields);
  return (a2222) => {
    for (const key of keys422) {
      if (!fields[key](a2222[key])) {
        return false;
      }
    }
    return true;
  };
};
var not2223 = (self2) => (a2222) => !self2(a2222);
var or2223 = /* @__PURE__ */ dual2225(2, (self2, that) => (a2222) => self2(a2222) || that(a2222));
var and2223 = /* @__PURE__ */ dual2225(2, (self2, that) => (a2222) => self2(a2222) && that(a2222));
var xor2223 = /* @__PURE__ */ dual2225(2, (self2, that) => (a2222) => self2(a2222) !== that(a2222));
var eqv2223 = /* @__PURE__ */ dual2225(2, (self2, that) => (a2222) => self2(a2222) === that(a2222));
var implies2223 = /* @__PURE__ */ dual2225(2, (self2, that) => (a2222) => self2(a2222) ? that(a2222) : true);
var nor2223 = /* @__PURE__ */ dual2225(2, (self2, that) => (a2222) => !(self2(a2222) || that(a2222)));
var nand2223 = /* @__PURE__ */ dual2225(2, (self2, that) => (a2222) => !(self2(a2222) && that(a2222)));
var every2223 = (collection) => (a2222) => {
  for (const p2222 of collection) {
    if (!p2222(a2222)) {
      return false;
    }
  }
  return true;
};
var some4223 = (collection) => (a2222) => {
  for (const p2222 of collection) {
    if (p2222(a2222)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage2225 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId2225 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind2225 = (u2222) => isObject2225(u2222) && GenKindTypeId2225 in u2222;
var GenKindImpl2225 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity2225;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId2225] = GenKindTypeId2225;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen3223(this);
  }
};
var SingleShotGen3223 = class _SingleShotGen55 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a2222) {
    return this.called ? {
      value: a2222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a2222) {
    return {
      value: a2222,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e2222) {
    throw e2222;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen55(this.self);
  }
};
var adapter3225 = () => function() {
  let x2222 = arguments[0];
  for (let i2222 = 1; i2222 < arguments.length; i2222++) {
    x2222 = arguments[i2222](x2222);
  }
  return new GenKindImpl2225(x2222);
};
var defaultIncHi2225 = 335903614;
var defaultIncLo2225 = 4150755663;
var MUL_HI2225 = 1481765933 >>> 0;
var MUL_LO2225 = 1284865837 >>> 0;
var BIT_532225 = 9007199254740992;
var BIT_272225 = 134217728;
var PCGRandom2225 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable2225(seedLo) && isNullable2225(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable2225(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable2225(incLo) && isNullable2225(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo2225;
      incHi = this._state ? this._state[2] : defaultIncHi2225;
    } else if (isNullable2225(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add642225(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max322) {
    if (!max322) {
      return this._next();
    }
    max322 = max322 >>> 0;
    if ((max322 & max322 - 1) === 0) {
      return this._next() & max322 - 1;
    }
    let num = 0;
    const skew = (-max322 >>> 0) % max322 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max322;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_272225 + lo) / BIT_532225;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul642225(this._state, oldHi, oldLo, MUL_HI2225, MUL_LO2225);
    add642225(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul642225(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add642225(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId2225 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap2225 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId2225]() {
    return this.#value;
  }
};
function yieldWrapGet2225(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId2225 in self2) {
    return self2[YieldWrapTypeId2225]();
  }
  throw new Error(getBugErrorMessage2225("yieldWrapGet"));
}
var structuralRegionState2225 = /* @__PURE__ */ globalValue2225("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache2225 = /* @__PURE__ */ globalValue2225(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr2225 = /* @__PURE__ */ globalValue2225(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom2225());
var symbol3225 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash2225 = (self2) => {
  if (structuralRegionState2225.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number2225(self2);
    case "bigint":
      return string2225(self2.toString(10));
    case "boolean":
      return string2225(String(self2));
    case "symbol":
      return string2225(String(self2));
    case "string":
      return string2225(self2);
    case "undefined":
      return string2225("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string2225("null");
      } else if (self2 instanceof Date) {
        return hash2225(self2.toISOString());
      } else if (isHash2225(self2)) {
        return self2[symbol3225]();
      } else {
        return random2225(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random2225 = (self2) => {
  if (!randomHashCache2225.has(self2)) {
    randomHashCache2225.set(self2, number2225(pcgr2225.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache2225.get(self2);
};
var combine3223 = (b2222) => (self2) => self2 * 53 ^ b2222;
var optimize2225 = (n2222) => n2222 & 3221225471 | n2222 >>> 1 & 1073741824;
var isHash2225 = (u2222) => hasProperty2225(u2222, symbol3225);
var number2225 = (n2222) => {
  if (n2222 !== n2222 || n2222 === Infinity) {
    return 0;
  }
  let h2222 = n2222 | 0;
  if (h2222 !== n2222) {
    h2222 ^= n2222 * 4294967295;
  }
  while (n2222 > 4294967295) {
    h2222 ^= n2222 /= 4294967295;
  }
  return optimize2225(n2222);
};
var string2225 = (str) => {
  let h2222 = 5381, i2222 = str.length;
  while (i2222) {
    h2222 = h2222 * 33 ^ str.charCodeAt(--i2222);
  }
  return optimize2225(h2222);
};
var cached2225 = function() {
  if (arguments.length === 1) {
    const self3 = arguments[0];
    return function(hash522) {
      Object.defineProperty(self3, symbol3225, {
        value() {
          return hash522;
        },
        enumerable: false
      });
      return hash522;
    };
  }
  const self2 = arguments[0];
  const hash422 = arguments[1];
  Object.defineProperty(self2, symbol3225, {
    value() {
      return hash422;
    },
    enumerable: false
  });
  return hash422;
};
var symbol45 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals2225() {
  if (arguments.length === 1) {
    return (self2) => compareBoth2225(self2, arguments[0]);
  }
  return compareBoth2225(arguments[0], arguments[1]);
}
function compareBoth2225(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual2225(self2) && isEqual2225(that)) {
        if (hash2225(self2) === hash2225(that) && self2[symbol45](that)) {
          return true;
        } else {
          return structuralRegionState2225.enabled && structuralRegionState2225.tester ? structuralRegionState2225.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState2225.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v2222, i2222) => compareBoth2225(v2222, that[i2222]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth2225(self2[key], that[key]))) {
              return structuralRegionState2225.tester ? structuralRegionState2225.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState2225.tester ? structuralRegionState2225.tester(self2, that) : false;
    }
  }
  return structuralRegionState2225.enabled && structuralRegionState2225.tester ? structuralRegionState2225.tester(self2, that) : false;
}
var isEqual2225 = (u2222) => hasProperty2225(u2222, symbol45);
var equivalence2225 = () => equals2225;
var NodeInspectSymbol2225 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON2225 = (x2222) => {
  if (hasProperty2225(x2222, "toJSON") && isFunction55(x2222["toJSON"]) && x2222["toJSON"].length === 0) {
    return x2222.toJSON();
  } else if (Array.isArray(x2222)) {
    return x2222.map(toJSON2225);
  }
  return x2222;
};
var format2225 = (x2222) => JSON.stringify(x2222, null, 2);
var pipeArguments2225 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i2222 = 0, len = args.length; i2222 < len; i2222++) {
        ret = args[i2222](ret);
      }
      return ret;
    }
  }
};
var EffectTypeId3223 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId2225 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId2225 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId2225 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance2225 = {
  /* c8 ignore next */
  _R: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _A: (_2222) => _2222,
  _V: /* @__PURE__ */ getCurrentVersion2225()
};
var sinkVariance2225 = {
  /* c8 ignore next */
  _A: (_2222) => _2222,
  /* c8 ignore next */
  _In: (_2222) => _2222,
  /* c8 ignore next */
  _L: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _R: (_2222) => _2222
};
var channelVariance2225 = {
  /* c8 ignore next */
  _Env: (_2222) => _2222,
  /* c8 ignore next */
  _InErr: (_2222) => _2222,
  /* c8 ignore next */
  _InElem: (_2222) => _2222,
  /* c8 ignore next */
  _InDone: (_2222) => _2222,
  /* c8 ignore next */
  _OutErr: (_2222) => _2222,
  /* c8 ignore next */
  _OutElem: (_2222) => _2222,
  /* c8 ignore next */
  _OutDone: (_2222) => _2222
};
var EffectPrototype2225 = {
  [EffectTypeId3223]: effectVariance2225,
  [StreamTypeId2225]: effectVariance2225,
  [SinkTypeId2225]: sinkVariance2225,
  [ChannelTypeId2225]: channelVariance2225,
  [symbol45](that) {
    return this === that;
  },
  [symbol3225]() {
    return cached2225(this, random2225(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen3223(new YieldWrap2225(this));
  },
  pipe() {
    return pipeArguments2225(this, arguments);
  }
};
var TypeId6223 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto3225 = {
  ...EffectPrototype2225,
  [TypeId6223]: {
    _A: (_2222) => _2222
  },
  [NodeInspectSymbol2225]() {
    return this.toJSON();
  },
  toString() {
    return format2225(this.toJSON());
  }
};
var SomeProto2225 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto3225), {
  _tag: "Some",
  _op: "Some",
  [symbol45](that) {
    return isOption3225(that) && isSome3225(that) && equals2225(this.value, that.value);
  },
  [symbol3225]() {
    return cached2225(this, combine3223(hash2225(this._tag))(hash2225(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON2225(this.value)
    };
  }
});
var NoneHash2225 = /* @__PURE__ */ hash2225("None");
var NoneProto2225 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto3225), {
  _tag: "None",
  _op: "None",
  [symbol45](that) {
    return isOption3225(that) && isNone3225(that);
  },
  [symbol3225]() {
    return NoneHash2225;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption3225 = (input) => hasProperty2225(input, TypeId6223);
var isNone3225 = (fa) => fa._tag === "None";
var isSome3225 = (fa) => fa._tag === "Some";
var none3225 = /* @__PURE__ */ Object.create(NoneProto2225);
var some55 = (value) => {
  const a2222 = Object.create(SomeProto2225);
  a2222.value = value;
  return a2222;
};
var TypeId75 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto45 = {
  ...EffectPrototype2225,
  [TypeId75]: {
    _R: (_2222) => _2222
  },
  [NodeInspectSymbol2225]() {
    return this.toJSON();
  },
  toString() {
    return format2225(this.toJSON());
  }
};
var RightProto2225 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto45), {
  _tag: "Right",
  _op: "Right",
  [symbol45](that) {
    return isEither2225(that) && isRight2225(that) && equals2225(this.right, that.right);
  },
  [symbol3225]() {
    return combine3223(hash2225(this._tag))(hash2225(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON2225(this.right)
    };
  }
});
var LeftProto2225 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto45), {
  _tag: "Left",
  _op: "Left",
  [symbol45](that) {
    return isEither2225(that) && isLeft2225(that) && equals2225(this.left, that.left);
  },
  [symbol3225]() {
    return combine3223(hash2225(this._tag))(hash2225(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON2225(this.left)
    };
  }
});
var isEither2225 = (input) => hasProperty2225(input, TypeId75);
var isLeft2225 = (ma) => ma._tag === "Left";
var isRight2225 = (ma) => ma._tag === "Right";
var left3223 = (left522) => {
  const a2222 = Object.create(LeftProto2225);
  a2222.left = left522;
  return a2222;
};
var right3223 = (right522) => {
  const a2222 = Object.create(RightProto2225);
  a2222.right = right522;
  return a2222;
};
var getLeft3225 = (self2) => isRight2225(self2) ? none3225 : some55(self2.left);
var getRight3225 = (self2) => isLeft2225(self2) ? none3225 : some55(self2.right);
var isLeft35 = isLeft2225;
var isRight35 = isRight2225;
var isNonEmptyArray6 = (self2) => self2.length > 0;
var Option_exports2225 = {};
__export325(Option_exports2225, {
  Do: () => Do2225,
  TypeId: () => TypeId85,
  all: () => all45,
  andThen: () => andThen2225,
  ap: () => ap2225,
  as: () => as2225,
  asVoid: () => asVoid2225,
  bind: () => bind45,
  bindTo: () => bindTo45,
  composeK: () => composeK2225,
  contains: () => contains2225,
  containsWith: () => containsWith2225,
  exists: () => exists2225,
  filter: () => filter2225,
  filterMap: () => filterMap2225,
  firstSomeOf: () => firstSomeOf2225,
  flatMap: () => flatMap2225,
  flatMapNullable: () => flatMapNullable2225,
  flatten: () => flatten2225,
  fromIterable: () => fromIterable3223,
  fromNullable: () => fromNullable2225,
  gen: () => gen2225,
  getEquivalence: () => getEquivalence3223,
  getLeft: () => getLeft45,
  getOrElse: () => getOrElse2225,
  getOrNull: () => getOrNull2225,
  getOrThrow: () => getOrThrow2225,
  getOrThrowWith: () => getOrThrowWith2225,
  getOrUndefined: () => getOrUndefined2225,
  getOrder: () => getOrder2225,
  getRight: () => getRight45,
  isNone: () => isNone45,
  isOption: () => isOption45,
  isSome: () => isSome45,
  let: () => let_45,
  lift2: () => lift22225,
  liftNullable: () => liftNullable2225,
  liftPredicate: () => liftPredicate2225,
  liftThrowable: () => liftThrowable2225,
  map: () => map2225,
  match: () => match324,
  none: () => none45,
  orElse: () => orElse2225,
  orElseEither: () => orElseEither2225,
  orElseSome: () => orElseSome2225,
  partitionMap: () => partitionMap2225,
  product: () => product45,
  productMany: () => productMany45,
  reduceCompact: () => reduceCompact2225,
  some: () => some65,
  tap: () => tap2225,
  toArray: () => toArray2225,
  toRefinement: () => toRefinement2225,
  void: () => void_2225,
  zipLeft: () => zipLeft2225,
  zipRight: () => zipRight2225,
  zipWith: () => zipWith2225
});
var make85 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var number35 = /* @__PURE__ */ make85((self2, that) => self2 < that ? -1 : 1);
var combineMany5 = /* @__PURE__ */ dual2225(2, (self2, collection) => make85((a1, a2222) => {
  let out = self2(a1, a2222);
  if (out !== 0) {
    return out;
  }
  for (const O2222 of collection) {
    out = O2222(a1, a2222);
    if (out !== 0) {
      return out;
    }
  }
  return out;
}));
var empty8223 = () => make85(() => 0);
var combineAll5 = (collection) => combineMany5(empty8223(), collection);
var mapInput35 = /* @__PURE__ */ dual2225(2, (self2, f2222) => make85((b1, b2222) => self2(f2222(b1), f2222(b2222))));
var array45 = (O2222) => make85((self2, that) => {
  const aLen = self2.length;
  const bLen = that.length;
  const len = Math.min(aLen, bLen);
  for (let i2222 = 0; i2222 < len; i2222++) {
    const o2222 = O2222(self2[i2222], that[i2222]);
    if (o2222 !== 0) {
      return o2222;
    }
  }
  return number35(aLen, bLen);
});
var min6 = (O2222) => dual2225(2, (self2, that) => self2 === that || O2222(self2, that) < 1 ? self2 : that);
var max6 = (O2222) => dual2225(2, (self2, that) => self2 === that || O2222(self2, that) > -1 ? self2 : that);
var TypeId85 = /* @__PURE__ */ Symbol.for("effect/Option");
var none45 = () => none3225;
var some65 = some55;
var isOption45 = isOption3225;
var isNone45 = isNone3225;
var isSome45 = isSome3225;
var match324 = /* @__PURE__ */ dual2225(2, (self2, {
  onNone,
  onSome
}) => isNone45(self2) ? onNone() : onSome(self2.value));
var toRefinement2225 = (f2222) => (a2222) => isSome45(f2222(a2222));
var fromIterable3223 = (collection) => {
  for (const a2222 of collection) {
    return some65(a2222);
  }
  return none45();
};
var getRight45 = getRight3225;
var getLeft45 = getLeft3225;
var getOrElse2225 = /* @__PURE__ */ dual2225(2, (self2, onNone) => isNone45(self2) ? onNone() : self2.value);
var orElse2225 = /* @__PURE__ */ dual2225(2, (self2, that) => isNone45(self2) ? that() : self2);
var orElseSome2225 = /* @__PURE__ */ dual2225(2, (self2, onNone) => isNone45(self2) ? some65(onNone()) : self2);
var orElseEither2225 = /* @__PURE__ */ dual2225(2, (self2, that) => isNone45(self2) ? map2225(that(), right3223) : map2225(self2, left3223));
var firstSomeOf2225 = (collection) => {
  let out = none45();
  for (out of collection) {
    if (isSome45(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable2225 = (nullableValue) => nullableValue == null ? none45() : some65(nullableValue);
var liftNullable2225 = (f2222) => (...a2222) => fromNullable2225(f2222(...a2222));
var getOrNull2225 = /* @__PURE__ */ getOrElse2225(constNull2225);
var getOrUndefined2225 = /* @__PURE__ */ getOrElse2225(constUndefined2225);
var liftThrowable2225 = (f2222) => (...a2222) => {
  try {
    return some65(f2222(...a2222));
  } catch (e2222) {
    return none45();
  }
};
var getOrThrowWith2225 = /* @__PURE__ */ dual2225(2, (self2, onNone) => {
  if (isSome45(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow2225 = /* @__PURE__ */ getOrThrowWith2225(() => new Error("getOrThrow called on a None"));
var map2225 = /* @__PURE__ */ dual2225(2, (self2, f2222) => isNone45(self2) ? none45() : some65(f2222(self2.value)));
var as2225 = /* @__PURE__ */ dual2225(2, (self2, b2222) => map2225(self2, () => b2222));
var asVoid2225 = /* @__PURE__ */ as2225(void 0);
var void_2225 = /* @__PURE__ */ some65(void 0);
var flatMap2225 = /* @__PURE__ */ dual2225(2, (self2, f2222) => isNone45(self2) ? none45() : f2222(self2.value));
var andThen2225 = /* @__PURE__ */ dual2225(2, (self2, f2222) => flatMap2225(self2, (a2222) => {
  const b2222 = isFunction423(f2222) ? f2222(a2222) : f2222;
  return isOption45(b2222) ? b2222 : some65(b2222);
}));
var flatMapNullable2225 = /* @__PURE__ */ dual2225(2, (self2, f2222) => isNone45(self2) ? none45() : fromNullable2225(f2222(self2.value)));
var flatten2225 = /* @__PURE__ */ flatMap2225(identity2225);
var zipRight2225 = /* @__PURE__ */ dual2225(2, (self2, that) => flatMap2225(self2, () => that));
var composeK2225 = /* @__PURE__ */ dual2225(2, (afb, bfc) => (a2222) => flatMap2225(afb(a2222), bfc));
var zipLeft2225 = /* @__PURE__ */ dual2225(2, (self2, that) => tap2225(self2, () => that));
var tap2225 = /* @__PURE__ */ dual2225(2, (self2, f2222) => flatMap2225(self2, (a2222) => map2225(f2222(a2222), () => a2222)));
var product45 = (self2, that) => isSome45(self2) && isSome45(that) ? some65([self2.value, that.value]) : none45();
var productMany45 = (self2, collection) => {
  if (isNone45(self2)) {
    return none45();
  }
  const out = [self2.value];
  for (const o2222 of collection) {
    if (isNone45(o2222)) {
      return none45();
    }
    out.push(o2222.value);
  }
  return some65(out);
};
var all45 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o2222 of input) {
      if (isNone45(o2222)) {
        return none45();
      }
      out2.push(o2222.value);
    }
    return some65(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o2222 = input[key];
    if (isNone45(o2222)) {
      return none45();
    }
    out[key] = o2222.value;
  }
  return some65(out);
};
var zipWith2225 = /* @__PURE__ */ dual2225(3, (self2, that, f2222) => map2225(product45(self2, that), ([a2222, b2222]) => f2222(a2222, b2222)));
var ap2225 = /* @__PURE__ */ dual2225(2, (self2, that) => zipWith2225(self2, that, (f2222, a2222) => f2222(a2222)));
var reduceCompact2225 = /* @__PURE__ */ dual2225(3, (self2, b2222, f2222) => {
  let out = b2222;
  for (const oa of self2) {
    if (isSome45(oa)) {
      out = f2222(out, oa.value);
    }
  }
  return out;
});
var toArray2225 = (self2) => isNone45(self2) ? [] : [self2.value];
var partitionMap2225 = /* @__PURE__ */ dual2225(2, (self2, f2222) => {
  if (isNone45(self2)) {
    return [none45(), none45()];
  }
  const e2222 = f2222(self2.value);
  return isLeft2225(e2222) ? [some65(e2222.left), none45()] : [none45(), some65(e2222.right)];
});
var filterMap2225 = /* @__PURE__ */ dual2225(2, (self2, f2222) => isNone45(self2) ? none45() : f2222(self2.value));
var filter2225 = /* @__PURE__ */ dual2225(2, (self2, predicate) => filterMap2225(self2, (b2222) => predicate(b2222) ? some55(b2222) : none3225));
var getEquivalence3223 = (isEquivalent) => make6223((x2222, y2222) => x2222 === y2222 || (isNone45(x2222) ? isNone45(y2222) : isNone45(y2222) ? false : isEquivalent(x2222.value, y2222.value)));
var getOrder2225 = (O2222) => make85((self2, that) => isSome45(self2) ? isSome45(that) ? O2222(self2.value, that.value) : 1 : -1);
var lift22225 = (f2222) => dual2225(2, (self2, that) => zipWith2225(self2, that, f2222));
var liftPredicate2225 = (predicate) => (b2222) => predicate(b2222) ? some65(b2222) : none45();
var containsWith2225 = (isEquivalent) => dual2225(2, (self2, a2222) => isNone45(self2) ? false : isEquivalent(self2.value, a2222));
var _equivalence3223 = /* @__PURE__ */ equivalence2225();
var contains2225 = /* @__PURE__ */ containsWith2225(_equivalence3223);
var exists2225 = /* @__PURE__ */ dual2225(2, (self2, refinement) => isNone45(self2) ? false : refinement(self2.value));
var bindTo45 = /* @__PURE__ */ bindTo3225(map2225);
var let_45 = /* @__PURE__ */ let_3225(map2225);
var bind45 = /* @__PURE__ */ bind3225(map2225, flatMap2225);
var Do2225 = /* @__PURE__ */ some65({});
var adapter45 = /* @__PURE__ */ adapter3225();
var gen2225 = (f2222) => {
  const iterator = f2222(adapter45);
  let state = iterator.next();
  if (state.done) {
    return some65(state.value);
  } else {
    let current = state.value;
    if (isGenKind2225(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet2225(current);
    }
    if (isNone45(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind2225(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet2225(current);
        }
        if (isNone45(current)) {
          return current;
        }
      }
    }
    return some65(state.value);
  }
};
var make95 = (...elements) => elements;
var findFirst6 = /* @__PURE__ */ dual2225(2, (self2, f2222) => {
  let i2222 = 0;
  for (const a2222 of self2) {
    const o2222 = f2222(a2222, i2222);
    if (isBoolean2223(o2222)) {
      if (o2222) {
        return some65(a2222);
      }
    } else {
      if (isSome45(o2222)) {
        return o2222;
      }
    }
    i2222++;
  }
  return none45();
});
var collect6 = /* @__PURE__ */ dual2225(2, (self2, f2222) => {
  const out = [];
  for (const key of keys2223(self2)) {
    out.push(f2222(key, self2[key]));
  }
  return out;
});
var toEntries6 = /* @__PURE__ */ collect6((key, value) => [key, value]);
var keys2223 = (self2) => Object.keys(self2);
var make105 = (...elements) => elements;
var allocate5 = (n2222) => new Array(n2222);
var makeBy5 = (n2222, f2222) => {
  const max322 = Math.max(1, Math.floor(n2222));
  const out = new Array(max322);
  for (let i2222 = 0; i2222 < max322; i2222++) {
    out[i2222] = f2222(i2222);
  }
  return out;
};
var range5 = (start, end) => start <= end ? makeBy5(end - start + 1, (i2222) => start + i2222) : [start];
var replicate5 = /* @__PURE__ */ dual2225(2, (a2222, n2222) => makeBy5(n2222, () => a2222));
var fromIterable45 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var fromRecord5 = toEntries6;
var fromOption25 = toArray2225;
var match45 = /* @__PURE__ */ dual2225(2, (self2, {
  onEmpty,
  onNonEmpty
}) => isNonEmptyReadonlyArray5(self2) ? onNonEmpty(self2) : onEmpty());
var matchLeft5 = /* @__PURE__ */ dual2225(2, (self2, {
  onEmpty,
  onNonEmpty
}) => isNonEmptyReadonlyArray5(self2) ? onNonEmpty(headNonEmpty2223(self2), tailNonEmpty2223(self2)) : onEmpty());
var matchRight5 = /* @__PURE__ */ dual2225(2, (self2, {
  onEmpty,
  onNonEmpty
}) => isNonEmptyReadonlyArray5(self2) ? onNonEmpty(initNonEmpty5(self2), lastNonEmpty5(self2)) : onEmpty());
var prepend2223 = /* @__PURE__ */ dual2225(2, (self2, head222) => [head222, ...self2]);
var prependAll5 = /* @__PURE__ */ dual2225(2, (self2, that) => fromIterable45(that).concat(fromIterable45(self2)));
var append6 = /* @__PURE__ */ dual2225(2, (self2, last222) => [...self2, last222]);
var appendAll2223 = /* @__PURE__ */ dual2225(2, (self2, that) => fromIterable45(self2).concat(fromIterable45(that)));
var scan5 = /* @__PURE__ */ dual2225(3, (self2, b2222, f2222) => {
  const out = [b2222];
  let i2222 = 0;
  for (const a2222 of self2) {
    out[i2222 + 1] = f2222(out[i2222], a2222);
    i2222++;
  }
  return out;
});
var scanRight5 = /* @__PURE__ */ dual2225(3, (self2, b2222, f2222) => {
  const input = fromIterable45(self2);
  const out = new Array(input.length + 1);
  out[input.length] = b2222;
  for (let i2222 = input.length - 1; i2222 >= 0; i2222--) {
    out[i2222] = f2222(out[i2222 + 1], input[i2222]);
  }
  return out;
});
var isArray5 = Array.isArray;
var isEmptyArray5 = (self2) => self2.length === 0;
var isEmptyReadonlyArray5 = isEmptyArray5;
var isNonEmptyArray25 = isNonEmptyArray6;
var isNonEmptyReadonlyArray5 = isNonEmptyArray6;
var length6 = (self2) => self2.length;
var isOutOfBound5 = (i2222, as422) => i2222 < 0 || i2222 >= as422.length;
var clamp5 = (i2222, as422) => Math.floor(Math.min(Math.max(0, i2222), as422.length));
var get10 = /* @__PURE__ */ dual2225(2, (self2, index) => {
  const i2222 = Math.floor(index);
  return isOutOfBound5(i2222, self2) ? none45() : some65(self2[i2222]);
});
var unsafeGet6 = /* @__PURE__ */ dual2225(2, (self2, index) => {
  const i2222 = Math.floor(index);
  if (isOutOfBound5(i2222, self2)) {
    throw new Error(`Index ${i2222} out of bounds`);
  }
  return self2[i2222];
});
var unprepend5 = (self2) => [headNonEmpty2223(self2), tailNonEmpty2223(self2)];
var unappend5 = (self2) => [initNonEmpty5(self2), lastNonEmpty5(self2)];
var head6 = /* @__PURE__ */ get10(0);
var headNonEmpty2223 = /* @__PURE__ */ unsafeGet6(0);
var last5 = (self2) => isNonEmptyReadonlyArray5(self2) ? some65(lastNonEmpty5(self2)) : none45();
var lastNonEmpty5 = (self2) => self2[self2.length - 1];
var tail6 = (self2) => {
  const input = fromIterable45(self2);
  return isNonEmptyReadonlyArray5(input) ? some65(tailNonEmpty2223(input)) : none45();
};
var tailNonEmpty2223 = (self2) => self2.slice(1);
var init5 = (self2) => {
  const input = fromIterable45(self2);
  return isNonEmptyReadonlyArray5(input) ? some65(initNonEmpty5(input)) : none45();
};
var initNonEmpty5 = (self2) => self2.slice(0, -1);
var take5 = /* @__PURE__ */ dual2225(2, (self2, n2222) => {
  const input = fromIterable45(self2);
  return input.slice(0, clamp5(n2222, input));
});
var takeRight5 = /* @__PURE__ */ dual2225(2, (self2, n2222) => {
  const input = fromIterable45(self2);
  const i2222 = clamp5(n2222, input);
  return i2222 === 0 ? [] : input.slice(-i2222);
});
var takeWhile5 = /* @__PURE__ */ dual2225(2, (self2, predicate) => {
  let i2222 = 0;
  const out = [];
  for (const a2222 of self2) {
    if (!predicate(a2222, i2222)) {
      break;
    }
    out.push(a2222);
    i2222++;
  }
  return out;
});
var spanIndex5 = (self2, predicate) => {
  let i2222 = 0;
  for (const a2222 of self2) {
    if (!predicate(a2222, i2222)) {
      break;
    }
    i2222++;
  }
  return i2222;
};
var span5 = /* @__PURE__ */ dual2225(2, (self2, predicate) => splitAt5(self2, spanIndex5(self2, predicate)));
var drop2223 = /* @__PURE__ */ dual2225(2, (self2, n2222) => {
  const input = fromIterable45(self2);
  return input.slice(clamp5(n2222, input), input.length);
});
var dropRight5 = /* @__PURE__ */ dual2225(2, (self2, n2222) => {
  const input = fromIterable45(self2);
  return input.slice(0, input.length - clamp5(n2222, input));
});
var dropWhile5 = /* @__PURE__ */ dual2225(2, (self2, predicate) => fromIterable45(self2).slice(spanIndex5(self2, predicate)));
var findFirstIndex5 = /* @__PURE__ */ dual2225(2, (self2, predicate) => {
  let i2222 = 0;
  for (const a2222 of self2) {
    if (predicate(a2222, i2222)) {
      return some65(i2222);
    }
    i2222++;
  }
  return none45();
});
var findLastIndex5 = /* @__PURE__ */ dual2225(2, (self2, predicate) => {
  const input = fromIterable45(self2);
  for (let i2222 = input.length - 1; i2222 >= 0; i2222--) {
    if (predicate(input[i2222], i2222)) {
      return some65(i2222);
    }
  }
  return none45();
});
var findFirst25 = findFirst6;
var findLast5 = /* @__PURE__ */ dual2225(2, (self2, f2222) => {
  const input = fromIterable45(self2);
  for (let i2222 = input.length - 1; i2222 >= 0; i2222--) {
    const a2222 = input[i2222];
    const o2222 = f2222(a2222, i2222);
    if (isBoolean2223(o2222)) {
      if (o2222) {
        return some65(a2222);
      }
    } else {
      if (isSome45(o2222)) {
        return o2222;
      }
    }
  }
  return none45();
});
var insertAt5 = /* @__PURE__ */ dual2225(3, (self2, i2222, b2222) => {
  const out = Array.from(self2);
  if (i2222 < 0 || i2222 > out.length) {
    return none45();
  }
  out.splice(i2222, 0, b2222);
  return some65(out);
});
var replace25 = /* @__PURE__ */ dual2225(3, (self2, i2222, b2222) => modify6(self2, i2222, () => b2222));
var replaceOption6 = /* @__PURE__ */ dual2225(3, (self2, i2222, b2222) => modifyOption6(self2, i2222, () => b2222));
var modify6 = /* @__PURE__ */ dual2225(3, (self2, i2222, f2222) => getOrElse2225(modifyOption6(self2, i2222, f2222), () => Array.from(self2)));
var modifyOption6 = /* @__PURE__ */ dual2225(3, (self2, i2222, f2222) => {
  const out = Array.from(self2);
  if (isOutOfBound5(i2222, out)) {
    return none45();
  }
  const next = f2222(out[i2222]);
  out[i2222] = next;
  return some65(out);
});
var remove7 = /* @__PURE__ */ dual2225(2, (self2, i2222) => {
  const out = Array.from(self2);
  if (isOutOfBound5(i2222, out)) {
    return out;
  }
  out.splice(i2222, 1);
  return out;
});
var reverse3223 = (self2) => Array.from(self2).reverse();
var sort5 = /* @__PURE__ */ dual2225(2, (self2, O2222) => {
  const out = Array.from(self2);
  out.sort(O2222);
  return out;
});
var sortWith5 = /* @__PURE__ */ dual2225(3, (self2, f2222, order) => sort5(self2, mapInput35(order, f2222)));
var sortBy5 = (...orders) => {
  const sortByAll = sort5(combineAll5(orders));
  return (self2) => {
    const input = fromIterable45(self2);
    if (isNonEmptyReadonlyArray5(input)) {
      return sortByAll(input);
    }
    return [];
  };
};
var zip5 = /* @__PURE__ */ dual2225(2, (self2, that) => zipWith35(self2, that, make95));
var zipWith35 = /* @__PURE__ */ dual2225(3, (self2, that, f2222) => {
  const as422 = fromIterable45(self2);
  const bs = fromIterable45(that);
  if (isNonEmptyReadonlyArray5(as422) && isNonEmptyReadonlyArray5(bs)) {
    const out = [f2222(headNonEmpty2223(as422), headNonEmpty2223(bs))];
    const len = Math.min(as422.length, bs.length);
    for (let i2222 = 1; i2222 < len; i2222++) {
      out[i2222] = f2222(as422[i2222], bs[i2222]);
    }
    return out;
  }
  return [];
});
var unzip5 = (self2) => {
  const input = fromIterable45(self2);
  if (isNonEmptyReadonlyArray5(input)) {
    const fa = [input[0][0]];
    const fb = [input[0][1]];
    for (let i2222 = 1; i2222 < input.length; i2222++) {
      fa[i2222] = input[i2222][0];
      fb[i2222] = input[i2222][1];
    }
    return [fa, fb];
  }
  return [[], []];
};
var intersperse5 = /* @__PURE__ */ dual2225(2, (self2, middle) => {
  const input = fromIterable45(self2);
  if (isNonEmptyReadonlyArray5(input)) {
    const out = [headNonEmpty2223(input)];
    const tail222 = tailNonEmpty2223(input);
    for (let i2222 = 0; i2222 < tail222.length; i2222++) {
      if (i2222 < tail222.length) {
        out.push(middle);
      }
      out.push(tail222[i2222]);
    }
    return out;
  }
  return [];
});
var modifyNonEmptyHead5 = /* @__PURE__ */ dual2225(2, (self2, f2222) => [f2222(headNonEmpty2223(self2)), ...tailNonEmpty2223(self2)]);
var setNonEmptyHead5 = /* @__PURE__ */ dual2225(2, (self2, b2222) => modifyNonEmptyHead5(self2, () => b2222));
var modifyNonEmptyLast5 = /* @__PURE__ */ dual2225(2, (self2, f2222) => append6(initNonEmpty5(self2), f2222(lastNonEmpty5(self2))));
var setNonEmptyLast5 = /* @__PURE__ */ dual2225(2, (self2, b2222) => modifyNonEmptyLast5(self2, () => b2222));
var rotate5 = /* @__PURE__ */ dual2225(2, (self2, n2222) => {
  const input = fromIterable45(self2);
  if (isNonEmptyReadonlyArray5(input)) {
    const len = input.length;
    const m2222 = Math.round(n2222) % len;
    if (isOutOfBound5(Math.abs(m2222), input) || m2222 === 0) {
      return copy2223(input);
    }
    if (m2222 < 0) {
      const [f2222, s2222] = splitNonEmptyAt5(input, -m2222);
      return appendAll2223(s2222, f2222);
    } else {
      return rotate5(self2, m2222 - len);
    }
  }
  return [];
});
var containsWith35 = (isEquivalent) => dual2225(2, (self2, a2222) => {
  for (const i2222 of self2) {
    if (isEquivalent(a2222, i2222)) {
      return true;
    }
  }
  return false;
});
var _equivalence45 = /* @__PURE__ */ equivalence2225();
var contains35 = /* @__PURE__ */ containsWith35(_equivalence45);
var chop5 = /* @__PURE__ */ dual2225(2, (self2, f2222) => {
  const input = fromIterable45(self2);
  if (isNonEmptyReadonlyArray5(input)) {
    const [b2222, rest] = f2222(input);
    const out = [b2222];
    let next = rest;
    while (isNonEmptyArray6(next)) {
      const [b322, rest2] = f2222(next);
      out.push(b322);
      next = rest2;
    }
    return out;
  }
  return [];
});
var splitAt5 = /* @__PURE__ */ dual2225(2, (self2, n2222) => {
  const input = Array.from(self2);
  const _n = Math.floor(n2222);
  if (isNonEmptyReadonlyArray5(input)) {
    if (_n >= 1) {
      return splitNonEmptyAt5(input, _n);
    }
    return [[], input];
  }
  return [input, []];
});
var splitNonEmptyAt5 = /* @__PURE__ */ dual2225(2, (self2, n2222) => {
  const _n = Math.max(1, Math.floor(n2222));
  return _n >= self2.length ? [copy2223(self2), []] : [prepend2223(self2.slice(1, _n), headNonEmpty2223(self2)), self2.slice(_n)];
});
var split5 = /* @__PURE__ */ dual2225(2, (self2, n2222) => {
  const input = fromIterable45(self2);
  return chunksOf5(input, Math.ceil(input.length / Math.floor(n2222)));
});
var splitWhere5 = /* @__PURE__ */ dual2225(2, (self2, predicate) => span5(self2, (a2222, i2222) => !predicate(a2222, i2222)));
var copy2223 = (self2) => self2.slice();
var chunksOf5 = /* @__PURE__ */ dual2225(2, (self2, n2222) => {
  const input = fromIterable45(self2);
  if (isNonEmptyReadonlyArray5(input)) {
    return chop5(input, splitNonEmptyAt5(n2222));
  }
  return [];
});
var groupWith5 = /* @__PURE__ */ dual2225(2, (self2, isEquivalent) => chop5(self2, (as422) => {
  const h2222 = headNonEmpty2223(as422);
  const out = [h2222];
  let i2222 = 1;
  for (; i2222 < as422.length; i2222++) {
    const a2222 = as422[i2222];
    if (isEquivalent(a2222, h2222)) {
      out.push(a2222);
    } else {
      break;
    }
  }
  return [out, as422.slice(i2222)];
}));
var group5 = /* @__PURE__ */ groupWith5(/* @__PURE__ */ equivalence2225());
var groupBy5 = /* @__PURE__ */ dual2225(2, (self2, f2222) => {
  const out = {};
  for (const a2222 of self2) {
    const k2222 = f2222(a2222);
    if (Object.prototype.hasOwnProperty.call(out, k2222)) {
      out[k2222].push(a2222);
    } else {
      out[k2222] = [a2222];
    }
  }
  return out;
});
var unionWith5 = /* @__PURE__ */ dual2225(3, (self2, that, isEquivalent) => {
  const a2222 = fromIterable45(self2);
  const b2222 = fromIterable45(that);
  if (isNonEmptyReadonlyArray5(a2222)) {
    if (isNonEmptyReadonlyArray5(b2222)) {
      const dedupe222 = dedupeWith5(isEquivalent);
      return dedupe222(appendAll2223(a2222, b2222));
    }
    return a2222;
  }
  return b2222;
});
var union8 = /* @__PURE__ */ dual2225(2, (self2, that) => unionWith5(self2, that, _equivalence45));
var intersectionWith5 = (isEquivalent) => {
  const has22 = containsWith35(isEquivalent);
  return dual2225(2, (self2, that) => fromIterable45(self2).filter((a2222) => has22(that, a2222)));
};
var intersection6 = /* @__PURE__ */ intersectionWith5(_equivalence45);
var differenceWith5 = (isEquivalent) => {
  const has22 = containsWith35(isEquivalent);
  return dual2225(2, (self2, that) => fromIterable45(self2).filter((a2222) => !has22(that, a2222)));
};
var difference6 = /* @__PURE__ */ differenceWith5(_equivalence45);
var empty95 = () => [];
var of2223 = (a2222) => [a2222];
var map35 = /* @__PURE__ */ dual2225(2, (self2, f2222) => self2.map(f2222));
var flatMap35 = /* @__PURE__ */ dual2225(2, (self2, f2222) => {
  if (isEmptyReadonlyArray5(self2)) {
    return [];
  }
  const out = [];
  for (let i2222 = 0; i2222 < self2.length; i2222++) {
    const inner = f2222(self2[i2222], i2222);
    for (let j2222 = 0; j2222 < inner.length; j2222++) {
      out.push(inner[j2222]);
    }
  }
  return out;
});
var flatten35 = /* @__PURE__ */ flatMap35(identity2225);
var filterMap35 = /* @__PURE__ */ dual2225(2, (self2, f2222) => {
  const as422 = fromIterable45(self2);
  const out = [];
  for (let i2222 = 0; i2222 < as422.length; i2222++) {
    const o2222 = f2222(as422[i2222], i2222);
    if (isSome45(o2222)) {
      out.push(o2222.value);
    }
  }
  return out;
});
var filterMapWhile5 = /* @__PURE__ */ dual2225(2, (self2, f2222) => {
  let i2222 = 0;
  const out = [];
  for (const a2222 of self2) {
    const b2222 = f2222(a2222, i2222);
    if (isSome45(b2222)) {
      out.push(b2222.value);
    } else {
      break;
    }
    i2222++;
  }
  return out;
});
var partitionMap35 = /* @__PURE__ */ dual2225(2, (self2, f2222) => {
  const left522 = [];
  const right522 = [];
  const as422 = fromIterable45(self2);
  for (let i2222 = 0; i2222 < as422.length; i2222++) {
    const e2222 = f2222(as422[i2222], i2222);
    if (isLeft35(e2222)) {
      left522.push(e2222.left);
    } else {
      right522.push(e2222.right);
    }
  }
  return [left522, right522];
});
var getSomes6 = /* @__PURE__ */ filterMap35(identity2225);
var getLefts6 = (self2) => {
  const out = [];
  for (const a2222 of self2) {
    if (isLeft35(a2222)) {
      out.push(a2222.left);
    }
  }
  return out;
};
var getRights6 = (self2) => {
  const out = [];
  for (const a2222 of self2) {
    if (isRight35(a2222)) {
      out.push(a2222.right);
    }
  }
  return out;
};
var filter35 = /* @__PURE__ */ dual2225(2, (self2, predicate) => {
  const as422 = fromIterable45(self2);
  const out = [];
  for (let i2222 = 0; i2222 < as422.length; i2222++) {
    if (predicate(as422[i2222], i2222)) {
      out.push(as422[i2222]);
    }
  }
  return out;
});
var partition6 = /* @__PURE__ */ dual2225(2, (self2, predicate) => {
  const left522 = [];
  const right522 = [];
  const as422 = fromIterable45(self2);
  for (let i2222 = 0; i2222 < as422.length; i2222++) {
    if (predicate(as422[i2222], i2222)) {
      right522.push(as422[i2222]);
    } else {
      left522.push(as422[i2222]);
    }
  }
  return [left522, right522];
});
var separate6 = /* @__PURE__ */ partitionMap35(identity2225);
var reduce3223 = /* @__PURE__ */ dual2225(3, (self2, b2222, f2222) => fromIterable45(self2).reduce((b322, a2222, i2222) => f2222(b322, a2222, i2222), b2222));
var reduceRight5 = /* @__PURE__ */ dual2225(3, (self2, b2222, f2222) => fromIterable45(self2).reduceRight((b322, a2222, i2222) => f2222(b322, a2222, i2222), b2222));
var liftPredicate35 = (predicate) => (b2222) => predicate(b2222) ? [b2222] : [];
var liftOption5 = (f2222) => (...a2222) => fromOption25(f2222(...a2222));
var fromNullable35 = (a2222) => a2222 == null ? empty95() : [a2222];
var liftNullable35 = (f2222) => (...a2222) => fromNullable35(f2222(...a2222));
var flatMapNullable35 = /* @__PURE__ */ dual2225(2, (self2, f2222) => flatMap35(self2, (a2222) => fromNullable35(f2222(a2222))));
var liftEither5 = (f2222) => (...a2222) => {
  const e2222 = f2222(...a2222);
  return isLeft35(e2222) ? [] : [e2222.right];
};
var every35 = /* @__PURE__ */ dual2225(2, (self2, refinement) => self2.every(refinement));
var some75 = /* @__PURE__ */ dual2225(2, (self2, predicate) => self2.some(predicate));
var extend5 = /* @__PURE__ */ dual2225(2, (self2, f2222) => self2.map((_2222, i2222, as422) => f2222(as422.slice(i2222))));
var min25 = /* @__PURE__ */ dual2225(2, (self2, O2222) => self2.reduce(min6(O2222)));
var max25 = /* @__PURE__ */ dual2225(2, (self2, O2222) => self2.reduce(max6(O2222)));
var unfold5 = (b2222, f2222) => {
  const out = [];
  let next = b2222;
  let o2222;
  while (isSome45(o2222 = f2222(next))) {
    const [a2222, b322] = o2222.value;
    out.push(a2222);
    next = b322;
  }
  return out;
};
var getOrder35 = array45;
var getEquivalence45 = array3223;
var forEach3223 = /* @__PURE__ */ dual2225(2, (self2, f2222) => fromIterable45(self2).forEach((a2222, i2222) => f2222(a2222, i2222)));
var dedupeWith5 = /* @__PURE__ */ dual2225(2, (self2, isEquivalent) => {
  const input = fromIterable45(self2);
  if (isNonEmptyReadonlyArray5(input)) {
    const out = [headNonEmpty2223(input)];
    const rest = tailNonEmpty2223(input);
    for (const r2222 of rest) {
      if (out.every((a2222) => !isEquivalent(r2222, a2222))) {
        out.push(r2222);
      }
    }
    return out;
  }
  return [];
});
var dedupe5 = (self2) => dedupeWith5(self2, equivalence2225());
var dedupeAdjacentWith5 = /* @__PURE__ */ dual2225(2, (self2, isEquivalent) => {
  const out = [];
  let lastA = none45();
  for (const a2222 of self2) {
    if (isNone45(lastA) || !isEquivalent(a2222, lastA.value)) {
      out.push(a2222);
      lastA = some65(a2222);
    }
  }
  return out;
});
var dedupeAdjacent5 = /* @__PURE__ */ dedupeAdjacentWith5(/* @__PURE__ */ equivalence2225());
var join5 = /* @__PURE__ */ dual2225(2, (self2, sep2) => fromIterable45(self2).join(sep2));
var mapAccum5 = /* @__PURE__ */ dual2225(3, (self2, s2222, f2222) => {
  let i2222 = 0;
  let s1 = s2222;
  const out = [];
  for (const a2222 of self2) {
    const r2222 = f2222(s1, a2222, i2222);
    s1 = r2222[0];
    out.push(r2222[1]);
    i2222++;
  }
  return [s1, out];
});
var cartesianWith5 = /* @__PURE__ */ dual2225(3, (self2, that, f2222) => flatMap35(self2, (a2222) => map35(that, (b2222) => f2222(a2222, b2222))));
var cartesian5 = /* @__PURE__ */ dual2225(2, (self2, that) => cartesianWith5(self2, that, (a2222, b2222) => [a2222, b2222]));
var Do35 = /* @__PURE__ */ of2223({});
var bind55 = /* @__PURE__ */ bind3225(map35, flatMap35);
var bindTo55 = /* @__PURE__ */ bindTo3225(map35);
var let_55 = /* @__PURE__ */ let_3225(map35);
var __defProp3223 = Object.defineProperty;
var __export3223 = (target, all32222) => {
  for (var name22 in all32222)
    __defProp3223(target, name22, { get: all32222[name22], enumerable: true });
};
var Function_exports35 = {};
__export3223(Function_exports35, {
  SK: () => SK35,
  absurd: () => absurd35,
  apply: () => apply35,
  compose: () => compose55,
  constFalse: () => constFalse35,
  constNull: () => constNull35,
  constTrue: () => constTrue35,
  constUndefined: () => constUndefined35,
  constVoid: () => constVoid35,
  constant: () => constant35,
  dual: () => dual35,
  flip: () => flip35,
  flow: () => flow35,
  hole: () => hole35,
  identity: () => identity35,
  isFunction: () => isFunction65,
  pipe: () => pipe35,
  satisfies: () => satisfies35,
  tupled: () => tupled35,
  unsafeCoerce: () => unsafeCoerce35,
  untupled: () => untupled35
});
var isFunction65 = (input) => typeof input === "function";
var dual35 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a2222, b2222) {
        if (arguments.length >= 2) {
          return body(a2222, b2222);
        }
        return function(self2) {
          return body(self2, a2222);
        };
      };
    case 3:
      return function(a2222, b2222, c2222) {
        if (arguments.length >= 3) {
          return body(a2222, b2222, c2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222);
        };
      };
    case 4:
      return function(a2222, b2222, c2222, d2222) {
        if (arguments.length >= 4) {
          return body(a2222, b2222, c2222, d2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222);
        };
      };
    case 5:
      return function(a2222, b2222, c2222, d2222, e2222) {
        if (arguments.length >= 5) {
          return body(a2222, b2222, c2222, d2222, e2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222, d2222);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply35 = (a2222) => (self2) => self2(a2222);
var identity35 = (a2222) => a2222;
var satisfies35 = () => (b2222) => b2222;
var unsafeCoerce35 = identity35;
var constant35 = (value) => () => value;
var constTrue35 = /* @__PURE__ */ constant35(true);
var constFalse35 = /* @__PURE__ */ constant35(false);
var constNull35 = /* @__PURE__ */ constant35(null);
var constUndefined35 = /* @__PURE__ */ constant35(void 0);
var constVoid35 = constUndefined35;
var flip35 = (f2222) => (...b2222) => (...a2222) => f2222(...a2222)(...b2222);
var compose55 = /* @__PURE__ */ dual35(2, (ab, bc) => (a2222) => bc(ab(a2222)));
var absurd35 = (_2222) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled35 = (f2222) => (a2222) => f2222(...a2222);
var untupled35 = (f2222) => (...a2222) => f2222(a2222);
function pipe35(a2222, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a2222;
    case 2:
      return ab(a2222);
    case 3:
      return bc(ab(a2222));
    case 4:
      return cd(bc(ab(a2222)));
    case 5:
      return de(cd(bc(ab(a2222))));
    case 6:
      return ef(de(cd(bc(ab(a2222)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a2222))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a2222)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a2222))))))));
    default: {
      let ret = arguments[0];
      for (let i2222 = 1; i2222 < arguments.length; i2222++) {
        ret = arguments[i2222](ret);
      }
      return ret;
    }
  }
}
function flow35(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole35 = /* @__PURE__ */ unsafeCoerce35(absurd35);
var SK35 = (_2222, b2222) => b2222;
var make115 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_65 = (map3222) => dual35(3, (self2, name22, f2222) => map3222(self2, (a2222) => Object.assign({}, a2222, {
  [name22]: f2222(a2222)
})));
var bindTo65 = (map3222) => dual35(2, (self2, name22) => map3222(self2, (a2222) => ({
  [name22]: a2222
})));
var bind65 = (map3222, flatMap3222) => dual35(3, (self2, name22, f2222) => flatMap3222(self2, (a2222) => map3222(f2222(a2222), (b2222) => Object.assign({}, a2222, {
  [name22]: b2222
}))));
var moduleVersion35 = "3.2.8";
var getCurrentVersion35 = () => moduleVersion35;
var globalStoreId35 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion35()}`);
if (!(globalStoreId35 in globalThis)) {
  globalThis[globalStoreId35] = /* @__PURE__ */ new Map();
}
var globalStore35 = globalThis[globalStoreId35];
var globalValue35 = (id, compute) => {
  if (!globalStore35.has(id)) {
    globalStore35.set(id, compute());
  }
  return globalStore35.get(id);
};
var isFunction22225 = isFunction65;
var isRecordOrArray35 = (input) => typeof input === "object" && input !== null;
var isObject35 = (input) => isRecordOrArray35(input) || isFunction22225(input);
var hasProperty35 = /* @__PURE__ */ dual35(2, (self2, property) => isObject35(self2) && property in self2);
var isNullable35 = (input) => input === null || input === void 0;
var getBugErrorMessage35 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId35 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind35 = (u2222) => isObject35(u2222) && GenKindTypeId35 in u2222;
var GenKindImpl35 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity35;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId35] = GenKindTypeId35;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen45(this);
  }
};
var SingleShotGen45 = class _SingleShotGen3223 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a2222) {
    return this.called ? {
      value: a2222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a2222) {
    return {
      value: a2222,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e2222) {
    throw e2222;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen3223(this.self);
  }
};
var adapter55 = () => function() {
  let x2222 = arguments[0];
  for (let i2222 = 1; i2222 < arguments.length; i2222++) {
    x2222 = arguments[i2222](x2222);
  }
  return new GenKindImpl35(x2222);
};
var defaultIncHi35 = 335903614;
var defaultIncLo35 = 4150755663;
var MUL_HI35 = 1481765933 >>> 0;
var MUL_LO35 = 1284865837 >>> 0;
var BIT_5335 = 9007199254740992;
var BIT_2735 = 134217728;
var PCGRandom35 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable35(seedLo) && isNullable35(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable35(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable35(incLo) && isNullable35(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo35;
      incHi = this._state ? this._state[2] : defaultIncHi35;
    } else if (isNullable35(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add6435(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max322) {
    if (!max322) {
      return this._next();
    }
    max322 = max322 >>> 0;
    if ((max322 & max322 - 1) === 0) {
      return this._next() & max322 - 1;
    }
    let num = 0;
    const skew = (-max322 >>> 0) % max322 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max322;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_2735 + lo) / BIT_5335;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul6435(this._state, oldHi, oldLo, MUL_HI35, MUL_LO35);
    add6435(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul6435(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add6435(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId35 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap35 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId35]() {
    return this.#value;
  }
};
function yieldWrapGet35(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId35 in self2) {
    return self2[YieldWrapTypeId35]();
  }
  throw new Error(getBugErrorMessage35("yieldWrapGet"));
}
var structuralRegionState35 = /* @__PURE__ */ globalValue35("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache35 = /* @__PURE__ */ globalValue35(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr35 = /* @__PURE__ */ globalValue35(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom35());
var symbol55 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash35 = (self2) => {
  if (structuralRegionState35.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number45(self2);
    case "bigint":
      return string35(self2.toString(10));
    case "boolean":
      return string35(String(self2));
    case "symbol":
      return string35(String(self2));
    case "string":
      return string35(self2);
    case "undefined":
      return string35("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string35("null");
      } else if (self2 instanceof Date) {
        return hash35(self2.toISOString());
      } else if (isHash35(self2)) {
        return self2[symbol55]();
      } else {
        return random35(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random35 = (self2) => {
  if (!randomHashCache35.has(self2)) {
    randomHashCache35.set(self2, number45(pcgr35.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache35.get(self2);
};
var combine45 = (b2222) => (self2) => self2 * 53 ^ b2222;
var optimize35 = (n2222) => n2222 & 3221225471 | n2222 >>> 1 & 1073741824;
var isHash35 = (u2222) => hasProperty35(u2222, symbol55);
var number45 = (n2222) => {
  if (n2222 !== n2222 || n2222 === Infinity) {
    return 0;
  }
  let h2222 = n2222 | 0;
  if (h2222 !== n2222) {
    h2222 ^= n2222 * 4294967295;
  }
  while (n2222 > 4294967295) {
    h2222 ^= n2222 /= 4294967295;
  }
  return optimize35(n2222);
};
var string35 = (str) => {
  let h2222 = 5381, i2222 = str.length;
  while (i2222) {
    h2222 = h2222 * 33 ^ str.charCodeAt(--i2222);
  }
  return optimize35(h2222);
};
var cached35 = function() {
  if (arguments.length === 1) {
    const self3 = arguments[0];
    return function(hash422) {
      Object.defineProperty(self3, symbol55, {
        value() {
          return hash422;
        },
        enumerable: false
      });
      return hash422;
    };
  }
  const self2 = arguments[0];
  const hash3222 = arguments[1];
  Object.defineProperty(self2, symbol55, {
    value() {
      return hash3222;
    },
    enumerable: false
  });
  return hash3222;
};
var symbol22225 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals35() {
  if (arguments.length === 1) {
    return (self2) => compareBoth35(self2, arguments[0]);
  }
  return compareBoth35(arguments[0], arguments[1]);
}
function compareBoth35(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual35(self2) && isEqual35(that)) {
        if (hash35(self2) === hash35(that) && self2[symbol22225](that)) {
          return true;
        } else {
          return structuralRegionState35.enabled && structuralRegionState35.tester ? structuralRegionState35.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState35.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v2222, i2222) => compareBoth35(v2222, that[i2222]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth35(self2[key], that[key]))) {
              return structuralRegionState35.tester ? structuralRegionState35.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState35.tester ? structuralRegionState35.tester(self2, that) : false;
    }
  }
  return structuralRegionState35.enabled && structuralRegionState35.tester ? structuralRegionState35.tester(self2, that) : false;
}
var isEqual35 = (u2222) => hasProperty35(u2222, symbol22225);
var equivalence35 = () => equals35;
var NodeInspectSymbol35 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON35 = (x2222) => {
  if (hasProperty35(x2222, "toJSON") && isFunction22225(x2222["toJSON"]) && x2222["toJSON"].length === 0) {
    return x2222.toJSON();
  } else if (Array.isArray(x2222)) {
    return x2222.map(toJSON35);
  }
  return x2222;
};
var format35 = (x2222) => JSON.stringify(x2222, null, 2);
var pipeArguments35 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i2222 = 0, len = args.length; i2222 < len; i2222++) {
        ret = args[i2222](ret);
      }
      return ret;
    }
  }
};
var EffectTypeId45 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId35 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId35 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId35 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance35 = {
  /* c8 ignore next */
  _R: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _A: (_2222) => _2222,
  _V: /* @__PURE__ */ getCurrentVersion35()
};
var sinkVariance35 = {
  /* c8 ignore next */
  _A: (_2222) => _2222,
  /* c8 ignore next */
  _In: (_2222) => _2222,
  /* c8 ignore next */
  _L: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _R: (_2222) => _2222
};
var channelVariance35 = {
  /* c8 ignore next */
  _Env: (_2222) => _2222,
  /* c8 ignore next */
  _InErr: (_2222) => _2222,
  /* c8 ignore next */
  _InElem: (_2222) => _2222,
  /* c8 ignore next */
  _InDone: (_2222) => _2222,
  /* c8 ignore next */
  _OutErr: (_2222) => _2222,
  /* c8 ignore next */
  _OutElem: (_2222) => _2222,
  /* c8 ignore next */
  _OutDone: (_2222) => _2222
};
var EffectPrototype35 = {
  [EffectTypeId45]: effectVariance35,
  [StreamTypeId35]: effectVariance35,
  [SinkTypeId35]: sinkVariance35,
  [ChannelTypeId35]: channelVariance35,
  [symbol22225](that) {
    return this === that;
  },
  [symbol55]() {
    return cached35(this, random35(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen45(new YieldWrap35(this));
  },
  pipe() {
    return pipeArguments35(this, arguments);
  }
};
var TypeId95 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto55 = {
  ...EffectPrototype35,
  [TypeId95]: {
    _A: (_2222) => _2222
  },
  [NodeInspectSymbol35]() {
    return this.toJSON();
  },
  toString() {
    return format35(this.toJSON());
  }
};
var SomeProto35 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto55), {
  _tag: "Some",
  _op: "Some",
  [symbol22225](that) {
    return isOption55(that) && isSome55(that) && equals35(this.value, that.value);
  },
  [symbol55]() {
    return cached35(this, combine45(hash35(this._tag))(hash35(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON35(this.value)
    };
  }
});
var NoneHash35 = /* @__PURE__ */ hash35("None");
var NoneProto35 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto55), {
  _tag: "None",
  _op: "None",
  [symbol22225](that) {
    return isOption55(that) && isNone55(that);
  },
  [symbol55]() {
    return NoneHash35;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption55 = (input) => hasProperty35(input, TypeId95);
var isNone55 = (fa) => fa._tag === "None";
var isSome55 = (fa) => fa._tag === "Some";
var none55 = /* @__PURE__ */ Object.create(NoneProto35);
var some85 = (value) => {
  const a2222 = Object.create(SomeProto35);
  a2222.value = value;
  return a2222;
};
var TypeId22225 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto22225 = {
  ...EffectPrototype35,
  [TypeId22225]: {
    _R: (_2222) => _2222
  },
  [NodeInspectSymbol35]() {
    return this.toJSON();
  },
  toString() {
    return format35(this.toJSON());
  }
};
var RightProto35 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto22225), {
  _tag: "Right",
  _op: "Right",
  [symbol22225](that) {
    return isEither35(that) && isRight45(that) && equals35(this.right, that.right);
  },
  [symbol55]() {
    return combine45(hash35(this._tag))(hash35(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON35(this.right)
    };
  }
});
var LeftProto35 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto22225), {
  _tag: "Left",
  _op: "Left",
  [symbol22225](that) {
    return isEither35(that) && isLeft45(that) && equals35(this.left, that.left);
  },
  [symbol55]() {
    return combine45(hash35(this._tag))(hash35(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON35(this.left)
    };
  }
});
var isEither35 = (input) => hasProperty35(input, TypeId22225);
var isLeft45 = (ma) => ma._tag === "Left";
var isRight45 = (ma) => ma._tag === "Right";
var left45 = (left32222) => {
  const a2222 = Object.create(LeftProto35);
  a2222.left = left32222;
  return a2222;
};
var right45 = (right32222) => {
  const a2222 = Object.create(RightProto35);
  a2222.right = right32222;
  return a2222;
};
var getLeft55 = (self2) => isRight45(self2) ? none55 : some85(self2.left);
var getRight55 = (self2) => isLeft45(self2) ? none55 : some85(self2.right);
var Option_exports35 = {};
__export3223(Option_exports35, {
  Do: () => Do45,
  TypeId: () => TypeId32225,
  all: () => all55,
  andThen: () => andThen35,
  ap: () => ap35,
  as: () => as35,
  asVoid: () => asVoid35,
  bind: () => bind22225,
  bindTo: () => bindTo22225,
  composeK: () => composeK35,
  contains: () => contains45,
  containsWith: () => containsWith45,
  exists: () => exists35,
  filter: () => filter45,
  filterMap: () => filterMap45,
  firstSomeOf: () => firstSomeOf35,
  flatMap: () => flatMap45,
  flatMapNullable: () => flatMapNullable45,
  flatten: () => flatten45,
  fromIterable: () => fromIterable55,
  fromNullable: () => fromNullable45,
  gen: () => gen35,
  getEquivalence: () => getEquivalence55,
  getLeft: () => getLeft22225,
  getOrElse: () => getOrElse35,
  getOrNull: () => getOrNull35,
  getOrThrow: () => getOrThrow35,
  getOrThrowWith: () => getOrThrowWith35,
  getOrUndefined: () => getOrUndefined35,
  getOrder: () => getOrder45,
  getRight: () => getRight22225,
  isNone: () => isNone22225,
  isOption: () => isOption22225,
  isSome: () => isSome22225,
  let: () => let_22225,
  lift2: () => lift235,
  liftNullable: () => liftNullable45,
  liftPredicate: () => liftPredicate45,
  liftThrowable: () => liftThrowable35,
  map: () => map45,
  match: () => match55,
  none: () => none22225,
  orElse: () => orElse35,
  orElseEither: () => orElseEither35,
  orElseSome: () => orElseSome35,
  partitionMap: () => partitionMap45,
  product: () => product55,
  productMany: () => productMany55,
  reduceCompact: () => reduceCompact35,
  some: () => some22225,
  tap: () => tap35,
  toArray: () => toArray35,
  toRefinement: () => toRefinement35,
  void: () => void_35,
  zipLeft: () => zipLeft35,
  zipRight: () => zipRight35,
  zipWith: () => zipWith45
});
var make22225 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId32225 = /* @__PURE__ */ Symbol.for("effect/Option");
var none22225 = () => none55;
var some22225 = some85;
var isOption22225 = isOption55;
var isNone22225 = isNone55;
var isSome22225 = isSome55;
var match55 = /* @__PURE__ */ dual35(2, (self2, {
  onNone,
  onSome
}) => isNone22225(self2) ? onNone() : onSome(self2.value));
var toRefinement35 = (f2222) => (a2222) => isSome22225(f2222(a2222));
var fromIterable55 = (collection) => {
  for (const a2222 of collection) {
    return some22225(a2222);
  }
  return none22225();
};
var getRight22225 = getRight55;
var getLeft22225 = getLeft55;
var getOrElse35 = /* @__PURE__ */ dual35(2, (self2, onNone) => isNone22225(self2) ? onNone() : self2.value);
var orElse35 = /* @__PURE__ */ dual35(2, (self2, that) => isNone22225(self2) ? that() : self2);
var orElseSome35 = /* @__PURE__ */ dual35(2, (self2, onNone) => isNone22225(self2) ? some22225(onNone()) : self2);
var orElseEither35 = /* @__PURE__ */ dual35(2, (self2, that) => isNone22225(self2) ? map45(that(), right45) : map45(self2, left45));
var firstSomeOf35 = (collection) => {
  let out = none22225();
  for (out of collection) {
    if (isSome22225(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable45 = (nullableValue) => nullableValue == null ? none22225() : some22225(nullableValue);
var liftNullable45 = (f2222) => (...a2222) => fromNullable45(f2222(...a2222));
var getOrNull35 = /* @__PURE__ */ getOrElse35(constNull35);
var getOrUndefined35 = /* @__PURE__ */ getOrElse35(constUndefined35);
var liftThrowable35 = (f2222) => (...a2222) => {
  try {
    return some22225(f2222(...a2222));
  } catch (e2222) {
    return none22225();
  }
};
var getOrThrowWith35 = /* @__PURE__ */ dual35(2, (self2, onNone) => {
  if (isSome22225(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow35 = /* @__PURE__ */ getOrThrowWith35(() => new Error("getOrThrow called on a None"));
var map45 = /* @__PURE__ */ dual35(2, (self2, f2222) => isNone22225(self2) ? none22225() : some22225(f2222(self2.value)));
var as35 = /* @__PURE__ */ dual35(2, (self2, b2222) => map45(self2, () => b2222));
var asVoid35 = /* @__PURE__ */ as35(void 0);
var void_35 = /* @__PURE__ */ some22225(void 0);
var flatMap45 = /* @__PURE__ */ dual35(2, (self2, f2222) => isNone22225(self2) ? none22225() : f2222(self2.value));
var andThen35 = /* @__PURE__ */ dual35(2, (self2, f2222) => flatMap45(self2, (a2222) => {
  const b2222 = isFunction65(f2222) ? f2222(a2222) : f2222;
  return isOption22225(b2222) ? b2222 : some22225(b2222);
}));
var flatMapNullable45 = /* @__PURE__ */ dual35(2, (self2, f2222) => isNone22225(self2) ? none22225() : fromNullable45(f2222(self2.value)));
var flatten45 = /* @__PURE__ */ flatMap45(identity35);
var zipRight35 = /* @__PURE__ */ dual35(2, (self2, that) => flatMap45(self2, () => that));
var composeK35 = /* @__PURE__ */ dual35(2, (afb, bfc) => (a2222) => flatMap45(afb(a2222), bfc));
var zipLeft35 = /* @__PURE__ */ dual35(2, (self2, that) => tap35(self2, () => that));
var tap35 = /* @__PURE__ */ dual35(2, (self2, f2222) => flatMap45(self2, (a2222) => map45(f2222(a2222), () => a2222)));
var product55 = (self2, that) => isSome22225(self2) && isSome22225(that) ? some22225([self2.value, that.value]) : none22225();
var productMany55 = (self2, collection) => {
  if (isNone22225(self2)) {
    return none22225();
  }
  const out = [self2.value];
  for (const o2222 of collection) {
    if (isNone22225(o2222)) {
      return none22225();
    }
    out.push(o2222.value);
  }
  return some22225(out);
};
var all55 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o2222 of input) {
      if (isNone22225(o2222)) {
        return none22225();
      }
      out2.push(o2222.value);
    }
    return some22225(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o2222 = input[key];
    if (isNone22225(o2222)) {
      return none22225();
    }
    out[key] = o2222.value;
  }
  return some22225(out);
};
var zipWith45 = /* @__PURE__ */ dual35(3, (self2, that, f2222) => map45(product55(self2, that), ([a2222, b2222]) => f2222(a2222, b2222)));
var ap35 = /* @__PURE__ */ dual35(2, (self2, that) => zipWith45(self2, that, (f2222, a2222) => f2222(a2222)));
var reduceCompact35 = /* @__PURE__ */ dual35(3, (self2, b2222, f2222) => {
  let out = b2222;
  for (const oa of self2) {
    if (isSome22225(oa)) {
      out = f2222(out, oa.value);
    }
  }
  return out;
});
var toArray35 = (self2) => isNone22225(self2) ? [] : [self2.value];
var partitionMap45 = /* @__PURE__ */ dual35(2, (self2, f2222) => {
  if (isNone22225(self2)) {
    return [none22225(), none22225()];
  }
  const e2222 = f2222(self2.value);
  return isLeft45(e2222) ? [some22225(e2222.left), none22225()] : [none22225(), some22225(e2222.right)];
});
var filterMap45 = /* @__PURE__ */ dual35(2, (self2, f2222) => isNone22225(self2) ? none22225() : f2222(self2.value));
var filter45 = /* @__PURE__ */ dual35(2, (self2, predicate) => filterMap45(self2, (b2222) => predicate(b2222) ? some85(b2222) : none55));
var getEquivalence55 = (isEquivalent) => make115((x2222, y2222) => x2222 === y2222 || (isNone22225(x2222) ? isNone22225(y2222) : isNone22225(y2222) ? false : isEquivalent(x2222.value, y2222.value)));
var getOrder45 = (O2222) => make22225((self2, that) => isSome22225(self2) ? isSome22225(that) ? O2222(self2.value, that.value) : 1 : -1);
var lift235 = (f2222) => dual35(2, (self2, that) => zipWith45(self2, that, f2222));
var liftPredicate45 = (predicate) => (b2222) => predicate(b2222) ? some22225(b2222) : none22225();
var containsWith45 = (isEquivalent) => dual35(2, (self2, a2222) => isNone22225(self2) ? false : isEquivalent(self2.value, a2222));
var _equivalence55 = /* @__PURE__ */ equivalence35();
var contains45 = /* @__PURE__ */ containsWith45(_equivalence55);
var exists35 = /* @__PURE__ */ dual35(2, (self2, refinement) => isNone22225(self2) ? false : refinement(self2.value));
var bindTo22225 = /* @__PURE__ */ bindTo65(map45);
var let_22225 = /* @__PURE__ */ let_65(map45);
var bind22225 = /* @__PURE__ */ bind65(map45, flatMap45);
var Do45 = /* @__PURE__ */ some22225({});
var adapter22225 = /* @__PURE__ */ adapter55();
var gen35 = (f2222) => {
  const iterator = f2222(adapter22225);
  let state = iterator.next();
  if (state.done) {
    return some22225(state.value);
  } else {
    let current = state.value;
    if (isGenKind35(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet35(current);
    }
    if (isNone22225(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind35(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet35(current);
        }
        if (isNone22225(current)) {
          return current;
        }
      }
    }
    return some22225(state.value);
  }
};
var MutableRef_exports25 = {};
__export3223(MutableRef_exports25, {
  compareAndSet: () => compareAndSet8,
  decrement: () => decrement8,
  decrementAndGet: () => decrementAndGet8,
  get: () => get25,
  getAndDecrement: () => getAndDecrement8,
  getAndIncrement: () => getAndIncrement8,
  getAndSet: () => getAndSet8,
  getAndUpdate: () => getAndUpdate8,
  increment: () => increment8,
  incrementAndGet: () => incrementAndGet8,
  make: () => make32225,
  set: () => set2225,
  setAndGet: () => setAndGet8,
  toggle: () => toggle8,
  update: () => update8,
  updateAndGet: () => updateAndGet8
});
var TypeId42225 = /* @__PURE__ */ Symbol.for("effect/MutableRef");
var MutableRefProto8 = {
  [TypeId42225]: TypeId42225,
  toString() {
    return format35(this.toJSON());
  },
  toJSON() {
    return {
      _id: "MutableRef",
      current: toJSON35(this.current)
    };
  },
  [NodeInspectSymbol35]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments35(this, arguments);
  }
};
var make32225 = (value) => {
  const ref = Object.create(MutableRefProto8);
  ref.current = value;
  return ref;
};
var compareAndSet8 = /* @__PURE__ */ dual35(3, (self2, oldValue, newValue) => {
  if (equals35(oldValue, self2.current)) {
    self2.current = newValue;
    return true;
  }
  return false;
});
var decrement8 = (self2) => update8(self2, (n2222) => n2222 - 1);
var decrementAndGet8 = (self2) => updateAndGet8(self2, (n2222) => n2222 - 1);
var get25 = (self2) => self2.current;
var getAndDecrement8 = (self2) => getAndUpdate8(self2, (n2222) => n2222 - 1);
var getAndIncrement8 = (self2) => getAndUpdate8(self2, (n2222) => n2222 + 1);
var getAndSet8 = /* @__PURE__ */ dual35(2, (self2, value) => {
  const ret = self2.current;
  self2.current = value;
  return ret;
});
var getAndUpdate8 = /* @__PURE__ */ dual35(2, (self2, f2222) => getAndSet8(self2, f2222(get25(self2))));
var increment8 = (self2) => update8(self2, (n2222) => n2222 + 1);
var incrementAndGet8 = (self2) => updateAndGet8(self2, (n2222) => n2222 + 1);
var set2225 = /* @__PURE__ */ dual35(2, (self2, value) => {
  self2.current = value;
  return self2;
});
var setAndGet8 = /* @__PURE__ */ dual35(2, (self2, value) => {
  self2.current = value;
  return self2.current;
});
var update8 = /* @__PURE__ */ dual35(2, (self2, f2222) => set2225(self2, f2222(get25(self2))));
var updateAndGet8 = /* @__PURE__ */ dual35(2, (self2, f2222) => setAndGet8(self2, f2222(get25(self2))));
var toggle8 = (self2) => update8(self2, (_2222) => !_2222);
function getVariables6(initialScope) {
  const scopeRef = MutableRef_exports25.make(initialScope);
  const variablesRef = MutableRef_exports25.make(MutableRef_exports25.get(scopeRef).variables);
  while (MutableRef_exports25.get(scopeRef).type !== scopeManager.ScopeType.global) {
    MutableRef_exports25.set(scopeRef, MutableRef_exports25.get(scopeRef).upper);
    MutableRef_exports25.update(variablesRef, (variables) => variables.concat(MutableRef_exports25.get(scopeRef).variables));
  }
  return MutableRef_exports25.get(variablesRef).reverse();
}
var findVariable2224 = Function_exports35.dual(2, (name22, initialScope) => {
  return Option_exports35.fromNullable(getVariables6(initialScope).find((variable) => variable.name === name22));
});
var t25 = Symbol.for("@ts-pattern/matcher");
var e25 = Symbol.for("@ts-pattern/isVariadic");
var n25 = "@ts-pattern/anonymous-select-key";
var r25 = (t2222) => Boolean(t2222 && "object" == typeof t2222);
var i25 = (e2222) => e2222 && !!e2222[t25];
var o25 = (n2222, s2222, c2222) => {
  if (i25(n2222)) {
    const e2222 = n2222[t25](), { matched: r2222, selections: i2222 } = e2222.match(s2222);
    return r2222 && i2222 && Object.keys(i2222).forEach((t2222) => c2222(t2222, i2222[t2222])), r2222;
  }
  if (r25(n2222)) {
    if (!r25(s2222)) return false;
    if (Array.isArray(n2222)) {
      if (!Array.isArray(s2222)) return false;
      let t2222 = [], r2222 = [], a2222 = [];
      for (const o2222 of n2222.keys()) {
        const s322 = n2222[o2222];
        i25(s322) && s322[e25] ? a2222.push(s322) : a2222.length ? r2222.push(s322) : t2222.push(s322);
      }
      if (a2222.length) {
        if (a2222.length > 1) throw new Error("Pattern error: Using `...P.array(...)` several times in a single pattern is not allowed.");
        if (s2222.length < t2222.length + r2222.length) return false;
        const e2222 = s2222.slice(0, t2222.length), n322 = 0 === r2222.length ? [] : s2222.slice(-r2222.length), i2222 = s2222.slice(t2222.length, 0 === r2222.length ? Infinity : -r2222.length);
        return t2222.every((t322, n43) => o25(t322, e2222[n43], c2222)) && r2222.every((t322, e322) => o25(t322, n322[e322], c2222)) && (0 === a2222.length || o25(a2222[0], i2222, c2222));
      }
      return n2222.length === s2222.length && n2222.every((t322, e2222) => o25(t322, s2222[e2222], c2222));
    }
    return Object.keys(n2222).every((e2222) => {
      const r2222 = n2222[e2222];
      return (e2222 in s2222 || i25(a2222 = r2222) && "optional" === a2222[t25]().matcherType) && o25(r2222, s2222[e2222], c2222);
      var a2222;
    });
  }
  return Object.is(s2222, n2222);
};
var s25 = (e2222) => {
  var n2222, o2222, a2222;
  return r25(e2222) ? i25(e2222) ? null != (n2222 = null == (o2222 = (a2222 = e2222[t25]()).getSelectionKeys) ? void 0 : o2222.call(a2222)) ? n2222 : [] : Array.isArray(e2222) ? c25(e2222, s25) : c25(Object.values(e2222), s25) : [];
};
var c25 = (t2222, e2222) => t2222.reduce((t322, n2222) => t322.concat(e2222(n2222)), []);
function a25(...t2222) {
  if (1 === t2222.length) {
    const [e2222] = t2222;
    return (t322) => o25(e2222, t322, () => {
    });
  }
  if (2 === t2222.length) {
    const [e2222, n2222] = t2222;
    return o25(e2222, n2222, () => {
    });
  }
  throw new Error(`isMatching wasn't given the right number of arguments: expected 1 or 2, received ${t2222.length}.`);
}
function u25(t2222) {
  return Object.assign(t2222, { optional: () => l25(t2222), and: (e2222) => m25(t2222, e2222), or: (e2222) => d25(t2222, e2222), select: (e2222) => void 0 === e2222 ? p25(t2222) : p25(e2222, t2222) });
}
function h25(t2222) {
  return Object.assign(((t322) => Object.assign(t322, { [Symbol.iterator]() {
    let n2222 = 0;
    const r2222 = [{ value: Object.assign(t322, { [e25]: true }), done: false }, { done: true, value: void 0 }];
    return { next: () => {
      var t43;
      return null != (t43 = r2222[n2222++]) ? t43 : r2222.at(-1);
    } };
  } }))(t2222), { optional: () => h25(l25(t2222)), select: (e2222) => h25(void 0 === e2222 ? p25(t2222) : p25(e2222, t2222)) });
}
function l25(e2222) {
  return u25({ [t25]: () => ({ match: (t2222) => {
    let n2222 = {};
    const r2222 = (t322, e322) => {
      n2222[t322] = e322;
    };
    return void 0 === t2222 ? (s25(e2222).forEach((t322) => r2222(t322, void 0)), { matched: true, selections: n2222 }) : { matched: o25(e2222, t2222, r2222), selections: n2222 };
  }, getSelectionKeys: () => s25(e2222), matcherType: "optional" }) });
}
var f25 = (t2222, e2222) => {
  for (const n2222 of t2222) if (!e2222(n2222)) return false;
  return true;
};
var g25 = (t2222, e2222) => {
  for (const [n2222, r2222] of t2222.entries()) if (!e2222(r2222, n2222)) return false;
  return true;
};
function m25(...e2222) {
  return u25({ [t25]: () => ({ match: (t2222) => {
    let n2222 = {};
    const r2222 = (t322, e322) => {
      n2222[t322] = e322;
    };
    return { matched: e2222.every((e322) => o25(e322, t2222, r2222)), selections: n2222 };
  }, getSelectionKeys: () => c25(e2222, s25), matcherType: "and" }) });
}
function d25(...e2222) {
  return u25({ [t25]: () => ({ match: (t2222) => {
    let n2222 = {};
    const r2222 = (t322, e322) => {
      n2222[t322] = e322;
    };
    return c25(e2222, s25).forEach((t322) => r2222(t322, void 0)), { matched: e2222.some((e322) => o25(e322, t2222, r2222)), selections: n2222 };
  }, getSelectionKeys: () => c25(e2222, s25), matcherType: "or" }) });
}
function y25(e2222) {
  return { [t25]: () => ({ match: (t2222) => ({ matched: Boolean(e2222(t2222)) }) }) };
}
function p25(...e2222) {
  const r2222 = "string" == typeof e2222[0] ? e2222[0] : void 0, i2222 = 2 === e2222.length ? e2222[1] : "string" == typeof e2222[0] ? void 0 : e2222[0];
  return u25({ [t25]: () => ({ match: (t2222) => {
    let e322 = { [null != r2222 ? r2222 : n25]: t2222 };
    return { matched: void 0 === i2222 || o25(i2222, t2222, (t322, n2222) => {
      e322[t322] = n2222;
    }), selections: e322 };
  }, getSelectionKeys: () => [null != r2222 ? r2222 : n25].concat(void 0 === i2222 ? [] : s25(i2222)) }) });
}
function v25(t2222) {
  return "number" == typeof t2222;
}
function b25(t2222) {
  return "string" == typeof t2222;
}
function w25(t2222) {
  return "bigint" == typeof t2222;
}
var S25 = u25(y25(function(t2222) {
  return true;
}));
var O25 = S25;
var j25 = (t2222) => Object.assign(u25(t2222), { startsWith: (e2222) => {
  return j25(m25(t2222, (n2222 = e2222, y25((t322) => b25(t322) && t322.startsWith(n2222)))));
  var n2222;
}, endsWith: (e2222) => {
  return j25(m25(t2222, (n2222 = e2222, y25((t322) => b25(t322) && t322.endsWith(n2222)))));
  var n2222;
}, minLength: (e2222) => j25(m25(t2222, ((t322) => y25((e322) => b25(e322) && e322.length >= t322))(e2222))), maxLength: (e2222) => j25(m25(t2222, ((t322) => y25((e322) => b25(e322) && e322.length <= t322))(e2222))), includes: (e2222) => {
  return j25(m25(t2222, (n2222 = e2222, y25((t322) => b25(t322) && t322.includes(n2222)))));
  var n2222;
}, regex: (e2222) => {
  return j25(m25(t2222, (n2222 = e2222, y25((t322) => b25(t322) && Boolean(t322.match(n2222))))));
  var n2222;
} });
var E25 = j25(y25(b25));
var K25 = (t2222) => Object.assign(u25(t2222), { between: (e2222, n2222) => K25(m25(t2222, ((t322, e322) => y25((n322) => v25(n322) && t322 <= n322 && e322 >= n322))(e2222, n2222))), lt: (e2222) => K25(m25(t2222, ((t322) => y25((e322) => v25(e322) && e322 < t322))(e2222))), gt: (e2222) => K25(m25(t2222, ((t322) => y25((e322) => v25(e322) && e322 > t322))(e2222))), lte: (e2222) => K25(m25(t2222, ((t322) => y25((e322) => v25(e322) && e322 <= t322))(e2222))), gte: (e2222) => K25(m25(t2222, ((t322) => y25((e322) => v25(e322) && e322 >= t322))(e2222))), int: () => K25(m25(t2222, y25((t322) => v25(t322) && Number.isInteger(t322)))), finite: () => K25(m25(t2222, y25((t322) => v25(t322) && Number.isFinite(t322)))), positive: () => K25(m25(t2222, y25((t322) => v25(t322) && t322 > 0))), negative: () => K25(m25(t2222, y25((t322) => v25(t322) && t322 < 0))) });
var x25 = K25(y25(v25));
var A25 = (t2222) => Object.assign(u25(t2222), { between: (e2222, n2222) => A25(m25(t2222, ((t322, e322) => y25((n322) => w25(n322) && t322 <= n322 && e322 >= n322))(e2222, n2222))), lt: (e2222) => A25(m25(t2222, ((t322) => y25((e322) => w25(e322) && e322 < t322))(e2222))), gt: (e2222) => A25(m25(t2222, ((t322) => y25((e322) => w25(e322) && e322 > t322))(e2222))), lte: (e2222) => A25(m25(t2222, ((t322) => y25((e322) => w25(e322) && e322 <= t322))(e2222))), gte: (e2222) => A25(m25(t2222, ((t322) => y25((e322) => w25(e322) && e322 >= t322))(e2222))), positive: () => A25(m25(t2222, y25((t322) => w25(t322) && t322 > 0))), negative: () => A25(m25(t2222, y25((t322) => w25(t322) && t322 < 0))) });
var P224 = A25(y25(w25));
var T25 = u25(y25(function(t2222) {
  return "boolean" == typeof t2222;
}));
var k25 = u25(y25(function(t2222) {
  return "symbol" == typeof t2222;
}));
var B25 = u25(y25(function(t2222) {
  return null == t2222;
}));
var _25 = u25(y25(function(t2222) {
  return null != t2222;
}));
var N25 = { __proto__: null, matcher: t25, optional: l25, array: function(...e2222) {
  return h25({ [t25]: () => ({ match: (t2222) => {
    if (!Array.isArray(t2222)) return { matched: false };
    if (0 === e2222.length) return { matched: true };
    const n2222 = e2222[0];
    let r2222 = {};
    if (0 === t2222.length) return s25(n2222).forEach((t322) => {
      r2222[t322] = [];
    }), { matched: true, selections: r2222 };
    const i2222 = (t322, e322) => {
      r2222[t322] = (r2222[t322] || []).concat([e322]);
    };
    return { matched: t2222.every((t322) => o25(n2222, t322, i2222)), selections: r2222 };
  }, getSelectionKeys: () => 0 === e2222.length ? [] : s25(e2222[0]) }) });
}, set: function(...e2222) {
  return u25({ [t25]: () => ({ match: (t2222) => {
    if (!(t2222 instanceof Set)) return { matched: false };
    let n2222 = {};
    if (0 === t2222.size) return { matched: true, selections: n2222 };
    if (0 === e2222.length) return { matched: true };
    const r2222 = (t322, e322) => {
      n2222[t322] = (n2222[t322] || []).concat([e322]);
    }, i2222 = e2222[0];
    return { matched: f25(t2222, (t322) => o25(i2222, t322, r2222)), selections: n2222 };
  }, getSelectionKeys: () => 0 === e2222.length ? [] : s25(e2222[0]) }) });
}, map: function(...e2222) {
  return u25({ [t25]: () => ({ match: (t2222) => {
    if (!(t2222 instanceof Map)) return { matched: false };
    let n2222 = {};
    if (0 === t2222.size) return { matched: true, selections: n2222 };
    const r2222 = (t322, e322) => {
      n2222[t322] = (n2222[t322] || []).concat([e322]);
    };
    if (0 === e2222.length) return { matched: true };
    var i2222;
    if (1 === e2222.length) throw new Error(`\`P.map\` wasn't given enough arguments. Expected (key, value), received ${null == (i2222 = e2222[0]) ? void 0 : i2222.toString()}`);
    const [s2222, c2222] = e2222;
    return { matched: g25(t2222, (t322, e322) => {
      const n322 = o25(s2222, e322, r2222), i322 = o25(c2222, t322, r2222);
      return n322 && i322;
    }), selections: n2222 };
  }, getSelectionKeys: () => 0 === e2222.length ? [] : [...s25(e2222[0]), ...s25(e2222[1])] }) });
}, intersection: m25, union: d25, not: function(e2222) {
  return u25({ [t25]: () => ({ match: (t2222) => ({ matched: !o25(e2222, t2222, () => {
  }) }), getSelectionKeys: () => [], matcherType: "not" }) });
}, when: y25, select: p25, any: S25, _: O25, string: E25, number: x25, bigint: P224, boolean: T25, symbol: k25, nullish: B25, nonNullable: _25, instanceOf: function(t2222) {
  return u25(y25(/* @__PURE__ */ function(t322) {
    return (e2222) => e2222 instanceof t322;
  }(t2222)));
}, shape: function(t2222) {
  return u25(y25(a25(t2222)));
} };
var KEYS2223 = {
  ArrayExpression: [
    "elements"
  ],
  ArrayPattern: [
    "elements"
  ],
  ArrowFunctionExpression: [
    "params",
    "body"
  ],
  AssignmentExpression: [
    "left",
    "right"
  ],
  AssignmentPattern: [
    "left",
    "right"
  ],
  AwaitExpression: [
    "argument"
  ],
  BinaryExpression: [
    "left",
    "right"
  ],
  BlockStatement: [
    "body"
  ],
  BreakStatement: [
    "label"
  ],
  CallExpression: [
    "callee",
    "arguments"
  ],
  CatchClause: [
    "param",
    "body"
  ],
  ChainExpression: [
    "expression"
  ],
  ClassBody: [
    "body"
  ],
  ClassDeclaration: [
    "id",
    "superClass",
    "body"
  ],
  ClassExpression: [
    "id",
    "superClass",
    "body"
  ],
  ConditionalExpression: [
    "test",
    "consequent",
    "alternate"
  ],
  ContinueStatement: [
    "label"
  ],
  DebuggerStatement: [],
  DoWhileStatement: [
    "body",
    "test"
  ],
  EmptyStatement: [],
  ExperimentalRestProperty: [
    "argument"
  ],
  ExperimentalSpreadProperty: [
    "argument"
  ],
  ExportAllDeclaration: [
    "exported",
    "source"
  ],
  ExportDefaultDeclaration: [
    "declaration"
  ],
  ExportNamedDeclaration: [
    "declaration",
    "specifiers",
    "source"
  ],
  ExportSpecifier: [
    "exported",
    "local"
  ],
  ExpressionStatement: [
    "expression"
  ],
  ForInStatement: [
    "left",
    "right",
    "body"
  ],
  ForOfStatement: [
    "left",
    "right",
    "body"
  ],
  ForStatement: [
    "init",
    "test",
    "update",
    "body"
  ],
  FunctionDeclaration: [
    "id",
    "params",
    "body"
  ],
  FunctionExpression: [
    "id",
    "params",
    "body"
  ],
  Identifier: [],
  IfStatement: [
    "test",
    "consequent",
    "alternate"
  ],
  ImportDeclaration: [
    "specifiers",
    "source"
  ],
  ImportDefaultSpecifier: [
    "local"
  ],
  ImportExpression: [
    "source"
  ],
  ImportNamespaceSpecifier: [
    "local"
  ],
  ImportSpecifier: [
    "imported",
    "local"
  ],
  JSXAttribute: [
    "name",
    "value"
  ],
  JSXClosingElement: [
    "name"
  ],
  JSXClosingFragment: [],
  JSXElement: [
    "openingElement",
    "children",
    "closingElement"
  ],
  JSXEmptyExpression: [],
  JSXExpressionContainer: [
    "expression"
  ],
  JSXFragment: [
    "openingFragment",
    "children",
    "closingFragment"
  ],
  JSXIdentifier: [],
  JSXMemberExpression: [
    "object",
    "property"
  ],
  JSXNamespacedName: [
    "namespace",
    "name"
  ],
  JSXOpeningElement: [
    "name",
    "attributes"
  ],
  JSXOpeningFragment: [],
  JSXSpreadAttribute: [
    "argument"
  ],
  JSXSpreadChild: [
    "expression"
  ],
  JSXText: [],
  LabeledStatement: [
    "label",
    "body"
  ],
  Literal: [],
  LogicalExpression: [
    "left",
    "right"
  ],
  MemberExpression: [
    "object",
    "property"
  ],
  MetaProperty: [
    "meta",
    "property"
  ],
  MethodDefinition: [
    "key",
    "value"
  ],
  NewExpression: [
    "callee",
    "arguments"
  ],
  ObjectExpression: [
    "properties"
  ],
  ObjectPattern: [
    "properties"
  ],
  PrivateIdentifier: [],
  Program: [
    "body"
  ],
  Property: [
    "key",
    "value"
  ],
  PropertyDefinition: [
    "key",
    "value"
  ],
  RestElement: [
    "argument"
  ],
  ReturnStatement: [
    "argument"
  ],
  SequenceExpression: [
    "expressions"
  ],
  SpreadElement: [
    "argument"
  ],
  StaticBlock: [
    "body"
  ],
  Super: [],
  SwitchCase: [
    "test",
    "consequent"
  ],
  SwitchStatement: [
    "discriminant",
    "cases"
  ],
  TaggedTemplateExpression: [
    "tag",
    "quasi"
  ],
  TemplateElement: [],
  TemplateLiteral: [
    "quasis",
    "expressions"
  ],
  ThisExpression: [],
  ThrowStatement: [
    "argument"
  ],
  TryStatement: [
    "block",
    "handler",
    "finalizer"
  ],
  UnaryExpression: [
    "argument"
  ],
  UpdateExpression: [
    "argument"
  ],
  VariableDeclaration: [
    "declarations"
  ],
  VariableDeclarator: [
    "id",
    "init"
  ],
  WhileStatement: [
    "test",
    "body"
  ],
  WithStatement: [
    "object",
    "body"
  ],
  YieldExpression: [
    "argument"
  ]
};
var NODE_TYPES2223 = Object.keys(KEYS2223);
for (const type of NODE_TYPES2223) {
  Object.freeze(KEYS2223[type]);
}
Object.freeze(KEYS2223);
var visitor_keys_default2223 = KEYS2223;
var KEY_BLACKLIST2223 = /* @__PURE__ */ new Set([
  "parent",
  "leadingComments",
  "trailingComments"
]);
function filterKey2223(key) {
  return !KEY_BLACKLIST2223.has(key) && key[0] !== "_";
}
function getKeys2223(node) {
  return Object.keys(node).filter(filterKey2223);
}
function getInnermostScope2223(initialScope, node) {
  const location = node.range[0];
  let scope = initialScope;
  let found = false;
  do {
    found = false;
    for (const childScope of scope.childScopes) {
      const range222 = childScope.block.range;
      if (range222[0] <= location && location < range222[1]) {
        scope = childScope;
        found = true;
        break;
      }
    }
  } while (found);
  return scope;
}
function findVariable22223(initialScope, nameOrNode) {
  let name22 = "";
  let scope = initialScope;
  if (typeof nameOrNode === "string") {
    name22 = nameOrNode;
  } else {
    name22 = nameOrNode.name;
    scope = getInnermostScope2223(scope, nameOrNode);
  }
  while (scope != null) {
    const variable = scope.set.get(name22);
    if (variable != null) {
      return variable;
    }
    scope = scope.upper;
  }
  return null;
}
function negate02223(token) {
  return !this(token);
}
function negate2223(f2222) {
  return negate02223.bind(f2222);
}
function isPunctuatorTokenWithValue2223(token, value) {
  return token.type === "Punctuator" && token.value === value;
}
function isArrowToken2223(token) {
  return isPunctuatorTokenWithValue2223(token, "=>");
}
function isCommaToken2223(token) {
  return isPunctuatorTokenWithValue2223(token, ",");
}
function isSemicolonToken2223(token) {
  return isPunctuatorTokenWithValue2223(token, ";");
}
function isColonToken2223(token) {
  return isPunctuatorTokenWithValue2223(token, ":");
}
function isOpeningParenToken2223(token) {
  return isPunctuatorTokenWithValue2223(token, "(");
}
function isClosingParenToken2223(token) {
  return isPunctuatorTokenWithValue2223(token, ")");
}
function isOpeningBracketToken2223(token) {
  return isPunctuatorTokenWithValue2223(token, "[");
}
function isClosingBracketToken2223(token) {
  return isPunctuatorTokenWithValue2223(token, "]");
}
function isOpeningBraceToken2223(token) {
  return isPunctuatorTokenWithValue2223(token, "{");
}
function isClosingBraceToken2223(token) {
  return isPunctuatorTokenWithValue2223(token, "}");
}
function isCommentToken2223(token) {
  return ["Block", "Line", "Shebang"].includes(token.type);
}
negate2223(isArrowToken2223);
negate2223(isCommaToken2223);
negate2223(isSemicolonToken2223);
negate2223(isColonToken2223);
negate2223(isOpeningParenToken2223);
negate2223(isClosingParenToken2223);
negate2223(isOpeningBracketToken2223);
negate2223(isClosingBracketToken2223);
negate2223(isOpeningBraceToken2223);
negate2223(isClosingBraceToken2223);
negate2223(isCommentToken2223);
function getOpeningParenOfParams2223(node, sourceCode) {
  return node.id ? sourceCode.getTokenAfter(node.id, isOpeningParenToken2223) : sourceCode.getFirstToken(node, isOpeningParenToken2223);
}
function getFunctionHeadLocation2223(node, sourceCode) {
  const parent = node.parent;
  let start = null;
  let end = null;
  if (node.type === "ArrowFunctionExpression") {
    const arrowToken = sourceCode.getTokenBefore(node.body, isArrowToken2223);
    start = arrowToken.loc.start;
    end = arrowToken.loc.end;
  } else if (parent.type === "Property" || parent.type === "MethodDefinition" || parent.type === "PropertyDefinition") {
    start = parent.loc.start;
    end = getOpeningParenOfParams2223(node, sourceCode).loc.start;
  } else {
    start = node.loc.start;
    end = getOpeningParenOfParams2223(node, sourceCode).loc.start;
  }
  return {
    start: { ...start },
    end: { ...end }
  };
}
var globalObject2223 = typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {};
var builtinNames2223 = Object.freeze(
  /* @__PURE__ */ new Set([
    "Array",
    "ArrayBuffer",
    "BigInt",
    "BigInt64Array",
    "BigUint64Array",
    "Boolean",
    "DataView",
    "Date",
    "decodeURI",
    "decodeURIComponent",
    "encodeURI",
    "encodeURIComponent",
    "escape",
    "Float32Array",
    "Float64Array",
    "Function",
    "Infinity",
    "Int16Array",
    "Int32Array",
    "Int8Array",
    "isFinite",
    "isNaN",
    "isPrototypeOf",
    "JSON",
    "Map",
    "Math",
    "NaN",
    "Number",
    "Object",
    "parseFloat",
    "parseInt",
    "Promise",
    "Proxy",
    "Reflect",
    "RegExp",
    "Set",
    "String",
    "Symbol",
    "Uint16Array",
    "Uint32Array",
    "Uint8Array",
    "Uint8ClampedArray",
    "undefined",
    "unescape",
    "WeakMap",
    "WeakSet"
  ])
);
var callAllowed2223 = new Set(
  [
    Array.isArray,
    Array.of,
    Array.prototype.at,
    Array.prototype.concat,
    Array.prototype.entries,
    Array.prototype.every,
    Array.prototype.filter,
    Array.prototype.find,
    Array.prototype.findIndex,
    Array.prototype.flat,
    Array.prototype.includes,
    Array.prototype.indexOf,
    Array.prototype.join,
    Array.prototype.keys,
    Array.prototype.lastIndexOf,
    Array.prototype.slice,
    Array.prototype.some,
    Array.prototype.toString,
    Array.prototype.values,
    typeof BigInt === "function" ? BigInt : void 0,
    Boolean,
    Date,
    Date.parse,
    decodeURI,
    decodeURIComponent,
    encodeURI,
    encodeURIComponent,
    escape,
    isFinite,
    isNaN,
    isPrototypeOf,
    Map,
    Map.prototype.entries,
    Map.prototype.get,
    Map.prototype.has,
    Map.prototype.keys,
    Map.prototype.values,
    ...Object.getOwnPropertyNames(Math).filter((k2222) => k2222 !== "random").map((k2222) => Math[k2222]).filter((f2222) => typeof f2222 === "function"),
    Number,
    Number.isFinite,
    Number.isNaN,
    Number.parseFloat,
    Number.parseInt,
    Number.prototype.toExponential,
    Number.prototype.toFixed,
    Number.prototype.toPrecision,
    Number.prototype.toString,
    Object,
    Object.entries,
    Object.is,
    Object.isExtensible,
    Object.isFrozen,
    Object.isSealed,
    Object.keys,
    Object.values,
    parseFloat,
    parseInt,
    RegExp,
    Set,
    Set.prototype.entries,
    Set.prototype.has,
    Set.prototype.keys,
    Set.prototype.values,
    String,
    String.fromCharCode,
    String.fromCodePoint,
    String.raw,
    String.prototype.at,
    String.prototype.charAt,
    String.prototype.charCodeAt,
    String.prototype.codePointAt,
    String.prototype.concat,
    String.prototype.endsWith,
    String.prototype.includes,
    String.prototype.indexOf,
    String.prototype.lastIndexOf,
    String.prototype.normalize,
    String.prototype.padEnd,
    String.prototype.padStart,
    String.prototype.slice,
    String.prototype.startsWith,
    String.prototype.substr,
    String.prototype.substring,
    String.prototype.toLowerCase,
    String.prototype.toString,
    String.prototype.toUpperCase,
    String.prototype.trim,
    String.prototype.trimEnd,
    String.prototype.trimLeft,
    String.prototype.trimRight,
    String.prototype.trimStart,
    Symbol.for,
    Symbol.keyFor,
    unescape
  ].filter((f2222) => typeof f2222 === "function")
);
var callPassThrough2223 = /* @__PURE__ */ new Set([
  Object.freeze,
  Object.preventExtensions,
  Object.seal
]);
var getterAllowed2223 = [
  [Map, /* @__PURE__ */ new Set(["size"])],
  [
    RegExp,
    /* @__PURE__ */ new Set([
      "dotAll",
      "flags",
      "global",
      "hasIndices",
      "ignoreCase",
      "multiline",
      "source",
      "sticky",
      "unicode"
    ])
  ],
  [Set, /* @__PURE__ */ new Set(["size"])]
];
function getPropertyDescriptor2223(object222, name22) {
  let x2222 = object222;
  while ((typeof x2222 === "object" || typeof x2222 === "function") && x2222 !== null) {
    const d2222 = Object.getOwnPropertyDescriptor(x2222, name22);
    if (d2222) {
      return d2222;
    }
    x2222 = Object.getPrototypeOf(x2222);
  }
  return null;
}
function isGetter2223(object222, name22) {
  const d2222 = getPropertyDescriptor2223(object222, name22);
  return d2222 != null && d2222.get != null;
}
function getElementValues2223(nodeList, initialScope) {
  const valueList = [];
  for (let i2222 = 0; i2222 < nodeList.length; ++i2222) {
    const elementNode = nodeList[i2222];
    if (elementNode == null) {
      valueList.length = i2222 + 1;
    } else if (elementNode.type === "SpreadElement") {
      const argument = getStaticValueR2223(elementNode.argument, initialScope);
      if (argument == null) {
        return null;
      }
      valueList.push(...argument.value);
    } else {
      const element = getStaticValueR2223(elementNode, initialScope);
      if (element == null) {
        return null;
      }
      valueList.push(element.value);
    }
  }
  return valueList;
}
function isEffectivelyConst2223(variable) {
  const refs = variable.references;
  const inits = refs.filter((r2222) => r2222.init).length;
  const reads = refs.filter((r2222) => r2222.isReadOnly()).length;
  if (inits === 1 && reads + inits === refs.length) {
    return true;
  }
  return false;
}
var operations2223 = Object.freeze({
  ArrayExpression(node, initialScope) {
    const elements = getElementValues2223(node.elements, initialScope);
    return elements != null ? { value: elements } : null;
  },
  AssignmentExpression(node, initialScope) {
    if (node.operator === "=") {
      return getStaticValueR2223(node.right, initialScope);
    }
    return null;
  },
  //eslint-disable-next-line complexity
  BinaryExpression(node, initialScope) {
    if (node.operator === "in" || node.operator === "instanceof") {
      return null;
    }
    const left32222 = getStaticValueR2223(node.left, initialScope);
    const right32222 = getStaticValueR2223(node.right, initialScope);
    if (left32222 != null && right32222 != null) {
      switch (node.operator) {
        case "==":
          return { value: left32222.value == right32222.value };
        case "!=":
          return { value: left32222.value != right32222.value };
        case "===":
          return { value: left32222.value === right32222.value };
        case "!==":
          return { value: left32222.value !== right32222.value };
        case "<":
          return { value: left32222.value < right32222.value };
        case "<=":
          return { value: left32222.value <= right32222.value };
        case ">":
          return { value: left32222.value > right32222.value };
        case ">=":
          return { value: left32222.value >= right32222.value };
        case "<<":
          return { value: left32222.value << right32222.value };
        case ">>":
          return { value: left32222.value >> right32222.value };
        case ">>>":
          return { value: left32222.value >>> right32222.value };
        case "+":
          return { value: left32222.value + right32222.value };
        case "-":
          return { value: left32222.value - right32222.value };
        case "*":
          return { value: left32222.value * right32222.value };
        case "/":
          return { value: left32222.value / right32222.value };
        case "%":
          return { value: left32222.value % right32222.value };
        case "**":
          return { value: left32222.value ** right32222.value };
        case "|":
          return { value: left32222.value | right32222.value };
        case "^":
          return { value: left32222.value ^ right32222.value };
        case "&":
          return { value: left32222.value & right32222.value };
      }
    }
    return null;
  },
  CallExpression(node, initialScope) {
    const calleeNode = node.callee;
    const args = getElementValues2223(node.arguments, initialScope);
    if (args != null) {
      if (calleeNode.type === "MemberExpression") {
        if (calleeNode.property.type === "PrivateIdentifier") {
          return null;
        }
        const object222 = getStaticValueR2223(calleeNode.object, initialScope);
        if (object222 != null) {
          if (object222.value == null && (object222.optional || node.optional)) {
            return { value: void 0, optional: true };
          }
          const property = getStaticPropertyNameValue2223(
            calleeNode,
            initialScope
          );
          if (property != null) {
            const receiver = object222.value;
            const methodName = property.value;
            if (callAllowed2223.has(receiver[methodName])) {
              return { value: receiver[methodName](...args) };
            }
            if (callPassThrough2223.has(receiver[methodName])) {
              return { value: args[0] };
            }
          }
        }
      } else {
        const callee = getStaticValueR2223(calleeNode, initialScope);
        if (callee != null) {
          if (callee.value == null && node.optional) {
            return { value: void 0, optional: true };
          }
          const func = callee.value;
          if (callAllowed2223.has(func)) {
            return { value: func(...args) };
          }
          if (callPassThrough2223.has(func)) {
            return { value: args[0] };
          }
        }
      }
    }
    return null;
  },
  ConditionalExpression(node, initialScope) {
    const test = getStaticValueR2223(node.test, initialScope);
    if (test != null) {
      return test.value ? getStaticValueR2223(node.consequent, initialScope) : getStaticValueR2223(node.alternate, initialScope);
    }
    return null;
  },
  ExpressionStatement(node, initialScope) {
    return getStaticValueR2223(node.expression, initialScope);
  },
  Identifier(node, initialScope) {
    if (initialScope != null) {
      const variable = findVariable22223(initialScope, node);
      if (variable != null && variable.defs.length === 0 && builtinNames2223.has(variable.name) && variable.name in globalObject2223) {
        return { value: globalObject2223[variable.name] };
      }
      if (variable != null && variable.defs.length === 1) {
        const def = variable.defs[0];
        if (def.parent && def.type === "Variable" && (def.parent.kind === "const" || isEffectivelyConst2223(variable)) && // TODO(mysticatea): don't support destructuring here.
        def.node.id.type === "Identifier") {
          return getStaticValueR2223(def.node.init, initialScope);
        }
      }
    }
    return null;
  },
  Literal(node) {
    if ((node.regex != null || node.bigint != null) && node.value == null) {
      return null;
    }
    return { value: node.value };
  },
  LogicalExpression(node, initialScope) {
    const left32222 = getStaticValueR2223(node.left, initialScope);
    if (left32222 != null) {
      if (node.operator === "||" && Boolean(left32222.value) === true || node.operator === "&&" && Boolean(left32222.value) === false || node.operator === "??" && left32222.value != null) {
        return left32222;
      }
      const right32222 = getStaticValueR2223(node.right, initialScope);
      if (right32222 != null) {
        return right32222;
      }
    }
    return null;
  },
  MemberExpression(node, initialScope) {
    if (node.property.type === "PrivateIdentifier") {
      return null;
    }
    const object222 = getStaticValueR2223(node.object, initialScope);
    if (object222 != null) {
      if (object222.value == null && (object222.optional || node.optional)) {
        return { value: void 0, optional: true };
      }
      const property = getStaticPropertyNameValue2223(node, initialScope);
      if (property != null) {
        if (!isGetter2223(object222.value, property.value)) {
          return { value: object222.value[property.value] };
        }
        for (const [classFn, allowed] of getterAllowed2223) {
          if (object222.value instanceof classFn && allowed.has(property.value)) {
            return { value: object222.value[property.value] };
          }
        }
      }
    }
    return null;
  },
  ChainExpression(node, initialScope) {
    const expression = getStaticValueR2223(node.expression, initialScope);
    if (expression != null) {
      return { value: expression.value };
    }
    return null;
  },
  NewExpression(node, initialScope) {
    const callee = getStaticValueR2223(node.callee, initialScope);
    const args = getElementValues2223(node.arguments, initialScope);
    if (callee != null && args != null) {
      const Func = callee.value;
      if (callAllowed2223.has(Func)) {
        return { value: new Func(...args) };
      }
    }
    return null;
  },
  ObjectExpression(node, initialScope) {
    const object222 = {};
    for (const propertyNode of node.properties) {
      if (propertyNode.type === "Property") {
        if (propertyNode.kind !== "init") {
          return null;
        }
        const key = getStaticPropertyNameValue2223(
          propertyNode,
          initialScope
        );
        const value = getStaticValueR2223(propertyNode.value, initialScope);
        if (key == null || value == null) {
          return null;
        }
        object222[key.value] = value.value;
      } else if (propertyNode.type === "SpreadElement" || propertyNode.type === "ExperimentalSpreadProperty") {
        const argument = getStaticValueR2223(
          propertyNode.argument,
          initialScope
        );
        if (argument == null) {
          return null;
        }
        Object.assign(object222, argument.value);
      } else {
        return null;
      }
    }
    return { value: object222 };
  },
  SequenceExpression(node, initialScope) {
    const last222 = node.expressions[node.expressions.length - 1];
    return getStaticValueR2223(last222, initialScope);
  },
  TaggedTemplateExpression(node, initialScope) {
    const tag = getStaticValueR2223(node.tag, initialScope);
    const expressions = getElementValues2223(
      node.quasi.expressions,
      initialScope
    );
    if (tag != null && expressions != null) {
      const func = tag.value;
      const strings = node.quasi.quasis.map((q) => q.value.cooked);
      strings.raw = node.quasi.quasis.map((q) => q.value.raw);
      if (func === String.raw) {
        return { value: func(strings, ...expressions) };
      }
    }
    return null;
  },
  TemplateLiteral(node, initialScope) {
    const expressions = getElementValues2223(node.expressions, initialScope);
    if (expressions != null) {
      let value = node.quasis[0].value.cooked;
      for (let i2222 = 0; i2222 < expressions.length; ++i2222) {
        value += expressions[i2222];
        value += node.quasis[i2222 + 1].value.cooked;
      }
      return { value };
    }
    return null;
  },
  UnaryExpression(node, initialScope) {
    if (node.operator === "delete") {
      return null;
    }
    if (node.operator === "void") {
      return { value: void 0 };
    }
    const arg = getStaticValueR2223(node.argument, initialScope);
    if (arg != null) {
      switch (node.operator) {
        case "-":
          return { value: -arg.value };
        case "+":
          return { value: +arg.value };
        case "!":
          return { value: !arg.value };
        case "~":
          return { value: ~arg.value };
        case "typeof":
          return { value: typeof arg.value };
      }
    }
    return null;
  }
});
function getStaticValueR2223(node, initialScope) {
  if (node != null && Object.hasOwnProperty.call(operations2223, node.type)) {
    return operations2223[node.type](node, initialScope);
  }
  return null;
}
function getStaticPropertyNameValue2223(node, initialScope) {
  const nameNode = node.type === "Property" ? node.key : node.property;
  if (node.computed) {
    return getStaticValueR2223(nameNode, initialScope);
  }
  if (nameNode.type === "Identifier") {
    return { value: nameNode.name };
  }
  if (nameNode.type === "Literal") {
    if (nameNode.bigint) {
      return { value: nameNode.bigint };
    }
    return { value: String(nameNode.value) };
  }
  return null;
}
function getStaticValue2223(node, initialScope = null) {
  try {
    return getStaticValueR2223(node, initialScope);
  } catch (_error) {
    return null;
  }
}
function getStringIfConstant2223(node, initialScope = null) {
  if (node && node.type === "Literal" && node.value === null) {
    if (node.regex) {
      return `/${node.regex.pattern}/${node.regex.flags}`;
    }
    if (node.bigint) {
      return node.bigint;
    }
  }
  const evaluated = getStaticValue2223(node, initialScope);
  return evaluated && String(evaluated.value);
}
function getPropertyName2223(node, initialScope) {
  switch (node.type) {
    case "MemberExpression":
      if (node.computed) {
        return getStringIfConstant2223(node.property, initialScope);
      }
      if (node.property.type === "PrivateIdentifier") {
        return null;
      }
      return node.property.name;
    case "Property":
    case "MethodDefinition":
    case "PropertyDefinition":
      if (node.computed) {
        return getStringIfConstant2223(node.key, initialScope);
      }
      if (node.key.type === "Literal") {
        return String(node.key.value);
      }
      if (node.key.type === "PrivateIdentifier") {
        return null;
      }
      return node.key.name;
  }
  return null;
}
function getFunctionNameWithKind2223(node, sourceCode) {
  const parent = node.parent;
  const tokens = [];
  const isObjectMethod = parent.type === "Property" && parent.value === node;
  const isClassMethod = parent.type === "MethodDefinition" && parent.value === node;
  const isClassFieldMethod = parent.type === "PropertyDefinition" && parent.value === node;
  if (isClassMethod || isClassFieldMethod) {
    if (parent.static) {
      tokens.push("static");
    }
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push("private");
    }
  }
  if (node.async) {
    tokens.push("async");
  }
  if (node.generator) {
    tokens.push("generator");
  }
  if (isObjectMethod || isClassMethod) {
    if (parent.kind === "constructor") {
      return "constructor";
    }
    if (parent.kind === "get") {
      tokens.push("getter");
    } else if (parent.kind === "set") {
      tokens.push("setter");
    } else {
      tokens.push("method");
    }
  } else if (isClassFieldMethod) {
    tokens.push("method");
  } else {
    if (node.type === "ArrowFunctionExpression") {
      tokens.push("arrow");
    }
    tokens.push("function");
  }
  if (isObjectMethod || isClassMethod || isClassFieldMethod) {
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push(`#${parent.key.name}`);
    } else {
      const name22 = getPropertyName2223(parent);
      if (name22) {
        tokens.push(`'${name22}'`);
      } else if (sourceCode) {
        const keyText = sourceCode.getText(parent.key);
        if (!keyText.includes("\n")) {
          tokens.push(`[${keyText}]`);
        }
      }
    }
  } else if (node.id) {
    tokens.push(`'${node.id.name}'`);
  } else if (parent.type === "VariableDeclarator" && parent.id && parent.id.type === "Identifier") {
    tokens.push(`'${parent.id.name}'`);
  } else if ((parent.type === "AssignmentExpression" || parent.type === "AssignmentPattern") && parent.left && parent.left.type === "Identifier") {
    tokens.push(`'${parent.left.name}'`);
  } else if (parent.type === "ExportDefaultDeclaration" && parent.declaration === node) {
    tokens.push("'default'");
  }
  return tokens.join(" ");
}
var typeConversionBinaryOps2223 = Object.freeze(
  /* @__PURE__ */ new Set([
    "==",
    "!=",
    "<",
    "<=",
    ">",
    ">=",
    "<<",
    ">>",
    ">>>",
    "+",
    "-",
    "*",
    "/",
    "%",
    "|",
    "^",
    "&",
    "in"
  ])
);
var typeConversionUnaryOps2223 = Object.freeze(/* @__PURE__ */ new Set(["-", "+", "!", "~"]));
function isNode2223(x2222) {
  return x2222 !== null && typeof x2222 === "object" && typeof x2222.type === "string";
}
var visitor2223 = Object.freeze(
  Object.assign(/* @__PURE__ */ Object.create(null), {
    $visit(node, options, visitorKeys) {
      const { type } = node;
      if (typeof this[type] === "function") {
        return this[type](node, options, visitorKeys);
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    $visitChildren(node, options, visitorKeys) {
      const { type } = node;
      for (const key of visitorKeys[type] || getKeys2223(node)) {
        const value = node[key];
        if (Array.isArray(value)) {
          for (const element of value) {
            if (isNode2223(element) && this.$visit(element, options, visitorKeys)) {
              return true;
            }
          }
        } else if (isNode2223(value) && this.$visit(value, options, visitorKeys)) {
          return true;
        }
      }
      return false;
    },
    ArrowFunctionExpression() {
      return false;
    },
    AssignmentExpression() {
      return true;
    },
    AwaitExpression() {
      return true;
    },
    BinaryExpression(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && typeConversionBinaryOps2223.has(node.operator) && (node.left.type !== "Literal" || node.right.type !== "Literal")) {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    CallExpression() {
      return true;
    },
    FunctionExpression() {
      return false;
    },
    ImportExpression() {
      return true;
    },
    MemberExpression(node, options, visitorKeys) {
      if (options.considerGetters) {
        return true;
      }
      if (options.considerImplicitTypeConversion && node.computed && node.property.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    MethodDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    NewExpression() {
      return true;
    },
    Property(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    PropertyDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UnaryExpression(node, options, visitorKeys) {
      if (node.operator === "delete") {
        return true;
      }
      if (options.considerImplicitTypeConversion && typeConversionUnaryOps2223.has(node.operator) && node.argument.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UpdateExpression() {
      return true;
    },
    YieldExpression() {
      return true;
    }
  })
);
function hasSideEffect2223(node, sourceCode, { considerGetters = false, considerImplicitTypeConversion = false } = {}) {
  return visitor2223.$visit(
    node,
    { considerGetters, considerImplicitTypeConversion },
    sourceCode.visitorKeys || visitor_keys_default2223
  );
}
function getParentSyntaxParen2223(node, sourceCode) {
  const parent = node.parent;
  switch (parent.type) {
    case "CallExpression":
    case "NewExpression":
      if (parent.arguments.length === 1 && parent.arguments[0] === node) {
        return sourceCode.getTokenAfter(
          parent.callee,
          isOpeningParenToken2223
        );
      }
      return null;
    case "DoWhileStatement":
      if (parent.test === node) {
        return sourceCode.getTokenAfter(
          parent.body,
          isOpeningParenToken2223
        );
      }
      return null;
    case "IfStatement":
    case "WhileStatement":
      if (parent.test === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "ImportExpression":
      if (parent.source === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "SwitchStatement":
      if (parent.discriminant === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "WithStatement":
      if (parent.object === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    default:
      return null;
  }
}
function isParenthesized2223(timesOrNode, nodeOrSourceCode, optionalSourceCode) {
  let times, node, sourceCode, maybeLeftParen, maybeRightParen;
  if (typeof timesOrNode === "number") {
    times = timesOrNode | 0;
    node = nodeOrSourceCode;
    sourceCode = optionalSourceCode;
    if (!(times >= 1)) {
      throw new TypeError("'times' should be a positive integer.");
    }
  } else {
    times = 1;
    node = timesOrNode;
    sourceCode = nodeOrSourceCode;
  }
  if (node == null || // `Program` can't be parenthesized
  node.parent == null || // `CatchClause.param` can't be parenthesized, example `try {} catch (error) {}`
  node.parent.type === "CatchClause" && node.parent.param === node) {
    return false;
  }
  maybeLeftParen = maybeRightParen = node;
  do {
    maybeLeftParen = sourceCode.getTokenBefore(maybeLeftParen);
    maybeRightParen = sourceCode.getTokenAfter(maybeRightParen);
  } while (maybeLeftParen != null && maybeRightParen != null && isOpeningParenToken2223(maybeLeftParen) && isClosingParenToken2223(maybeRightParen) && // Avoid false positive such as `if (a) {}`
  maybeLeftParen !== getParentSyntaxParen2223(node, sourceCode) && --times > 0);
  return times === 0;
}
Function.call.bind(Object.hasOwnProperty);
var __defProp22225 = Object.defineProperty;
var __export22225 = (target, all32222) => {
  for (var name22 in all32222)
    __defProp22225(target, name22, { get: all32222[name22], enumerable: true });
};
var NodeType2223 = types.AST_NODE_TYPES;
var is2223 = utils.ASTUtils.isNodeOfType;
var isOneOf2223 = utils.ASTUtils.isNodeOfTypes;
isOneOf2223([
  NodeType2223.ArrowFunctionExpression,
  NodeType2223.FunctionDeclaration,
  NodeType2223.FunctionExpression
]);
isOneOf2223([
  NodeType2223.ArrowFunctionExpression,
  NodeType2223.FunctionDeclaration,
  NodeType2223.FunctionExpression,
  NodeType2223.TSCallSignatureDeclaration,
  NodeType2223.TSConstructSignatureDeclaration,
  NodeType2223.TSDeclareFunction,
  NodeType2223.TSEmptyBodyFunctionExpression,
  NodeType2223.TSFunctionType,
  NodeType2223.TSMethodSignature
]);
isOneOf2223([NodeType2223.ClassDeclaration, NodeType2223.ClassExpression]);
isOneOf2223([
  NodeType2223.DoWhileStatement,
  NodeType2223.ForInStatement,
  NodeType2223.ForOfStatement,
  NodeType2223.ForStatement,
  NodeType2223.WhileStatement
]);
isOneOf2223([NodeType2223.TSArrayType, NodeType2223.TSTupleType]);
isOneOf2223([
  NodeType2223.PropertyDefinition,
  NodeType2223.TSIndexSignature,
  NodeType2223.TSParameterProperty,
  NodeType2223.TSPropertySignature
]);
is2223(NodeType2223.JSXElement);
is2223(NodeType2223.JSXFragment);
isOneOf2223([
  NodeType2223.JSXAttribute,
  NodeType2223.JSXSpreadChild,
  NodeType2223.JSXClosingElement,
  NodeType2223.JSXClosingFragment,
  NodeType2223.JSXElement,
  NodeType2223.JSXEmptyExpression,
  NodeType2223.JSXExpressionContainer,
  NodeType2223.JSXFragment,
  NodeType2223.JSXIdentifier,
  NodeType2223.JSXMemberExpression,
  NodeType2223.JSXNamespacedName,
  NodeType2223.JSXOpeningElement,
  NodeType2223.JSXOpeningFragment,
  NodeType2223.JSXSpreadAttribute,
  NodeType2223.JSXSpreadChild,
  NodeType2223.JSXText
]);
isOneOf2223([
  NodeType2223.JSXIdentifier,
  NodeType2223.JSXMemberExpression,
  NodeType2223.JSXNamespacedName
]);
isOneOf2223([
  NodeType2223.ArrayPattern,
  NodeType2223.AssignmentPattern,
  NodeType2223.ObjectPattern,
  NodeType2223.RestElement
]);
isOneOf2223([
  NodeType2223.TSInterfaceDeclaration,
  NodeType2223.TSTypeAliasDeclaration
]);
isOneOf2223([
  NodeType2223.ArrayExpression,
  NodeType2223.ArrayPattern,
  NodeType2223.ArrowFunctionExpression,
  NodeType2223.CallExpression,
  NodeType2223.ClassExpression,
  NodeType2223.FunctionExpression,
  NodeType2223.Identifier,
  NodeType2223.JSXElement,
  NodeType2223.JSXFragment,
  NodeType2223.Literal,
  NodeType2223.TemplateLiteral,
  NodeType2223.MemberExpression,
  NodeType2223.MetaProperty,
  NodeType2223.ObjectExpression,
  NodeType2223.ObjectPattern,
  NodeType2223.SequenceExpression,
  NodeType2223.Super,
  NodeType2223.TaggedTemplateExpression,
  NodeType2223.ThisExpression
]);
isOneOf2223([
  NodeType2223.ArrayExpression,
  NodeType2223.ArrayPattern,
  NodeType2223.ArrowFunctionExpression,
  NodeType2223.CallExpression,
  NodeType2223.ClassExpression,
  NodeType2223.FunctionExpression,
  NodeType2223.Identifier,
  NodeType2223.JSXElement,
  NodeType2223.JSXFragment,
  NodeType2223.Literal,
  NodeType2223.TemplateLiteral,
  NodeType2223.MemberExpression,
  NodeType2223.MetaProperty,
  NodeType2223.ObjectExpression,
  NodeType2223.ObjectPattern,
  NodeType2223.SequenceExpression,
  NodeType2223.Super,
  NodeType2223.TaggedTemplateExpression,
  NodeType2223.ThisExpression,
  NodeType2223.TSAsExpression,
  NodeType2223.TSNonNullExpression,
  NodeType2223.TSTypeAssertion
]);
var Function_exports22223 = {};
__export22225(Function_exports22223, {
  SK: () => SK22223,
  absurd: () => absurd22223,
  apply: () => apply22223,
  compose: () => compose22225,
  constFalse: () => constFalse22223,
  constNull: () => constNull22223,
  constTrue: () => constTrue22223,
  constUndefined: () => constUndefined22223,
  constVoid: () => constVoid22223,
  constant: () => constant22223,
  dual: () => dual22223,
  flip: () => flip22223,
  flow: () => flow22223,
  hole: () => hole22223,
  identity: () => identity22223,
  isFunction: () => isFunction222223,
  pipe: () => pipe22223,
  satisfies: () => satisfies22223,
  tupled: () => tupled22223,
  unsafeCoerce: () => unsafeCoerce22223,
  untupled: () => untupled22223
});
var isFunction222223 = (input) => typeof input === "function";
var dual22223 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a2222, b2222) {
        if (arguments.length >= 2) {
          return body(a2222, b2222);
        }
        return function(self2) {
          return body(self2, a2222);
        };
      };
    case 3:
      return function(a2222, b2222, c2222) {
        if (arguments.length >= 3) {
          return body(a2222, b2222, c2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222);
        };
      };
    case 4:
      return function(a2222, b2222, c2222, d2222) {
        if (arguments.length >= 4) {
          return body(a2222, b2222, c2222, d2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222);
        };
      };
    case 5:
      return function(a2222, b2222, c2222, d2222, e2222) {
        if (arguments.length >= 5) {
          return body(a2222, b2222, c2222, d2222, e2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222, d2222);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply22223 = (a2222) => (self2) => self2(a2222);
var identity22223 = (a2222) => a2222;
var satisfies22223 = () => (b2222) => b2222;
var unsafeCoerce22223 = identity22223;
var constant22223 = (value) => () => value;
var constTrue22223 = /* @__PURE__ */ constant22223(true);
var constFalse22223 = /* @__PURE__ */ constant22223(false);
var constNull22223 = /* @__PURE__ */ constant22223(null);
var constUndefined22223 = /* @__PURE__ */ constant22223(void 0);
var constVoid22223 = constUndefined22223;
var flip22223 = (f2222) => (...b2222) => (...a2222) => f2222(...a2222)(...b2222);
var compose22225 = /* @__PURE__ */ dual22223(2, (ab, bc) => (a2222) => bc(ab(a2222)));
var absurd22223 = (_2222) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled22223 = (f2222) => (a2222) => f2222(...a2222);
var untupled22223 = (f2222) => (...a2222) => f2222(a2222);
function pipe22223(a2222, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a2222;
    case 2:
      return ab(a2222);
    case 3:
      return bc(ab(a2222));
    case 4:
      return cd(bc(ab(a2222)));
    case 5:
      return de(cd(bc(ab(a2222))));
    case 6:
      return ef(de(cd(bc(ab(a2222)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a2222))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a2222)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a2222))))))));
    default: {
      let ret = arguments[0];
      for (let i2222 = 1; i2222 < arguments.length; i2222++) {
        ret = arguments[i2222](ret);
      }
      return ret;
    }
  }
}
function flow22223(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole22223 = /* @__PURE__ */ unsafeCoerce22223(absurd22223);
var SK22223 = (_2222, b2222) => b2222;
var make42225 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_32223 = (map622) => dual22223(3, (self2, name22, f2222) => map622(self2, (a2222) => Object.assign({}, a2222, {
  [name22]: f2222(a2222)
})));
var bindTo32223 = (map622) => dual22223(2, (self2, name22) => map622(self2, (a2222) => ({
  [name22]: a2222
})));
var bind32223 = (map622, flatMap4222) => dual22223(3, (self2, name22, f2222) => flatMap4222(self2, (a2222) => map622(f2222(a2222), (b2222) => Object.assign({}, a2222, {
  [name22]: b2222
}))));
var moduleVersion22223 = "3.2.8";
var getCurrentVersion22223 = () => moduleVersion22223;
var globalStoreId22223 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion22223()}`);
if (!(globalStoreId22223 in globalThis)) {
  globalThis[globalStoreId22223] = /* @__PURE__ */ new Map();
}
var globalStore22223 = globalThis[globalStoreId22223];
var globalValue22223 = (id, compute) => {
  if (!globalStore22223.has(id)) {
    globalStore22223.set(id, compute());
  }
  return globalStore22223.get(id);
};
var Predicate_exports22223 = {};
__export22225(Predicate_exports22223, {
  all: () => all22225,
  and: () => and35,
  compose: () => compose222223,
  eqv: () => eqv35,
  every: () => every45,
  hasProperty: () => hasProperty22223,
  implies: () => implies35,
  isBigInt: () => isBigInt35,
  isBoolean: () => isBoolean35,
  isDate: () => isDate35,
  isError: () => isError35,
  isFunction: () => isFunction32223,
  isIterable: () => isIterable35,
  isMap: () => isMap35,
  isNever: () => isNever35,
  isNotNull: () => isNotNull35,
  isNotNullable: () => isNotNullable35,
  isNotUndefined: () => isNotUndefined35,
  isNull: () => isNull35,
  isNullable: () => isNullable22223,
  isNumber: () => isNumber35,
  isObject: () => isObject22223,
  isPromise: () => isPromise35,
  isPromiseLike: () => isPromiseLike35,
  isReadonlyRecord: () => isReadonlyRecord35,
  isRecord: () => isRecord35,
  isSet: () => isSet35,
  isString: () => isString35,
  isSymbol: () => isSymbol35,
  isTagged: () => isTagged35,
  isTruthy: () => isTruthy35,
  isUint8Array: () => isUint8Array35,
  isUndefined: () => isUndefined35,
  isUnknown: () => isUnknown35,
  mapInput: () => mapInput45,
  nand: () => nand35,
  nor: () => nor35,
  not: () => not35,
  or: () => or35,
  product: () => product22225,
  productMany: () => productMany22225,
  some: () => some32225,
  struct: () => struct55,
  tuple: () => tuple45,
  xor: () => xor35
});
var mapInput45 = /* @__PURE__ */ dual22223(2, (self2, f2222) => (b2222) => self2(f2222(b2222)));
var isTruthy35 = (input) => !!input;
var isSet35 = (input) => input instanceof Set;
var isMap35 = (input) => input instanceof Map;
var isString35 = (input) => typeof input === "string";
var isNumber35 = (input) => typeof input === "number";
var isBoolean35 = (input) => typeof input === "boolean";
var isBigInt35 = (input) => typeof input === "bigint";
var isSymbol35 = (input) => typeof input === "symbol";
var isFunction32223 = isFunction222223;
var isUndefined35 = (input) => input === void 0;
var isNotUndefined35 = (input) => input !== void 0;
var isNull35 = (input) => input === null;
var isNotNull35 = (input) => input !== null;
var isNever35 = (_2222) => false;
var isUnknown35 = (_2222) => true;
var isRecordOrArray22223 = (input) => typeof input === "object" && input !== null;
var isObject22223 = (input) => isRecordOrArray22223(input) || isFunction32223(input);
var hasProperty22223 = /* @__PURE__ */ dual22223(2, (self2, property) => isObject22223(self2) && property in self2);
var isTagged35 = /* @__PURE__ */ dual22223(2, (self2, tag) => hasProperty22223(self2, "_tag") && self2["_tag"] === tag);
var isNullable22223 = (input) => input === null || input === void 0;
var isNotNullable35 = (input) => input !== null && input !== void 0;
var isError35 = (input) => input instanceof Error;
var isUint8Array35 = (input) => input instanceof Uint8Array;
var isDate35 = (input) => input instanceof Date;
var isIterable35 = (input) => hasProperty22223(input, Symbol.iterator);
var isRecord35 = (input) => isRecordOrArray22223(input) && !Array.isArray(input);
var isReadonlyRecord35 = isRecord35;
var isPromise35 = (input) => hasProperty22223(input, "then") && "catch" in input && isFunction32223(input.then) && isFunction32223(input.catch);
var isPromiseLike35 = (input) => hasProperty22223(input, "then") && isFunction32223(input.then);
var compose222223 = /* @__PURE__ */ dual22223(2, (ab, bc) => (a2222) => ab(a2222) && bc(a2222));
var product22225 = (self2, that) => ([a2222, b2222]) => self2(a2222) && that(b2222);
var all22225 = (collection) => {
  return (as222222) => {
    let collectionIndex = 0;
    for (const p2222 of collection) {
      if (collectionIndex >= as222222.length) {
        break;
      }
      if (p2222(as222222[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany22225 = (self2, collection) => {
  const rest = all22225(collection);
  return ([head222, ...tail222]) => self2(head222) === false ? false : rest(tail222);
};
var tuple45 = (...elements) => all22225(elements);
var struct55 = (fields) => {
  const keys22222 = Object.keys(fields);
  return (a2222) => {
    for (const key of keys22222) {
      if (!fields[key](a2222[key])) {
        return false;
      }
    }
    return true;
  };
};
var not35 = (self2) => (a2222) => !self2(a2222);
var or35 = /* @__PURE__ */ dual22223(2, (self2, that) => (a2222) => self2(a2222) || that(a2222));
var and35 = /* @__PURE__ */ dual22223(2, (self2, that) => (a2222) => self2(a2222) && that(a2222));
var xor35 = /* @__PURE__ */ dual22223(2, (self2, that) => (a2222) => self2(a2222) !== that(a2222));
var eqv35 = /* @__PURE__ */ dual22223(2, (self2, that) => (a2222) => self2(a2222) === that(a2222));
var implies35 = /* @__PURE__ */ dual22223(2, (self2, that) => (a2222) => self2(a2222) ? that(a2222) : true);
var nor35 = /* @__PURE__ */ dual22223(2, (self2, that) => (a2222) => !(self2(a2222) || that(a2222)));
var nand35 = /* @__PURE__ */ dual22223(2, (self2, that) => (a2222) => !(self2(a2222) && that(a2222)));
var every45 = (collection) => (a2222) => {
  for (const p2222 of collection) {
    if (!p2222(a2222)) {
      return false;
    }
  }
  return true;
};
var some32225 = (collection) => (a2222) => {
  for (const p2222 of collection) {
    if (p2222(a2222)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage22223 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId22223 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind22223 = (u2222) => isObject22223(u2222) && GenKindTypeId22223 in u2222;
var GenKindImpl22223 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity22223;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId22223] = GenKindTypeId22223;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen22225(this);
  }
};
var SingleShotGen22225 = class _SingleShotGen45 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a2222) {
    return this.called ? {
      value: a2222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a2222) {
    return {
      value: a2222,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e2222) {
    throw e2222;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen45(this.self);
  }
};
var adapter32223 = () => function() {
  let x2222 = arguments[0];
  for (let i2222 = 1; i2222 < arguments.length; i2222++) {
    x2222 = arguments[i2222](x2222);
  }
  return new GenKindImpl22223(x2222);
};
var defaultIncHi22223 = 335903614;
var defaultIncLo22223 = 4150755663;
var MUL_HI22223 = 1481765933 >>> 0;
var MUL_LO22223 = 1284865837 >>> 0;
var BIT_5322223 = 9007199254740992;
var BIT_2722223 = 134217728;
var PCGRandom22223 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable22223(seedLo) && isNullable22223(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable22223(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable22223(incLo) && isNullable22223(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo22223;
      incHi = this._state ? this._state[2] : defaultIncHi22223;
    } else if (isNullable22223(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add6422223(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max322) {
    if (!max322) {
      return this._next();
    }
    max322 = max322 >>> 0;
    if ((max322 & max322 - 1) === 0) {
      return this._next() & max322 - 1;
    }
    let num = 0;
    const skew = (-max322 >>> 0) % max322 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max322;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_2722223 + lo) / BIT_5322223;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul6422223(this._state, oldHi, oldLo, MUL_HI22223, MUL_LO22223);
    add6422223(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul6422223(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add6422223(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId22223 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap22223 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId22223]() {
    return this.#value;
  }
};
function yieldWrapGet22223(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId22223 in self2) {
    return self2[YieldWrapTypeId22223]();
  }
  throw new Error(getBugErrorMessage22223("yieldWrapGet"));
}
var structuralRegionState22223 = /* @__PURE__ */ globalValue22223("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache22223 = /* @__PURE__ */ globalValue22223(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr22223 = /* @__PURE__ */ globalValue22223(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom22223());
var symbol32223 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash22223 = (self2) => {
  if (structuralRegionState22223.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number22223(self2);
    case "bigint":
      return string22223(self2.toString(10));
    case "boolean":
      return string22223(String(self2));
    case "symbol":
      return string22223(String(self2));
    case "string":
      return string22223(self2);
    case "undefined":
      return string22223("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string22223("null");
      } else if (self2 instanceof Date) {
        return hash22223(self2.toISOString());
      } else if (isHash22223(self2)) {
        return self2[symbol32223]();
      } else {
        return random22223(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random22223 = (self2) => {
  if (!randomHashCache22223.has(self2)) {
    randomHashCache22223.set(self2, number22223(pcgr22223.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache22223.get(self2);
};
var combine22225 = (b2222) => (self2) => self2 * 53 ^ b2222;
var optimize22223 = (n2222) => n2222 & 3221225471 | n2222 >>> 1 & 1073741824;
var isHash22223 = (u2222) => hasProperty22223(u2222, symbol32223);
var number22223 = (n2222) => {
  if (n2222 !== n2222 || n2222 === Infinity) {
    return 0;
  }
  let h2222 = n2222 | 0;
  if (h2222 !== n2222) {
    h2222 ^= n2222 * 4294967295;
  }
  while (n2222 > 4294967295) {
    h2222 ^= n2222 /= 4294967295;
  }
  return optimize22223(n2222);
};
var string22223 = (str) => {
  let h2222 = 5381, i2222 = str.length;
  while (i2222) {
    h2222 = h2222 * 33 ^ str.charCodeAt(--i2222);
  }
  return optimize22223(h2222);
};
var structureKeys2223 = (o2222, keys22222) => {
  let h2222 = 12289;
  for (let i2222 = 0; i2222 < keys22222.length; i2222++) {
    h2222 ^= pipe22223(string22223(keys22222[i2222]), combine22225(hash22223(o2222[keys22222[i2222]])));
  }
  return optimize22223(h2222);
};
var structure2223 = (o2222) => structureKeys2223(o2222, Object.keys(o2222));
var array55 = (arr) => {
  let h2222 = 6151;
  for (let i2222 = 0; i2222 < arr.length; i2222++) {
    h2222 = pipe22223(h2222, combine22225(hash22223(arr[i2222])));
  }
  return optimize22223(h2222);
};
var cached22223 = function() {
  if (arguments.length === 1) {
    const self22 = arguments[0];
    return function(hash3222) {
      Object.defineProperty(self22, symbol32223, {
        value() {
          return hash3222;
        },
        enumerable: false
      });
      return hash3222;
    };
  }
  const self2 = arguments[0];
  const hash222222 = arguments[1];
  Object.defineProperty(self2, symbol32223, {
    value() {
      return hash222222;
    },
    enumerable: false
  });
  return hash222222;
};
var symbol222223 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals22223() {
  if (arguments.length === 1) {
    return (self2) => compareBoth22223(self2, arguments[0]);
  }
  return compareBoth22223(arguments[0], arguments[1]);
}
function compareBoth22223(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual22223(self2) && isEqual22223(that)) {
        if (hash22223(self2) === hash22223(that) && self2[symbol222223](that)) {
          return true;
        } else {
          return structuralRegionState22223.enabled && structuralRegionState22223.tester ? structuralRegionState22223.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState22223.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v2222, i2222) => compareBoth22223(v2222, that[i2222]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth22223(self2[key], that[key]))) {
              return structuralRegionState22223.tester ? structuralRegionState22223.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState22223.tester ? structuralRegionState22223.tester(self2, that) : false;
    }
  }
  return structuralRegionState22223.enabled && structuralRegionState22223.tester ? structuralRegionState22223.tester(self2, that) : false;
}
var isEqual22223 = (u2222) => hasProperty22223(u2222, symbol222223);
var equivalence22223 = () => equals22223;
var NodeInspectSymbol22223 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON22223 = (x2222) => {
  if (hasProperty22223(x2222, "toJSON") && isFunction32223(x2222["toJSON"]) && x2222["toJSON"].length === 0) {
    return x2222.toJSON();
  } else if (Array.isArray(x2222)) {
    return x2222.map(toJSON22223);
  }
  return x2222;
};
var format22223 = (x2222) => JSON.stringify(x2222, null, 2);
var pipeArguments22223 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i2222 = 0, len = args.length; i2222 < len; i2222++) {
        ret = args[i2222](ret);
      }
      return ret;
    }
  }
};
var OP_COMMIT2223 = "Commit";
var OP_FAILURE2223 = "Failure";
var OP_WITH_RUNTIME2223 = "WithRuntime";
var EffectTypeId22225 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId22223 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId22223 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId22223 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance22223 = {
  /* c8 ignore next */
  _R: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _A: (_2222) => _2222,
  _V: /* @__PURE__ */ getCurrentVersion22223()
};
var sinkVariance22223 = {
  /* c8 ignore next */
  _A: (_2222) => _2222,
  /* c8 ignore next */
  _In: (_2222) => _2222,
  /* c8 ignore next */
  _L: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _R: (_2222) => _2222
};
var channelVariance22223 = {
  /* c8 ignore next */
  _Env: (_2222) => _2222,
  /* c8 ignore next */
  _InErr: (_2222) => _2222,
  /* c8 ignore next */
  _InElem: (_2222) => _2222,
  /* c8 ignore next */
  _InDone: (_2222) => _2222,
  /* c8 ignore next */
  _OutErr: (_2222) => _2222,
  /* c8 ignore next */
  _OutElem: (_2222) => _2222,
  /* c8 ignore next */
  _OutDone: (_2222) => _2222
};
var EffectPrototype22223 = {
  [EffectTypeId22225]: effectVariance22223,
  [StreamTypeId22223]: effectVariance22223,
  [SinkTypeId22223]: sinkVariance22223,
  [ChannelTypeId22223]: channelVariance22223,
  [symbol222223](that) {
    return this === that;
  },
  [symbol32223]() {
    return cached22223(this, random22223(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen22225(new YieldWrap22223(this));
  },
  pipe() {
    return pipeArguments22223(this, arguments);
  }
};
var StructuralPrototype2223 = {
  [symbol32223]() {
    return cached22223(this, structure2223(this));
  },
  [symbol222223](that) {
    const selfKeys = Object.keys(this);
    const thatKeys = Object.keys(that);
    if (selfKeys.length !== thatKeys.length) {
      return false;
    }
    for (const key of selfKeys) {
      if (!(key in that && equals22223(this[key], that[key]))) {
        return false;
      }
    }
    return true;
  }
};
var CommitPrototype2223 = {
  ...EffectPrototype22223,
  _op: OP_COMMIT2223
};
var StructuralCommitPrototype2223 = {
  ...CommitPrototype2223,
  ...StructuralPrototype2223
};
var TypeId52225 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto32223 = {
  ...EffectPrototype22223,
  [TypeId52225]: {
    _A: (_2222) => _2222
  },
  [NodeInspectSymbol22223]() {
    return this.toJSON();
  },
  toString() {
    return format22223(this.toJSON());
  }
};
var SomeProto22223 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto32223), {
  _tag: "Some",
  _op: "Some",
  [symbol222223](that) {
    return isOption32223(that) && isSome32223(that) && equals22223(this.value, that.value);
  },
  [symbol32223]() {
    return cached22223(this, combine22225(hash22223(this._tag))(hash22223(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON22223(this.value)
    };
  }
});
var NoneHash22223 = /* @__PURE__ */ hash22223("None");
var NoneProto22223 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto32223), {
  _tag: "None",
  _op: "None",
  [symbol222223](that) {
    return isOption32223(that) && isNone32223(that);
  },
  [symbol32223]() {
    return NoneHash22223;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption32223 = (input) => hasProperty22223(input, TypeId52225);
var isNone32223 = (fa) => fa._tag === "None";
var isSome32223 = (fa) => fa._tag === "Some";
var none32223 = /* @__PURE__ */ Object.create(NoneProto22223);
var some222223 = (value) => {
  const a2222 = Object.create(SomeProto22223);
  a2222.value = value;
  return a2222;
};
var TypeId222223 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto222223 = {
  ...EffectPrototype22223,
  [TypeId222223]: {
    _R: (_2222) => _2222
  },
  [NodeInspectSymbol22223]() {
    return this.toJSON();
  },
  toString() {
    return format22223(this.toJSON());
  }
};
var RightProto22223 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto222223), {
  _tag: "Right",
  _op: "Right",
  [symbol222223](that) {
    return isEither22223(that) && isRight22223(that) && equals22223(this.right, that.right);
  },
  [symbol32223]() {
    return combine22225(hash22223(this._tag))(hash22223(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON22223(this.right)
    };
  }
});
var LeftProto22223 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto222223), {
  _tag: "Left",
  _op: "Left",
  [symbol222223](that) {
    return isEither22223(that) && isLeft22223(that) && equals22223(this.left, that.left);
  },
  [symbol32223]() {
    return combine22225(hash22223(this._tag))(hash22223(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON22223(this.left)
    };
  }
});
var isEither22223 = (input) => hasProperty22223(input, TypeId222223);
var isLeft22223 = (ma) => ma._tag === "Left";
var isRight22223 = (ma) => ma._tag === "Right";
var left22225 = (left32222) => {
  const a2222 = Object.create(LeftProto22223);
  a2222.left = left32222;
  return a2222;
};
var right22225 = (right32222) => {
  const a2222 = Object.create(RightProto22223);
  a2222.right = right32222;
  return a2222;
};
var getLeft32223 = (self2) => isRight22223(self2) ? none32223 : some222223(self2.left);
var getRight32223 = (self2) => isLeft22223(self2) ? none32223 : some222223(self2.right);
var right222223 = right22225;
var left222223 = left22225;
var Option_exports22223 = {};
__export22225(Option_exports22223, {
  Do: () => Do22223,
  TypeId: () => TypeId322223,
  all: () => all222223,
  andThen: () => andThen22223,
  ap: () => ap22223,
  as: () => as22223,
  asVoid: () => asVoid22223,
  bind: () => bind222223,
  bindTo: () => bindTo222223,
  composeK: () => composeK22223,
  contains: () => contains22223,
  containsWith: () => containsWith22223,
  exists: () => exists22223,
  filter: () => filter22223,
  filterMap: () => filterMap22223,
  firstSomeOf: () => firstSomeOf22223,
  flatMap: () => flatMap22223,
  flatMapNullable: () => flatMapNullable22223,
  flatten: () => flatten22223,
  fromIterable: () => fromIterable22225,
  fromNullable: () => fromNullable22223,
  gen: () => gen22223,
  getEquivalence: () => getEquivalence22225,
  getLeft: () => getLeft222223,
  getOrElse: () => getOrElse22223,
  getOrNull: () => getOrNull22223,
  getOrThrow: () => getOrThrow22223,
  getOrThrowWith: () => getOrThrowWith22223,
  getOrUndefined: () => getOrUndefined22223,
  getOrder: () => getOrder22223,
  getRight: () => getRight222223,
  isNone: () => isNone222223,
  isOption: () => isOption222223,
  isSome: () => isSome222223,
  let: () => let_222223,
  lift2: () => lift222223,
  liftNullable: () => liftNullable22223,
  liftPredicate: () => liftPredicate22223,
  liftThrowable: () => liftThrowable22223,
  map: () => map22223,
  match: () => match22223,
  none: () => none222223,
  orElse: () => orElse22223,
  orElseEither: () => orElseEither22223,
  orElseSome: () => orElseSome22223,
  partitionMap: () => partitionMap22223,
  product: () => product222223,
  productMany: () => productMany222223,
  reduceCompact: () => reduceCompact22223,
  some: () => some322223,
  tap: () => tap22223,
  toArray: () => toArray22223,
  toRefinement: () => toRefinement22223,
  void: () => void_22223,
  zipLeft: () => zipLeft22223,
  zipRight: () => zipRight22223,
  zipWith: () => zipWith22223
});
var make222223 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId322223 = /* @__PURE__ */ Symbol.for("effect/Option");
var none222223 = () => none32223;
var some322223 = some222223;
var isOption222223 = isOption32223;
var isNone222223 = isNone32223;
var isSome222223 = isSome32223;
var match22223 = /* @__PURE__ */ dual22223(2, (self2, {
  onNone,
  onSome
}) => isNone222223(self2) ? onNone() : onSome(self2.value));
var toRefinement22223 = (f2222) => (a2222) => isSome222223(f2222(a2222));
var fromIterable22225 = (collection) => {
  for (const a2222 of collection) {
    return some322223(a2222);
  }
  return none222223();
};
var getRight222223 = getRight32223;
var getLeft222223 = getLeft32223;
var getOrElse22223 = /* @__PURE__ */ dual22223(2, (self2, onNone) => isNone222223(self2) ? onNone() : self2.value);
var orElse22223 = /* @__PURE__ */ dual22223(2, (self2, that) => isNone222223(self2) ? that() : self2);
var orElseSome22223 = /* @__PURE__ */ dual22223(2, (self2, onNone) => isNone222223(self2) ? some322223(onNone()) : self2);
var orElseEither22223 = /* @__PURE__ */ dual22223(2, (self2, that) => isNone222223(self2) ? map22223(that(), right22225) : map22223(self2, left22225));
var firstSomeOf22223 = (collection) => {
  let out = none222223();
  for (out of collection) {
    if (isSome222223(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable22223 = (nullableValue) => nullableValue == null ? none222223() : some322223(nullableValue);
var liftNullable22223 = (f2222) => (...a2222) => fromNullable22223(f2222(...a2222));
var getOrNull22223 = /* @__PURE__ */ getOrElse22223(constNull22223);
var getOrUndefined22223 = /* @__PURE__ */ getOrElse22223(constUndefined22223);
var liftThrowable22223 = (f2222) => (...a2222) => {
  try {
    return some322223(f2222(...a2222));
  } catch (e2222) {
    return none222223();
  }
};
var getOrThrowWith22223 = /* @__PURE__ */ dual22223(2, (self2, onNone) => {
  if (isSome222223(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow22223 = /* @__PURE__ */ getOrThrowWith22223(() => new Error("getOrThrow called on a None"));
var map22223 = /* @__PURE__ */ dual22223(2, (self2, f2222) => isNone222223(self2) ? none222223() : some322223(f2222(self2.value)));
var as22223 = /* @__PURE__ */ dual22223(2, (self2, b2222) => map22223(self2, () => b2222));
var asVoid22223 = /* @__PURE__ */ as22223(void 0);
var void_22223 = /* @__PURE__ */ some322223(void 0);
var flatMap22223 = /* @__PURE__ */ dual22223(2, (self2, f2222) => isNone222223(self2) ? none222223() : f2222(self2.value));
var andThen22223 = /* @__PURE__ */ dual22223(2, (self2, f2222) => flatMap22223(self2, (a2222) => {
  const b2222 = isFunction222223(f2222) ? f2222(a2222) : f2222;
  return isOption222223(b2222) ? b2222 : some322223(b2222);
}));
var flatMapNullable22223 = /* @__PURE__ */ dual22223(2, (self2, f2222) => isNone222223(self2) ? none222223() : fromNullable22223(f2222(self2.value)));
var flatten22223 = /* @__PURE__ */ flatMap22223(identity22223);
var zipRight22223 = /* @__PURE__ */ dual22223(2, (self2, that) => flatMap22223(self2, () => that));
var composeK22223 = /* @__PURE__ */ dual22223(2, (afb, bfc) => (a2222) => flatMap22223(afb(a2222), bfc));
var zipLeft22223 = /* @__PURE__ */ dual22223(2, (self2, that) => tap22223(self2, () => that));
var tap22223 = /* @__PURE__ */ dual22223(2, (self2, f2222) => flatMap22223(self2, (a2222) => map22223(f2222(a2222), () => a2222)));
var product222223 = (self2, that) => isSome222223(self2) && isSome222223(that) ? some322223([self2.value, that.value]) : none222223();
var productMany222223 = (self2, collection) => {
  if (isNone222223(self2)) {
    return none222223();
  }
  const out = [self2.value];
  for (const o2222 of collection) {
    if (isNone222223(o2222)) {
      return none222223();
    }
    out.push(o2222.value);
  }
  return some322223(out);
};
var all222223 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o2222 of input) {
      if (isNone222223(o2222)) {
        return none222223();
      }
      out2.push(o2222.value);
    }
    return some322223(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o2222 = input[key];
    if (isNone222223(o2222)) {
      return none222223();
    }
    out[key] = o2222.value;
  }
  return some322223(out);
};
var zipWith22223 = /* @__PURE__ */ dual22223(3, (self2, that, f2222) => map22223(product222223(self2, that), ([a2222, b2222]) => f2222(a2222, b2222)));
var ap22223 = /* @__PURE__ */ dual22223(2, (self2, that) => zipWith22223(self2, that, (f2222, a2222) => f2222(a2222)));
var reduceCompact22223 = /* @__PURE__ */ dual22223(3, (self2, b2222, f2222) => {
  let out = b2222;
  for (const oa of self2) {
    if (isSome222223(oa)) {
      out = f2222(out, oa.value);
    }
  }
  return out;
});
var toArray22223 = (self2) => isNone222223(self2) ? [] : [self2.value];
var partitionMap22223 = /* @__PURE__ */ dual22223(2, (self2, f2222) => {
  if (isNone222223(self2)) {
    return [none222223(), none222223()];
  }
  const e2222 = f2222(self2.value);
  return isLeft22223(e2222) ? [some322223(e2222.left), none222223()] : [none222223(), some322223(e2222.right)];
});
var filterMap22223 = /* @__PURE__ */ dual22223(2, (self2, f2222) => isNone222223(self2) ? none222223() : f2222(self2.value));
var filter22223 = /* @__PURE__ */ dual22223(2, (self2, predicate) => filterMap22223(self2, (b2222) => predicate(b2222) ? some222223(b2222) : none32223));
var getEquivalence22225 = (isEquivalent) => make42225((x2222, y2222) => x2222 === y2222 || (isNone222223(x2222) ? isNone222223(y2222) : isNone222223(y2222) ? false : isEquivalent(x2222.value, y2222.value)));
var getOrder22223 = (O2222) => make222223((self2, that) => isSome222223(self2) ? isSome222223(that) ? O2222(self2.value, that.value) : 1 : -1);
var lift222223 = (f2222) => dual22223(2, (self2, that) => zipWith22223(self2, that, f2222));
var liftPredicate22223 = (predicate) => (b2222) => predicate(b2222) ? some322223(b2222) : none222223();
var containsWith22223 = (isEquivalent) => dual22223(2, (self2, a2222) => isNone222223(self2) ? false : isEquivalent(self2.value, a2222));
var _equivalence22225 = /* @__PURE__ */ equivalence22223();
var contains22223 = /* @__PURE__ */ containsWith22223(_equivalence22225);
var exists22223 = /* @__PURE__ */ dual22223(2, (self2, refinement) => isNone222223(self2) ? false : refinement(self2.value));
var bindTo222223 = /* @__PURE__ */ bindTo32223(map22223);
var let_222223 = /* @__PURE__ */ let_32223(map22223);
var bind222223 = /* @__PURE__ */ bind32223(map22223, flatMap22223);
var Do22223 = /* @__PURE__ */ some322223({});
var adapter222223 = /* @__PURE__ */ adapter32223();
var gen22223 = (f2222) => {
  const iterator = f2222(adapter222223);
  let state = iterator.next();
  if (state.done) {
    return some322223(state.value);
  } else {
    let current = state.value;
    if (isGenKind22223(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet22223(current);
    }
    if (isNone222223(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind22223(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet22223(current);
        }
        if (isNone222223(current)) {
          return current;
        }
      }
    }
    return some322223(state.value);
  }
};
var fromIterable222223 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var reverse45 = (self2) => Array.from(self2).reverse();
var reduce55 = /* @__PURE__ */ dual22223(3, (self2, b2222, f2222) => fromIterable222223(self2).reduce((b22222, a2222, i2222) => f2222(b22222, a2222, i2222), b2222));
var TagTypeId2223 = /* @__PURE__ */ Symbol.for("effect/Context/Tag");
var STMSymbolKey2223 = "effect/STM";
var STMTypeId2223 = /* @__PURE__ */ Symbol.for(STMSymbolKey2223);
var TagProto2223 = {
  ...EffectPrototype22223,
  _tag: "Tag",
  _op: "Tag",
  [STMTypeId2223]: effectVariance22223,
  [TagTypeId2223]: {
    _Service: (_2222) => _2222,
    _Identifier: (_2222) => _2222
  },
  toString() {
    return format22223(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Tag",
      key: this.key,
      stack: this.stack
    };
  },
  [NodeInspectSymbol22223]() {
    return this.toJSON();
  },
  of(self2) {
    return self2;
  },
  context(self2) {
    return make322223(this, self2);
  }
};
var makeGenericTag2223 = (key) => {
  const limit = Error.stackTraceLimit;
  Error.stackTraceLimit = 2;
  const creationError = new Error();
  Error.stackTraceLimit = limit;
  const tag = Object.create(TagProto2223);
  Object.defineProperty(tag, "stack", {
    get() {
      return creationError.stack;
    }
  });
  tag.key = key;
  return tag;
};
var TypeId422223 = /* @__PURE__ */ Symbol.for("effect/Context");
var ContextProto2223 = {
  [TypeId422223]: {
    _Services: (_2222) => _2222
  },
  [symbol222223](that) {
    if (isContext2223(that)) {
      if (this.unsafeMap.size === that.unsafeMap.size) {
        for (const k2222 of this.unsafeMap.keys()) {
          if (!that.unsafeMap.has(k2222) || !equals22223(this.unsafeMap.get(k2222), that.unsafeMap.get(k2222))) {
            return false;
          }
        }
        return true;
      }
    }
    return false;
  },
  [symbol32223]() {
    return cached22223(this, number22223(this.unsafeMap.size));
  },
  pipe() {
    return pipeArguments22223(this, arguments);
  },
  toString() {
    return format22223(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Context",
      services: Array.from(this.unsafeMap).map(toJSON22223)
    };
  },
  [NodeInspectSymbol22223]() {
    return this.toJSON();
  }
};
var makeContext2223 = (unsafeMap) => {
  const context = Object.create(ContextProto2223);
  context.unsafeMap = unsafeMap;
  return context;
};
var isContext2223 = (u2222) => hasProperty22223(u2222, TypeId422223);
var _empty6223 = /* @__PURE__ */ makeContext2223(/* @__PURE__ */ new Map());
var empty105 = () => _empty6223;
var make322223 = (tag, service) => makeContext2223(/* @__PURE__ */ new Map([[tag.key, service]]));
var GenericTag2223 = makeGenericTag2223;
var empty22223 = empty105;
var TypeId522223 = /* @__PURE__ */ Symbol.for("effect/Chunk");
function copy35(src, srcPos, dest, destPos, len) {
  for (let i2222 = srcPos; i2222 < Math.min(src.length, srcPos + len); i2222++) {
    dest[destPos + i2222 - srcPos] = src[i2222];
  }
  return dest;
}
var emptyArray2223 = [];
var getEquivalence222223 = (isEquivalent) => make42225((self2, that) => self2.length === that.length && toReadonlyArray2223(self2).every((value, i2222) => isEquivalent(value, unsafeGet22223(that, i2222))));
var _equivalence222223 = /* @__PURE__ */ getEquivalence222223(equals22223);
var ChunkProto2223 = {
  [TypeId522223]: {
    _A: (_2222) => _2222
  },
  toString() {
    return format22223(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Chunk",
      values: toReadonlyArray2223(this).map(toJSON22223)
    };
  },
  [NodeInspectSymbol22223]() {
    return this.toJSON();
  },
  [symbol222223](that) {
    return isChunk2223(that) && _equivalence222223(this, that);
  },
  [symbol32223]() {
    return cached22223(this, array55(toReadonlyArray2223(this)));
  },
  [Symbol.iterator]() {
    switch (this.backing._tag) {
      case "IArray": {
        return this.backing.array[Symbol.iterator]();
      }
      case "IEmpty": {
        return emptyArray2223[Symbol.iterator]();
      }
      default: {
        return toReadonlyArray2223(this)[Symbol.iterator]();
      }
    }
  },
  pipe() {
    return pipeArguments22223(this, arguments);
  }
};
var makeChunk2223 = (backing) => {
  const chunk = Object.create(ChunkProto2223);
  chunk.backing = backing;
  switch (backing._tag) {
    case "IEmpty": {
      chunk.length = 0;
      chunk.depth = 0;
      chunk.left = chunk;
      chunk.right = chunk;
      break;
    }
    case "IConcat": {
      chunk.length = backing.left.length + backing.right.length;
      chunk.depth = 1 + Math.max(backing.left.depth, backing.right.depth);
      chunk.left = backing.left;
      chunk.right = backing.right;
      break;
    }
    case "IArray": {
      chunk.length = backing.array.length;
      chunk.depth = 0;
      chunk.left = _empty22223;
      chunk.right = _empty22223;
      break;
    }
    case "ISingleton": {
      chunk.length = 1;
      chunk.depth = 0;
      chunk.left = _empty22223;
      chunk.right = _empty22223;
      break;
    }
    case "ISlice": {
      chunk.length = backing.length;
      chunk.depth = backing.chunk.depth + 1;
      chunk.left = _empty22223;
      chunk.right = _empty22223;
      break;
    }
  }
  return chunk;
};
var isChunk2223 = (u2222) => hasProperty22223(u2222, TypeId522223);
var _empty22223 = /* @__PURE__ */ makeChunk2223({
  _tag: "IEmpty"
});
var empty32223 = () => _empty22223;
var make422223 = (...as222222) => as222222.length === 1 ? of35(as222222[0]) : unsafeFromNonEmptyArray2223(as222222);
var of35 = (a2222) => makeChunk2223({
  _tag: "ISingleton",
  a: a2222
});
var copyToArray2223 = (self2, array32222, initial) => {
  switch (self2.backing._tag) {
    case "IArray": {
      copy35(self2.backing.array, 0, array32222, initial, self2.length);
      break;
    }
    case "IConcat": {
      copyToArray2223(self2.left, array32222, initial);
      copyToArray2223(self2.right, array32222, initial + self2.left.length);
      break;
    }
    case "ISingleton": {
      array32222[initial] = self2.backing.a;
      break;
    }
    case "ISlice": {
      let i2222 = 0;
      let j2222 = initial;
      while (i2222 < self2.length) {
        array32222[j2222] = unsafeGet22223(self2, i2222);
        i2222 += 1;
        j2222 += 1;
      }
      break;
    }
  }
};
var toReadonlyArray2223 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      return emptyArray2223;
    }
    case "IArray": {
      return self2.backing.array;
    }
    default: {
      const arr = new Array(self2.length);
      copyToArray2223(self2, arr, 0);
      self2.backing = {
        _tag: "IArray",
        array: arr
      };
      self2.left = _empty22223;
      self2.right = _empty22223;
      self2.depth = 0;
      return arr;
    }
  }
};
var reverse22223 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty":
    case "ISingleton":
      return self2;
    case "IArray": {
      return makeChunk2223({
        _tag: "IArray",
        array: reverse45(self2.backing.array)
      });
    }
    case "IConcat": {
      return makeChunk2223({
        _tag: "IConcat",
        left: reverse22223(self2.backing.right),
        right: reverse22223(self2.backing.left)
      });
    }
    case "ISlice":
      return unsafeFromArray2223(reverse45(toReadonlyArray2223(self2)));
  }
};
var unsafeFromArray2223 = (self2) => makeChunk2223({
  _tag: "IArray",
  array: self2
});
var unsafeFromNonEmptyArray2223 = (self2) => unsafeFromArray2223(self2);
var unsafeGet22223 = /* @__PURE__ */ dual22223(2, (self2, index) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      throw new Error(`Index out of bounds`);
    }
    case "ISingleton": {
      if (index !== 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.a;
    }
    case "IArray": {
      if (index >= self2.length || index < 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.array[index];
    }
    case "IConcat": {
      return index < self2.left.length ? unsafeGet22223(self2.left, index) : unsafeGet22223(self2.right, index - self2.left.length);
    }
    case "ISlice": {
      return unsafeGet22223(self2.backing.chunk, index + self2.backing.offset);
    }
  }
});
var prepend35 = /* @__PURE__ */ dual22223(2, (self2, elem) => appendAll35(of35(elem), self2));
var drop35 = /* @__PURE__ */ dual22223(2, (self2, n2222) => {
  if (n2222 <= 0) {
    return self2;
  } else if (n2222 >= self2.length) {
    return _empty22223;
  } else {
    switch (self2.backing._tag) {
      case "ISlice": {
        return makeChunk2223({
          _tag: "ISlice",
          chunk: self2.backing.chunk,
          offset: self2.backing.offset + n2222,
          length: self2.backing.length - n2222
        });
      }
      case "IConcat": {
        if (n2222 > self2.left.length) {
          return drop35(self2.right, n2222 - self2.left.length);
        }
        return makeChunk2223({
          _tag: "IConcat",
          left: drop35(self2.left, n2222),
          right: self2.right
        });
      }
      default: {
        return makeChunk2223({
          _tag: "ISlice",
          chunk: self2,
          offset: n2222,
          length: self2.length - n2222
        });
      }
    }
  }
});
var appendAll35 = /* @__PURE__ */ dual22223(2, (self2, that) => {
  if (self2.backing._tag === "IEmpty") {
    return that;
  }
  if (that.backing._tag === "IEmpty") {
    return self2;
  }
  const diff22222 = that.depth - self2.depth;
  if (Math.abs(diff22222) <= 1) {
    return makeChunk2223({
      _tag: "IConcat",
      left: self2,
      right: that
    });
  } else if (diff22222 < -1) {
    if (self2.left.depth >= self2.right.depth) {
      const nr = appendAll35(self2.right, that);
      return makeChunk2223({
        _tag: "IConcat",
        left: self2.left,
        right: nr
      });
    } else {
      const nrr = appendAll35(self2.right.right, that);
      if (nrr.depth === self2.depth - 3) {
        const nr = makeChunk2223({
          _tag: "IConcat",
          left: self2.right.left,
          right: nrr
        });
        return makeChunk2223({
          _tag: "IConcat",
          left: self2.left,
          right: nr
        });
      } else {
        const nl = makeChunk2223({
          _tag: "IConcat",
          left: self2.left,
          right: self2.right.left
        });
        return makeChunk2223({
          _tag: "IConcat",
          left: nl,
          right: nrr
        });
      }
    }
  } else {
    if (that.right.depth >= that.left.depth) {
      const nl = appendAll35(self2, that.left);
      return makeChunk2223({
        _tag: "IConcat",
        left: nl,
        right: that.right
      });
    } else {
      const nll = appendAll35(self2, that.left.left);
      if (nll.depth === that.depth - 3) {
        const nl = makeChunk2223({
          _tag: "IConcat",
          left: nll,
          right: that.left.right
        });
        return makeChunk2223({
          _tag: "IConcat",
          left: nl,
          right: that.right
        });
      } else {
        const nr = makeChunk2223({
          _tag: "IConcat",
          left: that.left.right,
          right: that.right
        });
        return makeChunk2223({
          _tag: "IConcat",
          left: nll,
          right: nr
        });
      }
    }
  }
});
var isEmpty2223 = (self2) => self2.length === 0;
var isNonEmpty2223 = (self2) => self2.length > 0;
var unsafeHead2223 = (self2) => unsafeGet22223(self2, 0);
var headNonEmpty35 = unsafeHead2223;
var tailNonEmpty35 = (self2) => drop35(self2, 1);
var SIZE2223 = 5;
var BUCKET_SIZE2223 = /* @__PURE__ */ Math.pow(2, SIZE2223);
var MASK2223 = BUCKET_SIZE2223 - 1;
var MAX_INDEX_NODE2223 = BUCKET_SIZE2223 / 2;
var MIN_ARRAY_NODE2223 = BUCKET_SIZE2223 / 4;
function popcount2223(x2222) {
  x2222 -= x2222 >> 1 & 1431655765;
  x2222 = (x2222 & 858993459) + (x2222 >> 2 & 858993459);
  x2222 = x2222 + (x2222 >> 4) & 252645135;
  x2222 += x2222 >> 8;
  x2222 += x2222 >> 16;
  return x2222 & 127;
}
function hashFragment2223(shift22, h2222) {
  return h2222 >>> shift22 & MASK2223;
}
function toBitmap2223(x2222) {
  return 1 << x2222;
}
function fromBitmap2223(bitmap, bit) {
  return popcount2223(bitmap & bit - 1);
}
var make52223 = (value, previous) => ({
  value,
  previous
});
function arrayUpdate2223(mutate22222, at, v2222, arr) {
  let out = arr;
  if (!mutate22222) {
    const len = arr.length;
    out = new Array(len);
    for (let i2222 = 0; i2222 < len; ++i2222) out[i2222] = arr[i2222];
  }
  out[at] = v2222;
  return out;
}
function arraySpliceOut2223(mutate22222, at, arr) {
  const newLen = arr.length - 1;
  let i2222 = 0;
  let g2222 = 0;
  let out = arr;
  if (mutate22222) {
    i2222 = g2222 = at;
  } else {
    out = new Array(newLen);
    while (i2222 < at) out[g2222++] = arr[i2222++];
  }
  ++i2222;
  while (i2222 <= newLen) out[g2222++] = arr[i2222++];
  if (mutate22222) {
    out.length = newLen;
  }
  return out;
}
function arraySpliceIn2223(mutate22222, at, v2222, arr) {
  const len = arr.length;
  if (mutate22222) {
    let i22222 = len;
    while (i22222 >= at) arr[i22222--] = arr[i22222];
    arr[at] = v2222;
    return arr;
  }
  let i2222 = 0, g2222 = 0;
  const out = new Array(len + 1);
  while (i2222 < at) out[g2222++] = arr[i2222++];
  out[at] = v2222;
  while (i2222 < len) out[++g2222] = arr[i2222++];
  return out;
}
var EmptyNode2223 = class _EmptyNode2223 {
  _tag = "EmptyNode";
  modify(edit, _shift, f2222, hash222222, key, size42222) {
    const v2222 = f2222(none222223());
    if (isNone222223(v2222)) return new _EmptyNode2223();
    ++size42222.value;
    return new LeafNode2223(edit, hash222222, key, v2222);
  }
};
function isEmptyNode2223(a2222) {
  return isTagged35(a2222, "EmptyNode");
}
function isLeafNode2223(node) {
  return isEmptyNode2223(node) || node._tag === "LeafNode" || node._tag === "CollisionNode";
}
function canEditNode2223(node, edit) {
  return isEmptyNode2223(node) ? false : edit === node.edit;
}
var LeafNode2223 = class _LeafNode2223 {
  edit;
  hash;
  key;
  value;
  _tag = "LeafNode";
  constructor(edit, hash222222, key, value) {
    this.edit = edit;
    this.hash = hash222222;
    this.key = key;
    this.value = value;
  }
  modify(edit, shift22, f2222, hash222222, key, size42222) {
    if (equals22223(key, this.key)) {
      const v22222 = f2222(this.value);
      if (v22222 === this.value) return this;
      else if (isNone222223(v22222)) {
        --size42222.value;
        return new EmptyNode2223();
      }
      if (canEditNode2223(this, edit)) {
        this.value = v22222;
        return this;
      }
      return new _LeafNode2223(edit, hash222222, key, v22222);
    }
    const v2222 = f2222(none222223());
    if (isNone222223(v2222)) return this;
    ++size42222.value;
    return mergeLeaves2223(edit, shift22, this.hash, this, hash222222, new _LeafNode2223(edit, hash222222, key, v2222));
  }
};
var CollisionNode2223 = class _CollisionNode2223 {
  edit;
  hash;
  children;
  _tag = "CollisionNode";
  constructor(edit, hash222222, children) {
    this.edit = edit;
    this.hash = hash222222;
    this.children = children;
  }
  modify(edit, shift22, f2222, hash222222, key, size42222) {
    if (hash222222 === this.hash) {
      const canEdit = canEditNode2223(this, edit);
      const list = this.updateCollisionList(canEdit, edit, this.hash, this.children, f2222, key, size42222);
      if (list === this.children) return this;
      return list.length > 1 ? new _CollisionNode2223(edit, this.hash, list) : list[0];
    }
    const v2222 = f2222(none222223());
    if (isNone222223(v2222)) return this;
    ++size42222.value;
    return mergeLeaves2223(edit, shift22, this.hash, this, hash222222, new LeafNode2223(edit, hash222222, key, v2222));
  }
  updateCollisionList(mutate22222, edit, hash222222, list, f2222, key, size42222) {
    const len = list.length;
    for (let i2222 = 0; i2222 < len; ++i2222) {
      const child = list[i2222];
      if ("key" in child && equals22223(key, child.key)) {
        const value = child.value;
        const newValue2 = f2222(value);
        if (newValue2 === value) return list;
        if (isNone222223(newValue2)) {
          --size42222.value;
          return arraySpliceOut2223(mutate22222, i2222, list);
        }
        return arrayUpdate2223(mutate22222, i2222, new LeafNode2223(edit, hash222222, key, newValue2), list);
      }
    }
    const newValue = f2222(none222223());
    if (isNone222223(newValue)) return list;
    ++size42222.value;
    return arrayUpdate2223(mutate22222, len, new LeafNode2223(edit, hash222222, key, newValue), list);
  }
};
var IndexedNode2223 = class _IndexedNode2223 {
  edit;
  mask;
  children;
  _tag = "IndexedNode";
  constructor(edit, mask, children) {
    this.edit = edit;
    this.mask = mask;
    this.children = children;
  }
  modify(edit, shift22, f2222, hash222222, key, size42222) {
    const mask = this.mask;
    const children = this.children;
    const frag = hashFragment2223(shift22, hash222222);
    const bit = toBitmap2223(frag);
    const indx = fromBitmap2223(mask, bit);
    const exists222222 = mask & bit;
    const canEdit = canEditNode2223(this, edit);
    if (!exists222222) {
      const _newChild = new EmptyNode2223().modify(edit, shift22 + SIZE2223, f2222, hash222222, key, size42222);
      if (!_newChild) return this;
      return children.length >= MAX_INDEX_NODE2223 ? expand2223(edit, frag, _newChild, mask, children) : new _IndexedNode2223(edit, mask | bit, arraySpliceIn2223(canEdit, indx, _newChild, children));
    }
    const current = children[indx];
    const child = current.modify(edit, shift22 + SIZE2223, f2222, hash222222, key, size42222);
    if (current === child) return this;
    let bitmap = mask;
    let newChildren;
    if (isEmptyNode2223(child)) {
      bitmap &= ~bit;
      if (!bitmap) return new EmptyNode2223();
      if (children.length <= 2 && isLeafNode2223(children[indx ^ 1])) {
        return children[indx ^ 1];
      }
      newChildren = arraySpliceOut2223(canEdit, indx, children);
    } else {
      newChildren = arrayUpdate2223(canEdit, indx, child, children);
    }
    if (canEdit) {
      this.mask = bitmap;
      this.children = newChildren;
      return this;
    }
    return new _IndexedNode2223(edit, bitmap, newChildren);
  }
};
var ArrayNode2223 = class _ArrayNode2223 {
  edit;
  size;
  children;
  _tag = "ArrayNode";
  constructor(edit, size42222, children) {
    this.edit = edit;
    this.size = size42222;
    this.children = children;
  }
  modify(edit, shift22, f2222, hash222222, key, size42222) {
    let count = this.size;
    const children = this.children;
    const frag = hashFragment2223(shift22, hash222222);
    const child = children[frag];
    const newChild = (child || new EmptyNode2223()).modify(edit, shift22 + SIZE2223, f2222, hash222222, key, size42222);
    if (child === newChild) return this;
    const canEdit = canEditNode2223(this, edit);
    let newChildren;
    if (isEmptyNode2223(child) && !isEmptyNode2223(newChild)) {
      ++count;
      newChildren = arrayUpdate2223(canEdit, frag, newChild, children);
    } else if (!isEmptyNode2223(child) && isEmptyNode2223(newChild)) {
      --count;
      if (count <= MIN_ARRAY_NODE2223) {
        return pack2223(edit, count, frag, children);
      }
      newChildren = arrayUpdate2223(canEdit, frag, new EmptyNode2223(), children);
    } else {
      newChildren = arrayUpdate2223(canEdit, frag, newChild, children);
    }
    if (canEdit) {
      this.size = count;
      this.children = newChildren;
      return this;
    }
    return new _ArrayNode2223(edit, count, newChildren);
  }
};
function pack2223(edit, count, removed, elements) {
  const children = new Array(count - 1);
  let g2222 = 0;
  let bitmap = 0;
  for (let i2222 = 0, len = elements.length; i2222 < len; ++i2222) {
    if (i2222 !== removed) {
      const elem = elements[i2222];
      if (elem && !isEmptyNode2223(elem)) {
        children[g2222++] = elem;
        bitmap |= 1 << i2222;
      }
    }
  }
  return new IndexedNode2223(edit, bitmap, children);
}
function expand2223(edit, frag, child, bitmap, subNodes) {
  const arr = [];
  let bit = bitmap;
  let count = 0;
  for (let i2222 = 0; bit; ++i2222) {
    if (bit & 1) arr[i2222] = subNodes[count++];
    bit >>>= 1;
  }
  arr[frag] = child;
  return new ArrayNode2223(edit, count + 1, arr);
}
function mergeLeavesInner2223(edit, shift22, h1, n1, h2222, n2222) {
  if (h1 === h2222) return new CollisionNode2223(edit, h1, [n2222, n1]);
  const subH1 = hashFragment2223(shift22, h1);
  const subH2 = hashFragment2223(shift22, h2222);
  if (subH1 === subH2) {
    return (child) => new IndexedNode2223(edit, toBitmap2223(subH1) | toBitmap2223(subH2), [child]);
  } else {
    const children = subH1 < subH2 ? [n1, n2222] : [n2222, n1];
    return new IndexedNode2223(edit, toBitmap2223(subH1) | toBitmap2223(subH2), children);
  }
}
function mergeLeaves2223(edit, shift22, h1, n1, h2222, n2222) {
  let stack = void 0;
  let currentShift = shift22;
  while (true) {
    const res = mergeLeavesInner2223(edit, currentShift, h1, n1, h2222, n2222);
    if (typeof res === "function") {
      stack = make52223(res, stack);
      currentShift = currentShift + SIZE2223;
    } else {
      let final = res;
      while (stack != null) {
        final = stack.value(final);
        stack = stack.previous;
      }
      return final;
    }
  }
}
var HashMapSymbolKey2223 = "effect/HashMap";
var HashMapTypeId2223 = /* @__PURE__ */ Symbol.for(HashMapSymbolKey2223);
var HashMapProto2223 = {
  [HashMapTypeId2223]: HashMapTypeId2223,
  [Symbol.iterator]() {
    return new HashMapIterator2223(this, (k2222, v2222) => [k2222, v2222]);
  },
  [symbol32223]() {
    let hash222222 = hash22223(HashMapSymbolKey2223);
    for (const item of this) {
      hash222222 ^= pipe22223(hash22223(item[0]), combine22225(hash22223(item[1])));
    }
    return cached22223(this, hash222222);
  },
  [symbol222223](that) {
    if (isHashMap2223(that)) {
      if (that._size !== this._size) {
        return false;
      }
      for (const item of this) {
        const elem = pipe22223(that, getHash2223(item[0], hash22223(item[0])));
        if (isNone222223(elem)) {
          return false;
        } else {
          if (!equals22223(item[1], elem.value)) {
            return false;
          }
        }
      }
      return true;
    }
    return false;
  },
  toString() {
    return format22223(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashMap",
      values: Array.from(this).map(toJSON22223)
    };
  },
  [NodeInspectSymbol22223]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments22223(this, arguments);
  }
};
var makeImpl3223 = (editable, edit, root, size42222) => {
  const map622 = Object.create(HashMapProto2223);
  map622._editable = editable;
  map622._edit = edit;
  map622._root = root;
  map622._size = size42222;
  return map622;
};
var HashMapIterator2223 = class _HashMapIterator2223 {
  map;
  f;
  v;
  constructor(map622, f2222) {
    this.map = map622;
    this.f = f2222;
    this.v = visitLazy2223(this.map._root, this.f, void 0);
  }
  next() {
    if (isNone222223(this.v)) {
      return {
        done: true,
        value: void 0
      };
    }
    const v0 = this.v.value;
    this.v = applyCont2223(v0.cont);
    return {
      done: false,
      value: v0.value
    };
  }
  [Symbol.iterator]() {
    return new _HashMapIterator2223(this.map, this.f);
  }
};
var applyCont2223 = (cont) => cont ? visitLazyChildren2223(cont[0], cont[1], cont[2], cont[3], cont[4]) : none222223();
var visitLazy2223 = (node, f2222, cont = void 0) => {
  switch (node._tag) {
    case "LeafNode": {
      if (isSome222223(node.value)) {
        return some322223({
          value: f2222(node.key, node.value.value),
          cont
        });
      }
      return applyCont2223(cont);
    }
    case "CollisionNode":
    case "ArrayNode":
    case "IndexedNode": {
      const children = node.children;
      return visitLazyChildren2223(children.length, children, 0, f2222, cont);
    }
    default: {
      return applyCont2223(cont);
    }
  }
};
var visitLazyChildren2223 = (len, children, i2222, f2222, cont) => {
  while (i2222 < len) {
    const child = children[i2222++];
    if (child && !isEmptyNode2223(child)) {
      return visitLazy2223(child, f2222, [len, children, i2222, f2222, cont]);
    }
  }
  return applyCont2223(cont);
};
var _empty32223 = /* @__PURE__ */ makeImpl3223(false, 0, /* @__PURE__ */ new EmptyNode2223(), 0);
var empty42223 = () => _empty32223;
var isHashMap2223 = (u2222) => hasProperty22223(u2222, HashMapTypeId2223);
var getHash2223 = /* @__PURE__ */ dual22223(3, (self2, key, hash222222) => {
  let node = self2._root;
  let shift22 = 0;
  while (true) {
    switch (node._tag) {
      case "LeafNode": {
        return equals22223(key, node.key) ? node.value : none222223();
      }
      case "CollisionNode": {
        if (hash222222 === node.hash) {
          const children = node.children;
          for (let i2222 = 0, len = children.length; i2222 < len; ++i2222) {
            const child = children[i2222];
            if ("key" in child && equals22223(key, child.key)) {
              return child.value;
            }
          }
        }
        return none222223();
      }
      case "IndexedNode": {
        const frag = hashFragment2223(shift22, hash222222);
        const bit = toBitmap2223(frag);
        if (node.mask & bit) {
          node = node.children[fromBitmap2223(node.mask, bit)];
          shift22 += SIZE2223;
          break;
        }
        return none222223();
      }
      case "ArrayNode": {
        node = node.children[hashFragment2223(shift22, hash222222)];
        if (node) {
          shift22 += SIZE2223;
          break;
        }
        return none222223();
      }
      default:
        return none222223();
    }
  }
});
var set22223 = /* @__PURE__ */ dual22223(3, (self2, key, value) => modifyAt2223(self2, key, () => some322223(value)));
var setTree2223 = /* @__PURE__ */ dual22223(3, (self2, newRoot, newSize) => {
  if (self2._editable) {
    self2._root = newRoot;
    self2._size = newSize;
    return self2;
  }
  return newRoot === self2._root ? self2 : makeImpl3223(self2._editable, self2._edit, newRoot, newSize);
});
var keys35 = (self2) => new HashMapIterator2223(self2, (key) => key);
var size4223 = (self2) => self2._size;
var beginMutation3223 = (self2) => makeImpl3223(true, self2._edit + 1, self2._root, self2._size);
var modifyAt2223 = /* @__PURE__ */ dual22223(3, (self2, key, f2222) => modifyHash2223(self2, key, hash22223(key), f2222));
var modifyHash2223 = /* @__PURE__ */ dual22223(4, (self2, key, hash222222, f2222) => {
  const size42222 = {
    value: self2._size
  };
  const newRoot = self2._root.modify(self2._editable ? self2._edit : NaN, 0, f2222, hash222222, key, size42222);
  return pipe22223(self2, setTree2223(newRoot, size42222.value));
});
var forEach45 = /* @__PURE__ */ dual22223(2, (self2, f2222) => reduce22223(self2, void 0, (_2222, value, key) => f2222(value, key)));
var reduce22223 = /* @__PURE__ */ dual22223(3, (self2, zero, f2222) => {
  const root = self2._root;
  if (root._tag === "LeafNode") {
    return isSome222223(root.value) ? f2222(zero, root.value.value, root.key) : zero;
  }
  if (root._tag === "EmptyNode") {
    return zero;
  }
  const toVisit = [root.children];
  let children;
  while (children = toVisit.pop()) {
    for (let i2222 = 0, len = children.length; i2222 < len; ) {
      const child = children[i2222++];
      if (child && !isEmptyNode2223(child)) {
        if (child._tag === "LeafNode") {
          if (isSome222223(child.value)) {
            zero = f2222(zero, child.value.value, child.key);
          }
        } else {
          toVisit.push(child.children);
        }
      }
    }
  }
  return zero;
});
var HashSetSymbolKey2223 = "effect/HashSet";
var HashSetTypeId2223 = /* @__PURE__ */ Symbol.for(HashSetSymbolKey2223);
var HashSetProto2223 = {
  [HashSetTypeId2223]: HashSetTypeId2223,
  [Symbol.iterator]() {
    return keys35(this._keyMap);
  },
  [symbol32223]() {
    return cached22223(this, combine22225(hash22223(this._keyMap))(hash22223(HashSetSymbolKey2223)));
  },
  [symbol222223](that) {
    if (isHashSet2223(that)) {
      return size4223(this._keyMap) === size4223(that._keyMap) && equals22223(this._keyMap, that._keyMap);
    }
    return false;
  },
  toString() {
    return format22223(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashSet",
      values: Array.from(this).map(toJSON22223)
    };
  },
  [NodeInspectSymbol22223]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments22223(this, arguments);
  }
};
var makeImpl22223 = (keyMap) => {
  const set222222 = Object.create(HashSetProto2223);
  set222222._keyMap = keyMap;
  return set222222;
};
var isHashSet2223 = (u2222) => hasProperty22223(u2222, HashSetTypeId2223);
var _empty42223 = /* @__PURE__ */ makeImpl22223(/* @__PURE__ */ empty42223());
var empty52223 = () => _empty42223;
var size22223 = (self2) => size4223(self2._keyMap);
var beginMutation22223 = (self2) => makeImpl22223(beginMutation3223(self2._keyMap));
var endMutation2223 = (self2) => {
  self2._keyMap._editable = false;
  return self2;
};
var mutate2223 = /* @__PURE__ */ dual22223(2, (self2, f2222) => {
  const transient = beginMutation22223(self2);
  f2222(transient);
  return endMutation2223(transient);
});
var add22223 = /* @__PURE__ */ dual22223(2, (self2, value) => self2._keyMap._editable ? (set22223(value, true)(self2._keyMap), self2) : makeImpl22223(set22223(value, true)(self2._keyMap)));
var union22223 = /* @__PURE__ */ dual22223(2, (self2, that) => mutate2223(empty52223(), (set222222) => {
  forEach22223(self2, (value) => add22223(set222222, value));
  for (const value of that) {
    add22223(set222222, value);
  }
}));
var forEach22223 = /* @__PURE__ */ dual22223(2, (self2, f2222) => forEach45(self2._keyMap, (_2222, k2222) => f2222(k2222)));
var empty62223 = empty52223;
var size32223 = size22223;
var add32223 = add22223;
var union32223 = union22223;
var ArrayProto2223 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(Array.prototype), {
  [symbol32223]() {
    return cached22223(this, array55(this));
  },
  [symbol222223](that) {
    if (Array.isArray(that) && this.length === that.length) {
      return this.every((v2222, i2222) => equals22223(v2222, that[i2222]));
    } else {
      return false;
    }
  }
});
var Structural3223 = /* @__PURE__ */ function() {
  function Structural32222(args) {
    if (args) {
      Object.assign(this, args);
    }
  }
  Structural32222.prototype = StructuralPrototype2223;
  return Structural32222;
}();
var struct22223 = (as222222) => Object.assign(Object.create(StructuralPrototype2223), as222222);
var ContextPatchTypeId2223 = /* @__PURE__ */ Symbol.for("effect/DifferContextPatch");
function variance3223(a2222) {
  return a2222;
}
var PatchProto2223 = {
  ...Structural3223.prototype,
  [ContextPatchTypeId2223]: {
    _Value: variance3223,
    _Patch: variance3223
  }
};
var EmptyProto2223 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto2223), {
  _tag: "Empty"
});
var _empty52223 = /* @__PURE__ */ Object.create(EmptyProto2223);
var empty72223 = () => _empty52223;
var AndThenProto2223 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto2223), {
  _tag: "AndThen"
});
var makeAndThen2223 = (first, second) => {
  const o2222 = Object.create(AndThenProto2223);
  o2222.first = first;
  o2222.second = second;
  return o2222;
};
var AddServiceProto2223 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto2223), {
  _tag: "AddService"
});
var makeAddService2223 = (key, service) => {
  const o2222 = Object.create(AddServiceProto2223);
  o2222.key = key;
  o2222.service = service;
  return o2222;
};
var RemoveServiceProto2223 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto2223), {
  _tag: "RemoveService"
});
var makeRemoveService2223 = (key) => {
  const o2222 = Object.create(RemoveServiceProto2223);
  o2222.key = key;
  return o2222;
};
var UpdateServiceProto2223 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto2223), {
  _tag: "UpdateService"
});
var makeUpdateService2223 = (key, update222) => {
  const o2222 = Object.create(UpdateServiceProto2223);
  o2222.key = key;
  o2222.update = update222;
  return o2222;
};
var diff2223 = (oldValue, newValue) => {
  const missingServices = new Map(oldValue.unsafeMap);
  let patch22222 = empty72223();
  for (const [tag, newService] of newValue.unsafeMap.entries()) {
    if (missingServices.has(tag)) {
      const old = missingServices.get(tag);
      missingServices.delete(tag);
      if (!equals22223(old, newService)) {
        patch22222 = combine222223(makeUpdateService2223(tag, () => newService))(patch22222);
      }
    } else {
      missingServices.delete(tag);
      patch22222 = combine222223(makeAddService2223(tag, newService))(patch22222);
    }
  }
  for (const [tag] of missingServices.entries()) {
    patch22222 = combine222223(makeRemoveService2223(tag))(patch22222);
  }
  return patch22222;
};
var combine222223 = /* @__PURE__ */ dual22223(2, (self2, that) => makeAndThen2223(self2, that));
var patch2223 = /* @__PURE__ */ dual22223(2, (self2, context) => {
  if (self2._tag === "Empty") {
    return context;
  }
  let wasServiceUpdated = false;
  let patches = of35(self2);
  const updatedContext = new Map(context.unsafeMap);
  while (isNonEmpty2223(patches)) {
    const head222 = headNonEmpty35(patches);
    const tail222 = tailNonEmpty35(patches);
    switch (head222._tag) {
      case "Empty": {
        patches = tail222;
        break;
      }
      case "AddService": {
        updatedContext.set(head222.key, head222.service);
        patches = tail222;
        break;
      }
      case "AndThen": {
        patches = prepend35(prepend35(tail222, head222.second), head222.first);
        break;
      }
      case "RemoveService": {
        updatedContext.delete(head222.key);
        patches = tail222;
        break;
      }
      case "UpdateService": {
        updatedContext.set(head222.key, head222.update(updatedContext.get(head222.key)));
        wasServiceUpdated = true;
        patches = tail222;
        break;
      }
    }
  }
  if (!wasServiceUpdated) {
    return makeContext2223(updatedContext);
  }
  const map622 = /* @__PURE__ */ new Map();
  for (const [tag] of context.unsafeMap) {
    if (updatedContext.has(tag)) {
      map622.set(tag, updatedContext.get(tag));
      updatedContext.delete(tag);
    }
  }
  for (const [tag, s2222] of updatedContext) {
    map622.set(tag, s2222);
  }
  return makeContext2223(map622);
});
var DifferTypeId2223 = /* @__PURE__ */ Symbol.for("effect/Differ");
var DifferProto2223 = {
  [DifferTypeId2223]: {
    _P: identity22223,
    _V: identity22223
  }
};
var make72223 = (params) => {
  const differ = Object.create(DifferProto2223);
  differ.empty = params.empty;
  differ.diff = params.diff;
  differ.combine = params.combine;
  differ.patch = params.patch;
  return differ;
};
var environment2223 = () => make72223({
  empty: empty72223(),
  combine: (first, second) => combine222223(second)(first),
  diff: (oldValue, newValue) => diff2223(oldValue, newValue),
  patch: (patch22222, oldValue) => patch2223(oldValue)(patch22222)
});
var OP_DIE2223 = "Die";
var OP_EMPTY2223 = "Empty";
var OP_FAIL2223 = "Fail";
var OP_INTERRUPT2223 = "Interrupt";
var OP_PARALLEL2223 = "Parallel";
var OP_SEQUENTIAL2223 = "Sequential";
var CauseSymbolKey2223 = "effect/Cause";
var CauseTypeId2223 = /* @__PURE__ */ Symbol.for(CauseSymbolKey2223);
var variance22223 = {
  /* c8 ignore next */
  _E: (_2222) => _2222
};
var proto2223 = {
  [CauseTypeId2223]: variance22223,
  [symbol32223]() {
    return pipe22223(hash22223(CauseSymbolKey2223), combine22225(hash22223(flattenCause2223(this))), cached22223(this));
  },
  [symbol222223](that) {
    return isCause2223(that) && causeEquals2223(this, that);
  },
  pipe() {
    return pipeArguments22223(this, arguments);
  },
  toJSON() {
    switch (this._tag) {
      case "Empty":
        return {
          _id: "Cause",
          _tag: this._tag
        };
      case "Die":
        return {
          _id: "Cause",
          _tag: this._tag,
          defect: toJSON22223(this.defect)
        };
      case "Interrupt":
        return {
          _id: "Cause",
          _tag: this._tag,
          fiberId: this.fiberId.toJSON()
        };
      case "Fail":
        return {
          _id: "Cause",
          _tag: this._tag,
          failure: toJSON22223(this.error)
        };
      case "Sequential":
      case "Parallel":
        return {
          _id: "Cause",
          _tag: this._tag,
          left: toJSON22223(this.left),
          right: toJSON22223(this.right)
        };
    }
  },
  toString() {
    return pretty2223(this);
  },
  [NodeInspectSymbol22223]() {
    return this.toJSON();
  }
};
var fail3223 = (error) => {
  const o2222 = Object.create(proto2223);
  o2222._tag = OP_FAIL2223;
  o2222.error = error;
  return o2222;
};
var parallel2223 = (left32222, right32222) => {
  const o2222 = Object.create(proto2223);
  o2222._tag = OP_PARALLEL2223;
  o2222.left = left32222;
  o2222.right = right32222;
  return o2222;
};
var sequential2223 = (left32222, right32222) => {
  const o2222 = Object.create(proto2223);
  o2222._tag = OP_SEQUENTIAL2223;
  o2222.left = left32222;
  o2222.right = right32222;
  return o2222;
};
var isCause2223 = (u2222) => hasProperty22223(u2222, CauseTypeId2223);
var isInterruptedOnly2223 = (self2) => reduceWithContext2223(void 0, IsInterruptedOnlyCauseReducer2223)(self2);
var causeEquals2223 = (left32222, right32222) => {
  let leftStack = of35(left32222);
  let rightStack = of35(right32222);
  while (isNonEmpty2223(leftStack) && isNonEmpty2223(rightStack)) {
    const [leftParallel, leftSequential] = pipe22223(headNonEmpty35(leftStack), reduce42223([empty62223(), empty32223()], ([parallel22222, sequential22222], cause) => {
      const [par, seq] = evaluateCause2223(cause);
      return some322223([pipe22223(parallel22222, union32223(par)), pipe22223(sequential22222, appendAll35(seq))]);
    }));
    const [rightParallel, rightSequential] = pipe22223(headNonEmpty35(rightStack), reduce42223([empty62223(), empty32223()], ([parallel22222, sequential22222], cause) => {
      const [par, seq] = evaluateCause2223(cause);
      return some322223([pipe22223(parallel22222, union32223(par)), pipe22223(sequential22222, appendAll35(seq))]);
    }));
    if (!equals22223(leftParallel, rightParallel)) {
      return false;
    }
    leftStack = leftSequential;
    rightStack = rightSequential;
  }
  return true;
};
var flattenCause2223 = (cause) => {
  return flattenCauseLoop2223(of35(cause), empty32223());
};
var flattenCauseLoop2223 = (causes, flattened) => {
  while (1) {
    const [parallel22222, sequential22222] = pipe22223(causes, reduce55([empty62223(), empty32223()], ([parallel322, sequential322], cause) => {
      const [par, seq] = evaluateCause2223(cause);
      return [pipe22223(parallel322, union32223(par)), pipe22223(sequential322, appendAll35(seq))];
    }));
    const updated = size32223(parallel22222) > 0 ? pipe22223(flattened, prepend35(parallel22222)) : flattened;
    if (isEmpty2223(sequential22222)) {
      return reverse22223(updated);
    }
    causes = sequential22222;
    flattened = updated;
  }
  throw new Error(getBugErrorMessage22223("Cause.flattenCauseLoop"));
};
var evaluateCause2223 = (self2) => {
  let cause = self2;
  const stack = [];
  let _parallel = empty62223();
  let _sequential = empty32223();
  while (cause !== void 0) {
    switch (cause._tag) {
      case OP_EMPTY2223: {
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_FAIL2223: {
        _parallel = add32223(_parallel, make422223(cause._tag, cause.error));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_DIE2223: {
        _parallel = add32223(_parallel, make422223(cause._tag, cause.defect));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_INTERRUPT2223: {
        _parallel = add32223(_parallel, make422223(cause._tag, cause.fiberId));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_SEQUENTIAL2223: {
        switch (cause.left._tag) {
          case OP_EMPTY2223: {
            cause = cause.right;
            break;
          }
          case OP_SEQUENTIAL2223: {
            cause = sequential2223(cause.left.left, sequential2223(cause.left.right, cause.right));
            break;
          }
          case OP_PARALLEL2223: {
            cause = parallel2223(sequential2223(cause.left.left, cause.right), sequential2223(cause.left.right, cause.right));
            break;
          }
          default: {
            _sequential = prepend35(_sequential, cause.right);
            cause = cause.left;
            break;
          }
        }
        break;
      }
      case OP_PARALLEL2223: {
        stack.push(cause.right);
        cause = cause.left;
        break;
      }
    }
  }
  throw new Error(getBugErrorMessage22223("Cause.evaluateCauseLoop"));
};
var IsInterruptedOnlyCauseReducer2223 = {
  emptyCase: constTrue22223,
  failCase: constFalse22223,
  dieCase: constFalse22223,
  interruptCase: constTrue22223,
  sequentialCase: (_2222, left32222, right32222) => left32222 && right32222,
  parallelCase: (_2222, left32222, right32222) => left32222 && right32222
};
var OP_SEQUENTIAL_CASE2223 = "SequentialCase";
var OP_PARALLEL_CASE2223 = "ParallelCase";
var reduce42223 = /* @__PURE__ */ dual22223(3, (self2, zero, pf) => {
  let accumulator = zero;
  let cause = self2;
  const causes = [];
  while (cause !== void 0) {
    const option = pf(accumulator, cause);
    accumulator = isSome222223(option) ? option.value : accumulator;
    switch (cause._tag) {
      case OP_SEQUENTIAL2223: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      case OP_PARALLEL2223: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      default: {
        cause = void 0;
        break;
      }
    }
    if (cause === void 0 && causes.length > 0) {
      cause = causes.pop();
    }
  }
  return accumulator;
});
var reduceWithContext2223 = /* @__PURE__ */ dual22223(3, (self2, context, reducer) => {
  const input = [self2];
  const output = [];
  while (input.length > 0) {
    const cause = input.pop();
    switch (cause._tag) {
      case OP_EMPTY2223: {
        output.push(right222223(reducer.emptyCase(context)));
        break;
      }
      case OP_FAIL2223: {
        output.push(right222223(reducer.failCase(context, cause.error)));
        break;
      }
      case OP_DIE2223: {
        output.push(right222223(reducer.dieCase(context, cause.defect)));
        break;
      }
      case OP_INTERRUPT2223: {
        output.push(right222223(reducer.interruptCase(context, cause.fiberId)));
        break;
      }
      case OP_SEQUENTIAL2223: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left222223({
          _tag: OP_SEQUENTIAL_CASE2223
        }));
        break;
      }
      case OP_PARALLEL2223: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left222223({
          _tag: OP_PARALLEL_CASE2223
        }));
        break;
      }
    }
  }
  const accumulator = [];
  while (output.length > 0) {
    const either = output.pop();
    switch (either._tag) {
      case "Left": {
        switch (either.left._tag) {
          case OP_SEQUENTIAL_CASE2223: {
            const left32222 = accumulator.pop();
            const right32222 = accumulator.pop();
            const value = reducer.sequentialCase(context, left32222, right32222);
            accumulator.push(value);
            break;
          }
          case OP_PARALLEL_CASE2223: {
            const left32222 = accumulator.pop();
            const right32222 = accumulator.pop();
            const value = reducer.parallelCase(context, left32222, right32222);
            accumulator.push(value);
            break;
          }
        }
        break;
      }
      case "Right": {
        accumulator.push(either.right);
        break;
      }
    }
  }
  if (accumulator.length === 0) {
    throw new Error("BUG: Cause.reduceWithContext - please report an issue at https://github.com/Effect-TS/effect/issues");
  }
  return accumulator.pop();
});
var pretty2223 = (cause) => {
  if (isInterruptedOnly2223(cause)) {
    return "All fibers interrupted without errors.";
  }
  return prettyErrors2223(cause).map((e2222) => e2222.stack).join("\n");
};
var PrettyError2223 = class extends globalThis.Error {
  span = void 0;
  constructor(originalError) {
    const prevLimit = Error.stackTraceLimit;
    Error.stackTraceLimit = 0;
    super(prettyErrorMessage2223(originalError));
    Error.stackTraceLimit = prevLimit;
    this.name = originalError instanceof Error ? originalError.name : "Error";
    if (typeof originalError === "object" && originalError !== null) {
      if (spanSymbol3223 in originalError) {
        this.span = originalError[spanSymbol3223];
      }
      Object.keys(originalError).forEach((key) => {
        if (!(key in this)) {
          this[key] = originalError[key];
        }
      });
    }
    this.stack = prettyErrorStack2223(this.message, originalError instanceof Error && originalError.stack ? originalError.stack : "", this.span);
  }
  toJSON() {
    const out = {
      message: this.message,
      stack: this.stack
    };
    if (this.span) {
      out.span = this.span;
    }
    return out;
  }
};
var prettyErrorMessage2223 = (u2222) => {
  if (typeof u2222 === "string") {
    return `Error: ${u2222}`;
  }
  try {
    if (hasProperty22223(u2222, "toString") && isFunction32223(u2222["toString"]) && u2222["toString"] !== Object.prototype.toString && u2222["toString"] !== globalThis.Array.prototype.toString) {
      return u2222["toString"]();
    }
  } catch {
  }
  return `Error: ${JSON.stringify(u2222)}`;
};
var locationRegex2223 = /\((.*)\)/;
var spanToTrace2223 = /* @__PURE__ */ globalValue22223("effect/Tracer/spanToTrace", () => /* @__PURE__ */ new WeakMap());
var prettyErrorStack2223 = (message, stack, span222) => {
  const out = [message];
  const lines = stack.split("\n");
  for (let i2222 = 1; i2222 < lines.length; i2222++) {
    if (lines[i2222].includes("Generator.next")) {
      break;
    }
    if (lines[i2222].includes("effect_internal_function")) {
      out.pop();
      break;
    }
    out.push(lines[i2222].replace(/at .*effect_instruction_i.*\((.*)\)/, "at $1").replace(/EffectPrimitive\.\w+/, "<anonymous>"));
  }
  if (span222) {
    let current = span222;
    let i2222 = 0;
    while (current && current._tag === "Span" && i2222 < 10) {
      const stackFn = spanToTrace2223.get(current);
      if (typeof stackFn === "function") {
        const stack2 = stackFn();
        const locationMatch = stack2.match(locationRegex2223);
        const location = locationMatch ? locationMatch[1] : stack2.replace(/^at /, "");
        out.push(`    at ${current.name} (${location})`);
      } else {
        out.push(`    at ${current.name}`);
      }
      current = getOrUndefined22223(current.parent);
      i2222++;
    }
  }
  return out.join("\n");
};
var spanSymbol3223 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var prettyErrors2223 = (cause) => reduceWithContext2223(cause, void 0, {
  emptyCase: () => [],
  dieCase: (_2222, unknownError) => {
    return [new PrettyError2223(unknownError)];
  },
  failCase: (_2222, error) => {
    return [new PrettyError2223(error)];
  },
  interruptCase: () => [],
  parallelCase: (_2222, l2222, r2222) => [...l2222, ...r2222],
  sequentialCase: (_2222, l2222, r2222) => [...l2222, ...r2222]
});
var SingleShotGen222223 = class _SingleShotGen22223 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  next(a2222) {
    return this.called ? {
      value: a2222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  return(a2222) {
    return {
      value: a2222,
      done: true
    };
  }
  throw(e2222) {
    throw e2222;
  }
  [Symbol.iterator]() {
    return new _SingleShotGen22223(this.self);
  }
};
var spanTag2223 = /* @__PURE__ */ GenericTag2223("effect/ParentSpan");
var EffectTypeId222223 = /* @__PURE__ */ Symbol.for("effect/Effect");
var EffectPrimitive2223 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId222223] = effectVariance22223;
  constructor(_op) {
    this._op = _op;
  }
  [symbol222223](that) {
    return this === that;
  }
  [symbol32223]() {
    return cached22223(this, random22223(this));
  }
  pipe() {
    return pipeArguments22223(this, arguments);
  }
  toJSON() {
    return {
      _id: "Effect",
      _op: this._op,
      effect_instruction_i0: toJSON22223(this.effect_instruction_i0),
      effect_instruction_i1: toJSON22223(this.effect_instruction_i1),
      effect_instruction_i2: toJSON22223(this.effect_instruction_i2)
    };
  }
  toString() {
    return format22223(this.toJSON());
  }
  [NodeInspectSymbol22223]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen222223(new YieldWrap22223(this));
  }
};
var EffectPrimitiveFailure2223 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId222223] = effectVariance22223;
  constructor(_op) {
    this._op = _op;
    this._tag = _op;
  }
  [symbol222223](that) {
    return exitIsExit2223(that) && that._op === "Failure" && // @ts-expect-error
    equals22223(this.effect_instruction_i0, that.effect_instruction_i0);
  }
  [symbol32223]() {
    return pipe22223(
      // @ts-expect-error
      string22223(this._tag),
      // @ts-expect-error
      combine22225(hash22223(this.effect_instruction_i0)),
      cached22223(this)
    );
  }
  get cause() {
    return this.effect_instruction_i0;
  }
  pipe() {
    return pipeArguments22223(this, arguments);
  }
  toJSON() {
    return {
      _id: "Exit",
      _tag: this._op,
      cause: this.cause.toJSON()
    };
  }
  toString() {
    return format22223(this.toJSON());
  }
  [NodeInspectSymbol22223]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen222223(new YieldWrap22223(this));
  }
};
var isEffect2223 = (u2222) => hasProperty22223(u2222, EffectTypeId222223);
var withFiberRuntime2223 = (withRuntime) => {
  const effect = new EffectPrimitive2223(OP_WITH_RUNTIME2223);
  effect.effect_instruction_i0 = withRuntime;
  return effect;
};
var spanSymbol22223 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var originalSymbol2223 = /* @__PURE__ */ Symbol.for("effect/OriginalAnnotation");
var capture2223 = (obj, span222) => {
  if (isSome222223(span222)) {
    return new Proxy(obj, {
      has(target, p2222) {
        return p2222 === spanSymbol22223 || p2222 === originalSymbol2223 || p2222 in target;
      },
      get(target, p2222) {
        if (p2222 === spanSymbol22223) {
          return span222.value;
        }
        if (p2222 === originalSymbol2223) {
          return obj;
        }
        return target[p2222];
      }
    });
  }
  return obj;
};
var fail22223 = (error) => isObject22223(error) && !(spanSymbol22223 in error) ? withFiberRuntime2223((fiber) => failCause2223(fail3223(capture2223(error, currentSpanFromFiber2223(fiber))))) : failCause2223(fail3223(error));
var failCause2223 = (cause) => {
  const effect = new EffectPrimitiveFailure2223(OP_FAILURE2223);
  effect.effect_instruction_i0 = cause;
  return effect;
};
var FiberRefSymbolKey2223 = "effect/FiberRef";
var FiberRefTypeId2223 = /* @__PURE__ */ Symbol.for(FiberRefSymbolKey2223);
var fiberRefVariance2223 = {
  /* c8 ignore next */
  _A: (_2222) => _2222
};
var fiberRefUnsafeMakeContext2223 = (initial) => {
  const differ = environment2223();
  return fiberRefUnsafeMakePatch2223(initial, {
    differ,
    fork: differ.empty
  });
};
var fiberRefUnsafeMakePatch2223 = (initial, options) => ({
  [FiberRefTypeId2223]: fiberRefVariance2223,
  initial,
  diff: (oldValue, newValue) => options.differ.diff(oldValue, newValue),
  combine: (first, second) => options.differ.combine(first, second),
  patch: (patch22222) => (oldValue) => options.differ.patch(patch22222, oldValue),
  fork: options.fork,
  join: options.join ?? ((_2222, n2222) => n2222),
  pipe() {
    return pipeArguments22223(this, arguments);
  }
});
var currentContext2223 = /* @__PURE__ */ globalValue22223(/* @__PURE__ */ Symbol.for("effect/FiberRef/currentContext"), () => fiberRefUnsafeMakeContext2223(empty22223()));
var YieldableError2223 = /* @__PURE__ */ function() {
  class YieldableError22222 extends globalThis.Error {
    commit() {
      return fail22223(this);
    }
    toString() {
      return this.message ? `${this.name}: ${this.message}` : this.name;
    }
    toJSON() {
      return {
        ...this
      };
    }
    [NodeInspectSymbol22223]() {
      const stack = this.stack;
      if (stack) {
        return `${this.toString()}
${stack.split("\n").slice(1).join("\n")}`;
      }
      return this.toString();
    }
  }
  Object.assign(YieldableError22222.prototype, StructuralCommitPrototype2223);
  return YieldableError22222;
}();
var exitIsExit2223 = (u2222) => isEffect2223(u2222) && "_tag" in u2222 && (u2222._tag === "Success" || u2222._tag === "Failure");
var currentSpanFromFiber2223 = (fiber) => {
  const span222 = fiber.getFiberRef(currentContext2223).unsafeMap.get(spanTag2223.key);
  return span222 !== void 0 && span222._tag === "Span" ? some322223(span222) : none222223();
};
var Data_exports2223 = {};
__export22225(Data_exports2223, {
  Class: () => Class22223,
  Error: () => Error22223,
  Structural: () => Structural22223,
  TaggedClass: () => TaggedClass2223,
  TaggedError: () => TaggedError2223,
  array: () => array22223,
  case: () => _case2223,
  struct: () => struct32223,
  tagged: () => tagged2223,
  taggedEnum: () => taggedEnum2223,
  tuple: () => tuple22223,
  unsafeArray: () => unsafeArray2223,
  unsafeStruct: () => unsafeStruct2223
});
var struct32223 = struct22223;
var unsafeStruct2223 = (as222222) => Object.setPrototypeOf(as222222, StructuralPrototype2223);
var tuple22223 = (...as222222) => unsafeArray2223(as222222);
var array22223 = (as222222) => unsafeArray2223(as222222.slice(0));
var unsafeArray2223 = (as222222) => Object.setPrototypeOf(as222222, ArrayProto2223);
var _case2223 = () => (args) => args === void 0 ? Object.create(StructuralPrototype2223) : struct32223(args);
var tagged2223 = (tag) => (args) => {
  const value = args === void 0 ? Object.create(StructuralPrototype2223) : struct32223(args);
  value._tag = tag;
  return value;
};
var Class22223 = Structural3223;
var TaggedClass2223 = (tag) => {
  class Base extends Class22223 {
    _tag = tag;
  }
  return Base;
};
var Structural22223 = Structural3223;
var taggedEnum2223 = () => new Proxy({}, {
  get(_target, tag, _receiver) {
    if (tag === "$is") {
      return isTagged35;
    } else if (tag === "$match") {
      return taggedMatch2223;
    }
    return tagged2223(tag);
  }
});
function taggedMatch2223() {
  if (arguments.length === 1) {
    const cases2 = arguments[0];
    return function(value2) {
      return cases2[value2._tag](value2);
    };
  }
  const value = arguments[0];
  const cases = arguments[1];
  return cases[value._tag](value);
}
var Error22223 = /* @__PURE__ */ function() {
  return class Base extends YieldableError2223 {
    constructor(args) {
      super();
      if (args) {
        Object.assign(this, args);
      }
    }
  };
}();
var TaggedError2223 = (tag) => {
  class Base extends Error22223 {
    _tag = tag;
  }
  Base.prototype.name = tag;
  return Base;
};
var traverseUp2223 = Function_exports22223.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType2223.Program) return Option_exports22223.none();
  return predicate(parent) ? Option_exports22223.some(parent) : traverseUp2223(parent, predicate);
});
var traverseUpGuard2223 = Function_exports22223.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType2223.Program) return Option_exports22223.none();
  return predicate(parent) ? Option_exports22223.some(parent) : traverseUpGuard2223(parent, predicate);
});
var ESLintCommunityESLintUtils2223;
((ESLintCommunityESLintUtils22222) => {
  ESLintCommunityESLintUtils22222.getFunctionHeadLocation = getFunctionHeadLocation2223;
  ESLintCommunityESLintUtils22222.getFunctionNameWithKind = getFunctionNameWithKind2223;
  ESLintCommunityESLintUtils22222.getPropertyName = getPropertyName2223;
  ESLintCommunityESLintUtils22222.getStaticValue = getStaticValue2223;
  ESLintCommunityESLintUtils22222.getStringIfConstant = getStringIfConstant2223;
  ESLintCommunityESLintUtils22222.hasSideEffect = hasSideEffect2223;
  ESLintCommunityESLintUtils22222.isParenthesized = isParenthesized2223;
})(ESLintCommunityESLintUtils2223 || (ESLintCommunityESLintUtils2223 = {}));
var Construction2223 = Data_exports2223.taggedEnum();
Construction2223.None();
a25({
  type: N25.union([NodeType2223.FunctionExpression, NodeType2223.ArrowFunctionExpression]),
  parent: {
    type: NodeType2223.Property,
    parent: {
      type: NodeType2223.ObjectExpression
    }
  }
});
a25({
  type: N25.union([NodeType2223.FunctionExpression, NodeType2223.ArrowFunctionExpression]),
  parent: {
    type: NodeType2223.MethodDefinition,
    parent: {
      type: NodeType2223.ClassBody
    }
  }
});
a25({
  type: N25.union([NodeType2223.FunctionExpression, NodeType2223.ArrowFunctionExpression]),
  parent: {
    type: NodeType2223.Property,
    parent: {
      type: NodeType2223.ClassBody
    }
  }
});
function getVariableInit5(at) {
  return (variable) => {
    return Function_exports35.pipe(
      Option_exports35.some(variable),
      Option_exports35.flatMapNullable((v2222) => v2222.defs.at(at)),
      Option_exports35.flatMap(
        (d2222) => "init" in d2222.node ? Option_exports35.fromNullable(d2222.node.init) : Option_exports35.none()
      )
    );
  };
}
isOneOf225([NodeType225.Literal, NodeType225.JSXText]);
var JSXValueHint = {
  None: 0n,
  SkipNullLiteral: 1n << 0n,
  SkipUndefinedLiteral: 1n << 1n,
  SkipBooleanLiteral: 1n << 2n,
  SkipStringLiteral: 1n << 3n,
  SkipNumberLiteral: 1n << 4n,
  SkipCreateElement: 1n << 5n,
  StrictArray: 1n << 6n,
  StrictLogical: 1n << 7n,
  StrictConditional: 1n << 8n
};
var DEFAULT_JSX_VALUE_HINT = JSXValueHint.SkipUndefinedLiteral | JSXValueHint.SkipBooleanLiteral;
function isJSXValue2(node, context, hint = DEFAULT_JSX_VALUE_HINT) {
  if (!node) return false;
  return $4(node).with({ type: NodeType225.JSXElement }, Function_exports2225.constTrue).with({ type: NodeType225.JSXFragment }, Function_exports2225.constTrue).with({ type: NodeType225.JSXMemberExpression }, Function_exports2225.constTrue).with({ type: NodeType225.JSXNamespacedName }, Function_exports2225.constTrue).with({ type: NodeType225.Literal }, (node2) => {
    return $4(node2.value).with(null, () => !(hint & JSXValueHint.SkipNullLiteral)).with(N7.boolean, () => !(hint & JSXValueHint.SkipBooleanLiteral)).with(N7.string, () => !(hint & JSXValueHint.SkipStringLiteral)).with(N7.number, () => !(hint & JSXValueHint.SkipNumberLiteral)).otherwise(Function_exports2225.constFalse);
  }).with({ type: NodeType225.TemplateLiteral }, () => !(hint & JSXValueHint.SkipStringLiteral)).with({ type: NodeType225.ArrayExpression }, (node2) => {
    if (hint & JSXValueHint.StrictArray) return node2.elements.every((n2222) => isJSXValue2(n2222, context, hint));
    return node2.elements.some((n2222) => isJSXValue2(n2222, context, hint));
  }).with({ type: NodeType225.ConditionalExpression }, (node2) => {
    function leftHasJSX(node3) {
      if (Array.isArray(node3.consequent)) {
        if (hint & JSXValueHint.StrictArray) {
          return node3.consequent.every((n2222) => isJSXValue2(n2222, context, hint));
        }
        return node3.consequent.some((n2222) => isJSXValue2(n2222, context, hint));
      }
      return isJSXValue2(node3.consequent, context, hint);
    }
    function rightHasJSX(node3) {
      return isJSXValue2(node3.alternate, context, hint);
    }
    if (hint & JSXValueHint.StrictConditional) {
      return leftHasJSX(node2) && rightHasJSX(node2);
    }
    return leftHasJSX(node2) || rightHasJSX(node2);
  }).with({ type: NodeType225.LogicalExpression }, (node2) => {
    return isJSXValue2(node2.left, context, hint) || isJSXValue2(node2.right, context, hint);
  }).with({ type: NodeType225.SequenceExpression }, (node2) => {
    const exp = node2.expressions.at(-1);
    return isJSXValue2(exp, context, hint);
  }).with({ type: NodeType225.CallExpression }, (node2) => {
    if (hint & JSXValueHint.SkipCreateElement) return false;
    return $4(node2.callee).with({ type: NodeType225.Identifier, name: "createElement" }, Function_exports2225.constTrue).with({ type: NodeType225.MemberExpression, property: { name: "createElement" } }, Function_exports2225.constTrue).otherwise(Function_exports2225.constFalse);
  }).with({ type: NodeType225.Identifier }, (node2) => {
    const { name: name22 } = node2;
    if (name22 === "undefined") return !(hint & JSXValueHint.SkipUndefinedLiteral);
    if (isJSXTagNameExpression2(node2)) return true;
    const initialScope = context.sourceCode.getScope(node2);
    const maybeVariable = findVariable2224(name22, initialScope);
    return Function_exports2225.pipe(
      maybeVariable,
      Option_exports2225.flatMap(getVariableInit5(0)),
      Option_exports2225.exists((n2222) => isJSXValue2(n2222, context, hint))
    );
  }).otherwise(Function_exports2225.constFalse);
}
var Function_exports45 = {};
__export35(Function_exports45, {
  SK: () => SK45,
  absurd: () => absurd45,
  apply: () => apply45,
  compose: () => compose65,
  constFalse: () => constFalse45,
  constNull: () => constNull45,
  constTrue: () => constTrue45,
  constUndefined: () => constUndefined45,
  constVoid: () => constVoid45,
  constant: () => constant45,
  dual: () => dual45,
  flip: () => flip45,
  flow: () => flow45,
  hole: () => hole45,
  identity: () => identity45,
  isFunction: () => isFunction74,
  pipe: () => pipe45,
  satisfies: () => satisfies45,
  tupled: () => tupled45,
  unsafeCoerce: () => unsafeCoerce45,
  untupled: () => untupled45
});
var isFunction74 = (input) => typeof input === "function";
var dual45 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a322, b322) {
        if (arguments.length >= 2) {
          return body(a322, b322);
        }
        return function(self2) {
          return body(self2, a322);
        };
      };
    case 3:
      return function(a322, b322, c322) {
        if (arguments.length >= 3) {
          return body(a322, b322, c322);
        }
        return function(self2) {
          return body(self2, a322, b322);
        };
      };
    case 4:
      return function(a322, b322, c322, d322) {
        if (arguments.length >= 4) {
          return body(a322, b322, c322, d322);
        }
        return function(self2) {
          return body(self2, a322, b322, c322);
        };
      };
    case 5:
      return function(a322, b322, c322, d322, e322) {
        if (arguments.length >= 5) {
          return body(a322, b322, c322, d322, e322);
        }
        return function(self2) {
          return body(self2, a322, b322, c322, d322);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply45 = (a322) => (self2) => self2(a322);
var identity45 = (a322) => a322;
var satisfies45 = () => (b322) => b322;
var unsafeCoerce45 = identity45;
var constant45 = (value) => () => value;
var constTrue45 = /* @__PURE__ */ constant45(true);
var constFalse45 = /* @__PURE__ */ constant45(false);
var constNull45 = /* @__PURE__ */ constant45(null);
var constUndefined45 = /* @__PURE__ */ constant45(void 0);
var constVoid45 = constUndefined45;
var flip45 = (f322) => (...b322) => (...a322) => f322(...a322)(...b322);
var compose65 = /* @__PURE__ */ dual45(2, (ab, bc) => (a322) => bc(ab(a322)));
var absurd45 = (_322) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled45 = (f322) => (a322) => f322(...a322);
var untupled45 = (f322) => (...a322) => f322(a322);
function pipe45(a322, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a322;
    case 2:
      return ab(a322);
    case 3:
      return bc(ab(a322));
    case 4:
      return cd(bc(ab(a322)));
    case 5:
      return de(cd(bc(ab(a322))));
    case 6:
      return ef(de(cd(bc(ab(a322)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a322))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a322)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a322))))))));
    default: {
      let ret = arguments[0];
      for (let i322 = 1; i322 < arguments.length; i322++) {
        ret = arguments[i322](ret);
      }
      return ret;
    }
  }
}
function flow45(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole45 = /* @__PURE__ */ unsafeCoerce45(absurd45);
var SK45 = (_322, b322) => b322;
var make125 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_75 = (map722) => dual45(3, (self2, name22, f322) => map722(self2, (a322) => Object.assign({}, a322, {
  [name22]: f322(a322)
})));
var bindTo75 = (map722) => dual45(2, (self2, name22) => map722(self2, (a322) => ({
  [name22]: a322
})));
var bind75 = (map722, flatMap722) => dual45(3, (self2, name22, f322) => flatMap722(self2, (a322) => map722(f322(a322), (b322) => Object.assign({}, a322, {
  [name22]: b322
}))));
var moduleVersion45 = "3.2.8";
var getCurrentVersion45 = () => moduleVersion45;
var globalStoreId45 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion45()}`);
if (!(globalStoreId45 in globalThis)) {
  globalThis[globalStoreId45] = /* @__PURE__ */ new Map();
}
var globalStore45 = globalThis[globalStoreId45];
var globalValue45 = (id, compute) => {
  if (!globalStore45.has(id)) {
    globalStore45.set(id, compute());
  }
  return globalStore45.get(id);
};
var Predicate_exports35 = {};
__export35(Predicate_exports35, {
  all: () => all65,
  and: () => and45,
  compose: () => compose75,
  eqv: () => eqv45,
  every: () => every55,
  hasProperty: () => hasProperty45,
  implies: () => implies45,
  isBigInt: () => isBigInt45,
  isBoolean: () => isBoolean45,
  isDate: () => isDate45,
  isError: () => isError45,
  isFunction: () => isFunction84,
  isIterable: () => isIterable45,
  isMap: () => isMap45,
  isNever: () => isNever45,
  isNotNull: () => isNotNull45,
  isNotNullable: () => isNotNullable45,
  isNotUndefined: () => isNotUndefined45,
  isNull: () => isNull45,
  isNullable: () => isNullable45,
  isNumber: () => isNumber45,
  isObject: () => isObject45,
  isPromise: () => isPromise45,
  isPromiseLike: () => isPromiseLike45,
  isReadonlyRecord: () => isReadonlyRecord45,
  isRecord: () => isRecord45,
  isSet: () => isSet45,
  isString: () => isString45,
  isSymbol: () => isSymbol45,
  isTagged: () => isTagged45,
  isTruthy: () => isTruthy45,
  isUint8Array: () => isUint8Array45,
  isUndefined: () => isUndefined45,
  isUnknown: () => isUnknown45,
  mapInput: () => mapInput55,
  nand: () => nand45,
  nor: () => nor45,
  not: () => not45,
  or: () => or45,
  product: () => product65,
  productMany: () => productMany65,
  some: () => some95,
  struct: () => struct65,
  tuple: () => tuple55,
  xor: () => xor45
});
var mapInput55 = /* @__PURE__ */ dual45(2, (self2, f322) => (b322) => self2(f322(b322)));
var isTruthy45 = (input) => !!input;
var isSet45 = (input) => input instanceof Set;
var isMap45 = (input) => input instanceof Map;
var isString45 = (input) => typeof input === "string";
var isNumber45 = (input) => typeof input === "number";
var isBoolean45 = (input) => typeof input === "boolean";
var isBigInt45 = (input) => typeof input === "bigint";
var isSymbol45 = (input) => typeof input === "symbol";
var isFunction84 = isFunction74;
var isUndefined45 = (input) => input === void 0;
var isNotUndefined45 = (input) => input !== void 0;
var isNull45 = (input) => input === null;
var isNotNull45 = (input) => input !== null;
var isNever45 = (_322) => false;
var isUnknown45 = (_322) => true;
var isRecordOrArray45 = (input) => typeof input === "object" && input !== null;
var isObject45 = (input) => isRecordOrArray45(input) || isFunction84(input);
var hasProperty45 = /* @__PURE__ */ dual45(2, (self2, property) => isObject45(self2) && property in self2);
var isTagged45 = /* @__PURE__ */ dual45(2, (self2, tag) => hasProperty45(self2, "_tag") && self2["_tag"] === tag);
var isNullable45 = (input) => input === null || input === void 0;
var isNotNullable45 = (input) => input !== null && input !== void 0;
var isError45 = (input) => input instanceof Error;
var isUint8Array45 = (input) => input instanceof Uint8Array;
var isDate45 = (input) => input instanceof Date;
var isIterable45 = (input) => hasProperty45(input, Symbol.iterator);
var isRecord45 = (input) => isRecordOrArray45(input) && !Array.isArray(input);
var isReadonlyRecord45 = isRecord45;
var isPromise45 = (input) => hasProperty45(input, "then") && "catch" in input && isFunction84(input.then) && isFunction84(input.catch);
var isPromiseLike45 = (input) => hasProperty45(input, "then") && isFunction84(input.then);
var compose75 = /* @__PURE__ */ dual45(2, (ab, bc) => (a322) => ab(a322) && bc(a322));
var product65 = (self2, that) => ([a322, b322]) => self2(a322) && that(b322);
var all65 = (collection) => {
  return (as622) => {
    let collectionIndex = 0;
    for (const p322 of collection) {
      if (collectionIndex >= as622.length) {
        break;
      }
      if (p322(as622[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany65 = (self2, collection) => {
  const rest = all65(collection);
  return ([head322, ...tail322]) => self2(head322) === false ? false : rest(tail322);
};
var tuple55 = (...elements) => all65(elements);
var struct65 = (fields) => {
  const keys522 = Object.keys(fields);
  return (a322) => {
    for (const key of keys522) {
      if (!fields[key](a322[key])) {
        return false;
      }
    }
    return true;
  };
};
var not45 = (self2) => (a322) => !self2(a322);
var or45 = /* @__PURE__ */ dual45(2, (self2, that) => (a322) => self2(a322) || that(a322));
var and45 = /* @__PURE__ */ dual45(2, (self2, that) => (a322) => self2(a322) && that(a322));
var xor45 = /* @__PURE__ */ dual45(2, (self2, that) => (a322) => self2(a322) !== that(a322));
var eqv45 = /* @__PURE__ */ dual45(2, (self2, that) => (a322) => self2(a322) === that(a322));
var implies45 = /* @__PURE__ */ dual45(2, (self2, that) => (a322) => self2(a322) ? that(a322) : true);
var nor45 = /* @__PURE__ */ dual45(2, (self2, that) => (a322) => !(self2(a322) || that(a322)));
var nand45 = /* @__PURE__ */ dual45(2, (self2, that) => (a322) => !(self2(a322) && that(a322)));
var every55 = (collection) => (a322) => {
  for (const p322 of collection) {
    if (!p322(a322)) {
      return false;
    }
  }
  return true;
};
var some95 = (collection) => (a322) => {
  for (const p322 of collection) {
    if (p322(a322)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage45 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId45 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind45 = (u322) => isObject45(u322) && GenKindTypeId45 in u322;
var GenKindImpl45 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity45;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_322) => _322;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_322) => _322;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_322) => _322;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId45] = GenKindTypeId45;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen55(this);
  }
};
var SingleShotGen55 = class _SingleShotGen75 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a322) {
    return this.called ? {
      value: a322,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a322) {
    return {
      value: a322,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e322) {
    throw e322;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen75(this.self);
  }
};
var adapter65 = () => function() {
  let x322 = arguments[0];
  for (let i322 = 1; i322 < arguments.length; i322++) {
    x322 = arguments[i322](x322);
  }
  return new GenKindImpl45(x322);
};
var defaultIncHi45 = 335903614;
var defaultIncLo45 = 4150755663;
var MUL_HI45 = 1481765933 >>> 0;
var MUL_LO45 = 1284865837 >>> 0;
var BIT_5345 = 9007199254740992;
var BIT_2745 = 134217728;
var PCGRandom45 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable45(seedLo) && isNullable45(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable45(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable45(incLo) && isNullable45(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo45;
      incHi = this._state ? this._state[2] : defaultIncHi45;
    } else if (isNullable45(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add6445(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max322) {
    if (!max322) {
      return this._next();
    }
    max322 = max322 >>> 0;
    if ((max322 & max322 - 1) === 0) {
      return this._next() & max322 - 1;
    }
    let num = 0;
    const skew = (-max322 >>> 0) % max322 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max322;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_2745 + lo) / BIT_5345;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul6445(this._state, oldHi, oldLo, MUL_HI45, MUL_LO45);
    add6445(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul6445(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add6445(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId45 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap45 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId45]() {
    return this.#value;
  }
};
function yieldWrapGet45(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId45 in self2) {
    return self2[YieldWrapTypeId45]();
  }
  throw new Error(getBugErrorMessage45("yieldWrapGet"));
}
var structuralRegionState45 = /* @__PURE__ */ globalValue45("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache45 = /* @__PURE__ */ globalValue45(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr45 = /* @__PURE__ */ globalValue45(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom45());
var symbol65 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash45 = (self2) => {
  if (structuralRegionState45.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number55(self2);
    case "bigint":
      return string45(self2.toString(10));
    case "boolean":
      return string45(String(self2));
    case "symbol":
      return string45(String(self2));
    case "string":
      return string45(self2);
    case "undefined":
      return string45("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string45("null");
      } else if (self2 instanceof Date) {
        return hash45(self2.toISOString());
      } else if (isHash45(self2)) {
        return self2[symbol65]();
      } else {
        return random45(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random45 = (self2) => {
  if (!randomHashCache45.has(self2)) {
    randomHashCache45.set(self2, number55(pcgr45.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache45.get(self2);
};
var combine55 = (b322) => (self2) => self2 * 53 ^ b322;
var optimize45 = (n322) => n322 & 3221225471 | n322 >>> 1 & 1073741824;
var isHash45 = (u322) => hasProperty45(u322, symbol65);
var number55 = (n322) => {
  if (n322 !== n322 || n322 === Infinity) {
    return 0;
  }
  let h322 = n322 | 0;
  if (h322 !== n322) {
    h322 ^= n322 * 4294967295;
  }
  while (n322 > 4294967295) {
    h322 ^= n322 /= 4294967295;
  }
  return optimize45(n322);
};
var string45 = (str) => {
  let h322 = 5381, i322 = str.length;
  while (i322) {
    h322 = h322 * 33 ^ str.charCodeAt(--i322);
  }
  return optimize45(h322);
};
var cached45 = function() {
  if (arguments.length === 1) {
    const self3 = arguments[0];
    return function(hash722) {
      Object.defineProperty(self3, symbol65, {
        value() {
          return hash722;
        },
        enumerable: false
      });
      return hash722;
    };
  }
  const self2 = arguments[0];
  const hash622 = arguments[1];
  Object.defineProperty(self2, symbol65, {
    value() {
      return hash622;
    },
    enumerable: false
  });
  return hash622;
};
var symbol75 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals45() {
  if (arguments.length === 1) {
    return (self2) => compareBoth45(self2, arguments[0]);
  }
  return compareBoth45(arguments[0], arguments[1]);
}
function compareBoth45(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual45(self2) && isEqual45(that)) {
        if (hash45(self2) === hash45(that) && self2[symbol75](that)) {
          return true;
        } else {
          return structuralRegionState45.enabled && structuralRegionState45.tester ? structuralRegionState45.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState45.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v322, i322) => compareBoth45(v322, that[i322]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth45(self2[key], that[key]))) {
              return structuralRegionState45.tester ? structuralRegionState45.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState45.tester ? structuralRegionState45.tester(self2, that) : false;
    }
  }
  return structuralRegionState45.enabled && structuralRegionState45.tester ? structuralRegionState45.tester(self2, that) : false;
}
var isEqual45 = (u322) => hasProperty45(u322, symbol75);
var equivalence45 = () => equals45;
var NodeInspectSymbol45 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON45 = (x322) => {
  if (hasProperty45(x322, "toJSON") && isFunction84(x322["toJSON"]) && x322["toJSON"].length === 0) {
    return x322.toJSON();
  } else if (Array.isArray(x322)) {
    return x322.map(toJSON45);
  }
  return x322;
};
var format45 = (x322) => JSON.stringify(x322, null, 2);
var pipeArguments45 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i322 = 0, len = args.length; i322 < len; i322++) {
        ret = args[i322](ret);
      }
      return ret;
    }
  }
};
var EffectTypeId55 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId45 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId45 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId45 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance45 = {
  /* c8 ignore next */
  _R: (_322) => _322,
  /* c8 ignore next */
  _E: (_322) => _322,
  /* c8 ignore next */
  _A: (_322) => _322,
  _V: /* @__PURE__ */ getCurrentVersion45()
};
var sinkVariance45 = {
  /* c8 ignore next */
  _A: (_322) => _322,
  /* c8 ignore next */
  _In: (_322) => _322,
  /* c8 ignore next */
  _L: (_322) => _322,
  /* c8 ignore next */
  _E: (_322) => _322,
  /* c8 ignore next */
  _R: (_322) => _322
};
var channelVariance45 = {
  /* c8 ignore next */
  _Env: (_322) => _322,
  /* c8 ignore next */
  _InErr: (_322) => _322,
  /* c8 ignore next */
  _InElem: (_322) => _322,
  /* c8 ignore next */
  _InDone: (_322) => _322,
  /* c8 ignore next */
  _OutErr: (_322) => _322,
  /* c8 ignore next */
  _OutElem: (_322) => _322,
  /* c8 ignore next */
  _OutDone: (_322) => _322
};
var EffectPrototype45 = {
  [EffectTypeId55]: effectVariance45,
  [StreamTypeId45]: effectVariance45,
  [SinkTypeId45]: sinkVariance45,
  [ChannelTypeId45]: channelVariance45,
  [symbol75](that) {
    return this === that;
  },
  [symbol65]() {
    return cached45(this, random45(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen55(new YieldWrap45(this));
  },
  pipe() {
    return pipeArguments45(this, arguments);
  }
};
var TypeId105 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto65 = {
  ...EffectPrototype45,
  [TypeId105]: {
    _A: (_322) => _322
  },
  [NodeInspectSymbol45]() {
    return this.toJSON();
  },
  toString() {
    return format45(this.toJSON());
  }
};
var SomeProto45 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto65), {
  _tag: "Some",
  _op: "Some",
  [symbol75](that) {
    return isOption65(that) && isSome65(that) && equals45(this.value, that.value);
  },
  [symbol65]() {
    return cached45(this, combine55(hash45(this._tag))(hash45(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON45(this.value)
    };
  }
});
var NoneHash45 = /* @__PURE__ */ hash45("None");
var NoneProto45 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto65), {
  _tag: "None",
  _op: "None",
  [symbol75](that) {
    return isOption65(that) && isNone65(that);
  },
  [symbol65]() {
    return NoneHash45;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption65 = (input) => hasProperty45(input, TypeId105);
var isNone65 = (fa) => fa._tag === "None";
var isSome65 = (fa) => fa._tag === "Some";
var none65 = /* @__PURE__ */ Object.create(NoneProto45);
var some105 = (value) => {
  const a322 = Object.create(SomeProto45);
  a322.value = value;
  return a322;
};
var TypeId115 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto75 = {
  ...EffectPrototype45,
  [TypeId115]: {
    _R: (_322) => _322
  },
  [NodeInspectSymbol45]() {
    return this.toJSON();
  },
  toString() {
    return format45(this.toJSON());
  }
};
var RightProto45 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto75), {
  _tag: "Right",
  _op: "Right",
  [symbol75](that) {
    return isEither45(that) && isRight55(that) && equals45(this.right, that.right);
  },
  [symbol65]() {
    return combine55(hash45(this._tag))(hash45(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON45(this.right)
    };
  }
});
var LeftProto45 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto75), {
  _tag: "Left",
  _op: "Left",
  [symbol75](that) {
    return isEither45(that) && isLeft55(that) && equals45(this.left, that.left);
  },
  [symbol65]() {
    return combine55(hash45(this._tag))(hash45(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON45(this.left)
    };
  }
});
var isEither45 = (input) => hasProperty45(input, TypeId115);
var isLeft55 = (ma) => ma._tag === "Left";
var isRight55 = (ma) => ma._tag === "Right";
var left55 = (left722) => {
  const a322 = Object.create(LeftProto45);
  a322.left = left722;
  return a322;
};
var right55 = (right722) => {
  const a322 = Object.create(RightProto45);
  a322.right = right722;
  return a322;
};
var getLeft65 = (self2) => isRight55(self2) ? none65 : some105(self2.left);
var getRight65 = (self2) => isLeft55(self2) ? none65 : some105(self2.right);
var Option_exports45 = {};
__export35(Option_exports45, {
  Do: () => Do55,
  TypeId: () => TypeId124,
  all: () => all75,
  andThen: () => andThen45,
  ap: () => ap45,
  as: () => as45,
  asVoid: () => asVoid45,
  bind: () => bind85,
  bindTo: () => bindTo85,
  composeK: () => composeK45,
  contains: () => contains55,
  containsWith: () => containsWith55,
  exists: () => exists45,
  filter: () => filter55,
  filterMap: () => filterMap55,
  firstSomeOf: () => firstSomeOf45,
  flatMap: () => flatMap55,
  flatMapNullable: () => flatMapNullable55,
  flatten: () => flatten55,
  fromIterable: () => fromIterable65,
  fromNullable: () => fromNullable55,
  gen: () => gen45,
  getEquivalence: () => getEquivalence65,
  getLeft: () => getLeft75,
  getOrElse: () => getOrElse45,
  getOrNull: () => getOrNull45,
  getOrThrow: () => getOrThrow45,
  getOrThrowWith: () => getOrThrowWith45,
  getOrUndefined: () => getOrUndefined45,
  getOrder: () => getOrder55,
  getRight: () => getRight75,
  isNone: () => isNone75,
  isOption: () => isOption75,
  isSome: () => isSome75,
  let: () => let_85,
  lift2: () => lift245,
  liftNullable: () => liftNullable55,
  liftPredicate: () => liftPredicate55,
  liftThrowable: () => liftThrowable45,
  map: () => map55,
  match: () => match64,
  none: () => none75,
  orElse: () => orElse45,
  orElseEither: () => orElseEither45,
  orElseSome: () => orElseSome45,
  partitionMap: () => partitionMap55,
  product: () => product75,
  productMany: () => productMany75,
  reduceCompact: () => reduceCompact45,
  some: () => some114,
  tap: () => tap45,
  toArray: () => toArray45,
  toRefinement: () => toRefinement45,
  void: () => void_45,
  zipLeft: () => zipLeft45,
  zipRight: () => zipRight45,
  zipWith: () => zipWith55
});
var make135 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId124 = /* @__PURE__ */ Symbol.for("effect/Option");
var none75 = () => none65;
var some114 = some105;
var isOption75 = isOption65;
var isNone75 = isNone65;
var isSome75 = isSome65;
var match64 = /* @__PURE__ */ dual45(2, (self2, {
  onNone,
  onSome
}) => isNone75(self2) ? onNone() : onSome(self2.value));
var toRefinement45 = (f322) => (a322) => isSome75(f322(a322));
var fromIterable65 = (collection) => {
  for (const a322 of collection) {
    return some114(a322);
  }
  return none75();
};
var getRight75 = getRight65;
var getLeft75 = getLeft65;
var getOrElse45 = /* @__PURE__ */ dual45(2, (self2, onNone) => isNone75(self2) ? onNone() : self2.value);
var orElse45 = /* @__PURE__ */ dual45(2, (self2, that) => isNone75(self2) ? that() : self2);
var orElseSome45 = /* @__PURE__ */ dual45(2, (self2, onNone) => isNone75(self2) ? some114(onNone()) : self2);
var orElseEither45 = /* @__PURE__ */ dual45(2, (self2, that) => isNone75(self2) ? map55(that(), right55) : map55(self2, left55));
var firstSomeOf45 = (collection) => {
  let out = none75();
  for (out of collection) {
    if (isSome75(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable55 = (nullableValue) => nullableValue == null ? none75() : some114(nullableValue);
var liftNullable55 = (f322) => (...a322) => fromNullable55(f322(...a322));
var getOrNull45 = /* @__PURE__ */ getOrElse45(constNull45);
var getOrUndefined45 = /* @__PURE__ */ getOrElse45(constUndefined45);
var liftThrowable45 = (f322) => (...a322) => {
  try {
    return some114(f322(...a322));
  } catch (e322) {
    return none75();
  }
};
var getOrThrowWith45 = /* @__PURE__ */ dual45(2, (self2, onNone) => {
  if (isSome75(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow45 = /* @__PURE__ */ getOrThrowWith45(() => new Error("getOrThrow called on a None"));
var map55 = /* @__PURE__ */ dual45(2, (self2, f322) => isNone75(self2) ? none75() : some114(f322(self2.value)));
var as45 = /* @__PURE__ */ dual45(2, (self2, b322) => map55(self2, () => b322));
var asVoid45 = /* @__PURE__ */ as45(void 0);
var void_45 = /* @__PURE__ */ some114(void 0);
var flatMap55 = /* @__PURE__ */ dual45(2, (self2, f322) => isNone75(self2) ? none75() : f322(self2.value));
var andThen45 = /* @__PURE__ */ dual45(2, (self2, f322) => flatMap55(self2, (a322) => {
  const b322 = isFunction74(f322) ? f322(a322) : f322;
  return isOption75(b322) ? b322 : some114(b322);
}));
var flatMapNullable55 = /* @__PURE__ */ dual45(2, (self2, f322) => isNone75(self2) ? none75() : fromNullable55(f322(self2.value)));
var flatten55 = /* @__PURE__ */ flatMap55(identity45);
var zipRight45 = /* @__PURE__ */ dual45(2, (self2, that) => flatMap55(self2, () => that));
var composeK45 = /* @__PURE__ */ dual45(2, (afb, bfc) => (a322) => flatMap55(afb(a322), bfc));
var zipLeft45 = /* @__PURE__ */ dual45(2, (self2, that) => tap45(self2, () => that));
var tap45 = /* @__PURE__ */ dual45(2, (self2, f322) => flatMap55(self2, (a322) => map55(f322(a322), () => a322)));
var product75 = (self2, that) => isSome75(self2) && isSome75(that) ? some114([self2.value, that.value]) : none75();
var productMany75 = (self2, collection) => {
  if (isNone75(self2)) {
    return none75();
  }
  const out = [self2.value];
  for (const o322 of collection) {
    if (isNone75(o322)) {
      return none75();
    }
    out.push(o322.value);
  }
  return some114(out);
};
var all75 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o322 of input) {
      if (isNone75(o322)) {
        return none75();
      }
      out2.push(o322.value);
    }
    return some114(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o322 = input[key];
    if (isNone75(o322)) {
      return none75();
    }
    out[key] = o322.value;
  }
  return some114(out);
};
var zipWith55 = /* @__PURE__ */ dual45(3, (self2, that, f322) => map55(product75(self2, that), ([a322, b322]) => f322(a322, b322)));
var ap45 = /* @__PURE__ */ dual45(2, (self2, that) => zipWith55(self2, that, (f322, a322) => f322(a322)));
var reduceCompact45 = /* @__PURE__ */ dual45(3, (self2, b322, f322) => {
  let out = b322;
  for (const oa of self2) {
    if (isSome75(oa)) {
      out = f322(out, oa.value);
    }
  }
  return out;
});
var toArray45 = (self2) => isNone75(self2) ? [] : [self2.value];
var partitionMap55 = /* @__PURE__ */ dual45(2, (self2, f322) => {
  if (isNone75(self2)) {
    return [none75(), none75()];
  }
  const e322 = f322(self2.value);
  return isLeft55(e322) ? [some114(e322.left), none75()] : [none75(), some114(e322.right)];
});
var filterMap55 = /* @__PURE__ */ dual45(2, (self2, f322) => isNone75(self2) ? none75() : f322(self2.value));
var filter55 = /* @__PURE__ */ dual45(2, (self2, predicate) => filterMap55(self2, (b322) => predicate(b322) ? some105(b322) : none65));
var getEquivalence65 = (isEquivalent) => make125((x322, y322) => x322 === y322 || (isNone75(x322) ? isNone75(y322) : isNone75(y322) ? false : isEquivalent(x322.value, y322.value)));
var getOrder55 = (O322) => make135((self2, that) => isSome75(self2) ? isSome75(that) ? O322(self2.value, that.value) : 1 : -1);
var lift245 = (f322) => dual45(2, (self2, that) => zipWith55(self2, that, f322));
var liftPredicate55 = (predicate) => (b322) => predicate(b322) ? some114(b322) : none75();
var containsWith55 = (isEquivalent) => dual45(2, (self2, a322) => isNone75(self2) ? false : isEquivalent(self2.value, a322));
var _equivalence65 = /* @__PURE__ */ equivalence45();
var contains55 = /* @__PURE__ */ containsWith55(_equivalence65);
var exists45 = /* @__PURE__ */ dual45(2, (self2, refinement) => isNone75(self2) ? false : refinement(self2.value));
var bindTo85 = /* @__PURE__ */ bindTo75(map55);
var let_85 = /* @__PURE__ */ let_75(map55);
var bind85 = /* @__PURE__ */ bind75(map55, flatMap55);
var Do55 = /* @__PURE__ */ some114({});
var adapter75 = /* @__PURE__ */ adapter65();
var gen45 = (f322) => {
  const iterator = f322(adapter75);
  let state = iterator.next();
  if (state.done) {
    return some114(state.value);
  } else {
    let current = state.value;
    if (isGenKind45(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet45(current);
    }
    if (isNone75(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind45(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet45(current);
        }
        if (isNone75(current)) {
          return current;
        }
      }
    }
    return some114(state.value);
  }
};
var MutableRef_exports8 = {};
__export35(MutableRef_exports8, {
  compareAndSet: () => compareAndSet25,
  decrement: () => decrement25,
  decrementAndGet: () => decrementAndGet25,
  get: () => get35,
  getAndDecrement: () => getAndDecrement25,
  getAndIncrement: () => getAndIncrement25,
  getAndSet: () => getAndSet25,
  getAndUpdate: () => getAndUpdate25,
  increment: () => increment25,
  incrementAndGet: () => incrementAndGet25,
  make: () => make144,
  set: () => set35,
  setAndGet: () => setAndGet25,
  toggle: () => toggle25,
  update: () => update25,
  updateAndGet: () => updateAndGet25
});
var TypeId134 = /* @__PURE__ */ Symbol.for("effect/MutableRef");
var MutableRefProto25 = {
  [TypeId134]: TypeId134,
  toString() {
    return format45(this.toJSON());
  },
  toJSON() {
    return {
      _id: "MutableRef",
      current: toJSON45(this.current)
    };
  },
  [NodeInspectSymbol45]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments45(this, arguments);
  }
};
var make144 = (value) => {
  const ref = Object.create(MutableRefProto25);
  ref.current = value;
  return ref;
};
var compareAndSet25 = /* @__PURE__ */ dual45(3, (self2, oldValue, newValue) => {
  if (equals45(oldValue, self2.current)) {
    self2.current = newValue;
    return true;
  }
  return false;
});
var decrement25 = (self2) => update25(self2, (n322) => n322 - 1);
var decrementAndGet25 = (self2) => updateAndGet25(self2, (n322) => n322 - 1);
var get35 = (self2) => self2.current;
var getAndDecrement25 = (self2) => getAndUpdate25(self2, (n322) => n322 - 1);
var getAndIncrement25 = (self2) => getAndUpdate25(self2, (n322) => n322 + 1);
var getAndSet25 = /* @__PURE__ */ dual45(2, (self2, value) => {
  const ret = self2.current;
  self2.current = value;
  return ret;
});
var getAndUpdate25 = /* @__PURE__ */ dual45(2, (self2, f322) => getAndSet25(self2, f322(get35(self2))));
var increment25 = (self2) => update25(self2, (n322) => n322 + 1);
var incrementAndGet25 = (self2) => updateAndGet25(self2, (n322) => n322 + 1);
var set35 = /* @__PURE__ */ dual45(2, (self2, value) => {
  self2.current = value;
  return self2;
});
var setAndGet25 = /* @__PURE__ */ dual45(2, (self2, value) => {
  self2.current = value;
  return self2.current;
});
var update25 = /* @__PURE__ */ dual45(2, (self2, f322) => set35(self2, f322(get35(self2))));
var updateAndGet25 = /* @__PURE__ */ dual45(2, (self2, f322) => setAndGet25(self2, f322(get35(self2))));
var toggle25 = (self2) => update25(self2, (_322) => !_322);
var MutableList_exports5 = {};
__export35(MutableList_exports5, {
  append: () => append25,
  empty: () => empty115,
  forEach: () => forEach55,
  fromIterable: () => fromIterable75,
  head: () => head25,
  isEmpty: () => isEmpty35,
  length: () => length25,
  make: () => make154,
  pop: () => pop6,
  prepend: () => prepend45,
  reset: () => reset5,
  shift: () => shift5,
  tail: () => tail25
});
var TypeId144 = /* @__PURE__ */ Symbol.for("effect/MutableList");
var MutableListProto5 = {
  [TypeId144]: TypeId144,
  [Symbol.iterator]() {
    let done = false;
    let head322 = this.head;
    return {
      next() {
        if (done) {
          return this.return();
        }
        if (head322 == null) {
          done = true;
          return this.return();
        }
        const value = head322.value;
        head322 = head322.next;
        return {
          done,
          value
        };
      },
      return(value) {
        if (!done) {
          done = true;
        }
        return {
          done: true,
          value
        };
      }
    };
  },
  toString() {
    return format45(this.toJSON());
  },
  toJSON() {
    return {
      _id: "MutableList",
      values: Array.from(this).map(toJSON45)
    };
  },
  [NodeInspectSymbol45]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments45(this, arguments);
  }
};
var makeNode5 = (value) => ({
  value,
  removed: false,
  prev: void 0,
  next: void 0
});
var empty115 = () => {
  const list = Object.create(MutableListProto5);
  list.head = void 0;
  list.tail = void 0;
  list._length = 0;
  return list;
};
var fromIterable75 = (iterable) => {
  const list = empty115();
  for (const element of iterable) {
    append25(list, element);
  }
  return list;
};
var make154 = (...elements) => fromIterable75(elements);
var isEmpty35 = (self2) => length25(self2) === 0;
var length25 = (self2) => self2._length;
var tail25 = (self2) => self2.tail === void 0 ? void 0 : self2.tail.value;
var head25 = (self2) => self2.head === void 0 ? void 0 : self2.head.value;
var forEach55 = /* @__PURE__ */ dual45(2, (self2, f322) => {
  let current = self2.head;
  while (current !== void 0) {
    f322(current.value);
    current = current.next;
  }
});
var reset5 = (self2) => {
  self2._length = 0;
  self2.head = void 0;
  self2.tail = void 0;
  return self2;
};
var append25 = /* @__PURE__ */ dual45(2, (self2, value) => {
  const node = makeNode5(value);
  if (self2.head === void 0) {
    self2.head = node;
  }
  if (self2.tail === void 0) {
    self2.tail = node;
  } else {
    self2.tail.next = node;
    node.prev = self2.tail;
    self2.tail = node;
  }
  self2._length += 1;
  return self2;
});
var shift5 = (self2) => {
  const head322 = self2.head;
  if (head322 !== void 0) {
    remove25(self2, head322);
    return head322.value;
  }
  return void 0;
};
var pop6 = (self2) => {
  const tail322 = self2.tail;
  if (tail322 !== void 0) {
    remove25(self2, tail322);
    return tail322.value;
  }
  return void 0;
};
var prepend45 = /* @__PURE__ */ dual45(2, (self2, value) => {
  const node = makeNode5(value);
  node.next = self2.head;
  if (self2.head !== void 0) {
    self2.head.prev = node;
  }
  self2.head = node;
  if (self2.tail === void 0) {
    self2.tail = node;
  }
  self2._length += 1;
  return self2;
});
var remove25 = (self2, node) => {
  if (node.removed) {
    return;
  }
  node.removed = true;
  if (node.prev !== void 0 && node.next !== void 0) {
    node.prev.next = node.next;
    node.next.prev = node.prev;
  } else if (node.prev !== void 0) {
    self2.tail = node.prev;
    node.prev.next = void 0;
  } else if (node.next !== void 0) {
    self2.head = node.next;
    node.next.prev = void 0;
  } else {
    self2.tail = void 0;
    self2.head = void 0;
  }
  if (self2._length > 0) {
    self2._length -= 1;
  }
};
var store25;
function getGlobalMessage5(lang) {
  return store25?.get(lang);
}
var store35;
function getSchemaMessage5(lang) {
  return store35?.get(lang);
}
var store45;
function getSpecificMessage5(reference, lang) {
  return store45?.get(reference)?.get(lang);
}
function _stringify5(input) {
  let type = typeof input;
  if (type === "object") {
    type = (input && Object.getPrototypeOf(input)?.constructor?.name) ?? "null";
  }
  return type === "string" ? `"${input}"` : type === "number" || type === "bigint" || type === "boolean" ? `${input}` : type;
}
function _addIssue5(context, label, dataset, config2, other) {
  const input = dataset.value;
  const expected = context.expects;
  const received = _stringify5(input);
  const issue = {
    kind: context.kind,
    type: context.type,
    input,
    expected,
    received,
    message: `Invalid ${label}: ${expected ? `Expected ${expected} but r` : "R"}eceived ${received}`,
    // @ts-expect-error
    requirement: context.requirement,
    path: other?.path,
    issues: other?.issues,
    lang: config2.lang,
    abortEarly: config2.abortEarly,
    abortPipeEarly: config2.abortPipeEarly,
    skipPipe: config2.skipPipe
  };
  const isSchema = context.kind === "schema";
  const message = (
    // @ts-expect-error
    context.message ?? getSpecificMessage5(context.reference, issue.lang) ?? (isSchema ? getSchemaMessage5(issue.lang) : null) ?? config2.message ?? getGlobalMessage5(issue.lang)
  );
  if (message) {
    issue.message = typeof message === "function" ? message(issue) : message;
  }
  if (isSchema) {
    dataset.typed = false;
  }
  if (dataset.issues) {
    dataset.issues.push(issue);
  } else {
    dataset.issues = [issue];
  }
}
function getDefault5(schema4, dataset, config2) {
  return typeof schema4.default === "function" ? (
    // @ts-expect-error
    schema4.default(dataset, config2)
  ) : (
    // @ts-expect-error
    schema4.default
  );
}
function array65(item, message) {
  return {
    kind: "schema",
    type: "array",
    reference: array65,
    expects: "Array",
    async: false,
    item,
    message,
    _run(dataset, config2) {
      const input = dataset.value;
      if (Array.isArray(input)) {
        dataset.typed = true;
        dataset.value = [];
        for (let key = 0; key < input.length; key++) {
          const value2 = input[key];
          const itemDataset = this.item._run({ typed: false, value: value2 }, config2);
          if (itemDataset.issues) {
            const pathItem = {
              type: "array",
              origin: "value",
              input,
              key,
              value: value2
            };
            for (const issue of itemDataset.issues) {
              if (issue.path) {
                issue.path.unshift(pathItem);
              } else {
                issue.path = [pathItem];
              }
              dataset.issues?.push(issue);
            }
            if (!dataset.issues) {
              dataset.issues = itemDataset.issues;
            }
            if (config2.abortEarly) {
              dataset.typed = false;
              break;
            }
          }
          if (!itemDataset.typed) {
            dataset.typed = false;
          }
          dataset.value.push(itemDataset.value);
        }
      } else {
        _addIssue5(this, "type", dataset, config2);
      }
      return dataset;
    }
  };
}
function object5(entries2, message) {
  return {
    kind: "schema",
    type: "object",
    reference: object5,
    expects: "Object",
    async: false,
    entries: entries2,
    message,
    _run(dataset, config2) {
      const input = dataset.value;
      if (input && typeof input === "object") {
        dataset.typed = true;
        dataset.value = {};
        for (const key in this.entries) {
          const value2 = input[key];
          const valueDataset = this.entries[key]._run(
            { typed: false, value: value2 },
            config2
          );
          if (valueDataset.issues) {
            const pathItem = {
              type: "object",
              origin: "value",
              input,
              key,
              value: value2
            };
            for (const issue of valueDataset.issues) {
              if (issue.path) {
                issue.path.unshift(pathItem);
              } else {
                issue.path = [pathItem];
              }
              dataset.issues?.push(issue);
            }
            if (!dataset.issues) {
              dataset.issues = valueDataset.issues;
            }
            if (config2.abortEarly) {
              dataset.typed = false;
              break;
            }
          }
          if (!valueDataset.typed) {
            dataset.typed = false;
          }
          if (valueDataset.value !== void 0 || key in input) {
            dataset.value[key] = valueDataset.value;
          }
        }
      } else {
        _addIssue5(this, "type", dataset, config2);
      }
      return dataset;
    }
  };
}
function optional5(wrapped, ...args) {
  const schema4 = {
    kind: "schema",
    type: "optional",
    reference: optional5,
    expects: `${wrapped.expects} | undefined`,
    async: false,
    wrapped,
    _run(dataset, config2) {
      if (dataset.value === void 0) {
        if ("default" in this) {
          dataset.value = getDefault5(
            this,
            dataset,
            config2
          );
        }
        if (dataset.value === void 0) {
          dataset.typed = true;
          return dataset;
        }
      }
      return this.wrapped._run(dataset, config2);
    }
  };
  if (0 in args) {
    schema4.default = args[0];
  }
  return schema4;
}
function string55(message) {
  return {
    kind: "schema",
    type: "string",
    reference: string55,
    expects: "string",
    async: false,
    message,
    _run(dataset, config2) {
      if (typeof dataset.value === "string") {
        dataset.typed = true;
      } else {
        _addIssue5(this, "type", dataset, config2);
      }
      return dataset;
    }
  };
}
var ESLintReactSettingsSchema5 = object5({
  additionalHooks: optional5(object5({
    use: optional5(string55()),
    useCallback: optional5(array65(string55())),
    useContext: optional5(array65(string55())),
    useDebugValue: optional5(array65(string55())),
    useDeferredValue: optional5(array65(string55())),
    useEffect: optional5(array65(string55())),
    useId: optional5(array65(string55())),
    useImperativeHandle: optional5(array65(string55())),
    useInsertionEffect: optional5(array65(string55())),
    useLayoutEffect: optional5(array65(string55())),
    useMemo: optional5(array65(string55())),
    useOptimistic: optional5(array65(string55())),
    useReducer: optional5(array65(string55())),
    useRef: optional5(array65(string55())),
    useState: optional5(array65(string55())),
    useSyncExternalStore: optional5(array65(string55())),
    useTransition: optional5(array65(string55()))
  })),
  importSource: optional5(string55()),
  jsxPragma: optional5(string55()),
  jsxPragmaFrag: optional5(string55()),
  version: optional5(string55())
});
var ESLintSettingsSchema4 = object5({
  reactOptions: optional5(ESLintReactSettingsSchema5)
});
var __defProp45 = Object.defineProperty;
var __export45 = (target, all3322) => {
  for (var name22 in all3322)
    __defProp45(target, name22, { get: all3322[name22], enumerable: true });
};
var Function_exports55 = {};
__export45(Function_exports55, {
  SK: () => SK55,
  absurd: () => absurd55,
  apply: () => apply55,
  compose: () => compose84,
  constFalse: () => constFalse55,
  constNull: () => constNull55,
  constTrue: () => constTrue55,
  constUndefined: () => constUndefined55,
  constVoid: () => constVoid55,
  constant: () => constant55,
  dual: () => dual55,
  flip: () => flip55,
  flow: () => flow55,
  hole: () => hole55,
  identity: () => identity55,
  isFunction: () => isFunction94,
  pipe: () => pipe55,
  satisfies: () => satisfies55,
  tupled: () => tupled55,
  unsafeCoerce: () => unsafeCoerce55,
  untupled: () => untupled55
});
var isFunction94 = (input) => typeof input === "function";
var dual55 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a2222, b2222) {
        if (arguments.length >= 2) {
          return body(a2222, b2222);
        }
        return function(self2) {
          return body(self2, a2222);
        };
      };
    case 3:
      return function(a2222, b2222, c2222) {
        if (arguments.length >= 3) {
          return body(a2222, b2222, c2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222);
        };
      };
    case 4:
      return function(a2222, b2222, c2222, d2222) {
        if (arguments.length >= 4) {
          return body(a2222, b2222, c2222, d2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222);
        };
      };
    case 5:
      return function(a2222, b2222, c2222, d2222, e2222) {
        if (arguments.length >= 5) {
          return body(a2222, b2222, c2222, d2222, e2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222, d2222);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply55 = (a2222) => (self2) => self2(a2222);
var identity55 = (a2222) => a2222;
var satisfies55 = () => (b2222) => b2222;
var unsafeCoerce55 = identity55;
var constant55 = (value) => () => value;
var constTrue55 = /* @__PURE__ */ constant55(true);
var constFalse55 = /* @__PURE__ */ constant55(false);
var constNull55 = /* @__PURE__ */ constant55(null);
var constUndefined55 = /* @__PURE__ */ constant55(void 0);
var constVoid55 = constUndefined55;
var flip55 = (f2222) => (...b2222) => (...a2222) => f2222(...a2222)(...b2222);
var compose84 = /* @__PURE__ */ dual55(2, (ab, bc) => (a2222) => bc(ab(a2222)));
var absurd55 = (_2222) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled55 = (f2222) => (a2222) => f2222(...a2222);
var untupled55 = (f2222) => (...a2222) => f2222(a2222);
function pipe55(a2222, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a2222;
    case 2:
      return ab(a2222);
    case 3:
      return bc(ab(a2222));
    case 4:
      return cd(bc(ab(a2222)));
    case 5:
      return de(cd(bc(ab(a2222))));
    case 6:
      return ef(de(cd(bc(ab(a2222)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a2222))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a2222)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a2222))))))));
    default: {
      let ret = arguments[0];
      for (let i2222 = 1; i2222 < arguments.length; i2222++) {
        ret = arguments[i2222](ret);
      }
      return ret;
    }
  }
}
function flow55(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole55 = /* @__PURE__ */ unsafeCoerce55(absurd55);
var SK55 = (_2222, b2222) => b2222;
var make164 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_94 = (map3222) => dual55(3, (self2, name22, f2222) => map3222(self2, (a2222) => Object.assign({}, a2222, {
  [name22]: f2222(a2222)
})));
var bindTo94 = (map3222) => dual55(2, (self2, name22) => map3222(self2, (a2222) => ({
  [name22]: a2222
})));
var bind94 = (map3222, flatMap3222) => dual55(3, (self2, name22, f2222) => flatMap3222(self2, (a2222) => map3222(f2222(a2222), (b2222) => Object.assign({}, a2222, {
  [name22]: b2222
}))));
var moduleVersion55 = "3.2.8";
var getCurrentVersion55 = () => moduleVersion55;
var globalStoreId55 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion55()}`);
if (!(globalStoreId55 in globalThis)) {
  globalThis[globalStoreId55] = /* @__PURE__ */ new Map();
}
var globalStore55 = globalThis[globalStoreId55];
var globalValue55 = (id, compute) => {
  if (!globalStore55.has(id)) {
    globalStore55.set(id, compute());
  }
  return globalStore55.get(id);
};
var isFunction235 = isFunction94;
var isRecordOrArray55 = (input) => typeof input === "object" && input !== null;
var isObject55 = (input) => isRecordOrArray55(input) || isFunction235(input);
var hasProperty55 = /* @__PURE__ */ dual55(2, (self2, property) => isObject55(self2) && property in self2);
var isNullable55 = (input) => input === null || input === void 0;
var getBugErrorMessage55 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId55 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind55 = (u2222) => isObject55(u2222) && GenKindTypeId55 in u2222;
var GenKindImpl55 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity55;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId55] = GenKindTypeId55;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen65(this);
  }
};
var SingleShotGen65 = class _SingleShotGen334 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a2222) {
    return this.called ? {
      value: a2222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a2222) {
    return {
      value: a2222,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e2222) {
    throw e2222;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen334(this.self);
  }
};
var adapter84 = () => function() {
  let x2222 = arguments[0];
  for (let i2222 = 1; i2222 < arguments.length; i2222++) {
    x2222 = arguments[i2222](x2222);
  }
  return new GenKindImpl55(x2222);
};
var defaultIncHi55 = 335903614;
var defaultIncLo55 = 4150755663;
var MUL_HI55 = 1481765933 >>> 0;
var MUL_LO55 = 1284865837 >>> 0;
var BIT_5355 = 9007199254740992;
var BIT_2755 = 134217728;
var PCGRandom55 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable55(seedLo) && isNullable55(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable55(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable55(incLo) && isNullable55(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo55;
      incHi = this._state ? this._state[2] : defaultIncHi55;
    } else if (isNullable55(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add6455(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max322) {
    if (!max322) {
      return this._next();
    }
    max322 = max322 >>> 0;
    if ((max322 & max322 - 1) === 0) {
      return this._next() & max322 - 1;
    }
    let num = 0;
    const skew = (-max322 >>> 0) % max322 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max322;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_2755 + lo) / BIT_5355;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul6455(this._state, oldHi, oldLo, MUL_HI55, MUL_LO55);
    add6455(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul6455(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add6455(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId55 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap55 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId55]() {
    return this.#value;
  }
};
function yieldWrapGet55(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId55 in self2) {
    return self2[YieldWrapTypeId55]();
  }
  throw new Error(getBugErrorMessage55("yieldWrapGet"));
}
var structuralRegionState55 = /* @__PURE__ */ globalValue55("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache55 = /* @__PURE__ */ globalValue55(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr55 = /* @__PURE__ */ globalValue55(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom55());
var symbol84 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash55 = (self2) => {
  if (structuralRegionState55.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number65(self2);
    case "bigint":
      return string65(self2.toString(10));
    case "boolean":
      return string65(String(self2));
    case "symbol":
      return string65(String(self2));
    case "string":
      return string65(self2);
    case "undefined":
      return string65("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string65("null");
      } else if (self2 instanceof Date) {
        return hash55(self2.toISOString());
      } else if (isHash55(self2)) {
        return self2[symbol84]();
      } else {
        return random55(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random55 = (self2) => {
  if (!randomHashCache55.has(self2)) {
    randomHashCache55.set(self2, number65(pcgr55.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache55.get(self2);
};
var combine65 = (b2222) => (self2) => self2 * 53 ^ b2222;
var optimize55 = (n2222) => n2222 & 3221225471 | n2222 >>> 1 & 1073741824;
var isHash55 = (u2222) => hasProperty55(u2222, symbol84);
var number65 = (n2222) => {
  if (n2222 !== n2222 || n2222 === Infinity) {
    return 0;
  }
  let h2222 = n2222 | 0;
  if (h2222 !== n2222) {
    h2222 ^= n2222 * 4294967295;
  }
  while (n2222 > 4294967295) {
    h2222 ^= n2222 /= 4294967295;
  }
  return optimize55(n2222);
};
var string65 = (str) => {
  let h2222 = 5381, i2222 = str.length;
  while (i2222) {
    h2222 = h2222 * 33 ^ str.charCodeAt(--i2222);
  }
  return optimize55(h2222);
};
var cached55 = function() {
  if (arguments.length === 1) {
    const self3 = arguments[0];
    return function(hash422) {
      Object.defineProperty(self3, symbol84, {
        value() {
          return hash422;
        },
        enumerable: false
      });
      return hash422;
    };
  }
  const self2 = arguments[0];
  const hash3222 = arguments[1];
  Object.defineProperty(self2, symbol84, {
    value() {
      return hash3222;
    },
    enumerable: false
  });
  return hash3222;
};
var symbol235 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals55() {
  if (arguments.length === 1) {
    return (self2) => compareBoth55(self2, arguments[0]);
  }
  return compareBoth55(arguments[0], arguments[1]);
}
function compareBoth55(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual55(self2) && isEqual55(that)) {
        if (hash55(self2) === hash55(that) && self2[symbol235](that)) {
          return true;
        } else {
          return structuralRegionState55.enabled && structuralRegionState55.tester ? structuralRegionState55.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState55.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v2222, i2222) => compareBoth55(v2222, that[i2222]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth55(self2[key], that[key]))) {
              return structuralRegionState55.tester ? structuralRegionState55.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState55.tester ? structuralRegionState55.tester(self2, that) : false;
    }
  }
  return structuralRegionState55.enabled && structuralRegionState55.tester ? structuralRegionState55.tester(self2, that) : false;
}
var isEqual55 = (u2222) => hasProperty55(u2222, symbol235);
var equivalence55 = () => equals55;
var NodeInspectSymbol55 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON55 = (x2222) => {
  if (hasProperty55(x2222, "toJSON") && isFunction235(x2222["toJSON"]) && x2222["toJSON"].length === 0) {
    return x2222.toJSON();
  } else if (Array.isArray(x2222)) {
    return x2222.map(toJSON55);
  }
  return x2222;
};
var format55 = (x2222) => JSON.stringify(x2222, null, 2);
var pipeArguments55 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i2222 = 0, len = args.length; i2222 < len; i2222++) {
        ret = args[i2222](ret);
      }
      return ret;
    }
  }
};
var EffectTypeId65 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId55 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId55 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId55 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance55 = {
  /* c8 ignore next */
  _R: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _A: (_2222) => _2222,
  _V: /* @__PURE__ */ getCurrentVersion55()
};
var sinkVariance55 = {
  /* c8 ignore next */
  _A: (_2222) => _2222,
  /* c8 ignore next */
  _In: (_2222) => _2222,
  /* c8 ignore next */
  _L: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _R: (_2222) => _2222
};
var channelVariance55 = {
  /* c8 ignore next */
  _Env: (_2222) => _2222,
  /* c8 ignore next */
  _InErr: (_2222) => _2222,
  /* c8 ignore next */
  _InElem: (_2222) => _2222,
  /* c8 ignore next */
  _InDone: (_2222) => _2222,
  /* c8 ignore next */
  _OutErr: (_2222) => _2222,
  /* c8 ignore next */
  _OutElem: (_2222) => _2222,
  /* c8 ignore next */
  _OutDone: (_2222) => _2222
};
var EffectPrototype55 = {
  [EffectTypeId65]: effectVariance55,
  [StreamTypeId55]: effectVariance55,
  [SinkTypeId55]: sinkVariance55,
  [ChannelTypeId55]: channelVariance55,
  [symbol235](that) {
    return this === that;
  },
  [symbol84]() {
    return cached55(this, random55(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen65(new YieldWrap55(this));
  },
  pipe() {
    return pipeArguments55(this, arguments);
  }
};
var TypeId154 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto84 = {
  ...EffectPrototype55,
  [TypeId154]: {
    _A: (_2222) => _2222
  },
  [NodeInspectSymbol55]() {
    return this.toJSON();
  },
  toString() {
    return format55(this.toJSON());
  }
};
var SomeProto55 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto84), {
  _tag: "Some",
  _op: "Some",
  [symbol235](that) {
    return isOption84(that) && isSome84(that) && equals55(this.value, that.value);
  },
  [symbol84]() {
    return cached55(this, combine65(hash55(this._tag))(hash55(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON55(this.value)
    };
  }
});
var NoneHash55 = /* @__PURE__ */ hash55("None");
var NoneProto55 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto84), {
  _tag: "None",
  _op: "None",
  [symbol235](that) {
    return isOption84(that) && isNone84(that);
  },
  [symbol84]() {
    return NoneHash55;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption84 = (input) => hasProperty55(input, TypeId154);
var isNone84 = (fa) => fa._tag === "None";
var isSome84 = (fa) => fa._tag === "Some";
var none84 = /* @__PURE__ */ Object.create(NoneProto55);
var some124 = (value) => {
  const a2222 = Object.create(SomeProto55);
  a2222.value = value;
  return a2222;
};
var TypeId235 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto235 = {
  ...EffectPrototype55,
  [TypeId235]: {
    _R: (_2222) => _2222
  },
  [NodeInspectSymbol55]() {
    return this.toJSON();
  },
  toString() {
    return format55(this.toJSON());
  }
};
var RightProto55 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto235), {
  _tag: "Right",
  _op: "Right",
  [symbol235](that) {
    return isEither55(that) && isRight65(that) && equals55(this.right, that.right);
  },
  [symbol84]() {
    return combine65(hash55(this._tag))(hash55(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON55(this.right)
    };
  }
});
var LeftProto55 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto235), {
  _tag: "Left",
  _op: "Left",
  [symbol235](that) {
    return isEither55(that) && isLeft65(that) && equals55(this.left, that.left);
  },
  [symbol84]() {
    return combine65(hash55(this._tag))(hash55(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON55(this.left)
    };
  }
});
var isEither55 = (input) => hasProperty55(input, TypeId235);
var isLeft65 = (ma) => ma._tag === "Left";
var isRight65 = (ma) => ma._tag === "Right";
var left65 = (left3322) => {
  const a2222 = Object.create(LeftProto55);
  a2222.left = left3322;
  return a2222;
};
var right65 = (right3322) => {
  const a2222 = Object.create(RightProto55);
  a2222.right = right3322;
  return a2222;
};
var getLeft84 = (self2) => isRight65(self2) ? none84 : some124(self2.left);
var getRight84 = (self2) => isLeft65(self2) ? none84 : some124(self2.right);
var Option_exports55 = {};
__export45(Option_exports55, {
  Do: () => Do65,
  TypeId: () => TypeId335,
  all: () => all84,
  andThen: () => andThen55,
  ap: () => ap55,
  as: () => as55,
  asVoid: () => asVoid55,
  bind: () => bind235,
  bindTo: () => bindTo235,
  composeK: () => composeK55,
  contains: () => contains65,
  containsWith: () => containsWith65,
  exists: () => exists55,
  filter: () => filter65,
  filterMap: () => filterMap65,
  firstSomeOf: () => firstSomeOf55,
  flatMap: () => flatMap65,
  flatMapNullable: () => flatMapNullable65,
  flatten: () => flatten65,
  fromIterable: () => fromIterable84,
  fromNullable: () => fromNullable65,
  gen: () => gen55,
  getEquivalence: () => getEquivalence75,
  getLeft: () => getLeft235,
  getOrElse: () => getOrElse55,
  getOrNull: () => getOrNull55,
  getOrThrow: () => getOrThrow55,
  getOrThrowWith: () => getOrThrowWith55,
  getOrUndefined: () => getOrUndefined55,
  getOrder: () => getOrder65,
  getRight: () => getRight235,
  isNone: () => isNone235,
  isOption: () => isOption235,
  isSome: () => isSome235,
  let: () => let_235,
  lift2: () => lift255,
  liftNullable: () => liftNullable65,
  liftPredicate: () => liftPredicate65,
  liftThrowable: () => liftThrowable55,
  map: () => map65,
  match: () => match74,
  none: () => none235,
  orElse: () => orElse55,
  orElseEither: () => orElseEither55,
  orElseSome: () => orElseSome55,
  partitionMap: () => partitionMap65,
  product: () => product84,
  productMany: () => productMany84,
  reduceCompact: () => reduceCompact55,
  some: () => some235,
  tap: () => tap55,
  toArray: () => toArray55,
  toRefinement: () => toRefinement55,
  void: () => void_55,
  zipLeft: () => zipLeft55,
  zipRight: () => zipRight55,
  zipWith: () => zipWith65
});
var make235 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId335 = /* @__PURE__ */ Symbol.for("effect/Option");
var none235 = () => none84;
var some235 = some124;
var isOption235 = isOption84;
var isNone235 = isNone84;
var isSome235 = isSome84;
var match74 = /* @__PURE__ */ dual55(2, (self2, {
  onNone,
  onSome
}) => isNone235(self2) ? onNone() : onSome(self2.value));
var toRefinement55 = (f2222) => (a2222) => isSome235(f2222(a2222));
var fromIterable84 = (collection) => {
  for (const a2222 of collection) {
    return some235(a2222);
  }
  return none235();
};
var getRight235 = getRight84;
var getLeft235 = getLeft84;
var getOrElse55 = /* @__PURE__ */ dual55(2, (self2, onNone) => isNone235(self2) ? onNone() : self2.value);
var orElse55 = /* @__PURE__ */ dual55(2, (self2, that) => isNone235(self2) ? that() : self2);
var orElseSome55 = /* @__PURE__ */ dual55(2, (self2, onNone) => isNone235(self2) ? some235(onNone()) : self2);
var orElseEither55 = /* @__PURE__ */ dual55(2, (self2, that) => isNone235(self2) ? map65(that(), right65) : map65(self2, left65));
var firstSomeOf55 = (collection) => {
  let out = none235();
  for (out of collection) {
    if (isSome235(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable65 = (nullableValue) => nullableValue == null ? none235() : some235(nullableValue);
var liftNullable65 = (f2222) => (...a2222) => fromNullable65(f2222(...a2222));
var getOrNull55 = /* @__PURE__ */ getOrElse55(constNull55);
var getOrUndefined55 = /* @__PURE__ */ getOrElse55(constUndefined55);
var liftThrowable55 = (f2222) => (...a2222) => {
  try {
    return some235(f2222(...a2222));
  } catch (e2222) {
    return none235();
  }
};
var getOrThrowWith55 = /* @__PURE__ */ dual55(2, (self2, onNone) => {
  if (isSome235(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow55 = /* @__PURE__ */ getOrThrowWith55(() => new Error("getOrThrow called on a None"));
var map65 = /* @__PURE__ */ dual55(2, (self2, f2222) => isNone235(self2) ? none235() : some235(f2222(self2.value)));
var as55 = /* @__PURE__ */ dual55(2, (self2, b2222) => map65(self2, () => b2222));
var asVoid55 = /* @__PURE__ */ as55(void 0);
var void_55 = /* @__PURE__ */ some235(void 0);
var flatMap65 = /* @__PURE__ */ dual55(2, (self2, f2222) => isNone235(self2) ? none235() : f2222(self2.value));
var andThen55 = /* @__PURE__ */ dual55(2, (self2, f2222) => flatMap65(self2, (a2222) => {
  const b2222 = isFunction94(f2222) ? f2222(a2222) : f2222;
  return isOption235(b2222) ? b2222 : some235(b2222);
}));
var flatMapNullable65 = /* @__PURE__ */ dual55(2, (self2, f2222) => isNone235(self2) ? none235() : fromNullable65(f2222(self2.value)));
var flatten65 = /* @__PURE__ */ flatMap65(identity55);
var zipRight55 = /* @__PURE__ */ dual55(2, (self2, that) => flatMap65(self2, () => that));
var composeK55 = /* @__PURE__ */ dual55(2, (afb, bfc) => (a2222) => flatMap65(afb(a2222), bfc));
var zipLeft55 = /* @__PURE__ */ dual55(2, (self2, that) => tap55(self2, () => that));
var tap55 = /* @__PURE__ */ dual55(2, (self2, f2222) => flatMap65(self2, (a2222) => map65(f2222(a2222), () => a2222)));
var product84 = (self2, that) => isSome235(self2) && isSome235(that) ? some235([self2.value, that.value]) : none235();
var productMany84 = (self2, collection) => {
  if (isNone235(self2)) {
    return none235();
  }
  const out = [self2.value];
  for (const o2222 of collection) {
    if (isNone235(o2222)) {
      return none235();
    }
    out.push(o2222.value);
  }
  return some235(out);
};
var all84 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o2222 of input) {
      if (isNone235(o2222)) {
        return none235();
      }
      out2.push(o2222.value);
    }
    return some235(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o2222 = input[key];
    if (isNone235(o2222)) {
      return none235();
    }
    out[key] = o2222.value;
  }
  return some235(out);
};
var zipWith65 = /* @__PURE__ */ dual55(3, (self2, that, f2222) => map65(product84(self2, that), ([a2222, b2222]) => f2222(a2222, b2222)));
var ap55 = /* @__PURE__ */ dual55(2, (self2, that) => zipWith65(self2, that, (f2222, a2222) => f2222(a2222)));
var reduceCompact55 = /* @__PURE__ */ dual55(3, (self2, b2222, f2222) => {
  let out = b2222;
  for (const oa of self2) {
    if (isSome235(oa)) {
      out = f2222(out, oa.value);
    }
  }
  return out;
});
var toArray55 = (self2) => isNone235(self2) ? [] : [self2.value];
var partitionMap65 = /* @__PURE__ */ dual55(2, (self2, f2222) => {
  if (isNone235(self2)) {
    return [none235(), none235()];
  }
  const e2222 = f2222(self2.value);
  return isLeft65(e2222) ? [some235(e2222.left), none235()] : [none235(), some235(e2222.right)];
});
var filterMap65 = /* @__PURE__ */ dual55(2, (self2, f2222) => isNone235(self2) ? none235() : f2222(self2.value));
var filter65 = /* @__PURE__ */ dual55(2, (self2, predicate) => filterMap65(self2, (b2222) => predicate(b2222) ? some124(b2222) : none84));
var getEquivalence75 = (isEquivalent) => make164((x2222, y2222) => x2222 === y2222 || (isNone235(x2222) ? isNone235(y2222) : isNone235(y2222) ? false : isEquivalent(x2222.value, y2222.value)));
var getOrder65 = (O2222) => make235((self2, that) => isSome235(self2) ? isSome235(that) ? O2222(self2.value, that.value) : 1 : -1);
var lift255 = (f2222) => dual55(2, (self2, that) => zipWith65(self2, that, f2222));
var liftPredicate65 = (predicate) => (b2222) => predicate(b2222) ? some235(b2222) : none235();
var containsWith65 = (isEquivalent) => dual55(2, (self2, a2222) => isNone235(self2) ? false : isEquivalent(self2.value, a2222));
var _equivalence75 = /* @__PURE__ */ equivalence55();
var contains65 = /* @__PURE__ */ containsWith65(_equivalence75);
var exists55 = /* @__PURE__ */ dual55(2, (self2, refinement) => isNone235(self2) ? false : refinement(self2.value));
var bindTo235 = /* @__PURE__ */ bindTo94(map65);
var let_235 = /* @__PURE__ */ let_94(map65);
var bind235 = /* @__PURE__ */ bind94(map65, flatMap65);
var Do65 = /* @__PURE__ */ some235({});
var adapter235 = /* @__PURE__ */ adapter84();
var gen55 = (f2222) => {
  const iterator = f2222(adapter235);
  let state = iterator.next();
  if (state.done) {
    return some235(state.value);
  } else {
    let current = state.value;
    if (isGenKind55(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet55(current);
    }
    if (isNone235(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind55(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet55(current);
        }
        if (isNone235(current)) {
          return current;
        }
      }
    }
    return some235(state.value);
  }
};
var MutableRef_exports34 = {};
__export45(MutableRef_exports34, {
  compareAndSet: () => compareAndSet34,
  decrement: () => decrement34,
  decrementAndGet: () => decrementAndGet34,
  get: () => get44,
  getAndDecrement: () => getAndDecrement34,
  getAndIncrement: () => getAndIncrement34,
  getAndSet: () => getAndSet34,
  getAndUpdate: () => getAndUpdate34,
  increment: () => increment34,
  incrementAndGet: () => incrementAndGet34,
  make: () => make335,
  set: () => set45,
  setAndGet: () => setAndGet34,
  toggle: () => toggle34,
  update: () => update34,
  updateAndGet: () => updateAndGet34
});
var TypeId435 = /* @__PURE__ */ Symbol.for("effect/MutableRef");
var MutableRefProto34 = {
  [TypeId435]: TypeId435,
  toString() {
    return format55(this.toJSON());
  },
  toJSON() {
    return {
      _id: "MutableRef",
      current: toJSON55(this.current)
    };
  },
  [NodeInspectSymbol55]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments55(this, arguments);
  }
};
var make335 = (value) => {
  const ref = Object.create(MutableRefProto34);
  ref.current = value;
  return ref;
};
var compareAndSet34 = /* @__PURE__ */ dual55(3, (self2, oldValue, newValue) => {
  if (equals55(oldValue, self2.current)) {
    self2.current = newValue;
    return true;
  }
  return false;
});
var decrement34 = (self2) => update34(self2, (n2222) => n2222 - 1);
var decrementAndGet34 = (self2) => updateAndGet34(self2, (n2222) => n2222 - 1);
var get44 = (self2) => self2.current;
var getAndDecrement34 = (self2) => getAndUpdate34(self2, (n2222) => n2222 - 1);
var getAndIncrement34 = (self2) => getAndUpdate34(self2, (n2222) => n2222 + 1);
var getAndSet34 = /* @__PURE__ */ dual55(2, (self2, value) => {
  const ret = self2.current;
  self2.current = value;
  return ret;
});
var getAndUpdate34 = /* @__PURE__ */ dual55(2, (self2, f2222) => getAndSet34(self2, f2222(get44(self2))));
var increment34 = (self2) => update34(self2, (n2222) => n2222 + 1);
var incrementAndGet34 = (self2) => updateAndGet34(self2, (n2222) => n2222 + 1);
var set45 = /* @__PURE__ */ dual55(2, (self2, value) => {
  self2.current = value;
  return self2;
});
var setAndGet34 = /* @__PURE__ */ dual55(2, (self2, value) => {
  self2.current = value;
  return self2.current;
});
var update34 = /* @__PURE__ */ dual55(2, (self2, f2222) => set45(self2, f2222(get44(self2))));
var updateAndGet34 = /* @__PURE__ */ dual55(2, (self2, f2222) => setAndGet34(self2, f2222(get44(self2))));
var toggle34 = (self2) => update34(self2, (_2222) => !_2222);
function getVariables25(initialScope) {
  const scopeRef = MutableRef_exports34.make(initialScope);
  const variablesRef = MutableRef_exports34.make(MutableRef_exports34.get(scopeRef).variables);
  while (MutableRef_exports34.get(scopeRef).type !== scopeManager.ScopeType.global) {
    MutableRef_exports34.set(scopeRef, MutableRef_exports34.get(scopeRef).upper);
    MutableRef_exports34.update(variablesRef, (variables) => variables.concat(MutableRef_exports34.get(scopeRef).variables));
  }
  return MutableRef_exports34.get(variablesRef).reverse();
}
var findVariable35 = Function_exports55.dual(2, (name22, initialScope) => {
  return Option_exports55.fromNullable(getVariables25(initialScope).find((variable) => variable.name === name22));
});
var t224 = Symbol.for("@ts-pattern/matcher");
var e224 = Symbol.for("@ts-pattern/isVariadic");
var n224 = "@ts-pattern/anonymous-select-key";
var r224 = (t2222) => Boolean(t2222 && "object" == typeof t2222);
var i224 = (e2222) => e2222 && !!e2222[t224];
var o224 = (n2222, s2222, c2222) => {
  if (i224(n2222)) {
    const e2222 = n2222[t224](), { matched: r2222, selections: i2222 } = e2222.match(s2222);
    return r2222 && i2222 && Object.keys(i2222).forEach((t2222) => c2222(t2222, i2222[t2222])), r2222;
  }
  if (r224(n2222)) {
    if (!r224(s2222)) return false;
    if (Array.isArray(n2222)) {
      if (!Array.isArray(s2222)) return false;
      let t2222 = [], r2222 = [], a2222 = [];
      for (const o2222 of n2222.keys()) {
        const s322 = n2222[o2222];
        i224(s322) && s322[e224] ? a2222.push(s322) : a2222.length ? r2222.push(s322) : t2222.push(s322);
      }
      if (a2222.length) {
        if (a2222.length > 1) throw new Error("Pattern error: Using `...P.array(...)` several times in a single pattern is not allowed.");
        if (s2222.length < t2222.length + r2222.length) return false;
        const e2222 = s2222.slice(0, t2222.length), n322 = 0 === r2222.length ? [] : s2222.slice(-r2222.length), i2222 = s2222.slice(t2222.length, 0 === r2222.length ? Infinity : -r2222.length);
        return t2222.every((t322, n43) => o224(t322, e2222[n43], c2222)) && r2222.every((t322, e322) => o224(t322, n322[e322], c2222)) && (0 === a2222.length || o224(a2222[0], i2222, c2222));
      }
      return n2222.length === s2222.length && n2222.every((t322, e2222) => o224(t322, s2222[e2222], c2222));
    }
    return Object.keys(n2222).every((e2222) => {
      const r2222 = n2222[e2222];
      return (e2222 in s2222 || i224(a2222 = r2222) && "optional" === a2222[t224]().matcherType) && o224(r2222, s2222[e2222], c2222);
      var a2222;
    });
  }
  return Object.is(s2222, n2222);
};
var s224 = (e2222) => {
  var n2222, o2222, a2222;
  return r224(e2222) ? i224(e2222) ? null != (n2222 = null == (o2222 = (a2222 = e2222[t224]()).getSelectionKeys) ? void 0 : o2222.call(a2222)) ? n2222 : [] : Array.isArray(e2222) ? c224(e2222, s224) : c224(Object.values(e2222), s224) : [];
};
var c224 = (t2222, e2222) => t2222.reduce((t322, n2222) => t322.concat(e2222(n2222)), []);
function a224(...t2222) {
  if (1 === t2222.length) {
    const [e2222] = t2222;
    return (t322) => o224(e2222, t322, () => {
    });
  }
  if (2 === t2222.length) {
    const [e2222, n2222] = t2222;
    return o224(e2222, n2222, () => {
    });
  }
  throw new Error(`isMatching wasn't given the right number of arguments: expected 1 or 2, received ${t2222.length}.`);
}
function u224(t2222) {
  return Object.assign(t2222, { optional: () => l224(t2222), and: (e2222) => m224(t2222, e2222), or: (e2222) => d224(t2222, e2222), select: (e2222) => void 0 === e2222 ? p224(t2222) : p224(e2222, t2222) });
}
function h224(t2222) {
  return Object.assign(((t322) => Object.assign(t322, { [Symbol.iterator]() {
    let n2222 = 0;
    const r2222 = [{ value: Object.assign(t322, { [e224]: true }), done: false }, { done: true, value: void 0 }];
    return { next: () => {
      var t43;
      return null != (t43 = r2222[n2222++]) ? t43 : r2222.at(-1);
    } };
  } }))(t2222), { optional: () => h224(l224(t2222)), select: (e2222) => h224(void 0 === e2222 ? p224(t2222) : p224(e2222, t2222)) });
}
function l224(e2222) {
  return u224({ [t224]: () => ({ match: (t2222) => {
    let n2222 = {};
    const r2222 = (t322, e322) => {
      n2222[t322] = e322;
    };
    return void 0 === t2222 ? (s224(e2222).forEach((t322) => r2222(t322, void 0)), { matched: true, selections: n2222 }) : { matched: o224(e2222, t2222, r2222), selections: n2222 };
  }, getSelectionKeys: () => s224(e2222), matcherType: "optional" }) });
}
var f224 = (t2222, e2222) => {
  for (const n2222 of t2222) if (!e2222(n2222)) return false;
  return true;
};
var g224 = (t2222, e2222) => {
  for (const [n2222, r2222] of t2222.entries()) if (!e2222(r2222, n2222)) return false;
  return true;
};
function m224(...e2222) {
  return u224({ [t224]: () => ({ match: (t2222) => {
    let n2222 = {};
    const r2222 = (t322, e322) => {
      n2222[t322] = e322;
    };
    return { matched: e2222.every((e322) => o224(e322, t2222, r2222)), selections: n2222 };
  }, getSelectionKeys: () => c224(e2222, s224), matcherType: "and" }) });
}
function d224(...e2222) {
  return u224({ [t224]: () => ({ match: (t2222) => {
    let n2222 = {};
    const r2222 = (t322, e322) => {
      n2222[t322] = e322;
    };
    return c224(e2222, s224).forEach((t322) => r2222(t322, void 0)), { matched: e2222.some((e322) => o224(e322, t2222, r2222)), selections: n2222 };
  }, getSelectionKeys: () => c224(e2222, s224), matcherType: "or" }) });
}
function y224(e2222) {
  return { [t224]: () => ({ match: (t2222) => ({ matched: Boolean(e2222(t2222)) }) }) };
}
function p224(...e2222) {
  const r2222 = "string" == typeof e2222[0] ? e2222[0] : void 0, i2222 = 2 === e2222.length ? e2222[1] : "string" == typeof e2222[0] ? void 0 : e2222[0];
  return u224({ [t224]: () => ({ match: (t2222) => {
    let e322 = { [null != r2222 ? r2222 : n224]: t2222 };
    return { matched: void 0 === i2222 || o224(i2222, t2222, (t322, n2222) => {
      e322[t322] = n2222;
    }), selections: e322 };
  }, getSelectionKeys: () => [null != r2222 ? r2222 : n224].concat(void 0 === i2222 ? [] : s224(i2222)) }) });
}
function v224(t2222) {
  return "number" == typeof t2222;
}
function b224(t2222) {
  return "string" == typeof t2222;
}
function w224(t2222) {
  return "bigint" == typeof t2222;
}
var S224 = u224(y224(function(t2222) {
  return true;
}));
var O224 = S224;
var j224 = (t2222) => Object.assign(u224(t2222), { startsWith: (e2222) => {
  return j224(m224(t2222, (n2222 = e2222, y224((t322) => b224(t322) && t322.startsWith(n2222)))));
  var n2222;
}, endsWith: (e2222) => {
  return j224(m224(t2222, (n2222 = e2222, y224((t322) => b224(t322) && t322.endsWith(n2222)))));
  var n2222;
}, minLength: (e2222) => j224(m224(t2222, ((t322) => y224((e322) => b224(e322) && e322.length >= t322))(e2222))), maxLength: (e2222) => j224(m224(t2222, ((t322) => y224((e322) => b224(e322) && e322.length <= t322))(e2222))), includes: (e2222) => {
  return j224(m224(t2222, (n2222 = e2222, y224((t322) => b224(t322) && t322.includes(n2222)))));
  var n2222;
}, regex: (e2222) => {
  return j224(m224(t2222, (n2222 = e2222, y224((t322) => b224(t322) && Boolean(t322.match(n2222))))));
  var n2222;
} });
var E224 = j224(y224(b224));
var K224 = (t2222) => Object.assign(u224(t2222), { between: (e2222, n2222) => K224(m224(t2222, ((t322, e322) => y224((n322) => v224(n322) && t322 <= n322 && e322 >= n322))(e2222, n2222))), lt: (e2222) => K224(m224(t2222, ((t322) => y224((e322) => v224(e322) && e322 < t322))(e2222))), gt: (e2222) => K224(m224(t2222, ((t322) => y224((e322) => v224(e322) && e322 > t322))(e2222))), lte: (e2222) => K224(m224(t2222, ((t322) => y224((e322) => v224(e322) && e322 <= t322))(e2222))), gte: (e2222) => K224(m224(t2222, ((t322) => y224((e322) => v224(e322) && e322 >= t322))(e2222))), int: () => K224(m224(t2222, y224((t322) => v224(t322) && Number.isInteger(t322)))), finite: () => K224(m224(t2222, y224((t322) => v224(t322) && Number.isFinite(t322)))), positive: () => K224(m224(t2222, y224((t322) => v224(t322) && t322 > 0))), negative: () => K224(m224(t2222, y224((t322) => v224(t322) && t322 < 0))) });
var x224 = K224(y224(v224));
var A224 = (t2222) => Object.assign(u224(t2222), { between: (e2222, n2222) => A224(m224(t2222, ((t322, e322) => y224((n322) => w224(n322) && t322 <= n322 && e322 >= n322))(e2222, n2222))), lt: (e2222) => A224(m224(t2222, ((t322) => y224((e322) => w224(e322) && e322 < t322))(e2222))), gt: (e2222) => A224(m224(t2222, ((t322) => y224((e322) => w224(e322) && e322 > t322))(e2222))), lte: (e2222) => A224(m224(t2222, ((t322) => y224((e322) => w224(e322) && e322 <= t322))(e2222))), gte: (e2222) => A224(m224(t2222, ((t322) => y224((e322) => w224(e322) && e322 >= t322))(e2222))), positive: () => A224(m224(t2222, y224((t322) => w224(t322) && t322 > 0))), negative: () => A224(m224(t2222, y224((t322) => w224(t322) && t322 < 0))) });
var P34 = A224(y224(w224));
var T224 = u224(y224(function(t2222) {
  return "boolean" == typeof t2222;
}));
var k224 = u224(y224(function(t2222) {
  return "symbol" == typeof t2222;
}));
var B224 = u224(y224(function(t2222) {
  return null == t2222;
}));
var _224 = u224(y224(function(t2222) {
  return null != t2222;
}));
var N224 = { __proto__: null, matcher: t224, optional: l224, array: function(...e2222) {
  return h224({ [t224]: () => ({ match: (t2222) => {
    if (!Array.isArray(t2222)) return { matched: false };
    if (0 === e2222.length) return { matched: true };
    const n2222 = e2222[0];
    let r2222 = {};
    if (0 === t2222.length) return s224(n2222).forEach((t322) => {
      r2222[t322] = [];
    }), { matched: true, selections: r2222 };
    const i2222 = (t322, e322) => {
      r2222[t322] = (r2222[t322] || []).concat([e322]);
    };
    return { matched: t2222.every((t322) => o224(n2222, t322, i2222)), selections: r2222 };
  }, getSelectionKeys: () => 0 === e2222.length ? [] : s224(e2222[0]) }) });
}, set: function(...e2222) {
  return u224({ [t224]: () => ({ match: (t2222) => {
    if (!(t2222 instanceof Set)) return { matched: false };
    let n2222 = {};
    if (0 === t2222.size) return { matched: true, selections: n2222 };
    if (0 === e2222.length) return { matched: true };
    const r2222 = (t322, e322) => {
      n2222[t322] = (n2222[t322] || []).concat([e322]);
    }, i2222 = e2222[0];
    return { matched: f224(t2222, (t322) => o224(i2222, t322, r2222)), selections: n2222 };
  }, getSelectionKeys: () => 0 === e2222.length ? [] : s224(e2222[0]) }) });
}, map: function(...e2222) {
  return u224({ [t224]: () => ({ match: (t2222) => {
    if (!(t2222 instanceof Map)) return { matched: false };
    let n2222 = {};
    if (0 === t2222.size) return { matched: true, selections: n2222 };
    const r2222 = (t322, e322) => {
      n2222[t322] = (n2222[t322] || []).concat([e322]);
    };
    if (0 === e2222.length) return { matched: true };
    var i2222;
    if (1 === e2222.length) throw new Error(`\`P.map\` wasn't given enough arguments. Expected (key, value), received ${null == (i2222 = e2222[0]) ? void 0 : i2222.toString()}`);
    const [s2222, c2222] = e2222;
    return { matched: g224(t2222, (t322, e322) => {
      const n322 = o224(s2222, e322, r2222), i322 = o224(c2222, t322, r2222);
      return n322 && i322;
    }), selections: n2222 };
  }, getSelectionKeys: () => 0 === e2222.length ? [] : [...s224(e2222[0]), ...s224(e2222[1])] }) });
}, intersection: m224, union: d224, not: function(e2222) {
  return u224({ [t224]: () => ({ match: (t2222) => ({ matched: !o224(e2222, t2222, () => {
  }) }), getSelectionKeys: () => [], matcherType: "not" }) });
}, when: y224, select: p224, any: S224, _: O224, string: E224, number: x224, bigint: P34, boolean: T224, symbol: k224, nullish: B224, nonNullable: _224, instanceOf: function(t2222) {
  return u224(y224(/* @__PURE__ */ function(t322) {
    return (e2222) => e2222 instanceof t322;
  }(t2222)));
}, shape: function(t2222) {
  return u224(y224(a224(t2222)));
} };
var KEYS35 = {
  ArrayExpression: [
    "elements"
  ],
  ArrayPattern: [
    "elements"
  ],
  ArrowFunctionExpression: [
    "params",
    "body"
  ],
  AssignmentExpression: [
    "left",
    "right"
  ],
  AssignmentPattern: [
    "left",
    "right"
  ],
  AwaitExpression: [
    "argument"
  ],
  BinaryExpression: [
    "left",
    "right"
  ],
  BlockStatement: [
    "body"
  ],
  BreakStatement: [
    "label"
  ],
  CallExpression: [
    "callee",
    "arguments"
  ],
  CatchClause: [
    "param",
    "body"
  ],
  ChainExpression: [
    "expression"
  ],
  ClassBody: [
    "body"
  ],
  ClassDeclaration: [
    "id",
    "superClass",
    "body"
  ],
  ClassExpression: [
    "id",
    "superClass",
    "body"
  ],
  ConditionalExpression: [
    "test",
    "consequent",
    "alternate"
  ],
  ContinueStatement: [
    "label"
  ],
  DebuggerStatement: [],
  DoWhileStatement: [
    "body",
    "test"
  ],
  EmptyStatement: [],
  ExperimentalRestProperty: [
    "argument"
  ],
  ExperimentalSpreadProperty: [
    "argument"
  ],
  ExportAllDeclaration: [
    "exported",
    "source"
  ],
  ExportDefaultDeclaration: [
    "declaration"
  ],
  ExportNamedDeclaration: [
    "declaration",
    "specifiers",
    "source"
  ],
  ExportSpecifier: [
    "exported",
    "local"
  ],
  ExpressionStatement: [
    "expression"
  ],
  ForInStatement: [
    "left",
    "right",
    "body"
  ],
  ForOfStatement: [
    "left",
    "right",
    "body"
  ],
  ForStatement: [
    "init",
    "test",
    "update",
    "body"
  ],
  FunctionDeclaration: [
    "id",
    "params",
    "body"
  ],
  FunctionExpression: [
    "id",
    "params",
    "body"
  ],
  Identifier: [],
  IfStatement: [
    "test",
    "consequent",
    "alternate"
  ],
  ImportDeclaration: [
    "specifiers",
    "source"
  ],
  ImportDefaultSpecifier: [
    "local"
  ],
  ImportExpression: [
    "source"
  ],
  ImportNamespaceSpecifier: [
    "local"
  ],
  ImportSpecifier: [
    "imported",
    "local"
  ],
  JSXAttribute: [
    "name",
    "value"
  ],
  JSXClosingElement: [
    "name"
  ],
  JSXClosingFragment: [],
  JSXElement: [
    "openingElement",
    "children",
    "closingElement"
  ],
  JSXEmptyExpression: [],
  JSXExpressionContainer: [
    "expression"
  ],
  JSXFragment: [
    "openingFragment",
    "children",
    "closingFragment"
  ],
  JSXIdentifier: [],
  JSXMemberExpression: [
    "object",
    "property"
  ],
  JSXNamespacedName: [
    "namespace",
    "name"
  ],
  JSXOpeningElement: [
    "name",
    "attributes"
  ],
  JSXOpeningFragment: [],
  JSXSpreadAttribute: [
    "argument"
  ],
  JSXSpreadChild: [
    "expression"
  ],
  JSXText: [],
  LabeledStatement: [
    "label",
    "body"
  ],
  Literal: [],
  LogicalExpression: [
    "left",
    "right"
  ],
  MemberExpression: [
    "object",
    "property"
  ],
  MetaProperty: [
    "meta",
    "property"
  ],
  MethodDefinition: [
    "key",
    "value"
  ],
  NewExpression: [
    "callee",
    "arguments"
  ],
  ObjectExpression: [
    "properties"
  ],
  ObjectPattern: [
    "properties"
  ],
  PrivateIdentifier: [],
  Program: [
    "body"
  ],
  Property: [
    "key",
    "value"
  ],
  PropertyDefinition: [
    "key",
    "value"
  ],
  RestElement: [
    "argument"
  ],
  ReturnStatement: [
    "argument"
  ],
  SequenceExpression: [
    "expressions"
  ],
  SpreadElement: [
    "argument"
  ],
  StaticBlock: [
    "body"
  ],
  Super: [],
  SwitchCase: [
    "test",
    "consequent"
  ],
  SwitchStatement: [
    "discriminant",
    "cases"
  ],
  TaggedTemplateExpression: [
    "tag",
    "quasi"
  ],
  TemplateElement: [],
  TemplateLiteral: [
    "quasis",
    "expressions"
  ],
  ThisExpression: [],
  ThrowStatement: [
    "argument"
  ],
  TryStatement: [
    "block",
    "handler",
    "finalizer"
  ],
  UnaryExpression: [
    "argument"
  ],
  UpdateExpression: [
    "argument"
  ],
  VariableDeclaration: [
    "declarations"
  ],
  VariableDeclarator: [
    "id",
    "init"
  ],
  WhileStatement: [
    "test",
    "body"
  ],
  WithStatement: [
    "object",
    "body"
  ],
  YieldExpression: [
    "argument"
  ]
};
var NODE_TYPES35 = Object.keys(KEYS35);
for (const type of NODE_TYPES35) {
  Object.freeze(KEYS35[type]);
}
Object.freeze(KEYS35);
var visitor_keys_default35 = KEYS35;
var KEY_BLACKLIST35 = /* @__PURE__ */ new Set([
  "parent",
  "leadingComments",
  "trailingComments"
]);
function filterKey35(key) {
  return !KEY_BLACKLIST35.has(key) && key[0] !== "_";
}
function getKeys35(node) {
  return Object.keys(node).filter(filterKey35);
}
function getInnermostScope35(initialScope, node) {
  const location = node.range[0];
  let scope = initialScope;
  let found = false;
  do {
    found = false;
    for (const childScope of scope.childScopes) {
      const range222 = childScope.block.range;
      if (range222[0] <= location && location < range222[1]) {
        scope = childScope;
        found = true;
        break;
      }
    }
  } while (found);
  return scope;
}
function findVariable235(initialScope, nameOrNode) {
  let name22 = "";
  let scope = initialScope;
  if (typeof nameOrNode === "string") {
    name22 = nameOrNode;
  } else {
    name22 = nameOrNode.name;
    scope = getInnermostScope35(scope, nameOrNode);
  }
  while (scope != null) {
    const variable = scope.set.get(name22);
    if (variable != null) {
      return variable;
    }
    scope = scope.upper;
  }
  return null;
}
function negate035(token) {
  return !this(token);
}
function negate35(f2222) {
  return negate035.bind(f2222);
}
function isPunctuatorTokenWithValue35(token, value) {
  return token.type === "Punctuator" && token.value === value;
}
function isArrowToken35(token) {
  return isPunctuatorTokenWithValue35(token, "=>");
}
function isCommaToken35(token) {
  return isPunctuatorTokenWithValue35(token, ",");
}
function isSemicolonToken35(token) {
  return isPunctuatorTokenWithValue35(token, ";");
}
function isColonToken35(token) {
  return isPunctuatorTokenWithValue35(token, ":");
}
function isOpeningParenToken35(token) {
  return isPunctuatorTokenWithValue35(token, "(");
}
function isClosingParenToken35(token) {
  return isPunctuatorTokenWithValue35(token, ")");
}
function isOpeningBracketToken35(token) {
  return isPunctuatorTokenWithValue35(token, "[");
}
function isClosingBracketToken35(token) {
  return isPunctuatorTokenWithValue35(token, "]");
}
function isOpeningBraceToken35(token) {
  return isPunctuatorTokenWithValue35(token, "{");
}
function isClosingBraceToken35(token) {
  return isPunctuatorTokenWithValue35(token, "}");
}
function isCommentToken35(token) {
  return ["Block", "Line", "Shebang"].includes(token.type);
}
negate35(isArrowToken35);
negate35(isCommaToken35);
negate35(isSemicolonToken35);
negate35(isColonToken35);
negate35(isOpeningParenToken35);
negate35(isClosingParenToken35);
negate35(isOpeningBracketToken35);
negate35(isClosingBracketToken35);
negate35(isOpeningBraceToken35);
negate35(isClosingBraceToken35);
negate35(isCommentToken35);
function getOpeningParenOfParams35(node, sourceCode) {
  return node.id ? sourceCode.getTokenAfter(node.id, isOpeningParenToken35) : sourceCode.getFirstToken(node, isOpeningParenToken35);
}
function getFunctionHeadLocation35(node, sourceCode) {
  const parent = node.parent;
  let start = null;
  let end = null;
  if (node.type === "ArrowFunctionExpression") {
    const arrowToken = sourceCode.getTokenBefore(node.body, isArrowToken35);
    start = arrowToken.loc.start;
    end = arrowToken.loc.end;
  } else if (parent.type === "Property" || parent.type === "MethodDefinition" || parent.type === "PropertyDefinition") {
    start = parent.loc.start;
    end = getOpeningParenOfParams35(node, sourceCode).loc.start;
  } else {
    start = node.loc.start;
    end = getOpeningParenOfParams35(node, sourceCode).loc.start;
  }
  return {
    start: { ...start },
    end: { ...end }
  };
}
var globalObject35 = typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {};
var builtinNames35 = Object.freeze(
  /* @__PURE__ */ new Set([
    "Array",
    "ArrayBuffer",
    "BigInt",
    "BigInt64Array",
    "BigUint64Array",
    "Boolean",
    "DataView",
    "Date",
    "decodeURI",
    "decodeURIComponent",
    "encodeURI",
    "encodeURIComponent",
    "escape",
    "Float32Array",
    "Float64Array",
    "Function",
    "Infinity",
    "Int16Array",
    "Int32Array",
    "Int8Array",
    "isFinite",
    "isNaN",
    "isPrototypeOf",
    "JSON",
    "Map",
    "Math",
    "NaN",
    "Number",
    "Object",
    "parseFloat",
    "parseInt",
    "Promise",
    "Proxy",
    "Reflect",
    "RegExp",
    "Set",
    "String",
    "Symbol",
    "Uint16Array",
    "Uint32Array",
    "Uint8Array",
    "Uint8ClampedArray",
    "undefined",
    "unescape",
    "WeakMap",
    "WeakSet"
  ])
);
var callAllowed35 = new Set(
  [
    Array.isArray,
    Array.of,
    Array.prototype.at,
    Array.prototype.concat,
    Array.prototype.entries,
    Array.prototype.every,
    Array.prototype.filter,
    Array.prototype.find,
    Array.prototype.findIndex,
    Array.prototype.flat,
    Array.prototype.includes,
    Array.prototype.indexOf,
    Array.prototype.join,
    Array.prototype.keys,
    Array.prototype.lastIndexOf,
    Array.prototype.slice,
    Array.prototype.some,
    Array.prototype.toString,
    Array.prototype.values,
    typeof BigInt === "function" ? BigInt : void 0,
    Boolean,
    Date,
    Date.parse,
    decodeURI,
    decodeURIComponent,
    encodeURI,
    encodeURIComponent,
    escape,
    isFinite,
    isNaN,
    isPrototypeOf,
    Map,
    Map.prototype.entries,
    Map.prototype.get,
    Map.prototype.has,
    Map.prototype.keys,
    Map.prototype.values,
    ...Object.getOwnPropertyNames(Math).filter((k2222) => k2222 !== "random").map((k2222) => Math[k2222]).filter((f2222) => typeof f2222 === "function"),
    Number,
    Number.isFinite,
    Number.isNaN,
    Number.parseFloat,
    Number.parseInt,
    Number.prototype.toExponential,
    Number.prototype.toFixed,
    Number.prototype.toPrecision,
    Number.prototype.toString,
    Object,
    Object.entries,
    Object.is,
    Object.isExtensible,
    Object.isFrozen,
    Object.isSealed,
    Object.keys,
    Object.values,
    parseFloat,
    parseInt,
    RegExp,
    Set,
    Set.prototype.entries,
    Set.prototype.has,
    Set.prototype.keys,
    Set.prototype.values,
    String,
    String.fromCharCode,
    String.fromCodePoint,
    String.raw,
    String.prototype.at,
    String.prototype.charAt,
    String.prototype.charCodeAt,
    String.prototype.codePointAt,
    String.prototype.concat,
    String.prototype.endsWith,
    String.prototype.includes,
    String.prototype.indexOf,
    String.prototype.lastIndexOf,
    String.prototype.normalize,
    String.prototype.padEnd,
    String.prototype.padStart,
    String.prototype.slice,
    String.prototype.startsWith,
    String.prototype.substr,
    String.prototype.substring,
    String.prototype.toLowerCase,
    String.prototype.toString,
    String.prototype.toUpperCase,
    String.prototype.trim,
    String.prototype.trimEnd,
    String.prototype.trimLeft,
    String.prototype.trimRight,
    String.prototype.trimStart,
    Symbol.for,
    Symbol.keyFor,
    unescape
  ].filter((f2222) => typeof f2222 === "function")
);
var callPassThrough35 = /* @__PURE__ */ new Set([
  Object.freeze,
  Object.preventExtensions,
  Object.seal
]);
var getterAllowed35 = [
  [Map, /* @__PURE__ */ new Set(["size"])],
  [
    RegExp,
    /* @__PURE__ */ new Set([
      "dotAll",
      "flags",
      "global",
      "hasIndices",
      "ignoreCase",
      "multiline",
      "source",
      "sticky",
      "unicode"
    ])
  ],
  [Set, /* @__PURE__ */ new Set(["size"])]
];
function getPropertyDescriptor35(object222, name22) {
  let x2222 = object222;
  while ((typeof x2222 === "object" || typeof x2222 === "function") && x2222 !== null) {
    const d2222 = Object.getOwnPropertyDescriptor(x2222, name22);
    if (d2222) {
      return d2222;
    }
    x2222 = Object.getPrototypeOf(x2222);
  }
  return null;
}
function isGetter35(object222, name22) {
  const d2222 = getPropertyDescriptor35(object222, name22);
  return d2222 != null && d2222.get != null;
}
function getElementValues35(nodeList, initialScope) {
  const valueList = [];
  for (let i2222 = 0; i2222 < nodeList.length; ++i2222) {
    const elementNode = nodeList[i2222];
    if (elementNode == null) {
      valueList.length = i2222 + 1;
    } else if (elementNode.type === "SpreadElement") {
      const argument = getStaticValueR35(elementNode.argument, initialScope);
      if (argument == null) {
        return null;
      }
      valueList.push(...argument.value);
    } else {
      const element = getStaticValueR35(elementNode, initialScope);
      if (element == null) {
        return null;
      }
      valueList.push(element.value);
    }
  }
  return valueList;
}
function isEffectivelyConst35(variable) {
  const refs = variable.references;
  const inits = refs.filter((r2222) => r2222.init).length;
  const reads = refs.filter((r2222) => r2222.isReadOnly()).length;
  if (inits === 1 && reads + inits === refs.length) {
    return true;
  }
  return false;
}
var operations35 = Object.freeze({
  ArrayExpression(node, initialScope) {
    const elements = getElementValues35(node.elements, initialScope);
    return elements != null ? { value: elements } : null;
  },
  AssignmentExpression(node, initialScope) {
    if (node.operator === "=") {
      return getStaticValueR35(node.right, initialScope);
    }
    return null;
  },
  //eslint-disable-next-line complexity
  BinaryExpression(node, initialScope) {
    if (node.operator === "in" || node.operator === "instanceof") {
      return null;
    }
    const left3322 = getStaticValueR35(node.left, initialScope);
    const right3322 = getStaticValueR35(node.right, initialScope);
    if (left3322 != null && right3322 != null) {
      switch (node.operator) {
        case "==":
          return { value: left3322.value == right3322.value };
        case "!=":
          return { value: left3322.value != right3322.value };
        case "===":
          return { value: left3322.value === right3322.value };
        case "!==":
          return { value: left3322.value !== right3322.value };
        case "<":
          return { value: left3322.value < right3322.value };
        case "<=":
          return { value: left3322.value <= right3322.value };
        case ">":
          return { value: left3322.value > right3322.value };
        case ">=":
          return { value: left3322.value >= right3322.value };
        case "<<":
          return { value: left3322.value << right3322.value };
        case ">>":
          return { value: left3322.value >> right3322.value };
        case ">>>":
          return { value: left3322.value >>> right3322.value };
        case "+":
          return { value: left3322.value + right3322.value };
        case "-":
          return { value: left3322.value - right3322.value };
        case "*":
          return { value: left3322.value * right3322.value };
        case "/":
          return { value: left3322.value / right3322.value };
        case "%":
          return { value: left3322.value % right3322.value };
        case "**":
          return { value: left3322.value ** right3322.value };
        case "|":
          return { value: left3322.value | right3322.value };
        case "^":
          return { value: left3322.value ^ right3322.value };
        case "&":
          return { value: left3322.value & right3322.value };
      }
    }
    return null;
  },
  CallExpression(node, initialScope) {
    const calleeNode = node.callee;
    const args = getElementValues35(node.arguments, initialScope);
    if (args != null) {
      if (calleeNode.type === "MemberExpression") {
        if (calleeNode.property.type === "PrivateIdentifier") {
          return null;
        }
        const object222 = getStaticValueR35(calleeNode.object, initialScope);
        if (object222 != null) {
          if (object222.value == null && (object222.optional || node.optional)) {
            return { value: void 0, optional: true };
          }
          const property = getStaticPropertyNameValue35(
            calleeNode,
            initialScope
          );
          if (property != null) {
            const receiver = object222.value;
            const methodName = property.value;
            if (callAllowed35.has(receiver[methodName])) {
              return { value: receiver[methodName](...args) };
            }
            if (callPassThrough35.has(receiver[methodName])) {
              return { value: args[0] };
            }
          }
        }
      } else {
        const callee = getStaticValueR35(calleeNode, initialScope);
        if (callee != null) {
          if (callee.value == null && node.optional) {
            return { value: void 0, optional: true };
          }
          const func = callee.value;
          if (callAllowed35.has(func)) {
            return { value: func(...args) };
          }
          if (callPassThrough35.has(func)) {
            return { value: args[0] };
          }
        }
      }
    }
    return null;
  },
  ConditionalExpression(node, initialScope) {
    const test = getStaticValueR35(node.test, initialScope);
    if (test != null) {
      return test.value ? getStaticValueR35(node.consequent, initialScope) : getStaticValueR35(node.alternate, initialScope);
    }
    return null;
  },
  ExpressionStatement(node, initialScope) {
    return getStaticValueR35(node.expression, initialScope);
  },
  Identifier(node, initialScope) {
    if (initialScope != null) {
      const variable = findVariable235(initialScope, node);
      if (variable != null && variable.defs.length === 0 && builtinNames35.has(variable.name) && variable.name in globalObject35) {
        return { value: globalObject35[variable.name] };
      }
      if (variable != null && variable.defs.length === 1) {
        const def = variable.defs[0];
        if (def.parent && def.type === "Variable" && (def.parent.kind === "const" || isEffectivelyConst35(variable)) && // TODO(mysticatea): don't support destructuring here.
        def.node.id.type === "Identifier") {
          return getStaticValueR35(def.node.init, initialScope);
        }
      }
    }
    return null;
  },
  Literal(node) {
    if ((node.regex != null || node.bigint != null) && node.value == null) {
      return null;
    }
    return { value: node.value };
  },
  LogicalExpression(node, initialScope) {
    const left3322 = getStaticValueR35(node.left, initialScope);
    if (left3322 != null) {
      if (node.operator === "||" && Boolean(left3322.value) === true || node.operator === "&&" && Boolean(left3322.value) === false || node.operator === "??" && left3322.value != null) {
        return left3322;
      }
      const right3322 = getStaticValueR35(node.right, initialScope);
      if (right3322 != null) {
        return right3322;
      }
    }
    return null;
  },
  MemberExpression(node, initialScope) {
    if (node.property.type === "PrivateIdentifier") {
      return null;
    }
    const object222 = getStaticValueR35(node.object, initialScope);
    if (object222 != null) {
      if (object222.value == null && (object222.optional || node.optional)) {
        return { value: void 0, optional: true };
      }
      const property = getStaticPropertyNameValue35(node, initialScope);
      if (property != null) {
        if (!isGetter35(object222.value, property.value)) {
          return { value: object222.value[property.value] };
        }
        for (const [classFn, allowed] of getterAllowed35) {
          if (object222.value instanceof classFn && allowed.has(property.value)) {
            return { value: object222.value[property.value] };
          }
        }
      }
    }
    return null;
  },
  ChainExpression(node, initialScope) {
    const expression = getStaticValueR35(node.expression, initialScope);
    if (expression != null) {
      return { value: expression.value };
    }
    return null;
  },
  NewExpression(node, initialScope) {
    const callee = getStaticValueR35(node.callee, initialScope);
    const args = getElementValues35(node.arguments, initialScope);
    if (callee != null && args != null) {
      const Func = callee.value;
      if (callAllowed35.has(Func)) {
        return { value: new Func(...args) };
      }
    }
    return null;
  },
  ObjectExpression(node, initialScope) {
    const object222 = {};
    for (const propertyNode of node.properties) {
      if (propertyNode.type === "Property") {
        if (propertyNode.kind !== "init") {
          return null;
        }
        const key = getStaticPropertyNameValue35(
          propertyNode,
          initialScope
        );
        const value = getStaticValueR35(propertyNode.value, initialScope);
        if (key == null || value == null) {
          return null;
        }
        object222[key.value] = value.value;
      } else if (propertyNode.type === "SpreadElement" || propertyNode.type === "ExperimentalSpreadProperty") {
        const argument = getStaticValueR35(
          propertyNode.argument,
          initialScope
        );
        if (argument == null) {
          return null;
        }
        Object.assign(object222, argument.value);
      } else {
        return null;
      }
    }
    return { value: object222 };
  },
  SequenceExpression(node, initialScope) {
    const last222 = node.expressions[node.expressions.length - 1];
    return getStaticValueR35(last222, initialScope);
  },
  TaggedTemplateExpression(node, initialScope) {
    const tag = getStaticValueR35(node.tag, initialScope);
    const expressions = getElementValues35(
      node.quasi.expressions,
      initialScope
    );
    if (tag != null && expressions != null) {
      const func = tag.value;
      const strings = node.quasi.quasis.map((q) => q.value.cooked);
      strings.raw = node.quasi.quasis.map((q) => q.value.raw);
      if (func === String.raw) {
        return { value: func(strings, ...expressions) };
      }
    }
    return null;
  },
  TemplateLiteral(node, initialScope) {
    const expressions = getElementValues35(node.expressions, initialScope);
    if (expressions != null) {
      let value = node.quasis[0].value.cooked;
      for (let i2222 = 0; i2222 < expressions.length; ++i2222) {
        value += expressions[i2222];
        value += node.quasis[i2222 + 1].value.cooked;
      }
      return { value };
    }
    return null;
  },
  UnaryExpression(node, initialScope) {
    if (node.operator === "delete") {
      return null;
    }
    if (node.operator === "void") {
      return { value: void 0 };
    }
    const arg = getStaticValueR35(node.argument, initialScope);
    if (arg != null) {
      switch (node.operator) {
        case "-":
          return { value: -arg.value };
        case "+":
          return { value: +arg.value };
        case "!":
          return { value: !arg.value };
        case "~":
          return { value: ~arg.value };
        case "typeof":
          return { value: typeof arg.value };
      }
    }
    return null;
  }
});
function getStaticValueR35(node, initialScope) {
  if (node != null && Object.hasOwnProperty.call(operations35, node.type)) {
    return operations35[node.type](node, initialScope);
  }
  return null;
}
function getStaticPropertyNameValue35(node, initialScope) {
  const nameNode = node.type === "Property" ? node.key : node.property;
  if (node.computed) {
    return getStaticValueR35(nameNode, initialScope);
  }
  if (nameNode.type === "Identifier") {
    return { value: nameNode.name };
  }
  if (nameNode.type === "Literal") {
    if (nameNode.bigint) {
      return { value: nameNode.bigint };
    }
    return { value: String(nameNode.value) };
  }
  return null;
}
function getStaticValue45(node, initialScope = null) {
  try {
    return getStaticValueR35(node, initialScope);
  } catch (_error) {
    return null;
  }
}
function getStringIfConstant35(node, initialScope = null) {
  if (node && node.type === "Literal" && node.value === null) {
    if (node.regex) {
      return `/${node.regex.pattern}/${node.regex.flags}`;
    }
    if (node.bigint) {
      return node.bigint;
    }
  }
  const evaluated = getStaticValue45(node, initialScope);
  return evaluated && String(evaluated.value);
}
function getPropertyName35(node, initialScope) {
  switch (node.type) {
    case "MemberExpression":
      if (node.computed) {
        return getStringIfConstant35(node.property, initialScope);
      }
      if (node.property.type === "PrivateIdentifier") {
        return null;
      }
      return node.property.name;
    case "Property":
    case "MethodDefinition":
    case "PropertyDefinition":
      if (node.computed) {
        return getStringIfConstant35(node.key, initialScope);
      }
      if (node.key.type === "Literal") {
        return String(node.key.value);
      }
      if (node.key.type === "PrivateIdentifier") {
        return null;
      }
      return node.key.name;
  }
  return null;
}
function getFunctionNameWithKind35(node, sourceCode) {
  const parent = node.parent;
  const tokens = [];
  const isObjectMethod = parent.type === "Property" && parent.value === node;
  const isClassMethod = parent.type === "MethodDefinition" && parent.value === node;
  const isClassFieldMethod = parent.type === "PropertyDefinition" && parent.value === node;
  if (isClassMethod || isClassFieldMethod) {
    if (parent.static) {
      tokens.push("static");
    }
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push("private");
    }
  }
  if (node.async) {
    tokens.push("async");
  }
  if (node.generator) {
    tokens.push("generator");
  }
  if (isObjectMethod || isClassMethod) {
    if (parent.kind === "constructor") {
      return "constructor";
    }
    if (parent.kind === "get") {
      tokens.push("getter");
    } else if (parent.kind === "set") {
      tokens.push("setter");
    } else {
      tokens.push("method");
    }
  } else if (isClassFieldMethod) {
    tokens.push("method");
  } else {
    if (node.type === "ArrowFunctionExpression") {
      tokens.push("arrow");
    }
    tokens.push("function");
  }
  if (isObjectMethod || isClassMethod || isClassFieldMethod) {
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push(`#${parent.key.name}`);
    } else {
      const name22 = getPropertyName35(parent);
      if (name22) {
        tokens.push(`'${name22}'`);
      } else if (sourceCode) {
        const keyText = sourceCode.getText(parent.key);
        if (!keyText.includes("\n")) {
          tokens.push(`[${keyText}]`);
        }
      }
    }
  } else if (node.id) {
    tokens.push(`'${node.id.name}'`);
  } else if (parent.type === "VariableDeclarator" && parent.id && parent.id.type === "Identifier") {
    tokens.push(`'${parent.id.name}'`);
  } else if ((parent.type === "AssignmentExpression" || parent.type === "AssignmentPattern") && parent.left && parent.left.type === "Identifier") {
    tokens.push(`'${parent.left.name}'`);
  } else if (parent.type === "ExportDefaultDeclaration" && parent.declaration === node) {
    tokens.push("'default'");
  }
  return tokens.join(" ");
}
var typeConversionBinaryOps35 = Object.freeze(
  /* @__PURE__ */ new Set([
    "==",
    "!=",
    "<",
    "<=",
    ">",
    ">=",
    "<<",
    ">>",
    ">>>",
    "+",
    "-",
    "*",
    "/",
    "%",
    "|",
    "^",
    "&",
    "in"
  ])
);
var typeConversionUnaryOps35 = Object.freeze(/* @__PURE__ */ new Set(["-", "+", "!", "~"]));
function isNode35(x2222) {
  return x2222 !== null && typeof x2222 === "object" && typeof x2222.type === "string";
}
var visitor35 = Object.freeze(
  Object.assign(/* @__PURE__ */ Object.create(null), {
    $visit(node, options, visitorKeys) {
      const { type } = node;
      if (typeof this[type] === "function") {
        return this[type](node, options, visitorKeys);
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    $visitChildren(node, options, visitorKeys) {
      const { type } = node;
      for (const key of visitorKeys[type] || getKeys35(node)) {
        const value = node[key];
        if (Array.isArray(value)) {
          for (const element of value) {
            if (isNode35(element) && this.$visit(element, options, visitorKeys)) {
              return true;
            }
          }
        } else if (isNode35(value) && this.$visit(value, options, visitorKeys)) {
          return true;
        }
      }
      return false;
    },
    ArrowFunctionExpression() {
      return false;
    },
    AssignmentExpression() {
      return true;
    },
    AwaitExpression() {
      return true;
    },
    BinaryExpression(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && typeConversionBinaryOps35.has(node.operator) && (node.left.type !== "Literal" || node.right.type !== "Literal")) {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    CallExpression() {
      return true;
    },
    FunctionExpression() {
      return false;
    },
    ImportExpression() {
      return true;
    },
    MemberExpression(node, options, visitorKeys) {
      if (options.considerGetters) {
        return true;
      }
      if (options.considerImplicitTypeConversion && node.computed && node.property.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    MethodDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    NewExpression() {
      return true;
    },
    Property(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    PropertyDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UnaryExpression(node, options, visitorKeys) {
      if (node.operator === "delete") {
        return true;
      }
      if (options.considerImplicitTypeConversion && typeConversionUnaryOps35.has(node.operator) && node.argument.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UpdateExpression() {
      return true;
    },
    YieldExpression() {
      return true;
    }
  })
);
function hasSideEffect35(node, sourceCode, { considerGetters = false, considerImplicitTypeConversion = false } = {}) {
  return visitor35.$visit(
    node,
    { considerGetters, considerImplicitTypeConversion },
    sourceCode.visitorKeys || visitor_keys_default35
  );
}
function getParentSyntaxParen35(node, sourceCode) {
  const parent = node.parent;
  switch (parent.type) {
    case "CallExpression":
    case "NewExpression":
      if (parent.arguments.length === 1 && parent.arguments[0] === node) {
        return sourceCode.getTokenAfter(
          parent.callee,
          isOpeningParenToken35
        );
      }
      return null;
    case "DoWhileStatement":
      if (parent.test === node) {
        return sourceCode.getTokenAfter(
          parent.body,
          isOpeningParenToken35
        );
      }
      return null;
    case "IfStatement":
    case "WhileStatement":
      if (parent.test === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "ImportExpression":
      if (parent.source === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "SwitchStatement":
      if (parent.discriminant === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "WithStatement":
      if (parent.object === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    default:
      return null;
  }
}
function isParenthesized35(timesOrNode, nodeOrSourceCode, optionalSourceCode) {
  let times, node, sourceCode, maybeLeftParen, maybeRightParen;
  if (typeof timesOrNode === "number") {
    times = timesOrNode | 0;
    node = nodeOrSourceCode;
    sourceCode = optionalSourceCode;
    if (!(times >= 1)) {
      throw new TypeError("'times' should be a positive integer.");
    }
  } else {
    times = 1;
    node = timesOrNode;
    sourceCode = nodeOrSourceCode;
  }
  if (node == null || // `Program` can't be parenthesized
  node.parent == null || // `CatchClause.param` can't be parenthesized, example `try {} catch (error) {}`
  node.parent.type === "CatchClause" && node.parent.param === node) {
    return false;
  }
  maybeLeftParen = maybeRightParen = node;
  do {
    maybeLeftParen = sourceCode.getTokenBefore(maybeLeftParen);
    maybeRightParen = sourceCode.getTokenAfter(maybeRightParen);
  } while (maybeLeftParen != null && maybeRightParen != null && isOpeningParenToken35(maybeLeftParen) && isClosingParenToken35(maybeRightParen) && // Avoid false positive such as `if (a) {}`
  maybeLeftParen !== getParentSyntaxParen35(node, sourceCode) && --times > 0);
  return times === 0;
}
Function.call.bind(Object.hasOwnProperty);
var __defProp235 = Object.defineProperty;
var __export235 = (target, all3322) => {
  for (var name22 in all3322)
    __defProp235(target, name22, { get: all3322[name22], enumerable: true });
};
var NodeType35 = types.AST_NODE_TYPES;
var is35 = utils.ASTUtils.isNodeOfType;
var isOneOf35 = utils.ASTUtils.isNodeOfTypes;
isOneOf35([
  NodeType35.ArrowFunctionExpression,
  NodeType35.FunctionDeclaration,
  NodeType35.FunctionExpression
]);
isOneOf35([
  NodeType35.ArrowFunctionExpression,
  NodeType35.FunctionDeclaration,
  NodeType35.FunctionExpression,
  NodeType35.TSCallSignatureDeclaration,
  NodeType35.TSConstructSignatureDeclaration,
  NodeType35.TSDeclareFunction,
  NodeType35.TSEmptyBodyFunctionExpression,
  NodeType35.TSFunctionType,
  NodeType35.TSMethodSignature
]);
isOneOf35([NodeType35.ClassDeclaration, NodeType35.ClassExpression]);
isOneOf35([
  NodeType35.DoWhileStatement,
  NodeType35.ForInStatement,
  NodeType35.ForOfStatement,
  NodeType35.ForStatement,
  NodeType35.WhileStatement
]);
isOneOf35([NodeType35.TSArrayType, NodeType35.TSTupleType]);
isOneOf35([
  NodeType35.PropertyDefinition,
  NodeType35.TSIndexSignature,
  NodeType35.TSParameterProperty,
  NodeType35.TSPropertySignature
]);
is35(NodeType35.JSXElement);
is35(NodeType35.JSXFragment);
isOneOf35([
  NodeType35.JSXAttribute,
  NodeType35.JSXSpreadChild,
  NodeType35.JSXClosingElement,
  NodeType35.JSXClosingFragment,
  NodeType35.JSXElement,
  NodeType35.JSXEmptyExpression,
  NodeType35.JSXExpressionContainer,
  NodeType35.JSXFragment,
  NodeType35.JSXIdentifier,
  NodeType35.JSXMemberExpression,
  NodeType35.JSXNamespacedName,
  NodeType35.JSXOpeningElement,
  NodeType35.JSXOpeningFragment,
  NodeType35.JSXSpreadAttribute,
  NodeType35.JSXSpreadChild,
  NodeType35.JSXText
]);
isOneOf35([
  NodeType35.JSXIdentifier,
  NodeType35.JSXMemberExpression,
  NodeType35.JSXNamespacedName
]);
isOneOf35([
  NodeType35.ArrayPattern,
  NodeType35.AssignmentPattern,
  NodeType35.ObjectPattern,
  NodeType35.RestElement
]);
isOneOf35([
  NodeType35.TSInterfaceDeclaration,
  NodeType35.TSTypeAliasDeclaration
]);
isOneOf35([
  NodeType35.ArrayExpression,
  NodeType35.ArrayPattern,
  NodeType35.ArrowFunctionExpression,
  NodeType35.CallExpression,
  NodeType35.ClassExpression,
  NodeType35.FunctionExpression,
  NodeType35.Identifier,
  NodeType35.JSXElement,
  NodeType35.JSXFragment,
  NodeType35.Literal,
  NodeType35.TemplateLiteral,
  NodeType35.MemberExpression,
  NodeType35.MetaProperty,
  NodeType35.ObjectExpression,
  NodeType35.ObjectPattern,
  NodeType35.SequenceExpression,
  NodeType35.Super,
  NodeType35.TaggedTemplateExpression,
  NodeType35.ThisExpression
]);
isOneOf35([
  NodeType35.ArrayExpression,
  NodeType35.ArrayPattern,
  NodeType35.ArrowFunctionExpression,
  NodeType35.CallExpression,
  NodeType35.ClassExpression,
  NodeType35.FunctionExpression,
  NodeType35.Identifier,
  NodeType35.JSXElement,
  NodeType35.JSXFragment,
  NodeType35.Literal,
  NodeType35.TemplateLiteral,
  NodeType35.MemberExpression,
  NodeType35.MetaProperty,
  NodeType35.ObjectExpression,
  NodeType35.ObjectPattern,
  NodeType35.SequenceExpression,
  NodeType35.Super,
  NodeType35.TaggedTemplateExpression,
  NodeType35.ThisExpression,
  NodeType35.TSAsExpression,
  NodeType35.TSNonNullExpression,
  NodeType35.TSTypeAssertion
]);
var Function_exports235 = {};
__export235(Function_exports235, {
  SK: () => SK235,
  absurd: () => absurd235,
  apply: () => apply235,
  compose: () => compose235,
  constFalse: () => constFalse235,
  constNull: () => constNull235,
  constTrue: () => constTrue235,
  constUndefined: () => constUndefined235,
  constVoid: () => constVoid235,
  constant: () => constant235,
  dual: () => dual235,
  flip: () => flip235,
  flow: () => flow235,
  hole: () => hole235,
  identity: () => identity235,
  isFunction: () => isFunction2235,
  pipe: () => pipe235,
  satisfies: () => satisfies235,
  tupled: () => tupled235,
  unsafeCoerce: () => unsafeCoerce235,
  untupled: () => untupled235
});
var isFunction2235 = (input) => typeof input === "function";
var dual235 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a2222, b2222) {
        if (arguments.length >= 2) {
          return body(a2222, b2222);
        }
        return function(self2) {
          return body(self2, a2222);
        };
      };
    case 3:
      return function(a2222, b2222, c2222) {
        if (arguments.length >= 3) {
          return body(a2222, b2222, c2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222);
        };
      };
    case 4:
      return function(a2222, b2222, c2222, d2222) {
        if (arguments.length >= 4) {
          return body(a2222, b2222, c2222, d2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222);
        };
      };
    case 5:
      return function(a2222, b2222, c2222, d2222, e2222) {
        if (arguments.length >= 5) {
          return body(a2222, b2222, c2222, d2222, e2222);
        }
        return function(self2) {
          return body(self2, a2222, b2222, c2222, d2222);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply235 = (a2222) => (self2) => self2(a2222);
var identity235 = (a2222) => a2222;
var satisfies235 = () => (b2222) => b2222;
var unsafeCoerce235 = identity235;
var constant235 = (value) => () => value;
var constTrue235 = /* @__PURE__ */ constant235(true);
var constFalse235 = /* @__PURE__ */ constant235(false);
var constNull235 = /* @__PURE__ */ constant235(null);
var constUndefined235 = /* @__PURE__ */ constant235(void 0);
var constVoid235 = constUndefined235;
var flip235 = (f2222) => (...b2222) => (...a2222) => f2222(...a2222)(...b2222);
var compose235 = /* @__PURE__ */ dual235(2, (ab, bc) => (a2222) => bc(ab(a2222)));
var absurd235 = (_2222) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled235 = (f2222) => (a2222) => f2222(...a2222);
var untupled235 = (f2222) => (...a2222) => f2222(a2222);
function pipe235(a2222, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a2222;
    case 2:
      return ab(a2222);
    case 3:
      return bc(ab(a2222));
    case 4:
      return cd(bc(ab(a2222)));
    case 5:
      return de(cd(bc(ab(a2222))));
    case 6:
      return ef(de(cd(bc(ab(a2222)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a2222))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a2222)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a2222))))))));
    default: {
      let ret = arguments[0];
      for (let i2222 = 1; i2222 < arguments.length; i2222++) {
        ret = arguments[i2222](ret);
      }
      return ret;
    }
  }
}
function flow235(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole235 = /* @__PURE__ */ unsafeCoerce235(absurd235);
var SK235 = (_2222, b2222) => b2222;
var make435 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_335 = (map622) => dual235(3, (self2, name22, f2222) => map622(self2, (a2222) => Object.assign({}, a2222, {
  [name22]: f2222(a2222)
})));
var bindTo335 = (map622) => dual235(2, (self2, name22) => map622(self2, (a2222) => ({
  [name22]: a2222
})));
var bind335 = (map622, flatMap4222) => dual235(3, (self2, name22, f2222) => flatMap4222(self2, (a2222) => map622(f2222(a2222), (b2222) => Object.assign({}, a2222, {
  [name22]: b2222
}))));
var moduleVersion235 = "3.2.8";
var getCurrentVersion235 = () => moduleVersion235;
var globalStoreId235 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion235()}`);
if (!(globalStoreId235 in globalThis)) {
  globalThis[globalStoreId235] = /* @__PURE__ */ new Map();
}
var globalStore235 = globalThis[globalStoreId235];
var globalValue235 = (id, compute) => {
  if (!globalStore235.has(id)) {
    globalStore235.set(id, compute());
  }
  return globalStore235.get(id);
};
var Predicate_exports235 = {};
__export235(Predicate_exports235, {
  all: () => all235,
  and: () => and55,
  compose: () => compose2235,
  eqv: () => eqv55,
  every: () => every65,
  hasProperty: () => hasProperty235,
  implies: () => implies55,
  isBigInt: () => isBigInt55,
  isBoolean: () => isBoolean55,
  isDate: () => isDate55,
  isError: () => isError55,
  isFunction: () => isFunction3234,
  isIterable: () => isIterable55,
  isMap: () => isMap55,
  isNever: () => isNever55,
  isNotNull: () => isNotNull55,
  isNotNullable: () => isNotNullable55,
  isNotUndefined: () => isNotUndefined55,
  isNull: () => isNull55,
  isNullable: () => isNullable235,
  isNumber: () => isNumber55,
  isObject: () => isObject235,
  isPromise: () => isPromise55,
  isPromiseLike: () => isPromiseLike55,
  isReadonlyRecord: () => isReadonlyRecord55,
  isRecord: () => isRecord55,
  isSet: () => isSet55,
  isString: () => isString55,
  isSymbol: () => isSymbol55,
  isTagged: () => isTagged55,
  isTruthy: () => isTruthy55,
  isUint8Array: () => isUint8Array55,
  isUndefined: () => isUndefined55,
  isUnknown: () => isUnknown55,
  mapInput: () => mapInput65,
  nand: () => nand55,
  nor: () => nor55,
  not: () => not55,
  or: () => or55,
  product: () => product235,
  productMany: () => productMany235,
  some: () => some335,
  struct: () => struct75,
  tuple: () => tuple65,
  xor: () => xor55
});
var mapInput65 = /* @__PURE__ */ dual235(2, (self2, f2222) => (b2222) => self2(f2222(b2222)));
var isTruthy55 = (input) => !!input;
var isSet55 = (input) => input instanceof Set;
var isMap55 = (input) => input instanceof Map;
var isString55 = (input) => typeof input === "string";
var isNumber55 = (input) => typeof input === "number";
var isBoolean55 = (input) => typeof input === "boolean";
var isBigInt55 = (input) => typeof input === "bigint";
var isSymbol55 = (input) => typeof input === "symbol";
var isFunction3234 = isFunction2235;
var isUndefined55 = (input) => input === void 0;
var isNotUndefined55 = (input) => input !== void 0;
var isNull55 = (input) => input === null;
var isNotNull55 = (input) => input !== null;
var isNever55 = (_2222) => false;
var isUnknown55 = (_2222) => true;
var isRecordOrArray235 = (input) => typeof input === "object" && input !== null;
var isObject235 = (input) => isRecordOrArray235(input) || isFunction3234(input);
var hasProperty235 = /* @__PURE__ */ dual235(2, (self2, property) => isObject235(self2) && property in self2);
var isTagged55 = /* @__PURE__ */ dual235(2, (self2, tag) => hasProperty235(self2, "_tag") && self2["_tag"] === tag);
var isNullable235 = (input) => input === null || input === void 0;
var isNotNullable55 = (input) => input !== null && input !== void 0;
var isError55 = (input) => input instanceof Error;
var isUint8Array55 = (input) => input instanceof Uint8Array;
var isDate55 = (input) => input instanceof Date;
var isIterable55 = (input) => hasProperty235(input, Symbol.iterator);
var isRecord55 = (input) => isRecordOrArray235(input) && !Array.isArray(input);
var isReadonlyRecord55 = isRecord55;
var isPromise55 = (input) => hasProperty235(input, "then") && "catch" in input && isFunction3234(input.then) && isFunction3234(input.catch);
var isPromiseLike55 = (input) => hasProperty235(input, "then") && isFunction3234(input.then);
var compose2235 = /* @__PURE__ */ dual235(2, (ab, bc) => (a2222) => ab(a2222) && bc(a2222));
var product235 = (self2, that) => ([a2222, b2222]) => self2(a2222) && that(b2222);
var all235 = (collection) => {
  return (as22322) => {
    let collectionIndex = 0;
    for (const p2222 of collection) {
      if (collectionIndex >= as22322.length) {
        break;
      }
      if (p2222(as22322[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany235 = (self2, collection) => {
  const rest = all235(collection);
  return ([head222, ...tail322]) => self2(head222) === false ? false : rest(tail322);
};
var tuple65 = (...elements) => all235(elements);
var struct75 = (fields) => {
  const keys2322 = Object.keys(fields);
  return (a2222) => {
    for (const key of keys2322) {
      if (!fields[key](a2222[key])) {
        return false;
      }
    }
    return true;
  };
};
var not55 = (self2) => (a2222) => !self2(a2222);
var or55 = /* @__PURE__ */ dual235(2, (self2, that) => (a2222) => self2(a2222) || that(a2222));
var and55 = /* @__PURE__ */ dual235(2, (self2, that) => (a2222) => self2(a2222) && that(a2222));
var xor55 = /* @__PURE__ */ dual235(2, (self2, that) => (a2222) => self2(a2222) !== that(a2222));
var eqv55 = /* @__PURE__ */ dual235(2, (self2, that) => (a2222) => self2(a2222) === that(a2222));
var implies55 = /* @__PURE__ */ dual235(2, (self2, that) => (a2222) => self2(a2222) ? that(a2222) : true);
var nor55 = /* @__PURE__ */ dual235(2, (self2, that) => (a2222) => !(self2(a2222) || that(a2222)));
var nand55 = /* @__PURE__ */ dual235(2, (self2, that) => (a2222) => !(self2(a2222) && that(a2222)));
var every65 = (collection) => (a2222) => {
  for (const p2222 of collection) {
    if (!p2222(a2222)) {
      return false;
    }
  }
  return true;
};
var some335 = (collection) => (a2222) => {
  for (const p2222 of collection) {
    if (p2222(a2222)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage235 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId235 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind235 = (u2222) => isObject235(u2222) && GenKindTypeId235 in u2222;
var GenKindImpl235 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity235;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_2222) => _2222;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId235] = GenKindTypeId235;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen235(this);
  }
};
var SingleShotGen235 = class _SingleShotGen65 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a2222) {
    return this.called ? {
      value: a2222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a2222) {
    return {
      value: a2222,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e2222) {
    throw e2222;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen65(this.self);
  }
};
var adapter335 = () => function() {
  let x2222 = arguments[0];
  for (let i2222 = 1; i2222 < arguments.length; i2222++) {
    x2222 = arguments[i2222](x2222);
  }
  return new GenKindImpl235(x2222);
};
var defaultIncHi235 = 335903614;
var defaultIncLo235 = 4150755663;
var MUL_HI235 = 1481765933 >>> 0;
var MUL_LO235 = 1284865837 >>> 0;
var BIT_53235 = 9007199254740992;
var BIT_27235 = 134217728;
var PCGRandom235 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable235(seedLo) && isNullable235(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable235(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable235(incLo) && isNullable235(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo235;
      incHi = this._state ? this._state[2] : defaultIncHi235;
    } else if (isNullable235(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add64235(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max322) {
    if (!max322) {
      return this._next();
    }
    max322 = max322 >>> 0;
    if ((max322 & max322 - 1) === 0) {
      return this._next() & max322 - 1;
    }
    let num = 0;
    const skew = (-max322 >>> 0) % max322 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max322;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_27235 + lo) / BIT_53235;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul64235(this._state, oldHi, oldLo, MUL_HI235, MUL_LO235);
    add64235(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul64235(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add64235(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId235 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap235 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId235]() {
    return this.#value;
  }
};
function yieldWrapGet235(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId235 in self2) {
    return self2[YieldWrapTypeId235]();
  }
  throw new Error(getBugErrorMessage235("yieldWrapGet"));
}
var structuralRegionState235 = /* @__PURE__ */ globalValue235("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache235 = /* @__PURE__ */ globalValue235(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr235 = /* @__PURE__ */ globalValue235(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom235());
var symbol335 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash235 = (self2) => {
  if (structuralRegionState235.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number235(self2);
    case "bigint":
      return string235(self2.toString(10));
    case "boolean":
      return string235(String(self2));
    case "symbol":
      return string235(String(self2));
    case "string":
      return string235(self2);
    case "undefined":
      return string235("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string235("null");
      } else if (self2 instanceof Date) {
        return hash235(self2.toISOString());
      } else if (isHash235(self2)) {
        return self2[symbol335]();
      } else {
        return random235(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random235 = (self2) => {
  if (!randomHashCache235.has(self2)) {
    randomHashCache235.set(self2, number235(pcgr235.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache235.get(self2);
};
var combine235 = (b2222) => (self2) => self2 * 53 ^ b2222;
var optimize235 = (n2222) => n2222 & 3221225471 | n2222 >>> 1 & 1073741824;
var isHash235 = (u2222) => hasProperty235(u2222, symbol335);
var number235 = (n2222) => {
  if (n2222 !== n2222 || n2222 === Infinity) {
    return 0;
  }
  let h2222 = n2222 | 0;
  if (h2222 !== n2222) {
    h2222 ^= n2222 * 4294967295;
  }
  while (n2222 > 4294967295) {
    h2222 ^= n2222 /= 4294967295;
  }
  return optimize235(n2222);
};
var string235 = (str) => {
  let h2222 = 5381, i2222 = str.length;
  while (i2222) {
    h2222 = h2222 * 33 ^ str.charCodeAt(--i2222);
  }
  return optimize235(h2222);
};
var structureKeys235 = (o2222, keys2322) => {
  let h2222 = 12289;
  for (let i2222 = 0; i2222 < keys2322.length; i2222++) {
    h2222 ^= pipe235(string235(keys2322[i2222]), combine235(hash235(o2222[keys2322[i2222]])));
  }
  return optimize235(h2222);
};
var structure235 = (o2222) => structureKeys235(o2222, Object.keys(o2222));
var array75 = (arr) => {
  let h2222 = 6151;
  for (let i2222 = 0; i2222 < arr.length; i2222++) {
    h2222 = pipe235(h2222, combine235(hash235(arr[i2222])));
  }
  return optimize235(h2222);
};
var cached235 = function() {
  if (arguments.length === 1) {
    const self22 = arguments[0];
    return function(hash3222) {
      Object.defineProperty(self22, symbol335, {
        value() {
          return hash3222;
        },
        enumerable: false
      });
      return hash3222;
    };
  }
  const self2 = arguments[0];
  const hash22322 = arguments[1];
  Object.defineProperty(self2, symbol335, {
    value() {
      return hash22322;
    },
    enumerable: false
  });
  return hash22322;
};
var symbol2235 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals235() {
  if (arguments.length === 1) {
    return (self2) => compareBoth235(self2, arguments[0]);
  }
  return compareBoth235(arguments[0], arguments[1]);
}
function compareBoth235(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual235(self2) && isEqual235(that)) {
        if (hash235(self2) === hash235(that) && self2[symbol2235](that)) {
          return true;
        } else {
          return structuralRegionState235.enabled && structuralRegionState235.tester ? structuralRegionState235.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState235.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v2222, i2222) => compareBoth235(v2222, that[i2222]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth235(self2[key], that[key]))) {
              return structuralRegionState235.tester ? structuralRegionState235.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState235.tester ? structuralRegionState235.tester(self2, that) : false;
    }
  }
  return structuralRegionState235.enabled && structuralRegionState235.tester ? structuralRegionState235.tester(self2, that) : false;
}
var isEqual235 = (u2222) => hasProperty235(u2222, symbol2235);
var equivalence235 = () => equals235;
var NodeInspectSymbol235 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON235 = (x2222) => {
  if (hasProperty235(x2222, "toJSON") && isFunction3234(x2222["toJSON"]) && x2222["toJSON"].length === 0) {
    return x2222.toJSON();
  } else if (Array.isArray(x2222)) {
    return x2222.map(toJSON235);
  }
  return x2222;
};
var format235 = (x2222) => JSON.stringify(x2222, null, 2);
var pipeArguments235 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i2222 = 0, len = args.length; i2222 < len; i2222++) {
        ret = args[i2222](ret);
      }
      return ret;
    }
  }
};
var OP_COMMIT235 = "Commit";
var OP_FAILURE35 = "Failure";
var OP_WITH_RUNTIME35 = "WithRuntime";
var EffectTypeId235 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId235 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId235 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId235 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance235 = {
  /* c8 ignore next */
  _R: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _A: (_2222) => _2222,
  _V: /* @__PURE__ */ getCurrentVersion235()
};
var sinkVariance235 = {
  /* c8 ignore next */
  _A: (_2222) => _2222,
  /* c8 ignore next */
  _In: (_2222) => _2222,
  /* c8 ignore next */
  _L: (_2222) => _2222,
  /* c8 ignore next */
  _E: (_2222) => _2222,
  /* c8 ignore next */
  _R: (_2222) => _2222
};
var channelVariance235 = {
  /* c8 ignore next */
  _Env: (_2222) => _2222,
  /* c8 ignore next */
  _InErr: (_2222) => _2222,
  /* c8 ignore next */
  _InElem: (_2222) => _2222,
  /* c8 ignore next */
  _InDone: (_2222) => _2222,
  /* c8 ignore next */
  _OutErr: (_2222) => _2222,
  /* c8 ignore next */
  _OutElem: (_2222) => _2222,
  /* c8 ignore next */
  _OutDone: (_2222) => _2222
};
var EffectPrototype235 = {
  [EffectTypeId235]: effectVariance235,
  [StreamTypeId235]: effectVariance235,
  [SinkTypeId235]: sinkVariance235,
  [ChannelTypeId235]: channelVariance235,
  [symbol2235](that) {
    return this === that;
  },
  [symbol335]() {
    return cached235(this, random235(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen235(new YieldWrap235(this));
  },
  pipe() {
    return pipeArguments235(this, arguments);
  }
};
var StructuralPrototype235 = {
  [symbol335]() {
    return cached235(this, structure235(this));
  },
  [symbol2235](that) {
    const selfKeys = Object.keys(this);
    const thatKeys = Object.keys(that);
    if (selfKeys.length !== thatKeys.length) {
      return false;
    }
    for (const key of selfKeys) {
      if (!(key in that && equals235(this[key], that[key]))) {
        return false;
      }
    }
    return true;
  }
};
var CommitPrototype235 = {
  ...EffectPrototype235,
  _op: OP_COMMIT235
};
var StructuralCommitPrototype235 = {
  ...CommitPrototype235,
  ...StructuralPrototype235
};
var TypeId535 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto335 = {
  ...EffectPrototype235,
  [TypeId535]: {
    _A: (_2222) => _2222
  },
  [NodeInspectSymbol235]() {
    return this.toJSON();
  },
  toString() {
    return format235(this.toJSON());
  }
};
var SomeProto235 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto335), {
  _tag: "Some",
  _op: "Some",
  [symbol2235](that) {
    return isOption335(that) && isSome335(that) && equals235(this.value, that.value);
  },
  [symbol335]() {
    return cached235(this, combine235(hash235(this._tag))(hash235(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON235(this.value)
    };
  }
});
var NoneHash235 = /* @__PURE__ */ hash235("None");
var NoneProto235 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto335), {
  _tag: "None",
  _op: "None",
  [symbol2235](that) {
    return isOption335(that) && isNone335(that);
  },
  [symbol335]() {
    return NoneHash235;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption335 = (input) => hasProperty235(input, TypeId535);
var isNone335 = (fa) => fa._tag === "None";
var isSome335 = (fa) => fa._tag === "Some";
var none335 = /* @__PURE__ */ Object.create(NoneProto235);
var some2235 = (value) => {
  const a2222 = Object.create(SomeProto235);
  a2222.value = value;
  return a2222;
};
var TypeId2235 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto2235 = {
  ...EffectPrototype235,
  [TypeId2235]: {
    _R: (_2222) => _2222
  },
  [NodeInspectSymbol235]() {
    return this.toJSON();
  },
  toString() {
    return format235(this.toJSON());
  }
};
var RightProto235 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto2235), {
  _tag: "Right",
  _op: "Right",
  [symbol2235](that) {
    return isEither235(that) && isRight235(that) && equals235(this.right, that.right);
  },
  [symbol335]() {
    return combine235(hash235(this._tag))(hash235(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON235(this.right)
    };
  }
});
var LeftProto235 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto2235), {
  _tag: "Left",
  _op: "Left",
  [symbol2235](that) {
    return isEither235(that) && isLeft235(that) && equals235(this.left, that.left);
  },
  [symbol335]() {
    return combine235(hash235(this._tag))(hash235(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON235(this.left)
    };
  }
});
var isEither235 = (input) => hasProperty235(input, TypeId2235);
var isLeft235 = (ma) => ma._tag === "Left";
var isRight235 = (ma) => ma._tag === "Right";
var left235 = (left3322) => {
  const a2222 = Object.create(LeftProto235);
  a2222.left = left3322;
  return a2222;
};
var right235 = (right3322) => {
  const a2222 = Object.create(RightProto235);
  a2222.right = right3322;
  return a2222;
};
var getLeft335 = (self2) => isRight235(self2) ? none335 : some2235(self2.left);
var getRight335 = (self2) => isLeft235(self2) ? none335 : some2235(self2.right);
var right2235 = right235;
var left2235 = left235;
var Option_exports235 = {};
__export235(Option_exports235, {
  Do: () => Do235,
  TypeId: () => TypeId3235,
  all: () => all2235,
  andThen: () => andThen235,
  ap: () => ap235,
  as: () => as235,
  asVoid: () => asVoid235,
  bind: () => bind2235,
  bindTo: () => bindTo2235,
  composeK: () => composeK235,
  contains: () => contains235,
  containsWith: () => containsWith235,
  exists: () => exists235,
  filter: () => filter235,
  filterMap: () => filterMap235,
  firstSomeOf: () => firstSomeOf235,
  flatMap: () => flatMap235,
  flatMapNullable: () => flatMapNullable235,
  flatten: () => flatten235,
  fromIterable: () => fromIterable235,
  fromNullable: () => fromNullable235,
  gen: () => gen235,
  getEquivalence: () => getEquivalence235,
  getLeft: () => getLeft2235,
  getOrElse: () => getOrElse235,
  getOrNull: () => getOrNull235,
  getOrThrow: () => getOrThrow235,
  getOrThrowWith: () => getOrThrowWith235,
  getOrUndefined: () => getOrUndefined235,
  getOrder: () => getOrder235,
  getRight: () => getRight2235,
  isNone: () => isNone2235,
  isOption: () => isOption2235,
  isSome: () => isSome2235,
  let: () => let_2235,
  lift2: () => lift2235,
  liftNullable: () => liftNullable235,
  liftPredicate: () => liftPredicate235,
  liftThrowable: () => liftThrowable235,
  map: () => map235,
  match: () => match235,
  none: () => none2235,
  orElse: () => orElse235,
  orElseEither: () => orElseEither235,
  orElseSome: () => orElseSome235,
  partitionMap: () => partitionMap235,
  product: () => product2235,
  productMany: () => productMany2235,
  reduceCompact: () => reduceCompact235,
  some: () => some3235,
  tap: () => tap235,
  toArray: () => toArray235,
  toRefinement: () => toRefinement235,
  void: () => void_235,
  zipLeft: () => zipLeft235,
  zipRight: () => zipRight235,
  zipWith: () => zipWith235
});
var make2235 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId3235 = /* @__PURE__ */ Symbol.for("effect/Option");
var none2235 = () => none335;
var some3235 = some2235;
var isOption2235 = isOption335;
var isNone2235 = isNone335;
var isSome2235 = isSome335;
var match235 = /* @__PURE__ */ dual235(2, (self2, {
  onNone,
  onSome
}) => isNone2235(self2) ? onNone() : onSome(self2.value));
var toRefinement235 = (f2222) => (a2222) => isSome2235(f2222(a2222));
var fromIterable235 = (collection) => {
  for (const a2222 of collection) {
    return some3235(a2222);
  }
  return none2235();
};
var getRight2235 = getRight335;
var getLeft2235 = getLeft335;
var getOrElse235 = /* @__PURE__ */ dual235(2, (self2, onNone) => isNone2235(self2) ? onNone() : self2.value);
var orElse235 = /* @__PURE__ */ dual235(2, (self2, that) => isNone2235(self2) ? that() : self2);
var orElseSome235 = /* @__PURE__ */ dual235(2, (self2, onNone) => isNone2235(self2) ? some3235(onNone()) : self2);
var orElseEither235 = /* @__PURE__ */ dual235(2, (self2, that) => isNone2235(self2) ? map235(that(), right235) : map235(self2, left235));
var firstSomeOf235 = (collection) => {
  let out = none2235();
  for (out of collection) {
    if (isSome2235(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable235 = (nullableValue) => nullableValue == null ? none2235() : some3235(nullableValue);
var liftNullable235 = (f2222) => (...a2222) => fromNullable235(f2222(...a2222));
var getOrNull235 = /* @__PURE__ */ getOrElse235(constNull235);
var getOrUndefined235 = /* @__PURE__ */ getOrElse235(constUndefined235);
var liftThrowable235 = (f2222) => (...a2222) => {
  try {
    return some3235(f2222(...a2222));
  } catch (e2222) {
    return none2235();
  }
};
var getOrThrowWith235 = /* @__PURE__ */ dual235(2, (self2, onNone) => {
  if (isSome2235(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow235 = /* @__PURE__ */ getOrThrowWith235(() => new Error("getOrThrow called on a None"));
var map235 = /* @__PURE__ */ dual235(2, (self2, f2222) => isNone2235(self2) ? none2235() : some3235(f2222(self2.value)));
var as235 = /* @__PURE__ */ dual235(2, (self2, b2222) => map235(self2, () => b2222));
var asVoid235 = /* @__PURE__ */ as235(void 0);
var void_235 = /* @__PURE__ */ some3235(void 0);
var flatMap235 = /* @__PURE__ */ dual235(2, (self2, f2222) => isNone2235(self2) ? none2235() : f2222(self2.value));
var andThen235 = /* @__PURE__ */ dual235(2, (self2, f2222) => flatMap235(self2, (a2222) => {
  const b2222 = isFunction2235(f2222) ? f2222(a2222) : f2222;
  return isOption2235(b2222) ? b2222 : some3235(b2222);
}));
var flatMapNullable235 = /* @__PURE__ */ dual235(2, (self2, f2222) => isNone2235(self2) ? none2235() : fromNullable235(f2222(self2.value)));
var flatten235 = /* @__PURE__ */ flatMap235(identity235);
var zipRight235 = /* @__PURE__ */ dual235(2, (self2, that) => flatMap235(self2, () => that));
var composeK235 = /* @__PURE__ */ dual235(2, (afb, bfc) => (a2222) => flatMap235(afb(a2222), bfc));
var zipLeft235 = /* @__PURE__ */ dual235(2, (self2, that) => tap235(self2, () => that));
var tap235 = /* @__PURE__ */ dual235(2, (self2, f2222) => flatMap235(self2, (a2222) => map235(f2222(a2222), () => a2222)));
var product2235 = (self2, that) => isSome2235(self2) && isSome2235(that) ? some3235([self2.value, that.value]) : none2235();
var productMany2235 = (self2, collection) => {
  if (isNone2235(self2)) {
    return none2235();
  }
  const out = [self2.value];
  for (const o2222 of collection) {
    if (isNone2235(o2222)) {
      return none2235();
    }
    out.push(o2222.value);
  }
  return some3235(out);
};
var all2235 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o2222 of input) {
      if (isNone2235(o2222)) {
        return none2235();
      }
      out2.push(o2222.value);
    }
    return some3235(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o2222 = input[key];
    if (isNone2235(o2222)) {
      return none2235();
    }
    out[key] = o2222.value;
  }
  return some3235(out);
};
var zipWith235 = /* @__PURE__ */ dual235(3, (self2, that, f2222) => map235(product2235(self2, that), ([a2222, b2222]) => f2222(a2222, b2222)));
var ap235 = /* @__PURE__ */ dual235(2, (self2, that) => zipWith235(self2, that, (f2222, a2222) => f2222(a2222)));
var reduceCompact235 = /* @__PURE__ */ dual235(3, (self2, b2222, f2222) => {
  let out = b2222;
  for (const oa of self2) {
    if (isSome2235(oa)) {
      out = f2222(out, oa.value);
    }
  }
  return out;
});
var toArray235 = (self2) => isNone2235(self2) ? [] : [self2.value];
var partitionMap235 = /* @__PURE__ */ dual235(2, (self2, f2222) => {
  if (isNone2235(self2)) {
    return [none2235(), none2235()];
  }
  const e2222 = f2222(self2.value);
  return isLeft235(e2222) ? [some3235(e2222.left), none2235()] : [none2235(), some3235(e2222.right)];
});
var filterMap235 = /* @__PURE__ */ dual235(2, (self2, f2222) => isNone2235(self2) ? none2235() : f2222(self2.value));
var filter235 = /* @__PURE__ */ dual235(2, (self2, predicate) => filterMap235(self2, (b2222) => predicate(b2222) ? some2235(b2222) : none335));
var getEquivalence235 = (isEquivalent) => make435((x2222, y2222) => x2222 === y2222 || (isNone2235(x2222) ? isNone2235(y2222) : isNone2235(y2222) ? false : isEquivalent(x2222.value, y2222.value)));
var getOrder235 = (O2222) => make2235((self2, that) => isSome2235(self2) ? isSome2235(that) ? O2222(self2.value, that.value) : 1 : -1);
var lift2235 = (f2222) => dual235(2, (self2, that) => zipWith235(self2, that, f2222));
var liftPredicate235 = (predicate) => (b2222) => predicate(b2222) ? some3235(b2222) : none2235();
var containsWith235 = (isEquivalent) => dual235(2, (self2, a2222) => isNone2235(self2) ? false : isEquivalent(self2.value, a2222));
var _equivalence235 = /* @__PURE__ */ equivalence235();
var contains235 = /* @__PURE__ */ containsWith235(_equivalence235);
var exists235 = /* @__PURE__ */ dual235(2, (self2, refinement) => isNone2235(self2) ? false : refinement(self2.value));
var bindTo2235 = /* @__PURE__ */ bindTo335(map235);
var let_2235 = /* @__PURE__ */ let_335(map235);
var bind2235 = /* @__PURE__ */ bind335(map235, flatMap235);
var Do235 = /* @__PURE__ */ some3235({});
var adapter2235 = /* @__PURE__ */ adapter335();
var gen235 = (f2222) => {
  const iterator = f2222(adapter2235);
  let state = iterator.next();
  if (state.done) {
    return some3235(state.value);
  } else {
    let current = state.value;
    if (isGenKind235(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet235(current);
    }
    if (isNone2235(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind235(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet235(current);
        }
        if (isNone2235(current)) {
          return current;
        }
      }
    }
    return some3235(state.value);
  }
};
var fromIterable2235 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var reverse55 = (self2) => Array.from(self2).reverse();
var reduce65 = /* @__PURE__ */ dual235(3, (self2, b2222, f2222) => fromIterable2235(self2).reduce((b22222, a2222, i2222) => f2222(b22222, a2222, i2222), b2222));
var TagTypeId35 = /* @__PURE__ */ Symbol.for("effect/Context/Tag");
var STMSymbolKey35 = "effect/STM";
var STMTypeId35 = /* @__PURE__ */ Symbol.for(STMSymbolKey35);
var TagProto35 = {
  ...EffectPrototype235,
  _tag: "Tag",
  _op: "Tag",
  [STMTypeId35]: effectVariance235,
  [TagTypeId35]: {
    _Service: (_2222) => _2222,
    _Identifier: (_2222) => _2222
  },
  toString() {
    return format235(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Tag",
      key: this.key,
      stack: this.stack
    };
  },
  [NodeInspectSymbol235]() {
    return this.toJSON();
  },
  of(self2) {
    return self2;
  },
  context(self2) {
    return make3235(this, self2);
  }
};
var makeGenericTag35 = (key) => {
  const limit = Error.stackTraceLimit;
  Error.stackTraceLimit = 2;
  const creationError = new Error();
  Error.stackTraceLimit = limit;
  const tag = Object.create(TagProto35);
  Object.defineProperty(tag, "stack", {
    get() {
      return creationError.stack;
    }
  });
  tag.key = key;
  return tag;
};
var TypeId4235 = /* @__PURE__ */ Symbol.for("effect/Context");
var ContextProto35 = {
  [TypeId4235]: {
    _Services: (_2222) => _2222
  },
  [symbol2235](that) {
    if (isContext35(that)) {
      if (this.unsafeMap.size === that.unsafeMap.size) {
        for (const k2222 of this.unsafeMap.keys()) {
          if (!that.unsafeMap.has(k2222) || !equals235(this.unsafeMap.get(k2222), that.unsafeMap.get(k2222))) {
            return false;
          }
        }
        return true;
      }
    }
    return false;
  },
  [symbol335]() {
    return cached235(this, number235(this.unsafeMap.size));
  },
  pipe() {
    return pipeArguments235(this, arguments);
  },
  toString() {
    return format235(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Context",
      services: Array.from(this.unsafeMap).map(toJSON235)
    };
  },
  [NodeInspectSymbol235]() {
    return this.toJSON();
  }
};
var makeContext35 = (unsafeMap) => {
  const context = Object.create(ContextProto35);
  context.unsafeMap = unsafeMap;
  return context;
};
var isContext35 = (u2222) => hasProperty235(u2222, TypeId4235);
var _empty75 = /* @__PURE__ */ makeContext35(/* @__PURE__ */ new Map());
var empty125 = () => _empty75;
var make3235 = (tag, service) => makeContext35(/* @__PURE__ */ new Map([[tag.key, service]]));
var GenericTag35 = makeGenericTag35;
var empty235 = empty125;
var TypeId5235 = /* @__PURE__ */ Symbol.for("effect/Chunk");
function copy45(src, srcPos, dest, destPos, len) {
  for (let i2222 = srcPos; i2222 < Math.min(src.length, srcPos + len); i2222++) {
    dest[destPos + i2222 - srcPos] = src[i2222];
  }
  return dest;
}
var emptyArray35 = [];
var getEquivalence2235 = (isEquivalent) => make435((self2, that) => self2.length === that.length && toReadonlyArray35(self2).every((value, i2222) => isEquivalent(value, unsafeGet235(that, i2222))));
var _equivalence2235 = /* @__PURE__ */ getEquivalence2235(equals235);
var ChunkProto35 = {
  [TypeId5235]: {
    _A: (_2222) => _2222
  },
  toString() {
    return format235(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Chunk",
      values: toReadonlyArray35(this).map(toJSON235)
    };
  },
  [NodeInspectSymbol235]() {
    return this.toJSON();
  },
  [symbol2235](that) {
    return isChunk35(that) && _equivalence2235(this, that);
  },
  [symbol335]() {
    return cached235(this, array75(toReadonlyArray35(this)));
  },
  [Symbol.iterator]() {
    switch (this.backing._tag) {
      case "IArray": {
        return this.backing.array[Symbol.iterator]();
      }
      case "IEmpty": {
        return emptyArray35[Symbol.iterator]();
      }
      default: {
        return toReadonlyArray35(this)[Symbol.iterator]();
      }
    }
  },
  pipe() {
    return pipeArguments235(this, arguments);
  }
};
var makeChunk35 = (backing) => {
  const chunk = Object.create(ChunkProto35);
  chunk.backing = backing;
  switch (backing._tag) {
    case "IEmpty": {
      chunk.length = 0;
      chunk.depth = 0;
      chunk.left = chunk;
      chunk.right = chunk;
      break;
    }
    case "IConcat": {
      chunk.length = backing.left.length + backing.right.length;
      chunk.depth = 1 + Math.max(backing.left.depth, backing.right.depth);
      chunk.left = backing.left;
      chunk.right = backing.right;
      break;
    }
    case "IArray": {
      chunk.length = backing.array.length;
      chunk.depth = 0;
      chunk.left = _empty235;
      chunk.right = _empty235;
      break;
    }
    case "ISingleton": {
      chunk.length = 1;
      chunk.depth = 0;
      chunk.left = _empty235;
      chunk.right = _empty235;
      break;
    }
    case "ISlice": {
      chunk.length = backing.length;
      chunk.depth = backing.chunk.depth + 1;
      chunk.left = _empty235;
      chunk.right = _empty235;
      break;
    }
  }
  return chunk;
};
var isChunk35 = (u2222) => hasProperty235(u2222, TypeId5235);
var _empty235 = /* @__PURE__ */ makeChunk35({
  _tag: "IEmpty"
});
var empty335 = () => _empty235;
var make4235 = (...as22322) => as22322.length === 1 ? of45(as22322[0]) : unsafeFromNonEmptyArray35(as22322);
var of45 = (a2222) => makeChunk35({
  _tag: "ISingleton",
  a: a2222
});
var copyToArray35 = (self2, array3322, initial) => {
  switch (self2.backing._tag) {
    case "IArray": {
      copy45(self2.backing.array, 0, array3322, initial, self2.length);
      break;
    }
    case "IConcat": {
      copyToArray35(self2.left, array3322, initial);
      copyToArray35(self2.right, array3322, initial + self2.left.length);
      break;
    }
    case "ISingleton": {
      array3322[initial] = self2.backing.a;
      break;
    }
    case "ISlice": {
      let i2222 = 0;
      let j2222 = initial;
      while (i2222 < self2.length) {
        array3322[j2222] = unsafeGet235(self2, i2222);
        i2222 += 1;
        j2222 += 1;
      }
      break;
    }
  }
};
var toReadonlyArray35 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      return emptyArray35;
    }
    case "IArray": {
      return self2.backing.array;
    }
    default: {
      const arr = new Array(self2.length);
      copyToArray35(self2, arr, 0);
      self2.backing = {
        _tag: "IArray",
        array: arr
      };
      self2.left = _empty235;
      self2.right = _empty235;
      self2.depth = 0;
      return arr;
    }
  }
};
var reverse235 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty":
    case "ISingleton":
      return self2;
    case "IArray": {
      return makeChunk35({
        _tag: "IArray",
        array: reverse55(self2.backing.array)
      });
    }
    case "IConcat": {
      return makeChunk35({
        _tag: "IConcat",
        left: reverse235(self2.backing.right),
        right: reverse235(self2.backing.left)
      });
    }
    case "ISlice":
      return unsafeFromArray35(reverse55(toReadonlyArray35(self2)));
  }
};
var unsafeFromArray35 = (self2) => makeChunk35({
  _tag: "IArray",
  array: self2
});
var unsafeFromNonEmptyArray35 = (self2) => unsafeFromArray35(self2);
var unsafeGet235 = /* @__PURE__ */ dual235(2, (self2, index) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      throw new Error(`Index out of bounds`);
    }
    case "ISingleton": {
      if (index !== 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.a;
    }
    case "IArray": {
      if (index >= self2.length || index < 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.array[index];
    }
    case "IConcat": {
      return index < self2.left.length ? unsafeGet235(self2.left, index) : unsafeGet235(self2.right, index - self2.left.length);
    }
    case "ISlice": {
      return unsafeGet235(self2.backing.chunk, index + self2.backing.offset);
    }
  }
});
var prepend55 = /* @__PURE__ */ dual235(2, (self2, elem) => appendAll45(of45(elem), self2));
var drop45 = /* @__PURE__ */ dual235(2, (self2, n2222) => {
  if (n2222 <= 0) {
    return self2;
  } else if (n2222 >= self2.length) {
    return _empty235;
  } else {
    switch (self2.backing._tag) {
      case "ISlice": {
        return makeChunk35({
          _tag: "ISlice",
          chunk: self2.backing.chunk,
          offset: self2.backing.offset + n2222,
          length: self2.backing.length - n2222
        });
      }
      case "IConcat": {
        if (n2222 > self2.left.length) {
          return drop45(self2.right, n2222 - self2.left.length);
        }
        return makeChunk35({
          _tag: "IConcat",
          left: drop45(self2.left, n2222),
          right: self2.right
        });
      }
      default: {
        return makeChunk35({
          _tag: "ISlice",
          chunk: self2,
          offset: n2222,
          length: self2.length - n2222
        });
      }
    }
  }
});
var appendAll45 = /* @__PURE__ */ dual235(2, (self2, that) => {
  if (self2.backing._tag === "IEmpty") {
    return that;
  }
  if (that.backing._tag === "IEmpty") {
    return self2;
  }
  const diff2322 = that.depth - self2.depth;
  if (Math.abs(diff2322) <= 1) {
    return makeChunk35({
      _tag: "IConcat",
      left: self2,
      right: that
    });
  } else if (diff2322 < -1) {
    if (self2.left.depth >= self2.right.depth) {
      const nr = appendAll45(self2.right, that);
      return makeChunk35({
        _tag: "IConcat",
        left: self2.left,
        right: nr
      });
    } else {
      const nrr = appendAll45(self2.right.right, that);
      if (nrr.depth === self2.depth - 3) {
        const nr = makeChunk35({
          _tag: "IConcat",
          left: self2.right.left,
          right: nrr
        });
        return makeChunk35({
          _tag: "IConcat",
          left: self2.left,
          right: nr
        });
      } else {
        const nl = makeChunk35({
          _tag: "IConcat",
          left: self2.left,
          right: self2.right.left
        });
        return makeChunk35({
          _tag: "IConcat",
          left: nl,
          right: nrr
        });
      }
    }
  } else {
    if (that.right.depth >= that.left.depth) {
      const nl = appendAll45(self2, that.left);
      return makeChunk35({
        _tag: "IConcat",
        left: nl,
        right: that.right
      });
    } else {
      const nll = appendAll45(self2, that.left.left);
      if (nll.depth === that.depth - 3) {
        const nl = makeChunk35({
          _tag: "IConcat",
          left: nll,
          right: that.left.right
        });
        return makeChunk35({
          _tag: "IConcat",
          left: nl,
          right: that.right
        });
      } else {
        const nr = makeChunk35({
          _tag: "IConcat",
          left: that.left.right,
          right: that.right
        });
        return makeChunk35({
          _tag: "IConcat",
          left: nll,
          right: nr
        });
      }
    }
  }
});
var isEmpty45 = (self2) => self2.length === 0;
var isNonEmpty35 = (self2) => self2.length > 0;
var unsafeHead35 = (self2) => unsafeGet235(self2, 0);
var headNonEmpty45 = unsafeHead35;
var tailNonEmpty45 = (self2) => drop45(self2, 1);
var SIZE35 = 5;
var BUCKET_SIZE35 = /* @__PURE__ */ Math.pow(2, SIZE35);
var MASK35 = BUCKET_SIZE35 - 1;
var MAX_INDEX_NODE35 = BUCKET_SIZE35 / 2;
var MIN_ARRAY_NODE35 = BUCKET_SIZE35 / 4;
function popcount35(x2222) {
  x2222 -= x2222 >> 1 & 1431655765;
  x2222 = (x2222 & 858993459) + (x2222 >> 2 & 858993459);
  x2222 = x2222 + (x2222 >> 4) & 252645135;
  x2222 += x2222 >> 8;
  x2222 += x2222 >> 16;
  return x2222 & 127;
}
function hashFragment35(shift22, h2222) {
  return h2222 >>> shift22 & MASK35;
}
function toBitmap35(x2222) {
  return 1 << x2222;
}
function fromBitmap35(bitmap, bit) {
  return popcount35(bitmap & bit - 1);
}
var make535 = (value, previous) => ({
  value,
  previous
});
function arrayUpdate35(mutate2322, at, v2222, arr) {
  let out = arr;
  if (!mutate2322) {
    const len = arr.length;
    out = new Array(len);
    for (let i2222 = 0; i2222 < len; ++i2222) out[i2222] = arr[i2222];
  }
  out[at] = v2222;
  return out;
}
function arraySpliceOut35(mutate2322, at, arr) {
  const newLen = arr.length - 1;
  let i2222 = 0;
  let g2222 = 0;
  let out = arr;
  if (mutate2322) {
    i2222 = g2222 = at;
  } else {
    out = new Array(newLen);
    while (i2222 < at) out[g2222++] = arr[i2222++];
  }
  ++i2222;
  while (i2222 <= newLen) out[g2222++] = arr[i2222++];
  if (mutate2322) {
    out.length = newLen;
  }
  return out;
}
function arraySpliceIn35(mutate2322, at, v2222, arr) {
  const len = arr.length;
  if (mutate2322) {
    let i22222 = len;
    while (i22222 >= at) arr[i22222--] = arr[i22222];
    arr[at] = v2222;
    return arr;
  }
  let i2222 = 0, g2222 = 0;
  const out = new Array(len + 1);
  while (i2222 < at) out[g2222++] = arr[i2222++];
  out[at] = v2222;
  while (i2222 < len) out[++g2222] = arr[i2222++];
  return out;
}
var EmptyNode35 = class _EmptyNode35 {
  _tag = "EmptyNode";
  modify(edit, _shift, f2222, hash22322, key, size4322) {
    const v2222 = f2222(none2235());
    if (isNone2235(v2222)) return new _EmptyNode35();
    ++size4322.value;
    return new LeafNode35(edit, hash22322, key, v2222);
  }
};
function isEmptyNode35(a2222) {
  return isTagged55(a2222, "EmptyNode");
}
function isLeafNode35(node) {
  return isEmptyNode35(node) || node._tag === "LeafNode" || node._tag === "CollisionNode";
}
function canEditNode35(node, edit) {
  return isEmptyNode35(node) ? false : edit === node.edit;
}
var LeafNode35 = class _LeafNode35 {
  edit;
  hash;
  key;
  value;
  _tag = "LeafNode";
  constructor(edit, hash22322, key, value) {
    this.edit = edit;
    this.hash = hash22322;
    this.key = key;
    this.value = value;
  }
  modify(edit, shift22, f2222, hash22322, key, size4322) {
    if (equals235(key, this.key)) {
      const v22222 = f2222(this.value);
      if (v22222 === this.value) return this;
      else if (isNone2235(v22222)) {
        --size4322.value;
        return new EmptyNode35();
      }
      if (canEditNode35(this, edit)) {
        this.value = v22222;
        return this;
      }
      return new _LeafNode35(edit, hash22322, key, v22222);
    }
    const v2222 = f2222(none2235());
    if (isNone2235(v2222)) return this;
    ++size4322.value;
    return mergeLeaves35(edit, shift22, this.hash, this, hash22322, new _LeafNode35(edit, hash22322, key, v2222));
  }
};
var CollisionNode35 = class _CollisionNode35 {
  edit;
  hash;
  children;
  _tag = "CollisionNode";
  constructor(edit, hash22322, children) {
    this.edit = edit;
    this.hash = hash22322;
    this.children = children;
  }
  modify(edit, shift22, f2222, hash22322, key, size4322) {
    if (hash22322 === this.hash) {
      const canEdit = canEditNode35(this, edit);
      const list = this.updateCollisionList(canEdit, edit, this.hash, this.children, f2222, key, size4322);
      if (list === this.children) return this;
      return list.length > 1 ? new _CollisionNode35(edit, this.hash, list) : list[0];
    }
    const v2222 = f2222(none2235());
    if (isNone2235(v2222)) return this;
    ++size4322.value;
    return mergeLeaves35(edit, shift22, this.hash, this, hash22322, new LeafNode35(edit, hash22322, key, v2222));
  }
  updateCollisionList(mutate2322, edit, hash22322, list, f2222, key, size4322) {
    const len = list.length;
    for (let i2222 = 0; i2222 < len; ++i2222) {
      const child = list[i2222];
      if ("key" in child && equals235(key, child.key)) {
        const value = child.value;
        const newValue2 = f2222(value);
        if (newValue2 === value) return list;
        if (isNone2235(newValue2)) {
          --size4322.value;
          return arraySpliceOut35(mutate2322, i2222, list);
        }
        return arrayUpdate35(mutate2322, i2222, new LeafNode35(edit, hash22322, key, newValue2), list);
      }
    }
    const newValue = f2222(none2235());
    if (isNone2235(newValue)) return list;
    ++size4322.value;
    return arrayUpdate35(mutate2322, len, new LeafNode35(edit, hash22322, key, newValue), list);
  }
};
var IndexedNode35 = class _IndexedNode35 {
  edit;
  mask;
  children;
  _tag = "IndexedNode";
  constructor(edit, mask, children) {
    this.edit = edit;
    this.mask = mask;
    this.children = children;
  }
  modify(edit, shift22, f2222, hash22322, key, size4322) {
    const mask = this.mask;
    const children = this.children;
    const frag = hashFragment35(shift22, hash22322);
    const bit = toBitmap35(frag);
    const indx = fromBitmap35(mask, bit);
    const exists22322 = mask & bit;
    const canEdit = canEditNode35(this, edit);
    if (!exists22322) {
      const _newChild = new EmptyNode35().modify(edit, shift22 + SIZE35, f2222, hash22322, key, size4322);
      if (!_newChild) return this;
      return children.length >= MAX_INDEX_NODE35 ? expand35(edit, frag, _newChild, mask, children) : new _IndexedNode35(edit, mask | bit, arraySpliceIn35(canEdit, indx, _newChild, children));
    }
    const current = children[indx];
    const child = current.modify(edit, shift22 + SIZE35, f2222, hash22322, key, size4322);
    if (current === child) return this;
    let bitmap = mask;
    let newChildren;
    if (isEmptyNode35(child)) {
      bitmap &= ~bit;
      if (!bitmap) return new EmptyNode35();
      if (children.length <= 2 && isLeafNode35(children[indx ^ 1])) {
        return children[indx ^ 1];
      }
      newChildren = arraySpliceOut35(canEdit, indx, children);
    } else {
      newChildren = arrayUpdate35(canEdit, indx, child, children);
    }
    if (canEdit) {
      this.mask = bitmap;
      this.children = newChildren;
      return this;
    }
    return new _IndexedNode35(edit, bitmap, newChildren);
  }
};
var ArrayNode35 = class _ArrayNode35 {
  edit;
  size;
  children;
  _tag = "ArrayNode";
  constructor(edit, size4322, children) {
    this.edit = edit;
    this.size = size4322;
    this.children = children;
  }
  modify(edit, shift22, f2222, hash22322, key, size4322) {
    let count = this.size;
    const children = this.children;
    const frag = hashFragment35(shift22, hash22322);
    const child = children[frag];
    const newChild = (child || new EmptyNode35()).modify(edit, shift22 + SIZE35, f2222, hash22322, key, size4322);
    if (child === newChild) return this;
    const canEdit = canEditNode35(this, edit);
    let newChildren;
    if (isEmptyNode35(child) && !isEmptyNode35(newChild)) {
      ++count;
      newChildren = arrayUpdate35(canEdit, frag, newChild, children);
    } else if (!isEmptyNode35(child) && isEmptyNode35(newChild)) {
      --count;
      if (count <= MIN_ARRAY_NODE35) {
        return pack35(edit, count, frag, children);
      }
      newChildren = arrayUpdate35(canEdit, frag, new EmptyNode35(), children);
    } else {
      newChildren = arrayUpdate35(canEdit, frag, newChild, children);
    }
    if (canEdit) {
      this.size = count;
      this.children = newChildren;
      return this;
    }
    return new _ArrayNode35(edit, count, newChildren);
  }
};
function pack35(edit, count, removed, elements) {
  const children = new Array(count - 1);
  let g2222 = 0;
  let bitmap = 0;
  for (let i2222 = 0, len = elements.length; i2222 < len; ++i2222) {
    if (i2222 !== removed) {
      const elem = elements[i2222];
      if (elem && !isEmptyNode35(elem)) {
        children[g2222++] = elem;
        bitmap |= 1 << i2222;
      }
    }
  }
  return new IndexedNode35(edit, bitmap, children);
}
function expand35(edit, frag, child, bitmap, subNodes) {
  const arr = [];
  let bit = bitmap;
  let count = 0;
  for (let i2222 = 0; bit; ++i2222) {
    if (bit & 1) arr[i2222] = subNodes[count++];
    bit >>>= 1;
  }
  arr[frag] = child;
  return new ArrayNode35(edit, count + 1, arr);
}
function mergeLeavesInner35(edit, shift22, h1, n1, h2222, n2222) {
  if (h1 === h2222) return new CollisionNode35(edit, h1, [n2222, n1]);
  const subH1 = hashFragment35(shift22, h1);
  const subH2 = hashFragment35(shift22, h2222);
  if (subH1 === subH2) {
    return (child) => new IndexedNode35(edit, toBitmap35(subH1) | toBitmap35(subH2), [child]);
  } else {
    const children = subH1 < subH2 ? [n1, n2222] : [n2222, n1];
    return new IndexedNode35(edit, toBitmap35(subH1) | toBitmap35(subH2), children);
  }
}
function mergeLeaves35(edit, shift22, h1, n1, h2222, n2222) {
  let stack = void 0;
  let currentShift = shift22;
  while (true) {
    const res = mergeLeavesInner35(edit, currentShift, h1, n1, h2222, n2222);
    if (typeof res === "function") {
      stack = make535(res, stack);
      currentShift = currentShift + SIZE35;
    } else {
      let final = res;
      while (stack != null) {
        final = stack.value(final);
        stack = stack.previous;
      }
      return final;
    }
  }
}
var HashMapSymbolKey35 = "effect/HashMap";
var HashMapTypeId35 = /* @__PURE__ */ Symbol.for(HashMapSymbolKey35);
var HashMapProto35 = {
  [HashMapTypeId35]: HashMapTypeId35,
  [Symbol.iterator]() {
    return new HashMapIterator35(this, (k2222, v2222) => [k2222, v2222]);
  },
  [symbol335]() {
    let hash22322 = hash235(HashMapSymbolKey35);
    for (const item of this) {
      hash22322 ^= pipe235(hash235(item[0]), combine235(hash235(item[1])));
    }
    return cached235(this, hash22322);
  },
  [symbol2235](that) {
    if (isHashMap35(that)) {
      if (that._size !== this._size) {
        return false;
      }
      for (const item of this) {
        const elem = pipe235(that, getHash35(item[0], hash235(item[0])));
        if (isNone2235(elem)) {
          return false;
        } else {
          if (!equals235(item[1], elem.value)) {
            return false;
          }
        }
      }
      return true;
    }
    return false;
  },
  toString() {
    return format235(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashMap",
      values: Array.from(this).map(toJSON235)
    };
  },
  [NodeInspectSymbol235]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments235(this, arguments);
  }
};
var makeImpl45 = (editable, edit, root, size4322) => {
  const map622 = Object.create(HashMapProto35);
  map622._editable = editable;
  map622._edit = edit;
  map622._root = root;
  map622._size = size4322;
  return map622;
};
var HashMapIterator35 = class _HashMapIterator35 {
  map;
  f;
  v;
  constructor(map622, f2222) {
    this.map = map622;
    this.f = f2222;
    this.v = visitLazy35(this.map._root, this.f, void 0);
  }
  next() {
    if (isNone2235(this.v)) {
      return {
        done: true,
        value: void 0
      };
    }
    const v0 = this.v.value;
    this.v = applyCont35(v0.cont);
    return {
      done: false,
      value: v0.value
    };
  }
  [Symbol.iterator]() {
    return new _HashMapIterator35(this.map, this.f);
  }
};
var applyCont35 = (cont) => cont ? visitLazyChildren35(cont[0], cont[1], cont[2], cont[3], cont[4]) : none2235();
var visitLazy35 = (node, f2222, cont = void 0) => {
  switch (node._tag) {
    case "LeafNode": {
      if (isSome2235(node.value)) {
        return some3235({
          value: f2222(node.key, node.value.value),
          cont
        });
      }
      return applyCont35(cont);
    }
    case "CollisionNode":
    case "ArrayNode":
    case "IndexedNode": {
      const children = node.children;
      return visitLazyChildren35(children.length, children, 0, f2222, cont);
    }
    default: {
      return applyCont35(cont);
    }
  }
};
var visitLazyChildren35 = (len, children, i2222, f2222, cont) => {
  while (i2222 < len) {
    const child = children[i2222++];
    if (child && !isEmptyNode35(child)) {
      return visitLazy35(child, f2222, [len, children, i2222, f2222, cont]);
    }
  }
  return applyCont35(cont);
};
var _empty335 = /* @__PURE__ */ makeImpl45(false, 0, /* @__PURE__ */ new EmptyNode35(), 0);
var empty435 = () => _empty335;
var isHashMap35 = (u2222) => hasProperty235(u2222, HashMapTypeId35);
var getHash35 = /* @__PURE__ */ dual235(3, (self2, key, hash22322) => {
  let node = self2._root;
  let shift22 = 0;
  while (true) {
    switch (node._tag) {
      case "LeafNode": {
        return equals235(key, node.key) ? node.value : none2235();
      }
      case "CollisionNode": {
        if (hash22322 === node.hash) {
          const children = node.children;
          for (let i2222 = 0, len = children.length; i2222 < len; ++i2222) {
            const child = children[i2222];
            if ("key" in child && equals235(key, child.key)) {
              return child.value;
            }
          }
        }
        return none2235();
      }
      case "IndexedNode": {
        const frag = hashFragment35(shift22, hash22322);
        const bit = toBitmap35(frag);
        if (node.mask & bit) {
          node = node.children[fromBitmap35(node.mask, bit)];
          shift22 += SIZE35;
          break;
        }
        return none2235();
      }
      case "ArrayNode": {
        node = node.children[hashFragment35(shift22, hash22322)];
        if (node) {
          shift22 += SIZE35;
          break;
        }
        return none2235();
      }
      default:
        return none2235();
    }
  }
});
var set235 = /* @__PURE__ */ dual235(3, (self2, key, value) => modifyAt35(self2, key, () => some3235(value)));
var setTree35 = /* @__PURE__ */ dual235(3, (self2, newRoot, newSize) => {
  if (self2._editable) {
    self2._root = newRoot;
    self2._size = newSize;
    return self2;
  }
  return newRoot === self2._root ? self2 : makeImpl45(self2._editable, self2._edit, newRoot, newSize);
});
var keys45 = (self2) => new HashMapIterator35(self2, (key) => key);
var size55 = (self2) => self2._size;
var beginMutation45 = (self2) => makeImpl45(true, self2._edit + 1, self2._root, self2._size);
var modifyAt35 = /* @__PURE__ */ dual235(3, (self2, key, f2222) => modifyHash35(self2, key, hash235(key), f2222));
var modifyHash35 = /* @__PURE__ */ dual235(4, (self2, key, hash22322, f2222) => {
  const size4322 = {
    value: self2._size
  };
  const newRoot = self2._root.modify(self2._editable ? self2._edit : NaN, 0, f2222, hash22322, key, size4322);
  return pipe235(self2, setTree35(newRoot, size4322.value));
});
var forEach65 = /* @__PURE__ */ dual235(2, (self2, f2222) => reduce235(self2, void 0, (_2222, value, key) => f2222(value, key)));
var reduce235 = /* @__PURE__ */ dual235(3, (self2, zero, f2222) => {
  const root = self2._root;
  if (root._tag === "LeafNode") {
    return isSome2235(root.value) ? f2222(zero, root.value.value, root.key) : zero;
  }
  if (root._tag === "EmptyNode") {
    return zero;
  }
  const toVisit = [root.children];
  let children;
  while (children = toVisit.pop()) {
    for (let i2222 = 0, len = children.length; i2222 < len; ) {
      const child = children[i2222++];
      if (child && !isEmptyNode35(child)) {
        if (child._tag === "LeafNode") {
          if (isSome2235(child.value)) {
            zero = f2222(zero, child.value.value, child.key);
          }
        } else {
          toVisit.push(child.children);
        }
      }
    }
  }
  return zero;
});
var HashSetSymbolKey35 = "effect/HashSet";
var HashSetTypeId35 = /* @__PURE__ */ Symbol.for(HashSetSymbolKey35);
var HashSetProto35 = {
  [HashSetTypeId35]: HashSetTypeId35,
  [Symbol.iterator]() {
    return keys45(this._keyMap);
  },
  [symbol335]() {
    return cached235(this, combine235(hash235(this._keyMap))(hash235(HashSetSymbolKey35)));
  },
  [symbol2235](that) {
    if (isHashSet35(that)) {
      return size55(this._keyMap) === size55(that._keyMap) && equals235(this._keyMap, that._keyMap);
    }
    return false;
  },
  toString() {
    return format235(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashSet",
      values: Array.from(this).map(toJSON235)
    };
  },
  [NodeInspectSymbol235]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments235(this, arguments);
  }
};
var makeImpl235 = (keyMap) => {
  const set22322 = Object.create(HashSetProto35);
  set22322._keyMap = keyMap;
  return set22322;
};
var isHashSet35 = (u2222) => hasProperty235(u2222, HashSetTypeId35);
var _empty435 = /* @__PURE__ */ makeImpl235(/* @__PURE__ */ empty435());
var empty535 = () => _empty435;
var size235 = (self2) => size55(self2._keyMap);
var beginMutation235 = (self2) => makeImpl235(beginMutation45(self2._keyMap));
var endMutation35 = (self2) => {
  self2._keyMap._editable = false;
  return self2;
};
var mutate35 = /* @__PURE__ */ dual235(2, (self2, f2222) => {
  const transient = beginMutation235(self2);
  f2222(transient);
  return endMutation35(transient);
});
var add235 = /* @__PURE__ */ dual235(2, (self2, value) => self2._keyMap._editable ? (set235(value, true)(self2._keyMap), self2) : makeImpl235(set235(value, true)(self2._keyMap)));
var union235 = /* @__PURE__ */ dual235(2, (self2, that) => mutate35(empty535(), (set22322) => {
  forEach235(self2, (value) => add235(set22322, value));
  for (const value of that) {
    add235(set22322, value);
  }
}));
var forEach235 = /* @__PURE__ */ dual235(2, (self2, f2222) => forEach65(self2._keyMap, (_2222, k2222) => f2222(k2222)));
var empty635 = empty535;
var size335 = size235;
var add335 = add235;
var union335 = union235;
var ArrayProto35 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(Array.prototype), {
  [symbol335]() {
    return cached235(this, array75(this));
  },
  [symbol2235](that) {
    if (Array.isArray(that) && this.length === that.length) {
      return this.every((v2222, i2222) => equals235(v2222, that[i2222]));
    } else {
      return false;
    }
  }
});
var Structural45 = /* @__PURE__ */ function() {
  function Structural3322(args) {
    if (args) {
      Object.assign(this, args);
    }
  }
  Structural3322.prototype = StructuralPrototype235;
  return Structural3322;
}();
var struct235 = (as22322) => Object.assign(Object.create(StructuralPrototype235), as22322);
var ContextPatchTypeId35 = /* @__PURE__ */ Symbol.for("effect/DifferContextPatch");
function variance45(a2222) {
  return a2222;
}
var PatchProto35 = {
  ...Structural45.prototype,
  [ContextPatchTypeId35]: {
    _Value: variance45,
    _Patch: variance45
  }
};
var EmptyProto35 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto35), {
  _tag: "Empty"
});
var _empty535 = /* @__PURE__ */ Object.create(EmptyProto35);
var empty735 = () => _empty535;
var AndThenProto35 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto35), {
  _tag: "AndThen"
});
var makeAndThen35 = (first, second) => {
  const o2222 = Object.create(AndThenProto35);
  o2222.first = first;
  o2222.second = second;
  return o2222;
};
var AddServiceProto35 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto35), {
  _tag: "AddService"
});
var makeAddService35 = (key, service) => {
  const o2222 = Object.create(AddServiceProto35);
  o2222.key = key;
  o2222.service = service;
  return o2222;
};
var RemoveServiceProto35 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto35), {
  _tag: "RemoveService"
});
var makeRemoveService35 = (key) => {
  const o2222 = Object.create(RemoveServiceProto35);
  o2222.key = key;
  return o2222;
};
var UpdateServiceProto35 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto35), {
  _tag: "UpdateService"
});
var makeUpdateService35 = (key, update222) => {
  const o2222 = Object.create(UpdateServiceProto35);
  o2222.key = key;
  o2222.update = update222;
  return o2222;
};
var diff35 = (oldValue, newValue) => {
  const missingServices = new Map(oldValue.unsafeMap);
  let patch2322 = empty735();
  for (const [tag, newService] of newValue.unsafeMap.entries()) {
    if (missingServices.has(tag)) {
      const old = missingServices.get(tag);
      missingServices.delete(tag);
      if (!equals235(old, newService)) {
        patch2322 = combine2235(makeUpdateService35(tag, () => newService))(patch2322);
      }
    } else {
      missingServices.delete(tag);
      patch2322 = combine2235(makeAddService35(tag, newService))(patch2322);
    }
  }
  for (const [tag] of missingServices.entries()) {
    patch2322 = combine2235(makeRemoveService35(tag))(patch2322);
  }
  return patch2322;
};
var combine2235 = /* @__PURE__ */ dual235(2, (self2, that) => makeAndThen35(self2, that));
var patch35 = /* @__PURE__ */ dual235(2, (self2, context) => {
  if (self2._tag === "Empty") {
    return context;
  }
  let wasServiceUpdated = false;
  let patches = of45(self2);
  const updatedContext = new Map(context.unsafeMap);
  while (isNonEmpty35(patches)) {
    const head222 = headNonEmpty45(patches);
    const tail322 = tailNonEmpty45(patches);
    switch (head222._tag) {
      case "Empty": {
        patches = tail322;
        break;
      }
      case "AddService": {
        updatedContext.set(head222.key, head222.service);
        patches = tail322;
        break;
      }
      case "AndThen": {
        patches = prepend55(prepend55(tail322, head222.second), head222.first);
        break;
      }
      case "RemoveService": {
        updatedContext.delete(head222.key);
        patches = tail322;
        break;
      }
      case "UpdateService": {
        updatedContext.set(head222.key, head222.update(updatedContext.get(head222.key)));
        wasServiceUpdated = true;
        patches = tail322;
        break;
      }
    }
  }
  if (!wasServiceUpdated) {
    return makeContext35(updatedContext);
  }
  const map622 = /* @__PURE__ */ new Map();
  for (const [tag] of context.unsafeMap) {
    if (updatedContext.has(tag)) {
      map622.set(tag, updatedContext.get(tag));
      updatedContext.delete(tag);
    }
  }
  for (const [tag, s2222] of updatedContext) {
    map622.set(tag, s2222);
  }
  return makeContext35(map622);
});
var DifferTypeId35 = /* @__PURE__ */ Symbol.for("effect/Differ");
var DifferProto35 = {
  [DifferTypeId35]: {
    _P: identity235,
    _V: identity235
  }
};
var make735 = (params) => {
  const differ = Object.create(DifferProto35);
  differ.empty = params.empty;
  differ.diff = params.diff;
  differ.combine = params.combine;
  differ.patch = params.patch;
  return differ;
};
var environment35 = () => make735({
  empty: empty735(),
  combine: (first, second) => combine2235(second)(first),
  diff: (oldValue, newValue) => diff35(oldValue, newValue),
  patch: (patch2322, oldValue) => patch35(oldValue)(patch2322)
});
var OP_DIE35 = "Die";
var OP_EMPTY35 = "Empty";
var OP_FAIL35 = "Fail";
var OP_INTERRUPT35 = "Interrupt";
var OP_PARALLEL35 = "Parallel";
var OP_SEQUENTIAL35 = "Sequential";
var CauseSymbolKey35 = "effect/Cause";
var CauseTypeId35 = /* @__PURE__ */ Symbol.for(CauseSymbolKey35);
var variance235 = {
  /* c8 ignore next */
  _E: (_2222) => _2222
};
var proto35 = {
  [CauseTypeId35]: variance235,
  [symbol335]() {
    return pipe235(hash235(CauseSymbolKey35), combine235(hash235(flattenCause35(this))), cached235(this));
  },
  [symbol2235](that) {
    return isCause35(that) && causeEquals35(this, that);
  },
  pipe() {
    return pipeArguments235(this, arguments);
  },
  toJSON() {
    switch (this._tag) {
      case "Empty":
        return {
          _id: "Cause",
          _tag: this._tag
        };
      case "Die":
        return {
          _id: "Cause",
          _tag: this._tag,
          defect: toJSON235(this.defect)
        };
      case "Interrupt":
        return {
          _id: "Cause",
          _tag: this._tag,
          fiberId: this.fiberId.toJSON()
        };
      case "Fail":
        return {
          _id: "Cause",
          _tag: this._tag,
          failure: toJSON235(this.error)
        };
      case "Sequential":
      case "Parallel":
        return {
          _id: "Cause",
          _tag: this._tag,
          left: toJSON235(this.left),
          right: toJSON235(this.right)
        };
    }
  },
  toString() {
    return pretty35(this);
  },
  [NodeInspectSymbol235]() {
    return this.toJSON();
  }
};
var fail45 = (error) => {
  const o2222 = Object.create(proto35);
  o2222._tag = OP_FAIL35;
  o2222.error = error;
  return o2222;
};
var parallel35 = (left3322, right3322) => {
  const o2222 = Object.create(proto35);
  o2222._tag = OP_PARALLEL35;
  o2222.left = left3322;
  o2222.right = right3322;
  return o2222;
};
var sequential35 = (left3322, right3322) => {
  const o2222 = Object.create(proto35);
  o2222._tag = OP_SEQUENTIAL35;
  o2222.left = left3322;
  o2222.right = right3322;
  return o2222;
};
var isCause35 = (u2222) => hasProperty235(u2222, CauseTypeId35);
var isInterruptedOnly35 = (self2) => reduceWithContext35(void 0, IsInterruptedOnlyCauseReducer35)(self2);
var causeEquals35 = (left3322, right3322) => {
  let leftStack = of45(left3322);
  let rightStack = of45(right3322);
  while (isNonEmpty35(leftStack) && isNonEmpty35(rightStack)) {
    const [leftParallel, leftSequential] = pipe235(headNonEmpty45(leftStack), reduce435([empty635(), empty335()], ([parallel2322, sequential2322], cause) => {
      const [par, seq] = evaluateCause35(cause);
      return some3235([pipe235(parallel2322, union335(par)), pipe235(sequential2322, appendAll45(seq))]);
    }));
    const [rightParallel, rightSequential] = pipe235(headNonEmpty45(rightStack), reduce435([empty635(), empty335()], ([parallel2322, sequential2322], cause) => {
      const [par, seq] = evaluateCause35(cause);
      return some3235([pipe235(parallel2322, union335(par)), pipe235(sequential2322, appendAll45(seq))]);
    }));
    if (!equals235(leftParallel, rightParallel)) {
      return false;
    }
    leftStack = leftSequential;
    rightStack = rightSequential;
  }
  return true;
};
var flattenCause35 = (cause) => {
  return flattenCauseLoop35(of45(cause), empty335());
};
var flattenCauseLoop35 = (causes, flattened) => {
  while (1) {
    const [parallel2322, sequential2322] = pipe235(causes, reduce65([empty635(), empty335()], ([parallel322, sequential322], cause) => {
      const [par, seq] = evaluateCause35(cause);
      return [pipe235(parallel322, union335(par)), pipe235(sequential322, appendAll45(seq))];
    }));
    const updated = size335(parallel2322) > 0 ? pipe235(flattened, prepend55(parallel2322)) : flattened;
    if (isEmpty45(sequential2322)) {
      return reverse235(updated);
    }
    causes = sequential2322;
    flattened = updated;
  }
  throw new Error(getBugErrorMessage235("Cause.flattenCauseLoop"));
};
var evaluateCause35 = (self2) => {
  let cause = self2;
  const stack = [];
  let _parallel = empty635();
  let _sequential = empty335();
  while (cause !== void 0) {
    switch (cause._tag) {
      case OP_EMPTY35: {
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_FAIL35: {
        _parallel = add335(_parallel, make4235(cause._tag, cause.error));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_DIE35: {
        _parallel = add335(_parallel, make4235(cause._tag, cause.defect));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_INTERRUPT35: {
        _parallel = add335(_parallel, make4235(cause._tag, cause.fiberId));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_SEQUENTIAL35: {
        switch (cause.left._tag) {
          case OP_EMPTY35: {
            cause = cause.right;
            break;
          }
          case OP_SEQUENTIAL35: {
            cause = sequential35(cause.left.left, sequential35(cause.left.right, cause.right));
            break;
          }
          case OP_PARALLEL35: {
            cause = parallel35(sequential35(cause.left.left, cause.right), sequential35(cause.left.right, cause.right));
            break;
          }
          default: {
            _sequential = prepend55(_sequential, cause.right);
            cause = cause.left;
            break;
          }
        }
        break;
      }
      case OP_PARALLEL35: {
        stack.push(cause.right);
        cause = cause.left;
        break;
      }
    }
  }
  throw new Error(getBugErrorMessage235("Cause.evaluateCauseLoop"));
};
var IsInterruptedOnlyCauseReducer35 = {
  emptyCase: constTrue235,
  failCase: constFalse235,
  dieCase: constFalse235,
  interruptCase: constTrue235,
  sequentialCase: (_2222, left3322, right3322) => left3322 && right3322,
  parallelCase: (_2222, left3322, right3322) => left3322 && right3322
};
var OP_SEQUENTIAL_CASE35 = "SequentialCase";
var OP_PARALLEL_CASE35 = "ParallelCase";
var reduce435 = /* @__PURE__ */ dual235(3, (self2, zero, pf) => {
  let accumulator = zero;
  let cause = self2;
  const causes = [];
  while (cause !== void 0) {
    const option = pf(accumulator, cause);
    accumulator = isSome2235(option) ? option.value : accumulator;
    switch (cause._tag) {
      case OP_SEQUENTIAL35: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      case OP_PARALLEL35: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      default: {
        cause = void 0;
        break;
      }
    }
    if (cause === void 0 && causes.length > 0) {
      cause = causes.pop();
    }
  }
  return accumulator;
});
var reduceWithContext35 = /* @__PURE__ */ dual235(3, (self2, context, reducer) => {
  const input = [self2];
  const output = [];
  while (input.length > 0) {
    const cause = input.pop();
    switch (cause._tag) {
      case OP_EMPTY35: {
        output.push(right2235(reducer.emptyCase(context)));
        break;
      }
      case OP_FAIL35: {
        output.push(right2235(reducer.failCase(context, cause.error)));
        break;
      }
      case OP_DIE35: {
        output.push(right2235(reducer.dieCase(context, cause.defect)));
        break;
      }
      case OP_INTERRUPT35: {
        output.push(right2235(reducer.interruptCase(context, cause.fiberId)));
        break;
      }
      case OP_SEQUENTIAL35: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left2235({
          _tag: OP_SEQUENTIAL_CASE35
        }));
        break;
      }
      case OP_PARALLEL35: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left2235({
          _tag: OP_PARALLEL_CASE35
        }));
        break;
      }
    }
  }
  const accumulator = [];
  while (output.length > 0) {
    const either = output.pop();
    switch (either._tag) {
      case "Left": {
        switch (either.left._tag) {
          case OP_SEQUENTIAL_CASE35: {
            const left3322 = accumulator.pop();
            const right3322 = accumulator.pop();
            const value = reducer.sequentialCase(context, left3322, right3322);
            accumulator.push(value);
            break;
          }
          case OP_PARALLEL_CASE35: {
            const left3322 = accumulator.pop();
            const right3322 = accumulator.pop();
            const value = reducer.parallelCase(context, left3322, right3322);
            accumulator.push(value);
            break;
          }
        }
        break;
      }
      case "Right": {
        accumulator.push(either.right);
        break;
      }
    }
  }
  if (accumulator.length === 0) {
    throw new Error("BUG: Cause.reduceWithContext - please report an issue at https://github.com/Effect-TS/effect/issues");
  }
  return accumulator.pop();
});
var pretty35 = (cause) => {
  if (isInterruptedOnly35(cause)) {
    return "All fibers interrupted without errors.";
  }
  return prettyErrors35(cause).map((e2222) => e2222.stack).join("\n");
};
var PrettyError35 = class extends globalThis.Error {
  span = void 0;
  constructor(originalError) {
    const prevLimit = Error.stackTraceLimit;
    Error.stackTraceLimit = 0;
    super(prettyErrorMessage35(originalError));
    Error.stackTraceLimit = prevLimit;
    this.name = originalError instanceof Error ? originalError.name : "Error";
    if (typeof originalError === "object" && originalError !== null) {
      if (spanSymbol45 in originalError) {
        this.span = originalError[spanSymbol45];
      }
      Object.keys(originalError).forEach((key) => {
        if (!(key in this)) {
          this[key] = originalError[key];
        }
      });
    }
    this.stack = prettyErrorStack35(this.message, originalError instanceof Error && originalError.stack ? originalError.stack : "", this.span);
  }
  toJSON() {
    const out = {
      message: this.message,
      stack: this.stack
    };
    if (this.span) {
      out.span = this.span;
    }
    return out;
  }
};
var prettyErrorMessage35 = (u2222) => {
  if (typeof u2222 === "string") {
    return `Error: ${u2222}`;
  }
  try {
    if (hasProperty235(u2222, "toString") && isFunction3234(u2222["toString"]) && u2222["toString"] !== Object.prototype.toString && u2222["toString"] !== globalThis.Array.prototype.toString) {
      return u2222["toString"]();
    }
  } catch {
  }
  return `Error: ${JSON.stringify(u2222)}`;
};
var locationRegex35 = /\((.*)\)/;
var spanToTrace35 = /* @__PURE__ */ globalValue235("effect/Tracer/spanToTrace", () => /* @__PURE__ */ new WeakMap());
var prettyErrorStack35 = (message, stack, span222) => {
  const out = [message];
  const lines = stack.split("\n");
  for (let i2222 = 1; i2222 < lines.length; i2222++) {
    if (lines[i2222].includes("Generator.next")) {
      break;
    }
    if (lines[i2222].includes("effect_internal_function")) {
      out.pop();
      break;
    }
    out.push(lines[i2222].replace(/at .*effect_instruction_i.*\((.*)\)/, "at $1").replace(/EffectPrimitive\.\w+/, "<anonymous>"));
  }
  if (span222) {
    let current = span222;
    let i2222 = 0;
    while (current && current._tag === "Span" && i2222 < 10) {
      const stackFn = spanToTrace35.get(current);
      if (typeof stackFn === "function") {
        const stack2 = stackFn();
        const locationMatch = stack2.match(locationRegex35);
        const location = locationMatch ? locationMatch[1] : stack2.replace(/^at /, "");
        out.push(`    at ${current.name} (${location})`);
      } else {
        out.push(`    at ${current.name}`);
      }
      current = getOrUndefined235(current.parent);
      i2222++;
    }
  }
  return out.join("\n");
};
var spanSymbol45 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var prettyErrors35 = (cause) => reduceWithContext35(cause, void 0, {
  emptyCase: () => [],
  dieCase: (_2222, unknownError) => {
    return [new PrettyError35(unknownError)];
  },
  failCase: (_2222, error) => {
    return [new PrettyError35(error)];
  },
  interruptCase: () => [],
  parallelCase: (_2222, l2222, r2222) => [...l2222, ...r2222],
  sequentialCase: (_2222, l2222, r2222) => [...l2222, ...r2222]
});
var SingleShotGen2235 = class _SingleShotGen235 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  next(a2222) {
    return this.called ? {
      value: a2222,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  return(a2222) {
    return {
      value: a2222,
      done: true
    };
  }
  throw(e2222) {
    throw e2222;
  }
  [Symbol.iterator]() {
    return new _SingleShotGen235(this.self);
  }
};
var spanTag35 = /* @__PURE__ */ GenericTag35("effect/ParentSpan");
var EffectTypeId2235 = /* @__PURE__ */ Symbol.for("effect/Effect");
var EffectPrimitive35 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId2235] = effectVariance235;
  constructor(_op) {
    this._op = _op;
  }
  [symbol2235](that) {
    return this === that;
  }
  [symbol335]() {
    return cached235(this, random235(this));
  }
  pipe() {
    return pipeArguments235(this, arguments);
  }
  toJSON() {
    return {
      _id: "Effect",
      _op: this._op,
      effect_instruction_i0: toJSON235(this.effect_instruction_i0),
      effect_instruction_i1: toJSON235(this.effect_instruction_i1),
      effect_instruction_i2: toJSON235(this.effect_instruction_i2)
    };
  }
  toString() {
    return format235(this.toJSON());
  }
  [NodeInspectSymbol235]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen2235(new YieldWrap235(this));
  }
};
var EffectPrimitiveFailure35 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId2235] = effectVariance235;
  constructor(_op) {
    this._op = _op;
    this._tag = _op;
  }
  [symbol2235](that) {
    return exitIsExit35(that) && that._op === "Failure" && // @ts-expect-error
    equals235(this.effect_instruction_i0, that.effect_instruction_i0);
  }
  [symbol335]() {
    return pipe235(
      // @ts-expect-error
      string235(this._tag),
      // @ts-expect-error
      combine235(hash235(this.effect_instruction_i0)),
      cached235(this)
    );
  }
  get cause() {
    return this.effect_instruction_i0;
  }
  pipe() {
    return pipeArguments235(this, arguments);
  }
  toJSON() {
    return {
      _id: "Exit",
      _tag: this._op,
      cause: this.cause.toJSON()
    };
  }
  toString() {
    return format235(this.toJSON());
  }
  [NodeInspectSymbol235]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen2235(new YieldWrap235(this));
  }
};
var isEffect35 = (u2222) => hasProperty235(u2222, EffectTypeId2235);
var withFiberRuntime35 = (withRuntime) => {
  const effect = new EffectPrimitive35(OP_WITH_RUNTIME35);
  effect.effect_instruction_i0 = withRuntime;
  return effect;
};
var spanSymbol235 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var originalSymbol35 = /* @__PURE__ */ Symbol.for("effect/OriginalAnnotation");
var capture35 = (obj, span222) => {
  if (isSome2235(span222)) {
    return new Proxy(obj, {
      has(target, p2222) {
        return p2222 === spanSymbol235 || p2222 === originalSymbol35 || p2222 in target;
      },
      get(target, p2222) {
        if (p2222 === spanSymbol235) {
          return span222.value;
        }
        if (p2222 === originalSymbol35) {
          return obj;
        }
        return target[p2222];
      }
    });
  }
  return obj;
};
var fail235 = (error) => isObject235(error) && !(spanSymbol235 in error) ? withFiberRuntime35((fiber) => failCause35(fail45(capture35(error, currentSpanFromFiber35(fiber))))) : failCause35(fail45(error));
var failCause35 = (cause) => {
  const effect = new EffectPrimitiveFailure35(OP_FAILURE35);
  effect.effect_instruction_i0 = cause;
  return effect;
};
var FiberRefSymbolKey35 = "effect/FiberRef";
var FiberRefTypeId35 = /* @__PURE__ */ Symbol.for(FiberRefSymbolKey35);
var fiberRefVariance35 = {
  /* c8 ignore next */
  _A: (_2222) => _2222
};
var fiberRefUnsafeMakeContext35 = (initial) => {
  const differ = environment35();
  return fiberRefUnsafeMakePatch35(initial, {
    differ,
    fork: differ.empty
  });
};
var fiberRefUnsafeMakePatch35 = (initial, options) => ({
  [FiberRefTypeId35]: fiberRefVariance35,
  initial,
  diff: (oldValue, newValue) => options.differ.diff(oldValue, newValue),
  combine: (first, second) => options.differ.combine(first, second),
  patch: (patch2322) => (oldValue) => options.differ.patch(patch2322, oldValue),
  fork: options.fork,
  join: options.join ?? ((_2222, n2222) => n2222),
  pipe() {
    return pipeArguments235(this, arguments);
  }
});
var currentContext35 = /* @__PURE__ */ globalValue235(/* @__PURE__ */ Symbol.for("effect/FiberRef/currentContext"), () => fiberRefUnsafeMakeContext35(empty235()));
var YieldableError35 = /* @__PURE__ */ function() {
  class YieldableError2322 extends globalThis.Error {
    commit() {
      return fail235(this);
    }
    toString() {
      return this.message ? `${this.name}: ${this.message}` : this.name;
    }
    toJSON() {
      return {
        ...this
      };
    }
    [NodeInspectSymbol235]() {
      const stack = this.stack;
      if (stack) {
        return `${this.toString()}
${stack.split("\n").slice(1).join("\n")}`;
      }
      return this.toString();
    }
  }
  Object.assign(YieldableError2322.prototype, StructuralCommitPrototype235);
  return YieldableError2322;
}();
var exitIsExit35 = (u2222) => isEffect35(u2222) && "_tag" in u2222 && (u2222._tag === "Success" || u2222._tag === "Failure");
var currentSpanFromFiber35 = (fiber) => {
  const span222 = fiber.getFiberRef(currentContext35).unsafeMap.get(spanTag35.key);
  return span222 !== void 0 && span222._tag === "Span" ? some3235(span222) : none2235();
};
var Data_exports235 = {};
__export235(Data_exports235, {
  Class: () => Class235,
  Error: () => Error235,
  Structural: () => Structural235,
  TaggedClass: () => TaggedClass35,
  TaggedError: () => TaggedError35,
  array: () => array235,
  case: () => _case35,
  struct: () => struct335,
  tagged: () => tagged35,
  taggedEnum: () => taggedEnum35,
  tuple: () => tuple235,
  unsafeArray: () => unsafeArray35,
  unsafeStruct: () => unsafeStruct35
});
var struct335 = struct235;
var unsafeStruct35 = (as22322) => Object.setPrototypeOf(as22322, StructuralPrototype235);
var tuple235 = (...as22322) => unsafeArray35(as22322);
var array235 = (as22322) => unsafeArray35(as22322.slice(0));
var unsafeArray35 = (as22322) => Object.setPrototypeOf(as22322, ArrayProto35);
var _case35 = () => (args) => args === void 0 ? Object.create(StructuralPrototype235) : struct335(args);
var tagged35 = (tag) => (args) => {
  const value = args === void 0 ? Object.create(StructuralPrototype235) : struct335(args);
  value._tag = tag;
  return value;
};
var Class235 = Structural45;
var TaggedClass35 = (tag) => {
  class Base extends Class235 {
    _tag = tag;
  }
  return Base;
};
var Structural235 = Structural45;
var taggedEnum35 = () => new Proxy({}, {
  get(_target, tag, _receiver) {
    if (tag === "$is") {
      return isTagged55;
    } else if (tag === "$match") {
      return taggedMatch35;
    }
    return tagged35(tag);
  }
});
function taggedMatch35() {
  if (arguments.length === 1) {
    const cases2 = arguments[0];
    return function(value2) {
      return cases2[value2._tag](value2);
    };
  }
  const value = arguments[0];
  const cases = arguments[1];
  return cases[value._tag](value);
}
var Error235 = /* @__PURE__ */ function() {
  return class Base extends YieldableError35 {
    constructor(args) {
      super();
      if (args) {
        Object.assign(this, args);
      }
    }
  };
}();
var TaggedError35 = (tag) => {
  class Base extends Error235 {
    _tag = tag;
  }
  Base.prototype.name = tag;
  return Base;
};
var traverseUp35 = Function_exports235.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType35.Program) return Option_exports235.none();
  return predicate(parent) ? Option_exports235.some(parent) : traverseUp35(parent, predicate);
});
var traverseUpGuard35 = Function_exports235.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType35.Program) return Option_exports235.none();
  return predicate(parent) ? Option_exports235.some(parent) : traverseUpGuard35(parent, predicate);
});
var ESLintCommunityESLintUtils35;
((ESLintCommunityESLintUtils2322) => {
  ESLintCommunityESLintUtils2322.getFunctionHeadLocation = getFunctionHeadLocation35;
  ESLintCommunityESLintUtils2322.getFunctionNameWithKind = getFunctionNameWithKind35;
  ESLintCommunityESLintUtils2322.getPropertyName = getPropertyName35;
  ESLintCommunityESLintUtils2322.getStaticValue = getStaticValue45;
  ESLintCommunityESLintUtils2322.getStringIfConstant = getStringIfConstant35;
  ESLintCommunityESLintUtils2322.hasSideEffect = hasSideEffect35;
  ESLintCommunityESLintUtils2322.isParenthesized = isParenthesized35;
})(ESLintCommunityESLintUtils35 || (ESLintCommunityESLintUtils35 = {}));
var Construction35 = Data_exports235.taggedEnum();
Construction35.None();
a224({
  type: N224.union([NodeType35.FunctionExpression, NodeType35.ArrowFunctionExpression]),
  parent: {
    type: NodeType35.Property,
    parent: {
      type: NodeType35.ObjectExpression
    }
  }
});
a224({
  type: N224.union([NodeType35.FunctionExpression, NodeType35.ArrowFunctionExpression]),
  parent: {
    type: NodeType35.MethodDefinition,
    parent: {
      type: NodeType35.ClassBody
    }
  }
});
a224({
  type: N224.union([NodeType35.FunctionExpression, NodeType35.ArrowFunctionExpression]),
  parent: {
    type: NodeType35.Property,
    parent: {
      type: NodeType35.ClassBody
    }
  }
});
function isInitializedFromReact4(variableName, context, initialScope) {
  if (variableName.toLowerCase() === "react") return true;
  const maybeVariable = findVariable35(variableName, initialScope);
  const maybeLatestDef = Option_exports45.flatMapNullable(maybeVariable, (v322) => v322.defs.at(-1));
  if (Option_exports45.isNone(maybeLatestDef)) return false;
  const latestDef = maybeLatestDef.value;
  const { node, parent } = latestDef;
  const settings = parse(ESLintSettingsSchema4, context.settings);
  const importSource = settings.reactOptions?.importSource ?? "react";
  if (node.type === NodeType25.VariableDeclarator && node.init) {
    const { init: init222 } = node;
    if (init222.type === NodeType25.MemberExpression && init222.object.type === NodeType25.Identifier) {
      return isInitializedFromReact4(init222.object.name, context, initialScope);
    }
    if (init222.type === NodeType25.Identifier) {
      return isInitializedFromReact4(init222.name, context, initialScope);
    }
    const maybeRequireExpression = $4(init222).with({
      type: NodeType25.CallExpression,
      callee: { type: NodeType25.Identifier, name: "require" }
    }, (exp) => Option_exports45.some(exp)).with(
      {
        type: NodeType25.MemberExpression,
        object: {
          type: NodeType25.CallExpression,
          callee: { type: NodeType25.Identifier, name: "require" }
        }
      },
      ({ object: object222 }) => Option_exports45.some(object222)
    ).otherwise(Option_exports45.none);
    if (Option_exports45.isNone(maybeRequireExpression)) return false;
    const requireExpression = maybeRequireExpression.value;
    const [firstArg] = requireExpression.arguments;
    if (firstArg?.type !== NodeType25.Literal || !Predicate_exports35.isString(firstArg.value)) return false;
    return firstArg.value === importSource || firstArg.value.startsWith(`${importSource}/`);
  }
  return a7({ type: "ImportDeclaration", source: { value: importSource } }, parent);
}
function isFromReact3(name22) {
  return (node, context) => {
    const initialScope = context.sourceCode.getScope(node);
    if (node.type === NodeType25.MemberExpression) {
      return node.object.type === NodeType25.Identifier && node.property.type === NodeType25.Identifier && node.property.name === name22 && isInitializedFromReact4(node.object.name, context, initialScope);
    }
    if (node.name === name22) return isInitializedFromReact4(name22, context, initialScope);
    return false;
  };
}
function isCallFromReact3(name22) {
  return (node, context) => {
    if (!isOneOf25([NodeType25.Identifier, NodeType25.MemberExpression])(node.callee)) return false;
    return isFromReact3(name22)(node.callee, context);
  };
}
function isReactAPICallWithName3(name22, member) {
  return isCallFromReact3(name22);
}
var isCreateElementCall3 = isReactAPICallWithName3("createElement");
var isForwardRefCall2 = isReactAPICallWithName3("forwardRef");
var isMemoCall2 = isReactAPICallWithName3("memo");
function isChildrenOfCreateElement2(node, context) {
  return Function_exports45.pipe(
    Option_exports45.fromNullable(node.parent),
    Option_exports45.filter(is25(NodeType25.CallExpression)),
    Option_exports45.filter((n322) => isCreateElementCall3(n322, context)),
    Option_exports45.exists(
      (n322) => n322.arguments.slice(2).some((arg) => arg === node)
    )
  );
}
var RE_HOOK_NAME3 = /^use[A-Z\d]/u;
function isReactHookName3(name22) {
  return name22 === "use" || RE_HOOK_NAME3.test(name22);
}
function isReactHookCall3(node) {
  if (node.callee.type === NodeType25.Identifier) return isReactHookName3(node.callee.name);
  if (node.callee.type === NodeType25.MemberExpression) {
    return node.callee.property.type === NodeType25.Identifier && isReactHookName3(node.callee.property.name);
  }
  return false;
}
function isReactHookCallWithName2(name22) {
  return (node, context) => {
    const initialScope = context.sourceCode.getScope(node);
    return $4(node.callee).with({ type: NodeType25.Identifier, name: name22 }, (n322) => isInitializedFromReact4(n322.name, context, initialScope)).with({ type: NodeType25.MemberExpression, object: { name: N7.string }, property: { name: name22 } }, (n322) => {
      return isInitializedFromReact4(n322.object.name, context, initialScope);
    }).otherwise(Function_exports45.constFalse);
  };
}
function isReactHookCallWithNameLoose3(name22) {
  return (node) => {
    return $4(node.callee).with({ type: NodeType25.Identifier, name: name22 }, Function_exports45.constTrue).with({ type: NodeType25.MemberExpression, property: { name: name22 } }, Function_exports45.constTrue).otherwise(Function_exports45.constFalse);
  };
}
var isUseStateCall2 = isReactHookCallWithName2("useState");
new import_short_unique_id4.default({ length: 10 });
var ERComponentHint2 = {
  ...JSXValueHint,
  // 1n << 0n - 1n << 63n are reserved for JSXValueHint
  // Skip function component created by React.memo
  SkipMemo: 1n << 64n,
  // Skip function component created by React.forwardRef
  SkipForwardRef: 1n << 65n,
  // Skip function component defined in map function callback
  SkipMapCallback: 1n << 66n,
  // Skip function component defined on object method
  SkipObjectMethod: 1n << 67n,
  // Skip function component defined on class method
  SkipClassMethod: 1n << 68n,
  // Skip function component defined on class property
  SkipClassProperty: 1n << 69n
};
var DEFAULT_COMPONENT_HINT2 = 0n | ERComponentHint2.SkipUndefinedLiteral | ERComponentHint2.SkipBooleanLiteral | ERComponentHint2.SkipStringLiteral | ERComponentHint2.SkipNumberLiteral;
var ERClassComponentFlag2 = {
  None: 0n,
  PureComponent: 1n << 0n
  // Reserved for future use
  // CreateElement: 1n << 1n,
};
var ERFunctionComponentFlag2 = {
  None: 0n,
  Memo: 1n << 0n,
  ForwardRef: 1n << 1n
  // Reserved for future use
  // CreateElement: 1n << 2n,
  // Reserved for future use
  // hasHooks: 1n << 3n,
  // Reserved for future use
  // Async: 1n << 4n,
};
function isComponentWrapperCall2(node, context) {
  if (node.type !== NodeType25.CallExpression) return false;
  return isMemoCall2(node, context) || isForwardRefCall2(node, context) || isReactHookCallWithNameLoose3("useCallback")(node);
}
function getFunctionComponentIdentifier2(node, context) {
  const functionId = getFunctionIdentifier22(node);
  if (Option_exports45.isSome(functionId)) return functionId;
  const { parent } = node;
  if (parent.type === NodeType25.CallExpression && isComponentWrapperCall2(parent, context) && parent.parent.type === NodeType25.VariableDeclarator && parent.parent.id.type === NodeType25.Identifier && parent.parent.parent.type === NodeType25.VariableDeclaration) {
    return Option_exports45.some(parent.parent.id);
  }
  if (parent.type === NodeType25.CallExpression && isComponentWrapperCall2(parent, context) && parent.parent.type === NodeType25.CallExpression && isComponentWrapperCall2(parent.parent, context) && parent.parent.parent.type === NodeType25.VariableDeclarator && parent.parent.parent.id.type === NodeType25.Identifier && parent.parent.parent.parent.type === NodeType25.VariableDeclaration) {
    return Option_exports45.some(parent.parent.parent.id);
  }
  return Option_exports45.none();
}
function getComponentInitPath2(node) {
  const { parent } = node;
  if (node.type === NodeType25.FunctionDeclaration) return Option_exports45.some([node]);
  if (parent.type === NodeType25.VariableDeclarator && parent.parent.type === NodeType25.VariableDeclaration) {
    return Option_exports45.some([
      parent.parent,
      parent,
      node
    ]);
  }
  if (parent.type === NodeType25.CallExpression && parent.parent.type === NodeType25.VariableDeclarator && parent.parent.parent.type === NodeType25.VariableDeclaration) {
    return Option_exports45.some([
      parent.parent.parent,
      parent.parent,
      parent,
      node
    ]);
  }
  if (parent.type === NodeType25.CallExpression && parent.parent.type === NodeType25.CallExpression && parent.parent.parent.type === NodeType25.VariableDeclarator && parent.parent.parent.parent.type === NodeType25.VariableDeclaration) {
    return Option_exports45.some([
      parent.parent.parent.parent,
      parent.parent.parent,
      parent.parent,
      parent,
      node
    ]);
  }
  if (parent.type === NodeType25.Property && parent.parent.type === NodeType25.ObjectExpression && parent.parent.parent.type === NodeType25.VariableDeclarator && parent.parent.parent.parent.type === NodeType25.VariableDeclaration) {
    return Option_exports45.some([
      parent.parent.parent.parent,
      parent.parent.parent,
      parent.parent,
      parent,
      node
    ]);
  }
  if (parent.type === NodeType25.MethodDefinition && parent.parent.type === NodeType25.ClassBody && parent.parent.parent.type === NodeType25.ClassDeclaration) {
    return Option_exports45.some([
      parent.parent.parent,
      parent.parent,
      parent,
      node
    ]);
  }
  if (parent.type === NodeType25.PropertyDefinition && parent.parent.type === NodeType25.ClassBody && parent.parent.parent.type === NodeType25.ClassDeclaration) {
    return Option_exports45.some([
      parent.parent.parent,
      parent.parent,
      parent,
      node
    ]);
  }
  return Option_exports45.none();
}
function hasCallInInitPath2(callName) {
  return (initPath) => {
    return Function_exports45.pipe(
      initPath,
      Option_exports45.filter((p322) => p322.length > 0),
      Option_exports45.exists((nodes) => {
        return nodes.some(
          // callName.includes(".")
          //   ? n => {
          //     const [objectName, propertyName] = callName.split(".");
          //     return "callee" in n
          //       && n.callee.type === NodeType.MemberExpression
          //       && n.callee.object.type === NodeType.Identifier
          //       && n.callee.object.name === objectName
          //       && n.callee.property.type === NodeType.Identifier
          //       && n.callee.property.name === propertyName;
          //   }
          //   : n => {
          //     return "callee" in n
          //       && n.callee.type === NodeType.Identifier
          //       && n.callee.name === callName;
          //   },
          (n322) => {
            if (n322.type !== NodeType25.CallExpression) return false;
            if (n322.callee.type === NodeType25.Identifier) return n322.callee.name === callName;
            return a7({ callee: { property: { name: callName } } }, n322);
          }
        );
      })
    );
  };
}
var RE_COMPONENT_NAME2 = /^[A-Z]/u;
function getComponentNameFromIdentifier2(node) {
  return Array.isArray(node) ? node.map((n322) => n322.name).join(".") : node.name;
}
function isComponentName2(name22) {
  return !!name22 && RE_COMPONENT_NAME2.test(name22);
}
function hasNoneOrValidComponentName2(node, context) {
  return Option_exports45.match(
    getFunctionComponentIdentifier2(node, context),
    {
      onNone: Function_exports45.constTrue,
      onSome: (id) => {
        const name22 = Array.isArray(id) ? id.at(-1)?.name : id.name;
        return !!name22 && isComponentName2(name22);
      }
    }
  );
}
var uid22 = new import_short_unique_id4.default({ length: 10 });
function isClassComponent2(node) {
  if (!("superClass" in node && node.superClass)) return false;
  const { superClass } = node;
  return $4(superClass).with({ type: NodeType25.Identifier, name: N7.string }, ({ name: name22 }) => /^(Pure)?Component$/u.test(name22)).with({
    type: NodeType25.MemberExpression,
    property: { name: N7.string }
  }, ({ property }) => /^(Pure)?Component$/u.test(property.name)).otherwise(() => false);
}
function isPureComponent2(node) {
  if ("superClass" in node && node.superClass) {
    return $4(node.superClass).with({ type: NodeType25.Identifier, name: N7.string }, ({ name: name22 }) => /^PureComponent$/u.test(name22)).with({
      type: NodeType25.MemberExpression,
      property: { name: N7.string }
    }, ({ property }) => /^PureComponent$/u.test(property.name)).otherwise(() => false);
  }
  return false;
}
function useComponentCollectorLegacy2() {
  const components = /* @__PURE__ */ new Map();
  const ctx = {
    getAllComponents(_322) {
      return components;
    },
    getCurrentComponents() {
      return new Map(components);
    }
  };
  const collect222 = (node) => {
    if (!isClassComponent2(node)) return;
    const id = getClassIdentifier22(node);
    const key = uid22.rnd();
    const flag = isPureComponent2(node) ? ERClassComponentFlag2.PureComponent : ERClassComponentFlag2.None;
    components.set(
      key,
      {
        _: key,
        id,
        kind: "class",
        name: Option_exports45.flatMapNullable(id, (n322) => n322.name),
        // TODO: get displayName of class component
        displayName: Option_exports45.none(),
        flag,
        hint: 0n,
        // TODO: get methods of class component
        methods: [],
        node
      }
    );
  };
  const listeners = {
    ClassDeclaration: collect222,
    ClassExpression: collect222
  };
  return {
    ctx,
    listeners
  };
}
var isRenderMethodLike2 = a7({
  key: {
    type: NodeType25.Identifier,
    name: "render"
  },
  type: N7.union(NodeType25.MethodDefinition, NodeType25.PropertyDefinition),
  parent: {
    type: NodeType25.ClassBody,
    parent: {
      type: NodeType25.ClassDeclaration
    }
  }
});
function isFunctionOfRenderMethod2(node) {
  if (!isRenderMethodLike2(node.parent)) return false;
  return isClassComponent2(node.parent.parent.parent);
}
var uid32 = new import_short_unique_id4.default({ length: 10 });
var isMapCall2 = a7({
  callee: {
    type: NodeType25.MemberExpression,
    property: {
      name: "map"
    }
  }
});
function hasValidHierarchy2(node, context, hint) {
  if (isChildrenOfCreateElement2(node, context) || isFunctionOfRenderMethod2(node)) {
    return false;
  }
  if (hint & ERComponentHint2.SkipMapCallback && isMapCall2(node.parent)) {
    return false;
  }
  if (hint & ERComponentHint2.SkipObjectMethod && isFunctionOfObjectMethod22(node.parent)) {
    return false;
  }
  if (hint & ERComponentHint2.SkipClassMethod && isFunctionOfClassMethod22(node.parent)) {
    return false;
  }
  if (hint & ERComponentHint2.SkipClassProperty && isFunctionOfClassProperty22(node.parent)) {
    return false;
  }
  return !Function_exports45.pipe(
    traverseUp25(
      node,
      isOneOf25([
        NodeType25.JSXExpressionContainer,
        NodeType25.ArrowFunctionExpression,
        NodeType25.FunctionExpression,
        NodeType25.Property,
        NodeType25.ClassBody
      ])
    ),
    Option_exports45.exists(is25(NodeType25.JSXExpressionContainer))
  );
}
function getComponentFlag2(initPath) {
  const flagRef = MutableRef_exports8.make(ERFunctionComponentFlag2.None);
  if (hasCallInInitPath2("memo")(initPath)) {
    MutableRef_exports8.update(flagRef, (f322) => f322 | ERFunctionComponentFlag2.Memo);
  }
  if (hasCallInInitPath2("forwardRef")(initPath)) {
    MutableRef_exports8.update(flagRef, (f322) => f322 | ERFunctionComponentFlag2.ForwardRef);
  }
  return MutableRef_exports8.get(flagRef);
}
function useComponentCollector2(context, hint = DEFAULT_COMPONENT_HINT2) {
  const components = /* @__PURE__ */ new Map();
  const functionStack = MutableList_exports5.make();
  const getCurrentFunction = () => Option_exports45.fromNullable(MutableList_exports5.tail(functionStack));
  const onFunctionEnter = (node) => MutableList_exports5.append(functionStack, [node, false, []]);
  const onFunctionExit = () => MutableList_exports5.pop(functionStack);
  const ctx = {
    getAllComponents(_322) {
      return components;
    },
    getCurrentComponents() {
      return new Map(components);
    },
    getCurrentFunction,
    getCurrentFunctionStack() {
      return [...functionStack];
    }
  };
  const listeners = {
    ":function": onFunctionEnter,
    ":function:exit": onFunctionExit,
    ReturnStatement(node) {
      const maybeCurrentFn = getCurrentFunction();
      if (Option_exports45.isNone(maybeCurrentFn)) return;
      const [currentFn, isKnown, hookCalls] = maybeCurrentFn.value;
      if (isKnown) return;
      const isComponent = hasNoneOrValidComponentName2(currentFn, context) && isJSXValue2(node.argument, context, hint) && hasValidHierarchy2(currentFn, context, hint);
      if (!isComponent) return;
      MutableList_exports5.pop(functionStack);
      MutableList_exports5.append(functionStack, [currentFn, true, []]);
      const initPath = getComponentInitPath2(currentFn);
      const id = getFunctionComponentIdentifier2(currentFn, context);
      const name22 = Option_exports45.flatMapNullable(id, getComponentNameFromIdentifier2);
      const key = uid32.rnd();
      components.set(key, {
        _: key,
        id,
        kind: "function",
        name: name22,
        displayName: Option_exports45.none(),
        flag: getComponentFlag2(initPath),
        hint,
        hookCalls,
        initPath,
        node: currentFn
      });
    },
    // eslint-disable-next-line perfectionist/sort-objects
    "ArrowFunctionExpression[body.type!='BlockStatement']"() {
      const maybeCurrentFn = getCurrentFunction();
      if (Option_exports45.isNone(maybeCurrentFn)) return;
      const [currentFn, _322, hookCalls] = maybeCurrentFn.value;
      const { body } = currentFn;
      const isComponent = Function_exports45.constTrue() && hasNoneOrValidComponentName2(currentFn, context) && isJSXValue2(body, context, hint) && hasValidHierarchy2(currentFn, context, hint);
      if (!isComponent) return;
      const initPath = getComponentInitPath2(currentFn);
      const id = getFunctionComponentIdentifier2(currentFn, context);
      const name22 = Option_exports45.flatMapNullable(id, getComponentNameFromIdentifier2);
      const key = uid32.rnd();
      components.set(key, {
        _: key,
        id,
        kind: "function",
        name: name22,
        displayName: Option_exports45.none(),
        flag: getComponentFlag2(initPath),
        hint,
        hookCalls,
        initPath,
        node: currentFn
      });
    },
    "CallExpression:exit"(node) {
      if (!isReactHookCall3(node)) return;
      const maybeCurrentFn = getCurrentFunction();
      if (Option_exports45.isNone(maybeCurrentFn)) return;
      const [currentFn, IsComponent, hookCalls] = maybeCurrentFn.value;
      MutableList_exports5.pop(functionStack);
      MutableList_exports5.append(functionStack, [currentFn, IsComponent, [...hookCalls, node]]);
    },
    // eslint-disable-next-line perfectionist/sort-objects
    "AssignmentExpression[operator='='][left.type='MemberExpression'][left.property.name='displayName']"(node) {
      if (node.type !== NodeType25.AssignmentExpression) return;
      const { left: left722, right: right722 } = node;
      if (left722.type !== NodeType25.MemberExpression) return;
      const maybeComponentName = $4(left722.object).with({ type: NodeType25.Identifier }, (n322) => Option_exports45.some(n322.name)).otherwise(Option_exports45.none);
      if (Option_exports45.isNone(maybeComponentName)) return;
      const component = Array.from(components.values()).findLast(({ name: name22 }) => Option_exports45.exists(name22, (n322) => n322 === maybeComponentName.value));
      if (!component) return;
      components.set(component._, {
        ...component,
        displayName: Option_exports45.some(right722)
      });
    }
  };
  return {
    ctx,
    listeners
  };
}
var __defProp54 = Object.defineProperty;
var __export54 = (target, all622) => {
  for (var name22 in all622)
    __defProp54(target, name22, { get: all622[name22], enumerable: true });
};
function resolveMemberExpressions2(object32, property) {
  if (object32.type === types.AST_NODE_TYPES.JSXMemberExpression) {
    return `${resolveMemberExpressions2(object32.object, object32.property)}.${property.name}`;
  }
  if (object32.type === types.AST_NODE_TYPES.JSXNamespacedName) {
    return `${object32.namespace.name}:${object32.name.name}.${property.name}`;
  }
  return `${object32.name}.${property.name}`;
}
function elementType2(node) {
  if (node.type === types.AST_NODE_TYPES.JSXOpeningFragment) {
    return "<>";
  }
  const { name: name22 } = node;
  if (name22.type === types.AST_NODE_TYPES.JSXMemberExpression) {
    const { object: object32, property } = name22;
    return resolveMemberExpressions2(object32, property);
  }
  if (name22.type === types.AST_NODE_TYPES.JSXNamespacedName) {
    return `${name22.namespace.name}:${name22.name.name}`;
  }
  return name22.name;
}
var KEYS44 = {
  ArrayExpression: [
    "elements"
  ],
  ArrayPattern: [
    "elements"
  ],
  ArrowFunctionExpression: [
    "params",
    "body"
  ],
  AssignmentExpression: [
    "left",
    "right"
  ],
  AssignmentPattern: [
    "left",
    "right"
  ],
  AwaitExpression: [
    "argument"
  ],
  BinaryExpression: [
    "left",
    "right"
  ],
  BlockStatement: [
    "body"
  ],
  BreakStatement: [
    "label"
  ],
  CallExpression: [
    "callee",
    "arguments"
  ],
  CatchClause: [
    "param",
    "body"
  ],
  ChainExpression: [
    "expression"
  ],
  ClassBody: [
    "body"
  ],
  ClassDeclaration: [
    "id",
    "superClass",
    "body"
  ],
  ClassExpression: [
    "id",
    "superClass",
    "body"
  ],
  ConditionalExpression: [
    "test",
    "consequent",
    "alternate"
  ],
  ContinueStatement: [
    "label"
  ],
  DebuggerStatement: [],
  DoWhileStatement: [
    "body",
    "test"
  ],
  EmptyStatement: [],
  ExperimentalRestProperty: [
    "argument"
  ],
  ExperimentalSpreadProperty: [
    "argument"
  ],
  ExportAllDeclaration: [
    "exported",
    "source"
  ],
  ExportDefaultDeclaration: [
    "declaration"
  ],
  ExportNamedDeclaration: [
    "declaration",
    "specifiers",
    "source"
  ],
  ExportSpecifier: [
    "exported",
    "local"
  ],
  ExpressionStatement: [
    "expression"
  ],
  ForInStatement: [
    "left",
    "right",
    "body"
  ],
  ForOfStatement: [
    "left",
    "right",
    "body"
  ],
  ForStatement: [
    "init",
    "test",
    "update",
    "body"
  ],
  FunctionDeclaration: [
    "id",
    "params",
    "body"
  ],
  FunctionExpression: [
    "id",
    "params",
    "body"
  ],
  Identifier: [],
  IfStatement: [
    "test",
    "consequent",
    "alternate"
  ],
  ImportDeclaration: [
    "specifiers",
    "source"
  ],
  ImportDefaultSpecifier: [
    "local"
  ],
  ImportExpression: [
    "source"
  ],
  ImportNamespaceSpecifier: [
    "local"
  ],
  ImportSpecifier: [
    "imported",
    "local"
  ],
  JSXAttribute: [
    "name",
    "value"
  ],
  JSXClosingElement: [
    "name"
  ],
  JSXClosingFragment: [],
  JSXElement: [
    "openingElement",
    "children",
    "closingElement"
  ],
  JSXEmptyExpression: [],
  JSXExpressionContainer: [
    "expression"
  ],
  JSXFragment: [
    "openingFragment",
    "children",
    "closingFragment"
  ],
  JSXIdentifier: [],
  JSXMemberExpression: [
    "object",
    "property"
  ],
  JSXNamespacedName: [
    "namespace",
    "name"
  ],
  JSXOpeningElement: [
    "name",
    "attributes"
  ],
  JSXOpeningFragment: [],
  JSXSpreadAttribute: [
    "argument"
  ],
  JSXSpreadChild: [
    "expression"
  ],
  JSXText: [],
  LabeledStatement: [
    "label",
    "body"
  ],
  Literal: [],
  LogicalExpression: [
    "left",
    "right"
  ],
  MemberExpression: [
    "object",
    "property"
  ],
  MetaProperty: [
    "meta",
    "property"
  ],
  MethodDefinition: [
    "key",
    "value"
  ],
  NewExpression: [
    "callee",
    "arguments"
  ],
  ObjectExpression: [
    "properties"
  ],
  ObjectPattern: [
    "properties"
  ],
  PrivateIdentifier: [],
  Program: [
    "body"
  ],
  Property: [
    "key",
    "value"
  ],
  PropertyDefinition: [
    "key",
    "value"
  ],
  RestElement: [
    "argument"
  ],
  ReturnStatement: [
    "argument"
  ],
  SequenceExpression: [
    "expressions"
  ],
  SpreadElement: [
    "argument"
  ],
  StaticBlock: [
    "body"
  ],
  Super: [],
  SwitchCase: [
    "test",
    "consequent"
  ],
  SwitchStatement: [
    "discriminant",
    "cases"
  ],
  TaggedTemplateExpression: [
    "tag",
    "quasi"
  ],
  TemplateElement: [],
  TemplateLiteral: [
    "quasis",
    "expressions"
  ],
  ThisExpression: [],
  ThrowStatement: [
    "argument"
  ],
  TryStatement: [
    "block",
    "handler",
    "finalizer"
  ],
  UnaryExpression: [
    "argument"
  ],
  UpdateExpression: [
    "argument"
  ],
  VariableDeclaration: [
    "declarations"
  ],
  VariableDeclarator: [
    "id",
    "init"
  ],
  WhileStatement: [
    "test",
    "body"
  ],
  WithStatement: [
    "object",
    "body"
  ],
  YieldExpression: [
    "argument"
  ]
};
var NODE_TYPES44 = Object.keys(KEYS44);
for (const type of NODE_TYPES44) {
  Object.freeze(KEYS44[type]);
}
Object.freeze(KEYS44);
var visitor_keys_default44 = KEYS44;
var KEY_BLACKLIST44 = /* @__PURE__ */ new Set([
  "parent",
  "leadingComments",
  "trailingComments"
]);
function filterKey44(key) {
  return !KEY_BLACKLIST44.has(key) && key[0] !== "_";
}
function getKeys44(node) {
  return Object.keys(node).filter(filterKey44);
}
function getInnermostScope44(initialScope, node) {
  const location = node.range[0];
  let scope = initialScope;
  let found = false;
  do {
    found = false;
    for (const childScope of scope.childScopes) {
      const range222 = childScope.block.range;
      if (range222[0] <= location && location < range222[1]) {
        scope = childScope;
        found = true;
        break;
      }
    }
  } while (found);
  return scope;
}
function findVariable44(initialScope, nameOrNode) {
  let name22 = "";
  let scope = initialScope;
  if (typeof nameOrNode === "string") {
    name22 = nameOrNode;
  } else {
    name22 = nameOrNode.name;
    scope = getInnermostScope44(scope, nameOrNode);
  }
  while (scope != null) {
    const variable = scope.set.get(name22);
    if (variable != null) {
      return variable;
    }
    scope = scope.upper;
  }
  return null;
}
function negate044(token) {
  return !this(token);
}
function negate44(f232) {
  return negate044.bind(f232);
}
function isPunctuatorTokenWithValue44(token, value) {
  return token.type === "Punctuator" && token.value === value;
}
function isArrowToken44(token) {
  return isPunctuatorTokenWithValue44(token, "=>");
}
function isCommaToken44(token) {
  return isPunctuatorTokenWithValue44(token, ",");
}
function isSemicolonToken44(token) {
  return isPunctuatorTokenWithValue44(token, ";");
}
function isColonToken44(token) {
  return isPunctuatorTokenWithValue44(token, ":");
}
function isOpeningParenToken44(token) {
  return isPunctuatorTokenWithValue44(token, "(");
}
function isClosingParenToken44(token) {
  return isPunctuatorTokenWithValue44(token, ")");
}
function isOpeningBracketToken44(token) {
  return isPunctuatorTokenWithValue44(token, "[");
}
function isClosingBracketToken44(token) {
  return isPunctuatorTokenWithValue44(token, "]");
}
function isOpeningBraceToken44(token) {
  return isPunctuatorTokenWithValue44(token, "{");
}
function isClosingBraceToken44(token) {
  return isPunctuatorTokenWithValue44(token, "}");
}
function isCommentToken44(token) {
  return ["Block", "Line", "Shebang"].includes(token.type);
}
negate44(isArrowToken44);
negate44(isCommaToken44);
negate44(isSemicolonToken44);
negate44(isColonToken44);
negate44(isOpeningParenToken44);
negate44(isClosingParenToken44);
negate44(isOpeningBracketToken44);
negate44(isClosingBracketToken44);
negate44(isOpeningBraceToken44);
negate44(isClosingBraceToken44);
negate44(isCommentToken44);
function getOpeningParenOfParams44(node, sourceCode) {
  return node.id ? sourceCode.getTokenAfter(node.id, isOpeningParenToken44) : sourceCode.getFirstToken(node, isOpeningParenToken44);
}
function getFunctionHeadLocation44(node, sourceCode) {
  const parent = node.parent;
  let start = null;
  let end = null;
  if (node.type === "ArrowFunctionExpression") {
    const arrowToken = sourceCode.getTokenBefore(node.body, isArrowToken44);
    start = arrowToken.loc.start;
    end = arrowToken.loc.end;
  } else if (parent.type === "Property" || parent.type === "MethodDefinition" || parent.type === "PropertyDefinition") {
    start = parent.loc.start;
    end = getOpeningParenOfParams44(node, sourceCode).loc.start;
  } else {
    start = node.loc.start;
    end = getOpeningParenOfParams44(node, sourceCode).loc.start;
  }
  return {
    start: { ...start },
    end: { ...end }
  };
}
var globalObject44 = typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {};
var builtinNames44 = Object.freeze(
  /* @__PURE__ */ new Set([
    "Array",
    "ArrayBuffer",
    "BigInt",
    "BigInt64Array",
    "BigUint64Array",
    "Boolean",
    "DataView",
    "Date",
    "decodeURI",
    "decodeURIComponent",
    "encodeURI",
    "encodeURIComponent",
    "escape",
    "Float32Array",
    "Float64Array",
    "Function",
    "Infinity",
    "Int16Array",
    "Int32Array",
    "Int8Array",
    "isFinite",
    "isNaN",
    "isPrototypeOf",
    "JSON",
    "Map",
    "Math",
    "NaN",
    "Number",
    "Object",
    "parseFloat",
    "parseInt",
    "Promise",
    "Proxy",
    "Reflect",
    "RegExp",
    "Set",
    "String",
    "Symbol",
    "Uint16Array",
    "Uint32Array",
    "Uint8Array",
    "Uint8ClampedArray",
    "undefined",
    "unescape",
    "WeakMap",
    "WeakSet"
  ])
);
var callAllowed44 = new Set(
  [
    Array.isArray,
    Array.of,
    Array.prototype.at,
    Array.prototype.concat,
    Array.prototype.entries,
    Array.prototype.every,
    Array.prototype.filter,
    Array.prototype.find,
    Array.prototype.findIndex,
    Array.prototype.flat,
    Array.prototype.includes,
    Array.prototype.indexOf,
    Array.prototype.join,
    Array.prototype.keys,
    Array.prototype.lastIndexOf,
    Array.prototype.slice,
    Array.prototype.some,
    Array.prototype.toString,
    Array.prototype.values,
    typeof BigInt === "function" ? BigInt : void 0,
    Boolean,
    Date,
    Date.parse,
    decodeURI,
    decodeURIComponent,
    encodeURI,
    encodeURIComponent,
    escape,
    isFinite,
    isNaN,
    isPrototypeOf,
    Map,
    Map.prototype.entries,
    Map.prototype.get,
    Map.prototype.has,
    Map.prototype.keys,
    Map.prototype.values,
    ...Object.getOwnPropertyNames(Math).filter((k232) => k232 !== "random").map((k232) => Math[k232]).filter((f232) => typeof f232 === "function"),
    Number,
    Number.isFinite,
    Number.isNaN,
    Number.parseFloat,
    Number.parseInt,
    Number.prototype.toExponential,
    Number.prototype.toFixed,
    Number.prototype.toPrecision,
    Number.prototype.toString,
    Object,
    Object.entries,
    Object.is,
    Object.isExtensible,
    Object.isFrozen,
    Object.isSealed,
    Object.keys,
    Object.values,
    parseFloat,
    parseInt,
    RegExp,
    Set,
    Set.prototype.entries,
    Set.prototype.has,
    Set.prototype.keys,
    Set.prototype.values,
    String,
    String.fromCharCode,
    String.fromCodePoint,
    String.raw,
    String.prototype.at,
    String.prototype.charAt,
    String.prototype.charCodeAt,
    String.prototype.codePointAt,
    String.prototype.concat,
    String.prototype.endsWith,
    String.prototype.includes,
    String.prototype.indexOf,
    String.prototype.lastIndexOf,
    String.prototype.normalize,
    String.prototype.padEnd,
    String.prototype.padStart,
    String.prototype.slice,
    String.prototype.startsWith,
    String.prototype.substr,
    String.prototype.substring,
    String.prototype.toLowerCase,
    String.prototype.toString,
    String.prototype.toUpperCase,
    String.prototype.trim,
    String.prototype.trimEnd,
    String.prototype.trimLeft,
    String.prototype.trimRight,
    String.prototype.trimStart,
    Symbol.for,
    Symbol.keyFor,
    unescape
  ].filter((f232) => typeof f232 === "function")
);
var callPassThrough44 = /* @__PURE__ */ new Set([
  Object.freeze,
  Object.preventExtensions,
  Object.seal
]);
var getterAllowed44 = [
  [Map, /* @__PURE__ */ new Set(["size"])],
  [
    RegExp,
    /* @__PURE__ */ new Set([
      "dotAll",
      "flags",
      "global",
      "hasIndices",
      "ignoreCase",
      "multiline",
      "source",
      "sticky",
      "unicode"
    ])
  ],
  [Set, /* @__PURE__ */ new Set(["size"])]
];
function getPropertyDescriptor44(object32, name22) {
  let x232 = object32;
  while ((typeof x232 === "object" || typeof x232 === "function") && x232 !== null) {
    const d232 = Object.getOwnPropertyDescriptor(x232, name22);
    if (d232) {
      return d232;
    }
    x232 = Object.getPrototypeOf(x232);
  }
  return null;
}
function isGetter44(object32, name22) {
  const d232 = getPropertyDescriptor44(object32, name22);
  return d232 != null && d232.get != null;
}
function getElementValues44(nodeList, initialScope) {
  const valueList = [];
  for (let i232 = 0; i232 < nodeList.length; ++i232) {
    const elementNode = nodeList[i232];
    if (elementNode == null) {
      valueList.length = i232 + 1;
    } else if (elementNode.type === "SpreadElement") {
      const argument = getStaticValueR44(elementNode.argument, initialScope);
      if (argument == null) {
        return null;
      }
      valueList.push(...argument.value);
    } else {
      const element = getStaticValueR44(elementNode, initialScope);
      if (element == null) {
        return null;
      }
      valueList.push(element.value);
    }
  }
  return valueList;
}
function isEffectivelyConst44(variable) {
  const refs = variable.references;
  const inits = refs.filter((r232) => r232.init).length;
  const reads = refs.filter((r232) => r232.isReadOnly()).length;
  if (inits === 1 && reads + inits === refs.length) {
    return true;
  }
  return false;
}
var operations44 = Object.freeze({
  ArrayExpression(node, initialScope) {
    const elements = getElementValues44(node.elements, initialScope);
    return elements != null ? { value: elements } : null;
  },
  AssignmentExpression(node, initialScope) {
    if (node.operator === "=") {
      return getStaticValueR44(node.right, initialScope);
    }
    return null;
  },
  //eslint-disable-next-line complexity
  BinaryExpression(node, initialScope) {
    if (node.operator === "in" || node.operator === "instanceof") {
      return null;
    }
    const left522 = getStaticValueR44(node.left, initialScope);
    const right522 = getStaticValueR44(node.right, initialScope);
    if (left522 != null && right522 != null) {
      switch (node.operator) {
        case "==":
          return { value: left522.value == right522.value };
        case "!=":
          return { value: left522.value != right522.value };
        case "===":
          return { value: left522.value === right522.value };
        case "!==":
          return { value: left522.value !== right522.value };
        case "<":
          return { value: left522.value < right522.value };
        case "<=":
          return { value: left522.value <= right522.value };
        case ">":
          return { value: left522.value > right522.value };
        case ">=":
          return { value: left522.value >= right522.value };
        case "<<":
          return { value: left522.value << right522.value };
        case ">>":
          return { value: left522.value >> right522.value };
        case ">>>":
          return { value: left522.value >>> right522.value };
        case "+":
          return { value: left522.value + right522.value };
        case "-":
          return { value: left522.value - right522.value };
        case "*":
          return { value: left522.value * right522.value };
        case "/":
          return { value: left522.value / right522.value };
        case "%":
          return { value: left522.value % right522.value };
        case "**":
          return { value: left522.value ** right522.value };
        case "|":
          return { value: left522.value | right522.value };
        case "^":
          return { value: left522.value ^ right522.value };
        case "&":
          return { value: left522.value & right522.value };
      }
    }
    return null;
  },
  CallExpression(node, initialScope) {
    const calleeNode = node.callee;
    const args = getElementValues44(node.arguments, initialScope);
    if (args != null) {
      if (calleeNode.type === "MemberExpression") {
        if (calleeNode.property.type === "PrivateIdentifier") {
          return null;
        }
        const object32 = getStaticValueR44(calleeNode.object, initialScope);
        if (object32 != null) {
          if (object32.value == null && (object32.optional || node.optional)) {
            return { value: void 0, optional: true };
          }
          const property = getStaticPropertyNameValue44(
            calleeNode,
            initialScope
          );
          if (property != null) {
            const receiver = object32.value;
            const methodName = property.value;
            if (callAllowed44.has(receiver[methodName])) {
              return { value: receiver[methodName](...args) };
            }
            if (callPassThrough44.has(receiver[methodName])) {
              return { value: args[0] };
            }
          }
        }
      } else {
        const callee = getStaticValueR44(calleeNode, initialScope);
        if (callee != null) {
          if (callee.value == null && node.optional) {
            return { value: void 0, optional: true };
          }
          const func = callee.value;
          if (callAllowed44.has(func)) {
            return { value: func(...args) };
          }
          if (callPassThrough44.has(func)) {
            return { value: args[0] };
          }
        }
      }
    }
    return null;
  },
  ConditionalExpression(node, initialScope) {
    const test = getStaticValueR44(node.test, initialScope);
    if (test != null) {
      return test.value ? getStaticValueR44(node.consequent, initialScope) : getStaticValueR44(node.alternate, initialScope);
    }
    return null;
  },
  ExpressionStatement(node, initialScope) {
    return getStaticValueR44(node.expression, initialScope);
  },
  Identifier(node, initialScope) {
    if (initialScope != null) {
      const variable = findVariable44(initialScope, node);
      if (variable != null && variable.defs.length === 0 && builtinNames44.has(variable.name) && variable.name in globalObject44) {
        return { value: globalObject44[variable.name] };
      }
      if (variable != null && variable.defs.length === 1) {
        const def = variable.defs[0];
        if (def.parent && def.type === "Variable" && (def.parent.kind === "const" || isEffectivelyConst44(variable)) && // TODO(mysticatea): don't support destructuring here.
        def.node.id.type === "Identifier") {
          return getStaticValueR44(def.node.init, initialScope);
        }
      }
    }
    return null;
  },
  Literal(node) {
    if ((node.regex != null || node.bigint != null) && node.value == null) {
      return null;
    }
    return { value: node.value };
  },
  LogicalExpression(node, initialScope) {
    const left522 = getStaticValueR44(node.left, initialScope);
    if (left522 != null) {
      if (node.operator === "||" && Boolean(left522.value) === true || node.operator === "&&" && Boolean(left522.value) === false || node.operator === "??" && left522.value != null) {
        return left522;
      }
      const right522 = getStaticValueR44(node.right, initialScope);
      if (right522 != null) {
        return right522;
      }
    }
    return null;
  },
  MemberExpression(node, initialScope) {
    if (node.property.type === "PrivateIdentifier") {
      return null;
    }
    const object32 = getStaticValueR44(node.object, initialScope);
    if (object32 != null) {
      if (object32.value == null && (object32.optional || node.optional)) {
        return { value: void 0, optional: true };
      }
      const property = getStaticPropertyNameValue44(node, initialScope);
      if (property != null) {
        if (!isGetter44(object32.value, property.value)) {
          return { value: object32.value[property.value] };
        }
        for (const [classFn, allowed] of getterAllowed44) {
          if (object32.value instanceof classFn && allowed.has(property.value)) {
            return { value: object32.value[property.value] };
          }
        }
      }
    }
    return null;
  },
  ChainExpression(node, initialScope) {
    const expression = getStaticValueR44(node.expression, initialScope);
    if (expression != null) {
      return { value: expression.value };
    }
    return null;
  },
  NewExpression(node, initialScope) {
    const callee = getStaticValueR44(node.callee, initialScope);
    const args = getElementValues44(node.arguments, initialScope);
    if (callee != null && args != null) {
      const Func = callee.value;
      if (callAllowed44.has(Func)) {
        return { value: new Func(...args) };
      }
    }
    return null;
  },
  ObjectExpression(node, initialScope) {
    const object32 = {};
    for (const propertyNode of node.properties) {
      if (propertyNode.type === "Property") {
        if (propertyNode.kind !== "init") {
          return null;
        }
        const key = getStaticPropertyNameValue44(
          propertyNode,
          initialScope
        );
        const value = getStaticValueR44(propertyNode.value, initialScope);
        if (key == null || value == null) {
          return null;
        }
        object32[key.value] = value.value;
      } else if (propertyNode.type === "SpreadElement" || propertyNode.type === "ExperimentalSpreadProperty") {
        const argument = getStaticValueR44(
          propertyNode.argument,
          initialScope
        );
        if (argument == null) {
          return null;
        }
        Object.assign(object32, argument.value);
      } else {
        return null;
      }
    }
    return { value: object32 };
  },
  SequenceExpression(node, initialScope) {
    const last222 = node.expressions[node.expressions.length - 1];
    return getStaticValueR44(last222, initialScope);
  },
  TaggedTemplateExpression(node, initialScope) {
    const tag = getStaticValueR44(node.tag, initialScope);
    const expressions = getElementValues44(
      node.quasi.expressions,
      initialScope
    );
    if (tag != null && expressions != null) {
      const func = tag.value;
      const strings = node.quasi.quasis.map((q) => q.value.cooked);
      strings.raw = node.quasi.quasis.map((q) => q.value.raw);
      if (func === String.raw) {
        return { value: func(strings, ...expressions) };
      }
    }
    return null;
  },
  TemplateLiteral(node, initialScope) {
    const expressions = getElementValues44(node.expressions, initialScope);
    if (expressions != null) {
      let value = node.quasis[0].value.cooked;
      for (let i232 = 0; i232 < expressions.length; ++i232) {
        value += expressions[i232];
        value += node.quasis[i232 + 1].value.cooked;
      }
      return { value };
    }
    return null;
  },
  UnaryExpression(node, initialScope) {
    if (node.operator === "delete") {
      return null;
    }
    if (node.operator === "void") {
      return { value: void 0 };
    }
    const arg = getStaticValueR44(node.argument, initialScope);
    if (arg != null) {
      switch (node.operator) {
        case "-":
          return { value: -arg.value };
        case "+":
          return { value: +arg.value };
        case "!":
          return { value: !arg.value };
        case "~":
          return { value: ~arg.value };
        case "typeof":
          return { value: typeof arg.value };
      }
    }
    return null;
  }
});
function getStaticValueR44(node, initialScope) {
  if (node != null && Object.hasOwnProperty.call(operations44, node.type)) {
    return operations44[node.type](node, initialScope);
  }
  return null;
}
function getStaticPropertyNameValue44(node, initialScope) {
  const nameNode = node.type === "Property" ? node.key : node.property;
  if (node.computed) {
    return getStaticValueR44(nameNode, initialScope);
  }
  if (nameNode.type === "Identifier") {
    return { value: nameNode.name };
  }
  if (nameNode.type === "Literal") {
    if (nameNode.bigint) {
      return { value: nameNode.bigint };
    }
    return { value: String(nameNode.value) };
  }
  return null;
}
function getStaticValue34(node, initialScope = null) {
  try {
    return getStaticValueR44(node, initialScope);
  } catch (_error) {
    return null;
  }
}
function getStringIfConstant44(node, initialScope = null) {
  if (node && node.type === "Literal" && node.value === null) {
    if (node.regex) {
      return `/${node.regex.pattern}/${node.regex.flags}`;
    }
    if (node.bigint) {
      return node.bigint;
    }
  }
  const evaluated = getStaticValue34(node, initialScope);
  return evaluated && String(evaluated.value);
}
function getPropertyName44(node, initialScope) {
  switch (node.type) {
    case "MemberExpression":
      if (node.computed) {
        return getStringIfConstant44(node.property, initialScope);
      }
      if (node.property.type === "PrivateIdentifier") {
        return null;
      }
      return node.property.name;
    case "Property":
    case "MethodDefinition":
    case "PropertyDefinition":
      if (node.computed) {
        return getStringIfConstant44(node.key, initialScope);
      }
      if (node.key.type === "Literal") {
        return String(node.key.value);
      }
      if (node.key.type === "PrivateIdentifier") {
        return null;
      }
      return node.key.name;
  }
  return null;
}
function getFunctionNameWithKind44(node, sourceCode) {
  const parent = node.parent;
  const tokens = [];
  const isObjectMethod = parent.type === "Property" && parent.value === node;
  const isClassMethod = parent.type === "MethodDefinition" && parent.value === node;
  const isClassFieldMethod = parent.type === "PropertyDefinition" && parent.value === node;
  if (isClassMethod || isClassFieldMethod) {
    if (parent.static) {
      tokens.push("static");
    }
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push("private");
    }
  }
  if (node.async) {
    tokens.push("async");
  }
  if (node.generator) {
    tokens.push("generator");
  }
  if (isObjectMethod || isClassMethod) {
    if (parent.kind === "constructor") {
      return "constructor";
    }
    if (parent.kind === "get") {
      tokens.push("getter");
    } else if (parent.kind === "set") {
      tokens.push("setter");
    } else {
      tokens.push("method");
    }
  } else if (isClassFieldMethod) {
    tokens.push("method");
  } else {
    if (node.type === "ArrowFunctionExpression") {
      tokens.push("arrow");
    }
    tokens.push("function");
  }
  if (isObjectMethod || isClassMethod || isClassFieldMethod) {
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push(`#${parent.key.name}`);
    } else {
      const name22 = getPropertyName44(parent);
      if (name22) {
        tokens.push(`'${name22}'`);
      } else if (sourceCode) {
        const keyText = sourceCode.getText(parent.key);
        if (!keyText.includes("\n")) {
          tokens.push(`[${keyText}]`);
        }
      }
    }
  } else if (node.id) {
    tokens.push(`'${node.id.name}'`);
  } else if (parent.type === "VariableDeclarator" && parent.id && parent.id.type === "Identifier") {
    tokens.push(`'${parent.id.name}'`);
  } else if ((parent.type === "AssignmentExpression" || parent.type === "AssignmentPattern") && parent.left && parent.left.type === "Identifier") {
    tokens.push(`'${parent.left.name}'`);
  } else if (parent.type === "ExportDefaultDeclaration" && parent.declaration === node) {
    tokens.push("'default'");
  }
  return tokens.join(" ");
}
var typeConversionBinaryOps44 = Object.freeze(
  /* @__PURE__ */ new Set([
    "==",
    "!=",
    "<",
    "<=",
    ">",
    ">=",
    "<<",
    ">>",
    ">>>",
    "+",
    "-",
    "*",
    "/",
    "%",
    "|",
    "^",
    "&",
    "in"
  ])
);
var typeConversionUnaryOps44 = Object.freeze(/* @__PURE__ */ new Set(["-", "+", "!", "~"]));
function isNode44(x232) {
  return x232 !== null && typeof x232 === "object" && typeof x232.type === "string";
}
var visitor44 = Object.freeze(
  Object.assign(/* @__PURE__ */ Object.create(null), {
    $visit(node, options, visitorKeys) {
      const { type } = node;
      if (typeof this[type] === "function") {
        return this[type](node, options, visitorKeys);
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    $visitChildren(node, options, visitorKeys) {
      const { type } = node;
      for (const key of visitorKeys[type] || getKeys44(node)) {
        const value = node[key];
        if (Array.isArray(value)) {
          for (const element of value) {
            if (isNode44(element) && this.$visit(element, options, visitorKeys)) {
              return true;
            }
          }
        } else if (isNode44(value) && this.$visit(value, options, visitorKeys)) {
          return true;
        }
      }
      return false;
    },
    ArrowFunctionExpression() {
      return false;
    },
    AssignmentExpression() {
      return true;
    },
    AwaitExpression() {
      return true;
    },
    BinaryExpression(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && typeConversionBinaryOps44.has(node.operator) && (node.left.type !== "Literal" || node.right.type !== "Literal")) {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    CallExpression() {
      return true;
    },
    FunctionExpression() {
      return false;
    },
    ImportExpression() {
      return true;
    },
    MemberExpression(node, options, visitorKeys) {
      if (options.considerGetters) {
        return true;
      }
      if (options.considerImplicitTypeConversion && node.computed && node.property.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    MethodDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    NewExpression() {
      return true;
    },
    Property(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    PropertyDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UnaryExpression(node, options, visitorKeys) {
      if (node.operator === "delete") {
        return true;
      }
      if (options.considerImplicitTypeConversion && typeConversionUnaryOps44.has(node.operator) && node.argument.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UpdateExpression() {
      return true;
    },
    YieldExpression() {
      return true;
    }
  })
);
function hasSideEffect44(node, sourceCode, { considerGetters = false, considerImplicitTypeConversion = false } = {}) {
  return visitor44.$visit(
    node,
    { considerGetters, considerImplicitTypeConversion },
    sourceCode.visitorKeys || visitor_keys_default44
  );
}
function getParentSyntaxParen44(node, sourceCode) {
  const parent = node.parent;
  switch (parent.type) {
    case "CallExpression":
    case "NewExpression":
      if (parent.arguments.length === 1 && parent.arguments[0] === node) {
        return sourceCode.getTokenAfter(
          parent.callee,
          isOpeningParenToken44
        );
      }
      return null;
    case "DoWhileStatement":
      if (parent.test === node) {
        return sourceCode.getTokenAfter(
          parent.body,
          isOpeningParenToken44
        );
      }
      return null;
    case "IfStatement":
    case "WhileStatement":
      if (parent.test === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "ImportExpression":
      if (parent.source === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "SwitchStatement":
      if (parent.discriminant === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "WithStatement":
      if (parent.object === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    default:
      return null;
  }
}
function isParenthesized44(timesOrNode, nodeOrSourceCode, optionalSourceCode) {
  let times, node, sourceCode, maybeLeftParen, maybeRightParen;
  if (typeof timesOrNode === "number") {
    times = timesOrNode | 0;
    node = nodeOrSourceCode;
    sourceCode = optionalSourceCode;
    if (!(times >= 1)) {
      throw new TypeError("'times' should be a positive integer.");
    }
  } else {
    times = 1;
    node = timesOrNode;
    sourceCode = nodeOrSourceCode;
  }
  if (node == null || // `Program` can't be parenthesized
  node.parent == null || // `CatchClause.param` can't be parenthesized, example `try {} catch (error) {}`
  node.parent.type === "CatchClause" && node.parent.param === node) {
    return false;
  }
  maybeLeftParen = maybeRightParen = node;
  do {
    maybeLeftParen = sourceCode.getTokenBefore(maybeLeftParen);
    maybeRightParen = sourceCode.getTokenAfter(maybeRightParen);
  } while (maybeLeftParen != null && maybeRightParen != null && isOpeningParenToken44(maybeLeftParen) && isClosingParenToken44(maybeRightParen) && // Avoid false positive such as `if (a) {}`
  maybeLeftParen !== getParentSyntaxParen44(node, sourceCode) && --times > 0);
  return times === 0;
}
Function.call.bind(Object.hasOwnProperty);
var __defProp244 = Object.defineProperty;
var __export244 = (target, all3232) => {
  for (var name22 in all3232)
    __defProp244(target, name22, { get: all3232[name22], enumerable: true });
};
var NodeType44 = types.AST_NODE_TYPES;
var is44 = utils.ASTUtils.isNodeOfType;
var isOneOf44 = utils.ASTUtils.isNodeOfTypes;
isOneOf44([
  NodeType44.ArrowFunctionExpression,
  NodeType44.FunctionDeclaration,
  NodeType44.FunctionExpression
]);
isOneOf44([
  NodeType44.ArrowFunctionExpression,
  NodeType44.FunctionDeclaration,
  NodeType44.FunctionExpression,
  NodeType44.TSCallSignatureDeclaration,
  NodeType44.TSConstructSignatureDeclaration,
  NodeType44.TSDeclareFunction,
  NodeType44.TSEmptyBodyFunctionExpression,
  NodeType44.TSFunctionType,
  NodeType44.TSMethodSignature
]);
isOneOf44([NodeType44.ClassDeclaration, NodeType44.ClassExpression]);
isOneOf44([
  NodeType44.DoWhileStatement,
  NodeType44.ForInStatement,
  NodeType44.ForOfStatement,
  NodeType44.ForStatement,
  NodeType44.WhileStatement
]);
isOneOf44([NodeType44.TSArrayType, NodeType44.TSTupleType]);
isOneOf44([
  NodeType44.PropertyDefinition,
  NodeType44.TSIndexSignature,
  NodeType44.TSParameterProperty,
  NodeType44.TSPropertySignature
]);
is44(NodeType44.JSXElement);
is44(NodeType44.JSXFragment);
isOneOf44([
  NodeType44.JSXAttribute,
  NodeType44.JSXSpreadChild,
  NodeType44.JSXClosingElement,
  NodeType44.JSXClosingFragment,
  NodeType44.JSXElement,
  NodeType44.JSXEmptyExpression,
  NodeType44.JSXExpressionContainer,
  NodeType44.JSXFragment,
  NodeType44.JSXIdentifier,
  NodeType44.JSXMemberExpression,
  NodeType44.JSXNamespacedName,
  NodeType44.JSXOpeningElement,
  NodeType44.JSXOpeningFragment,
  NodeType44.JSXSpreadAttribute,
  NodeType44.JSXSpreadChild,
  NodeType44.JSXText
]);
isOneOf44([
  NodeType44.JSXIdentifier,
  NodeType44.JSXMemberExpression,
  NodeType44.JSXNamespacedName
]);
isOneOf44([
  NodeType44.ArrayPattern,
  NodeType44.AssignmentPattern,
  NodeType44.ObjectPattern,
  NodeType44.RestElement
]);
isOneOf44([
  NodeType44.TSInterfaceDeclaration,
  NodeType44.TSTypeAliasDeclaration
]);
isOneOf44([
  NodeType44.ArrayExpression,
  NodeType44.ArrayPattern,
  NodeType44.ArrowFunctionExpression,
  NodeType44.CallExpression,
  NodeType44.ClassExpression,
  NodeType44.FunctionExpression,
  NodeType44.Identifier,
  NodeType44.JSXElement,
  NodeType44.JSXFragment,
  NodeType44.Literal,
  NodeType44.TemplateLiteral,
  NodeType44.MemberExpression,
  NodeType44.MetaProperty,
  NodeType44.ObjectExpression,
  NodeType44.ObjectPattern,
  NodeType44.SequenceExpression,
  NodeType44.Super,
  NodeType44.TaggedTemplateExpression,
  NodeType44.ThisExpression
]);
isOneOf44([
  NodeType44.ArrayExpression,
  NodeType44.ArrayPattern,
  NodeType44.ArrowFunctionExpression,
  NodeType44.CallExpression,
  NodeType44.ClassExpression,
  NodeType44.FunctionExpression,
  NodeType44.Identifier,
  NodeType44.JSXElement,
  NodeType44.JSXFragment,
  NodeType44.Literal,
  NodeType44.TemplateLiteral,
  NodeType44.MemberExpression,
  NodeType44.MetaProperty,
  NodeType44.ObjectExpression,
  NodeType44.ObjectPattern,
  NodeType44.SequenceExpression,
  NodeType44.Super,
  NodeType44.TaggedTemplateExpression,
  NodeType44.ThisExpression,
  NodeType44.TSAsExpression,
  NodeType44.TSNonNullExpression,
  NodeType44.TSTypeAssertion
]);
var Function_exports64 = {};
__export244(Function_exports64, {
  SK: () => SK64,
  absurd: () => absurd64,
  apply: () => apply64,
  compose: () => compose94,
  constFalse: () => constFalse64,
  constNull: () => constNull64,
  constTrue: () => constTrue64,
  constUndefined: () => constUndefined64,
  constVoid: () => constVoid64,
  constant: () => constant64,
  dual: () => dual64,
  flip: () => flip64,
  flow: () => flow64,
  hole: () => hole64,
  identity: () => identity64,
  isFunction: () => isFunction244,
  pipe: () => pipe64,
  satisfies: () => satisfies64,
  tupled: () => tupled64,
  unsafeCoerce: () => unsafeCoerce64,
  untupled: () => untupled64
});
var isFunction244 = (input) => typeof input === "function";
var dual64 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a232, b232) {
        if (arguments.length >= 2) {
          return body(a232, b232);
        }
        return function(self2) {
          return body(self2, a232);
        };
      };
    case 3:
      return function(a232, b232, c232) {
        if (arguments.length >= 3) {
          return body(a232, b232, c232);
        }
        return function(self2) {
          return body(self2, a232, b232);
        };
      };
    case 4:
      return function(a232, b232, c232, d232) {
        if (arguments.length >= 4) {
          return body(a232, b232, c232, d232);
        }
        return function(self2) {
          return body(self2, a232, b232, c232);
        };
      };
    case 5:
      return function(a232, b232, c232, d232, e232) {
        if (arguments.length >= 5) {
          return body(a232, b232, c232, d232, e232);
        }
        return function(self2) {
          return body(self2, a232, b232, c232, d232);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply64 = (a232) => (self2) => self2(a232);
var identity64 = (a232) => a232;
var satisfies64 = () => (b232) => b232;
var unsafeCoerce64 = identity64;
var constant64 = (value) => () => value;
var constTrue64 = /* @__PURE__ */ constant64(true);
var constFalse64 = /* @__PURE__ */ constant64(false);
var constNull64 = /* @__PURE__ */ constant64(null);
var constUndefined64 = /* @__PURE__ */ constant64(void 0);
var constVoid64 = constUndefined64;
var flip64 = (f232) => (...b232) => (...a232) => f232(...a232)(...b232);
var compose94 = /* @__PURE__ */ dual64(2, (ab, bc) => (a232) => bc(ab(a232)));
var absurd64 = (_232) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled64 = (f232) => (a232) => f232(...a232);
var untupled64 = (f232) => (...a232) => f232(a232);
function pipe64(a232, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a232;
    case 2:
      return ab(a232);
    case 3:
      return bc(ab(a232));
    case 4:
      return cd(bc(ab(a232)));
    case 5:
      return de(cd(bc(ab(a232))));
    case 6:
      return ef(de(cd(bc(ab(a232)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a232))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a232)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a232))))))));
    default: {
      let ret = arguments[0];
      for (let i232 = 1; i232 < arguments.length; i232++) {
        ret = arguments[i232](ret);
      }
      return ret;
    }
  }
}
function flow64(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole64 = /* @__PURE__ */ unsafeCoerce64(absurd64);
var SK64 = (_232, b232) => b232;
var make174 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_104 = (map622) => dual64(3, (self2, name22, f232) => map622(self2, (a232) => Object.assign({}, a232, {
  [name22]: f232(a232)
})));
var bindTo104 = (map622) => dual64(2, (self2, name22) => map622(self2, (a232) => ({
  [name22]: a232
})));
var bind104 = (map622, flatMap4222) => dual64(3, (self2, name22, f232) => flatMap4222(self2, (a232) => map622(f232(a232), (b232) => Object.assign({}, a232, {
  [name22]: b232
}))));
var moduleVersion64 = "3.2.8";
var getCurrentVersion64 = () => moduleVersion64;
var globalStoreId64 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion64()}`);
if (!(globalStoreId64 in globalThis)) {
  globalThis[globalStoreId64] = /* @__PURE__ */ new Map();
}
var globalStore64 = globalThis[globalStoreId64];
var globalValue64 = (id, compute) => {
  if (!globalStore64.has(id)) {
    globalStore64.set(id, compute());
  }
  return globalStore64.get(id);
};
var Predicate_exports44 = {};
__export244(Predicate_exports44, {
  all: () => all94,
  and: () => and64,
  compose: () => compose244,
  eqv: () => eqv64,
  every: () => every74,
  hasProperty: () => hasProperty64,
  implies: () => implies64,
  isBigInt: () => isBigInt64,
  isBoolean: () => isBoolean64,
  isDate: () => isDate64,
  isError: () => isError64,
  isFunction: () => isFunction334,
  isIterable: () => isIterable64,
  isMap: () => isMap64,
  isNever: () => isNever64,
  isNotNull: () => isNotNull64,
  isNotNullable: () => isNotNullable64,
  isNotUndefined: () => isNotUndefined64,
  isNull: () => isNull64,
  isNullable: () => isNullable64,
  isNumber: () => isNumber64,
  isObject: () => isObject64,
  isPromise: () => isPromise64,
  isPromiseLike: () => isPromiseLike64,
  isReadonlyRecord: () => isReadonlyRecord64,
  isRecord: () => isRecord64,
  isSet: () => isSet64,
  isString: () => isString64,
  isSymbol: () => isSymbol64,
  isTagged: () => isTagged64,
  isTruthy: () => isTruthy64,
  isUint8Array: () => isUint8Array64,
  isUndefined: () => isUndefined64,
  isUnknown: () => isUnknown64,
  mapInput: () => mapInput74,
  nand: () => nand64,
  nor: () => nor64,
  not: () => not64,
  or: () => or64,
  product: () => product94,
  productMany: () => productMany94,
  some: () => some134,
  struct: () => struct84,
  tuple: () => tuple74,
  xor: () => xor64
});
var mapInput74 = /* @__PURE__ */ dual64(2, (self2, f232) => (b232) => self2(f232(b232)));
var isTruthy64 = (input) => !!input;
var isSet64 = (input) => input instanceof Set;
var isMap64 = (input) => input instanceof Map;
var isString64 = (input) => typeof input === "string";
var isNumber64 = (input) => typeof input === "number";
var isBoolean64 = (input) => typeof input === "boolean";
var isBigInt64 = (input) => typeof input === "bigint";
var isSymbol64 = (input) => typeof input === "symbol";
var isFunction334 = isFunction244;
var isUndefined64 = (input) => input === void 0;
var isNotUndefined64 = (input) => input !== void 0;
var isNull64 = (input) => input === null;
var isNotNull64 = (input) => input !== null;
var isNever64 = (_232) => false;
var isUnknown64 = (_232) => true;
var isRecordOrArray64 = (input) => typeof input === "object" && input !== null;
var isObject64 = (input) => isRecordOrArray64(input) || isFunction334(input);
var hasProperty64 = /* @__PURE__ */ dual64(2, (self2, property) => isObject64(self2) && property in self2);
var isTagged64 = /* @__PURE__ */ dual64(2, (self2, tag) => hasProperty64(self2, "_tag") && self2["_tag"] === tag);
var isNullable64 = (input) => input === null || input === void 0;
var isNotNullable64 = (input) => input !== null && input !== void 0;
var isError64 = (input) => input instanceof Error;
var isUint8Array64 = (input) => input instanceof Uint8Array;
var isDate64 = (input) => input instanceof Date;
var isIterable64 = (input) => hasProperty64(input, Symbol.iterator);
var isRecord64 = (input) => isRecordOrArray64(input) && !Array.isArray(input);
var isReadonlyRecord64 = isRecord64;
var isPromise64 = (input) => hasProperty64(input, "then") && "catch" in input && isFunction334(input.then) && isFunction334(input.catch);
var isPromiseLike64 = (input) => hasProperty64(input, "then") && isFunction334(input.then);
var compose244 = /* @__PURE__ */ dual64(2, (ab, bc) => (a232) => ab(a232) && bc(a232));
var product94 = (self2, that) => ([a232, b232]) => self2(a232) && that(b232);
var all94 = (collection) => {
  return (as2322) => {
    let collectionIndex = 0;
    for (const p232 of collection) {
      if (collectionIndex >= as2322.length) {
        break;
      }
      if (p232(as2322[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany94 = (self2, collection) => {
  const rest = all94(collection);
  return ([head222, ...tail222]) => self2(head222) === false ? false : rest(tail222);
};
var tuple74 = (...elements) => all94(elements);
var struct84 = (fields) => {
  const keys2232 = Object.keys(fields);
  return (a232) => {
    for (const key of keys2232) {
      if (!fields[key](a232[key])) {
        return false;
      }
    }
    return true;
  };
};
var not64 = (self2) => (a232) => !self2(a232);
var or64 = /* @__PURE__ */ dual64(2, (self2, that) => (a232) => self2(a232) || that(a232));
var and64 = /* @__PURE__ */ dual64(2, (self2, that) => (a232) => self2(a232) && that(a232));
var xor64 = /* @__PURE__ */ dual64(2, (self2, that) => (a232) => self2(a232) !== that(a232));
var eqv64 = /* @__PURE__ */ dual64(2, (self2, that) => (a232) => self2(a232) === that(a232));
var implies64 = /* @__PURE__ */ dual64(2, (self2, that) => (a232) => self2(a232) ? that(a232) : true);
var nor64 = /* @__PURE__ */ dual64(2, (self2, that) => (a232) => !(self2(a232) || that(a232)));
var nand64 = /* @__PURE__ */ dual64(2, (self2, that) => (a232) => !(self2(a232) && that(a232)));
var every74 = (collection) => (a232) => {
  for (const p232 of collection) {
    if (!p232(a232)) {
      return false;
    }
  }
  return true;
};
var some134 = (collection) => (a232) => {
  for (const p232 of collection) {
    if (p232(a232)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage64 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId64 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind64 = (u232) => isObject64(u232) && GenKindTypeId64 in u232;
var GenKindImpl64 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity64;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId64] = GenKindTypeId64;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen74(this);
  }
};
var SingleShotGen74 = class _SingleShotGen84 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a232) {
    return this.called ? {
      value: a232,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a232) {
    return {
      value: a232,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e232) {
    throw e232;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen84(this.self);
  }
};
var adapter94 = () => function() {
  let x232 = arguments[0];
  for (let i232 = 1; i232 < arguments.length; i232++) {
    x232 = arguments[i232](x232);
  }
  return new GenKindImpl64(x232);
};
var defaultIncHi64 = 335903614;
var defaultIncLo64 = 4150755663;
var MUL_HI64 = 1481765933 >>> 0;
var MUL_LO64 = 1284865837 >>> 0;
var BIT_5364 = 9007199254740992;
var BIT_2764 = 134217728;
var PCGRandom64 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable64(seedLo) && isNullable64(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable64(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable64(incLo) && isNullable64(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo64;
      incHi = this._state ? this._state[2] : defaultIncHi64;
    } else if (isNullable64(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add6464(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max322) {
    if (!max322) {
      return this._next();
    }
    max322 = max322 >>> 0;
    if ((max322 & max322 - 1) === 0) {
      return this._next() & max322 - 1;
    }
    let num = 0;
    const skew = (-max322 >>> 0) % max322 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max322;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_2764 + lo) / BIT_5364;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul6464(this._state, oldHi, oldLo, MUL_HI64, MUL_LO64);
    add6464(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul6464(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add6464(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId64 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap64 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId64]() {
    return this.#value;
  }
};
function yieldWrapGet64(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId64 in self2) {
    return self2[YieldWrapTypeId64]();
  }
  throw new Error(getBugErrorMessage64("yieldWrapGet"));
}
var structuralRegionState64 = /* @__PURE__ */ globalValue64("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache64 = /* @__PURE__ */ globalValue64(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr64 = /* @__PURE__ */ globalValue64(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom64());
var symbol94 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash64 = (self2) => {
  if (structuralRegionState64.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number74(self2);
    case "bigint":
      return string74(self2.toString(10));
    case "boolean":
      return string74(String(self2));
    case "symbol":
      return string74(String(self2));
    case "string":
      return string74(self2);
    case "undefined":
      return string74("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string74("null");
      } else if (self2 instanceof Date) {
        return hash64(self2.toISOString());
      } else if (isHash64(self2)) {
        return self2[symbol94]();
      } else {
        return random64(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random64 = (self2) => {
  if (!randomHashCache64.has(self2)) {
    randomHashCache64.set(self2, number74(pcgr64.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache64.get(self2);
};
var combine74 = (b232) => (self2) => self2 * 53 ^ b232;
var optimize64 = (n232) => n232 & 3221225471 | n232 >>> 1 & 1073741824;
var isHash64 = (u232) => hasProperty64(u232, symbol94);
var number74 = (n232) => {
  if (n232 !== n232 || n232 === Infinity) {
    return 0;
  }
  let h232 = n232 | 0;
  if (h232 !== n232) {
    h232 ^= n232 * 4294967295;
  }
  while (n232 > 4294967295) {
    h232 ^= n232 /= 4294967295;
  }
  return optimize64(n232);
};
var string74 = (str) => {
  let h232 = 5381, i232 = str.length;
  while (i232) {
    h232 = h232 * 33 ^ str.charCodeAt(--i232);
  }
  return optimize64(h232);
};
var structureKeys34 = (o232, keys2232) => {
  let h232 = 12289;
  for (let i232 = 0; i232 < keys2232.length; i232++) {
    h232 ^= pipe64(string74(keys2232[i232]), combine74(hash64(o232[keys2232[i232]])));
  }
  return optimize64(h232);
};
var structure34 = (o232) => structureKeys34(o232, Object.keys(o232));
var array84 = (arr) => {
  let h232 = 6151;
  for (let i232 = 0; i232 < arr.length; i232++) {
    h232 = pipe64(h232, combine74(hash64(arr[i232])));
  }
  return optimize64(h232);
};
var cached64 = function() {
  if (arguments.length === 1) {
    const self22 = arguments[0];
    return function(hash3222) {
      Object.defineProperty(self22, symbol94, {
        value() {
          return hash3222;
        },
        enumerable: false
      });
      return hash3222;
    };
  }
  const self2 = arguments[0];
  const hash2322 = arguments[1];
  Object.defineProperty(self2, symbol94, {
    value() {
      return hash2322;
    },
    enumerable: false
  });
  return hash2322;
};
var symbol244 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals64() {
  if (arguments.length === 1) {
    return (self2) => compareBoth64(self2, arguments[0]);
  }
  return compareBoth64(arguments[0], arguments[1]);
}
function compareBoth64(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual64(self2) && isEqual64(that)) {
        if (hash64(self2) === hash64(that) && self2[symbol244](that)) {
          return true;
        } else {
          return structuralRegionState64.enabled && structuralRegionState64.tester ? structuralRegionState64.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState64.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v232, i232) => compareBoth64(v232, that[i232]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth64(self2[key], that[key]))) {
              return structuralRegionState64.tester ? structuralRegionState64.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState64.tester ? structuralRegionState64.tester(self2, that) : false;
    }
  }
  return structuralRegionState64.enabled && structuralRegionState64.tester ? structuralRegionState64.tester(self2, that) : false;
}
var isEqual64 = (u232) => hasProperty64(u232, symbol244);
var equivalence64 = () => equals64;
var NodeInspectSymbol64 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON64 = (x232) => {
  if (hasProperty64(x232, "toJSON") && isFunction334(x232["toJSON"]) && x232["toJSON"].length === 0) {
    return x232.toJSON();
  } else if (Array.isArray(x232)) {
    return x232.map(toJSON64);
  }
  return x232;
};
var format64 = (x232) => JSON.stringify(x232, null, 2);
var pipeArguments64 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i232 = 0, len = args.length; i232 < len; i232++) {
        ret = args[i232](ret);
      }
      return ret;
    }
  }
};
var OP_COMMIT34 = "Commit";
var OP_FAILURE44 = "Failure";
var OP_WITH_RUNTIME44 = "WithRuntime";
var EffectTypeId74 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId64 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId64 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId64 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance64 = {
  /* c8 ignore next */
  _R: (_232) => _232,
  /* c8 ignore next */
  _E: (_232) => _232,
  /* c8 ignore next */
  _A: (_232) => _232,
  _V: /* @__PURE__ */ getCurrentVersion64()
};
var sinkVariance64 = {
  /* c8 ignore next */
  _A: (_232) => _232,
  /* c8 ignore next */
  _In: (_232) => _232,
  /* c8 ignore next */
  _L: (_232) => _232,
  /* c8 ignore next */
  _E: (_232) => _232,
  /* c8 ignore next */
  _R: (_232) => _232
};
var channelVariance64 = {
  /* c8 ignore next */
  _Env: (_232) => _232,
  /* c8 ignore next */
  _InErr: (_232) => _232,
  /* c8 ignore next */
  _InElem: (_232) => _232,
  /* c8 ignore next */
  _InDone: (_232) => _232,
  /* c8 ignore next */
  _OutErr: (_232) => _232,
  /* c8 ignore next */
  _OutElem: (_232) => _232,
  /* c8 ignore next */
  _OutDone: (_232) => _232
};
var EffectPrototype64 = {
  [EffectTypeId74]: effectVariance64,
  [StreamTypeId64]: effectVariance64,
  [SinkTypeId64]: sinkVariance64,
  [ChannelTypeId64]: channelVariance64,
  [symbol244](that) {
    return this === that;
  },
  [symbol94]() {
    return cached64(this, random64(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen74(new YieldWrap64(this));
  },
  pipe() {
    return pipeArguments64(this, arguments);
  }
};
var StructuralPrototype34 = {
  [symbol94]() {
    return cached64(this, structure34(this));
  },
  [symbol244](that) {
    const selfKeys = Object.keys(this);
    const thatKeys = Object.keys(that);
    if (selfKeys.length !== thatKeys.length) {
      return false;
    }
    for (const key of selfKeys) {
      if (!(key in that && equals64(this[key], that[key]))) {
        return false;
      }
    }
    return true;
  }
};
var CommitPrototype34 = {
  ...EffectPrototype64,
  _op: OP_COMMIT34
};
var StructuralCommitPrototype34 = {
  ...CommitPrototype34,
  ...StructuralPrototype34
};
var TypeId164 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto94 = {
  ...EffectPrototype64,
  [TypeId164]: {
    _A: (_232) => _232
  },
  [NodeInspectSymbol64]() {
    return this.toJSON();
  },
  toString() {
    return format64(this.toJSON());
  }
};
var SomeProto64 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto94), {
  _tag: "Some",
  _op: "Some",
  [symbol244](that) {
    return isOption94(that) && isSome94(that) && equals64(this.value, that.value);
  },
  [symbol94]() {
    return cached64(this, combine74(hash64(this._tag))(hash64(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON64(this.value)
    };
  }
});
var NoneHash64 = /* @__PURE__ */ hash64("None");
var NoneProto64 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto94), {
  _tag: "None",
  _op: "None",
  [symbol244](that) {
    return isOption94(that) && isNone94(that);
  },
  [symbol94]() {
    return NoneHash64;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption94 = (input) => hasProperty64(input, TypeId164);
var isNone94 = (fa) => fa._tag === "None";
var isSome94 = (fa) => fa._tag === "Some";
var none94 = /* @__PURE__ */ Object.create(NoneProto64);
var some244 = (value) => {
  const a232 = Object.create(SomeProto64);
  a232.value = value;
  return a232;
};
var TypeId244 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto244 = {
  ...EffectPrototype64,
  [TypeId244]: {
    _R: (_232) => _232
  },
  [NodeInspectSymbol64]() {
    return this.toJSON();
  },
  toString() {
    return format64(this.toJSON());
  }
};
var RightProto64 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto244), {
  _tag: "Right",
  _op: "Right",
  [symbol244](that) {
    return isEither64(that) && isRight74(that) && equals64(this.right, that.right);
  },
  [symbol94]() {
    return combine74(hash64(this._tag))(hash64(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON64(this.right)
    };
  }
});
var LeftProto64 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto244), {
  _tag: "Left",
  _op: "Left",
  [symbol244](that) {
    return isEither64(that) && isLeft74(that) && equals64(this.left, that.left);
  },
  [symbol94]() {
    return combine74(hash64(this._tag))(hash64(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON64(this.left)
    };
  }
});
var isEither64 = (input) => hasProperty64(input, TypeId244);
var isLeft74 = (ma) => ma._tag === "Left";
var isRight74 = (ma) => ma._tag === "Right";
var left74 = (left3232) => {
  const a232 = Object.create(LeftProto64);
  a232.left = left3232;
  return a232;
};
var right74 = (right3232) => {
  const a232 = Object.create(RightProto64);
  a232.right = right3232;
  return a232;
};
var getLeft94 = (self2) => isRight74(self2) ? none94 : some244(self2.left);
var getRight94 = (self2) => isLeft74(self2) ? none94 : some244(self2.right);
var right244 = right74;
var left244 = left74;
var Option_exports64 = {};
__export244(Option_exports64, {
  Do: () => Do74,
  TypeId: () => TypeId344,
  all: () => all244,
  andThen: () => andThen64,
  ap: () => ap64,
  as: () => as64,
  asVoid: () => asVoid64,
  bind: () => bind244,
  bindTo: () => bindTo244,
  composeK: () => composeK64,
  contains: () => contains74,
  containsWith: () => containsWith74,
  exists: () => exists64,
  filter: () => filter74,
  filterMap: () => filterMap74,
  firstSomeOf: () => firstSomeOf64,
  flatMap: () => flatMap74,
  flatMapNullable: () => flatMapNullable74,
  flatten: () => flatten74,
  fromIterable: () => fromIterable94,
  fromNullable: () => fromNullable74,
  gen: () => gen64,
  getEquivalence: () => getEquivalence84,
  getLeft: () => getLeft244,
  getOrElse: () => getOrElse64,
  getOrNull: () => getOrNull64,
  getOrThrow: () => getOrThrow64,
  getOrThrowWith: () => getOrThrowWith64,
  getOrUndefined: () => getOrUndefined64,
  getOrder: () => getOrder74,
  getRight: () => getRight244,
  isNone: () => isNone244,
  isOption: () => isOption244,
  isSome: () => isSome244,
  let: () => let_244,
  lift2: () => lift264,
  liftNullable: () => liftNullable74,
  liftPredicate: () => liftPredicate74,
  liftThrowable: () => liftThrowable64,
  map: () => map74,
  match: () => match244,
  none: () => none244,
  orElse: () => orElse64,
  orElseEither: () => orElseEither64,
  orElseSome: () => orElseSome64,
  partitionMap: () => partitionMap74,
  product: () => product244,
  productMany: () => productMany244,
  reduceCompact: () => reduceCompact64,
  some: () => some344,
  tap: () => tap64,
  toArray: () => toArray64,
  toRefinement: () => toRefinement64,
  void: () => void_64,
  zipLeft: () => zipLeft64,
  zipRight: () => zipRight64,
  zipWith: () => zipWith74
});
var make244 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId344 = /* @__PURE__ */ Symbol.for("effect/Option");
var none244 = () => none94;
var some344 = some244;
var isOption244 = isOption94;
var isNone244 = isNone94;
var isSome244 = isSome94;
var match244 = /* @__PURE__ */ dual64(2, (self2, {
  onNone,
  onSome
}) => isNone244(self2) ? onNone() : onSome(self2.value));
var toRefinement64 = (f232) => (a232) => isSome244(f232(a232));
var fromIterable94 = (collection) => {
  for (const a232 of collection) {
    return some344(a232);
  }
  return none244();
};
var getRight244 = getRight94;
var getLeft244 = getLeft94;
var getOrElse64 = /* @__PURE__ */ dual64(2, (self2, onNone) => isNone244(self2) ? onNone() : self2.value);
var orElse64 = /* @__PURE__ */ dual64(2, (self2, that) => isNone244(self2) ? that() : self2);
var orElseSome64 = /* @__PURE__ */ dual64(2, (self2, onNone) => isNone244(self2) ? some344(onNone()) : self2);
var orElseEither64 = /* @__PURE__ */ dual64(2, (self2, that) => isNone244(self2) ? map74(that(), right74) : map74(self2, left74));
var firstSomeOf64 = (collection) => {
  let out = none244();
  for (out of collection) {
    if (isSome244(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable74 = (nullableValue) => nullableValue == null ? none244() : some344(nullableValue);
var liftNullable74 = (f232) => (...a232) => fromNullable74(f232(...a232));
var getOrNull64 = /* @__PURE__ */ getOrElse64(constNull64);
var getOrUndefined64 = /* @__PURE__ */ getOrElse64(constUndefined64);
var liftThrowable64 = (f232) => (...a232) => {
  try {
    return some344(f232(...a232));
  } catch (e232) {
    return none244();
  }
};
var getOrThrowWith64 = /* @__PURE__ */ dual64(2, (self2, onNone) => {
  if (isSome244(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow64 = /* @__PURE__ */ getOrThrowWith64(() => new Error("getOrThrow called on a None"));
var map74 = /* @__PURE__ */ dual64(2, (self2, f232) => isNone244(self2) ? none244() : some344(f232(self2.value)));
var as64 = /* @__PURE__ */ dual64(2, (self2, b232) => map74(self2, () => b232));
var asVoid64 = /* @__PURE__ */ as64(void 0);
var void_64 = /* @__PURE__ */ some344(void 0);
var flatMap74 = /* @__PURE__ */ dual64(2, (self2, f232) => isNone244(self2) ? none244() : f232(self2.value));
var andThen64 = /* @__PURE__ */ dual64(2, (self2, f232) => flatMap74(self2, (a232) => {
  const b232 = isFunction244(f232) ? f232(a232) : f232;
  return isOption244(b232) ? b232 : some344(b232);
}));
var flatMapNullable74 = /* @__PURE__ */ dual64(2, (self2, f232) => isNone244(self2) ? none244() : fromNullable74(f232(self2.value)));
var flatten74 = /* @__PURE__ */ flatMap74(identity64);
var zipRight64 = /* @__PURE__ */ dual64(2, (self2, that) => flatMap74(self2, () => that));
var composeK64 = /* @__PURE__ */ dual64(2, (afb, bfc) => (a232) => flatMap74(afb(a232), bfc));
var zipLeft64 = /* @__PURE__ */ dual64(2, (self2, that) => tap64(self2, () => that));
var tap64 = /* @__PURE__ */ dual64(2, (self2, f232) => flatMap74(self2, (a232) => map74(f232(a232), () => a232)));
var product244 = (self2, that) => isSome244(self2) && isSome244(that) ? some344([self2.value, that.value]) : none244();
var productMany244 = (self2, collection) => {
  if (isNone244(self2)) {
    return none244();
  }
  const out = [self2.value];
  for (const o232 of collection) {
    if (isNone244(o232)) {
      return none244();
    }
    out.push(o232.value);
  }
  return some344(out);
};
var all244 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o232 of input) {
      if (isNone244(o232)) {
        return none244();
      }
      out2.push(o232.value);
    }
    return some344(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o232 = input[key];
    if (isNone244(o232)) {
      return none244();
    }
    out[key] = o232.value;
  }
  return some344(out);
};
var zipWith74 = /* @__PURE__ */ dual64(3, (self2, that, f232) => map74(product244(self2, that), ([a232, b232]) => f232(a232, b232)));
var ap64 = /* @__PURE__ */ dual64(2, (self2, that) => zipWith74(self2, that, (f232, a232) => f232(a232)));
var reduceCompact64 = /* @__PURE__ */ dual64(3, (self2, b232, f232) => {
  let out = b232;
  for (const oa of self2) {
    if (isSome244(oa)) {
      out = f232(out, oa.value);
    }
  }
  return out;
});
var toArray64 = (self2) => isNone244(self2) ? [] : [self2.value];
var partitionMap74 = /* @__PURE__ */ dual64(2, (self2, f232) => {
  if (isNone244(self2)) {
    return [none244(), none244()];
  }
  const e232 = f232(self2.value);
  return isLeft74(e232) ? [some344(e232.left), none244()] : [none244(), some344(e232.right)];
});
var filterMap74 = /* @__PURE__ */ dual64(2, (self2, f232) => isNone244(self2) ? none244() : f232(self2.value));
var filter74 = /* @__PURE__ */ dual64(2, (self2, predicate) => filterMap74(self2, (b232) => predicate(b232) ? some244(b232) : none94));
var getEquivalence84 = (isEquivalent) => make174((x232, y232) => x232 === y232 || (isNone244(x232) ? isNone244(y232) : isNone244(y232) ? false : isEquivalent(x232.value, y232.value)));
var getOrder74 = (O232) => make244((self2, that) => isSome244(self2) ? isSome244(that) ? O232(self2.value, that.value) : 1 : -1);
var lift264 = (f232) => dual64(2, (self2, that) => zipWith74(self2, that, f232));
var liftPredicate74 = (predicate) => (b232) => predicate(b232) ? some344(b232) : none244();
var containsWith74 = (isEquivalent) => dual64(2, (self2, a232) => isNone244(self2) ? false : isEquivalent(self2.value, a232));
var _equivalence84 = /* @__PURE__ */ equivalence64();
var contains74 = /* @__PURE__ */ containsWith74(_equivalence84);
var exists64 = /* @__PURE__ */ dual64(2, (self2, refinement) => isNone244(self2) ? false : refinement(self2.value));
var bindTo244 = /* @__PURE__ */ bindTo104(map74);
var let_244 = /* @__PURE__ */ let_104(map74);
var bind244 = /* @__PURE__ */ bind104(map74, flatMap74);
var Do74 = /* @__PURE__ */ some344({});
var adapter244 = /* @__PURE__ */ adapter94();
var gen64 = (f232) => {
  const iterator = f232(adapter244);
  let state = iterator.next();
  if (state.done) {
    return some344(state.value);
  } else {
    let current = state.value;
    if (isGenKind64(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet64(current);
    }
    if (isNone244(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind64(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet64(current);
        }
        if (isNone244(current)) {
          return current;
        }
      }
    }
    return some344(state.value);
  }
};
var fromIterable244 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var reverse64 = (self2) => Array.from(self2).reverse();
var reduce74 = /* @__PURE__ */ dual64(3, (self2, b232, f232) => fromIterable244(self2).reduce((b2222, a232, i232) => f232(b2222, a232, i232), b232));
var TagTypeId44 = /* @__PURE__ */ Symbol.for("effect/Context/Tag");
var STMSymbolKey44 = "effect/STM";
var STMTypeId44 = /* @__PURE__ */ Symbol.for(STMSymbolKey44);
var TagProto44 = {
  ...EffectPrototype64,
  _tag: "Tag",
  _op: "Tag",
  [STMTypeId44]: effectVariance64,
  [TagTypeId44]: {
    _Service: (_232) => _232,
    _Identifier: (_232) => _232
  },
  toString() {
    return format64(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Tag",
      key: this.key,
      stack: this.stack
    };
  },
  [NodeInspectSymbol64]() {
    return this.toJSON();
  },
  of(self2) {
    return self2;
  },
  context(self2) {
    return make344(this, self2);
  }
};
var makeGenericTag44 = (key) => {
  const limit = Error.stackTraceLimit;
  Error.stackTraceLimit = 2;
  const creationError = new Error();
  Error.stackTraceLimit = limit;
  const tag = Object.create(TagProto44);
  Object.defineProperty(tag, "stack", {
    get() {
      return creationError.stack;
    }
  });
  tag.key = key;
  return tag;
};
var TypeId444 = /* @__PURE__ */ Symbol.for("effect/Context");
var ContextProto44 = {
  [TypeId444]: {
    _Services: (_232) => _232
  },
  [symbol244](that) {
    if (isContext44(that)) {
      if (this.unsafeMap.size === that.unsafeMap.size) {
        for (const k232 of this.unsafeMap.keys()) {
          if (!that.unsafeMap.has(k232) || !equals64(this.unsafeMap.get(k232), that.unsafeMap.get(k232))) {
            return false;
          }
        }
        return true;
      }
    }
    return false;
  },
  [symbol94]() {
    return cached64(this, number74(this.unsafeMap.size));
  },
  pipe() {
    return pipeArguments64(this, arguments);
  },
  toString() {
    return format64(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Context",
      services: Array.from(this.unsafeMap).map(toJSON64)
    };
  },
  [NodeInspectSymbol64]() {
    return this.toJSON();
  }
};
var makeContext44 = (unsafeMap) => {
  const context = Object.create(ContextProto44);
  context.unsafeMap = unsafeMap;
  return context;
};
var isContext44 = (u232) => hasProperty64(u232, TypeId444);
var _empty84 = /* @__PURE__ */ makeContext44(/* @__PURE__ */ new Map());
var empty134 = () => _empty84;
var make344 = (tag, service) => makeContext44(/* @__PURE__ */ new Map([[tag.key, service]]));
var GenericTag44 = makeGenericTag44;
var empty244 = empty134;
var TypeId544 = /* @__PURE__ */ Symbol.for("effect/Chunk");
function copy54(src, srcPos, dest, destPos, len) {
  for (let i232 = srcPos; i232 < Math.min(src.length, srcPos + len); i232++) {
    dest[destPos + i232 - srcPos] = src[i232];
  }
  return dest;
}
var emptyArray44 = [];
var getEquivalence244 = (isEquivalent) => make174((self2, that) => self2.length === that.length && toReadonlyArray44(self2).every((value, i232) => isEquivalent(value, unsafeGet244(that, i232))));
var _equivalence244 = /* @__PURE__ */ getEquivalence244(equals64);
var ChunkProto44 = {
  [TypeId544]: {
    _A: (_232) => _232
  },
  toString() {
    return format64(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Chunk",
      values: toReadonlyArray44(this).map(toJSON64)
    };
  },
  [NodeInspectSymbol64]() {
    return this.toJSON();
  },
  [symbol244](that) {
    return isChunk44(that) && _equivalence244(this, that);
  },
  [symbol94]() {
    return cached64(this, array84(toReadonlyArray44(this)));
  },
  [Symbol.iterator]() {
    switch (this.backing._tag) {
      case "IArray": {
        return this.backing.array[Symbol.iterator]();
      }
      case "IEmpty": {
        return emptyArray44[Symbol.iterator]();
      }
      default: {
        return toReadonlyArray44(this)[Symbol.iterator]();
      }
    }
  },
  pipe() {
    return pipeArguments64(this, arguments);
  }
};
var makeChunk44 = (backing) => {
  const chunk = Object.create(ChunkProto44);
  chunk.backing = backing;
  switch (backing._tag) {
    case "IEmpty": {
      chunk.length = 0;
      chunk.depth = 0;
      chunk.left = chunk;
      chunk.right = chunk;
      break;
    }
    case "IConcat": {
      chunk.length = backing.left.length + backing.right.length;
      chunk.depth = 1 + Math.max(backing.left.depth, backing.right.depth);
      chunk.left = backing.left;
      chunk.right = backing.right;
      break;
    }
    case "IArray": {
      chunk.length = backing.array.length;
      chunk.depth = 0;
      chunk.left = _empty244;
      chunk.right = _empty244;
      break;
    }
    case "ISingleton": {
      chunk.length = 1;
      chunk.depth = 0;
      chunk.left = _empty244;
      chunk.right = _empty244;
      break;
    }
    case "ISlice": {
      chunk.length = backing.length;
      chunk.depth = backing.chunk.depth + 1;
      chunk.left = _empty244;
      chunk.right = _empty244;
      break;
    }
  }
  return chunk;
};
var isChunk44 = (u232) => hasProperty64(u232, TypeId544);
var _empty244 = /* @__PURE__ */ makeChunk44({
  _tag: "IEmpty"
});
var empty344 = () => _empty244;
var make444 = (...as2322) => as2322.length === 1 ? of54(as2322[0]) : unsafeFromNonEmptyArray44(as2322);
var of54 = (a232) => makeChunk44({
  _tag: "ISingleton",
  a: a232
});
var copyToArray44 = (self2, array3232, initial) => {
  switch (self2.backing._tag) {
    case "IArray": {
      copy54(self2.backing.array, 0, array3232, initial, self2.length);
      break;
    }
    case "IConcat": {
      copyToArray44(self2.left, array3232, initial);
      copyToArray44(self2.right, array3232, initial + self2.left.length);
      break;
    }
    case "ISingleton": {
      array3232[initial] = self2.backing.a;
      break;
    }
    case "ISlice": {
      let i232 = 0;
      let j232 = initial;
      while (i232 < self2.length) {
        array3232[j232] = unsafeGet244(self2, i232);
        i232 += 1;
        j232 += 1;
      }
      break;
    }
  }
};
var toReadonlyArray44 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      return emptyArray44;
    }
    case "IArray": {
      return self2.backing.array;
    }
    default: {
      const arr = new Array(self2.length);
      copyToArray44(self2, arr, 0);
      self2.backing = {
        _tag: "IArray",
        array: arr
      };
      self2.left = _empty244;
      self2.right = _empty244;
      self2.depth = 0;
      return arr;
    }
  }
};
var reverse244 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty":
    case "ISingleton":
      return self2;
    case "IArray": {
      return makeChunk44({
        _tag: "IArray",
        array: reverse64(self2.backing.array)
      });
    }
    case "IConcat": {
      return makeChunk44({
        _tag: "IConcat",
        left: reverse244(self2.backing.right),
        right: reverse244(self2.backing.left)
      });
    }
    case "ISlice":
      return unsafeFromArray44(reverse64(toReadonlyArray44(self2)));
  }
};
var unsafeFromArray44 = (self2) => makeChunk44({
  _tag: "IArray",
  array: self2
});
var unsafeFromNonEmptyArray44 = (self2) => unsafeFromArray44(self2);
var unsafeGet244 = /* @__PURE__ */ dual64(2, (self2, index) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      throw new Error(`Index out of bounds`);
    }
    case "ISingleton": {
      if (index !== 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.a;
    }
    case "IArray": {
      if (index >= self2.length || index < 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.array[index];
    }
    case "IConcat": {
      return index < self2.left.length ? unsafeGet244(self2.left, index) : unsafeGet244(self2.right, index - self2.left.length);
    }
    case "ISlice": {
      return unsafeGet244(self2.backing.chunk, index + self2.backing.offset);
    }
  }
});
var prepend64 = /* @__PURE__ */ dual64(2, (self2, elem) => appendAll54(of54(elem), self2));
var drop54 = /* @__PURE__ */ dual64(2, (self2, n232) => {
  if (n232 <= 0) {
    return self2;
  } else if (n232 >= self2.length) {
    return _empty244;
  } else {
    switch (self2.backing._tag) {
      case "ISlice": {
        return makeChunk44({
          _tag: "ISlice",
          chunk: self2.backing.chunk,
          offset: self2.backing.offset + n232,
          length: self2.backing.length - n232
        });
      }
      case "IConcat": {
        if (n232 > self2.left.length) {
          return drop54(self2.right, n232 - self2.left.length);
        }
        return makeChunk44({
          _tag: "IConcat",
          left: drop54(self2.left, n232),
          right: self2.right
        });
      }
      default: {
        return makeChunk44({
          _tag: "ISlice",
          chunk: self2,
          offset: n232,
          length: self2.length - n232
        });
      }
    }
  }
});
var appendAll54 = /* @__PURE__ */ dual64(2, (self2, that) => {
  if (self2.backing._tag === "IEmpty") {
    return that;
  }
  if (that.backing._tag === "IEmpty") {
    return self2;
  }
  const diff2232 = that.depth - self2.depth;
  if (Math.abs(diff2232) <= 1) {
    return makeChunk44({
      _tag: "IConcat",
      left: self2,
      right: that
    });
  } else if (diff2232 < -1) {
    if (self2.left.depth >= self2.right.depth) {
      const nr = appendAll54(self2.right, that);
      return makeChunk44({
        _tag: "IConcat",
        left: self2.left,
        right: nr
      });
    } else {
      const nrr = appendAll54(self2.right.right, that);
      if (nrr.depth === self2.depth - 3) {
        const nr = makeChunk44({
          _tag: "IConcat",
          left: self2.right.left,
          right: nrr
        });
        return makeChunk44({
          _tag: "IConcat",
          left: self2.left,
          right: nr
        });
      } else {
        const nl = makeChunk44({
          _tag: "IConcat",
          left: self2.left,
          right: self2.right.left
        });
        return makeChunk44({
          _tag: "IConcat",
          left: nl,
          right: nrr
        });
      }
    }
  } else {
    if (that.right.depth >= that.left.depth) {
      const nl = appendAll54(self2, that.left);
      return makeChunk44({
        _tag: "IConcat",
        left: nl,
        right: that.right
      });
    } else {
      const nll = appendAll54(self2, that.left.left);
      if (nll.depth === that.depth - 3) {
        const nl = makeChunk44({
          _tag: "IConcat",
          left: nll,
          right: that.left.right
        });
        return makeChunk44({
          _tag: "IConcat",
          left: nl,
          right: that.right
        });
      } else {
        const nr = makeChunk44({
          _tag: "IConcat",
          left: that.left.right,
          right: that.right
        });
        return makeChunk44({
          _tag: "IConcat",
          left: nll,
          right: nr
        });
      }
    }
  }
});
var isEmpty54 = (self2) => self2.length === 0;
var isNonEmpty44 = (self2) => self2.length > 0;
var unsafeHead44 = (self2) => unsafeGet244(self2, 0);
var headNonEmpty54 = unsafeHead44;
var tailNonEmpty54 = (self2) => drop54(self2, 1);
var SIZE44 = 5;
var BUCKET_SIZE44 = /* @__PURE__ */ Math.pow(2, SIZE44);
var MASK44 = BUCKET_SIZE44 - 1;
var MAX_INDEX_NODE44 = BUCKET_SIZE44 / 2;
var MIN_ARRAY_NODE44 = BUCKET_SIZE44 / 4;
function popcount44(x232) {
  x232 -= x232 >> 1 & 1431655765;
  x232 = (x232 & 858993459) + (x232 >> 2 & 858993459);
  x232 = x232 + (x232 >> 4) & 252645135;
  x232 += x232 >> 8;
  x232 += x232 >> 16;
  return x232 & 127;
}
function hashFragment44(shift22, h232) {
  return h232 >>> shift22 & MASK44;
}
function toBitmap44(x232) {
  return 1 << x232;
}
function fromBitmap44(bitmap, bit) {
  return popcount44(bitmap & bit - 1);
}
var make544 = (value, previous) => ({
  value,
  previous
});
function arrayUpdate44(mutate2232, at, v232, arr) {
  let out = arr;
  if (!mutate2232) {
    const len = arr.length;
    out = new Array(len);
    for (let i232 = 0; i232 < len; ++i232) out[i232] = arr[i232];
  }
  out[at] = v232;
  return out;
}
function arraySpliceOut44(mutate2232, at, arr) {
  const newLen = arr.length - 1;
  let i232 = 0;
  let g232 = 0;
  let out = arr;
  if (mutate2232) {
    i232 = g232 = at;
  } else {
    out = new Array(newLen);
    while (i232 < at) out[g232++] = arr[i232++];
  }
  ++i232;
  while (i232 <= newLen) out[g232++] = arr[i232++];
  if (mutate2232) {
    out.length = newLen;
  }
  return out;
}
function arraySpliceIn44(mutate2232, at, v232, arr) {
  const len = arr.length;
  if (mutate2232) {
    let i2222 = len;
    while (i2222 >= at) arr[i2222--] = arr[i2222];
    arr[at] = v232;
    return arr;
  }
  let i232 = 0, g232 = 0;
  const out = new Array(len + 1);
  while (i232 < at) out[g232++] = arr[i232++];
  out[at] = v232;
  while (i232 < len) out[++g232] = arr[i232++];
  return out;
}
var EmptyNode44 = class _EmptyNode44 {
  _tag = "EmptyNode";
  modify(edit, _shift, f232, hash2322, key, size4232) {
    const v232 = f232(none244());
    if (isNone244(v232)) return new _EmptyNode44();
    ++size4232.value;
    return new LeafNode44(edit, hash2322, key, v232);
  }
};
function isEmptyNode44(a232) {
  return isTagged64(a232, "EmptyNode");
}
function isLeafNode44(node) {
  return isEmptyNode44(node) || node._tag === "LeafNode" || node._tag === "CollisionNode";
}
function canEditNode44(node, edit) {
  return isEmptyNode44(node) ? false : edit === node.edit;
}
var LeafNode44 = class _LeafNode44 {
  edit;
  hash;
  key;
  value;
  _tag = "LeafNode";
  constructor(edit, hash2322, key, value) {
    this.edit = edit;
    this.hash = hash2322;
    this.key = key;
    this.value = value;
  }
  modify(edit, shift22, f232, hash2322, key, size4232) {
    if (equals64(key, this.key)) {
      const v2222 = f232(this.value);
      if (v2222 === this.value) return this;
      else if (isNone244(v2222)) {
        --size4232.value;
        return new EmptyNode44();
      }
      if (canEditNode44(this, edit)) {
        this.value = v2222;
        return this;
      }
      return new _LeafNode44(edit, hash2322, key, v2222);
    }
    const v232 = f232(none244());
    if (isNone244(v232)) return this;
    ++size4232.value;
    return mergeLeaves44(edit, shift22, this.hash, this, hash2322, new _LeafNode44(edit, hash2322, key, v232));
  }
};
var CollisionNode44 = class _CollisionNode44 {
  edit;
  hash;
  children;
  _tag = "CollisionNode";
  constructor(edit, hash2322, children) {
    this.edit = edit;
    this.hash = hash2322;
    this.children = children;
  }
  modify(edit, shift22, f232, hash2322, key, size4232) {
    if (hash2322 === this.hash) {
      const canEdit = canEditNode44(this, edit);
      const list = this.updateCollisionList(canEdit, edit, this.hash, this.children, f232, key, size4232);
      if (list === this.children) return this;
      return list.length > 1 ? new _CollisionNode44(edit, this.hash, list) : list[0];
    }
    const v232 = f232(none244());
    if (isNone244(v232)) return this;
    ++size4232.value;
    return mergeLeaves44(edit, shift22, this.hash, this, hash2322, new LeafNode44(edit, hash2322, key, v232));
  }
  updateCollisionList(mutate2232, edit, hash2322, list, f232, key, size4232) {
    const len = list.length;
    for (let i232 = 0; i232 < len; ++i232) {
      const child = list[i232];
      if ("key" in child && equals64(key, child.key)) {
        const value = child.value;
        const newValue2 = f232(value);
        if (newValue2 === value) return list;
        if (isNone244(newValue2)) {
          --size4232.value;
          return arraySpliceOut44(mutate2232, i232, list);
        }
        return arrayUpdate44(mutate2232, i232, new LeafNode44(edit, hash2322, key, newValue2), list);
      }
    }
    const newValue = f232(none244());
    if (isNone244(newValue)) return list;
    ++size4232.value;
    return arrayUpdate44(mutate2232, len, new LeafNode44(edit, hash2322, key, newValue), list);
  }
};
var IndexedNode44 = class _IndexedNode44 {
  edit;
  mask;
  children;
  _tag = "IndexedNode";
  constructor(edit, mask, children) {
    this.edit = edit;
    this.mask = mask;
    this.children = children;
  }
  modify(edit, shift22, f232, hash2322, key, size4232) {
    const mask = this.mask;
    const children = this.children;
    const frag = hashFragment44(shift22, hash2322);
    const bit = toBitmap44(frag);
    const indx = fromBitmap44(mask, bit);
    const exists2322 = mask & bit;
    const canEdit = canEditNode44(this, edit);
    if (!exists2322) {
      const _newChild = new EmptyNode44().modify(edit, shift22 + SIZE44, f232, hash2322, key, size4232);
      if (!_newChild) return this;
      return children.length >= MAX_INDEX_NODE44 ? expand44(edit, frag, _newChild, mask, children) : new _IndexedNode44(edit, mask | bit, arraySpliceIn44(canEdit, indx, _newChild, children));
    }
    const current = children[indx];
    const child = current.modify(edit, shift22 + SIZE44, f232, hash2322, key, size4232);
    if (current === child) return this;
    let bitmap = mask;
    let newChildren;
    if (isEmptyNode44(child)) {
      bitmap &= ~bit;
      if (!bitmap) return new EmptyNode44();
      if (children.length <= 2 && isLeafNode44(children[indx ^ 1])) {
        return children[indx ^ 1];
      }
      newChildren = arraySpliceOut44(canEdit, indx, children);
    } else {
      newChildren = arrayUpdate44(canEdit, indx, child, children);
    }
    if (canEdit) {
      this.mask = bitmap;
      this.children = newChildren;
      return this;
    }
    return new _IndexedNode44(edit, bitmap, newChildren);
  }
};
var ArrayNode44 = class _ArrayNode44 {
  edit;
  size;
  children;
  _tag = "ArrayNode";
  constructor(edit, size4232, children) {
    this.edit = edit;
    this.size = size4232;
    this.children = children;
  }
  modify(edit, shift22, f232, hash2322, key, size4232) {
    let count = this.size;
    const children = this.children;
    const frag = hashFragment44(shift22, hash2322);
    const child = children[frag];
    const newChild = (child || new EmptyNode44()).modify(edit, shift22 + SIZE44, f232, hash2322, key, size4232);
    if (child === newChild) return this;
    const canEdit = canEditNode44(this, edit);
    let newChildren;
    if (isEmptyNode44(child) && !isEmptyNode44(newChild)) {
      ++count;
      newChildren = arrayUpdate44(canEdit, frag, newChild, children);
    } else if (!isEmptyNode44(child) && isEmptyNode44(newChild)) {
      --count;
      if (count <= MIN_ARRAY_NODE44) {
        return pack44(edit, count, frag, children);
      }
      newChildren = arrayUpdate44(canEdit, frag, new EmptyNode44(), children);
    } else {
      newChildren = arrayUpdate44(canEdit, frag, newChild, children);
    }
    if (canEdit) {
      this.size = count;
      this.children = newChildren;
      return this;
    }
    return new _ArrayNode44(edit, count, newChildren);
  }
};
function pack44(edit, count, removed, elements) {
  const children = new Array(count - 1);
  let g232 = 0;
  let bitmap = 0;
  for (let i232 = 0, len = elements.length; i232 < len; ++i232) {
    if (i232 !== removed) {
      const elem = elements[i232];
      if (elem && !isEmptyNode44(elem)) {
        children[g232++] = elem;
        bitmap |= 1 << i232;
      }
    }
  }
  return new IndexedNode44(edit, bitmap, children);
}
function expand44(edit, frag, child, bitmap, subNodes) {
  const arr = [];
  let bit = bitmap;
  let count = 0;
  for (let i232 = 0; bit; ++i232) {
    if (bit & 1) arr[i232] = subNodes[count++];
    bit >>>= 1;
  }
  arr[frag] = child;
  return new ArrayNode44(edit, count + 1, arr);
}
function mergeLeavesInner44(edit, shift22, h1, n1, h232, n232) {
  if (h1 === h232) return new CollisionNode44(edit, h1, [n232, n1]);
  const subH1 = hashFragment44(shift22, h1);
  const subH2 = hashFragment44(shift22, h232);
  if (subH1 === subH2) {
    return (child) => new IndexedNode44(edit, toBitmap44(subH1) | toBitmap44(subH2), [child]);
  } else {
    const children = subH1 < subH2 ? [n1, n232] : [n232, n1];
    return new IndexedNode44(edit, toBitmap44(subH1) | toBitmap44(subH2), children);
  }
}
function mergeLeaves44(edit, shift22, h1, n1, h232, n232) {
  let stack = void 0;
  let currentShift = shift22;
  while (true) {
    const res = mergeLeavesInner44(edit, currentShift, h1, n1, h232, n232);
    if (typeof res === "function") {
      stack = make544(res, stack);
      currentShift = currentShift + SIZE44;
    } else {
      let final = res;
      while (stack != null) {
        final = stack.value(final);
        stack = stack.previous;
      }
      return final;
    }
  }
}
var HashMapSymbolKey44 = "effect/HashMap";
var HashMapTypeId44 = /* @__PURE__ */ Symbol.for(HashMapSymbolKey44);
var HashMapProto44 = {
  [HashMapTypeId44]: HashMapTypeId44,
  [Symbol.iterator]() {
    return new HashMapIterator44(this, (k232, v232) => [k232, v232]);
  },
  [symbol94]() {
    let hash2322 = hash64(HashMapSymbolKey44);
    for (const item of this) {
      hash2322 ^= pipe64(hash64(item[0]), combine74(hash64(item[1])));
    }
    return cached64(this, hash2322);
  },
  [symbol244](that) {
    if (isHashMap44(that)) {
      if (that._size !== this._size) {
        return false;
      }
      for (const item of this) {
        const elem = pipe64(that, getHash44(item[0], hash64(item[0])));
        if (isNone244(elem)) {
          return false;
        } else {
          if (!equals64(item[1], elem.value)) {
            return false;
          }
        }
      }
      return true;
    }
    return false;
  },
  toString() {
    return format64(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashMap",
      values: Array.from(this).map(toJSON64)
    };
  },
  [NodeInspectSymbol64]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments64(this, arguments);
  }
};
var makeImpl54 = (editable, edit, root, size4232) => {
  const map622 = Object.create(HashMapProto44);
  map622._editable = editable;
  map622._edit = edit;
  map622._root = root;
  map622._size = size4232;
  return map622;
};
var HashMapIterator44 = class _HashMapIterator44 {
  map;
  f;
  v;
  constructor(map622, f232) {
    this.map = map622;
    this.f = f232;
    this.v = visitLazy44(this.map._root, this.f, void 0);
  }
  next() {
    if (isNone244(this.v)) {
      return {
        done: true,
        value: void 0
      };
    }
    const v0 = this.v.value;
    this.v = applyCont44(v0.cont);
    return {
      done: false,
      value: v0.value
    };
  }
  [Symbol.iterator]() {
    return new _HashMapIterator44(this.map, this.f);
  }
};
var applyCont44 = (cont) => cont ? visitLazyChildren44(cont[0], cont[1], cont[2], cont[3], cont[4]) : none244();
var visitLazy44 = (node, f232, cont = void 0) => {
  switch (node._tag) {
    case "LeafNode": {
      if (isSome244(node.value)) {
        return some344({
          value: f232(node.key, node.value.value),
          cont
        });
      }
      return applyCont44(cont);
    }
    case "CollisionNode":
    case "ArrayNode":
    case "IndexedNode": {
      const children = node.children;
      return visitLazyChildren44(children.length, children, 0, f232, cont);
    }
    default: {
      return applyCont44(cont);
    }
  }
};
var visitLazyChildren44 = (len, children, i232, f232, cont) => {
  while (i232 < len) {
    const child = children[i232++];
    if (child && !isEmptyNode44(child)) {
      return visitLazy44(child, f232, [len, children, i232, f232, cont]);
    }
  }
  return applyCont44(cont);
};
var _empty344 = /* @__PURE__ */ makeImpl54(false, 0, /* @__PURE__ */ new EmptyNode44(), 0);
var empty444 = () => _empty344;
var isHashMap44 = (u232) => hasProperty64(u232, HashMapTypeId44);
var getHash44 = /* @__PURE__ */ dual64(3, (self2, key, hash2322) => {
  let node = self2._root;
  let shift22 = 0;
  while (true) {
    switch (node._tag) {
      case "LeafNode": {
        return equals64(key, node.key) ? node.value : none244();
      }
      case "CollisionNode": {
        if (hash2322 === node.hash) {
          const children = node.children;
          for (let i232 = 0, len = children.length; i232 < len; ++i232) {
            const child = children[i232];
            if ("key" in child && equals64(key, child.key)) {
              return child.value;
            }
          }
        }
        return none244();
      }
      case "IndexedNode": {
        const frag = hashFragment44(shift22, hash2322);
        const bit = toBitmap44(frag);
        if (node.mask & bit) {
          node = node.children[fromBitmap44(node.mask, bit)];
          shift22 += SIZE44;
          break;
        }
        return none244();
      }
      case "ArrayNode": {
        node = node.children[hashFragment44(shift22, hash2322)];
        if (node) {
          shift22 += SIZE44;
          break;
        }
        return none244();
      }
      default:
        return none244();
    }
  }
});
var set54 = /* @__PURE__ */ dual64(3, (self2, key, value) => modifyAt44(self2, key, () => some344(value)));
var setTree44 = /* @__PURE__ */ dual64(3, (self2, newRoot, newSize) => {
  if (self2._editable) {
    self2._root = newRoot;
    self2._size = newSize;
    return self2;
  }
  return newRoot === self2._root ? self2 : makeImpl54(self2._editable, self2._edit, newRoot, newSize);
});
var keys54 = (self2) => new HashMapIterator44(self2, (key) => key);
var size64 = (self2) => self2._size;
var beginMutation54 = (self2) => makeImpl54(true, self2._edit + 1, self2._root, self2._size);
var modifyAt44 = /* @__PURE__ */ dual64(3, (self2, key, f232) => modifyHash44(self2, key, hash64(key), f232));
var modifyHash44 = /* @__PURE__ */ dual64(4, (self2, key, hash2322, f232) => {
  const size4232 = {
    value: self2._size
  };
  const newRoot = self2._root.modify(self2._editable ? self2._edit : NaN, 0, f232, hash2322, key, size4232);
  return pipe64(self2, setTree44(newRoot, size4232.value));
});
var forEach74 = /* @__PURE__ */ dual64(2, (self2, f232) => reduce244(self2, void 0, (_232, value, key) => f232(value, key)));
var reduce244 = /* @__PURE__ */ dual64(3, (self2, zero, f232) => {
  const root = self2._root;
  if (root._tag === "LeafNode") {
    return isSome244(root.value) ? f232(zero, root.value.value, root.key) : zero;
  }
  if (root._tag === "EmptyNode") {
    return zero;
  }
  const toVisit = [root.children];
  let children;
  while (children = toVisit.pop()) {
    for (let i232 = 0, len = children.length; i232 < len; ) {
      const child = children[i232++];
      if (child && !isEmptyNode44(child)) {
        if (child._tag === "LeafNode") {
          if (isSome244(child.value)) {
            zero = f232(zero, child.value.value, child.key);
          }
        } else {
          toVisit.push(child.children);
        }
      }
    }
  }
  return zero;
});
var HashSetSymbolKey44 = "effect/HashSet";
var HashSetTypeId44 = /* @__PURE__ */ Symbol.for(HashSetSymbolKey44);
var HashSetProto44 = {
  [HashSetTypeId44]: HashSetTypeId44,
  [Symbol.iterator]() {
    return keys54(this._keyMap);
  },
  [symbol94]() {
    return cached64(this, combine74(hash64(this._keyMap))(hash64(HashSetSymbolKey44)));
  },
  [symbol244](that) {
    if (isHashSet44(that)) {
      return size64(this._keyMap) === size64(that._keyMap) && equals64(this._keyMap, that._keyMap);
    }
    return false;
  },
  toString() {
    return format64(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashSet",
      values: Array.from(this).map(toJSON64)
    };
  },
  [NodeInspectSymbol64]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments64(this, arguments);
  }
};
var makeImpl244 = (keyMap) => {
  const set2322 = Object.create(HashSetProto44);
  set2322._keyMap = keyMap;
  return set2322;
};
var isHashSet44 = (u232) => hasProperty64(u232, HashSetTypeId44);
var _empty444 = /* @__PURE__ */ makeImpl244(/* @__PURE__ */ empty444());
var empty544 = () => _empty444;
var size244 = (self2) => size64(self2._keyMap);
var beginMutation244 = (self2) => makeImpl244(beginMutation54(self2._keyMap));
var endMutation44 = (self2) => {
  self2._keyMap._editable = false;
  return self2;
};
var mutate44 = /* @__PURE__ */ dual64(2, (self2, f232) => {
  const transient = beginMutation244(self2);
  f232(transient);
  return endMutation44(transient);
});
var add244 = /* @__PURE__ */ dual64(2, (self2, value) => self2._keyMap._editable ? (set54(value, true)(self2._keyMap), self2) : makeImpl244(set54(value, true)(self2._keyMap)));
var union244 = /* @__PURE__ */ dual64(2, (self2, that) => mutate44(empty544(), (set2322) => {
  forEach244(self2, (value) => add244(set2322, value));
  for (const value of that) {
    add244(set2322, value);
  }
}));
var forEach244 = /* @__PURE__ */ dual64(2, (self2, f232) => forEach74(self2._keyMap, (_232, k232) => f232(k232)));
var empty644 = empty544;
var size344 = size244;
var add344 = add244;
var union344 = union244;
var ArrayProto44 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(Array.prototype), {
  [symbol94]() {
    return cached64(this, array84(this));
  },
  [symbol244](that) {
    if (Array.isArray(that) && this.length === that.length) {
      return this.every((v232, i232) => equals64(v232, that[i232]));
    } else {
      return false;
    }
  }
});
var Structural54 = /* @__PURE__ */ function() {
  function Structural3232(args) {
    if (args) {
      Object.assign(this, args);
    }
  }
  Structural3232.prototype = StructuralPrototype34;
  return Structural3232;
}();
var struct244 = (as2322) => Object.assign(Object.create(StructuralPrototype34), as2322);
var ContextPatchTypeId44 = /* @__PURE__ */ Symbol.for("effect/DifferContextPatch");
function variance54(a232) {
  return a232;
}
var PatchProto44 = {
  ...Structural54.prototype,
  [ContextPatchTypeId44]: {
    _Value: variance54,
    _Patch: variance54
  }
};
var EmptyProto44 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto44), {
  _tag: "Empty"
});
var _empty544 = /* @__PURE__ */ Object.create(EmptyProto44);
var empty744 = () => _empty544;
var AndThenProto44 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto44), {
  _tag: "AndThen"
});
var makeAndThen44 = (first, second) => {
  const o232 = Object.create(AndThenProto44);
  o232.first = first;
  o232.second = second;
  return o232;
};
var AddServiceProto44 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto44), {
  _tag: "AddService"
});
var makeAddService44 = (key, service) => {
  const o232 = Object.create(AddServiceProto44);
  o232.key = key;
  o232.service = service;
  return o232;
};
var RemoveServiceProto44 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto44), {
  _tag: "RemoveService"
});
var makeRemoveService44 = (key) => {
  const o232 = Object.create(RemoveServiceProto44);
  o232.key = key;
  return o232;
};
var UpdateServiceProto44 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto44), {
  _tag: "UpdateService"
});
var makeUpdateService44 = (key, update222) => {
  const o232 = Object.create(UpdateServiceProto44);
  o232.key = key;
  o232.update = update222;
  return o232;
};
var diff44 = (oldValue, newValue) => {
  const missingServices = new Map(oldValue.unsafeMap);
  let patch2232 = empty744();
  for (const [tag, newService] of newValue.unsafeMap.entries()) {
    if (missingServices.has(tag)) {
      const old = missingServices.get(tag);
      missingServices.delete(tag);
      if (!equals64(old, newService)) {
        patch2232 = combine244(makeUpdateService44(tag, () => newService))(patch2232);
      }
    } else {
      missingServices.delete(tag);
      patch2232 = combine244(makeAddService44(tag, newService))(patch2232);
    }
  }
  for (const [tag] of missingServices.entries()) {
    patch2232 = combine244(makeRemoveService44(tag))(patch2232);
  }
  return patch2232;
};
var combine244 = /* @__PURE__ */ dual64(2, (self2, that) => makeAndThen44(self2, that));
var patch44 = /* @__PURE__ */ dual64(2, (self2, context) => {
  if (self2._tag === "Empty") {
    return context;
  }
  let wasServiceUpdated = false;
  let patches = of54(self2);
  const updatedContext = new Map(context.unsafeMap);
  while (isNonEmpty44(patches)) {
    const head222 = headNonEmpty54(patches);
    const tail222 = tailNonEmpty54(patches);
    switch (head222._tag) {
      case "Empty": {
        patches = tail222;
        break;
      }
      case "AddService": {
        updatedContext.set(head222.key, head222.service);
        patches = tail222;
        break;
      }
      case "AndThen": {
        patches = prepend64(prepend64(tail222, head222.second), head222.first);
        break;
      }
      case "RemoveService": {
        updatedContext.delete(head222.key);
        patches = tail222;
        break;
      }
      case "UpdateService": {
        updatedContext.set(head222.key, head222.update(updatedContext.get(head222.key)));
        wasServiceUpdated = true;
        patches = tail222;
        break;
      }
    }
  }
  if (!wasServiceUpdated) {
    return makeContext44(updatedContext);
  }
  const map622 = /* @__PURE__ */ new Map();
  for (const [tag] of context.unsafeMap) {
    if (updatedContext.has(tag)) {
      map622.set(tag, updatedContext.get(tag));
      updatedContext.delete(tag);
    }
  }
  for (const [tag, s232] of updatedContext) {
    map622.set(tag, s232);
  }
  return makeContext44(map622);
});
var DifferTypeId44 = /* @__PURE__ */ Symbol.for("effect/Differ");
var DifferProto44 = {
  [DifferTypeId44]: {
    _P: identity64,
    _V: identity64
  }
};
var make744 = (params) => {
  const differ = Object.create(DifferProto44);
  differ.empty = params.empty;
  differ.diff = params.diff;
  differ.combine = params.combine;
  differ.patch = params.patch;
  return differ;
};
var environment44 = () => make744({
  empty: empty744(),
  combine: (first, second) => combine244(second)(first),
  diff: (oldValue, newValue) => diff44(oldValue, newValue),
  patch: (patch2232, oldValue) => patch44(oldValue)(patch2232)
});
var OP_DIE44 = "Die";
var OP_EMPTY44 = "Empty";
var OP_FAIL44 = "Fail";
var OP_INTERRUPT44 = "Interrupt";
var OP_PARALLEL44 = "Parallel";
var OP_SEQUENTIAL44 = "Sequential";
var CauseSymbolKey44 = "effect/Cause";
var CauseTypeId44 = /* @__PURE__ */ Symbol.for(CauseSymbolKey44);
var variance244 = {
  /* c8 ignore next */
  _E: (_232) => _232
};
var proto44 = {
  [CauseTypeId44]: variance244,
  [symbol94]() {
    return pipe64(hash64(CauseSymbolKey44), combine74(hash64(flattenCause44(this))), cached64(this));
  },
  [symbol244](that) {
    return isCause44(that) && causeEquals44(this, that);
  },
  pipe() {
    return pipeArguments64(this, arguments);
  },
  toJSON() {
    switch (this._tag) {
      case "Empty":
        return {
          _id: "Cause",
          _tag: this._tag
        };
      case "Die":
        return {
          _id: "Cause",
          _tag: this._tag,
          defect: toJSON64(this.defect)
        };
      case "Interrupt":
        return {
          _id: "Cause",
          _tag: this._tag,
          fiberId: this.fiberId.toJSON()
        };
      case "Fail":
        return {
          _id: "Cause",
          _tag: this._tag,
          failure: toJSON64(this.error)
        };
      case "Sequential":
      case "Parallel":
        return {
          _id: "Cause",
          _tag: this._tag,
          left: toJSON64(this.left),
          right: toJSON64(this.right)
        };
    }
  },
  toString() {
    return pretty44(this);
  },
  [NodeInspectSymbol64]() {
    return this.toJSON();
  }
};
var fail54 = (error) => {
  const o232 = Object.create(proto44);
  o232._tag = OP_FAIL44;
  o232.error = error;
  return o232;
};
var parallel44 = (left3232, right3232) => {
  const o232 = Object.create(proto44);
  o232._tag = OP_PARALLEL44;
  o232.left = left3232;
  o232.right = right3232;
  return o232;
};
var sequential44 = (left3232, right3232) => {
  const o232 = Object.create(proto44);
  o232._tag = OP_SEQUENTIAL44;
  o232.left = left3232;
  o232.right = right3232;
  return o232;
};
var isCause44 = (u232) => hasProperty64(u232, CauseTypeId44);
var isInterruptedOnly44 = (self2) => reduceWithContext44(void 0, IsInterruptedOnlyCauseReducer44)(self2);
var causeEquals44 = (left3232, right3232) => {
  let leftStack = of54(left3232);
  let rightStack = of54(right3232);
  while (isNonEmpty44(leftStack) && isNonEmpty44(rightStack)) {
    const [leftParallel, leftSequential] = pipe64(headNonEmpty54(leftStack), reduce444([empty644(), empty344()], ([parallel2232, sequential2232], cause) => {
      const [par, seq] = evaluateCause44(cause);
      return some344([pipe64(parallel2232, union344(par)), pipe64(sequential2232, appendAll54(seq))]);
    }));
    const [rightParallel, rightSequential] = pipe64(headNonEmpty54(rightStack), reduce444([empty644(), empty344()], ([parallel2232, sequential2232], cause) => {
      const [par, seq] = evaluateCause44(cause);
      return some344([pipe64(parallel2232, union344(par)), pipe64(sequential2232, appendAll54(seq))]);
    }));
    if (!equals64(leftParallel, rightParallel)) {
      return false;
    }
    leftStack = leftSequential;
    rightStack = rightSequential;
  }
  return true;
};
var flattenCause44 = (cause) => {
  return flattenCauseLoop44(of54(cause), empty344());
};
var flattenCauseLoop44 = (causes, flattened) => {
  while (1) {
    const [parallel2232, sequential2232] = pipe64(causes, reduce74([empty644(), empty344()], ([parallel322, sequential322], cause) => {
      const [par, seq] = evaluateCause44(cause);
      return [pipe64(parallel322, union344(par)), pipe64(sequential322, appendAll54(seq))];
    }));
    const updated = size344(parallel2232) > 0 ? pipe64(flattened, prepend64(parallel2232)) : flattened;
    if (isEmpty54(sequential2232)) {
      return reverse244(updated);
    }
    causes = sequential2232;
    flattened = updated;
  }
  throw new Error(getBugErrorMessage64("Cause.flattenCauseLoop"));
};
var evaluateCause44 = (self2) => {
  let cause = self2;
  const stack = [];
  let _parallel = empty644();
  let _sequential = empty344();
  while (cause !== void 0) {
    switch (cause._tag) {
      case OP_EMPTY44: {
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_FAIL44: {
        _parallel = add344(_parallel, make444(cause._tag, cause.error));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_DIE44: {
        _parallel = add344(_parallel, make444(cause._tag, cause.defect));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_INTERRUPT44: {
        _parallel = add344(_parallel, make444(cause._tag, cause.fiberId));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_SEQUENTIAL44: {
        switch (cause.left._tag) {
          case OP_EMPTY44: {
            cause = cause.right;
            break;
          }
          case OP_SEQUENTIAL44: {
            cause = sequential44(cause.left.left, sequential44(cause.left.right, cause.right));
            break;
          }
          case OP_PARALLEL44: {
            cause = parallel44(sequential44(cause.left.left, cause.right), sequential44(cause.left.right, cause.right));
            break;
          }
          default: {
            _sequential = prepend64(_sequential, cause.right);
            cause = cause.left;
            break;
          }
        }
        break;
      }
      case OP_PARALLEL44: {
        stack.push(cause.right);
        cause = cause.left;
        break;
      }
    }
  }
  throw new Error(getBugErrorMessage64("Cause.evaluateCauseLoop"));
};
var IsInterruptedOnlyCauseReducer44 = {
  emptyCase: constTrue64,
  failCase: constFalse64,
  dieCase: constFalse64,
  interruptCase: constTrue64,
  sequentialCase: (_232, left3232, right3232) => left3232 && right3232,
  parallelCase: (_232, left3232, right3232) => left3232 && right3232
};
var OP_SEQUENTIAL_CASE44 = "SequentialCase";
var OP_PARALLEL_CASE44 = "ParallelCase";
var reduce444 = /* @__PURE__ */ dual64(3, (self2, zero, pf) => {
  let accumulator = zero;
  let cause = self2;
  const causes = [];
  while (cause !== void 0) {
    const option = pf(accumulator, cause);
    accumulator = isSome244(option) ? option.value : accumulator;
    switch (cause._tag) {
      case OP_SEQUENTIAL44: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      case OP_PARALLEL44: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      default: {
        cause = void 0;
        break;
      }
    }
    if (cause === void 0 && causes.length > 0) {
      cause = causes.pop();
    }
  }
  return accumulator;
});
var reduceWithContext44 = /* @__PURE__ */ dual64(3, (self2, context, reducer) => {
  const input = [self2];
  const output = [];
  while (input.length > 0) {
    const cause = input.pop();
    switch (cause._tag) {
      case OP_EMPTY44: {
        output.push(right244(reducer.emptyCase(context)));
        break;
      }
      case OP_FAIL44: {
        output.push(right244(reducer.failCase(context, cause.error)));
        break;
      }
      case OP_DIE44: {
        output.push(right244(reducer.dieCase(context, cause.defect)));
        break;
      }
      case OP_INTERRUPT44: {
        output.push(right244(reducer.interruptCase(context, cause.fiberId)));
        break;
      }
      case OP_SEQUENTIAL44: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left244({
          _tag: OP_SEQUENTIAL_CASE44
        }));
        break;
      }
      case OP_PARALLEL44: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left244({
          _tag: OP_PARALLEL_CASE44
        }));
        break;
      }
    }
  }
  const accumulator = [];
  while (output.length > 0) {
    const either = output.pop();
    switch (either._tag) {
      case "Left": {
        switch (either.left._tag) {
          case OP_SEQUENTIAL_CASE44: {
            const left3232 = accumulator.pop();
            const right3232 = accumulator.pop();
            const value = reducer.sequentialCase(context, left3232, right3232);
            accumulator.push(value);
            break;
          }
          case OP_PARALLEL_CASE44: {
            const left3232 = accumulator.pop();
            const right3232 = accumulator.pop();
            const value = reducer.parallelCase(context, left3232, right3232);
            accumulator.push(value);
            break;
          }
        }
        break;
      }
      case "Right": {
        accumulator.push(either.right);
        break;
      }
    }
  }
  if (accumulator.length === 0) {
    throw new Error("BUG: Cause.reduceWithContext - please report an issue at https://github.com/Effect-TS/effect/issues");
  }
  return accumulator.pop();
});
var pretty44 = (cause) => {
  if (isInterruptedOnly44(cause)) {
    return "All fibers interrupted without errors.";
  }
  return prettyErrors44(cause).map((e232) => e232.stack).join("\n");
};
var PrettyError44 = class extends globalThis.Error {
  span = void 0;
  constructor(originalError) {
    const prevLimit = Error.stackTraceLimit;
    Error.stackTraceLimit = 0;
    super(prettyErrorMessage44(originalError));
    Error.stackTraceLimit = prevLimit;
    this.name = originalError instanceof Error ? originalError.name : "Error";
    if (typeof originalError === "object" && originalError !== null) {
      if (spanSymbol54 in originalError) {
        this.span = originalError[spanSymbol54];
      }
      Object.keys(originalError).forEach((key) => {
        if (!(key in this)) {
          this[key] = originalError[key];
        }
      });
    }
    this.stack = prettyErrorStack44(this.message, originalError instanceof Error && originalError.stack ? originalError.stack : "", this.span);
  }
  toJSON() {
    const out = {
      message: this.message,
      stack: this.stack
    };
    if (this.span) {
      out.span = this.span;
    }
    return out;
  }
};
var prettyErrorMessage44 = (u232) => {
  if (typeof u232 === "string") {
    return `Error: ${u232}`;
  }
  try {
    if (hasProperty64(u232, "toString") && isFunction334(u232["toString"]) && u232["toString"] !== Object.prototype.toString && u232["toString"] !== globalThis.Array.prototype.toString) {
      return u232["toString"]();
    }
  } catch {
  }
  return `Error: ${JSON.stringify(u232)}`;
};
var locationRegex44 = /\((.*)\)/;
var spanToTrace44 = /* @__PURE__ */ globalValue64("effect/Tracer/spanToTrace", () => /* @__PURE__ */ new WeakMap());
var prettyErrorStack44 = (message, stack, span222) => {
  const out = [message];
  const lines = stack.split("\n");
  for (let i232 = 1; i232 < lines.length; i232++) {
    if (lines[i232].includes("Generator.next")) {
      break;
    }
    if (lines[i232].includes("effect_internal_function")) {
      out.pop();
      break;
    }
    out.push(lines[i232].replace(/at .*effect_instruction_i.*\((.*)\)/, "at $1").replace(/EffectPrimitive\.\w+/, "<anonymous>"));
  }
  if (span222) {
    let current = span222;
    let i232 = 0;
    while (current && current._tag === "Span" && i232 < 10) {
      const stackFn = spanToTrace44.get(current);
      if (typeof stackFn === "function") {
        const stack2 = stackFn();
        const locationMatch = stack2.match(locationRegex44);
        const location = locationMatch ? locationMatch[1] : stack2.replace(/^at /, "");
        out.push(`    at ${current.name} (${location})`);
      } else {
        out.push(`    at ${current.name}`);
      }
      current = getOrUndefined64(current.parent);
      i232++;
    }
  }
  return out.join("\n");
};
var spanSymbol54 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var prettyErrors44 = (cause) => reduceWithContext44(cause, void 0, {
  emptyCase: () => [],
  dieCase: (_232, unknownError) => {
    return [new PrettyError44(unknownError)];
  },
  failCase: (_232, error) => {
    return [new PrettyError44(error)];
  },
  interruptCase: () => [],
  parallelCase: (_232, l232, r232) => [...l232, ...r232],
  sequentialCase: (_232, l232, r232) => [...l232, ...r232]
});
var SingleShotGen244 = class _SingleShotGen244 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  next(a232) {
    return this.called ? {
      value: a232,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  return(a232) {
    return {
      value: a232,
      done: true
    };
  }
  throw(e232) {
    throw e232;
  }
  [Symbol.iterator]() {
    return new _SingleShotGen244(this.self);
  }
};
var spanTag44 = /* @__PURE__ */ GenericTag44("effect/ParentSpan");
var EffectTypeId244 = /* @__PURE__ */ Symbol.for("effect/Effect");
var EffectPrimitive44 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId244] = effectVariance64;
  constructor(_op) {
    this._op = _op;
  }
  [symbol244](that) {
    return this === that;
  }
  [symbol94]() {
    return cached64(this, random64(this));
  }
  pipe() {
    return pipeArguments64(this, arguments);
  }
  toJSON() {
    return {
      _id: "Effect",
      _op: this._op,
      effect_instruction_i0: toJSON64(this.effect_instruction_i0),
      effect_instruction_i1: toJSON64(this.effect_instruction_i1),
      effect_instruction_i2: toJSON64(this.effect_instruction_i2)
    };
  }
  toString() {
    return format64(this.toJSON());
  }
  [NodeInspectSymbol64]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen244(new YieldWrap64(this));
  }
};
var EffectPrimitiveFailure44 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId244] = effectVariance64;
  constructor(_op) {
    this._op = _op;
    this._tag = _op;
  }
  [symbol244](that) {
    return exitIsExit44(that) && that._op === "Failure" && // @ts-expect-error
    equals64(this.effect_instruction_i0, that.effect_instruction_i0);
  }
  [symbol94]() {
    return pipe64(
      // @ts-expect-error
      string74(this._tag),
      // @ts-expect-error
      combine74(hash64(this.effect_instruction_i0)),
      cached64(this)
    );
  }
  get cause() {
    return this.effect_instruction_i0;
  }
  pipe() {
    return pipeArguments64(this, arguments);
  }
  toJSON() {
    return {
      _id: "Exit",
      _tag: this._op,
      cause: this.cause.toJSON()
    };
  }
  toString() {
    return format64(this.toJSON());
  }
  [NodeInspectSymbol64]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen244(new YieldWrap64(this));
  }
};
var isEffect44 = (u232) => hasProperty64(u232, EffectTypeId244);
var withFiberRuntime44 = (withRuntime) => {
  const effect = new EffectPrimitive44(OP_WITH_RUNTIME44);
  effect.effect_instruction_i0 = withRuntime;
  return effect;
};
var spanSymbol244 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var originalSymbol44 = /* @__PURE__ */ Symbol.for("effect/OriginalAnnotation");
var capture44 = (obj, span222) => {
  if (isSome244(span222)) {
    return new Proxy(obj, {
      has(target, p232) {
        return p232 === spanSymbol244 || p232 === originalSymbol44 || p232 in target;
      },
      get(target, p232) {
        if (p232 === spanSymbol244) {
          return span222.value;
        }
        if (p232 === originalSymbol44) {
          return obj;
        }
        return target[p232];
      }
    });
  }
  return obj;
};
var fail244 = (error) => isObject64(error) && !(spanSymbol244 in error) ? withFiberRuntime44((fiber) => failCause44(fail54(capture44(error, currentSpanFromFiber44(fiber))))) : failCause44(fail54(error));
var failCause44 = (cause) => {
  const effect = new EffectPrimitiveFailure44(OP_FAILURE44);
  effect.effect_instruction_i0 = cause;
  return effect;
};
var FiberRefSymbolKey44 = "effect/FiberRef";
var FiberRefTypeId44 = /* @__PURE__ */ Symbol.for(FiberRefSymbolKey44);
var fiberRefVariance44 = {
  /* c8 ignore next */
  _A: (_232) => _232
};
var fiberRefUnsafeMakeContext44 = (initial) => {
  const differ = environment44();
  return fiberRefUnsafeMakePatch44(initial, {
    differ,
    fork: differ.empty
  });
};
var fiberRefUnsafeMakePatch44 = (initial, options) => ({
  [FiberRefTypeId44]: fiberRefVariance44,
  initial,
  diff: (oldValue, newValue) => options.differ.diff(oldValue, newValue),
  combine: (first, second) => options.differ.combine(first, second),
  patch: (patch2232) => (oldValue) => options.differ.patch(patch2232, oldValue),
  fork: options.fork,
  join: options.join ?? ((_232, n232) => n232),
  pipe() {
    return pipeArguments64(this, arguments);
  }
});
var currentContext44 = /* @__PURE__ */ globalValue64(/* @__PURE__ */ Symbol.for("effect/FiberRef/currentContext"), () => fiberRefUnsafeMakeContext44(empty244()));
var YieldableError44 = /* @__PURE__ */ function() {
  class YieldableError2232 extends globalThis.Error {
    commit() {
      return fail244(this);
    }
    toString() {
      return this.message ? `${this.name}: ${this.message}` : this.name;
    }
    toJSON() {
      return {
        ...this
      };
    }
    [NodeInspectSymbol64]() {
      const stack = this.stack;
      if (stack) {
        return `${this.toString()}
${stack.split("\n").slice(1).join("\n")}`;
      }
      return this.toString();
    }
  }
  Object.assign(YieldableError2232.prototype, StructuralCommitPrototype34);
  return YieldableError2232;
}();
var exitIsExit44 = (u232) => isEffect44(u232) && "_tag" in u232 && (u232._tag === "Success" || u232._tag === "Failure");
var currentSpanFromFiber44 = (fiber) => {
  const span222 = fiber.getFiberRef(currentContext44).unsafeMap.get(spanTag44.key);
  return span222 !== void 0 && span222._tag === "Span" ? some344(span222) : none244();
};
var Data_exports34 = {};
__export244(Data_exports34, {
  Class: () => Class244,
  Error: () => Error244,
  Structural: () => Structural244,
  TaggedClass: () => TaggedClass44,
  TaggedError: () => TaggedError44,
  array: () => array244,
  case: () => _case44,
  struct: () => struct344,
  tagged: () => tagged44,
  taggedEnum: () => taggedEnum44,
  tuple: () => tuple244,
  unsafeArray: () => unsafeArray44,
  unsafeStruct: () => unsafeStruct44
});
var struct344 = struct244;
var unsafeStruct44 = (as2322) => Object.setPrototypeOf(as2322, StructuralPrototype34);
var tuple244 = (...as2322) => unsafeArray44(as2322);
var array244 = (as2322) => unsafeArray44(as2322.slice(0));
var unsafeArray44 = (as2322) => Object.setPrototypeOf(as2322, ArrayProto44);
var _case44 = () => (args) => args === void 0 ? Object.create(StructuralPrototype34) : struct344(args);
var tagged44 = (tag) => (args) => {
  const value = args === void 0 ? Object.create(StructuralPrototype34) : struct344(args);
  value._tag = tag;
  return value;
};
var Class244 = Structural54;
var TaggedClass44 = (tag) => {
  class Base extends Class244 {
    _tag = tag;
  }
  return Base;
};
var Structural244 = Structural54;
var taggedEnum44 = () => new Proxy({}, {
  get(_target, tag, _receiver) {
    if (tag === "$is") {
      return isTagged64;
    } else if (tag === "$match") {
      return taggedMatch44;
    }
    return tagged44(tag);
  }
});
function taggedMatch44() {
  if (arguments.length === 1) {
    const cases2 = arguments[0];
    return function(value2) {
      return cases2[value2._tag](value2);
    };
  }
  const value = arguments[0];
  const cases = arguments[1];
  return cases[value._tag](value);
}
var Error244 = /* @__PURE__ */ function() {
  return class Base extends YieldableError44 {
    constructor(args) {
      super();
      if (args) {
        Object.assign(this, args);
      }
    }
  };
}();
var TaggedError44 = (tag) => {
  class Base extends Error244 {
    _tag = tag;
  }
  Base.prototype.name = tag;
  return Base;
};
var traverseUp44 = Function_exports64.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType44.Program) return Option_exports64.none();
  return predicate(parent) ? Option_exports64.some(parent) : traverseUp44(parent, predicate);
});
var traverseUpGuard44 = Function_exports64.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType44.Program) return Option_exports64.none();
  return predicate(parent) ? Option_exports64.some(parent) : traverseUpGuard44(parent, predicate);
});
var ESLintCommunityESLintUtils44;
((ESLintCommunityESLintUtils2232) => {
  ESLintCommunityESLintUtils2232.getFunctionHeadLocation = getFunctionHeadLocation44;
  ESLintCommunityESLintUtils2232.getFunctionNameWithKind = getFunctionNameWithKind44;
  ESLintCommunityESLintUtils2232.getPropertyName = getPropertyName44;
  ESLintCommunityESLintUtils2232.getStaticValue = getStaticValue34;
  ESLintCommunityESLintUtils2232.getStringIfConstant = getStringIfConstant44;
  ESLintCommunityESLintUtils2232.hasSideEffect = hasSideEffect44;
  ESLintCommunityESLintUtils2232.isParenthesized = isParenthesized44;
})(ESLintCommunityESLintUtils44 || (ESLintCommunityESLintUtils44 = {}));
var Construction44 = Data_exports34.taggedEnum();
Construction44.None();
a7({
  type: N7.union([NodeType44.FunctionExpression, NodeType44.ArrowFunctionExpression]),
  parent: {
    type: NodeType44.Property,
    parent: {
      type: NodeType44.ObjectExpression
    }
  }
});
a7({
  type: N7.union([NodeType44.FunctionExpression, NodeType44.ArrowFunctionExpression]),
  parent: {
    type: NodeType44.MethodDefinition,
    parent: {
      type: NodeType44.ClassBody
    }
  }
});
a7({
  type: N7.union([NodeType44.FunctionExpression, NodeType44.ArrowFunctionExpression]),
  parent: {
    type: NodeType44.Property,
    parent: {
      type: NodeType44.ClassBody
    }
  }
});
var Function_exports244 = {};
__export54(Function_exports244, {
  SK: () => SK244,
  absurd: () => absurd244,
  apply: () => apply244,
  compose: () => compose333,
  constFalse: () => constFalse244,
  constNull: () => constNull244,
  constTrue: () => constTrue244,
  constUndefined: () => constUndefined244,
  constVoid: () => constVoid244,
  constant: () => constant244,
  dual: () => dual244,
  flip: () => flip244,
  flow: () => flow244,
  hole: () => hole244,
  identity: () => identity244,
  isFunction: () => isFunction432,
  pipe: () => pipe244,
  satisfies: () => satisfies244,
  tupled: () => tupled244,
  unsafeCoerce: () => unsafeCoerce244,
  untupled: () => untupled244
});
var isFunction432 = (input) => typeof input === "function";
var dual244 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a232, b232) {
        if (arguments.length >= 2) {
          return body(a232, b232);
        }
        return function(self2) {
          return body(self2, a232);
        };
      };
    case 3:
      return function(a232, b232, c232) {
        if (arguments.length >= 3) {
          return body(a232, b232, c232);
        }
        return function(self2) {
          return body(self2, a232, b232);
        };
      };
    case 4:
      return function(a232, b232, c232, d232) {
        if (arguments.length >= 4) {
          return body(a232, b232, c232, d232);
        }
        return function(self2) {
          return body(self2, a232, b232, c232);
        };
      };
    case 5:
      return function(a232, b232, c232, d232, e232) {
        if (arguments.length >= 5) {
          return body(a232, b232, c232, d232, e232);
        }
        return function(self2) {
          return body(self2, a232, b232, c232, d232);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply244 = (a232) => (self2) => self2(a232);
var identity244 = (a232) => a232;
var satisfies244 = () => (b232) => b232;
var unsafeCoerce244 = identity244;
var constant244 = (value) => () => value;
var constTrue244 = /* @__PURE__ */ constant244(true);
var constFalse244 = /* @__PURE__ */ constant244(false);
var constNull244 = /* @__PURE__ */ constant244(null);
var constUndefined244 = /* @__PURE__ */ constant244(void 0);
var constVoid244 = constUndefined244;
var flip244 = (f232) => (...b232) => (...a232) => f232(...a232)(...b232);
var compose333 = /* @__PURE__ */ dual244(2, (ab, bc) => (a232) => bc(ab(a232)));
var absurd244 = (_232) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled244 = (f232) => (a232) => f232(...a232);
var untupled244 = (f232) => (...a232) => f232(a232);
function pipe244(a232, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a232;
    case 2:
      return ab(a232);
    case 3:
      return bc(ab(a232));
    case 4:
      return cd(bc(ab(a232)));
    case 5:
      return de(cd(bc(ab(a232))));
    case 6:
      return ef(de(cd(bc(ab(a232)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a232))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a232)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a232))))))));
    default: {
      let ret = arguments[0];
      for (let i232 = 1; i232 < arguments.length; i232++) {
        ret = arguments[i232](ret);
      }
      return ret;
    }
  }
}
function flow244(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole244 = /* @__PURE__ */ unsafeCoerce244(absurd244);
var SK244 = (_232, b232) => b232;
var Array_exports23 = {};
__export54(Array_exports23, {
  Do: () => Do323,
  allocate: () => allocate23,
  append: () => append33,
  appendAll: () => appendAll233,
  bind: () => bind523,
  bindTo: () => bindTo523,
  cartesian: () => cartesian23,
  cartesianWith: () => cartesianWith23,
  chop: () => chop23,
  chunksOf: () => chunksOf23,
  contains: () => contains323,
  containsWith: () => containsWith323,
  copy: () => copy233,
  dedupe: () => dedupe23,
  dedupeAdjacent: () => dedupeAdjacent23,
  dedupeAdjacentWith: () => dedupeAdjacentWith23,
  dedupeWith: () => dedupeWith23,
  difference: () => difference23,
  differenceWith: () => differenceWith23,
  drop: () => drop233,
  dropRight: () => dropRight23,
  dropWhile: () => dropWhile23,
  empty: () => empty923,
  every: () => every323,
  extend: () => extend23,
  filter: () => filter323,
  filterMap: () => filterMap323,
  filterMapWhile: () => filterMapWhile23,
  findFirst: () => findFirst223,
  findFirstIndex: () => findFirstIndex23,
  findLast: () => findLast23,
  findLastIndex: () => findLastIndex23,
  flatMap: () => flatMap323,
  flatMapNullable: () => flatMapNullable323,
  flatten: () => flatten323,
  forEach: () => forEach333,
  fromIterable: () => fromIterable423,
  fromNullable: () => fromNullable323,
  fromOption: () => fromOption223,
  fromRecord: () => fromRecord23,
  get: () => get54,
  getEquivalence: () => getEquivalence423,
  getLefts: () => getLefts23,
  getOrder: () => getOrder323,
  getRights: () => getRights23,
  getSomes: () => getSomes23,
  group: () => group23,
  groupBy: () => groupBy23,
  groupWith: () => groupWith23,
  head: () => head33,
  headNonEmpty: () => headNonEmpty233,
  init: () => init23,
  initNonEmpty: () => initNonEmpty23,
  insertAt: () => insertAt23,
  intersection: () => intersection23,
  intersectionWith: () => intersectionWith23,
  intersperse: () => intersperse23,
  isArray: () => isArray23,
  isEmptyArray: () => isEmptyArray23,
  isEmptyReadonlyArray: () => isEmptyReadonlyArray23,
  isNonEmptyArray: () => isNonEmptyArray223,
  isNonEmptyReadonlyArray: () => isNonEmptyReadonlyArray23,
  join: () => join24,
  last: () => last23,
  lastNonEmpty: () => lastNonEmpty23,
  length: () => length33,
  let: () => let_523,
  liftEither: () => liftEither23,
  liftNullable: () => liftNullable323,
  liftOption: () => liftOption23,
  liftPredicate: () => liftPredicate323,
  make: () => make1023,
  makeBy: () => makeBy23,
  map: () => map323,
  mapAccum: () => mapAccum23,
  match: () => match423,
  matchLeft: () => matchLeft23,
  matchRight: () => matchRight23,
  max: () => max223,
  min: () => min223,
  modify: () => modify23,
  modifyNonEmptyHead: () => modifyNonEmptyHead23,
  modifyNonEmptyLast: () => modifyNonEmptyLast23,
  modifyOption: () => modifyOption23,
  of: () => of233,
  partition: () => partition23,
  partitionMap: () => partitionMap323,
  prepend: () => prepend233,
  prependAll: () => prependAll23,
  range: () => range23,
  reduce: () => reduce333,
  reduceRight: () => reduceRight23,
  remove: () => remove33,
  replace: () => replace223,
  replaceOption: () => replaceOption23,
  replicate: () => replicate23,
  reverse: () => reverse333,
  rotate: () => rotate23,
  scan: () => scan23,
  scanRight: () => scanRight23,
  separate: () => separate23,
  setNonEmptyHead: () => setNonEmptyHead23,
  setNonEmptyLast: () => setNonEmptyLast23,
  some: () => some723,
  sort: () => sort23,
  sortBy: () => sortBy23,
  sortWith: () => sortWith23,
  span: () => span23,
  split: () => split23,
  splitAt: () => splitAt23,
  splitNonEmptyAt: () => splitNonEmptyAt23,
  splitWhere: () => splitWhere23,
  tail: () => tail33,
  tailNonEmpty: () => tailNonEmpty233,
  take: () => take23,
  takeRight: () => takeRight23,
  takeWhile: () => takeWhile23,
  unappend: () => unappend23,
  unfold: () => unfold23,
  union: () => union43,
  unionWith: () => unionWith23,
  unprepend: () => unprepend23,
  unsafeGet: () => unsafeGet33,
  unzip: () => unzip23,
  zip: () => zip23,
  zipWith: () => zipWith323
});
var make633 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var array333 = (item) => make633((self2, that) => {
  if (self2.length !== that.length) {
    return false;
  }
  for (let i232 = 0; i232 < self2.length; i232++) {
    const isEq = item(self2[i232], that[i232]);
    if (!isEq) {
      return false;
    }
  }
  return true;
});
var let_344 = (map522) => dual244(3, (self2, name22, f232) => map522(self2, (a232) => Object.assign({}, a232, {
  [name22]: f232(a232)
})));
var bindTo344 = (map522) => dual244(2, (self2, name22) => map522(self2, (a232) => ({
  [name22]: a232
})));
var bind344 = (map522, flatMap522) => dual244(3, (self2, name22, f232) => flatMap522(self2, (a232) => map522(f232(a232), (b232) => Object.assign({}, a232, {
  [name22]: b232
}))));
var moduleVersion244 = "3.2.8";
var getCurrentVersion244 = () => moduleVersion244;
var globalStoreId244 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion244()}`);
if (!(globalStoreId244 in globalThis)) {
  globalThis[globalStoreId244] = /* @__PURE__ */ new Map();
}
var globalStore244 = globalThis[globalStoreId244];
var globalValue244 = (id, compute) => {
  if (!globalStore244.has(id)) {
    globalStore244.set(id, compute());
  }
  return globalStore244.get(id);
};
var Predicate_exports244 = {};
__export54(Predicate_exports244, {
  all: () => all333,
  and: () => and233,
  compose: () => compose423,
  eqv: () => eqv233,
  every: () => every233,
  hasProperty: () => hasProperty244,
  implies: () => implies233,
  isBigInt: () => isBigInt233,
  isBoolean: () => isBoolean233,
  isDate: () => isDate233,
  isError: () => isError233,
  isFunction: () => isFunction523,
  isIterable: () => isIterable233,
  isMap: () => isMap233,
  isNever: () => isNever233,
  isNotNull: () => isNotNull233,
  isNotNullable: () => isNotNullable233,
  isNotUndefined: () => isNotUndefined233,
  isNull: () => isNull233,
  isNullable: () => isNullable244,
  isNumber: () => isNumber233,
  isObject: () => isObject244,
  isPromise: () => isPromise233,
  isPromiseLike: () => isPromiseLike233,
  isReadonlyRecord: () => isReadonlyRecord233,
  isRecord: () => isRecord233,
  isSet: () => isSet233,
  isString: () => isString233,
  isSymbol: () => isSymbol233,
  isTagged: () => isTagged233,
  isTruthy: () => isTruthy233,
  isUint8Array: () => isUint8Array233,
  isUndefined: () => isUndefined233,
  isUnknown: () => isUnknown233,
  mapInput: () => mapInput233,
  nand: () => nand233,
  nor: () => nor233,
  not: () => not233,
  or: () => or233,
  product: () => product333,
  productMany: () => productMany333,
  some: () => some433,
  struct: () => struct433,
  tuple: () => tuple333,
  xor: () => xor233
});
var mapInput233 = /* @__PURE__ */ dual244(2, (self2, f232) => (b232) => self2(f232(b232)));
var isTruthy233 = (input) => !!input;
var isSet233 = (input) => input instanceof Set;
var isMap233 = (input) => input instanceof Map;
var isString233 = (input) => typeof input === "string";
var isNumber233 = (input) => typeof input === "number";
var isBoolean233 = (input) => typeof input === "boolean";
var isBigInt233 = (input) => typeof input === "bigint";
var isSymbol233 = (input) => typeof input === "symbol";
var isFunction523 = isFunction432;
var isUndefined233 = (input) => input === void 0;
var isNotUndefined233 = (input) => input !== void 0;
var isNull233 = (input) => input === null;
var isNotNull233 = (input) => input !== null;
var isNever233 = (_232) => false;
var isUnknown233 = (_232) => true;
var isRecordOrArray244 = (input) => typeof input === "object" && input !== null;
var isObject244 = (input) => isRecordOrArray244(input) || isFunction523(input);
var hasProperty244 = /* @__PURE__ */ dual244(2, (self2, property) => isObject244(self2) && property in self2);
var isTagged233 = /* @__PURE__ */ dual244(2, (self2, tag) => hasProperty244(self2, "_tag") && self2["_tag"] === tag);
var isNullable244 = (input) => input === null || input === void 0;
var isNotNullable233 = (input) => input !== null && input !== void 0;
var isError233 = (input) => input instanceof Error;
var isUint8Array233 = (input) => input instanceof Uint8Array;
var isDate233 = (input) => input instanceof Date;
var isIterable233 = (input) => hasProperty244(input, Symbol.iterator);
var isRecord233 = (input) => isRecordOrArray244(input) && !Array.isArray(input);
var isReadonlyRecord233 = isRecord233;
var isPromise233 = (input) => hasProperty244(input, "then") && "catch" in input && isFunction523(input.then) && isFunction523(input.catch);
var isPromiseLike233 = (input) => hasProperty244(input, "then") && isFunction523(input.then);
var compose423 = /* @__PURE__ */ dual244(2, (ab, bc) => (a232) => ab(a232) && bc(a232));
var product333 = (self2, that) => ([a232, b232]) => self2(a232) && that(b232);
var all333 = (collection) => {
  return (as422) => {
    let collectionIndex = 0;
    for (const p232 of collection) {
      if (collectionIndex >= as422.length) {
        break;
      }
      if (p232(as422[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany333 = (self2, collection) => {
  const rest = all333(collection);
  return ([head222, ...tail222]) => self2(head222) === false ? false : rest(tail222);
};
var tuple333 = (...elements) => all333(elements);
var struct433 = (fields) => {
  const keys422 = Object.keys(fields);
  return (a232) => {
    for (const key of keys422) {
      if (!fields[key](a232[key])) {
        return false;
      }
    }
    return true;
  };
};
var not233 = (self2) => (a232) => !self2(a232);
var or233 = /* @__PURE__ */ dual244(2, (self2, that) => (a232) => self2(a232) || that(a232));
var and233 = /* @__PURE__ */ dual244(2, (self2, that) => (a232) => self2(a232) && that(a232));
var xor233 = /* @__PURE__ */ dual244(2, (self2, that) => (a232) => self2(a232) !== that(a232));
var eqv233 = /* @__PURE__ */ dual244(2, (self2, that) => (a232) => self2(a232) === that(a232));
var implies233 = /* @__PURE__ */ dual244(2, (self2, that) => (a232) => self2(a232) ? that(a232) : true);
var nor233 = /* @__PURE__ */ dual244(2, (self2, that) => (a232) => !(self2(a232) || that(a232)));
var nand233 = /* @__PURE__ */ dual244(2, (self2, that) => (a232) => !(self2(a232) && that(a232)));
var every233 = (collection) => (a232) => {
  for (const p232 of collection) {
    if (!p232(a232)) {
      return false;
    }
  }
  return true;
};
var some433 = (collection) => (a232) => {
  for (const p232 of collection) {
    if (p232(a232)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage244 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId244 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind244 = (u232) => isObject244(u232) && GenKindTypeId244 in u232;
var GenKindImpl244 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity244;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId244] = GenKindTypeId244;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen333(this);
  }
};
var SingleShotGen333 = class _SingleShotGen523 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a232) {
    return this.called ? {
      value: a232,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a232) {
    return {
      value: a232,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e232) {
    throw e232;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen523(this.self);
  }
};
var adapter344 = () => function() {
  let x232 = arguments[0];
  for (let i232 = 1; i232 < arguments.length; i232++) {
    x232 = arguments[i232](x232);
  }
  return new GenKindImpl244(x232);
};
var defaultIncHi244 = 335903614;
var defaultIncLo244 = 4150755663;
var MUL_HI244 = 1481765933 >>> 0;
var MUL_LO244 = 1284865837 >>> 0;
var BIT_53244 = 9007199254740992;
var BIT_27244 = 134217728;
var PCGRandom244 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable244(seedLo) && isNullable244(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable244(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable244(incLo) && isNullable244(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo244;
      incHi = this._state ? this._state[2] : defaultIncHi244;
    } else if (isNullable244(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add64244(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max322) {
    if (!max322) {
      return this._next();
    }
    max322 = max322 >>> 0;
    if ((max322 & max322 - 1) === 0) {
      return this._next() & max322 - 1;
    }
    let num = 0;
    const skew = (-max322 >>> 0) % max322 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max322;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_27244 + lo) / BIT_53244;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul64244(this._state, oldHi, oldLo, MUL_HI244, MUL_LO244);
    add64244(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul64244(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add64244(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId244 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap244 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId244]() {
    return this.#value;
  }
};
function yieldWrapGet244(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId244 in self2) {
    return self2[YieldWrapTypeId244]();
  }
  throw new Error(getBugErrorMessage244("yieldWrapGet"));
}
var structuralRegionState244 = /* @__PURE__ */ globalValue244("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache244 = /* @__PURE__ */ globalValue244(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr244 = /* @__PURE__ */ globalValue244(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom244());
var symbol344 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash244 = (self2) => {
  if (structuralRegionState244.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number244(self2);
    case "bigint":
      return string244(self2.toString(10));
    case "boolean":
      return string244(String(self2));
    case "symbol":
      return string244(String(self2));
    case "string":
      return string244(self2);
    case "undefined":
      return string244("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string244("null");
      } else if (self2 instanceof Date) {
        return hash244(self2.toISOString());
      } else if (isHash244(self2)) {
        return self2[symbol344]();
      } else {
        return random244(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random244 = (self2) => {
  if (!randomHashCache244.has(self2)) {
    randomHashCache244.set(self2, number244(pcgr244.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache244.get(self2);
};
var combine333 = (b232) => (self2) => self2 * 53 ^ b232;
var optimize244 = (n232) => n232 & 3221225471 | n232 >>> 1 & 1073741824;
var isHash244 = (u232) => hasProperty244(u232, symbol344);
var number244 = (n232) => {
  if (n232 !== n232 || n232 === Infinity) {
    return 0;
  }
  let h232 = n232 | 0;
  if (h232 !== n232) {
    h232 ^= n232 * 4294967295;
  }
  while (n232 > 4294967295) {
    h232 ^= n232 /= 4294967295;
  }
  return optimize244(n232);
};
var string244 = (str) => {
  let h232 = 5381, i232 = str.length;
  while (i232) {
    h232 = h232 * 33 ^ str.charCodeAt(--i232);
  }
  return optimize244(h232);
};
var cached244 = function() {
  if (arguments.length === 1) {
    const self3 = arguments[0];
    return function(hash522) {
      Object.defineProperty(self3, symbol344, {
        value() {
          return hash522;
        },
        enumerable: false
      });
      return hash522;
    };
  }
  const self2 = arguments[0];
  const hash422 = arguments[1];
  Object.defineProperty(self2, symbol344, {
    value() {
      return hash422;
    },
    enumerable: false
  });
  return hash422;
};
var symbol423 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals244() {
  if (arguments.length === 1) {
    return (self2) => compareBoth244(self2, arguments[0]);
  }
  return compareBoth244(arguments[0], arguments[1]);
}
function compareBoth244(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual244(self2) && isEqual244(that)) {
        if (hash244(self2) === hash244(that) && self2[symbol423](that)) {
          return true;
        } else {
          return structuralRegionState244.enabled && structuralRegionState244.tester ? structuralRegionState244.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState244.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v232, i232) => compareBoth244(v232, that[i232]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth244(self2[key], that[key]))) {
              return structuralRegionState244.tester ? structuralRegionState244.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState244.tester ? structuralRegionState244.tester(self2, that) : false;
    }
  }
  return structuralRegionState244.enabled && structuralRegionState244.tester ? structuralRegionState244.tester(self2, that) : false;
}
var isEqual244 = (u232) => hasProperty244(u232, symbol423);
var equivalence244 = () => equals244;
var NodeInspectSymbol244 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON244 = (x232) => {
  if (hasProperty244(x232, "toJSON") && isFunction523(x232["toJSON"]) && x232["toJSON"].length === 0) {
    return x232.toJSON();
  } else if (Array.isArray(x232)) {
    return x232.map(toJSON244);
  }
  return x232;
};
var format244 = (x232) => JSON.stringify(x232, null, 2);
var pipeArguments244 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i232 = 0, len = args.length; i232 < len; i232++) {
        ret = args[i232](ret);
      }
      return ret;
    }
  }
};
var EffectTypeId333 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId244 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId244 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId244 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance244 = {
  /* c8 ignore next */
  _R: (_232) => _232,
  /* c8 ignore next */
  _E: (_232) => _232,
  /* c8 ignore next */
  _A: (_232) => _232,
  _V: /* @__PURE__ */ getCurrentVersion244()
};
var sinkVariance244 = {
  /* c8 ignore next */
  _A: (_232) => _232,
  /* c8 ignore next */
  _In: (_232) => _232,
  /* c8 ignore next */
  _L: (_232) => _232,
  /* c8 ignore next */
  _E: (_232) => _232,
  /* c8 ignore next */
  _R: (_232) => _232
};
var channelVariance244 = {
  /* c8 ignore next */
  _Env: (_232) => _232,
  /* c8 ignore next */
  _InErr: (_232) => _232,
  /* c8 ignore next */
  _InElem: (_232) => _232,
  /* c8 ignore next */
  _InDone: (_232) => _232,
  /* c8 ignore next */
  _OutErr: (_232) => _232,
  /* c8 ignore next */
  _OutElem: (_232) => _232,
  /* c8 ignore next */
  _OutDone: (_232) => _232
};
var EffectPrototype244 = {
  [EffectTypeId333]: effectVariance244,
  [StreamTypeId244]: effectVariance244,
  [SinkTypeId244]: sinkVariance244,
  [ChannelTypeId244]: channelVariance244,
  [symbol423](that) {
    return this === that;
  },
  [symbol344]() {
    return cached244(this, random244(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen333(new YieldWrap244(this));
  },
  pipe() {
    return pipeArguments244(this, arguments);
  }
};
var TypeId633 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto344 = {
  ...EffectPrototype244,
  [TypeId633]: {
    _A: (_232) => _232
  },
  [NodeInspectSymbol244]() {
    return this.toJSON();
  },
  toString() {
    return format244(this.toJSON());
  }
};
var SomeProto244 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto344), {
  _tag: "Some",
  _op: "Some",
  [symbol423](that) {
    return isOption344(that) && isSome344(that) && equals244(this.value, that.value);
  },
  [symbol344]() {
    return cached244(this, combine333(hash244(this._tag))(hash244(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON244(this.value)
    };
  }
});
var NoneHash244 = /* @__PURE__ */ hash244("None");
var NoneProto244 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto344), {
  _tag: "None",
  _op: "None",
  [symbol423](that) {
    return isOption344(that) && isNone344(that);
  },
  [symbol344]() {
    return NoneHash244;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption344 = (input) => hasProperty244(input, TypeId633);
var isNone344 = (fa) => fa._tag === "None";
var isSome344 = (fa) => fa._tag === "Some";
var none344 = /* @__PURE__ */ Object.create(NoneProto244);
var some523 = (value) => {
  const a232 = Object.create(SomeProto244);
  a232.value = value;
  return a232;
};
var TypeId723 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto423 = {
  ...EffectPrototype244,
  [TypeId723]: {
    _R: (_232) => _232
  },
  [NodeInspectSymbol244]() {
    return this.toJSON();
  },
  toString() {
    return format244(this.toJSON());
  }
};
var RightProto244 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto423), {
  _tag: "Right",
  _op: "Right",
  [symbol423](that) {
    return isEither244(that) && isRight244(that) && equals244(this.right, that.right);
  },
  [symbol344]() {
    return combine333(hash244(this._tag))(hash244(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON244(this.right)
    };
  }
});
var LeftProto244 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto423), {
  _tag: "Left",
  _op: "Left",
  [symbol423](that) {
    return isEither244(that) && isLeft244(that) && equals244(this.left, that.left);
  },
  [symbol344]() {
    return combine333(hash244(this._tag))(hash244(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON244(this.left)
    };
  }
});
var isEither244 = (input) => hasProperty244(input, TypeId723);
var isLeft244 = (ma) => ma._tag === "Left";
var isRight244 = (ma) => ma._tag === "Right";
var left333 = (left522) => {
  const a232 = Object.create(LeftProto244);
  a232.left = left522;
  return a232;
};
var right333 = (right522) => {
  const a232 = Object.create(RightProto244);
  a232.right = right522;
  return a232;
};
var getLeft344 = (self2) => isRight244(self2) ? none344 : some523(self2.left);
var getRight344 = (self2) => isLeft244(self2) ? none344 : some523(self2.right);
var isLeft323 = isLeft244;
var isRight323 = isRight244;
var isNonEmptyArray33 = (self2) => self2.length > 0;
var Option_exports244 = {};
__export54(Option_exports244, {
  Do: () => Do244,
  TypeId: () => TypeId823,
  all: () => all423,
  andThen: () => andThen244,
  ap: () => ap244,
  as: () => as244,
  asVoid: () => asVoid244,
  bind: () => bind423,
  bindTo: () => bindTo423,
  composeK: () => composeK244,
  contains: () => contains244,
  containsWith: () => containsWith244,
  exists: () => exists244,
  filter: () => filter244,
  filterMap: () => filterMap244,
  firstSomeOf: () => firstSomeOf244,
  flatMap: () => flatMap244,
  flatMapNullable: () => flatMapNullable244,
  flatten: () => flatten244,
  fromIterable: () => fromIterable333,
  fromNullable: () => fromNullable244,
  gen: () => gen244,
  getEquivalence: () => getEquivalence333,
  getLeft: () => getLeft423,
  getOrElse: () => getOrElse244,
  getOrNull: () => getOrNull244,
  getOrThrow: () => getOrThrow244,
  getOrThrowWith: () => getOrThrowWith244,
  getOrUndefined: () => getOrUndefined244,
  getOrder: () => getOrder244,
  getRight: () => getRight423,
  isNone: () => isNone423,
  isOption: () => isOption423,
  isSome: () => isSome423,
  let: () => let_423,
  lift2: () => lift2244,
  liftNullable: () => liftNullable244,
  liftPredicate: () => liftPredicate244,
  liftThrowable: () => liftThrowable244,
  map: () => map244,
  match: () => match35,
  none: () => none423,
  orElse: () => orElse244,
  orElseEither: () => orElseEither244,
  orElseSome: () => orElseSome244,
  partitionMap: () => partitionMap244,
  product: () => product423,
  productMany: () => productMany423,
  reduceCompact: () => reduceCompact244,
  some: () => some623,
  tap: () => tap244,
  toArray: () => toArray244,
  toRefinement: () => toRefinement244,
  void: () => void_244,
  zipLeft: () => zipLeft244,
  zipRight: () => zipRight244,
  zipWith: () => zipWith244
});
var make823 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var number323 = /* @__PURE__ */ make823((self2, that) => self2 < that ? -1 : 1);
var combineMany23 = /* @__PURE__ */ dual244(2, (self2, collection) => make823((a1, a232) => {
  let out = self2(a1, a232);
  if (out !== 0) {
    return out;
  }
  for (const O232 of collection) {
    out = O232(a1, a232);
    if (out !== 0) {
      return out;
    }
  }
  return out;
}));
var empty833 = () => make823(() => 0);
var combineAll23 = (collection) => combineMany23(empty833(), collection);
var mapInput323 = /* @__PURE__ */ dual244(2, (self2, f232) => make823((b1, b232) => self2(f232(b1), f232(b232))));
var array423 = (O232) => make823((self2, that) => {
  const aLen = self2.length;
  const bLen = that.length;
  const len = Math.min(aLen, bLen);
  for (let i232 = 0; i232 < len; i232++) {
    const o232 = O232(self2[i232], that[i232]);
    if (o232 !== 0) {
      return o232;
    }
  }
  return number323(aLen, bLen);
});
var min33 = (O232) => dual244(2, (self2, that) => self2 === that || O232(self2, that) < 1 ? self2 : that);
var max33 = (O232) => dual244(2, (self2, that) => self2 === that || O232(self2, that) > -1 ? self2 : that);
var TypeId823 = /* @__PURE__ */ Symbol.for("effect/Option");
var none423 = () => none344;
var some623 = some523;
var isOption423 = isOption344;
var isNone423 = isNone344;
var isSome423 = isSome344;
var match35 = /* @__PURE__ */ dual244(2, (self2, {
  onNone,
  onSome
}) => isNone423(self2) ? onNone() : onSome(self2.value));
var toRefinement244 = (f232) => (a232) => isSome423(f232(a232));
var fromIterable333 = (collection) => {
  for (const a232 of collection) {
    return some623(a232);
  }
  return none423();
};
var getRight423 = getRight344;
var getLeft423 = getLeft344;
var getOrElse244 = /* @__PURE__ */ dual244(2, (self2, onNone) => isNone423(self2) ? onNone() : self2.value);
var orElse244 = /* @__PURE__ */ dual244(2, (self2, that) => isNone423(self2) ? that() : self2);
var orElseSome244 = /* @__PURE__ */ dual244(2, (self2, onNone) => isNone423(self2) ? some623(onNone()) : self2);
var orElseEither244 = /* @__PURE__ */ dual244(2, (self2, that) => isNone423(self2) ? map244(that(), right333) : map244(self2, left333));
var firstSomeOf244 = (collection) => {
  let out = none423();
  for (out of collection) {
    if (isSome423(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable244 = (nullableValue) => nullableValue == null ? none423() : some623(nullableValue);
var liftNullable244 = (f232) => (...a232) => fromNullable244(f232(...a232));
var getOrNull244 = /* @__PURE__ */ getOrElse244(constNull244);
var getOrUndefined244 = /* @__PURE__ */ getOrElse244(constUndefined244);
var liftThrowable244 = (f232) => (...a232) => {
  try {
    return some623(f232(...a232));
  } catch (e232) {
    return none423();
  }
};
var getOrThrowWith244 = /* @__PURE__ */ dual244(2, (self2, onNone) => {
  if (isSome423(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow244 = /* @__PURE__ */ getOrThrowWith244(() => new Error("getOrThrow called on a None"));
var map244 = /* @__PURE__ */ dual244(2, (self2, f232) => isNone423(self2) ? none423() : some623(f232(self2.value)));
var as244 = /* @__PURE__ */ dual244(2, (self2, b232) => map244(self2, () => b232));
var asVoid244 = /* @__PURE__ */ as244(void 0);
var void_244 = /* @__PURE__ */ some623(void 0);
var flatMap244 = /* @__PURE__ */ dual244(2, (self2, f232) => isNone423(self2) ? none423() : f232(self2.value));
var andThen244 = /* @__PURE__ */ dual244(2, (self2, f232) => flatMap244(self2, (a232) => {
  const b232 = isFunction432(f232) ? f232(a232) : f232;
  return isOption423(b232) ? b232 : some623(b232);
}));
var flatMapNullable244 = /* @__PURE__ */ dual244(2, (self2, f232) => isNone423(self2) ? none423() : fromNullable244(f232(self2.value)));
var flatten244 = /* @__PURE__ */ flatMap244(identity244);
var zipRight244 = /* @__PURE__ */ dual244(2, (self2, that) => flatMap244(self2, () => that));
var composeK244 = /* @__PURE__ */ dual244(2, (afb, bfc) => (a232) => flatMap244(afb(a232), bfc));
var zipLeft244 = /* @__PURE__ */ dual244(2, (self2, that) => tap244(self2, () => that));
var tap244 = /* @__PURE__ */ dual244(2, (self2, f232) => flatMap244(self2, (a232) => map244(f232(a232), () => a232)));
var product423 = (self2, that) => isSome423(self2) && isSome423(that) ? some623([self2.value, that.value]) : none423();
var productMany423 = (self2, collection) => {
  if (isNone423(self2)) {
    return none423();
  }
  const out = [self2.value];
  for (const o232 of collection) {
    if (isNone423(o232)) {
      return none423();
    }
    out.push(o232.value);
  }
  return some623(out);
};
var all423 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o232 of input) {
      if (isNone423(o232)) {
        return none423();
      }
      out2.push(o232.value);
    }
    return some623(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o232 = input[key];
    if (isNone423(o232)) {
      return none423();
    }
    out[key] = o232.value;
  }
  return some623(out);
};
var zipWith244 = /* @__PURE__ */ dual244(3, (self2, that, f232) => map244(product423(self2, that), ([a232, b232]) => f232(a232, b232)));
var ap244 = /* @__PURE__ */ dual244(2, (self2, that) => zipWith244(self2, that, (f232, a232) => f232(a232)));
var reduceCompact244 = /* @__PURE__ */ dual244(3, (self2, b232, f232) => {
  let out = b232;
  for (const oa of self2) {
    if (isSome423(oa)) {
      out = f232(out, oa.value);
    }
  }
  return out;
});
var toArray244 = (self2) => isNone423(self2) ? [] : [self2.value];
var partitionMap244 = /* @__PURE__ */ dual244(2, (self2, f232) => {
  if (isNone423(self2)) {
    return [none423(), none423()];
  }
  const e232 = f232(self2.value);
  return isLeft244(e232) ? [some623(e232.left), none423()] : [none423(), some623(e232.right)];
});
var filterMap244 = /* @__PURE__ */ dual244(2, (self2, f232) => isNone423(self2) ? none423() : f232(self2.value));
var filter244 = /* @__PURE__ */ dual244(2, (self2, predicate) => filterMap244(self2, (b232) => predicate(b232) ? some523(b232) : none344));
var getEquivalence333 = (isEquivalent) => make633((x232, y232) => x232 === y232 || (isNone423(x232) ? isNone423(y232) : isNone423(y232) ? false : isEquivalent(x232.value, y232.value)));
var getOrder244 = (O232) => make823((self2, that) => isSome423(self2) ? isSome423(that) ? O232(self2.value, that.value) : 1 : -1);
var lift2244 = (f232) => dual244(2, (self2, that) => zipWith244(self2, that, f232));
var liftPredicate244 = (predicate) => (b232) => predicate(b232) ? some623(b232) : none423();
var containsWith244 = (isEquivalent) => dual244(2, (self2, a232) => isNone423(self2) ? false : isEquivalent(self2.value, a232));
var _equivalence333 = /* @__PURE__ */ equivalence244();
var contains244 = /* @__PURE__ */ containsWith244(_equivalence333);
var exists244 = /* @__PURE__ */ dual244(2, (self2, refinement) => isNone423(self2) ? false : refinement(self2.value));
var bindTo423 = /* @__PURE__ */ bindTo344(map244);
var let_423 = /* @__PURE__ */ let_344(map244);
var bind423 = /* @__PURE__ */ bind344(map244, flatMap244);
var Do244 = /* @__PURE__ */ some623({});
var adapter423 = /* @__PURE__ */ adapter344();
var gen244 = (f232) => {
  const iterator = f232(adapter423);
  let state = iterator.next();
  if (state.done) {
    return some623(state.value);
  } else {
    let current = state.value;
    if (isGenKind244(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet244(current);
    }
    if (isNone423(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind244(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet244(current);
        }
        if (isNone423(current)) {
          return current;
        }
      }
    }
    return some623(state.value);
  }
};
var make923 = (...elements) => elements;
var findFirst33 = /* @__PURE__ */ dual244(2, (self2, f232) => {
  let i232 = 0;
  for (const a232 of self2) {
    const o232 = f232(a232, i232);
    if (isBoolean233(o232)) {
      if (o232) {
        return some623(a232);
      }
    } else {
      if (isSome423(o232)) {
        return o232;
      }
    }
    i232++;
  }
  return none423();
});
var collect23 = /* @__PURE__ */ dual244(2, (self2, f232) => {
  const out = [];
  for (const key of keys233(self2)) {
    out.push(f232(key, self2[key]));
  }
  return out;
});
var toEntries23 = /* @__PURE__ */ collect23((key, value) => [key, value]);
var keys233 = (self2) => Object.keys(self2);
var make1023 = (...elements) => elements;
var allocate23 = (n232) => new Array(n232);
var makeBy23 = (n232, f232) => {
  const max322 = Math.max(1, Math.floor(n232));
  const out = new Array(max322);
  for (let i232 = 0; i232 < max322; i232++) {
    out[i232] = f232(i232);
  }
  return out;
};
var range23 = (start, end) => start <= end ? makeBy23(end - start + 1, (i232) => start + i232) : [start];
var replicate23 = /* @__PURE__ */ dual244(2, (a232, n232) => makeBy23(n232, () => a232));
var fromIterable423 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var fromRecord23 = toEntries23;
var fromOption223 = toArray244;
var match423 = /* @__PURE__ */ dual244(2, (self2, {
  onEmpty,
  onNonEmpty
}) => isNonEmptyReadonlyArray23(self2) ? onNonEmpty(self2) : onEmpty());
var matchLeft23 = /* @__PURE__ */ dual244(2, (self2, {
  onEmpty,
  onNonEmpty
}) => isNonEmptyReadonlyArray23(self2) ? onNonEmpty(headNonEmpty233(self2), tailNonEmpty233(self2)) : onEmpty());
var matchRight23 = /* @__PURE__ */ dual244(2, (self2, {
  onEmpty,
  onNonEmpty
}) => isNonEmptyReadonlyArray23(self2) ? onNonEmpty(initNonEmpty23(self2), lastNonEmpty23(self2)) : onEmpty());
var prepend233 = /* @__PURE__ */ dual244(2, (self2, head222) => [head222, ...self2]);
var prependAll23 = /* @__PURE__ */ dual244(2, (self2, that) => fromIterable423(that).concat(fromIterable423(self2)));
var append33 = /* @__PURE__ */ dual244(2, (self2, last222) => [...self2, last222]);
var appendAll233 = /* @__PURE__ */ dual244(2, (self2, that) => fromIterable423(self2).concat(fromIterable423(that)));
var scan23 = /* @__PURE__ */ dual244(3, (self2, b232, f232) => {
  const out = [b232];
  let i232 = 0;
  for (const a232 of self2) {
    out[i232 + 1] = f232(out[i232], a232);
    i232++;
  }
  return out;
});
var scanRight23 = /* @__PURE__ */ dual244(3, (self2, b232, f232) => {
  const input = fromIterable423(self2);
  const out = new Array(input.length + 1);
  out[input.length] = b232;
  for (let i232 = input.length - 1; i232 >= 0; i232--) {
    out[i232] = f232(out[i232 + 1], input[i232]);
  }
  return out;
});
var isArray23 = Array.isArray;
var isEmptyArray23 = (self2) => self2.length === 0;
var isEmptyReadonlyArray23 = isEmptyArray23;
var isNonEmptyArray223 = isNonEmptyArray33;
var isNonEmptyReadonlyArray23 = isNonEmptyArray33;
var length33 = (self2) => self2.length;
var isOutOfBound23 = (i232, as422) => i232 < 0 || i232 >= as422.length;
var clamp23 = (i232, as422) => Math.floor(Math.min(Math.max(0, i232), as422.length));
var get54 = /* @__PURE__ */ dual244(2, (self2, index) => {
  const i232 = Math.floor(index);
  return isOutOfBound23(i232, self2) ? none423() : some623(self2[i232]);
});
var unsafeGet33 = /* @__PURE__ */ dual244(2, (self2, index) => {
  const i232 = Math.floor(index);
  if (isOutOfBound23(i232, self2)) {
    throw new Error(`Index ${i232} out of bounds`);
  }
  return self2[i232];
});
var unprepend23 = (self2) => [headNonEmpty233(self2), tailNonEmpty233(self2)];
var unappend23 = (self2) => [initNonEmpty23(self2), lastNonEmpty23(self2)];
var head33 = /* @__PURE__ */ get54(0);
var headNonEmpty233 = /* @__PURE__ */ unsafeGet33(0);
var last23 = (self2) => isNonEmptyReadonlyArray23(self2) ? some623(lastNonEmpty23(self2)) : none423();
var lastNonEmpty23 = (self2) => self2[self2.length - 1];
var tail33 = (self2) => {
  const input = fromIterable423(self2);
  return isNonEmptyReadonlyArray23(input) ? some623(tailNonEmpty233(input)) : none423();
};
var tailNonEmpty233 = (self2) => self2.slice(1);
var init23 = (self2) => {
  const input = fromIterable423(self2);
  return isNonEmptyReadonlyArray23(input) ? some623(initNonEmpty23(input)) : none423();
};
var initNonEmpty23 = (self2) => self2.slice(0, -1);
var take23 = /* @__PURE__ */ dual244(2, (self2, n232) => {
  const input = fromIterable423(self2);
  return input.slice(0, clamp23(n232, input));
});
var takeRight23 = /* @__PURE__ */ dual244(2, (self2, n232) => {
  const input = fromIterable423(self2);
  const i232 = clamp23(n232, input);
  return i232 === 0 ? [] : input.slice(-i232);
});
var takeWhile23 = /* @__PURE__ */ dual244(2, (self2, predicate) => {
  let i232 = 0;
  const out = [];
  for (const a232 of self2) {
    if (!predicate(a232, i232)) {
      break;
    }
    out.push(a232);
    i232++;
  }
  return out;
});
var spanIndex23 = (self2, predicate) => {
  let i232 = 0;
  for (const a232 of self2) {
    if (!predicate(a232, i232)) {
      break;
    }
    i232++;
  }
  return i232;
};
var span23 = /* @__PURE__ */ dual244(2, (self2, predicate) => splitAt23(self2, spanIndex23(self2, predicate)));
var drop233 = /* @__PURE__ */ dual244(2, (self2, n232) => {
  const input = fromIterable423(self2);
  return input.slice(clamp23(n232, input), input.length);
});
var dropRight23 = /* @__PURE__ */ dual244(2, (self2, n232) => {
  const input = fromIterable423(self2);
  return input.slice(0, input.length - clamp23(n232, input));
});
var dropWhile23 = /* @__PURE__ */ dual244(2, (self2, predicate) => fromIterable423(self2).slice(spanIndex23(self2, predicate)));
var findFirstIndex23 = /* @__PURE__ */ dual244(2, (self2, predicate) => {
  let i232 = 0;
  for (const a232 of self2) {
    if (predicate(a232, i232)) {
      return some623(i232);
    }
    i232++;
  }
  return none423();
});
var findLastIndex23 = /* @__PURE__ */ dual244(2, (self2, predicate) => {
  const input = fromIterable423(self2);
  for (let i232 = input.length - 1; i232 >= 0; i232--) {
    if (predicate(input[i232], i232)) {
      return some623(i232);
    }
  }
  return none423();
});
var findFirst223 = findFirst33;
var findLast23 = /* @__PURE__ */ dual244(2, (self2, f232) => {
  const input = fromIterable423(self2);
  for (let i232 = input.length - 1; i232 >= 0; i232--) {
    const a232 = input[i232];
    const o232 = f232(a232, i232);
    if (isBoolean233(o232)) {
      if (o232) {
        return some623(a232);
      }
    } else {
      if (isSome423(o232)) {
        return o232;
      }
    }
  }
  return none423();
});
var insertAt23 = /* @__PURE__ */ dual244(3, (self2, i232, b232) => {
  const out = Array.from(self2);
  if (i232 < 0 || i232 > out.length) {
    return none423();
  }
  out.splice(i232, 0, b232);
  return some623(out);
});
var replace223 = /* @__PURE__ */ dual244(3, (self2, i232, b232) => modify23(self2, i232, () => b232));
var replaceOption23 = /* @__PURE__ */ dual244(3, (self2, i232, b232) => modifyOption23(self2, i232, () => b232));
var modify23 = /* @__PURE__ */ dual244(3, (self2, i232, f232) => getOrElse244(modifyOption23(self2, i232, f232), () => Array.from(self2)));
var modifyOption23 = /* @__PURE__ */ dual244(3, (self2, i232, f232) => {
  const out = Array.from(self2);
  if (isOutOfBound23(i232, out)) {
    return none423();
  }
  const next = f232(out[i232]);
  out[i232] = next;
  return some623(out);
});
var remove33 = /* @__PURE__ */ dual244(2, (self2, i232) => {
  const out = Array.from(self2);
  if (isOutOfBound23(i232, out)) {
    return out;
  }
  out.splice(i232, 1);
  return out;
});
var reverse333 = (self2) => Array.from(self2).reverse();
var sort23 = /* @__PURE__ */ dual244(2, (self2, O232) => {
  const out = Array.from(self2);
  out.sort(O232);
  return out;
});
var sortWith23 = /* @__PURE__ */ dual244(3, (self2, f232, order) => sort23(self2, mapInput323(order, f232)));
var sortBy23 = (...orders) => {
  const sortByAll = sort23(combineAll23(orders));
  return (self2) => {
    const input = fromIterable423(self2);
    if (isNonEmptyReadonlyArray23(input)) {
      return sortByAll(input);
    }
    return [];
  };
};
var zip23 = /* @__PURE__ */ dual244(2, (self2, that) => zipWith323(self2, that, make923));
var zipWith323 = /* @__PURE__ */ dual244(3, (self2, that, f232) => {
  const as422 = fromIterable423(self2);
  const bs = fromIterable423(that);
  if (isNonEmptyReadonlyArray23(as422) && isNonEmptyReadonlyArray23(bs)) {
    const out = [f232(headNonEmpty233(as422), headNonEmpty233(bs))];
    const len = Math.min(as422.length, bs.length);
    for (let i232 = 1; i232 < len; i232++) {
      out[i232] = f232(as422[i232], bs[i232]);
    }
    return out;
  }
  return [];
});
var unzip23 = (self2) => {
  const input = fromIterable423(self2);
  if (isNonEmptyReadonlyArray23(input)) {
    const fa = [input[0][0]];
    const fb = [input[0][1]];
    for (let i232 = 1; i232 < input.length; i232++) {
      fa[i232] = input[i232][0];
      fb[i232] = input[i232][1];
    }
    return [fa, fb];
  }
  return [[], []];
};
var intersperse23 = /* @__PURE__ */ dual244(2, (self2, middle) => {
  const input = fromIterable423(self2);
  if (isNonEmptyReadonlyArray23(input)) {
    const out = [headNonEmpty233(input)];
    const tail222 = tailNonEmpty233(input);
    for (let i232 = 0; i232 < tail222.length; i232++) {
      if (i232 < tail222.length) {
        out.push(middle);
      }
      out.push(tail222[i232]);
    }
    return out;
  }
  return [];
});
var modifyNonEmptyHead23 = /* @__PURE__ */ dual244(2, (self2, f232) => [f232(headNonEmpty233(self2)), ...tailNonEmpty233(self2)]);
var setNonEmptyHead23 = /* @__PURE__ */ dual244(2, (self2, b232) => modifyNonEmptyHead23(self2, () => b232));
var modifyNonEmptyLast23 = /* @__PURE__ */ dual244(2, (self2, f232) => append33(initNonEmpty23(self2), f232(lastNonEmpty23(self2))));
var setNonEmptyLast23 = /* @__PURE__ */ dual244(2, (self2, b232) => modifyNonEmptyLast23(self2, () => b232));
var rotate23 = /* @__PURE__ */ dual244(2, (self2, n232) => {
  const input = fromIterable423(self2);
  if (isNonEmptyReadonlyArray23(input)) {
    const len = input.length;
    const m232 = Math.round(n232) % len;
    if (isOutOfBound23(Math.abs(m232), input) || m232 === 0) {
      return copy233(input);
    }
    if (m232 < 0) {
      const [f232, s232] = splitNonEmptyAt23(input, -m232);
      return appendAll233(s232, f232);
    } else {
      return rotate23(self2, m232 - len);
    }
  }
  return [];
});
var containsWith323 = (isEquivalent) => dual244(2, (self2, a232) => {
  for (const i232 of self2) {
    if (isEquivalent(a232, i232)) {
      return true;
    }
  }
  return false;
});
var _equivalence423 = /* @__PURE__ */ equivalence244();
var contains323 = /* @__PURE__ */ containsWith323(_equivalence423);
var chop23 = /* @__PURE__ */ dual244(2, (self2, f232) => {
  const input = fromIterable423(self2);
  if (isNonEmptyReadonlyArray23(input)) {
    const [b232, rest] = f232(input);
    const out = [b232];
    let next = rest;
    while (isNonEmptyArray33(next)) {
      const [b322, rest2] = f232(next);
      out.push(b322);
      next = rest2;
    }
    return out;
  }
  return [];
});
var splitAt23 = /* @__PURE__ */ dual244(2, (self2, n232) => {
  const input = Array.from(self2);
  const _n = Math.floor(n232);
  if (isNonEmptyReadonlyArray23(input)) {
    if (_n >= 1) {
      return splitNonEmptyAt23(input, _n);
    }
    return [[], input];
  }
  return [input, []];
});
var splitNonEmptyAt23 = /* @__PURE__ */ dual244(2, (self2, n232) => {
  const _n = Math.max(1, Math.floor(n232));
  return _n >= self2.length ? [copy233(self2), []] : [prepend233(self2.slice(1, _n), headNonEmpty233(self2)), self2.slice(_n)];
});
var split23 = /* @__PURE__ */ dual244(2, (self2, n232) => {
  const input = fromIterable423(self2);
  return chunksOf23(input, Math.ceil(input.length / Math.floor(n232)));
});
var splitWhere23 = /* @__PURE__ */ dual244(2, (self2, predicate) => span23(self2, (a232, i232) => !predicate(a232, i232)));
var copy233 = (self2) => self2.slice();
var chunksOf23 = /* @__PURE__ */ dual244(2, (self2, n232) => {
  const input = fromIterable423(self2);
  if (isNonEmptyReadonlyArray23(input)) {
    return chop23(input, splitNonEmptyAt23(n232));
  }
  return [];
});
var groupWith23 = /* @__PURE__ */ dual244(2, (self2, isEquivalent) => chop23(self2, (as422) => {
  const h232 = headNonEmpty233(as422);
  const out = [h232];
  let i232 = 1;
  for (; i232 < as422.length; i232++) {
    const a232 = as422[i232];
    if (isEquivalent(a232, h232)) {
      out.push(a232);
    } else {
      break;
    }
  }
  return [out, as422.slice(i232)];
}));
var group23 = /* @__PURE__ */ groupWith23(/* @__PURE__ */ equivalence244());
var groupBy23 = /* @__PURE__ */ dual244(2, (self2, f232) => {
  const out = {};
  for (const a232 of self2) {
    const k232 = f232(a232);
    if (Object.prototype.hasOwnProperty.call(out, k232)) {
      out[k232].push(a232);
    } else {
      out[k232] = [a232];
    }
  }
  return out;
});
var unionWith23 = /* @__PURE__ */ dual244(3, (self2, that, isEquivalent) => {
  const a232 = fromIterable423(self2);
  const b232 = fromIterable423(that);
  if (isNonEmptyReadonlyArray23(a232)) {
    if (isNonEmptyReadonlyArray23(b232)) {
      const dedupe222 = dedupeWith23(isEquivalent);
      return dedupe222(appendAll233(a232, b232));
    }
    return a232;
  }
  return b232;
});
var union43 = /* @__PURE__ */ dual244(2, (self2, that) => unionWith23(self2, that, _equivalence423));
var intersectionWith23 = (isEquivalent) => {
  const has22 = containsWith323(isEquivalent);
  return dual244(2, (self2, that) => fromIterable423(self2).filter((a232) => has22(that, a232)));
};
var intersection23 = /* @__PURE__ */ intersectionWith23(_equivalence423);
var differenceWith23 = (isEquivalent) => {
  const has22 = containsWith323(isEquivalent);
  return dual244(2, (self2, that) => fromIterable423(self2).filter((a232) => !has22(that, a232)));
};
var difference23 = /* @__PURE__ */ differenceWith23(_equivalence423);
var empty923 = () => [];
var of233 = (a232) => [a232];
var map323 = /* @__PURE__ */ dual244(2, (self2, f232) => self2.map(f232));
var flatMap323 = /* @__PURE__ */ dual244(2, (self2, f232) => {
  if (isEmptyReadonlyArray23(self2)) {
    return [];
  }
  const out = [];
  for (let i232 = 0; i232 < self2.length; i232++) {
    const inner = f232(self2[i232], i232);
    for (let j232 = 0; j232 < inner.length; j232++) {
      out.push(inner[j232]);
    }
  }
  return out;
});
var flatten323 = /* @__PURE__ */ flatMap323(identity244);
var filterMap323 = /* @__PURE__ */ dual244(2, (self2, f232) => {
  const as422 = fromIterable423(self2);
  const out = [];
  for (let i232 = 0; i232 < as422.length; i232++) {
    const o232 = f232(as422[i232], i232);
    if (isSome423(o232)) {
      out.push(o232.value);
    }
  }
  return out;
});
var filterMapWhile23 = /* @__PURE__ */ dual244(2, (self2, f232) => {
  let i232 = 0;
  const out = [];
  for (const a232 of self2) {
    const b232 = f232(a232, i232);
    if (isSome423(b232)) {
      out.push(b232.value);
    } else {
      break;
    }
    i232++;
  }
  return out;
});
var partitionMap323 = /* @__PURE__ */ dual244(2, (self2, f232) => {
  const left522 = [];
  const right522 = [];
  const as422 = fromIterable423(self2);
  for (let i232 = 0; i232 < as422.length; i232++) {
    const e232 = f232(as422[i232], i232);
    if (isLeft323(e232)) {
      left522.push(e232.left);
    } else {
      right522.push(e232.right);
    }
  }
  return [left522, right522];
});
var getSomes23 = /* @__PURE__ */ filterMap323(identity244);
var getLefts23 = (self2) => {
  const out = [];
  for (const a232 of self2) {
    if (isLeft323(a232)) {
      out.push(a232.left);
    }
  }
  return out;
};
var getRights23 = (self2) => {
  const out = [];
  for (const a232 of self2) {
    if (isRight323(a232)) {
      out.push(a232.right);
    }
  }
  return out;
};
var filter323 = /* @__PURE__ */ dual244(2, (self2, predicate) => {
  const as422 = fromIterable423(self2);
  const out = [];
  for (let i232 = 0; i232 < as422.length; i232++) {
    if (predicate(as422[i232], i232)) {
      out.push(as422[i232]);
    }
  }
  return out;
});
var partition23 = /* @__PURE__ */ dual244(2, (self2, predicate) => {
  const left522 = [];
  const right522 = [];
  const as422 = fromIterable423(self2);
  for (let i232 = 0; i232 < as422.length; i232++) {
    if (predicate(as422[i232], i232)) {
      right522.push(as422[i232]);
    } else {
      left522.push(as422[i232]);
    }
  }
  return [left522, right522];
});
var separate23 = /* @__PURE__ */ partitionMap323(identity244);
var reduce333 = /* @__PURE__ */ dual244(3, (self2, b232, f232) => fromIterable423(self2).reduce((b322, a232, i232) => f232(b322, a232, i232), b232));
var reduceRight23 = /* @__PURE__ */ dual244(3, (self2, b232, f232) => fromIterable423(self2).reduceRight((b322, a232, i232) => f232(b322, a232, i232), b232));
var liftPredicate323 = (predicate) => (b232) => predicate(b232) ? [b232] : [];
var liftOption23 = (f232) => (...a232) => fromOption223(f232(...a232));
var fromNullable323 = (a232) => a232 == null ? empty923() : [a232];
var liftNullable323 = (f232) => (...a232) => fromNullable323(f232(...a232));
var flatMapNullable323 = /* @__PURE__ */ dual244(2, (self2, f232) => flatMap323(self2, (a232) => fromNullable323(f232(a232))));
var liftEither23 = (f232) => (...a232) => {
  const e232 = f232(...a232);
  return isLeft323(e232) ? [] : [e232.right];
};
var every323 = /* @__PURE__ */ dual244(2, (self2, refinement) => self2.every(refinement));
var some723 = /* @__PURE__ */ dual244(2, (self2, predicate) => self2.some(predicate));
var extend23 = /* @__PURE__ */ dual244(2, (self2, f232) => self2.map((_232, i232, as422) => f232(as422.slice(i232))));
var min223 = /* @__PURE__ */ dual244(2, (self2, O232) => self2.reduce(min33(O232)));
var max223 = /* @__PURE__ */ dual244(2, (self2, O232) => self2.reduce(max33(O232)));
var unfold23 = (b232, f232) => {
  const out = [];
  let next = b232;
  let o232;
  while (isSome423(o232 = f232(next))) {
    const [a232, b322] = o232.value;
    out.push(a232);
    next = b322;
  }
  return out;
};
var getOrder323 = array423;
var getEquivalence423 = array333;
var forEach333 = /* @__PURE__ */ dual244(2, (self2, f232) => fromIterable423(self2).forEach((a232, i232) => f232(a232, i232)));
var dedupeWith23 = /* @__PURE__ */ dual244(2, (self2, isEquivalent) => {
  const input = fromIterable423(self2);
  if (isNonEmptyReadonlyArray23(input)) {
    const out = [headNonEmpty233(input)];
    const rest = tailNonEmpty233(input);
    for (const r232 of rest) {
      if (out.every((a232) => !isEquivalent(r232, a232))) {
        out.push(r232);
      }
    }
    return out;
  }
  return [];
});
var dedupe23 = (self2) => dedupeWith23(self2, equivalence244());
var dedupeAdjacentWith23 = /* @__PURE__ */ dual244(2, (self2, isEquivalent) => {
  const out = [];
  let lastA = none423();
  for (const a232 of self2) {
    if (isNone423(lastA) || !isEquivalent(a232, lastA.value)) {
      out.push(a232);
      lastA = some623(a232);
    }
  }
  return out;
});
var dedupeAdjacent23 = /* @__PURE__ */ dedupeAdjacentWith23(/* @__PURE__ */ equivalence244());
var join24 = /* @__PURE__ */ dual244(2, (self2, sep2) => fromIterable423(self2).join(sep2));
var mapAccum23 = /* @__PURE__ */ dual244(3, (self2, s232, f232) => {
  let i232 = 0;
  let s1 = s232;
  const out = [];
  for (const a232 of self2) {
    const r232 = f232(s1, a232, i232);
    s1 = r232[0];
    out.push(r232[1]);
    i232++;
  }
  return [s1, out];
});
var cartesianWith23 = /* @__PURE__ */ dual244(3, (self2, that, f232) => flatMap323(self2, (a232) => map323(that, (b232) => f232(a232, b232))));
var cartesian23 = /* @__PURE__ */ dual244(2, (self2, that) => cartesianWith23(self2, that, (a232, b232) => [a232, b232]));
var Do323 = /* @__PURE__ */ of233({});
var bind523 = /* @__PURE__ */ bind344(map323, flatMap323);
var bindTo523 = /* @__PURE__ */ bindTo344(map323);
var let_523 = /* @__PURE__ */ let_344(map323);
var __defProp333 = Object.defineProperty;
var __export333 = (target, all3232) => {
  for (var name22 in all3232)
    __defProp333(target, name22, { get: all3232[name22], enumerable: true });
};
var Function_exports323 = {};
__export333(Function_exports323, {
  SK: () => SK323,
  absurd: () => absurd323,
  apply: () => apply323,
  compose: () => compose523,
  constFalse: () => constFalse323,
  constNull: () => constNull323,
  constTrue: () => constTrue323,
  constUndefined: () => constUndefined323,
  constVoid: () => constVoid323,
  constant: () => constant323,
  dual: () => dual323,
  flip: () => flip323,
  flow: () => flow323,
  hole: () => hole323,
  identity: () => identity323,
  isFunction: () => isFunction623,
  pipe: () => pipe323,
  satisfies: () => satisfies323,
  tupled: () => tupled323,
  unsafeCoerce: () => unsafeCoerce323,
  untupled: () => untupled323
});
var isFunction623 = (input) => typeof input === "function";
var dual323 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a232, b232) {
        if (arguments.length >= 2) {
          return body(a232, b232);
        }
        return function(self2) {
          return body(self2, a232);
        };
      };
    case 3:
      return function(a232, b232, c232) {
        if (arguments.length >= 3) {
          return body(a232, b232, c232);
        }
        return function(self2) {
          return body(self2, a232, b232);
        };
      };
    case 4:
      return function(a232, b232, c232, d232) {
        if (arguments.length >= 4) {
          return body(a232, b232, c232, d232);
        }
        return function(self2) {
          return body(self2, a232, b232, c232);
        };
      };
    case 5:
      return function(a232, b232, c232, d232, e232) {
        if (arguments.length >= 5) {
          return body(a232, b232, c232, d232, e232);
        }
        return function(self2) {
          return body(self2, a232, b232, c232, d232);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply323 = (a232) => (self2) => self2(a232);
var identity323 = (a232) => a232;
var satisfies323 = () => (b232) => b232;
var unsafeCoerce323 = identity323;
var constant323 = (value) => () => value;
var constTrue323 = /* @__PURE__ */ constant323(true);
var constFalse323 = /* @__PURE__ */ constant323(false);
var constNull323 = /* @__PURE__ */ constant323(null);
var constUndefined323 = /* @__PURE__ */ constant323(void 0);
var constVoid323 = constUndefined323;
var flip323 = (f232) => (...b232) => (...a232) => f232(...a232)(...b232);
var compose523 = /* @__PURE__ */ dual323(2, (ab, bc) => (a232) => bc(ab(a232)));
var absurd323 = (_232) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled323 = (f232) => (a232) => f232(...a232);
var untupled323 = (f232) => (...a232) => f232(a232);
function pipe323(a232, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a232;
    case 2:
      return ab(a232);
    case 3:
      return bc(ab(a232));
    case 4:
      return cd(bc(ab(a232)));
    case 5:
      return de(cd(bc(ab(a232))));
    case 6:
      return ef(de(cd(bc(ab(a232)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a232))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a232)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a232))))))));
    default: {
      let ret = arguments[0];
      for (let i232 = 1; i232 < arguments.length; i232++) {
        ret = arguments[i232](ret);
      }
      return ret;
    }
  }
}
function flow323(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole323 = /* @__PURE__ */ unsafeCoerce323(absurd323);
var SK323 = (_232, b232) => b232;
var make1123 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_623 = (map3222) => dual323(3, (self2, name22, f232) => map3222(self2, (a232) => Object.assign({}, a232, {
  [name22]: f232(a232)
})));
var bindTo623 = (map3222) => dual323(2, (self2, name22) => map3222(self2, (a232) => ({
  [name22]: a232
})));
var bind623 = (map3222, flatMap3222) => dual323(3, (self2, name22, f232) => flatMap3222(self2, (a232) => map3222(f232(a232), (b232) => Object.assign({}, a232, {
  [name22]: b232
}))));
var moduleVersion323 = "3.2.8";
var getCurrentVersion323 = () => moduleVersion323;
var globalStoreId323 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion323()}`);
if (!(globalStoreId323 in globalThis)) {
  globalThis[globalStoreId323] = /* @__PURE__ */ new Map();
}
var globalStore323 = globalThis[globalStoreId323];
var globalValue323 = (id, compute) => {
  if (!globalStore323.has(id)) {
    globalStore323.set(id, compute());
  }
  return globalStore323.get(id);
};
var isFunction2244 = isFunction623;
var isRecordOrArray323 = (input) => typeof input === "object" && input !== null;
var isObject323 = (input) => isRecordOrArray323(input) || isFunction2244(input);
var hasProperty323 = /* @__PURE__ */ dual323(2, (self2, property) => isObject323(self2) && property in self2);
var isNullable323 = (input) => input === null || input === void 0;
var getBugErrorMessage323 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId323 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind323 = (u232) => isObject323(u232) && GenKindTypeId323 in u232;
var GenKindImpl323 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity323;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId323] = GenKindTypeId323;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen423(this);
  }
};
var SingleShotGen423 = class _SingleShotGen344 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a232) {
    return this.called ? {
      value: a232,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a232) {
    return {
      value: a232,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e232) {
    throw e232;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen344(this.self);
  }
};
var adapter523 = () => function() {
  let x232 = arguments[0];
  for (let i232 = 1; i232 < arguments.length; i232++) {
    x232 = arguments[i232](x232);
  }
  return new GenKindImpl323(x232);
};
var defaultIncHi323 = 335903614;
var defaultIncLo323 = 4150755663;
var MUL_HI323 = 1481765933 >>> 0;
var MUL_LO323 = 1284865837 >>> 0;
var BIT_53323 = 9007199254740992;
var BIT_27323 = 134217728;
var PCGRandom323 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable323(seedLo) && isNullable323(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable323(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable323(incLo) && isNullable323(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo323;
      incHi = this._state ? this._state[2] : defaultIncHi323;
    } else if (isNullable323(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add64323(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max322) {
    if (!max322) {
      return this._next();
    }
    max322 = max322 >>> 0;
    if ((max322 & max322 - 1) === 0) {
      return this._next() & max322 - 1;
    }
    let num = 0;
    const skew = (-max322 >>> 0) % max322 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max322;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_27323 + lo) / BIT_53323;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul64323(this._state, oldHi, oldLo, MUL_HI323, MUL_LO323);
    add64323(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul64323(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add64323(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId323 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap323 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId323]() {
    return this.#value;
  }
};
function yieldWrapGet323(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId323 in self2) {
    return self2[YieldWrapTypeId323]();
  }
  throw new Error(getBugErrorMessage323("yieldWrapGet"));
}
var structuralRegionState323 = /* @__PURE__ */ globalValue323("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache323 = /* @__PURE__ */ globalValue323(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr323 = /* @__PURE__ */ globalValue323(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom323());
var symbol523 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash323 = (self2) => {
  if (structuralRegionState323.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number423(self2);
    case "bigint":
      return string323(self2.toString(10));
    case "boolean":
      return string323(String(self2));
    case "symbol":
      return string323(String(self2));
    case "string":
      return string323(self2);
    case "undefined":
      return string323("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string323("null");
      } else if (self2 instanceof Date) {
        return hash323(self2.toISOString());
      } else if (isHash323(self2)) {
        return self2[symbol523]();
      } else {
        return random323(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random323 = (self2) => {
  if (!randomHashCache323.has(self2)) {
    randomHashCache323.set(self2, number423(pcgr323.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache323.get(self2);
};
var combine423 = (b232) => (self2) => self2 * 53 ^ b232;
var optimize323 = (n232) => n232 & 3221225471 | n232 >>> 1 & 1073741824;
var isHash323 = (u232) => hasProperty323(u232, symbol523);
var number423 = (n232) => {
  if (n232 !== n232 || n232 === Infinity) {
    return 0;
  }
  let h232 = n232 | 0;
  if (h232 !== n232) {
    h232 ^= n232 * 4294967295;
  }
  while (n232 > 4294967295) {
    h232 ^= n232 /= 4294967295;
  }
  return optimize323(n232);
};
var string323 = (str) => {
  let h232 = 5381, i232 = str.length;
  while (i232) {
    h232 = h232 * 33 ^ str.charCodeAt(--i232);
  }
  return optimize323(h232);
};
var cached323 = function() {
  if (arguments.length === 1) {
    const self3 = arguments[0];
    return function(hash422) {
      Object.defineProperty(self3, symbol523, {
        value() {
          return hash422;
        },
        enumerable: false
      });
      return hash422;
    };
  }
  const self2 = arguments[0];
  const hash3222 = arguments[1];
  Object.defineProperty(self2, symbol523, {
    value() {
      return hash3222;
    },
    enumerable: false
  });
  return hash3222;
};
var symbol2244 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals323() {
  if (arguments.length === 1) {
    return (self2) => compareBoth323(self2, arguments[0]);
  }
  return compareBoth323(arguments[0], arguments[1]);
}
function compareBoth323(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual323(self2) && isEqual323(that)) {
        if (hash323(self2) === hash323(that) && self2[symbol2244](that)) {
          return true;
        } else {
          return structuralRegionState323.enabled && structuralRegionState323.tester ? structuralRegionState323.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState323.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v232, i232) => compareBoth323(v232, that[i232]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth323(self2[key], that[key]))) {
              return structuralRegionState323.tester ? structuralRegionState323.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState323.tester ? structuralRegionState323.tester(self2, that) : false;
    }
  }
  return structuralRegionState323.enabled && structuralRegionState323.tester ? structuralRegionState323.tester(self2, that) : false;
}
var isEqual323 = (u232) => hasProperty323(u232, symbol2244);
var equivalence323 = () => equals323;
var NodeInspectSymbol323 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON323 = (x232) => {
  if (hasProperty323(x232, "toJSON") && isFunction2244(x232["toJSON"]) && x232["toJSON"].length === 0) {
    return x232.toJSON();
  } else if (Array.isArray(x232)) {
    return x232.map(toJSON323);
  }
  return x232;
};
var format323 = (x232) => JSON.stringify(x232, null, 2);
var pipeArguments323 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i232 = 0, len = args.length; i232 < len; i232++) {
        ret = args[i232](ret);
      }
      return ret;
    }
  }
};
var EffectTypeId423 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId323 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId323 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId323 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance323 = {
  /* c8 ignore next */
  _R: (_232) => _232,
  /* c8 ignore next */
  _E: (_232) => _232,
  /* c8 ignore next */
  _A: (_232) => _232,
  _V: /* @__PURE__ */ getCurrentVersion323()
};
var sinkVariance323 = {
  /* c8 ignore next */
  _A: (_232) => _232,
  /* c8 ignore next */
  _In: (_232) => _232,
  /* c8 ignore next */
  _L: (_232) => _232,
  /* c8 ignore next */
  _E: (_232) => _232,
  /* c8 ignore next */
  _R: (_232) => _232
};
var channelVariance323 = {
  /* c8 ignore next */
  _Env: (_232) => _232,
  /* c8 ignore next */
  _InErr: (_232) => _232,
  /* c8 ignore next */
  _InElem: (_232) => _232,
  /* c8 ignore next */
  _InDone: (_232) => _232,
  /* c8 ignore next */
  _OutErr: (_232) => _232,
  /* c8 ignore next */
  _OutElem: (_232) => _232,
  /* c8 ignore next */
  _OutDone: (_232) => _232
};
var EffectPrototype323 = {
  [EffectTypeId423]: effectVariance323,
  [StreamTypeId323]: effectVariance323,
  [SinkTypeId323]: sinkVariance323,
  [ChannelTypeId323]: channelVariance323,
  [symbol2244](that) {
    return this === that;
  },
  [symbol523]() {
    return cached323(this, random323(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen423(new YieldWrap323(this));
  },
  pipe() {
    return pipeArguments323(this, arguments);
  }
};
var TypeId923 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto523 = {
  ...EffectPrototype323,
  [TypeId923]: {
    _A: (_232) => _232
  },
  [NodeInspectSymbol323]() {
    return this.toJSON();
  },
  toString() {
    return format323(this.toJSON());
  }
};
var SomeProto323 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto523), {
  _tag: "Some",
  _op: "Some",
  [symbol2244](that) {
    return isOption523(that) && isSome523(that) && equals323(this.value, that.value);
  },
  [symbol523]() {
    return cached323(this, combine423(hash323(this._tag))(hash323(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON323(this.value)
    };
  }
});
var NoneHash323 = /* @__PURE__ */ hash323("None");
var NoneProto323 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto523), {
  _tag: "None",
  _op: "None",
  [symbol2244](that) {
    return isOption523(that) && isNone523(that);
  },
  [symbol523]() {
    return NoneHash323;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption523 = (input) => hasProperty323(input, TypeId923);
var isNone523 = (fa) => fa._tag === "None";
var isSome523 = (fa) => fa._tag === "Some";
var none523 = /* @__PURE__ */ Object.create(NoneProto323);
var some823 = (value) => {
  const a232 = Object.create(SomeProto323);
  a232.value = value;
  return a232;
};
var TypeId2244 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto2244 = {
  ...EffectPrototype323,
  [TypeId2244]: {
    _R: (_232) => _232
  },
  [NodeInspectSymbol323]() {
    return this.toJSON();
  },
  toString() {
    return format323(this.toJSON());
  }
};
var RightProto323 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto2244), {
  _tag: "Right",
  _op: "Right",
  [symbol2244](that) {
    return isEither323(that) && isRight423(that) && equals323(this.right, that.right);
  },
  [symbol523]() {
    return combine423(hash323(this._tag))(hash323(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON323(this.right)
    };
  }
});
var LeftProto323 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto2244), {
  _tag: "Left",
  _op: "Left",
  [symbol2244](that) {
    return isEither323(that) && isLeft423(that) && equals323(this.left, that.left);
  },
  [symbol523]() {
    return combine423(hash323(this._tag))(hash323(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON323(this.left)
    };
  }
});
var isEither323 = (input) => hasProperty323(input, TypeId2244);
var isLeft423 = (ma) => ma._tag === "Left";
var isRight423 = (ma) => ma._tag === "Right";
var left423 = (left3232) => {
  const a232 = Object.create(LeftProto323);
  a232.left = left3232;
  return a232;
};
var right423 = (right3232) => {
  const a232 = Object.create(RightProto323);
  a232.right = right3232;
  return a232;
};
var getLeft523 = (self2) => isRight423(self2) ? none523 : some823(self2.left);
var getRight523 = (self2) => isLeft423(self2) ? none523 : some823(self2.right);
var Option_exports323 = {};
__export333(Option_exports323, {
  Do: () => Do423,
  TypeId: () => TypeId3244,
  all: () => all523,
  andThen: () => andThen323,
  ap: () => ap323,
  as: () => as323,
  asVoid: () => asVoid323,
  bind: () => bind2244,
  bindTo: () => bindTo2244,
  composeK: () => composeK323,
  contains: () => contains423,
  containsWith: () => containsWith423,
  exists: () => exists323,
  filter: () => filter423,
  filterMap: () => filterMap423,
  firstSomeOf: () => firstSomeOf323,
  flatMap: () => flatMap423,
  flatMapNullable: () => flatMapNullable423,
  flatten: () => flatten423,
  fromIterable: () => fromIterable523,
  fromNullable: () => fromNullable423,
  gen: () => gen323,
  getEquivalence: () => getEquivalence523,
  getLeft: () => getLeft2244,
  getOrElse: () => getOrElse323,
  getOrNull: () => getOrNull323,
  getOrThrow: () => getOrThrow323,
  getOrThrowWith: () => getOrThrowWith323,
  getOrUndefined: () => getOrUndefined323,
  getOrder: () => getOrder423,
  getRight: () => getRight2244,
  isNone: () => isNone2244,
  isOption: () => isOption2244,
  isSome: () => isSome2244,
  let: () => let_2244,
  lift2: () => lift2323,
  liftNullable: () => liftNullable423,
  liftPredicate: () => liftPredicate423,
  liftThrowable: () => liftThrowable323,
  map: () => map423,
  match: () => match523,
  none: () => none2244,
  orElse: () => orElse323,
  orElseEither: () => orElseEither323,
  orElseSome: () => orElseSome323,
  partitionMap: () => partitionMap423,
  product: () => product523,
  productMany: () => productMany523,
  reduceCompact: () => reduceCompact323,
  some: () => some2244,
  tap: () => tap323,
  toArray: () => toArray323,
  toRefinement: () => toRefinement323,
  void: () => void_323,
  zipLeft: () => zipLeft323,
  zipRight: () => zipRight323,
  zipWith: () => zipWith423
});
var make2244 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId3244 = /* @__PURE__ */ Symbol.for("effect/Option");
var none2244 = () => none523;
var some2244 = some823;
var isOption2244 = isOption523;
var isNone2244 = isNone523;
var isSome2244 = isSome523;
var match523 = /* @__PURE__ */ dual323(2, (self2, {
  onNone,
  onSome
}) => isNone2244(self2) ? onNone() : onSome(self2.value));
var toRefinement323 = (f232) => (a232) => isSome2244(f232(a232));
var fromIterable523 = (collection) => {
  for (const a232 of collection) {
    return some2244(a232);
  }
  return none2244();
};
var getRight2244 = getRight523;
var getLeft2244 = getLeft523;
var getOrElse323 = /* @__PURE__ */ dual323(2, (self2, onNone) => isNone2244(self2) ? onNone() : self2.value);
var orElse323 = /* @__PURE__ */ dual323(2, (self2, that) => isNone2244(self2) ? that() : self2);
var orElseSome323 = /* @__PURE__ */ dual323(2, (self2, onNone) => isNone2244(self2) ? some2244(onNone()) : self2);
var orElseEither323 = /* @__PURE__ */ dual323(2, (self2, that) => isNone2244(self2) ? map423(that(), right423) : map423(self2, left423));
var firstSomeOf323 = (collection) => {
  let out = none2244();
  for (out of collection) {
    if (isSome2244(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable423 = (nullableValue) => nullableValue == null ? none2244() : some2244(nullableValue);
var liftNullable423 = (f232) => (...a232) => fromNullable423(f232(...a232));
var getOrNull323 = /* @__PURE__ */ getOrElse323(constNull323);
var getOrUndefined323 = /* @__PURE__ */ getOrElse323(constUndefined323);
var liftThrowable323 = (f232) => (...a232) => {
  try {
    return some2244(f232(...a232));
  } catch (e232) {
    return none2244();
  }
};
var getOrThrowWith323 = /* @__PURE__ */ dual323(2, (self2, onNone) => {
  if (isSome2244(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow323 = /* @__PURE__ */ getOrThrowWith323(() => new Error("getOrThrow called on a None"));
var map423 = /* @__PURE__ */ dual323(2, (self2, f232) => isNone2244(self2) ? none2244() : some2244(f232(self2.value)));
var as323 = /* @__PURE__ */ dual323(2, (self2, b232) => map423(self2, () => b232));
var asVoid323 = /* @__PURE__ */ as323(void 0);
var void_323 = /* @__PURE__ */ some2244(void 0);
var flatMap423 = /* @__PURE__ */ dual323(2, (self2, f232) => isNone2244(self2) ? none2244() : f232(self2.value));
var andThen323 = /* @__PURE__ */ dual323(2, (self2, f232) => flatMap423(self2, (a232) => {
  const b232 = isFunction623(f232) ? f232(a232) : f232;
  return isOption2244(b232) ? b232 : some2244(b232);
}));
var flatMapNullable423 = /* @__PURE__ */ dual323(2, (self2, f232) => isNone2244(self2) ? none2244() : fromNullable423(f232(self2.value)));
var flatten423 = /* @__PURE__ */ flatMap423(identity323);
var zipRight323 = /* @__PURE__ */ dual323(2, (self2, that) => flatMap423(self2, () => that));
var composeK323 = /* @__PURE__ */ dual323(2, (afb, bfc) => (a232) => flatMap423(afb(a232), bfc));
var zipLeft323 = /* @__PURE__ */ dual323(2, (self2, that) => tap323(self2, () => that));
var tap323 = /* @__PURE__ */ dual323(2, (self2, f232) => flatMap423(self2, (a232) => map423(f232(a232), () => a232)));
var product523 = (self2, that) => isSome2244(self2) && isSome2244(that) ? some2244([self2.value, that.value]) : none2244();
var productMany523 = (self2, collection) => {
  if (isNone2244(self2)) {
    return none2244();
  }
  const out = [self2.value];
  for (const o232 of collection) {
    if (isNone2244(o232)) {
      return none2244();
    }
    out.push(o232.value);
  }
  return some2244(out);
};
var all523 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o232 of input) {
      if (isNone2244(o232)) {
        return none2244();
      }
      out2.push(o232.value);
    }
    return some2244(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o232 = input[key];
    if (isNone2244(o232)) {
      return none2244();
    }
    out[key] = o232.value;
  }
  return some2244(out);
};
var zipWith423 = /* @__PURE__ */ dual323(3, (self2, that, f232) => map423(product523(self2, that), ([a232, b232]) => f232(a232, b232)));
var ap323 = /* @__PURE__ */ dual323(2, (self2, that) => zipWith423(self2, that, (f232, a232) => f232(a232)));
var reduceCompact323 = /* @__PURE__ */ dual323(3, (self2, b232, f232) => {
  let out = b232;
  for (const oa of self2) {
    if (isSome2244(oa)) {
      out = f232(out, oa.value);
    }
  }
  return out;
});
var toArray323 = (self2) => isNone2244(self2) ? [] : [self2.value];
var partitionMap423 = /* @__PURE__ */ dual323(2, (self2, f232) => {
  if (isNone2244(self2)) {
    return [none2244(), none2244()];
  }
  const e232 = f232(self2.value);
  return isLeft423(e232) ? [some2244(e232.left), none2244()] : [none2244(), some2244(e232.right)];
});
var filterMap423 = /* @__PURE__ */ dual323(2, (self2, f232) => isNone2244(self2) ? none2244() : f232(self2.value));
var filter423 = /* @__PURE__ */ dual323(2, (self2, predicate) => filterMap423(self2, (b232) => predicate(b232) ? some823(b232) : none523));
var getEquivalence523 = (isEquivalent) => make1123((x232, y232) => x232 === y232 || (isNone2244(x232) ? isNone2244(y232) : isNone2244(y232) ? false : isEquivalent(x232.value, y232.value)));
var getOrder423 = (O232) => make2244((self2, that) => isSome2244(self2) ? isSome2244(that) ? O232(self2.value, that.value) : 1 : -1);
var lift2323 = (f232) => dual323(2, (self2, that) => zipWith423(self2, that, f232));
var liftPredicate423 = (predicate) => (b232) => predicate(b232) ? some2244(b232) : none2244();
var containsWith423 = (isEquivalent) => dual323(2, (self2, a232) => isNone2244(self2) ? false : isEquivalent(self2.value, a232));
var _equivalence523 = /* @__PURE__ */ equivalence323();
var contains423 = /* @__PURE__ */ containsWith423(_equivalence523);
var exists323 = /* @__PURE__ */ dual323(2, (self2, refinement) => isNone2244(self2) ? false : refinement(self2.value));
var bindTo2244 = /* @__PURE__ */ bindTo623(map423);
var let_2244 = /* @__PURE__ */ let_623(map423);
var bind2244 = /* @__PURE__ */ bind623(map423, flatMap423);
var Do423 = /* @__PURE__ */ some2244({});
var adapter2244 = /* @__PURE__ */ adapter523();
var gen323 = (f232) => {
  const iterator = f232(adapter2244);
  let state = iterator.next();
  if (state.done) {
    return some2244(state.value);
  } else {
    let current = state.value;
    if (isGenKind323(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet323(current);
    }
    if (isNone2244(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind323(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet323(current);
        }
        if (isNone2244(current)) {
          return current;
        }
      }
    }
    return some2244(state.value);
  }
};
var MutableRef_exports223 = {};
__export333(MutableRef_exports223, {
  compareAndSet: () => compareAndSet44,
  decrement: () => decrement44,
  decrementAndGet: () => decrementAndGet44,
  get: () => get223,
  getAndDecrement: () => getAndDecrement44,
  getAndIncrement: () => getAndIncrement44,
  getAndSet: () => getAndSet44,
  getAndUpdate: () => getAndUpdate44,
  increment: () => increment44,
  incrementAndGet: () => incrementAndGet44,
  make: () => make3244,
  set: () => set244,
  setAndGet: () => setAndGet44,
  toggle: () => toggle44,
  update: () => update44,
  updateAndGet: () => updateAndGet44
});
var TypeId4244 = /* @__PURE__ */ Symbol.for("effect/MutableRef");
var MutableRefProto44 = {
  [TypeId4244]: TypeId4244,
  toString() {
    return format323(this.toJSON());
  },
  toJSON() {
    return {
      _id: "MutableRef",
      current: toJSON323(this.current)
    };
  },
  [NodeInspectSymbol323]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments323(this, arguments);
  }
};
var make3244 = (value) => {
  const ref = Object.create(MutableRefProto44);
  ref.current = value;
  return ref;
};
var compareAndSet44 = /* @__PURE__ */ dual323(3, (self2, oldValue, newValue) => {
  if (equals323(oldValue, self2.current)) {
    self2.current = newValue;
    return true;
  }
  return false;
});
var decrement44 = (self2) => update44(self2, (n232) => n232 - 1);
var decrementAndGet44 = (self2) => updateAndGet44(self2, (n232) => n232 - 1);
var get223 = (self2) => self2.current;
var getAndDecrement44 = (self2) => getAndUpdate44(self2, (n232) => n232 - 1);
var getAndIncrement44 = (self2) => getAndUpdate44(self2, (n232) => n232 + 1);
var getAndSet44 = /* @__PURE__ */ dual323(2, (self2, value) => {
  const ret = self2.current;
  self2.current = value;
  return ret;
});
var getAndUpdate44 = /* @__PURE__ */ dual323(2, (self2, f232) => getAndSet44(self2, f232(get223(self2))));
var increment44 = (self2) => update44(self2, (n232) => n232 + 1);
var incrementAndGet44 = (self2) => updateAndGet44(self2, (n232) => n232 + 1);
var set244 = /* @__PURE__ */ dual323(2, (self2, value) => {
  self2.current = value;
  return self2;
});
var setAndGet44 = /* @__PURE__ */ dual323(2, (self2, value) => {
  self2.current = value;
  return self2.current;
});
var update44 = /* @__PURE__ */ dual323(2, (self2, f232) => set244(self2, f232(get223(self2))));
var updateAndGet44 = /* @__PURE__ */ dual323(2, (self2, f232) => setAndGet44(self2, f232(get223(self2))));
var toggle44 = (self2) => update44(self2, (_232) => !_232);
function getVariables34(initialScope) {
  const scopeRef = MutableRef_exports223.make(initialScope);
  const variablesRef = MutableRef_exports223.make(MutableRef_exports223.get(scopeRef).variables);
  while (MutableRef_exports223.get(scopeRef).type !== scopeManager.ScopeType.global) {
    MutableRef_exports223.set(scopeRef, MutableRef_exports223.get(scopeRef).upper);
    MutableRef_exports223.update(variablesRef, (variables) => variables.concat(MutableRef_exports223.get(scopeRef).variables));
  }
  return MutableRef_exports223.get(variablesRef).reverse();
}
Function_exports323.dual(2, (name22, initialScope) => {
  return Option_exports323.fromNullable(getVariables34(initialScope).find((variable) => variable.name === name22));
});
var t34 = Symbol.for("@ts-pattern/matcher");
var e34 = Symbol.for("@ts-pattern/isVariadic");
var n34 = "@ts-pattern/anonymous-select-key";
var r34 = (t232) => Boolean(t232 && "object" == typeof t232);
var i34 = (e232) => e232 && !!e232[t34];
var o34 = (n232, s232, c232) => {
  if (i34(n232)) {
    const e232 = n232[t34](), { matched: r232, selections: i232 } = e232.match(s232);
    return r232 && i232 && Object.keys(i232).forEach((t232) => c232(t232, i232[t232])), r232;
  }
  if (r34(n232)) {
    if (!r34(s232)) return false;
    if (Array.isArray(n232)) {
      if (!Array.isArray(s232)) return false;
      let t232 = [], r232 = [], a232 = [];
      for (const o232 of n232.keys()) {
        const s322 = n232[o232];
        i34(s322) && s322[e34] ? a232.push(s322) : a232.length ? r232.push(s322) : t232.push(s322);
      }
      if (a232.length) {
        if (a232.length > 1) throw new Error("Pattern error: Using `...P.array(...)` several times in a single pattern is not allowed.");
        if (s232.length < t232.length + r232.length) return false;
        const e232 = s232.slice(0, t232.length), n322 = 0 === r232.length ? [] : s232.slice(-r232.length), i232 = s232.slice(t232.length, 0 === r232.length ? Infinity : -r232.length);
        return t232.every((t322, n43) => o34(t322, e232[n43], c232)) && r232.every((t322, e322) => o34(t322, n322[e322], c232)) && (0 === a232.length || o34(a232[0], i232, c232));
      }
      return n232.length === s232.length && n232.every((t322, e232) => o34(t322, s232[e232], c232));
    }
    return Object.keys(n232).every((e232) => {
      const r232 = n232[e232];
      return (e232 in s232 || i34(a232 = r232) && "optional" === a232[t34]().matcherType) && o34(r232, s232[e232], c232);
      var a232;
    });
  }
  return Object.is(s232, n232);
};
var s34 = (e232) => {
  var n232, o232, a232;
  return r34(e232) ? i34(e232) ? null != (n232 = null == (o232 = (a232 = e232[t34]()).getSelectionKeys) ? void 0 : o232.call(a232)) ? n232 : [] : Array.isArray(e232) ? c34(e232, s34) : c34(Object.values(e232), s34) : [];
};
var c34 = (t232, e232) => t232.reduce((t322, n232) => t322.concat(e232(n232)), []);
function a34(...t232) {
  if (1 === t232.length) {
    const [e232] = t232;
    return (t322) => o34(e232, t322, () => {
    });
  }
  if (2 === t232.length) {
    const [e232, n232] = t232;
    return o34(e232, n232, () => {
    });
  }
  throw new Error(`isMatching wasn't given the right number of arguments: expected 1 or 2, received ${t232.length}.`);
}
function u34(t232) {
  return Object.assign(t232, { optional: () => l34(t232), and: (e232) => m34(t232, e232), or: (e232) => d34(t232, e232), select: (e232) => void 0 === e232 ? p34(t232) : p34(e232, t232) });
}
function h34(t232) {
  return Object.assign(((t322) => Object.assign(t322, { [Symbol.iterator]() {
    let n232 = 0;
    const r232 = [{ value: Object.assign(t322, { [e34]: true }), done: false }, { done: true, value: void 0 }];
    return { next: () => {
      var t43;
      return null != (t43 = r232[n232++]) ? t43 : r232.at(-1);
    } };
  } }))(t232), { optional: () => h34(l34(t232)), select: (e232) => h34(void 0 === e232 ? p34(t232) : p34(e232, t232)) });
}
function l34(e232) {
  return u34({ [t34]: () => ({ match: (t232) => {
    let n232 = {};
    const r232 = (t322, e322) => {
      n232[t322] = e322;
    };
    return void 0 === t232 ? (s34(e232).forEach((t322) => r232(t322, void 0)), { matched: true, selections: n232 }) : { matched: o34(e232, t232, r232), selections: n232 };
  }, getSelectionKeys: () => s34(e232), matcherType: "optional" }) });
}
var f34 = (t232, e232) => {
  for (const n232 of t232) if (!e232(n232)) return false;
  return true;
};
var g34 = (t232, e232) => {
  for (const [n232, r232] of t232.entries()) if (!e232(r232, n232)) return false;
  return true;
};
function m34(...e232) {
  return u34({ [t34]: () => ({ match: (t232) => {
    let n232 = {};
    const r232 = (t322, e322) => {
      n232[t322] = e322;
    };
    return { matched: e232.every((e322) => o34(e322, t232, r232)), selections: n232 };
  }, getSelectionKeys: () => c34(e232, s34), matcherType: "and" }) });
}
function d34(...e232) {
  return u34({ [t34]: () => ({ match: (t232) => {
    let n232 = {};
    const r232 = (t322, e322) => {
      n232[t322] = e322;
    };
    return c34(e232, s34).forEach((t322) => r232(t322, void 0)), { matched: e232.some((e322) => o34(e322, t232, r232)), selections: n232 };
  }, getSelectionKeys: () => c34(e232, s34), matcherType: "or" }) });
}
function y34(e232) {
  return { [t34]: () => ({ match: (t232) => ({ matched: Boolean(e232(t232)) }) }) };
}
function p34(...e232) {
  const r232 = "string" == typeof e232[0] ? e232[0] : void 0, i232 = 2 === e232.length ? e232[1] : "string" == typeof e232[0] ? void 0 : e232[0];
  return u34({ [t34]: () => ({ match: (t232) => {
    let e322 = { [null != r232 ? r232 : n34]: t232 };
    return { matched: void 0 === i232 || o34(i232, t232, (t322, n232) => {
      e322[t322] = n232;
    }), selections: e322 };
  }, getSelectionKeys: () => [null != r232 ? r232 : n34].concat(void 0 === i232 ? [] : s34(i232)) }) });
}
function v34(t232) {
  return "number" == typeof t232;
}
function b34(t232) {
  return "string" == typeof t232;
}
function w34(t232) {
  return "bigint" == typeof t232;
}
var S34 = u34(y34(function(t232) {
  return true;
}));
var O34 = S34;
var j34 = (t232) => Object.assign(u34(t232), { startsWith: (e232) => {
  return j34(m34(t232, (n232 = e232, y34((t322) => b34(t322) && t322.startsWith(n232)))));
  var n232;
}, endsWith: (e232) => {
  return j34(m34(t232, (n232 = e232, y34((t322) => b34(t322) && t322.endsWith(n232)))));
  var n232;
}, minLength: (e232) => j34(m34(t232, ((t322) => y34((e322) => b34(e322) && e322.length >= t322))(e232))), maxLength: (e232) => j34(m34(t232, ((t322) => y34((e322) => b34(e322) && e322.length <= t322))(e232))), includes: (e232) => {
  return j34(m34(t232, (n232 = e232, y34((t322) => b34(t322) && t322.includes(n232)))));
  var n232;
}, regex: (e232) => {
  return j34(m34(t232, (n232 = e232, y34((t322) => b34(t322) && Boolean(t322.match(n232))))));
  var n232;
} });
var E34 = j34(y34(b34));
var K34 = (t232) => Object.assign(u34(t232), { between: (e232, n232) => K34(m34(t232, ((t322, e322) => y34((n322) => v34(n322) && t322 <= n322 && e322 >= n322))(e232, n232))), lt: (e232) => K34(m34(t232, ((t322) => y34((e322) => v34(e322) && e322 < t322))(e232))), gt: (e232) => K34(m34(t232, ((t322) => y34((e322) => v34(e322) && e322 > t322))(e232))), lte: (e232) => K34(m34(t232, ((t322) => y34((e322) => v34(e322) && e322 <= t322))(e232))), gte: (e232) => K34(m34(t232, ((t322) => y34((e322) => v34(e322) && e322 >= t322))(e232))), int: () => K34(m34(t232, y34((t322) => v34(t322) && Number.isInteger(t322)))), finite: () => K34(m34(t232, y34((t322) => v34(t322) && Number.isFinite(t322)))), positive: () => K34(m34(t232, y34((t322) => v34(t322) && t322 > 0))), negative: () => K34(m34(t232, y34((t322) => v34(t322) && t322 < 0))) });
var x34 = K34(y34(v34));
var A34 = (t232) => Object.assign(u34(t232), { between: (e232, n232) => A34(m34(t232, ((t322, e322) => y34((n322) => w34(n322) && t322 <= n322 && e322 >= n322))(e232, n232))), lt: (e232) => A34(m34(t232, ((t322) => y34((e322) => w34(e322) && e322 < t322))(e232))), gt: (e232) => A34(m34(t232, ((t322) => y34((e322) => w34(e322) && e322 > t322))(e232))), lte: (e232) => A34(m34(t232, ((t322) => y34((e322) => w34(e322) && e322 <= t322))(e232))), gte: (e232) => A34(m34(t232, ((t322) => y34((e322) => w34(e322) && e322 >= t322))(e232))), positive: () => A34(m34(t232, y34((t322) => w34(t322) && t322 > 0))), negative: () => A34(m34(t232, y34((t322) => w34(t322) && t322 < 0))) });
var P25 = A34(y34(w34));
var T34 = u34(y34(function(t232) {
  return "boolean" == typeof t232;
}));
var k34 = u34(y34(function(t232) {
  return "symbol" == typeof t232;
}));
var B34 = u34(y34(function(t232) {
  return null == t232;
}));
var _34 = u34(y34(function(t232) {
  return null != t232;
}));
var N34 = { __proto__: null, matcher: t34, optional: l34, array: function(...e232) {
  return h34({ [t34]: () => ({ match: (t232) => {
    if (!Array.isArray(t232)) return { matched: false };
    if (0 === e232.length) return { matched: true };
    const n232 = e232[0];
    let r232 = {};
    if (0 === t232.length) return s34(n232).forEach((t322) => {
      r232[t322] = [];
    }), { matched: true, selections: r232 };
    const i232 = (t322, e322) => {
      r232[t322] = (r232[t322] || []).concat([e322]);
    };
    return { matched: t232.every((t322) => o34(n232, t322, i232)), selections: r232 };
  }, getSelectionKeys: () => 0 === e232.length ? [] : s34(e232[0]) }) });
}, set: function(...e232) {
  return u34({ [t34]: () => ({ match: (t232) => {
    if (!(t232 instanceof Set)) return { matched: false };
    let n232 = {};
    if (0 === t232.size) return { matched: true, selections: n232 };
    if (0 === e232.length) return { matched: true };
    const r232 = (t322, e322) => {
      n232[t322] = (n232[t322] || []).concat([e322]);
    }, i232 = e232[0];
    return { matched: f34(t232, (t322) => o34(i232, t322, r232)), selections: n232 };
  }, getSelectionKeys: () => 0 === e232.length ? [] : s34(e232[0]) }) });
}, map: function(...e232) {
  return u34({ [t34]: () => ({ match: (t232) => {
    if (!(t232 instanceof Map)) return { matched: false };
    let n232 = {};
    if (0 === t232.size) return { matched: true, selections: n232 };
    const r232 = (t322, e322) => {
      n232[t322] = (n232[t322] || []).concat([e322]);
    };
    if (0 === e232.length) return { matched: true };
    var i232;
    if (1 === e232.length) throw new Error(`\`P.map\` wasn't given enough arguments. Expected (key, value), received ${null == (i232 = e232[0]) ? void 0 : i232.toString()}`);
    const [s232, c232] = e232;
    return { matched: g34(t232, (t322, e322) => {
      const n322 = o34(s232, e322, r232), i322 = o34(c232, t322, r232);
      return n322 && i322;
    }), selections: n232 };
  }, getSelectionKeys: () => 0 === e232.length ? [] : [...s34(e232[0]), ...s34(e232[1])] }) });
}, intersection: m34, union: d34, not: function(e232) {
  return u34({ [t34]: () => ({ match: (t232) => ({ matched: !o34(e232, t232, () => {
  }) }), getSelectionKeys: () => [], matcherType: "not" }) });
}, when: y34, select: p34, any: S34, _: O34, string: E34, number: x34, bigint: P25, boolean: T34, symbol: k34, nullish: B34, nonNullable: _34, instanceOf: function(t232) {
  return u34(y34(/* @__PURE__ */ function(t322) {
    return (e232) => e232 instanceof t322;
  }(t232)));
}, shape: function(t232) {
  return u34(y34(a34(t232)));
} };
var KEYS233 = {
  ArrayExpression: [
    "elements"
  ],
  ArrayPattern: [
    "elements"
  ],
  ArrowFunctionExpression: [
    "params",
    "body"
  ],
  AssignmentExpression: [
    "left",
    "right"
  ],
  AssignmentPattern: [
    "left",
    "right"
  ],
  AwaitExpression: [
    "argument"
  ],
  BinaryExpression: [
    "left",
    "right"
  ],
  BlockStatement: [
    "body"
  ],
  BreakStatement: [
    "label"
  ],
  CallExpression: [
    "callee",
    "arguments"
  ],
  CatchClause: [
    "param",
    "body"
  ],
  ChainExpression: [
    "expression"
  ],
  ClassBody: [
    "body"
  ],
  ClassDeclaration: [
    "id",
    "superClass",
    "body"
  ],
  ClassExpression: [
    "id",
    "superClass",
    "body"
  ],
  ConditionalExpression: [
    "test",
    "consequent",
    "alternate"
  ],
  ContinueStatement: [
    "label"
  ],
  DebuggerStatement: [],
  DoWhileStatement: [
    "body",
    "test"
  ],
  EmptyStatement: [],
  ExperimentalRestProperty: [
    "argument"
  ],
  ExperimentalSpreadProperty: [
    "argument"
  ],
  ExportAllDeclaration: [
    "exported",
    "source"
  ],
  ExportDefaultDeclaration: [
    "declaration"
  ],
  ExportNamedDeclaration: [
    "declaration",
    "specifiers",
    "source"
  ],
  ExportSpecifier: [
    "exported",
    "local"
  ],
  ExpressionStatement: [
    "expression"
  ],
  ForInStatement: [
    "left",
    "right",
    "body"
  ],
  ForOfStatement: [
    "left",
    "right",
    "body"
  ],
  ForStatement: [
    "init",
    "test",
    "update",
    "body"
  ],
  FunctionDeclaration: [
    "id",
    "params",
    "body"
  ],
  FunctionExpression: [
    "id",
    "params",
    "body"
  ],
  Identifier: [],
  IfStatement: [
    "test",
    "consequent",
    "alternate"
  ],
  ImportDeclaration: [
    "specifiers",
    "source"
  ],
  ImportDefaultSpecifier: [
    "local"
  ],
  ImportExpression: [
    "source"
  ],
  ImportNamespaceSpecifier: [
    "local"
  ],
  ImportSpecifier: [
    "imported",
    "local"
  ],
  JSXAttribute: [
    "name",
    "value"
  ],
  JSXClosingElement: [
    "name"
  ],
  JSXClosingFragment: [],
  JSXElement: [
    "openingElement",
    "children",
    "closingElement"
  ],
  JSXEmptyExpression: [],
  JSXExpressionContainer: [
    "expression"
  ],
  JSXFragment: [
    "openingFragment",
    "children",
    "closingFragment"
  ],
  JSXIdentifier: [],
  JSXMemberExpression: [
    "object",
    "property"
  ],
  JSXNamespacedName: [
    "namespace",
    "name"
  ],
  JSXOpeningElement: [
    "name",
    "attributes"
  ],
  JSXOpeningFragment: [],
  JSXSpreadAttribute: [
    "argument"
  ],
  JSXSpreadChild: [
    "expression"
  ],
  JSXText: [],
  LabeledStatement: [
    "label",
    "body"
  ],
  Literal: [],
  LogicalExpression: [
    "left",
    "right"
  ],
  MemberExpression: [
    "object",
    "property"
  ],
  MetaProperty: [
    "meta",
    "property"
  ],
  MethodDefinition: [
    "key",
    "value"
  ],
  NewExpression: [
    "callee",
    "arguments"
  ],
  ObjectExpression: [
    "properties"
  ],
  ObjectPattern: [
    "properties"
  ],
  PrivateIdentifier: [],
  Program: [
    "body"
  ],
  Property: [
    "key",
    "value"
  ],
  PropertyDefinition: [
    "key",
    "value"
  ],
  RestElement: [
    "argument"
  ],
  ReturnStatement: [
    "argument"
  ],
  SequenceExpression: [
    "expressions"
  ],
  SpreadElement: [
    "argument"
  ],
  StaticBlock: [
    "body"
  ],
  Super: [],
  SwitchCase: [
    "test",
    "consequent"
  ],
  SwitchStatement: [
    "discriminant",
    "cases"
  ],
  TaggedTemplateExpression: [
    "tag",
    "quasi"
  ],
  TemplateElement: [],
  TemplateLiteral: [
    "quasis",
    "expressions"
  ],
  ThisExpression: [],
  ThrowStatement: [
    "argument"
  ],
  TryStatement: [
    "block",
    "handler",
    "finalizer"
  ],
  UnaryExpression: [
    "argument"
  ],
  UpdateExpression: [
    "argument"
  ],
  VariableDeclaration: [
    "declarations"
  ],
  VariableDeclarator: [
    "id",
    "init"
  ],
  WhileStatement: [
    "test",
    "body"
  ],
  WithStatement: [
    "object",
    "body"
  ],
  YieldExpression: [
    "argument"
  ]
};
var NODE_TYPES233 = Object.keys(KEYS233);
for (const type of NODE_TYPES233) {
  Object.freeze(KEYS233[type]);
}
Object.freeze(KEYS233);
var visitor_keys_default233 = KEYS233;
var KEY_BLACKLIST233 = /* @__PURE__ */ new Set([
  "parent",
  "leadingComments",
  "trailingComments"
]);
function filterKey233(key) {
  return !KEY_BLACKLIST233.has(key) && key[0] !== "_";
}
function getKeys233(node) {
  return Object.keys(node).filter(filterKey233);
}
function getInnermostScope233(initialScope, node) {
  const location = node.range[0];
  let scope = initialScope;
  let found = false;
  do {
    found = false;
    for (const childScope of scope.childScopes) {
      const range222 = childScope.block.range;
      if (range222[0] <= location && location < range222[1]) {
        scope = childScope;
        found = true;
        break;
      }
    }
  } while (found);
  return scope;
}
function findVariable2233(initialScope, nameOrNode) {
  let name22 = "";
  let scope = initialScope;
  if (typeof nameOrNode === "string") {
    name22 = nameOrNode;
  } else {
    name22 = nameOrNode.name;
    scope = getInnermostScope233(scope, nameOrNode);
  }
  while (scope != null) {
    const variable = scope.set.get(name22);
    if (variable != null) {
      return variable;
    }
    scope = scope.upper;
  }
  return null;
}
function negate0233(token) {
  return !this(token);
}
function negate233(f232) {
  return negate0233.bind(f232);
}
function isPunctuatorTokenWithValue233(token, value) {
  return token.type === "Punctuator" && token.value === value;
}
function isArrowToken233(token) {
  return isPunctuatorTokenWithValue233(token, "=>");
}
function isCommaToken233(token) {
  return isPunctuatorTokenWithValue233(token, ",");
}
function isSemicolonToken233(token) {
  return isPunctuatorTokenWithValue233(token, ";");
}
function isColonToken233(token) {
  return isPunctuatorTokenWithValue233(token, ":");
}
function isOpeningParenToken233(token) {
  return isPunctuatorTokenWithValue233(token, "(");
}
function isClosingParenToken233(token) {
  return isPunctuatorTokenWithValue233(token, ")");
}
function isOpeningBracketToken233(token) {
  return isPunctuatorTokenWithValue233(token, "[");
}
function isClosingBracketToken233(token) {
  return isPunctuatorTokenWithValue233(token, "]");
}
function isOpeningBraceToken233(token) {
  return isPunctuatorTokenWithValue233(token, "{");
}
function isClosingBraceToken233(token) {
  return isPunctuatorTokenWithValue233(token, "}");
}
function isCommentToken233(token) {
  return ["Block", "Line", "Shebang"].includes(token.type);
}
negate233(isArrowToken233);
negate233(isCommaToken233);
negate233(isSemicolonToken233);
negate233(isColonToken233);
negate233(isOpeningParenToken233);
negate233(isClosingParenToken233);
negate233(isOpeningBracketToken233);
negate233(isClosingBracketToken233);
negate233(isOpeningBraceToken233);
negate233(isClosingBraceToken233);
negate233(isCommentToken233);
function getOpeningParenOfParams233(node, sourceCode) {
  return node.id ? sourceCode.getTokenAfter(node.id, isOpeningParenToken233) : sourceCode.getFirstToken(node, isOpeningParenToken233);
}
function getFunctionHeadLocation233(node, sourceCode) {
  const parent = node.parent;
  let start = null;
  let end = null;
  if (node.type === "ArrowFunctionExpression") {
    const arrowToken = sourceCode.getTokenBefore(node.body, isArrowToken233);
    start = arrowToken.loc.start;
    end = arrowToken.loc.end;
  } else if (parent.type === "Property" || parent.type === "MethodDefinition" || parent.type === "PropertyDefinition") {
    start = parent.loc.start;
    end = getOpeningParenOfParams233(node, sourceCode).loc.start;
  } else {
    start = node.loc.start;
    end = getOpeningParenOfParams233(node, sourceCode).loc.start;
  }
  return {
    start: { ...start },
    end: { ...end }
  };
}
var globalObject233 = typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {};
var builtinNames233 = Object.freeze(
  /* @__PURE__ */ new Set([
    "Array",
    "ArrayBuffer",
    "BigInt",
    "BigInt64Array",
    "BigUint64Array",
    "Boolean",
    "DataView",
    "Date",
    "decodeURI",
    "decodeURIComponent",
    "encodeURI",
    "encodeURIComponent",
    "escape",
    "Float32Array",
    "Float64Array",
    "Function",
    "Infinity",
    "Int16Array",
    "Int32Array",
    "Int8Array",
    "isFinite",
    "isNaN",
    "isPrototypeOf",
    "JSON",
    "Map",
    "Math",
    "NaN",
    "Number",
    "Object",
    "parseFloat",
    "parseInt",
    "Promise",
    "Proxy",
    "Reflect",
    "RegExp",
    "Set",
    "String",
    "Symbol",
    "Uint16Array",
    "Uint32Array",
    "Uint8Array",
    "Uint8ClampedArray",
    "undefined",
    "unescape",
    "WeakMap",
    "WeakSet"
  ])
);
var callAllowed233 = new Set(
  [
    Array.isArray,
    Array.of,
    Array.prototype.at,
    Array.prototype.concat,
    Array.prototype.entries,
    Array.prototype.every,
    Array.prototype.filter,
    Array.prototype.find,
    Array.prototype.findIndex,
    Array.prototype.flat,
    Array.prototype.includes,
    Array.prototype.indexOf,
    Array.prototype.join,
    Array.prototype.keys,
    Array.prototype.lastIndexOf,
    Array.prototype.slice,
    Array.prototype.some,
    Array.prototype.toString,
    Array.prototype.values,
    typeof BigInt === "function" ? BigInt : void 0,
    Boolean,
    Date,
    Date.parse,
    decodeURI,
    decodeURIComponent,
    encodeURI,
    encodeURIComponent,
    escape,
    isFinite,
    isNaN,
    isPrototypeOf,
    Map,
    Map.prototype.entries,
    Map.prototype.get,
    Map.prototype.has,
    Map.prototype.keys,
    Map.prototype.values,
    ...Object.getOwnPropertyNames(Math).filter((k232) => k232 !== "random").map((k232) => Math[k232]).filter((f232) => typeof f232 === "function"),
    Number,
    Number.isFinite,
    Number.isNaN,
    Number.parseFloat,
    Number.parseInt,
    Number.prototype.toExponential,
    Number.prototype.toFixed,
    Number.prototype.toPrecision,
    Number.prototype.toString,
    Object,
    Object.entries,
    Object.is,
    Object.isExtensible,
    Object.isFrozen,
    Object.isSealed,
    Object.keys,
    Object.values,
    parseFloat,
    parseInt,
    RegExp,
    Set,
    Set.prototype.entries,
    Set.prototype.has,
    Set.prototype.keys,
    Set.prototype.values,
    String,
    String.fromCharCode,
    String.fromCodePoint,
    String.raw,
    String.prototype.at,
    String.prototype.charAt,
    String.prototype.charCodeAt,
    String.prototype.codePointAt,
    String.prototype.concat,
    String.prototype.endsWith,
    String.prototype.includes,
    String.prototype.indexOf,
    String.prototype.lastIndexOf,
    String.prototype.normalize,
    String.prototype.padEnd,
    String.prototype.padStart,
    String.prototype.slice,
    String.prototype.startsWith,
    String.prototype.substr,
    String.prototype.substring,
    String.prototype.toLowerCase,
    String.prototype.toString,
    String.prototype.toUpperCase,
    String.prototype.trim,
    String.prototype.trimEnd,
    String.prototype.trimLeft,
    String.prototype.trimRight,
    String.prototype.trimStart,
    Symbol.for,
    Symbol.keyFor,
    unescape
  ].filter((f232) => typeof f232 === "function")
);
var callPassThrough233 = /* @__PURE__ */ new Set([
  Object.freeze,
  Object.preventExtensions,
  Object.seal
]);
var getterAllowed233 = [
  [Map, /* @__PURE__ */ new Set(["size"])],
  [
    RegExp,
    /* @__PURE__ */ new Set([
      "dotAll",
      "flags",
      "global",
      "hasIndices",
      "ignoreCase",
      "multiline",
      "source",
      "sticky",
      "unicode"
    ])
  ],
  [Set, /* @__PURE__ */ new Set(["size"])]
];
function getPropertyDescriptor233(object32, name22) {
  let x232 = object32;
  while ((typeof x232 === "object" || typeof x232 === "function") && x232 !== null) {
    const d232 = Object.getOwnPropertyDescriptor(x232, name22);
    if (d232) {
      return d232;
    }
    x232 = Object.getPrototypeOf(x232);
  }
  return null;
}
function isGetter233(object32, name22) {
  const d232 = getPropertyDescriptor233(object32, name22);
  return d232 != null && d232.get != null;
}
function getElementValues233(nodeList, initialScope) {
  const valueList = [];
  for (let i232 = 0; i232 < nodeList.length; ++i232) {
    const elementNode = nodeList[i232];
    if (elementNode == null) {
      valueList.length = i232 + 1;
    } else if (elementNode.type === "SpreadElement") {
      const argument = getStaticValueR233(elementNode.argument, initialScope);
      if (argument == null) {
        return null;
      }
      valueList.push(...argument.value);
    } else {
      const element = getStaticValueR233(elementNode, initialScope);
      if (element == null) {
        return null;
      }
      valueList.push(element.value);
    }
  }
  return valueList;
}
function isEffectivelyConst233(variable) {
  const refs = variable.references;
  const inits = refs.filter((r232) => r232.init).length;
  const reads = refs.filter((r232) => r232.isReadOnly()).length;
  if (inits === 1 && reads + inits === refs.length) {
    return true;
  }
  return false;
}
var operations233 = Object.freeze({
  ArrayExpression(node, initialScope) {
    const elements = getElementValues233(node.elements, initialScope);
    return elements != null ? { value: elements } : null;
  },
  AssignmentExpression(node, initialScope) {
    if (node.operator === "=") {
      return getStaticValueR233(node.right, initialScope);
    }
    return null;
  },
  //eslint-disable-next-line complexity
  BinaryExpression(node, initialScope) {
    if (node.operator === "in" || node.operator === "instanceof") {
      return null;
    }
    const left3232 = getStaticValueR233(node.left, initialScope);
    const right3232 = getStaticValueR233(node.right, initialScope);
    if (left3232 != null && right3232 != null) {
      switch (node.operator) {
        case "==":
          return { value: left3232.value == right3232.value };
        case "!=":
          return { value: left3232.value != right3232.value };
        case "===":
          return { value: left3232.value === right3232.value };
        case "!==":
          return { value: left3232.value !== right3232.value };
        case "<":
          return { value: left3232.value < right3232.value };
        case "<=":
          return { value: left3232.value <= right3232.value };
        case ">":
          return { value: left3232.value > right3232.value };
        case ">=":
          return { value: left3232.value >= right3232.value };
        case "<<":
          return { value: left3232.value << right3232.value };
        case ">>":
          return { value: left3232.value >> right3232.value };
        case ">>>":
          return { value: left3232.value >>> right3232.value };
        case "+":
          return { value: left3232.value + right3232.value };
        case "-":
          return { value: left3232.value - right3232.value };
        case "*":
          return { value: left3232.value * right3232.value };
        case "/":
          return { value: left3232.value / right3232.value };
        case "%":
          return { value: left3232.value % right3232.value };
        case "**":
          return { value: left3232.value ** right3232.value };
        case "|":
          return { value: left3232.value | right3232.value };
        case "^":
          return { value: left3232.value ^ right3232.value };
        case "&":
          return { value: left3232.value & right3232.value };
      }
    }
    return null;
  },
  CallExpression(node, initialScope) {
    const calleeNode = node.callee;
    const args = getElementValues233(node.arguments, initialScope);
    if (args != null) {
      if (calleeNode.type === "MemberExpression") {
        if (calleeNode.property.type === "PrivateIdentifier") {
          return null;
        }
        const object32 = getStaticValueR233(calleeNode.object, initialScope);
        if (object32 != null) {
          if (object32.value == null && (object32.optional || node.optional)) {
            return { value: void 0, optional: true };
          }
          const property = getStaticPropertyNameValue233(
            calleeNode,
            initialScope
          );
          if (property != null) {
            const receiver = object32.value;
            const methodName = property.value;
            if (callAllowed233.has(receiver[methodName])) {
              return { value: receiver[methodName](...args) };
            }
            if (callPassThrough233.has(receiver[methodName])) {
              return { value: args[0] };
            }
          }
        }
      } else {
        const callee = getStaticValueR233(calleeNode, initialScope);
        if (callee != null) {
          if (callee.value == null && node.optional) {
            return { value: void 0, optional: true };
          }
          const func = callee.value;
          if (callAllowed233.has(func)) {
            return { value: func(...args) };
          }
          if (callPassThrough233.has(func)) {
            return { value: args[0] };
          }
        }
      }
    }
    return null;
  },
  ConditionalExpression(node, initialScope) {
    const test = getStaticValueR233(node.test, initialScope);
    if (test != null) {
      return test.value ? getStaticValueR233(node.consequent, initialScope) : getStaticValueR233(node.alternate, initialScope);
    }
    return null;
  },
  ExpressionStatement(node, initialScope) {
    return getStaticValueR233(node.expression, initialScope);
  },
  Identifier(node, initialScope) {
    if (initialScope != null) {
      const variable = findVariable2233(initialScope, node);
      if (variable != null && variable.defs.length === 0 && builtinNames233.has(variable.name) && variable.name in globalObject233) {
        return { value: globalObject233[variable.name] };
      }
      if (variable != null && variable.defs.length === 1) {
        const def = variable.defs[0];
        if (def.parent && def.type === "Variable" && (def.parent.kind === "const" || isEffectivelyConst233(variable)) && // TODO(mysticatea): don't support destructuring here.
        def.node.id.type === "Identifier") {
          return getStaticValueR233(def.node.init, initialScope);
        }
      }
    }
    return null;
  },
  Literal(node) {
    if ((node.regex != null || node.bigint != null) && node.value == null) {
      return null;
    }
    return { value: node.value };
  },
  LogicalExpression(node, initialScope) {
    const left3232 = getStaticValueR233(node.left, initialScope);
    if (left3232 != null) {
      if (node.operator === "||" && Boolean(left3232.value) === true || node.operator === "&&" && Boolean(left3232.value) === false || node.operator === "??" && left3232.value != null) {
        return left3232;
      }
      const right3232 = getStaticValueR233(node.right, initialScope);
      if (right3232 != null) {
        return right3232;
      }
    }
    return null;
  },
  MemberExpression(node, initialScope) {
    if (node.property.type === "PrivateIdentifier") {
      return null;
    }
    const object32 = getStaticValueR233(node.object, initialScope);
    if (object32 != null) {
      if (object32.value == null && (object32.optional || node.optional)) {
        return { value: void 0, optional: true };
      }
      const property = getStaticPropertyNameValue233(node, initialScope);
      if (property != null) {
        if (!isGetter233(object32.value, property.value)) {
          return { value: object32.value[property.value] };
        }
        for (const [classFn, allowed] of getterAllowed233) {
          if (object32.value instanceof classFn && allowed.has(property.value)) {
            return { value: object32.value[property.value] };
          }
        }
      }
    }
    return null;
  },
  ChainExpression(node, initialScope) {
    const expression = getStaticValueR233(node.expression, initialScope);
    if (expression != null) {
      return { value: expression.value };
    }
    return null;
  },
  NewExpression(node, initialScope) {
    const callee = getStaticValueR233(node.callee, initialScope);
    const args = getElementValues233(node.arguments, initialScope);
    if (callee != null && args != null) {
      const Func = callee.value;
      if (callAllowed233.has(Func)) {
        return { value: new Func(...args) };
      }
    }
    return null;
  },
  ObjectExpression(node, initialScope) {
    const object32 = {};
    for (const propertyNode of node.properties) {
      if (propertyNode.type === "Property") {
        if (propertyNode.kind !== "init") {
          return null;
        }
        const key = getStaticPropertyNameValue233(
          propertyNode,
          initialScope
        );
        const value = getStaticValueR233(propertyNode.value, initialScope);
        if (key == null || value == null) {
          return null;
        }
        object32[key.value] = value.value;
      } else if (propertyNode.type === "SpreadElement" || propertyNode.type === "ExperimentalSpreadProperty") {
        const argument = getStaticValueR233(
          propertyNode.argument,
          initialScope
        );
        if (argument == null) {
          return null;
        }
        Object.assign(object32, argument.value);
      } else {
        return null;
      }
    }
    return { value: object32 };
  },
  SequenceExpression(node, initialScope) {
    const last222 = node.expressions[node.expressions.length - 1];
    return getStaticValueR233(last222, initialScope);
  },
  TaggedTemplateExpression(node, initialScope) {
    const tag = getStaticValueR233(node.tag, initialScope);
    const expressions = getElementValues233(
      node.quasi.expressions,
      initialScope
    );
    if (tag != null && expressions != null) {
      const func = tag.value;
      const strings = node.quasi.quasis.map((q) => q.value.cooked);
      strings.raw = node.quasi.quasis.map((q) => q.value.raw);
      if (func === String.raw) {
        return { value: func(strings, ...expressions) };
      }
    }
    return null;
  },
  TemplateLiteral(node, initialScope) {
    const expressions = getElementValues233(node.expressions, initialScope);
    if (expressions != null) {
      let value = node.quasis[0].value.cooked;
      for (let i232 = 0; i232 < expressions.length; ++i232) {
        value += expressions[i232];
        value += node.quasis[i232 + 1].value.cooked;
      }
      return { value };
    }
    return null;
  },
  UnaryExpression(node, initialScope) {
    if (node.operator === "delete") {
      return null;
    }
    if (node.operator === "void") {
      return { value: void 0 };
    }
    const arg = getStaticValueR233(node.argument, initialScope);
    if (arg != null) {
      switch (node.operator) {
        case "-":
          return { value: -arg.value };
        case "+":
          return { value: +arg.value };
        case "!":
          return { value: !arg.value };
        case "~":
          return { value: ~arg.value };
        case "typeof":
          return { value: typeof arg.value };
      }
    }
    return null;
  }
});
function getStaticValueR233(node, initialScope) {
  if (node != null && Object.hasOwnProperty.call(operations233, node.type)) {
    return operations233[node.type](node, initialScope);
  }
  return null;
}
function getStaticPropertyNameValue233(node, initialScope) {
  const nameNode = node.type === "Property" ? node.key : node.property;
  if (node.computed) {
    return getStaticValueR233(nameNode, initialScope);
  }
  if (nameNode.type === "Identifier") {
    return { value: nameNode.name };
  }
  if (nameNode.type === "Literal") {
    if (nameNode.bigint) {
      return { value: nameNode.bigint };
    }
    return { value: String(nameNode.value) };
  }
  return null;
}
function getStaticValue233(node, initialScope = null) {
  try {
    return getStaticValueR233(node, initialScope);
  } catch (_error) {
    return null;
  }
}
function getStringIfConstant233(node, initialScope = null) {
  if (node && node.type === "Literal" && node.value === null) {
    if (node.regex) {
      return `/${node.regex.pattern}/${node.regex.flags}`;
    }
    if (node.bigint) {
      return node.bigint;
    }
  }
  const evaluated = getStaticValue233(node, initialScope);
  return evaluated && String(evaluated.value);
}
function getPropertyName233(node, initialScope) {
  switch (node.type) {
    case "MemberExpression":
      if (node.computed) {
        return getStringIfConstant233(node.property, initialScope);
      }
      if (node.property.type === "PrivateIdentifier") {
        return null;
      }
      return node.property.name;
    case "Property":
    case "MethodDefinition":
    case "PropertyDefinition":
      if (node.computed) {
        return getStringIfConstant233(node.key, initialScope);
      }
      if (node.key.type === "Literal") {
        return String(node.key.value);
      }
      if (node.key.type === "PrivateIdentifier") {
        return null;
      }
      return node.key.name;
  }
  return null;
}
function getFunctionNameWithKind233(node, sourceCode) {
  const parent = node.parent;
  const tokens = [];
  const isObjectMethod = parent.type === "Property" && parent.value === node;
  const isClassMethod = parent.type === "MethodDefinition" && parent.value === node;
  const isClassFieldMethod = parent.type === "PropertyDefinition" && parent.value === node;
  if (isClassMethod || isClassFieldMethod) {
    if (parent.static) {
      tokens.push("static");
    }
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push("private");
    }
  }
  if (node.async) {
    tokens.push("async");
  }
  if (node.generator) {
    tokens.push("generator");
  }
  if (isObjectMethod || isClassMethod) {
    if (parent.kind === "constructor") {
      return "constructor";
    }
    if (parent.kind === "get") {
      tokens.push("getter");
    } else if (parent.kind === "set") {
      tokens.push("setter");
    } else {
      tokens.push("method");
    }
  } else if (isClassFieldMethod) {
    tokens.push("method");
  } else {
    if (node.type === "ArrowFunctionExpression") {
      tokens.push("arrow");
    }
    tokens.push("function");
  }
  if (isObjectMethod || isClassMethod || isClassFieldMethod) {
    if (parent.key.type === "PrivateIdentifier") {
      tokens.push(`#${parent.key.name}`);
    } else {
      const name22 = getPropertyName233(parent);
      if (name22) {
        tokens.push(`'${name22}'`);
      } else if (sourceCode) {
        const keyText = sourceCode.getText(parent.key);
        if (!keyText.includes("\n")) {
          tokens.push(`[${keyText}]`);
        }
      }
    }
  } else if (node.id) {
    tokens.push(`'${node.id.name}'`);
  } else if (parent.type === "VariableDeclarator" && parent.id && parent.id.type === "Identifier") {
    tokens.push(`'${parent.id.name}'`);
  } else if ((parent.type === "AssignmentExpression" || parent.type === "AssignmentPattern") && parent.left && parent.left.type === "Identifier") {
    tokens.push(`'${parent.left.name}'`);
  } else if (parent.type === "ExportDefaultDeclaration" && parent.declaration === node) {
    tokens.push("'default'");
  }
  return tokens.join(" ");
}
var typeConversionBinaryOps233 = Object.freeze(
  /* @__PURE__ */ new Set([
    "==",
    "!=",
    "<",
    "<=",
    ">",
    ">=",
    "<<",
    ">>",
    ">>>",
    "+",
    "-",
    "*",
    "/",
    "%",
    "|",
    "^",
    "&",
    "in"
  ])
);
var typeConversionUnaryOps233 = Object.freeze(/* @__PURE__ */ new Set(["-", "+", "!", "~"]));
function isNode233(x232) {
  return x232 !== null && typeof x232 === "object" && typeof x232.type === "string";
}
var visitor233 = Object.freeze(
  Object.assign(/* @__PURE__ */ Object.create(null), {
    $visit(node, options, visitorKeys) {
      const { type } = node;
      if (typeof this[type] === "function") {
        return this[type](node, options, visitorKeys);
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    $visitChildren(node, options, visitorKeys) {
      const { type } = node;
      for (const key of visitorKeys[type] || getKeys233(node)) {
        const value = node[key];
        if (Array.isArray(value)) {
          for (const element of value) {
            if (isNode233(element) && this.$visit(element, options, visitorKeys)) {
              return true;
            }
          }
        } else if (isNode233(value) && this.$visit(value, options, visitorKeys)) {
          return true;
        }
      }
      return false;
    },
    ArrowFunctionExpression() {
      return false;
    },
    AssignmentExpression() {
      return true;
    },
    AwaitExpression() {
      return true;
    },
    BinaryExpression(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && typeConversionBinaryOps233.has(node.operator) && (node.left.type !== "Literal" || node.right.type !== "Literal")) {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    CallExpression() {
      return true;
    },
    FunctionExpression() {
      return false;
    },
    ImportExpression() {
      return true;
    },
    MemberExpression(node, options, visitorKeys) {
      if (options.considerGetters) {
        return true;
      }
      if (options.considerImplicitTypeConversion && node.computed && node.property.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    MethodDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    NewExpression() {
      return true;
    },
    Property(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    PropertyDefinition(node, options, visitorKeys) {
      if (options.considerImplicitTypeConversion && node.computed && node.key.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UnaryExpression(node, options, visitorKeys) {
      if (node.operator === "delete") {
        return true;
      }
      if (options.considerImplicitTypeConversion && typeConversionUnaryOps233.has(node.operator) && node.argument.type !== "Literal") {
        return true;
      }
      return this.$visitChildren(node, options, visitorKeys);
    },
    UpdateExpression() {
      return true;
    },
    YieldExpression() {
      return true;
    }
  })
);
function hasSideEffect233(node, sourceCode, { considerGetters = false, considerImplicitTypeConversion = false } = {}) {
  return visitor233.$visit(
    node,
    { considerGetters, considerImplicitTypeConversion },
    sourceCode.visitorKeys || visitor_keys_default233
  );
}
function getParentSyntaxParen233(node, sourceCode) {
  const parent = node.parent;
  switch (parent.type) {
    case "CallExpression":
    case "NewExpression":
      if (parent.arguments.length === 1 && parent.arguments[0] === node) {
        return sourceCode.getTokenAfter(
          parent.callee,
          isOpeningParenToken233
        );
      }
      return null;
    case "DoWhileStatement":
      if (parent.test === node) {
        return sourceCode.getTokenAfter(
          parent.body,
          isOpeningParenToken233
        );
      }
      return null;
    case "IfStatement":
    case "WhileStatement":
      if (parent.test === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "ImportExpression":
      if (parent.source === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "SwitchStatement":
      if (parent.discriminant === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    case "WithStatement":
      if (parent.object === node) {
        return sourceCode.getFirstToken(parent, 1);
      }
      return null;
    default:
      return null;
  }
}
function isParenthesized233(timesOrNode, nodeOrSourceCode, optionalSourceCode) {
  let times, node, sourceCode, maybeLeftParen, maybeRightParen;
  if (typeof timesOrNode === "number") {
    times = timesOrNode | 0;
    node = nodeOrSourceCode;
    sourceCode = optionalSourceCode;
    if (!(times >= 1)) {
      throw new TypeError("'times' should be a positive integer.");
    }
  } else {
    times = 1;
    node = timesOrNode;
    sourceCode = nodeOrSourceCode;
  }
  if (node == null || // `Program` can't be parenthesized
  node.parent == null || // `CatchClause.param` can't be parenthesized, example `try {} catch (error) {}`
  node.parent.type === "CatchClause" && node.parent.param === node) {
    return false;
  }
  maybeLeftParen = maybeRightParen = node;
  do {
    maybeLeftParen = sourceCode.getTokenBefore(maybeLeftParen);
    maybeRightParen = sourceCode.getTokenAfter(maybeRightParen);
  } while (maybeLeftParen != null && maybeRightParen != null && isOpeningParenToken233(maybeLeftParen) && isClosingParenToken233(maybeRightParen) && // Avoid false positive such as `if (a) {}`
  maybeLeftParen !== getParentSyntaxParen233(node, sourceCode) && --times > 0);
  return times === 0;
}
Function.call.bind(Object.hasOwnProperty);
var __defProp2233 = Object.defineProperty;
var __export2233 = (target, all3232) => {
  for (var name22 in all3232)
    __defProp2233(target, name22, { get: all3232[name22], enumerable: true });
};
var NodeType233 = types.AST_NODE_TYPES;
var is233 = utils.ASTUtils.isNodeOfType;
var isOneOf233 = utils.ASTUtils.isNodeOfTypes;
isOneOf233([
  NodeType233.ArrowFunctionExpression,
  NodeType233.FunctionDeclaration,
  NodeType233.FunctionExpression
]);
isOneOf233([
  NodeType233.ArrowFunctionExpression,
  NodeType233.FunctionDeclaration,
  NodeType233.FunctionExpression,
  NodeType233.TSCallSignatureDeclaration,
  NodeType233.TSConstructSignatureDeclaration,
  NodeType233.TSDeclareFunction,
  NodeType233.TSEmptyBodyFunctionExpression,
  NodeType233.TSFunctionType,
  NodeType233.TSMethodSignature
]);
isOneOf233([NodeType233.ClassDeclaration, NodeType233.ClassExpression]);
isOneOf233([
  NodeType233.DoWhileStatement,
  NodeType233.ForInStatement,
  NodeType233.ForOfStatement,
  NodeType233.ForStatement,
  NodeType233.WhileStatement
]);
isOneOf233([NodeType233.TSArrayType, NodeType233.TSTupleType]);
isOneOf233([
  NodeType233.PropertyDefinition,
  NodeType233.TSIndexSignature,
  NodeType233.TSParameterProperty,
  NodeType233.TSPropertySignature
]);
is233(NodeType233.JSXElement);
is233(NodeType233.JSXFragment);
isOneOf233([
  NodeType233.JSXAttribute,
  NodeType233.JSXSpreadChild,
  NodeType233.JSXClosingElement,
  NodeType233.JSXClosingFragment,
  NodeType233.JSXElement,
  NodeType233.JSXEmptyExpression,
  NodeType233.JSXExpressionContainer,
  NodeType233.JSXFragment,
  NodeType233.JSXIdentifier,
  NodeType233.JSXMemberExpression,
  NodeType233.JSXNamespacedName,
  NodeType233.JSXOpeningElement,
  NodeType233.JSXOpeningFragment,
  NodeType233.JSXSpreadAttribute,
  NodeType233.JSXSpreadChild,
  NodeType233.JSXText
]);
isOneOf233([
  NodeType233.JSXIdentifier,
  NodeType233.JSXMemberExpression,
  NodeType233.JSXNamespacedName
]);
isOneOf233([
  NodeType233.ArrayPattern,
  NodeType233.AssignmentPattern,
  NodeType233.ObjectPattern,
  NodeType233.RestElement
]);
isOneOf233([
  NodeType233.TSInterfaceDeclaration,
  NodeType233.TSTypeAliasDeclaration
]);
isOneOf233([
  NodeType233.ArrayExpression,
  NodeType233.ArrayPattern,
  NodeType233.ArrowFunctionExpression,
  NodeType233.CallExpression,
  NodeType233.ClassExpression,
  NodeType233.FunctionExpression,
  NodeType233.Identifier,
  NodeType233.JSXElement,
  NodeType233.JSXFragment,
  NodeType233.Literal,
  NodeType233.TemplateLiteral,
  NodeType233.MemberExpression,
  NodeType233.MetaProperty,
  NodeType233.ObjectExpression,
  NodeType233.ObjectPattern,
  NodeType233.SequenceExpression,
  NodeType233.Super,
  NodeType233.TaggedTemplateExpression,
  NodeType233.ThisExpression
]);
isOneOf233([
  NodeType233.ArrayExpression,
  NodeType233.ArrayPattern,
  NodeType233.ArrowFunctionExpression,
  NodeType233.CallExpression,
  NodeType233.ClassExpression,
  NodeType233.FunctionExpression,
  NodeType233.Identifier,
  NodeType233.JSXElement,
  NodeType233.JSXFragment,
  NodeType233.Literal,
  NodeType233.TemplateLiteral,
  NodeType233.MemberExpression,
  NodeType233.MetaProperty,
  NodeType233.ObjectExpression,
  NodeType233.ObjectPattern,
  NodeType233.SequenceExpression,
  NodeType233.Super,
  NodeType233.TaggedTemplateExpression,
  NodeType233.ThisExpression,
  NodeType233.TSAsExpression,
  NodeType233.TSNonNullExpression,
  NodeType233.TSTypeAssertion
]);
var Function_exports2233 = {};
__export2233(Function_exports2233, {
  SK: () => SK2233,
  absurd: () => absurd2233,
  apply: () => apply2233,
  compose: () => compose2244,
  constFalse: () => constFalse2233,
  constNull: () => constNull2233,
  constTrue: () => constTrue2233,
  constUndefined: () => constUndefined2233,
  constVoid: () => constVoid2233,
  constant: () => constant2233,
  dual: () => dual2233,
  flip: () => flip2233,
  flow: () => flow2233,
  hole: () => hole2233,
  identity: () => identity2233,
  isFunction: () => isFunction22233,
  pipe: () => pipe2233,
  satisfies: () => satisfies2233,
  tupled: () => tupled2233,
  unsafeCoerce: () => unsafeCoerce2233,
  untupled: () => untupled2233
});
var isFunction22233 = (input) => typeof input === "function";
var dual2233 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a232, b232) {
        if (arguments.length >= 2) {
          return body(a232, b232);
        }
        return function(self2) {
          return body(self2, a232);
        };
      };
    case 3:
      return function(a232, b232, c232) {
        if (arguments.length >= 3) {
          return body(a232, b232, c232);
        }
        return function(self2) {
          return body(self2, a232, b232);
        };
      };
    case 4:
      return function(a232, b232, c232, d232) {
        if (arguments.length >= 4) {
          return body(a232, b232, c232, d232);
        }
        return function(self2) {
          return body(self2, a232, b232, c232);
        };
      };
    case 5:
      return function(a232, b232, c232, d232, e232) {
        if (arguments.length >= 5) {
          return body(a232, b232, c232, d232, e232);
        }
        return function(self2) {
          return body(self2, a232, b232, c232, d232);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply2233 = (a232) => (self2) => self2(a232);
var identity2233 = (a232) => a232;
var satisfies2233 = () => (b232) => b232;
var unsafeCoerce2233 = identity2233;
var constant2233 = (value) => () => value;
var constTrue2233 = /* @__PURE__ */ constant2233(true);
var constFalse2233 = /* @__PURE__ */ constant2233(false);
var constNull2233 = /* @__PURE__ */ constant2233(null);
var constUndefined2233 = /* @__PURE__ */ constant2233(void 0);
var constVoid2233 = constUndefined2233;
var flip2233 = (f232) => (...b232) => (...a232) => f232(...a232)(...b232);
var compose2244 = /* @__PURE__ */ dual2233(2, (ab, bc) => (a232) => bc(ab(a232)));
var absurd2233 = (_232) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled2233 = (f232) => (a232) => f232(...a232);
var untupled2233 = (f232) => (...a232) => f232(a232);
function pipe2233(a232, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a232;
    case 2:
      return ab(a232);
    case 3:
      return bc(ab(a232));
    case 4:
      return cd(bc(ab(a232)));
    case 5:
      return de(cd(bc(ab(a232))));
    case 6:
      return ef(de(cd(bc(ab(a232)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a232))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a232)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a232))))))));
    default: {
      let ret = arguments[0];
      for (let i232 = 1; i232 < arguments.length; i232++) {
        ret = arguments[i232](ret);
      }
      return ret;
    }
  }
}
function flow2233(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole2233 = /* @__PURE__ */ unsafeCoerce2233(absurd2233);
var SK2233 = (_232, b232) => b232;
var make4244 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_3233 = (map622) => dual2233(3, (self2, name22, f232) => map622(self2, (a232) => Object.assign({}, a232, {
  [name22]: f232(a232)
})));
var bindTo3233 = (map622) => dual2233(2, (self2, name22) => map622(self2, (a232) => ({
  [name22]: a232
})));
var bind3233 = (map622, flatMap4222) => dual2233(3, (self2, name22, f232) => flatMap4222(self2, (a232) => map622(f232(a232), (b232) => Object.assign({}, a232, {
  [name22]: b232
}))));
var moduleVersion2233 = "3.2.8";
var getCurrentVersion2233 = () => moduleVersion2233;
var globalStoreId2233 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion2233()}`);
if (!(globalStoreId2233 in globalThis)) {
  globalThis[globalStoreId2233] = /* @__PURE__ */ new Map();
}
var globalStore2233 = globalThis[globalStoreId2233];
var globalValue2233 = (id, compute) => {
  if (!globalStore2233.has(id)) {
    globalStore2233.set(id, compute());
  }
  return globalStore2233.get(id);
};
var Predicate_exports2233 = {};
__export2233(Predicate_exports2233, {
  all: () => all2244,
  and: () => and323,
  compose: () => compose22233,
  eqv: () => eqv323,
  every: () => every423,
  hasProperty: () => hasProperty2233,
  implies: () => implies323,
  isBigInt: () => isBigInt323,
  isBoolean: () => isBoolean323,
  isDate: () => isDate323,
  isError: () => isError323,
  isFunction: () => isFunction3244,
  isIterable: () => isIterable323,
  isMap: () => isMap323,
  isNever: () => isNever323,
  isNotNull: () => isNotNull323,
  isNotNullable: () => isNotNullable323,
  isNotUndefined: () => isNotUndefined323,
  isNull: () => isNull323,
  isNullable: () => isNullable2233,
  isNumber: () => isNumber323,
  isObject: () => isObject2233,
  isPromise: () => isPromise323,
  isPromiseLike: () => isPromiseLike323,
  isReadonlyRecord: () => isReadonlyRecord323,
  isRecord: () => isRecord323,
  isSet: () => isSet323,
  isString: () => isString323,
  isSymbol: () => isSymbol323,
  isTagged: () => isTagged323,
  isTruthy: () => isTruthy323,
  isUint8Array: () => isUint8Array323,
  isUndefined: () => isUndefined323,
  isUnknown: () => isUnknown323,
  mapInput: () => mapInput423,
  nand: () => nand323,
  nor: () => nor323,
  not: () => not323,
  or: () => or323,
  product: () => product2244,
  productMany: () => productMany2244,
  some: () => some3244,
  struct: () => struct523,
  tuple: () => tuple423,
  xor: () => xor323
});
var mapInput423 = /* @__PURE__ */ dual2233(2, (self2, f232) => (b232) => self2(f232(b232)));
var isTruthy323 = (input) => !!input;
var isSet323 = (input) => input instanceof Set;
var isMap323 = (input) => input instanceof Map;
var isString323 = (input) => typeof input === "string";
var isNumber323 = (input) => typeof input === "number";
var isBoolean323 = (input) => typeof input === "boolean";
var isBigInt323 = (input) => typeof input === "bigint";
var isSymbol323 = (input) => typeof input === "symbol";
var isFunction3244 = isFunction22233;
var isUndefined323 = (input) => input === void 0;
var isNotUndefined323 = (input) => input !== void 0;
var isNull323 = (input) => input === null;
var isNotNull323 = (input) => input !== null;
var isNever323 = (_232) => false;
var isUnknown323 = (_232) => true;
var isRecordOrArray2233 = (input) => typeof input === "object" && input !== null;
var isObject2233 = (input) => isRecordOrArray2233(input) || isFunction3244(input);
var hasProperty2233 = /* @__PURE__ */ dual2233(2, (self2, property) => isObject2233(self2) && property in self2);
var isTagged323 = /* @__PURE__ */ dual2233(2, (self2, tag) => hasProperty2233(self2, "_tag") && self2["_tag"] === tag);
var isNullable2233 = (input) => input === null || input === void 0;
var isNotNullable323 = (input) => input !== null && input !== void 0;
var isError323 = (input) => input instanceof Error;
var isUint8Array323 = (input) => input instanceof Uint8Array;
var isDate323 = (input) => input instanceof Date;
var isIterable323 = (input) => hasProperty2233(input, Symbol.iterator);
var isRecord323 = (input) => isRecordOrArray2233(input) && !Array.isArray(input);
var isReadonlyRecord323 = isRecord323;
var isPromise323 = (input) => hasProperty2233(input, "then") && "catch" in input && isFunction3244(input.then) && isFunction3244(input.catch);
var isPromiseLike323 = (input) => hasProperty2233(input, "then") && isFunction3244(input.then);
var compose22233 = /* @__PURE__ */ dual2233(2, (ab, bc) => (a232) => ab(a232) && bc(a232));
var product2244 = (self2, that) => ([a232, b232]) => self2(a232) && that(b232);
var all2244 = (collection) => {
  return (as22232) => {
    let collectionIndex = 0;
    for (const p232 of collection) {
      if (collectionIndex >= as22232.length) {
        break;
      }
      if (p232(as22232[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany2244 = (self2, collection) => {
  const rest = all2244(collection);
  return ([head222, ...tail222]) => self2(head222) === false ? false : rest(tail222);
};
var tuple423 = (...elements) => all2244(elements);
var struct523 = (fields) => {
  const keys2232 = Object.keys(fields);
  return (a232) => {
    for (const key of keys2232) {
      if (!fields[key](a232[key])) {
        return false;
      }
    }
    return true;
  };
};
var not323 = (self2) => (a232) => !self2(a232);
var or323 = /* @__PURE__ */ dual2233(2, (self2, that) => (a232) => self2(a232) || that(a232));
var and323 = /* @__PURE__ */ dual2233(2, (self2, that) => (a232) => self2(a232) && that(a232));
var xor323 = /* @__PURE__ */ dual2233(2, (self2, that) => (a232) => self2(a232) !== that(a232));
var eqv323 = /* @__PURE__ */ dual2233(2, (self2, that) => (a232) => self2(a232) === that(a232));
var implies323 = /* @__PURE__ */ dual2233(2, (self2, that) => (a232) => self2(a232) ? that(a232) : true);
var nor323 = /* @__PURE__ */ dual2233(2, (self2, that) => (a232) => !(self2(a232) || that(a232)));
var nand323 = /* @__PURE__ */ dual2233(2, (self2, that) => (a232) => !(self2(a232) && that(a232)));
var every423 = (collection) => (a232) => {
  for (const p232 of collection) {
    if (!p232(a232)) {
      return false;
    }
  }
  return true;
};
var some3244 = (collection) => (a232) => {
  for (const p232 of collection) {
    if (p232(a232)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage2233 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId2233 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind2233 = (u232) => isObject2233(u232) && GenKindTypeId2233 in u232;
var GenKindImpl2233 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity2233;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_232) => _232;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId2233] = GenKindTypeId2233;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen2244(this);
  }
};
var SingleShotGen2244 = class _SingleShotGen423 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a232) {
    return this.called ? {
      value: a232,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a232) {
    return {
      value: a232,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e232) {
    throw e232;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen423(this.self);
  }
};
var adapter3233 = () => function() {
  let x232 = arguments[0];
  for (let i232 = 1; i232 < arguments.length; i232++) {
    x232 = arguments[i232](x232);
  }
  return new GenKindImpl2233(x232);
};
var defaultIncHi2233 = 335903614;
var defaultIncLo2233 = 4150755663;
var MUL_HI2233 = 1481765933 >>> 0;
var MUL_LO2233 = 1284865837 >>> 0;
var BIT_532233 = 9007199254740992;
var BIT_272233 = 134217728;
var PCGRandom2233 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable2233(seedLo) && isNullable2233(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable2233(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable2233(incLo) && isNullable2233(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo2233;
      incHi = this._state ? this._state[2] : defaultIncHi2233;
    } else if (isNullable2233(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add642233(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max322) {
    if (!max322) {
      return this._next();
    }
    max322 = max322 >>> 0;
    if ((max322 & max322 - 1) === 0) {
      return this._next() & max322 - 1;
    }
    let num = 0;
    const skew = (-max322 >>> 0) % max322 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max322;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_272233 + lo) / BIT_532233;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul642233(this._state, oldHi, oldLo, MUL_HI2233, MUL_LO2233);
    add642233(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul642233(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add642233(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId2233 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap2233 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId2233]() {
    return this.#value;
  }
};
function yieldWrapGet2233(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId2233 in self2) {
    return self2[YieldWrapTypeId2233]();
  }
  throw new Error(getBugErrorMessage2233("yieldWrapGet"));
}
var structuralRegionState2233 = /* @__PURE__ */ globalValue2233("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache2233 = /* @__PURE__ */ globalValue2233(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr2233 = /* @__PURE__ */ globalValue2233(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom2233());
var symbol3233 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash2233 = (self2) => {
  if (structuralRegionState2233.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number2233(self2);
    case "bigint":
      return string2233(self2.toString(10));
    case "boolean":
      return string2233(String(self2));
    case "symbol":
      return string2233(String(self2));
    case "string":
      return string2233(self2);
    case "undefined":
      return string2233("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string2233("null");
      } else if (self2 instanceof Date) {
        return hash2233(self2.toISOString());
      } else if (isHash2233(self2)) {
        return self2[symbol3233]();
      } else {
        return random2233(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random2233 = (self2) => {
  if (!randomHashCache2233.has(self2)) {
    randomHashCache2233.set(self2, number2233(pcgr2233.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache2233.get(self2);
};
var combine2244 = (b232) => (self2) => self2 * 53 ^ b232;
var optimize2233 = (n232) => n232 & 3221225471 | n232 >>> 1 & 1073741824;
var isHash2233 = (u232) => hasProperty2233(u232, symbol3233);
var number2233 = (n232) => {
  if (n232 !== n232 || n232 === Infinity) {
    return 0;
  }
  let h232 = n232 | 0;
  if (h232 !== n232) {
    h232 ^= n232 * 4294967295;
  }
  while (n232 > 4294967295) {
    h232 ^= n232 /= 4294967295;
  }
  return optimize2233(n232);
};
var string2233 = (str) => {
  let h232 = 5381, i232 = str.length;
  while (i232) {
    h232 = h232 * 33 ^ str.charCodeAt(--i232);
  }
  return optimize2233(h232);
};
var structureKeys2233 = (o232, keys2232) => {
  let h232 = 12289;
  for (let i232 = 0; i232 < keys2232.length; i232++) {
    h232 ^= pipe2233(string2233(keys2232[i232]), combine2244(hash2233(o232[keys2232[i232]])));
  }
  return optimize2233(h232);
};
var structure2233 = (o232) => structureKeys2233(o232, Object.keys(o232));
var array523 = (arr) => {
  let h232 = 6151;
  for (let i232 = 0; i232 < arr.length; i232++) {
    h232 = pipe2233(h232, combine2244(hash2233(arr[i232])));
  }
  return optimize2233(h232);
};
var cached2233 = function() {
  if (arguments.length === 1) {
    const self22 = arguments[0];
    return function(hash3222) {
      Object.defineProperty(self22, symbol3233, {
        value() {
          return hash3222;
        },
        enumerable: false
      });
      return hash3222;
    };
  }
  const self2 = arguments[0];
  const hash22232 = arguments[1];
  Object.defineProperty(self2, symbol3233, {
    value() {
      return hash22232;
    },
    enumerable: false
  });
  return hash22232;
};
var symbol22233 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals2233() {
  if (arguments.length === 1) {
    return (self2) => compareBoth2233(self2, arguments[0]);
  }
  return compareBoth2233(arguments[0], arguments[1]);
}
function compareBoth2233(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual2233(self2) && isEqual2233(that)) {
        if (hash2233(self2) === hash2233(that) && self2[symbol22233](that)) {
          return true;
        } else {
          return structuralRegionState2233.enabled && structuralRegionState2233.tester ? structuralRegionState2233.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState2233.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v232, i232) => compareBoth2233(v232, that[i232]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth2233(self2[key], that[key]))) {
              return structuralRegionState2233.tester ? structuralRegionState2233.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState2233.tester ? structuralRegionState2233.tester(self2, that) : false;
    }
  }
  return structuralRegionState2233.enabled && structuralRegionState2233.tester ? structuralRegionState2233.tester(self2, that) : false;
}
var isEqual2233 = (u232) => hasProperty2233(u232, symbol22233);
var equivalence2233 = () => equals2233;
var NodeInspectSymbol2233 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON2233 = (x232) => {
  if (hasProperty2233(x232, "toJSON") && isFunction3244(x232["toJSON"]) && x232["toJSON"].length === 0) {
    return x232.toJSON();
  } else if (Array.isArray(x232)) {
    return x232.map(toJSON2233);
  }
  return x232;
};
var format2233 = (x232) => JSON.stringify(x232, null, 2);
var pipeArguments2233 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i232 = 0, len = args.length; i232 < len; i232++) {
        ret = args[i232](ret);
      }
      return ret;
    }
  }
};
var OP_COMMIT2233 = "Commit";
var OP_FAILURE233 = "Failure";
var OP_WITH_RUNTIME233 = "WithRuntime";
var EffectTypeId2244 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId2233 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId2233 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId2233 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance2233 = {
  /* c8 ignore next */
  _R: (_232) => _232,
  /* c8 ignore next */
  _E: (_232) => _232,
  /* c8 ignore next */
  _A: (_232) => _232,
  _V: /* @__PURE__ */ getCurrentVersion2233()
};
var sinkVariance2233 = {
  /* c8 ignore next */
  _A: (_232) => _232,
  /* c8 ignore next */
  _In: (_232) => _232,
  /* c8 ignore next */
  _L: (_232) => _232,
  /* c8 ignore next */
  _E: (_232) => _232,
  /* c8 ignore next */
  _R: (_232) => _232
};
var channelVariance2233 = {
  /* c8 ignore next */
  _Env: (_232) => _232,
  /* c8 ignore next */
  _InErr: (_232) => _232,
  /* c8 ignore next */
  _InElem: (_232) => _232,
  /* c8 ignore next */
  _InDone: (_232) => _232,
  /* c8 ignore next */
  _OutErr: (_232) => _232,
  /* c8 ignore next */
  _OutElem: (_232) => _232,
  /* c8 ignore next */
  _OutDone: (_232) => _232
};
var EffectPrototype2233 = {
  [EffectTypeId2244]: effectVariance2233,
  [StreamTypeId2233]: effectVariance2233,
  [SinkTypeId2233]: sinkVariance2233,
  [ChannelTypeId2233]: channelVariance2233,
  [symbol22233](that) {
    return this === that;
  },
  [symbol3233]() {
    return cached2233(this, random2233(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen2244(new YieldWrap2233(this));
  },
  pipe() {
    return pipeArguments2233(this, arguments);
  }
};
var StructuralPrototype2233 = {
  [symbol3233]() {
    return cached2233(this, structure2233(this));
  },
  [symbol22233](that) {
    const selfKeys = Object.keys(this);
    const thatKeys = Object.keys(that);
    if (selfKeys.length !== thatKeys.length) {
      return false;
    }
    for (const key of selfKeys) {
      if (!(key in that && equals2233(this[key], that[key]))) {
        return false;
      }
    }
    return true;
  }
};
var CommitPrototype2233 = {
  ...EffectPrototype2233,
  _op: OP_COMMIT2233
};
var StructuralCommitPrototype2233 = {
  ...CommitPrototype2233,
  ...StructuralPrototype2233
};
var TypeId5244 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto3233 = {
  ...EffectPrototype2233,
  [TypeId5244]: {
    _A: (_232) => _232
  },
  [NodeInspectSymbol2233]() {
    return this.toJSON();
  },
  toString() {
    return format2233(this.toJSON());
  }
};
var SomeProto2233 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto3233), {
  _tag: "Some",
  _op: "Some",
  [symbol22233](that) {
    return isOption3233(that) && isSome3233(that) && equals2233(this.value, that.value);
  },
  [symbol3233]() {
    return cached2233(this, combine2244(hash2233(this._tag))(hash2233(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON2233(this.value)
    };
  }
});
var NoneHash2233 = /* @__PURE__ */ hash2233("None");
var NoneProto2233 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto3233), {
  _tag: "None",
  _op: "None",
  [symbol22233](that) {
    return isOption3233(that) && isNone3233(that);
  },
  [symbol3233]() {
    return NoneHash2233;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption3233 = (input) => hasProperty2233(input, TypeId5244);
var isNone3233 = (fa) => fa._tag === "None";
var isSome3233 = (fa) => fa._tag === "Some";
var none3233 = /* @__PURE__ */ Object.create(NoneProto2233);
var some22233 = (value) => {
  const a232 = Object.create(SomeProto2233);
  a232.value = value;
  return a232;
};
var TypeId22233 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto22233 = {
  ...EffectPrototype2233,
  [TypeId22233]: {
    _R: (_232) => _232
  },
  [NodeInspectSymbol2233]() {
    return this.toJSON();
  },
  toString() {
    return format2233(this.toJSON());
  }
};
var RightProto2233 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto22233), {
  _tag: "Right",
  _op: "Right",
  [symbol22233](that) {
    return isEither2233(that) && isRight2233(that) && equals2233(this.right, that.right);
  },
  [symbol3233]() {
    return combine2244(hash2233(this._tag))(hash2233(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON2233(this.right)
    };
  }
});
var LeftProto2233 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto22233), {
  _tag: "Left",
  _op: "Left",
  [symbol22233](that) {
    return isEither2233(that) && isLeft2233(that) && equals2233(this.left, that.left);
  },
  [symbol3233]() {
    return combine2244(hash2233(this._tag))(hash2233(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON2233(this.left)
    };
  }
});
var isEither2233 = (input) => hasProperty2233(input, TypeId22233);
var isLeft2233 = (ma) => ma._tag === "Left";
var isRight2233 = (ma) => ma._tag === "Right";
var left2244 = (left3232) => {
  const a232 = Object.create(LeftProto2233);
  a232.left = left3232;
  return a232;
};
var right2244 = (right3232) => {
  const a232 = Object.create(RightProto2233);
  a232.right = right3232;
  return a232;
};
var getLeft3233 = (self2) => isRight2233(self2) ? none3233 : some22233(self2.left);
var getRight3233 = (self2) => isLeft2233(self2) ? none3233 : some22233(self2.right);
var right22233 = right2244;
var left22233 = left2244;
var Option_exports2233 = {};
__export2233(Option_exports2233, {
  Do: () => Do2233,
  TypeId: () => TypeId32233,
  all: () => all22233,
  andThen: () => andThen2233,
  ap: () => ap2233,
  as: () => as2233,
  asVoid: () => asVoid2233,
  bind: () => bind22233,
  bindTo: () => bindTo22233,
  composeK: () => composeK2233,
  contains: () => contains2233,
  containsWith: () => containsWith2233,
  exists: () => exists2233,
  filter: () => filter2233,
  filterMap: () => filterMap2233,
  firstSomeOf: () => firstSomeOf2233,
  flatMap: () => flatMap2233,
  flatMapNullable: () => flatMapNullable2233,
  flatten: () => flatten2233,
  fromIterable: () => fromIterable2244,
  fromNullable: () => fromNullable2233,
  gen: () => gen2233,
  getEquivalence: () => getEquivalence2244,
  getLeft: () => getLeft22233,
  getOrElse: () => getOrElse2233,
  getOrNull: () => getOrNull2233,
  getOrThrow: () => getOrThrow2233,
  getOrThrowWith: () => getOrThrowWith2233,
  getOrUndefined: () => getOrUndefined2233,
  getOrder: () => getOrder2233,
  getRight: () => getRight22233,
  isNone: () => isNone22233,
  isOption: () => isOption22233,
  isSome: () => isSome22233,
  let: () => let_22233,
  lift2: () => lift22233,
  liftNullable: () => liftNullable2233,
  liftPredicate: () => liftPredicate2233,
  liftThrowable: () => liftThrowable2233,
  map: () => map2233,
  match: () => match2233,
  none: () => none22233,
  orElse: () => orElse2233,
  orElseEither: () => orElseEither2233,
  orElseSome: () => orElseSome2233,
  partitionMap: () => partitionMap2233,
  product: () => product22233,
  productMany: () => productMany22233,
  reduceCompact: () => reduceCompact2233,
  some: () => some32233,
  tap: () => tap2233,
  toArray: () => toArray2233,
  toRefinement: () => toRefinement2233,
  void: () => void_2233,
  zipLeft: () => zipLeft2233,
  zipRight: () => zipRight2233,
  zipWith: () => zipWith2233
});
var make22233 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId32233 = /* @__PURE__ */ Symbol.for("effect/Option");
var none22233 = () => none3233;
var some32233 = some22233;
var isOption22233 = isOption3233;
var isNone22233 = isNone3233;
var isSome22233 = isSome3233;
var match2233 = /* @__PURE__ */ dual2233(2, (self2, {
  onNone,
  onSome
}) => isNone22233(self2) ? onNone() : onSome(self2.value));
var toRefinement2233 = (f232) => (a232) => isSome22233(f232(a232));
var fromIterable2244 = (collection) => {
  for (const a232 of collection) {
    return some32233(a232);
  }
  return none22233();
};
var getRight22233 = getRight3233;
var getLeft22233 = getLeft3233;
var getOrElse2233 = /* @__PURE__ */ dual2233(2, (self2, onNone) => isNone22233(self2) ? onNone() : self2.value);
var orElse2233 = /* @__PURE__ */ dual2233(2, (self2, that) => isNone22233(self2) ? that() : self2);
var orElseSome2233 = /* @__PURE__ */ dual2233(2, (self2, onNone) => isNone22233(self2) ? some32233(onNone()) : self2);
var orElseEither2233 = /* @__PURE__ */ dual2233(2, (self2, that) => isNone22233(self2) ? map2233(that(), right2244) : map2233(self2, left2244));
var firstSomeOf2233 = (collection) => {
  let out = none22233();
  for (out of collection) {
    if (isSome22233(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable2233 = (nullableValue) => nullableValue == null ? none22233() : some32233(nullableValue);
var liftNullable2233 = (f232) => (...a232) => fromNullable2233(f232(...a232));
var getOrNull2233 = /* @__PURE__ */ getOrElse2233(constNull2233);
var getOrUndefined2233 = /* @__PURE__ */ getOrElse2233(constUndefined2233);
var liftThrowable2233 = (f232) => (...a232) => {
  try {
    return some32233(f232(...a232));
  } catch (e232) {
    return none22233();
  }
};
var getOrThrowWith2233 = /* @__PURE__ */ dual2233(2, (self2, onNone) => {
  if (isSome22233(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow2233 = /* @__PURE__ */ getOrThrowWith2233(() => new Error("getOrThrow called on a None"));
var map2233 = /* @__PURE__ */ dual2233(2, (self2, f232) => isNone22233(self2) ? none22233() : some32233(f232(self2.value)));
var as2233 = /* @__PURE__ */ dual2233(2, (self2, b232) => map2233(self2, () => b232));
var asVoid2233 = /* @__PURE__ */ as2233(void 0);
var void_2233 = /* @__PURE__ */ some32233(void 0);
var flatMap2233 = /* @__PURE__ */ dual2233(2, (self2, f232) => isNone22233(self2) ? none22233() : f232(self2.value));
var andThen2233 = /* @__PURE__ */ dual2233(2, (self2, f232) => flatMap2233(self2, (a232) => {
  const b232 = isFunction22233(f232) ? f232(a232) : f232;
  return isOption22233(b232) ? b232 : some32233(b232);
}));
var flatMapNullable2233 = /* @__PURE__ */ dual2233(2, (self2, f232) => isNone22233(self2) ? none22233() : fromNullable2233(f232(self2.value)));
var flatten2233 = /* @__PURE__ */ flatMap2233(identity2233);
var zipRight2233 = /* @__PURE__ */ dual2233(2, (self2, that) => flatMap2233(self2, () => that));
var composeK2233 = /* @__PURE__ */ dual2233(2, (afb, bfc) => (a232) => flatMap2233(afb(a232), bfc));
var zipLeft2233 = /* @__PURE__ */ dual2233(2, (self2, that) => tap2233(self2, () => that));
var tap2233 = /* @__PURE__ */ dual2233(2, (self2, f232) => flatMap2233(self2, (a232) => map2233(f232(a232), () => a232)));
var product22233 = (self2, that) => isSome22233(self2) && isSome22233(that) ? some32233([self2.value, that.value]) : none22233();
var productMany22233 = (self2, collection) => {
  if (isNone22233(self2)) {
    return none22233();
  }
  const out = [self2.value];
  for (const o232 of collection) {
    if (isNone22233(o232)) {
      return none22233();
    }
    out.push(o232.value);
  }
  return some32233(out);
};
var all22233 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o232 of input) {
      if (isNone22233(o232)) {
        return none22233();
      }
      out2.push(o232.value);
    }
    return some32233(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o232 = input[key];
    if (isNone22233(o232)) {
      return none22233();
    }
    out[key] = o232.value;
  }
  return some32233(out);
};
var zipWith2233 = /* @__PURE__ */ dual2233(3, (self2, that, f232) => map2233(product22233(self2, that), ([a232, b232]) => f232(a232, b232)));
var ap2233 = /* @__PURE__ */ dual2233(2, (self2, that) => zipWith2233(self2, that, (f232, a232) => f232(a232)));
var reduceCompact2233 = /* @__PURE__ */ dual2233(3, (self2, b232, f232) => {
  let out = b232;
  for (const oa of self2) {
    if (isSome22233(oa)) {
      out = f232(out, oa.value);
    }
  }
  return out;
});
var toArray2233 = (self2) => isNone22233(self2) ? [] : [self2.value];
var partitionMap2233 = /* @__PURE__ */ dual2233(2, (self2, f232) => {
  if (isNone22233(self2)) {
    return [none22233(), none22233()];
  }
  const e232 = f232(self2.value);
  return isLeft2233(e232) ? [some32233(e232.left), none22233()] : [none22233(), some32233(e232.right)];
});
var filterMap2233 = /* @__PURE__ */ dual2233(2, (self2, f232) => isNone22233(self2) ? none22233() : f232(self2.value));
var filter2233 = /* @__PURE__ */ dual2233(2, (self2, predicate) => filterMap2233(self2, (b232) => predicate(b232) ? some22233(b232) : none3233));
var getEquivalence2244 = (isEquivalent) => make4244((x232, y232) => x232 === y232 || (isNone22233(x232) ? isNone22233(y232) : isNone22233(y232) ? false : isEquivalent(x232.value, y232.value)));
var getOrder2233 = (O232) => make22233((self2, that) => isSome22233(self2) ? isSome22233(that) ? O232(self2.value, that.value) : 1 : -1);
var lift22233 = (f232) => dual2233(2, (self2, that) => zipWith2233(self2, that, f232));
var liftPredicate2233 = (predicate) => (b232) => predicate(b232) ? some32233(b232) : none22233();
var containsWith2233 = (isEquivalent) => dual2233(2, (self2, a232) => isNone22233(self2) ? false : isEquivalent(self2.value, a232));
var _equivalence2244 = /* @__PURE__ */ equivalence2233();
var contains2233 = /* @__PURE__ */ containsWith2233(_equivalence2244);
var exists2233 = /* @__PURE__ */ dual2233(2, (self2, refinement) => isNone22233(self2) ? false : refinement(self2.value));
var bindTo22233 = /* @__PURE__ */ bindTo3233(map2233);
var let_22233 = /* @__PURE__ */ let_3233(map2233);
var bind22233 = /* @__PURE__ */ bind3233(map2233, flatMap2233);
var Do2233 = /* @__PURE__ */ some32233({});
var adapter22233 = /* @__PURE__ */ adapter3233();
var gen2233 = (f232) => {
  const iterator = f232(adapter22233);
  let state = iterator.next();
  if (state.done) {
    return some32233(state.value);
  } else {
    let current = state.value;
    if (isGenKind2233(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet2233(current);
    }
    if (isNone22233(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind2233(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet2233(current);
        }
        if (isNone22233(current)) {
          return current;
        }
      }
    }
    return some32233(state.value);
  }
};
var fromIterable22233 = (collection) => Array.isArray(collection) ? collection : Array.from(collection);
var reverse423 = (self2) => Array.from(self2).reverse();
var reduce523 = /* @__PURE__ */ dual2233(3, (self2, b232, f232) => fromIterable22233(self2).reduce((b2222, a232, i232) => f232(b2222, a232, i232), b232));
var TagTypeId233 = /* @__PURE__ */ Symbol.for("effect/Context/Tag");
var STMSymbolKey233 = "effect/STM";
var STMTypeId233 = /* @__PURE__ */ Symbol.for(STMSymbolKey233);
var TagProto233 = {
  ...EffectPrototype2233,
  _tag: "Tag",
  _op: "Tag",
  [STMTypeId233]: effectVariance2233,
  [TagTypeId233]: {
    _Service: (_232) => _232,
    _Identifier: (_232) => _232
  },
  toString() {
    return format2233(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Tag",
      key: this.key,
      stack: this.stack
    };
  },
  [NodeInspectSymbol2233]() {
    return this.toJSON();
  },
  of(self2) {
    return self2;
  },
  context(self2) {
    return make32233(this, self2);
  }
};
var makeGenericTag233 = (key) => {
  const limit = Error.stackTraceLimit;
  Error.stackTraceLimit = 2;
  const creationError = new Error();
  Error.stackTraceLimit = limit;
  const tag = Object.create(TagProto233);
  Object.defineProperty(tag, "stack", {
    get() {
      return creationError.stack;
    }
  });
  tag.key = key;
  return tag;
};
var TypeId42233 = /* @__PURE__ */ Symbol.for("effect/Context");
var ContextProto233 = {
  [TypeId42233]: {
    _Services: (_232) => _232
  },
  [symbol22233](that) {
    if (isContext233(that)) {
      if (this.unsafeMap.size === that.unsafeMap.size) {
        for (const k232 of this.unsafeMap.keys()) {
          if (!that.unsafeMap.has(k232) || !equals2233(this.unsafeMap.get(k232), that.unsafeMap.get(k232))) {
            return false;
          }
        }
        return true;
      }
    }
    return false;
  },
  [symbol3233]() {
    return cached2233(this, number2233(this.unsafeMap.size));
  },
  pipe() {
    return pipeArguments2233(this, arguments);
  },
  toString() {
    return format2233(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Context",
      services: Array.from(this.unsafeMap).map(toJSON2233)
    };
  },
  [NodeInspectSymbol2233]() {
    return this.toJSON();
  }
};
var makeContext233 = (unsafeMap) => {
  const context = Object.create(ContextProto233);
  context.unsafeMap = unsafeMap;
  return context;
};
var isContext233 = (u232) => hasProperty2233(u232, TypeId42233);
var _empty633 = /* @__PURE__ */ makeContext233(/* @__PURE__ */ new Map());
var empty1023 = () => _empty633;
var make32233 = (tag, service) => makeContext233(/* @__PURE__ */ new Map([[tag.key, service]]));
var GenericTag233 = makeGenericTag233;
var empty2233 = empty1023;
var TypeId52233 = /* @__PURE__ */ Symbol.for("effect/Chunk");
function copy323(src, srcPos, dest, destPos, len) {
  for (let i232 = srcPos; i232 < Math.min(src.length, srcPos + len); i232++) {
    dest[destPos + i232 - srcPos] = src[i232];
  }
  return dest;
}
var emptyArray233 = [];
var getEquivalence22233 = (isEquivalent) => make4244((self2, that) => self2.length === that.length && toReadonlyArray233(self2).every((value, i232) => isEquivalent(value, unsafeGet2233(that, i232))));
var _equivalence22233 = /* @__PURE__ */ getEquivalence22233(equals2233);
var ChunkProto233 = {
  [TypeId52233]: {
    _A: (_232) => _232
  },
  toString() {
    return format2233(this.toJSON());
  },
  toJSON() {
    return {
      _id: "Chunk",
      values: toReadonlyArray233(this).map(toJSON2233)
    };
  },
  [NodeInspectSymbol2233]() {
    return this.toJSON();
  },
  [symbol22233](that) {
    return isChunk233(that) && _equivalence22233(this, that);
  },
  [symbol3233]() {
    return cached2233(this, array523(toReadonlyArray233(this)));
  },
  [Symbol.iterator]() {
    switch (this.backing._tag) {
      case "IArray": {
        return this.backing.array[Symbol.iterator]();
      }
      case "IEmpty": {
        return emptyArray233[Symbol.iterator]();
      }
      default: {
        return toReadonlyArray233(this)[Symbol.iterator]();
      }
    }
  },
  pipe() {
    return pipeArguments2233(this, arguments);
  }
};
var makeChunk233 = (backing) => {
  const chunk = Object.create(ChunkProto233);
  chunk.backing = backing;
  switch (backing._tag) {
    case "IEmpty": {
      chunk.length = 0;
      chunk.depth = 0;
      chunk.left = chunk;
      chunk.right = chunk;
      break;
    }
    case "IConcat": {
      chunk.length = backing.left.length + backing.right.length;
      chunk.depth = 1 + Math.max(backing.left.depth, backing.right.depth);
      chunk.left = backing.left;
      chunk.right = backing.right;
      break;
    }
    case "IArray": {
      chunk.length = backing.array.length;
      chunk.depth = 0;
      chunk.left = _empty2233;
      chunk.right = _empty2233;
      break;
    }
    case "ISingleton": {
      chunk.length = 1;
      chunk.depth = 0;
      chunk.left = _empty2233;
      chunk.right = _empty2233;
      break;
    }
    case "ISlice": {
      chunk.length = backing.length;
      chunk.depth = backing.chunk.depth + 1;
      chunk.left = _empty2233;
      chunk.right = _empty2233;
      break;
    }
  }
  return chunk;
};
var isChunk233 = (u232) => hasProperty2233(u232, TypeId52233);
var _empty2233 = /* @__PURE__ */ makeChunk233({
  _tag: "IEmpty"
});
var empty3233 = () => _empty2233;
var make42233 = (...as22232) => as22232.length === 1 ? of323(as22232[0]) : unsafeFromNonEmptyArray233(as22232);
var of323 = (a232) => makeChunk233({
  _tag: "ISingleton",
  a: a232
});
var copyToArray233 = (self2, array3232, initial) => {
  switch (self2.backing._tag) {
    case "IArray": {
      copy323(self2.backing.array, 0, array3232, initial, self2.length);
      break;
    }
    case "IConcat": {
      copyToArray233(self2.left, array3232, initial);
      copyToArray233(self2.right, array3232, initial + self2.left.length);
      break;
    }
    case "ISingleton": {
      array3232[initial] = self2.backing.a;
      break;
    }
    case "ISlice": {
      let i232 = 0;
      let j232 = initial;
      while (i232 < self2.length) {
        array3232[j232] = unsafeGet2233(self2, i232);
        i232 += 1;
        j232 += 1;
      }
      break;
    }
  }
};
var toReadonlyArray233 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      return emptyArray233;
    }
    case "IArray": {
      return self2.backing.array;
    }
    default: {
      const arr = new Array(self2.length);
      copyToArray233(self2, arr, 0);
      self2.backing = {
        _tag: "IArray",
        array: arr
      };
      self2.left = _empty2233;
      self2.right = _empty2233;
      self2.depth = 0;
      return arr;
    }
  }
};
var reverse2233 = (self2) => {
  switch (self2.backing._tag) {
    case "IEmpty":
    case "ISingleton":
      return self2;
    case "IArray": {
      return makeChunk233({
        _tag: "IArray",
        array: reverse423(self2.backing.array)
      });
    }
    case "IConcat": {
      return makeChunk233({
        _tag: "IConcat",
        left: reverse2233(self2.backing.right),
        right: reverse2233(self2.backing.left)
      });
    }
    case "ISlice":
      return unsafeFromArray233(reverse423(toReadonlyArray233(self2)));
  }
};
var unsafeFromArray233 = (self2) => makeChunk233({
  _tag: "IArray",
  array: self2
});
var unsafeFromNonEmptyArray233 = (self2) => unsafeFromArray233(self2);
var unsafeGet2233 = /* @__PURE__ */ dual2233(2, (self2, index) => {
  switch (self2.backing._tag) {
    case "IEmpty": {
      throw new Error(`Index out of bounds`);
    }
    case "ISingleton": {
      if (index !== 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.a;
    }
    case "IArray": {
      if (index >= self2.length || index < 0) {
        throw new Error(`Index out of bounds`);
      }
      return self2.backing.array[index];
    }
    case "IConcat": {
      return index < self2.left.length ? unsafeGet2233(self2.left, index) : unsafeGet2233(self2.right, index - self2.left.length);
    }
    case "ISlice": {
      return unsafeGet2233(self2.backing.chunk, index + self2.backing.offset);
    }
  }
});
var prepend323 = /* @__PURE__ */ dual2233(2, (self2, elem) => appendAll323(of323(elem), self2));
var drop323 = /* @__PURE__ */ dual2233(2, (self2, n232) => {
  if (n232 <= 0) {
    return self2;
  } else if (n232 >= self2.length) {
    return _empty2233;
  } else {
    switch (self2.backing._tag) {
      case "ISlice": {
        return makeChunk233({
          _tag: "ISlice",
          chunk: self2.backing.chunk,
          offset: self2.backing.offset + n232,
          length: self2.backing.length - n232
        });
      }
      case "IConcat": {
        if (n232 > self2.left.length) {
          return drop323(self2.right, n232 - self2.left.length);
        }
        return makeChunk233({
          _tag: "IConcat",
          left: drop323(self2.left, n232),
          right: self2.right
        });
      }
      default: {
        return makeChunk233({
          _tag: "ISlice",
          chunk: self2,
          offset: n232,
          length: self2.length - n232
        });
      }
    }
  }
});
var appendAll323 = /* @__PURE__ */ dual2233(2, (self2, that) => {
  if (self2.backing._tag === "IEmpty") {
    return that;
  }
  if (that.backing._tag === "IEmpty") {
    return self2;
  }
  const diff2232 = that.depth - self2.depth;
  if (Math.abs(diff2232) <= 1) {
    return makeChunk233({
      _tag: "IConcat",
      left: self2,
      right: that
    });
  } else if (diff2232 < -1) {
    if (self2.left.depth >= self2.right.depth) {
      const nr = appendAll323(self2.right, that);
      return makeChunk233({
        _tag: "IConcat",
        left: self2.left,
        right: nr
      });
    } else {
      const nrr = appendAll323(self2.right.right, that);
      if (nrr.depth === self2.depth - 3) {
        const nr = makeChunk233({
          _tag: "IConcat",
          left: self2.right.left,
          right: nrr
        });
        return makeChunk233({
          _tag: "IConcat",
          left: self2.left,
          right: nr
        });
      } else {
        const nl = makeChunk233({
          _tag: "IConcat",
          left: self2.left,
          right: self2.right.left
        });
        return makeChunk233({
          _tag: "IConcat",
          left: nl,
          right: nrr
        });
      }
    }
  } else {
    if (that.right.depth >= that.left.depth) {
      const nl = appendAll323(self2, that.left);
      return makeChunk233({
        _tag: "IConcat",
        left: nl,
        right: that.right
      });
    } else {
      const nll = appendAll323(self2, that.left.left);
      if (nll.depth === that.depth - 3) {
        const nl = makeChunk233({
          _tag: "IConcat",
          left: nll,
          right: that.left.right
        });
        return makeChunk233({
          _tag: "IConcat",
          left: nl,
          right: that.right
        });
      } else {
        const nr = makeChunk233({
          _tag: "IConcat",
          left: that.left.right,
          right: that.right
        });
        return makeChunk233({
          _tag: "IConcat",
          left: nll,
          right: nr
        });
      }
    }
  }
});
var isEmpty233 = (self2) => self2.length === 0;
var isNonEmpty233 = (self2) => self2.length > 0;
var unsafeHead233 = (self2) => unsafeGet2233(self2, 0);
var headNonEmpty323 = unsafeHead233;
var tailNonEmpty323 = (self2) => drop323(self2, 1);
var SIZE233 = 5;
var BUCKET_SIZE233 = /* @__PURE__ */ Math.pow(2, SIZE233);
var MASK233 = BUCKET_SIZE233 - 1;
var MAX_INDEX_NODE233 = BUCKET_SIZE233 / 2;
var MIN_ARRAY_NODE233 = BUCKET_SIZE233 / 4;
function popcount233(x232) {
  x232 -= x232 >> 1 & 1431655765;
  x232 = (x232 & 858993459) + (x232 >> 2 & 858993459);
  x232 = x232 + (x232 >> 4) & 252645135;
  x232 += x232 >> 8;
  x232 += x232 >> 16;
  return x232 & 127;
}
function hashFragment233(shift22, h232) {
  return h232 >>> shift22 & MASK233;
}
function toBitmap233(x232) {
  return 1 << x232;
}
function fromBitmap233(bitmap, bit) {
  return popcount233(bitmap & bit - 1);
}
var make5233 = (value, previous) => ({
  value,
  previous
});
function arrayUpdate233(mutate2232, at, v232, arr) {
  let out = arr;
  if (!mutate2232) {
    const len = arr.length;
    out = new Array(len);
    for (let i232 = 0; i232 < len; ++i232) out[i232] = arr[i232];
  }
  out[at] = v232;
  return out;
}
function arraySpliceOut233(mutate2232, at, arr) {
  const newLen = arr.length - 1;
  let i232 = 0;
  let g232 = 0;
  let out = arr;
  if (mutate2232) {
    i232 = g232 = at;
  } else {
    out = new Array(newLen);
    while (i232 < at) out[g232++] = arr[i232++];
  }
  ++i232;
  while (i232 <= newLen) out[g232++] = arr[i232++];
  if (mutate2232) {
    out.length = newLen;
  }
  return out;
}
function arraySpliceIn233(mutate2232, at, v232, arr) {
  const len = arr.length;
  if (mutate2232) {
    let i2222 = len;
    while (i2222 >= at) arr[i2222--] = arr[i2222];
    arr[at] = v232;
    return arr;
  }
  let i232 = 0, g232 = 0;
  const out = new Array(len + 1);
  while (i232 < at) out[g232++] = arr[i232++];
  out[at] = v232;
  while (i232 < len) out[++g232] = arr[i232++];
  return out;
}
var EmptyNode233 = class _EmptyNode233 {
  _tag = "EmptyNode";
  modify(edit, _shift, f232, hash22232, key, size4232) {
    const v232 = f232(none22233());
    if (isNone22233(v232)) return new _EmptyNode233();
    ++size4232.value;
    return new LeafNode233(edit, hash22232, key, v232);
  }
};
function isEmptyNode233(a232) {
  return isTagged323(a232, "EmptyNode");
}
function isLeafNode233(node) {
  return isEmptyNode233(node) || node._tag === "LeafNode" || node._tag === "CollisionNode";
}
function canEditNode233(node, edit) {
  return isEmptyNode233(node) ? false : edit === node.edit;
}
var LeafNode233 = class _LeafNode233 {
  edit;
  hash;
  key;
  value;
  _tag = "LeafNode";
  constructor(edit, hash22232, key, value) {
    this.edit = edit;
    this.hash = hash22232;
    this.key = key;
    this.value = value;
  }
  modify(edit, shift22, f232, hash22232, key, size4232) {
    if (equals2233(key, this.key)) {
      const v2222 = f232(this.value);
      if (v2222 === this.value) return this;
      else if (isNone22233(v2222)) {
        --size4232.value;
        return new EmptyNode233();
      }
      if (canEditNode233(this, edit)) {
        this.value = v2222;
        return this;
      }
      return new _LeafNode233(edit, hash22232, key, v2222);
    }
    const v232 = f232(none22233());
    if (isNone22233(v232)) return this;
    ++size4232.value;
    return mergeLeaves233(edit, shift22, this.hash, this, hash22232, new _LeafNode233(edit, hash22232, key, v232));
  }
};
var CollisionNode233 = class _CollisionNode233 {
  edit;
  hash;
  children;
  _tag = "CollisionNode";
  constructor(edit, hash22232, children) {
    this.edit = edit;
    this.hash = hash22232;
    this.children = children;
  }
  modify(edit, shift22, f232, hash22232, key, size4232) {
    if (hash22232 === this.hash) {
      const canEdit = canEditNode233(this, edit);
      const list = this.updateCollisionList(canEdit, edit, this.hash, this.children, f232, key, size4232);
      if (list === this.children) return this;
      return list.length > 1 ? new _CollisionNode233(edit, this.hash, list) : list[0];
    }
    const v232 = f232(none22233());
    if (isNone22233(v232)) return this;
    ++size4232.value;
    return mergeLeaves233(edit, shift22, this.hash, this, hash22232, new LeafNode233(edit, hash22232, key, v232));
  }
  updateCollisionList(mutate2232, edit, hash22232, list, f232, key, size4232) {
    const len = list.length;
    for (let i232 = 0; i232 < len; ++i232) {
      const child = list[i232];
      if ("key" in child && equals2233(key, child.key)) {
        const value = child.value;
        const newValue2 = f232(value);
        if (newValue2 === value) return list;
        if (isNone22233(newValue2)) {
          --size4232.value;
          return arraySpliceOut233(mutate2232, i232, list);
        }
        return arrayUpdate233(mutate2232, i232, new LeafNode233(edit, hash22232, key, newValue2), list);
      }
    }
    const newValue = f232(none22233());
    if (isNone22233(newValue)) return list;
    ++size4232.value;
    return arrayUpdate233(mutate2232, len, new LeafNode233(edit, hash22232, key, newValue), list);
  }
};
var IndexedNode233 = class _IndexedNode233 {
  edit;
  mask;
  children;
  _tag = "IndexedNode";
  constructor(edit, mask, children) {
    this.edit = edit;
    this.mask = mask;
    this.children = children;
  }
  modify(edit, shift22, f232, hash22232, key, size4232) {
    const mask = this.mask;
    const children = this.children;
    const frag = hashFragment233(shift22, hash22232);
    const bit = toBitmap233(frag);
    const indx = fromBitmap233(mask, bit);
    const exists22232 = mask & bit;
    const canEdit = canEditNode233(this, edit);
    if (!exists22232) {
      const _newChild = new EmptyNode233().modify(edit, shift22 + SIZE233, f232, hash22232, key, size4232);
      if (!_newChild) return this;
      return children.length >= MAX_INDEX_NODE233 ? expand233(edit, frag, _newChild, mask, children) : new _IndexedNode233(edit, mask | bit, arraySpliceIn233(canEdit, indx, _newChild, children));
    }
    const current = children[indx];
    const child = current.modify(edit, shift22 + SIZE233, f232, hash22232, key, size4232);
    if (current === child) return this;
    let bitmap = mask;
    let newChildren;
    if (isEmptyNode233(child)) {
      bitmap &= ~bit;
      if (!bitmap) return new EmptyNode233();
      if (children.length <= 2 && isLeafNode233(children[indx ^ 1])) {
        return children[indx ^ 1];
      }
      newChildren = arraySpliceOut233(canEdit, indx, children);
    } else {
      newChildren = arrayUpdate233(canEdit, indx, child, children);
    }
    if (canEdit) {
      this.mask = bitmap;
      this.children = newChildren;
      return this;
    }
    return new _IndexedNode233(edit, bitmap, newChildren);
  }
};
var ArrayNode233 = class _ArrayNode233 {
  edit;
  size;
  children;
  _tag = "ArrayNode";
  constructor(edit, size4232, children) {
    this.edit = edit;
    this.size = size4232;
    this.children = children;
  }
  modify(edit, shift22, f232, hash22232, key, size4232) {
    let count = this.size;
    const children = this.children;
    const frag = hashFragment233(shift22, hash22232);
    const child = children[frag];
    const newChild = (child || new EmptyNode233()).modify(edit, shift22 + SIZE233, f232, hash22232, key, size4232);
    if (child === newChild) return this;
    const canEdit = canEditNode233(this, edit);
    let newChildren;
    if (isEmptyNode233(child) && !isEmptyNode233(newChild)) {
      ++count;
      newChildren = arrayUpdate233(canEdit, frag, newChild, children);
    } else if (!isEmptyNode233(child) && isEmptyNode233(newChild)) {
      --count;
      if (count <= MIN_ARRAY_NODE233) {
        return pack233(edit, count, frag, children);
      }
      newChildren = arrayUpdate233(canEdit, frag, new EmptyNode233(), children);
    } else {
      newChildren = arrayUpdate233(canEdit, frag, newChild, children);
    }
    if (canEdit) {
      this.size = count;
      this.children = newChildren;
      return this;
    }
    return new _ArrayNode233(edit, count, newChildren);
  }
};
function pack233(edit, count, removed, elements) {
  const children = new Array(count - 1);
  let g232 = 0;
  let bitmap = 0;
  for (let i232 = 0, len = elements.length; i232 < len; ++i232) {
    if (i232 !== removed) {
      const elem = elements[i232];
      if (elem && !isEmptyNode233(elem)) {
        children[g232++] = elem;
        bitmap |= 1 << i232;
      }
    }
  }
  return new IndexedNode233(edit, bitmap, children);
}
function expand233(edit, frag, child, bitmap, subNodes) {
  const arr = [];
  let bit = bitmap;
  let count = 0;
  for (let i232 = 0; bit; ++i232) {
    if (bit & 1) arr[i232] = subNodes[count++];
    bit >>>= 1;
  }
  arr[frag] = child;
  return new ArrayNode233(edit, count + 1, arr);
}
function mergeLeavesInner233(edit, shift22, h1, n1, h232, n232) {
  if (h1 === h232) return new CollisionNode233(edit, h1, [n232, n1]);
  const subH1 = hashFragment233(shift22, h1);
  const subH2 = hashFragment233(shift22, h232);
  if (subH1 === subH2) {
    return (child) => new IndexedNode233(edit, toBitmap233(subH1) | toBitmap233(subH2), [child]);
  } else {
    const children = subH1 < subH2 ? [n1, n232] : [n232, n1];
    return new IndexedNode233(edit, toBitmap233(subH1) | toBitmap233(subH2), children);
  }
}
function mergeLeaves233(edit, shift22, h1, n1, h232, n232) {
  let stack = void 0;
  let currentShift = shift22;
  while (true) {
    const res = mergeLeavesInner233(edit, currentShift, h1, n1, h232, n232);
    if (typeof res === "function") {
      stack = make5233(res, stack);
      currentShift = currentShift + SIZE233;
    } else {
      let final = res;
      while (stack != null) {
        final = stack.value(final);
        stack = stack.previous;
      }
      return final;
    }
  }
}
var HashMapSymbolKey233 = "effect/HashMap";
var HashMapTypeId233 = /* @__PURE__ */ Symbol.for(HashMapSymbolKey233);
var HashMapProto233 = {
  [HashMapTypeId233]: HashMapTypeId233,
  [Symbol.iterator]() {
    return new HashMapIterator233(this, (k232, v232) => [k232, v232]);
  },
  [symbol3233]() {
    let hash22232 = hash2233(HashMapSymbolKey233);
    for (const item of this) {
      hash22232 ^= pipe2233(hash2233(item[0]), combine2244(hash2233(item[1])));
    }
    return cached2233(this, hash22232);
  },
  [symbol22233](that) {
    if (isHashMap233(that)) {
      if (that._size !== this._size) {
        return false;
      }
      for (const item of this) {
        const elem = pipe2233(that, getHash233(item[0], hash2233(item[0])));
        if (isNone22233(elem)) {
          return false;
        } else {
          if (!equals2233(item[1], elem.value)) {
            return false;
          }
        }
      }
      return true;
    }
    return false;
  },
  toString() {
    return format2233(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashMap",
      values: Array.from(this).map(toJSON2233)
    };
  },
  [NodeInspectSymbol2233]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments2233(this, arguments);
  }
};
var makeImpl333 = (editable, edit, root, size4232) => {
  const map622 = Object.create(HashMapProto233);
  map622._editable = editable;
  map622._edit = edit;
  map622._root = root;
  map622._size = size4232;
  return map622;
};
var HashMapIterator233 = class _HashMapIterator233 {
  map;
  f;
  v;
  constructor(map622, f232) {
    this.map = map622;
    this.f = f232;
    this.v = visitLazy233(this.map._root, this.f, void 0);
  }
  next() {
    if (isNone22233(this.v)) {
      return {
        done: true,
        value: void 0
      };
    }
    const v0 = this.v.value;
    this.v = applyCont233(v0.cont);
    return {
      done: false,
      value: v0.value
    };
  }
  [Symbol.iterator]() {
    return new _HashMapIterator233(this.map, this.f);
  }
};
var applyCont233 = (cont) => cont ? visitLazyChildren233(cont[0], cont[1], cont[2], cont[3], cont[4]) : none22233();
var visitLazy233 = (node, f232, cont = void 0) => {
  switch (node._tag) {
    case "LeafNode": {
      if (isSome22233(node.value)) {
        return some32233({
          value: f232(node.key, node.value.value),
          cont
        });
      }
      return applyCont233(cont);
    }
    case "CollisionNode":
    case "ArrayNode":
    case "IndexedNode": {
      const children = node.children;
      return visitLazyChildren233(children.length, children, 0, f232, cont);
    }
    default: {
      return applyCont233(cont);
    }
  }
};
var visitLazyChildren233 = (len, children, i232, f232, cont) => {
  while (i232 < len) {
    const child = children[i232++];
    if (child && !isEmptyNode233(child)) {
      return visitLazy233(child, f232, [len, children, i232, f232, cont]);
    }
  }
  return applyCont233(cont);
};
var _empty3233 = /* @__PURE__ */ makeImpl333(false, 0, /* @__PURE__ */ new EmptyNode233(), 0);
var empty4233 = () => _empty3233;
var isHashMap233 = (u232) => hasProperty2233(u232, HashMapTypeId233);
var getHash233 = /* @__PURE__ */ dual2233(3, (self2, key, hash22232) => {
  let node = self2._root;
  let shift22 = 0;
  while (true) {
    switch (node._tag) {
      case "LeafNode": {
        return equals2233(key, node.key) ? node.value : none22233();
      }
      case "CollisionNode": {
        if (hash22232 === node.hash) {
          const children = node.children;
          for (let i232 = 0, len = children.length; i232 < len; ++i232) {
            const child = children[i232];
            if ("key" in child && equals2233(key, child.key)) {
              return child.value;
            }
          }
        }
        return none22233();
      }
      case "IndexedNode": {
        const frag = hashFragment233(shift22, hash22232);
        const bit = toBitmap233(frag);
        if (node.mask & bit) {
          node = node.children[fromBitmap233(node.mask, bit)];
          shift22 += SIZE233;
          break;
        }
        return none22233();
      }
      case "ArrayNode": {
        node = node.children[hashFragment233(shift22, hash22232)];
        if (node) {
          shift22 += SIZE233;
          break;
        }
        return none22233();
      }
      default:
        return none22233();
    }
  }
});
var set2233 = /* @__PURE__ */ dual2233(3, (self2, key, value) => modifyAt233(self2, key, () => some32233(value)));
var setTree233 = /* @__PURE__ */ dual2233(3, (self2, newRoot, newSize) => {
  if (self2._editable) {
    self2._root = newRoot;
    self2._size = newSize;
    return self2;
  }
  return newRoot === self2._root ? self2 : makeImpl333(self2._editable, self2._edit, newRoot, newSize);
});
var keys323 = (self2) => new HashMapIterator233(self2, (key) => key);
var size433 = (self2) => self2._size;
var beginMutation333 = (self2) => makeImpl333(true, self2._edit + 1, self2._root, self2._size);
var modifyAt233 = /* @__PURE__ */ dual2233(3, (self2, key, f232) => modifyHash233(self2, key, hash2233(key), f232));
var modifyHash233 = /* @__PURE__ */ dual2233(4, (self2, key, hash22232, f232) => {
  const size4232 = {
    value: self2._size
  };
  const newRoot = self2._root.modify(self2._editable ? self2._edit : NaN, 0, f232, hash22232, key, size4232);
  return pipe2233(self2, setTree233(newRoot, size4232.value));
});
var forEach423 = /* @__PURE__ */ dual2233(2, (self2, f232) => reduce2233(self2, void 0, (_232, value, key) => f232(value, key)));
var reduce2233 = /* @__PURE__ */ dual2233(3, (self2, zero, f232) => {
  const root = self2._root;
  if (root._tag === "LeafNode") {
    return isSome22233(root.value) ? f232(zero, root.value.value, root.key) : zero;
  }
  if (root._tag === "EmptyNode") {
    return zero;
  }
  const toVisit = [root.children];
  let children;
  while (children = toVisit.pop()) {
    for (let i232 = 0, len = children.length; i232 < len; ) {
      const child = children[i232++];
      if (child && !isEmptyNode233(child)) {
        if (child._tag === "LeafNode") {
          if (isSome22233(child.value)) {
            zero = f232(zero, child.value.value, child.key);
          }
        } else {
          toVisit.push(child.children);
        }
      }
    }
  }
  return zero;
});
var HashSetSymbolKey233 = "effect/HashSet";
var HashSetTypeId233 = /* @__PURE__ */ Symbol.for(HashSetSymbolKey233);
var HashSetProto233 = {
  [HashSetTypeId233]: HashSetTypeId233,
  [Symbol.iterator]() {
    return keys323(this._keyMap);
  },
  [symbol3233]() {
    return cached2233(this, combine2244(hash2233(this._keyMap))(hash2233(HashSetSymbolKey233)));
  },
  [symbol22233](that) {
    if (isHashSet233(that)) {
      return size433(this._keyMap) === size433(that._keyMap) && equals2233(this._keyMap, that._keyMap);
    }
    return false;
  },
  toString() {
    return format2233(this.toJSON());
  },
  toJSON() {
    return {
      _id: "HashSet",
      values: Array.from(this).map(toJSON2233)
    };
  },
  [NodeInspectSymbol2233]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments2233(this, arguments);
  }
};
var makeImpl2233 = (keyMap) => {
  const set22232 = Object.create(HashSetProto233);
  set22232._keyMap = keyMap;
  return set22232;
};
var isHashSet233 = (u232) => hasProperty2233(u232, HashSetTypeId233);
var _empty4233 = /* @__PURE__ */ makeImpl2233(/* @__PURE__ */ empty4233());
var empty5233 = () => _empty4233;
var size2233 = (self2) => size433(self2._keyMap);
var beginMutation2233 = (self2) => makeImpl2233(beginMutation333(self2._keyMap));
var endMutation233 = (self2) => {
  self2._keyMap._editable = false;
  return self2;
};
var mutate233 = /* @__PURE__ */ dual2233(2, (self2, f232) => {
  const transient = beginMutation2233(self2);
  f232(transient);
  return endMutation233(transient);
});
var add2233 = /* @__PURE__ */ dual2233(2, (self2, value) => self2._keyMap._editable ? (set2233(value, true)(self2._keyMap), self2) : makeImpl2233(set2233(value, true)(self2._keyMap)));
var union2233 = /* @__PURE__ */ dual2233(2, (self2, that) => mutate233(empty5233(), (set22232) => {
  forEach2233(self2, (value) => add2233(set22232, value));
  for (const value of that) {
    add2233(set22232, value);
  }
}));
var forEach2233 = /* @__PURE__ */ dual2233(2, (self2, f232) => forEach423(self2._keyMap, (_232, k232) => f232(k232)));
var empty6233 = empty5233;
var size3233 = size2233;
var add3233 = add2233;
var union3233 = union2233;
var ArrayProto233 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(Array.prototype), {
  [symbol3233]() {
    return cached2233(this, array523(this));
  },
  [symbol22233](that) {
    if (Array.isArray(that) && this.length === that.length) {
      return this.every((v232, i232) => equals2233(v232, that[i232]));
    } else {
      return false;
    }
  }
});
var Structural333 = /* @__PURE__ */ function() {
  function Structural3232(args) {
    if (args) {
      Object.assign(this, args);
    }
  }
  Structural3232.prototype = StructuralPrototype2233;
  return Structural3232;
}();
var struct2233 = (as22232) => Object.assign(Object.create(StructuralPrototype2233), as22232);
var ContextPatchTypeId233 = /* @__PURE__ */ Symbol.for("effect/DifferContextPatch");
function variance333(a232) {
  return a232;
}
var PatchProto233 = {
  ...Structural333.prototype,
  [ContextPatchTypeId233]: {
    _Value: variance333,
    _Patch: variance333
  }
};
var EmptyProto233 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto233), {
  _tag: "Empty"
});
var _empty5233 = /* @__PURE__ */ Object.create(EmptyProto233);
var empty7233 = () => _empty5233;
var AndThenProto233 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto233), {
  _tag: "AndThen"
});
var makeAndThen233 = (first, second) => {
  const o232 = Object.create(AndThenProto233);
  o232.first = first;
  o232.second = second;
  return o232;
};
var AddServiceProto233 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto233), {
  _tag: "AddService"
});
var makeAddService233 = (key, service) => {
  const o232 = Object.create(AddServiceProto233);
  o232.key = key;
  o232.service = service;
  return o232;
};
var RemoveServiceProto233 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto233), {
  _tag: "RemoveService"
});
var makeRemoveService233 = (key) => {
  const o232 = Object.create(RemoveServiceProto233);
  o232.key = key;
  return o232;
};
var UpdateServiceProto233 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(PatchProto233), {
  _tag: "UpdateService"
});
var makeUpdateService233 = (key, update222) => {
  const o232 = Object.create(UpdateServiceProto233);
  o232.key = key;
  o232.update = update222;
  return o232;
};
var diff233 = (oldValue, newValue) => {
  const missingServices = new Map(oldValue.unsafeMap);
  let patch2232 = empty7233();
  for (const [tag, newService] of newValue.unsafeMap.entries()) {
    if (missingServices.has(tag)) {
      const old = missingServices.get(tag);
      missingServices.delete(tag);
      if (!equals2233(old, newService)) {
        patch2232 = combine22233(makeUpdateService233(tag, () => newService))(patch2232);
      }
    } else {
      missingServices.delete(tag);
      patch2232 = combine22233(makeAddService233(tag, newService))(patch2232);
    }
  }
  for (const [tag] of missingServices.entries()) {
    patch2232 = combine22233(makeRemoveService233(tag))(patch2232);
  }
  return patch2232;
};
var combine22233 = /* @__PURE__ */ dual2233(2, (self2, that) => makeAndThen233(self2, that));
var patch233 = /* @__PURE__ */ dual2233(2, (self2, context) => {
  if (self2._tag === "Empty") {
    return context;
  }
  let wasServiceUpdated = false;
  let patches = of323(self2);
  const updatedContext = new Map(context.unsafeMap);
  while (isNonEmpty233(patches)) {
    const head222 = headNonEmpty323(patches);
    const tail222 = tailNonEmpty323(patches);
    switch (head222._tag) {
      case "Empty": {
        patches = tail222;
        break;
      }
      case "AddService": {
        updatedContext.set(head222.key, head222.service);
        patches = tail222;
        break;
      }
      case "AndThen": {
        patches = prepend323(prepend323(tail222, head222.second), head222.first);
        break;
      }
      case "RemoveService": {
        updatedContext.delete(head222.key);
        patches = tail222;
        break;
      }
      case "UpdateService": {
        updatedContext.set(head222.key, head222.update(updatedContext.get(head222.key)));
        wasServiceUpdated = true;
        patches = tail222;
        break;
      }
    }
  }
  if (!wasServiceUpdated) {
    return makeContext233(updatedContext);
  }
  const map622 = /* @__PURE__ */ new Map();
  for (const [tag] of context.unsafeMap) {
    if (updatedContext.has(tag)) {
      map622.set(tag, updatedContext.get(tag));
      updatedContext.delete(tag);
    }
  }
  for (const [tag, s232] of updatedContext) {
    map622.set(tag, s232);
  }
  return makeContext233(map622);
});
var DifferTypeId233 = /* @__PURE__ */ Symbol.for("effect/Differ");
var DifferProto233 = {
  [DifferTypeId233]: {
    _P: identity2233,
    _V: identity2233
  }
};
var make7233 = (params) => {
  const differ = Object.create(DifferProto233);
  differ.empty = params.empty;
  differ.diff = params.diff;
  differ.combine = params.combine;
  differ.patch = params.patch;
  return differ;
};
var environment233 = () => make7233({
  empty: empty7233(),
  combine: (first, second) => combine22233(second)(first),
  diff: (oldValue, newValue) => diff233(oldValue, newValue),
  patch: (patch2232, oldValue) => patch233(oldValue)(patch2232)
});
var OP_DIE233 = "Die";
var OP_EMPTY233 = "Empty";
var OP_FAIL233 = "Fail";
var OP_INTERRUPT233 = "Interrupt";
var OP_PARALLEL233 = "Parallel";
var OP_SEQUENTIAL233 = "Sequential";
var CauseSymbolKey233 = "effect/Cause";
var CauseTypeId233 = /* @__PURE__ */ Symbol.for(CauseSymbolKey233);
var variance2233 = {
  /* c8 ignore next */
  _E: (_232) => _232
};
var proto233 = {
  [CauseTypeId233]: variance2233,
  [symbol3233]() {
    return pipe2233(hash2233(CauseSymbolKey233), combine2244(hash2233(flattenCause233(this))), cached2233(this));
  },
  [symbol22233](that) {
    return isCause233(that) && causeEquals233(this, that);
  },
  pipe() {
    return pipeArguments2233(this, arguments);
  },
  toJSON() {
    switch (this._tag) {
      case "Empty":
        return {
          _id: "Cause",
          _tag: this._tag
        };
      case "Die":
        return {
          _id: "Cause",
          _tag: this._tag,
          defect: toJSON2233(this.defect)
        };
      case "Interrupt":
        return {
          _id: "Cause",
          _tag: this._tag,
          fiberId: this.fiberId.toJSON()
        };
      case "Fail":
        return {
          _id: "Cause",
          _tag: this._tag,
          failure: toJSON2233(this.error)
        };
      case "Sequential":
      case "Parallel":
        return {
          _id: "Cause",
          _tag: this._tag,
          left: toJSON2233(this.left),
          right: toJSON2233(this.right)
        };
    }
  },
  toString() {
    return pretty233(this);
  },
  [NodeInspectSymbol2233]() {
    return this.toJSON();
  }
};
var fail333 = (error) => {
  const o232 = Object.create(proto233);
  o232._tag = OP_FAIL233;
  o232.error = error;
  return o232;
};
var parallel233 = (left3232, right3232) => {
  const o232 = Object.create(proto233);
  o232._tag = OP_PARALLEL233;
  o232.left = left3232;
  o232.right = right3232;
  return o232;
};
var sequential233 = (left3232, right3232) => {
  const o232 = Object.create(proto233);
  o232._tag = OP_SEQUENTIAL233;
  o232.left = left3232;
  o232.right = right3232;
  return o232;
};
var isCause233 = (u232) => hasProperty2233(u232, CauseTypeId233);
var isInterruptedOnly233 = (self2) => reduceWithContext233(void 0, IsInterruptedOnlyCauseReducer233)(self2);
var causeEquals233 = (left3232, right3232) => {
  let leftStack = of323(left3232);
  let rightStack = of323(right3232);
  while (isNonEmpty233(leftStack) && isNonEmpty233(rightStack)) {
    const [leftParallel, leftSequential] = pipe2233(headNonEmpty323(leftStack), reduce4233([empty6233(), empty3233()], ([parallel2232, sequential2232], cause) => {
      const [par, seq] = evaluateCause233(cause);
      return some32233([pipe2233(parallel2232, union3233(par)), pipe2233(sequential2232, appendAll323(seq))]);
    }));
    const [rightParallel, rightSequential] = pipe2233(headNonEmpty323(rightStack), reduce4233([empty6233(), empty3233()], ([parallel2232, sequential2232], cause) => {
      const [par, seq] = evaluateCause233(cause);
      return some32233([pipe2233(parallel2232, union3233(par)), pipe2233(sequential2232, appendAll323(seq))]);
    }));
    if (!equals2233(leftParallel, rightParallel)) {
      return false;
    }
    leftStack = leftSequential;
    rightStack = rightSequential;
  }
  return true;
};
var flattenCause233 = (cause) => {
  return flattenCauseLoop233(of323(cause), empty3233());
};
var flattenCauseLoop233 = (causes, flattened) => {
  while (1) {
    const [parallel2232, sequential2232] = pipe2233(causes, reduce523([empty6233(), empty3233()], ([parallel322, sequential322], cause) => {
      const [par, seq] = evaluateCause233(cause);
      return [pipe2233(parallel322, union3233(par)), pipe2233(sequential322, appendAll323(seq))];
    }));
    const updated = size3233(parallel2232) > 0 ? pipe2233(flattened, prepend323(parallel2232)) : flattened;
    if (isEmpty233(sequential2232)) {
      return reverse2233(updated);
    }
    causes = sequential2232;
    flattened = updated;
  }
  throw new Error(getBugErrorMessage2233("Cause.flattenCauseLoop"));
};
var evaluateCause233 = (self2) => {
  let cause = self2;
  const stack = [];
  let _parallel = empty6233();
  let _sequential = empty3233();
  while (cause !== void 0) {
    switch (cause._tag) {
      case OP_EMPTY233: {
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_FAIL233: {
        _parallel = add3233(_parallel, make42233(cause._tag, cause.error));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_DIE233: {
        _parallel = add3233(_parallel, make42233(cause._tag, cause.defect));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_INTERRUPT233: {
        _parallel = add3233(_parallel, make42233(cause._tag, cause.fiberId));
        if (stack.length === 0) {
          return [_parallel, _sequential];
        }
        cause = stack.pop();
        break;
      }
      case OP_SEQUENTIAL233: {
        switch (cause.left._tag) {
          case OP_EMPTY233: {
            cause = cause.right;
            break;
          }
          case OP_SEQUENTIAL233: {
            cause = sequential233(cause.left.left, sequential233(cause.left.right, cause.right));
            break;
          }
          case OP_PARALLEL233: {
            cause = parallel233(sequential233(cause.left.left, cause.right), sequential233(cause.left.right, cause.right));
            break;
          }
          default: {
            _sequential = prepend323(_sequential, cause.right);
            cause = cause.left;
            break;
          }
        }
        break;
      }
      case OP_PARALLEL233: {
        stack.push(cause.right);
        cause = cause.left;
        break;
      }
    }
  }
  throw new Error(getBugErrorMessage2233("Cause.evaluateCauseLoop"));
};
var IsInterruptedOnlyCauseReducer233 = {
  emptyCase: constTrue2233,
  failCase: constFalse2233,
  dieCase: constFalse2233,
  interruptCase: constTrue2233,
  sequentialCase: (_232, left3232, right3232) => left3232 && right3232,
  parallelCase: (_232, left3232, right3232) => left3232 && right3232
};
var OP_SEQUENTIAL_CASE233 = "SequentialCase";
var OP_PARALLEL_CASE233 = "ParallelCase";
var reduce4233 = /* @__PURE__ */ dual2233(3, (self2, zero, pf) => {
  let accumulator = zero;
  let cause = self2;
  const causes = [];
  while (cause !== void 0) {
    const option = pf(accumulator, cause);
    accumulator = isSome22233(option) ? option.value : accumulator;
    switch (cause._tag) {
      case OP_SEQUENTIAL233: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      case OP_PARALLEL233: {
        causes.push(cause.right);
        cause = cause.left;
        break;
      }
      default: {
        cause = void 0;
        break;
      }
    }
    if (cause === void 0 && causes.length > 0) {
      cause = causes.pop();
    }
  }
  return accumulator;
});
var reduceWithContext233 = /* @__PURE__ */ dual2233(3, (self2, context, reducer) => {
  const input = [self2];
  const output = [];
  while (input.length > 0) {
    const cause = input.pop();
    switch (cause._tag) {
      case OP_EMPTY233: {
        output.push(right22233(reducer.emptyCase(context)));
        break;
      }
      case OP_FAIL233: {
        output.push(right22233(reducer.failCase(context, cause.error)));
        break;
      }
      case OP_DIE233: {
        output.push(right22233(reducer.dieCase(context, cause.defect)));
        break;
      }
      case OP_INTERRUPT233: {
        output.push(right22233(reducer.interruptCase(context, cause.fiberId)));
        break;
      }
      case OP_SEQUENTIAL233: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left22233({
          _tag: OP_SEQUENTIAL_CASE233
        }));
        break;
      }
      case OP_PARALLEL233: {
        input.push(cause.right);
        input.push(cause.left);
        output.push(left22233({
          _tag: OP_PARALLEL_CASE233
        }));
        break;
      }
    }
  }
  const accumulator = [];
  while (output.length > 0) {
    const either = output.pop();
    switch (either._tag) {
      case "Left": {
        switch (either.left._tag) {
          case OP_SEQUENTIAL_CASE233: {
            const left3232 = accumulator.pop();
            const right3232 = accumulator.pop();
            const value = reducer.sequentialCase(context, left3232, right3232);
            accumulator.push(value);
            break;
          }
          case OP_PARALLEL_CASE233: {
            const left3232 = accumulator.pop();
            const right3232 = accumulator.pop();
            const value = reducer.parallelCase(context, left3232, right3232);
            accumulator.push(value);
            break;
          }
        }
        break;
      }
      case "Right": {
        accumulator.push(either.right);
        break;
      }
    }
  }
  if (accumulator.length === 0) {
    throw new Error("BUG: Cause.reduceWithContext - please report an issue at https://github.com/Effect-TS/effect/issues");
  }
  return accumulator.pop();
});
var pretty233 = (cause) => {
  if (isInterruptedOnly233(cause)) {
    return "All fibers interrupted without errors.";
  }
  return prettyErrors233(cause).map((e232) => e232.stack).join("\n");
};
var PrettyError233 = class extends globalThis.Error {
  span = void 0;
  constructor(originalError) {
    const prevLimit = Error.stackTraceLimit;
    Error.stackTraceLimit = 0;
    super(prettyErrorMessage233(originalError));
    Error.stackTraceLimit = prevLimit;
    this.name = originalError instanceof Error ? originalError.name : "Error";
    if (typeof originalError === "object" && originalError !== null) {
      if (spanSymbol333 in originalError) {
        this.span = originalError[spanSymbol333];
      }
      Object.keys(originalError).forEach((key) => {
        if (!(key in this)) {
          this[key] = originalError[key];
        }
      });
    }
    this.stack = prettyErrorStack233(this.message, originalError instanceof Error && originalError.stack ? originalError.stack : "", this.span);
  }
  toJSON() {
    const out = {
      message: this.message,
      stack: this.stack
    };
    if (this.span) {
      out.span = this.span;
    }
    return out;
  }
};
var prettyErrorMessage233 = (u232) => {
  if (typeof u232 === "string") {
    return `Error: ${u232}`;
  }
  try {
    if (hasProperty2233(u232, "toString") && isFunction3244(u232["toString"]) && u232["toString"] !== Object.prototype.toString && u232["toString"] !== globalThis.Array.prototype.toString) {
      return u232["toString"]();
    }
  } catch {
  }
  return `Error: ${JSON.stringify(u232)}`;
};
var locationRegex233 = /\((.*)\)/;
var spanToTrace233 = /* @__PURE__ */ globalValue2233("effect/Tracer/spanToTrace", () => /* @__PURE__ */ new WeakMap());
var prettyErrorStack233 = (message, stack, span222) => {
  const out = [message];
  const lines = stack.split("\n");
  for (let i232 = 1; i232 < lines.length; i232++) {
    if (lines[i232].includes("Generator.next")) {
      break;
    }
    if (lines[i232].includes("effect_internal_function")) {
      out.pop();
      break;
    }
    out.push(lines[i232].replace(/at .*effect_instruction_i.*\((.*)\)/, "at $1").replace(/EffectPrimitive\.\w+/, "<anonymous>"));
  }
  if (span222) {
    let current = span222;
    let i232 = 0;
    while (current && current._tag === "Span" && i232 < 10) {
      const stackFn = spanToTrace233.get(current);
      if (typeof stackFn === "function") {
        const stack2 = stackFn();
        const locationMatch = stack2.match(locationRegex233);
        const location = locationMatch ? locationMatch[1] : stack2.replace(/^at /, "");
        out.push(`    at ${current.name} (${location})`);
      } else {
        out.push(`    at ${current.name}`);
      }
      current = getOrUndefined2233(current.parent);
      i232++;
    }
  }
  return out.join("\n");
};
var spanSymbol333 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var prettyErrors233 = (cause) => reduceWithContext233(cause, void 0, {
  emptyCase: () => [],
  dieCase: (_232, unknownError) => {
    return [new PrettyError233(unknownError)];
  },
  failCase: (_232, error) => {
    return [new PrettyError233(error)];
  },
  interruptCase: () => [],
  parallelCase: (_232, l232, r232) => [...l232, ...r232],
  sequentialCase: (_232, l232, r232) => [...l232, ...r232]
});
var SingleShotGen22233 = class _SingleShotGen2233 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  next(a232) {
    return this.called ? {
      value: a232,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  return(a232) {
    return {
      value: a232,
      done: true
    };
  }
  throw(e232) {
    throw e232;
  }
  [Symbol.iterator]() {
    return new _SingleShotGen2233(this.self);
  }
};
var spanTag233 = /* @__PURE__ */ GenericTag233("effect/ParentSpan");
var EffectTypeId22233 = /* @__PURE__ */ Symbol.for("effect/Effect");
var EffectPrimitive233 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId22233] = effectVariance2233;
  constructor(_op) {
    this._op = _op;
  }
  [symbol22233](that) {
    return this === that;
  }
  [symbol3233]() {
    return cached2233(this, random2233(this));
  }
  pipe() {
    return pipeArguments2233(this, arguments);
  }
  toJSON() {
    return {
      _id: "Effect",
      _op: this._op,
      effect_instruction_i0: toJSON2233(this.effect_instruction_i0),
      effect_instruction_i1: toJSON2233(this.effect_instruction_i1),
      effect_instruction_i2: toJSON2233(this.effect_instruction_i2)
    };
  }
  toString() {
    return format2233(this.toJSON());
  }
  [NodeInspectSymbol2233]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen22233(new YieldWrap2233(this));
  }
};
var EffectPrimitiveFailure233 = class {
  _op;
  effect_instruction_i0 = void 0;
  effect_instruction_i1 = void 0;
  effect_instruction_i2 = void 0;
  trace = void 0;
  [EffectTypeId22233] = effectVariance2233;
  constructor(_op) {
    this._op = _op;
    this._tag = _op;
  }
  [symbol22233](that) {
    return exitIsExit233(that) && that._op === "Failure" && // @ts-expect-error
    equals2233(this.effect_instruction_i0, that.effect_instruction_i0);
  }
  [symbol3233]() {
    return pipe2233(
      // @ts-expect-error
      string2233(this._tag),
      // @ts-expect-error
      combine2244(hash2233(this.effect_instruction_i0)),
      cached2233(this)
    );
  }
  get cause() {
    return this.effect_instruction_i0;
  }
  pipe() {
    return pipeArguments2233(this, arguments);
  }
  toJSON() {
    return {
      _id: "Exit",
      _tag: this._op,
      cause: this.cause.toJSON()
    };
  }
  toString() {
    return format2233(this.toJSON());
  }
  [NodeInspectSymbol2233]() {
    return this.toJSON();
  }
  [Symbol.iterator]() {
    return new SingleShotGen22233(new YieldWrap2233(this));
  }
};
var isEffect233 = (u232) => hasProperty2233(u232, EffectTypeId22233);
var withFiberRuntime233 = (withRuntime) => {
  const effect = new EffectPrimitive233(OP_WITH_RUNTIME233);
  effect.effect_instruction_i0 = withRuntime;
  return effect;
};
var spanSymbol2233 = /* @__PURE__ */ Symbol.for("effect/SpanAnnotation");
var originalSymbol233 = /* @__PURE__ */ Symbol.for("effect/OriginalAnnotation");
var capture233 = (obj, span222) => {
  if (isSome22233(span222)) {
    return new Proxy(obj, {
      has(target, p232) {
        return p232 === spanSymbol2233 || p232 === originalSymbol233 || p232 in target;
      },
      get(target, p232) {
        if (p232 === spanSymbol2233) {
          return span222.value;
        }
        if (p232 === originalSymbol233) {
          return obj;
        }
        return target[p232];
      }
    });
  }
  return obj;
};
var fail2233 = (error) => isObject2233(error) && !(spanSymbol2233 in error) ? withFiberRuntime233((fiber) => failCause233(fail333(capture233(error, currentSpanFromFiber233(fiber))))) : failCause233(fail333(error));
var failCause233 = (cause) => {
  const effect = new EffectPrimitiveFailure233(OP_FAILURE233);
  effect.effect_instruction_i0 = cause;
  return effect;
};
var FiberRefSymbolKey233 = "effect/FiberRef";
var FiberRefTypeId233 = /* @__PURE__ */ Symbol.for(FiberRefSymbolKey233);
var fiberRefVariance233 = {
  /* c8 ignore next */
  _A: (_232) => _232
};
var fiberRefUnsafeMakeContext233 = (initial) => {
  const differ = environment233();
  return fiberRefUnsafeMakePatch233(initial, {
    differ,
    fork: differ.empty
  });
};
var fiberRefUnsafeMakePatch233 = (initial, options) => ({
  [FiberRefTypeId233]: fiberRefVariance233,
  initial,
  diff: (oldValue, newValue) => options.differ.diff(oldValue, newValue),
  combine: (first, second) => options.differ.combine(first, second),
  patch: (patch2232) => (oldValue) => options.differ.patch(patch2232, oldValue),
  fork: options.fork,
  join: options.join ?? ((_232, n232) => n232),
  pipe() {
    return pipeArguments2233(this, arguments);
  }
});
var currentContext233 = /* @__PURE__ */ globalValue2233(/* @__PURE__ */ Symbol.for("effect/FiberRef/currentContext"), () => fiberRefUnsafeMakeContext233(empty2233()));
var YieldableError233 = /* @__PURE__ */ function() {
  class YieldableError2232 extends globalThis.Error {
    commit() {
      return fail2233(this);
    }
    toString() {
      return this.message ? `${this.name}: ${this.message}` : this.name;
    }
    toJSON() {
      return {
        ...this
      };
    }
    [NodeInspectSymbol2233]() {
      const stack = this.stack;
      if (stack) {
        return `${this.toString()}
${stack.split("\n").slice(1).join("\n")}`;
      }
      return this.toString();
    }
  }
  Object.assign(YieldableError2232.prototype, StructuralCommitPrototype2233);
  return YieldableError2232;
}();
var exitIsExit233 = (u232) => isEffect233(u232) && "_tag" in u232 && (u232._tag === "Success" || u232._tag === "Failure");
var currentSpanFromFiber233 = (fiber) => {
  const span222 = fiber.getFiberRef(currentContext233).unsafeMap.get(spanTag233.key);
  return span222 !== void 0 && span222._tag === "Span" ? some32233(span222) : none22233();
};
var Data_exports2233 = {};
__export2233(Data_exports2233, {
  Class: () => Class2233,
  Error: () => Error2233,
  Structural: () => Structural2233,
  TaggedClass: () => TaggedClass233,
  TaggedError: () => TaggedError233,
  array: () => array2233,
  case: () => _case233,
  struct: () => struct3233,
  tagged: () => tagged233,
  taggedEnum: () => taggedEnum233,
  tuple: () => tuple2233,
  unsafeArray: () => unsafeArray233,
  unsafeStruct: () => unsafeStruct233
});
var struct3233 = struct2233;
var unsafeStruct233 = (as22232) => Object.setPrototypeOf(as22232, StructuralPrototype2233);
var tuple2233 = (...as22232) => unsafeArray233(as22232);
var array2233 = (as22232) => unsafeArray233(as22232.slice(0));
var unsafeArray233 = (as22232) => Object.setPrototypeOf(as22232, ArrayProto233);
var _case233 = () => (args) => args === void 0 ? Object.create(StructuralPrototype2233) : struct3233(args);
var tagged233 = (tag) => (args) => {
  const value = args === void 0 ? Object.create(StructuralPrototype2233) : struct3233(args);
  value._tag = tag;
  return value;
};
var Class2233 = Structural333;
var TaggedClass233 = (tag) => {
  class Base extends Class2233 {
    _tag = tag;
  }
  return Base;
};
var Structural2233 = Structural333;
var taggedEnum233 = () => new Proxy({}, {
  get(_target, tag, _receiver) {
    if (tag === "$is") {
      return isTagged323;
    } else if (tag === "$match") {
      return taggedMatch233;
    }
    return tagged233(tag);
  }
});
function taggedMatch233() {
  if (arguments.length === 1) {
    const cases2 = arguments[0];
    return function(value2) {
      return cases2[value2._tag](value2);
    };
  }
  const value = arguments[0];
  const cases = arguments[1];
  return cases[value._tag](value);
}
var Error2233 = /* @__PURE__ */ function() {
  return class Base extends YieldableError233 {
    constructor(args) {
      super();
      if (args) {
        Object.assign(this, args);
      }
    }
  };
}();
var TaggedError233 = (tag) => {
  class Base extends Error2233 {
    _tag = tag;
  }
  Base.prototype.name = tag;
  return Base;
};
var traverseUp233 = Function_exports2233.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType233.Program) return Option_exports2233.none();
  return predicate(parent) ? Option_exports2233.some(parent) : traverseUp233(parent, predicate);
});
var traverseUpGuard233 = Function_exports2233.dual(2, (node, predicate) => {
  const { parent } = node;
  if (!parent || parent.type === NodeType233.Program) return Option_exports2233.none();
  return predicate(parent) ? Option_exports2233.some(parent) : traverseUpGuard233(parent, predicate);
});
var ESLintCommunityESLintUtils233;
((ESLintCommunityESLintUtils2232) => {
  ESLintCommunityESLintUtils2232.getFunctionHeadLocation = getFunctionHeadLocation233;
  ESLintCommunityESLintUtils2232.getFunctionNameWithKind = getFunctionNameWithKind233;
  ESLintCommunityESLintUtils2232.getPropertyName = getPropertyName233;
  ESLintCommunityESLintUtils2232.getStaticValue = getStaticValue233;
  ESLintCommunityESLintUtils2232.getStringIfConstant = getStringIfConstant233;
  ESLintCommunityESLintUtils2232.hasSideEffect = hasSideEffect233;
  ESLintCommunityESLintUtils2232.isParenthesized = isParenthesized233;
})(ESLintCommunityESLintUtils233 || (ESLintCommunityESLintUtils233 = {}));
var Construction233 = Data_exports2233.taggedEnum();
Construction233.None();
a34({
  type: N34.union([NodeType233.FunctionExpression, NodeType233.ArrowFunctionExpression]),
  parent: {
    type: NodeType233.Property,
    parent: {
      type: NodeType233.ObjectExpression
    }
  }
});
a34({
  type: N34.union([NodeType233.FunctionExpression, NodeType233.ArrowFunctionExpression]),
  parent: {
    type: NodeType233.MethodDefinition,
    parent: {
      type: NodeType233.ClassBody
    }
  }
});
a34({
  type: N34.union([NodeType233.FunctionExpression, NodeType233.ArrowFunctionExpression]),
  parent: {
    type: NodeType233.Property,
    parent: {
      type: NodeType233.ClassBody
    }
  }
});
isOneOf44([NodeType44.Literal, NodeType44.JSXText]);
var WEBSITE_URL4 = "https://eslint-react.xyz";
var RE_PASCAL_CASE = /^[A-Z][\dA-Za-z]*$/u;
var RE_CAMEL_CASE = /^[a-z][\dA-Za-z]*$/u;
var RE_KEBAB_CASE = /^[a-z][\d\-a-z]*$/u;
var RE_SNAKE_CASE = /^[a-z][\d_a-z]*$/u;
var RE_CONSTANT_CASE = /^[A-Z][\d_A-Z]*$/u;
var getDocsUrl4 = (pluginName) => (ruleName) => {
  return `${WEBSITE_URL4}/rules/${pluginName}-${ruleName}`;
};
var createRuleForPlugin4 = (pluginName) => utils.ESLintUtils.RuleCreator(getDocsUrl4(pluginName));
var store224;
function getGlobalMessage24(lang) {
  return store224?.get(lang);
}
var store324;
function getSchemaMessage24(lang) {
  return store324?.get(lang);
}
var store424;
function getSpecificMessage24(reference, lang) {
  return store424?.get(reference)?.get(lang);
}
function _stringify24(input) {
  let type = typeof input;
  if (type === "object") {
    type = (input && Object.getPrototypeOf(input)?.constructor?.name) ?? "null";
  }
  return type === "string" ? `"${input}"` : type === "number" || type === "bigint" || type === "boolean" ? `${input}` : type;
}
function _addIssue24(context, label, dataset, config2, other) {
  const input = dataset.value;
  const expected = context.expects;
  const received = _stringify24(input);
  const issue = {
    kind: context.kind,
    type: context.type,
    input,
    expected,
    received,
    message: `Invalid ${label}: ${expected ? `Expected ${expected} but r` : "R"}eceived ${received}`,
    // @ts-expect-error
    requirement: context.requirement,
    path: other?.path,
    issues: other?.issues,
    lang: config2.lang,
    abortEarly: config2.abortEarly,
    abortPipeEarly: config2.abortPipeEarly,
    skipPipe: config2.skipPipe
  };
  const isSchema = context.kind === "schema";
  const message = (
    // @ts-expect-error
    context.message ?? getSpecificMessage24(context.reference, issue.lang) ?? (isSchema ? getSchemaMessage24(issue.lang) : null) ?? config2.message ?? getGlobalMessage24(issue.lang)
  );
  if (message) {
    issue.message = typeof message === "function" ? message(issue) : message;
  }
  if (isSchema) {
    dataset.typed = false;
  }
  if (dataset.issues) {
    dataset.issues.push(issue);
  } else {
    dataset.issues = [issue];
  }
}
function getDefault24(schema4, dataset, config2) {
  return typeof schema4.default === "function" ? (
    // @ts-expect-error
    schema4.default(dataset, config2)
  ) : (
    // @ts-expect-error
    schema4.default
  );
}
function array94(item, message) {
  return {
    kind: "schema",
    type: "array",
    reference: array94,
    expects: "Array",
    async: false,
    item,
    message,
    _run(dataset, config2) {
      const input = dataset.value;
      if (Array.isArray(input)) {
        dataset.typed = true;
        dataset.value = [];
        for (let key = 0; key < input.length; key++) {
          const value2 = input[key];
          const itemDataset = this.item._run({ typed: false, value: value2 }, config2);
          if (itemDataset.issues) {
            const pathItem = {
              type: "array",
              origin: "value",
              input,
              key,
              value: value2
            };
            for (const issue of itemDataset.issues) {
              if (issue.path) {
                issue.path.unshift(pathItem);
              } else {
                issue.path = [pathItem];
              }
              dataset.issues?.push(issue);
            }
            if (!dataset.issues) {
              dataset.issues = itemDataset.issues;
            }
            if (config2.abortEarly) {
              dataset.typed = false;
              break;
            }
          }
          if (!itemDataset.typed) {
            dataset.typed = false;
          }
          dataset.value.push(itemDataset.value);
        }
      } else {
        _addIssue24(this, "type", dataset, config2);
      }
      return dataset;
    }
  };
}
function object24(entries2, message) {
  return {
    kind: "schema",
    type: "object",
    reference: object24,
    expects: "Object",
    async: false,
    entries: entries2,
    message,
    _run(dataset, config2) {
      const input = dataset.value;
      if (input && typeof input === "object") {
        dataset.typed = true;
        dataset.value = {};
        for (const key in this.entries) {
          const value2 = input[key];
          const valueDataset = this.entries[key]._run(
            { typed: false, value: value2 },
            config2
          );
          if (valueDataset.issues) {
            const pathItem = {
              type: "object",
              origin: "value",
              input,
              key,
              value: value2
            };
            for (const issue of valueDataset.issues) {
              if (issue.path) {
                issue.path.unshift(pathItem);
              } else {
                issue.path = [pathItem];
              }
              dataset.issues?.push(issue);
            }
            if (!dataset.issues) {
              dataset.issues = valueDataset.issues;
            }
            if (config2.abortEarly) {
              dataset.typed = false;
              break;
            }
          }
          if (!valueDataset.typed) {
            dataset.typed = false;
          }
          if (valueDataset.value !== void 0 || key in input) {
            dataset.value[key] = valueDataset.value;
          }
        }
      } else {
        _addIssue24(this, "type", dataset, config2);
      }
      return dataset;
    }
  };
}
function optional24(wrapped, ...args) {
  const schema4 = {
    kind: "schema",
    type: "optional",
    reference: optional24,
    expects: `${wrapped.expects} | undefined`,
    async: false,
    wrapped,
    _run(dataset, config2) {
      if (dataset.value === void 0) {
        if ("default" in this) {
          dataset.value = getDefault24(
            this,
            dataset,
            config2
          );
        }
        if (dataset.value === void 0) {
          dataset.typed = true;
          return dataset;
        }
      }
      return this.wrapped._run(dataset, config2);
    }
  };
  if (0 in args) {
    schema4.default = args[0];
  }
  return schema4;
}
function string84(message) {
  return {
    kind: "schema",
    type: "string",
    reference: string84,
    expects: "string",
    async: false,
    message,
    _run(dataset, config2) {
      if (typeof dataset.value === "string") {
        dataset.typed = true;
      } else {
        _addIssue24(this, "type", dataset, config2);
      }
      return dataset;
    }
  };
}
var ESLintReactSettingsSchema24 = object24({
  additionalHooks: optional24(object24({
    use: optional24(string84()),
    useCallback: optional24(array94(string84())),
    useContext: optional24(array94(string84())),
    useDebugValue: optional24(array94(string84())),
    useDeferredValue: optional24(array94(string84())),
    useEffect: optional24(array94(string84())),
    useId: optional24(array94(string84())),
    useImperativeHandle: optional24(array94(string84())),
    useInsertionEffect: optional24(array94(string84())),
    useLayoutEffect: optional24(array94(string84())),
    useMemo: optional24(array94(string84())),
    useOptimistic: optional24(array94(string84())),
    useReducer: optional24(array94(string84())),
    useRef: optional24(array94(string84())),
    useState: optional24(array94(string84())),
    useSyncExternalStore: optional24(array94(string84())),
    useTransition: optional24(array94(string84()))
  })),
  importSource: optional24(string84()),
  jsxPragma: optional24(string84()),
  jsxPragmaFrag: optional24(string84()),
  version: optional24(string84())
});
var ESLintSettingsSchema23 = object24({
  reactOptions: optional24(ESLintReactSettingsSchema24)
});
var Function_exports74 = {};
__export9(Function_exports74, {
  SK: () => SK74,
  absurd: () => absurd74,
  apply: () => apply74,
  compose: () => compose104,
  constFalse: () => constFalse74,
  constNull: () => constNull74,
  constTrue: () => constTrue74,
  constUndefined: () => constUndefined74,
  constVoid: () => constVoid74,
  constant: () => constant74,
  dual: () => dual74,
  flip: () => flip74,
  flow: () => flow74,
  hole: () => hole74,
  identity: () => identity74,
  isFunction: () => isFunction103,
  pipe: () => pipe74,
  satisfies: () => satisfies74,
  tupled: () => tupled74,
  unsafeCoerce: () => unsafeCoerce74,
  untupled: () => untupled74
});
var isFunction103 = (input) => typeof input === "function";
var dual74 = function(arity, body) {
  if (typeof arity === "function") {
    return function() {
      if (arity(arguments)) {
        return body.apply(this, arguments);
      }
      return (self2) => body(self2, ...arguments);
    };
  }
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a43, b43) {
        if (arguments.length >= 2) {
          return body(a43, b43);
        }
        return function(self2) {
          return body(self2, a43);
        };
      };
    case 3:
      return function(a43, b43, c43) {
        if (arguments.length >= 3) {
          return body(a43, b43, c43);
        }
        return function(self2) {
          return body(self2, a43, b43);
        };
      };
    case 4:
      return function(a43, b43, c43, d43) {
        if (arguments.length >= 4) {
          return body(a43, b43, c43, d43);
        }
        return function(self2) {
          return body(self2, a43, b43, c43);
        };
      };
    case 5:
      return function(a43, b43, c43, d43, e43) {
        if (arguments.length >= 5) {
          return body(a43, b43, c43, d43, e43);
        }
        return function(self2) {
          return body(self2, a43, b43, c43, d43);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};
var apply74 = (a43) => (self2) => self2(a43);
var identity74 = (a43) => a43;
var satisfies74 = () => (b43) => b43;
var unsafeCoerce74 = identity74;
var constant74 = (value) => () => value;
var constTrue74 = /* @__PURE__ */ constant74(true);
var constFalse74 = /* @__PURE__ */ constant74(false);
var constNull74 = /* @__PURE__ */ constant74(null);
var constUndefined74 = /* @__PURE__ */ constant74(void 0);
var constVoid74 = constUndefined74;
var flip74 = (f43) => (...b43) => (...a43) => f43(...a43)(...b43);
var compose104 = /* @__PURE__ */ dual74(2, (ab, bc) => (a43) => bc(ab(a43)));
var absurd74 = (_43) => {
  throw new Error("Called `absurd` function which should be uncallable");
};
var tupled74 = (f43) => (a43) => f43(...a43);
var untupled74 = (f43) => (...a43) => f43(a43);
function pipe74(a43, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a43;
    case 2:
      return ab(a43);
    case 3:
      return bc(ab(a43));
    case 4:
      return cd(bc(ab(a43)));
    case 5:
      return de(cd(bc(ab(a43))));
    case 6:
      return ef(de(cd(bc(ab(a43)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a43))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a43)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a43))))))));
    default: {
      let ret = arguments[0];
      for (let i43 = 1; i43 < arguments.length; i43++) {
        ret = arguments[i43](ret);
      }
      return ret;
    }
  }
}
function flow74(ab, bc, cd, de, ef, fg, gh, hi, ij) {
  switch (arguments.length) {
    case 1:
      return ab;
    case 2:
      return function() {
        return bc(ab.apply(this, arguments));
      };
    case 3:
      return function() {
        return cd(bc(ab.apply(this, arguments)));
      };
    case 4:
      return function() {
        return de(cd(bc(ab.apply(this, arguments))));
      };
    case 5:
      return function() {
        return ef(de(cd(bc(ab.apply(this, arguments)))));
      };
    case 6:
      return function() {
        return fg(ef(de(cd(bc(ab.apply(this, arguments))))));
      };
    case 7:
      return function() {
        return gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))));
      };
    case 8:
      return function() {
        return hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments))))))));
      };
    case 9:
      return function() {
        return ij(hi(gh(fg(ef(de(cd(bc(ab.apply(this, arguments)))))))));
      };
  }
  return;
}
var hole74 = /* @__PURE__ */ unsafeCoerce74(absurd74);
var SK74 = (_43, b43) => b43;
var make184 = (isEquivalent) => (self2, that) => self2 === that || isEquivalent(self2, that);
var let_114 = (map94) => dual74(3, (self2, name22, f43) => map94(self2, (a43) => Object.assign({}, a43, {
  [name22]: f43(a43)
})));
var bindTo114 = (map94) => dual74(2, (self2, name22) => map94(self2, (a43) => ({
  [name22]: a43
})));
var bind114 = (map94, flatMap94) => dual74(3, (self2, name22, f43) => flatMap94(self2, (a43) => map94(f43(a43), (b43) => Object.assign({}, a43, {
  [name22]: b43
}))));
var moduleVersion74 = "3.2.8";
var getCurrentVersion74 = () => moduleVersion74;
var globalStoreId74 = /* @__PURE__ */ Symbol.for(`effect/GlobalValue/globalStoreId/${/* @__PURE__ */ getCurrentVersion74()}`);
if (!(globalStoreId74 in globalThis)) {
  globalThis[globalStoreId74] = /* @__PURE__ */ new Map();
}
var globalStore74 = globalThis[globalStoreId74];
var globalValue74 = (id, compute) => {
  if (!globalStore74.has(id)) {
    globalStore74.set(id, compute());
  }
  return globalStore74.get(id);
};
var Predicate_exports53 = {};
__export9(Predicate_exports53, {
  all: () => all104,
  and: () => and74,
  compose: () => compose114,
  eqv: () => eqv74,
  every: () => every84,
  hasProperty: () => hasProperty74,
  implies: () => implies74,
  isBigInt: () => isBigInt74,
  isBoolean: () => isBoolean74,
  isDate: () => isDate74,
  isError: () => isError74,
  isFunction: () => isFunction114,
  isIterable: () => isIterable74,
  isMap: () => isMap74,
  isNever: () => isNever74,
  isNotNull: () => isNotNull74,
  isNotNullable: () => isNotNullable74,
  isNotUndefined: () => isNotUndefined74,
  isNull: () => isNull74,
  isNullable: () => isNullable74,
  isNumber: () => isNumber74,
  isObject: () => isObject74,
  isPromise: () => isPromise74,
  isPromiseLike: () => isPromiseLike74,
  isReadonlyRecord: () => isReadonlyRecord74,
  isRecord: () => isRecord74,
  isSet: () => isSet74,
  isString: () => isString74,
  isSymbol: () => isSymbol74,
  isTagged: () => isTagged74,
  isTruthy: () => isTruthy74,
  isUint8Array: () => isUint8Array74,
  isUndefined: () => isUndefined74,
  isUnknown: () => isUnknown74,
  mapInput: () => mapInput84,
  nand: () => nand74,
  nor: () => nor74,
  not: () => not74,
  or: () => or74,
  product: () => product104,
  productMany: () => productMany104,
  some: () => some144,
  struct: () => struct94,
  tuple: () => tuple84,
  xor: () => xor74
});
var mapInput84 = /* @__PURE__ */ dual74(2, (self2, f43) => (b43) => self2(f43(b43)));
var isTruthy74 = (input) => !!input;
var isSet74 = (input) => input instanceof Set;
var isMap74 = (input) => input instanceof Map;
var isString74 = (input) => typeof input === "string";
var isNumber74 = (input) => typeof input === "number";
var isBoolean74 = (input) => typeof input === "boolean";
var isBigInt74 = (input) => typeof input === "bigint";
var isSymbol74 = (input) => typeof input === "symbol";
var isFunction114 = isFunction103;
var isUndefined74 = (input) => input === void 0;
var isNotUndefined74 = (input) => input !== void 0;
var isNull74 = (input) => input === null;
var isNotNull74 = (input) => input !== null;
var isNever74 = (_43) => false;
var isUnknown74 = (_43) => true;
var isRecordOrArray74 = (input) => typeof input === "object" && input !== null;
var isObject74 = (input) => isRecordOrArray74(input) || isFunction114(input);
var hasProperty74 = /* @__PURE__ */ dual74(2, (self2, property) => isObject74(self2) && property in self2);
var isTagged74 = /* @__PURE__ */ dual74(2, (self2, tag) => hasProperty74(self2, "_tag") && self2["_tag"] === tag);
var isNullable74 = (input) => input === null || input === void 0;
var isNotNullable74 = (input) => input !== null && input !== void 0;
var isError74 = (input) => input instanceof Error;
var isUint8Array74 = (input) => input instanceof Uint8Array;
var isDate74 = (input) => input instanceof Date;
var isIterable74 = (input) => hasProperty74(input, Symbol.iterator);
var isRecord74 = (input) => isRecordOrArray74(input) && !Array.isArray(input);
var isReadonlyRecord74 = isRecord74;
var isPromise74 = (input) => hasProperty74(input, "then") && "catch" in input && isFunction114(input.then) && isFunction114(input.catch);
var isPromiseLike74 = (input) => hasProperty74(input, "then") && isFunction114(input.then);
var compose114 = /* @__PURE__ */ dual74(2, (ab, bc) => (a43) => ab(a43) && bc(a43));
var product104 = (self2, that) => ([a43, b43]) => self2(a43) && that(b43);
var all104 = (collection) => {
  return (as84) => {
    let collectionIndex = 0;
    for (const p43 of collection) {
      if (collectionIndex >= as84.length) {
        break;
      }
      if (p43(as84[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany104 = (self2, collection) => {
  const rest = all104(collection);
  return ([head42, ...tail42]) => self2(head42) === false ? false : rest(tail42);
};
var tuple84 = (...elements) => all104(elements);
var struct94 = (fields) => {
  const keys64 = Object.keys(fields);
  return (a43) => {
    for (const key of keys64) {
      if (!fields[key](a43[key])) {
        return false;
      }
    }
    return true;
  };
};
var not74 = (self2) => (a43) => !self2(a43);
var or74 = /* @__PURE__ */ dual74(2, (self2, that) => (a43) => self2(a43) || that(a43));
var and74 = /* @__PURE__ */ dual74(2, (self2, that) => (a43) => self2(a43) && that(a43));
var xor74 = /* @__PURE__ */ dual74(2, (self2, that) => (a43) => self2(a43) !== that(a43));
var eqv74 = /* @__PURE__ */ dual74(2, (self2, that) => (a43) => self2(a43) === that(a43));
var implies74 = /* @__PURE__ */ dual74(2, (self2, that) => (a43) => self2(a43) ? that(a43) : true);
var nor74 = /* @__PURE__ */ dual74(2, (self2, that) => (a43) => !(self2(a43) || that(a43)));
var nand74 = /* @__PURE__ */ dual74(2, (self2, that) => (a43) => !(self2(a43) && that(a43)));
var every84 = (collection) => (a43) => {
  for (const p43 of collection) {
    if (!p43(a43)) {
      return false;
    }
  }
  return true;
};
var some144 = (collection) => (a43) => {
  for (const p43 of collection) {
    if (p43(a43)) {
      return true;
    }
  }
  return false;
};
var getBugErrorMessage74 = (message) => `BUG: ${message} - please report an issue at https://github.com/Effect-TS/effect/issues`;
var GenKindTypeId74 = /* @__PURE__ */ Symbol.for("effect/Gen/GenKind");
var isGenKind74 = (u43) => isObject74(u43) && GenKindTypeId74 in u43;
var GenKindImpl74 = class {
  value;
  constructor(value) {
    this.value = value;
  }
  /**
   * @since 2.0.0
   */
  get _F() {
    return identity74;
  }
  /**
   * @since 2.0.0
   */
  get _R() {
    return (_43) => _43;
  }
  /**
   * @since 2.0.0
   */
  get _O() {
    return (_43) => _43;
  }
  /**
   * @since 2.0.0
   */
  get _E() {
    return (_43) => _43;
  }
  /**
   * @since 2.0.0
   */
  [GenKindTypeId74] = GenKindTypeId74;
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new SingleShotGen84(this);
  }
};
var SingleShotGen84 = class _SingleShotGen94 {
  self;
  called = false;
  constructor(self2) {
    this.self = self2;
  }
  /**
   * @since 2.0.0
   */
  next(a43) {
    return this.called ? {
      value: a43,
      done: true
    } : (this.called = true, {
      value: this.self,
      done: false
    });
  }
  /**
   * @since 2.0.0
   */
  return(a43) {
    return {
      value: a43,
      done: true
    };
  }
  /**
   * @since 2.0.0
   */
  throw(e43) {
    throw e43;
  }
  /**
   * @since 2.0.0
   */
  [Symbol.iterator]() {
    return new _SingleShotGen94(this.self);
  }
};
var adapter104 = () => function() {
  let x43 = arguments[0];
  for (let i43 = 1; i43 < arguments.length; i43++) {
    x43 = arguments[i43](x43);
  }
  return new GenKindImpl74(x43);
};
var defaultIncHi74 = 335903614;
var defaultIncLo74 = 4150755663;
var MUL_HI74 = 1481765933 >>> 0;
var MUL_LO74 = 1284865837 >>> 0;
var BIT_5374 = 9007199254740992;
var BIT_2774 = 134217728;
var PCGRandom74 = class {
  _state;
  constructor(seedHi, seedLo, incHi, incLo) {
    if (isNullable74(seedLo) && isNullable74(seedHi)) {
      seedLo = Math.random() * 4294967295 >>> 0;
      seedHi = 0;
    } else if (isNullable74(seedLo)) {
      seedLo = seedHi;
      seedHi = 0;
    }
    if (isNullable74(incLo) && isNullable74(incHi)) {
      incLo = this._state ? this._state[3] : defaultIncLo74;
      incHi = this._state ? this._state[2] : defaultIncHi74;
    } else if (isNullable74(incLo)) {
      incLo = incHi;
      incHi = 0;
    }
    this._state = new Int32Array([0, 0, incHi >>> 0, ((incLo || 0) | 1) >>> 0]);
    this._next();
    add6474(this._state, this._state[0], this._state[1], seedHi >>> 0, seedLo >>> 0);
    this._next();
    return this;
  }
  /**
   * Returns a copy of the internal state of this random number generator as a
   * JavaScript Array.
   *
   * @category getters
   * @since 2.0.0
   */
  getState() {
    return [this._state[0], this._state[1], this._state[2], this._state[3]];
  }
  /**
   * Restore state previously retrieved using `getState()`.
   *
   * @since 2.0.0
   */
  setState(state) {
    this._state[0] = state[0];
    this._state[1] = state[1];
    this._state[2] = state[2];
    this._state[3] = state[3] | 1;
  }
  /**
   * Get a uniformly distributed 32 bit integer between [0, max).
   *
   * @category getter
   * @since 2.0.0
   */
  integer(max42) {
    if (!max42) {
      return this._next();
    }
    max42 = max42 >>> 0;
    if ((max42 & max42 - 1) === 0) {
      return this._next() & max42 - 1;
    }
    let num = 0;
    const skew = (-max42 >>> 0) % max42 >>> 0;
    for (num = this._next(); num < skew; num = this._next()) {
    }
    return num % max42;
  }
  /**
   * Get a uniformly distributed IEEE-754 double between 0.0 and 1.0, with
   * 53 bits of precision (every bit of the mantissa is randomized).
   *
   * @category getters
   * @since 2.0.0
   */
  number() {
    const hi = (this._next() & 67108863) * 1;
    const lo = (this._next() & 134217727) * 1;
    return (hi * BIT_2774 + lo) / BIT_5374;
  }
  /** @internal */
  _next() {
    const oldHi = this._state[0] >>> 0;
    const oldLo = this._state[1] >>> 0;
    mul6474(this._state, oldHi, oldLo, MUL_HI74, MUL_LO74);
    add6474(this._state, this._state[0], this._state[1], this._state[2], this._state[3]);
    let xsHi = oldHi >>> 18;
    let xsLo = (oldLo >>> 18 | oldHi << 14) >>> 0;
    xsHi = (xsHi ^ oldHi) >>> 0;
    xsLo = (xsLo ^ oldLo) >>> 0;
    const xorshifted = (xsLo >>> 27 | xsHi << 5) >>> 0;
    const rot = oldHi >>> 27;
    const rot2 = (-rot >>> 0 & 31) >>> 0;
    return (xorshifted >>> rot | xorshifted << rot2) >>> 0;
  }
};
function mul6474(out, aHi, aLo, bHi, bLo) {
  let c1 = (aLo >>> 16) * (bLo & 65535) >>> 0;
  let c0 = (aLo & 65535) * (bLo >>> 16) >>> 0;
  let lo = (aLo & 65535) * (bLo & 65535) >>> 0;
  let hi = (aLo >>> 16) * (bLo >>> 16) + ((c0 >>> 16) + (c1 >>> 16)) >>> 0;
  c0 = c0 << 16 >>> 0;
  lo = lo + c0 >>> 0;
  if (lo >>> 0 < c0 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  c1 = c1 << 16 >>> 0;
  lo = lo + c1 >>> 0;
  if (lo >>> 0 < c1 >>> 0) {
    hi = hi + 1 >>> 0;
  }
  hi = hi + Math.imul(aLo, bHi) >>> 0;
  hi = hi + Math.imul(aHi, bLo) >>> 0;
  out[0] = hi;
  out[1] = lo;
}
function add6474(out, aHi, aLo, bHi, bLo) {
  let hi = aHi + bHi >>> 0;
  const lo = aLo + bLo >>> 0;
  if (lo >>> 0 < aLo >>> 0) {
    hi = hi + 1 | 0;
  }
  out[0] = hi;
  out[1] = lo;
}
var YieldWrapTypeId74 = /* @__PURE__ */ Symbol.for("effect/Utils/YieldWrap");
var YieldWrap74 = class {
  /**
   * @since 3.0.6
   */
  #value;
  constructor(value) {
    this.#value = value;
  }
  /**
   * @since 3.0.6
   */
  [YieldWrapTypeId74]() {
    return this.#value;
  }
};
function yieldWrapGet74(self2) {
  if (typeof self2 === "object" && self2 !== null && YieldWrapTypeId74 in self2) {
    return self2[YieldWrapTypeId74]();
  }
  throw new Error(getBugErrorMessage74("yieldWrapGet"));
}
var structuralRegionState74 = /* @__PURE__ */ globalValue74("effect/Utils/isStructuralRegion", () => ({
  enabled: false,
  tester: void 0
}));
var randomHashCache74 = /* @__PURE__ */ globalValue74(/* @__PURE__ */ Symbol.for("effect/Hash/randomHashCache"), () => /* @__PURE__ */ new WeakMap());
var pcgr74 = /* @__PURE__ */ globalValue74(/* @__PURE__ */ Symbol.for("effect/Hash/pcgr"), () => new PCGRandom74());
var symbol104 = /* @__PURE__ */ Symbol.for("effect/Hash");
var hash74 = (self2) => {
  if (structuralRegionState74.enabled === true) {
    return 0;
  }
  switch (typeof self2) {
    case "number":
      return number84(self2);
    case "bigint":
      return string94(self2.toString(10));
    case "boolean":
      return string94(String(self2));
    case "symbol":
      return string94(String(self2));
    case "string":
      return string94(self2);
    case "undefined":
      return string94("undefined");
    case "function":
    case "object": {
      if (self2 === null) {
        return string94("null");
      } else if (self2 instanceof Date) {
        return hash74(self2.toISOString());
      } else if (isHash74(self2)) {
        return self2[symbol104]();
      } else {
        return random74(self2);
      }
    }
    default:
      throw new Error(`BUG: unhandled typeof ${typeof self2} - please report an issue at https://github.com/Effect-TS/effect/issues`);
  }
};
var random74 = (self2) => {
  if (!randomHashCache74.has(self2)) {
    randomHashCache74.set(self2, number84(pcgr74.integer(Number.MAX_SAFE_INTEGER)));
  }
  return randomHashCache74.get(self2);
};
var combine84 = (b43) => (self2) => self2 * 53 ^ b43;
var optimize74 = (n43) => n43 & 3221225471 | n43 >>> 1 & 1073741824;
var isHash74 = (u43) => hasProperty74(u43, symbol104);
var number84 = (n43) => {
  if (n43 !== n43 || n43 === Infinity) {
    return 0;
  }
  let h43 = n43 | 0;
  if (h43 !== n43) {
    h43 ^= n43 * 4294967295;
  }
  while (n43 > 4294967295) {
    h43 ^= n43 /= 4294967295;
  }
  return optimize74(n43);
};
var string94 = (str) => {
  let h43 = 5381, i43 = str.length;
  while (i43) {
    h43 = h43 * 33 ^ str.charCodeAt(--i43);
  }
  return optimize74(h43);
};
var cached74 = function() {
  if (arguments.length === 1) {
    const self3 = arguments[0];
    return function(hash92) {
      Object.defineProperty(self3, symbol104, {
        value() {
          return hash92;
        },
        enumerable: false
      });
      return hash92;
    };
  }
  const self2 = arguments[0];
  const hash84 = arguments[1];
  Object.defineProperty(self2, symbol104, {
    value() {
      return hash84;
    },
    enumerable: false
  });
  return hash84;
};
var symbol114 = /* @__PURE__ */ Symbol.for("effect/Equal");
function equals74() {
  if (arguments.length === 1) {
    return (self2) => compareBoth74(self2, arguments[0]);
  }
  return compareBoth74(arguments[0], arguments[1]);
}
function compareBoth74(self2, that) {
  if (self2 === that) {
    return true;
  }
  const selfType = typeof self2;
  if (selfType !== typeof that) {
    return false;
  }
  if (selfType === "object" || selfType === "function") {
    if (self2 !== null && that !== null) {
      if (isEqual74(self2) && isEqual74(that)) {
        if (hash74(self2) === hash74(that) && self2[symbol114](that)) {
          return true;
        } else {
          return structuralRegionState74.enabled && structuralRegionState74.tester ? structuralRegionState74.tester(self2, that) : false;
        }
      } else if (self2 instanceof Date && that instanceof Date) {
        return self2.toISOString() === that.toISOString();
      }
    }
    if (structuralRegionState74.enabled) {
      if (Array.isArray(self2) && Array.isArray(that)) {
        return self2.length === that.length && self2.every((v43, i43) => compareBoth74(v43, that[i43]));
      }
      if (Object.getPrototypeOf(self2) === Object.prototype && Object.getPrototypeOf(self2) === Object.prototype) {
        const keysSelf = Object.keys(self2);
        const keysThat = Object.keys(that);
        if (keysSelf.length === keysThat.length) {
          for (const key of keysSelf) {
            if (!(key in that && compareBoth74(self2[key], that[key]))) {
              return structuralRegionState74.tester ? structuralRegionState74.tester(self2, that) : false;
            }
          }
          return true;
        }
      }
      return structuralRegionState74.tester ? structuralRegionState74.tester(self2, that) : false;
    }
  }
  return structuralRegionState74.enabled && structuralRegionState74.tester ? structuralRegionState74.tester(self2, that) : false;
}
var isEqual74 = (u43) => hasProperty74(u43, symbol114);
var equivalence74 = () => equals74;
var NodeInspectSymbol74 = /* @__PURE__ */ Symbol.for("nodejs.util.inspect.custom");
var toJSON74 = (x43) => {
  if (hasProperty74(x43, "toJSON") && isFunction114(x43["toJSON"]) && x43["toJSON"].length === 0) {
    return x43.toJSON();
  } else if (Array.isArray(x43)) {
    return x43.map(toJSON74);
  }
  return x43;
};
var format74 = (x43) => JSON.stringify(x43, null, 2);
var pipeArguments74 = (self2, args) => {
  switch (args.length) {
    case 1:
      return args[0](self2);
    case 2:
      return args[1](args[0](self2));
    case 3:
      return args[2](args[1](args[0](self2)));
    case 4:
      return args[3](args[2](args[1](args[0](self2))));
    case 5:
      return args[4](args[3](args[2](args[1](args[0](self2)))));
    case 6:
      return args[5](args[4](args[3](args[2](args[1](args[0](self2))))));
    case 7:
      return args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))));
    case 8:
      return args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2))))))));
    case 9:
      return args[8](args[7](args[6](args[5](args[4](args[3](args[2](args[1](args[0](self2)))))))));
    default: {
      let ret = self2;
      for (let i43 = 0, len = args.length; i43 < len; i43++) {
        ret = args[i43](ret);
      }
      return ret;
    }
  }
};
var EffectTypeId84 = /* @__PURE__ */ Symbol.for("effect/Effect");
var StreamTypeId74 = /* @__PURE__ */ Symbol.for("effect/Stream");
var SinkTypeId74 = /* @__PURE__ */ Symbol.for("effect/Sink");
var ChannelTypeId74 = /* @__PURE__ */ Symbol.for("effect/Channel");
var effectVariance74 = {
  /* c8 ignore next */
  _R: (_43) => _43,
  /* c8 ignore next */
  _E: (_43) => _43,
  /* c8 ignore next */
  _A: (_43) => _43,
  _V: /* @__PURE__ */ getCurrentVersion74()
};
var sinkVariance74 = {
  /* c8 ignore next */
  _A: (_43) => _43,
  /* c8 ignore next */
  _In: (_43) => _43,
  /* c8 ignore next */
  _L: (_43) => _43,
  /* c8 ignore next */
  _E: (_43) => _43,
  /* c8 ignore next */
  _R: (_43) => _43
};
var channelVariance74 = {
  /* c8 ignore next */
  _Env: (_43) => _43,
  /* c8 ignore next */
  _InErr: (_43) => _43,
  /* c8 ignore next */
  _InElem: (_43) => _43,
  /* c8 ignore next */
  _InDone: (_43) => _43,
  /* c8 ignore next */
  _OutErr: (_43) => _43,
  /* c8 ignore next */
  _OutElem: (_43) => _43,
  /* c8 ignore next */
  _OutDone: (_43) => _43
};
var EffectPrototype74 = {
  [EffectTypeId84]: effectVariance74,
  [StreamTypeId74]: effectVariance74,
  [SinkTypeId74]: sinkVariance74,
  [ChannelTypeId74]: channelVariance74,
  [symbol114](that) {
    return this === that;
  },
  [symbol104]() {
    return cached74(this, random74(this));
  },
  [Symbol.iterator]() {
    return new SingleShotGen84(new YieldWrap74(this));
  },
  pipe() {
    return pipeArguments74(this, arguments);
  }
};
var TypeId174 = /* @__PURE__ */ Symbol.for("effect/Option");
var CommonProto104 = {
  ...EffectPrototype74,
  [TypeId174]: {
    _A: (_43) => _43
  },
  [NodeInspectSymbol74]() {
    return this.toJSON();
  },
  toString() {
    return format74(this.toJSON());
  }
};
var SomeProto74 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto104), {
  _tag: "Some",
  _op: "Some",
  [symbol114](that) {
    return isOption104(that) && isSome104(that) && equals74(this.value, that.value);
  },
  [symbol104]() {
    return cached74(this, combine84(hash74(this._tag))(hash74(this.value)));
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag,
      value: toJSON74(this.value)
    };
  }
});
var NoneHash74 = /* @__PURE__ */ hash74("None");
var NoneProto74 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto104), {
  _tag: "None",
  _op: "None",
  [symbol114](that) {
    return isOption104(that) && isNone104(that);
  },
  [symbol104]() {
    return NoneHash74;
  },
  toJSON() {
    return {
      _id: "Option",
      _tag: this._tag
    };
  }
});
var isOption104 = (input) => hasProperty74(input, TypeId174);
var isNone104 = (fa) => fa._tag === "None";
var isSome104 = (fa) => fa._tag === "Some";
var none104 = /* @__PURE__ */ Object.create(NoneProto74);
var some154 = (value) => {
  const a43 = Object.create(SomeProto74);
  a43.value = value;
  return a43;
};
var TypeId184 = /* @__PURE__ */ Symbol.for("effect/Either");
var CommonProto114 = {
  ...EffectPrototype74,
  [TypeId184]: {
    _R: (_43) => _43
  },
  [NodeInspectSymbol74]() {
    return this.toJSON();
  },
  toString() {
    return format74(this.toJSON());
  }
};
var RightProto74 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto114), {
  _tag: "Right",
  _op: "Right",
  [symbol114](that) {
    return isEither74(that) && isRight84(that) && equals74(this.right, that.right);
  },
  [symbol104]() {
    return combine84(hash74(this._tag))(hash74(this.right));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      right: toJSON74(this.right)
    };
  }
});
var LeftProto74 = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(CommonProto114), {
  _tag: "Left",
  _op: "Left",
  [symbol114](that) {
    return isEither74(that) && isLeft84(that) && equals74(this.left, that.left);
  },
  [symbol104]() {
    return combine84(hash74(this._tag))(hash74(this.left));
  },
  toJSON() {
    return {
      _id: "Either",
      _tag: this._tag,
      left: toJSON74(this.left)
    };
  }
});
var isEither74 = (input) => hasProperty74(input, TypeId184);
var isLeft84 = (ma) => ma._tag === "Left";
var isRight84 = (ma) => ma._tag === "Right";
var left84 = (left94) => {
  const a43 = Object.create(LeftProto74);
  a43.left = left94;
  return a43;
};
var right84 = (right94) => {
  const a43 = Object.create(RightProto74);
  a43.right = right94;
  return a43;
};
var getLeft104 = (self2) => isRight84(self2) ? none104 : some154(self2.left);
var getRight104 = (self2) => isLeft84(self2) ? none104 : some154(self2.right);
var Option_exports74 = {};
__export9(Option_exports74, {
  Do: () => Do84,
  TypeId: () => TypeId194,
  all: () => all114,
  andThen: () => andThen74,
  ap: () => ap74,
  as: () => as74,
  asVoid: () => asVoid74,
  bind: () => bind124,
  bindTo: () => bindTo124,
  composeK: () => composeK74,
  contains: () => contains84,
  containsWith: () => containsWith84,
  exists: () => exists74,
  filter: () => filter84,
  filterMap: () => filterMap84,
  firstSomeOf: () => firstSomeOf74,
  flatMap: () => flatMap84,
  flatMapNullable: () => flatMapNullable84,
  flatten: () => flatten84,
  fromIterable: () => fromIterable104,
  fromNullable: () => fromNullable84,
  gen: () => gen74,
  getEquivalence: () => getEquivalence94,
  getLeft: () => getLeft114,
  getOrElse: () => getOrElse74,
  getOrNull: () => getOrNull74,
  getOrThrow: () => getOrThrow74,
  getOrThrowWith: () => getOrThrowWith74,
  getOrUndefined: () => getOrUndefined74,
  getOrder: () => getOrder84,
  getRight: () => getRight114,
  isNone: () => isNone114,
  isOption: () => isOption114,
  isSome: () => isSome114,
  let: () => let_124,
  lift2: () => lift274,
  liftNullable: () => liftNullable84,
  liftPredicate: () => liftPredicate84,
  liftThrowable: () => liftThrowable74,
  map: () => map84,
  match: () => match11,
  none: () => none114,
  orElse: () => orElse74,
  orElseEither: () => orElseEither74,
  orElseSome: () => orElseSome74,
  partitionMap: () => partitionMap84,
  product: () => product114,
  productMany: () => productMany114,
  reduceCompact: () => reduceCompact74,
  some: () => some164,
  tap: () => tap74,
  toArray: () => toArray74,
  toRefinement: () => toRefinement74,
  void: () => void_74,
  zipLeft: () => zipLeft74,
  zipRight: () => zipRight74,
  zipWith: () => zipWith84
});
var make194 = (compare) => (self2, that) => self2 === that ? 0 : compare(self2, that);
var TypeId194 = /* @__PURE__ */ Symbol.for("effect/Option");
var none114 = () => none104;
var some164 = some154;
var isOption114 = isOption104;
var isNone114 = isNone104;
var isSome114 = isSome104;
var match11 = /* @__PURE__ */ dual74(2, (self2, {
  onNone,
  onSome
}) => isNone114(self2) ? onNone() : onSome(self2.value));
var toRefinement74 = (f43) => (a43) => isSome114(f43(a43));
var fromIterable104 = (collection) => {
  for (const a43 of collection) {
    return some164(a43);
  }
  return none114();
};
var getRight114 = getRight104;
var getLeft114 = getLeft104;
var getOrElse74 = /* @__PURE__ */ dual74(2, (self2, onNone) => isNone114(self2) ? onNone() : self2.value);
var orElse74 = /* @__PURE__ */ dual74(2, (self2, that) => isNone114(self2) ? that() : self2);
var orElseSome74 = /* @__PURE__ */ dual74(2, (self2, onNone) => isNone114(self2) ? some164(onNone()) : self2);
var orElseEither74 = /* @__PURE__ */ dual74(2, (self2, that) => isNone114(self2) ? map84(that(), right84) : map84(self2, left84));
var firstSomeOf74 = (collection) => {
  let out = none114();
  for (out of collection) {
    if (isSome114(out)) {
      return out;
    }
  }
  return out;
};
var fromNullable84 = (nullableValue) => nullableValue == null ? none114() : some164(nullableValue);
var liftNullable84 = (f43) => (...a43) => fromNullable84(f43(...a43));
var getOrNull74 = /* @__PURE__ */ getOrElse74(constNull74);
var getOrUndefined74 = /* @__PURE__ */ getOrElse74(constUndefined74);
var liftThrowable74 = (f43) => (...a43) => {
  try {
    return some164(f43(...a43));
  } catch (e43) {
    return none114();
  }
};
var getOrThrowWith74 = /* @__PURE__ */ dual74(2, (self2, onNone) => {
  if (isSome114(self2)) {
    return self2.value;
  }
  throw onNone();
});
var getOrThrow74 = /* @__PURE__ */ getOrThrowWith74(() => new Error("getOrThrow called on a None"));
var map84 = /* @__PURE__ */ dual74(2, (self2, f43) => isNone114(self2) ? none114() : some164(f43(self2.value)));
var as74 = /* @__PURE__ */ dual74(2, (self2, b43) => map84(self2, () => b43));
var asVoid74 = /* @__PURE__ */ as74(void 0);
var void_74 = /* @__PURE__ */ some164(void 0);
var flatMap84 = /* @__PURE__ */ dual74(2, (self2, f43) => isNone114(self2) ? none114() : f43(self2.value));
var andThen74 = /* @__PURE__ */ dual74(2, (self2, f43) => flatMap84(self2, (a43) => {
  const b43 = isFunction103(f43) ? f43(a43) : f43;
  return isOption114(b43) ? b43 : some164(b43);
}));
var flatMapNullable84 = /* @__PURE__ */ dual74(2, (self2, f43) => isNone114(self2) ? none114() : fromNullable84(f43(self2.value)));
var flatten84 = /* @__PURE__ */ flatMap84(identity74);
var zipRight74 = /* @__PURE__ */ dual74(2, (self2, that) => flatMap84(self2, () => that));
var composeK74 = /* @__PURE__ */ dual74(2, (afb, bfc) => (a43) => flatMap84(afb(a43), bfc));
var zipLeft74 = /* @__PURE__ */ dual74(2, (self2, that) => tap74(self2, () => that));
var tap74 = /* @__PURE__ */ dual74(2, (self2, f43) => flatMap84(self2, (a43) => map84(f43(a43), () => a43)));
var product114 = (self2, that) => isSome114(self2) && isSome114(that) ? some164([self2.value, that.value]) : none114();
var productMany114 = (self2, collection) => {
  if (isNone114(self2)) {
    return none114();
  }
  const out = [self2.value];
  for (const o43 of collection) {
    if (isNone114(o43)) {
      return none114();
    }
    out.push(o43.value);
  }
  return some164(out);
};
var all114 = (input) => {
  if (Symbol.iterator in input) {
    const out2 = [];
    for (const o43 of input) {
      if (isNone114(o43)) {
        return none114();
      }
      out2.push(o43.value);
    }
    return some164(out2);
  }
  const out = {};
  for (const key of Object.keys(input)) {
    const o43 = input[key];
    if (isNone114(o43)) {
      return none114();
    }
    out[key] = o43.value;
  }
  return some164(out);
};
var zipWith84 = /* @__PURE__ */ dual74(3, (self2, that, f43) => map84(product114(self2, that), ([a43, b43]) => f43(a43, b43)));
var ap74 = /* @__PURE__ */ dual74(2, (self2, that) => zipWith84(self2, that, (f43, a43) => f43(a43)));
var reduceCompact74 = /* @__PURE__ */ dual74(3, (self2, b43, f43) => {
  let out = b43;
  for (const oa of self2) {
    if (isSome114(oa)) {
      out = f43(out, oa.value);
    }
  }
  return out;
});
var toArray74 = (self2) => isNone114(self2) ? [] : [self2.value];
var partitionMap84 = /* @__PURE__ */ dual74(2, (self2, f43) => {
  if (isNone114(self2)) {
    return [none114(), none114()];
  }
  const e43 = f43(self2.value);
  return isLeft84(e43) ? [some164(e43.left), none114()] : [none114(), some164(e43.right)];
});
var filterMap84 = /* @__PURE__ */ dual74(2, (self2, f43) => isNone114(self2) ? none114() : f43(self2.value));
var filter84 = /* @__PURE__ */ dual74(2, (self2, predicate) => filterMap84(self2, (b43) => predicate(b43) ? some154(b43) : none104));
var getEquivalence94 = (isEquivalent) => make184((x43, y43) => x43 === y43 || (isNone114(x43) ? isNone114(y43) : isNone114(y43) ? false : isEquivalent(x43.value, y43.value)));
var getOrder84 = (O43) => make194((self2, that) => isSome114(self2) ? isSome114(that) ? O43(self2.value, that.value) : 1 : -1);
var lift274 = (f43) => dual74(2, (self2, that) => zipWith84(self2, that, f43));
var liftPredicate84 = (predicate) => (b43) => predicate(b43) ? some164(b43) : none114();
var containsWith84 = (isEquivalent) => dual74(2, (self2, a43) => isNone114(self2) ? false : isEquivalent(self2.value, a43));
var _equivalence94 = /* @__PURE__ */ equivalence74();
var contains84 = /* @__PURE__ */ containsWith84(_equivalence94);
var exists74 = /* @__PURE__ */ dual74(2, (self2, refinement) => isNone114(self2) ? false : refinement(self2.value));
var bindTo124 = /* @__PURE__ */ bindTo114(map84);
var let_124 = /* @__PURE__ */ let_114(map84);
var bind124 = /* @__PURE__ */ bind114(map84, flatMap84);
var Do84 = /* @__PURE__ */ some164({});
var adapter114 = /* @__PURE__ */ adapter104();
var gen74 = (f43) => {
  const iterator = f43(adapter114);
  let state = iterator.next();
  if (state.done) {
    return some164(state.value);
  } else {
    let current = state.value;
    if (isGenKind74(current)) {
      current = current.value;
    } else {
      current = yieldWrapGet74(current);
    }
    if (isNone114(current)) {
      return current;
    }
    while (!state.done) {
      state = iterator.next(current.value);
      if (!state.done) {
        current = state.value;
        if (isGenKind74(current)) {
          current = current.value;
        } else {
          current = yieldWrapGet74(current);
        }
        if (isNone114(current)) {
          return current;
        }
      }
    }
    return some164(state.value);
  }
};
var MutableRef_exports43 = {};
__export9(MutableRef_exports43, {
  compareAndSet: () => compareAndSet53,
  decrement: () => decrement53,
  decrementAndGet: () => decrementAndGet53,
  get: () => get63,
  getAndDecrement: () => getAndDecrement53,
  getAndIncrement: () => getAndIncrement53,
  getAndSet: () => getAndSet53,
  getAndUpdate: () => getAndUpdate53,
  increment: () => increment53,
  incrementAndGet: () => incrementAndGet53,
  make: () => make204,
  set: () => set64,
  setAndGet: () => setAndGet53,
  toggle: () => toggle53,
  update: () => update53,
  updateAndGet: () => updateAndGet53
});
var TypeId204 = /* @__PURE__ */ Symbol.for("effect/MutableRef");
var MutableRefProto53 = {
  [TypeId204]: TypeId204,
  toString() {
    return format74(this.toJSON());
  },
  toJSON() {
    return {
      _id: "MutableRef",
      current: toJSON74(this.current)
    };
  },
  [NodeInspectSymbol74]() {
    return this.toJSON();
  },
  pipe() {
    return pipeArguments74(this, arguments);
  }
};
var make204 = (value) => {
  const ref = Object.create(MutableRefProto53);
  ref.current = value;
  return ref;
};
var compareAndSet53 = /* @__PURE__ */ dual74(3, (self2, oldValue, newValue) => {
  if (equals74(oldValue, self2.current)) {
    self2.current = newValue;
    return true;
  }
  return false;
});
var decrement53 = (self2) => update53(self2, (n43) => n43 - 1);
var decrementAndGet53 = (self2) => updateAndGet53(self2, (n43) => n43 - 1);
var get63 = (self2) => self2.current;
var getAndDecrement53 = (self2) => getAndUpdate53(self2, (n43) => n43 - 1);
var getAndIncrement53 = (self2) => getAndUpdate53(self2, (n43) => n43 + 1);
var getAndSet53 = /* @__PURE__ */ dual74(2, (self2, value) => {
  const ret = self2.current;
  self2.current = value;
  return ret;
});
var getAndUpdate53 = /* @__PURE__ */ dual74(2, (self2, f43) => getAndSet53(self2, f43(get63(self2))));
var increment53 = (self2) => update53(self2, (n43) => n43 + 1);
var incrementAndGet53 = (self2) => updateAndGet53(self2, (n43) => n43 + 1);
var set64 = /* @__PURE__ */ dual74(2, (self2, value) => {
  self2.current = value;
  return self2;
});
var setAndGet53 = /* @__PURE__ */ dual74(2, (self2, value) => {
  self2.current = value;
  return self2.current;
});
var update53 = /* @__PURE__ */ dual74(2, (self2, f43) => set64(self2, f43(get63(self2))));
var updateAndGet53 = /* @__PURE__ */ dual74(2, (self2, f43) => setAndGet53(self2, f43(get63(self2))));
var toggle53 = (self2) => update53(self2, (_43) => !_43);
var createRule4 = createRuleForPlugin4("naming-convention");
var RULE_NAME47 = "component-name";
var defaultOptions = [
  {
    excepts: [],
    rule: "PascalCase"
  }
];
var schema = [
  {
    anyOf: [
      {
        type: "string",
        enum: ["PascalCase", "CONSTANT_CASE"]
      },
      {
        type: "object",
        additionalProperties: false,
        properties: {
          excepts: {
            type: "array",
            items: { type: "string", format: "regex" }
          },
          rule: {
            type: "string",
            enum: ["PascalCase", "CONSTANT_CASE"]
          }
        }
      }
    ]
  }
];
var component_name_default = createRule4({
  meta: {
    type: "problem",
    docs: {
      description: "enforce component naming convention to 'PascalCase' or 'CONSTANT_CASE'",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      COMPONENT_NAME: "A component name must be in {{case}}."
    },
    schema
  },
  name: RULE_NAME47,
  create(context) {
    const options = context.options[0] ?? defaultOptions[0];
    const excepts = Predicate_exports53.isString(options) ? [] : options.excepts ?? [];
    const rule = Predicate_exports53.isString(options) ? options : options.rule ?? "PascalCase";
    function validate(name22, casing = rule, ignores = excepts) {
      if (ignores.map((pattern) => new RegExp(pattern, "u")).some((pattern) => pattern.test(name22))) {
        return true;
      }
      return $4(casing).with("CONSTANT_CASE", () => RE_CONSTANT_CASE.test(name22)).with("PascalCase", () => RE_PASCAL_CASE.test(name22)).exhaustive();
    }
    const collector = useComponentCollector2(context);
    const collectorLegacy = useComponentCollectorLegacy2();
    return {
      ...collector.listeners,
      ...collectorLegacy.listeners,
      JSXOpeningElement(node) {
        const name22 = elementType2(node);
        const shouldIgnore = (
          // Ignore built-in element names
          /^[a-z]/u.test(name22) || /\W/u.test(name22) || name22.includes(".") || name22.includes(":")
        );
        if (shouldIgnore || validate(name22.replace(/^_/u, ""))) return;
        context.report({
          data: {
            case: rule
          },
          messageId: "COMPONENT_NAME",
          node
        });
      },
      "Program:exit"(node) {
        const functionComponents = collector.ctx.getAllComponents(node);
        const classComponents = collectorLegacy.ctx.getAllComponents(node);
        for (const { node: component } of functionComponents.values()) {
          const maybeId = getFunctionIdentifier4(component);
          if (Option_exports74.isNone(maybeId)) continue;
          const id = maybeId.value;
          const { name: name22 } = id;
          if (validate(name22)) continue;
          context.report({
            data: {
              case: rule
            },
            messageId: "COMPONENT_NAME",
            node: id
          });
        }
        for (const { node: component } of classComponents.values()) {
          const maybeId = getClassIdentifier3(component);
          if (Option_exports74.isNone(maybeId)) continue;
          const id = maybeId.value;
          const { name: name22 } = id;
          if (validate(name22)) continue;
          context.report({
            data: {
              case: rule
            },
            messageId: "COMPONENT_NAME",
            node: id
          });
        }
      }
    };
  },
  defaultOptions
});
var _DRIVE_LETTER_START_RE = /^[A-Za-z]:\//;
function normalizeWindowsPath(input = "") {
  if (!input) {
    return input;
  }
  return input.replace(/\\/g, "/").replace(_DRIVE_LETTER_START_RE, (r43) => r43.toUpperCase());
}
var _UNC_REGEX = /^[/\\]{2}/;
var _IS_ABSOLUTE_RE = /^[/\\](?![/\\])|^[/\\]{2}(?!\.)|^[A-Za-z]:[/\\]/;
var _DRIVE_LETTER_RE = /^[A-Za-z]:$/;
var _ROOT_FOLDER_RE = /^\/([A-Za-z]:)?$/;
var sep = "/";
var delimiter = ":";
var normalize = function(path2) {
  if (path2.length === 0) {
    return ".";
  }
  path2 = normalizeWindowsPath(path2);
  const isUNCPath = path2.match(_UNC_REGEX);
  const isPathAbsolute = isAbsolute(path2);
  const trailingSeparator = path2[path2.length - 1] === "/";
  path2 = normalizeString(path2, !isPathAbsolute);
  if (path2.length === 0) {
    if (isPathAbsolute) {
      return "/";
    }
    return trailingSeparator ? "./" : ".";
  }
  if (trailingSeparator) {
    path2 += "/";
  }
  if (_DRIVE_LETTER_RE.test(path2)) {
    path2 += "/";
  }
  if (isUNCPath) {
    if (!isPathAbsolute) {
      return `//./${path2}`;
    }
    return `//${path2}`;
  }
  return isPathAbsolute && !isAbsolute(path2) ? `/${path2}` : path2;
};
var join32 = function(...arguments_) {
  if (arguments_.length === 0) {
    return ".";
  }
  let joined;
  for (const argument of arguments_) {
    if (argument && argument.length > 0) {
      if (joined === void 0) {
        joined = argument;
      } else {
        joined += `/${argument}`;
      }
    }
  }
  if (joined === void 0) {
    return ".";
  }
  return normalize(joined.replace(/\/\/+/g, "/"));
};
function cwd() {
  if (typeof process !== "undefined" && typeof process.cwd === "function") {
    return process.cwd().replace(/\\/g, "/");
  }
  return "/";
}
var resolve = function(...arguments_) {
  arguments_ = arguments_.map((argument) => normalizeWindowsPath(argument));
  let resolvedPath = "";
  let resolvedAbsolute = false;
  for (let index = arguments_.length - 1; index >= -1 && !resolvedAbsolute; index--) {
    const path2 = index >= 0 ? arguments_[index] : cwd();
    if (!path2 || path2.length === 0) {
      continue;
    }
    resolvedPath = `${path2}/${resolvedPath}`;
    resolvedAbsolute = isAbsolute(path2);
  }
  resolvedPath = normalizeString(resolvedPath, !resolvedAbsolute);
  if (resolvedAbsolute && !isAbsolute(resolvedPath)) {
    return `/${resolvedPath}`;
  }
  return resolvedPath.length > 0 ? resolvedPath : ".";
};
function normalizeString(path2, allowAboveRoot) {
  let res = "";
  let lastSegmentLength = 0;
  let lastSlash = -1;
  let dots = 0;
  let char = null;
  for (let index = 0; index <= path2.length; ++index) {
    if (index < path2.length) {
      char = path2[index];
    } else if (char === "/") {
      break;
    } else {
      char = "/";
    }
    if (char === "/") {
      if (lastSlash === index - 1 || dots === 1) ;
      else if (dots === 2) {
        if (res.length < 2 || lastSegmentLength !== 2 || res[res.length - 1] !== "." || res[res.length - 2] !== ".") {
          if (res.length > 2) {
            const lastSlashIndex = res.lastIndexOf("/");
            if (lastSlashIndex === -1) {
              res = "";
              lastSegmentLength = 0;
            } else {
              res = res.slice(0, lastSlashIndex);
              lastSegmentLength = res.length - 1 - res.lastIndexOf("/");
            }
            lastSlash = index;
            dots = 0;
            continue;
          } else if (res.length > 0) {
            res = "";
            lastSegmentLength = 0;
            lastSlash = index;
            dots = 0;
            continue;
          }
        }
        if (allowAboveRoot) {
          res += res.length > 0 ? "/.." : "..";
          lastSegmentLength = 2;
        }
      } else {
        if (res.length > 0) {
          res += `/${path2.slice(lastSlash + 1, index)}`;
        } else {
          res = path2.slice(lastSlash + 1, index);
        }
        lastSegmentLength = index - lastSlash - 1;
      }
      lastSlash = index;
      dots = 0;
    } else if (char === "." && dots !== -1) {
      ++dots;
    } else {
      dots = -1;
    }
  }
  return res;
}
var isAbsolute = function(p43) {
  return _IS_ABSOLUTE_RE.test(p43);
};
var toNamespacedPath = function(p43) {
  return normalizeWindowsPath(p43);
};
var _EXTNAME_RE = /.(\.[^./]+)$/;
var extname = function(p43) {
  const match83 = _EXTNAME_RE.exec(normalizeWindowsPath(p43));
  return match83 && match83[1] || "";
};
var relative = function(from, to) {
  const _from = resolve(from).replace(_ROOT_FOLDER_RE, "$1").split("/");
  const _to = resolve(to).replace(_ROOT_FOLDER_RE, "$1").split("/");
  if (_to[0][1] === ":" && _from[0][1] === ":" && _from[0] !== _to[0]) {
    return _to.join("/");
  }
  const _fromCopy = [..._from];
  for (const segment of _fromCopy) {
    if (_to[0] !== segment) {
      break;
    }
    _from.shift();
    _to.shift();
  }
  return [..._from.map(() => ".."), ..._to].join("/");
};
var dirname = function(p43) {
  const segments = normalizeWindowsPath(p43).replace(/\/$/, "").split("/").slice(0, -1);
  if (segments.length === 1 && _DRIVE_LETTER_RE.test(segments[0])) {
    segments[0] += "/";
  }
  return segments.join("/") || (isAbsolute(p43) ? "/" : ".");
};
var format84 = function(p43) {
  const segments = [p43.root, p43.dir, p43.base ?? p43.name + p43.ext].filter(Boolean);
  return normalizeWindowsPath(
    p43.root ? resolve(...segments) : segments.join("/")
  );
};
var basename = function(p43, extension) {
  const lastSegment = normalizeWindowsPath(p43).split("/").pop();
  return extension && lastSegment.endsWith(extension) ? lastSegment.slice(0, -extension.length) : lastSegment;
};
var parse2 = function(p43) {
  const root = normalizeWindowsPath(p43).split("/").shift() || "/";
  const base = basename(p43);
  const extension = extname(base);
  return {
    root,
    dir: dirname(p43),
    base,
    ext: extension,
    name: base.slice(0, base.length - extension.length)
  };
};
var path = {
  __proto__: null,
  basename,
  delimiter,
  dirname,
  extname,
  format: format84,
  isAbsolute,
  join: join32,
  normalize,
  normalizeString,
  parse: parse2,
  relative,
  resolve,
  sep,
  toNamespacedPath
};
var RULE_NAME212 = "filename";
var defaultOptions2 = [
  {
    excepts: ["^index$"],
    extensions: [".jsx", ".tsx"],
    rule: "PascalCase"
  }
];
var schema2 = [
  {
    anyOf: [
      {
        type: "string",
        enum: ["PascalCase", "camelCase", "kebab-case", "snake_case"]
      },
      {
        type: "object",
        additionalProperties: false,
        properties: {
          excepts: {
            type: "array",
            items: { type: "string", format: "regex" }
          },
          extensions: {
            type: "array",
            items: { type: "string" },
            uniqueItems: true
          },
          rule: {
            type: "string",
            enum: ["PascalCase", "camelCase", "kebab-case", "snake_case"]
          }
        }
      }
    ]
  }
];
var filename_default = createRule4({
  meta: {
    type: "problem",
    docs: {
      description: "enforce naming convention for JSX filenames",
      requiresTypeChecking: false
    },
    messages: {
      FILENAME_CASE_MISMATCH: "A file with name '{{name}}' does not match {{rule}}",
      FILENAME_CASE_MISMATCH_SUGGESTION: "A file with name '{{name}}' does not match {{rule}}. Should rename to '{{suggestion}}'.",
      FILENAME_EMPTY: "A file must have non-empty name"
    },
    schema: schema2
  },
  name: RULE_NAME212,
  create(context) {
    const options = context.options[0] ?? defaultOptions2[0];
    const rule = Predicate_exports53.isString(options) ? options : options.rule ?? "PascalCase";
    const excepts = Predicate_exports53.isString(options) ? [] : options.excepts ?? [];
    const extensions = Predicate_exports53.isObject(options) && "extensions" in options ? options.extensions : defaultOptions2[0].extensions;
    const filename = context.filename;
    const fileNameExt = filename.slice(filename.lastIndexOf("."));
    if (!extensions.includes(fileNameExt)) return {};
    function validate(name22, casing = rule, ignores = excepts) {
      if (ignores.map((pattern) => new RegExp(pattern, "u")).some((pattern) => pattern.test(name22))) {
        return true;
      }
      return $4(casing).with("PascalCase", () => RE_PASCAL_CASE.test(name22)).with("camelCase", () => RE_CAMEL_CASE.test(name22)).with("kebab-case", () => RE_KEBAB_CASE.test(name22)).with("snake_case", () => RE_SNAKE_CASE.test(name22)).exhaustive();
    }
    function getSuggestion(name22, casing = rule) {
      return $4(casing).with("PascalCase", () => pascalCase(name22)).with("camelCase", () => camelCase(name22)).with("kebab-case", () => kebabCase(name22)).with("snake_case", () => snakeCase(name22)).exhaustive();
    }
    return {
      Program(node) {
        const [basename2 = "", ...rest] = path.basename(context.filename).split(".");
        if (basename2.length === 0) {
          context.report({ messageId: "FILENAME_EMPTY", node });
          return;
        }
        if (validate(basename2)) return;
        context.report({
          data: {
            name: filename,
            rule,
            suggestion: [getSuggestion(basename2), ...rest].join(".")
          },
          messageId: "FILENAME_CASE_MISMATCH_SUGGESTION",
          node
        });
      }
    };
  },
  defaultOptions: defaultOptions2
});
var RULE_NAME312 = "filename-extension";
var defaultOptions3 = [{
  allow: "as-needed",
  extensions: [".jsx", ".tsx"]
}];
var schema3 = [
  {
    anyOf: [
      {
        type: "string",
        enum: ["always", "as-needed"]
      },
      {
        type: "object",
        additionalProperties: false,
        properties: {
          allow: {
            type: "string",
            enum: ["always", "as-needed"]
          },
          extensions: {
            type: "array",
            items: {
              type: "string"
            },
            uniqueItems: true
          }
        }
      }
    ]
  }
];
var filename_extension_default = createRule4({
  meta: {
    type: "problem",
    docs: {
      description: "enforce naming convention for JSX file extensions",
      requiresTypeChecking: false
    },
    messages: {
      FILE_NAME_EXTENSION_INVALID: "The JSX file extension is required",
      FILE_NAME_EXTENSION_UNEXPECTED: "Use JSX file extension as needed"
    },
    schema: schema3
  },
  name: RULE_NAME312,
  create(context) {
    const options = context.options[0] ?? defaultOptions3[0];
    const allow = Predicate_exports53.isObject(options) ? options.allow : options;
    const extensions = Predicate_exports53.isObject(options) && "extensions" in options ? options.extensions : defaultOptions3[0].extensions;
    const filename = context.getFilename();
    const hasJSXNodeRef = MutableRef_exports43.make(false);
    return {
      JSXElement() {
        MutableRef_exports43.set(hasJSXNodeRef, true);
      },
      JSXFragment() {
        MutableRef_exports43.set(hasJSXNodeRef, true);
      },
      "Program:exit"(node) {
        const fileNameExt = filename.slice(filename.lastIndexOf("."));
        const isJSXExt = extensions.includes(fileNameExt);
        const hasJSXCode = MutableRef_exports43.get(hasJSXNodeRef);
        if (hasJSXCode && !isJSXExt) {
          context.report({
            messageId: "FILE_NAME_EXTENSION_INVALID",
            node
          });
          return;
        }
        if (!hasJSXCode && isJSXExt && allow === "as-needed") {
          context.report({
            messageId: "FILE_NAME_EXTENSION_UNEXPECTED",
            node
          });
        }
      }
    };
  },
  defaultOptions: defaultOptions3
});
var RULE_NAME48 = "use-state";
function isSetterNameLoose(name22) {
  const fourthChar = [...name22][3];
  return name22.startsWith("set") && fourthChar === fourthChar?.toUpperCase();
}
var use_state_default = createRule4({
  meta: {
    type: "problem",
    docs: {
      description: "enforce destructuring and symmetric naming of 'useState' hook value and setter variables",
      recommended: "recommended",
      requiresTypeChecking: false
    },
    messages: {
      USE_STATE: "An useState call is not destructured into value + setter pair."
    },
    schema: []
  },
  name: RULE_NAME48,
  create(context) {
    const alias = parse(ESLintSettingsSchema23, context.settings).reactOptions?.additionalHooks?.useState ?? [];
    const { ctx, listeners } = useComponentCollector2(context);
    return {
      ...listeners,
      "Program:exit"(node) {
        const components = ctx.getAllComponents(node);
        for (const { hookCalls } of components.values()) {
          if (hookCalls.length === 0) continue;
          for (const hookCall of hookCalls) {
            if (!isUseStateCall2(hookCall, context) && !alias.some(Function_exports74.flip(isReactHookCallWithNameLoose3)(hookCall))) {
              continue;
            }
            if (hookCall.parent.type !== NodeType8.VariableDeclarator) {
              continue;
            }
            const { id } = hookCall.parent;
            const descriptor = Option_exports74.some({ messageId: "USE_STATE", node: id });
            Function_exports74.pipe(
              $4(id).with({ type: NodeType8.Identifier }, Function_exports74.constant(descriptor)).with({ type: NodeType8.ArrayPattern }, (n43) => {
                const [state, setState] = n43.elements;
                if (state?.type === NodeType8.ObjectPattern && setState?.type === NodeType8.Identifier) {
                  return Function_exports74.pipe(
                    Option_exports74.liftPredicate(Predicate_exports53.not(isSetterNameLoose))(setState.name),
                    Option_exports74.flatMap(Function_exports74.constant(descriptor))
                  );
                }
                if (state?.type !== NodeType8.Identifier || setState?.type !== NodeType8.Identifier) return Option_exports74.none();
                const [stateName, setStateName] = [state.name, setState.name];
                const expectedSetterName = `set${capitalize(stateName)}`;
                if (setStateName === expectedSetterName) return Option_exports74.none();
                return descriptor;
              }).otherwise(Option_exports74.none),
              Option_exports74.map(context.report)
            );
          }
        }
      }
    };
  },
  defaultOptions: []
});
var meta4 = {
  name: name4,
  version: version4
};
var rules4 = {
  "component-name": component_name_default,
  filename: filename_default,
  "filename-extension": filename_extension_default,
  "use-state": use_state_default
};

// package.json
var name5 = "@neetly-eslint-react/eslint-plugin";
var version5 = "0.0.0-dev.0";

// ../../../node_modules/.pnpm/effect@3.2.8/node_modules/effect/dist/esm/Function.js
var isFunction14 = (input) => typeof input === "function";
var dual11 = function(arity, body) {
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a8, b8) {
        if (arguments.length >= 2) {
          return body(a8, b8);
        }
        return function(self2) {
          return body(self2, a8);
        };
      };
    case 3:
      return function(a8, b8, c8) {
        if (arguments.length >= 3) {
          return body(a8, b8, c8);
        }
        return function(self2) {
          return body(self2, a8, b8);
        };
      };
    case 4:
      return function(a8, b8, c8, d8) {
        if (arguments.length >= 4) {
          return body(a8, b8, c8, d8);
        }
        return function(self2) {
          return body(self2, a8, b8, c8);
        };
      };
    case 5:
      return function(a8, b8, c8, d8, e8) {
        if (arguments.length >= 5) {
          return body(a8, b8, c8, d8, e8);
        }
        return function(self2) {
          return body(self2, a8, b8, c8, d8);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self2) {
          return body(self2, ...args);
        };
      };
  }
};

// ../../../node_modules/.pnpm/effect@3.2.8/node_modules/effect/dist/esm/Predicate.js
var Predicate_exports9 = {};
__export(Predicate_exports9, {
  all: () => all15,
  and: () => and11,
  compose: () => compose15,
  eqv: () => eqv11,
  every: () => every13,
  hasProperty: () => hasProperty11,
  implies: () => implies11,
  isBigInt: () => isBigInt11,
  isBoolean: () => isBoolean11,
  isDate: () => isDate11,
  isError: () => isError11,
  isFunction: () => isFunction15,
  isIterable: () => isIterable11,
  isMap: () => isMap11,
  isNever: () => isNever11,
  isNotNull: () => isNotNull11,
  isNotNullable: () => isNotNullable11,
  isNotUndefined: () => isNotUndefined11,
  isNull: () => isNull11,
  isNullable: () => isNullable11,
  isNumber: () => isNumber11,
  isObject: () => isObject11,
  isPromise: () => isPromise11,
  isPromiseLike: () => isPromiseLike11,
  isReadonlyRecord: () => isReadonlyRecord11,
  isRecord: () => isRecord11,
  isSet: () => isSet11,
  isString: () => isString11,
  isSymbol: () => isSymbol11,
  isTagged: () => isTagged11,
  isTruthy: () => isTruthy11,
  isUint8Array: () => isUint8Array11,
  isUndefined: () => isUndefined11,
  isUnknown: () => isUnknown11,
  mapInput: () => mapInput12,
  nand: () => nand11,
  nor: () => nor11,
  not: () => not11,
  or: () => or11,
  product: () => product15,
  productMany: () => productMany15,
  some: () => some21,
  struct: () => struct13,
  tuple: () => tuple12,
  xor: () => xor11
});
var mapInput12 = /* @__PURE__ */ dual11(2, (self2, f8) => (b8) => self2(f8(b8)));
var isTruthy11 = (input) => !!input;
var isSet11 = (input) => input instanceof Set;
var isMap11 = (input) => input instanceof Map;
var isString11 = (input) => typeof input === "string";
var isNumber11 = (input) => typeof input === "number";
var isBoolean11 = (input) => typeof input === "boolean";
var isBigInt11 = (input) => typeof input === "bigint";
var isSymbol11 = (input) => typeof input === "symbol";
var isFunction15 = isFunction14;
var isUndefined11 = (input) => input === void 0;
var isNotUndefined11 = (input) => input !== void 0;
var isNull11 = (input) => input === null;
var isNotNull11 = (input) => input !== null;
var isNever11 = (_8) => false;
var isUnknown11 = (_8) => true;
var isRecordOrArray11 = (input) => typeof input === "object" && input !== null;
var isObject11 = (input) => isRecordOrArray11(input) || isFunction15(input);
var hasProperty11 = /* @__PURE__ */ dual11(2, (self2, property) => isObject11(self2) && property in self2);
var isTagged11 = /* @__PURE__ */ dual11(2, (self2, tag) => hasProperty11(self2, "_tag") && self2["_tag"] === tag);
var isNullable11 = (input) => input === null || input === void 0;
var isNotNullable11 = (input) => input !== null && input !== void 0;
var isError11 = (input) => input instanceof Error;
var isUint8Array11 = (input) => input instanceof Uint8Array;
var isDate11 = (input) => input instanceof Date;
var isIterable11 = (input) => hasProperty11(input, Symbol.iterator);
var isRecord11 = (input) => isRecordOrArray11(input) && !Array.isArray(input);
var isReadonlyRecord11 = isRecord11;
var isPromise11 = (input) => hasProperty11(input, "then") && "catch" in input && isFunction15(input.then) && isFunction15(input.catch);
var isPromiseLike11 = (input) => hasProperty11(input, "then") && isFunction15(input.then);
var compose15 = /* @__PURE__ */ dual11(2, (ab, bc) => (a8) => ab(a8) && bc(a8));
var product15 = (self2, that) => ([a8, b8]) => self2(a8) && that(b8);
var all15 = (collection) => {
  return (as11) => {
    let collectionIndex = 0;
    for (const p8 of collection) {
      if (collectionIndex >= as11.length) {
        break;
      }
      if (p8(as11[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany15 = (self2, collection) => {
  const rest = all15(collection);
  return ([head7, ...tail7]) => self2(head7) === false ? false : rest(tail7);
};
var tuple12 = (...elements) => all15(elements);
var struct13 = (fields) => {
  const keys11 = Object.keys(fields);
  return (a8) => {
    for (const key of keys11) {
      if (!fields[key](a8[key])) {
        return false;
      }
    }
    return true;
  };
};
var not11 = (self2) => (a8) => !self2(a8);
var or11 = /* @__PURE__ */ dual11(2, (self2, that) => (a8) => self2(a8) || that(a8));
var and11 = /* @__PURE__ */ dual11(2, (self2, that) => (a8) => self2(a8) && that(a8));
var xor11 = /* @__PURE__ */ dual11(2, (self2, that) => (a8) => self2(a8) !== that(a8));
var eqv11 = /* @__PURE__ */ dual11(2, (self2, that) => (a8) => self2(a8) === that(a8));
var implies11 = /* @__PURE__ */ dual11(2, (self2, that) => (a8) => self2(a8) ? that(a8) : true);
var nor11 = /* @__PURE__ */ dual11(2, (self2, that) => (a8) => !(self2(a8) || that(a8)));
var nand11 = /* @__PURE__ */ dual11(2, (self2, that) => (a8) => !(self2(a8) && that(a8)));
var every13 = (collection) => (a8) => {
  for (const p8 of collection) {
    if (!p8(a8)) {
      return false;
    }
  }
  return true;
};
var some21 = (collection) => (a8) => {
  for (const p8 of collection) {
    if (p8(a8)) {
      return true;
    }
  }
  return false;
};

// src/utils/transform-keys.ts
function transformKeys(obj, transform) {
  if (!Predicate_exports9.isObject(obj)) return obj;
  const res = {};
  for (const key in obj) {
    res[transform(key)] = obj[key];
  }
  return res;
}

// src/utils/pad-keys.ts
function padKeysLeft(obj, left12) {
  return transformKeys(obj, (key) => `${left12}${key}`);
}

// src/index.ts
var allPreset = {
  "avoid-shorthand-boolean": "warn",
  "avoid-shorthand-fragment": "warn",
  "ensure-forward-ref-using-ref": "warn",
  "no-access-state-in-setstate": "error",
  "no-array-index-key": "warn",
  "no-children-count": "warn",
  "no-children-for-each": "warn",
  "no-children-map": "warn",
  "no-children-only": "warn",
  "no-children-prop": "warn",
  "no-children-to-array": "warn",
  "no-class-component": "warn",
  "no-clone-element": "warn",
  "no-comment-textnodes": "warn",
  // This rule has been deprecated
  // "no-complicated-conditional-rendering": "warn",
  "no-component-will-mount": "error",
  "no-component-will-receive-props": "error",
  "no-component-will-update": "error",
  "no-create-ref": "error",
  "no-direct-mutation-state": "error",
  "no-duplicate-key": "error",
  // This rule has been deprecated
  // "no-implicit-key": "error",
  // This rule requires type information
  // "no-leaked-conditional-rendering": "warn",
  "no-missing-component-display-name": "warn",
  "no-missing-key": "error",
  "no-nested-components": "warn",
  "no-redundant-should-component-update": "error",
  "no-set-state-in-component-did-mount": "warn",
  "no-set-state-in-component-did-update": "warn",
  "no-set-state-in-component-will-update": "warn",
  "no-string-refs": "error",
  "no-unsafe-component-will-mount": "warn",
  "no-unsafe-component-will-receive-props": "warn",
  "no-unsafe-component-will-update": "warn",
  "no-unstable-context-value": "error",
  "no-unstable-default-props": "error",
  "no-unused-class-component-members": "warn",
  "no-unused-state": "warn",
  "no-useless-fragment": "warn",
  "prefer-destructuring-assignment": "warn",
  "prefer-shorthand-boolean": "warn",
  "prefer-shorthand-fragment": "warn",
  // eslint-disable-next-line perfectionist/sort-objects
  "dom/no-children-in-void-dom-elements": "warn",
  "dom/no-dangerously-set-innerhtml": "warn",
  "dom/no-dangerously-set-innerhtml-with-children": "error",
  "dom/no-find-dom-node": "error",
  "dom/no-missing-button-type": "warn",
  "dom/no-missing-iframe-sandbox": "warn",
  "dom/no-namespace": "error",
  "dom/no-render-return-value": "error",
  "dom/no-script-url": "warn",
  "dom/no-unsafe-iframe-sandbox": "warn",
  "dom/no-unsafe-target-blank": "warn",
  "hooks-extra/ensure-custom-hooks-using-other-hooks": "warn",
  "hooks-extra/ensure-use-callback-has-non-empty-deps": "warn",
  "hooks-extra/ensure-use-memo-has-non-empty-deps": "warn",
  "hooks-extra/prefer-use-state-lazy-initialization": "warn",
  "naming-convention/component-name": "warn",
  "naming-convention/filename": "warn",
  "naming-convention/filename-extension": "warn",
  "naming-convention/use-state": "warn"
};
var recommendedPreset = {
  // "avoid-shorthand-boolean": "warn",
  // "avoid-shorthand-fragment": "warn",
  "ensure-forward-ref-using-ref": "warn",
  "no-access-state-in-setstate": "error",
  "no-array-index-key": "warn",
  "no-children-count": "warn",
  "no-children-for-each": "warn",
  "no-children-map": "warn",
  "no-children-only": "warn",
  "no-children-prop": "warn",
  "no-children-to-array": "warn",
  // "no-class-component": "warn",
  "no-clone-element": "warn",
  "no-comment-textnodes": "warn",
  // "no-complicated-conditional-rendering": "warn",
  "no-component-will-mount": "error",
  "no-component-will-receive-props": "error",
  "no-component-will-update": "error",
  "no-create-ref": "error",
  "no-direct-mutation-state": "error",
  "no-duplicate-key": "error",
  // "no-implicit-key": "error",
  // "no-leaked-conditional-rendering": "warn",
  // "no-missing-component-display-name": "warn",
  "no-missing-key": "error",
  "no-nested-components": "warn",
  "no-redundant-should-component-update": "error",
  "no-set-state-in-component-did-mount": "warn",
  "no-set-state-in-component-did-update": "warn",
  "no-set-state-in-component-will-update": "warn",
  "no-string-refs": "error",
  "no-unsafe-component-will-mount": "warn",
  "no-unsafe-component-will-receive-props": "warn",
  "no-unsafe-component-will-update": "warn",
  "no-unstable-context-value": "error",
  "no-unstable-default-props": "error",
  "no-unused-class-component-members": "warn",
  "no-unused-state": "warn",
  "no-useless-fragment": "warn",
  "prefer-destructuring-assignment": "warn",
  "prefer-shorthand-boolean": "warn",
  "prefer-shorthand-fragment": "warn",
  // eslint-disable-next-line perfectionist/sort-objects
  "dom/no-children-in-void-dom-elements": "warn",
  "dom/no-dangerously-set-innerhtml": "warn",
  "dom/no-dangerously-set-innerhtml-with-children": "error",
  "dom/no-find-dom-node": "error",
  "dom/no-missing-button-type": "warn",
  "dom/no-missing-iframe-sandbox": "warn",
  "dom/no-namespace": "error",
  "dom/no-render-return-value": "error",
  "dom/no-script-url": "warn",
  "dom/no-unsafe-iframe-sandbox": "warn",
  "dom/no-unsafe-target-blank": "warn"
};
var recommendedTypeCheckedPreset = {
  ...recommendedPreset,
  "no-leaked-conditional-rendering": "warn"
};
var domPreset = {
  "dom/no-children-in-void-dom-elements": "warn",
  "dom/no-dangerously-set-innerhtml": "warn",
  "dom/no-dangerously-set-innerhtml-with-children": "error",
  "dom/no-find-dom-node": "error",
  "dom/no-missing-button-type": "warn",
  "dom/no-missing-iframe-sandbox": "warn",
  "dom/no-namespace": "error",
  "dom/no-script-url": "warn",
  "dom/no-unsafe-iframe-sandbox": "warn",
  "dom/no-unsafe-target-blank": "warn"
};
var debugPreset = {
  "debug/class-component": "warn",
  "debug/function-component": "warn",
  "debug/react-hooks": "warn"
};
var allPresetEntries = entries(allPreset);
var offPreset = fromEntries(allPresetEntries.map(([key]) => [key, "off"]));
var offDomPreset = fromEntries(entries(domPreset).map(([key]) => [key, "off"]));
var legacyConfigPlugins = ["@eslint-react"];
var flatConfigPlugins = {
  "@eslint-react": dist_exports,
  "@eslint-react/dom": dist_exports2,
  "@eslint-react/hooks-extra": dist_exports3,
  "@eslint-react/naming-convention": dist_exports4
};
function createLegacyConfig(rules5, plugins = legacyConfigPlugins) {
  return {
    parser: "@typescript-eslint/parser",
    plugins,
    rules: padKeysLeft(rules5, "@eslint-react/")
  };
}
function createFlatConfig(rules5, plugins = flatConfigPlugins) {
  return {
    languageOptions: {
      parser: tsParser__default.default
    },
    plugins,
    rules: padKeysLeft(rules5, "@eslint-react/")
  };
}
var src_default = {
  meta: {
    name: name5,
    version: version5
  },
  configs: {
    all: createFlatConfig(allPreset),
    debug: createFlatConfig(debugPreset),
    dom: createFlatConfig(domPreset),
    off: createFlatConfig(offPreset),
    "off-dom": createFlatConfig(offDomPreset),
    recommended: createFlatConfig(recommendedPreset),
    "recommended-type-checked": createFlatConfig(recommendedTypeCheckedPreset),
    // eslint-disable-next-line perfectionist/sort-objects
    "all-legacy": createLegacyConfig(allPreset),
    "debug-legacy": createLegacyConfig(debugPreset),
    "dom-legacy": createLegacyConfig(domPreset),
    "off-dom-legacy": createLegacyConfig(offDomPreset),
    "off-legacy": createLegacyConfig(offPreset),
    "recommended-legacy": createLegacyConfig(recommendedPreset),
    "recommended-type-checked-legacy": createLegacyConfig(recommendedTypeCheckedPreset)
  },
  rules: {
    ...rules,
    ...padKeysLeft(rules2, "dom/"),
    ...padKeysLeft(rules3, "hooks-extra/"),
    ...padKeysLeft(rules4, "naming-convention/")
  }
};

module.exports = src_default;
